#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 11
#define STATE_COUNT 1136
#define LARGE_STATE_COUNT 184
#define SYMBOL_COUNT 229
#define ALIAS_COUNT 7
#define TOKEN_COUNT 123
#define EXTERNAL_TOKEN_COUNT 2
#define FIELD_COUNT 34
#define MAX_ALIAS_SEQUENCE_LENGTH 7

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_LBRACE = 6,
  anon_sym_COMMA = 7,
  anon_sym_RBRACE = 8,
  anon_sym_as = 9,
  anon_sym_import = 10,
  anon_sym_from = 11,
  anon_sym_var = 12,
  anon_sym_let = 13,
  anon_sym_const = 14,
  anon_sym_if = 15,
  anon_sym_else = 16,
  anon_sym_switch = 17,
  anon_sym_for = 18,
  anon_sym_LPAREN = 19,
  anon_sym_RPAREN = 20,
  anon_sym_await = 21,
  anon_sym_in = 22,
  anon_sym_of = 23,
  anon_sym_while = 24,
  anon_sym_do = 25,
  anon_sym_try = 26,
  anon_sym_with = 27,
  anon_sym_break = 28,
  anon_sym_continue = 29,
  anon_sym_debugger = 30,
  anon_sym_return = 31,
  anon_sym_throw = 32,
  anon_sym_SEMI = 33,
  anon_sym_COLON = 34,
  anon_sym_case = 35,
  anon_sym_catch = 36,
  anon_sym_finally = 37,
  anon_sym_yield = 38,
  anon_sym_EQ = 39,
  anon_sym_LBRACK = 40,
  anon_sym_RBRACK = 41,
  anon_sym_LT = 42,
  anon_sym_GT = 43,
  anon_sym_SLASH = 44,
  sym_jsx_text = 45,
  sym_jsx_identifier = 46,
  anon_sym_DOT = 47,
  anon_sym_class = 48,
  anon_sym_extends = 49,
  anon_sym_async = 50,
  anon_sym_function = 51,
  anon_sym_EQ_GT = 52,
  anon_sym_new = 53,
  anon_sym_PLUS_EQ = 54,
  anon_sym_DASH_EQ = 55,
  anon_sym_STAR_EQ = 56,
  anon_sym_SLASH_EQ = 57,
  anon_sym_PERCENT_EQ = 58,
  anon_sym_CARET_EQ = 59,
  anon_sym_AMP_EQ = 60,
  anon_sym_PIPE_EQ = 61,
  anon_sym_GT_GT_EQ = 62,
  anon_sym_GT_GT_GT_EQ = 63,
  anon_sym_LT_LT_EQ = 64,
  anon_sym_STAR_STAR_EQ = 65,
  anon_sym_AMP_AMP_EQ = 66,
  anon_sym_PIPE_PIPE_EQ = 67,
  anon_sym_QMARK_QMARK_EQ = 68,
  anon_sym_DOT_DOT_DOT = 69,
  anon_sym_QMARK = 70,
  anon_sym_AMP_AMP = 71,
  anon_sym_PIPE_PIPE = 72,
  anon_sym_GT_GT = 73,
  anon_sym_GT_GT_GT = 74,
  anon_sym_LT_LT = 75,
  anon_sym_AMP = 76,
  anon_sym_CARET = 77,
  anon_sym_PIPE = 78,
  anon_sym_PLUS = 79,
  anon_sym_DASH = 80,
  anon_sym_PERCENT = 81,
  anon_sym_STAR_STAR = 82,
  anon_sym_LT_EQ = 83,
  anon_sym_EQ_EQ = 84,
  anon_sym_EQ_EQ_EQ = 85,
  anon_sym_BANG_EQ = 86,
  anon_sym_BANG_EQ_EQ = 87,
  anon_sym_GT_EQ = 88,
  anon_sym_QMARK_QMARK = 89,
  anon_sym_instanceof = 90,
  anon_sym_BANG = 91,
  anon_sym_TILDE = 92,
  anon_sym_typeof = 93,
  anon_sym_void = 94,
  anon_sym_delete = 95,
  anon_sym_PLUS_PLUS = 96,
  anon_sym_DASH_DASH = 97,
  anon_sym_DQUOTE = 98,
  aux_sym_string_token1 = 99,
  anon_sym_SQUOTE = 100,
  aux_sym_string_token2 = 101,
  sym_escape_sequence = 102,
  sym_comment = 103,
  anon_sym_BQUOTE = 104,
  anon_sym_DOLLAR_LBRACE = 105,
  anon_sym_SLASH2 = 106,
  sym_regex_pattern = 107,
  sym_regex_flags = 108,
  sym_number = 109,
  anon_sym_target = 110,
  sym_this = 111,
  sym_super = 112,
  sym_true = 113,
  sym_false = 114,
  sym_null = 115,
  sym_undefined = 116,
  anon_sym_AT = 117,
  anon_sym_static = 118,
  anon_sym_get = 119,
  anon_sym_set = 120,
  sym__automatic_semicolon = 121,
  sym__template_chars = 122,
  sym_program = 123,
  sym_export_statement = 124,
  sym_export_clause = 125,
  sym__import_export_specifier = 126,
  sym__declaration = 127,
  sym_import = 128,
  sym_import_statement = 129,
  sym_import_clause = 130,
  sym__from_clause = 131,
  sym_namespace_import = 132,
  sym_named_imports = 133,
  sym_expression_statement = 134,
  sym_variable_declaration = 135,
  sym_lexical_declaration = 136,
  sym_variable_declarator = 137,
  sym_statement_block = 138,
  sym_if_statement = 139,
  sym_switch_statement = 140,
  sym_for_statement = 141,
  sym_for_in_statement = 142,
  sym__for_header = 143,
  sym_while_statement = 144,
  sym_do_statement = 145,
  sym_try_statement = 146,
  sym_with_statement = 147,
  sym_break_statement = 148,
  sym_continue_statement = 149,
  sym_debugger_statement = 150,
  sym_return_statement = 151,
  sym_throw_statement = 152,
  sym_empty_statement = 153,
  sym_labeled_statement = 154,
  sym_switch_body = 155,
  sym_switch_case = 156,
  sym_switch_default = 157,
  sym_catch_clause = 158,
  sym_finally_clause = 159,
  sym_parenthesized_expression = 160,
  sym__expression = 161,
  sym_yield_expression = 162,
  sym_object = 163,
  sym_assignment_pattern = 164,
  sym_array = 165,
  sym_jsx_element = 166,
  sym_jsx_fragment = 167,
  sym_jsx_expression = 168,
  sym_jsx_opening_element = 169,
  sym_nested_identifier = 170,
  sym_jsx_namespace_name = 171,
  sym_jsx_closing_element = 172,
  sym_jsx_self_closing_element = 173,
  sym_jsx_attribute = 174,
  sym_class = 175,
  sym_class_declaration = 176,
  sym_class_heritage = 177,
  sym_function = 178,
  sym_function_declaration = 179,
  sym_generator_function = 180,
  sym_generator_function_declaration = 181,
  sym_arrow_function = 182,
  sym_call_expression = 183,
  sym_new_expression = 184,
  sym_await_expression = 185,
  sym_member_expression = 186,
  sym_subscript_expression = 187,
  sym_assignment_expression = 188,
  sym_augmented_assignment_expression = 189,
  sym__initializer = 190,
  sym_spread_element = 191,
  sym_ternary_expression = 192,
  sym_binary_expression = 193,
  sym_unary_expression = 194,
  sym_update_expression = 195,
  sym_sequence_expression = 196,
  sym_string = 197,
  sym_template_string = 198,
  sym_template_substitution = 199,
  sym_regex = 200,
  sym_meta_property = 201,
  sym_arguments = 202,
  sym_decorator = 203,
  sym_decorator_member_expression = 204,
  sym_decorator_call_expression = 205,
  sym_class_body = 206,
  sym_public_field_definition = 207,
  sym_formal_parameters = 208,
  sym_rest_parameter = 209,
  sym_method_definition = 210,
  sym_pair = 211,
  sym__property_name = 212,
  sym_computed_property_name = 213,
  aux_sym_program_repeat1 = 214,
  aux_sym_export_statement_repeat1 = 215,
  aux_sym_export_clause_repeat1 = 216,
  aux_sym_named_imports_repeat1 = 217,
  aux_sym_variable_declaration_repeat1 = 218,
  aux_sym_switch_body_repeat1 = 219,
  aux_sym_object_repeat1 = 220,
  aux_sym_array_repeat1 = 221,
  aux_sym_jsx_element_repeat1 = 222,
  aux_sym_jsx_opening_element_repeat1 = 223,
  aux_sym_string_repeat1 = 224,
  aux_sym_string_repeat2 = 225,
  aux_sym_template_string_repeat1 = 226,
  aux_sym_class_body_repeat1 = 227,
  aux_sym_formal_parameters_repeat1 = 228,
  alias_sym_array_pattern = 229,
  alias_sym_export_specifier = 230,
  alias_sym_import_specifier = 231,
  alias_sym_object_pattern = 232,
  alias_sym_property_identifier = 233,
  alias_sym_shorthand_property_identifier = 234,
  alias_sym_statement_identifier = 235,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_as] = "as",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_EQ] = "=",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [sym_jsx_text] = "jsx_text",
  [sym_jsx_identifier] = "identifier",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_extends] = "extends",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_QMARK_QMARK_EQ] = "??=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "?",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_QMARK_QMARK] = "??",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_typeof] = "typeof",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "_import_export_specifier",
  [sym__declaration] = "_declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__expression] = "_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_array] = "array",
  [sym_jsx_element] = "jsx_element",
  [sym_jsx_fragment] = "jsx_fragment",
  [sym_jsx_expression] = "jsx_expression",
  [sym_jsx_opening_element] = "jsx_opening_element",
  [sym_nested_identifier] = "nested_identifier",
  [sym_jsx_namespace_name] = "jsx_namespace_name",
  [sym_jsx_closing_element] = "jsx_closing_element",
  [sym_jsx_self_closing_element] = "jsx_self_closing_element",
  [sym_jsx_attribute] = "jsx_attribute",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_public_field_definition] = "public_field_definition",
  [sym_formal_parameters] = "formal_parameters",
  [sym_rest_parameter] = "rest_parameter",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_jsx_element_repeat1] = "jsx_element_repeat1",
  [aux_sym_jsx_opening_element_repeat1] = "jsx_opening_element_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [alias_sym_array_pattern] = "array_pattern",
  [alias_sym_export_specifier] = "export_specifier",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_object_pattern] = "object_pattern",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [sym_jsx_text] = sym_jsx_text,
  [sym_jsx_identifier] = sym_identifier,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_AMP_AMP_EQ] = anon_sym_AMP_AMP_EQ,
  [anon_sym_PIPE_PIPE_EQ] = anon_sym_PIPE_PIPE_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_token2] = aux_sym_string_token2,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_comment] = sym_comment,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_undefined] = sym_undefined,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_export_clause] = sym_export_clause,
  [sym__import_export_specifier] = sym__import_export_specifier,
  [sym__declaration] = sym__declaration,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_import_clause] = sym_import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym_namespace_import] = sym_namespace_import,
  [sym_named_imports] = sym_named_imports,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__expression] = sym__expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_array] = sym_array,
  [sym_jsx_element] = sym_jsx_element,
  [sym_jsx_fragment] = sym_jsx_fragment,
  [sym_jsx_expression] = sym_jsx_expression,
  [sym_jsx_opening_element] = sym_jsx_opening_element,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_jsx_namespace_name] = sym_jsx_namespace_name,
  [sym_jsx_closing_element] = sym_jsx_closing_element,
  [sym_jsx_self_closing_element] = sym_jsx_self_closing_element,
  [sym_jsx_attribute] = sym_jsx_attribute,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function] = sym_function,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_rest_parameter] = sym_rest_parameter,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_export_clause_repeat1] = aux_sym_export_clause_repeat1,
  [aux_sym_named_imports_repeat1] = aux_sym_named_imports_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_jsx_element_repeat1] = aux_sym_jsx_element_repeat1,
  [aux_sym_jsx_opening_element_repeat1] = aux_sym_jsx_opening_element_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [alias_sym_array_pattern] = alias_sym_array_pattern,
  [alias_sym_export_specifier] = alias_sym_export_specifier,
  [alias_sym_import_specifier] = alias_sym_import_specifier,
  [alias_sym_object_pattern] = alias_sym_object_pattern,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_jsx_text] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_opening_element] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_namespace_name] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_self_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_opening_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_attribute = 5,
  field_body = 6,
  field_close_tag = 7,
  field_condition = 8,
  field_consequence = 9,
  field_constructor = 10,
  field_declaration = 11,
  field_decorator = 12,
  field_finalizer = 13,
  field_flags = 14,
  field_function = 15,
  field_handler = 16,
  field_increment = 17,
  field_index = 18,
  field_initializer = 19,
  field_key = 20,
  field_label = 21,
  field_left = 22,
  field_member = 23,
  field_name = 24,
  field_object = 25,
  field_open_tag = 26,
  field_operator = 27,
  field_parameter = 28,
  field_parameters = 29,
  field_pattern = 30,
  field_property = 31,
  field_right = 32,
  field_source = 33,
  field_value = 34,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_close_tag] = "close_tag",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constructor] = "constructor",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_member] = "member",
  [field_name] = "name",
  [field_object] = "object",
  [field_open_tag] = "open_tag",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_right] = "right",
  [field_source] = "source",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[107] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [5] = {.index = 2, .length = 1},
  [6] = {.index = 2, .length = 1},
  [7] = {.index = 2, .length = 1},
  [8] = {.index = 3, .length = 1},
  [9] = {.index = 4, .length = 1},
  [10] = {.index = 4, .length = 1},
  [11] = {.index = 5, .length = 2},
  [12] = {.index = 7, .length = 2},
  [14] = {.index = 9, .length = 2},
  [15] = {.index = 11, .length = 2},
  [16] = {.index = 13, .length = 2},
  [18] = {.index = 15, .length = 1},
  [19] = {.index = 16, .length = 2},
  [20] = {.index = 16, .length = 2},
  [21] = {.index = 16, .length = 2},
  [22] = {.index = 18, .length = 2},
  [23] = {.index = 20, .length = 2},
  [24] = {.index = 22, .length = 3},
  [27] = {.index = 25, .length = 2},
  [28] = {.index = 27, .length = 2},
  [29] = {.index = 29, .length = 2},
  [30] = {.index = 31, .length = 2},
  [31] = {.index = 33, .length = 1},
  [32] = {.index = 34, .length = 1},
  [33] = {.index = 35, .length = 1},
  [34] = {.index = 36, .length = 1},
  [35] = {.index = 37, .length = 1},
  [36] = {.index = 38, .length = 1},
  [37] = {.index = 39, .length = 2},
  [38] = {.index = 41, .length = 1},
  [39] = {.index = 42, .length = 1},
  [40] = {.index = 43, .length = 2},
  [41] = {.index = 45, .length = 2},
  [42] = {.index = 47, .length = 2},
  [43] = {.index = 49, .length = 2},
  [44] = {.index = 51, .length = 2},
  [45] = {.index = 51, .length = 2},
  [46] = {.index = 43, .length = 2},
  [47] = {.index = 45, .length = 2},
  [48] = {.index = 47, .length = 2},
  [49] = {.index = 7, .length = 2},
  [50] = {.index = 53, .length = 3},
  [51] = {.index = 43, .length = 2},
  [52] = {.index = 43, .length = 2},
  [53] = {.index = 56, .length = 2},
  [54] = {.index = 58, .length = 2},
  [55] = {.index = 60, .length = 2},
  [56] = {.index = 62, .length = 1},
  [57] = {.index = 63, .length = 1},
  [58] = {.index = 64, .length = 2},
  [59] = {.index = 43, .length = 2},
  [60] = {.index = 66, .length = 2},
  [61] = {.index = 68, .length = 3},
  [62] = {.index = 64, .length = 2},
  [63] = {.index = 71, .length = 1},
  [64] = {.index = 72, .length = 3},
  [65] = {.index = 75, .length = 3},
  [66] = {.index = 78, .length = 2},
  [67] = {.index = 80, .length = 2},
  [68] = {.index = 82, .length = 2},
  [69] = {.index = 84, .length = 1},
  [70] = {.index = 85, .length = 2},
  [71] = {.index = 87, .length = 1},
  [72] = {.index = 88, .length = 2},
  [73] = {.index = 90, .length = 2},
  [74] = {.index = 92, .length = 2},
  [75] = {.index = 94, .length = 2},
  [76] = {.index = 92, .length = 2},
  [77] = {.index = 96, .length = 2},
  [78] = {.index = 98, .length = 3},
  [79] = {.index = 101, .length = 2},
  [80] = {.index = 103, .length = 3},
  [81] = {.index = 106, .length = 2},
  [82] = {.index = 108, .length = 2},
  [83] = {.index = 110, .length = 3},
  [84] = {.index = 113, .length = 2},
  [85] = {.index = 115, .length = 2},
  [86] = {.index = 117, .length = 2},
  [87] = {.index = 119, .length = 3},
  [88] = {.index = 122, .length = 3},
  [89] = {.index = 125, .length = 1},
  [90] = {.index = 126, .length = 2},
  [91] = {.index = 128, .length = 3},
  [92] = {.index = 131, .length = 2},
  [93] = {.index = 131, .length = 2},
  [94] = {.index = 133, .length = 3},
  [95] = {.index = 131, .length = 2},
  [96] = {.index = 131, .length = 2},
  [97] = {.index = 136, .length = 3},
  [98] = {.index = 139, .length = 2},
  [99] = {.index = 139, .length = 2},
  [100] = {.index = 139, .length = 2},
  [101] = {.index = 139, .length = 2},
  [102] = {.index = 141, .length = 4},
  [103] = {.index = 145, .length = 2},
  [104] = {.index = 145, .length = 2},
  [105] = {.index = 145, .length = 2},
  [106] = {.index = 147, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_declaration, 1},
  [2] =
    {field_name, 0},
  [3] =
    {field_body, 1},
  [4] =
    {field_constructor, 1},
  [5] =
    {field_argument, 1},
    {field_operator, 0},
  [7] =
    {field_arguments, 1},
    {field_function, 0},
  [9] =
    {field_argument, 0},
    {field_operator, 1},
  [11] =
    {field_close_tag, 1},
    {field_open_tag, 0},
  [13] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [15] =
    {field_source, 1},
  [16] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [18] =
    {field_condition, 1},
    {field_consequence, 2},
  [20] =
    {field_body, 2},
    {field_value, 1},
  [22] =
    {field_body, 2},
    {field_left, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [25] =
    {field_body, 2},
    {field_condition, 1},
  [27] =
    {field_body, 1},
    {field_handler, 2},
  [29] =
    {field_body, 1},
    {field_finalizer, 2},
  [31] =
    {field_body, 2},
    {field_object, 1},
  [33] =
    {field_label, 1},
  [34] =
    {field_name, 1},
  [35] =
    {field_attribute, 0},
  [36] =
    {field_pattern, 1},
  [37] =
    {field_member, 0},
  [38] =
    {field_property, 0},
  [39] =
    {field_body, 2},
    {field_name, 1},
  [41] =
    {field_body, 2},
  [42] =
    {field_label, 0},
  [43] =
    {field_left, 0},
    {field_right, 2},
  [45] =
    {field_object, 0},
    {field_property, 2},
  [47] =
    {field_body, 2},
    {field_parameter, 0},
  [49] =
    {field_body, 2},
    {field_parameters, 1},
  [51] =
    {field_arguments, 2},
    {field_constructor, 1},
  [53] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [56] =
    {field_close_tag, 2},
    {field_open_tag, 0},
  [58] =
    {field_body, 2},
    {field_parameters, 0},
  [60] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [62] =
    {field_source, 2, .inherited = true},
  [63] =
    {field_value, 2},
  [64] =
    {field_alias, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [66] =
    {field_key, 0},
    {field_value, 2},
  [68] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1},
  [71] =
    {field_value, 1},
  [72] =
    {field_body, 3},
    {field_left, 2, .inherited = true},
    {field_right, 2, .inherited = true},
  [75] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [78] =
    {field_attribute, 2, .inherited = true},
    {field_name, 1},
  [80] =
    {field_attribute, 0, .inherited = true},
    {field_attribute, 1, .inherited = true},
  [82] =
    {field_flags, 3},
    {field_pattern, 1},
  [84] =
    {field_property, 1},
  [85] =
    {field_property, 0},
    {field_value, 1, .inherited = true},
  [87] =
    {field_member, 1, .inherited = true},
  [88] =
    {field_member, 0, .inherited = true},
    {field_member, 1, .inherited = true},
  [90] =
    {field_body, 3},
    {field_name, 1},
  [92] =
    {field_body, 3},
    {field_parameter, 1},
  [94] =
    {field_body, 3},
    {field_parameters, 2},
  [96] =
    {field_body, 3},
    {field_parameters, 1},
  [98] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2},
  [101] =
    {field_index, 2},
    {field_object, 0},
  [103] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [106] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [108] =
    {field_alias, 2},
    {field_name, 0},
  [110] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [113] =
    {field_body, 1},
    {field_condition, 3},
  [115] =
    {field_property, 1},
    {field_value, 2, .inherited = true},
  [117] =
    {field_body, 4},
    {field_parameters, 3},
  [119] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
  [122] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [125] =
    {field_name, 2},
  [126] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [128] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [131] =
    {field_left, 1},
    {field_right, 3},
  [133] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [136] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4},
  [139] =
    {field_left, 2},
    {field_right, 4},
  [141] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [145] =
    {field_body, 4},
    {field_parameter, 2},
  [147] =
    {field_body, 6},
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
    {field_parameters, 5},
};

static TSSymbol ts_alias_sequences[107][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [4] = {
    [0] = alias_sym_property_identifier,
  },
  [6] = {
    [0] = alias_sym_object_pattern,
  },
  [7] = {
    [0] = alias_sym_array_pattern,
  },
  [9] = {
    [1] = sym_identifier,
  },
  [13] = {
    [1] = sym_identifier,
  },
  [17] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [20] = {
    [0] = alias_sym_object_pattern,
  },
  [21] = {
    [0] = alias_sym_array_pattern,
  },
  [25] = {
    [1] = alias_sym_object_pattern,
  },
  [26] = {
    [1] = alias_sym_array_pattern,
  },
  [31] = {
    [1] = alias_sym_statement_identifier,
  },
  [39] = {
    [0] = alias_sym_statement_identifier,
  },
  [40] = {
    [0] = sym_identifier,
  },
  [41] = {
    [0] = sym_identifier,
    [2] = alias_sym_property_identifier,
  },
  [42] = {
    [0] = sym_identifier,
  },
  [44] = {
    [1] = sym_identifier,
  },
  [47] = {
    [2] = alias_sym_property_identifier,
  },
  [49] = {
    [0] = sym_identifier,
  },
  [51] = {
    [0] = alias_sym_object_pattern,
  },
  [52] = {
    [0] = alias_sym_array_pattern,
  },
  [58] = {
    [1] = alias_sym_export_specifier,
  },
  [59] = {
    [0] = alias_sym_shorthand_property_identifier,
  },
  [62] = {
    [1] = alias_sym_import_specifier,
  },
  [74] = {
    [1] = sym_identifier,
  },
  [92] = {
    [1] = sym_identifier,
  },
  [95] = {
    [1] = alias_sym_object_pattern,
  },
  [96] = {
    [1] = alias_sym_array_pattern,
  },
  [98] = {
    [2] = sym_identifier,
  },
  [100] = {
    [2] = alias_sym_object_pattern,
  },
  [101] = {
    [2] = alias_sym_array_pattern,
  },
  [104] = {
    [2] = alias_sym_object_pattern,
  },
  [105] = {
    [2] = alias_sym_array_pattern,
  },
};

static inline bool sym_identifier_character_set_1(int32_t lookahead) {
  return
    lookahead == 0 ||
    (0 <= lookahead && lookahead <= '#') ||
    ('%' <= lookahead && lookahead <= '/') ||
    (':' <= lookahead && lookahead <= '@') ||
    ('[' <= lookahead && lookahead <= '^') ||
    lookahead == '`' ||
    ('{' <= lookahead && lookahead <= '~') ||
    lookahead == 160 ||
    lookahead == 8203 ||
    lookahead == 8288 ||
    lookahead == 65279;
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(61);
      if (lookahead == '!') ADVANCE(147);
      if (lookahead == '"') ADVANCE(151);
      if (lookahead == '#') ADVANCE(6);
      if (lookahead == '$') ADVANCE(191);
      if (lookahead == '%') ADVANCE(135);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '\'') ADVANCE(158);
      if (lookahead == '(') ADVANCE(69);
      if (lookahead == ')') ADVANCE(70);
      if (lookahead == '*') ADVANCE(64);
      if (lookahead == '+') ADVANCE(131);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(133);
      if (lookahead == '.') ADVANCE(93);
      if (lookahead == '/') ADVANCE(176);
      if (lookahead == '0') ADVANCE(181);
      if (lookahead == ':') ADVANCE(72);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(79);
      if (lookahead == '=') ADVANCE(74);
      if (lookahead == '>') ADVANCE(82);
      if (lookahead == '?') ADVANCE(112);
      if (lookahead == '@') ADVANCE(193);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == ']') ADVANCE(77);
      if (lookahead == '^') ADVANCE(127);
      if (lookahead == '`') ADVANCE(174);
      if (lookahead == '{') ADVANCE(66);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(68);
      if (lookahead == '~') ADVANCE(148);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(58)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(182);
      if (lookahead != 0 &&
          (lookahead < 0 || 31 < lookahead)) ADVANCE(192);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(11)
      if (lookahead == '"') ADVANCE(151);
      if (lookahead == '/') ADVANCE(153);
      if (lookahead == '\\') ADVANCE(2);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(156);
      if (lookahead != 0) ADVANCE(157);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(152);
      if (lookahead == '\r') ADVANCE(166);
      if (lookahead == 'u') ADVANCE(32);
      if (lookahead == 'x') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(170);
      if (lookahead != 0) ADVANCE(165);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(14)
      if (lookahead == '\'') ADVANCE(158);
      if (lookahead == '/') ADVANCE(160);
      if (lookahead == '\\') ADVANCE(4);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(163);
      if (lookahead != 0) ADVANCE(164);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(159);
      if (lookahead == '\r') ADVANCE(167);
      if (lookahead == 'u') ADVANCE(32);
      if (lookahead == 'x') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(170);
      if (lookahead != 0) ADVANCE(165);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(22)
      if (lookahead == '/') ADVANCE(15);
      if (lookahead == '[') ADVANCE(25);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(177);
      if (lookahead != 0) ADVANCE(178);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(62);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(146);
      if (lookahead == '"') ADVANCE(151);
      if (lookahead == '\'') ADVANCE(158);
      if (lookahead == '(') ADVANCE(69);
      if (lookahead == '+') ADVANCE(130);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(94);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == '0') ADVANCE(181);
      if (lookahead == ':') ADVANCE(72);
      if (lookahead == '<') ADVANCE(78);
      if (lookahead == '>') ADVANCE(81);
      if (lookahead == '@') ADVANCE(193);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == '`') ADVANCE(174);
      if (lookahead == '{') ADVANCE(66);
      if (lookahead == '~') ADVANCE(148);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(7)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(182);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '?' < lookahead) &&
          lookahead != ']' &&
          lookahead != '^' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(192);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(23);
      if (lookahead == '"') ADVANCE(151);
      if (lookahead == '%') ADVANCE(135);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '\'') ADVANCE(158);
      if (lookahead == '(') ADVANCE(69);
      if (lookahead == ')') ADVANCE(70);
      if (lookahead == '*') ADVANCE(64);
      if (lookahead == '+') ADVANCE(131);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(133);
      if (lookahead == '.') ADVANCE(94);
      if (lookahead == '/') ADVANCE(85);
      if (lookahead == '0') ADVANCE(181);
      if (lookahead == ':') ADVANCE(72);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(79);
      if (lookahead == '=') ADVANCE(74);
      if (lookahead == '>') ADVANCE(82);
      if (lookahead == '?') ADVANCE(112);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(77);
      if (lookahead == '^') ADVANCE(127);
      if (lookahead == '`') ADVANCE(174);
      if (lookahead == '{') ADVANCE(66);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(8)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(182);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          lookahead != '@' &&
          lookahead != '~') ADVANCE(192);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(23);
      if (lookahead == '%') ADVANCE(134);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '(') ADVANCE(69);
      if (lookahead == ')') ADVANCE(70);
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '+') ADVANCE(130);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(92);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == ':') ADVANCE(72);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(80);
      if (lookahead == '=') ADVANCE(24);
      if (lookahead == '>') ADVANCE(83);
      if (lookahead == '?') ADVANCE(113);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(77);
      if (lookahead == '^') ADVANCE(126);
      if (lookahead == '`') ADVANCE(174);
      if (lookahead == '{') ADVANCE(66);
      if (lookahead == '|') ADVANCE(129);
      if (lookahead == '}') ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(179);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(192);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(23);
      if (lookahead == '%') ADVANCE(134);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '(') ADVANCE(69);
      if (lookahead == ')') ADVANCE(70);
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '+') ADVANCE(130);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(92);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == ':') ADVANCE(72);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(80);
      if (lookahead == '=') ADVANCE(24);
      if (lookahead == '>') ADVANCE(83);
      if (lookahead == '?') ADVANCE(113);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(77);
      if (lookahead == '^') ADVANCE(126);
      if (lookahead == '`') ADVANCE(174);
      if (lookahead == '{') ADVANCE(66);
      if (lookahead == '|') ADVANCE(129);
      if (lookahead == '}') ADVANCE(68);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(192);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(151);
      if (lookahead == '/') ADVANCE(15);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(11)
      END_STATE();
    case 12:
      if (lookahead == '$') ADVANCE(29);
      if (lookahead == '/') ADVANCE(176);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == '`') ADVANCE(174);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(13)
      END_STATE();
    case 13:
      if (lookahead == '$') ADVANCE(29);
      if (lookahead == '/') ADVANCE(15);
      if (lookahead == '`') ADVANCE(174);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(13)
      END_STATE();
    case 14:
      if (lookahead == '\'') ADVANCE(158);
      if (lookahead == '/') ADVANCE(15);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(14)
      END_STATE();
    case 15:
      if (lookahead == '*') ADVANCE(17);
      if (lookahead == '/') ADVANCE(173);
      END_STATE();
    case 16:
      if (lookahead == '*') ADVANCE(16);
      if (lookahead == '/') ADVANCE(171);
      if (lookahead != 0) ADVANCE(17);
      END_STATE();
    case 17:
      if (lookahead == '*') ADVANCE(16);
      if (lookahead != 0) ADVANCE(17);
      END_STATE();
    case 18:
      if (lookahead == '.') ADVANCE(19);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(188);
      END_STATE();
    case 19:
      if (lookahead == '.') ADVANCE(111);
      END_STATE();
    case 20:
      if (lookahead == '.') ADVANCE(92);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == ':') ADVANCE(72);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(81);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == '{') ADVANCE(66);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(20)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(190);
      if (lookahead != 0 &&
          (lookahead < 0 || '~' < lookahead)) ADVANCE(192);
      END_STATE();
    case 21:
      if (lookahead == '/') ADVANCE(86);
      if (lookahead == '<') ADVANCE(78);
      if (lookahead == '{') ADVANCE(66);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '}') ADVANCE(90);
      END_STATE();
    case 22:
      if (lookahead == '/') ADVANCE(15);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(22)
      END_STATE();
    case 23:
      if (lookahead == '=') ADVANCE(141);
      END_STATE();
    case 24:
      if (lookahead == '=') ADVANCE(139);
      END_STATE();
    case 25:
      if (lookahead == '\\') ADVANCE(56);
      if (lookahead == ']') ADVANCE(178);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(25);
      END_STATE();
    case 26:
      if (lookahead == 'u') ADVANCE(30);
      if (lookahead == 'x') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(170);
      if (lookahead != 0) ADVANCE(165);
      END_STATE();
    case 27:
      if (lookahead == 'u') ADVANCE(31);
      END_STATE();
    case 28:
      if (lookahead == 'u') ADVANCE(32);
      if (lookahead == 'x') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(170);
      if (lookahead != 0) ADVANCE(165);
      END_STATE();
    case 29:
      if (lookahead == '{') ADVANCE(175);
      END_STATE();
    case 30:
      if (lookahead == '{') ADVANCE(46);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 31:
      if (lookahead == '{') ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 32:
      if (lookahead == '{') ADVANCE(50);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 33:
      if (lookahead == '}') ADVANCE(192);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(33);
      END_STATE();
    case 34:
      if (lookahead == '}') ADVANCE(165);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(34);
      END_STATE();
    case 35:
      if (lookahead == '}') ADVANCE(168);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(35);
      END_STATE();
    case 36:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(187);
      END_STATE();
    case 37:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(183);
      END_STATE();
    case 38:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(184);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(182);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(188);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(186);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(187);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(192);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(165);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(185);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(35);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(168);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(33);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(34);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(47);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(43);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      END_STATE();
    case 56:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(25);
      END_STATE();
    case 57:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(178);
      END_STATE();
    case 58:
      if (eof) ADVANCE(61);
      if (lookahead == '!') ADVANCE(147);
      if (lookahead == '"') ADVANCE(151);
      if (lookahead == '#') ADVANCE(6);
      if (lookahead == '$') ADVANCE(191);
      if (lookahead == '%') ADVANCE(135);
      if (lookahead == '&') ADVANCE(124);
      if (lookahead == '\'') ADVANCE(158);
      if (lookahead == '(') ADVANCE(69);
      if (lookahead == ')') ADVANCE(70);
      if (lookahead == '*') ADVANCE(64);
      if (lookahead == '+') ADVANCE(131);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(133);
      if (lookahead == '.') ADVANCE(93);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == '0') ADVANCE(181);
      if (lookahead == ':') ADVANCE(72);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(79);
      if (lookahead == '=') ADVANCE(74);
      if (lookahead == '>') ADVANCE(82);
      if (lookahead == '?') ADVANCE(112);
      if (lookahead == '@') ADVANCE(193);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(77);
      if (lookahead == '^') ADVANCE(127);
      if (lookahead == '`') ADVANCE(174);
      if (lookahead == '{') ADVANCE(66);
      if (lookahead == '|') ADVANCE(128);
      if (lookahead == '}') ADVANCE(68);
      if (lookahead == '~') ADVANCE(148);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(58)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(182);
      if (lookahead != 0 &&
          (lookahead < 0 || 31 < lookahead)) ADVANCE(192);
      END_STATE();
    case 59:
      if (eof) ADVANCE(61);
      if (lookahead == '!') ADVANCE(147);
      if (lookahead == '"') ADVANCE(151);
      if (lookahead == '%') ADVANCE(134);
      if (lookahead == '&') ADVANCE(125);
      if (lookahead == '\'') ADVANCE(158);
      if (lookahead == '(') ADVANCE(69);
      if (lookahead == ')') ADVANCE(70);
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '+') ADVANCE(130);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(94);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == '0') ADVANCE(181);
      if (lookahead == ':') ADVANCE(72);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(80);
      if (lookahead == '=') ADVANCE(74);
      if (lookahead == '>') ADVANCE(83);
      if (lookahead == '?') ADVANCE(113);
      if (lookahead == '@') ADVANCE(193);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(77);
      if (lookahead == '^') ADVANCE(126);
      if (lookahead == '`') ADVANCE(174);
      if (lookahead == '{') ADVANCE(66);
      if (lookahead == '|') ADVANCE(129);
      if (lookahead == '}') ADVANCE(68);
      if (lookahead == '~') ADVANCE(148);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(59)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(182);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead)) ADVANCE(192);
      END_STATE();
    case 60:
      if (eof) ADVANCE(61);
      if (lookahead == '!') ADVANCE(146);
      if (lookahead == '"') ADVANCE(151);
      if (lookahead == '#') ADVANCE(6);
      if (lookahead == '\'') ADVANCE(158);
      if (lookahead == '(') ADVANCE(69);
      if (lookahead == ')') ADVANCE(70);
      if (lookahead == '*') ADVANCE(63);
      if (lookahead == '+') ADVANCE(130);
      if (lookahead == ',') ADVANCE(67);
      if (lookahead == '-') ADVANCE(132);
      if (lookahead == '.') ADVANCE(18);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == '0') ADVANCE(181);
      if (lookahead == ':') ADVANCE(72);
      if (lookahead == ';') ADVANCE(71);
      if (lookahead == '<') ADVANCE(78);
      if (lookahead == '=') ADVANCE(75);
      if (lookahead == '>') ADVANCE(81);
      if (lookahead == '@') ADVANCE(193);
      if (lookahead == '[') ADVANCE(76);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(77);
      if (lookahead == '`') ADVANCE(174);
      if (lookahead == '{') ADVANCE(66);
      if (lookahead == '}') ADVANCE(68);
      if (lookahead == '~') ADVANCE(148);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(60)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(182);
      if (lookahead != 0 &&
          (lookahead < 0 || 31 < lookahead) &&
          (lookahead < '%' || '?' < lookahead) &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(192);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(62);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(137);
      if (lookahead == '=') ADVANCE(98);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(136);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(139);
      if (lookahead == '>') ADVANCE(95);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(95);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(123);
      if (lookahead == '=') ADVANCE(138);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(122);
      if (lookahead == '=') ADVANCE(138);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(143);
      if (lookahead == '>') ADVANCE(118);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(143);
      if (lookahead == '>') ADVANCE(119);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(17);
      if (lookahead == '/') ADVANCE(173);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(17);
      if (lookahead == '/') ADVANCE(173);
      if (lookahead == '=') ADVANCE(99);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(88);
      if (lookahead == '/') ADVANCE(172);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(90);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(87);
      if (lookahead == '/') ADVANCE(171);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(17);
      if (lookahead != 0) ADVANCE(88);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(87);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(17);
      if (lookahead != 0) ADVANCE(88);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '/') ADVANCE(86);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(90);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(90);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_jsx_identifier);
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(91);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(19);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(188);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(188);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '?') ADVANCE(145);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '?') ADVANCE(144);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=') ADVANCE(108);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=') ADVANCE(109);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '>') ADVANCE(121);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(120);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(105);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(106);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(115);
      if (lookahead == '=') ADVANCE(102);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(114);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(101);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(103);
      if (lookahead == '|') ADVANCE(117);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(116);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(149);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(149);
      if (lookahead == '=') ADVANCE(96);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(150);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(150);
      if (lookahead == '=') ADVANCE(97);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(100);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(107);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(140);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(142);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(110);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(141);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(155);
      if (lookahead == '/') ADVANCE(157);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(157);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(154);
      if (lookahead == '/') ADVANCE(157);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(155);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(154);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(155);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/') ADVANCE(153);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(156);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(157);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(157);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(162);
      if (lookahead == '/') ADVANCE(164);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(164);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(161);
      if (lookahead == '/') ADVANCE(164);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(161);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(162);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '/') ADVANCE(160);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(163);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(164);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(164);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(152);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(159);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(27);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(192);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(165);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(169);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(173);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(172);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(173);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(17);
      if (lookahead == '/') ADVANCE(173);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '/') ADVANCE(15);
      if (lookahead == '[') ADVANCE(25);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(178);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(25);
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(178);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(27);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(179);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(192);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(189);
      if (lookahead == '0') ADVANCE(186);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(37);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(36);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(38);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(45);
      if (lookahead == '_') ADVANCE(41);
      if (lookahead == 'n') ADVANCE(180);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(182);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(189);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(36);
      if (lookahead == '_') ADVANCE(39);
      if (lookahead == 'n') ADVANCE(180);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(182);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(37);
      if (lookahead == 'n') ADVANCE(180);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(183);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(38);
      if (lookahead == 'n') ADVANCE(180);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(184);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(45);
      if (lookahead == 'n') ADVANCE(180);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(185);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(41);
      if (lookahead == 'n') ADVANCE(180);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(186);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(42);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(187);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(36);
      if (lookahead == '_') ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(188);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(188);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(91);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(190);
      if (lookahead != 0 &&
          (lookahead < 0 || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(192);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == '{') ADVANCE(175);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(192);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(27);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(192);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'l') ADVANCE(9);
      if (lookahead == 'n') ADVANCE(10);
      if (lookahead == 'o') ADVANCE(11);
      if (lookahead == 'r') ADVANCE(12);
      if (lookahead == 's') ADVANCE(13);
      if (lookahead == 't') ADVANCE(14);
      if (lookahead == 'u') ADVANCE(15);
      if (lookahead == 'v') ADVANCE(16);
      if (lookahead == 'w') ADVANCE(17);
      if (lookahead == 'y') ADVANCE(18);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 's') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      END_STATE();
    case 2:
      if (lookahead == 'r') ADVANCE(21);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(22);
      if (lookahead == 'l') ADVANCE(23);
      if (lookahead == 'o') ADVANCE(24);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(25);
      if (lookahead == 'o') ADVANCE(26);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(27);
      if (lookahead == 'x') ADVANCE(28);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(29);
      if (lookahead == 'i') ADVANCE(30);
      if (lookahead == 'o') ADVANCE(31);
      if (lookahead == 'r') ADVANCE(32);
      if (lookahead == 'u') ADVANCE(33);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(34);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(35);
      if (lookahead == 'm') ADVANCE(36);
      if (lookahead == 'n') ADVANCE(37);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(38);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 11:
      if (lookahead == 'f') ADVANCE(41);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(42);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(43);
      if (lookahead == 't') ADVANCE(44);
      if (lookahead == 'u') ADVANCE(45);
      if (lookahead == 'w') ADVANCE(46);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(47);
      if (lookahead == 'h') ADVANCE(48);
      if (lookahead == 'r') ADVANCE(49);
      if (lookahead == 'y') ADVANCE(50);
      END_STATE();
    case 15:
      if (lookahead == 'n') ADVANCE(51);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(52);
      if (lookahead == 'o') ADVANCE(53);
      END_STATE();
    case 17:
      if (lookahead == 'h') ADVANCE(54);
      if (lookahead == 'i') ADVANCE(55);
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(56);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(57);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(58);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(59);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(60);
      if (lookahead == 't') ADVANCE(61);
      END_STATE();
    case 23:
      if (lookahead == 'a') ADVANCE(62);
      END_STATE();
    case 24:
      if (lookahead == 'n') ADVANCE(63);
      END_STATE();
    case 25:
      if (lookahead == 'b') ADVANCE(64);
      if (lookahead == 'f') ADVANCE(65);
      if (lookahead == 'l') ADVANCE(66);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 27:
      if (lookahead == 's') ADVANCE(67);
      END_STATE();
    case 28:
      if (lookahead == 'p') ADVANCE(68);
      if (lookahead == 't') ADVANCE(69);
      END_STATE();
    case 29:
      if (lookahead == 'l') ADVANCE(70);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(71);
      END_STATE();
    case 31:
      if (lookahead == 'r') ADVANCE(72);
      END_STATE();
    case 32:
      if (lookahead == 'o') ADVANCE(73);
      END_STATE();
    case 33:
      if (lookahead == 'n') ADVANCE(74);
      END_STATE();
    case 34:
      if (lookahead == 't') ADVANCE(75);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 36:
      if (lookahead == 'p') ADVANCE(76);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(77);
      END_STATE();
    case 38:
      if (lookahead == 't') ADVANCE(78);
      END_STATE();
    case 39:
      if (lookahead == 'w') ADVANCE(79);
      END_STATE();
    case 40:
      if (lookahead == 'l') ADVANCE(80);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 42:
      if (lookahead == 't') ADVANCE(81);
      END_STATE();
    case 43:
      if (lookahead == 't') ADVANCE(82);
      END_STATE();
    case 44:
      if (lookahead == 'a') ADVANCE(83);
      END_STATE();
    case 45:
      if (lookahead == 'p') ADVANCE(84);
      END_STATE();
    case 46:
      if (lookahead == 'i') ADVANCE(85);
      END_STATE();
    case 47:
      if (lookahead == 'r') ADVANCE(86);
      END_STATE();
    case 48:
      if (lookahead == 'i') ADVANCE(87);
      if (lookahead == 'r') ADVANCE(88);
      END_STATE();
    case 49:
      if (lookahead == 'u') ADVANCE(89);
      if (lookahead == 'y') ADVANCE(90);
      END_STATE();
    case 50:
      if (lookahead == 'p') ADVANCE(91);
      END_STATE();
    case 51:
      if (lookahead == 'd') ADVANCE(92);
      END_STATE();
    case 52:
      if (lookahead == 'r') ADVANCE(93);
      END_STATE();
    case 53:
      if (lookahead == 'i') ADVANCE(94);
      END_STATE();
    case 54:
      if (lookahead == 'i') ADVANCE(95);
      END_STATE();
    case 55:
      if (lookahead == 't') ADVANCE(96);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 57:
      if (lookahead == 'n') ADVANCE(98);
      END_STATE();
    case 58:
      if (lookahead == 'i') ADVANCE(99);
      END_STATE();
    case 59:
      if (lookahead == 'a') ADVANCE(100);
      END_STATE();
    case 60:
      if (lookahead == 'e') ADVANCE(101);
      END_STATE();
    case 61:
      if (lookahead == 'c') ADVANCE(102);
      END_STATE();
    case 62:
      if (lookahead == 's') ADVANCE(103);
      END_STATE();
    case 63:
      if (lookahead == 's') ADVANCE(104);
      if (lookahead == 't') ADVANCE(105);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(106);
      END_STATE();
    case 65:
      if (lookahead == 'a') ADVANCE(107);
      END_STATE();
    case 66:
      if (lookahead == 'e') ADVANCE(108);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(109);
      END_STATE();
    case 68:
      if (lookahead == 'o') ADVANCE(110);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(111);
      END_STATE();
    case 70:
      if (lookahead == 's') ADVANCE(112);
      END_STATE();
    case 71:
      if (lookahead == 'a') ADVANCE(113);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 73:
      if (lookahead == 'm') ADVANCE(114);
      END_STATE();
    case 74:
      if (lookahead == 'c') ADVANCE(115);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 76:
      if (lookahead == 'o') ADVANCE(116);
      END_STATE();
    case 77:
      if (lookahead == 't') ADVANCE(117);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 80:
      if (lookahead == 'l') ADVANCE(118);
      END_STATE();
    case 81:
      if (lookahead == 'u') ADVANCE(119);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 83:
      if (lookahead == 't') ADVANCE(120);
      END_STATE();
    case 84:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 85:
      if (lookahead == 't') ADVANCE(122);
      END_STATE();
    case 86:
      if (lookahead == 'g') ADVANCE(123);
      END_STATE();
    case 87:
      if (lookahead == 's') ADVANCE(124);
      END_STATE();
    case 88:
      if (lookahead == 'o') ADVANCE(125);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(126);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 91:
      if (lookahead == 'e') ADVANCE(127);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(128);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 94:
      if (lookahead == 'd') ADVANCE(129);
      END_STATE();
    case 95:
      if (lookahead == 'l') ADVANCE(130);
      END_STATE();
    case 96:
      if (lookahead == 'h') ADVANCE(131);
      END_STATE();
    case 97:
      if (lookahead == 'l') ADVANCE(132);
      END_STATE();
    case 98:
      if (lookahead == 'c') ADVANCE(133);
      END_STATE();
    case 99:
      if (lookahead == 't') ADVANCE(134);
      END_STATE();
    case 100:
      if (lookahead == 'k') ADVANCE(135);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 102:
      if (lookahead == 'h') ADVANCE(136);
      END_STATE();
    case 103:
      if (lookahead == 's') ADVANCE(137);
      END_STATE();
    case 104:
      if (lookahead == 't') ADVANCE(138);
      END_STATE();
    case 105:
      if (lookahead == 'i') ADVANCE(139);
      END_STATE();
    case 106:
      if (lookahead == 'g') ADVANCE(140);
      END_STATE();
    case 107:
      if (lookahead == 'u') ADVANCE(141);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(142);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 110:
      if (lookahead == 'r') ADVANCE(143);
      END_STATE();
    case 111:
      if (lookahead == 'n') ADVANCE(144);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 113:
      if (lookahead == 'l') ADVANCE(146);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 115:
      if (lookahead == 't') ADVANCE(147);
      END_STATE();
    case 116:
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 117:
      if (lookahead == 'a') ADVANCE(149);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 119:
      if (lookahead == 'r') ADVANCE(150);
      END_STATE();
    case 120:
      if (lookahead == 'i') ADVANCE(151);
      END_STATE();
    case 121:
      if (lookahead == 'r') ADVANCE(152);
      END_STATE();
    case 122:
      if (lookahead == 'c') ADVANCE(153);
      END_STATE();
    case 123:
      if (lookahead == 'e') ADVANCE(154);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 125:
      if (lookahead == 'w') ADVANCE(155);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 127:
      if (lookahead == 'o') ADVANCE(156);
      END_STATE();
    case 128:
      if (lookahead == 'f') ADVANCE(157);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 130:
      if (lookahead == 'e') ADVANCE(158);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 132:
      if (lookahead == 'd') ADVANCE(159);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 139:
      if (lookahead == 'n') ADVANCE(160);
      END_STATE();
    case 140:
      if (lookahead == 'g') ADVANCE(161);
      END_STATE();
    case 141:
      if (lookahead == 'l') ADVANCE(162);
      END_STATE();
    case 142:
      if (lookahead == 'e') ADVANCE(163);
      END_STATE();
    case 143:
      if (lookahead == 't') ADVANCE(164);
      END_STATE();
    case 144:
      if (lookahead == 'd') ADVANCE(165);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 146:
      if (lookahead == 'l') ADVANCE(166);
      END_STATE();
    case 147:
      if (lookahead == 'i') ADVANCE(167);
      END_STATE();
    case 148:
      if (lookahead == 't') ADVANCE(168);
      END_STATE();
    case 149:
      if (lookahead == 'n') ADVANCE(169);
      END_STATE();
    case 150:
      if (lookahead == 'n') ADVANCE(170);
      END_STATE();
    case 151:
      if (lookahead == 'c') ADVANCE(171);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 153:
      if (lookahead == 'h') ADVANCE(172);
      END_STATE();
    case 154:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 156:
      if (lookahead == 'f') ADVANCE(174);
      END_STATE();
    case 157:
      if (lookahead == 'i') ADVANCE(175);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 160:
      if (lookahead == 'u') ADVANCE(176);
      END_STATE();
    case 161:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 162:
      if (lookahead == 't') ADVANCE(178);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 165:
      if (lookahead == 's') ADVANCE(179);
      END_STATE();
    case 166:
      if (lookahead == 'y') ADVANCE(180);
      END_STATE();
    case 167:
      if (lookahead == 'o') ADVANCE(181);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 169:
      if (lookahead == 'c') ADVANCE(182);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 175:
      if (lookahead == 'n') ADVANCE(183);
      END_STATE();
    case 176:
      if (lookahead == 'e') ADVANCE(184);
      END_STATE();
    case 177:
      if (lookahead == 'r') ADVANCE(185);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 181:
      if (lookahead == 'n') ADVANCE(186);
      END_STATE();
    case 182:
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 183:
      if (lookahead == 'e') ADVANCE(188);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 187:
      if (lookahead == 'o') ADVANCE(189);
      END_STATE();
    case 188:
      if (lookahead == 'd') ADVANCE(190);
      END_STATE();
    case 189:
      if (lookahead == 'f') ADVANCE(191);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 60},
  [2] = {.lex_state = 60},
  [3] = {.lex_state = 60},
  [4] = {.lex_state = 60},
  [5] = {.lex_state = 60},
  [6] = {.lex_state = 60},
  [7] = {.lex_state = 60},
  [8] = {.lex_state = 60},
  [9] = {.lex_state = 60},
  [10] = {.lex_state = 60},
  [11] = {.lex_state = 60},
  [12] = {.lex_state = 60},
  [13] = {.lex_state = 60},
  [14] = {.lex_state = 60},
  [15] = {.lex_state = 60},
  [16] = {.lex_state = 60},
  [17] = {.lex_state = 60},
  [18] = {.lex_state = 60},
  [19] = {.lex_state = 60},
  [20] = {.lex_state = 60},
  [21] = {.lex_state = 60},
  [22] = {.lex_state = 60},
  [23] = {.lex_state = 60},
  [24] = {.lex_state = 60},
  [25] = {.lex_state = 60},
  [26] = {.lex_state = 60},
  [27] = {.lex_state = 60},
  [28] = {.lex_state = 60},
  [29] = {.lex_state = 60},
  [30] = {.lex_state = 60},
  [31] = {.lex_state = 60},
  [32] = {.lex_state = 60},
  [33] = {.lex_state = 60},
  [34] = {.lex_state = 60},
  [35] = {.lex_state = 60},
  [36] = {.lex_state = 60},
  [37] = {.lex_state = 60},
  [38] = {.lex_state = 60},
  [39] = {.lex_state = 60},
  [40] = {.lex_state = 60},
  [41] = {.lex_state = 60},
  [42] = {.lex_state = 60},
  [43] = {.lex_state = 59},
  [44] = {.lex_state = 59, .external_lex_state = 2},
  [45] = {.lex_state = 59, .external_lex_state = 2},
  [46] = {.lex_state = 59, .external_lex_state = 2},
  [47] = {.lex_state = 59, .external_lex_state = 2},
  [48] = {.lex_state = 59, .external_lex_state = 2},
  [49] = {.lex_state = 59, .external_lex_state = 2},
  [50] = {.lex_state = 59, .external_lex_state = 2},
  [51] = {.lex_state = 59, .external_lex_state = 2},
  [52] = {.lex_state = 59, .external_lex_state = 2},
  [53] = {.lex_state = 59, .external_lex_state = 2},
  [54] = {.lex_state = 59, .external_lex_state = 2},
  [55] = {.lex_state = 59, .external_lex_state = 2},
  [56] = {.lex_state = 59, .external_lex_state = 2},
  [57] = {.lex_state = 59, .external_lex_state = 2},
  [58] = {.lex_state = 59, .external_lex_state = 2},
  [59] = {.lex_state = 59, .external_lex_state = 2},
  [60] = {.lex_state = 60},
  [61] = {.lex_state = 60},
  [62] = {.lex_state = 60},
  [63] = {.lex_state = 60},
  [64] = {.lex_state = 60},
  [65] = {.lex_state = 60},
  [66] = {.lex_state = 60},
  [67] = {.lex_state = 60},
  [68] = {.lex_state = 60},
  [69] = {.lex_state = 60},
  [70] = {.lex_state = 60},
  [71] = {.lex_state = 60},
  [72] = {.lex_state = 60},
  [73] = {.lex_state = 60},
  [74] = {.lex_state = 60},
  [75] = {.lex_state = 60},
  [76] = {.lex_state = 60, .external_lex_state = 2},
  [77] = {.lex_state = 60},
  [78] = {.lex_state = 60},
  [79] = {.lex_state = 60},
  [80] = {.lex_state = 60},
  [81] = {.lex_state = 60},
  [82] = {.lex_state = 60},
  [83] = {.lex_state = 60},
  [84] = {.lex_state = 60},
  [85] = {.lex_state = 60},
  [86] = {.lex_state = 60},
  [87] = {.lex_state = 60},
  [88] = {.lex_state = 60},
  [89] = {.lex_state = 7},
  [90] = {.lex_state = 60},
  [91] = {.lex_state = 60},
  [92] = {.lex_state = 60},
  [93] = {.lex_state = 60},
  [94] = {.lex_state = 7},
  [95] = {.lex_state = 60},
  [96] = {.lex_state = 60},
  [97] = {.lex_state = 60},
  [98] = {.lex_state = 60},
  [99] = {.lex_state = 60},
  [100] = {.lex_state = 60},
  [101] = {.lex_state = 60},
  [102] = {.lex_state = 60},
  [103] = {.lex_state = 60},
  [104] = {.lex_state = 60},
  [105] = {.lex_state = 60},
  [106] = {.lex_state = 60},
  [107] = {.lex_state = 60},
  [108] = {.lex_state = 60},
  [109] = {.lex_state = 60},
  [110] = {.lex_state = 60},
  [111] = {.lex_state = 60},
  [112] = {.lex_state = 60},
  [113] = {.lex_state = 60},
  [114] = {.lex_state = 60},
  [115] = {.lex_state = 60},
  [116] = {.lex_state = 60},
  [117] = {.lex_state = 60},
  [118] = {.lex_state = 60},
  [119] = {.lex_state = 60},
  [120] = {.lex_state = 60},
  [121] = {.lex_state = 60},
  [122] = {.lex_state = 60},
  [123] = {.lex_state = 60},
  [124] = {.lex_state = 60},
  [125] = {.lex_state = 60},
  [126] = {.lex_state = 60},
  [127] = {.lex_state = 60},
  [128] = {.lex_state = 60},
  [129] = {.lex_state = 60},
  [130] = {.lex_state = 60},
  [131] = {.lex_state = 60},
  [132] = {.lex_state = 60},
  [133] = {.lex_state = 8, .external_lex_state = 2},
  [134] = {.lex_state = 8, .external_lex_state = 2},
  [135] = {.lex_state = 60},
  [136] = {.lex_state = 60},
  [137] = {.lex_state = 60},
  [138] = {.lex_state = 60},
  [139] = {.lex_state = 60},
  [140] = {.lex_state = 60},
  [141] = {.lex_state = 60},
  [142] = {.lex_state = 60},
  [143] = {.lex_state = 60},
  [144] = {.lex_state = 60},
  [145] = {.lex_state = 60},
  [146] = {.lex_state = 60},
  [147] = {.lex_state = 60},
  [148] = {.lex_state = 60},
  [149] = {.lex_state = 60},
  [150] = {.lex_state = 60},
  [151] = {.lex_state = 60},
  [152] = {.lex_state = 60},
  [153] = {.lex_state = 60},
  [154] = {.lex_state = 60},
  [155] = {.lex_state = 60},
  [156] = {.lex_state = 60},
  [157] = {.lex_state = 60},
  [158] = {.lex_state = 60},
  [159] = {.lex_state = 60},
  [160] = {.lex_state = 60},
  [161] = {.lex_state = 60},
  [162] = {.lex_state = 60},
  [163] = {.lex_state = 60},
  [164] = {.lex_state = 60},
  [165] = {.lex_state = 60},
  [166] = {.lex_state = 60},
  [167] = {.lex_state = 60},
  [168] = {.lex_state = 60},
  [169] = {.lex_state = 60},
  [170] = {.lex_state = 60},
  [171] = {.lex_state = 60},
  [172] = {.lex_state = 60},
  [173] = {.lex_state = 60},
  [174] = {.lex_state = 60},
  [175] = {.lex_state = 60},
  [176] = {.lex_state = 60},
  [177] = {.lex_state = 60},
  [178] = {.lex_state = 60},
  [179] = {.lex_state = 60},
  [180] = {.lex_state = 8, .external_lex_state = 2},
  [181] = {.lex_state = 8, .external_lex_state = 2},
  [182] = {.lex_state = 8, .external_lex_state = 2},
  [183] = {.lex_state = 8, .external_lex_state = 2},
  [184] = {.lex_state = 60, .external_lex_state = 2},
  [185] = {.lex_state = 8},
  [186] = {.lex_state = 60, .external_lex_state = 2},
  [187] = {.lex_state = 8},
  [188] = {.lex_state = 60},
  [189] = {.lex_state = 60},
  [190] = {.lex_state = 60},
  [191] = {.lex_state = 8, .external_lex_state = 2},
  [192] = {.lex_state = 8, .external_lex_state = 2},
  [193] = {.lex_state = 60},
  [194] = {.lex_state = 8, .external_lex_state = 2},
  [195] = {.lex_state = 8, .external_lex_state = 2},
  [196] = {.lex_state = 8, .external_lex_state = 2},
  [197] = {.lex_state = 60, .external_lex_state = 2},
  [198] = {.lex_state = 60, .external_lex_state = 2},
  [199] = {.lex_state = 8},
  [200] = {.lex_state = 60, .external_lex_state = 2},
  [201] = {.lex_state = 60, .external_lex_state = 2},
  [202] = {.lex_state = 60},
  [203] = {.lex_state = 60, .external_lex_state = 2},
  [204] = {.lex_state = 60, .external_lex_state = 2},
  [205] = {.lex_state = 60, .external_lex_state = 2},
  [206] = {.lex_state = 60},
  [207] = {.lex_state = 60},
  [208] = {.lex_state = 60},
  [209] = {.lex_state = 60, .external_lex_state = 2},
  [210] = {.lex_state = 60},
  [211] = {.lex_state = 60, .external_lex_state = 2},
  [212] = {.lex_state = 60},
  [213] = {.lex_state = 60, .external_lex_state = 2},
  [214] = {.lex_state = 60, .external_lex_state = 2},
  [215] = {.lex_state = 60, .external_lex_state = 2},
  [216] = {.lex_state = 60, .external_lex_state = 2},
  [217] = {.lex_state = 60, .external_lex_state = 2},
  [218] = {.lex_state = 60},
  [219] = {.lex_state = 60},
  [220] = {.lex_state = 60},
  [221] = {.lex_state = 60},
  [222] = {.lex_state = 60},
  [223] = {.lex_state = 60},
  [224] = {.lex_state = 60},
  [225] = {.lex_state = 60},
  [226] = {.lex_state = 60},
  [227] = {.lex_state = 60},
  [228] = {.lex_state = 60},
  [229] = {.lex_state = 60},
  [230] = {.lex_state = 60},
  [231] = {.lex_state = 60},
  [232] = {.lex_state = 60},
  [233] = {.lex_state = 60},
  [234] = {.lex_state = 60},
  [235] = {.lex_state = 60},
  [236] = {.lex_state = 60},
  [237] = {.lex_state = 60},
  [238] = {.lex_state = 60},
  [239] = {.lex_state = 60},
  [240] = {.lex_state = 60},
  [241] = {.lex_state = 60},
  [242] = {.lex_state = 60},
  [243] = {.lex_state = 60},
  [244] = {.lex_state = 60},
  [245] = {.lex_state = 60},
  [246] = {.lex_state = 60},
  [247] = {.lex_state = 60},
  [248] = {.lex_state = 60},
  [249] = {.lex_state = 60},
  [250] = {.lex_state = 60},
  [251] = {.lex_state = 60},
  [252] = {.lex_state = 60},
  [253] = {.lex_state = 60},
  [254] = {.lex_state = 60},
  [255] = {.lex_state = 60},
  [256] = {.lex_state = 60},
  [257] = {.lex_state = 60},
  [258] = {.lex_state = 60},
  [259] = {.lex_state = 60},
  [260] = {.lex_state = 60},
  [261] = {.lex_state = 60},
  [262] = {.lex_state = 8},
  [263] = {.lex_state = 8},
  [264] = {.lex_state = 8},
  [265] = {.lex_state = 8},
  [266] = {.lex_state = 8, .external_lex_state = 2},
  [267] = {.lex_state = 8, .external_lex_state = 2},
  [268] = {.lex_state = 8},
  [269] = {.lex_state = 8},
  [270] = {.lex_state = 8},
  [271] = {.lex_state = 8},
  [272] = {.lex_state = 8},
  [273] = {.lex_state = 8},
  [274] = {.lex_state = 8},
  [275] = {.lex_state = 8, .external_lex_state = 2},
  [276] = {.lex_state = 8, .external_lex_state = 2},
  [277] = {.lex_state = 8, .external_lex_state = 2},
  [278] = {.lex_state = 8},
  [279] = {.lex_state = 8, .external_lex_state = 2},
  [280] = {.lex_state = 8, .external_lex_state = 2},
  [281] = {.lex_state = 8, .external_lex_state = 2},
  [282] = {.lex_state = 8, .external_lex_state = 2},
  [283] = {.lex_state = 60},
  [284] = {.lex_state = 60},
  [285] = {.lex_state = 8, .external_lex_state = 2},
  [286] = {.lex_state = 8, .external_lex_state = 2},
  [287] = {.lex_state = 60},
  [288] = {.lex_state = 8, .external_lex_state = 2},
  [289] = {.lex_state = 8, .external_lex_state = 2},
  [290] = {.lex_state = 8, .external_lex_state = 2},
  [291] = {.lex_state = 8, .external_lex_state = 2},
  [292] = {.lex_state = 8, .external_lex_state = 2},
  [293] = {.lex_state = 60},
  [294] = {.lex_state = 60},
  [295] = {.lex_state = 60},
  [296] = {.lex_state = 60},
  [297] = {.lex_state = 60},
  [298] = {.lex_state = 8, .external_lex_state = 2},
  [299] = {.lex_state = 8, .external_lex_state = 2},
  [300] = {.lex_state = 60},
  [301] = {.lex_state = 8},
  [302] = {.lex_state = 8, .external_lex_state = 2},
  [303] = {.lex_state = 8, .external_lex_state = 2},
  [304] = {.lex_state = 8},
  [305] = {.lex_state = 8},
  [306] = {.lex_state = 8},
  [307] = {.lex_state = 8},
  [308] = {.lex_state = 8},
  [309] = {.lex_state = 8},
  [310] = {.lex_state = 8},
  [311] = {.lex_state = 59},
  [312] = {.lex_state = 59},
  [313] = {.lex_state = 8},
  [314] = {.lex_state = 59},
  [315] = {.lex_state = 59, .external_lex_state = 2},
  [316] = {.lex_state = 59},
  [317] = {.lex_state = 59},
  [318] = {.lex_state = 59},
  [319] = {.lex_state = 59},
  [320] = {.lex_state = 59},
  [321] = {.lex_state = 59},
  [322] = {.lex_state = 59},
  [323] = {.lex_state = 59},
  [324] = {.lex_state = 59},
  [325] = {.lex_state = 59},
  [326] = {.lex_state = 59},
  [327] = {.lex_state = 59},
  [328] = {.lex_state = 59},
  [329] = {.lex_state = 59},
  [330] = {.lex_state = 59},
  [331] = {.lex_state = 59},
  [332] = {.lex_state = 59},
  [333] = {.lex_state = 59},
  [334] = {.lex_state = 59},
  [335] = {.lex_state = 59},
  [336] = {.lex_state = 59},
  [337] = {.lex_state = 59},
  [338] = {.lex_state = 59, .external_lex_state = 2},
  [339] = {.lex_state = 59},
  [340] = {.lex_state = 59},
  [341] = {.lex_state = 59},
  [342] = {.lex_state = 59},
  [343] = {.lex_state = 59},
  [344] = {.lex_state = 59},
  [345] = {.lex_state = 59},
  [346] = {.lex_state = 59},
  [347] = {.lex_state = 59},
  [348] = {.lex_state = 59},
  [349] = {.lex_state = 59},
  [350] = {.lex_state = 59},
  [351] = {.lex_state = 59},
  [352] = {.lex_state = 59},
  [353] = {.lex_state = 59},
  [354] = {.lex_state = 59},
  [355] = {.lex_state = 59},
  [356] = {.lex_state = 9},
  [357] = {.lex_state = 59, .external_lex_state = 2},
  [358] = {.lex_state = 59},
  [359] = {.lex_state = 59},
  [360] = {.lex_state = 59, .external_lex_state = 2},
  [361] = {.lex_state = 59},
  [362] = {.lex_state = 59},
  [363] = {.lex_state = 59},
  [364] = {.lex_state = 59},
  [365] = {.lex_state = 59, .external_lex_state = 2},
  [366] = {.lex_state = 59, .external_lex_state = 2},
  [367] = {.lex_state = 59},
  [368] = {.lex_state = 59, .external_lex_state = 2},
  [369] = {.lex_state = 59},
  [370] = {.lex_state = 59},
  [371] = {.lex_state = 59, .external_lex_state = 2},
  [372] = {.lex_state = 59, .external_lex_state = 2},
  [373] = {.lex_state = 59, .external_lex_state = 2},
  [374] = {.lex_state = 59, .external_lex_state = 2},
  [375] = {.lex_state = 59},
  [376] = {.lex_state = 59, .external_lex_state = 2},
  [377] = {.lex_state = 59, .external_lex_state = 2},
  [378] = {.lex_state = 59, .external_lex_state = 2},
  [379] = {.lex_state = 59},
  [380] = {.lex_state = 59},
  [381] = {.lex_state = 59},
  [382] = {.lex_state = 59},
  [383] = {.lex_state = 59, .external_lex_state = 2},
  [384] = {.lex_state = 59, .external_lex_state = 2},
  [385] = {.lex_state = 59, .external_lex_state = 2},
  [386] = {.lex_state = 59},
  [387] = {.lex_state = 59, .external_lex_state = 2},
  [388] = {.lex_state = 59},
  [389] = {.lex_state = 59},
  [390] = {.lex_state = 59, .external_lex_state = 2},
  [391] = {.lex_state = 59, .external_lex_state = 2},
  [392] = {.lex_state = 59},
  [393] = {.lex_state = 59, .external_lex_state = 2},
  [394] = {.lex_state = 59, .external_lex_state = 2},
  [395] = {.lex_state = 59, .external_lex_state = 2},
  [396] = {.lex_state = 59},
  [397] = {.lex_state = 59},
  [398] = {.lex_state = 59},
  [399] = {.lex_state = 59},
  [400] = {.lex_state = 59},
  [401] = {.lex_state = 59},
  [402] = {.lex_state = 59},
  [403] = {.lex_state = 59, .external_lex_state = 2},
  [404] = {.lex_state = 59, .external_lex_state = 2},
  [405] = {.lex_state = 59, .external_lex_state = 2},
  [406] = {.lex_state = 59},
  [407] = {.lex_state = 59},
  [408] = {.lex_state = 59, .external_lex_state = 2},
  [409] = {.lex_state = 59, .external_lex_state = 2},
  [410] = {.lex_state = 59, .external_lex_state = 2},
  [411] = {.lex_state = 59, .external_lex_state = 2},
  [412] = {.lex_state = 59, .external_lex_state = 2},
  [413] = {.lex_state = 59, .external_lex_state = 2},
  [414] = {.lex_state = 59, .external_lex_state = 2},
  [415] = {.lex_state = 59, .external_lex_state = 2},
  [416] = {.lex_state = 59, .external_lex_state = 2},
  [417] = {.lex_state = 59},
  [418] = {.lex_state = 59},
  [419] = {.lex_state = 59, .external_lex_state = 2},
  [420] = {.lex_state = 59, .external_lex_state = 2},
  [421] = {.lex_state = 59, .external_lex_state = 2},
  [422] = {.lex_state = 59, .external_lex_state = 2},
  [423] = {.lex_state = 59, .external_lex_state = 2},
  [424] = {.lex_state = 59, .external_lex_state = 2},
  [425] = {.lex_state = 59, .external_lex_state = 2},
  [426] = {.lex_state = 59},
  [427] = {.lex_state = 59},
  [428] = {.lex_state = 59, .external_lex_state = 2},
  [429] = {.lex_state = 59},
  [430] = {.lex_state = 59},
  [431] = {.lex_state = 59},
  [432] = {.lex_state = 59},
  [433] = {.lex_state = 59, .external_lex_state = 2},
  [434] = {.lex_state = 59},
  [435] = {.lex_state = 59},
  [436] = {.lex_state = 59},
  [437] = {.lex_state = 59, .external_lex_state = 2},
  [438] = {.lex_state = 59, .external_lex_state = 2},
  [439] = {.lex_state = 59},
  [440] = {.lex_state = 59},
  [441] = {.lex_state = 59},
  [442] = {.lex_state = 59},
  [443] = {.lex_state = 59},
  [444] = {.lex_state = 59},
  [445] = {.lex_state = 59},
  [446] = {.lex_state = 59},
  [447] = {.lex_state = 59},
  [448] = {.lex_state = 59},
  [449] = {.lex_state = 59, .external_lex_state = 2},
  [450] = {.lex_state = 59},
  [451] = {.lex_state = 59, .external_lex_state = 2},
  [452] = {.lex_state = 59, .external_lex_state = 2},
  [453] = {.lex_state = 59, .external_lex_state = 2},
  [454] = {.lex_state = 59},
  [455] = {.lex_state = 59, .external_lex_state = 2},
  [456] = {.lex_state = 59, .external_lex_state = 2},
  [457] = {.lex_state = 59},
  [458] = {.lex_state = 59, .external_lex_state = 2},
  [459] = {.lex_state = 59, .external_lex_state = 2},
  [460] = {.lex_state = 59},
  [461] = {.lex_state = 59, .external_lex_state = 2},
  [462] = {.lex_state = 59, .external_lex_state = 2},
  [463] = {.lex_state = 59, .external_lex_state = 2},
  [464] = {.lex_state = 59, .external_lex_state = 2},
  [465] = {.lex_state = 59},
  [466] = {.lex_state = 59, .external_lex_state = 2},
  [467] = {.lex_state = 59, .external_lex_state = 2},
  [468] = {.lex_state = 59, .external_lex_state = 2},
  [469] = {.lex_state = 59},
  [470] = {.lex_state = 59, .external_lex_state = 2},
  [471] = {.lex_state = 59, .external_lex_state = 2},
  [472] = {.lex_state = 59, .external_lex_state = 2},
  [473] = {.lex_state = 59, .external_lex_state = 2},
  [474] = {.lex_state = 59, .external_lex_state = 2},
  [475] = {.lex_state = 9, .external_lex_state = 2},
  [476] = {.lex_state = 59, .external_lex_state = 2},
  [477] = {.lex_state = 59},
  [478] = {.lex_state = 59},
  [479] = {.lex_state = 59},
  [480] = {.lex_state = 59, .external_lex_state = 2},
  [481] = {.lex_state = 59, .external_lex_state = 2},
  [482] = {.lex_state = 59, .external_lex_state = 2},
  [483] = {.lex_state = 59, .external_lex_state = 2},
  [484] = {.lex_state = 59, .external_lex_state = 2},
  [485] = {.lex_state = 59},
  [486] = {.lex_state = 59},
  [487] = {.lex_state = 59},
  [488] = {.lex_state = 59, .external_lex_state = 2},
  [489] = {.lex_state = 59, .external_lex_state = 2},
  [490] = {.lex_state = 59, .external_lex_state = 2},
  [491] = {.lex_state = 59, .external_lex_state = 2},
  [492] = {.lex_state = 59, .external_lex_state = 2},
  [493] = {.lex_state = 59, .external_lex_state = 2},
  [494] = {.lex_state = 59},
  [495] = {.lex_state = 59},
  [496] = {.lex_state = 59},
  [497] = {.lex_state = 59},
  [498] = {.lex_state = 59},
  [499] = {.lex_state = 59},
  [500] = {.lex_state = 59},
  [501] = {.lex_state = 59, .external_lex_state = 2},
  [502] = {.lex_state = 59},
  [503] = {.lex_state = 59},
  [504] = {.lex_state = 59},
  [505] = {.lex_state = 59},
  [506] = {.lex_state = 59, .external_lex_state = 2},
  [507] = {.lex_state = 59, .external_lex_state = 2},
  [508] = {.lex_state = 59, .external_lex_state = 2},
  [509] = {.lex_state = 59},
  [510] = {.lex_state = 59},
  [511] = {.lex_state = 59, .external_lex_state = 2},
  [512] = {.lex_state = 59},
  [513] = {.lex_state = 59, .external_lex_state = 2},
  [514] = {.lex_state = 59, .external_lex_state = 2},
  [515] = {.lex_state = 59, .external_lex_state = 2},
  [516] = {.lex_state = 59, .external_lex_state = 2},
  [517] = {.lex_state = 59, .external_lex_state = 2},
  [518] = {.lex_state = 59, .external_lex_state = 2},
  [519] = {.lex_state = 59, .external_lex_state = 2},
  [520] = {.lex_state = 59},
  [521] = {.lex_state = 59, .external_lex_state = 2},
  [522] = {.lex_state = 59, .external_lex_state = 2},
  [523] = {.lex_state = 59, .external_lex_state = 2},
  [524] = {.lex_state = 59},
  [525] = {.lex_state = 59, .external_lex_state = 2},
  [526] = {.lex_state = 59, .external_lex_state = 2},
  [527] = {.lex_state = 59},
  [528] = {.lex_state = 59},
  [529] = {.lex_state = 59, .external_lex_state = 2},
  [530] = {.lex_state = 59, .external_lex_state = 2},
  [531] = {.lex_state = 59},
  [532] = {.lex_state = 59, .external_lex_state = 2},
  [533] = {.lex_state = 59, .external_lex_state = 2},
  [534] = {.lex_state = 59, .external_lex_state = 2},
  [535] = {.lex_state = 59, .external_lex_state = 2},
  [536] = {.lex_state = 59, .external_lex_state = 2},
  [537] = {.lex_state = 59, .external_lex_state = 2},
  [538] = {.lex_state = 59, .external_lex_state = 2},
  [539] = {.lex_state = 59},
  [540] = {.lex_state = 59, .external_lex_state = 2},
  [541] = {.lex_state = 59, .external_lex_state = 2},
  [542] = {.lex_state = 59},
  [543] = {.lex_state = 59, .external_lex_state = 2},
  [544] = {.lex_state = 59, .external_lex_state = 2},
  [545] = {.lex_state = 59},
  [546] = {.lex_state = 59, .external_lex_state = 2},
  [547] = {.lex_state = 59, .external_lex_state = 2},
  [548] = {.lex_state = 59},
  [549] = {.lex_state = 59, .external_lex_state = 2},
  [550] = {.lex_state = 59, .external_lex_state = 2},
  [551] = {.lex_state = 59, .external_lex_state = 2},
  [552] = {.lex_state = 59, .external_lex_state = 2},
  [553] = {.lex_state = 59, .external_lex_state = 2},
  [554] = {.lex_state = 59, .external_lex_state = 2},
  [555] = {.lex_state = 59, .external_lex_state = 2},
  [556] = {.lex_state = 59, .external_lex_state = 2},
  [557] = {.lex_state = 59},
  [558] = {.lex_state = 59, .external_lex_state = 2},
  [559] = {.lex_state = 59},
  [560] = {.lex_state = 59},
  [561] = {.lex_state = 59, .external_lex_state = 2},
  [562] = {.lex_state = 59, .external_lex_state = 2},
  [563] = {.lex_state = 59, .external_lex_state = 2},
  [564] = {.lex_state = 59},
  [565] = {.lex_state = 59},
  [566] = {.lex_state = 59},
  [567] = {.lex_state = 59},
  [568] = {.lex_state = 59},
  [569] = {.lex_state = 59},
  [570] = {.lex_state = 59},
  [571] = {.lex_state = 59},
  [572] = {.lex_state = 59},
  [573] = {.lex_state = 59},
  [574] = {.lex_state = 59},
  [575] = {.lex_state = 59},
  [576] = {.lex_state = 59},
  [577] = {.lex_state = 60},
  [578] = {.lex_state = 60},
  [579] = {.lex_state = 60},
  [580] = {.lex_state = 60},
  [581] = {.lex_state = 60},
  [582] = {.lex_state = 60},
  [583] = {.lex_state = 60},
  [584] = {.lex_state = 60},
  [585] = {.lex_state = 60},
  [586] = {.lex_state = 60},
  [587] = {.lex_state = 60},
  [588] = {.lex_state = 60},
  [589] = {.lex_state = 60},
  [590] = {.lex_state = 60},
  [591] = {.lex_state = 60},
  [592] = {.lex_state = 60},
  [593] = {.lex_state = 60},
  [594] = {.lex_state = 60},
  [595] = {.lex_state = 60},
  [596] = {.lex_state = 60},
  [597] = {.lex_state = 60},
  [598] = {.lex_state = 60},
  [599] = {.lex_state = 60, .external_lex_state = 2},
  [600] = {.lex_state = 60, .external_lex_state = 2},
  [601] = {.lex_state = 60, .external_lex_state = 2},
  [602] = {.lex_state = 60},
  [603] = {.lex_state = 60},
  [604] = {.lex_state = 59},
  [605] = {.lex_state = 60},
  [606] = {.lex_state = 60, .external_lex_state = 2},
  [607] = {.lex_state = 59},
  [608] = {.lex_state = 60, .external_lex_state = 2},
  [609] = {.lex_state = 59},
  [610] = {.lex_state = 59},
  [611] = {.lex_state = 60},
  [612] = {.lex_state = 60},
  [613] = {.lex_state = 60},
  [614] = {.lex_state = 60},
  [615] = {.lex_state = 60},
  [616] = {.lex_state = 60},
  [617] = {.lex_state = 60},
  [618] = {.lex_state = 60},
  [619] = {.lex_state = 60},
  [620] = {.lex_state = 60},
  [621] = {.lex_state = 60},
  [622] = {.lex_state = 60},
  [623] = {.lex_state = 60},
  [624] = {.lex_state = 60},
  [625] = {.lex_state = 60},
  [626] = {.lex_state = 60},
  [627] = {.lex_state = 60},
  [628] = {.lex_state = 60},
  [629] = {.lex_state = 60},
  [630] = {.lex_state = 60},
  [631] = {.lex_state = 60},
  [632] = {.lex_state = 60},
  [633] = {.lex_state = 60},
  [634] = {.lex_state = 60},
  [635] = {.lex_state = 60},
  [636] = {.lex_state = 60},
  [637] = {.lex_state = 60},
  [638] = {.lex_state = 60},
  [639] = {.lex_state = 60},
  [640] = {.lex_state = 60},
  [641] = {.lex_state = 60},
  [642] = {.lex_state = 60},
  [643] = {.lex_state = 60},
  [644] = {.lex_state = 20},
  [645] = {.lex_state = 20},
  [646] = {.lex_state = 20},
  [647] = {.lex_state = 20},
  [648] = {.lex_state = 20},
  [649] = {.lex_state = 20},
  [650] = {.lex_state = 20},
  [651] = {.lex_state = 60},
  [652] = {.lex_state = 60},
  [653] = {.lex_state = 20},
  [654] = {.lex_state = 20},
  [655] = {.lex_state = 20},
  [656] = {.lex_state = 20},
  [657] = {.lex_state = 20},
  [658] = {.lex_state = 20},
  [659] = {.lex_state = 21},
  [660] = {.lex_state = 20},
  [661] = {.lex_state = 21},
  [662] = {.lex_state = 21},
  [663] = {.lex_state = 20},
  [664] = {.lex_state = 20},
  [665] = {.lex_state = 20},
  [666] = {.lex_state = 20},
  [667] = {.lex_state = 21},
  [668] = {.lex_state = 21},
  [669] = {.lex_state = 21},
  [670] = {.lex_state = 20},
  [671] = {.lex_state = 21},
  [672] = {.lex_state = 20},
  [673] = {.lex_state = 20},
  [674] = {.lex_state = 21},
  [675] = {.lex_state = 21},
  [676] = {.lex_state = 21},
  [677] = {.lex_state = 21},
  [678] = {.lex_state = 21},
  [679] = {.lex_state = 21},
  [680] = {.lex_state = 21},
  [681] = {.lex_state = 21},
  [682] = {.lex_state = 20},
  [683] = {.lex_state = 60},
  [684] = {.lex_state = 0, .external_lex_state = 2},
  [685] = {.lex_state = 60},
  [686] = {.lex_state = 60},
  [687] = {.lex_state = 12, .external_lex_state = 3},
  [688] = {.lex_state = 60},
  [689] = {.lex_state = 59},
  [690] = {.lex_state = 12, .external_lex_state = 3},
  [691] = {.lex_state = 12, .external_lex_state = 3},
  [692] = {.lex_state = 60},
  [693] = {.lex_state = 0, .external_lex_state = 2},
  [694] = {.lex_state = 20},
  [695] = {.lex_state = 59},
  [696] = {.lex_state = 20},
  [697] = {.lex_state = 60},
  [698] = {.lex_state = 59},
  [699] = {.lex_state = 12, .external_lex_state = 3},
  [700] = {.lex_state = 0},
  [701] = {.lex_state = 20},
  [702] = {.lex_state = 0},
  [703] = {.lex_state = 12, .external_lex_state = 3},
  [704] = {.lex_state = 60},
  [705] = {.lex_state = 20},
  [706] = {.lex_state = 0, .external_lex_state = 2},
  [707] = {.lex_state = 20},
  [708] = {.lex_state = 20},
  [709] = {.lex_state = 60},
  [710] = {.lex_state = 0, .external_lex_state = 2},
  [711] = {.lex_state = 20},
  [712] = {.lex_state = 20},
  [713] = {.lex_state = 60},
  [714] = {.lex_state = 60},
  [715] = {.lex_state = 20},
  [716] = {.lex_state = 60},
  [717] = {.lex_state = 60},
  [718] = {.lex_state = 20},
  [719] = {.lex_state = 20},
  [720] = {.lex_state = 20},
  [721] = {.lex_state = 20},
  [722] = {.lex_state = 0},
  [723] = {.lex_state = 60},
  [724] = {.lex_state = 20},
  [725] = {.lex_state = 0, .external_lex_state = 2},
  [726] = {.lex_state = 60},
  [727] = {.lex_state = 20},
  [728] = {.lex_state = 20},
  [729] = {.lex_state = 20},
  [730] = {.lex_state = 20},
  [731] = {.lex_state = 20},
  [732] = {.lex_state = 20},
  [733] = {.lex_state = 20},
  [734] = {.lex_state = 60},
  [735] = {.lex_state = 20},
  [736] = {.lex_state = 60},
  [737] = {.lex_state = 20},
  [738] = {.lex_state = 20},
  [739] = {.lex_state = 60},
  [740] = {.lex_state = 20},
  [741] = {.lex_state = 60},
  [742] = {.lex_state = 20},
  [743] = {.lex_state = 20},
  [744] = {.lex_state = 20},
  [745] = {.lex_state = 20},
  [746] = {.lex_state = 20},
  [747] = {.lex_state = 60},
  [748] = {.lex_state = 20},
  [749] = {.lex_state = 60},
  [750] = {.lex_state = 60},
  [751] = {.lex_state = 20},
  [752] = {.lex_state = 60, .external_lex_state = 2},
  [753] = {.lex_state = 60},
  [754] = {.lex_state = 60},
  [755] = {.lex_state = 12, .external_lex_state = 3},
  [756] = {.lex_state = 1},
  [757] = {.lex_state = 3},
  [758] = {.lex_state = 1},
  [759] = {.lex_state = 3},
  [760] = {.lex_state = 60},
  [761] = {.lex_state = 3},
  [762] = {.lex_state = 1},
  [763] = {.lex_state = 0},
  [764] = {.lex_state = 60},
  [765] = {.lex_state = 0},
  [766] = {.lex_state = 60},
  [767] = {.lex_state = 60},
  [768] = {.lex_state = 60},
  [769] = {.lex_state = 0, .external_lex_state = 2},
  [770] = {.lex_state = 60},
  [771] = {.lex_state = 0},
  [772] = {.lex_state = 60},
  [773] = {.lex_state = 3},
  [774] = {.lex_state = 1},
  [775] = {.lex_state = 1},
  [776] = {.lex_state = 3},
  [777] = {.lex_state = 60},
  [778] = {.lex_state = 3},
  [779] = {.lex_state = 1},
  [780] = {.lex_state = 60},
  [781] = {.lex_state = 60},
  [782] = {.lex_state = 3},
  [783] = {.lex_state = 0, .external_lex_state = 2},
  [784] = {.lex_state = 1},
  [785] = {.lex_state = 0, .external_lex_state = 2},
  [786] = {.lex_state = 0, .external_lex_state = 2},
  [787] = {.lex_state = 60},
  [788] = {.lex_state = 60},
  [789] = {.lex_state = 60},
  [790] = {.lex_state = 0, .external_lex_state = 2},
  [791] = {.lex_state = 60},
  [792] = {.lex_state = 60},
  [793] = {.lex_state = 60},
  [794] = {.lex_state = 0, .external_lex_state = 2},
  [795] = {.lex_state = 20},
  [796] = {.lex_state = 0, .external_lex_state = 2},
  [797] = {.lex_state = 20},
  [798] = {.lex_state = 60},
  [799] = {.lex_state = 20},
  [800] = {.lex_state = 0},
  [801] = {.lex_state = 60},
  [802] = {.lex_state = 60},
  [803] = {.lex_state = 60},
  [804] = {.lex_state = 60},
  [805] = {.lex_state = 0},
  [806] = {.lex_state = 0},
  [807] = {.lex_state = 60},
  [808] = {.lex_state = 0},
  [809] = {.lex_state = 0},
  [810] = {.lex_state = 0},
  [811] = {.lex_state = 60},
  [812] = {.lex_state = 0},
  [813] = {.lex_state = 0},
  [814] = {.lex_state = 0},
  [815] = {.lex_state = 0},
  [816] = {.lex_state = 0},
  [817] = {.lex_state = 0},
  [818] = {.lex_state = 0},
  [819] = {.lex_state = 60},
  [820] = {.lex_state = 60},
  [821] = {.lex_state = 0},
  [822] = {.lex_state = 0},
  [823] = {.lex_state = 60},
  [824] = {.lex_state = 0},
  [825] = {.lex_state = 0},
  [826] = {.lex_state = 0},
  [827] = {.lex_state = 60},
  [828] = {.lex_state = 0},
  [829] = {.lex_state = 0},
  [830] = {.lex_state = 60},
  [831] = {.lex_state = 0},
  [832] = {.lex_state = 60, .external_lex_state = 2},
  [833] = {.lex_state = 60},
  [834] = {.lex_state = 21},
  [835] = {.lex_state = 0},
  [836] = {.lex_state = 60},
  [837] = {.lex_state = 0},
  [838] = {.lex_state = 0},
  [839] = {.lex_state = 0, .external_lex_state = 2},
  [840] = {.lex_state = 60, .external_lex_state = 2},
  [841] = {.lex_state = 60, .external_lex_state = 2},
  [842] = {.lex_state = 60, .external_lex_state = 2},
  [843] = {.lex_state = 60},
  [844] = {.lex_state = 7},
  [845] = {.lex_state = 60},
  [846] = {.lex_state = 7},
  [847] = {.lex_state = 60, .external_lex_state = 2},
  [848] = {.lex_state = 7},
  [849] = {.lex_state = 0, .external_lex_state = 2},
  [850] = {.lex_state = 21},
  [851] = {.lex_state = 60},
  [852] = {.lex_state = 0},
  [853] = {.lex_state = 7},
  [854] = {.lex_state = 0},
  [855] = {.lex_state = 0},
  [856] = {.lex_state = 60},
  [857] = {.lex_state = 60},
  [858] = {.lex_state = 60, .external_lex_state = 2},
  [859] = {.lex_state = 0},
  [860] = {.lex_state = 0},
  [861] = {.lex_state = 0},
  [862] = {.lex_state = 0},
  [863] = {.lex_state = 0},
  [864] = {.lex_state = 0},
  [865] = {.lex_state = 0},
  [866] = {.lex_state = 0},
  [867] = {.lex_state = 0, .external_lex_state = 2},
  [868] = {.lex_state = 0, .external_lex_state = 2},
  [869] = {.lex_state = 0},
  [870] = {.lex_state = 0},
  [871] = {.lex_state = 0},
  [872] = {.lex_state = 21},
  [873] = {.lex_state = 0},
  [874] = {.lex_state = 21},
  [875] = {.lex_state = 21},
  [876] = {.lex_state = 60},
  [877] = {.lex_state = 21},
  [878] = {.lex_state = 21},
  [879] = {.lex_state = 0},
  [880] = {.lex_state = 21},
  [881] = {.lex_state = 0},
  [882] = {.lex_state = 60, .external_lex_state = 2},
  [883] = {.lex_state = 60},
  [884] = {.lex_state = 0},
  [885] = {.lex_state = 0},
  [886] = {.lex_state = 21},
  [887] = {.lex_state = 60, .external_lex_state = 2},
  [888] = {.lex_state = 0},
  [889] = {.lex_state = 0},
  [890] = {.lex_state = 0},
  [891] = {.lex_state = 0},
  [892] = {.lex_state = 0},
  [893] = {.lex_state = 0},
  [894] = {.lex_state = 0},
  [895] = {.lex_state = 0, .external_lex_state = 2},
  [896] = {.lex_state = 0},
  [897] = {.lex_state = 0},
  [898] = {.lex_state = 0},
  [899] = {.lex_state = 60},
  [900] = {.lex_state = 0},
  [901] = {.lex_state = 60},
  [902] = {.lex_state = 0},
  [903] = {.lex_state = 0},
  [904] = {.lex_state = 60},
  [905] = {.lex_state = 60},
  [906] = {.lex_state = 0},
  [907] = {.lex_state = 0},
  [908] = {.lex_state = 0, .external_lex_state = 2},
  [909] = {.lex_state = 0},
  [910] = {.lex_state = 0},
  [911] = {.lex_state = 0},
  [912] = {.lex_state = 0, .external_lex_state = 2},
  [913] = {.lex_state = 0},
  [914] = {.lex_state = 60},
  [915] = {.lex_state = 0},
  [916] = {.lex_state = 0},
  [917] = {.lex_state = 0},
  [918] = {.lex_state = 0},
  [919] = {.lex_state = 0, .external_lex_state = 2},
  [920] = {.lex_state = 0},
  [921] = {.lex_state = 0, .external_lex_state = 2},
  [922] = {.lex_state = 0},
  [923] = {.lex_state = 0},
  [924] = {.lex_state = 0},
  [925] = {.lex_state = 0},
  [926] = {.lex_state = 0},
  [927] = {.lex_state = 0},
  [928] = {.lex_state = 0},
  [929] = {.lex_state = 60},
  [930] = {.lex_state = 0, .external_lex_state = 2},
  [931] = {.lex_state = 0},
  [932] = {.lex_state = 0},
  [933] = {.lex_state = 0},
  [934] = {.lex_state = 0},
  [935] = {.lex_state = 0, .external_lex_state = 2},
  [936] = {.lex_state = 60},
  [937] = {.lex_state = 0},
  [938] = {.lex_state = 0},
  [939] = {.lex_state = 0},
  [940] = {.lex_state = 0, .external_lex_state = 2},
  [941] = {.lex_state = 0, .external_lex_state = 2},
  [942] = {.lex_state = 0},
  [943] = {.lex_state = 0, .external_lex_state = 2},
  [944] = {.lex_state = 0},
  [945] = {.lex_state = 0},
  [946] = {.lex_state = 0},
  [947] = {.lex_state = 0},
  [948] = {.lex_state = 0},
  [949] = {.lex_state = 0},
  [950] = {.lex_state = 0},
  [951] = {.lex_state = 0},
  [952] = {.lex_state = 0},
  [953] = {.lex_state = 0},
  [954] = {.lex_state = 0, .external_lex_state = 2},
  [955] = {.lex_state = 0},
  [956] = {.lex_state = 0},
  [957] = {.lex_state = 0},
  [958] = {.lex_state = 0},
  [959] = {.lex_state = 0},
  [960] = {.lex_state = 0, .external_lex_state = 2},
  [961] = {.lex_state = 0},
  [962] = {.lex_state = 0},
  [963] = {.lex_state = 0, .external_lex_state = 2},
  [964] = {.lex_state = 0},
  [965] = {.lex_state = 0},
  [966] = {.lex_state = 0},
  [967] = {.lex_state = 0},
  [968] = {.lex_state = 0},
  [969] = {.lex_state = 0},
  [970] = {.lex_state = 0},
  [971] = {.lex_state = 0},
  [972] = {.lex_state = 0},
  [973] = {.lex_state = 0},
  [974] = {.lex_state = 0},
  [975] = {.lex_state = 0, .external_lex_state = 2},
  [976] = {.lex_state = 0},
  [977] = {.lex_state = 0},
  [978] = {.lex_state = 0},
  [979] = {.lex_state = 20},
  [980] = {.lex_state = 0},
  [981] = {.lex_state = 0},
  [982] = {.lex_state = 0},
  [983] = {.lex_state = 0},
  [984] = {.lex_state = 0},
  [985] = {.lex_state = 0},
  [986] = {.lex_state = 0},
  [987] = {.lex_state = 0},
  [988] = {.lex_state = 60},
  [989] = {.lex_state = 0},
  [990] = {.lex_state = 0},
  [991] = {.lex_state = 0},
  [992] = {.lex_state = 0},
  [993] = {.lex_state = 0},
  [994] = {.lex_state = 0},
  [995] = {.lex_state = 60},
  [996] = {.lex_state = 0},
  [997] = {.lex_state = 7},
  [998] = {.lex_state = 0},
  [999] = {.lex_state = 0},
  [1000] = {.lex_state = 0},
  [1001] = {.lex_state = 60},
  [1002] = {.lex_state = 0},
  [1003] = {.lex_state = 0},
  [1004] = {.lex_state = 0},
  [1005] = {.lex_state = 0},
  [1006] = {.lex_state = 0},
  [1007] = {.lex_state = 0},
  [1008] = {.lex_state = 0},
  [1009] = {.lex_state = 0},
  [1010] = {.lex_state = 0},
  [1011] = {.lex_state = 0},
  [1012] = {.lex_state = 0},
  [1013] = {.lex_state = 0},
  [1014] = {.lex_state = 0},
  [1015] = {.lex_state = 0},
  [1016] = {.lex_state = 0},
  [1017] = {.lex_state = 60},
  [1018] = {.lex_state = 0},
  [1019] = {.lex_state = 7},
  [1020] = {.lex_state = 0},
  [1021] = {.lex_state = 0},
  [1022] = {.lex_state = 60},
  [1023] = {.lex_state = 7},
  [1024] = {.lex_state = 0},
  [1025] = {.lex_state = 60},
  [1026] = {.lex_state = 7},
  [1027] = {.lex_state = 0},
  [1028] = {.lex_state = 0},
  [1029] = {.lex_state = 0},
  [1030] = {.lex_state = 0},
  [1031] = {.lex_state = 0},
  [1032] = {.lex_state = 0},
  [1033] = {.lex_state = 0, .external_lex_state = 2},
  [1034] = {.lex_state = 0},
  [1035] = {.lex_state = 60},
  [1036] = {.lex_state = 0},
  [1037] = {.lex_state = 0},
  [1038] = {.lex_state = 0},
  [1039] = {.lex_state = 0},
  [1040] = {.lex_state = 0},
  [1041] = {.lex_state = 0},
  [1042] = {.lex_state = 0},
  [1043] = {.lex_state = 0},
  [1044] = {.lex_state = 0},
  [1045] = {.lex_state = 0},
  [1046] = {.lex_state = 5},
  [1047] = {.lex_state = 60},
  [1048] = {.lex_state = 60},
  [1049] = {.lex_state = 5},
  [1050] = {.lex_state = 60},
  [1051] = {.lex_state = 60},
  [1052] = {.lex_state = 0},
  [1053] = {.lex_state = 0},
  [1054] = {.lex_state = 60},
  [1055] = {.lex_state = 60},
  [1056] = {.lex_state = 0},
  [1057] = {.lex_state = 60},
  [1058] = {.lex_state = 60},
  [1059] = {.lex_state = 0},
  [1060] = {.lex_state = 0},
  [1061] = {.lex_state = 60},
  [1062] = {.lex_state = 60},
  [1063] = {.lex_state = 60},
  [1064] = {.lex_state = 60},
  [1065] = {.lex_state = 0},
  [1066] = {.lex_state = 60},
  [1067] = {.lex_state = 0},
  [1068] = {.lex_state = 0},
  [1069] = {.lex_state = 60},
  [1070] = {.lex_state = 60},
  [1071] = {.lex_state = 0},
  [1072] = {.lex_state = 60},
  [1073] = {.lex_state = 60},
  [1074] = {.lex_state = 60},
  [1075] = {.lex_state = 60},
  [1076] = {.lex_state = 60},
  [1077] = {.lex_state = 60},
  [1078] = {.lex_state = 0},
  [1079] = {.lex_state = 60},
  [1080] = {.lex_state = 12},
  [1081] = {.lex_state = 0},
  [1082] = {.lex_state = 0},
  [1083] = {.lex_state = 60},
  [1084] = {.lex_state = 60},
  [1085] = {.lex_state = 60},
  [1086] = {.lex_state = 0},
  [1087] = {.lex_state = 60},
  [1088] = {.lex_state = 60},
  [1089] = {.lex_state = 60},
  [1090] = {.lex_state = 0},
  [1091] = {.lex_state = 0},
  [1092] = {.lex_state = 60},
  [1093] = {.lex_state = 0},
  [1094] = {.lex_state = 60},
  [1095] = {.lex_state = 0},
  [1096] = {.lex_state = 0},
  [1097] = {.lex_state = 60},
  [1098] = {.lex_state = 60},
  [1099] = {.lex_state = 0},
  [1100] = {.lex_state = 0},
  [1101] = {.lex_state = 0},
  [1102] = {.lex_state = 60},
  [1103] = {.lex_state = 0},
  [1104] = {.lex_state = 0},
  [1105] = {.lex_state = 0},
  [1106] = {.lex_state = 0},
  [1107] = {.lex_state = 0},
  [1108] = {.lex_state = 60},
  [1109] = {.lex_state = 12},
  [1110] = {.lex_state = 0},
  [1111] = {.lex_state = 0},
  [1112] = {.lex_state = 0},
  [1113] = {.lex_state = 60},
  [1114] = {.lex_state = 0},
  [1115] = {.lex_state = 60},
  [1116] = {.lex_state = 60},
  [1117] = {.lex_state = 0},
  [1118] = {.lex_state = 60},
  [1119] = {.lex_state = 60},
  [1120] = {.lex_state = 60},
  [1121] = {.lex_state = 0},
  [1122] = {.lex_state = 0},
  [1123] = {.lex_state = 60},
  [1124] = {.lex_state = 60},
  [1125] = {.lex_state = 60},
  [1126] = {.lex_state = 0},
  [1127] = {.lex_state = 0},
  [1128] = {.lex_state = 60},
  [1129] = {.lex_state = 0},
  [1130] = {.lex_state = 0},
  [1131] = {.lex_state = 60},
  [1132] = {.lex_state = 60},
  [1133] = {.lex_state = 60},
  [1134] = {.lex_state = 60},
  [1135] = {.lex_state = 60},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
};

static bool ts_external_scanner_states[4][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
  },
  [2] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [3] = {
    [ts_external_token__template_chars] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(1130),
    [sym_export_statement] = STATE(22),
    [sym__declaration] = STATE(22),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(22),
    [sym_expression_statement] = STATE(22),
    [sym_variable_declaration] = STATE(22),
    [sym_lexical_declaration] = STATE(22),
    [sym_statement_block] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_switch_statement] = STATE(22),
    [sym_for_statement] = STATE(22),
    [sym_for_in_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_do_statement] = STATE(22),
    [sym_try_statement] = STATE(22),
    [sym_with_statement] = STATE(22),
    [sym_break_statement] = STATE(22),
    [sym_continue_statement] = STATE(22),
    [sym_debugger_statement] = STATE(22),
    [sym_return_statement] = STATE(22),
    [sym_throw_statement] = STATE(22),
    [sym_empty_statement] = STATE(22),
    [sym_labeled_statement] = STATE(22),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(22),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(22),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(22),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(22),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_hash_bang_line] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [2] = {
    [sym_export_statement] = STATE(12),
    [sym__declaration] = STATE(12),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(12),
    [sym_lexical_declaration] = STATE(12),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(532),
    [sym_assignment_pattern] = STATE(809),
    [sym_array] = STATE(529),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(12),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(12),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(12),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_spread_element] = STATE(809),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(534),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [sym_method_definition] = STATE(809),
    [sym_pair] = STATE(809),
    [sym__property_name] = STATE(890),
    [sym_computed_property_name] = STATE(890),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(594),
    [aux_sym_object_repeat1] = STATE(885),
    [sym_identifier] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(97),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(105),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
  },
  [3] = {
    [sym_export_statement] = STATE(14),
    [sym__declaration] = STATE(14),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym_variable_declaration] = STATE(14),
    [sym_lexical_declaration] = STATE(14),
    [sym_statement_block] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_switch_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_for_in_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_with_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_debugger_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_statement] = STATE(14),
    [sym_empty_statement] = STATE(14),
    [sym_labeled_statement] = STATE(14),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(532),
    [sym_assignment_pattern] = STATE(809),
    [sym_array] = STATE(529),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(14),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(14),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(14),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_spread_element] = STATE(809),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(534),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [sym_method_definition] = STATE(809),
    [sym_pair] = STATE(809),
    [sym__property_name] = STATE(890),
    [sym_computed_property_name] = STATE(890),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_export_statement_repeat1] = STATE(594),
    [aux_sym_object_repeat1] = STATE(885),
    [sym_identifier] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(105),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
  },
  [4] = {
    [sym_export_statement] = STATE(19),
    [sym__declaration] = STATE(19),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(19),
    [sym_lexical_declaration] = STATE(19),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(532),
    [sym_assignment_pattern] = STATE(884),
    [sym_array] = STATE(529),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(19),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(19),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(19),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_spread_element] = STATE(884),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(534),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [sym_method_definition] = STATE(884),
    [sym_pair] = STATE(884),
    [sym__property_name] = STATE(890),
    [sym_computed_property_name] = STATE(890),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(594),
    [aux_sym_object_repeat1] = STATE(889),
    [sym_identifier] = ACTIONS(113),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(115),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(117),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(105),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(119),
    [anon_sym_get] = ACTIONS(121),
    [anon_sym_set] = ACTIONS(121),
  },
  [5] = {
    [sym_export_statement] = STATE(12),
    [sym__declaration] = STATE(12),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(12),
    [sym_lexical_declaration] = STATE(12),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(532),
    [sym_assignment_pattern] = STATE(809),
    [sym_array] = STATE(529),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(12),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(12),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(12),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_spread_element] = STATE(809),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(534),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [sym_method_definition] = STATE(809),
    [sym_pair] = STATE(809),
    [sym__property_name] = STATE(890),
    [sym_computed_property_name] = STATE(890),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(594),
    [aux_sym_object_repeat1] = STATE(885),
    [sym_identifier] = ACTIONS(91),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(93),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(95),
    [anon_sym_RBRACE] = ACTIONS(123),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(99),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(101),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(105),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(107),
    [anon_sym_get] = ACTIONS(109),
    [anon_sym_set] = ACTIONS(109),
  },
  [6] = {
    [sym_export_statement] = STATE(6),
    [sym__declaration] = STATE(6),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_variable_declaration] = STATE(6),
    [sym_lexical_declaration] = STATE(6),
    [sym_statement_block] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_for_in_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_try_statement] = STATE(6),
    [sym_with_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_debugger_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_throw_statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(6),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(6),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(6),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [ts_builtin_sym_end] = ACTIONS(125),
    [sym_identifier] = ACTIONS(127),
    [anon_sym_export] = ACTIONS(130),
    [anon_sym_default] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_RBRACE] = ACTIONS(125),
    [anon_sym_import] = ACTIONS(138),
    [anon_sym_var] = ACTIONS(141),
    [anon_sym_let] = ACTIONS(144),
    [anon_sym_const] = ACTIONS(144),
    [anon_sym_if] = ACTIONS(147),
    [anon_sym_switch] = ACTIONS(150),
    [anon_sym_for] = ACTIONS(153),
    [anon_sym_LPAREN] = ACTIONS(156),
    [anon_sym_await] = ACTIONS(159),
    [anon_sym_while] = ACTIONS(162),
    [anon_sym_do] = ACTIONS(165),
    [anon_sym_try] = ACTIONS(168),
    [anon_sym_with] = ACTIONS(171),
    [anon_sym_break] = ACTIONS(174),
    [anon_sym_continue] = ACTIONS(177),
    [anon_sym_debugger] = ACTIONS(180),
    [anon_sym_return] = ACTIONS(183),
    [anon_sym_throw] = ACTIONS(186),
    [anon_sym_SEMI] = ACTIONS(189),
    [anon_sym_case] = ACTIONS(133),
    [anon_sym_yield] = ACTIONS(192),
    [anon_sym_LBRACK] = ACTIONS(195),
    [anon_sym_LT] = ACTIONS(198),
    [anon_sym_SLASH] = ACTIONS(201),
    [anon_sym_class] = ACTIONS(204),
    [anon_sym_async] = ACTIONS(207),
    [anon_sym_function] = ACTIONS(210),
    [anon_sym_new] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(216),
    [anon_sym_DASH] = ACTIONS(216),
    [anon_sym_BANG] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(219),
    [anon_sym_typeof] = ACTIONS(222),
    [anon_sym_void] = ACTIONS(222),
    [anon_sym_delete] = ACTIONS(222),
    [anon_sym_PLUS_PLUS] = ACTIONS(225),
    [anon_sym_DASH_DASH] = ACTIONS(225),
    [anon_sym_DQUOTE] = ACTIONS(228),
    [anon_sym_SQUOTE] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(234),
    [sym_number] = ACTIONS(237),
    [sym_this] = ACTIONS(240),
    [sym_super] = ACTIONS(243),
    [sym_true] = ACTIONS(240),
    [sym_false] = ACTIONS(240),
    [sym_null] = ACTIONS(240),
    [sym_undefined] = ACTIONS(240),
    [anon_sym_AT] = ACTIONS(246),
    [anon_sym_static] = ACTIONS(249),
    [anon_sym_get] = ACTIONS(249),
    [anon_sym_set] = ACTIONS(249),
  },
  [7] = {
    [sym_export_statement] = STATE(6),
    [sym__declaration] = STATE(6),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_variable_declaration] = STATE(6),
    [sym_lexical_declaration] = STATE(6),
    [sym_statement_block] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_for_in_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_try_statement] = STATE(6),
    [sym_with_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_debugger_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_throw_statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(6),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(6),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(6),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(252),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(254),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(252),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [8] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(256),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(258),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(256),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [9] = {
    [sym_export_statement] = STATE(6),
    [sym__declaration] = STATE(6),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_variable_declaration] = STATE(6),
    [sym_lexical_declaration] = STATE(6),
    [sym_statement_block] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_for_in_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_try_statement] = STATE(6),
    [sym_with_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_debugger_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_throw_statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(6),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(6),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(6),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(260),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(262),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(260),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [10] = {
    [sym_export_statement] = STATE(9),
    [sym__declaration] = STATE(9),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(9),
    [sym_lexical_declaration] = STATE(9),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(9),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(9),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(9),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(264),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(266),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(264),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [11] = {
    [sym_export_statement] = STATE(6),
    [sym__declaration] = STATE(6),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_variable_declaration] = STATE(6),
    [sym_lexical_declaration] = STATE(6),
    [sym_statement_block] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_for_in_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_try_statement] = STATE(6),
    [sym_with_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_debugger_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_throw_statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(6),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(6),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(6),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(268),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [12] = {
    [sym_export_statement] = STATE(6),
    [sym__declaration] = STATE(6),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_variable_declaration] = STATE(6),
    [sym_lexical_declaration] = STATE(6),
    [sym_statement_block] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_for_in_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_try_statement] = STATE(6),
    [sym_with_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_debugger_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_throw_statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(6),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(6),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(6),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [13] = {
    [sym_export_statement] = STATE(23),
    [sym__declaration] = STATE(23),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(23),
    [sym_expression_statement] = STATE(23),
    [sym_variable_declaration] = STATE(23),
    [sym_lexical_declaration] = STATE(23),
    [sym_statement_block] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_switch_statement] = STATE(23),
    [sym_for_statement] = STATE(23),
    [sym_for_in_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_do_statement] = STATE(23),
    [sym_try_statement] = STATE(23),
    [sym_with_statement] = STATE(23),
    [sym_break_statement] = STATE(23),
    [sym_continue_statement] = STATE(23),
    [sym_debugger_statement] = STATE(23),
    [sym_return_statement] = STATE(23),
    [sym_throw_statement] = STATE(23),
    [sym_empty_statement] = STATE(23),
    [sym_labeled_statement] = STATE(23),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(23),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(23),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(23),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(23),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [ts_builtin_sym_end] = ACTIONS(272),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [14] = {
    [sym_export_statement] = STATE(6),
    [sym__declaration] = STATE(6),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_variable_declaration] = STATE(6),
    [sym_lexical_declaration] = STATE(6),
    [sym_statement_block] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_for_in_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_try_statement] = STATE(6),
    [sym_with_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_debugger_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_throw_statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(6),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(6),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(6),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(274),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [15] = {
    [sym_export_statement] = STATE(19),
    [sym__declaration] = STATE(19),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(19),
    [sym_lexical_declaration] = STATE(19),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(19),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(19),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(19),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(276),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [16] = {
    [sym_export_statement] = STATE(11),
    [sym__declaration] = STATE(11),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(11),
    [sym_lexical_declaration] = STATE(11),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(11),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(11),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(11),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(278),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [17] = {
    [sym_export_statement] = STATE(6),
    [sym__declaration] = STATE(6),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_variable_declaration] = STATE(6),
    [sym_lexical_declaration] = STATE(6),
    [sym_statement_block] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_for_in_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_try_statement] = STATE(6),
    [sym_with_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_debugger_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_throw_statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(6),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(6),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(6),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(280),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [18] = {
    [sym_export_statement] = STATE(17),
    [sym__declaration] = STATE(17),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_variable_declaration] = STATE(17),
    [sym_lexical_declaration] = STATE(17),
    [sym_statement_block] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_for_in_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_try_statement] = STATE(17),
    [sym_with_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_debugger_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_throw_statement] = STATE(17),
    [sym_empty_statement] = STATE(17),
    [sym_labeled_statement] = STATE(17),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(17),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(17),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(17),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(282),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [19] = {
    [sym_export_statement] = STATE(6),
    [sym__declaration] = STATE(6),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_variable_declaration] = STATE(6),
    [sym_lexical_declaration] = STATE(6),
    [sym_statement_block] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_for_in_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_try_statement] = STATE(6),
    [sym_with_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_debugger_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_throw_statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(6),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(6),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(6),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(284),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [20] = {
    [sym_export_statement] = STATE(12),
    [sym__declaration] = STATE(12),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(12),
    [sym_lexical_declaration] = STATE(12),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(12),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(12),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(12),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(286),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [21] = {
    [sym_export_statement] = STATE(14),
    [sym__declaration] = STATE(14),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym_variable_declaration] = STATE(14),
    [sym_lexical_declaration] = STATE(14),
    [sym_statement_block] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_switch_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_for_in_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_with_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_debugger_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_statement] = STATE(14),
    [sym_empty_statement] = STATE(14),
    [sym_labeled_statement] = STATE(14),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(14),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(14),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(14),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(278),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [22] = {
    [sym_export_statement] = STATE(6),
    [sym__declaration] = STATE(6),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_variable_declaration] = STATE(6),
    [sym_lexical_declaration] = STATE(6),
    [sym_statement_block] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_for_in_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_try_statement] = STATE(6),
    [sym_with_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_debugger_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_throw_statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(6),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(6),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(6),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [ts_builtin_sym_end] = ACTIONS(272),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [23] = {
    [sym_export_statement] = STATE(6),
    [sym__declaration] = STATE(6),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_variable_declaration] = STATE(6),
    [sym_lexical_declaration] = STATE(6),
    [sym_statement_block] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_for_in_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_try_statement] = STATE(6),
    [sym_with_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_debugger_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_throw_statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(6),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(6),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(6),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [ts_builtin_sym_end] = ACTIONS(288),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [24] = {
    [sym_export_statement] = STATE(1001),
    [sym__declaration] = STATE(1001),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(1001),
    [sym_expression_statement] = STATE(1001),
    [sym_variable_declaration] = STATE(1001),
    [sym_lexical_declaration] = STATE(1001),
    [sym_statement_block] = STATE(1001),
    [sym_if_statement] = STATE(1001),
    [sym_switch_statement] = STATE(1001),
    [sym_for_statement] = STATE(1001),
    [sym_for_in_statement] = STATE(1001),
    [sym_while_statement] = STATE(1001),
    [sym_do_statement] = STATE(1001),
    [sym_try_statement] = STATE(1001),
    [sym_with_statement] = STATE(1001),
    [sym_break_statement] = STATE(1001),
    [sym_continue_statement] = STATE(1001),
    [sym_debugger_statement] = STATE(1001),
    [sym_return_statement] = STATE(1001),
    [sym_throw_statement] = STATE(1001),
    [sym_empty_statement] = STATE(1001),
    [sym_labeled_statement] = STATE(1001),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(1001),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(1001),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(1001),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(726),
    [sym_identifier] = ACTIONS(290),
    [anon_sym_export] = ACTIONS(292),
    [anon_sym_LBRACE] = ACTIONS(294),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(296),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(300),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(302),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(304),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_function] = ACTIONS(308),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(310),
    [anon_sym_get] = ACTIONS(310),
    [anon_sym_set] = ACTIONS(310),
  },
  [25] = {
    [sym_export_statement] = STATE(230),
    [sym__declaration] = STATE(230),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(230),
    [sym_expression_statement] = STATE(230),
    [sym_variable_declaration] = STATE(230),
    [sym_lexical_declaration] = STATE(230),
    [sym_statement_block] = STATE(230),
    [sym_if_statement] = STATE(230),
    [sym_switch_statement] = STATE(230),
    [sym_for_statement] = STATE(230),
    [sym_for_in_statement] = STATE(230),
    [sym_while_statement] = STATE(230),
    [sym_do_statement] = STATE(230),
    [sym_try_statement] = STATE(230),
    [sym_with_statement] = STATE(230),
    [sym_break_statement] = STATE(230),
    [sym_continue_statement] = STATE(230),
    [sym_debugger_statement] = STATE(230),
    [sym_return_statement] = STATE(230),
    [sym_throw_statement] = STATE(230),
    [sym_empty_statement] = STATE(230),
    [sym_labeled_statement] = STATE(230),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(230),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(230),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(230),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(726),
    [sym_identifier] = ACTIONS(290),
    [anon_sym_export] = ACTIONS(292),
    [anon_sym_LBRACE] = ACTIONS(294),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(296),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(300),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(302),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(304),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_function] = ACTIONS(308),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(310),
    [anon_sym_get] = ACTIONS(310),
    [anon_sym_set] = ACTIONS(310),
  },
  [26] = {
    [sym_export_statement] = STATE(226),
    [sym__declaration] = STATE(226),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(226),
    [sym_expression_statement] = STATE(226),
    [sym_variable_declaration] = STATE(226),
    [sym_lexical_declaration] = STATE(226),
    [sym_statement_block] = STATE(226),
    [sym_if_statement] = STATE(226),
    [sym_switch_statement] = STATE(226),
    [sym_for_statement] = STATE(226),
    [sym_for_in_statement] = STATE(226),
    [sym_while_statement] = STATE(226),
    [sym_do_statement] = STATE(226),
    [sym_try_statement] = STATE(226),
    [sym_with_statement] = STATE(226),
    [sym_break_statement] = STATE(226),
    [sym_continue_statement] = STATE(226),
    [sym_debugger_statement] = STATE(226),
    [sym_return_statement] = STATE(226),
    [sym_throw_statement] = STATE(226),
    [sym_empty_statement] = STATE(226),
    [sym_labeled_statement] = STATE(226),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(226),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(226),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(226),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [27] = {
    [sym_export_statement] = STATE(243),
    [sym__declaration] = STATE(243),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(243),
    [sym_expression_statement] = STATE(243),
    [sym_variable_declaration] = STATE(243),
    [sym_lexical_declaration] = STATE(243),
    [sym_statement_block] = STATE(243),
    [sym_if_statement] = STATE(243),
    [sym_switch_statement] = STATE(243),
    [sym_for_statement] = STATE(243),
    [sym_for_in_statement] = STATE(243),
    [sym_while_statement] = STATE(243),
    [sym_do_statement] = STATE(243),
    [sym_try_statement] = STATE(243),
    [sym_with_statement] = STATE(243),
    [sym_break_statement] = STATE(243),
    [sym_continue_statement] = STATE(243),
    [sym_debugger_statement] = STATE(243),
    [sym_return_statement] = STATE(243),
    [sym_throw_statement] = STATE(243),
    [sym_empty_statement] = STATE(243),
    [sym_labeled_statement] = STATE(243),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(243),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(243),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(243),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [28] = {
    [sym_export_statement] = STATE(245),
    [sym__declaration] = STATE(245),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(245),
    [sym_expression_statement] = STATE(245),
    [sym_variable_declaration] = STATE(245),
    [sym_lexical_declaration] = STATE(245),
    [sym_statement_block] = STATE(245),
    [sym_if_statement] = STATE(245),
    [sym_switch_statement] = STATE(245),
    [sym_for_statement] = STATE(245),
    [sym_for_in_statement] = STATE(245),
    [sym_while_statement] = STATE(245),
    [sym_do_statement] = STATE(245),
    [sym_try_statement] = STATE(245),
    [sym_with_statement] = STATE(245),
    [sym_break_statement] = STATE(245),
    [sym_continue_statement] = STATE(245),
    [sym_debugger_statement] = STATE(245),
    [sym_return_statement] = STATE(245),
    [sym_throw_statement] = STATE(245),
    [sym_empty_statement] = STATE(245),
    [sym_labeled_statement] = STATE(245),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(245),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(245),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(245),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [29] = {
    [sym_export_statement] = STATE(230),
    [sym__declaration] = STATE(230),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(230),
    [sym_expression_statement] = STATE(230),
    [sym_variable_declaration] = STATE(230),
    [sym_lexical_declaration] = STATE(230),
    [sym_statement_block] = STATE(230),
    [sym_if_statement] = STATE(230),
    [sym_switch_statement] = STATE(230),
    [sym_for_statement] = STATE(230),
    [sym_for_in_statement] = STATE(230),
    [sym_while_statement] = STATE(230),
    [sym_do_statement] = STATE(230),
    [sym_try_statement] = STATE(230),
    [sym_with_statement] = STATE(230),
    [sym_break_statement] = STATE(230),
    [sym_continue_statement] = STATE(230),
    [sym_debugger_statement] = STATE(230),
    [sym_return_statement] = STATE(230),
    [sym_throw_statement] = STATE(230),
    [sym_empty_statement] = STATE(230),
    [sym_labeled_statement] = STATE(230),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(230),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(230),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(230),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [30] = {
    [sym_export_statement] = STATE(1102),
    [sym__declaration] = STATE(1102),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(1102),
    [sym_expression_statement] = STATE(1102),
    [sym_variable_declaration] = STATE(1102),
    [sym_lexical_declaration] = STATE(1102),
    [sym_statement_block] = STATE(1102),
    [sym_if_statement] = STATE(1102),
    [sym_switch_statement] = STATE(1102),
    [sym_for_statement] = STATE(1102),
    [sym_for_in_statement] = STATE(1102),
    [sym_while_statement] = STATE(1102),
    [sym_do_statement] = STATE(1102),
    [sym_try_statement] = STATE(1102),
    [sym_with_statement] = STATE(1102),
    [sym_break_statement] = STATE(1102),
    [sym_continue_statement] = STATE(1102),
    [sym_debugger_statement] = STATE(1102),
    [sym_return_statement] = STATE(1102),
    [sym_throw_statement] = STATE(1102),
    [sym_empty_statement] = STATE(1102),
    [sym_labeled_statement] = STATE(1102),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(1102),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(1102),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(1102),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(726),
    [sym_identifier] = ACTIONS(290),
    [anon_sym_export] = ACTIONS(292),
    [anon_sym_LBRACE] = ACTIONS(294),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(296),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(300),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(302),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(304),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_function] = ACTIONS(308),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(310),
    [anon_sym_get] = ACTIONS(310),
    [anon_sym_set] = ACTIONS(310),
  },
  [31] = {
    [sym_export_statement] = STATE(234),
    [sym__declaration] = STATE(234),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(234),
    [sym_expression_statement] = STATE(234),
    [sym_variable_declaration] = STATE(234),
    [sym_lexical_declaration] = STATE(234),
    [sym_statement_block] = STATE(234),
    [sym_if_statement] = STATE(234),
    [sym_switch_statement] = STATE(234),
    [sym_for_statement] = STATE(234),
    [sym_for_in_statement] = STATE(234),
    [sym_while_statement] = STATE(234),
    [sym_do_statement] = STATE(234),
    [sym_try_statement] = STATE(234),
    [sym_with_statement] = STATE(234),
    [sym_break_statement] = STATE(234),
    [sym_continue_statement] = STATE(234),
    [sym_debugger_statement] = STATE(234),
    [sym_return_statement] = STATE(234),
    [sym_throw_statement] = STATE(234),
    [sym_empty_statement] = STATE(234),
    [sym_labeled_statement] = STATE(234),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(234),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(234),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(234),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [32] = {
    [sym_export_statement] = STATE(219),
    [sym__declaration] = STATE(219),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(219),
    [sym_expression_statement] = STATE(219),
    [sym_variable_declaration] = STATE(219),
    [sym_lexical_declaration] = STATE(219),
    [sym_statement_block] = STATE(219),
    [sym_if_statement] = STATE(219),
    [sym_switch_statement] = STATE(219),
    [sym_for_statement] = STATE(219),
    [sym_for_in_statement] = STATE(219),
    [sym_while_statement] = STATE(219),
    [sym_do_statement] = STATE(219),
    [sym_try_statement] = STATE(219),
    [sym_with_statement] = STATE(219),
    [sym_break_statement] = STATE(219),
    [sym_continue_statement] = STATE(219),
    [sym_debugger_statement] = STATE(219),
    [sym_return_statement] = STATE(219),
    [sym_throw_statement] = STATE(219),
    [sym_empty_statement] = STATE(219),
    [sym_labeled_statement] = STATE(219),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(219),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(219),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(219),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(726),
    [sym_identifier] = ACTIONS(290),
    [anon_sym_export] = ACTIONS(292),
    [anon_sym_LBRACE] = ACTIONS(294),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(296),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(300),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(302),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(304),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_function] = ACTIONS(308),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(310),
    [anon_sym_get] = ACTIONS(310),
    [anon_sym_set] = ACTIONS(310),
  },
  [33] = {
    [sym_export_statement] = STATE(226),
    [sym__declaration] = STATE(226),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(226),
    [sym_expression_statement] = STATE(226),
    [sym_variable_declaration] = STATE(226),
    [sym_lexical_declaration] = STATE(226),
    [sym_statement_block] = STATE(226),
    [sym_if_statement] = STATE(226),
    [sym_switch_statement] = STATE(226),
    [sym_for_statement] = STATE(226),
    [sym_for_in_statement] = STATE(226),
    [sym_while_statement] = STATE(226),
    [sym_do_statement] = STATE(226),
    [sym_try_statement] = STATE(226),
    [sym_with_statement] = STATE(226),
    [sym_break_statement] = STATE(226),
    [sym_continue_statement] = STATE(226),
    [sym_debugger_statement] = STATE(226),
    [sym_return_statement] = STATE(226),
    [sym_throw_statement] = STATE(226),
    [sym_empty_statement] = STATE(226),
    [sym_labeled_statement] = STATE(226),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(226),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(226),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(226),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(726),
    [sym_identifier] = ACTIONS(290),
    [anon_sym_export] = ACTIONS(292),
    [anon_sym_LBRACE] = ACTIONS(294),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(296),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(300),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(302),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(304),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_function] = ACTIONS(308),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(310),
    [anon_sym_get] = ACTIONS(310),
    [anon_sym_set] = ACTIONS(310),
  },
  [34] = {
    [sym_export_statement] = STATE(219),
    [sym__declaration] = STATE(219),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(219),
    [sym_expression_statement] = STATE(219),
    [sym_variable_declaration] = STATE(219),
    [sym_lexical_declaration] = STATE(219),
    [sym_statement_block] = STATE(219),
    [sym_if_statement] = STATE(219),
    [sym_switch_statement] = STATE(219),
    [sym_for_statement] = STATE(219),
    [sym_for_in_statement] = STATE(219),
    [sym_while_statement] = STATE(219),
    [sym_do_statement] = STATE(219),
    [sym_try_statement] = STATE(219),
    [sym_with_statement] = STATE(219),
    [sym_break_statement] = STATE(219),
    [sym_continue_statement] = STATE(219),
    [sym_debugger_statement] = STATE(219),
    [sym_return_statement] = STATE(219),
    [sym_throw_statement] = STATE(219),
    [sym_empty_statement] = STATE(219),
    [sym_labeled_statement] = STATE(219),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(219),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(219),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(219),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [35] = {
    [sym_export_statement] = STATE(234),
    [sym__declaration] = STATE(234),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(234),
    [sym_expression_statement] = STATE(234),
    [sym_variable_declaration] = STATE(234),
    [sym_lexical_declaration] = STATE(234),
    [sym_statement_block] = STATE(234),
    [sym_if_statement] = STATE(234),
    [sym_switch_statement] = STATE(234),
    [sym_for_statement] = STATE(234),
    [sym_for_in_statement] = STATE(234),
    [sym_while_statement] = STATE(234),
    [sym_do_statement] = STATE(234),
    [sym_try_statement] = STATE(234),
    [sym_with_statement] = STATE(234),
    [sym_break_statement] = STATE(234),
    [sym_continue_statement] = STATE(234),
    [sym_debugger_statement] = STATE(234),
    [sym_return_statement] = STATE(234),
    [sym_throw_statement] = STATE(234),
    [sym_empty_statement] = STATE(234),
    [sym_labeled_statement] = STATE(234),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(234),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(234),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(234),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(726),
    [sym_identifier] = ACTIONS(290),
    [anon_sym_export] = ACTIONS(292),
    [anon_sym_LBRACE] = ACTIONS(294),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(296),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(300),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(302),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(304),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_function] = ACTIONS(308),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(310),
    [anon_sym_get] = ACTIONS(310),
    [anon_sym_set] = ACTIONS(310),
  },
  [36] = {
    [sym_export_statement] = STATE(258),
    [sym__declaration] = STATE(258),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(258),
    [sym_expression_statement] = STATE(258),
    [sym_variable_declaration] = STATE(258),
    [sym_lexical_declaration] = STATE(258),
    [sym_statement_block] = STATE(258),
    [sym_if_statement] = STATE(258),
    [sym_switch_statement] = STATE(258),
    [sym_for_statement] = STATE(258),
    [sym_for_in_statement] = STATE(258),
    [sym_while_statement] = STATE(258),
    [sym_do_statement] = STATE(258),
    [sym_try_statement] = STATE(258),
    [sym_with_statement] = STATE(258),
    [sym_break_statement] = STATE(258),
    [sym_continue_statement] = STATE(258),
    [sym_debugger_statement] = STATE(258),
    [sym_return_statement] = STATE(258),
    [sym_throw_statement] = STATE(258),
    [sym_empty_statement] = STATE(258),
    [sym_labeled_statement] = STATE(258),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(258),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(258),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(258),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [37] = {
    [sym_export_statement] = STATE(260),
    [sym__declaration] = STATE(260),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(260),
    [sym_expression_statement] = STATE(260),
    [sym_variable_declaration] = STATE(260),
    [sym_lexical_declaration] = STATE(260),
    [sym_statement_block] = STATE(260),
    [sym_if_statement] = STATE(260),
    [sym_switch_statement] = STATE(260),
    [sym_for_statement] = STATE(260),
    [sym_for_in_statement] = STATE(260),
    [sym_while_statement] = STATE(260),
    [sym_do_statement] = STATE(260),
    [sym_try_statement] = STATE(260),
    [sym_with_statement] = STATE(260),
    [sym_break_statement] = STATE(260),
    [sym_continue_statement] = STATE(260),
    [sym_debugger_statement] = STATE(260),
    [sym_return_statement] = STATE(260),
    [sym_throw_statement] = STATE(260),
    [sym_empty_statement] = STATE(260),
    [sym_labeled_statement] = STATE(260),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(260),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(260),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(260),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [38] = {
    [sym_export_statement] = STATE(245),
    [sym__declaration] = STATE(245),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(245),
    [sym_expression_statement] = STATE(245),
    [sym_variable_declaration] = STATE(245),
    [sym_lexical_declaration] = STATE(245),
    [sym_statement_block] = STATE(245),
    [sym_if_statement] = STATE(245),
    [sym_switch_statement] = STATE(245),
    [sym_for_statement] = STATE(245),
    [sym_for_in_statement] = STATE(245),
    [sym_while_statement] = STATE(245),
    [sym_do_statement] = STATE(245),
    [sym_try_statement] = STATE(245),
    [sym_with_statement] = STATE(245),
    [sym_break_statement] = STATE(245),
    [sym_continue_statement] = STATE(245),
    [sym_debugger_statement] = STATE(245),
    [sym_return_statement] = STATE(245),
    [sym_throw_statement] = STATE(245),
    [sym_empty_statement] = STATE(245),
    [sym_labeled_statement] = STATE(245),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(245),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(245),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(245),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(726),
    [sym_identifier] = ACTIONS(290),
    [anon_sym_export] = ACTIONS(292),
    [anon_sym_LBRACE] = ACTIONS(294),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(296),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(300),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(302),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(304),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_function] = ACTIONS(308),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(310),
    [anon_sym_get] = ACTIONS(310),
    [anon_sym_set] = ACTIONS(310),
  },
  [39] = {
    [sym_export_statement] = STATE(242),
    [sym__declaration] = STATE(242),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(242),
    [sym_expression_statement] = STATE(242),
    [sym_variable_declaration] = STATE(242),
    [sym_lexical_declaration] = STATE(242),
    [sym_statement_block] = STATE(242),
    [sym_if_statement] = STATE(242),
    [sym_switch_statement] = STATE(242),
    [sym_for_statement] = STATE(242),
    [sym_for_in_statement] = STATE(242),
    [sym_while_statement] = STATE(242),
    [sym_do_statement] = STATE(242),
    [sym_try_statement] = STATE(242),
    [sym_with_statement] = STATE(242),
    [sym_break_statement] = STATE(242),
    [sym_continue_statement] = STATE(242),
    [sym_debugger_statement] = STATE(242),
    [sym_return_statement] = STATE(242),
    [sym_throw_statement] = STATE(242),
    [sym_empty_statement] = STATE(242),
    [sym_labeled_statement] = STATE(242),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(242),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(242),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(242),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
  },
  [40] = {
    [sym_export_statement] = STATE(243),
    [sym__declaration] = STATE(243),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(243),
    [sym_expression_statement] = STATE(243),
    [sym_variable_declaration] = STATE(243),
    [sym_lexical_declaration] = STATE(243),
    [sym_statement_block] = STATE(243),
    [sym_if_statement] = STATE(243),
    [sym_switch_statement] = STATE(243),
    [sym_for_statement] = STATE(243),
    [sym_for_in_statement] = STATE(243),
    [sym_while_statement] = STATE(243),
    [sym_do_statement] = STATE(243),
    [sym_try_statement] = STATE(243),
    [sym_with_statement] = STATE(243),
    [sym_break_statement] = STATE(243),
    [sym_continue_statement] = STATE(243),
    [sym_debugger_statement] = STATE(243),
    [sym_return_statement] = STATE(243),
    [sym_throw_statement] = STATE(243),
    [sym_empty_statement] = STATE(243),
    [sym_labeled_statement] = STATE(243),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(243),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(243),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(243),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(726),
    [sym_identifier] = ACTIONS(290),
    [anon_sym_export] = ACTIONS(292),
    [anon_sym_LBRACE] = ACTIONS(294),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(296),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(300),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(302),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(304),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_function] = ACTIONS(308),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(310),
    [anon_sym_get] = ACTIONS(310),
    [anon_sym_set] = ACTIONS(310),
  },
  [41] = {
    [sym_export_statement] = STATE(260),
    [sym__declaration] = STATE(260),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(260),
    [sym_expression_statement] = STATE(260),
    [sym_variable_declaration] = STATE(260),
    [sym_lexical_declaration] = STATE(260),
    [sym_statement_block] = STATE(260),
    [sym_if_statement] = STATE(260),
    [sym_switch_statement] = STATE(260),
    [sym_for_statement] = STATE(260),
    [sym_for_in_statement] = STATE(260),
    [sym_while_statement] = STATE(260),
    [sym_do_statement] = STATE(260),
    [sym_try_statement] = STATE(260),
    [sym_with_statement] = STATE(260),
    [sym_break_statement] = STATE(260),
    [sym_continue_statement] = STATE(260),
    [sym_debugger_statement] = STATE(260),
    [sym_return_statement] = STATE(260),
    [sym_throw_statement] = STATE(260),
    [sym_empty_statement] = STATE(260),
    [sym_labeled_statement] = STATE(260),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(260),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(260),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(260),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(726),
    [sym_identifier] = ACTIONS(290),
    [anon_sym_export] = ACTIONS(292),
    [anon_sym_LBRACE] = ACTIONS(294),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(296),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(300),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(302),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(304),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_function] = ACTIONS(308),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(310),
    [anon_sym_get] = ACTIONS(310),
    [anon_sym_set] = ACTIONS(310),
  },
  [42] = {
    [sym_export_statement] = STATE(242),
    [sym__declaration] = STATE(242),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(242),
    [sym_expression_statement] = STATE(242),
    [sym_variable_declaration] = STATE(242),
    [sym_lexical_declaration] = STATE(242),
    [sym_statement_block] = STATE(242),
    [sym_if_statement] = STATE(242),
    [sym_switch_statement] = STATE(242),
    [sym_for_statement] = STATE(242),
    [sym_for_in_statement] = STATE(242),
    [sym_while_statement] = STATE(242),
    [sym_do_statement] = STATE(242),
    [sym_try_statement] = STATE(242),
    [sym_with_statement] = STATE(242),
    [sym_break_statement] = STATE(242),
    [sym_continue_statement] = STATE(242),
    [sym_debugger_statement] = STATE(242),
    [sym_return_statement] = STATE(242),
    [sym_throw_statement] = STATE(242),
    [sym_empty_statement] = STATE(242),
    [sym_labeled_statement] = STATE(242),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(242),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(242),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(242),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(726),
    [sym_identifier] = ACTIONS(290),
    [anon_sym_export] = ACTIONS(292),
    [anon_sym_LBRACE] = ACTIONS(294),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(296),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(298),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(300),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(302),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(304),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_function] = ACTIONS(308),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(310),
    [anon_sym_get] = ACTIONS(310),
    [anon_sym_set] = ACTIONS(310),
  },
  [43] = {
    [sym_import] = STATE(319),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(319),
    [sym_yield_expression] = STATE(319),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(319),
    [sym_jsx_fragment] = STATE(319),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(319),
    [sym_class] = STATE(319),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(319),
    [sym_arrow_function] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_new_expression] = STATE(319),
    [sym_await_expression] = STATE(319),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(319),
    [sym_augmented_assignment_expression] = STATE(319),
    [sym_ternary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_update_expression] = STATE(319),
    [sym_string] = STATE(319),
    [sym_template_string] = STATE(319),
    [sym_regex] = STATE(319),
    [sym_meta_property] = STATE(319),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_STAR] = ACTIONS(314),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_COMMA] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(318),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_RPAREN] = ACTIONS(318),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_in] = ACTIONS(326),
    [anon_sym_COLON] = ACTIONS(318),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_RBRACK] = ACTIONS(318),
    [anon_sym_LT] = ACTIONS(332),
    [anon_sym_GT] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_DOT] = ACTIONS(326),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_QMARK] = ACTIONS(326),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [anon_sym_GT_GT] = ACTIONS(326),
    [anon_sym_GT_GT_GT] = ACTIONS(318),
    [anon_sym_LT_LT] = ACTIONS(318),
    [anon_sym_AMP] = ACTIONS(326),
    [anon_sym_CARET] = ACTIONS(318),
    [anon_sym_PIPE] = ACTIONS(326),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_PERCENT] = ACTIONS(318),
    [anon_sym_STAR_STAR] = ACTIONS(318),
    [anon_sym_LT_EQ] = ACTIONS(318),
    [anon_sym_EQ_EQ] = ACTIONS(326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(318),
    [anon_sym_BANG_EQ] = ACTIONS(326),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(318),
    [anon_sym_GT_EQ] = ACTIONS(318),
    [anon_sym_QMARK_QMARK] = ACTIONS(318),
    [anon_sym_instanceof] = ACTIONS(326),
    [anon_sym_BANG] = ACTIONS(346),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(360),
    [sym_this] = ACTIONS(362),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(362),
    [sym_false] = ACTIONS(362),
    [sym_null] = ACTIONS(362),
    [sym_undefined] = ACTIONS(362),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [44] = {
    [sym_import] = STATE(384),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(384),
    [sym_yield_expression] = STATE(384),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(384),
    [sym_jsx_fragment] = STATE(384),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(384),
    [sym_class] = STATE(384),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(384),
    [sym_arrow_function] = STATE(384),
    [sym_call_expression] = STATE(384),
    [sym_new_expression] = STATE(384),
    [sym_await_expression] = STATE(384),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(384),
    [sym_augmented_assignment_expression] = STATE(384),
    [sym_ternary_expression] = STATE(384),
    [sym_binary_expression] = STATE(384),
    [sym_unary_expression] = STATE(384),
    [sym_update_expression] = STATE(384),
    [sym_string] = STATE(384),
    [sym_template_string] = STATE(384),
    [sym_regex] = STATE(384),
    [sym_meta_property] = STATE(384),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_STAR] = ACTIONS(370),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_COMMA] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(318),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_in] = ACTIONS(326),
    [anon_sym_SEMI] = ACTIONS(318),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(376),
    [anon_sym_GT] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_DOT] = ACTIONS(326),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_QMARK] = ACTIONS(326),
    [anon_sym_AMP_AMP] = ACTIONS(318),
    [anon_sym_PIPE_PIPE] = ACTIONS(318),
    [anon_sym_GT_GT] = ACTIONS(326),
    [anon_sym_GT_GT_GT] = ACTIONS(318),
    [anon_sym_LT_LT] = ACTIONS(318),
    [anon_sym_AMP] = ACTIONS(326),
    [anon_sym_CARET] = ACTIONS(318),
    [anon_sym_PIPE] = ACTIONS(326),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_PERCENT] = ACTIONS(318),
    [anon_sym_STAR_STAR] = ACTIONS(318),
    [anon_sym_LT_EQ] = ACTIONS(318),
    [anon_sym_EQ_EQ] = ACTIONS(326),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(318),
    [anon_sym_BANG_EQ] = ACTIONS(326),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(318),
    [anon_sym_GT_EQ] = ACTIONS(318),
    [anon_sym_QMARK_QMARK] = ACTIONS(318),
    [anon_sym_instanceof] = ACTIONS(326),
    [anon_sym_BANG] = ACTIONS(384),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(386),
    [sym_this] = ACTIONS(388),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(388),
    [sym_false] = ACTIONS(388),
    [sym_null] = ACTIONS(388),
    [sym_undefined] = ACTIONS(388),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
    [sym__automatic_semicolon] = ACTIONS(318),
  },
  [45] = {
    [ts_builtin_sym_end] = ACTIONS(392),
    [sym_identifier] = ACTIONS(394),
    [anon_sym_export] = ACTIONS(394),
    [anon_sym_STAR] = ACTIONS(396),
    [anon_sym_default] = ACTIONS(394),
    [anon_sym_LBRACE] = ACTIONS(392),
    [anon_sym_COMMA] = ACTIONS(398),
    [anon_sym_RBRACE] = ACTIONS(392),
    [anon_sym_import] = ACTIONS(394),
    [anon_sym_var] = ACTIONS(394),
    [anon_sym_let] = ACTIONS(394),
    [anon_sym_const] = ACTIONS(394),
    [anon_sym_if] = ACTIONS(394),
    [anon_sym_else] = ACTIONS(394),
    [anon_sym_switch] = ACTIONS(394),
    [anon_sym_for] = ACTIONS(394),
    [anon_sym_LPAREN] = ACTIONS(392),
    [anon_sym_await] = ACTIONS(394),
    [anon_sym_in] = ACTIONS(396),
    [anon_sym_while] = ACTIONS(394),
    [anon_sym_do] = ACTIONS(394),
    [anon_sym_try] = ACTIONS(394),
    [anon_sym_with] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(394),
    [anon_sym_continue] = ACTIONS(394),
    [anon_sym_debugger] = ACTIONS(394),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_throw] = ACTIONS(394),
    [anon_sym_SEMI] = ACTIONS(392),
    [anon_sym_case] = ACTIONS(394),
    [anon_sym_yield] = ACTIONS(394),
    [anon_sym_EQ] = ACTIONS(396),
    [anon_sym_LBRACK] = ACTIONS(392),
    [anon_sym_LT] = ACTIONS(394),
    [anon_sym_GT] = ACTIONS(396),
    [anon_sym_SLASH] = ACTIONS(394),
    [anon_sym_DOT] = ACTIONS(396),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_async] = ACTIONS(394),
    [anon_sym_function] = ACTIONS(394),
    [anon_sym_new] = ACTIONS(394),
    [anon_sym_QMARK] = ACTIONS(396),
    [anon_sym_AMP_AMP] = ACTIONS(398),
    [anon_sym_PIPE_PIPE] = ACTIONS(398),
    [anon_sym_GT_GT] = ACTIONS(396),
    [anon_sym_GT_GT_GT] = ACTIONS(398),
    [anon_sym_LT_LT] = ACTIONS(398),
    [anon_sym_AMP] = ACTIONS(396),
    [anon_sym_CARET] = ACTIONS(398),
    [anon_sym_PIPE] = ACTIONS(396),
    [anon_sym_PLUS] = ACTIONS(394),
    [anon_sym_DASH] = ACTIONS(394),
    [anon_sym_PERCENT] = ACTIONS(398),
    [anon_sym_STAR_STAR] = ACTIONS(398),
    [anon_sym_LT_EQ] = ACTIONS(398),
    [anon_sym_EQ_EQ] = ACTIONS(396),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(398),
    [anon_sym_BANG_EQ] = ACTIONS(396),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(398),
    [anon_sym_GT_EQ] = ACTIONS(398),
    [anon_sym_QMARK_QMARK] = ACTIONS(398),
    [anon_sym_instanceof] = ACTIONS(396),
    [anon_sym_BANG] = ACTIONS(394),
    [anon_sym_TILDE] = ACTIONS(392),
    [anon_sym_typeof] = ACTIONS(394),
    [anon_sym_void] = ACTIONS(394),
    [anon_sym_delete] = ACTIONS(394),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DQUOTE] = ACTIONS(392),
    [anon_sym_SQUOTE] = ACTIONS(392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(392),
    [sym_number] = ACTIONS(392),
    [sym_this] = ACTIONS(394),
    [sym_super] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_null] = ACTIONS(394),
    [sym_undefined] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(392),
    [anon_sym_static] = ACTIONS(394),
    [anon_sym_get] = ACTIONS(394),
    [anon_sym_set] = ACTIONS(394),
    [sym__automatic_semicolon] = ACTIONS(400),
  },
  [46] = {
    [ts_builtin_sym_end] = ACTIONS(402),
    [sym_identifier] = ACTIONS(404),
    [anon_sym_export] = ACTIONS(404),
    [anon_sym_STAR] = ACTIONS(406),
    [anon_sym_default] = ACTIONS(404),
    [anon_sym_LBRACE] = ACTIONS(402),
    [anon_sym_COMMA] = ACTIONS(408),
    [anon_sym_RBRACE] = ACTIONS(402),
    [anon_sym_import] = ACTIONS(404),
    [anon_sym_var] = ACTIONS(404),
    [anon_sym_let] = ACTIONS(404),
    [anon_sym_const] = ACTIONS(404),
    [anon_sym_if] = ACTIONS(404),
    [anon_sym_else] = ACTIONS(404),
    [anon_sym_switch] = ACTIONS(404),
    [anon_sym_for] = ACTIONS(404),
    [anon_sym_LPAREN] = ACTIONS(402),
    [anon_sym_await] = ACTIONS(404),
    [anon_sym_in] = ACTIONS(406),
    [anon_sym_while] = ACTIONS(404),
    [anon_sym_do] = ACTIONS(404),
    [anon_sym_try] = ACTIONS(404),
    [anon_sym_with] = ACTIONS(404),
    [anon_sym_break] = ACTIONS(404),
    [anon_sym_continue] = ACTIONS(404),
    [anon_sym_debugger] = ACTIONS(404),
    [anon_sym_return] = ACTIONS(404),
    [anon_sym_throw] = ACTIONS(404),
    [anon_sym_SEMI] = ACTIONS(402),
    [anon_sym_case] = ACTIONS(404),
    [anon_sym_yield] = ACTIONS(404),
    [anon_sym_LBRACK] = ACTIONS(402),
    [anon_sym_LT] = ACTIONS(404),
    [anon_sym_GT] = ACTIONS(406),
    [anon_sym_SLASH] = ACTIONS(404),
    [anon_sym_DOT] = ACTIONS(406),
    [anon_sym_class] = ACTIONS(404),
    [anon_sym_async] = ACTIONS(404),
    [anon_sym_function] = ACTIONS(404),
    [anon_sym_new] = ACTIONS(404),
    [anon_sym_QMARK] = ACTIONS(406),
    [anon_sym_AMP_AMP] = ACTIONS(408),
    [anon_sym_PIPE_PIPE] = ACTIONS(408),
    [anon_sym_GT_GT] = ACTIONS(406),
    [anon_sym_GT_GT_GT] = ACTIONS(408),
    [anon_sym_LT_LT] = ACTIONS(408),
    [anon_sym_AMP] = ACTIONS(406),
    [anon_sym_CARET] = ACTIONS(408),
    [anon_sym_PIPE] = ACTIONS(406),
    [anon_sym_PLUS] = ACTIONS(404),
    [anon_sym_DASH] = ACTIONS(404),
    [anon_sym_PERCENT] = ACTIONS(408),
    [anon_sym_STAR_STAR] = ACTIONS(408),
    [anon_sym_LT_EQ] = ACTIONS(408),
    [anon_sym_EQ_EQ] = ACTIONS(406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(408),
    [anon_sym_BANG_EQ] = ACTIONS(406),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(408),
    [anon_sym_GT_EQ] = ACTIONS(408),
    [anon_sym_QMARK_QMARK] = ACTIONS(408),
    [anon_sym_instanceof] = ACTIONS(406),
    [anon_sym_BANG] = ACTIONS(404),
    [anon_sym_TILDE] = ACTIONS(402),
    [anon_sym_typeof] = ACTIONS(404),
    [anon_sym_void] = ACTIONS(404),
    [anon_sym_delete] = ACTIONS(404),
    [anon_sym_PLUS_PLUS] = ACTIONS(402),
    [anon_sym_DASH_DASH] = ACTIONS(402),
    [anon_sym_DQUOTE] = ACTIONS(402),
    [anon_sym_SQUOTE] = ACTIONS(402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(402),
    [sym_number] = ACTIONS(402),
    [sym_this] = ACTIONS(404),
    [sym_super] = ACTIONS(404),
    [sym_true] = ACTIONS(404),
    [sym_false] = ACTIONS(404),
    [sym_null] = ACTIONS(404),
    [sym_undefined] = ACTIONS(404),
    [anon_sym_AT] = ACTIONS(402),
    [anon_sym_static] = ACTIONS(404),
    [anon_sym_get] = ACTIONS(404),
    [anon_sym_set] = ACTIONS(404),
    [sym__automatic_semicolon] = ACTIONS(410),
  },
  [47] = {
    [ts_builtin_sym_end] = ACTIONS(412),
    [sym_identifier] = ACTIONS(414),
    [anon_sym_export] = ACTIONS(414),
    [anon_sym_STAR] = ACTIONS(416),
    [anon_sym_default] = ACTIONS(414),
    [anon_sym_LBRACE] = ACTIONS(412),
    [anon_sym_COMMA] = ACTIONS(418),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_import] = ACTIONS(414),
    [anon_sym_var] = ACTIONS(414),
    [anon_sym_let] = ACTIONS(414),
    [anon_sym_const] = ACTIONS(414),
    [anon_sym_if] = ACTIONS(414),
    [anon_sym_else] = ACTIONS(414),
    [anon_sym_switch] = ACTIONS(414),
    [anon_sym_for] = ACTIONS(414),
    [anon_sym_LPAREN] = ACTIONS(412),
    [anon_sym_await] = ACTIONS(414),
    [anon_sym_in] = ACTIONS(416),
    [anon_sym_while] = ACTIONS(414),
    [anon_sym_do] = ACTIONS(414),
    [anon_sym_try] = ACTIONS(414),
    [anon_sym_with] = ACTIONS(414),
    [anon_sym_break] = ACTIONS(414),
    [anon_sym_continue] = ACTIONS(414),
    [anon_sym_debugger] = ACTIONS(414),
    [anon_sym_return] = ACTIONS(414),
    [anon_sym_throw] = ACTIONS(414),
    [anon_sym_SEMI] = ACTIONS(412),
    [anon_sym_case] = ACTIONS(414),
    [anon_sym_yield] = ACTIONS(414),
    [anon_sym_LBRACK] = ACTIONS(412),
    [anon_sym_LT] = ACTIONS(414),
    [anon_sym_GT] = ACTIONS(416),
    [anon_sym_SLASH] = ACTIONS(414),
    [anon_sym_DOT] = ACTIONS(416),
    [anon_sym_class] = ACTIONS(414),
    [anon_sym_async] = ACTIONS(414),
    [anon_sym_function] = ACTIONS(414),
    [anon_sym_new] = ACTIONS(414),
    [anon_sym_QMARK] = ACTIONS(416),
    [anon_sym_AMP_AMP] = ACTIONS(418),
    [anon_sym_PIPE_PIPE] = ACTIONS(418),
    [anon_sym_GT_GT] = ACTIONS(416),
    [anon_sym_GT_GT_GT] = ACTIONS(418),
    [anon_sym_LT_LT] = ACTIONS(418),
    [anon_sym_AMP] = ACTIONS(416),
    [anon_sym_CARET] = ACTIONS(418),
    [anon_sym_PIPE] = ACTIONS(416),
    [anon_sym_PLUS] = ACTIONS(414),
    [anon_sym_DASH] = ACTIONS(414),
    [anon_sym_PERCENT] = ACTIONS(418),
    [anon_sym_STAR_STAR] = ACTIONS(418),
    [anon_sym_LT_EQ] = ACTIONS(418),
    [anon_sym_EQ_EQ] = ACTIONS(416),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(418),
    [anon_sym_BANG_EQ] = ACTIONS(416),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(418),
    [anon_sym_GT_EQ] = ACTIONS(418),
    [anon_sym_QMARK_QMARK] = ACTIONS(418),
    [anon_sym_instanceof] = ACTIONS(416),
    [anon_sym_BANG] = ACTIONS(414),
    [anon_sym_TILDE] = ACTIONS(412),
    [anon_sym_typeof] = ACTIONS(414),
    [anon_sym_void] = ACTIONS(414),
    [anon_sym_delete] = ACTIONS(414),
    [anon_sym_PLUS_PLUS] = ACTIONS(412),
    [anon_sym_DASH_DASH] = ACTIONS(412),
    [anon_sym_DQUOTE] = ACTIONS(412),
    [anon_sym_SQUOTE] = ACTIONS(412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(412),
    [sym_number] = ACTIONS(412),
    [sym_this] = ACTIONS(414),
    [sym_super] = ACTIONS(414),
    [sym_true] = ACTIONS(414),
    [sym_false] = ACTIONS(414),
    [sym_null] = ACTIONS(414),
    [sym_undefined] = ACTIONS(414),
    [anon_sym_AT] = ACTIONS(412),
    [anon_sym_static] = ACTIONS(414),
    [anon_sym_get] = ACTIONS(414),
    [anon_sym_set] = ACTIONS(414),
    [sym__automatic_semicolon] = ACTIONS(420),
  },
  [48] = {
    [ts_builtin_sym_end] = ACTIONS(422),
    [sym_identifier] = ACTIONS(424),
    [anon_sym_export] = ACTIONS(424),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_default] = ACTIONS(424),
    [anon_sym_LBRACE] = ACTIONS(422),
    [anon_sym_COMMA] = ACTIONS(428),
    [anon_sym_RBRACE] = ACTIONS(422),
    [anon_sym_import] = ACTIONS(424),
    [anon_sym_var] = ACTIONS(424),
    [anon_sym_let] = ACTIONS(424),
    [anon_sym_const] = ACTIONS(424),
    [anon_sym_if] = ACTIONS(424),
    [anon_sym_else] = ACTIONS(424),
    [anon_sym_switch] = ACTIONS(424),
    [anon_sym_for] = ACTIONS(424),
    [anon_sym_LPAREN] = ACTIONS(422),
    [anon_sym_await] = ACTIONS(424),
    [anon_sym_in] = ACTIONS(426),
    [anon_sym_while] = ACTIONS(424),
    [anon_sym_do] = ACTIONS(424),
    [anon_sym_try] = ACTIONS(424),
    [anon_sym_with] = ACTIONS(424),
    [anon_sym_break] = ACTIONS(424),
    [anon_sym_continue] = ACTIONS(424),
    [anon_sym_debugger] = ACTIONS(424),
    [anon_sym_return] = ACTIONS(424),
    [anon_sym_throw] = ACTIONS(424),
    [anon_sym_SEMI] = ACTIONS(422),
    [anon_sym_case] = ACTIONS(424),
    [anon_sym_yield] = ACTIONS(424),
    [anon_sym_LBRACK] = ACTIONS(422),
    [anon_sym_LT] = ACTIONS(424),
    [anon_sym_GT] = ACTIONS(426),
    [anon_sym_SLASH] = ACTIONS(424),
    [anon_sym_DOT] = ACTIONS(426),
    [anon_sym_class] = ACTIONS(424),
    [anon_sym_async] = ACTIONS(424),
    [anon_sym_function] = ACTIONS(424),
    [anon_sym_new] = ACTIONS(424),
    [anon_sym_QMARK] = ACTIONS(426),
    [anon_sym_AMP_AMP] = ACTIONS(428),
    [anon_sym_PIPE_PIPE] = ACTIONS(428),
    [anon_sym_GT_GT] = ACTIONS(426),
    [anon_sym_GT_GT_GT] = ACTIONS(428),
    [anon_sym_LT_LT] = ACTIONS(428),
    [anon_sym_AMP] = ACTIONS(426),
    [anon_sym_CARET] = ACTIONS(428),
    [anon_sym_PIPE] = ACTIONS(426),
    [anon_sym_PLUS] = ACTIONS(424),
    [anon_sym_DASH] = ACTIONS(424),
    [anon_sym_PERCENT] = ACTIONS(428),
    [anon_sym_STAR_STAR] = ACTIONS(428),
    [anon_sym_LT_EQ] = ACTIONS(428),
    [anon_sym_EQ_EQ] = ACTIONS(426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(428),
    [anon_sym_BANG_EQ] = ACTIONS(426),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(428),
    [anon_sym_GT_EQ] = ACTIONS(428),
    [anon_sym_QMARK_QMARK] = ACTIONS(428),
    [anon_sym_instanceof] = ACTIONS(426),
    [anon_sym_BANG] = ACTIONS(424),
    [anon_sym_TILDE] = ACTIONS(422),
    [anon_sym_typeof] = ACTIONS(424),
    [anon_sym_void] = ACTIONS(424),
    [anon_sym_delete] = ACTIONS(424),
    [anon_sym_PLUS_PLUS] = ACTIONS(422),
    [anon_sym_DASH_DASH] = ACTIONS(422),
    [anon_sym_DQUOTE] = ACTIONS(422),
    [anon_sym_SQUOTE] = ACTIONS(422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(422),
    [sym_number] = ACTIONS(422),
    [sym_this] = ACTIONS(424),
    [sym_super] = ACTIONS(424),
    [sym_true] = ACTIONS(424),
    [sym_false] = ACTIONS(424),
    [sym_null] = ACTIONS(424),
    [sym_undefined] = ACTIONS(424),
    [anon_sym_AT] = ACTIONS(422),
    [anon_sym_static] = ACTIONS(424),
    [anon_sym_get] = ACTIONS(424),
    [anon_sym_set] = ACTIONS(424),
    [sym__automatic_semicolon] = ACTIONS(430),
  },
  [49] = {
    [ts_builtin_sym_end] = ACTIONS(432),
    [sym_identifier] = ACTIONS(434),
    [anon_sym_export] = ACTIONS(434),
    [anon_sym_STAR] = ACTIONS(436),
    [anon_sym_default] = ACTIONS(434),
    [anon_sym_LBRACE] = ACTIONS(432),
    [anon_sym_COMMA] = ACTIONS(438),
    [anon_sym_RBRACE] = ACTIONS(432),
    [anon_sym_import] = ACTIONS(434),
    [anon_sym_var] = ACTIONS(434),
    [anon_sym_let] = ACTIONS(434),
    [anon_sym_const] = ACTIONS(434),
    [anon_sym_if] = ACTIONS(434),
    [anon_sym_else] = ACTIONS(434),
    [anon_sym_switch] = ACTIONS(434),
    [anon_sym_for] = ACTIONS(434),
    [anon_sym_LPAREN] = ACTIONS(432),
    [anon_sym_await] = ACTIONS(434),
    [anon_sym_in] = ACTIONS(436),
    [anon_sym_while] = ACTIONS(434),
    [anon_sym_do] = ACTIONS(434),
    [anon_sym_try] = ACTIONS(434),
    [anon_sym_with] = ACTIONS(434),
    [anon_sym_break] = ACTIONS(434),
    [anon_sym_continue] = ACTIONS(434),
    [anon_sym_debugger] = ACTIONS(434),
    [anon_sym_return] = ACTIONS(434),
    [anon_sym_throw] = ACTIONS(434),
    [anon_sym_SEMI] = ACTIONS(432),
    [anon_sym_case] = ACTIONS(434),
    [anon_sym_yield] = ACTIONS(434),
    [anon_sym_LBRACK] = ACTIONS(432),
    [anon_sym_LT] = ACTIONS(434),
    [anon_sym_GT] = ACTIONS(436),
    [anon_sym_SLASH] = ACTIONS(434),
    [anon_sym_DOT] = ACTIONS(436),
    [anon_sym_class] = ACTIONS(434),
    [anon_sym_async] = ACTIONS(434),
    [anon_sym_function] = ACTIONS(434),
    [anon_sym_new] = ACTIONS(434),
    [anon_sym_QMARK] = ACTIONS(436),
    [anon_sym_AMP_AMP] = ACTIONS(438),
    [anon_sym_PIPE_PIPE] = ACTIONS(438),
    [anon_sym_GT_GT] = ACTIONS(436),
    [anon_sym_GT_GT_GT] = ACTIONS(438),
    [anon_sym_LT_LT] = ACTIONS(438),
    [anon_sym_AMP] = ACTIONS(436),
    [anon_sym_CARET] = ACTIONS(438),
    [anon_sym_PIPE] = ACTIONS(436),
    [anon_sym_PLUS] = ACTIONS(434),
    [anon_sym_DASH] = ACTIONS(434),
    [anon_sym_PERCENT] = ACTIONS(438),
    [anon_sym_STAR_STAR] = ACTIONS(438),
    [anon_sym_LT_EQ] = ACTIONS(438),
    [anon_sym_EQ_EQ] = ACTIONS(436),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(438),
    [anon_sym_BANG_EQ] = ACTIONS(436),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(438),
    [anon_sym_GT_EQ] = ACTIONS(438),
    [anon_sym_QMARK_QMARK] = ACTIONS(438),
    [anon_sym_instanceof] = ACTIONS(436),
    [anon_sym_BANG] = ACTIONS(434),
    [anon_sym_TILDE] = ACTIONS(432),
    [anon_sym_typeof] = ACTIONS(434),
    [anon_sym_void] = ACTIONS(434),
    [anon_sym_delete] = ACTIONS(434),
    [anon_sym_PLUS_PLUS] = ACTIONS(432),
    [anon_sym_DASH_DASH] = ACTIONS(432),
    [anon_sym_DQUOTE] = ACTIONS(432),
    [anon_sym_SQUOTE] = ACTIONS(432),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(432),
    [sym_number] = ACTIONS(432),
    [sym_this] = ACTIONS(434),
    [sym_super] = ACTIONS(434),
    [sym_true] = ACTIONS(434),
    [sym_false] = ACTIONS(434),
    [sym_null] = ACTIONS(434),
    [sym_undefined] = ACTIONS(434),
    [anon_sym_AT] = ACTIONS(432),
    [anon_sym_static] = ACTIONS(434),
    [anon_sym_get] = ACTIONS(434),
    [anon_sym_set] = ACTIONS(434),
    [sym__automatic_semicolon] = ACTIONS(440),
  },
  [50] = {
    [ts_builtin_sym_end] = ACTIONS(442),
    [sym_identifier] = ACTIONS(444),
    [anon_sym_export] = ACTIONS(444),
    [anon_sym_STAR] = ACTIONS(444),
    [anon_sym_default] = ACTIONS(444),
    [anon_sym_LBRACE] = ACTIONS(442),
    [anon_sym_COMMA] = ACTIONS(442),
    [anon_sym_RBRACE] = ACTIONS(442),
    [anon_sym_import] = ACTIONS(444),
    [anon_sym_var] = ACTIONS(444),
    [anon_sym_let] = ACTIONS(444),
    [anon_sym_const] = ACTIONS(444),
    [anon_sym_if] = ACTIONS(444),
    [anon_sym_else] = ACTIONS(444),
    [anon_sym_switch] = ACTIONS(444),
    [anon_sym_for] = ACTIONS(444),
    [anon_sym_LPAREN] = ACTIONS(442),
    [anon_sym_await] = ACTIONS(444),
    [anon_sym_in] = ACTIONS(444),
    [anon_sym_while] = ACTIONS(444),
    [anon_sym_do] = ACTIONS(444),
    [anon_sym_try] = ACTIONS(444),
    [anon_sym_with] = ACTIONS(444),
    [anon_sym_break] = ACTIONS(444),
    [anon_sym_continue] = ACTIONS(444),
    [anon_sym_debugger] = ACTIONS(444),
    [anon_sym_return] = ACTIONS(444),
    [anon_sym_throw] = ACTIONS(444),
    [anon_sym_SEMI] = ACTIONS(442),
    [anon_sym_case] = ACTIONS(444),
    [anon_sym_yield] = ACTIONS(444),
    [anon_sym_LBRACK] = ACTIONS(442),
    [anon_sym_LT] = ACTIONS(444),
    [anon_sym_GT] = ACTIONS(444),
    [anon_sym_SLASH] = ACTIONS(444),
    [anon_sym_DOT] = ACTIONS(444),
    [anon_sym_class] = ACTIONS(444),
    [anon_sym_async] = ACTIONS(444),
    [anon_sym_function] = ACTIONS(444),
    [anon_sym_new] = ACTIONS(444),
    [anon_sym_QMARK] = ACTIONS(444),
    [anon_sym_AMP_AMP] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_GT_GT] = ACTIONS(444),
    [anon_sym_GT_GT_GT] = ACTIONS(442),
    [anon_sym_LT_LT] = ACTIONS(442),
    [anon_sym_AMP] = ACTIONS(444),
    [anon_sym_CARET] = ACTIONS(442),
    [anon_sym_PIPE] = ACTIONS(444),
    [anon_sym_PLUS] = ACTIONS(444),
    [anon_sym_DASH] = ACTIONS(444),
    [anon_sym_PERCENT] = ACTIONS(442),
    [anon_sym_STAR_STAR] = ACTIONS(442),
    [anon_sym_LT_EQ] = ACTIONS(442),
    [anon_sym_EQ_EQ] = ACTIONS(444),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(442),
    [anon_sym_BANG_EQ] = ACTIONS(444),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(442),
    [anon_sym_GT_EQ] = ACTIONS(442),
    [anon_sym_QMARK_QMARK] = ACTIONS(442),
    [anon_sym_instanceof] = ACTIONS(444),
    [anon_sym_BANG] = ACTIONS(444),
    [anon_sym_TILDE] = ACTIONS(442),
    [anon_sym_typeof] = ACTIONS(444),
    [anon_sym_void] = ACTIONS(444),
    [anon_sym_delete] = ACTIONS(444),
    [anon_sym_PLUS_PLUS] = ACTIONS(442),
    [anon_sym_DASH_DASH] = ACTIONS(442),
    [anon_sym_DQUOTE] = ACTIONS(442),
    [anon_sym_SQUOTE] = ACTIONS(442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(442),
    [sym_number] = ACTIONS(442),
    [sym_this] = ACTIONS(444),
    [sym_super] = ACTIONS(444),
    [sym_true] = ACTIONS(444),
    [sym_false] = ACTIONS(444),
    [sym_null] = ACTIONS(444),
    [sym_undefined] = ACTIONS(444),
    [anon_sym_AT] = ACTIONS(442),
    [anon_sym_static] = ACTIONS(444),
    [anon_sym_get] = ACTIONS(444),
    [anon_sym_set] = ACTIONS(444),
    [sym__automatic_semicolon] = ACTIONS(442),
  },
  [51] = {
    [ts_builtin_sym_end] = ACTIONS(446),
    [sym_identifier] = ACTIONS(448),
    [anon_sym_export] = ACTIONS(448),
    [anon_sym_STAR] = ACTIONS(450),
    [anon_sym_default] = ACTIONS(448),
    [anon_sym_LBRACE] = ACTIONS(446),
    [anon_sym_COMMA] = ACTIONS(452),
    [anon_sym_RBRACE] = ACTIONS(446),
    [anon_sym_import] = ACTIONS(448),
    [anon_sym_var] = ACTIONS(448),
    [anon_sym_let] = ACTIONS(448),
    [anon_sym_const] = ACTIONS(448),
    [anon_sym_if] = ACTIONS(448),
    [anon_sym_else] = ACTIONS(448),
    [anon_sym_switch] = ACTIONS(448),
    [anon_sym_for] = ACTIONS(448),
    [anon_sym_LPAREN] = ACTIONS(446),
    [anon_sym_await] = ACTIONS(448),
    [anon_sym_in] = ACTIONS(450),
    [anon_sym_while] = ACTIONS(448),
    [anon_sym_do] = ACTIONS(448),
    [anon_sym_try] = ACTIONS(448),
    [anon_sym_with] = ACTIONS(448),
    [anon_sym_break] = ACTIONS(448),
    [anon_sym_continue] = ACTIONS(448),
    [anon_sym_debugger] = ACTIONS(448),
    [anon_sym_return] = ACTIONS(448),
    [anon_sym_throw] = ACTIONS(448),
    [anon_sym_SEMI] = ACTIONS(446),
    [anon_sym_case] = ACTIONS(448),
    [anon_sym_yield] = ACTIONS(448),
    [anon_sym_LBRACK] = ACTIONS(446),
    [anon_sym_LT] = ACTIONS(448),
    [anon_sym_GT] = ACTIONS(450),
    [anon_sym_SLASH] = ACTIONS(448),
    [anon_sym_DOT] = ACTIONS(450),
    [anon_sym_class] = ACTIONS(448),
    [anon_sym_async] = ACTIONS(448),
    [anon_sym_function] = ACTIONS(448),
    [anon_sym_new] = ACTIONS(448),
    [anon_sym_QMARK] = ACTIONS(450),
    [anon_sym_AMP_AMP] = ACTIONS(452),
    [anon_sym_PIPE_PIPE] = ACTIONS(452),
    [anon_sym_GT_GT] = ACTIONS(450),
    [anon_sym_GT_GT_GT] = ACTIONS(452),
    [anon_sym_LT_LT] = ACTIONS(452),
    [anon_sym_AMP] = ACTIONS(450),
    [anon_sym_CARET] = ACTIONS(452),
    [anon_sym_PIPE] = ACTIONS(450),
    [anon_sym_PLUS] = ACTIONS(448),
    [anon_sym_DASH] = ACTIONS(448),
    [anon_sym_PERCENT] = ACTIONS(452),
    [anon_sym_STAR_STAR] = ACTIONS(452),
    [anon_sym_LT_EQ] = ACTIONS(452),
    [anon_sym_EQ_EQ] = ACTIONS(450),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(452),
    [anon_sym_BANG_EQ] = ACTIONS(450),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(452),
    [anon_sym_GT_EQ] = ACTIONS(452),
    [anon_sym_QMARK_QMARK] = ACTIONS(452),
    [anon_sym_instanceof] = ACTIONS(450),
    [anon_sym_BANG] = ACTIONS(448),
    [anon_sym_TILDE] = ACTIONS(446),
    [anon_sym_typeof] = ACTIONS(448),
    [anon_sym_void] = ACTIONS(448),
    [anon_sym_delete] = ACTIONS(448),
    [anon_sym_PLUS_PLUS] = ACTIONS(446),
    [anon_sym_DASH_DASH] = ACTIONS(446),
    [anon_sym_DQUOTE] = ACTIONS(446),
    [anon_sym_SQUOTE] = ACTIONS(446),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(446),
    [sym_number] = ACTIONS(446),
    [sym_this] = ACTIONS(448),
    [sym_super] = ACTIONS(448),
    [sym_true] = ACTIONS(448),
    [sym_false] = ACTIONS(448),
    [sym_null] = ACTIONS(448),
    [sym_undefined] = ACTIONS(448),
    [anon_sym_AT] = ACTIONS(446),
    [anon_sym_static] = ACTIONS(448),
    [anon_sym_get] = ACTIONS(448),
    [anon_sym_set] = ACTIONS(448),
    [sym__automatic_semicolon] = ACTIONS(454),
  },
  [52] = {
    [ts_builtin_sym_end] = ACTIONS(456),
    [sym_identifier] = ACTIONS(458),
    [anon_sym_export] = ACTIONS(458),
    [anon_sym_STAR] = ACTIONS(458),
    [anon_sym_default] = ACTIONS(458),
    [anon_sym_LBRACE] = ACTIONS(456),
    [anon_sym_COMMA] = ACTIONS(456),
    [anon_sym_RBRACE] = ACTIONS(456),
    [anon_sym_import] = ACTIONS(458),
    [anon_sym_var] = ACTIONS(458),
    [anon_sym_let] = ACTIONS(458),
    [anon_sym_const] = ACTIONS(458),
    [anon_sym_if] = ACTIONS(458),
    [anon_sym_else] = ACTIONS(458),
    [anon_sym_switch] = ACTIONS(458),
    [anon_sym_for] = ACTIONS(458),
    [anon_sym_LPAREN] = ACTIONS(456),
    [anon_sym_await] = ACTIONS(458),
    [anon_sym_in] = ACTIONS(458),
    [anon_sym_while] = ACTIONS(458),
    [anon_sym_do] = ACTIONS(458),
    [anon_sym_try] = ACTIONS(458),
    [anon_sym_with] = ACTIONS(458),
    [anon_sym_break] = ACTIONS(458),
    [anon_sym_continue] = ACTIONS(458),
    [anon_sym_debugger] = ACTIONS(458),
    [anon_sym_return] = ACTIONS(458),
    [anon_sym_throw] = ACTIONS(458),
    [anon_sym_SEMI] = ACTIONS(456),
    [anon_sym_case] = ACTIONS(458),
    [anon_sym_yield] = ACTIONS(458),
    [anon_sym_LBRACK] = ACTIONS(456),
    [anon_sym_LT] = ACTIONS(458),
    [anon_sym_GT] = ACTIONS(458),
    [anon_sym_SLASH] = ACTIONS(458),
    [anon_sym_DOT] = ACTIONS(458),
    [anon_sym_class] = ACTIONS(458),
    [anon_sym_async] = ACTIONS(458),
    [anon_sym_function] = ACTIONS(458),
    [anon_sym_new] = ACTIONS(458),
    [anon_sym_QMARK] = ACTIONS(458),
    [anon_sym_AMP_AMP] = ACTIONS(456),
    [anon_sym_PIPE_PIPE] = ACTIONS(456),
    [anon_sym_GT_GT] = ACTIONS(458),
    [anon_sym_GT_GT_GT] = ACTIONS(456),
    [anon_sym_LT_LT] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(458),
    [anon_sym_CARET] = ACTIONS(456),
    [anon_sym_PIPE] = ACTIONS(458),
    [anon_sym_PLUS] = ACTIONS(458),
    [anon_sym_DASH] = ACTIONS(458),
    [anon_sym_PERCENT] = ACTIONS(456),
    [anon_sym_STAR_STAR] = ACTIONS(456),
    [anon_sym_LT_EQ] = ACTIONS(456),
    [anon_sym_EQ_EQ] = ACTIONS(458),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(456),
    [anon_sym_BANG_EQ] = ACTIONS(458),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(456),
    [anon_sym_GT_EQ] = ACTIONS(456),
    [anon_sym_QMARK_QMARK] = ACTIONS(456),
    [anon_sym_instanceof] = ACTIONS(458),
    [anon_sym_BANG] = ACTIONS(458),
    [anon_sym_TILDE] = ACTIONS(456),
    [anon_sym_typeof] = ACTIONS(458),
    [anon_sym_void] = ACTIONS(458),
    [anon_sym_delete] = ACTIONS(458),
    [anon_sym_PLUS_PLUS] = ACTIONS(456),
    [anon_sym_DASH_DASH] = ACTIONS(456),
    [anon_sym_DQUOTE] = ACTIONS(456),
    [anon_sym_SQUOTE] = ACTIONS(456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(456),
    [sym_number] = ACTIONS(456),
    [sym_this] = ACTIONS(458),
    [sym_super] = ACTIONS(458),
    [sym_true] = ACTIONS(458),
    [sym_false] = ACTIONS(458),
    [sym_null] = ACTIONS(458),
    [sym_undefined] = ACTIONS(458),
    [anon_sym_AT] = ACTIONS(456),
    [anon_sym_static] = ACTIONS(458),
    [anon_sym_get] = ACTIONS(458),
    [anon_sym_set] = ACTIONS(458),
    [sym__automatic_semicolon] = ACTIONS(456),
  },
  [53] = {
    [ts_builtin_sym_end] = ACTIONS(460),
    [sym_identifier] = ACTIONS(462),
    [anon_sym_export] = ACTIONS(462),
    [anon_sym_STAR] = ACTIONS(464),
    [anon_sym_default] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(460),
    [anon_sym_COMMA] = ACTIONS(466),
    [anon_sym_RBRACE] = ACTIONS(460),
    [anon_sym_import] = ACTIONS(462),
    [anon_sym_var] = ACTIONS(462),
    [anon_sym_let] = ACTIONS(462),
    [anon_sym_const] = ACTIONS(462),
    [anon_sym_if] = ACTIONS(462),
    [anon_sym_else] = ACTIONS(462),
    [anon_sym_switch] = ACTIONS(462),
    [anon_sym_for] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(460),
    [anon_sym_await] = ACTIONS(462),
    [anon_sym_in] = ACTIONS(464),
    [anon_sym_while] = ACTIONS(462),
    [anon_sym_do] = ACTIONS(462),
    [anon_sym_try] = ACTIONS(462),
    [anon_sym_with] = ACTIONS(462),
    [anon_sym_break] = ACTIONS(462),
    [anon_sym_continue] = ACTIONS(462),
    [anon_sym_debugger] = ACTIONS(462),
    [anon_sym_return] = ACTIONS(462),
    [anon_sym_throw] = ACTIONS(462),
    [anon_sym_SEMI] = ACTIONS(460),
    [anon_sym_case] = ACTIONS(462),
    [anon_sym_yield] = ACTIONS(462),
    [anon_sym_LBRACK] = ACTIONS(460),
    [anon_sym_LT] = ACTIONS(462),
    [anon_sym_GT] = ACTIONS(464),
    [anon_sym_SLASH] = ACTIONS(462),
    [anon_sym_DOT] = ACTIONS(464),
    [anon_sym_class] = ACTIONS(462),
    [anon_sym_async] = ACTIONS(462),
    [anon_sym_function] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(462),
    [anon_sym_QMARK] = ACTIONS(464),
    [anon_sym_AMP_AMP] = ACTIONS(466),
    [anon_sym_PIPE_PIPE] = ACTIONS(466),
    [anon_sym_GT_GT] = ACTIONS(464),
    [anon_sym_GT_GT_GT] = ACTIONS(466),
    [anon_sym_LT_LT] = ACTIONS(466),
    [anon_sym_AMP] = ACTIONS(464),
    [anon_sym_CARET] = ACTIONS(466),
    [anon_sym_PIPE] = ACTIONS(464),
    [anon_sym_PLUS] = ACTIONS(462),
    [anon_sym_DASH] = ACTIONS(462),
    [anon_sym_PERCENT] = ACTIONS(466),
    [anon_sym_STAR_STAR] = ACTIONS(466),
    [anon_sym_LT_EQ] = ACTIONS(466),
    [anon_sym_EQ_EQ] = ACTIONS(464),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(466),
    [anon_sym_BANG_EQ] = ACTIONS(464),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(466),
    [anon_sym_GT_EQ] = ACTIONS(466),
    [anon_sym_QMARK_QMARK] = ACTIONS(466),
    [anon_sym_instanceof] = ACTIONS(464),
    [anon_sym_BANG] = ACTIONS(462),
    [anon_sym_TILDE] = ACTIONS(460),
    [anon_sym_typeof] = ACTIONS(462),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_delete] = ACTIONS(462),
    [anon_sym_PLUS_PLUS] = ACTIONS(460),
    [anon_sym_DASH_DASH] = ACTIONS(460),
    [anon_sym_DQUOTE] = ACTIONS(460),
    [anon_sym_SQUOTE] = ACTIONS(460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(460),
    [sym_number] = ACTIONS(460),
    [sym_this] = ACTIONS(462),
    [sym_super] = ACTIONS(462),
    [sym_true] = ACTIONS(462),
    [sym_false] = ACTIONS(462),
    [sym_null] = ACTIONS(462),
    [sym_undefined] = ACTIONS(462),
    [anon_sym_AT] = ACTIONS(460),
    [anon_sym_static] = ACTIONS(462),
    [anon_sym_get] = ACTIONS(462),
    [anon_sym_set] = ACTIONS(462),
    [sym__automatic_semicolon] = ACTIONS(468),
  },
  [54] = {
    [ts_builtin_sym_end] = ACTIONS(470),
    [sym_identifier] = ACTIONS(472),
    [anon_sym_export] = ACTIONS(472),
    [anon_sym_STAR] = ACTIONS(474),
    [anon_sym_default] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(470),
    [anon_sym_COMMA] = ACTIONS(476),
    [anon_sym_RBRACE] = ACTIONS(470),
    [anon_sym_import] = ACTIONS(472),
    [anon_sym_var] = ACTIONS(472),
    [anon_sym_let] = ACTIONS(472),
    [anon_sym_const] = ACTIONS(472),
    [anon_sym_if] = ACTIONS(472),
    [anon_sym_else] = ACTIONS(472),
    [anon_sym_switch] = ACTIONS(472),
    [anon_sym_for] = ACTIONS(472),
    [anon_sym_LPAREN] = ACTIONS(470),
    [anon_sym_await] = ACTIONS(472),
    [anon_sym_in] = ACTIONS(474),
    [anon_sym_while] = ACTIONS(472),
    [anon_sym_do] = ACTIONS(472),
    [anon_sym_try] = ACTIONS(472),
    [anon_sym_with] = ACTIONS(472),
    [anon_sym_break] = ACTIONS(472),
    [anon_sym_continue] = ACTIONS(472),
    [anon_sym_debugger] = ACTIONS(472),
    [anon_sym_return] = ACTIONS(472),
    [anon_sym_throw] = ACTIONS(472),
    [anon_sym_SEMI] = ACTIONS(470),
    [anon_sym_case] = ACTIONS(472),
    [anon_sym_yield] = ACTIONS(472),
    [anon_sym_LBRACK] = ACTIONS(470),
    [anon_sym_LT] = ACTIONS(472),
    [anon_sym_GT] = ACTIONS(474),
    [anon_sym_SLASH] = ACTIONS(472),
    [anon_sym_DOT] = ACTIONS(474),
    [anon_sym_class] = ACTIONS(472),
    [anon_sym_async] = ACTIONS(472),
    [anon_sym_function] = ACTIONS(472),
    [anon_sym_new] = ACTIONS(472),
    [anon_sym_QMARK] = ACTIONS(474),
    [anon_sym_AMP_AMP] = ACTIONS(476),
    [anon_sym_PIPE_PIPE] = ACTIONS(476),
    [anon_sym_GT_GT] = ACTIONS(474),
    [anon_sym_GT_GT_GT] = ACTIONS(476),
    [anon_sym_LT_LT] = ACTIONS(476),
    [anon_sym_AMP] = ACTIONS(474),
    [anon_sym_CARET] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(474),
    [anon_sym_PLUS] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(472),
    [anon_sym_PERCENT] = ACTIONS(476),
    [anon_sym_STAR_STAR] = ACTIONS(476),
    [anon_sym_LT_EQ] = ACTIONS(476),
    [anon_sym_EQ_EQ] = ACTIONS(474),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(476),
    [anon_sym_BANG_EQ] = ACTIONS(474),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(476),
    [anon_sym_GT_EQ] = ACTIONS(476),
    [anon_sym_QMARK_QMARK] = ACTIONS(476),
    [anon_sym_instanceof] = ACTIONS(474),
    [anon_sym_BANG] = ACTIONS(472),
    [anon_sym_TILDE] = ACTIONS(470),
    [anon_sym_typeof] = ACTIONS(472),
    [anon_sym_void] = ACTIONS(472),
    [anon_sym_delete] = ACTIONS(472),
    [anon_sym_PLUS_PLUS] = ACTIONS(470),
    [anon_sym_DASH_DASH] = ACTIONS(470),
    [anon_sym_DQUOTE] = ACTIONS(470),
    [anon_sym_SQUOTE] = ACTIONS(470),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(470),
    [sym_number] = ACTIONS(470),
    [sym_this] = ACTIONS(472),
    [sym_super] = ACTIONS(472),
    [sym_true] = ACTIONS(472),
    [sym_false] = ACTIONS(472),
    [sym_null] = ACTIONS(472),
    [sym_undefined] = ACTIONS(472),
    [anon_sym_AT] = ACTIONS(470),
    [anon_sym_static] = ACTIONS(472),
    [anon_sym_get] = ACTIONS(472),
    [anon_sym_set] = ACTIONS(472),
    [sym__automatic_semicolon] = ACTIONS(478),
  },
  [55] = {
    [ts_builtin_sym_end] = ACTIONS(480),
    [sym_identifier] = ACTIONS(482),
    [anon_sym_export] = ACTIONS(482),
    [anon_sym_STAR] = ACTIONS(482),
    [anon_sym_default] = ACTIONS(482),
    [anon_sym_LBRACE] = ACTIONS(480),
    [anon_sym_COMMA] = ACTIONS(480),
    [anon_sym_RBRACE] = ACTIONS(480),
    [anon_sym_import] = ACTIONS(482),
    [anon_sym_var] = ACTIONS(482),
    [anon_sym_let] = ACTIONS(482),
    [anon_sym_const] = ACTIONS(482),
    [anon_sym_if] = ACTIONS(482),
    [anon_sym_else] = ACTIONS(482),
    [anon_sym_switch] = ACTIONS(482),
    [anon_sym_for] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_await] = ACTIONS(482),
    [anon_sym_in] = ACTIONS(482),
    [anon_sym_while] = ACTIONS(482),
    [anon_sym_do] = ACTIONS(482),
    [anon_sym_try] = ACTIONS(482),
    [anon_sym_with] = ACTIONS(482),
    [anon_sym_break] = ACTIONS(482),
    [anon_sym_continue] = ACTIONS(482),
    [anon_sym_debugger] = ACTIONS(482),
    [anon_sym_return] = ACTIONS(482),
    [anon_sym_throw] = ACTIONS(482),
    [anon_sym_SEMI] = ACTIONS(480),
    [anon_sym_case] = ACTIONS(482),
    [anon_sym_yield] = ACTIONS(482),
    [anon_sym_LBRACK] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_GT] = ACTIONS(482),
    [anon_sym_SLASH] = ACTIONS(482),
    [anon_sym_DOT] = ACTIONS(482),
    [anon_sym_class] = ACTIONS(482),
    [anon_sym_async] = ACTIONS(482),
    [anon_sym_function] = ACTIONS(482),
    [anon_sym_new] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(482),
    [anon_sym_AMP_AMP] = ACTIONS(480),
    [anon_sym_PIPE_PIPE] = ACTIONS(480),
    [anon_sym_GT_GT] = ACTIONS(482),
    [anon_sym_GT_GT_GT] = ACTIONS(480),
    [anon_sym_LT_LT] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(482),
    [anon_sym_CARET] = ACTIONS(480),
    [anon_sym_PIPE] = ACTIONS(482),
    [anon_sym_PLUS] = ACTIONS(482),
    [anon_sym_DASH] = ACTIONS(482),
    [anon_sym_PERCENT] = ACTIONS(480),
    [anon_sym_STAR_STAR] = ACTIONS(480),
    [anon_sym_LT_EQ] = ACTIONS(480),
    [anon_sym_EQ_EQ] = ACTIONS(482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(480),
    [anon_sym_BANG_EQ] = ACTIONS(482),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(480),
    [anon_sym_GT_EQ] = ACTIONS(480),
    [anon_sym_QMARK_QMARK] = ACTIONS(480),
    [anon_sym_instanceof] = ACTIONS(482),
    [anon_sym_BANG] = ACTIONS(482),
    [anon_sym_TILDE] = ACTIONS(480),
    [anon_sym_typeof] = ACTIONS(482),
    [anon_sym_void] = ACTIONS(482),
    [anon_sym_delete] = ACTIONS(482),
    [anon_sym_PLUS_PLUS] = ACTIONS(480),
    [anon_sym_DASH_DASH] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [anon_sym_SQUOTE] = ACTIONS(480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(480),
    [sym_number] = ACTIONS(480),
    [sym_this] = ACTIONS(482),
    [sym_super] = ACTIONS(482),
    [sym_true] = ACTIONS(482),
    [sym_false] = ACTIONS(482),
    [sym_null] = ACTIONS(482),
    [sym_undefined] = ACTIONS(482),
    [anon_sym_AT] = ACTIONS(480),
    [anon_sym_static] = ACTIONS(482),
    [anon_sym_get] = ACTIONS(482),
    [anon_sym_set] = ACTIONS(482),
    [sym__automatic_semicolon] = ACTIONS(480),
  },
  [56] = {
    [ts_builtin_sym_end] = ACTIONS(484),
    [sym_identifier] = ACTIONS(486),
    [anon_sym_export] = ACTIONS(486),
    [anon_sym_STAR] = ACTIONS(488),
    [anon_sym_default] = ACTIONS(486),
    [anon_sym_LBRACE] = ACTIONS(484),
    [anon_sym_COMMA] = ACTIONS(490),
    [anon_sym_RBRACE] = ACTIONS(484),
    [anon_sym_import] = ACTIONS(486),
    [anon_sym_var] = ACTIONS(486),
    [anon_sym_let] = ACTIONS(486),
    [anon_sym_const] = ACTIONS(486),
    [anon_sym_if] = ACTIONS(486),
    [anon_sym_else] = ACTIONS(486),
    [anon_sym_switch] = ACTIONS(486),
    [anon_sym_for] = ACTIONS(486),
    [anon_sym_LPAREN] = ACTIONS(484),
    [anon_sym_await] = ACTIONS(486),
    [anon_sym_in] = ACTIONS(488),
    [anon_sym_while] = ACTIONS(486),
    [anon_sym_do] = ACTIONS(486),
    [anon_sym_try] = ACTIONS(486),
    [anon_sym_with] = ACTIONS(486),
    [anon_sym_break] = ACTIONS(486),
    [anon_sym_continue] = ACTIONS(486),
    [anon_sym_debugger] = ACTIONS(486),
    [anon_sym_return] = ACTIONS(486),
    [anon_sym_throw] = ACTIONS(486),
    [anon_sym_SEMI] = ACTIONS(484),
    [anon_sym_case] = ACTIONS(486),
    [anon_sym_yield] = ACTIONS(486),
    [anon_sym_LBRACK] = ACTIONS(484),
    [anon_sym_LT] = ACTIONS(486),
    [anon_sym_GT] = ACTIONS(488),
    [anon_sym_SLASH] = ACTIONS(486),
    [anon_sym_DOT] = ACTIONS(488),
    [anon_sym_class] = ACTIONS(486),
    [anon_sym_async] = ACTIONS(486),
    [anon_sym_function] = ACTIONS(486),
    [anon_sym_new] = ACTIONS(486),
    [anon_sym_QMARK] = ACTIONS(488),
    [anon_sym_AMP_AMP] = ACTIONS(490),
    [anon_sym_PIPE_PIPE] = ACTIONS(490),
    [anon_sym_GT_GT] = ACTIONS(488),
    [anon_sym_GT_GT_GT] = ACTIONS(490),
    [anon_sym_LT_LT] = ACTIONS(490),
    [anon_sym_AMP] = ACTIONS(488),
    [anon_sym_CARET] = ACTIONS(490),
    [anon_sym_PIPE] = ACTIONS(488),
    [anon_sym_PLUS] = ACTIONS(486),
    [anon_sym_DASH] = ACTIONS(486),
    [anon_sym_PERCENT] = ACTIONS(490),
    [anon_sym_STAR_STAR] = ACTIONS(490),
    [anon_sym_LT_EQ] = ACTIONS(490),
    [anon_sym_EQ_EQ] = ACTIONS(488),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(490),
    [anon_sym_BANG_EQ] = ACTIONS(488),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(490),
    [anon_sym_GT_EQ] = ACTIONS(490),
    [anon_sym_QMARK_QMARK] = ACTIONS(490),
    [anon_sym_instanceof] = ACTIONS(488),
    [anon_sym_BANG] = ACTIONS(486),
    [anon_sym_TILDE] = ACTIONS(484),
    [anon_sym_typeof] = ACTIONS(486),
    [anon_sym_void] = ACTIONS(486),
    [anon_sym_delete] = ACTIONS(486),
    [anon_sym_PLUS_PLUS] = ACTIONS(484),
    [anon_sym_DASH_DASH] = ACTIONS(484),
    [anon_sym_DQUOTE] = ACTIONS(484),
    [anon_sym_SQUOTE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(484),
    [sym_number] = ACTIONS(484),
    [sym_this] = ACTIONS(486),
    [sym_super] = ACTIONS(486),
    [sym_true] = ACTIONS(486),
    [sym_false] = ACTIONS(486),
    [sym_null] = ACTIONS(486),
    [sym_undefined] = ACTIONS(486),
    [anon_sym_AT] = ACTIONS(484),
    [anon_sym_static] = ACTIONS(486),
    [anon_sym_get] = ACTIONS(486),
    [anon_sym_set] = ACTIONS(486),
    [sym__automatic_semicolon] = ACTIONS(492),
  },
  [57] = {
    [ts_builtin_sym_end] = ACTIONS(494),
    [sym_identifier] = ACTIONS(496),
    [anon_sym_export] = ACTIONS(496),
    [anon_sym_STAR] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(496),
    [anon_sym_LBRACE] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_RBRACE] = ACTIONS(494),
    [anon_sym_import] = ACTIONS(496),
    [anon_sym_var] = ACTIONS(496),
    [anon_sym_let] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(496),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_else] = ACTIONS(496),
    [anon_sym_switch] = ACTIONS(496),
    [anon_sym_for] = ACTIONS(496),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_await] = ACTIONS(496),
    [anon_sym_in] = ACTIONS(496),
    [anon_sym_while] = ACTIONS(496),
    [anon_sym_do] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(496),
    [anon_sym_with] = ACTIONS(496),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_debugger] = ACTIONS(496),
    [anon_sym_return] = ACTIONS(496),
    [anon_sym_throw] = ACTIONS(496),
    [anon_sym_SEMI] = ACTIONS(494),
    [anon_sym_case] = ACTIONS(496),
    [anon_sym_yield] = ACTIONS(496),
    [anon_sym_LBRACK] = ACTIONS(494),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_SLASH] = ACTIONS(496),
    [anon_sym_DOT] = ACTIONS(496),
    [anon_sym_class] = ACTIONS(496),
    [anon_sym_async] = ACTIONS(496),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(496),
    [anon_sym_QMARK] = ACTIONS(496),
    [anon_sym_AMP_AMP] = ACTIONS(494),
    [anon_sym_PIPE_PIPE] = ACTIONS(494),
    [anon_sym_GT_GT] = ACTIONS(496),
    [anon_sym_GT_GT_GT] = ACTIONS(494),
    [anon_sym_LT_LT] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(496),
    [anon_sym_CARET] = ACTIONS(494),
    [anon_sym_PIPE] = ACTIONS(496),
    [anon_sym_PLUS] = ACTIONS(496),
    [anon_sym_DASH] = ACTIONS(496),
    [anon_sym_PERCENT] = ACTIONS(494),
    [anon_sym_STAR_STAR] = ACTIONS(494),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(496),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(496),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_QMARK_QMARK] = ACTIONS(494),
    [anon_sym_instanceof] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_TILDE] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(496),
    [anon_sym_void] = ACTIONS(496),
    [anon_sym_delete] = ACTIONS(496),
    [anon_sym_PLUS_PLUS] = ACTIONS(494),
    [anon_sym_DASH_DASH] = ACTIONS(494),
    [anon_sym_DQUOTE] = ACTIONS(494),
    [anon_sym_SQUOTE] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(494),
    [sym_number] = ACTIONS(494),
    [sym_this] = ACTIONS(496),
    [sym_super] = ACTIONS(496),
    [sym_true] = ACTIONS(496),
    [sym_false] = ACTIONS(496),
    [sym_null] = ACTIONS(496),
    [sym_undefined] = ACTIONS(496),
    [anon_sym_AT] = ACTIONS(494),
    [anon_sym_static] = ACTIONS(496),
    [anon_sym_get] = ACTIONS(496),
    [anon_sym_set] = ACTIONS(496),
    [sym__automatic_semicolon] = ACTIONS(494),
  },
  [58] = {
    [ts_builtin_sym_end] = ACTIONS(494),
    [sym_identifier] = ACTIONS(496),
    [anon_sym_export] = ACTIONS(496),
    [anon_sym_STAR] = ACTIONS(496),
    [anon_sym_default] = ACTIONS(496),
    [anon_sym_LBRACE] = ACTIONS(494),
    [anon_sym_COMMA] = ACTIONS(494),
    [anon_sym_RBRACE] = ACTIONS(494),
    [anon_sym_import] = ACTIONS(496),
    [anon_sym_var] = ACTIONS(496),
    [anon_sym_let] = ACTIONS(496),
    [anon_sym_const] = ACTIONS(496),
    [anon_sym_if] = ACTIONS(496),
    [anon_sym_else] = ACTIONS(496),
    [anon_sym_switch] = ACTIONS(496),
    [anon_sym_for] = ACTIONS(496),
    [anon_sym_LPAREN] = ACTIONS(494),
    [anon_sym_await] = ACTIONS(496),
    [anon_sym_in] = ACTIONS(496),
    [anon_sym_while] = ACTIONS(496),
    [anon_sym_do] = ACTIONS(496),
    [anon_sym_try] = ACTIONS(496),
    [anon_sym_with] = ACTIONS(496),
    [anon_sym_break] = ACTIONS(496),
    [anon_sym_continue] = ACTIONS(496),
    [anon_sym_debugger] = ACTIONS(496),
    [anon_sym_return] = ACTIONS(496),
    [anon_sym_throw] = ACTIONS(496),
    [anon_sym_SEMI] = ACTIONS(494),
    [anon_sym_case] = ACTIONS(496),
    [anon_sym_yield] = ACTIONS(496),
    [anon_sym_LBRACK] = ACTIONS(494),
    [anon_sym_LT] = ACTIONS(496),
    [anon_sym_GT] = ACTIONS(496),
    [anon_sym_SLASH] = ACTIONS(496),
    [anon_sym_DOT] = ACTIONS(496),
    [anon_sym_class] = ACTIONS(496),
    [anon_sym_async] = ACTIONS(496),
    [anon_sym_function] = ACTIONS(496),
    [anon_sym_new] = ACTIONS(496),
    [anon_sym_QMARK] = ACTIONS(496),
    [anon_sym_AMP_AMP] = ACTIONS(494),
    [anon_sym_PIPE_PIPE] = ACTIONS(494),
    [anon_sym_GT_GT] = ACTIONS(496),
    [anon_sym_GT_GT_GT] = ACTIONS(494),
    [anon_sym_LT_LT] = ACTIONS(494),
    [anon_sym_AMP] = ACTIONS(496),
    [anon_sym_CARET] = ACTIONS(494),
    [anon_sym_PIPE] = ACTIONS(496),
    [anon_sym_PLUS] = ACTIONS(496),
    [anon_sym_DASH] = ACTIONS(496),
    [anon_sym_PERCENT] = ACTIONS(494),
    [anon_sym_STAR_STAR] = ACTIONS(494),
    [anon_sym_LT_EQ] = ACTIONS(494),
    [anon_sym_EQ_EQ] = ACTIONS(496),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(494),
    [anon_sym_BANG_EQ] = ACTIONS(496),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(494),
    [anon_sym_GT_EQ] = ACTIONS(494),
    [anon_sym_QMARK_QMARK] = ACTIONS(494),
    [anon_sym_instanceof] = ACTIONS(496),
    [anon_sym_BANG] = ACTIONS(496),
    [anon_sym_TILDE] = ACTIONS(494),
    [anon_sym_typeof] = ACTIONS(496),
    [anon_sym_void] = ACTIONS(496),
    [anon_sym_delete] = ACTIONS(496),
    [anon_sym_PLUS_PLUS] = ACTIONS(494),
    [anon_sym_DASH_DASH] = ACTIONS(494),
    [anon_sym_DQUOTE] = ACTIONS(494),
    [anon_sym_SQUOTE] = ACTIONS(494),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(494),
    [sym_number] = ACTIONS(494),
    [sym_this] = ACTIONS(496),
    [sym_super] = ACTIONS(496),
    [sym_true] = ACTIONS(496),
    [sym_false] = ACTIONS(496),
    [sym_null] = ACTIONS(496),
    [sym_undefined] = ACTIONS(496),
    [anon_sym_AT] = ACTIONS(494),
    [anon_sym_static] = ACTIONS(496),
    [anon_sym_get] = ACTIONS(496),
    [anon_sym_set] = ACTIONS(496),
    [sym__automatic_semicolon] = ACTIONS(498),
  },
  [59] = {
    [ts_builtin_sym_end] = ACTIONS(392),
    [sym_identifier] = ACTIONS(394),
    [anon_sym_export] = ACTIONS(394),
    [anon_sym_STAR] = ACTIONS(394),
    [anon_sym_default] = ACTIONS(394),
    [anon_sym_LBRACE] = ACTIONS(392),
    [anon_sym_COMMA] = ACTIONS(392),
    [anon_sym_RBRACE] = ACTIONS(392),
    [anon_sym_import] = ACTIONS(394),
    [anon_sym_var] = ACTIONS(394),
    [anon_sym_let] = ACTIONS(394),
    [anon_sym_const] = ACTIONS(394),
    [anon_sym_if] = ACTIONS(394),
    [anon_sym_else] = ACTIONS(394),
    [anon_sym_switch] = ACTIONS(394),
    [anon_sym_for] = ACTIONS(394),
    [anon_sym_LPAREN] = ACTIONS(392),
    [anon_sym_await] = ACTIONS(394),
    [anon_sym_in] = ACTIONS(394),
    [anon_sym_while] = ACTIONS(394),
    [anon_sym_do] = ACTIONS(394),
    [anon_sym_try] = ACTIONS(394),
    [anon_sym_with] = ACTIONS(394),
    [anon_sym_break] = ACTIONS(394),
    [anon_sym_continue] = ACTIONS(394),
    [anon_sym_debugger] = ACTIONS(394),
    [anon_sym_return] = ACTIONS(394),
    [anon_sym_throw] = ACTIONS(394),
    [anon_sym_SEMI] = ACTIONS(392),
    [anon_sym_case] = ACTIONS(394),
    [anon_sym_yield] = ACTIONS(394),
    [anon_sym_LBRACK] = ACTIONS(392),
    [anon_sym_LT] = ACTIONS(394),
    [anon_sym_GT] = ACTIONS(394),
    [anon_sym_SLASH] = ACTIONS(394),
    [anon_sym_DOT] = ACTIONS(394),
    [anon_sym_class] = ACTIONS(394),
    [anon_sym_async] = ACTIONS(394),
    [anon_sym_function] = ACTIONS(394),
    [anon_sym_new] = ACTIONS(394),
    [anon_sym_QMARK] = ACTIONS(394),
    [anon_sym_AMP_AMP] = ACTIONS(392),
    [anon_sym_PIPE_PIPE] = ACTIONS(392),
    [anon_sym_GT_GT] = ACTIONS(394),
    [anon_sym_GT_GT_GT] = ACTIONS(392),
    [anon_sym_LT_LT] = ACTIONS(392),
    [anon_sym_AMP] = ACTIONS(394),
    [anon_sym_CARET] = ACTIONS(392),
    [anon_sym_PIPE] = ACTIONS(394),
    [anon_sym_PLUS] = ACTIONS(394),
    [anon_sym_DASH] = ACTIONS(394),
    [anon_sym_PERCENT] = ACTIONS(392),
    [anon_sym_STAR_STAR] = ACTIONS(392),
    [anon_sym_LT_EQ] = ACTIONS(392),
    [anon_sym_EQ_EQ] = ACTIONS(394),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(392),
    [anon_sym_BANG_EQ] = ACTIONS(394),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(392),
    [anon_sym_GT_EQ] = ACTIONS(392),
    [anon_sym_QMARK_QMARK] = ACTIONS(392),
    [anon_sym_instanceof] = ACTIONS(394),
    [anon_sym_BANG] = ACTIONS(394),
    [anon_sym_TILDE] = ACTIONS(392),
    [anon_sym_typeof] = ACTIONS(394),
    [anon_sym_void] = ACTIONS(394),
    [anon_sym_delete] = ACTIONS(394),
    [anon_sym_PLUS_PLUS] = ACTIONS(392),
    [anon_sym_DASH_DASH] = ACTIONS(392),
    [anon_sym_DQUOTE] = ACTIONS(392),
    [anon_sym_SQUOTE] = ACTIONS(392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(392),
    [sym_number] = ACTIONS(392),
    [sym_this] = ACTIONS(394),
    [sym_super] = ACTIONS(394),
    [sym_true] = ACTIONS(394),
    [sym_false] = ACTIONS(394),
    [sym_null] = ACTIONS(394),
    [sym_undefined] = ACTIONS(394),
    [anon_sym_AT] = ACTIONS(392),
    [anon_sym_static] = ACTIONS(394),
    [anon_sym_get] = ACTIONS(394),
    [anon_sym_set] = ACTIONS(394),
    [sym__automatic_semicolon] = ACTIONS(500),
  },
  [60] = {
    [sym_import] = STATE(481),
    [sym_expression_statement] = STATE(72),
    [sym_variable_declaration] = STATE(72),
    [sym_lexical_declaration] = STATE(72),
    [sym_empty_statement] = STATE(72),
    [sym_parenthesized_expression] = STATE(303),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(490),
    [sym_array] = STATE(489),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(481),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(303),
    [sym_subscript_expression] = STATE(303),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(502),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_var] = ACTIONS(504),
    [anon_sym_let] = ACTIONS(506),
    [anon_sym_const] = ACTIONS(506),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(508),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
  },
  [61] = {
    [sym_import] = STATE(481),
    [sym_expression_statement] = STATE(73),
    [sym_variable_declaration] = STATE(73),
    [sym_lexical_declaration] = STATE(73),
    [sym_empty_statement] = STATE(73),
    [sym_parenthesized_expression] = STATE(303),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(490),
    [sym_array] = STATE(489),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(481),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(303),
    [sym_subscript_expression] = STATE(303),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(502),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_var] = ACTIONS(504),
    [anon_sym_let] = ACTIONS(506),
    [anon_sym_const] = ACTIONS(506),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(508),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(510),
    [anon_sym_get] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(510),
  },
  [62] = {
    [sym_import] = STATE(479),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(479),
    [sym_yield_expression] = STATE(479),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(479),
    [sym_jsx_fragment] = STATE(479),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(479),
    [sym_class] = STATE(479),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(479),
    [sym_arrow_function] = STATE(479),
    [sym_call_expression] = STATE(479),
    [sym_new_expression] = STATE(479),
    [sym_await_expression] = STATE(479),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(479),
    [sym_augmented_assignment_expression] = STATE(479),
    [sym_spread_element] = STATE(831),
    [sym_ternary_expression] = STATE(479),
    [sym_binary_expression] = STATE(479),
    [sym_unary_expression] = STATE(479),
    [sym_update_expression] = STATE(479),
    [sym_string] = STATE(479),
    [sym_template_string] = STATE(479),
    [sym_regex] = STATE(479),
    [sym_meta_property] = STATE(479),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [aux_sym_array_repeat1] = STATE(837),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_COMMA] = ACTIONS(512),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_RBRACK] = ACTIONS(514),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(518),
    [sym_this] = ACTIONS(520),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(520),
    [sym_false] = ACTIONS(520),
    [sym_null] = ACTIONS(520),
    [sym_undefined] = ACTIONS(520),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [63] = {
    [sym_import] = STATE(457),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(457),
    [sym_yield_expression] = STATE(457),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(457),
    [sym_jsx_fragment] = STATE(457),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(457),
    [sym_class] = STATE(457),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(457),
    [sym_arrow_function] = STATE(457),
    [sym_call_expression] = STATE(457),
    [sym_new_expression] = STATE(457),
    [sym_await_expression] = STATE(457),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(457),
    [sym_augmented_assignment_expression] = STATE(457),
    [sym_spread_element] = STATE(810),
    [sym_ternary_expression] = STATE(457),
    [sym_binary_expression] = STATE(457),
    [sym_unary_expression] = STATE(457),
    [sym_update_expression] = STATE(457),
    [sym_string] = STATE(457),
    [sym_template_string] = STATE(457),
    [sym_regex] = STATE(457),
    [sym_meta_property] = STATE(457),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [aux_sym_array_repeat1] = STATE(879),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_COMMA] = ACTIONS(512),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_RBRACK] = ACTIONS(522),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(524),
    [sym_this] = ACTIONS(526),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(526),
    [sym_false] = ACTIONS(526),
    [sym_null] = ACTIONS(526),
    [sym_undefined] = ACTIONS(526),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [64] = {
    [sym_import] = STATE(465),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(465),
    [sym_yield_expression] = STATE(465),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(465),
    [sym_jsx_fragment] = STATE(465),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(465),
    [sym_class] = STATE(465),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(465),
    [sym_arrow_function] = STATE(465),
    [sym_call_expression] = STATE(465),
    [sym_new_expression] = STATE(465),
    [sym_await_expression] = STATE(465),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(465),
    [sym_augmented_assignment_expression] = STATE(465),
    [sym_spread_element] = STATE(859),
    [sym_ternary_expression] = STATE(465),
    [sym_binary_expression] = STATE(465),
    [sym_unary_expression] = STATE(465),
    [sym_update_expression] = STATE(465),
    [sym_string] = STATE(465),
    [sym_template_string] = STATE(465),
    [sym_regex] = STATE(465),
    [sym_meta_property] = STATE(465),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_COMMA] = ACTIONS(528),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_RPAREN] = ACTIONS(528),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_RBRACK] = ACTIONS(528),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(530),
    [sym_this] = ACTIONS(532),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(532),
    [sym_false] = ACTIONS(532),
    [sym_null] = ACTIONS(532),
    [sym_undefined] = ACTIONS(532),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [65] = {
    [sym_import] = STATE(460),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(460),
    [sym_yield_expression] = STATE(460),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(460),
    [sym_jsx_fragment] = STATE(460),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(460),
    [sym_class] = STATE(460),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(460),
    [sym_arrow_function] = STATE(460),
    [sym_call_expression] = STATE(460),
    [sym_new_expression] = STATE(460),
    [sym_await_expression] = STATE(460),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(460),
    [sym_augmented_assignment_expression] = STATE(460),
    [sym_spread_element] = STATE(831),
    [sym_ternary_expression] = STATE(460),
    [sym_binary_expression] = STATE(460),
    [sym_unary_expression] = STATE(460),
    [sym_update_expression] = STATE(460),
    [sym_string] = STATE(460),
    [sym_template_string] = STATE(460),
    [sym_regex] = STATE(460),
    [sym_meta_property] = STATE(460),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [aux_sym_array_repeat1] = STATE(837),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_COMMA] = ACTIONS(512),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_RBRACK] = ACTIONS(514),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(534),
    [sym_this] = ACTIONS(536),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(536),
    [sym_false] = ACTIONS(536),
    [sym_null] = ACTIONS(536),
    [sym_undefined] = ACTIONS(536),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [66] = {
    [sym_import] = STATE(469),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(469),
    [sym_yield_expression] = STATE(469),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(469),
    [sym_jsx_fragment] = STATE(469),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(469),
    [sym_class] = STATE(469),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(469),
    [sym_arrow_function] = STATE(469),
    [sym_call_expression] = STATE(469),
    [sym_new_expression] = STATE(469),
    [sym_await_expression] = STATE(469),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(469),
    [sym_augmented_assignment_expression] = STATE(469),
    [sym_spread_element] = STATE(810),
    [sym_ternary_expression] = STATE(469),
    [sym_binary_expression] = STATE(469),
    [sym_unary_expression] = STATE(469),
    [sym_update_expression] = STATE(469),
    [sym_string] = STATE(469),
    [sym_template_string] = STATE(469),
    [sym_regex] = STATE(469),
    [sym_meta_property] = STATE(469),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [aux_sym_array_repeat1] = STATE(879),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_COMMA] = ACTIONS(512),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_RBRACK] = ACTIONS(522),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(538),
    [sym_this] = ACTIONS(540),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(540),
    [sym_false] = ACTIONS(540),
    [sym_null] = ACTIONS(540),
    [sym_undefined] = ACTIONS(540),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [67] = {
    [sym_import] = STATE(520),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(520),
    [sym_yield_expression] = STATE(520),
    [sym_object] = STATE(528),
    [sym_assignment_pattern] = STATE(829),
    [sym_array] = STATE(494),
    [sym_jsx_element] = STATE(520),
    [sym_jsx_fragment] = STATE(520),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(520),
    [sym_class] = STATE(520),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(520),
    [sym_arrow_function] = STATE(520),
    [sym_call_expression] = STATE(520),
    [sym_new_expression] = STATE(520),
    [sym_await_expression] = STATE(520),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(520),
    [sym_augmented_assignment_expression] = STATE(520),
    [sym_ternary_expression] = STATE(520),
    [sym_binary_expression] = STATE(520),
    [sym_unary_expression] = STATE(520),
    [sym_update_expression] = STATE(520),
    [sym_sequence_expression] = STATE(1059),
    [sym_string] = STATE(520),
    [sym_template_string] = STATE(520),
    [sym_regex] = STATE(520),
    [sym_meta_property] = STATE(520),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [sym_rest_parameter] = STATE(829),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_RPAREN] = ACTIONS(544),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(546),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(548),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(550),
    [sym_this] = ACTIONS(552),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(552),
    [sym_false] = ACTIONS(552),
    [sym_null] = ACTIONS(552),
    [sym_undefined] = ACTIONS(552),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(554),
    [anon_sym_get] = ACTIONS(554),
    [anon_sym_set] = ACTIONS(554),
  },
  [68] = {
    [sym_import] = STATE(477),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(477),
    [sym_yield_expression] = STATE(477),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(477),
    [sym_jsx_fragment] = STATE(477),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(477),
    [sym_class] = STATE(477),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(477),
    [sym_arrow_function] = STATE(477),
    [sym_call_expression] = STATE(477),
    [sym_new_expression] = STATE(477),
    [sym_await_expression] = STATE(477),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(477),
    [sym_augmented_assignment_expression] = STATE(477),
    [sym_spread_element] = STATE(863),
    [sym_ternary_expression] = STATE(477),
    [sym_binary_expression] = STATE(477),
    [sym_unary_expression] = STATE(477),
    [sym_update_expression] = STATE(477),
    [sym_string] = STATE(477),
    [sym_template_string] = STATE(477),
    [sym_regex] = STATE(477),
    [sym_meta_property] = STATE(477),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [aux_sym_array_repeat1] = STATE(862),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_COMMA] = ACTIONS(512),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_RPAREN] = ACTIONS(556),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(558),
    [sym_this] = ACTIONS(560),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(560),
    [sym_false] = ACTIONS(560),
    [sym_null] = ACTIONS(560),
    [sym_undefined] = ACTIONS(560),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [69] = {
    [sym_import] = STATE(478),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(478),
    [sym_yield_expression] = STATE(478),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(478),
    [sym_jsx_fragment] = STATE(478),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(478),
    [sym_class] = STATE(478),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(478),
    [sym_arrow_function] = STATE(478),
    [sym_call_expression] = STATE(478),
    [sym_new_expression] = STATE(478),
    [sym_await_expression] = STATE(478),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(478),
    [sym_augmented_assignment_expression] = STATE(478),
    [sym_spread_element] = STATE(860),
    [sym_ternary_expression] = STATE(478),
    [sym_binary_expression] = STATE(478),
    [sym_unary_expression] = STATE(478),
    [sym_update_expression] = STATE(478),
    [sym_string] = STATE(478),
    [sym_template_string] = STATE(478),
    [sym_regex] = STATE(478),
    [sym_meta_property] = STATE(478),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [aux_sym_array_repeat1] = STATE(861),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_COMMA] = ACTIONS(512),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_RPAREN] = ACTIONS(562),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(564),
    [sym_this] = ACTIONS(566),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(566),
    [sym_false] = ACTIONS(566),
    [sym_null] = ACTIONS(566),
    [sym_undefined] = ACTIONS(566),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [70] = {
    [sym_import] = STATE(496),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(496),
    [sym_yield_expression] = STATE(496),
    [sym_object] = STATE(528),
    [sym_assignment_pattern] = STATE(829),
    [sym_array] = STATE(494),
    [sym_jsx_element] = STATE(496),
    [sym_jsx_fragment] = STATE(496),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(496),
    [sym_class] = STATE(496),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(496),
    [sym_arrow_function] = STATE(496),
    [sym_call_expression] = STATE(496),
    [sym_new_expression] = STATE(496),
    [sym_await_expression] = STATE(496),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(496),
    [sym_augmented_assignment_expression] = STATE(496),
    [sym_ternary_expression] = STATE(496),
    [sym_binary_expression] = STATE(496),
    [sym_unary_expression] = STATE(496),
    [sym_update_expression] = STATE(496),
    [sym_sequence_expression] = STATE(1100),
    [sym_string] = STATE(496),
    [sym_template_string] = STATE(496),
    [sym_regex] = STATE(496),
    [sym_meta_property] = STATE(496),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [sym_rest_parameter] = STATE(829),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(542),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_RPAREN] = ACTIONS(544),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(546),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(548),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(568),
    [sym_this] = ACTIONS(570),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(570),
    [sym_false] = ACTIONS(570),
    [sym_null] = ACTIONS(570),
    [sym_undefined] = ACTIONS(570),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(554),
    [anon_sym_get] = ACTIONS(554),
    [anon_sym_set] = ACTIONS(554),
  },
  [71] = {
    [sym_import] = STATE(542),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(542),
    [sym_yield_expression] = STATE(542),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(542),
    [sym_jsx_fragment] = STATE(542),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(542),
    [sym_class] = STATE(542),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(542),
    [sym_arrow_function] = STATE(542),
    [sym_call_expression] = STATE(542),
    [sym_new_expression] = STATE(542),
    [sym_await_expression] = STATE(542),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(542),
    [sym_augmented_assignment_expression] = STATE(542),
    [sym_spread_element] = STATE(1112),
    [sym_ternary_expression] = STATE(542),
    [sym_binary_expression] = STATE(542),
    [sym_unary_expression] = STATE(542),
    [sym_update_expression] = STATE(542),
    [sym_sequence_expression] = STATE(1112),
    [sym_string] = STATE(542),
    [sym_template_string] = STATE(542),
    [sym_regex] = STATE(542),
    [sym_meta_property] = STATE(542),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_RBRACE] = ACTIONS(572),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(574),
    [sym_this] = ACTIONS(576),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(576),
    [sym_false] = ACTIONS(576),
    [sym_null] = ACTIONS(576),
    [sym_undefined] = ACTIONS(576),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [72] = {
    [sym_import] = STATE(481),
    [sym_expression_statement] = STATE(77),
    [sym_empty_statement] = STATE(77),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(481),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [73] = {
    [sym_import] = STATE(481),
    [sym_expression_statement] = STATE(78),
    [sym_empty_statement] = STATE(78),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(481),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [74] = {
    [sym_import] = STATE(560),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(560),
    [sym_yield_expression] = STATE(560),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(560),
    [sym_jsx_fragment] = STATE(560),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(560),
    [sym_class] = STATE(560),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(560),
    [sym_arrow_function] = STATE(560),
    [sym_call_expression] = STATE(560),
    [sym_new_expression] = STATE(560),
    [sym_await_expression] = STATE(560),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(560),
    [sym_augmented_assignment_expression] = STATE(560),
    [sym_spread_element] = STATE(1081),
    [sym_ternary_expression] = STATE(560),
    [sym_binary_expression] = STATE(560),
    [sym_unary_expression] = STATE(560),
    [sym_update_expression] = STATE(560),
    [sym_sequence_expression] = STATE(1081),
    [sym_string] = STATE(560),
    [sym_template_string] = STATE(560),
    [sym_regex] = STATE(560),
    [sym_meta_property] = STATE(560),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_RBRACE] = ACTIONS(578),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(580),
    [sym_this] = ACTIONS(582),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(582),
    [sym_false] = ACTIONS(582),
    [sym_null] = ACTIONS(582),
    [sym_undefined] = ACTIONS(582),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [75] = {
    [sym_import] = STATE(574),
    [sym_parenthesized_expression] = STATE(310),
    [sym__expression] = STATE(574),
    [sym_yield_expression] = STATE(574),
    [sym_object] = STATE(571),
    [sym_array] = STATE(575),
    [sym_jsx_element] = STATE(574),
    [sym_jsx_fragment] = STATE(574),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(574),
    [sym_class] = STATE(574),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(574),
    [sym_arrow_function] = STATE(574),
    [sym_call_expression] = STATE(574),
    [sym_new_expression] = STATE(574),
    [sym_await_expression] = STATE(574),
    [sym_member_expression] = STATE(310),
    [sym_subscript_expression] = STATE(310),
    [sym_assignment_expression] = STATE(574),
    [sym_augmented_assignment_expression] = STATE(574),
    [sym_ternary_expression] = STATE(574),
    [sym_binary_expression] = STATE(574),
    [sym_unary_expression] = STATE(574),
    [sym_update_expression] = STATE(574),
    [sym_string] = STATE(574),
    [sym_template_string] = STATE(574),
    [sym_regex] = STATE(574),
    [sym_meta_property] = STATE(574),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(584),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_var] = ACTIONS(586),
    [anon_sym_let] = ACTIONS(586),
    [anon_sym_const] = ACTIONS(586),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(588),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(590),
    [sym_this] = ACTIONS(592),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(592),
    [sym_false] = ACTIONS(592),
    [sym_null] = ACTIONS(592),
    [sym_undefined] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(594),
    [anon_sym_get] = ACTIONS(594),
    [anon_sym_set] = ACTIONS(594),
  },
  [76] = {
    [sym_import] = STATE(488),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(488),
    [sym_yield_expression] = STATE(488),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(488),
    [sym_jsx_fragment] = STATE(488),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(488),
    [sym_class] = STATE(488),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(488),
    [sym_arrow_function] = STATE(488),
    [sym_call_expression] = STATE(488),
    [sym_new_expression] = STATE(488),
    [sym_await_expression] = STATE(488),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(488),
    [sym_augmented_assignment_expression] = STATE(488),
    [sym_ternary_expression] = STATE(488),
    [sym_binary_expression] = STATE(488),
    [sym_unary_expression] = STATE(488),
    [sym_update_expression] = STATE(488),
    [sym_sequence_expression] = STATE(908),
    [sym_string] = STATE(488),
    [sym_template_string] = STATE(488),
    [sym_regex] = STATE(488),
    [sym_meta_property] = STATE(488),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(596),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(598),
    [sym_this] = ACTIONS(600),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(600),
    [sym_false] = ACTIONS(600),
    [sym_null] = ACTIONS(600),
    [sym_undefined] = ACTIONS(600),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
    [sym__automatic_semicolon] = ACTIONS(596),
  },
  [77] = {
    [sym_import] = STATE(504),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(504),
    [sym_yield_expression] = STATE(504),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(504),
    [sym_jsx_fragment] = STATE(504),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(504),
    [sym_class] = STATE(504),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(504),
    [sym_arrow_function] = STATE(504),
    [sym_call_expression] = STATE(504),
    [sym_new_expression] = STATE(504),
    [sym_await_expression] = STATE(504),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(504),
    [sym_augmented_assignment_expression] = STATE(504),
    [sym_ternary_expression] = STATE(504),
    [sym_binary_expression] = STATE(504),
    [sym_unary_expression] = STATE(504),
    [sym_update_expression] = STATE(504),
    [sym_sequence_expression] = STATE(1105),
    [sym_string] = STATE(504),
    [sym_template_string] = STATE(504),
    [sym_regex] = STATE(504),
    [sym_meta_property] = STATE(504),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_RPAREN] = ACTIONS(602),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(604),
    [sym_this] = ACTIONS(606),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(606),
    [sym_false] = ACTIONS(606),
    [sym_null] = ACTIONS(606),
    [sym_undefined] = ACTIONS(606),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [78] = {
    [sym_import] = STATE(503),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(503),
    [sym_yield_expression] = STATE(503),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(503),
    [sym_jsx_fragment] = STATE(503),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(503),
    [sym_class] = STATE(503),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(503),
    [sym_arrow_function] = STATE(503),
    [sym_call_expression] = STATE(503),
    [sym_new_expression] = STATE(503),
    [sym_await_expression] = STATE(503),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(503),
    [sym_augmented_assignment_expression] = STATE(503),
    [sym_ternary_expression] = STATE(503),
    [sym_binary_expression] = STATE(503),
    [sym_unary_expression] = STATE(503),
    [sym_update_expression] = STATE(503),
    [sym_sequence_expression] = STATE(1091),
    [sym_string] = STATE(503),
    [sym_template_string] = STATE(503),
    [sym_regex] = STATE(503),
    [sym_meta_property] = STATE(503),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_RPAREN] = ACTIONS(608),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(610),
    [sym_this] = ACTIONS(612),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(612),
    [sym_false] = ACTIONS(612),
    [sym_null] = ACTIONS(612),
    [sym_undefined] = ACTIONS(612),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [79] = {
    [sym_import] = STATE(472),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(472),
    [sym_yield_expression] = STATE(472),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(472),
    [sym_jsx_fragment] = STATE(472),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(472),
    [sym_class] = STATE(472),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(472),
    [sym_arrow_function] = STATE(472),
    [sym_call_expression] = STATE(472),
    [sym_new_expression] = STATE(472),
    [sym_await_expression] = STATE(472),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(472),
    [sym_augmented_assignment_expression] = STATE(472),
    [sym_ternary_expression] = STATE(472),
    [sym_binary_expression] = STATE(472),
    [sym_unary_expression] = STATE(472),
    [sym_update_expression] = STATE(472),
    [sym_sequence_expression] = STATE(940),
    [sym_string] = STATE(472),
    [sym_template_string] = STATE(472),
    [sym_regex] = STATE(472),
    [sym_meta_property] = STATE(472),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(614),
    [sym_this] = ACTIONS(616),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(616),
    [sym_false] = ACTIONS(616),
    [sym_null] = ACTIONS(616),
    [sym_undefined] = ACTIONS(616),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [80] = {
    [sym_import] = STATE(404),
    [sym_statement_block] = STATE(546),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(404),
    [sym_yield_expression] = STATE(404),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(404),
    [sym_jsx_fragment] = STATE(404),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(404),
    [sym_class] = STATE(404),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(404),
    [sym_arrow_function] = STATE(404),
    [sym_call_expression] = STATE(404),
    [sym_new_expression] = STATE(404),
    [sym_await_expression] = STATE(404),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(404),
    [sym_augmented_assignment_expression] = STATE(404),
    [sym_ternary_expression] = STATE(404),
    [sym_binary_expression] = STATE(404),
    [sym_unary_expression] = STATE(404),
    [sym_update_expression] = STATE(404),
    [sym_string] = STATE(404),
    [sym_template_string] = STATE(404),
    [sym_regex] = STATE(404),
    [sym_meta_property] = STATE(404),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(620),
    [sym_this] = ACTIONS(622),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(622),
    [sym_false] = ACTIONS(622),
    [sym_null] = ACTIONS(622),
    [sym_undefined] = ACTIONS(622),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [81] = {
    [sym_import] = STATE(524),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(524),
    [sym_yield_expression] = STATE(524),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(524),
    [sym_jsx_fragment] = STATE(524),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(524),
    [sym_class] = STATE(524),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(524),
    [sym_arrow_function] = STATE(524),
    [sym_call_expression] = STATE(524),
    [sym_new_expression] = STATE(524),
    [sym_await_expression] = STATE(524),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(524),
    [sym_augmented_assignment_expression] = STATE(524),
    [sym_ternary_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_sequence_expression] = STATE(1122),
    [sym_string] = STATE(524),
    [sym_template_string] = STATE(524),
    [sym_regex] = STATE(524),
    [sym_meta_property] = STATE(524),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(624),
    [sym_this] = ACTIONS(626),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(626),
    [sym_false] = ACTIONS(626),
    [sym_null] = ACTIONS(626),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [82] = {
    [sym_import] = STATE(509),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(509),
    [sym_yield_expression] = STATE(509),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(509),
    [sym_jsx_fragment] = STATE(509),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(509),
    [sym_class] = STATE(509),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(509),
    [sym_arrow_function] = STATE(509),
    [sym_call_expression] = STATE(509),
    [sym_new_expression] = STATE(509),
    [sym_await_expression] = STATE(509),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(509),
    [sym_augmented_assignment_expression] = STATE(509),
    [sym_ternary_expression] = STATE(509),
    [sym_binary_expression] = STATE(509),
    [sym_unary_expression] = STATE(509),
    [sym_update_expression] = STATE(509),
    [sym_sequence_expression] = STATE(1103),
    [sym_string] = STATE(509),
    [sym_template_string] = STATE(509),
    [sym_regex] = STATE(509),
    [sym_meta_property] = STATE(509),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(628),
    [sym_this] = ACTIONS(630),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(630),
    [sym_false] = ACTIONS(630),
    [sym_null] = ACTIONS(630),
    [sym_undefined] = ACTIONS(630),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [83] = {
    [sym_import] = STATE(419),
    [sym_statement_block] = STATE(538),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(419),
    [sym_yield_expression] = STATE(419),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(419),
    [sym_jsx_fragment] = STATE(419),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(419),
    [sym_class] = STATE(419),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(419),
    [sym_arrow_function] = STATE(419),
    [sym_call_expression] = STATE(419),
    [sym_new_expression] = STATE(419),
    [sym_await_expression] = STATE(419),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(419),
    [sym_augmented_assignment_expression] = STATE(419),
    [sym_ternary_expression] = STATE(419),
    [sym_binary_expression] = STATE(419),
    [sym_unary_expression] = STATE(419),
    [sym_update_expression] = STATE(419),
    [sym_string] = STATE(419),
    [sym_template_string] = STATE(419),
    [sym_regex] = STATE(419),
    [sym_meta_property] = STATE(419),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(632),
    [sym_this] = ACTIONS(634),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(634),
    [sym_false] = ACTIONS(634),
    [sym_null] = ACTIONS(634),
    [sym_undefined] = ACTIONS(634),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [84] = {
    [sym_import] = STATE(502),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(502),
    [sym_yield_expression] = STATE(502),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(502),
    [sym_jsx_fragment] = STATE(502),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(502),
    [sym_class] = STATE(502),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(502),
    [sym_arrow_function] = STATE(502),
    [sym_call_expression] = STATE(502),
    [sym_new_expression] = STATE(502),
    [sym_await_expression] = STATE(502),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(502),
    [sym_augmented_assignment_expression] = STATE(502),
    [sym_ternary_expression] = STATE(502),
    [sym_binary_expression] = STATE(502),
    [sym_unary_expression] = STATE(502),
    [sym_update_expression] = STATE(502),
    [sym_sequence_expression] = STATE(1104),
    [sym_string] = STATE(502),
    [sym_template_string] = STATE(502),
    [sym_regex] = STATE(502),
    [sym_meta_property] = STATE(502),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(636),
    [sym_this] = ACTIONS(638),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(638),
    [sym_false] = ACTIONS(638),
    [sym_null] = ACTIONS(638),
    [sym_undefined] = ACTIONS(638),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [85] = {
    [sym_import] = STATE(350),
    [sym_statement_block] = STATE(454),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(350),
    [sym_yield_expression] = STATE(350),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(350),
    [sym_jsx_fragment] = STATE(350),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(350),
    [sym_class] = STATE(350),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(350),
    [sym_arrow_function] = STATE(350),
    [sym_call_expression] = STATE(350),
    [sym_new_expression] = STATE(350),
    [sym_await_expression] = STATE(350),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(350),
    [sym_augmented_assignment_expression] = STATE(350),
    [sym_ternary_expression] = STATE(350),
    [sym_binary_expression] = STATE(350),
    [sym_unary_expression] = STATE(350),
    [sym_update_expression] = STATE(350),
    [sym_string] = STATE(350),
    [sym_template_string] = STATE(350),
    [sym_regex] = STATE(350),
    [sym_meta_property] = STATE(350),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(642),
    [sym_this] = ACTIONS(644),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(644),
    [sym_false] = ACTIONS(644),
    [sym_null] = ACTIONS(644),
    [sym_undefined] = ACTIONS(644),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [86] = {
    [sym_import] = STATE(424),
    [sym_statement_block] = STATE(533),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(424),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(424),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(424),
    [sym_arrow_function] = STATE(424),
    [sym_call_expression] = STATE(424),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(424),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(424),
    [sym_template_string] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_meta_property] = STATE(424),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(646),
    [sym_this] = ACTIONS(648),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(648),
    [sym_false] = ACTIONS(648),
    [sym_null] = ACTIONS(648),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [87] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(539),
    [sym_yield_expression] = STATE(539),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(539),
    [sym_jsx_fragment] = STATE(539),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(539),
    [sym_class] = STATE(539),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(539),
    [sym_await_expression] = STATE(539),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(539),
    [sym_augmented_assignment_expression] = STATE(539),
    [sym_ternary_expression] = STATE(539),
    [sym_binary_expression] = STATE(539),
    [sym_unary_expression] = STATE(539),
    [sym_update_expression] = STATE(539),
    [sym_sequence_expression] = STATE(1127),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(650),
    [sym_this] = ACTIONS(652),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(652),
    [sym_false] = ACTIONS(652),
    [sym_null] = ACTIONS(652),
    [sym_undefined] = ACTIONS(652),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [88] = {
    [sym_import] = STATE(557),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(557),
    [sym_yield_expression] = STATE(557),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(557),
    [sym_jsx_fragment] = STATE(557),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(557),
    [sym_class] = STATE(557),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(557),
    [sym_arrow_function] = STATE(557),
    [sym_call_expression] = STATE(557),
    [sym_new_expression] = STATE(557),
    [sym_await_expression] = STATE(557),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(557),
    [sym_augmented_assignment_expression] = STATE(557),
    [sym_ternary_expression] = STATE(557),
    [sym_binary_expression] = STATE(557),
    [sym_unary_expression] = STATE(557),
    [sym_update_expression] = STATE(557),
    [sym_sequence_expression] = STATE(1086),
    [sym_string] = STATE(557),
    [sym_template_string] = STATE(557),
    [sym_regex] = STATE(557),
    [sym_meta_property] = STATE(557),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(654),
    [sym_this] = ACTIONS(656),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(656),
    [sym_false] = ACTIONS(656),
    [sym_null] = ACTIONS(656),
    [sym_undefined] = ACTIONS(656),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [89] = {
    [sym_import] = STATE(363),
    [sym_parenthesized_expression] = STATE(269),
    [sym__expression] = STATE(574),
    [sym_yield_expression] = STATE(574),
    [sym_object] = STATE(324),
    [sym_array] = STATE(325),
    [sym_jsx_element] = STATE(574),
    [sym_jsx_fragment] = STATE(574),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(574),
    [sym_class] = STATE(363),
    [sym_function] = STATE(326),
    [sym_generator_function] = STATE(363),
    [sym_arrow_function] = STATE(363),
    [sym_call_expression] = STATE(574),
    [sym_new_expression] = STATE(363),
    [sym_await_expression] = STATE(574),
    [sym_member_expression] = STATE(269),
    [sym_subscript_expression] = STATE(269),
    [sym_assignment_expression] = STATE(574),
    [sym_augmented_assignment_expression] = STATE(574),
    [sym_ternary_expression] = STATE(574),
    [sym_binary_expression] = STATE(574),
    [sym_unary_expression] = STATE(574),
    [sym_update_expression] = STATE(574),
    [sym_string] = STATE(363),
    [sym_template_string] = STATE(363),
    [sym_regex] = STATE(363),
    [sym_meta_property] = STATE(363),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(658),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_DOT] = ACTIONS(660),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(662),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(664),
    [sym_this] = ACTIONS(666),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(666),
    [sym_false] = ACTIONS(666),
    [sym_null] = ACTIONS(666),
    [sym_undefined] = ACTIONS(666),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
  },
  [90] = {
    [sym_import] = STATE(393),
    [sym_statement_block] = STATE(562),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(393),
    [sym_yield_expression] = STATE(393),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(393),
    [sym_jsx_fragment] = STATE(393),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(393),
    [sym_class] = STATE(393),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(393),
    [sym_arrow_function] = STATE(393),
    [sym_call_expression] = STATE(393),
    [sym_new_expression] = STATE(393),
    [sym_await_expression] = STATE(393),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(393),
    [sym_augmented_assignment_expression] = STATE(393),
    [sym_ternary_expression] = STATE(393),
    [sym_binary_expression] = STATE(393),
    [sym_unary_expression] = STATE(393),
    [sym_update_expression] = STATE(393),
    [sym_string] = STATE(393),
    [sym_template_string] = STATE(393),
    [sym_regex] = STATE(393),
    [sym_meta_property] = STATE(393),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(670),
    [sym_this] = ACTIONS(672),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(672),
    [sym_false] = ACTIONS(672),
    [sym_null] = ACTIONS(672),
    [sym_undefined] = ACTIONS(672),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [91] = {
    [sym_import] = STATE(316),
    [sym_statement_block] = STATE(380),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(316),
    [sym_yield_expression] = STATE(316),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(316),
    [sym_jsx_fragment] = STATE(316),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(316),
    [sym_class] = STATE(316),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(316),
    [sym_arrow_function] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_new_expression] = STATE(316),
    [sym_await_expression] = STATE(316),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(316),
    [sym_augmented_assignment_expression] = STATE(316),
    [sym_ternary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_update_expression] = STATE(316),
    [sym_string] = STATE(316),
    [sym_template_string] = STATE(316),
    [sym_regex] = STATE(316),
    [sym_meta_property] = STATE(316),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(674),
    [sym_this] = ACTIONS(676),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(676),
    [sym_false] = ACTIONS(676),
    [sym_null] = ACTIONS(676),
    [sym_undefined] = ACTIONS(676),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [92] = {
    [sym_import] = STATE(548),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(548),
    [sym_yield_expression] = STATE(548),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(548),
    [sym_jsx_fragment] = STATE(548),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(548),
    [sym_class] = STATE(548),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(548),
    [sym_arrow_function] = STATE(548),
    [sym_call_expression] = STATE(548),
    [sym_new_expression] = STATE(548),
    [sym_await_expression] = STATE(548),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(548),
    [sym_augmented_assignment_expression] = STATE(548),
    [sym_ternary_expression] = STATE(548),
    [sym_binary_expression] = STATE(548),
    [sym_unary_expression] = STATE(548),
    [sym_update_expression] = STATE(548),
    [sym_sequence_expression] = STATE(1078),
    [sym_string] = STATE(548),
    [sym_template_string] = STATE(548),
    [sym_regex] = STATE(548),
    [sym_meta_property] = STATE(548),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(678),
    [sym_this] = ACTIONS(680),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(680),
    [sym_false] = ACTIONS(680),
    [sym_null] = ACTIONS(680),
    [sym_undefined] = ACTIONS(680),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [93] = {
    [sym_import] = STATE(545),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(545),
    [sym_yield_expression] = STATE(545),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(545),
    [sym_jsx_fragment] = STATE(545),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(545),
    [sym_class] = STATE(545),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(545),
    [sym_arrow_function] = STATE(545),
    [sym_call_expression] = STATE(545),
    [sym_new_expression] = STATE(545),
    [sym_await_expression] = STATE(545),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(545),
    [sym_augmented_assignment_expression] = STATE(545),
    [sym_ternary_expression] = STATE(545),
    [sym_binary_expression] = STATE(545),
    [sym_unary_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_sequence_expression] = STATE(1111),
    [sym_string] = STATE(545),
    [sym_template_string] = STATE(545),
    [sym_regex] = STATE(545),
    [sym_meta_property] = STATE(545),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(682),
    [sym_this] = ACTIONS(684),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(684),
    [sym_false] = ACTIONS(684),
    [sym_null] = ACTIONS(684),
    [sym_undefined] = ACTIONS(684),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [94] = {
    [sym_import] = STATE(466),
    [sym_parenthesized_expression] = STATE(280),
    [sym__expression] = STATE(576),
    [sym_yield_expression] = STATE(576),
    [sym_object] = STATE(433),
    [sym_array] = STATE(428),
    [sym_jsx_element] = STATE(576),
    [sym_jsx_fragment] = STATE(576),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(576),
    [sym_class] = STATE(466),
    [sym_function] = STATE(365),
    [sym_generator_function] = STATE(466),
    [sym_arrow_function] = STATE(466),
    [sym_call_expression] = STATE(576),
    [sym_new_expression] = STATE(466),
    [sym_await_expression] = STATE(576),
    [sym_member_expression] = STATE(280),
    [sym_subscript_expression] = STATE(280),
    [sym_assignment_expression] = STATE(576),
    [sym_augmented_assignment_expression] = STATE(576),
    [sym_ternary_expression] = STATE(576),
    [sym_binary_expression] = STATE(576),
    [sym_unary_expression] = STATE(576),
    [sym_update_expression] = STATE(576),
    [sym_string] = STATE(466),
    [sym_template_string] = STATE(466),
    [sym_regex] = STATE(466),
    [sym_meta_property] = STATE(466),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(686),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_DOT] = ACTIONS(688),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(690),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(692),
    [sym_this] = ACTIONS(694),
    [sym_super] = ACTIONS(696),
    [sym_true] = ACTIONS(694),
    [sym_false] = ACTIONS(694),
    [sym_null] = ACTIONS(694),
    [sym_undefined] = ACTIONS(694),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(698),
    [anon_sym_get] = ACTIONS(698),
    [anon_sym_set] = ACTIONS(698),
  },
  [95] = {
    [sym_import] = STATE(559),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(559),
    [sym_yield_expression] = STATE(559),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(559),
    [sym_jsx_fragment] = STATE(559),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(559),
    [sym_class] = STATE(559),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(559),
    [sym_arrow_function] = STATE(559),
    [sym_call_expression] = STATE(559),
    [sym_new_expression] = STATE(559),
    [sym_await_expression] = STATE(559),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(559),
    [sym_ternary_expression] = STATE(559),
    [sym_binary_expression] = STATE(559),
    [sym_unary_expression] = STATE(559),
    [sym_update_expression] = STATE(559),
    [sym_sequence_expression] = STATE(1082),
    [sym_string] = STATE(559),
    [sym_template_string] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_meta_property] = STATE(559),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(700),
    [sym_this] = ACTIONS(702),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(702),
    [sym_false] = ACTIONS(702),
    [sym_null] = ACTIONS(702),
    [sym_undefined] = ACTIONS(702),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [96] = {
    [sym_import] = STATE(527),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(527),
    [sym_yield_expression] = STATE(527),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(527),
    [sym_jsx_fragment] = STATE(527),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(527),
    [sym_class] = STATE(527),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(527),
    [sym_arrow_function] = STATE(527),
    [sym_call_expression] = STATE(527),
    [sym_new_expression] = STATE(527),
    [sym_await_expression] = STATE(527),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(527),
    [sym_augmented_assignment_expression] = STATE(527),
    [sym_ternary_expression] = STATE(527),
    [sym_binary_expression] = STATE(527),
    [sym_unary_expression] = STATE(527),
    [sym_update_expression] = STATE(527),
    [sym_sequence_expression] = STATE(1045),
    [sym_string] = STATE(527),
    [sym_template_string] = STATE(527),
    [sym_regex] = STATE(527),
    [sym_meta_property] = STATE(527),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(704),
    [sym_this] = ACTIONS(706),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(706),
    [sym_false] = ACTIONS(706),
    [sym_null] = ACTIONS(706),
    [sym_undefined] = ACTIONS(706),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [97] = {
    [sym_import] = STATE(361),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(361),
    [sym_yield_expression] = STATE(361),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(361),
    [sym_jsx_fragment] = STATE(361),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(361),
    [sym_class] = STATE(361),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(361),
    [sym_arrow_function] = STATE(361),
    [sym_call_expression] = STATE(361),
    [sym_new_expression] = STATE(361),
    [sym_await_expression] = STATE(361),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(361),
    [sym_augmented_assignment_expression] = STATE(361),
    [sym_ternary_expression] = STATE(361),
    [sym_binary_expression] = STATE(361),
    [sym_unary_expression] = STATE(361),
    [sym_update_expression] = STATE(361),
    [sym_sequence_expression] = STATE(808),
    [sym_string] = STATE(361),
    [sym_template_string] = STATE(361),
    [sym_regex] = STATE(361),
    [sym_meta_property] = STATE(361),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(708),
    [sym_this] = ACTIONS(710),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(710),
    [sym_false] = ACTIONS(710),
    [sym_null] = ACTIONS(710),
    [sym_undefined] = ACTIONS(710),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [98] = {
    [sym_import] = STATE(531),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(531),
    [sym_yield_expression] = STATE(531),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(531),
    [sym_jsx_fragment] = STATE(531),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(531),
    [sym_class] = STATE(531),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(531),
    [sym_arrow_function] = STATE(531),
    [sym_call_expression] = STATE(531),
    [sym_new_expression] = STATE(531),
    [sym_await_expression] = STATE(531),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(531),
    [sym_augmented_assignment_expression] = STATE(531),
    [sym_ternary_expression] = STATE(531),
    [sym_binary_expression] = STATE(531),
    [sym_unary_expression] = STATE(531),
    [sym_update_expression] = STATE(531),
    [sym_sequence_expression] = STATE(1071),
    [sym_string] = STATE(531),
    [sym_template_string] = STATE(531),
    [sym_regex] = STATE(531),
    [sym_meta_property] = STATE(531),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(712),
    [sym_this] = ACTIONS(714),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(714),
    [sym_false] = ACTIONS(714),
    [sym_null] = ACTIONS(714),
    [sym_undefined] = ACTIONS(714),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [99] = {
    [sym_import] = STATE(348),
    [sym_statement_block] = STATE(379),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(348),
    [sym_yield_expression] = STATE(348),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(348),
    [sym_jsx_fragment] = STATE(348),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(348),
    [sym_class] = STATE(348),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(348),
    [sym_arrow_function] = STATE(348),
    [sym_call_expression] = STATE(348),
    [sym_new_expression] = STATE(348),
    [sym_await_expression] = STATE(348),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(348),
    [sym_augmented_assignment_expression] = STATE(348),
    [sym_ternary_expression] = STATE(348),
    [sym_binary_expression] = STATE(348),
    [sym_unary_expression] = STATE(348),
    [sym_update_expression] = STATE(348),
    [sym_string] = STATE(348),
    [sym_template_string] = STATE(348),
    [sym_regex] = STATE(348),
    [sym_meta_property] = STATE(348),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(716),
    [sym_this] = ACTIONS(718),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(718),
    [sym_false] = ACTIONS(718),
    [sym_null] = ACTIONS(718),
    [sym_undefined] = ACTIONS(718),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [100] = {
    [sym_import] = STATE(496),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(496),
    [sym_yield_expression] = STATE(496),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(496),
    [sym_jsx_fragment] = STATE(496),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(496),
    [sym_class] = STATE(496),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(496),
    [sym_arrow_function] = STATE(496),
    [sym_call_expression] = STATE(496),
    [sym_new_expression] = STATE(496),
    [sym_await_expression] = STATE(496),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(496),
    [sym_augmented_assignment_expression] = STATE(496),
    [sym_ternary_expression] = STATE(496),
    [sym_binary_expression] = STATE(496),
    [sym_unary_expression] = STATE(496),
    [sym_update_expression] = STATE(496),
    [sym_sequence_expression] = STATE(1100),
    [sym_string] = STATE(496),
    [sym_template_string] = STATE(496),
    [sym_regex] = STATE(496),
    [sym_meta_property] = STATE(496),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(568),
    [sym_this] = ACTIONS(570),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(570),
    [sym_false] = ACTIONS(570),
    [sym_null] = ACTIONS(570),
    [sym_undefined] = ACTIONS(570),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [101] = {
    [sym_import] = STATE(510),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(510),
    [sym_yield_expression] = STATE(510),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(510),
    [sym_jsx_fragment] = STATE(510),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(510),
    [sym_class] = STATE(510),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(510),
    [sym_arrow_function] = STATE(510),
    [sym_call_expression] = STATE(510),
    [sym_new_expression] = STATE(510),
    [sym_await_expression] = STATE(510),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(510),
    [sym_augmented_assignment_expression] = STATE(510),
    [sym_ternary_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_sequence_expression] = STATE(1107),
    [sym_string] = STATE(510),
    [sym_template_string] = STATE(510),
    [sym_regex] = STATE(510),
    [sym_meta_property] = STATE(510),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(720),
    [sym_this] = ACTIONS(722),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(722),
    [sym_false] = ACTIONS(722),
    [sym_null] = ACTIONS(722),
    [sym_undefined] = ACTIONS(722),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [102] = {
    [sym_import] = STATE(373),
    [sym_statement_block] = STATE(518),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(373),
    [sym_yield_expression] = STATE(373),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(373),
    [sym_jsx_fragment] = STATE(373),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(373),
    [sym_class] = STATE(373),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(373),
    [sym_arrow_function] = STATE(373),
    [sym_call_expression] = STATE(373),
    [sym_new_expression] = STATE(373),
    [sym_await_expression] = STATE(373),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(373),
    [sym_augmented_assignment_expression] = STATE(373),
    [sym_ternary_expression] = STATE(373),
    [sym_binary_expression] = STATE(373),
    [sym_unary_expression] = STATE(373),
    [sym_update_expression] = STATE(373),
    [sym_string] = STATE(373),
    [sym_template_string] = STATE(373),
    [sym_regex] = STATE(373),
    [sym_meta_property] = STATE(373),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(724),
    [sym_this] = ACTIONS(726),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(726),
    [sym_false] = ACTIONS(726),
    [sym_null] = ACTIONS(726),
    [sym_undefined] = ACTIONS(726),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [103] = {
    [sym_import] = STATE(491),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(491),
    [sym_yield_expression] = STATE(491),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(491),
    [sym_jsx_fragment] = STATE(491),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(491),
    [sym_class] = STATE(491),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(491),
    [sym_arrow_function] = STATE(491),
    [sym_call_expression] = STATE(491),
    [sym_new_expression] = STATE(491),
    [sym_await_expression] = STATE(491),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(491),
    [sym_augmented_assignment_expression] = STATE(491),
    [sym_ternary_expression] = STATE(491),
    [sym_binary_expression] = STATE(491),
    [sym_unary_expression] = STATE(491),
    [sym_update_expression] = STATE(491),
    [sym_sequence_expression] = STATE(941),
    [sym_string] = STATE(491),
    [sym_template_string] = STATE(491),
    [sym_regex] = STATE(491),
    [sym_meta_property] = STATE(491),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(728),
    [sym_this] = ACTIONS(730),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(730),
    [sym_false] = ACTIONS(730),
    [sym_null] = ACTIONS(730),
    [sym_undefined] = ACTIONS(730),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [104] = {
    [sym_import] = STATE(574),
    [sym_variable_declarator] = STATE(790),
    [sym_parenthesized_expression] = STATE(313),
    [sym__expression] = STATE(574),
    [sym_yield_expression] = STATE(574),
    [sym_object] = STATE(378),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(574),
    [sym_jsx_fragment] = STATE(574),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(574),
    [sym_class] = STATE(574),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(574),
    [sym_arrow_function] = STATE(574),
    [sym_call_expression] = STATE(574),
    [sym_new_expression] = STATE(574),
    [sym_await_expression] = STATE(574),
    [sym_member_expression] = STATE(313),
    [sym_subscript_expression] = STATE(313),
    [sym_assignment_expression] = STATE(574),
    [sym_augmented_assignment_expression] = STATE(574),
    [sym_ternary_expression] = STATE(574),
    [sym_binary_expression] = STATE(574),
    [sym_unary_expression] = STATE(574),
    [sym_update_expression] = STATE(574),
    [sym_string] = STATE(574),
    [sym_template_string] = STATE(574),
    [sym_regex] = STATE(574),
    [sym_meta_property] = STATE(574),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(734),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(590),
    [sym_this] = ACTIONS(592),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(592),
    [sym_false] = ACTIONS(592),
    [sym_null] = ACTIONS(592),
    [sym_undefined] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(736),
    [anon_sym_get] = ACTIONS(736),
    [anon_sym_set] = ACTIONS(736),
  },
  [105] = {
    [sym_import] = STATE(495),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(495),
    [sym_yield_expression] = STATE(495),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(495),
    [sym_jsx_fragment] = STATE(495),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(495),
    [sym_class] = STATE(495),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(495),
    [sym_arrow_function] = STATE(495),
    [sym_call_expression] = STATE(495),
    [sym_new_expression] = STATE(495),
    [sym_await_expression] = STATE(495),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(495),
    [sym_augmented_assignment_expression] = STATE(495),
    [sym_ternary_expression] = STATE(495),
    [sym_binary_expression] = STATE(495),
    [sym_unary_expression] = STATE(495),
    [sym_update_expression] = STATE(495),
    [sym_sequence_expression] = STATE(1114),
    [sym_string] = STATE(495),
    [sym_template_string] = STATE(495),
    [sym_regex] = STATE(495),
    [sym_meta_property] = STATE(495),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(738),
    [sym_this] = ACTIONS(740),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(740),
    [sym_false] = ACTIONS(740),
    [sym_null] = ACTIONS(740),
    [sym_undefined] = ACTIONS(740),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [106] = {
    [sym_import] = STATE(337),
    [sym_statement_block] = STATE(432),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(337),
    [sym_yield_expression] = STATE(337),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(337),
    [sym_jsx_fragment] = STATE(337),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(337),
    [sym_class] = STATE(337),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(337),
    [sym_arrow_function] = STATE(337),
    [sym_call_expression] = STATE(337),
    [sym_new_expression] = STATE(337),
    [sym_await_expression] = STATE(337),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(337),
    [sym_augmented_assignment_expression] = STATE(337),
    [sym_ternary_expression] = STATE(337),
    [sym_binary_expression] = STATE(337),
    [sym_unary_expression] = STATE(337),
    [sym_update_expression] = STATE(337),
    [sym_string] = STATE(337),
    [sym_template_string] = STATE(337),
    [sym_regex] = STATE(337),
    [sym_meta_property] = STATE(337),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(742),
    [sym_this] = ACTIONS(744),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(744),
    [sym_false] = ACTIONS(744),
    [sym_null] = ACTIONS(744),
    [sym_undefined] = ACTIONS(744),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [107] = {
    [sym_import] = STATE(336),
    [sym_statement_block] = STATE(436),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(336),
    [sym_yield_expression] = STATE(336),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(336),
    [sym_jsx_fragment] = STATE(336),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(336),
    [sym_class] = STATE(336),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(336),
    [sym_arrow_function] = STATE(336),
    [sym_call_expression] = STATE(336),
    [sym_new_expression] = STATE(336),
    [sym_await_expression] = STATE(336),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(336),
    [sym_augmented_assignment_expression] = STATE(336),
    [sym_ternary_expression] = STATE(336),
    [sym_binary_expression] = STATE(336),
    [sym_unary_expression] = STATE(336),
    [sym_update_expression] = STATE(336),
    [sym_string] = STATE(336),
    [sym_template_string] = STATE(336),
    [sym_regex] = STATE(336),
    [sym_meta_property] = STATE(336),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(746),
    [sym_this] = ACTIONS(748),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(748),
    [sym_false] = ACTIONS(748),
    [sym_null] = ACTIONS(748),
    [sym_undefined] = ACTIONS(748),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [108] = {
    [sym_import] = STATE(335),
    [sym_statement_block] = STATE(439),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(335),
    [sym_yield_expression] = STATE(335),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(335),
    [sym_jsx_fragment] = STATE(335),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(335),
    [sym_class] = STATE(335),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(335),
    [sym_arrow_function] = STATE(335),
    [sym_call_expression] = STATE(335),
    [sym_new_expression] = STATE(335),
    [sym_await_expression] = STATE(335),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(335),
    [sym_augmented_assignment_expression] = STATE(335),
    [sym_ternary_expression] = STATE(335),
    [sym_binary_expression] = STATE(335),
    [sym_unary_expression] = STATE(335),
    [sym_update_expression] = STATE(335),
    [sym_string] = STATE(335),
    [sym_template_string] = STATE(335),
    [sym_regex] = STATE(335),
    [sym_meta_property] = STATE(335),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(640),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(750),
    [sym_this] = ACTIONS(752),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(752),
    [sym_false] = ACTIONS(752),
    [sym_null] = ACTIONS(752),
    [sym_undefined] = ACTIONS(752),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [109] = {
    [sym_import] = STATE(574),
    [sym_variable_declarator] = STATE(794),
    [sym_parenthesized_expression] = STATE(313),
    [sym__expression] = STATE(574),
    [sym_yield_expression] = STATE(574),
    [sym_object] = STATE(378),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(574),
    [sym_jsx_fragment] = STATE(574),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(574),
    [sym_class] = STATE(574),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(574),
    [sym_arrow_function] = STATE(574),
    [sym_call_expression] = STATE(574),
    [sym_new_expression] = STATE(574),
    [sym_await_expression] = STATE(574),
    [sym_member_expression] = STATE(313),
    [sym_subscript_expression] = STATE(313),
    [sym_assignment_expression] = STATE(574),
    [sym_augmented_assignment_expression] = STATE(574),
    [sym_ternary_expression] = STATE(574),
    [sym_binary_expression] = STATE(574),
    [sym_unary_expression] = STATE(574),
    [sym_update_expression] = STATE(574),
    [sym_string] = STATE(574),
    [sym_template_string] = STATE(574),
    [sym_regex] = STATE(574),
    [sym_meta_property] = STATE(574),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(732),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(734),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(590),
    [sym_this] = ACTIONS(592),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(592),
    [sym_false] = ACTIONS(592),
    [sym_null] = ACTIONS(592),
    [sym_undefined] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(736),
    [anon_sym_get] = ACTIONS(736),
    [anon_sym_set] = ACTIONS(736),
  },
  [110] = {
    [sym_import] = STATE(409),
    [sym_statement_block] = STATE(544),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(409),
    [sym_yield_expression] = STATE(409),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(409),
    [sym_jsx_fragment] = STATE(409),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(409),
    [sym_class] = STATE(409),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(409),
    [sym_arrow_function] = STATE(409),
    [sym_call_expression] = STATE(409),
    [sym_new_expression] = STATE(409),
    [sym_await_expression] = STATE(409),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(409),
    [sym_augmented_assignment_expression] = STATE(409),
    [sym_ternary_expression] = STATE(409),
    [sym_binary_expression] = STATE(409),
    [sym_unary_expression] = STATE(409),
    [sym_update_expression] = STATE(409),
    [sym_string] = STATE(409),
    [sym_template_string] = STATE(409),
    [sym_regex] = STATE(409),
    [sym_meta_property] = STATE(409),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(618),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(754),
    [sym_this] = ACTIONS(756),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(756),
    [sym_false] = ACTIONS(756),
    [sym_null] = ACTIONS(756),
    [sym_undefined] = ACTIONS(756),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [111] = {
    [sym_import] = STATE(512),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(512),
    [sym_yield_expression] = STATE(512),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(512),
    [sym_jsx_fragment] = STATE(512),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(512),
    [sym_class] = STATE(512),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(512),
    [sym_arrow_function] = STATE(512),
    [sym_call_expression] = STATE(512),
    [sym_new_expression] = STATE(512),
    [sym_await_expression] = STATE(512),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(512),
    [sym_augmented_assignment_expression] = STATE(512),
    [sym_ternary_expression] = STATE(512),
    [sym_binary_expression] = STATE(512),
    [sym_unary_expression] = STATE(512),
    [sym_update_expression] = STATE(512),
    [sym_sequence_expression] = STATE(1096),
    [sym_string] = STATE(512),
    [sym_template_string] = STATE(512),
    [sym_regex] = STATE(512),
    [sym_meta_property] = STATE(512),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(758),
    [sym_this] = ACTIONS(760),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(760),
    [sym_false] = ACTIONS(760),
    [sym_null] = ACTIONS(760),
    [sym_undefined] = ACTIONS(760),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [112] = {
    [sym_import] = STATE(470),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(470),
    [sym_yield_expression] = STATE(470),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(470),
    [sym_jsx_fragment] = STATE(470),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(470),
    [sym_class] = STATE(470),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(470),
    [sym_arrow_function] = STATE(470),
    [sym_call_expression] = STATE(470),
    [sym_new_expression] = STATE(470),
    [sym_await_expression] = STATE(470),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(470),
    [sym_augmented_assignment_expression] = STATE(470),
    [sym_ternary_expression] = STATE(470),
    [sym_binary_expression] = STATE(470),
    [sym_unary_expression] = STATE(470),
    [sym_update_expression] = STATE(470),
    [sym_string] = STATE(470),
    [sym_template_string] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_meta_property] = STATE(470),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(762),
    [sym_this] = ACTIONS(764),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(764),
    [sym_false] = ACTIONS(764),
    [sym_null] = ACTIONS(764),
    [sym_undefined] = ACTIONS(764),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [113] = {
    [sym_import] = STATE(347),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(347),
    [sym_yield_expression] = STATE(347),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(347),
    [sym_jsx_fragment] = STATE(347),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(347),
    [sym_class] = STATE(347),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(347),
    [sym_arrow_function] = STATE(347),
    [sym_call_expression] = STATE(347),
    [sym_new_expression] = STATE(347),
    [sym_await_expression] = STATE(347),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(347),
    [sym_augmented_assignment_expression] = STATE(347),
    [sym_ternary_expression] = STATE(347),
    [sym_binary_expression] = STATE(347),
    [sym_unary_expression] = STATE(347),
    [sym_update_expression] = STATE(347),
    [sym_string] = STATE(347),
    [sym_template_string] = STATE(347),
    [sym_regex] = STATE(347),
    [sym_meta_property] = STATE(347),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(766),
    [sym_this] = ACTIONS(768),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(768),
    [sym_false] = ACTIONS(768),
    [sym_null] = ACTIONS(768),
    [sym_undefined] = ACTIONS(768),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [114] = {
    [sym_import] = STATE(570),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(570),
    [sym_yield_expression] = STATE(570),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(570),
    [sym_jsx_fragment] = STATE(570),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(570),
    [sym_class] = STATE(570),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(570),
    [sym_arrow_function] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_new_expression] = STATE(570),
    [sym_await_expression] = STATE(570),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(570),
    [sym_augmented_assignment_expression] = STATE(570),
    [sym_ternary_expression] = STATE(570),
    [sym_binary_expression] = STATE(570),
    [sym_unary_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_string] = STATE(570),
    [sym_template_string] = STATE(570),
    [sym_regex] = STATE(570),
    [sym_meta_property] = STATE(570),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(770),
    [sym_this] = ACTIONS(772),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(772),
    [sym_false] = ACTIONS(772),
    [sym_null] = ACTIONS(772),
    [sym_undefined] = ACTIONS(772),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [115] = {
    [sym_import] = STATE(567),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(567),
    [sym_yield_expression] = STATE(567),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(567),
    [sym_jsx_fragment] = STATE(567),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(567),
    [sym_class] = STATE(567),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(567),
    [sym_arrow_function] = STATE(567),
    [sym_call_expression] = STATE(567),
    [sym_new_expression] = STATE(567),
    [sym_await_expression] = STATE(567),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(567),
    [sym_augmented_assignment_expression] = STATE(567),
    [sym_ternary_expression] = STATE(567),
    [sym_binary_expression] = STATE(567),
    [sym_unary_expression] = STATE(567),
    [sym_update_expression] = STATE(567),
    [sym_string] = STATE(567),
    [sym_template_string] = STATE(567),
    [sym_regex] = STATE(567),
    [sym_meta_property] = STATE(567),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(774),
    [sym_this] = ACTIONS(776),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(776),
    [sym_false] = ACTIONS(776),
    [sym_null] = ACTIONS(776),
    [sym_undefined] = ACTIONS(776),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [116] = {
    [sym_import] = STATE(561),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(561),
    [sym_yield_expression] = STATE(561),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(561),
    [sym_jsx_fragment] = STATE(561),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(561),
    [sym_class] = STATE(561),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(561),
    [sym_arrow_function] = STATE(561),
    [sym_call_expression] = STATE(561),
    [sym_new_expression] = STATE(561),
    [sym_await_expression] = STATE(561),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(561),
    [sym_augmented_assignment_expression] = STATE(561),
    [sym_ternary_expression] = STATE(561),
    [sym_binary_expression] = STATE(561),
    [sym_unary_expression] = STATE(561),
    [sym_update_expression] = STATE(561),
    [sym_string] = STATE(561),
    [sym_template_string] = STATE(561),
    [sym_regex] = STATE(561),
    [sym_meta_property] = STATE(561),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(778),
    [sym_this] = ACTIONS(780),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(780),
    [sym_false] = ACTIONS(780),
    [sym_null] = ACTIONS(780),
    [sym_undefined] = ACTIONS(780),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [117] = {
    [sym_import] = STATE(372),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(372),
    [sym_yield_expression] = STATE(372),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(372),
    [sym_jsx_fragment] = STATE(372),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(372),
    [sym_class] = STATE(372),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(372),
    [sym_arrow_function] = STATE(372),
    [sym_call_expression] = STATE(372),
    [sym_new_expression] = STATE(372),
    [sym_await_expression] = STATE(372),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(372),
    [sym_augmented_assignment_expression] = STATE(372),
    [sym_ternary_expression] = STATE(372),
    [sym_binary_expression] = STATE(372),
    [sym_unary_expression] = STATE(372),
    [sym_update_expression] = STATE(372),
    [sym_string] = STATE(372),
    [sym_template_string] = STATE(372),
    [sym_regex] = STATE(372),
    [sym_meta_property] = STATE(372),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(782),
    [sym_this] = ACTIONS(784),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(784),
    [sym_false] = ACTIONS(784),
    [sym_null] = ACTIONS(784),
    [sym_undefined] = ACTIONS(784),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [118] = {
    [sym_import] = STATE(485),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(485),
    [sym_yield_expression] = STATE(485),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(485),
    [sym_jsx_fragment] = STATE(485),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(485),
    [sym_class] = STATE(485),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(485),
    [sym_arrow_function] = STATE(485),
    [sym_call_expression] = STATE(485),
    [sym_new_expression] = STATE(485),
    [sym_await_expression] = STATE(485),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(485),
    [sym_augmented_assignment_expression] = STATE(485),
    [sym_ternary_expression] = STATE(485),
    [sym_binary_expression] = STATE(485),
    [sym_unary_expression] = STATE(485),
    [sym_update_expression] = STATE(485),
    [sym_string] = STATE(485),
    [sym_template_string] = STATE(485),
    [sym_regex] = STATE(485),
    [sym_meta_property] = STATE(485),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(786),
    [sym_this] = ACTIONS(788),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(788),
    [sym_false] = ACTIONS(788),
    [sym_null] = ACTIONS(788),
    [sym_undefined] = ACTIONS(788),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [119] = {
    [sym_import] = STATE(486),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(486),
    [sym_yield_expression] = STATE(486),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(486),
    [sym_jsx_fragment] = STATE(486),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(486),
    [sym_class] = STATE(486),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(486),
    [sym_arrow_function] = STATE(486),
    [sym_call_expression] = STATE(486),
    [sym_new_expression] = STATE(486),
    [sym_await_expression] = STATE(486),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(486),
    [sym_augmented_assignment_expression] = STATE(486),
    [sym_ternary_expression] = STATE(486),
    [sym_binary_expression] = STATE(486),
    [sym_unary_expression] = STATE(486),
    [sym_update_expression] = STATE(486),
    [sym_string] = STATE(486),
    [sym_template_string] = STATE(486),
    [sym_regex] = STATE(486),
    [sym_meta_property] = STATE(486),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(790),
    [sym_this] = ACTIONS(792),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(792),
    [sym_false] = ACTIONS(792),
    [sym_null] = ACTIONS(792),
    [sym_undefined] = ACTIONS(792),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [120] = {
    [sym_import] = STATE(487),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(487),
    [sym_yield_expression] = STATE(487),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(487),
    [sym_jsx_fragment] = STATE(487),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(487),
    [sym_class] = STATE(487),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(487),
    [sym_arrow_function] = STATE(487),
    [sym_call_expression] = STATE(487),
    [sym_new_expression] = STATE(487),
    [sym_await_expression] = STATE(487),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(487),
    [sym_augmented_assignment_expression] = STATE(487),
    [sym_ternary_expression] = STATE(487),
    [sym_binary_expression] = STATE(487),
    [sym_unary_expression] = STATE(487),
    [sym_update_expression] = STATE(487),
    [sym_string] = STATE(487),
    [sym_template_string] = STATE(487),
    [sym_regex] = STATE(487),
    [sym_meta_property] = STATE(487),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(794),
    [sym_this] = ACTIONS(796),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(796),
    [sym_false] = ACTIONS(796),
    [sym_null] = ACTIONS(796),
    [sym_undefined] = ACTIONS(796),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [121] = {
    [sym_import] = STATE(425),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(425),
    [sym_yield_expression] = STATE(425),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(425),
    [sym_jsx_fragment] = STATE(425),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(425),
    [sym_class] = STATE(425),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(425),
    [sym_arrow_function] = STATE(425),
    [sym_call_expression] = STATE(425),
    [sym_new_expression] = STATE(425),
    [sym_await_expression] = STATE(425),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(425),
    [sym_augmented_assignment_expression] = STATE(425),
    [sym_ternary_expression] = STATE(425),
    [sym_binary_expression] = STATE(425),
    [sym_unary_expression] = STATE(425),
    [sym_update_expression] = STATE(425),
    [sym_string] = STATE(425),
    [sym_template_string] = STATE(425),
    [sym_regex] = STATE(425),
    [sym_meta_property] = STATE(425),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(798),
    [sym_this] = ACTIONS(800),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(800),
    [sym_false] = ACTIONS(800),
    [sym_null] = ACTIONS(800),
    [sym_undefined] = ACTIONS(800),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [122] = {
    [sym_import] = STATE(423),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(423),
    [sym_yield_expression] = STATE(423),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(423),
    [sym_jsx_fragment] = STATE(423),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(423),
    [sym_class] = STATE(423),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(423),
    [sym_arrow_function] = STATE(423),
    [sym_call_expression] = STATE(423),
    [sym_new_expression] = STATE(423),
    [sym_await_expression] = STATE(423),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(423),
    [sym_augmented_assignment_expression] = STATE(423),
    [sym_ternary_expression] = STATE(423),
    [sym_binary_expression] = STATE(423),
    [sym_unary_expression] = STATE(423),
    [sym_update_expression] = STATE(423),
    [sym_string] = STATE(423),
    [sym_template_string] = STATE(423),
    [sym_regex] = STATE(423),
    [sym_meta_property] = STATE(423),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(802),
    [sym_this] = ACTIONS(804),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(804),
    [sym_false] = ACTIONS(804),
    [sym_null] = ACTIONS(804),
    [sym_undefined] = ACTIONS(804),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [123] = {
    [sym_import] = STATE(422),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(422),
    [sym_yield_expression] = STATE(422),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(422),
    [sym_jsx_fragment] = STATE(422),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(422),
    [sym_class] = STATE(422),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(422),
    [sym_arrow_function] = STATE(422),
    [sym_call_expression] = STATE(422),
    [sym_new_expression] = STATE(422),
    [sym_await_expression] = STATE(422),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(422),
    [sym_augmented_assignment_expression] = STATE(422),
    [sym_ternary_expression] = STATE(422),
    [sym_binary_expression] = STATE(422),
    [sym_unary_expression] = STATE(422),
    [sym_update_expression] = STATE(422),
    [sym_string] = STATE(422),
    [sym_template_string] = STATE(422),
    [sym_regex] = STATE(422),
    [sym_meta_property] = STATE(422),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(806),
    [sym_this] = ACTIONS(808),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(808),
    [sym_false] = ACTIONS(808),
    [sym_null] = ACTIONS(808),
    [sym_undefined] = ACTIONS(808),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [124] = {
    [sym_import] = STATE(574),
    [sym_parenthesized_expression] = STATE(313),
    [sym__expression] = STATE(574),
    [sym_yield_expression] = STATE(574),
    [sym_object] = STATE(572),
    [sym_array] = STATE(573),
    [sym_jsx_element] = STATE(574),
    [sym_jsx_fragment] = STATE(574),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(574),
    [sym_class] = STATE(574),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(574),
    [sym_arrow_function] = STATE(574),
    [sym_call_expression] = STATE(574),
    [sym_new_expression] = STATE(574),
    [sym_await_expression] = STATE(574),
    [sym_member_expression] = STATE(313),
    [sym_subscript_expression] = STATE(313),
    [sym_assignment_expression] = STATE(574),
    [sym_augmented_assignment_expression] = STATE(574),
    [sym_ternary_expression] = STATE(574),
    [sym_binary_expression] = STATE(574),
    [sym_unary_expression] = STATE(574),
    [sym_update_expression] = STATE(574),
    [sym_string] = STATE(574),
    [sym_template_string] = STATE(574),
    [sym_regex] = STATE(574),
    [sym_meta_property] = STATE(574),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(810),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(734),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(590),
    [sym_this] = ACTIONS(592),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(592),
    [sym_false] = ACTIONS(592),
    [sym_null] = ACTIONS(592),
    [sym_undefined] = ACTIONS(592),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(736),
    [anon_sym_get] = ACTIONS(736),
    [anon_sym_set] = ACTIONS(736),
  },
  [125] = {
    [sym_import] = STATE(421),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(421),
    [sym_yield_expression] = STATE(421),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(421),
    [sym_jsx_fragment] = STATE(421),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(421),
    [sym_class] = STATE(421),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(421),
    [sym_arrow_function] = STATE(421),
    [sym_call_expression] = STATE(421),
    [sym_new_expression] = STATE(421),
    [sym_await_expression] = STATE(421),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(421),
    [sym_augmented_assignment_expression] = STATE(421),
    [sym_ternary_expression] = STATE(421),
    [sym_binary_expression] = STATE(421),
    [sym_unary_expression] = STATE(421),
    [sym_update_expression] = STATE(421),
    [sym_string] = STATE(421),
    [sym_template_string] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_meta_property] = STATE(421),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(812),
    [sym_this] = ACTIONS(814),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(814),
    [sym_false] = ACTIONS(814),
    [sym_null] = ACTIONS(814),
    [sym_undefined] = ACTIONS(814),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [126] = {
    [sym_import] = STATE(388),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(388),
    [sym_yield_expression] = STATE(388),
    [sym_object] = STATE(566),
    [sym_array] = STATE(568),
    [sym_jsx_element] = STATE(388),
    [sym_jsx_fragment] = STATE(388),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(388),
    [sym_class] = STATE(388),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(388),
    [sym_arrow_function] = STATE(388),
    [sym_call_expression] = STATE(388),
    [sym_new_expression] = STATE(388),
    [sym_await_expression] = STATE(388),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(388),
    [sym_augmented_assignment_expression] = STATE(388),
    [sym_ternary_expression] = STATE(388),
    [sym_binary_expression] = STATE(388),
    [sym_unary_expression] = STATE(388),
    [sym_update_expression] = STATE(388),
    [sym_string] = STATE(388),
    [sym_template_string] = STATE(388),
    [sym_regex] = STATE(388),
    [sym_meta_property] = STATE(388),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(816),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(818),
    [sym_this] = ACTIONS(820),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(820),
    [sym_false] = ACTIONS(820),
    [sym_null] = ACTIONS(820),
    [sym_undefined] = ACTIONS(820),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [127] = {
    [sym_import] = STATE(371),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(371),
    [sym_yield_expression] = STATE(371),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(371),
    [sym_jsx_fragment] = STATE(371),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(371),
    [sym_class] = STATE(371),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(371),
    [sym_arrow_function] = STATE(371),
    [sym_call_expression] = STATE(371),
    [sym_new_expression] = STATE(371),
    [sym_await_expression] = STATE(371),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(371),
    [sym_augmented_assignment_expression] = STATE(371),
    [sym_ternary_expression] = STATE(371),
    [sym_binary_expression] = STATE(371),
    [sym_unary_expression] = STATE(371),
    [sym_update_expression] = STATE(371),
    [sym_string] = STATE(371),
    [sym_template_string] = STATE(371),
    [sym_regex] = STATE(371),
    [sym_meta_property] = STATE(371),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(822),
    [sym_this] = ACTIONS(824),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(824),
    [sym_false] = ACTIONS(824),
    [sym_null] = ACTIONS(824),
    [sym_undefined] = ACTIONS(824),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [128] = {
    [sym_import] = STATE(556),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(556),
    [sym_yield_expression] = STATE(556),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(556),
    [sym_jsx_fragment] = STATE(556),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(556),
    [sym_class] = STATE(556),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(556),
    [sym_arrow_function] = STATE(556),
    [sym_call_expression] = STATE(556),
    [sym_new_expression] = STATE(556),
    [sym_await_expression] = STATE(556),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(556),
    [sym_augmented_assignment_expression] = STATE(556),
    [sym_ternary_expression] = STATE(556),
    [sym_binary_expression] = STATE(556),
    [sym_unary_expression] = STATE(556),
    [sym_update_expression] = STATE(556),
    [sym_string] = STATE(556),
    [sym_template_string] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_meta_property] = STATE(556),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(826),
    [sym_this] = ACTIONS(828),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(828),
    [sym_false] = ACTIONS(828),
    [sym_null] = ACTIONS(828),
    [sym_undefined] = ACTIONS(828),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [129] = {
    [sym_import] = STATE(484),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(484),
    [sym_yield_expression] = STATE(484),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(484),
    [sym_jsx_fragment] = STATE(484),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(484),
    [sym_class] = STATE(484),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(484),
    [sym_arrow_function] = STATE(484),
    [sym_call_expression] = STATE(484),
    [sym_new_expression] = STATE(484),
    [sym_await_expression] = STATE(484),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(484),
    [sym_augmented_assignment_expression] = STATE(484),
    [sym_ternary_expression] = STATE(484),
    [sym_binary_expression] = STATE(484),
    [sym_unary_expression] = STATE(484),
    [sym_update_expression] = STATE(484),
    [sym_string] = STATE(484),
    [sym_template_string] = STATE(484),
    [sym_regex] = STATE(484),
    [sym_meta_property] = STATE(484),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(830),
    [sym_this] = ACTIONS(832),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(832),
    [sym_false] = ACTIONS(832),
    [sym_null] = ACTIONS(832),
    [sym_undefined] = ACTIONS(832),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [130] = {
    [sym_import] = STATE(483),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(483),
    [sym_yield_expression] = STATE(483),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(483),
    [sym_jsx_fragment] = STATE(483),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(483),
    [sym_class] = STATE(483),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(483),
    [sym_arrow_function] = STATE(483),
    [sym_call_expression] = STATE(483),
    [sym_new_expression] = STATE(483),
    [sym_await_expression] = STATE(483),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(483),
    [sym_augmented_assignment_expression] = STATE(483),
    [sym_ternary_expression] = STATE(483),
    [sym_binary_expression] = STATE(483),
    [sym_unary_expression] = STATE(483),
    [sym_update_expression] = STATE(483),
    [sym_string] = STATE(483),
    [sym_template_string] = STATE(483),
    [sym_regex] = STATE(483),
    [sym_meta_property] = STATE(483),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(834),
    [sym_this] = ACTIONS(836),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(836),
    [sym_false] = ACTIONS(836),
    [sym_null] = ACTIONS(836),
    [sym_undefined] = ACTIONS(836),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [131] = {
    [sym_import] = STATE(458),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(458),
    [sym_yield_expression] = STATE(458),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(458),
    [sym_jsx_fragment] = STATE(458),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(458),
    [sym_class] = STATE(458),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(458),
    [sym_arrow_function] = STATE(458),
    [sym_call_expression] = STATE(458),
    [sym_new_expression] = STATE(458),
    [sym_await_expression] = STATE(458),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(458),
    [sym_augmented_assignment_expression] = STATE(458),
    [sym_ternary_expression] = STATE(458),
    [sym_binary_expression] = STATE(458),
    [sym_unary_expression] = STATE(458),
    [sym_update_expression] = STATE(458),
    [sym_string] = STATE(458),
    [sym_template_string] = STATE(458),
    [sym_regex] = STATE(458),
    [sym_meta_property] = STATE(458),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(838),
    [sym_this] = ACTIONS(840),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(840),
    [sym_false] = ACTIONS(840),
    [sym_null] = ACTIONS(840),
    [sym_undefined] = ACTIONS(840),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [132] = {
    [sym_import] = STATE(438),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(438),
    [sym_yield_expression] = STATE(438),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(438),
    [sym_jsx_fragment] = STATE(438),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(438),
    [sym_class] = STATE(438),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(438),
    [sym_arrow_function] = STATE(438),
    [sym_call_expression] = STATE(438),
    [sym_new_expression] = STATE(438),
    [sym_await_expression] = STATE(438),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(438),
    [sym_augmented_assignment_expression] = STATE(438),
    [sym_ternary_expression] = STATE(438),
    [sym_binary_expression] = STATE(438),
    [sym_unary_expression] = STATE(438),
    [sym_update_expression] = STATE(438),
    [sym_string] = STATE(438),
    [sym_template_string] = STATE(438),
    [sym_regex] = STATE(438),
    [sym_meta_property] = STATE(438),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(842),
    [sym_this] = ACTIONS(844),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(844),
    [sym_false] = ACTIONS(844),
    [sym_null] = ACTIONS(844),
    [sym_undefined] = ACTIONS(844),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [133] = {
    [sym_string] = STATE(1015),
    [sym_formal_parameters] = STATE(1126),
    [sym__property_name] = STATE(1015),
    [sym_computed_property_name] = STATE(1015),
    [aux_sym_object_repeat1] = STATE(870),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_COMMA] = ACTIONS(851),
    [anon_sym_RBRACE] = ACTIONS(853),
    [anon_sym_LPAREN] = ACTIONS(855),
    [anon_sym_in] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(851),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(864),
    [anon_sym_LBRACK] = ACTIONS(866),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(869),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(873),
    [anon_sym_EQ_GT] = ACTIONS(875),
    [anon_sym_PLUS_EQ] = ACTIONS(877),
    [anon_sym_DASH_EQ] = ACTIONS(877),
    [anon_sym_STAR_EQ] = ACTIONS(877),
    [anon_sym_SLASH_EQ] = ACTIONS(877),
    [anon_sym_PERCENT_EQ] = ACTIONS(877),
    [anon_sym_CARET_EQ] = ACTIONS(877),
    [anon_sym_AMP_EQ] = ACTIONS(877),
    [anon_sym_PIPE_EQ] = ACTIONS(877),
    [anon_sym_GT_GT_EQ] = ACTIONS(877),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(877),
    [anon_sym_LT_LT_EQ] = ACTIONS(877),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(877),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(877),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(877),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_GT_GT_GT] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_PIPE] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_STAR_STAR] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(851),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_QMARK_QMARK] = ACTIONS(859),
    [anon_sym_instanceof] = ACTIONS(859),
    [anon_sym_PLUS_PLUS] = ACTIONS(851),
    [anon_sym_DASH_DASH] = ACTIONS(851),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(851),
    [sym_number] = ACTIONS(879),
    [anon_sym_static] = ACTIONS(871),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [sym__automatic_semicolon] = ACTIONS(851),
  },
  [134] = {
    [sym_string] = STATE(1015),
    [sym_formal_parameters] = STATE(1126),
    [sym__property_name] = STATE(1015),
    [sym_computed_property_name] = STATE(1015),
    [aux_sym_object_repeat1] = STATE(838),
    [sym_identifier] = ACTIONS(846),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_COMMA] = ACTIONS(851),
    [anon_sym_RBRACE] = ACTIONS(883),
    [anon_sym_LPAREN] = ACTIONS(855),
    [anon_sym_in] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(851),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(864),
    [anon_sym_LBRACK] = ACTIONS(866),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(869),
    [anon_sym_async] = ACTIONS(871),
    [anon_sym_function] = ACTIONS(873),
    [anon_sym_EQ_GT] = ACTIONS(875),
    [anon_sym_PLUS_EQ] = ACTIONS(877),
    [anon_sym_DASH_EQ] = ACTIONS(877),
    [anon_sym_STAR_EQ] = ACTIONS(877),
    [anon_sym_SLASH_EQ] = ACTIONS(877),
    [anon_sym_PERCENT_EQ] = ACTIONS(877),
    [anon_sym_CARET_EQ] = ACTIONS(877),
    [anon_sym_AMP_EQ] = ACTIONS(877),
    [anon_sym_PIPE_EQ] = ACTIONS(877),
    [anon_sym_GT_GT_EQ] = ACTIONS(877),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(877),
    [anon_sym_LT_LT_EQ] = ACTIONS(877),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(877),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(877),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(877),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_GT_GT_GT] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_PIPE] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_STAR_STAR] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(851),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_QMARK_QMARK] = ACTIONS(859),
    [anon_sym_instanceof] = ACTIONS(859),
    [anon_sym_PLUS_PLUS] = ACTIONS(851),
    [anon_sym_DASH_DASH] = ACTIONS(851),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(851),
    [sym_number] = ACTIONS(879),
    [anon_sym_static] = ACTIONS(871),
    [anon_sym_get] = ACTIONS(881),
    [anon_sym_set] = ACTIONS(881),
    [sym__automatic_semicolon] = ACTIONS(851),
  },
  [135] = {
    [sym_import] = STATE(388),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(388),
    [sym_yield_expression] = STATE(388),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(388),
    [sym_jsx_fragment] = STATE(388),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(388),
    [sym_class] = STATE(388),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(388),
    [sym_arrow_function] = STATE(388),
    [sym_call_expression] = STATE(388),
    [sym_new_expression] = STATE(388),
    [sym_await_expression] = STATE(388),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(388),
    [sym_augmented_assignment_expression] = STATE(388),
    [sym_ternary_expression] = STATE(388),
    [sym_binary_expression] = STATE(388),
    [sym_unary_expression] = STATE(388),
    [sym_update_expression] = STATE(388),
    [sym_string] = STATE(388),
    [sym_template_string] = STATE(388),
    [sym_regex] = STATE(388),
    [sym_meta_property] = STATE(388),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(818),
    [sym_this] = ACTIONS(820),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(820),
    [sym_false] = ACTIONS(820),
    [sym_null] = ACTIONS(820),
    [sym_undefined] = ACTIONS(820),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [136] = {
    [sym_import] = STATE(318),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(318),
    [sym_yield_expression] = STATE(318),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(318),
    [sym_jsx_fragment] = STATE(318),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(318),
    [sym_class] = STATE(318),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(318),
    [sym_arrow_function] = STATE(318),
    [sym_call_expression] = STATE(318),
    [sym_new_expression] = STATE(318),
    [sym_await_expression] = STATE(318),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(318),
    [sym_augmented_assignment_expression] = STATE(318),
    [sym_ternary_expression] = STATE(318),
    [sym_binary_expression] = STATE(318),
    [sym_unary_expression] = STATE(318),
    [sym_update_expression] = STATE(318),
    [sym_string] = STATE(318),
    [sym_template_string] = STATE(318),
    [sym_regex] = STATE(318),
    [sym_meta_property] = STATE(318),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(885),
    [sym_this] = ACTIONS(887),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(887),
    [sym_false] = ACTIONS(887),
    [sym_null] = ACTIONS(887),
    [sym_undefined] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [137] = {
    [sym_import] = STATE(505),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(505),
    [sym_yield_expression] = STATE(505),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(505),
    [sym_jsx_fragment] = STATE(505),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(505),
    [sym_class] = STATE(505),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(505),
    [sym_arrow_function] = STATE(505),
    [sym_call_expression] = STATE(505),
    [sym_new_expression] = STATE(505),
    [sym_await_expression] = STATE(505),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(505),
    [sym_augmented_assignment_expression] = STATE(505),
    [sym_ternary_expression] = STATE(505),
    [sym_binary_expression] = STATE(505),
    [sym_unary_expression] = STATE(505),
    [sym_update_expression] = STATE(505),
    [sym_string] = STATE(505),
    [sym_template_string] = STATE(505),
    [sym_regex] = STATE(505),
    [sym_meta_property] = STATE(505),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(889),
    [sym_this] = ACTIONS(891),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(891),
    [sym_false] = ACTIONS(891),
    [sym_null] = ACTIONS(891),
    [sym_undefined] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [138] = {
    [sym_import] = STATE(449),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(449),
    [sym_yield_expression] = STATE(449),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(449),
    [sym_jsx_fragment] = STATE(449),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(449),
    [sym_class] = STATE(449),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(449),
    [sym_arrow_function] = STATE(449),
    [sym_call_expression] = STATE(449),
    [sym_new_expression] = STATE(449),
    [sym_await_expression] = STATE(449),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(449),
    [sym_augmented_assignment_expression] = STATE(449),
    [sym_ternary_expression] = STATE(449),
    [sym_binary_expression] = STATE(449),
    [sym_unary_expression] = STATE(449),
    [sym_update_expression] = STATE(449),
    [sym_string] = STATE(449),
    [sym_template_string] = STATE(449),
    [sym_regex] = STATE(449),
    [sym_meta_property] = STATE(449),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(893),
    [sym_this] = ACTIONS(895),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(895),
    [sym_false] = ACTIONS(895),
    [sym_null] = ACTIONS(895),
    [sym_undefined] = ACTIONS(895),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [139] = {
    [sym_import] = STATE(456),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(456),
    [sym_yield_expression] = STATE(456),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(456),
    [sym_jsx_fragment] = STATE(456),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(456),
    [sym_class] = STATE(456),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(456),
    [sym_arrow_function] = STATE(456),
    [sym_call_expression] = STATE(456),
    [sym_new_expression] = STATE(456),
    [sym_await_expression] = STATE(456),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(456),
    [sym_augmented_assignment_expression] = STATE(456),
    [sym_ternary_expression] = STATE(456),
    [sym_binary_expression] = STATE(456),
    [sym_unary_expression] = STATE(456),
    [sym_update_expression] = STATE(456),
    [sym_string] = STATE(456),
    [sym_template_string] = STATE(456),
    [sym_regex] = STATE(456),
    [sym_meta_property] = STATE(456),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(897),
    [sym_this] = ACTIONS(899),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(899),
    [sym_false] = ACTIONS(899),
    [sym_null] = ACTIONS(899),
    [sym_undefined] = ACTIONS(899),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [140] = {
    [sym_import] = STATE(453),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(453),
    [sym_yield_expression] = STATE(453),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(453),
    [sym_jsx_fragment] = STATE(453),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(453),
    [sym_class] = STATE(453),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(453),
    [sym_arrow_function] = STATE(453),
    [sym_call_expression] = STATE(453),
    [sym_new_expression] = STATE(453),
    [sym_await_expression] = STATE(453),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(453),
    [sym_augmented_assignment_expression] = STATE(453),
    [sym_ternary_expression] = STATE(453),
    [sym_binary_expression] = STATE(453),
    [sym_unary_expression] = STATE(453),
    [sym_update_expression] = STATE(453),
    [sym_string] = STATE(453),
    [sym_template_string] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_meta_property] = STATE(453),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(901),
    [sym_this] = ACTIONS(903),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(903),
    [sym_false] = ACTIONS(903),
    [sym_null] = ACTIONS(903),
    [sym_undefined] = ACTIONS(903),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [141] = {
    [sym_import] = STATE(451),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(451),
    [sym_yield_expression] = STATE(451),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(451),
    [sym_jsx_fragment] = STATE(451),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(451),
    [sym_class] = STATE(451),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(451),
    [sym_arrow_function] = STATE(451),
    [sym_call_expression] = STATE(451),
    [sym_new_expression] = STATE(451),
    [sym_await_expression] = STATE(451),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(451),
    [sym_augmented_assignment_expression] = STATE(451),
    [sym_ternary_expression] = STATE(451),
    [sym_binary_expression] = STATE(451),
    [sym_unary_expression] = STATE(451),
    [sym_update_expression] = STATE(451),
    [sym_string] = STATE(451),
    [sym_template_string] = STATE(451),
    [sym_regex] = STATE(451),
    [sym_meta_property] = STATE(451),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(905),
    [sym_this] = ACTIONS(907),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(907),
    [sym_false] = ACTIONS(907),
    [sym_null] = ACTIONS(907),
    [sym_undefined] = ACTIONS(907),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [142] = {
    [sym_import] = STATE(330),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(330),
    [sym_yield_expression] = STATE(330),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(330),
    [sym_jsx_fragment] = STATE(330),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(330),
    [sym_class] = STATE(330),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(330),
    [sym_arrow_function] = STATE(330),
    [sym_call_expression] = STATE(330),
    [sym_new_expression] = STATE(330),
    [sym_await_expression] = STATE(330),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(330),
    [sym_augmented_assignment_expression] = STATE(330),
    [sym_ternary_expression] = STATE(330),
    [sym_binary_expression] = STATE(330),
    [sym_unary_expression] = STATE(330),
    [sym_update_expression] = STATE(330),
    [sym_string] = STATE(330),
    [sym_template_string] = STATE(330),
    [sym_regex] = STATE(330),
    [sym_meta_property] = STATE(330),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(909),
    [sym_this] = ACTIONS(911),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(911),
    [sym_false] = ACTIONS(911),
    [sym_null] = ACTIONS(911),
    [sym_undefined] = ACTIONS(911),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [143] = {
    [sym_import] = STATE(415),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(415),
    [sym_yield_expression] = STATE(415),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(415),
    [sym_jsx_fragment] = STATE(415),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(415),
    [sym_class] = STATE(415),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(415),
    [sym_arrow_function] = STATE(415),
    [sym_call_expression] = STATE(415),
    [sym_new_expression] = STATE(415),
    [sym_await_expression] = STATE(415),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(415),
    [sym_augmented_assignment_expression] = STATE(415),
    [sym_ternary_expression] = STATE(415),
    [sym_binary_expression] = STATE(415),
    [sym_unary_expression] = STATE(415),
    [sym_update_expression] = STATE(415),
    [sym_string] = STATE(415),
    [sym_template_string] = STATE(415),
    [sym_regex] = STATE(415),
    [sym_meta_property] = STATE(415),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(913),
    [sym_this] = ACTIONS(915),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(915),
    [sym_false] = ACTIONS(915),
    [sym_null] = ACTIONS(915),
    [sym_undefined] = ACTIONS(915),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [144] = {
    [sym_import] = STATE(390),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(390),
    [sym_yield_expression] = STATE(390),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(390),
    [sym_jsx_fragment] = STATE(390),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(390),
    [sym_class] = STATE(390),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(390),
    [sym_arrow_function] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_new_expression] = STATE(390),
    [sym_await_expression] = STATE(390),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(390),
    [sym_augmented_assignment_expression] = STATE(390),
    [sym_ternary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_string] = STATE(390),
    [sym_template_string] = STATE(390),
    [sym_regex] = STATE(390),
    [sym_meta_property] = STATE(390),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(917),
    [sym_this] = ACTIONS(919),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_null] = ACTIONS(919),
    [sym_undefined] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [145] = {
    [sym_import] = STATE(354),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(354),
    [sym_yield_expression] = STATE(354),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(354),
    [sym_jsx_fragment] = STATE(354),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(354),
    [sym_class] = STATE(354),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(354),
    [sym_arrow_function] = STATE(354),
    [sym_call_expression] = STATE(354),
    [sym_new_expression] = STATE(354),
    [sym_await_expression] = STATE(354),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(354),
    [sym_augmented_assignment_expression] = STATE(354),
    [sym_ternary_expression] = STATE(354),
    [sym_binary_expression] = STATE(354),
    [sym_unary_expression] = STATE(354),
    [sym_update_expression] = STATE(354),
    [sym_string] = STATE(354),
    [sym_template_string] = STATE(354),
    [sym_regex] = STATE(354),
    [sym_meta_property] = STATE(354),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(921),
    [sym_this] = ACTIONS(923),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(923),
    [sym_false] = ACTIONS(923),
    [sym_null] = ACTIONS(923),
    [sym_undefined] = ACTIONS(923),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [146] = {
    [sym_import] = STATE(564),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(564),
    [sym_yield_expression] = STATE(564),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(564),
    [sym_jsx_fragment] = STATE(564),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(564),
    [sym_class] = STATE(564),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(564),
    [sym_arrow_function] = STATE(564),
    [sym_call_expression] = STATE(564),
    [sym_new_expression] = STATE(564),
    [sym_await_expression] = STATE(564),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(564),
    [sym_augmented_assignment_expression] = STATE(564),
    [sym_ternary_expression] = STATE(564),
    [sym_binary_expression] = STATE(564),
    [sym_unary_expression] = STATE(564),
    [sym_update_expression] = STATE(564),
    [sym_string] = STATE(564),
    [sym_template_string] = STATE(564),
    [sym_regex] = STATE(564),
    [sym_meta_property] = STATE(564),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(925),
    [sym_this] = ACTIONS(927),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(927),
    [sym_false] = ACTIONS(927),
    [sym_null] = ACTIONS(927),
    [sym_undefined] = ACTIONS(927),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [147] = {
    [sym_import] = STATE(416),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(416),
    [sym_yield_expression] = STATE(416),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(416),
    [sym_jsx_fragment] = STATE(416),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(416),
    [sym_class] = STATE(416),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(416),
    [sym_arrow_function] = STATE(416),
    [sym_call_expression] = STATE(416),
    [sym_new_expression] = STATE(416),
    [sym_await_expression] = STATE(416),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(416),
    [sym_augmented_assignment_expression] = STATE(416),
    [sym_ternary_expression] = STATE(416),
    [sym_binary_expression] = STATE(416),
    [sym_unary_expression] = STATE(416),
    [sym_update_expression] = STATE(416),
    [sym_string] = STATE(416),
    [sym_template_string] = STATE(416),
    [sym_regex] = STATE(416),
    [sym_meta_property] = STATE(416),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(929),
    [sym_this] = ACTIONS(931),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(931),
    [sym_false] = ACTIONS(931),
    [sym_null] = ACTIONS(931),
    [sym_undefined] = ACTIONS(931),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [148] = {
    [sym_import] = STATE(394),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(394),
    [sym_yield_expression] = STATE(394),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(394),
    [sym_jsx_fragment] = STATE(394),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(394),
    [sym_class] = STATE(394),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(394),
    [sym_arrow_function] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_await_expression] = STATE(394),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_string] = STATE(394),
    [sym_template_string] = STATE(394),
    [sym_regex] = STATE(394),
    [sym_meta_property] = STATE(394),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(933),
    [sym_this] = ACTIONS(935),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(935),
    [sym_false] = ACTIONS(935),
    [sym_null] = ACTIONS(935),
    [sym_undefined] = ACTIONS(935),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [149] = {
    [sym_import] = STATE(322),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(322),
    [sym_yield_expression] = STATE(322),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(322),
    [sym_jsx_fragment] = STATE(322),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(322),
    [sym_class] = STATE(322),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(322),
    [sym_arrow_function] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_new_expression] = STATE(322),
    [sym_await_expression] = STATE(322),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(322),
    [sym_augmented_assignment_expression] = STATE(322),
    [sym_ternary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_update_expression] = STATE(322),
    [sym_string] = STATE(322),
    [sym_template_string] = STATE(322),
    [sym_regex] = STATE(322),
    [sym_meta_property] = STATE(322),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(937),
    [sym_this] = ACTIONS(939),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(939),
    [sym_false] = ACTIONS(939),
    [sym_null] = ACTIONS(939),
    [sym_undefined] = ACTIONS(939),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [150] = {
    [sym_import] = STATE(565),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(565),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(565),
    [sym_arrow_function] = STATE(565),
    [sym_call_expression] = STATE(565),
    [sym_new_expression] = STATE(565),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(565),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_string] = STATE(565),
    [sym_template_string] = STATE(565),
    [sym_regex] = STATE(565),
    [sym_meta_property] = STATE(565),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(941),
    [sym_this] = ACTIONS(943),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(943),
    [sym_false] = ACTIONS(943),
    [sym_null] = ACTIONS(943),
    [sym_undefined] = ACTIONS(943),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [151] = {
    [sym_import] = STATE(323),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(323),
    [sym_yield_expression] = STATE(323),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(323),
    [sym_jsx_fragment] = STATE(323),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(323),
    [sym_class] = STATE(323),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(323),
    [sym_arrow_function] = STATE(323),
    [sym_call_expression] = STATE(323),
    [sym_new_expression] = STATE(323),
    [sym_await_expression] = STATE(323),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(323),
    [sym_augmented_assignment_expression] = STATE(323),
    [sym_ternary_expression] = STATE(323),
    [sym_binary_expression] = STATE(323),
    [sym_unary_expression] = STATE(323),
    [sym_update_expression] = STATE(323),
    [sym_string] = STATE(323),
    [sym_template_string] = STATE(323),
    [sym_regex] = STATE(323),
    [sym_meta_property] = STATE(323),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(945),
    [sym_this] = ACTIONS(947),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(947),
    [sym_false] = ACTIONS(947),
    [sym_null] = ACTIONS(947),
    [sym_undefined] = ACTIONS(947),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [152] = {
    [sym_import] = STATE(368),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(368),
    [sym_yield_expression] = STATE(368),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(368),
    [sym_jsx_fragment] = STATE(368),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(368),
    [sym_class] = STATE(368),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(368),
    [sym_arrow_function] = STATE(368),
    [sym_call_expression] = STATE(368),
    [sym_new_expression] = STATE(368),
    [sym_await_expression] = STATE(368),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(368),
    [sym_augmented_assignment_expression] = STATE(368),
    [sym_ternary_expression] = STATE(368),
    [sym_binary_expression] = STATE(368),
    [sym_unary_expression] = STATE(368),
    [sym_update_expression] = STATE(368),
    [sym_string] = STATE(368),
    [sym_template_string] = STATE(368),
    [sym_regex] = STATE(368),
    [sym_meta_property] = STATE(368),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(949),
    [sym_this] = ACTIONS(951),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(951),
    [sym_false] = ACTIONS(951),
    [sym_null] = ACTIONS(951),
    [sym_undefined] = ACTIONS(951),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [153] = {
    [sym_import] = STATE(329),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(329),
    [sym_yield_expression] = STATE(329),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(329),
    [sym_jsx_fragment] = STATE(329),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(329),
    [sym_class] = STATE(329),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(329),
    [sym_arrow_function] = STATE(329),
    [sym_call_expression] = STATE(329),
    [sym_new_expression] = STATE(329),
    [sym_await_expression] = STATE(329),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(329),
    [sym_augmented_assignment_expression] = STATE(329),
    [sym_ternary_expression] = STATE(329),
    [sym_binary_expression] = STATE(329),
    [sym_unary_expression] = STATE(329),
    [sym_update_expression] = STATE(329),
    [sym_string] = STATE(329),
    [sym_template_string] = STATE(329),
    [sym_regex] = STATE(329),
    [sym_meta_property] = STATE(329),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(953),
    [sym_this] = ACTIONS(955),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(955),
    [sym_false] = ACTIONS(955),
    [sym_null] = ACTIONS(955),
    [sym_undefined] = ACTIONS(955),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [154] = {
    [sym_import] = STATE(317),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(317),
    [sym_yield_expression] = STATE(317),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(317),
    [sym_jsx_fragment] = STATE(317),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(317),
    [sym_class] = STATE(317),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(317),
    [sym_arrow_function] = STATE(317),
    [sym_call_expression] = STATE(317),
    [sym_new_expression] = STATE(317),
    [sym_await_expression] = STATE(317),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(317),
    [sym_augmented_assignment_expression] = STATE(317),
    [sym_ternary_expression] = STATE(317),
    [sym_binary_expression] = STATE(317),
    [sym_unary_expression] = STATE(317),
    [sym_update_expression] = STATE(317),
    [sym_string] = STATE(317),
    [sym_template_string] = STATE(317),
    [sym_regex] = STATE(317),
    [sym_meta_property] = STATE(317),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(957),
    [sym_this] = ACTIONS(959),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(959),
    [sym_false] = ACTIONS(959),
    [sym_null] = ACTIONS(959),
    [sym_undefined] = ACTIONS(959),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [155] = {
    [sym_import] = STATE(328),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(328),
    [sym_yield_expression] = STATE(328),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(328),
    [sym_jsx_fragment] = STATE(328),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(328),
    [sym_class] = STATE(328),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(328),
    [sym_arrow_function] = STATE(328),
    [sym_call_expression] = STATE(328),
    [sym_new_expression] = STATE(328),
    [sym_await_expression] = STATE(328),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(328),
    [sym_augmented_assignment_expression] = STATE(328),
    [sym_ternary_expression] = STATE(328),
    [sym_binary_expression] = STATE(328),
    [sym_unary_expression] = STATE(328),
    [sym_update_expression] = STATE(328),
    [sym_string] = STATE(328),
    [sym_template_string] = STATE(328),
    [sym_regex] = STATE(328),
    [sym_meta_property] = STATE(328),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(961),
    [sym_this] = ACTIONS(963),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(963),
    [sym_false] = ACTIONS(963),
    [sym_null] = ACTIONS(963),
    [sym_undefined] = ACTIONS(963),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [156] = {
    [sym_import] = STATE(327),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(327),
    [sym_yield_expression] = STATE(327),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(327),
    [sym_jsx_fragment] = STATE(327),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(327),
    [sym_class] = STATE(327),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(327),
    [sym_arrow_function] = STATE(327),
    [sym_call_expression] = STATE(327),
    [sym_new_expression] = STATE(327),
    [sym_await_expression] = STATE(327),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(327),
    [sym_augmented_assignment_expression] = STATE(327),
    [sym_ternary_expression] = STATE(327),
    [sym_binary_expression] = STATE(327),
    [sym_unary_expression] = STATE(327),
    [sym_update_expression] = STATE(327),
    [sym_string] = STATE(327),
    [sym_template_string] = STATE(327),
    [sym_regex] = STATE(327),
    [sym_meta_property] = STATE(327),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(965),
    [sym_this] = ACTIONS(967),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(967),
    [sym_false] = ACTIONS(967),
    [sym_null] = ACTIONS(967),
    [sym_undefined] = ACTIONS(967),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [157] = {
    [sym_import] = STATE(374),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(374),
    [sym_yield_expression] = STATE(374),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(374),
    [sym_jsx_fragment] = STATE(374),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(374),
    [sym_class] = STATE(374),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(374),
    [sym_arrow_function] = STATE(374),
    [sym_call_expression] = STATE(374),
    [sym_new_expression] = STATE(374),
    [sym_await_expression] = STATE(374),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(374),
    [sym_augmented_assignment_expression] = STATE(374),
    [sym_ternary_expression] = STATE(374),
    [sym_binary_expression] = STATE(374),
    [sym_unary_expression] = STATE(374),
    [sym_update_expression] = STATE(374),
    [sym_string] = STATE(374),
    [sym_template_string] = STATE(374),
    [sym_regex] = STATE(374),
    [sym_meta_property] = STATE(374),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(969),
    [sym_this] = ACTIONS(971),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(971),
    [sym_false] = ACTIONS(971),
    [sym_null] = ACTIONS(971),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [158] = {
    [sym_import] = STATE(500),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(500),
    [sym_yield_expression] = STATE(500),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(500),
    [sym_jsx_fragment] = STATE(500),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(500),
    [sym_class] = STATE(500),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(500),
    [sym_arrow_function] = STATE(500),
    [sym_call_expression] = STATE(500),
    [sym_new_expression] = STATE(500),
    [sym_await_expression] = STATE(500),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(500),
    [sym_augmented_assignment_expression] = STATE(500),
    [sym_ternary_expression] = STATE(500),
    [sym_binary_expression] = STATE(500),
    [sym_unary_expression] = STATE(500),
    [sym_update_expression] = STATE(500),
    [sym_string] = STATE(500),
    [sym_template_string] = STATE(500),
    [sym_regex] = STATE(500),
    [sym_meta_property] = STATE(500),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(973),
    [sym_this] = ACTIONS(975),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(975),
    [sym_false] = ACTIONS(975),
    [sym_null] = ACTIONS(975),
    [sym_undefined] = ACTIONS(975),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [159] = {
    [sym_import] = STATE(405),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(405),
    [sym_yield_expression] = STATE(405),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(405),
    [sym_jsx_fragment] = STATE(405),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(405),
    [sym_class] = STATE(405),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(405),
    [sym_arrow_function] = STATE(405),
    [sym_call_expression] = STATE(405),
    [sym_new_expression] = STATE(405),
    [sym_await_expression] = STATE(405),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(405),
    [sym_augmented_assignment_expression] = STATE(405),
    [sym_ternary_expression] = STATE(405),
    [sym_binary_expression] = STATE(405),
    [sym_unary_expression] = STATE(405),
    [sym_update_expression] = STATE(405),
    [sym_string] = STATE(405),
    [sym_template_string] = STATE(405),
    [sym_regex] = STATE(405),
    [sym_meta_property] = STATE(405),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(977),
    [sym_this] = ACTIONS(979),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(979),
    [sym_false] = ACTIONS(979),
    [sym_null] = ACTIONS(979),
    [sym_undefined] = ACTIONS(979),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [160] = {
    [sym_import] = STATE(499),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(499),
    [sym_yield_expression] = STATE(499),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(499),
    [sym_jsx_fragment] = STATE(499),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(499),
    [sym_class] = STATE(499),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(499),
    [sym_arrow_function] = STATE(499),
    [sym_call_expression] = STATE(499),
    [sym_new_expression] = STATE(499),
    [sym_await_expression] = STATE(499),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(499),
    [sym_augmented_assignment_expression] = STATE(499),
    [sym_ternary_expression] = STATE(499),
    [sym_binary_expression] = STATE(499),
    [sym_unary_expression] = STATE(499),
    [sym_update_expression] = STATE(499),
    [sym_string] = STATE(499),
    [sym_template_string] = STATE(499),
    [sym_regex] = STATE(499),
    [sym_meta_property] = STATE(499),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(981),
    [sym_this] = ACTIONS(983),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_null] = ACTIONS(983),
    [sym_undefined] = ACTIONS(983),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [161] = {
    [sym_import] = STATE(498),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(498),
    [sym_yield_expression] = STATE(498),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(498),
    [sym_jsx_fragment] = STATE(498),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(498),
    [sym_class] = STATE(498),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(498),
    [sym_arrow_function] = STATE(498),
    [sym_call_expression] = STATE(498),
    [sym_new_expression] = STATE(498),
    [sym_await_expression] = STATE(498),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(498),
    [sym_augmented_assignment_expression] = STATE(498),
    [sym_ternary_expression] = STATE(498),
    [sym_binary_expression] = STATE(498),
    [sym_unary_expression] = STATE(498),
    [sym_update_expression] = STATE(498),
    [sym_string] = STATE(498),
    [sym_template_string] = STATE(498),
    [sym_regex] = STATE(498),
    [sym_meta_property] = STATE(498),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(985),
    [sym_this] = ACTIONS(987),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(987),
    [sym_false] = ACTIONS(987),
    [sym_null] = ACTIONS(987),
    [sym_undefined] = ACTIONS(987),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [162] = {
    [sym_import] = STATE(497),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(497),
    [sym_yield_expression] = STATE(497),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(497),
    [sym_jsx_fragment] = STATE(497),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(497),
    [sym_class] = STATE(497),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(497),
    [sym_arrow_function] = STATE(497),
    [sym_call_expression] = STATE(497),
    [sym_new_expression] = STATE(497),
    [sym_await_expression] = STATE(497),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_ternary_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_unary_expression] = STATE(497),
    [sym_update_expression] = STATE(497),
    [sym_string] = STATE(497),
    [sym_template_string] = STATE(497),
    [sym_regex] = STATE(497),
    [sym_meta_property] = STATE(497),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(989),
    [sym_this] = ACTIONS(991),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(991),
    [sym_false] = ACTIONS(991),
    [sym_null] = ACTIONS(991),
    [sym_undefined] = ACTIONS(991),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [163] = {
    [sym_import] = STATE(321),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(321),
    [sym_yield_expression] = STATE(321),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(321),
    [sym_jsx_fragment] = STATE(321),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(321),
    [sym_class] = STATE(321),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(321),
    [sym_arrow_function] = STATE(321),
    [sym_call_expression] = STATE(321),
    [sym_new_expression] = STATE(321),
    [sym_await_expression] = STATE(321),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(321),
    [sym_augmented_assignment_expression] = STATE(321),
    [sym_ternary_expression] = STATE(321),
    [sym_binary_expression] = STATE(321),
    [sym_unary_expression] = STATE(321),
    [sym_update_expression] = STATE(321),
    [sym_string] = STATE(321),
    [sym_template_string] = STATE(321),
    [sym_regex] = STATE(321),
    [sym_meta_property] = STATE(321),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(993),
    [sym_this] = ACTIONS(995),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(995),
    [sym_false] = ACTIONS(995),
    [sym_null] = ACTIONS(995),
    [sym_undefined] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [164] = {
    [sym_import] = STATE(408),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(408),
    [sym_yield_expression] = STATE(408),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(408),
    [sym_jsx_fragment] = STATE(408),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(408),
    [sym_class] = STATE(408),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(408),
    [sym_arrow_function] = STATE(408),
    [sym_call_expression] = STATE(408),
    [sym_new_expression] = STATE(408),
    [sym_await_expression] = STATE(408),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(408),
    [sym_augmented_assignment_expression] = STATE(408),
    [sym_ternary_expression] = STATE(408),
    [sym_binary_expression] = STATE(408),
    [sym_unary_expression] = STATE(408),
    [sym_update_expression] = STATE(408),
    [sym_string] = STATE(408),
    [sym_template_string] = STATE(408),
    [sym_regex] = STATE(408),
    [sym_meta_property] = STATE(408),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(997),
    [sym_this] = ACTIONS(999),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(999),
    [sym_false] = ACTIONS(999),
    [sym_null] = ACTIONS(999),
    [sym_undefined] = ACTIONS(999),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [165] = {
    [sym_import] = STATE(569),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(569),
    [sym_yield_expression] = STATE(569),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(569),
    [sym_jsx_fragment] = STATE(569),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(569),
    [sym_class] = STATE(569),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(569),
    [sym_arrow_function] = STATE(569),
    [sym_call_expression] = STATE(569),
    [sym_new_expression] = STATE(569),
    [sym_await_expression] = STATE(569),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(569),
    [sym_augmented_assignment_expression] = STATE(569),
    [sym_ternary_expression] = STATE(569),
    [sym_binary_expression] = STATE(569),
    [sym_unary_expression] = STATE(569),
    [sym_update_expression] = STATE(569),
    [sym_string] = STATE(569),
    [sym_template_string] = STATE(569),
    [sym_regex] = STATE(569),
    [sym_meta_property] = STATE(569),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(1001),
    [sym_this] = ACTIONS(1003),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(1003),
    [sym_false] = ACTIONS(1003),
    [sym_null] = ACTIONS(1003),
    [sym_undefined] = ACTIONS(1003),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [166] = {
    [sym_import] = STATE(410),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(410),
    [sym_yield_expression] = STATE(410),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(410),
    [sym_jsx_fragment] = STATE(410),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(410),
    [sym_class] = STATE(410),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(410),
    [sym_arrow_function] = STATE(410),
    [sym_call_expression] = STATE(410),
    [sym_new_expression] = STATE(410),
    [sym_await_expression] = STATE(410),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(410),
    [sym_augmented_assignment_expression] = STATE(410),
    [sym_ternary_expression] = STATE(410),
    [sym_binary_expression] = STATE(410),
    [sym_unary_expression] = STATE(410),
    [sym_update_expression] = STATE(410),
    [sym_string] = STATE(410),
    [sym_template_string] = STATE(410),
    [sym_regex] = STATE(410),
    [sym_meta_property] = STATE(410),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(1005),
    [sym_this] = ACTIONS(1007),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(1007),
    [sym_false] = ACTIONS(1007),
    [sym_null] = ACTIONS(1007),
    [sym_undefined] = ACTIONS(1007),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [167] = {
    [sym_import] = STATE(411),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(411),
    [sym_yield_expression] = STATE(411),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(411),
    [sym_jsx_fragment] = STATE(411),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(411),
    [sym_class] = STATE(411),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(411),
    [sym_arrow_function] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_new_expression] = STATE(411),
    [sym_await_expression] = STATE(411),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(411),
    [sym_augmented_assignment_expression] = STATE(411),
    [sym_ternary_expression] = STATE(411),
    [sym_binary_expression] = STATE(411),
    [sym_unary_expression] = STATE(411),
    [sym_update_expression] = STATE(411),
    [sym_string] = STATE(411),
    [sym_template_string] = STATE(411),
    [sym_regex] = STATE(411),
    [sym_meta_property] = STATE(411),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(1009),
    [sym_this] = ACTIONS(1011),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(1011),
    [sym_false] = ACTIONS(1011),
    [sym_null] = ACTIONS(1011),
    [sym_undefined] = ACTIONS(1011),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [168] = {
    [sym_import] = STATE(412),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(412),
    [sym_yield_expression] = STATE(412),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(412),
    [sym_jsx_fragment] = STATE(412),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(412),
    [sym_class] = STATE(412),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(412),
    [sym_arrow_function] = STATE(412),
    [sym_call_expression] = STATE(412),
    [sym_new_expression] = STATE(412),
    [sym_await_expression] = STATE(412),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(412),
    [sym_augmented_assignment_expression] = STATE(412),
    [sym_ternary_expression] = STATE(412),
    [sym_binary_expression] = STATE(412),
    [sym_unary_expression] = STATE(412),
    [sym_update_expression] = STATE(412),
    [sym_string] = STATE(412),
    [sym_template_string] = STATE(412),
    [sym_regex] = STATE(412),
    [sym_meta_property] = STATE(412),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(1013),
    [sym_this] = ACTIONS(1015),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(1015),
    [sym_false] = ACTIONS(1015),
    [sym_null] = ACTIONS(1015),
    [sym_undefined] = ACTIONS(1015),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [169] = {
    [sym_import] = STATE(413),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(413),
    [sym_yield_expression] = STATE(413),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(413),
    [sym_jsx_fragment] = STATE(413),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(413),
    [sym_class] = STATE(413),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(413),
    [sym_arrow_function] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_new_expression] = STATE(413),
    [sym_await_expression] = STATE(413),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(413),
    [sym_augmented_assignment_expression] = STATE(413),
    [sym_ternary_expression] = STATE(413),
    [sym_binary_expression] = STATE(413),
    [sym_unary_expression] = STATE(413),
    [sym_update_expression] = STATE(413),
    [sym_string] = STATE(413),
    [sym_template_string] = STATE(413),
    [sym_regex] = STATE(413),
    [sym_meta_property] = STATE(413),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(1017),
    [sym_this] = ACTIONS(1019),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(1019),
    [sym_false] = ACTIONS(1019),
    [sym_null] = ACTIONS(1019),
    [sym_undefined] = ACTIONS(1019),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [170] = {
    [sym_import] = STATE(355),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(355),
    [sym_yield_expression] = STATE(355),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(355),
    [sym_jsx_fragment] = STATE(355),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(355),
    [sym_class] = STATE(355),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(355),
    [sym_arrow_function] = STATE(355),
    [sym_call_expression] = STATE(355),
    [sym_new_expression] = STATE(355),
    [sym_await_expression] = STATE(355),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(355),
    [sym_augmented_assignment_expression] = STATE(355),
    [sym_ternary_expression] = STATE(355),
    [sym_binary_expression] = STATE(355),
    [sym_unary_expression] = STATE(355),
    [sym_update_expression] = STATE(355),
    [sym_string] = STATE(355),
    [sym_template_string] = STATE(355),
    [sym_regex] = STATE(355),
    [sym_meta_property] = STATE(355),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(1021),
    [sym_this] = ACTIONS(1023),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(1023),
    [sym_false] = ACTIONS(1023),
    [sym_null] = ACTIONS(1023),
    [sym_undefined] = ACTIONS(1023),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [171] = {
    [sym_import] = STATE(339),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(339),
    [sym_yield_expression] = STATE(339),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(339),
    [sym_jsx_fragment] = STATE(339),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(339),
    [sym_class] = STATE(339),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(339),
    [sym_arrow_function] = STATE(339),
    [sym_call_expression] = STATE(339),
    [sym_new_expression] = STATE(339),
    [sym_await_expression] = STATE(339),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(339),
    [sym_augmented_assignment_expression] = STATE(339),
    [sym_ternary_expression] = STATE(339),
    [sym_binary_expression] = STATE(339),
    [sym_unary_expression] = STATE(339),
    [sym_update_expression] = STATE(339),
    [sym_string] = STATE(339),
    [sym_template_string] = STATE(339),
    [sym_regex] = STATE(339),
    [sym_meta_property] = STATE(339),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(1025),
    [sym_this] = ACTIONS(1027),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(1027),
    [sym_false] = ACTIONS(1027),
    [sym_null] = ACTIONS(1027),
    [sym_undefined] = ACTIONS(1027),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [172] = {
    [sym_import] = STATE(342),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(342),
    [sym_yield_expression] = STATE(342),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(342),
    [sym_jsx_fragment] = STATE(342),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(342),
    [sym_class] = STATE(342),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(342),
    [sym_arrow_function] = STATE(342),
    [sym_call_expression] = STATE(342),
    [sym_new_expression] = STATE(342),
    [sym_await_expression] = STATE(342),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(342),
    [sym_augmented_assignment_expression] = STATE(342),
    [sym_ternary_expression] = STATE(342),
    [sym_binary_expression] = STATE(342),
    [sym_unary_expression] = STATE(342),
    [sym_update_expression] = STATE(342),
    [sym_string] = STATE(342),
    [sym_template_string] = STATE(342),
    [sym_regex] = STATE(342),
    [sym_meta_property] = STATE(342),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(1029),
    [sym_this] = ACTIONS(1031),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(1031),
    [sym_false] = ACTIONS(1031),
    [sym_null] = ACTIONS(1031),
    [sym_undefined] = ACTIONS(1031),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [173] = {
    [sym_import] = STATE(353),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(353),
    [sym_yield_expression] = STATE(353),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(353),
    [sym_jsx_fragment] = STATE(353),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(353),
    [sym_class] = STATE(353),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(353),
    [sym_arrow_function] = STATE(353),
    [sym_call_expression] = STATE(353),
    [sym_new_expression] = STATE(353),
    [sym_await_expression] = STATE(353),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(353),
    [sym_augmented_assignment_expression] = STATE(353),
    [sym_ternary_expression] = STATE(353),
    [sym_binary_expression] = STATE(353),
    [sym_unary_expression] = STATE(353),
    [sym_update_expression] = STATE(353),
    [sym_string] = STATE(353),
    [sym_template_string] = STATE(353),
    [sym_regex] = STATE(353),
    [sym_meta_property] = STATE(353),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(1033),
    [sym_this] = ACTIONS(1035),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(1035),
    [sym_false] = ACTIONS(1035),
    [sym_null] = ACTIONS(1035),
    [sym_undefined] = ACTIONS(1035),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [174] = {
    [sym_import] = STATE(344),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(344),
    [sym_yield_expression] = STATE(344),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(344),
    [sym_jsx_fragment] = STATE(344),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(344),
    [sym_class] = STATE(344),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(344),
    [sym_arrow_function] = STATE(344),
    [sym_call_expression] = STATE(344),
    [sym_new_expression] = STATE(344),
    [sym_await_expression] = STATE(344),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(344),
    [sym_augmented_assignment_expression] = STATE(344),
    [sym_ternary_expression] = STATE(344),
    [sym_binary_expression] = STATE(344),
    [sym_unary_expression] = STATE(344),
    [sym_update_expression] = STATE(344),
    [sym_string] = STATE(344),
    [sym_template_string] = STATE(344),
    [sym_regex] = STATE(344),
    [sym_meta_property] = STATE(344),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(1037),
    [sym_this] = ACTIONS(1039),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(1039),
    [sym_false] = ACTIONS(1039),
    [sym_null] = ACTIONS(1039),
    [sym_undefined] = ACTIONS(1039),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [175] = {
    [sym_import] = STATE(333),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(333),
    [sym_yield_expression] = STATE(333),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(333),
    [sym_jsx_fragment] = STATE(333),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(333),
    [sym_class] = STATE(333),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(333),
    [sym_arrow_function] = STATE(333),
    [sym_call_expression] = STATE(333),
    [sym_new_expression] = STATE(333),
    [sym_await_expression] = STATE(333),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(333),
    [sym_augmented_assignment_expression] = STATE(333),
    [sym_ternary_expression] = STATE(333),
    [sym_binary_expression] = STATE(333),
    [sym_unary_expression] = STATE(333),
    [sym_update_expression] = STATE(333),
    [sym_string] = STATE(333),
    [sym_template_string] = STATE(333),
    [sym_regex] = STATE(333),
    [sym_meta_property] = STATE(333),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(1041),
    [sym_this] = ACTIONS(1043),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(1043),
    [sym_false] = ACTIONS(1043),
    [sym_null] = ACTIONS(1043),
    [sym_undefined] = ACTIONS(1043),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [176] = {
    [sym_import] = STATE(352),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(352),
    [sym_yield_expression] = STATE(352),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(352),
    [sym_jsx_fragment] = STATE(352),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(352),
    [sym_class] = STATE(352),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(352),
    [sym_arrow_function] = STATE(352),
    [sym_call_expression] = STATE(352),
    [sym_new_expression] = STATE(352),
    [sym_await_expression] = STATE(352),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(352),
    [sym_augmented_assignment_expression] = STATE(352),
    [sym_ternary_expression] = STATE(352),
    [sym_binary_expression] = STATE(352),
    [sym_unary_expression] = STATE(352),
    [sym_update_expression] = STATE(352),
    [sym_string] = STATE(352),
    [sym_template_string] = STATE(352),
    [sym_regex] = STATE(352),
    [sym_meta_property] = STATE(352),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(1045),
    [sym_this] = ACTIONS(1047),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(1047),
    [sym_false] = ACTIONS(1047),
    [sym_null] = ACTIONS(1047),
    [sym_undefined] = ACTIONS(1047),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [177] = {
    [sym_import] = STATE(351),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(351),
    [sym_yield_expression] = STATE(351),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(351),
    [sym_jsx_fragment] = STATE(351),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(351),
    [sym_class] = STATE(351),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(351),
    [sym_arrow_function] = STATE(351),
    [sym_call_expression] = STATE(351),
    [sym_new_expression] = STATE(351),
    [sym_await_expression] = STATE(351),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(351),
    [sym_augmented_assignment_expression] = STATE(351),
    [sym_ternary_expression] = STATE(351),
    [sym_binary_expression] = STATE(351),
    [sym_unary_expression] = STATE(351),
    [sym_update_expression] = STATE(351),
    [sym_string] = STATE(351),
    [sym_template_string] = STATE(351),
    [sym_regex] = STATE(351),
    [sym_meta_property] = STATE(351),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(1049),
    [sym_this] = ACTIONS(1051),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(1051),
    [sym_false] = ACTIONS(1051),
    [sym_null] = ACTIONS(1051),
    [sym_undefined] = ACTIONS(1051),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [178] = {
    [sym_import] = STATE(414),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(414),
    [sym_yield_expression] = STATE(414),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(414),
    [sym_jsx_fragment] = STATE(414),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(414),
    [sym_class] = STATE(414),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(414),
    [sym_arrow_function] = STATE(414),
    [sym_call_expression] = STATE(414),
    [sym_new_expression] = STATE(414),
    [sym_await_expression] = STATE(414),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(414),
    [sym_augmented_assignment_expression] = STATE(414),
    [sym_ternary_expression] = STATE(414),
    [sym_binary_expression] = STATE(414),
    [sym_unary_expression] = STATE(414),
    [sym_update_expression] = STATE(414),
    [sym_string] = STATE(414),
    [sym_template_string] = STATE(414),
    [sym_regex] = STATE(414),
    [sym_meta_property] = STATE(414),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_LBRACE] = ACTIONS(372),
    [anon_sym_import] = ACTIONS(374),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(378),
    [anon_sym_async] = ACTIONS(380),
    [anon_sym_function] = ACTIONS(382),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(1053),
    [sym_this] = ACTIONS(1055),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(1055),
    [sym_false] = ACTIONS(1055),
    [sym_null] = ACTIONS(1055),
    [sym_undefined] = ACTIONS(1055),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(390),
    [anon_sym_get] = ACTIONS(390),
    [anon_sym_set] = ACTIONS(390),
  },
  [179] = {
    [sym_import] = STATE(332),
    [sym_parenthesized_expression] = STATE(278),
    [sym__expression] = STATE(332),
    [sym_yield_expression] = STATE(332),
    [sym_object] = STATE(358),
    [sym_array] = STATE(359),
    [sym_jsx_element] = STATE(332),
    [sym_jsx_fragment] = STATE(332),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(332),
    [sym_class] = STATE(332),
    [sym_function] = STATE(331),
    [sym_generator_function] = STATE(332),
    [sym_arrow_function] = STATE(332),
    [sym_call_expression] = STATE(332),
    [sym_new_expression] = STATE(332),
    [sym_await_expression] = STATE(332),
    [sym_member_expression] = STATE(278),
    [sym_subscript_expression] = STATE(278),
    [sym_assignment_expression] = STATE(332),
    [sym_augmented_assignment_expression] = STATE(332),
    [sym_ternary_expression] = STATE(332),
    [sym_binary_expression] = STATE(332),
    [sym_unary_expression] = STATE(332),
    [sym_update_expression] = STATE(332),
    [sym_string] = STATE(332),
    [sym_template_string] = STATE(332),
    [sym_regex] = STATE(332),
    [sym_meta_property] = STATE(332),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(312),
    [anon_sym_LBRACE] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_await] = ACTIONS(324),
    [anon_sym_yield] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(330),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_SLASH] = ACTIONS(334),
    [anon_sym_class] = ACTIONS(336),
    [anon_sym_async] = ACTIONS(338),
    [anon_sym_function] = ACTIONS(340),
    [anon_sym_new] = ACTIONS(342),
    [anon_sym_PLUS] = ACTIONS(344),
    [anon_sym_DASH] = ACTIONS(344),
    [anon_sym_BANG] = ACTIONS(348),
    [anon_sym_TILDE] = ACTIONS(348),
    [anon_sym_typeof] = ACTIONS(350),
    [anon_sym_void] = ACTIONS(350),
    [anon_sym_delete] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(352),
    [anon_sym_DASH_DASH] = ACTIONS(352),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(358),
    [sym_number] = ACTIONS(1057),
    [sym_this] = ACTIONS(1059),
    [sym_super] = ACTIONS(364),
    [sym_true] = ACTIONS(1059),
    [sym_false] = ACTIONS(1059),
    [sym_null] = ACTIONS(1059),
    [sym_undefined] = ACTIONS(1059),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(366),
    [anon_sym_get] = ACTIONS(366),
    [anon_sym_set] = ACTIONS(366),
  },
  [180] = {
    [sym_string] = STATE(1015),
    [sym__property_name] = STATE(1015),
    [sym_computed_property_name] = STATE(1015),
    [aux_sym_object_repeat1] = STATE(870),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_COMMA] = ACTIONS(851),
    [anon_sym_RBRACE] = ACTIONS(853),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_in] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(851),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(864),
    [anon_sym_LBRACK] = ACTIONS(866),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(869),
    [anon_sym_async] = ACTIONS(1066),
    [anon_sym_EQ_GT] = ACTIONS(875),
    [anon_sym_PLUS_EQ] = ACTIONS(877),
    [anon_sym_DASH_EQ] = ACTIONS(877),
    [anon_sym_STAR_EQ] = ACTIONS(877),
    [anon_sym_SLASH_EQ] = ACTIONS(877),
    [anon_sym_PERCENT_EQ] = ACTIONS(877),
    [anon_sym_CARET_EQ] = ACTIONS(877),
    [anon_sym_AMP_EQ] = ACTIONS(877),
    [anon_sym_PIPE_EQ] = ACTIONS(877),
    [anon_sym_GT_GT_EQ] = ACTIONS(877),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(877),
    [anon_sym_LT_LT_EQ] = ACTIONS(877),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(877),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(877),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(877),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_GT_GT_GT] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_PIPE] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_STAR_STAR] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(851),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_QMARK_QMARK] = ACTIONS(859),
    [anon_sym_instanceof] = ACTIONS(859),
    [anon_sym_PLUS_PLUS] = ACTIONS(851),
    [anon_sym_DASH_DASH] = ACTIONS(851),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(851),
    [sym_number] = ACTIONS(879),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_get] = ACTIONS(1068),
    [anon_sym_set] = ACTIONS(1068),
    [sym__automatic_semicolon] = ACTIONS(851),
  },
  [181] = {
    [sym_string] = STATE(1015),
    [sym__property_name] = STATE(1015),
    [sym_computed_property_name] = STATE(1015),
    [aux_sym_object_repeat1] = STATE(838),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(848),
    [anon_sym_COMMA] = ACTIONS(851),
    [anon_sym_RBRACE] = ACTIONS(883),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_in] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(851),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(864),
    [anon_sym_LBRACK] = ACTIONS(866),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(869),
    [anon_sym_async] = ACTIONS(1066),
    [anon_sym_EQ_GT] = ACTIONS(875),
    [anon_sym_PLUS_EQ] = ACTIONS(877),
    [anon_sym_DASH_EQ] = ACTIONS(877),
    [anon_sym_STAR_EQ] = ACTIONS(877),
    [anon_sym_SLASH_EQ] = ACTIONS(877),
    [anon_sym_PERCENT_EQ] = ACTIONS(877),
    [anon_sym_CARET_EQ] = ACTIONS(877),
    [anon_sym_AMP_EQ] = ACTIONS(877),
    [anon_sym_PIPE_EQ] = ACTIONS(877),
    [anon_sym_GT_GT_EQ] = ACTIONS(877),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(877),
    [anon_sym_LT_LT_EQ] = ACTIONS(877),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(877),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(877),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(877),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_GT_GT_GT] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_PIPE] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_STAR_STAR] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(851),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_QMARK_QMARK] = ACTIONS(859),
    [anon_sym_instanceof] = ACTIONS(859),
    [anon_sym_PLUS_PLUS] = ACTIONS(851),
    [anon_sym_DASH_DASH] = ACTIONS(851),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(851),
    [sym_number] = ACTIONS(879),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_get] = ACTIONS(1068),
    [anon_sym_set] = ACTIONS(1068),
    [sym__automatic_semicolon] = ACTIONS(851),
  },
  [182] = {
    [sym_string] = STATE(1015),
    [sym__property_name] = STATE(1015),
    [sym_computed_property_name] = STATE(1015),
    [aux_sym_object_repeat1] = STATE(838),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(851),
    [anon_sym_RBRACE] = ACTIONS(883),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_in] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(851),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(864),
    [anon_sym_LBRACK] = ACTIONS(866),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(869),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_EQ_GT] = ACTIONS(875),
    [anon_sym_PLUS_EQ] = ACTIONS(877),
    [anon_sym_DASH_EQ] = ACTIONS(877),
    [anon_sym_STAR_EQ] = ACTIONS(877),
    [anon_sym_SLASH_EQ] = ACTIONS(877),
    [anon_sym_PERCENT_EQ] = ACTIONS(877),
    [anon_sym_CARET_EQ] = ACTIONS(877),
    [anon_sym_AMP_EQ] = ACTIONS(877),
    [anon_sym_PIPE_EQ] = ACTIONS(877),
    [anon_sym_GT_GT_EQ] = ACTIONS(877),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(877),
    [anon_sym_LT_LT_EQ] = ACTIONS(877),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(877),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(877),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(877),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_GT_GT_GT] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_PIPE] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_STAR_STAR] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(851),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_QMARK_QMARK] = ACTIONS(859),
    [anon_sym_instanceof] = ACTIONS(859),
    [anon_sym_PLUS_PLUS] = ACTIONS(851),
    [anon_sym_DASH_DASH] = ACTIONS(851),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(851),
    [sym_number] = ACTIONS(879),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_set] = ACTIONS(1061),
    [sym__automatic_semicolon] = ACTIONS(851),
  },
  [183] = {
    [sym_string] = STATE(1015),
    [sym__property_name] = STATE(1015),
    [sym_computed_property_name] = STATE(1015),
    [aux_sym_object_repeat1] = STATE(870),
    [sym_identifier] = ACTIONS(1061),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_COMMA] = ACTIONS(851),
    [anon_sym_RBRACE] = ACTIONS(853),
    [anon_sym_LPAREN] = ACTIONS(1063),
    [anon_sym_in] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(851),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(864),
    [anon_sym_LBRACK] = ACTIONS(866),
    [anon_sym_LT] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_DOT] = ACTIONS(869),
    [anon_sym_async] = ACTIONS(1061),
    [anon_sym_EQ_GT] = ACTIONS(875),
    [anon_sym_PLUS_EQ] = ACTIONS(877),
    [anon_sym_DASH_EQ] = ACTIONS(877),
    [anon_sym_STAR_EQ] = ACTIONS(877),
    [anon_sym_SLASH_EQ] = ACTIONS(877),
    [anon_sym_PERCENT_EQ] = ACTIONS(877),
    [anon_sym_CARET_EQ] = ACTIONS(877),
    [anon_sym_AMP_EQ] = ACTIONS(877),
    [anon_sym_PIPE_EQ] = ACTIONS(877),
    [anon_sym_GT_GT_EQ] = ACTIONS(877),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(877),
    [anon_sym_LT_LT_EQ] = ACTIONS(877),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(877),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(877),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(877),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(877),
    [anon_sym_QMARK] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [anon_sym_GT_GT_GT] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_PIPE] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(859),
    [anon_sym_STAR_STAR] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(851),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(851),
    [anon_sym_GT_EQ] = ACTIONS(851),
    [anon_sym_QMARK_QMARK] = ACTIONS(859),
    [anon_sym_instanceof] = ACTIONS(859),
    [anon_sym_PLUS_PLUS] = ACTIONS(851),
    [anon_sym_DASH_DASH] = ACTIONS(851),
    [anon_sym_DQUOTE] = ACTIONS(354),
    [anon_sym_SQUOTE] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(851),
    [sym_number] = ACTIONS(879),
    [anon_sym_static] = ACTIONS(1061),
    [anon_sym_get] = ACTIONS(1061),
    [anon_sym_set] = ACTIONS(1061),
    [sym__automatic_semicolon] = ACTIONS(851),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(400), 1,
      sym__automatic_semicolon,
    ACTIONS(392), 18,
      ts_builtin_sym_end,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(394), 44,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [73] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1070), 1,
      sym_identifier,
    ACTIONS(1076), 1,
      anon_sym_EQ,
    ACTIONS(1078), 1,
      anon_sym_DOT,
    ACTIONS(1082), 1,
      anon_sym_function,
    ACTIONS(1084), 1,
      anon_sym_EQ_GT,
    STATE(407), 1,
      sym_arguments,
    STATE(1099), 1,
      sym_formal_parameters,
    ACTIONS(1080), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1074), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1086), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1072), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [162] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1088), 1,
      sym__automatic_semicolon,
    ACTIONS(494), 18,
      ts_builtin_sym_end,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(496), 44,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [235] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1070), 1,
      sym_identifier,
    ACTIONS(1076), 1,
      anon_sym_EQ,
    ACTIONS(1078), 1,
      anon_sym_DOT,
    ACTIONS(1082), 1,
      anon_sym_function,
    ACTIONS(1084), 1,
      anon_sym_EQ_GT,
    ACTIONS(1090), 1,
      anon_sym_LPAREN,
    STATE(1099), 1,
      sym_formal_parameters,
    ACTIONS(1080), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(851), 14,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1086), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(859), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [323] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1097), 1,
      anon_sym_catch,
    ACTIONS(1099), 1,
      anon_sym_finally,
    STATE(193), 1,
      sym_catch_clause,
    STATE(233), 1,
      sym_finally_clause,
    ACTIONS(1093), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1095), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 18,
      ts_builtin_sym_end,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(482), 44,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(494), 18,
      ts_builtin_sym_end,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(496), 44,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [541] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(875), 1,
      anon_sym_EQ_GT,
    ACTIONS(1076), 1,
      anon_sym_EQ,
    ACTIONS(1101), 1,
      sym_identifier,
    ACTIONS(1103), 1,
      anon_sym_DOT,
    ACTIONS(1107), 1,
      anon_sym_function,
    STATE(535), 1,
      sym_arguments,
    STATE(1126), 1,
      sym_formal_parameters,
    ACTIONS(1105), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1074), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1086), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1072), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [628] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(875), 1,
      anon_sym_EQ_GT,
    ACTIONS(1090), 1,
      anon_sym_LPAREN,
    ACTIONS(1101), 1,
      sym_identifier,
    ACTIONS(1103), 1,
      anon_sym_DOT,
    ACTIONS(1107), 1,
      anon_sym_function,
    ACTIONS(1109), 1,
      anon_sym_EQ,
    STATE(1126), 1,
      sym_formal_parameters,
    ACTIONS(1105), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(851), 12,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(877), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(859), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [714] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1099), 1,
      anon_sym_finally,
    STATE(221), 1,
      sym_finally_clause,
    ACTIONS(1111), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1113), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [786] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(873), 1,
      anon_sym_function,
    ACTIONS(875), 1,
      anon_sym_EQ_GT,
    ACTIONS(1090), 1,
      anon_sym_LPAREN,
    ACTIONS(1101), 1,
      sym_identifier,
    ACTIONS(1103), 1,
      anon_sym_DOT,
    ACTIONS(1109), 1,
      anon_sym_EQ,
    ACTIONS(1115), 1,
      anon_sym_COLON,
    STATE(1126), 1,
      sym_formal_parameters,
    ACTIONS(1105), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(851), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(877), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(859), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [874] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(875), 1,
      anon_sym_EQ_GT,
    ACTIONS(1090), 1,
      anon_sym_LPAREN,
    ACTIONS(1101), 1,
      sym_identifier,
    ACTIONS(1103), 1,
      anon_sym_DOT,
    ACTIONS(1107), 1,
      anon_sym_function,
    ACTIONS(1109), 1,
      anon_sym_EQ,
    ACTIONS(1117), 1,
      anon_sym_in,
    ACTIONS(1120), 1,
      anon_sym_of,
    STATE(1126), 1,
      sym_formal_parameters,
    ACTIONS(1105), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(851), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(877), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(859), 21,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [964] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(875), 1,
      anon_sym_EQ_GT,
    ACTIONS(1090), 1,
      anon_sym_LPAREN,
    ACTIONS(1101), 1,
      sym_identifier,
    ACTIONS(1103), 1,
      anon_sym_DOT,
    ACTIONS(1109), 1,
      anon_sym_EQ,
    ACTIONS(1122), 1,
      anon_sym_COLON,
    ACTIONS(1124), 1,
      anon_sym_function,
    STATE(1126), 1,
      sym_formal_parameters,
    ACTIONS(1105), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(851), 11,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(877), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(859), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(442), 17,
      sym__automatic_semicolon,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(444), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(494), 17,
      sym__automatic_semicolon,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(496), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1186] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1070), 1,
      sym_identifier,
    ACTIONS(1078), 1,
      anon_sym_DOT,
    ACTIONS(1082), 1,
      anon_sym_function,
    ACTIONS(1084), 1,
      anon_sym_EQ_GT,
    ACTIONS(1090), 1,
      anon_sym_LPAREN,
    ACTIONS(1126), 1,
      anon_sym_COMMA,
    ACTIONS(1129), 1,
      anon_sym_RPAREN,
    ACTIONS(1132), 1,
      anon_sym_EQ,
    STATE(817), 1,
      aux_sym_formal_parameters_repeat1,
    STATE(1099), 1,
      sym_formal_parameters,
    ACTIONS(1080), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(851), 8,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1086), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(859), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [1277] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      sym__automatic_semicolon,
    ACTIONS(446), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(448), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(456), 17,
      sym__automatic_semicolon,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(458), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1134), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1136), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(480), 17,
      sym__automatic_semicolon,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(482), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1547] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1138), 1,
      sym__automatic_semicolon,
    ACTIONS(392), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(394), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1616] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1140), 1,
      sym__automatic_semicolon,
    ACTIONS(494), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(496), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1142), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1144), 43,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_finally,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1146), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1148), 43,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_finally,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1150), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1152), 43,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_finally,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(468), 1,
      sym__automatic_semicolon,
    ACTIONS(460), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(462), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1154), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1156), 43,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_finally,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2022] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(410), 1,
      sym__automatic_semicolon,
    ACTIONS(402), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(404), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1158), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1160), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(420), 1,
      sym__automatic_semicolon,
    ACTIONS(412), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(414), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(430), 1,
      sym__automatic_semicolon,
    ACTIONS(422), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(424), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(478), 1,
      sym__automatic_semicolon,
    ACTIONS(470), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(472), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(440), 1,
      sym__automatic_semicolon,
    ACTIONS(432), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(434), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2434] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      sym__automatic_semicolon,
    ACTIONS(484), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(486), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1162), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1164), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1166), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1168), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1170), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1172), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1174), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1176), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1178), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1180), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1182), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1184), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1186), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1188), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1190), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1192), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1194), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1196), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1198), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1200), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1202), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1204), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1206), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1208), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1210), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1212), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1214), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1216), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1218), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1220), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1222), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1224), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1226), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1228), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1230), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1232), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1234), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1236), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1238), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1240), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1242), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1244), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1246), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1248), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1250), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1252), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1254), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1256), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1258), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1260), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1262), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1264), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1266), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1268), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1270), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1272), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1274), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1276), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1278), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1280), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1282), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1284), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1286), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1288), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1292), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1294), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1296), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1300), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1302), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1304), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1306), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1308), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1312), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1314), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1316), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1318), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1320), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5143] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1326), 1,
      anon_sym_else,
    ACTIONS(1322), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1324), 41,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1328), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1330), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1332), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1334), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1336), 16,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1338), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5409] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1070), 1,
      sym_identifier,
    ACTIONS(1076), 1,
      anon_sym_EQ,
    ACTIONS(1078), 1,
      anon_sym_DOT,
    ACTIONS(1082), 1,
      anon_sym_function,
    ACTIONS(1084), 1,
      anon_sym_EQ_GT,
    ACTIONS(1090), 1,
      anon_sym_LPAREN,
    ACTIONS(1340), 1,
      anon_sym_in,
    ACTIONS(1343), 1,
      anon_sym_of,
    STATE(1099), 1,
      sym_formal_parameters,
    ACTIONS(1080), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(851), 8,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1086), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(859), 21,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [5496] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1070), 1,
      sym_identifier,
    ACTIONS(1076), 1,
      anon_sym_EQ,
    ACTIONS(1078), 1,
      anon_sym_DOT,
    ACTIONS(1082), 1,
      anon_sym_function,
    ACTIONS(1084), 1,
      anon_sym_EQ_GT,
    ACTIONS(1090), 1,
      anon_sym_LPAREN,
    ACTIONS(1117), 1,
      anon_sym_in,
    ACTIONS(1120), 1,
      anon_sym_of,
    STATE(1099), 1,
      sym_formal_parameters,
    ACTIONS(1080), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(851), 8,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1086), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(859), 21,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [5583] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1351), 1,
      anon_sym_EQ,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1355), 1,
      anon_sym_EQ_GT,
    STATE(406), 1,
      sym_arguments,
    ACTIONS(1347), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1357), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1345), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5659] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1076), 1,
      anon_sym_EQ,
    ACTIONS(1078), 1,
      anon_sym_DOT,
    ACTIONS(1084), 1,
      anon_sym_EQ_GT,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    STATE(407), 1,
      sym_arguments,
    ACTIONS(1074), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1086), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1072), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5735] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(861), 1,
      anon_sym_COLON,
    ACTIONS(883), 1,
      anon_sym_RBRACE,
    ACTIONS(1363), 1,
      anon_sym_LPAREN,
    ACTIONS(1366), 1,
      anon_sym_EQ,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1370), 1,
      anon_sym_EQ_GT,
    STATE(838), 1,
      aux_sym_object_repeat1,
    ACTIONS(1361), 12,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1372), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1359), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5814] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(853), 1,
      anon_sym_RBRACE,
    ACTIONS(861), 1,
      anon_sym_COLON,
    ACTIONS(1363), 1,
      anon_sym_LPAREN,
    ACTIONS(1366), 1,
      anon_sym_EQ,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1370), 1,
      anon_sym_EQ_GT,
    STATE(870), 1,
      aux_sym_object_repeat1,
    ACTIONS(1361), 12,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1372), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1359), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [5893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1376), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [5956] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1351), 1,
      anon_sym_EQ,
    STATE(406), 1,
      sym_arguments,
    ACTIONS(1357), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1347), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1345), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1378), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1380), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [6090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1382), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1384), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [6153] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1351), 1,
      anon_sym_EQ,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1355), 1,
      anon_sym_EQ_GT,
    ACTIONS(1357), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1361), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1359), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6224] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1076), 1,
      anon_sym_EQ,
    ACTIONS(1078), 1,
      anon_sym_DOT,
    ACTIONS(1084), 1,
      anon_sym_EQ_GT,
    ACTIONS(1086), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(851), 16,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(859), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1386), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1388), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [6358] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1351), 1,
      anon_sym_EQ,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1370), 1,
      anon_sym_EQ_GT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    STATE(540), 1,
      sym_arguments,
    ACTIONS(1347), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1357), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1345), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6432] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(875), 1,
      anon_sym_EQ_GT,
    ACTIONS(1076), 1,
      anon_sym_EQ,
    ACTIONS(1103), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    STATE(535), 1,
      sym_arguments,
    ACTIONS(1074), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1086), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1072), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6506] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1355), 1,
      anon_sym_EQ_GT,
    ACTIONS(1394), 1,
      anon_sym_in,
    ACTIONS(1397), 1,
      anon_sym_of,
    ACTIONS(1399), 1,
      anon_sym_EQ,
    STATE(839), 1,
      sym__initializer,
    ACTIONS(1392), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1361), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1357), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1359), 20,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6584] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1351), 1,
      anon_sym_EQ,
    ACTIONS(1357), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1361), 17,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1359), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6650] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 1,
      anon_sym_COLON,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1370), 1,
      anon_sym_EQ_GT,
    ACTIONS(1401), 1,
      anon_sym_EQ,
    ACTIONS(1361), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1372), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1359), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6721] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1351), 1,
      anon_sym_EQ,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    STATE(540), 1,
      sym_arguments,
    ACTIONS(1347), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1357), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1345), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [6790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1382), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1384), 31,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [6851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1376), 31,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [6912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1405), 14,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1403), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1409), 14,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1407), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1378), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1380), 31,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [7095] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1370), 1,
      anon_sym_EQ_GT,
    ACTIONS(1401), 1,
      anon_sym_EQ,
    ACTIONS(1361), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1372), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1359), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1413), 14,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1411), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7225] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1370), 1,
      anon_sym_EQ_GT,
    ACTIONS(1401), 1,
      anon_sym_EQ,
    ACTIONS(1415), 1,
      anon_sym_in,
    ACTIONS(1418), 1,
      anon_sym_of,
    ACTIONS(1361), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1372), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1359), 20,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7298] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(875), 1,
      anon_sym_EQ_GT,
    ACTIONS(1103), 1,
      anon_sym_DOT,
    ACTIONS(1109), 1,
      anon_sym_EQ,
    ACTIONS(1117), 1,
      anon_sym_in,
    ACTIONS(1420), 1,
      anon_sym_of,
    ACTIONS(851), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(877), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(859), 20,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7371] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(875), 1,
      anon_sym_EQ_GT,
    ACTIONS(1103), 1,
      anon_sym_DOT,
    ACTIONS(1109), 1,
      anon_sym_EQ,
    ACTIONS(851), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(877), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(859), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7440] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(875), 1,
      anon_sym_EQ_GT,
    ACTIONS(1103), 1,
      anon_sym_DOT,
    ACTIONS(1109), 1,
      anon_sym_EQ,
    ACTIONS(1115), 1,
      anon_sym_COLON,
    ACTIONS(851), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(877), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(859), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1386), 22,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
    ACTIONS(1388), 31,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [7572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1388), 14,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1386), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1424), 14,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1422), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1428), 14,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1426), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1432), 14,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1430), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1436), 14,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1434), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [7877] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1122), 1,
      anon_sym_COLON,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1370), 1,
      anon_sym_EQ_GT,
    ACTIONS(1401), 1,
      anon_sym_EQ,
    ACTIONS(1361), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1372), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1359), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [7948] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(875), 1,
      anon_sym_EQ_GT,
    ACTIONS(1103), 1,
      anon_sym_DOT,
    ACTIONS(1109), 1,
      anon_sym_EQ,
    ACTIONS(1122), 1,
      anon_sym_COLON,
    ACTIONS(851), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(877), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(859), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1440), 14,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(1438), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [8080] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1355), 1,
      anon_sym_EQ_GT,
    ACTIONS(1442), 1,
      anon_sym_COMMA,
    ACTIONS(1445), 1,
      anon_sym_RPAREN,
    ACTIONS(1448), 1,
      anon_sym_EQ,
    STATE(813), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(1361), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1357), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1359), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8154] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1401), 1,
      anon_sym_EQ,
    ACTIONS(1361), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1372), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1359), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8218] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1401), 1,
      anon_sym_EQ,
    ACTIONS(1415), 1,
      anon_sym_in,
    ACTIONS(1418), 1,
      anon_sym_of,
    ACTIONS(1361), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1372), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1359), 20,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8286] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1078), 1,
      anon_sym_DOT,
    ACTIONS(1084), 1,
      anon_sym_EQ_GT,
    ACTIONS(1126), 1,
      anon_sym_COMMA,
    ACTIONS(1129), 1,
      anon_sym_RPAREN,
    ACTIONS(1132), 1,
      anon_sym_EQ,
    STATE(817), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(851), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1086), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(859), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8360] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1351), 1,
      anon_sym_EQ,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1355), 1,
      anon_sym_EQ_GT,
    ACTIONS(1450), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1361), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1357), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1359), 21,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8429] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1351), 1,
      anon_sym_EQ,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1355), 1,
      anon_sym_EQ_GT,
    ACTIONS(1415), 1,
      anon_sym_in,
    ACTIONS(1418), 1,
      anon_sym_of,
    ACTIONS(1361), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1357), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1359), 20,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8499] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1076), 1,
      anon_sym_EQ,
    ACTIONS(1078), 1,
      anon_sym_DOT,
    ACTIONS(1084), 1,
      anon_sym_EQ_GT,
    ACTIONS(1117), 1,
      anon_sym_in,
    ACTIONS(1420), 1,
      anon_sym_of,
    ACTIONS(851), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1086), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(859), 20,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8569] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1076), 1,
      anon_sym_EQ,
    ACTIONS(1078), 1,
      anon_sym_DOT,
    ACTIONS(1084), 1,
      anon_sym_EQ_GT,
    ACTIONS(1340), 1,
      anon_sym_in,
    ACTIONS(1453), 1,
      anon_sym_of,
    ACTIONS(851), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1086), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(859), 20,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8639] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1351), 1,
      anon_sym_EQ,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1355), 1,
      anon_sym_EQ_GT,
    ACTIONS(1394), 1,
      anon_sym_in,
    ACTIONS(1397), 1,
      anon_sym_of,
    ACTIONS(1361), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1357), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1359), 20,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8709] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1351), 1,
      anon_sym_EQ,
    ACTIONS(1415), 1,
      anon_sym_in,
    ACTIONS(1418), 1,
      anon_sym_of,
    ACTIONS(1361), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1357), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1359), 20,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1455), 22,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1457), 27,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
  [8831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 22,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1461), 27,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
  [8888] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1351), 1,
      anon_sym_EQ,
    ACTIONS(1394), 1,
      anon_sym_in,
    ACTIONS(1397), 1,
      anon_sym_of,
    ACTIONS(1361), 11,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1357), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP_EQ,
      anon_sym_PIPE_PIPE_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(1359), 20,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_QMARK_QMARK,
  [8953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 22,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1465), 27,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
  [9010] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(1467), 1,
      sym_identifier,
    ACTIONS(1469), 1,
      anon_sym_STAR,
    ACTIONS(1471), 1,
      anon_sym_LBRACE,
    STATE(895), 1,
      sym_string,
    STATE(904), 1,
      sym_import_clause,
    STATE(1131), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(1475), 13,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(1473), 21,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9077] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1479), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [9159] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1507), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [9241] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1509), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [9323] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1511), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [9405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1513), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1515), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9453] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1517), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [9535] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1519), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [9617] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1521), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [9699] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1523), 1,
      anon_sym_EQ,
    STATE(406), 1,
      sym_arguments,
    ACTIONS(1345), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1347), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9753] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1525), 1,
      anon_sym_EQ,
    STATE(406), 1,
      sym_arguments,
    ACTIONS(1345), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1347), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9807] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(398), 1,
      sym_arguments,
    STATE(418), 1,
      sym_template_string,
    ACTIONS(1345), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1347), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9859] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1527), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1529), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [9919] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1527), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1529), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [9979] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1527), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1529), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [10039] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1531), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1533), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [10097] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1359), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 23,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [10151] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1535), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1537), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [10213] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1535), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1537), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [10289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1539), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1541), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [10337] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1543), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [10419] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1545), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [10501] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1547), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [10583] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(396), 1,
      anon_sym_EQ,
    ACTIONS(1549), 1,
      sym__automatic_semicolon,
    ACTIONS(394), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(392), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [10635] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1551), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [10717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1553), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1555), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [10765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1557), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1559), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [10813] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1535), 1,
      anon_sym_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1537), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
  [10893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1561), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1563), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [10941] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1535), 10,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1537), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [11007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1565), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1567), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [11055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1569), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1571), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [11103] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1573), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [11185] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1575), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [11267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(396), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(398), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [11315] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1577), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [11397] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1535), 8,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1537), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [11465] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1535), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1537), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [11537] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1535), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1537), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [11597] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1579), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [11679] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1581), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [11761] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1587), 1,
      sym_regex_flags,
    ACTIONS(1583), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(1585), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [11810] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1549), 1,
      sym__automatic_semicolon,
    ACTIONS(394), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(392), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [11859] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1523), 1,
      anon_sym_EQ,
    ACTIONS(1359), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [11908] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1525), 1,
      anon_sym_EQ,
    ACTIONS(1359), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [11957] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1589), 1,
      sym__automatic_semicolon,
    ACTIONS(496), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(494), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12006] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1591), 1,
      anon_sym_COMMA,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1593), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [12089] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1595), 1,
      anon_sym_EQ_GT,
    ACTIONS(1459), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1461), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12138] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    STATE(406), 1,
      sym_arguments,
    ACTIONS(1345), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1347), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1599), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12235] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(418), 1,
      sym_template_string,
    STATE(547), 1,
      sym_arguments,
    ACTIONS(1345), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1347), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1539), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1541), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(426), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(428), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12377] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1507), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [12457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(416), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(418), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(406), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(408), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12549] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1519), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [12629] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1509), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [12709] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1577), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [12789] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1521), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [12869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1629), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1631), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12915] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1635), 1,
      anon_sym_in,
    ACTIONS(1638), 1,
      anon_sym_of,
    ACTIONS(1640), 1,
      anon_sym_EQ,
    STATE(868), 1,
      sym__initializer,
    ACTIONS(1633), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1359), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 19,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(396), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(398), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13017] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1644), 1,
      anon_sym_in,
    ACTIONS(1647), 1,
      anon_sym_of,
    ACTIONS(1649), 1,
      anon_sym_EQ,
    STATE(867), 1,
      sym__initializer,
    ACTIONS(1642), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1359), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 19,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1651), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1575), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1479), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(488), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(490), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(474), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(476), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1655), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1657), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13303] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1511), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [13383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1513), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1515), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(464), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(466), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1565), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1567), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13521] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1659), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [13601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(450), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(452), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13647] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1579), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [13727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1561), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1563), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1661), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1663), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13819] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1479), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [13899] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1573), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [13979] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(400), 1,
      sym__automatic_semicolon,
    ACTIONS(392), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(396), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(398), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1655), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1657), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1665), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1667), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1669), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1671), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1675), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1677), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1679), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1681), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1683), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(444), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(442), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14351] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1359), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 21,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [14403] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1543), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [14483] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1535), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1537), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1669), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1671), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1685), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1687), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14635] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1535), 8,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1537), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14701] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1545), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [14781] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1535), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1537), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [14851] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1535), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1537), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [14925] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1535), 10,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1537), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14989] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1535), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1537), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15047] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1535), 1,
      anon_sym_QMARK,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1537), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [15125] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1551), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [15205] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1581), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [15285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1689), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1691), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1693), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1695), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15377] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1547), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [15457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1677), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1679), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15503] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1531), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1533), 19,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [15559] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1527), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1529), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15617] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1527), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1529), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15675] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1575), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [15755] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1527), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1529), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1697), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1699), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(438), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15905] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1525), 1,
      anon_sym_EQ,
    STATE(540), 1,
      sym_arguments,
    ACTIONS(1345), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1347), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(482), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(480), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(496), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(494), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1701), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1703), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1705), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1547), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16141] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1523), 1,
      anon_sym_EQ,
    STATE(540), 1,
      sym_arguments,
    ACTIONS(1345), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1347), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1473), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1707), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1709), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1545), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1553), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1555), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16377] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1517), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [16457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1713), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1543), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1715), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1717), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1719), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1721), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(458), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(456), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1723), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1725), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1727), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1729), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1731), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1733), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1735), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1737), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1739), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1741), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1743), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1745), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16917] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1747), 1,
      anon_sym_COMMA,
    ACTIONS(1750), 1,
      anon_sym_RBRACE,
    ACTIONS(1581), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [17001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1752), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1754), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17047] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1756), 1,
      anon_sym_COMMA,
    ACTIONS(1759), 1,
      anon_sym_RBRACE,
    ACTIONS(1507), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [17131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1569), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1571), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17177] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1759), 1,
      anon_sym_RBRACE,
    ACTIONS(1761), 1,
      anon_sym_COMMA,
    ACTIONS(1579), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [17261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1764), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1577), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1557), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1559), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17353] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1766), 1,
      anon_sym_COMMA,
    ACTIONS(1769), 1,
      anon_sym_RBRACE,
    ACTIONS(1551), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [17437] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(512), 1,
      anon_sym_COMMA,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1771), 1,
      anon_sym_RBRACK,
    STATE(865), 1,
      aux_sym_array_repeat1,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [17520] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1773), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [17599] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(492), 1,
      sym__automatic_semicolon,
    ACTIONS(484), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(488), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(490), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17648] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(512), 1,
      anon_sym_COMMA,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1775), 1,
      anon_sym_RBRACK,
    STATE(825), 1,
      aux_sym_array_repeat1,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [17731] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(478), 1,
      sym__automatic_semicolon,
    ACTIONS(470), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(474), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(476), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17780] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(410), 1,
      sym__automatic_semicolon,
    ACTIONS(402), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(406), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(408), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17829] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(420), 1,
      sym__automatic_semicolon,
    ACTIONS(412), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(416), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(418), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17878] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(468), 1,
      sym__automatic_semicolon,
    ACTIONS(460), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(464), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(466), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17927] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1777), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [18006] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    STATE(540), 1,
      sym_arguments,
    ACTIONS(1345), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1347), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18055] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(454), 1,
      sym__automatic_semicolon,
    ACTIONS(446), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(450), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(452), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18104] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(396), 1,
      anon_sym_EQ,
    ACTIONS(500), 1,
      sym__automatic_semicolon,
    ACTIONS(394), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(392), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18153] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(512), 1,
      anon_sym_COMMA,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1779), 1,
      anon_sym_RBRACK,
    STATE(865), 1,
      aux_sym_array_repeat1,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [18236] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1773), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [18315] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(430), 1,
      sym__automatic_semicolon,
    ACTIONS(422), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(426), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(428), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18364] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1781), 1,
      anon_sym_COMMA,
    ACTIONS(1593), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [18445] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(440), 1,
      sym__automatic_semicolon,
    ACTIONS(432), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(436), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(438), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18494] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1783), 1,
      anon_sym_LPAREN,
    ACTIONS(1786), 1,
      anon_sym_COLON,
    ACTIONS(1539), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1541), 21,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1788), 1,
      sym_regex_flags,
    ACTIONS(1583), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(1585), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18590] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1595), 1,
      anon_sym_EQ_GT,
    ACTIONS(1459), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1461), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18637] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(512), 1,
      anon_sym_COMMA,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1790), 1,
      anon_sym_RPAREN,
    STATE(854), 1,
      aux_sym_array_repeat1,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [18720] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(512), 1,
      anon_sym_COMMA,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1792), 1,
      anon_sym_RPAREN,
    STATE(871), 1,
      aux_sym_array_repeat1,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [18803] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(512), 1,
      anon_sym_COMMA,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1794), 1,
      anon_sym_RBRACK,
    STATE(825), 1,
      aux_sym_array_repeat1,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [18886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_EQ,
    ACTIONS(1359), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18933] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1781), 1,
      anon_sym_COMMA,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1798), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1800), 1,
      anon_sym_EQ,
    ACTIONS(1359), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19061] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1773), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19140] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1773), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19219] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1759), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19298] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1769), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19377] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1750), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19456] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1781), 1,
      anon_sym_COMMA,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1802), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19537] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1800), 1,
      anon_sym_EQ,
    ACTIONS(1804), 1,
      anon_sym_in,
    ACTIONS(1807), 1,
      anon_sym_of,
    ACTIONS(1359), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19588] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1796), 1,
      anon_sym_EQ,
    ACTIONS(1809), 1,
      anon_sym_in,
    ACTIONS(1812), 1,
      anon_sym_of,
    ACTIONS(1359), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19639] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1781), 1,
      anon_sym_COMMA,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1814), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1752), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1754), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1723), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1725), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19808] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_COMMA,
    ACTIONS(1819), 1,
      anon_sym_RPAREN,
    ACTIONS(1822), 1,
      anon_sym_EQ,
    STATE(888), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(1359), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 19,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19860] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1591), 1,
      anon_sym_COMMA,
    ACTIONS(1824), 1,
      anon_sym_RPAREN,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19940] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1591), 1,
      anon_sym_COMMA,
    ACTIONS(1826), 1,
      anon_sym_RPAREN,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20020] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1756), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20098] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1761), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20176] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1766), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20254] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1747), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20332] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(436), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(438), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20376] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1591), 1,
      anon_sym_COMMA,
    ACTIONS(1828), 1,
      anon_sym_RPAREN,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20456] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1591), 1,
      anon_sym_COMMA,
    ACTIONS(1830), 1,
      anon_sym_RPAREN,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20536] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1591), 1,
      anon_sym_COMMA,
    ACTIONS(1832), 1,
      anon_sym_RPAREN,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20616] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1834), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(426), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(428), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(416), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(418), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(406), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(408), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20826] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1591), 1,
      anon_sym_COMMA,
    ACTIONS(1836), 1,
      anon_sym_RPAREN,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20906] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1591), 1,
      anon_sym_COMMA,
    ACTIONS(1838), 1,
      anon_sym_RPAREN,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1743), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1745), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21030] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1591), 1,
      anon_sym_COMMA,
    ACTIONS(1840), 1,
      anon_sym_COLON,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [21110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1665), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1667), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1739), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1741), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1735), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1737), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1455), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1457), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(488), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(490), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1764), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1577), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1719), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1721), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21418] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1591), 1,
      anon_sym_COMMA,
    ACTIONS(1842), 1,
      anon_sym_RPAREN,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [21498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1731), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1733), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(474), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(476), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1675), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21630] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1591), 1,
      anon_sym_COMMA,
    ACTIONS(1844), 1,
      anon_sym_RPAREN,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [21710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(464), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(466), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(450), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(452), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21798] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1591), 1,
      anon_sym_COMMA,
    ACTIONS(1846), 1,
      anon_sym_RPAREN,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [21878] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1848), 1,
      anon_sym_COMMA,
    ACTIONS(1851), 1,
      anon_sym_RPAREN,
    ACTIONS(1854), 1,
      anon_sym_EQ,
    STATE(824), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(1359), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 19,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1856), 1,
      anon_sym_EQ,
    ACTIONS(1359), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1681), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1683), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22020] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1591), 1,
      anon_sym_COMMA,
    ACTIONS(1858), 1,
      anon_sym_RPAREN,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [22100] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1860), 1,
      anon_sym_EQ,
    ACTIONS(1359), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1651), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1575), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22190] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1862), 1,
      anon_sym_LPAREN,
    ACTIONS(1865), 1,
      anon_sym_COLON,
    ACTIONS(1359), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 21,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1685), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1687), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1629), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1631), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22326] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1689), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1691), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1705), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1547), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22414] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1591), 1,
      anon_sym_COMMA,
    ACTIONS(1867), 1,
      anon_sym_RPAREN,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [22494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1669), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1671), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1693), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1695), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22582] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1591), 1,
      anon_sym_COMMA,
    ACTIONS(1869), 1,
      anon_sym_RBRACE,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [22662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1599), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1545), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22750] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1591), 1,
      anon_sym_COMMA,
    ACTIONS(1871), 1,
      anon_sym_RPAREN,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [22830] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1713), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1543), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1669), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1671), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22918] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1591), 1,
      anon_sym_COMMA,
    ACTIONS(1873), 1,
      anon_sym_RBRACE,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [22998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1715), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1717), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23042] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1707), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1709), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1661), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1663), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1697), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1699), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1701), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1703), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1465), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23262] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1727), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1729), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23306] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1875), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [23384] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1591), 1,
      anon_sym_COMMA,
    ACTIONS(1877), 1,
      anon_sym_RBRACK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [23464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1475), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1473), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23508] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1591), 1,
      anon_sym_COMMA,
    ACTIONS(1879), 1,
      anon_sym_RBRACK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [23588] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1591), 1,
      anon_sym_COMMA,
    ACTIONS(1881), 1,
      anon_sym_RBRACE,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [23668] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1607), 1,
      anon_sym_QMARK,
    ACTIONS(1609), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1615), 1,
      anon_sym_AMP,
    ACTIONS(1617), 1,
      anon_sym_PIPE,
    ACTIONS(1621), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1625), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1611), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1619), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1627), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1883), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1601), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1613), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1603), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1623), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [23746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1653), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1479), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1461), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23834] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1885), 1,
      anon_sym_LBRACE,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [23911] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1887), 1,
      anon_sym_RBRACK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [23988] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1523), 1,
      anon_sym_EQ,
    ACTIONS(1889), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1359), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 19,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24035] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1892), 1,
      anon_sym_COLON,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [24112] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1525), 1,
      anon_sym_EQ,
    ACTIONS(1894), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1359), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 19,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24159] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1897), 1,
      anon_sym_COLON,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [24236] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1899), 1,
      anon_sym_RBRACK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [24313] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1523), 1,
      anon_sym_EQ,
    ACTIONS(1809), 1,
      anon_sym_in,
    ACTIONS(1812), 1,
      anon_sym_of,
    ACTIONS(1359), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 19,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24361] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1523), 1,
      anon_sym_EQ,
    ACTIONS(1644), 1,
      anon_sym_in,
    ACTIONS(1647), 1,
      anon_sym_of,
    ACTIONS(1359), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 19,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24409] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1525), 1,
      anon_sym_EQ,
    ACTIONS(1635), 1,
      anon_sym_in,
    ACTIONS(1638), 1,
      anon_sym_of,
    ACTIONS(1359), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 19,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24457] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [24531] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1525), 1,
      anon_sym_EQ,
    ACTIONS(1804), 1,
      anon_sym_in,
    ACTIONS(1807), 1,
      anon_sym_of,
    ACTIONS(1359), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1361), 19,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24579] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1485), 1,
      anon_sym_QMARK,
    ACTIONS(1487), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1493), 1,
      anon_sym_AMP,
    ACTIONS(1495), 1,
      anon_sym_PIPE,
    ACTIONS(1499), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1503), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    ACTIONS(1489), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1497), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1505), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1477), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1491), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1481), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1501), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [24653] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(103), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(1901), 1,
      sym_identifier,
    ACTIONS(1903), 1,
      anon_sym_RBRACE,
    ACTIONS(1905), 1,
      anon_sym_LBRACK,
    ACTIONS(1907), 1,
      anon_sym_async,
    ACTIONS(1909), 1,
      sym_number,
    ACTIONS(1911), 1,
      anon_sym_static,
    STATE(602), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    STATE(885), 1,
      aux_sym_object_repeat1,
    STATE(1052), 1,
      sym_object,
    STATE(1056), 1,
      sym_array,
    ACTIONS(1913), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(890), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(809), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
  [24726] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(103), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(1905), 1,
      anon_sym_LBRACK,
    ACTIONS(1909), 1,
      sym_number,
    ACTIONS(1915), 1,
      sym_identifier,
    ACTIONS(1917), 1,
      anon_sym_RBRACE,
    ACTIONS(1919), 1,
      anon_sym_async,
    ACTIONS(1921), 1,
      anon_sym_static,
    STATE(602), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    STATE(889), 1,
      aux_sym_object_repeat1,
    STATE(1052), 1,
      sym_object,
    STATE(1056), 1,
      sym_array,
    ACTIONS(1923), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(890), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(884), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
  [24799] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(103), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(1905), 1,
      anon_sym_LBRACK,
    ACTIONS(1909), 1,
      sym_number,
    ACTIONS(1925), 1,
      sym_identifier,
    ACTIONS(1929), 1,
      anon_sym_async,
    ACTIONS(1931), 1,
      anon_sym_static,
    STATE(602), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    STATE(1052), 1,
      sym_object,
    STATE(1056), 1,
      sym_array,
    ACTIONS(1927), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1933), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(890), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(1024), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
  [24867] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(1935), 1,
      sym_identifier,
    ACTIONS(1937), 1,
      anon_sym_RBRACE,
    ACTIONS(1939), 1,
      anon_sym_LBRACK,
    ACTIONS(1941), 1,
      anon_sym_async,
    ACTIONS(1943), 1,
      sym_number,
    ACTIONS(1945), 1,
      anon_sym_static,
    STATE(585), 1,
      aux_sym_class_body_repeat1,
    STATE(602), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    STATE(636), 1,
      sym_method_definition,
    STATE(960), 1,
      sym_public_field_definition,
    ACTIONS(1947), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(684), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [24925] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(1935), 1,
      sym_identifier,
    ACTIONS(1939), 1,
      anon_sym_LBRACK,
    ACTIONS(1941), 1,
      anon_sym_async,
    ACTIONS(1943), 1,
      sym_number,
    ACTIONS(1945), 1,
      anon_sym_static,
    ACTIONS(1949), 1,
      anon_sym_RBRACE,
    STATE(585), 1,
      aux_sym_class_body_repeat1,
    STATE(602), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    STATE(636), 1,
      sym_method_definition,
    STATE(960), 1,
      sym_public_field_definition,
    ACTIONS(1947), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(684), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [24983] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(1935), 1,
      sym_identifier,
    ACTIONS(1939), 1,
      anon_sym_LBRACK,
    ACTIONS(1941), 1,
      anon_sym_async,
    ACTIONS(1943), 1,
      sym_number,
    ACTIONS(1945), 1,
      anon_sym_static,
    ACTIONS(1951), 1,
      anon_sym_RBRACE,
    STATE(581), 1,
      aux_sym_class_body_repeat1,
    STATE(602), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    STATE(636), 1,
      sym_method_definition,
    STATE(960), 1,
      sym_public_field_definition,
    ACTIONS(1947), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(684), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25041] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(1935), 1,
      sym_identifier,
    ACTIONS(1939), 1,
      anon_sym_LBRACK,
    ACTIONS(1941), 1,
      anon_sym_async,
    ACTIONS(1943), 1,
      sym_number,
    ACTIONS(1945), 1,
      anon_sym_static,
    ACTIONS(1953), 1,
      anon_sym_RBRACE,
    STATE(584), 1,
      aux_sym_class_body_repeat1,
    STATE(602), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    STATE(636), 1,
      sym_method_definition,
    STATE(960), 1,
      sym_public_field_definition,
    ACTIONS(1947), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(684), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25099] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(1935), 1,
      sym_identifier,
    ACTIONS(1939), 1,
      anon_sym_LBRACK,
    ACTIONS(1941), 1,
      anon_sym_async,
    ACTIONS(1943), 1,
      sym_number,
    ACTIONS(1945), 1,
      anon_sym_static,
    ACTIONS(1955), 1,
      anon_sym_RBRACE,
    STATE(585), 1,
      aux_sym_class_body_repeat1,
    STATE(602), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    STATE(636), 1,
      sym_method_definition,
    STATE(960), 1,
      sym_public_field_definition,
    ACTIONS(1947), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(684), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25157] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1957), 1,
      sym_identifier,
    ACTIONS(1960), 1,
      anon_sym_STAR,
    ACTIONS(1963), 1,
      anon_sym_RBRACE,
    ACTIONS(1965), 1,
      anon_sym_LBRACK,
    ACTIONS(1968), 1,
      anon_sym_async,
    ACTIONS(1971), 1,
      anon_sym_DQUOTE,
    ACTIONS(1974), 1,
      anon_sym_SQUOTE,
    ACTIONS(1977), 1,
      sym_number,
    ACTIONS(1980), 1,
      anon_sym_AT,
    ACTIONS(1983), 1,
      anon_sym_static,
    STATE(585), 1,
      aux_sym_class_body_repeat1,
    STATE(602), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    STATE(636), 1,
      sym_method_definition,
    STATE(960), 1,
      sym_public_field_definition,
    ACTIONS(1986), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(684), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25215] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(93), 1,
      anon_sym_STAR,
    ACTIONS(1935), 1,
      sym_identifier,
    ACTIONS(1939), 1,
      anon_sym_LBRACK,
    ACTIONS(1941), 1,
      anon_sym_async,
    ACTIONS(1943), 1,
      sym_number,
    ACTIONS(1945), 1,
      anon_sym_static,
    ACTIONS(1989), 1,
      anon_sym_RBRACE,
    STATE(580), 1,
      aux_sym_class_body_repeat1,
    STATE(602), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    STATE(636), 1,
      sym_method_definition,
    STATE(960), 1,
      sym_public_field_definition,
    ACTIONS(1947), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(684), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25273] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(879), 1,
      sym_number,
    ACTIONS(883), 1,
      anon_sym_RBRACE,
    ACTIONS(1066), 1,
      anon_sym_async,
    ACTIONS(1991), 1,
      anon_sym_STAR,
    ACTIONS(1995), 1,
      anon_sym_EQ,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    STATE(838), 1,
      aux_sym_object_repeat1,
    ACTIONS(1061), 2,
      sym_identifier,
      anon_sym_static,
    ACTIONS(1068), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1993), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25324] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(853), 1,
      anon_sym_RBRACE,
    ACTIONS(879), 1,
      sym_number,
    ACTIONS(1066), 1,
      anon_sym_async,
    ACTIONS(1991), 1,
      anon_sym_STAR,
    ACTIONS(1995), 1,
      anon_sym_EQ,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      aux_sym_object_repeat1,
    ACTIONS(1061), 2,
      sym_identifier,
      anon_sym_static,
    ACTIONS(1068), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1993), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25375] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(879), 1,
      sym_number,
    ACTIONS(883), 1,
      anon_sym_RBRACE,
    ACTIONS(1991), 1,
      anon_sym_STAR,
    ACTIONS(1995), 1,
      anon_sym_EQ,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    STATE(838), 1,
      aux_sym_object_repeat1,
    ACTIONS(1068), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1993), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(1061), 3,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25424] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(1999), 1,
      anon_sym_STAR,
    ACTIONS(2001), 1,
      anon_sym_default,
    ACTIONS(2003), 1,
      anon_sym_LBRACE,
    ACTIONS(2005), 1,
      anon_sym_var,
    ACTIONS(2009), 1,
      anon_sym_class,
    ACTIONS(2011), 1,
      anon_sym_async,
    ACTIONS(2013), 1,
      anon_sym_function,
    STATE(635), 1,
      sym_decorator,
    STATE(752), 1,
      sym_export_clause,
    STATE(803), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(2007), 2,
      anon_sym_let,
      anon_sym_const,
    STATE(256), 6,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
  [25473] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(853), 1,
      anon_sym_RBRACE,
    ACTIONS(879), 1,
      sym_number,
    ACTIONS(1991), 1,
      anon_sym_STAR,
    ACTIONS(1995), 1,
      anon_sym_EQ,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      aux_sym_object_repeat1,
    ACTIONS(1068), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1993), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(1061), 3,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25522] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(1999), 1,
      anon_sym_STAR,
    ACTIONS(2001), 1,
      anon_sym_default,
    ACTIONS(2003), 1,
      anon_sym_LBRACE,
    ACTIONS(2005), 1,
      anon_sym_var,
    ACTIONS(2015), 1,
      anon_sym_class,
    ACTIONS(2017), 1,
      anon_sym_async,
    ACTIONS(2019), 1,
      anon_sym_function,
    STATE(635), 1,
      sym_decorator,
    STATE(752), 1,
      sym_export_clause,
    STATE(753), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(2007), 2,
      anon_sym_let,
      anon_sym_const,
    STATE(256), 6,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
  [25571] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(879), 1,
      sym_number,
    ACTIONS(1066), 1,
      anon_sym_async,
    ACTIONS(1991), 1,
      anon_sym_STAR,
    ACTIONS(1995), 1,
      anon_sym_EQ,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    ACTIONS(1061), 2,
      sym_identifier,
      anon_sym_static,
    ACTIONS(1068), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1993), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(2021), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25617] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(879), 1,
      sym_number,
    ACTIONS(1061), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_async,
    ACTIONS(1991), 1,
      anon_sym_STAR,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    ACTIONS(2023), 1,
      anon_sym_export,
    ACTIONS(2025), 1,
      anon_sym_class,
    ACTIONS(2027), 1,
      anon_sym_static,
    STATE(611), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    ACTIONS(1068), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25669] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(879), 1,
      sym_number,
    ACTIONS(1991), 1,
      anon_sym_STAR,
    ACTIONS(1995), 1,
      anon_sym_EQ,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    ACTIONS(1068), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1993), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(2021), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1061), 3,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25713] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(853), 1,
      anon_sym_RBRACE,
    ACTIONS(879), 1,
      sym_number,
    ACTIONS(1995), 1,
      anon_sym_EQ,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      aux_sym_object_repeat1,
    ACTIONS(1993), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1061), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [25757] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(879), 1,
      sym_number,
    ACTIONS(883), 1,
      anon_sym_RBRACE,
    ACTIONS(1995), 1,
      anon_sym_EQ,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    STATE(838), 1,
      aux_sym_object_repeat1,
    ACTIONS(1993), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1061), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [25801] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(879), 1,
      sym_number,
    ACTIONS(1995), 1,
      anon_sym_EQ,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    ACTIONS(1993), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(2021), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1061), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [25840] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    ACTIONS(2029), 1,
      anon_sym_STAR,
    ACTIONS(2031), 1,
      sym_number,
    ACTIONS(2033), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1061), 3,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
    STATE(961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1993), 4,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
  [25879] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(1939), 1,
      anon_sym_LBRACK,
    ACTIONS(1991), 1,
      anon_sym_STAR,
    ACTIONS(2035), 1,
      anon_sym_async,
    ACTIONS(2037), 1,
      sym_number,
    ACTIONS(1935), 2,
      sym_identifier,
      anon_sym_static,
    ACTIONS(2039), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1993), 4,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
  [25920] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(879), 1,
      sym_number,
    ACTIONS(1991), 1,
      anon_sym_STAR,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    ACTIONS(1068), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1061), 3,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1993), 4,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
  [25959] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(879), 1,
      sym_number,
    ACTIONS(1061), 1,
      sym_identifier,
    ACTIONS(1066), 1,
      anon_sym_async,
    ACTIONS(1991), 1,
      anon_sym_STAR,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    ACTIONS(2027), 1,
      anon_sym_static,
    STATE(611), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    ACTIONS(1068), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [26005] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(2005), 1,
      anon_sym_var,
    ACTIONS(2015), 1,
      anon_sym_class,
    ACTIONS(2017), 1,
      anon_sym_async,
    ACTIONS(2019), 1,
      anon_sym_function,
    ACTIONS(2041), 1,
      anon_sym_default,
    STATE(635), 1,
      sym_decorator,
    STATE(753), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(2007), 2,
      anon_sym_let,
      anon_sym_const,
    STATE(223), 6,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
  [26045] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(2047), 1,
      anon_sym_DOT,
    STATE(624), 1,
      sym_arguments,
    ACTIONS(2045), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(2043), 7,
      anon_sym_export,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26075] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(2005), 1,
      anon_sym_var,
    ACTIONS(2009), 1,
      anon_sym_class,
    ACTIONS(2011), 1,
      anon_sym_async,
    ACTIONS(2013), 1,
      anon_sym_function,
    ACTIONS(2041), 1,
      anon_sym_default,
    STATE(635), 1,
      sym_decorator,
    STATE(803), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(2007), 2,
      anon_sym_let,
      anon_sym_const,
    STATE(223), 6,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
  [26115] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    ACTIONS(2031), 1,
      sym_number,
    STATE(961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1993), 4,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
    ACTIONS(1061), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26149] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(2053), 1,
      anon_sym_DOT,
    STATE(626), 1,
      sym_arguments,
    ACTIONS(2051), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(2049), 7,
      anon_sym_export,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26179] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(879), 1,
      sym_number,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1993), 4,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
    ACTIONS(1061), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2057), 7,
      anon_sym_STAR,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(2055), 8,
      anon_sym_export,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2061), 7,
      anon_sym_STAR,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(2059), 8,
      anon_sym_export,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26259] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2067), 1,
      anon_sym_AT,
    STATE(611), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    ACTIONS(2065), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2063), 7,
      anon_sym_export,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2070), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2072), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [26310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2074), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2076), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [26332] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(1993), 1,
      anon_sym_LPAREN,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    ACTIONS(2029), 1,
      anon_sym_STAR,
    ACTIONS(2031), 1,
      sym_number,
    ACTIONS(2078), 1,
      anon_sym_async,
    ACTIONS(1061), 2,
      sym_identifier,
      anon_sym_static,
    ACTIONS(2033), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [26370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2080), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2082), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [26392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2084), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2086), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [26414] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(1993), 1,
      anon_sym_LPAREN,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    ACTIONS(2031), 1,
      sym_number,
    ACTIONS(2088), 1,
      anon_sym_EQ_GT,
    STATE(961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1061), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26448] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(1993), 1,
      anon_sym_LPAREN,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    ACTIONS(2090), 1,
      anon_sym_STAR,
    ACTIONS(2092), 1,
      sym_number,
    ACTIONS(2094), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1061), 3,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
    STATE(996), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [26484] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(1993), 1,
      anon_sym_LPAREN,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    ACTIONS(2029), 1,
      anon_sym_STAR,
    ACTIONS(2031), 1,
      sym_number,
    ACTIONS(2033), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1061), 3,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
    STATE(961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [26520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2096), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2098), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [26542] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(330), 1,
      anon_sym_LBRACK,
    ACTIONS(548), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2100), 1,
      sym_identifier,
    ACTIONS(2102), 1,
      anon_sym_RPAREN,
    STATE(812), 1,
      sym_array,
    STATE(814), 1,
      sym_object,
    STATE(1009), 2,
      sym_assignment_pattern,
      sym_rest_parameter,
    ACTIONS(2104), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26577] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(330), 1,
      anon_sym_LBRACK,
    ACTIONS(544), 1,
      anon_sym_RPAREN,
    ACTIONS(548), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2106), 1,
      sym_identifier,
    STATE(771), 1,
      sym_object,
    STATE(800), 1,
      sym_array,
    STATE(829), 2,
      sym_assignment_pattern,
      sym_rest_parameter,
    ACTIONS(2108), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26612] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(330), 1,
      anon_sym_LBRACK,
    ACTIONS(548), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2100), 1,
      sym_identifier,
    ACTIONS(2110), 1,
      anon_sym_RPAREN,
    STATE(812), 1,
      sym_array,
    STATE(814), 1,
      sym_object,
    STATE(1009), 2,
      sym_assignment_pattern,
      sym_rest_parameter,
    ACTIONS(2104), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2114), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(2112), 7,
      anon_sym_export,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26668] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(330), 1,
      anon_sym_LBRACK,
    ACTIONS(548), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2100), 1,
      sym_identifier,
    ACTIONS(2116), 1,
      anon_sym_RPAREN,
    STATE(812), 1,
      sym_array,
    STATE(814), 1,
      sym_object,
    STATE(1009), 2,
      sym_assignment_pattern,
      sym_rest_parameter,
    ACTIONS(2104), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2120), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(2118), 7,
      anon_sym_export,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26724] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(1993), 1,
      anon_sym_LPAREN,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    ACTIONS(2122), 1,
      sym_number,
    STATE(977), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1061), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26755] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(330), 1,
      anon_sym_LBRACK,
    ACTIONS(548), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2100), 1,
      sym_identifier,
    ACTIONS(2124), 1,
      anon_sym_RPAREN,
    STATE(812), 1,
      sym_array,
    STATE(814), 1,
      sym_object,
    STATE(1009), 2,
      sym_assignment_pattern,
      sym_rest_parameter,
    ACTIONS(2104), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26790] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(330), 1,
      anon_sym_LBRACK,
    ACTIONS(548), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2100), 1,
      sym_identifier,
    ACTIONS(2126), 1,
      anon_sym_RPAREN,
    STATE(812), 1,
      sym_array,
    STATE(814), 1,
      sym_object,
    STATE(1009), 2,
      sym_assignment_pattern,
      sym_rest_parameter,
    ACTIONS(2104), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2051), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(2049), 7,
      anon_sym_export,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26846] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(330), 1,
      anon_sym_LBRACK,
    ACTIONS(548), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2100), 1,
      sym_identifier,
    ACTIONS(2128), 1,
      anon_sym_RPAREN,
    STATE(812), 1,
      sym_array,
    STATE(814), 1,
      sym_object,
    STATE(1009), 2,
      sym_assignment_pattern,
      sym_rest_parameter,
    ACTIONS(2104), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26881] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(1993), 1,
      anon_sym_LPAREN,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    ACTIONS(2092), 1,
      sym_number,
    STATE(996), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1061), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26912] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(1993), 1,
      anon_sym_LPAREN,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    ACTIONS(2031), 1,
      sym_number,
    STATE(961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1061), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26943] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(330), 1,
      anon_sym_LBRACK,
    ACTIONS(548), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2100), 1,
      sym_identifier,
    ACTIONS(2130), 1,
      anon_sym_RPAREN,
    STATE(812), 1,
      sym_array,
    STATE(814), 1,
      sym_object,
    STATE(1009), 2,
      sym_assignment_pattern,
      sym_rest_parameter,
    ACTIONS(2104), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26978] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2134), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(2132), 7,
      anon_sym_export,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26999] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2140), 1,
      anon_sym_SEMI,
    ACTIONS(2136), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2138), 7,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [27022] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(330), 1,
      anon_sym_LBRACK,
    ACTIONS(548), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2100), 1,
      sym_identifier,
    ACTIONS(2142), 1,
      anon_sym_RPAREN,
    STATE(812), 1,
      sym_array,
    STATE(814), 1,
      sym_object,
    STATE(1009), 2,
      sym_assignment_pattern,
      sym_rest_parameter,
    ACTIONS(2104), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [27057] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    ACTIONS(2092), 1,
      sym_number,
    STATE(996), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1061), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [27085] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    ACTIONS(2031), 1,
      sym_number,
    STATE(961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1061), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [27113] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(879), 1,
      sym_number,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1061), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [27141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2144), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2146), 7,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [27161] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(330), 1,
      anon_sym_LBRACK,
    ACTIONS(548), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2100), 1,
      sym_identifier,
    STATE(812), 1,
      sym_array,
    STATE(814), 1,
      sym_object,
    STATE(1009), 2,
      sym_assignment_pattern,
      sym_rest_parameter,
    ACTIONS(2104), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [27193] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(354), 1,
      anon_sym_DQUOTE,
    ACTIONS(356), 1,
      anon_sym_SQUOTE,
    ACTIONS(1997), 1,
      anon_sym_LBRACK,
    ACTIONS(2122), 1,
      sym_number,
    STATE(977), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1061), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [27221] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      sym_identifier,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2152), 1,
      anon_sym_COLON,
    ACTIONS(2154), 1,
      anon_sym_GT,
    ACTIONS(2156), 1,
      anon_sym_SLASH,
    ACTIONS(2158), 1,
      sym_jsx_identifier,
    ACTIONS(2160), 1,
      anon_sym_DOT,
    STATE(663), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27256] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      sym_identifier,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2152), 1,
      anon_sym_COLON,
    ACTIONS(2154), 1,
      anon_sym_GT,
    ACTIONS(2158), 1,
      sym_jsx_identifier,
    ACTIONS(2160), 1,
      anon_sym_DOT,
    ACTIONS(2162), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27291] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      sym_identifier,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2152), 1,
      anon_sym_COLON,
    ACTIONS(2154), 1,
      anon_sym_GT,
    ACTIONS(2158), 1,
      sym_jsx_identifier,
    ACTIONS(2160), 1,
      anon_sym_DOT,
    ACTIONS(2164), 1,
      anon_sym_SLASH,
    STATE(658), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27326] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      sym_identifier,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2152), 1,
      anon_sym_COLON,
    ACTIONS(2154), 1,
      anon_sym_GT,
    ACTIONS(2158), 1,
      sym_jsx_identifier,
    ACTIONS(2160), 1,
      anon_sym_DOT,
    ACTIONS(2166), 1,
      anon_sym_SLASH,
    STATE(666), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27361] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      sym_identifier,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2154), 1,
      anon_sym_GT,
    ACTIONS(2158), 1,
      sym_jsx_identifier,
    ACTIONS(2160), 1,
      anon_sym_DOT,
    ACTIONS(2166), 1,
      anon_sym_SLASH,
    STATE(666), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27393] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      sym_identifier,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2154), 1,
      anon_sym_GT,
    ACTIONS(2156), 1,
      anon_sym_SLASH,
    ACTIONS(2158), 1,
      sym_jsx_identifier,
    ACTIONS(2160), 1,
      anon_sym_DOT,
    STATE(663), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27425] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      sym_identifier,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2152), 1,
      anon_sym_COLON,
    ACTIONS(2154), 1,
      anon_sym_GT,
    ACTIONS(2156), 1,
      anon_sym_SLASH,
    ACTIONS(2158), 1,
      sym_jsx_identifier,
    STATE(663), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27457] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2168), 1,
      anon_sym_LT,
    ACTIONS(2170), 1,
      anon_sym_DQUOTE,
    ACTIONS(2172), 1,
      anon_sym_SQUOTE,
    STATE(668), 1,
      sym_jsx_opening_element,
    STATE(740), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      sym_string,
  [27483] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2168), 1,
      anon_sym_LT,
    ACTIONS(2170), 1,
      anon_sym_DQUOTE,
    ACTIONS(2172), 1,
      anon_sym_SQUOTE,
    STATE(668), 1,
      sym_jsx_opening_element,
    STATE(738), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      sym_string,
  [27509] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      sym_identifier,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2154), 1,
      anon_sym_GT,
    ACTIONS(2158), 1,
      sym_jsx_identifier,
    ACTIONS(2160), 1,
      anon_sym_DOT,
    ACTIONS(2162), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27541] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      sym_identifier,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2152), 1,
      anon_sym_COLON,
    ACTIONS(2154), 1,
      anon_sym_GT,
    ACTIONS(2158), 1,
      sym_jsx_identifier,
    ACTIONS(2164), 1,
      anon_sym_SLASH,
    STATE(658), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27573] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      sym_identifier,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2152), 1,
      anon_sym_COLON,
    ACTIONS(2154), 1,
      anon_sym_GT,
    ACTIONS(2158), 1,
      sym_jsx_identifier,
    ACTIONS(2162), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27605] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      sym_identifier,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2154), 1,
      anon_sym_GT,
    ACTIONS(2158), 1,
      sym_jsx_identifier,
    ACTIONS(2160), 1,
      anon_sym_DOT,
    ACTIONS(2164), 1,
      anon_sym_SLASH,
    STATE(658), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27637] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      sym_identifier,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2152), 1,
      anon_sym_COLON,
    ACTIONS(2154), 1,
      anon_sym_GT,
    ACTIONS(2158), 1,
      sym_jsx_identifier,
    ACTIONS(2166), 1,
      anon_sym_SLASH,
    STATE(666), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27669] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      sym_identifier,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2158), 1,
      sym_jsx_identifier,
    ACTIONS(2174), 1,
      anon_sym_GT,
    ACTIONS(2176), 1,
      anon_sym_SLASH,
    STATE(670), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27698] = 7,
    ACTIONS(2178), 1,
      anon_sym_LBRACE,
    ACTIONS(2180), 1,
      anon_sym_LT,
    ACTIONS(2182), 1,
      sym_jsx_text,
    ACTIONS(2184), 1,
      sym_comment,
    STATE(553), 1,
      sym_jsx_closing_element,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(674), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [27723] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      sym_identifier,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2154), 1,
      anon_sym_GT,
    ACTIONS(2158), 1,
      sym_jsx_identifier,
    ACTIONS(2164), 1,
      anon_sym_SLASH,
    STATE(658), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27752] = 7,
    ACTIONS(2178), 1,
      anon_sym_LBRACE,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2186), 1,
      anon_sym_LT,
    ACTIONS(2188), 1,
      sym_jsx_text,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(872), 1,
      sym_jsx_closing_element,
    STATE(675), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [27777] = 7,
    ACTIONS(2178), 1,
      anon_sym_LBRACE,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2186), 1,
      anon_sym_LT,
    ACTIONS(2190), 1,
      sym_jsx_text,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(886), 1,
      sym_jsx_closing_element,
    STATE(661), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [27802] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      sym_identifier,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2158), 1,
      sym_jsx_identifier,
    ACTIONS(2174), 1,
      anon_sym_GT,
    ACTIONS(2192), 1,
      anon_sym_SLASH,
    STATE(670), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27831] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      sym_identifier,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2154), 1,
      anon_sym_GT,
    ACTIONS(2158), 1,
      sym_jsx_identifier,
    ACTIONS(2166), 1,
      anon_sym_SLASH,
    STATE(666), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27860] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      sym_identifier,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2154), 1,
      anon_sym_GT,
    ACTIONS(2156), 1,
      anon_sym_SLASH,
    ACTIONS(2158), 1,
      sym_jsx_identifier,
    STATE(663), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27889] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      sym_identifier,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2158), 1,
      sym_jsx_identifier,
    ACTIONS(2174), 1,
      anon_sym_GT,
    ACTIONS(2194), 1,
      anon_sym_SLASH,
    STATE(670), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27918] = 7,
    ACTIONS(2178), 1,
      anon_sym_LBRACE,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2188), 1,
      sym_jsx_text,
    ACTIONS(2196), 1,
      anon_sym_LT,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(730), 1,
      sym_jsx_closing_element,
    STATE(675), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [27943] = 7,
    ACTIONS(2178), 1,
      anon_sym_LBRACE,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2196), 1,
      anon_sym_LT,
    ACTIONS(2198), 1,
      sym_jsx_text,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(729), 1,
      sym_jsx_closing_element,
    STATE(667), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [27968] = 7,
    ACTIONS(2178), 1,
      anon_sym_LBRACE,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2188), 1,
      sym_jsx_text,
    ACTIONS(2200), 1,
      anon_sym_LT,
    STATE(375), 1,
      sym_jsx_closing_element,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(675), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [27993] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2202), 1,
      sym_identifier,
    ACTIONS(2205), 1,
      anon_sym_LBRACE,
    ACTIONS(2208), 1,
      anon_sym_GT,
    ACTIONS(2210), 1,
      anon_sym_SLASH,
    ACTIONS(2212), 1,
      sym_jsx_identifier,
    STATE(670), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [28022] = 7,
    ACTIONS(2178), 1,
      anon_sym_LBRACE,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2200), 1,
      anon_sym_LT,
    ACTIONS(2215), 1,
      sym_jsx_text,
    STATE(431), 1,
      sym_jsx_closing_element,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(669), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [28047] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      sym_identifier,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2154), 1,
      anon_sym_GT,
    ACTIONS(2158), 1,
      sym_jsx_identifier,
    ACTIONS(2162), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [28076] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2148), 1,
      sym_identifier,
    ACTIONS(2150), 1,
      anon_sym_LBRACE,
    ACTIONS(2158), 1,
      sym_jsx_identifier,
    ACTIONS(2174), 1,
      anon_sym_GT,
    ACTIONS(2217), 1,
      anon_sym_SLASH,
    STATE(670), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [28105] = 7,
    ACTIONS(2178), 1,
      anon_sym_LBRACE,
    ACTIONS(2180), 1,
      anon_sym_LT,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2188), 1,
      sym_jsx_text,
    STATE(536), 1,
      sym_jsx_closing_element,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(675), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [28130] = 6,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2219), 1,
      anon_sym_LBRACE,
    ACTIONS(2222), 1,
      anon_sym_LT,
    ACTIONS(2225), 1,
      sym_jsx_text,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(675), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [28152] = 6,
    ACTIONS(2178), 1,
      anon_sym_LBRACE,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2188), 1,
      sym_jsx_text,
    ACTIONS(2228), 1,
      anon_sym_LT,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(675), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [28174] = 6,
    ACTIONS(2178), 1,
      anon_sym_LBRACE,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2230), 1,
      anon_sym_LT,
    ACTIONS(2232), 1,
      sym_jsx_text,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(678), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [28196] = 6,
    ACTIONS(2178), 1,
      anon_sym_LBRACE,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2188), 1,
      sym_jsx_text,
    ACTIONS(2234), 1,
      anon_sym_LT,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(675), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [28218] = 6,
    ACTIONS(2178), 1,
      anon_sym_LBRACE,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2236), 1,
      anon_sym_LT,
    ACTIONS(2238), 1,
      sym_jsx_text,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(680), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [28240] = 6,
    ACTIONS(2178), 1,
      anon_sym_LBRACE,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2188), 1,
      sym_jsx_text,
    ACTIONS(2240), 1,
      anon_sym_LT,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(675), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [28262] = 6,
    ACTIONS(2178), 1,
      anon_sym_LBRACE,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2242), 1,
      anon_sym_LT,
    ACTIONS(2244), 1,
      sym_jsx_text,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(676), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [28284] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 1,
      anon_sym_COLON,
    ACTIONS(2250), 1,
      anon_sym_EQ,
    ACTIONS(2246), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2248), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [28303] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2252), 1,
      sym_identifier,
    STATE(607), 1,
      sym_decorator_member_expression,
    STATE(630), 1,
      sym_decorator_call_expression,
    ACTIONS(2254), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [28322] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    ACTIONS(2260), 1,
      anon_sym_EQ,
    STATE(921), 1,
      sym__initializer,
    STATE(946), 1,
      sym_formal_parameters,
    ACTIONS(2258), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [28342] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2262), 1,
      anon_sym_default,
    ACTIONS(2265), 1,
      anon_sym_RBRACE,
    ACTIONS(2267), 1,
      anon_sym_case,
    STATE(685), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [28360] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(372), 1,
      anon_sym_LBRACE,
    ACTIONS(2270), 1,
      sym_identifier,
    STATE(706), 1,
      sym_array,
    STATE(725), 1,
      sym_object,
    STATE(790), 1,
      sym_variable_declarator,
  [28382] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2274), 1,
      anon_sym_BQUOTE,
    ACTIONS(2276), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2272), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(703), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [28400] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2278), 1,
      anon_sym_default,
    ACTIONS(2280), 1,
      anon_sym_RBRACE,
    ACTIONS(2282), 1,
      anon_sym_case,
    STATE(697), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [28418] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1353), 1,
      anon_sym_DOT,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
  [28438] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2276), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2284), 1,
      anon_sym_BQUOTE,
    ACTIONS(2272), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(703), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [28456] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2276), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2288), 1,
      anon_sym_BQUOTE,
    ACTIONS(2286), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(690), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [28474] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(372), 1,
      anon_sym_LBRACE,
    ACTIONS(2270), 1,
      sym_identifier,
    STATE(706), 1,
      sym_array,
    STATE(725), 1,
      sym_object,
    STATE(794), 1,
      sym_variable_declarator,
  [28496] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    ACTIONS(2260), 1,
      anon_sym_EQ,
    STATE(893), 1,
      sym_formal_parameters,
    STATE(943), 1,
      sym__initializer,
    ACTIONS(2290), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [28516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2292), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2294), 4,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_DOT,
  [28530] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1390), 1,
      anon_sym_LPAREN,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
  [28550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2296), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2298), 4,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT,
      sym_jsx_identifier,
  [28564] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2278), 1,
      anon_sym_default,
    ACTIONS(2282), 1,
      anon_sym_case,
    ACTIONS(2300), 1,
      anon_sym_RBRACE,
    STATE(685), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [28582] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(358), 1,
      anon_sym_BQUOTE,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1368), 1,
      anon_sym_DOT,
    ACTIONS(1605), 1,
      anon_sym_LBRACK,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
  [28602] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2276), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2304), 1,
      anon_sym_BQUOTE,
    ACTIONS(2302), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(687), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [28620] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(883), 1,
      anon_sym_RBRACE,
    ACTIONS(1995), 1,
      anon_sym_EQ,
    STATE(838), 1,
      aux_sym_object_repeat1,
    ACTIONS(1993), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
  [28640] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2310), 1,
      anon_sym_EQ,
    ACTIONS(2306), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2308), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [28656] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(853), 1,
      anon_sym_RBRACE,
    ACTIONS(1995), 1,
      anon_sym_EQ,
    STATE(870), 1,
      aux_sym_object_repeat1,
    ACTIONS(1993), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
  [28676] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2315), 1,
      anon_sym_BQUOTE,
    ACTIONS(2317), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2312), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(703), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [28694] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(372), 1,
      anon_sym_LBRACE,
    ACTIONS(2270), 1,
      sym_identifier,
    STATE(706), 1,
      sym_array,
    STATE(725), 1,
      sym_object,
    STATE(849), 1,
      sym_variable_declarator,
  [28716] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2320), 1,
      sym_identifier,
    ACTIONS(2322), 1,
      anon_sym_SLASH,
    ACTIONS(2324), 1,
      sym_jsx_identifier,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [28735] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2260), 1,
      anon_sym_EQ,
    STATE(868), 1,
      sym__initializer,
    ACTIONS(1633), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [28750] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2320), 1,
      sym_identifier,
    ACTIONS(2324), 1,
      sym_jsx_identifier,
    ACTIONS(2326), 1,
      anon_sym_SLASH,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [28769] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2320), 1,
      sym_identifier,
    ACTIONS(2324), 1,
      sym_jsx_identifier,
    ACTIONS(2328), 1,
      anon_sym_SLASH,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [28788] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2330), 1,
      sym_identifier,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    ACTIONS(2334), 1,
      anon_sym_extends,
    STATE(492), 1,
      sym_class_body,
    STATE(916), 1,
      sym_class_heritage,
  [28807] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2260), 1,
      anon_sym_EQ,
    STATE(839), 1,
      sym__initializer,
    ACTIONS(1392), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [28822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2336), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2338), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [28835] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2340), 1,
      sym_identifier,
    ACTIONS(2342), 1,
      anon_sym_GT,
    ACTIONS(2344), 1,
      sym_jsx_identifier,
    STATE(648), 1,
      sym_nested_identifier,
    STATE(664), 1,
      sym_jsx_namespace_name,
  [28854] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    ACTIONS(2334), 1,
      anon_sym_extends,
    ACTIONS(2346), 1,
      sym_identifier,
    STATE(513), 1,
      sym_class_body,
    STATE(978), 1,
      sym_class_heritage,
  [28873] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    ACTIONS(2334), 1,
      anon_sym_extends,
    ACTIONS(2348), 1,
      sym_identifier,
    STATE(513), 1,
      sym_class_body,
    STATE(978), 1,
      sym_class_heritage,
  [28892] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2320), 1,
      sym_identifier,
    ACTIONS(2324), 1,
      sym_jsx_identifier,
    ACTIONS(2350), 1,
      anon_sym_SLASH,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [28911] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    ACTIONS(2334), 1,
      anon_sym_extends,
    ACTIONS(2352), 1,
      sym_identifier,
    STATE(513), 1,
      sym_class_body,
    STATE(978), 1,
      sym_class_heritage,
  [28930] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(330), 1,
      anon_sym_LBRACK,
    ACTIONS(2354), 1,
      sym_identifier,
    STATE(1065), 1,
      sym_object,
    STATE(1067), 1,
      sym_array,
  [28949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2356), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2358), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [28962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1677), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1679), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [28975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1655), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1657), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [28988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1743), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1745), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_EQ,
    ACTIONS(1993), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(2021), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [29016] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2334), 1,
      anon_sym_extends,
    ACTIONS(2360), 1,
      sym_identifier,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    STATE(397), 1,
      sym_class_body,
    STATE(942), 1,
      sym_class_heritage,
  [29035] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2364), 1,
      sym_identifier,
    ACTIONS(2366), 1,
      anon_sym_GT,
    ACTIONS(2368), 1,
      sym_jsx_identifier,
    STATE(656), 1,
      sym_nested_identifier,
    STATE(660), 1,
      sym_jsx_namespace_name,
  [29054] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2260), 1,
      anon_sym_EQ,
    STATE(867), 1,
      sym__initializer,
    ACTIONS(1642), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [29069] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(2370), 1,
      anon_sym_export,
    ACTIONS(2372), 1,
      anon_sym_class,
    STATE(611), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
  [29088] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2320), 1,
      sym_identifier,
    ACTIONS(2324), 1,
      sym_jsx_identifier,
    ACTIONS(2374), 1,
      anon_sym_SLASH,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [29107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1707), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1709), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1701), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1703), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1629), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1631), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1673), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1675), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1739), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1741), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1719), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1721), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29185] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(316), 1,
      anon_sym_LBRACE,
    ACTIONS(330), 1,
      anon_sym_LBRACK,
    ACTIONS(2376), 1,
      sym_identifier,
    STATE(923), 1,
      sym_object,
    STATE(950), 1,
      sym_array,
  [29204] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2320), 1,
      sym_identifier,
    ACTIONS(2324), 1,
      sym_jsx_identifier,
    ACTIONS(2378), 1,
      anon_sym_SLASH,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [29223] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    ACTIONS(2334), 1,
      anon_sym_extends,
    ACTIONS(2380), 1,
      sym_identifier,
    STATE(492), 1,
      sym_class_body,
    STATE(916), 1,
      sym_class_heritage,
  [29242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2382), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2384), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2386), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2388), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29268] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2334), 1,
      anon_sym_extends,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2390), 1,
      sym_identifier,
    STATE(450), 1,
      sym_class_body,
    STATE(981), 1,
      sym_class_heritage,
  [29287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2392), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2394), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29300] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    ACTIONS(2334), 1,
      anon_sym_extends,
    ACTIONS(2396), 1,
      sym_identifier,
    STATE(492), 1,
      sym_class_body,
    STATE(916), 1,
      sym_class_heritage,
  [29319] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2398), 1,
      sym_identifier,
    ACTIONS(2400), 1,
      anon_sym_GT,
    ACTIONS(2402), 1,
      sym_jsx_identifier,
    STATE(649), 1,
      sym_nested_identifier,
    STATE(665), 1,
      sym_jsx_namespace_name,
  [29338] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2320), 1,
      sym_identifier,
    ACTIONS(2324), 1,
      sym_jsx_identifier,
    ACTIONS(2404), 1,
      anon_sym_SLASH,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [29357] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2320), 1,
      sym_identifier,
    ACTIONS(2324), 1,
      sym_jsx_identifier,
    ACTIONS(2406), 1,
      anon_sym_SLASH,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [29376] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2320), 1,
      sym_identifier,
    ACTIONS(2324), 1,
      sym_jsx_identifier,
    ACTIONS(2408), 1,
      anon_sym_SLASH,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [29395] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2320), 1,
      sym_identifier,
    ACTIONS(2324), 1,
      sym_jsx_identifier,
    ACTIONS(2410), 1,
      anon_sym_SLASH,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [29414] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(2412), 1,
      anon_sym_export,
    ACTIONS(2414), 1,
      anon_sym_class,
    STATE(611), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
  [29433] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2320), 1,
      sym_identifier,
    ACTIONS(2324), 1,
      sym_jsx_identifier,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [29449] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    ACTIONS(2416), 1,
      anon_sym_extends,
    STATE(473), 1,
      sym_class_body,
    STATE(892), 1,
      sym_class_heritage,
  [29465] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2418), 1,
      sym_identifier,
    ACTIONS(2420), 1,
      anon_sym_COMMA,
    ACTIONS(2422), 1,
      anon_sym_RBRACE,
    STATE(855), 1,
      sym__import_export_specifier,
  [29481] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2424), 1,
      sym_identifier,
    ACTIONS(2426), 1,
      sym_jsx_identifier,
    STATE(1019), 1,
      sym_nested_identifier,
    STATE(1063), 1,
      sym_jsx_namespace_name,
  [29497] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_from,
    STATE(963), 1,
      sym__from_clause,
    ACTIONS(2430), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [29511] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(2432), 1,
      anon_sym_class,
    STATE(611), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
  [29527] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    ACTIONS(2434), 1,
      sym_identifier,
    ACTIONS(2436), 1,
      anon_sym_STAR,
    STATE(969), 1,
      sym_formal_parameters,
  [29543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2438), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [29553] = 5,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_DQUOTE,
    ACTIONS(2442), 1,
      aux_sym_string_token1,
    ACTIONS(2444), 1,
      sym_escape_sequence,
    STATE(774), 1,
      aux_sym_string_repeat1,
  [29569] = 5,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2446), 1,
      anon_sym_SQUOTE,
    ACTIONS(2448), 1,
      aux_sym_string_token2,
    ACTIONS(2450), 1,
      sym_escape_sequence,
    STATE(773), 1,
      aux_sym_string_repeat2,
  [29585] = 5,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2442), 1,
      aux_sym_string_token1,
    ACTIONS(2444), 1,
      sym_escape_sequence,
    ACTIONS(2446), 1,
      anon_sym_DQUOTE,
    STATE(774), 1,
      aux_sym_string_repeat1,
  [29601] = 5,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2440), 1,
      anon_sym_SQUOTE,
    ACTIONS(2448), 1,
      aux_sym_string_token2,
    ACTIONS(2450), 1,
      sym_escape_sequence,
    STATE(773), 1,
      aux_sym_string_repeat2,
  [29617] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    ACTIONS(2416), 1,
      anon_sym_extends,
    STATE(216), 1,
      sym_class_body,
    STATE(982), 1,
      sym_class_heritage,
  [29633] = 5,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_SQUOTE,
    ACTIONS(2454), 1,
      aux_sym_string_token2,
    ACTIONS(2456), 1,
      sym_escape_sequence,
    STATE(759), 1,
      aux_sym_string_repeat2,
  [29649] = 5,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2452), 1,
      anon_sym_DQUOTE,
    ACTIONS(2458), 1,
      aux_sym_string_token1,
    ACTIONS(2460), 1,
      sym_escape_sequence,
    STATE(756), 1,
      aux_sym_string_repeat1,
  [29665] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_EQ,
    ACTIONS(2462), 1,
      anon_sym_COMMA,
    ACTIONS(2464), 1,
      anon_sym_RPAREN,
    STATE(817), 1,
      aux_sym_formal_parameters_repeat1,
  [29681] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    ACTIONS(2416), 1,
      anon_sym_extends,
    STATE(501), 1,
      sym_class_body,
    STATE(986), 1,
      sym_class_heritage,
  [29697] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_EQ,
    ACTIONS(2466), 1,
      anon_sym_COMMA,
    ACTIONS(2468), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      aux_sym_formal_parameters_repeat1,
  [29713] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    ACTIONS(2416), 1,
      anon_sym_extends,
    STATE(46), 1,
      sym_class_body,
    STATE(1031), 1,
      sym_class_heritage,
  [29729] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    ACTIONS(2416), 1,
      anon_sym_extends,
    STATE(462), 1,
      sym_class_body,
    STATE(999), 1,
      sym_class_heritage,
  [29745] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    ACTIONS(2416), 1,
      anon_sym_extends,
    STATE(211), 1,
      sym_class_body,
    STATE(1000), 1,
      sym_class_heritage,
  [29761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1993), 4,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
  [29771] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_extends,
    ACTIONS(2470), 1,
      anon_sym_LBRACE,
    STATE(216), 1,
      sym_class_body,
    STATE(900), 1,
      sym_class_heritage,
  [29787] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2472), 1,
      anon_sym_COMMA,
    ACTIONS(2474), 1,
      anon_sym_RPAREN,
    ACTIONS(2476), 1,
      anon_sym_EQ,
    STATE(824), 1,
      aux_sym_formal_parameters_repeat1,
  [29803] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    ACTIONS(2416), 1,
      anon_sym_extends,
    STATE(508), 1,
      sym_class_body,
    STATE(1004), 1,
      sym_class_heritage,
  [29819] = 5,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2478), 1,
      anon_sym_SQUOTE,
    ACTIONS(2480), 1,
      aux_sym_string_token2,
    ACTIONS(2483), 1,
      sym_escape_sequence,
    STATE(773), 1,
      aux_sym_string_repeat2,
  [29835] = 5,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2486), 1,
      anon_sym_DQUOTE,
    ACTIONS(2488), 1,
      aux_sym_string_token1,
    ACTIONS(2491), 1,
      sym_escape_sequence,
    STATE(774), 1,
      aux_sym_string_repeat1,
  [29851] = 5,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2494), 1,
      anon_sym_DQUOTE,
    ACTIONS(2496), 1,
      aux_sym_string_token1,
    ACTIONS(2498), 1,
      sym_escape_sequence,
    STATE(779), 1,
      aux_sym_string_repeat1,
  [29867] = 5,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2494), 1,
      anon_sym_SQUOTE,
    ACTIONS(2500), 1,
      aux_sym_string_token2,
    ACTIONS(2502), 1,
      sym_escape_sequence,
    STATE(782), 1,
      aux_sym_string_repeat2,
  [29883] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2418), 1,
      sym_identifier,
    ACTIONS(2504), 1,
      anon_sym_COMMA,
    ACTIONS(2506), 1,
      anon_sym_RBRACE,
    STATE(818), 1,
      sym__import_export_specifier,
  [29899] = 5,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2508), 1,
      anon_sym_SQUOTE,
    ACTIONS(2510), 1,
      aux_sym_string_token2,
    ACTIONS(2512), 1,
      sym_escape_sequence,
    STATE(757), 1,
      aux_sym_string_repeat2,
  [29915] = 5,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2442), 1,
      aux_sym_string_token1,
    ACTIONS(2444), 1,
      sym_escape_sequence,
    ACTIONS(2514), 1,
      anon_sym_DQUOTE,
    STATE(774), 1,
      aux_sym_string_repeat1,
  [29931] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    ACTIONS(2516), 1,
      sym_identifier,
    ACTIONS(2518), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_formal_parameters,
  [29947] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2416), 1,
      anon_sym_extends,
    ACTIONS(2470), 1,
      anon_sym_LBRACE,
    STATE(211), 1,
      sym_class_body,
    STATE(917), 1,
      sym_class_heritage,
  [29963] = 5,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2448), 1,
      aux_sym_string_token2,
    ACTIONS(2450), 1,
      sym_escape_sequence,
    ACTIONS(2514), 1,
      anon_sym_SQUOTE,
    STATE(773), 1,
      aux_sym_string_repeat2,
  [29979] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2520), 1,
      anon_sym_COMMA,
    STATE(796), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(2522), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [29993] = 5,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2508), 1,
      anon_sym_DQUOTE,
    ACTIONS(2524), 1,
      aux_sym_string_token1,
    ACTIONS(2526), 1,
      sym_escape_sequence,
    STATE(758), 1,
      aux_sym_string_repeat1,
  [30009] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2520), 1,
      anon_sym_COMMA,
    STATE(796), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(2528), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1786), 4,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
  [30033] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    ACTIONS(2530), 1,
      sym_identifier,
    ACTIONS(2532), 1,
      anon_sym_STAR,
    STATE(911), 1,
      sym_formal_parameters,
  [30049] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    ACTIONS(2534), 1,
      sym_identifier,
    ACTIONS(2536), 1,
      anon_sym_STAR,
    STATE(911), 1,
      sym_formal_parameters,
  [30065] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2416), 1,
      anon_sym_extends,
    STATE(370), 1,
      sym_class_body,
    STATE(1040), 1,
      sym_class_heritage,
  [30081] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2520), 1,
      anon_sym_COMMA,
    STATE(785), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(2538), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30095] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(2540), 1,
      anon_sym_class,
    STATE(611), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
  [30111] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    ACTIONS(2416), 1,
      anon_sym_extends,
    STATE(49), 1,
      sym_class_body,
    STATE(907), 1,
      sym_class_heritage,
  [30127] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    ACTIONS(2542), 1,
      sym_identifier,
    ACTIONS(2544), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_formal_parameters,
  [30143] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2520), 1,
      anon_sym_COMMA,
    STATE(783), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(2546), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30157] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2548), 1,
      sym_identifier,
    ACTIONS(2550), 1,
      sym_jsx_identifier,
    STATE(997), 1,
      sym_nested_identifier,
    STATE(1075), 1,
      sym_jsx_namespace_name,
  [30173] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2552), 1,
      anon_sym_COMMA,
    STATE(796), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(2555), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30187] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2557), 1,
      sym_identifier,
    ACTIONS(2559), 1,
      sym_jsx_identifier,
    STATE(1023), 1,
      sym_nested_identifier,
    STATE(1050), 1,
      sym_jsx_namespace_name,
  [30203] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    ACTIONS(2416), 1,
      anon_sym_extends,
    STATE(427), 1,
      sym_class_body,
    STATE(920), 1,
      sym_class_heritage,
  [30219] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2561), 1,
      sym_identifier,
    ACTIONS(2563), 1,
      sym_jsx_identifier,
    STATE(1026), 1,
      sym_nested_identifier,
    STATE(1062), 1,
      sym_jsx_namespace_name,
  [30235] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2565), 1,
      anon_sym_COMMA,
    ACTIONS(2567), 1,
      anon_sym_RPAREN,
    ACTIONS(2569), 1,
      anon_sym_EQ,
    STATE(888), 1,
      aux_sym_formal_parameters_repeat1,
  [30251] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    ACTIONS(2571), 1,
      sym_identifier,
    ACTIONS(2573), 1,
      anon_sym_STAR,
    STATE(948), 1,
      sym_formal_parameters,
  [30267] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    ACTIONS(2575), 1,
      sym_identifier,
    ACTIONS(2577), 1,
      anon_sym_STAR,
    STATE(911), 1,
      sym_formal_parameters,
  [30283] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(2579), 1,
      anon_sym_class,
    STATE(611), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
  [30299] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    ACTIONS(2581), 1,
      sym_identifier,
    ACTIONS(2583), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_formal_parameters,
  [30315] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1471), 1,
      anon_sym_LBRACE,
    ACTIONS(2585), 1,
      anon_sym_STAR,
    STATE(1048), 2,
      sym_namespace_import,
      sym_named_imports,
  [30329] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2587), 1,
      anon_sym_COMMA,
    STATE(806), 1,
      aux_sym_array_repeat1,
    ACTIONS(1777), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [30343] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(2590), 1,
      anon_sym_class,
    STATE(611), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
  [30359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [30369] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(2592), 1,
      anon_sym_RBRACE,
    STATE(828), 1,
      aux_sym_object_repeat1,
  [30382] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_COMMA,
    ACTIONS(1779), 1,
      anon_sym_RBRACK,
    STATE(865), 1,
      aux_sym_array_repeat1,
  [30395] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    ACTIONS(2594), 1,
      sym_identifier,
    STATE(991), 1,
      sym_formal_parameters,
  [30408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2569), 1,
      anon_sym_EQ,
    ACTIONS(2596), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [30419] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2126), 1,
      anon_sym_RPAREN,
    ACTIONS(2598), 1,
      anon_sym_COMMA,
    STATE(826), 1,
      aux_sym_formal_parameters_repeat1,
  [30432] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2476), 1,
      anon_sym_EQ,
    ACTIONS(2600), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [30443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_EQ,
    ACTIONS(2602), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [30454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1995), 1,
      anon_sym_EQ,
    ACTIONS(2604), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [30465] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2130), 1,
      anon_sym_RPAREN,
    ACTIONS(2606), 1,
      anon_sym_COMMA,
    STATE(826), 1,
      aux_sym_formal_parameters_repeat1,
  [30478] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2608), 1,
      anon_sym_COMMA,
    ACTIONS(2610), 1,
      anon_sym_RBRACE,
    STATE(852), 1,
      aux_sym_named_imports_repeat1,
  [30491] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    ACTIONS(2612), 1,
      sym_identifier,
    STATE(927), 1,
      sym_formal_parameters,
  [30504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    ACTIONS(2614), 1,
      sym_identifier,
    STATE(1018), 1,
      sym_formal_parameters,
  [30517] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2616), 1,
      anon_sym_COMMA,
    ACTIONS(2619), 1,
      anon_sym_RBRACE,
    STATE(821), 1,
      aux_sym_object_repeat1,
  [30530] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2621), 1,
      anon_sym_COMMA,
    ACTIONS(2624), 1,
      anon_sym_RBRACE,
    STATE(822), 1,
      aux_sym_export_clause_repeat1,
  [30543] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2418), 1,
      sym_identifier,
    ACTIONS(2626), 1,
      anon_sym_RBRACE,
    STATE(945), 1,
      sym__import_export_specifier,
  [30556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 1,
      anon_sym_RPAREN,
    ACTIONS(2628), 1,
      anon_sym_COMMA,
    STATE(826), 1,
      aux_sym_formal_parameters_repeat1,
  [30569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_COMMA,
    ACTIONS(2630), 1,
      anon_sym_RBRACK,
    STATE(806), 1,
      aux_sym_array_repeat1,
  [30582] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2602), 1,
      anon_sym_RPAREN,
    ACTIONS(2632), 1,
      anon_sym_COMMA,
    STATE(826), 1,
      aux_sym_formal_parameters_repeat1,
  [30595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    ACTIONS(2635), 1,
      sym_identifier,
    STATE(927), 1,
      sym_formal_parameters,
  [30608] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(2637), 1,
      anon_sym_RBRACE,
    STATE(821), 1,
      aux_sym_object_repeat1,
  [30621] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2466), 1,
      anon_sym_COMMA,
    ACTIONS(2468), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      aux_sym_formal_parameters_repeat1,
  [30634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    ACTIONS(2639), 1,
      sym_identifier,
    STATE(927), 1,
      sym_formal_parameters,
  [30647] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_COMMA,
    ACTIONS(1775), 1,
      anon_sym_RBRACK,
    STATE(825), 1,
      aux_sym_array_repeat1,
  [30660] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2641), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [30669] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    ACTIONS(2643), 1,
      sym_identifier,
    STATE(1018), 1,
      sym_formal_parameters,
  [30682] = 2,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2645), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [30691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1541), 1,
      anon_sym_EQ,
    ACTIONS(1786), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
  [30702] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2647), 1,
      anon_sym_LPAREN,
    ACTIONS(2649), 1,
      anon_sym_await,
    STATE(34), 1,
      sym__for_header,
  [30715] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_COMMA,
    ACTIONS(1775), 1,
      anon_sym_RBRACK,
    STATE(806), 1,
      aux_sym_array_repeat1,
  [30728] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(2651), 1,
      anon_sym_RBRACE,
    STATE(821), 1,
      aux_sym_object_repeat1,
  [30741] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2653), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [30750] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2655), 1,
      sym_identifier,
    ACTIONS(2657), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2659), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [30770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      sym_identifier,
    ACTIONS(2663), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30781] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2665), 1,
      anon_sym_LPAREN,
    ACTIONS(2667), 1,
      anon_sym_await,
    STATE(32), 1,
      sym__for_header,
  [30794] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 1,
      anon_sym_COLON,
    ACTIONS(2160), 1,
      anon_sym_DOT,
    ACTIONS(2669), 1,
      anon_sym_GT,
  [30807] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2418), 1,
      sym_identifier,
    ACTIONS(2671), 1,
      anon_sym_RBRACE,
    STATE(1005), 1,
      sym__import_export_specifier,
  [30820] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 1,
      anon_sym_COLON,
    ACTIONS(2160), 1,
      anon_sym_DOT,
    ACTIONS(2673), 1,
      anon_sym_GT,
  [30833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(498), 1,
      sym__automatic_semicolon,
    ACTIONS(494), 2,
      anon_sym_else,
      anon_sym_while,
  [30844] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 1,
      anon_sym_COLON,
    ACTIONS(2160), 1,
      anon_sym_DOT,
    ACTIONS(2675), 1,
      anon_sym_GT,
  [30857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2555), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [30866] = 2,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2336), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [30875] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    ACTIONS(2677), 1,
      sym_identifier,
    STATE(970), 1,
      sym_formal_parameters,
  [30888] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2679), 1,
      anon_sym_COMMA,
    ACTIONS(2681), 1,
      anon_sym_RBRACE,
    STATE(864), 1,
      aux_sym_named_imports_repeat1,
  [30901] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 1,
      anon_sym_COLON,
    ACTIONS(2160), 1,
      anon_sym_DOT,
    ACTIONS(2683), 1,
      anon_sym_GT,
  [30914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_COMMA,
    ACTIONS(2685), 1,
      anon_sym_RPAREN,
    STATE(806), 1,
      aux_sym_array_repeat1,
  [30927] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2687), 1,
      anon_sym_COMMA,
    ACTIONS(2689), 1,
      anon_sym_RBRACE,
    STATE(881), 1,
      aux_sym_export_clause_repeat1,
  [30940] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2418), 1,
      sym_identifier,
    ACTIONS(2681), 1,
      anon_sym_RBRACE,
    STATE(1005), 1,
      sym__import_export_specifier,
  [30953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2693), 1,
      anon_sym_as,
    ACTIONS(2691), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [30964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2695), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [30973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1777), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [30982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_COMMA,
    ACTIONS(1792), 1,
      anon_sym_RPAREN,
    STATE(871), 1,
      aux_sym_array_repeat1,
  [30995] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_COMMA,
    ACTIONS(1792), 1,
      anon_sym_RPAREN,
    STATE(806), 1,
      aux_sym_array_repeat1,
  [31008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_COMMA,
    ACTIONS(1790), 1,
      anon_sym_RPAREN,
    STATE(806), 1,
      aux_sym_array_repeat1,
  [31021] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_COMMA,
    ACTIONS(1790), 1,
      anon_sym_RPAREN,
    STATE(854), 1,
      aux_sym_array_repeat1,
  [31034] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2697), 1,
      anon_sym_COMMA,
    ACTIONS(2700), 1,
      anon_sym_RBRACE,
    STATE(864), 1,
      aux_sym_named_imports_repeat1,
  [31047] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_COMMA,
    ACTIONS(2702), 1,
      anon_sym_RBRACK,
    STATE(806), 1,
      aux_sym_array_repeat1,
  [31060] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    STATE(912), 1,
      sym_string,
  [31073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2704), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [31082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2706), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [31091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(2708), 1,
      anon_sym_RBRACE,
    STATE(821), 1,
      aux_sym_object_repeat1,
  [31104] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(2710), 1,
      anon_sym_RBRACE,
    STATE(821), 1,
      aux_sym_object_repeat1,
  [31117] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_COMMA,
    ACTIONS(2712), 1,
      anon_sym_RPAREN,
    STATE(806), 1,
      aux_sym_array_repeat1,
  [31130] = 2,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(1629), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [31139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    ACTIONS(2716), 1,
      anon_sym_LPAREN,
    STATE(207), 1,
      sym_statement_block,
  [31152] = 2,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(1673), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [31161] = 2,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2718), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [31170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    ACTIONS(2720), 1,
      sym_identifier,
    STATE(1018), 1,
      sym_formal_parameters,
  [31183] = 2,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(1739), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [31192] = 2,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(1719), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [31201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(512), 1,
      anon_sym_COMMA,
    ACTIONS(1779), 1,
      anon_sym_RBRACK,
    STATE(806), 1,
      aux_sym_array_repeat1,
  [31214] = 2,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2382), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [31223] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2722), 1,
      anon_sym_COMMA,
    ACTIONS(2724), 1,
      anon_sym_RBRACE,
    STATE(822), 1,
      aux_sym_export_clause_repeat1,
  [31236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2726), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [31245] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2418), 1,
      sym_identifier,
    ACTIONS(2724), 1,
      anon_sym_RBRACE,
    STATE(945), 1,
      sym__import_export_specifier,
  [31258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(2728), 1,
      anon_sym_RBRACE,
    STATE(869), 1,
      aux_sym_object_repeat1,
  [31271] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(2592), 1,
      anon_sym_RBRACE,
    STATE(821), 1,
      aux_sym_object_repeat1,
  [31284] = 2,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(1701), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [31293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2730), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [31302] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2102), 1,
      anon_sym_RPAREN,
    ACTIONS(2732), 1,
      anon_sym_COMMA,
    STATE(826), 1,
      aux_sym_formal_parameters_repeat1,
  [31315] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(2728), 1,
      anon_sym_RBRACE,
    STATE(821), 1,
      aux_sym_object_repeat1,
  [31328] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    ACTIONS(2734), 1,
      anon_sym_COLON,
    STATE(946), 1,
      sym_formal_parameters,
  [31341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_LBRACE,
    STATE(463), 1,
      sym_statement_block,
  [31351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    STATE(471), 1,
      sym_class_body,
  [31361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    STATE(613), 1,
      sym_statement_block,
  [31371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    STATE(220), 1,
      sym_statement_block,
  [31381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2740), 1,
      anon_sym_LBRACE,
    STATE(213), 1,
      sym_statement_block,
  [31399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(903), 1,
      sym_formal_parameters,
  [31409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(906), 1,
      sym_formal_parameters,
  [31419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 1,
      sym_identifier,
    ACTIONS(2744), 1,
      anon_sym_STAR,
  [31429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2470), 1,
      anon_sym_LBRACE,
    STATE(214), 1,
      sym_class_body,
  [31439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2746), 1,
      sym_identifier,
    ACTIONS(2748), 1,
      anon_sym_STAR,
  [31449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(896), 1,
      sym_formal_parameters,
  [31459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2740), 1,
      anon_sym_LBRACE,
    STATE(215), 1,
      sym_statement_block,
  [31469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_from,
    STATE(919), 1,
      sym__from_clause,
  [31479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2750), 1,
      anon_sym_COMMA,
    ACTIONS(2752), 1,
      anon_sym_from,
  [31489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2740), 1,
      anon_sym_LBRACE,
    STATE(217), 1,
      sym_statement_block,
  [31499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    STATE(48), 1,
      sym_class_body,
  [31509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1802), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(1016), 1,
      sym_formal_parameters,
  [31527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(958), 1,
      sym_formal_parameters,
  [31537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_LBRACE,
    STATE(521), 1,
      sym_statement_block,
  [31547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2754), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(964), 1,
      sym_formal_parameters,
  [31565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2418), 1,
      sym_identifier,
    STATE(1005), 1,
      sym__import_export_specifier,
  [31575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    STATE(612), 1,
      sym_statement_block,
  [31585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    STATE(555), 1,
      sym_class_body,
  [31595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2470), 1,
      anon_sym_LBRACE,
    STATE(209), 1,
      sym_class_body,
  [31605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(965), 1,
      sym_formal_parameters,
  [31615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2756), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    STATE(367), 1,
      sym_class_body,
  [31633] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2758), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2760), 1,
      anon_sym_LPAREN,
    STATE(975), 1,
      sym_parenthesized_expression,
  [31651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2762), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [31659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2764), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [31667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_LBRACE,
    STATE(51), 1,
      sym_statement_block,
  [31677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(925), 1,
      sym_formal_parameters,
  [31687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_LBRACE,
    STATE(515), 1,
      sym_statement_block,
  [31697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(976), 1,
      sym_formal_parameters,
  [31707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2766), 1,
      sym_identifier,
    ACTIONS(2768), 1,
      anon_sym_STAR,
  [31717] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2770), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_LBRACE,
    STATE(56), 1,
      sym_statement_block,
  [31735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_LBRACE,
    STATE(389), 1,
      sym_statement_block,
  [31745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_LBRACE,
    STATE(54), 1,
      sym_statement_block,
  [31755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(1034), 1,
      sym_formal_parameters,
  [31765] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2774), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2428), 1,
      anon_sym_from,
    STATE(963), 1,
      sym__from_clause,
  [31783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2776), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [31791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    STATE(206), 1,
      sym_statement_block,
  [31801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    STATE(208), 1,
      sym_statement_block,
  [31811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1593), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1814), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    STATE(450), 1,
      sym_class_body,
  [31837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2778), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    STATE(210), 1,
      sym_statement_block,
  [31855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2780), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [31863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    STATE(616), 1,
      sym_statement_block,
  [31873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(932), 1,
      sym_formal_parameters,
  [31883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_LBRACE,
    STATE(445), 1,
      sym_statement_block,
  [31893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_LBRACE,
    STATE(381), 1,
      sym_statement_block,
  [31903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2782), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [31911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2784), 1,
      anon_sym_LBRACE,
    STATE(261), 1,
      sym_switch_body,
  [31921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(967), 1,
      sym_formal_parameters,
  [31931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2786), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [31939] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1798), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_LBRACE,
    STATE(382), 1,
      sym_statement_block,
  [31957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2788), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [31965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2790), 1,
      anon_sym_LPAREN,
    STATE(36), 1,
      sym_parenthesized_expression,
  [31975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2792), 1,
      anon_sym_LBRACE,
    STATE(200), 1,
      sym_statement_block,
  [31985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(1008), 1,
      sym_formal_parameters,
  [31995] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2140), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [32003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(915), 1,
      sym_formal_parameters,
  [32013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(955), 1,
      sym_formal_parameters,
  [32023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2794), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [32031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2792), 1,
      anon_sym_LBRACE,
    STATE(215), 1,
      sym_statement_block,
  [32041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2792), 1,
      anon_sym_LBRACE,
    STATE(217), 1,
      sym_statement_block,
  [32051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(1006), 1,
      sym_formal_parameters,
  [32061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_LBRACE,
    STATE(369), 1,
      sym_statement_block,
  [32071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_LBRACE,
    STATE(543), 1,
      sym_statement_block,
  [32081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_LBRACE,
    STATE(364), 1,
      sym_statement_block,
  [32091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_LBRACE,
    STATE(440), 1,
      sym_statement_block,
  [32101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(949), 1,
      sym_formal_parameters,
  [32111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(1003), 1,
      sym_formal_parameters,
  [32121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(1002), 1,
      sym_formal_parameters,
  [32131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2790), 1,
      anon_sym_LPAREN,
    STATE(951), 1,
      sym_parenthesized_expression,
  [32141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2796), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [32149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2792), 1,
      anon_sym_LBRACE,
    STATE(213), 1,
      sym_statement_block,
  [32159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(989), 1,
      sym_formal_parameters,
  [32169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    STATE(492), 1,
      sym_class_body,
  [32179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2798), 1,
      sym_identifier,
    ACTIONS(2800), 1,
      sym_jsx_identifier,
  [32189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2802), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [32197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    STATE(444), 1,
      sym_class_body,
  [32207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    STATE(214), 1,
      sym_class_body,
  [32217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(993), 1,
      sym_formal_parameters,
  [32227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(992), 1,
      sym_formal_parameters,
  [32237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2804), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [32245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    STATE(506), 1,
      sym_class_body,
  [32255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_LBRACE,
    STATE(507), 1,
      sym_statement_block,
  [32265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2806), 1,
      sym_identifier,
    ACTIONS(2808), 1,
      anon_sym_STAR,
  [32275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    STATE(615), 1,
      sym_statement_block,
  [32285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(987), 1,
      sym_formal_parameters,
  [32295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2772), 1,
      anon_sym_LBRACE,
    STATE(446), 1,
      sym_statement_block,
  [32305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_LBRACE,
    STATE(459), 1,
      sym_statement_block,
  [32315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_LBRACE,
    STATE(461), 1,
      sym_statement_block,
  [32325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    STATE(620), 1,
      sym_statement_block,
  [32335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 1,
      anon_sym_COLON,
    ACTIONS(2683), 1,
      anon_sym_GT,
  [32345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(994), 1,
      sym_formal_parameters,
  [32355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2160), 1,
      anon_sym_DOT,
    ACTIONS(2683), 1,
      anon_sym_GT,
  [32365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2810), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [32373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    STATE(464), 1,
      sym_class_body,
  [32383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    STATE(209), 1,
      sym_class_body,
  [32393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1322), 1,
      anon_sym_while,
    ACTIONS(2812), 1,
      anon_sym_else,
  [32403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_LBRACE,
    STATE(517), 1,
      sym_statement_block,
  [32413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_LBRACE,
    STATE(522), 1,
      sym_statement_block,
  [32423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    STATE(525), 1,
      sym_class_body,
  [32433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2814), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [32441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_LBRACE,
    STATE(467), 1,
      sym_statement_block,
  [32451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2816), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [32459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_LBRACE,
    STATE(526), 1,
      sym_statement_block,
  [32469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2602), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [32477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(931), 1,
      sym_formal_parameters,
  [32487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2818), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [32495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2820), 1,
      anon_sym_LPAREN,
    STATE(28), 1,
      sym__for_header,
  [32505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2790), 1,
      anon_sym_LPAREN,
    STATE(26), 1,
      sym_parenthesized_expression,
  [32515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2714), 1,
      anon_sym_LBRACE,
    STATE(188), 1,
      sym_statement_block,
  [32525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(893), 1,
      sym_formal_parameters,
  [32535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_LBRACE,
    STATE(47), 1,
      sym_statement_block,
  [32545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 1,
      anon_sym_COLON,
    ACTIONS(2675), 1,
      anon_sym_GT,
  [32555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2736), 1,
      anon_sym_LBRACE,
    STATE(549), 1,
      sym_statement_block,
  [32565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2160), 1,
      anon_sym_DOT,
    ACTIONS(2675), 1,
      anon_sym_GT,
  [32575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2822), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [32583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(933), 1,
      sym_formal_parameters,
  [32593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 1,
      anon_sym_COLON,
    ACTIONS(2673), 1,
      anon_sym_GT,
  [32603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2160), 1,
      anon_sym_DOT,
    ACTIONS(2673), 1,
      anon_sym_GT,
  [32613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2619), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [32621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2152), 1,
      anon_sym_COLON,
    ACTIONS(2669), 1,
      anon_sym_GT,
  [32631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2160), 1,
      anon_sym_DOT,
    ACTIONS(2669), 1,
      anon_sym_GT,
  [32641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2790), 1,
      anon_sym_LPAREN,
    STATE(24), 1,
      sym_parenthesized_expression,
  [32651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1595), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [32659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2790), 1,
      anon_sym_LPAREN,
    STATE(33), 1,
      sym_parenthesized_expression,
  [32669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2790), 1,
      anon_sym_LPAREN,
    STATE(35), 1,
      sym_parenthesized_expression,
  [32679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2332), 1,
      anon_sym_LBRACE,
    STATE(53), 1,
      sym_class_body,
  [32689] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2824), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [32697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2826), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [32705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2740), 1,
      anon_sym_LBRACE,
    STATE(200), 1,
      sym_statement_block,
  [32715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2418), 1,
      sym_identifier,
    STATE(945), 1,
      sym__import_export_specifier,
  [32725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2790), 1,
      anon_sym_LPAREN,
    STATE(31), 1,
      sym_parenthesized_expression,
  [32735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2820), 1,
      anon_sym_LPAREN,
    STATE(38), 1,
      sym__for_header,
  [32745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1993), 1,
      anon_sym_LPAREN,
    ACTIONS(2088), 1,
      anon_sym_EQ_GT,
  [32755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1993), 1,
      anon_sym_LPAREN,
    ACTIONS(2828), 1,
      anon_sym_EQ_GT,
  [32765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2362), 1,
      anon_sym_LBRACE,
    STATE(386), 1,
      sym_class_body,
  [32775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2830), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [32783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2832), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [32791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2834), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [32799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2256), 1,
      anon_sym_LPAREN,
    STATE(891), 1,
      sym_formal_parameters,
  [32809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1846), 1,
      anon_sym_RPAREN,
  [32816] = 2,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2836), 1,
      sym_regex_pattern,
  [32823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2838), 1,
      sym_identifier,
  [32830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2840), 1,
      anon_sym_from,
  [32837] = 2,
    ACTIONS(2184), 1,
      sym_comment,
    ACTIONS(2842), 1,
      sym_regex_pattern,
  [32844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2673), 1,
      anon_sym_GT,
  [32851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2844), 1,
      anon_sym_GT,
  [32858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2476), 1,
      anon_sym_EQ,
  [32865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2846), 1,
      anon_sym_RPAREN,
  [32872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2848), 1,
      sym_identifier,
  [32879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2850), 1,
      anon_sym_GT,
  [32886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2569), 1,
      anon_sym_EQ,
  [32893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2852), 1,
      anon_sym_GT,
  [32900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2854), 1,
      anon_sym_GT,
  [32907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1842), 1,
      anon_sym_RPAREN,
  [32914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2856), 1,
      anon_sym_COLON,
  [32921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2858), 1,
      anon_sym_GT,
  [32928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2669), 1,
      anon_sym_GT,
  [32935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2675), 1,
      anon_sym_GT,
  [32942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2860), 1,
      anon_sym_GT,
  [32949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2862), 1,
      anon_sym_RPAREN,
  [32956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2864), 1,
      sym_identifier,
  [32963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2866), 1,
      anon_sym_RPAREN,
  [32970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1993), 1,
      anon_sym_LPAREN,
  [32977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2868), 1,
      sym_identifier,
  [32984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2870), 1,
      sym_identifier,
  [32991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1858), 1,
      anon_sym_RPAREN,
  [32998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2872), 1,
      anon_sym_GT,
  [33005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2874), 1,
      sym_identifier,
  [33012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2876), 1,
      anon_sym_GT,
  [33019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2683), 1,
      anon_sym_GT,
  [33026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2878), 1,
      anon_sym_GT,
  [33033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2880), 1,
      anon_sym_GT,
  [33040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 1,
      anon_sym_RBRACE,
  [33047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2882), 1,
      anon_sym_from,
  [33054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2884), 1,
      anon_sym_SLASH2,
  [33061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1881), 1,
      anon_sym_RBRACE,
  [33068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 1,
      anon_sym_RBRACK,
  [33075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2886), 1,
      anon_sym_from,
  [33082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2888), 1,
      anon_sym_from,
  [33089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2890), 1,
      anon_sym_from,
  [33096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1877), 1,
      anon_sym_RBRACK,
  [33103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2892), 1,
      sym_identifier,
  [33110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2894), 1,
      anon_sym_GT,
  [33117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2896), 1,
      sym_identifier,
  [33124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2898), 1,
      anon_sym_RBRACE,
  [33131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1830), 1,
      anon_sym_RPAREN,
  [33138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2900), 1,
      anon_sym_GT,
  [33145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2088), 1,
      anon_sym_EQ_GT,
  [33152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2902), 1,
      sym_identifier,
  [33159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1786), 1,
      anon_sym_LPAREN,
  [33166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1840), 1,
      anon_sym_COLON,
  [33173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2904), 1,
      sym_identifier,
  [33180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2906), 1,
      anon_sym_target,
  [33187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2908), 1,
      anon_sym_EQ_GT,
  [33194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1826), 1,
      anon_sym_RPAREN,
  [33201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2910), 1,
      anon_sym_EQ_GT,
  [33208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2912), 1,
      anon_sym_while,
  [33215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1836), 1,
      anon_sym_RPAREN,
  [33222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1828), 1,
      anon_sym_RPAREN,
  [33229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1832), 1,
      anon_sym_RPAREN,
  [33236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2914), 1,
      anon_sym_EQ_GT,
  [33243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1838), 1,
      anon_sym_RPAREN,
  [33250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2916), 1,
      sym_identifier,
  [33257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2918), 1,
      anon_sym_SLASH2,
  [33264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2920), 1,
      anon_sym_EQ_GT,
  [33271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_RPAREN,
  [33278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      anon_sym_RBRACE,
  [33285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2922), 1,
      anon_sym_GT,
  [33292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1824), 1,
      anon_sym_RPAREN,
  [33299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2924), 1,
      sym_identifier,
  [33306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2926), 1,
      sym_identifier,
  [33313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2928), 1,
      anon_sym_RBRACE,
  [33320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2930), 1,
      anon_sym_function,
  [33327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2932), 1,
      anon_sym_from,
  [33334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2934), 1,
      sym_identifier,
  [33341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2936), 1,
      anon_sym_EQ_GT,
  [33348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1844), 1,
      anon_sym_RPAREN,
  [33355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2938), 1,
      anon_sym_GT,
  [33362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2940), 1,
      anon_sym_target,
  [33369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2942), 1,
      anon_sym_as,
  [33376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2944), 1,
      anon_sym_EQ_GT,
  [33383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1867), 1,
      anon_sym_RPAREN,
  [33390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2946), 1,
      anon_sym_from,
  [33397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2828), 1,
      anon_sym_EQ_GT,
  [33404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2948), 1,
      ts_builtin_sym_end,
  [33411] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2752), 1,
      anon_sym_from,
  [33418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2950), 1,
      sym_identifier,
  [33425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2952), 1,
      sym_identifier,
  [33432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2954), 1,
      sym_identifier,
  [33439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2956), 1,
      anon_sym_function,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(184)] = 0,
  [SMALL_STATE(185)] = 73,
  [SMALL_STATE(186)] = 162,
  [SMALL_STATE(187)] = 235,
  [SMALL_STATE(188)] = 323,
  [SMALL_STATE(189)] = 401,
  [SMALL_STATE(190)] = 471,
  [SMALL_STATE(191)] = 541,
  [SMALL_STATE(192)] = 628,
  [SMALL_STATE(193)] = 714,
  [SMALL_STATE(194)] = 786,
  [SMALL_STATE(195)] = 874,
  [SMALL_STATE(196)] = 964,
  [SMALL_STATE(197)] = 1052,
  [SMALL_STATE(198)] = 1119,
  [SMALL_STATE(199)] = 1186,
  [SMALL_STATE(200)] = 1277,
  [SMALL_STATE(201)] = 1346,
  [SMALL_STATE(202)] = 1413,
  [SMALL_STATE(203)] = 1480,
  [SMALL_STATE(204)] = 1547,
  [SMALL_STATE(205)] = 1616,
  [SMALL_STATE(206)] = 1685,
  [SMALL_STATE(207)] = 1752,
  [SMALL_STATE(208)] = 1819,
  [SMALL_STATE(209)] = 1886,
  [SMALL_STATE(210)] = 1955,
  [SMALL_STATE(211)] = 2022,
  [SMALL_STATE(212)] = 2091,
  [SMALL_STATE(213)] = 2158,
  [SMALL_STATE(214)] = 2227,
  [SMALL_STATE(215)] = 2296,
  [SMALL_STATE(216)] = 2365,
  [SMALL_STATE(217)] = 2434,
  [SMALL_STATE(218)] = 2503,
  [SMALL_STATE(219)] = 2569,
  [SMALL_STATE(220)] = 2635,
  [SMALL_STATE(221)] = 2701,
  [SMALL_STATE(222)] = 2767,
  [SMALL_STATE(223)] = 2833,
  [SMALL_STATE(224)] = 2899,
  [SMALL_STATE(225)] = 2965,
  [SMALL_STATE(226)] = 3031,
  [SMALL_STATE(227)] = 3097,
  [SMALL_STATE(228)] = 3163,
  [SMALL_STATE(229)] = 3229,
  [SMALL_STATE(230)] = 3295,
  [SMALL_STATE(231)] = 3361,
  [SMALL_STATE(232)] = 3427,
  [SMALL_STATE(233)] = 3493,
  [SMALL_STATE(234)] = 3559,
  [SMALL_STATE(235)] = 3625,
  [SMALL_STATE(236)] = 3691,
  [SMALL_STATE(237)] = 3757,
  [SMALL_STATE(238)] = 3823,
  [SMALL_STATE(239)] = 3889,
  [SMALL_STATE(240)] = 3955,
  [SMALL_STATE(241)] = 4021,
  [SMALL_STATE(242)] = 4087,
  [SMALL_STATE(243)] = 4153,
  [SMALL_STATE(244)] = 4219,
  [SMALL_STATE(245)] = 4285,
  [SMALL_STATE(246)] = 4351,
  [SMALL_STATE(247)] = 4417,
  [SMALL_STATE(248)] = 4483,
  [SMALL_STATE(249)] = 4549,
  [SMALL_STATE(250)] = 4615,
  [SMALL_STATE(251)] = 4681,
  [SMALL_STATE(252)] = 4747,
  [SMALL_STATE(253)] = 4813,
  [SMALL_STATE(254)] = 4879,
  [SMALL_STATE(255)] = 4945,
  [SMALL_STATE(256)] = 5011,
  [SMALL_STATE(257)] = 5077,
  [SMALL_STATE(258)] = 5143,
  [SMALL_STATE(259)] = 5211,
  [SMALL_STATE(260)] = 5277,
  [SMALL_STATE(261)] = 5343,
  [SMALL_STATE(262)] = 5409,
  [SMALL_STATE(263)] = 5496,
  [SMALL_STATE(264)] = 5583,
  [SMALL_STATE(265)] = 5659,
  [SMALL_STATE(266)] = 5735,
  [SMALL_STATE(267)] = 5814,
  [SMALL_STATE(268)] = 5893,
  [SMALL_STATE(269)] = 5956,
  [SMALL_STATE(270)] = 6027,
  [SMALL_STATE(271)] = 6090,
  [SMALL_STATE(272)] = 6153,
  [SMALL_STATE(273)] = 6224,
  [SMALL_STATE(274)] = 6295,
  [SMALL_STATE(275)] = 6358,
  [SMALL_STATE(276)] = 6432,
  [SMALL_STATE(277)] = 6506,
  [SMALL_STATE(278)] = 6584,
  [SMALL_STATE(279)] = 6650,
  [SMALL_STATE(280)] = 6721,
  [SMALL_STATE(281)] = 6790,
  [SMALL_STATE(282)] = 6851,
  [SMALL_STATE(283)] = 6912,
  [SMALL_STATE(284)] = 6973,
  [SMALL_STATE(285)] = 7034,
  [SMALL_STATE(286)] = 7095,
  [SMALL_STATE(287)] = 7164,
  [SMALL_STATE(288)] = 7225,
  [SMALL_STATE(289)] = 7298,
  [SMALL_STATE(290)] = 7371,
  [SMALL_STATE(291)] = 7440,
  [SMALL_STATE(292)] = 7511,
  [SMALL_STATE(293)] = 7572,
  [SMALL_STATE(294)] = 7633,
  [SMALL_STATE(295)] = 7694,
  [SMALL_STATE(296)] = 7755,
  [SMALL_STATE(297)] = 7816,
  [SMALL_STATE(298)] = 7877,
  [SMALL_STATE(299)] = 7948,
  [SMALL_STATE(300)] = 8019,
  [SMALL_STATE(301)] = 8080,
  [SMALL_STATE(302)] = 8154,
  [SMALL_STATE(303)] = 8218,
  [SMALL_STATE(304)] = 8286,
  [SMALL_STATE(305)] = 8360,
  [SMALL_STATE(306)] = 8429,
  [SMALL_STATE(307)] = 8499,
  [SMALL_STATE(308)] = 8569,
  [SMALL_STATE(309)] = 8639,
  [SMALL_STATE(310)] = 8709,
  [SMALL_STATE(311)] = 8774,
  [SMALL_STATE(312)] = 8831,
  [SMALL_STATE(313)] = 8888,
  [SMALL_STATE(314)] = 8953,
  [SMALL_STATE(315)] = 9010,
  [SMALL_STATE(316)] = 9077,
  [SMALL_STATE(317)] = 9159,
  [SMALL_STATE(318)] = 9241,
  [SMALL_STATE(319)] = 9323,
  [SMALL_STATE(320)] = 9405,
  [SMALL_STATE(321)] = 9453,
  [SMALL_STATE(322)] = 9535,
  [SMALL_STATE(323)] = 9617,
  [SMALL_STATE(324)] = 9699,
  [SMALL_STATE(325)] = 9753,
  [SMALL_STATE(326)] = 9807,
  [SMALL_STATE(327)] = 9859,
  [SMALL_STATE(328)] = 9919,
  [SMALL_STATE(329)] = 9979,
  [SMALL_STATE(330)] = 10039,
  [SMALL_STATE(331)] = 10097,
  [SMALL_STATE(332)] = 10151,
  [SMALL_STATE(333)] = 10213,
  [SMALL_STATE(334)] = 10289,
  [SMALL_STATE(335)] = 10337,
  [SMALL_STATE(336)] = 10419,
  [SMALL_STATE(337)] = 10501,
  [SMALL_STATE(338)] = 10583,
  [SMALL_STATE(339)] = 10635,
  [SMALL_STATE(340)] = 10717,
  [SMALL_STATE(341)] = 10765,
  [SMALL_STATE(342)] = 10813,
  [SMALL_STATE(343)] = 10893,
  [SMALL_STATE(344)] = 10941,
  [SMALL_STATE(345)] = 11007,
  [SMALL_STATE(346)] = 11055,
  [SMALL_STATE(347)] = 11103,
  [SMALL_STATE(348)] = 11185,
  [SMALL_STATE(349)] = 11267,
  [SMALL_STATE(350)] = 11315,
  [SMALL_STATE(351)] = 11397,
  [SMALL_STATE(352)] = 11465,
  [SMALL_STATE(353)] = 11537,
  [SMALL_STATE(354)] = 11597,
  [SMALL_STATE(355)] = 11679,
  [SMALL_STATE(356)] = 11761,
  [SMALL_STATE(357)] = 11810,
  [SMALL_STATE(358)] = 11859,
  [SMALL_STATE(359)] = 11908,
  [SMALL_STATE(360)] = 11957,
  [SMALL_STATE(361)] = 12006,
  [SMALL_STATE(362)] = 12089,
  [SMALL_STATE(363)] = 12138,
  [SMALL_STATE(364)] = 12189,
  [SMALL_STATE(365)] = 12235,
  [SMALL_STATE(366)] = 12285,
  [SMALL_STATE(367)] = 12331,
  [SMALL_STATE(368)] = 12377,
  [SMALL_STATE(369)] = 12457,
  [SMALL_STATE(370)] = 12503,
  [SMALL_STATE(371)] = 12549,
  [SMALL_STATE(372)] = 12629,
  [SMALL_STATE(373)] = 12709,
  [SMALL_STATE(374)] = 12789,
  [SMALL_STATE(375)] = 12869,
  [SMALL_STATE(376)] = 12915,
  [SMALL_STATE(377)] = 12971,
  [SMALL_STATE(378)] = 13017,
  [SMALL_STATE(379)] = 13073,
  [SMALL_STATE(380)] = 13119,
  [SMALL_STATE(381)] = 13165,
  [SMALL_STATE(382)] = 13211,
  [SMALL_STATE(383)] = 13257,
  [SMALL_STATE(384)] = 13303,
  [SMALL_STATE(385)] = 13383,
  [SMALL_STATE(386)] = 13429,
  [SMALL_STATE(387)] = 13475,
  [SMALL_STATE(388)] = 13521,
  [SMALL_STATE(389)] = 13601,
  [SMALL_STATE(390)] = 13647,
  [SMALL_STATE(391)] = 13727,
  [SMALL_STATE(392)] = 13773,
  [SMALL_STATE(393)] = 13819,
  [SMALL_STATE(394)] = 13899,
  [SMALL_STATE(395)] = 13979,
  [SMALL_STATE(396)] = 14029,
  [SMALL_STATE(397)] = 14075,
  [SMALL_STATE(398)] = 14121,
  [SMALL_STATE(399)] = 14167,
  [SMALL_STATE(400)] = 14213,
  [SMALL_STATE(401)] = 14259,
  [SMALL_STATE(402)] = 14305,
  [SMALL_STATE(403)] = 14351,
  [SMALL_STATE(404)] = 14403,
  [SMALL_STATE(405)] = 14483,
  [SMALL_STATE(406)] = 14543,
  [SMALL_STATE(407)] = 14589,
  [SMALL_STATE(408)] = 14635,
  [SMALL_STATE(409)] = 14701,
  [SMALL_STATE(410)] = 14781,
  [SMALL_STATE(411)] = 14851,
  [SMALL_STATE(412)] = 14925,
  [SMALL_STATE(413)] = 14989,
  [SMALL_STATE(414)] = 15047,
  [SMALL_STATE(415)] = 15125,
  [SMALL_STATE(416)] = 15205,
  [SMALL_STATE(417)] = 15285,
  [SMALL_STATE(418)] = 15331,
  [SMALL_STATE(419)] = 15377,
  [SMALL_STATE(420)] = 15457,
  [SMALL_STATE(421)] = 15503,
  [SMALL_STATE(422)] = 15559,
  [SMALL_STATE(423)] = 15617,
  [SMALL_STATE(424)] = 15675,
  [SMALL_STATE(425)] = 15755,
  [SMALL_STATE(426)] = 15813,
  [SMALL_STATE(427)] = 15859,
  [SMALL_STATE(428)] = 15905,
  [SMALL_STATE(429)] = 15957,
  [SMALL_STATE(430)] = 16003,
  [SMALL_STATE(431)] = 16049,
  [SMALL_STATE(432)] = 16095,
  [SMALL_STATE(433)] = 16141,
  [SMALL_STATE(434)] = 16193,
  [SMALL_STATE(435)] = 16239,
  [SMALL_STATE(436)] = 16285,
  [SMALL_STATE(437)] = 16331,
  [SMALL_STATE(438)] = 16377,
  [SMALL_STATE(439)] = 16457,
  [SMALL_STATE(440)] = 16503,
  [SMALL_STATE(441)] = 16549,
  [SMALL_STATE(442)] = 16595,
  [SMALL_STATE(443)] = 16641,
  [SMALL_STATE(444)] = 16687,
  [SMALL_STATE(445)] = 16733,
  [SMALL_STATE(446)] = 16779,
  [SMALL_STATE(447)] = 16825,
  [SMALL_STATE(448)] = 16871,
  [SMALL_STATE(449)] = 16917,
  [SMALL_STATE(450)] = 17001,
  [SMALL_STATE(451)] = 17047,
  [SMALL_STATE(452)] = 17131,
  [SMALL_STATE(453)] = 17177,
  [SMALL_STATE(454)] = 17261,
  [SMALL_STATE(455)] = 17307,
  [SMALL_STATE(456)] = 17353,
  [SMALL_STATE(457)] = 17437,
  [SMALL_STATE(458)] = 17520,
  [SMALL_STATE(459)] = 17599,
  [SMALL_STATE(460)] = 17648,
  [SMALL_STATE(461)] = 17731,
  [SMALL_STATE(462)] = 17780,
  [SMALL_STATE(463)] = 17829,
  [SMALL_STATE(464)] = 17878,
  [SMALL_STATE(465)] = 17927,
  [SMALL_STATE(466)] = 18006,
  [SMALL_STATE(467)] = 18055,
  [SMALL_STATE(468)] = 18104,
  [SMALL_STATE(469)] = 18153,
  [SMALL_STATE(470)] = 18236,
  [SMALL_STATE(471)] = 18315,
  [SMALL_STATE(472)] = 18364,
  [SMALL_STATE(473)] = 18445,
  [SMALL_STATE(474)] = 18494,
  [SMALL_STATE(475)] = 18543,
  [SMALL_STATE(476)] = 18590,
  [SMALL_STATE(477)] = 18637,
  [SMALL_STATE(478)] = 18720,
  [SMALL_STATE(479)] = 18803,
  [SMALL_STATE(480)] = 18886,
  [SMALL_STATE(481)] = 18933,
  [SMALL_STATE(482)] = 19014,
  [SMALL_STATE(483)] = 19061,
  [SMALL_STATE(484)] = 19140,
  [SMALL_STATE(485)] = 19219,
  [SMALL_STATE(486)] = 19298,
  [SMALL_STATE(487)] = 19377,
  [SMALL_STATE(488)] = 19456,
  [SMALL_STATE(489)] = 19537,
  [SMALL_STATE(490)] = 19588,
  [SMALL_STATE(491)] = 19639,
  [SMALL_STATE(492)] = 19720,
  [SMALL_STATE(493)] = 19764,
  [SMALL_STATE(494)] = 19808,
  [SMALL_STATE(495)] = 19860,
  [SMALL_STATE(496)] = 19940,
  [SMALL_STATE(497)] = 20020,
  [SMALL_STATE(498)] = 20098,
  [SMALL_STATE(499)] = 20176,
  [SMALL_STATE(500)] = 20254,
  [SMALL_STATE(501)] = 20332,
  [SMALL_STATE(502)] = 20376,
  [SMALL_STATE(503)] = 20456,
  [SMALL_STATE(504)] = 20536,
  [SMALL_STATE(505)] = 20616,
  [SMALL_STATE(506)] = 20694,
  [SMALL_STATE(507)] = 20738,
  [SMALL_STATE(508)] = 20782,
  [SMALL_STATE(509)] = 20826,
  [SMALL_STATE(510)] = 20906,
  [SMALL_STATE(511)] = 20986,
  [SMALL_STATE(512)] = 21030,
  [SMALL_STATE(513)] = 21110,
  [SMALL_STATE(514)] = 21154,
  [SMALL_STATE(515)] = 21198,
  [SMALL_STATE(516)] = 21242,
  [SMALL_STATE(517)] = 21286,
  [SMALL_STATE(518)] = 21330,
  [SMALL_STATE(519)] = 21374,
  [SMALL_STATE(520)] = 21418,
  [SMALL_STATE(521)] = 21498,
  [SMALL_STATE(522)] = 21542,
  [SMALL_STATE(523)] = 21586,
  [SMALL_STATE(524)] = 21630,
  [SMALL_STATE(525)] = 21710,
  [SMALL_STATE(526)] = 21754,
  [SMALL_STATE(527)] = 21798,
  [SMALL_STATE(528)] = 21878,
  [SMALL_STATE(529)] = 21930,
  [SMALL_STATE(530)] = 21976,
  [SMALL_STATE(531)] = 22020,
  [SMALL_STATE(532)] = 22100,
  [SMALL_STATE(533)] = 22146,
  [SMALL_STATE(534)] = 22190,
  [SMALL_STATE(535)] = 22238,
  [SMALL_STATE(536)] = 22282,
  [SMALL_STATE(537)] = 22326,
  [SMALL_STATE(538)] = 22370,
  [SMALL_STATE(539)] = 22414,
  [SMALL_STATE(540)] = 22494,
  [SMALL_STATE(541)] = 22538,
  [SMALL_STATE(542)] = 22582,
  [SMALL_STATE(543)] = 22662,
  [SMALL_STATE(544)] = 22706,
  [SMALL_STATE(545)] = 22750,
  [SMALL_STATE(546)] = 22830,
  [SMALL_STATE(547)] = 22874,
  [SMALL_STATE(548)] = 22918,
  [SMALL_STATE(549)] = 22998,
  [SMALL_STATE(550)] = 23042,
  [SMALL_STATE(551)] = 23086,
  [SMALL_STATE(552)] = 23130,
  [SMALL_STATE(553)] = 23174,
  [SMALL_STATE(554)] = 23218,
  [SMALL_STATE(555)] = 23262,
  [SMALL_STATE(556)] = 23306,
  [SMALL_STATE(557)] = 23384,
  [SMALL_STATE(558)] = 23464,
  [SMALL_STATE(559)] = 23508,
  [SMALL_STATE(560)] = 23588,
  [SMALL_STATE(561)] = 23668,
  [SMALL_STATE(562)] = 23746,
  [SMALL_STATE(563)] = 23790,
  [SMALL_STATE(564)] = 23834,
  [SMALL_STATE(565)] = 23911,
  [SMALL_STATE(566)] = 23988,
  [SMALL_STATE(567)] = 24035,
  [SMALL_STATE(568)] = 24112,
  [SMALL_STATE(569)] = 24159,
  [SMALL_STATE(570)] = 24236,
  [SMALL_STATE(571)] = 24313,
  [SMALL_STATE(572)] = 24361,
  [SMALL_STATE(573)] = 24409,
  [SMALL_STATE(574)] = 24457,
  [SMALL_STATE(575)] = 24531,
  [SMALL_STATE(576)] = 24579,
  [SMALL_STATE(577)] = 24653,
  [SMALL_STATE(578)] = 24726,
  [SMALL_STATE(579)] = 24799,
  [SMALL_STATE(580)] = 24867,
  [SMALL_STATE(581)] = 24925,
  [SMALL_STATE(582)] = 24983,
  [SMALL_STATE(583)] = 25041,
  [SMALL_STATE(584)] = 25099,
  [SMALL_STATE(585)] = 25157,
  [SMALL_STATE(586)] = 25215,
  [SMALL_STATE(587)] = 25273,
  [SMALL_STATE(588)] = 25324,
  [SMALL_STATE(589)] = 25375,
  [SMALL_STATE(590)] = 25424,
  [SMALL_STATE(591)] = 25473,
  [SMALL_STATE(592)] = 25522,
  [SMALL_STATE(593)] = 25571,
  [SMALL_STATE(594)] = 25617,
  [SMALL_STATE(595)] = 25669,
  [SMALL_STATE(596)] = 25713,
  [SMALL_STATE(597)] = 25757,
  [SMALL_STATE(598)] = 25801,
  [SMALL_STATE(599)] = 25840,
  [SMALL_STATE(600)] = 25879,
  [SMALL_STATE(601)] = 25920,
  [SMALL_STATE(602)] = 25959,
  [SMALL_STATE(603)] = 26005,
  [SMALL_STATE(604)] = 26045,
  [SMALL_STATE(605)] = 26075,
  [SMALL_STATE(606)] = 26115,
  [SMALL_STATE(607)] = 26149,
  [SMALL_STATE(608)] = 26179,
  [SMALL_STATE(609)] = 26213,
  [SMALL_STATE(610)] = 26236,
  [SMALL_STATE(611)] = 26259,
  [SMALL_STATE(612)] = 26288,
  [SMALL_STATE(613)] = 26310,
  [SMALL_STATE(614)] = 26332,
  [SMALL_STATE(615)] = 26370,
  [SMALL_STATE(616)] = 26392,
  [SMALL_STATE(617)] = 26414,
  [SMALL_STATE(618)] = 26448,
  [SMALL_STATE(619)] = 26484,
  [SMALL_STATE(620)] = 26520,
  [SMALL_STATE(621)] = 26542,
  [SMALL_STATE(622)] = 26577,
  [SMALL_STATE(623)] = 26612,
  [SMALL_STATE(624)] = 26647,
  [SMALL_STATE(625)] = 26668,
  [SMALL_STATE(626)] = 26703,
  [SMALL_STATE(627)] = 26724,
  [SMALL_STATE(628)] = 26755,
  [SMALL_STATE(629)] = 26790,
  [SMALL_STATE(630)] = 26825,
  [SMALL_STATE(631)] = 26846,
  [SMALL_STATE(632)] = 26881,
  [SMALL_STATE(633)] = 26912,
  [SMALL_STATE(634)] = 26943,
  [SMALL_STATE(635)] = 26978,
  [SMALL_STATE(636)] = 26999,
  [SMALL_STATE(637)] = 27022,
  [SMALL_STATE(638)] = 27057,
  [SMALL_STATE(639)] = 27085,
  [SMALL_STATE(640)] = 27113,
  [SMALL_STATE(641)] = 27141,
  [SMALL_STATE(642)] = 27161,
  [SMALL_STATE(643)] = 27193,
  [SMALL_STATE(644)] = 27221,
  [SMALL_STATE(645)] = 27256,
  [SMALL_STATE(646)] = 27291,
  [SMALL_STATE(647)] = 27326,
  [SMALL_STATE(648)] = 27361,
  [SMALL_STATE(649)] = 27393,
  [SMALL_STATE(650)] = 27425,
  [SMALL_STATE(651)] = 27457,
  [SMALL_STATE(652)] = 27483,
  [SMALL_STATE(653)] = 27509,
  [SMALL_STATE(654)] = 27541,
  [SMALL_STATE(655)] = 27573,
  [SMALL_STATE(656)] = 27605,
  [SMALL_STATE(657)] = 27637,
  [SMALL_STATE(658)] = 27669,
  [SMALL_STATE(659)] = 27698,
  [SMALL_STATE(660)] = 27723,
  [SMALL_STATE(661)] = 27752,
  [SMALL_STATE(662)] = 27777,
  [SMALL_STATE(663)] = 27802,
  [SMALL_STATE(664)] = 27831,
  [SMALL_STATE(665)] = 27860,
  [SMALL_STATE(666)] = 27889,
  [SMALL_STATE(667)] = 27918,
  [SMALL_STATE(668)] = 27943,
  [SMALL_STATE(669)] = 27968,
  [SMALL_STATE(670)] = 27993,
  [SMALL_STATE(671)] = 28022,
  [SMALL_STATE(672)] = 28047,
  [SMALL_STATE(673)] = 28076,
  [SMALL_STATE(674)] = 28105,
  [SMALL_STATE(675)] = 28130,
  [SMALL_STATE(676)] = 28152,
  [SMALL_STATE(677)] = 28174,
  [SMALL_STATE(678)] = 28196,
  [SMALL_STATE(679)] = 28218,
  [SMALL_STATE(680)] = 28240,
  [SMALL_STATE(681)] = 28262,
  [SMALL_STATE(682)] = 28284,
  [SMALL_STATE(683)] = 28303,
  [SMALL_STATE(684)] = 28322,
  [SMALL_STATE(685)] = 28342,
  [SMALL_STATE(686)] = 28360,
  [SMALL_STATE(687)] = 28382,
  [SMALL_STATE(688)] = 28400,
  [SMALL_STATE(689)] = 28418,
  [SMALL_STATE(690)] = 28438,
  [SMALL_STATE(691)] = 28456,
  [SMALL_STATE(692)] = 28474,
  [SMALL_STATE(693)] = 28496,
  [SMALL_STATE(694)] = 28516,
  [SMALL_STATE(695)] = 28530,
  [SMALL_STATE(696)] = 28550,
  [SMALL_STATE(697)] = 28564,
  [SMALL_STATE(698)] = 28582,
  [SMALL_STATE(699)] = 28602,
  [SMALL_STATE(700)] = 28620,
  [SMALL_STATE(701)] = 28640,
  [SMALL_STATE(702)] = 28656,
  [SMALL_STATE(703)] = 28676,
  [SMALL_STATE(704)] = 28694,
  [SMALL_STATE(705)] = 28716,
  [SMALL_STATE(706)] = 28735,
  [SMALL_STATE(707)] = 28750,
  [SMALL_STATE(708)] = 28769,
  [SMALL_STATE(709)] = 28788,
  [SMALL_STATE(710)] = 28807,
  [SMALL_STATE(711)] = 28822,
  [SMALL_STATE(712)] = 28835,
  [SMALL_STATE(713)] = 28854,
  [SMALL_STATE(714)] = 28873,
  [SMALL_STATE(715)] = 28892,
  [SMALL_STATE(716)] = 28911,
  [SMALL_STATE(717)] = 28930,
  [SMALL_STATE(718)] = 28949,
  [SMALL_STATE(719)] = 28962,
  [SMALL_STATE(720)] = 28975,
  [SMALL_STATE(721)] = 28988,
  [SMALL_STATE(722)] = 29001,
  [SMALL_STATE(723)] = 29016,
  [SMALL_STATE(724)] = 29035,
  [SMALL_STATE(725)] = 29054,
  [SMALL_STATE(726)] = 29069,
  [SMALL_STATE(727)] = 29088,
  [SMALL_STATE(728)] = 29107,
  [SMALL_STATE(729)] = 29120,
  [SMALL_STATE(730)] = 29133,
  [SMALL_STATE(731)] = 29146,
  [SMALL_STATE(732)] = 29159,
  [SMALL_STATE(733)] = 29172,
  [SMALL_STATE(734)] = 29185,
  [SMALL_STATE(735)] = 29204,
  [SMALL_STATE(736)] = 29223,
  [SMALL_STATE(737)] = 29242,
  [SMALL_STATE(738)] = 29255,
  [SMALL_STATE(739)] = 29268,
  [SMALL_STATE(740)] = 29287,
  [SMALL_STATE(741)] = 29300,
  [SMALL_STATE(742)] = 29319,
  [SMALL_STATE(743)] = 29338,
  [SMALL_STATE(744)] = 29357,
  [SMALL_STATE(745)] = 29376,
  [SMALL_STATE(746)] = 29395,
  [SMALL_STATE(747)] = 29414,
  [SMALL_STATE(748)] = 29433,
  [SMALL_STATE(749)] = 29449,
  [SMALL_STATE(750)] = 29465,
  [SMALL_STATE(751)] = 29481,
  [SMALL_STATE(752)] = 29497,
  [SMALL_STATE(753)] = 29511,
  [SMALL_STATE(754)] = 29527,
  [SMALL_STATE(755)] = 29543,
  [SMALL_STATE(756)] = 29553,
  [SMALL_STATE(757)] = 29569,
  [SMALL_STATE(758)] = 29585,
  [SMALL_STATE(759)] = 29601,
  [SMALL_STATE(760)] = 29617,
  [SMALL_STATE(761)] = 29633,
  [SMALL_STATE(762)] = 29649,
  [SMALL_STATE(763)] = 29665,
  [SMALL_STATE(764)] = 29681,
  [SMALL_STATE(765)] = 29697,
  [SMALL_STATE(766)] = 29713,
  [SMALL_STATE(767)] = 29729,
  [SMALL_STATE(768)] = 29745,
  [SMALL_STATE(769)] = 29761,
  [SMALL_STATE(770)] = 29771,
  [SMALL_STATE(771)] = 29787,
  [SMALL_STATE(772)] = 29803,
  [SMALL_STATE(773)] = 29819,
  [SMALL_STATE(774)] = 29835,
  [SMALL_STATE(775)] = 29851,
  [SMALL_STATE(776)] = 29867,
  [SMALL_STATE(777)] = 29883,
  [SMALL_STATE(778)] = 29899,
  [SMALL_STATE(779)] = 29915,
  [SMALL_STATE(780)] = 29931,
  [SMALL_STATE(781)] = 29947,
  [SMALL_STATE(782)] = 29963,
  [SMALL_STATE(783)] = 29979,
  [SMALL_STATE(784)] = 29993,
  [SMALL_STATE(785)] = 30009,
  [SMALL_STATE(786)] = 30023,
  [SMALL_STATE(787)] = 30033,
  [SMALL_STATE(788)] = 30049,
  [SMALL_STATE(789)] = 30065,
  [SMALL_STATE(790)] = 30081,
  [SMALL_STATE(791)] = 30095,
  [SMALL_STATE(792)] = 30111,
  [SMALL_STATE(793)] = 30127,
  [SMALL_STATE(794)] = 30143,
  [SMALL_STATE(795)] = 30157,
  [SMALL_STATE(796)] = 30173,
  [SMALL_STATE(797)] = 30187,
  [SMALL_STATE(798)] = 30203,
  [SMALL_STATE(799)] = 30219,
  [SMALL_STATE(800)] = 30235,
  [SMALL_STATE(801)] = 30251,
  [SMALL_STATE(802)] = 30267,
  [SMALL_STATE(803)] = 30283,
  [SMALL_STATE(804)] = 30299,
  [SMALL_STATE(805)] = 30315,
  [SMALL_STATE(806)] = 30329,
  [SMALL_STATE(807)] = 30343,
  [SMALL_STATE(808)] = 30359,
  [SMALL_STATE(809)] = 30369,
  [SMALL_STATE(810)] = 30382,
  [SMALL_STATE(811)] = 30395,
  [SMALL_STATE(812)] = 30408,
  [SMALL_STATE(813)] = 30419,
  [SMALL_STATE(814)] = 30432,
  [SMALL_STATE(815)] = 30443,
  [SMALL_STATE(816)] = 30454,
  [SMALL_STATE(817)] = 30465,
  [SMALL_STATE(818)] = 30478,
  [SMALL_STATE(819)] = 30491,
  [SMALL_STATE(820)] = 30504,
  [SMALL_STATE(821)] = 30517,
  [SMALL_STATE(822)] = 30530,
  [SMALL_STATE(823)] = 30543,
  [SMALL_STATE(824)] = 30556,
  [SMALL_STATE(825)] = 30569,
  [SMALL_STATE(826)] = 30582,
  [SMALL_STATE(827)] = 30595,
  [SMALL_STATE(828)] = 30608,
  [SMALL_STATE(829)] = 30621,
  [SMALL_STATE(830)] = 30634,
  [SMALL_STATE(831)] = 30647,
  [SMALL_STATE(832)] = 30660,
  [SMALL_STATE(833)] = 30669,
  [SMALL_STATE(834)] = 30682,
  [SMALL_STATE(835)] = 30691,
  [SMALL_STATE(836)] = 30702,
  [SMALL_STATE(837)] = 30715,
  [SMALL_STATE(838)] = 30728,
  [SMALL_STATE(839)] = 30741,
  [SMALL_STATE(840)] = 30750,
  [SMALL_STATE(841)] = 30761,
  [SMALL_STATE(842)] = 30770,
  [SMALL_STATE(843)] = 30781,
  [SMALL_STATE(844)] = 30794,
  [SMALL_STATE(845)] = 30807,
  [SMALL_STATE(846)] = 30820,
  [SMALL_STATE(847)] = 30833,
  [SMALL_STATE(848)] = 30844,
  [SMALL_STATE(849)] = 30857,
  [SMALL_STATE(850)] = 30866,
  [SMALL_STATE(851)] = 30875,
  [SMALL_STATE(852)] = 30888,
  [SMALL_STATE(853)] = 30901,
  [SMALL_STATE(854)] = 30914,
  [SMALL_STATE(855)] = 30927,
  [SMALL_STATE(856)] = 30940,
  [SMALL_STATE(857)] = 30953,
  [SMALL_STATE(858)] = 30964,
  [SMALL_STATE(859)] = 30973,
  [SMALL_STATE(860)] = 30982,
  [SMALL_STATE(861)] = 30995,
  [SMALL_STATE(862)] = 31008,
  [SMALL_STATE(863)] = 31021,
  [SMALL_STATE(864)] = 31034,
  [SMALL_STATE(865)] = 31047,
  [SMALL_STATE(866)] = 31060,
  [SMALL_STATE(867)] = 31073,
  [SMALL_STATE(868)] = 31082,
  [SMALL_STATE(869)] = 31091,
  [SMALL_STATE(870)] = 31104,
  [SMALL_STATE(871)] = 31117,
  [SMALL_STATE(872)] = 31130,
  [SMALL_STATE(873)] = 31139,
  [SMALL_STATE(874)] = 31152,
  [SMALL_STATE(875)] = 31161,
  [SMALL_STATE(876)] = 31170,
  [SMALL_STATE(877)] = 31183,
  [SMALL_STATE(878)] = 31192,
  [SMALL_STATE(879)] = 31201,
  [SMALL_STATE(880)] = 31214,
  [SMALL_STATE(881)] = 31223,
  [SMALL_STATE(882)] = 31236,
  [SMALL_STATE(883)] = 31245,
  [SMALL_STATE(884)] = 31258,
  [SMALL_STATE(885)] = 31271,
  [SMALL_STATE(886)] = 31284,
  [SMALL_STATE(887)] = 31293,
  [SMALL_STATE(888)] = 31302,
  [SMALL_STATE(889)] = 31315,
  [SMALL_STATE(890)] = 31328,
  [SMALL_STATE(891)] = 31341,
  [SMALL_STATE(892)] = 31351,
  [SMALL_STATE(893)] = 31361,
  [SMALL_STATE(894)] = 31371,
  [SMALL_STATE(895)] = 31381,
  [SMALL_STATE(896)] = 31389,
  [SMALL_STATE(897)] = 31399,
  [SMALL_STATE(898)] = 31409,
  [SMALL_STATE(899)] = 31419,
  [SMALL_STATE(900)] = 31429,
  [SMALL_STATE(901)] = 31439,
  [SMALL_STATE(902)] = 31449,
  [SMALL_STATE(903)] = 31459,
  [SMALL_STATE(904)] = 31469,
  [SMALL_STATE(905)] = 31479,
  [SMALL_STATE(906)] = 31489,
  [SMALL_STATE(907)] = 31499,
  [SMALL_STATE(908)] = 31509,
  [SMALL_STATE(909)] = 31517,
  [SMALL_STATE(910)] = 31527,
  [SMALL_STATE(911)] = 31537,
  [SMALL_STATE(912)] = 31547,
  [SMALL_STATE(913)] = 31555,
  [SMALL_STATE(914)] = 31565,
  [SMALL_STATE(915)] = 31575,
  [SMALL_STATE(916)] = 31585,
  [SMALL_STATE(917)] = 31595,
  [SMALL_STATE(918)] = 31605,
  [SMALL_STATE(919)] = 31615,
  [SMALL_STATE(920)] = 31623,
  [SMALL_STATE(921)] = 31633,
  [SMALL_STATE(922)] = 31641,
  [SMALL_STATE(923)] = 31651,
  [SMALL_STATE(924)] = 31659,
  [SMALL_STATE(925)] = 31667,
  [SMALL_STATE(926)] = 31677,
  [SMALL_STATE(927)] = 31687,
  [SMALL_STATE(928)] = 31697,
  [SMALL_STATE(929)] = 31707,
  [SMALL_STATE(930)] = 31717,
  [SMALL_STATE(931)] = 31725,
  [SMALL_STATE(932)] = 31735,
  [SMALL_STATE(933)] = 31745,
  [SMALL_STATE(934)] = 31755,
  [SMALL_STATE(935)] = 31765,
  [SMALL_STATE(936)] = 31773,
  [SMALL_STATE(937)] = 31783,
  [SMALL_STATE(938)] = 31791,
  [SMALL_STATE(939)] = 31801,
  [SMALL_STATE(940)] = 31811,
  [SMALL_STATE(941)] = 31819,
  [SMALL_STATE(942)] = 31827,
  [SMALL_STATE(943)] = 31837,
  [SMALL_STATE(944)] = 31845,
  [SMALL_STATE(945)] = 31855,
  [SMALL_STATE(946)] = 31863,
  [SMALL_STATE(947)] = 31873,
  [SMALL_STATE(948)] = 31883,
  [SMALL_STATE(949)] = 31893,
  [SMALL_STATE(950)] = 31903,
  [SMALL_STATE(951)] = 31911,
  [SMALL_STATE(952)] = 31921,
  [SMALL_STATE(953)] = 31931,
  [SMALL_STATE(954)] = 31939,
  [SMALL_STATE(955)] = 31947,
  [SMALL_STATE(956)] = 31957,
  [SMALL_STATE(957)] = 31965,
  [SMALL_STATE(958)] = 31975,
  [SMALL_STATE(959)] = 31985,
  [SMALL_STATE(960)] = 31995,
  [SMALL_STATE(961)] = 32003,
  [SMALL_STATE(962)] = 32013,
  [SMALL_STATE(963)] = 32023,
  [SMALL_STATE(964)] = 32031,
  [SMALL_STATE(965)] = 32041,
  [SMALL_STATE(966)] = 32051,
  [SMALL_STATE(967)] = 32061,
  [SMALL_STATE(968)] = 32071,
  [SMALL_STATE(969)] = 32081,
  [SMALL_STATE(970)] = 32091,
  [SMALL_STATE(971)] = 32101,
  [SMALL_STATE(972)] = 32111,
  [SMALL_STATE(973)] = 32121,
  [SMALL_STATE(974)] = 32131,
  [SMALL_STATE(975)] = 32141,
  [SMALL_STATE(976)] = 32149,
  [SMALL_STATE(977)] = 32159,
  [SMALL_STATE(978)] = 32169,
  [SMALL_STATE(979)] = 32179,
  [SMALL_STATE(980)] = 32189,
  [SMALL_STATE(981)] = 32197,
  [SMALL_STATE(982)] = 32207,
  [SMALL_STATE(983)] = 32217,
  [SMALL_STATE(984)] = 32227,
  [SMALL_STATE(985)] = 32237,
  [SMALL_STATE(986)] = 32245,
  [SMALL_STATE(987)] = 32255,
  [SMALL_STATE(988)] = 32265,
  [SMALL_STATE(989)] = 32275,
  [SMALL_STATE(990)] = 32285,
  [SMALL_STATE(991)] = 32295,
  [SMALL_STATE(992)] = 32305,
  [SMALL_STATE(993)] = 32315,
  [SMALL_STATE(994)] = 32325,
  [SMALL_STATE(995)] = 32335,
  [SMALL_STATE(996)] = 32345,
  [SMALL_STATE(997)] = 32355,
  [SMALL_STATE(998)] = 32365,
  [SMALL_STATE(999)] = 32373,
  [SMALL_STATE(1000)] = 32383,
  [SMALL_STATE(1001)] = 32393,
  [SMALL_STATE(1002)] = 32403,
  [SMALL_STATE(1003)] = 32413,
  [SMALL_STATE(1004)] = 32423,
  [SMALL_STATE(1005)] = 32433,
  [SMALL_STATE(1006)] = 32441,
  [SMALL_STATE(1007)] = 32451,
  [SMALL_STATE(1008)] = 32459,
  [SMALL_STATE(1009)] = 32469,
  [SMALL_STATE(1010)] = 32477,
  [SMALL_STATE(1011)] = 32487,
  [SMALL_STATE(1012)] = 32495,
  [SMALL_STATE(1013)] = 32505,
  [SMALL_STATE(1014)] = 32515,
  [SMALL_STATE(1015)] = 32525,
  [SMALL_STATE(1016)] = 32535,
  [SMALL_STATE(1017)] = 32545,
  [SMALL_STATE(1018)] = 32555,
  [SMALL_STATE(1019)] = 32565,
  [SMALL_STATE(1020)] = 32575,
  [SMALL_STATE(1021)] = 32583,
  [SMALL_STATE(1022)] = 32593,
  [SMALL_STATE(1023)] = 32603,
  [SMALL_STATE(1024)] = 32613,
  [SMALL_STATE(1025)] = 32621,
  [SMALL_STATE(1026)] = 32631,
  [SMALL_STATE(1027)] = 32641,
  [SMALL_STATE(1028)] = 32651,
  [SMALL_STATE(1029)] = 32659,
  [SMALL_STATE(1030)] = 32669,
  [SMALL_STATE(1031)] = 32679,
  [SMALL_STATE(1032)] = 32689,
  [SMALL_STATE(1033)] = 32697,
  [SMALL_STATE(1034)] = 32705,
  [SMALL_STATE(1035)] = 32715,
  [SMALL_STATE(1036)] = 32725,
  [SMALL_STATE(1037)] = 32735,
  [SMALL_STATE(1038)] = 32745,
  [SMALL_STATE(1039)] = 32755,
  [SMALL_STATE(1040)] = 32765,
  [SMALL_STATE(1041)] = 32775,
  [SMALL_STATE(1042)] = 32783,
  [SMALL_STATE(1043)] = 32791,
  [SMALL_STATE(1044)] = 32799,
  [SMALL_STATE(1045)] = 32809,
  [SMALL_STATE(1046)] = 32816,
  [SMALL_STATE(1047)] = 32823,
  [SMALL_STATE(1048)] = 32830,
  [SMALL_STATE(1049)] = 32837,
  [SMALL_STATE(1050)] = 32844,
  [SMALL_STATE(1051)] = 32851,
  [SMALL_STATE(1052)] = 32858,
  [SMALL_STATE(1053)] = 32865,
  [SMALL_STATE(1054)] = 32872,
  [SMALL_STATE(1055)] = 32879,
  [SMALL_STATE(1056)] = 32886,
  [SMALL_STATE(1057)] = 32893,
  [SMALL_STATE(1058)] = 32900,
  [SMALL_STATE(1059)] = 32907,
  [SMALL_STATE(1060)] = 32914,
  [SMALL_STATE(1061)] = 32921,
  [SMALL_STATE(1062)] = 32928,
  [SMALL_STATE(1063)] = 32935,
  [SMALL_STATE(1064)] = 32942,
  [SMALL_STATE(1065)] = 32949,
  [SMALL_STATE(1066)] = 32956,
  [SMALL_STATE(1067)] = 32963,
  [SMALL_STATE(1068)] = 32970,
  [SMALL_STATE(1069)] = 32977,
  [SMALL_STATE(1070)] = 32984,
  [SMALL_STATE(1071)] = 32991,
  [SMALL_STATE(1072)] = 32998,
  [SMALL_STATE(1073)] = 33005,
  [SMALL_STATE(1074)] = 33012,
  [SMALL_STATE(1075)] = 33019,
  [SMALL_STATE(1076)] = 33026,
  [SMALL_STATE(1077)] = 33033,
  [SMALL_STATE(1078)] = 33040,
  [SMALL_STATE(1079)] = 33047,
  [SMALL_STATE(1080)] = 33054,
  [SMALL_STATE(1081)] = 33061,
  [SMALL_STATE(1082)] = 33068,
  [SMALL_STATE(1083)] = 33075,
  [SMALL_STATE(1084)] = 33082,
  [SMALL_STATE(1085)] = 33089,
  [SMALL_STATE(1086)] = 33096,
  [SMALL_STATE(1087)] = 33103,
  [SMALL_STATE(1088)] = 33110,
  [SMALL_STATE(1089)] = 33117,
  [SMALL_STATE(1090)] = 33124,
  [SMALL_STATE(1091)] = 33131,
  [SMALL_STATE(1092)] = 33138,
  [SMALL_STATE(1093)] = 33145,
  [SMALL_STATE(1094)] = 33152,
  [SMALL_STATE(1095)] = 33159,
  [SMALL_STATE(1096)] = 33166,
  [SMALL_STATE(1097)] = 33173,
  [SMALL_STATE(1098)] = 33180,
  [SMALL_STATE(1099)] = 33187,
  [SMALL_STATE(1100)] = 33194,
  [SMALL_STATE(1101)] = 33201,
  [SMALL_STATE(1102)] = 33208,
  [SMALL_STATE(1103)] = 33215,
  [SMALL_STATE(1104)] = 33222,
  [SMALL_STATE(1105)] = 33229,
  [SMALL_STATE(1106)] = 33236,
  [SMALL_STATE(1107)] = 33243,
  [SMALL_STATE(1108)] = 33250,
  [SMALL_STATE(1109)] = 33257,
  [SMALL_STATE(1110)] = 33264,
  [SMALL_STATE(1111)] = 33271,
  [SMALL_STATE(1112)] = 33278,
  [SMALL_STATE(1113)] = 33285,
  [SMALL_STATE(1114)] = 33292,
  [SMALL_STATE(1115)] = 33299,
  [SMALL_STATE(1116)] = 33306,
  [SMALL_STATE(1117)] = 33313,
  [SMALL_STATE(1118)] = 33320,
  [SMALL_STATE(1119)] = 33327,
  [SMALL_STATE(1120)] = 33334,
  [SMALL_STATE(1121)] = 33341,
  [SMALL_STATE(1122)] = 33348,
  [SMALL_STATE(1123)] = 33355,
  [SMALL_STATE(1124)] = 33362,
  [SMALL_STATE(1125)] = 33369,
  [SMALL_STATE(1126)] = 33376,
  [SMALL_STATE(1127)] = 33383,
  [SMALL_STATE(1128)] = 33390,
  [SMALL_STATE(1129)] = 33397,
  [SMALL_STATE(1130)] = 33404,
  [SMALL_STATE(1131)] = 33411,
  [SMALL_STATE(1132)] = 33418,
  [SMALL_STATE(1133)] = 33425,
  [SMALL_STATE(1134)] = 33432,
  [SMALL_STATE(1135)] = 33439,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(194),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(181),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(279),
  [130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(592),
  [133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [135] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5),
  [138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(315),
  [141] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(686),
  [144] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(692),
  [147] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(957),
  [150] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(974),
  [153] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(836),
  [156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(70),
  [159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(117),
  [162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1013),
  [165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(30),
  [168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1014),
  [171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1036),
  [174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(840),
  [177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(842),
  [180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1033),
  [183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(76),
  [186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(103),
  [189] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(202),
  [192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(44),
  [195] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(65),
  [198] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(712),
  [201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1046),
  [204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(714),
  [207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(194),
  [210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(787),
  [213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(94),
  [216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(121),
  [219] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(122),
  [222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(123),
  [225] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(125),
  [228] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(784),
  [231] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(778),
  [234] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(699),
  [237] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(481),
  [240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(481),
  [243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(695),
  [246] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(683),
  [249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(291),
  [252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, .production_id = 63),
  [254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, .production_id = 63),
  [256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, .production_id = 63),
  [258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, .production_id = 63),
  [260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3),
  [262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 3),
  [264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2),
  [266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 2),
  [268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2),
  [290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(298),
  [292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [300] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [382] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [388] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2),
  [394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2),
  [396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2),
  [398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2),
  [400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 80),
  [404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 80),
  [406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 80),
  [408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 80),
  [410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 78),
  [414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 78),
  [416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 78),
  [418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 78),
  [420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 73),
  [424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 73),
  [426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 73),
  [428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 73),
  [430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 37),
  [434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 37),
  [436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 37),
  [438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 37),
  [440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3, .production_id = 71),
  [444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3, .production_id = 71),
  [446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 97),
  [448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 97),
  [450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 6, .production_id = 97),
  [452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 6, .production_id = 97),
  [454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 91),
  [462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 91),
  [464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 91),
  [466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 91),
  [468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 87),
  [472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 87),
  [474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 87),
  [476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 87),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 4),
  [482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 4),
  [484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 87),
  [486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 87),
  [488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, .production_id = 87),
  [490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, .production_id = 87),
  [492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3),
  [496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3),
  [498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [506] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(195),
  [510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1),
  [530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [584] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(263),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(307),
  [596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [638] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [666] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [668] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [672] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [680] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [684] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [686] = {.entry = {.count = 1, .reusable = false}}, SHIFT(275),
  [688] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [690] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [706] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(277),
  [734] = {.entry = {.count = 1, .reusable = false}}, SHIFT(262),
  [736] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [740] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [748] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [752] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [764] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [820] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [824] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [832] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(639),
  [851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [855] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 4), SHIFT(622),
  [859] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1),
  [861] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 4), SHIFT(29),
  [864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [866] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(150),
  [869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [1011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(344),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [1063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 4),
  [1066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(619),
  [1068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [1070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [1072] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 9),
  [1074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 9),
  [1076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [1078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [1080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [1082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [1084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [1088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [1090] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(622),
  [1093] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, .production_id = 8),
  [1095] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, .production_id = 8),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [1099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [1111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 28),
  [1113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 28),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [1117] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(105),
  [1120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [1122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [1124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [1126] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(634),
  [1129] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(924),
  [1132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [1134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [1136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [1138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [1140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [1142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 103),
  [1144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 103),
  [1146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, .production_id = 8),
  [1148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, .production_id = 8),
  [1150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 104),
  [1152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 104),
  [1154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 105),
  [1156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 105),
  [1158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [1160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [1162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 87),
  [1164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 87),
  [1166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 3, .production_id = 24),
  [1168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 3, .production_id = 24),
  [1170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 8),
  [1172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 8),
  [1174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 65),
  [1176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 65),
  [1178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 3),
  [1180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 3),
  [1182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, .production_id = 55),
  [1184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, .production_id = 55),
  [1186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 56),
  [1188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 56),
  [1190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debugger_statement, 2),
  [1192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debugger_statement, 2),
  [1194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 27),
  [1196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 27),
  [1198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 37),
  [1200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 37),
  [1202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 78),
  [1204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 78),
  [1206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3),
  [1208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3),
  [1210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 39),
  [1212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 39),
  [1214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3),
  [1216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3),
  [1218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [1220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [1222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 29),
  [1224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 29),
  [1226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, .production_id = 30),
  [1228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, .production_id = 30),
  [1230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, .production_id = 90),
  [1232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, .production_id = 90),
  [1234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 57),
  [1236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 57),
  [1238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 97),
  [1240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 97),
  [1242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, .production_id = 31),
  [1244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, .production_id = 31),
  [1246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, .production_id = 31),
  [1248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, .production_id = 31),
  [1250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [1252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [1254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [1256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [1258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 102),
  [1260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 102),
  [1262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 83),
  [1264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 83),
  [1266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3),
  [1268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3),
  [1270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 4, .production_id = 64),
  [1272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 4, .production_id = 64),
  [1274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [1276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [1278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 80),
  [1280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 80),
  [1282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [1284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [1286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, .production_id = 56),
  [1288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, .production_id = 56),
  [1290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4),
  [1292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4),
  [1294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 91),
  [1296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 91),
  [1298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3, .production_id = 18),
  [1300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3, .production_id = 18),
  [1302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 87),
  [1304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 87),
  [1306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 73),
  [1308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 73),
  [1310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 4),
  [1312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 4),
  [1314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2, .production_id = 3),
  [1316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2, .production_id = 3),
  [1318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2),
  [1320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2),
  [1322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 22),
  [1324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 22),
  [1326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [1328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 84),
  [1330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 84),
  [1332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 94),
  [1334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 94),
  [1336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 23),
  [1338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 23),
  [1340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(81),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [1345] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 10),
  [1347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 10),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [1351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [1361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [1363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 4),
  [1366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [1368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [1370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [1374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 41),
  [1376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 41),
  [1378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 47),
  [1380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 47),
  [1382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 79),
  [1384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 79),
  [1386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [1388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [1392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 5),
  [1394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(96),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [1399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [1403] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 92),
  [1405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 92),
  [1407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 93),
  [1409] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 93),
  [1411] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 95),
  [1413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 95),
  [1415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(101),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 96),
  [1424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 96),
  [1426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 101),
  [1428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 101),
  [1430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 100),
  [1432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 100),
  [1434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 99),
  [1436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 99),
  [1438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 98),
  [1440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 98),
  [1442] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(629),
  [1445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(956),
  [1448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [1450] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym_rest_parameter, 2),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [1455] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [1457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [1459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [1461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [1463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [1465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [1467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [1469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [1473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 1),
  [1475] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 1),
  [1477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [1479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 48),
  [1481] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [1485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [1493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(176),
  [1495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [1497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [1507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 40),
  [1509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2),
  [1511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [1513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [1515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [1517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3),
  [1519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 88),
  [1521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 40),
  [1523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [1527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 11),
  [1529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 11),
  [1531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 11),
  [1533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 11),
  [1535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 50),
  [1537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 50),
  [1539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3),
  [1541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3),
  [1543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 77),
  [1545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 76),
  [1547] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 74),
  [1549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [1551] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 51),
  [1553] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4),
  [1555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4),
  [1557] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4),
  [1559] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4),
  [1561] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 17),
  [1563] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 17),
  [1565] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3),
  [1567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3),
  [1569] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, .production_id = 17),
  [1571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, .production_id = 17),
  [1573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 46),
  [1575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 54),
  [1577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 42),
  [1579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 46),
  [1581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 52),
  [1583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, .production_id = 34),
  [1585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, .production_id = 34),
  [1587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [1593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3, .production_id = 46),
  [1595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [1597] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 75),
  [1599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 75),
  [1601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [1603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [1605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [1607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [1609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [1611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [1617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [1619] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [1629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_element, 3, .production_id = 53),
  [1631] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_element, 3, .production_id = 53),
  [1633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 7),
  [1635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(87),
  [1638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [1640] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [1642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 6),
  [1644] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(98),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [1649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [1651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 54),
  [1653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 48),
  [1655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2),
  [1661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 3),
  [1663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 3),
  [1665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 8),
  [1667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 8),
  [1669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 45),
  [1671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 45),
  [1673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 4, .production_id = 32),
  [1675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 4, .production_id = 32),
  [1677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [1679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [1681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, .production_id = 68),
  [1683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, .production_id = 68),
  [1685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 44),
  [1687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 44),
  [1689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 2),
  [1691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 2),
  [1693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 12),
  [1695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 12),
  [1697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 14),
  [1699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 14),
  [1701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_element, 2, .production_id = 15),
  [1703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_element, 2, .production_id = 15),
  [1705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 74),
  [1707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_fragment, 6),
  [1709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_fragment, 6),
  [1711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 76),
  [1713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 77),
  [1715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 4, .production_id = 75),
  [1717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 4, .production_id = 75),
  [1719] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_closing_element, 4, .production_id = 89),
  [1721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_closing_element, 4, .production_id = 89),
  [1723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_property, 3),
  [1725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_property, 3),
  [1727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 81),
  [1729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 81),
  [1731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 3, .production_id = 43),
  [1733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, .production_id = 43),
  [1735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 86),
  [1737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 86),
  [1739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 5, .production_id = 66),
  [1741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 5, .production_id = 66),
  [1743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_fragment, 5),
  [1745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_fragment, 5),
  [1747] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 52), REDUCE(sym_assignment_expression, 3, .production_id = 52),
  [1750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 52),
  [1752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 38),
  [1754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 38),
  [1756] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 59), REDUCE(sym_assignment_expression, 3, .production_id = 40),
  [1759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 59),
  [1761] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 59), REDUCE(sym_assignment_expression, 3, .production_id = 46),
  [1764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 42),
  [1766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 51), REDUCE(sym_assignment_expression, 3, .production_id = 51),
  [1769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 51),
  [1771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [1773] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 2, .production_id = 63),
  [1775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [1777] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2),
  [1779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [1783] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [1786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_computed_property_name, 3),
  [1788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [1790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [1792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [1794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [1796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [1798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [1800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [1802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [1804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(82),
  [1807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [1809] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(84),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [1814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [1816] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(621),
  [1819] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(937),
  [1822] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [1826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [1828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [1830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [1832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [1834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 60),
  [1836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [1838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [1842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [1844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [1846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [1848] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(631),
  [1851] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(1032),
  [1854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [1856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [1858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [1860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [1862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [1865] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1),
  [1867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [1869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [1871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [1873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [1877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [1879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [1883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 2),
  [1887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [1889] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym_rest_parameter, 2, .production_id = 25),
  [1892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [1894] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym_rest_parameter, 2, .production_id = 26),
  [1897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [1901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [1903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [1905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [1911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [1913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [1915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [1917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [1919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [1921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [1923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [1925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [1927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1),
  [1929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [1931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [1933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [1935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [1937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [1939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [1941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [1945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [1947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [1949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [1951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [1957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72), SHIFT_REPEAT(769),
  [1960] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72), SHIFT_REPEAT(640),
  [1963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72),
  [1965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72), SHIFT_REPEAT(114),
  [1968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72), SHIFT_REPEAT(601),
  [1971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72), SHIFT_REPEAT(784),
  [1974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72), SHIFT_REPEAT(778),
  [1977] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72), SHIFT_REPEAT(684),
  [1980] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72), SHIFT_REPEAT(683),
  [1983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72), SHIFT_REPEAT(600),
  [1986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72), SHIFT_REPEAT(608),
  [1989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [1993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 4),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [1999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [2001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [2003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [2021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 17),
  [2023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [2025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [2027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [2033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [2035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(599),
  [2037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [2039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [2041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [2043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2, .production_id = 13),
  [2045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2, .production_id = 13),
  [2047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [2049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2),
  [2051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2),
  [2053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1094),
  [2055] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 47),
  [2057] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 47),
  [2059] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 41),
  [2061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 41),
  [2063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 16),
  [2065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 16),
  [2067] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 16), SHIFT_REPEAT(683),
  [2070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 87),
  [2072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 87),
  [2074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 78),
  [2076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 78),
  [2078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [2080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 106),
  [2082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 106),
  [2084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 3, .production_id = 61),
  [2086] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 3, .production_id = 61),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [2090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [2092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [2094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(627),
  [2096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 97),
  [2098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 97),
  [2100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [2102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [2104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [2106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [2108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [2110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [2112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 49),
  [2114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 49),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [2118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 12),
  [2120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 12),
  [2122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [2124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [2126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [2128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [2130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [2132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [2134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [2136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1, .production_id = 35),
  [2138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 1, .production_id = 35),
  [2140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [2142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [2144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 35),
  [2146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 35),
  [2148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [2150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [2152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [2156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [2158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [2160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [2162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [2164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [2166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1074),
  [2168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [2170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [2172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [2176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [2178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [2180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [2182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [2184] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [2186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [2188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [2190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [2192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [2194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [2196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [2198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [2200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [2202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 67), SHIFT_REPEAT(682),
  [2205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 67), SHIFT_REPEAT(74),
  [2208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 67),
  [2210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 67),
  [2212] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 67), SHIFT_REPEAT(682),
  [2215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [2217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [2219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(71),
  [2222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(748),
  [2225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(675),
  [2228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [2230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [2232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [2234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [2236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [2238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [2240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [2242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [2244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [2246] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 1, .production_id = 4),
  [2248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 1, .production_id = 4),
  [2250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [2252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [2254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [2258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 1, .production_id = 36),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [2262] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(1060),
  [2265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [2267] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(111),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [2272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [2274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [2280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [2286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [2288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [2290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 69),
  [2292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3),
  [2294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3),
  [2296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_namespace_name, 3),
  [2298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_namespace_name, 3),
  [2300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [2302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [2304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [2306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 1),
  [2308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 1),
  [2310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [2312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(703),
  [2315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2),
  [2317] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(92),
  [2320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [2322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [2324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [2326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [2328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [2330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [2332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [2334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [2336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_expression, 3),
  [2338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_expression, 3),
  [2340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [2346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [2348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [2350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [2352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [2356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_jsx_opening_element_repeat1, 1, .production_id = 33),
  [2358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_jsx_opening_element_repeat1, 1, .production_id = 33),
  [2360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [2362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [2364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [2366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [2368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [2370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [2372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [2374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [2376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [2378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [2380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [2382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_expression, 2),
  [2384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_expression, 2),
  [2386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 3, .production_id = 4),
  [2388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 3, .production_id = 4),
  [2390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [2392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 3),
  [2394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 3),
  [2396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [2398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [2400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [2402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [2404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [2406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [2408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [2410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [2412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [2414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [2416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [2418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [2420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [2422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [2424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [2428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [2430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [2432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [2434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [2438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 3),
  [2440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [2442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [2444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [2446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [2448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [2450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [2452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [2456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [2458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [2460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [2462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [2470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [2472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [2474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [2478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [2480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(773),
  [2483] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(773),
  [2486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [2488] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(774),
  [2491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(774),
  [2494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [2498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [2502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [2504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [2506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [2508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [2510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [2512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [2514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [2516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [2518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [2520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [2522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [2524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [2526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [2528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [2530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [2532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [2534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [2536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [2538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [2540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [2542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [2548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [2552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(704),
  [2555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [2557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [2559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [2561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [2565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [2569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [2571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [2577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [2581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [2587] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(64),
  [2590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [2592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [2594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [2596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 26),
  [2598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [2600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 25),
  [2602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [2604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 13),
  [2606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [2608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [2614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [2616] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(579),
  [2619] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2),
  [2621] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(1035),
  [2624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [2632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(642),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [2637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [2639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [2641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 4, .production_id = 58),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [2645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 3, .dynamic_precedence = -1, .production_id = 32),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [2651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [2653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 19),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [2659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 5, .production_id = 58),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [2691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 1, .production_id = 5),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [2695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 2),
  [2697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(914),
  [2700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [2704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 20),
  [2706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 21),
  [2708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [2710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [2712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [2714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [2718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 4, .dynamic_precedence = -1, .production_id = 66),
  [2720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [2722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [2724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [2726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3, .production_id = 58),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [2730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [2736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [2740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [2742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [2744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [2746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [2748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [2750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [2752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 1),
  [2754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__from_clause, 2, .production_id = 18),
  [2756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [2758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 70),
  [2760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [2762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_parameter, 2, .production_id = 25),
  [2764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3, .production_id = 13),
  [2766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [2768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [2770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [2772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [2774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [2776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3, .production_id = 26),
  [2778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 85),
  [2780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 58),
  [2782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_parameter, 2, .production_id = 26),
  [2784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [2786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5, .production_id = 13),
  [2788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [2790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [2792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [2794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [2796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [2798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [2800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [2802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4, .production_id = 26),
  [2804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_parameter, 2),
  [2806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [2808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [2810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 3, .production_id = 82),
  [2812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [2814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 62),
  [2816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [2818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4, .production_id = 13),
  [2820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [2822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4, .production_id = 25),
  [2824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3, .production_id = 25),
  [2826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [2828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [2830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5, .production_id = 26),
  [2832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5, .production_id = 25),
  [2834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5),
  [2836] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [2838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [2840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 3),
  [2842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [2844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [2846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [2848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [2850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [2852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [2854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [2856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [2858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [2860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [2862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [2864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [2866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [2868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [2870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [2872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [2874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [2876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [2878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [2880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [2882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3),
  [2884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [2886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 4, .production_id = 62),
  [2888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_import, 3),
  [2890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 5, .production_id = 62),
  [2892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [2894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [2896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [2898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [2900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [2902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [2904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [2906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [2908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [2910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [2912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [2914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [2916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [2918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [2920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [2922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [2924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [2926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [2928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [2930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [2932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 2),
  [2934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [2936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [2938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [2940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [2942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [2944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [2946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3, .production_id = 62),
  [2948] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [2952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [2954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [2956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_javascript_external_scanner_create(void);
void tree_sitter_javascript_external_scanner_destroy(void *);
bool tree_sitter_javascript_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_javascript_external_scanner_serialize(void *, char *);
void tree_sitter_javascript_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_javascript(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .public_symbol_map = ts_symbol_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_javascript_external_scanner_create,
      tree_sitter_javascript_external_scanner_destroy,
      tree_sitter_javascript_external_scanner_scan,
      tree_sitter_javascript_external_scanner_serialize,
      tree_sitter_javascript_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
