#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 11
#define STATE_COUNT 1136
#define LARGE_STATE_COUNT 182
#define SYMBOL_COUNT 227
#define ALIAS_COUNT 7
#define TOKEN_COUNT 121
#define EXTERNAL_TOKEN_COUNT 2
#define FIELD_COUNT 34
#define MAX_ALIAS_SEQUENCE_LENGTH 7

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_LBRACE = 6,
  anon_sym_COMMA = 7,
  anon_sym_RBRACE = 8,
  anon_sym_as = 9,
  anon_sym_import = 10,
  anon_sym_from = 11,
  anon_sym_var = 12,
  anon_sym_let = 13,
  anon_sym_const = 14,
  anon_sym_if = 15,
  anon_sym_else = 16,
  anon_sym_switch = 17,
  anon_sym_for = 18,
  anon_sym_LPAREN = 19,
  anon_sym_RPAREN = 20,
  anon_sym_await = 21,
  anon_sym_in = 22,
  anon_sym_of = 23,
  anon_sym_while = 24,
  anon_sym_do = 25,
  anon_sym_try = 26,
  anon_sym_with = 27,
  anon_sym_break = 28,
  anon_sym_continue = 29,
  anon_sym_debugger = 30,
  anon_sym_return = 31,
  anon_sym_throw = 32,
  anon_sym_SEMI = 33,
  anon_sym_COLON = 34,
  anon_sym_case = 35,
  anon_sym_catch = 36,
  anon_sym_finally = 37,
  anon_sym_yield = 38,
  anon_sym_EQ = 39,
  anon_sym_LBRACK = 40,
  anon_sym_RBRACK = 41,
  anon_sym_LT = 42,
  anon_sym_GT = 43,
  anon_sym_SLASH = 44,
  sym_jsx_text = 45,
  sym_jsx_identifier = 46,
  anon_sym_DOT = 47,
  anon_sym_class = 48,
  anon_sym_extends = 49,
  anon_sym_async = 50,
  anon_sym_function = 51,
  anon_sym_EQ_GT = 52,
  anon_sym_new = 53,
  anon_sym_PLUS_EQ = 54,
  anon_sym_DASH_EQ = 55,
  anon_sym_STAR_EQ = 56,
  anon_sym_SLASH_EQ = 57,
  anon_sym_PERCENT_EQ = 58,
  anon_sym_CARET_EQ = 59,
  anon_sym_AMP_EQ = 60,
  anon_sym_PIPE_EQ = 61,
  anon_sym_GT_GT_EQ = 62,
  anon_sym_GT_GT_GT_EQ = 63,
  anon_sym_LT_LT_EQ = 64,
  anon_sym_STAR_STAR_EQ = 65,
  anon_sym_DOT_DOT_DOT = 66,
  anon_sym_QMARK = 67,
  anon_sym_AMP_AMP = 68,
  anon_sym_PIPE_PIPE = 69,
  anon_sym_GT_GT = 70,
  anon_sym_GT_GT_GT = 71,
  anon_sym_LT_LT = 72,
  anon_sym_AMP = 73,
  anon_sym_CARET = 74,
  anon_sym_PIPE = 75,
  anon_sym_PLUS = 76,
  anon_sym_DASH = 77,
  anon_sym_PERCENT = 78,
  anon_sym_STAR_STAR = 79,
  anon_sym_LT_EQ = 80,
  anon_sym_EQ_EQ = 81,
  anon_sym_EQ_EQ_EQ = 82,
  anon_sym_BANG_EQ = 83,
  anon_sym_BANG_EQ_EQ = 84,
  anon_sym_GT_EQ = 85,
  anon_sym_QMARK_QMARK = 86,
  anon_sym_instanceof = 87,
  anon_sym_BANG = 88,
  anon_sym_TILDE = 89,
  anon_sym_typeof = 90,
  anon_sym_void = 91,
  anon_sym_delete = 92,
  anon_sym_PLUS_PLUS = 93,
  anon_sym_DASH_DASH = 94,
  anon_sym_DQUOTE = 95,
  aux_sym_string_token1 = 96,
  anon_sym_SQUOTE = 97,
  aux_sym_string_token2 = 98,
  sym_escape_sequence = 99,
  sym_comment = 100,
  anon_sym_BQUOTE = 101,
  anon_sym_DOLLAR_LBRACE = 102,
  anon_sym_SLASH2 = 103,
  sym_regex_pattern = 104,
  sym_regex_flags = 105,
  sym_number = 106,
  anon_sym_target = 107,
  sym_this = 108,
  sym_super = 109,
  sym_true = 110,
  sym_false = 111,
  sym_null = 112,
  sym_undefined = 113,
  anon_sym_AT = 114,
  anon_sym_static = 115,
  anon_sym_get = 116,
  anon_sym_set = 117,
  sym_preproc = 118,
  sym__automatic_semicolon = 119,
  sym__template_chars = 120,
  sym_program = 121,
  sym_export_statement = 122,
  sym_export_clause = 123,
  sym__import_export_specifier = 124,
  sym__declaration = 125,
  sym_import = 126,
  sym_import_statement = 127,
  sym_import_clause = 128,
  sym__from_clause = 129,
  sym_namespace_import = 130,
  sym_named_imports = 131,
  sym_expression_statement = 132,
  sym_variable_declaration = 133,
  sym_lexical_declaration = 134,
  sym_variable_declarator = 135,
  sym_statement_block = 136,
  sym_if_statement = 137,
  sym_switch_statement = 138,
  sym_for_statement = 139,
  sym_for_in_statement = 140,
  sym__for_header = 141,
  sym_while_statement = 142,
  sym_do_statement = 143,
  sym_try_statement = 144,
  sym_with_statement = 145,
  sym_break_statement = 146,
  sym_continue_statement = 147,
  sym_debugger_statement = 148,
  sym_return_statement = 149,
  sym_throw_statement = 150,
  sym_empty_statement = 151,
  sym_labeled_statement = 152,
  sym_switch_body = 153,
  sym_switch_case = 154,
  sym_switch_default = 155,
  sym_catch_clause = 156,
  sym_finally_clause = 157,
  sym_parenthesized_expression = 158,
  sym__expression = 159,
  sym_yield_expression = 160,
  sym_object = 161,
  sym_assignment_pattern = 162,
  sym_array = 163,
  sym_jsx_element = 164,
  sym_jsx_fragment = 165,
  sym_jsx_expression = 166,
  sym_jsx_opening_element = 167,
  sym_nested_identifier = 168,
  sym_jsx_namespace_name = 169,
  sym_jsx_closing_element = 170,
  sym_jsx_self_closing_element = 171,
  sym_jsx_attribute = 172,
  sym_class = 173,
  sym_class_declaration = 174,
  sym_class_heritage = 175,
  sym_function = 176,
  sym_function_declaration = 177,
  sym_generator_function = 178,
  sym_generator_function_declaration = 179,
  sym_arrow_function = 180,
  sym_call_expression = 181,
  sym_new_expression = 182,
  sym_await_expression = 183,
  sym_member_expression = 184,
  sym_subscript_expression = 185,
  sym_assignment_expression = 186,
  sym_augmented_assignment_expression = 187,
  sym__initializer = 188,
  sym_spread_element = 189,
  sym_ternary_expression = 190,
  sym_binary_expression = 191,
  sym_unary_expression = 192,
  sym_update_expression = 193,
  sym_sequence_expression = 194,
  sym_string = 195,
  sym_template_string = 196,
  sym_template_substitution = 197,
  sym_regex = 198,
  sym_meta_property = 199,
  sym_arguments = 200,
  sym_decorator = 201,
  sym_decorator_member_expression = 202,
  sym_decorator_call_expression = 203,
  sym_class_body = 204,
  sym_public_field_definition = 205,
  sym_formal_parameters = 206,
  sym_rest_parameter = 207,
  sym_method_definition = 208,
  sym_pair = 209,
  sym__property_name = 210,
  sym_computed_property_name = 211,
  aux_sym_program_repeat1 = 212,
  aux_sym_export_statement_repeat1 = 213,
  aux_sym_export_clause_repeat1 = 214,
  aux_sym_named_imports_repeat1 = 215,
  aux_sym_variable_declaration_repeat1 = 216,
  aux_sym_switch_body_repeat1 = 217,
  aux_sym_object_repeat1 = 218,
  aux_sym_array_repeat1 = 219,
  aux_sym_jsx_element_repeat1 = 220,
  aux_sym_jsx_opening_element_repeat1 = 221,
  aux_sym_string_repeat1 = 222,
  aux_sym_string_repeat2 = 223,
  aux_sym_template_string_repeat1 = 224,
  aux_sym_class_body_repeat1 = 225,
  aux_sym_formal_parameters_repeat1 = 226,
  alias_sym_array_pattern = 227,
  alias_sym_export_specifier = 228,
  alias_sym_import_specifier = 229,
  alias_sym_object_pattern = 230,
  alias_sym_property_identifier = 231,
  alias_sym_shorthand_property_identifier = 232,
  alias_sym_statement_identifier = 233,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_as] = "as",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_await] = "await",
  [anon_sym_in] = "in",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_EQ] = "=",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [sym_jsx_text] = "jsx_text",
  [sym_jsx_identifier] = "identifier",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_extends] = "extends",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "?",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_QMARK_QMARK] = "??",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_typeof] = "typeof",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [anon_sym_target] = "target",
  [sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [sym_preproc] = "preproc",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "_import_export_specifier",
  [sym__declaration] = "_declaration",
  [sym_import] = "import",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym__for_header] = "_for_header",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__expression] = "_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_array] = "array",
  [sym_jsx_element] = "jsx_element",
  [sym_jsx_fragment] = "jsx_fragment",
  [sym_jsx_expression] = "jsx_expression",
  [sym_jsx_opening_element] = "jsx_opening_element",
  [sym_nested_identifier] = "nested_identifier",
  [sym_jsx_namespace_name] = "jsx_namespace_name",
  [sym_jsx_closing_element] = "jsx_closing_element",
  [sym_jsx_self_closing_element] = "jsx_self_closing_element",
  [sym_jsx_attribute] = "jsx_attribute",
  [sym_class] = "class",
  [sym_class_declaration] = "class_declaration",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_function_declaration] = "function_declaration",
  [sym_generator_function] = "generator_function",
  [sym_generator_function_declaration] = "generator_function_declaration",
  [sym_arrow_function] = "arrow_function",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_public_field_definition] = "public_field_definition",
  [sym_formal_parameters] = "formal_parameters",
  [sym_rest_parameter] = "rest_parameter",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_jsx_element_repeat1] = "jsx_element_repeat1",
  [aux_sym_jsx_opening_element_repeat1] = "jsx_opening_element_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [alias_sym_array_pattern] = "array_pattern",
  [alias_sym_export_specifier] = "export_specifier",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_object_pattern] = "object_pattern",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_statement_identifier] = "statement_identifier",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [sym_hash_bang_line] = sym_hash_bang_line,
  [anon_sym_export] = anon_sym_export,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_of] = anon_sym_of,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_debugger] = anon_sym_debugger,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [sym_jsx_text] = sym_jsx_text,
  [sym_jsx_identifier] = sym_identifier,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_extends] = anon_sym_extends,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_function] = anon_sym_function,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_GT_GT_GT_EQ] = anon_sym_GT_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_GT_GT_GT] = anon_sym_GT_GT_GT,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_EQ_EQ_EQ] = anon_sym_EQ_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_BANG_EQ_EQ] = anon_sym_BANG_EQ_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_instanceof] = anon_sym_instanceof,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_void] = anon_sym_void,
  [anon_sym_delete] = anon_sym_delete,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_token1] = aux_sym_string_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_string_token2] = aux_sym_string_token2,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_comment] = sym_comment,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_DOLLAR_LBRACE] = anon_sym_DOLLAR_LBRACE,
  [anon_sym_SLASH2] = anon_sym_SLASH,
  [sym_regex_pattern] = sym_regex_pattern,
  [sym_regex_flags] = sym_regex_flags,
  [sym_number] = sym_number,
  [anon_sym_target] = anon_sym_target,
  [sym_this] = sym_this,
  [sym_super] = sym_super,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_undefined] = sym_undefined,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [sym_preproc] = sym_preproc,
  [sym__automatic_semicolon] = sym__automatic_semicolon,
  [sym__template_chars] = sym__template_chars,
  [sym_program] = sym_program,
  [sym_export_statement] = sym_export_statement,
  [sym_export_clause] = sym_export_clause,
  [sym__import_export_specifier] = sym__import_export_specifier,
  [sym__declaration] = sym__declaration,
  [sym_import] = sym_import,
  [sym_import_statement] = sym_import_statement,
  [sym_import_clause] = sym_import_clause,
  [sym__from_clause] = sym__from_clause,
  [sym_namespace_import] = sym_namespace_import,
  [sym_named_imports] = sym_named_imports,
  [sym_expression_statement] = sym_expression_statement,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_lexical_declaration] = sym_lexical_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_statement_block] = sym_statement_block,
  [sym_if_statement] = sym_if_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_in_statement] = sym_for_in_statement,
  [sym__for_header] = sym__for_header,
  [sym_while_statement] = sym_while_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_with_statement] = sym_with_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_debugger_statement] = sym_debugger_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_throw_statement] = sym_throw_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_case] = sym_switch_case,
  [sym_switch_default] = sym_switch_default,
  [sym_catch_clause] = sym_catch_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__expression] = sym__expression,
  [sym_yield_expression] = sym_yield_expression,
  [sym_object] = sym_object,
  [sym_assignment_pattern] = sym_assignment_pattern,
  [sym_array] = sym_array,
  [sym_jsx_element] = sym_jsx_element,
  [sym_jsx_fragment] = sym_jsx_fragment,
  [sym_jsx_expression] = sym_jsx_expression,
  [sym_jsx_opening_element] = sym_jsx_opening_element,
  [sym_nested_identifier] = sym_nested_identifier,
  [sym_jsx_namespace_name] = sym_jsx_namespace_name,
  [sym_jsx_closing_element] = sym_jsx_closing_element,
  [sym_jsx_self_closing_element] = sym_jsx_self_closing_element,
  [sym_jsx_attribute] = sym_jsx_attribute,
  [sym_class] = sym_class,
  [sym_class_declaration] = sym_class_declaration,
  [sym_class_heritage] = sym_class_heritage,
  [sym_function] = sym_function,
  [sym_function_declaration] = sym_function_declaration,
  [sym_generator_function] = sym_generator_function,
  [sym_generator_function_declaration] = sym_generator_function_declaration,
  [sym_arrow_function] = sym_arrow_function,
  [sym_call_expression] = sym_call_expression,
  [sym_new_expression] = sym_new_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_member_expression] = sym_member_expression,
  [sym_subscript_expression] = sym_subscript_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_augmented_assignment_expression] = sym_augmented_assignment_expression,
  [sym__initializer] = sym__initializer,
  [sym_spread_element] = sym_spread_element,
  [sym_ternary_expression] = sym_ternary_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_update_expression] = sym_update_expression,
  [sym_sequence_expression] = sym_sequence_expression,
  [sym_string] = sym_string,
  [sym_template_string] = sym_template_string,
  [sym_template_substitution] = sym_template_substitution,
  [sym_regex] = sym_regex,
  [sym_meta_property] = sym_meta_property,
  [sym_arguments] = sym_arguments,
  [sym_decorator] = sym_decorator,
  [sym_decorator_member_expression] = sym_member_expression,
  [sym_decorator_call_expression] = sym_call_expression,
  [sym_class_body] = sym_class_body,
  [sym_public_field_definition] = sym_public_field_definition,
  [sym_formal_parameters] = sym_formal_parameters,
  [sym_rest_parameter] = sym_rest_parameter,
  [sym_method_definition] = sym_method_definition,
  [sym_pair] = sym_pair,
  [sym__property_name] = sym__property_name,
  [sym_computed_property_name] = sym_computed_property_name,
  [aux_sym_program_repeat1] = aux_sym_program_repeat1,
  [aux_sym_export_statement_repeat1] = aux_sym_export_statement_repeat1,
  [aux_sym_export_clause_repeat1] = aux_sym_export_clause_repeat1,
  [aux_sym_named_imports_repeat1] = aux_sym_named_imports_repeat1,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_jsx_element_repeat1] = aux_sym_jsx_element_repeat1,
  [aux_sym_jsx_opening_element_repeat1] = aux_sym_jsx_opening_element_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_string_repeat2] = aux_sym_string_repeat2,
  [aux_sym_template_string_repeat1] = aux_sym_template_string_repeat1,
  [aux_sym_class_body_repeat1] = aux_sym_class_body_repeat1,
  [aux_sym_formal_parameters_repeat1] = aux_sym_formal_parameters_repeat1,
  [alias_sym_array_pattern] = alias_sym_array_pattern,
  [alias_sym_export_specifier] = alias_sym_export_specifier,
  [alias_sym_import_specifier] = alias_sym_import_specifier,
  [alias_sym_object_pattern] = alias_sym_object_pattern,
  [alias_sym_property_identifier] = alias_sym_property_identifier,
  [alias_sym_shorthand_property_identifier] = alias_sym_shorthand_property_identifier,
  [alias_sym_statement_identifier] = alias_sym_statement_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_jsx_text] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [sym_preproc] = {
    .visible = true,
    .named = true,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_import] = {
    .visible = true,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__for_header] = {
    .visible = false,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_fragment] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_opening_element] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_namespace_name] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_self_closing_element] = {
    .visible = true,
    .named = true,
  },
  [sym_jsx_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_jsx_opening_element_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_attribute = 5,
  field_body = 6,
  field_close_tag = 7,
  field_condition = 8,
  field_consequence = 9,
  field_constructor = 10,
  field_declaration = 11,
  field_decorator = 12,
  field_finalizer = 13,
  field_flags = 14,
  field_function = 15,
  field_handler = 16,
  field_increment = 17,
  field_index = 18,
  field_initializer = 19,
  field_key = 20,
  field_label = 21,
  field_left = 22,
  field_member = 23,
  field_name = 24,
  field_object = 25,
  field_open_tag = 26,
  field_operator = 27,
  field_parameter = 28,
  field_parameters = 29,
  field_pattern = 30,
  field_property = 31,
  field_right = 32,
  field_source = 33,
  field_value = 34,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_close_tag] = "close_tag",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constructor] = "constructor",
  [field_declaration] = "declaration",
  [field_decorator] = "decorator",
  [field_finalizer] = "finalizer",
  [field_flags] = "flags",
  [field_function] = "function",
  [field_handler] = "handler",
  [field_increment] = "increment",
  [field_index] = "index",
  [field_initializer] = "initializer",
  [field_key] = "key",
  [field_label] = "label",
  [field_left] = "left",
  [field_member] = "member",
  [field_name] = "name",
  [field_object] = "object",
  [field_open_tag] = "open_tag",
  [field_operator] = "operator",
  [field_parameter] = "parameter",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_property] = "property",
  [field_right] = "right",
  [field_source] = "source",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[107] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [5] = {.index = 2, .length = 1},
  [6] = {.index = 2, .length = 1},
  [7] = {.index = 2, .length = 1},
  [8] = {.index = 3, .length = 1},
  [9] = {.index = 4, .length = 1},
  [10] = {.index = 4, .length = 1},
  [11] = {.index = 5, .length = 2},
  [12] = {.index = 7, .length = 2},
  [14] = {.index = 9, .length = 2},
  [15] = {.index = 11, .length = 2},
  [16] = {.index = 13, .length = 2},
  [18] = {.index = 15, .length = 1},
  [19] = {.index = 16, .length = 2},
  [20] = {.index = 16, .length = 2},
  [21] = {.index = 16, .length = 2},
  [22] = {.index = 18, .length = 2},
  [23] = {.index = 20, .length = 2},
  [24] = {.index = 22, .length = 3},
  [27] = {.index = 25, .length = 2},
  [28] = {.index = 27, .length = 2},
  [29] = {.index = 29, .length = 2},
  [30] = {.index = 31, .length = 2},
  [31] = {.index = 33, .length = 1},
  [32] = {.index = 34, .length = 1},
  [33] = {.index = 35, .length = 1},
  [34] = {.index = 36, .length = 1},
  [35] = {.index = 37, .length = 1},
  [36] = {.index = 38, .length = 1},
  [37] = {.index = 39, .length = 2},
  [38] = {.index = 41, .length = 1},
  [39] = {.index = 42, .length = 1},
  [40] = {.index = 43, .length = 2},
  [41] = {.index = 45, .length = 2},
  [42] = {.index = 47, .length = 2},
  [43] = {.index = 49, .length = 2},
  [44] = {.index = 51, .length = 2},
  [45] = {.index = 51, .length = 2},
  [46] = {.index = 43, .length = 2},
  [47] = {.index = 45, .length = 2},
  [48] = {.index = 47, .length = 2},
  [49] = {.index = 7, .length = 2},
  [50] = {.index = 53, .length = 3},
  [51] = {.index = 43, .length = 2},
  [52] = {.index = 43, .length = 2},
  [53] = {.index = 56, .length = 2},
  [54] = {.index = 58, .length = 2},
  [55] = {.index = 60, .length = 2},
  [56] = {.index = 62, .length = 1},
  [57] = {.index = 63, .length = 1},
  [58] = {.index = 64, .length = 2},
  [59] = {.index = 43, .length = 2},
  [60] = {.index = 66, .length = 2},
  [61] = {.index = 68, .length = 3},
  [62] = {.index = 64, .length = 2},
  [63] = {.index = 71, .length = 1},
  [64] = {.index = 72, .length = 3},
  [65] = {.index = 75, .length = 3},
  [66] = {.index = 78, .length = 2},
  [67] = {.index = 80, .length = 2},
  [68] = {.index = 82, .length = 2},
  [69] = {.index = 84, .length = 1},
  [70] = {.index = 85, .length = 2},
  [71] = {.index = 87, .length = 1},
  [72] = {.index = 88, .length = 2},
  [73] = {.index = 90, .length = 2},
  [74] = {.index = 92, .length = 2},
  [75] = {.index = 94, .length = 2},
  [76] = {.index = 92, .length = 2},
  [77] = {.index = 96, .length = 2},
  [78] = {.index = 98, .length = 3},
  [79] = {.index = 101, .length = 2},
  [80] = {.index = 103, .length = 3},
  [81] = {.index = 106, .length = 2},
  [82] = {.index = 108, .length = 2},
  [83] = {.index = 110, .length = 3},
  [84] = {.index = 113, .length = 2},
  [85] = {.index = 115, .length = 2},
  [86] = {.index = 117, .length = 2},
  [87] = {.index = 119, .length = 3},
  [88] = {.index = 122, .length = 3},
  [89] = {.index = 125, .length = 1},
  [90] = {.index = 126, .length = 2},
  [91] = {.index = 128, .length = 3},
  [92] = {.index = 131, .length = 2},
  [93] = {.index = 131, .length = 2},
  [94] = {.index = 133, .length = 3},
  [95] = {.index = 131, .length = 2},
  [96] = {.index = 131, .length = 2},
  [97] = {.index = 136, .length = 3},
  [98] = {.index = 139, .length = 2},
  [99] = {.index = 139, .length = 2},
  [100] = {.index = 139, .length = 2},
  [101] = {.index = 139, .length = 2},
  [102] = {.index = 141, .length = 4},
  [103] = {.index = 145, .length = 2},
  [104] = {.index = 145, .length = 2},
  [105] = {.index = 145, .length = 2},
  [106] = {.index = 147, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_decorator, 0},
  [1] =
    {field_declaration, 1},
  [2] =
    {field_name, 0},
  [3] =
    {field_body, 1},
  [4] =
    {field_constructor, 1},
  [5] =
    {field_argument, 1},
    {field_operator, 0},
  [7] =
    {field_arguments, 1},
    {field_function, 0},
  [9] =
    {field_argument, 0},
    {field_operator, 1},
  [11] =
    {field_close_tag, 1},
    {field_open_tag, 0},
  [13] =
    {field_decorator, 0, .inherited = true},
    {field_decorator, 1, .inherited = true},
  [15] =
    {field_source, 1},
  [16] =
    {field_name, 0},
    {field_value, 1, .inherited = true},
  [18] =
    {field_condition, 1},
    {field_consequence, 2},
  [20] =
    {field_body, 2},
    {field_value, 1},
  [22] =
    {field_body, 2},
    {field_left, 1, .inherited = true},
    {field_right, 1, .inherited = true},
  [25] =
    {field_body, 2},
    {field_condition, 1},
  [27] =
    {field_body, 1},
    {field_handler, 2},
  [29] =
    {field_body, 1},
    {field_finalizer, 2},
  [31] =
    {field_body, 2},
    {field_object, 1},
  [33] =
    {field_label, 1},
  [34] =
    {field_name, 1},
  [35] =
    {field_attribute, 0},
  [36] =
    {field_pattern, 1},
  [37] =
    {field_member, 0},
  [38] =
    {field_property, 0},
  [39] =
    {field_body, 2},
    {field_name, 1},
  [41] =
    {field_body, 2},
  [42] =
    {field_label, 0},
  [43] =
    {field_left, 0},
    {field_right, 2},
  [45] =
    {field_object, 0},
    {field_property, 2},
  [47] =
    {field_body, 2},
    {field_parameter, 0},
  [49] =
    {field_body, 2},
    {field_parameters, 1},
  [51] =
    {field_arguments, 2},
    {field_constructor, 1},
  [53] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [56] =
    {field_close_tag, 2},
    {field_open_tag, 0},
  [58] =
    {field_body, 2},
    {field_parameters, 0},
  [60] =
    {field_declaration, 2},
    {field_decorator, 0, .inherited = true},
  [62] =
    {field_source, 2, .inherited = true},
  [63] =
    {field_value, 2},
  [64] =
    {field_alias, 1, .inherited = true},
    {field_name, 1, .inherited = true},
  [66] =
    {field_key, 0},
    {field_value, 2},
  [68] =
    {field_body, 2},
    {field_name, 0},
    {field_parameters, 1},
  [71] =
    {field_value, 1},
  [72] =
    {field_body, 3},
    {field_left, 2, .inherited = true},
    {field_right, 2, .inherited = true},
  [75] =
    {field_body, 1},
    {field_finalizer, 3},
    {field_handler, 2},
  [78] =
    {field_attribute, 2, .inherited = true},
    {field_name, 1},
  [80] =
    {field_attribute, 0, .inherited = true},
    {field_attribute, 1, .inherited = true},
  [82] =
    {field_flags, 3},
    {field_pattern, 1},
  [84] =
    {field_property, 1},
  [85] =
    {field_property, 0},
    {field_value, 1, .inherited = true},
  [87] =
    {field_member, 1, .inherited = true},
  [88] =
    {field_member, 0, .inherited = true},
    {field_member, 1, .inherited = true},
  [90] =
    {field_body, 3},
    {field_name, 1},
  [92] =
    {field_body, 3},
    {field_parameter, 1},
  [94] =
    {field_body, 3},
    {field_parameters, 2},
  [96] =
    {field_body, 3},
    {field_parameters, 1},
  [98] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2},
  [101] =
    {field_index, 2},
    {field_object, 0},
  [103] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [106] =
    {field_body, 3},
    {field_decorator, 0, .inherited = true},
  [108] =
    {field_alias, 2},
    {field_name, 0},
  [110] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 2},
  [113] =
    {field_body, 1},
    {field_condition, 3},
  [115] =
    {field_property, 1},
    {field_value, 2, .inherited = true},
  [117] =
    {field_body, 4},
    {field_parameters, 3},
  [119] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
  [122] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [125] =
    {field_name, 2},
  [126] =
    {field_decorator, 0, .inherited = true},
    {field_value, 3},
  [128] =
    {field_body, 4},
    {field_decorator, 0, .inherited = true},
    {field_name, 2},
  [131] =
    {field_left, 1},
    {field_right, 3},
  [133] =
    {field_body, 5},
    {field_condition, 3},
    {field_initializer, 2},
  [136] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4},
  [139] =
    {field_left, 2},
    {field_right, 4},
  [141] =
    {field_body, 6},
    {field_condition, 3},
    {field_increment, 4},
    {field_initializer, 2},
  [145] =
    {field_body, 4},
    {field_parameter, 2},
  [147] =
    {field_body, 6},
    {field_decorator, 0, .inherited = true},
    {field_name, 4},
    {field_parameters, 5},
};

static TSSymbol ts_alias_sequences[107][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [4] = {
    [0] = alias_sym_property_identifier,
  },
  [6] = {
    [0] = alias_sym_object_pattern,
  },
  [7] = {
    [0] = alias_sym_array_pattern,
  },
  [9] = {
    [1] = sym_identifier,
  },
  [13] = {
    [1] = sym_identifier,
  },
  [17] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [20] = {
    [0] = alias_sym_object_pattern,
  },
  [21] = {
    [0] = alias_sym_array_pattern,
  },
  [25] = {
    [1] = alias_sym_object_pattern,
  },
  [26] = {
    [1] = alias_sym_array_pattern,
  },
  [31] = {
    [1] = alias_sym_statement_identifier,
  },
  [39] = {
    [0] = alias_sym_statement_identifier,
  },
  [40] = {
    [0] = sym_identifier,
  },
  [41] = {
    [0] = sym_identifier,
    [2] = alias_sym_property_identifier,
  },
  [42] = {
    [0] = sym_identifier,
  },
  [44] = {
    [1] = sym_identifier,
  },
  [47] = {
    [2] = alias_sym_property_identifier,
  },
  [49] = {
    [0] = sym_identifier,
  },
  [51] = {
    [0] = alias_sym_object_pattern,
  },
  [52] = {
    [0] = alias_sym_array_pattern,
  },
  [58] = {
    [1] = alias_sym_export_specifier,
  },
  [59] = {
    [0] = alias_sym_shorthand_property_identifier,
  },
  [62] = {
    [1] = alias_sym_import_specifier,
  },
  [74] = {
    [1] = sym_identifier,
  },
  [92] = {
    [1] = sym_identifier,
  },
  [95] = {
    [1] = alias_sym_object_pattern,
  },
  [96] = {
    [1] = alias_sym_array_pattern,
  },
  [98] = {
    [2] = sym_identifier,
  },
  [100] = {
    [2] = alias_sym_object_pattern,
  },
  [101] = {
    [2] = alias_sym_array_pattern,
  },
  [104] = {
    [2] = alias_sym_object_pattern,
  },
  [105] = {
    [2] = alias_sym_array_pattern,
  },
};

static inline bool sym_identifier_character_set_1(int32_t lookahead) {
  return
    lookahead == 0 ||
    (0 <= lookahead && lookahead <= '#') ||
    ('%' <= lookahead && lookahead <= '/') ||
    (':' <= lookahead && lookahead <= '@') ||
    ('[' <= lookahead && lookahead <= '^') ||
    lookahead == '`' ||
    ('{' <= lookahead && lookahead <= '~') ||
    lookahead == 160 ||
    lookahead == 8203 ||
    lookahead == 8288 ||
    lookahead == 65279;
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(62);
      if (lookahead == '!') ADVANCE(141);
      if (lookahead == '"') ADVANCE(145);
      if (lookahead == '#') ADVANCE(1);
      if (lookahead == '$') ADVANCE(185);
      if (lookahead == '%') ADVANCE(130);
      if (lookahead == '&') ADVANCE(120);
      if (lookahead == '\'') ADVANCE(152);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(71);
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '+') ADVANCE(126);
      if (lookahead == ',') ADVANCE(68);
      if (lookahead == '-') ADVANCE(128);
      if (lookahead == '.') ADVANCE(94);
      if (lookahead == '/') ADVANCE(170);
      if (lookahead == '0') ADVANCE(175);
      if (lookahead == ':') ADVANCE(73);
      if (lookahead == ';') ADVANCE(72);
      if (lookahead == '<') ADVANCE(80);
      if (lookahead == '=') ADVANCE(75);
      if (lookahead == '>') ADVANCE(83);
      if (lookahead == '?') ADVANCE(110);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(77);
      if (lookahead == '\\') ADVANCE(27);
      if (lookahead == ']') ADVANCE(78);
      if (lookahead == '^') ADVANCE(122);
      if (lookahead == '`') ADVANCE(168);
      if (lookahead == '{') ADVANCE(67);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '~') ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(59)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(176);
      if (lookahead != 0 &&
          (lookahead < 0 || 31 < lookahead)) ADVANCE(186);
      END_STATE();
    case 1:
      if (lookahead == '\n') ADVANCE(188);
      if (lookahead == '!') ADVANCE(63);
      if (lookahead != 0) ADVANCE(2);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(188);
      if (lookahead != 0) ADVANCE(2);
      END_STATE();
    case 3:
      if (lookahead == '\n') SKIP(12)
      if (lookahead == '"') ADVANCE(145);
      if (lookahead == '/') ADVANCE(147);
      if (lookahead == '\\') ADVANCE(4);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(150);
      if (lookahead != 0) ADVANCE(151);
      END_STATE();
    case 4:
      if (lookahead == '\n') ADVANCE(146);
      if (lookahead == '\r') ADVANCE(160);
      if (lookahead == 'u') ADVANCE(33);
      if (lookahead == 'x') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(164);
      if (lookahead != 0) ADVANCE(159);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(15)
      if (lookahead == '\'') ADVANCE(152);
      if (lookahead == '/') ADVANCE(154);
      if (lookahead == '\\') ADVANCE(6);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(157);
      if (lookahead != 0) ADVANCE(158);
      END_STATE();
    case 6:
      if (lookahead == '\n') ADVANCE(153);
      if (lookahead == '\r') ADVANCE(161);
      if (lookahead == 'u') ADVANCE(33);
      if (lookahead == 'x') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(164);
      if (lookahead != 0) ADVANCE(159);
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(23)
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '[') ADVANCE(26);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(171);
      if (lookahead != 0) ADVANCE(172);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(140);
      if (lookahead == '"') ADVANCE(145);
      if (lookahead == '\'') ADVANCE(152);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == '-') ADVANCE(127);
      if (lookahead == '.') ADVANCE(95);
      if (lookahead == '/') ADVANCE(85);
      if (lookahead == '0') ADVANCE(175);
      if (lookahead == ':') ADVANCE(73);
      if (lookahead == '<') ADVANCE(79);
      if (lookahead == '>') ADVANCE(82);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(77);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == '`') ADVANCE(168);
      if (lookahead == '{') ADVANCE(67);
      if (lookahead == '~') ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(8)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(176);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '?' < lookahead) &&
          lookahead != ']' &&
          lookahead != '^' &&
          lookahead != '|' &&
          lookahead != '}') ADVANCE(186);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(24);
      if (lookahead == '"') ADVANCE(145);
      if (lookahead == '%') ADVANCE(130);
      if (lookahead == '&') ADVANCE(120);
      if (lookahead == '\'') ADVANCE(152);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(71);
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '+') ADVANCE(126);
      if (lookahead == ',') ADVANCE(68);
      if (lookahead == '-') ADVANCE(128);
      if (lookahead == '.') ADVANCE(95);
      if (lookahead == '/') ADVANCE(86);
      if (lookahead == '0') ADVANCE(175);
      if (lookahead == ':') ADVANCE(73);
      if (lookahead == ';') ADVANCE(72);
      if (lookahead == '<') ADVANCE(80);
      if (lookahead == '=') ADVANCE(75);
      if (lookahead == '>') ADVANCE(83);
      if (lookahead == '?') ADVANCE(110);
      if (lookahead == '[') ADVANCE(77);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == ']') ADVANCE(78);
      if (lookahead == '^') ADVANCE(122);
      if (lookahead == '`') ADVANCE(168);
      if (lookahead == '{') ADVANCE(67);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(9)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(176);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          lookahead != '@' &&
          lookahead != '~') ADVANCE(186);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(24);
      if (lookahead == '%') ADVANCE(129);
      if (lookahead == '&') ADVANCE(119);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(71);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(68);
      if (lookahead == '-') ADVANCE(127);
      if (lookahead == '.') ADVANCE(93);
      if (lookahead == '/') ADVANCE(85);
      if (lookahead == ':') ADVANCE(73);
      if (lookahead == ';') ADVANCE(72);
      if (lookahead == '<') ADVANCE(81);
      if (lookahead == '=') ADVANCE(25);
      if (lookahead == '>') ADVANCE(84);
      if (lookahead == '?') ADVANCE(110);
      if (lookahead == '[') ADVANCE(77);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == ']') ADVANCE(78);
      if (lookahead == '^') ADVANCE(121);
      if (lookahead == '`') ADVANCE(168);
      if (lookahead == '{') ADVANCE(67);
      if (lookahead == '|') ADVANCE(124);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(11)
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(173);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(186);
      END_STATE();
    case 11:
      if (lookahead == '!') ADVANCE(24);
      if (lookahead == '%') ADVANCE(129);
      if (lookahead == '&') ADVANCE(119);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(71);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(68);
      if (lookahead == '-') ADVANCE(127);
      if (lookahead == '.') ADVANCE(93);
      if (lookahead == '/') ADVANCE(85);
      if (lookahead == ':') ADVANCE(73);
      if (lookahead == ';') ADVANCE(72);
      if (lookahead == '<') ADVANCE(81);
      if (lookahead == '=') ADVANCE(25);
      if (lookahead == '>') ADVANCE(84);
      if (lookahead == '?') ADVANCE(110);
      if (lookahead == '[') ADVANCE(77);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == ']') ADVANCE(78);
      if (lookahead == '^') ADVANCE(121);
      if (lookahead == '`') ADVANCE(168);
      if (lookahead == '{') ADVANCE(67);
      if (lookahead == '|') ADVANCE(124);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(11)
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '~') ADVANCE(186);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(145);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      END_STATE();
    case 13:
      if (lookahead == '$') ADVANCE(30);
      if (lookahead == '/') ADVANCE(170);
      if (lookahead == '\\') ADVANCE(29);
      if (lookahead == '`') ADVANCE(168);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(14)
      END_STATE();
    case 14:
      if (lookahead == '$') ADVANCE(30);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '`') ADVANCE(168);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(14)
      END_STATE();
    case 15:
      if (lookahead == '\'') ADVANCE(152);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(15)
      END_STATE();
    case 16:
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '/') ADVANCE(167);
      END_STATE();
    case 17:
      if (lookahead == '*') ADVANCE(17);
      if (lookahead == '/') ADVANCE(165);
      if (lookahead != 0) ADVANCE(18);
      END_STATE();
    case 18:
      if (lookahead == '*') ADVANCE(17);
      if (lookahead != 0) ADVANCE(18);
      END_STATE();
    case 19:
      if (lookahead == '.') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(182);
      END_STATE();
    case 20:
      if (lookahead == '.') ADVANCE(109);
      END_STATE();
    case 21:
      if (lookahead == '.') ADVANCE(93);
      if (lookahead == '/') ADVANCE(85);
      if (lookahead == ':') ADVANCE(73);
      if (lookahead == '=') ADVANCE(74);
      if (lookahead == '>') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == '{') ADVANCE(67);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(21)
      if (lookahead == '$' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      if (lookahead != 0 &&
          (lookahead < 0 || '~' < lookahead)) ADVANCE(186);
      END_STATE();
    case 22:
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '<') ADVANCE(79);
      if (lookahead == '{') ADVANCE(67);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(90);
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '}') ADVANCE(91);
      END_STATE();
    case 23:
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(23)
      END_STATE();
    case 24:
      if (lookahead == '=') ADVANCE(136);
      END_STATE();
    case 25:
      if (lookahead == '=') ADVANCE(134);
      END_STATE();
    case 26:
      if (lookahead == '\\') ADVANCE(57);
      if (lookahead == ']') ADVANCE(172);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(26);
      END_STATE();
    case 27:
      if (lookahead == 'u') ADVANCE(31);
      if (lookahead == 'x') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(164);
      if (lookahead != 0) ADVANCE(159);
      END_STATE();
    case 28:
      if (lookahead == 'u') ADVANCE(32);
      END_STATE();
    case 29:
      if (lookahead == 'u') ADVANCE(33);
      if (lookahead == 'x') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(164);
      if (lookahead != 0) ADVANCE(159);
      END_STATE();
    case 30:
      if (lookahead == '{') ADVANCE(169);
      END_STATE();
    case 31:
      if (lookahead == '{') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(55);
      END_STATE();
    case 32:
      if (lookahead == '{') ADVANCE(50);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(56);
      END_STATE();
    case 33:
      if (lookahead == '{') ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(49);
      END_STATE();
    case 34:
      if (lookahead == '}') ADVANCE(186);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(34);
      END_STATE();
    case 35:
      if (lookahead == '}') ADVANCE(159);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(35);
      END_STATE();
    case 36:
      if (lookahead == '}') ADVANCE(162);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(36);
      END_STATE();
    case 37:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(181);
      END_STATE();
    case 38:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(177);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(178);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(176);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(182);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(180);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(181);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(186);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(159);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(179);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(36);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(162);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(52);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(34);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(35);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(45);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(48);
      END_STATE();
    case 54:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 55:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(53);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(54);
      END_STATE();
    case 57:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(26);
      END_STATE();
    case 58:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(172);
      END_STATE();
    case 59:
      if (eof) ADVANCE(62);
      if (lookahead == '!') ADVANCE(141);
      if (lookahead == '"') ADVANCE(145);
      if (lookahead == '#') ADVANCE(1);
      if (lookahead == '$') ADVANCE(185);
      if (lookahead == '%') ADVANCE(130);
      if (lookahead == '&') ADVANCE(120);
      if (lookahead == '\'') ADVANCE(152);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(71);
      if (lookahead == '*') ADVANCE(65);
      if (lookahead == '+') ADVANCE(126);
      if (lookahead == ',') ADVANCE(68);
      if (lookahead == '-') ADVANCE(128);
      if (lookahead == '.') ADVANCE(94);
      if (lookahead == '/') ADVANCE(85);
      if (lookahead == '0') ADVANCE(175);
      if (lookahead == ':') ADVANCE(73);
      if (lookahead == ';') ADVANCE(72);
      if (lookahead == '<') ADVANCE(80);
      if (lookahead == '=') ADVANCE(75);
      if (lookahead == '>') ADVANCE(83);
      if (lookahead == '?') ADVANCE(110);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(77);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == ']') ADVANCE(78);
      if (lookahead == '^') ADVANCE(122);
      if (lookahead == '`') ADVANCE(168);
      if (lookahead == '{') ADVANCE(67);
      if (lookahead == '|') ADVANCE(123);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '~') ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(59)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(176);
      if (lookahead != 0 &&
          (lookahead < 0 || 31 < lookahead)) ADVANCE(186);
      END_STATE();
    case 60:
      if (eof) ADVANCE(62);
      if (lookahead == '!') ADVANCE(141);
      if (lookahead == '"') ADVANCE(145);
      if (lookahead == '#') ADVANCE(2);
      if (lookahead == '%') ADVANCE(129);
      if (lookahead == '&') ADVANCE(119);
      if (lookahead == '\'') ADVANCE(152);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(71);
      if (lookahead == '*') ADVANCE(66);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(68);
      if (lookahead == '-') ADVANCE(127);
      if (lookahead == '.') ADVANCE(95);
      if (lookahead == '/') ADVANCE(85);
      if (lookahead == '0') ADVANCE(175);
      if (lookahead == ':') ADVANCE(73);
      if (lookahead == ';') ADVANCE(72);
      if (lookahead == '<') ADVANCE(81);
      if (lookahead == '=') ADVANCE(75);
      if (lookahead == '>') ADVANCE(84);
      if (lookahead == '?') ADVANCE(110);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(77);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == ']') ADVANCE(78);
      if (lookahead == '^') ADVANCE(121);
      if (lookahead == '`') ADVANCE(168);
      if (lookahead == '{') ADVANCE(67);
      if (lookahead == '|') ADVANCE(124);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '~') ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(60)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(176);
      if (lookahead != 0 &&
          (lookahead < 0 || 31 < lookahead)) ADVANCE(186);
      END_STATE();
    case 61:
      if (eof) ADVANCE(62);
      if (lookahead == '!') ADVANCE(140);
      if (lookahead == '"') ADVANCE(145);
      if (lookahead == '#') ADVANCE(1);
      if (lookahead == '\'') ADVANCE(152);
      if (lookahead == '(') ADVANCE(70);
      if (lookahead == ')') ADVANCE(71);
      if (lookahead == '*') ADVANCE(64);
      if (lookahead == '+') ADVANCE(125);
      if (lookahead == ',') ADVANCE(68);
      if (lookahead == '-') ADVANCE(127);
      if (lookahead == '.') ADVANCE(19);
      if (lookahead == '/') ADVANCE(85);
      if (lookahead == '0') ADVANCE(175);
      if (lookahead == ':') ADVANCE(73);
      if (lookahead == ';') ADVANCE(72);
      if (lookahead == '<') ADVANCE(79);
      if (lookahead == '=') ADVANCE(76);
      if (lookahead == '>') ADVANCE(82);
      if (lookahead == '@') ADVANCE(187);
      if (lookahead == '[') ADVANCE(77);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == ']') ADVANCE(78);
      if (lookahead == '`') ADVANCE(168);
      if (lookahead == '{') ADVANCE(67);
      if (lookahead == '}') ADVANCE(69);
      if (lookahead == '~') ADVANCE(142);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(61)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(176);
      if (lookahead != 0 &&
          (lookahead < 0 || 31 < lookahead) &&
          (lookahead < '%' || '?' < lookahead) &&
          lookahead != '^' &&
          lookahead != '|') ADVANCE(186);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead == '\n') ADVANCE(188);
      if (lookahead != 0) ADVANCE(63);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(132);
      if (lookahead == '=') ADVANCE(99);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(131);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(134);
      if (lookahead == '>') ADVANCE(96);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(96);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(118);
      if (lookahead == '=') ADVANCE(133);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(117);
      if (lookahead == '=') ADVANCE(133);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '>') ADVANCE(113);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(138);
      if (lookahead == '>') ADVANCE(114);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '/') ADVANCE(167);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '/') ADVANCE(167);
      if (lookahead == '=') ADVANCE(100);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(89);
      if (lookahead == '/') ADVANCE(166);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(91);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(88);
      if (lookahead == '/') ADVANCE(165);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(18);
      if (lookahead != 0) ADVANCE(89);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '*') ADVANCE(88);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(18);
      if (lookahead != 0) ADVANCE(89);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(90);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(91);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_jsx_text);
      if (lookahead != 0 &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(91);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_jsx_identifier);
      if (lookahead == '$' ||
          lookahead == '-' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(92);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(20);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(182);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(182);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '?') ADVANCE(139);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(105);
      if (lookahead == '>') ADVANCE(116);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>') ADVANCE(115);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=') ADVANCE(106);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(107);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(111);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(111);
      if (lookahead == '=') ADVANCE(103);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(102);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(104);
      if (lookahead == '|') ADVANCE(112);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|') ADVANCE(112);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(143);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(143);
      if (lookahead == '=') ADVANCE(97);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(144);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(144);
      if (lookahead == '=') ADVANCE(98);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(101);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(108);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=') ADVANCE(135);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=') ADVANCE(137);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(136);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(aux_sym_string_token1);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(149);
      if (lookahead == '/') ADVANCE(151);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(151);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(148);
      if (lookahead == '/') ADVANCE(151);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(149);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*') ADVANCE(148);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(149);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/') ADVANCE(147);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(150);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(151);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(151);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym_string_token2);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(156);
      if (lookahead == '/') ADVANCE(158);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(158);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(155);
      if (lookahead == '/') ADVANCE(158);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(156);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*') ADVANCE(155);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(156);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '/') ADVANCE(154);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(157);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(158);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(158);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(146);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n') ADVANCE(153);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(28);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(186);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(159);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(163);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '<' ||
          lookahead == '>' ||
          lookahead == '{' ||
          lookahead == '}') ADVANCE(167);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(166);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(167);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*') ADVANCE(18);
      if (lookahead == '/') ADVANCE(167);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '/') ADVANCE(16);
      if (lookahead == '[') ADVANCE(26);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(171);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(172);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[') ADVANCE(26);
      if (lookahead == '\\') ADVANCE(58);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/') ADVANCE(172);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym_regex_flags);
      if (lookahead == '\\') ADVANCE(28);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(173);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(186);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(183);
      if (lookahead == '0') ADVANCE(180);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(38);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(39);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(46);
      if (lookahead == '_') ADVANCE(42);
      if (lookahead == 'n') ADVANCE(174);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(176);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(183);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (lookahead == '_') ADVANCE(40);
      if (lookahead == 'n') ADVANCE(174);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(176);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(38);
      if (lookahead == 'n') ADVANCE(174);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(177);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(39);
      if (lookahead == 'n') ADVANCE(174);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(178);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(46);
      if (lookahead == 'n') ADVANCE(174);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(179);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(42);
      if (lookahead == 'n') ADVANCE(174);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(180);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '_') ADVANCE(43);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(181);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (lookahead == '_') ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(182);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(37);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(182);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '-') ADVANCE(92);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == '$' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(184);
      if (lookahead != 0 &&
          (lookahead < 0 || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(186);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(28);
      if (lookahead == '{') ADVANCE(169);
      if (lookahead != 0 &&
          (lookahead < 0 || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279) ADVANCE(186);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '\\') ADVANCE(28);
      if (!sym_identifier_character_set_1(lookahead)) ADVANCE(186);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_preproc);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'a') ADVANCE(1);
      if (lookahead == 'b') ADVANCE(2);
      if (lookahead == 'c') ADVANCE(3);
      if (lookahead == 'd') ADVANCE(4);
      if (lookahead == 'e') ADVANCE(5);
      if (lookahead == 'f') ADVANCE(6);
      if (lookahead == 'g') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'l') ADVANCE(9);
      if (lookahead == 'n') ADVANCE(10);
      if (lookahead == 'o') ADVANCE(11);
      if (lookahead == 'r') ADVANCE(12);
      if (lookahead == 's') ADVANCE(13);
      if (lookahead == 't') ADVANCE(14);
      if (lookahead == 'u') ADVANCE(15);
      if (lookahead == 'v') ADVANCE(16);
      if (lookahead == 'w') ADVANCE(17);
      if (lookahead == 'y') ADVANCE(18);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 's') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      END_STATE();
    case 2:
      if (lookahead == 'r') ADVANCE(21);
      END_STATE();
    case 3:
      if (lookahead == 'a') ADVANCE(22);
      if (lookahead == 'l') ADVANCE(23);
      if (lookahead == 'o') ADVANCE(24);
      END_STATE();
    case 4:
      if (lookahead == 'e') ADVANCE(25);
      if (lookahead == 'o') ADVANCE(26);
      END_STATE();
    case 5:
      if (lookahead == 'l') ADVANCE(27);
      if (lookahead == 'x') ADVANCE(28);
      END_STATE();
    case 6:
      if (lookahead == 'a') ADVANCE(29);
      if (lookahead == 'i') ADVANCE(30);
      if (lookahead == 'o') ADVANCE(31);
      if (lookahead == 'r') ADVANCE(32);
      if (lookahead == 'u') ADVANCE(33);
      END_STATE();
    case 7:
      if (lookahead == 'e') ADVANCE(34);
      END_STATE();
    case 8:
      if (lookahead == 'f') ADVANCE(35);
      if (lookahead == 'm') ADVANCE(36);
      if (lookahead == 'n') ADVANCE(37);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(38);
      END_STATE();
    case 10:
      if (lookahead == 'e') ADVANCE(39);
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 11:
      if (lookahead == 'f') ADVANCE(41);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(42);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(43);
      if (lookahead == 't') ADVANCE(44);
      if (lookahead == 'u') ADVANCE(45);
      if (lookahead == 'w') ADVANCE(46);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(47);
      if (lookahead == 'h') ADVANCE(48);
      if (lookahead == 'r') ADVANCE(49);
      if (lookahead == 'y') ADVANCE(50);
      END_STATE();
    case 15:
      if (lookahead == 'n') ADVANCE(51);
      END_STATE();
    case 16:
      if (lookahead == 'a') ADVANCE(52);
      if (lookahead == 'o') ADVANCE(53);
      END_STATE();
    case 17:
      if (lookahead == 'h') ADVANCE(54);
      if (lookahead == 'i') ADVANCE(55);
      END_STATE();
    case 18:
      if (lookahead == 'i') ADVANCE(56);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(57);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(58);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(59);
      END_STATE();
    case 22:
      if (lookahead == 's') ADVANCE(60);
      if (lookahead == 't') ADVANCE(61);
      END_STATE();
    case 23:
      if (lookahead == 'a') ADVANCE(62);
      END_STATE();
    case 24:
      if (lookahead == 'n') ADVANCE(63);
      END_STATE();
    case 25:
      if (lookahead == 'b') ADVANCE(64);
      if (lookahead == 'f') ADVANCE(65);
      if (lookahead == 'l') ADVANCE(66);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 27:
      if (lookahead == 's') ADVANCE(67);
      END_STATE();
    case 28:
      if (lookahead == 'p') ADVANCE(68);
      if (lookahead == 't') ADVANCE(69);
      END_STATE();
    case 29:
      if (lookahead == 'l') ADVANCE(70);
      END_STATE();
    case 30:
      if (lookahead == 'n') ADVANCE(71);
      END_STATE();
    case 31:
      if (lookahead == 'r') ADVANCE(72);
      END_STATE();
    case 32:
      if (lookahead == 'o') ADVANCE(73);
      END_STATE();
    case 33:
      if (lookahead == 'n') ADVANCE(74);
      END_STATE();
    case 34:
      if (lookahead == 't') ADVANCE(75);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 36:
      if (lookahead == 'p') ADVANCE(76);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's') ADVANCE(77);
      END_STATE();
    case 38:
      if (lookahead == 't') ADVANCE(78);
      END_STATE();
    case 39:
      if (lookahead == 'w') ADVANCE(79);
      END_STATE();
    case 40:
      if (lookahead == 'l') ADVANCE(80);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 42:
      if (lookahead == 't') ADVANCE(81);
      END_STATE();
    case 43:
      if (lookahead == 't') ADVANCE(82);
      END_STATE();
    case 44:
      if (lookahead == 'a') ADVANCE(83);
      END_STATE();
    case 45:
      if (lookahead == 'p') ADVANCE(84);
      END_STATE();
    case 46:
      if (lookahead == 'i') ADVANCE(85);
      END_STATE();
    case 47:
      if (lookahead == 'r') ADVANCE(86);
      END_STATE();
    case 48:
      if (lookahead == 'i') ADVANCE(87);
      if (lookahead == 'r') ADVANCE(88);
      END_STATE();
    case 49:
      if (lookahead == 'u') ADVANCE(89);
      if (lookahead == 'y') ADVANCE(90);
      END_STATE();
    case 50:
      if (lookahead == 'p') ADVANCE(91);
      END_STATE();
    case 51:
      if (lookahead == 'd') ADVANCE(92);
      END_STATE();
    case 52:
      if (lookahead == 'r') ADVANCE(93);
      END_STATE();
    case 53:
      if (lookahead == 'i') ADVANCE(94);
      END_STATE();
    case 54:
      if (lookahead == 'i') ADVANCE(95);
      END_STATE();
    case 55:
      if (lookahead == 't') ADVANCE(96);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(97);
      END_STATE();
    case 57:
      if (lookahead == 'n') ADVANCE(98);
      END_STATE();
    case 58:
      if (lookahead == 'i') ADVANCE(99);
      END_STATE();
    case 59:
      if (lookahead == 'a') ADVANCE(100);
      END_STATE();
    case 60:
      if (lookahead == 'e') ADVANCE(101);
      END_STATE();
    case 61:
      if (lookahead == 'c') ADVANCE(102);
      END_STATE();
    case 62:
      if (lookahead == 's') ADVANCE(103);
      END_STATE();
    case 63:
      if (lookahead == 's') ADVANCE(104);
      if (lookahead == 't') ADVANCE(105);
      END_STATE();
    case 64:
      if (lookahead == 'u') ADVANCE(106);
      END_STATE();
    case 65:
      if (lookahead == 'a') ADVANCE(107);
      END_STATE();
    case 66:
      if (lookahead == 'e') ADVANCE(108);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(109);
      END_STATE();
    case 68:
      if (lookahead == 'o') ADVANCE(110);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(111);
      END_STATE();
    case 70:
      if (lookahead == 's') ADVANCE(112);
      END_STATE();
    case 71:
      if (lookahead == 'a') ADVANCE(113);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 73:
      if (lookahead == 'm') ADVANCE(114);
      END_STATE();
    case 74:
      if (lookahead == 'c') ADVANCE(115);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 76:
      if (lookahead == 'o') ADVANCE(116);
      END_STATE();
    case 77:
      if (lookahead == 't') ADVANCE(117);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 80:
      if (lookahead == 'l') ADVANCE(118);
      END_STATE();
    case 81:
      if (lookahead == 'u') ADVANCE(119);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 83:
      if (lookahead == 't') ADVANCE(120);
      END_STATE();
    case 84:
      if (lookahead == 'e') ADVANCE(121);
      END_STATE();
    case 85:
      if (lookahead == 't') ADVANCE(122);
      END_STATE();
    case 86:
      if (lookahead == 'g') ADVANCE(123);
      END_STATE();
    case 87:
      if (lookahead == 's') ADVANCE(124);
      END_STATE();
    case 88:
      if (lookahead == 'o') ADVANCE(125);
      END_STATE();
    case 89:
      if (lookahead == 'e') ADVANCE(126);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 91:
      if (lookahead == 'e') ADVANCE(127);
      END_STATE();
    case 92:
      if (lookahead == 'e') ADVANCE(128);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 94:
      if (lookahead == 'd') ADVANCE(129);
      END_STATE();
    case 95:
      if (lookahead == 'l') ADVANCE(130);
      END_STATE();
    case 96:
      if (lookahead == 'h') ADVANCE(131);
      END_STATE();
    case 97:
      if (lookahead == 'l') ADVANCE(132);
      END_STATE();
    case 98:
      if (lookahead == 'c') ADVANCE(133);
      END_STATE();
    case 99:
      if (lookahead == 't') ADVANCE(134);
      END_STATE();
    case 100:
      if (lookahead == 'k') ADVANCE(135);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 102:
      if (lookahead == 'h') ADVANCE(136);
      END_STATE();
    case 103:
      if (lookahead == 's') ADVANCE(137);
      END_STATE();
    case 104:
      if (lookahead == 't') ADVANCE(138);
      END_STATE();
    case 105:
      if (lookahead == 'i') ADVANCE(139);
      END_STATE();
    case 106:
      if (lookahead == 'g') ADVANCE(140);
      END_STATE();
    case 107:
      if (lookahead == 'u') ADVANCE(141);
      END_STATE();
    case 108:
      if (lookahead == 't') ADVANCE(142);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 110:
      if (lookahead == 'r') ADVANCE(143);
      END_STATE();
    case 111:
      if (lookahead == 'n') ADVANCE(144);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(145);
      END_STATE();
    case 113:
      if (lookahead == 'l') ADVANCE(146);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 115:
      if (lookahead == 't') ADVANCE(147);
      END_STATE();
    case 116:
      if (lookahead == 'r') ADVANCE(148);
      END_STATE();
    case 117:
      if (lookahead == 'a') ADVANCE(149);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 119:
      if (lookahead == 'r') ADVANCE(150);
      END_STATE();
    case 120:
      if (lookahead == 'i') ADVANCE(151);
      END_STATE();
    case 121:
      if (lookahead == 'r') ADVANCE(152);
      END_STATE();
    case 122:
      if (lookahead == 'c') ADVANCE(153);
      END_STATE();
    case 123:
      if (lookahead == 'e') ADVANCE(154);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_this);
      END_STATE();
    case 125:
      if (lookahead == 'w') ADVANCE(155);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 127:
      if (lookahead == 'o') ADVANCE(156);
      END_STATE();
    case 128:
      if (lookahead == 'f') ADVANCE(157);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 130:
      if (lookahead == 'e') ADVANCE(158);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 132:
      if (lookahead == 'd') ADVANCE(159);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 139:
      if (lookahead == 'n') ADVANCE(160);
      END_STATE();
    case 140:
      if (lookahead == 'g') ADVANCE(161);
      END_STATE();
    case 141:
      if (lookahead == 'l') ADVANCE(162);
      END_STATE();
    case 142:
      if (lookahead == 'e') ADVANCE(163);
      END_STATE();
    case 143:
      if (lookahead == 't') ADVANCE(164);
      END_STATE();
    case 144:
      if (lookahead == 'd') ADVANCE(165);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 146:
      if (lookahead == 'l') ADVANCE(166);
      END_STATE();
    case 147:
      if (lookahead == 'i') ADVANCE(167);
      END_STATE();
    case 148:
      if (lookahead == 't') ADVANCE(168);
      END_STATE();
    case 149:
      if (lookahead == 'n') ADVANCE(169);
      END_STATE();
    case 150:
      if (lookahead == 'n') ADVANCE(170);
      END_STATE();
    case 151:
      if (lookahead == 'c') ADVANCE(171);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 153:
      if (lookahead == 'h') ADVANCE(172);
      END_STATE();
    case 154:
      if (lookahead == 't') ADVANCE(173);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 156:
      if (lookahead == 'f') ADVANCE(174);
      END_STATE();
    case 157:
      if (lookahead == 'i') ADVANCE(175);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 160:
      if (lookahead == 'u') ADVANCE(176);
      END_STATE();
    case 161:
      if (lookahead == 'e') ADVANCE(177);
      END_STATE();
    case 162:
      if (lookahead == 't') ADVANCE(178);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 165:
      if (lookahead == 's') ADVANCE(179);
      END_STATE();
    case 166:
      if (lookahead == 'y') ADVANCE(180);
      END_STATE();
    case 167:
      if (lookahead == 'o') ADVANCE(181);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 169:
      if (lookahead == 'c') ADVANCE(182);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 175:
      if (lookahead == 'n') ADVANCE(183);
      END_STATE();
    case 176:
      if (lookahead == 'e') ADVANCE(184);
      END_STATE();
    case 177:
      if (lookahead == 'r') ADVANCE(185);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 181:
      if (lookahead == 'n') ADVANCE(186);
      END_STATE();
    case 182:
      if (lookahead == 'e') ADVANCE(187);
      END_STATE();
    case 183:
      if (lookahead == 'e') ADVANCE(188);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 187:
      if (lookahead == 'o') ADVANCE(189);
      END_STATE();
    case 188:
      if (lookahead == 'd') ADVANCE(190);
      END_STATE();
    case 189:
      if (lookahead == 'f') ADVANCE(191);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 61},
  [2] = {.lex_state = 61},
  [3] = {.lex_state = 61},
  [4] = {.lex_state = 61},
  [5] = {.lex_state = 61},
  [6] = {.lex_state = 61},
  [7] = {.lex_state = 61},
  [8] = {.lex_state = 61},
  [9] = {.lex_state = 61},
  [10] = {.lex_state = 61},
  [11] = {.lex_state = 61},
  [12] = {.lex_state = 61},
  [13] = {.lex_state = 61},
  [14] = {.lex_state = 61},
  [15] = {.lex_state = 61},
  [16] = {.lex_state = 61},
  [17] = {.lex_state = 61},
  [18] = {.lex_state = 61},
  [19] = {.lex_state = 61},
  [20] = {.lex_state = 61},
  [21] = {.lex_state = 61},
  [22] = {.lex_state = 61},
  [23] = {.lex_state = 61},
  [24] = {.lex_state = 61},
  [25] = {.lex_state = 61},
  [26] = {.lex_state = 61},
  [27] = {.lex_state = 61},
  [28] = {.lex_state = 61},
  [29] = {.lex_state = 61},
  [30] = {.lex_state = 61},
  [31] = {.lex_state = 61},
  [32] = {.lex_state = 61},
  [33] = {.lex_state = 61},
  [34] = {.lex_state = 61},
  [35] = {.lex_state = 61},
  [36] = {.lex_state = 61},
  [37] = {.lex_state = 61},
  [38] = {.lex_state = 61},
  [39] = {.lex_state = 61},
  [40] = {.lex_state = 61},
  [41] = {.lex_state = 61},
  [42] = {.lex_state = 61},
  [43] = {.lex_state = 60},
  [44] = {.lex_state = 60, .external_lex_state = 2},
  [45] = {.lex_state = 60, .external_lex_state = 2},
  [46] = {.lex_state = 60, .external_lex_state = 2},
  [47] = {.lex_state = 60, .external_lex_state = 2},
  [48] = {.lex_state = 60, .external_lex_state = 2},
  [49] = {.lex_state = 60, .external_lex_state = 2},
  [50] = {.lex_state = 60, .external_lex_state = 2},
  [51] = {.lex_state = 60, .external_lex_state = 2},
  [52] = {.lex_state = 60, .external_lex_state = 2},
  [53] = {.lex_state = 60, .external_lex_state = 2},
  [54] = {.lex_state = 60, .external_lex_state = 2},
  [55] = {.lex_state = 60, .external_lex_state = 2},
  [56] = {.lex_state = 60, .external_lex_state = 2},
  [57] = {.lex_state = 60, .external_lex_state = 2},
  [58] = {.lex_state = 60, .external_lex_state = 2},
  [59] = {.lex_state = 60, .external_lex_state = 2},
  [60] = {.lex_state = 61},
  [61] = {.lex_state = 61},
  [62] = {.lex_state = 61},
  [63] = {.lex_state = 61},
  [64] = {.lex_state = 61},
  [65] = {.lex_state = 61},
  [66] = {.lex_state = 61},
  [67] = {.lex_state = 61},
  [68] = {.lex_state = 61},
  [69] = {.lex_state = 61},
  [70] = {.lex_state = 61},
  [71] = {.lex_state = 61},
  [72] = {.lex_state = 61},
  [73] = {.lex_state = 61},
  [74] = {.lex_state = 61},
  [75] = {.lex_state = 61},
  [76] = {.lex_state = 61, .external_lex_state = 2},
  [77] = {.lex_state = 61},
  [78] = {.lex_state = 61},
  [79] = {.lex_state = 61},
  [80] = {.lex_state = 61},
  [81] = {.lex_state = 61},
  [82] = {.lex_state = 61},
  [83] = {.lex_state = 61},
  [84] = {.lex_state = 61},
  [85] = {.lex_state = 61},
  [86] = {.lex_state = 61},
  [87] = {.lex_state = 61},
  [88] = {.lex_state = 61},
  [89] = {.lex_state = 8},
  [90] = {.lex_state = 61},
  [91] = {.lex_state = 61},
  [92] = {.lex_state = 61},
  [93] = {.lex_state = 61},
  [94] = {.lex_state = 8},
  [95] = {.lex_state = 61},
  [96] = {.lex_state = 61},
  [97] = {.lex_state = 61},
  [98] = {.lex_state = 61},
  [99] = {.lex_state = 61},
  [100] = {.lex_state = 61},
  [101] = {.lex_state = 61},
  [102] = {.lex_state = 61},
  [103] = {.lex_state = 61},
  [104] = {.lex_state = 61},
  [105] = {.lex_state = 61},
  [106] = {.lex_state = 61},
  [107] = {.lex_state = 61},
  [108] = {.lex_state = 61},
  [109] = {.lex_state = 61},
  [110] = {.lex_state = 61},
  [111] = {.lex_state = 61},
  [112] = {.lex_state = 61},
  [113] = {.lex_state = 61},
  [114] = {.lex_state = 61},
  [115] = {.lex_state = 61},
  [116] = {.lex_state = 61},
  [117] = {.lex_state = 61},
  [118] = {.lex_state = 61},
  [119] = {.lex_state = 61},
  [120] = {.lex_state = 61},
  [121] = {.lex_state = 61},
  [122] = {.lex_state = 61},
  [123] = {.lex_state = 61},
  [124] = {.lex_state = 61},
  [125] = {.lex_state = 61},
  [126] = {.lex_state = 61},
  [127] = {.lex_state = 61},
  [128] = {.lex_state = 61},
  [129] = {.lex_state = 61},
  [130] = {.lex_state = 61},
  [131] = {.lex_state = 61},
  [132] = {.lex_state = 61},
  [133] = {.lex_state = 61},
  [134] = {.lex_state = 61},
  [135] = {.lex_state = 61},
  [136] = {.lex_state = 61},
  [137] = {.lex_state = 61},
  [138] = {.lex_state = 61},
  [139] = {.lex_state = 61},
  [140] = {.lex_state = 61},
  [141] = {.lex_state = 61},
  [142] = {.lex_state = 61},
  [143] = {.lex_state = 61},
  [144] = {.lex_state = 61},
  [145] = {.lex_state = 61},
  [146] = {.lex_state = 61},
  [147] = {.lex_state = 61},
  [148] = {.lex_state = 61},
  [149] = {.lex_state = 61},
  [150] = {.lex_state = 61},
  [151] = {.lex_state = 61},
  [152] = {.lex_state = 61},
  [153] = {.lex_state = 61},
  [154] = {.lex_state = 61},
  [155] = {.lex_state = 61},
  [156] = {.lex_state = 61},
  [157] = {.lex_state = 61},
  [158] = {.lex_state = 61},
  [159] = {.lex_state = 61},
  [160] = {.lex_state = 61},
  [161] = {.lex_state = 61},
  [162] = {.lex_state = 61},
  [163] = {.lex_state = 61},
  [164] = {.lex_state = 61},
  [165] = {.lex_state = 61},
  [166] = {.lex_state = 61},
  [167] = {.lex_state = 61},
  [168] = {.lex_state = 61},
  [169] = {.lex_state = 61},
  [170] = {.lex_state = 61},
  [171] = {.lex_state = 61},
  [172] = {.lex_state = 61},
  [173] = {.lex_state = 61},
  [174] = {.lex_state = 61},
  [175] = {.lex_state = 61},
  [176] = {.lex_state = 61},
  [177] = {.lex_state = 61},
  [178] = {.lex_state = 9, .external_lex_state = 2},
  [179] = {.lex_state = 9, .external_lex_state = 2},
  [180] = {.lex_state = 61, .external_lex_state = 2},
  [181] = {.lex_state = 61, .external_lex_state = 2},
  [182] = {.lex_state = 9, .external_lex_state = 2},
  [183] = {.lex_state = 9, .external_lex_state = 2},
  [184] = {.lex_state = 61},
  [185] = {.lex_state = 61},
  [186] = {.lex_state = 61},
  [187] = {.lex_state = 9, .external_lex_state = 2},
  [188] = {.lex_state = 9, .external_lex_state = 2},
  [189] = {.lex_state = 61},
  [190] = {.lex_state = 61, .external_lex_state = 2},
  [191] = {.lex_state = 61, .external_lex_state = 2},
  [192] = {.lex_state = 61, .external_lex_state = 2},
  [193] = {.lex_state = 61, .external_lex_state = 2},
  [194] = {.lex_state = 61, .external_lex_state = 2},
  [195] = {.lex_state = 61, .external_lex_state = 2},
  [196] = {.lex_state = 61},
  [197] = {.lex_state = 9},
  [198] = {.lex_state = 61, .external_lex_state = 2},
  [199] = {.lex_state = 61, .external_lex_state = 2},
  [200] = {.lex_state = 61},
  [201] = {.lex_state = 61, .external_lex_state = 2},
  [202] = {.lex_state = 61, .external_lex_state = 2},
  [203] = {.lex_state = 61, .external_lex_state = 2},
  [204] = {.lex_state = 61, .external_lex_state = 2},
  [205] = {.lex_state = 61},
  [206] = {.lex_state = 61},
  [207] = {.lex_state = 61},
  [208] = {.lex_state = 61},
  [209] = {.lex_state = 61, .external_lex_state = 2},
  [210] = {.lex_state = 61, .external_lex_state = 2},
  [211] = {.lex_state = 61},
  [212] = {.lex_state = 61},
  [213] = {.lex_state = 61},
  [214] = {.lex_state = 61},
  [215] = {.lex_state = 61},
  [216] = {.lex_state = 61},
  [217] = {.lex_state = 61},
  [218] = {.lex_state = 61},
  [219] = {.lex_state = 61},
  [220] = {.lex_state = 61},
  [221] = {.lex_state = 61},
  [222] = {.lex_state = 61},
  [223] = {.lex_state = 61},
  [224] = {.lex_state = 61},
  [225] = {.lex_state = 61},
  [226] = {.lex_state = 61},
  [227] = {.lex_state = 61},
  [228] = {.lex_state = 61},
  [229] = {.lex_state = 61},
  [230] = {.lex_state = 61},
  [231] = {.lex_state = 61},
  [232] = {.lex_state = 61},
  [233] = {.lex_state = 61},
  [234] = {.lex_state = 61},
  [235] = {.lex_state = 61},
  [236] = {.lex_state = 61},
  [237] = {.lex_state = 61},
  [238] = {.lex_state = 61},
  [239] = {.lex_state = 61},
  [240] = {.lex_state = 9},
  [241] = {.lex_state = 61},
  [242] = {.lex_state = 61},
  [243] = {.lex_state = 61},
  [244] = {.lex_state = 61},
  [245] = {.lex_state = 61},
  [246] = {.lex_state = 61},
  [247] = {.lex_state = 61},
  [248] = {.lex_state = 61},
  [249] = {.lex_state = 61},
  [250] = {.lex_state = 61},
  [251] = {.lex_state = 61},
  [252] = {.lex_state = 61},
  [253] = {.lex_state = 61},
  [254] = {.lex_state = 61},
  [255] = {.lex_state = 61},
  [256] = {.lex_state = 9, .external_lex_state = 2},
  [257] = {.lex_state = 9, .external_lex_state = 2},
  [258] = {.lex_state = 9, .external_lex_state = 2},
  [259] = {.lex_state = 9, .external_lex_state = 2},
  [260] = {.lex_state = 9, .external_lex_state = 2},
  [261] = {.lex_state = 9},
  [262] = {.lex_state = 61},
  [263] = {.lex_state = 61},
  [264] = {.lex_state = 9},
  [265] = {.lex_state = 9},
  [266] = {.lex_state = 61},
  [267] = {.lex_state = 61},
  [268] = {.lex_state = 61},
  [269] = {.lex_state = 61},
  [270] = {.lex_state = 61},
  [271] = {.lex_state = 61},
  [272] = {.lex_state = 61},
  [273] = {.lex_state = 9},
  [274] = {.lex_state = 9},
  [275] = {.lex_state = 9},
  [276] = {.lex_state = 9},
  [277] = {.lex_state = 9},
  [278] = {.lex_state = 9},
  [279] = {.lex_state = 9, .external_lex_state = 2},
  [280] = {.lex_state = 9},
  [281] = {.lex_state = 9},
  [282] = {.lex_state = 9, .external_lex_state = 2},
  [283] = {.lex_state = 9},
  [284] = {.lex_state = 9},
  [285] = {.lex_state = 9, .external_lex_state = 2},
  [286] = {.lex_state = 9, .external_lex_state = 2},
  [287] = {.lex_state = 9, .external_lex_state = 2},
  [288] = {.lex_state = 9, .external_lex_state = 2},
  [289] = {.lex_state = 9, .external_lex_state = 2},
  [290] = {.lex_state = 9, .external_lex_state = 2},
  [291] = {.lex_state = 9, .external_lex_state = 2},
  [292] = {.lex_state = 9, .external_lex_state = 2},
  [293] = {.lex_state = 9, .external_lex_state = 2},
  [294] = {.lex_state = 9, .external_lex_state = 2},
  [295] = {.lex_state = 9, .external_lex_state = 2},
  [296] = {.lex_state = 9, .external_lex_state = 2},
  [297] = {.lex_state = 9, .external_lex_state = 2},
  [298] = {.lex_state = 9, .external_lex_state = 2},
  [299] = {.lex_state = 9, .external_lex_state = 2},
  [300] = {.lex_state = 9, .external_lex_state = 2},
  [301] = {.lex_state = 60},
  [302] = {.lex_state = 9, .external_lex_state = 2},
  [303] = {.lex_state = 60},
  [304] = {.lex_state = 9},
  [305] = {.lex_state = 9, .external_lex_state = 2},
  [306] = {.lex_state = 9},
  [307] = {.lex_state = 60},
  [308] = {.lex_state = 9},
  [309] = {.lex_state = 9},
  [310] = {.lex_state = 9},
  [311] = {.lex_state = 9},
  [312] = {.lex_state = 9},
  [313] = {.lex_state = 9},
  [314] = {.lex_state = 9},
  [315] = {.lex_state = 60, .external_lex_state = 2},
  [316] = {.lex_state = 60},
  [317] = {.lex_state = 60},
  [318] = {.lex_state = 60},
  [319] = {.lex_state = 60},
  [320] = {.lex_state = 60},
  [321] = {.lex_state = 60},
  [322] = {.lex_state = 60},
  [323] = {.lex_state = 60},
  [324] = {.lex_state = 60},
  [325] = {.lex_state = 60},
  [326] = {.lex_state = 60},
  [327] = {.lex_state = 60},
  [328] = {.lex_state = 60},
  [329] = {.lex_state = 60},
  [330] = {.lex_state = 60},
  [331] = {.lex_state = 60},
  [332] = {.lex_state = 60},
  [333] = {.lex_state = 60},
  [334] = {.lex_state = 60},
  [335] = {.lex_state = 60},
  [336] = {.lex_state = 60},
  [337] = {.lex_state = 60},
  [338] = {.lex_state = 60},
  [339] = {.lex_state = 60},
  [340] = {.lex_state = 60},
  [341] = {.lex_state = 60},
  [342] = {.lex_state = 60},
  [343] = {.lex_state = 60},
  [344] = {.lex_state = 60},
  [345] = {.lex_state = 60},
  [346] = {.lex_state = 60},
  [347] = {.lex_state = 60, .external_lex_state = 2},
  [348] = {.lex_state = 60},
  [349] = {.lex_state = 60},
  [350] = {.lex_state = 60},
  [351] = {.lex_state = 60},
  [352] = {.lex_state = 60},
  [353] = {.lex_state = 60},
  [354] = {.lex_state = 60},
  [355] = {.lex_state = 60},
  [356] = {.lex_state = 60},
  [357] = {.lex_state = 60, .external_lex_state = 2},
  [358] = {.lex_state = 10},
  [359] = {.lex_state = 60},
  [360] = {.lex_state = 60},
  [361] = {.lex_state = 60},
  [362] = {.lex_state = 60},
  [363] = {.lex_state = 60, .external_lex_state = 2},
  [364] = {.lex_state = 60},
  [365] = {.lex_state = 60, .external_lex_state = 2},
  [366] = {.lex_state = 60, .external_lex_state = 2},
  [367] = {.lex_state = 60},
  [368] = {.lex_state = 60, .external_lex_state = 2},
  [369] = {.lex_state = 60},
  [370] = {.lex_state = 60},
  [371] = {.lex_state = 60, .external_lex_state = 2},
  [372] = {.lex_state = 60, .external_lex_state = 2},
  [373] = {.lex_state = 60, .external_lex_state = 2},
  [374] = {.lex_state = 60, .external_lex_state = 2},
  [375] = {.lex_state = 60},
  [376] = {.lex_state = 60, .external_lex_state = 2},
  [377] = {.lex_state = 60, .external_lex_state = 2},
  [378] = {.lex_state = 60, .external_lex_state = 2},
  [379] = {.lex_state = 60},
  [380] = {.lex_state = 60},
  [381] = {.lex_state = 60},
  [382] = {.lex_state = 60},
  [383] = {.lex_state = 60, .external_lex_state = 2},
  [384] = {.lex_state = 60, .external_lex_state = 2},
  [385] = {.lex_state = 60, .external_lex_state = 2},
  [386] = {.lex_state = 60},
  [387] = {.lex_state = 60, .external_lex_state = 2},
  [388] = {.lex_state = 60},
  [389] = {.lex_state = 60},
  [390] = {.lex_state = 60, .external_lex_state = 2},
  [391] = {.lex_state = 60, .external_lex_state = 2},
  [392] = {.lex_state = 60},
  [393] = {.lex_state = 60, .external_lex_state = 2},
  [394] = {.lex_state = 60, .external_lex_state = 2},
  [395] = {.lex_state = 60, .external_lex_state = 2},
  [396] = {.lex_state = 60},
  [397] = {.lex_state = 60},
  [398] = {.lex_state = 60},
  [399] = {.lex_state = 60},
  [400] = {.lex_state = 60},
  [401] = {.lex_state = 60},
  [402] = {.lex_state = 60},
  [403] = {.lex_state = 60, .external_lex_state = 2},
  [404] = {.lex_state = 60, .external_lex_state = 2},
  [405] = {.lex_state = 60, .external_lex_state = 2},
  [406] = {.lex_state = 60},
  [407] = {.lex_state = 60},
  [408] = {.lex_state = 60, .external_lex_state = 2},
  [409] = {.lex_state = 60, .external_lex_state = 2},
  [410] = {.lex_state = 60, .external_lex_state = 2},
  [411] = {.lex_state = 60, .external_lex_state = 2},
  [412] = {.lex_state = 60, .external_lex_state = 2},
  [413] = {.lex_state = 60, .external_lex_state = 2},
  [414] = {.lex_state = 60, .external_lex_state = 2},
  [415] = {.lex_state = 60, .external_lex_state = 2},
  [416] = {.lex_state = 60, .external_lex_state = 2},
  [417] = {.lex_state = 60},
  [418] = {.lex_state = 60},
  [419] = {.lex_state = 60, .external_lex_state = 2},
  [420] = {.lex_state = 60, .external_lex_state = 2},
  [421] = {.lex_state = 60, .external_lex_state = 2},
  [422] = {.lex_state = 60, .external_lex_state = 2},
  [423] = {.lex_state = 60, .external_lex_state = 2},
  [424] = {.lex_state = 60, .external_lex_state = 2},
  [425] = {.lex_state = 60, .external_lex_state = 2},
  [426] = {.lex_state = 60},
  [427] = {.lex_state = 60},
  [428] = {.lex_state = 60, .external_lex_state = 2},
  [429] = {.lex_state = 60},
  [430] = {.lex_state = 60},
  [431] = {.lex_state = 60},
  [432] = {.lex_state = 60},
  [433] = {.lex_state = 60, .external_lex_state = 2},
  [434] = {.lex_state = 60},
  [435] = {.lex_state = 60},
  [436] = {.lex_state = 60},
  [437] = {.lex_state = 60, .external_lex_state = 2},
  [438] = {.lex_state = 60, .external_lex_state = 2},
  [439] = {.lex_state = 60},
  [440] = {.lex_state = 60},
  [441] = {.lex_state = 60},
  [442] = {.lex_state = 60},
  [443] = {.lex_state = 60},
  [444] = {.lex_state = 60},
  [445] = {.lex_state = 60},
  [446] = {.lex_state = 60},
  [447] = {.lex_state = 60},
  [448] = {.lex_state = 60},
  [449] = {.lex_state = 60, .external_lex_state = 2},
  [450] = {.lex_state = 60},
  [451] = {.lex_state = 60, .external_lex_state = 2},
  [452] = {.lex_state = 60, .external_lex_state = 2},
  [453] = {.lex_state = 60, .external_lex_state = 2},
  [454] = {.lex_state = 60},
  [455] = {.lex_state = 60, .external_lex_state = 2},
  [456] = {.lex_state = 60, .external_lex_state = 2},
  [457] = {.lex_state = 60},
  [458] = {.lex_state = 60, .external_lex_state = 2},
  [459] = {.lex_state = 60, .external_lex_state = 2},
  [460] = {.lex_state = 60},
  [461] = {.lex_state = 60, .external_lex_state = 2},
  [462] = {.lex_state = 60, .external_lex_state = 2},
  [463] = {.lex_state = 60, .external_lex_state = 2},
  [464] = {.lex_state = 60, .external_lex_state = 2},
  [465] = {.lex_state = 60},
  [466] = {.lex_state = 60, .external_lex_state = 2},
  [467] = {.lex_state = 60, .external_lex_state = 2},
  [468] = {.lex_state = 60, .external_lex_state = 2},
  [469] = {.lex_state = 60},
  [470] = {.lex_state = 60, .external_lex_state = 2},
  [471] = {.lex_state = 60, .external_lex_state = 2},
  [472] = {.lex_state = 60, .external_lex_state = 2},
  [473] = {.lex_state = 60, .external_lex_state = 2},
  [474] = {.lex_state = 60, .external_lex_state = 2},
  [475] = {.lex_state = 10, .external_lex_state = 2},
  [476] = {.lex_state = 60, .external_lex_state = 2},
  [477] = {.lex_state = 60},
  [478] = {.lex_state = 60},
  [479] = {.lex_state = 60},
  [480] = {.lex_state = 60, .external_lex_state = 2},
  [481] = {.lex_state = 60, .external_lex_state = 2},
  [482] = {.lex_state = 60, .external_lex_state = 2},
  [483] = {.lex_state = 60, .external_lex_state = 2},
  [484] = {.lex_state = 60, .external_lex_state = 2},
  [485] = {.lex_state = 60},
  [486] = {.lex_state = 60},
  [487] = {.lex_state = 60},
  [488] = {.lex_state = 60, .external_lex_state = 2},
  [489] = {.lex_state = 60, .external_lex_state = 2},
  [490] = {.lex_state = 60, .external_lex_state = 2},
  [491] = {.lex_state = 60, .external_lex_state = 2},
  [492] = {.lex_state = 60, .external_lex_state = 2},
  [493] = {.lex_state = 60, .external_lex_state = 2},
  [494] = {.lex_state = 60},
  [495] = {.lex_state = 60},
  [496] = {.lex_state = 60},
  [497] = {.lex_state = 60},
  [498] = {.lex_state = 60},
  [499] = {.lex_state = 60},
  [500] = {.lex_state = 60},
  [501] = {.lex_state = 60, .external_lex_state = 2},
  [502] = {.lex_state = 60},
  [503] = {.lex_state = 60},
  [504] = {.lex_state = 60},
  [505] = {.lex_state = 60},
  [506] = {.lex_state = 60, .external_lex_state = 2},
  [507] = {.lex_state = 60, .external_lex_state = 2},
  [508] = {.lex_state = 60, .external_lex_state = 2},
  [509] = {.lex_state = 60},
  [510] = {.lex_state = 60},
  [511] = {.lex_state = 60, .external_lex_state = 2},
  [512] = {.lex_state = 60},
  [513] = {.lex_state = 60, .external_lex_state = 2},
  [514] = {.lex_state = 60, .external_lex_state = 2},
  [515] = {.lex_state = 60, .external_lex_state = 2},
  [516] = {.lex_state = 60, .external_lex_state = 2},
  [517] = {.lex_state = 60, .external_lex_state = 2},
  [518] = {.lex_state = 60, .external_lex_state = 2},
  [519] = {.lex_state = 60, .external_lex_state = 2},
  [520] = {.lex_state = 60},
  [521] = {.lex_state = 60, .external_lex_state = 2},
  [522] = {.lex_state = 60, .external_lex_state = 2},
  [523] = {.lex_state = 60, .external_lex_state = 2},
  [524] = {.lex_state = 60},
  [525] = {.lex_state = 60, .external_lex_state = 2},
  [526] = {.lex_state = 60, .external_lex_state = 2},
  [527] = {.lex_state = 60},
  [528] = {.lex_state = 60},
  [529] = {.lex_state = 60, .external_lex_state = 2},
  [530] = {.lex_state = 60, .external_lex_state = 2},
  [531] = {.lex_state = 60},
  [532] = {.lex_state = 60, .external_lex_state = 2},
  [533] = {.lex_state = 60, .external_lex_state = 2},
  [534] = {.lex_state = 60, .external_lex_state = 2},
  [535] = {.lex_state = 60, .external_lex_state = 2},
  [536] = {.lex_state = 60, .external_lex_state = 2},
  [537] = {.lex_state = 60, .external_lex_state = 2},
  [538] = {.lex_state = 60, .external_lex_state = 2},
  [539] = {.lex_state = 60},
  [540] = {.lex_state = 60, .external_lex_state = 2},
  [541] = {.lex_state = 60, .external_lex_state = 2},
  [542] = {.lex_state = 60},
  [543] = {.lex_state = 60, .external_lex_state = 2},
  [544] = {.lex_state = 60, .external_lex_state = 2},
  [545] = {.lex_state = 60},
  [546] = {.lex_state = 60, .external_lex_state = 2},
  [547] = {.lex_state = 60, .external_lex_state = 2},
  [548] = {.lex_state = 60},
  [549] = {.lex_state = 60, .external_lex_state = 2},
  [550] = {.lex_state = 60, .external_lex_state = 2},
  [551] = {.lex_state = 60, .external_lex_state = 2},
  [552] = {.lex_state = 60, .external_lex_state = 2},
  [553] = {.lex_state = 60, .external_lex_state = 2},
  [554] = {.lex_state = 60, .external_lex_state = 2},
  [555] = {.lex_state = 60, .external_lex_state = 2},
  [556] = {.lex_state = 60, .external_lex_state = 2},
  [557] = {.lex_state = 60},
  [558] = {.lex_state = 60, .external_lex_state = 2},
  [559] = {.lex_state = 60},
  [560] = {.lex_state = 60},
  [561] = {.lex_state = 60, .external_lex_state = 2},
  [562] = {.lex_state = 60, .external_lex_state = 2},
  [563] = {.lex_state = 60, .external_lex_state = 2},
  [564] = {.lex_state = 60},
  [565] = {.lex_state = 60},
  [566] = {.lex_state = 60},
  [567] = {.lex_state = 60},
  [568] = {.lex_state = 60},
  [569] = {.lex_state = 60},
  [570] = {.lex_state = 60},
  [571] = {.lex_state = 60},
  [572] = {.lex_state = 60},
  [573] = {.lex_state = 60},
  [574] = {.lex_state = 60},
  [575] = {.lex_state = 60},
  [576] = {.lex_state = 60},
  [577] = {.lex_state = 61},
  [578] = {.lex_state = 61},
  [579] = {.lex_state = 61},
  [580] = {.lex_state = 61},
  [581] = {.lex_state = 61},
  [582] = {.lex_state = 61},
  [583] = {.lex_state = 61},
  [584] = {.lex_state = 61},
  [585] = {.lex_state = 61},
  [586] = {.lex_state = 61},
  [587] = {.lex_state = 61},
  [588] = {.lex_state = 61},
  [589] = {.lex_state = 61},
  [590] = {.lex_state = 61},
  [591] = {.lex_state = 61},
  [592] = {.lex_state = 61},
  [593] = {.lex_state = 61},
  [594] = {.lex_state = 61},
  [595] = {.lex_state = 61},
  [596] = {.lex_state = 61},
  [597] = {.lex_state = 61},
  [598] = {.lex_state = 61},
  [599] = {.lex_state = 61, .external_lex_state = 2},
  [600] = {.lex_state = 61, .external_lex_state = 2},
  [601] = {.lex_state = 61, .external_lex_state = 2},
  [602] = {.lex_state = 61},
  [603] = {.lex_state = 61},
  [604] = {.lex_state = 60},
  [605] = {.lex_state = 61},
  [606] = {.lex_state = 61, .external_lex_state = 2},
  [607] = {.lex_state = 60},
  [608] = {.lex_state = 61, .external_lex_state = 2},
  [609] = {.lex_state = 60},
  [610] = {.lex_state = 60},
  [611] = {.lex_state = 61},
  [612] = {.lex_state = 61},
  [613] = {.lex_state = 61},
  [614] = {.lex_state = 61},
  [615] = {.lex_state = 61},
  [616] = {.lex_state = 61},
  [617] = {.lex_state = 61},
  [618] = {.lex_state = 61},
  [619] = {.lex_state = 61},
  [620] = {.lex_state = 61},
  [621] = {.lex_state = 61},
  [622] = {.lex_state = 61},
  [623] = {.lex_state = 61},
  [624] = {.lex_state = 61},
  [625] = {.lex_state = 61},
  [626] = {.lex_state = 61},
  [627] = {.lex_state = 61},
  [628] = {.lex_state = 61},
  [629] = {.lex_state = 61},
  [630] = {.lex_state = 61},
  [631] = {.lex_state = 61},
  [632] = {.lex_state = 61},
  [633] = {.lex_state = 61},
  [634] = {.lex_state = 61},
  [635] = {.lex_state = 61},
  [636] = {.lex_state = 61},
  [637] = {.lex_state = 61},
  [638] = {.lex_state = 61},
  [639] = {.lex_state = 61},
  [640] = {.lex_state = 61},
  [641] = {.lex_state = 61},
  [642] = {.lex_state = 61},
  [643] = {.lex_state = 61},
  [644] = {.lex_state = 21},
  [645] = {.lex_state = 21},
  [646] = {.lex_state = 21},
  [647] = {.lex_state = 21},
  [648] = {.lex_state = 21},
  [649] = {.lex_state = 21},
  [650] = {.lex_state = 21},
  [651] = {.lex_state = 61},
  [652] = {.lex_state = 61},
  [653] = {.lex_state = 21},
  [654] = {.lex_state = 21},
  [655] = {.lex_state = 21},
  [656] = {.lex_state = 21},
  [657] = {.lex_state = 21},
  [658] = {.lex_state = 21},
  [659] = {.lex_state = 22},
  [660] = {.lex_state = 21},
  [661] = {.lex_state = 22},
  [662] = {.lex_state = 22},
  [663] = {.lex_state = 21},
  [664] = {.lex_state = 21},
  [665] = {.lex_state = 21},
  [666] = {.lex_state = 21},
  [667] = {.lex_state = 22},
  [668] = {.lex_state = 22},
  [669] = {.lex_state = 22},
  [670] = {.lex_state = 21},
  [671] = {.lex_state = 22},
  [672] = {.lex_state = 21},
  [673] = {.lex_state = 21},
  [674] = {.lex_state = 22},
  [675] = {.lex_state = 22},
  [676] = {.lex_state = 22},
  [677] = {.lex_state = 22},
  [678] = {.lex_state = 22},
  [679] = {.lex_state = 22},
  [680] = {.lex_state = 22},
  [681] = {.lex_state = 22},
  [682] = {.lex_state = 21},
  [683] = {.lex_state = 61},
  [684] = {.lex_state = 0, .external_lex_state = 2},
  [685] = {.lex_state = 61},
  [686] = {.lex_state = 61},
  [687] = {.lex_state = 13, .external_lex_state = 3},
  [688] = {.lex_state = 61},
  [689] = {.lex_state = 60},
  [690] = {.lex_state = 13, .external_lex_state = 3},
  [691] = {.lex_state = 13, .external_lex_state = 3},
  [692] = {.lex_state = 61},
  [693] = {.lex_state = 0, .external_lex_state = 2},
  [694] = {.lex_state = 21},
  [695] = {.lex_state = 60},
  [696] = {.lex_state = 21},
  [697] = {.lex_state = 61},
  [698] = {.lex_state = 60},
  [699] = {.lex_state = 13, .external_lex_state = 3},
  [700] = {.lex_state = 0},
  [701] = {.lex_state = 21},
  [702] = {.lex_state = 0},
  [703] = {.lex_state = 13, .external_lex_state = 3},
  [704] = {.lex_state = 61},
  [705] = {.lex_state = 21},
  [706] = {.lex_state = 0, .external_lex_state = 2},
  [707] = {.lex_state = 21},
  [708] = {.lex_state = 21},
  [709] = {.lex_state = 61},
  [710] = {.lex_state = 0, .external_lex_state = 2},
  [711] = {.lex_state = 21},
  [712] = {.lex_state = 21},
  [713] = {.lex_state = 61},
  [714] = {.lex_state = 61},
  [715] = {.lex_state = 21},
  [716] = {.lex_state = 61},
  [717] = {.lex_state = 61},
  [718] = {.lex_state = 21},
  [719] = {.lex_state = 21},
  [720] = {.lex_state = 21},
  [721] = {.lex_state = 21},
  [722] = {.lex_state = 0},
  [723] = {.lex_state = 61},
  [724] = {.lex_state = 21},
  [725] = {.lex_state = 0, .external_lex_state = 2},
  [726] = {.lex_state = 61},
  [727] = {.lex_state = 21},
  [728] = {.lex_state = 21},
  [729] = {.lex_state = 21},
  [730] = {.lex_state = 21},
  [731] = {.lex_state = 21},
  [732] = {.lex_state = 21},
  [733] = {.lex_state = 21},
  [734] = {.lex_state = 61},
  [735] = {.lex_state = 21},
  [736] = {.lex_state = 61},
  [737] = {.lex_state = 21},
  [738] = {.lex_state = 21},
  [739] = {.lex_state = 61},
  [740] = {.lex_state = 21},
  [741] = {.lex_state = 61},
  [742] = {.lex_state = 21},
  [743] = {.lex_state = 21},
  [744] = {.lex_state = 21},
  [745] = {.lex_state = 21},
  [746] = {.lex_state = 21},
  [747] = {.lex_state = 61},
  [748] = {.lex_state = 21},
  [749] = {.lex_state = 61},
  [750] = {.lex_state = 61},
  [751] = {.lex_state = 21},
  [752] = {.lex_state = 61, .external_lex_state = 2},
  [753] = {.lex_state = 61},
  [754] = {.lex_state = 61},
  [755] = {.lex_state = 13, .external_lex_state = 3},
  [756] = {.lex_state = 3},
  [757] = {.lex_state = 5},
  [758] = {.lex_state = 3},
  [759] = {.lex_state = 5},
  [760] = {.lex_state = 61},
  [761] = {.lex_state = 5},
  [762] = {.lex_state = 3},
  [763] = {.lex_state = 0},
  [764] = {.lex_state = 61},
  [765] = {.lex_state = 0},
  [766] = {.lex_state = 61},
  [767] = {.lex_state = 61},
  [768] = {.lex_state = 61},
  [769] = {.lex_state = 0, .external_lex_state = 2},
  [770] = {.lex_state = 61},
  [771] = {.lex_state = 0},
  [772] = {.lex_state = 61},
  [773] = {.lex_state = 5},
  [774] = {.lex_state = 3},
  [775] = {.lex_state = 3},
  [776] = {.lex_state = 5},
  [777] = {.lex_state = 61},
  [778] = {.lex_state = 5},
  [779] = {.lex_state = 3},
  [780] = {.lex_state = 61},
  [781] = {.lex_state = 61},
  [782] = {.lex_state = 5},
  [783] = {.lex_state = 0, .external_lex_state = 2},
  [784] = {.lex_state = 3},
  [785] = {.lex_state = 0, .external_lex_state = 2},
  [786] = {.lex_state = 0, .external_lex_state = 2},
  [787] = {.lex_state = 61},
  [788] = {.lex_state = 61},
  [789] = {.lex_state = 61},
  [790] = {.lex_state = 0, .external_lex_state = 2},
  [791] = {.lex_state = 61},
  [792] = {.lex_state = 61},
  [793] = {.lex_state = 61},
  [794] = {.lex_state = 0, .external_lex_state = 2},
  [795] = {.lex_state = 21},
  [796] = {.lex_state = 0, .external_lex_state = 2},
  [797] = {.lex_state = 21},
  [798] = {.lex_state = 61},
  [799] = {.lex_state = 21},
  [800] = {.lex_state = 0},
  [801] = {.lex_state = 61},
  [802] = {.lex_state = 61},
  [803] = {.lex_state = 61},
  [804] = {.lex_state = 61},
  [805] = {.lex_state = 0},
  [806] = {.lex_state = 0},
  [807] = {.lex_state = 61},
  [808] = {.lex_state = 0},
  [809] = {.lex_state = 0},
  [810] = {.lex_state = 0},
  [811] = {.lex_state = 61},
  [812] = {.lex_state = 0},
  [813] = {.lex_state = 0},
  [814] = {.lex_state = 0},
  [815] = {.lex_state = 0},
  [816] = {.lex_state = 0},
  [817] = {.lex_state = 0},
  [818] = {.lex_state = 0},
  [819] = {.lex_state = 61},
  [820] = {.lex_state = 61},
  [821] = {.lex_state = 0},
  [822] = {.lex_state = 0},
  [823] = {.lex_state = 61},
  [824] = {.lex_state = 0},
  [825] = {.lex_state = 0},
  [826] = {.lex_state = 0},
  [827] = {.lex_state = 61},
  [828] = {.lex_state = 0},
  [829] = {.lex_state = 0},
  [830] = {.lex_state = 61},
  [831] = {.lex_state = 0},
  [832] = {.lex_state = 61, .external_lex_state = 2},
  [833] = {.lex_state = 61},
  [834] = {.lex_state = 22},
  [835] = {.lex_state = 0},
  [836] = {.lex_state = 61},
  [837] = {.lex_state = 0},
  [838] = {.lex_state = 0},
  [839] = {.lex_state = 0, .external_lex_state = 2},
  [840] = {.lex_state = 61, .external_lex_state = 2},
  [841] = {.lex_state = 61, .external_lex_state = 2},
  [842] = {.lex_state = 61, .external_lex_state = 2},
  [843] = {.lex_state = 61},
  [844] = {.lex_state = 8},
  [845] = {.lex_state = 61},
  [846] = {.lex_state = 8},
  [847] = {.lex_state = 61, .external_lex_state = 2},
  [848] = {.lex_state = 8},
  [849] = {.lex_state = 0, .external_lex_state = 2},
  [850] = {.lex_state = 22},
  [851] = {.lex_state = 61},
  [852] = {.lex_state = 0},
  [853] = {.lex_state = 8},
  [854] = {.lex_state = 0},
  [855] = {.lex_state = 0},
  [856] = {.lex_state = 61},
  [857] = {.lex_state = 61},
  [858] = {.lex_state = 61, .external_lex_state = 2},
  [859] = {.lex_state = 0},
  [860] = {.lex_state = 0},
  [861] = {.lex_state = 0},
  [862] = {.lex_state = 0},
  [863] = {.lex_state = 0},
  [864] = {.lex_state = 0},
  [865] = {.lex_state = 0},
  [866] = {.lex_state = 0},
  [867] = {.lex_state = 0, .external_lex_state = 2},
  [868] = {.lex_state = 0, .external_lex_state = 2},
  [869] = {.lex_state = 0},
  [870] = {.lex_state = 0},
  [871] = {.lex_state = 0},
  [872] = {.lex_state = 22},
  [873] = {.lex_state = 0},
  [874] = {.lex_state = 22},
  [875] = {.lex_state = 22},
  [876] = {.lex_state = 61},
  [877] = {.lex_state = 22},
  [878] = {.lex_state = 22},
  [879] = {.lex_state = 0},
  [880] = {.lex_state = 22},
  [881] = {.lex_state = 0},
  [882] = {.lex_state = 61, .external_lex_state = 2},
  [883] = {.lex_state = 61},
  [884] = {.lex_state = 0},
  [885] = {.lex_state = 0},
  [886] = {.lex_state = 22},
  [887] = {.lex_state = 61, .external_lex_state = 2},
  [888] = {.lex_state = 0},
  [889] = {.lex_state = 0},
  [890] = {.lex_state = 0},
  [891] = {.lex_state = 0},
  [892] = {.lex_state = 0},
  [893] = {.lex_state = 0},
  [894] = {.lex_state = 0},
  [895] = {.lex_state = 0, .external_lex_state = 2},
  [896] = {.lex_state = 0},
  [897] = {.lex_state = 0},
  [898] = {.lex_state = 0},
  [899] = {.lex_state = 61},
  [900] = {.lex_state = 0},
  [901] = {.lex_state = 61},
  [902] = {.lex_state = 0},
  [903] = {.lex_state = 0},
  [904] = {.lex_state = 61},
  [905] = {.lex_state = 61},
  [906] = {.lex_state = 0},
  [907] = {.lex_state = 0},
  [908] = {.lex_state = 0, .external_lex_state = 2},
  [909] = {.lex_state = 0},
  [910] = {.lex_state = 0},
  [911] = {.lex_state = 0},
  [912] = {.lex_state = 0, .external_lex_state = 2},
  [913] = {.lex_state = 0},
  [914] = {.lex_state = 61},
  [915] = {.lex_state = 0},
  [916] = {.lex_state = 0},
  [917] = {.lex_state = 0},
  [918] = {.lex_state = 0},
  [919] = {.lex_state = 0, .external_lex_state = 2},
  [920] = {.lex_state = 0},
  [921] = {.lex_state = 0, .external_lex_state = 2},
  [922] = {.lex_state = 0},
  [923] = {.lex_state = 0},
  [924] = {.lex_state = 0},
  [925] = {.lex_state = 0},
  [926] = {.lex_state = 0},
  [927] = {.lex_state = 0},
  [928] = {.lex_state = 0},
  [929] = {.lex_state = 61},
  [930] = {.lex_state = 0, .external_lex_state = 2},
  [931] = {.lex_state = 0},
  [932] = {.lex_state = 0},
  [933] = {.lex_state = 0},
  [934] = {.lex_state = 0},
  [935] = {.lex_state = 0, .external_lex_state = 2},
  [936] = {.lex_state = 61},
  [937] = {.lex_state = 0},
  [938] = {.lex_state = 0},
  [939] = {.lex_state = 0},
  [940] = {.lex_state = 0, .external_lex_state = 2},
  [941] = {.lex_state = 0, .external_lex_state = 2},
  [942] = {.lex_state = 0},
  [943] = {.lex_state = 0, .external_lex_state = 2},
  [944] = {.lex_state = 0},
  [945] = {.lex_state = 0},
  [946] = {.lex_state = 0},
  [947] = {.lex_state = 0},
  [948] = {.lex_state = 0},
  [949] = {.lex_state = 0},
  [950] = {.lex_state = 0},
  [951] = {.lex_state = 0},
  [952] = {.lex_state = 0},
  [953] = {.lex_state = 0},
  [954] = {.lex_state = 0, .external_lex_state = 2},
  [955] = {.lex_state = 0},
  [956] = {.lex_state = 0},
  [957] = {.lex_state = 0},
  [958] = {.lex_state = 0},
  [959] = {.lex_state = 0},
  [960] = {.lex_state = 0, .external_lex_state = 2},
  [961] = {.lex_state = 0},
  [962] = {.lex_state = 0},
  [963] = {.lex_state = 0, .external_lex_state = 2},
  [964] = {.lex_state = 0},
  [965] = {.lex_state = 0},
  [966] = {.lex_state = 0},
  [967] = {.lex_state = 0},
  [968] = {.lex_state = 0},
  [969] = {.lex_state = 0},
  [970] = {.lex_state = 0},
  [971] = {.lex_state = 0},
  [972] = {.lex_state = 0},
  [973] = {.lex_state = 0},
  [974] = {.lex_state = 0},
  [975] = {.lex_state = 0, .external_lex_state = 2},
  [976] = {.lex_state = 0},
  [977] = {.lex_state = 0},
  [978] = {.lex_state = 0},
  [979] = {.lex_state = 21},
  [980] = {.lex_state = 0},
  [981] = {.lex_state = 0},
  [982] = {.lex_state = 0},
  [983] = {.lex_state = 0},
  [984] = {.lex_state = 0},
  [985] = {.lex_state = 0},
  [986] = {.lex_state = 0},
  [987] = {.lex_state = 0},
  [988] = {.lex_state = 61},
  [989] = {.lex_state = 0},
  [990] = {.lex_state = 0},
  [991] = {.lex_state = 0},
  [992] = {.lex_state = 0},
  [993] = {.lex_state = 0},
  [994] = {.lex_state = 0},
  [995] = {.lex_state = 61},
  [996] = {.lex_state = 0},
  [997] = {.lex_state = 8},
  [998] = {.lex_state = 0},
  [999] = {.lex_state = 0},
  [1000] = {.lex_state = 0},
  [1001] = {.lex_state = 61},
  [1002] = {.lex_state = 0},
  [1003] = {.lex_state = 0},
  [1004] = {.lex_state = 0},
  [1005] = {.lex_state = 0},
  [1006] = {.lex_state = 0},
  [1007] = {.lex_state = 0},
  [1008] = {.lex_state = 0},
  [1009] = {.lex_state = 0},
  [1010] = {.lex_state = 0},
  [1011] = {.lex_state = 0},
  [1012] = {.lex_state = 0},
  [1013] = {.lex_state = 0},
  [1014] = {.lex_state = 0},
  [1015] = {.lex_state = 0},
  [1016] = {.lex_state = 0},
  [1017] = {.lex_state = 61},
  [1018] = {.lex_state = 0},
  [1019] = {.lex_state = 8},
  [1020] = {.lex_state = 0},
  [1021] = {.lex_state = 0},
  [1022] = {.lex_state = 61},
  [1023] = {.lex_state = 8},
  [1024] = {.lex_state = 0},
  [1025] = {.lex_state = 61},
  [1026] = {.lex_state = 8},
  [1027] = {.lex_state = 0},
  [1028] = {.lex_state = 0},
  [1029] = {.lex_state = 0},
  [1030] = {.lex_state = 0},
  [1031] = {.lex_state = 0},
  [1032] = {.lex_state = 0},
  [1033] = {.lex_state = 0, .external_lex_state = 2},
  [1034] = {.lex_state = 0},
  [1035] = {.lex_state = 61},
  [1036] = {.lex_state = 0},
  [1037] = {.lex_state = 0},
  [1038] = {.lex_state = 0},
  [1039] = {.lex_state = 0},
  [1040] = {.lex_state = 0},
  [1041] = {.lex_state = 0},
  [1042] = {.lex_state = 0},
  [1043] = {.lex_state = 0},
  [1044] = {.lex_state = 0},
  [1045] = {.lex_state = 0},
  [1046] = {.lex_state = 7},
  [1047] = {.lex_state = 61},
  [1048] = {.lex_state = 61},
  [1049] = {.lex_state = 7},
  [1050] = {.lex_state = 61},
  [1051] = {.lex_state = 61},
  [1052] = {.lex_state = 0},
  [1053] = {.lex_state = 0},
  [1054] = {.lex_state = 61},
  [1055] = {.lex_state = 61},
  [1056] = {.lex_state = 0},
  [1057] = {.lex_state = 61},
  [1058] = {.lex_state = 61},
  [1059] = {.lex_state = 0},
  [1060] = {.lex_state = 0},
  [1061] = {.lex_state = 61},
  [1062] = {.lex_state = 61},
  [1063] = {.lex_state = 61},
  [1064] = {.lex_state = 61},
  [1065] = {.lex_state = 0},
  [1066] = {.lex_state = 61},
  [1067] = {.lex_state = 0},
  [1068] = {.lex_state = 0},
  [1069] = {.lex_state = 61},
  [1070] = {.lex_state = 61},
  [1071] = {.lex_state = 0},
  [1072] = {.lex_state = 61},
  [1073] = {.lex_state = 61},
  [1074] = {.lex_state = 61},
  [1075] = {.lex_state = 61},
  [1076] = {.lex_state = 61},
  [1077] = {.lex_state = 61},
  [1078] = {.lex_state = 0},
  [1079] = {.lex_state = 61},
  [1080] = {.lex_state = 13},
  [1081] = {.lex_state = 0},
  [1082] = {.lex_state = 0},
  [1083] = {.lex_state = 61},
  [1084] = {.lex_state = 61},
  [1085] = {.lex_state = 61},
  [1086] = {.lex_state = 0},
  [1087] = {.lex_state = 61},
  [1088] = {.lex_state = 61},
  [1089] = {.lex_state = 61},
  [1090] = {.lex_state = 0},
  [1091] = {.lex_state = 0},
  [1092] = {.lex_state = 61},
  [1093] = {.lex_state = 0},
  [1094] = {.lex_state = 61},
  [1095] = {.lex_state = 0},
  [1096] = {.lex_state = 0},
  [1097] = {.lex_state = 61},
  [1098] = {.lex_state = 61},
  [1099] = {.lex_state = 0},
  [1100] = {.lex_state = 0},
  [1101] = {.lex_state = 0},
  [1102] = {.lex_state = 61},
  [1103] = {.lex_state = 0},
  [1104] = {.lex_state = 0},
  [1105] = {.lex_state = 0},
  [1106] = {.lex_state = 0},
  [1107] = {.lex_state = 0},
  [1108] = {.lex_state = 61},
  [1109] = {.lex_state = 13},
  [1110] = {.lex_state = 0},
  [1111] = {.lex_state = 0},
  [1112] = {.lex_state = 0},
  [1113] = {.lex_state = 61},
  [1114] = {.lex_state = 0},
  [1115] = {.lex_state = 61},
  [1116] = {.lex_state = 61},
  [1117] = {.lex_state = 0},
  [1118] = {.lex_state = 61},
  [1119] = {.lex_state = 61},
  [1120] = {.lex_state = 61},
  [1121] = {.lex_state = 0},
  [1122] = {.lex_state = 0},
  [1123] = {.lex_state = 61},
  [1124] = {.lex_state = 61},
  [1125] = {.lex_state = 61},
  [1126] = {.lex_state = 0},
  [1127] = {.lex_state = 0},
  [1128] = {.lex_state = 61},
  [1129] = {.lex_state = 0},
  [1130] = {.lex_state = 0},
  [1131] = {.lex_state = 61},
  [1132] = {.lex_state = 61},
  [1133] = {.lex_state = 61},
  [1134] = {.lex_state = 61},
  [1135] = {.lex_state = 61},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
};

static bool ts_external_scanner_states[4][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
  },
  [2] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [3] = {
    [ts_external_token__template_chars] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [sym_this] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [sym_preproc] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
  },
  [1] = {
    [sym_program] = STATE(1130),
    [sym_export_statement] = STATE(22),
    [sym__declaration] = STATE(22),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(22),
    [sym_expression_statement] = STATE(22),
    [sym_variable_declaration] = STATE(22),
    [sym_lexical_declaration] = STATE(22),
    [sym_statement_block] = STATE(22),
    [sym_if_statement] = STATE(22),
    [sym_switch_statement] = STATE(22),
    [sym_for_statement] = STATE(22),
    [sym_for_in_statement] = STATE(22),
    [sym_while_statement] = STATE(22),
    [sym_do_statement] = STATE(22),
    [sym_try_statement] = STATE(22),
    [sym_with_statement] = STATE(22),
    [sym_break_statement] = STATE(22),
    [sym_continue_statement] = STATE(22),
    [sym_debugger_statement] = STATE(22),
    [sym_return_statement] = STATE(22),
    [sym_throw_statement] = STATE(22),
    [sym_empty_statement] = STATE(22),
    [sym_labeled_statement] = STATE(22),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(22),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(22),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(22),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(22),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [sym_hash_bang_line] = ACTIONS(9),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(91),
  },
  [2] = {
    [sym_export_statement] = STATE(12),
    [sym__declaration] = STATE(12),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(12),
    [sym_lexical_declaration] = STATE(12),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(532),
    [sym_assignment_pattern] = STATE(809),
    [sym_array] = STATE(529),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(12),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(12),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(12),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_spread_element] = STATE(809),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(534),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [sym_method_definition] = STATE(809),
    [sym_pair] = STATE(809),
    [sym__property_name] = STATE(890),
    [sym_computed_property_name] = STATE(890),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(594),
    [aux_sym_object_repeat1] = STATE(885),
    [sym_identifier] = ACTIONS(93),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(95),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(97),
    [anon_sym_RBRACE] = ACTIONS(99),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(105),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(107),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [sym_preproc] = ACTIONS(113),
  },
  [3] = {
    [sym_export_statement] = STATE(14),
    [sym__declaration] = STATE(14),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym_variable_declaration] = STATE(14),
    [sym_lexical_declaration] = STATE(14),
    [sym_statement_block] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_switch_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_for_in_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_with_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_debugger_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_statement] = STATE(14),
    [sym_empty_statement] = STATE(14),
    [sym_labeled_statement] = STATE(14),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(532),
    [sym_assignment_pattern] = STATE(809),
    [sym_array] = STATE(529),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(14),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(14),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(14),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_spread_element] = STATE(809),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(534),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [sym_method_definition] = STATE(809),
    [sym_pair] = STATE(809),
    [sym__property_name] = STATE(890),
    [sym_computed_property_name] = STATE(890),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_export_statement_repeat1] = STATE(594),
    [aux_sym_object_repeat1] = STATE(885),
    [sym_identifier] = ACTIONS(93),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(95),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(97),
    [anon_sym_RBRACE] = ACTIONS(115),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(105),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(107),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [sym_preproc] = ACTIONS(117),
  },
  [4] = {
    [sym_export_statement] = STATE(19),
    [sym__declaration] = STATE(19),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(19),
    [sym_lexical_declaration] = STATE(19),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(532),
    [sym_assignment_pattern] = STATE(884),
    [sym_array] = STATE(529),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(19),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(19),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(19),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_spread_element] = STATE(884),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(534),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [sym_method_definition] = STATE(884),
    [sym_pair] = STATE(884),
    [sym__property_name] = STATE(890),
    [sym_computed_property_name] = STATE(890),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(594),
    [aux_sym_object_repeat1] = STATE(889),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(95),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(97),
    [anon_sym_RBRACE] = ACTIONS(121),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(123),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(105),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(107),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(125),
    [anon_sym_get] = ACTIONS(127),
    [anon_sym_set] = ACTIONS(127),
    [sym_preproc] = ACTIONS(129),
  },
  [5] = {
    [sym_export_statement] = STATE(12),
    [sym__declaration] = STATE(12),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(12),
    [sym_lexical_declaration] = STATE(12),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(532),
    [sym_assignment_pattern] = STATE(809),
    [sym_array] = STATE(529),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(12),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(12),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(12),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_spread_element] = STATE(809),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(534),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [sym_method_definition] = STATE(809),
    [sym_pair] = STATE(809),
    [sym__property_name] = STATE(890),
    [sym_computed_property_name] = STATE(890),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(594),
    [aux_sym_object_repeat1] = STATE(885),
    [sym_identifier] = ACTIONS(93),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_STAR] = ACTIONS(95),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(97),
    [anon_sym_RBRACE] = ACTIONS(131),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(103),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(105),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(107),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(109),
    [anon_sym_get] = ACTIONS(111),
    [anon_sym_set] = ACTIONS(111),
    [sym_preproc] = ACTIONS(113),
  },
  [6] = {
    [sym_export_statement] = STATE(6),
    [sym__declaration] = STATE(6),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_variable_declaration] = STATE(6),
    [sym_lexical_declaration] = STATE(6),
    [sym_statement_block] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_for_in_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_try_statement] = STATE(6),
    [sym_with_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_debugger_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_throw_statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(6),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(6),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(6),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [ts_builtin_sym_end] = ACTIONS(133),
    [sym_identifier] = ACTIONS(135),
    [anon_sym_export] = ACTIONS(138),
    [anon_sym_default] = ACTIONS(141),
    [anon_sym_LBRACE] = ACTIONS(143),
    [anon_sym_RBRACE] = ACTIONS(133),
    [anon_sym_import] = ACTIONS(146),
    [anon_sym_var] = ACTIONS(149),
    [anon_sym_let] = ACTIONS(152),
    [anon_sym_const] = ACTIONS(152),
    [anon_sym_if] = ACTIONS(155),
    [anon_sym_switch] = ACTIONS(158),
    [anon_sym_for] = ACTIONS(161),
    [anon_sym_LPAREN] = ACTIONS(164),
    [anon_sym_await] = ACTIONS(167),
    [anon_sym_while] = ACTIONS(170),
    [anon_sym_do] = ACTIONS(173),
    [anon_sym_try] = ACTIONS(176),
    [anon_sym_with] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(182),
    [anon_sym_continue] = ACTIONS(185),
    [anon_sym_debugger] = ACTIONS(188),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_throw] = ACTIONS(194),
    [anon_sym_SEMI] = ACTIONS(197),
    [anon_sym_case] = ACTIONS(141),
    [anon_sym_yield] = ACTIONS(200),
    [anon_sym_LBRACK] = ACTIONS(203),
    [anon_sym_LT] = ACTIONS(206),
    [anon_sym_SLASH] = ACTIONS(209),
    [anon_sym_class] = ACTIONS(212),
    [anon_sym_async] = ACTIONS(215),
    [anon_sym_function] = ACTIONS(218),
    [anon_sym_new] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(224),
    [anon_sym_DASH] = ACTIONS(224),
    [anon_sym_BANG] = ACTIONS(227),
    [anon_sym_TILDE] = ACTIONS(227),
    [anon_sym_typeof] = ACTIONS(230),
    [anon_sym_void] = ACTIONS(230),
    [anon_sym_delete] = ACTIONS(230),
    [anon_sym_PLUS_PLUS] = ACTIONS(233),
    [anon_sym_DASH_DASH] = ACTIONS(233),
    [anon_sym_DQUOTE] = ACTIONS(236),
    [anon_sym_SQUOTE] = ACTIONS(239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [sym_number] = ACTIONS(245),
    [sym_this] = ACTIONS(248),
    [sym_super] = ACTIONS(251),
    [sym_true] = ACTIONS(248),
    [sym_false] = ACTIONS(248),
    [sym_null] = ACTIONS(248),
    [sym_undefined] = ACTIONS(248),
    [anon_sym_AT] = ACTIONS(254),
    [anon_sym_static] = ACTIONS(257),
    [anon_sym_get] = ACTIONS(257),
    [anon_sym_set] = ACTIONS(257),
    [sym_preproc] = ACTIONS(260),
  },
  [7] = {
    [sym_export_statement] = STATE(6),
    [sym__declaration] = STATE(6),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_variable_declaration] = STATE(6),
    [sym_lexical_declaration] = STATE(6),
    [sym_statement_block] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_for_in_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_try_statement] = STATE(6),
    [sym_with_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_debugger_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_throw_statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(6),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(6),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(6),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(263),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(265),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(263),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(267),
  },
  [8] = {
    [sym_export_statement] = STATE(7),
    [sym__declaration] = STATE(7),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(7),
    [sym_expression_statement] = STATE(7),
    [sym_variable_declaration] = STATE(7),
    [sym_lexical_declaration] = STATE(7),
    [sym_statement_block] = STATE(7),
    [sym_if_statement] = STATE(7),
    [sym_switch_statement] = STATE(7),
    [sym_for_statement] = STATE(7),
    [sym_for_in_statement] = STATE(7),
    [sym_while_statement] = STATE(7),
    [sym_do_statement] = STATE(7),
    [sym_try_statement] = STATE(7),
    [sym_with_statement] = STATE(7),
    [sym_break_statement] = STATE(7),
    [sym_continue_statement] = STATE(7),
    [sym_debugger_statement] = STATE(7),
    [sym_return_statement] = STATE(7),
    [sym_throw_statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym_labeled_statement] = STATE(7),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(7),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(7),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(7),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(7),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(271),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(269),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(273),
  },
  [9] = {
    [sym_export_statement] = STATE(6),
    [sym__declaration] = STATE(6),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_variable_declaration] = STATE(6),
    [sym_lexical_declaration] = STATE(6),
    [sym_statement_block] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_for_in_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_try_statement] = STATE(6),
    [sym_with_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_debugger_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_throw_statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(6),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(6),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(6),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(275),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(277),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(275),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(267),
  },
  [10] = {
    [sym_export_statement] = STATE(9),
    [sym__declaration] = STATE(9),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(9),
    [sym_expression_statement] = STATE(9),
    [sym_variable_declaration] = STATE(9),
    [sym_lexical_declaration] = STATE(9),
    [sym_statement_block] = STATE(9),
    [sym_if_statement] = STATE(9),
    [sym_switch_statement] = STATE(9),
    [sym_for_statement] = STATE(9),
    [sym_for_in_statement] = STATE(9),
    [sym_while_statement] = STATE(9),
    [sym_do_statement] = STATE(9),
    [sym_try_statement] = STATE(9),
    [sym_with_statement] = STATE(9),
    [sym_break_statement] = STATE(9),
    [sym_continue_statement] = STATE(9),
    [sym_debugger_statement] = STATE(9),
    [sym_return_statement] = STATE(9),
    [sym_throw_statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym_labeled_statement] = STATE(9),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(9),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(9),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(9),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(9),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_default] = ACTIONS(279),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(281),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_case] = ACTIONS(279),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(283),
  },
  [11] = {
    [sym_export_statement] = STATE(6),
    [sym__declaration] = STATE(6),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_variable_declaration] = STATE(6),
    [sym_lexical_declaration] = STATE(6),
    [sym_statement_block] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_for_in_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_try_statement] = STATE(6),
    [sym_with_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_debugger_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_throw_statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(6),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(6),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(6),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(285),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(267),
  },
  [12] = {
    [sym_export_statement] = STATE(6),
    [sym__declaration] = STATE(6),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_variable_declaration] = STATE(6),
    [sym_lexical_declaration] = STATE(6),
    [sym_statement_block] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_for_in_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_try_statement] = STATE(6),
    [sym_with_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_debugger_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_throw_statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(6),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(6),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(6),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(287),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(267),
  },
  [13] = {
    [sym_export_statement] = STATE(23),
    [sym__declaration] = STATE(23),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(23),
    [sym_expression_statement] = STATE(23),
    [sym_variable_declaration] = STATE(23),
    [sym_lexical_declaration] = STATE(23),
    [sym_statement_block] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_switch_statement] = STATE(23),
    [sym_for_statement] = STATE(23),
    [sym_for_in_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_do_statement] = STATE(23),
    [sym_try_statement] = STATE(23),
    [sym_with_statement] = STATE(23),
    [sym_break_statement] = STATE(23),
    [sym_continue_statement] = STATE(23),
    [sym_debugger_statement] = STATE(23),
    [sym_return_statement] = STATE(23),
    [sym_throw_statement] = STATE(23),
    [sym_empty_statement] = STATE(23),
    [sym_labeled_statement] = STATE(23),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(23),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(23),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(23),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(23),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [ts_builtin_sym_end] = ACTIONS(289),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(291),
  },
  [14] = {
    [sym_export_statement] = STATE(6),
    [sym__declaration] = STATE(6),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_variable_declaration] = STATE(6),
    [sym_lexical_declaration] = STATE(6),
    [sym_statement_block] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_for_in_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_try_statement] = STATE(6),
    [sym_with_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_debugger_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_throw_statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(6),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(6),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(6),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(293),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(267),
  },
  [15] = {
    [sym_export_statement] = STATE(19),
    [sym__declaration] = STATE(19),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(19),
    [sym_expression_statement] = STATE(19),
    [sym_variable_declaration] = STATE(19),
    [sym_lexical_declaration] = STATE(19),
    [sym_statement_block] = STATE(19),
    [sym_if_statement] = STATE(19),
    [sym_switch_statement] = STATE(19),
    [sym_for_statement] = STATE(19),
    [sym_for_in_statement] = STATE(19),
    [sym_while_statement] = STATE(19),
    [sym_do_statement] = STATE(19),
    [sym_try_statement] = STATE(19),
    [sym_with_statement] = STATE(19),
    [sym_break_statement] = STATE(19),
    [sym_continue_statement] = STATE(19),
    [sym_debugger_statement] = STATE(19),
    [sym_return_statement] = STATE(19),
    [sym_throw_statement] = STATE(19),
    [sym_empty_statement] = STATE(19),
    [sym_labeled_statement] = STATE(19),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(19),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(19),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(19),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(19),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(295),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(129),
  },
  [16] = {
    [sym_export_statement] = STATE(11),
    [sym__declaration] = STATE(11),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(11),
    [sym_expression_statement] = STATE(11),
    [sym_variable_declaration] = STATE(11),
    [sym_lexical_declaration] = STATE(11),
    [sym_statement_block] = STATE(11),
    [sym_if_statement] = STATE(11),
    [sym_switch_statement] = STATE(11),
    [sym_for_statement] = STATE(11),
    [sym_for_in_statement] = STATE(11),
    [sym_while_statement] = STATE(11),
    [sym_do_statement] = STATE(11),
    [sym_try_statement] = STATE(11),
    [sym_with_statement] = STATE(11),
    [sym_break_statement] = STATE(11),
    [sym_continue_statement] = STATE(11),
    [sym_debugger_statement] = STATE(11),
    [sym_return_statement] = STATE(11),
    [sym_throw_statement] = STATE(11),
    [sym_empty_statement] = STATE(11),
    [sym_labeled_statement] = STATE(11),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(11),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(11),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(11),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(11),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(297),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(299),
  },
  [17] = {
    [sym_export_statement] = STATE(6),
    [sym__declaration] = STATE(6),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_variable_declaration] = STATE(6),
    [sym_lexical_declaration] = STATE(6),
    [sym_statement_block] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_for_in_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_try_statement] = STATE(6),
    [sym_with_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_debugger_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_throw_statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(6),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(6),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(6),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(301),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(267),
  },
  [18] = {
    [sym_export_statement] = STATE(17),
    [sym__declaration] = STATE(17),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(17),
    [sym_expression_statement] = STATE(17),
    [sym_variable_declaration] = STATE(17),
    [sym_lexical_declaration] = STATE(17),
    [sym_statement_block] = STATE(17),
    [sym_if_statement] = STATE(17),
    [sym_switch_statement] = STATE(17),
    [sym_for_statement] = STATE(17),
    [sym_for_in_statement] = STATE(17),
    [sym_while_statement] = STATE(17),
    [sym_do_statement] = STATE(17),
    [sym_try_statement] = STATE(17),
    [sym_with_statement] = STATE(17),
    [sym_break_statement] = STATE(17),
    [sym_continue_statement] = STATE(17),
    [sym_debugger_statement] = STATE(17),
    [sym_return_statement] = STATE(17),
    [sym_throw_statement] = STATE(17),
    [sym_empty_statement] = STATE(17),
    [sym_labeled_statement] = STATE(17),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(17),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(17),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(17),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(17),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(303),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(305),
  },
  [19] = {
    [sym_export_statement] = STATE(6),
    [sym__declaration] = STATE(6),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_variable_declaration] = STATE(6),
    [sym_lexical_declaration] = STATE(6),
    [sym_statement_block] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_for_in_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_try_statement] = STATE(6),
    [sym_with_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_debugger_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_throw_statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(6),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(6),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(6),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(307),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(267),
  },
  [20] = {
    [sym_export_statement] = STATE(12),
    [sym__declaration] = STATE(12),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(12),
    [sym_expression_statement] = STATE(12),
    [sym_variable_declaration] = STATE(12),
    [sym_lexical_declaration] = STATE(12),
    [sym_statement_block] = STATE(12),
    [sym_if_statement] = STATE(12),
    [sym_switch_statement] = STATE(12),
    [sym_for_statement] = STATE(12),
    [sym_for_in_statement] = STATE(12),
    [sym_while_statement] = STATE(12),
    [sym_do_statement] = STATE(12),
    [sym_try_statement] = STATE(12),
    [sym_with_statement] = STATE(12),
    [sym_break_statement] = STATE(12),
    [sym_continue_statement] = STATE(12),
    [sym_debugger_statement] = STATE(12),
    [sym_return_statement] = STATE(12),
    [sym_throw_statement] = STATE(12),
    [sym_empty_statement] = STATE(12),
    [sym_labeled_statement] = STATE(12),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(12),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(12),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(12),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(12),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(309),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(113),
  },
  [21] = {
    [sym_export_statement] = STATE(14),
    [sym__declaration] = STATE(14),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(14),
    [sym_expression_statement] = STATE(14),
    [sym_variable_declaration] = STATE(14),
    [sym_lexical_declaration] = STATE(14),
    [sym_statement_block] = STATE(14),
    [sym_if_statement] = STATE(14),
    [sym_switch_statement] = STATE(14),
    [sym_for_statement] = STATE(14),
    [sym_for_in_statement] = STATE(14),
    [sym_while_statement] = STATE(14),
    [sym_do_statement] = STATE(14),
    [sym_try_statement] = STATE(14),
    [sym_with_statement] = STATE(14),
    [sym_break_statement] = STATE(14),
    [sym_continue_statement] = STATE(14),
    [sym_debugger_statement] = STATE(14),
    [sym_return_statement] = STATE(14),
    [sym_throw_statement] = STATE(14),
    [sym_empty_statement] = STATE(14),
    [sym_labeled_statement] = STATE(14),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(14),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(14),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(14),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(14),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_RBRACE] = ACTIONS(297),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(117),
  },
  [22] = {
    [sym_export_statement] = STATE(6),
    [sym__declaration] = STATE(6),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_variable_declaration] = STATE(6),
    [sym_lexical_declaration] = STATE(6),
    [sym_statement_block] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_for_in_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_try_statement] = STATE(6),
    [sym_with_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_debugger_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_throw_statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(6),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(6),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(6),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [ts_builtin_sym_end] = ACTIONS(289),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(267),
  },
  [23] = {
    [sym_export_statement] = STATE(6),
    [sym__declaration] = STATE(6),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(6),
    [sym_expression_statement] = STATE(6),
    [sym_variable_declaration] = STATE(6),
    [sym_lexical_declaration] = STATE(6),
    [sym_statement_block] = STATE(6),
    [sym_if_statement] = STATE(6),
    [sym_switch_statement] = STATE(6),
    [sym_for_statement] = STATE(6),
    [sym_for_in_statement] = STATE(6),
    [sym_while_statement] = STATE(6),
    [sym_do_statement] = STATE(6),
    [sym_try_statement] = STATE(6),
    [sym_with_statement] = STATE(6),
    [sym_break_statement] = STATE(6),
    [sym_continue_statement] = STATE(6),
    [sym_debugger_statement] = STATE(6),
    [sym_return_statement] = STATE(6),
    [sym_throw_statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym_labeled_statement] = STATE(6),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(6),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(6),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(6),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_program_repeat1] = STATE(6),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [ts_builtin_sym_end] = ACTIONS(311),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(267),
  },
  [24] = {
    [sym_export_statement] = STATE(1001),
    [sym__declaration] = STATE(1001),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(1001),
    [sym_expression_statement] = STATE(1001),
    [sym_variable_declaration] = STATE(1001),
    [sym_lexical_declaration] = STATE(1001),
    [sym_statement_block] = STATE(1001),
    [sym_if_statement] = STATE(1001),
    [sym_switch_statement] = STATE(1001),
    [sym_for_statement] = STATE(1001),
    [sym_for_in_statement] = STATE(1001),
    [sym_while_statement] = STATE(1001),
    [sym_do_statement] = STATE(1001),
    [sym_try_statement] = STATE(1001),
    [sym_with_statement] = STATE(1001),
    [sym_break_statement] = STATE(1001),
    [sym_continue_statement] = STATE(1001),
    [sym_debugger_statement] = STATE(1001),
    [sym_return_statement] = STATE(1001),
    [sym_throw_statement] = STATE(1001),
    [sym_empty_statement] = STATE(1001),
    [sym_labeled_statement] = STATE(1001),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(1001),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(1001),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(1001),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(726),
    [sym_identifier] = ACTIONS(313),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(321),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(325),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(327),
    [anon_sym_async] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(333),
    [anon_sym_get] = ACTIONS(333),
    [anon_sym_set] = ACTIONS(333),
    [sym_preproc] = ACTIONS(335),
  },
  [25] = {
    [sym_export_statement] = STATE(213),
    [sym__declaration] = STATE(213),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(213),
    [sym_expression_statement] = STATE(213),
    [sym_variable_declaration] = STATE(213),
    [sym_lexical_declaration] = STATE(213),
    [sym_statement_block] = STATE(213),
    [sym_if_statement] = STATE(213),
    [sym_switch_statement] = STATE(213),
    [sym_for_statement] = STATE(213),
    [sym_for_in_statement] = STATE(213),
    [sym_while_statement] = STATE(213),
    [sym_do_statement] = STATE(213),
    [sym_try_statement] = STATE(213),
    [sym_with_statement] = STATE(213),
    [sym_break_statement] = STATE(213),
    [sym_continue_statement] = STATE(213),
    [sym_debugger_statement] = STATE(213),
    [sym_return_statement] = STATE(213),
    [sym_throw_statement] = STATE(213),
    [sym_empty_statement] = STATE(213),
    [sym_labeled_statement] = STATE(213),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(213),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(213),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(213),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(726),
    [sym_identifier] = ACTIONS(313),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(321),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(325),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(327),
    [anon_sym_async] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(333),
    [anon_sym_get] = ACTIONS(333),
    [anon_sym_set] = ACTIONS(333),
    [sym_preproc] = ACTIONS(337),
  },
  [26] = {
    [sym_export_statement] = STATE(212),
    [sym__declaration] = STATE(212),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(212),
    [sym_expression_statement] = STATE(212),
    [sym_variable_declaration] = STATE(212),
    [sym_lexical_declaration] = STATE(212),
    [sym_statement_block] = STATE(212),
    [sym_if_statement] = STATE(212),
    [sym_switch_statement] = STATE(212),
    [sym_for_statement] = STATE(212),
    [sym_for_in_statement] = STATE(212),
    [sym_while_statement] = STATE(212),
    [sym_do_statement] = STATE(212),
    [sym_try_statement] = STATE(212),
    [sym_with_statement] = STATE(212),
    [sym_break_statement] = STATE(212),
    [sym_continue_statement] = STATE(212),
    [sym_debugger_statement] = STATE(212),
    [sym_return_statement] = STATE(212),
    [sym_throw_statement] = STATE(212),
    [sym_empty_statement] = STATE(212),
    [sym_labeled_statement] = STATE(212),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(212),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(212),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(212),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(339),
  },
  [27] = {
    [sym_export_statement] = STATE(238),
    [sym__declaration] = STATE(238),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(238),
    [sym_expression_statement] = STATE(238),
    [sym_variable_declaration] = STATE(238),
    [sym_lexical_declaration] = STATE(238),
    [sym_statement_block] = STATE(238),
    [sym_if_statement] = STATE(238),
    [sym_switch_statement] = STATE(238),
    [sym_for_statement] = STATE(238),
    [sym_for_in_statement] = STATE(238),
    [sym_while_statement] = STATE(238),
    [sym_do_statement] = STATE(238),
    [sym_try_statement] = STATE(238),
    [sym_with_statement] = STATE(238),
    [sym_break_statement] = STATE(238),
    [sym_continue_statement] = STATE(238),
    [sym_debugger_statement] = STATE(238),
    [sym_return_statement] = STATE(238),
    [sym_throw_statement] = STATE(238),
    [sym_empty_statement] = STATE(238),
    [sym_labeled_statement] = STATE(238),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(238),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(238),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(238),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(341),
  },
  [28] = {
    [sym_export_statement] = STATE(226),
    [sym__declaration] = STATE(226),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(226),
    [sym_expression_statement] = STATE(226),
    [sym_variable_declaration] = STATE(226),
    [sym_lexical_declaration] = STATE(226),
    [sym_statement_block] = STATE(226),
    [sym_if_statement] = STATE(226),
    [sym_switch_statement] = STATE(226),
    [sym_for_statement] = STATE(226),
    [sym_for_in_statement] = STATE(226),
    [sym_while_statement] = STATE(226),
    [sym_do_statement] = STATE(226),
    [sym_try_statement] = STATE(226),
    [sym_with_statement] = STATE(226),
    [sym_break_statement] = STATE(226),
    [sym_continue_statement] = STATE(226),
    [sym_debugger_statement] = STATE(226),
    [sym_return_statement] = STATE(226),
    [sym_throw_statement] = STATE(226),
    [sym_empty_statement] = STATE(226),
    [sym_labeled_statement] = STATE(226),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(226),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(226),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(226),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(343),
  },
  [29] = {
    [sym_export_statement] = STATE(213),
    [sym__declaration] = STATE(213),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(213),
    [sym_expression_statement] = STATE(213),
    [sym_variable_declaration] = STATE(213),
    [sym_lexical_declaration] = STATE(213),
    [sym_statement_block] = STATE(213),
    [sym_if_statement] = STATE(213),
    [sym_switch_statement] = STATE(213),
    [sym_for_statement] = STATE(213),
    [sym_for_in_statement] = STATE(213),
    [sym_while_statement] = STATE(213),
    [sym_do_statement] = STATE(213),
    [sym_try_statement] = STATE(213),
    [sym_with_statement] = STATE(213),
    [sym_break_statement] = STATE(213),
    [sym_continue_statement] = STATE(213),
    [sym_debugger_statement] = STATE(213),
    [sym_return_statement] = STATE(213),
    [sym_throw_statement] = STATE(213),
    [sym_empty_statement] = STATE(213),
    [sym_labeled_statement] = STATE(213),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(213),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(213),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(213),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(337),
  },
  [30] = {
    [sym_export_statement] = STATE(1102),
    [sym__declaration] = STATE(1102),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(1102),
    [sym_expression_statement] = STATE(1102),
    [sym_variable_declaration] = STATE(1102),
    [sym_lexical_declaration] = STATE(1102),
    [sym_statement_block] = STATE(1102),
    [sym_if_statement] = STATE(1102),
    [sym_switch_statement] = STATE(1102),
    [sym_for_statement] = STATE(1102),
    [sym_for_in_statement] = STATE(1102),
    [sym_while_statement] = STATE(1102),
    [sym_do_statement] = STATE(1102),
    [sym_try_statement] = STATE(1102),
    [sym_with_statement] = STATE(1102),
    [sym_break_statement] = STATE(1102),
    [sym_continue_statement] = STATE(1102),
    [sym_debugger_statement] = STATE(1102),
    [sym_return_statement] = STATE(1102),
    [sym_throw_statement] = STATE(1102),
    [sym_empty_statement] = STATE(1102),
    [sym_labeled_statement] = STATE(1102),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(1102),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(1102),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(1102),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(726),
    [sym_identifier] = ACTIONS(313),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(321),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(325),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(327),
    [anon_sym_async] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(333),
    [anon_sym_get] = ACTIONS(333),
    [anon_sym_set] = ACTIONS(333),
    [sym_preproc] = ACTIONS(345),
  },
  [31] = {
    [sym_export_statement] = STATE(231),
    [sym__declaration] = STATE(231),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(231),
    [sym_expression_statement] = STATE(231),
    [sym_variable_declaration] = STATE(231),
    [sym_lexical_declaration] = STATE(231),
    [sym_statement_block] = STATE(231),
    [sym_if_statement] = STATE(231),
    [sym_switch_statement] = STATE(231),
    [sym_for_statement] = STATE(231),
    [sym_for_in_statement] = STATE(231),
    [sym_while_statement] = STATE(231),
    [sym_do_statement] = STATE(231),
    [sym_try_statement] = STATE(231),
    [sym_with_statement] = STATE(231),
    [sym_break_statement] = STATE(231),
    [sym_continue_statement] = STATE(231),
    [sym_debugger_statement] = STATE(231),
    [sym_return_statement] = STATE(231),
    [sym_throw_statement] = STATE(231),
    [sym_empty_statement] = STATE(231),
    [sym_labeled_statement] = STATE(231),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(231),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(231),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(231),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(347),
  },
  [32] = {
    [sym_export_statement] = STATE(242),
    [sym__declaration] = STATE(242),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(242),
    [sym_expression_statement] = STATE(242),
    [sym_variable_declaration] = STATE(242),
    [sym_lexical_declaration] = STATE(242),
    [sym_statement_block] = STATE(242),
    [sym_if_statement] = STATE(242),
    [sym_switch_statement] = STATE(242),
    [sym_for_statement] = STATE(242),
    [sym_for_in_statement] = STATE(242),
    [sym_while_statement] = STATE(242),
    [sym_do_statement] = STATE(242),
    [sym_try_statement] = STATE(242),
    [sym_with_statement] = STATE(242),
    [sym_break_statement] = STATE(242),
    [sym_continue_statement] = STATE(242),
    [sym_debugger_statement] = STATE(242),
    [sym_return_statement] = STATE(242),
    [sym_throw_statement] = STATE(242),
    [sym_empty_statement] = STATE(242),
    [sym_labeled_statement] = STATE(242),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(242),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(242),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(242),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(726),
    [sym_identifier] = ACTIONS(313),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(321),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(325),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(327),
    [anon_sym_async] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(333),
    [anon_sym_get] = ACTIONS(333),
    [anon_sym_set] = ACTIONS(333),
    [sym_preproc] = ACTIONS(349),
  },
  [33] = {
    [sym_export_statement] = STATE(212),
    [sym__declaration] = STATE(212),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(212),
    [sym_expression_statement] = STATE(212),
    [sym_variable_declaration] = STATE(212),
    [sym_lexical_declaration] = STATE(212),
    [sym_statement_block] = STATE(212),
    [sym_if_statement] = STATE(212),
    [sym_switch_statement] = STATE(212),
    [sym_for_statement] = STATE(212),
    [sym_for_in_statement] = STATE(212),
    [sym_while_statement] = STATE(212),
    [sym_do_statement] = STATE(212),
    [sym_try_statement] = STATE(212),
    [sym_with_statement] = STATE(212),
    [sym_break_statement] = STATE(212),
    [sym_continue_statement] = STATE(212),
    [sym_debugger_statement] = STATE(212),
    [sym_return_statement] = STATE(212),
    [sym_throw_statement] = STATE(212),
    [sym_empty_statement] = STATE(212),
    [sym_labeled_statement] = STATE(212),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(212),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(212),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(212),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(726),
    [sym_identifier] = ACTIONS(313),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(321),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(325),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(327),
    [anon_sym_async] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(333),
    [anon_sym_get] = ACTIONS(333),
    [anon_sym_set] = ACTIONS(333),
    [sym_preproc] = ACTIONS(339),
  },
  [34] = {
    [sym_export_statement] = STATE(242),
    [sym__declaration] = STATE(242),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(242),
    [sym_expression_statement] = STATE(242),
    [sym_variable_declaration] = STATE(242),
    [sym_lexical_declaration] = STATE(242),
    [sym_statement_block] = STATE(242),
    [sym_if_statement] = STATE(242),
    [sym_switch_statement] = STATE(242),
    [sym_for_statement] = STATE(242),
    [sym_for_in_statement] = STATE(242),
    [sym_while_statement] = STATE(242),
    [sym_do_statement] = STATE(242),
    [sym_try_statement] = STATE(242),
    [sym_with_statement] = STATE(242),
    [sym_break_statement] = STATE(242),
    [sym_continue_statement] = STATE(242),
    [sym_debugger_statement] = STATE(242),
    [sym_return_statement] = STATE(242),
    [sym_throw_statement] = STATE(242),
    [sym_empty_statement] = STATE(242),
    [sym_labeled_statement] = STATE(242),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(242),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(242),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(242),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(349),
  },
  [35] = {
    [sym_export_statement] = STATE(231),
    [sym__declaration] = STATE(231),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(231),
    [sym_expression_statement] = STATE(231),
    [sym_variable_declaration] = STATE(231),
    [sym_lexical_declaration] = STATE(231),
    [sym_statement_block] = STATE(231),
    [sym_if_statement] = STATE(231),
    [sym_switch_statement] = STATE(231),
    [sym_for_statement] = STATE(231),
    [sym_for_in_statement] = STATE(231),
    [sym_while_statement] = STATE(231),
    [sym_do_statement] = STATE(231),
    [sym_try_statement] = STATE(231),
    [sym_with_statement] = STATE(231),
    [sym_break_statement] = STATE(231),
    [sym_continue_statement] = STATE(231),
    [sym_debugger_statement] = STATE(231),
    [sym_return_statement] = STATE(231),
    [sym_throw_statement] = STATE(231),
    [sym_empty_statement] = STATE(231),
    [sym_labeled_statement] = STATE(231),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(231),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(231),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(231),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(726),
    [sym_identifier] = ACTIONS(313),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(321),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(325),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(327),
    [anon_sym_async] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(333),
    [anon_sym_get] = ACTIONS(333),
    [anon_sym_set] = ACTIONS(333),
    [sym_preproc] = ACTIONS(347),
  },
  [36] = {
    [sym_export_statement] = STATE(253),
    [sym__declaration] = STATE(253),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(253),
    [sym_expression_statement] = STATE(253),
    [sym_variable_declaration] = STATE(253),
    [sym_lexical_declaration] = STATE(253),
    [sym_statement_block] = STATE(253),
    [sym_if_statement] = STATE(253),
    [sym_switch_statement] = STATE(253),
    [sym_for_statement] = STATE(253),
    [sym_for_in_statement] = STATE(253),
    [sym_while_statement] = STATE(253),
    [sym_do_statement] = STATE(253),
    [sym_try_statement] = STATE(253),
    [sym_with_statement] = STATE(253),
    [sym_break_statement] = STATE(253),
    [sym_continue_statement] = STATE(253),
    [sym_debugger_statement] = STATE(253),
    [sym_return_statement] = STATE(253),
    [sym_throw_statement] = STATE(253),
    [sym_empty_statement] = STATE(253),
    [sym_labeled_statement] = STATE(253),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(253),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(253),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(253),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(351),
  },
  [37] = {
    [sym_export_statement] = STATE(246),
    [sym__declaration] = STATE(246),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(246),
    [sym_expression_statement] = STATE(246),
    [sym_variable_declaration] = STATE(246),
    [sym_lexical_declaration] = STATE(246),
    [sym_statement_block] = STATE(246),
    [sym_if_statement] = STATE(246),
    [sym_switch_statement] = STATE(246),
    [sym_for_statement] = STATE(246),
    [sym_for_in_statement] = STATE(246),
    [sym_while_statement] = STATE(246),
    [sym_do_statement] = STATE(246),
    [sym_try_statement] = STATE(246),
    [sym_with_statement] = STATE(246),
    [sym_break_statement] = STATE(246),
    [sym_continue_statement] = STATE(246),
    [sym_debugger_statement] = STATE(246),
    [sym_return_statement] = STATE(246),
    [sym_throw_statement] = STATE(246),
    [sym_empty_statement] = STATE(246),
    [sym_labeled_statement] = STATE(246),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(246),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(246),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(246),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(353),
  },
  [38] = {
    [sym_export_statement] = STATE(226),
    [sym__declaration] = STATE(226),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(226),
    [sym_expression_statement] = STATE(226),
    [sym_variable_declaration] = STATE(226),
    [sym_lexical_declaration] = STATE(226),
    [sym_statement_block] = STATE(226),
    [sym_if_statement] = STATE(226),
    [sym_switch_statement] = STATE(226),
    [sym_for_statement] = STATE(226),
    [sym_for_in_statement] = STATE(226),
    [sym_while_statement] = STATE(226),
    [sym_do_statement] = STATE(226),
    [sym_try_statement] = STATE(226),
    [sym_with_statement] = STATE(226),
    [sym_break_statement] = STATE(226),
    [sym_continue_statement] = STATE(226),
    [sym_debugger_statement] = STATE(226),
    [sym_return_statement] = STATE(226),
    [sym_throw_statement] = STATE(226),
    [sym_empty_statement] = STATE(226),
    [sym_labeled_statement] = STATE(226),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(226),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(226),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(226),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(726),
    [sym_identifier] = ACTIONS(313),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(321),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(325),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(327),
    [anon_sym_async] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(333),
    [anon_sym_get] = ACTIONS(333),
    [anon_sym_set] = ACTIONS(333),
    [sym_preproc] = ACTIONS(343),
  },
  [39] = {
    [sym_export_statement] = STATE(248),
    [sym__declaration] = STATE(248),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(248),
    [sym_expression_statement] = STATE(248),
    [sym_variable_declaration] = STATE(248),
    [sym_lexical_declaration] = STATE(248),
    [sym_statement_block] = STATE(248),
    [sym_if_statement] = STATE(248),
    [sym_switch_statement] = STATE(248),
    [sym_for_statement] = STATE(248),
    [sym_for_in_statement] = STATE(248),
    [sym_while_statement] = STATE(248),
    [sym_do_statement] = STATE(248),
    [sym_try_statement] = STATE(248),
    [sym_with_statement] = STATE(248),
    [sym_break_statement] = STATE(248),
    [sym_continue_statement] = STATE(248),
    [sym_debugger_statement] = STATE(248),
    [sym_return_statement] = STATE(248),
    [sym_throw_statement] = STATE(248),
    [sym_empty_statement] = STATE(248),
    [sym_labeled_statement] = STATE(248),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(248),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(248),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(248),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(747),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_LBRACE] = ACTIONS(13),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(21),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(31),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(37),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(59),
    [anon_sym_async] = ACTIONS(61),
    [anon_sym_function] = ACTIONS(63),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(89),
    [anon_sym_get] = ACTIONS(89),
    [anon_sym_set] = ACTIONS(89),
    [sym_preproc] = ACTIONS(355),
  },
  [40] = {
    [sym_export_statement] = STATE(238),
    [sym__declaration] = STATE(238),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(238),
    [sym_expression_statement] = STATE(238),
    [sym_variable_declaration] = STATE(238),
    [sym_lexical_declaration] = STATE(238),
    [sym_statement_block] = STATE(238),
    [sym_if_statement] = STATE(238),
    [sym_switch_statement] = STATE(238),
    [sym_for_statement] = STATE(238),
    [sym_for_in_statement] = STATE(238),
    [sym_while_statement] = STATE(238),
    [sym_do_statement] = STATE(238),
    [sym_try_statement] = STATE(238),
    [sym_with_statement] = STATE(238),
    [sym_break_statement] = STATE(238),
    [sym_continue_statement] = STATE(238),
    [sym_debugger_statement] = STATE(238),
    [sym_return_statement] = STATE(238),
    [sym_throw_statement] = STATE(238),
    [sym_empty_statement] = STATE(238),
    [sym_labeled_statement] = STATE(238),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(238),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(238),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(238),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(726),
    [sym_identifier] = ACTIONS(313),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(321),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(325),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(327),
    [anon_sym_async] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(333),
    [anon_sym_get] = ACTIONS(333),
    [anon_sym_set] = ACTIONS(333),
    [sym_preproc] = ACTIONS(341),
  },
  [41] = {
    [sym_export_statement] = STATE(246),
    [sym__declaration] = STATE(246),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(246),
    [sym_expression_statement] = STATE(246),
    [sym_variable_declaration] = STATE(246),
    [sym_lexical_declaration] = STATE(246),
    [sym_statement_block] = STATE(246),
    [sym_if_statement] = STATE(246),
    [sym_switch_statement] = STATE(246),
    [sym_for_statement] = STATE(246),
    [sym_for_in_statement] = STATE(246),
    [sym_while_statement] = STATE(246),
    [sym_do_statement] = STATE(246),
    [sym_try_statement] = STATE(246),
    [sym_with_statement] = STATE(246),
    [sym_break_statement] = STATE(246),
    [sym_continue_statement] = STATE(246),
    [sym_debugger_statement] = STATE(246),
    [sym_return_statement] = STATE(246),
    [sym_throw_statement] = STATE(246),
    [sym_empty_statement] = STATE(246),
    [sym_labeled_statement] = STATE(246),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(246),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(246),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(246),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(726),
    [sym_identifier] = ACTIONS(313),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(321),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(325),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(327),
    [anon_sym_async] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(333),
    [anon_sym_get] = ACTIONS(333),
    [anon_sym_set] = ACTIONS(333),
    [sym_preproc] = ACTIONS(353),
  },
  [42] = {
    [sym_export_statement] = STATE(248),
    [sym__declaration] = STATE(248),
    [sym_import] = STATE(481),
    [sym_import_statement] = STATE(248),
    [sym_expression_statement] = STATE(248),
    [sym_variable_declaration] = STATE(248),
    [sym_lexical_declaration] = STATE(248),
    [sym_statement_block] = STATE(248),
    [sym_if_statement] = STATE(248),
    [sym_switch_statement] = STATE(248),
    [sym_for_statement] = STATE(248),
    [sym_for_in_statement] = STATE(248),
    [sym_while_statement] = STATE(248),
    [sym_do_statement] = STATE(248),
    [sym_try_statement] = STATE(248),
    [sym_with_statement] = STATE(248),
    [sym_break_statement] = STATE(248),
    [sym_continue_statement] = STATE(248),
    [sym_debugger_statement] = STATE(248),
    [sym_return_statement] = STATE(248),
    [sym_throw_statement] = STATE(248),
    [sym_empty_statement] = STATE(248),
    [sym_labeled_statement] = STATE(248),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_class_declaration] = STATE(248),
    [sym_function] = STATE(403),
    [sym_function_declaration] = STATE(248),
    [sym_generator_function] = STATE(481),
    [sym_generator_function_declaration] = STATE(248),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(726),
    [sym_identifier] = ACTIONS(313),
    [anon_sym_export] = ACTIONS(315),
    [anon_sym_LBRACE] = ACTIONS(317),
    [anon_sym_import] = ACTIONS(15),
    [anon_sym_var] = ACTIONS(17),
    [anon_sym_let] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(19),
    [anon_sym_if] = ACTIONS(319),
    [anon_sym_switch] = ACTIONS(23),
    [anon_sym_for] = ACTIONS(321),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_while] = ACTIONS(323),
    [anon_sym_do] = ACTIONS(33),
    [anon_sym_try] = ACTIONS(35),
    [anon_sym_with] = ACTIONS(325),
    [anon_sym_break] = ACTIONS(39),
    [anon_sym_continue] = ACTIONS(41),
    [anon_sym_debugger] = ACTIONS(43),
    [anon_sym_return] = ACTIONS(45),
    [anon_sym_throw] = ACTIONS(47),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(327),
    [anon_sym_async] = ACTIONS(329),
    [anon_sym_function] = ACTIONS(331),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(333),
    [anon_sym_get] = ACTIONS(333),
    [anon_sym_set] = ACTIONS(333),
    [sym_preproc] = ACTIONS(355),
  },
  [43] = {
    [sym_import] = STATE(322),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(322),
    [sym_yield_expression] = STATE(322),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(322),
    [sym_jsx_fragment] = STATE(322),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(322),
    [sym_class] = STATE(322),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(322),
    [sym_arrow_function] = STATE(322),
    [sym_call_expression] = STATE(322),
    [sym_new_expression] = STATE(322),
    [sym_await_expression] = STATE(322),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(322),
    [sym_augmented_assignment_expression] = STATE(322),
    [sym_ternary_expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_unary_expression] = STATE(322),
    [sym_update_expression] = STATE(322),
    [sym_string] = STATE(322),
    [sym_template_string] = STATE(322),
    [sym_regex] = STATE(322),
    [sym_meta_property] = STATE(322),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_STAR] = ACTIONS(359),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_in] = ACTIONS(371),
    [anon_sym_COLON] = ACTIONS(363),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_RBRACK] = ACTIONS(363),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(371),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_GT_GT_GT] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(363),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_QMARK_QMARK] = ACTIONS(363),
    [anon_sym_instanceof] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(405),
    [sym_this] = ACTIONS(407),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(407),
    [sym_false] = ACTIONS(407),
    [sym_null] = ACTIONS(407),
    [sym_undefined] = ACTIONS(407),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [44] = {
    [sym_import] = STATE(384),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(384),
    [sym_yield_expression] = STATE(384),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(384),
    [sym_jsx_fragment] = STATE(384),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(384),
    [sym_class] = STATE(384),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(384),
    [sym_arrow_function] = STATE(384),
    [sym_call_expression] = STATE(384),
    [sym_new_expression] = STATE(384),
    [sym_await_expression] = STATE(384),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(384),
    [sym_augmented_assignment_expression] = STATE(384),
    [sym_ternary_expression] = STATE(384),
    [sym_binary_expression] = STATE(384),
    [sym_unary_expression] = STATE(384),
    [sym_update_expression] = STATE(384),
    [sym_string] = STATE(384),
    [sym_template_string] = STATE(384),
    [sym_regex] = STATE(384),
    [sym_meta_property] = STATE(384),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_STAR] = ACTIONS(415),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_in] = ACTIONS(371),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_DOT] = ACTIONS(371),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_QMARK] = ACTIONS(371),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(371),
    [anon_sym_GT_GT_GT] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(371),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_BANG_EQ] = ACTIONS(371),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(363),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_QMARK_QMARK] = ACTIONS(363),
    [anon_sym_instanceof] = ACTIONS(371),
    [anon_sym_BANG] = ACTIONS(429),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(431),
    [sym_this] = ACTIONS(433),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(433),
    [sym_false] = ACTIONS(433),
    [sym_null] = ACTIONS(433),
    [sym_undefined] = ACTIONS(433),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [sym__automatic_semicolon] = ACTIONS(363),
  },
  [45] = {
    [ts_builtin_sym_end] = ACTIONS(437),
    [sym_identifier] = ACTIONS(439),
    [anon_sym_export] = ACTIONS(439),
    [anon_sym_STAR] = ACTIONS(441),
    [anon_sym_default] = ACTIONS(439),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_COMMA] = ACTIONS(443),
    [anon_sym_RBRACE] = ACTIONS(437),
    [anon_sym_import] = ACTIONS(439),
    [anon_sym_var] = ACTIONS(439),
    [anon_sym_let] = ACTIONS(439),
    [anon_sym_const] = ACTIONS(439),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_else] = ACTIONS(439),
    [anon_sym_switch] = ACTIONS(439),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_LPAREN] = ACTIONS(437),
    [anon_sym_await] = ACTIONS(439),
    [anon_sym_in] = ACTIONS(441),
    [anon_sym_while] = ACTIONS(439),
    [anon_sym_do] = ACTIONS(439),
    [anon_sym_try] = ACTIONS(439),
    [anon_sym_with] = ACTIONS(439),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_continue] = ACTIONS(439),
    [anon_sym_debugger] = ACTIONS(439),
    [anon_sym_return] = ACTIONS(439),
    [anon_sym_throw] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(437),
    [anon_sym_case] = ACTIONS(439),
    [anon_sym_yield] = ACTIONS(439),
    [anon_sym_EQ] = ACTIONS(441),
    [anon_sym_LBRACK] = ACTIONS(437),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(441),
    [anon_sym_SLASH] = ACTIONS(439),
    [anon_sym_DOT] = ACTIONS(441),
    [anon_sym_class] = ACTIONS(439),
    [anon_sym_async] = ACTIONS(439),
    [anon_sym_function] = ACTIONS(439),
    [anon_sym_new] = ACTIONS(439),
    [anon_sym_QMARK] = ACTIONS(441),
    [anon_sym_AMP_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(443),
    [anon_sym_GT_GT] = ACTIONS(441),
    [anon_sym_GT_GT_GT] = ACTIONS(443),
    [anon_sym_LT_LT] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(441),
    [anon_sym_CARET] = ACTIONS(443),
    [anon_sym_PIPE] = ACTIONS(441),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_DASH] = ACTIONS(439),
    [anon_sym_PERCENT] = ACTIONS(443),
    [anon_sym_STAR_STAR] = ACTIONS(443),
    [anon_sym_LT_EQ] = ACTIONS(443),
    [anon_sym_EQ_EQ] = ACTIONS(441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(443),
    [anon_sym_BANG_EQ] = ACTIONS(441),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(443),
    [anon_sym_GT_EQ] = ACTIONS(443),
    [anon_sym_QMARK_QMARK] = ACTIONS(443),
    [anon_sym_instanceof] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(439),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_typeof] = ACTIONS(439),
    [anon_sym_void] = ACTIONS(439),
    [anon_sym_delete] = ACTIONS(439),
    [anon_sym_PLUS_PLUS] = ACTIONS(437),
    [anon_sym_DASH_DASH] = ACTIONS(437),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [anon_sym_SQUOTE] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [sym_number] = ACTIONS(437),
    [sym_this] = ACTIONS(439),
    [sym_super] = ACTIONS(439),
    [sym_true] = ACTIONS(439),
    [sym_false] = ACTIONS(439),
    [sym_null] = ACTIONS(439),
    [sym_undefined] = ACTIONS(439),
    [anon_sym_AT] = ACTIONS(437),
    [anon_sym_static] = ACTIONS(439),
    [anon_sym_get] = ACTIONS(439),
    [anon_sym_set] = ACTIONS(439),
    [sym_preproc] = ACTIONS(437),
    [sym__automatic_semicolon] = ACTIONS(445),
  },
  [46] = {
    [ts_builtin_sym_end] = ACTIONS(447),
    [sym_identifier] = ACTIONS(449),
    [anon_sym_export] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(451),
    [anon_sym_default] = ACTIONS(449),
    [anon_sym_LBRACE] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(453),
    [anon_sym_RBRACE] = ACTIONS(447),
    [anon_sym_import] = ACTIONS(449),
    [anon_sym_var] = ACTIONS(449),
    [anon_sym_let] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(449),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_else] = ACTIONS(449),
    [anon_sym_switch] = ACTIONS(449),
    [anon_sym_for] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_await] = ACTIONS(449),
    [anon_sym_in] = ACTIONS(451),
    [anon_sym_while] = ACTIONS(449),
    [anon_sym_do] = ACTIONS(449),
    [anon_sym_try] = ACTIONS(449),
    [anon_sym_with] = ACTIONS(449),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_continue] = ACTIONS(449),
    [anon_sym_debugger] = ACTIONS(449),
    [anon_sym_return] = ACTIONS(449),
    [anon_sym_throw] = ACTIONS(449),
    [anon_sym_SEMI] = ACTIONS(447),
    [anon_sym_case] = ACTIONS(449),
    [anon_sym_yield] = ACTIONS(449),
    [anon_sym_LBRACK] = ACTIONS(447),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(451),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(451),
    [anon_sym_class] = ACTIONS(449),
    [anon_sym_async] = ACTIONS(449),
    [anon_sym_function] = ACTIONS(449),
    [anon_sym_new] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(451),
    [anon_sym_AMP_AMP] = ACTIONS(453),
    [anon_sym_PIPE_PIPE] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(451),
    [anon_sym_GT_GT_GT] = ACTIONS(453),
    [anon_sym_LT_LT] = ACTIONS(453),
    [anon_sym_AMP] = ACTIONS(451),
    [anon_sym_CARET] = ACTIONS(453),
    [anon_sym_PIPE] = ACTIONS(451),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_PERCENT] = ACTIONS(453),
    [anon_sym_STAR_STAR] = ACTIONS(453),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(451),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(451),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_QMARK_QMARK] = ACTIONS(453),
    [anon_sym_instanceof] = ACTIONS(451),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_TILDE] = ACTIONS(447),
    [anon_sym_typeof] = ACTIONS(449),
    [anon_sym_void] = ACTIONS(449),
    [anon_sym_delete] = ACTIONS(449),
    [anon_sym_PLUS_PLUS] = ACTIONS(447),
    [anon_sym_DASH_DASH] = ACTIONS(447),
    [anon_sym_DQUOTE] = ACTIONS(447),
    [anon_sym_SQUOTE] = ACTIONS(447),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(447),
    [sym_number] = ACTIONS(447),
    [sym_this] = ACTIONS(449),
    [sym_super] = ACTIONS(449),
    [sym_true] = ACTIONS(449),
    [sym_false] = ACTIONS(449),
    [sym_null] = ACTIONS(449),
    [sym_undefined] = ACTIONS(449),
    [anon_sym_AT] = ACTIONS(447),
    [anon_sym_static] = ACTIONS(449),
    [anon_sym_get] = ACTIONS(449),
    [anon_sym_set] = ACTIONS(449),
    [sym_preproc] = ACTIONS(447),
    [sym__automatic_semicolon] = ACTIONS(455),
  },
  [47] = {
    [ts_builtin_sym_end] = ACTIONS(457),
    [sym_identifier] = ACTIONS(459),
    [anon_sym_export] = ACTIONS(459),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_default] = ACTIONS(459),
    [anon_sym_LBRACE] = ACTIONS(457),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_RBRACE] = ACTIONS(457),
    [anon_sym_import] = ACTIONS(459),
    [anon_sym_var] = ACTIONS(459),
    [anon_sym_let] = ACTIONS(459),
    [anon_sym_const] = ACTIONS(459),
    [anon_sym_if] = ACTIONS(459),
    [anon_sym_else] = ACTIONS(459),
    [anon_sym_switch] = ACTIONS(459),
    [anon_sym_for] = ACTIONS(459),
    [anon_sym_LPAREN] = ACTIONS(457),
    [anon_sym_await] = ACTIONS(459),
    [anon_sym_in] = ACTIONS(461),
    [anon_sym_while] = ACTIONS(459),
    [anon_sym_do] = ACTIONS(459),
    [anon_sym_try] = ACTIONS(459),
    [anon_sym_with] = ACTIONS(459),
    [anon_sym_break] = ACTIONS(459),
    [anon_sym_continue] = ACTIONS(459),
    [anon_sym_debugger] = ACTIONS(459),
    [anon_sym_return] = ACTIONS(459),
    [anon_sym_throw] = ACTIONS(459),
    [anon_sym_SEMI] = ACTIONS(457),
    [anon_sym_case] = ACTIONS(459),
    [anon_sym_yield] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(459),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_SLASH] = ACTIONS(459),
    [anon_sym_DOT] = ACTIONS(461),
    [anon_sym_class] = ACTIONS(459),
    [anon_sym_async] = ACTIONS(459),
    [anon_sym_function] = ACTIONS(459),
    [anon_sym_new] = ACTIONS(459),
    [anon_sym_QMARK] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_GT_GT_GT] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_PERCENT] = ACTIONS(463),
    [anon_sym_STAR_STAR] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_EQ_EQ] = ACTIONS(461),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(461),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_QMARK_QMARK] = ACTIONS(463),
    [anon_sym_instanceof] = ACTIONS(461),
    [anon_sym_BANG] = ACTIONS(459),
    [anon_sym_TILDE] = ACTIONS(457),
    [anon_sym_typeof] = ACTIONS(459),
    [anon_sym_void] = ACTIONS(459),
    [anon_sym_delete] = ACTIONS(459),
    [anon_sym_PLUS_PLUS] = ACTIONS(457),
    [anon_sym_DASH_DASH] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(457),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(457),
    [sym_number] = ACTIONS(457),
    [sym_this] = ACTIONS(459),
    [sym_super] = ACTIONS(459),
    [sym_true] = ACTIONS(459),
    [sym_false] = ACTIONS(459),
    [sym_null] = ACTIONS(459),
    [sym_undefined] = ACTIONS(459),
    [anon_sym_AT] = ACTIONS(457),
    [anon_sym_static] = ACTIONS(459),
    [anon_sym_get] = ACTIONS(459),
    [anon_sym_set] = ACTIONS(459),
    [sym_preproc] = ACTIONS(457),
    [sym__automatic_semicolon] = ACTIONS(465),
  },
  [48] = {
    [ts_builtin_sym_end] = ACTIONS(467),
    [sym_identifier] = ACTIONS(469),
    [anon_sym_export] = ACTIONS(469),
    [anon_sym_STAR] = ACTIONS(471),
    [anon_sym_default] = ACTIONS(469),
    [anon_sym_LBRACE] = ACTIONS(467),
    [anon_sym_COMMA] = ACTIONS(473),
    [anon_sym_RBRACE] = ACTIONS(467),
    [anon_sym_import] = ACTIONS(469),
    [anon_sym_var] = ACTIONS(469),
    [anon_sym_let] = ACTIONS(469),
    [anon_sym_const] = ACTIONS(469),
    [anon_sym_if] = ACTIONS(469),
    [anon_sym_else] = ACTIONS(469),
    [anon_sym_switch] = ACTIONS(469),
    [anon_sym_for] = ACTIONS(469),
    [anon_sym_LPAREN] = ACTIONS(467),
    [anon_sym_await] = ACTIONS(469),
    [anon_sym_in] = ACTIONS(471),
    [anon_sym_while] = ACTIONS(469),
    [anon_sym_do] = ACTIONS(469),
    [anon_sym_try] = ACTIONS(469),
    [anon_sym_with] = ACTIONS(469),
    [anon_sym_break] = ACTIONS(469),
    [anon_sym_continue] = ACTIONS(469),
    [anon_sym_debugger] = ACTIONS(469),
    [anon_sym_return] = ACTIONS(469),
    [anon_sym_throw] = ACTIONS(469),
    [anon_sym_SEMI] = ACTIONS(467),
    [anon_sym_case] = ACTIONS(469),
    [anon_sym_yield] = ACTIONS(469),
    [anon_sym_LBRACK] = ACTIONS(467),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(471),
    [anon_sym_SLASH] = ACTIONS(469),
    [anon_sym_DOT] = ACTIONS(471),
    [anon_sym_class] = ACTIONS(469),
    [anon_sym_async] = ACTIONS(469),
    [anon_sym_function] = ACTIONS(469),
    [anon_sym_new] = ACTIONS(469),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(473),
    [anon_sym_GT_GT] = ACTIONS(471),
    [anon_sym_GT_GT_GT] = ACTIONS(473),
    [anon_sym_LT_LT] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(471),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_PIPE] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(469),
    [anon_sym_DASH] = ACTIONS(469),
    [anon_sym_PERCENT] = ACTIONS(473),
    [anon_sym_STAR_STAR] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(473),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(473),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(473),
    [anon_sym_QMARK_QMARK] = ACTIONS(473),
    [anon_sym_instanceof] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(469),
    [anon_sym_TILDE] = ACTIONS(467),
    [anon_sym_typeof] = ACTIONS(469),
    [anon_sym_void] = ACTIONS(469),
    [anon_sym_delete] = ACTIONS(469),
    [anon_sym_PLUS_PLUS] = ACTIONS(467),
    [anon_sym_DASH_DASH] = ACTIONS(467),
    [anon_sym_DQUOTE] = ACTIONS(467),
    [anon_sym_SQUOTE] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(467),
    [sym_number] = ACTIONS(467),
    [sym_this] = ACTIONS(469),
    [sym_super] = ACTIONS(469),
    [sym_true] = ACTIONS(469),
    [sym_false] = ACTIONS(469),
    [sym_null] = ACTIONS(469),
    [sym_undefined] = ACTIONS(469),
    [anon_sym_AT] = ACTIONS(467),
    [anon_sym_static] = ACTIONS(469),
    [anon_sym_get] = ACTIONS(469),
    [anon_sym_set] = ACTIONS(469),
    [sym_preproc] = ACTIONS(467),
    [sym__automatic_semicolon] = ACTIONS(475),
  },
  [49] = {
    [ts_builtin_sym_end] = ACTIONS(477),
    [sym_identifier] = ACTIONS(479),
    [anon_sym_export] = ACTIONS(479),
    [anon_sym_STAR] = ACTIONS(481),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_RBRACE] = ACTIONS(477),
    [anon_sym_import] = ACTIONS(479),
    [anon_sym_var] = ACTIONS(479),
    [anon_sym_let] = ACTIONS(479),
    [anon_sym_const] = ACTIONS(479),
    [anon_sym_if] = ACTIONS(479),
    [anon_sym_else] = ACTIONS(479),
    [anon_sym_switch] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(479),
    [anon_sym_LPAREN] = ACTIONS(477),
    [anon_sym_await] = ACTIONS(479),
    [anon_sym_in] = ACTIONS(481),
    [anon_sym_while] = ACTIONS(479),
    [anon_sym_do] = ACTIONS(479),
    [anon_sym_try] = ACTIONS(479),
    [anon_sym_with] = ACTIONS(479),
    [anon_sym_break] = ACTIONS(479),
    [anon_sym_continue] = ACTIONS(479),
    [anon_sym_debugger] = ACTIONS(479),
    [anon_sym_return] = ACTIONS(479),
    [anon_sym_throw] = ACTIONS(479),
    [anon_sym_SEMI] = ACTIONS(477),
    [anon_sym_case] = ACTIONS(479),
    [anon_sym_yield] = ACTIONS(479),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_SLASH] = ACTIONS(479),
    [anon_sym_DOT] = ACTIONS(481),
    [anon_sym_class] = ACTIONS(479),
    [anon_sym_async] = ACTIONS(479),
    [anon_sym_function] = ACTIONS(479),
    [anon_sym_new] = ACTIONS(479),
    [anon_sym_QMARK] = ACTIONS(481),
    [anon_sym_AMP_AMP] = ACTIONS(483),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_GT_GT_GT] = ACTIONS(483),
    [anon_sym_LT_LT] = ACTIONS(483),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_CARET] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_PLUS] = ACTIONS(479),
    [anon_sym_DASH] = ACTIONS(479),
    [anon_sym_PERCENT] = ACTIONS(483),
    [anon_sym_STAR_STAR] = ACTIONS(483),
    [anon_sym_LT_EQ] = ACTIONS(483),
    [anon_sym_EQ_EQ] = ACTIONS(481),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(483),
    [anon_sym_BANG_EQ] = ACTIONS(481),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(483),
    [anon_sym_GT_EQ] = ACTIONS(483),
    [anon_sym_QMARK_QMARK] = ACTIONS(483),
    [anon_sym_instanceof] = ACTIONS(481),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_TILDE] = ACTIONS(477),
    [anon_sym_typeof] = ACTIONS(479),
    [anon_sym_void] = ACTIONS(479),
    [anon_sym_delete] = ACTIONS(479),
    [anon_sym_PLUS_PLUS] = ACTIONS(477),
    [anon_sym_DASH_DASH] = ACTIONS(477),
    [anon_sym_DQUOTE] = ACTIONS(477),
    [anon_sym_SQUOTE] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(477),
    [sym_number] = ACTIONS(477),
    [sym_this] = ACTIONS(479),
    [sym_super] = ACTIONS(479),
    [sym_true] = ACTIONS(479),
    [sym_false] = ACTIONS(479),
    [sym_null] = ACTIONS(479),
    [sym_undefined] = ACTIONS(479),
    [anon_sym_AT] = ACTIONS(477),
    [anon_sym_static] = ACTIONS(479),
    [anon_sym_get] = ACTIONS(479),
    [anon_sym_set] = ACTIONS(479),
    [sym_preproc] = ACTIONS(477),
    [sym__automatic_semicolon] = ACTIONS(485),
  },
  [50] = {
    [ts_builtin_sym_end] = ACTIONS(487),
    [sym_identifier] = ACTIONS(489),
    [anon_sym_export] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(489),
    [anon_sym_default] = ACTIONS(489),
    [anon_sym_LBRACE] = ACTIONS(487),
    [anon_sym_COMMA] = ACTIONS(487),
    [anon_sym_RBRACE] = ACTIONS(487),
    [anon_sym_import] = ACTIONS(489),
    [anon_sym_var] = ACTIONS(489),
    [anon_sym_let] = ACTIONS(489),
    [anon_sym_const] = ACTIONS(489),
    [anon_sym_if] = ACTIONS(489),
    [anon_sym_else] = ACTIONS(489),
    [anon_sym_switch] = ACTIONS(489),
    [anon_sym_for] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(487),
    [anon_sym_await] = ACTIONS(489),
    [anon_sym_in] = ACTIONS(489),
    [anon_sym_while] = ACTIONS(489),
    [anon_sym_do] = ACTIONS(489),
    [anon_sym_try] = ACTIONS(489),
    [anon_sym_with] = ACTIONS(489),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_continue] = ACTIONS(489),
    [anon_sym_debugger] = ACTIONS(489),
    [anon_sym_return] = ACTIONS(489),
    [anon_sym_throw] = ACTIONS(489),
    [anon_sym_SEMI] = ACTIONS(487),
    [anon_sym_case] = ACTIONS(489),
    [anon_sym_yield] = ACTIONS(489),
    [anon_sym_LBRACK] = ACTIONS(487),
    [anon_sym_LT] = ACTIONS(489),
    [anon_sym_GT] = ACTIONS(489),
    [anon_sym_SLASH] = ACTIONS(489),
    [anon_sym_DOT] = ACTIONS(489),
    [anon_sym_class] = ACTIONS(489),
    [anon_sym_async] = ACTIONS(489),
    [anon_sym_function] = ACTIONS(489),
    [anon_sym_new] = ACTIONS(489),
    [anon_sym_QMARK] = ACTIONS(489),
    [anon_sym_AMP_AMP] = ACTIONS(487),
    [anon_sym_PIPE_PIPE] = ACTIONS(487),
    [anon_sym_GT_GT] = ACTIONS(489),
    [anon_sym_GT_GT_GT] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(487),
    [anon_sym_AMP] = ACTIONS(489),
    [anon_sym_CARET] = ACTIONS(487),
    [anon_sym_PIPE] = ACTIONS(489),
    [anon_sym_PLUS] = ACTIONS(489),
    [anon_sym_DASH] = ACTIONS(489),
    [anon_sym_PERCENT] = ACTIONS(487),
    [anon_sym_STAR_STAR] = ACTIONS(487),
    [anon_sym_LT_EQ] = ACTIONS(487),
    [anon_sym_EQ_EQ] = ACTIONS(489),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(487),
    [anon_sym_BANG_EQ] = ACTIONS(489),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(487),
    [anon_sym_GT_EQ] = ACTIONS(487),
    [anon_sym_QMARK_QMARK] = ACTIONS(487),
    [anon_sym_instanceof] = ACTIONS(489),
    [anon_sym_BANG] = ACTIONS(489),
    [anon_sym_TILDE] = ACTIONS(487),
    [anon_sym_typeof] = ACTIONS(489),
    [anon_sym_void] = ACTIONS(489),
    [anon_sym_delete] = ACTIONS(489),
    [anon_sym_PLUS_PLUS] = ACTIONS(487),
    [anon_sym_DASH_DASH] = ACTIONS(487),
    [anon_sym_DQUOTE] = ACTIONS(487),
    [anon_sym_SQUOTE] = ACTIONS(487),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(487),
    [sym_number] = ACTIONS(487),
    [sym_this] = ACTIONS(489),
    [sym_super] = ACTIONS(489),
    [sym_true] = ACTIONS(489),
    [sym_false] = ACTIONS(489),
    [sym_null] = ACTIONS(489),
    [sym_undefined] = ACTIONS(489),
    [anon_sym_AT] = ACTIONS(487),
    [anon_sym_static] = ACTIONS(489),
    [anon_sym_get] = ACTIONS(489),
    [anon_sym_set] = ACTIONS(489),
    [sym_preproc] = ACTIONS(487),
    [sym__automatic_semicolon] = ACTIONS(487),
  },
  [51] = {
    [ts_builtin_sym_end] = ACTIONS(491),
    [sym_identifier] = ACTIONS(493),
    [anon_sym_export] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_default] = ACTIONS(493),
    [anon_sym_LBRACE] = ACTIONS(491),
    [anon_sym_COMMA] = ACTIONS(497),
    [anon_sym_RBRACE] = ACTIONS(491),
    [anon_sym_import] = ACTIONS(493),
    [anon_sym_var] = ACTIONS(493),
    [anon_sym_let] = ACTIONS(493),
    [anon_sym_const] = ACTIONS(493),
    [anon_sym_if] = ACTIONS(493),
    [anon_sym_else] = ACTIONS(493),
    [anon_sym_switch] = ACTIONS(493),
    [anon_sym_for] = ACTIONS(493),
    [anon_sym_LPAREN] = ACTIONS(491),
    [anon_sym_await] = ACTIONS(493),
    [anon_sym_in] = ACTIONS(495),
    [anon_sym_while] = ACTIONS(493),
    [anon_sym_do] = ACTIONS(493),
    [anon_sym_try] = ACTIONS(493),
    [anon_sym_with] = ACTIONS(493),
    [anon_sym_break] = ACTIONS(493),
    [anon_sym_continue] = ACTIONS(493),
    [anon_sym_debugger] = ACTIONS(493),
    [anon_sym_return] = ACTIONS(493),
    [anon_sym_throw] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(491),
    [anon_sym_case] = ACTIONS(493),
    [anon_sym_yield] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(491),
    [anon_sym_LT] = ACTIONS(493),
    [anon_sym_GT] = ACTIONS(495),
    [anon_sym_SLASH] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(495),
    [anon_sym_class] = ACTIONS(493),
    [anon_sym_async] = ACTIONS(493),
    [anon_sym_function] = ACTIONS(493),
    [anon_sym_new] = ACTIONS(493),
    [anon_sym_QMARK] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(497),
    [anon_sym_PIPE_PIPE] = ACTIONS(497),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_GT_GT_GT] = ACTIONS(497),
    [anon_sym_LT_LT] = ACTIONS(497),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_CARET] = ACTIONS(497),
    [anon_sym_PIPE] = ACTIONS(495),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(493),
    [anon_sym_PERCENT] = ACTIONS(497),
    [anon_sym_STAR_STAR] = ACTIONS(497),
    [anon_sym_LT_EQ] = ACTIONS(497),
    [anon_sym_EQ_EQ] = ACTIONS(495),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(497),
    [anon_sym_BANG_EQ] = ACTIONS(495),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(497),
    [anon_sym_GT_EQ] = ACTIONS(497),
    [anon_sym_QMARK_QMARK] = ACTIONS(497),
    [anon_sym_instanceof] = ACTIONS(495),
    [anon_sym_BANG] = ACTIONS(493),
    [anon_sym_TILDE] = ACTIONS(491),
    [anon_sym_typeof] = ACTIONS(493),
    [anon_sym_void] = ACTIONS(493),
    [anon_sym_delete] = ACTIONS(493),
    [anon_sym_PLUS_PLUS] = ACTIONS(491),
    [anon_sym_DASH_DASH] = ACTIONS(491),
    [anon_sym_DQUOTE] = ACTIONS(491),
    [anon_sym_SQUOTE] = ACTIONS(491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(491),
    [sym_number] = ACTIONS(491),
    [sym_this] = ACTIONS(493),
    [sym_super] = ACTIONS(493),
    [sym_true] = ACTIONS(493),
    [sym_false] = ACTIONS(493),
    [sym_null] = ACTIONS(493),
    [sym_undefined] = ACTIONS(493),
    [anon_sym_AT] = ACTIONS(491),
    [anon_sym_static] = ACTIONS(493),
    [anon_sym_get] = ACTIONS(493),
    [anon_sym_set] = ACTIONS(493),
    [sym_preproc] = ACTIONS(491),
    [sym__automatic_semicolon] = ACTIONS(499),
  },
  [52] = {
    [ts_builtin_sym_end] = ACTIONS(501),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_export] = ACTIONS(503),
    [anon_sym_STAR] = ACTIONS(503),
    [anon_sym_default] = ACTIONS(503),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(501),
    [anon_sym_import] = ACTIONS(503),
    [anon_sym_var] = ACTIONS(503),
    [anon_sym_let] = ACTIONS(503),
    [anon_sym_const] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_else] = ACTIONS(503),
    [anon_sym_switch] = ACTIONS(503),
    [anon_sym_for] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_await] = ACTIONS(503),
    [anon_sym_in] = ACTIONS(503),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_do] = ACTIONS(503),
    [anon_sym_try] = ACTIONS(503),
    [anon_sym_with] = ACTIONS(503),
    [anon_sym_break] = ACTIONS(503),
    [anon_sym_continue] = ACTIONS(503),
    [anon_sym_debugger] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_throw] = ACTIONS(503),
    [anon_sym_SEMI] = ACTIONS(501),
    [anon_sym_case] = ACTIONS(503),
    [anon_sym_yield] = ACTIONS(503),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_LT] = ACTIONS(503),
    [anon_sym_GT] = ACTIONS(503),
    [anon_sym_SLASH] = ACTIONS(503),
    [anon_sym_DOT] = ACTIONS(503),
    [anon_sym_class] = ACTIONS(503),
    [anon_sym_async] = ACTIONS(503),
    [anon_sym_function] = ACTIONS(503),
    [anon_sym_new] = ACTIONS(503),
    [anon_sym_QMARK] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_GT_GT] = ACTIONS(503),
    [anon_sym_GT_GT_GT] = ACTIONS(501),
    [anon_sym_LT_LT] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(503),
    [anon_sym_CARET] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(503),
    [anon_sym_PLUS] = ACTIONS(503),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_PERCENT] = ACTIONS(501),
    [anon_sym_STAR_STAR] = ACTIONS(501),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_EQ_EQ] = ACTIONS(503),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(503),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_QMARK_QMARK] = ACTIONS(501),
    [anon_sym_instanceof] = ACTIONS(503),
    [anon_sym_BANG] = ACTIONS(503),
    [anon_sym_TILDE] = ACTIONS(501),
    [anon_sym_typeof] = ACTIONS(503),
    [anon_sym_void] = ACTIONS(503),
    [anon_sym_delete] = ACTIONS(503),
    [anon_sym_PLUS_PLUS] = ACTIONS(501),
    [anon_sym_DASH_DASH] = ACTIONS(501),
    [anon_sym_DQUOTE] = ACTIONS(501),
    [anon_sym_SQUOTE] = ACTIONS(501),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(501),
    [sym_number] = ACTIONS(501),
    [sym_this] = ACTIONS(503),
    [sym_super] = ACTIONS(503),
    [sym_true] = ACTIONS(503),
    [sym_false] = ACTIONS(503),
    [sym_null] = ACTIONS(503),
    [sym_undefined] = ACTIONS(503),
    [anon_sym_AT] = ACTIONS(501),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_get] = ACTIONS(503),
    [anon_sym_set] = ACTIONS(503),
    [sym_preproc] = ACTIONS(501),
    [sym__automatic_semicolon] = ACTIONS(501),
  },
  [53] = {
    [ts_builtin_sym_end] = ACTIONS(505),
    [sym_identifier] = ACTIONS(507),
    [anon_sym_export] = ACTIONS(507),
    [anon_sym_STAR] = ACTIONS(509),
    [anon_sym_default] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(505),
    [anon_sym_COMMA] = ACTIONS(511),
    [anon_sym_RBRACE] = ACTIONS(505),
    [anon_sym_import] = ACTIONS(507),
    [anon_sym_var] = ACTIONS(507),
    [anon_sym_let] = ACTIONS(507),
    [anon_sym_const] = ACTIONS(507),
    [anon_sym_if] = ACTIONS(507),
    [anon_sym_else] = ACTIONS(507),
    [anon_sym_switch] = ACTIONS(507),
    [anon_sym_for] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(505),
    [anon_sym_await] = ACTIONS(507),
    [anon_sym_in] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(507),
    [anon_sym_do] = ACTIONS(507),
    [anon_sym_try] = ACTIONS(507),
    [anon_sym_with] = ACTIONS(507),
    [anon_sym_break] = ACTIONS(507),
    [anon_sym_continue] = ACTIONS(507),
    [anon_sym_debugger] = ACTIONS(507),
    [anon_sym_return] = ACTIONS(507),
    [anon_sym_throw] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(505),
    [anon_sym_case] = ACTIONS(507),
    [anon_sym_yield] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(505),
    [anon_sym_LT] = ACTIONS(507),
    [anon_sym_GT] = ACTIONS(509),
    [anon_sym_SLASH] = ACTIONS(507),
    [anon_sym_DOT] = ACTIONS(509),
    [anon_sym_class] = ACTIONS(507),
    [anon_sym_async] = ACTIONS(507),
    [anon_sym_function] = ACTIONS(507),
    [anon_sym_new] = ACTIONS(507),
    [anon_sym_QMARK] = ACTIONS(509),
    [anon_sym_AMP_AMP] = ACTIONS(511),
    [anon_sym_PIPE_PIPE] = ACTIONS(511),
    [anon_sym_GT_GT] = ACTIONS(509),
    [anon_sym_GT_GT_GT] = ACTIONS(511),
    [anon_sym_LT_LT] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(509),
    [anon_sym_CARET] = ACTIONS(511),
    [anon_sym_PIPE] = ACTIONS(509),
    [anon_sym_PLUS] = ACTIONS(507),
    [anon_sym_DASH] = ACTIONS(507),
    [anon_sym_PERCENT] = ACTIONS(511),
    [anon_sym_STAR_STAR] = ACTIONS(511),
    [anon_sym_LT_EQ] = ACTIONS(511),
    [anon_sym_EQ_EQ] = ACTIONS(509),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(511),
    [anon_sym_BANG_EQ] = ACTIONS(509),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(511),
    [anon_sym_GT_EQ] = ACTIONS(511),
    [anon_sym_QMARK_QMARK] = ACTIONS(511),
    [anon_sym_instanceof] = ACTIONS(509),
    [anon_sym_BANG] = ACTIONS(507),
    [anon_sym_TILDE] = ACTIONS(505),
    [anon_sym_typeof] = ACTIONS(507),
    [anon_sym_void] = ACTIONS(507),
    [anon_sym_delete] = ACTIONS(507),
    [anon_sym_PLUS_PLUS] = ACTIONS(505),
    [anon_sym_DASH_DASH] = ACTIONS(505),
    [anon_sym_DQUOTE] = ACTIONS(505),
    [anon_sym_SQUOTE] = ACTIONS(505),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(505),
    [sym_number] = ACTIONS(505),
    [sym_this] = ACTIONS(507),
    [sym_super] = ACTIONS(507),
    [sym_true] = ACTIONS(507),
    [sym_false] = ACTIONS(507),
    [sym_null] = ACTIONS(507),
    [sym_undefined] = ACTIONS(507),
    [anon_sym_AT] = ACTIONS(505),
    [anon_sym_static] = ACTIONS(507),
    [anon_sym_get] = ACTIONS(507),
    [anon_sym_set] = ACTIONS(507),
    [sym_preproc] = ACTIONS(505),
    [sym__automatic_semicolon] = ACTIONS(513),
  },
  [54] = {
    [ts_builtin_sym_end] = ACTIONS(515),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_export] = ACTIONS(517),
    [anon_sym_STAR] = ACTIONS(519),
    [anon_sym_default] = ACTIONS(517),
    [anon_sym_LBRACE] = ACTIONS(515),
    [anon_sym_COMMA] = ACTIONS(521),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_import] = ACTIONS(517),
    [anon_sym_var] = ACTIONS(517),
    [anon_sym_let] = ACTIONS(517),
    [anon_sym_const] = ACTIONS(517),
    [anon_sym_if] = ACTIONS(517),
    [anon_sym_else] = ACTIONS(517),
    [anon_sym_switch] = ACTIONS(517),
    [anon_sym_for] = ACTIONS(517),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_await] = ACTIONS(517),
    [anon_sym_in] = ACTIONS(519),
    [anon_sym_while] = ACTIONS(517),
    [anon_sym_do] = ACTIONS(517),
    [anon_sym_try] = ACTIONS(517),
    [anon_sym_with] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(517),
    [anon_sym_continue] = ACTIONS(517),
    [anon_sym_debugger] = ACTIONS(517),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_throw] = ACTIONS(517),
    [anon_sym_SEMI] = ACTIONS(515),
    [anon_sym_case] = ACTIONS(517),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_LBRACK] = ACTIONS(515),
    [anon_sym_LT] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(519),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(519),
    [anon_sym_class] = ACTIONS(517),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_function] = ACTIONS(517),
    [anon_sym_new] = ACTIONS(517),
    [anon_sym_QMARK] = ACTIONS(519),
    [anon_sym_AMP_AMP] = ACTIONS(521),
    [anon_sym_PIPE_PIPE] = ACTIONS(521),
    [anon_sym_GT_GT] = ACTIONS(519),
    [anon_sym_GT_GT_GT] = ACTIONS(521),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(519),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_PIPE] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(517),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_STAR_STAR] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(519),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(521),
    [anon_sym_BANG_EQ] = ACTIONS(519),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(521),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [anon_sym_QMARK_QMARK] = ACTIONS(521),
    [anon_sym_instanceof] = ACTIONS(519),
    [anon_sym_BANG] = ACTIONS(517),
    [anon_sym_TILDE] = ACTIONS(515),
    [anon_sym_typeof] = ACTIONS(517),
    [anon_sym_void] = ACTIONS(517),
    [anon_sym_delete] = ACTIONS(517),
    [anon_sym_PLUS_PLUS] = ACTIONS(515),
    [anon_sym_DASH_DASH] = ACTIONS(515),
    [anon_sym_DQUOTE] = ACTIONS(515),
    [anon_sym_SQUOTE] = ACTIONS(515),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(515),
    [sym_number] = ACTIONS(515),
    [sym_this] = ACTIONS(517),
    [sym_super] = ACTIONS(517),
    [sym_true] = ACTIONS(517),
    [sym_false] = ACTIONS(517),
    [sym_null] = ACTIONS(517),
    [sym_undefined] = ACTIONS(517),
    [anon_sym_AT] = ACTIONS(515),
    [anon_sym_static] = ACTIONS(517),
    [anon_sym_get] = ACTIONS(517),
    [anon_sym_set] = ACTIONS(517),
    [sym_preproc] = ACTIONS(515),
    [sym__automatic_semicolon] = ACTIONS(523),
  },
  [55] = {
    [ts_builtin_sym_end] = ACTIONS(525),
    [sym_identifier] = ACTIONS(527),
    [anon_sym_export] = ACTIONS(527),
    [anon_sym_STAR] = ACTIONS(527),
    [anon_sym_default] = ACTIONS(527),
    [anon_sym_LBRACE] = ACTIONS(525),
    [anon_sym_COMMA] = ACTIONS(525),
    [anon_sym_RBRACE] = ACTIONS(525),
    [anon_sym_import] = ACTIONS(527),
    [anon_sym_var] = ACTIONS(527),
    [anon_sym_let] = ACTIONS(527),
    [anon_sym_const] = ACTIONS(527),
    [anon_sym_if] = ACTIONS(527),
    [anon_sym_else] = ACTIONS(527),
    [anon_sym_switch] = ACTIONS(527),
    [anon_sym_for] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(525),
    [anon_sym_await] = ACTIONS(527),
    [anon_sym_in] = ACTIONS(527),
    [anon_sym_while] = ACTIONS(527),
    [anon_sym_do] = ACTIONS(527),
    [anon_sym_try] = ACTIONS(527),
    [anon_sym_with] = ACTIONS(527),
    [anon_sym_break] = ACTIONS(527),
    [anon_sym_continue] = ACTIONS(527),
    [anon_sym_debugger] = ACTIONS(527),
    [anon_sym_return] = ACTIONS(527),
    [anon_sym_throw] = ACTIONS(527),
    [anon_sym_SEMI] = ACTIONS(525),
    [anon_sym_case] = ACTIONS(527),
    [anon_sym_yield] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(527),
    [anon_sym_SLASH] = ACTIONS(527),
    [anon_sym_DOT] = ACTIONS(527),
    [anon_sym_class] = ACTIONS(527),
    [anon_sym_async] = ACTIONS(527),
    [anon_sym_function] = ACTIONS(527),
    [anon_sym_new] = ACTIONS(527),
    [anon_sym_QMARK] = ACTIONS(527),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [anon_sym_GT_GT] = ACTIONS(527),
    [anon_sym_GT_GT_GT] = ACTIONS(525),
    [anon_sym_LT_LT] = ACTIONS(525),
    [anon_sym_AMP] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(525),
    [anon_sym_PIPE] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(527),
    [anon_sym_DASH] = ACTIONS(527),
    [anon_sym_PERCENT] = ACTIONS(525),
    [anon_sym_STAR_STAR] = ACTIONS(525),
    [anon_sym_LT_EQ] = ACTIONS(525),
    [anon_sym_EQ_EQ] = ACTIONS(527),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(525),
    [anon_sym_BANG_EQ] = ACTIONS(527),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(525),
    [anon_sym_GT_EQ] = ACTIONS(525),
    [anon_sym_QMARK_QMARK] = ACTIONS(525),
    [anon_sym_instanceof] = ACTIONS(527),
    [anon_sym_BANG] = ACTIONS(527),
    [anon_sym_TILDE] = ACTIONS(525),
    [anon_sym_typeof] = ACTIONS(527),
    [anon_sym_void] = ACTIONS(527),
    [anon_sym_delete] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(525),
    [anon_sym_DASH_DASH] = ACTIONS(525),
    [anon_sym_DQUOTE] = ACTIONS(525),
    [anon_sym_SQUOTE] = ACTIONS(525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(525),
    [sym_number] = ACTIONS(525),
    [sym_this] = ACTIONS(527),
    [sym_super] = ACTIONS(527),
    [sym_true] = ACTIONS(527),
    [sym_false] = ACTIONS(527),
    [sym_null] = ACTIONS(527),
    [sym_undefined] = ACTIONS(527),
    [anon_sym_AT] = ACTIONS(525),
    [anon_sym_static] = ACTIONS(527),
    [anon_sym_get] = ACTIONS(527),
    [anon_sym_set] = ACTIONS(527),
    [sym_preproc] = ACTIONS(525),
    [sym__automatic_semicolon] = ACTIONS(525),
  },
  [56] = {
    [ts_builtin_sym_end] = ACTIONS(529),
    [sym_identifier] = ACTIONS(531),
    [anon_sym_export] = ACTIONS(531),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_default] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(529),
    [anon_sym_COMMA] = ACTIONS(535),
    [anon_sym_RBRACE] = ACTIONS(529),
    [anon_sym_import] = ACTIONS(531),
    [anon_sym_var] = ACTIONS(531),
    [anon_sym_let] = ACTIONS(531),
    [anon_sym_const] = ACTIONS(531),
    [anon_sym_if] = ACTIONS(531),
    [anon_sym_else] = ACTIONS(531),
    [anon_sym_switch] = ACTIONS(531),
    [anon_sym_for] = ACTIONS(531),
    [anon_sym_LPAREN] = ACTIONS(529),
    [anon_sym_await] = ACTIONS(531),
    [anon_sym_in] = ACTIONS(533),
    [anon_sym_while] = ACTIONS(531),
    [anon_sym_do] = ACTIONS(531),
    [anon_sym_try] = ACTIONS(531),
    [anon_sym_with] = ACTIONS(531),
    [anon_sym_break] = ACTIONS(531),
    [anon_sym_continue] = ACTIONS(531),
    [anon_sym_debugger] = ACTIONS(531),
    [anon_sym_return] = ACTIONS(531),
    [anon_sym_throw] = ACTIONS(531),
    [anon_sym_SEMI] = ACTIONS(529),
    [anon_sym_case] = ACTIONS(531),
    [anon_sym_yield] = ACTIONS(531),
    [anon_sym_LBRACK] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(531),
    [anon_sym_DOT] = ACTIONS(533),
    [anon_sym_class] = ACTIONS(531),
    [anon_sym_async] = ACTIONS(531),
    [anon_sym_function] = ACTIONS(531),
    [anon_sym_new] = ACTIONS(531),
    [anon_sym_QMARK] = ACTIONS(533),
    [anon_sym_AMP_AMP] = ACTIONS(535),
    [anon_sym_PIPE_PIPE] = ACTIONS(535),
    [anon_sym_GT_GT] = ACTIONS(533),
    [anon_sym_GT_GT_GT] = ACTIONS(535),
    [anon_sym_LT_LT] = ACTIONS(535),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_CARET] = ACTIONS(535),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_PLUS] = ACTIONS(531),
    [anon_sym_DASH] = ACTIONS(531),
    [anon_sym_PERCENT] = ACTIONS(535),
    [anon_sym_STAR_STAR] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(535),
    [anon_sym_EQ_EQ] = ACTIONS(533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(535),
    [anon_sym_BANG_EQ] = ACTIONS(533),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(535),
    [anon_sym_GT_EQ] = ACTIONS(535),
    [anon_sym_QMARK_QMARK] = ACTIONS(535),
    [anon_sym_instanceof] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(531),
    [anon_sym_TILDE] = ACTIONS(529),
    [anon_sym_typeof] = ACTIONS(531),
    [anon_sym_void] = ACTIONS(531),
    [anon_sym_delete] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(529),
    [anon_sym_DASH_DASH] = ACTIONS(529),
    [anon_sym_DQUOTE] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(529),
    [sym_number] = ACTIONS(529),
    [sym_this] = ACTIONS(531),
    [sym_super] = ACTIONS(531),
    [sym_true] = ACTIONS(531),
    [sym_false] = ACTIONS(531),
    [sym_null] = ACTIONS(531),
    [sym_undefined] = ACTIONS(531),
    [anon_sym_AT] = ACTIONS(529),
    [anon_sym_static] = ACTIONS(531),
    [anon_sym_get] = ACTIONS(531),
    [anon_sym_set] = ACTIONS(531),
    [sym_preproc] = ACTIONS(529),
    [sym__automatic_semicolon] = ACTIONS(537),
  },
  [57] = {
    [ts_builtin_sym_end] = ACTIONS(539),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(541),
    [anon_sym_STAR] = ACTIONS(541),
    [anon_sym_default] = ACTIONS(541),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_import] = ACTIONS(541),
    [anon_sym_var] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(541),
    [anon_sym_const] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(541),
    [anon_sym_else] = ACTIONS(541),
    [anon_sym_switch] = ACTIONS(541),
    [anon_sym_for] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(539),
    [anon_sym_await] = ACTIONS(541),
    [anon_sym_in] = ACTIONS(541),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_do] = ACTIONS(541),
    [anon_sym_try] = ACTIONS(541),
    [anon_sym_with] = ACTIONS(541),
    [anon_sym_break] = ACTIONS(541),
    [anon_sym_continue] = ACTIONS(541),
    [anon_sym_debugger] = ACTIONS(541),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_throw] = ACTIONS(541),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_case] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_LBRACK] = ACTIONS(539),
    [anon_sym_LT] = ACTIONS(541),
    [anon_sym_GT] = ACTIONS(541),
    [anon_sym_SLASH] = ACTIONS(541),
    [anon_sym_DOT] = ACTIONS(541),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(541),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(541),
    [anon_sym_QMARK] = ACTIONS(541),
    [anon_sym_AMP_AMP] = ACTIONS(539),
    [anon_sym_PIPE_PIPE] = ACTIONS(539),
    [anon_sym_GT_GT] = ACTIONS(541),
    [anon_sym_GT_GT_GT] = ACTIONS(539),
    [anon_sym_LT_LT] = ACTIONS(539),
    [anon_sym_AMP] = ACTIONS(541),
    [anon_sym_CARET] = ACTIONS(539),
    [anon_sym_PIPE] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(541),
    [anon_sym_DASH] = ACTIONS(541),
    [anon_sym_PERCENT] = ACTIONS(539),
    [anon_sym_STAR_STAR] = ACTIONS(539),
    [anon_sym_LT_EQ] = ACTIONS(539),
    [anon_sym_EQ_EQ] = ACTIONS(541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(539),
    [anon_sym_BANG_EQ] = ACTIONS(541),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(539),
    [anon_sym_GT_EQ] = ACTIONS(539),
    [anon_sym_QMARK_QMARK] = ACTIONS(539),
    [anon_sym_instanceof] = ACTIONS(541),
    [anon_sym_BANG] = ACTIONS(541),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_typeof] = ACTIONS(541),
    [anon_sym_void] = ACTIONS(541),
    [anon_sym_delete] = ACTIONS(541),
    [anon_sym_PLUS_PLUS] = ACTIONS(539),
    [anon_sym_DASH_DASH] = ACTIONS(539),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_SQUOTE] = ACTIONS(539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(539),
    [sym_number] = ACTIONS(539),
    [sym_this] = ACTIONS(541),
    [sym_super] = ACTIONS(541),
    [sym_true] = ACTIONS(541),
    [sym_false] = ACTIONS(541),
    [sym_null] = ACTIONS(541),
    [sym_undefined] = ACTIONS(541),
    [anon_sym_AT] = ACTIONS(539),
    [anon_sym_static] = ACTIONS(541),
    [anon_sym_get] = ACTIONS(541),
    [anon_sym_set] = ACTIONS(541),
    [sym_preproc] = ACTIONS(539),
    [sym__automatic_semicolon] = ACTIONS(539),
  },
  [58] = {
    [ts_builtin_sym_end] = ACTIONS(539),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(541),
    [anon_sym_STAR] = ACTIONS(541),
    [anon_sym_default] = ACTIONS(541),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_import] = ACTIONS(541),
    [anon_sym_var] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(541),
    [anon_sym_const] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(541),
    [anon_sym_else] = ACTIONS(541),
    [anon_sym_switch] = ACTIONS(541),
    [anon_sym_for] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(539),
    [anon_sym_await] = ACTIONS(541),
    [anon_sym_in] = ACTIONS(541),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_do] = ACTIONS(541),
    [anon_sym_try] = ACTIONS(541),
    [anon_sym_with] = ACTIONS(541),
    [anon_sym_break] = ACTIONS(541),
    [anon_sym_continue] = ACTIONS(541),
    [anon_sym_debugger] = ACTIONS(541),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_throw] = ACTIONS(541),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_case] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_LBRACK] = ACTIONS(539),
    [anon_sym_LT] = ACTIONS(541),
    [anon_sym_GT] = ACTIONS(541),
    [anon_sym_SLASH] = ACTIONS(541),
    [anon_sym_DOT] = ACTIONS(541),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(541),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(541),
    [anon_sym_QMARK] = ACTIONS(541),
    [anon_sym_AMP_AMP] = ACTIONS(539),
    [anon_sym_PIPE_PIPE] = ACTIONS(539),
    [anon_sym_GT_GT] = ACTIONS(541),
    [anon_sym_GT_GT_GT] = ACTIONS(539),
    [anon_sym_LT_LT] = ACTIONS(539),
    [anon_sym_AMP] = ACTIONS(541),
    [anon_sym_CARET] = ACTIONS(539),
    [anon_sym_PIPE] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(541),
    [anon_sym_DASH] = ACTIONS(541),
    [anon_sym_PERCENT] = ACTIONS(539),
    [anon_sym_STAR_STAR] = ACTIONS(539),
    [anon_sym_LT_EQ] = ACTIONS(539),
    [anon_sym_EQ_EQ] = ACTIONS(541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(539),
    [anon_sym_BANG_EQ] = ACTIONS(541),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(539),
    [anon_sym_GT_EQ] = ACTIONS(539),
    [anon_sym_QMARK_QMARK] = ACTIONS(539),
    [anon_sym_instanceof] = ACTIONS(541),
    [anon_sym_BANG] = ACTIONS(541),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_typeof] = ACTIONS(541),
    [anon_sym_void] = ACTIONS(541),
    [anon_sym_delete] = ACTIONS(541),
    [anon_sym_PLUS_PLUS] = ACTIONS(539),
    [anon_sym_DASH_DASH] = ACTIONS(539),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_SQUOTE] = ACTIONS(539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(539),
    [sym_number] = ACTIONS(539),
    [sym_this] = ACTIONS(541),
    [sym_super] = ACTIONS(541),
    [sym_true] = ACTIONS(541),
    [sym_false] = ACTIONS(541),
    [sym_null] = ACTIONS(541),
    [sym_undefined] = ACTIONS(541),
    [anon_sym_AT] = ACTIONS(539),
    [anon_sym_static] = ACTIONS(541),
    [anon_sym_get] = ACTIONS(541),
    [anon_sym_set] = ACTIONS(541),
    [sym_preproc] = ACTIONS(539),
    [sym__automatic_semicolon] = ACTIONS(543),
  },
  [59] = {
    [ts_builtin_sym_end] = ACTIONS(437),
    [sym_identifier] = ACTIONS(439),
    [anon_sym_export] = ACTIONS(439),
    [anon_sym_STAR] = ACTIONS(439),
    [anon_sym_default] = ACTIONS(439),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_COMMA] = ACTIONS(437),
    [anon_sym_RBRACE] = ACTIONS(437),
    [anon_sym_import] = ACTIONS(439),
    [anon_sym_var] = ACTIONS(439),
    [anon_sym_let] = ACTIONS(439),
    [anon_sym_const] = ACTIONS(439),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_else] = ACTIONS(439),
    [anon_sym_switch] = ACTIONS(439),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_LPAREN] = ACTIONS(437),
    [anon_sym_await] = ACTIONS(439),
    [anon_sym_in] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(439),
    [anon_sym_do] = ACTIONS(439),
    [anon_sym_try] = ACTIONS(439),
    [anon_sym_with] = ACTIONS(439),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_continue] = ACTIONS(439),
    [anon_sym_debugger] = ACTIONS(439),
    [anon_sym_return] = ACTIONS(439),
    [anon_sym_throw] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(437),
    [anon_sym_case] = ACTIONS(439),
    [anon_sym_yield] = ACTIONS(439),
    [anon_sym_LBRACK] = ACTIONS(437),
    [anon_sym_LT] = ACTIONS(439),
    [anon_sym_GT] = ACTIONS(439),
    [anon_sym_SLASH] = ACTIONS(439),
    [anon_sym_DOT] = ACTIONS(439),
    [anon_sym_class] = ACTIONS(439),
    [anon_sym_async] = ACTIONS(439),
    [anon_sym_function] = ACTIONS(439),
    [anon_sym_new] = ACTIONS(439),
    [anon_sym_QMARK] = ACTIONS(439),
    [anon_sym_AMP_AMP] = ACTIONS(437),
    [anon_sym_PIPE_PIPE] = ACTIONS(437),
    [anon_sym_GT_GT] = ACTIONS(439),
    [anon_sym_GT_GT_GT] = ACTIONS(437),
    [anon_sym_LT_LT] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(439),
    [anon_sym_CARET] = ACTIONS(437),
    [anon_sym_PIPE] = ACTIONS(439),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_DASH] = ACTIONS(439),
    [anon_sym_PERCENT] = ACTIONS(437),
    [anon_sym_STAR_STAR] = ACTIONS(437),
    [anon_sym_LT_EQ] = ACTIONS(437),
    [anon_sym_EQ_EQ] = ACTIONS(439),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(437),
    [anon_sym_BANG_EQ] = ACTIONS(439),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(437),
    [anon_sym_GT_EQ] = ACTIONS(437),
    [anon_sym_QMARK_QMARK] = ACTIONS(437),
    [anon_sym_instanceof] = ACTIONS(439),
    [anon_sym_BANG] = ACTIONS(439),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_typeof] = ACTIONS(439),
    [anon_sym_void] = ACTIONS(439),
    [anon_sym_delete] = ACTIONS(439),
    [anon_sym_PLUS_PLUS] = ACTIONS(437),
    [anon_sym_DASH_DASH] = ACTIONS(437),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [anon_sym_SQUOTE] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [sym_number] = ACTIONS(437),
    [sym_this] = ACTIONS(439),
    [sym_super] = ACTIONS(439),
    [sym_true] = ACTIONS(439),
    [sym_false] = ACTIONS(439),
    [sym_null] = ACTIONS(439),
    [sym_undefined] = ACTIONS(439),
    [anon_sym_AT] = ACTIONS(437),
    [anon_sym_static] = ACTIONS(439),
    [anon_sym_get] = ACTIONS(439),
    [anon_sym_set] = ACTIONS(439),
    [sym_preproc] = ACTIONS(437),
    [sym__automatic_semicolon] = ACTIONS(545),
  },
  [60] = {
    [sym_import] = STATE(481),
    [sym_expression_statement] = STATE(72),
    [sym_variable_declaration] = STATE(72),
    [sym_lexical_declaration] = STATE(72),
    [sym_empty_statement] = STATE(72),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(490),
    [sym_array] = STATE(489),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(481),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_var] = ACTIONS(549),
    [anon_sym_let] = ACTIONS(551),
    [anon_sym_const] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(553),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(555),
    [anon_sym_get] = ACTIONS(555),
    [anon_sym_set] = ACTIONS(555),
  },
  [61] = {
    [sym_import] = STATE(481),
    [sym_expression_statement] = STATE(73),
    [sym_variable_declaration] = STATE(73),
    [sym_lexical_declaration] = STATE(73),
    [sym_empty_statement] = STATE(73),
    [sym_parenthesized_expression] = STATE(302),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(490),
    [sym_array] = STATE(489),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(481),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(302),
    [sym_subscript_expression] = STATE(302),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(547),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_var] = ACTIONS(549),
    [anon_sym_let] = ACTIONS(551),
    [anon_sym_const] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(553),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(555),
    [anon_sym_get] = ACTIONS(555),
    [anon_sym_set] = ACTIONS(555),
  },
  [62] = {
    [sym_import] = STATE(479),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(479),
    [sym_yield_expression] = STATE(479),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(479),
    [sym_jsx_fragment] = STATE(479),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(479),
    [sym_class] = STATE(479),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(479),
    [sym_arrow_function] = STATE(479),
    [sym_call_expression] = STATE(479),
    [sym_new_expression] = STATE(479),
    [sym_await_expression] = STATE(479),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(479),
    [sym_augmented_assignment_expression] = STATE(479),
    [sym_spread_element] = STATE(831),
    [sym_ternary_expression] = STATE(479),
    [sym_binary_expression] = STATE(479),
    [sym_unary_expression] = STATE(479),
    [sym_update_expression] = STATE(479),
    [sym_string] = STATE(479),
    [sym_template_string] = STATE(479),
    [sym_regex] = STATE(479),
    [sym_meta_property] = STATE(479),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [aux_sym_array_repeat1] = STATE(837),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(557),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(105),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(563),
    [sym_this] = ACTIONS(565),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(565),
    [sym_false] = ACTIONS(565),
    [sym_null] = ACTIONS(565),
    [sym_undefined] = ACTIONS(565),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [63] = {
    [sym_import] = STATE(457),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(457),
    [sym_yield_expression] = STATE(457),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(457),
    [sym_jsx_fragment] = STATE(457),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(457),
    [sym_class] = STATE(457),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(457),
    [sym_arrow_function] = STATE(457),
    [sym_call_expression] = STATE(457),
    [sym_new_expression] = STATE(457),
    [sym_await_expression] = STATE(457),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(457),
    [sym_augmented_assignment_expression] = STATE(457),
    [sym_spread_element] = STATE(810),
    [sym_ternary_expression] = STATE(457),
    [sym_binary_expression] = STATE(457),
    [sym_unary_expression] = STATE(457),
    [sym_update_expression] = STATE(457),
    [sym_string] = STATE(457),
    [sym_template_string] = STATE(457),
    [sym_regex] = STATE(457),
    [sym_meta_property] = STATE(457),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [aux_sym_array_repeat1] = STATE(879),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(557),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_RBRACK] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(105),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(569),
    [sym_this] = ACTIONS(571),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(571),
    [sym_false] = ACTIONS(571),
    [sym_null] = ACTIONS(571),
    [sym_undefined] = ACTIONS(571),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [64] = {
    [sym_import] = STATE(465),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(465),
    [sym_yield_expression] = STATE(465),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(465),
    [sym_jsx_fragment] = STATE(465),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(465),
    [sym_class] = STATE(465),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(465),
    [sym_arrow_function] = STATE(465),
    [sym_call_expression] = STATE(465),
    [sym_new_expression] = STATE(465),
    [sym_await_expression] = STATE(465),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(465),
    [sym_augmented_assignment_expression] = STATE(465),
    [sym_spread_element] = STATE(859),
    [sym_ternary_expression] = STATE(465),
    [sym_binary_expression] = STATE(465),
    [sym_unary_expression] = STATE(465),
    [sym_update_expression] = STATE(465),
    [sym_string] = STATE(465),
    [sym_template_string] = STATE(465),
    [sym_regex] = STATE(465),
    [sym_meta_property] = STATE(465),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_RBRACK] = ACTIONS(573),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(105),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(575),
    [sym_this] = ACTIONS(577),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(577),
    [sym_false] = ACTIONS(577),
    [sym_null] = ACTIONS(577),
    [sym_undefined] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [65] = {
    [sym_import] = STATE(460),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(460),
    [sym_yield_expression] = STATE(460),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(460),
    [sym_jsx_fragment] = STATE(460),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(460),
    [sym_class] = STATE(460),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(460),
    [sym_arrow_function] = STATE(460),
    [sym_call_expression] = STATE(460),
    [sym_new_expression] = STATE(460),
    [sym_await_expression] = STATE(460),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(460),
    [sym_augmented_assignment_expression] = STATE(460),
    [sym_spread_element] = STATE(831),
    [sym_ternary_expression] = STATE(460),
    [sym_binary_expression] = STATE(460),
    [sym_unary_expression] = STATE(460),
    [sym_update_expression] = STATE(460),
    [sym_string] = STATE(460),
    [sym_template_string] = STATE(460),
    [sym_regex] = STATE(460),
    [sym_meta_property] = STATE(460),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [aux_sym_array_repeat1] = STATE(837),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(557),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(105),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(579),
    [sym_this] = ACTIONS(581),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(581),
    [sym_false] = ACTIONS(581),
    [sym_null] = ACTIONS(581),
    [sym_undefined] = ACTIONS(581),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [66] = {
    [sym_import] = STATE(469),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(469),
    [sym_yield_expression] = STATE(469),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(469),
    [sym_jsx_fragment] = STATE(469),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(469),
    [sym_class] = STATE(469),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(469),
    [sym_arrow_function] = STATE(469),
    [sym_call_expression] = STATE(469),
    [sym_new_expression] = STATE(469),
    [sym_await_expression] = STATE(469),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(469),
    [sym_augmented_assignment_expression] = STATE(469),
    [sym_spread_element] = STATE(810),
    [sym_ternary_expression] = STATE(469),
    [sym_binary_expression] = STATE(469),
    [sym_unary_expression] = STATE(469),
    [sym_update_expression] = STATE(469),
    [sym_string] = STATE(469),
    [sym_template_string] = STATE(469),
    [sym_regex] = STATE(469),
    [sym_meta_property] = STATE(469),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [aux_sym_array_repeat1] = STATE(879),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(557),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_RBRACK] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(105),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(583),
    [sym_this] = ACTIONS(585),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(585),
    [sym_false] = ACTIONS(585),
    [sym_null] = ACTIONS(585),
    [sym_undefined] = ACTIONS(585),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [67] = {
    [sym_import] = STATE(520),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(520),
    [sym_yield_expression] = STATE(520),
    [sym_object] = STATE(528),
    [sym_assignment_pattern] = STATE(829),
    [sym_array] = STATE(494),
    [sym_jsx_element] = STATE(520),
    [sym_jsx_fragment] = STATE(520),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(520),
    [sym_class] = STATE(520),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(520),
    [sym_arrow_function] = STATE(520),
    [sym_call_expression] = STATE(520),
    [sym_new_expression] = STATE(520),
    [sym_await_expression] = STATE(520),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(520),
    [sym_augmented_assignment_expression] = STATE(520),
    [sym_ternary_expression] = STATE(520),
    [sym_binary_expression] = STATE(520),
    [sym_unary_expression] = STATE(520),
    [sym_update_expression] = STATE(520),
    [sym_sequence_expression] = STATE(1059),
    [sym_string] = STATE(520),
    [sym_template_string] = STATE(520),
    [sym_regex] = STATE(520),
    [sym_meta_property] = STATE(520),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [sym_rest_parameter] = STATE(829),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(587),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_RPAREN] = ACTIONS(589),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(591),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(593),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(595),
    [sym_this] = ACTIONS(597),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(597),
    [sym_false] = ACTIONS(597),
    [sym_null] = ACTIONS(597),
    [sym_undefined] = ACTIONS(597),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(599),
    [anon_sym_get] = ACTIONS(599),
    [anon_sym_set] = ACTIONS(599),
  },
  [68] = {
    [sym_import] = STATE(477),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(477),
    [sym_yield_expression] = STATE(477),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(477),
    [sym_jsx_fragment] = STATE(477),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(477),
    [sym_class] = STATE(477),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(477),
    [sym_arrow_function] = STATE(477),
    [sym_call_expression] = STATE(477),
    [sym_new_expression] = STATE(477),
    [sym_await_expression] = STATE(477),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(477),
    [sym_augmented_assignment_expression] = STATE(477),
    [sym_spread_element] = STATE(863),
    [sym_ternary_expression] = STATE(477),
    [sym_binary_expression] = STATE(477),
    [sym_unary_expression] = STATE(477),
    [sym_update_expression] = STATE(477),
    [sym_string] = STATE(477),
    [sym_template_string] = STATE(477),
    [sym_regex] = STATE(477),
    [sym_meta_property] = STATE(477),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [aux_sym_array_repeat1] = STATE(862),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(557),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_RPAREN] = ACTIONS(601),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(105),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(603),
    [sym_this] = ACTIONS(605),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(605),
    [sym_false] = ACTIONS(605),
    [sym_null] = ACTIONS(605),
    [sym_undefined] = ACTIONS(605),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [69] = {
    [sym_import] = STATE(478),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(478),
    [sym_yield_expression] = STATE(478),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(478),
    [sym_jsx_fragment] = STATE(478),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(478),
    [sym_class] = STATE(478),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(478),
    [sym_arrow_function] = STATE(478),
    [sym_call_expression] = STATE(478),
    [sym_new_expression] = STATE(478),
    [sym_await_expression] = STATE(478),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(478),
    [sym_augmented_assignment_expression] = STATE(478),
    [sym_spread_element] = STATE(860),
    [sym_ternary_expression] = STATE(478),
    [sym_binary_expression] = STATE(478),
    [sym_unary_expression] = STATE(478),
    [sym_update_expression] = STATE(478),
    [sym_string] = STATE(478),
    [sym_template_string] = STATE(478),
    [sym_regex] = STATE(478),
    [sym_meta_property] = STATE(478),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [aux_sym_array_repeat1] = STATE(861),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_COMMA] = ACTIONS(557),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_RPAREN] = ACTIONS(607),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(105),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(609),
    [sym_this] = ACTIONS(611),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(611),
    [sym_false] = ACTIONS(611),
    [sym_null] = ACTIONS(611),
    [sym_undefined] = ACTIONS(611),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [70] = {
    [sym_import] = STATE(496),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(496),
    [sym_yield_expression] = STATE(496),
    [sym_object] = STATE(528),
    [sym_assignment_pattern] = STATE(829),
    [sym_array] = STATE(494),
    [sym_jsx_element] = STATE(496),
    [sym_jsx_fragment] = STATE(496),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(496),
    [sym_class] = STATE(496),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(496),
    [sym_arrow_function] = STATE(496),
    [sym_call_expression] = STATE(496),
    [sym_new_expression] = STATE(496),
    [sym_await_expression] = STATE(496),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(496),
    [sym_augmented_assignment_expression] = STATE(496),
    [sym_ternary_expression] = STATE(496),
    [sym_binary_expression] = STATE(496),
    [sym_unary_expression] = STATE(496),
    [sym_update_expression] = STATE(496),
    [sym_sequence_expression] = STATE(1100),
    [sym_string] = STATE(496),
    [sym_template_string] = STATE(496),
    [sym_regex] = STATE(496),
    [sym_meta_property] = STATE(496),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [sym_rest_parameter] = STATE(829),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(587),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_RPAREN] = ACTIONS(589),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(591),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(593),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(599),
    [anon_sym_get] = ACTIONS(599),
    [anon_sym_set] = ACTIONS(599),
  },
  [71] = {
    [sym_import] = STATE(542),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(542),
    [sym_yield_expression] = STATE(542),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(542),
    [sym_jsx_fragment] = STATE(542),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(542),
    [sym_class] = STATE(542),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(542),
    [sym_arrow_function] = STATE(542),
    [sym_call_expression] = STATE(542),
    [sym_new_expression] = STATE(542),
    [sym_await_expression] = STATE(542),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(542),
    [sym_augmented_assignment_expression] = STATE(542),
    [sym_spread_element] = STATE(1112),
    [sym_ternary_expression] = STATE(542),
    [sym_binary_expression] = STATE(542),
    [sym_unary_expression] = STATE(542),
    [sym_update_expression] = STATE(542),
    [sym_sequence_expression] = STATE(1112),
    [sym_string] = STATE(542),
    [sym_template_string] = STATE(542),
    [sym_regex] = STATE(542),
    [sym_meta_property] = STATE(542),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_RBRACE] = ACTIONS(617),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(105),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(619),
    [sym_this] = ACTIONS(621),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(621),
    [sym_false] = ACTIONS(621),
    [sym_null] = ACTIONS(621),
    [sym_undefined] = ACTIONS(621),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [72] = {
    [sym_import] = STATE(481),
    [sym_expression_statement] = STATE(77),
    [sym_empty_statement] = STATE(77),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(481),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [73] = {
    [sym_import] = STATE(481),
    [sym_expression_statement] = STATE(78),
    [sym_empty_statement] = STATE(78),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(481),
    [sym_yield_expression] = STATE(481),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(481),
    [sym_jsx_fragment] = STATE(481),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(481),
    [sym_class] = STATE(481),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(481),
    [sym_arrow_function] = STATE(481),
    [sym_call_expression] = STATE(481),
    [sym_new_expression] = STATE(481),
    [sym_await_expression] = STATE(481),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(481),
    [sym_augmented_assignment_expression] = STATE(481),
    [sym_ternary_expression] = STATE(481),
    [sym_binary_expression] = STATE(481),
    [sym_unary_expression] = STATE(481),
    [sym_update_expression] = STATE(481),
    [sym_sequence_expression] = STATE(954),
    [sym_string] = STATE(481),
    [sym_template_string] = STATE(481),
    [sym_regex] = STATE(481),
    [sym_meta_property] = STATE(481),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(49),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(81),
    [sym_this] = ACTIONS(83),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(83),
    [sym_false] = ACTIONS(83),
    [sym_null] = ACTIONS(83),
    [sym_undefined] = ACTIONS(83),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [74] = {
    [sym_import] = STATE(560),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(560),
    [sym_yield_expression] = STATE(560),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(560),
    [sym_jsx_fragment] = STATE(560),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(560),
    [sym_class] = STATE(560),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(560),
    [sym_arrow_function] = STATE(560),
    [sym_call_expression] = STATE(560),
    [sym_new_expression] = STATE(560),
    [sym_await_expression] = STATE(560),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(560),
    [sym_augmented_assignment_expression] = STATE(560),
    [sym_spread_element] = STATE(1081),
    [sym_ternary_expression] = STATE(560),
    [sym_binary_expression] = STATE(560),
    [sym_unary_expression] = STATE(560),
    [sym_update_expression] = STATE(560),
    [sym_sequence_expression] = STATE(1081),
    [sym_string] = STATE(560),
    [sym_template_string] = STATE(560),
    [sym_regex] = STATE(560),
    [sym_meta_property] = STATE(560),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_RBRACE] = ACTIONS(623),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(105),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(625),
    [sym_this] = ACTIONS(627),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(627),
    [sym_false] = ACTIONS(627),
    [sym_null] = ACTIONS(627),
    [sym_undefined] = ACTIONS(627),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [75] = {
    [sym_import] = STATE(574),
    [sym_parenthesized_expression] = STATE(313),
    [sym__expression] = STATE(574),
    [sym_yield_expression] = STATE(574),
    [sym_object] = STATE(571),
    [sym_array] = STATE(575),
    [sym_jsx_element] = STATE(574),
    [sym_jsx_fragment] = STATE(574),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(574),
    [sym_class] = STATE(574),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(574),
    [sym_arrow_function] = STATE(574),
    [sym_call_expression] = STATE(574),
    [sym_new_expression] = STATE(574),
    [sym_await_expression] = STATE(574),
    [sym_member_expression] = STATE(313),
    [sym_subscript_expression] = STATE(313),
    [sym_assignment_expression] = STATE(574),
    [sym_augmented_assignment_expression] = STATE(574),
    [sym_ternary_expression] = STATE(574),
    [sym_binary_expression] = STATE(574),
    [sym_unary_expression] = STATE(574),
    [sym_update_expression] = STATE(574),
    [sym_string] = STATE(574),
    [sym_template_string] = STATE(574),
    [sym_regex] = STATE(574),
    [sym_meta_property] = STATE(574),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(629),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_var] = ACTIONS(631),
    [anon_sym_let] = ACTIONS(631),
    [anon_sym_const] = ACTIONS(631),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(633),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(635),
    [sym_this] = ACTIONS(637),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(637),
    [sym_false] = ACTIONS(637),
    [sym_null] = ACTIONS(637),
    [sym_undefined] = ACTIONS(637),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(639),
    [anon_sym_get] = ACTIONS(639),
    [anon_sym_set] = ACTIONS(639),
  },
  [76] = {
    [sym_import] = STATE(488),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(488),
    [sym_yield_expression] = STATE(488),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(488),
    [sym_jsx_fragment] = STATE(488),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(488),
    [sym_class] = STATE(488),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(488),
    [sym_arrow_function] = STATE(488),
    [sym_call_expression] = STATE(488),
    [sym_new_expression] = STATE(488),
    [sym_await_expression] = STATE(488),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(488),
    [sym_augmented_assignment_expression] = STATE(488),
    [sym_ternary_expression] = STATE(488),
    [sym_binary_expression] = STATE(488),
    [sym_unary_expression] = STATE(488),
    [sym_update_expression] = STATE(488),
    [sym_sequence_expression] = STATE(908),
    [sym_string] = STATE(488),
    [sym_template_string] = STATE(488),
    [sym_regex] = STATE(488),
    [sym_meta_property] = STATE(488),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_SEMI] = ACTIONS(641),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(643),
    [sym_this] = ACTIONS(645),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(645),
    [sym_false] = ACTIONS(645),
    [sym_null] = ACTIONS(645),
    [sym_undefined] = ACTIONS(645),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
    [sym__automatic_semicolon] = ACTIONS(641),
  },
  [77] = {
    [sym_import] = STATE(504),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(504),
    [sym_yield_expression] = STATE(504),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(504),
    [sym_jsx_fragment] = STATE(504),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(504),
    [sym_class] = STATE(504),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(504),
    [sym_arrow_function] = STATE(504),
    [sym_call_expression] = STATE(504),
    [sym_new_expression] = STATE(504),
    [sym_await_expression] = STATE(504),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(504),
    [sym_augmented_assignment_expression] = STATE(504),
    [sym_ternary_expression] = STATE(504),
    [sym_binary_expression] = STATE(504),
    [sym_unary_expression] = STATE(504),
    [sym_update_expression] = STATE(504),
    [sym_sequence_expression] = STATE(1105),
    [sym_string] = STATE(504),
    [sym_template_string] = STATE(504),
    [sym_regex] = STATE(504),
    [sym_meta_property] = STATE(504),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_RPAREN] = ACTIONS(647),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(649),
    [sym_this] = ACTIONS(651),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(651),
    [sym_false] = ACTIONS(651),
    [sym_null] = ACTIONS(651),
    [sym_undefined] = ACTIONS(651),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [78] = {
    [sym_import] = STATE(503),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(503),
    [sym_yield_expression] = STATE(503),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(503),
    [sym_jsx_fragment] = STATE(503),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(503),
    [sym_class] = STATE(503),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(503),
    [sym_arrow_function] = STATE(503),
    [sym_call_expression] = STATE(503),
    [sym_new_expression] = STATE(503),
    [sym_await_expression] = STATE(503),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(503),
    [sym_augmented_assignment_expression] = STATE(503),
    [sym_ternary_expression] = STATE(503),
    [sym_binary_expression] = STATE(503),
    [sym_unary_expression] = STATE(503),
    [sym_update_expression] = STATE(503),
    [sym_sequence_expression] = STATE(1091),
    [sym_string] = STATE(503),
    [sym_template_string] = STATE(503),
    [sym_regex] = STATE(503),
    [sym_meta_property] = STATE(503),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(655),
    [sym_this] = ACTIONS(657),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(657),
    [sym_false] = ACTIONS(657),
    [sym_null] = ACTIONS(657),
    [sym_undefined] = ACTIONS(657),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [79] = {
    [sym_import] = STATE(472),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(472),
    [sym_yield_expression] = STATE(472),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(472),
    [sym_jsx_fragment] = STATE(472),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(472),
    [sym_class] = STATE(472),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(472),
    [sym_arrow_function] = STATE(472),
    [sym_call_expression] = STATE(472),
    [sym_new_expression] = STATE(472),
    [sym_await_expression] = STATE(472),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(472),
    [sym_augmented_assignment_expression] = STATE(472),
    [sym_ternary_expression] = STATE(472),
    [sym_binary_expression] = STATE(472),
    [sym_unary_expression] = STATE(472),
    [sym_update_expression] = STATE(472),
    [sym_sequence_expression] = STATE(940),
    [sym_string] = STATE(472),
    [sym_template_string] = STATE(472),
    [sym_regex] = STATE(472),
    [sym_meta_property] = STATE(472),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(659),
    [sym_this] = ACTIONS(661),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(661),
    [sym_false] = ACTIONS(661),
    [sym_null] = ACTIONS(661),
    [sym_undefined] = ACTIONS(661),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [80] = {
    [sym_import] = STATE(404),
    [sym_statement_block] = STATE(546),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(404),
    [sym_yield_expression] = STATE(404),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(404),
    [sym_jsx_fragment] = STATE(404),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(404),
    [sym_class] = STATE(404),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(404),
    [sym_arrow_function] = STATE(404),
    [sym_call_expression] = STATE(404),
    [sym_new_expression] = STATE(404),
    [sym_await_expression] = STATE(404),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(404),
    [sym_augmented_assignment_expression] = STATE(404),
    [sym_ternary_expression] = STATE(404),
    [sym_binary_expression] = STATE(404),
    [sym_unary_expression] = STATE(404),
    [sym_update_expression] = STATE(404),
    [sym_string] = STATE(404),
    [sym_template_string] = STATE(404),
    [sym_regex] = STATE(404),
    [sym_meta_property] = STATE(404),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(665),
    [sym_this] = ACTIONS(667),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(667),
    [sym_false] = ACTIONS(667),
    [sym_null] = ACTIONS(667),
    [sym_undefined] = ACTIONS(667),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [81] = {
    [sym_import] = STATE(524),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(524),
    [sym_yield_expression] = STATE(524),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(524),
    [sym_jsx_fragment] = STATE(524),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(524),
    [sym_class] = STATE(524),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(524),
    [sym_arrow_function] = STATE(524),
    [sym_call_expression] = STATE(524),
    [sym_new_expression] = STATE(524),
    [sym_await_expression] = STATE(524),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(524),
    [sym_augmented_assignment_expression] = STATE(524),
    [sym_ternary_expression] = STATE(524),
    [sym_binary_expression] = STATE(524),
    [sym_unary_expression] = STATE(524),
    [sym_update_expression] = STATE(524),
    [sym_sequence_expression] = STATE(1122),
    [sym_string] = STATE(524),
    [sym_template_string] = STATE(524),
    [sym_regex] = STATE(524),
    [sym_meta_property] = STATE(524),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(669),
    [sym_this] = ACTIONS(671),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(671),
    [sym_false] = ACTIONS(671),
    [sym_null] = ACTIONS(671),
    [sym_undefined] = ACTIONS(671),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [82] = {
    [sym_import] = STATE(509),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(509),
    [sym_yield_expression] = STATE(509),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(509),
    [sym_jsx_fragment] = STATE(509),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(509),
    [sym_class] = STATE(509),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(509),
    [sym_arrow_function] = STATE(509),
    [sym_call_expression] = STATE(509),
    [sym_new_expression] = STATE(509),
    [sym_await_expression] = STATE(509),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(509),
    [sym_augmented_assignment_expression] = STATE(509),
    [sym_ternary_expression] = STATE(509),
    [sym_binary_expression] = STATE(509),
    [sym_unary_expression] = STATE(509),
    [sym_update_expression] = STATE(509),
    [sym_sequence_expression] = STATE(1103),
    [sym_string] = STATE(509),
    [sym_template_string] = STATE(509),
    [sym_regex] = STATE(509),
    [sym_meta_property] = STATE(509),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(673),
    [sym_this] = ACTIONS(675),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(675),
    [sym_false] = ACTIONS(675),
    [sym_null] = ACTIONS(675),
    [sym_undefined] = ACTIONS(675),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [83] = {
    [sym_import] = STATE(419),
    [sym_statement_block] = STATE(538),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(419),
    [sym_yield_expression] = STATE(419),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(419),
    [sym_jsx_fragment] = STATE(419),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(419),
    [sym_class] = STATE(419),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(419),
    [sym_arrow_function] = STATE(419),
    [sym_call_expression] = STATE(419),
    [sym_new_expression] = STATE(419),
    [sym_await_expression] = STATE(419),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(419),
    [sym_augmented_assignment_expression] = STATE(419),
    [sym_ternary_expression] = STATE(419),
    [sym_binary_expression] = STATE(419),
    [sym_unary_expression] = STATE(419),
    [sym_update_expression] = STATE(419),
    [sym_string] = STATE(419),
    [sym_template_string] = STATE(419),
    [sym_regex] = STATE(419),
    [sym_meta_property] = STATE(419),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(677),
    [sym_this] = ACTIONS(679),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(679),
    [sym_false] = ACTIONS(679),
    [sym_null] = ACTIONS(679),
    [sym_undefined] = ACTIONS(679),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [84] = {
    [sym_import] = STATE(502),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(502),
    [sym_yield_expression] = STATE(502),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(502),
    [sym_jsx_fragment] = STATE(502),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(502),
    [sym_class] = STATE(502),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(502),
    [sym_arrow_function] = STATE(502),
    [sym_call_expression] = STATE(502),
    [sym_new_expression] = STATE(502),
    [sym_await_expression] = STATE(502),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(502),
    [sym_augmented_assignment_expression] = STATE(502),
    [sym_ternary_expression] = STATE(502),
    [sym_binary_expression] = STATE(502),
    [sym_unary_expression] = STATE(502),
    [sym_update_expression] = STATE(502),
    [sym_sequence_expression] = STATE(1104),
    [sym_string] = STATE(502),
    [sym_template_string] = STATE(502),
    [sym_regex] = STATE(502),
    [sym_meta_property] = STATE(502),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(681),
    [sym_this] = ACTIONS(683),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(683),
    [sym_false] = ACTIONS(683),
    [sym_null] = ACTIONS(683),
    [sym_undefined] = ACTIONS(683),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [85] = {
    [sym_import] = STATE(341),
    [sym_statement_block] = STATE(454),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(341),
    [sym_yield_expression] = STATE(341),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(341),
    [sym_jsx_fragment] = STATE(341),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(341),
    [sym_class] = STATE(341),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(341),
    [sym_arrow_function] = STATE(341),
    [sym_call_expression] = STATE(341),
    [sym_new_expression] = STATE(341),
    [sym_await_expression] = STATE(341),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(341),
    [sym_augmented_assignment_expression] = STATE(341),
    [sym_ternary_expression] = STATE(341),
    [sym_binary_expression] = STATE(341),
    [sym_unary_expression] = STATE(341),
    [sym_update_expression] = STATE(341),
    [sym_string] = STATE(341),
    [sym_template_string] = STATE(341),
    [sym_regex] = STATE(341),
    [sym_meta_property] = STATE(341),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(685),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(687),
    [sym_this] = ACTIONS(689),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(689),
    [sym_false] = ACTIONS(689),
    [sym_null] = ACTIONS(689),
    [sym_undefined] = ACTIONS(689),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [86] = {
    [sym_import] = STATE(424),
    [sym_statement_block] = STATE(533),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(424),
    [sym_yield_expression] = STATE(424),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(424),
    [sym_jsx_fragment] = STATE(424),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(424),
    [sym_class] = STATE(424),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(424),
    [sym_arrow_function] = STATE(424),
    [sym_call_expression] = STATE(424),
    [sym_new_expression] = STATE(424),
    [sym_await_expression] = STATE(424),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(424),
    [sym_augmented_assignment_expression] = STATE(424),
    [sym_ternary_expression] = STATE(424),
    [sym_binary_expression] = STATE(424),
    [sym_unary_expression] = STATE(424),
    [sym_update_expression] = STATE(424),
    [sym_string] = STATE(424),
    [sym_template_string] = STATE(424),
    [sym_regex] = STATE(424),
    [sym_meta_property] = STATE(424),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(691),
    [sym_this] = ACTIONS(693),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(693),
    [sym_false] = ACTIONS(693),
    [sym_null] = ACTIONS(693),
    [sym_undefined] = ACTIONS(693),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [87] = {
    [sym_import] = STATE(539),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(539),
    [sym_yield_expression] = STATE(539),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(539),
    [sym_jsx_fragment] = STATE(539),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(539),
    [sym_class] = STATE(539),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(539),
    [sym_arrow_function] = STATE(539),
    [sym_call_expression] = STATE(539),
    [sym_new_expression] = STATE(539),
    [sym_await_expression] = STATE(539),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(539),
    [sym_augmented_assignment_expression] = STATE(539),
    [sym_ternary_expression] = STATE(539),
    [sym_binary_expression] = STATE(539),
    [sym_unary_expression] = STATE(539),
    [sym_update_expression] = STATE(539),
    [sym_sequence_expression] = STATE(1127),
    [sym_string] = STATE(539),
    [sym_template_string] = STATE(539),
    [sym_regex] = STATE(539),
    [sym_meta_property] = STATE(539),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(695),
    [sym_this] = ACTIONS(697),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(697),
    [sym_false] = ACTIONS(697),
    [sym_null] = ACTIONS(697),
    [sym_undefined] = ACTIONS(697),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [88] = {
    [sym_import] = STATE(557),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(557),
    [sym_yield_expression] = STATE(557),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(557),
    [sym_jsx_fragment] = STATE(557),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(557),
    [sym_class] = STATE(557),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(557),
    [sym_arrow_function] = STATE(557),
    [sym_call_expression] = STATE(557),
    [sym_new_expression] = STATE(557),
    [sym_await_expression] = STATE(557),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(557),
    [sym_augmented_assignment_expression] = STATE(557),
    [sym_ternary_expression] = STATE(557),
    [sym_binary_expression] = STATE(557),
    [sym_unary_expression] = STATE(557),
    [sym_update_expression] = STATE(557),
    [sym_sequence_expression] = STATE(1086),
    [sym_string] = STATE(557),
    [sym_template_string] = STATE(557),
    [sym_regex] = STATE(557),
    [sym_meta_property] = STATE(557),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(699),
    [sym_this] = ACTIONS(701),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(701),
    [sym_false] = ACTIONS(701),
    [sym_null] = ACTIONS(701),
    [sym_undefined] = ACTIONS(701),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [89] = {
    [sym_import] = STATE(361),
    [sym_parenthesized_expression] = STATE(283),
    [sym__expression] = STATE(574),
    [sym_yield_expression] = STATE(574),
    [sym_object] = STATE(331),
    [sym_array] = STATE(333),
    [sym_jsx_element] = STATE(574),
    [sym_jsx_fragment] = STATE(574),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(574),
    [sym_class] = STATE(361),
    [sym_function] = STATE(335),
    [sym_generator_function] = STATE(361),
    [sym_arrow_function] = STATE(361),
    [sym_call_expression] = STATE(574),
    [sym_new_expression] = STATE(361),
    [sym_await_expression] = STATE(574),
    [sym_member_expression] = STATE(283),
    [sym_subscript_expression] = STATE(283),
    [sym_assignment_expression] = STATE(574),
    [sym_augmented_assignment_expression] = STATE(574),
    [sym_ternary_expression] = STATE(574),
    [sym_binary_expression] = STATE(574),
    [sym_unary_expression] = STATE(574),
    [sym_update_expression] = STATE(574),
    [sym_string] = STATE(361),
    [sym_template_string] = STATE(361),
    [sym_regex] = STATE(361),
    [sym_meta_property] = STATE(361),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(703),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_DOT] = ACTIONS(705),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(707),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(709),
    [sym_this] = ACTIONS(711),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(711),
    [sym_false] = ACTIONS(711),
    [sym_null] = ACTIONS(711),
    [sym_undefined] = ACTIONS(711),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(713),
    [anon_sym_get] = ACTIONS(713),
    [anon_sym_set] = ACTIONS(713),
  },
  [90] = {
    [sym_import] = STATE(393),
    [sym_statement_block] = STATE(562),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(393),
    [sym_yield_expression] = STATE(393),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(393),
    [sym_jsx_fragment] = STATE(393),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(393),
    [sym_class] = STATE(393),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(393),
    [sym_arrow_function] = STATE(393),
    [sym_call_expression] = STATE(393),
    [sym_new_expression] = STATE(393),
    [sym_await_expression] = STATE(393),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(393),
    [sym_augmented_assignment_expression] = STATE(393),
    [sym_ternary_expression] = STATE(393),
    [sym_binary_expression] = STATE(393),
    [sym_unary_expression] = STATE(393),
    [sym_update_expression] = STATE(393),
    [sym_string] = STATE(393),
    [sym_template_string] = STATE(393),
    [sym_regex] = STATE(393),
    [sym_meta_property] = STATE(393),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(715),
    [sym_this] = ACTIONS(717),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(717),
    [sym_false] = ACTIONS(717),
    [sym_null] = ACTIONS(717),
    [sym_undefined] = ACTIONS(717),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [91] = {
    [sym_import] = STATE(349),
    [sym_statement_block] = STATE(380),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(349),
    [sym_yield_expression] = STATE(349),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(349),
    [sym_jsx_fragment] = STATE(349),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(349),
    [sym_class] = STATE(349),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(349),
    [sym_arrow_function] = STATE(349),
    [sym_call_expression] = STATE(349),
    [sym_new_expression] = STATE(349),
    [sym_await_expression] = STATE(349),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(349),
    [sym_augmented_assignment_expression] = STATE(349),
    [sym_ternary_expression] = STATE(349),
    [sym_binary_expression] = STATE(349),
    [sym_unary_expression] = STATE(349),
    [sym_update_expression] = STATE(349),
    [sym_string] = STATE(349),
    [sym_template_string] = STATE(349),
    [sym_regex] = STATE(349),
    [sym_meta_property] = STATE(349),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(685),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(719),
    [sym_this] = ACTIONS(721),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(721),
    [sym_false] = ACTIONS(721),
    [sym_null] = ACTIONS(721),
    [sym_undefined] = ACTIONS(721),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [92] = {
    [sym_import] = STATE(548),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(548),
    [sym_yield_expression] = STATE(548),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(548),
    [sym_jsx_fragment] = STATE(548),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(548),
    [sym_class] = STATE(548),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(548),
    [sym_arrow_function] = STATE(548),
    [sym_call_expression] = STATE(548),
    [sym_new_expression] = STATE(548),
    [sym_await_expression] = STATE(548),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(548),
    [sym_augmented_assignment_expression] = STATE(548),
    [sym_ternary_expression] = STATE(548),
    [sym_binary_expression] = STATE(548),
    [sym_unary_expression] = STATE(548),
    [sym_update_expression] = STATE(548),
    [sym_sequence_expression] = STATE(1078),
    [sym_string] = STATE(548),
    [sym_template_string] = STATE(548),
    [sym_regex] = STATE(548),
    [sym_meta_property] = STATE(548),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(723),
    [sym_this] = ACTIONS(725),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(725),
    [sym_false] = ACTIONS(725),
    [sym_null] = ACTIONS(725),
    [sym_undefined] = ACTIONS(725),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [93] = {
    [sym_import] = STATE(545),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(545),
    [sym_yield_expression] = STATE(545),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(545),
    [sym_jsx_fragment] = STATE(545),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(545),
    [sym_class] = STATE(545),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(545),
    [sym_arrow_function] = STATE(545),
    [sym_call_expression] = STATE(545),
    [sym_new_expression] = STATE(545),
    [sym_await_expression] = STATE(545),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(545),
    [sym_augmented_assignment_expression] = STATE(545),
    [sym_ternary_expression] = STATE(545),
    [sym_binary_expression] = STATE(545),
    [sym_unary_expression] = STATE(545),
    [sym_update_expression] = STATE(545),
    [sym_sequence_expression] = STATE(1111),
    [sym_string] = STATE(545),
    [sym_template_string] = STATE(545),
    [sym_regex] = STATE(545),
    [sym_meta_property] = STATE(545),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(727),
    [sym_this] = ACTIONS(729),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(729),
    [sym_false] = ACTIONS(729),
    [sym_null] = ACTIONS(729),
    [sym_undefined] = ACTIONS(729),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [94] = {
    [sym_import] = STATE(466),
    [sym_parenthesized_expression] = STATE(288),
    [sym__expression] = STATE(576),
    [sym_yield_expression] = STATE(576),
    [sym_object] = STATE(433),
    [sym_array] = STATE(428),
    [sym_jsx_element] = STATE(576),
    [sym_jsx_fragment] = STATE(576),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(576),
    [sym_class] = STATE(466),
    [sym_function] = STATE(365),
    [sym_generator_function] = STATE(466),
    [sym_arrow_function] = STATE(466),
    [sym_call_expression] = STATE(576),
    [sym_new_expression] = STATE(466),
    [sym_await_expression] = STATE(576),
    [sym_member_expression] = STATE(288),
    [sym_subscript_expression] = STATE(288),
    [sym_assignment_expression] = STATE(576),
    [sym_augmented_assignment_expression] = STATE(576),
    [sym_ternary_expression] = STATE(576),
    [sym_binary_expression] = STATE(576),
    [sym_unary_expression] = STATE(576),
    [sym_update_expression] = STATE(576),
    [sym_string] = STATE(466),
    [sym_template_string] = STATE(466),
    [sym_regex] = STATE(466),
    [sym_meta_property] = STATE(466),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(731),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_DOT] = ACTIONS(733),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(735),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(737),
    [sym_this] = ACTIONS(739),
    [sym_super] = ACTIONS(741),
    [sym_true] = ACTIONS(739),
    [sym_false] = ACTIONS(739),
    [sym_null] = ACTIONS(739),
    [sym_undefined] = ACTIONS(739),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(743),
    [anon_sym_get] = ACTIONS(743),
    [anon_sym_set] = ACTIONS(743),
  },
  [95] = {
    [sym_import] = STATE(559),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(559),
    [sym_yield_expression] = STATE(559),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(559),
    [sym_jsx_fragment] = STATE(559),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(559),
    [sym_class] = STATE(559),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(559),
    [sym_arrow_function] = STATE(559),
    [sym_call_expression] = STATE(559),
    [sym_new_expression] = STATE(559),
    [sym_await_expression] = STATE(559),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(559),
    [sym_augmented_assignment_expression] = STATE(559),
    [sym_ternary_expression] = STATE(559),
    [sym_binary_expression] = STATE(559),
    [sym_unary_expression] = STATE(559),
    [sym_update_expression] = STATE(559),
    [sym_sequence_expression] = STATE(1082),
    [sym_string] = STATE(559),
    [sym_template_string] = STATE(559),
    [sym_regex] = STATE(559),
    [sym_meta_property] = STATE(559),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(745),
    [sym_this] = ACTIONS(747),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(747),
    [sym_false] = ACTIONS(747),
    [sym_null] = ACTIONS(747),
    [sym_undefined] = ACTIONS(747),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [96] = {
    [sym_import] = STATE(527),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(527),
    [sym_yield_expression] = STATE(527),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(527),
    [sym_jsx_fragment] = STATE(527),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(527),
    [sym_class] = STATE(527),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(527),
    [sym_arrow_function] = STATE(527),
    [sym_call_expression] = STATE(527),
    [sym_new_expression] = STATE(527),
    [sym_await_expression] = STATE(527),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(527),
    [sym_augmented_assignment_expression] = STATE(527),
    [sym_ternary_expression] = STATE(527),
    [sym_binary_expression] = STATE(527),
    [sym_unary_expression] = STATE(527),
    [sym_update_expression] = STATE(527),
    [sym_sequence_expression] = STATE(1045),
    [sym_string] = STATE(527),
    [sym_template_string] = STATE(527),
    [sym_regex] = STATE(527),
    [sym_meta_property] = STATE(527),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(749),
    [sym_this] = ACTIONS(751),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(751),
    [sym_false] = ACTIONS(751),
    [sym_null] = ACTIONS(751),
    [sym_undefined] = ACTIONS(751),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [97] = {
    [sym_import] = STATE(359),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(359),
    [sym_yield_expression] = STATE(359),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(359),
    [sym_jsx_fragment] = STATE(359),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(359),
    [sym_class] = STATE(359),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(359),
    [sym_arrow_function] = STATE(359),
    [sym_call_expression] = STATE(359),
    [sym_new_expression] = STATE(359),
    [sym_await_expression] = STATE(359),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(359),
    [sym_augmented_assignment_expression] = STATE(359),
    [sym_ternary_expression] = STATE(359),
    [sym_binary_expression] = STATE(359),
    [sym_unary_expression] = STATE(359),
    [sym_update_expression] = STATE(359),
    [sym_sequence_expression] = STATE(808),
    [sym_string] = STATE(359),
    [sym_template_string] = STATE(359),
    [sym_regex] = STATE(359),
    [sym_meta_property] = STATE(359),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(753),
    [sym_this] = ACTIONS(755),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(755),
    [sym_false] = ACTIONS(755),
    [sym_null] = ACTIONS(755),
    [sym_undefined] = ACTIONS(755),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [98] = {
    [sym_import] = STATE(531),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(531),
    [sym_yield_expression] = STATE(531),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(531),
    [sym_jsx_fragment] = STATE(531),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(531),
    [sym_class] = STATE(531),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(531),
    [sym_arrow_function] = STATE(531),
    [sym_call_expression] = STATE(531),
    [sym_new_expression] = STATE(531),
    [sym_await_expression] = STATE(531),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(531),
    [sym_augmented_assignment_expression] = STATE(531),
    [sym_ternary_expression] = STATE(531),
    [sym_binary_expression] = STATE(531),
    [sym_unary_expression] = STATE(531),
    [sym_update_expression] = STATE(531),
    [sym_sequence_expression] = STATE(1071),
    [sym_string] = STATE(531),
    [sym_template_string] = STATE(531),
    [sym_regex] = STATE(531),
    [sym_meta_property] = STATE(531),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(757),
    [sym_this] = ACTIONS(759),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(759),
    [sym_false] = ACTIONS(759),
    [sym_null] = ACTIONS(759),
    [sym_undefined] = ACTIONS(759),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [99] = {
    [sym_import] = STATE(317),
    [sym_statement_block] = STATE(379),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(317),
    [sym_yield_expression] = STATE(317),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(317),
    [sym_jsx_fragment] = STATE(317),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(317),
    [sym_class] = STATE(317),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(317),
    [sym_arrow_function] = STATE(317),
    [sym_call_expression] = STATE(317),
    [sym_new_expression] = STATE(317),
    [sym_await_expression] = STATE(317),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(317),
    [sym_augmented_assignment_expression] = STATE(317),
    [sym_ternary_expression] = STATE(317),
    [sym_binary_expression] = STATE(317),
    [sym_unary_expression] = STATE(317),
    [sym_update_expression] = STATE(317),
    [sym_string] = STATE(317),
    [sym_template_string] = STATE(317),
    [sym_regex] = STATE(317),
    [sym_meta_property] = STATE(317),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(685),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(761),
    [sym_this] = ACTIONS(763),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(763),
    [sym_false] = ACTIONS(763),
    [sym_null] = ACTIONS(763),
    [sym_undefined] = ACTIONS(763),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [100] = {
    [sym_import] = STATE(496),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(496),
    [sym_yield_expression] = STATE(496),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(496),
    [sym_jsx_fragment] = STATE(496),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(496),
    [sym_class] = STATE(496),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(496),
    [sym_arrow_function] = STATE(496),
    [sym_call_expression] = STATE(496),
    [sym_new_expression] = STATE(496),
    [sym_await_expression] = STATE(496),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(496),
    [sym_augmented_assignment_expression] = STATE(496),
    [sym_ternary_expression] = STATE(496),
    [sym_binary_expression] = STATE(496),
    [sym_unary_expression] = STATE(496),
    [sym_update_expression] = STATE(496),
    [sym_sequence_expression] = STATE(1100),
    [sym_string] = STATE(496),
    [sym_template_string] = STATE(496),
    [sym_regex] = STATE(496),
    [sym_meta_property] = STATE(496),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(613),
    [sym_this] = ACTIONS(615),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(615),
    [sym_false] = ACTIONS(615),
    [sym_null] = ACTIONS(615),
    [sym_undefined] = ACTIONS(615),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [101] = {
    [sym_import] = STATE(510),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(510),
    [sym_yield_expression] = STATE(510),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(510),
    [sym_jsx_fragment] = STATE(510),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(510),
    [sym_class] = STATE(510),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(510),
    [sym_arrow_function] = STATE(510),
    [sym_call_expression] = STATE(510),
    [sym_new_expression] = STATE(510),
    [sym_await_expression] = STATE(510),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(510),
    [sym_augmented_assignment_expression] = STATE(510),
    [sym_ternary_expression] = STATE(510),
    [sym_binary_expression] = STATE(510),
    [sym_unary_expression] = STATE(510),
    [sym_update_expression] = STATE(510),
    [sym_sequence_expression] = STATE(1107),
    [sym_string] = STATE(510),
    [sym_template_string] = STATE(510),
    [sym_regex] = STATE(510),
    [sym_meta_property] = STATE(510),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(765),
    [sym_this] = ACTIONS(767),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(767),
    [sym_false] = ACTIONS(767),
    [sym_null] = ACTIONS(767),
    [sym_undefined] = ACTIONS(767),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [102] = {
    [sym_import] = STATE(373),
    [sym_statement_block] = STATE(518),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(373),
    [sym_yield_expression] = STATE(373),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(373),
    [sym_jsx_fragment] = STATE(373),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(373),
    [sym_class] = STATE(373),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(373),
    [sym_arrow_function] = STATE(373),
    [sym_call_expression] = STATE(373),
    [sym_new_expression] = STATE(373),
    [sym_await_expression] = STATE(373),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(373),
    [sym_augmented_assignment_expression] = STATE(373),
    [sym_ternary_expression] = STATE(373),
    [sym_binary_expression] = STATE(373),
    [sym_unary_expression] = STATE(373),
    [sym_update_expression] = STATE(373),
    [sym_string] = STATE(373),
    [sym_template_string] = STATE(373),
    [sym_regex] = STATE(373),
    [sym_meta_property] = STATE(373),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(769),
    [sym_this] = ACTIONS(771),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(771),
    [sym_false] = ACTIONS(771),
    [sym_null] = ACTIONS(771),
    [sym_undefined] = ACTIONS(771),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [103] = {
    [sym_import] = STATE(491),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(491),
    [sym_yield_expression] = STATE(491),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(491),
    [sym_jsx_fragment] = STATE(491),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(491),
    [sym_class] = STATE(491),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(491),
    [sym_arrow_function] = STATE(491),
    [sym_call_expression] = STATE(491),
    [sym_new_expression] = STATE(491),
    [sym_await_expression] = STATE(491),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(491),
    [sym_augmented_assignment_expression] = STATE(491),
    [sym_ternary_expression] = STATE(491),
    [sym_binary_expression] = STATE(491),
    [sym_unary_expression] = STATE(491),
    [sym_update_expression] = STATE(491),
    [sym_sequence_expression] = STATE(941),
    [sym_string] = STATE(491),
    [sym_template_string] = STATE(491),
    [sym_regex] = STATE(491),
    [sym_meta_property] = STATE(491),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(773),
    [sym_this] = ACTIONS(775),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(775),
    [sym_false] = ACTIONS(775),
    [sym_null] = ACTIONS(775),
    [sym_undefined] = ACTIONS(775),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [104] = {
    [sym_import] = STATE(574),
    [sym_variable_declarator] = STATE(790),
    [sym_parenthesized_expression] = STATE(314),
    [sym__expression] = STATE(574),
    [sym_yield_expression] = STATE(574),
    [sym_object] = STATE(378),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(574),
    [sym_jsx_fragment] = STATE(574),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(574),
    [sym_class] = STATE(574),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(574),
    [sym_arrow_function] = STATE(574),
    [sym_call_expression] = STATE(574),
    [sym_new_expression] = STATE(574),
    [sym_await_expression] = STATE(574),
    [sym_member_expression] = STATE(314),
    [sym_subscript_expression] = STATE(314),
    [sym_assignment_expression] = STATE(574),
    [sym_augmented_assignment_expression] = STATE(574),
    [sym_ternary_expression] = STATE(574),
    [sym_binary_expression] = STATE(574),
    [sym_unary_expression] = STATE(574),
    [sym_update_expression] = STATE(574),
    [sym_string] = STATE(574),
    [sym_template_string] = STATE(574),
    [sym_regex] = STATE(574),
    [sym_meta_property] = STATE(574),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(779),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(635),
    [sym_this] = ACTIONS(637),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(637),
    [sym_false] = ACTIONS(637),
    [sym_null] = ACTIONS(637),
    [sym_undefined] = ACTIONS(637),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
  },
  [105] = {
    [sym_import] = STATE(495),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(495),
    [sym_yield_expression] = STATE(495),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(495),
    [sym_jsx_fragment] = STATE(495),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(495),
    [sym_class] = STATE(495),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(495),
    [sym_arrow_function] = STATE(495),
    [sym_call_expression] = STATE(495),
    [sym_new_expression] = STATE(495),
    [sym_await_expression] = STATE(495),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(495),
    [sym_augmented_assignment_expression] = STATE(495),
    [sym_ternary_expression] = STATE(495),
    [sym_binary_expression] = STATE(495),
    [sym_unary_expression] = STATE(495),
    [sym_update_expression] = STATE(495),
    [sym_sequence_expression] = STATE(1114),
    [sym_string] = STATE(495),
    [sym_template_string] = STATE(495),
    [sym_regex] = STATE(495),
    [sym_meta_property] = STATE(495),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(783),
    [sym_this] = ACTIONS(785),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(785),
    [sym_false] = ACTIONS(785),
    [sym_null] = ACTIONS(785),
    [sym_undefined] = ACTIONS(785),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [106] = {
    [sym_import] = STATE(326),
    [sym_statement_block] = STATE(432),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(326),
    [sym_yield_expression] = STATE(326),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(326),
    [sym_jsx_fragment] = STATE(326),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(326),
    [sym_class] = STATE(326),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(326),
    [sym_arrow_function] = STATE(326),
    [sym_call_expression] = STATE(326),
    [sym_new_expression] = STATE(326),
    [sym_await_expression] = STATE(326),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(326),
    [sym_augmented_assignment_expression] = STATE(326),
    [sym_ternary_expression] = STATE(326),
    [sym_binary_expression] = STATE(326),
    [sym_unary_expression] = STATE(326),
    [sym_update_expression] = STATE(326),
    [sym_string] = STATE(326),
    [sym_template_string] = STATE(326),
    [sym_regex] = STATE(326),
    [sym_meta_property] = STATE(326),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(685),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(787),
    [sym_this] = ACTIONS(789),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(789),
    [sym_false] = ACTIONS(789),
    [sym_null] = ACTIONS(789),
    [sym_undefined] = ACTIONS(789),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [107] = {
    [sym_import] = STATE(354),
    [sym_statement_block] = STATE(436),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(354),
    [sym_yield_expression] = STATE(354),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(354),
    [sym_jsx_fragment] = STATE(354),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(354),
    [sym_class] = STATE(354),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(354),
    [sym_arrow_function] = STATE(354),
    [sym_call_expression] = STATE(354),
    [sym_new_expression] = STATE(354),
    [sym_await_expression] = STATE(354),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(354),
    [sym_augmented_assignment_expression] = STATE(354),
    [sym_ternary_expression] = STATE(354),
    [sym_binary_expression] = STATE(354),
    [sym_unary_expression] = STATE(354),
    [sym_update_expression] = STATE(354),
    [sym_string] = STATE(354),
    [sym_template_string] = STATE(354),
    [sym_regex] = STATE(354),
    [sym_meta_property] = STATE(354),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(685),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(791),
    [sym_this] = ACTIONS(793),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(793),
    [sym_false] = ACTIONS(793),
    [sym_null] = ACTIONS(793),
    [sym_undefined] = ACTIONS(793),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [108] = {
    [sym_import] = STATE(355),
    [sym_statement_block] = STATE(439),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(355),
    [sym_yield_expression] = STATE(355),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(355),
    [sym_jsx_fragment] = STATE(355),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(355),
    [sym_class] = STATE(355),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(355),
    [sym_arrow_function] = STATE(355),
    [sym_call_expression] = STATE(355),
    [sym_new_expression] = STATE(355),
    [sym_await_expression] = STATE(355),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(355),
    [sym_augmented_assignment_expression] = STATE(355),
    [sym_ternary_expression] = STATE(355),
    [sym_binary_expression] = STATE(355),
    [sym_unary_expression] = STATE(355),
    [sym_update_expression] = STATE(355),
    [sym_string] = STATE(355),
    [sym_template_string] = STATE(355),
    [sym_regex] = STATE(355),
    [sym_meta_property] = STATE(355),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(685),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(795),
    [sym_this] = ACTIONS(797),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(797),
    [sym_false] = ACTIONS(797),
    [sym_null] = ACTIONS(797),
    [sym_undefined] = ACTIONS(797),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [109] = {
    [sym_import] = STATE(574),
    [sym_variable_declarator] = STATE(794),
    [sym_parenthesized_expression] = STATE(314),
    [sym__expression] = STATE(574),
    [sym_yield_expression] = STATE(574),
    [sym_object] = STATE(378),
    [sym_array] = STATE(376),
    [sym_jsx_element] = STATE(574),
    [sym_jsx_fragment] = STATE(574),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(574),
    [sym_class] = STATE(574),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(574),
    [sym_arrow_function] = STATE(574),
    [sym_call_expression] = STATE(574),
    [sym_new_expression] = STATE(574),
    [sym_await_expression] = STATE(574),
    [sym_member_expression] = STATE(314),
    [sym_subscript_expression] = STATE(314),
    [sym_assignment_expression] = STATE(574),
    [sym_augmented_assignment_expression] = STATE(574),
    [sym_ternary_expression] = STATE(574),
    [sym_binary_expression] = STATE(574),
    [sym_unary_expression] = STATE(574),
    [sym_update_expression] = STATE(574),
    [sym_string] = STATE(574),
    [sym_template_string] = STATE(574),
    [sym_regex] = STATE(574),
    [sym_meta_property] = STATE(574),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(777),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(779),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(635),
    [sym_this] = ACTIONS(637),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(637),
    [sym_false] = ACTIONS(637),
    [sym_null] = ACTIONS(637),
    [sym_undefined] = ACTIONS(637),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
  },
  [110] = {
    [sym_import] = STATE(409),
    [sym_statement_block] = STATE(544),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(409),
    [sym_yield_expression] = STATE(409),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(409),
    [sym_jsx_fragment] = STATE(409),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(409),
    [sym_class] = STATE(409),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(409),
    [sym_arrow_function] = STATE(409),
    [sym_call_expression] = STATE(409),
    [sym_new_expression] = STATE(409),
    [sym_await_expression] = STATE(409),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(409),
    [sym_augmented_assignment_expression] = STATE(409),
    [sym_ternary_expression] = STATE(409),
    [sym_binary_expression] = STATE(409),
    [sym_unary_expression] = STATE(409),
    [sym_update_expression] = STATE(409),
    [sym_string] = STATE(409),
    [sym_template_string] = STATE(409),
    [sym_regex] = STATE(409),
    [sym_meta_property] = STATE(409),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(663),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(799),
    [sym_this] = ACTIONS(801),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(801),
    [sym_false] = ACTIONS(801),
    [sym_null] = ACTIONS(801),
    [sym_undefined] = ACTIONS(801),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [111] = {
    [sym_import] = STATE(512),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(512),
    [sym_yield_expression] = STATE(512),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(512),
    [sym_jsx_fragment] = STATE(512),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(512),
    [sym_class] = STATE(512),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(512),
    [sym_arrow_function] = STATE(512),
    [sym_call_expression] = STATE(512),
    [sym_new_expression] = STATE(512),
    [sym_await_expression] = STATE(512),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(512),
    [sym_augmented_assignment_expression] = STATE(512),
    [sym_ternary_expression] = STATE(512),
    [sym_binary_expression] = STATE(512),
    [sym_unary_expression] = STATE(512),
    [sym_update_expression] = STATE(512),
    [sym_sequence_expression] = STATE(1096),
    [sym_string] = STATE(512),
    [sym_template_string] = STATE(512),
    [sym_regex] = STATE(512),
    [sym_meta_property] = STATE(512),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(803),
    [sym_this] = ACTIONS(805),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(805),
    [sym_false] = ACTIONS(805),
    [sym_null] = ACTIONS(805),
    [sym_undefined] = ACTIONS(805),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [112] = {
    [sym_import] = STATE(470),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(470),
    [sym_yield_expression] = STATE(470),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(470),
    [sym_jsx_fragment] = STATE(470),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(470),
    [sym_class] = STATE(470),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(470),
    [sym_arrow_function] = STATE(470),
    [sym_call_expression] = STATE(470),
    [sym_new_expression] = STATE(470),
    [sym_await_expression] = STATE(470),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(470),
    [sym_augmented_assignment_expression] = STATE(470),
    [sym_ternary_expression] = STATE(470),
    [sym_binary_expression] = STATE(470),
    [sym_unary_expression] = STATE(470),
    [sym_update_expression] = STATE(470),
    [sym_string] = STATE(470),
    [sym_template_string] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_meta_property] = STATE(470),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(807),
    [sym_this] = ACTIONS(809),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(809),
    [sym_false] = ACTIONS(809),
    [sym_null] = ACTIONS(809),
    [sym_undefined] = ACTIONS(809),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [113] = {
    [sym_import] = STATE(327),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(327),
    [sym_yield_expression] = STATE(327),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(327),
    [sym_jsx_fragment] = STATE(327),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(327),
    [sym_class] = STATE(327),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(327),
    [sym_arrow_function] = STATE(327),
    [sym_call_expression] = STATE(327),
    [sym_new_expression] = STATE(327),
    [sym_await_expression] = STATE(327),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(327),
    [sym_augmented_assignment_expression] = STATE(327),
    [sym_ternary_expression] = STATE(327),
    [sym_binary_expression] = STATE(327),
    [sym_unary_expression] = STATE(327),
    [sym_update_expression] = STATE(327),
    [sym_string] = STATE(327),
    [sym_template_string] = STATE(327),
    [sym_regex] = STATE(327),
    [sym_meta_property] = STATE(327),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(811),
    [sym_this] = ACTIONS(813),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(813),
    [sym_false] = ACTIONS(813),
    [sym_null] = ACTIONS(813),
    [sym_undefined] = ACTIONS(813),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [114] = {
    [sym_import] = STATE(570),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(570),
    [sym_yield_expression] = STATE(570),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(570),
    [sym_jsx_fragment] = STATE(570),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(570),
    [sym_class] = STATE(570),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(570),
    [sym_arrow_function] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_new_expression] = STATE(570),
    [sym_await_expression] = STATE(570),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(570),
    [sym_augmented_assignment_expression] = STATE(570),
    [sym_ternary_expression] = STATE(570),
    [sym_binary_expression] = STATE(570),
    [sym_unary_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_string] = STATE(570),
    [sym_template_string] = STATE(570),
    [sym_regex] = STATE(570),
    [sym_meta_property] = STATE(570),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(815),
    [sym_this] = ACTIONS(817),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(817),
    [sym_false] = ACTIONS(817),
    [sym_null] = ACTIONS(817),
    [sym_undefined] = ACTIONS(817),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [115] = {
    [sym_import] = STATE(567),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(567),
    [sym_yield_expression] = STATE(567),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(567),
    [sym_jsx_fragment] = STATE(567),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(567),
    [sym_class] = STATE(567),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(567),
    [sym_arrow_function] = STATE(567),
    [sym_call_expression] = STATE(567),
    [sym_new_expression] = STATE(567),
    [sym_await_expression] = STATE(567),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(567),
    [sym_augmented_assignment_expression] = STATE(567),
    [sym_ternary_expression] = STATE(567),
    [sym_binary_expression] = STATE(567),
    [sym_unary_expression] = STATE(567),
    [sym_update_expression] = STATE(567),
    [sym_string] = STATE(567),
    [sym_template_string] = STATE(567),
    [sym_regex] = STATE(567),
    [sym_meta_property] = STATE(567),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(819),
    [sym_this] = ACTIONS(821),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(821),
    [sym_false] = ACTIONS(821),
    [sym_null] = ACTIONS(821),
    [sym_undefined] = ACTIONS(821),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [116] = {
    [sym_import] = STATE(561),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(561),
    [sym_yield_expression] = STATE(561),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(561),
    [sym_jsx_fragment] = STATE(561),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(561),
    [sym_class] = STATE(561),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(561),
    [sym_arrow_function] = STATE(561),
    [sym_call_expression] = STATE(561),
    [sym_new_expression] = STATE(561),
    [sym_await_expression] = STATE(561),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(561),
    [sym_augmented_assignment_expression] = STATE(561),
    [sym_ternary_expression] = STATE(561),
    [sym_binary_expression] = STATE(561),
    [sym_unary_expression] = STATE(561),
    [sym_update_expression] = STATE(561),
    [sym_string] = STATE(561),
    [sym_template_string] = STATE(561),
    [sym_regex] = STATE(561),
    [sym_meta_property] = STATE(561),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(823),
    [sym_this] = ACTIONS(825),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(825),
    [sym_false] = ACTIONS(825),
    [sym_null] = ACTIONS(825),
    [sym_undefined] = ACTIONS(825),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [117] = {
    [sym_import] = STATE(372),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(372),
    [sym_yield_expression] = STATE(372),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(372),
    [sym_jsx_fragment] = STATE(372),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(372),
    [sym_class] = STATE(372),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(372),
    [sym_arrow_function] = STATE(372),
    [sym_call_expression] = STATE(372),
    [sym_new_expression] = STATE(372),
    [sym_await_expression] = STATE(372),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(372),
    [sym_augmented_assignment_expression] = STATE(372),
    [sym_ternary_expression] = STATE(372),
    [sym_binary_expression] = STATE(372),
    [sym_unary_expression] = STATE(372),
    [sym_update_expression] = STATE(372),
    [sym_string] = STATE(372),
    [sym_template_string] = STATE(372),
    [sym_regex] = STATE(372),
    [sym_meta_property] = STATE(372),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(827),
    [sym_this] = ACTIONS(829),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(829),
    [sym_false] = ACTIONS(829),
    [sym_null] = ACTIONS(829),
    [sym_undefined] = ACTIONS(829),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [118] = {
    [sym_import] = STATE(485),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(485),
    [sym_yield_expression] = STATE(485),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(485),
    [sym_jsx_fragment] = STATE(485),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(485),
    [sym_class] = STATE(485),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(485),
    [sym_arrow_function] = STATE(485),
    [sym_call_expression] = STATE(485),
    [sym_new_expression] = STATE(485),
    [sym_await_expression] = STATE(485),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(485),
    [sym_augmented_assignment_expression] = STATE(485),
    [sym_ternary_expression] = STATE(485),
    [sym_binary_expression] = STATE(485),
    [sym_unary_expression] = STATE(485),
    [sym_update_expression] = STATE(485),
    [sym_string] = STATE(485),
    [sym_template_string] = STATE(485),
    [sym_regex] = STATE(485),
    [sym_meta_property] = STATE(485),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(831),
    [sym_this] = ACTIONS(833),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(833),
    [sym_false] = ACTIONS(833),
    [sym_null] = ACTIONS(833),
    [sym_undefined] = ACTIONS(833),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [119] = {
    [sym_import] = STATE(486),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(486),
    [sym_yield_expression] = STATE(486),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(486),
    [sym_jsx_fragment] = STATE(486),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(486),
    [sym_class] = STATE(486),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(486),
    [sym_arrow_function] = STATE(486),
    [sym_call_expression] = STATE(486),
    [sym_new_expression] = STATE(486),
    [sym_await_expression] = STATE(486),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(486),
    [sym_augmented_assignment_expression] = STATE(486),
    [sym_ternary_expression] = STATE(486),
    [sym_binary_expression] = STATE(486),
    [sym_unary_expression] = STATE(486),
    [sym_update_expression] = STATE(486),
    [sym_string] = STATE(486),
    [sym_template_string] = STATE(486),
    [sym_regex] = STATE(486),
    [sym_meta_property] = STATE(486),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(835),
    [sym_this] = ACTIONS(837),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(837),
    [sym_false] = ACTIONS(837),
    [sym_null] = ACTIONS(837),
    [sym_undefined] = ACTIONS(837),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [120] = {
    [sym_import] = STATE(487),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(487),
    [sym_yield_expression] = STATE(487),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(487),
    [sym_jsx_fragment] = STATE(487),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(487),
    [sym_class] = STATE(487),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(487),
    [sym_arrow_function] = STATE(487),
    [sym_call_expression] = STATE(487),
    [sym_new_expression] = STATE(487),
    [sym_await_expression] = STATE(487),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(487),
    [sym_augmented_assignment_expression] = STATE(487),
    [sym_ternary_expression] = STATE(487),
    [sym_binary_expression] = STATE(487),
    [sym_unary_expression] = STATE(487),
    [sym_update_expression] = STATE(487),
    [sym_string] = STATE(487),
    [sym_template_string] = STATE(487),
    [sym_regex] = STATE(487),
    [sym_meta_property] = STATE(487),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(839),
    [sym_this] = ACTIONS(841),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(841),
    [sym_false] = ACTIONS(841),
    [sym_null] = ACTIONS(841),
    [sym_undefined] = ACTIONS(841),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [121] = {
    [sym_import] = STATE(425),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(425),
    [sym_yield_expression] = STATE(425),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(425),
    [sym_jsx_fragment] = STATE(425),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(425),
    [sym_class] = STATE(425),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(425),
    [sym_arrow_function] = STATE(425),
    [sym_call_expression] = STATE(425),
    [sym_new_expression] = STATE(425),
    [sym_await_expression] = STATE(425),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(425),
    [sym_augmented_assignment_expression] = STATE(425),
    [sym_ternary_expression] = STATE(425),
    [sym_binary_expression] = STATE(425),
    [sym_unary_expression] = STATE(425),
    [sym_update_expression] = STATE(425),
    [sym_string] = STATE(425),
    [sym_template_string] = STATE(425),
    [sym_regex] = STATE(425),
    [sym_meta_property] = STATE(425),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(843),
    [sym_this] = ACTIONS(845),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(845),
    [sym_false] = ACTIONS(845),
    [sym_null] = ACTIONS(845),
    [sym_undefined] = ACTIONS(845),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [122] = {
    [sym_import] = STATE(423),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(423),
    [sym_yield_expression] = STATE(423),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(423),
    [sym_jsx_fragment] = STATE(423),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(423),
    [sym_class] = STATE(423),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(423),
    [sym_arrow_function] = STATE(423),
    [sym_call_expression] = STATE(423),
    [sym_new_expression] = STATE(423),
    [sym_await_expression] = STATE(423),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(423),
    [sym_augmented_assignment_expression] = STATE(423),
    [sym_ternary_expression] = STATE(423),
    [sym_binary_expression] = STATE(423),
    [sym_unary_expression] = STATE(423),
    [sym_update_expression] = STATE(423),
    [sym_string] = STATE(423),
    [sym_template_string] = STATE(423),
    [sym_regex] = STATE(423),
    [sym_meta_property] = STATE(423),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(847),
    [sym_this] = ACTIONS(849),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(849),
    [sym_false] = ACTIONS(849),
    [sym_null] = ACTIONS(849),
    [sym_undefined] = ACTIONS(849),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [123] = {
    [sym_import] = STATE(422),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(422),
    [sym_yield_expression] = STATE(422),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(422),
    [sym_jsx_fragment] = STATE(422),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(422),
    [sym_class] = STATE(422),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(422),
    [sym_arrow_function] = STATE(422),
    [sym_call_expression] = STATE(422),
    [sym_new_expression] = STATE(422),
    [sym_await_expression] = STATE(422),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(422),
    [sym_augmented_assignment_expression] = STATE(422),
    [sym_ternary_expression] = STATE(422),
    [sym_binary_expression] = STATE(422),
    [sym_unary_expression] = STATE(422),
    [sym_update_expression] = STATE(422),
    [sym_string] = STATE(422),
    [sym_template_string] = STATE(422),
    [sym_regex] = STATE(422),
    [sym_meta_property] = STATE(422),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(851),
    [sym_this] = ACTIONS(853),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(853),
    [sym_false] = ACTIONS(853),
    [sym_null] = ACTIONS(853),
    [sym_undefined] = ACTIONS(853),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [124] = {
    [sym_import] = STATE(574),
    [sym_parenthesized_expression] = STATE(314),
    [sym__expression] = STATE(574),
    [sym_yield_expression] = STATE(574),
    [sym_object] = STATE(572),
    [sym_array] = STATE(573),
    [sym_jsx_element] = STATE(574),
    [sym_jsx_fragment] = STATE(574),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(574),
    [sym_class] = STATE(574),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(574),
    [sym_arrow_function] = STATE(574),
    [sym_call_expression] = STATE(574),
    [sym_new_expression] = STATE(574),
    [sym_await_expression] = STATE(574),
    [sym_member_expression] = STATE(314),
    [sym_subscript_expression] = STATE(314),
    [sym_assignment_expression] = STATE(574),
    [sym_augmented_assignment_expression] = STATE(574),
    [sym_ternary_expression] = STATE(574),
    [sym_binary_expression] = STATE(574),
    [sym_unary_expression] = STATE(574),
    [sym_update_expression] = STATE(574),
    [sym_string] = STATE(574),
    [sym_template_string] = STATE(574),
    [sym_regex] = STATE(574),
    [sym_meta_property] = STATE(574),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(855),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(779),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(635),
    [sym_this] = ACTIONS(637),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(637),
    [sym_false] = ACTIONS(637),
    [sym_null] = ACTIONS(637),
    [sym_undefined] = ACTIONS(637),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(781),
    [anon_sym_get] = ACTIONS(781),
    [anon_sym_set] = ACTIONS(781),
  },
  [125] = {
    [sym_import] = STATE(421),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(421),
    [sym_yield_expression] = STATE(421),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(421),
    [sym_jsx_fragment] = STATE(421),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(421),
    [sym_class] = STATE(421),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(421),
    [sym_arrow_function] = STATE(421),
    [sym_call_expression] = STATE(421),
    [sym_new_expression] = STATE(421),
    [sym_await_expression] = STATE(421),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(421),
    [sym_augmented_assignment_expression] = STATE(421),
    [sym_ternary_expression] = STATE(421),
    [sym_binary_expression] = STATE(421),
    [sym_unary_expression] = STATE(421),
    [sym_update_expression] = STATE(421),
    [sym_string] = STATE(421),
    [sym_template_string] = STATE(421),
    [sym_regex] = STATE(421),
    [sym_meta_property] = STATE(421),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(857),
    [sym_this] = ACTIONS(859),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(859),
    [sym_false] = ACTIONS(859),
    [sym_null] = ACTIONS(859),
    [sym_undefined] = ACTIONS(859),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [126] = {
    [sym_import] = STATE(388),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(388),
    [sym_yield_expression] = STATE(388),
    [sym_object] = STATE(566),
    [sym_array] = STATE(568),
    [sym_jsx_element] = STATE(388),
    [sym_jsx_fragment] = STATE(388),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(388),
    [sym_class] = STATE(388),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(388),
    [sym_arrow_function] = STATE(388),
    [sym_call_expression] = STATE(388),
    [sym_new_expression] = STATE(388),
    [sym_await_expression] = STATE(388),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(388),
    [sym_augmented_assignment_expression] = STATE(388),
    [sym_ternary_expression] = STATE(388),
    [sym_binary_expression] = STATE(388),
    [sym_unary_expression] = STATE(388),
    [sym_update_expression] = STATE(388),
    [sym_string] = STATE(388),
    [sym_template_string] = STATE(388),
    [sym_regex] = STATE(388),
    [sym_meta_property] = STATE(388),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(861),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(863),
    [sym_this] = ACTIONS(865),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(865),
    [sym_false] = ACTIONS(865),
    [sym_null] = ACTIONS(865),
    [sym_undefined] = ACTIONS(865),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [127] = {
    [sym_import] = STATE(371),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(371),
    [sym_yield_expression] = STATE(371),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(371),
    [sym_jsx_fragment] = STATE(371),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(371),
    [sym_class] = STATE(371),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(371),
    [sym_arrow_function] = STATE(371),
    [sym_call_expression] = STATE(371),
    [sym_new_expression] = STATE(371),
    [sym_await_expression] = STATE(371),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(371),
    [sym_augmented_assignment_expression] = STATE(371),
    [sym_ternary_expression] = STATE(371),
    [sym_binary_expression] = STATE(371),
    [sym_unary_expression] = STATE(371),
    [sym_update_expression] = STATE(371),
    [sym_string] = STATE(371),
    [sym_template_string] = STATE(371),
    [sym_regex] = STATE(371),
    [sym_meta_property] = STATE(371),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(867),
    [sym_this] = ACTIONS(869),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(869),
    [sym_false] = ACTIONS(869),
    [sym_null] = ACTIONS(869),
    [sym_undefined] = ACTIONS(869),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [128] = {
    [sym_import] = STATE(556),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(556),
    [sym_yield_expression] = STATE(556),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(556),
    [sym_jsx_fragment] = STATE(556),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(556),
    [sym_class] = STATE(556),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(556),
    [sym_arrow_function] = STATE(556),
    [sym_call_expression] = STATE(556),
    [sym_new_expression] = STATE(556),
    [sym_await_expression] = STATE(556),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(556),
    [sym_augmented_assignment_expression] = STATE(556),
    [sym_ternary_expression] = STATE(556),
    [sym_binary_expression] = STATE(556),
    [sym_unary_expression] = STATE(556),
    [sym_update_expression] = STATE(556),
    [sym_string] = STATE(556),
    [sym_template_string] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_meta_property] = STATE(556),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(871),
    [sym_this] = ACTIONS(873),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(873),
    [sym_false] = ACTIONS(873),
    [sym_null] = ACTIONS(873),
    [sym_undefined] = ACTIONS(873),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [129] = {
    [sym_import] = STATE(484),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(484),
    [sym_yield_expression] = STATE(484),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(484),
    [sym_jsx_fragment] = STATE(484),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(484),
    [sym_class] = STATE(484),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(484),
    [sym_arrow_function] = STATE(484),
    [sym_call_expression] = STATE(484),
    [sym_new_expression] = STATE(484),
    [sym_await_expression] = STATE(484),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(484),
    [sym_augmented_assignment_expression] = STATE(484),
    [sym_ternary_expression] = STATE(484),
    [sym_binary_expression] = STATE(484),
    [sym_unary_expression] = STATE(484),
    [sym_update_expression] = STATE(484),
    [sym_string] = STATE(484),
    [sym_template_string] = STATE(484),
    [sym_regex] = STATE(484),
    [sym_meta_property] = STATE(484),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(875),
    [sym_this] = ACTIONS(877),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(877),
    [sym_false] = ACTIONS(877),
    [sym_null] = ACTIONS(877),
    [sym_undefined] = ACTIONS(877),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [130] = {
    [sym_import] = STATE(483),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(483),
    [sym_yield_expression] = STATE(483),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(483),
    [sym_jsx_fragment] = STATE(483),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(483),
    [sym_class] = STATE(483),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(483),
    [sym_arrow_function] = STATE(483),
    [sym_call_expression] = STATE(483),
    [sym_new_expression] = STATE(483),
    [sym_await_expression] = STATE(483),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(483),
    [sym_augmented_assignment_expression] = STATE(483),
    [sym_ternary_expression] = STATE(483),
    [sym_binary_expression] = STATE(483),
    [sym_unary_expression] = STATE(483),
    [sym_update_expression] = STATE(483),
    [sym_string] = STATE(483),
    [sym_template_string] = STATE(483),
    [sym_regex] = STATE(483),
    [sym_meta_property] = STATE(483),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(879),
    [sym_this] = ACTIONS(881),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(881),
    [sym_false] = ACTIONS(881),
    [sym_null] = ACTIONS(881),
    [sym_undefined] = ACTIONS(881),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [131] = {
    [sym_import] = STATE(438),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(438),
    [sym_yield_expression] = STATE(438),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(438),
    [sym_jsx_fragment] = STATE(438),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(438),
    [sym_class] = STATE(438),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(438),
    [sym_arrow_function] = STATE(438),
    [sym_call_expression] = STATE(438),
    [sym_new_expression] = STATE(438),
    [sym_await_expression] = STATE(438),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(438),
    [sym_augmented_assignment_expression] = STATE(438),
    [sym_ternary_expression] = STATE(438),
    [sym_binary_expression] = STATE(438),
    [sym_unary_expression] = STATE(438),
    [sym_update_expression] = STATE(438),
    [sym_string] = STATE(438),
    [sym_template_string] = STATE(438),
    [sym_regex] = STATE(438),
    [sym_meta_property] = STATE(438),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(883),
    [sym_this] = ACTIONS(885),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(885),
    [sym_false] = ACTIONS(885),
    [sym_null] = ACTIONS(885),
    [sym_undefined] = ACTIONS(885),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [132] = {
    [sym_import] = STATE(458),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(458),
    [sym_yield_expression] = STATE(458),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(458),
    [sym_jsx_fragment] = STATE(458),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(458),
    [sym_class] = STATE(458),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(458),
    [sym_arrow_function] = STATE(458),
    [sym_call_expression] = STATE(458),
    [sym_new_expression] = STATE(458),
    [sym_await_expression] = STATE(458),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(458),
    [sym_augmented_assignment_expression] = STATE(458),
    [sym_ternary_expression] = STATE(458),
    [sym_binary_expression] = STATE(458),
    [sym_unary_expression] = STATE(458),
    [sym_update_expression] = STATE(458),
    [sym_string] = STATE(458),
    [sym_template_string] = STATE(458),
    [sym_regex] = STATE(458),
    [sym_meta_property] = STATE(458),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(887),
    [sym_this] = ACTIONS(889),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(889),
    [sym_false] = ACTIONS(889),
    [sym_null] = ACTIONS(889),
    [sym_undefined] = ACTIONS(889),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [133] = {
    [sym_import] = STATE(388),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(388),
    [sym_yield_expression] = STATE(388),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(388),
    [sym_jsx_fragment] = STATE(388),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(388),
    [sym_class] = STATE(388),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(388),
    [sym_arrow_function] = STATE(388),
    [sym_call_expression] = STATE(388),
    [sym_new_expression] = STATE(388),
    [sym_await_expression] = STATE(388),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(388),
    [sym_augmented_assignment_expression] = STATE(388),
    [sym_ternary_expression] = STATE(388),
    [sym_binary_expression] = STATE(388),
    [sym_unary_expression] = STATE(388),
    [sym_update_expression] = STATE(388),
    [sym_string] = STATE(388),
    [sym_template_string] = STATE(388),
    [sym_regex] = STATE(388),
    [sym_meta_property] = STATE(388),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(863),
    [sym_this] = ACTIONS(865),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(865),
    [sym_false] = ACTIONS(865),
    [sym_null] = ACTIONS(865),
    [sym_undefined] = ACTIONS(865),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [134] = {
    [sym_import] = STATE(320),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(320),
    [sym_yield_expression] = STATE(320),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(320),
    [sym_jsx_fragment] = STATE(320),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(320),
    [sym_class] = STATE(320),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(320),
    [sym_arrow_function] = STATE(320),
    [sym_call_expression] = STATE(320),
    [sym_new_expression] = STATE(320),
    [sym_await_expression] = STATE(320),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(320),
    [sym_augmented_assignment_expression] = STATE(320),
    [sym_ternary_expression] = STATE(320),
    [sym_binary_expression] = STATE(320),
    [sym_unary_expression] = STATE(320),
    [sym_update_expression] = STATE(320),
    [sym_string] = STATE(320),
    [sym_template_string] = STATE(320),
    [sym_regex] = STATE(320),
    [sym_meta_property] = STATE(320),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(891),
    [sym_this] = ACTIONS(893),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(893),
    [sym_false] = ACTIONS(893),
    [sym_null] = ACTIONS(893),
    [sym_undefined] = ACTIONS(893),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [135] = {
    [sym_import] = STATE(505),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(505),
    [sym_yield_expression] = STATE(505),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(505),
    [sym_jsx_fragment] = STATE(505),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(505),
    [sym_class] = STATE(505),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(505),
    [sym_arrow_function] = STATE(505),
    [sym_call_expression] = STATE(505),
    [sym_new_expression] = STATE(505),
    [sym_await_expression] = STATE(505),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(505),
    [sym_augmented_assignment_expression] = STATE(505),
    [sym_ternary_expression] = STATE(505),
    [sym_binary_expression] = STATE(505),
    [sym_unary_expression] = STATE(505),
    [sym_update_expression] = STATE(505),
    [sym_string] = STATE(505),
    [sym_template_string] = STATE(505),
    [sym_regex] = STATE(505),
    [sym_meta_property] = STATE(505),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(895),
    [sym_this] = ACTIONS(897),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(897),
    [sym_false] = ACTIONS(897),
    [sym_null] = ACTIONS(897),
    [sym_undefined] = ACTIONS(897),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [136] = {
    [sym_import] = STATE(449),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(449),
    [sym_yield_expression] = STATE(449),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(449),
    [sym_jsx_fragment] = STATE(449),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(449),
    [sym_class] = STATE(449),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(449),
    [sym_arrow_function] = STATE(449),
    [sym_call_expression] = STATE(449),
    [sym_new_expression] = STATE(449),
    [sym_await_expression] = STATE(449),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(449),
    [sym_augmented_assignment_expression] = STATE(449),
    [sym_ternary_expression] = STATE(449),
    [sym_binary_expression] = STATE(449),
    [sym_unary_expression] = STATE(449),
    [sym_update_expression] = STATE(449),
    [sym_string] = STATE(449),
    [sym_template_string] = STATE(449),
    [sym_regex] = STATE(449),
    [sym_meta_property] = STATE(449),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(899),
    [sym_this] = ACTIONS(901),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(901),
    [sym_false] = ACTIONS(901),
    [sym_null] = ACTIONS(901),
    [sym_undefined] = ACTIONS(901),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [137] = {
    [sym_import] = STATE(316),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(316),
    [sym_yield_expression] = STATE(316),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(316),
    [sym_jsx_fragment] = STATE(316),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(316),
    [sym_class] = STATE(316),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(316),
    [sym_arrow_function] = STATE(316),
    [sym_call_expression] = STATE(316),
    [sym_new_expression] = STATE(316),
    [sym_await_expression] = STATE(316),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(316),
    [sym_augmented_assignment_expression] = STATE(316),
    [sym_ternary_expression] = STATE(316),
    [sym_binary_expression] = STATE(316),
    [sym_unary_expression] = STATE(316),
    [sym_update_expression] = STATE(316),
    [sym_string] = STATE(316),
    [sym_template_string] = STATE(316),
    [sym_regex] = STATE(316),
    [sym_meta_property] = STATE(316),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(903),
    [sym_this] = ACTIONS(905),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(905),
    [sym_false] = ACTIONS(905),
    [sym_null] = ACTIONS(905),
    [sym_undefined] = ACTIONS(905),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [138] = {
    [sym_import] = STATE(337),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(337),
    [sym_yield_expression] = STATE(337),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(337),
    [sym_jsx_fragment] = STATE(337),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(337),
    [sym_class] = STATE(337),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(337),
    [sym_arrow_function] = STATE(337),
    [sym_call_expression] = STATE(337),
    [sym_new_expression] = STATE(337),
    [sym_await_expression] = STATE(337),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(337),
    [sym_augmented_assignment_expression] = STATE(337),
    [sym_ternary_expression] = STATE(337),
    [sym_binary_expression] = STATE(337),
    [sym_unary_expression] = STATE(337),
    [sym_update_expression] = STATE(337),
    [sym_string] = STATE(337),
    [sym_template_string] = STATE(337),
    [sym_regex] = STATE(337),
    [sym_meta_property] = STATE(337),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(907),
    [sym_this] = ACTIONS(909),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(909),
    [sym_false] = ACTIONS(909),
    [sym_null] = ACTIONS(909),
    [sym_undefined] = ACTIONS(909),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [139] = {
    [sym_import] = STATE(456),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(456),
    [sym_yield_expression] = STATE(456),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(456),
    [sym_jsx_fragment] = STATE(456),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(456),
    [sym_class] = STATE(456),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(456),
    [sym_arrow_function] = STATE(456),
    [sym_call_expression] = STATE(456),
    [sym_new_expression] = STATE(456),
    [sym_await_expression] = STATE(456),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(456),
    [sym_augmented_assignment_expression] = STATE(456),
    [sym_ternary_expression] = STATE(456),
    [sym_binary_expression] = STATE(456),
    [sym_unary_expression] = STATE(456),
    [sym_update_expression] = STATE(456),
    [sym_string] = STATE(456),
    [sym_template_string] = STATE(456),
    [sym_regex] = STATE(456),
    [sym_meta_property] = STATE(456),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(911),
    [sym_this] = ACTIONS(913),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(913),
    [sym_false] = ACTIONS(913),
    [sym_null] = ACTIONS(913),
    [sym_undefined] = ACTIONS(913),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [140] = {
    [sym_import] = STATE(453),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(453),
    [sym_yield_expression] = STATE(453),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(453),
    [sym_jsx_fragment] = STATE(453),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(453),
    [sym_class] = STATE(453),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(453),
    [sym_arrow_function] = STATE(453),
    [sym_call_expression] = STATE(453),
    [sym_new_expression] = STATE(453),
    [sym_await_expression] = STATE(453),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(453),
    [sym_augmented_assignment_expression] = STATE(453),
    [sym_ternary_expression] = STATE(453),
    [sym_binary_expression] = STATE(453),
    [sym_unary_expression] = STATE(453),
    [sym_update_expression] = STATE(453),
    [sym_string] = STATE(453),
    [sym_template_string] = STATE(453),
    [sym_regex] = STATE(453),
    [sym_meta_property] = STATE(453),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(915),
    [sym_this] = ACTIONS(917),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(917),
    [sym_false] = ACTIONS(917),
    [sym_null] = ACTIONS(917),
    [sym_undefined] = ACTIONS(917),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [141] = {
    [sym_import] = STATE(451),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(451),
    [sym_yield_expression] = STATE(451),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(451),
    [sym_jsx_fragment] = STATE(451),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(451),
    [sym_class] = STATE(451),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(451),
    [sym_arrow_function] = STATE(451),
    [sym_call_expression] = STATE(451),
    [sym_new_expression] = STATE(451),
    [sym_await_expression] = STATE(451),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(451),
    [sym_augmented_assignment_expression] = STATE(451),
    [sym_ternary_expression] = STATE(451),
    [sym_binary_expression] = STATE(451),
    [sym_unary_expression] = STATE(451),
    [sym_update_expression] = STATE(451),
    [sym_string] = STATE(451),
    [sym_template_string] = STATE(451),
    [sym_regex] = STATE(451),
    [sym_meta_property] = STATE(451),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(919),
    [sym_this] = ACTIONS(921),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(921),
    [sym_false] = ACTIONS(921),
    [sym_null] = ACTIONS(921),
    [sym_undefined] = ACTIONS(921),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [142] = {
    [sym_import] = STATE(390),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(390),
    [sym_yield_expression] = STATE(390),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(390),
    [sym_jsx_fragment] = STATE(390),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(390),
    [sym_class] = STATE(390),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(390),
    [sym_arrow_function] = STATE(390),
    [sym_call_expression] = STATE(390),
    [sym_new_expression] = STATE(390),
    [sym_await_expression] = STATE(390),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(390),
    [sym_augmented_assignment_expression] = STATE(390),
    [sym_ternary_expression] = STATE(390),
    [sym_binary_expression] = STATE(390),
    [sym_unary_expression] = STATE(390),
    [sym_update_expression] = STATE(390),
    [sym_string] = STATE(390),
    [sym_template_string] = STATE(390),
    [sym_regex] = STATE(390),
    [sym_meta_property] = STATE(390),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(923),
    [sym_this] = ACTIONS(925),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(925),
    [sym_false] = ACTIONS(925),
    [sym_null] = ACTIONS(925),
    [sym_undefined] = ACTIONS(925),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [143] = {
    [sym_import] = STATE(328),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(328),
    [sym_yield_expression] = STATE(328),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(328),
    [sym_jsx_fragment] = STATE(328),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(328),
    [sym_class] = STATE(328),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(328),
    [sym_arrow_function] = STATE(328),
    [sym_call_expression] = STATE(328),
    [sym_new_expression] = STATE(328),
    [sym_await_expression] = STATE(328),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(328),
    [sym_augmented_assignment_expression] = STATE(328),
    [sym_ternary_expression] = STATE(328),
    [sym_binary_expression] = STATE(328),
    [sym_unary_expression] = STATE(328),
    [sym_update_expression] = STATE(328),
    [sym_string] = STATE(328),
    [sym_template_string] = STATE(328),
    [sym_regex] = STATE(328),
    [sym_meta_property] = STATE(328),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(927),
    [sym_this] = ACTIONS(929),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(929),
    [sym_false] = ACTIONS(929),
    [sym_null] = ACTIONS(929),
    [sym_undefined] = ACTIONS(929),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [144] = {
    [sym_import] = STATE(564),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(564),
    [sym_yield_expression] = STATE(564),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(564),
    [sym_jsx_fragment] = STATE(564),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(564),
    [sym_class] = STATE(564),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(564),
    [sym_arrow_function] = STATE(564),
    [sym_call_expression] = STATE(564),
    [sym_new_expression] = STATE(564),
    [sym_await_expression] = STATE(564),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(564),
    [sym_augmented_assignment_expression] = STATE(564),
    [sym_ternary_expression] = STATE(564),
    [sym_binary_expression] = STATE(564),
    [sym_unary_expression] = STATE(564),
    [sym_update_expression] = STATE(564),
    [sym_string] = STATE(564),
    [sym_template_string] = STATE(564),
    [sym_regex] = STATE(564),
    [sym_meta_property] = STATE(564),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(931),
    [sym_this] = ACTIONS(933),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(933),
    [sym_false] = ACTIONS(933),
    [sym_null] = ACTIONS(933),
    [sym_undefined] = ACTIONS(933),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [145] = {
    [sym_import] = STATE(416),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(416),
    [sym_yield_expression] = STATE(416),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(416),
    [sym_jsx_fragment] = STATE(416),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(416),
    [sym_class] = STATE(416),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(416),
    [sym_arrow_function] = STATE(416),
    [sym_call_expression] = STATE(416),
    [sym_new_expression] = STATE(416),
    [sym_await_expression] = STATE(416),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(416),
    [sym_augmented_assignment_expression] = STATE(416),
    [sym_ternary_expression] = STATE(416),
    [sym_binary_expression] = STATE(416),
    [sym_unary_expression] = STATE(416),
    [sym_update_expression] = STATE(416),
    [sym_string] = STATE(416),
    [sym_template_string] = STATE(416),
    [sym_regex] = STATE(416),
    [sym_meta_property] = STATE(416),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(935),
    [sym_this] = ACTIONS(937),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(937),
    [sym_false] = ACTIONS(937),
    [sym_null] = ACTIONS(937),
    [sym_undefined] = ACTIONS(937),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [146] = {
    [sym_import] = STATE(394),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(394),
    [sym_yield_expression] = STATE(394),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(394),
    [sym_jsx_fragment] = STATE(394),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(394),
    [sym_class] = STATE(394),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(394),
    [sym_arrow_function] = STATE(394),
    [sym_call_expression] = STATE(394),
    [sym_new_expression] = STATE(394),
    [sym_await_expression] = STATE(394),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(394),
    [sym_augmented_assignment_expression] = STATE(394),
    [sym_ternary_expression] = STATE(394),
    [sym_binary_expression] = STATE(394),
    [sym_unary_expression] = STATE(394),
    [sym_update_expression] = STATE(394),
    [sym_string] = STATE(394),
    [sym_template_string] = STATE(394),
    [sym_regex] = STATE(394),
    [sym_meta_property] = STATE(394),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(939),
    [sym_this] = ACTIONS(941),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(941),
    [sym_false] = ACTIONS(941),
    [sym_null] = ACTIONS(941),
    [sym_undefined] = ACTIONS(941),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [147] = {
    [sym_import] = STATE(415),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(415),
    [sym_yield_expression] = STATE(415),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(415),
    [sym_jsx_fragment] = STATE(415),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(415),
    [sym_class] = STATE(415),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(415),
    [sym_arrow_function] = STATE(415),
    [sym_call_expression] = STATE(415),
    [sym_new_expression] = STATE(415),
    [sym_await_expression] = STATE(415),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(415),
    [sym_augmented_assignment_expression] = STATE(415),
    [sym_ternary_expression] = STATE(415),
    [sym_binary_expression] = STATE(415),
    [sym_unary_expression] = STATE(415),
    [sym_update_expression] = STATE(415),
    [sym_string] = STATE(415),
    [sym_template_string] = STATE(415),
    [sym_regex] = STATE(415),
    [sym_meta_property] = STATE(415),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(943),
    [sym_this] = ACTIONS(945),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(945),
    [sym_false] = ACTIONS(945),
    [sym_null] = ACTIONS(945),
    [sym_undefined] = ACTIONS(945),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [148] = {
    [sym_import] = STATE(565),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(565),
    [sym_jsx_fragment] = STATE(565),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(565),
    [sym_class] = STATE(565),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(565),
    [sym_arrow_function] = STATE(565),
    [sym_call_expression] = STATE(565),
    [sym_new_expression] = STATE(565),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(565),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_string] = STATE(565),
    [sym_template_string] = STATE(565),
    [sym_regex] = STATE(565),
    [sym_meta_property] = STATE(565),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(947),
    [sym_this] = ACTIONS(949),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(949),
    [sym_false] = ACTIONS(949),
    [sym_null] = ACTIONS(949),
    [sym_undefined] = ACTIONS(949),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [149] = {
    [sym_import] = STATE(336),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(336),
    [sym_yield_expression] = STATE(336),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(336),
    [sym_jsx_fragment] = STATE(336),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(336),
    [sym_class] = STATE(336),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(336),
    [sym_arrow_function] = STATE(336),
    [sym_call_expression] = STATE(336),
    [sym_new_expression] = STATE(336),
    [sym_await_expression] = STATE(336),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(336),
    [sym_augmented_assignment_expression] = STATE(336),
    [sym_ternary_expression] = STATE(336),
    [sym_binary_expression] = STATE(336),
    [sym_unary_expression] = STATE(336),
    [sym_update_expression] = STATE(336),
    [sym_string] = STATE(336),
    [sym_template_string] = STATE(336),
    [sym_regex] = STATE(336),
    [sym_meta_property] = STATE(336),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(951),
    [sym_this] = ACTIONS(953),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(953),
    [sym_false] = ACTIONS(953),
    [sym_null] = ACTIONS(953),
    [sym_undefined] = ACTIONS(953),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [150] = {
    [sym_import] = STATE(368),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(368),
    [sym_yield_expression] = STATE(368),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(368),
    [sym_jsx_fragment] = STATE(368),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(368),
    [sym_class] = STATE(368),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(368),
    [sym_arrow_function] = STATE(368),
    [sym_call_expression] = STATE(368),
    [sym_new_expression] = STATE(368),
    [sym_await_expression] = STATE(368),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(368),
    [sym_augmented_assignment_expression] = STATE(368),
    [sym_ternary_expression] = STATE(368),
    [sym_binary_expression] = STATE(368),
    [sym_unary_expression] = STATE(368),
    [sym_update_expression] = STATE(368),
    [sym_string] = STATE(368),
    [sym_template_string] = STATE(368),
    [sym_regex] = STATE(368),
    [sym_meta_property] = STATE(368),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(955),
    [sym_this] = ACTIONS(957),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(957),
    [sym_false] = ACTIONS(957),
    [sym_null] = ACTIONS(957),
    [sym_undefined] = ACTIONS(957),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [151] = {
    [sym_import] = STATE(345),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(345),
    [sym_yield_expression] = STATE(345),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(345),
    [sym_jsx_fragment] = STATE(345),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(345),
    [sym_class] = STATE(345),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(345),
    [sym_arrow_function] = STATE(345),
    [sym_call_expression] = STATE(345),
    [sym_new_expression] = STATE(345),
    [sym_await_expression] = STATE(345),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(345),
    [sym_augmented_assignment_expression] = STATE(345),
    [sym_ternary_expression] = STATE(345),
    [sym_binary_expression] = STATE(345),
    [sym_unary_expression] = STATE(345),
    [sym_update_expression] = STATE(345),
    [sym_string] = STATE(345),
    [sym_template_string] = STATE(345),
    [sym_regex] = STATE(345),
    [sym_meta_property] = STATE(345),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(959),
    [sym_this] = ACTIONS(961),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(961),
    [sym_false] = ACTIONS(961),
    [sym_null] = ACTIONS(961),
    [sym_undefined] = ACTIONS(961),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [152] = {
    [sym_import] = STATE(339),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(339),
    [sym_yield_expression] = STATE(339),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(339),
    [sym_jsx_fragment] = STATE(339),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(339),
    [sym_class] = STATE(339),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(339),
    [sym_arrow_function] = STATE(339),
    [sym_call_expression] = STATE(339),
    [sym_new_expression] = STATE(339),
    [sym_await_expression] = STATE(339),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(339),
    [sym_augmented_assignment_expression] = STATE(339),
    [sym_ternary_expression] = STATE(339),
    [sym_binary_expression] = STATE(339),
    [sym_unary_expression] = STATE(339),
    [sym_update_expression] = STATE(339),
    [sym_string] = STATE(339),
    [sym_template_string] = STATE(339),
    [sym_regex] = STATE(339),
    [sym_meta_property] = STATE(339),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(963),
    [sym_this] = ACTIONS(965),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(965),
    [sym_false] = ACTIONS(965),
    [sym_null] = ACTIONS(965),
    [sym_undefined] = ACTIONS(965),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [153] = {
    [sym_import] = STATE(343),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(343),
    [sym_yield_expression] = STATE(343),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(343),
    [sym_jsx_fragment] = STATE(343),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(343),
    [sym_class] = STATE(343),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(343),
    [sym_arrow_function] = STATE(343),
    [sym_call_expression] = STATE(343),
    [sym_new_expression] = STATE(343),
    [sym_await_expression] = STATE(343),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(343),
    [sym_augmented_assignment_expression] = STATE(343),
    [sym_ternary_expression] = STATE(343),
    [sym_binary_expression] = STATE(343),
    [sym_unary_expression] = STATE(343),
    [sym_update_expression] = STATE(343),
    [sym_string] = STATE(343),
    [sym_template_string] = STATE(343),
    [sym_regex] = STATE(343),
    [sym_meta_property] = STATE(343),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(967),
    [sym_this] = ACTIONS(969),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(969),
    [sym_false] = ACTIONS(969),
    [sym_null] = ACTIONS(969),
    [sym_undefined] = ACTIONS(969),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [154] = {
    [sym_import] = STATE(342),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(342),
    [sym_yield_expression] = STATE(342),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(342),
    [sym_jsx_fragment] = STATE(342),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(342),
    [sym_class] = STATE(342),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(342),
    [sym_arrow_function] = STATE(342),
    [sym_call_expression] = STATE(342),
    [sym_new_expression] = STATE(342),
    [sym_await_expression] = STATE(342),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(342),
    [sym_augmented_assignment_expression] = STATE(342),
    [sym_ternary_expression] = STATE(342),
    [sym_binary_expression] = STATE(342),
    [sym_unary_expression] = STATE(342),
    [sym_update_expression] = STATE(342),
    [sym_string] = STATE(342),
    [sym_template_string] = STATE(342),
    [sym_regex] = STATE(342),
    [sym_meta_property] = STATE(342),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(971),
    [sym_this] = ACTIONS(973),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(973),
    [sym_false] = ACTIONS(973),
    [sym_null] = ACTIONS(973),
    [sym_undefined] = ACTIONS(973),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [155] = {
    [sym_import] = STATE(374),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(374),
    [sym_yield_expression] = STATE(374),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(374),
    [sym_jsx_fragment] = STATE(374),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(374),
    [sym_class] = STATE(374),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(374),
    [sym_arrow_function] = STATE(374),
    [sym_call_expression] = STATE(374),
    [sym_new_expression] = STATE(374),
    [sym_await_expression] = STATE(374),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(374),
    [sym_augmented_assignment_expression] = STATE(374),
    [sym_ternary_expression] = STATE(374),
    [sym_binary_expression] = STATE(374),
    [sym_unary_expression] = STATE(374),
    [sym_update_expression] = STATE(374),
    [sym_string] = STATE(374),
    [sym_template_string] = STATE(374),
    [sym_regex] = STATE(374),
    [sym_meta_property] = STATE(374),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(975),
    [sym_this] = ACTIONS(977),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(977),
    [sym_false] = ACTIONS(977),
    [sym_null] = ACTIONS(977),
    [sym_undefined] = ACTIONS(977),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [156] = {
    [sym_import] = STATE(500),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(500),
    [sym_yield_expression] = STATE(500),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(500),
    [sym_jsx_fragment] = STATE(500),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(500),
    [sym_class] = STATE(500),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(500),
    [sym_arrow_function] = STATE(500),
    [sym_call_expression] = STATE(500),
    [sym_new_expression] = STATE(500),
    [sym_await_expression] = STATE(500),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(500),
    [sym_augmented_assignment_expression] = STATE(500),
    [sym_ternary_expression] = STATE(500),
    [sym_binary_expression] = STATE(500),
    [sym_unary_expression] = STATE(500),
    [sym_update_expression] = STATE(500),
    [sym_string] = STATE(500),
    [sym_template_string] = STATE(500),
    [sym_regex] = STATE(500),
    [sym_meta_property] = STATE(500),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(979),
    [sym_this] = ACTIONS(981),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(981),
    [sym_false] = ACTIONS(981),
    [sym_null] = ACTIONS(981),
    [sym_undefined] = ACTIONS(981),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [157] = {
    [sym_import] = STATE(405),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(405),
    [sym_yield_expression] = STATE(405),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(405),
    [sym_jsx_fragment] = STATE(405),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(405),
    [sym_class] = STATE(405),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(405),
    [sym_arrow_function] = STATE(405),
    [sym_call_expression] = STATE(405),
    [sym_new_expression] = STATE(405),
    [sym_await_expression] = STATE(405),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(405),
    [sym_augmented_assignment_expression] = STATE(405),
    [sym_ternary_expression] = STATE(405),
    [sym_binary_expression] = STATE(405),
    [sym_unary_expression] = STATE(405),
    [sym_update_expression] = STATE(405),
    [sym_string] = STATE(405),
    [sym_template_string] = STATE(405),
    [sym_regex] = STATE(405),
    [sym_meta_property] = STATE(405),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(983),
    [sym_this] = ACTIONS(985),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(985),
    [sym_false] = ACTIONS(985),
    [sym_null] = ACTIONS(985),
    [sym_undefined] = ACTIONS(985),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [158] = {
    [sym_import] = STATE(499),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(499),
    [sym_yield_expression] = STATE(499),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(499),
    [sym_jsx_fragment] = STATE(499),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(499),
    [sym_class] = STATE(499),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(499),
    [sym_arrow_function] = STATE(499),
    [sym_call_expression] = STATE(499),
    [sym_new_expression] = STATE(499),
    [sym_await_expression] = STATE(499),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(499),
    [sym_augmented_assignment_expression] = STATE(499),
    [sym_ternary_expression] = STATE(499),
    [sym_binary_expression] = STATE(499),
    [sym_unary_expression] = STATE(499),
    [sym_update_expression] = STATE(499),
    [sym_string] = STATE(499),
    [sym_template_string] = STATE(499),
    [sym_regex] = STATE(499),
    [sym_meta_property] = STATE(499),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(987),
    [sym_this] = ACTIONS(989),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(989),
    [sym_false] = ACTIONS(989),
    [sym_null] = ACTIONS(989),
    [sym_undefined] = ACTIONS(989),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [159] = {
    [sym_import] = STATE(498),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(498),
    [sym_yield_expression] = STATE(498),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(498),
    [sym_jsx_fragment] = STATE(498),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(498),
    [sym_class] = STATE(498),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(498),
    [sym_arrow_function] = STATE(498),
    [sym_call_expression] = STATE(498),
    [sym_new_expression] = STATE(498),
    [sym_await_expression] = STATE(498),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(498),
    [sym_augmented_assignment_expression] = STATE(498),
    [sym_ternary_expression] = STATE(498),
    [sym_binary_expression] = STATE(498),
    [sym_unary_expression] = STATE(498),
    [sym_update_expression] = STATE(498),
    [sym_string] = STATE(498),
    [sym_template_string] = STATE(498),
    [sym_regex] = STATE(498),
    [sym_meta_property] = STATE(498),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(991),
    [sym_this] = ACTIONS(993),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(993),
    [sym_false] = ACTIONS(993),
    [sym_null] = ACTIONS(993),
    [sym_undefined] = ACTIONS(993),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [160] = {
    [sym_import] = STATE(497),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(497),
    [sym_yield_expression] = STATE(497),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(497),
    [sym_jsx_fragment] = STATE(497),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(497),
    [sym_class] = STATE(497),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(497),
    [sym_arrow_function] = STATE(497),
    [sym_call_expression] = STATE(497),
    [sym_new_expression] = STATE(497),
    [sym_await_expression] = STATE(497),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(497),
    [sym_augmented_assignment_expression] = STATE(497),
    [sym_ternary_expression] = STATE(497),
    [sym_binary_expression] = STATE(497),
    [sym_unary_expression] = STATE(497),
    [sym_update_expression] = STATE(497),
    [sym_string] = STATE(497),
    [sym_template_string] = STATE(497),
    [sym_regex] = STATE(497),
    [sym_meta_property] = STATE(497),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(995),
    [sym_this] = ACTIONS(997),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(997),
    [sym_false] = ACTIONS(997),
    [sym_null] = ACTIONS(997),
    [sym_undefined] = ACTIONS(997),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [161] = {
    [sym_import] = STATE(321),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(321),
    [sym_yield_expression] = STATE(321),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(321),
    [sym_jsx_fragment] = STATE(321),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(321),
    [sym_class] = STATE(321),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(321),
    [sym_arrow_function] = STATE(321),
    [sym_call_expression] = STATE(321),
    [sym_new_expression] = STATE(321),
    [sym_await_expression] = STATE(321),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(321),
    [sym_augmented_assignment_expression] = STATE(321),
    [sym_ternary_expression] = STATE(321),
    [sym_binary_expression] = STATE(321),
    [sym_unary_expression] = STATE(321),
    [sym_update_expression] = STATE(321),
    [sym_string] = STATE(321),
    [sym_template_string] = STATE(321),
    [sym_regex] = STATE(321),
    [sym_meta_property] = STATE(321),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(999),
    [sym_this] = ACTIONS(1001),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(1001),
    [sym_false] = ACTIONS(1001),
    [sym_null] = ACTIONS(1001),
    [sym_undefined] = ACTIONS(1001),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [162] = {
    [sym_import] = STATE(408),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(408),
    [sym_yield_expression] = STATE(408),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(408),
    [sym_jsx_fragment] = STATE(408),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(408),
    [sym_class] = STATE(408),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(408),
    [sym_arrow_function] = STATE(408),
    [sym_call_expression] = STATE(408),
    [sym_new_expression] = STATE(408),
    [sym_await_expression] = STATE(408),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(408),
    [sym_augmented_assignment_expression] = STATE(408),
    [sym_ternary_expression] = STATE(408),
    [sym_binary_expression] = STATE(408),
    [sym_unary_expression] = STATE(408),
    [sym_update_expression] = STATE(408),
    [sym_string] = STATE(408),
    [sym_template_string] = STATE(408),
    [sym_regex] = STATE(408),
    [sym_meta_property] = STATE(408),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(1003),
    [sym_this] = ACTIONS(1005),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(1005),
    [sym_false] = ACTIONS(1005),
    [sym_null] = ACTIONS(1005),
    [sym_undefined] = ACTIONS(1005),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [163] = {
    [sym_import] = STATE(569),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(569),
    [sym_yield_expression] = STATE(569),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(569),
    [sym_jsx_fragment] = STATE(569),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(569),
    [sym_class] = STATE(569),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(569),
    [sym_arrow_function] = STATE(569),
    [sym_call_expression] = STATE(569),
    [sym_new_expression] = STATE(569),
    [sym_await_expression] = STATE(569),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(569),
    [sym_augmented_assignment_expression] = STATE(569),
    [sym_ternary_expression] = STATE(569),
    [sym_binary_expression] = STATE(569),
    [sym_unary_expression] = STATE(569),
    [sym_update_expression] = STATE(569),
    [sym_string] = STATE(569),
    [sym_template_string] = STATE(569),
    [sym_regex] = STATE(569),
    [sym_meta_property] = STATE(569),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(1007),
    [sym_this] = ACTIONS(1009),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(1009),
    [sym_false] = ACTIONS(1009),
    [sym_null] = ACTIONS(1009),
    [sym_undefined] = ACTIONS(1009),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [164] = {
    [sym_import] = STATE(410),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(410),
    [sym_yield_expression] = STATE(410),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(410),
    [sym_jsx_fragment] = STATE(410),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(410),
    [sym_class] = STATE(410),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(410),
    [sym_arrow_function] = STATE(410),
    [sym_call_expression] = STATE(410),
    [sym_new_expression] = STATE(410),
    [sym_await_expression] = STATE(410),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(410),
    [sym_augmented_assignment_expression] = STATE(410),
    [sym_ternary_expression] = STATE(410),
    [sym_binary_expression] = STATE(410),
    [sym_unary_expression] = STATE(410),
    [sym_update_expression] = STATE(410),
    [sym_string] = STATE(410),
    [sym_template_string] = STATE(410),
    [sym_regex] = STATE(410),
    [sym_meta_property] = STATE(410),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(1011),
    [sym_this] = ACTIONS(1013),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(1013),
    [sym_false] = ACTIONS(1013),
    [sym_null] = ACTIONS(1013),
    [sym_undefined] = ACTIONS(1013),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [165] = {
    [sym_import] = STATE(411),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(411),
    [sym_yield_expression] = STATE(411),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(411),
    [sym_jsx_fragment] = STATE(411),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(411),
    [sym_class] = STATE(411),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(411),
    [sym_arrow_function] = STATE(411),
    [sym_call_expression] = STATE(411),
    [sym_new_expression] = STATE(411),
    [sym_await_expression] = STATE(411),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(411),
    [sym_augmented_assignment_expression] = STATE(411),
    [sym_ternary_expression] = STATE(411),
    [sym_binary_expression] = STATE(411),
    [sym_unary_expression] = STATE(411),
    [sym_update_expression] = STATE(411),
    [sym_string] = STATE(411),
    [sym_template_string] = STATE(411),
    [sym_regex] = STATE(411),
    [sym_meta_property] = STATE(411),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(1015),
    [sym_this] = ACTIONS(1017),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(1017),
    [sym_false] = ACTIONS(1017),
    [sym_null] = ACTIONS(1017),
    [sym_undefined] = ACTIONS(1017),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [166] = {
    [sym_import] = STATE(412),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(412),
    [sym_yield_expression] = STATE(412),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(412),
    [sym_jsx_fragment] = STATE(412),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(412),
    [sym_class] = STATE(412),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(412),
    [sym_arrow_function] = STATE(412),
    [sym_call_expression] = STATE(412),
    [sym_new_expression] = STATE(412),
    [sym_await_expression] = STATE(412),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(412),
    [sym_augmented_assignment_expression] = STATE(412),
    [sym_ternary_expression] = STATE(412),
    [sym_binary_expression] = STATE(412),
    [sym_unary_expression] = STATE(412),
    [sym_update_expression] = STATE(412),
    [sym_string] = STATE(412),
    [sym_template_string] = STATE(412),
    [sym_regex] = STATE(412),
    [sym_meta_property] = STATE(412),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(1019),
    [sym_this] = ACTIONS(1021),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(1021),
    [sym_false] = ACTIONS(1021),
    [sym_null] = ACTIONS(1021),
    [sym_undefined] = ACTIONS(1021),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [167] = {
    [sym_import] = STATE(413),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(413),
    [sym_yield_expression] = STATE(413),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(413),
    [sym_jsx_fragment] = STATE(413),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(413),
    [sym_class] = STATE(413),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(413),
    [sym_arrow_function] = STATE(413),
    [sym_call_expression] = STATE(413),
    [sym_new_expression] = STATE(413),
    [sym_await_expression] = STATE(413),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(413),
    [sym_augmented_assignment_expression] = STATE(413),
    [sym_ternary_expression] = STATE(413),
    [sym_binary_expression] = STATE(413),
    [sym_unary_expression] = STATE(413),
    [sym_update_expression] = STATE(413),
    [sym_string] = STATE(413),
    [sym_template_string] = STATE(413),
    [sym_regex] = STATE(413),
    [sym_meta_property] = STATE(413),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(1023),
    [sym_this] = ACTIONS(1025),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(1025),
    [sym_false] = ACTIONS(1025),
    [sym_null] = ACTIONS(1025),
    [sym_undefined] = ACTIONS(1025),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [168] = {
    [sym_import] = STATE(353),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(353),
    [sym_yield_expression] = STATE(353),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(353),
    [sym_jsx_fragment] = STATE(353),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(353),
    [sym_class] = STATE(353),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(353),
    [sym_arrow_function] = STATE(353),
    [sym_call_expression] = STATE(353),
    [sym_new_expression] = STATE(353),
    [sym_await_expression] = STATE(353),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(353),
    [sym_augmented_assignment_expression] = STATE(353),
    [sym_ternary_expression] = STATE(353),
    [sym_binary_expression] = STATE(353),
    [sym_unary_expression] = STATE(353),
    [sym_update_expression] = STATE(353),
    [sym_string] = STATE(353),
    [sym_template_string] = STATE(353),
    [sym_regex] = STATE(353),
    [sym_meta_property] = STATE(353),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(1027),
    [sym_this] = ACTIONS(1029),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(1029),
    [sym_false] = ACTIONS(1029),
    [sym_null] = ACTIONS(1029),
    [sym_undefined] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [169] = {
    [sym_import] = STATE(329),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(329),
    [sym_yield_expression] = STATE(329),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(329),
    [sym_jsx_fragment] = STATE(329),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(329),
    [sym_class] = STATE(329),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(329),
    [sym_arrow_function] = STATE(329),
    [sym_call_expression] = STATE(329),
    [sym_new_expression] = STATE(329),
    [sym_await_expression] = STATE(329),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(329),
    [sym_augmented_assignment_expression] = STATE(329),
    [sym_ternary_expression] = STATE(329),
    [sym_binary_expression] = STATE(329),
    [sym_unary_expression] = STATE(329),
    [sym_update_expression] = STATE(329),
    [sym_string] = STATE(329),
    [sym_template_string] = STATE(329),
    [sym_regex] = STATE(329),
    [sym_meta_property] = STATE(329),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(1031),
    [sym_this] = ACTIONS(1033),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(1033),
    [sym_false] = ACTIONS(1033),
    [sym_null] = ACTIONS(1033),
    [sym_undefined] = ACTIONS(1033),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [170] = {
    [sym_import] = STATE(325),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(325),
    [sym_yield_expression] = STATE(325),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(325),
    [sym_jsx_fragment] = STATE(325),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(325),
    [sym_class] = STATE(325),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(325),
    [sym_arrow_function] = STATE(325),
    [sym_call_expression] = STATE(325),
    [sym_new_expression] = STATE(325),
    [sym_await_expression] = STATE(325),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(325),
    [sym_augmented_assignment_expression] = STATE(325),
    [sym_ternary_expression] = STATE(325),
    [sym_binary_expression] = STATE(325),
    [sym_unary_expression] = STATE(325),
    [sym_update_expression] = STATE(325),
    [sym_string] = STATE(325),
    [sym_template_string] = STATE(325),
    [sym_regex] = STATE(325),
    [sym_meta_property] = STATE(325),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(1035),
    [sym_this] = ACTIONS(1037),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(1037),
    [sym_false] = ACTIONS(1037),
    [sym_null] = ACTIONS(1037),
    [sym_undefined] = ACTIONS(1037),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [171] = {
    [sym_import] = STATE(346),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(346),
    [sym_yield_expression] = STATE(346),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(346),
    [sym_jsx_fragment] = STATE(346),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(346),
    [sym_class] = STATE(346),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(346),
    [sym_arrow_function] = STATE(346),
    [sym_call_expression] = STATE(346),
    [sym_new_expression] = STATE(346),
    [sym_await_expression] = STATE(346),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(346),
    [sym_augmented_assignment_expression] = STATE(346),
    [sym_ternary_expression] = STATE(346),
    [sym_binary_expression] = STATE(346),
    [sym_unary_expression] = STATE(346),
    [sym_update_expression] = STATE(346),
    [sym_string] = STATE(346),
    [sym_template_string] = STATE(346),
    [sym_regex] = STATE(346),
    [sym_meta_property] = STATE(346),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(1039),
    [sym_this] = ACTIONS(1041),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(1041),
    [sym_false] = ACTIONS(1041),
    [sym_null] = ACTIONS(1041),
    [sym_undefined] = ACTIONS(1041),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [172] = {
    [sym_import] = STATE(330),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(330),
    [sym_yield_expression] = STATE(330),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(330),
    [sym_jsx_fragment] = STATE(330),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(330),
    [sym_class] = STATE(330),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(330),
    [sym_arrow_function] = STATE(330),
    [sym_call_expression] = STATE(330),
    [sym_new_expression] = STATE(330),
    [sym_await_expression] = STATE(330),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(330),
    [sym_augmented_assignment_expression] = STATE(330),
    [sym_ternary_expression] = STATE(330),
    [sym_binary_expression] = STATE(330),
    [sym_unary_expression] = STATE(330),
    [sym_update_expression] = STATE(330),
    [sym_string] = STATE(330),
    [sym_template_string] = STATE(330),
    [sym_regex] = STATE(330),
    [sym_meta_property] = STATE(330),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(1043),
    [sym_this] = ACTIONS(1045),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(1045),
    [sym_false] = ACTIONS(1045),
    [sym_null] = ACTIONS(1045),
    [sym_undefined] = ACTIONS(1045),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [173] = {
    [sym_import] = STATE(319),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(319),
    [sym_yield_expression] = STATE(319),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(319),
    [sym_jsx_fragment] = STATE(319),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(319),
    [sym_class] = STATE(319),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(319),
    [sym_arrow_function] = STATE(319),
    [sym_call_expression] = STATE(319),
    [sym_new_expression] = STATE(319),
    [sym_await_expression] = STATE(319),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(319),
    [sym_augmented_assignment_expression] = STATE(319),
    [sym_ternary_expression] = STATE(319),
    [sym_binary_expression] = STATE(319),
    [sym_unary_expression] = STATE(319),
    [sym_update_expression] = STATE(319),
    [sym_string] = STATE(319),
    [sym_template_string] = STATE(319),
    [sym_regex] = STATE(319),
    [sym_meta_property] = STATE(319),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(1047),
    [sym_this] = ACTIONS(1049),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(1049),
    [sym_false] = ACTIONS(1049),
    [sym_null] = ACTIONS(1049),
    [sym_undefined] = ACTIONS(1049),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [174] = {
    [sym_import] = STATE(352),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(352),
    [sym_yield_expression] = STATE(352),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(352),
    [sym_jsx_fragment] = STATE(352),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(352),
    [sym_class] = STATE(352),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(352),
    [sym_arrow_function] = STATE(352),
    [sym_call_expression] = STATE(352),
    [sym_new_expression] = STATE(352),
    [sym_await_expression] = STATE(352),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(352),
    [sym_augmented_assignment_expression] = STATE(352),
    [sym_ternary_expression] = STATE(352),
    [sym_binary_expression] = STATE(352),
    [sym_unary_expression] = STATE(352),
    [sym_update_expression] = STATE(352),
    [sym_string] = STATE(352),
    [sym_template_string] = STATE(352),
    [sym_regex] = STATE(352),
    [sym_meta_property] = STATE(352),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(1051),
    [sym_this] = ACTIONS(1053),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(1053),
    [sym_false] = ACTIONS(1053),
    [sym_null] = ACTIONS(1053),
    [sym_undefined] = ACTIONS(1053),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [175] = {
    [sym_import] = STATE(351),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(351),
    [sym_yield_expression] = STATE(351),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(351),
    [sym_jsx_fragment] = STATE(351),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(351),
    [sym_class] = STATE(351),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(351),
    [sym_arrow_function] = STATE(351),
    [sym_call_expression] = STATE(351),
    [sym_new_expression] = STATE(351),
    [sym_await_expression] = STATE(351),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(351),
    [sym_augmented_assignment_expression] = STATE(351),
    [sym_ternary_expression] = STATE(351),
    [sym_binary_expression] = STATE(351),
    [sym_unary_expression] = STATE(351),
    [sym_update_expression] = STATE(351),
    [sym_string] = STATE(351),
    [sym_template_string] = STATE(351),
    [sym_regex] = STATE(351),
    [sym_meta_property] = STATE(351),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(1055),
    [sym_this] = ACTIONS(1057),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(1057),
    [sym_false] = ACTIONS(1057),
    [sym_null] = ACTIONS(1057),
    [sym_undefined] = ACTIONS(1057),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [176] = {
    [sym_import] = STATE(414),
    [sym_parenthesized_expression] = STATE(305),
    [sym__expression] = STATE(414),
    [sym_yield_expression] = STATE(414),
    [sym_object] = STATE(480),
    [sym_array] = STATE(482),
    [sym_jsx_element] = STATE(414),
    [sym_jsx_fragment] = STATE(414),
    [sym_jsx_opening_element] = STATE(659),
    [sym_jsx_self_closing_element] = STATE(414),
    [sym_class] = STATE(414),
    [sym_function] = STATE(403),
    [sym_generator_function] = STATE(414),
    [sym_arrow_function] = STATE(414),
    [sym_call_expression] = STATE(414),
    [sym_new_expression] = STATE(414),
    [sym_await_expression] = STATE(414),
    [sym_member_expression] = STATE(305),
    [sym_subscript_expression] = STATE(305),
    [sym_assignment_expression] = STATE(414),
    [sym_augmented_assignment_expression] = STATE(414),
    [sym_ternary_expression] = STATE(414),
    [sym_binary_expression] = STATE(414),
    [sym_unary_expression] = STATE(414),
    [sym_update_expression] = STATE(414),
    [sym_string] = STATE(414),
    [sym_template_string] = STATE(414),
    [sym_regex] = STATE(414),
    [sym_meta_property] = STATE(414),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1110),
    [aux_sym_export_statement_repeat1] = STATE(791),
    [sym_identifier] = ACTIONS(413),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_import] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_await] = ACTIONS(29),
    [anon_sym_yield] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LT] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(57),
    [anon_sym_class] = ACTIONS(423),
    [anon_sym_async] = ACTIONS(425),
    [anon_sym_function] = ACTIONS(427),
    [anon_sym_new] = ACTIONS(65),
    [anon_sym_PLUS] = ACTIONS(67),
    [anon_sym_DASH] = ACTIONS(67),
    [anon_sym_BANG] = ACTIONS(69),
    [anon_sym_TILDE] = ACTIONS(69),
    [anon_sym_typeof] = ACTIONS(71),
    [anon_sym_void] = ACTIONS(71),
    [anon_sym_delete] = ACTIONS(71),
    [anon_sym_PLUS_PLUS] = ACTIONS(73),
    [anon_sym_DASH_DASH] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(75),
    [anon_sym_SQUOTE] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(79),
    [sym_number] = ACTIONS(1059),
    [sym_this] = ACTIONS(1061),
    [sym_super] = ACTIONS(85),
    [sym_true] = ACTIONS(1061),
    [sym_false] = ACTIONS(1061),
    [sym_null] = ACTIONS(1061),
    [sym_undefined] = ACTIONS(1061),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(435),
    [anon_sym_get] = ACTIONS(435),
    [anon_sym_set] = ACTIONS(435),
  },
  [177] = {
    [sym_import] = STATE(332),
    [sym_parenthesized_expression] = STATE(284),
    [sym__expression] = STATE(332),
    [sym_yield_expression] = STATE(332),
    [sym_object] = STATE(360),
    [sym_array] = STATE(362),
    [sym_jsx_element] = STATE(332),
    [sym_jsx_fragment] = STATE(332),
    [sym_jsx_opening_element] = STATE(671),
    [sym_jsx_self_closing_element] = STATE(332),
    [sym_class] = STATE(332),
    [sym_function] = STATE(344),
    [sym_generator_function] = STATE(332),
    [sym_arrow_function] = STATE(332),
    [sym_call_expression] = STATE(332),
    [sym_new_expression] = STATE(332),
    [sym_await_expression] = STATE(332),
    [sym_member_expression] = STATE(284),
    [sym_subscript_expression] = STATE(284),
    [sym_assignment_expression] = STATE(332),
    [sym_augmented_assignment_expression] = STATE(332),
    [sym_ternary_expression] = STATE(332),
    [sym_binary_expression] = STATE(332),
    [sym_unary_expression] = STATE(332),
    [sym_update_expression] = STATE(332),
    [sym_string] = STATE(332),
    [sym_template_string] = STATE(332),
    [sym_regex] = STATE(332),
    [sym_meta_property] = STATE(332),
    [sym_decorator] = STATE(635),
    [sym_formal_parameters] = STATE(1121),
    [aux_sym_export_statement_repeat1] = STATE(807),
    [sym_identifier] = ACTIONS(357),
    [anon_sym_LBRACE] = ACTIONS(361),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_LPAREN] = ACTIONS(367),
    [anon_sym_await] = ACTIONS(369),
    [anon_sym_yield] = ACTIONS(373),
    [anon_sym_LBRACK] = ACTIONS(375),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(379),
    [anon_sym_class] = ACTIONS(381),
    [anon_sym_async] = ACTIONS(383),
    [anon_sym_function] = ACTIONS(385),
    [anon_sym_new] = ACTIONS(387),
    [anon_sym_PLUS] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(393),
    [anon_sym_TILDE] = ACTIONS(393),
    [anon_sym_typeof] = ACTIONS(395),
    [anon_sym_void] = ACTIONS(395),
    [anon_sym_delete] = ACTIONS(395),
    [anon_sym_PLUS_PLUS] = ACTIONS(397),
    [anon_sym_DASH_DASH] = ACTIONS(397),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_number] = ACTIONS(1063),
    [sym_this] = ACTIONS(1065),
    [sym_super] = ACTIONS(409),
    [sym_true] = ACTIONS(1065),
    [sym_false] = ACTIONS(1065),
    [sym_null] = ACTIONS(1065),
    [sym_undefined] = ACTIONS(1065),
    [anon_sym_AT] = ACTIONS(87),
    [anon_sym_static] = ACTIONS(411),
    [anon_sym_get] = ACTIONS(411),
    [anon_sym_set] = ACTIONS(411),
  },
  [178] = {
    [sym_string] = STATE(1015),
    [sym_formal_parameters] = STATE(1126),
    [sym__property_name] = STATE(1015),
    [sym_computed_property_name] = STATE(1015),
    [aux_sym_object_repeat1] = STATE(838),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_COMMA] = ACTIONS(1072),
    [anon_sym_RBRACE] = ACTIONS(1074),
    [anon_sym_LPAREN] = ACTIONS(1076),
    [anon_sym_in] = ACTIONS(1080),
    [anon_sym_SEMI] = ACTIONS(1072),
    [anon_sym_COLON] = ACTIONS(1082),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_LBRACK] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1080),
    [anon_sym_GT] = ACTIONS(1080),
    [anon_sym_SLASH] = ACTIONS(1080),
    [anon_sym_DOT] = ACTIONS(1090),
    [anon_sym_async] = ACTIONS(1092),
    [anon_sym_function] = ACTIONS(1094),
    [anon_sym_EQ_GT] = ACTIONS(1096),
    [anon_sym_PLUS_EQ] = ACTIONS(1098),
    [anon_sym_DASH_EQ] = ACTIONS(1098),
    [anon_sym_STAR_EQ] = ACTIONS(1098),
    [anon_sym_SLASH_EQ] = ACTIONS(1098),
    [anon_sym_PERCENT_EQ] = ACTIONS(1098),
    [anon_sym_CARET_EQ] = ACTIONS(1098),
    [anon_sym_AMP_EQ] = ACTIONS(1098),
    [anon_sym_PIPE_EQ] = ACTIONS(1098),
    [anon_sym_GT_GT_EQ] = ACTIONS(1098),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1098),
    [anon_sym_LT_LT_EQ] = ACTIONS(1098),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(1080),
    [anon_sym_AMP_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1080),
    [anon_sym_GT_GT_GT] = ACTIONS(1080),
    [anon_sym_LT_LT] = ACTIONS(1080),
    [anon_sym_AMP] = ACTIONS(1080),
    [anon_sym_CARET] = ACTIONS(1080),
    [anon_sym_PIPE] = ACTIONS(1080),
    [anon_sym_PLUS] = ACTIONS(1080),
    [anon_sym_DASH] = ACTIONS(1080),
    [anon_sym_PERCENT] = ACTIONS(1080),
    [anon_sym_STAR_STAR] = ACTIONS(1080),
    [anon_sym_LT_EQ] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1072),
    [anon_sym_BANG_EQ] = ACTIONS(1080),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1072),
    [anon_sym_GT_EQ] = ACTIONS(1072),
    [anon_sym_QMARK_QMARK] = ACTIONS(1072),
    [anon_sym_instanceof] = ACTIONS(1080),
    [anon_sym_PLUS_PLUS] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [sym_number] = ACTIONS(1100),
    [anon_sym_static] = ACTIONS(1092),
    [anon_sym_get] = ACTIONS(1102),
    [anon_sym_set] = ACTIONS(1102),
    [sym__automatic_semicolon] = ACTIONS(1072),
  },
  [179] = {
    [sym_string] = STATE(1015),
    [sym_formal_parameters] = STATE(1126),
    [sym__property_name] = STATE(1015),
    [sym_computed_property_name] = STATE(1015),
    [aux_sym_object_repeat1] = STATE(870),
    [sym_identifier] = ACTIONS(1067),
    [anon_sym_STAR] = ACTIONS(1069),
    [anon_sym_COMMA] = ACTIONS(1072),
    [anon_sym_RBRACE] = ACTIONS(1104),
    [anon_sym_LPAREN] = ACTIONS(1076),
    [anon_sym_in] = ACTIONS(1080),
    [anon_sym_SEMI] = ACTIONS(1072),
    [anon_sym_COLON] = ACTIONS(1082),
    [anon_sym_EQ] = ACTIONS(1085),
    [anon_sym_LBRACK] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1080),
    [anon_sym_GT] = ACTIONS(1080),
    [anon_sym_SLASH] = ACTIONS(1080),
    [anon_sym_DOT] = ACTIONS(1090),
    [anon_sym_async] = ACTIONS(1092),
    [anon_sym_function] = ACTIONS(1094),
    [anon_sym_EQ_GT] = ACTIONS(1096),
    [anon_sym_PLUS_EQ] = ACTIONS(1098),
    [anon_sym_DASH_EQ] = ACTIONS(1098),
    [anon_sym_STAR_EQ] = ACTIONS(1098),
    [anon_sym_SLASH_EQ] = ACTIONS(1098),
    [anon_sym_PERCENT_EQ] = ACTIONS(1098),
    [anon_sym_CARET_EQ] = ACTIONS(1098),
    [anon_sym_AMP_EQ] = ACTIONS(1098),
    [anon_sym_PIPE_EQ] = ACTIONS(1098),
    [anon_sym_GT_GT_EQ] = ACTIONS(1098),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1098),
    [anon_sym_LT_LT_EQ] = ACTIONS(1098),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1098),
    [anon_sym_QMARK] = ACTIONS(1080),
    [anon_sym_AMP_AMP] = ACTIONS(1072),
    [anon_sym_PIPE_PIPE] = ACTIONS(1072),
    [anon_sym_GT_GT] = ACTIONS(1080),
    [anon_sym_GT_GT_GT] = ACTIONS(1080),
    [anon_sym_LT_LT] = ACTIONS(1080),
    [anon_sym_AMP] = ACTIONS(1080),
    [anon_sym_CARET] = ACTIONS(1080),
    [anon_sym_PIPE] = ACTIONS(1080),
    [anon_sym_PLUS] = ACTIONS(1080),
    [anon_sym_DASH] = ACTIONS(1080),
    [anon_sym_PERCENT] = ACTIONS(1080),
    [anon_sym_STAR_STAR] = ACTIONS(1080),
    [anon_sym_LT_EQ] = ACTIONS(1072),
    [anon_sym_EQ_EQ] = ACTIONS(1080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1072),
    [anon_sym_BANG_EQ] = ACTIONS(1080),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1072),
    [anon_sym_GT_EQ] = ACTIONS(1072),
    [anon_sym_QMARK_QMARK] = ACTIONS(1072),
    [anon_sym_instanceof] = ACTIONS(1080),
    [anon_sym_PLUS_PLUS] = ACTIONS(1072),
    [anon_sym_DASH_DASH] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(399),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(1072),
    [sym_number] = ACTIONS(1100),
    [anon_sym_static] = ACTIONS(1092),
    [anon_sym_get] = ACTIONS(1102),
    [anon_sym_set] = ACTIONS(1102),
    [sym__automatic_semicolon] = ACTIONS(1072),
  },
  [180] = {
    [ts_builtin_sym_end] = ACTIONS(437),
    [sym_identifier] = ACTIONS(439),
    [anon_sym_export] = ACTIONS(439),
    [anon_sym_STAR] = ACTIONS(437),
    [anon_sym_default] = ACTIONS(439),
    [anon_sym_LBRACE] = ACTIONS(437),
    [anon_sym_COMMA] = ACTIONS(437),
    [anon_sym_RBRACE] = ACTIONS(437),
    [anon_sym_import] = ACTIONS(439),
    [anon_sym_var] = ACTIONS(439),
    [anon_sym_let] = ACTIONS(439),
    [anon_sym_const] = ACTIONS(439),
    [anon_sym_if] = ACTIONS(439),
    [anon_sym_else] = ACTIONS(439),
    [anon_sym_switch] = ACTIONS(439),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_LPAREN] = ACTIONS(437),
    [anon_sym_await] = ACTIONS(439),
    [anon_sym_while] = ACTIONS(439),
    [anon_sym_do] = ACTIONS(439),
    [anon_sym_try] = ACTIONS(439),
    [anon_sym_with] = ACTIONS(439),
    [anon_sym_break] = ACTIONS(439),
    [anon_sym_continue] = ACTIONS(439),
    [anon_sym_debugger] = ACTIONS(439),
    [anon_sym_return] = ACTIONS(439),
    [anon_sym_throw] = ACTIONS(439),
    [anon_sym_SEMI] = ACTIONS(437),
    [anon_sym_case] = ACTIONS(439),
    [anon_sym_catch] = ACTIONS(439),
    [anon_sym_finally] = ACTIONS(439),
    [anon_sym_yield] = ACTIONS(439),
    [anon_sym_LBRACK] = ACTIONS(437),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_SLASH] = ACTIONS(439),
    [anon_sym_class] = ACTIONS(439),
    [anon_sym_async] = ACTIONS(439),
    [anon_sym_function] = ACTIONS(439),
    [anon_sym_new] = ACTIONS(439),
    [anon_sym_PLUS] = ACTIONS(439),
    [anon_sym_DASH] = ACTIONS(439),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_TILDE] = ACTIONS(437),
    [anon_sym_typeof] = ACTIONS(439),
    [anon_sym_void] = ACTIONS(439),
    [anon_sym_delete] = ACTIONS(439),
    [anon_sym_PLUS_PLUS] = ACTIONS(437),
    [anon_sym_DASH_DASH] = ACTIONS(437),
    [anon_sym_DQUOTE] = ACTIONS(437),
    [anon_sym_SQUOTE] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(437),
    [sym_number] = ACTIONS(437),
    [sym_this] = ACTIONS(439),
    [sym_super] = ACTIONS(439),
    [sym_true] = ACTIONS(439),
    [sym_false] = ACTIONS(439),
    [sym_null] = ACTIONS(439),
    [sym_undefined] = ACTIONS(439),
    [anon_sym_AT] = ACTIONS(437),
    [anon_sym_static] = ACTIONS(439),
    [anon_sym_get] = ACTIONS(439),
    [anon_sym_set] = ACTIONS(439),
    [sym_preproc] = ACTIONS(437),
    [sym__automatic_semicolon] = ACTIONS(445),
  },
  [181] = {
    [ts_builtin_sym_end] = ACTIONS(539),
    [sym_identifier] = ACTIONS(541),
    [anon_sym_export] = ACTIONS(541),
    [anon_sym_STAR] = ACTIONS(539),
    [anon_sym_default] = ACTIONS(541),
    [anon_sym_LBRACE] = ACTIONS(539),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_RBRACE] = ACTIONS(539),
    [anon_sym_import] = ACTIONS(541),
    [anon_sym_var] = ACTIONS(541),
    [anon_sym_let] = ACTIONS(541),
    [anon_sym_const] = ACTIONS(541),
    [anon_sym_if] = ACTIONS(541),
    [anon_sym_else] = ACTIONS(541),
    [anon_sym_switch] = ACTIONS(541),
    [anon_sym_for] = ACTIONS(541),
    [anon_sym_LPAREN] = ACTIONS(539),
    [anon_sym_await] = ACTIONS(541),
    [anon_sym_while] = ACTIONS(541),
    [anon_sym_do] = ACTIONS(541),
    [anon_sym_try] = ACTIONS(541),
    [anon_sym_with] = ACTIONS(541),
    [anon_sym_break] = ACTIONS(541),
    [anon_sym_continue] = ACTIONS(541),
    [anon_sym_debugger] = ACTIONS(541),
    [anon_sym_return] = ACTIONS(541),
    [anon_sym_throw] = ACTIONS(541),
    [anon_sym_SEMI] = ACTIONS(539),
    [anon_sym_case] = ACTIONS(541),
    [anon_sym_catch] = ACTIONS(541),
    [anon_sym_finally] = ACTIONS(541),
    [anon_sym_yield] = ACTIONS(541),
    [anon_sym_LBRACK] = ACTIONS(539),
    [anon_sym_LT] = ACTIONS(539),
    [anon_sym_SLASH] = ACTIONS(541),
    [anon_sym_class] = ACTIONS(541),
    [anon_sym_async] = ACTIONS(541),
    [anon_sym_function] = ACTIONS(541),
    [anon_sym_new] = ACTIONS(541),
    [anon_sym_PLUS] = ACTIONS(541),
    [anon_sym_DASH] = ACTIONS(541),
    [anon_sym_BANG] = ACTIONS(539),
    [anon_sym_TILDE] = ACTIONS(539),
    [anon_sym_typeof] = ACTIONS(541),
    [anon_sym_void] = ACTIONS(541),
    [anon_sym_delete] = ACTIONS(541),
    [anon_sym_PLUS_PLUS] = ACTIONS(539),
    [anon_sym_DASH_DASH] = ACTIONS(539),
    [anon_sym_DQUOTE] = ACTIONS(539),
    [anon_sym_SQUOTE] = ACTIONS(539),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(539),
    [sym_number] = ACTIONS(539),
    [sym_this] = ACTIONS(541),
    [sym_super] = ACTIONS(541),
    [sym_true] = ACTIONS(541),
    [sym_false] = ACTIONS(541),
    [sym_null] = ACTIONS(541),
    [sym_undefined] = ACTIONS(541),
    [anon_sym_AT] = ACTIONS(539),
    [anon_sym_static] = ACTIONS(541),
    [anon_sym_get] = ACTIONS(541),
    [anon_sym_set] = ACTIONS(541),
    [sym_preproc] = ACTIONS(539),
    [sym__automatic_semicolon] = ACTIONS(1106),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(1069), 1,
      anon_sym_STAR,
    ACTIONS(1082), 1,
      anon_sym_COLON,
    ACTIONS(1085), 1,
      anon_sym_EQ,
    ACTIONS(1087), 1,
      anon_sym_LBRACK,
    ACTIONS(1090), 1,
      anon_sym_DOT,
    ACTIONS(1096), 1,
      anon_sym_EQ_GT,
    ACTIONS(1100), 1,
      sym_number,
    ACTIONS(1104), 1,
      anon_sym_RBRACE,
    ACTIONS(1110), 1,
      anon_sym_LPAREN,
    ACTIONS(1113), 1,
      anon_sym_async,
    STATE(870), 1,
      aux_sym_object_repeat1,
    ACTIONS(1108), 2,
      sym_identifier,
      anon_sym_static,
    ACTIONS(1115), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1098), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1072), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1080), 18,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
  [105] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(1082), 1,
      anon_sym_COLON,
    ACTIONS(1085), 1,
      anon_sym_EQ,
    ACTIONS(1087), 1,
      anon_sym_LBRACK,
    ACTIONS(1090), 1,
      anon_sym_DOT,
    ACTIONS(1096), 1,
      anon_sym_EQ_GT,
    ACTIONS(1100), 1,
      sym_number,
    ACTIONS(1104), 1,
      anon_sym_RBRACE,
    ACTIONS(1110), 1,
      anon_sym_LPAREN,
    STATE(870), 1,
      aux_sym_object_repeat1,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1108), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1098), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1072), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1080), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
  [204] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(539), 19,
      ts_builtin_sym_end,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(541), 44,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [275] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1121), 1,
      anon_sym_catch,
    ACTIONS(1123), 1,
      anon_sym_finally,
    STATE(189), 1,
      sym_catch_clause,
    STATE(232), 1,
      sym_finally_clause,
    ACTIONS(1117), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1119), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 19,
      ts_builtin_sym_end,
      anon_sym_STAR,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(527), 44,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_catch,
      anon_sym_finally,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [425] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(1074), 1,
      anon_sym_RBRACE,
    ACTIONS(1082), 1,
      anon_sym_COLON,
    ACTIONS(1085), 1,
      anon_sym_EQ,
    ACTIONS(1087), 1,
      anon_sym_LBRACK,
    ACTIONS(1090), 1,
      anon_sym_DOT,
    ACTIONS(1096), 1,
      anon_sym_EQ_GT,
    ACTIONS(1100), 1,
      sym_number,
    ACTIONS(1110), 1,
      anon_sym_LPAREN,
    STATE(838), 1,
      aux_sym_object_repeat1,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1108), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1098), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1072), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1080), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
  [524] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(1069), 1,
      anon_sym_STAR,
    ACTIONS(1074), 1,
      anon_sym_RBRACE,
    ACTIONS(1082), 1,
      anon_sym_COLON,
    ACTIONS(1085), 1,
      anon_sym_EQ,
    ACTIONS(1087), 1,
      anon_sym_LBRACK,
    ACTIONS(1090), 1,
      anon_sym_DOT,
    ACTIONS(1096), 1,
      anon_sym_EQ_GT,
    ACTIONS(1100), 1,
      sym_number,
    ACTIONS(1110), 1,
      anon_sym_LPAREN,
    ACTIONS(1113), 1,
      anon_sym_async,
    STATE(838), 1,
      aux_sym_object_repeat1,
    ACTIONS(1108), 2,
      sym_identifier,
      anon_sym_static,
    ACTIONS(1115), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1098), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1072), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1080), 18,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
  [629] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1123), 1,
      anon_sym_finally,
    STATE(234), 1,
      sym_finally_clause,
    ACTIONS(1125), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1127), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(525), 18,
      sym__automatic_semicolon,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(527), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [770] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      sym__automatic_semicolon,
    ACTIONS(467), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(469), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [840] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      sym__automatic_semicolon,
    ACTIONS(457), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(459), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(455), 1,
      sym__automatic_semicolon,
    ACTIONS(447), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(449), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1129), 1,
      sym__automatic_semicolon,
    ACTIONS(539), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(541), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1050] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(485), 1,
      sym__automatic_semicolon,
    ACTIONS(477), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(479), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1131), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1133), 43,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_finally,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1188] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1135), 1,
      sym_identifier,
    ACTIONS(1141), 1,
      anon_sym_EQ,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_function,
    ACTIONS(1149), 1,
      anon_sym_EQ_GT,
    STATE(407), 1,
      sym_arguments,
    STATE(1099), 1,
      sym_formal_parameters,
    ACTIONS(1145), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1151), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1139), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1137), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
  [1274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(537), 1,
      sym__automatic_semicolon,
    ACTIONS(529), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(531), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1344] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      sym__automatic_semicolon,
    ACTIONS(515), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(517), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1153), 18,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1155), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(499), 1,
      sym__automatic_semicolon,
    ACTIONS(491), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(493), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(539), 18,
      sym__automatic_semicolon,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(541), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1620] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1157), 1,
      sym__automatic_semicolon,
    ACTIONS(437), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(439), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(487), 18,
      sym__automatic_semicolon,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(489), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1758] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1159), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1161), 43,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_finally,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 18,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1165), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1169), 43,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_finally,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [1962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1171), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1173), 43,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_finally,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(501), 18,
      sym__automatic_semicolon,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(503), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2098] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(513), 1,
      sym__automatic_semicolon,
    ACTIONS(505), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(507), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1175), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1177), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1179), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1181), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1183), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1185), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1187), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1189), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1191), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1193), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1195), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1197), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1199), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1201), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1203), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1205), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1207), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1209), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1211), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1213), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1215), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1217), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1219), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1221), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [2972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1223), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1225), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1227), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1229), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1231), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1233), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1235), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1237), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1239), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1241), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1243), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1245), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1247), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1249), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1251), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1253), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1255), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1257), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1259), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1261), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1263), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1265), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1267), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1269), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1271), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1273), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1275), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1277), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1281), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [3977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1283), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1285), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1287), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1289), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4111] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1135), 1,
      sym_identifier,
    ACTIONS(1141), 1,
      anon_sym_EQ,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_function,
    ACTIONS(1149), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_LPAREN,
    STATE(1099), 1,
      sym_formal_parameters,
    ACTIONS(1145), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1151), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1072), 17,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1080), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
  [4196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1294), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1296), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1298), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1300), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4330] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1302), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1304), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1306), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1308), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4464] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1310), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1312), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1314), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1316), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1318), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1320), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1322), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1324), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1326), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1328), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1330), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1332), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1334), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1336), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [4933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1338), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1340), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5000] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1346), 1,
      anon_sym_else,
    ACTIONS(1342), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1344), 41,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1348), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1350), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1352), 17,
      ts_builtin_sym_end,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1354), 42,
      anon_sym_export,
      anon_sym_default,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_else,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_case,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5203] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_EQ_GT,
    ACTIONS(1141), 1,
      anon_sym_EQ,
    ACTIONS(1356), 1,
      sym_identifier,
    ACTIONS(1358), 1,
      anon_sym_DOT,
    ACTIONS(1362), 1,
      anon_sym_function,
    STATE(535), 1,
      sym_arguments,
    STATE(1126), 1,
      sym_formal_parameters,
    ACTIONS(1360), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1151), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1139), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1137), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
  [5287] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_LPAREN,
    ACTIONS(1356), 1,
      sym_identifier,
    ACTIONS(1358), 1,
      anon_sym_DOT,
    ACTIONS(1362), 1,
      anon_sym_function,
    ACTIONS(1364), 1,
      anon_sym_in,
    ACTIONS(1367), 1,
      anon_sym_of,
    ACTIONS(1369), 1,
      anon_sym_EQ,
    STATE(1126), 1,
      sym_formal_parameters,
    ACTIONS(1360), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1098), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1072), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1080), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
  [5374] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1094), 1,
      anon_sym_function,
    ACTIONS(1096), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_LPAREN,
    ACTIONS(1356), 1,
      sym_identifier,
    ACTIONS(1358), 1,
      anon_sym_DOT,
    ACTIONS(1369), 1,
      anon_sym_EQ,
    ACTIONS(1371), 1,
      anon_sym_COLON,
    STATE(1126), 1,
      sym_formal_parameters,
    ACTIONS(1360), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1098), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1072), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1080), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
  [5459] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_LPAREN,
    ACTIONS(1356), 1,
      sym_identifier,
    ACTIONS(1358), 1,
      anon_sym_DOT,
    ACTIONS(1369), 1,
      anon_sym_EQ,
    ACTIONS(1373), 1,
      anon_sym_COLON,
    ACTIONS(1375), 1,
      anon_sym_function,
    STATE(1126), 1,
      sym_formal_parameters,
    ACTIONS(1360), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1098), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1072), 14,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1080), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
  [5544] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_LPAREN,
    ACTIONS(1356), 1,
      sym_identifier,
    ACTIONS(1358), 1,
      anon_sym_DOT,
    ACTIONS(1362), 1,
      anon_sym_function,
    ACTIONS(1369), 1,
      anon_sym_EQ,
    STATE(1126), 1,
      sym_formal_parameters,
    ACTIONS(1360), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1098), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1072), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1080), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
  [5627] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1135), 1,
      sym_identifier,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_function,
    ACTIONS(1149), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_LPAREN,
    ACTIONS(1377), 1,
      anon_sym_COMMA,
    ACTIONS(1380), 1,
      anon_sym_RPAREN,
    ACTIONS(1383), 1,
      anon_sym_EQ,
    STATE(817), 1,
      aux_sym_formal_parameters_repeat1,
    STATE(1099), 1,
      sym_formal_parameters,
    ACTIONS(1145), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1072), 11,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1151), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1080), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
  [5715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1387), 15,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1385), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1391), 15,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1389), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [5839] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1135), 1,
      sym_identifier,
    ACTIONS(1141), 1,
      anon_sym_EQ,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_function,
    ACTIONS(1149), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_LPAREN,
    ACTIONS(1364), 1,
      anon_sym_in,
    ACTIONS(1367), 1,
      anon_sym_of,
    STATE(1099), 1,
      sym_formal_parameters,
    ACTIONS(1145), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1072), 11,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1151), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1080), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
  [5923] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1135), 1,
      sym_identifier,
    ACTIONS(1141), 1,
      anon_sym_EQ,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    ACTIONS(1147), 1,
      anon_sym_function,
    ACTIONS(1149), 1,
      anon_sym_EQ_GT,
    ACTIONS(1291), 1,
      anon_sym_LPAREN,
    ACTIONS(1393), 1,
      anon_sym_in,
    ACTIONS(1396), 1,
      anon_sym_of,
    STATE(1099), 1,
      sym_formal_parameters,
    ACTIONS(1145), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1072), 11,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1151), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1080), 18,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
  [6007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1400), 15,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1398), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1404), 15,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1402), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1408), 15,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1406), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1412), 15,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1410), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1416), 15,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1414), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1420), 15,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1418), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1424), 15,
      anon_sym_LBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LT,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
      sym_preproc,
    ACTIONS(1422), 39,
      anon_sym_export,
      anon_sym_import,
      anon_sym_var,
      anon_sym_let,
      anon_sym_const,
      anon_sym_if,
      anon_sym_switch,
      anon_sym_for,
      anon_sym_await,
      anon_sym_while,
      anon_sym_do,
      anon_sym_try,
      anon_sym_with,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_debugger,
      anon_sym_return,
      anon_sym_throw,
      anon_sym_yield,
      anon_sym_SLASH,
      anon_sym_class,
      anon_sym_async,
      anon_sym_function,
      anon_sym_new,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_typeof,
      anon_sym_void,
      anon_sym_delete,
      sym_identifier,
      sym_this,
      sym_super,
      sym_true,
      sym_false,
      sym_null,
      sym_undefined,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [6441] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1141), 1,
      anon_sym_EQ,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    ACTIONS(1149), 1,
      anon_sym_EQ_GT,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    STATE(407), 1,
      sym_arguments,
    ACTIONS(1151), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1137), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1139), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [6514] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1432), 1,
      anon_sym_EQ,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1436), 1,
      anon_sym_EQ_GT,
    STATE(406), 1,
      sym_arguments,
    ACTIONS(1438), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1428), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1430), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [6587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1440), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1442), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [6647] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1432), 1,
      anon_sym_EQ,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1436), 1,
      anon_sym_EQ_GT,
    ACTIONS(1438), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1444), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [6715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1448), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1450), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [6775] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1141), 1,
      anon_sym_EQ,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    ACTIONS(1149), 1,
      anon_sym_EQ_GT,
    ACTIONS(1151), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1080), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1072), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [6843] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1082), 1,
      anon_sym_COLON,
    ACTIONS(1104), 1,
      anon_sym_RBRACE,
    ACTIONS(1452), 1,
      anon_sym_LPAREN,
    ACTIONS(1455), 1,
      anon_sym_EQ,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1459), 1,
      anon_sym_EQ_GT,
    STATE(870), 1,
      aux_sym_object_repeat1,
    ACTIONS(1461), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1446), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1444), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [6919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1389), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1391), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [6979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1465), 33,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [7039] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1074), 1,
      anon_sym_RBRACE,
    ACTIONS(1082), 1,
      anon_sym_COLON,
    ACTIONS(1452), 1,
      anon_sym_LPAREN,
    ACTIONS(1455), 1,
      anon_sym_EQ,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1459), 1,
      anon_sym_EQ_GT,
    STATE(838), 1,
      aux_sym_object_repeat1,
    ACTIONS(1461), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1446), 15,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1444), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [7115] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1432), 1,
      anon_sym_EQ,
    STATE(406), 1,
      sym_arguments,
    ACTIONS(1438), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1428), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1430), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [7183] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1432), 1,
      anon_sym_EQ,
    ACTIONS(1438), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1444), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 20,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [7246] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_EQ_GT,
    ACTIONS(1141), 1,
      anon_sym_EQ,
    ACTIONS(1358), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    STATE(535), 1,
      sym_arguments,
    ACTIONS(1151), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1139), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1137), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [7317] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1432), 1,
      anon_sym_EQ,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1459), 1,
      anon_sym_EQ_GT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    STATE(540), 1,
      sym_arguments,
    ACTIONS(1438), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1430), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1428), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [7388] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1436), 1,
      anon_sym_EQ_GT,
    ACTIONS(1471), 1,
      anon_sym_in,
    ACTIONS(1474), 1,
      anon_sym_of,
    ACTIONS(1476), 1,
      anon_sym_EQ,
    STATE(839), 1,
      sym__initializer,
    ACTIONS(1469), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1438), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1446), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1444), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [7463] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1432), 1,
      anon_sym_EQ,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    STATE(540), 1,
      sym_arguments,
    ACTIONS(1438), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1430), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1428), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [7529] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_EQ_GT,
    ACTIONS(1358), 1,
      anon_sym_DOT,
    ACTIONS(1364), 1,
      anon_sym_in,
    ACTIONS(1369), 1,
      anon_sym_EQ,
    ACTIONS(1478), 1,
      anon_sym_of,
    ACTIONS(1098), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1072), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1080), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [7599] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1459), 1,
      anon_sym_EQ_GT,
    ACTIONS(1480), 1,
      anon_sym_in,
    ACTIONS(1483), 1,
      anon_sym_of,
    ACTIONS(1485), 1,
      anon_sym_EQ,
    ACTIONS(1461), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1446), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1444), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [7669] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_EQ_GT,
    ACTIONS(1358), 1,
      anon_sym_DOT,
    ACTIONS(1369), 1,
      anon_sym_EQ,
    ACTIONS(1098), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1072), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1080), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [7735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1448), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1450), 31,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [7793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1440), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1442), 31,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [7851] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1371), 1,
      anon_sym_COLON,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1459), 1,
      anon_sym_EQ_GT,
    ACTIONS(1485), 1,
      anon_sym_EQ,
    ACTIONS(1461), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1446), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1444), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [7919] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1459), 1,
      anon_sym_EQ_GT,
    ACTIONS(1485), 1,
      anon_sym_EQ,
    ACTIONS(1461), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1446), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1444), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [7985] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1373), 1,
      anon_sym_COLON,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1459), 1,
      anon_sym_EQ_GT,
    ACTIONS(1485), 1,
      anon_sym_EQ,
    ACTIONS(1461), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1446), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1444), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [8053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1463), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1465), 31,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [8111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1389), 19,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1391), 31,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [8169] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_EQ_GT,
    ACTIONS(1358), 1,
      anon_sym_DOT,
    ACTIONS(1369), 1,
      anon_sym_EQ,
    ACTIONS(1373), 1,
      anon_sym_COLON,
    ACTIONS(1098), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1072), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1080), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [8237] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1096), 1,
      anon_sym_EQ_GT,
    ACTIONS(1358), 1,
      anon_sym_DOT,
    ACTIONS(1369), 1,
      anon_sym_EQ,
    ACTIONS(1371), 1,
      anon_sym_COLON,
    ACTIONS(1098), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1072), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1080), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [8305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1487), 22,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1489), 27,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
  [8362] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1480), 1,
      anon_sym_in,
    ACTIONS(1483), 1,
      anon_sym_of,
    ACTIONS(1485), 1,
      anon_sym_EQ,
    ACTIONS(1461), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1444), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [8427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 22,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1493), 27,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
  [8484] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    ACTIONS(1149), 1,
      anon_sym_EQ_GT,
    ACTIONS(1377), 1,
      anon_sym_COMMA,
    ACTIONS(1380), 1,
      anon_sym_RPAREN,
    ACTIONS(1383), 1,
      anon_sym_EQ,
    STATE(817), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(1151), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1072), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1080), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [8555] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1485), 1,
      anon_sym_EQ,
    ACTIONS(1461), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1444), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 18,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [8616] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1436), 1,
      anon_sym_EQ_GT,
    ACTIONS(1495), 1,
      anon_sym_COMMA,
    ACTIONS(1498), 1,
      anon_sym_RPAREN,
    ACTIONS(1501), 1,
      anon_sym_EQ,
    STATE(813), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(1438), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1446), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1444), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [8687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1503), 22,
      anon_sym_export,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1505), 27,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      anon_sym_BQUOTE,
      sym_number,
      anon_sym_AT,
  [8744] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1432), 1,
      anon_sym_EQ,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1436), 1,
      anon_sym_EQ_GT,
    ACTIONS(1507), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1438), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1446), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1444), 18,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [8810] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1141), 1,
      anon_sym_EQ,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    ACTIONS(1149), 1,
      anon_sym_EQ_GT,
    ACTIONS(1364), 1,
      anon_sym_in,
    ACTIONS(1478), 1,
      anon_sym_of,
    ACTIONS(1151), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1072), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1080), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [8877] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1141), 1,
      anon_sym_EQ,
    ACTIONS(1143), 1,
      anon_sym_DOT,
    ACTIONS(1149), 1,
      anon_sym_EQ_GT,
    ACTIONS(1393), 1,
      anon_sym_in,
    ACTIONS(1510), 1,
      anon_sym_of,
    ACTIONS(1151), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1072), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1080), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [8944] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1432), 1,
      anon_sym_EQ,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1436), 1,
      anon_sym_EQ_GT,
    ACTIONS(1480), 1,
      anon_sym_in,
    ACTIONS(1483), 1,
      anon_sym_of,
    ACTIONS(1438), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1446), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1444), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [9011] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1432), 1,
      anon_sym_EQ,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1436), 1,
      anon_sym_EQ_GT,
    ACTIONS(1471), 1,
      anon_sym_in,
    ACTIONS(1474), 1,
      anon_sym_of,
    ACTIONS(1438), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1446), 13,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1444), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [9078] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1432), 1,
      anon_sym_EQ,
    ACTIONS(1480), 1,
      anon_sym_in,
    ACTIONS(1483), 1,
      anon_sym_of,
    ACTIONS(1438), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1446), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1444), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [9140] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1432), 1,
      anon_sym_EQ,
    ACTIONS(1471), 1,
      anon_sym_in,
    ACTIONS(1474), 1,
      anon_sym_of,
    ACTIONS(1438), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_CARET_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_GT_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_STAR_STAR_EQ,
    ACTIONS(1446), 14,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
    ACTIONS(1444), 17,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [9202] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(1512), 1,
      sym_identifier,
    ACTIONS(1514), 1,
      anon_sym_STAR,
    ACTIONS(1516), 1,
      anon_sym_LBRACE,
    STATE(895), 1,
      sym_string,
    STATE(904), 1,
      sym_import_clause,
    STATE(1131), 2,
      sym_namespace_import,
      sym_named_imports,
    ACTIONS(1520), 13,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(1518), 21,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9269] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1522), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1524), 21,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [9327] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1530), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [9409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1558), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9457] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1562), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1560), 9,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [9533] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1564), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [9615] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1566), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [9697] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1568), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [9779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1572), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1576), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [9875] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1562), 1,
      anon_sym_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1560), 7,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_QMARK_QMARK,
  [9955] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1578), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [10037] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1580), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [10119] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1582), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [10201] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1584), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [10283] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1562), 10,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1560), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [10349] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1586), 1,
      anon_sym_EQ,
    STATE(406), 1,
      sym_arguments,
    ACTIONS(1428), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1430), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [10403] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1562), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1560), 18,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [10465] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1588), 1,
      anon_sym_EQ,
    STATE(406), 1,
      sym_arguments,
    ACTIONS(1428), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1430), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [10519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1590), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1592), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [10567] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(398), 1,
      sym_arguments,
    STATE(418), 1,
      sym_template_string,
    ACTIONS(1428), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1430), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [10619] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1594), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [10701] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1596), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [10783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(441), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(443), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [10831] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1598), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [10913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1600), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1602), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [10961] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1604), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [11043] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1606), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1608), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [11103] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1606), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1608), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [11163] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1444), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 23,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [11217] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1606), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1608), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [11277] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1562), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1560), 19,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [11337] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(441), 1,
      anon_sym_EQ,
    ACTIONS(1610), 1,
      sym__automatic_semicolon,
    ACTIONS(439), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(437), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [11389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1614), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [11437] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1616), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [11519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1620), 26,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_of,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [11567] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1562), 8,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1560), 15,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [11635] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1562), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1560), 10,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [11707] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1622), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [11789] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1624), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [11871] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1626), 6,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [11953] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1628), 1,
      anon_sym_EQ_GT,
    ACTIONS(1487), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1489), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1630), 1,
      sym__automatic_semicolon,
    ACTIONS(541), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(539), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12051] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1636), 1,
      sym_regex_flags,
    ACTIONS(1632), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(1634), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12100] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1638), 1,
      anon_sym_COMMA,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1640), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [12183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1586), 1,
      anon_sym_EQ,
    ACTIONS(1444), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12232] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    STATE(406), 1,
      sym_arguments,
    ACTIONS(1428), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1430), 24,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_EQ,
    ACTIONS(1444), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12332] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1610), 1,
      sym__automatic_semicolon,
    ACTIONS(439), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(437), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1644), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12427] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(418), 1,
      sym_template_string,
    STATE(547), 1,
      sym_arguments,
    ACTIONS(1428), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1430), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1590), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1592), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(473), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12569] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1598), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [12649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(463), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(453), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [12741] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1580), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [12821] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1564), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [12901] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1604), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [12981] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1594), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [13061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1674), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1676), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13107] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1680), 1,
      anon_sym_in,
    ACTIONS(1683), 1,
      anon_sym_of,
    ACTIONS(1685), 1,
      anon_sym_EQ,
    STATE(868), 1,
      sym__initializer,
    ACTIONS(1678), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1444), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 19,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(441), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(443), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13209] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1689), 1,
      anon_sym_in,
    ACTIONS(1692), 1,
      anon_sym_of,
    ACTIONS(1694), 1,
      anon_sym_EQ,
    STATE(867), 1,
      sym__initializer,
    ACTIONS(1687), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1444), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 19,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1696), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1530), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1698), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1616), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(535), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(521), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1700), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1702), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13495] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1568), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [13575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1570), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1572), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(511), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1612), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1614), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13713] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1704), 4,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [13793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(497), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13839] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1582), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [13919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1618), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1620), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [13965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1706), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1708), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14011] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1616), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [14091] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1596), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [14171] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(445), 1,
      sym__automatic_semicolon,
    ACTIONS(437), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(441), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(443), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1700), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1702), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1710), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1712), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1714), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1716), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1720), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1722), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1724), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1726), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1728), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(489), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(487), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14543] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1444), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 21,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [14595] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1626), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [14675] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1562), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1560), 16,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1714), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1716), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1732), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [14827] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1562), 8,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1560), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [14893] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1624), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [14973] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1562), 3,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1560), 8,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [15043] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1562), 2,
      anon_sym_QMARK,
      anon_sym_PIPE,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
    ACTIONS(1560), 7,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_QMARK_QMARK,
  [15117] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1562), 10,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1560), 13,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15181] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1562), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1560), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15239] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1562), 1,
      anon_sym_QMARK,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1560), 5,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_QMARK_QMARK,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [15317] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1584), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [15397] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1622), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [15477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1734), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1736), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1738), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1740), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15569] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1578), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [15649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1722), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1724), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [15695] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1522), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1524), 19,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
  [15751] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1606), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1608), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15809] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1606), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1608), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [15867] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1530), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [15947] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1606), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1608), 17,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
  [16005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1742), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1744), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(483), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16097] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1588), 1,
      anon_sym_EQ,
    STATE(540), 1,
      sym_arguments,
    ACTIONS(1428), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1430), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(527), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(525), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(541), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(539), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1746), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1748), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1750), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1578), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16333] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1586), 1,
      anon_sym_EQ,
    STATE(540), 1,
      sym_arguments,
    ACTIONS(1428), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1430), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1520), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1518), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1752), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1754), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1756), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1624), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1556), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1558), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16569] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1566), 4,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [16649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1758), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1626), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1760), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1762), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1764), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1766), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(503), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(501), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1768), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1770), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1772), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1774), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1776), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1778), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [16971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1782), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1784), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1786), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1788), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1790), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17109] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1792), 1,
      anon_sym_COMMA,
    ACTIONS(1795), 1,
      anon_sym_RBRACE,
    ACTIONS(1622), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [17193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1797), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1799), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17239] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1801), 1,
      anon_sym_COMMA,
    ACTIONS(1804), 1,
      anon_sym_RBRACE,
    ACTIONS(1598), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [17323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1600), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1602), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17369] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1804), 1,
      anon_sym_RBRACE,
    ACTIONS(1806), 1,
      anon_sym_COMMA,
    ACTIONS(1582), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [17453] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1809), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1604), 25,
      anon_sym_LBRACE,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1574), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1576), 24,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_of,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17545] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1811), 1,
      anon_sym_COMMA,
    ACTIONS(1814), 1,
      anon_sym_RBRACE,
    ACTIONS(1584), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [17629] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(557), 1,
      anon_sym_COMMA,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1816), 1,
      anon_sym_RBRACK,
    STATE(865), 1,
      aux_sym_array_repeat1,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [17712] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1818), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [17791] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(537), 1,
      sym__automatic_semicolon,
    ACTIONS(529), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(533), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(535), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17840] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(557), 1,
      anon_sym_COMMA,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1820), 1,
      anon_sym_RBRACK,
    STATE(825), 1,
      aux_sym_array_repeat1,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [17923] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(523), 1,
      sym__automatic_semicolon,
    ACTIONS(515), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(519), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(521), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [17972] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(455), 1,
      sym__automatic_semicolon,
    ACTIONS(447), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(451), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(453), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18021] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(465), 1,
      sym__automatic_semicolon,
    ACTIONS(457), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(461), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(463), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18070] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(513), 1,
      sym__automatic_semicolon,
    ACTIONS(505), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(509), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(511), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18119] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1822), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [18198] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    STATE(540), 1,
      sym_arguments,
    ACTIONS(1428), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1430), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18247] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(499), 1,
      sym__automatic_semicolon,
    ACTIONS(491), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(495), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(497), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18296] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(441), 1,
      anon_sym_EQ,
    ACTIONS(545), 1,
      sym__automatic_semicolon,
    ACTIONS(439), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(437), 22,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18345] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(557), 1,
      anon_sym_COMMA,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1824), 1,
      anon_sym_RBRACK,
    STATE(865), 1,
      aux_sym_array_repeat1,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [18428] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1818), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [18507] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(475), 1,
      sym__automatic_semicolon,
    ACTIONS(467), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(471), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(473), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18556] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1826), 1,
      anon_sym_COMMA,
    ACTIONS(1640), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [18637] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(485), 1,
      sym__automatic_semicolon,
    ACTIONS(477), 2,
      anon_sym_else,
      anon_sym_while,
    ACTIONS(481), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(483), 21,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18686] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1828), 1,
      anon_sym_LPAREN,
    ACTIONS(1831), 1,
      anon_sym_COLON,
    ACTIONS(1590), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1592), 21,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18735] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1833), 1,
      sym_regex_flags,
    ACTIONS(1632), 14,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_instanceof,
    ACTIONS(1634), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1628), 1,
      anon_sym_EQ_GT,
    ACTIONS(1487), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1489), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [18829] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(557), 1,
      anon_sym_COMMA,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1835), 1,
      anon_sym_RPAREN,
    STATE(854), 1,
      aux_sym_array_repeat1,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [18912] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(557), 1,
      anon_sym_COMMA,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1837), 1,
      anon_sym_RPAREN,
    STATE(871), 1,
      aux_sym_array_repeat1,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [18995] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(557), 1,
      anon_sym_COMMA,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1839), 1,
      anon_sym_RBRACK,
    STATE(825), 1,
      aux_sym_array_repeat1,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19078] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1841), 1,
      anon_sym_EQ,
    ACTIONS(1444), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19125] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1826), 1,
      anon_sym_COMMA,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1843), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1845), 1,
      anon_sym_EQ,
    ACTIONS(1444), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19253] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1818), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19332] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1818), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19411] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1804), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19490] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1814), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19569] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1795), 3,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19648] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1826), 1,
      anon_sym_COMMA,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1847), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19729] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1845), 1,
      anon_sym_EQ,
    ACTIONS(1849), 1,
      anon_sym_in,
    ACTIONS(1852), 1,
      anon_sym_of,
    ACTIONS(1444), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19780] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1841), 1,
      anon_sym_EQ,
    ACTIONS(1854), 1,
      anon_sym_in,
    ACTIONS(1857), 1,
      anon_sym_of,
    ACTIONS(1444), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19831] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1826), 1,
      anon_sym_COMMA,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1859), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [19912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1797), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1799), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [19956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1768), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1770), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20000] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1861), 1,
      anon_sym_COMMA,
    ACTIONS(1864), 1,
      anon_sym_RPAREN,
    ACTIONS(1867), 1,
      anon_sym_EQ,
    STATE(888), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(1444), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 19,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20052] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1638), 1,
      anon_sym_COMMA,
    ACTIONS(1869), 1,
      anon_sym_RPAREN,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20132] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1638), 1,
      anon_sym_COMMA,
    ACTIONS(1871), 1,
      anon_sym_RPAREN,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20212] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1801), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20290] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1806), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20368] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1811), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20446] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1792), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20524] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(481), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(483), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20568] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1638), 1,
      anon_sym_COMMA,
    ACTIONS(1873), 1,
      anon_sym_RPAREN,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20648] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1638), 1,
      anon_sym_COMMA,
    ACTIONS(1875), 1,
      anon_sym_RPAREN,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20728] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1638), 1,
      anon_sym_COMMA,
    ACTIONS(1877), 1,
      anon_sym_RPAREN,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20808] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1879), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [20886] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(473), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(461), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(463), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [20974] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(451), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(453), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21018] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1638), 1,
      anon_sym_COMMA,
    ACTIONS(1881), 1,
      anon_sym_RPAREN,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [21098] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1638), 1,
      anon_sym_COMMA,
    ACTIONS(1883), 1,
      anon_sym_RPAREN,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [21178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1788), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1790), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21222] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1638), 1,
      anon_sym_COMMA,
    ACTIONS(1885), 1,
      anon_sym_COLON,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [21302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1710), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1712), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1784), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1786), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1780), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1782), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1503), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1505), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(533), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(535), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21522] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1809), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1604), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1764), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1766), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21610] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1638), 1,
      anon_sym_COMMA,
    ACTIONS(1887), 1,
      anon_sym_RPAREN,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [21690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1776), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1778), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(519), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(521), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1720), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21822] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1638), 1,
      anon_sym_COMMA,
    ACTIONS(1889), 1,
      anon_sym_RPAREN,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [21902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(509), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(511), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(497), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [21990] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1638), 1,
      anon_sym_COMMA,
    ACTIONS(1891), 1,
      anon_sym_RPAREN,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [22070] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1893), 1,
      anon_sym_COMMA,
    ACTIONS(1896), 1,
      anon_sym_RPAREN,
    ACTIONS(1899), 1,
      anon_sym_EQ,
    STATE(824), 1,
      aux_sym_formal_parameters_repeat1,
    ACTIONS(1444), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 19,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22122] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1901), 1,
      anon_sym_EQ,
    ACTIONS(1444), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1726), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1728), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22212] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1638), 1,
      anon_sym_COMMA,
    ACTIONS(1903), 1,
      anon_sym_RPAREN,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [22292] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1905), 1,
      anon_sym_EQ,
    ACTIONS(1444), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 22,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1696), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1530), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22382] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1907), 1,
      anon_sym_LPAREN,
    ACTIONS(1910), 1,
      anon_sym_COLON,
    ACTIONS(1444), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 21,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1730), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1732), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1674), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1676), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1734), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1736), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1750), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1578), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22606] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1638), 1,
      anon_sym_COMMA,
    ACTIONS(1912), 1,
      anon_sym_RPAREN,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [22686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1714), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1716), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1738), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1740), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22774] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1638), 1,
      anon_sym_COMMA,
    ACTIONS(1914), 1,
      anon_sym_RBRACE,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [22854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1642), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1644), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1756), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1624), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [22942] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1638), 1,
      anon_sym_COMMA,
    ACTIONS(1916), 1,
      anon_sym_RPAREN,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [23022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1758), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1626), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1714), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1716), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23110] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1638), 1,
      anon_sym_COMMA,
    ACTIONS(1918), 1,
      anon_sym_RBRACE,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [23190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1760), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1762), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1752), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1754), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1706), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1708), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23322] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1742), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1744), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1746), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1748), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23410] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1493), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1772), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1774), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23498] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1920), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [23576] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1638), 1,
      anon_sym_COMMA,
    ACTIONS(1922), 1,
      anon_sym_RBRACK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [23656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1520), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1518), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23700] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1638), 1,
      anon_sym_COMMA,
    ACTIONS(1924), 1,
      anon_sym_RBRACK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [23780] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1638), 1,
      anon_sym_COMMA,
    ACTIONS(1926), 1,
      anon_sym_RBRACE,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [23860] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1652), 1,
      anon_sym_QMARK,
    ACTIONS(1654), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1660), 1,
      anon_sym_AMP,
    ACTIONS(1662), 1,
      anon_sym_PIPE,
    ACTIONS(1666), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1670), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1656), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1664), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1672), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(1928), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1646), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1658), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1648), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1668), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [23938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1698), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1616), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [23982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1487), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1489), 23,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24026] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1930), 1,
      anon_sym_LBRACE,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [24103] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1932), 1,
      anon_sym_RBRACK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [24180] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1586), 1,
      anon_sym_EQ,
    ACTIONS(1934), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1444), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 19,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24227] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1937), 1,
      anon_sym_COLON,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [24304] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_EQ,
    ACTIONS(1939), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(1444), 13,
      anon_sym_STAR,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 19,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24351] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1942), 1,
      anon_sym_COLON,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [24428] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1944), 1,
      anon_sym_RBRACK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [24505] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1586), 1,
      anon_sym_EQ,
    ACTIONS(1854), 1,
      anon_sym_in,
    ACTIONS(1857), 1,
      anon_sym_of,
    ACTIONS(1444), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 19,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24553] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1586), 1,
      anon_sym_EQ,
    ACTIONS(1689), 1,
      anon_sym_in,
    ACTIONS(1692), 1,
      anon_sym_of,
    ACTIONS(1444), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 19,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24601] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_EQ,
    ACTIONS(1680), 1,
      anon_sym_in,
    ACTIONS(1683), 1,
      anon_sym_of,
    ACTIONS(1444), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 19,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24649] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [24723] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1588), 1,
      anon_sym_EQ,
    ACTIONS(1849), 1,
      anon_sym_in,
    ACTIONS(1852), 1,
      anon_sym_of,
    ACTIONS(1444), 12,
      anon_sym_STAR,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_SLASH,
      anon_sym_QMARK,
      anon_sym_GT_GT,
      anon_sym_AMP,
      anon_sym_PIPE,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1446), 19,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DOT,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_CARET,
      anon_sym_PERCENT,
      anon_sym_STAR_STAR,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_QMARK_QMARK,
      anon_sym_instanceof,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_BQUOTE,
  [24771] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1534), 1,
      anon_sym_QMARK,
    ACTIONS(1536), 1,
      anon_sym_AMP_AMP,
    ACTIONS(1542), 1,
      anon_sym_AMP,
    ACTIONS(1544), 1,
      anon_sym_PIPE,
    ACTIONS(1548), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1552), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    ACTIONS(1538), 2,
      anon_sym_PIPE_PIPE,
      anon_sym_CARET,
    ACTIONS(1546), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1554), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
    ACTIONS(1528), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_GT_GT,
    ACTIONS(1540), 3,
      anon_sym_GT_GT_GT,
      anon_sym_LT_LT,
      anon_sym_PERCENT,
    ACTIONS(1532), 5,
      anon_sym_in,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(1550), 5,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ_EQ,
      anon_sym_BANG_EQ_EQ,
      anon_sym_GT_EQ,
      anon_sym_instanceof,
  [24845] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(95), 1,
      anon_sym_STAR,
    ACTIONS(97), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(361), 1,
      anon_sym_LBRACE,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(1946), 1,
      sym_identifier,
    ACTIONS(1948), 1,
      anon_sym_RBRACE,
    ACTIONS(1950), 1,
      anon_sym_LBRACK,
    ACTIONS(1952), 1,
      anon_sym_async,
    ACTIONS(1954), 1,
      sym_number,
    ACTIONS(1956), 1,
      anon_sym_static,
    STATE(602), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    STATE(885), 1,
      aux_sym_object_repeat1,
    STATE(1052), 1,
      sym_object,
    STATE(1056), 1,
      sym_array,
    ACTIONS(1958), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(890), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(809), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
  [24918] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(95), 1,
      anon_sym_STAR,
    ACTIONS(97), 1,
      anon_sym_COMMA,
    ACTIONS(105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(361), 1,
      anon_sym_LBRACE,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(1950), 1,
      anon_sym_LBRACK,
    ACTIONS(1954), 1,
      sym_number,
    ACTIONS(1960), 1,
      sym_identifier,
    ACTIONS(1962), 1,
      anon_sym_RBRACE,
    ACTIONS(1964), 1,
      anon_sym_async,
    ACTIONS(1966), 1,
      anon_sym_static,
    STATE(602), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    STATE(889), 1,
      aux_sym_object_repeat1,
    STATE(1052), 1,
      sym_object,
    STATE(1056), 1,
      sym_array,
    ACTIONS(1968), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(890), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(884), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
  [24991] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(95), 1,
      anon_sym_STAR,
    ACTIONS(105), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(361), 1,
      anon_sym_LBRACE,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(1950), 1,
      anon_sym_LBRACK,
    ACTIONS(1954), 1,
      sym_number,
    ACTIONS(1970), 1,
      sym_identifier,
    ACTIONS(1974), 1,
      anon_sym_async,
    ACTIONS(1976), 1,
      anon_sym_static,
    STATE(602), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    STATE(1052), 1,
      sym_object,
    STATE(1056), 1,
      sym_array,
    ACTIONS(1972), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1978), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(890), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    STATE(1024), 4,
      sym_assignment_pattern,
      sym_spread_element,
      sym_method_definition,
      sym_pair,
  [25059] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(95), 1,
      anon_sym_STAR,
    ACTIONS(1980), 1,
      sym_identifier,
    ACTIONS(1982), 1,
      anon_sym_RBRACE,
    ACTIONS(1984), 1,
      anon_sym_LBRACK,
    ACTIONS(1986), 1,
      anon_sym_async,
    ACTIONS(1988), 1,
      sym_number,
    ACTIONS(1990), 1,
      anon_sym_static,
    STATE(585), 1,
      aux_sym_class_body_repeat1,
    STATE(602), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    STATE(636), 1,
      sym_method_definition,
    STATE(960), 1,
      sym_public_field_definition,
    ACTIONS(1992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(684), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25117] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(95), 1,
      anon_sym_STAR,
    ACTIONS(1980), 1,
      sym_identifier,
    ACTIONS(1984), 1,
      anon_sym_LBRACK,
    ACTIONS(1986), 1,
      anon_sym_async,
    ACTIONS(1988), 1,
      sym_number,
    ACTIONS(1990), 1,
      anon_sym_static,
    ACTIONS(1994), 1,
      anon_sym_RBRACE,
    STATE(585), 1,
      aux_sym_class_body_repeat1,
    STATE(602), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    STATE(636), 1,
      sym_method_definition,
    STATE(960), 1,
      sym_public_field_definition,
    ACTIONS(1992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(684), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25175] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(95), 1,
      anon_sym_STAR,
    ACTIONS(1980), 1,
      sym_identifier,
    ACTIONS(1984), 1,
      anon_sym_LBRACK,
    ACTIONS(1986), 1,
      anon_sym_async,
    ACTIONS(1988), 1,
      sym_number,
    ACTIONS(1990), 1,
      anon_sym_static,
    ACTIONS(1996), 1,
      anon_sym_RBRACE,
    STATE(581), 1,
      aux_sym_class_body_repeat1,
    STATE(602), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    STATE(636), 1,
      sym_method_definition,
    STATE(960), 1,
      sym_public_field_definition,
    ACTIONS(1992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(684), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25233] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(95), 1,
      anon_sym_STAR,
    ACTIONS(1980), 1,
      sym_identifier,
    ACTIONS(1984), 1,
      anon_sym_LBRACK,
    ACTIONS(1986), 1,
      anon_sym_async,
    ACTIONS(1988), 1,
      sym_number,
    ACTIONS(1990), 1,
      anon_sym_static,
    ACTIONS(1998), 1,
      anon_sym_RBRACE,
    STATE(584), 1,
      aux_sym_class_body_repeat1,
    STATE(602), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    STATE(636), 1,
      sym_method_definition,
    STATE(960), 1,
      sym_public_field_definition,
    ACTIONS(1992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(684), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25291] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(95), 1,
      anon_sym_STAR,
    ACTIONS(1980), 1,
      sym_identifier,
    ACTIONS(1984), 1,
      anon_sym_LBRACK,
    ACTIONS(1986), 1,
      anon_sym_async,
    ACTIONS(1988), 1,
      sym_number,
    ACTIONS(1990), 1,
      anon_sym_static,
    ACTIONS(2000), 1,
      anon_sym_RBRACE,
    STATE(585), 1,
      aux_sym_class_body_repeat1,
    STATE(602), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    STATE(636), 1,
      sym_method_definition,
    STATE(960), 1,
      sym_public_field_definition,
    ACTIONS(1992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(684), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25349] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2002), 1,
      sym_identifier,
    ACTIONS(2005), 1,
      anon_sym_STAR,
    ACTIONS(2008), 1,
      anon_sym_RBRACE,
    ACTIONS(2010), 1,
      anon_sym_LBRACK,
    ACTIONS(2013), 1,
      anon_sym_async,
    ACTIONS(2016), 1,
      anon_sym_DQUOTE,
    ACTIONS(2019), 1,
      anon_sym_SQUOTE,
    ACTIONS(2022), 1,
      sym_number,
    ACTIONS(2025), 1,
      anon_sym_AT,
    ACTIONS(2028), 1,
      anon_sym_static,
    STATE(585), 1,
      aux_sym_class_body_repeat1,
    STATE(602), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    STATE(636), 1,
      sym_method_definition,
    STATE(960), 1,
      sym_public_field_definition,
    ACTIONS(2031), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(684), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25407] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(95), 1,
      anon_sym_STAR,
    ACTIONS(1980), 1,
      sym_identifier,
    ACTIONS(1984), 1,
      anon_sym_LBRACK,
    ACTIONS(1986), 1,
      anon_sym_async,
    ACTIONS(1988), 1,
      sym_number,
    ACTIONS(1990), 1,
      anon_sym_static,
    ACTIONS(2034), 1,
      anon_sym_RBRACE,
    STATE(580), 1,
      aux_sym_class_body_repeat1,
    STATE(602), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    STATE(636), 1,
      sym_method_definition,
    STATE(960), 1,
      sym_public_field_definition,
    ACTIONS(1992), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(684), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25465] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_COMMA,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(1074), 1,
      anon_sym_RBRACE,
    ACTIONS(1100), 1,
      sym_number,
    ACTIONS(1113), 1,
      anon_sym_async,
    ACTIONS(2036), 1,
      anon_sym_STAR,
    ACTIONS(2040), 1,
      anon_sym_EQ,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    STATE(838), 1,
      aux_sym_object_repeat1,
    ACTIONS(1108), 2,
      sym_identifier,
      anon_sym_static,
    ACTIONS(1115), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2038), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25516] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_COMMA,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(1100), 1,
      sym_number,
    ACTIONS(1104), 1,
      anon_sym_RBRACE,
    ACTIONS(1113), 1,
      anon_sym_async,
    ACTIONS(2036), 1,
      anon_sym_STAR,
    ACTIONS(2040), 1,
      anon_sym_EQ,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      aux_sym_object_repeat1,
    ACTIONS(1108), 2,
      sym_identifier,
      anon_sym_static,
    ACTIONS(1115), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2038), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25567] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_COMMA,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(1074), 1,
      anon_sym_RBRACE,
    ACTIONS(1100), 1,
      sym_number,
    ACTIONS(2036), 1,
      anon_sym_STAR,
    ACTIONS(2040), 1,
      anon_sym_EQ,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    STATE(838), 1,
      aux_sym_object_repeat1,
    ACTIONS(1115), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2038), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(1108), 3,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25616] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(2044), 1,
      anon_sym_STAR,
    ACTIONS(2046), 1,
      anon_sym_default,
    ACTIONS(2048), 1,
      anon_sym_LBRACE,
    ACTIONS(2050), 1,
      anon_sym_var,
    ACTIONS(2054), 1,
      anon_sym_class,
    ACTIONS(2056), 1,
      anon_sym_async,
    ACTIONS(2058), 1,
      anon_sym_function,
    STATE(635), 1,
      sym_decorator,
    STATE(752), 1,
      sym_export_clause,
    STATE(803), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(2052), 2,
      anon_sym_let,
      anon_sym_const,
    STATE(243), 6,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
  [25665] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_COMMA,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(1100), 1,
      sym_number,
    ACTIONS(1104), 1,
      anon_sym_RBRACE,
    ACTIONS(2036), 1,
      anon_sym_STAR,
    ACTIONS(2040), 1,
      anon_sym_EQ,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      aux_sym_object_repeat1,
    ACTIONS(1115), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2038), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(1108), 3,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25714] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(2044), 1,
      anon_sym_STAR,
    ACTIONS(2046), 1,
      anon_sym_default,
    ACTIONS(2048), 1,
      anon_sym_LBRACE,
    ACTIONS(2050), 1,
      anon_sym_var,
    ACTIONS(2060), 1,
      anon_sym_class,
    ACTIONS(2062), 1,
      anon_sym_async,
    ACTIONS(2064), 1,
      anon_sym_function,
    STATE(635), 1,
      sym_decorator,
    STATE(752), 1,
      sym_export_clause,
    STATE(753), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(2052), 2,
      anon_sym_let,
      anon_sym_const,
    STATE(243), 6,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
  [25763] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(1100), 1,
      sym_number,
    ACTIONS(1113), 1,
      anon_sym_async,
    ACTIONS(2036), 1,
      anon_sym_STAR,
    ACTIONS(2040), 1,
      anon_sym_EQ,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(1108), 2,
      sym_identifier,
      anon_sym_static,
    ACTIONS(1115), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2038), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(2066), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25809] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(1100), 1,
      sym_number,
    ACTIONS(1108), 1,
      sym_identifier,
    ACTIONS(1113), 1,
      anon_sym_async,
    ACTIONS(2036), 1,
      anon_sym_STAR,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2068), 1,
      anon_sym_export,
    ACTIONS(2070), 1,
      anon_sym_class,
    ACTIONS(2072), 1,
      anon_sym_static,
    STATE(611), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    ACTIONS(1115), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25861] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(1100), 1,
      sym_number,
    ACTIONS(2036), 1,
      anon_sym_STAR,
    ACTIONS(2040), 1,
      anon_sym_EQ,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(1115), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2038), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(2066), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(1108), 3,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [25905] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_COMMA,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(1100), 1,
      sym_number,
    ACTIONS(1104), 1,
      anon_sym_RBRACE,
    ACTIONS(2040), 1,
      anon_sym_EQ,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    STATE(870), 1,
      aux_sym_object_repeat1,
    ACTIONS(2038), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1108), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [25949] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_COMMA,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(1074), 1,
      anon_sym_RBRACE,
    ACTIONS(1100), 1,
      sym_number,
    ACTIONS(2040), 1,
      anon_sym_EQ,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    STATE(838), 1,
      aux_sym_object_repeat1,
    ACTIONS(2038), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1108), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [25993] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(1100), 1,
      sym_number,
    ACTIONS(2040), 1,
      anon_sym_EQ,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2038), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(2066), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1108), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26032] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2074), 1,
      anon_sym_STAR,
    ACTIONS(2076), 1,
      sym_number,
    ACTIONS(2078), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1108), 3,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
    STATE(961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2038), 4,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
  [26071] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    ACTIONS(1984), 1,
      anon_sym_LBRACK,
    ACTIONS(2036), 1,
      anon_sym_STAR,
    ACTIONS(2080), 1,
      anon_sym_async,
    ACTIONS(2082), 1,
      sym_number,
    ACTIONS(1980), 2,
      sym_identifier,
      anon_sym_static,
    ACTIONS(2084), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(693), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2038), 4,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
  [26112] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(1100), 1,
      sym_number,
    ACTIONS(2036), 1,
      anon_sym_STAR,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(1115), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1108), 3,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2038), 4,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
  [26151] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(1100), 1,
      sym_number,
    ACTIONS(1108), 1,
      sym_identifier,
    ACTIONS(1113), 1,
      anon_sym_async,
    ACTIONS(2036), 1,
      anon_sym_STAR,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2072), 1,
      anon_sym_static,
    STATE(611), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    ACTIONS(1115), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [26197] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(2050), 1,
      anon_sym_var,
    ACTIONS(2060), 1,
      anon_sym_class,
    ACTIONS(2062), 1,
      anon_sym_async,
    ACTIONS(2064), 1,
      anon_sym_function,
    ACTIONS(2086), 1,
      anon_sym_default,
    STATE(635), 1,
      sym_decorator,
    STATE(753), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(2052), 2,
      anon_sym_let,
      anon_sym_const,
    STATE(215), 6,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
  [26237] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(2092), 1,
      anon_sym_DOT,
    STATE(624), 1,
      sym_arguments,
    ACTIONS(2090), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(2088), 7,
      anon_sym_export,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26267] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(2050), 1,
      anon_sym_var,
    ACTIONS(2054), 1,
      anon_sym_class,
    ACTIONS(2056), 1,
      anon_sym_async,
    ACTIONS(2058), 1,
      anon_sym_function,
    ACTIONS(2086), 1,
      anon_sym_default,
    STATE(635), 1,
      sym_decorator,
    STATE(803), 1,
      aux_sym_export_statement_repeat1,
    ACTIONS(2052), 2,
      anon_sym_let,
      anon_sym_const,
    STATE(215), 6,
      sym__declaration,
      sym_variable_declaration,
      sym_lexical_declaration,
      sym_class_declaration,
      sym_function_declaration,
      sym_generator_function_declaration,
  [26307] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2076), 1,
      sym_number,
    STATE(961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2038), 4,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
    ACTIONS(1108), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26341] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(2098), 1,
      anon_sym_DOT,
    STATE(626), 1,
      sym_arguments,
    ACTIONS(2096), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(2094), 7,
      anon_sym_export,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26371] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(1100), 1,
      sym_number,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(2038), 4,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
    ACTIONS(1108), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2102), 7,
      anon_sym_STAR,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(2100), 8,
      anon_sym_export,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2106), 7,
      anon_sym_STAR,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(2104), 8,
      anon_sym_export,
      anon_sym_DOT,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26451] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2112), 1,
      anon_sym_AT,
    STATE(611), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
    ACTIONS(2110), 5,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
    ACTIONS(2108), 7,
      anon_sym_export,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2115), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2117), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [26502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2119), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2121), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [26524] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(2038), 1,
      anon_sym_LPAREN,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2074), 1,
      anon_sym_STAR,
    ACTIONS(2076), 1,
      sym_number,
    ACTIONS(2123), 1,
      anon_sym_async,
    ACTIONS(1108), 2,
      sym_identifier,
      anon_sym_static,
    ACTIONS(2078), 2,
      anon_sym_get,
      anon_sym_set,
    STATE(961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [26562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2125), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2127), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [26584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2129), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2131), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [26606] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(2038), 1,
      anon_sym_LPAREN,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2076), 1,
      sym_number,
    ACTIONS(2133), 1,
      anon_sym_EQ_GT,
    STATE(961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1108), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26640] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(2038), 1,
      anon_sym_LPAREN,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2135), 1,
      anon_sym_STAR,
    ACTIONS(2137), 1,
      sym_number,
    ACTIONS(2139), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1108), 3,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
    STATE(996), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [26676] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(2038), 1,
      anon_sym_LPAREN,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2074), 1,
      anon_sym_STAR,
    ACTIONS(2076), 1,
      sym_number,
    ACTIONS(2078), 2,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(1108), 3,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
    STATE(961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
  [26712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2141), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2143), 9,
      anon_sym_STAR,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [26734] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_LBRACE,
    ACTIONS(375), 1,
      anon_sym_LBRACK,
    ACTIONS(593), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2145), 1,
      sym_identifier,
    ACTIONS(2147), 1,
      anon_sym_RPAREN,
    STATE(812), 1,
      sym_array,
    STATE(814), 1,
      sym_object,
    STATE(1009), 2,
      sym_assignment_pattern,
      sym_rest_parameter,
    ACTIONS(2149), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26769] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_LBRACE,
    ACTIONS(375), 1,
      anon_sym_LBRACK,
    ACTIONS(589), 1,
      anon_sym_RPAREN,
    ACTIONS(593), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2151), 1,
      sym_identifier,
    STATE(771), 1,
      sym_object,
    STATE(800), 1,
      sym_array,
    STATE(829), 2,
      sym_assignment_pattern,
      sym_rest_parameter,
    ACTIONS(2153), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26804] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_LBRACE,
    ACTIONS(375), 1,
      anon_sym_LBRACK,
    ACTIONS(593), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2145), 1,
      sym_identifier,
    ACTIONS(2155), 1,
      anon_sym_RPAREN,
    STATE(812), 1,
      sym_array,
    STATE(814), 1,
      sym_object,
    STATE(1009), 2,
      sym_assignment_pattern,
      sym_rest_parameter,
    ACTIONS(2149), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2159), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(2157), 7,
      anon_sym_export,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26860] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_LBRACE,
    ACTIONS(375), 1,
      anon_sym_LBRACK,
    ACTIONS(593), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2145), 1,
      sym_identifier,
    ACTIONS(2161), 1,
      anon_sym_RPAREN,
    STATE(812), 1,
      sym_array,
    STATE(814), 1,
      sym_object,
    STATE(1009), 2,
      sym_assignment_pattern,
      sym_rest_parameter,
    ACTIONS(2149), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(2163), 7,
      anon_sym_export,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26916] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(2038), 1,
      anon_sym_LPAREN,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2167), 1,
      sym_number,
    STATE(977), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1108), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26947] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_LBRACE,
    ACTIONS(375), 1,
      anon_sym_LBRACK,
    ACTIONS(593), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2145), 1,
      sym_identifier,
    ACTIONS(2169), 1,
      anon_sym_RPAREN,
    STATE(812), 1,
      sym_array,
    STATE(814), 1,
      sym_object,
    STATE(1009), 2,
      sym_assignment_pattern,
      sym_rest_parameter,
    ACTIONS(2149), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [26982] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_LBRACE,
    ACTIONS(375), 1,
      anon_sym_LBRACK,
    ACTIONS(593), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2145), 1,
      sym_identifier,
    ACTIONS(2171), 1,
      anon_sym_RPAREN,
    STATE(812), 1,
      sym_array,
    STATE(814), 1,
      sym_object,
    STATE(1009), 2,
      sym_assignment_pattern,
      sym_rest_parameter,
    ACTIONS(2149), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [27017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2096), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(2094), 7,
      anon_sym_export,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [27038] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_LBRACE,
    ACTIONS(375), 1,
      anon_sym_LBRACK,
    ACTIONS(593), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2145), 1,
      sym_identifier,
    ACTIONS(2173), 1,
      anon_sym_RPAREN,
    STATE(812), 1,
      sym_array,
    STATE(814), 1,
      sym_object,
    STATE(1009), 2,
      sym_assignment_pattern,
      sym_rest_parameter,
    ACTIONS(2149), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [27073] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(2038), 1,
      anon_sym_LPAREN,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2137), 1,
      sym_number,
    STATE(996), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1108), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [27104] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(2038), 1,
      anon_sym_LPAREN,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2076), 1,
      sym_number,
    STATE(961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1108), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [27135] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_LBRACE,
    ACTIONS(375), 1,
      anon_sym_LBRACK,
    ACTIONS(593), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2145), 1,
      sym_identifier,
    ACTIONS(2175), 1,
      anon_sym_RPAREN,
    STATE(812), 1,
      sym_array,
    STATE(814), 1,
      sym_object,
    STATE(1009), 2,
      sym_assignment_pattern,
      sym_rest_parameter,
    ACTIONS(2149), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [27170] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2179), 6,
      anon_sym_STAR,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
    ACTIONS(2177), 7,
      anon_sym_export,
      anon_sym_class,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [27191] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_SEMI,
    ACTIONS(2181), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2183), 7,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [27214] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_LBRACE,
    ACTIONS(375), 1,
      anon_sym_LBRACK,
    ACTIONS(593), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2145), 1,
      sym_identifier,
    ACTIONS(2187), 1,
      anon_sym_RPAREN,
    STATE(812), 1,
      sym_array,
    STATE(814), 1,
      sym_object,
    STATE(1009), 2,
      sym_assignment_pattern,
      sym_rest_parameter,
    ACTIONS(2149), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [27249] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2137), 1,
      sym_number,
    STATE(996), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1108), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [27277] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2076), 1,
      sym_number,
    STATE(961), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1108), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [27305] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(1100), 1,
      sym_number,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    STATE(1015), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1108), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [27333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2189), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
    ACTIONS(2191), 7,
      anon_sym_STAR,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_DQUOTE,
      anon_sym_SQUOTE,
      sym_number,
      anon_sym_AT,
  [27353] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_LBRACE,
    ACTIONS(375), 1,
      anon_sym_LBRACK,
    ACTIONS(593), 1,
      anon_sym_DOT_DOT_DOT,
    ACTIONS(2145), 1,
      sym_identifier,
    STATE(812), 1,
      sym_array,
    STATE(814), 1,
      sym_object,
    STATE(1009), 2,
      sym_assignment_pattern,
      sym_rest_parameter,
    ACTIONS(2149), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [27385] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(399), 1,
      anon_sym_DQUOTE,
    ACTIONS(401), 1,
      anon_sym_SQUOTE,
    ACTIONS(2042), 1,
      anon_sym_LBRACK,
    ACTIONS(2167), 1,
      sym_number,
    STATE(977), 3,
      sym_string,
      sym__property_name,
      sym_computed_property_name,
    ACTIONS(1108), 5,
      anon_sym_async,
      sym_identifier,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [27413] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2197), 1,
      anon_sym_COLON,
    ACTIONS(2199), 1,
      anon_sym_GT,
    ACTIONS(2201), 1,
      anon_sym_SLASH,
    ACTIONS(2203), 1,
      sym_jsx_identifier,
    ACTIONS(2205), 1,
      anon_sym_DOT,
    STATE(663), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27448] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2197), 1,
      anon_sym_COLON,
    ACTIONS(2199), 1,
      anon_sym_GT,
    ACTIONS(2203), 1,
      sym_jsx_identifier,
    ACTIONS(2205), 1,
      anon_sym_DOT,
    ACTIONS(2207), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27483] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2197), 1,
      anon_sym_COLON,
    ACTIONS(2199), 1,
      anon_sym_GT,
    ACTIONS(2203), 1,
      sym_jsx_identifier,
    ACTIONS(2205), 1,
      anon_sym_DOT,
    ACTIONS(2209), 1,
      anon_sym_SLASH,
    STATE(658), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27518] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2197), 1,
      anon_sym_COLON,
    ACTIONS(2199), 1,
      anon_sym_GT,
    ACTIONS(2203), 1,
      sym_jsx_identifier,
    ACTIONS(2205), 1,
      anon_sym_DOT,
    ACTIONS(2211), 1,
      anon_sym_SLASH,
    STATE(666), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27553] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2199), 1,
      anon_sym_GT,
    ACTIONS(2203), 1,
      sym_jsx_identifier,
    ACTIONS(2205), 1,
      anon_sym_DOT,
    ACTIONS(2211), 1,
      anon_sym_SLASH,
    STATE(666), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27585] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2199), 1,
      anon_sym_GT,
    ACTIONS(2201), 1,
      anon_sym_SLASH,
    ACTIONS(2203), 1,
      sym_jsx_identifier,
    ACTIONS(2205), 1,
      anon_sym_DOT,
    STATE(663), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27617] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2197), 1,
      anon_sym_COLON,
    ACTIONS(2199), 1,
      anon_sym_GT,
    ACTIONS(2201), 1,
      anon_sym_SLASH,
    ACTIONS(2203), 1,
      sym_jsx_identifier,
    STATE(663), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27649] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2213), 1,
      anon_sym_LT,
    ACTIONS(2215), 1,
      anon_sym_DQUOTE,
    ACTIONS(2217), 1,
      anon_sym_SQUOTE,
    STATE(668), 1,
      sym_jsx_opening_element,
    STATE(740), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      sym_string,
  [27675] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2213), 1,
      anon_sym_LT,
    ACTIONS(2215), 1,
      anon_sym_DQUOTE,
    ACTIONS(2217), 1,
      anon_sym_SQUOTE,
    STATE(668), 1,
      sym_jsx_opening_element,
    STATE(738), 5,
      sym_jsx_element,
      sym_jsx_fragment,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      sym_string,
  [27701] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2199), 1,
      anon_sym_GT,
    ACTIONS(2203), 1,
      sym_jsx_identifier,
    ACTIONS(2205), 1,
      anon_sym_DOT,
    ACTIONS(2207), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27733] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2197), 1,
      anon_sym_COLON,
    ACTIONS(2199), 1,
      anon_sym_GT,
    ACTIONS(2203), 1,
      sym_jsx_identifier,
    ACTIONS(2209), 1,
      anon_sym_SLASH,
    STATE(658), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27765] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2197), 1,
      anon_sym_COLON,
    ACTIONS(2199), 1,
      anon_sym_GT,
    ACTIONS(2203), 1,
      sym_jsx_identifier,
    ACTIONS(2207), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27797] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2199), 1,
      anon_sym_GT,
    ACTIONS(2203), 1,
      sym_jsx_identifier,
    ACTIONS(2205), 1,
      anon_sym_DOT,
    ACTIONS(2209), 1,
      anon_sym_SLASH,
    STATE(658), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27829] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2197), 1,
      anon_sym_COLON,
    ACTIONS(2199), 1,
      anon_sym_GT,
    ACTIONS(2203), 1,
      sym_jsx_identifier,
    ACTIONS(2211), 1,
      anon_sym_SLASH,
    STATE(666), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27861] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2203), 1,
      sym_jsx_identifier,
    ACTIONS(2219), 1,
      anon_sym_GT,
    ACTIONS(2221), 1,
      anon_sym_SLASH,
    STATE(670), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27890] = 7,
    ACTIONS(2223), 1,
      anon_sym_LBRACE,
    ACTIONS(2225), 1,
      anon_sym_LT,
    ACTIONS(2227), 1,
      sym_jsx_text,
    ACTIONS(2229), 1,
      sym_comment,
    STATE(553), 1,
      sym_jsx_closing_element,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(674), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [27915] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2199), 1,
      anon_sym_GT,
    ACTIONS(2203), 1,
      sym_jsx_identifier,
    ACTIONS(2209), 1,
      anon_sym_SLASH,
    STATE(658), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [27944] = 7,
    ACTIONS(2223), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2231), 1,
      anon_sym_LT,
    ACTIONS(2233), 1,
      sym_jsx_text,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(872), 1,
      sym_jsx_closing_element,
    STATE(675), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [27969] = 7,
    ACTIONS(2223), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2231), 1,
      anon_sym_LT,
    ACTIONS(2235), 1,
      sym_jsx_text,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(886), 1,
      sym_jsx_closing_element,
    STATE(661), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [27994] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2203), 1,
      sym_jsx_identifier,
    ACTIONS(2219), 1,
      anon_sym_GT,
    ACTIONS(2237), 1,
      anon_sym_SLASH,
    STATE(670), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [28023] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2199), 1,
      anon_sym_GT,
    ACTIONS(2203), 1,
      sym_jsx_identifier,
    ACTIONS(2211), 1,
      anon_sym_SLASH,
    STATE(666), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [28052] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2199), 1,
      anon_sym_GT,
    ACTIONS(2201), 1,
      anon_sym_SLASH,
    ACTIONS(2203), 1,
      sym_jsx_identifier,
    STATE(663), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [28081] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2203), 1,
      sym_jsx_identifier,
    ACTIONS(2219), 1,
      anon_sym_GT,
    ACTIONS(2239), 1,
      anon_sym_SLASH,
    STATE(670), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [28110] = 7,
    ACTIONS(2223), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2233), 1,
      sym_jsx_text,
    ACTIONS(2241), 1,
      anon_sym_LT,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(730), 1,
      sym_jsx_closing_element,
    STATE(675), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [28135] = 7,
    ACTIONS(2223), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2241), 1,
      anon_sym_LT,
    ACTIONS(2243), 1,
      sym_jsx_text,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(729), 1,
      sym_jsx_closing_element,
    STATE(667), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [28160] = 7,
    ACTIONS(2223), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2233), 1,
      sym_jsx_text,
    ACTIONS(2245), 1,
      anon_sym_LT,
    STATE(375), 1,
      sym_jsx_closing_element,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(675), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [28185] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2247), 1,
      sym_identifier,
    ACTIONS(2250), 1,
      anon_sym_LBRACE,
    ACTIONS(2253), 1,
      anon_sym_GT,
    ACTIONS(2255), 1,
      anon_sym_SLASH,
    ACTIONS(2257), 1,
      sym_jsx_identifier,
    STATE(670), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [28214] = 7,
    ACTIONS(2223), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2245), 1,
      anon_sym_LT,
    ACTIONS(2260), 1,
      sym_jsx_text,
    STATE(431), 1,
      sym_jsx_closing_element,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(669), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [28239] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2199), 1,
      anon_sym_GT,
    ACTIONS(2203), 1,
      sym_jsx_identifier,
    ACTIONS(2207), 1,
      anon_sym_SLASH,
    STATE(673), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [28268] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      sym_identifier,
    ACTIONS(2195), 1,
      anon_sym_LBRACE,
    ACTIONS(2203), 1,
      sym_jsx_identifier,
    ACTIONS(2219), 1,
      anon_sym_GT,
    ACTIONS(2262), 1,
      anon_sym_SLASH,
    STATE(670), 1,
      aux_sym_jsx_opening_element_repeat1,
    STATE(701), 1,
      sym_jsx_namespace_name,
    STATE(718), 2,
      sym_jsx_expression,
      sym_jsx_attribute,
  [28297] = 7,
    ACTIONS(2223), 1,
      anon_sym_LBRACE,
    ACTIONS(2225), 1,
      anon_sym_LT,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2233), 1,
      sym_jsx_text,
    STATE(536), 1,
      sym_jsx_closing_element,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(675), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [28322] = 6,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2264), 1,
      anon_sym_LBRACE,
    ACTIONS(2267), 1,
      anon_sym_LT,
    ACTIONS(2270), 1,
      sym_jsx_text,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(675), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [28344] = 6,
    ACTIONS(2223), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2233), 1,
      sym_jsx_text,
    ACTIONS(2273), 1,
      anon_sym_LT,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(675), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [28366] = 6,
    ACTIONS(2223), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_LT,
    ACTIONS(2277), 1,
      sym_jsx_text,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(678), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [28388] = 6,
    ACTIONS(2223), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2233), 1,
      sym_jsx_text,
    ACTIONS(2279), 1,
      anon_sym_LT,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(675), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [28410] = 6,
    ACTIONS(2223), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2281), 1,
      anon_sym_LT,
    ACTIONS(2283), 1,
      sym_jsx_text,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(680), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [28432] = 6,
    ACTIONS(2223), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2233), 1,
      sym_jsx_text,
    ACTIONS(2285), 1,
      anon_sym_LT,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(675), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [28454] = 6,
    ACTIONS(2223), 1,
      anon_sym_LBRACE,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2287), 1,
      anon_sym_LT,
    ACTIONS(2289), 1,
      sym_jsx_text,
    STATE(662), 1,
      sym_jsx_opening_element,
    STATE(676), 4,
      sym_jsx_element,
      sym_jsx_expression,
      sym_jsx_self_closing_element,
      aux_sym_jsx_element_repeat1,
  [28476] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_COLON,
    ACTIONS(2295), 1,
      anon_sym_EQ,
    ACTIONS(2291), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2293), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [28495] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 1,
      sym_identifier,
    STATE(607), 1,
      sym_decorator_member_expression,
    STATE(630), 1,
      sym_decorator_call_expression,
    ACTIONS(2299), 4,
      anon_sym_async,
      anon_sym_static,
      anon_sym_get,
      anon_sym_set,
  [28514] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_EQ,
    STATE(921), 1,
      sym__initializer,
    STATE(946), 1,
      sym_formal_parameters,
    ACTIONS(2303), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [28534] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2307), 1,
      anon_sym_default,
    ACTIONS(2310), 1,
      anon_sym_RBRACE,
    ACTIONS(2312), 1,
      anon_sym_case,
    STATE(685), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [28552] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(417), 1,
      anon_sym_LBRACE,
    ACTIONS(2315), 1,
      sym_identifier,
    STATE(706), 1,
      sym_array,
    STATE(725), 1,
      sym_object,
    STATE(790), 1,
      sym_variable_declarator,
  [28574] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2319), 1,
      anon_sym_BQUOTE,
    ACTIONS(2321), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2317), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(703), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [28592] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2323), 1,
      anon_sym_default,
    ACTIONS(2325), 1,
      anon_sym_RBRACE,
    ACTIONS(2327), 1,
      anon_sym_case,
    STATE(697), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [28610] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1434), 1,
      anon_sym_DOT,
    ACTIONS(1526), 1,
      anon_sym_LBRACK,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
  [28630] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2321), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2329), 1,
      anon_sym_BQUOTE,
    ACTIONS(2317), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(703), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [28648] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2321), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2333), 1,
      anon_sym_BQUOTE,
    ACTIONS(2331), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(690), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [28666] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(417), 1,
      anon_sym_LBRACE,
    ACTIONS(2315), 1,
      sym_identifier,
    STATE(706), 1,
      sym_array,
    STATE(725), 1,
      sym_object,
    STATE(794), 1,
      sym_variable_declarator,
  [28688] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    ACTIONS(2305), 1,
      anon_sym_EQ,
    STATE(893), 1,
      sym_formal_parameters,
    STATE(943), 1,
      sym__initializer,
    ACTIONS(2335), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [28708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2337), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2339), 4,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
      anon_sym_DOT,
  [28722] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(79), 1,
      anon_sym_BQUOTE,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1467), 1,
      anon_sym_LPAREN,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    STATE(541), 2,
      sym_template_string,
      sym_arguments,
  [28742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2341), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2343), 4,
      anon_sym_LBRACE,
      anon_sym_EQ,
      anon_sym_GT,
      sym_jsx_identifier,
  [28756] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2323), 1,
      anon_sym_default,
    ACTIONS(2327), 1,
      anon_sym_case,
    ACTIONS(2345), 1,
      anon_sym_RBRACE,
    STATE(685), 3,
      sym_switch_case,
      sym_switch_default,
      aux_sym_switch_body_repeat1,
  [28774] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      anon_sym_BQUOTE,
    ACTIONS(1426), 1,
      anon_sym_LPAREN,
    ACTIONS(1457), 1,
      anon_sym_DOT,
    ACTIONS(1650), 1,
      anon_sym_LBRACK,
    STATE(418), 2,
      sym_template_string,
      sym_arguments,
  [28794] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2321), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2349), 1,
      anon_sym_BQUOTE,
    ACTIONS(2347), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(687), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [28812] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_COMMA,
    ACTIONS(1074), 1,
      anon_sym_RBRACE,
    ACTIONS(2040), 1,
      anon_sym_EQ,
    STATE(838), 1,
      aux_sym_object_repeat1,
    ACTIONS(2038), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
  [28832] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2355), 1,
      anon_sym_EQ,
    ACTIONS(2351), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2353), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [28848] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_COMMA,
    ACTIONS(1104), 1,
      anon_sym_RBRACE,
    ACTIONS(2040), 1,
      anon_sym_EQ,
    STATE(870), 1,
      aux_sym_object_repeat1,
    ACTIONS(2038), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
  [28868] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2360), 1,
      anon_sym_BQUOTE,
    ACTIONS(2362), 1,
      anon_sym_DOLLAR_LBRACE,
    ACTIONS(2357), 2,
      sym__template_chars,
      sym_escape_sequence,
    STATE(703), 2,
      sym_template_substitution,
      aux_sym_template_string_repeat1,
  [28886] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_LBRACK,
    ACTIONS(417), 1,
      anon_sym_LBRACE,
    ACTIONS(2315), 1,
      sym_identifier,
    STATE(706), 1,
      sym_array,
    STATE(725), 1,
      sym_object,
    STATE(849), 1,
      sym_variable_declarator,
  [28908] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      sym_identifier,
    ACTIONS(2367), 1,
      anon_sym_SLASH,
    ACTIONS(2369), 1,
      sym_jsx_identifier,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [28927] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2305), 1,
      anon_sym_EQ,
    STATE(868), 1,
      sym__initializer,
    ACTIONS(1678), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [28942] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      sym_identifier,
    ACTIONS(2369), 1,
      sym_jsx_identifier,
    ACTIONS(2371), 1,
      anon_sym_SLASH,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [28961] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      sym_identifier,
    ACTIONS(2369), 1,
      sym_jsx_identifier,
    ACTIONS(2373), 1,
      anon_sym_SLASH,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [28980] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2375), 1,
      sym_identifier,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    ACTIONS(2379), 1,
      anon_sym_extends,
    STATE(492), 1,
      sym_class_body,
    STATE(916), 1,
      sym_class_heritage,
  [28999] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2305), 1,
      anon_sym_EQ,
    STATE(839), 1,
      sym__initializer,
    ACTIONS(1469), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [29014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2381), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2383), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29027] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2385), 1,
      sym_identifier,
    ACTIONS(2387), 1,
      anon_sym_GT,
    ACTIONS(2389), 1,
      sym_jsx_identifier,
    STATE(648), 1,
      sym_nested_identifier,
    STATE(664), 1,
      sym_jsx_namespace_name,
  [29046] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    ACTIONS(2379), 1,
      anon_sym_extends,
    ACTIONS(2391), 1,
      sym_identifier,
    STATE(513), 1,
      sym_class_body,
    STATE(978), 1,
      sym_class_heritage,
  [29065] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    ACTIONS(2379), 1,
      anon_sym_extends,
    ACTIONS(2393), 1,
      sym_identifier,
    STATE(513), 1,
      sym_class_body,
    STATE(978), 1,
      sym_class_heritage,
  [29084] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      sym_identifier,
    ACTIONS(2369), 1,
      sym_jsx_identifier,
    ACTIONS(2395), 1,
      anon_sym_SLASH,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [29103] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    ACTIONS(2379), 1,
      anon_sym_extends,
    ACTIONS(2397), 1,
      sym_identifier,
    STATE(513), 1,
      sym_class_body,
    STATE(978), 1,
      sym_class_heritage,
  [29122] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_LBRACE,
    ACTIONS(375), 1,
      anon_sym_LBRACK,
    ACTIONS(2399), 1,
      sym_identifier,
    STATE(1065), 1,
      sym_object,
    STATE(1067), 1,
      sym_array,
  [29141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2401), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2403), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29154] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1722), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1724), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1700), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1702), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29180] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1788), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1790), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29193] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      anon_sym_EQ,
    ACTIONS(2038), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
    ACTIONS(2066), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [29208] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2379), 1,
      anon_sym_extends,
    ACTIONS(2405), 1,
      sym_identifier,
    ACTIONS(2407), 1,
      anon_sym_LBRACE,
    STATE(397), 1,
      sym_class_body,
    STATE(942), 1,
      sym_class_heritage,
  [29227] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2409), 1,
      sym_identifier,
    ACTIONS(2411), 1,
      anon_sym_GT,
    ACTIONS(2413), 1,
      sym_jsx_identifier,
    STATE(656), 1,
      sym_nested_identifier,
    STATE(660), 1,
      sym_jsx_namespace_name,
  [29246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2305), 1,
      anon_sym_EQ,
    STATE(867), 1,
      sym__initializer,
    ACTIONS(1687), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [29261] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(2415), 1,
      anon_sym_export,
    ACTIONS(2417), 1,
      anon_sym_class,
    STATE(611), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
  [29280] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      sym_identifier,
    ACTIONS(2369), 1,
      sym_jsx_identifier,
    ACTIONS(2419), 1,
      anon_sym_SLASH,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [29299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1752), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1754), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1746), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1748), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1674), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1676), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1718), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1720), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1784), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1786), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1764), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(1766), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29377] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(361), 1,
      anon_sym_LBRACE,
    ACTIONS(375), 1,
      anon_sym_LBRACK,
    ACTIONS(2421), 1,
      sym_identifier,
    STATE(923), 1,
      sym_object,
    STATE(950), 1,
      sym_array,
  [29396] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      sym_identifier,
    ACTIONS(2369), 1,
      sym_jsx_identifier,
    ACTIONS(2423), 1,
      anon_sym_SLASH,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [29415] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    ACTIONS(2379), 1,
      anon_sym_extends,
    ACTIONS(2425), 1,
      sym_identifier,
    STATE(492), 1,
      sym_class_body,
    STATE(916), 1,
      sym_class_heritage,
  [29434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2427), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2429), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2431), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2433), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29460] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2379), 1,
      anon_sym_extends,
    ACTIONS(2407), 1,
      anon_sym_LBRACE,
    ACTIONS(2435), 1,
      sym_identifier,
    STATE(450), 1,
      sym_class_body,
    STATE(981), 1,
      sym_class_heritage,
  [29479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2437), 2,
      anon_sym_SLASH,
      sym_identifier,
    ACTIONS(2439), 3,
      anon_sym_LBRACE,
      anon_sym_GT,
      sym_jsx_identifier,
  [29492] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    ACTIONS(2379), 1,
      anon_sym_extends,
    ACTIONS(2441), 1,
      sym_identifier,
    STATE(492), 1,
      sym_class_body,
    STATE(916), 1,
      sym_class_heritage,
  [29511] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2443), 1,
      sym_identifier,
    ACTIONS(2445), 1,
      anon_sym_GT,
    ACTIONS(2447), 1,
      sym_jsx_identifier,
    STATE(649), 1,
      sym_nested_identifier,
    STATE(665), 1,
      sym_jsx_namespace_name,
  [29530] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      sym_identifier,
    ACTIONS(2369), 1,
      sym_jsx_identifier,
    ACTIONS(2449), 1,
      anon_sym_SLASH,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [29549] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      sym_identifier,
    ACTIONS(2369), 1,
      sym_jsx_identifier,
    ACTIONS(2451), 1,
      anon_sym_SLASH,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [29568] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      sym_identifier,
    ACTIONS(2369), 1,
      sym_jsx_identifier,
    ACTIONS(2453), 1,
      anon_sym_SLASH,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [29587] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      sym_identifier,
    ACTIONS(2369), 1,
      sym_jsx_identifier,
    ACTIONS(2455), 1,
      anon_sym_SLASH,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [29606] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(2457), 1,
      anon_sym_export,
    ACTIONS(2459), 1,
      anon_sym_class,
    STATE(611), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
  [29625] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2365), 1,
      sym_identifier,
    ACTIONS(2369), 1,
      sym_jsx_identifier,
    STATE(653), 1,
      sym_nested_identifier,
    STATE(672), 1,
      sym_jsx_namespace_name,
  [29641] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    ACTIONS(2461), 1,
      anon_sym_extends,
    STATE(473), 1,
      sym_class_body,
    STATE(892), 1,
      sym_class_heritage,
  [29657] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2463), 1,
      sym_identifier,
    ACTIONS(2465), 1,
      anon_sym_COMMA,
    ACTIONS(2467), 1,
      anon_sym_RBRACE,
    STATE(855), 1,
      sym__import_export_specifier,
  [29673] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2469), 1,
      sym_identifier,
    ACTIONS(2471), 1,
      sym_jsx_identifier,
    STATE(1019), 1,
      sym_nested_identifier,
    STATE(1063), 1,
      sym_jsx_namespace_name,
  [29689] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_from,
    STATE(963), 1,
      sym__from_clause,
    ACTIONS(2475), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [29703] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(2477), 1,
      anon_sym_class,
    STATE(611), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
  [29719] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    ACTIONS(2479), 1,
      sym_identifier,
    ACTIONS(2481), 1,
      anon_sym_STAR,
    STATE(969), 1,
      sym_formal_parameters,
  [29735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2483), 4,
      sym__template_chars,
      sym_escape_sequence,
      anon_sym_BQUOTE,
      anon_sym_DOLLAR_LBRACE,
  [29745] = 5,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2485), 1,
      anon_sym_DQUOTE,
    ACTIONS(2487), 1,
      aux_sym_string_token1,
    ACTIONS(2489), 1,
      sym_escape_sequence,
    STATE(774), 1,
      aux_sym_string_repeat1,
  [29761] = 5,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2491), 1,
      anon_sym_SQUOTE,
    ACTIONS(2493), 1,
      aux_sym_string_token2,
    ACTIONS(2495), 1,
      sym_escape_sequence,
    STATE(773), 1,
      aux_sym_string_repeat2,
  [29777] = 5,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2487), 1,
      aux_sym_string_token1,
    ACTIONS(2489), 1,
      sym_escape_sequence,
    ACTIONS(2491), 1,
      anon_sym_DQUOTE,
    STATE(774), 1,
      aux_sym_string_repeat1,
  [29793] = 5,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2485), 1,
      anon_sym_SQUOTE,
    ACTIONS(2493), 1,
      aux_sym_string_token2,
    ACTIONS(2495), 1,
      sym_escape_sequence,
    STATE(773), 1,
      aux_sym_string_repeat2,
  [29809] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    ACTIONS(2461), 1,
      anon_sym_extends,
    STATE(195), 1,
      sym_class_body,
    STATE(982), 1,
      sym_class_heritage,
  [29825] = 5,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2497), 1,
      anon_sym_SQUOTE,
    ACTIONS(2499), 1,
      aux_sym_string_token2,
    ACTIONS(2501), 1,
      sym_escape_sequence,
    STATE(759), 1,
      aux_sym_string_repeat2,
  [29841] = 5,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2497), 1,
      anon_sym_DQUOTE,
    ACTIONS(2503), 1,
      aux_sym_string_token1,
    ACTIONS(2505), 1,
      sym_escape_sequence,
    STATE(756), 1,
      aux_sym_string_repeat1,
  [29857] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      anon_sym_EQ,
    ACTIONS(2507), 1,
      anon_sym_COMMA,
    ACTIONS(2509), 1,
      anon_sym_RPAREN,
    STATE(817), 1,
      aux_sym_formal_parameters_repeat1,
  [29873] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    ACTIONS(2461), 1,
      anon_sym_extends,
    STATE(501), 1,
      sym_class_body,
    STATE(986), 1,
      sym_class_heritage,
  [29889] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      anon_sym_EQ,
    ACTIONS(2511), 1,
      anon_sym_COMMA,
    ACTIONS(2513), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      aux_sym_formal_parameters_repeat1,
  [29905] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    ACTIONS(2461), 1,
      anon_sym_extends,
    STATE(46), 1,
      sym_class_body,
    STATE(1031), 1,
      sym_class_heritage,
  [29921] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    ACTIONS(2461), 1,
      anon_sym_extends,
    STATE(462), 1,
      sym_class_body,
    STATE(999), 1,
      sym_class_heritage,
  [29937] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    ACTIONS(2461), 1,
      anon_sym_extends,
    STATE(193), 1,
      sym_class_body,
    STATE(1000), 1,
      sym_class_heritage,
  [29953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2038), 4,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
  [29963] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2461), 1,
      anon_sym_extends,
    ACTIONS(2515), 1,
      anon_sym_LBRACE,
    STATE(195), 1,
      sym_class_body,
    STATE(900), 1,
      sym_class_heritage,
  [29979] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2517), 1,
      anon_sym_COMMA,
    ACTIONS(2519), 1,
      anon_sym_RPAREN,
    ACTIONS(2521), 1,
      anon_sym_EQ,
    STATE(824), 1,
      aux_sym_formal_parameters_repeat1,
  [29995] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    ACTIONS(2461), 1,
      anon_sym_extends,
    STATE(508), 1,
      sym_class_body,
    STATE(1004), 1,
      sym_class_heritage,
  [30011] = 5,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2523), 1,
      anon_sym_SQUOTE,
    ACTIONS(2525), 1,
      aux_sym_string_token2,
    ACTIONS(2528), 1,
      sym_escape_sequence,
    STATE(773), 1,
      aux_sym_string_repeat2,
  [30027] = 5,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2531), 1,
      anon_sym_DQUOTE,
    ACTIONS(2533), 1,
      aux_sym_string_token1,
    ACTIONS(2536), 1,
      sym_escape_sequence,
    STATE(774), 1,
      aux_sym_string_repeat1,
  [30043] = 5,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2539), 1,
      anon_sym_DQUOTE,
    ACTIONS(2541), 1,
      aux_sym_string_token1,
    ACTIONS(2543), 1,
      sym_escape_sequence,
    STATE(779), 1,
      aux_sym_string_repeat1,
  [30059] = 5,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2539), 1,
      anon_sym_SQUOTE,
    ACTIONS(2545), 1,
      aux_sym_string_token2,
    ACTIONS(2547), 1,
      sym_escape_sequence,
    STATE(782), 1,
      aux_sym_string_repeat2,
  [30075] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2463), 1,
      sym_identifier,
    ACTIONS(2549), 1,
      anon_sym_COMMA,
    ACTIONS(2551), 1,
      anon_sym_RBRACE,
    STATE(818), 1,
      sym__import_export_specifier,
  [30091] = 5,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2553), 1,
      anon_sym_SQUOTE,
    ACTIONS(2555), 1,
      aux_sym_string_token2,
    ACTIONS(2557), 1,
      sym_escape_sequence,
    STATE(757), 1,
      aux_sym_string_repeat2,
  [30107] = 5,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2487), 1,
      aux_sym_string_token1,
    ACTIONS(2489), 1,
      sym_escape_sequence,
    ACTIONS(2559), 1,
      anon_sym_DQUOTE,
    STATE(774), 1,
      aux_sym_string_repeat1,
  [30123] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    ACTIONS(2561), 1,
      sym_identifier,
    ACTIONS(2563), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_formal_parameters,
  [30139] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2461), 1,
      anon_sym_extends,
    ACTIONS(2515), 1,
      anon_sym_LBRACE,
    STATE(193), 1,
      sym_class_body,
    STATE(917), 1,
      sym_class_heritage,
  [30155] = 5,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2493), 1,
      aux_sym_string_token2,
    ACTIONS(2495), 1,
      sym_escape_sequence,
    ACTIONS(2559), 1,
      anon_sym_SQUOTE,
    STATE(773), 1,
      aux_sym_string_repeat2,
  [30171] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2565), 1,
      anon_sym_COMMA,
    STATE(796), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(2567), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30185] = 5,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2553), 1,
      anon_sym_DQUOTE,
    ACTIONS(2569), 1,
      aux_sym_string_token1,
    ACTIONS(2571), 1,
      sym_escape_sequence,
    STATE(758), 1,
      aux_sym_string_repeat1,
  [30201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2565), 1,
      anon_sym_COMMA,
    STATE(796), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(2573), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1831), 4,
      sym__automatic_semicolon,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_EQ,
  [30225] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    ACTIONS(2575), 1,
      sym_identifier,
    ACTIONS(2577), 1,
      anon_sym_STAR,
    STATE(911), 1,
      sym_formal_parameters,
  [30241] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    ACTIONS(2579), 1,
      sym_identifier,
    ACTIONS(2581), 1,
      anon_sym_STAR,
    STATE(911), 1,
      sym_formal_parameters,
  [30257] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_LBRACE,
    ACTIONS(2461), 1,
      anon_sym_extends,
    STATE(370), 1,
      sym_class_body,
    STATE(1040), 1,
      sym_class_heritage,
  [30273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2565), 1,
      anon_sym_COMMA,
    STATE(785), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(2583), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30287] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(2585), 1,
      anon_sym_class,
    STATE(611), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
  [30303] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    ACTIONS(2461), 1,
      anon_sym_extends,
    STATE(49), 1,
      sym_class_body,
    STATE(907), 1,
      sym_class_heritage,
  [30319] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    ACTIONS(2587), 1,
      sym_identifier,
    ACTIONS(2589), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_formal_parameters,
  [30335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2565), 1,
      anon_sym_COMMA,
    STATE(783), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(2591), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30349] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2593), 1,
      sym_identifier,
    ACTIONS(2595), 1,
      sym_jsx_identifier,
    STATE(997), 1,
      sym_nested_identifier,
    STATE(1075), 1,
      sym_jsx_namespace_name,
  [30365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2597), 1,
      anon_sym_COMMA,
    STATE(796), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(2600), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30379] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2602), 1,
      sym_identifier,
    ACTIONS(2604), 1,
      sym_jsx_identifier,
    STATE(1023), 1,
      sym_nested_identifier,
    STATE(1050), 1,
      sym_jsx_namespace_name,
  [30395] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_LBRACE,
    ACTIONS(2461), 1,
      anon_sym_extends,
    STATE(427), 1,
      sym_class_body,
    STATE(920), 1,
      sym_class_heritage,
  [30411] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2606), 1,
      sym_identifier,
    ACTIONS(2608), 1,
      sym_jsx_identifier,
    STATE(1026), 1,
      sym_nested_identifier,
    STATE(1062), 1,
      sym_jsx_namespace_name,
  [30427] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2610), 1,
      anon_sym_COMMA,
    ACTIONS(2612), 1,
      anon_sym_RPAREN,
    ACTIONS(2614), 1,
      anon_sym_EQ,
    STATE(888), 1,
      aux_sym_formal_parameters_repeat1,
  [30443] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    ACTIONS(2616), 1,
      sym_identifier,
    ACTIONS(2618), 1,
      anon_sym_STAR,
    STATE(948), 1,
      sym_formal_parameters,
  [30459] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    ACTIONS(2620), 1,
      sym_identifier,
    ACTIONS(2622), 1,
      anon_sym_STAR,
    STATE(911), 1,
      sym_formal_parameters,
  [30475] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(2624), 1,
      anon_sym_class,
    STATE(611), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
  [30491] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    ACTIONS(2626), 1,
      sym_identifier,
    ACTIONS(2628), 1,
      anon_sym_STAR,
    STATE(968), 1,
      sym_formal_parameters,
  [30507] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1516), 1,
      anon_sym_LBRACE,
    ACTIONS(2630), 1,
      anon_sym_STAR,
    STATE(1048), 2,
      sym_namespace_import,
      sym_named_imports,
  [30521] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2632), 1,
      anon_sym_COMMA,
    STATE(806), 1,
      aux_sym_array_repeat1,
    ACTIONS(1822), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [30535] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_AT,
    ACTIONS(2635), 1,
      anon_sym_class,
    STATE(611), 1,
      aux_sym_export_statement_repeat1,
    STATE(635), 1,
      sym_decorator,
  [30551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 4,
      anon_sym_RBRACE,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [30561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_COMMA,
    ACTIONS(2637), 1,
      anon_sym_RBRACE,
    STATE(828), 1,
      aux_sym_object_repeat1,
  [30574] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_COMMA,
    ACTIONS(1824), 1,
      anon_sym_RBRACK,
    STATE(865), 1,
      aux_sym_array_repeat1,
  [30587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    ACTIONS(2639), 1,
      sym_identifier,
    STATE(991), 1,
      sym_formal_parameters,
  [30600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2614), 1,
      anon_sym_EQ,
    ACTIONS(2641), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [30611] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2171), 1,
      anon_sym_RPAREN,
    ACTIONS(2643), 1,
      anon_sym_COMMA,
    STATE(826), 1,
      aux_sym_formal_parameters_repeat1,
  [30624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2521), 1,
      anon_sym_EQ,
    ACTIONS(2645), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [30635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      anon_sym_EQ,
    ACTIONS(2647), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [30646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2040), 1,
      anon_sym_EQ,
    ACTIONS(2649), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [30657] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2175), 1,
      anon_sym_RPAREN,
    ACTIONS(2651), 1,
      anon_sym_COMMA,
    STATE(826), 1,
      aux_sym_formal_parameters_repeat1,
  [30670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2653), 1,
      anon_sym_COMMA,
    ACTIONS(2655), 1,
      anon_sym_RBRACE,
    STATE(852), 1,
      aux_sym_named_imports_repeat1,
  [30683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    ACTIONS(2657), 1,
      sym_identifier,
    STATE(927), 1,
      sym_formal_parameters,
  [30696] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    ACTIONS(2659), 1,
      sym_identifier,
    STATE(1018), 1,
      sym_formal_parameters,
  [30709] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2661), 1,
      anon_sym_COMMA,
    ACTIONS(2664), 1,
      anon_sym_RBRACE,
    STATE(821), 1,
      aux_sym_object_repeat1,
  [30722] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2666), 1,
      anon_sym_COMMA,
    ACTIONS(2669), 1,
      anon_sym_RBRACE,
    STATE(822), 1,
      aux_sym_export_clause_repeat1,
  [30735] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2463), 1,
      sym_identifier,
    ACTIONS(2671), 1,
      anon_sym_RBRACE,
    STATE(945), 1,
      sym__import_export_specifier,
  [30748] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2173), 1,
      anon_sym_RPAREN,
    ACTIONS(2673), 1,
      anon_sym_COMMA,
    STATE(826), 1,
      aux_sym_formal_parameters_repeat1,
  [30761] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_COMMA,
    ACTIONS(2675), 1,
      anon_sym_RBRACK,
    STATE(806), 1,
      aux_sym_array_repeat1,
  [30774] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2647), 1,
      anon_sym_RPAREN,
    ACTIONS(2677), 1,
      anon_sym_COMMA,
    STATE(826), 1,
      aux_sym_formal_parameters_repeat1,
  [30787] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    ACTIONS(2680), 1,
      sym_identifier,
    STATE(927), 1,
      sym_formal_parameters,
  [30800] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_COMMA,
    ACTIONS(2682), 1,
      anon_sym_RBRACE,
    STATE(821), 1,
      aux_sym_object_repeat1,
  [30813] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2511), 1,
      anon_sym_COMMA,
    ACTIONS(2513), 1,
      anon_sym_RPAREN,
    STATE(813), 1,
      aux_sym_formal_parameters_repeat1,
  [30826] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    ACTIONS(2684), 1,
      sym_identifier,
    STATE(927), 1,
      sym_formal_parameters,
  [30839] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_COMMA,
    ACTIONS(1820), 1,
      anon_sym_RBRACK,
    STATE(825), 1,
      aux_sym_array_repeat1,
  [30852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2686), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [30861] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    ACTIONS(2688), 1,
      sym_identifier,
    STATE(1018), 1,
      sym_formal_parameters,
  [30874] = 2,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2690), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [30883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1592), 1,
      anon_sym_EQ,
    ACTIONS(1831), 2,
      anon_sym_LPAREN,
      anon_sym_COLON,
  [30894] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2692), 1,
      anon_sym_LPAREN,
    ACTIONS(2694), 1,
      anon_sym_await,
    STATE(34), 1,
      sym__for_header,
  [30907] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_COMMA,
    ACTIONS(1820), 1,
      anon_sym_RBRACK,
    STATE(806), 1,
      aux_sym_array_repeat1,
  [30920] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_COMMA,
    ACTIONS(2696), 1,
      anon_sym_RBRACE,
    STATE(821), 1,
      aux_sym_object_repeat1,
  [30933] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2698), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [30942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2700), 1,
      sym_identifier,
    ACTIONS(2702), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2704), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [30962] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2706), 1,
      sym_identifier,
    ACTIONS(2708), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [30973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2710), 1,
      anon_sym_LPAREN,
    ACTIONS(2712), 1,
      anon_sym_await,
    STATE(32), 1,
      sym__for_header,
  [30986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_COLON,
    ACTIONS(2205), 1,
      anon_sym_DOT,
    ACTIONS(2714), 1,
      anon_sym_GT,
  [30999] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2463), 1,
      sym_identifier,
    ACTIONS(2716), 1,
      anon_sym_RBRACE,
    STATE(1005), 1,
      sym__import_export_specifier,
  [31012] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_COLON,
    ACTIONS(2205), 1,
      anon_sym_DOT,
    ACTIONS(2718), 1,
      anon_sym_GT,
  [31025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(543), 1,
      sym__automatic_semicolon,
    ACTIONS(539), 2,
      anon_sym_else,
      anon_sym_while,
  [31036] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_COLON,
    ACTIONS(2205), 1,
      anon_sym_DOT,
    ACTIONS(2720), 1,
      anon_sym_GT,
  [31049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2600), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [31058] = 2,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2381), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [31067] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    ACTIONS(2722), 1,
      sym_identifier,
    STATE(970), 1,
      sym_formal_parameters,
  [31080] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2724), 1,
      anon_sym_COMMA,
    ACTIONS(2726), 1,
      anon_sym_RBRACE,
    STATE(864), 1,
      aux_sym_named_imports_repeat1,
  [31093] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_COLON,
    ACTIONS(2205), 1,
      anon_sym_DOT,
    ACTIONS(2728), 1,
      anon_sym_GT,
  [31106] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_COMMA,
    ACTIONS(2730), 1,
      anon_sym_RPAREN,
    STATE(806), 1,
      aux_sym_array_repeat1,
  [31119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2732), 1,
      anon_sym_COMMA,
    ACTIONS(2734), 1,
      anon_sym_RBRACE,
    STATE(881), 1,
      aux_sym_export_clause_repeat1,
  [31132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2463), 1,
      sym_identifier,
    ACTIONS(2726), 1,
      anon_sym_RBRACE,
    STATE(1005), 1,
      sym__import_export_specifier,
  [31145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2738), 1,
      anon_sym_as,
    ACTIONS(2736), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [31156] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2740), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [31165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1822), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [31174] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_COMMA,
    ACTIONS(1837), 1,
      anon_sym_RPAREN,
    STATE(871), 1,
      aux_sym_array_repeat1,
  [31187] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_COMMA,
    ACTIONS(1837), 1,
      anon_sym_RPAREN,
    STATE(806), 1,
      aux_sym_array_repeat1,
  [31200] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_COMMA,
    ACTIONS(1835), 1,
      anon_sym_RPAREN,
    STATE(806), 1,
      aux_sym_array_repeat1,
  [31213] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_COMMA,
    ACTIONS(1835), 1,
      anon_sym_RPAREN,
    STATE(854), 1,
      aux_sym_array_repeat1,
  [31226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2742), 1,
      anon_sym_COMMA,
    ACTIONS(2745), 1,
      anon_sym_RBRACE,
    STATE(864), 1,
      aux_sym_named_imports_repeat1,
  [31239] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_COMMA,
    ACTIONS(2747), 1,
      anon_sym_RBRACK,
    STATE(806), 1,
      aux_sym_array_repeat1,
  [31252] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 1,
      anon_sym_DQUOTE,
    ACTIONS(77), 1,
      anon_sym_SQUOTE,
    STATE(912), 1,
      sym_string,
  [31265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2749), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [31274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2751), 3,
      sym__automatic_semicolon,
      anon_sym_COMMA,
      anon_sym_SEMI,
  [31283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_COMMA,
    ACTIONS(2753), 1,
      anon_sym_RBRACE,
    STATE(821), 1,
      aux_sym_object_repeat1,
  [31296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_COMMA,
    ACTIONS(2755), 1,
      anon_sym_RBRACE,
    STATE(821), 1,
      aux_sym_object_repeat1,
  [31309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_COMMA,
    ACTIONS(2757), 1,
      anon_sym_RPAREN,
    STATE(806), 1,
      aux_sym_array_repeat1,
  [31322] = 2,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(1674), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [31331] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 1,
      anon_sym_LBRACE,
    ACTIONS(2761), 1,
      anon_sym_LPAREN,
    STATE(196), 1,
      sym_statement_block,
  [31344] = 2,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(1718), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [31353] = 2,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2763), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [31362] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    ACTIONS(2765), 1,
      sym_identifier,
    STATE(1018), 1,
      sym_formal_parameters,
  [31375] = 2,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(1784), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [31384] = 2,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(1764), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [31393] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(557), 1,
      anon_sym_COMMA,
    ACTIONS(1824), 1,
      anon_sym_RBRACK,
    STATE(806), 1,
      aux_sym_array_repeat1,
  [31406] = 2,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2427), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [31415] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2767), 1,
      anon_sym_COMMA,
    ACTIONS(2769), 1,
      anon_sym_RBRACE,
    STATE(822), 1,
      aux_sym_export_clause_repeat1,
  [31428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2771), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [31437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2463), 1,
      sym_identifier,
    ACTIONS(2769), 1,
      anon_sym_RBRACE,
    STATE(945), 1,
      sym__import_export_specifier,
  [31450] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_COMMA,
    ACTIONS(2773), 1,
      anon_sym_RBRACE,
    STATE(869), 1,
      aux_sym_object_repeat1,
  [31463] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_COMMA,
    ACTIONS(2637), 1,
      anon_sym_RBRACE,
    STATE(821), 1,
      aux_sym_object_repeat1,
  [31476] = 2,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(1746), 3,
      anon_sym_LBRACE,
      anon_sym_LT,
      sym_jsx_text,
  [31485] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2775), 3,
      sym__automatic_semicolon,
      anon_sym_from,
      anon_sym_SEMI,
  [31494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2147), 1,
      anon_sym_RPAREN,
    ACTIONS(2777), 1,
      anon_sym_COMMA,
    STATE(826), 1,
      aux_sym_formal_parameters_repeat1,
  [31507] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_COMMA,
    ACTIONS(2773), 1,
      anon_sym_RBRACE,
    STATE(821), 1,
      aux_sym_object_repeat1,
  [31520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    ACTIONS(2779), 1,
      anon_sym_COLON,
    STATE(946), 1,
      sym_formal_parameters,
  [31533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2781), 1,
      anon_sym_LBRACE,
    STATE(463), 1,
      sym_statement_block,
  [31543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    STATE(471), 1,
      sym_class_body,
  [31553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 1,
      anon_sym_LBRACE,
    STATE(613), 1,
      sym_statement_block,
  [31563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 1,
      anon_sym_LBRACE,
    STATE(233), 1,
      sym_statement_block,
  [31573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2783), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2785), 1,
      anon_sym_LBRACE,
    STATE(192), 1,
      sym_statement_block,
  [31591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(903), 1,
      sym_formal_parameters,
  [31601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(906), 1,
      sym_formal_parameters,
  [31611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2787), 1,
      sym_identifier,
    ACTIONS(2789), 1,
      anon_sym_STAR,
  [31621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2515), 1,
      anon_sym_LBRACE,
    STATE(191), 1,
      sym_class_body,
  [31631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2791), 1,
      sym_identifier,
    ACTIONS(2793), 1,
      anon_sym_STAR,
  [31641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(896), 1,
      sym_formal_parameters,
  [31651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2785), 1,
      anon_sym_LBRACE,
    STATE(199), 1,
      sym_statement_block,
  [31661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_from,
    STATE(919), 1,
      sym__from_clause,
  [31671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2795), 1,
      anon_sym_COMMA,
    ACTIONS(2797), 1,
      anon_sym_from,
  [31681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2785), 1,
      anon_sym_LBRACE,
    STATE(198), 1,
      sym_statement_block,
  [31691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    STATE(48), 1,
      sym_class_body,
  [31701] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1847), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(1016), 1,
      sym_formal_parameters,
  [31719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(958), 1,
      sym_formal_parameters,
  [31729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2781), 1,
      anon_sym_LBRACE,
    STATE(521), 1,
      sym_statement_block,
  [31739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2799), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(964), 1,
      sym_formal_parameters,
  [31757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2463), 1,
      sym_identifier,
    STATE(1005), 1,
      sym__import_export_specifier,
  [31767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 1,
      anon_sym_LBRACE,
    STATE(612), 1,
      sym_statement_block,
  [31777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    STATE(555), 1,
      sym_class_body,
  [31787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2515), 1,
      anon_sym_LBRACE,
    STATE(210), 1,
      sym_class_body,
  [31797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(965), 1,
      sym_formal_parameters,
  [31807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2801), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_LBRACE,
    STATE(367), 1,
      sym_class_body,
  [31825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2803), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2805), 1,
      anon_sym_LPAREN,
    STATE(975), 1,
      sym_parenthesized_expression,
  [31843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2807), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [31851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2809), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [31859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2781), 1,
      anon_sym_LBRACE,
    STATE(51), 1,
      sym_statement_block,
  [31869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(925), 1,
      sym_formal_parameters,
  [31879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2781), 1,
      anon_sym_LBRACE,
    STATE(515), 1,
      sym_statement_block,
  [31889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(976), 1,
      sym_formal_parameters,
  [31899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2811), 1,
      sym_identifier,
    ACTIONS(2813), 1,
      anon_sym_STAR,
  [31909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2815), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2781), 1,
      anon_sym_LBRACE,
    STATE(56), 1,
      sym_statement_block,
  [31927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2817), 1,
      anon_sym_LBRACE,
    STATE(389), 1,
      sym_statement_block,
  [31937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2781), 1,
      anon_sym_LBRACE,
    STATE(54), 1,
      sym_statement_block,
  [31947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(1034), 1,
      sym_formal_parameters,
  [31957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2819), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [31965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2473), 1,
      anon_sym_from,
    STATE(963), 1,
      sym__from_clause,
  [31975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2821), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [31983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 1,
      anon_sym_LBRACE,
    STATE(208), 1,
      sym_statement_block,
  [31993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 1,
      anon_sym_LBRACE,
    STATE(207), 1,
      sym_statement_block,
  [32003] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1640), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [32011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1859), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [32019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_LBRACE,
    STATE(450), 1,
      sym_class_body,
  [32029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2823), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [32037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 1,
      anon_sym_LBRACE,
    STATE(205), 1,
      sym_statement_block,
  [32047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2825), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [32055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 1,
      anon_sym_LBRACE,
    STATE(616), 1,
      sym_statement_block,
  [32065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(932), 1,
      sym_formal_parameters,
  [32075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2817), 1,
      anon_sym_LBRACE,
    STATE(445), 1,
      sym_statement_block,
  [32085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2817), 1,
      anon_sym_LBRACE,
    STATE(381), 1,
      sym_statement_block,
  [32095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2827), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [32103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2829), 1,
      anon_sym_LBRACE,
    STATE(223), 1,
      sym_switch_body,
  [32113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(967), 1,
      sym_formal_parameters,
  [32123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2831), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [32131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1843), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [32139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2817), 1,
      anon_sym_LBRACE,
    STATE(382), 1,
      sym_statement_block,
  [32149] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2833), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [32157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2835), 1,
      anon_sym_LPAREN,
    STATE(36), 1,
      sym_parenthesized_expression,
  [32167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2837), 1,
      anon_sym_LBRACE,
    STATE(201), 1,
      sym_statement_block,
  [32177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(1008), 1,
      sym_formal_parameters,
  [32187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [32195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(915), 1,
      sym_formal_parameters,
  [32205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(955), 1,
      sym_formal_parameters,
  [32215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2839), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [32223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2837), 1,
      anon_sym_LBRACE,
    STATE(199), 1,
      sym_statement_block,
  [32233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2837), 1,
      anon_sym_LBRACE,
    STATE(198), 1,
      sym_statement_block,
  [32243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(1006), 1,
      sym_formal_parameters,
  [32253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2817), 1,
      anon_sym_LBRACE,
    STATE(369), 1,
      sym_statement_block,
  [32263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2781), 1,
      anon_sym_LBRACE,
    STATE(543), 1,
      sym_statement_block,
  [32273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2817), 1,
      anon_sym_LBRACE,
    STATE(364), 1,
      sym_statement_block,
  [32283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2817), 1,
      anon_sym_LBRACE,
    STATE(440), 1,
      sym_statement_block,
  [32293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(949), 1,
      sym_formal_parameters,
  [32303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(1003), 1,
      sym_formal_parameters,
  [32313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(1002), 1,
      sym_formal_parameters,
  [32323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2835), 1,
      anon_sym_LPAREN,
    STATE(951), 1,
      sym_parenthesized_expression,
  [32333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2841), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [32341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2837), 1,
      anon_sym_LBRACE,
    STATE(192), 1,
      sym_statement_block,
  [32351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(989), 1,
      sym_formal_parameters,
  [32361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    STATE(492), 1,
      sym_class_body,
  [32371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2843), 1,
      sym_identifier,
    ACTIONS(2845), 1,
      sym_jsx_identifier,
  [32381] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2847), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [32389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_LBRACE,
    STATE(444), 1,
      sym_class_body,
  [32399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    STATE(191), 1,
      sym_class_body,
  [32409] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(993), 1,
      sym_formal_parameters,
  [32419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(992), 1,
      sym_formal_parameters,
  [32429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2849), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [32437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    STATE(506), 1,
      sym_class_body,
  [32447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2781), 1,
      anon_sym_LBRACE,
    STATE(507), 1,
      sym_statement_block,
  [32457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2851), 1,
      sym_identifier,
    ACTIONS(2853), 1,
      anon_sym_STAR,
  [32467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 1,
      anon_sym_LBRACE,
    STATE(615), 1,
      sym_statement_block,
  [32477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(987), 1,
      sym_formal_parameters,
  [32487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2817), 1,
      anon_sym_LBRACE,
    STATE(446), 1,
      sym_statement_block,
  [32497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2781), 1,
      anon_sym_LBRACE,
    STATE(459), 1,
      sym_statement_block,
  [32507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2781), 1,
      anon_sym_LBRACE,
    STATE(461), 1,
      sym_statement_block,
  [32517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 1,
      anon_sym_LBRACE,
    STATE(620), 1,
      sym_statement_block,
  [32527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_COLON,
    ACTIONS(2728), 1,
      anon_sym_GT,
  [32537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(994), 1,
      sym_formal_parameters,
  [32547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2205), 1,
      anon_sym_DOT,
    ACTIONS(2728), 1,
      anon_sym_GT,
  [32557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2855), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [32565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    STATE(464), 1,
      sym_class_body,
  [32575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    STATE(210), 1,
      sym_class_body,
  [32585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1342), 1,
      anon_sym_while,
    ACTIONS(2857), 1,
      anon_sym_else,
  [32595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2781), 1,
      anon_sym_LBRACE,
    STATE(517), 1,
      sym_statement_block,
  [32605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2781), 1,
      anon_sym_LBRACE,
    STATE(522), 1,
      sym_statement_block,
  [32615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    STATE(525), 1,
      sym_class_body,
  [32625] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2859), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [32633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2781), 1,
      anon_sym_LBRACE,
    STATE(467), 1,
      sym_statement_block,
  [32643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2861), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [32651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2781), 1,
      anon_sym_LBRACE,
    STATE(526), 1,
      sym_statement_block,
  [32661] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2647), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [32669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(931), 1,
      sym_formal_parameters,
  [32679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2863), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [32687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2865), 1,
      anon_sym_LPAREN,
    STATE(28), 1,
      sym__for_header,
  [32697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2835), 1,
      anon_sym_LPAREN,
    STATE(26), 1,
      sym_parenthesized_expression,
  [32707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2759), 1,
      anon_sym_LBRACE,
    STATE(185), 1,
      sym_statement_block,
  [32717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(893), 1,
      sym_formal_parameters,
  [32727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2781), 1,
      anon_sym_LBRACE,
    STATE(47), 1,
      sym_statement_block,
  [32737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_COLON,
    ACTIONS(2720), 1,
      anon_sym_GT,
  [32747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2781), 1,
      anon_sym_LBRACE,
    STATE(549), 1,
      sym_statement_block,
  [32757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2205), 1,
      anon_sym_DOT,
    ACTIONS(2720), 1,
      anon_sym_GT,
  [32767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2867), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [32775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(933), 1,
      sym_formal_parameters,
  [32785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_COLON,
    ACTIONS(2718), 1,
      anon_sym_GT,
  [32795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2205), 1,
      anon_sym_DOT,
    ACTIONS(2718), 1,
      anon_sym_GT,
  [32805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2664), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [32813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_COLON,
    ACTIONS(2714), 1,
      anon_sym_GT,
  [32823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2205), 1,
      anon_sym_DOT,
    ACTIONS(2714), 1,
      anon_sym_GT,
  [32833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2835), 1,
      anon_sym_LPAREN,
    STATE(24), 1,
      sym_parenthesized_expression,
  [32843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1628), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [32851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2835), 1,
      anon_sym_LPAREN,
    STATE(33), 1,
      sym_parenthesized_expression,
  [32861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2835), 1,
      anon_sym_LPAREN,
    STATE(35), 1,
      sym_parenthesized_expression,
  [32871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2377), 1,
      anon_sym_LBRACE,
    STATE(53), 1,
      sym_class_body,
  [32881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2869), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [32889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2871), 2,
      sym__automatic_semicolon,
      anon_sym_SEMI,
  [32897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2785), 1,
      anon_sym_LBRACE,
    STATE(201), 1,
      sym_statement_block,
  [32907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2463), 1,
      sym_identifier,
    STATE(945), 1,
      sym__import_export_specifier,
  [32917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2835), 1,
      anon_sym_LPAREN,
    STATE(31), 1,
      sym_parenthesized_expression,
  [32927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2865), 1,
      anon_sym_LPAREN,
    STATE(38), 1,
      sym__for_header,
  [32937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2038), 1,
      anon_sym_LPAREN,
    ACTIONS(2133), 1,
      anon_sym_EQ_GT,
  [32947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2038), 1,
      anon_sym_LPAREN,
    ACTIONS(2873), 1,
      anon_sym_EQ_GT,
  [32957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2407), 1,
      anon_sym_LBRACE,
    STATE(386), 1,
      sym_class_body,
  [32967] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2875), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [32975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2877), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [32983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2879), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [32991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      anon_sym_LPAREN,
    STATE(891), 1,
      sym_formal_parameters,
  [33001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1891), 1,
      anon_sym_RPAREN,
  [33008] = 2,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2881), 1,
      sym_regex_pattern,
  [33015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2883), 1,
      sym_identifier,
  [33022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2885), 1,
      anon_sym_from,
  [33029] = 2,
    ACTIONS(2229), 1,
      sym_comment,
    ACTIONS(2887), 1,
      sym_regex_pattern,
  [33036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2718), 1,
      anon_sym_GT,
  [33043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2889), 1,
      anon_sym_GT,
  [33050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2521), 1,
      anon_sym_EQ,
  [33057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2891), 1,
      anon_sym_RPAREN,
  [33064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2893), 1,
      sym_identifier,
  [33071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2895), 1,
      anon_sym_GT,
  [33078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2614), 1,
      anon_sym_EQ,
  [33085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2897), 1,
      anon_sym_GT,
  [33092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2899), 1,
      anon_sym_GT,
  [33099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1887), 1,
      anon_sym_RPAREN,
  [33106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2901), 1,
      anon_sym_COLON,
  [33113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2903), 1,
      anon_sym_GT,
  [33120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2714), 1,
      anon_sym_GT,
  [33127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2720), 1,
      anon_sym_GT,
  [33134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2905), 1,
      anon_sym_GT,
  [33141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2907), 1,
      anon_sym_RPAREN,
  [33148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2909), 1,
      sym_identifier,
  [33155] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2911), 1,
      anon_sym_RPAREN,
  [33162] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2038), 1,
      anon_sym_LPAREN,
  [33169] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2913), 1,
      sym_identifier,
  [33176] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2915), 1,
      sym_identifier,
  [33183] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1903), 1,
      anon_sym_RPAREN,
  [33190] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2917), 1,
      anon_sym_GT,
  [33197] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2919), 1,
      sym_identifier,
  [33204] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2921), 1,
      anon_sym_GT,
  [33211] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2728), 1,
      anon_sym_GT,
  [33218] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2923), 1,
      anon_sym_GT,
  [33225] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2925), 1,
      anon_sym_GT,
  [33232] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1918), 1,
      anon_sym_RBRACE,
  [33239] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2927), 1,
      anon_sym_from,
  [33246] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2929), 1,
      anon_sym_SLASH2,
  [33253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1926), 1,
      anon_sym_RBRACE,
  [33260] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1924), 1,
      anon_sym_RBRACK,
  [33267] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2931), 1,
      anon_sym_from,
  [33274] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2933), 1,
      anon_sym_from,
  [33281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2935), 1,
      anon_sym_from,
  [33288] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1922), 1,
      anon_sym_RBRACK,
  [33295] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2937), 1,
      sym_identifier,
  [33302] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2939), 1,
      anon_sym_GT,
  [33309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2941), 1,
      sym_identifier,
  [33316] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2943), 1,
      anon_sym_RBRACE,
  [33323] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1875), 1,
      anon_sym_RPAREN,
  [33330] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2945), 1,
      anon_sym_GT,
  [33337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2133), 1,
      anon_sym_EQ_GT,
  [33344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2947), 1,
      sym_identifier,
  [33351] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1831), 1,
      anon_sym_LPAREN,
  [33358] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1885), 1,
      anon_sym_COLON,
  [33365] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2949), 1,
      sym_identifier,
  [33372] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2951), 1,
      anon_sym_target,
  [33379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2953), 1,
      anon_sym_EQ_GT,
  [33386] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_RPAREN,
  [33393] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2955), 1,
      anon_sym_EQ_GT,
  [33400] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2957), 1,
      anon_sym_while,
  [33407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1881), 1,
      anon_sym_RPAREN,
  [33414] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1873), 1,
      anon_sym_RPAREN,
  [33421] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1877), 1,
      anon_sym_RPAREN,
  [33428] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2959), 1,
      anon_sym_EQ_GT,
  [33435] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      anon_sym_RPAREN,
  [33442] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2961), 1,
      sym_identifier,
  [33449] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2963), 1,
      anon_sym_SLASH2,
  [33456] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2965), 1,
      anon_sym_EQ_GT,
  [33463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1916), 1,
      anon_sym_RPAREN,
  [33470] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1914), 1,
      anon_sym_RBRACE,
  [33477] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2967), 1,
      anon_sym_GT,
  [33484] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1869), 1,
      anon_sym_RPAREN,
  [33491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2969), 1,
      sym_identifier,
  [33498] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2971), 1,
      sym_identifier,
  [33505] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2973), 1,
      anon_sym_RBRACE,
  [33512] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2975), 1,
      anon_sym_function,
  [33519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2977), 1,
      anon_sym_from,
  [33526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2979), 1,
      sym_identifier,
  [33533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2981), 1,
      anon_sym_EQ_GT,
  [33540] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1889), 1,
      anon_sym_RPAREN,
  [33547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2983), 1,
      anon_sym_GT,
  [33554] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2985), 1,
      anon_sym_target,
  [33561] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2987), 1,
      anon_sym_as,
  [33568] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2989), 1,
      anon_sym_EQ_GT,
  [33575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1912), 1,
      anon_sym_RPAREN,
  [33582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2991), 1,
      anon_sym_from,
  [33589] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2873), 1,
      anon_sym_EQ_GT,
  [33596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2993), 1,
      ts_builtin_sym_end,
  [33603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2797), 1,
      anon_sym_from,
  [33610] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2995), 1,
      sym_identifier,
  [33617] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2997), 1,
      sym_identifier,
  [33624] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2999), 1,
      sym_identifier,
  [33631] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3001), 1,
      anon_sym_function,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(182)] = 0,
  [SMALL_STATE(183)] = 105,
  [SMALL_STATE(184)] = 204,
  [SMALL_STATE(185)] = 275,
  [SMALL_STATE(186)] = 354,
  [SMALL_STATE(187)] = 425,
  [SMALL_STATE(188)] = 524,
  [SMALL_STATE(189)] = 629,
  [SMALL_STATE(190)] = 702,
  [SMALL_STATE(191)] = 770,
  [SMALL_STATE(192)] = 840,
  [SMALL_STATE(193)] = 910,
  [SMALL_STATE(194)] = 980,
  [SMALL_STATE(195)] = 1050,
  [SMALL_STATE(196)] = 1120,
  [SMALL_STATE(197)] = 1188,
  [SMALL_STATE(198)] = 1274,
  [SMALL_STATE(199)] = 1344,
  [SMALL_STATE(200)] = 1414,
  [SMALL_STATE(201)] = 1482,
  [SMALL_STATE(202)] = 1552,
  [SMALL_STATE(203)] = 1620,
  [SMALL_STATE(204)] = 1690,
  [SMALL_STATE(205)] = 1758,
  [SMALL_STATE(206)] = 1826,
  [SMALL_STATE(207)] = 1894,
  [SMALL_STATE(208)] = 1962,
  [SMALL_STATE(209)] = 2030,
  [SMALL_STATE(210)] = 2098,
  [SMALL_STATE(211)] = 2168,
  [SMALL_STATE(212)] = 2235,
  [SMALL_STATE(213)] = 2302,
  [SMALL_STATE(214)] = 2369,
  [SMALL_STATE(215)] = 2436,
  [SMALL_STATE(216)] = 2503,
  [SMALL_STATE(217)] = 2570,
  [SMALL_STATE(218)] = 2637,
  [SMALL_STATE(219)] = 2704,
  [SMALL_STATE(220)] = 2771,
  [SMALL_STATE(221)] = 2838,
  [SMALL_STATE(222)] = 2905,
  [SMALL_STATE(223)] = 2972,
  [SMALL_STATE(224)] = 3039,
  [SMALL_STATE(225)] = 3106,
  [SMALL_STATE(226)] = 3173,
  [SMALL_STATE(227)] = 3240,
  [SMALL_STATE(228)] = 3307,
  [SMALL_STATE(229)] = 3374,
  [SMALL_STATE(230)] = 3441,
  [SMALL_STATE(231)] = 3508,
  [SMALL_STATE(232)] = 3575,
  [SMALL_STATE(233)] = 3642,
  [SMALL_STATE(234)] = 3709,
  [SMALL_STATE(235)] = 3776,
  [SMALL_STATE(236)] = 3843,
  [SMALL_STATE(237)] = 3910,
  [SMALL_STATE(238)] = 3977,
  [SMALL_STATE(239)] = 4044,
  [SMALL_STATE(240)] = 4111,
  [SMALL_STATE(241)] = 4196,
  [SMALL_STATE(242)] = 4263,
  [SMALL_STATE(243)] = 4330,
  [SMALL_STATE(244)] = 4397,
  [SMALL_STATE(245)] = 4464,
  [SMALL_STATE(246)] = 4531,
  [SMALL_STATE(247)] = 4598,
  [SMALL_STATE(248)] = 4665,
  [SMALL_STATE(249)] = 4732,
  [SMALL_STATE(250)] = 4799,
  [SMALL_STATE(251)] = 4866,
  [SMALL_STATE(252)] = 4933,
  [SMALL_STATE(253)] = 5000,
  [SMALL_STATE(254)] = 5069,
  [SMALL_STATE(255)] = 5136,
  [SMALL_STATE(256)] = 5203,
  [SMALL_STATE(257)] = 5287,
  [SMALL_STATE(258)] = 5374,
  [SMALL_STATE(259)] = 5459,
  [SMALL_STATE(260)] = 5544,
  [SMALL_STATE(261)] = 5627,
  [SMALL_STATE(262)] = 5715,
  [SMALL_STATE(263)] = 5777,
  [SMALL_STATE(264)] = 5839,
  [SMALL_STATE(265)] = 5923,
  [SMALL_STATE(266)] = 6007,
  [SMALL_STATE(267)] = 6069,
  [SMALL_STATE(268)] = 6131,
  [SMALL_STATE(269)] = 6193,
  [SMALL_STATE(270)] = 6255,
  [SMALL_STATE(271)] = 6317,
  [SMALL_STATE(272)] = 6379,
  [SMALL_STATE(273)] = 6441,
  [SMALL_STATE(274)] = 6514,
  [SMALL_STATE(275)] = 6587,
  [SMALL_STATE(276)] = 6647,
  [SMALL_STATE(277)] = 6715,
  [SMALL_STATE(278)] = 6775,
  [SMALL_STATE(279)] = 6843,
  [SMALL_STATE(280)] = 6919,
  [SMALL_STATE(281)] = 6979,
  [SMALL_STATE(282)] = 7039,
  [SMALL_STATE(283)] = 7115,
  [SMALL_STATE(284)] = 7183,
  [SMALL_STATE(285)] = 7246,
  [SMALL_STATE(286)] = 7317,
  [SMALL_STATE(287)] = 7388,
  [SMALL_STATE(288)] = 7463,
  [SMALL_STATE(289)] = 7529,
  [SMALL_STATE(290)] = 7599,
  [SMALL_STATE(291)] = 7669,
  [SMALL_STATE(292)] = 7735,
  [SMALL_STATE(293)] = 7793,
  [SMALL_STATE(294)] = 7851,
  [SMALL_STATE(295)] = 7919,
  [SMALL_STATE(296)] = 7985,
  [SMALL_STATE(297)] = 8053,
  [SMALL_STATE(298)] = 8111,
  [SMALL_STATE(299)] = 8169,
  [SMALL_STATE(300)] = 8237,
  [SMALL_STATE(301)] = 8305,
  [SMALL_STATE(302)] = 8362,
  [SMALL_STATE(303)] = 8427,
  [SMALL_STATE(304)] = 8484,
  [SMALL_STATE(305)] = 8555,
  [SMALL_STATE(306)] = 8616,
  [SMALL_STATE(307)] = 8687,
  [SMALL_STATE(308)] = 8744,
  [SMALL_STATE(309)] = 8810,
  [SMALL_STATE(310)] = 8877,
  [SMALL_STATE(311)] = 8944,
  [SMALL_STATE(312)] = 9011,
  [SMALL_STATE(313)] = 9078,
  [SMALL_STATE(314)] = 9140,
  [SMALL_STATE(315)] = 9202,
  [SMALL_STATE(316)] = 9269,
  [SMALL_STATE(317)] = 9327,
  [SMALL_STATE(318)] = 9409,
  [SMALL_STATE(319)] = 9457,
  [SMALL_STATE(320)] = 9533,
  [SMALL_STATE(321)] = 9615,
  [SMALL_STATE(322)] = 9697,
  [SMALL_STATE(323)] = 9779,
  [SMALL_STATE(324)] = 9827,
  [SMALL_STATE(325)] = 9875,
  [SMALL_STATE(326)] = 9955,
  [SMALL_STATE(327)] = 10037,
  [SMALL_STATE(328)] = 10119,
  [SMALL_STATE(329)] = 10201,
  [SMALL_STATE(330)] = 10283,
  [SMALL_STATE(331)] = 10349,
  [SMALL_STATE(332)] = 10403,
  [SMALL_STATE(333)] = 10465,
  [SMALL_STATE(334)] = 10519,
  [SMALL_STATE(335)] = 10567,
  [SMALL_STATE(336)] = 10619,
  [SMALL_STATE(337)] = 10701,
  [SMALL_STATE(338)] = 10783,
  [SMALL_STATE(339)] = 10831,
  [SMALL_STATE(340)] = 10913,
  [SMALL_STATE(341)] = 10961,
  [SMALL_STATE(342)] = 11043,
  [SMALL_STATE(343)] = 11103,
  [SMALL_STATE(344)] = 11163,
  [SMALL_STATE(345)] = 11217,
  [SMALL_STATE(346)] = 11277,
  [SMALL_STATE(347)] = 11337,
  [SMALL_STATE(348)] = 11389,
  [SMALL_STATE(349)] = 11437,
  [SMALL_STATE(350)] = 11519,
  [SMALL_STATE(351)] = 11567,
  [SMALL_STATE(352)] = 11635,
  [SMALL_STATE(353)] = 11707,
  [SMALL_STATE(354)] = 11789,
  [SMALL_STATE(355)] = 11871,
  [SMALL_STATE(356)] = 11953,
  [SMALL_STATE(357)] = 12002,
  [SMALL_STATE(358)] = 12051,
  [SMALL_STATE(359)] = 12100,
  [SMALL_STATE(360)] = 12183,
  [SMALL_STATE(361)] = 12232,
  [SMALL_STATE(362)] = 12283,
  [SMALL_STATE(363)] = 12332,
  [SMALL_STATE(364)] = 12381,
  [SMALL_STATE(365)] = 12427,
  [SMALL_STATE(366)] = 12477,
  [SMALL_STATE(367)] = 12523,
  [SMALL_STATE(368)] = 12569,
  [SMALL_STATE(369)] = 12649,
  [SMALL_STATE(370)] = 12695,
  [SMALL_STATE(371)] = 12741,
  [SMALL_STATE(372)] = 12821,
  [SMALL_STATE(373)] = 12901,
  [SMALL_STATE(374)] = 12981,
  [SMALL_STATE(375)] = 13061,
  [SMALL_STATE(376)] = 13107,
  [SMALL_STATE(377)] = 13163,
  [SMALL_STATE(378)] = 13209,
  [SMALL_STATE(379)] = 13265,
  [SMALL_STATE(380)] = 13311,
  [SMALL_STATE(381)] = 13357,
  [SMALL_STATE(382)] = 13403,
  [SMALL_STATE(383)] = 13449,
  [SMALL_STATE(384)] = 13495,
  [SMALL_STATE(385)] = 13575,
  [SMALL_STATE(386)] = 13621,
  [SMALL_STATE(387)] = 13667,
  [SMALL_STATE(388)] = 13713,
  [SMALL_STATE(389)] = 13793,
  [SMALL_STATE(390)] = 13839,
  [SMALL_STATE(391)] = 13919,
  [SMALL_STATE(392)] = 13965,
  [SMALL_STATE(393)] = 14011,
  [SMALL_STATE(394)] = 14091,
  [SMALL_STATE(395)] = 14171,
  [SMALL_STATE(396)] = 14221,
  [SMALL_STATE(397)] = 14267,
  [SMALL_STATE(398)] = 14313,
  [SMALL_STATE(399)] = 14359,
  [SMALL_STATE(400)] = 14405,
  [SMALL_STATE(401)] = 14451,
  [SMALL_STATE(402)] = 14497,
  [SMALL_STATE(403)] = 14543,
  [SMALL_STATE(404)] = 14595,
  [SMALL_STATE(405)] = 14675,
  [SMALL_STATE(406)] = 14735,
  [SMALL_STATE(407)] = 14781,
  [SMALL_STATE(408)] = 14827,
  [SMALL_STATE(409)] = 14893,
  [SMALL_STATE(410)] = 14973,
  [SMALL_STATE(411)] = 15043,
  [SMALL_STATE(412)] = 15117,
  [SMALL_STATE(413)] = 15181,
  [SMALL_STATE(414)] = 15239,
  [SMALL_STATE(415)] = 15317,
  [SMALL_STATE(416)] = 15397,
  [SMALL_STATE(417)] = 15477,
  [SMALL_STATE(418)] = 15523,
  [SMALL_STATE(419)] = 15569,
  [SMALL_STATE(420)] = 15649,
  [SMALL_STATE(421)] = 15695,
  [SMALL_STATE(422)] = 15751,
  [SMALL_STATE(423)] = 15809,
  [SMALL_STATE(424)] = 15867,
  [SMALL_STATE(425)] = 15947,
  [SMALL_STATE(426)] = 16005,
  [SMALL_STATE(427)] = 16051,
  [SMALL_STATE(428)] = 16097,
  [SMALL_STATE(429)] = 16149,
  [SMALL_STATE(430)] = 16195,
  [SMALL_STATE(431)] = 16241,
  [SMALL_STATE(432)] = 16287,
  [SMALL_STATE(433)] = 16333,
  [SMALL_STATE(434)] = 16385,
  [SMALL_STATE(435)] = 16431,
  [SMALL_STATE(436)] = 16477,
  [SMALL_STATE(437)] = 16523,
  [SMALL_STATE(438)] = 16569,
  [SMALL_STATE(439)] = 16649,
  [SMALL_STATE(440)] = 16695,
  [SMALL_STATE(441)] = 16741,
  [SMALL_STATE(442)] = 16787,
  [SMALL_STATE(443)] = 16833,
  [SMALL_STATE(444)] = 16879,
  [SMALL_STATE(445)] = 16925,
  [SMALL_STATE(446)] = 16971,
  [SMALL_STATE(447)] = 17017,
  [SMALL_STATE(448)] = 17063,
  [SMALL_STATE(449)] = 17109,
  [SMALL_STATE(450)] = 17193,
  [SMALL_STATE(451)] = 17239,
  [SMALL_STATE(452)] = 17323,
  [SMALL_STATE(453)] = 17369,
  [SMALL_STATE(454)] = 17453,
  [SMALL_STATE(455)] = 17499,
  [SMALL_STATE(456)] = 17545,
  [SMALL_STATE(457)] = 17629,
  [SMALL_STATE(458)] = 17712,
  [SMALL_STATE(459)] = 17791,
  [SMALL_STATE(460)] = 17840,
  [SMALL_STATE(461)] = 17923,
  [SMALL_STATE(462)] = 17972,
  [SMALL_STATE(463)] = 18021,
  [SMALL_STATE(464)] = 18070,
  [SMALL_STATE(465)] = 18119,
  [SMALL_STATE(466)] = 18198,
  [SMALL_STATE(467)] = 18247,
  [SMALL_STATE(468)] = 18296,
  [SMALL_STATE(469)] = 18345,
  [SMALL_STATE(470)] = 18428,
  [SMALL_STATE(471)] = 18507,
  [SMALL_STATE(472)] = 18556,
  [SMALL_STATE(473)] = 18637,
  [SMALL_STATE(474)] = 18686,
  [SMALL_STATE(475)] = 18735,
  [SMALL_STATE(476)] = 18782,
  [SMALL_STATE(477)] = 18829,
  [SMALL_STATE(478)] = 18912,
  [SMALL_STATE(479)] = 18995,
  [SMALL_STATE(480)] = 19078,
  [SMALL_STATE(481)] = 19125,
  [SMALL_STATE(482)] = 19206,
  [SMALL_STATE(483)] = 19253,
  [SMALL_STATE(484)] = 19332,
  [SMALL_STATE(485)] = 19411,
  [SMALL_STATE(486)] = 19490,
  [SMALL_STATE(487)] = 19569,
  [SMALL_STATE(488)] = 19648,
  [SMALL_STATE(489)] = 19729,
  [SMALL_STATE(490)] = 19780,
  [SMALL_STATE(491)] = 19831,
  [SMALL_STATE(492)] = 19912,
  [SMALL_STATE(493)] = 19956,
  [SMALL_STATE(494)] = 20000,
  [SMALL_STATE(495)] = 20052,
  [SMALL_STATE(496)] = 20132,
  [SMALL_STATE(497)] = 20212,
  [SMALL_STATE(498)] = 20290,
  [SMALL_STATE(499)] = 20368,
  [SMALL_STATE(500)] = 20446,
  [SMALL_STATE(501)] = 20524,
  [SMALL_STATE(502)] = 20568,
  [SMALL_STATE(503)] = 20648,
  [SMALL_STATE(504)] = 20728,
  [SMALL_STATE(505)] = 20808,
  [SMALL_STATE(506)] = 20886,
  [SMALL_STATE(507)] = 20930,
  [SMALL_STATE(508)] = 20974,
  [SMALL_STATE(509)] = 21018,
  [SMALL_STATE(510)] = 21098,
  [SMALL_STATE(511)] = 21178,
  [SMALL_STATE(512)] = 21222,
  [SMALL_STATE(513)] = 21302,
  [SMALL_STATE(514)] = 21346,
  [SMALL_STATE(515)] = 21390,
  [SMALL_STATE(516)] = 21434,
  [SMALL_STATE(517)] = 21478,
  [SMALL_STATE(518)] = 21522,
  [SMALL_STATE(519)] = 21566,
  [SMALL_STATE(520)] = 21610,
  [SMALL_STATE(521)] = 21690,
  [SMALL_STATE(522)] = 21734,
  [SMALL_STATE(523)] = 21778,
  [SMALL_STATE(524)] = 21822,
  [SMALL_STATE(525)] = 21902,
  [SMALL_STATE(526)] = 21946,
  [SMALL_STATE(527)] = 21990,
  [SMALL_STATE(528)] = 22070,
  [SMALL_STATE(529)] = 22122,
  [SMALL_STATE(530)] = 22168,
  [SMALL_STATE(531)] = 22212,
  [SMALL_STATE(532)] = 22292,
  [SMALL_STATE(533)] = 22338,
  [SMALL_STATE(534)] = 22382,
  [SMALL_STATE(535)] = 22430,
  [SMALL_STATE(536)] = 22474,
  [SMALL_STATE(537)] = 22518,
  [SMALL_STATE(538)] = 22562,
  [SMALL_STATE(539)] = 22606,
  [SMALL_STATE(540)] = 22686,
  [SMALL_STATE(541)] = 22730,
  [SMALL_STATE(542)] = 22774,
  [SMALL_STATE(543)] = 22854,
  [SMALL_STATE(544)] = 22898,
  [SMALL_STATE(545)] = 22942,
  [SMALL_STATE(546)] = 23022,
  [SMALL_STATE(547)] = 23066,
  [SMALL_STATE(548)] = 23110,
  [SMALL_STATE(549)] = 23190,
  [SMALL_STATE(550)] = 23234,
  [SMALL_STATE(551)] = 23278,
  [SMALL_STATE(552)] = 23322,
  [SMALL_STATE(553)] = 23366,
  [SMALL_STATE(554)] = 23410,
  [SMALL_STATE(555)] = 23454,
  [SMALL_STATE(556)] = 23498,
  [SMALL_STATE(557)] = 23576,
  [SMALL_STATE(558)] = 23656,
  [SMALL_STATE(559)] = 23700,
  [SMALL_STATE(560)] = 23780,
  [SMALL_STATE(561)] = 23860,
  [SMALL_STATE(562)] = 23938,
  [SMALL_STATE(563)] = 23982,
  [SMALL_STATE(564)] = 24026,
  [SMALL_STATE(565)] = 24103,
  [SMALL_STATE(566)] = 24180,
  [SMALL_STATE(567)] = 24227,
  [SMALL_STATE(568)] = 24304,
  [SMALL_STATE(569)] = 24351,
  [SMALL_STATE(570)] = 24428,
  [SMALL_STATE(571)] = 24505,
  [SMALL_STATE(572)] = 24553,
  [SMALL_STATE(573)] = 24601,
  [SMALL_STATE(574)] = 24649,
  [SMALL_STATE(575)] = 24723,
  [SMALL_STATE(576)] = 24771,
  [SMALL_STATE(577)] = 24845,
  [SMALL_STATE(578)] = 24918,
  [SMALL_STATE(579)] = 24991,
  [SMALL_STATE(580)] = 25059,
  [SMALL_STATE(581)] = 25117,
  [SMALL_STATE(582)] = 25175,
  [SMALL_STATE(583)] = 25233,
  [SMALL_STATE(584)] = 25291,
  [SMALL_STATE(585)] = 25349,
  [SMALL_STATE(586)] = 25407,
  [SMALL_STATE(587)] = 25465,
  [SMALL_STATE(588)] = 25516,
  [SMALL_STATE(589)] = 25567,
  [SMALL_STATE(590)] = 25616,
  [SMALL_STATE(591)] = 25665,
  [SMALL_STATE(592)] = 25714,
  [SMALL_STATE(593)] = 25763,
  [SMALL_STATE(594)] = 25809,
  [SMALL_STATE(595)] = 25861,
  [SMALL_STATE(596)] = 25905,
  [SMALL_STATE(597)] = 25949,
  [SMALL_STATE(598)] = 25993,
  [SMALL_STATE(599)] = 26032,
  [SMALL_STATE(600)] = 26071,
  [SMALL_STATE(601)] = 26112,
  [SMALL_STATE(602)] = 26151,
  [SMALL_STATE(603)] = 26197,
  [SMALL_STATE(604)] = 26237,
  [SMALL_STATE(605)] = 26267,
  [SMALL_STATE(606)] = 26307,
  [SMALL_STATE(607)] = 26341,
  [SMALL_STATE(608)] = 26371,
  [SMALL_STATE(609)] = 26405,
  [SMALL_STATE(610)] = 26428,
  [SMALL_STATE(611)] = 26451,
  [SMALL_STATE(612)] = 26480,
  [SMALL_STATE(613)] = 26502,
  [SMALL_STATE(614)] = 26524,
  [SMALL_STATE(615)] = 26562,
  [SMALL_STATE(616)] = 26584,
  [SMALL_STATE(617)] = 26606,
  [SMALL_STATE(618)] = 26640,
  [SMALL_STATE(619)] = 26676,
  [SMALL_STATE(620)] = 26712,
  [SMALL_STATE(621)] = 26734,
  [SMALL_STATE(622)] = 26769,
  [SMALL_STATE(623)] = 26804,
  [SMALL_STATE(624)] = 26839,
  [SMALL_STATE(625)] = 26860,
  [SMALL_STATE(626)] = 26895,
  [SMALL_STATE(627)] = 26916,
  [SMALL_STATE(628)] = 26947,
  [SMALL_STATE(629)] = 26982,
  [SMALL_STATE(630)] = 27017,
  [SMALL_STATE(631)] = 27038,
  [SMALL_STATE(632)] = 27073,
  [SMALL_STATE(633)] = 27104,
  [SMALL_STATE(634)] = 27135,
  [SMALL_STATE(635)] = 27170,
  [SMALL_STATE(636)] = 27191,
  [SMALL_STATE(637)] = 27214,
  [SMALL_STATE(638)] = 27249,
  [SMALL_STATE(639)] = 27277,
  [SMALL_STATE(640)] = 27305,
  [SMALL_STATE(641)] = 27333,
  [SMALL_STATE(642)] = 27353,
  [SMALL_STATE(643)] = 27385,
  [SMALL_STATE(644)] = 27413,
  [SMALL_STATE(645)] = 27448,
  [SMALL_STATE(646)] = 27483,
  [SMALL_STATE(647)] = 27518,
  [SMALL_STATE(648)] = 27553,
  [SMALL_STATE(649)] = 27585,
  [SMALL_STATE(650)] = 27617,
  [SMALL_STATE(651)] = 27649,
  [SMALL_STATE(652)] = 27675,
  [SMALL_STATE(653)] = 27701,
  [SMALL_STATE(654)] = 27733,
  [SMALL_STATE(655)] = 27765,
  [SMALL_STATE(656)] = 27797,
  [SMALL_STATE(657)] = 27829,
  [SMALL_STATE(658)] = 27861,
  [SMALL_STATE(659)] = 27890,
  [SMALL_STATE(660)] = 27915,
  [SMALL_STATE(661)] = 27944,
  [SMALL_STATE(662)] = 27969,
  [SMALL_STATE(663)] = 27994,
  [SMALL_STATE(664)] = 28023,
  [SMALL_STATE(665)] = 28052,
  [SMALL_STATE(666)] = 28081,
  [SMALL_STATE(667)] = 28110,
  [SMALL_STATE(668)] = 28135,
  [SMALL_STATE(669)] = 28160,
  [SMALL_STATE(670)] = 28185,
  [SMALL_STATE(671)] = 28214,
  [SMALL_STATE(672)] = 28239,
  [SMALL_STATE(673)] = 28268,
  [SMALL_STATE(674)] = 28297,
  [SMALL_STATE(675)] = 28322,
  [SMALL_STATE(676)] = 28344,
  [SMALL_STATE(677)] = 28366,
  [SMALL_STATE(678)] = 28388,
  [SMALL_STATE(679)] = 28410,
  [SMALL_STATE(680)] = 28432,
  [SMALL_STATE(681)] = 28454,
  [SMALL_STATE(682)] = 28476,
  [SMALL_STATE(683)] = 28495,
  [SMALL_STATE(684)] = 28514,
  [SMALL_STATE(685)] = 28534,
  [SMALL_STATE(686)] = 28552,
  [SMALL_STATE(687)] = 28574,
  [SMALL_STATE(688)] = 28592,
  [SMALL_STATE(689)] = 28610,
  [SMALL_STATE(690)] = 28630,
  [SMALL_STATE(691)] = 28648,
  [SMALL_STATE(692)] = 28666,
  [SMALL_STATE(693)] = 28688,
  [SMALL_STATE(694)] = 28708,
  [SMALL_STATE(695)] = 28722,
  [SMALL_STATE(696)] = 28742,
  [SMALL_STATE(697)] = 28756,
  [SMALL_STATE(698)] = 28774,
  [SMALL_STATE(699)] = 28794,
  [SMALL_STATE(700)] = 28812,
  [SMALL_STATE(701)] = 28832,
  [SMALL_STATE(702)] = 28848,
  [SMALL_STATE(703)] = 28868,
  [SMALL_STATE(704)] = 28886,
  [SMALL_STATE(705)] = 28908,
  [SMALL_STATE(706)] = 28927,
  [SMALL_STATE(707)] = 28942,
  [SMALL_STATE(708)] = 28961,
  [SMALL_STATE(709)] = 28980,
  [SMALL_STATE(710)] = 28999,
  [SMALL_STATE(711)] = 29014,
  [SMALL_STATE(712)] = 29027,
  [SMALL_STATE(713)] = 29046,
  [SMALL_STATE(714)] = 29065,
  [SMALL_STATE(715)] = 29084,
  [SMALL_STATE(716)] = 29103,
  [SMALL_STATE(717)] = 29122,
  [SMALL_STATE(718)] = 29141,
  [SMALL_STATE(719)] = 29154,
  [SMALL_STATE(720)] = 29167,
  [SMALL_STATE(721)] = 29180,
  [SMALL_STATE(722)] = 29193,
  [SMALL_STATE(723)] = 29208,
  [SMALL_STATE(724)] = 29227,
  [SMALL_STATE(725)] = 29246,
  [SMALL_STATE(726)] = 29261,
  [SMALL_STATE(727)] = 29280,
  [SMALL_STATE(728)] = 29299,
  [SMALL_STATE(729)] = 29312,
  [SMALL_STATE(730)] = 29325,
  [SMALL_STATE(731)] = 29338,
  [SMALL_STATE(732)] = 29351,
  [SMALL_STATE(733)] = 29364,
  [SMALL_STATE(734)] = 29377,
  [SMALL_STATE(735)] = 29396,
  [SMALL_STATE(736)] = 29415,
  [SMALL_STATE(737)] = 29434,
  [SMALL_STATE(738)] = 29447,
  [SMALL_STATE(739)] = 29460,
  [SMALL_STATE(740)] = 29479,
  [SMALL_STATE(741)] = 29492,
  [SMALL_STATE(742)] = 29511,
  [SMALL_STATE(743)] = 29530,
  [SMALL_STATE(744)] = 29549,
  [SMALL_STATE(745)] = 29568,
  [SMALL_STATE(746)] = 29587,
  [SMALL_STATE(747)] = 29606,
  [SMALL_STATE(748)] = 29625,
  [SMALL_STATE(749)] = 29641,
  [SMALL_STATE(750)] = 29657,
  [SMALL_STATE(751)] = 29673,
  [SMALL_STATE(752)] = 29689,
  [SMALL_STATE(753)] = 29703,
  [SMALL_STATE(754)] = 29719,
  [SMALL_STATE(755)] = 29735,
  [SMALL_STATE(756)] = 29745,
  [SMALL_STATE(757)] = 29761,
  [SMALL_STATE(758)] = 29777,
  [SMALL_STATE(759)] = 29793,
  [SMALL_STATE(760)] = 29809,
  [SMALL_STATE(761)] = 29825,
  [SMALL_STATE(762)] = 29841,
  [SMALL_STATE(763)] = 29857,
  [SMALL_STATE(764)] = 29873,
  [SMALL_STATE(765)] = 29889,
  [SMALL_STATE(766)] = 29905,
  [SMALL_STATE(767)] = 29921,
  [SMALL_STATE(768)] = 29937,
  [SMALL_STATE(769)] = 29953,
  [SMALL_STATE(770)] = 29963,
  [SMALL_STATE(771)] = 29979,
  [SMALL_STATE(772)] = 29995,
  [SMALL_STATE(773)] = 30011,
  [SMALL_STATE(774)] = 30027,
  [SMALL_STATE(775)] = 30043,
  [SMALL_STATE(776)] = 30059,
  [SMALL_STATE(777)] = 30075,
  [SMALL_STATE(778)] = 30091,
  [SMALL_STATE(779)] = 30107,
  [SMALL_STATE(780)] = 30123,
  [SMALL_STATE(781)] = 30139,
  [SMALL_STATE(782)] = 30155,
  [SMALL_STATE(783)] = 30171,
  [SMALL_STATE(784)] = 30185,
  [SMALL_STATE(785)] = 30201,
  [SMALL_STATE(786)] = 30215,
  [SMALL_STATE(787)] = 30225,
  [SMALL_STATE(788)] = 30241,
  [SMALL_STATE(789)] = 30257,
  [SMALL_STATE(790)] = 30273,
  [SMALL_STATE(791)] = 30287,
  [SMALL_STATE(792)] = 30303,
  [SMALL_STATE(793)] = 30319,
  [SMALL_STATE(794)] = 30335,
  [SMALL_STATE(795)] = 30349,
  [SMALL_STATE(796)] = 30365,
  [SMALL_STATE(797)] = 30379,
  [SMALL_STATE(798)] = 30395,
  [SMALL_STATE(799)] = 30411,
  [SMALL_STATE(800)] = 30427,
  [SMALL_STATE(801)] = 30443,
  [SMALL_STATE(802)] = 30459,
  [SMALL_STATE(803)] = 30475,
  [SMALL_STATE(804)] = 30491,
  [SMALL_STATE(805)] = 30507,
  [SMALL_STATE(806)] = 30521,
  [SMALL_STATE(807)] = 30535,
  [SMALL_STATE(808)] = 30551,
  [SMALL_STATE(809)] = 30561,
  [SMALL_STATE(810)] = 30574,
  [SMALL_STATE(811)] = 30587,
  [SMALL_STATE(812)] = 30600,
  [SMALL_STATE(813)] = 30611,
  [SMALL_STATE(814)] = 30624,
  [SMALL_STATE(815)] = 30635,
  [SMALL_STATE(816)] = 30646,
  [SMALL_STATE(817)] = 30657,
  [SMALL_STATE(818)] = 30670,
  [SMALL_STATE(819)] = 30683,
  [SMALL_STATE(820)] = 30696,
  [SMALL_STATE(821)] = 30709,
  [SMALL_STATE(822)] = 30722,
  [SMALL_STATE(823)] = 30735,
  [SMALL_STATE(824)] = 30748,
  [SMALL_STATE(825)] = 30761,
  [SMALL_STATE(826)] = 30774,
  [SMALL_STATE(827)] = 30787,
  [SMALL_STATE(828)] = 30800,
  [SMALL_STATE(829)] = 30813,
  [SMALL_STATE(830)] = 30826,
  [SMALL_STATE(831)] = 30839,
  [SMALL_STATE(832)] = 30852,
  [SMALL_STATE(833)] = 30861,
  [SMALL_STATE(834)] = 30874,
  [SMALL_STATE(835)] = 30883,
  [SMALL_STATE(836)] = 30894,
  [SMALL_STATE(837)] = 30907,
  [SMALL_STATE(838)] = 30920,
  [SMALL_STATE(839)] = 30933,
  [SMALL_STATE(840)] = 30942,
  [SMALL_STATE(841)] = 30953,
  [SMALL_STATE(842)] = 30962,
  [SMALL_STATE(843)] = 30973,
  [SMALL_STATE(844)] = 30986,
  [SMALL_STATE(845)] = 30999,
  [SMALL_STATE(846)] = 31012,
  [SMALL_STATE(847)] = 31025,
  [SMALL_STATE(848)] = 31036,
  [SMALL_STATE(849)] = 31049,
  [SMALL_STATE(850)] = 31058,
  [SMALL_STATE(851)] = 31067,
  [SMALL_STATE(852)] = 31080,
  [SMALL_STATE(853)] = 31093,
  [SMALL_STATE(854)] = 31106,
  [SMALL_STATE(855)] = 31119,
  [SMALL_STATE(856)] = 31132,
  [SMALL_STATE(857)] = 31145,
  [SMALL_STATE(858)] = 31156,
  [SMALL_STATE(859)] = 31165,
  [SMALL_STATE(860)] = 31174,
  [SMALL_STATE(861)] = 31187,
  [SMALL_STATE(862)] = 31200,
  [SMALL_STATE(863)] = 31213,
  [SMALL_STATE(864)] = 31226,
  [SMALL_STATE(865)] = 31239,
  [SMALL_STATE(866)] = 31252,
  [SMALL_STATE(867)] = 31265,
  [SMALL_STATE(868)] = 31274,
  [SMALL_STATE(869)] = 31283,
  [SMALL_STATE(870)] = 31296,
  [SMALL_STATE(871)] = 31309,
  [SMALL_STATE(872)] = 31322,
  [SMALL_STATE(873)] = 31331,
  [SMALL_STATE(874)] = 31344,
  [SMALL_STATE(875)] = 31353,
  [SMALL_STATE(876)] = 31362,
  [SMALL_STATE(877)] = 31375,
  [SMALL_STATE(878)] = 31384,
  [SMALL_STATE(879)] = 31393,
  [SMALL_STATE(880)] = 31406,
  [SMALL_STATE(881)] = 31415,
  [SMALL_STATE(882)] = 31428,
  [SMALL_STATE(883)] = 31437,
  [SMALL_STATE(884)] = 31450,
  [SMALL_STATE(885)] = 31463,
  [SMALL_STATE(886)] = 31476,
  [SMALL_STATE(887)] = 31485,
  [SMALL_STATE(888)] = 31494,
  [SMALL_STATE(889)] = 31507,
  [SMALL_STATE(890)] = 31520,
  [SMALL_STATE(891)] = 31533,
  [SMALL_STATE(892)] = 31543,
  [SMALL_STATE(893)] = 31553,
  [SMALL_STATE(894)] = 31563,
  [SMALL_STATE(895)] = 31573,
  [SMALL_STATE(896)] = 31581,
  [SMALL_STATE(897)] = 31591,
  [SMALL_STATE(898)] = 31601,
  [SMALL_STATE(899)] = 31611,
  [SMALL_STATE(900)] = 31621,
  [SMALL_STATE(901)] = 31631,
  [SMALL_STATE(902)] = 31641,
  [SMALL_STATE(903)] = 31651,
  [SMALL_STATE(904)] = 31661,
  [SMALL_STATE(905)] = 31671,
  [SMALL_STATE(906)] = 31681,
  [SMALL_STATE(907)] = 31691,
  [SMALL_STATE(908)] = 31701,
  [SMALL_STATE(909)] = 31709,
  [SMALL_STATE(910)] = 31719,
  [SMALL_STATE(911)] = 31729,
  [SMALL_STATE(912)] = 31739,
  [SMALL_STATE(913)] = 31747,
  [SMALL_STATE(914)] = 31757,
  [SMALL_STATE(915)] = 31767,
  [SMALL_STATE(916)] = 31777,
  [SMALL_STATE(917)] = 31787,
  [SMALL_STATE(918)] = 31797,
  [SMALL_STATE(919)] = 31807,
  [SMALL_STATE(920)] = 31815,
  [SMALL_STATE(921)] = 31825,
  [SMALL_STATE(922)] = 31833,
  [SMALL_STATE(923)] = 31843,
  [SMALL_STATE(924)] = 31851,
  [SMALL_STATE(925)] = 31859,
  [SMALL_STATE(926)] = 31869,
  [SMALL_STATE(927)] = 31879,
  [SMALL_STATE(928)] = 31889,
  [SMALL_STATE(929)] = 31899,
  [SMALL_STATE(930)] = 31909,
  [SMALL_STATE(931)] = 31917,
  [SMALL_STATE(932)] = 31927,
  [SMALL_STATE(933)] = 31937,
  [SMALL_STATE(934)] = 31947,
  [SMALL_STATE(935)] = 31957,
  [SMALL_STATE(936)] = 31965,
  [SMALL_STATE(937)] = 31975,
  [SMALL_STATE(938)] = 31983,
  [SMALL_STATE(939)] = 31993,
  [SMALL_STATE(940)] = 32003,
  [SMALL_STATE(941)] = 32011,
  [SMALL_STATE(942)] = 32019,
  [SMALL_STATE(943)] = 32029,
  [SMALL_STATE(944)] = 32037,
  [SMALL_STATE(945)] = 32047,
  [SMALL_STATE(946)] = 32055,
  [SMALL_STATE(947)] = 32065,
  [SMALL_STATE(948)] = 32075,
  [SMALL_STATE(949)] = 32085,
  [SMALL_STATE(950)] = 32095,
  [SMALL_STATE(951)] = 32103,
  [SMALL_STATE(952)] = 32113,
  [SMALL_STATE(953)] = 32123,
  [SMALL_STATE(954)] = 32131,
  [SMALL_STATE(955)] = 32139,
  [SMALL_STATE(956)] = 32149,
  [SMALL_STATE(957)] = 32157,
  [SMALL_STATE(958)] = 32167,
  [SMALL_STATE(959)] = 32177,
  [SMALL_STATE(960)] = 32187,
  [SMALL_STATE(961)] = 32195,
  [SMALL_STATE(962)] = 32205,
  [SMALL_STATE(963)] = 32215,
  [SMALL_STATE(964)] = 32223,
  [SMALL_STATE(965)] = 32233,
  [SMALL_STATE(966)] = 32243,
  [SMALL_STATE(967)] = 32253,
  [SMALL_STATE(968)] = 32263,
  [SMALL_STATE(969)] = 32273,
  [SMALL_STATE(970)] = 32283,
  [SMALL_STATE(971)] = 32293,
  [SMALL_STATE(972)] = 32303,
  [SMALL_STATE(973)] = 32313,
  [SMALL_STATE(974)] = 32323,
  [SMALL_STATE(975)] = 32333,
  [SMALL_STATE(976)] = 32341,
  [SMALL_STATE(977)] = 32351,
  [SMALL_STATE(978)] = 32361,
  [SMALL_STATE(979)] = 32371,
  [SMALL_STATE(980)] = 32381,
  [SMALL_STATE(981)] = 32389,
  [SMALL_STATE(982)] = 32399,
  [SMALL_STATE(983)] = 32409,
  [SMALL_STATE(984)] = 32419,
  [SMALL_STATE(985)] = 32429,
  [SMALL_STATE(986)] = 32437,
  [SMALL_STATE(987)] = 32447,
  [SMALL_STATE(988)] = 32457,
  [SMALL_STATE(989)] = 32467,
  [SMALL_STATE(990)] = 32477,
  [SMALL_STATE(991)] = 32487,
  [SMALL_STATE(992)] = 32497,
  [SMALL_STATE(993)] = 32507,
  [SMALL_STATE(994)] = 32517,
  [SMALL_STATE(995)] = 32527,
  [SMALL_STATE(996)] = 32537,
  [SMALL_STATE(997)] = 32547,
  [SMALL_STATE(998)] = 32557,
  [SMALL_STATE(999)] = 32565,
  [SMALL_STATE(1000)] = 32575,
  [SMALL_STATE(1001)] = 32585,
  [SMALL_STATE(1002)] = 32595,
  [SMALL_STATE(1003)] = 32605,
  [SMALL_STATE(1004)] = 32615,
  [SMALL_STATE(1005)] = 32625,
  [SMALL_STATE(1006)] = 32633,
  [SMALL_STATE(1007)] = 32643,
  [SMALL_STATE(1008)] = 32651,
  [SMALL_STATE(1009)] = 32661,
  [SMALL_STATE(1010)] = 32669,
  [SMALL_STATE(1011)] = 32679,
  [SMALL_STATE(1012)] = 32687,
  [SMALL_STATE(1013)] = 32697,
  [SMALL_STATE(1014)] = 32707,
  [SMALL_STATE(1015)] = 32717,
  [SMALL_STATE(1016)] = 32727,
  [SMALL_STATE(1017)] = 32737,
  [SMALL_STATE(1018)] = 32747,
  [SMALL_STATE(1019)] = 32757,
  [SMALL_STATE(1020)] = 32767,
  [SMALL_STATE(1021)] = 32775,
  [SMALL_STATE(1022)] = 32785,
  [SMALL_STATE(1023)] = 32795,
  [SMALL_STATE(1024)] = 32805,
  [SMALL_STATE(1025)] = 32813,
  [SMALL_STATE(1026)] = 32823,
  [SMALL_STATE(1027)] = 32833,
  [SMALL_STATE(1028)] = 32843,
  [SMALL_STATE(1029)] = 32851,
  [SMALL_STATE(1030)] = 32861,
  [SMALL_STATE(1031)] = 32871,
  [SMALL_STATE(1032)] = 32881,
  [SMALL_STATE(1033)] = 32889,
  [SMALL_STATE(1034)] = 32897,
  [SMALL_STATE(1035)] = 32907,
  [SMALL_STATE(1036)] = 32917,
  [SMALL_STATE(1037)] = 32927,
  [SMALL_STATE(1038)] = 32937,
  [SMALL_STATE(1039)] = 32947,
  [SMALL_STATE(1040)] = 32957,
  [SMALL_STATE(1041)] = 32967,
  [SMALL_STATE(1042)] = 32975,
  [SMALL_STATE(1043)] = 32983,
  [SMALL_STATE(1044)] = 32991,
  [SMALL_STATE(1045)] = 33001,
  [SMALL_STATE(1046)] = 33008,
  [SMALL_STATE(1047)] = 33015,
  [SMALL_STATE(1048)] = 33022,
  [SMALL_STATE(1049)] = 33029,
  [SMALL_STATE(1050)] = 33036,
  [SMALL_STATE(1051)] = 33043,
  [SMALL_STATE(1052)] = 33050,
  [SMALL_STATE(1053)] = 33057,
  [SMALL_STATE(1054)] = 33064,
  [SMALL_STATE(1055)] = 33071,
  [SMALL_STATE(1056)] = 33078,
  [SMALL_STATE(1057)] = 33085,
  [SMALL_STATE(1058)] = 33092,
  [SMALL_STATE(1059)] = 33099,
  [SMALL_STATE(1060)] = 33106,
  [SMALL_STATE(1061)] = 33113,
  [SMALL_STATE(1062)] = 33120,
  [SMALL_STATE(1063)] = 33127,
  [SMALL_STATE(1064)] = 33134,
  [SMALL_STATE(1065)] = 33141,
  [SMALL_STATE(1066)] = 33148,
  [SMALL_STATE(1067)] = 33155,
  [SMALL_STATE(1068)] = 33162,
  [SMALL_STATE(1069)] = 33169,
  [SMALL_STATE(1070)] = 33176,
  [SMALL_STATE(1071)] = 33183,
  [SMALL_STATE(1072)] = 33190,
  [SMALL_STATE(1073)] = 33197,
  [SMALL_STATE(1074)] = 33204,
  [SMALL_STATE(1075)] = 33211,
  [SMALL_STATE(1076)] = 33218,
  [SMALL_STATE(1077)] = 33225,
  [SMALL_STATE(1078)] = 33232,
  [SMALL_STATE(1079)] = 33239,
  [SMALL_STATE(1080)] = 33246,
  [SMALL_STATE(1081)] = 33253,
  [SMALL_STATE(1082)] = 33260,
  [SMALL_STATE(1083)] = 33267,
  [SMALL_STATE(1084)] = 33274,
  [SMALL_STATE(1085)] = 33281,
  [SMALL_STATE(1086)] = 33288,
  [SMALL_STATE(1087)] = 33295,
  [SMALL_STATE(1088)] = 33302,
  [SMALL_STATE(1089)] = 33309,
  [SMALL_STATE(1090)] = 33316,
  [SMALL_STATE(1091)] = 33323,
  [SMALL_STATE(1092)] = 33330,
  [SMALL_STATE(1093)] = 33337,
  [SMALL_STATE(1094)] = 33344,
  [SMALL_STATE(1095)] = 33351,
  [SMALL_STATE(1096)] = 33358,
  [SMALL_STATE(1097)] = 33365,
  [SMALL_STATE(1098)] = 33372,
  [SMALL_STATE(1099)] = 33379,
  [SMALL_STATE(1100)] = 33386,
  [SMALL_STATE(1101)] = 33393,
  [SMALL_STATE(1102)] = 33400,
  [SMALL_STATE(1103)] = 33407,
  [SMALL_STATE(1104)] = 33414,
  [SMALL_STATE(1105)] = 33421,
  [SMALL_STATE(1106)] = 33428,
  [SMALL_STATE(1107)] = 33435,
  [SMALL_STATE(1108)] = 33442,
  [SMALL_STATE(1109)] = 33449,
  [SMALL_STATE(1110)] = 33456,
  [SMALL_STATE(1111)] = 33463,
  [SMALL_STATE(1112)] = 33470,
  [SMALL_STATE(1113)] = 33477,
  [SMALL_STATE(1114)] = 33484,
  [SMALL_STATE(1115)] = 33491,
  [SMALL_STATE(1116)] = 33498,
  [SMALL_STATE(1117)] = 33505,
  [SMALL_STATE(1118)] = 33512,
  [SMALL_STATE(1119)] = 33519,
  [SMALL_STATE(1120)] = 33526,
  [SMALL_STATE(1121)] = 33533,
  [SMALL_STATE(1122)] = 33540,
  [SMALL_STATE(1123)] = 33547,
  [SMALL_STATE(1124)] = 33554,
  [SMALL_STATE(1125)] = 33561,
  [SMALL_STATE(1126)] = 33568,
  [SMALL_STATE(1127)] = 33575,
  [SMALL_STATE(1128)] = 33582,
  [SMALL_STATE(1129)] = 33589,
  [SMALL_STATE(1130)] = 33596,
  [SMALL_STATE(1131)] = 33603,
  [SMALL_STATE(1132)] = 33610,
  [SMALL_STATE(1133)] = 33617,
  [SMALL_STATE(1134)] = 33624,
  [SMALL_STATE(1135)] = 33631,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(592),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(315),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(692),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(30),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(842),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(76),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(44),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(258),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(94),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(778),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(695),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(300),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(282),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(178),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(187),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2),
  [135] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(294),
  [138] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(592),
  [141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2),
  [143] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5),
  [146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(315),
  [149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(686),
  [152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(692),
  [155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(957),
  [158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(974),
  [161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(836),
  [164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(70),
  [167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(117),
  [170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1013),
  [173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(30),
  [176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1014),
  [179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1036),
  [182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(840),
  [185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(842),
  [188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1033),
  [191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(76),
  [194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(103),
  [197] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(206),
  [200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(44),
  [203] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(65),
  [206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(712),
  [209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(1046),
  [212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(714),
  [215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(258),
  [218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(787),
  [221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(94),
  [224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(121),
  [227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(122),
  [230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(123),
  [233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(125),
  [236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(784),
  [239] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(778),
  [242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(699),
  [245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(481),
  [248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(481),
  [251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(695),
  [254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(683),
  [257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(300),
  [260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(6),
  [263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 4, .production_id = 63),
  [265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 4, .production_id = 63),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_case, 3, .production_id = 63),
  [271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_case, 3, .production_id = 63),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [275] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 3),
  [277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 3),
  [279] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_default, 2),
  [281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_default, 2),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 1),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_program, 2),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(296),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(843),
  [323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(299),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(161),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 1),
  [365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(434),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_expression, 1),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(43),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(240),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(278),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(716),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [429] = {.entry = {.count = 1, .reusable = false}}, SHIFT(122),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [437] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 2),
  [439] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 2),
  [441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 2),
  [443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 80),
  [449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 80),
  [451] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 80),
  [453] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 80),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 4, .production_id = 78),
  [459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 4, .production_id = 78),
  [461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 78),
  [463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 78),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 73),
  [469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 73),
  [471] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 73),
  [473] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 73),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 37),
  [479] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 37),
  [481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 37),
  [483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 37),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 3, .production_id = 71),
  [489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 3, .production_id = 71),
  [491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 97),
  [493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 97),
  [495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 6, .production_id = 97),
  [497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 6, .production_id = 97),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_body, 2),
  [503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_body, 2),
  [505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 91),
  [507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 91),
  [509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 5, .production_id = 91),
  [511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 5, .production_id = 91),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 87),
  [517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 5, .production_id = 87),
  [519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 87),
  [521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 87),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 4),
  [527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 4),
  [529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 87),
  [531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 87),
  [533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 5, .production_id = 87),
  [535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 5, .production_id = 87),
  [537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statement_block, 3),
  [541] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_statement_block, 3),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(104),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(109),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 1),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(261),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(477),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(496),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(560),
  [629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(311),
  [631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(124),
  [633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(574),
  [639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(488),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(472),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(419),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(341),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(274),
  [705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(361),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(698),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(285),
  [745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(559),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(373),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(491),
  [777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(265),
  [781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(495),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(570),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(567),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(485),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(484),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(449),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(451),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(390),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(564),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(416),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(394),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(565),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(336),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(405),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(408),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [1009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(569),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(412),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(353),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(346),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(319),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(352),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1039),
  [1069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(639),
  [1072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [1076] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 4), SHIFT(622),
  [1080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1),
  [1082] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 4), SHIFT(29),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [1087] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(148),
  [1090] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [1092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1038),
  [1094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [1096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [1098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [1102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(617),
  [1104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [1106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [1108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1068),
  [1110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 4),
  [1113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(619),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(633),
  [1117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, .production_id = 8),
  [1119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, .production_id = 8),
  [1121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(894),
  [1125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 28),
  [1127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 28),
  [1129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, .production_id = 8),
  [1133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, .production_id = 8),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1101),
  [1137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 9),
  [1139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 9),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1106),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [1153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [1155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [1159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 105),
  [1161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 105),
  [1163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [1165] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [1167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 104),
  [1169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 104),
  [1171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 5, .production_id = 103),
  [1173] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 5, .production_id = 103),
  [1175] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [1177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [1179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 3, .production_id = 27),
  [1181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 3, .production_id = 27),
  [1183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 39),
  [1185] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 39),
  [1187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3),
  [1189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 3),
  [1191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3, .production_id = 55),
  [1193] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3, .production_id = 55),
  [1195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 56),
  [1197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 56),
  [1199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 4, .production_id = 57),
  [1201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 4, .production_id = 57),
  [1203] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 4, .production_id = 56),
  [1205] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 4, .production_id = 56),
  [1207] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 4),
  [1209] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variable_declaration, 4),
  [1211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 4),
  [1213] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 4),
  [1215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2),
  [1217] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2),
  [1219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 5, .production_id = 90),
  [1221] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 5, .production_id = 90),
  [1223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 23),
  [1225] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 23),
  [1227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [1229] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [1231] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [1233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [1235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 4, .production_id = 64),
  [1237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 4, .production_id = 64),
  [1239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [1241] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [1243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [1245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [1247] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 3, .production_id = 31),
  [1249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 3, .production_id = 31),
  [1251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 3, .production_id = 31),
  [1253] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 3, .production_id = 31),
  [1255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 3, .production_id = 30),
  [1257] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 3, .production_id = 30),
  [1259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 29),
  [1261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 29),
  [1263] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2, .production_id = 8),
  [1265] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2, .production_id = 8),
  [1267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 65),
  [1269] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 65),
  [1271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_debugger_statement, 2),
  [1273] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_debugger_statement, 2),
  [1275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 6, .production_id = 87),
  [1277] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 6, .production_id = 87),
  [1279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 37),
  [1281] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 37),
  [1283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 83),
  [1285] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 83),
  [1287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3),
  [1289] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3),
  [1291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(622),
  [1294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 3),
  [1296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 3),
  [1298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_statement, 3, .production_id = 24),
  [1300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_statement, 3, .production_id = 24),
  [1302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_statement, 2, .production_id = 3),
  [1304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_export_statement, 2, .production_id = 3),
  [1306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_declaration, 5, .production_id = 78),
  [1308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_declaration, 5, .production_id = 78),
  [1310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 87),
  [1312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 6, .production_id = 87),
  [1314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 94),
  [1316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 94),
  [1318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 97),
  [1320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function_declaration, 7, .production_id = 97),
  [1322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 102),
  [1324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 102),
  [1326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 5, .production_id = 84),
  [1328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 5, .production_id = 84),
  [1330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lexical_declaration, 3),
  [1332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lexical_declaration, 3),
  [1334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 3, .production_id = 18),
  [1336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_statement, 3, .production_id = 18),
  [1338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 73),
  [1340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 73),
  [1342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 3, .production_id = 22),
  [1344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 3, .production_id = 22),
  [1346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(27),
  [1348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 80),
  [1350] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 80),
  [1352] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 91),
  [1354] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 91),
  [1356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1129),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [1360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [1362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [1364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(105),
  [1367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [1369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [1375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(804),
  [1377] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(634),
  [1380] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(924),
  [1383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(160),
  [1385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 100),
  [1387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 100),
  [1389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [1391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [1393] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(81),
  [1396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [1398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 92),
  [1400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 92),
  [1402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 101),
  [1404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 101),
  [1406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 93),
  [1408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 93),
  [1410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 99),
  [1412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 99),
  [1414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 6, .production_id = 98),
  [1416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 6, .production_id = 98),
  [1418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 96),
  [1420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 96),
  [1422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__for_header, 5, .production_id = 95),
  [1424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__for_header, 5, .production_id = 95),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [1428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 2, .production_id = 10),
  [1430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 2, .production_id = 10),
  [1432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [1434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [1440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 47),
  [1442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 47),
  [1444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [1446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [1448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_expression, 3, .production_id = 41),
  [1450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_expression, 3, .production_id = 41),
  [1452] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 4),
  [1455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [1463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript_expression, 4, .production_id = 79),
  [1465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript_expression, 4, .production_id = 79),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [1469] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 5),
  [1471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(96),
  [1474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [1476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [1478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(101),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [1487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [1489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [1491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [1493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [1495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(629),
  [1498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(956),
  [1501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(159),
  [1503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [1505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [1507] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym_rest_parameter, 2),
  [1510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [1512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [1514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [1516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [1518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import, 1),
  [1520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import, 1),
  [1522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 11),
  [1524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 11),
  [1526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [1528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [1530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 54),
  [1532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [1534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [1536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [1538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [1540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(174),
  [1544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [1546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(172),
  [1548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [1550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [1552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [1554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [1556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 4),
  [1558] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4),
  [1560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 50),
  [1562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 50),
  [1564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2),
  [1566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 3),
  [1568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_expression, 2),
  [1570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 2),
  [1572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [1574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4),
  [1576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4),
  [1578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 74),
  [1580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ternary_expression, 5, .production_id = 88),
  [1582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 46),
  [1584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 51),
  [1586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [1588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(168),
  [1590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array, 3),
  [1592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3),
  [1594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 40),
  [1596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 46),
  [1598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 40),
  [1600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 4, .production_id = 17),
  [1602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4, .production_id = 17),
  [1604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 42),
  [1606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, .production_id = 11),
  [1608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, .production_id = 11),
  [1610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [1612] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3),
  [1614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3),
  [1616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 3, .production_id = 48),
  [1618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object, 3, .production_id = 17),
  [1620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3, .production_id = 17),
  [1622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 52),
  [1624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 76),
  [1626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_function, 4, .production_id = 77),
  [1628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 2),
  [1630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [1632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 3, .production_id = 34),
  [1634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 3, .production_id = 34),
  [1636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(401),
  [1638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [1640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_expression, 3, .production_id = 46),
  [1642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 4, .production_id = 75),
  [1644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 4, .production_id = 75),
  [1646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(157),
  [1648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(162),
  [1650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [1652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [1654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [1660] = {.entry = {.count = 1, .reusable = false}}, SHIFT(164),
  [1662] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [1664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [1666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [1668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [1670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [1672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [1674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_element, 3, .production_id = 53),
  [1676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_element, 3, .production_id = 53),
  [1678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 7),
  [1680] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(87),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [1685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(132),
  [1687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1, .production_id = 6),
  [1689] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(98),
  [1692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [1694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(130),
  [1696] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 54),
  [1698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 48),
  [1700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [1702] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [1704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spread_element, 2),
  [1706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 3),
  [1708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 3),
  [1710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 2, .production_id = 8),
  [1712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 2, .production_id = 8),
  [1714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 45),
  [1716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 45),
  [1718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 4, .production_id = 32),
  [1720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 4, .production_id = 32),
  [1722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [1724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [1726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_regex, 4, .production_id = 68),
  [1728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_regex, 4, .production_id = 68),
  [1730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_new_expression, 3, .production_id = 44),
  [1732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_new_expression, 3, .production_id = 44),
  [1734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_template_string, 2),
  [1736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_string, 2),
  [1738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 12),
  [1740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 12),
  [1742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_update_expression, 2, .production_id = 14),
  [1744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_update_expression, 2, .production_id = 14),
  [1746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_element, 2, .production_id = 15),
  [1748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_element, 2, .production_id = 15),
  [1750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 74),
  [1752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_fragment, 6),
  [1754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_fragment, 6),
  [1756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 76),
  [1758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 4, .production_id = 77),
  [1760] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 4, .production_id = 75),
  [1762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 4, .production_id = 75),
  [1764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_closing_element, 4, .production_id = 89),
  [1766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_closing_element, 4, .production_id = 89),
  [1768] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_meta_property, 3),
  [1770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_property, 3),
  [1772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 4, .production_id = 81),
  [1774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 4, .production_id = 81),
  [1776] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function, 3, .production_id = 43),
  [1778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function, 3, .production_id = 43),
  [1780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_function, 5, .production_id = 86),
  [1782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_function, 5, .production_id = 86),
  [1784] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_self_closing_element, 5, .production_id = 66),
  [1786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_self_closing_element, 5, .production_id = 66),
  [1788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_fragment, 5),
  [1790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_fragment, 5),
  [1792] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 52), REDUCE(sym_assignment_expression, 3, .production_id = 52),
  [1795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 52),
  [1797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class, 3, .production_id = 38),
  [1799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class, 3, .production_id = 38),
  [1801] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 59), REDUCE(sym_assignment_expression, 3, .production_id = 40),
  [1804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 59),
  [1806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 59), REDUCE(sym_assignment_expression, 3, .production_id = 46),
  [1809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_function, 3, .production_id = 42),
  [1811] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 51), REDUCE(sym_assignment_expression, 3, .production_id = 51),
  [1814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_pattern, 3, .production_id = 51),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [1818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__initializer, 2, .production_id = 63),
  [1820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [1822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2),
  [1824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [1828] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [1831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_computed_property_name, 3),
  [1833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [1835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [1837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [1839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [1841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [1843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [1845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [1847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1849] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(82),
  [1852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [1854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__expression, 1), SHIFT(84),
  [1857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [1859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [1861] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(621),
  [1864] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(937),
  [1867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [1869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [1871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [1873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [1877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [1879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 60),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [1883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [1885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [1887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [1889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [1891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [1893] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(631),
  [1896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), SHIFT(1032),
  [1899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [1901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [1903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [1905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [1907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [1910] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1),
  [1912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [1914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [1916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [1918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [1920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [1922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [1924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [1926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [1928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [1930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_heritage, 2),
  [1932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [1934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym_rest_parameter, 2, .production_id = 25),
  [1937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1939] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__expression, 1), REDUCE(sym_rest_parameter, 2, .production_id = 26),
  [1942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [1944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [1946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [1948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [1950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(589),
  [1954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [1956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(587),
  [1958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(597),
  [1960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [1962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [1964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(591),
  [1966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(588),
  [1968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(596),
  [1970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(722),
  [1972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 1),
  [1974] = {.entry = {.count = 1, .reusable = false}}, SHIFT(595),
  [1976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(593),
  [1978] = {.entry = {.count = 1, .reusable = false}}, SHIFT(598),
  [1980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [1982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [1984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [1986] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [1988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [1990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(600),
  [1992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(608),
  [1994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [1996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [1998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [2000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [2002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72), SHIFT_REPEAT(769),
  [2005] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72), SHIFT_REPEAT(640),
  [2008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72),
  [2010] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72), SHIFT_REPEAT(114),
  [2013] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72), SHIFT_REPEAT(601),
  [2016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72), SHIFT_REPEAT(784),
  [2019] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72), SHIFT_REPEAT(778),
  [2022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72), SHIFT_REPEAT(684),
  [2025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72), SHIFT_REPEAT(683),
  [2028] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72), SHIFT_REPEAT(600),
  [2031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 72), SHIFT_REPEAT(608),
  [2034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [2036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [2038] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__property_name, 1, .production_id = 4),
  [2040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [2042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [2044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [2046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [2048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [2050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [2052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [2054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [2056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [2062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [2066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 17),
  [2068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [2070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [2072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [2074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [2076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [2078] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [2080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(599),
  [2082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [2084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [2086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [2088] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2, .production_id = 13),
  [2090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2, .production_id = 13),
  [2092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [2094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator, 2),
  [2096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 2),
  [2098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1094),
  [2100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 47),
  [2102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 47),
  [2104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 41),
  [2106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_member_expression, 3, .production_id = 41),
  [2108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 16),
  [2110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 16),
  [2112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 2, .production_id = 16), SHIFT_REPEAT(683),
  [2115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 5, .production_id = 87),
  [2117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 5, .production_id = 87),
  [2119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 4, .production_id = 78),
  [2121] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 4, .production_id = 78),
  [2123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(618),
  [2125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 7, .production_id = 106),
  [2127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 7, .production_id = 106),
  [2129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 3, .production_id = 61),
  [2131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 3, .production_id = 61),
  [2133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [2139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(627),
  [2141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_definition, 6, .production_id = 97),
  [2143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_definition, 6, .production_id = 97),
  [2145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [2149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(816),
  [2151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [2153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [2155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [2157] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 49),
  [2159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 49),
  [2161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [2163] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 12),
  [2165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator_call_expression, 2, .production_id = 12),
  [2167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [2169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [2171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [2177] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [2179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_statement_repeat1, 1, .production_id = 2),
  [2181] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 1, .production_id = 35),
  [2183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 1, .production_id = 35),
  [2185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [2187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [2189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 35),
  [2191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_class_body_repeat1, 2, .production_id = 35),
  [2193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [2195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [2197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [2199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [2201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [2203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [2205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [2207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [2209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1088),
  [2211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1074),
  [2213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [2217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [2219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [2221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [2223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [2225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [2227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [2229] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [2231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [2233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [2235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [2237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [2239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1123),
  [2241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [2243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(667),
  [2245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(735),
  [2247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 67), SHIFT_REPEAT(682),
  [2250] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 67), SHIFT_REPEAT(74),
  [2253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 67),
  [2255] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 67),
  [2257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_jsx_opening_element_repeat1, 2, .production_id = 67), SHIFT_REPEAT(682),
  [2260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(669),
  [2262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1064),
  [2264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(71),
  [2267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(748),
  [2270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_jsx_element_repeat1, 2), SHIFT_REPEAT(675),
  [2273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [2275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [2277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(678),
  [2279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(705),
  [2281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [2283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [2285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [2287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [2289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [2291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 1, .production_id = 4),
  [2293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 1, .production_id = 4),
  [2295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [2297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(607),
  [2299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [2303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 1, .production_id = 36),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [2307] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(1060),
  [2310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [2312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(111),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [2327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [2329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [2331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [2335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 69),
  [2337] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nested_identifier, 3),
  [2339] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nested_identifier, 3),
  [2341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_namespace_name, 3),
  [2343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_namespace_name, 3),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [2347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [2349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [2351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 1),
  [2353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 1),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [2357] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(703),
  [2360] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2),
  [2362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(92),
  [2365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(645),
  [2367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [2369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [2371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [2373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [2375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [2377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [2379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [2381] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_expression, 3),
  [2383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_expression, 3),
  [2385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(647),
  [2387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [2389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [2391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [2393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(792),
  [2395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [2397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [2399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [2401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_jsx_opening_element_repeat1, 1, .production_id = 33),
  [2403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_jsx_opening_element_repeat1, 1, .production_id = 33),
  [2405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [2407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [2409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(646),
  [2411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [2413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [2417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [2419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [2421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [2423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(795),
  [2425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [2427] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_expression, 2),
  [2429] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_expression, 2),
  [2431] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 3, .production_id = 4),
  [2433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 3, .production_id = 4),
  [2435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [2437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_attribute, 3),
  [2439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_jsx_attribute, 3),
  [2441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [2443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(644),
  [2445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [2447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [2449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [2451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(797),
  [2453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [2455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [2457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [2459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [2463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [2467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [2469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(848),
  [2471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [2475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [2477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [2479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [2481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [2483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_template_substitution, 3),
  [2485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [2487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [2489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(774),
  [2491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(383),
  [2493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [2495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(773),
  [2497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [2499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [2501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [2503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [2505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(756),
  [2507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [2509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [2511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [2513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [2515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [2517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [2519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [2521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [2523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2),
  [2525] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(773),
  [2528] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(773),
  [2531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2),
  [2533] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(774),
  [2536] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(774),
  [2539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [2541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [2543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(779),
  [2545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [2547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(782),
  [2549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [2551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [2553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [2557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(757),
  [2559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(720),
  [2561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [2563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [2565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [2567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [2569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [2571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [2573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [2575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [2577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [2579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [2581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [2583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [2585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [2587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [2589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(830),
  [2591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [2593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(853),
  [2595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [2597] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(704),
  [2600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [2602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [2604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [2606] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [2608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [2610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [2612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(937),
  [2614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [2616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [2618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [2620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [2622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [2624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [2626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [2628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [2630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [2632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(64),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [2637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [2639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [2641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 26),
  [2643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [2645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 25),
  [2647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [2649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2, .production_id = 13),
  [2651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [2659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [2661] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(579),
  [2664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2),
  [2666] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(1035),
  [2669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [2677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(642),
  [2680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [2682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [2684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [2686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 4, .production_id = 58),
  [2688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [2690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 3, .dynamic_precedence = -1, .production_id = 32),
  [2692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [2694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [2696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [2698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 19),
  [2700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [2702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [2704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 5, .production_id = 58),
  [2706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [2708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [2710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [2712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [2714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [2716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [2718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [2720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [2722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [2724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [2726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [2728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [2730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [2732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [2734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [2736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 1, .production_id = 5),
  [2738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [2740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 2),
  [2742] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(914),
  [2745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [2749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 20),
  [2751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2, .production_id = 21),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [2757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [2759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [2761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [2763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_jsx_opening_element, 4, .dynamic_precedence = -1, .production_id = 66),
  [2765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [2767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [2769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [2771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3, .production_id = 58),
  [2773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [2775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_export_clause, 3),
  [2777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [2779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [2781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [2783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [2785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [2789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [2791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [2793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [2797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 1),
  [2799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__from_clause, 2, .production_id = 18),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [2803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 2, .production_id = 70),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [2807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_parameter, 2, .production_id = 25),
  [2809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3, .production_id = 13),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [2813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [2815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [2817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [2821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3, .production_id = 26),
  [2823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_public_field_definition, 3, .production_id = 85),
  [2825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 58),
  [2827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_parameter, 2, .production_id = 26),
  [2829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [2831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5, .production_id = 13),
  [2833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [2841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [2843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(696),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [2847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4, .production_id = 26),
  [2849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rest_parameter, 2),
  [2851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [2853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [2855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_export_specifier, 3, .production_id = 82),
  [2857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [2859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 62),
  [2861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4),
  [2863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4, .production_id = 13),
  [2865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [2867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 4, .production_id = 25),
  [2869] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 3, .production_id = 25),
  [2871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [2873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [2875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5, .production_id = 26),
  [2877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5, .production_id = 25),
  [2879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_formal_parameters, 5),
  [2881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1080),
  [2883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [2885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_clause, 3),
  [2887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1109),
  [2889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [2891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [2895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [2897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [2899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [2901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [2903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [2905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [2907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [2911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [2913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [2915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [2917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [2921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [2923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [2925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [2927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3),
  [2929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [2931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 4, .production_id = 62),
  [2933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_import, 3),
  [2935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 5, .production_id = 62),
  [2937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [2939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [2941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [2943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [2945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [2947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [2949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [2951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [2953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [2955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [2957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [2959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [2961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [2963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [2965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [2967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [2969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [2971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(770),
  [2973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [2975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [2977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 2),
  [2979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [2983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [2985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [2987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [2989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [2991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_imports, 3, .production_id = 62),
  [2993] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [2997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [2999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [3001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_mozjs_external_scanner_create(void);
void tree_sitter_mozjs_external_scanner_destroy(void *);
bool tree_sitter_mozjs_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_mozjs_external_scanner_serialize(void *, char *);
void tree_sitter_mozjs_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_mozjs(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .public_symbol_map = ts_symbol_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_mozjs_external_scanner_create,
      tree_sitter_mozjs_external_scanner_destroy,
      tree_sitter_mozjs_external_scanner_scan,
      tree_sitter_mozjs_external_scanner_serialize,
      tree_sitter_mozjs_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
