#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 11
#define STATE_COUNT 1031
#define LARGE_STATE_COUNT 96
#define SYMBOL_COUNT 220
#define ALIAS_COUNT 0
#define TOKEN_COUNT 101
#define EXTERNAL_TOKEN_COUNT 6
#define FIELD_COUNT 25
#define MAX_ALIAS_SEQUENCE_LENGTH 9

enum {
  sym_identifier = 1,
  anon_sym_import = 2,
  anon_sym_DOT = 3,
  anon_sym_from = 4,
  anon_sym___future__ = 5,
  anon_sym_LPAREN = 6,
  anon_sym_RPAREN = 7,
  anon_sym_COMMA = 8,
  anon_sym_as = 9,
  anon_sym_STAR = 10,
  anon_sym_print = 11,
  anon_sym_GT_GT = 12,
  anon_sym_assert = 13,
  anon_sym_COLON_EQ = 14,
  anon_sym_return = 15,
  anon_sym_del = 16,
  anon_sym_raise = 17,
  anon_sym_pass = 18,
  anon_sym_break = 19,
  anon_sym_continue = 20,
  anon_sym_if = 21,
  anon_sym_COLON = 22,
  anon_sym_elif = 23,
  anon_sym_else = 24,
  anon_sym_async = 25,
  anon_sym_for = 26,
  anon_sym_in = 27,
  anon_sym_while = 28,
  anon_sym_try = 29,
  anon_sym_except = 30,
  anon_sym_finally = 31,
  anon_sym_with = 32,
  anon_sym_def = 33,
  anon_sym_DASH_GT = 34,
  anon_sym_EQ = 35,
  anon_sym_STAR_STAR = 36,
  anon_sym_global = 37,
  anon_sym_nonlocal = 38,
  anon_sym_exec = 39,
  anon_sym_class = 40,
  anon_sym_AT = 41,
  anon_sym_not = 42,
  anon_sym_and = 43,
  anon_sym_or = 44,
  anon_sym_PLUS = 45,
  anon_sym_DASH = 46,
  anon_sym_SLASH = 47,
  anon_sym_PERCENT = 48,
  anon_sym_SLASH_SLASH = 49,
  anon_sym_PIPE = 50,
  anon_sym_AMP = 51,
  anon_sym_CARET = 52,
  anon_sym_LT_LT = 53,
  anon_sym_TILDE = 54,
  anon_sym_LT = 55,
  anon_sym_LT_EQ = 56,
  anon_sym_EQ_EQ = 57,
  anon_sym_BANG_EQ = 58,
  anon_sym_GT_EQ = 59,
  anon_sym_GT = 60,
  anon_sym_LT_GT = 61,
  anon_sym_is = 62,
  anon_sym_lambda = 63,
  anon_sym_PLUS_EQ = 64,
  anon_sym_DASH_EQ = 65,
  anon_sym_STAR_EQ = 66,
  anon_sym_SLASH_EQ = 67,
  anon_sym_AT_EQ = 68,
  anon_sym_SLASH_SLASH_EQ = 69,
  anon_sym_PERCENT_EQ = 70,
  anon_sym_STAR_STAR_EQ = 71,
  anon_sym_GT_GT_EQ = 72,
  anon_sym_LT_LT_EQ = 73,
  anon_sym_AMP_EQ = 74,
  anon_sym_CARET_EQ = 75,
  anon_sym_PIPE_EQ = 76,
  anon_sym_yield = 77,
  anon_sym_LBRACK = 78,
  anon_sym_RBRACK = 79,
  sym_ellipsis = 80,
  anon_sym_LBRACE = 81,
  anon_sym_RBRACE = 82,
  sym_escape_sequence = 83,
  sym__not_escape_sequence = 84,
  aux_sym_format_specifier_token1 = 85,
  sym_type_conversion = 86,
  sym_integer = 87,
  sym_float = 88,
  sym_true = 89,
  sym_false = 90,
  sym_none = 91,
  anon_sym_await = 92,
  sym_comment = 93,
  sym__semicolon = 94,
  sym__newline = 95,
  sym__indent = 96,
  sym__dedent = 97,
  sym__string_start = 98,
  sym__string_content = 99,
  sym__string_end = 100,
  sym_module = 101,
  sym__statement = 102,
  sym__simple_statements = 103,
  sym_import_statement = 104,
  sym_import_prefix = 105,
  sym_relative_import = 106,
  sym_future_import_statement = 107,
  sym_import_from_statement = 108,
  sym__import_list = 109,
  sym_aliased_import = 110,
  sym_wildcard_import = 111,
  sym_print_statement = 112,
  sym_chevron = 113,
  sym_assert_statement = 114,
  sym_expression_statement = 115,
  sym_named_expression = 116,
  sym_return_statement = 117,
  sym_delete_statement = 118,
  sym_raise_statement = 119,
  sym_pass_statement = 120,
  sym_break_statement = 121,
  sym_continue_statement = 122,
  sym_if_statement = 123,
  sym_elif_clause = 124,
  sym_else_clause = 125,
  sym_for_statement = 126,
  sym_while_statement = 127,
  sym_try_statement = 128,
  sym_except_clause = 129,
  sym_finally_clause = 130,
  sym_with_statement = 131,
  sym_with_item = 132,
  sym_function_definition = 133,
  sym_parameters = 134,
  sym_lambda_parameters = 135,
  sym__parameters = 136,
  sym_default_parameter = 137,
  sym_typed_default_parameter = 138,
  sym_list_splat = 139,
  sym_dictionary_splat = 140,
  sym_global_statement = 141,
  sym_nonlocal_statement = 142,
  sym_exec_statement = 143,
  sym_class_definition = 144,
  sym_parenthesized_list_splat = 145,
  sym_argument_list = 146,
  sym_decorated_definition = 147,
  sym_decorator = 148,
  sym_block = 149,
  sym_variables = 150,
  sym_expression_list = 151,
  sym_dotted_name = 152,
  sym__expression_within_for_in_clause = 153,
  sym__expression = 154,
  sym__primary_expression = 155,
  sym_not_operator = 156,
  sym_boolean_operator = 157,
  sym_binary_operator = 158,
  sym_unary_operator = 159,
  sym_comparison_operator = 160,
  sym_lambda = 161,
  sym_lambda_within_for_in_clause = 162,
  sym_assignment = 163,
  sym_augmented_assignment = 164,
  sym__right_hand_side = 165,
  sym_yield = 166,
  sym_attribute = 167,
  sym_subscript = 168,
  sym_slice = 169,
  sym_call = 170,
  sym_typed_parameter = 171,
  sym_type = 172,
  sym_keyword_argument = 173,
  sym_list = 174,
  sym__comprehension_clauses = 175,
  sym_list_comprehension = 176,
  sym_dictionary = 177,
  sym_dictionary_comprehension = 178,
  sym_pair = 179,
  sym_set = 180,
  sym_set_comprehension = 181,
  sym_parenthesized_expression = 182,
  sym__collection_elements = 183,
  sym_tuple = 184,
  sym_generator_expression = 185,
  sym_for_in_clause = 186,
  sym_if_clause = 187,
  sym_conditional_expression = 188,
  sym_concatenated_string = 189,
  sym_string = 190,
  sym_interpolation = 191,
  sym_format_specifier = 192,
  sym_format_expression = 193,
  sym_await = 194,
  aux_sym_module_repeat1 = 195,
  aux_sym__simple_statements_repeat1 = 196,
  aux_sym_import_prefix_repeat1 = 197,
  aux_sym__import_list_repeat1 = 198,
  aux_sym_print_statement_repeat1 = 199,
  aux_sym_assert_statement_repeat1 = 200,
  aux_sym_if_statement_repeat1 = 201,
  aux_sym_try_statement_repeat1 = 202,
  aux_sym_with_statement_repeat1 = 203,
  aux_sym__parameters_repeat1 = 204,
  aux_sym_global_statement_repeat1 = 205,
  aux_sym_argument_list_repeat1 = 206,
  aux_sym_decorated_definition_repeat1 = 207,
  aux_sym_variables_repeat1 = 208,
  aux_sym_dotted_name_repeat1 = 209,
  aux_sym_comparison_operator_repeat1 = 210,
  aux_sym_subscript_repeat1 = 211,
  aux_sym__comprehension_clauses_repeat1 = 212,
  aux_sym_dictionary_repeat1 = 213,
  aux_sym_set_repeat1 = 214,
  aux_sym__collection_elements_repeat1 = 215,
  aux_sym_for_in_clause_repeat1 = 216,
  aux_sym_concatenated_string_repeat1 = 217,
  aux_sym_string_repeat1 = 218,
  aux_sym_format_specifier_repeat1 = 219,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_import] = "import",
  [anon_sym_DOT] = ".",
  [anon_sym_from] = "from",
  [anon_sym___future__] = "__future__",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [anon_sym_as] = "as",
  [anon_sym_STAR] = "*",
  [anon_sym_print] = "print",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_assert] = "assert",
  [anon_sym_COLON_EQ] = ":=",
  [anon_sym_return] = "return",
  [anon_sym_del] = "del",
  [anon_sym_raise] = "raise",
  [anon_sym_pass] = "pass",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_if] = "if",
  [anon_sym_COLON] = ":",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_async] = "async",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_try] = "try",
  [anon_sym_except] = "except",
  [anon_sym_finally] = "finally",
  [anon_sym_with] = "with",
  [anon_sym_def] = "def",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_EQ] = "=",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_global] = "global",
  [anon_sym_nonlocal] = "nonlocal",
  [anon_sym_exec] = "exec",
  [anon_sym_class] = "class",
  [anon_sym_AT] = "@",
  [anon_sym_not] = "not",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_TILDE] = "~",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT] = ">",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_is] = "is",
  [anon_sym_lambda] = "lambda",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_AT_EQ] = "@=",
  [anon_sym_SLASH_SLASH_EQ] = "//=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [sym_ellipsis] = "ellipsis",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [sym_escape_sequence] = "escape_sequence",
  [sym__not_escape_sequence] = "_not_escape_sequence",
  [aux_sym_format_specifier_token1] = "format_specifier_token1",
  [sym_type_conversion] = "type_conversion",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_none] = "none",
  [anon_sym_await] = "await",
  [sym_comment] = "comment",
  [sym__semicolon] = "_semicolon",
  [sym__newline] = "_newline",
  [sym__indent] = "_indent",
  [sym__dedent] = "_dedent",
  [sym__string_start] = "\"",
  [sym__string_content] = "_string_content",
  [sym__string_end] = "\"",
  [sym_module] = "module",
  [sym__statement] = "_statement",
  [sym__simple_statements] = "_simple_statements",
  [sym_import_statement] = "import_statement",
  [sym_import_prefix] = "import_prefix",
  [sym_relative_import] = "relative_import",
  [sym_future_import_statement] = "future_import_statement",
  [sym_import_from_statement] = "import_from_statement",
  [sym__import_list] = "_import_list",
  [sym_aliased_import] = "aliased_import",
  [sym_wildcard_import] = "wildcard_import",
  [sym_print_statement] = "print_statement",
  [sym_chevron] = "chevron",
  [sym_assert_statement] = "assert_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_named_expression] = "named_expression",
  [sym_return_statement] = "return_statement",
  [sym_delete_statement] = "delete_statement",
  [sym_raise_statement] = "raise_statement",
  [sym_pass_statement] = "pass_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_try_statement] = "try_statement",
  [sym_except_clause] = "except_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_with_statement] = "with_statement",
  [sym_with_item] = "with_item",
  [sym_function_definition] = "function_definition",
  [sym_parameters] = "parameters",
  [sym_lambda_parameters] = "lambda_parameters",
  [sym__parameters] = "_parameters",
  [sym_default_parameter] = "default_parameter",
  [sym_typed_default_parameter] = "typed_default_parameter",
  [sym_list_splat] = "list_splat",
  [sym_dictionary_splat] = "dictionary_splat",
  [sym_global_statement] = "global_statement",
  [sym_nonlocal_statement] = "nonlocal_statement",
  [sym_exec_statement] = "exec_statement",
  [sym_class_definition] = "class_definition",
  [sym_parenthesized_list_splat] = "parenthesized_list_splat",
  [sym_argument_list] = "argument_list",
  [sym_decorated_definition] = "decorated_definition",
  [sym_decorator] = "decorator",
  [sym_block] = "block",
  [sym_variables] = "variables",
  [sym_expression_list] = "expression_list",
  [sym_dotted_name] = "dotted_name",
  [sym__expression_within_for_in_clause] = "_expression_within_for_in_clause",
  [sym__expression] = "_expression",
  [sym__primary_expression] = "_primary_expression",
  [sym_not_operator] = "not_operator",
  [sym_boolean_operator] = "boolean_operator",
  [sym_binary_operator] = "binary_operator",
  [sym_unary_operator] = "unary_operator",
  [sym_comparison_operator] = "comparison_operator",
  [sym_lambda] = "lambda",
  [sym_lambda_within_for_in_clause] = "lambda",
  [sym_assignment] = "assignment",
  [sym_augmented_assignment] = "augmented_assignment",
  [sym__right_hand_side] = "_right_hand_side",
  [sym_yield] = "yield",
  [sym_attribute] = "attribute",
  [sym_subscript] = "subscript",
  [sym_slice] = "slice",
  [sym_call] = "call",
  [sym_typed_parameter] = "typed_parameter",
  [sym_type] = "type",
  [sym_keyword_argument] = "keyword_argument",
  [sym_list] = "list",
  [sym__comprehension_clauses] = "_comprehension_clauses",
  [sym_list_comprehension] = "list_comprehension",
  [sym_dictionary] = "dictionary",
  [sym_dictionary_comprehension] = "dictionary_comprehension",
  [sym_pair] = "pair",
  [sym_set] = "set",
  [sym_set_comprehension] = "set_comprehension",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__collection_elements] = "_collection_elements",
  [sym_tuple] = "tuple",
  [sym_generator_expression] = "generator_expression",
  [sym_for_in_clause] = "for_in_clause",
  [sym_if_clause] = "if_clause",
  [sym_conditional_expression] = "conditional_expression",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string] = "string",
  [sym_interpolation] = "interpolation",
  [sym_format_specifier] = "format_specifier",
  [sym_format_expression] = "format_expression",
  [sym_await] = "await",
  [aux_sym_module_repeat1] = "module_repeat1",
  [aux_sym__simple_statements_repeat1] = "_simple_statements_repeat1",
  [aux_sym_import_prefix_repeat1] = "import_prefix_repeat1",
  [aux_sym__import_list_repeat1] = "_import_list_repeat1",
  [aux_sym_print_statement_repeat1] = "print_statement_repeat1",
  [aux_sym_assert_statement_repeat1] = "assert_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_with_statement_repeat1] = "with_statement_repeat1",
  [aux_sym__parameters_repeat1] = "_parameters_repeat1",
  [aux_sym_global_statement_repeat1] = "global_statement_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_decorated_definition_repeat1] = "decorated_definition_repeat1",
  [aux_sym_variables_repeat1] = "variables_repeat1",
  [aux_sym_dotted_name_repeat1] = "dotted_name_repeat1",
  [aux_sym_comparison_operator_repeat1] = "comparison_operator_repeat1",
  [aux_sym_subscript_repeat1] = "subscript_repeat1",
  [aux_sym__comprehension_clauses_repeat1] = "_comprehension_clauses_repeat1",
  [aux_sym_dictionary_repeat1] = "dictionary_repeat1",
  [aux_sym_set_repeat1] = "set_repeat1",
  [aux_sym__collection_elements_repeat1] = "_collection_elements_repeat1",
  [aux_sym_for_in_clause_repeat1] = "for_in_clause_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_format_specifier_repeat1] = "format_specifier_repeat1",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_import] = anon_sym_import,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_from] = anon_sym_from,
  [anon_sym___future__] = anon_sym___future__,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_print] = anon_sym_print,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_COLON_EQ] = anon_sym_COLON_EQ,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_del] = anon_sym_del,
  [anon_sym_raise] = anon_sym_raise,
  [anon_sym_pass] = anon_sym_pass,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_elif] = anon_sym_elif,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_except] = anon_sym_except,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_def] = anon_sym_def,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_STAR_STAR] = anon_sym_STAR_STAR,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_nonlocal] = anon_sym_nonlocal,
  [anon_sym_exec] = anon_sym_exec,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_SLASH_SLASH] = anon_sym_SLASH_SLASH,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_LT_GT] = anon_sym_LT_GT,
  [anon_sym_is] = anon_sym_is,
  [anon_sym_lambda] = anon_sym_lambda,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_AT_EQ] = anon_sym_AT_EQ,
  [anon_sym_SLASH_SLASH_EQ] = anon_sym_SLASH_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_STAR_STAR_EQ] = anon_sym_STAR_STAR_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [sym_ellipsis] = sym_ellipsis,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym__not_escape_sequence] = sym__not_escape_sequence,
  [aux_sym_format_specifier_token1] = aux_sym_format_specifier_token1,
  [sym_type_conversion] = sym_type_conversion,
  [sym_integer] = sym_integer,
  [sym_float] = sym_float,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_none] = sym_none,
  [anon_sym_await] = anon_sym_await,
  [sym_comment] = sym_comment,
  [sym__semicolon] = sym__semicolon,
  [sym__newline] = sym__newline,
  [sym__indent] = sym__indent,
  [sym__dedent] = sym__dedent,
  [sym__string_start] = sym__string_start,
  [sym__string_content] = sym__string_content,
  [sym__string_end] = sym__string_start,
  [sym_module] = sym_module,
  [sym__statement] = sym__statement,
  [sym__simple_statements] = sym__simple_statements,
  [sym_import_statement] = sym_import_statement,
  [sym_import_prefix] = sym_import_prefix,
  [sym_relative_import] = sym_relative_import,
  [sym_future_import_statement] = sym_future_import_statement,
  [sym_import_from_statement] = sym_import_from_statement,
  [sym__import_list] = sym__import_list,
  [sym_aliased_import] = sym_aliased_import,
  [sym_wildcard_import] = sym_wildcard_import,
  [sym_print_statement] = sym_print_statement,
  [sym_chevron] = sym_chevron,
  [sym_assert_statement] = sym_assert_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_named_expression] = sym_named_expression,
  [sym_return_statement] = sym_return_statement,
  [sym_delete_statement] = sym_delete_statement,
  [sym_raise_statement] = sym_raise_statement,
  [sym_pass_statement] = sym_pass_statement,
  [sym_break_statement] = sym_break_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_elif_clause] = sym_elif_clause,
  [sym_else_clause] = sym_else_clause,
  [sym_for_statement] = sym_for_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_except_clause] = sym_except_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_with_statement] = sym_with_statement,
  [sym_with_item] = sym_with_item,
  [sym_function_definition] = sym_function_definition,
  [sym_parameters] = sym_parameters,
  [sym_lambda_parameters] = sym_lambda_parameters,
  [sym__parameters] = sym__parameters,
  [sym_default_parameter] = sym_default_parameter,
  [sym_typed_default_parameter] = sym_typed_default_parameter,
  [sym_list_splat] = sym_list_splat,
  [sym_dictionary_splat] = sym_dictionary_splat,
  [sym_global_statement] = sym_global_statement,
  [sym_nonlocal_statement] = sym_nonlocal_statement,
  [sym_exec_statement] = sym_exec_statement,
  [sym_class_definition] = sym_class_definition,
  [sym_parenthesized_list_splat] = sym_parenthesized_list_splat,
  [sym_argument_list] = sym_argument_list,
  [sym_decorated_definition] = sym_decorated_definition,
  [sym_decorator] = sym_decorator,
  [sym_block] = sym_block,
  [sym_variables] = sym_variables,
  [sym_expression_list] = sym_expression_list,
  [sym_dotted_name] = sym_dotted_name,
  [sym__expression_within_for_in_clause] = sym__expression_within_for_in_clause,
  [sym__expression] = sym__expression,
  [sym__primary_expression] = sym__primary_expression,
  [sym_not_operator] = sym_not_operator,
  [sym_boolean_operator] = sym_boolean_operator,
  [sym_binary_operator] = sym_binary_operator,
  [sym_unary_operator] = sym_unary_operator,
  [sym_comparison_operator] = sym_comparison_operator,
  [sym_lambda] = sym_lambda,
  [sym_lambda_within_for_in_clause] = sym_lambda,
  [sym_assignment] = sym_assignment,
  [sym_augmented_assignment] = sym_augmented_assignment,
  [sym__right_hand_side] = sym__right_hand_side,
  [sym_yield] = sym_yield,
  [sym_attribute] = sym_attribute,
  [sym_subscript] = sym_subscript,
  [sym_slice] = sym_slice,
  [sym_call] = sym_call,
  [sym_typed_parameter] = sym_typed_parameter,
  [sym_type] = sym_type,
  [sym_keyword_argument] = sym_keyword_argument,
  [sym_list] = sym_list,
  [sym__comprehension_clauses] = sym__comprehension_clauses,
  [sym_list_comprehension] = sym_list_comprehension,
  [sym_dictionary] = sym_dictionary,
  [sym_dictionary_comprehension] = sym_dictionary_comprehension,
  [sym_pair] = sym_pair,
  [sym_set] = sym_set,
  [sym_set_comprehension] = sym_set_comprehension,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym__collection_elements] = sym__collection_elements,
  [sym_tuple] = sym_tuple,
  [sym_generator_expression] = sym_generator_expression,
  [sym_for_in_clause] = sym_for_in_clause,
  [sym_if_clause] = sym_if_clause,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_concatenated_string] = sym_concatenated_string,
  [sym_string] = sym_string,
  [sym_interpolation] = sym_interpolation,
  [sym_format_specifier] = sym_format_specifier,
  [sym_format_expression] = sym_format_expression,
  [sym_await] = sym_await,
  [aux_sym_module_repeat1] = aux_sym_module_repeat1,
  [aux_sym__simple_statements_repeat1] = aux_sym__simple_statements_repeat1,
  [aux_sym_import_prefix_repeat1] = aux_sym_import_prefix_repeat1,
  [aux_sym__import_list_repeat1] = aux_sym__import_list_repeat1,
  [aux_sym_print_statement_repeat1] = aux_sym_print_statement_repeat1,
  [aux_sym_assert_statement_repeat1] = aux_sym_assert_statement_repeat1,
  [aux_sym_if_statement_repeat1] = aux_sym_if_statement_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_with_statement_repeat1] = aux_sym_with_statement_repeat1,
  [aux_sym__parameters_repeat1] = aux_sym__parameters_repeat1,
  [aux_sym_global_statement_repeat1] = aux_sym_global_statement_repeat1,
  [aux_sym_argument_list_repeat1] = aux_sym_argument_list_repeat1,
  [aux_sym_decorated_definition_repeat1] = aux_sym_decorated_definition_repeat1,
  [aux_sym_variables_repeat1] = aux_sym_variables_repeat1,
  [aux_sym_dotted_name_repeat1] = aux_sym_dotted_name_repeat1,
  [aux_sym_comparison_operator_repeat1] = aux_sym_comparison_operator_repeat1,
  [aux_sym_subscript_repeat1] = aux_sym_subscript_repeat1,
  [aux_sym__comprehension_clauses_repeat1] = aux_sym__comprehension_clauses_repeat1,
  [aux_sym_dictionary_repeat1] = aux_sym_dictionary_repeat1,
  [aux_sym_set_repeat1] = aux_sym_set_repeat1,
  [aux_sym__collection_elements_repeat1] = aux_sym__collection_elements_repeat1,
  [aux_sym_for_in_clause_repeat1] = aux_sym_for_in_clause_repeat1,
  [aux_sym_concatenated_string_repeat1] = aux_sym_concatenated_string_repeat1,
  [aux_sym_string_repeat1] = aux_sym_string_repeat1,
  [aux_sym_format_specifier_repeat1] = aux_sym_format_specifier_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___future__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_print] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_del] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_raise] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pass] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonlocal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lambda] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym_ellipsis] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym__not_escape_sequence] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_format_specifier_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_type_conversion] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_none] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__dedent] = {
    .visible = false,
    .named = true,
  },
  [sym__string_start] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__string_end] = {
    .visible = true,
    .named = false,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_statements] = {
    .visible = false,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym_relative_import] = {
    .visible = true,
    .named = true,
  },
  [sym_future_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_from_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__import_list] = {
    .visible = false,
    .named = true,
  },
  [sym_aliased_import] = {
    .visible = true,
    .named = true,
  },
  [sym_wildcard_import] = {
    .visible = true,
    .named = true,
  },
  [sym_print_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_chevron] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_named_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_raise_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_pass_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__parameters] = {
    .visible = false,
    .named = true,
  },
  [sym_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_global_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_nonlocal_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_exec_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_class_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_decorated_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_variables] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_dotted_name] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_within_for_in_clause] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym__primary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_not_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_comparison_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_within_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__right_hand_side] = {
    .visible = false,
    .named = true,
  },
  [sym_yield] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_slice] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym__comprehension_clauses] = {
    .visible = false,
    .named = true,
  },
  [sym_list_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_set] = {
    .visible = true,
    .named = true,
  },
  [sym_set_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__collection_elements] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_format_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_format_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_module_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__simple_statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_prefix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_print_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_assert_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_with_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decorated_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variables_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dotted_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_comparison_operator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__comprehension_clauses_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dictionary_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_set_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__collection_elements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_in_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_format_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_attribute = 5,
  field_body = 6,
  field_cause = 7,
  field_code = 8,
  field_condition = 9,
  field_consequence = 10,
  field_definition = 11,
  field_function = 12,
  field_key = 13,
  field_left = 14,
  field_module_name = 15,
  field_name = 16,
  field_object = 17,
  field_operator = 18,
  field_parameters = 19,
  field_return_type = 20,
  field_right = 21,
  field_subscript = 22,
  field_superclasses = 23,
  field_type = 24,
  field_value = 25,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_attribute] = "attribute",
  [field_body] = "body",
  [field_cause] = "cause",
  [field_code] = "code",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_definition] = "definition",
  [field_function] = "function",
  [field_key] = "key",
  [field_left] = "left",
  [field_module_name] = "module_name",
  [field_name] = "name",
  [field_object] = "object",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_subscript] = "subscript",
  [field_superclasses] = "superclasses",
  [field_type] = "type",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[94] = {
  [2] = {.index = 0, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 1},
  [5] = {.index = 3, .length = 1},
  [6] = {.index = 4, .length = 1},
  [7] = {.index = 5, .length = 2},
  [9] = {.index = 7, .length = 2},
  [10] = {.index = 9, .length = 1},
  [11] = {.index = 10, .length = 2},
  [12] = {.index = 12, .length = 1},
  [13] = {.index = 13, .length = 2},
  [14] = {.index = 15, .length = 1},
  [15] = {.index = 16, .length = 1},
  [16] = {.index = 17, .length = 2},
  [17] = {.index = 19, .length = 2},
  [18] = {.index = 21, .length = 2},
  [19] = {.index = 23, .length = 3},
  [20] = {.index = 26, .length = 2},
  [21] = {.index = 28, .length = 1},
  [22] = {.index = 29, .length = 2},
  [23] = {.index = 31, .length = 2},
  [24] = {.index = 33, .length = 1},
  [25] = {.index = 34, .length = 2},
  [27] = {.index = 36, .length = 1},
  [28] = {.index = 37, .length = 2},
  [29] = {.index = 39, .length = 1},
  [30] = {.index = 40, .length = 2},
  [31] = {.index = 42, .length = 2},
  [32] = {.index = 16, .length = 1},
  [33] = {.index = 44, .length = 1},
  [34] = {.index = 45, .length = 2},
  [35] = {.index = 47, .length = 2},
  [36] = {.index = 49, .length = 1},
  [39] = {.index = 17, .length = 2},
  [40] = {.index = 50, .length = 1},
  [41] = {.index = 51, .length = 2},
  [42] = {.index = 53, .length = 2},
  [43] = {.index = 55, .length = 2},
  [44] = {.index = 57, .length = 1},
  [45] = {.index = 58, .length = 3},
  [46] = {.index = 61, .length = 3},
  [47] = {.index = 64, .length = 3},
  [48] = {.index = 67, .length = 1},
  [49] = {.index = 68, .length = 3},
  [50] = {.index = 71, .length = 3},
  [51] = {.index = 74, .length = 2},
  [52] = {.index = 76, .length = 2},
  [53] = {.index = 78, .length = 3},
  [54] = {.index = 81, .length = 3},
  [55] = {.index = 84, .length = 3},
  [56] = {.index = 87, .length = 3},
  [57] = {.index = 90, .length = 3},
  [58] = {.index = 93, .length = 1},
  [59] = {.index = 94, .length = 2},
  [60] = {.index = 96, .length = 2},
  [61] = {.index = 98, .length = 4},
  [62] = {.index = 102, .length = 2},
  [63] = {.index = 104, .length = 4},
  [64] = {.index = 108, .length = 4},
  [65] = {.index = 112, .length = 2},
  [66] = {.index = 114, .length = 1},
  [67] = {.index = 115, .length = 3},
  [68] = {.index = 118, .length = 3},
  [69] = {.index = 121, .length = 4},
  [71] = {.index = 125, .length = 4},
  [72] = {.index = 129, .length = 4},
  [73] = {.index = 133, .length = 3},
  [74] = {.index = 133, .length = 3},
  [75] = {.index = 136, .length = 2},
  [76] = {.index = 138, .length = 3},
  [77] = {.index = 141, .length = 5},
  [78] = {.index = 146, .length = 3},
  [79] = {.index = 149, .length = 2},
  [80] = {.index = 151, .length = 4},
  [81] = {.index = 155, .length = 4},
  [82] = {.index = 159, .length = 4},
  [84] = {.index = 163, .length = 4},
  [85] = {.index = 167, .length = 3},
  [86] = {.index = 170, .length = 4},
  [87] = {.index = 174, .length = 4},
  [88] = {.index = 178, .length = 4},
  [89] = {.index = 182, .length = 5},
  [90] = {.index = 187, .length = 5},
  [91] = {.index = 192, .length = 5},
  [92] = {.index = 197, .length = 5},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 1, .inherited = true},
  [1] =
    {field_name, 0},
  [2] =
    {field_argument, 1},
  [3] =
    {field_value, 0},
  [4] =
    {field_code, 1},
  [5] =
    {field_argument, 1},
    {field_operator, 0},
  [7] =
    {field_arguments, 1},
    {field_function, 0},
  [9] =
    {field_definition, 1},
  [10] =
    {field_name, 0},
    {field_name, 1, .inherited = true},
  [12] =
    {field_argument, 2, .inherited = true},
  [13] =
    {field_argument, 1},
    {field_argument, 2, .inherited = true},
  [15] =
    {field_cause, 2},
  [16] =
    {field_body, 2},
  [17] =
    {field_name, 0},
    {field_value, 2},
  [19] =
    {field_left, 0},
    {field_type, 2},
  [21] =
    {field_left, 0},
    {field_right, 2},
  [23] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [26] =
    {field_attribute, 2},
    {field_object, 0},
  [28] =
    {field_name, 1},
  [29] =
    {field_name, 0, .inherited = true},
    {field_name, 1, .inherited = true},
  [31] =
    {field_alias, 2},
    {field_name, 0},
  [33] =
    {field_name, 3, .inherited = true},
  [34] =
    {field_module_name, 1},
    {field_name, 3, .inherited = true},
  [36] =
    {field_body, 1},
  [37] =
    {field_argument, 0, .inherited = true},
    {field_argument, 1, .inherited = true},
  [39] =
    {field_cause, 3},
  [40] =
    {field_condition, 1},
    {field_consequence, 3},
  [42] =
    {field_body, 3},
    {field_condition, 1},
  [44] =
    {field_body, 3},
  [45] =
    {field_alias, 2},
    {field_value, 0},
  [47] =
    {field_body, 3},
    {field_name, 1},
  [49] =
    {field_arguments, 2},
  [50] =
    {field_type, 2},
  [51] =
    {field_body, 3},
    {field_parameters, 1},
  [53] =
    {field_key, 0},
    {field_value, 2},
  [55] =
    {field_subscript, 2},
    {field_value, 0},
  [57] =
    {field_alternative, 0},
  [58] =
    {field_alternative, 4},
    {field_condition, 1},
    {field_consequence, 3},
  [61] =
    {field_alternative, 4, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
  [64] =
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [67] =
    {field_body, 4},
  [68] =
    {field_alternative, 4},
    {field_body, 3},
    {field_condition, 1},
  [71] =
    {field_body, 3},
    {field_body, 4},
    {field_condition, 1},
  [74] =
    {field_body, 2},
    {field_body, 3},
  [76] =
    {field_body, 3},
    {field_body, 4},
  [78] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
  [81] =
    {field_body, 3},
    {field_body, 4},
    {field_name, 1},
  [84] =
    {field_body, 4},
    {field_name, 1},
    {field_superclasses, 2},
  [87] =
    {field_left, 0},
    {field_right, 4},
    {field_type, 2},
  [90] =
    {field_subscript, 2},
    {field_subscript, 3},
    {field_value, 0},
  [93] =
    {field_name, 4, .inherited = true},
  [94] =
    {field_module_name, 1},
    {field_name, 4, .inherited = true},
  [96] =
    {field_left, 1},
    {field_right, 3},
  [98] =
    {field_alternative, 4, .inherited = true},
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
  [102] =
    {field_alternative, 0, .inherited = true},
    {field_alternative, 1, .inherited = true},
  [104] =
    {field_alternative, 5},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [108] =
    {field_alternative, 5, .inherited = true},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [112] =
    {field_body, 4},
    {field_body, 5},
  [114] =
    {field_body, 5},
  [115] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
  [118] =
    {field_body, 5},
    {field_left, 1},
    {field_right, 3},
  [121] =
    {field_alternative, 5},
    {field_body, 3},
    {field_body, 4},
    {field_condition, 1},
  [125] =
    {field_body, 4},
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 2},
  [129] =
    {field_body, 4},
    {field_body, 5},
    {field_name, 1},
    {field_superclasses, 2},
  [133] =
    {field_name, 0},
    {field_type, 2},
    {field_value, 4},
  [136] =
    {field_left, 2},
    {field_right, 4},
  [138] =
    {field_left, 1},
    {field_right, 3},
    {field_right, 4},
  [141] =
    {field_alternative, 5, .inherited = true},
    {field_alternative, 6},
    {field_condition, 1},
    {field_consequence, 3},
    {field_consequence, 4},
  [146] =
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [149] =
    {field_body, 5},
    {field_body, 6},
  [151] =
    {field_body, 5},
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 3},
  [155] =
    {field_alternative, 6},
    {field_body, 5},
    {field_left, 1},
    {field_right, 3},
  [159] =
    {field_body, 5},
    {field_body, 6},
    {field_left, 1},
    {field_right, 3},
  [163] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [167] =
    {field_left, 2},
    {field_right, 4},
    {field_right, 5},
  [170] =
    {field_alternative, 7},
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [174] =
    {field_body, 6},
    {field_body, 7},
    {field_left, 2},
    {field_right, 4},
  [178] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [182] =
    {field_alternative, 7},
    {field_body, 5},
    {field_body, 6},
    {field_left, 1},
    {field_right, 3},
  [187] =
    {field_body, 6},
    {field_body, 7},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [192] =
    {field_alternative, 8},
    {field_body, 6},
    {field_body, 7},
    {field_left, 2},
    {field_right, 4},
  [197] =
    {field_body, 7},
    {field_body, 8},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
};

static TSSymbol ts_alias_sequences[94][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [8] = {
    [0] = sym_list_splat,
  },
  [26] = {
    [1] = sym_parenthesized_expression,
  },
  [30] = {
    [3] = sym_block,
  },
  [31] = {
    [3] = sym_block,
  },
  [32] = {
    [2] = sym_block,
  },
  [33] = {
    [3] = sym_block,
  },
  [35] = {
    [3] = sym_block,
  },
  [37] = {
    [1] = sym_list_splat,
  },
  [38] = {
    [1] = sym_identifier,
  },
  [39] = {
    [0] = sym_identifier,
  },
  [45] = {
    [3] = sym_block,
  },
  [46] = {
    [3] = sym_block,
  },
  [48] = {
    [4] = sym_block,
  },
  [49] = {
    [3] = sym_block,
  },
  [53] = {
    [4] = sym_block,
  },
  [55] = {
    [4] = sym_block,
  },
  [61] = {
    [3] = sym_block,
  },
  [66] = {
    [5] = sym_block,
  },
  [67] = {
    [5] = sym_block,
  },
  [68] = {
    [5] = sym_block,
  },
  [70] = {
    [2] = sym_block,
  },
  [73] = {
    [0] = sym_identifier,
  },
  [78] = {
    [6] = sym_block,
  },
  [81] = {
    [5] = sym_block,
  },
  [83] = {
    [3] = sym_block,
  },
  [84] = {
    [6] = sym_block,
  },
  [86] = {
    [6] = sym_block,
  },
  [88] = {
    [7] = sym_block,
  },
  [93] = {
    [5] = sym_block,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(39);
      if (lookahead == '!') ADVANCE(14);
      if (lookahead == '#') ADVANCE(111);
      if (lookahead == '%') ADVANCE(58);
      if (lookahead == '&') ADVANCE(61);
      if (lookahead == '(') ADVANCE(42);
      if (lookahead == ')') ADVANCE(43);
      if (lookahead == '*') ADVANCE(45);
      if (lookahead == '+') ADVANCE(54);
      if (lookahead == ',') ADVANCE(44);
      if (lookahead == '-') ADVANCE(56);
      if (lookahead == '.') ADVANCE(41);
      if (lookahead == '/') ADVANCE(57);
      if (lookahead == '0') ADVANCE(100);
      if (lookahead == ':') ADVANCE(49);
      if (lookahead == ';') ADVANCE(112);
      if (lookahead == '<') ADVANCE(65);
      if (lookahead == '=') ADVANCE(51);
      if (lookahead == '>') ADVANCE(70);
      if (lookahead == '@') ADVANCE(53);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') SKIP(35)
      if (lookahead == ']') ADVANCE(86);
      if (lookahead == '^') ADVANCE(62);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '|') ADVANCE(60);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '~') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(99);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(110);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(10)
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(10)
      if (lookahead == '\r') SKIP(1)
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(91);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(4)
      if (lookahead == '#') ADVANCE(95);
      if (lookahead == '\\') ADVANCE(93);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(94);
      if (lookahead != 0) ADVANCE(96);
      END_STATE();
    case 5:
      if (lookahead == '\n') SKIP(11)
      END_STATE();
    case 6:
      if (lookahead == '\n') SKIP(11)
      if (lookahead == '\r') SKIP(5)
      END_STATE();
    case 7:
      if (lookahead == '\n') SKIP(9)
      END_STATE();
    case 8:
      if (lookahead == '\n') SKIP(9)
      if (lookahead == '\r') SKIP(7)
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(14);
      if (lookahead == '#') ADVANCE(111);
      if (lookahead == '%') ADVANCE(58);
      if (lookahead == '&') ADVANCE(61);
      if (lookahead == '(') ADVANCE(42);
      if (lookahead == ')') ADVANCE(43);
      if (lookahead == '*') ADVANCE(45);
      if (lookahead == '+') ADVANCE(54);
      if (lookahead == ',') ADVANCE(44);
      if (lookahead == '-') ADVANCE(55);
      if (lookahead == '.') ADVANCE(40);
      if (lookahead == '/') ADVANCE(57);
      if (lookahead == ':') ADVANCE(49);
      if (lookahead == ';') ADVANCE(112);
      if (lookahead == '<') ADVANCE(65);
      if (lookahead == '=') ADVANCE(51);
      if (lookahead == '>') ADVANCE(70);
      if (lookahead == '@') ADVANCE(53);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') SKIP(8)
      if (lookahead == ']') ADVANCE(86);
      if (lookahead == '^') ADVANCE(62);
      if (lookahead == '|') ADVANCE(60);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(9)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(110);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(14);
      if (lookahead == '#') ADVANCE(111);
      if (lookahead == '%') ADVANCE(58);
      if (lookahead == '&') ADVANCE(61);
      if (lookahead == '(') ADVANCE(42);
      if (lookahead == ')') ADVANCE(43);
      if (lookahead == '*') ADVANCE(45);
      if (lookahead == '+') ADVANCE(54);
      if (lookahead == ',') ADVANCE(44);
      if (lookahead == '-') ADVANCE(55);
      if (lookahead == '.') ADVANCE(40);
      if (lookahead == '/') ADVANCE(57);
      if (lookahead == ':') ADVANCE(48);
      if (lookahead == ';') ADVANCE(112);
      if (lookahead == '<') ADVANCE(65);
      if (lookahead == '=') ADVANCE(51);
      if (lookahead == '>') ADVANCE(70);
      if (lookahead == '@') ADVANCE(53);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') SKIP(2)
      if (lookahead == ']') ADVANCE(86);
      if (lookahead == '^') ADVANCE(62);
      if (lookahead == '|') ADVANCE(60);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(10)
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(110);
      END_STATE();
    case 11:
      if (lookahead == '#') ADVANCE(111);
      if (lookahead == '-') ADVANCE(15);
      if (lookahead == ':') ADVANCE(48);
      if (lookahead == '\\') SKIP(6)
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(11)
      END_STATE();
    case 12:
      if (lookahead == '#') ADVANCE(111);
      if (lookahead == '\\') ADVANCE(92);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(12)
      END_STATE();
    case 13:
      if (lookahead == '.') ADVANCE(87);
      END_STATE();
    case 14:
      if (lookahead == '=') ADVANCE(68);
      if (('a' <= lookahead && lookahead <= 'z')) ADVANCE(97);
      END_STATE();
    case 15:
      if (lookahead == '>') ADVANCE(50);
      END_STATE();
    case 16:
      if (lookahead == '_') ADVANCE(20);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(102);
      END_STATE();
    case 17:
      if (lookahead == '_') ADVANCE(21);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(103);
      END_STATE();
    case 18:
      if (lookahead == '_') ADVANCE(25);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(104);
      END_STATE();
    case 19:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(22);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(107);
      END_STATE();
    case 20:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(102);
      END_STATE();
    case 21:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(103);
      END_STATE();
    case 22:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(107);
      END_STATE();
    case 23:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(90);
      END_STATE();
    case 24:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(23);
      END_STATE();
    case 25:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(104);
      END_STATE();
    case 26:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(90);
      END_STATE();
    case 27:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(26);
      END_STATE();
    case 28:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(27);
      END_STATE();
    case 29:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(28);
      END_STATE();
    case 30:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(29);
      END_STATE();
    case 31:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(30);
      END_STATE();
    case 32:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(31);
      END_STATE();
    case 33:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(32);
      END_STATE();
    case 34:
      if (eof) ADVANCE(39);
      if (lookahead == '\n') SKIP(0)
      END_STATE();
    case 35:
      if (eof) ADVANCE(39);
      if (lookahead == '\n') SKIP(0)
      if (lookahead == '\r') SKIP(34)
      END_STATE();
    case 36:
      if (eof) ADVANCE(39);
      if (lookahead == '\n') SKIP(38)
      END_STATE();
    case 37:
      if (eof) ADVANCE(39);
      if (lookahead == '\n') SKIP(38)
      if (lookahead == '\r') SKIP(36)
      END_STATE();
    case 38:
      if (eof) ADVANCE(39);
      if (lookahead == '!') ADVANCE(14);
      if (lookahead == '#') ADVANCE(111);
      if (lookahead == '%') ADVANCE(58);
      if (lookahead == '&') ADVANCE(61);
      if (lookahead == '(') ADVANCE(42);
      if (lookahead == ')') ADVANCE(43);
      if (lookahead == '*') ADVANCE(45);
      if (lookahead == '+') ADVANCE(54);
      if (lookahead == ',') ADVANCE(44);
      if (lookahead == '-') ADVANCE(55);
      if (lookahead == '.') ADVANCE(41);
      if (lookahead == '/') ADVANCE(57);
      if (lookahead == '0') ADVANCE(100);
      if (lookahead == ':') ADVANCE(48);
      if (lookahead == ';') ADVANCE(112);
      if (lookahead == '<') ADVANCE(65);
      if (lookahead == '=') ADVANCE(51);
      if (lookahead == '>') ADVANCE(70);
      if (lookahead == '@') ADVANCE(53);
      if (lookahead == '[') ADVANCE(85);
      if (lookahead == '\\') SKIP(37)
      if (lookahead == ']') ADVANCE(86);
      if (lookahead == '^') ADVANCE(62);
      if (lookahead == '{') ADVANCE(88);
      if (lookahead == '|') ADVANCE(60);
      if (lookahead == '}') ADVANCE(89);
      if (lookahead == '~') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(38)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(99);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(110);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(13);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(106);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*') ADVANCE(52);
      if (lookahead == '=') ADVANCE(74);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(80);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_COLON_EQ);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '=') ADVANCE(47);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(67);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=') ADVANCE(79);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '=') ADVANCE(76);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(72);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(73);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(73);
      if (lookahead == '>') ADVANCE(50);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(59);
      if (lookahead == '=') ADVANCE(75);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(78);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '=') ADVANCE(77);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(84);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '=') ADVANCE(82);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(83);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(81);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(63);
      if (lookahead == '=') ADVANCE(66);
      if (lookahead == '>') ADVANCE(71);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(69);
      if (lookahead == '>') ADVANCE(46);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_AT_EQ);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_EQ);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_ellipsis);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\\') ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym__not_escape_sequence);
      if (lookahead == '\n') ADVANCE(91);
      if (lookahead == '\r') ADVANCE(3);
      if (lookahead == 'U') ADVANCE(33);
      if (lookahead == 'u') ADVANCE(29);
      if (lookahead == 'x') ADVANCE(27);
      if (lookahead == '"' ||
          lookahead == '\'' ||
          lookahead == '\\' ||
          lookahead == 'a' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          ('t' <= lookahead && lookahead <= 'v')) ADVANCE(90);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(24);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == '\r') ADVANCE(96);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(96);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == '#') ADVANCE(95);
      if (lookahead == '\\') ADVANCE(93);
      if (lookahead == '\t' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) ADVANCE(94);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(96);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead == '{' ||
          lookahead == '}') ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(95);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(aux_sym_format_specifier_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '{' &&
          lookahead != '}') ADVANCE(96);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_type_conversion);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_integer);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == '_') ADVANCE(101);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(19);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(99);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(16);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(17);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(18);
      if (lookahead == '_') ADVANCE(101);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(19);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(99);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.') ADVANCE(108);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(19);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(99);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(20);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(102);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(98);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(21);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(103);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_') ADVANCE(25);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(98);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(104);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_float);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(108);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(19);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(106);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_') ADVANCE(109);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(107);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(19);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(106);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'J' ||
          lookahead == 'L' ||
          lookahead == 'j' ||
          lookahead == 'l') ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(107);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(110);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(111);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(sym__semicolon);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'F') ADVANCE(1);
      if (lookahead == 'N') ADVANCE(2);
      if (lookahead == 'T') ADVANCE(3);
      if (lookahead == '\\') SKIP(4)
      if (lookahead == '_') ADVANCE(5);
      if (lookahead == 'a') ADVANCE(6);
      if (lookahead == 'b') ADVANCE(7);
      if (lookahead == 'c') ADVANCE(8);
      if (lookahead == 'd') ADVANCE(9);
      if (lookahead == 'e') ADVANCE(10);
      if (lookahead == 'f') ADVANCE(11);
      if (lookahead == 'g') ADVANCE(12);
      if (lookahead == 'i') ADVANCE(13);
      if (lookahead == 'l') ADVANCE(14);
      if (lookahead == 'n') ADVANCE(15);
      if (lookahead == 'o') ADVANCE(16);
      if (lookahead == 'p') ADVANCE(17);
      if (lookahead == 'r') ADVANCE(18);
      if (lookahead == 't') ADVANCE(19);
      if (lookahead == 'w') ADVANCE(20);
      if (lookahead == 'y') ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\f' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'a') ADVANCE(22);
      END_STATE();
    case 2:
      if (lookahead == 'o') ADVANCE(23);
      END_STATE();
    case 3:
      if (lookahead == 'r') ADVANCE(24);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(0)
      if (lookahead == '\r') SKIP(25)
      END_STATE();
    case 5:
      if (lookahead == '_') ADVANCE(26);
      END_STATE();
    case 6:
      if (lookahead == 'n') ADVANCE(27);
      if (lookahead == 's') ADVANCE(28);
      if (lookahead == 'w') ADVANCE(29);
      END_STATE();
    case 7:
      if (lookahead == 'r') ADVANCE(30);
      END_STATE();
    case 8:
      if (lookahead == 'l') ADVANCE(31);
      if (lookahead == 'o') ADVANCE(32);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(33);
      END_STATE();
    case 10:
      if (lookahead == 'l') ADVANCE(34);
      if (lookahead == 'x') ADVANCE(35);
      END_STATE();
    case 11:
      if (lookahead == 'i') ADVANCE(36);
      if (lookahead == 'o') ADVANCE(37);
      if (lookahead == 'r') ADVANCE(38);
      END_STATE();
    case 12:
      if (lookahead == 'l') ADVANCE(39);
      END_STATE();
    case 13:
      if (lookahead == 'f') ADVANCE(40);
      if (lookahead == 'm') ADVANCE(41);
      if (lookahead == 'n') ADVANCE(42);
      if (lookahead == 's') ADVANCE(43);
      END_STATE();
    case 14:
      if (lookahead == 'a') ADVANCE(44);
      END_STATE();
    case 15:
      if (lookahead == 'o') ADVANCE(45);
      END_STATE();
    case 16:
      if (lookahead == 'r') ADVANCE(46);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(47);
      if (lookahead == 'r') ADVANCE(48);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(49);
      if (lookahead == 'e') ADVANCE(50);
      END_STATE();
    case 19:
      if (lookahead == 'r') ADVANCE(51);
      END_STATE();
    case 20:
      if (lookahead == 'h') ADVANCE(52);
      if (lookahead == 'i') ADVANCE(53);
      END_STATE();
    case 21:
      if (lookahead == 'i') ADVANCE(54);
      END_STATE();
    case 22:
      if (lookahead == 'l') ADVANCE(55);
      END_STATE();
    case 23:
      if (lookahead == 'n') ADVANCE(56);
      END_STATE();
    case 24:
      if (lookahead == 'u') ADVANCE(57);
      END_STATE();
    case 25:
      if (lookahead == '\n') SKIP(0)
      END_STATE();
    case 26:
      if (lookahead == 'f') ADVANCE(58);
      END_STATE();
    case 27:
      if (lookahead == 'd') ADVANCE(59);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's') ADVANCE(60);
      if (lookahead == 'y') ADVANCE(61);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(62);
      END_STATE();
    case 30:
      if (lookahead == 'e') ADVANCE(63);
      END_STATE();
    case 31:
      if (lookahead == 'a') ADVANCE(64);
      END_STATE();
    case 32:
      if (lookahead == 'n') ADVANCE(65);
      END_STATE();
    case 33:
      if (lookahead == 'f') ADVANCE(66);
      if (lookahead == 'l') ADVANCE(67);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(68);
      if (lookahead == 's') ADVANCE(69);
      END_STATE();
    case 35:
      if (lookahead == 'c') ADVANCE(70);
      if (lookahead == 'e') ADVANCE(71);
      END_STATE();
    case 36:
      if (lookahead == 'n') ADVANCE(72);
      END_STATE();
    case 37:
      if (lookahead == 'r') ADVANCE(73);
      END_STATE();
    case 38:
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 39:
      if (lookahead == 'o') ADVANCE(75);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 41:
      if (lookahead == 'p') ADVANCE(76);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 44:
      if (lookahead == 'm') ADVANCE(77);
      END_STATE();
    case 45:
      if (lookahead == 'n') ADVANCE(78);
      if (lookahead == 't') ADVANCE(79);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 47:
      if (lookahead == 's') ADVANCE(80);
      END_STATE();
    case 48:
      if (lookahead == 'i') ADVANCE(81);
      END_STATE();
    case 49:
      if (lookahead == 'i') ADVANCE(82);
      END_STATE();
    case 50:
      if (lookahead == 't') ADVANCE(83);
      END_STATE();
    case 51:
      if (lookahead == 'y') ADVANCE(84);
      END_STATE();
    case 52:
      if (lookahead == 'i') ADVANCE(85);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(86);
      END_STATE();
    case 54:
      if (lookahead == 'e') ADVANCE(87);
      END_STATE();
    case 55:
      if (lookahead == 's') ADVANCE(88);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(89);
      END_STATE();
    case 57:
      if (lookahead == 'e') ADVANCE(90);
      END_STATE();
    case 58:
      if (lookahead == 'u') ADVANCE(91);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 60:
      if (lookahead == 'e') ADVANCE(92);
      END_STATE();
    case 61:
      if (lookahead == 'n') ADVANCE(93);
      END_STATE();
    case 62:
      if (lookahead == 'i') ADVANCE(94);
      END_STATE();
    case 63:
      if (lookahead == 'a') ADVANCE(95);
      END_STATE();
    case 64:
      if (lookahead == 's') ADVANCE(96);
      END_STATE();
    case 65:
      if (lookahead == 't') ADVANCE(97);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_def);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_del);
      END_STATE();
    case 68:
      if (lookahead == 'f') ADVANCE(98);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(99);
      END_STATE();
    case 70:
      if (lookahead == 'e') ADVANCE(100);
      END_STATE();
    case 71:
      if (lookahead == 'c') ADVANCE(101);
      END_STATE();
    case 72:
      if (lookahead == 'a') ADVANCE(102);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 74:
      if (lookahead == 'm') ADVANCE(103);
      END_STATE();
    case 75:
      if (lookahead == 'b') ADVANCE(104);
      END_STATE();
    case 76:
      if (lookahead == 'o') ADVANCE(105);
      END_STATE();
    case 77:
      if (lookahead == 'b') ADVANCE(106);
      END_STATE();
    case 78:
      if (lookahead == 'l') ADVANCE(107);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 80:
      if (lookahead == 's') ADVANCE(108);
      END_STATE();
    case 81:
      if (lookahead == 'n') ADVANCE(109);
      END_STATE();
    case 82:
      if (lookahead == 's') ADVANCE(110);
      END_STATE();
    case 83:
      if (lookahead == 'u') ADVANCE(111);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 85:
      if (lookahead == 'l') ADVANCE(112);
      END_STATE();
    case 86:
      if (lookahead == 'h') ADVANCE(113);
      END_STATE();
    case 87:
      if (lookahead == 'l') ADVANCE(114);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(115);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_none);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 91:
      if (lookahead == 't') ADVANCE(116);
      END_STATE();
    case 92:
      if (lookahead == 'r') ADVANCE(117);
      END_STATE();
    case 93:
      if (lookahead == 'c') ADVANCE(118);
      END_STATE();
    case 94:
      if (lookahead == 't') ADVANCE(119);
      END_STATE();
    case 95:
      if (lookahead == 'k') ADVANCE(120);
      END_STATE();
    case 96:
      if (lookahead == 's') ADVANCE(121);
      END_STATE();
    case 97:
      if (lookahead == 'i') ADVANCE(122);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 100:
      if (lookahead == 'p') ADVANCE(123);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_exec);
      END_STATE();
    case 102:
      if (lookahead == 'l') ADVANCE(124);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 104:
      if (lookahead == 'a') ADVANCE(125);
      END_STATE();
    case 105:
      if (lookahead == 'r') ADVANCE(126);
      END_STATE();
    case 106:
      if (lookahead == 'd') ADVANCE(127);
      END_STATE();
    case 107:
      if (lookahead == 'o') ADVANCE(128);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_pass);
      END_STATE();
    case 109:
      if (lookahead == 't') ADVANCE(129);
      END_STATE();
    case 110:
      if (lookahead == 'e') ADVANCE(130);
      END_STATE();
    case 111:
      if (lookahead == 'r') ADVANCE(131);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 114:
      if (lookahead == 'd') ADVANCE(133);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 116:
      if (lookahead == 'u') ADVANCE(134);
      END_STATE();
    case 117:
      if (lookahead == 't') ADVANCE(135);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 122:
      if (lookahead == 'n') ADVANCE(136);
      END_STATE();
    case 123:
      if (lookahead == 't') ADVANCE(137);
      END_STATE();
    case 124:
      if (lookahead == 'l') ADVANCE(138);
      END_STATE();
    case 125:
      if (lookahead == 'l') ADVANCE(139);
      END_STATE();
    case 126:
      if (lookahead == 't') ADVANCE(140);
      END_STATE();
    case 127:
      if (lookahead == 'a') ADVANCE(141);
      END_STATE();
    case 128:
      if (lookahead == 'c') ADVANCE(142);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_print);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_raise);
      END_STATE();
    case 131:
      if (lookahead == 'n') ADVANCE(143);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 134:
      if (lookahead == 'r') ADVANCE(144);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 136:
      if (lookahead == 'u') ADVANCE(145);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_except);
      END_STATE();
    case 138:
      if (lookahead == 'y') ADVANCE(146);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_lambda);
      END_STATE();
    case 142:
      if (lookahead == 'a') ADVANCE(147);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 144:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 145:
      if (lookahead == 'e') ADVANCE(149);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 147:
      if (lookahead == 'l') ADVANCE(150);
      END_STATE();
    case 148:
      if (lookahead == '_') ADVANCE(151);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_nonlocal);
      END_STATE();
    case 151:
      if (lookahead == '_') ADVANCE(152);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym___future__);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 38, .external_lex_state = 2},
  [2] = {.lex_state = 38, .external_lex_state = 3},
  [3] = {.lex_state = 38, .external_lex_state = 3},
  [4] = {.lex_state = 38, .external_lex_state = 3},
  [5] = {.lex_state = 38, .external_lex_state = 3},
  [6] = {.lex_state = 38, .external_lex_state = 3},
  [7] = {.lex_state = 38, .external_lex_state = 3},
  [8] = {.lex_state = 38, .external_lex_state = 3},
  [9] = {.lex_state = 38, .external_lex_state = 3},
  [10] = {.lex_state = 38, .external_lex_state = 3},
  [11] = {.lex_state = 38, .external_lex_state = 3},
  [12] = {.lex_state = 38, .external_lex_state = 3},
  [13] = {.lex_state = 38, .external_lex_state = 3},
  [14] = {.lex_state = 38, .external_lex_state = 3},
  [15] = {.lex_state = 38, .external_lex_state = 3},
  [16] = {.lex_state = 38, .external_lex_state = 3},
  [17] = {.lex_state = 38, .external_lex_state = 3},
  [18] = {.lex_state = 38, .external_lex_state = 3},
  [19] = {.lex_state = 38, .external_lex_state = 3},
  [20] = {.lex_state = 38, .external_lex_state = 3},
  [21] = {.lex_state = 38, .external_lex_state = 3},
  [22] = {.lex_state = 38, .external_lex_state = 3},
  [23] = {.lex_state = 38, .external_lex_state = 3},
  [24] = {.lex_state = 38, .external_lex_state = 3},
  [25] = {.lex_state = 38, .external_lex_state = 3},
  [26] = {.lex_state = 38, .external_lex_state = 3},
  [27] = {.lex_state = 38, .external_lex_state = 3},
  [28] = {.lex_state = 38, .external_lex_state = 3},
  [29] = {.lex_state = 38, .external_lex_state = 3},
  [30] = {.lex_state = 38, .external_lex_state = 3},
  [31] = {.lex_state = 38, .external_lex_state = 3},
  [32] = {.lex_state = 38, .external_lex_state = 3},
  [33] = {.lex_state = 38, .external_lex_state = 3},
  [34] = {.lex_state = 38, .external_lex_state = 3},
  [35] = {.lex_state = 38, .external_lex_state = 3},
  [36] = {.lex_state = 38, .external_lex_state = 3},
  [37] = {.lex_state = 38, .external_lex_state = 3},
  [38] = {.lex_state = 38, .external_lex_state = 3},
  [39] = {.lex_state = 38, .external_lex_state = 3},
  [40] = {.lex_state = 38, .external_lex_state = 3},
  [41] = {.lex_state = 38, .external_lex_state = 3},
  [42] = {.lex_state = 38, .external_lex_state = 2},
  [43] = {.lex_state = 38, .external_lex_state = 3},
  [44] = {.lex_state = 38, .external_lex_state = 3},
  [45] = {.lex_state = 38, .external_lex_state = 3},
  [46] = {.lex_state = 38, .external_lex_state = 3},
  [47] = {.lex_state = 38, .external_lex_state = 2},
  [48] = {.lex_state = 38, .external_lex_state = 4},
  [49] = {.lex_state = 38, .external_lex_state = 5},
  [50] = {.lex_state = 38, .external_lex_state = 5},
  [51] = {.lex_state = 38, .external_lex_state = 5},
  [52] = {.lex_state = 38, .external_lex_state = 5},
  [53] = {.lex_state = 38, .external_lex_state = 5},
  [54] = {.lex_state = 38, .external_lex_state = 5},
  [55] = {.lex_state = 38, .external_lex_state = 5},
  [56] = {.lex_state = 38, .external_lex_state = 5},
  [57] = {.lex_state = 38, .external_lex_state = 5},
  [58] = {.lex_state = 38, .external_lex_state = 5},
  [59] = {.lex_state = 38, .external_lex_state = 5},
  [60] = {.lex_state = 38, .external_lex_state = 5},
  [61] = {.lex_state = 38, .external_lex_state = 5},
  [62] = {.lex_state = 38, .external_lex_state = 5},
  [63] = {.lex_state = 38, .external_lex_state = 5},
  [64] = {.lex_state = 38, .external_lex_state = 5},
  [65] = {.lex_state = 38, .external_lex_state = 5},
  [66] = {.lex_state = 38, .external_lex_state = 5},
  [67] = {.lex_state = 38, .external_lex_state = 5},
  [68] = {.lex_state = 38, .external_lex_state = 5},
  [69] = {.lex_state = 38, .external_lex_state = 5},
  [70] = {.lex_state = 38, .external_lex_state = 5},
  [71] = {.lex_state = 38, .external_lex_state = 5},
  [72] = {.lex_state = 38, .external_lex_state = 5},
  [73] = {.lex_state = 38, .external_lex_state = 5},
  [74] = {.lex_state = 38, .external_lex_state = 5},
  [75] = {.lex_state = 38, .external_lex_state = 5},
  [76] = {.lex_state = 38, .external_lex_state = 5},
  [77] = {.lex_state = 38, .external_lex_state = 5},
  [78] = {.lex_state = 38, .external_lex_state = 5},
  [79] = {.lex_state = 38, .external_lex_state = 5},
  [80] = {.lex_state = 38, .external_lex_state = 5},
  [81] = {.lex_state = 38, .external_lex_state = 5},
  [82] = {.lex_state = 38, .external_lex_state = 5},
  [83] = {.lex_state = 38, .external_lex_state = 5},
  [84] = {.lex_state = 38, .external_lex_state = 5},
  [85] = {.lex_state = 38, .external_lex_state = 5},
  [86] = {.lex_state = 38, .external_lex_state = 5},
  [87] = {.lex_state = 38, .external_lex_state = 5},
  [88] = {.lex_state = 38, .external_lex_state = 5},
  [89] = {.lex_state = 38, .external_lex_state = 4},
  [90] = {.lex_state = 38, .external_lex_state = 4},
  [91] = {.lex_state = 38, .external_lex_state = 4},
  [92] = {.lex_state = 38, .external_lex_state = 4},
  [93] = {.lex_state = 38, .external_lex_state = 4},
  [94] = {.lex_state = 38, .external_lex_state = 4},
  [95] = {.lex_state = 38, .external_lex_state = 2},
  [96] = {.lex_state = 38, .external_lex_state = 4},
  [97] = {.lex_state = 38, .external_lex_state = 4},
  [98] = {.lex_state = 38, .external_lex_state = 4},
  [99] = {.lex_state = 38, .external_lex_state = 4},
  [100] = {.lex_state = 38, .external_lex_state = 2},
  [101] = {.lex_state = 38, .external_lex_state = 2},
  [102] = {.lex_state = 38, .external_lex_state = 2},
  [103] = {.lex_state = 38, .external_lex_state = 2},
  [104] = {.lex_state = 38, .external_lex_state = 2},
  [105] = {.lex_state = 38, .external_lex_state = 2},
  [106] = {.lex_state = 38, .external_lex_state = 2},
  [107] = {.lex_state = 38, .external_lex_state = 2},
  [108] = {.lex_state = 38, .external_lex_state = 2},
  [109] = {.lex_state = 10, .external_lex_state = 4},
  [110] = {.lex_state = 38, .external_lex_state = 2},
  [111] = {.lex_state = 38, .external_lex_state = 2},
  [112] = {.lex_state = 38, .external_lex_state = 2},
  [113] = {.lex_state = 38, .external_lex_state = 2},
  [114] = {.lex_state = 38, .external_lex_state = 2},
  [115] = {.lex_state = 38, .external_lex_state = 2},
  [116] = {.lex_state = 38, .external_lex_state = 2},
  [117] = {.lex_state = 38, .external_lex_state = 2},
  [118] = {.lex_state = 38, .external_lex_state = 2},
  [119] = {.lex_state = 38, .external_lex_state = 2},
  [120] = {.lex_state = 38, .external_lex_state = 2},
  [121] = {.lex_state = 38, .external_lex_state = 2},
  [122] = {.lex_state = 38, .external_lex_state = 2},
  [123] = {.lex_state = 38, .external_lex_state = 2},
  [124] = {.lex_state = 10, .external_lex_state = 4},
  [125] = {.lex_state = 38, .external_lex_state = 2},
  [126] = {.lex_state = 10, .external_lex_state = 6},
  [127] = {.lex_state = 38, .external_lex_state = 2},
  [128] = {.lex_state = 38, .external_lex_state = 2},
  [129] = {.lex_state = 38, .external_lex_state = 2},
  [130] = {.lex_state = 38, .external_lex_state = 2},
  [131] = {.lex_state = 38, .external_lex_state = 2},
  [132] = {.lex_state = 38, .external_lex_state = 2},
  [133] = {.lex_state = 38, .external_lex_state = 2},
  [134] = {.lex_state = 38, .external_lex_state = 2},
  [135] = {.lex_state = 10, .external_lex_state = 4},
  [136] = {.lex_state = 38, .external_lex_state = 2},
  [137] = {.lex_state = 38, .external_lex_state = 2},
  [138] = {.lex_state = 10, .external_lex_state = 6},
  [139] = {.lex_state = 10, .external_lex_state = 6},
  [140] = {.lex_state = 38, .external_lex_state = 2},
  [141] = {.lex_state = 10, .external_lex_state = 6},
  [142] = {.lex_state = 38, .external_lex_state = 2},
  [143] = {.lex_state = 10, .external_lex_state = 6},
  [144] = {.lex_state = 10, .external_lex_state = 6},
  [145] = {.lex_state = 10, .external_lex_state = 6},
  [146] = {.lex_state = 10, .external_lex_state = 6},
  [147] = {.lex_state = 10, .external_lex_state = 6},
  [148] = {.lex_state = 10, .external_lex_state = 6},
  [149] = {.lex_state = 10, .external_lex_state = 6},
  [150] = {.lex_state = 38, .external_lex_state = 2},
  [151] = {.lex_state = 38, .external_lex_state = 2},
  [152] = {.lex_state = 10, .external_lex_state = 4},
  [153] = {.lex_state = 38, .external_lex_state = 2},
  [154] = {.lex_state = 10, .external_lex_state = 4},
  [155] = {.lex_state = 10, .external_lex_state = 4},
  [156] = {.lex_state = 9, .external_lex_state = 6},
  [157] = {.lex_state = 38, .external_lex_state = 2},
  [158] = {.lex_state = 10, .external_lex_state = 6},
  [159] = {.lex_state = 10, .external_lex_state = 6},
  [160] = {.lex_state = 10, .external_lex_state = 6},
  [161] = {.lex_state = 10, .external_lex_state = 6},
  [162] = {.lex_state = 10, .external_lex_state = 6},
  [163] = {.lex_state = 38, .external_lex_state = 4},
  [164] = {.lex_state = 38, .external_lex_state = 2},
  [165] = {.lex_state = 38, .external_lex_state = 2},
  [166] = {.lex_state = 10, .external_lex_state = 6},
  [167] = {.lex_state = 10, .external_lex_state = 6},
  [168] = {.lex_state = 10, .external_lex_state = 6},
  [169] = {.lex_state = 10, .external_lex_state = 6},
  [170] = {.lex_state = 10, .external_lex_state = 6},
  [171] = {.lex_state = 10, .external_lex_state = 6},
  [172] = {.lex_state = 10, .external_lex_state = 6},
  [173] = {.lex_state = 10, .external_lex_state = 6},
  [174] = {.lex_state = 10, .external_lex_state = 6},
  [175] = {.lex_state = 38, .external_lex_state = 3},
  [176] = {.lex_state = 10, .external_lex_state = 6},
  [177] = {.lex_state = 38, .external_lex_state = 2},
  [178] = {.lex_state = 10, .external_lex_state = 6},
  [179] = {.lex_state = 38, .external_lex_state = 4},
  [180] = {.lex_state = 10, .external_lex_state = 6},
  [181] = {.lex_state = 10, .external_lex_state = 6},
  [182] = {.lex_state = 38, .external_lex_state = 2},
  [183] = {.lex_state = 10, .external_lex_state = 6},
  [184] = {.lex_state = 10, .external_lex_state = 6},
  [185] = {.lex_state = 38, .external_lex_state = 3},
  [186] = {.lex_state = 10, .external_lex_state = 6},
  [187] = {.lex_state = 10, .external_lex_state = 6},
  [188] = {.lex_state = 38, .external_lex_state = 2},
  [189] = {.lex_state = 10, .external_lex_state = 6},
  [190] = {.lex_state = 10, .external_lex_state = 6},
  [191] = {.lex_state = 38, .external_lex_state = 2},
  [192] = {.lex_state = 10, .external_lex_state = 6},
  [193] = {.lex_state = 38, .external_lex_state = 2},
  [194] = {.lex_state = 10, .external_lex_state = 6},
  [195] = {.lex_state = 38, .external_lex_state = 2},
  [196] = {.lex_state = 10, .external_lex_state = 6},
  [197] = {.lex_state = 38, .external_lex_state = 2},
  [198] = {.lex_state = 38, .external_lex_state = 2},
  [199] = {.lex_state = 10, .external_lex_state = 6},
  [200] = {.lex_state = 10, .external_lex_state = 6},
  [201] = {.lex_state = 10, .external_lex_state = 6},
  [202] = {.lex_state = 38, .external_lex_state = 2},
  [203] = {.lex_state = 38, .external_lex_state = 2},
  [204] = {.lex_state = 38, .external_lex_state = 2},
  [205] = {.lex_state = 38, .external_lex_state = 2},
  [206] = {.lex_state = 38, .external_lex_state = 2},
  [207] = {.lex_state = 38, .external_lex_state = 2},
  [208] = {.lex_state = 38, .external_lex_state = 2},
  [209] = {.lex_state = 38, .external_lex_state = 4},
  [210] = {.lex_state = 38, .external_lex_state = 2},
  [211] = {.lex_state = 38, .external_lex_state = 2},
  [212] = {.lex_state = 38, .external_lex_state = 2},
  [213] = {.lex_state = 38, .external_lex_state = 2},
  [214] = {.lex_state = 38, .external_lex_state = 2},
  [215] = {.lex_state = 38, .external_lex_state = 2},
  [216] = {.lex_state = 38, .external_lex_state = 2},
  [217] = {.lex_state = 38, .external_lex_state = 2},
  [218] = {.lex_state = 38, .external_lex_state = 2},
  [219] = {.lex_state = 38, .external_lex_state = 2},
  [220] = {.lex_state = 38, .external_lex_state = 2},
  [221] = {.lex_state = 38, .external_lex_state = 4},
  [222] = {.lex_state = 38, .external_lex_state = 2},
  [223] = {.lex_state = 38, .external_lex_state = 3},
  [224] = {.lex_state = 38, .external_lex_state = 3},
  [225] = {.lex_state = 38, .external_lex_state = 2},
  [226] = {.lex_state = 38, .external_lex_state = 2},
  [227] = {.lex_state = 38, .external_lex_state = 2},
  [228] = {.lex_state = 38, .external_lex_state = 2},
  [229] = {.lex_state = 38, .external_lex_state = 3},
  [230] = {.lex_state = 38, .external_lex_state = 2},
  [231] = {.lex_state = 38, .external_lex_state = 2},
  [232] = {.lex_state = 38, .external_lex_state = 3},
  [233] = {.lex_state = 38, .external_lex_state = 4},
  [234] = {.lex_state = 38, .external_lex_state = 3},
  [235] = {.lex_state = 38, .external_lex_state = 2},
  [236] = {.lex_state = 38, .external_lex_state = 2},
  [237] = {.lex_state = 38, .external_lex_state = 4},
  [238] = {.lex_state = 38, .external_lex_state = 4},
  [239] = {.lex_state = 38, .external_lex_state = 2},
  [240] = {.lex_state = 38, .external_lex_state = 2},
  [241] = {.lex_state = 38, .external_lex_state = 2},
  [242] = {.lex_state = 38, .external_lex_state = 2},
  [243] = {.lex_state = 38, .external_lex_state = 2},
  [244] = {.lex_state = 38, .external_lex_state = 2},
  [245] = {.lex_state = 38, .external_lex_state = 2},
  [246] = {.lex_state = 38, .external_lex_state = 2},
  [247] = {.lex_state = 38, .external_lex_state = 2},
  [248] = {.lex_state = 38, .external_lex_state = 2},
  [249] = {.lex_state = 38, .external_lex_state = 2},
  [250] = {.lex_state = 38, .external_lex_state = 2},
  [251] = {.lex_state = 38, .external_lex_state = 2},
  [252] = {.lex_state = 38, .external_lex_state = 2},
  [253] = {.lex_state = 38, .external_lex_state = 2},
  [254] = {.lex_state = 38, .external_lex_state = 2},
  [255] = {.lex_state = 38, .external_lex_state = 2},
  [256] = {.lex_state = 38, .external_lex_state = 2},
  [257] = {.lex_state = 38, .external_lex_state = 2},
  [258] = {.lex_state = 38, .external_lex_state = 2},
  [259] = {.lex_state = 38, .external_lex_state = 2},
  [260] = {.lex_state = 38, .external_lex_state = 2},
  [261] = {.lex_state = 38, .external_lex_state = 2},
  [262] = {.lex_state = 38, .external_lex_state = 2},
  [263] = {.lex_state = 38, .external_lex_state = 2},
  [264] = {.lex_state = 38, .external_lex_state = 2},
  [265] = {.lex_state = 38, .external_lex_state = 3},
  [266] = {.lex_state = 38, .external_lex_state = 2},
  [267] = {.lex_state = 38, .external_lex_state = 2},
  [268] = {.lex_state = 38, .external_lex_state = 3},
  [269] = {.lex_state = 38, .external_lex_state = 2},
  [270] = {.lex_state = 38, .external_lex_state = 3},
  [271] = {.lex_state = 38, .external_lex_state = 2},
  [272] = {.lex_state = 38, .external_lex_state = 3},
  [273] = {.lex_state = 38, .external_lex_state = 3},
  [274] = {.lex_state = 38, .external_lex_state = 2},
  [275] = {.lex_state = 38, .external_lex_state = 2},
  [276] = {.lex_state = 38, .external_lex_state = 3},
  [277] = {.lex_state = 38, .external_lex_state = 2},
  [278] = {.lex_state = 38, .external_lex_state = 2},
  [279] = {.lex_state = 38, .external_lex_state = 2},
  [280] = {.lex_state = 38, .external_lex_state = 2},
  [281] = {.lex_state = 38, .external_lex_state = 3},
  [282] = {.lex_state = 38, .external_lex_state = 2},
  [283] = {.lex_state = 38, .external_lex_state = 2},
  [284] = {.lex_state = 38, .external_lex_state = 2},
  [285] = {.lex_state = 38, .external_lex_state = 2},
  [286] = {.lex_state = 38, .external_lex_state = 2},
  [287] = {.lex_state = 38, .external_lex_state = 2},
  [288] = {.lex_state = 38, .external_lex_state = 2},
  [289] = {.lex_state = 38, .external_lex_state = 2},
  [290] = {.lex_state = 38, .external_lex_state = 2},
  [291] = {.lex_state = 38, .external_lex_state = 2},
  [292] = {.lex_state = 38, .external_lex_state = 2},
  [293] = {.lex_state = 38, .external_lex_state = 2},
  [294] = {.lex_state = 38, .external_lex_state = 3},
  [295] = {.lex_state = 38, .external_lex_state = 2},
  [296] = {.lex_state = 38, .external_lex_state = 2},
  [297] = {.lex_state = 38, .external_lex_state = 2},
  [298] = {.lex_state = 38, .external_lex_state = 2},
  [299] = {.lex_state = 38, .external_lex_state = 3},
  [300] = {.lex_state = 38, .external_lex_state = 2},
  [301] = {.lex_state = 38, .external_lex_state = 2},
  [302] = {.lex_state = 38, .external_lex_state = 2},
  [303] = {.lex_state = 38, .external_lex_state = 2},
  [304] = {.lex_state = 38, .external_lex_state = 2},
  [305] = {.lex_state = 38, .external_lex_state = 2},
  [306] = {.lex_state = 38, .external_lex_state = 2},
  [307] = {.lex_state = 38, .external_lex_state = 2},
  [308] = {.lex_state = 38, .external_lex_state = 2},
  [309] = {.lex_state = 38, .external_lex_state = 2},
  [310] = {.lex_state = 38, .external_lex_state = 2},
  [311] = {.lex_state = 38, .external_lex_state = 2},
  [312] = {.lex_state = 38, .external_lex_state = 2},
  [313] = {.lex_state = 38, .external_lex_state = 2},
  [314] = {.lex_state = 38, .external_lex_state = 2},
  [315] = {.lex_state = 38, .external_lex_state = 2},
  [316] = {.lex_state = 38, .external_lex_state = 2},
  [317] = {.lex_state = 38, .external_lex_state = 2},
  [318] = {.lex_state = 38, .external_lex_state = 2},
  [319] = {.lex_state = 38, .external_lex_state = 2},
  [320] = {.lex_state = 38, .external_lex_state = 2},
  [321] = {.lex_state = 38, .external_lex_state = 3},
  [322] = {.lex_state = 38, .external_lex_state = 3},
  [323] = {.lex_state = 38, .external_lex_state = 2},
  [324] = {.lex_state = 38, .external_lex_state = 3},
  [325] = {.lex_state = 38, .external_lex_state = 2},
  [326] = {.lex_state = 38, .external_lex_state = 2},
  [327] = {.lex_state = 38, .external_lex_state = 2},
  [328] = {.lex_state = 38, .external_lex_state = 2},
  [329] = {.lex_state = 38, .external_lex_state = 2},
  [330] = {.lex_state = 38, .external_lex_state = 2},
  [331] = {.lex_state = 38, .external_lex_state = 2},
  [332] = {.lex_state = 38, .external_lex_state = 2},
  [333] = {.lex_state = 38, .external_lex_state = 2},
  [334] = {.lex_state = 38, .external_lex_state = 2},
  [335] = {.lex_state = 38, .external_lex_state = 2},
  [336] = {.lex_state = 38, .external_lex_state = 2},
  [337] = {.lex_state = 38, .external_lex_state = 2},
  [338] = {.lex_state = 38, .external_lex_state = 2},
  [339] = {.lex_state = 38, .external_lex_state = 2},
  [340] = {.lex_state = 38, .external_lex_state = 2},
  [341] = {.lex_state = 38, .external_lex_state = 2},
  [342] = {.lex_state = 38, .external_lex_state = 2},
  [343] = {.lex_state = 38, .external_lex_state = 2},
  [344] = {.lex_state = 38, .external_lex_state = 2},
  [345] = {.lex_state = 38, .external_lex_state = 2},
  [346] = {.lex_state = 38, .external_lex_state = 2},
  [347] = {.lex_state = 38, .external_lex_state = 2},
  [348] = {.lex_state = 38, .external_lex_state = 2},
  [349] = {.lex_state = 38, .external_lex_state = 2},
  [350] = {.lex_state = 38, .external_lex_state = 2},
  [351] = {.lex_state = 38, .external_lex_state = 2},
  [352] = {.lex_state = 38, .external_lex_state = 2},
  [353] = {.lex_state = 38, .external_lex_state = 2},
  [354] = {.lex_state = 38, .external_lex_state = 3},
  [355] = {.lex_state = 38, .external_lex_state = 3},
  [356] = {.lex_state = 38, .external_lex_state = 2},
  [357] = {.lex_state = 38, .external_lex_state = 2},
  [358] = {.lex_state = 38, .external_lex_state = 3},
  [359] = {.lex_state = 38, .external_lex_state = 2},
  [360] = {.lex_state = 38, .external_lex_state = 3},
  [361] = {.lex_state = 38, .external_lex_state = 2},
  [362] = {.lex_state = 38, .external_lex_state = 2},
  [363] = {.lex_state = 38, .external_lex_state = 3},
  [364] = {.lex_state = 38, .external_lex_state = 3},
  [365] = {.lex_state = 38, .external_lex_state = 3},
  [366] = {.lex_state = 38, .external_lex_state = 3},
  [367] = {.lex_state = 38, .external_lex_state = 3},
  [368] = {.lex_state = 38, .external_lex_state = 2},
  [369] = {.lex_state = 38, .external_lex_state = 2},
  [370] = {.lex_state = 38, .external_lex_state = 3},
  [371] = {.lex_state = 38, .external_lex_state = 3},
  [372] = {.lex_state = 38, .external_lex_state = 2},
  [373] = {.lex_state = 38, .external_lex_state = 3},
  [374] = {.lex_state = 10, .external_lex_state = 2},
  [375] = {.lex_state = 38, .external_lex_state = 2},
  [376] = {.lex_state = 10, .external_lex_state = 2},
  [377] = {.lex_state = 10, .external_lex_state = 2},
  [378] = {.lex_state = 10},
  [379] = {.lex_state = 38, .external_lex_state = 3},
  [380] = {.lex_state = 38, .external_lex_state = 3},
  [381] = {.lex_state = 10},
  [382] = {.lex_state = 38, .external_lex_state = 3},
  [383] = {.lex_state = 38, .external_lex_state = 3},
  [384] = {.lex_state = 38, .external_lex_state = 2},
  [385] = {.lex_state = 38, .external_lex_state = 3},
  [386] = {.lex_state = 38, .external_lex_state = 3},
  [387] = {.lex_state = 38, .external_lex_state = 3},
  [388] = {.lex_state = 38, .external_lex_state = 3},
  [389] = {.lex_state = 38, .external_lex_state = 3},
  [390] = {.lex_state = 38, .external_lex_state = 3},
  [391] = {.lex_state = 38, .external_lex_state = 3},
  [392] = {.lex_state = 38, .external_lex_state = 3},
  [393] = {.lex_state = 38, .external_lex_state = 3},
  [394] = {.lex_state = 38, .external_lex_state = 3},
  [395] = {.lex_state = 38, .external_lex_state = 3},
  [396] = {.lex_state = 38, .external_lex_state = 3},
  [397] = {.lex_state = 38, .external_lex_state = 3},
  [398] = {.lex_state = 38, .external_lex_state = 2},
  [399] = {.lex_state = 38, .external_lex_state = 3},
  [400] = {.lex_state = 38, .external_lex_state = 3},
  [401] = {.lex_state = 38, .external_lex_state = 2},
  [402] = {.lex_state = 10},
  [403] = {.lex_state = 38, .external_lex_state = 3},
  [404] = {.lex_state = 38, .external_lex_state = 2},
  [405] = {.lex_state = 38, .external_lex_state = 2},
  [406] = {.lex_state = 38, .external_lex_state = 3},
  [407] = {.lex_state = 38, .external_lex_state = 2},
  [408] = {.lex_state = 38, .external_lex_state = 3},
  [409] = {.lex_state = 38, .external_lex_state = 3},
  [410] = {.lex_state = 38, .external_lex_state = 3},
  [411] = {.lex_state = 38, .external_lex_state = 2},
  [412] = {.lex_state = 38, .external_lex_state = 3},
  [413] = {.lex_state = 10},
  [414] = {.lex_state = 10},
  [415] = {.lex_state = 10},
  [416] = {.lex_state = 38, .external_lex_state = 3},
  [417] = {.lex_state = 38, .external_lex_state = 2},
  [418] = {.lex_state = 10},
  [419] = {.lex_state = 38, .external_lex_state = 2},
  [420] = {.lex_state = 10},
  [421] = {.lex_state = 10},
  [422] = {.lex_state = 38, .external_lex_state = 2},
  [423] = {.lex_state = 38, .external_lex_state = 3},
  [424] = {.lex_state = 38, .external_lex_state = 2},
  [425] = {.lex_state = 10},
  [426] = {.lex_state = 38, .external_lex_state = 2},
  [427] = {.lex_state = 38, .external_lex_state = 3},
  [428] = {.lex_state = 38, .external_lex_state = 2},
  [429] = {.lex_state = 38, .external_lex_state = 2},
  [430] = {.lex_state = 38, .external_lex_state = 3},
  [431] = {.lex_state = 10},
  [432] = {.lex_state = 38, .external_lex_state = 2},
  [433] = {.lex_state = 38, .external_lex_state = 3},
  [434] = {.lex_state = 38, .external_lex_state = 3},
  [435] = {.lex_state = 38, .external_lex_state = 2},
  [436] = {.lex_state = 38, .external_lex_state = 2},
  [437] = {.lex_state = 38, .external_lex_state = 2},
  [438] = {.lex_state = 38, .external_lex_state = 3},
  [439] = {.lex_state = 38, .external_lex_state = 2},
  [440] = {.lex_state = 38, .external_lex_state = 2},
  [441] = {.lex_state = 38, .external_lex_state = 2},
  [442] = {.lex_state = 38, .external_lex_state = 3},
  [443] = {.lex_state = 38, .external_lex_state = 2},
  [444] = {.lex_state = 38, .external_lex_state = 3},
  [445] = {.lex_state = 38, .external_lex_state = 3},
  [446] = {.lex_state = 38, .external_lex_state = 2},
  [447] = {.lex_state = 38, .external_lex_state = 2},
  [448] = {.lex_state = 38, .external_lex_state = 2},
  [449] = {.lex_state = 38, .external_lex_state = 2},
  [450] = {.lex_state = 38, .external_lex_state = 2},
  [451] = {.lex_state = 38, .external_lex_state = 2},
  [452] = {.lex_state = 38, .external_lex_state = 2},
  [453] = {.lex_state = 38, .external_lex_state = 2},
  [454] = {.lex_state = 38, .external_lex_state = 3},
  [455] = {.lex_state = 38, .external_lex_state = 2},
  [456] = {.lex_state = 38, .external_lex_state = 2},
  [457] = {.lex_state = 38, .external_lex_state = 2},
  [458] = {.lex_state = 38, .external_lex_state = 3},
  [459] = {.lex_state = 38, .external_lex_state = 2},
  [460] = {.lex_state = 38, .external_lex_state = 2},
  [461] = {.lex_state = 38, .external_lex_state = 2},
  [462] = {.lex_state = 38, .external_lex_state = 3},
  [463] = {.lex_state = 38, .external_lex_state = 2},
  [464] = {.lex_state = 9},
  [465] = {.lex_state = 10, .external_lex_state = 2},
  [466] = {.lex_state = 10, .external_lex_state = 2},
  [467] = {.lex_state = 10},
  [468] = {.lex_state = 10},
  [469] = {.lex_state = 10},
  [470] = {.lex_state = 10},
  [471] = {.lex_state = 10},
  [472] = {.lex_state = 10},
  [473] = {.lex_state = 10},
  [474] = {.lex_state = 10},
  [475] = {.lex_state = 10},
  [476] = {.lex_state = 10},
  [477] = {.lex_state = 10},
  [478] = {.lex_state = 10},
  [479] = {.lex_state = 10},
  [480] = {.lex_state = 10},
  [481] = {.lex_state = 10},
  [482] = {.lex_state = 10},
  [483] = {.lex_state = 10},
  [484] = {.lex_state = 10},
  [485] = {.lex_state = 10},
  [486] = {.lex_state = 10},
  [487] = {.lex_state = 10},
  [488] = {.lex_state = 10},
  [489] = {.lex_state = 10},
  [490] = {.lex_state = 10},
  [491] = {.lex_state = 10},
  [492] = {.lex_state = 10},
  [493] = {.lex_state = 10},
  [494] = {.lex_state = 10},
  [495] = {.lex_state = 10},
  [496] = {.lex_state = 10},
  [497] = {.lex_state = 10, .external_lex_state = 2},
  [498] = {.lex_state = 10},
  [499] = {.lex_state = 10, .external_lex_state = 2},
  [500] = {.lex_state = 9},
  [501] = {.lex_state = 10, .external_lex_state = 2},
  [502] = {.lex_state = 38, .external_lex_state = 2},
  [503] = {.lex_state = 10},
  [504] = {.lex_state = 38, .external_lex_state = 2},
  [505] = {.lex_state = 38, .external_lex_state = 2},
  [506] = {.lex_state = 10},
  [507] = {.lex_state = 38, .external_lex_state = 2},
  [508] = {.lex_state = 10},
  [509] = {.lex_state = 38, .external_lex_state = 2},
  [510] = {.lex_state = 38, .external_lex_state = 2},
  [511] = {.lex_state = 38, .external_lex_state = 2},
  [512] = {.lex_state = 38, .external_lex_state = 2},
  [513] = {.lex_state = 38, .external_lex_state = 2},
  [514] = {.lex_state = 38, .external_lex_state = 2},
  [515] = {.lex_state = 10},
  [516] = {.lex_state = 10},
  [517] = {.lex_state = 38, .external_lex_state = 2},
  [518] = {.lex_state = 10},
  [519] = {.lex_state = 10},
  [520] = {.lex_state = 10},
  [521] = {.lex_state = 10},
  [522] = {.lex_state = 10},
  [523] = {.lex_state = 10},
  [524] = {.lex_state = 38, .external_lex_state = 2},
  [525] = {.lex_state = 38, .external_lex_state = 2},
  [526] = {.lex_state = 38, .external_lex_state = 2},
  [527] = {.lex_state = 38, .external_lex_state = 2},
  [528] = {.lex_state = 38, .external_lex_state = 2},
  [529] = {.lex_state = 38, .external_lex_state = 2},
  [530] = {.lex_state = 38, .external_lex_state = 6},
  [531] = {.lex_state = 38, .external_lex_state = 2},
  [532] = {.lex_state = 38, .external_lex_state = 2},
  [533] = {.lex_state = 38, .external_lex_state = 2},
  [534] = {.lex_state = 38, .external_lex_state = 2},
  [535] = {.lex_state = 10, .external_lex_state = 2},
  [536] = {.lex_state = 38, .external_lex_state = 2},
  [537] = {.lex_state = 38, .external_lex_state = 2},
  [538] = {.lex_state = 38, .external_lex_state = 2},
  [539] = {.lex_state = 9},
  [540] = {.lex_state = 38, .external_lex_state = 2},
  [541] = {.lex_state = 38, .external_lex_state = 2},
  [542] = {.lex_state = 10, .external_lex_state = 2},
  [543] = {.lex_state = 38, .external_lex_state = 6},
  [544] = {.lex_state = 38, .external_lex_state = 2},
  [545] = {.lex_state = 38, .external_lex_state = 2},
  [546] = {.lex_state = 38, .external_lex_state = 2},
  [547] = {.lex_state = 38, .external_lex_state = 2},
  [548] = {.lex_state = 38, .external_lex_state = 2},
  [549] = {.lex_state = 38, .external_lex_state = 2},
  [550] = {.lex_state = 38, .external_lex_state = 2},
  [551] = {.lex_state = 38, .external_lex_state = 2},
  [552] = {.lex_state = 38, .external_lex_state = 2},
  [553] = {.lex_state = 38, .external_lex_state = 2},
  [554] = {.lex_state = 38, .external_lex_state = 2},
  [555] = {.lex_state = 38, .external_lex_state = 2},
  [556] = {.lex_state = 38, .external_lex_state = 2},
  [557] = {.lex_state = 38, .external_lex_state = 2},
  [558] = {.lex_state = 38, .external_lex_state = 2},
  [559] = {.lex_state = 38, .external_lex_state = 2},
  [560] = {.lex_state = 10},
  [561] = {.lex_state = 10},
  [562] = {.lex_state = 10},
  [563] = {.lex_state = 10},
  [564] = {.lex_state = 10},
  [565] = {.lex_state = 10},
  [566] = {.lex_state = 10},
  [567] = {.lex_state = 10},
  [568] = {.lex_state = 10},
  [569] = {.lex_state = 10},
  [570] = {.lex_state = 10},
  [571] = {.lex_state = 10},
  [572] = {.lex_state = 10},
  [573] = {.lex_state = 10},
  [574] = {.lex_state = 10},
  [575] = {.lex_state = 10},
  [576] = {.lex_state = 10},
  [577] = {.lex_state = 10},
  [578] = {.lex_state = 10},
  [579] = {.lex_state = 10},
  [580] = {.lex_state = 10},
  [581] = {.lex_state = 10},
  [582] = {.lex_state = 10},
  [583] = {.lex_state = 10},
  [584] = {.lex_state = 10},
  [585] = {.lex_state = 10},
  [586] = {.lex_state = 10},
  [587] = {.lex_state = 10},
  [588] = {.lex_state = 10},
  [589] = {.lex_state = 10},
  [590] = {.lex_state = 38},
  [591] = {.lex_state = 38},
  [592] = {.lex_state = 38, .external_lex_state = 6},
  [593] = {.lex_state = 38, .external_lex_state = 6},
  [594] = {.lex_state = 38, .external_lex_state = 6},
  [595] = {.lex_state = 38, .external_lex_state = 6},
  [596] = {.lex_state = 38, .external_lex_state = 6},
  [597] = {.lex_state = 38, .external_lex_state = 6},
  [598] = {.lex_state = 38, .external_lex_state = 6},
  [599] = {.lex_state = 38, .external_lex_state = 6},
  [600] = {.lex_state = 38, .external_lex_state = 6},
  [601] = {.lex_state = 38, .external_lex_state = 6},
  [602] = {.lex_state = 38, .external_lex_state = 6},
  [603] = {.lex_state = 10},
  [604] = {.lex_state = 38, .external_lex_state = 6},
  [605] = {.lex_state = 38, .external_lex_state = 6},
  [606] = {.lex_state = 10},
  [607] = {.lex_state = 38, .external_lex_state = 6},
  [608] = {.lex_state = 38},
  [609] = {.lex_state = 38},
  [610] = {.lex_state = 38, .external_lex_state = 6},
  [611] = {.lex_state = 38},
  [612] = {.lex_state = 38},
  [613] = {.lex_state = 38},
  [614] = {.lex_state = 38},
  [615] = {.lex_state = 38},
  [616] = {.lex_state = 0},
  [617] = {.lex_state = 38},
  [618] = {.lex_state = 38},
  [619] = {.lex_state = 0},
  [620] = {.lex_state = 38},
  [621] = {.lex_state = 38},
  [622] = {.lex_state = 38},
  [623] = {.lex_state = 38},
  [624] = {.lex_state = 0},
  [625] = {.lex_state = 38},
  [626] = {.lex_state = 38},
  [627] = {.lex_state = 38},
  [628] = {.lex_state = 0},
  [629] = {.lex_state = 0},
  [630] = {.lex_state = 38},
  [631] = {.lex_state = 0},
  [632] = {.lex_state = 0},
  [633] = {.lex_state = 38},
  [634] = {.lex_state = 38},
  [635] = {.lex_state = 38},
  [636] = {.lex_state = 38},
  [637] = {.lex_state = 0},
  [638] = {.lex_state = 0},
  [639] = {.lex_state = 38},
  [640] = {.lex_state = 38},
  [641] = {.lex_state = 38},
  [642] = {.lex_state = 0},
  [643] = {.lex_state = 0},
  [644] = {.lex_state = 0},
  [645] = {.lex_state = 0},
  [646] = {.lex_state = 0},
  [647] = {.lex_state = 0},
  [648] = {.lex_state = 0},
  [649] = {.lex_state = 0},
  [650] = {.lex_state = 0},
  [651] = {.lex_state = 0},
  [652] = {.lex_state = 0},
  [653] = {.lex_state = 0},
  [654] = {.lex_state = 0},
  [655] = {.lex_state = 0},
  [656] = {.lex_state = 0},
  [657] = {.lex_state = 0},
  [658] = {.lex_state = 0},
  [659] = {.lex_state = 0},
  [660] = {.lex_state = 0},
  [661] = {.lex_state = 38},
  [662] = {.lex_state = 0},
  [663] = {.lex_state = 38},
  [664] = {.lex_state = 0},
  [665] = {.lex_state = 0},
  [666] = {.lex_state = 0},
  [667] = {.lex_state = 12, .external_lex_state = 7},
  [668] = {.lex_state = 0},
  [669] = {.lex_state = 10, .external_lex_state = 6},
  [670] = {.lex_state = 12, .external_lex_state = 7},
  [671] = {.lex_state = 38},
  [672] = {.lex_state = 12, .external_lex_state = 7},
  [673] = {.lex_state = 0, .external_lex_state = 6},
  [674] = {.lex_state = 0, .external_lex_state = 6},
  [675] = {.lex_state = 12, .external_lex_state = 7},
  [676] = {.lex_state = 12, .external_lex_state = 7},
  [677] = {.lex_state = 12, .external_lex_state = 7},
  [678] = {.lex_state = 38},
  [679] = {.lex_state = 0},
  [680] = {.lex_state = 0, .external_lex_state = 6},
  [681] = {.lex_state = 12, .external_lex_state = 7},
  [682] = {.lex_state = 38},
  [683] = {.lex_state = 0},
  [684] = {.lex_state = 0},
  [685] = {.lex_state = 38},
  [686] = {.lex_state = 12, .external_lex_state = 7},
  [687] = {.lex_state = 38},
  [688] = {.lex_state = 12, .external_lex_state = 7},
  [689] = {.lex_state = 0},
  [690] = {.lex_state = 10, .external_lex_state = 6},
  [691] = {.lex_state = 0},
  [692] = {.lex_state = 38},
  [693] = {.lex_state = 10, .external_lex_state = 6},
  [694] = {.lex_state = 10},
  [695] = {.lex_state = 0},
  [696] = {.lex_state = 0},
  [697] = {.lex_state = 38},
  [698] = {.lex_state = 38},
  [699] = {.lex_state = 0, .external_lex_state = 6},
  [700] = {.lex_state = 0},
  [701] = {.lex_state = 0},
  [702] = {.lex_state = 0, .external_lex_state = 6},
  [703] = {.lex_state = 38},
  [704] = {.lex_state = 38},
  [705] = {.lex_state = 10},
  [706] = {.lex_state = 38},
  [707] = {.lex_state = 38},
  [708] = {.lex_state = 0},
  [709] = {.lex_state = 38},
  [710] = {.lex_state = 38},
  [711] = {.lex_state = 38},
  [712] = {.lex_state = 38},
  [713] = {.lex_state = 38},
  [714] = {.lex_state = 38},
  [715] = {.lex_state = 10, .external_lex_state = 6},
  [716] = {.lex_state = 38},
  [717] = {.lex_state = 38},
  [718] = {.lex_state = 10},
  [719] = {.lex_state = 38},
  [720] = {.lex_state = 0},
  [721] = {.lex_state = 38},
  [722] = {.lex_state = 38},
  [723] = {.lex_state = 38},
  [724] = {.lex_state = 0, .external_lex_state = 6},
  [725] = {.lex_state = 38},
  [726] = {.lex_state = 0},
  [727] = {.lex_state = 0},
  [728] = {.lex_state = 10},
  [729] = {.lex_state = 12, .external_lex_state = 7},
  [730] = {.lex_state = 0},
  [731] = {.lex_state = 0, .external_lex_state = 6},
  [732] = {.lex_state = 38},
  [733] = {.lex_state = 0},
  [734] = {.lex_state = 12, .external_lex_state = 7},
  [735] = {.lex_state = 38},
  [736] = {.lex_state = 4},
  [737] = {.lex_state = 38},
  [738] = {.lex_state = 0, .external_lex_state = 6},
  [739] = {.lex_state = 38},
  [740] = {.lex_state = 0, .external_lex_state = 6},
  [741] = {.lex_state = 0, .external_lex_state = 6},
  [742] = {.lex_state = 0, .external_lex_state = 6},
  [743] = {.lex_state = 0},
  [744] = {.lex_state = 0},
  [745] = {.lex_state = 0},
  [746] = {.lex_state = 0},
  [747] = {.lex_state = 0},
  [748] = {.lex_state = 0},
  [749] = {.lex_state = 4},
  [750] = {.lex_state = 10},
  [751] = {.lex_state = 0},
  [752] = {.lex_state = 0, .external_lex_state = 6},
  [753] = {.lex_state = 38},
  [754] = {.lex_state = 0},
  [755] = {.lex_state = 0},
  [756] = {.lex_state = 0},
  [757] = {.lex_state = 4},
  [758] = {.lex_state = 12, .external_lex_state = 7},
  [759] = {.lex_state = 38},
  [760] = {.lex_state = 0, .external_lex_state = 6},
  [761] = {.lex_state = 38},
  [762] = {.lex_state = 10},
  [763] = {.lex_state = 38},
  [764] = {.lex_state = 38},
  [765] = {.lex_state = 38},
  [766] = {.lex_state = 0},
  [767] = {.lex_state = 0},
  [768] = {.lex_state = 0, .external_lex_state = 6},
  [769] = {.lex_state = 0},
  [770] = {.lex_state = 0},
  [771] = {.lex_state = 38},
  [772] = {.lex_state = 0},
  [773] = {.lex_state = 0},
  [774] = {.lex_state = 0, .external_lex_state = 6},
  [775] = {.lex_state = 38},
  [776] = {.lex_state = 0, .external_lex_state = 6},
  [777] = {.lex_state = 38},
  [778] = {.lex_state = 38},
  [779] = {.lex_state = 0, .external_lex_state = 6},
  [780] = {.lex_state = 0},
  [781] = {.lex_state = 0},
  [782] = {.lex_state = 0, .external_lex_state = 6},
  [783] = {.lex_state = 38},
  [784] = {.lex_state = 38},
  [785] = {.lex_state = 0},
  [786] = {.lex_state = 0},
  [787] = {.lex_state = 0, .external_lex_state = 6},
  [788] = {.lex_state = 0, .external_lex_state = 6},
  [789] = {.lex_state = 0, .external_lex_state = 6},
  [790] = {.lex_state = 0, .external_lex_state = 6},
  [791] = {.lex_state = 0, .external_lex_state = 6},
  [792] = {.lex_state = 0},
  [793] = {.lex_state = 38},
  [794] = {.lex_state = 0, .external_lex_state = 6},
  [795] = {.lex_state = 0},
  [796] = {.lex_state = 10},
  [797] = {.lex_state = 0, .external_lex_state = 6},
  [798] = {.lex_state = 38},
  [799] = {.lex_state = 0},
  [800] = {.lex_state = 38},
  [801] = {.lex_state = 0},
  [802] = {.lex_state = 0},
  [803] = {.lex_state = 0, .external_lex_state = 6},
  [804] = {.lex_state = 0, .external_lex_state = 6},
  [805] = {.lex_state = 38},
  [806] = {.lex_state = 38},
  [807] = {.lex_state = 0},
  [808] = {.lex_state = 0},
  [809] = {.lex_state = 0},
  [810] = {.lex_state = 0},
  [811] = {.lex_state = 0},
  [812] = {.lex_state = 0},
  [813] = {.lex_state = 0},
  [814] = {.lex_state = 38},
  [815] = {.lex_state = 0},
  [816] = {.lex_state = 0},
  [817] = {.lex_state = 38},
  [818] = {.lex_state = 0},
  [819] = {.lex_state = 0},
  [820] = {.lex_state = 38},
  [821] = {.lex_state = 0, .external_lex_state = 6},
  [822] = {.lex_state = 0, .external_lex_state = 6},
  [823] = {.lex_state = 0},
  [824] = {.lex_state = 38},
  [825] = {.lex_state = 0},
  [826] = {.lex_state = 0},
  [827] = {.lex_state = 0},
  [828] = {.lex_state = 0, .external_lex_state = 6},
  [829] = {.lex_state = 0, .external_lex_state = 6},
  [830] = {.lex_state = 0},
  [831] = {.lex_state = 0},
  [832] = {.lex_state = 0},
  [833] = {.lex_state = 38},
  [834] = {.lex_state = 0},
  [835] = {.lex_state = 0, .external_lex_state = 6},
  [836] = {.lex_state = 38},
  [837] = {.lex_state = 0},
  [838] = {.lex_state = 0},
  [839] = {.lex_state = 0, .external_lex_state = 6},
  [840] = {.lex_state = 38},
  [841] = {.lex_state = 0},
  [842] = {.lex_state = 0, .external_lex_state = 6},
  [843] = {.lex_state = 0},
  [844] = {.lex_state = 0, .external_lex_state = 6},
  [845] = {.lex_state = 0},
  [846] = {.lex_state = 0},
  [847] = {.lex_state = 38},
  [848] = {.lex_state = 38},
  [849] = {.lex_state = 0},
  [850] = {.lex_state = 0},
  [851] = {.lex_state = 38},
  [852] = {.lex_state = 0},
  [853] = {.lex_state = 0},
  [854] = {.lex_state = 0},
  [855] = {.lex_state = 0},
  [856] = {.lex_state = 0},
  [857] = {.lex_state = 0},
  [858] = {.lex_state = 0},
  [859] = {.lex_state = 0},
  [860] = {.lex_state = 0},
  [861] = {.lex_state = 0},
  [862] = {.lex_state = 0, .external_lex_state = 6},
  [863] = {.lex_state = 0},
  [864] = {.lex_state = 0, .external_lex_state = 6},
  [865] = {.lex_state = 0},
  [866] = {.lex_state = 0},
  [867] = {.lex_state = 0},
  [868] = {.lex_state = 0},
  [869] = {.lex_state = 0},
  [870] = {.lex_state = 0},
  [871] = {.lex_state = 0},
  [872] = {.lex_state = 0},
  [873] = {.lex_state = 0},
  [874] = {.lex_state = 0},
  [875] = {.lex_state = 0},
  [876] = {.lex_state = 0},
  [877] = {.lex_state = 38},
  [878] = {.lex_state = 0},
  [879] = {.lex_state = 4},
  [880] = {.lex_state = 0, .external_lex_state = 6},
  [881] = {.lex_state = 0},
  [882] = {.lex_state = 38},
  [883] = {.lex_state = 0, .external_lex_state = 6},
  [884] = {.lex_state = 0, .external_lex_state = 6},
  [885] = {.lex_state = 38},
  [886] = {.lex_state = 0},
  [887] = {.lex_state = 38},
  [888] = {.lex_state = 38},
  [889] = {.lex_state = 0},
  [890] = {.lex_state = 0},
  [891] = {.lex_state = 0},
  [892] = {.lex_state = 0},
  [893] = {.lex_state = 38},
  [894] = {.lex_state = 0},
  [895] = {.lex_state = 38},
  [896] = {.lex_state = 0},
  [897] = {.lex_state = 0, .external_lex_state = 6},
  [898] = {.lex_state = 38},
  [899] = {.lex_state = 38},
  [900] = {.lex_state = 38},
  [901] = {.lex_state = 38},
  [902] = {.lex_state = 38},
  [903] = {.lex_state = 0, .external_lex_state = 6},
  [904] = {.lex_state = 0, .external_lex_state = 6},
  [905] = {.lex_state = 0, .external_lex_state = 6},
  [906] = {.lex_state = 0},
  [907] = {.lex_state = 0, .external_lex_state = 6},
  [908] = {.lex_state = 0, .external_lex_state = 6},
  [909] = {.lex_state = 0, .external_lex_state = 6},
  [910] = {.lex_state = 0},
  [911] = {.lex_state = 0},
  [912] = {.lex_state = 0, .external_lex_state = 6},
  [913] = {.lex_state = 38},
  [914] = {.lex_state = 38},
  [915] = {.lex_state = 0},
  [916] = {.lex_state = 0, .external_lex_state = 6},
  [917] = {.lex_state = 0},
  [918] = {.lex_state = 0, .external_lex_state = 6},
  [919] = {.lex_state = 0},
  [920] = {.lex_state = 0, .external_lex_state = 6},
  [921] = {.lex_state = 11},
  [922] = {.lex_state = 0},
  [923] = {.lex_state = 0},
  [924] = {.lex_state = 0, .external_lex_state = 6},
  [925] = {.lex_state = 0, .external_lex_state = 6},
  [926] = {.lex_state = 0, .external_lex_state = 6},
  [927] = {.lex_state = 0, .external_lex_state = 6},
  [928] = {.lex_state = 0, .external_lex_state = 6},
  [929] = {.lex_state = 0},
  [930] = {.lex_state = 0, .external_lex_state = 6},
  [931] = {.lex_state = 0},
  [932] = {.lex_state = 0},
  [933] = {.lex_state = 0},
  [934] = {.lex_state = 0, .external_lex_state = 6},
  [935] = {.lex_state = 0, .external_lex_state = 6},
  [936] = {.lex_state = 0},
  [937] = {.lex_state = 11},
  [938] = {.lex_state = 0, .external_lex_state = 6},
  [939] = {.lex_state = 11},
  [940] = {.lex_state = 0},
  [941] = {.lex_state = 11},
  [942] = {.lex_state = 0},
  [943] = {.lex_state = 0},
  [944] = {.lex_state = 11},
  [945] = {.lex_state = 0},
  [946] = {.lex_state = 11},
  [947] = {.lex_state = 0},
  [948] = {.lex_state = 0},
  [949] = {.lex_state = 0},
  [950] = {.lex_state = 0},
  [951] = {.lex_state = 0},
  [952] = {.lex_state = 0},
  [953] = {.lex_state = 0},
  [954] = {.lex_state = 0},
  [955] = {.lex_state = 0},
  [956] = {.lex_state = 0},
  [957] = {.lex_state = 0},
  [958] = {.lex_state = 0},
  [959] = {.lex_state = 0},
  [960] = {.lex_state = 38},
  [961] = {.lex_state = 0},
  [962] = {.lex_state = 0},
  [963] = {.lex_state = 0},
  [964] = {.lex_state = 38},
  [965] = {.lex_state = 0},
  [966] = {.lex_state = 0},
  [967] = {.lex_state = 38},
  [968] = {.lex_state = 38},
  [969] = {.lex_state = 0},
  [970] = {.lex_state = 0},
  [971] = {.lex_state = 0},
  [972] = {.lex_state = 0},
  [973] = {.lex_state = 0},
  [974] = {.lex_state = 0},
  [975] = {.lex_state = 0},
  [976] = {.lex_state = 0},
  [977] = {.lex_state = 0},
  [978] = {.lex_state = 0},
  [979] = {.lex_state = 0},
  [980] = {.lex_state = 0},
  [981] = {.lex_state = 0},
  [982] = {.lex_state = 0},
  [983] = {.lex_state = 0},
  [984] = {.lex_state = 0},
  [985] = {.lex_state = 0},
  [986] = {.lex_state = 0},
  [987] = {.lex_state = 0},
  [988] = {.lex_state = 38},
  [989] = {.lex_state = 38},
  [990] = {.lex_state = 0},
  [991] = {.lex_state = 0},
  [992] = {.lex_state = 0},
  [993] = {.lex_state = 38},
  [994] = {.lex_state = 0},
  [995] = {.lex_state = 0},
  [996] = {.lex_state = 38},
  [997] = {.lex_state = 0, .external_lex_state = 6},
  [998] = {.lex_state = 38},
  [999] = {.lex_state = 38},
  [1000] = {.lex_state = 38},
  [1001] = {.lex_state = 38},
  [1002] = {.lex_state = 38},
  [1003] = {.lex_state = 0},
  [1004] = {.lex_state = 38},
  [1005] = {.lex_state = 38},
  [1006] = {.lex_state = 0},
  [1007] = {.lex_state = 0},
  [1008] = {.lex_state = 0},
  [1009] = {.lex_state = 0},
  [1010] = {.lex_state = 0},
  [1011] = {.lex_state = 38},
  [1012] = {.lex_state = 38},
  [1013] = {.lex_state = 0},
  [1014] = {.lex_state = 38},
  [1015] = {.lex_state = 38},
  [1016] = {.lex_state = 38},
  [1017] = {.lex_state = 38},
  [1018] = {.lex_state = 0},
  [1019] = {.lex_state = 0},
  [1020] = {.lex_state = 0},
  [1021] = {.lex_state = 0},
  [1022] = {.lex_state = 0},
  [1023] = {.lex_state = 0},
  [1024] = {.lex_state = 0},
  [1025] = {.lex_state = 0},
  [1026] = {.lex_state = 0},
  [1027] = {.lex_state = 0},
  [1028] = {.lex_state = 0},
  [1029] = {.lex_state = 0},
  [1030] = {.lex_state = 0},
};

enum {
  ts_external_token__newline = 0,
  ts_external_token__indent = 1,
  ts_external_token__dedent = 2,
  ts_external_token__string_start = 3,
  ts_external_token__string_content = 4,
  ts_external_token__string_end = 5,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__indent] = sym__indent,
  [ts_external_token__dedent] = sym__dedent,
  [ts_external_token__string_start] = sym__string_start,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token__string_end] = sym__string_end,
};

static bool ts_external_scanner_states[8][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
  [2] = {
    [ts_external_token__string_start] = true,
  },
  [3] = {
    [ts_external_token__dedent] = true,
    [ts_external_token__string_start] = true,
  },
  [4] = {
    [ts_external_token__newline] = true,
    [ts_external_token__string_start] = true,
  },
  [5] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__string_start] = true,
  },
  [6] = {
    [ts_external_token__newline] = true,
  },
  [7] = {
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym___future__] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_print] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_COLON_EQ] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_del] = ACTIONS(1),
    [anon_sym_raise] = ACTIONS(1),
    [anon_sym_pass] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_except] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_def] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_nonlocal] = ACTIONS(1),
    [anon_sym_exec] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_SLASH_SLASH] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LT_GT] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_lambda] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_AT_EQ] = ACTIONS(1),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [sym_ellipsis] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [sym_type_conversion] = ACTIONS(1),
    [sym_integer] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_none] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(1),
    [sym__newline] = ACTIONS(1),
    [sym__indent] = ACTIONS(1),
    [sym__dedent] = ACTIONS(1),
    [sym__string_start] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym__string_end] = ACTIONS(1),
  },
  [1] = {
    [sym_module] = STATE(987),
    [sym__statement] = STATE(42),
    [sym__simple_statements] = STATE(42),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_if_statement] = STATE(42),
    [sym_for_statement] = STATE(42),
    [sym_while_statement] = STATE(42),
    [sym_try_statement] = STATE(42),
    [sym_with_statement] = STATE(42),
    [sym_function_definition] = STATE(42),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_class_definition] = STATE(42),
    [sym_decorated_definition] = STATE(42),
    [sym_decorator] = STATE(657),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(42),
    [aux_sym_decorated_definition_repeat1] = STATE(657),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_with] = ACTIONS(41),
    [anon_sym_def] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [2] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(321),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [3] = {
    [sym__statement] = STATE(46),
    [sym__simple_statements] = STATE(46),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(46),
    [sym_for_statement] = STATE(46),
    [sym_while_statement] = STATE(46),
    [sym_try_statement] = STATE(46),
    [sym_with_statement] = STATE(46),
    [sym_function_definition] = STATE(46),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(46),
    [sym_decorated_definition] = STATE(46),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(746),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(46),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [4] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(428),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [5] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(372),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [6] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(359),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [7] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(224),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [8] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(365),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [9] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(422),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [10] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(454),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [11] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(426),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [12] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(369),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [13] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(324),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [14] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(394),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [15] = {
    [sym__statement] = STATE(46),
    [sym__simple_statements] = STATE(46),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(46),
    [sym_for_statement] = STATE(46),
    [sym_while_statement] = STATE(46),
    [sym_try_statement] = STATE(46),
    [sym_with_statement] = STATE(46),
    [sym_function_definition] = STATE(46),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(46),
    [sym_decorated_definition] = STATE(46),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(747),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(46),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(93),
    [sym__string_start] = ACTIONS(73),
  },
  [16] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(392),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [17] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(355),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [18] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(307),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [19] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(242),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [20] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(388),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [21] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(456),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [22] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(455),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [23] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(423),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [24] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(436),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [25] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(448),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [26] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(351),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [27] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(409),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [28] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(340),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [29] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(452),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [30] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(412),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [31] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(416),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [32] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(451),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [33] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(356),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [34] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(326),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [35] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(367),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [36] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(299),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [37] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(433),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [38] = {
    [sym__statement] = STATE(45),
    [sym__simple_statements] = STATE(45),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(45),
    [sym_for_statement] = STATE(45),
    [sym_while_statement] = STATE(45),
    [sym_try_statement] = STATE(45),
    [sym_with_statement] = STATE(45),
    [sym_function_definition] = STATE(45),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(45),
    [sym_decorated_definition] = STATE(45),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(439),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(45),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(95),
    [sym__string_start] = ACTIONS(73),
  },
  [39] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(379),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [40] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(360),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [41] = {
    [sym__statement] = STATE(43),
    [sym__simple_statements] = STATE(43),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(43),
    [sym_for_statement] = STATE(43),
    [sym_while_statement] = STATE(43),
    [sym_try_statement] = STATE(43),
    [sym_with_statement] = STATE(43),
    [sym_function_definition] = STATE(43),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(43),
    [sym_decorated_definition] = STATE(43),
    [sym_decorator] = STATE(662),
    [sym_block] = STATE(462),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(43),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(91),
    [sym__string_start] = ACTIONS(73),
  },
  [42] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(657),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(657),
    [ts_builtin_sym_end] = ACTIONS(97),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_with] = ACTIONS(41),
    [anon_sym_def] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
  [43] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(662),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(99),
    [sym__string_start] = ACTIONS(73),
  },
  [44] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(662),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(104),
    [anon_sym_from] = ACTIONS(107),
    [anon_sym_LPAREN] = ACTIONS(110),
    [anon_sym_print] = ACTIONS(113),
    [anon_sym_assert] = ACTIONS(116),
    [anon_sym_return] = ACTIONS(119),
    [anon_sym_del] = ACTIONS(122),
    [anon_sym_raise] = ACTIONS(125),
    [anon_sym_pass] = ACTIONS(128),
    [anon_sym_break] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(134),
    [anon_sym_if] = ACTIONS(137),
    [anon_sym_async] = ACTIONS(140),
    [anon_sym_for] = ACTIONS(143),
    [anon_sym_while] = ACTIONS(146),
    [anon_sym_try] = ACTIONS(149),
    [anon_sym_with] = ACTIONS(152),
    [anon_sym_def] = ACTIONS(155),
    [anon_sym_global] = ACTIONS(158),
    [anon_sym_nonlocal] = ACTIONS(161),
    [anon_sym_exec] = ACTIONS(164),
    [anon_sym_class] = ACTIONS(167),
    [anon_sym_AT] = ACTIONS(170),
    [anon_sym_not] = ACTIONS(173),
    [anon_sym_PLUS] = ACTIONS(176),
    [anon_sym_DASH] = ACTIONS(176),
    [anon_sym_TILDE] = ACTIONS(176),
    [anon_sym_lambda] = ACTIONS(179),
    [anon_sym_yield] = ACTIONS(182),
    [anon_sym_LBRACK] = ACTIONS(185),
    [sym_ellipsis] = ACTIONS(188),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_integer] = ACTIONS(194),
    [sym_float] = ACTIONS(188),
    [sym_true] = ACTIONS(194),
    [sym_false] = ACTIONS(194),
    [sym_none] = ACTIONS(194),
    [anon_sym_await] = ACTIONS(197),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(200),
    [sym__string_start] = ACTIONS(202),
  },
  [45] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(662),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(205),
    [sym__string_start] = ACTIONS(73),
  },
  [46] = {
    [sym__statement] = STATE(44),
    [sym__simple_statements] = STATE(44),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_if_statement] = STATE(44),
    [sym_for_statement] = STATE(44),
    [sym_while_statement] = STATE(44),
    [sym_try_statement] = STATE(44),
    [sym_with_statement] = STATE(44),
    [sym_function_definition] = STATE(44),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_class_definition] = STATE(44),
    [sym_decorated_definition] = STATE(44),
    [sym_decorator] = STATE(662),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(44),
    [aux_sym_decorated_definition_repeat1] = STATE(662),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(75),
    [anon_sym_async] = ACTIONS(77),
    [anon_sym_for] = ACTIONS(79),
    [anon_sym_while] = ACTIONS(81),
    [anon_sym_try] = ACTIONS(83),
    [anon_sym_with] = ACTIONS(85),
    [anon_sym_def] = ACTIONS(87),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(89),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__dedent] = ACTIONS(207),
    [sym__string_start] = ACTIONS(73),
  },
  [47] = {
    [sym__statement] = STATE(47),
    [sym__simple_statements] = STATE(47),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_if_statement] = STATE(47),
    [sym_for_statement] = STATE(47),
    [sym_while_statement] = STATE(47),
    [sym_try_statement] = STATE(47),
    [sym_with_statement] = STATE(47),
    [sym_function_definition] = STATE(47),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_class_definition] = STATE(47),
    [sym_decorated_definition] = STATE(47),
    [sym_decorator] = STATE(657),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [aux_sym_module_repeat1] = STATE(47),
    [aux_sym_decorated_definition_repeat1] = STATE(657),
    [ts_builtin_sym_end] = ACTIONS(200),
    [sym_identifier] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(104),
    [anon_sym_from] = ACTIONS(107),
    [anon_sym_LPAREN] = ACTIONS(110),
    [anon_sym_print] = ACTIONS(113),
    [anon_sym_assert] = ACTIONS(116),
    [anon_sym_return] = ACTIONS(119),
    [anon_sym_del] = ACTIONS(122),
    [anon_sym_raise] = ACTIONS(125),
    [anon_sym_pass] = ACTIONS(128),
    [anon_sym_break] = ACTIONS(131),
    [anon_sym_continue] = ACTIONS(134),
    [anon_sym_if] = ACTIONS(209),
    [anon_sym_async] = ACTIONS(212),
    [anon_sym_for] = ACTIONS(215),
    [anon_sym_while] = ACTIONS(218),
    [anon_sym_try] = ACTIONS(221),
    [anon_sym_with] = ACTIONS(224),
    [anon_sym_def] = ACTIONS(227),
    [anon_sym_global] = ACTIONS(158),
    [anon_sym_nonlocal] = ACTIONS(161),
    [anon_sym_exec] = ACTIONS(164),
    [anon_sym_class] = ACTIONS(230),
    [anon_sym_AT] = ACTIONS(170),
    [anon_sym_not] = ACTIONS(173),
    [anon_sym_PLUS] = ACTIONS(176),
    [anon_sym_DASH] = ACTIONS(176),
    [anon_sym_TILDE] = ACTIONS(176),
    [anon_sym_lambda] = ACTIONS(179),
    [anon_sym_yield] = ACTIONS(182),
    [anon_sym_LBRACK] = ACTIONS(185),
    [sym_ellipsis] = ACTIONS(188),
    [anon_sym_LBRACE] = ACTIONS(191),
    [sym_integer] = ACTIONS(194),
    [sym_float] = ACTIONS(188),
    [sym_true] = ACTIONS(194),
    [sym_false] = ACTIONS(194),
    [sym_none] = ACTIONS(194),
    [anon_sym_await] = ACTIONS(197),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(202),
  },
  [48] = {
    [sym_chevron] = STATE(760),
    [sym_named_expression] = STATE(674),
    [sym__expression] = STATE(674),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(674),
    [sym_boolean_operator] = STATE(674),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(674),
    [sym_lambda] = STATE(674),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(674),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(674),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_DOT] = ACTIONS(233),
    [anon_sym_LPAREN] = ACTIONS(235),
    [anon_sym_COMMA] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(233),
    [anon_sym_print] = ACTIONS(237),
    [anon_sym_GT_GT] = ACTIONS(239),
    [anon_sym_if] = ACTIONS(233),
    [anon_sym_COLON] = ACTIONS(235),
    [anon_sym_in] = ACTIONS(233),
    [anon_sym_EQ] = ACTIONS(233),
    [anon_sym_STAR_STAR] = ACTIONS(233),
    [anon_sym_exec] = ACTIONS(237),
    [anon_sym_AT] = ACTIONS(233),
    [anon_sym_not] = ACTIONS(233),
    [anon_sym_and] = ACTIONS(233),
    [anon_sym_or] = ACTIONS(233),
    [anon_sym_PLUS] = ACTIONS(233),
    [anon_sym_DASH] = ACTIONS(233),
    [anon_sym_SLASH] = ACTIONS(233),
    [anon_sym_PERCENT] = ACTIONS(233),
    [anon_sym_SLASH_SLASH] = ACTIONS(233),
    [anon_sym_PIPE] = ACTIONS(233),
    [anon_sym_AMP] = ACTIONS(233),
    [anon_sym_CARET] = ACTIONS(233),
    [anon_sym_LT_LT] = ACTIONS(233),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LT] = ACTIONS(233),
    [anon_sym_LT_EQ] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(235),
    [anon_sym_BANG_EQ] = ACTIONS(235),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_GT] = ACTIONS(233),
    [anon_sym_LT_GT] = ACTIONS(235),
    [anon_sym_is] = ACTIONS(233),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_PLUS_EQ] = ACTIONS(235),
    [anon_sym_DASH_EQ] = ACTIONS(235),
    [anon_sym_STAR_EQ] = ACTIONS(235),
    [anon_sym_SLASH_EQ] = ACTIONS(235),
    [anon_sym_AT_EQ] = ACTIONS(235),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(235),
    [anon_sym_PERCENT_EQ] = ACTIONS(235),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(235),
    [anon_sym_GT_GT_EQ] = ACTIONS(235),
    [anon_sym_LT_LT_EQ] = ACTIONS(235),
    [anon_sym_AMP_EQ] = ACTIONS(235),
    [anon_sym_CARET_EQ] = ACTIONS(235),
    [anon_sym_PIPE_EQ] = ACTIONS(235),
    [anon_sym_LBRACK] = ACTIONS(235),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__semicolon] = ACTIONS(235),
    [sym__newline] = ACTIONS(235),
    [sym__string_start] = ACTIONS(73),
  },
  [49] = {
    [sym__simple_statements] = STATE(370),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(241),
    [sym__indent] = ACTIONS(243),
    [sym__string_start] = ACTIONS(73),
  },
  [50] = {
    [sym__simple_statements] = STATE(393),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(245),
    [sym__indent] = ACTIONS(247),
    [sym__string_start] = ACTIONS(73),
  },
  [51] = {
    [sym__simple_statements] = STATE(289),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(249),
    [sym__indent] = ACTIONS(251),
    [sym__string_start] = ACTIONS(73),
  },
  [52] = {
    [sym__simple_statements] = STATE(234),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(253),
    [sym__indent] = ACTIONS(255),
    [sym__string_start] = ACTIONS(73),
  },
  [53] = {
    [sym__simple_statements] = STATE(371),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(257),
    [sym__indent] = ACTIONS(259),
    [sym__string_start] = ACTIONS(73),
  },
  [54] = {
    [sym__simple_statements] = STATE(446),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(261),
    [sym__indent] = ACTIONS(263),
    [sym__string_start] = ACTIONS(73),
  },
  [55] = {
    [sym__simple_statements] = STATE(460),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(265),
    [sym__indent] = ACTIONS(267),
    [sym__string_start] = ACTIONS(73),
  },
  [56] = {
    [sym__simple_statements] = STATE(398),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(269),
    [sym__indent] = ACTIONS(271),
    [sym__string_start] = ACTIONS(73),
  },
  [57] = {
    [sym__simple_statements] = STATE(391),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(273),
    [sym__indent] = ACTIONS(275),
    [sym__string_start] = ACTIONS(73),
  },
  [58] = {
    [sym__simple_statements] = STATE(357),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(277),
    [sym__indent] = ACTIONS(279),
    [sym__string_start] = ACTIONS(73),
  },
  [59] = {
    [sym__simple_statements] = STATE(404),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(281),
    [sym__indent] = ACTIONS(283),
    [sym__string_start] = ACTIONS(73),
  },
  [60] = {
    [sym__simple_statements] = STATE(406),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(285),
    [sym__indent] = ACTIONS(287),
    [sym__string_start] = ACTIONS(73),
  },
  [61] = {
    [sym__simple_statements] = STATE(444),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(289),
    [sym__indent] = ACTIONS(291),
    [sym__string_start] = ACTIONS(73),
  },
  [62] = {
    [sym__simple_statements] = STATE(449),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(293),
    [sym__indent] = ACTIONS(295),
    [sym__string_start] = ACTIONS(73),
  },
  [63] = {
    [sym__simple_statements] = STATE(387),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(297),
    [sym__indent] = ACTIONS(299),
    [sym__string_start] = ACTIONS(73),
  },
  [64] = {
    [sym__simple_statements] = STATE(403),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(301),
    [sym__indent] = ACTIONS(303),
    [sym__string_start] = ACTIONS(73),
  },
  [65] = {
    [sym__simple_statements] = STATE(285),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(305),
    [sym__indent] = ACTIONS(307),
    [sym__string_start] = ACTIONS(73),
  },
  [66] = {
    [sym__simple_statements] = STATE(441),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(309),
    [sym__indent] = ACTIONS(311),
    [sym__string_start] = ACTIONS(73),
  },
  [67] = {
    [sym__simple_statements] = STATE(322),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(313),
    [sym__indent] = ACTIONS(315),
    [sym__string_start] = ACTIONS(73),
  },
  [68] = {
    [sym__simple_statements] = STATE(375),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(317),
    [sym__indent] = ACTIONS(319),
    [sym__string_start] = ACTIONS(73),
  },
  [69] = {
    [sym__simple_statements] = STATE(429),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(321),
    [sym__indent] = ACTIONS(323),
    [sym__string_start] = ACTIONS(73),
  },
  [70] = {
    [sym__simple_statements] = STATE(386),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(325),
    [sym__indent] = ACTIONS(327),
    [sym__string_start] = ACTIONS(73),
  },
  [71] = {
    [sym__simple_statements] = STATE(424),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(329),
    [sym__indent] = ACTIONS(331),
    [sym__string_start] = ACTIONS(73),
  },
  [72] = {
    [sym__simple_statements] = STATE(327),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(333),
    [sym__indent] = ACTIONS(335),
    [sym__string_start] = ACTIONS(73),
  },
  [73] = {
    [sym__simple_statements] = STATE(399),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(337),
    [sym__indent] = ACTIONS(339),
    [sym__string_start] = ACTIONS(73),
  },
  [74] = {
    [sym__simple_statements] = STATE(363),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(341),
    [sym__indent] = ACTIONS(343),
    [sym__string_start] = ACTIONS(73),
  },
  [75] = {
    [sym__simple_statements] = STATE(438),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(345),
    [sym__indent] = ACTIONS(347),
    [sym__string_start] = ACTIONS(73),
  },
  [76] = {
    [sym__simple_statements] = STATE(463),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(349),
    [sym__indent] = ACTIONS(351),
    [sym__string_start] = ACTIONS(73),
  },
  [77] = {
    [sym__simple_statements] = STATE(281),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(353),
    [sym__indent] = ACTIONS(355),
    [sym__string_start] = ACTIONS(73),
  },
  [78] = {
    [sym__simple_statements] = STATE(756),
    [sym_import_statement] = STATE(828),
    [sym_future_import_statement] = STATE(828),
    [sym_import_from_statement] = STATE(828),
    [sym_print_statement] = STATE(828),
    [sym_assert_statement] = STATE(828),
    [sym_expression_statement] = STATE(828),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(828),
    [sym_delete_statement] = STATE(828),
    [sym_raise_statement] = STATE(828),
    [sym_pass_statement] = STATE(828),
    [sym_break_statement] = STATE(828),
    [sym_continue_statement] = STATE(828),
    [sym_global_statement] = STATE(828),
    [sym_nonlocal_statement] = STATE(828),
    [sym_exec_statement] = STATE(828),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(357),
    [sym__indent] = ACTIONS(359),
    [sym__string_start] = ACTIONS(73),
  },
  [79] = {
    [sym__simple_statements] = STATE(366),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(361),
    [sym__indent] = ACTIONS(363),
    [sym__string_start] = ACTIONS(73),
  },
  [80] = {
    [sym__simple_statements] = STATE(435),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(365),
    [sym__indent] = ACTIONS(367),
    [sym__string_start] = ACTIONS(73),
  },
  [81] = {
    [sym__simple_statements] = STATE(755),
    [sym_import_statement] = STATE(828),
    [sym_future_import_statement] = STATE(828),
    [sym_import_from_statement] = STATE(828),
    [sym_print_statement] = STATE(828),
    [sym_assert_statement] = STATE(828),
    [sym_expression_statement] = STATE(828),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(828),
    [sym_delete_statement] = STATE(828),
    [sym_raise_statement] = STATE(828),
    [sym_pass_statement] = STATE(828),
    [sym_break_statement] = STATE(828),
    [sym_continue_statement] = STATE(828),
    [sym_global_statement] = STATE(828),
    [sym_nonlocal_statement] = STATE(828),
    [sym_exec_statement] = STATE(828),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(369),
    [sym__indent] = ACTIONS(371),
    [sym__string_start] = ACTIONS(73),
  },
  [82] = {
    [sym__simple_statements] = STATE(352),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(373),
    [sym__indent] = ACTIONS(375),
    [sym__string_start] = ACTIONS(73),
  },
  [83] = {
    [sym__simple_statements] = STATE(294),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(377),
    [sym__indent] = ACTIONS(379),
    [sym__string_start] = ACTIONS(73),
  },
  [84] = {
    [sym__simple_statements] = STATE(373),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(381),
    [sym__indent] = ACTIONS(383),
    [sym__string_start] = ACTIONS(73),
  },
  [85] = {
    [sym__simple_statements] = STATE(380),
    [sym_import_statement] = STATE(864),
    [sym_future_import_statement] = STATE(864),
    [sym_import_from_statement] = STATE(864),
    [sym_print_statement] = STATE(864),
    [sym_assert_statement] = STATE(864),
    [sym_expression_statement] = STATE(864),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(864),
    [sym_delete_statement] = STATE(864),
    [sym_raise_statement] = STATE(864),
    [sym_pass_statement] = STATE(864),
    [sym_break_statement] = STATE(864),
    [sym_continue_statement] = STATE(864),
    [sym_global_statement] = STATE(864),
    [sym_nonlocal_statement] = STATE(864),
    [sym_exec_statement] = STATE(864),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(385),
    [sym__indent] = ACTIONS(387),
    [sym__string_start] = ACTIONS(73),
  },
  [86] = {
    [sym__simple_statements] = STATE(350),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(389),
    [sym__indent] = ACTIONS(391),
    [sym__string_start] = ACTIONS(73),
  },
  [87] = {
    [sym__simple_statements] = STATE(243),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(393),
    [sym__indent] = ACTIONS(395),
    [sym__string_start] = ACTIONS(73),
  },
  [88] = {
    [sym__simple_statements] = STATE(361),
    [sym_import_statement] = STATE(835),
    [sym_future_import_statement] = STATE(835),
    [sym_import_from_statement] = STATE(835),
    [sym_print_statement] = STATE(835),
    [sym_assert_statement] = STATE(835),
    [sym_expression_statement] = STATE(835),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(835),
    [sym_delete_statement] = STATE(835),
    [sym_raise_statement] = STATE(835),
    [sym_pass_statement] = STATE(835),
    [sym_break_statement] = STATE(835),
    [sym_continue_statement] = STATE(835),
    [sym_global_statement] = STATE(835),
    [sym_nonlocal_statement] = STATE(835),
    [sym_exec_statement] = STATE(835),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(397),
    [sym__indent] = ACTIONS(399),
    [sym__string_start] = ACTIONS(73),
  },
  [89] = {
    [sym_import_statement] = STATE(928),
    [sym_future_import_statement] = STATE(928),
    [sym_import_from_statement] = STATE(928),
    [sym_print_statement] = STATE(928),
    [sym_assert_statement] = STATE(928),
    [sym_expression_statement] = STATE(928),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(928),
    [sym_delete_statement] = STATE(928),
    [sym_raise_statement] = STATE(928),
    [sym_pass_statement] = STATE(928),
    [sym_break_statement] = STATE(928),
    [sym_continue_statement] = STATE(928),
    [sym_global_statement] = STATE(928),
    [sym_nonlocal_statement] = STATE(928),
    [sym_exec_statement] = STATE(928),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(401),
    [sym__string_start] = ACTIONS(73),
  },
  [90] = {
    [sym_import_statement] = STATE(928),
    [sym_future_import_statement] = STATE(928),
    [sym_import_from_statement] = STATE(928),
    [sym_print_statement] = STATE(928),
    [sym_assert_statement] = STATE(928),
    [sym_expression_statement] = STATE(928),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(928),
    [sym_delete_statement] = STATE(928),
    [sym_raise_statement] = STATE(928),
    [sym_pass_statement] = STATE(928),
    [sym_break_statement] = STATE(928),
    [sym_continue_statement] = STATE(928),
    [sym_global_statement] = STATE(928),
    [sym_nonlocal_statement] = STATE(928),
    [sym_exec_statement] = STATE(928),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(403),
    [sym__string_start] = ACTIONS(73),
  },
  [91] = {
    [sym_import_statement] = STATE(928),
    [sym_future_import_statement] = STATE(928),
    [sym_import_from_statement] = STATE(928),
    [sym_print_statement] = STATE(928),
    [sym_assert_statement] = STATE(928),
    [sym_expression_statement] = STATE(928),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(928),
    [sym_delete_statement] = STATE(928),
    [sym_raise_statement] = STATE(928),
    [sym_pass_statement] = STATE(928),
    [sym_break_statement] = STATE(928),
    [sym_continue_statement] = STATE(928),
    [sym_global_statement] = STATE(928),
    [sym_nonlocal_statement] = STATE(928),
    [sym_exec_statement] = STATE(928),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(405),
    [sym__string_start] = ACTIONS(73),
  },
  [92] = {
    [sym_import_statement] = STATE(928),
    [sym_future_import_statement] = STATE(928),
    [sym_import_from_statement] = STATE(928),
    [sym_print_statement] = STATE(928),
    [sym_assert_statement] = STATE(928),
    [sym_expression_statement] = STATE(928),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(928),
    [sym_delete_statement] = STATE(928),
    [sym_raise_statement] = STATE(928),
    [sym_pass_statement] = STATE(928),
    [sym_break_statement] = STATE(928),
    [sym_continue_statement] = STATE(928),
    [sym_global_statement] = STATE(928),
    [sym_nonlocal_statement] = STATE(928),
    [sym_exec_statement] = STATE(928),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(407),
    [sym__string_start] = ACTIONS(73),
  },
  [93] = {
    [sym_import_statement] = STATE(928),
    [sym_future_import_statement] = STATE(928),
    [sym_import_from_statement] = STATE(928),
    [sym_print_statement] = STATE(928),
    [sym_assert_statement] = STATE(928),
    [sym_expression_statement] = STATE(928),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(928),
    [sym_delete_statement] = STATE(928),
    [sym_raise_statement] = STATE(928),
    [sym_pass_statement] = STATE(928),
    [sym_break_statement] = STATE(928),
    [sym_continue_statement] = STATE(928),
    [sym_global_statement] = STATE(928),
    [sym_nonlocal_statement] = STATE(928),
    [sym_exec_statement] = STATE(928),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(409),
    [sym__string_start] = ACTIONS(73),
  },
  [94] = {
    [sym_import_statement] = STATE(928),
    [sym_future_import_statement] = STATE(928),
    [sym_import_from_statement] = STATE(928),
    [sym_print_statement] = STATE(928),
    [sym_assert_statement] = STATE(928),
    [sym_expression_statement] = STATE(928),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(928),
    [sym_delete_statement] = STATE(928),
    [sym_raise_statement] = STATE(928),
    [sym_pass_statement] = STATE(928),
    [sym_break_statement] = STATE(928),
    [sym_continue_statement] = STATE(928),
    [sym_global_statement] = STATE(928),
    [sym_nonlocal_statement] = STATE(928),
    [sym_exec_statement] = STATE(928),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__newline] = ACTIONS(411),
    [sym__string_start] = ACTIONS(73),
  },
  [95] = {
    [sym_import_statement] = STATE(928),
    [sym_future_import_statement] = STATE(928),
    [sym_import_from_statement] = STATE(928),
    [sym_print_statement] = STATE(928),
    [sym_assert_statement] = STATE(928),
    [sym_expression_statement] = STATE(928),
    [sym_named_expression] = STATE(598),
    [sym_return_statement] = STATE(928),
    [sym_delete_statement] = STATE(928),
    [sym_raise_statement] = STATE(928),
    [sym_pass_statement] = STATE(928),
    [sym_break_statement] = STATE(928),
    [sym_continue_statement] = STATE(928),
    [sym_global_statement] = STATE(928),
    [sym_nonlocal_statement] = STATE(928),
    [sym_exec_statement] = STATE(928),
    [sym_expression_list] = STATE(613),
    [sym__expression] = STATE(598),
    [sym__primary_expression] = STATE(126),
    [sym_not_operator] = STATE(598),
    [sym_boolean_operator] = STATE(598),
    [sym_binary_operator] = STATE(126),
    [sym_unary_operator] = STATE(126),
    [sym_comparison_operator] = STATE(598),
    [sym_lambda] = STATE(598),
    [sym_assignment] = STATE(930),
    [sym_augmented_assignment] = STATE(930),
    [sym_yield] = STATE(930),
    [sym_attribute] = STATE(126),
    [sym_subscript] = STATE(126),
    [sym_call] = STATE(126),
    [sym_list] = STATE(126),
    [sym_list_comprehension] = STATE(126),
    [sym_dictionary] = STATE(126),
    [sym_dictionary_comprehension] = STATE(126),
    [sym_set] = STATE(126),
    [sym_set_comprehension] = STATE(126),
    [sym_parenthesized_expression] = STATE(126),
    [sym_tuple] = STATE(126),
    [sym_generator_expression] = STATE(126),
    [sym_conditional_expression] = STATE(598),
    [sym_concatenated_string] = STATE(126),
    [sym_string] = STATE(109),
    [sym_await] = STATE(598),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(65),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(3),
    [sym__string_start] = ACTIONS(73),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(57), 1,
      anon_sym_TILDE,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    ACTIONS(413), 1,
      anon_sym_from,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(417), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(602), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
    ACTIONS(415), 17,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [102] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(57), 1,
      anon_sym_TILDE,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    ACTIONS(419), 1,
      anon_sym_from,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(417), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(602), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
    ACTIONS(421), 17,
      sym__newline,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [204] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(57), 1,
      anon_sym_TILDE,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(417), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(423), 2,
      sym__newline,
      sym__semicolon,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(602), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    ACTIONS(415), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [305] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(57), 1,
      anon_sym_TILDE,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(417), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(425), 2,
      sym__newline,
      sym__semicolon,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(602), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    ACTIONS(421), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [406] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(441), 1,
      anon_sym_lambda,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    STATE(689), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(431), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(435), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(652), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [498] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(441), 1,
      anon_sym_lambda,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    STATE(689), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(455), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(457), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(652), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [590] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(459), 1,
      sym_identifier,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(463), 1,
      anon_sym_RPAREN,
    ACTIONS(465), 1,
      anon_sym_COMMA,
    ACTIONS(467), 1,
      anon_sym_STAR,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    STATE(859), 1,
      sym_parenthesized_list_splat,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(469), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(878), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(649), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [688] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(459), 1,
      sym_identifier,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(463), 1,
      anon_sym_RPAREN,
    ACTIONS(465), 1,
      anon_sym_COMMA,
    ACTIONS(467), 1,
      anon_sym_STAR,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    STATE(859), 1,
      sym_parenthesized_list_splat,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(469), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(878), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(727), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [786] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(441), 1,
      anon_sym_lambda,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    STATE(689), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(475), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(477), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(652), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [878] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(459), 1,
      sym_identifier,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(467), 1,
      anon_sym_STAR,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(479), 1,
      anon_sym_RPAREN,
    ACTIONS(481), 1,
      anon_sym_COMMA,
    STATE(377), 1,
      sym_string,
    STATE(872), 1,
      sym_parenthesized_list_splat,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(469), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(871), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(726), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [976] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(459), 1,
      sym_identifier,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(467), 1,
      anon_sym_STAR,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(483), 1,
      anon_sym_RPAREN,
    ACTIONS(485), 1,
      anon_sym_COMMA,
    STATE(377), 1,
      sym_string,
    STATE(809), 1,
      sym_parenthesized_list_splat,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(469), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(810), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(647), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [1074] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(441), 1,
      anon_sym_lambda,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    STATE(689), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(487), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    ACTIONS(489), 3,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(652), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [1166] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(459), 1,
      sym_identifier,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(467), 1,
      anon_sym_STAR,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(479), 1,
      anon_sym_RPAREN,
    ACTIONS(481), 1,
      anon_sym_COMMA,
    STATE(377), 1,
      sym_string,
    STATE(872), 1,
      sym_parenthesized_list_splat,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(469), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(871), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(645), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [1264] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(135), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(493), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(491), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [1327] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(459), 1,
      sym_identifier,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(467), 1,
      anon_sym_STAR,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(495), 1,
      anon_sym_RPAREN,
    STATE(377), 1,
      sym_string,
    STATE(931), 1,
      sym_parenthesized_list_splat,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(469), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(932), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(754), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [1422] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(459), 1,
      sym_identifier,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(467), 1,
      anon_sym_STAR,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(497), 1,
      anon_sym_RPAREN,
    STATE(377), 1,
      sym_string,
    STATE(931), 1,
      sym_parenthesized_list_splat,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(469), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(932), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(754), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [1517] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(459), 1,
      sym_identifier,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(467), 1,
      anon_sym_STAR,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(499), 1,
      anon_sym_RPAREN,
    STATE(377), 1,
      sym_string,
    STATE(931), 1,
      sym_parenthesized_list_splat,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(469), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(932), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(754), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [1612] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      anon_sym_STAR,
    ACTIONS(505), 1,
      anon_sym_yield,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(501), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(850), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(701), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [1705] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(459), 1,
      sym_identifier,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(467), 1,
      anon_sym_STAR,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(507), 1,
      anon_sym_RPAREN,
    STATE(377), 1,
      sym_string,
    STATE(931), 1,
      sym_parenthesized_list_splat,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(469), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(932), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(754), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [1800] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(459), 1,
      sym_identifier,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(467), 1,
      anon_sym_STAR,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(509), 1,
      anon_sym_RPAREN,
    STATE(377), 1,
      sym_string,
    STATE(931), 1,
      sym_parenthesized_list_splat,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(469), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(932), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(754), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [1895] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      anon_sym_STAR,
    ACTIONS(505), 1,
      anon_sym_yield,
    ACTIONS(511), 1,
      anon_sym_RPAREN,
    STATE(377), 1,
      sym_string,
    STATE(966), 1,
      sym__collection_elements,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(780), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(700), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [1990] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(459), 1,
      sym_identifier,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(467), 1,
      anon_sym_STAR,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(513), 1,
      anon_sym_RPAREN,
    STATE(377), 1,
      sym_string,
    STATE(931), 1,
      sym_parenthesized_list_splat,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(469), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(932), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(754), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [2085] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(459), 1,
      sym_identifier,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(467), 1,
      anon_sym_STAR,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(515), 1,
      anon_sym_RPAREN,
    STATE(377), 1,
      sym_string,
    STATE(931), 1,
      sym_parenthesized_list_splat,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(469), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(932), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(754), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [2180] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      anon_sym_STAR,
    ACTIONS(505), 1,
      anon_sym_yield,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(517), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(850), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(701), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [2273] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      anon_sym_STAR,
    ACTIONS(505), 1,
      anon_sym_yield,
    ACTIONS(511), 1,
      anon_sym_RPAREN,
    STATE(377), 1,
      sym_string,
    STATE(832), 1,
      sym_yield,
    STATE(966), 1,
      sym__collection_elements,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    STATE(780), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(646), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [2370] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      anon_sym_STAR,
    ACTIONS(505), 1,
      anon_sym_yield,
    ACTIONS(519), 1,
      anon_sym_RBRACK,
    STATE(377), 1,
      sym_string,
    STATE(985), 1,
      sym__collection_elements,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(780), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(644), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [2465] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      anon_sym_STAR,
    ACTIONS(505), 1,
      anon_sym_yield,
    ACTIONS(521), 1,
      anon_sym_RBRACK,
    STATE(377), 1,
      sym_string,
    STATE(947), 1,
      sym__collection_elements,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(780), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(642), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [2560] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(467), 1,
      anon_sym_STAR,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(523), 1,
      anon_sym_COMMA,
    ACTIONS(525), 1,
      anon_sym_RBRACE,
    STATE(377), 1,
      sym_string,
    STATE(696), 1,
      sym_pair,
    STATE(889), 1,
      sym_dictionary_splat,
    STATE(891), 1,
      sym_list_splat,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(640), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [2659] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(531), 1,
      sym__string_start,
    STATE(124), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(529), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(527), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [2722] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(459), 1,
      sym_identifier,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(467), 1,
      anon_sym_STAR,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(534), 1,
      anon_sym_RPAREN,
    STATE(377), 1,
      sym_string,
    STATE(931), 1,
      sym_parenthesized_list_splat,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(469), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(932), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(754), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [2817] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(536), 1,
      anon_sym_DOT,
    ACTIONS(540), 1,
      anon_sym_LPAREN,
    ACTIONS(548), 1,
      anon_sym_EQ,
    ACTIONS(550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(552), 1,
      anon_sym_not,
    ACTIONS(556), 1,
      anon_sym_PIPE,
    ACTIONS(558), 1,
      anon_sym_AMP,
    ACTIONS(560), 1,
      anon_sym_CARET,
    ACTIONS(564), 1,
      anon_sym_is,
    ACTIONS(566), 1,
      anon_sym_LBRACK,
    STATE(543), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(544), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(554), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(562), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(167), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(542), 5,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(546), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(538), 21,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [2908] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(459), 1,
      sym_identifier,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(467), 1,
      anon_sym_STAR,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(568), 1,
      anon_sym_RPAREN,
    STATE(377), 1,
      sym_string,
    STATE(931), 1,
      sym_parenthesized_list_splat,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(469), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(932), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(754), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [3003] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      anon_sym_STAR,
    ACTIONS(505), 1,
      anon_sym_yield,
    ACTIONS(570), 1,
      anon_sym_RPAREN,
    STATE(377), 1,
      sym_string,
    STATE(874), 1,
      sym_yield,
    STATE(957), 1,
      sym__collection_elements,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    STATE(780), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(648), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [3100] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(467), 1,
      anon_sym_STAR,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(572), 1,
      anon_sym_COMMA,
    ACTIONS(574), 1,
      anon_sym_RBRACE,
    STATE(377), 1,
      sym_string,
    STATE(668), 1,
      sym_pair,
    STATE(837), 1,
      sym_list_splat,
    STATE(838), 1,
      sym_dictionary_splat,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(641), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [3199] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      anon_sym_STAR,
    ACTIONS(505), 1,
      anon_sym_yield,
    ACTIONS(576), 1,
      anon_sym_RPAREN,
    STATE(377), 1,
      sym_string,
    STATE(855), 1,
      sym_yield,
    STATE(962), 1,
      sym__collection_elements,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    STATE(780), 2,
      sym_list_splat,
      sym_parenthesized_list_splat,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(650), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [3296] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      anon_sym_STAR,
    ACTIONS(505), 1,
      anon_sym_yield,
    ACTIONS(578), 1,
      anon_sym_RBRACK,
    STATE(377), 1,
      sym_string,
    STATE(951), 1,
      sym__collection_elements,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(780), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(643), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [3391] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(467), 1,
      anon_sym_STAR,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(580), 1,
      anon_sym_COMMA,
    ACTIONS(582), 1,
      anon_sym_RBRACE,
    STATE(377), 1,
      sym_string,
    STATE(684), 1,
      sym_pair,
    STATE(852), 1,
      sym_dictionary_splat,
    STATE(853), 1,
      sym_list_splat,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(639), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [3490] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      anon_sym_STAR,
    ACTIONS(505), 1,
      anon_sym_yield,
    ACTIONS(511), 1,
      anon_sym_RPAREN,
    STATE(377), 1,
      sym_string,
    STATE(832), 1,
      sym_yield,
    STATE(854), 1,
      sym_list_splat,
    STATE(861), 1,
      sym_parenthesized_list_splat,
    STATE(966), 1,
      sym__collection_elements,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(646), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [3589] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(459), 1,
      sym_identifier,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(467), 1,
      anon_sym_STAR,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(584), 1,
      anon_sym_RPAREN,
    STATE(377), 1,
      sym_string,
    STATE(931), 1,
      sym_parenthesized_list_splat,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(469), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(932), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(754), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [3684] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(124), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(588), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(586), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [3747] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(459), 1,
      sym_identifier,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(467), 1,
      anon_sym_STAR,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(590), 1,
      anon_sym_RPAREN,
    STATE(377), 1,
      sym_string,
    STATE(931), 1,
      sym_parenthesized_list_splat,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(469), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(932), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(754), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [3842] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(459), 1,
      sym_identifier,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(467), 1,
      anon_sym_STAR,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(592), 1,
      anon_sym_RPAREN,
    STATE(377), 1,
      sym_string,
    STATE(931), 1,
      sym_parenthesized_list_splat,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(469), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(932), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(754), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [3937] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(536), 1,
      anon_sym_DOT,
    ACTIONS(540), 1,
      anon_sym_LPAREN,
    ACTIONS(550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(566), 1,
      anon_sym_LBRACK,
    ACTIONS(544), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(554), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(167), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(542), 5,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(596), 6,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(594), 29,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [4011] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(536), 1,
      anon_sym_DOT,
    ACTIONS(540), 1,
      anon_sym_LPAREN,
    ACTIONS(550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(566), 1,
      anon_sym_LBRACK,
    STATE(167), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(600), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(598), 29,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [4079] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(459), 1,
      sym_identifier,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(467), 1,
      anon_sym_STAR,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    STATE(931), 1,
      sym_parenthesized_list_splat,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(469), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(932), 3,
      sym_list_splat,
      sym_dictionary_splat,
      sym_keyword_argument,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(754), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [4171] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(536), 1,
      anon_sym_DOT,
    ACTIONS(540), 1,
      anon_sym_LPAREN,
    ACTIONS(550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(566), 1,
      anon_sym_LBRACK,
    STATE(167), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(596), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(594), 29,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [4239] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(61), 1,
      anon_sym_yield,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    STATE(610), 1,
      sym_expression_list,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(938), 4,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
      sym_yield,
    STATE(592), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [4329] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(536), 1,
      anon_sym_DOT,
    ACTIONS(540), 1,
      anon_sym_LPAREN,
    ACTIONS(550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(566), 1,
      anon_sym_LBRACK,
    ACTIONS(554), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(167), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(542), 5,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(596), 8,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(594), 29,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [4401] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(536), 1,
      anon_sym_DOT,
    ACTIONS(540), 1,
      anon_sym_LPAREN,
    ACTIONS(550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(556), 1,
      anon_sym_PIPE,
    ACTIONS(558), 1,
      anon_sym_AMP,
    ACTIONS(560), 1,
      anon_sym_CARET,
    ACTIONS(566), 1,
      anon_sym_LBRACK,
    ACTIONS(544), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(554), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(167), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(604), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(542), 5,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(602), 29,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [4481] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(536), 1,
      anon_sym_DOT,
    ACTIONS(540), 1,
      anon_sym_LPAREN,
    ACTIONS(550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(566), 1,
      anon_sym_LBRACK,
    STATE(167), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(596), 15,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(594), 29,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [4549] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(536), 1,
      anon_sym_DOT,
    ACTIONS(540), 1,
      anon_sym_LPAREN,
    ACTIONS(550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(566), 1,
      anon_sym_LBRACK,
    STATE(167), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(542), 5,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(596), 10,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(594), 29,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [4619] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(536), 1,
      anon_sym_DOT,
    ACTIONS(540), 1,
      anon_sym_LPAREN,
    ACTIONS(550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(556), 1,
      anon_sym_PIPE,
    ACTIONS(558), 1,
      anon_sym_AMP,
    ACTIONS(560), 1,
      anon_sym_CARET,
    ACTIONS(566), 1,
      anon_sym_LBRACK,
    ACTIONS(544), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(554), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(167), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(608), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(542), 5,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(606), 29,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [4699] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(536), 1,
      anon_sym_DOT,
    ACTIONS(540), 1,
      anon_sym_LPAREN,
    ACTIONS(550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(558), 1,
      anon_sym_AMP,
    ACTIONS(560), 1,
      anon_sym_CARET,
    ACTIONS(566), 1,
      anon_sym_LBRACK,
    ACTIONS(544), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(554), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(167), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(596), 4,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(542), 5,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(594), 29,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [4777] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(536), 1,
      anon_sym_DOT,
    ACTIONS(540), 1,
      anon_sym_LPAREN,
    ACTIONS(550), 1,
      anon_sym_STAR_STAR,
    ACTIONS(560), 1,
      anon_sym_CARET,
    ACTIONS(566), 1,
      anon_sym_LBRACK,
    ACTIONS(544), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(554), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(167), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(542), 5,
      anon_sym_STAR,
      anon_sym_AT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(596), 5,
      anon_sym_EQ,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(594), 29,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [4853] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(61), 1,
      anon_sym_yield,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    STATE(610), 1,
      sym_expression_list,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(916), 4,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
      sym_yield,
    STATE(592), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [4943] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(61), 1,
      anon_sym_yield,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    STATE(610), 1,
      sym_expression_list,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(909), 4,
      sym_assignment,
      sym_augmented_assignment,
      sym__right_hand_side,
      sym_yield,
    STATE(592), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [5033] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(610), 1,
      sym__string_start,
    STATE(897), 1,
      sym_string,
    ACTIONS(233), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(235), 31,
      sym__newline,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [5094] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(612), 1,
      anon_sym_from,
    STATE(377), 1,
      sym_string,
    STATE(816), 1,
      sym_expression_list,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(614), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(663), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [5183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(618), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(616), 33,
      sym__newline,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [5240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(620), 33,
      sym__newline,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [5297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(624), 1,
      anon_sym_COLON_EQ,
    ACTIONS(493), 17,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(491), 31,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [5356] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(461), 1,
      anon_sym_LPAREN,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      anon_sym_STAR,
    ACTIONS(505), 1,
      anon_sym_yield,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    STATE(850), 3,
      sym_list_splat,
      sym_parenthesized_list_splat,
      sym_yield,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(701), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [5445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(626), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [5501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(632), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(630), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [5557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(636), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(634), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [5613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(640), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(638), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [5669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(644), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(642), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [5725] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    ACTIONS(646), 1,
      anon_sym_from,
    STATE(109), 1,
      sym_string,
    STATE(883), 1,
      sym_expression_list,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(648), 2,
      sym__newline,
      sym__semicolon,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(592), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [5813] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(654), 1,
      anon_sym_else,
    ACTIONS(656), 1,
      anon_sym_except,
    ACTIONS(658), 1,
      anon_sym_finally,
    STATE(368), 1,
      sym_else_clause,
    STATE(417), 1,
      sym_finally_clause,
    STATE(246), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(650), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(652), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [5881] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(654), 1,
      anon_sym_else,
    ACTIONS(656), 1,
      anon_sym_except,
    ACTIONS(658), 1,
      anon_sym_finally,
    STATE(353), 1,
      sym_else_clause,
    STATE(457), 1,
      sym_finally_clause,
    STATE(246), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(660), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(662), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [5949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(666), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(664), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [6005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(670), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(668), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [6061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(674), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(672), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [6117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(678), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(676), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [6173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(682), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [6229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(686), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(684), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [6285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(690), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(688), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [6341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(694), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(692), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [6397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(698), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(696), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [6453] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(700), 1,
      anon_sym_else,
    ACTIONS(702), 1,
      anon_sym_except,
    ACTIONS(704), 1,
      anon_sym_finally,
    STATE(364), 1,
      sym_else_clause,
    STATE(382), 1,
      sym_finally_clause,
    STATE(223), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(660), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(662), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [6521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(708), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(706), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [6577] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(710), 1,
      anon_sym_RBRACE,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    STATE(929), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(783), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [6665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(714), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(712), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [6721] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    ACTIONS(716), 1,
      anon_sym_from,
    STATE(109), 1,
      sym_string,
    STATE(907), 1,
      sym_expression_list,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(614), 2,
      sym__newline,
      sym__semicolon,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(592), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [6809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(720), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(718), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [6865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(724), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(722), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [6921] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(726), 1,
      anon_sym_RBRACE,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    STATE(929), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(783), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [7009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(728), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [7065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(734), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(732), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [7121] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(700), 1,
      anon_sym_else,
    ACTIONS(702), 1,
      anon_sym_except,
    ACTIONS(704), 1,
      anon_sym_finally,
    STATE(358), 1,
      sym_else_clause,
    STATE(396), 1,
      sym_finally_clause,
    STATE(223), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(650), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(652), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [7189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(738), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(736), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [7245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(742), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(740), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [7301] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(744), 1,
      anon_sym_RBRACE,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    STATE(929), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(783), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [7389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(748), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(746), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [7445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(750), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [7501] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(421), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(692), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [7585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(233), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(235), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [7641] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(415), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(692), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [7725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(756), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(754), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [7781] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(758), 1,
      anon_sym_RBRACE,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    STATE(929), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(783), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [7869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(762), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(760), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [7925] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(764), 1,
      anon_sym_RBRACE,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    STATE(929), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(783), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [8013] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(766), 1,
      anon_sym_RBRACE,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    STATE(929), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(783), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [8101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(768), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [8157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(774), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(772), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [8213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(778), 16,
      anon_sym_STAR,
      anon_sym_GT_GT,
      anon_sym_EQ,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(776), 32,
      sym__newline,
      anon_sym_DOT,
      anon_sym_from,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LBRACK,
      sym__semicolon,
  [8269] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      anon_sym_STAR,
    ACTIONS(780), 1,
      anon_sym_RBRACE,
    STATE(377), 1,
      sym_string,
    STATE(922), 1,
      sym_list_splat,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(745), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [8356] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      anon_sym_STAR,
    ACTIONS(782), 1,
      anon_sym_RBRACE,
    STATE(377), 1,
      sym_string,
    STATE(922), 1,
      sym_list_splat,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(745), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [8443] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(784), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(661), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [8526] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(788), 1,
      anon_sym_COLON,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(786), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(719), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [8611] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(790), 1,
      anon_sym_COLON,
    ACTIONS(792), 1,
      anon_sym_RBRACK,
    STATE(377), 1,
      sym_string,
    STATE(906), 1,
      sym_slice,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(703), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [8698] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(796), 1,
      anon_sym_COLON,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(794), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(710), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [8783] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(790), 1,
      anon_sym_COLON,
    ACTIONS(798), 1,
      anon_sym_RBRACK,
    STATE(377), 1,
      sym_string,
    STATE(906), 1,
      sym_slice,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(703), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [8870] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    STATE(920), 1,
      sym_expression_list,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(800), 2,
      sym__newline,
      sym__semicolon,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(592), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [8955] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      anon_sym_STAR,
    ACTIONS(802), 1,
      anon_sym_RBRACE,
    STATE(377), 1,
      sym_string,
    STATE(922), 1,
      sym_list_splat,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(745), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [9042] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(790), 1,
      anon_sym_COLON,
    ACTIONS(804), 1,
      anon_sym_RBRACK,
    STATE(377), 1,
      sym_string,
    STATE(906), 1,
      sym_slice,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(703), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [9129] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(790), 1,
      anon_sym_COLON,
    ACTIONS(806), 1,
      anon_sym_RBRACK,
    STATE(377), 1,
      sym_string,
    STATE(906), 1,
      sym_slice,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(703), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [9216] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(808), 1,
      anon_sym_COMMA,
    ACTIONS(810), 1,
      anon_sym_COLON,
    STATE(377), 1,
      sym_string,
    STATE(817), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(661), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [9303] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(810), 1,
      anon_sym_RPAREN,
    ACTIONS(812), 1,
      anon_sym_COMMA,
    STATE(377), 1,
      sym_string,
    STATE(856), 1,
      aux_sym__parameters_repeat1,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(661), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [9390] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(790), 1,
      anon_sym_COLON,
    ACTIONS(814), 1,
      anon_sym_RBRACK,
    STATE(377), 1,
      sym_string,
    STATE(906), 1,
      sym_slice,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(703), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [9477] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      anon_sym_STAR,
    ACTIONS(816), 1,
      anon_sym_RBRACE,
    STATE(377), 1,
      sym_string,
    STATE(922), 1,
      sym_list_splat,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(745), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [9564] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(790), 1,
      anon_sym_COLON,
    ACTIONS(818), 1,
      anon_sym_RBRACK,
    STATE(377), 1,
      sym_string,
    STATE(906), 1,
      sym_slice,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(703), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [9651] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      anon_sym_STAR,
    ACTIONS(820), 1,
      anon_sym_RBRACE,
    STATE(377), 1,
      sym_string,
    STATE(922), 1,
      sym_list_splat,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(745), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [9738] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    STATE(929), 2,
      sym_dictionary_splat,
      sym_pair,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(783), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [9823] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      anon_sym_STAR,
    ACTIONS(822), 1,
      anon_sym_RBRACE,
    STATE(377), 1,
      sym_string,
    STATE(922), 1,
      sym_list_splat,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(745), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [9910] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(824), 2,
      sym__newline,
      sym__semicolon,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(702), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [9992] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(826), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(748), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [10074] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(832), 1,
      anon_sym_except,
    STATE(223), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(830), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(828), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [10132] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(700), 1,
      anon_sym_else,
    ACTIONS(839), 1,
      anon_sym_elif,
    STATE(232), 1,
      aux_sym_if_statement_repeat1,
    STATE(354), 1,
      sym_elif_clause,
    STATE(389), 1,
      sym_else_clause,
    ACTIONS(837), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(835), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [10196] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(441), 1,
      anon_sym_lambda,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    STATE(658), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(652), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [10278] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(441), 1,
      anon_sym_lambda,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    STATE(689), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(652), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [10360] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(790), 1,
      anon_sym_COLON,
    STATE(377), 1,
      sym_string,
    STATE(875), 1,
      sym_slice,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(671), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [10444] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(654), 1,
      anon_sym_else,
    ACTIONS(845), 1,
      anon_sym_elif,
    STATE(274), 1,
      aux_sym_if_statement_repeat1,
    STATE(362), 1,
      sym_elif_clause,
    STATE(453), 1,
      sym_else_clause,
    ACTIONS(841), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(843), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [10508] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(700), 1,
      anon_sym_else,
    ACTIONS(839), 1,
      anon_sym_elif,
    STATE(270), 1,
      aux_sym_if_statement_repeat1,
    STATE(354), 1,
      sym_elif_clause,
    STATE(390), 1,
      sym_else_clause,
    ACTIONS(849), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(847), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [10572] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(786), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(744), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [10654] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(503), 1,
      anon_sym_STAR,
    STATE(377), 1,
      sym_string,
    STATE(922), 1,
      sym_list_splat,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(745), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [10738] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(700), 1,
      anon_sym_else,
    ACTIONS(839), 1,
      anon_sym_elif,
    STATE(270), 1,
      aux_sym_if_statement_repeat1,
    STATE(354), 1,
      sym_elif_clause,
    STATE(410), 1,
      sym_else_clause,
    ACTIONS(841), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(843), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [10802] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(851), 2,
      sym__newline,
      sym__semicolon,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(702), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [10884] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(700), 1,
      anon_sym_else,
    ACTIONS(839), 1,
      anon_sym_elif,
    STATE(229), 1,
      aux_sym_if_statement_repeat1,
    STATE(354), 1,
      sym_elif_clause,
    STATE(400), 1,
      sym_else_clause,
    ACTIONS(855), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(853), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [10948] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(441), 1,
      anon_sym_lambda,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    STATE(695), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(656), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [11030] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(857), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(743), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [11112] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(859), 2,
      sym__newline,
      sym__semicolon,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(702), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [11194] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(861), 2,
      sym__newline,
      sym__semicolon,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(702), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [11276] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(441), 1,
      anon_sym_lambda,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    STATE(659), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(652), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [11358] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(790), 1,
      anon_sym_COLON,
    STATE(377), 1,
      sym_string,
    STATE(823), 1,
      sym_slice,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(682), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [11442] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(654), 1,
      anon_sym_else,
    ACTIONS(845), 1,
      anon_sym_elif,
    STATE(274), 1,
      aux_sym_if_statement_repeat1,
    STATE(362), 1,
      sym_elif_clause,
    STATE(432), 1,
      sym_else_clause,
    ACTIONS(849), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(847), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [11506] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(654), 1,
      anon_sym_else,
    ACTIONS(845), 1,
      anon_sym_elif,
    STATE(228), 1,
      aux_sym_if_statement_repeat1,
    STATE(362), 1,
      sym_elif_clause,
    STATE(384), 1,
      sym_else_clause,
    ACTIONS(837), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(835), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [11570] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(654), 1,
      anon_sym_else,
    ACTIONS(845), 1,
      anon_sym_elif,
    STATE(241), 1,
      aux_sym_if_statement_repeat1,
    STATE(362), 1,
      sym_elif_clause,
    STATE(401), 1,
      sym_else_clause,
    ACTIONS(855), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(853), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [11634] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(441), 1,
      anon_sym_lambda,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    STATE(691), 2,
      sym__expression_within_for_in_clause,
      sym_lambda_within_for_in_clause,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(653), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [11716] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(790), 1,
      anon_sym_COLON,
    STATE(377), 1,
      sym_string,
    STATE(867), 1,
      sym_slice,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(685), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [11800] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(863), 1,
      anon_sym_except,
    STATE(246), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
    ACTIONS(830), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(828), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [11858] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    ACTIONS(790), 1,
      anon_sym_COLON,
    STATE(377), 1,
      sym_string,
    STATE(906), 1,
      sym_slice,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(703), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [11942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(868), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [11995] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    STATE(1005), 1,
      sym_type,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(687), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [12076] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    STATE(996), 1,
      sym_expression_list,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(663), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [12157] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(870), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(880), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(890), 1,
      anon_sym_await,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    STATE(833), 1,
      sym_with_item,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(884), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(888), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(723), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(498), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [12238] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    STATE(988), 1,
      sym_type,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(687), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [12319] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(870), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(880), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(890), 1,
      anon_sym_await,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    STATE(840), 1,
      sym_with_item,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(884), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(888), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(723), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(498), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [12400] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    STATE(1004), 1,
      sym_type,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(687), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [12481] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(870), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(880), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(890), 1,
      anon_sym_await,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    STATE(888), 1,
      sym_with_item,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(884), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(888), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(723), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(498), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [12562] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    STATE(1016), 1,
      sym_expression_list,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(663), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [12643] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(870), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(880), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(890), 1,
      anon_sym_await,
    ACTIONS(892), 1,
      sym__string_start,
    ACTIONS(894), 1,
      anon_sym_COLON,
    STATE(497), 1,
      sym_string,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(884), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(888), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(717), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(498), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [12724] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    STATE(1000), 1,
      sym_expression_list,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(663), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [12805] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    STATE(1002), 1,
      sym_type,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(687), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [12886] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    STATE(918), 1,
      sym_expression_list,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(592), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [12967] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(870), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(880), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(890), 1,
      anon_sym_await,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    STATE(901), 1,
      sym_with_item,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(884), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(888), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(723), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(498), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [13048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(896), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(898), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [13101] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    STATE(1022), 1,
      sym_type,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(687), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [13182] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(870), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(880), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(890), 1,
      anon_sym_await,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    STATE(913), 1,
      sym_with_item,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(884), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(888), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(723), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(498), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [13263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(896), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(898), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [13316] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    STATE(880), 1,
      sym_type,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(699), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [13397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(900), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(902), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [13450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(868), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [13503] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(870), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(880), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(890), 1,
      anon_sym_await,
    ACTIONS(892), 1,
      sym__string_start,
    ACTIONS(904), 1,
      anon_sym_COLON,
    STATE(497), 1,
      sym_string,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(884), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(888), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(707), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(498), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [13584] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(910), 1,
      anon_sym_elif,
    STATE(270), 1,
      aux_sym_if_statement_repeat1,
    STATE(354), 1,
      sym_elif_clause,
    ACTIONS(908), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(906), 31,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [13643] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    STATE(1014), 1,
      sym_expression_list,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(663), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [13724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(900), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(902), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [13777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(915), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(913), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [13830] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(917), 1,
      anon_sym_elif,
    STATE(274), 1,
      aux_sym_if_statement_repeat1,
    STATE(362), 1,
      sym_elif_clause,
    ACTIONS(908), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(906), 31,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [13889] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    STATE(877), 1,
      sym_type,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(687), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [13970] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(920), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [14023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(915), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(913), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [14076] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    STATE(765), 1,
      sym_type,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(687), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [14157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(920), 34,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [14210] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(630), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [14288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(926), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(924), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [14340] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(738), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [14418] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(601), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [14496] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(795), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [14574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(928), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(930), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [14626] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(602), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [14704] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(597), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [14782] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(621), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [14860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(932), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(934), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [14912] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(714), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [14990] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(771), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [15068] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(666), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [15146] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(713), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [15224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(932), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(934), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [15276] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(697), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [15354] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(799), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [15432] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(753), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [15510] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(618), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [15588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(936), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [15640] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(692), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [15718] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(763), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [15796] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(594), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [15874] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(680), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [15952] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(617), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [16030] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(764), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [16108] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(793), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [16186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(940), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(942), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [16238] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(627), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [16316] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(708), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [16394] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(798), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [16472] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(622), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [16550] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(636), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [16628] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(725), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [16706] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(661), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [16784] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(767), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [16862] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(870), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(880), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(890), 1,
      anon_sym_await,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(884), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(888), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(698), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(498), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [16940] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(805), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [17018] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(724), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [17096] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(702), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [17174] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(752), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [17252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(946), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(944), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [17304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(928), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(930), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [17356] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(801), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [17434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(940), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(942), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [17486] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(870), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(880), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(890), 1,
      anon_sym_await,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(884), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(888), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(722), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(498), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [17564] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(938), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(936), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [17616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(926), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(924), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [17668] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(595), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [17746] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(870), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(880), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(890), 1,
      anon_sym_await,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(884), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(888), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(716), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(498), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [17824] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(870), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(880), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(890), 1,
      anon_sym_await,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(884), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(888), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(712), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(498), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [17902] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(599), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [17980] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(870), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(880), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(890), 1,
      anon_sym_await,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(884), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(888), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(711), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(498), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [18058] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(673), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [18136] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(777), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [18214] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(870), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(880), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(890), 1,
      anon_sym_await,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(884), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(888), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(709), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(498), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [18292] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(870), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(880), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(890), 1,
      anon_sym_await,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(884), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(888), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(704), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(498), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [18370] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(678), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [18448] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(683), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [18526] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(742), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [18604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(946), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(944), 33,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_except,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [18656] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(870), 1,
      sym_identifier,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(876), 1,
      anon_sym_not,
    ACTIONS(880), 1,
      anon_sym_lambda,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(890), 1,
      anon_sym_await,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(884), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(888), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(706), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(498), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [18734] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(778), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [18812] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(596), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [18890] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(721), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [18968] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(593), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [19046] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      sym_identifier,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(55), 1,
      anon_sym_not,
    ACTIONS(59), 1,
      anon_sym_lambda,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(71), 1,
      anon_sym_await,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(65), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(69), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(600), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(126), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [19124] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(634), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [19202] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(730), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [19280] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(427), 1,
      sym_identifier,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(437), 1,
      anon_sym_not,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(451), 1,
      anon_sym_await,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(473), 1,
      anon_sym_lambda,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(445), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(449), 4,
      sym_integer,
      sym_true,
      sym_false,
      sym_none,
    STATE(751), 8,
      sym_named_expression,
      sym__expression,
      sym_not_operator,
      sym_boolean_operator,
      sym_comparison_operator,
      sym_lambda,
      sym_conditional_expression,
      sym_await,
    STATE(378), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [19358] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(654), 1,
      anon_sym_else,
    STATE(443), 1,
      sym_else_clause,
    ACTIONS(948), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(950), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [19413] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(952), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(954), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [19464] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(654), 1,
      anon_sym_else,
    STATE(450), 1,
      sym_else_clause,
    ACTIONS(956), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(958), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [19519] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(658), 1,
      anon_sym_finally,
    STATE(447), 1,
      sym_finally_clause,
    ACTIONS(960), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(962), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [19574] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(966), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(964), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [19625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(952), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(954), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [19676] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(654), 1,
      anon_sym_else,
    STATE(440), 1,
      sym_else_clause,
    ACTIONS(968), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(970), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [19731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(974), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [19782] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(704), 1,
      anon_sym_finally,
    STATE(383), 1,
      sym_finally_clause,
    ACTIONS(978), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(976), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [19837] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(654), 1,
      anon_sym_else,
    STATE(437), 1,
      sym_else_clause,
    ACTIONS(980), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(982), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [19892] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(700), 1,
      anon_sym_else,
    STATE(458), 1,
      sym_else_clause,
    ACTIONS(980), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(982), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [19947] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(654), 1,
      anon_sym_else,
    STATE(411), 1,
      sym_else_clause,
    ACTIONS(984), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(986), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [20002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(966), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(964), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [20053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(972), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(974), 32,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_elif,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [20104] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(704), 1,
      anon_sym_finally,
    STATE(434), 1,
      sym_finally_clause,
    ACTIONS(960), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(962), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [20159] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(700), 1,
      anon_sym_else,
    STATE(385), 1,
      sym_else_clause,
    ACTIONS(990), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(988), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [20214] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(700), 1,
      anon_sym_else,
    STATE(430), 1,
      sym_else_clause,
    ACTIONS(956), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(958), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [20269] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(700), 1,
      anon_sym_else,
    STATE(445), 1,
      sym_else_clause,
    ACTIONS(968), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(970), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [20324] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(658), 1,
      anon_sym_finally,
    STATE(459), 1,
      sym_finally_clause,
    ACTIONS(978), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(976), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [20379] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(654), 1,
      anon_sym_else,
    STATE(461), 1,
      sym_else_clause,
    ACTIONS(990), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(988), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [20434] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(700), 1,
      anon_sym_else,
    STATE(442), 1,
      sym_else_clause,
    ACTIONS(948), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(950), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [20489] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(700), 1,
      anon_sym_else,
    STATE(397), 1,
      sym_else_clause,
    ACTIONS(984), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(986), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [20544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(992), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(994), 31,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [20594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(998), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(996), 31,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [20644] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1000), 1,
      sym__string_start,
    STATE(374), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(529), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(527), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [20698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(998), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(996), 31,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [20748] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(374), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(588), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(586), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [20802] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(376), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(493), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(491), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [20856] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(548), 1,
      anon_sym_EQ,
    ACTIONS(1003), 1,
      anon_sym_DOT,
    ACTIONS(1005), 1,
      anon_sym_LPAREN,
    ACTIONS(1013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1017), 1,
      anon_sym_not,
    ACTIONS(1021), 1,
      anon_sym_PIPE,
    ACTIONS(1023), 1,
      anon_sym_AMP,
    ACTIONS(1025), 1,
      anon_sym_CARET,
    ACTIONS(1029), 1,
      anon_sym_is,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    STATE(590), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1007), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1009), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1019), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1027), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(477), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1015), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(1011), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(538), 12,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [20940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(992), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(994), 31,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_finally,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [20990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1033), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [21039] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_DOT,
    ACTIONS(1005), 1,
      anon_sym_LPAREN,
    ACTIONS(1013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1007), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1019), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(477), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(596), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1015), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(594), 25,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [21104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(960), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(962), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [21153] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1039), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1037), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [21202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1041), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1043), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [21251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1047), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1045), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [21300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1051), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1049), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [21349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1055), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1053), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [21398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1057), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [21447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1041), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1043), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [21496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1063), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1061), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [21545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1067), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1065), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [21594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1071), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1069), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [21643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1075), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1073), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [21692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1079), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1077), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [21741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(662), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [21790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(978), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(976), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [21839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1083), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1081), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [21888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1087), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [21937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1091), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1089), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [21986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1095), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1093), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [22035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1095), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1093), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [22084] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_DOT,
    ACTIONS(1005), 1,
      anon_sym_LPAREN,
    ACTIONS(1013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1021), 1,
      anon_sym_PIPE,
    ACTIONS(1023), 1,
      anon_sym_AMP,
    ACTIONS(1025), 1,
      anon_sym_CARET,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1007), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1009), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1019), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(477), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(608), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1015), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(606), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [22157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1099), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1097), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [22206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1091), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1089), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [22255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(650), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(652), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [22304] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1085), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1087), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [22353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1101), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1103), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [22402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(650), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(652), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [22451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1107), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1105), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [22500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1109), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [22549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1083), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1081), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [22598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1113), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [22647] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_DOT,
    ACTIONS(1005), 1,
      anon_sym_LPAREN,
    ACTIONS(1013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1007), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1009), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1019), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(477), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(596), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1015), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(594), 23,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [22714] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_DOT,
    ACTIONS(1005), 1,
      anon_sym_LPAREN,
    ACTIONS(1013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1025), 1,
      anon_sym_CARET,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1007), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1009), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1019), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(477), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(596), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1015), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(594), 22,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [22783] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_DOT,
    ACTIONS(1005), 1,
      anon_sym_LPAREN,
    ACTIONS(1013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1023), 1,
      anon_sym_AMP,
    ACTIONS(1025), 1,
      anon_sym_CARET,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1007), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1009), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1019), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(477), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(596), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1015), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(594), 21,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [22854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1117), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [22903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(978), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(976), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [22952] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_DOT,
    ACTIONS(1005), 1,
      anon_sym_LPAREN,
    ACTIONS(1013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1007), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(477), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(596), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1015), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(594), 27,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [23015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(660), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(662), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [23064] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_DOT,
    ACTIONS(1005), 1,
      anon_sym_LPAREN,
    ACTIONS(1013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    STATE(477), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(596), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(594), 30,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [23123] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_DOT,
    ACTIONS(1005), 1,
      anon_sym_LPAREN,
    ACTIONS(1013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1021), 1,
      anon_sym_PIPE,
    ACTIONS(1023), 1,
      anon_sym_AMP,
    ACTIONS(1025), 1,
      anon_sym_CARET,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1007), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1009), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1019), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(477), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(604), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1015), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(602), 20,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [23196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1079), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1077), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [23245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1123), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1121), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [23294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1075), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1073), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [23343] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_DOT,
    ACTIONS(1005), 1,
      anon_sym_LPAREN,
    ACTIONS(1013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    STATE(477), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(596), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(594), 30,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [23402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1059), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1057), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [23451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1101), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1103), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [23500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1071), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1069), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [23549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1067), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1065), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [23598] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1127), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1125), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [23647] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_DOT,
    ACTIONS(1005), 1,
      anon_sym_LPAREN,
    ACTIONS(1013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    STATE(477), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(600), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(598), 30,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [23706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1063), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1061), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [23755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1131), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1129), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [23804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1135), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1133), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [23853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1051), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1049), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [23902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1137), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1139), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [23951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1141), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1143), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [24000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1145), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [24049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1149), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1151), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [24098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1153), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1155), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [24147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1157), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1159), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [24196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1161), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [24245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1163), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1161), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [24294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1157), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1159), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [24343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1153), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1155), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [24392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1147), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1145), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [24441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1135), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1133), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [24490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1131), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1129), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [24539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1099), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1097), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [24588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1127), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1125), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [24637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1119), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1117), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [24686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1115), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1113), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [24735] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1111), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1109), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [24784] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1149), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1151), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [24833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1107), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1105), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [24882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1123), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1121), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [24931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(960), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(962), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [24980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1141), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1143), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [25029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1039), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1037), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [25078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1035), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1033), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [25127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1047), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1045), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [25176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1137), 11,
      sym__dedent,
      sym__string_start,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1139), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [25225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1055), 11,
      sym__string_start,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_AT,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
      anon_sym_LBRACK,
      sym_ellipsis,
      anon_sym_LBRACE,
      sym_float,
    ACTIONS(1053), 30,
      anon_sym_import,
      anon_sym_from,
      anon_sym_print,
      anon_sym_assert,
      anon_sym_return,
      anon_sym_del,
      anon_sym_raise,
      anon_sym_pass,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_while,
      anon_sym_try,
      anon_sym_with,
      anon_sym_def,
      anon_sym_global,
      anon_sym_nonlocal,
      anon_sym_exec,
      anon_sym_class,
      anon_sym_not,
      anon_sym_lambda,
      anon_sym_yield,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
      anon_sym_await,
  [25274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 1,
      anon_sym_COLON_EQ,
    ACTIONS(493), 6,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(491), 33,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [25324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(620), 35,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [25372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(618), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(616), 35,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [25420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(690), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(688), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [25467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(666), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(664), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [25514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(734), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(732), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [25561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(778), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(776), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [25608] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(714), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(712), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [25655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(698), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(696), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [25702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(708), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(706), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [25749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(694), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(692), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [25796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(728), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [25843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(682), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [25890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(670), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(668), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [25937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(678), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(676), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [25984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(750), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [26031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(756), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(754), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [26078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(644), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(642), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [26125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(748), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(746), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [26172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(742), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(740), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [26219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(674), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(672), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [26266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(686), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(684), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [26313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(762), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(760), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [26360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(640), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(638), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [26407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(738), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(736), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [26454] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(720), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(718), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [26501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(724), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(722), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [26548] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(774), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(772), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [26595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(233), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(235), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [26642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(768), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [26689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(632), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(630), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [26736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(636), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(634), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [26783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 5,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(626), 34,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [26830] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(499), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(493), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(491), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [26877] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_LPAREN,
    ACTIONS(1177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1181), 1,
      anon_sym_not,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_AMP,
    ACTIONS(1189), 1,
      anon_sym_CARET,
    ACTIONS(1193), 1,
      anon_sym_is,
    ACTIONS(1195), 1,
      anon_sym_LBRACK,
    STATE(608), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1171), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1173), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1183), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1191), 2,
      anon_sym_LT,
      anon_sym_GT,
    STATE(570), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1179), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(538), 6,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(1175), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [26952] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(501), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(588), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(586), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [26999] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1165), 1,
      anon_sym_COLON_EQ,
    ACTIONS(1197), 1,
      anon_sym_EQ,
    ACTIONS(493), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(491), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [27046] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1199), 1,
      sym__string_start,
    STATE(501), 2,
      sym_string,
      aux_sym_concatenated_string_repeat1,
    ACTIONS(529), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(527), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [27093] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      sym__string_start,
    ACTIONS(1204), 1,
      anon_sym_not,
    STATE(497), 1,
      sym_string,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1206), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1202), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(522), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [27153] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_LPAREN,
    ACTIONS(1177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1195), 1,
      anon_sym_LBRACK,
    STATE(570), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(600), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(598), 24,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [27205] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    STATE(1026), 1,
      sym_variables,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1210), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1208), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(603), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [27265] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    STATE(958), 1,
      sym_variables,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1210), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1208), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(603), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [27325] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1212), 1,
      anon_sym_EQ,
    ACTIONS(233), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(235), 29,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [27369] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    STATE(1020), 1,
      sym_variables,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1210), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1208), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(603), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [27429] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_LPAREN,
    ACTIONS(1177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_AMP,
    ACTIONS(1189), 1,
      anon_sym_CARET,
    ACTIONS(1195), 1,
      anon_sym_LBRACK,
    ACTIONS(608), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1173), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1183), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(570), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1179), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(606), 14,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [27495] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(1216), 1,
      anon_sym_in,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1218), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1214), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(606), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [27555] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(1222), 1,
      anon_sym_not,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1224), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1220), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(421), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [27615] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    STATE(994), 1,
      sym_variables,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1210), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1208), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(603), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [27675] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(73), 1,
      sym__string_start,
    ACTIONS(1228), 1,
      anon_sym_not,
    STATE(109), 1,
      sym_string,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1230), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1226), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(144), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [27735] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    STATE(1021), 1,
      sym_variables,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1210), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1208), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(603), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [27795] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    STATE(1028), 1,
      sym_variables,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1210), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1208), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(603), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [27855] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_LPAREN,
    ACTIONS(1177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1195), 1,
      anon_sym_LBRACK,
    ACTIONS(596), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1173), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1183), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(570), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1179), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(594), 17,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [27915] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_LPAREN,
    ACTIONS(1177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1189), 1,
      anon_sym_CARET,
    ACTIONS(1195), 1,
      anon_sym_LBRACK,
    ACTIONS(596), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1173), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1183), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(570), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1179), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(594), 16,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [27977] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(453), 1,
      sym__string_start,
    ACTIONS(1232), 1,
      anon_sym_in,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1218), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1214), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(606), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [28037] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_LPAREN,
    ACTIONS(1177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1187), 1,
      anon_sym_AMP,
    ACTIONS(1189), 1,
      anon_sym_CARET,
    ACTIONS(1195), 1,
      anon_sym_LBRACK,
    ACTIONS(596), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1173), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1183), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(570), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1179), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(594), 15,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [28101] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_LPAREN,
    ACTIONS(1177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1195), 1,
      anon_sym_LBRACK,
    ACTIONS(596), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    STATE(570), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1179), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(594), 21,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [28157] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_LPAREN,
    ACTIONS(1177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1195), 1,
      anon_sym_LBRACK,
    STATE(570), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(596), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(594), 24,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [28209] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_LPAREN,
    ACTIONS(1177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1195), 1,
      anon_sym_LBRACK,
    ACTIONS(596), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1183), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(570), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1179), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(594), 19,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [28267] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_LPAREN,
    ACTIONS(1177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1185), 1,
      anon_sym_PIPE,
    ACTIONS(1187), 1,
      anon_sym_AMP,
    ACTIONS(1189), 1,
      anon_sym_CARET,
    ACTIONS(1195), 1,
      anon_sym_LBRACK,
    ACTIONS(604), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1171), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1173), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1183), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(570), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1179), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
    ACTIONS(602), 14,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [28333] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1167), 1,
      anon_sym_DOT,
    ACTIONS(1169), 1,
      anon_sym_LPAREN,
    ACTIONS(1177), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1195), 1,
      anon_sym_LBRACK,
    STATE(570), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(596), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(594), 24,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
  [28385] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1236), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1234), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(402), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [28442] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1240), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1238), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(138), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [28499] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1244), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1242), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(141), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [28556] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1248), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1246), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(143), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [28613] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1230), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1226), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(144), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [28670] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1252), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1250), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(145), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [28727] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(604), 1,
      anon_sym_EQ,
    ACTIONS(1257), 1,
      anon_sym_not,
    ACTIONS(1263), 1,
      anon_sym_is,
    STATE(530), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1260), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1254), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(602), 21,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [28778] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1268), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1266), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(148), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [28835] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1272), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1270), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(508), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [28892] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1276), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1274), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(523), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [28949] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1280), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1278), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(147), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [29006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(622), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(620), 29,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [29047] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1284), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1282), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(521), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [29104] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1206), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1202), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(522), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [29161] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1288), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1286), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(146), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [29218] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1290), 1,
      anon_sym_COLON_EQ,
    ACTIONS(493), 5,
      anon_sym_STAR,
      anon_sym_COLON,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(491), 27,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [29261] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1294), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1292), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(149), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [29318] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1298), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1296), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(520), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [29375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(618), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(616), 29,
      sym__string_start,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [29416] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(552), 1,
      anon_sym_not,
    ACTIONS(564), 1,
      anon_sym_is,
    ACTIONS(1302), 1,
      anon_sym_EQ,
    STATE(530), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(562), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(546), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1300), 21,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [29467] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1306), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1304), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(515), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [29524] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1310), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1308), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(516), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [29581] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1314), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1312), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(413), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [29638] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1318), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1316), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(414), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [29695] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1322), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1320), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(415), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [29752] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1326), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1324), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(418), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [29809] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1330), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1328), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(420), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [29866] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1224), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1220), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(421), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [29923] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1334), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1332), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(381), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [29980] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1338), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1336), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(425), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [30037] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      anon_sym_LPAREN,
    ACTIONS(63), 1,
      anon_sym_LBRACK,
    ACTIONS(67), 1,
      anon_sym_LBRACE,
    ACTIONS(73), 1,
      sym__string_start,
    STATE(109), 1,
      sym_string,
    ACTIONS(237), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1342), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(57), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1340), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(139), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [30094] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1346), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1344), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(431), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [30151] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(429), 1,
      anon_sym_LPAREN,
    ACTIONS(443), 1,
      anon_sym_LBRACK,
    ACTIONS(447), 1,
      anon_sym_LBRACE,
    ACTIONS(453), 1,
      sym__string_start,
    STATE(377), 1,
      sym_string,
    ACTIONS(433), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1218), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(439), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1214), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(606), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [30208] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1350), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1348), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(518), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [30265] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1354), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1352), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(519), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [30322] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(872), 1,
      anon_sym_LPAREN,
    ACTIONS(882), 1,
      anon_sym_LBRACK,
    ACTIONS(886), 1,
      anon_sym_LBRACE,
    ACTIONS(892), 1,
      sym__string_start,
    STATE(497), 1,
      sym_string,
    ACTIONS(874), 2,
      anon_sym_print,
      anon_sym_exec,
    ACTIONS(1358), 2,
      sym_ellipsis,
      sym_float,
    ACTIONS(878), 3,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_TILDE,
    ACTIONS(1356), 5,
      sym_integer,
      sym_identifier,
      sym_true,
      sym_false,
      sym_none,
    STATE(503), 16,
      sym__primary_expression,
      sym_binary_operator,
      sym_unary_operator,
      sym_attribute,
      sym_subscript,
      sym_call,
      sym_list,
      sym_list_comprehension,
      sym_dictionary,
      sym_dictionary_comprehension,
      sym_set,
      sym_set_comprehension,
      sym_parenthesized_expression,
      sym_tuple,
      sym_generator_expression,
      sym_concatenated_string,
  [30379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(724), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(722), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [30419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(690), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(688), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [30459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(708), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(706), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [30499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(233), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(235), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [30539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(730), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(728), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [30579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(734), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(732), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [30619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(674), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(672), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [30659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(752), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(750), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [30699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(756), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(754), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [30739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(778), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(776), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [30779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(670), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(668), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [30819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(714), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(712), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [30859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(698), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(696), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [30899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(694), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(692), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [30939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(628), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(626), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [30979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(644), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(642), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [31019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(666), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(664), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [31059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(636), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(634), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [31099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(682), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(680), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [31139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(678), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(676), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [31179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(762), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(760), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [31219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(686), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(684), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [31259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(720), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(718), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [31299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(640), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(638), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [31339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(774), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(772), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [31379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(770), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(768), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [31419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(632), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(630), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [31459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(738), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(736), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [31499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(742), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(740), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [31539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(748), 4,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(746), 28,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_GT_GT,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_STAR_STAR,
      anon_sym_AT,
      anon_sym_not,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
      anon_sym_is,
      anon_sym_LBRACK,
  [31579] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1017), 1,
      anon_sym_not,
    ACTIONS(1029), 1,
      anon_sym_is,
    ACTIONS(1302), 1,
      anon_sym_EQ,
    STATE(591), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1027), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1011), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1300), 12,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [31621] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(604), 1,
      anon_sym_EQ,
    ACTIONS(1363), 1,
      anon_sym_not,
    ACTIONS(1369), 1,
      anon_sym_is,
    STATE(591), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1366), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1360), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(602), 12,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_and,
      anon_sym_or,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [31663] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1374), 1,
      anon_sym_COMMA,
    ACTIONS(1376), 1,
      anon_sym_if,
    ACTIONS(1378), 1,
      anon_sym_and,
    ACTIONS(1380), 1,
      anon_sym_or,
    STATE(605), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(1372), 18,
      sym__newline,
      anon_sym_from,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [31702] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1378), 1,
      anon_sym_and,
    ACTIONS(1382), 21,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [31732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1378), 1,
      anon_sym_and,
    ACTIONS(1380), 1,
      anon_sym_or,
    ACTIONS(1384), 20,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [31764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1382), 22,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [31792] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1376), 1,
      anon_sym_if,
    ACTIONS(1378), 1,
      anon_sym_and,
    ACTIONS(1380), 1,
      anon_sym_or,
    ACTIONS(1386), 19,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [31826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1388), 22,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [31854] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1376), 1,
      anon_sym_if,
    ACTIONS(1378), 1,
      anon_sym_and,
    ACTIONS(1380), 1,
      anon_sym_or,
    ACTIONS(1390), 1,
      anon_sym_COMMA,
    STATE(607), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(1392), 2,
      sym__newline,
      sym__semicolon,
    ACTIONS(1372), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [31894] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1376), 1,
      anon_sym_if,
    ACTIONS(1378), 1,
      anon_sym_and,
    ACTIONS(1380), 1,
      anon_sym_or,
    ACTIONS(1394), 19,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [31928] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1376), 1,
      anon_sym_if,
    ACTIONS(1378), 1,
      anon_sym_and,
    ACTIONS(1380), 1,
      anon_sym_or,
    ACTIONS(1396), 19,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [31962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1378), 1,
      anon_sym_and,
    ACTIONS(1380), 1,
      anon_sym_or,
    ACTIONS(1398), 20,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [31994] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1376), 1,
      anon_sym_if,
    ACTIONS(1378), 1,
      anon_sym_and,
    ACTIONS(1380), 1,
      anon_sym_or,
    ACTIONS(1400), 19,
      sym__newline,
      anon_sym_from,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [32028] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_DOT,
    ACTIONS(1005), 1,
      anon_sym_LPAREN,
    ACTIONS(1013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1021), 1,
      anon_sym_PIPE,
    ACTIONS(1023), 1,
      anon_sym_AMP,
    ACTIONS(1025), 1,
      anon_sym_CARET,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1402), 1,
      anon_sym_COMMA,
    ACTIONS(1404), 1,
      anon_sym_in,
    STATE(869), 1,
      aux_sym_variables_repeat1,
    ACTIONS(1007), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1009), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1019), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    STATE(477), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1015), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [32083] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1406), 1,
      anon_sym_COMMA,
    STATE(604), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(1400), 18,
      sym__newline,
      anon_sym_from,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [32113] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1409), 1,
      anon_sym_COMMA,
    STATE(604), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(415), 18,
      sym__newline,
      anon_sym_from,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      sym__semicolon,
  [32143] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1003), 1,
      anon_sym_DOT,
    ACTIONS(1005), 1,
      anon_sym_LPAREN,
    ACTIONS(1013), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1021), 1,
      anon_sym_PIPE,
    ACTIONS(1023), 1,
      anon_sym_AMP,
    ACTIONS(1025), 1,
      anon_sym_CARET,
    ACTIONS(1031), 1,
      anon_sym_LBRACK,
    ACTIONS(1007), 2,
      anon_sym_STAR,
      anon_sym_SLASH,
    ACTIONS(1009), 2,
      anon_sym_GT_GT,
      anon_sym_LT_LT,
    ACTIONS(1019), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(1411), 2,
      anon_sym_COMMA,
      anon_sym_in,
    STATE(477), 2,
      sym_argument_list,
      sym_generator_expression,
    ACTIONS(1015), 3,
      anon_sym_AT,
      anon_sym_PERCENT,
      anon_sym_SLASH_SLASH,
  [32193] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1413), 1,
      anon_sym_COMMA,
    STATE(604), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(423), 2,
      sym__newline,
      sym__semicolon,
    ACTIONS(415), 15,
      anon_sym_COLON,
      anon_sym_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32224] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1181), 1,
      anon_sym_not,
    ACTIONS(1193), 1,
      anon_sym_is,
    STATE(609), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1191), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(1175), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
    ACTIONS(1300), 6,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
  [32257] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1418), 1,
      anon_sym_not,
    ACTIONS(1424), 1,
      anon_sym_is,
    STATE(609), 1,
      aux_sym_comparison_operator_repeat1,
    ACTIONS(1421), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(602), 6,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(1415), 6,
      anon_sym_in,
      anon_sym_LT_EQ,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_GT,
  [32290] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1427), 1,
      anon_sym_COLON,
    ACTIONS(1429), 1,
      anon_sym_EQ,
    ACTIONS(1433), 2,
      sym__newline,
      sym__semicolon,
    ACTIONS(1431), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32319] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1435), 1,
      sym_identifier,
    ACTIONS(1437), 1,
      anon_sym_LPAREN,
    ACTIONS(1439), 1,
      anon_sym_STAR,
    ACTIONS(1443), 1,
      anon_sym_COLON,
    STATE(960), 1,
      sym_lambda_parameters,
    STATE(968), 1,
      sym__parameters,
    ACTIONS(1441), 2,
      anon_sym_print,
      anon_sym_exec,
    STATE(898), 2,
      sym_list_splat,
      sym_dictionary_splat,
    STATE(899), 4,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_tuple,
  [32358] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1435), 1,
      sym_identifier,
    ACTIONS(1437), 1,
      anon_sym_LPAREN,
    ACTIONS(1439), 1,
      anon_sym_STAR,
    ACTIONS(1445), 1,
      anon_sym_COLON,
    STATE(964), 1,
      sym_lambda_parameters,
    STATE(968), 1,
      sym__parameters,
    ACTIONS(1441), 2,
      anon_sym_print,
      anon_sym_exec,
    STATE(898), 2,
      sym_list_splat,
      sym_dictionary_splat,
    STATE(899), 4,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_tuple,
  [32397] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1427), 1,
      anon_sym_COLON,
    ACTIONS(1429), 1,
      anon_sym_EQ,
    ACTIONS(1431), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_AT_EQ,
      anon_sym_SLASH_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_STAR_STAR_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
  [32422] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1435), 1,
      sym_identifier,
    ACTIONS(1437), 1,
      anon_sym_LPAREN,
    ACTIONS(1439), 1,
      anon_sym_STAR,
    ACTIONS(1447), 1,
      anon_sym_COLON,
    STATE(967), 1,
      sym_lambda_parameters,
    STATE(968), 1,
      sym__parameters,
    ACTIONS(1441), 2,
      anon_sym_print,
      anon_sym_exec,
    STATE(898), 2,
      sym_list_splat,
      sym_dictionary_splat,
    STATE(899), 4,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_tuple,
  [32461] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1435), 1,
      sym_identifier,
    ACTIONS(1437), 1,
      anon_sym_LPAREN,
    ACTIONS(1439), 1,
      anon_sym_STAR,
    ACTIONS(1449), 1,
      anon_sym_COLON,
    STATE(968), 1,
      sym__parameters,
    STATE(989), 1,
      sym_lambda_parameters,
    ACTIONS(1441), 2,
      anon_sym_print,
      anon_sym_exec,
    STATE(898), 2,
      sym_list_splat,
      sym_dictionary_splat,
    STATE(899), 4,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_tuple,
  [32500] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1437), 1,
      anon_sym_LPAREN,
    ACTIONS(1451), 1,
      sym_identifier,
    ACTIONS(1453), 1,
      anon_sym_RPAREN,
    ACTIONS(1455), 1,
      anon_sym_STAR,
    STATE(1023), 1,
      sym__parameters,
    ACTIONS(1457), 2,
      anon_sym_print,
      anon_sym_exec,
    STATE(775), 2,
      sym_list_splat,
      sym_dictionary_splat,
    STATE(834), 4,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_tuple,
  [32536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1382), 12,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_EQ,
      anon_sym_or,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [32557] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1386), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [32582] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1437), 1,
      anon_sym_LPAREN,
    ACTIONS(1465), 1,
      sym_identifier,
    ACTIONS(1467), 1,
      anon_sym_RPAREN,
    ACTIONS(1469), 1,
      anon_sym_STAR,
    ACTIONS(1471), 2,
      anon_sym_print,
      anon_sym_exec,
    STATE(851), 2,
      sym_list_splat,
      sym_dictionary_splat,
    STATE(887), 4,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_tuple,
  [32615] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1437), 1,
      anon_sym_LPAREN,
    ACTIONS(1469), 1,
      anon_sym_STAR,
    ACTIONS(1473), 1,
      sym_identifier,
    ACTIONS(1477), 1,
      anon_sym_COLON,
    ACTIONS(1475), 2,
      anon_sym_print,
      anon_sym_exec,
    STATE(914), 2,
      sym_list_splat,
      sym_dictionary_splat,
    STATE(887), 4,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_tuple,
  [32648] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1396), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [32673] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1394), 10,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [32698] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1437), 1,
      anon_sym_LPAREN,
    ACTIONS(1469), 1,
      anon_sym_STAR,
    ACTIONS(1473), 1,
      sym_identifier,
    ACTIONS(1479), 1,
      anon_sym_COLON,
    ACTIONS(1475), 2,
      anon_sym_print,
      anon_sym_exec,
    STATE(914), 2,
      sym_list_splat,
      sym_dictionary_splat,
    STATE(887), 4,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_tuple,
  [32731] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1437), 1,
      anon_sym_LPAREN,
    ACTIONS(1465), 1,
      sym_identifier,
    ACTIONS(1469), 1,
      anon_sym_STAR,
    ACTIONS(1481), 1,
      anon_sym_RPAREN,
    ACTIONS(1471), 2,
      anon_sym_print,
      anon_sym_exec,
    STATE(851), 2,
      sym_list_splat,
      sym_dictionary_splat,
    STATE(887), 4,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_tuple,
  [32764] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1437), 1,
      anon_sym_LPAREN,
    ACTIONS(1469), 1,
      anon_sym_STAR,
    ACTIONS(1473), 1,
      sym_identifier,
    ACTIONS(1483), 1,
      anon_sym_COLON,
    ACTIONS(1475), 2,
      anon_sym_print,
      anon_sym_exec,
    STATE(914), 2,
      sym_list_splat,
      sym_dictionary_splat,
    STATE(887), 4,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_tuple,
  [32797] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1437), 1,
      anon_sym_LPAREN,
    ACTIONS(1469), 1,
      anon_sym_STAR,
    ACTIONS(1473), 1,
      sym_identifier,
    ACTIONS(1481), 1,
      anon_sym_COLON,
    ACTIONS(1475), 2,
      anon_sym_print,
      anon_sym_exec,
    STATE(914), 2,
      sym_list_splat,
      sym_dictionary_splat,
    STATE(887), 4,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_tuple,
  [32830] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1384), 11,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [32853] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1437), 1,
      anon_sym_LPAREN,
    ACTIONS(1465), 1,
      sym_identifier,
    ACTIONS(1469), 1,
      anon_sym_STAR,
    ACTIONS(1485), 1,
      anon_sym_RPAREN,
    ACTIONS(1471), 2,
      anon_sym_print,
      anon_sym_exec,
    STATE(851), 2,
      sym_list_splat,
      sym_dictionary_splat,
    STATE(887), 4,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_tuple,
  [32886] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1437), 1,
      anon_sym_LPAREN,
    ACTIONS(1465), 1,
      sym_identifier,
    ACTIONS(1469), 1,
      anon_sym_STAR,
    ACTIONS(1479), 1,
      anon_sym_RPAREN,
    ACTIONS(1471), 2,
      anon_sym_print,
      anon_sym_exec,
    STATE(851), 2,
      sym_list_splat,
      sym_dictionary_splat,
    STATE(887), 4,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_tuple,
  [32919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1382), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [32938] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1437), 1,
      anon_sym_LPAREN,
    ACTIONS(1465), 1,
      sym_identifier,
    ACTIONS(1469), 1,
      anon_sym_STAR,
    ACTIONS(1477), 1,
      anon_sym_RPAREN,
    ACTIONS(1471), 2,
      anon_sym_print,
      anon_sym_exec,
    STATE(851), 2,
      sym_list_splat,
      sym_dictionary_splat,
    STATE(887), 4,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_tuple,
  [32971] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1437), 1,
      anon_sym_LPAREN,
    ACTIONS(1465), 1,
      sym_identifier,
    ACTIONS(1469), 1,
      anon_sym_STAR,
    ACTIONS(1483), 1,
      anon_sym_RPAREN,
    ACTIONS(1471), 2,
      anon_sym_print,
      anon_sym_exec,
    STATE(851), 2,
      sym_list_splat,
      sym_dictionary_splat,
    STATE(887), 4,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_tuple,
  [33004] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1437), 1,
      anon_sym_LPAREN,
    ACTIONS(1467), 1,
      anon_sym_COLON,
    ACTIONS(1469), 1,
      anon_sym_STAR,
    ACTIONS(1473), 1,
      sym_identifier,
    ACTIONS(1475), 2,
      anon_sym_print,
      anon_sym_exec,
    STATE(914), 2,
      sym_list_splat,
      sym_dictionary_splat,
    STATE(887), 4,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_tuple,
  [33037] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1398), 11,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_EQ,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [33060] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1437), 1,
      anon_sym_LPAREN,
    ACTIONS(1469), 1,
      anon_sym_STAR,
    ACTIONS(1473), 1,
      sym_identifier,
    ACTIONS(1485), 1,
      anon_sym_COLON,
    ACTIONS(1475), 2,
      anon_sym_print,
      anon_sym_exec,
    STATE(914), 2,
      sym_list_splat,
      sym_dictionary_splat,
    STATE(887), 4,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_tuple,
  [33093] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1388), 13,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_else,
      anon_sym_async,
      anon_sym_for,
      anon_sym_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_type_conversion,
  [33112] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1437), 1,
      anon_sym_LPAREN,
    ACTIONS(1465), 1,
      sym_identifier,
    ACTIONS(1469), 1,
      anon_sym_STAR,
    ACTIONS(1471), 2,
      anon_sym_print,
      anon_sym_exec,
    STATE(851), 2,
      sym_list_splat,
      sym_dictionary_splat,
    STATE(887), 4,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_tuple,
  [33142] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(471), 1,
      anon_sym_STAR_STAR,
    ACTIONS(1437), 1,
      anon_sym_LPAREN,
    ACTIONS(1469), 1,
      anon_sym_STAR,
    ACTIONS(1473), 1,
      sym_identifier,
    ACTIONS(1475), 2,
      anon_sym_print,
      anon_sym_exec,
    STATE(914), 2,
      sym_list_splat,
      sym_dictionary_splat,
    STATE(887), 4,
      sym_default_parameter,
      sym_typed_default_parameter,
      sym_typed_parameter,
      sym_tuple,
  [33172] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1487), 1,
      anon_sym_COMMA,
    ACTIONS(1489), 1,
      anon_sym_COLON,
    ACTIONS(1491), 1,
      anon_sym_async,
    ACTIONS(1493), 1,
      anon_sym_for,
    ACTIONS(1495), 1,
      anon_sym_RBRACE,
    STATE(651), 1,
      sym_for_in_clause,
    STATE(819), 1,
      aux_sym_set_repeat1,
    STATE(955), 1,
      sym__comprehension_clauses,
  [33209] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1489), 1,
      anon_sym_COLON,
    ACTIONS(1491), 1,
      anon_sym_async,
    ACTIONS(1493), 1,
      anon_sym_for,
    ACTIONS(1497), 1,
      anon_sym_COMMA,
    ACTIONS(1499), 1,
      anon_sym_RBRACE,
    STATE(651), 1,
      sym_for_in_clause,
    STATE(830), 1,
      aux_sym_set_repeat1,
    STATE(983), 1,
      sym__comprehension_clauses,
  [33246] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1489), 1,
      anon_sym_COLON,
    ACTIONS(1491), 1,
      anon_sym_async,
    ACTIONS(1493), 1,
      anon_sym_for,
    ACTIONS(1501), 1,
      anon_sym_COMMA,
    ACTIONS(1503), 1,
      anon_sym_RBRACE,
    STATE(651), 1,
      sym_for_in_clause,
    STATE(863), 1,
      aux_sym_set_repeat1,
    STATE(974), 1,
      sym__comprehension_clauses,
  [33283] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1491), 1,
      anon_sym_async,
    ACTIONS(1493), 1,
      anon_sym_for,
    ACTIONS(1505), 1,
      anon_sym_COMMA,
    ACTIONS(1507), 1,
      anon_sym_RBRACK,
    STATE(651), 1,
      sym_for_in_clause,
    STATE(770), 1,
      aux_sym__collection_elements_repeat1,
    STATE(991), 1,
      sym__comprehension_clauses,
  [33317] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1491), 1,
      anon_sym_async,
    ACTIONS(1493), 1,
      anon_sym_for,
    ACTIONS(1505), 1,
      anon_sym_COMMA,
    ACTIONS(1507), 1,
      anon_sym_RBRACK,
    STATE(651), 1,
      sym_for_in_clause,
    STATE(770), 1,
      aux_sym__collection_elements_repeat1,
    STATE(950), 1,
      sym__comprehension_clauses,
  [33351] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1491), 1,
      anon_sym_async,
    ACTIONS(1493), 1,
      anon_sym_for,
    ACTIONS(1505), 1,
      anon_sym_COMMA,
    ACTIONS(1507), 1,
      anon_sym_RBRACK,
    STATE(651), 1,
      sym_for_in_clause,
    STATE(770), 1,
      aux_sym__collection_elements_repeat1,
    STATE(975), 1,
      sym__comprehension_clauses,
  [33385] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1491), 1,
      anon_sym_async,
    ACTIONS(1493), 1,
      anon_sym_for,
    ACTIONS(1509), 1,
      anon_sym_RPAREN,
    ACTIONS(1511), 1,
      anon_sym_COMMA,
    STATE(651), 1,
      sym_for_in_clause,
    STATE(890), 1,
      aux_sym_argument_list_repeat1,
    STATE(978), 1,
      sym__comprehension_clauses,
  [33419] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1491), 1,
      anon_sym_async,
    ACTIONS(1493), 1,
      anon_sym_for,
    ACTIONS(1505), 1,
      anon_sym_COMMA,
    ACTIONS(1513), 1,
      anon_sym_RPAREN,
    STATE(651), 1,
      sym_for_in_clause,
    STATE(770), 1,
      aux_sym__collection_elements_repeat1,
    STATE(978), 1,
      sym__comprehension_clauses,
  [33453] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1491), 1,
      anon_sym_async,
    ACTIONS(1493), 1,
      anon_sym_for,
    ACTIONS(1515), 1,
      anon_sym_RPAREN,
    ACTIONS(1517), 1,
      anon_sym_COMMA,
    STATE(651), 1,
      sym_for_in_clause,
    STATE(881), 1,
      aux_sym_argument_list_repeat1,
    STATE(949), 1,
      sym__comprehension_clauses,
  [33487] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1491), 1,
      anon_sym_async,
    ACTIONS(1493), 1,
      anon_sym_for,
    ACTIONS(1505), 1,
      anon_sym_COMMA,
    ACTIONS(1519), 1,
      anon_sym_RPAREN,
    STATE(651), 1,
      sym_for_in_clause,
    STATE(770), 1,
      aux_sym__collection_elements_repeat1,
    STATE(1019), 1,
      sym__comprehension_clauses,
  [33521] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1491), 1,
      anon_sym_async,
    ACTIONS(1493), 1,
      anon_sym_for,
    ACTIONS(1521), 1,
      anon_sym_RPAREN,
    ACTIONS(1523), 1,
      anon_sym_COMMA,
    STATE(651), 1,
      sym_for_in_clause,
    STATE(843), 1,
      aux_sym_argument_list_repeat1,
    STATE(1019), 1,
      sym__comprehension_clauses,
  [33555] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1491), 1,
      anon_sym_async,
    ACTIONS(1493), 1,
      anon_sym_for,
    ACTIONS(1505), 1,
      anon_sym_COMMA,
    ACTIONS(1525), 1,
      anon_sym_RPAREN,
    STATE(651), 1,
      sym_for_in_clause,
    STATE(770), 1,
      aux_sym__collection_elements_repeat1,
    STATE(949), 1,
      sym__comprehension_clauses,
  [33589] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 1,
      anon_sym_async,
    ACTIONS(1493), 1,
      anon_sym_for,
    ACTIONS(1529), 1,
      anon_sym_if,
    ACTIONS(1527), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(654), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [33612] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1531), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [33631] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1531), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [33650] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 1,
      anon_sym_async,
    ACTIONS(1493), 1,
      anon_sym_for,
    ACTIONS(1529), 1,
      anon_sym_if,
    ACTIONS(1533), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(655), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [33673] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1537), 1,
      anon_sym_if,
    ACTIONS(1540), 1,
      anon_sym_async,
    ACTIONS(1543), 1,
      anon_sym_for,
    ACTIONS(1535), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(655), 3,
      sym_for_in_clause,
      sym_if_clause,
      aux_sym__comprehension_clauses_repeat1,
  [33696] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1531), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [33715] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_AT,
    ACTIONS(1546), 1,
      anon_sym_async,
    ACTIONS(1548), 1,
      anon_sym_def,
    ACTIONS(1550), 1,
      anon_sym_class,
    STATE(407), 2,
      sym_function_definition,
      sym_class_definition,
    STATE(720), 2,
      sym_decorator,
      aux_sym_decorated_definition_repeat1,
  [33739] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1554), 1,
      anon_sym_COMMA,
    STATE(664), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(1552), 6,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [33757] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1558), 1,
      anon_sym_COMMA,
    STATE(665), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(1556), 6,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [33775] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1562), 1,
      anon_sym_COMMA,
    STATE(660), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(1560), 6,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [33793] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1565), 5,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [33813] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      anon_sym_AT,
    ACTIONS(1567), 1,
      anon_sym_async,
    ACTIONS(1569), 1,
      anon_sym_def,
    ACTIONS(1571), 1,
      anon_sym_class,
    STATE(427), 2,
      sym_function_definition,
      sym_class_definition,
    STATE(720), 2,
      sym_decorator,
      aux_sym_decorated_definition_repeat1,
  [33837] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1573), 1,
      anon_sym_COMMA,
    STATE(735), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(1372), 3,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [33861] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1577), 1,
      anon_sym_COMMA,
    STATE(660), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(1575), 6,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [33879] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1581), 1,
      anon_sym_COMMA,
    STATE(660), 1,
      aux_sym_for_in_clause_repeat1,
    ACTIONS(1579), 6,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [33897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1583), 6,
      anon_sym_RPAREN,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [33915] = 6,
    ACTIONS(1585), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      sym_comment,
    ACTIONS(1591), 1,
      sym__string_content,
    ACTIONS(1593), 1,
      sym__string_end,
    ACTIONS(1587), 2,
      sym_escape_sequence,
      sym__not_escape_sequence,
    STATE(675), 2,
      sym_interpolation,
      aux_sym_string_repeat1,
  [33936] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 1,
      anon_sym_async,
    ACTIONS(1493), 1,
      anon_sym_for,
    ACTIONS(1595), 1,
      anon_sym_COMMA,
    ACTIONS(1597), 1,
      anon_sym_RBRACE,
    STATE(651), 1,
      sym_for_in_clause,
    STATE(865), 1,
      aux_sym_dictionary_repeat1,
    STATE(973), 1,
      sym__comprehension_clauses,
  [33961] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1599), 1,
      anon_sym_DOT,
    STATE(693), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(1601), 5,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      sym__semicolon,
  [33978] = 6,
    ACTIONS(1585), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      sym_comment,
    ACTIONS(1605), 1,
      sym__string_content,
    ACTIONS(1607), 1,
      sym__string_end,
    ACTIONS(1603), 2,
      sym_escape_sequence,
      sym__not_escape_sequence,
    STATE(676), 2,
      sym_interpolation,
      aux_sym_string_repeat1,
  [33999] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1609), 1,
      anon_sym_COMMA,
    ACTIONS(1611), 1,
      anon_sym_COLON,
    ACTIONS(1613), 1,
      anon_sym_RBRACK,
    STATE(894), 1,
      aux_sym_subscript_repeat1,
  [34024] = 6,
    ACTIONS(1585), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      sym_comment,
    ACTIONS(1617), 1,
      sym__string_content,
    ACTIONS(1619), 1,
      sym__string_end,
    ACTIONS(1615), 2,
      sym_escape_sequence,
      sym__not_escape_sequence,
    STATE(686), 2,
      sym_interpolation,
      aux_sym_string_repeat1,
  [34045] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1376), 1,
      anon_sym_if,
    ACTIONS(1378), 1,
      anon_sym_and,
    ACTIONS(1380), 1,
      anon_sym_or,
    ACTIONS(1621), 1,
      anon_sym_COMMA,
    STATE(791), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(1623), 2,
      sym__newline,
      sym__semicolon,
  [34068] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1376), 1,
      anon_sym_if,
    ACTIONS(1378), 1,
      anon_sym_and,
    ACTIONS(1380), 1,
      anon_sym_or,
    ACTIONS(1625), 1,
      anon_sym_COMMA,
    STATE(779), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(1627), 2,
      sym__newline,
      sym__semicolon,
  [34091] = 6,
    ACTIONS(1585), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      sym_comment,
    ACTIONS(1605), 1,
      sym__string_content,
    ACTIONS(1629), 1,
      sym__string_end,
    ACTIONS(1603), 2,
      sym_escape_sequence,
      sym__not_escape_sequence,
    STATE(676), 2,
      sym_interpolation,
      aux_sym_string_repeat1,
  [34112] = 6,
    ACTIONS(1589), 1,
      sym_comment,
    ACTIONS(1631), 1,
      anon_sym_LBRACE,
    ACTIONS(1637), 1,
      sym__string_content,
    ACTIONS(1640), 1,
      sym__string_end,
    ACTIONS(1634), 2,
      sym_escape_sequence,
      sym__not_escape_sequence,
    STATE(676), 2,
      sym_interpolation,
      aux_sym_string_repeat1,
  [34133] = 6,
    ACTIONS(1585), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      sym_comment,
    ACTIONS(1644), 1,
      sym__string_content,
    ACTIONS(1646), 1,
      sym__string_end,
    ACTIONS(1642), 2,
      sym_escape_sequence,
      sym__not_escape_sequence,
    STATE(688), 2,
      sym_interpolation,
      aux_sym_string_repeat1,
  [34154] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1648), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACE,
  [34173] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 1,
      sym_identifier,
    ACTIONS(1652), 1,
      anon_sym_LPAREN,
    ACTIONS(1654), 1,
      anon_sym_STAR,
    STATE(741), 1,
      sym_dotted_name,
    STATE(774), 1,
      sym_aliased_import,
    STATE(924), 2,
      sym__import_list,
      sym_wildcard_import,
  [34196] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1376), 1,
      anon_sym_if,
    ACTIONS(1378), 1,
      anon_sym_and,
    ACTIONS(1380), 1,
      anon_sym_or,
    ACTIONS(1621), 1,
      anon_sym_COMMA,
    STATE(794), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(1656), 2,
      sym__newline,
      sym__semicolon,
  [34219] = 6,
    ACTIONS(1585), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      sym_comment,
    ACTIONS(1660), 1,
      sym__string_content,
    ACTIONS(1662), 1,
      sym__string_end,
    ACTIONS(1658), 2,
      sym_escape_sequence,
      sym__not_escape_sequence,
    STATE(670), 2,
      sym_interpolation,
      aux_sym_string_repeat1,
  [34240] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1611), 1,
      anon_sym_COLON,
    ACTIONS(1664), 1,
      anon_sym_COMMA,
    ACTIONS(1666), 1,
      anon_sym_RBRACK,
    STATE(866), 1,
      aux_sym_subscript_repeat1,
  [34265] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1668), 4,
      anon_sym_COMMA,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACE,
  [34284] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 1,
      anon_sym_async,
    ACTIONS(1493), 1,
      anon_sym_for,
    ACTIONS(1670), 1,
      anon_sym_COMMA,
    ACTIONS(1672), 1,
      anon_sym_RBRACE,
    STATE(651), 1,
      sym_for_in_clause,
    STATE(815), 1,
      aux_sym_dictionary_repeat1,
    STATE(956), 1,
      sym__comprehension_clauses,
  [34309] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1611), 1,
      anon_sym_COLON,
    ACTIONS(1674), 1,
      anon_sym_COMMA,
    ACTIONS(1676), 1,
      anon_sym_RBRACK,
    STATE(825), 1,
      aux_sym_subscript_repeat1,
  [34334] = 6,
    ACTIONS(1585), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      sym_comment,
    ACTIONS(1605), 1,
      sym__string_content,
    ACTIONS(1678), 1,
      sym__string_end,
    ACTIONS(1603), 2,
      sym_escape_sequence,
      sym__not_escape_sequence,
    STATE(676), 2,
      sym_interpolation,
      aux_sym_string_repeat1,
  [34355] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1680), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_EQ,
  [34374] = 6,
    ACTIONS(1585), 1,
      anon_sym_LBRACE,
    ACTIONS(1589), 1,
      sym_comment,
    ACTIONS(1605), 1,
      sym__string_content,
    ACTIONS(1682), 1,
      sym__string_end,
    ACTIONS(1603), 2,
      sym_escape_sequence,
      sym__not_escape_sequence,
    STATE(676), 2,
      sym_interpolation,
      aux_sym_string_repeat1,
  [34395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1560), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [34408] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1684), 1,
      anon_sym_DOT,
    STATE(690), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(1687), 5,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      sym__semicolon,
  [34425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1689), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [34438] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1400), 4,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [34457] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1599), 1,
      anon_sym_DOT,
    STATE(690), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(1691), 5,
      sym__newline,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      sym__semicolon,
  [34474] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1695), 1,
      anon_sym_DOT,
    ACTIONS(1697), 1,
      anon_sym___future__,
    STATE(796), 1,
      aux_sym_import_prefix_repeat1,
    STATE(813), 1,
      sym_import_prefix,
    STATE(953), 2,
      sym_relative_import,
      sym_dotted_name,
  [34497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1699), 7,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_async,
      anon_sym_for,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
  [34510] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1491), 1,
      anon_sym_async,
    ACTIONS(1493), 1,
      anon_sym_for,
    ACTIONS(1701), 1,
      anon_sym_COMMA,
    ACTIONS(1703), 1,
      anon_sym_RBRACE,
    STATE(651), 1,
      sym_for_in_clause,
    STATE(831), 1,
      aux_sym_dictionary_repeat1,
    STATE(976), 1,
      sym__comprehension_clauses,
  [34535] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1705), 1,
      anon_sym_COLON,
    ACTIONS(1707), 1,
      anon_sym_RBRACE,
    ACTIONS(1709), 1,
      sym_type_conversion,
    STATE(986), 1,
      sym_format_specifier,
  [34560] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_and,
    ACTIONS(1713), 1,
      anon_sym_or,
    ACTIONS(1398), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [34576] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1376), 1,
      anon_sym_if,
    ACTIONS(1378), 1,
      anon_sym_and,
    ACTIONS(1380), 1,
      anon_sym_or,
    ACTIONS(1680), 3,
      sym__newline,
      anon_sym_EQ,
      sym__semicolon,
  [34594] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1505), 1,
      anon_sym_COMMA,
    ACTIONS(1507), 1,
      anon_sym_RPAREN,
    STATE(770), 1,
      aux_sym__collection_elements_repeat1,
  [34616] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1715), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [34634] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1376), 1,
      anon_sym_if,
    ACTIONS(1378), 1,
      anon_sym_and,
    ACTIONS(1380), 1,
      anon_sym_or,
    ACTIONS(1717), 3,
      sym__newline,
      anon_sym_COMMA,
      sym__semicolon,
  [34652] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1611), 1,
      anon_sym_COLON,
    ACTIONS(1719), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [34672] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_and,
    ACTIONS(1713), 1,
      anon_sym_or,
    ACTIONS(1721), 1,
      anon_sym_if,
    ACTIONS(1386), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_COLON,
  [34690] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_DOT,
    STATE(718), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(1691), 4,
      anon_sym_import,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [34706] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_and,
    ACTIONS(1713), 1,
      anon_sym_or,
    ACTIONS(1721), 1,
      anon_sym_if,
    ACTIONS(1396), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_COLON,
  [34724] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_and,
    ACTIONS(1713), 1,
      anon_sym_or,
    ACTIONS(1721), 1,
      anon_sym_if,
    ACTIONS(1727), 1,
      anon_sym_COLON,
    ACTIONS(1725), 2,
      anon_sym_COMMA,
      anon_sym_as,
  [34744] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1729), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [34762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_and,
    ACTIONS(1382), 5,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_or,
  [34776] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(788), 1,
      anon_sym_COLON,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(786), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [34796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1382), 6,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
  [34808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_and,
    ACTIONS(1713), 1,
      anon_sym_or,
    ACTIONS(1384), 4,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
  [34824] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1731), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
  [34842] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1733), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
  [34860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1687), 6,
      sym__newline,
      anon_sym_DOT,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_as,
      sym__semicolon,
  [34872] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_and,
    ACTIONS(1713), 1,
      anon_sym_or,
    ACTIONS(1721), 1,
      anon_sym_if,
    ACTIONS(1394), 3,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_COLON,
  [34890] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_and,
    ACTIONS(1713), 1,
      anon_sym_or,
    ACTIONS(1721), 1,
      anon_sym_if,
    ACTIONS(1737), 1,
      anon_sym_COLON,
    ACTIONS(1735), 2,
      anon_sym_COMMA,
      anon_sym_as,
  [34910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1739), 1,
      anon_sym_DOT,
    STATE(718), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(1687), 4,
      anon_sym_import,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [34926] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1742), 1,
      anon_sym_COLON,
    ACTIONS(857), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [34946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1746), 1,
      anon_sym_AT,
    STATE(720), 2,
      sym_decorator,
      aux_sym_decorated_definition_repeat1,
    ACTIONS(1744), 3,
      anon_sym_async,
      anon_sym_def,
      anon_sym_class,
  [34962] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1749), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
  [34980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1388), 6,
      anon_sym_COMMA,
      anon_sym_as,
      anon_sym_if,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
  [34992] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1711), 1,
      anon_sym_and,
    ACTIONS(1713), 1,
      anon_sym_or,
    ACTIONS(1721), 1,
      anon_sym_if,
    ACTIONS(1753), 1,
      anon_sym_as,
    ACTIONS(1751), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [35012] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1376), 1,
      anon_sym_if,
    ACTIONS(1378), 1,
      anon_sym_and,
    ACTIONS(1380), 1,
      anon_sym_or,
    ACTIONS(1755), 3,
      sym__newline,
      anon_sym_COMMA,
      sym__semicolon,
  [35030] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1757), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
  [35048] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1509), 1,
      anon_sym_RPAREN,
    ACTIONS(1511), 1,
      anon_sym_COMMA,
    STATE(890), 1,
      aux_sym_argument_list_repeat1,
  [35070] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1521), 1,
      anon_sym_RPAREN,
    ACTIONS(1523), 1,
      anon_sym_COMMA,
    STATE(843), 1,
      aux_sym_argument_list_repeat1,
  [35092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1723), 1,
      anon_sym_DOT,
    STATE(705), 1,
      aux_sym_dotted_name_repeat1,
    ACTIONS(1601), 4,
      anon_sym_import,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [35108] = 3,
    ACTIONS(1589), 1,
      sym_comment,
    ACTIONS(1761), 2,
      sym__string_content,
      sym__string_end,
    ACTIONS(1759), 3,
      anon_sym_LBRACE,
      sym_escape_sequence,
      sym__not_escape_sequence,
  [35121] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1763), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [35138] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 1,
      sym_identifier,
    STATE(782), 1,
      sym_dotted_name,
    STATE(829), 1,
      sym_aliased_import,
    ACTIONS(1765), 2,
      sym__newline,
      sym__semicolon,
  [35155] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1767), 1,
      anon_sym_RPAREN,
    ACTIONS(1769), 1,
      anon_sym_COMMA,
    ACTIONS(1771), 1,
      anon_sym_COLON,
    ACTIONS(1773), 1,
      anon_sym_EQ,
    STATE(858), 1,
      aux_sym__parameters_repeat1,
  [35174] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 1,
      sym_identifier,
    ACTIONS(1775), 1,
      anon_sym_LPAREN,
    STATE(741), 1,
      sym_dotted_name,
    STATE(774), 1,
      sym_aliased_import,
    STATE(934), 1,
      sym__import_list,
  [35193] = 3,
    ACTIONS(1589), 1,
      sym_comment,
    ACTIONS(1779), 2,
      sym__string_content,
      sym__string_end,
    ACTIONS(1777), 3,
      anon_sym_LBRACE,
      sym_escape_sequence,
      sym__not_escape_sequence,
  [35206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1781), 1,
      anon_sym_COMMA,
    STATE(737), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(415), 3,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [35221] = 5,
    ACTIONS(1589), 1,
      sym_comment,
    ACTIONS(1783), 1,
      anon_sym_LBRACE,
    ACTIONS(1785), 1,
      anon_sym_RBRACE,
    ACTIONS(1787), 1,
      aux_sym_format_specifier_token1,
    STATE(749), 2,
      sym_format_expression,
      aux_sym_format_specifier_repeat1,
  [35238] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1789), 1,
      anon_sym_COMMA,
    STATE(737), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(1400), 3,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [35253] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1376), 1,
      anon_sym_if,
    ACTIONS(1378), 1,
      anon_sym_and,
    ACTIONS(1380), 1,
      anon_sym_or,
    ACTIONS(1792), 2,
      sym__newline,
      sym__semicolon,
  [35270] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1794), 1,
      anon_sym_RPAREN,
    ACTIONS(1796), 1,
      anon_sym_COMMA,
    ACTIONS(1798), 1,
      anon_sym_COLON,
    ACTIONS(1800), 1,
      anon_sym_EQ,
    STATE(860), 1,
      aux_sym__parameters_repeat1,
  [35289] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 1,
      sym_identifier,
    STATE(782), 1,
      sym_dotted_name,
    STATE(829), 1,
      sym_aliased_import,
    ACTIONS(1802), 2,
      sym__newline,
      sym__semicolon,
  [35306] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    ACTIONS(1806), 1,
      anon_sym_as,
    STATE(803), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(1808), 2,
      sym__newline,
      sym__semicolon,
  [35323] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1376), 1,
      anon_sym_if,
    ACTIONS(1378), 1,
      anon_sym_and,
    ACTIONS(1380), 1,
      anon_sym_or,
    ACTIONS(1729), 2,
      sym__newline,
      sym__semicolon,
  [35340] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(826), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [35357] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(857), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [35374] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1810), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [35391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1812), 1,
      anon_sym_except,
    ACTIONS(1814), 1,
      anon_sym_finally,
    STATE(395), 1,
      sym_finally_clause,
    STATE(175), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
  [35408] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_except,
    ACTIONS(1818), 1,
      anon_sym_finally,
    STATE(419), 1,
      sym_finally_clause,
    STATE(165), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
  [35425] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1820), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [35442] = 5,
    ACTIONS(1589), 1,
      sym_comment,
    ACTIONS(1822), 1,
      anon_sym_LBRACE,
    ACTIONS(1825), 1,
      anon_sym_RBRACE,
    ACTIONS(1827), 1,
      aux_sym_format_specifier_token1,
    STATE(749), 2,
      sym_format_expression,
      aux_sym_format_specifier_repeat1,
  [35459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1687), 5,
      anon_sym_import,
      anon_sym_DOT,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_as,
  [35470] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1830), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [35487] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1376), 1,
      anon_sym_if,
    ACTIONS(1378), 1,
      anon_sym_and,
    ACTIONS(1380), 1,
      anon_sym_or,
    ACTIONS(1832), 2,
      sym__newline,
      sym__semicolon,
  [35504] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1834), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [35521] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1836), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [35538] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1812), 1,
      anon_sym_except,
    ACTIONS(1814), 1,
      anon_sym_finally,
    STATE(408), 1,
      sym_finally_clause,
    STATE(185), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
  [35555] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1816), 1,
      anon_sym_except,
    ACTIONS(1818), 1,
      anon_sym_finally,
    STATE(405), 1,
      sym_finally_clause,
    STATE(164), 2,
      sym_except_clause,
      aux_sym_try_statement_repeat1,
  [35572] = 5,
    ACTIONS(1589), 1,
      sym_comment,
    ACTIONS(1783), 1,
      anon_sym_LBRACE,
    ACTIONS(1838), 1,
      anon_sym_RBRACE,
    ACTIONS(1840), 1,
      aux_sym_format_specifier_token1,
    STATE(736), 2,
      sym_format_expression,
      aux_sym_format_specifier_repeat1,
  [35589] = 3,
    ACTIONS(1589), 1,
      sym_comment,
    ACTIONS(1844), 2,
      sym__string_content,
      sym__string_end,
    ACTIONS(1842), 3,
      anon_sym_LBRACE,
      sym_escape_sequence,
      sym__not_escape_sequence,
  [35602] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1794), 1,
      anon_sym_COLON,
    ACTIONS(1800), 1,
      anon_sym_EQ,
    ACTIONS(1846), 1,
      anon_sym_COMMA,
    STATE(806), 1,
      aux_sym__parameters_repeat1,
  [35618] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1848), 1,
      anon_sym_COMMA,
    STATE(768), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(1850), 2,
      sym__newline,
      sym__semicolon,
  [35632] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1798), 1,
      anon_sym_COLON,
    ACTIONS(1800), 1,
      anon_sym_EQ,
    ACTIONS(1852), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [35646] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1856), 1,
      anon_sym_DOT,
    STATE(762), 1,
      aux_sym_import_prefix_repeat1,
    ACTIONS(1854), 2,
      anon_sym_import,
      sym_identifier,
  [35660] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1859), 1,
      anon_sym_COLON,
  [35676] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1861), 1,
      anon_sym_COLON,
  [35692] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1865), 1,
      anon_sym_EQ,
    ACTIONS(1863), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
  [35704] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1765), 1,
      anon_sym_RPAREN,
    ACTIONS(1867), 1,
      sym_identifier,
    STATE(841), 1,
      sym_dotted_name,
    STATE(936), 1,
      sym_aliased_import,
  [35720] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1869), 1,
      anon_sym_else,
  [35736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1871), 1,
      anon_sym_COMMA,
    STATE(797), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(1873), 2,
      sym__newline,
      sym__semicolon,
  [35750] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 1,
      sym_identifier,
    STATE(741), 1,
      sym_dotted_name,
    STATE(774), 1,
      sym_aliased_import,
    STATE(927), 1,
      sym__import_list,
  [35766] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1875), 1,
      anon_sym_COMMA,
    STATE(785), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(517), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [35780] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1877), 1,
      anon_sym_COLON,
  [35796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1879), 4,
      anon_sym_async,
      anon_sym_def,
      anon_sym_class,
      anon_sym_AT,
  [35806] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1867), 1,
      sym_identifier,
    STATE(802), 1,
      sym_dotted_name,
    STATE(818), 1,
      sym_aliased_import,
    STATE(990), 1,
      sym__import_list,
  [35822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1804), 1,
      anon_sym_COMMA,
    STATE(803), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(1808), 2,
      sym__newline,
      sym__semicolon,
  [35836] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1794), 1,
      anon_sym_RPAREN,
    ACTIONS(1796), 1,
      anon_sym_COMMA,
    ACTIONS(1881), 1,
      anon_sym_COLON,
    STATE(860), 1,
      aux_sym__parameters_repeat1,
  [35852] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1883), 1,
      anon_sym_COMMA,
    STATE(776), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(1886), 2,
      sym__newline,
      sym__semicolon,
  [35866] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1888), 1,
      anon_sym_COLON,
  [35882] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1890), 1,
      anon_sym_COLON,
  [35898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1892), 1,
      anon_sym_COMMA,
    STATE(797), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(1894), 2,
      sym__newline,
      sym__semicolon,
  [35912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1505), 1,
      anon_sym_COMMA,
    STATE(770), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(1507), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [35926] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1896), 4,
      anon_sym_async,
      anon_sym_def,
      anon_sym_class,
      anon_sym_AT,
  [35936] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1806), 1,
      anon_sym_as,
    ACTIONS(1898), 3,
      sym__newline,
      anon_sym_COMMA,
      sym__semicolon,
  [35948] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1489), 1,
      anon_sym_COLON,
  [35964] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1767), 1,
      anon_sym_COLON,
    ACTIONS(1773), 1,
      anon_sym_EQ,
    ACTIONS(1900), 1,
      anon_sym_COMMA,
    STATE(820), 1,
      aux_sym__parameters_repeat1,
  [35980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1902), 1,
      anon_sym_COMMA,
    STATE(785), 1,
      aux_sym__collection_elements_repeat1,
    ACTIONS(1715), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [35994] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1867), 1,
      sym_identifier,
    STATE(802), 1,
      sym_dotted_name,
    STATE(818), 1,
      sym_aliased_import,
    STATE(1030), 1,
      sym__import_list,
  [36010] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1905), 1,
      anon_sym_COMMA,
    STATE(790), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(1907), 2,
      sym__newline,
      sym__semicolon,
  [36024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1905), 1,
      anon_sym_COMMA,
    STATE(789), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(1909), 2,
      sym__newline,
      sym__semicolon,
  [36038] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1905), 1,
      anon_sym_COMMA,
    STATE(776), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(1911), 2,
      sym__newline,
      sym__semicolon,
  [36052] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1905), 1,
      anon_sym_COMMA,
    STATE(776), 1,
      aux_sym_global_statement_repeat1,
    ACTIONS(1913), 2,
      sym__newline,
      sym__semicolon,
  [36066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1621), 1,
      anon_sym_COMMA,
    STATE(604), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(1915), 2,
      sym__newline,
      sym__semicolon,
  [36080] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1802), 1,
      anon_sym_RPAREN,
    ACTIONS(1867), 1,
      sym_identifier,
    STATE(841), 1,
      sym_dotted_name,
    STATE(936), 1,
      sym_aliased_import,
  [36096] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1917), 1,
      anon_sym_COLON,
  [36112] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1621), 1,
      anon_sym_COMMA,
    STATE(604), 1,
      aux_sym_assert_statement_repeat1,
    ACTIONS(1919), 2,
      sym__newline,
      sym__semicolon,
  [36126] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1921), 1,
      anon_sym_else,
  [36142] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1925), 1,
      anon_sym_DOT,
    STATE(762), 1,
      aux_sym_import_prefix_repeat1,
    ACTIONS(1923), 2,
      anon_sym_import,
      sym_identifier,
  [36156] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1927), 1,
      anon_sym_COMMA,
    STATE(797), 1,
      aux_sym_print_statement_repeat1,
    ACTIONS(1930), 2,
      sym__newline,
      sym__semicolon,
  [36170] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1932), 1,
      anon_sym_COLON,
  [36186] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1934), 1,
      anon_sym_else,
  [36202] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1771), 1,
      anon_sym_COLON,
    ACTIONS(1773), 1,
      anon_sym_EQ,
    ACTIONS(1936), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [36216] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1938), 1,
      anon_sym_RBRACE,
  [36232] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1808), 1,
      anon_sym_RPAREN,
    ACTIONS(1940), 1,
      anon_sym_COMMA,
    ACTIONS(1942), 1,
      anon_sym_as,
    STATE(811), 1,
      aux_sym__import_list_repeat1,
  [36248] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1944), 1,
      anon_sym_COMMA,
    STATE(804), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(1946), 2,
      sym__newline,
      sym__semicolon,
  [36262] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1948), 1,
      anon_sym_COMMA,
    STATE(804), 1,
      aux_sym__import_list_repeat1,
    ACTIONS(1951), 2,
      sym__newline,
      sym__semicolon,
  [36276] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1459), 1,
      anon_sym_and,
    ACTIONS(1461), 1,
      anon_sym_if,
    ACTIONS(1463), 1,
      anon_sym_or,
    ACTIONS(1953), 1,
      anon_sym_COLON,
  [36292] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1481), 1,
      anon_sym_COLON,
    ACTIONS(1955), 1,
      anon_sym_COMMA,
    STATE(882), 1,
      aux_sym__parameters_repeat1,
  [36305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1957), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [36314] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1719), 1,
      anon_sym_RBRACK,
    ACTIONS(1959), 1,
      anon_sym_COMMA,
    STATE(808), 1,
      aux_sym_subscript_repeat1,
  [36327] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1962), 1,
      anon_sym_RPAREN,
    ACTIONS(1964), 1,
      anon_sym_COMMA,
    STATE(868), 1,
      aux_sym_argument_list_repeat1,
  [36340] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1515), 1,
      anon_sym_RPAREN,
    ACTIONS(1517), 1,
      anon_sym_COMMA,
    STATE(881), 1,
      aux_sym_argument_list_repeat1,
  [36353] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1946), 1,
      anon_sym_RPAREN,
    ACTIONS(1966), 1,
      anon_sym_COMMA,
    STATE(845), 1,
      aux_sym__import_list_repeat1,
  [36366] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1968), 1,
      anon_sym_for,
    ACTIONS(1970), 1,
      anon_sym_with,
    ACTIONS(1972), 1,
      anon_sym_def,
  [36379] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1693), 1,
      sym_identifier,
    ACTIONS(1974), 1,
      anon_sym_import,
    STATE(1006), 1,
      sym_dotted_name,
  [36392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1976), 1,
      anon_sym_COMMA,
    ACTIONS(1978), 1,
      anon_sym_COLON,
    STATE(900), 1,
      aux_sym_with_statement_repeat1,
  [36405] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(710), 1,
      anon_sym_RBRACE,
    ACTIONS(1980), 1,
      anon_sym_COMMA,
    STATE(846), 1,
      aux_sym_dictionary_repeat1,
  [36418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1982), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [36427] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1485), 1,
      anon_sym_COLON,
    ACTIONS(1984), 1,
      anon_sym_COMMA,
    STATE(882), 1,
      aux_sym__parameters_repeat1,
  [36440] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1808), 1,
      anon_sym_RPAREN,
    ACTIONS(1940), 1,
      anon_sym_COMMA,
    STATE(811), 1,
      aux_sym__import_list_repeat1,
  [36453] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(820), 1,
      anon_sym_RBRACE,
    ACTIONS(1986), 1,
      anon_sym_COMMA,
    STATE(870), 1,
      aux_sym_set_repeat1,
  [36466] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1467), 1,
      anon_sym_COLON,
    ACTIONS(1988), 1,
      anon_sym_COMMA,
    STATE(882), 1,
      aux_sym__parameters_repeat1,
  [36479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(620), 3,
      sym__newline,
      anon_sym_in,
      sym__semicolon,
  [36488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(616), 3,
      sym__newline,
      anon_sym_in,
      sym__semicolon,
  [36497] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1664), 1,
      anon_sym_COMMA,
    ACTIONS(1666), 1,
      anon_sym_RBRACK,
    STATE(866), 1,
      aux_sym_subscript_repeat1,
  [36510] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1976), 1,
      anon_sym_COMMA,
    ACTIONS(1990), 1,
      anon_sym_COLON,
    STATE(900), 1,
      aux_sym_with_statement_repeat1,
  [36523] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1992), 1,
      anon_sym_COMMA,
    ACTIONS(1994), 1,
      anon_sym_RBRACK,
    STATE(808), 1,
      aux_sym_subscript_repeat1,
  [36536] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 1,
      sym_identifier,
    STATE(782), 1,
      sym_dotted_name,
    STATE(829), 1,
      sym_aliased_import,
  [36549] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(590), 1,
      anon_sym_RPAREN,
    ACTIONS(1996), 1,
      anon_sym_COMMA,
    STATE(876), 1,
      aux_sym_argument_list_repeat1,
  [36562] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1998), 1,
      sym__semicolon,
    ACTIONS(2000), 1,
      sym__newline,
    STATE(842), 1,
      aux_sym__simple_statements_repeat1,
  [36575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1898), 3,
      sym__newline,
      anon_sym_COMMA,
      sym__semicolon,
  [36584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(822), 1,
      anon_sym_RBRACE,
    ACTIONS(2002), 1,
      anon_sym_COMMA,
    STATE(870), 1,
      aux_sym_set_repeat1,
  [36597] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(726), 1,
      anon_sym_RBRACE,
    ACTIONS(2004), 1,
      anon_sym_COMMA,
    STATE(846), 1,
      aux_sym_dictionary_repeat1,
  [36610] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1505), 1,
      anon_sym_COMMA,
    ACTIONS(1513), 1,
      anon_sym_RPAREN,
    STATE(770), 1,
      aux_sym__collection_elements_repeat1,
  [36623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1976), 1,
      anon_sym_COMMA,
    ACTIONS(1990), 1,
      anon_sym_COLON,
    STATE(814), 1,
      aux_sym_with_statement_repeat1,
  [36636] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1794), 1,
      anon_sym_RPAREN,
    ACTIONS(1796), 1,
      anon_sym_COMMA,
    STATE(860), 1,
      aux_sym__parameters_repeat1,
  [36649] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2006), 1,
      sym__semicolon,
    ACTIONS(2008), 1,
      sym__newline,
    STATE(884), 1,
      aux_sym__simple_statements_repeat1,
  [36662] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2010), 1,
      anon_sym_LPAREN,
    ACTIONS(2012), 1,
      anon_sym_COLON,
    STATE(993), 1,
      sym_argument_list,
  [36675] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1501), 1,
      anon_sym_COMMA,
    ACTIONS(1503), 1,
      anon_sym_RBRACE,
    STATE(863), 1,
      aux_sym_set_repeat1,
  [36688] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1595), 1,
      anon_sym_COMMA,
    ACTIONS(1597), 1,
      anon_sym_RBRACE,
    STATE(865), 1,
      aux_sym_dictionary_repeat1,
  [36701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(409), 1,
      sym__newline,
    ACTIONS(2014), 1,
      sym__semicolon,
    STATE(862), 1,
      aux_sym__simple_statements_repeat1,
  [36714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1976), 1,
      anon_sym_COMMA,
    ACTIONS(2016), 1,
      anon_sym_COLON,
    STATE(824), 1,
      aux_sym_with_statement_repeat1,
  [36727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1942), 1,
      anon_sym_as,
    ACTIONS(1898), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [36738] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(401), 1,
      sym__newline,
    ACTIONS(2018), 1,
      sym__semicolon,
    STATE(862), 1,
      aux_sym__simple_statements_repeat1,
  [36751] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(507), 1,
      anon_sym_RPAREN,
    ACTIONS(2020), 1,
      anon_sym_COMMA,
    STATE(876), 1,
      aux_sym_argument_list_repeat1,
  [36764] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1886), 3,
      sym__newline,
      anon_sym_COMMA,
      sym__semicolon,
  [36773] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1951), 1,
      anon_sym_RPAREN,
    ACTIONS(2022), 1,
      anon_sym_COMMA,
    STATE(845), 1,
      aux_sym__import_list_repeat1,
  [36786] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2025), 1,
      anon_sym_COMMA,
    ACTIONS(2028), 1,
      anon_sym_RBRACE,
    STATE(846), 1,
      aux_sym_dictionary_repeat1,
  [36799] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1705), 1,
      anon_sym_COLON,
    ACTIONS(2030), 1,
      anon_sym_RBRACE,
    STATE(1029), 1,
      sym_format_specifier,
  [36812] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1976), 1,
      anon_sym_COMMA,
    ACTIONS(2032), 1,
      anon_sym_COLON,
    STATE(900), 1,
      aux_sym_with_statement_repeat1,
  [36825] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1411), 1,
      anon_sym_in,
    ACTIONS(2034), 1,
      anon_sym_COMMA,
    STATE(849), 1,
      aux_sym_variables_repeat1,
  [36838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1715), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [36847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1881), 1,
      anon_sym_COLON,
    ACTIONS(1852), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [36858] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1670), 1,
      anon_sym_COMMA,
    ACTIONS(1672), 1,
      anon_sym_RBRACE,
    STATE(815), 1,
      aux_sym_dictionary_repeat1,
  [36871] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1487), 1,
      anon_sym_COMMA,
    ACTIONS(1495), 1,
      anon_sym_RBRACE,
    STATE(819), 1,
      aux_sym_set_repeat1,
  [36884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1505), 1,
      anon_sym_COMMA,
    ACTIONS(2037), 1,
      anon_sym_RPAREN,
    STATE(770), 1,
      aux_sym__collection_elements_repeat1,
  [36897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1505), 1,
      anon_sym_COMMA,
    ACTIONS(1525), 1,
      anon_sym_RPAREN,
    STATE(770), 1,
      aux_sym__collection_elements_repeat1,
  [36910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1485), 1,
      anon_sym_RPAREN,
    ACTIONS(2039), 1,
      anon_sym_COMMA,
    STATE(886), 1,
      aux_sym__parameters_repeat1,
  [36923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2041), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [36932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1467), 1,
      anon_sym_RPAREN,
    ACTIONS(2043), 1,
      anon_sym_COMMA,
    STATE(886), 1,
      aux_sym__parameters_repeat1,
  [36945] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2045), 1,
      anon_sym_RPAREN,
    ACTIONS(2047), 1,
      anon_sym_COMMA,
    STATE(827), 1,
      aux_sym_argument_list_repeat1,
  [36958] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1481), 1,
      anon_sym_RPAREN,
    ACTIONS(2049), 1,
      anon_sym_COMMA,
    STATE(886), 1,
      aux_sym__parameters_repeat1,
  [36971] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1505), 1,
      anon_sym_COMMA,
    ACTIONS(2051), 1,
      anon_sym_RPAREN,
    STATE(770), 1,
      aux_sym__collection_elements_repeat1,
  [36984] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2053), 1,
      sym__semicolon,
    ACTIONS(2056), 1,
      sym__newline,
    STATE(862), 1,
      aux_sym__simple_statements_repeat1,
  [36997] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(816), 1,
      anon_sym_RBRACE,
    ACTIONS(2058), 1,
      anon_sym_COMMA,
    STATE(870), 1,
      aux_sym_set_repeat1,
  [37010] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2060), 1,
      sym__semicolon,
    ACTIONS(2062), 1,
      sym__newline,
    STATE(839), 1,
      aux_sym__simple_statements_repeat1,
  [37023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(764), 1,
      anon_sym_RBRACE,
    ACTIONS(2064), 1,
      anon_sym_COMMA,
    STATE(846), 1,
      aux_sym_dictionary_repeat1,
  [37036] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2066), 1,
      anon_sym_COMMA,
    ACTIONS(2068), 1,
      anon_sym_RBRACK,
    STATE(808), 1,
      aux_sym_subscript_repeat1,
  [37049] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1674), 1,
      anon_sym_COMMA,
    ACTIONS(1676), 1,
      anon_sym_RBRACK,
    STATE(825), 1,
      aux_sym_subscript_repeat1,
  [37062] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(592), 1,
      anon_sym_RPAREN,
    ACTIONS(2070), 1,
      anon_sym_COMMA,
    STATE(876), 1,
      aux_sym_argument_list_repeat1,
  [37075] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2072), 1,
      anon_sym_COMMA,
    ACTIONS(2074), 1,
      anon_sym_in,
    STATE(849), 1,
      aux_sym_variables_repeat1,
  [37088] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1810), 1,
      anon_sym_RBRACE,
    ACTIONS(2076), 1,
      anon_sym_COMMA,
    STATE(870), 1,
      aux_sym_set_repeat1,
  [37101] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1509), 1,
      anon_sym_RPAREN,
    ACTIONS(1511), 1,
      anon_sym_COMMA,
    STATE(890), 1,
      aux_sym_argument_list_repeat1,
  [37114] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2079), 1,
      anon_sym_RPAREN,
    ACTIONS(2081), 1,
      anon_sym_COMMA,
    STATE(892), 1,
      aux_sym_argument_list_repeat1,
  [37127] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1867), 1,
      sym_identifier,
    STATE(841), 1,
      sym_dotted_name,
    STATE(936), 1,
      sym_aliased_import,
  [37140] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1505), 1,
      anon_sym_COMMA,
    ACTIONS(1519), 1,
      anon_sym_RPAREN,
    STATE(770), 1,
      aux_sym__collection_elements_repeat1,
  [37153] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1609), 1,
      anon_sym_COMMA,
    ACTIONS(1613), 1,
      anon_sym_RBRACK,
    STATE(894), 1,
      aux_sym_subscript_repeat1,
  [37166] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1836), 1,
      anon_sym_RPAREN,
    ACTIONS(2083), 1,
      anon_sym_COMMA,
    STATE(876), 1,
      aux_sym_argument_list_repeat1,
  [37179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1863), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
  [37188] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1521), 1,
      anon_sym_RPAREN,
    ACTIONS(1523), 1,
      anon_sym_COMMA,
    STATE(843), 1,
      aux_sym_argument_list_repeat1,
  [37201] = 2,
    ACTIONS(1589), 1,
      sym_comment,
    ACTIONS(2086), 3,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_format_specifier_token1,
  [37210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2088), 1,
      anon_sym_EQ,
    ACTIONS(2090), 2,
      sym__newline,
      sym__semicolon,
  [37221] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(584), 1,
      anon_sym_RPAREN,
    ACTIONS(2092), 1,
      anon_sym_COMMA,
    STATE(876), 1,
      aux_sym_argument_list_repeat1,
  [37234] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_COLON,
    ACTIONS(2094), 1,
      anon_sym_COMMA,
    STATE(882), 1,
      aux_sym__parameters_repeat1,
  [37247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2097), 1,
      anon_sym_from,
    ACTIONS(2099), 2,
      sym__newline,
      sym__semicolon,
  [37258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(403), 1,
      sym__newline,
    ACTIONS(2101), 1,
      sym__semicolon,
    STATE(862), 1,
      aux_sym__simple_statements_repeat1,
  [37271] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1976), 1,
      anon_sym_COMMA,
    ACTIONS(2103), 1,
      anon_sym_COLON,
    STATE(900), 1,
      aux_sym_with_statement_repeat1,
  [37284] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 1,
      anon_sym_RPAREN,
    ACTIONS(2105), 1,
      anon_sym_COMMA,
    STATE(886), 1,
      aux_sym__parameters_repeat1,
  [37297] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_COLON,
  [37306] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1976), 1,
      anon_sym_COMMA,
    ACTIONS(2108), 1,
      anon_sym_COLON,
    STATE(848), 1,
      aux_sym_with_statement_repeat1,
  [37319] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1701), 1,
      anon_sym_COMMA,
    ACTIONS(1703), 1,
      anon_sym_RBRACE,
    STATE(831), 1,
      aux_sym_dictionary_repeat1,
  [37332] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(495), 1,
      anon_sym_RPAREN,
    ACTIONS(2110), 1,
      anon_sym_COMMA,
    STATE(876), 1,
      aux_sym_argument_list_repeat1,
  [37345] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1497), 1,
      anon_sym_COMMA,
    ACTIONS(1499), 1,
      anon_sym_RBRACE,
    STATE(830), 1,
      aux_sym_set_repeat1,
  [37358] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(499), 1,
      anon_sym_RPAREN,
    ACTIONS(2112), 1,
      anon_sym_COMMA,
    STATE(876), 1,
      aux_sym_argument_list_repeat1,
  [37371] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1800), 1,
      anon_sym_EQ,
    ACTIONS(1852), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [37382] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2114), 1,
      anon_sym_COMMA,
    ACTIONS(2116), 1,
      anon_sym_RBRACK,
    STATE(808), 1,
      aux_sym_subscript_repeat1,
  [37395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1773), 1,
      anon_sym_EQ,
    ACTIONS(1936), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [37406] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2118), 1,
      anon_sym_for,
    ACTIONS(2120), 1,
      anon_sym_with,
    ACTIONS(2122), 1,
      anon_sym_def,
  [37419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2124), 1,
      anon_sym_in,
    ACTIONS(2126), 2,
      sym__newline,
      sym__semicolon,
  [37430] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1794), 1,
      anon_sym_COLON,
    ACTIONS(1846), 1,
      anon_sym_COMMA,
    STATE(806), 1,
      aux_sym__parameters_repeat1,
  [37443] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1794), 1,
      anon_sym_COLON,
    ACTIONS(1846), 1,
      anon_sym_COMMA,
    STATE(806), 1,
      aux_sym__parameters_repeat1,
  [37456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2128), 1,
      anon_sym_COMMA,
    ACTIONS(2131), 1,
      anon_sym_COLON,
    STATE(900), 1,
      aux_sym_with_statement_repeat1,
  [37469] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1976), 1,
      anon_sym_COMMA,
    ACTIONS(2032), 1,
      anon_sym_COLON,
    STATE(885), 1,
      aux_sym_with_statement_repeat1,
  [37482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2010), 1,
      anon_sym_LPAREN,
    ACTIONS(2133), 1,
      anon_sym_COLON,
    STATE(1001), 1,
      sym_argument_list,
  [37495] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2135), 1,
      anon_sym_LPAREN,
    ACTIONS(2137), 1,
      sym__newline,
    STATE(997), 1,
      sym_argument_list,
  [37508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 3,
      sym__newline,
      anon_sym_COMMA,
      sym__semicolon,
  [37517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2141), 2,
      sym__newline,
      sym__semicolon,
  [37525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1719), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [37533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1982), 2,
      sym__newline,
      sym__semicolon,
  [37541] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2143), 2,
      sym__newline,
      sym__semicolon,
  [37549] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2145), 2,
      sym__newline,
      sym__semicolon,
  [37557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2147), 1,
      anon_sym_LPAREN,
    STATE(921), 1,
      sym_parameters,
  [37567] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(915), 2,
      anon_sym_except,
      anon_sym_finally,
  [37575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2149), 2,
      sym__newline,
      sym__semicolon,
  [37583] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2131), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [37591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1852), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
  [37599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2147), 1,
      anon_sym_LPAREN,
    STATE(939), 1,
      sym_parameters,
  [37609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2151), 2,
      sym__newline,
      sym__semicolon,
  [37617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2147), 1,
      anon_sym_LPAREN,
    STATE(941), 1,
      sym_parameters,
  [37627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2153), 2,
      sym__newline,
      sym__semicolon,
  [37635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2147), 1,
      anon_sym_LPAREN,
    STATE(937), 1,
      sym_parameters,
  [37645] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2155), 2,
      sym__newline,
      sym__semicolon,
  [37653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2157), 1,
      anon_sym_COLON,
    ACTIONS(2159), 1,
      anon_sym_DASH_GT,
  [37663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1810), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [37671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(900), 2,
      anon_sym_except,
      anon_sym_finally,
  [37679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2161), 2,
      sym__newline,
      sym__semicolon,
  [37687] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2163), 2,
      sym__newline,
      sym__semicolon,
  [37695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2165), 2,
      sym__newline,
      sym__semicolon,
  [37703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2167), 2,
      sym__newline,
      sym__semicolon,
  [37711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2056), 2,
      sym__newline,
      sym__semicolon,
  [37719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2028), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [37727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1392), 2,
      sym__newline,
      sym__semicolon,
  [37735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2169), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [37743] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1836), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [37751] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2139), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [37759] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2171), 2,
      sym__newline,
      sym__semicolon,
  [37767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2173), 2,
      sym__newline,
      sym__semicolon,
  [37775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1898), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [37783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2175), 1,
      anon_sym_COLON,
    ACTIONS(2177), 1,
      anon_sym_DASH_GT,
  [37793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2179), 2,
      sym__newline,
      sym__semicolon,
  [37801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2181), 1,
      anon_sym_COLON,
    ACTIONS(2183), 1,
      anon_sym_DASH_GT,
  [37811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(896), 2,
      anon_sym_except,
      anon_sym_finally,
  [37819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2185), 1,
      anon_sym_COLON,
    ACTIONS(2187), 1,
      anon_sym_DASH_GT,
  [37829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1650), 1,
      sym_identifier,
    STATE(903), 1,
      sym_dotted_name,
  [37839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(866), 2,
      anon_sym_except,
      anon_sym_finally,
  [37847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2189), 2,
      anon_sym_COLON,
      anon_sym_DASH_GT,
  [37855] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(922), 2,
      anon_sym_except,
      anon_sym_finally,
  [37863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2191), 2,
      anon_sym_COLON,
      anon_sym_DASH_GT,
  [37871] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2193), 1,
      anon_sym_RBRACK,
  [37878] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2195), 1,
      anon_sym_in,
  [37885] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2197), 1,
      anon_sym_RPAREN,
  [37892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2199), 1,
      anon_sym_RBRACK,
  [37899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2201), 1,
      anon_sym_RBRACK,
  [37906] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1672), 1,
      anon_sym_RBRACE,
  [37913] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2203), 1,
      anon_sym_import,
  [37920] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2205), 1,
      sym_identifier,
  [37927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2207), 1,
      anon_sym_RBRACE,
  [37934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2209), 1,
      anon_sym_RBRACE,
  [37941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2211), 1,
      anon_sym_RPAREN,
  [37948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2213), 1,
      anon_sym_in,
  [37955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1515), 1,
      anon_sym_RPAREN,
  [37962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2215), 1,
      anon_sym_COLON,
  [37969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1521), 1,
      anon_sym_RPAREN,
  [37976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2217), 1,
      anon_sym_RPAREN,
  [37983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2219), 1,
      sym_identifier,
  [37990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2221), 1,
      anon_sym_COLON,
  [37997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2223), 1,
      anon_sym_import,
  [38004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2225), 1,
      anon_sym_RPAREN,
  [38011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2227), 1,
      anon_sym_COLON,
  [38018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2229), 1,
      anon_sym_COLON,
  [38025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1703), 1,
      anon_sym_RBRACE,
  [38032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2231), 1,
      sym_identifier,
  [38039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1509), 1,
      anon_sym_RPAREN,
  [38046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2233), 1,
      anon_sym_in,
  [38053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2235), 1,
      anon_sym_RBRACE,
  [38060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2237), 1,
      anon_sym_RBRACE,
  [38067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2239), 1,
      anon_sym_RBRACK,
  [38074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2241), 1,
      anon_sym_RBRACE,
  [38081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2122), 1,
      anon_sym_def,
  [38088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2243), 1,
      anon_sym_RPAREN,
  [38095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2245), 1,
      sym_identifier,
  [38102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2247), 1,
      sym_identifier,
  [38109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2249), 1,
      anon_sym_in,
  [38116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2251), 1,
      sym_identifier,
  [38123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2253), 1,
      anon_sym_RBRACE,
  [38130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1597), 1,
      anon_sym_RBRACE,
  [38137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2255), 1,
      anon_sym_RBRACK,
  [38144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2030), 1,
      anon_sym_RBRACE,
  [38151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2257), 1,
      ts_builtin_sym_end,
  [38158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2259), 1,
      anon_sym_COLON,
  [38165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2261), 1,
      anon_sym_COLON,
  [38172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2263), 1,
      anon_sym_RPAREN,
  [38179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2265), 1,
      anon_sym_RBRACK,
  [38186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2267), 1,
      sym_identifier,
  [38193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2269), 1,
      anon_sym_COLON,
  [38200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2271), 1,
      anon_sym_in,
  [38207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2273), 1,
      sym_identifier,
  [38214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2275), 1,
      anon_sym_COLON,
  [38221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2277), 1,
      sym__newline,
  [38228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2279), 1,
      anon_sym_COLON,
  [38235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2281), 1,
      anon_sym_COLON,
  [38242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2283), 1,
      anon_sym_COLON,
  [38249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2285), 1,
      anon_sym_COLON,
  [38256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2287), 1,
      anon_sym_COLON,
  [38263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2289), 1,
      sym_identifier,
  [38270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2291), 1,
      anon_sym_COLON,
  [38277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2293), 1,
      anon_sym_COLON,
  [38284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2295), 1,
      anon_sym_import,
  [38291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2297), 1,
      sym_identifier,
  [38298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2299), 1,
      sym_identifier,
  [38305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2301), 1,
      sym_identifier,
  [38312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2303), 1,
      sym_identifier,
  [38319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2305), 1,
      anon_sym_COLON,
  [38326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2307), 1,
      anon_sym_COLON,
  [38333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2309), 1,
      sym_identifier,
  [38340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2311), 1,
      anon_sym_COLON,
  [38347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2313), 1,
      anon_sym_COLON,
  [38354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2315), 1,
      anon_sym_COLON,
  [38361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2317), 1,
      anon_sym_COLON,
  [38368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2319), 1,
      anon_sym_for,
  [38375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2321), 1,
      anon_sym_RPAREN,
  [38382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2323), 1,
      anon_sym_in,
  [38389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2325), 1,
      anon_sym_in,
  [38396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2327), 1,
      anon_sym_EQ,
  [38403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2329), 1,
      anon_sym_RPAREN,
  [38410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2331), 1,
      sym_identifier,
  [38417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2333), 1,
      sym_identifier,
  [38424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2335), 1,
      anon_sym_in,
  [38431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1972), 1,
      anon_sym_def,
  [38438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2337), 1,
      anon_sym_in,
  [38445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2339), 1,
      anon_sym_RBRACE,
  [38452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2341), 1,
      anon_sym_RPAREN,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(96)] = 0,
  [SMALL_STATE(97)] = 102,
  [SMALL_STATE(98)] = 204,
  [SMALL_STATE(99)] = 305,
  [SMALL_STATE(100)] = 406,
  [SMALL_STATE(101)] = 498,
  [SMALL_STATE(102)] = 590,
  [SMALL_STATE(103)] = 688,
  [SMALL_STATE(104)] = 786,
  [SMALL_STATE(105)] = 878,
  [SMALL_STATE(106)] = 976,
  [SMALL_STATE(107)] = 1074,
  [SMALL_STATE(108)] = 1166,
  [SMALL_STATE(109)] = 1264,
  [SMALL_STATE(110)] = 1327,
  [SMALL_STATE(111)] = 1422,
  [SMALL_STATE(112)] = 1517,
  [SMALL_STATE(113)] = 1612,
  [SMALL_STATE(114)] = 1705,
  [SMALL_STATE(115)] = 1800,
  [SMALL_STATE(116)] = 1895,
  [SMALL_STATE(117)] = 1990,
  [SMALL_STATE(118)] = 2085,
  [SMALL_STATE(119)] = 2180,
  [SMALL_STATE(120)] = 2273,
  [SMALL_STATE(121)] = 2370,
  [SMALL_STATE(122)] = 2465,
  [SMALL_STATE(123)] = 2560,
  [SMALL_STATE(124)] = 2659,
  [SMALL_STATE(125)] = 2722,
  [SMALL_STATE(126)] = 2817,
  [SMALL_STATE(127)] = 2908,
  [SMALL_STATE(128)] = 3003,
  [SMALL_STATE(129)] = 3100,
  [SMALL_STATE(130)] = 3199,
  [SMALL_STATE(131)] = 3296,
  [SMALL_STATE(132)] = 3391,
  [SMALL_STATE(133)] = 3490,
  [SMALL_STATE(134)] = 3589,
  [SMALL_STATE(135)] = 3684,
  [SMALL_STATE(136)] = 3747,
  [SMALL_STATE(137)] = 3842,
  [SMALL_STATE(138)] = 3937,
  [SMALL_STATE(139)] = 4011,
  [SMALL_STATE(140)] = 4079,
  [SMALL_STATE(141)] = 4171,
  [SMALL_STATE(142)] = 4239,
  [SMALL_STATE(143)] = 4329,
  [SMALL_STATE(144)] = 4401,
  [SMALL_STATE(145)] = 4481,
  [SMALL_STATE(146)] = 4549,
  [SMALL_STATE(147)] = 4619,
  [SMALL_STATE(148)] = 4699,
  [SMALL_STATE(149)] = 4777,
  [SMALL_STATE(150)] = 4853,
  [SMALL_STATE(151)] = 4943,
  [SMALL_STATE(152)] = 5033,
  [SMALL_STATE(153)] = 5094,
  [SMALL_STATE(154)] = 5183,
  [SMALL_STATE(155)] = 5240,
  [SMALL_STATE(156)] = 5297,
  [SMALL_STATE(157)] = 5356,
  [SMALL_STATE(158)] = 5445,
  [SMALL_STATE(159)] = 5501,
  [SMALL_STATE(160)] = 5557,
  [SMALL_STATE(161)] = 5613,
  [SMALL_STATE(162)] = 5669,
  [SMALL_STATE(163)] = 5725,
  [SMALL_STATE(164)] = 5813,
  [SMALL_STATE(165)] = 5881,
  [SMALL_STATE(166)] = 5949,
  [SMALL_STATE(167)] = 6005,
  [SMALL_STATE(168)] = 6061,
  [SMALL_STATE(169)] = 6117,
  [SMALL_STATE(170)] = 6173,
  [SMALL_STATE(171)] = 6229,
  [SMALL_STATE(172)] = 6285,
  [SMALL_STATE(173)] = 6341,
  [SMALL_STATE(174)] = 6397,
  [SMALL_STATE(175)] = 6453,
  [SMALL_STATE(176)] = 6521,
  [SMALL_STATE(177)] = 6577,
  [SMALL_STATE(178)] = 6665,
  [SMALL_STATE(179)] = 6721,
  [SMALL_STATE(180)] = 6809,
  [SMALL_STATE(181)] = 6865,
  [SMALL_STATE(182)] = 6921,
  [SMALL_STATE(183)] = 7009,
  [SMALL_STATE(184)] = 7065,
  [SMALL_STATE(185)] = 7121,
  [SMALL_STATE(186)] = 7189,
  [SMALL_STATE(187)] = 7245,
  [SMALL_STATE(188)] = 7301,
  [SMALL_STATE(189)] = 7389,
  [SMALL_STATE(190)] = 7445,
  [SMALL_STATE(191)] = 7501,
  [SMALL_STATE(192)] = 7585,
  [SMALL_STATE(193)] = 7641,
  [SMALL_STATE(194)] = 7725,
  [SMALL_STATE(195)] = 7781,
  [SMALL_STATE(196)] = 7869,
  [SMALL_STATE(197)] = 7925,
  [SMALL_STATE(198)] = 8013,
  [SMALL_STATE(199)] = 8101,
  [SMALL_STATE(200)] = 8157,
  [SMALL_STATE(201)] = 8213,
  [SMALL_STATE(202)] = 8269,
  [SMALL_STATE(203)] = 8356,
  [SMALL_STATE(204)] = 8443,
  [SMALL_STATE(205)] = 8526,
  [SMALL_STATE(206)] = 8611,
  [SMALL_STATE(207)] = 8698,
  [SMALL_STATE(208)] = 8783,
  [SMALL_STATE(209)] = 8870,
  [SMALL_STATE(210)] = 8955,
  [SMALL_STATE(211)] = 9042,
  [SMALL_STATE(212)] = 9129,
  [SMALL_STATE(213)] = 9216,
  [SMALL_STATE(214)] = 9303,
  [SMALL_STATE(215)] = 9390,
  [SMALL_STATE(216)] = 9477,
  [SMALL_STATE(217)] = 9564,
  [SMALL_STATE(218)] = 9651,
  [SMALL_STATE(219)] = 9738,
  [SMALL_STATE(220)] = 9823,
  [SMALL_STATE(221)] = 9910,
  [SMALL_STATE(222)] = 9992,
  [SMALL_STATE(223)] = 10074,
  [SMALL_STATE(224)] = 10132,
  [SMALL_STATE(225)] = 10196,
  [SMALL_STATE(226)] = 10278,
  [SMALL_STATE(227)] = 10360,
  [SMALL_STATE(228)] = 10444,
  [SMALL_STATE(229)] = 10508,
  [SMALL_STATE(230)] = 10572,
  [SMALL_STATE(231)] = 10654,
  [SMALL_STATE(232)] = 10738,
  [SMALL_STATE(233)] = 10802,
  [SMALL_STATE(234)] = 10884,
  [SMALL_STATE(235)] = 10948,
  [SMALL_STATE(236)] = 11030,
  [SMALL_STATE(237)] = 11112,
  [SMALL_STATE(238)] = 11194,
  [SMALL_STATE(239)] = 11276,
  [SMALL_STATE(240)] = 11358,
  [SMALL_STATE(241)] = 11442,
  [SMALL_STATE(242)] = 11506,
  [SMALL_STATE(243)] = 11570,
  [SMALL_STATE(244)] = 11634,
  [SMALL_STATE(245)] = 11716,
  [SMALL_STATE(246)] = 11800,
  [SMALL_STATE(247)] = 11858,
  [SMALL_STATE(248)] = 11942,
  [SMALL_STATE(249)] = 11995,
  [SMALL_STATE(250)] = 12076,
  [SMALL_STATE(251)] = 12157,
  [SMALL_STATE(252)] = 12238,
  [SMALL_STATE(253)] = 12319,
  [SMALL_STATE(254)] = 12400,
  [SMALL_STATE(255)] = 12481,
  [SMALL_STATE(256)] = 12562,
  [SMALL_STATE(257)] = 12643,
  [SMALL_STATE(258)] = 12724,
  [SMALL_STATE(259)] = 12805,
  [SMALL_STATE(260)] = 12886,
  [SMALL_STATE(261)] = 12967,
  [SMALL_STATE(262)] = 13048,
  [SMALL_STATE(263)] = 13101,
  [SMALL_STATE(264)] = 13182,
  [SMALL_STATE(265)] = 13263,
  [SMALL_STATE(266)] = 13316,
  [SMALL_STATE(267)] = 13397,
  [SMALL_STATE(268)] = 13450,
  [SMALL_STATE(269)] = 13503,
  [SMALL_STATE(270)] = 13584,
  [SMALL_STATE(271)] = 13643,
  [SMALL_STATE(272)] = 13724,
  [SMALL_STATE(273)] = 13777,
  [SMALL_STATE(274)] = 13830,
  [SMALL_STATE(275)] = 13889,
  [SMALL_STATE(276)] = 13970,
  [SMALL_STATE(277)] = 14023,
  [SMALL_STATE(278)] = 14076,
  [SMALL_STATE(279)] = 14157,
  [SMALL_STATE(280)] = 14210,
  [SMALL_STATE(281)] = 14288,
  [SMALL_STATE(282)] = 14340,
  [SMALL_STATE(283)] = 14418,
  [SMALL_STATE(284)] = 14496,
  [SMALL_STATE(285)] = 14574,
  [SMALL_STATE(286)] = 14626,
  [SMALL_STATE(287)] = 14704,
  [SMALL_STATE(288)] = 14782,
  [SMALL_STATE(289)] = 14860,
  [SMALL_STATE(290)] = 14912,
  [SMALL_STATE(291)] = 14990,
  [SMALL_STATE(292)] = 15068,
  [SMALL_STATE(293)] = 15146,
  [SMALL_STATE(294)] = 15224,
  [SMALL_STATE(295)] = 15276,
  [SMALL_STATE(296)] = 15354,
  [SMALL_STATE(297)] = 15432,
  [SMALL_STATE(298)] = 15510,
  [SMALL_STATE(299)] = 15588,
  [SMALL_STATE(300)] = 15640,
  [SMALL_STATE(301)] = 15718,
  [SMALL_STATE(302)] = 15796,
  [SMALL_STATE(303)] = 15874,
  [SMALL_STATE(304)] = 15952,
  [SMALL_STATE(305)] = 16030,
  [SMALL_STATE(306)] = 16108,
  [SMALL_STATE(307)] = 16186,
  [SMALL_STATE(308)] = 16238,
  [SMALL_STATE(309)] = 16316,
  [SMALL_STATE(310)] = 16394,
  [SMALL_STATE(311)] = 16472,
  [SMALL_STATE(312)] = 16550,
  [SMALL_STATE(313)] = 16628,
  [SMALL_STATE(314)] = 16706,
  [SMALL_STATE(315)] = 16784,
  [SMALL_STATE(316)] = 16862,
  [SMALL_STATE(317)] = 16940,
  [SMALL_STATE(318)] = 17018,
  [SMALL_STATE(319)] = 17096,
  [SMALL_STATE(320)] = 17174,
  [SMALL_STATE(321)] = 17252,
  [SMALL_STATE(322)] = 17304,
  [SMALL_STATE(323)] = 17356,
  [SMALL_STATE(324)] = 17434,
  [SMALL_STATE(325)] = 17486,
  [SMALL_STATE(326)] = 17564,
  [SMALL_STATE(327)] = 17616,
  [SMALL_STATE(328)] = 17668,
  [SMALL_STATE(329)] = 17746,
  [SMALL_STATE(330)] = 17824,
  [SMALL_STATE(331)] = 17902,
  [SMALL_STATE(332)] = 17980,
  [SMALL_STATE(333)] = 18058,
  [SMALL_STATE(334)] = 18136,
  [SMALL_STATE(335)] = 18214,
  [SMALL_STATE(336)] = 18292,
  [SMALL_STATE(337)] = 18370,
  [SMALL_STATE(338)] = 18448,
  [SMALL_STATE(339)] = 18526,
  [SMALL_STATE(340)] = 18604,
  [SMALL_STATE(341)] = 18656,
  [SMALL_STATE(342)] = 18734,
  [SMALL_STATE(343)] = 18812,
  [SMALL_STATE(344)] = 18890,
  [SMALL_STATE(345)] = 18968,
  [SMALL_STATE(346)] = 19046,
  [SMALL_STATE(347)] = 19124,
  [SMALL_STATE(348)] = 19202,
  [SMALL_STATE(349)] = 19280,
  [SMALL_STATE(350)] = 19358,
  [SMALL_STATE(351)] = 19413,
  [SMALL_STATE(352)] = 19464,
  [SMALL_STATE(353)] = 19519,
  [SMALL_STATE(354)] = 19574,
  [SMALL_STATE(355)] = 19625,
  [SMALL_STATE(356)] = 19676,
  [SMALL_STATE(357)] = 19731,
  [SMALL_STATE(358)] = 19782,
  [SMALL_STATE(359)] = 19837,
  [SMALL_STATE(360)] = 19892,
  [SMALL_STATE(361)] = 19947,
  [SMALL_STATE(362)] = 20002,
  [SMALL_STATE(363)] = 20053,
  [SMALL_STATE(364)] = 20104,
  [SMALL_STATE(365)] = 20159,
  [SMALL_STATE(366)] = 20214,
  [SMALL_STATE(367)] = 20269,
  [SMALL_STATE(368)] = 20324,
  [SMALL_STATE(369)] = 20379,
  [SMALL_STATE(370)] = 20434,
  [SMALL_STATE(371)] = 20489,
  [SMALL_STATE(372)] = 20544,
  [SMALL_STATE(373)] = 20594,
  [SMALL_STATE(374)] = 20644,
  [SMALL_STATE(375)] = 20698,
  [SMALL_STATE(376)] = 20748,
  [SMALL_STATE(377)] = 20802,
  [SMALL_STATE(378)] = 20856,
  [SMALL_STATE(379)] = 20940,
  [SMALL_STATE(380)] = 20990,
  [SMALL_STATE(381)] = 21039,
  [SMALL_STATE(382)] = 21104,
  [SMALL_STATE(383)] = 21153,
  [SMALL_STATE(384)] = 21202,
  [SMALL_STATE(385)] = 21251,
  [SMALL_STATE(386)] = 21300,
  [SMALL_STATE(387)] = 21349,
  [SMALL_STATE(388)] = 21398,
  [SMALL_STATE(389)] = 21447,
  [SMALL_STATE(390)] = 21496,
  [SMALL_STATE(391)] = 21545,
  [SMALL_STATE(392)] = 21594,
  [SMALL_STATE(393)] = 21643,
  [SMALL_STATE(394)] = 21692,
  [SMALL_STATE(395)] = 21741,
  [SMALL_STATE(396)] = 21790,
  [SMALL_STATE(397)] = 21839,
  [SMALL_STATE(398)] = 21888,
  [SMALL_STATE(399)] = 21937,
  [SMALL_STATE(400)] = 21986,
  [SMALL_STATE(401)] = 22035,
  [SMALL_STATE(402)] = 22084,
  [SMALL_STATE(403)] = 22157,
  [SMALL_STATE(404)] = 22206,
  [SMALL_STATE(405)] = 22255,
  [SMALL_STATE(406)] = 22304,
  [SMALL_STATE(407)] = 22353,
  [SMALL_STATE(408)] = 22402,
  [SMALL_STATE(409)] = 22451,
  [SMALL_STATE(410)] = 22500,
  [SMALL_STATE(411)] = 22549,
  [SMALL_STATE(412)] = 22598,
  [SMALL_STATE(413)] = 22647,
  [SMALL_STATE(414)] = 22714,
  [SMALL_STATE(415)] = 22783,
  [SMALL_STATE(416)] = 22854,
  [SMALL_STATE(417)] = 22903,
  [SMALL_STATE(418)] = 22952,
  [SMALL_STATE(419)] = 23015,
  [SMALL_STATE(420)] = 23064,
  [SMALL_STATE(421)] = 23123,
  [SMALL_STATE(422)] = 23196,
  [SMALL_STATE(423)] = 23245,
  [SMALL_STATE(424)] = 23294,
  [SMALL_STATE(425)] = 23343,
  [SMALL_STATE(426)] = 23402,
  [SMALL_STATE(427)] = 23451,
  [SMALL_STATE(428)] = 23500,
  [SMALL_STATE(429)] = 23549,
  [SMALL_STATE(430)] = 23598,
  [SMALL_STATE(431)] = 23647,
  [SMALL_STATE(432)] = 23706,
  [SMALL_STATE(433)] = 23755,
  [SMALL_STATE(434)] = 23804,
  [SMALL_STATE(435)] = 23853,
  [SMALL_STATE(436)] = 23902,
  [SMALL_STATE(437)] = 23951,
  [SMALL_STATE(438)] = 24000,
  [SMALL_STATE(439)] = 24049,
  [SMALL_STATE(440)] = 24098,
  [SMALL_STATE(441)] = 24147,
  [SMALL_STATE(442)] = 24196,
  [SMALL_STATE(443)] = 24245,
  [SMALL_STATE(444)] = 24294,
  [SMALL_STATE(445)] = 24343,
  [SMALL_STATE(446)] = 24392,
  [SMALL_STATE(447)] = 24441,
  [SMALL_STATE(448)] = 24490,
  [SMALL_STATE(449)] = 24539,
  [SMALL_STATE(450)] = 24588,
  [SMALL_STATE(451)] = 24637,
  [SMALL_STATE(452)] = 24686,
  [SMALL_STATE(453)] = 24735,
  [SMALL_STATE(454)] = 24784,
  [SMALL_STATE(455)] = 24833,
  [SMALL_STATE(456)] = 24882,
  [SMALL_STATE(457)] = 24931,
  [SMALL_STATE(458)] = 24980,
  [SMALL_STATE(459)] = 25029,
  [SMALL_STATE(460)] = 25078,
  [SMALL_STATE(461)] = 25127,
  [SMALL_STATE(462)] = 25176,
  [SMALL_STATE(463)] = 25225,
  [SMALL_STATE(464)] = 25274,
  [SMALL_STATE(465)] = 25324,
  [SMALL_STATE(466)] = 25372,
  [SMALL_STATE(467)] = 25420,
  [SMALL_STATE(468)] = 25467,
  [SMALL_STATE(469)] = 25514,
  [SMALL_STATE(470)] = 25561,
  [SMALL_STATE(471)] = 25608,
  [SMALL_STATE(472)] = 25655,
  [SMALL_STATE(473)] = 25702,
  [SMALL_STATE(474)] = 25749,
  [SMALL_STATE(475)] = 25796,
  [SMALL_STATE(476)] = 25843,
  [SMALL_STATE(477)] = 25890,
  [SMALL_STATE(478)] = 25937,
  [SMALL_STATE(479)] = 25984,
  [SMALL_STATE(480)] = 26031,
  [SMALL_STATE(481)] = 26078,
  [SMALL_STATE(482)] = 26125,
  [SMALL_STATE(483)] = 26172,
  [SMALL_STATE(484)] = 26219,
  [SMALL_STATE(485)] = 26266,
  [SMALL_STATE(486)] = 26313,
  [SMALL_STATE(487)] = 26360,
  [SMALL_STATE(488)] = 26407,
  [SMALL_STATE(489)] = 26454,
  [SMALL_STATE(490)] = 26501,
  [SMALL_STATE(491)] = 26548,
  [SMALL_STATE(492)] = 26595,
  [SMALL_STATE(493)] = 26642,
  [SMALL_STATE(494)] = 26689,
  [SMALL_STATE(495)] = 26736,
  [SMALL_STATE(496)] = 26783,
  [SMALL_STATE(497)] = 26830,
  [SMALL_STATE(498)] = 26877,
  [SMALL_STATE(499)] = 26952,
  [SMALL_STATE(500)] = 26999,
  [SMALL_STATE(501)] = 27046,
  [SMALL_STATE(502)] = 27093,
  [SMALL_STATE(503)] = 27153,
  [SMALL_STATE(504)] = 27205,
  [SMALL_STATE(505)] = 27265,
  [SMALL_STATE(506)] = 27325,
  [SMALL_STATE(507)] = 27369,
  [SMALL_STATE(508)] = 27429,
  [SMALL_STATE(509)] = 27495,
  [SMALL_STATE(510)] = 27555,
  [SMALL_STATE(511)] = 27615,
  [SMALL_STATE(512)] = 27675,
  [SMALL_STATE(513)] = 27735,
  [SMALL_STATE(514)] = 27795,
  [SMALL_STATE(515)] = 27855,
  [SMALL_STATE(516)] = 27915,
  [SMALL_STATE(517)] = 27977,
  [SMALL_STATE(518)] = 28037,
  [SMALL_STATE(519)] = 28101,
  [SMALL_STATE(520)] = 28157,
  [SMALL_STATE(521)] = 28209,
  [SMALL_STATE(522)] = 28267,
  [SMALL_STATE(523)] = 28333,
  [SMALL_STATE(524)] = 28385,
  [SMALL_STATE(525)] = 28442,
  [SMALL_STATE(526)] = 28499,
  [SMALL_STATE(527)] = 28556,
  [SMALL_STATE(528)] = 28613,
  [SMALL_STATE(529)] = 28670,
  [SMALL_STATE(530)] = 28727,
  [SMALL_STATE(531)] = 28778,
  [SMALL_STATE(532)] = 28835,
  [SMALL_STATE(533)] = 28892,
  [SMALL_STATE(534)] = 28949,
  [SMALL_STATE(535)] = 29006,
  [SMALL_STATE(536)] = 29047,
  [SMALL_STATE(537)] = 29104,
  [SMALL_STATE(538)] = 29161,
  [SMALL_STATE(539)] = 29218,
  [SMALL_STATE(540)] = 29261,
  [SMALL_STATE(541)] = 29318,
  [SMALL_STATE(542)] = 29375,
  [SMALL_STATE(543)] = 29416,
  [SMALL_STATE(544)] = 29467,
  [SMALL_STATE(545)] = 29524,
  [SMALL_STATE(546)] = 29581,
  [SMALL_STATE(547)] = 29638,
  [SMALL_STATE(548)] = 29695,
  [SMALL_STATE(549)] = 29752,
  [SMALL_STATE(550)] = 29809,
  [SMALL_STATE(551)] = 29866,
  [SMALL_STATE(552)] = 29923,
  [SMALL_STATE(553)] = 29980,
  [SMALL_STATE(554)] = 30037,
  [SMALL_STATE(555)] = 30094,
  [SMALL_STATE(556)] = 30151,
  [SMALL_STATE(557)] = 30208,
  [SMALL_STATE(558)] = 30265,
  [SMALL_STATE(559)] = 30322,
  [SMALL_STATE(560)] = 30379,
  [SMALL_STATE(561)] = 30419,
  [SMALL_STATE(562)] = 30459,
  [SMALL_STATE(563)] = 30499,
  [SMALL_STATE(564)] = 30539,
  [SMALL_STATE(565)] = 30579,
  [SMALL_STATE(566)] = 30619,
  [SMALL_STATE(567)] = 30659,
  [SMALL_STATE(568)] = 30699,
  [SMALL_STATE(569)] = 30739,
  [SMALL_STATE(570)] = 30779,
  [SMALL_STATE(571)] = 30819,
  [SMALL_STATE(572)] = 30859,
  [SMALL_STATE(573)] = 30899,
  [SMALL_STATE(574)] = 30939,
  [SMALL_STATE(575)] = 30979,
  [SMALL_STATE(576)] = 31019,
  [SMALL_STATE(577)] = 31059,
  [SMALL_STATE(578)] = 31099,
  [SMALL_STATE(579)] = 31139,
  [SMALL_STATE(580)] = 31179,
  [SMALL_STATE(581)] = 31219,
  [SMALL_STATE(582)] = 31259,
  [SMALL_STATE(583)] = 31299,
  [SMALL_STATE(584)] = 31339,
  [SMALL_STATE(585)] = 31379,
  [SMALL_STATE(586)] = 31419,
  [SMALL_STATE(587)] = 31459,
  [SMALL_STATE(588)] = 31499,
  [SMALL_STATE(589)] = 31539,
  [SMALL_STATE(590)] = 31579,
  [SMALL_STATE(591)] = 31621,
  [SMALL_STATE(592)] = 31663,
  [SMALL_STATE(593)] = 31702,
  [SMALL_STATE(594)] = 31732,
  [SMALL_STATE(595)] = 31764,
  [SMALL_STATE(596)] = 31792,
  [SMALL_STATE(597)] = 31826,
  [SMALL_STATE(598)] = 31854,
  [SMALL_STATE(599)] = 31894,
  [SMALL_STATE(600)] = 31928,
  [SMALL_STATE(601)] = 31962,
  [SMALL_STATE(602)] = 31994,
  [SMALL_STATE(603)] = 32028,
  [SMALL_STATE(604)] = 32083,
  [SMALL_STATE(605)] = 32113,
  [SMALL_STATE(606)] = 32143,
  [SMALL_STATE(607)] = 32193,
  [SMALL_STATE(608)] = 32224,
  [SMALL_STATE(609)] = 32257,
  [SMALL_STATE(610)] = 32290,
  [SMALL_STATE(611)] = 32319,
  [SMALL_STATE(612)] = 32358,
  [SMALL_STATE(613)] = 32397,
  [SMALL_STATE(614)] = 32422,
  [SMALL_STATE(615)] = 32461,
  [SMALL_STATE(616)] = 32500,
  [SMALL_STATE(617)] = 32536,
  [SMALL_STATE(618)] = 32557,
  [SMALL_STATE(619)] = 32582,
  [SMALL_STATE(620)] = 32615,
  [SMALL_STATE(621)] = 32648,
  [SMALL_STATE(622)] = 32673,
  [SMALL_STATE(623)] = 32698,
  [SMALL_STATE(624)] = 32731,
  [SMALL_STATE(625)] = 32764,
  [SMALL_STATE(626)] = 32797,
  [SMALL_STATE(627)] = 32830,
  [SMALL_STATE(628)] = 32853,
  [SMALL_STATE(629)] = 32886,
  [SMALL_STATE(630)] = 32919,
  [SMALL_STATE(631)] = 32938,
  [SMALL_STATE(632)] = 32971,
  [SMALL_STATE(633)] = 33004,
  [SMALL_STATE(634)] = 33037,
  [SMALL_STATE(635)] = 33060,
  [SMALL_STATE(636)] = 33093,
  [SMALL_STATE(637)] = 33112,
  [SMALL_STATE(638)] = 33142,
  [SMALL_STATE(639)] = 33172,
  [SMALL_STATE(640)] = 33209,
  [SMALL_STATE(641)] = 33246,
  [SMALL_STATE(642)] = 33283,
  [SMALL_STATE(643)] = 33317,
  [SMALL_STATE(644)] = 33351,
  [SMALL_STATE(645)] = 33385,
  [SMALL_STATE(646)] = 33419,
  [SMALL_STATE(647)] = 33453,
  [SMALL_STATE(648)] = 33487,
  [SMALL_STATE(649)] = 33521,
  [SMALL_STATE(650)] = 33555,
  [SMALL_STATE(651)] = 33589,
  [SMALL_STATE(652)] = 33612,
  [SMALL_STATE(653)] = 33631,
  [SMALL_STATE(654)] = 33650,
  [SMALL_STATE(655)] = 33673,
  [SMALL_STATE(656)] = 33696,
  [SMALL_STATE(657)] = 33715,
  [SMALL_STATE(658)] = 33739,
  [SMALL_STATE(659)] = 33757,
  [SMALL_STATE(660)] = 33775,
  [SMALL_STATE(661)] = 33793,
  [SMALL_STATE(662)] = 33813,
  [SMALL_STATE(663)] = 33837,
  [SMALL_STATE(664)] = 33861,
  [SMALL_STATE(665)] = 33879,
  [SMALL_STATE(666)] = 33897,
  [SMALL_STATE(667)] = 33915,
  [SMALL_STATE(668)] = 33936,
  [SMALL_STATE(669)] = 33961,
  [SMALL_STATE(670)] = 33978,
  [SMALL_STATE(671)] = 33999,
  [SMALL_STATE(672)] = 34024,
  [SMALL_STATE(673)] = 34045,
  [SMALL_STATE(674)] = 34068,
  [SMALL_STATE(675)] = 34091,
  [SMALL_STATE(676)] = 34112,
  [SMALL_STATE(677)] = 34133,
  [SMALL_STATE(678)] = 34154,
  [SMALL_STATE(679)] = 34173,
  [SMALL_STATE(680)] = 34196,
  [SMALL_STATE(681)] = 34219,
  [SMALL_STATE(682)] = 34240,
  [SMALL_STATE(683)] = 34265,
  [SMALL_STATE(684)] = 34284,
  [SMALL_STATE(685)] = 34309,
  [SMALL_STATE(686)] = 34334,
  [SMALL_STATE(687)] = 34355,
  [SMALL_STATE(688)] = 34374,
  [SMALL_STATE(689)] = 34395,
  [SMALL_STATE(690)] = 34408,
  [SMALL_STATE(691)] = 34425,
  [SMALL_STATE(692)] = 34438,
  [SMALL_STATE(693)] = 34457,
  [SMALL_STATE(694)] = 34474,
  [SMALL_STATE(695)] = 34497,
  [SMALL_STATE(696)] = 34510,
  [SMALL_STATE(697)] = 34535,
  [SMALL_STATE(698)] = 34560,
  [SMALL_STATE(699)] = 34576,
  [SMALL_STATE(700)] = 34594,
  [SMALL_STATE(701)] = 34616,
  [SMALL_STATE(702)] = 34634,
  [SMALL_STATE(703)] = 34652,
  [SMALL_STATE(704)] = 34672,
  [SMALL_STATE(705)] = 34690,
  [SMALL_STATE(706)] = 34706,
  [SMALL_STATE(707)] = 34724,
  [SMALL_STATE(708)] = 34744,
  [SMALL_STATE(709)] = 34762,
  [SMALL_STATE(710)] = 34776,
  [SMALL_STATE(711)] = 34796,
  [SMALL_STATE(712)] = 34808,
  [SMALL_STATE(713)] = 34824,
  [SMALL_STATE(714)] = 34842,
  [SMALL_STATE(715)] = 34860,
  [SMALL_STATE(716)] = 34872,
  [SMALL_STATE(717)] = 34890,
  [SMALL_STATE(718)] = 34910,
  [SMALL_STATE(719)] = 34926,
  [SMALL_STATE(720)] = 34946,
  [SMALL_STATE(721)] = 34962,
  [SMALL_STATE(722)] = 34980,
  [SMALL_STATE(723)] = 34992,
  [SMALL_STATE(724)] = 35012,
  [SMALL_STATE(725)] = 35030,
  [SMALL_STATE(726)] = 35048,
  [SMALL_STATE(727)] = 35070,
  [SMALL_STATE(728)] = 35092,
  [SMALL_STATE(729)] = 35108,
  [SMALL_STATE(730)] = 35121,
  [SMALL_STATE(731)] = 35138,
  [SMALL_STATE(732)] = 35155,
  [SMALL_STATE(733)] = 35174,
  [SMALL_STATE(734)] = 35193,
  [SMALL_STATE(735)] = 35206,
  [SMALL_STATE(736)] = 35221,
  [SMALL_STATE(737)] = 35238,
  [SMALL_STATE(738)] = 35253,
  [SMALL_STATE(739)] = 35270,
  [SMALL_STATE(740)] = 35289,
  [SMALL_STATE(741)] = 35306,
  [SMALL_STATE(742)] = 35323,
  [SMALL_STATE(743)] = 35340,
  [SMALL_STATE(744)] = 35357,
  [SMALL_STATE(745)] = 35374,
  [SMALL_STATE(746)] = 35391,
  [SMALL_STATE(747)] = 35408,
  [SMALL_STATE(748)] = 35425,
  [SMALL_STATE(749)] = 35442,
  [SMALL_STATE(750)] = 35459,
  [SMALL_STATE(751)] = 35470,
  [SMALL_STATE(752)] = 35487,
  [SMALL_STATE(753)] = 35504,
  [SMALL_STATE(754)] = 35521,
  [SMALL_STATE(755)] = 35538,
  [SMALL_STATE(756)] = 35555,
  [SMALL_STATE(757)] = 35572,
  [SMALL_STATE(758)] = 35589,
  [SMALL_STATE(759)] = 35602,
  [SMALL_STATE(760)] = 35618,
  [SMALL_STATE(761)] = 35632,
  [SMALL_STATE(762)] = 35646,
  [SMALL_STATE(763)] = 35660,
  [SMALL_STATE(764)] = 35676,
  [SMALL_STATE(765)] = 35692,
  [SMALL_STATE(766)] = 35704,
  [SMALL_STATE(767)] = 35720,
  [SMALL_STATE(768)] = 35736,
  [SMALL_STATE(769)] = 35750,
  [SMALL_STATE(770)] = 35766,
  [SMALL_STATE(771)] = 35780,
  [SMALL_STATE(772)] = 35796,
  [SMALL_STATE(773)] = 35806,
  [SMALL_STATE(774)] = 35822,
  [SMALL_STATE(775)] = 35836,
  [SMALL_STATE(776)] = 35852,
  [SMALL_STATE(777)] = 35866,
  [SMALL_STATE(778)] = 35882,
  [SMALL_STATE(779)] = 35898,
  [SMALL_STATE(780)] = 35912,
  [SMALL_STATE(781)] = 35926,
  [SMALL_STATE(782)] = 35936,
  [SMALL_STATE(783)] = 35948,
  [SMALL_STATE(784)] = 35964,
  [SMALL_STATE(785)] = 35980,
  [SMALL_STATE(786)] = 35994,
  [SMALL_STATE(787)] = 36010,
  [SMALL_STATE(788)] = 36024,
  [SMALL_STATE(789)] = 36038,
  [SMALL_STATE(790)] = 36052,
  [SMALL_STATE(791)] = 36066,
  [SMALL_STATE(792)] = 36080,
  [SMALL_STATE(793)] = 36096,
  [SMALL_STATE(794)] = 36112,
  [SMALL_STATE(795)] = 36126,
  [SMALL_STATE(796)] = 36142,
  [SMALL_STATE(797)] = 36156,
  [SMALL_STATE(798)] = 36170,
  [SMALL_STATE(799)] = 36186,
  [SMALL_STATE(800)] = 36202,
  [SMALL_STATE(801)] = 36216,
  [SMALL_STATE(802)] = 36232,
  [SMALL_STATE(803)] = 36248,
  [SMALL_STATE(804)] = 36262,
  [SMALL_STATE(805)] = 36276,
  [SMALL_STATE(806)] = 36292,
  [SMALL_STATE(807)] = 36305,
  [SMALL_STATE(808)] = 36314,
  [SMALL_STATE(809)] = 36327,
  [SMALL_STATE(810)] = 36340,
  [SMALL_STATE(811)] = 36353,
  [SMALL_STATE(812)] = 36366,
  [SMALL_STATE(813)] = 36379,
  [SMALL_STATE(814)] = 36392,
  [SMALL_STATE(815)] = 36405,
  [SMALL_STATE(816)] = 36418,
  [SMALL_STATE(817)] = 36427,
  [SMALL_STATE(818)] = 36440,
  [SMALL_STATE(819)] = 36453,
  [SMALL_STATE(820)] = 36466,
  [SMALL_STATE(821)] = 36479,
  [SMALL_STATE(822)] = 36488,
  [SMALL_STATE(823)] = 36497,
  [SMALL_STATE(824)] = 36510,
  [SMALL_STATE(825)] = 36523,
  [SMALL_STATE(826)] = 36536,
  [SMALL_STATE(827)] = 36549,
  [SMALL_STATE(828)] = 36562,
  [SMALL_STATE(829)] = 36575,
  [SMALL_STATE(830)] = 36584,
  [SMALL_STATE(831)] = 36597,
  [SMALL_STATE(832)] = 36610,
  [SMALL_STATE(833)] = 36623,
  [SMALL_STATE(834)] = 36636,
  [SMALL_STATE(835)] = 36649,
  [SMALL_STATE(836)] = 36662,
  [SMALL_STATE(837)] = 36675,
  [SMALL_STATE(838)] = 36688,
  [SMALL_STATE(839)] = 36701,
  [SMALL_STATE(840)] = 36714,
  [SMALL_STATE(841)] = 36727,
  [SMALL_STATE(842)] = 36738,
  [SMALL_STATE(843)] = 36751,
  [SMALL_STATE(844)] = 36764,
  [SMALL_STATE(845)] = 36773,
  [SMALL_STATE(846)] = 36786,
  [SMALL_STATE(847)] = 36799,
  [SMALL_STATE(848)] = 36812,
  [SMALL_STATE(849)] = 36825,
  [SMALL_STATE(850)] = 36838,
  [SMALL_STATE(851)] = 36847,
  [SMALL_STATE(852)] = 36858,
  [SMALL_STATE(853)] = 36871,
  [SMALL_STATE(854)] = 36884,
  [SMALL_STATE(855)] = 36897,
  [SMALL_STATE(856)] = 36910,
  [SMALL_STATE(857)] = 36923,
  [SMALL_STATE(858)] = 36932,
  [SMALL_STATE(859)] = 36945,
  [SMALL_STATE(860)] = 36958,
  [SMALL_STATE(861)] = 36971,
  [SMALL_STATE(862)] = 36984,
  [SMALL_STATE(863)] = 36997,
  [SMALL_STATE(864)] = 37010,
  [SMALL_STATE(865)] = 37023,
  [SMALL_STATE(866)] = 37036,
  [SMALL_STATE(867)] = 37049,
  [SMALL_STATE(868)] = 37062,
  [SMALL_STATE(869)] = 37075,
  [SMALL_STATE(870)] = 37088,
  [SMALL_STATE(871)] = 37101,
  [SMALL_STATE(872)] = 37114,
  [SMALL_STATE(873)] = 37127,
  [SMALL_STATE(874)] = 37140,
  [SMALL_STATE(875)] = 37153,
  [SMALL_STATE(876)] = 37166,
  [SMALL_STATE(877)] = 37179,
  [SMALL_STATE(878)] = 37188,
  [SMALL_STATE(879)] = 37201,
  [SMALL_STATE(880)] = 37210,
  [SMALL_STATE(881)] = 37221,
  [SMALL_STATE(882)] = 37234,
  [SMALL_STATE(883)] = 37247,
  [SMALL_STATE(884)] = 37258,
  [SMALL_STATE(885)] = 37271,
  [SMALL_STATE(886)] = 37284,
  [SMALL_STATE(887)] = 37297,
  [SMALL_STATE(888)] = 37306,
  [SMALL_STATE(889)] = 37319,
  [SMALL_STATE(890)] = 37332,
  [SMALL_STATE(891)] = 37345,
  [SMALL_STATE(892)] = 37358,
  [SMALL_STATE(893)] = 37371,
  [SMALL_STATE(894)] = 37382,
  [SMALL_STATE(895)] = 37395,
  [SMALL_STATE(896)] = 37406,
  [SMALL_STATE(897)] = 37419,
  [SMALL_STATE(898)] = 37430,
  [SMALL_STATE(899)] = 37443,
  [SMALL_STATE(900)] = 37456,
  [SMALL_STATE(901)] = 37469,
  [SMALL_STATE(902)] = 37482,
  [SMALL_STATE(903)] = 37495,
  [SMALL_STATE(904)] = 37508,
  [SMALL_STATE(905)] = 37517,
  [SMALL_STATE(906)] = 37525,
  [SMALL_STATE(907)] = 37533,
  [SMALL_STATE(908)] = 37541,
  [SMALL_STATE(909)] = 37549,
  [SMALL_STATE(910)] = 37557,
  [SMALL_STATE(911)] = 37567,
  [SMALL_STATE(912)] = 37575,
  [SMALL_STATE(913)] = 37583,
  [SMALL_STATE(914)] = 37591,
  [SMALL_STATE(915)] = 37599,
  [SMALL_STATE(916)] = 37609,
  [SMALL_STATE(917)] = 37617,
  [SMALL_STATE(918)] = 37627,
  [SMALL_STATE(919)] = 37635,
  [SMALL_STATE(920)] = 37645,
  [SMALL_STATE(921)] = 37653,
  [SMALL_STATE(922)] = 37663,
  [SMALL_STATE(923)] = 37671,
  [SMALL_STATE(924)] = 37679,
  [SMALL_STATE(925)] = 37687,
  [SMALL_STATE(926)] = 37695,
  [SMALL_STATE(927)] = 37703,
  [SMALL_STATE(928)] = 37711,
  [SMALL_STATE(929)] = 37719,
  [SMALL_STATE(930)] = 37727,
  [SMALL_STATE(931)] = 37735,
  [SMALL_STATE(932)] = 37743,
  [SMALL_STATE(933)] = 37751,
  [SMALL_STATE(934)] = 37759,
  [SMALL_STATE(935)] = 37767,
  [SMALL_STATE(936)] = 37775,
  [SMALL_STATE(937)] = 37783,
  [SMALL_STATE(938)] = 37793,
  [SMALL_STATE(939)] = 37801,
  [SMALL_STATE(940)] = 37811,
  [SMALL_STATE(941)] = 37819,
  [SMALL_STATE(942)] = 37829,
  [SMALL_STATE(943)] = 37839,
  [SMALL_STATE(944)] = 37847,
  [SMALL_STATE(945)] = 37855,
  [SMALL_STATE(946)] = 37863,
  [SMALL_STATE(947)] = 37871,
  [SMALL_STATE(948)] = 37878,
  [SMALL_STATE(949)] = 37885,
  [SMALL_STATE(950)] = 37892,
  [SMALL_STATE(951)] = 37899,
  [SMALL_STATE(952)] = 37906,
  [SMALL_STATE(953)] = 37913,
  [SMALL_STATE(954)] = 37920,
  [SMALL_STATE(955)] = 37927,
  [SMALL_STATE(956)] = 37934,
  [SMALL_STATE(957)] = 37941,
  [SMALL_STATE(958)] = 37948,
  [SMALL_STATE(959)] = 37955,
  [SMALL_STATE(960)] = 37962,
  [SMALL_STATE(961)] = 37969,
  [SMALL_STATE(962)] = 37976,
  [SMALL_STATE(963)] = 37983,
  [SMALL_STATE(964)] = 37990,
  [SMALL_STATE(965)] = 37997,
  [SMALL_STATE(966)] = 38004,
  [SMALL_STATE(967)] = 38011,
  [SMALL_STATE(968)] = 38018,
  [SMALL_STATE(969)] = 38025,
  [SMALL_STATE(970)] = 38032,
  [SMALL_STATE(971)] = 38039,
  [SMALL_STATE(972)] = 38046,
  [SMALL_STATE(973)] = 38053,
  [SMALL_STATE(974)] = 38060,
  [SMALL_STATE(975)] = 38067,
  [SMALL_STATE(976)] = 38074,
  [SMALL_STATE(977)] = 38081,
  [SMALL_STATE(978)] = 38088,
  [SMALL_STATE(979)] = 38095,
  [SMALL_STATE(980)] = 38102,
  [SMALL_STATE(981)] = 38109,
  [SMALL_STATE(982)] = 38116,
  [SMALL_STATE(983)] = 38123,
  [SMALL_STATE(984)] = 38130,
  [SMALL_STATE(985)] = 38137,
  [SMALL_STATE(986)] = 38144,
  [SMALL_STATE(987)] = 38151,
  [SMALL_STATE(988)] = 38158,
  [SMALL_STATE(989)] = 38165,
  [SMALL_STATE(990)] = 38172,
  [SMALL_STATE(991)] = 38179,
  [SMALL_STATE(992)] = 38186,
  [SMALL_STATE(993)] = 38193,
  [SMALL_STATE(994)] = 38200,
  [SMALL_STATE(995)] = 38207,
  [SMALL_STATE(996)] = 38214,
  [SMALL_STATE(997)] = 38221,
  [SMALL_STATE(998)] = 38228,
  [SMALL_STATE(999)] = 38235,
  [SMALL_STATE(1000)] = 38242,
  [SMALL_STATE(1001)] = 38249,
  [SMALL_STATE(1002)] = 38256,
  [SMALL_STATE(1003)] = 38263,
  [SMALL_STATE(1004)] = 38270,
  [SMALL_STATE(1005)] = 38277,
  [SMALL_STATE(1006)] = 38284,
  [SMALL_STATE(1007)] = 38291,
  [SMALL_STATE(1008)] = 38298,
  [SMALL_STATE(1009)] = 38305,
  [SMALL_STATE(1010)] = 38312,
  [SMALL_STATE(1011)] = 38319,
  [SMALL_STATE(1012)] = 38326,
  [SMALL_STATE(1013)] = 38333,
  [SMALL_STATE(1014)] = 38340,
  [SMALL_STATE(1015)] = 38347,
  [SMALL_STATE(1016)] = 38354,
  [SMALL_STATE(1017)] = 38361,
  [SMALL_STATE(1018)] = 38368,
  [SMALL_STATE(1019)] = 38375,
  [SMALL_STATE(1020)] = 38382,
  [SMALL_STATE(1021)] = 38389,
  [SMALL_STATE(1022)] = 38396,
  [SMALL_STATE(1023)] = 38403,
  [SMALL_STATE(1024)] = 38410,
  [SMALL_STATE(1025)] = 38417,
  [SMALL_STATE(1026)] = 38424,
  [SMALL_STATE(1027)] = 38431,
  [SMALL_STATE(1028)] = 38438,
  [SMALL_STATE(1029)] = 38445,
  [SMALL_STATE(1030)] = 38452,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(48),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(333),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(908),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(912),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(310),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1008),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [57] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(614),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(179),
  [63] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(812),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(305),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(253),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1013),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [97] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_module, 1),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(156),
  [104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(769),
  [107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(694),
  [110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(128),
  [113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(48),
  [116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(333),
  [119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(209),
  [122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(260),
  [125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(163),
  [128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(908),
  [131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(912),
  [134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(926),
  [137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(301),
  [140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(812),
  [143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(504),
  [146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(305),
  [149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1011),
  [152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(253),
  [155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1024),
  [158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1009),
  [161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1008),
  [164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(152),
  [167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1013),
  [170] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(942),
  [173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(283),
  [176] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(554),
  [179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(614),
  [182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(179),
  [185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(122),
  [188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(126),
  [191] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(123),
  [194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(126),
  [197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(287),
  [200] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2),
  [202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(681),
  [205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(310),
  [212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(896),
  [215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(505),
  [218] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(306),
  [221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1012),
  [224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(255),
  [227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1010),
  [230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(1007),
  [233] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_expression, 1, .production_id = 1),
  [235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_expression, 1, .production_id = 1),
  [237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(318),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(370),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(911),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 2),
  [415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 2),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(554),
  [419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_list, 3),
  [421] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 3),
  [423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [425] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 3),
  [427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, .production_id = 75),
  [433] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [435] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 6, .production_id = 75),
  [437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(312),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, .production_id = 76),
  [457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 6, .production_id = 76),
  [459] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(314),
  [469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 7, .production_id = 85),
  [477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 7, .production_id = 85),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, .production_id = 60),
  [489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_in_clause, 5, .production_id = 60),
  [491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__primary_expression, 1),
  [493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__primary_expression, 1),
  [495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 3),
  [503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(153),
  [507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 2),
  [519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [531] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(681),
  [534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(529),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [562] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(512),
  [566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [586] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenated_string, 2),
  [588] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenated_string, 2),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_operator, 3, .production_id = 19),
  [596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_operator, 3, .production_id = 19),
  [598] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_operator, 2, .production_id = 7),
  [600] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_operator, 2, .production_id = 7),
  [602] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2),
  [604] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2),
  [606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 3),
  [608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 3),
  [610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(309),
  [614] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 1),
  [616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 3),
  [620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string, 2),
  [624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_comprehension, 4, .production_id = 27),
  [628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list_comprehension, 4, .production_id = 27),
  [630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 4),
  [632] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 4),
  [634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set, 4),
  [636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set, 4),
  [638] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 3),
  [640] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 3),
  [642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [644] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(320),
  [648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 1),
  [650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 32),
  [652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 32),
  [654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(257),
  [658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 5, .production_id = 51),
  [662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 5, .production_id = 51),
  [664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 3),
  [666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 3),
  [668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call, 2, .production_id = 9),
  [670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call, 2, .production_id = 9),
  [672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generator_expression, 4, .production_id = 27),
  [674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generator_expression, 4, .production_id = 27),
  [676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set, 5),
  [678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set, 5),
  [680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 5),
  [682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 5),
  [684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 3),
  [686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 3),
  [688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4),
  [690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4),
  [692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4, .production_id = 26),
  [694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4, .production_id = 26),
  [696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 5, .production_id = 43),
  [698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 5, .production_id = 43),
  [700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(999),
  [702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(269),
  [704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(998),
  [706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple, 2),
  [708] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple, 2),
  [710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 5, .production_id = 57),
  [714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 5, .production_id = 57),
  [716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [718] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3, .production_id = 26),
  [720] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3, .production_id = 26),
  [722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [724] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3),
  [726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list, 2),
  [730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_list, 2),
  [732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary, 2),
  [734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary, 2),
  [736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set, 3),
  [738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set, 3),
  [740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 3, .production_id = 20),
  [742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute, 3, .production_id = 20),
  [744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [748] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2),
  [750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 6, .production_id = 57),
  [752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 6, .production_id = 57),
  [754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5, .production_id = 26),
  [756] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5, .production_id = 26),
  [758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subscript, 4, .production_id = 43),
  [762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_subscript, 4, .production_id = 43),
  [764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_comprehension, 4, .production_id = 27),
  [770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_set_comprehension, 4, .production_id = 27),
  [772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_comprehension, 4, .production_id = 27),
  [774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dictionary_comprehension, 4, .production_id = 27),
  [776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 5),
  [778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 5),
  [780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2, .production_id = 37),
  [786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 2),
  [788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 1),
  [796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 1),
  [802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 1, .production_id = 8),
  [812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 4, .production_id = 12),
  [826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 4),
  [828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [832] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(269),
  [835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 47),
  [837] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 47),
  [839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [841] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 64),
  [843] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 64),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(317),
  [847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 46),
  [849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 46),
  [851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, .production_id = 4),
  [853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 4, .production_id = 30),
  [855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 4, .production_id = 30),
  [857] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 3),
  [859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3),
  [861] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 4, .production_id = 13),
  [863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(257),
  [866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 3),
  [868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 3),
  [870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(563),
  [876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(316),
  [878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(498),
  [890] = {.entry = {.count = 1, .reusable = false}}, SHIFT(325),
  [892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 2),
  [898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 2),
  [900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 1),
  [902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 1),
  [904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 62),
  [908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 62),
  [910] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 62), SHIFT_REPEAT(334),
  [913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_statements, 4),
  [915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_statements, 4),
  [917] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 2, .production_id = 62), SHIFT_REPEAT(317),
  [920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2),
  [922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2),
  [924] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 4, .production_id = 83),
  [926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 4, .production_id = 83),
  [928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 6, .production_id = 93),
  [930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 6, .production_id = 93),
  [932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 3, .production_id = 70),
  [934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 3, .production_id = 70),
  [936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 4),
  [938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 4),
  [940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 7),
  [942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 7),
  [944] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_except_clause, 5),
  [946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_except_clause, 5),
  [948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 78),
  [950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 78),
  [952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_clause, 5, .production_id = 47),
  [954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elif_clause, 5, .production_id = 47),
  [956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 68),
  [958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 68),
  [960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 6, .production_id = 51),
  [962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 6, .production_id = 51),
  [964] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 44),
  [966] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_if_statement_repeat1, 1, .production_id = 44),
  [968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 82),
  [970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 82),
  [972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_clause, 4, .production_id = 30),
  [974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_elif_clause, 4, .production_id = 30),
  [976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 5, .production_id = 32),
  [978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 5, .production_id = 32),
  [980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 87),
  [982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 87),
  [984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 4, .production_id = 31),
  [986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 4, .production_id = 31),
  [988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, .production_id = 50),
  [990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, .production_id = 50),
  [992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 4, .production_id = 51),
  [994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 4, .production_id = 51),
  [996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_else_clause, 3, .production_id = 32),
  [998] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_clause, 3, .production_id = 32),
  [1000] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(672),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(553),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(551),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [1033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 3, .production_id = 70),
  [1035] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 3, .production_id = 70),
  [1037] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 6, .production_id = 32),
  [1039] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 6, .production_id = 32),
  [1041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 63),
  [1043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 63),
  [1045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 6, .production_id = 69),
  [1047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 6, .production_id = 69),
  [1049] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, .production_id = 67),
  [1051] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, .production_id = 67),
  [1053] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 6, .production_id = 66),
  [1055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 6, .production_id = 66),
  [1057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 6, .production_id = 65),
  [1059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 6, .production_id = 65),
  [1061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 6, .production_id = 61),
  [1063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 6, .production_id = 61),
  [1065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, .production_id = 55),
  [1067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, .production_id = 55),
  [1069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 5, .production_id = 54),
  [1071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 5, .production_id = 54),
  [1073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 5, .production_id = 53),
  [1075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 5, .production_id = 53),
  [1077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 5, .production_id = 52),
  [1079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 5, .production_id = 52),
  [1081] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5, .production_id = 49),
  [1083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5, .production_id = 49),
  [1085] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 4, .production_id = 33),
  [1087] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 4, .production_id = 33),
  [1089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 5, .production_id = 48),
  [1091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 5, .production_id = 48),
  [1093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 45),
  [1095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 45),
  [1097] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 4, .production_id = 35),
  [1099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 4, .production_id = 35),
  [1101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorated_definition, 2, .production_id = 10),
  [1103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_decorated_definition, 2, .production_id = 10),
  [1105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_definition, 6, .production_id = 72),
  [1107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_definition, 6, .production_id = 72),
  [1109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, .production_id = 77),
  [1111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, .production_id = 77),
  [1113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_statement, 7, .production_id = 79),
  [1115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_statement, 7, .production_id = 79),
  [1117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, .production_id = 80),
  [1119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, .production_id = 80),
  [1121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 6, .production_id = 71),
  [1123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 6, .production_id = 71),
  [1125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 81),
  [1127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 81),
  [1129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 4),
  [1131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 4),
  [1133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 7, .production_id = 51),
  [1135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 7, .production_id = 51),
  [1137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 9, .production_id = 92),
  [1139] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 9, .production_id = 92),
  [1141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 91),
  [1143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 91),
  [1145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 7, .production_id = 84),
  [1147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 7, .production_id = 84),
  [1149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, .production_id = 90),
  [1151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, .production_id = 90),
  [1153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 89),
  [1155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 89),
  [1157] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_definition, 8, .production_id = 88),
  [1159] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_definition, 8, .production_id = 88),
  [1161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 86),
  [1163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 86),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [1191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [1195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [1199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(677),
  [1202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [1204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [1206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [1208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(603),
  [1210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [1212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [1214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(606),
  [1216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variables, 3),
  [1218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [1220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [1222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [1224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(144),
  [1228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [1230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [1232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_variables, 2),
  [1234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(402),
  [1236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [1238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [1240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [1242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [1244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [1246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [1248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [1250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(145),
  [1252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [1254] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(528),
  [1257] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(972),
  [1260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(528),
  [1263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(512),
  [1266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [1268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [1270] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [1272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [1274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [1276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [1278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(147),
  [1280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [1282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [1286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [1290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [1292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [1296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(520),
  [1298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [1300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comparison_operator, 2),
  [1302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comparison_operator, 2),
  [1304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [1306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [1308] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [1310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [1312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [1314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1316] = {.entry = {.count = 1, .reusable = false}}, SHIFT(414),
  [1318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [1320] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [1322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [1324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(418),
  [1326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [1328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [1330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [1334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [1336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [1338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [1340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(139),
  [1342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(431),
  [1346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [1348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(518),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [1352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(519),
  [1354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [1356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [1360] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(551),
  [1363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(981),
  [1366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(551),
  [1369] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(510),
  [1372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_list, 1),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [1382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_operator, 3, .production_id = 19),
  [1384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_expression, 3, .production_id = 16),
  [1386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 4, .production_id = 41),
  [1388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await, 2),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [1392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 1),
  [1394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda, 3, .production_id = 15),
  [1396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5),
  [1398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_not_operator, 2, .production_id = 4),
  [1400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2),
  [1402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [1404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variables, 1),
  [1406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(286),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [1411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variables_repeat1, 2),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [1415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(537),
  [1418] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(948),
  [1421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(537),
  [1424] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(502),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [1433] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__right_hand_side, 1),
  [1435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(759),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [1439] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [1441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(784),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [1451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [1455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [1457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [1465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(761),
  [1467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 2, .production_id = 1),
  [1469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(204),
  [1471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [1473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(893),
  [1475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(895),
  [1477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 3, .production_id = 1),
  [1479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 3),
  [1481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 2),
  [1483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 3, .production_id = 8),
  [1485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 2, .production_id = 8),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [1507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__collection_elements, 1),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [1525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [1527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clauses, 1),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [1531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_within_for_in_clause, 1),
  [1533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comprehension_clauses, 2),
  [1535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2),
  [1537] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(292),
  [1540] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(1018),
  [1543] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__comprehension_clauses_repeat1, 2), SHIFT_REPEAT(511),
  [1546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [1548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [1550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [1552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, .production_id = 75),
  [1554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [1556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 4, .production_id = 60),
  [1558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [1560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2),
  [1562] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(226),
  [1565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_list_splat, 2),
  [1567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [1569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [1573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [1575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 6, .production_id = 85),
  [1577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_in_clause, 5, .production_id = 76),
  [1581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [1583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_clause, 2),
  [1585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [1587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [1589] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [1591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [1593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [1595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [1599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [1601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_name, 1),
  [1603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(676),
  [1605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [1607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [1609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [1611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [1613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [1615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(686),
  [1617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [1619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [1623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 2),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [1627] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 2, .production_id = 4),
  [1629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [1631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(295),
  [1634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(676),
  [1637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(676),
  [1640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_repeat1, 2),
  [1642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [1644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [1646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [1648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dictionary_splat, 2),
  [1650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [1652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [1654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [1656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 4, .production_id = 6),
  [1658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(670),
  [1660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [1662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [1666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [1668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 42),
  [1670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [1674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [1676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [1678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [1680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1),
  [1682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [1684] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(992),
  [1687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2),
  [1689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_within_for_in_clause, 3, .production_id = 15),
  [1691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dotted_name, 2),
  [1693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [1695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [1697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [1699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_within_for_in_clause, 4, .production_id = 41),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [1703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [1711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [1715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2),
  [1717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, .production_id = 4),
  [1719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2),
  [1721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [1729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 3),
  [1731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_default_parameter, 5, .production_id = 73),
  [1733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_default_parameter, 5, .production_id = 74),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [1737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [1739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(980),
  [1742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [1744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decorated_definition_repeat1, 2),
  [1746] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decorated_definition_repeat1, 2), SHIFT_REPEAT(942),
  [1749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_parameter, 3, .production_id = 16),
  [1751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_item, 1, .production_id = 5),
  [1753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [1755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_chevron, 2),
  [1757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_parameter, 3, .production_id = 39),
  [1759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 5),
  [1761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5),
  [1763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_argument, 3, .production_id = 39),
  [1765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 3, .production_id = 11),
  [1767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 1, .production_id = 1),
  [1769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [1771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [1773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [1775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [1777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 4),
  [1779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4),
  [1781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [1783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [1785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_specifier, 2),
  [1787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [1789] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_assert_statement_repeat1, 2), SHIFT_REPEAT(300),
  [1792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 4, .production_id = 29),
  [1794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameters, 1),
  [1796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [1798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [1800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 2, .production_id = 3),
  [1804] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [1806] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [1808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 1, .production_id = 3),
  [1810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_set_repeat1, 2),
  [1812] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [1814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [1816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [1818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [1820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice, 5),
  [1822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 2), SHIFT_REPEAT(323),
  [1825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 2),
  [1827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_format_specifier_repeat1, 2), SHIFT_REPEAT(749),
  [1830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_keyword_argument, 3, .production_id = 16),
  [1832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 3, .production_id = 14),
  [1834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_item, 3, .production_id = 34),
  [1836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [1838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_specifier, 1),
  [1840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [1842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 3),
  [1844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 3),
  [1846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [1848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [1850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 2),
  [1852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2),
  [1854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_import_prefix_repeat1, 2),
  [1856] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_import_prefix_repeat1, 2), SHIFT_REPEAT(762),
  [1859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [1861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [1863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_parameter, 3, .production_id = 40),
  [1865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [1867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [1869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [1871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [1873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, .production_id = 12),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [1877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [1879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 4, .production_id = 36),
  [1881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [1883] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_global_statement_repeat1, 2), SHIFT_REPEAT(1003),
  [1886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_global_statement_repeat1, 2),
  [1888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [1890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [1892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [1894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_print_statement, 3, .production_id = 13),
  [1896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decorator, 3),
  [1898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 21),
  [1900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [1902] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__collection_elements_repeat1, 2), SHIFT_REPEAT(157),
  [1905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [1907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nonlocal_statement, 2),
  [1909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_statement, 2),
  [1911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_statement, 3),
  [1913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nonlocal_statement, 3),
  [1915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 3),
  [1917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [1919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 5, .production_id = 6),
  [1921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [1923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_import_prefix, 1),
  [1925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [1927] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, .production_id = 28), SHIFT_REPEAT(319),
  [1930] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_print_statement_repeat1, 2, .production_id = 28),
  [1932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [1934] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [1936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2, .production_id = 38),
  [1938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [1940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [1942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [1944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [1946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__import_list, 2, .production_id = 11),
  [1948] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 22), SHIFT_REPEAT(826),
  [1951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 22),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [1955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [1957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_list_splat, 3),
  [1959] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_subscript_repeat1, 2), SHIFT_REPEAT(247),
  [1962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [1964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [1966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [1968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [1970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [1972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [1974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relative_import, 1),
  [1976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [1978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [1980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield, 2),
  [1984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [1986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [1988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [1990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [1992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [1994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [1996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [1998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [2000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [2002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [2004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [2006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [2008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [2010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [2012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [2014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [2016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [2018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [2020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [2022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__import_list_repeat1, 2, .production_id = 22), SHIFT_REPEAT(873),
  [2025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_dictionary_repeat1, 2), SHIFT_REPEAT(219),
  [2028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_dictionary_repeat1, 2),
  [2030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [2032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [2034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variables_repeat1, 2), SHIFT_REPEAT(556),
  [2037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [2039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [2041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_list_splat, 3, .production_id = 26),
  [2043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [2045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [2047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [2049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [2053] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__simple_statements_repeat1, 2), SHIFT_REPEAT(95),
  [2056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__simple_statements_repeat1, 2),
  [2058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [2060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [2062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [2064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [2066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [2068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [2070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [2072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [2074] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variables, 2),
  [2076] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_set_repeat1, 2), SHIFT_REPEAT(231),
  [2079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [2081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [2083] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(140),
  [2086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_format_expression, 3),
  [2088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [2090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, .production_id = 17),
  [2092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [2094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2), SHIFT_REPEAT(638),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [2099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_raise_statement, 2),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [2105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__parameters_repeat1, 2), SHIFT_REPEAT(637),
  [2108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [2110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [2112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [2114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [2116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [2118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [2120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [2122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [2124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [2126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exec_statement, 2, .production_id = 6),
  [2128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_statement_repeat1, 2), SHIFT_REPEAT(264),
  [2131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_with_statement_repeat1, 2),
  [2133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [2139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_aliased_import, 3, .production_id = 23),
  [2141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_from_statement, 6, .production_id = 59),
  [2143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pass_statement, 1),
  [2145] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_augmented_assignment, 3, .production_id = 19),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [2149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 1),
  [2151] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 3, .production_id = 18),
  [2153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delete_statement, 2),
  [2155] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [2159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [2161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_from_statement, 4, .production_id = 25),
  [2163] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wildcard_import, 1),
  [2165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 1),
  [2167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_import_statement, 2, .production_id = 2),
  [2169] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_argument_list_repeat1, 2, .production_id = 26),
  [2171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_future_import_statement, 4, .production_id = 24),
  [2173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_future_import_statement, 6, .production_id = 58),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [2177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [2179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment, 5, .production_id = 56),
  [2181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [2183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [2185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [2187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [2189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3),
  [2191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2),
  [2193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [2195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [2197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [2199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [2201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [2203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [2205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [2207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [2213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [2217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [2219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [2221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [2223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [2225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [2227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(343),
  [2229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_parameters, 1),
  [2231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [2233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [2237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [2239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [2243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [2245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [2247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [2249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [2251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [2253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [2255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [2257] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [2261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [2263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [2267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [2269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [2271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [2273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [2275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [2277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [2279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [2281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [2283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [2289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [2291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [2295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relative_import, 2),
  [2297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [2299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [2303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [2307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [2319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [2325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [2327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [2329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [2331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [2333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [2335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [2337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [2339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [2341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_python_external_scanner_create(void);
void tree_sitter_python_external_scanner_destroy(void *);
bool tree_sitter_python_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_python_external_scanner_serialize(void *, char *);
void tree_sitter_python_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_python(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .public_symbol_map = ts_symbol_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_python_external_scanner_create,
      tree_sitter_python_external_scanner_destroy,
      tree_sitter_python_external_scanner_scan,
      tree_sitter_python_external_scanner_serialize,
      tree_sitter_python_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
