#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 11
#define STATE_COUNT 2392
#define LARGE_STATE_COUNT 531
#define SYMBOL_COUNT 312
#define ALIAS_COUNT 4
#define TOKEN_COUNT 138
#define EXTERNAL_TOKEN_COUNT 4
#define FIELD_COUNT 28
#define MAX_ALIAS_SEQUENCE_LENGTH 10

enum {
  sym_identifier = 1,
  anon_sym_SEMI = 2,
  anon_sym_macro_rules_BANG = 3,
  anon_sym_LPAREN = 4,
  anon_sym_RPAREN = 5,
  anon_sym_LBRACE = 6,
  anon_sym_RBRACE = 7,
  anon_sym_EQ_GT = 8,
  anon_sym_LBRACK = 9,
  anon_sym_RBRACK = 10,
  anon_sym_COLON = 11,
  anon_sym_DOLLAR = 12,
  aux_sym_token_repetition_pattern_token1 = 13,
  anon_sym_PLUS = 14,
  anon_sym_STAR = 15,
  anon_sym_QMARK = 16,
  anon_sym_block = 17,
  anon_sym_expr = 18,
  anon_sym_ident = 19,
  anon_sym_item = 20,
  anon_sym_lifetime = 21,
  anon_sym_literal = 22,
  anon_sym_meta = 23,
  anon_sym_pat = 24,
  anon_sym_path = 25,
  anon_sym_stmt = 26,
  anon_sym_tt = 27,
  anon_sym_ty = 28,
  anon_sym_vis = 29,
  anon_sym_u8 = 30,
  anon_sym_i8 = 31,
  anon_sym_u16 = 32,
  anon_sym_i16 = 33,
  anon_sym_u32 = 34,
  anon_sym_i32 = 35,
  anon_sym_u64 = 36,
  anon_sym_i64 = 37,
  anon_sym_u128 = 38,
  anon_sym_i128 = 39,
  anon_sym_isize = 40,
  anon_sym_usize = 41,
  anon_sym_f32 = 42,
  anon_sym_f64 = 43,
  anon_sym_bool = 44,
  anon_sym_str = 45,
  anon_sym_char = 46,
  aux_sym__non_special_token_token1 = 47,
  anon_sym_SQUOTE = 48,
  anon_sym_as = 49,
  anon_sym_async = 50,
  anon_sym_await = 51,
  anon_sym_break = 52,
  anon_sym_const = 53,
  anon_sym_continue = 54,
  anon_sym_default = 55,
  anon_sym_enum = 56,
  anon_sym_fn = 57,
  anon_sym_for = 58,
  anon_sym_if = 59,
  anon_sym_impl = 60,
  anon_sym_let = 61,
  anon_sym_loop = 62,
  anon_sym_match = 63,
  anon_sym_mod = 64,
  anon_sym_pub = 65,
  anon_sym_return = 66,
  anon_sym_static = 67,
  anon_sym_struct = 68,
  anon_sym_trait = 69,
  anon_sym_type = 70,
  anon_sym_union = 71,
  anon_sym_unsafe = 72,
  anon_sym_use = 73,
  anon_sym_where = 74,
  anon_sym_while = 75,
  anon_sym_POUND = 76,
  anon_sym_BANG = 77,
  anon_sym_EQ = 78,
  anon_sym_COMMA = 79,
  anon_sym_extern = 80,
  anon_sym_ref = 81,
  anon_sym_DASH_GT = 82,
  anon_sym_LT = 83,
  anon_sym_GT = 84,
  anon_sym_COLON_COLON = 85,
  anon_sym__ = 86,
  anon_sym_AMP = 87,
  anon_sym_DOT_DOT_DOT = 88,
  anon_sym_in = 89,
  anon_sym_LT2 = 90,
  anon_sym_dyn = 91,
  sym_mutable_specifier = 92,
  anon_sym_DOT_DOT = 93,
  anon_sym_DOT_DOT_EQ = 94,
  anon_sym_DASH = 95,
  anon_sym_AMP_AMP = 96,
  anon_sym_PIPE_PIPE = 97,
  anon_sym_PIPE = 98,
  anon_sym_CARET = 99,
  anon_sym_EQ_EQ = 100,
  anon_sym_BANG_EQ = 101,
  anon_sym_LT_EQ = 102,
  anon_sym_GT_EQ = 103,
  anon_sym_LT_LT = 104,
  anon_sym_GT_GT = 105,
  anon_sym_SLASH = 106,
  anon_sym_PERCENT = 107,
  anon_sym_PLUS_EQ = 108,
  anon_sym_DASH_EQ = 109,
  anon_sym_STAR_EQ = 110,
  anon_sym_SLASH_EQ = 111,
  anon_sym_PERCENT_EQ = 112,
  anon_sym_AMP_EQ = 113,
  anon_sym_PIPE_EQ = 114,
  anon_sym_CARET_EQ = 115,
  anon_sym_LT_LT_EQ = 116,
  anon_sym_GT_GT_EQ = 117,
  anon_sym_else = 118,
  anon_sym_move = 119,
  anon_sym_DOT = 120,
  anon_sym_AT = 121,
  sym_integer_literal = 122,
  aux_sym_string_literal_token1 = 123,
  anon_sym_DQUOTE = 124,
  sym_char_literal = 125,
  sym_escape_sequence = 126,
  anon_sym_true = 127,
  anon_sym_false = 128,
  sym_line_comment = 129,
  sym_self = 130,
  sym_super = 131,
  sym_crate = 132,
  sym_metavariable = 133,
  sym__string_content = 134,
  sym_raw_string_literal = 135,
  sym_float_literal = 136,
  sym_block_comment = 137,
  sym_source_file = 138,
  sym__statement = 139,
  sym_empty_statement = 140,
  sym__expression_statement = 141,
  sym_macro_definition = 142,
  sym_macro_rule = 143,
  sym__token_pattern = 144,
  sym_token_tree_pattern = 145,
  sym_token_binding_pattern = 146,
  sym_token_repetition_pattern = 147,
  sym_fragment_specifier = 148,
  sym_token_tree = 149,
  sym_token_repetition = 150,
  sym_attribute_item = 151,
  sym_inner_attribute_item = 152,
  sym_meta_item = 153,
  sym_meta_arguments = 154,
  sym_mod_item = 155,
  sym_foreign_mod_item = 156,
  sym_declaration_list = 157,
  sym_struct_item = 158,
  sym_union_item = 159,
  sym_enum_item = 160,
  sym_enum_variant_list = 161,
  sym_enum_variant = 162,
  sym_field_declaration_list = 163,
  sym_field_declaration = 164,
  sym_ordered_field_declaration_list = 165,
  sym_extern_crate_declaration = 166,
  sym_const_item = 167,
  sym_static_item = 168,
  sym_type_item = 169,
  sym_function_item = 170,
  sym_function_signature_item = 171,
  sym_function_modifiers = 172,
  sym_where_clause = 173,
  sym_where_predicate = 174,
  sym_impl_item = 175,
  sym_trait_item = 176,
  sym_associated_type = 177,
  sym_trait_bounds = 178,
  sym_higher_ranked_trait_bound = 179,
  sym_removed_trait_bound = 180,
  sym_type_parameters = 181,
  sym_const_parameter = 182,
  sym_constrained_type_parameter = 183,
  sym_optional_type_parameter = 184,
  sym_let_declaration = 185,
  sym_use_declaration = 186,
  sym__use_clause = 187,
  sym_scoped_use_list = 188,
  sym_use_list = 189,
  sym_use_as_clause = 190,
  sym_use_wildcard = 191,
  sym_parameters = 192,
  sym_self_parameter = 193,
  sym_variadic_parameter = 194,
  sym_parameter = 195,
  sym_extern_modifier = 196,
  sym_visibility_modifier = 197,
  sym__type = 198,
  sym_bracketed_type = 199,
  sym_qualified_type = 200,
  sym_lifetime = 201,
  sym_array_type = 202,
  sym_for_lifetimes = 203,
  sym_function_type = 204,
  sym_tuple_type = 205,
  sym_unit_type = 206,
  sym_generic_function = 207,
  sym_generic_type = 208,
  sym_generic_type_with_turbofish = 209,
  sym_bounded_type = 210,
  sym_type_arguments = 211,
  sym_type_binding = 212,
  sym_reference_type = 213,
  sym_pointer_type = 214,
  sym_empty_type = 215,
  sym_abstract_type = 216,
  sym_dynamic_type = 217,
  sym__expression = 218,
  sym_macro_invocation = 219,
  sym_scoped_identifier = 220,
  sym_scoped_type_identifier_in_expression_position = 221,
  sym_scoped_type_identifier = 222,
  sym_range_expression = 223,
  sym_unary_expression = 224,
  sym_try_expression = 225,
  sym_reference_expression = 226,
  sym_binary_expression = 227,
  sym_assignment_expression = 228,
  sym_compound_assignment_expr = 229,
  sym_type_cast_expression = 230,
  sym_return_expression = 231,
  sym_call_expression = 232,
  sym_arguments = 233,
  sym_array_expression = 234,
  sym_parenthesized_expression = 235,
  sym_tuple_expression = 236,
  sym_unit_expression = 237,
  sym_struct_expression = 238,
  sym_field_initializer_list = 239,
  sym_shorthand_field_initializer = 240,
  sym_field_initializer = 241,
  sym_base_field_initializer = 242,
  sym_if_expression = 243,
  sym_if_let_expression = 244,
  sym__else_tail = 245,
  sym_match_expression = 246,
  sym_match_block = 247,
  sym_match_arm = 248,
  sym_last_match_arm = 249,
  sym_match_pattern = 250,
  sym_while_expression = 251,
  sym_while_let_expression = 252,
  sym_loop_expression = 253,
  sym_for_expression = 254,
  sym_closure_expression = 255,
  sym_closure_parameters = 256,
  sym_loop_label = 257,
  sym_break_expression = 258,
  sym_continue_expression = 259,
  sym_index_expression = 260,
  sym_await_expression = 261,
  sym_field_expression = 262,
  sym_unsafe_block = 263,
  sym_async_block = 264,
  sym_block = 265,
  sym__pattern = 266,
  sym_tuple_pattern = 267,
  sym_slice_pattern = 268,
  sym_tuple_struct_pattern = 269,
  sym_struct_pattern = 270,
  sym_field_pattern = 271,
  sym_remaining_field_pattern = 272,
  sym_mut_pattern = 273,
  sym_range_pattern = 274,
  sym_ref_pattern = 275,
  sym_captured_pattern = 276,
  sym_reference_pattern = 277,
  sym_or_pattern = 278,
  sym__literal = 279,
  sym__literal_pattern = 280,
  sym_negative_literal = 281,
  sym_string_literal = 282,
  sym_boolean_literal = 283,
  aux_sym_source_file_repeat1 = 284,
  aux_sym_macro_definition_repeat1 = 285,
  aux_sym_token_tree_pattern_repeat1 = 286,
  aux_sym_token_tree_repeat1 = 287,
  aux_sym_meta_arguments_repeat1 = 288,
  aux_sym_declaration_list_repeat1 = 289,
  aux_sym_enum_variant_list_repeat1 = 290,
  aux_sym_enum_variant_list_repeat2 = 291,
  aux_sym_field_declaration_list_repeat1 = 292,
  aux_sym_ordered_field_declaration_list_repeat1 = 293,
  aux_sym_function_modifiers_repeat1 = 294,
  aux_sym_where_clause_repeat1 = 295,
  aux_sym_trait_bounds_repeat1 = 296,
  aux_sym_type_parameters_repeat1 = 297,
  aux_sym_use_list_repeat1 = 298,
  aux_sym_parameters_repeat1 = 299,
  aux_sym_for_lifetimes_repeat1 = 300,
  aux_sym_tuple_type_repeat1 = 301,
  aux_sym_type_arguments_repeat1 = 302,
  aux_sym_arguments_repeat1 = 303,
  aux_sym_array_expression_repeat1 = 304,
  aux_sym_tuple_expression_repeat1 = 305,
  aux_sym_field_initializer_list_repeat1 = 306,
  aux_sym_match_block_repeat1 = 307,
  aux_sym_closure_parameters_repeat1 = 308,
  aux_sym_tuple_pattern_repeat1 = 309,
  aux_sym_struct_pattern_repeat1 = 310,
  aux_sym_string_literal_repeat1 = 311,
  alias_sym_field_identifier = 312,
  alias_sym_primitive_type = 313,
  alias_sym_shorthand_field_identifier = 314,
  alias_sym_type_identifier = 315,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [anon_sym_SEMI] = ";",
  [anon_sym_macro_rules_BANG] = "macro_rules!",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_COLON] = ":",
  [anon_sym_DOLLAR] = "$",
  [aux_sym_token_repetition_pattern_token1] = "token_repetition_pattern_token1",
  [anon_sym_PLUS] = "+",
  [anon_sym_STAR] = "*",
  [anon_sym_QMARK] = "?",
  [anon_sym_block] = "block",
  [anon_sym_expr] = "expr",
  [anon_sym_ident] = "ident",
  [anon_sym_item] = "item",
  [anon_sym_lifetime] = "lifetime",
  [anon_sym_literal] = "literal",
  [anon_sym_meta] = "meta",
  [anon_sym_pat] = "pat",
  [anon_sym_path] = "path",
  [anon_sym_stmt] = "stmt",
  [anon_sym_tt] = "tt",
  [anon_sym_ty] = "ty",
  [anon_sym_vis] = "vis",
  [anon_sym_u8] = "u8",
  [anon_sym_i8] = "i8",
  [anon_sym_u16] = "u16",
  [anon_sym_i16] = "i16",
  [anon_sym_u32] = "u32",
  [anon_sym_i32] = "i32",
  [anon_sym_u64] = "u64",
  [anon_sym_i64] = "i64",
  [anon_sym_u128] = "u128",
  [anon_sym_i128] = "i128",
  [anon_sym_isize] = "isize",
  [anon_sym_usize] = "usize",
  [anon_sym_f32] = "f32",
  [anon_sym_f64] = "f64",
  [anon_sym_bool] = "bool",
  [anon_sym_str] = "str",
  [anon_sym_char] = "char",
  [aux_sym__non_special_token_token1] = "_non_special_token_token1",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_as] = "as",
  [anon_sym_async] = "async",
  [anon_sym_await] = "await",
  [anon_sym_break] = "break",
  [anon_sym_const] = "const",
  [anon_sym_continue] = "continue",
  [anon_sym_default] = "default",
  [anon_sym_enum] = "enum",
  [anon_sym_fn] = "fn",
  [anon_sym_for] = "for",
  [anon_sym_if] = "if",
  [anon_sym_impl] = "impl",
  [anon_sym_let] = "let",
  [anon_sym_loop] = "loop",
  [anon_sym_match] = "match",
  [anon_sym_mod] = "mod",
  [anon_sym_pub] = "pub",
  [anon_sym_return] = "return",
  [anon_sym_static] = "static",
  [anon_sym_struct] = "struct",
  [anon_sym_trait] = "trait",
  [anon_sym_type] = "type",
  [anon_sym_union] = "union",
  [anon_sym_unsafe] = "unsafe",
  [anon_sym_use] = "use",
  [anon_sym_where] = "where",
  [anon_sym_while] = "while",
  [anon_sym_POUND] = "#",
  [anon_sym_BANG] = "!",
  [anon_sym_EQ] = "=",
  [anon_sym_COMMA] = ",",
  [anon_sym_extern] = "extern",
  [anon_sym_ref] = "ref",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym__] = "_",
  [anon_sym_AMP] = "&",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_in] = "in",
  [anon_sym_LT2] = "<",
  [anon_sym_dyn] = "dyn",
  [sym_mutable_specifier] = "mutable_specifier",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_DOT_DOT_EQ] = "..=",
  [anon_sym_DASH] = "-",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_PIPE] = "|",
  [anon_sym_CARET] = "^",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_else] = "else",
  [anon_sym_move] = "move",
  [anon_sym_DOT] = ".",
  [anon_sym_AT] = "@",
  [sym_integer_literal] = "integer_literal",
  [aux_sym_string_literal_token1] = "\"",
  [anon_sym_DQUOTE] = "\"",
  [sym_char_literal] = "char_literal",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [sym_line_comment] = "line_comment",
  [sym_self] = "self",
  [sym_super] = "super",
  [sym_crate] = "crate",
  [sym_metavariable] = "metavariable",
  [sym__string_content] = "_string_content",
  [sym_raw_string_literal] = "raw_string_literal",
  [sym_float_literal] = "float_literal",
  [sym_block_comment] = "block_comment",
  [sym_source_file] = "source_file",
  [sym__statement] = "_statement",
  [sym_empty_statement] = "empty_statement",
  [sym__expression_statement] = "_expression_statement",
  [sym_macro_definition] = "macro_definition",
  [sym_macro_rule] = "macro_rule",
  [sym__token_pattern] = "_token_pattern",
  [sym_token_tree_pattern] = "token_tree_pattern",
  [sym_token_binding_pattern] = "token_binding_pattern",
  [sym_token_repetition_pattern] = "token_repetition_pattern",
  [sym_fragment_specifier] = "fragment_specifier",
  [sym_token_tree] = "token_tree",
  [sym_token_repetition] = "token_repetition",
  [sym_attribute_item] = "attribute_item",
  [sym_inner_attribute_item] = "inner_attribute_item",
  [sym_meta_item] = "meta_item",
  [sym_meta_arguments] = "meta_arguments",
  [sym_mod_item] = "mod_item",
  [sym_foreign_mod_item] = "foreign_mod_item",
  [sym_declaration_list] = "declaration_list",
  [sym_struct_item] = "struct_item",
  [sym_union_item] = "union_item",
  [sym_enum_item] = "enum_item",
  [sym_enum_variant_list] = "enum_variant_list",
  [sym_enum_variant] = "enum_variant",
  [sym_field_declaration_list] = "field_declaration_list",
  [sym_field_declaration] = "field_declaration",
  [sym_ordered_field_declaration_list] = "ordered_field_declaration_list",
  [sym_extern_crate_declaration] = "extern_crate_declaration",
  [sym_const_item] = "const_item",
  [sym_static_item] = "static_item",
  [sym_type_item] = "type_item",
  [sym_function_item] = "function_item",
  [sym_function_signature_item] = "function_signature_item",
  [sym_function_modifiers] = "function_modifiers",
  [sym_where_clause] = "where_clause",
  [sym_where_predicate] = "where_predicate",
  [sym_impl_item] = "impl_item",
  [sym_trait_item] = "trait_item",
  [sym_associated_type] = "associated_type",
  [sym_trait_bounds] = "trait_bounds",
  [sym_higher_ranked_trait_bound] = "higher_ranked_trait_bound",
  [sym_removed_trait_bound] = "removed_trait_bound",
  [sym_type_parameters] = "type_parameters",
  [sym_const_parameter] = "const_parameter",
  [sym_constrained_type_parameter] = "constrained_type_parameter",
  [sym_optional_type_parameter] = "optional_type_parameter",
  [sym_let_declaration] = "let_declaration",
  [sym_use_declaration] = "use_declaration",
  [sym__use_clause] = "_use_clause",
  [sym_scoped_use_list] = "scoped_use_list",
  [sym_use_list] = "use_list",
  [sym_use_as_clause] = "use_as_clause",
  [sym_use_wildcard] = "use_wildcard",
  [sym_parameters] = "parameters",
  [sym_self_parameter] = "self_parameter",
  [sym_variadic_parameter] = "variadic_parameter",
  [sym_parameter] = "parameter",
  [sym_extern_modifier] = "extern_modifier",
  [sym_visibility_modifier] = "visibility_modifier",
  [sym__type] = "_type",
  [sym_bracketed_type] = "bracketed_type",
  [sym_qualified_type] = "qualified_type",
  [sym_lifetime] = "lifetime",
  [sym_array_type] = "array_type",
  [sym_for_lifetimes] = "for_lifetimes",
  [sym_function_type] = "function_type",
  [sym_tuple_type] = "tuple_type",
  [sym_unit_type] = "unit_type",
  [sym_generic_function] = "generic_function",
  [sym_generic_type] = "generic_type",
  [sym_generic_type_with_turbofish] = "generic_type_with_turbofish",
  [sym_bounded_type] = "bounded_type",
  [sym_type_arguments] = "type_arguments",
  [sym_type_binding] = "type_binding",
  [sym_reference_type] = "reference_type",
  [sym_pointer_type] = "pointer_type",
  [sym_empty_type] = "empty_type",
  [sym_abstract_type] = "abstract_type",
  [sym_dynamic_type] = "dynamic_type",
  [sym__expression] = "_expression",
  [sym_macro_invocation] = "macro_invocation",
  [sym_scoped_identifier] = "scoped_identifier",
  [sym_scoped_type_identifier_in_expression_position] = "scoped_type_identifier",
  [sym_scoped_type_identifier] = "scoped_type_identifier",
  [sym_range_expression] = "range_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_try_expression] = "try_expression",
  [sym_reference_expression] = "reference_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_compound_assignment_expr] = "compound_assignment_expr",
  [sym_type_cast_expression] = "type_cast_expression",
  [sym_return_expression] = "return_expression",
  [sym_call_expression] = "call_expression",
  [sym_arguments] = "arguments",
  [sym_array_expression] = "array_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_tuple_expression] = "tuple_expression",
  [sym_unit_expression] = "unit_expression",
  [sym_struct_expression] = "struct_expression",
  [sym_field_initializer_list] = "field_initializer_list",
  [sym_shorthand_field_initializer] = "shorthand_field_initializer",
  [sym_field_initializer] = "field_initializer",
  [sym_base_field_initializer] = "base_field_initializer",
  [sym_if_expression] = "if_expression",
  [sym_if_let_expression] = "if_let_expression",
  [sym__else_tail] = "_else_tail",
  [sym_match_expression] = "match_expression",
  [sym_match_block] = "match_block",
  [sym_match_arm] = "match_arm",
  [sym_last_match_arm] = "match_arm",
  [sym_match_pattern] = "match_pattern",
  [sym_while_expression] = "while_expression",
  [sym_while_let_expression] = "while_let_expression",
  [sym_loop_expression] = "loop_expression",
  [sym_for_expression] = "for_expression",
  [sym_closure_expression] = "closure_expression",
  [sym_closure_parameters] = "closure_parameters",
  [sym_loop_label] = "loop_label",
  [sym_break_expression] = "break_expression",
  [sym_continue_expression] = "continue_expression",
  [sym_index_expression] = "index_expression",
  [sym_await_expression] = "await_expression",
  [sym_field_expression] = "field_expression",
  [sym_unsafe_block] = "unsafe_block",
  [sym_async_block] = "async_block",
  [sym_block] = "block",
  [sym__pattern] = "_pattern",
  [sym_tuple_pattern] = "tuple_pattern",
  [sym_slice_pattern] = "slice_pattern",
  [sym_tuple_struct_pattern] = "tuple_struct_pattern",
  [sym_struct_pattern] = "struct_pattern",
  [sym_field_pattern] = "field_pattern",
  [sym_remaining_field_pattern] = "remaining_field_pattern",
  [sym_mut_pattern] = "mut_pattern",
  [sym_range_pattern] = "range_pattern",
  [sym_ref_pattern] = "ref_pattern",
  [sym_captured_pattern] = "captured_pattern",
  [sym_reference_pattern] = "reference_pattern",
  [sym_or_pattern] = "or_pattern",
  [sym__literal] = "_literal",
  [sym__literal_pattern] = "_literal_pattern",
  [sym_negative_literal] = "negative_literal",
  [sym_string_literal] = "string_literal",
  [sym_boolean_literal] = "boolean_literal",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym_macro_definition_repeat1] = "macro_definition_repeat1",
  [aux_sym_token_tree_pattern_repeat1] = "token_tree_pattern_repeat1",
  [aux_sym_token_tree_repeat1] = "token_tree_repeat1",
  [aux_sym_meta_arguments_repeat1] = "meta_arguments_repeat1",
  [aux_sym_declaration_list_repeat1] = "declaration_list_repeat1",
  [aux_sym_enum_variant_list_repeat1] = "enum_variant_list_repeat1",
  [aux_sym_enum_variant_list_repeat2] = "enum_variant_list_repeat2",
  [aux_sym_field_declaration_list_repeat1] = "field_declaration_list_repeat1",
  [aux_sym_ordered_field_declaration_list_repeat1] = "ordered_field_declaration_list_repeat1",
  [aux_sym_function_modifiers_repeat1] = "function_modifiers_repeat1",
  [aux_sym_where_clause_repeat1] = "where_clause_repeat1",
  [aux_sym_trait_bounds_repeat1] = "trait_bounds_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [aux_sym_use_list_repeat1] = "use_list_repeat1",
  [aux_sym_parameters_repeat1] = "parameters_repeat1",
  [aux_sym_for_lifetimes_repeat1] = "for_lifetimes_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym_type_arguments_repeat1] = "type_arguments_repeat1",
  [aux_sym_arguments_repeat1] = "arguments_repeat1",
  [aux_sym_array_expression_repeat1] = "array_expression_repeat1",
  [aux_sym_tuple_expression_repeat1] = "tuple_expression_repeat1",
  [aux_sym_field_initializer_list_repeat1] = "field_initializer_list_repeat1",
  [aux_sym_match_block_repeat1] = "match_block_repeat1",
  [aux_sym_closure_parameters_repeat1] = "closure_parameters_repeat1",
  [aux_sym_tuple_pattern_repeat1] = "tuple_pattern_repeat1",
  [aux_sym_struct_pattern_repeat1] = "struct_pattern_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [alias_sym_field_identifier] = "field_identifier",
  [alias_sym_primitive_type] = "primitive_type",
  [alias_sym_shorthand_field_identifier] = "shorthand_field_identifier",
  [alias_sym_type_identifier] = "type_identifier",
};

static TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym_identifier] = sym_identifier,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_macro_rules_BANG] = anon_sym_macro_rules_BANG,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [aux_sym_token_repetition_pattern_token1] = aux_sym_token_repetition_pattern_token1,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_block] = anon_sym_block,
  [anon_sym_expr] = anon_sym_expr,
  [anon_sym_ident] = anon_sym_ident,
  [anon_sym_item] = anon_sym_item,
  [anon_sym_lifetime] = anon_sym_lifetime,
  [anon_sym_literal] = anon_sym_literal,
  [anon_sym_meta] = anon_sym_meta,
  [anon_sym_pat] = anon_sym_pat,
  [anon_sym_path] = anon_sym_path,
  [anon_sym_stmt] = anon_sym_stmt,
  [anon_sym_tt] = anon_sym_tt,
  [anon_sym_ty] = anon_sym_ty,
  [anon_sym_vis] = anon_sym_vis,
  [anon_sym_u8] = anon_sym_u8,
  [anon_sym_i8] = anon_sym_i8,
  [anon_sym_u16] = anon_sym_u16,
  [anon_sym_i16] = anon_sym_i16,
  [anon_sym_u32] = anon_sym_u32,
  [anon_sym_i32] = anon_sym_i32,
  [anon_sym_u64] = anon_sym_u64,
  [anon_sym_i64] = anon_sym_i64,
  [anon_sym_u128] = anon_sym_u128,
  [anon_sym_i128] = anon_sym_i128,
  [anon_sym_isize] = anon_sym_isize,
  [anon_sym_usize] = anon_sym_usize,
  [anon_sym_f32] = anon_sym_f32,
  [anon_sym_f64] = anon_sym_f64,
  [anon_sym_bool] = anon_sym_bool,
  [anon_sym_str] = anon_sym_str,
  [anon_sym_char] = anon_sym_char,
  [aux_sym__non_special_token_token1] = aux_sym__non_special_token_token1,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_fn] = anon_sym_fn,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_impl] = anon_sym_impl,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_loop] = anon_sym_loop,
  [anon_sym_match] = anon_sym_match,
  [anon_sym_mod] = anon_sym_mod,
  [anon_sym_pub] = anon_sym_pub,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_trait] = anon_sym_trait,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_union] = anon_sym_union,
  [anon_sym_unsafe] = anon_sym_unsafe,
  [anon_sym_use] = anon_sym_use,
  [anon_sym_where] = anon_sym_where,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym_ref] = anon_sym_ref,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym__] = anon_sym__,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_LT2] = anon_sym_LT,
  [anon_sym_dyn] = anon_sym_dyn,
  [sym_mutable_specifier] = sym_mutable_specifier,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym_DOT_DOT_EQ] = anon_sym_DOT_DOT_EQ,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_move] = anon_sym_move,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_AT] = anon_sym_AT,
  [sym_integer_literal] = sym_integer_literal,
  [aux_sym_string_literal_token1] = anon_sym_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [sym_char_literal] = sym_char_literal,
  [sym_escape_sequence] = sym_escape_sequence,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [sym_line_comment] = sym_line_comment,
  [sym_self] = sym_self,
  [sym_super] = sym_super,
  [sym_crate] = sym_crate,
  [sym_metavariable] = sym_metavariable,
  [sym__string_content] = sym__string_content,
  [sym_raw_string_literal] = sym_raw_string_literal,
  [sym_float_literal] = sym_float_literal,
  [sym_block_comment] = sym_block_comment,
  [sym_source_file] = sym_source_file,
  [sym__statement] = sym__statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym__expression_statement] = sym__expression_statement,
  [sym_macro_definition] = sym_macro_definition,
  [sym_macro_rule] = sym_macro_rule,
  [sym__token_pattern] = sym__token_pattern,
  [sym_token_tree_pattern] = sym_token_tree_pattern,
  [sym_token_binding_pattern] = sym_token_binding_pattern,
  [sym_token_repetition_pattern] = sym_token_repetition_pattern,
  [sym_fragment_specifier] = sym_fragment_specifier,
  [sym_token_tree] = sym_token_tree,
  [sym_token_repetition] = sym_token_repetition,
  [sym_attribute_item] = sym_attribute_item,
  [sym_inner_attribute_item] = sym_inner_attribute_item,
  [sym_meta_item] = sym_meta_item,
  [sym_meta_arguments] = sym_meta_arguments,
  [sym_mod_item] = sym_mod_item,
  [sym_foreign_mod_item] = sym_foreign_mod_item,
  [sym_declaration_list] = sym_declaration_list,
  [sym_struct_item] = sym_struct_item,
  [sym_union_item] = sym_union_item,
  [sym_enum_item] = sym_enum_item,
  [sym_enum_variant_list] = sym_enum_variant_list,
  [sym_enum_variant] = sym_enum_variant,
  [sym_field_declaration_list] = sym_field_declaration_list,
  [sym_field_declaration] = sym_field_declaration,
  [sym_ordered_field_declaration_list] = sym_ordered_field_declaration_list,
  [sym_extern_crate_declaration] = sym_extern_crate_declaration,
  [sym_const_item] = sym_const_item,
  [sym_static_item] = sym_static_item,
  [sym_type_item] = sym_type_item,
  [sym_function_item] = sym_function_item,
  [sym_function_signature_item] = sym_function_signature_item,
  [sym_function_modifiers] = sym_function_modifiers,
  [sym_where_clause] = sym_where_clause,
  [sym_where_predicate] = sym_where_predicate,
  [sym_impl_item] = sym_impl_item,
  [sym_trait_item] = sym_trait_item,
  [sym_associated_type] = sym_associated_type,
  [sym_trait_bounds] = sym_trait_bounds,
  [sym_higher_ranked_trait_bound] = sym_higher_ranked_trait_bound,
  [sym_removed_trait_bound] = sym_removed_trait_bound,
  [sym_type_parameters] = sym_type_parameters,
  [sym_const_parameter] = sym_const_parameter,
  [sym_constrained_type_parameter] = sym_constrained_type_parameter,
  [sym_optional_type_parameter] = sym_optional_type_parameter,
  [sym_let_declaration] = sym_let_declaration,
  [sym_use_declaration] = sym_use_declaration,
  [sym__use_clause] = sym__use_clause,
  [sym_scoped_use_list] = sym_scoped_use_list,
  [sym_use_list] = sym_use_list,
  [sym_use_as_clause] = sym_use_as_clause,
  [sym_use_wildcard] = sym_use_wildcard,
  [sym_parameters] = sym_parameters,
  [sym_self_parameter] = sym_self_parameter,
  [sym_variadic_parameter] = sym_variadic_parameter,
  [sym_parameter] = sym_parameter,
  [sym_extern_modifier] = sym_extern_modifier,
  [sym_visibility_modifier] = sym_visibility_modifier,
  [sym__type] = sym__type,
  [sym_bracketed_type] = sym_bracketed_type,
  [sym_qualified_type] = sym_qualified_type,
  [sym_lifetime] = sym_lifetime,
  [sym_array_type] = sym_array_type,
  [sym_for_lifetimes] = sym_for_lifetimes,
  [sym_function_type] = sym_function_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_unit_type] = sym_unit_type,
  [sym_generic_function] = sym_generic_function,
  [sym_generic_type] = sym_generic_type,
  [sym_generic_type_with_turbofish] = sym_generic_type_with_turbofish,
  [sym_bounded_type] = sym_bounded_type,
  [sym_type_arguments] = sym_type_arguments,
  [sym_type_binding] = sym_type_binding,
  [sym_reference_type] = sym_reference_type,
  [sym_pointer_type] = sym_pointer_type,
  [sym_empty_type] = sym_empty_type,
  [sym_abstract_type] = sym_abstract_type,
  [sym_dynamic_type] = sym_dynamic_type,
  [sym__expression] = sym__expression,
  [sym_macro_invocation] = sym_macro_invocation,
  [sym_scoped_identifier] = sym_scoped_identifier,
  [sym_scoped_type_identifier_in_expression_position] = sym_scoped_type_identifier,
  [sym_scoped_type_identifier] = sym_scoped_type_identifier,
  [sym_range_expression] = sym_range_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_try_expression] = sym_try_expression,
  [sym_reference_expression] = sym_reference_expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_compound_assignment_expr] = sym_compound_assignment_expr,
  [sym_type_cast_expression] = sym_type_cast_expression,
  [sym_return_expression] = sym_return_expression,
  [sym_call_expression] = sym_call_expression,
  [sym_arguments] = sym_arguments,
  [sym_array_expression] = sym_array_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_tuple_expression] = sym_tuple_expression,
  [sym_unit_expression] = sym_unit_expression,
  [sym_struct_expression] = sym_struct_expression,
  [sym_field_initializer_list] = sym_field_initializer_list,
  [sym_shorthand_field_initializer] = sym_shorthand_field_initializer,
  [sym_field_initializer] = sym_field_initializer,
  [sym_base_field_initializer] = sym_base_field_initializer,
  [sym_if_expression] = sym_if_expression,
  [sym_if_let_expression] = sym_if_let_expression,
  [sym__else_tail] = sym__else_tail,
  [sym_match_expression] = sym_match_expression,
  [sym_match_block] = sym_match_block,
  [sym_match_arm] = sym_match_arm,
  [sym_last_match_arm] = sym_match_arm,
  [sym_match_pattern] = sym_match_pattern,
  [sym_while_expression] = sym_while_expression,
  [sym_while_let_expression] = sym_while_let_expression,
  [sym_loop_expression] = sym_loop_expression,
  [sym_for_expression] = sym_for_expression,
  [sym_closure_expression] = sym_closure_expression,
  [sym_closure_parameters] = sym_closure_parameters,
  [sym_loop_label] = sym_loop_label,
  [sym_break_expression] = sym_break_expression,
  [sym_continue_expression] = sym_continue_expression,
  [sym_index_expression] = sym_index_expression,
  [sym_await_expression] = sym_await_expression,
  [sym_field_expression] = sym_field_expression,
  [sym_unsafe_block] = sym_unsafe_block,
  [sym_async_block] = sym_async_block,
  [sym_block] = sym_block,
  [sym__pattern] = sym__pattern,
  [sym_tuple_pattern] = sym_tuple_pattern,
  [sym_slice_pattern] = sym_slice_pattern,
  [sym_tuple_struct_pattern] = sym_tuple_struct_pattern,
  [sym_struct_pattern] = sym_struct_pattern,
  [sym_field_pattern] = sym_field_pattern,
  [sym_remaining_field_pattern] = sym_remaining_field_pattern,
  [sym_mut_pattern] = sym_mut_pattern,
  [sym_range_pattern] = sym_range_pattern,
  [sym_ref_pattern] = sym_ref_pattern,
  [sym_captured_pattern] = sym_captured_pattern,
  [sym_reference_pattern] = sym_reference_pattern,
  [sym_or_pattern] = sym_or_pattern,
  [sym__literal] = sym__literal,
  [sym__literal_pattern] = sym__literal_pattern,
  [sym_negative_literal] = sym_negative_literal,
  [sym_string_literal] = sym_string_literal,
  [sym_boolean_literal] = sym_boolean_literal,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym_macro_definition_repeat1] = aux_sym_macro_definition_repeat1,
  [aux_sym_token_tree_pattern_repeat1] = aux_sym_token_tree_pattern_repeat1,
  [aux_sym_token_tree_repeat1] = aux_sym_token_tree_repeat1,
  [aux_sym_meta_arguments_repeat1] = aux_sym_meta_arguments_repeat1,
  [aux_sym_declaration_list_repeat1] = aux_sym_declaration_list_repeat1,
  [aux_sym_enum_variant_list_repeat1] = aux_sym_enum_variant_list_repeat1,
  [aux_sym_enum_variant_list_repeat2] = aux_sym_enum_variant_list_repeat2,
  [aux_sym_field_declaration_list_repeat1] = aux_sym_field_declaration_list_repeat1,
  [aux_sym_ordered_field_declaration_list_repeat1] = aux_sym_ordered_field_declaration_list_repeat1,
  [aux_sym_function_modifiers_repeat1] = aux_sym_function_modifiers_repeat1,
  [aux_sym_where_clause_repeat1] = aux_sym_where_clause_repeat1,
  [aux_sym_trait_bounds_repeat1] = aux_sym_trait_bounds_repeat1,
  [aux_sym_type_parameters_repeat1] = aux_sym_type_parameters_repeat1,
  [aux_sym_use_list_repeat1] = aux_sym_use_list_repeat1,
  [aux_sym_parameters_repeat1] = aux_sym_parameters_repeat1,
  [aux_sym_for_lifetimes_repeat1] = aux_sym_for_lifetimes_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [aux_sym_type_arguments_repeat1] = aux_sym_type_arguments_repeat1,
  [aux_sym_arguments_repeat1] = aux_sym_arguments_repeat1,
  [aux_sym_array_expression_repeat1] = aux_sym_array_expression_repeat1,
  [aux_sym_tuple_expression_repeat1] = aux_sym_tuple_expression_repeat1,
  [aux_sym_field_initializer_list_repeat1] = aux_sym_field_initializer_list_repeat1,
  [aux_sym_match_block_repeat1] = aux_sym_match_block_repeat1,
  [aux_sym_closure_parameters_repeat1] = aux_sym_closure_parameters_repeat1,
  [aux_sym_tuple_pattern_repeat1] = aux_sym_tuple_pattern_repeat1,
  [aux_sym_struct_pattern_repeat1] = aux_sym_struct_pattern_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [alias_sym_field_identifier] = alias_sym_field_identifier,
  [alias_sym_primitive_type] = alias_sym_primitive_type,
  [alias_sym_shorthand_field_identifier] = alias_sym_shorthand_field_identifier,
  [alias_sym_type_identifier] = alias_sym_type_identifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_macro_rules_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_token_repetition_pattern_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_block] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_expr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ident] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_item] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lifetime] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_literal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_meta] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pat] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_path] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stmt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_tt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ty] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_vis] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_i8] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_i16] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_i32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_i64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u128] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_i128] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_isize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_usize] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_f32] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_f64] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_str] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_char] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__non_special_token_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_impl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_loop] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pub] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_trait] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_union] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsafe] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_use] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_dyn] = {
    .visible = true,
    .named = false,
  },
  [sym_mutable_specifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_move] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [sym_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_string_literal_token1] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_char_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_self] = {
    .visible = true,
    .named = true,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_crate] = {
    .visible = true,
    .named = true,
  },
  [sym_metavariable] = {
    .visible = true,
    .named = true,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_float_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_macro_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_rule] = {
    .visible = true,
    .named = true,
  },
  [sym__token_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_token_tree_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_token_binding_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_token_repetition_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_fragment_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_token_tree] = {
    .visible = true,
    .named = true,
  },
  [sym_token_repetition] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_item] = {
    .visible = true,
    .named = true,
  },
  [sym_inner_attribute_item] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_item] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_mod_item] = {
    .visible = true,
    .named = true,
  },
  [sym_foreign_mod_item] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_item] = {
    .visible = true,
    .named = true,
  },
  [sym_union_item] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_item] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_variant_list] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_variant] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_ordered_field_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_extern_crate_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_const_item] = {
    .visible = true,
    .named = true,
  },
  [sym_static_item] = {
    .visible = true,
    .named = true,
  },
  [sym_type_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_modifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_where_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_where_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_impl_item] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_item] = {
    .visible = true,
    .named = true,
  },
  [sym_associated_type] = {
    .visible = true,
    .named = true,
  },
  [sym_trait_bounds] = {
    .visible = true,
    .named = true,
  },
  [sym_higher_ranked_trait_bound] = {
    .visible = true,
    .named = true,
  },
  [sym_removed_trait_bound] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_const_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_constrained_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_let_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_use_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__use_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_scoped_use_list] = {
    .visible = true,
    .named = true,
  },
  [sym_use_list] = {
    .visible = true,
    .named = true,
  },
  [sym_use_as_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_use_wildcard] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_self_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_variadic_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_extern_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_visibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_bracketed_type] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_type] = {
    .visible = true,
    .named = true,
  },
  [sym_lifetime] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_for_lifetimes] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_unit_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_type_with_turbofish] = {
    .visible = true,
    .named = true,
  },
  [sym_bounded_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_type_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_type] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_type] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_type] = {
    .visible = true,
    .named = true,
  },
  [sym_dynamic_type] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_macro_invocation] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_type_identifier_in_expression_position] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_range_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_try_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_assignment_expr] = {
    .visible = true,
    .named = true,
  },
  [sym_type_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_return_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_array_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unit_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer_list] = {
    .visible = true,
    .named = true,
  },
  [sym_shorthand_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_base_field_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_if_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_if_let_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__else_tail] = {
    .visible = false,
    .named = true,
  },
  [sym_match_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_match_block] = {
    .visible = true,
    .named = true,
  },
  [sym_match_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_last_match_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_match_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_while_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_while_let_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_loop_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_for_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_closure_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_closure_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_loop_label] = {
    .visible = true,
    .named = true,
  },
  [sym_break_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_index_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_field_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unsafe_block] = {
    .visible = true,
    .named = true,
  },
  [sym_async_block] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_slice_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_struct_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_field_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_remaining_field_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_mut_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_range_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_captured_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_reference_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_or_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym__literal_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_negative_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_literal] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_macro_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_token_tree_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_token_tree_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_meta_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_variant_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_variant_list_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_ordered_field_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_modifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_where_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_trait_bounds_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_use_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_lifetimes_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_arguments_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_field_initializer_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_closure_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_struct_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_primitive_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_field_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_alias = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_body = 5,
  field_bounds = 6,
  field_condition = 7,
  field_consequence = 8,
  field_default_type = 9,
  field_element = 10,
  field_field = 11,
  field_function = 12,
  field_left = 13,
  field_length = 14,
  field_list = 15,
  field_macro = 16,
  field_name = 17,
  field_operator = 18,
  field_parameters = 19,
  field_path = 20,
  field_pattern = 21,
  field_return_type = 22,
  field_right = 23,
  field_trait = 24,
  field_type = 25,
  field_type_arguments = 26,
  field_type_parameters = 27,
  field_value = 28,
};

static const char *ts_field_names[] = {
  [0] = NULL,
  [field_alias] = "alias",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_body] = "body",
  [field_bounds] = "bounds",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_default_type] = "default_type",
  [field_element] = "element",
  [field_field] = "field",
  [field_function] = "function",
  [field_left] = "left",
  [field_length] = "length",
  [field_list] = "list",
  [field_macro] = "macro",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_path] = "path",
  [field_pattern] = "pattern",
  [field_return_type] = "return_type",
  [field_right] = "right",
  [field_trait] = "trait",
  [field_type] = "type",
  [field_type_arguments] = "type_arguments",
  [field_type_parameters] = "type_parameters",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[233] = {
  [4] = {.index = 0, .length = 1},
  [5] = {.index = 1, .length = 1},
  [6] = {.index = 1, .length = 1},
  [7] = {.index = 2, .length = 1},
  [8] = {.index = 3, .length = 2},
  [9] = {.index = 3, .length = 2},
  [10] = {.index = 5, .length = 2},
  [11] = {.index = 7, .length = 2},
  [12] = {.index = 9, .length = 2},
  [13] = {.index = 9, .length = 2},
  [14] = {.index = 11, .length = 2},
  [15] = {.index = 13, .length = 2},
  [16] = {.index = 13, .length = 2},
  [17] = {.index = 15, .length = 2},
  [18] = {.index = 17, .length = 1},
  [19] = {.index = 18, .length = 1},
  [20] = {.index = 18, .length = 1},
  [21] = {.index = 19, .length = 1},
  [22] = {.index = 20, .length = 2},
  [23] = {.index = 22, .length = 2},
  [24] = {.index = 20, .length = 2},
  [25] = {.index = 24, .length = 1},
  [26] = {.index = 25, .length = 2},
  [27] = {.index = 11, .length = 2},
  [28] = {.index = 27, .length = 1},
  [29] = {.index = 28, .length = 1},
  [30] = {.index = 29, .length = 2},
  [31] = {.index = 31, .length = 1},
  [32] = {.index = 32, .length = 2},
  [33] = {.index = 34, .length = 1},
  [34] = {.index = 9, .length = 2},
  [35] = {.index = 9, .length = 2},
  [36] = {.index = 35, .length = 2},
  [37] = {.index = 37, .length = 2},
  [38] = {.index = 39, .length = 1},
  [39] = {.index = 9, .length = 2},
  [40] = {.index = 9, .length = 2},
  [41] = {.index = 40, .length = 3},
  [42] = {.index = 43, .length = 2},
  [43] = {.index = 45, .length = 2},
  [44] = {.index = 47, .length = 2},
  [45] = {.index = 47, .length = 2},
  [46] = {.index = 37, .length = 2},
  [47] = {.index = 49, .length = 1},
  [48] = {.index = 50, .length = 2},
  [49] = {.index = 52, .length = 3},
  [50] = {.index = 55, .length = 2},
  [51] = {.index = 57, .length = 3},
  [53] = {.index = 60, .length = 1},
  [54] = {.index = 60, .length = 1},
  [55] = {.index = 49, .length = 1},
  [57] = {.index = 61, .length = 3},
  [58] = {.index = 64, .length = 1},
  [59] = {.index = 65, .length = 1},
  [61] = {.index = 66, .length = 2},
  [62] = {.index = 66, .length = 2},
  [63] = {.index = 68, .length = 1},
  [64] = {.index = 69, .length = 3},
  [65] = {.index = 72, .length = 2},
  [66] = {.index = 74, .length = 2},
  [67] = {.index = 74, .length = 2},
  [68] = {.index = 76, .length = 1},
  [69] = {.index = 77, .length = 2},
  [70] = {.index = 79, .length = 3},
  [71] = {.index = 82, .length = 2},
  [72] = {.index = 84, .length = 2},
  [73] = {.index = 86, .length = 2},
  [74] = {.index = 88, .length = 2},
  [75] = {.index = 90, .length = 2},
  [76] = {.index = 88, .length = 2},
  [77] = {.index = 90, .length = 2},
  [78] = {.index = 92, .length = 1},
  [79] = {.index = 92, .length = 1},
  [80] = {.index = 93, .length = 1},
  [81] = {.index = 94, .length = 2},
  [82] = {.index = 96, .length = 2},
  [83] = {.index = 96, .length = 2},
  [84] = {.index = 86, .length = 2},
  [85] = {.index = 93, .length = 1},
  [86] = {.index = 98, .length = 1},
  [87] = {.index = 99, .length = 3},
  [88] = {.index = 102, .length = 1},
  [89] = {.index = 103, .length = 1},
  [90] = {.index = 104, .length = 2},
  [91] = {.index = 66, .length = 2},
  [92] = {.index = 106, .length = 3},
  [93] = {.index = 109, .length = 3},
  [94] = {.index = 112, .length = 4},
  [95] = {.index = 116, .length = 3},
  [96] = {.index = 1, .length = 1},
  [97] = {.index = 119, .length = 3},
  [98] = {.index = 122, .length = 1},
  [99] = {.index = 123, .length = 2},
  [100] = {.index = 125, .length = 2},
  [101] = {.index = 125, .length = 2},
  [102] = {.index = 127, .length = 1},
  [103] = {.index = 128, .length = 3},
  [104] = {.index = 131, .length = 3},
  [105] = {.index = 134, .length = 3},
  [106] = {.index = 137, .length = 1},
  [107] = {.index = 128, .length = 3},
  [108] = {.index = 131, .length = 3},
  [109] = {.index = 138, .length = 2},
  [110] = {.index = 140, .length = 2},
  [112] = {.index = 142, .length = 3},
  [113] = {.index = 145, .length = 4},
  [114] = {.index = 104, .length = 2},
  [115] = {.index = 149, .length = 3},
  [116] = {.index = 152, .length = 2},
  [117] = {.index = 154, .length = 2},
  [118] = {.index = 156, .length = 3},
  [119] = {.index = 159, .length = 3},
  [120] = {.index = 31, .length = 1},
  [121] = {.index = 138, .length = 2},
  [122] = {.index = 162, .length = 3},
  [123] = {.index = 165, .length = 2},
  [124] = {.index = 167, .length = 2},
  [125] = {.index = 169, .length = 3},
  [126] = {.index = 172, .length = 2},
  [127] = {.index = 174, .length = 2},
  [128] = {.index = 176, .length = 1},
  [129] = {.index = 177, .length = 2},
  [130] = {.index = 179, .length = 1},
  [131] = {.index = 165, .length = 2},
  [132] = {.index = 180, .length = 2},
  [133] = {.index = 182, .length = 4},
  [134] = {.index = 186, .length = 3},
  [135] = {.index = 189, .length = 4},
  [136] = {.index = 93, .length = 1},
  [137] = {.index = 193, .length = 2},
  [138] = {.index = 195, .length = 2},
  [139] = {.index = 197, .length = 3},
  [140] = {.index = 200, .length = 2},
  [141] = {.index = 202, .length = 3},
  [142] = {.index = 205, .length = 2},
  [143] = {.index = 207, .length = 4},
  [144] = {.index = 207, .length = 4},
  [145] = {.index = 211, .length = 3},
  [146] = {.index = 211, .length = 3},
  [147] = {.index = 202, .length = 3},
  [148] = {.index = 214, .length = 2},
  [149] = {.index = 216, .length = 2},
  [150] = {.index = 218, .length = 2},
  [151] = {.index = 220, .length = 1},
  [152] = {.index = 221, .length = 2},
  [153] = {.index = 223, .length = 2},
  [154] = {.index = 195, .length = 2},
  [155] = {.index = 225, .length = 4},
  [156] = {.index = 229, .length = 3},
  [157] = {.index = 232, .length = 3},
  [158] = {.index = 235, .length = 3},
  [159] = {.index = 232, .length = 3},
  [160] = {.index = 238, .length = 3},
  [161] = {.index = 241, .length = 3},
  [162] = {.index = 244, .length = 4},
  [163] = {.index = 248, .length = 3},
  [164] = {.index = 251, .length = 2},
  [165] = {.index = 253, .length = 2},
  [166] = {.index = 255, .length = 3},
  [167] = {.index = 258, .length = 4},
  [168] = {.index = 262, .length = 3},
  [169] = {.index = 221, .length = 2},
  [170] = {.index = 265, .length = 2},
  [171] = {.index = 267, .length = 3},
  [172] = {.index = 270, .length = 3},
  [173] = {.index = 273, .length = 2},
  [174] = {.index = 275, .length = 3},
  [175] = {.index = 195, .length = 2},
  [176] = {.index = 278, .length = 3},
  [177] = {.index = 281, .length = 3},
  [178] = {.index = 253, .length = 2},
  [179] = {.index = 284, .length = 4},
  [180] = {.index = 288, .length = 5},
  [181] = {.index = 293, .length = 4},
  [182] = {.index = 297, .length = 2},
  [183] = {.index = 299, .length = 4},
  [184] = {.index = 303, .length = 4},
  [185] = {.index = 303, .length = 4},
  [186] = {.index = 307, .length = 2},
  [187] = {.index = 309, .length = 3},
  [188] = {.index = 312, .length = 2},
  [189] = {.index = 314, .length = 2},
  [190] = {.index = 104, .length = 2},
  [191] = {.index = 316, .length = 3},
  [192] = {.index = 319, .length = 4},
  [193] = {.index = 319, .length = 4},
  [194] = {.index = 316, .length = 3},
  [195] = {.index = 323, .length = 4},
  [196] = {.index = 327, .length = 4},
  [197] = {.index = 331, .length = 3},
  [198] = {.index = 334, .length = 4},
  [199] = {.index = 338, .length = 3},
  [200] = {.index = 341, .length = 3},
  [201] = {.index = 344, .length = 3},
  [202] = {.index = 347, .length = 4},
  [203] = {.index = 351, .length = 2},
  [204] = {.index = 353, .length = 3},
  [205] = {.index = 356, .length = 4},
  [206] = {.index = 360, .length = 3},
  [207] = {.index = 363, .length = 3},
  [208] = {.index = 366, .length = 3},
  [209] = {.index = 369, .length = 5},
  [210] = {.index = 374, .length = 2},
  [211] = {.index = 376, .length = 3},
  [212] = {.index = 379, .length = 3},
  [213] = {.index = 382, .length = 2},
  [214] = {.index = 384, .length = 4},
  [215] = {.index = 384, .length = 4},
  [216] = {.index = 388, .length = 4},
  [217] = {.index = 392, .length = 5},
  [218] = {.index = 397, .length = 4},
  [219] = {.index = 401, .length = 2},
  [220] = {.index = 403, .length = 4},
  [221] = {.index = 407, .length = 4},
  [222] = {.index = 411, .length = 3},
  [223] = {.index = 414, .length = 4},
  [224] = {.index = 418, .length = 3},
  [225] = {.index = 421, .length = 3},
  [226] = {.index = 424, .length = 2},
  [227] = {.index = 426, .length = 5},
  [228] = {.index = 431, .length = 4},
  [229] = {.index = 435, .length = 5},
  [230] = {.index = 440, .length = 4},
  [231] = {.index = 444, .length = 3},
  [232] = {.index = 447, .length = 5},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_body, 1},
  [1] =
    {field_name, 1},
  [2] =
    {field_value, 1},
  [3] =
    {field_body, 1},
    {field_name, 0},
  [5] =
    {field_arguments, 1},
    {field_function, 0},
  [7] =
    {field_body, 1},
    {field_parameters, 0},
  [9] =
    {field_name, 2},
    {field_path, 0},
  [11] =
    {field_body, 2},
    {field_name, 1},
  [13] =
    {field_type, 0},
    {field_type_arguments, 1},
  [15] =
    {field_condition, 1},
    {field_consequence, 2},
  [17] =
    {field_parameters, 1},
  [18] =
    {field_trait, 1},
  [19] =
    {field_type, 1},
  [20] =
    {field_parameters, 1},
    {field_trait, 0},
  [22] =
    {field_body, 2},
    {field_type, 1},
  [24] =
    {field_pattern, 1},
  [25] =
    {field_body, 2},
    {field_value, 1},
  [27] =
    {field_list, 1},
  [28] =
    {field_argument, 1},
  [29] =
    {field_body, 2},
    {field_condition, 1},
  [31] =
    {field_value, 2},
  [32] =
    {field_body, 2},
    {field_parameters, 1},
  [34] =
    {field_macro, 0},
  [35] =
    {field_function, 0},
    {field_type_arguments, 2},
  [37] =
    {field_type, 0},
    {field_type_arguments, 2},
  [39] =
    {field_body, 2},
  [40] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [43] =
    {field_type, 2},
    {field_value, 0},
  [45] =
    {field_left, 0},
    {field_right, 2},
  [47] =
    {field_field, 2},
    {field_value, 0},
  [49] =
    {field_name, 0},
  [50] =
    {field_body, 3},
    {field_name, 1},
  [52] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [55] =
    {field_name, 1},
    {field_parameters, 2},
  [57] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2},
  [60] =
    {field_type, 0},
  [61] =
    {field_alternative, 3, .inherited = true},
    {field_condition, 1},
    {field_consequence, 2},
  [64] =
    {field_element, 1},
  [65] =
    {field_type, 2},
  [66] =
    {field_bounds, 1},
    {field_left, 0},
  [68] =
    {field_parameters, 2},
  [69] =
    {field_body, 3},
    {field_type, 2},
    {field_type_parameters, 1},
  [72] =
    {field_body, 3},
    {field_type, 1},
  [74] =
    {field_parameters, 2},
    {field_trait, 1},
  [76] =
    {field_pattern, 2},
  [77] =
    {field_name, 1},
    {field_type_parameters, 2},
  [79] =
    {field_body, 3},
    {field_bounds, 2},
    {field_name, 1},
  [82] =
    {field_bounds, 2},
    {field_name, 1},
  [84] =
    {field_body, 3},
    {field_type, 2},
  [86] =
    {field_body, 3},
    {field_name, 2},
  [88] =
    {field_alias, 2},
    {field_path, 0},
  [90] =
    {field_list, 2},
    {field_path, 0},
  [92] =
    {field_arguments, 1},
  [93] =
    {field_name, 2},
  [94] =
    {field_alias, 2},
    {field_type, 0},
  [96] =
    {field_pattern, 0},
    {field_type, 2},
  [98] =
    {field_argument, 2},
  [99] =
    {field_body, 3},
    {field_parameters, 0},
    {field_return_type, 2},
  [102] =
    {field_body, 3},
  [103] =
    {field_length, 3},
  [104] =
    {field_name, 1},
    {field_type, 3},
  [106] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [109] =
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [112] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [116] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
  [119] =
    {field_body, 4},
    {field_pattern, 1},
    {field_value, 3},
  [122] =
    {field_alternative, 1},
  [123] =
    {field_parameters, 1},
    {field_return_type, 3},
  [125] =
    {field_default_type, 2},
    {field_name, 0},
  [127] =
    {field_type, 3},
  [128] =
    {field_body, 4},
    {field_trait, 1},
    {field_type, 3},
  [131] =
    {field_parameters, 1},
    {field_return_type, 3},
    {field_trait, 0},
  [134] =
    {field_body, 4},
    {field_type, 2},
    {field_type_parameters, 1},
  [137] =
    {field_parameters, 3},
  [138] =
    {field_pattern, 1},
    {field_type, 3},
  [140] =
    {field_pattern, 1},
    {field_value, 3},
  [142] =
    {field_body, 4},
    {field_bounds, 2},
    {field_name, 1},
  [145] =
    {field_body, 4},
    {field_bounds, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [149] =
    {field_body, 4},
    {field_type, 3},
    {field_type_parameters, 2},
  [152] =
    {field_body, 4},
    {field_type, 2},
  [154] =
    {field_body, 4},
    {field_name, 2},
  [156] =
    {field_body, 4},
    {field_bounds, 3},
    {field_name, 2},
  [159] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [162] =
    {field_body, 4},
    {field_parameters, 1},
    {field_return_type, 3},
  [165] =
    {field_name, 0},
    {field_value, 2},
  [167] =
    {field_name, 2},
    {field_parameters, 3},
  [169] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
  [172] =
    {field_name, 2},
    {field_type_parameters, 3},
  [174] =
    {field_body, 4},
    {field_name, 3},
  [176] =
    {field_name, 3},
  [177] =
    {field_body, 4},
    {field_condition, 3},
  [179] =
    {field_length, 4},
  [180] =
    {field_type, 2},
    {field_type_parameters, 1},
  [182] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [186] =
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [189] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [193] =
    {field_name, 0},
    {field_pattern, 2},
  [195] =
    {field_name, 0},
    {field_type, 2},
  [197] =
    {field_consequence, 5},
    {field_pattern, 2},
    {field_value, 4},
  [200] =
    {field_element, 1},
    {field_length, 3},
  [202] =
    {field_body, 5},
    {field_trait, 1},
    {field_type, 3},
  [205] =
    {field_parameters, 2},
    {field_return_type, 4},
  [207] =
    {field_body, 5},
    {field_trait, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [211] =
    {field_parameters, 2},
    {field_return_type, 4},
    {field_trait, 1},
  [214] =
    {field_pattern, 2},
    {field_type, 4},
  [216] =
    {field_pattern, 2},
    {field_value, 4},
  [218] =
    {field_pattern, 0},
    {field_value, 2},
  [220] =
    {field_condition, 2},
  [221] =
    {field_name, 2},
    {field_type, 4},
  [223] =
    {field_type, 0, .inherited = true},
    {field_type, 1, .inherited = true},
  [225] =
    {field_body, 5},
    {field_bounds, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [229] =
    {field_name, 1},
    {field_type, 4},
    {field_type_parameters, 2},
  [232] =
    {field_body, 5},
    {field_trait, 2},
    {field_type, 4},
  [235] =
    {field_body, 5},
    {field_type, 3},
    {field_type_parameters, 2},
  [238] =
    {field_body, 5},
    {field_bounds, 3},
    {field_name, 2},
  [241] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [244] =
    {field_body, 5},
    {field_bounds, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [248] =
    {field_body, 5},
    {field_pattern, 2},
    {field_value, 4},
  [251] =
    {field_alias, 4},
    {field_name, 2},
  [253] =
    {field_name, 1},
    {field_value, 3},
  [255] =
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [258] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [262] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
  [265] =
    {field_body, 5},
    {field_name, 3},
  [267] =
    {field_body, 5},
    {field_bounds, 4},
    {field_name, 3},
  [270] =
    {field_body, 5},
    {field_name, 3},
    {field_type_parameters, 4},
  [273] =
    {field_name, 3},
    {field_parameters, 4},
  [275] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4},
  [278] =
    {field_name, 1},
    {field_type, 3},
    {field_value, 5},
  [281] =
    {field_body, 1},
    {field_name, 0},
    {field_value, 3},
  [284] =
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [288] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [293] =
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 2},
    {field_return_type, 4},
  [297] =
    {field_name, 1},
    {field_pattern, 3},
  [299] =
    {field_alternative, 6, .inherited = true},
    {field_consequence, 5},
    {field_pattern, 2},
    {field_value, 4},
  [303] =
    {field_body, 6},
    {field_trait, 2},
    {field_type, 4},
    {field_type_parameters, 1},
  [307] =
    {field_parameters, 3},
    {field_return_type, 5},
  [309] =
    {field_pattern, 1},
    {field_type, 3},
    {field_value, 5},
  [312] =
    {field_name, 3},
    {field_type, 5},
  [314] =
    {field_type, 1},
    {field_type, 2, .inherited = true},
  [316] =
    {field_body, 6},
    {field_trait, 2},
    {field_type, 4},
  [319] =
    {field_body, 6},
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [323] =
    {field_body, 6},
    {field_bounds, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [327] =
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [331] =
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [334] =
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [338] =
    {field_name, 2},
    {field_type, 5},
    {field_type_parameters, 3},
  [341] =
    {field_body, 6},
    {field_bounds, 4},
    {field_name, 3},
  [344] =
    {field_body, 6},
    {field_name, 3},
    {field_type_parameters, 4},
  [347] =
    {field_body, 6},
    {field_bounds, 5},
    {field_name, 3},
    {field_type_parameters, 4},
  [351] =
    {field_alias, 5},
    {field_name, 3},
  [353] =
    {field_name, 3},
    {field_parameters, 5},
    {field_type_parameters, 4},
  [356] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5},
    {field_type_parameters, 4},
  [360] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 4},
  [363] =
    {field_body, 6},
    {field_pattern, 3},
    {field_value, 5},
  [366] =
    {field_body, 2},
    {field_name, 1},
    {field_value, 4},
  [369] =
    {field_body, 7},
    {field_name, 1},
    {field_parameters, 3},
    {field_return_type, 5},
    {field_type_parameters, 2},
  [374] =
    {field_name, 2},
    {field_pattern, 4},
  [376] =
    {field_pattern, 2},
    {field_type, 4},
    {field_value, 6},
  [379] =
    {field_name, 2},
    {field_type, 4},
    {field_value, 6},
  [382] =
    {field_type, 2},
    {field_type, 3, .inherited = true},
  [384] =
    {field_body, 7},
    {field_trait, 3},
    {field_type, 5},
    {field_type_parameters, 2},
  [388] =
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [392] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [397] =
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 3},
    {field_return_type, 5},
  [401] =
    {field_name, 4},
    {field_type, 6},
  [403] =
    {field_body, 7},
    {field_bounds, 5},
    {field_name, 3},
    {field_type_parameters, 4},
  [407] =
    {field_body, 7},
    {field_name, 3},
    {field_parameters, 5},
    {field_type_parameters, 4},
  [411] =
    {field_name, 3},
    {field_parameters, 4},
    {field_return_type, 6},
  [414] =
    {field_body, 7},
    {field_name, 3},
    {field_parameters, 4},
    {field_return_type, 6},
  [418] =
    {field_body, 7},
    {field_pattern, 4},
    {field_value, 6},
  [421] =
    {field_name, 3},
    {field_type, 5},
    {field_value, 7},
  [424] =
    {field_type, 3},
    {field_type, 4, .inherited = true},
  [426] =
    {field_body, 8},
    {field_name, 2},
    {field_parameters, 4},
    {field_return_type, 6},
    {field_type_parameters, 3},
  [431] =
    {field_name, 3},
    {field_parameters, 5},
    {field_return_type, 7},
    {field_type_parameters, 4},
  [435] =
    {field_body, 8},
    {field_name, 3},
    {field_parameters, 5},
    {field_return_type, 7},
    {field_type_parameters, 4},
  [440] =
    {field_body, 8},
    {field_name, 3},
    {field_parameters, 4},
    {field_return_type, 6},
  [444] =
    {field_name, 4},
    {field_type, 6},
    {field_value, 8},
  [447] =
    {field_body, 9},
    {field_name, 3},
    {field_parameters, 5},
    {field_return_type, 7},
    {field_type_parameters, 4},
};

static TSSymbol ts_alias_sequences[233][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [1] = {
    [0] = sym_identifier,
  },
  [2] = {
    [0] = alias_sym_primitive_type,
  },
  [3] = {
    [0] = alias_sym_type_identifier,
  },
  [6] = {
    [1] = alias_sym_type_identifier,
  },
  [8] = {
    [0] = alias_sym_type_identifier,
  },
  [12] = {
    [0] = sym_identifier,
  },
  [13] = {
    [0] = sym_identifier,
    [2] = alias_sym_type_identifier,
  },
  [14] = {
    [1] = alias_sym_type_identifier,
  },
  [15] = {
    [0] = alias_sym_type_identifier,
  },
  [19] = {
    [1] = alias_sym_type_identifier,
  },
  [22] = {
    [0] = alias_sym_type_identifier,
  },
  [35] = {
    [2] = alias_sym_type_identifier,
  },
  [37] = {
    [0] = alias_sym_type_identifier,
  },
  [39] = {
    [0] = sym_generic_type,
  },
  [40] = {
    [0] = sym_generic_type,
    [2] = alias_sym_type_identifier,
  },
  [45] = {
    [2] = alias_sym_field_identifier,
  },
  [48] = {
    [1] = alias_sym_type_identifier,
  },
  [49] = {
    [1] = alias_sym_type_identifier,
  },
  [52] = {
    [0] = sym_identifier,
    [2] = sym_identifier,
  },
  [54] = {
    [0] = alias_sym_type_identifier,
  },
  [55] = {
    [0] = alias_sym_shorthand_field_identifier,
  },
  [56] = {
    [2] = sym_identifier,
  },
  [60] = {
    [1] = alias_sym_type_identifier,
  },
  [61] = {
    [0] = alias_sym_type_identifier,
  },
  [66] = {
    [1] = alias_sym_type_identifier,
  },
  [69] = {
    [1] = alias_sym_type_identifier,
  },
  [70] = {
    [1] = alias_sym_type_identifier,
  },
  [71] = {
    [1] = alias_sym_type_identifier,
  },
  [73] = {
    [2] = alias_sym_type_identifier,
  },
  [74] = {
    [0] = sym_identifier,
  },
  [75] = {
    [0] = sym_identifier,
  },
  [78] = {
    [0] = sym_identifier,
  },
  [82] = {
    [0] = sym_identifier,
  },
  [85] = {
    [2] = alias_sym_type_identifier,
  },
  [91] = {
    [0] = alias_sym_primitive_type,
  },
  [92] = {
    [1] = alias_sym_type_identifier,
  },
  [96] = {
    [1] = alias_sym_shorthand_field_identifier,
  },
  [100] = {
    [0] = alias_sym_type_identifier,
  },
  [103] = {
    [1] = alias_sym_type_identifier,
  },
  [104] = {
    [0] = alias_sym_type_identifier,
  },
  [111] = {
    [3] = sym_identifier,
  },
  [112] = {
    [1] = alias_sym_type_identifier,
  },
  [113] = {
    [1] = alias_sym_type_identifier,
  },
  [114] = {
    [1] = alias_sym_type_identifier,
  },
  [117] = {
    [2] = alias_sym_type_identifier,
  },
  [118] = {
    [2] = alias_sym_type_identifier,
  },
  [119] = {
    [2] = alias_sym_type_identifier,
  },
  [120] = {
    [0] = sym_identifier,
  },
  [121] = {
    [1] = sym_identifier,
  },
  [123] = {
    [0] = alias_sym_field_identifier,
  },
  [126] = {
    [2] = alias_sym_type_identifier,
  },
  [127] = {
    [3] = alias_sym_type_identifier,
  },
  [136] = {
    [2] = alias_sym_shorthand_field_identifier,
  },
  [137] = {
    [0] = alias_sym_field_identifier,
  },
  [138] = {
    [0] = alias_sym_type_identifier,
  },
  [141] = {
    [1] = alias_sym_type_identifier,
  },
  [143] = {
    [2] = alias_sym_type_identifier,
  },
  [145] = {
    [1] = alias_sym_type_identifier,
  },
  [154] = {
    [0] = alias_sym_field_identifier,
  },
  [155] = {
    [1] = alias_sym_type_identifier,
  },
  [156] = {
    [1] = alias_sym_type_identifier,
  },
  [157] = {
    [2] = alias_sym_type_identifier,
  },
  [160] = {
    [2] = alias_sym_type_identifier,
  },
  [161] = {
    [2] = alias_sym_type_identifier,
  },
  [162] = {
    [2] = alias_sym_type_identifier,
  },
  [165] = {
    [1] = alias_sym_field_identifier,
  },
  [169] = {
    [2] = alias_sym_type_identifier,
  },
  [170] = {
    [3] = alias_sym_type_identifier,
  },
  [171] = {
    [3] = alias_sym_type_identifier,
  },
  [172] = {
    [3] = alias_sym_type_identifier,
  },
  [182] = {
    [1] = alias_sym_field_identifier,
  },
  [184] = {
    [2] = alias_sym_type_identifier,
  },
  [190] = {
    [1] = alias_sym_field_identifier,
  },
  [191] = {
    [2] = alias_sym_type_identifier,
  },
  [192] = {
    [3] = alias_sym_type_identifier,
  },
  [195] = {
    [2] = alias_sym_type_identifier,
  },
  [199] = {
    [2] = alias_sym_type_identifier,
  },
  [200] = {
    [3] = alias_sym_type_identifier,
  },
  [201] = {
    [3] = alias_sym_type_identifier,
  },
  [202] = {
    [3] = alias_sym_type_identifier,
  },
  [210] = {
    [2] = alias_sym_field_identifier,
  },
  [214] = {
    [3] = alias_sym_type_identifier,
  },
  [220] = {
    [3] = alias_sym_type_identifier,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(58);
      if (lookahead == '!') ADVANCE(89);
      if (lookahead == '"') ADVANCE(148);
      if (lookahead == '#') ADVANCE(87);
      if (lookahead == '$') ADVANCE(71);
      if (lookahead == '%') ADVANCE(125);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(86);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '*') ADVANCE(79);
      if (lookahead == '+') ADVANCE(77);
      if (lookahead == ',') ADVANCE(94);
      if (lookahead == '-') ADVANCE(111);
      if (lookahead == '.') ADVANCE(136);
      if (lookahead == '/') ADVANCE(124);
      if (lookahead == '0') ADVANCE(142);
      if (lookahead == ':') ADVANCE(69);
      if (lookahead == ';') ADVANCE(59);
      if (lookahead == '<') ADVANCE(104);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(99);
      if (lookahead == '?') ADVANCE(80);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(66);
      if (lookahead == '\\') ADVANCE(35);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == '^') ADVANCE(117);
      if (lookahead == 'b') ADVANCE(153);
      if (lookahead == 'm') ADVANCE(157);
      if (lookahead == 'r') ADVANCE(155);
      if (lookahead == '{') ADVANCE(63);
      if (lookahead == '|') ADVANCE(116);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(55)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(145);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 1:
      if (lookahead == '!') ADVANCE(89);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '#') ADVANCE(87);
      if (lookahead == '$') ADVANCE(53);
      if (lookahead == '%') ADVANCE(125);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(86);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '*') ADVANCE(79);
      if (lookahead == '+') ADVANCE(77);
      if (lookahead == ',') ADVANCE(94);
      if (lookahead == '-') ADVANCE(110);
      if (lookahead == '.') ADVANCE(136);
      if (lookahead == '/') ADVANCE(124);
      if (lookahead == '0') ADVANCE(142);
      if (lookahead == ':') ADVANCE(69);
      if (lookahead == ';') ADVANCE(59);
      if (lookahead == '<') ADVANCE(97);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(99);
      if (lookahead == '?') ADVANCE(80);
      if (lookahead == '[') ADVANCE(66);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == '^') ADVANCE(117);
      if (lookahead == 'b') ADVANCE(153);
      if (lookahead == 'r') ADVANCE(155);
      if (lookahead == '{') ADVANCE(63);
      if (lookahead == '|') ADVANCE(116);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(1)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(145);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 2:
      if (lookahead == '!') ADVANCE(89);
      if (lookahead == '%') ADVANCE(125);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(85);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '*') ADVANCE(79);
      if (lookahead == '+') ADVANCE(77);
      if (lookahead == ',') ADVANCE(94);
      if (lookahead == '-') ADVANCE(111);
      if (lookahead == '.') ADVANCE(136);
      if (lookahead == '/') ADVANCE(124);
      if (lookahead == ':') ADVANCE(30);
      if (lookahead == ';') ADVANCE(59);
      if (lookahead == '<') ADVANCE(97);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(99);
      if (lookahead == '?') ADVANCE(80);
      if (lookahead == '[') ADVANCE(66);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == '^') ADVANCE(117);
      if (lookahead == 'r') ADVANCE(155);
      if (lookahead == '{') ADVANCE(63);
      if (lookahead == '|') ADVANCE(116);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(2)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(89);
      if (lookahead == '%') ADVANCE(125);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '*') ADVANCE(79);
      if (lookahead == '+') ADVANCE(77);
      if (lookahead == ',') ADVANCE(94);
      if (lookahead == '-') ADVANCE(110);
      if (lookahead == '.') ADVANCE(136);
      if (lookahead == '/') ADVANCE(124);
      if (lookahead == ':') ADVANCE(30);
      if (lookahead == ';') ADVANCE(59);
      if (lookahead == '<') ADVANCE(104);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(99);
      if (lookahead == '?') ADVANCE(80);
      if (lookahead == '[') ADVANCE(66);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == '^') ADVANCE(117);
      if (lookahead == 'r') ADVANCE(155);
      if (lookahead == '{') ADVANCE(63);
      if (lookahead == '|') ADVANCE(116);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(3)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '"') ADVANCE(148);
      if (lookahead == '#') ADVANCE(87);
      if (lookahead == '$') ADVANCE(53);
      if (lookahead == '\'') ADVANCE(85);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '+') ADVANCE(76);
      if (lookahead == ',') ADVANCE(94);
      if (lookahead == '.') ADVANCE(22);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == ':') ADVANCE(69);
      if (lookahead == ';') ADVANCE(59);
      if (lookahead == '<') ADVANCE(96);
      if (lookahead == '=') ADVANCE(90);
      if (lookahead == '>') ADVANCE(98);
      if (lookahead == '\\') ADVANCE(35);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == 'm') ADVANCE(157);
      if (lookahead == 'r') ADVANCE(155);
      if (lookahead == '|') ADVANCE(115);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(8)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '#') ADVANCE(87);
      if (lookahead == '$') ADVANCE(53);
      if (lookahead == '&') ADVANCE(101);
      if (lookahead == '\'') ADVANCE(86);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '*') ADVANCE(78);
      if (lookahead == ',') ADVANCE(94);
      if (lookahead == '-') ADVANCE(112);
      if (lookahead == '.') ADVANCE(20);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '0') ADVANCE(142);
      if (lookahead == ':') ADVANCE(30);
      if (lookahead == '<') ADVANCE(96);
      if (lookahead == '>') ADVANCE(98);
      if (lookahead == '[') ADVANCE(66);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == 'b') ADVANCE(153);
      if (lookahead == 'r') ADVANCE(155);
      if (lookahead == '{') ADVANCE(63);
      if (lookahead == '|') ADVANCE(115);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(5)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(145);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 6:
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '#') ADVANCE(87);
      if (lookahead == '$') ADVANCE(53);
      if (lookahead == '&') ADVANCE(101);
      if (lookahead == '\'') ADVANCE(86);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '*') ADVANCE(78);
      if (lookahead == ',') ADVANCE(94);
      if (lookahead == '-') ADVANCE(109);
      if (lookahead == '.') ADVANCE(21);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '0') ADVANCE(142);
      if (lookahead == ':') ADVANCE(30);
      if (lookahead == '<') ADVANCE(96);
      if (lookahead == '[') ADVANCE(66);
      if (lookahead == 'b') ADVANCE(153);
      if (lookahead == 'r') ADVANCE(155);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(6)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(145);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 7:
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '#') ADVANCE(87);
      if (lookahead == '$') ADVANCE(53);
      if (lookahead == '&') ADVANCE(101);
      if (lookahead == '\'') ADVANCE(85);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '*') ADVANCE(78);
      if (lookahead == '+') ADVANCE(76);
      if (lookahead == ',') ADVANCE(94);
      if (lookahead == '-') ADVANCE(32);
      if (lookahead == '.') ADVANCE(22);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '0') ADVANCE(142);
      if (lookahead == ':') ADVANCE(69);
      if (lookahead == ';') ADVANCE(59);
      if (lookahead == '<') ADVANCE(96);
      if (lookahead == '=') ADVANCE(93);
      if (lookahead == '>') ADVANCE(98);
      if (lookahead == '?') ADVANCE(80);
      if (lookahead == '[') ADVANCE(66);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == 'r') ADVANCE(155);
      if (lookahead == '{') ADVANCE(63);
      if (lookahead == '|') ADVANCE(115);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(7)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(145);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 8:
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '#') ADVANCE(87);
      if (lookahead == '$') ADVANCE(53);
      if (lookahead == '\'') ADVANCE(85);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '+') ADVANCE(76);
      if (lookahead == ',') ADVANCE(94);
      if (lookahead == '.') ADVANCE(22);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == ':') ADVANCE(69);
      if (lookahead == ';') ADVANCE(59);
      if (lookahead == '<') ADVANCE(96);
      if (lookahead == '=') ADVANCE(90);
      if (lookahead == '>') ADVANCE(98);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == 'm') ADVANCE(157);
      if (lookahead == 'r') ADVANCE(155);
      if (lookahead == '|') ADVANCE(115);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(8)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 9:
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '+') ADVANCE(76);
      if (lookahead == ',') ADVANCE(94);
      if (lookahead == '.') ADVANCE(22);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == ':') ADVANCE(69);
      if (lookahead == ';') ADVANCE(59);
      if (lookahead == '<') ADVANCE(104);
      if (lookahead == '=') ADVANCE(93);
      if (lookahead == '>') ADVANCE(98);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == 'r') ADVANCE(155);
      if (lookahead == '{') ADVANCE(63);
      if (lookahead == '|') ADVANCE(115);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(9)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 10:
      if (lookahead == '!') ADVANCE(31);
      if (lookahead == '%') ADVANCE(125);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '*') ADVANCE(79);
      if (lookahead == '+') ADVANCE(77);
      if (lookahead == ',') ADVANCE(94);
      if (lookahead == '-') ADVANCE(110);
      if (lookahead == '.') ADVANCE(136);
      if (lookahead == '/') ADVANCE(124);
      if (lookahead == ':') ADVANCE(68);
      if (lookahead == ';') ADVANCE(59);
      if (lookahead == '<') ADVANCE(97);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(99);
      if (lookahead == '?') ADVANCE(80);
      if (lookahead == '[') ADVANCE(66);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == '^') ADVANCE(117);
      if (lookahead == 'r') ADVANCE(155);
      if (lookahead == '{') ADVANCE(63);
      if (lookahead == '|') ADVANCE(116);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(10)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '$') ADVANCE(71);
      if (lookahead == '\'') ADVANCE(86);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '/') ADVANCE(81);
      if (lookahead == '0') ADVANCE(142);
      if (lookahead == ':') ADVANCE(70);
      if (lookahead == '[') ADVANCE(66);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == '_') ADVANCE(82);
      if (lookahead == 'b') ADVANCE(153);
      if (lookahead == 'r') ADVANCE(155);
      if (lookahead == '{') ADVANCE(63);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(11)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(145);
      if (('!' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          ('|' <= lookahead && lookahead <= '~')) ADVANCE(83);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '$') ADVANCE(71);
      if (lookahead == '\'') ADVANCE(86);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '/') ADVANCE(81);
      if (lookahead == '0') ADVANCE(142);
      if (lookahead == '[') ADVANCE(66);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == '_') ADVANCE(82);
      if (lookahead == 'b') ADVANCE(153);
      if (lookahead == 'r') ADVANCE(155);
      if (lookahead == '{') ADVANCE(63);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(12)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(145);
      if (('!' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          ('|' <= lookahead && lookahead <= '~')) ADVANCE(83);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == ':') ADVANCE(68);
      if (lookahead == ';') ADVANCE(59);
      if (lookahead == '<') ADVANCE(96);
      if (lookahead == '=') ADVANCE(90);
      if (lookahead == 'b') ADVANCE(154);
      if (lookahead == 'r') ADVANCE(155);
      if (lookahead == '{') ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(13)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 14:
      if (lookahead == '#') ADVANCE(87);
      if (lookahead == ',') ADVANCE(94);
      if (lookahead == '.') ADVANCE(20);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == ':') ADVANCE(68);
      if (lookahead == '<') ADVANCE(96);
      if (lookahead == 'r') ADVANCE(155);
      if (lookahead == '{') ADVANCE(63);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(14)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 15:
      if (lookahead == '\'') ADVANCE(149);
      END_STATE();
    case 16:
      if (lookahead == '\'') ADVANCE(149);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead != 0) ADVANCE(15);
      END_STATE();
    case 17:
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '*') ADVANCE(78);
      if (lookahead == '+') ADVANCE(76);
      if (lookahead == ',') ADVANCE(94);
      if (lookahead == '-') ADVANCE(32);
      if (lookahead == '.') ADVANCE(22);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == ':') ADVANCE(68);
      if (lookahead == ';') ADVANCE(59);
      if (lookahead == '<') ADVANCE(104);
      if (lookahead == '=') ADVANCE(93);
      if (lookahead == '>') ADVANCE(98);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == 'r') ADVANCE(155);
      if (lookahead == '{') ADVANCE(63);
      if (lookahead == '|') ADVANCE(115);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(17)
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 18:
      if (lookahead == '*') ADVANCE(78);
      if (lookahead == '+') ADVANCE(76);
      if (lookahead == '/') ADVANCE(74);
      if (lookahead == '?') ADVANCE(80);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(73);
      if (lookahead != 0) ADVANCE(75);
      END_STATE();
    case 19:
      if (lookahead == '.') ADVANCE(103);
      if (lookahead == '=') ADVANCE(108);
      END_STATE();
    case 20:
      if (lookahead == '.') ADVANCE(105);
      END_STATE();
    case 21:
      if (lookahead == '.') ADVANCE(106);
      END_STATE();
    case 22:
      if (lookahead == '.') ADVANCE(19);
      END_STATE();
    case 23:
      if (lookahead == '/') ADVANCE(151);
      END_STATE();
    case 24:
      if (lookahead == '1') ADVANCE(26);
      if (lookahead == '3') ADVANCE(25);
      if (lookahead == '6') ADVANCE(28);
      if (lookahead == '8') ADVANCE(138);
      if (lookahead == 's') ADVANCE(34);
      END_STATE();
    case 25:
      if (lookahead == '2') ADVANCE(138);
      END_STATE();
    case 26:
      if (lookahead == '2') ADVANCE(29);
      if (lookahead == '6') ADVANCE(138);
      END_STATE();
    case 27:
      if (lookahead == '3') ADVANCE(25);
      if (lookahead == '6') ADVANCE(28);
      END_STATE();
    case 28:
      if (lookahead == '4') ADVANCE(138);
      END_STATE();
    case 29:
      if (lookahead == '8') ADVANCE(138);
      END_STATE();
    case 30:
      if (lookahead == ':') ADVANCE(100);
      END_STATE();
    case 31:
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 32:
      if (lookahead == '>') ADVANCE(95);
      END_STATE();
    case 33:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 34:
      if (lookahead == 'i') ADVANCE(37);
      END_STATE();
    case 35:
      if (lookahead == 'u') ADVANCE(38);
      if (lookahead == 'x') ADVANCE(49);
      if (lookahead != 0) ADVANCE(150);
      END_STATE();
    case 36:
      if (lookahead == 'u') ADVANCE(39);
      if (lookahead == 'x') ADVANCE(50);
      if (lookahead != 0) ADVANCE(15);
      END_STATE();
    case 37:
      if (lookahead == 'z') ADVANCE(33);
      END_STATE();
    case 38:
      if (lookahead == '{') ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(45);
      END_STATE();
    case 39:
      if (lookahead == '{') ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(51);
      END_STATE();
    case 40:
      if (lookahead == '}') ADVANCE(15);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 41:
      if (lookahead == '}') ADVANCE(150);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 42:
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(143);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '7') ||
          lookahead == '_') ADVANCE(144);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(15);
      END_STATE();
    case 45:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(49);
      END_STATE();
    case 46:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(150);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(46);
      END_STATE();
    case 50:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(44);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(50);
      END_STATE();
    case 52:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(146);
      END_STATE();
    case 53:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(167);
      END_STATE();
    case 54:
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 55:
      if (eof) ADVANCE(58);
      if (lookahead == '!') ADVANCE(89);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '#') ADVANCE(87);
      if (lookahead == '$') ADVANCE(71);
      if (lookahead == '%') ADVANCE(125);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(86);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '*') ADVANCE(79);
      if (lookahead == '+') ADVANCE(77);
      if (lookahead == ',') ADVANCE(94);
      if (lookahead == '-') ADVANCE(111);
      if (lookahead == '.') ADVANCE(136);
      if (lookahead == '/') ADVANCE(124);
      if (lookahead == '0') ADVANCE(142);
      if (lookahead == ':') ADVANCE(69);
      if (lookahead == ';') ADVANCE(59);
      if (lookahead == '<') ADVANCE(104);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '>') ADVANCE(99);
      if (lookahead == '?') ADVANCE(80);
      if (lookahead == '@') ADVANCE(137);
      if (lookahead == '[') ADVANCE(66);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == '^') ADVANCE(117);
      if (lookahead == 'b') ADVANCE(153);
      if (lookahead == 'm') ADVANCE(157);
      if (lookahead == 'r') ADVANCE(155);
      if (lookahead == '{') ADVANCE(63);
      if (lookahead == '|') ADVANCE(116);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(55)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(145);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 56:
      if (eof) ADVANCE(58);
      if (lookahead == '!') ADVANCE(89);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '#') ADVANCE(87);
      if (lookahead == '$') ADVANCE(53);
      if (lookahead == '%') ADVANCE(125);
      if (lookahead == '&') ADVANCE(102);
      if (lookahead == '\'') ADVANCE(86);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == '*') ADVANCE(79);
      if (lookahead == '+') ADVANCE(77);
      if (lookahead == '-') ADVANCE(110);
      if (lookahead == '.') ADVANCE(136);
      if (lookahead == '/') ADVANCE(124);
      if (lookahead == '0') ADVANCE(142);
      if (lookahead == ':') ADVANCE(30);
      if (lookahead == ';') ADVANCE(59);
      if (lookahead == '<') ADVANCE(97);
      if (lookahead == '=') ADVANCE(91);
      if (lookahead == '>') ADVANCE(99);
      if (lookahead == '?') ADVANCE(80);
      if (lookahead == '[') ADVANCE(66);
      if (lookahead == '^') ADVANCE(117);
      if (lookahead == 'b') ADVANCE(153);
      if (lookahead == 'm') ADVANCE(157);
      if (lookahead == 'r') ADVANCE(155);
      if (lookahead == '{') ADVANCE(63);
      if (lookahead == '|') ADVANCE(116);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(56)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(145);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 57:
      if (eof) ADVANCE(58);
      if (lookahead == '!') ADVANCE(88);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '#') ADVANCE(87);
      if (lookahead == '$') ADVANCE(53);
      if (lookahead == '&') ADVANCE(101);
      if (lookahead == '\'') ADVANCE(86);
      if (lookahead == '(') ADVANCE(61);
      if (lookahead == ')') ADVANCE(62);
      if (lookahead == '*') ADVANCE(78);
      if (lookahead == '+') ADVANCE(76);
      if (lookahead == ',') ADVANCE(94);
      if (lookahead == '-') ADVANCE(112);
      if (lookahead == '.') ADVANCE(20);
      if (lookahead == '/') ADVANCE(23);
      if (lookahead == '0') ADVANCE(142);
      if (lookahead == ':') ADVANCE(30);
      if (lookahead == ';') ADVANCE(59);
      if (lookahead == '<') ADVANCE(96);
      if (lookahead == '=') ADVANCE(90);
      if (lookahead == '>') ADVANCE(98);
      if (lookahead == '?') ADVANCE(80);
      if (lookahead == '[') ADVANCE(66);
      if (lookahead == ']') ADVANCE(67);
      if (lookahead == 'b') ADVANCE(153);
      if (lookahead == 'm') ADVANCE(157);
      if (lookahead == 'r') ADVANCE(155);
      if (lookahead == '{') ADVANCE(63);
      if (lookahead == '|') ADVANCE(115);
      if (lookahead == '}') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(57)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(145);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_macro_rules_BANG);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(100);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '!' ||
          lookahead == '#' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          (':' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '_' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(83);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(167);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(aux_sym_token_repetition_pattern_token1);
      if (lookahead == '\n') ADVANCE(75);
      if (lookahead == '*' ||
          lookahead == '+' ||
          lookahead == '?') ADVANCE(151);
      if (lookahead != 0) ADVANCE(72);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(aux_sym_token_repetition_pattern_token1);
      if (lookahead == '/') ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(73);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '+' &&
          lookahead != '?') ADVANCE(75);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(aux_sym_token_repetition_pattern_token1);
      if (lookahead == '/') ADVANCE(72);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '+' &&
          lookahead != '?') ADVANCE(75);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(aux_sym_token_repetition_pattern_token1);
      if (lookahead != 0 &&
          lookahead != '*' &&
          lookahead != '+' &&
          lookahead != '?') ADVANCE(75);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=') ADVANCE(126);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(128);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(aux_sym__non_special_token_token1);
      if (lookahead == '/') ADVANCE(84);
      if (lookahead == '!' ||
          lookahead == '#' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '.') ||
          (':' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '_' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(83);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(aux_sym__non_special_token_token1);
      if (lookahead == '_') ADVANCE(82);
      if (lookahead == '!' ||
          lookahead == '#' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          (':' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(83);
      if (('0' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(aux_sym__non_special_token_token1);
      if (lookahead == '!' ||
          lookahead == '#' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          (':' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '_' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(83);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(aux_sym__non_special_token_token1);
      if (lookahead == '!' ||
          lookahead == '#' ||
          lookahead == '%' ||
          lookahead == '&' ||
          ('*' <= lookahead && lookahead <= '/') ||
          (':' <= lookahead && lookahead <= '@') ||
          lookahead == '^' ||
          lookahead == '_' ||
          lookahead == '|' ||
          lookahead == '~') ADVANCE(84);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(151);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      if (lookahead == '\'') ADVANCE(149);
      if (lookahead == '\\') ADVANCE(36);
      if (lookahead != 0) ADVANCE(15);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(119);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(118);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(118);
      if (lookahead == '>') ADVANCE(65);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(65);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(122);
      if (lookahead == '=') ADVANCE(120);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(121);
      if (lookahead == '>') ADVANCE(123);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(113);
      if (lookahead == '=') ADVANCE(131);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_LT2);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(103);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.') ADVANCE(103);
      if (lookahead == '=') ADVANCE(108);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_EQ);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(127);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=') ADVANCE(127);
      if (lookahead == '>') ADVANCE(95);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(95);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(132);
      if (lookahead == '|') ADVANCE(114);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(133);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(134);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(135);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/') ADVANCE(151);
      if (lookahead == '=') ADVANCE(129);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(130);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(107);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_integer_literal);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '2') ADVANCE(146);
      if (lookahead == 'f') ADVANCE(140);
      if (lookahead == 'i') ADVANCE(24);
      if (lookahead == 'u') ADVANCE(24);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(146);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '3') ADVANCE(139);
      if (lookahead == '6') ADVANCE(141);
      if (lookahead == 'f') ADVANCE(140);
      if (lookahead == 'i') ADVANCE(24);
      if (lookahead == 'u') ADVANCE(24);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(146);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '4') ADVANCE(146);
      if (lookahead == 'f') ADVANCE(140);
      if (lookahead == 'i') ADVANCE(24);
      if (lookahead == 'u') ADVANCE(24);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(146);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'b') ADVANCE(42);
      if (lookahead == 'f') ADVANCE(27);
      if (lookahead == 'i') ADVANCE(24);
      if (lookahead == 'o') ADVANCE(43);
      if (lookahead == 'u') ADVANCE(24);
      if (lookahead == 'x') ADVANCE(52);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(145);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f') ADVANCE(27);
      if (lookahead == 'i') ADVANCE(24);
      if (lookahead == 'u') ADVANCE(24);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(143);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f') ADVANCE(27);
      if (lookahead == 'i') ADVANCE(24);
      if (lookahead == 'u') ADVANCE(24);
      if (('0' <= lookahead && lookahead <= '7') ||
          lookahead == '_') ADVANCE(144);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f') ADVANCE(27);
      if (lookahead == 'i') ADVANCE(24);
      if (lookahead == 'u') ADVANCE(24);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(145);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'f') ADVANCE(140);
      if (lookahead == 'i') ADVANCE(24);
      if (lookahead == 'u') ADVANCE(24);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'e')) ADVANCE(146);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(aux_sym_string_literal_token1);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_char_literal);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(151);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!') ADVANCE(60);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '\'') ADVANCE(16);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '"') ADVANCE(147);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '#') ADVANCE(54);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(163);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(158);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(162);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(164);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(159);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(156);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(161);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(165);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(152);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u') ADVANCE(160);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          lookahead == 181 ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969)) ADVANCE(166);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_metavariable);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(167);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == '_') ADVANCE(1);
      if (lookahead == 'a') ADVANCE(2);
      if (lookahead == 'b') ADVANCE(3);
      if (lookahead == 'c') ADVANCE(4);
      if (lookahead == 'd') ADVANCE(5);
      if (lookahead == 'e') ADVANCE(6);
      if (lookahead == 'f') ADVANCE(7);
      if (lookahead == 'i') ADVANCE(8);
      if (lookahead == 'l') ADVANCE(9);
      if (lookahead == 'm') ADVANCE(10);
      if (lookahead == 'p') ADVANCE(11);
      if (lookahead == 'r') ADVANCE(12);
      if (lookahead == 's') ADVANCE(13);
      if (lookahead == 't') ADVANCE(14);
      if (lookahead == 'u') ADVANCE(15);
      if (lookahead == 'v') ADVANCE(16);
      if (lookahead == 'w') ADVANCE(17);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(0)
      END_STATE();
    case 1:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 2:
      if (lookahead == 's') ADVANCE(18);
      if (lookahead == 'w') ADVANCE(19);
      END_STATE();
    case 3:
      if (lookahead == 'l') ADVANCE(20);
      if (lookahead == 'o') ADVANCE(21);
      if (lookahead == 'r') ADVANCE(22);
      END_STATE();
    case 4:
      if (lookahead == 'h') ADVANCE(23);
      if (lookahead == 'o') ADVANCE(24);
      if (lookahead == 'r') ADVANCE(25);
      END_STATE();
    case 5:
      if (lookahead == 'e') ADVANCE(26);
      if (lookahead == 'y') ADVANCE(27);
      END_STATE();
    case 6:
      if (lookahead == 'l') ADVANCE(28);
      if (lookahead == 'n') ADVANCE(29);
      if (lookahead == 'x') ADVANCE(30);
      END_STATE();
    case 7:
      if (lookahead == '3') ADVANCE(31);
      if (lookahead == '6') ADVANCE(32);
      if (lookahead == 'a') ADVANCE(33);
      if (lookahead == 'n') ADVANCE(34);
      if (lookahead == 'o') ADVANCE(35);
      END_STATE();
    case 8:
      if (lookahead == '1') ADVANCE(36);
      if (lookahead == '3') ADVANCE(37);
      if (lookahead == '6') ADVANCE(38);
      if (lookahead == '8') ADVANCE(39);
      if (lookahead == 'd') ADVANCE(40);
      if (lookahead == 'f') ADVANCE(41);
      if (lookahead == 'm') ADVANCE(42);
      if (lookahead == 'n') ADVANCE(43);
      if (lookahead == 's') ADVANCE(44);
      if (lookahead == 't') ADVANCE(45);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(46);
      if (lookahead == 'i') ADVANCE(47);
      if (lookahead == 'o') ADVANCE(48);
      END_STATE();
    case 10:
      if (lookahead == 'a') ADVANCE(49);
      if (lookahead == 'e') ADVANCE(50);
      if (lookahead == 'o') ADVANCE(51);
      if (lookahead == 'u') ADVANCE(52);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(53);
      if (lookahead == 'u') ADVANCE(54);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(55);
      END_STATE();
    case 13:
      if (lookahead == 'e') ADVANCE(56);
      if (lookahead == 't') ADVANCE(57);
      if (lookahead == 'u') ADVANCE(58);
      END_STATE();
    case 14:
      if (lookahead == 'r') ADVANCE(59);
      if (lookahead == 't') ADVANCE(60);
      if (lookahead == 'y') ADVANCE(61);
      END_STATE();
    case 15:
      if (lookahead == '1') ADVANCE(62);
      if (lookahead == '3') ADVANCE(63);
      if (lookahead == '6') ADVANCE(64);
      if (lookahead == '8') ADVANCE(65);
      if (lookahead == 'n') ADVANCE(66);
      if (lookahead == 's') ADVANCE(67);
      END_STATE();
    case 16:
      if (lookahead == 'i') ADVANCE(68);
      END_STATE();
    case 17:
      if (lookahead == 'h') ADVANCE(69);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y') ADVANCE(70);
      END_STATE();
    case 19:
      if (lookahead == 'a') ADVANCE(71);
      END_STATE();
    case 20:
      if (lookahead == 'o') ADVANCE(72);
      END_STATE();
    case 21:
      if (lookahead == 'o') ADVANCE(73);
      END_STATE();
    case 22:
      if (lookahead == 'e') ADVANCE(74);
      END_STATE();
    case 23:
      if (lookahead == 'a') ADVANCE(75);
      END_STATE();
    case 24:
      if (lookahead == 'n') ADVANCE(76);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(77);
      END_STATE();
    case 26:
      if (lookahead == 'f') ADVANCE(78);
      END_STATE();
    case 27:
      if (lookahead == 'n') ADVANCE(79);
      END_STATE();
    case 28:
      if (lookahead == 's') ADVANCE(80);
      END_STATE();
    case 29:
      if (lookahead == 'u') ADVANCE(81);
      END_STATE();
    case 30:
      if (lookahead == 'p') ADVANCE(82);
      if (lookahead == 't') ADVANCE(83);
      END_STATE();
    case 31:
      if (lookahead == '2') ADVANCE(84);
      END_STATE();
    case 32:
      if (lookahead == '4') ADVANCE(85);
      END_STATE();
    case 33:
      if (lookahead == 'l') ADVANCE(86);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 35:
      if (lookahead == 'r') ADVANCE(87);
      END_STATE();
    case 36:
      if (lookahead == '2') ADVANCE(88);
      if (lookahead == '6') ADVANCE(89);
      END_STATE();
    case 37:
      if (lookahead == '2') ADVANCE(90);
      END_STATE();
    case 38:
      if (lookahead == '4') ADVANCE(91);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_i8);
      END_STATE();
    case 40:
      if (lookahead == 'e') ADVANCE(92);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 42:
      if (lookahead == 'p') ADVANCE(93);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 44:
      if (lookahead == 'i') ADVANCE(94);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(95);
      END_STATE();
    case 46:
      if (lookahead == 't') ADVANCE(96);
      END_STATE();
    case 47:
      if (lookahead == 'f') ADVANCE(97);
      if (lookahead == 't') ADVANCE(98);
      END_STATE();
    case 48:
      if (lookahead == 'o') ADVANCE(99);
      END_STATE();
    case 49:
      if (lookahead == 't') ADVANCE(100);
      END_STATE();
    case 50:
      if (lookahead == 't') ADVANCE(101);
      END_STATE();
    case 51:
      if (lookahead == 'd') ADVANCE(102);
      if (lookahead == 'v') ADVANCE(103);
      END_STATE();
    case 52:
      if (lookahead == 't') ADVANCE(104);
      END_STATE();
    case 53:
      if (lookahead == 't') ADVANCE(105);
      END_STATE();
    case 54:
      if (lookahead == 'b') ADVANCE(106);
      END_STATE();
    case 55:
      if (lookahead == 'f') ADVANCE(107);
      if (lookahead == 't') ADVANCE(108);
      END_STATE();
    case 56:
      if (lookahead == 'l') ADVANCE(109);
      END_STATE();
    case 57:
      if (lookahead == 'a') ADVANCE(110);
      if (lookahead == 'm') ADVANCE(111);
      if (lookahead == 'r') ADVANCE(112);
      END_STATE();
    case 58:
      if (lookahead == 'p') ADVANCE(113);
      END_STATE();
    case 59:
      if (lookahead == 'a') ADVANCE(114);
      if (lookahead == 'u') ADVANCE(115);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_tt);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_ty);
      if (lookahead == 'p') ADVANCE(116);
      END_STATE();
    case 62:
      if (lookahead == '2') ADVANCE(117);
      if (lookahead == '6') ADVANCE(118);
      END_STATE();
    case 63:
      if (lookahead == '2') ADVANCE(119);
      END_STATE();
    case 64:
      if (lookahead == '4') ADVANCE(120);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_u8);
      END_STATE();
    case 66:
      if (lookahead == 'i') ADVANCE(121);
      if (lookahead == 's') ADVANCE(122);
      END_STATE();
    case 67:
      if (lookahead == 'e') ADVANCE(123);
      if (lookahead == 'i') ADVANCE(124);
      END_STATE();
    case 68:
      if (lookahead == 's') ADVANCE(125);
      END_STATE();
    case 69:
      if (lookahead == 'e') ADVANCE(126);
      if (lookahead == 'i') ADVANCE(127);
      END_STATE();
    case 70:
      if (lookahead == 'n') ADVANCE(128);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(129);
      END_STATE();
    case 72:
      if (lookahead == 'c') ADVANCE(130);
      END_STATE();
    case 73:
      if (lookahead == 'l') ADVANCE(131);
      END_STATE();
    case 74:
      if (lookahead == 'a') ADVANCE(132);
      END_STATE();
    case 75:
      if (lookahead == 'r') ADVANCE(133);
      END_STATE();
    case 76:
      if (lookahead == 's') ADVANCE(134);
      if (lookahead == 't') ADVANCE(135);
      END_STATE();
    case 77:
      if (lookahead == 't') ADVANCE(136);
      END_STATE();
    case 78:
      if (lookahead == 'a') ADVANCE(137);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_dyn);
      END_STATE();
    case 80:
      if (lookahead == 'e') ADVANCE(138);
      END_STATE();
    case 81:
      if (lookahead == 'm') ADVANCE(139);
      END_STATE();
    case 82:
      if (lookahead == 'r') ADVANCE(140);
      END_STATE();
    case 83:
      if (lookahead == 'e') ADVANCE(141);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_f32);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_f64);
      END_STATE();
    case 86:
      if (lookahead == 's') ADVANCE(142);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 88:
      if (lookahead == '8') ADVANCE(143);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_i16);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_i32);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_i64);
      END_STATE();
    case 92:
      if (lookahead == 'n') ADVANCE(144);
      END_STATE();
    case 93:
      if (lookahead == 'l') ADVANCE(145);
      END_STATE();
    case 94:
      if (lookahead == 'z') ADVANCE(146);
      END_STATE();
    case 95:
      if (lookahead == 'm') ADVANCE(147);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 97:
      if (lookahead == 'e') ADVANCE(148);
      END_STATE();
    case 98:
      if (lookahead == 'e') ADVANCE(149);
      END_STATE();
    case 99:
      if (lookahead == 'p') ADVANCE(150);
      END_STATE();
    case 100:
      if (lookahead == 'c') ADVANCE(151);
      END_STATE();
    case 101:
      if (lookahead == 'a') ADVANCE(152);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_mod);
      END_STATE();
    case 103:
      if (lookahead == 'e') ADVANCE(153);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_mutable_specifier);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_pat);
      if (lookahead == 'h') ADVANCE(154);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_pub);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_ref);
      END_STATE();
    case 108:
      if (lookahead == 'u') ADVANCE(155);
      END_STATE();
    case 109:
      if (lookahead == 'f') ADVANCE(156);
      END_STATE();
    case 110:
      if (lookahead == 't') ADVANCE(157);
      END_STATE();
    case 111:
      if (lookahead == 't') ADVANCE(158);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_str);
      if (lookahead == 'u') ADVANCE(159);
      END_STATE();
    case 113:
      if (lookahead == 'e') ADVANCE(160);
      END_STATE();
    case 114:
      if (lookahead == 'i') ADVANCE(161);
      END_STATE();
    case 115:
      if (lookahead == 'e') ADVANCE(162);
      END_STATE();
    case 116:
      if (lookahead == 'e') ADVANCE(163);
      END_STATE();
    case 117:
      if (lookahead == '8') ADVANCE(164);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_u16);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_u32);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_u64);
      END_STATE();
    case 121:
      if (lookahead == 'o') ADVANCE(165);
      END_STATE();
    case 122:
      if (lookahead == 'a') ADVANCE(166);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_use);
      END_STATE();
    case 124:
      if (lookahead == 'z') ADVANCE(167);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_vis);
      END_STATE();
    case 126:
      if (lookahead == 'r') ADVANCE(168);
      END_STATE();
    case 127:
      if (lookahead == 'l') ADVANCE(169);
      END_STATE();
    case 128:
      if (lookahead == 'c') ADVANCE(170);
      END_STATE();
    case 129:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 130:
      if (lookahead == 'k') ADVANCE(172);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_bool);
      END_STATE();
    case 132:
      if (lookahead == 'k') ADVANCE(173);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_char);
      END_STATE();
    case 134:
      if (lookahead == 't') ADVANCE(174);
      END_STATE();
    case 135:
      if (lookahead == 'i') ADVANCE(175);
      END_STATE();
    case 136:
      if (lookahead == 'e') ADVANCE(176);
      END_STATE();
    case 137:
      if (lookahead == 'u') ADVANCE(177);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_expr);
      END_STATE();
    case 141:
      if (lookahead == 'r') ADVANCE(178);
      END_STATE();
    case 142:
      if (lookahead == 'e') ADVANCE(179);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_i128);
      END_STATE();
    case 144:
      if (lookahead == 't') ADVANCE(180);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_impl);
      END_STATE();
    case 146:
      if (lookahead == 'e') ADVANCE(181);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_item);
      END_STATE();
    case 148:
      if (lookahead == 't') ADVANCE(182);
      END_STATE();
    case 149:
      if (lookahead == 'r') ADVANCE(183);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_loop);
      END_STATE();
    case 151:
      if (lookahead == 'h') ADVANCE(184);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_meta);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_move);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_path);
      END_STATE();
    case 155:
      if (lookahead == 'r') ADVANCE(185);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_self);
      END_STATE();
    case 157:
      if (lookahead == 'i') ADVANCE(186);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_stmt);
      END_STATE();
    case 159:
      if (lookahead == 'c') ADVANCE(187);
      END_STATE();
    case 160:
      if (lookahead == 'r') ADVANCE(188);
      END_STATE();
    case 161:
      if (lookahead == 't') ADVANCE(189);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_type);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_u128);
      END_STATE();
    case 165:
      if (lookahead == 'n') ADVANCE(190);
      END_STATE();
    case 166:
      if (lookahead == 'f') ADVANCE(191);
      END_STATE();
    case 167:
      if (lookahead == 'e') ADVANCE(192);
      END_STATE();
    case 168:
      if (lookahead == 'e') ADVANCE(193);
      END_STATE();
    case 169:
      if (lookahead == 'e') ADVANCE(194);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_block);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 175:
      if (lookahead == 'n') ADVANCE(195);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_crate);
      END_STATE();
    case 177:
      if (lookahead == 'l') ADVANCE(196);
      END_STATE();
    case 178:
      if (lookahead == 'n') ADVANCE(197);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_ident);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_isize);
      END_STATE();
    case 182:
      if (lookahead == 'i') ADVANCE(198);
      END_STATE();
    case 183:
      if (lookahead == 'a') ADVANCE(199);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 185:
      if (lookahead == 'n') ADVANCE(200);
      END_STATE();
    case 186:
      if (lookahead == 'c') ADVANCE(201);
      END_STATE();
    case 187:
      if (lookahead == 't') ADVANCE(202);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_trait);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_union);
      END_STATE();
    case 191:
      if (lookahead == 'e') ADVANCE(203);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_usize);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 195:
      if (lookahead == 'u') ADVANCE(204);
      END_STATE();
    case 196:
      if (lookahead == 't') ADVANCE(205);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 198:
      if (lookahead == 'm') ADVANCE(206);
      END_STATE();
    case 199:
      if (lookahead == 'l') ADVANCE(207);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_unsafe);
      END_STATE();
    case 204:
      if (lookahead == 'e') ADVANCE(208);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 206:
      if (lookahead == 'e') ADVANCE(209);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_literal);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(anon_sym_lifetime);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 57, .external_lex_state = 2},
  [2] = {.lex_state = 57, .external_lex_state = 2},
  [3] = {.lex_state = 57, .external_lex_state = 2},
  [4] = {.lex_state = 57, .external_lex_state = 2},
  [5] = {.lex_state = 57, .external_lex_state = 2},
  [6] = {.lex_state = 57, .external_lex_state = 2},
  [7] = {.lex_state = 57, .external_lex_state = 2},
  [8] = {.lex_state = 57, .external_lex_state = 2},
  [9] = {.lex_state = 57, .external_lex_state = 2},
  [10] = {.lex_state = 57, .external_lex_state = 2},
  [11] = {.lex_state = 57, .external_lex_state = 2},
  [12] = {.lex_state = 57, .external_lex_state = 2},
  [13] = {.lex_state = 57, .external_lex_state = 2},
  [14] = {.lex_state = 57, .external_lex_state = 2},
  [15] = {.lex_state = 1, .external_lex_state = 2},
  [16] = {.lex_state = 1, .external_lex_state = 2},
  [17] = {.lex_state = 1, .external_lex_state = 2},
  [18] = {.lex_state = 1, .external_lex_state = 2},
  [19] = {.lex_state = 1, .external_lex_state = 2},
  [20] = {.lex_state = 1, .external_lex_state = 2},
  [21] = {.lex_state = 1, .external_lex_state = 2},
  [22] = {.lex_state = 1, .external_lex_state = 2},
  [23] = {.lex_state = 1, .external_lex_state = 2},
  [24] = {.lex_state = 1, .external_lex_state = 2},
  [25] = {.lex_state = 56, .external_lex_state = 2},
  [26] = {.lex_state = 56, .external_lex_state = 2},
  [27] = {.lex_state = 56, .external_lex_state = 2},
  [28] = {.lex_state = 5, .external_lex_state = 2},
  [29] = {.lex_state = 5, .external_lex_state = 2},
  [30] = {.lex_state = 56, .external_lex_state = 2},
  [31] = {.lex_state = 5, .external_lex_state = 2},
  [32] = {.lex_state = 56, .external_lex_state = 2},
  [33] = {.lex_state = 56, .external_lex_state = 2},
  [34] = {.lex_state = 56, .external_lex_state = 2},
  [35] = {.lex_state = 5, .external_lex_state = 2},
  [36] = {.lex_state = 56, .external_lex_state = 2},
  [37] = {.lex_state = 56, .external_lex_state = 2},
  [38] = {.lex_state = 56, .external_lex_state = 2},
  [39] = {.lex_state = 56, .external_lex_state = 2},
  [40] = {.lex_state = 56, .external_lex_state = 2},
  [41] = {.lex_state = 56, .external_lex_state = 2},
  [42] = {.lex_state = 5, .external_lex_state = 2},
  [43] = {.lex_state = 56, .external_lex_state = 2},
  [44] = {.lex_state = 5, .external_lex_state = 2},
  [45] = {.lex_state = 56, .external_lex_state = 2},
  [46] = {.lex_state = 56, .external_lex_state = 2},
  [47] = {.lex_state = 56, .external_lex_state = 2},
  [48] = {.lex_state = 56, .external_lex_state = 2},
  [49] = {.lex_state = 56, .external_lex_state = 2},
  [50] = {.lex_state = 56, .external_lex_state = 2},
  [51] = {.lex_state = 5, .external_lex_state = 2},
  [52] = {.lex_state = 56, .external_lex_state = 2},
  [53] = {.lex_state = 56, .external_lex_state = 2},
  [54] = {.lex_state = 56, .external_lex_state = 2},
  [55] = {.lex_state = 56, .external_lex_state = 2},
  [56] = {.lex_state = 56, .external_lex_state = 2},
  [57] = {.lex_state = 56, .external_lex_state = 2},
  [58] = {.lex_state = 56, .external_lex_state = 2},
  [59] = {.lex_state = 56, .external_lex_state = 2},
  [60] = {.lex_state = 5, .external_lex_state = 2},
  [61] = {.lex_state = 5, .external_lex_state = 2},
  [62] = {.lex_state = 56, .external_lex_state = 2},
  [63] = {.lex_state = 5, .external_lex_state = 2},
  [64] = {.lex_state = 5, .external_lex_state = 2},
  [65] = {.lex_state = 5, .external_lex_state = 2},
  [66] = {.lex_state = 5, .external_lex_state = 2},
  [67] = {.lex_state = 5, .external_lex_state = 2},
  [68] = {.lex_state = 5, .external_lex_state = 2},
  [69] = {.lex_state = 5, .external_lex_state = 2},
  [70] = {.lex_state = 6, .external_lex_state = 2},
  [71] = {.lex_state = 5, .external_lex_state = 2},
  [72] = {.lex_state = 5, .external_lex_state = 2},
  [73] = {.lex_state = 5, .external_lex_state = 2},
  [74] = {.lex_state = 5, .external_lex_state = 2},
  [75] = {.lex_state = 5, .external_lex_state = 2},
  [76] = {.lex_state = 5, .external_lex_state = 2},
  [77] = {.lex_state = 6, .external_lex_state = 2},
  [78] = {.lex_state = 5, .external_lex_state = 2},
  [79] = {.lex_state = 5, .external_lex_state = 2},
  [80] = {.lex_state = 6, .external_lex_state = 2},
  [81] = {.lex_state = 5, .external_lex_state = 2},
  [82] = {.lex_state = 5, .external_lex_state = 2},
  [83] = {.lex_state = 5, .external_lex_state = 2},
  [84] = {.lex_state = 5, .external_lex_state = 2},
  [85] = {.lex_state = 5, .external_lex_state = 2},
  [86] = {.lex_state = 5, .external_lex_state = 2},
  [87] = {.lex_state = 5, .external_lex_state = 2},
  [88] = {.lex_state = 5, .external_lex_state = 2},
  [89] = {.lex_state = 5, .external_lex_state = 2},
  [90] = {.lex_state = 5, .external_lex_state = 2},
  [91] = {.lex_state = 6, .external_lex_state = 2},
  [92] = {.lex_state = 6, .external_lex_state = 2},
  [93] = {.lex_state = 5, .external_lex_state = 2},
  [94] = {.lex_state = 6, .external_lex_state = 2},
  [95] = {.lex_state = 5, .external_lex_state = 2},
  [96] = {.lex_state = 6, .external_lex_state = 2},
  [97] = {.lex_state = 5, .external_lex_state = 2},
  [98] = {.lex_state = 5, .external_lex_state = 2},
  [99] = {.lex_state = 5, .external_lex_state = 2},
  [100] = {.lex_state = 5, .external_lex_state = 2},
  [101] = {.lex_state = 5, .external_lex_state = 2},
  [102] = {.lex_state = 5, .external_lex_state = 2},
  [103] = {.lex_state = 5, .external_lex_state = 2},
  [104] = {.lex_state = 5, .external_lex_state = 2},
  [105] = {.lex_state = 5, .external_lex_state = 2},
  [106] = {.lex_state = 5, .external_lex_state = 2},
  [107] = {.lex_state = 5, .external_lex_state = 2},
  [108] = {.lex_state = 5, .external_lex_state = 2},
  [109] = {.lex_state = 5, .external_lex_state = 2},
  [110] = {.lex_state = 5, .external_lex_state = 2},
  [111] = {.lex_state = 5, .external_lex_state = 2},
  [112] = {.lex_state = 5, .external_lex_state = 2},
  [113] = {.lex_state = 5, .external_lex_state = 2},
  [114] = {.lex_state = 5, .external_lex_state = 2},
  [115] = {.lex_state = 5, .external_lex_state = 2},
  [116] = {.lex_state = 5, .external_lex_state = 2},
  [117] = {.lex_state = 5, .external_lex_state = 2},
  [118] = {.lex_state = 5, .external_lex_state = 2},
  [119] = {.lex_state = 5, .external_lex_state = 2},
  [120] = {.lex_state = 5, .external_lex_state = 2},
  [121] = {.lex_state = 5, .external_lex_state = 2},
  [122] = {.lex_state = 5, .external_lex_state = 2},
  [123] = {.lex_state = 5, .external_lex_state = 2},
  [124] = {.lex_state = 5, .external_lex_state = 2},
  [125] = {.lex_state = 5, .external_lex_state = 2},
  [126] = {.lex_state = 5, .external_lex_state = 2},
  [127] = {.lex_state = 5, .external_lex_state = 2},
  [128] = {.lex_state = 5, .external_lex_state = 2},
  [129] = {.lex_state = 5, .external_lex_state = 2},
  [130] = {.lex_state = 5, .external_lex_state = 2},
  [131] = {.lex_state = 5, .external_lex_state = 2},
  [132] = {.lex_state = 5, .external_lex_state = 2},
  [133] = {.lex_state = 5, .external_lex_state = 2},
  [134] = {.lex_state = 5, .external_lex_state = 2},
  [135] = {.lex_state = 5, .external_lex_state = 2},
  [136] = {.lex_state = 5, .external_lex_state = 2},
  [137] = {.lex_state = 5, .external_lex_state = 2},
  [138] = {.lex_state = 5, .external_lex_state = 2},
  [139] = {.lex_state = 6, .external_lex_state = 2},
  [140] = {.lex_state = 5, .external_lex_state = 2},
  [141] = {.lex_state = 5, .external_lex_state = 2},
  [142] = {.lex_state = 5, .external_lex_state = 2},
  [143] = {.lex_state = 5, .external_lex_state = 2},
  [144] = {.lex_state = 5, .external_lex_state = 2},
  [145] = {.lex_state = 5, .external_lex_state = 2},
  [146] = {.lex_state = 5, .external_lex_state = 2},
  [147] = {.lex_state = 5, .external_lex_state = 2},
  [148] = {.lex_state = 5, .external_lex_state = 2},
  [149] = {.lex_state = 5, .external_lex_state = 2},
  [150] = {.lex_state = 5, .external_lex_state = 2},
  [151] = {.lex_state = 5, .external_lex_state = 2},
  [152] = {.lex_state = 5, .external_lex_state = 2},
  [153] = {.lex_state = 5, .external_lex_state = 2},
  [154] = {.lex_state = 5, .external_lex_state = 2},
  [155] = {.lex_state = 5, .external_lex_state = 2},
  [156] = {.lex_state = 5, .external_lex_state = 2},
  [157] = {.lex_state = 5, .external_lex_state = 2},
  [158] = {.lex_state = 5, .external_lex_state = 2},
  [159] = {.lex_state = 5, .external_lex_state = 2},
  [160] = {.lex_state = 5, .external_lex_state = 2},
  [161] = {.lex_state = 5, .external_lex_state = 2},
  [162] = {.lex_state = 5, .external_lex_state = 2},
  [163] = {.lex_state = 5, .external_lex_state = 2},
  [164] = {.lex_state = 6, .external_lex_state = 2},
  [165] = {.lex_state = 5, .external_lex_state = 2},
  [166] = {.lex_state = 5, .external_lex_state = 2},
  [167] = {.lex_state = 5, .external_lex_state = 2},
  [168] = {.lex_state = 5, .external_lex_state = 2},
  [169] = {.lex_state = 5, .external_lex_state = 2},
  [170] = {.lex_state = 5, .external_lex_state = 2},
  [171] = {.lex_state = 5, .external_lex_state = 2},
  [172] = {.lex_state = 6, .external_lex_state = 2},
  [173] = {.lex_state = 5, .external_lex_state = 2},
  [174] = {.lex_state = 5, .external_lex_state = 2},
  [175] = {.lex_state = 5, .external_lex_state = 2},
  [176] = {.lex_state = 5, .external_lex_state = 2},
  [177] = {.lex_state = 5, .external_lex_state = 2},
  [178] = {.lex_state = 6, .external_lex_state = 2},
  [179] = {.lex_state = 5, .external_lex_state = 2},
  [180] = {.lex_state = 5, .external_lex_state = 2},
  [181] = {.lex_state = 5, .external_lex_state = 2},
  [182] = {.lex_state = 5, .external_lex_state = 2},
  [183] = {.lex_state = 6, .external_lex_state = 2},
  [184] = {.lex_state = 6, .external_lex_state = 2},
  [185] = {.lex_state = 6, .external_lex_state = 2},
  [186] = {.lex_state = 6, .external_lex_state = 2},
  [187] = {.lex_state = 5, .external_lex_state = 2},
  [188] = {.lex_state = 5, .external_lex_state = 2},
  [189] = {.lex_state = 5, .external_lex_state = 2},
  [190] = {.lex_state = 5, .external_lex_state = 2},
  [191] = {.lex_state = 1, .external_lex_state = 2},
  [192] = {.lex_state = 5, .external_lex_state = 2},
  [193] = {.lex_state = 5, .external_lex_state = 2},
  [194] = {.lex_state = 5, .external_lex_state = 2},
  [195] = {.lex_state = 5, .external_lex_state = 2},
  [196] = {.lex_state = 5, .external_lex_state = 2},
  [197] = {.lex_state = 5, .external_lex_state = 2},
  [198] = {.lex_state = 5, .external_lex_state = 2},
  [199] = {.lex_state = 5, .external_lex_state = 2},
  [200] = {.lex_state = 5, .external_lex_state = 2},
  [201] = {.lex_state = 5, .external_lex_state = 2},
  [202] = {.lex_state = 5, .external_lex_state = 2},
  [203] = {.lex_state = 1, .external_lex_state = 2},
  [204] = {.lex_state = 5, .external_lex_state = 2},
  [205] = {.lex_state = 1, .external_lex_state = 2},
  [206] = {.lex_state = 5, .external_lex_state = 2},
  [207] = {.lex_state = 5, .external_lex_state = 2},
  [208] = {.lex_state = 5, .external_lex_state = 2},
  [209] = {.lex_state = 12, .external_lex_state = 2},
  [210] = {.lex_state = 5, .external_lex_state = 2},
  [211] = {.lex_state = 4, .external_lex_state = 3},
  [212] = {.lex_state = 1, .external_lex_state = 2},
  [213] = {.lex_state = 5, .external_lex_state = 2},
  [214] = {.lex_state = 4, .external_lex_state = 3},
  [215] = {.lex_state = 5, .external_lex_state = 2},
  [216] = {.lex_state = 4, .external_lex_state = 3},
  [217] = {.lex_state = 4, .external_lex_state = 3},
  [218] = {.lex_state = 1, .external_lex_state = 2},
  [219] = {.lex_state = 4, .external_lex_state = 3},
  [220] = {.lex_state = 1, .external_lex_state = 2},
  [221] = {.lex_state = 1, .external_lex_state = 2},
  [222] = {.lex_state = 1, .external_lex_state = 2},
  [223] = {.lex_state = 1, .external_lex_state = 2},
  [224] = {.lex_state = 1, .external_lex_state = 2},
  [225] = {.lex_state = 1, .external_lex_state = 2},
  [226] = {.lex_state = 1, .external_lex_state = 2},
  [227] = {.lex_state = 1, .external_lex_state = 2},
  [228] = {.lex_state = 1, .external_lex_state = 2},
  [229] = {.lex_state = 1, .external_lex_state = 2},
  [230] = {.lex_state = 1, .external_lex_state = 2},
  [231] = {.lex_state = 1, .external_lex_state = 2},
  [232] = {.lex_state = 1, .external_lex_state = 2},
  [233] = {.lex_state = 1, .external_lex_state = 2},
  [234] = {.lex_state = 1, .external_lex_state = 2},
  [235] = {.lex_state = 1, .external_lex_state = 2},
  [236] = {.lex_state = 1, .external_lex_state = 2},
  [237] = {.lex_state = 1, .external_lex_state = 2},
  [238] = {.lex_state = 1, .external_lex_state = 2},
  [239] = {.lex_state = 1, .external_lex_state = 2},
  [240] = {.lex_state = 1, .external_lex_state = 2},
  [241] = {.lex_state = 57, .external_lex_state = 2},
  [242] = {.lex_state = 57, .external_lex_state = 2},
  [243] = {.lex_state = 57, .external_lex_state = 2},
  [244] = {.lex_state = 57, .external_lex_state = 2},
  [245] = {.lex_state = 57, .external_lex_state = 2},
  [246] = {.lex_state = 12, .external_lex_state = 2},
  [247] = {.lex_state = 57, .external_lex_state = 2},
  [248] = {.lex_state = 57, .external_lex_state = 2},
  [249] = {.lex_state = 57, .external_lex_state = 2},
  [250] = {.lex_state = 57, .external_lex_state = 2},
  [251] = {.lex_state = 57, .external_lex_state = 2},
  [252] = {.lex_state = 57, .external_lex_state = 2},
  [253] = {.lex_state = 57, .external_lex_state = 2},
  [254] = {.lex_state = 57, .external_lex_state = 2},
  [255] = {.lex_state = 57, .external_lex_state = 2},
  [256] = {.lex_state = 57, .external_lex_state = 2},
  [257] = {.lex_state = 57, .external_lex_state = 2},
  [258] = {.lex_state = 12, .external_lex_state = 2},
  [259] = {.lex_state = 57, .external_lex_state = 2},
  [260] = {.lex_state = 57, .external_lex_state = 2},
  [261] = {.lex_state = 57, .external_lex_state = 2},
  [262] = {.lex_state = 57, .external_lex_state = 2},
  [263] = {.lex_state = 57, .external_lex_state = 2},
  [264] = {.lex_state = 57, .external_lex_state = 2},
  [265] = {.lex_state = 57, .external_lex_state = 2},
  [266] = {.lex_state = 57, .external_lex_state = 2},
  [267] = {.lex_state = 57, .external_lex_state = 2},
  [268] = {.lex_state = 57, .external_lex_state = 2},
  [269] = {.lex_state = 57, .external_lex_state = 2},
  [270] = {.lex_state = 57, .external_lex_state = 2},
  [271] = {.lex_state = 12, .external_lex_state = 2},
  [272] = {.lex_state = 12, .external_lex_state = 2},
  [273] = {.lex_state = 57, .external_lex_state = 2},
  [274] = {.lex_state = 57, .external_lex_state = 2},
  [275] = {.lex_state = 57, .external_lex_state = 2},
  [276] = {.lex_state = 57, .external_lex_state = 2},
  [277] = {.lex_state = 57, .external_lex_state = 2},
  [278] = {.lex_state = 57, .external_lex_state = 2},
  [279] = {.lex_state = 57, .external_lex_state = 2},
  [280] = {.lex_state = 57, .external_lex_state = 2},
  [281] = {.lex_state = 57, .external_lex_state = 2},
  [282] = {.lex_state = 57, .external_lex_state = 2},
  [283] = {.lex_state = 57, .external_lex_state = 2},
  [284] = {.lex_state = 57, .external_lex_state = 2},
  [285] = {.lex_state = 57, .external_lex_state = 2},
  [286] = {.lex_state = 57, .external_lex_state = 2},
  [287] = {.lex_state = 57, .external_lex_state = 2},
  [288] = {.lex_state = 12, .external_lex_state = 2},
  [289] = {.lex_state = 57, .external_lex_state = 2},
  [290] = {.lex_state = 57, .external_lex_state = 2},
  [291] = {.lex_state = 12, .external_lex_state = 2},
  [292] = {.lex_state = 12, .external_lex_state = 2},
  [293] = {.lex_state = 57, .external_lex_state = 2},
  [294] = {.lex_state = 57, .external_lex_state = 2},
  [295] = {.lex_state = 57, .external_lex_state = 2},
  [296] = {.lex_state = 57, .external_lex_state = 2},
  [297] = {.lex_state = 57, .external_lex_state = 2},
  [298] = {.lex_state = 57, .external_lex_state = 2},
  [299] = {.lex_state = 57, .external_lex_state = 2},
  [300] = {.lex_state = 57, .external_lex_state = 2},
  [301] = {.lex_state = 57, .external_lex_state = 2},
  [302] = {.lex_state = 57, .external_lex_state = 2},
  [303] = {.lex_state = 57, .external_lex_state = 2},
  [304] = {.lex_state = 57, .external_lex_state = 2},
  [305] = {.lex_state = 57, .external_lex_state = 2},
  [306] = {.lex_state = 57, .external_lex_state = 2},
  [307] = {.lex_state = 57, .external_lex_state = 2},
  [308] = {.lex_state = 57, .external_lex_state = 2},
  [309] = {.lex_state = 57, .external_lex_state = 2},
  [310] = {.lex_state = 57, .external_lex_state = 2},
  [311] = {.lex_state = 57, .external_lex_state = 2},
  [312] = {.lex_state = 57, .external_lex_state = 2},
  [313] = {.lex_state = 57, .external_lex_state = 2},
  [314] = {.lex_state = 57, .external_lex_state = 2},
  [315] = {.lex_state = 57, .external_lex_state = 2},
  [316] = {.lex_state = 57, .external_lex_state = 2},
  [317] = {.lex_state = 57, .external_lex_state = 2},
  [318] = {.lex_state = 57, .external_lex_state = 2},
  [319] = {.lex_state = 57, .external_lex_state = 2},
  [320] = {.lex_state = 57, .external_lex_state = 2},
  [321] = {.lex_state = 57, .external_lex_state = 2},
  [322] = {.lex_state = 57, .external_lex_state = 2},
  [323] = {.lex_state = 57, .external_lex_state = 2},
  [324] = {.lex_state = 57, .external_lex_state = 2},
  [325] = {.lex_state = 57, .external_lex_state = 2},
  [326] = {.lex_state = 57, .external_lex_state = 2},
  [327] = {.lex_state = 57, .external_lex_state = 2},
  [328] = {.lex_state = 57, .external_lex_state = 2},
  [329] = {.lex_state = 57, .external_lex_state = 2},
  [330] = {.lex_state = 57, .external_lex_state = 2},
  [331] = {.lex_state = 57, .external_lex_state = 2},
  [332] = {.lex_state = 57, .external_lex_state = 2},
  [333] = {.lex_state = 57, .external_lex_state = 2},
  [334] = {.lex_state = 57, .external_lex_state = 2},
  [335] = {.lex_state = 57, .external_lex_state = 2},
  [336] = {.lex_state = 57, .external_lex_state = 2},
  [337] = {.lex_state = 12, .external_lex_state = 2},
  [338] = {.lex_state = 57, .external_lex_state = 2},
  [339] = {.lex_state = 57, .external_lex_state = 2},
  [340] = {.lex_state = 57, .external_lex_state = 2},
  [341] = {.lex_state = 57, .external_lex_state = 2},
  [342] = {.lex_state = 57, .external_lex_state = 2},
  [343] = {.lex_state = 57, .external_lex_state = 2},
  [344] = {.lex_state = 57, .external_lex_state = 2},
  [345] = {.lex_state = 57, .external_lex_state = 2},
  [346] = {.lex_state = 57, .external_lex_state = 2},
  [347] = {.lex_state = 57, .external_lex_state = 2},
  [348] = {.lex_state = 57, .external_lex_state = 2},
  [349] = {.lex_state = 57, .external_lex_state = 2},
  [350] = {.lex_state = 57, .external_lex_state = 2},
  [351] = {.lex_state = 57, .external_lex_state = 2},
  [352] = {.lex_state = 57, .external_lex_state = 2},
  [353] = {.lex_state = 57, .external_lex_state = 2},
  [354] = {.lex_state = 57, .external_lex_state = 2},
  [355] = {.lex_state = 57, .external_lex_state = 2},
  [356] = {.lex_state = 57, .external_lex_state = 2},
  [357] = {.lex_state = 57, .external_lex_state = 2},
  [358] = {.lex_state = 57, .external_lex_state = 2},
  [359] = {.lex_state = 57, .external_lex_state = 2},
  [360] = {.lex_state = 57, .external_lex_state = 2},
  [361] = {.lex_state = 57, .external_lex_state = 2},
  [362] = {.lex_state = 57, .external_lex_state = 2},
  [363] = {.lex_state = 57, .external_lex_state = 2},
  [364] = {.lex_state = 57, .external_lex_state = 2},
  [365] = {.lex_state = 57, .external_lex_state = 2},
  [366] = {.lex_state = 57, .external_lex_state = 2},
  [367] = {.lex_state = 57, .external_lex_state = 2},
  [368] = {.lex_state = 57, .external_lex_state = 2},
  [369] = {.lex_state = 57, .external_lex_state = 2},
  [370] = {.lex_state = 57, .external_lex_state = 2},
  [371] = {.lex_state = 57, .external_lex_state = 2},
  [372] = {.lex_state = 57, .external_lex_state = 2},
  [373] = {.lex_state = 57, .external_lex_state = 2},
  [374] = {.lex_state = 57, .external_lex_state = 2},
  [375] = {.lex_state = 57, .external_lex_state = 2},
  [376] = {.lex_state = 57, .external_lex_state = 2},
  [377] = {.lex_state = 57, .external_lex_state = 2},
  [378] = {.lex_state = 57, .external_lex_state = 2},
  [379] = {.lex_state = 57, .external_lex_state = 2},
  [380] = {.lex_state = 57, .external_lex_state = 2},
  [381] = {.lex_state = 57, .external_lex_state = 2},
  [382] = {.lex_state = 57, .external_lex_state = 2},
  [383] = {.lex_state = 57, .external_lex_state = 2},
  [384] = {.lex_state = 57, .external_lex_state = 2},
  [385] = {.lex_state = 57, .external_lex_state = 2},
  [386] = {.lex_state = 12, .external_lex_state = 2},
  [387] = {.lex_state = 57, .external_lex_state = 2},
  [388] = {.lex_state = 12, .external_lex_state = 2},
  [389] = {.lex_state = 57, .external_lex_state = 2},
  [390] = {.lex_state = 57, .external_lex_state = 2},
  [391] = {.lex_state = 57, .external_lex_state = 2},
  [392] = {.lex_state = 12, .external_lex_state = 2},
  [393] = {.lex_state = 57, .external_lex_state = 2},
  [394] = {.lex_state = 57, .external_lex_state = 2},
  [395] = {.lex_state = 57, .external_lex_state = 2},
  [396] = {.lex_state = 57, .external_lex_state = 2},
  [397] = {.lex_state = 57, .external_lex_state = 2},
  [398] = {.lex_state = 57, .external_lex_state = 2},
  [399] = {.lex_state = 57, .external_lex_state = 2},
  [400] = {.lex_state = 57, .external_lex_state = 2},
  [401] = {.lex_state = 57, .external_lex_state = 2},
  [402] = {.lex_state = 57, .external_lex_state = 2},
  [403] = {.lex_state = 57, .external_lex_state = 2},
  [404] = {.lex_state = 57, .external_lex_state = 2},
  [405] = {.lex_state = 57, .external_lex_state = 2},
  [406] = {.lex_state = 57, .external_lex_state = 2},
  [407] = {.lex_state = 57, .external_lex_state = 2},
  [408] = {.lex_state = 57, .external_lex_state = 2},
  [409] = {.lex_state = 57, .external_lex_state = 2},
  [410] = {.lex_state = 57, .external_lex_state = 2},
  [411] = {.lex_state = 57, .external_lex_state = 2},
  [412] = {.lex_state = 57, .external_lex_state = 2},
  [413] = {.lex_state = 57, .external_lex_state = 2},
  [414] = {.lex_state = 57, .external_lex_state = 2},
  [415] = {.lex_state = 57, .external_lex_state = 2},
  [416] = {.lex_state = 57, .external_lex_state = 2},
  [417] = {.lex_state = 57, .external_lex_state = 2},
  [418] = {.lex_state = 57, .external_lex_state = 2},
  [419] = {.lex_state = 57, .external_lex_state = 2},
  [420] = {.lex_state = 57, .external_lex_state = 2},
  [421] = {.lex_state = 12, .external_lex_state = 2},
  [422] = {.lex_state = 57, .external_lex_state = 2},
  [423] = {.lex_state = 12, .external_lex_state = 2},
  [424] = {.lex_state = 57, .external_lex_state = 2},
  [425] = {.lex_state = 12, .external_lex_state = 2},
  [426] = {.lex_state = 12, .external_lex_state = 2},
  [427] = {.lex_state = 57, .external_lex_state = 2},
  [428] = {.lex_state = 57, .external_lex_state = 2},
  [429] = {.lex_state = 57, .external_lex_state = 2},
  [430] = {.lex_state = 57, .external_lex_state = 2},
  [431] = {.lex_state = 57, .external_lex_state = 2},
  [432] = {.lex_state = 57, .external_lex_state = 2},
  [433] = {.lex_state = 57, .external_lex_state = 2},
  [434] = {.lex_state = 57, .external_lex_state = 2},
  [435] = {.lex_state = 57, .external_lex_state = 2},
  [436] = {.lex_state = 57, .external_lex_state = 2},
  [437] = {.lex_state = 57, .external_lex_state = 2},
  [438] = {.lex_state = 57, .external_lex_state = 2},
  [439] = {.lex_state = 57, .external_lex_state = 2},
  [440] = {.lex_state = 57, .external_lex_state = 2},
  [441] = {.lex_state = 57, .external_lex_state = 2},
  [442] = {.lex_state = 57, .external_lex_state = 2},
  [443] = {.lex_state = 57, .external_lex_state = 2},
  [444] = {.lex_state = 57, .external_lex_state = 2},
  [445] = {.lex_state = 57, .external_lex_state = 2},
  [446] = {.lex_state = 57, .external_lex_state = 2},
  [447] = {.lex_state = 57, .external_lex_state = 2},
  [448] = {.lex_state = 57, .external_lex_state = 2},
  [449] = {.lex_state = 57, .external_lex_state = 2},
  [450] = {.lex_state = 57, .external_lex_state = 2},
  [451] = {.lex_state = 12, .external_lex_state = 2},
  [452] = {.lex_state = 12, .external_lex_state = 2},
  [453] = {.lex_state = 12, .external_lex_state = 2},
  [454] = {.lex_state = 12, .external_lex_state = 2},
  [455] = {.lex_state = 12, .external_lex_state = 2},
  [456] = {.lex_state = 12, .external_lex_state = 2},
  [457] = {.lex_state = 12, .external_lex_state = 2},
  [458] = {.lex_state = 12, .external_lex_state = 2},
  [459] = {.lex_state = 12, .external_lex_state = 2},
  [460] = {.lex_state = 12, .external_lex_state = 2},
  [461] = {.lex_state = 12, .external_lex_state = 2},
  [462] = {.lex_state = 12, .external_lex_state = 2},
  [463] = {.lex_state = 12, .external_lex_state = 2},
  [464] = {.lex_state = 12, .external_lex_state = 2},
  [465] = {.lex_state = 12, .external_lex_state = 2},
  [466] = {.lex_state = 12, .external_lex_state = 2},
  [467] = {.lex_state = 12, .external_lex_state = 2},
  [468] = {.lex_state = 12, .external_lex_state = 2},
  [469] = {.lex_state = 12, .external_lex_state = 2},
  [470] = {.lex_state = 12, .external_lex_state = 2},
  [471] = {.lex_state = 12, .external_lex_state = 2},
  [472] = {.lex_state = 12, .external_lex_state = 2},
  [473] = {.lex_state = 12, .external_lex_state = 2},
  [474] = {.lex_state = 12, .external_lex_state = 2},
  [475] = {.lex_state = 12, .external_lex_state = 2},
  [476] = {.lex_state = 12, .external_lex_state = 2},
  [477] = {.lex_state = 12, .external_lex_state = 2},
  [478] = {.lex_state = 12, .external_lex_state = 2},
  [479] = {.lex_state = 12, .external_lex_state = 2},
  [480] = {.lex_state = 12, .external_lex_state = 2},
  [481] = {.lex_state = 12, .external_lex_state = 2},
  [482] = {.lex_state = 12, .external_lex_state = 2},
  [483] = {.lex_state = 5, .external_lex_state = 2},
  [484] = {.lex_state = 5, .external_lex_state = 2},
  [485] = {.lex_state = 5, .external_lex_state = 2},
  [486] = {.lex_state = 5, .external_lex_state = 2},
  [487] = {.lex_state = 5, .external_lex_state = 2},
  [488] = {.lex_state = 7, .external_lex_state = 3},
  [489] = {.lex_state = 5, .external_lex_state = 2},
  [490] = {.lex_state = 5, .external_lex_state = 2},
  [491] = {.lex_state = 7, .external_lex_state = 3},
  [492] = {.lex_state = 7, .external_lex_state = 3},
  [493] = {.lex_state = 11, .external_lex_state = 2},
  [494] = {.lex_state = 7, .external_lex_state = 3},
  [495] = {.lex_state = 7, .external_lex_state = 3},
  [496] = {.lex_state = 7, .external_lex_state = 3},
  [497] = {.lex_state = 7, .external_lex_state = 3},
  [498] = {.lex_state = 7, .external_lex_state = 3},
  [499] = {.lex_state = 12, .external_lex_state = 2},
  [500] = {.lex_state = 7, .external_lex_state = 3},
  [501] = {.lex_state = 12, .external_lex_state = 2},
  [502] = {.lex_state = 12, .external_lex_state = 2},
  [503] = {.lex_state = 12, .external_lex_state = 2},
  [504] = {.lex_state = 12, .external_lex_state = 2},
  [505] = {.lex_state = 12, .external_lex_state = 2},
  [506] = {.lex_state = 12, .external_lex_state = 2},
  [507] = {.lex_state = 12, .external_lex_state = 2},
  [508] = {.lex_state = 12, .external_lex_state = 2},
  [509] = {.lex_state = 12, .external_lex_state = 2},
  [510] = {.lex_state = 12, .external_lex_state = 2},
  [511] = {.lex_state = 12, .external_lex_state = 2},
  [512] = {.lex_state = 7, .external_lex_state = 3},
  [513] = {.lex_state = 12, .external_lex_state = 2},
  [514] = {.lex_state = 12, .external_lex_state = 2},
  [515] = {.lex_state = 12, .external_lex_state = 2},
  [516] = {.lex_state = 12, .external_lex_state = 2},
  [517] = {.lex_state = 12, .external_lex_state = 2},
  [518] = {.lex_state = 5, .external_lex_state = 2},
  [519] = {.lex_state = 7, .external_lex_state = 3},
  [520] = {.lex_state = 5, .external_lex_state = 2},
  [521] = {.lex_state = 7, .external_lex_state = 3},
  [522] = {.lex_state = 5, .external_lex_state = 2},
  [523] = {.lex_state = 7, .external_lex_state = 3},
  [524] = {.lex_state = 7, .external_lex_state = 3},
  [525] = {.lex_state = 7, .external_lex_state = 3},
  [526] = {.lex_state = 7, .external_lex_state = 3},
  [527] = {.lex_state = 5, .external_lex_state = 2},
  [528] = {.lex_state = 7, .external_lex_state = 3},
  [529] = {.lex_state = 7, .external_lex_state = 3},
  [530] = {.lex_state = 7, .external_lex_state = 3},
  [531] = {.lex_state = 5, .external_lex_state = 2},
  [532] = {.lex_state = 7, .external_lex_state = 3},
  [533] = {.lex_state = 7, .external_lex_state = 3},
  [534] = {.lex_state = 7, .external_lex_state = 3},
  [535] = {.lex_state = 5, .external_lex_state = 2},
  [536] = {.lex_state = 5, .external_lex_state = 2},
  [537] = {.lex_state = 7, .external_lex_state = 3},
  [538] = {.lex_state = 7, .external_lex_state = 3},
  [539] = {.lex_state = 7, .external_lex_state = 3},
  [540] = {.lex_state = 7, .external_lex_state = 3},
  [541] = {.lex_state = 7, .external_lex_state = 3},
  [542] = {.lex_state = 7, .external_lex_state = 3},
  [543] = {.lex_state = 7, .external_lex_state = 3},
  [544] = {.lex_state = 5, .external_lex_state = 2},
  [545] = {.lex_state = 7, .external_lex_state = 3},
  [546] = {.lex_state = 7, .external_lex_state = 3},
  [547] = {.lex_state = 5, .external_lex_state = 2},
  [548] = {.lex_state = 7, .external_lex_state = 3},
  [549] = {.lex_state = 5, .external_lex_state = 2},
  [550] = {.lex_state = 7, .external_lex_state = 3},
  [551] = {.lex_state = 7, .external_lex_state = 3},
  [552] = {.lex_state = 7, .external_lex_state = 3},
  [553] = {.lex_state = 7, .external_lex_state = 3},
  [554] = {.lex_state = 7, .external_lex_state = 3},
  [555] = {.lex_state = 5, .external_lex_state = 2},
  [556] = {.lex_state = 5, .external_lex_state = 2},
  [557] = {.lex_state = 7, .external_lex_state = 3},
  [558] = {.lex_state = 5, .external_lex_state = 2},
  [559] = {.lex_state = 7, .external_lex_state = 3},
  [560] = {.lex_state = 7, .external_lex_state = 3},
  [561] = {.lex_state = 7, .external_lex_state = 3},
  [562] = {.lex_state = 7, .external_lex_state = 3},
  [563] = {.lex_state = 7, .external_lex_state = 3},
  [564] = {.lex_state = 7, .external_lex_state = 3},
  [565] = {.lex_state = 7, .external_lex_state = 3},
  [566] = {.lex_state = 7, .external_lex_state = 3},
  [567] = {.lex_state = 7, .external_lex_state = 3},
  [568] = {.lex_state = 7, .external_lex_state = 3},
  [569] = {.lex_state = 7, .external_lex_state = 3},
  [570] = {.lex_state = 7, .external_lex_state = 3},
  [571] = {.lex_state = 7, .external_lex_state = 3},
  [572] = {.lex_state = 7, .external_lex_state = 3},
  [573] = {.lex_state = 7, .external_lex_state = 3},
  [574] = {.lex_state = 7, .external_lex_state = 3},
  [575] = {.lex_state = 7, .external_lex_state = 3},
  [576] = {.lex_state = 7, .external_lex_state = 3},
  [577] = {.lex_state = 7, .external_lex_state = 3},
  [578] = {.lex_state = 7, .external_lex_state = 3},
  [579] = {.lex_state = 7, .external_lex_state = 3},
  [580] = {.lex_state = 7, .external_lex_state = 3},
  [581] = {.lex_state = 7, .external_lex_state = 3},
  [582] = {.lex_state = 7, .external_lex_state = 3},
  [583] = {.lex_state = 7, .external_lex_state = 3},
  [584] = {.lex_state = 7, .external_lex_state = 3},
  [585] = {.lex_state = 7, .external_lex_state = 3},
  [586] = {.lex_state = 7, .external_lex_state = 3},
  [587] = {.lex_state = 7, .external_lex_state = 3},
  [588] = {.lex_state = 7, .external_lex_state = 3},
  [589] = {.lex_state = 7, .external_lex_state = 3},
  [590] = {.lex_state = 7, .external_lex_state = 3},
  [591] = {.lex_state = 7, .external_lex_state = 3},
  [592] = {.lex_state = 7, .external_lex_state = 3},
  [593] = {.lex_state = 7, .external_lex_state = 3},
  [594] = {.lex_state = 7, .external_lex_state = 3},
  [595] = {.lex_state = 7, .external_lex_state = 3},
  [596] = {.lex_state = 7, .external_lex_state = 3},
  [597] = {.lex_state = 7, .external_lex_state = 3},
  [598] = {.lex_state = 7, .external_lex_state = 3},
  [599] = {.lex_state = 7, .external_lex_state = 3},
  [600] = {.lex_state = 7, .external_lex_state = 3},
  [601] = {.lex_state = 7, .external_lex_state = 3},
  [602] = {.lex_state = 7, .external_lex_state = 3},
  [603] = {.lex_state = 7, .external_lex_state = 3},
  [604] = {.lex_state = 7, .external_lex_state = 3},
  [605] = {.lex_state = 7, .external_lex_state = 3},
  [606] = {.lex_state = 7, .external_lex_state = 3},
  [607] = {.lex_state = 7, .external_lex_state = 3},
  [608] = {.lex_state = 7, .external_lex_state = 3},
  [609] = {.lex_state = 5, .external_lex_state = 2},
  [610] = {.lex_state = 7, .external_lex_state = 3},
  [611] = {.lex_state = 7, .external_lex_state = 3},
  [612] = {.lex_state = 7, .external_lex_state = 3},
  [613] = {.lex_state = 7, .external_lex_state = 3},
  [614] = {.lex_state = 7, .external_lex_state = 3},
  [615] = {.lex_state = 7, .external_lex_state = 3},
  [616] = {.lex_state = 7, .external_lex_state = 3},
  [617] = {.lex_state = 5, .external_lex_state = 2},
  [618] = {.lex_state = 7, .external_lex_state = 3},
  [619] = {.lex_state = 7, .external_lex_state = 3},
  [620] = {.lex_state = 5, .external_lex_state = 2},
  [621] = {.lex_state = 7, .external_lex_state = 3},
  [622] = {.lex_state = 7, .external_lex_state = 3},
  [623] = {.lex_state = 7, .external_lex_state = 3},
  [624] = {.lex_state = 7, .external_lex_state = 3},
  [625] = {.lex_state = 7, .external_lex_state = 3},
  [626] = {.lex_state = 7, .external_lex_state = 3},
  [627] = {.lex_state = 7, .external_lex_state = 3},
  [628] = {.lex_state = 7, .external_lex_state = 3},
  [629] = {.lex_state = 7, .external_lex_state = 3},
  [630] = {.lex_state = 7, .external_lex_state = 3},
  [631] = {.lex_state = 7, .external_lex_state = 3},
  [632] = {.lex_state = 7, .external_lex_state = 3},
  [633] = {.lex_state = 7, .external_lex_state = 3},
  [634] = {.lex_state = 7, .external_lex_state = 3},
  [635] = {.lex_state = 7, .external_lex_state = 3},
  [636] = {.lex_state = 7, .external_lex_state = 3},
  [637] = {.lex_state = 7, .external_lex_state = 3},
  [638] = {.lex_state = 7, .external_lex_state = 3},
  [639] = {.lex_state = 7, .external_lex_state = 3},
  [640] = {.lex_state = 7, .external_lex_state = 3},
  [641] = {.lex_state = 7, .external_lex_state = 3},
  [642] = {.lex_state = 7, .external_lex_state = 3},
  [643] = {.lex_state = 7, .external_lex_state = 3},
  [644] = {.lex_state = 7, .external_lex_state = 3},
  [645] = {.lex_state = 7, .external_lex_state = 3},
  [646] = {.lex_state = 7, .external_lex_state = 3},
  [647] = {.lex_state = 7, .external_lex_state = 3},
  [648] = {.lex_state = 7, .external_lex_state = 3},
  [649] = {.lex_state = 7, .external_lex_state = 3},
  [650] = {.lex_state = 7, .external_lex_state = 3},
  [651] = {.lex_state = 7, .external_lex_state = 3},
  [652] = {.lex_state = 7, .external_lex_state = 3},
  [653] = {.lex_state = 7, .external_lex_state = 3},
  [654] = {.lex_state = 7, .external_lex_state = 3},
  [655] = {.lex_state = 7, .external_lex_state = 3},
  [656] = {.lex_state = 7, .external_lex_state = 3},
  [657] = {.lex_state = 7, .external_lex_state = 3},
  [658] = {.lex_state = 7, .external_lex_state = 3},
  [659] = {.lex_state = 7, .external_lex_state = 3},
  [660] = {.lex_state = 7, .external_lex_state = 3},
  [661] = {.lex_state = 7, .external_lex_state = 3},
  [662] = {.lex_state = 7, .external_lex_state = 3},
  [663] = {.lex_state = 7, .external_lex_state = 3},
  [664] = {.lex_state = 7, .external_lex_state = 3},
  [665] = {.lex_state = 5, .external_lex_state = 2},
  [666] = {.lex_state = 5, .external_lex_state = 2},
  [667] = {.lex_state = 5, .external_lex_state = 2},
  [668] = {.lex_state = 5, .external_lex_state = 2},
  [669] = {.lex_state = 5, .external_lex_state = 2},
  [670] = {.lex_state = 5, .external_lex_state = 2},
  [671] = {.lex_state = 5, .external_lex_state = 2},
  [672] = {.lex_state = 5, .external_lex_state = 2},
  [673] = {.lex_state = 5, .external_lex_state = 2},
  [674] = {.lex_state = 5, .external_lex_state = 2},
  [675] = {.lex_state = 5, .external_lex_state = 2},
  [676] = {.lex_state = 5, .external_lex_state = 2},
  [677] = {.lex_state = 5, .external_lex_state = 2},
  [678] = {.lex_state = 5, .external_lex_state = 2},
  [679] = {.lex_state = 5, .external_lex_state = 2},
  [680] = {.lex_state = 5, .external_lex_state = 2},
  [681] = {.lex_state = 5, .external_lex_state = 2},
  [682] = {.lex_state = 5, .external_lex_state = 2},
  [683] = {.lex_state = 5, .external_lex_state = 2},
  [684] = {.lex_state = 5, .external_lex_state = 2},
  [685] = {.lex_state = 5, .external_lex_state = 2},
  [686] = {.lex_state = 5, .external_lex_state = 2},
  [687] = {.lex_state = 5, .external_lex_state = 2},
  [688] = {.lex_state = 5, .external_lex_state = 2},
  [689] = {.lex_state = 5, .external_lex_state = 2},
  [690] = {.lex_state = 5, .external_lex_state = 2},
  [691] = {.lex_state = 5, .external_lex_state = 2},
  [692] = {.lex_state = 5, .external_lex_state = 2},
  [693] = {.lex_state = 5, .external_lex_state = 2},
  [694] = {.lex_state = 5, .external_lex_state = 2},
  [695] = {.lex_state = 5, .external_lex_state = 2},
  [696] = {.lex_state = 5, .external_lex_state = 2},
  [697] = {.lex_state = 5, .external_lex_state = 2},
  [698] = {.lex_state = 5, .external_lex_state = 2},
  [699] = {.lex_state = 6, .external_lex_state = 2},
  [700] = {.lex_state = 3, .external_lex_state = 3},
  [701] = {.lex_state = 3, .external_lex_state = 3},
  [702] = {.lex_state = 3, .external_lex_state = 3},
  [703] = {.lex_state = 4, .external_lex_state = 3},
  [704] = {.lex_state = 4, .external_lex_state = 3},
  [705] = {.lex_state = 3, .external_lex_state = 3},
  [706] = {.lex_state = 2, .external_lex_state = 3},
  [707] = {.lex_state = 3, .external_lex_state = 3},
  [708] = {.lex_state = 4, .external_lex_state = 3},
  [709] = {.lex_state = 3, .external_lex_state = 3},
  [710] = {.lex_state = 3, .external_lex_state = 3},
  [711] = {.lex_state = 3, .external_lex_state = 3},
  [712] = {.lex_state = 4, .external_lex_state = 3},
  [713] = {.lex_state = 4, .external_lex_state = 3},
  [714] = {.lex_state = 4, .external_lex_state = 3},
  [715] = {.lex_state = 4, .external_lex_state = 3},
  [716] = {.lex_state = 4, .external_lex_state = 3},
  [717] = {.lex_state = 3, .external_lex_state = 3},
  [718] = {.lex_state = 3, .external_lex_state = 3},
  [719] = {.lex_state = 2, .external_lex_state = 3},
  [720] = {.lex_state = 2, .external_lex_state = 3},
  [721] = {.lex_state = 2, .external_lex_state = 3},
  [722] = {.lex_state = 2, .external_lex_state = 3},
  [723] = {.lex_state = 2, .external_lex_state = 3},
  [724] = {.lex_state = 2, .external_lex_state = 3},
  [725] = {.lex_state = 2, .external_lex_state = 3},
  [726] = {.lex_state = 2, .external_lex_state = 3},
  [727] = {.lex_state = 4, .external_lex_state = 3},
  [728] = {.lex_state = 4, .external_lex_state = 3},
  [729] = {.lex_state = 4, .external_lex_state = 3},
  [730] = {.lex_state = 4, .external_lex_state = 3},
  [731] = {.lex_state = 4, .external_lex_state = 3},
  [732] = {.lex_state = 4, .external_lex_state = 3},
  [733] = {.lex_state = 4, .external_lex_state = 3},
  [734] = {.lex_state = 4, .external_lex_state = 3},
  [735] = {.lex_state = 4, .external_lex_state = 3},
  [736] = {.lex_state = 4, .external_lex_state = 3},
  [737] = {.lex_state = 4, .external_lex_state = 3},
  [738] = {.lex_state = 2, .external_lex_state = 3},
  [739] = {.lex_state = 2, .external_lex_state = 3},
  [740] = {.lex_state = 2, .external_lex_state = 3},
  [741] = {.lex_state = 2, .external_lex_state = 3},
  [742] = {.lex_state = 4, .external_lex_state = 3},
  [743] = {.lex_state = 4, .external_lex_state = 3},
  [744] = {.lex_state = 4, .external_lex_state = 3},
  [745] = {.lex_state = 4, .external_lex_state = 3},
  [746] = {.lex_state = 4, .external_lex_state = 3},
  [747] = {.lex_state = 4, .external_lex_state = 3},
  [748] = {.lex_state = 4, .external_lex_state = 3},
  [749] = {.lex_state = 4, .external_lex_state = 3},
  [750] = {.lex_state = 4, .external_lex_state = 3},
  [751] = {.lex_state = 4, .external_lex_state = 3},
  [752] = {.lex_state = 4, .external_lex_state = 3},
  [753] = {.lex_state = 2, .external_lex_state = 3},
  [754] = {.lex_state = 4, .external_lex_state = 3},
  [755] = {.lex_state = 2, .external_lex_state = 3},
  [756] = {.lex_state = 4, .external_lex_state = 3},
  [757] = {.lex_state = 4, .external_lex_state = 3},
  [758] = {.lex_state = 2, .external_lex_state = 3},
  [759] = {.lex_state = 2, .external_lex_state = 3},
  [760] = {.lex_state = 4, .external_lex_state = 3},
  [761] = {.lex_state = 2, .external_lex_state = 3},
  [762] = {.lex_state = 4, .external_lex_state = 3},
  [763] = {.lex_state = 2, .external_lex_state = 3},
  [764] = {.lex_state = 4, .external_lex_state = 3},
  [765] = {.lex_state = 4, .external_lex_state = 3},
  [766] = {.lex_state = 2, .external_lex_state = 3},
  [767] = {.lex_state = 4, .external_lex_state = 3},
  [768] = {.lex_state = 4, .external_lex_state = 3},
  [769] = {.lex_state = 2, .external_lex_state = 3},
  [770] = {.lex_state = 4, .external_lex_state = 3},
  [771] = {.lex_state = 2, .external_lex_state = 3},
  [772] = {.lex_state = 4, .external_lex_state = 3},
  [773] = {.lex_state = 4, .external_lex_state = 3},
  [774] = {.lex_state = 4, .external_lex_state = 3},
  [775] = {.lex_state = 4, .external_lex_state = 3},
  [776] = {.lex_state = 4, .external_lex_state = 3},
  [777] = {.lex_state = 4, .external_lex_state = 3},
  [778] = {.lex_state = 4, .external_lex_state = 3},
  [779] = {.lex_state = 4, .external_lex_state = 3},
  [780] = {.lex_state = 4, .external_lex_state = 3},
  [781] = {.lex_state = 2, .external_lex_state = 3},
  [782] = {.lex_state = 4, .external_lex_state = 3},
  [783] = {.lex_state = 4, .external_lex_state = 3},
  [784] = {.lex_state = 4, .external_lex_state = 3},
  [785] = {.lex_state = 4, .external_lex_state = 3},
  [786] = {.lex_state = 4, .external_lex_state = 3},
  [787] = {.lex_state = 4, .external_lex_state = 3},
  [788] = {.lex_state = 4, .external_lex_state = 3},
  [789] = {.lex_state = 10, .external_lex_state = 3},
  [790] = {.lex_state = 4, .external_lex_state = 3},
  [791] = {.lex_state = 4, .external_lex_state = 3},
  [792] = {.lex_state = 2, .external_lex_state = 3},
  [793] = {.lex_state = 4, .external_lex_state = 3},
  [794] = {.lex_state = 4, .external_lex_state = 3},
  [795] = {.lex_state = 4, .external_lex_state = 3},
  [796] = {.lex_state = 4, .external_lex_state = 3},
  [797] = {.lex_state = 4, .external_lex_state = 3},
  [798] = {.lex_state = 4, .external_lex_state = 3},
  [799] = {.lex_state = 4, .external_lex_state = 3},
  [800] = {.lex_state = 4, .external_lex_state = 3},
  [801] = {.lex_state = 4, .external_lex_state = 3},
  [802] = {.lex_state = 4, .external_lex_state = 3},
  [803] = {.lex_state = 4, .external_lex_state = 3},
  [804] = {.lex_state = 2, .external_lex_state = 3},
  [805] = {.lex_state = 4, .external_lex_state = 3},
  [806] = {.lex_state = 4, .external_lex_state = 3},
  [807] = {.lex_state = 2, .external_lex_state = 3},
  [808] = {.lex_state = 2, .external_lex_state = 3},
  [809] = {.lex_state = 4, .external_lex_state = 3},
  [810] = {.lex_state = 4, .external_lex_state = 3},
  [811] = {.lex_state = 4, .external_lex_state = 3},
  [812] = {.lex_state = 4, .external_lex_state = 3},
  [813] = {.lex_state = 2, .external_lex_state = 3},
  [814] = {.lex_state = 4, .external_lex_state = 3},
  [815] = {.lex_state = 4, .external_lex_state = 3},
  [816] = {.lex_state = 4, .external_lex_state = 3},
  [817] = {.lex_state = 4, .external_lex_state = 3},
  [818] = {.lex_state = 4, .external_lex_state = 3},
  [819] = {.lex_state = 2, .external_lex_state = 3},
  [820] = {.lex_state = 4, .external_lex_state = 3},
  [821] = {.lex_state = 4, .external_lex_state = 3},
  [822] = {.lex_state = 4, .external_lex_state = 3},
  [823] = {.lex_state = 4, .external_lex_state = 3},
  [824] = {.lex_state = 2, .external_lex_state = 3},
  [825] = {.lex_state = 4, .external_lex_state = 3},
  [826] = {.lex_state = 4, .external_lex_state = 3},
  [827] = {.lex_state = 4, .external_lex_state = 3},
  [828] = {.lex_state = 4, .external_lex_state = 3},
  [829] = {.lex_state = 4, .external_lex_state = 3},
  [830] = {.lex_state = 2, .external_lex_state = 3},
  [831] = {.lex_state = 4, .external_lex_state = 3},
  [832] = {.lex_state = 4, .external_lex_state = 3},
  [833] = {.lex_state = 4, .external_lex_state = 3},
  [834] = {.lex_state = 4, .external_lex_state = 3},
  [835] = {.lex_state = 4, .external_lex_state = 3},
  [836] = {.lex_state = 4, .external_lex_state = 3},
  [837] = {.lex_state = 4, .external_lex_state = 3},
  [838] = {.lex_state = 2, .external_lex_state = 3},
  [839] = {.lex_state = 4, .external_lex_state = 3},
  [840] = {.lex_state = 4, .external_lex_state = 3},
  [841] = {.lex_state = 4, .external_lex_state = 3},
  [842] = {.lex_state = 4, .external_lex_state = 3},
  [843] = {.lex_state = 4, .external_lex_state = 3},
  [844] = {.lex_state = 4, .external_lex_state = 3},
  [845] = {.lex_state = 4, .external_lex_state = 3},
  [846] = {.lex_state = 4, .external_lex_state = 3},
  [847] = {.lex_state = 4, .external_lex_state = 3},
  [848] = {.lex_state = 2, .external_lex_state = 3},
  [849] = {.lex_state = 4, .external_lex_state = 3},
  [850] = {.lex_state = 4, .external_lex_state = 3},
  [851] = {.lex_state = 2, .external_lex_state = 3},
  [852] = {.lex_state = 4, .external_lex_state = 3},
  [853] = {.lex_state = 4, .external_lex_state = 3},
  [854] = {.lex_state = 4, .external_lex_state = 3},
  [855] = {.lex_state = 4, .external_lex_state = 3},
  [856] = {.lex_state = 4, .external_lex_state = 3},
  [857] = {.lex_state = 4, .external_lex_state = 3},
  [858] = {.lex_state = 4, .external_lex_state = 3},
  [859] = {.lex_state = 4, .external_lex_state = 3},
  [860] = {.lex_state = 4, .external_lex_state = 3},
  [861] = {.lex_state = 4, .external_lex_state = 3},
  [862] = {.lex_state = 4, .external_lex_state = 3},
  [863] = {.lex_state = 4, .external_lex_state = 3},
  [864] = {.lex_state = 2, .external_lex_state = 3},
  [865] = {.lex_state = 4, .external_lex_state = 3},
  [866] = {.lex_state = 2, .external_lex_state = 3},
  [867] = {.lex_state = 4, .external_lex_state = 3},
  [868] = {.lex_state = 4, .external_lex_state = 3},
  [869] = {.lex_state = 4, .external_lex_state = 3},
  [870] = {.lex_state = 4, .external_lex_state = 3},
  [871] = {.lex_state = 4, .external_lex_state = 3},
  [872] = {.lex_state = 4, .external_lex_state = 3},
  [873] = {.lex_state = 4, .external_lex_state = 3},
  [874] = {.lex_state = 4, .external_lex_state = 3},
  [875] = {.lex_state = 4, .external_lex_state = 3},
  [876] = {.lex_state = 4, .external_lex_state = 3},
  [877] = {.lex_state = 2, .external_lex_state = 3},
  [878] = {.lex_state = 4, .external_lex_state = 3},
  [879] = {.lex_state = 4, .external_lex_state = 3},
  [880] = {.lex_state = 4, .external_lex_state = 3},
  [881] = {.lex_state = 4, .external_lex_state = 3},
  [882] = {.lex_state = 4, .external_lex_state = 3},
  [883] = {.lex_state = 4, .external_lex_state = 3},
  [884] = {.lex_state = 4, .external_lex_state = 3},
  [885] = {.lex_state = 4, .external_lex_state = 3},
  [886] = {.lex_state = 4, .external_lex_state = 3},
  [887] = {.lex_state = 4, .external_lex_state = 3},
  [888] = {.lex_state = 4, .external_lex_state = 3},
  [889] = {.lex_state = 4, .external_lex_state = 3},
  [890] = {.lex_state = 2, .external_lex_state = 3},
  [891] = {.lex_state = 4, .external_lex_state = 3},
  [892] = {.lex_state = 4, .external_lex_state = 3},
  [893] = {.lex_state = 4, .external_lex_state = 3},
  [894] = {.lex_state = 4, .external_lex_state = 3},
  [895] = {.lex_state = 4, .external_lex_state = 3},
  [896] = {.lex_state = 4, .external_lex_state = 3},
  [897] = {.lex_state = 4, .external_lex_state = 3},
  [898] = {.lex_state = 4, .external_lex_state = 3},
  [899] = {.lex_state = 4, .external_lex_state = 3},
  [900] = {.lex_state = 4, .external_lex_state = 3},
  [901] = {.lex_state = 4, .external_lex_state = 3},
  [902] = {.lex_state = 4, .external_lex_state = 3},
  [903] = {.lex_state = 4, .external_lex_state = 3},
  [904] = {.lex_state = 4, .external_lex_state = 3},
  [905] = {.lex_state = 4, .external_lex_state = 3},
  [906] = {.lex_state = 4, .external_lex_state = 3},
  [907] = {.lex_state = 4, .external_lex_state = 3},
  [908] = {.lex_state = 4, .external_lex_state = 3},
  [909] = {.lex_state = 4, .external_lex_state = 3},
  [910] = {.lex_state = 4, .external_lex_state = 3},
  [911] = {.lex_state = 4, .external_lex_state = 3},
  [912] = {.lex_state = 4, .external_lex_state = 3},
  [913] = {.lex_state = 4, .external_lex_state = 3},
  [914] = {.lex_state = 4, .external_lex_state = 3},
  [915] = {.lex_state = 4, .external_lex_state = 3},
  [916] = {.lex_state = 4, .external_lex_state = 3},
  [917] = {.lex_state = 4, .external_lex_state = 3},
  [918] = {.lex_state = 4, .external_lex_state = 3},
  [919] = {.lex_state = 2, .external_lex_state = 3},
  [920] = {.lex_state = 4, .external_lex_state = 3},
  [921] = {.lex_state = 4, .external_lex_state = 3},
  [922] = {.lex_state = 4, .external_lex_state = 3},
  [923] = {.lex_state = 4, .external_lex_state = 3},
  [924] = {.lex_state = 4, .external_lex_state = 3},
  [925] = {.lex_state = 4, .external_lex_state = 3},
  [926] = {.lex_state = 4, .external_lex_state = 3},
  [927] = {.lex_state = 4, .external_lex_state = 3},
  [928] = {.lex_state = 4, .external_lex_state = 3},
  [929] = {.lex_state = 2, .external_lex_state = 3},
  [930] = {.lex_state = 4, .external_lex_state = 3},
  [931] = {.lex_state = 4, .external_lex_state = 3},
  [932] = {.lex_state = 4, .external_lex_state = 3},
  [933] = {.lex_state = 4, .external_lex_state = 3},
  [934] = {.lex_state = 4, .external_lex_state = 3},
  [935] = {.lex_state = 4, .external_lex_state = 3},
  [936] = {.lex_state = 4, .external_lex_state = 3},
  [937] = {.lex_state = 4, .external_lex_state = 3},
  [938] = {.lex_state = 3, .external_lex_state = 3},
  [939] = {.lex_state = 2, .external_lex_state = 3},
  [940] = {.lex_state = 4, .external_lex_state = 3},
  [941] = {.lex_state = 4, .external_lex_state = 3},
  [942] = {.lex_state = 4, .external_lex_state = 3},
  [943] = {.lex_state = 2, .external_lex_state = 3},
  [944] = {.lex_state = 2, .external_lex_state = 3},
  [945] = {.lex_state = 4, .external_lex_state = 3},
  [946] = {.lex_state = 4, .external_lex_state = 3},
  [947] = {.lex_state = 4, .external_lex_state = 3},
  [948] = {.lex_state = 4, .external_lex_state = 3},
  [949] = {.lex_state = 4, .external_lex_state = 3},
  [950] = {.lex_state = 2, .external_lex_state = 3},
  [951] = {.lex_state = 2, .external_lex_state = 3},
  [952] = {.lex_state = 4, .external_lex_state = 3},
  [953] = {.lex_state = 4, .external_lex_state = 3},
  [954] = {.lex_state = 2, .external_lex_state = 3},
  [955] = {.lex_state = 2, .external_lex_state = 3},
  [956] = {.lex_state = 2, .external_lex_state = 3},
  [957] = {.lex_state = 2, .external_lex_state = 3},
  [958] = {.lex_state = 2, .external_lex_state = 3},
  [959] = {.lex_state = 2, .external_lex_state = 3},
  [960] = {.lex_state = 2, .external_lex_state = 3},
  [961] = {.lex_state = 2, .external_lex_state = 3},
  [962] = {.lex_state = 2, .external_lex_state = 3},
  [963] = {.lex_state = 2, .external_lex_state = 3},
  [964] = {.lex_state = 2, .external_lex_state = 3},
  [965] = {.lex_state = 2, .external_lex_state = 3},
  [966] = {.lex_state = 2, .external_lex_state = 3},
  [967] = {.lex_state = 2, .external_lex_state = 3},
  [968] = {.lex_state = 2, .external_lex_state = 3},
  [969] = {.lex_state = 2, .external_lex_state = 3},
  [970] = {.lex_state = 2, .external_lex_state = 3},
  [971] = {.lex_state = 2, .external_lex_state = 3},
  [972] = {.lex_state = 2, .external_lex_state = 3},
  [973] = {.lex_state = 2, .external_lex_state = 3},
  [974] = {.lex_state = 2, .external_lex_state = 3},
  [975] = {.lex_state = 2, .external_lex_state = 3},
  [976] = {.lex_state = 2, .external_lex_state = 3},
  [977] = {.lex_state = 2, .external_lex_state = 3},
  [978] = {.lex_state = 2, .external_lex_state = 3},
  [979] = {.lex_state = 2, .external_lex_state = 3},
  [980] = {.lex_state = 2, .external_lex_state = 3},
  [981] = {.lex_state = 2, .external_lex_state = 3},
  [982] = {.lex_state = 2, .external_lex_state = 3},
  [983] = {.lex_state = 2, .external_lex_state = 3},
  [984] = {.lex_state = 2, .external_lex_state = 3},
  [985] = {.lex_state = 2, .external_lex_state = 3},
  [986] = {.lex_state = 2, .external_lex_state = 3},
  [987] = {.lex_state = 2, .external_lex_state = 3},
  [988] = {.lex_state = 2, .external_lex_state = 3},
  [989] = {.lex_state = 2, .external_lex_state = 3},
  [990] = {.lex_state = 2, .external_lex_state = 3},
  [991] = {.lex_state = 2, .external_lex_state = 3},
  [992] = {.lex_state = 2, .external_lex_state = 3},
  [993] = {.lex_state = 2, .external_lex_state = 3},
  [994] = {.lex_state = 2, .external_lex_state = 3},
  [995] = {.lex_state = 2, .external_lex_state = 3},
  [996] = {.lex_state = 2, .external_lex_state = 3},
  [997] = {.lex_state = 2, .external_lex_state = 3},
  [998] = {.lex_state = 2, .external_lex_state = 3},
  [999] = {.lex_state = 2, .external_lex_state = 3},
  [1000] = {.lex_state = 2, .external_lex_state = 3},
  [1001] = {.lex_state = 2, .external_lex_state = 3},
  [1002] = {.lex_state = 2, .external_lex_state = 3},
  [1003] = {.lex_state = 2, .external_lex_state = 3},
  [1004] = {.lex_state = 2, .external_lex_state = 3},
  [1005] = {.lex_state = 2, .external_lex_state = 3},
  [1006] = {.lex_state = 2, .external_lex_state = 3},
  [1007] = {.lex_state = 2, .external_lex_state = 3},
  [1008] = {.lex_state = 2, .external_lex_state = 3},
  [1009] = {.lex_state = 2, .external_lex_state = 3},
  [1010] = {.lex_state = 2, .external_lex_state = 3},
  [1011] = {.lex_state = 2, .external_lex_state = 3},
  [1012] = {.lex_state = 2, .external_lex_state = 3},
  [1013] = {.lex_state = 2, .external_lex_state = 3},
  [1014] = {.lex_state = 2, .external_lex_state = 3},
  [1015] = {.lex_state = 2, .external_lex_state = 3},
  [1016] = {.lex_state = 2, .external_lex_state = 3},
  [1017] = {.lex_state = 2, .external_lex_state = 3},
  [1018] = {.lex_state = 2, .external_lex_state = 3},
  [1019] = {.lex_state = 2, .external_lex_state = 3},
  [1020] = {.lex_state = 2, .external_lex_state = 3},
  [1021] = {.lex_state = 2, .external_lex_state = 3},
  [1022] = {.lex_state = 2, .external_lex_state = 3},
  [1023] = {.lex_state = 2, .external_lex_state = 3},
  [1024] = {.lex_state = 2, .external_lex_state = 3},
  [1025] = {.lex_state = 2, .external_lex_state = 3},
  [1026] = {.lex_state = 2, .external_lex_state = 3},
  [1027] = {.lex_state = 2, .external_lex_state = 3},
  [1028] = {.lex_state = 2, .external_lex_state = 3},
  [1029] = {.lex_state = 2, .external_lex_state = 3},
  [1030] = {.lex_state = 2, .external_lex_state = 3},
  [1031] = {.lex_state = 2, .external_lex_state = 3},
  [1032] = {.lex_state = 2, .external_lex_state = 3},
  [1033] = {.lex_state = 2, .external_lex_state = 3},
  [1034] = {.lex_state = 2, .external_lex_state = 3},
  [1035] = {.lex_state = 2, .external_lex_state = 3},
  [1036] = {.lex_state = 2, .external_lex_state = 3},
  [1037] = {.lex_state = 2, .external_lex_state = 3},
  [1038] = {.lex_state = 2, .external_lex_state = 3},
  [1039] = {.lex_state = 2, .external_lex_state = 3},
  [1040] = {.lex_state = 2, .external_lex_state = 3},
  [1041] = {.lex_state = 2, .external_lex_state = 3},
  [1042] = {.lex_state = 2, .external_lex_state = 3},
  [1043] = {.lex_state = 2, .external_lex_state = 3},
  [1044] = {.lex_state = 2, .external_lex_state = 3},
  [1045] = {.lex_state = 2, .external_lex_state = 3},
  [1046] = {.lex_state = 2, .external_lex_state = 3},
  [1047] = {.lex_state = 2, .external_lex_state = 3},
  [1048] = {.lex_state = 2, .external_lex_state = 3},
  [1049] = {.lex_state = 2, .external_lex_state = 3},
  [1050] = {.lex_state = 2, .external_lex_state = 3},
  [1051] = {.lex_state = 2, .external_lex_state = 3},
  [1052] = {.lex_state = 2, .external_lex_state = 3},
  [1053] = {.lex_state = 2, .external_lex_state = 3},
  [1054] = {.lex_state = 7, .external_lex_state = 3},
  [1055] = {.lex_state = 7, .external_lex_state = 3},
  [1056] = {.lex_state = 7, .external_lex_state = 3},
  [1057] = {.lex_state = 7, .external_lex_state = 3},
  [1058] = {.lex_state = 7, .external_lex_state = 3},
  [1059] = {.lex_state = 2, .external_lex_state = 3},
  [1060] = {.lex_state = 7, .external_lex_state = 3},
  [1061] = {.lex_state = 7, .external_lex_state = 3},
  [1062] = {.lex_state = 7, .external_lex_state = 3},
  [1063] = {.lex_state = 7, .external_lex_state = 3},
  [1064] = {.lex_state = 2, .external_lex_state = 3},
  [1065] = {.lex_state = 2, .external_lex_state = 3},
  [1066] = {.lex_state = 2, .external_lex_state = 3},
  [1067] = {.lex_state = 7, .external_lex_state = 3},
  [1068] = {.lex_state = 5, .external_lex_state = 2},
  [1069] = {.lex_state = 7, .external_lex_state = 3},
  [1070] = {.lex_state = 7, .external_lex_state = 3},
  [1071] = {.lex_state = 7, .external_lex_state = 3},
  [1072] = {.lex_state = 5, .external_lex_state = 2},
  [1073] = {.lex_state = 2, .external_lex_state = 3},
  [1074] = {.lex_state = 2, .external_lex_state = 3},
  [1075] = {.lex_state = 7, .external_lex_state = 3},
  [1076] = {.lex_state = 2, .external_lex_state = 3},
  [1077] = {.lex_state = 7, .external_lex_state = 3},
  [1078] = {.lex_state = 2, .external_lex_state = 3},
  [1079] = {.lex_state = 5, .external_lex_state = 2},
  [1080] = {.lex_state = 2, .external_lex_state = 3},
  [1081] = {.lex_state = 2, .external_lex_state = 3},
  [1082] = {.lex_state = 2, .external_lex_state = 3},
  [1083] = {.lex_state = 2, .external_lex_state = 3},
  [1084] = {.lex_state = 2, .external_lex_state = 3},
  [1085] = {.lex_state = 2, .external_lex_state = 3},
  [1086] = {.lex_state = 2, .external_lex_state = 3},
  [1087] = {.lex_state = 2, .external_lex_state = 3},
  [1088] = {.lex_state = 2, .external_lex_state = 3},
  [1089] = {.lex_state = 2, .external_lex_state = 3},
  [1090] = {.lex_state = 2, .external_lex_state = 3},
  [1091] = {.lex_state = 2, .external_lex_state = 3},
  [1092] = {.lex_state = 2, .external_lex_state = 3},
  [1093] = {.lex_state = 2, .external_lex_state = 3},
  [1094] = {.lex_state = 2, .external_lex_state = 3},
  [1095] = {.lex_state = 2, .external_lex_state = 3},
  [1096] = {.lex_state = 2, .external_lex_state = 3},
  [1097] = {.lex_state = 2, .external_lex_state = 3},
  [1098] = {.lex_state = 2, .external_lex_state = 3},
  [1099] = {.lex_state = 2, .external_lex_state = 3},
  [1100] = {.lex_state = 2, .external_lex_state = 3},
  [1101] = {.lex_state = 2, .external_lex_state = 3},
  [1102] = {.lex_state = 2, .external_lex_state = 3},
  [1103] = {.lex_state = 2, .external_lex_state = 3},
  [1104] = {.lex_state = 2, .external_lex_state = 3},
  [1105] = {.lex_state = 2, .external_lex_state = 3},
  [1106] = {.lex_state = 2, .external_lex_state = 3},
  [1107] = {.lex_state = 5, .external_lex_state = 2},
  [1108] = {.lex_state = 2, .external_lex_state = 3},
  [1109] = {.lex_state = 2, .external_lex_state = 3},
  [1110] = {.lex_state = 2, .external_lex_state = 3},
  [1111] = {.lex_state = 2, .external_lex_state = 3},
  [1112] = {.lex_state = 2, .external_lex_state = 3},
  [1113] = {.lex_state = 2, .external_lex_state = 3},
  [1114] = {.lex_state = 2, .external_lex_state = 3},
  [1115] = {.lex_state = 2, .external_lex_state = 3},
  [1116] = {.lex_state = 2, .external_lex_state = 3},
  [1117] = {.lex_state = 2, .external_lex_state = 3},
  [1118] = {.lex_state = 2, .external_lex_state = 3},
  [1119] = {.lex_state = 2, .external_lex_state = 3},
  [1120] = {.lex_state = 2, .external_lex_state = 3},
  [1121] = {.lex_state = 2, .external_lex_state = 3},
  [1122] = {.lex_state = 2, .external_lex_state = 3},
  [1123] = {.lex_state = 2, .external_lex_state = 3},
  [1124] = {.lex_state = 2, .external_lex_state = 3},
  [1125] = {.lex_state = 2, .external_lex_state = 3},
  [1126] = {.lex_state = 2, .external_lex_state = 3},
  [1127] = {.lex_state = 2, .external_lex_state = 3},
  [1128] = {.lex_state = 2, .external_lex_state = 3},
  [1129] = {.lex_state = 2, .external_lex_state = 3},
  [1130] = {.lex_state = 2, .external_lex_state = 3},
  [1131] = {.lex_state = 2, .external_lex_state = 3},
  [1132] = {.lex_state = 2, .external_lex_state = 3},
  [1133] = {.lex_state = 2, .external_lex_state = 3},
  [1134] = {.lex_state = 2, .external_lex_state = 3},
  [1135] = {.lex_state = 7, .external_lex_state = 3},
  [1136] = {.lex_state = 2, .external_lex_state = 3},
  [1137] = {.lex_state = 2, .external_lex_state = 3},
  [1138] = {.lex_state = 2, .external_lex_state = 3},
  [1139] = {.lex_state = 2, .external_lex_state = 3},
  [1140] = {.lex_state = 5, .external_lex_state = 2},
  [1141] = {.lex_state = 7, .external_lex_state = 3},
  [1142] = {.lex_state = 2, .external_lex_state = 3},
  [1143] = {.lex_state = 2, .external_lex_state = 3},
  [1144] = {.lex_state = 7, .external_lex_state = 3},
  [1145] = {.lex_state = 5, .external_lex_state = 2},
  [1146] = {.lex_state = 7, .external_lex_state = 3},
  [1147] = {.lex_state = 2, .external_lex_state = 3},
  [1148] = {.lex_state = 7, .external_lex_state = 3},
  [1149] = {.lex_state = 2, .external_lex_state = 3},
  [1150] = {.lex_state = 2, .external_lex_state = 3},
  [1151] = {.lex_state = 5, .external_lex_state = 2},
  [1152] = {.lex_state = 2, .external_lex_state = 3},
  [1153] = {.lex_state = 2, .external_lex_state = 3},
  [1154] = {.lex_state = 2, .external_lex_state = 3},
  [1155] = {.lex_state = 2, .external_lex_state = 3},
  [1156] = {.lex_state = 2, .external_lex_state = 3},
  [1157] = {.lex_state = 2, .external_lex_state = 3},
  [1158] = {.lex_state = 2, .external_lex_state = 3},
  [1159] = {.lex_state = 2, .external_lex_state = 3},
  [1160] = {.lex_state = 7, .external_lex_state = 3},
  [1161] = {.lex_state = 7, .external_lex_state = 3},
  [1162] = {.lex_state = 2, .external_lex_state = 3},
  [1163] = {.lex_state = 2, .external_lex_state = 3},
  [1164] = {.lex_state = 2, .external_lex_state = 3},
  [1165] = {.lex_state = 7, .external_lex_state = 3},
  [1166] = {.lex_state = 2, .external_lex_state = 3},
  [1167] = {.lex_state = 2, .external_lex_state = 3},
  [1168] = {.lex_state = 2, .external_lex_state = 3},
  [1169] = {.lex_state = 2, .external_lex_state = 3},
  [1170] = {.lex_state = 2, .external_lex_state = 3},
  [1171] = {.lex_state = 2, .external_lex_state = 3},
  [1172] = {.lex_state = 5, .external_lex_state = 2},
  [1173] = {.lex_state = 2, .external_lex_state = 3},
  [1174] = {.lex_state = 2, .external_lex_state = 3},
  [1175] = {.lex_state = 2, .external_lex_state = 3},
  [1176] = {.lex_state = 2, .external_lex_state = 3},
  [1177] = {.lex_state = 2, .external_lex_state = 3},
  [1178] = {.lex_state = 2, .external_lex_state = 3},
  [1179] = {.lex_state = 2, .external_lex_state = 3},
  [1180] = {.lex_state = 5, .external_lex_state = 2},
  [1181] = {.lex_state = 7, .external_lex_state = 3},
  [1182] = {.lex_state = 2, .external_lex_state = 3},
  [1183] = {.lex_state = 2, .external_lex_state = 3},
  [1184] = {.lex_state = 2, .external_lex_state = 3},
  [1185] = {.lex_state = 2, .external_lex_state = 3},
  [1186] = {.lex_state = 2, .external_lex_state = 3},
  [1187] = {.lex_state = 2, .external_lex_state = 3},
  [1188] = {.lex_state = 2, .external_lex_state = 3},
  [1189] = {.lex_state = 2, .external_lex_state = 3},
  [1190] = {.lex_state = 2, .external_lex_state = 3},
  [1191] = {.lex_state = 2, .external_lex_state = 3},
  [1192] = {.lex_state = 2, .external_lex_state = 3},
  [1193] = {.lex_state = 2, .external_lex_state = 3},
  [1194] = {.lex_state = 2, .external_lex_state = 3},
  [1195] = {.lex_state = 2, .external_lex_state = 3},
  [1196] = {.lex_state = 2, .external_lex_state = 3},
  [1197] = {.lex_state = 2, .external_lex_state = 3},
  [1198] = {.lex_state = 2, .external_lex_state = 3},
  [1199] = {.lex_state = 2, .external_lex_state = 3},
  [1200] = {.lex_state = 2, .external_lex_state = 3},
  [1201] = {.lex_state = 2, .external_lex_state = 3},
  [1202] = {.lex_state = 2, .external_lex_state = 3},
  [1203] = {.lex_state = 2, .external_lex_state = 3},
  [1204] = {.lex_state = 2, .external_lex_state = 3},
  [1205] = {.lex_state = 7, .external_lex_state = 3},
  [1206] = {.lex_state = 7, .external_lex_state = 3},
  [1207] = {.lex_state = 5, .external_lex_state = 2},
  [1208] = {.lex_state = 7, .external_lex_state = 3},
  [1209] = {.lex_state = 7, .external_lex_state = 3},
  [1210] = {.lex_state = 7, .external_lex_state = 3},
  [1211] = {.lex_state = 7, .external_lex_state = 3},
  [1212] = {.lex_state = 7, .external_lex_state = 3},
  [1213] = {.lex_state = 7, .external_lex_state = 3},
  [1214] = {.lex_state = 7, .external_lex_state = 3},
  [1215] = {.lex_state = 7, .external_lex_state = 3},
  [1216] = {.lex_state = 7, .external_lex_state = 3},
  [1217] = {.lex_state = 7, .external_lex_state = 3},
  [1218] = {.lex_state = 7, .external_lex_state = 3},
  [1219] = {.lex_state = 7, .external_lex_state = 3},
  [1220] = {.lex_state = 7, .external_lex_state = 3},
  [1221] = {.lex_state = 7, .external_lex_state = 3},
  [1222] = {.lex_state = 7, .external_lex_state = 3},
  [1223] = {.lex_state = 7, .external_lex_state = 3},
  [1224] = {.lex_state = 7, .external_lex_state = 3},
  [1225] = {.lex_state = 7, .external_lex_state = 3},
  [1226] = {.lex_state = 7, .external_lex_state = 3},
  [1227] = {.lex_state = 7, .external_lex_state = 3},
  [1228] = {.lex_state = 17, .external_lex_state = 3},
  [1229] = {.lex_state = 17, .external_lex_state = 3},
  [1230] = {.lex_state = 9, .external_lex_state = 3},
  [1231] = {.lex_state = 9, .external_lex_state = 3},
  [1232] = {.lex_state = 9, .external_lex_state = 3},
  [1233] = {.lex_state = 9, .external_lex_state = 3},
  [1234] = {.lex_state = 9, .external_lex_state = 3},
  [1235] = {.lex_state = 9, .external_lex_state = 3},
  [1236] = {.lex_state = 9, .external_lex_state = 3},
  [1237] = {.lex_state = 9, .external_lex_state = 3},
  [1238] = {.lex_state = 9, .external_lex_state = 3},
  [1239] = {.lex_state = 9, .external_lex_state = 3},
  [1240] = {.lex_state = 9, .external_lex_state = 3},
  [1241] = {.lex_state = 9, .external_lex_state = 3},
  [1242] = {.lex_state = 17, .external_lex_state = 3},
  [1243] = {.lex_state = 17, .external_lex_state = 3},
  [1244] = {.lex_state = 17, .external_lex_state = 3},
  [1245] = {.lex_state = 7, .external_lex_state = 3},
  [1246] = {.lex_state = 7, .external_lex_state = 3},
  [1247] = {.lex_state = 17, .external_lex_state = 3},
  [1248] = {.lex_state = 7, .external_lex_state = 3},
  [1249] = {.lex_state = 7, .external_lex_state = 3},
  [1250] = {.lex_state = 7, .external_lex_state = 3},
  [1251] = {.lex_state = 9, .external_lex_state = 3},
  [1252] = {.lex_state = 7, .external_lex_state = 3},
  [1253] = {.lex_state = 7, .external_lex_state = 3},
  [1254] = {.lex_state = 17, .external_lex_state = 3},
  [1255] = {.lex_state = 7, .external_lex_state = 3},
  [1256] = {.lex_state = 9, .external_lex_state = 3},
  [1257] = {.lex_state = 7, .external_lex_state = 3},
  [1258] = {.lex_state = 7, .external_lex_state = 3},
  [1259] = {.lex_state = 7, .external_lex_state = 3},
  [1260] = {.lex_state = 7, .external_lex_state = 3},
  [1261] = {.lex_state = 7, .external_lex_state = 3},
  [1262] = {.lex_state = 7, .external_lex_state = 3},
  [1263] = {.lex_state = 9, .external_lex_state = 3},
  [1264] = {.lex_state = 7, .external_lex_state = 3},
  [1265] = {.lex_state = 7, .external_lex_state = 3},
  [1266] = {.lex_state = 7, .external_lex_state = 3},
  [1267] = {.lex_state = 7, .external_lex_state = 3},
  [1268] = {.lex_state = 17, .external_lex_state = 3},
  [1269] = {.lex_state = 7, .external_lex_state = 3},
  [1270] = {.lex_state = 17, .external_lex_state = 3},
  [1271] = {.lex_state = 7, .external_lex_state = 3},
  [1272] = {.lex_state = 7, .external_lex_state = 3},
  [1273] = {.lex_state = 7, .external_lex_state = 3},
  [1274] = {.lex_state = 17, .external_lex_state = 3},
  [1275] = {.lex_state = 17, .external_lex_state = 3},
  [1276] = {.lex_state = 7, .external_lex_state = 3},
  [1277] = {.lex_state = 17, .external_lex_state = 3},
  [1278] = {.lex_state = 17, .external_lex_state = 3},
  [1279] = {.lex_state = 17, .external_lex_state = 3},
  [1280] = {.lex_state = 9, .external_lex_state = 3},
  [1281] = {.lex_state = 7, .external_lex_state = 3},
  [1282] = {.lex_state = 17, .external_lex_state = 3},
  [1283] = {.lex_state = 17, .external_lex_state = 3},
  [1284] = {.lex_state = 17, .external_lex_state = 3},
  [1285] = {.lex_state = 17, .external_lex_state = 3},
  [1286] = {.lex_state = 17, .external_lex_state = 3},
  [1287] = {.lex_state = 17, .external_lex_state = 3},
  [1288] = {.lex_state = 17, .external_lex_state = 3},
  [1289] = {.lex_state = 17, .external_lex_state = 3},
  [1290] = {.lex_state = 17, .external_lex_state = 3},
  [1291] = {.lex_state = 17, .external_lex_state = 3},
  [1292] = {.lex_state = 7, .external_lex_state = 3},
  [1293] = {.lex_state = 17, .external_lex_state = 3},
  [1294] = {.lex_state = 17, .external_lex_state = 3},
  [1295] = {.lex_state = 17, .external_lex_state = 3},
  [1296] = {.lex_state = 17, .external_lex_state = 3},
  [1297] = {.lex_state = 17, .external_lex_state = 3},
  [1298] = {.lex_state = 17, .external_lex_state = 3},
  [1299] = {.lex_state = 17, .external_lex_state = 3},
  [1300] = {.lex_state = 17, .external_lex_state = 3},
  [1301] = {.lex_state = 17, .external_lex_state = 3},
  [1302] = {.lex_state = 17, .external_lex_state = 3},
  [1303] = {.lex_state = 17, .external_lex_state = 3},
  [1304] = {.lex_state = 17, .external_lex_state = 3},
  [1305] = {.lex_state = 17, .external_lex_state = 3},
  [1306] = {.lex_state = 17, .external_lex_state = 3},
  [1307] = {.lex_state = 17, .external_lex_state = 3},
  [1308] = {.lex_state = 17, .external_lex_state = 3},
  [1309] = {.lex_state = 17, .external_lex_state = 3},
  [1310] = {.lex_state = 17, .external_lex_state = 3},
  [1311] = {.lex_state = 17, .external_lex_state = 3},
  [1312] = {.lex_state = 17, .external_lex_state = 3},
  [1313] = {.lex_state = 17, .external_lex_state = 3},
  [1314] = {.lex_state = 17, .external_lex_state = 3},
  [1315] = {.lex_state = 17, .external_lex_state = 3},
  [1316] = {.lex_state = 7, .external_lex_state = 3},
  [1317] = {.lex_state = 9, .external_lex_state = 3},
  [1318] = {.lex_state = 9, .external_lex_state = 3},
  [1319] = {.lex_state = 9, .external_lex_state = 3},
  [1320] = {.lex_state = 9, .external_lex_state = 3},
  [1321] = {.lex_state = 9, .external_lex_state = 3},
  [1322] = {.lex_state = 9, .external_lex_state = 3},
  [1323] = {.lex_state = 9, .external_lex_state = 3},
  [1324] = {.lex_state = 7, .external_lex_state = 3},
  [1325] = {.lex_state = 9, .external_lex_state = 3},
  [1326] = {.lex_state = 9, .external_lex_state = 3},
  [1327] = {.lex_state = 9, .external_lex_state = 3},
  [1328] = {.lex_state = 9, .external_lex_state = 3},
  [1329] = {.lex_state = 7, .external_lex_state = 3},
  [1330] = {.lex_state = 9, .external_lex_state = 3},
  [1331] = {.lex_state = 9, .external_lex_state = 3},
  [1332] = {.lex_state = 7, .external_lex_state = 3},
  [1333] = {.lex_state = 7, .external_lex_state = 3},
  [1334] = {.lex_state = 7, .external_lex_state = 3},
  [1335] = {.lex_state = 7, .external_lex_state = 3},
  [1336] = {.lex_state = 7, .external_lex_state = 3},
  [1337] = {.lex_state = 17, .external_lex_state = 3},
  [1338] = {.lex_state = 17, .external_lex_state = 3},
  [1339] = {.lex_state = 17, .external_lex_state = 3},
  [1340] = {.lex_state = 17, .external_lex_state = 3},
  [1341] = {.lex_state = 17, .external_lex_state = 3},
  [1342] = {.lex_state = 17, .external_lex_state = 3},
  [1343] = {.lex_state = 17, .external_lex_state = 3},
  [1344] = {.lex_state = 17, .external_lex_state = 3},
  [1345] = {.lex_state = 17, .external_lex_state = 3},
  [1346] = {.lex_state = 13, .external_lex_state = 3},
  [1347] = {.lex_state = 17, .external_lex_state = 3},
  [1348] = {.lex_state = 17, .external_lex_state = 3},
  [1349] = {.lex_state = 17, .external_lex_state = 3},
  [1350] = {.lex_state = 17, .external_lex_state = 3},
  [1351] = {.lex_state = 17, .external_lex_state = 3},
  [1352] = {.lex_state = 17, .external_lex_state = 3},
  [1353] = {.lex_state = 13, .external_lex_state = 3},
  [1354] = {.lex_state = 17, .external_lex_state = 3},
  [1355] = {.lex_state = 17, .external_lex_state = 3},
  [1356] = {.lex_state = 17, .external_lex_state = 3},
  [1357] = {.lex_state = 13, .external_lex_state = 3},
  [1358] = {.lex_state = 17, .external_lex_state = 3},
  [1359] = {.lex_state = 17, .external_lex_state = 3},
  [1360] = {.lex_state = 13, .external_lex_state = 3},
  [1361] = {.lex_state = 17, .external_lex_state = 3},
  [1362] = {.lex_state = 17, .external_lex_state = 3},
  [1363] = {.lex_state = 17, .external_lex_state = 3},
  [1364] = {.lex_state = 17, .external_lex_state = 3},
  [1365] = {.lex_state = 17, .external_lex_state = 3},
  [1366] = {.lex_state = 17, .external_lex_state = 3},
  [1367] = {.lex_state = 17, .external_lex_state = 3},
  [1368] = {.lex_state = 17, .external_lex_state = 3},
  [1369] = {.lex_state = 17, .external_lex_state = 3},
  [1370] = {.lex_state = 7, .external_lex_state = 3},
  [1371] = {.lex_state = 9, .external_lex_state = 3},
  [1372] = {.lex_state = 14, .external_lex_state = 3},
  [1373] = {.lex_state = 7, .external_lex_state = 3},
  [1374] = {.lex_state = 7, .external_lex_state = 3},
  [1375] = {.lex_state = 9, .external_lex_state = 3},
  [1376] = {.lex_state = 7, .external_lex_state = 3},
  [1377] = {.lex_state = 9, .external_lex_state = 3},
  [1378] = {.lex_state = 17, .external_lex_state = 3},
  [1379] = {.lex_state = 9, .external_lex_state = 3},
  [1380] = {.lex_state = 9, .external_lex_state = 3},
  [1381] = {.lex_state = 9, .external_lex_state = 3},
  [1382] = {.lex_state = 9, .external_lex_state = 3},
  [1383] = {.lex_state = 1, .external_lex_state = 2},
  [1384] = {.lex_state = 1, .external_lex_state = 2},
  [1385] = {.lex_state = 9, .external_lex_state = 3},
  [1386] = {.lex_state = 9, .external_lex_state = 3},
  [1387] = {.lex_state = 7, .external_lex_state = 3},
  [1388] = {.lex_state = 7, .external_lex_state = 3},
  [1389] = {.lex_state = 7, .external_lex_state = 3},
  [1390] = {.lex_state = 7, .external_lex_state = 3},
  [1391] = {.lex_state = 7, .external_lex_state = 3},
  [1392] = {.lex_state = 7, .external_lex_state = 3},
  [1393] = {.lex_state = 7, .external_lex_state = 3},
  [1394] = {.lex_state = 7, .external_lex_state = 3},
  [1395] = {.lex_state = 7, .external_lex_state = 3},
  [1396] = {.lex_state = 7, .external_lex_state = 3},
  [1397] = {.lex_state = 14, .external_lex_state = 3},
  [1398] = {.lex_state = 7, .external_lex_state = 3},
  [1399] = {.lex_state = 7, .external_lex_state = 3},
  [1400] = {.lex_state = 7, .external_lex_state = 3},
  [1401] = {.lex_state = 7, .external_lex_state = 3},
  [1402] = {.lex_state = 7, .external_lex_state = 3},
  [1403] = {.lex_state = 7, .external_lex_state = 3},
  [1404] = {.lex_state = 7, .external_lex_state = 3},
  [1405] = {.lex_state = 7, .external_lex_state = 3},
  [1406] = {.lex_state = 7, .external_lex_state = 3},
  [1407] = {.lex_state = 7, .external_lex_state = 3},
  [1408] = {.lex_state = 7, .external_lex_state = 3},
  [1409] = {.lex_state = 7, .external_lex_state = 3},
  [1410] = {.lex_state = 7, .external_lex_state = 3},
  [1411] = {.lex_state = 7, .external_lex_state = 3},
  [1412] = {.lex_state = 7, .external_lex_state = 3},
  [1413] = {.lex_state = 7, .external_lex_state = 3},
  [1414] = {.lex_state = 7, .external_lex_state = 3},
  [1415] = {.lex_state = 7, .external_lex_state = 3},
  [1416] = {.lex_state = 7, .external_lex_state = 3},
  [1417] = {.lex_state = 14, .external_lex_state = 3},
  [1418] = {.lex_state = 7, .external_lex_state = 3},
  [1419] = {.lex_state = 7, .external_lex_state = 3},
  [1420] = {.lex_state = 4, .external_lex_state = 3},
  [1421] = {.lex_state = 7, .external_lex_state = 3},
  [1422] = {.lex_state = 7, .external_lex_state = 3},
  [1423] = {.lex_state = 14, .external_lex_state = 3},
  [1424] = {.lex_state = 7, .external_lex_state = 3},
  [1425] = {.lex_state = 17, .external_lex_state = 3},
  [1426] = {.lex_state = 7, .external_lex_state = 3},
  [1427] = {.lex_state = 4, .external_lex_state = 3},
  [1428] = {.lex_state = 7, .external_lex_state = 3},
  [1429] = {.lex_state = 17, .external_lex_state = 3},
  [1430] = {.lex_state = 14, .external_lex_state = 3},
  [1431] = {.lex_state = 7, .external_lex_state = 3},
  [1432] = {.lex_state = 7, .external_lex_state = 3},
  [1433] = {.lex_state = 17, .external_lex_state = 3},
  [1434] = {.lex_state = 14, .external_lex_state = 3},
  [1435] = {.lex_state = 14, .external_lex_state = 3},
  [1436] = {.lex_state = 4, .external_lex_state = 3},
  [1437] = {.lex_state = 14, .external_lex_state = 3},
  [1438] = {.lex_state = 7, .external_lex_state = 3},
  [1439] = {.lex_state = 7, .external_lex_state = 3},
  [1440] = {.lex_state = 7, .external_lex_state = 3},
  [1441] = {.lex_state = 14, .external_lex_state = 3},
  [1442] = {.lex_state = 0, .external_lex_state = 3},
  [1443] = {.lex_state = 7, .external_lex_state = 3},
  [1444] = {.lex_state = 17, .external_lex_state = 3},
  [1445] = {.lex_state = 7, .external_lex_state = 3},
  [1446] = {.lex_state = 7, .external_lex_state = 3},
  [1447] = {.lex_state = 7, .external_lex_state = 3},
  [1448] = {.lex_state = 7, .external_lex_state = 3},
  [1449] = {.lex_state = 14, .external_lex_state = 3},
  [1450] = {.lex_state = 7, .external_lex_state = 3},
  [1451] = {.lex_state = 7, .external_lex_state = 3},
  [1452] = {.lex_state = 17, .external_lex_state = 3},
  [1453] = {.lex_state = 7, .external_lex_state = 3},
  [1454] = {.lex_state = 7, .external_lex_state = 3},
  [1455] = {.lex_state = 17, .external_lex_state = 3},
  [1456] = {.lex_state = 17, .external_lex_state = 3},
  [1457] = {.lex_state = 14, .external_lex_state = 3},
  [1458] = {.lex_state = 4, .external_lex_state = 3},
  [1459] = {.lex_state = 4, .external_lex_state = 3},
  [1460] = {.lex_state = 13, .external_lex_state = 3},
  [1461] = {.lex_state = 17, .external_lex_state = 3},
  [1462] = {.lex_state = 7, .external_lex_state = 3},
  [1463] = {.lex_state = 14, .external_lex_state = 3},
  [1464] = {.lex_state = 7, .external_lex_state = 3},
  [1465] = {.lex_state = 7, .external_lex_state = 3},
  [1466] = {.lex_state = 7, .external_lex_state = 3},
  [1467] = {.lex_state = 0, .external_lex_state = 3},
  [1468] = {.lex_state = 7, .external_lex_state = 3},
  [1469] = {.lex_state = 0, .external_lex_state = 3},
  [1470] = {.lex_state = 7, .external_lex_state = 3},
  [1471] = {.lex_state = 7, .external_lex_state = 3},
  [1472] = {.lex_state = 4, .external_lex_state = 3},
  [1473] = {.lex_state = 0, .external_lex_state = 3},
  [1474] = {.lex_state = 14, .external_lex_state = 3},
  [1475] = {.lex_state = 0, .external_lex_state = 3},
  [1476] = {.lex_state = 7, .external_lex_state = 3},
  [1477] = {.lex_state = 7, .external_lex_state = 3},
  [1478] = {.lex_state = 10, .external_lex_state = 3},
  [1479] = {.lex_state = 7, .external_lex_state = 3},
  [1480] = {.lex_state = 7, .external_lex_state = 3},
  [1481] = {.lex_state = 14, .external_lex_state = 3},
  [1482] = {.lex_state = 0, .external_lex_state = 3},
  [1483] = {.lex_state = 14, .external_lex_state = 3},
  [1484] = {.lex_state = 0, .external_lex_state = 3},
  [1485] = {.lex_state = 0, .external_lex_state = 3},
  [1486] = {.lex_state = 0, .external_lex_state = 3},
  [1487] = {.lex_state = 7, .external_lex_state = 3},
  [1488] = {.lex_state = 7, .external_lex_state = 3},
  [1489] = {.lex_state = 0, .external_lex_state = 3},
  [1490] = {.lex_state = 0, .external_lex_state = 3},
  [1491] = {.lex_state = 7, .external_lex_state = 3},
  [1492] = {.lex_state = 7, .external_lex_state = 3},
  [1493] = {.lex_state = 0, .external_lex_state = 3},
  [1494] = {.lex_state = 7, .external_lex_state = 3},
  [1495] = {.lex_state = 7, .external_lex_state = 3},
  [1496] = {.lex_state = 7, .external_lex_state = 3},
  [1497] = {.lex_state = 14, .external_lex_state = 3},
  [1498] = {.lex_state = 0, .external_lex_state = 3},
  [1499] = {.lex_state = 7, .external_lex_state = 3},
  [1500] = {.lex_state = 0, .external_lex_state = 3},
  [1501] = {.lex_state = 7, .external_lex_state = 3},
  [1502] = {.lex_state = 0, .external_lex_state = 3},
  [1503] = {.lex_state = 7, .external_lex_state = 3},
  [1504] = {.lex_state = 7, .external_lex_state = 3},
  [1505] = {.lex_state = 17, .external_lex_state = 3},
  [1506] = {.lex_state = 7, .external_lex_state = 3},
  [1507] = {.lex_state = 13, .external_lex_state = 3},
  [1508] = {.lex_state = 7, .external_lex_state = 3},
  [1509] = {.lex_state = 7, .external_lex_state = 3},
  [1510] = {.lex_state = 7, .external_lex_state = 3},
  [1511] = {.lex_state = 17, .external_lex_state = 3},
  [1512] = {.lex_state = 13, .external_lex_state = 3},
  [1513] = {.lex_state = 7, .external_lex_state = 3},
  [1514] = {.lex_state = 17, .external_lex_state = 3},
  [1515] = {.lex_state = 7, .external_lex_state = 3},
  [1516] = {.lex_state = 7, .external_lex_state = 3},
  [1517] = {.lex_state = 4, .external_lex_state = 3},
  [1518] = {.lex_state = 7, .external_lex_state = 3},
  [1519] = {.lex_state = 7, .external_lex_state = 3},
  [1520] = {.lex_state = 7, .external_lex_state = 3},
  [1521] = {.lex_state = 0, .external_lex_state = 3},
  [1522] = {.lex_state = 7, .external_lex_state = 3},
  [1523] = {.lex_state = 4, .external_lex_state = 3},
  [1524] = {.lex_state = 7, .external_lex_state = 3},
  [1525] = {.lex_state = 7, .external_lex_state = 3},
  [1526] = {.lex_state = 7, .external_lex_state = 3},
  [1527] = {.lex_state = 7, .external_lex_state = 3},
  [1528] = {.lex_state = 7, .external_lex_state = 3},
  [1529] = {.lex_state = 17, .external_lex_state = 3},
  [1530] = {.lex_state = 10, .external_lex_state = 3},
  [1531] = {.lex_state = 7, .external_lex_state = 3},
  [1532] = {.lex_state = 7, .external_lex_state = 3},
  [1533] = {.lex_state = 7, .external_lex_state = 3},
  [1534] = {.lex_state = 0, .external_lex_state = 3},
  [1535] = {.lex_state = 17, .external_lex_state = 3},
  [1536] = {.lex_state = 7, .external_lex_state = 3},
  [1537] = {.lex_state = 17, .external_lex_state = 3},
  [1538] = {.lex_state = 7, .external_lex_state = 3},
  [1539] = {.lex_state = 10, .external_lex_state = 3},
  [1540] = {.lex_state = 10, .external_lex_state = 3},
  [1541] = {.lex_state = 17, .external_lex_state = 3},
  [1542] = {.lex_state = 17, .external_lex_state = 3},
  [1543] = {.lex_state = 7, .external_lex_state = 3},
  [1544] = {.lex_state = 7, .external_lex_state = 3},
  [1545] = {.lex_state = 10, .external_lex_state = 3},
  [1546] = {.lex_state = 10, .external_lex_state = 3},
  [1547] = {.lex_state = 7, .external_lex_state = 3},
  [1548] = {.lex_state = 57, .external_lex_state = 3},
  [1549] = {.lex_state = 57, .external_lex_state = 3},
  [1550] = {.lex_state = 17, .external_lex_state = 3},
  [1551] = {.lex_state = 7, .external_lex_state = 3},
  [1552] = {.lex_state = 14, .external_lex_state = 3},
  [1553] = {.lex_state = 7, .external_lex_state = 3},
  [1554] = {.lex_state = 10, .external_lex_state = 3},
  [1555] = {.lex_state = 7, .external_lex_state = 3},
  [1556] = {.lex_state = 17, .external_lex_state = 3},
  [1557] = {.lex_state = 7, .external_lex_state = 3},
  [1558] = {.lex_state = 7, .external_lex_state = 3},
  [1559] = {.lex_state = 4, .external_lex_state = 3},
  [1560] = {.lex_state = 7, .external_lex_state = 3},
  [1561] = {.lex_state = 7, .external_lex_state = 3},
  [1562] = {.lex_state = 0, .external_lex_state = 3},
  [1563] = {.lex_state = 7, .external_lex_state = 3},
  [1564] = {.lex_state = 0, .external_lex_state = 3},
  [1565] = {.lex_state = 7, .external_lex_state = 3},
  [1566] = {.lex_state = 7, .external_lex_state = 3},
  [1567] = {.lex_state = 7, .external_lex_state = 3},
  [1568] = {.lex_state = 7, .external_lex_state = 3},
  [1569] = {.lex_state = 57, .external_lex_state = 3},
  [1570] = {.lex_state = 7, .external_lex_state = 3},
  [1571] = {.lex_state = 7, .external_lex_state = 3},
  [1572] = {.lex_state = 0, .external_lex_state = 3},
  [1573] = {.lex_state = 17, .external_lex_state = 3},
  [1574] = {.lex_state = 7, .external_lex_state = 3},
  [1575] = {.lex_state = 0, .external_lex_state = 3},
  [1576] = {.lex_state = 17, .external_lex_state = 3},
  [1577] = {.lex_state = 7, .external_lex_state = 3},
  [1578] = {.lex_state = 0, .external_lex_state = 3},
  [1579] = {.lex_state = 7, .external_lex_state = 3},
  [1580] = {.lex_state = 0, .external_lex_state = 3},
  [1581] = {.lex_state = 7, .external_lex_state = 3},
  [1582] = {.lex_state = 7, .external_lex_state = 3},
  [1583] = {.lex_state = 7, .external_lex_state = 3},
  [1584] = {.lex_state = 7, .external_lex_state = 3},
  [1585] = {.lex_state = 7, .external_lex_state = 3},
  [1586] = {.lex_state = 7, .external_lex_state = 3},
  [1587] = {.lex_state = 7, .external_lex_state = 3},
  [1588] = {.lex_state = 17, .external_lex_state = 3},
  [1589] = {.lex_state = 0, .external_lex_state = 3},
  [1590] = {.lex_state = 7, .external_lex_state = 3},
  [1591] = {.lex_state = 7, .external_lex_state = 3},
  [1592] = {.lex_state = 17, .external_lex_state = 3},
  [1593] = {.lex_state = 7, .external_lex_state = 3},
  [1594] = {.lex_state = 7, .external_lex_state = 3},
  [1595] = {.lex_state = 7, .external_lex_state = 3},
  [1596] = {.lex_state = 7, .external_lex_state = 3},
  [1597] = {.lex_state = 7, .external_lex_state = 3},
  [1598] = {.lex_state = 7, .external_lex_state = 3},
  [1599] = {.lex_state = 7, .external_lex_state = 3},
  [1600] = {.lex_state = 0, .external_lex_state = 3},
  [1601] = {.lex_state = 7, .external_lex_state = 3},
  [1602] = {.lex_state = 17, .external_lex_state = 3},
  [1603] = {.lex_state = 7, .external_lex_state = 3},
  [1604] = {.lex_state = 7, .external_lex_state = 3},
  [1605] = {.lex_state = 17, .external_lex_state = 3},
  [1606] = {.lex_state = 17, .external_lex_state = 3},
  [1607] = {.lex_state = 7, .external_lex_state = 3},
  [1608] = {.lex_state = 7, .external_lex_state = 3},
  [1609] = {.lex_state = 7, .external_lex_state = 3},
  [1610] = {.lex_state = 7, .external_lex_state = 3},
  [1611] = {.lex_state = 17, .external_lex_state = 3},
  [1612] = {.lex_state = 17, .external_lex_state = 3},
  [1613] = {.lex_state = 7, .external_lex_state = 3},
  [1614] = {.lex_state = 7, .external_lex_state = 3},
  [1615] = {.lex_state = 7, .external_lex_state = 3},
  [1616] = {.lex_state = 17, .external_lex_state = 3},
  [1617] = {.lex_state = 7, .external_lex_state = 3},
  [1618] = {.lex_state = 0, .external_lex_state = 3},
  [1619] = {.lex_state = 7, .external_lex_state = 3},
  [1620] = {.lex_state = 7, .external_lex_state = 3},
  [1621] = {.lex_state = 7, .external_lex_state = 3},
  [1622] = {.lex_state = 7, .external_lex_state = 3},
  [1623] = {.lex_state = 7, .external_lex_state = 3},
  [1624] = {.lex_state = 7, .external_lex_state = 3},
  [1625] = {.lex_state = 7, .external_lex_state = 3},
  [1626] = {.lex_state = 7, .external_lex_state = 3},
  [1627] = {.lex_state = 7, .external_lex_state = 3},
  [1628] = {.lex_state = 17, .external_lex_state = 3},
  [1629] = {.lex_state = 7, .external_lex_state = 3},
  [1630] = {.lex_state = 7, .external_lex_state = 3},
  [1631] = {.lex_state = 7, .external_lex_state = 3},
  [1632] = {.lex_state = 7, .external_lex_state = 3},
  [1633] = {.lex_state = 7, .external_lex_state = 3},
  [1634] = {.lex_state = 7, .external_lex_state = 3},
  [1635] = {.lex_state = 0, .external_lex_state = 3},
  [1636] = {.lex_state = 7, .external_lex_state = 3},
  [1637] = {.lex_state = 57, .external_lex_state = 3},
  [1638] = {.lex_state = 57, .external_lex_state = 3},
  [1639] = {.lex_state = 17, .external_lex_state = 3},
  [1640] = {.lex_state = 0, .external_lex_state = 3},
  [1641] = {.lex_state = 17, .external_lex_state = 3},
  [1642] = {.lex_state = 4, .external_lex_state = 4},
  [1643] = {.lex_state = 7, .external_lex_state = 3},
  [1644] = {.lex_state = 57, .external_lex_state = 3},
  [1645] = {.lex_state = 0, .external_lex_state = 3},
  [1646] = {.lex_state = 18, .external_lex_state = 3},
  [1647] = {.lex_state = 7, .external_lex_state = 3},
  [1648] = {.lex_state = 7, .external_lex_state = 3},
  [1649] = {.lex_state = 7, .external_lex_state = 3},
  [1650] = {.lex_state = 7, .external_lex_state = 3},
  [1651] = {.lex_state = 0, .external_lex_state = 3},
  [1652] = {.lex_state = 4, .external_lex_state = 4},
  [1653] = {.lex_state = 7, .external_lex_state = 3},
  [1654] = {.lex_state = 7, .external_lex_state = 3},
  [1655] = {.lex_state = 17, .external_lex_state = 3},
  [1656] = {.lex_state = 4, .external_lex_state = 4},
  [1657] = {.lex_state = 57, .external_lex_state = 3},
  [1658] = {.lex_state = 57, .external_lex_state = 3},
  [1659] = {.lex_state = 17, .external_lex_state = 3},
  [1660] = {.lex_state = 57, .external_lex_state = 3},
  [1661] = {.lex_state = 0, .external_lex_state = 3},
  [1662] = {.lex_state = 57, .external_lex_state = 3},
  [1663] = {.lex_state = 18, .external_lex_state = 3},
  [1664] = {.lex_state = 0, .external_lex_state = 3},
  [1665] = {.lex_state = 57, .external_lex_state = 3},
  [1666] = {.lex_state = 7, .external_lex_state = 3},
  [1667] = {.lex_state = 57, .external_lex_state = 3},
  [1668] = {.lex_state = 7, .external_lex_state = 3},
  [1669] = {.lex_state = 7, .external_lex_state = 3},
  [1670] = {.lex_state = 4, .external_lex_state = 4},
  [1671] = {.lex_state = 17, .external_lex_state = 3},
  [1672] = {.lex_state = 17, .external_lex_state = 3},
  [1673] = {.lex_state = 0, .external_lex_state = 3},
  [1674] = {.lex_state = 0, .external_lex_state = 3},
  [1675] = {.lex_state = 18, .external_lex_state = 3},
  [1676] = {.lex_state = 57, .external_lex_state = 3},
  [1677] = {.lex_state = 57, .external_lex_state = 3},
  [1678] = {.lex_state = 57, .external_lex_state = 3},
  [1679] = {.lex_state = 7, .external_lex_state = 3},
  [1680] = {.lex_state = 0, .external_lex_state = 3},
  [1681] = {.lex_state = 4, .external_lex_state = 4},
  [1682] = {.lex_state = 18, .external_lex_state = 3},
  [1683] = {.lex_state = 7, .external_lex_state = 3},
  [1684] = {.lex_state = 17, .external_lex_state = 3},
  [1685] = {.lex_state = 17, .external_lex_state = 3},
  [1686] = {.lex_state = 7, .external_lex_state = 3},
  [1687] = {.lex_state = 57, .external_lex_state = 3},
  [1688] = {.lex_state = 7, .external_lex_state = 3},
  [1689] = {.lex_state = 17, .external_lex_state = 3},
  [1690] = {.lex_state = 0, .external_lex_state = 3},
  [1691] = {.lex_state = 57, .external_lex_state = 3},
  [1692] = {.lex_state = 4, .external_lex_state = 4},
  [1693] = {.lex_state = 7, .external_lex_state = 3},
  [1694] = {.lex_state = 57, .external_lex_state = 3},
  [1695] = {.lex_state = 57, .external_lex_state = 3},
  [1696] = {.lex_state = 7, .external_lex_state = 3},
  [1697] = {.lex_state = 7, .external_lex_state = 3},
  [1698] = {.lex_state = 57, .external_lex_state = 3},
  [1699] = {.lex_state = 57, .external_lex_state = 3},
  [1700] = {.lex_state = 57, .external_lex_state = 3},
  [1701] = {.lex_state = 57, .external_lex_state = 3},
  [1702] = {.lex_state = 57, .external_lex_state = 3},
  [1703] = {.lex_state = 7, .external_lex_state = 3},
  [1704] = {.lex_state = 7, .external_lex_state = 3},
  [1705] = {.lex_state = 0, .external_lex_state = 3},
  [1706] = {.lex_state = 57, .external_lex_state = 3},
  [1707] = {.lex_state = 57, .external_lex_state = 3},
  [1708] = {.lex_state = 7, .external_lex_state = 3},
  [1709] = {.lex_state = 4, .external_lex_state = 4},
  [1710] = {.lex_state = 7, .external_lex_state = 3},
  [1711] = {.lex_state = 57, .external_lex_state = 3},
  [1712] = {.lex_state = 57, .external_lex_state = 3},
  [1713] = {.lex_state = 7, .external_lex_state = 3},
  [1714] = {.lex_state = 17, .external_lex_state = 3},
  [1715] = {.lex_state = 7, .external_lex_state = 3},
  [1716] = {.lex_state = 57, .external_lex_state = 3},
  [1717] = {.lex_state = 57, .external_lex_state = 3},
  [1718] = {.lex_state = 17, .external_lex_state = 3},
  [1719] = {.lex_state = 0, .external_lex_state = 3},
  [1720] = {.lex_state = 0, .external_lex_state = 3},
  [1721] = {.lex_state = 57, .external_lex_state = 3},
  [1722] = {.lex_state = 57, .external_lex_state = 3},
  [1723] = {.lex_state = 0, .external_lex_state = 3},
  [1724] = {.lex_state = 0, .external_lex_state = 3},
  [1725] = {.lex_state = 0, .external_lex_state = 3},
  [1726] = {.lex_state = 0, .external_lex_state = 3},
  [1727] = {.lex_state = 0, .external_lex_state = 3},
  [1728] = {.lex_state = 0, .external_lex_state = 3},
  [1729] = {.lex_state = 0, .external_lex_state = 3},
  [1730] = {.lex_state = 0, .external_lex_state = 3},
  [1731] = {.lex_state = 7, .external_lex_state = 3},
  [1732] = {.lex_state = 0, .external_lex_state = 3},
  [1733] = {.lex_state = 3, .external_lex_state = 3},
  [1734] = {.lex_state = 0, .external_lex_state = 3},
  [1735] = {.lex_state = 3, .external_lex_state = 3},
  [1736] = {.lex_state = 0, .external_lex_state = 3},
  [1737] = {.lex_state = 57, .external_lex_state = 3},
  [1738] = {.lex_state = 0, .external_lex_state = 3},
  [1739] = {.lex_state = 7, .external_lex_state = 3},
  [1740] = {.lex_state = 7, .external_lex_state = 3},
  [1741] = {.lex_state = 0, .external_lex_state = 3},
  [1742] = {.lex_state = 0, .external_lex_state = 3},
  [1743] = {.lex_state = 0, .external_lex_state = 3},
  [1744] = {.lex_state = 10, .external_lex_state = 3},
  [1745] = {.lex_state = 17, .external_lex_state = 3},
  [1746] = {.lex_state = 57, .external_lex_state = 3},
  [1747] = {.lex_state = 10, .external_lex_state = 3},
  [1748] = {.lex_state = 57, .external_lex_state = 3},
  [1749] = {.lex_state = 57, .external_lex_state = 3},
  [1750] = {.lex_state = 57, .external_lex_state = 3},
  [1751] = {.lex_state = 0, .external_lex_state = 3},
  [1752] = {.lex_state = 57, .external_lex_state = 3},
  [1753] = {.lex_state = 0, .external_lex_state = 3},
  [1754] = {.lex_state = 10, .external_lex_state = 3},
  [1755] = {.lex_state = 0, .external_lex_state = 3},
  [1756] = {.lex_state = 10, .external_lex_state = 3},
  [1757] = {.lex_state = 0, .external_lex_state = 3},
  [1758] = {.lex_state = 3, .external_lex_state = 3},
  [1759] = {.lex_state = 0, .external_lex_state = 3},
  [1760] = {.lex_state = 10, .external_lex_state = 3},
  [1761] = {.lex_state = 0, .external_lex_state = 3},
  [1762] = {.lex_state = 57, .external_lex_state = 3},
  [1763] = {.lex_state = 0, .external_lex_state = 3},
  [1764] = {.lex_state = 57, .external_lex_state = 3},
  [1765] = {.lex_state = 57, .external_lex_state = 3},
  [1766] = {.lex_state = 7, .external_lex_state = 3},
  [1767] = {.lex_state = 57, .external_lex_state = 3},
  [1768] = {.lex_state = 7, .external_lex_state = 3},
  [1769] = {.lex_state = 3, .external_lex_state = 3},
  [1770] = {.lex_state = 0, .external_lex_state = 3},
  [1771] = {.lex_state = 57, .external_lex_state = 3},
  [1772] = {.lex_state = 4, .external_lex_state = 3},
  [1773] = {.lex_state = 57, .external_lex_state = 3},
  [1774] = {.lex_state = 57, .external_lex_state = 3},
  [1775] = {.lex_state = 0, .external_lex_state = 3},
  [1776] = {.lex_state = 57, .external_lex_state = 3},
  [1777] = {.lex_state = 0, .external_lex_state = 3},
  [1778] = {.lex_state = 0, .external_lex_state = 3},
  [1779] = {.lex_state = 7, .external_lex_state = 3},
  [1780] = {.lex_state = 7, .external_lex_state = 3},
  [1781] = {.lex_state = 0, .external_lex_state = 3},
  [1782] = {.lex_state = 0, .external_lex_state = 3},
  [1783] = {.lex_state = 0, .external_lex_state = 3},
  [1784] = {.lex_state = 57, .external_lex_state = 3},
  [1785] = {.lex_state = 0, .external_lex_state = 3},
  [1786] = {.lex_state = 0, .external_lex_state = 3},
  [1787] = {.lex_state = 57, .external_lex_state = 3},
  [1788] = {.lex_state = 0, .external_lex_state = 3},
  [1789] = {.lex_state = 0, .external_lex_state = 3},
  [1790] = {.lex_state = 3, .external_lex_state = 3},
  [1791] = {.lex_state = 57, .external_lex_state = 3},
  [1792] = {.lex_state = 0, .external_lex_state = 3},
  [1793] = {.lex_state = 0, .external_lex_state = 3},
  [1794] = {.lex_state = 0, .external_lex_state = 3},
  [1795] = {.lex_state = 0, .external_lex_state = 3},
  [1796] = {.lex_state = 0, .external_lex_state = 3},
  [1797] = {.lex_state = 57, .external_lex_state = 3},
  [1798] = {.lex_state = 0, .external_lex_state = 3},
  [1799] = {.lex_state = 0, .external_lex_state = 3},
  [1800] = {.lex_state = 0, .external_lex_state = 3},
  [1801] = {.lex_state = 0, .external_lex_state = 3},
  [1802] = {.lex_state = 0, .external_lex_state = 3},
  [1803] = {.lex_state = 57, .external_lex_state = 3},
  [1804] = {.lex_state = 0, .external_lex_state = 3},
  [1805] = {.lex_state = 0, .external_lex_state = 3},
  [1806] = {.lex_state = 0, .external_lex_state = 3},
  [1807] = {.lex_state = 7, .external_lex_state = 3},
  [1808] = {.lex_state = 0, .external_lex_state = 3},
  [1809] = {.lex_state = 0, .external_lex_state = 3},
  [1810] = {.lex_state = 0, .external_lex_state = 3},
  [1811] = {.lex_state = 57, .external_lex_state = 3},
  [1812] = {.lex_state = 0, .external_lex_state = 3},
  [1813] = {.lex_state = 0, .external_lex_state = 3},
  [1814] = {.lex_state = 57, .external_lex_state = 3},
  [1815] = {.lex_state = 0, .external_lex_state = 3},
  [1816] = {.lex_state = 0, .external_lex_state = 3},
  [1817] = {.lex_state = 7, .external_lex_state = 3},
  [1818] = {.lex_state = 0, .external_lex_state = 3},
  [1819] = {.lex_state = 57, .external_lex_state = 3},
  [1820] = {.lex_state = 57, .external_lex_state = 3},
  [1821] = {.lex_state = 7, .external_lex_state = 3},
  [1822] = {.lex_state = 3, .external_lex_state = 3},
  [1823] = {.lex_state = 0, .external_lex_state = 3},
  [1824] = {.lex_state = 0, .external_lex_state = 3},
  [1825] = {.lex_state = 3, .external_lex_state = 3},
  [1826] = {.lex_state = 57, .external_lex_state = 3},
  [1827] = {.lex_state = 57, .external_lex_state = 3},
  [1828] = {.lex_state = 7, .external_lex_state = 3},
  [1829] = {.lex_state = 0, .external_lex_state = 3},
  [1830] = {.lex_state = 0, .external_lex_state = 3},
  [1831] = {.lex_state = 0, .external_lex_state = 3},
  [1832] = {.lex_state = 0, .external_lex_state = 3},
  [1833] = {.lex_state = 0, .external_lex_state = 3},
  [1834] = {.lex_state = 3, .external_lex_state = 3},
  [1835] = {.lex_state = 3, .external_lex_state = 3},
  [1836] = {.lex_state = 0, .external_lex_state = 3},
  [1837] = {.lex_state = 0, .external_lex_state = 3},
  [1838] = {.lex_state = 0, .external_lex_state = 3},
  [1839] = {.lex_state = 0, .external_lex_state = 3},
  [1840] = {.lex_state = 0, .external_lex_state = 3},
  [1841] = {.lex_state = 57, .external_lex_state = 3},
  [1842] = {.lex_state = 0, .external_lex_state = 3},
  [1843] = {.lex_state = 3, .external_lex_state = 3},
  [1844] = {.lex_state = 3, .external_lex_state = 3},
  [1845] = {.lex_state = 57, .external_lex_state = 3},
  [1846] = {.lex_state = 10, .external_lex_state = 3},
  [1847] = {.lex_state = 0, .external_lex_state = 3},
  [1848] = {.lex_state = 0, .external_lex_state = 3},
  [1849] = {.lex_state = 0, .external_lex_state = 3},
  [1850] = {.lex_state = 57, .external_lex_state = 3},
  [1851] = {.lex_state = 0, .external_lex_state = 3},
  [1852] = {.lex_state = 0, .external_lex_state = 3},
  [1853] = {.lex_state = 3, .external_lex_state = 3},
  [1854] = {.lex_state = 57, .external_lex_state = 3},
  [1855] = {.lex_state = 0, .external_lex_state = 3},
  [1856] = {.lex_state = 57, .external_lex_state = 3},
  [1857] = {.lex_state = 0, .external_lex_state = 3},
  [1858] = {.lex_state = 3, .external_lex_state = 3},
  [1859] = {.lex_state = 3, .external_lex_state = 3},
  [1860] = {.lex_state = 7, .external_lex_state = 3},
  [1861] = {.lex_state = 0, .external_lex_state = 3},
  [1862] = {.lex_state = 0, .external_lex_state = 3},
  [1863] = {.lex_state = 57, .external_lex_state = 3},
  [1864] = {.lex_state = 3, .external_lex_state = 3},
  [1865] = {.lex_state = 0, .external_lex_state = 3},
  [1866] = {.lex_state = 3, .external_lex_state = 3},
  [1867] = {.lex_state = 0, .external_lex_state = 3},
  [1868] = {.lex_state = 0, .external_lex_state = 3},
  [1869] = {.lex_state = 3, .external_lex_state = 3},
  [1870] = {.lex_state = 3, .external_lex_state = 3},
  [1871] = {.lex_state = 0, .external_lex_state = 3},
  [1872] = {.lex_state = 0, .external_lex_state = 3},
  [1873] = {.lex_state = 3, .external_lex_state = 3},
  [1874] = {.lex_state = 0, .external_lex_state = 3},
  [1875] = {.lex_state = 57, .external_lex_state = 3},
  [1876] = {.lex_state = 7, .external_lex_state = 3},
  [1877] = {.lex_state = 57, .external_lex_state = 3},
  [1878] = {.lex_state = 7, .external_lex_state = 3},
  [1879] = {.lex_state = 0, .external_lex_state = 3},
  [1880] = {.lex_state = 7, .external_lex_state = 3},
  [1881] = {.lex_state = 0, .external_lex_state = 3},
  [1882] = {.lex_state = 57, .external_lex_state = 3},
  [1883] = {.lex_state = 0, .external_lex_state = 3},
  [1884] = {.lex_state = 0, .external_lex_state = 3},
  [1885] = {.lex_state = 0, .external_lex_state = 3},
  [1886] = {.lex_state = 0, .external_lex_state = 3},
  [1887] = {.lex_state = 4, .external_lex_state = 3},
  [1888] = {.lex_state = 0, .external_lex_state = 3},
  [1889] = {.lex_state = 57, .external_lex_state = 3},
  [1890] = {.lex_state = 7, .external_lex_state = 3},
  [1891] = {.lex_state = 0, .external_lex_state = 3},
  [1892] = {.lex_state = 57, .external_lex_state = 3},
  [1893] = {.lex_state = 0, .external_lex_state = 3},
  [1894] = {.lex_state = 57, .external_lex_state = 3},
  [1895] = {.lex_state = 57, .external_lex_state = 3},
  [1896] = {.lex_state = 10, .external_lex_state = 3},
  [1897] = {.lex_state = 0, .external_lex_state = 3},
  [1898] = {.lex_state = 10, .external_lex_state = 3},
  [1899] = {.lex_state = 10, .external_lex_state = 3},
  [1900] = {.lex_state = 0, .external_lex_state = 3},
  [1901] = {.lex_state = 57, .external_lex_state = 3},
  [1902] = {.lex_state = 57, .external_lex_state = 3},
  [1903] = {.lex_state = 7, .external_lex_state = 3},
  [1904] = {.lex_state = 0, .external_lex_state = 3},
  [1905] = {.lex_state = 0, .external_lex_state = 3},
  [1906] = {.lex_state = 0, .external_lex_state = 3},
  [1907] = {.lex_state = 57, .external_lex_state = 3},
  [1908] = {.lex_state = 0, .external_lex_state = 3},
  [1909] = {.lex_state = 57, .external_lex_state = 3},
  [1910] = {.lex_state = 0, .external_lex_state = 3},
  [1911] = {.lex_state = 0, .external_lex_state = 3},
  [1912] = {.lex_state = 0, .external_lex_state = 3},
  [1913] = {.lex_state = 0, .external_lex_state = 3},
  [1914] = {.lex_state = 57, .external_lex_state = 3},
  [1915] = {.lex_state = 0, .external_lex_state = 3},
  [1916] = {.lex_state = 0, .external_lex_state = 3},
  [1917] = {.lex_state = 7, .external_lex_state = 3},
  [1918] = {.lex_state = 57, .external_lex_state = 3},
  [1919] = {.lex_state = 57, .external_lex_state = 3},
  [1920] = {.lex_state = 0, .external_lex_state = 3},
  [1921] = {.lex_state = 0, .external_lex_state = 3},
  [1922] = {.lex_state = 0, .external_lex_state = 3},
  [1923] = {.lex_state = 57, .external_lex_state = 3},
  [1924] = {.lex_state = 57, .external_lex_state = 3},
  [1925] = {.lex_state = 7, .external_lex_state = 3},
  [1926] = {.lex_state = 0, .external_lex_state = 3},
  [1927] = {.lex_state = 10, .external_lex_state = 3},
  [1928] = {.lex_state = 0, .external_lex_state = 3},
  [1929] = {.lex_state = 0, .external_lex_state = 3},
  [1930] = {.lex_state = 0, .external_lex_state = 3},
  [1931] = {.lex_state = 0, .external_lex_state = 3},
  [1932] = {.lex_state = 0, .external_lex_state = 3},
  [1933] = {.lex_state = 57, .external_lex_state = 3},
  [1934] = {.lex_state = 57, .external_lex_state = 3},
  [1935] = {.lex_state = 57, .external_lex_state = 3},
  [1936] = {.lex_state = 57, .external_lex_state = 3},
  [1937] = {.lex_state = 10, .external_lex_state = 3},
  [1938] = {.lex_state = 57, .external_lex_state = 3},
  [1939] = {.lex_state = 0, .external_lex_state = 3},
  [1940] = {.lex_state = 7, .external_lex_state = 3},
  [1941] = {.lex_state = 57, .external_lex_state = 3},
  [1942] = {.lex_state = 57, .external_lex_state = 3},
  [1943] = {.lex_state = 57, .external_lex_state = 3},
  [1944] = {.lex_state = 0, .external_lex_state = 3},
  [1945] = {.lex_state = 0, .external_lex_state = 3},
  [1946] = {.lex_state = 57, .external_lex_state = 3},
  [1947] = {.lex_state = 0, .external_lex_state = 3},
  [1948] = {.lex_state = 0, .external_lex_state = 3},
  [1949] = {.lex_state = 57, .external_lex_state = 3},
  [1950] = {.lex_state = 57, .external_lex_state = 3},
  [1951] = {.lex_state = 0, .external_lex_state = 3},
  [1952] = {.lex_state = 57, .external_lex_state = 3},
  [1953] = {.lex_state = 0, .external_lex_state = 3},
  [1954] = {.lex_state = 0, .external_lex_state = 3},
  [1955] = {.lex_state = 57, .external_lex_state = 3},
  [1956] = {.lex_state = 57, .external_lex_state = 3},
  [1957] = {.lex_state = 57, .external_lex_state = 3},
  [1958] = {.lex_state = 0, .external_lex_state = 3},
  [1959] = {.lex_state = 3, .external_lex_state = 3},
  [1960] = {.lex_state = 7, .external_lex_state = 3},
  [1961] = {.lex_state = 57, .external_lex_state = 3},
  [1962] = {.lex_state = 7, .external_lex_state = 3},
  [1963] = {.lex_state = 0, .external_lex_state = 3},
  [1964] = {.lex_state = 0, .external_lex_state = 3},
  [1965] = {.lex_state = 57, .external_lex_state = 3},
  [1966] = {.lex_state = 0, .external_lex_state = 3},
  [1967] = {.lex_state = 57, .external_lex_state = 3},
  [1968] = {.lex_state = 0, .external_lex_state = 3},
  [1969] = {.lex_state = 0, .external_lex_state = 3},
  [1970] = {.lex_state = 0, .external_lex_state = 3},
  [1971] = {.lex_state = 0, .external_lex_state = 3},
  [1972] = {.lex_state = 7, .external_lex_state = 3},
  [1973] = {.lex_state = 0, .external_lex_state = 3},
  [1974] = {.lex_state = 7, .external_lex_state = 3},
  [1975] = {.lex_state = 7, .external_lex_state = 3},
  [1976] = {.lex_state = 0, .external_lex_state = 3},
  [1977] = {.lex_state = 0, .external_lex_state = 3},
  [1978] = {.lex_state = 17, .external_lex_state = 3},
  [1979] = {.lex_state = 0, .external_lex_state = 3},
  [1980] = {.lex_state = 0, .external_lex_state = 3},
  [1981] = {.lex_state = 0, .external_lex_state = 3},
  [1982] = {.lex_state = 0, .external_lex_state = 3},
  [1983] = {.lex_state = 7, .external_lex_state = 3},
  [1984] = {.lex_state = 7, .external_lex_state = 3},
  [1985] = {.lex_state = 7, .external_lex_state = 3},
  [1986] = {.lex_state = 0, .external_lex_state = 3},
  [1987] = {.lex_state = 57, .external_lex_state = 3},
  [1988] = {.lex_state = 0, .external_lex_state = 3},
  [1989] = {.lex_state = 57, .external_lex_state = 3},
  [1990] = {.lex_state = 7, .external_lex_state = 3},
  [1991] = {.lex_state = 0, .external_lex_state = 3},
  [1992] = {.lex_state = 0, .external_lex_state = 3},
  [1993] = {.lex_state = 0, .external_lex_state = 3},
  [1994] = {.lex_state = 0, .external_lex_state = 3},
  [1995] = {.lex_state = 0, .external_lex_state = 3},
  [1996] = {.lex_state = 57, .external_lex_state = 3},
  [1997] = {.lex_state = 0, .external_lex_state = 3},
  [1998] = {.lex_state = 57, .external_lex_state = 3},
  [1999] = {.lex_state = 0, .external_lex_state = 3},
  [2000] = {.lex_state = 7, .external_lex_state = 3},
  [2001] = {.lex_state = 7, .external_lex_state = 3},
  [2002] = {.lex_state = 0, .external_lex_state = 3},
  [2003] = {.lex_state = 0, .external_lex_state = 3},
  [2004] = {.lex_state = 0, .external_lex_state = 3},
  [2005] = {.lex_state = 57, .external_lex_state = 3},
  [2006] = {.lex_state = 0, .external_lex_state = 3},
  [2007] = {.lex_state = 7, .external_lex_state = 3},
  [2008] = {.lex_state = 0, .external_lex_state = 3},
  [2009] = {.lex_state = 0, .external_lex_state = 3},
  [2010] = {.lex_state = 57, .external_lex_state = 3},
  [2011] = {.lex_state = 4, .external_lex_state = 3},
  [2012] = {.lex_state = 0, .external_lex_state = 3},
  [2013] = {.lex_state = 0, .external_lex_state = 3},
  [2014] = {.lex_state = 7, .external_lex_state = 3},
  [2015] = {.lex_state = 0, .external_lex_state = 3},
  [2016] = {.lex_state = 57, .external_lex_state = 3},
  [2017] = {.lex_state = 0, .external_lex_state = 3},
  [2018] = {.lex_state = 4, .external_lex_state = 3},
  [2019] = {.lex_state = 57, .external_lex_state = 3},
  [2020] = {.lex_state = 0, .external_lex_state = 3},
  [2021] = {.lex_state = 0, .external_lex_state = 3},
  [2022] = {.lex_state = 57, .external_lex_state = 3},
  [2023] = {.lex_state = 57, .external_lex_state = 3},
  [2024] = {.lex_state = 0, .external_lex_state = 3},
  [2025] = {.lex_state = 57, .external_lex_state = 3},
  [2026] = {.lex_state = 0, .external_lex_state = 3},
  [2027] = {.lex_state = 0, .external_lex_state = 3},
  [2028] = {.lex_state = 0, .external_lex_state = 3},
  [2029] = {.lex_state = 0, .external_lex_state = 3},
  [2030] = {.lex_state = 0, .external_lex_state = 3},
  [2031] = {.lex_state = 57, .external_lex_state = 3},
  [2032] = {.lex_state = 0, .external_lex_state = 3},
  [2033] = {.lex_state = 17, .external_lex_state = 3},
  [2034] = {.lex_state = 7, .external_lex_state = 3},
  [2035] = {.lex_state = 7, .external_lex_state = 3},
  [2036] = {.lex_state = 0, .external_lex_state = 3},
  [2037] = {.lex_state = 0, .external_lex_state = 3},
  [2038] = {.lex_state = 7, .external_lex_state = 3},
  [2039] = {.lex_state = 0, .external_lex_state = 3},
  [2040] = {.lex_state = 0, .external_lex_state = 3},
  [2041] = {.lex_state = 57, .external_lex_state = 3},
  [2042] = {.lex_state = 0, .external_lex_state = 3},
  [2043] = {.lex_state = 0, .external_lex_state = 3},
  [2044] = {.lex_state = 0, .external_lex_state = 3},
  [2045] = {.lex_state = 57, .external_lex_state = 3},
  [2046] = {.lex_state = 7, .external_lex_state = 3},
  [2047] = {.lex_state = 0, .external_lex_state = 3},
  [2048] = {.lex_state = 0, .external_lex_state = 3},
  [2049] = {.lex_state = 0, .external_lex_state = 3},
  [2050] = {.lex_state = 57, .external_lex_state = 3},
  [2051] = {.lex_state = 0, .external_lex_state = 3},
  [2052] = {.lex_state = 17, .external_lex_state = 3},
  [2053] = {.lex_state = 17, .external_lex_state = 3},
  [2054] = {.lex_state = 57, .external_lex_state = 3},
  [2055] = {.lex_state = 0, .external_lex_state = 3},
  [2056] = {.lex_state = 57, .external_lex_state = 3},
  [2057] = {.lex_state = 57, .external_lex_state = 3},
  [2058] = {.lex_state = 0, .external_lex_state = 3},
  [2059] = {.lex_state = 0, .external_lex_state = 3},
  [2060] = {.lex_state = 7, .external_lex_state = 3},
  [2061] = {.lex_state = 57, .external_lex_state = 3},
  [2062] = {.lex_state = 0, .external_lex_state = 3},
  [2063] = {.lex_state = 0, .external_lex_state = 3},
  [2064] = {.lex_state = 0, .external_lex_state = 3},
  [2065] = {.lex_state = 0, .external_lex_state = 3},
  [2066] = {.lex_state = 7, .external_lex_state = 3},
  [2067] = {.lex_state = 0, .external_lex_state = 3},
  [2068] = {.lex_state = 0, .external_lex_state = 3},
  [2069] = {.lex_state = 0, .external_lex_state = 3},
  [2070] = {.lex_state = 0, .external_lex_state = 3},
  [2071] = {.lex_state = 0, .external_lex_state = 3},
  [2072] = {.lex_state = 17, .external_lex_state = 3},
  [2073] = {.lex_state = 57, .external_lex_state = 3},
  [2074] = {.lex_state = 0, .external_lex_state = 3},
  [2075] = {.lex_state = 0, .external_lex_state = 3},
  [2076] = {.lex_state = 0, .external_lex_state = 3},
  [2077] = {.lex_state = 0, .external_lex_state = 3},
  [2078] = {.lex_state = 0, .external_lex_state = 3},
  [2079] = {.lex_state = 0, .external_lex_state = 3},
  [2080] = {.lex_state = 0, .external_lex_state = 3},
  [2081] = {.lex_state = 7, .external_lex_state = 3},
  [2082] = {.lex_state = 0, .external_lex_state = 3},
  [2083] = {.lex_state = 7, .external_lex_state = 3},
  [2084] = {.lex_state = 0, .external_lex_state = 3},
  [2085] = {.lex_state = 0, .external_lex_state = 3},
  [2086] = {.lex_state = 57, .external_lex_state = 3},
  [2087] = {.lex_state = 0, .external_lex_state = 3},
  [2088] = {.lex_state = 0, .external_lex_state = 3},
  [2089] = {.lex_state = 0, .external_lex_state = 3},
  [2090] = {.lex_state = 0, .external_lex_state = 3},
  [2091] = {.lex_state = 0, .external_lex_state = 3},
  [2092] = {.lex_state = 0, .external_lex_state = 3},
  [2093] = {.lex_state = 0, .external_lex_state = 3},
  [2094] = {.lex_state = 0, .external_lex_state = 3},
  [2095] = {.lex_state = 0, .external_lex_state = 3},
  [2096] = {.lex_state = 0, .external_lex_state = 3},
  [2097] = {.lex_state = 0, .external_lex_state = 3},
  [2098] = {.lex_state = 0, .external_lex_state = 3},
  [2099] = {.lex_state = 0, .external_lex_state = 3},
  [2100] = {.lex_state = 0, .external_lex_state = 3},
  [2101] = {.lex_state = 0, .external_lex_state = 3},
  [2102] = {.lex_state = 57, .external_lex_state = 3},
  [2103] = {.lex_state = 0, .external_lex_state = 5},
  [2104] = {.lex_state = 0, .external_lex_state = 3},
  [2105] = {.lex_state = 57, .external_lex_state = 3},
  [2106] = {.lex_state = 0, .external_lex_state = 3},
  [2107] = {.lex_state = 0, .external_lex_state = 3},
  [2108] = {.lex_state = 0, .external_lex_state = 3},
  [2109] = {.lex_state = 0, .external_lex_state = 3},
  [2110] = {.lex_state = 10, .external_lex_state = 3},
  [2111] = {.lex_state = 0, .external_lex_state = 3},
  [2112] = {.lex_state = 0, .external_lex_state = 3},
  [2113] = {.lex_state = 0, .external_lex_state = 3},
  [2114] = {.lex_state = 0, .external_lex_state = 3},
  [2115] = {.lex_state = 0, .external_lex_state = 3},
  [2116] = {.lex_state = 0, .external_lex_state = 3},
  [2117] = {.lex_state = 7, .external_lex_state = 3},
  [2118] = {.lex_state = 0, .external_lex_state = 3},
  [2119] = {.lex_state = 7, .external_lex_state = 3},
  [2120] = {.lex_state = 0, .external_lex_state = 3},
  [2121] = {.lex_state = 0, .external_lex_state = 3},
  [2122] = {.lex_state = 0, .external_lex_state = 3},
  [2123] = {.lex_state = 0, .external_lex_state = 3},
  [2124] = {.lex_state = 57, .external_lex_state = 3},
  [2125] = {.lex_state = 0, .external_lex_state = 3},
  [2126] = {.lex_state = 0, .external_lex_state = 3},
  [2127] = {.lex_state = 0, .external_lex_state = 3},
  [2128] = {.lex_state = 0, .external_lex_state = 3},
  [2129] = {.lex_state = 0, .external_lex_state = 3},
  [2130] = {.lex_state = 0, .external_lex_state = 3},
  [2131] = {.lex_state = 0, .external_lex_state = 3},
  [2132] = {.lex_state = 17, .external_lex_state = 3},
  [2133] = {.lex_state = 57, .external_lex_state = 3},
  [2134] = {.lex_state = 0, .external_lex_state = 3},
  [2135] = {.lex_state = 57, .external_lex_state = 3},
  [2136] = {.lex_state = 57, .external_lex_state = 3},
  [2137] = {.lex_state = 57, .external_lex_state = 3},
  [2138] = {.lex_state = 0, .external_lex_state = 3},
  [2139] = {.lex_state = 57, .external_lex_state = 3},
  [2140] = {.lex_state = 0, .external_lex_state = 3},
  [2141] = {.lex_state = 0, .external_lex_state = 3},
  [2142] = {.lex_state = 0, .external_lex_state = 3},
  [2143] = {.lex_state = 7, .external_lex_state = 3},
  [2144] = {.lex_state = 0, .external_lex_state = 3},
  [2145] = {.lex_state = 7, .external_lex_state = 3},
  [2146] = {.lex_state = 0, .external_lex_state = 3},
  [2147] = {.lex_state = 0, .external_lex_state = 3},
  [2148] = {.lex_state = 0, .external_lex_state = 3},
  [2149] = {.lex_state = 0, .external_lex_state = 3},
  [2150] = {.lex_state = 0, .external_lex_state = 3},
  [2151] = {.lex_state = 0, .external_lex_state = 3},
  [2152] = {.lex_state = 57, .external_lex_state = 3},
  [2153] = {.lex_state = 0, .external_lex_state = 3},
  [2154] = {.lex_state = 0, .external_lex_state = 3},
  [2155] = {.lex_state = 0, .external_lex_state = 3},
  [2156] = {.lex_state = 7, .external_lex_state = 3},
  [2157] = {.lex_state = 57, .external_lex_state = 3},
  [2158] = {.lex_state = 0, .external_lex_state = 3},
  [2159] = {.lex_state = 0, .external_lex_state = 3},
  [2160] = {.lex_state = 7, .external_lex_state = 3},
  [2161] = {.lex_state = 0, .external_lex_state = 3},
  [2162] = {.lex_state = 0, .external_lex_state = 3},
  [2163] = {.lex_state = 0, .external_lex_state = 3},
  [2164] = {.lex_state = 0, .external_lex_state = 3},
  [2165] = {.lex_state = 0, .external_lex_state = 3},
  [2166] = {.lex_state = 0, .external_lex_state = 3},
  [2167] = {.lex_state = 7, .external_lex_state = 3},
  [2168] = {.lex_state = 0, .external_lex_state = 3},
  [2169] = {.lex_state = 0, .external_lex_state = 3},
  [2170] = {.lex_state = 0, .external_lex_state = 3},
  [2171] = {.lex_state = 0, .external_lex_state = 3},
  [2172] = {.lex_state = 0, .external_lex_state = 3},
  [2173] = {.lex_state = 0, .external_lex_state = 3},
  [2174] = {.lex_state = 0, .external_lex_state = 3},
  [2175] = {.lex_state = 7, .external_lex_state = 3},
  [2176] = {.lex_state = 7, .external_lex_state = 3},
  [2177] = {.lex_state = 7, .external_lex_state = 3},
  [2178] = {.lex_state = 7, .external_lex_state = 3},
  [2179] = {.lex_state = 7, .external_lex_state = 3},
  [2180] = {.lex_state = 0, .external_lex_state = 3},
  [2181] = {.lex_state = 0, .external_lex_state = 3},
  [2182] = {.lex_state = 7, .external_lex_state = 3},
  [2183] = {.lex_state = 57, .external_lex_state = 3},
  [2184] = {.lex_state = 10, .external_lex_state = 3},
  [2185] = {.lex_state = 7, .external_lex_state = 3},
  [2186] = {.lex_state = 7, .external_lex_state = 3},
  [2187] = {.lex_state = 7, .external_lex_state = 3},
  [2188] = {.lex_state = 7, .external_lex_state = 3},
  [2189] = {.lex_state = 7, .external_lex_state = 3},
  [2190] = {.lex_state = 7, .external_lex_state = 3},
  [2191] = {.lex_state = 7, .external_lex_state = 3},
  [2192] = {.lex_state = 0, .external_lex_state = 3},
  [2193] = {.lex_state = 7, .external_lex_state = 3},
  [2194] = {.lex_state = 7, .external_lex_state = 3},
  [2195] = {.lex_state = 7, .external_lex_state = 3},
  [2196] = {.lex_state = 7, .external_lex_state = 3},
  [2197] = {.lex_state = 7, .external_lex_state = 3},
  [2198] = {.lex_state = 7, .external_lex_state = 3},
  [2199] = {.lex_state = 7, .external_lex_state = 3},
  [2200] = {.lex_state = 57, .external_lex_state = 3},
  [2201] = {.lex_state = 7, .external_lex_state = 3},
  [2202] = {.lex_state = 7, .external_lex_state = 3},
  [2203] = {.lex_state = 7, .external_lex_state = 3},
  [2204] = {.lex_state = 7, .external_lex_state = 3},
  [2205] = {.lex_state = 10, .external_lex_state = 3},
  [2206] = {.lex_state = 7, .external_lex_state = 3},
  [2207] = {.lex_state = 7, .external_lex_state = 3},
  [2208] = {.lex_state = 0, .external_lex_state = 3},
  [2209] = {.lex_state = 0, .external_lex_state = 3},
  [2210] = {.lex_state = 0, .external_lex_state = 3},
  [2211] = {.lex_state = 7, .external_lex_state = 3},
  [2212] = {.lex_state = 7, .external_lex_state = 3},
  [2213] = {.lex_state = 0, .external_lex_state = 3},
  [2214] = {.lex_state = 0, .external_lex_state = 3},
  [2215] = {.lex_state = 7, .external_lex_state = 3},
  [2216] = {.lex_state = 7, .external_lex_state = 3},
  [2217] = {.lex_state = 7, .external_lex_state = 3},
  [2218] = {.lex_state = 0, .external_lex_state = 3},
  [2219] = {.lex_state = 7, .external_lex_state = 3},
  [2220] = {.lex_state = 7, .external_lex_state = 3},
  [2221] = {.lex_state = 7, .external_lex_state = 3},
  [2222] = {.lex_state = 7, .external_lex_state = 3},
  [2223] = {.lex_state = 7, .external_lex_state = 3},
  [2224] = {.lex_state = 7, .external_lex_state = 3},
  [2225] = {.lex_state = 0, .external_lex_state = 3},
  [2226] = {.lex_state = 7, .external_lex_state = 3},
  [2227] = {.lex_state = 0, .external_lex_state = 3},
  [2228] = {.lex_state = 7, .external_lex_state = 3},
  [2229] = {.lex_state = 0, .external_lex_state = 3},
  [2230] = {.lex_state = 57, .external_lex_state = 3},
  [2231] = {.lex_state = 0, .external_lex_state = 3},
  [2232] = {.lex_state = 0, .external_lex_state = 3},
  [2233] = {.lex_state = 0, .external_lex_state = 3},
  [2234] = {.lex_state = 7, .external_lex_state = 3},
  [2235] = {.lex_state = 7, .external_lex_state = 3},
  [2236] = {.lex_state = 7, .external_lex_state = 3},
  [2237] = {.lex_state = 7, .external_lex_state = 3},
  [2238] = {.lex_state = 7, .external_lex_state = 3},
  [2239] = {.lex_state = 0, .external_lex_state = 3},
  [2240] = {.lex_state = 0, .external_lex_state = 3},
  [2241] = {.lex_state = 7, .external_lex_state = 3},
  [2242] = {.lex_state = 7, .external_lex_state = 3},
  [2243] = {.lex_state = 7, .external_lex_state = 3},
  [2244] = {.lex_state = 10, .external_lex_state = 3},
  [2245] = {.lex_state = 7, .external_lex_state = 3},
  [2246] = {.lex_state = 7, .external_lex_state = 3},
  [2247] = {.lex_state = 7, .external_lex_state = 3},
  [2248] = {.lex_state = 0, .external_lex_state = 3},
  [2249] = {.lex_state = 7, .external_lex_state = 3},
  [2250] = {.lex_state = 0, .external_lex_state = 3},
  [2251] = {.lex_state = 0, .external_lex_state = 3},
  [2252] = {.lex_state = 7, .external_lex_state = 3},
  [2253] = {.lex_state = 0, .external_lex_state = 3},
  [2254] = {.lex_state = 0, .external_lex_state = 3},
  [2255] = {.lex_state = 0, .external_lex_state = 3},
  [2256] = {.lex_state = 0, .external_lex_state = 3},
  [2257] = {.lex_state = 0, .external_lex_state = 3},
  [2258] = {.lex_state = 7, .external_lex_state = 3},
  [2259] = {.lex_state = 7, .external_lex_state = 3},
  [2260] = {.lex_state = 7, .external_lex_state = 3},
  [2261] = {.lex_state = 7, .external_lex_state = 3},
  [2262] = {.lex_state = 7, .external_lex_state = 3},
  [2263] = {.lex_state = 7, .external_lex_state = 3},
  [2264] = {.lex_state = 0, .external_lex_state = 3},
  [2265] = {.lex_state = 7, .external_lex_state = 3},
  [2266] = {.lex_state = 10, .external_lex_state = 3},
  [2267] = {.lex_state = 7, .external_lex_state = 3},
  [2268] = {.lex_state = 7, .external_lex_state = 3},
  [2269] = {.lex_state = 7, .external_lex_state = 3},
  [2270] = {.lex_state = 7, .external_lex_state = 3},
  [2271] = {.lex_state = 0, .external_lex_state = 3},
  [2272] = {.lex_state = 0, .external_lex_state = 3},
  [2273] = {.lex_state = 0, .external_lex_state = 3},
  [2274] = {.lex_state = 0, .external_lex_state = 3},
  [2275] = {.lex_state = 0, .external_lex_state = 3},
  [2276] = {.lex_state = 0, .external_lex_state = 3},
  [2277] = {.lex_state = 0, .external_lex_state = 3},
  [2278] = {.lex_state = 0, .external_lex_state = 3},
  [2279] = {.lex_state = 7, .external_lex_state = 3},
  [2280] = {.lex_state = 0, .external_lex_state = 3},
  [2281] = {.lex_state = 0, .external_lex_state = 3},
  [2282] = {.lex_state = 0, .external_lex_state = 3},
  [2283] = {.lex_state = 10, .external_lex_state = 3},
  [2284] = {.lex_state = 10, .external_lex_state = 3},
  [2285] = {.lex_state = 7, .external_lex_state = 3},
  [2286] = {.lex_state = 10, .external_lex_state = 3},
  [2287] = {.lex_state = 0, .external_lex_state = 3},
  [2288] = {.lex_state = 0, .external_lex_state = 3},
  [2289] = {.lex_state = 0, .external_lex_state = 3},
  [2290] = {.lex_state = 0, .external_lex_state = 3},
  [2291] = {.lex_state = 0, .external_lex_state = 3},
  [2292] = {.lex_state = 10, .external_lex_state = 3},
  [2293] = {.lex_state = 7, .external_lex_state = 3},
  [2294] = {.lex_state = 7, .external_lex_state = 3},
  [2295] = {.lex_state = 0, .external_lex_state = 3},
  [2296] = {.lex_state = 7, .external_lex_state = 3},
  [2297] = {.lex_state = 0, .external_lex_state = 3},
  [2298] = {.lex_state = 0, .external_lex_state = 3},
  [2299] = {.lex_state = 0, .external_lex_state = 3},
  [2300] = {.lex_state = 0, .external_lex_state = 3},
  [2301] = {.lex_state = 7, .external_lex_state = 3},
  [2302] = {.lex_state = 0, .external_lex_state = 3},
  [2303] = {.lex_state = 7, .external_lex_state = 3},
  [2304] = {.lex_state = 0, .external_lex_state = 3},
  [2305] = {.lex_state = 0, .external_lex_state = 3},
  [2306] = {.lex_state = 0, .external_lex_state = 3},
  [2307] = {.lex_state = 0, .external_lex_state = 3},
  [2308] = {.lex_state = 0, .external_lex_state = 3},
  [2309] = {.lex_state = 57, .external_lex_state = 3},
  [2310] = {.lex_state = 7, .external_lex_state = 3},
  [2311] = {.lex_state = 7, .external_lex_state = 3},
  [2312] = {.lex_state = 7, .external_lex_state = 3},
  [2313] = {.lex_state = 7, .external_lex_state = 3},
  [2314] = {.lex_state = 0, .external_lex_state = 3},
  [2315] = {.lex_state = 7, .external_lex_state = 3},
  [2316] = {.lex_state = 7, .external_lex_state = 3},
  [2317] = {.lex_state = 0, .external_lex_state = 3},
  [2318] = {.lex_state = 0, .external_lex_state = 3},
  [2319] = {.lex_state = 0, .external_lex_state = 3},
  [2320] = {.lex_state = 7, .external_lex_state = 3},
  [2321] = {.lex_state = 0, .external_lex_state = 3},
  [2322] = {.lex_state = 0, .external_lex_state = 3},
  [2323] = {.lex_state = 0, .external_lex_state = 3},
  [2324] = {.lex_state = 0, .external_lex_state = 3},
  [2325] = {.lex_state = 0, .external_lex_state = 3},
  [2326] = {.lex_state = 7, .external_lex_state = 3},
  [2327] = {.lex_state = 0, .external_lex_state = 3},
  [2328] = {.lex_state = 7, .external_lex_state = 3},
  [2329] = {.lex_state = 0, .external_lex_state = 3},
  [2330] = {.lex_state = 10, .external_lex_state = 3},
  [2331] = {.lex_state = 0, .external_lex_state = 3},
  [2332] = {.lex_state = 10, .external_lex_state = 3},
  [2333] = {.lex_state = 7, .external_lex_state = 3},
  [2334] = {.lex_state = 0, .external_lex_state = 3},
  [2335] = {.lex_state = 0, .external_lex_state = 3},
  [2336] = {.lex_state = 0, .external_lex_state = 3},
  [2337] = {.lex_state = 10, .external_lex_state = 3},
  [2338] = {.lex_state = 0, .external_lex_state = 3},
  [2339] = {.lex_state = 0, .external_lex_state = 3},
  [2340] = {.lex_state = 0, .external_lex_state = 3},
  [2341] = {.lex_state = 7, .external_lex_state = 3},
  [2342] = {.lex_state = 0, .external_lex_state = 3},
  [2343] = {.lex_state = 7, .external_lex_state = 3},
  [2344] = {.lex_state = 0, .external_lex_state = 3},
  [2345] = {.lex_state = 7, .external_lex_state = 3},
  [2346] = {.lex_state = 10, .external_lex_state = 3},
  [2347] = {.lex_state = 0, .external_lex_state = 3},
  [2348] = {.lex_state = 0, .external_lex_state = 3},
  [2349] = {.lex_state = 0, .external_lex_state = 3},
  [2350] = {.lex_state = 0, .external_lex_state = 3},
  [2351] = {.lex_state = 0, .external_lex_state = 3},
  [2352] = {.lex_state = 10, .external_lex_state = 3},
  [2353] = {.lex_state = 0, .external_lex_state = 3},
  [2354] = {.lex_state = 10, .external_lex_state = 3},
  [2355] = {.lex_state = 10, .external_lex_state = 3},
  [2356] = {.lex_state = 10, .external_lex_state = 3},
  [2357] = {.lex_state = 0, .external_lex_state = 3},
  [2358] = {.lex_state = 10, .external_lex_state = 3},
  [2359] = {.lex_state = 0, .external_lex_state = 3},
  [2360] = {.lex_state = 7, .external_lex_state = 3},
  [2361] = {.lex_state = 10, .external_lex_state = 3},
  [2362] = {.lex_state = 7, .external_lex_state = 3},
  [2363] = {.lex_state = 10, .external_lex_state = 3},
  [2364] = {.lex_state = 0, .external_lex_state = 3},
  [2365] = {.lex_state = 10, .external_lex_state = 3},
  [2366] = {.lex_state = 0, .external_lex_state = 3},
  [2367] = {.lex_state = 0, .external_lex_state = 3},
  [2368] = {.lex_state = 0, .external_lex_state = 3},
  [2369] = {.lex_state = 0, .external_lex_state = 3},
  [2370] = {.lex_state = 0, .external_lex_state = 3},
  [2371] = {.lex_state = 7, .external_lex_state = 3},
  [2372] = {.lex_state = 0, .external_lex_state = 3},
  [2373] = {.lex_state = 7, .external_lex_state = 3},
  [2374] = {.lex_state = 7, .external_lex_state = 3},
  [2375] = {.lex_state = 0, .external_lex_state = 3},
  [2376] = {.lex_state = 7, .external_lex_state = 3},
  [2377] = {.lex_state = 0, .external_lex_state = 3},
  [2378] = {.lex_state = 0, .external_lex_state = 3},
  [2379] = {.lex_state = 7, .external_lex_state = 3},
  [2380] = {.lex_state = 7, .external_lex_state = 3},
  [2381] = {.lex_state = 7, .external_lex_state = 3},
  [2382] = {.lex_state = 7, .external_lex_state = 3},
  [2383] = {.lex_state = 7, .external_lex_state = 3},
  [2384] = {.lex_state = 7, .external_lex_state = 3},
  [2385] = {.lex_state = 7, .external_lex_state = 3},
  [2386] = {.lex_state = 7, .external_lex_state = 3},
  [2387] = {.lex_state = 0, .external_lex_state = 3},
  [2388] = {.lex_state = 7, .external_lex_state = 3},
  [2389] = {.lex_state = 0, .external_lex_state = 3},
  [2390] = {.lex_state = 7, .external_lex_state = 3},
  [2391] = {.lex_state = 7, .external_lex_state = 3},
};

enum {
  ts_external_token__string_content = 0,
  ts_external_token_raw_string_literal = 1,
  ts_external_token_float_literal = 2,
  ts_external_token_block_comment = 3,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token_raw_string_literal] = sym_raw_string_literal,
  [ts_external_token_float_literal] = sym_float_literal,
  [ts_external_token_block_comment] = sym_block_comment,
};

static bool ts_external_scanner_states[6][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__string_content] = true,
    [ts_external_token_raw_string_literal] = true,
    [ts_external_token_float_literal] = true,
    [ts_external_token_block_comment] = true,
  },
  [2] = {
    [ts_external_token_raw_string_literal] = true,
    [ts_external_token_float_literal] = true,
    [ts_external_token_block_comment] = true,
  },
  [3] = {
    [ts_external_token_block_comment] = true,
  },
  [4] = {
    [ts_external_token__string_content] = true,
    [ts_external_token_block_comment] = true,
  },
  [5] = {
    [ts_external_token_float_literal] = true,
    [ts_external_token_block_comment] = true,
  },
};

static uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_macro_rules_BANG] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_block] = ACTIONS(1),
    [anon_sym_expr] = ACTIONS(1),
    [anon_sym_ident] = ACTIONS(1),
    [anon_sym_item] = ACTIONS(1),
    [anon_sym_lifetime] = ACTIONS(1),
    [anon_sym_literal] = ACTIONS(1),
    [anon_sym_meta] = ACTIONS(1),
    [anon_sym_pat] = ACTIONS(1),
    [anon_sym_path] = ACTIONS(1),
    [anon_sym_stmt] = ACTIONS(1),
    [anon_sym_tt] = ACTIONS(1),
    [anon_sym_ty] = ACTIONS(1),
    [anon_sym_vis] = ACTIONS(1),
    [anon_sym_u8] = ACTIONS(1),
    [anon_sym_i8] = ACTIONS(1),
    [anon_sym_u16] = ACTIONS(1),
    [anon_sym_i16] = ACTIONS(1),
    [anon_sym_u32] = ACTIONS(1),
    [anon_sym_i32] = ACTIONS(1),
    [anon_sym_u64] = ACTIONS(1),
    [anon_sym_i64] = ACTIONS(1),
    [anon_sym_u128] = ACTIONS(1),
    [anon_sym_i128] = ACTIONS(1),
    [anon_sym_isize] = ACTIONS(1),
    [anon_sym_usize] = ACTIONS(1),
    [anon_sym_f32] = ACTIONS(1),
    [anon_sym_f64] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_str] = ACTIONS(1),
    [anon_sym_char] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_impl] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_loop] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_mod] = ACTIONS(1),
    [anon_sym_pub] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_trait] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_union] = ACTIONS(1),
    [anon_sym_unsafe] = ACTIONS(1),
    [anon_sym_use] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym_ref] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_LT2] = ACTIONS(1),
    [anon_sym_dyn] = ACTIONS(1),
    [sym_mutable_specifier] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_move] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [sym_integer_literal] = ACTIONS(1),
    [aux_sym_string_literal_token1] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_char_literal] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [sym_crate] = ACTIONS(1),
    [sym_metavariable] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym_raw_string_literal] = ACTIONS(1),
    [sym_float_literal] = ACTIONS(1),
    [sym_block_comment] = ACTIONS(3),
  },
  [1] = {
    [sym_source_file] = STATE(2295),
    [sym__statement] = STATE(5),
    [sym_empty_statement] = STATE(5),
    [sym__expression_statement] = STATE(5),
    [sym_macro_definition] = STATE(5),
    [sym_attribute_item] = STATE(5),
    [sym_inner_attribute_item] = STATE(5),
    [sym_mod_item] = STATE(5),
    [sym_foreign_mod_item] = STATE(5),
    [sym_struct_item] = STATE(5),
    [sym_union_item] = STATE(5),
    [sym_enum_item] = STATE(5),
    [sym_extern_crate_declaration] = STATE(5),
    [sym_const_item] = STATE(5),
    [sym_static_item] = STATE(5),
    [sym_type_item] = STATE(5),
    [sym_function_item] = STATE(5),
    [sym_function_signature_item] = STATE(5),
    [sym_function_modifiers] = STATE(2294),
    [sym_impl_item] = STATE(5),
    [sym_trait_item] = STATE(5),
    [sym_associated_type] = STATE(5),
    [sym_let_declaration] = STATE(5),
    [sym_use_declaration] = STATE(5),
    [sym_extern_modifier] = STATE(1392),
    [sym_visibility_modifier] = STATE(1246),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1179),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1179),
    [sym_macro_invocation] = STATE(47),
    [sym_scoped_identifier] = STATE(1073),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1179),
    [sym_unary_expression] = STATE(1179),
    [sym_try_expression] = STATE(1179),
    [sym_reference_expression] = STATE(1179),
    [sym_binary_expression] = STATE(1179),
    [sym_assignment_expression] = STATE(1179),
    [sym_compound_assignment_expr] = STATE(1179),
    [sym_type_cast_expression] = STATE(1179),
    [sym_return_expression] = STATE(1179),
    [sym_call_expression] = STATE(1179),
    [sym_array_expression] = STATE(1179),
    [sym_parenthesized_expression] = STATE(1179),
    [sym_tuple_expression] = STATE(1179),
    [sym_unit_expression] = STATE(1179),
    [sym_struct_expression] = STATE(1179),
    [sym_if_expression] = STATE(45),
    [sym_if_let_expression] = STATE(45),
    [sym_match_expression] = STATE(45),
    [sym_while_expression] = STATE(45),
    [sym_while_let_expression] = STATE(45),
    [sym_loop_expression] = STATE(45),
    [sym_for_expression] = STATE(45),
    [sym_closure_expression] = STATE(1179),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2283),
    [sym_break_expression] = STATE(1179),
    [sym_continue_expression] = STATE(1179),
    [sym_index_expression] = STATE(1179),
    [sym_await_expression] = STATE(1179),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(45),
    [sym_async_block] = STATE(45),
    [sym_block] = STATE(45),
    [sym__literal] = STATE(1179),
    [sym_string_literal] = STATE(1179),
    [sym_boolean_literal] = STATE(1179),
    [aux_sym_source_file_repeat1] = STATE(5),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [ts_builtin_sym_end] = ACTIONS(5),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_macro_rules_BANG] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_fn] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_impl] = ACTIONS(43),
    [anon_sym_let] = ACTIONS(45),
    [anon_sym_loop] = ACTIONS(47),
    [anon_sym_match] = ACTIONS(49),
    [anon_sym_mod] = ACTIONS(51),
    [anon_sym_pub] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_struct] = ACTIONS(59),
    [anon_sym_trait] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_unsafe] = ACTIONS(67),
    [anon_sym_use] = ACTIONS(69),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_extern] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(89),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(89),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(99),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(89),
    [sym_float_literal] = ACTIONS(89),
    [sym_block_comment] = ACTIONS(3),
  },
  [2] = {
    [sym__statement] = STATE(8),
    [sym_empty_statement] = STATE(8),
    [sym__expression_statement] = STATE(8),
    [sym_macro_definition] = STATE(8),
    [sym_attribute_item] = STATE(8),
    [sym_inner_attribute_item] = STATE(8),
    [sym_mod_item] = STATE(8),
    [sym_foreign_mod_item] = STATE(8),
    [sym_struct_item] = STATE(8),
    [sym_union_item] = STATE(8),
    [sym_enum_item] = STATE(8),
    [sym_extern_crate_declaration] = STATE(8),
    [sym_const_item] = STATE(8),
    [sym_static_item] = STATE(8),
    [sym_type_item] = STATE(8),
    [sym_function_item] = STATE(8),
    [sym_function_signature_item] = STATE(8),
    [sym_function_modifiers] = STATE(2294),
    [sym_impl_item] = STATE(8),
    [sym_trait_item] = STATE(8),
    [sym_associated_type] = STATE(8),
    [sym_let_declaration] = STATE(8),
    [sym_use_declaration] = STATE(8),
    [sym_extern_modifier] = STATE(1392),
    [sym_visibility_modifier] = STATE(1246),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1097),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1097),
    [sym_macro_invocation] = STATE(47),
    [sym_scoped_identifier] = STATE(1073),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1097),
    [sym_unary_expression] = STATE(1097),
    [sym_try_expression] = STATE(1097),
    [sym_reference_expression] = STATE(1097),
    [sym_binary_expression] = STATE(1097),
    [sym_assignment_expression] = STATE(1097),
    [sym_compound_assignment_expr] = STATE(1097),
    [sym_type_cast_expression] = STATE(1097),
    [sym_return_expression] = STATE(1097),
    [sym_call_expression] = STATE(1097),
    [sym_array_expression] = STATE(1097),
    [sym_parenthesized_expression] = STATE(1097),
    [sym_tuple_expression] = STATE(1097),
    [sym_unit_expression] = STATE(1097),
    [sym_struct_expression] = STATE(1097),
    [sym_if_expression] = STATE(45),
    [sym_if_let_expression] = STATE(45),
    [sym_match_expression] = STATE(45),
    [sym_while_expression] = STATE(45),
    [sym_while_let_expression] = STATE(45),
    [sym_loop_expression] = STATE(45),
    [sym_for_expression] = STATE(45),
    [sym_closure_expression] = STATE(1097),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2283),
    [sym_break_expression] = STATE(1097),
    [sym_continue_expression] = STATE(1097),
    [sym_index_expression] = STATE(1097),
    [sym_await_expression] = STATE(1097),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(45),
    [sym_async_block] = STATE(45),
    [sym_block] = STATE(45),
    [sym__literal] = STATE(1097),
    [sym_string_literal] = STATE(1097),
    [sym_boolean_literal] = STATE(1097),
    [aux_sym_source_file_repeat1] = STATE(8),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_macro_rules_BANG] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_fn] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_impl] = ACTIONS(43),
    [anon_sym_let] = ACTIONS(45),
    [anon_sym_loop] = ACTIONS(47),
    [anon_sym_match] = ACTIONS(49),
    [anon_sym_mod] = ACTIONS(51),
    [anon_sym_pub] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_struct] = ACTIONS(59),
    [anon_sym_trait] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_unsafe] = ACTIONS(67),
    [anon_sym_use] = ACTIONS(69),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_extern] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(105),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(105),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(99),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(105),
    [sym_float_literal] = ACTIONS(105),
    [sym_block_comment] = ACTIONS(3),
  },
  [3] = {
    [sym__statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym__expression_statement] = STATE(7),
    [sym_macro_definition] = STATE(7),
    [sym_attribute_item] = STATE(7),
    [sym_inner_attribute_item] = STATE(7),
    [sym_mod_item] = STATE(7),
    [sym_foreign_mod_item] = STATE(7),
    [sym_struct_item] = STATE(7),
    [sym_union_item] = STATE(7),
    [sym_enum_item] = STATE(7),
    [sym_extern_crate_declaration] = STATE(7),
    [sym_const_item] = STATE(7),
    [sym_static_item] = STATE(7),
    [sym_type_item] = STATE(7),
    [sym_function_item] = STATE(7),
    [sym_function_signature_item] = STATE(7),
    [sym_function_modifiers] = STATE(2294),
    [sym_impl_item] = STATE(7),
    [sym_trait_item] = STATE(7),
    [sym_associated_type] = STATE(7),
    [sym_let_declaration] = STATE(7),
    [sym_use_declaration] = STATE(7),
    [sym_extern_modifier] = STATE(1392),
    [sym_visibility_modifier] = STATE(1246),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1109),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1109),
    [sym_macro_invocation] = STATE(47),
    [sym_scoped_identifier] = STATE(1073),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1109),
    [sym_unary_expression] = STATE(1109),
    [sym_try_expression] = STATE(1109),
    [sym_reference_expression] = STATE(1109),
    [sym_binary_expression] = STATE(1109),
    [sym_assignment_expression] = STATE(1109),
    [sym_compound_assignment_expr] = STATE(1109),
    [sym_type_cast_expression] = STATE(1109),
    [sym_return_expression] = STATE(1109),
    [sym_call_expression] = STATE(1109),
    [sym_array_expression] = STATE(1109),
    [sym_parenthesized_expression] = STATE(1109),
    [sym_tuple_expression] = STATE(1109),
    [sym_unit_expression] = STATE(1109),
    [sym_struct_expression] = STATE(1109),
    [sym_if_expression] = STATE(45),
    [sym_if_let_expression] = STATE(45),
    [sym_match_expression] = STATE(45),
    [sym_while_expression] = STATE(45),
    [sym_while_let_expression] = STATE(45),
    [sym_loop_expression] = STATE(45),
    [sym_for_expression] = STATE(45),
    [sym_closure_expression] = STATE(1109),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2283),
    [sym_break_expression] = STATE(1109),
    [sym_continue_expression] = STATE(1109),
    [sym_index_expression] = STATE(1109),
    [sym_await_expression] = STATE(1109),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(45),
    [sym_async_block] = STATE(45),
    [sym_block] = STATE(45),
    [sym__literal] = STATE(1109),
    [sym_string_literal] = STATE(1109),
    [sym_boolean_literal] = STATE(1109),
    [aux_sym_source_file_repeat1] = STATE(7),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_macro_rules_BANG] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_fn] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_impl] = ACTIONS(43),
    [anon_sym_let] = ACTIONS(45),
    [anon_sym_loop] = ACTIONS(47),
    [anon_sym_match] = ACTIONS(49),
    [anon_sym_mod] = ACTIONS(51),
    [anon_sym_pub] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_struct] = ACTIONS(59),
    [anon_sym_trait] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_unsafe] = ACTIONS(67),
    [anon_sym_use] = ACTIONS(69),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_extern] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(109),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(109),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(99),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(109),
    [sym_float_literal] = ACTIONS(109),
    [sym_block_comment] = ACTIONS(3),
  },
  [4] = {
    [sym__statement] = STATE(13),
    [sym_empty_statement] = STATE(13),
    [sym__expression_statement] = STATE(13),
    [sym_macro_definition] = STATE(13),
    [sym_attribute_item] = STATE(13),
    [sym_inner_attribute_item] = STATE(13),
    [sym_mod_item] = STATE(13),
    [sym_foreign_mod_item] = STATE(13),
    [sym_struct_item] = STATE(13),
    [sym_union_item] = STATE(13),
    [sym_enum_item] = STATE(13),
    [sym_extern_crate_declaration] = STATE(13),
    [sym_const_item] = STATE(13),
    [sym_static_item] = STATE(13),
    [sym_type_item] = STATE(13),
    [sym_function_item] = STATE(13),
    [sym_function_signature_item] = STATE(13),
    [sym_function_modifiers] = STATE(2294),
    [sym_impl_item] = STATE(13),
    [sym_trait_item] = STATE(13),
    [sym_associated_type] = STATE(13),
    [sym_let_declaration] = STATE(13),
    [sym_use_declaration] = STATE(13),
    [sym_extern_modifier] = STATE(1392),
    [sym_visibility_modifier] = STATE(1246),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1118),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1118),
    [sym_macro_invocation] = STATE(47),
    [sym_scoped_identifier] = STATE(1073),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1118),
    [sym_unary_expression] = STATE(1118),
    [sym_try_expression] = STATE(1118),
    [sym_reference_expression] = STATE(1118),
    [sym_binary_expression] = STATE(1118),
    [sym_assignment_expression] = STATE(1118),
    [sym_compound_assignment_expr] = STATE(1118),
    [sym_type_cast_expression] = STATE(1118),
    [sym_return_expression] = STATE(1118),
    [sym_call_expression] = STATE(1118),
    [sym_array_expression] = STATE(1118),
    [sym_parenthesized_expression] = STATE(1118),
    [sym_tuple_expression] = STATE(1118),
    [sym_unit_expression] = STATE(1118),
    [sym_struct_expression] = STATE(1118),
    [sym_if_expression] = STATE(45),
    [sym_if_let_expression] = STATE(45),
    [sym_match_expression] = STATE(45),
    [sym_while_expression] = STATE(45),
    [sym_while_let_expression] = STATE(45),
    [sym_loop_expression] = STATE(45),
    [sym_for_expression] = STATE(45),
    [sym_closure_expression] = STATE(1118),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2283),
    [sym_break_expression] = STATE(1118),
    [sym_continue_expression] = STATE(1118),
    [sym_index_expression] = STATE(1118),
    [sym_await_expression] = STATE(1118),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(45),
    [sym_async_block] = STATE(45),
    [sym_block] = STATE(45),
    [sym__literal] = STATE(1118),
    [sym_string_literal] = STATE(1118),
    [sym_boolean_literal] = STATE(1118),
    [aux_sym_source_file_repeat1] = STATE(13),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_macro_rules_BANG] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_fn] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_impl] = ACTIONS(43),
    [anon_sym_let] = ACTIONS(45),
    [anon_sym_loop] = ACTIONS(47),
    [anon_sym_match] = ACTIONS(49),
    [anon_sym_mod] = ACTIONS(51),
    [anon_sym_pub] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_struct] = ACTIONS(59),
    [anon_sym_trait] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_unsafe] = ACTIONS(67),
    [anon_sym_use] = ACTIONS(69),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_extern] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(113),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(113),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(99),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(113),
    [sym_float_literal] = ACTIONS(113),
    [sym_block_comment] = ACTIONS(3),
  },
  [5] = {
    [sym__statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym__expression_statement] = STATE(6),
    [sym_macro_definition] = STATE(6),
    [sym_attribute_item] = STATE(6),
    [sym_inner_attribute_item] = STATE(6),
    [sym_mod_item] = STATE(6),
    [sym_foreign_mod_item] = STATE(6),
    [sym_struct_item] = STATE(6),
    [sym_union_item] = STATE(6),
    [sym_enum_item] = STATE(6),
    [sym_extern_crate_declaration] = STATE(6),
    [sym_const_item] = STATE(6),
    [sym_static_item] = STATE(6),
    [sym_type_item] = STATE(6),
    [sym_function_item] = STATE(6),
    [sym_function_signature_item] = STATE(6),
    [sym_function_modifiers] = STATE(2294),
    [sym_impl_item] = STATE(6),
    [sym_trait_item] = STATE(6),
    [sym_associated_type] = STATE(6),
    [sym_let_declaration] = STATE(6),
    [sym_use_declaration] = STATE(6),
    [sym_extern_modifier] = STATE(1392),
    [sym_visibility_modifier] = STATE(1246),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1179),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1179),
    [sym_macro_invocation] = STATE(47),
    [sym_scoped_identifier] = STATE(1073),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1179),
    [sym_unary_expression] = STATE(1179),
    [sym_try_expression] = STATE(1179),
    [sym_reference_expression] = STATE(1179),
    [sym_binary_expression] = STATE(1179),
    [sym_assignment_expression] = STATE(1179),
    [sym_compound_assignment_expr] = STATE(1179),
    [sym_type_cast_expression] = STATE(1179),
    [sym_return_expression] = STATE(1179),
    [sym_call_expression] = STATE(1179),
    [sym_array_expression] = STATE(1179),
    [sym_parenthesized_expression] = STATE(1179),
    [sym_tuple_expression] = STATE(1179),
    [sym_unit_expression] = STATE(1179),
    [sym_struct_expression] = STATE(1179),
    [sym_if_expression] = STATE(45),
    [sym_if_let_expression] = STATE(45),
    [sym_match_expression] = STATE(45),
    [sym_while_expression] = STATE(45),
    [sym_while_let_expression] = STATE(45),
    [sym_loop_expression] = STATE(45),
    [sym_for_expression] = STATE(45),
    [sym_closure_expression] = STATE(1179),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2283),
    [sym_break_expression] = STATE(1179),
    [sym_continue_expression] = STATE(1179),
    [sym_index_expression] = STATE(1179),
    [sym_await_expression] = STATE(1179),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(45),
    [sym_async_block] = STATE(45),
    [sym_block] = STATE(45),
    [sym__literal] = STATE(1179),
    [sym_string_literal] = STATE(1179),
    [sym_boolean_literal] = STATE(1179),
    [aux_sym_source_file_repeat1] = STATE(6),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [ts_builtin_sym_end] = ACTIONS(115),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_macro_rules_BANG] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_fn] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_impl] = ACTIONS(43),
    [anon_sym_let] = ACTIONS(45),
    [anon_sym_loop] = ACTIONS(47),
    [anon_sym_match] = ACTIONS(49),
    [anon_sym_mod] = ACTIONS(51),
    [anon_sym_pub] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_struct] = ACTIONS(59),
    [anon_sym_trait] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_unsafe] = ACTIONS(67),
    [anon_sym_use] = ACTIONS(69),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_extern] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(89),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(89),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(99),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(89),
    [sym_float_literal] = ACTIONS(89),
    [sym_block_comment] = ACTIONS(3),
  },
  [6] = {
    [sym__statement] = STATE(6),
    [sym_empty_statement] = STATE(6),
    [sym__expression_statement] = STATE(6),
    [sym_macro_definition] = STATE(6),
    [sym_attribute_item] = STATE(6),
    [sym_inner_attribute_item] = STATE(6),
    [sym_mod_item] = STATE(6),
    [sym_foreign_mod_item] = STATE(6),
    [sym_struct_item] = STATE(6),
    [sym_union_item] = STATE(6),
    [sym_enum_item] = STATE(6),
    [sym_extern_crate_declaration] = STATE(6),
    [sym_const_item] = STATE(6),
    [sym_static_item] = STATE(6),
    [sym_type_item] = STATE(6),
    [sym_function_item] = STATE(6),
    [sym_function_signature_item] = STATE(6),
    [sym_function_modifiers] = STATE(2294),
    [sym_impl_item] = STATE(6),
    [sym_trait_item] = STATE(6),
    [sym_associated_type] = STATE(6),
    [sym_let_declaration] = STATE(6),
    [sym_use_declaration] = STATE(6),
    [sym_extern_modifier] = STATE(1392),
    [sym_visibility_modifier] = STATE(1246),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1179),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1179),
    [sym_macro_invocation] = STATE(47),
    [sym_scoped_identifier] = STATE(1073),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1179),
    [sym_unary_expression] = STATE(1179),
    [sym_try_expression] = STATE(1179),
    [sym_reference_expression] = STATE(1179),
    [sym_binary_expression] = STATE(1179),
    [sym_assignment_expression] = STATE(1179),
    [sym_compound_assignment_expr] = STATE(1179),
    [sym_type_cast_expression] = STATE(1179),
    [sym_return_expression] = STATE(1179),
    [sym_call_expression] = STATE(1179),
    [sym_array_expression] = STATE(1179),
    [sym_parenthesized_expression] = STATE(1179),
    [sym_tuple_expression] = STATE(1179),
    [sym_unit_expression] = STATE(1179),
    [sym_struct_expression] = STATE(1179),
    [sym_if_expression] = STATE(45),
    [sym_if_let_expression] = STATE(45),
    [sym_match_expression] = STATE(45),
    [sym_while_expression] = STATE(45),
    [sym_while_let_expression] = STATE(45),
    [sym_loop_expression] = STATE(45),
    [sym_for_expression] = STATE(45),
    [sym_closure_expression] = STATE(1179),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2283),
    [sym_break_expression] = STATE(1179),
    [sym_continue_expression] = STATE(1179),
    [sym_index_expression] = STATE(1179),
    [sym_await_expression] = STATE(1179),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(45),
    [sym_async_block] = STATE(45),
    [sym_block] = STATE(45),
    [sym__literal] = STATE(1179),
    [sym_string_literal] = STATE(1179),
    [sym_boolean_literal] = STATE(1179),
    [aux_sym_source_file_repeat1] = STATE(6),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [ts_builtin_sym_end] = ACTIONS(117),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_SEMI] = ACTIONS(122),
    [anon_sym_macro_rules_BANG] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(128),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(134),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_u8] = ACTIONS(140),
    [anon_sym_i8] = ACTIONS(140),
    [anon_sym_u16] = ACTIONS(140),
    [anon_sym_i16] = ACTIONS(140),
    [anon_sym_u32] = ACTIONS(140),
    [anon_sym_i32] = ACTIONS(140),
    [anon_sym_u64] = ACTIONS(140),
    [anon_sym_i64] = ACTIONS(140),
    [anon_sym_u128] = ACTIONS(140),
    [anon_sym_i128] = ACTIONS(140),
    [anon_sym_isize] = ACTIONS(140),
    [anon_sym_usize] = ACTIONS(140),
    [anon_sym_f32] = ACTIONS(140),
    [anon_sym_f64] = ACTIONS(140),
    [anon_sym_bool] = ACTIONS(140),
    [anon_sym_str] = ACTIONS(140),
    [anon_sym_char] = ACTIONS(140),
    [anon_sym_SQUOTE] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(152),
    [anon_sym_continue] = ACTIONS(155),
    [anon_sym_default] = ACTIONS(158),
    [anon_sym_enum] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(164),
    [anon_sym_for] = ACTIONS(167),
    [anon_sym_if] = ACTIONS(170),
    [anon_sym_impl] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(176),
    [anon_sym_loop] = ACTIONS(179),
    [anon_sym_match] = ACTIONS(182),
    [anon_sym_mod] = ACTIONS(185),
    [anon_sym_pub] = ACTIONS(188),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_static] = ACTIONS(194),
    [anon_sym_struct] = ACTIONS(197),
    [anon_sym_trait] = ACTIONS(200),
    [anon_sym_type] = ACTIONS(203),
    [anon_sym_union] = ACTIONS(206),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_use] = ACTIONS(212),
    [anon_sym_while] = ACTIONS(215),
    [anon_sym_POUND] = ACTIONS(218),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_extern] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(224),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_DOT_DOT] = ACTIONS(233),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(236),
    [anon_sym_move] = ACTIONS(239),
    [sym_integer_literal] = ACTIONS(242),
    [aux_sym_string_literal_token1] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(242),
    [anon_sym_true] = ACTIONS(248),
    [anon_sym_false] = ACTIONS(248),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(251),
    [sym_super] = ACTIONS(254),
    [sym_crate] = ACTIONS(257),
    [sym_metavariable] = ACTIONS(260),
    [sym_raw_string_literal] = ACTIONS(242),
    [sym_float_literal] = ACTIONS(242),
    [sym_block_comment] = ACTIONS(3),
  },
  [7] = {
    [sym__statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym__expression_statement] = STATE(7),
    [sym_macro_definition] = STATE(7),
    [sym_attribute_item] = STATE(7),
    [sym_inner_attribute_item] = STATE(7),
    [sym_mod_item] = STATE(7),
    [sym_foreign_mod_item] = STATE(7),
    [sym_struct_item] = STATE(7),
    [sym_union_item] = STATE(7),
    [sym_enum_item] = STATE(7),
    [sym_extern_crate_declaration] = STATE(7),
    [sym_const_item] = STATE(7),
    [sym_static_item] = STATE(7),
    [sym_type_item] = STATE(7),
    [sym_function_item] = STATE(7),
    [sym_function_signature_item] = STATE(7),
    [sym_function_modifiers] = STATE(2294),
    [sym_impl_item] = STATE(7),
    [sym_trait_item] = STATE(7),
    [sym_associated_type] = STATE(7),
    [sym_let_declaration] = STATE(7),
    [sym_use_declaration] = STATE(7),
    [sym_extern_modifier] = STATE(1392),
    [sym_visibility_modifier] = STATE(1246),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1179),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1179),
    [sym_macro_invocation] = STATE(62),
    [sym_scoped_identifier] = STATE(1073),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1179),
    [sym_unary_expression] = STATE(1179),
    [sym_try_expression] = STATE(1179),
    [sym_reference_expression] = STATE(1179),
    [sym_binary_expression] = STATE(1179),
    [sym_assignment_expression] = STATE(1179),
    [sym_compound_assignment_expr] = STATE(1179),
    [sym_type_cast_expression] = STATE(1179),
    [sym_return_expression] = STATE(1179),
    [sym_call_expression] = STATE(1179),
    [sym_array_expression] = STATE(1179),
    [sym_parenthesized_expression] = STATE(1179),
    [sym_tuple_expression] = STATE(1179),
    [sym_unit_expression] = STATE(1179),
    [sym_struct_expression] = STATE(1179),
    [sym_if_expression] = STATE(45),
    [sym_if_let_expression] = STATE(45),
    [sym_match_expression] = STATE(45),
    [sym_while_expression] = STATE(45),
    [sym_while_let_expression] = STATE(45),
    [sym_loop_expression] = STATE(45),
    [sym_for_expression] = STATE(45),
    [sym_closure_expression] = STATE(1179),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2283),
    [sym_break_expression] = STATE(1179),
    [sym_continue_expression] = STATE(1179),
    [sym_index_expression] = STATE(1179),
    [sym_await_expression] = STATE(1179),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(45),
    [sym_async_block] = STATE(45),
    [sym_block] = STATE(45),
    [sym__literal] = STATE(1179),
    [sym_string_literal] = STATE(1179),
    [sym_boolean_literal] = STATE(1179),
    [aux_sym_source_file_repeat1] = STATE(7),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(119),
    [anon_sym_SEMI] = ACTIONS(122),
    [anon_sym_macro_rules_BANG] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(128),
    [anon_sym_LBRACE] = ACTIONS(131),
    [anon_sym_RBRACE] = ACTIONS(117),
    [anon_sym_LBRACK] = ACTIONS(134),
    [anon_sym_STAR] = ACTIONS(137),
    [anon_sym_u8] = ACTIONS(140),
    [anon_sym_i8] = ACTIONS(140),
    [anon_sym_u16] = ACTIONS(140),
    [anon_sym_i16] = ACTIONS(140),
    [anon_sym_u32] = ACTIONS(140),
    [anon_sym_i32] = ACTIONS(140),
    [anon_sym_u64] = ACTIONS(140),
    [anon_sym_i64] = ACTIONS(140),
    [anon_sym_u128] = ACTIONS(140),
    [anon_sym_i128] = ACTIONS(140),
    [anon_sym_isize] = ACTIONS(140),
    [anon_sym_usize] = ACTIONS(140),
    [anon_sym_f32] = ACTIONS(140),
    [anon_sym_f64] = ACTIONS(140),
    [anon_sym_bool] = ACTIONS(140),
    [anon_sym_str] = ACTIONS(140),
    [anon_sym_char] = ACTIONS(140),
    [anon_sym_SQUOTE] = ACTIONS(143),
    [anon_sym_async] = ACTIONS(146),
    [anon_sym_break] = ACTIONS(149),
    [anon_sym_const] = ACTIONS(152),
    [anon_sym_continue] = ACTIONS(155),
    [anon_sym_default] = ACTIONS(158),
    [anon_sym_enum] = ACTIONS(161),
    [anon_sym_fn] = ACTIONS(164),
    [anon_sym_for] = ACTIONS(167),
    [anon_sym_if] = ACTIONS(170),
    [anon_sym_impl] = ACTIONS(173),
    [anon_sym_let] = ACTIONS(176),
    [anon_sym_loop] = ACTIONS(179),
    [anon_sym_match] = ACTIONS(182),
    [anon_sym_mod] = ACTIONS(185),
    [anon_sym_pub] = ACTIONS(188),
    [anon_sym_return] = ACTIONS(191),
    [anon_sym_static] = ACTIONS(194),
    [anon_sym_struct] = ACTIONS(197),
    [anon_sym_trait] = ACTIONS(200),
    [anon_sym_type] = ACTIONS(203),
    [anon_sym_union] = ACTIONS(206),
    [anon_sym_unsafe] = ACTIONS(209),
    [anon_sym_use] = ACTIONS(212),
    [anon_sym_while] = ACTIONS(215),
    [anon_sym_POUND] = ACTIONS(218),
    [anon_sym_BANG] = ACTIONS(137),
    [anon_sym_extern] = ACTIONS(221),
    [anon_sym_LT] = ACTIONS(224),
    [anon_sym_COLON_COLON] = ACTIONS(227),
    [anon_sym_AMP] = ACTIONS(230),
    [anon_sym_DOT_DOT] = ACTIONS(233),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(236),
    [anon_sym_move] = ACTIONS(239),
    [sym_integer_literal] = ACTIONS(242),
    [aux_sym_string_literal_token1] = ACTIONS(245),
    [sym_char_literal] = ACTIONS(242),
    [anon_sym_true] = ACTIONS(248),
    [anon_sym_false] = ACTIONS(248),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(251),
    [sym_super] = ACTIONS(254),
    [sym_crate] = ACTIONS(257),
    [sym_metavariable] = ACTIONS(260),
    [sym_raw_string_literal] = ACTIONS(242),
    [sym_float_literal] = ACTIONS(242),
    [sym_block_comment] = ACTIONS(3),
  },
  [8] = {
    [sym__statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym__expression_statement] = STATE(7),
    [sym_macro_definition] = STATE(7),
    [sym_attribute_item] = STATE(7),
    [sym_inner_attribute_item] = STATE(7),
    [sym_mod_item] = STATE(7),
    [sym_foreign_mod_item] = STATE(7),
    [sym_struct_item] = STATE(7),
    [sym_union_item] = STATE(7),
    [sym_enum_item] = STATE(7),
    [sym_extern_crate_declaration] = STATE(7),
    [sym_const_item] = STATE(7),
    [sym_static_item] = STATE(7),
    [sym_type_item] = STATE(7),
    [sym_function_item] = STATE(7),
    [sym_function_signature_item] = STATE(7),
    [sym_function_modifiers] = STATE(2294),
    [sym_impl_item] = STATE(7),
    [sym_trait_item] = STATE(7),
    [sym_associated_type] = STATE(7),
    [sym_let_declaration] = STATE(7),
    [sym_use_declaration] = STATE(7),
    [sym_extern_modifier] = STATE(1392),
    [sym_visibility_modifier] = STATE(1246),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1098),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1098),
    [sym_macro_invocation] = STATE(47),
    [sym_scoped_identifier] = STATE(1073),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1098),
    [sym_unary_expression] = STATE(1098),
    [sym_try_expression] = STATE(1098),
    [sym_reference_expression] = STATE(1098),
    [sym_binary_expression] = STATE(1098),
    [sym_assignment_expression] = STATE(1098),
    [sym_compound_assignment_expr] = STATE(1098),
    [sym_type_cast_expression] = STATE(1098),
    [sym_return_expression] = STATE(1098),
    [sym_call_expression] = STATE(1098),
    [sym_array_expression] = STATE(1098),
    [sym_parenthesized_expression] = STATE(1098),
    [sym_tuple_expression] = STATE(1098),
    [sym_unit_expression] = STATE(1098),
    [sym_struct_expression] = STATE(1098),
    [sym_if_expression] = STATE(45),
    [sym_if_let_expression] = STATE(45),
    [sym_match_expression] = STATE(45),
    [sym_while_expression] = STATE(45),
    [sym_while_let_expression] = STATE(45),
    [sym_loop_expression] = STATE(45),
    [sym_for_expression] = STATE(45),
    [sym_closure_expression] = STATE(1098),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2283),
    [sym_break_expression] = STATE(1098),
    [sym_continue_expression] = STATE(1098),
    [sym_index_expression] = STATE(1098),
    [sym_await_expression] = STATE(1098),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(45),
    [sym_async_block] = STATE(45),
    [sym_block] = STATE(45),
    [sym__literal] = STATE(1098),
    [sym_string_literal] = STATE(1098),
    [sym_boolean_literal] = STATE(1098),
    [aux_sym_source_file_repeat1] = STATE(7),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_macro_rules_BANG] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(263),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_fn] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_impl] = ACTIONS(43),
    [anon_sym_let] = ACTIONS(45),
    [anon_sym_loop] = ACTIONS(47),
    [anon_sym_match] = ACTIONS(49),
    [anon_sym_mod] = ACTIONS(51),
    [anon_sym_pub] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_struct] = ACTIONS(59),
    [anon_sym_trait] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_unsafe] = ACTIONS(67),
    [anon_sym_use] = ACTIONS(69),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_extern] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(265),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(265),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(99),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(265),
    [sym_float_literal] = ACTIONS(265),
    [sym_block_comment] = ACTIONS(3),
  },
  [9] = {
    [sym__statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym__expression_statement] = STATE(7),
    [sym_macro_definition] = STATE(7),
    [sym_attribute_item] = STATE(7),
    [sym_inner_attribute_item] = STATE(7),
    [sym_mod_item] = STATE(7),
    [sym_foreign_mod_item] = STATE(7),
    [sym_struct_item] = STATE(7),
    [sym_union_item] = STATE(7),
    [sym_enum_item] = STATE(7),
    [sym_extern_crate_declaration] = STATE(7),
    [sym_const_item] = STATE(7),
    [sym_static_item] = STATE(7),
    [sym_type_item] = STATE(7),
    [sym_function_item] = STATE(7),
    [sym_function_signature_item] = STATE(7),
    [sym_function_modifiers] = STATE(2294),
    [sym_impl_item] = STATE(7),
    [sym_trait_item] = STATE(7),
    [sym_associated_type] = STATE(7),
    [sym_let_declaration] = STATE(7),
    [sym_use_declaration] = STATE(7),
    [sym_extern_modifier] = STATE(1392),
    [sym_visibility_modifier] = STATE(1246),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1086),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1086),
    [sym_macro_invocation] = STATE(47),
    [sym_scoped_identifier] = STATE(1073),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1086),
    [sym_unary_expression] = STATE(1086),
    [sym_try_expression] = STATE(1086),
    [sym_reference_expression] = STATE(1086),
    [sym_binary_expression] = STATE(1086),
    [sym_assignment_expression] = STATE(1086),
    [sym_compound_assignment_expr] = STATE(1086),
    [sym_type_cast_expression] = STATE(1086),
    [sym_return_expression] = STATE(1086),
    [sym_call_expression] = STATE(1086),
    [sym_array_expression] = STATE(1086),
    [sym_parenthesized_expression] = STATE(1086),
    [sym_tuple_expression] = STATE(1086),
    [sym_unit_expression] = STATE(1086),
    [sym_struct_expression] = STATE(1086),
    [sym_if_expression] = STATE(45),
    [sym_if_let_expression] = STATE(45),
    [sym_match_expression] = STATE(45),
    [sym_while_expression] = STATE(45),
    [sym_while_let_expression] = STATE(45),
    [sym_loop_expression] = STATE(45),
    [sym_for_expression] = STATE(45),
    [sym_closure_expression] = STATE(1086),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2283),
    [sym_break_expression] = STATE(1086),
    [sym_continue_expression] = STATE(1086),
    [sym_index_expression] = STATE(1086),
    [sym_await_expression] = STATE(1086),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(45),
    [sym_async_block] = STATE(45),
    [sym_block] = STATE(45),
    [sym__literal] = STATE(1086),
    [sym_string_literal] = STATE(1086),
    [sym_boolean_literal] = STATE(1086),
    [aux_sym_source_file_repeat1] = STATE(7),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_macro_rules_BANG] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_fn] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_impl] = ACTIONS(43),
    [anon_sym_let] = ACTIONS(45),
    [anon_sym_loop] = ACTIONS(47),
    [anon_sym_match] = ACTIONS(49),
    [anon_sym_mod] = ACTIONS(51),
    [anon_sym_pub] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_struct] = ACTIONS(59),
    [anon_sym_trait] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_unsafe] = ACTIONS(67),
    [anon_sym_use] = ACTIONS(69),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_extern] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(269),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(269),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(99),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(269),
    [sym_float_literal] = ACTIONS(269),
    [sym_block_comment] = ACTIONS(3),
  },
  [10] = {
    [sym__statement] = STATE(14),
    [sym_empty_statement] = STATE(14),
    [sym__expression_statement] = STATE(14),
    [sym_macro_definition] = STATE(14),
    [sym_attribute_item] = STATE(14),
    [sym_inner_attribute_item] = STATE(14),
    [sym_mod_item] = STATE(14),
    [sym_foreign_mod_item] = STATE(14),
    [sym_struct_item] = STATE(14),
    [sym_union_item] = STATE(14),
    [sym_enum_item] = STATE(14),
    [sym_extern_crate_declaration] = STATE(14),
    [sym_const_item] = STATE(14),
    [sym_static_item] = STATE(14),
    [sym_type_item] = STATE(14),
    [sym_function_item] = STATE(14),
    [sym_function_signature_item] = STATE(14),
    [sym_function_modifiers] = STATE(2294),
    [sym_impl_item] = STATE(14),
    [sym_trait_item] = STATE(14),
    [sym_associated_type] = STATE(14),
    [sym_let_declaration] = STATE(14),
    [sym_use_declaration] = STATE(14),
    [sym_extern_modifier] = STATE(1392),
    [sym_visibility_modifier] = STATE(1246),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1111),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1111),
    [sym_macro_invocation] = STATE(47),
    [sym_scoped_identifier] = STATE(1073),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1111),
    [sym_unary_expression] = STATE(1111),
    [sym_try_expression] = STATE(1111),
    [sym_reference_expression] = STATE(1111),
    [sym_binary_expression] = STATE(1111),
    [sym_assignment_expression] = STATE(1111),
    [sym_compound_assignment_expr] = STATE(1111),
    [sym_type_cast_expression] = STATE(1111),
    [sym_return_expression] = STATE(1111),
    [sym_call_expression] = STATE(1111),
    [sym_array_expression] = STATE(1111),
    [sym_parenthesized_expression] = STATE(1111),
    [sym_tuple_expression] = STATE(1111),
    [sym_unit_expression] = STATE(1111),
    [sym_struct_expression] = STATE(1111),
    [sym_if_expression] = STATE(45),
    [sym_if_let_expression] = STATE(45),
    [sym_match_expression] = STATE(45),
    [sym_while_expression] = STATE(45),
    [sym_while_let_expression] = STATE(45),
    [sym_loop_expression] = STATE(45),
    [sym_for_expression] = STATE(45),
    [sym_closure_expression] = STATE(1111),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2283),
    [sym_break_expression] = STATE(1111),
    [sym_continue_expression] = STATE(1111),
    [sym_index_expression] = STATE(1111),
    [sym_await_expression] = STATE(1111),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(45),
    [sym_async_block] = STATE(45),
    [sym_block] = STATE(45),
    [sym__literal] = STATE(1111),
    [sym_string_literal] = STATE(1111),
    [sym_boolean_literal] = STATE(1111),
    [aux_sym_source_file_repeat1] = STATE(14),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_macro_rules_BANG] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(271),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_fn] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_impl] = ACTIONS(43),
    [anon_sym_let] = ACTIONS(45),
    [anon_sym_loop] = ACTIONS(47),
    [anon_sym_match] = ACTIONS(49),
    [anon_sym_mod] = ACTIONS(51),
    [anon_sym_pub] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_struct] = ACTIONS(59),
    [anon_sym_trait] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_unsafe] = ACTIONS(67),
    [anon_sym_use] = ACTIONS(69),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_extern] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(273),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(273),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(99),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(273),
    [sym_float_literal] = ACTIONS(273),
    [sym_block_comment] = ACTIONS(3),
  },
  [11] = {
    [sym__statement] = STATE(3),
    [sym_empty_statement] = STATE(3),
    [sym__expression_statement] = STATE(3),
    [sym_macro_definition] = STATE(3),
    [sym_attribute_item] = STATE(3),
    [sym_inner_attribute_item] = STATE(3),
    [sym_mod_item] = STATE(3),
    [sym_foreign_mod_item] = STATE(3),
    [sym_struct_item] = STATE(3),
    [sym_union_item] = STATE(3),
    [sym_enum_item] = STATE(3),
    [sym_extern_crate_declaration] = STATE(3),
    [sym_const_item] = STATE(3),
    [sym_static_item] = STATE(3),
    [sym_type_item] = STATE(3),
    [sym_function_item] = STATE(3),
    [sym_function_signature_item] = STATE(3),
    [sym_function_modifiers] = STATE(2294),
    [sym_impl_item] = STATE(3),
    [sym_trait_item] = STATE(3),
    [sym_associated_type] = STATE(3),
    [sym_let_declaration] = STATE(3),
    [sym_use_declaration] = STATE(3),
    [sym_extern_modifier] = STATE(1392),
    [sym_visibility_modifier] = STATE(1246),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1126),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1126),
    [sym_macro_invocation] = STATE(47),
    [sym_scoped_identifier] = STATE(1073),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1126),
    [sym_unary_expression] = STATE(1126),
    [sym_try_expression] = STATE(1126),
    [sym_reference_expression] = STATE(1126),
    [sym_binary_expression] = STATE(1126),
    [sym_assignment_expression] = STATE(1126),
    [sym_compound_assignment_expr] = STATE(1126),
    [sym_type_cast_expression] = STATE(1126),
    [sym_return_expression] = STATE(1126),
    [sym_call_expression] = STATE(1126),
    [sym_array_expression] = STATE(1126),
    [sym_parenthesized_expression] = STATE(1126),
    [sym_tuple_expression] = STATE(1126),
    [sym_unit_expression] = STATE(1126),
    [sym_struct_expression] = STATE(1126),
    [sym_if_expression] = STATE(45),
    [sym_if_let_expression] = STATE(45),
    [sym_match_expression] = STATE(45),
    [sym_while_expression] = STATE(45),
    [sym_while_let_expression] = STATE(45),
    [sym_loop_expression] = STATE(45),
    [sym_for_expression] = STATE(45),
    [sym_closure_expression] = STATE(1126),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2283),
    [sym_break_expression] = STATE(1126),
    [sym_continue_expression] = STATE(1126),
    [sym_index_expression] = STATE(1126),
    [sym_await_expression] = STATE(1126),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(45),
    [sym_async_block] = STATE(45),
    [sym_block] = STATE(45),
    [sym__literal] = STATE(1126),
    [sym_string_literal] = STATE(1126),
    [sym_boolean_literal] = STATE(1126),
    [aux_sym_source_file_repeat1] = STATE(3),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_macro_rules_BANG] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(275),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_fn] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_impl] = ACTIONS(43),
    [anon_sym_let] = ACTIONS(45),
    [anon_sym_loop] = ACTIONS(47),
    [anon_sym_match] = ACTIONS(49),
    [anon_sym_mod] = ACTIONS(51),
    [anon_sym_pub] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_struct] = ACTIONS(59),
    [anon_sym_trait] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_unsafe] = ACTIONS(67),
    [anon_sym_use] = ACTIONS(69),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_extern] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(277),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(277),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(99),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(277),
    [sym_float_literal] = ACTIONS(277),
    [sym_block_comment] = ACTIONS(3),
  },
  [12] = {
    [sym__statement] = STATE(9),
    [sym_empty_statement] = STATE(9),
    [sym__expression_statement] = STATE(9),
    [sym_macro_definition] = STATE(9),
    [sym_attribute_item] = STATE(9),
    [sym_inner_attribute_item] = STATE(9),
    [sym_mod_item] = STATE(9),
    [sym_foreign_mod_item] = STATE(9),
    [sym_struct_item] = STATE(9),
    [sym_union_item] = STATE(9),
    [sym_enum_item] = STATE(9),
    [sym_extern_crate_declaration] = STATE(9),
    [sym_const_item] = STATE(9),
    [sym_static_item] = STATE(9),
    [sym_type_item] = STATE(9),
    [sym_function_item] = STATE(9),
    [sym_function_signature_item] = STATE(9),
    [sym_function_modifiers] = STATE(2294),
    [sym_impl_item] = STATE(9),
    [sym_trait_item] = STATE(9),
    [sym_associated_type] = STATE(9),
    [sym_let_declaration] = STATE(9),
    [sym_use_declaration] = STATE(9),
    [sym_extern_modifier] = STATE(1392),
    [sym_visibility_modifier] = STATE(1246),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1081),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1081),
    [sym_macro_invocation] = STATE(47),
    [sym_scoped_identifier] = STATE(1073),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1081),
    [sym_unary_expression] = STATE(1081),
    [sym_try_expression] = STATE(1081),
    [sym_reference_expression] = STATE(1081),
    [sym_binary_expression] = STATE(1081),
    [sym_assignment_expression] = STATE(1081),
    [sym_compound_assignment_expr] = STATE(1081),
    [sym_type_cast_expression] = STATE(1081),
    [sym_return_expression] = STATE(1081),
    [sym_call_expression] = STATE(1081),
    [sym_array_expression] = STATE(1081),
    [sym_parenthesized_expression] = STATE(1081),
    [sym_tuple_expression] = STATE(1081),
    [sym_unit_expression] = STATE(1081),
    [sym_struct_expression] = STATE(1081),
    [sym_if_expression] = STATE(45),
    [sym_if_let_expression] = STATE(45),
    [sym_match_expression] = STATE(45),
    [sym_while_expression] = STATE(45),
    [sym_while_let_expression] = STATE(45),
    [sym_loop_expression] = STATE(45),
    [sym_for_expression] = STATE(45),
    [sym_closure_expression] = STATE(1081),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2283),
    [sym_break_expression] = STATE(1081),
    [sym_continue_expression] = STATE(1081),
    [sym_index_expression] = STATE(1081),
    [sym_await_expression] = STATE(1081),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(45),
    [sym_async_block] = STATE(45),
    [sym_block] = STATE(45),
    [sym__literal] = STATE(1081),
    [sym_string_literal] = STATE(1081),
    [sym_boolean_literal] = STATE(1081),
    [aux_sym_source_file_repeat1] = STATE(9),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_macro_rules_BANG] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(279),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_fn] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_impl] = ACTIONS(43),
    [anon_sym_let] = ACTIONS(45),
    [anon_sym_loop] = ACTIONS(47),
    [anon_sym_match] = ACTIONS(49),
    [anon_sym_mod] = ACTIONS(51),
    [anon_sym_pub] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_struct] = ACTIONS(59),
    [anon_sym_trait] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_unsafe] = ACTIONS(67),
    [anon_sym_use] = ACTIONS(69),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_extern] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(281),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(281),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(99),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(281),
    [sym_float_literal] = ACTIONS(281),
    [sym_block_comment] = ACTIONS(3),
  },
  [13] = {
    [sym__statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym__expression_statement] = STATE(7),
    [sym_macro_definition] = STATE(7),
    [sym_attribute_item] = STATE(7),
    [sym_inner_attribute_item] = STATE(7),
    [sym_mod_item] = STATE(7),
    [sym_foreign_mod_item] = STATE(7),
    [sym_struct_item] = STATE(7),
    [sym_union_item] = STATE(7),
    [sym_enum_item] = STATE(7),
    [sym_extern_crate_declaration] = STATE(7),
    [sym_const_item] = STATE(7),
    [sym_static_item] = STATE(7),
    [sym_type_item] = STATE(7),
    [sym_function_item] = STATE(7),
    [sym_function_signature_item] = STATE(7),
    [sym_function_modifiers] = STATE(2294),
    [sym_impl_item] = STATE(7),
    [sym_trait_item] = STATE(7),
    [sym_associated_type] = STATE(7),
    [sym_let_declaration] = STATE(7),
    [sym_use_declaration] = STATE(7),
    [sym_extern_modifier] = STATE(1392),
    [sym_visibility_modifier] = STATE(1246),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1128),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1128),
    [sym_macro_invocation] = STATE(47),
    [sym_scoped_identifier] = STATE(1073),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1128),
    [sym_unary_expression] = STATE(1128),
    [sym_try_expression] = STATE(1128),
    [sym_reference_expression] = STATE(1128),
    [sym_binary_expression] = STATE(1128),
    [sym_assignment_expression] = STATE(1128),
    [sym_compound_assignment_expr] = STATE(1128),
    [sym_type_cast_expression] = STATE(1128),
    [sym_return_expression] = STATE(1128),
    [sym_call_expression] = STATE(1128),
    [sym_array_expression] = STATE(1128),
    [sym_parenthesized_expression] = STATE(1128),
    [sym_tuple_expression] = STATE(1128),
    [sym_unit_expression] = STATE(1128),
    [sym_struct_expression] = STATE(1128),
    [sym_if_expression] = STATE(45),
    [sym_if_let_expression] = STATE(45),
    [sym_match_expression] = STATE(45),
    [sym_while_expression] = STATE(45),
    [sym_while_let_expression] = STATE(45),
    [sym_loop_expression] = STATE(45),
    [sym_for_expression] = STATE(45),
    [sym_closure_expression] = STATE(1128),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2283),
    [sym_break_expression] = STATE(1128),
    [sym_continue_expression] = STATE(1128),
    [sym_index_expression] = STATE(1128),
    [sym_await_expression] = STATE(1128),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(45),
    [sym_async_block] = STATE(45),
    [sym_block] = STATE(45),
    [sym__literal] = STATE(1128),
    [sym_string_literal] = STATE(1128),
    [sym_boolean_literal] = STATE(1128),
    [aux_sym_source_file_repeat1] = STATE(7),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_macro_rules_BANG] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(283),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_fn] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_impl] = ACTIONS(43),
    [anon_sym_let] = ACTIONS(45),
    [anon_sym_loop] = ACTIONS(47),
    [anon_sym_match] = ACTIONS(49),
    [anon_sym_mod] = ACTIONS(51),
    [anon_sym_pub] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_struct] = ACTIONS(59),
    [anon_sym_trait] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_unsafe] = ACTIONS(67),
    [anon_sym_use] = ACTIONS(69),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_extern] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(285),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(285),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(99),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(285),
    [sym_float_literal] = ACTIONS(285),
    [sym_block_comment] = ACTIONS(3),
  },
  [14] = {
    [sym__statement] = STATE(7),
    [sym_empty_statement] = STATE(7),
    [sym__expression_statement] = STATE(7),
    [sym_macro_definition] = STATE(7),
    [sym_attribute_item] = STATE(7),
    [sym_inner_attribute_item] = STATE(7),
    [sym_mod_item] = STATE(7),
    [sym_foreign_mod_item] = STATE(7),
    [sym_struct_item] = STATE(7),
    [sym_union_item] = STATE(7),
    [sym_enum_item] = STATE(7),
    [sym_extern_crate_declaration] = STATE(7),
    [sym_const_item] = STATE(7),
    [sym_static_item] = STATE(7),
    [sym_type_item] = STATE(7),
    [sym_function_item] = STATE(7),
    [sym_function_signature_item] = STATE(7),
    [sym_function_modifiers] = STATE(2294),
    [sym_impl_item] = STATE(7),
    [sym_trait_item] = STATE(7),
    [sym_associated_type] = STATE(7),
    [sym_let_declaration] = STATE(7),
    [sym_use_declaration] = STATE(7),
    [sym_extern_modifier] = STATE(1392),
    [sym_visibility_modifier] = STATE(1246),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1113),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1113),
    [sym_macro_invocation] = STATE(47),
    [sym_scoped_identifier] = STATE(1073),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1113),
    [sym_unary_expression] = STATE(1113),
    [sym_try_expression] = STATE(1113),
    [sym_reference_expression] = STATE(1113),
    [sym_binary_expression] = STATE(1113),
    [sym_assignment_expression] = STATE(1113),
    [sym_compound_assignment_expr] = STATE(1113),
    [sym_type_cast_expression] = STATE(1113),
    [sym_return_expression] = STATE(1113),
    [sym_call_expression] = STATE(1113),
    [sym_array_expression] = STATE(1113),
    [sym_parenthesized_expression] = STATE(1113),
    [sym_tuple_expression] = STATE(1113),
    [sym_unit_expression] = STATE(1113),
    [sym_struct_expression] = STATE(1113),
    [sym_if_expression] = STATE(45),
    [sym_if_let_expression] = STATE(45),
    [sym_match_expression] = STATE(45),
    [sym_while_expression] = STATE(45),
    [sym_while_let_expression] = STATE(45),
    [sym_loop_expression] = STATE(45),
    [sym_for_expression] = STATE(45),
    [sym_closure_expression] = STATE(1113),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2283),
    [sym_break_expression] = STATE(1113),
    [sym_continue_expression] = STATE(1113),
    [sym_index_expression] = STATE(1113),
    [sym_await_expression] = STATE(1113),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(45),
    [sym_async_block] = STATE(45),
    [sym_block] = STATE(45),
    [sym__literal] = STATE(1113),
    [sym_string_literal] = STATE(1113),
    [sym_boolean_literal] = STATE(1113),
    [aux_sym_source_file_repeat1] = STATE(7),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_macro_rules_BANG] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(15),
    [anon_sym_RBRACE] = ACTIONS(287),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(33),
    [anon_sym_enum] = ACTIONS(35),
    [anon_sym_fn] = ACTIONS(37),
    [anon_sym_for] = ACTIONS(39),
    [anon_sym_if] = ACTIONS(41),
    [anon_sym_impl] = ACTIONS(43),
    [anon_sym_let] = ACTIONS(45),
    [anon_sym_loop] = ACTIONS(47),
    [anon_sym_match] = ACTIONS(49),
    [anon_sym_mod] = ACTIONS(51),
    [anon_sym_pub] = ACTIONS(53),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_static] = ACTIONS(57),
    [anon_sym_struct] = ACTIONS(59),
    [anon_sym_trait] = ACTIONS(61),
    [anon_sym_type] = ACTIONS(63),
    [anon_sym_union] = ACTIONS(65),
    [anon_sym_unsafe] = ACTIONS(67),
    [anon_sym_use] = ACTIONS(69),
    [anon_sym_while] = ACTIONS(71),
    [anon_sym_POUND] = ACTIONS(73),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_extern] = ACTIONS(75),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(289),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(289),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(99),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(289),
    [sym_float_literal] = ACTIONS(289),
    [sym_block_comment] = ACTIONS(3),
  },
  [15] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(975),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(975),
    [sym_macro_invocation] = STATE(975),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(975),
    [sym_unary_expression] = STATE(975),
    [sym_try_expression] = STATE(975),
    [sym_reference_expression] = STATE(975),
    [sym_binary_expression] = STATE(975),
    [sym_assignment_expression] = STATE(975),
    [sym_compound_assignment_expr] = STATE(975),
    [sym_type_cast_expression] = STATE(975),
    [sym_return_expression] = STATE(975),
    [sym_call_expression] = STATE(975),
    [sym_array_expression] = STATE(975),
    [sym_parenthesized_expression] = STATE(975),
    [sym_tuple_expression] = STATE(975),
    [sym_unit_expression] = STATE(975),
    [sym_struct_expression] = STATE(975),
    [sym_if_expression] = STATE(975),
    [sym_if_let_expression] = STATE(975),
    [sym_match_expression] = STATE(975),
    [sym_while_expression] = STATE(975),
    [sym_while_let_expression] = STATE(975),
    [sym_loop_expression] = STATE(975),
    [sym_for_expression] = STATE(975),
    [sym_closure_expression] = STATE(975),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(975),
    [sym_continue_expression] = STATE(975),
    [sym_index_expression] = STATE(975),
    [sym_await_expression] = STATE(975),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(975),
    [sym_async_block] = STATE(975),
    [sym_block] = STATE(975),
    [sym__literal] = STATE(975),
    [sym_string_literal] = STATE(975),
    [sym_boolean_literal] = STATE(975),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_SEMI] = ACTIONS(293),
    [anon_sym_LPAREN] = ACTIONS(293),
    [anon_sym_RPAREN] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_RBRACE] = ACTIONS(293),
    [anon_sym_EQ_GT] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(293),
    [anon_sym_RBRACK] = ACTIONS(293),
    [anon_sym_COLON] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(293),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(299),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(317),
    [anon_sym_EQ] = ACTIONS(299),
    [anon_sym_COMMA] = ACTIONS(293),
    [anon_sym_LT] = ACTIONS(299),
    [anon_sym_GT] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(299),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(293),
    [anon_sym_DOT_DOT] = ACTIONS(299),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(299),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [anon_sym_PIPE] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_LT_LT] = ACTIONS(299),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(299),
    [anon_sym_PERCENT] = ACTIONS(299),
    [anon_sym_PLUS_EQ] = ACTIONS(293),
    [anon_sym_DASH_EQ] = ACTIONS(293),
    [anon_sym_STAR_EQ] = ACTIONS(293),
    [anon_sym_SLASH_EQ] = ACTIONS(293),
    [anon_sym_PERCENT_EQ] = ACTIONS(293),
    [anon_sym_AMP_EQ] = ACTIONS(293),
    [anon_sym_PIPE_EQ] = ACTIONS(293),
    [anon_sym_CARET_EQ] = ACTIONS(293),
    [anon_sym_LT_LT_EQ] = ACTIONS(293),
    [anon_sym_GT_GT_EQ] = ACTIONS(293),
    [anon_sym_move] = ACTIONS(87),
    [anon_sym_DOT] = ACTIONS(299),
    [sym_integer_literal] = ACTIONS(319),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(319),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(319),
    [sym_float_literal] = ACTIONS(319),
    [sym_block_comment] = ACTIONS(3),
  },
  [16] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1039),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1039),
    [sym_macro_invocation] = STATE(1039),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1039),
    [sym_unary_expression] = STATE(1039),
    [sym_try_expression] = STATE(1039),
    [sym_reference_expression] = STATE(1039),
    [sym_binary_expression] = STATE(1039),
    [sym_assignment_expression] = STATE(1039),
    [sym_compound_assignment_expr] = STATE(1039),
    [sym_type_cast_expression] = STATE(1039),
    [sym_return_expression] = STATE(1039),
    [sym_call_expression] = STATE(1039),
    [sym_array_expression] = STATE(1039),
    [sym_parenthesized_expression] = STATE(1039),
    [sym_tuple_expression] = STATE(1039),
    [sym_unit_expression] = STATE(1039),
    [sym_struct_expression] = STATE(1039),
    [sym_if_expression] = STATE(1039),
    [sym_if_let_expression] = STATE(1039),
    [sym_match_expression] = STATE(1039),
    [sym_while_expression] = STATE(1039),
    [sym_while_let_expression] = STATE(1039),
    [sym_loop_expression] = STATE(1039),
    [sym_for_expression] = STATE(1039),
    [sym_closure_expression] = STATE(1039),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1039),
    [sym_continue_expression] = STATE(1039),
    [sym_index_expression] = STATE(1039),
    [sym_await_expression] = STATE(1039),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1039),
    [sym_async_block] = STATE(1039),
    [sym_block] = STATE(1039),
    [sym__literal] = STATE(1039),
    [sym_string_literal] = STATE(1039),
    [sym_boolean_literal] = STATE(1039),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_SEMI] = ACTIONS(321),
    [anon_sym_LPAREN] = ACTIONS(321),
    [anon_sym_RPAREN] = ACTIONS(321),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_RBRACE] = ACTIONS(321),
    [anon_sym_EQ_GT] = ACTIONS(321),
    [anon_sym_LBRACK] = ACTIONS(321),
    [anon_sym_RBRACK] = ACTIONS(321),
    [anon_sym_PLUS] = ACTIONS(323),
    [anon_sym_STAR] = ACTIONS(323),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(323),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(317),
    [anon_sym_EQ] = ACTIONS(323),
    [anon_sym_COMMA] = ACTIONS(321),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(323),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_DOT_DOT] = ACTIONS(323),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(321),
    [anon_sym_DASH] = ACTIONS(323),
    [anon_sym_AMP_AMP] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(323),
    [anon_sym_CARET] = ACTIONS(323),
    [anon_sym_EQ_EQ] = ACTIONS(321),
    [anon_sym_BANG_EQ] = ACTIONS(321),
    [anon_sym_LT_EQ] = ACTIONS(321),
    [anon_sym_GT_EQ] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_SLASH] = ACTIONS(323),
    [anon_sym_PERCENT] = ACTIONS(323),
    [anon_sym_PLUS_EQ] = ACTIONS(321),
    [anon_sym_DASH_EQ] = ACTIONS(321),
    [anon_sym_STAR_EQ] = ACTIONS(321),
    [anon_sym_SLASH_EQ] = ACTIONS(321),
    [anon_sym_PERCENT_EQ] = ACTIONS(321),
    [anon_sym_AMP_EQ] = ACTIONS(321),
    [anon_sym_PIPE_EQ] = ACTIONS(321),
    [anon_sym_CARET_EQ] = ACTIONS(321),
    [anon_sym_LT_LT_EQ] = ACTIONS(321),
    [anon_sym_GT_GT_EQ] = ACTIONS(321),
    [anon_sym_move] = ACTIONS(87),
    [anon_sym_DOT] = ACTIONS(323),
    [sym_integer_literal] = ACTIONS(325),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(325),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(325),
    [sym_float_literal] = ACTIONS(325),
    [sym_block_comment] = ACTIONS(3),
  },
  [17] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(956),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(956),
    [sym_macro_invocation] = STATE(956),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(956),
    [sym_unary_expression] = STATE(956),
    [sym_try_expression] = STATE(956),
    [sym_reference_expression] = STATE(956),
    [sym_binary_expression] = STATE(956),
    [sym_assignment_expression] = STATE(956),
    [sym_compound_assignment_expr] = STATE(956),
    [sym_type_cast_expression] = STATE(956),
    [sym_return_expression] = STATE(956),
    [sym_call_expression] = STATE(956),
    [sym_array_expression] = STATE(956),
    [sym_parenthesized_expression] = STATE(956),
    [sym_tuple_expression] = STATE(956),
    [sym_unit_expression] = STATE(956),
    [sym_struct_expression] = STATE(956),
    [sym_if_expression] = STATE(956),
    [sym_if_let_expression] = STATE(956),
    [sym_match_expression] = STATE(956),
    [sym_while_expression] = STATE(956),
    [sym_while_let_expression] = STATE(956),
    [sym_loop_expression] = STATE(956),
    [sym_for_expression] = STATE(956),
    [sym_closure_expression] = STATE(956),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(956),
    [sym_continue_expression] = STATE(956),
    [sym_index_expression] = STATE(956),
    [sym_await_expression] = STATE(956),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(956),
    [sym_async_block] = STATE(956),
    [sym_block] = STATE(956),
    [sym__literal] = STATE(956),
    [sym_string_literal] = STATE(956),
    [sym_boolean_literal] = STATE(956),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_SEMI] = ACTIONS(327),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_RPAREN] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_RBRACE] = ACTIONS(327),
    [anon_sym_EQ_GT] = ACTIONS(327),
    [anon_sym_LBRACK] = ACTIONS(327),
    [anon_sym_RBRACK] = ACTIONS(327),
    [anon_sym_PLUS] = ACTIONS(329),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(327),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(329),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(317),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_COMMA] = ACTIONS(327),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(327),
    [anon_sym_DOT_DOT] = ACTIONS(329),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(327),
    [anon_sym_DASH] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(327),
    [anon_sym_PIPE_PIPE] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_CARET] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(327),
    [anon_sym_BANG_EQ] = ACTIONS(327),
    [anon_sym_LT_EQ] = ACTIONS(327),
    [anon_sym_GT_EQ] = ACTIONS(327),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(329),
    [anon_sym_SLASH] = ACTIONS(329),
    [anon_sym_PERCENT] = ACTIONS(329),
    [anon_sym_PLUS_EQ] = ACTIONS(327),
    [anon_sym_DASH_EQ] = ACTIONS(327),
    [anon_sym_STAR_EQ] = ACTIONS(327),
    [anon_sym_SLASH_EQ] = ACTIONS(327),
    [anon_sym_PERCENT_EQ] = ACTIONS(327),
    [anon_sym_AMP_EQ] = ACTIONS(327),
    [anon_sym_PIPE_EQ] = ACTIONS(327),
    [anon_sym_CARET_EQ] = ACTIONS(327),
    [anon_sym_LT_LT_EQ] = ACTIONS(327),
    [anon_sym_GT_GT_EQ] = ACTIONS(327),
    [anon_sym_move] = ACTIONS(87),
    [anon_sym_DOT] = ACTIONS(329),
    [sym_integer_literal] = ACTIONS(331),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(331),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(331),
    [sym_float_literal] = ACTIONS(331),
    [sym_block_comment] = ACTIONS(3),
  },
  [18] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1015),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1015),
    [sym_macro_invocation] = STATE(1015),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1015),
    [sym_unary_expression] = STATE(1015),
    [sym_try_expression] = STATE(1015),
    [sym_reference_expression] = STATE(1015),
    [sym_binary_expression] = STATE(1015),
    [sym_assignment_expression] = STATE(1015),
    [sym_compound_assignment_expr] = STATE(1015),
    [sym_type_cast_expression] = STATE(1015),
    [sym_return_expression] = STATE(1015),
    [sym_call_expression] = STATE(1015),
    [sym_array_expression] = STATE(1015),
    [sym_parenthesized_expression] = STATE(1015),
    [sym_tuple_expression] = STATE(1015),
    [sym_unit_expression] = STATE(1015),
    [sym_struct_expression] = STATE(1015),
    [sym_if_expression] = STATE(1015),
    [sym_if_let_expression] = STATE(1015),
    [sym_match_expression] = STATE(1015),
    [sym_while_expression] = STATE(1015),
    [sym_while_let_expression] = STATE(1015),
    [sym_loop_expression] = STATE(1015),
    [sym_for_expression] = STATE(1015),
    [sym_closure_expression] = STATE(1015),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(15),
    [sym_break_expression] = STATE(1015),
    [sym_continue_expression] = STATE(1015),
    [sym_index_expression] = STATE(1015),
    [sym_await_expression] = STATE(1015),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1015),
    [sym_async_block] = STATE(1015),
    [sym_block] = STATE(1015),
    [sym__literal] = STATE(1015),
    [sym_string_literal] = STATE(1015),
    [sym_boolean_literal] = STATE(1015),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_SEMI] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(333),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_RBRACE] = ACTIONS(333),
    [anon_sym_EQ_GT] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_RBRACK] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(337),
    [anon_sym_as] = ACTIONS(335),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(317),
    [anon_sym_EQ] = ACTIONS(335),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(335),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(335),
    [anon_sym_CARET] = ACTIONS(335),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(335),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_move] = ACTIONS(87),
    [anon_sym_DOT] = ACTIONS(335),
    [sym_integer_literal] = ACTIONS(339),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(339),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(339),
    [sym_float_literal] = ACTIONS(339),
    [sym_block_comment] = ACTIONS(3),
  },
  [19] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(962),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(962),
    [sym_macro_invocation] = STATE(962),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(962),
    [sym_unary_expression] = STATE(962),
    [sym_try_expression] = STATE(962),
    [sym_reference_expression] = STATE(962),
    [sym_binary_expression] = STATE(962),
    [sym_assignment_expression] = STATE(962),
    [sym_compound_assignment_expr] = STATE(962),
    [sym_type_cast_expression] = STATE(962),
    [sym_return_expression] = STATE(962),
    [sym_call_expression] = STATE(962),
    [sym_array_expression] = STATE(962),
    [sym_parenthesized_expression] = STATE(962),
    [sym_tuple_expression] = STATE(962),
    [sym_unit_expression] = STATE(962),
    [sym_struct_expression] = STATE(962),
    [sym_if_expression] = STATE(962),
    [sym_if_let_expression] = STATE(962),
    [sym_match_expression] = STATE(962),
    [sym_while_expression] = STATE(962),
    [sym_while_let_expression] = STATE(962),
    [sym_loop_expression] = STATE(962),
    [sym_for_expression] = STATE(962),
    [sym_closure_expression] = STATE(962),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(962),
    [sym_continue_expression] = STATE(962),
    [sym_index_expression] = STATE(962),
    [sym_await_expression] = STATE(962),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(962),
    [sym_async_block] = STATE(962),
    [sym_block] = STATE(962),
    [sym__literal] = STATE(962),
    [sym_string_literal] = STATE(962),
    [sym_boolean_literal] = STATE(962),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_SEMI] = ACTIONS(341),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(341),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_RBRACE] = ACTIONS(341),
    [anon_sym_EQ_GT] = ACTIONS(341),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(341),
    [anon_sym_PLUS] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(317),
    [anon_sym_QMARK] = ACTIONS(341),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(343),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(317),
    [anon_sym_EQ] = ACTIONS(343),
    [anon_sym_COMMA] = ACTIONS(341),
    [anon_sym_LT] = ACTIONS(345),
    [anon_sym_GT] = ACTIONS(343),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(347),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(341),
    [anon_sym_DOT_DOT] = ACTIONS(349),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_AMP_AMP] = ACTIONS(341),
    [anon_sym_PIPE_PIPE] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(351),
    [anon_sym_CARET] = ACTIONS(343),
    [anon_sym_EQ_EQ] = ACTIONS(341),
    [anon_sym_BANG_EQ] = ACTIONS(341),
    [anon_sym_LT_EQ] = ACTIONS(341),
    [anon_sym_GT_EQ] = ACTIONS(341),
    [anon_sym_LT_LT] = ACTIONS(343),
    [anon_sym_GT_GT] = ACTIONS(343),
    [anon_sym_SLASH] = ACTIONS(343),
    [anon_sym_PERCENT] = ACTIONS(343),
    [anon_sym_PLUS_EQ] = ACTIONS(341),
    [anon_sym_DASH_EQ] = ACTIONS(341),
    [anon_sym_STAR_EQ] = ACTIONS(341),
    [anon_sym_SLASH_EQ] = ACTIONS(341),
    [anon_sym_PERCENT_EQ] = ACTIONS(341),
    [anon_sym_AMP_EQ] = ACTIONS(341),
    [anon_sym_PIPE_EQ] = ACTIONS(341),
    [anon_sym_CARET_EQ] = ACTIONS(341),
    [anon_sym_LT_LT_EQ] = ACTIONS(341),
    [anon_sym_GT_GT_EQ] = ACTIONS(341),
    [anon_sym_move] = ACTIONS(87),
    [anon_sym_DOT] = ACTIONS(343),
    [sym_integer_literal] = ACTIONS(353),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(353),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(353),
    [sym_float_literal] = ACTIONS(353),
    [sym_block_comment] = ACTIONS(3),
  },
  [20] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1175),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1175),
    [sym_macro_invocation] = STATE(1175),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1175),
    [sym_unary_expression] = STATE(1175),
    [sym_try_expression] = STATE(1175),
    [sym_reference_expression] = STATE(1175),
    [sym_binary_expression] = STATE(1175),
    [sym_assignment_expression] = STATE(1175),
    [sym_compound_assignment_expr] = STATE(1175),
    [sym_type_cast_expression] = STATE(1175),
    [sym_return_expression] = STATE(1175),
    [sym_call_expression] = STATE(1175),
    [sym_array_expression] = STATE(1175),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_tuple_expression] = STATE(1175),
    [sym_unit_expression] = STATE(1175),
    [sym_struct_expression] = STATE(1175),
    [sym_if_expression] = STATE(1175),
    [sym_if_let_expression] = STATE(1175),
    [sym_match_expression] = STATE(1175),
    [sym_while_expression] = STATE(1175),
    [sym_while_let_expression] = STATE(1175),
    [sym_loop_expression] = STATE(1175),
    [sym_for_expression] = STATE(1175),
    [sym_closure_expression] = STATE(1175),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1175),
    [sym_continue_expression] = STATE(1175),
    [sym_index_expression] = STATE(1175),
    [sym_await_expression] = STATE(1175),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1175),
    [sym_async_block] = STATE(1175),
    [sym_block] = STATE(1175),
    [sym__literal] = STATE(1175),
    [sym_string_literal] = STATE(1175),
    [sym_boolean_literal] = STATE(1175),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(293),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_LBRACK] = ACTIONS(293),
    [anon_sym_COLON] = ACTIONS(297),
    [anon_sym_PLUS] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(299),
    [anon_sym_QMARK] = ACTIONS(293),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(299),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(363),
    [anon_sym_EQ] = ACTIONS(299),
    [anon_sym_LT] = ACTIONS(299),
    [anon_sym_GT] = ACTIONS(299),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(299),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(293),
    [anon_sym_DOT_DOT] = ACTIONS(299),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(293),
    [anon_sym_DASH] = ACTIONS(299),
    [anon_sym_AMP_AMP] = ACTIONS(293),
    [anon_sym_PIPE_PIPE] = ACTIONS(293),
    [anon_sym_PIPE] = ACTIONS(299),
    [anon_sym_CARET] = ACTIONS(299),
    [anon_sym_EQ_EQ] = ACTIONS(293),
    [anon_sym_BANG_EQ] = ACTIONS(293),
    [anon_sym_LT_EQ] = ACTIONS(293),
    [anon_sym_GT_EQ] = ACTIONS(293),
    [anon_sym_LT_LT] = ACTIONS(299),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_SLASH] = ACTIONS(299),
    [anon_sym_PERCENT] = ACTIONS(299),
    [anon_sym_PLUS_EQ] = ACTIONS(293),
    [anon_sym_DASH_EQ] = ACTIONS(293),
    [anon_sym_STAR_EQ] = ACTIONS(293),
    [anon_sym_SLASH_EQ] = ACTIONS(293),
    [anon_sym_PERCENT_EQ] = ACTIONS(293),
    [anon_sym_AMP_EQ] = ACTIONS(293),
    [anon_sym_PIPE_EQ] = ACTIONS(293),
    [anon_sym_CARET_EQ] = ACTIONS(293),
    [anon_sym_LT_LT_EQ] = ACTIONS(293),
    [anon_sym_GT_GT_EQ] = ACTIONS(293),
    [anon_sym_move] = ACTIONS(367),
    [anon_sym_DOT] = ACTIONS(299),
    [sym_integer_literal] = ACTIONS(369),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(369),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(369),
    [sym_float_literal] = ACTIONS(369),
    [sym_block_comment] = ACTIONS(3),
  },
  [21] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1156),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1156),
    [sym_macro_invocation] = STATE(1156),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1156),
    [sym_unary_expression] = STATE(1156),
    [sym_try_expression] = STATE(1156),
    [sym_reference_expression] = STATE(1156),
    [sym_binary_expression] = STATE(1156),
    [sym_assignment_expression] = STATE(1156),
    [sym_compound_assignment_expr] = STATE(1156),
    [sym_type_cast_expression] = STATE(1156),
    [sym_return_expression] = STATE(1156),
    [sym_call_expression] = STATE(1156),
    [sym_array_expression] = STATE(1156),
    [sym_parenthesized_expression] = STATE(1156),
    [sym_tuple_expression] = STATE(1156),
    [sym_unit_expression] = STATE(1156),
    [sym_struct_expression] = STATE(1156),
    [sym_if_expression] = STATE(1156),
    [sym_if_let_expression] = STATE(1156),
    [sym_match_expression] = STATE(1156),
    [sym_while_expression] = STATE(1156),
    [sym_while_let_expression] = STATE(1156),
    [sym_loop_expression] = STATE(1156),
    [sym_for_expression] = STATE(1156),
    [sym_closure_expression] = STATE(1156),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(20),
    [sym_break_expression] = STATE(1156),
    [sym_continue_expression] = STATE(1156),
    [sym_index_expression] = STATE(1156),
    [sym_await_expression] = STATE(1156),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1156),
    [sym_async_block] = STATE(1156),
    [sym_block] = STATE(1156),
    [sym__literal] = STATE(1156),
    [sym_string_literal] = STATE(1156),
    [sym_boolean_literal] = STATE(1156),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_LBRACE] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_QMARK] = ACTIONS(333),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(337),
    [anon_sym_as] = ACTIONS(335),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(363),
    [anon_sym_EQ] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(333),
    [anon_sym_DOT_DOT] = ACTIONS(335),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(335),
    [anon_sym_CARET] = ACTIONS(335),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(335),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_move] = ACTIONS(367),
    [anon_sym_DOT] = ACTIONS(335),
    [sym_integer_literal] = ACTIONS(377),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(377),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(377),
    [sym_float_literal] = ACTIONS(377),
    [sym_block_comment] = ACTIONS(3),
  },
  [22] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1178),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1178),
    [sym_macro_invocation] = STATE(1178),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1178),
    [sym_unary_expression] = STATE(1178),
    [sym_try_expression] = STATE(1178),
    [sym_reference_expression] = STATE(1178),
    [sym_binary_expression] = STATE(1178),
    [sym_assignment_expression] = STATE(1178),
    [sym_compound_assignment_expr] = STATE(1178),
    [sym_type_cast_expression] = STATE(1178),
    [sym_return_expression] = STATE(1178),
    [sym_call_expression] = STATE(1178),
    [sym_array_expression] = STATE(1178),
    [sym_parenthesized_expression] = STATE(1178),
    [sym_tuple_expression] = STATE(1178),
    [sym_unit_expression] = STATE(1178),
    [sym_struct_expression] = STATE(1178),
    [sym_if_expression] = STATE(1178),
    [sym_if_let_expression] = STATE(1178),
    [sym_match_expression] = STATE(1178),
    [sym_while_expression] = STATE(1178),
    [sym_while_let_expression] = STATE(1178),
    [sym_loop_expression] = STATE(1178),
    [sym_for_expression] = STATE(1178),
    [sym_closure_expression] = STATE(1178),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1178),
    [sym_continue_expression] = STATE(1178),
    [sym_index_expression] = STATE(1178),
    [sym_await_expression] = STATE(1178),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1178),
    [sym_async_block] = STATE(1178),
    [sym_block] = STATE(1178),
    [sym__literal] = STATE(1178),
    [sym_string_literal] = STATE(1178),
    [sym_boolean_literal] = STATE(1178),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_PLUS] = ACTIONS(343),
    [anon_sym_STAR] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(341),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(343),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(363),
    [anon_sym_EQ] = ACTIONS(343),
    [anon_sym_LT] = ACTIONS(345),
    [anon_sym_GT] = ACTIONS(343),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(379),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(341),
    [anon_sym_DOT_DOT] = ACTIONS(381),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(341),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(341),
    [anon_sym_PIPE_PIPE] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(351),
    [anon_sym_CARET] = ACTIONS(343),
    [anon_sym_EQ_EQ] = ACTIONS(341),
    [anon_sym_BANG_EQ] = ACTIONS(341),
    [anon_sym_LT_EQ] = ACTIONS(341),
    [anon_sym_GT_EQ] = ACTIONS(341),
    [anon_sym_LT_LT] = ACTIONS(343),
    [anon_sym_GT_GT] = ACTIONS(343),
    [anon_sym_SLASH] = ACTIONS(343),
    [anon_sym_PERCENT] = ACTIONS(343),
    [anon_sym_PLUS_EQ] = ACTIONS(341),
    [anon_sym_DASH_EQ] = ACTIONS(341),
    [anon_sym_STAR_EQ] = ACTIONS(341),
    [anon_sym_SLASH_EQ] = ACTIONS(341),
    [anon_sym_PERCENT_EQ] = ACTIONS(341),
    [anon_sym_AMP_EQ] = ACTIONS(341),
    [anon_sym_PIPE_EQ] = ACTIONS(341),
    [anon_sym_CARET_EQ] = ACTIONS(341),
    [anon_sym_LT_LT_EQ] = ACTIONS(341),
    [anon_sym_GT_GT_EQ] = ACTIONS(341),
    [anon_sym_move] = ACTIONS(367),
    [anon_sym_DOT] = ACTIONS(343),
    [sym_integer_literal] = ACTIONS(383),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(383),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(383),
    [sym_float_literal] = ACTIONS(383),
    [sym_block_comment] = ACTIONS(3),
  },
  [23] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1196),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1196),
    [sym_macro_invocation] = STATE(1196),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1196),
    [sym_unary_expression] = STATE(1196),
    [sym_try_expression] = STATE(1196),
    [sym_reference_expression] = STATE(1196),
    [sym_binary_expression] = STATE(1196),
    [sym_assignment_expression] = STATE(1196),
    [sym_compound_assignment_expr] = STATE(1196),
    [sym_type_cast_expression] = STATE(1196),
    [sym_return_expression] = STATE(1196),
    [sym_call_expression] = STATE(1196),
    [sym_array_expression] = STATE(1196),
    [sym_parenthesized_expression] = STATE(1196),
    [sym_tuple_expression] = STATE(1196),
    [sym_unit_expression] = STATE(1196),
    [sym_struct_expression] = STATE(1196),
    [sym_if_expression] = STATE(1196),
    [sym_if_let_expression] = STATE(1196),
    [sym_match_expression] = STATE(1196),
    [sym_while_expression] = STATE(1196),
    [sym_while_let_expression] = STATE(1196),
    [sym_loop_expression] = STATE(1196),
    [sym_for_expression] = STATE(1196),
    [sym_closure_expression] = STATE(1196),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1196),
    [sym_continue_expression] = STATE(1196),
    [sym_index_expression] = STATE(1196),
    [sym_await_expression] = STATE(1196),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1196),
    [sym_async_block] = STATE(1196),
    [sym_block] = STATE(1196),
    [sym__literal] = STATE(1196),
    [sym_string_literal] = STATE(1196),
    [sym_boolean_literal] = STATE(1196),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(321),
    [anon_sym_LBRACE] = ACTIONS(321),
    [anon_sym_LBRACK] = ACTIONS(321),
    [anon_sym_PLUS] = ACTIONS(323),
    [anon_sym_STAR] = ACTIONS(323),
    [anon_sym_QMARK] = ACTIONS(321),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(323),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(363),
    [anon_sym_EQ] = ACTIONS(323),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(323),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(321),
    [anon_sym_DOT_DOT] = ACTIONS(323),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(321),
    [anon_sym_DASH] = ACTIONS(323),
    [anon_sym_AMP_AMP] = ACTIONS(321),
    [anon_sym_PIPE_PIPE] = ACTIONS(321),
    [anon_sym_PIPE] = ACTIONS(323),
    [anon_sym_CARET] = ACTIONS(323),
    [anon_sym_EQ_EQ] = ACTIONS(321),
    [anon_sym_BANG_EQ] = ACTIONS(321),
    [anon_sym_LT_EQ] = ACTIONS(321),
    [anon_sym_GT_EQ] = ACTIONS(321),
    [anon_sym_LT_LT] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [anon_sym_SLASH] = ACTIONS(323),
    [anon_sym_PERCENT] = ACTIONS(323),
    [anon_sym_PLUS_EQ] = ACTIONS(321),
    [anon_sym_DASH_EQ] = ACTIONS(321),
    [anon_sym_STAR_EQ] = ACTIONS(321),
    [anon_sym_SLASH_EQ] = ACTIONS(321),
    [anon_sym_PERCENT_EQ] = ACTIONS(321),
    [anon_sym_AMP_EQ] = ACTIONS(321),
    [anon_sym_PIPE_EQ] = ACTIONS(321),
    [anon_sym_CARET_EQ] = ACTIONS(321),
    [anon_sym_LT_LT_EQ] = ACTIONS(321),
    [anon_sym_GT_GT_EQ] = ACTIONS(321),
    [anon_sym_move] = ACTIONS(367),
    [anon_sym_DOT] = ACTIONS(323),
    [sym_integer_literal] = ACTIONS(385),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(385),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(385),
    [sym_float_literal] = ACTIONS(385),
    [sym_block_comment] = ACTIONS(3),
  },
  [24] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1184),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1184),
    [sym_macro_invocation] = STATE(1184),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1184),
    [sym_unary_expression] = STATE(1184),
    [sym_try_expression] = STATE(1184),
    [sym_reference_expression] = STATE(1184),
    [sym_binary_expression] = STATE(1184),
    [sym_assignment_expression] = STATE(1184),
    [sym_compound_assignment_expr] = STATE(1184),
    [sym_type_cast_expression] = STATE(1184),
    [sym_return_expression] = STATE(1184),
    [sym_call_expression] = STATE(1184),
    [sym_array_expression] = STATE(1184),
    [sym_parenthesized_expression] = STATE(1184),
    [sym_tuple_expression] = STATE(1184),
    [sym_unit_expression] = STATE(1184),
    [sym_struct_expression] = STATE(1184),
    [sym_if_expression] = STATE(1184),
    [sym_if_let_expression] = STATE(1184),
    [sym_match_expression] = STATE(1184),
    [sym_while_expression] = STATE(1184),
    [sym_while_let_expression] = STATE(1184),
    [sym_loop_expression] = STATE(1184),
    [sym_for_expression] = STATE(1184),
    [sym_closure_expression] = STATE(1184),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1184),
    [sym_continue_expression] = STATE(1184),
    [sym_index_expression] = STATE(1184),
    [sym_await_expression] = STATE(1184),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1184),
    [sym_async_block] = STATE(1184),
    [sym_block] = STATE(1184),
    [sym__literal] = STATE(1184),
    [sym_string_literal] = STATE(1184),
    [sym_boolean_literal] = STATE(1184),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(327),
    [anon_sym_LBRACE] = ACTIONS(327),
    [anon_sym_LBRACK] = ACTIONS(327),
    [anon_sym_PLUS] = ACTIONS(329),
    [anon_sym_STAR] = ACTIONS(329),
    [anon_sym_QMARK] = ACTIONS(327),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_as] = ACTIONS(329),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(363),
    [anon_sym_EQ] = ACTIONS(329),
    [anon_sym_LT] = ACTIONS(329),
    [anon_sym_GT] = ACTIONS(329),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(329),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(327),
    [anon_sym_DOT_DOT] = ACTIONS(329),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(327),
    [anon_sym_DASH] = ACTIONS(329),
    [anon_sym_AMP_AMP] = ACTIONS(327),
    [anon_sym_PIPE_PIPE] = ACTIONS(327),
    [anon_sym_PIPE] = ACTIONS(329),
    [anon_sym_CARET] = ACTIONS(329),
    [anon_sym_EQ_EQ] = ACTIONS(327),
    [anon_sym_BANG_EQ] = ACTIONS(327),
    [anon_sym_LT_EQ] = ACTIONS(327),
    [anon_sym_GT_EQ] = ACTIONS(327),
    [anon_sym_LT_LT] = ACTIONS(329),
    [anon_sym_GT_GT] = ACTIONS(329),
    [anon_sym_SLASH] = ACTIONS(329),
    [anon_sym_PERCENT] = ACTIONS(329),
    [anon_sym_PLUS_EQ] = ACTIONS(327),
    [anon_sym_DASH_EQ] = ACTIONS(327),
    [anon_sym_STAR_EQ] = ACTIONS(327),
    [anon_sym_SLASH_EQ] = ACTIONS(327),
    [anon_sym_PERCENT_EQ] = ACTIONS(327),
    [anon_sym_AMP_EQ] = ACTIONS(327),
    [anon_sym_PIPE_EQ] = ACTIONS(327),
    [anon_sym_CARET_EQ] = ACTIONS(327),
    [anon_sym_LT_LT_EQ] = ACTIONS(327),
    [anon_sym_GT_GT_EQ] = ACTIONS(327),
    [anon_sym_move] = ACTIONS(367),
    [anon_sym_DOT] = ACTIONS(329),
    [sym_integer_literal] = ACTIONS(387),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(387),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(387),
    [sym_float_literal] = ACTIONS(387),
    [sym_block_comment] = ACTIONS(3),
  },
  [25] = {
    [sym__else_tail] = STATE(50),
    [ts_builtin_sym_end] = ACTIONS(389),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_SEMI] = ACTIONS(389),
    [anon_sym_macro_rules_BANG] = ACTIONS(389),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_LBRACE] = ACTIONS(389),
    [anon_sym_RBRACE] = ACTIONS(389),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_PLUS] = ACTIONS(391),
    [anon_sym_STAR] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(389),
    [anon_sym_u8] = ACTIONS(391),
    [anon_sym_i8] = ACTIONS(391),
    [anon_sym_u16] = ACTIONS(391),
    [anon_sym_i16] = ACTIONS(391),
    [anon_sym_u32] = ACTIONS(391),
    [anon_sym_i32] = ACTIONS(391),
    [anon_sym_u64] = ACTIONS(391),
    [anon_sym_i64] = ACTIONS(391),
    [anon_sym_u128] = ACTIONS(391),
    [anon_sym_i128] = ACTIONS(391),
    [anon_sym_isize] = ACTIONS(391),
    [anon_sym_usize] = ACTIONS(391),
    [anon_sym_f32] = ACTIONS(391),
    [anon_sym_f64] = ACTIONS(391),
    [anon_sym_bool] = ACTIONS(391),
    [anon_sym_str] = ACTIONS(391),
    [anon_sym_char] = ACTIONS(391),
    [anon_sym_SQUOTE] = ACTIONS(391),
    [anon_sym_as] = ACTIONS(391),
    [anon_sym_async] = ACTIONS(391),
    [anon_sym_break] = ACTIONS(391),
    [anon_sym_const] = ACTIONS(391),
    [anon_sym_continue] = ACTIONS(391),
    [anon_sym_default] = ACTIONS(391),
    [anon_sym_enum] = ACTIONS(391),
    [anon_sym_fn] = ACTIONS(391),
    [anon_sym_for] = ACTIONS(391),
    [anon_sym_if] = ACTIONS(391),
    [anon_sym_impl] = ACTIONS(391),
    [anon_sym_let] = ACTIONS(391),
    [anon_sym_loop] = ACTIONS(391),
    [anon_sym_match] = ACTIONS(391),
    [anon_sym_mod] = ACTIONS(391),
    [anon_sym_pub] = ACTIONS(391),
    [anon_sym_return] = ACTIONS(391),
    [anon_sym_static] = ACTIONS(391),
    [anon_sym_struct] = ACTIONS(391),
    [anon_sym_trait] = ACTIONS(391),
    [anon_sym_type] = ACTIONS(391),
    [anon_sym_union] = ACTIONS(391),
    [anon_sym_unsafe] = ACTIONS(391),
    [anon_sym_use] = ACTIONS(391),
    [anon_sym_while] = ACTIONS(391),
    [anon_sym_POUND] = ACTIONS(389),
    [anon_sym_BANG] = ACTIONS(391),
    [anon_sym_EQ] = ACTIONS(391),
    [anon_sym_extern] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(391),
    [anon_sym_GT] = ACTIONS(391),
    [anon_sym_COLON_COLON] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(391),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(389),
    [anon_sym_DOT_DOT] = ACTIONS(391),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(391),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(391),
    [anon_sym_CARET] = ACTIONS(391),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_BANG_EQ] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(389),
    [anon_sym_LT_LT] = ACTIONS(391),
    [anon_sym_GT_GT] = ACTIONS(391),
    [anon_sym_SLASH] = ACTIONS(391),
    [anon_sym_PERCENT] = ACTIONS(391),
    [anon_sym_PLUS_EQ] = ACTIONS(389),
    [anon_sym_DASH_EQ] = ACTIONS(389),
    [anon_sym_STAR_EQ] = ACTIONS(389),
    [anon_sym_SLASH_EQ] = ACTIONS(389),
    [anon_sym_PERCENT_EQ] = ACTIONS(389),
    [anon_sym_AMP_EQ] = ACTIONS(389),
    [anon_sym_PIPE_EQ] = ACTIONS(389),
    [anon_sym_CARET_EQ] = ACTIONS(389),
    [anon_sym_LT_LT_EQ] = ACTIONS(389),
    [anon_sym_GT_GT_EQ] = ACTIONS(389),
    [anon_sym_else] = ACTIONS(393),
    [anon_sym_move] = ACTIONS(391),
    [anon_sym_DOT] = ACTIONS(391),
    [sym_integer_literal] = ACTIONS(389),
    [aux_sym_string_literal_token1] = ACTIONS(389),
    [sym_char_literal] = ACTIONS(389),
    [anon_sym_true] = ACTIONS(391),
    [anon_sym_false] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(391),
    [sym_super] = ACTIONS(391),
    [sym_crate] = ACTIONS(391),
    [sym_metavariable] = ACTIONS(389),
    [sym_raw_string_literal] = ACTIONS(389),
    [sym_float_literal] = ACTIONS(389),
    [sym_block_comment] = ACTIONS(3),
  },
  [26] = {
    [sym__else_tail] = STATE(34),
    [ts_builtin_sym_end] = ACTIONS(395),
    [sym_identifier] = ACTIONS(397),
    [anon_sym_SEMI] = ACTIONS(395),
    [anon_sym_macro_rules_BANG] = ACTIONS(395),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACE] = ACTIONS(395),
    [anon_sym_RBRACE] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(395),
    [anon_sym_PLUS] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_QMARK] = ACTIONS(395),
    [anon_sym_u8] = ACTIONS(397),
    [anon_sym_i8] = ACTIONS(397),
    [anon_sym_u16] = ACTIONS(397),
    [anon_sym_i16] = ACTIONS(397),
    [anon_sym_u32] = ACTIONS(397),
    [anon_sym_i32] = ACTIONS(397),
    [anon_sym_u64] = ACTIONS(397),
    [anon_sym_i64] = ACTIONS(397),
    [anon_sym_u128] = ACTIONS(397),
    [anon_sym_i128] = ACTIONS(397),
    [anon_sym_isize] = ACTIONS(397),
    [anon_sym_usize] = ACTIONS(397),
    [anon_sym_f32] = ACTIONS(397),
    [anon_sym_f64] = ACTIONS(397),
    [anon_sym_bool] = ACTIONS(397),
    [anon_sym_str] = ACTIONS(397),
    [anon_sym_char] = ACTIONS(397),
    [anon_sym_SQUOTE] = ACTIONS(397),
    [anon_sym_as] = ACTIONS(397),
    [anon_sym_async] = ACTIONS(397),
    [anon_sym_break] = ACTIONS(397),
    [anon_sym_const] = ACTIONS(397),
    [anon_sym_continue] = ACTIONS(397),
    [anon_sym_default] = ACTIONS(397),
    [anon_sym_enum] = ACTIONS(397),
    [anon_sym_fn] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(397),
    [anon_sym_impl] = ACTIONS(397),
    [anon_sym_let] = ACTIONS(397),
    [anon_sym_loop] = ACTIONS(397),
    [anon_sym_match] = ACTIONS(397),
    [anon_sym_mod] = ACTIONS(397),
    [anon_sym_pub] = ACTIONS(397),
    [anon_sym_return] = ACTIONS(397),
    [anon_sym_static] = ACTIONS(397),
    [anon_sym_struct] = ACTIONS(397),
    [anon_sym_trait] = ACTIONS(397),
    [anon_sym_type] = ACTIONS(397),
    [anon_sym_union] = ACTIONS(397),
    [anon_sym_unsafe] = ACTIONS(397),
    [anon_sym_use] = ACTIONS(397),
    [anon_sym_while] = ACTIONS(397),
    [anon_sym_POUND] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_EQ] = ACTIONS(397),
    [anon_sym_extern] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(397),
    [anon_sym_COLON_COLON] = ACTIONS(395),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(395),
    [anon_sym_DOT_DOT] = ACTIONS(397),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(395),
    [anon_sym_DASH] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(395),
    [anon_sym_PIPE_PIPE] = ACTIONS(395),
    [anon_sym_PIPE] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(395),
    [anon_sym_BANG_EQ] = ACTIONS(395),
    [anon_sym_LT_EQ] = ACTIONS(395),
    [anon_sym_GT_EQ] = ACTIONS(395),
    [anon_sym_LT_LT] = ACTIONS(397),
    [anon_sym_GT_GT] = ACTIONS(397),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_PERCENT] = ACTIONS(397),
    [anon_sym_PLUS_EQ] = ACTIONS(395),
    [anon_sym_DASH_EQ] = ACTIONS(395),
    [anon_sym_STAR_EQ] = ACTIONS(395),
    [anon_sym_SLASH_EQ] = ACTIONS(395),
    [anon_sym_PERCENT_EQ] = ACTIONS(395),
    [anon_sym_AMP_EQ] = ACTIONS(395),
    [anon_sym_PIPE_EQ] = ACTIONS(395),
    [anon_sym_CARET_EQ] = ACTIONS(395),
    [anon_sym_LT_LT_EQ] = ACTIONS(395),
    [anon_sym_GT_GT_EQ] = ACTIONS(395),
    [anon_sym_else] = ACTIONS(393),
    [anon_sym_move] = ACTIONS(397),
    [anon_sym_DOT] = ACTIONS(397),
    [sym_integer_literal] = ACTIONS(395),
    [aux_sym_string_literal_token1] = ACTIONS(395),
    [sym_char_literal] = ACTIONS(395),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_false] = ACTIONS(397),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(397),
    [sym_super] = ACTIONS(397),
    [sym_crate] = ACTIONS(397),
    [sym_metavariable] = ACTIONS(395),
    [sym_raw_string_literal] = ACTIONS(395),
    [sym_float_literal] = ACTIONS(395),
    [sym_block_comment] = ACTIONS(3),
  },
  [27] = {
    [ts_builtin_sym_end] = ACTIONS(399),
    [sym_identifier] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(399),
    [anon_sym_macro_rules_BANG] = ACTIONS(399),
    [anon_sym_LPAREN] = ACTIONS(399),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_LBRACK] = ACTIONS(399),
    [anon_sym_PLUS] = ACTIONS(401),
    [anon_sym_STAR] = ACTIONS(401),
    [anon_sym_QMARK] = ACTIONS(399),
    [anon_sym_u8] = ACTIONS(401),
    [anon_sym_i8] = ACTIONS(401),
    [anon_sym_u16] = ACTIONS(401),
    [anon_sym_i16] = ACTIONS(401),
    [anon_sym_u32] = ACTIONS(401),
    [anon_sym_i32] = ACTIONS(401),
    [anon_sym_u64] = ACTIONS(401),
    [anon_sym_i64] = ACTIONS(401),
    [anon_sym_u128] = ACTIONS(401),
    [anon_sym_i128] = ACTIONS(401),
    [anon_sym_isize] = ACTIONS(401),
    [anon_sym_usize] = ACTIONS(401),
    [anon_sym_f32] = ACTIONS(401),
    [anon_sym_f64] = ACTIONS(401),
    [anon_sym_bool] = ACTIONS(401),
    [anon_sym_str] = ACTIONS(401),
    [anon_sym_char] = ACTIONS(401),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [anon_sym_as] = ACTIONS(401),
    [anon_sym_async] = ACTIONS(401),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_const] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(401),
    [anon_sym_default] = ACTIONS(401),
    [anon_sym_enum] = ACTIONS(401),
    [anon_sym_fn] = ACTIONS(401),
    [anon_sym_for] = ACTIONS(401),
    [anon_sym_if] = ACTIONS(401),
    [anon_sym_impl] = ACTIONS(401),
    [anon_sym_let] = ACTIONS(401),
    [anon_sym_loop] = ACTIONS(401),
    [anon_sym_match] = ACTIONS(401),
    [anon_sym_mod] = ACTIONS(401),
    [anon_sym_pub] = ACTIONS(401),
    [anon_sym_return] = ACTIONS(401),
    [anon_sym_static] = ACTIONS(401),
    [anon_sym_struct] = ACTIONS(401),
    [anon_sym_trait] = ACTIONS(401),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_union] = ACTIONS(401),
    [anon_sym_unsafe] = ACTIONS(401),
    [anon_sym_use] = ACTIONS(401),
    [anon_sym_while] = ACTIONS(401),
    [anon_sym_POUND] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_EQ] = ACTIONS(401),
    [anon_sym_extern] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(401),
    [anon_sym_GT] = ACTIONS(401),
    [anon_sym_COLON_COLON] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(401),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(399),
    [anon_sym_DOT_DOT] = ACTIONS(401),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(401),
    [anon_sym_AMP_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(399),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_CARET] = ACTIONS(401),
    [anon_sym_EQ_EQ] = ACTIONS(399),
    [anon_sym_BANG_EQ] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(399),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_GT_GT] = ACTIONS(401),
    [anon_sym_SLASH] = ACTIONS(401),
    [anon_sym_PERCENT] = ACTIONS(401),
    [anon_sym_PLUS_EQ] = ACTIONS(399),
    [anon_sym_DASH_EQ] = ACTIONS(399),
    [anon_sym_STAR_EQ] = ACTIONS(399),
    [anon_sym_SLASH_EQ] = ACTIONS(399),
    [anon_sym_PERCENT_EQ] = ACTIONS(399),
    [anon_sym_AMP_EQ] = ACTIONS(399),
    [anon_sym_PIPE_EQ] = ACTIONS(399),
    [anon_sym_CARET_EQ] = ACTIONS(399),
    [anon_sym_LT_LT_EQ] = ACTIONS(399),
    [anon_sym_GT_GT_EQ] = ACTIONS(399),
    [anon_sym_else] = ACTIONS(401),
    [anon_sym_move] = ACTIONS(401),
    [anon_sym_DOT] = ACTIONS(401),
    [sym_integer_literal] = ACTIONS(399),
    [aux_sym_string_literal_token1] = ACTIONS(399),
    [sym_char_literal] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(401),
    [sym_super] = ACTIONS(401),
    [sym_crate] = ACTIONS(401),
    [sym_metavariable] = ACTIONS(399),
    [sym_raw_string_literal] = ACTIONS(399),
    [sym_float_literal] = ACTIONS(399),
    [sym_block_comment] = ACTIONS(3),
  },
  [28] = {
    [sym_attribute_item] = STATE(29),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1064),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1064),
    [sym_macro_invocation] = STATE(1064),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1064),
    [sym_unary_expression] = STATE(1064),
    [sym_try_expression] = STATE(1064),
    [sym_reference_expression] = STATE(1064),
    [sym_binary_expression] = STATE(1064),
    [sym_assignment_expression] = STATE(1064),
    [sym_compound_assignment_expr] = STATE(1064),
    [sym_type_cast_expression] = STATE(1064),
    [sym_return_expression] = STATE(1064),
    [sym_call_expression] = STATE(1064),
    [sym_array_expression] = STATE(1064),
    [sym_parenthesized_expression] = STATE(1064),
    [sym_tuple_expression] = STATE(1064),
    [sym_unit_expression] = STATE(1064),
    [sym_struct_expression] = STATE(1064),
    [sym_if_expression] = STATE(1064),
    [sym_if_let_expression] = STATE(1064),
    [sym_match_expression] = STATE(1064),
    [sym_while_expression] = STATE(1064),
    [sym_while_let_expression] = STATE(1064),
    [sym_loop_expression] = STATE(1064),
    [sym_for_expression] = STATE(1064),
    [sym_closure_expression] = STATE(1064),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1064),
    [sym_continue_expression] = STATE(1064),
    [sym_index_expression] = STATE(1064),
    [sym_await_expression] = STATE(1064),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1064),
    [sym_async_block] = STATE(1064),
    [sym_block] = STATE(1064),
    [sym__literal] = STATE(1064),
    [sym_string_literal] = STATE(1064),
    [sym_boolean_literal] = STATE(1064),
    [aux_sym_enum_variant_list_repeat1] = STATE(29),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(403),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_POUND] = ACTIONS(405),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_COMMA] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(409),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(409),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(409),
    [sym_float_literal] = ACTIONS(409),
    [sym_block_comment] = ACTIONS(3),
  },
  [29] = {
    [sym_attribute_item] = STATE(536),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1065),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1065),
    [sym_macro_invocation] = STATE(1065),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1065),
    [sym_unary_expression] = STATE(1065),
    [sym_try_expression] = STATE(1065),
    [sym_reference_expression] = STATE(1065),
    [sym_binary_expression] = STATE(1065),
    [sym_assignment_expression] = STATE(1065),
    [sym_compound_assignment_expr] = STATE(1065),
    [sym_type_cast_expression] = STATE(1065),
    [sym_return_expression] = STATE(1065),
    [sym_call_expression] = STATE(1065),
    [sym_array_expression] = STATE(1065),
    [sym_parenthesized_expression] = STATE(1065),
    [sym_tuple_expression] = STATE(1065),
    [sym_unit_expression] = STATE(1065),
    [sym_struct_expression] = STATE(1065),
    [sym_if_expression] = STATE(1065),
    [sym_if_let_expression] = STATE(1065),
    [sym_match_expression] = STATE(1065),
    [sym_while_expression] = STATE(1065),
    [sym_while_let_expression] = STATE(1065),
    [sym_loop_expression] = STATE(1065),
    [sym_for_expression] = STATE(1065),
    [sym_closure_expression] = STATE(1065),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1065),
    [sym_continue_expression] = STATE(1065),
    [sym_index_expression] = STATE(1065),
    [sym_await_expression] = STATE(1065),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1065),
    [sym_async_block] = STATE(1065),
    [sym_block] = STATE(1065),
    [sym__literal] = STATE(1065),
    [sym_string_literal] = STATE(1065),
    [sym_boolean_literal] = STATE(1065),
    [aux_sym_enum_variant_list_repeat1] = STATE(536),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(411),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_POUND] = ACTIONS(405),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_COMMA] = ACTIONS(413),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(415),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(415),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(415),
    [sym_float_literal] = ACTIONS(415),
    [sym_block_comment] = ACTIONS(3),
  },
  [30] = {
    [ts_builtin_sym_end] = ACTIONS(417),
    [sym_identifier] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_macro_rules_BANG] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_u8] = ACTIONS(419),
    [anon_sym_i8] = ACTIONS(419),
    [anon_sym_u16] = ACTIONS(419),
    [anon_sym_i16] = ACTIONS(419),
    [anon_sym_u32] = ACTIONS(419),
    [anon_sym_i32] = ACTIONS(419),
    [anon_sym_u64] = ACTIONS(419),
    [anon_sym_i64] = ACTIONS(419),
    [anon_sym_u128] = ACTIONS(419),
    [anon_sym_i128] = ACTIONS(419),
    [anon_sym_isize] = ACTIONS(419),
    [anon_sym_usize] = ACTIONS(419),
    [anon_sym_f32] = ACTIONS(419),
    [anon_sym_f64] = ACTIONS(419),
    [anon_sym_bool] = ACTIONS(419),
    [anon_sym_str] = ACTIONS(419),
    [anon_sym_char] = ACTIONS(419),
    [anon_sym_SQUOTE] = ACTIONS(419),
    [anon_sym_as] = ACTIONS(419),
    [anon_sym_async] = ACTIONS(419),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_const] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(419),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_enum] = ACTIONS(419),
    [anon_sym_fn] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(419),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_impl] = ACTIONS(419),
    [anon_sym_let] = ACTIONS(419),
    [anon_sym_loop] = ACTIONS(419),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_mod] = ACTIONS(419),
    [anon_sym_pub] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(419),
    [anon_sym_static] = ACTIONS(419),
    [anon_sym_struct] = ACTIONS(419),
    [anon_sym_trait] = ACTIONS(419),
    [anon_sym_type] = ACTIONS(419),
    [anon_sym_union] = ACTIONS(419),
    [anon_sym_unsafe] = ACTIONS(419),
    [anon_sym_use] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_POUND] = ACTIONS(417),
    [anon_sym_BANG] = ACTIONS(419),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_extern] = ACTIONS(419),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_move] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(419),
    [sym_integer_literal] = ACTIONS(417),
    [aux_sym_string_literal_token1] = ACTIONS(417),
    [sym_char_literal] = ACTIONS(417),
    [anon_sym_true] = ACTIONS(419),
    [anon_sym_false] = ACTIONS(419),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(419),
    [sym_super] = ACTIONS(419),
    [sym_crate] = ACTIONS(419),
    [sym_metavariable] = ACTIONS(417),
    [sym_raw_string_literal] = ACTIONS(417),
    [sym_float_literal] = ACTIONS(417),
    [sym_block_comment] = ACTIONS(3),
  },
  [31] = {
    [sym_attribute_item] = STATE(63),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1074),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1074),
    [sym_macro_invocation] = STATE(1074),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1074),
    [sym_unary_expression] = STATE(1074),
    [sym_try_expression] = STATE(1074),
    [sym_reference_expression] = STATE(1074),
    [sym_binary_expression] = STATE(1074),
    [sym_assignment_expression] = STATE(1074),
    [sym_compound_assignment_expr] = STATE(1074),
    [sym_type_cast_expression] = STATE(1074),
    [sym_return_expression] = STATE(1074),
    [sym_call_expression] = STATE(1074),
    [sym_array_expression] = STATE(1074),
    [sym_parenthesized_expression] = STATE(1074),
    [sym_tuple_expression] = STATE(1074),
    [sym_unit_expression] = STATE(1074),
    [sym_struct_expression] = STATE(1074),
    [sym_if_expression] = STATE(1074),
    [sym_if_let_expression] = STATE(1074),
    [sym_match_expression] = STATE(1074),
    [sym_while_expression] = STATE(1074),
    [sym_while_let_expression] = STATE(1074),
    [sym_loop_expression] = STATE(1074),
    [sym_for_expression] = STATE(1074),
    [sym_closure_expression] = STATE(1074),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1074),
    [sym_continue_expression] = STATE(1074),
    [sym_index_expression] = STATE(1074),
    [sym_await_expression] = STATE(1074),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1074),
    [sym_async_block] = STATE(1074),
    [sym_block] = STATE(1074),
    [sym__literal] = STATE(1074),
    [sym_string_literal] = STATE(1074),
    [sym_boolean_literal] = STATE(1074),
    [aux_sym_enum_variant_list_repeat1] = STATE(63),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_POUND] = ACTIONS(405),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(425),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(425),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(425),
    [sym_float_literal] = ACTIONS(425),
    [sym_block_comment] = ACTIONS(3),
  },
  [32] = {
    [ts_builtin_sym_end] = ACTIONS(427),
    [sym_identifier] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_macro_rules_BANG] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(427),
    [anon_sym_RBRACE] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(429),
    [anon_sym_STAR] = ACTIONS(429),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_u8] = ACTIONS(429),
    [anon_sym_i8] = ACTIONS(429),
    [anon_sym_u16] = ACTIONS(429),
    [anon_sym_i16] = ACTIONS(429),
    [anon_sym_u32] = ACTIONS(429),
    [anon_sym_i32] = ACTIONS(429),
    [anon_sym_u64] = ACTIONS(429),
    [anon_sym_i64] = ACTIONS(429),
    [anon_sym_u128] = ACTIONS(429),
    [anon_sym_i128] = ACTIONS(429),
    [anon_sym_isize] = ACTIONS(429),
    [anon_sym_usize] = ACTIONS(429),
    [anon_sym_f32] = ACTIONS(429),
    [anon_sym_f64] = ACTIONS(429),
    [anon_sym_bool] = ACTIONS(429),
    [anon_sym_str] = ACTIONS(429),
    [anon_sym_char] = ACTIONS(429),
    [anon_sym_SQUOTE] = ACTIONS(429),
    [anon_sym_as] = ACTIONS(429),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_const] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(429),
    [anon_sym_default] = ACTIONS(429),
    [anon_sym_enum] = ACTIONS(429),
    [anon_sym_fn] = ACTIONS(429),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_impl] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(429),
    [anon_sym_loop] = ACTIONS(429),
    [anon_sym_match] = ACTIONS(429),
    [anon_sym_mod] = ACTIONS(429),
    [anon_sym_pub] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_static] = ACTIONS(429),
    [anon_sym_struct] = ACTIONS(429),
    [anon_sym_trait] = ACTIONS(429),
    [anon_sym_type] = ACTIONS(429),
    [anon_sym_union] = ACTIONS(429),
    [anon_sym_unsafe] = ACTIONS(429),
    [anon_sym_use] = ACTIONS(429),
    [anon_sym_while] = ACTIONS(429),
    [anon_sym_POUND] = ACTIONS(427),
    [anon_sym_BANG] = ACTIONS(429),
    [anon_sym_EQ] = ACTIONS(429),
    [anon_sym_extern] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(427),
    [anon_sym_DASH] = ACTIONS(429),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(429),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(429),
    [anon_sym_GT_GT] = ACTIONS(429),
    [anon_sym_SLASH] = ACTIONS(429),
    [anon_sym_PERCENT] = ACTIONS(429),
    [anon_sym_PLUS_EQ] = ACTIONS(427),
    [anon_sym_DASH_EQ] = ACTIONS(427),
    [anon_sym_STAR_EQ] = ACTIONS(427),
    [anon_sym_SLASH_EQ] = ACTIONS(427),
    [anon_sym_PERCENT_EQ] = ACTIONS(427),
    [anon_sym_AMP_EQ] = ACTIONS(427),
    [anon_sym_PIPE_EQ] = ACTIONS(427),
    [anon_sym_CARET_EQ] = ACTIONS(427),
    [anon_sym_LT_LT_EQ] = ACTIONS(427),
    [anon_sym_GT_GT_EQ] = ACTIONS(427),
    [anon_sym_else] = ACTIONS(429),
    [anon_sym_move] = ACTIONS(429),
    [anon_sym_DOT] = ACTIONS(429),
    [sym_integer_literal] = ACTIONS(427),
    [aux_sym_string_literal_token1] = ACTIONS(427),
    [sym_char_literal] = ACTIONS(427),
    [anon_sym_true] = ACTIONS(429),
    [anon_sym_false] = ACTIONS(429),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(429),
    [sym_super] = ACTIONS(429),
    [sym_crate] = ACTIONS(429),
    [sym_metavariable] = ACTIONS(427),
    [sym_raw_string_literal] = ACTIONS(427),
    [sym_float_literal] = ACTIONS(427),
    [sym_block_comment] = ACTIONS(3),
  },
  [33] = {
    [ts_builtin_sym_end] = ACTIONS(431),
    [sym_identifier] = ACTIONS(433),
    [anon_sym_SEMI] = ACTIONS(431),
    [anon_sym_macro_rules_BANG] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(431),
    [anon_sym_LBRACE] = ACTIONS(431),
    [anon_sym_RBRACE] = ACTIONS(431),
    [anon_sym_LBRACK] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(433),
    [anon_sym_STAR] = ACTIONS(433),
    [anon_sym_QMARK] = ACTIONS(431),
    [anon_sym_u8] = ACTIONS(433),
    [anon_sym_i8] = ACTIONS(433),
    [anon_sym_u16] = ACTIONS(433),
    [anon_sym_i16] = ACTIONS(433),
    [anon_sym_u32] = ACTIONS(433),
    [anon_sym_i32] = ACTIONS(433),
    [anon_sym_u64] = ACTIONS(433),
    [anon_sym_i64] = ACTIONS(433),
    [anon_sym_u128] = ACTIONS(433),
    [anon_sym_i128] = ACTIONS(433),
    [anon_sym_isize] = ACTIONS(433),
    [anon_sym_usize] = ACTIONS(433),
    [anon_sym_f32] = ACTIONS(433),
    [anon_sym_f64] = ACTIONS(433),
    [anon_sym_bool] = ACTIONS(433),
    [anon_sym_str] = ACTIONS(433),
    [anon_sym_char] = ACTIONS(433),
    [anon_sym_SQUOTE] = ACTIONS(433),
    [anon_sym_as] = ACTIONS(433),
    [anon_sym_async] = ACTIONS(433),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_const] = ACTIONS(433),
    [anon_sym_continue] = ACTIONS(433),
    [anon_sym_default] = ACTIONS(433),
    [anon_sym_enum] = ACTIONS(433),
    [anon_sym_fn] = ACTIONS(433),
    [anon_sym_for] = ACTIONS(433),
    [anon_sym_if] = ACTIONS(433),
    [anon_sym_impl] = ACTIONS(433),
    [anon_sym_let] = ACTIONS(433),
    [anon_sym_loop] = ACTIONS(433),
    [anon_sym_match] = ACTIONS(433),
    [anon_sym_mod] = ACTIONS(433),
    [anon_sym_pub] = ACTIONS(433),
    [anon_sym_return] = ACTIONS(433),
    [anon_sym_static] = ACTIONS(433),
    [anon_sym_struct] = ACTIONS(433),
    [anon_sym_trait] = ACTIONS(433),
    [anon_sym_type] = ACTIONS(433),
    [anon_sym_union] = ACTIONS(433),
    [anon_sym_unsafe] = ACTIONS(433),
    [anon_sym_use] = ACTIONS(433),
    [anon_sym_while] = ACTIONS(433),
    [anon_sym_POUND] = ACTIONS(431),
    [anon_sym_BANG] = ACTIONS(433),
    [anon_sym_EQ] = ACTIONS(433),
    [anon_sym_extern] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(433),
    [anon_sym_GT] = ACTIONS(433),
    [anon_sym_COLON_COLON] = ACTIONS(431),
    [anon_sym_AMP] = ACTIONS(433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(431),
    [anon_sym_DOT_DOT] = ACTIONS(433),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(431),
    [anon_sym_DASH] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(431),
    [anon_sym_PIPE] = ACTIONS(433),
    [anon_sym_CARET] = ACTIONS(433),
    [anon_sym_EQ_EQ] = ACTIONS(431),
    [anon_sym_BANG_EQ] = ACTIONS(431),
    [anon_sym_LT_EQ] = ACTIONS(431),
    [anon_sym_GT_EQ] = ACTIONS(431),
    [anon_sym_LT_LT] = ACTIONS(433),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_SLASH] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(433),
    [anon_sym_PLUS_EQ] = ACTIONS(431),
    [anon_sym_DASH_EQ] = ACTIONS(431),
    [anon_sym_STAR_EQ] = ACTIONS(431),
    [anon_sym_SLASH_EQ] = ACTIONS(431),
    [anon_sym_PERCENT_EQ] = ACTIONS(431),
    [anon_sym_AMP_EQ] = ACTIONS(431),
    [anon_sym_PIPE_EQ] = ACTIONS(431),
    [anon_sym_CARET_EQ] = ACTIONS(431),
    [anon_sym_LT_LT_EQ] = ACTIONS(431),
    [anon_sym_GT_GT_EQ] = ACTIONS(431),
    [anon_sym_move] = ACTIONS(433),
    [anon_sym_DOT] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(431),
    [aux_sym_string_literal_token1] = ACTIONS(431),
    [sym_char_literal] = ACTIONS(431),
    [anon_sym_true] = ACTIONS(433),
    [anon_sym_false] = ACTIONS(433),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(433),
    [sym_super] = ACTIONS(433),
    [sym_crate] = ACTIONS(433),
    [sym_metavariable] = ACTIONS(431),
    [sym_raw_string_literal] = ACTIONS(431),
    [sym_float_literal] = ACTIONS(431),
    [sym_block_comment] = ACTIONS(3),
  },
  [34] = {
    [ts_builtin_sym_end] = ACTIONS(435),
    [sym_identifier] = ACTIONS(437),
    [anon_sym_SEMI] = ACTIONS(435),
    [anon_sym_macro_rules_BANG] = ACTIONS(435),
    [anon_sym_LPAREN] = ACTIONS(435),
    [anon_sym_LBRACE] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(435),
    [anon_sym_LBRACK] = ACTIONS(435),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_STAR] = ACTIONS(437),
    [anon_sym_QMARK] = ACTIONS(435),
    [anon_sym_u8] = ACTIONS(437),
    [anon_sym_i8] = ACTIONS(437),
    [anon_sym_u16] = ACTIONS(437),
    [anon_sym_i16] = ACTIONS(437),
    [anon_sym_u32] = ACTIONS(437),
    [anon_sym_i32] = ACTIONS(437),
    [anon_sym_u64] = ACTIONS(437),
    [anon_sym_i64] = ACTIONS(437),
    [anon_sym_u128] = ACTIONS(437),
    [anon_sym_i128] = ACTIONS(437),
    [anon_sym_isize] = ACTIONS(437),
    [anon_sym_usize] = ACTIONS(437),
    [anon_sym_f32] = ACTIONS(437),
    [anon_sym_f64] = ACTIONS(437),
    [anon_sym_bool] = ACTIONS(437),
    [anon_sym_str] = ACTIONS(437),
    [anon_sym_char] = ACTIONS(437),
    [anon_sym_SQUOTE] = ACTIONS(437),
    [anon_sym_as] = ACTIONS(437),
    [anon_sym_async] = ACTIONS(437),
    [anon_sym_break] = ACTIONS(437),
    [anon_sym_const] = ACTIONS(437),
    [anon_sym_continue] = ACTIONS(437),
    [anon_sym_default] = ACTIONS(437),
    [anon_sym_enum] = ACTIONS(437),
    [anon_sym_fn] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(437),
    [anon_sym_if] = ACTIONS(437),
    [anon_sym_impl] = ACTIONS(437),
    [anon_sym_let] = ACTIONS(437),
    [anon_sym_loop] = ACTIONS(437),
    [anon_sym_match] = ACTIONS(437),
    [anon_sym_mod] = ACTIONS(437),
    [anon_sym_pub] = ACTIONS(437),
    [anon_sym_return] = ACTIONS(437),
    [anon_sym_static] = ACTIONS(437),
    [anon_sym_struct] = ACTIONS(437),
    [anon_sym_trait] = ACTIONS(437),
    [anon_sym_type] = ACTIONS(437),
    [anon_sym_union] = ACTIONS(437),
    [anon_sym_unsafe] = ACTIONS(437),
    [anon_sym_use] = ACTIONS(437),
    [anon_sym_while] = ACTIONS(437),
    [anon_sym_POUND] = ACTIONS(435),
    [anon_sym_BANG] = ACTIONS(437),
    [anon_sym_EQ] = ACTIONS(437),
    [anon_sym_extern] = ACTIONS(437),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_GT] = ACTIONS(437),
    [anon_sym_COLON_COLON] = ACTIONS(435),
    [anon_sym_AMP] = ACTIONS(437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(435),
    [anon_sym_DOT_DOT] = ACTIONS(437),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(435),
    [anon_sym_PIPE_PIPE] = ACTIONS(435),
    [anon_sym_PIPE] = ACTIONS(437),
    [anon_sym_CARET] = ACTIONS(437),
    [anon_sym_EQ_EQ] = ACTIONS(435),
    [anon_sym_BANG_EQ] = ACTIONS(435),
    [anon_sym_LT_EQ] = ACTIONS(435),
    [anon_sym_GT_EQ] = ACTIONS(435),
    [anon_sym_LT_LT] = ACTIONS(437),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_SLASH] = ACTIONS(437),
    [anon_sym_PERCENT] = ACTIONS(437),
    [anon_sym_PLUS_EQ] = ACTIONS(435),
    [anon_sym_DASH_EQ] = ACTIONS(435),
    [anon_sym_STAR_EQ] = ACTIONS(435),
    [anon_sym_SLASH_EQ] = ACTIONS(435),
    [anon_sym_PERCENT_EQ] = ACTIONS(435),
    [anon_sym_AMP_EQ] = ACTIONS(435),
    [anon_sym_PIPE_EQ] = ACTIONS(435),
    [anon_sym_CARET_EQ] = ACTIONS(435),
    [anon_sym_LT_LT_EQ] = ACTIONS(435),
    [anon_sym_GT_GT_EQ] = ACTIONS(435),
    [anon_sym_move] = ACTIONS(437),
    [anon_sym_DOT] = ACTIONS(437),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(435),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(437),
    [anon_sym_false] = ACTIONS(437),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(437),
    [sym_super] = ACTIONS(437),
    [sym_crate] = ACTIONS(437),
    [sym_metavariable] = ACTIONS(435),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
    [sym_block_comment] = ACTIONS(3),
  },
  [35] = {
    [sym_attribute_item] = STATE(61),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1112),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1112),
    [sym_macro_invocation] = STATE(1112),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1112),
    [sym_unary_expression] = STATE(1112),
    [sym_try_expression] = STATE(1112),
    [sym_reference_expression] = STATE(1112),
    [sym_binary_expression] = STATE(1112),
    [sym_assignment_expression] = STATE(1112),
    [sym_compound_assignment_expr] = STATE(1112),
    [sym_type_cast_expression] = STATE(1112),
    [sym_return_expression] = STATE(1112),
    [sym_call_expression] = STATE(1112),
    [sym_array_expression] = STATE(1112),
    [sym_parenthesized_expression] = STATE(1112),
    [sym_tuple_expression] = STATE(1112),
    [sym_unit_expression] = STATE(1112),
    [sym_struct_expression] = STATE(1112),
    [sym_if_expression] = STATE(1112),
    [sym_if_let_expression] = STATE(1112),
    [sym_match_expression] = STATE(1112),
    [sym_while_expression] = STATE(1112),
    [sym_while_let_expression] = STATE(1112),
    [sym_loop_expression] = STATE(1112),
    [sym_for_expression] = STATE(1112),
    [sym_closure_expression] = STATE(1112),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1112),
    [sym_continue_expression] = STATE(1112),
    [sym_index_expression] = STATE(1112),
    [sym_await_expression] = STATE(1112),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1112),
    [sym_async_block] = STATE(1112),
    [sym_block] = STATE(1112),
    [sym__literal] = STATE(1112),
    [sym_string_literal] = STATE(1112),
    [sym_boolean_literal] = STATE(1112),
    [aux_sym_enum_variant_list_repeat1] = STATE(61),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(439),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_POUND] = ACTIONS(405),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(441),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(441),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(441),
    [sym_float_literal] = ACTIONS(441),
    [sym_block_comment] = ACTIONS(3),
  },
  [36] = {
    [ts_builtin_sym_end] = ACTIONS(443),
    [sym_identifier] = ACTIONS(445),
    [anon_sym_SEMI] = ACTIONS(443),
    [anon_sym_macro_rules_BANG] = ACTIONS(443),
    [anon_sym_LPAREN] = ACTIONS(443),
    [anon_sym_LBRACE] = ACTIONS(443),
    [anon_sym_RBRACE] = ACTIONS(443),
    [anon_sym_LBRACK] = ACTIONS(443),
    [anon_sym_PLUS] = ACTIONS(445),
    [anon_sym_STAR] = ACTIONS(445),
    [anon_sym_QMARK] = ACTIONS(443),
    [anon_sym_u8] = ACTIONS(445),
    [anon_sym_i8] = ACTIONS(445),
    [anon_sym_u16] = ACTIONS(445),
    [anon_sym_i16] = ACTIONS(445),
    [anon_sym_u32] = ACTIONS(445),
    [anon_sym_i32] = ACTIONS(445),
    [anon_sym_u64] = ACTIONS(445),
    [anon_sym_i64] = ACTIONS(445),
    [anon_sym_u128] = ACTIONS(445),
    [anon_sym_i128] = ACTIONS(445),
    [anon_sym_isize] = ACTIONS(445),
    [anon_sym_usize] = ACTIONS(445),
    [anon_sym_f32] = ACTIONS(445),
    [anon_sym_f64] = ACTIONS(445),
    [anon_sym_bool] = ACTIONS(445),
    [anon_sym_str] = ACTIONS(445),
    [anon_sym_char] = ACTIONS(445),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_async] = ACTIONS(445),
    [anon_sym_break] = ACTIONS(445),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_continue] = ACTIONS(445),
    [anon_sym_default] = ACTIONS(445),
    [anon_sym_enum] = ACTIONS(445),
    [anon_sym_fn] = ACTIONS(445),
    [anon_sym_for] = ACTIONS(445),
    [anon_sym_if] = ACTIONS(445),
    [anon_sym_impl] = ACTIONS(445),
    [anon_sym_let] = ACTIONS(445),
    [anon_sym_loop] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(445),
    [anon_sym_mod] = ACTIONS(445),
    [anon_sym_pub] = ACTIONS(445),
    [anon_sym_return] = ACTIONS(445),
    [anon_sym_static] = ACTIONS(445),
    [anon_sym_struct] = ACTIONS(445),
    [anon_sym_trait] = ACTIONS(445),
    [anon_sym_type] = ACTIONS(445),
    [anon_sym_union] = ACTIONS(445),
    [anon_sym_unsafe] = ACTIONS(445),
    [anon_sym_use] = ACTIONS(445),
    [anon_sym_while] = ACTIONS(445),
    [anon_sym_POUND] = ACTIONS(443),
    [anon_sym_BANG] = ACTIONS(445),
    [anon_sym_EQ] = ACTIONS(445),
    [anon_sym_extern] = ACTIONS(445),
    [anon_sym_LT] = ACTIONS(445),
    [anon_sym_GT] = ACTIONS(445),
    [anon_sym_COLON_COLON] = ACTIONS(443),
    [anon_sym_AMP] = ACTIONS(445),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(443),
    [anon_sym_DOT_DOT] = ACTIONS(445),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(443),
    [anon_sym_DASH] = ACTIONS(445),
    [anon_sym_AMP_AMP] = ACTIONS(443),
    [anon_sym_PIPE_PIPE] = ACTIONS(443),
    [anon_sym_PIPE] = ACTIONS(445),
    [anon_sym_CARET] = ACTIONS(445),
    [anon_sym_EQ_EQ] = ACTIONS(443),
    [anon_sym_BANG_EQ] = ACTIONS(443),
    [anon_sym_LT_EQ] = ACTIONS(443),
    [anon_sym_GT_EQ] = ACTIONS(443),
    [anon_sym_LT_LT] = ACTIONS(445),
    [anon_sym_GT_GT] = ACTIONS(445),
    [anon_sym_SLASH] = ACTIONS(445),
    [anon_sym_PERCENT] = ACTIONS(445),
    [anon_sym_PLUS_EQ] = ACTIONS(443),
    [anon_sym_DASH_EQ] = ACTIONS(443),
    [anon_sym_STAR_EQ] = ACTIONS(443),
    [anon_sym_SLASH_EQ] = ACTIONS(443),
    [anon_sym_PERCENT_EQ] = ACTIONS(443),
    [anon_sym_AMP_EQ] = ACTIONS(443),
    [anon_sym_PIPE_EQ] = ACTIONS(443),
    [anon_sym_CARET_EQ] = ACTIONS(443),
    [anon_sym_LT_LT_EQ] = ACTIONS(443),
    [anon_sym_GT_GT_EQ] = ACTIONS(443),
    [anon_sym_move] = ACTIONS(445),
    [anon_sym_DOT] = ACTIONS(445),
    [sym_integer_literal] = ACTIONS(443),
    [aux_sym_string_literal_token1] = ACTIONS(443),
    [sym_char_literal] = ACTIONS(443),
    [anon_sym_true] = ACTIONS(445),
    [anon_sym_false] = ACTIONS(445),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(445),
    [sym_super] = ACTIONS(445),
    [sym_crate] = ACTIONS(445),
    [sym_metavariable] = ACTIONS(443),
    [sym_raw_string_literal] = ACTIONS(443),
    [sym_float_literal] = ACTIONS(443),
    [sym_block_comment] = ACTIONS(3),
  },
  [37] = {
    [ts_builtin_sym_end] = ACTIONS(447),
    [sym_identifier] = ACTIONS(449),
    [anon_sym_SEMI] = ACTIONS(447),
    [anon_sym_macro_rules_BANG] = ACTIONS(447),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_LBRACE] = ACTIONS(447),
    [anon_sym_RBRACE] = ACTIONS(447),
    [anon_sym_LBRACK] = ACTIONS(447),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(447),
    [anon_sym_u8] = ACTIONS(449),
    [anon_sym_i8] = ACTIONS(449),
    [anon_sym_u16] = ACTIONS(449),
    [anon_sym_i16] = ACTIONS(449),
    [anon_sym_u32] = ACTIONS(449),
    [anon_sym_i32] = ACTIONS(449),
    [anon_sym_u64] = ACTIONS(449),
    [anon_sym_i64] = ACTIONS(449),
    [anon_sym_u128] = ACTIONS(449),
    [anon_sym_i128] = ACTIONS(449),
    [anon_sym_isize] = ACTIONS(449),
    [anon_sym_usize] = ACTIONS(449),
    [anon_sym_f32] = ACTIONS(449),
    [anon_sym_f64] = ACTIONS(449),
    [anon_sym_bool] = ACTIONS(449),
    [anon_sym_str] = ACTIONS(449),
    [anon_sym_char] = ACTIONS(449),
    [anon_sym_SQUOTE] = ACTIONS(449),
    [anon_sym_as] = ACTIONS(449),
    [anon_sym_async] = ACTIONS(449),
    [anon_sym_break] = ACTIONS(449),
    [anon_sym_const] = ACTIONS(449),
    [anon_sym_continue] = ACTIONS(449),
    [anon_sym_default] = ACTIONS(449),
    [anon_sym_enum] = ACTIONS(449),
    [anon_sym_fn] = ACTIONS(449),
    [anon_sym_for] = ACTIONS(449),
    [anon_sym_if] = ACTIONS(449),
    [anon_sym_impl] = ACTIONS(449),
    [anon_sym_let] = ACTIONS(449),
    [anon_sym_loop] = ACTIONS(449),
    [anon_sym_match] = ACTIONS(449),
    [anon_sym_mod] = ACTIONS(449),
    [anon_sym_pub] = ACTIONS(449),
    [anon_sym_return] = ACTIONS(449),
    [anon_sym_static] = ACTIONS(449),
    [anon_sym_struct] = ACTIONS(449),
    [anon_sym_trait] = ACTIONS(449),
    [anon_sym_type] = ACTIONS(449),
    [anon_sym_union] = ACTIONS(449),
    [anon_sym_unsafe] = ACTIONS(449),
    [anon_sym_use] = ACTIONS(449),
    [anon_sym_while] = ACTIONS(449),
    [anon_sym_POUND] = ACTIONS(447),
    [anon_sym_BANG] = ACTIONS(449),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_extern] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_COLON_COLON] = ACTIONS(447),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(447),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(447),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(447),
    [anon_sym_PIPE_PIPE] = ACTIONS(447),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_CARET] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(447),
    [anon_sym_BANG_EQ] = ACTIONS(447),
    [anon_sym_LT_EQ] = ACTIONS(447),
    [anon_sym_GT_EQ] = ACTIONS(447),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_GT_GT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(447),
    [anon_sym_DASH_EQ] = ACTIONS(447),
    [anon_sym_STAR_EQ] = ACTIONS(447),
    [anon_sym_SLASH_EQ] = ACTIONS(447),
    [anon_sym_PERCENT_EQ] = ACTIONS(447),
    [anon_sym_AMP_EQ] = ACTIONS(447),
    [anon_sym_PIPE_EQ] = ACTIONS(447),
    [anon_sym_CARET_EQ] = ACTIONS(447),
    [anon_sym_LT_LT_EQ] = ACTIONS(447),
    [anon_sym_GT_GT_EQ] = ACTIONS(447),
    [anon_sym_move] = ACTIONS(449),
    [anon_sym_DOT] = ACTIONS(449),
    [sym_integer_literal] = ACTIONS(447),
    [aux_sym_string_literal_token1] = ACTIONS(447),
    [sym_char_literal] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(449),
    [anon_sym_false] = ACTIONS(449),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(449),
    [sym_super] = ACTIONS(449),
    [sym_crate] = ACTIONS(449),
    [sym_metavariable] = ACTIONS(447),
    [sym_raw_string_literal] = ACTIONS(447),
    [sym_float_literal] = ACTIONS(447),
    [sym_block_comment] = ACTIONS(3),
  },
  [38] = {
    [ts_builtin_sym_end] = ACTIONS(451),
    [sym_identifier] = ACTIONS(453),
    [anon_sym_SEMI] = ACTIONS(451),
    [anon_sym_macro_rules_BANG] = ACTIONS(451),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(451),
    [anon_sym_RBRACE] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_PLUS] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(453),
    [anon_sym_QMARK] = ACTIONS(451),
    [anon_sym_u8] = ACTIONS(453),
    [anon_sym_i8] = ACTIONS(453),
    [anon_sym_u16] = ACTIONS(453),
    [anon_sym_i16] = ACTIONS(453),
    [anon_sym_u32] = ACTIONS(453),
    [anon_sym_i32] = ACTIONS(453),
    [anon_sym_u64] = ACTIONS(453),
    [anon_sym_i64] = ACTIONS(453),
    [anon_sym_u128] = ACTIONS(453),
    [anon_sym_i128] = ACTIONS(453),
    [anon_sym_isize] = ACTIONS(453),
    [anon_sym_usize] = ACTIONS(453),
    [anon_sym_f32] = ACTIONS(453),
    [anon_sym_f64] = ACTIONS(453),
    [anon_sym_bool] = ACTIONS(453),
    [anon_sym_str] = ACTIONS(453),
    [anon_sym_char] = ACTIONS(453),
    [anon_sym_SQUOTE] = ACTIONS(453),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_async] = ACTIONS(453),
    [anon_sym_break] = ACTIONS(453),
    [anon_sym_const] = ACTIONS(453),
    [anon_sym_continue] = ACTIONS(453),
    [anon_sym_default] = ACTIONS(453),
    [anon_sym_enum] = ACTIONS(453),
    [anon_sym_fn] = ACTIONS(453),
    [anon_sym_for] = ACTIONS(453),
    [anon_sym_if] = ACTIONS(453),
    [anon_sym_impl] = ACTIONS(453),
    [anon_sym_let] = ACTIONS(453),
    [anon_sym_loop] = ACTIONS(453),
    [anon_sym_match] = ACTIONS(453),
    [anon_sym_mod] = ACTIONS(453),
    [anon_sym_pub] = ACTIONS(453),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_static] = ACTIONS(453),
    [anon_sym_struct] = ACTIONS(453),
    [anon_sym_trait] = ACTIONS(453),
    [anon_sym_type] = ACTIONS(453),
    [anon_sym_union] = ACTIONS(453),
    [anon_sym_unsafe] = ACTIONS(453),
    [anon_sym_use] = ACTIONS(453),
    [anon_sym_while] = ACTIONS(453),
    [anon_sym_POUND] = ACTIONS(451),
    [anon_sym_BANG] = ACTIONS(453),
    [anon_sym_EQ] = ACTIONS(453),
    [anon_sym_extern] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(453),
    [anon_sym_COLON_COLON] = ACTIONS(451),
    [anon_sym_AMP] = ACTIONS(453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(451),
    [anon_sym_DOT_DOT] = ACTIONS(453),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(451),
    [anon_sym_DASH] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [anon_sym_PIPE] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(451),
    [anon_sym_BANG_EQ] = ACTIONS(451),
    [anon_sym_LT_EQ] = ACTIONS(451),
    [anon_sym_GT_EQ] = ACTIONS(451),
    [anon_sym_LT_LT] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(453),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_PERCENT] = ACTIONS(453),
    [anon_sym_PLUS_EQ] = ACTIONS(451),
    [anon_sym_DASH_EQ] = ACTIONS(451),
    [anon_sym_STAR_EQ] = ACTIONS(451),
    [anon_sym_SLASH_EQ] = ACTIONS(451),
    [anon_sym_PERCENT_EQ] = ACTIONS(451),
    [anon_sym_AMP_EQ] = ACTIONS(451),
    [anon_sym_PIPE_EQ] = ACTIONS(451),
    [anon_sym_CARET_EQ] = ACTIONS(451),
    [anon_sym_LT_LT_EQ] = ACTIONS(451),
    [anon_sym_GT_GT_EQ] = ACTIONS(451),
    [anon_sym_move] = ACTIONS(453),
    [anon_sym_DOT] = ACTIONS(453),
    [sym_integer_literal] = ACTIONS(451),
    [aux_sym_string_literal_token1] = ACTIONS(451),
    [sym_char_literal] = ACTIONS(451),
    [anon_sym_true] = ACTIONS(453),
    [anon_sym_false] = ACTIONS(453),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(453),
    [sym_super] = ACTIONS(453),
    [sym_crate] = ACTIONS(453),
    [sym_metavariable] = ACTIONS(451),
    [sym_raw_string_literal] = ACTIONS(451),
    [sym_float_literal] = ACTIONS(451),
    [sym_block_comment] = ACTIONS(3),
  },
  [39] = {
    [ts_builtin_sym_end] = ACTIONS(455),
    [sym_identifier] = ACTIONS(457),
    [anon_sym_SEMI] = ACTIONS(455),
    [anon_sym_macro_rules_BANG] = ACTIONS(455),
    [anon_sym_LPAREN] = ACTIONS(455),
    [anon_sym_LBRACE] = ACTIONS(455),
    [anon_sym_RBRACE] = ACTIONS(455),
    [anon_sym_LBRACK] = ACTIONS(455),
    [anon_sym_PLUS] = ACTIONS(457),
    [anon_sym_STAR] = ACTIONS(457),
    [anon_sym_QMARK] = ACTIONS(455),
    [anon_sym_u8] = ACTIONS(457),
    [anon_sym_i8] = ACTIONS(457),
    [anon_sym_u16] = ACTIONS(457),
    [anon_sym_i16] = ACTIONS(457),
    [anon_sym_u32] = ACTIONS(457),
    [anon_sym_i32] = ACTIONS(457),
    [anon_sym_u64] = ACTIONS(457),
    [anon_sym_i64] = ACTIONS(457),
    [anon_sym_u128] = ACTIONS(457),
    [anon_sym_i128] = ACTIONS(457),
    [anon_sym_isize] = ACTIONS(457),
    [anon_sym_usize] = ACTIONS(457),
    [anon_sym_f32] = ACTIONS(457),
    [anon_sym_f64] = ACTIONS(457),
    [anon_sym_bool] = ACTIONS(457),
    [anon_sym_str] = ACTIONS(457),
    [anon_sym_char] = ACTIONS(457),
    [anon_sym_SQUOTE] = ACTIONS(457),
    [anon_sym_as] = ACTIONS(457),
    [anon_sym_async] = ACTIONS(457),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_const] = ACTIONS(457),
    [anon_sym_continue] = ACTIONS(457),
    [anon_sym_default] = ACTIONS(457),
    [anon_sym_enum] = ACTIONS(457),
    [anon_sym_fn] = ACTIONS(457),
    [anon_sym_for] = ACTIONS(457),
    [anon_sym_if] = ACTIONS(457),
    [anon_sym_impl] = ACTIONS(457),
    [anon_sym_let] = ACTIONS(457),
    [anon_sym_loop] = ACTIONS(457),
    [anon_sym_match] = ACTIONS(457),
    [anon_sym_mod] = ACTIONS(457),
    [anon_sym_pub] = ACTIONS(457),
    [anon_sym_return] = ACTIONS(457),
    [anon_sym_static] = ACTIONS(457),
    [anon_sym_struct] = ACTIONS(457),
    [anon_sym_trait] = ACTIONS(457),
    [anon_sym_type] = ACTIONS(457),
    [anon_sym_union] = ACTIONS(457),
    [anon_sym_unsafe] = ACTIONS(457),
    [anon_sym_use] = ACTIONS(457),
    [anon_sym_while] = ACTIONS(457),
    [anon_sym_POUND] = ACTIONS(455),
    [anon_sym_BANG] = ACTIONS(457),
    [anon_sym_EQ] = ACTIONS(457),
    [anon_sym_extern] = ACTIONS(457),
    [anon_sym_LT] = ACTIONS(457),
    [anon_sym_GT] = ACTIONS(457),
    [anon_sym_COLON_COLON] = ACTIONS(455),
    [anon_sym_AMP] = ACTIONS(457),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(455),
    [anon_sym_DOT_DOT] = ACTIONS(457),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(455),
    [anon_sym_DASH] = ACTIONS(457),
    [anon_sym_AMP_AMP] = ACTIONS(455),
    [anon_sym_PIPE_PIPE] = ACTIONS(455),
    [anon_sym_PIPE] = ACTIONS(457),
    [anon_sym_CARET] = ACTIONS(457),
    [anon_sym_EQ_EQ] = ACTIONS(455),
    [anon_sym_BANG_EQ] = ACTIONS(455),
    [anon_sym_LT_EQ] = ACTIONS(455),
    [anon_sym_GT_EQ] = ACTIONS(455),
    [anon_sym_LT_LT] = ACTIONS(457),
    [anon_sym_GT_GT] = ACTIONS(457),
    [anon_sym_SLASH] = ACTIONS(457),
    [anon_sym_PERCENT] = ACTIONS(457),
    [anon_sym_PLUS_EQ] = ACTIONS(455),
    [anon_sym_DASH_EQ] = ACTIONS(455),
    [anon_sym_STAR_EQ] = ACTIONS(455),
    [anon_sym_SLASH_EQ] = ACTIONS(455),
    [anon_sym_PERCENT_EQ] = ACTIONS(455),
    [anon_sym_AMP_EQ] = ACTIONS(455),
    [anon_sym_PIPE_EQ] = ACTIONS(455),
    [anon_sym_CARET_EQ] = ACTIONS(455),
    [anon_sym_LT_LT_EQ] = ACTIONS(455),
    [anon_sym_GT_GT_EQ] = ACTIONS(455),
    [anon_sym_move] = ACTIONS(457),
    [anon_sym_DOT] = ACTIONS(457),
    [sym_integer_literal] = ACTIONS(455),
    [aux_sym_string_literal_token1] = ACTIONS(455),
    [sym_char_literal] = ACTIONS(455),
    [anon_sym_true] = ACTIONS(457),
    [anon_sym_false] = ACTIONS(457),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(457),
    [sym_super] = ACTIONS(457),
    [sym_crate] = ACTIONS(457),
    [sym_metavariable] = ACTIONS(455),
    [sym_raw_string_literal] = ACTIONS(455),
    [sym_float_literal] = ACTIONS(455),
    [sym_block_comment] = ACTIONS(3),
  },
  [40] = {
    [ts_builtin_sym_end] = ACTIONS(459),
    [sym_identifier] = ACTIONS(461),
    [anon_sym_SEMI] = ACTIONS(459),
    [anon_sym_macro_rules_BANG] = ACTIONS(459),
    [anon_sym_LPAREN] = ACTIONS(459),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_STAR] = ACTIONS(461),
    [anon_sym_QMARK] = ACTIONS(459),
    [anon_sym_u8] = ACTIONS(461),
    [anon_sym_i8] = ACTIONS(461),
    [anon_sym_u16] = ACTIONS(461),
    [anon_sym_i16] = ACTIONS(461),
    [anon_sym_u32] = ACTIONS(461),
    [anon_sym_i32] = ACTIONS(461),
    [anon_sym_u64] = ACTIONS(461),
    [anon_sym_i64] = ACTIONS(461),
    [anon_sym_u128] = ACTIONS(461),
    [anon_sym_i128] = ACTIONS(461),
    [anon_sym_isize] = ACTIONS(461),
    [anon_sym_usize] = ACTIONS(461),
    [anon_sym_f32] = ACTIONS(461),
    [anon_sym_f64] = ACTIONS(461),
    [anon_sym_bool] = ACTIONS(461),
    [anon_sym_str] = ACTIONS(461),
    [anon_sym_char] = ACTIONS(461),
    [anon_sym_SQUOTE] = ACTIONS(461),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(461),
    [anon_sym_break] = ACTIONS(461),
    [anon_sym_const] = ACTIONS(461),
    [anon_sym_continue] = ACTIONS(461),
    [anon_sym_default] = ACTIONS(461),
    [anon_sym_enum] = ACTIONS(461),
    [anon_sym_fn] = ACTIONS(461),
    [anon_sym_for] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_impl] = ACTIONS(461),
    [anon_sym_let] = ACTIONS(461),
    [anon_sym_loop] = ACTIONS(461),
    [anon_sym_match] = ACTIONS(461),
    [anon_sym_mod] = ACTIONS(461),
    [anon_sym_pub] = ACTIONS(461),
    [anon_sym_return] = ACTIONS(461),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(461),
    [anon_sym_trait] = ACTIONS(461),
    [anon_sym_type] = ACTIONS(461),
    [anon_sym_union] = ACTIONS(461),
    [anon_sym_unsafe] = ACTIONS(461),
    [anon_sym_use] = ACTIONS(461),
    [anon_sym_while] = ACTIONS(461),
    [anon_sym_POUND] = ACTIONS(459),
    [anon_sym_BANG] = ACTIONS(461),
    [anon_sym_EQ] = ACTIONS(461),
    [anon_sym_extern] = ACTIONS(461),
    [anon_sym_LT] = ACTIONS(461),
    [anon_sym_GT] = ACTIONS(461),
    [anon_sym_COLON_COLON] = ACTIONS(459),
    [anon_sym_AMP] = ACTIONS(461),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(459),
    [anon_sym_DOT_DOT] = ACTIONS(461),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(461),
    [anon_sym_AMP_AMP] = ACTIONS(459),
    [anon_sym_PIPE_PIPE] = ACTIONS(459),
    [anon_sym_PIPE] = ACTIONS(461),
    [anon_sym_CARET] = ACTIONS(461),
    [anon_sym_EQ_EQ] = ACTIONS(459),
    [anon_sym_BANG_EQ] = ACTIONS(459),
    [anon_sym_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_EQ] = ACTIONS(459),
    [anon_sym_LT_LT] = ACTIONS(461),
    [anon_sym_GT_GT] = ACTIONS(461),
    [anon_sym_SLASH] = ACTIONS(461),
    [anon_sym_PERCENT] = ACTIONS(461),
    [anon_sym_PLUS_EQ] = ACTIONS(459),
    [anon_sym_DASH_EQ] = ACTIONS(459),
    [anon_sym_STAR_EQ] = ACTIONS(459),
    [anon_sym_SLASH_EQ] = ACTIONS(459),
    [anon_sym_PERCENT_EQ] = ACTIONS(459),
    [anon_sym_AMP_EQ] = ACTIONS(459),
    [anon_sym_PIPE_EQ] = ACTIONS(459),
    [anon_sym_CARET_EQ] = ACTIONS(459),
    [anon_sym_LT_LT_EQ] = ACTIONS(459),
    [anon_sym_GT_GT_EQ] = ACTIONS(459),
    [anon_sym_move] = ACTIONS(461),
    [anon_sym_DOT] = ACTIONS(461),
    [sym_integer_literal] = ACTIONS(459),
    [aux_sym_string_literal_token1] = ACTIONS(459),
    [sym_char_literal] = ACTIONS(459),
    [anon_sym_true] = ACTIONS(461),
    [anon_sym_false] = ACTIONS(461),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(461),
    [sym_super] = ACTIONS(461),
    [sym_crate] = ACTIONS(461),
    [sym_metavariable] = ACTIONS(459),
    [sym_raw_string_literal] = ACTIONS(459),
    [sym_float_literal] = ACTIONS(459),
    [sym_block_comment] = ACTIONS(3),
  },
  [41] = {
    [ts_builtin_sym_end] = ACTIONS(463),
    [sym_identifier] = ACTIONS(465),
    [anon_sym_SEMI] = ACTIONS(463),
    [anon_sym_macro_rules_BANG] = ACTIONS(463),
    [anon_sym_LPAREN] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(463),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_u8] = ACTIONS(465),
    [anon_sym_i8] = ACTIONS(465),
    [anon_sym_u16] = ACTIONS(465),
    [anon_sym_i16] = ACTIONS(465),
    [anon_sym_u32] = ACTIONS(465),
    [anon_sym_i32] = ACTIONS(465),
    [anon_sym_u64] = ACTIONS(465),
    [anon_sym_i64] = ACTIONS(465),
    [anon_sym_u128] = ACTIONS(465),
    [anon_sym_i128] = ACTIONS(465),
    [anon_sym_isize] = ACTIONS(465),
    [anon_sym_usize] = ACTIONS(465),
    [anon_sym_f32] = ACTIONS(465),
    [anon_sym_f64] = ACTIONS(465),
    [anon_sym_bool] = ACTIONS(465),
    [anon_sym_str] = ACTIONS(465),
    [anon_sym_char] = ACTIONS(465),
    [anon_sym_SQUOTE] = ACTIONS(465),
    [anon_sym_as] = ACTIONS(465),
    [anon_sym_async] = ACTIONS(465),
    [anon_sym_break] = ACTIONS(465),
    [anon_sym_const] = ACTIONS(465),
    [anon_sym_continue] = ACTIONS(465),
    [anon_sym_default] = ACTIONS(465),
    [anon_sym_enum] = ACTIONS(465),
    [anon_sym_fn] = ACTIONS(465),
    [anon_sym_for] = ACTIONS(465),
    [anon_sym_if] = ACTIONS(465),
    [anon_sym_impl] = ACTIONS(465),
    [anon_sym_let] = ACTIONS(465),
    [anon_sym_loop] = ACTIONS(465),
    [anon_sym_match] = ACTIONS(465),
    [anon_sym_mod] = ACTIONS(465),
    [anon_sym_pub] = ACTIONS(465),
    [anon_sym_return] = ACTIONS(465),
    [anon_sym_static] = ACTIONS(465),
    [anon_sym_struct] = ACTIONS(465),
    [anon_sym_trait] = ACTIONS(465),
    [anon_sym_type] = ACTIONS(465),
    [anon_sym_union] = ACTIONS(465),
    [anon_sym_unsafe] = ACTIONS(465),
    [anon_sym_use] = ACTIONS(465),
    [anon_sym_while] = ACTIONS(465),
    [anon_sym_POUND] = ACTIONS(463),
    [anon_sym_BANG] = ACTIONS(465),
    [anon_sym_EQ] = ACTIONS(465),
    [anon_sym_extern] = ACTIONS(465),
    [anon_sym_LT] = ACTIONS(465),
    [anon_sym_GT] = ACTIONS(465),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [anon_sym_DOT_DOT] = ACTIONS(465),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(465),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_CARET] = ACTIONS(465),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(465),
    [anon_sym_GT_GT] = ACTIONS(465),
    [anon_sym_SLASH] = ACTIONS(465),
    [anon_sym_PERCENT] = ACTIONS(465),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_move] = ACTIONS(465),
    [anon_sym_DOT] = ACTIONS(465),
    [sym_integer_literal] = ACTIONS(463),
    [aux_sym_string_literal_token1] = ACTIONS(463),
    [sym_char_literal] = ACTIONS(463),
    [anon_sym_true] = ACTIONS(465),
    [anon_sym_false] = ACTIONS(465),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(465),
    [sym_super] = ACTIONS(465),
    [sym_crate] = ACTIONS(465),
    [sym_metavariable] = ACTIONS(463),
    [sym_raw_string_literal] = ACTIONS(463),
    [sym_float_literal] = ACTIONS(463),
    [sym_block_comment] = ACTIONS(3),
  },
  [42] = {
    [sym_attribute_item] = STATE(60),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1133),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1133),
    [sym_macro_invocation] = STATE(1133),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1133),
    [sym_unary_expression] = STATE(1133),
    [sym_try_expression] = STATE(1133),
    [sym_reference_expression] = STATE(1133),
    [sym_binary_expression] = STATE(1133),
    [sym_assignment_expression] = STATE(1133),
    [sym_compound_assignment_expr] = STATE(1133),
    [sym_type_cast_expression] = STATE(1133),
    [sym_return_expression] = STATE(1133),
    [sym_call_expression] = STATE(1133),
    [sym_array_expression] = STATE(1133),
    [sym_parenthesized_expression] = STATE(1133),
    [sym_tuple_expression] = STATE(1133),
    [sym_unit_expression] = STATE(1133),
    [sym_struct_expression] = STATE(1133),
    [sym_if_expression] = STATE(1133),
    [sym_if_let_expression] = STATE(1133),
    [sym_match_expression] = STATE(1133),
    [sym_while_expression] = STATE(1133),
    [sym_while_let_expression] = STATE(1133),
    [sym_loop_expression] = STATE(1133),
    [sym_for_expression] = STATE(1133),
    [sym_closure_expression] = STATE(1133),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1133),
    [sym_continue_expression] = STATE(1133),
    [sym_index_expression] = STATE(1133),
    [sym_await_expression] = STATE(1133),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1133),
    [sym_async_block] = STATE(1133),
    [sym_block] = STATE(1133),
    [sym__literal] = STATE(1133),
    [sym_string_literal] = STATE(1133),
    [sym_boolean_literal] = STATE(1133),
    [aux_sym_enum_variant_list_repeat1] = STATE(60),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(467),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_POUND] = ACTIONS(405),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(469),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(469),
    [sym_float_literal] = ACTIONS(469),
    [sym_block_comment] = ACTIONS(3),
  },
  [43] = {
    [ts_builtin_sym_end] = ACTIONS(471),
    [sym_identifier] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(471),
    [anon_sym_macro_rules_BANG] = ACTIONS(471),
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_LBRACE] = ACTIONS(471),
    [anon_sym_RBRACE] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_u8] = ACTIONS(473),
    [anon_sym_i8] = ACTIONS(473),
    [anon_sym_u16] = ACTIONS(473),
    [anon_sym_i16] = ACTIONS(473),
    [anon_sym_u32] = ACTIONS(473),
    [anon_sym_i32] = ACTIONS(473),
    [anon_sym_u64] = ACTIONS(473),
    [anon_sym_i64] = ACTIONS(473),
    [anon_sym_u128] = ACTIONS(473),
    [anon_sym_i128] = ACTIONS(473),
    [anon_sym_isize] = ACTIONS(473),
    [anon_sym_usize] = ACTIONS(473),
    [anon_sym_f32] = ACTIONS(473),
    [anon_sym_f64] = ACTIONS(473),
    [anon_sym_bool] = ACTIONS(473),
    [anon_sym_str] = ACTIONS(473),
    [anon_sym_char] = ACTIONS(473),
    [anon_sym_SQUOTE] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(473),
    [anon_sym_async] = ACTIONS(473),
    [anon_sym_break] = ACTIONS(473),
    [anon_sym_const] = ACTIONS(473),
    [anon_sym_continue] = ACTIONS(473),
    [anon_sym_default] = ACTIONS(473),
    [anon_sym_enum] = ACTIONS(473),
    [anon_sym_fn] = ACTIONS(473),
    [anon_sym_for] = ACTIONS(473),
    [anon_sym_if] = ACTIONS(473),
    [anon_sym_impl] = ACTIONS(473),
    [anon_sym_let] = ACTIONS(473),
    [anon_sym_loop] = ACTIONS(473),
    [anon_sym_match] = ACTIONS(473),
    [anon_sym_mod] = ACTIONS(473),
    [anon_sym_pub] = ACTIONS(473),
    [anon_sym_return] = ACTIONS(473),
    [anon_sym_static] = ACTIONS(473),
    [anon_sym_struct] = ACTIONS(473),
    [anon_sym_trait] = ACTIONS(473),
    [anon_sym_type] = ACTIONS(473),
    [anon_sym_union] = ACTIONS(473),
    [anon_sym_unsafe] = ACTIONS(473),
    [anon_sym_use] = ACTIONS(473),
    [anon_sym_while] = ACTIONS(473),
    [anon_sym_POUND] = ACTIONS(471),
    [anon_sym_BANG] = ACTIONS(473),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_extern] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(471),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(471),
    [anon_sym_DOT_DOT] = ACTIONS(473),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(473),
    [anon_sym_GT_GT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(473),
    [anon_sym_PERCENT] = ACTIONS(473),
    [anon_sym_PLUS_EQ] = ACTIONS(471),
    [anon_sym_DASH_EQ] = ACTIONS(471),
    [anon_sym_STAR_EQ] = ACTIONS(471),
    [anon_sym_SLASH_EQ] = ACTIONS(471),
    [anon_sym_PERCENT_EQ] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(471),
    [anon_sym_PIPE_EQ] = ACTIONS(471),
    [anon_sym_CARET_EQ] = ACTIONS(471),
    [anon_sym_LT_LT_EQ] = ACTIONS(471),
    [anon_sym_GT_GT_EQ] = ACTIONS(471),
    [anon_sym_move] = ACTIONS(473),
    [anon_sym_DOT] = ACTIONS(473),
    [sym_integer_literal] = ACTIONS(471),
    [aux_sym_string_literal_token1] = ACTIONS(471),
    [sym_char_literal] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(473),
    [anon_sym_false] = ACTIONS(473),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(473),
    [sym_super] = ACTIONS(473),
    [sym_crate] = ACTIONS(473),
    [sym_metavariable] = ACTIONS(471),
    [sym_raw_string_literal] = ACTIONS(471),
    [sym_float_literal] = ACTIONS(471),
    [sym_block_comment] = ACTIONS(3),
  },
  [44] = {
    [sym_attribute_item] = STATE(60),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1133),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1133),
    [sym_macro_invocation] = STATE(1133),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1133),
    [sym_unary_expression] = STATE(1133),
    [sym_try_expression] = STATE(1133),
    [sym_reference_expression] = STATE(1133),
    [sym_binary_expression] = STATE(1133),
    [sym_assignment_expression] = STATE(1133),
    [sym_compound_assignment_expr] = STATE(1133),
    [sym_type_cast_expression] = STATE(1133),
    [sym_return_expression] = STATE(1133),
    [sym_call_expression] = STATE(1133),
    [sym_array_expression] = STATE(1133),
    [sym_parenthesized_expression] = STATE(1133),
    [sym_tuple_expression] = STATE(1133),
    [sym_unit_expression] = STATE(1133),
    [sym_struct_expression] = STATE(1133),
    [sym_if_expression] = STATE(1133),
    [sym_if_let_expression] = STATE(1133),
    [sym_match_expression] = STATE(1133),
    [sym_while_expression] = STATE(1133),
    [sym_while_let_expression] = STATE(1133),
    [sym_loop_expression] = STATE(1133),
    [sym_for_expression] = STATE(1133),
    [sym_closure_expression] = STATE(1133),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1133),
    [sym_continue_expression] = STATE(1133),
    [sym_index_expression] = STATE(1133),
    [sym_await_expression] = STATE(1133),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1133),
    [sym_async_block] = STATE(1133),
    [sym_block] = STATE(1133),
    [sym__literal] = STATE(1133),
    [sym_string_literal] = STATE(1133),
    [sym_boolean_literal] = STATE(1133),
    [aux_sym_enum_variant_list_repeat1] = STATE(60),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(475),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_POUND] = ACTIONS(405),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(469),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(469),
    [sym_float_literal] = ACTIONS(469),
    [sym_block_comment] = ACTIONS(3),
  },
  [45] = {
    [ts_builtin_sym_end] = ACTIONS(477),
    [sym_identifier] = ACTIONS(479),
    [anon_sym_SEMI] = ACTIONS(477),
    [anon_sym_macro_rules_BANG] = ACTIONS(477),
    [anon_sym_LPAREN] = ACTIONS(477),
    [anon_sym_LBRACE] = ACTIONS(477),
    [anon_sym_RBRACE] = ACTIONS(477),
    [anon_sym_LBRACK] = ACTIONS(477),
    [anon_sym_PLUS] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(479),
    [anon_sym_QMARK] = ACTIONS(483),
    [anon_sym_u8] = ACTIONS(479),
    [anon_sym_i8] = ACTIONS(479),
    [anon_sym_u16] = ACTIONS(479),
    [anon_sym_i16] = ACTIONS(479),
    [anon_sym_u32] = ACTIONS(479),
    [anon_sym_i32] = ACTIONS(479),
    [anon_sym_u64] = ACTIONS(479),
    [anon_sym_i64] = ACTIONS(479),
    [anon_sym_u128] = ACTIONS(479),
    [anon_sym_i128] = ACTIONS(479),
    [anon_sym_isize] = ACTIONS(479),
    [anon_sym_usize] = ACTIONS(479),
    [anon_sym_f32] = ACTIONS(479),
    [anon_sym_f64] = ACTIONS(479),
    [anon_sym_bool] = ACTIONS(479),
    [anon_sym_str] = ACTIONS(479),
    [anon_sym_char] = ACTIONS(479),
    [anon_sym_SQUOTE] = ACTIONS(479),
    [anon_sym_as] = ACTIONS(481),
    [anon_sym_async] = ACTIONS(479),
    [anon_sym_break] = ACTIONS(479),
    [anon_sym_const] = ACTIONS(479),
    [anon_sym_continue] = ACTIONS(479),
    [anon_sym_default] = ACTIONS(479),
    [anon_sym_enum] = ACTIONS(479),
    [anon_sym_fn] = ACTIONS(479),
    [anon_sym_for] = ACTIONS(479),
    [anon_sym_if] = ACTIONS(479),
    [anon_sym_impl] = ACTIONS(479),
    [anon_sym_let] = ACTIONS(479),
    [anon_sym_loop] = ACTIONS(479),
    [anon_sym_match] = ACTIONS(479),
    [anon_sym_mod] = ACTIONS(479),
    [anon_sym_pub] = ACTIONS(479),
    [anon_sym_return] = ACTIONS(479),
    [anon_sym_static] = ACTIONS(479),
    [anon_sym_struct] = ACTIONS(479),
    [anon_sym_trait] = ACTIONS(479),
    [anon_sym_type] = ACTIONS(479),
    [anon_sym_union] = ACTIONS(479),
    [anon_sym_unsafe] = ACTIONS(479),
    [anon_sym_use] = ACTIONS(479),
    [anon_sym_while] = ACTIONS(479),
    [anon_sym_POUND] = ACTIONS(477),
    [anon_sym_BANG] = ACTIONS(479),
    [anon_sym_EQ] = ACTIONS(481),
    [anon_sym_extern] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(479),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_COLON_COLON] = ACTIONS(477),
    [anon_sym_AMP] = ACTIONS(479),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(483),
    [anon_sym_DOT_DOT] = ACTIONS(479),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(483),
    [anon_sym_DASH] = ACTIONS(479),
    [anon_sym_AMP_AMP] = ACTIONS(483),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(479),
    [anon_sym_CARET] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(483),
    [anon_sym_BANG_EQ] = ACTIONS(483),
    [anon_sym_LT_EQ] = ACTIONS(483),
    [anon_sym_GT_EQ] = ACTIONS(483),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_PERCENT] = ACTIONS(481),
    [anon_sym_PLUS_EQ] = ACTIONS(483),
    [anon_sym_DASH_EQ] = ACTIONS(483),
    [anon_sym_STAR_EQ] = ACTIONS(483),
    [anon_sym_SLASH_EQ] = ACTIONS(483),
    [anon_sym_PERCENT_EQ] = ACTIONS(483),
    [anon_sym_AMP_EQ] = ACTIONS(483),
    [anon_sym_PIPE_EQ] = ACTIONS(483),
    [anon_sym_CARET_EQ] = ACTIONS(483),
    [anon_sym_LT_LT_EQ] = ACTIONS(483),
    [anon_sym_GT_GT_EQ] = ACTIONS(483),
    [anon_sym_move] = ACTIONS(479),
    [anon_sym_DOT] = ACTIONS(481),
    [sym_integer_literal] = ACTIONS(477),
    [aux_sym_string_literal_token1] = ACTIONS(477),
    [sym_char_literal] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(479),
    [anon_sym_false] = ACTIONS(479),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(479),
    [sym_super] = ACTIONS(479),
    [sym_crate] = ACTIONS(479),
    [sym_metavariable] = ACTIONS(477),
    [sym_raw_string_literal] = ACTIONS(477),
    [sym_float_literal] = ACTIONS(477),
    [sym_block_comment] = ACTIONS(3),
  },
  [46] = {
    [ts_builtin_sym_end] = ACTIONS(485),
    [sym_identifier] = ACTIONS(487),
    [anon_sym_SEMI] = ACTIONS(485),
    [anon_sym_macro_rules_BANG] = ACTIONS(485),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_LBRACE] = ACTIONS(485),
    [anon_sym_RBRACE] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_STAR] = ACTIONS(487),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_u8] = ACTIONS(487),
    [anon_sym_i8] = ACTIONS(487),
    [anon_sym_u16] = ACTIONS(487),
    [anon_sym_i16] = ACTIONS(487),
    [anon_sym_u32] = ACTIONS(487),
    [anon_sym_i32] = ACTIONS(487),
    [anon_sym_u64] = ACTIONS(487),
    [anon_sym_i64] = ACTIONS(487),
    [anon_sym_u128] = ACTIONS(487),
    [anon_sym_i128] = ACTIONS(487),
    [anon_sym_isize] = ACTIONS(487),
    [anon_sym_usize] = ACTIONS(487),
    [anon_sym_f32] = ACTIONS(487),
    [anon_sym_f64] = ACTIONS(487),
    [anon_sym_bool] = ACTIONS(487),
    [anon_sym_str] = ACTIONS(487),
    [anon_sym_char] = ACTIONS(487),
    [anon_sym_SQUOTE] = ACTIONS(487),
    [anon_sym_as] = ACTIONS(487),
    [anon_sym_async] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(487),
    [anon_sym_const] = ACTIONS(487),
    [anon_sym_continue] = ACTIONS(487),
    [anon_sym_default] = ACTIONS(487),
    [anon_sym_enum] = ACTIONS(487),
    [anon_sym_fn] = ACTIONS(487),
    [anon_sym_for] = ACTIONS(487),
    [anon_sym_if] = ACTIONS(487),
    [anon_sym_impl] = ACTIONS(487),
    [anon_sym_let] = ACTIONS(487),
    [anon_sym_loop] = ACTIONS(487),
    [anon_sym_match] = ACTIONS(487),
    [anon_sym_mod] = ACTIONS(487),
    [anon_sym_pub] = ACTIONS(487),
    [anon_sym_return] = ACTIONS(487),
    [anon_sym_static] = ACTIONS(487),
    [anon_sym_struct] = ACTIONS(487),
    [anon_sym_trait] = ACTIONS(487),
    [anon_sym_type] = ACTIONS(487),
    [anon_sym_union] = ACTIONS(487),
    [anon_sym_unsafe] = ACTIONS(487),
    [anon_sym_use] = ACTIONS(487),
    [anon_sym_while] = ACTIONS(487),
    [anon_sym_POUND] = ACTIONS(485),
    [anon_sym_BANG] = ACTIONS(487),
    [anon_sym_EQ] = ACTIONS(487),
    [anon_sym_extern] = ACTIONS(487),
    [anon_sym_LT] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(487),
    [anon_sym_COLON_COLON] = ACTIONS(485),
    [anon_sym_AMP] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(485),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(487),
    [anon_sym_AMP_AMP] = ACTIONS(485),
    [anon_sym_PIPE_PIPE] = ACTIONS(485),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_CARET] = ACTIONS(487),
    [anon_sym_EQ_EQ] = ACTIONS(485),
    [anon_sym_BANG_EQ] = ACTIONS(485),
    [anon_sym_LT_EQ] = ACTIONS(485),
    [anon_sym_GT_EQ] = ACTIONS(485),
    [anon_sym_LT_LT] = ACTIONS(487),
    [anon_sym_GT_GT] = ACTIONS(487),
    [anon_sym_SLASH] = ACTIONS(487),
    [anon_sym_PERCENT] = ACTIONS(487),
    [anon_sym_PLUS_EQ] = ACTIONS(485),
    [anon_sym_DASH_EQ] = ACTIONS(485),
    [anon_sym_STAR_EQ] = ACTIONS(485),
    [anon_sym_SLASH_EQ] = ACTIONS(485),
    [anon_sym_PERCENT_EQ] = ACTIONS(485),
    [anon_sym_AMP_EQ] = ACTIONS(485),
    [anon_sym_PIPE_EQ] = ACTIONS(485),
    [anon_sym_CARET_EQ] = ACTIONS(485),
    [anon_sym_LT_LT_EQ] = ACTIONS(485),
    [anon_sym_GT_GT_EQ] = ACTIONS(485),
    [anon_sym_move] = ACTIONS(487),
    [anon_sym_DOT] = ACTIONS(487),
    [sym_integer_literal] = ACTIONS(485),
    [aux_sym_string_literal_token1] = ACTIONS(485),
    [sym_char_literal] = ACTIONS(485),
    [anon_sym_true] = ACTIONS(487),
    [anon_sym_false] = ACTIONS(487),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(487),
    [sym_super] = ACTIONS(487),
    [sym_crate] = ACTIONS(487),
    [sym_metavariable] = ACTIONS(485),
    [sym_raw_string_literal] = ACTIONS(485),
    [sym_float_literal] = ACTIONS(485),
    [sym_block_comment] = ACTIONS(3),
  },
  [47] = {
    [ts_builtin_sym_end] = ACTIONS(489),
    [sym_identifier] = ACTIONS(491),
    [anon_sym_SEMI] = ACTIONS(483),
    [anon_sym_macro_rules_BANG] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(489),
    [anon_sym_RBRACE] = ACTIONS(483),
    [anon_sym_LBRACK] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(481),
    [anon_sym_QMARK] = ACTIONS(483),
    [anon_sym_u8] = ACTIONS(491),
    [anon_sym_i8] = ACTIONS(491),
    [anon_sym_u16] = ACTIONS(491),
    [anon_sym_i16] = ACTIONS(491),
    [anon_sym_u32] = ACTIONS(491),
    [anon_sym_i32] = ACTIONS(491),
    [anon_sym_u64] = ACTIONS(491),
    [anon_sym_i64] = ACTIONS(491),
    [anon_sym_u128] = ACTIONS(491),
    [anon_sym_i128] = ACTIONS(491),
    [anon_sym_isize] = ACTIONS(491),
    [anon_sym_usize] = ACTIONS(491),
    [anon_sym_f32] = ACTIONS(491),
    [anon_sym_f64] = ACTIONS(491),
    [anon_sym_bool] = ACTIONS(491),
    [anon_sym_str] = ACTIONS(491),
    [anon_sym_char] = ACTIONS(491),
    [anon_sym_SQUOTE] = ACTIONS(491),
    [anon_sym_as] = ACTIONS(481),
    [anon_sym_async] = ACTIONS(491),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_const] = ACTIONS(491),
    [anon_sym_continue] = ACTIONS(491),
    [anon_sym_default] = ACTIONS(491),
    [anon_sym_enum] = ACTIONS(491),
    [anon_sym_fn] = ACTIONS(491),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_impl] = ACTIONS(491),
    [anon_sym_let] = ACTIONS(491),
    [anon_sym_loop] = ACTIONS(491),
    [anon_sym_match] = ACTIONS(491),
    [anon_sym_mod] = ACTIONS(491),
    [anon_sym_pub] = ACTIONS(491),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_struct] = ACTIONS(491),
    [anon_sym_trait] = ACTIONS(491),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_union] = ACTIONS(491),
    [anon_sym_unsafe] = ACTIONS(491),
    [anon_sym_use] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_POUND] = ACTIONS(489),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(481),
    [anon_sym_extern] = ACTIONS(491),
    [anon_sym_LT] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_COLON_COLON] = ACTIONS(489),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(483),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(483),
    [anon_sym_DASH] = ACTIONS(481),
    [anon_sym_AMP_AMP] = ACTIONS(483),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_CARET] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(483),
    [anon_sym_BANG_EQ] = ACTIONS(483),
    [anon_sym_LT_EQ] = ACTIONS(483),
    [anon_sym_GT_EQ] = ACTIONS(483),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_PERCENT] = ACTIONS(481),
    [anon_sym_PLUS_EQ] = ACTIONS(483),
    [anon_sym_DASH_EQ] = ACTIONS(483),
    [anon_sym_STAR_EQ] = ACTIONS(483),
    [anon_sym_SLASH_EQ] = ACTIONS(483),
    [anon_sym_PERCENT_EQ] = ACTIONS(483),
    [anon_sym_AMP_EQ] = ACTIONS(483),
    [anon_sym_PIPE_EQ] = ACTIONS(483),
    [anon_sym_CARET_EQ] = ACTIONS(483),
    [anon_sym_LT_LT_EQ] = ACTIONS(483),
    [anon_sym_GT_GT_EQ] = ACTIONS(483),
    [anon_sym_move] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(481),
    [sym_integer_literal] = ACTIONS(489),
    [aux_sym_string_literal_token1] = ACTIONS(489),
    [sym_char_literal] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(491),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(489),
    [sym_raw_string_literal] = ACTIONS(489),
    [sym_float_literal] = ACTIONS(489),
    [sym_block_comment] = ACTIONS(3),
  },
  [48] = {
    [ts_builtin_sym_end] = ACTIONS(493),
    [sym_identifier] = ACTIONS(495),
    [anon_sym_SEMI] = ACTIONS(493),
    [anon_sym_macro_rules_BANG] = ACTIONS(493),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACE] = ACTIONS(493),
    [anon_sym_RBRACE] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_QMARK] = ACTIONS(493),
    [anon_sym_u8] = ACTIONS(495),
    [anon_sym_i8] = ACTIONS(495),
    [anon_sym_u16] = ACTIONS(495),
    [anon_sym_i16] = ACTIONS(495),
    [anon_sym_u32] = ACTIONS(495),
    [anon_sym_i32] = ACTIONS(495),
    [anon_sym_u64] = ACTIONS(495),
    [anon_sym_i64] = ACTIONS(495),
    [anon_sym_u128] = ACTIONS(495),
    [anon_sym_i128] = ACTIONS(495),
    [anon_sym_isize] = ACTIONS(495),
    [anon_sym_usize] = ACTIONS(495),
    [anon_sym_f32] = ACTIONS(495),
    [anon_sym_f64] = ACTIONS(495),
    [anon_sym_bool] = ACTIONS(495),
    [anon_sym_str] = ACTIONS(495),
    [anon_sym_char] = ACTIONS(495),
    [anon_sym_SQUOTE] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(495),
    [anon_sym_async] = ACTIONS(495),
    [anon_sym_break] = ACTIONS(495),
    [anon_sym_const] = ACTIONS(495),
    [anon_sym_continue] = ACTIONS(495),
    [anon_sym_default] = ACTIONS(495),
    [anon_sym_enum] = ACTIONS(495),
    [anon_sym_fn] = ACTIONS(495),
    [anon_sym_for] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(495),
    [anon_sym_impl] = ACTIONS(495),
    [anon_sym_let] = ACTIONS(495),
    [anon_sym_loop] = ACTIONS(495),
    [anon_sym_match] = ACTIONS(495),
    [anon_sym_mod] = ACTIONS(495),
    [anon_sym_pub] = ACTIONS(495),
    [anon_sym_return] = ACTIONS(495),
    [anon_sym_static] = ACTIONS(495),
    [anon_sym_struct] = ACTIONS(495),
    [anon_sym_trait] = ACTIONS(495),
    [anon_sym_type] = ACTIONS(495),
    [anon_sym_union] = ACTIONS(495),
    [anon_sym_unsafe] = ACTIONS(495),
    [anon_sym_use] = ACTIONS(495),
    [anon_sym_while] = ACTIONS(495),
    [anon_sym_POUND] = ACTIONS(493),
    [anon_sym_BANG] = ACTIONS(495),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_extern] = ACTIONS(495),
    [anon_sym_LT] = ACTIONS(495),
    [anon_sym_GT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(493),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(493),
    [anon_sym_DOT_DOT] = ACTIONS(495),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(493),
    [anon_sym_PIPE_PIPE] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(495),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(493),
    [anon_sym_GT_EQ] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SLASH] = ACTIONS(495),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(493),
    [anon_sym_DASH_EQ] = ACTIONS(493),
    [anon_sym_STAR_EQ] = ACTIONS(493),
    [anon_sym_SLASH_EQ] = ACTIONS(493),
    [anon_sym_PERCENT_EQ] = ACTIONS(493),
    [anon_sym_AMP_EQ] = ACTIONS(493),
    [anon_sym_PIPE_EQ] = ACTIONS(493),
    [anon_sym_CARET_EQ] = ACTIONS(493),
    [anon_sym_LT_LT_EQ] = ACTIONS(493),
    [anon_sym_GT_GT_EQ] = ACTIONS(493),
    [anon_sym_move] = ACTIONS(495),
    [anon_sym_DOT] = ACTIONS(495),
    [sym_integer_literal] = ACTIONS(493),
    [aux_sym_string_literal_token1] = ACTIONS(493),
    [sym_char_literal] = ACTIONS(493),
    [anon_sym_true] = ACTIONS(495),
    [anon_sym_false] = ACTIONS(495),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(495),
    [sym_super] = ACTIONS(495),
    [sym_crate] = ACTIONS(495),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(493),
    [sym_float_literal] = ACTIONS(493),
    [sym_block_comment] = ACTIONS(3),
  },
  [49] = {
    [ts_builtin_sym_end] = ACTIONS(497),
    [sym_identifier] = ACTIONS(499),
    [anon_sym_SEMI] = ACTIONS(497),
    [anon_sym_macro_rules_BANG] = ACTIONS(497),
    [anon_sym_LPAREN] = ACTIONS(497),
    [anon_sym_LBRACE] = ACTIONS(497),
    [anon_sym_RBRACE] = ACTIONS(497),
    [anon_sym_LBRACK] = ACTIONS(497),
    [anon_sym_PLUS] = ACTIONS(499),
    [anon_sym_STAR] = ACTIONS(499),
    [anon_sym_QMARK] = ACTIONS(497),
    [anon_sym_u8] = ACTIONS(499),
    [anon_sym_i8] = ACTIONS(499),
    [anon_sym_u16] = ACTIONS(499),
    [anon_sym_i16] = ACTIONS(499),
    [anon_sym_u32] = ACTIONS(499),
    [anon_sym_i32] = ACTIONS(499),
    [anon_sym_u64] = ACTIONS(499),
    [anon_sym_i64] = ACTIONS(499),
    [anon_sym_u128] = ACTIONS(499),
    [anon_sym_i128] = ACTIONS(499),
    [anon_sym_isize] = ACTIONS(499),
    [anon_sym_usize] = ACTIONS(499),
    [anon_sym_f32] = ACTIONS(499),
    [anon_sym_f64] = ACTIONS(499),
    [anon_sym_bool] = ACTIONS(499),
    [anon_sym_str] = ACTIONS(499),
    [anon_sym_char] = ACTIONS(499),
    [anon_sym_SQUOTE] = ACTIONS(499),
    [anon_sym_as] = ACTIONS(499),
    [anon_sym_async] = ACTIONS(499),
    [anon_sym_break] = ACTIONS(499),
    [anon_sym_const] = ACTIONS(499),
    [anon_sym_continue] = ACTIONS(499),
    [anon_sym_default] = ACTIONS(499),
    [anon_sym_enum] = ACTIONS(499),
    [anon_sym_fn] = ACTIONS(499),
    [anon_sym_for] = ACTIONS(499),
    [anon_sym_if] = ACTIONS(499),
    [anon_sym_impl] = ACTIONS(499),
    [anon_sym_let] = ACTIONS(499),
    [anon_sym_loop] = ACTIONS(499),
    [anon_sym_match] = ACTIONS(499),
    [anon_sym_mod] = ACTIONS(499),
    [anon_sym_pub] = ACTIONS(499),
    [anon_sym_return] = ACTIONS(499),
    [anon_sym_static] = ACTIONS(499),
    [anon_sym_struct] = ACTIONS(499),
    [anon_sym_trait] = ACTIONS(499),
    [anon_sym_type] = ACTIONS(499),
    [anon_sym_union] = ACTIONS(499),
    [anon_sym_unsafe] = ACTIONS(499),
    [anon_sym_use] = ACTIONS(499),
    [anon_sym_while] = ACTIONS(499),
    [anon_sym_POUND] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_EQ] = ACTIONS(499),
    [anon_sym_extern] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(499),
    [anon_sym_GT] = ACTIONS(499),
    [anon_sym_COLON_COLON] = ACTIONS(497),
    [anon_sym_AMP] = ACTIONS(499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(497),
    [anon_sym_DOT_DOT] = ACTIONS(499),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(497),
    [anon_sym_DASH] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(497),
    [anon_sym_PIPE_PIPE] = ACTIONS(497),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_CARET] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(497),
    [anon_sym_BANG_EQ] = ACTIONS(497),
    [anon_sym_LT_EQ] = ACTIONS(497),
    [anon_sym_GT_EQ] = ACTIONS(497),
    [anon_sym_LT_LT] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(499),
    [anon_sym_SLASH] = ACTIONS(499),
    [anon_sym_PERCENT] = ACTIONS(499),
    [anon_sym_PLUS_EQ] = ACTIONS(497),
    [anon_sym_DASH_EQ] = ACTIONS(497),
    [anon_sym_STAR_EQ] = ACTIONS(497),
    [anon_sym_SLASH_EQ] = ACTIONS(497),
    [anon_sym_PERCENT_EQ] = ACTIONS(497),
    [anon_sym_AMP_EQ] = ACTIONS(497),
    [anon_sym_PIPE_EQ] = ACTIONS(497),
    [anon_sym_CARET_EQ] = ACTIONS(497),
    [anon_sym_LT_LT_EQ] = ACTIONS(497),
    [anon_sym_GT_GT_EQ] = ACTIONS(497),
    [anon_sym_move] = ACTIONS(499),
    [anon_sym_DOT] = ACTIONS(499),
    [sym_integer_literal] = ACTIONS(497),
    [aux_sym_string_literal_token1] = ACTIONS(497),
    [sym_char_literal] = ACTIONS(497),
    [anon_sym_true] = ACTIONS(499),
    [anon_sym_false] = ACTIONS(499),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(499),
    [sym_super] = ACTIONS(499),
    [sym_crate] = ACTIONS(499),
    [sym_metavariable] = ACTIONS(497),
    [sym_raw_string_literal] = ACTIONS(497),
    [sym_float_literal] = ACTIONS(497),
    [sym_block_comment] = ACTIONS(3),
  },
  [50] = {
    [ts_builtin_sym_end] = ACTIONS(501),
    [sym_identifier] = ACTIONS(503),
    [anon_sym_SEMI] = ACTIONS(501),
    [anon_sym_macro_rules_BANG] = ACTIONS(501),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_LBRACE] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(503),
    [anon_sym_STAR] = ACTIONS(503),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_u8] = ACTIONS(503),
    [anon_sym_i8] = ACTIONS(503),
    [anon_sym_u16] = ACTIONS(503),
    [anon_sym_i16] = ACTIONS(503),
    [anon_sym_u32] = ACTIONS(503),
    [anon_sym_i32] = ACTIONS(503),
    [anon_sym_u64] = ACTIONS(503),
    [anon_sym_i64] = ACTIONS(503),
    [anon_sym_u128] = ACTIONS(503),
    [anon_sym_i128] = ACTIONS(503),
    [anon_sym_isize] = ACTIONS(503),
    [anon_sym_usize] = ACTIONS(503),
    [anon_sym_f32] = ACTIONS(503),
    [anon_sym_f64] = ACTIONS(503),
    [anon_sym_bool] = ACTIONS(503),
    [anon_sym_str] = ACTIONS(503),
    [anon_sym_char] = ACTIONS(503),
    [anon_sym_SQUOTE] = ACTIONS(503),
    [anon_sym_as] = ACTIONS(503),
    [anon_sym_async] = ACTIONS(503),
    [anon_sym_break] = ACTIONS(503),
    [anon_sym_const] = ACTIONS(503),
    [anon_sym_continue] = ACTIONS(503),
    [anon_sym_default] = ACTIONS(503),
    [anon_sym_enum] = ACTIONS(503),
    [anon_sym_fn] = ACTIONS(503),
    [anon_sym_for] = ACTIONS(503),
    [anon_sym_if] = ACTIONS(503),
    [anon_sym_impl] = ACTIONS(503),
    [anon_sym_let] = ACTIONS(503),
    [anon_sym_loop] = ACTIONS(503),
    [anon_sym_match] = ACTIONS(503),
    [anon_sym_mod] = ACTIONS(503),
    [anon_sym_pub] = ACTIONS(503),
    [anon_sym_return] = ACTIONS(503),
    [anon_sym_static] = ACTIONS(503),
    [anon_sym_struct] = ACTIONS(503),
    [anon_sym_trait] = ACTIONS(503),
    [anon_sym_type] = ACTIONS(503),
    [anon_sym_union] = ACTIONS(503),
    [anon_sym_unsafe] = ACTIONS(503),
    [anon_sym_use] = ACTIONS(503),
    [anon_sym_while] = ACTIONS(503),
    [anon_sym_POUND] = ACTIONS(501),
    [anon_sym_BANG] = ACTIONS(503),
    [anon_sym_EQ] = ACTIONS(503),
    [anon_sym_extern] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(503),
    [anon_sym_GT] = ACTIONS(503),
    [anon_sym_COLON_COLON] = ACTIONS(501),
    [anon_sym_AMP] = ACTIONS(503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(501),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(503),
    [anon_sym_CARET] = ACTIONS(503),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(501),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_LT_LT] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(503),
    [anon_sym_SLASH] = ACTIONS(503),
    [anon_sym_PERCENT] = ACTIONS(503),
    [anon_sym_PLUS_EQ] = ACTIONS(501),
    [anon_sym_DASH_EQ] = ACTIONS(501),
    [anon_sym_STAR_EQ] = ACTIONS(501),
    [anon_sym_SLASH_EQ] = ACTIONS(501),
    [anon_sym_PERCENT_EQ] = ACTIONS(501),
    [anon_sym_AMP_EQ] = ACTIONS(501),
    [anon_sym_PIPE_EQ] = ACTIONS(501),
    [anon_sym_CARET_EQ] = ACTIONS(501),
    [anon_sym_LT_LT_EQ] = ACTIONS(501),
    [anon_sym_GT_GT_EQ] = ACTIONS(501),
    [anon_sym_move] = ACTIONS(503),
    [anon_sym_DOT] = ACTIONS(503),
    [sym_integer_literal] = ACTIONS(501),
    [aux_sym_string_literal_token1] = ACTIONS(501),
    [sym_char_literal] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(503),
    [anon_sym_false] = ACTIONS(503),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(503),
    [sym_super] = ACTIONS(503),
    [sym_crate] = ACTIONS(503),
    [sym_metavariable] = ACTIONS(501),
    [sym_raw_string_literal] = ACTIONS(501),
    [sym_float_literal] = ACTIONS(501),
    [sym_block_comment] = ACTIONS(3),
  },
  [51] = {
    [sym_attribute_item] = STATE(60),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1133),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1133),
    [sym_macro_invocation] = STATE(1133),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1133),
    [sym_unary_expression] = STATE(1133),
    [sym_try_expression] = STATE(1133),
    [sym_reference_expression] = STATE(1133),
    [sym_binary_expression] = STATE(1133),
    [sym_assignment_expression] = STATE(1133),
    [sym_compound_assignment_expr] = STATE(1133),
    [sym_type_cast_expression] = STATE(1133),
    [sym_return_expression] = STATE(1133),
    [sym_call_expression] = STATE(1133),
    [sym_array_expression] = STATE(1133),
    [sym_parenthesized_expression] = STATE(1133),
    [sym_tuple_expression] = STATE(1133),
    [sym_unit_expression] = STATE(1133),
    [sym_struct_expression] = STATE(1133),
    [sym_if_expression] = STATE(1133),
    [sym_if_let_expression] = STATE(1133),
    [sym_match_expression] = STATE(1133),
    [sym_while_expression] = STATE(1133),
    [sym_while_let_expression] = STATE(1133),
    [sym_loop_expression] = STATE(1133),
    [sym_for_expression] = STATE(1133),
    [sym_closure_expression] = STATE(1133),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1133),
    [sym_continue_expression] = STATE(1133),
    [sym_index_expression] = STATE(1133),
    [sym_await_expression] = STATE(1133),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1133),
    [sym_async_block] = STATE(1133),
    [sym_block] = STATE(1133),
    [sym__literal] = STATE(1133),
    [sym_string_literal] = STATE(1133),
    [sym_boolean_literal] = STATE(1133),
    [aux_sym_enum_variant_list_repeat1] = STATE(60),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(505),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_POUND] = ACTIONS(405),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(469),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(469),
    [sym_float_literal] = ACTIONS(469),
    [sym_block_comment] = ACTIONS(3),
  },
  [52] = {
    [ts_builtin_sym_end] = ACTIONS(507),
    [sym_identifier] = ACTIONS(509),
    [anon_sym_SEMI] = ACTIONS(507),
    [anon_sym_macro_rules_BANG] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(507),
    [anon_sym_LBRACE] = ACTIONS(507),
    [anon_sym_RBRACE] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(509),
    [anon_sym_QMARK] = ACTIONS(507),
    [anon_sym_u8] = ACTIONS(509),
    [anon_sym_i8] = ACTIONS(509),
    [anon_sym_u16] = ACTIONS(509),
    [anon_sym_i16] = ACTIONS(509),
    [anon_sym_u32] = ACTIONS(509),
    [anon_sym_i32] = ACTIONS(509),
    [anon_sym_u64] = ACTIONS(509),
    [anon_sym_i64] = ACTIONS(509),
    [anon_sym_u128] = ACTIONS(509),
    [anon_sym_i128] = ACTIONS(509),
    [anon_sym_isize] = ACTIONS(509),
    [anon_sym_usize] = ACTIONS(509),
    [anon_sym_f32] = ACTIONS(509),
    [anon_sym_f64] = ACTIONS(509),
    [anon_sym_bool] = ACTIONS(509),
    [anon_sym_str] = ACTIONS(509),
    [anon_sym_char] = ACTIONS(509),
    [anon_sym_SQUOTE] = ACTIONS(509),
    [anon_sym_as] = ACTIONS(509),
    [anon_sym_async] = ACTIONS(509),
    [anon_sym_break] = ACTIONS(509),
    [anon_sym_const] = ACTIONS(509),
    [anon_sym_continue] = ACTIONS(509),
    [anon_sym_default] = ACTIONS(509),
    [anon_sym_enum] = ACTIONS(509),
    [anon_sym_fn] = ACTIONS(509),
    [anon_sym_for] = ACTIONS(509),
    [anon_sym_if] = ACTIONS(509),
    [anon_sym_impl] = ACTIONS(509),
    [anon_sym_let] = ACTIONS(509),
    [anon_sym_loop] = ACTIONS(509),
    [anon_sym_match] = ACTIONS(509),
    [anon_sym_mod] = ACTIONS(509),
    [anon_sym_pub] = ACTIONS(509),
    [anon_sym_return] = ACTIONS(509),
    [anon_sym_static] = ACTIONS(509),
    [anon_sym_struct] = ACTIONS(509),
    [anon_sym_trait] = ACTIONS(509),
    [anon_sym_type] = ACTIONS(509),
    [anon_sym_union] = ACTIONS(509),
    [anon_sym_unsafe] = ACTIONS(509),
    [anon_sym_use] = ACTIONS(509),
    [anon_sym_while] = ACTIONS(509),
    [anon_sym_POUND] = ACTIONS(507),
    [anon_sym_BANG] = ACTIONS(509),
    [anon_sym_EQ] = ACTIONS(509),
    [anon_sym_extern] = ACTIONS(509),
    [anon_sym_LT] = ACTIONS(509),
    [anon_sym_GT] = ACTIONS(509),
    [anon_sym_COLON_COLON] = ACTIONS(507),
    [anon_sym_AMP] = ACTIONS(509),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(507),
    [anon_sym_DOT_DOT] = ACTIONS(509),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(507),
    [anon_sym_DASH] = ACTIONS(509),
    [anon_sym_AMP_AMP] = ACTIONS(507),
    [anon_sym_PIPE_PIPE] = ACTIONS(507),
    [anon_sym_PIPE] = ACTIONS(509),
    [anon_sym_CARET] = ACTIONS(509),
    [anon_sym_EQ_EQ] = ACTIONS(507),
    [anon_sym_BANG_EQ] = ACTIONS(507),
    [anon_sym_LT_EQ] = ACTIONS(507),
    [anon_sym_GT_EQ] = ACTIONS(507),
    [anon_sym_LT_LT] = ACTIONS(509),
    [anon_sym_GT_GT] = ACTIONS(509),
    [anon_sym_SLASH] = ACTIONS(509),
    [anon_sym_PERCENT] = ACTIONS(509),
    [anon_sym_PLUS_EQ] = ACTIONS(507),
    [anon_sym_DASH_EQ] = ACTIONS(507),
    [anon_sym_STAR_EQ] = ACTIONS(507),
    [anon_sym_SLASH_EQ] = ACTIONS(507),
    [anon_sym_PERCENT_EQ] = ACTIONS(507),
    [anon_sym_AMP_EQ] = ACTIONS(507),
    [anon_sym_PIPE_EQ] = ACTIONS(507),
    [anon_sym_CARET_EQ] = ACTIONS(507),
    [anon_sym_LT_LT_EQ] = ACTIONS(507),
    [anon_sym_GT_GT_EQ] = ACTIONS(507),
    [anon_sym_move] = ACTIONS(509),
    [anon_sym_DOT] = ACTIONS(509),
    [sym_integer_literal] = ACTIONS(507),
    [aux_sym_string_literal_token1] = ACTIONS(507),
    [sym_char_literal] = ACTIONS(507),
    [anon_sym_true] = ACTIONS(509),
    [anon_sym_false] = ACTIONS(509),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(509),
    [sym_super] = ACTIONS(509),
    [sym_crate] = ACTIONS(509),
    [sym_metavariable] = ACTIONS(507),
    [sym_raw_string_literal] = ACTIONS(507),
    [sym_float_literal] = ACTIONS(507),
    [sym_block_comment] = ACTIONS(3),
  },
  [53] = {
    [ts_builtin_sym_end] = ACTIONS(511),
    [sym_identifier] = ACTIONS(513),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_macro_rules_BANG] = ACTIONS(511),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_LBRACE] = ACTIONS(511),
    [anon_sym_RBRACE] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(511),
    [anon_sym_PLUS] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(513),
    [anon_sym_QMARK] = ACTIONS(511),
    [anon_sym_u8] = ACTIONS(513),
    [anon_sym_i8] = ACTIONS(513),
    [anon_sym_u16] = ACTIONS(513),
    [anon_sym_i16] = ACTIONS(513),
    [anon_sym_u32] = ACTIONS(513),
    [anon_sym_i32] = ACTIONS(513),
    [anon_sym_u64] = ACTIONS(513),
    [anon_sym_i64] = ACTIONS(513),
    [anon_sym_u128] = ACTIONS(513),
    [anon_sym_i128] = ACTIONS(513),
    [anon_sym_isize] = ACTIONS(513),
    [anon_sym_usize] = ACTIONS(513),
    [anon_sym_f32] = ACTIONS(513),
    [anon_sym_f64] = ACTIONS(513),
    [anon_sym_bool] = ACTIONS(513),
    [anon_sym_str] = ACTIONS(513),
    [anon_sym_char] = ACTIONS(513),
    [anon_sym_SQUOTE] = ACTIONS(513),
    [anon_sym_as] = ACTIONS(513),
    [anon_sym_async] = ACTIONS(513),
    [anon_sym_break] = ACTIONS(513),
    [anon_sym_const] = ACTIONS(513),
    [anon_sym_continue] = ACTIONS(513),
    [anon_sym_default] = ACTIONS(513),
    [anon_sym_enum] = ACTIONS(513),
    [anon_sym_fn] = ACTIONS(513),
    [anon_sym_for] = ACTIONS(513),
    [anon_sym_if] = ACTIONS(513),
    [anon_sym_impl] = ACTIONS(513),
    [anon_sym_let] = ACTIONS(513),
    [anon_sym_loop] = ACTIONS(513),
    [anon_sym_match] = ACTIONS(513),
    [anon_sym_mod] = ACTIONS(513),
    [anon_sym_pub] = ACTIONS(513),
    [anon_sym_return] = ACTIONS(513),
    [anon_sym_static] = ACTIONS(513),
    [anon_sym_struct] = ACTIONS(513),
    [anon_sym_trait] = ACTIONS(513),
    [anon_sym_type] = ACTIONS(513),
    [anon_sym_union] = ACTIONS(513),
    [anon_sym_unsafe] = ACTIONS(513),
    [anon_sym_use] = ACTIONS(513),
    [anon_sym_while] = ACTIONS(513),
    [anon_sym_POUND] = ACTIONS(511),
    [anon_sym_BANG] = ACTIONS(513),
    [anon_sym_EQ] = ACTIONS(513),
    [anon_sym_extern] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_COLON_COLON] = ACTIONS(511),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(511),
    [anon_sym_DOT_DOT] = ACTIONS(513),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(511),
    [anon_sym_DASH] = ACTIONS(513),
    [anon_sym_AMP_AMP] = ACTIONS(511),
    [anon_sym_PIPE_PIPE] = ACTIONS(511),
    [anon_sym_PIPE] = ACTIONS(513),
    [anon_sym_CARET] = ACTIONS(513),
    [anon_sym_EQ_EQ] = ACTIONS(511),
    [anon_sym_BANG_EQ] = ACTIONS(511),
    [anon_sym_LT_EQ] = ACTIONS(511),
    [anon_sym_GT_EQ] = ACTIONS(511),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_GT_GT] = ACTIONS(513),
    [anon_sym_SLASH] = ACTIONS(513),
    [anon_sym_PERCENT] = ACTIONS(513),
    [anon_sym_PLUS_EQ] = ACTIONS(511),
    [anon_sym_DASH_EQ] = ACTIONS(511),
    [anon_sym_STAR_EQ] = ACTIONS(511),
    [anon_sym_SLASH_EQ] = ACTIONS(511),
    [anon_sym_PERCENT_EQ] = ACTIONS(511),
    [anon_sym_AMP_EQ] = ACTIONS(511),
    [anon_sym_PIPE_EQ] = ACTIONS(511),
    [anon_sym_CARET_EQ] = ACTIONS(511),
    [anon_sym_LT_LT_EQ] = ACTIONS(511),
    [anon_sym_GT_GT_EQ] = ACTIONS(511),
    [anon_sym_move] = ACTIONS(513),
    [anon_sym_DOT] = ACTIONS(513),
    [sym_integer_literal] = ACTIONS(511),
    [aux_sym_string_literal_token1] = ACTIONS(511),
    [sym_char_literal] = ACTIONS(511),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(513),
    [sym_super] = ACTIONS(513),
    [sym_crate] = ACTIONS(513),
    [sym_metavariable] = ACTIONS(511),
    [sym_raw_string_literal] = ACTIONS(511),
    [sym_float_literal] = ACTIONS(511),
    [sym_block_comment] = ACTIONS(3),
  },
  [54] = {
    [ts_builtin_sym_end] = ACTIONS(515),
    [sym_identifier] = ACTIONS(517),
    [anon_sym_SEMI] = ACTIONS(515),
    [anon_sym_macro_rules_BANG] = ACTIONS(515),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_LBRACE] = ACTIONS(515),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_LBRACK] = ACTIONS(515),
    [anon_sym_PLUS] = ACTIONS(517),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_QMARK] = ACTIONS(515),
    [anon_sym_u8] = ACTIONS(517),
    [anon_sym_i8] = ACTIONS(517),
    [anon_sym_u16] = ACTIONS(517),
    [anon_sym_i16] = ACTIONS(517),
    [anon_sym_u32] = ACTIONS(517),
    [anon_sym_i32] = ACTIONS(517),
    [anon_sym_u64] = ACTIONS(517),
    [anon_sym_i64] = ACTIONS(517),
    [anon_sym_u128] = ACTIONS(517),
    [anon_sym_i128] = ACTIONS(517),
    [anon_sym_isize] = ACTIONS(517),
    [anon_sym_usize] = ACTIONS(517),
    [anon_sym_f32] = ACTIONS(517),
    [anon_sym_f64] = ACTIONS(517),
    [anon_sym_bool] = ACTIONS(517),
    [anon_sym_str] = ACTIONS(517),
    [anon_sym_char] = ACTIONS(517),
    [anon_sym_SQUOTE] = ACTIONS(517),
    [anon_sym_as] = ACTIONS(517),
    [anon_sym_async] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(517),
    [anon_sym_const] = ACTIONS(517),
    [anon_sym_continue] = ACTIONS(517),
    [anon_sym_default] = ACTIONS(517),
    [anon_sym_enum] = ACTIONS(517),
    [anon_sym_fn] = ACTIONS(517),
    [anon_sym_for] = ACTIONS(517),
    [anon_sym_if] = ACTIONS(517),
    [anon_sym_impl] = ACTIONS(517),
    [anon_sym_let] = ACTIONS(517),
    [anon_sym_loop] = ACTIONS(517),
    [anon_sym_match] = ACTIONS(517),
    [anon_sym_mod] = ACTIONS(517),
    [anon_sym_pub] = ACTIONS(517),
    [anon_sym_return] = ACTIONS(517),
    [anon_sym_static] = ACTIONS(517),
    [anon_sym_struct] = ACTIONS(517),
    [anon_sym_trait] = ACTIONS(517),
    [anon_sym_type] = ACTIONS(517),
    [anon_sym_union] = ACTIONS(517),
    [anon_sym_unsafe] = ACTIONS(517),
    [anon_sym_use] = ACTIONS(517),
    [anon_sym_while] = ACTIONS(517),
    [anon_sym_POUND] = ACTIONS(515),
    [anon_sym_BANG] = ACTIONS(517),
    [anon_sym_EQ] = ACTIONS(517),
    [anon_sym_extern] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(517),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(515),
    [anon_sym_DOT_DOT] = ACTIONS(517),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_AMP_AMP] = ACTIONS(515),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_PIPE] = ACTIONS(517),
    [anon_sym_CARET] = ACTIONS(517),
    [anon_sym_EQ_EQ] = ACTIONS(515),
    [anon_sym_BANG_EQ] = ACTIONS(515),
    [anon_sym_LT_EQ] = ACTIONS(515),
    [anon_sym_GT_EQ] = ACTIONS(515),
    [anon_sym_LT_LT] = ACTIONS(517),
    [anon_sym_GT_GT] = ACTIONS(517),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(515),
    [anon_sym_DASH_EQ] = ACTIONS(515),
    [anon_sym_STAR_EQ] = ACTIONS(515),
    [anon_sym_SLASH_EQ] = ACTIONS(515),
    [anon_sym_PERCENT_EQ] = ACTIONS(515),
    [anon_sym_AMP_EQ] = ACTIONS(515),
    [anon_sym_PIPE_EQ] = ACTIONS(515),
    [anon_sym_CARET_EQ] = ACTIONS(515),
    [anon_sym_LT_LT_EQ] = ACTIONS(515),
    [anon_sym_GT_GT_EQ] = ACTIONS(515),
    [anon_sym_move] = ACTIONS(517),
    [anon_sym_DOT] = ACTIONS(517),
    [sym_integer_literal] = ACTIONS(515),
    [aux_sym_string_literal_token1] = ACTIONS(515),
    [sym_char_literal] = ACTIONS(515),
    [anon_sym_true] = ACTIONS(517),
    [anon_sym_false] = ACTIONS(517),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(517),
    [sym_super] = ACTIONS(517),
    [sym_crate] = ACTIONS(517),
    [sym_metavariable] = ACTIONS(515),
    [sym_raw_string_literal] = ACTIONS(515),
    [sym_float_literal] = ACTIONS(515),
    [sym_block_comment] = ACTIONS(3),
  },
  [55] = {
    [ts_builtin_sym_end] = ACTIONS(519),
    [sym_identifier] = ACTIONS(521),
    [anon_sym_SEMI] = ACTIONS(519),
    [anon_sym_macro_rules_BANG] = ACTIONS(519),
    [anon_sym_LPAREN] = ACTIONS(519),
    [anon_sym_LBRACE] = ACTIONS(519),
    [anon_sym_RBRACE] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(519),
    [anon_sym_u8] = ACTIONS(521),
    [anon_sym_i8] = ACTIONS(521),
    [anon_sym_u16] = ACTIONS(521),
    [anon_sym_i16] = ACTIONS(521),
    [anon_sym_u32] = ACTIONS(521),
    [anon_sym_i32] = ACTIONS(521),
    [anon_sym_u64] = ACTIONS(521),
    [anon_sym_i64] = ACTIONS(521),
    [anon_sym_u128] = ACTIONS(521),
    [anon_sym_i128] = ACTIONS(521),
    [anon_sym_isize] = ACTIONS(521),
    [anon_sym_usize] = ACTIONS(521),
    [anon_sym_f32] = ACTIONS(521),
    [anon_sym_f64] = ACTIONS(521),
    [anon_sym_bool] = ACTIONS(521),
    [anon_sym_str] = ACTIONS(521),
    [anon_sym_char] = ACTIONS(521),
    [anon_sym_SQUOTE] = ACTIONS(521),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_async] = ACTIONS(521),
    [anon_sym_break] = ACTIONS(521),
    [anon_sym_const] = ACTIONS(521),
    [anon_sym_continue] = ACTIONS(521),
    [anon_sym_default] = ACTIONS(521),
    [anon_sym_enum] = ACTIONS(521),
    [anon_sym_fn] = ACTIONS(521),
    [anon_sym_for] = ACTIONS(521),
    [anon_sym_if] = ACTIONS(521),
    [anon_sym_impl] = ACTIONS(521),
    [anon_sym_let] = ACTIONS(521),
    [anon_sym_loop] = ACTIONS(521),
    [anon_sym_match] = ACTIONS(521),
    [anon_sym_mod] = ACTIONS(521),
    [anon_sym_pub] = ACTIONS(521),
    [anon_sym_return] = ACTIONS(521),
    [anon_sym_static] = ACTIONS(521),
    [anon_sym_struct] = ACTIONS(521),
    [anon_sym_trait] = ACTIONS(521),
    [anon_sym_type] = ACTIONS(521),
    [anon_sym_union] = ACTIONS(521),
    [anon_sym_unsafe] = ACTIONS(521),
    [anon_sym_use] = ACTIONS(521),
    [anon_sym_while] = ACTIONS(521),
    [anon_sym_POUND] = ACTIONS(519),
    [anon_sym_BANG] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(521),
    [anon_sym_extern] = ACTIONS(521),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_COLON_COLON] = ACTIONS(519),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(519),
    [anon_sym_DOT_DOT] = ACTIONS(521),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(519),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_AMP_AMP] = ACTIONS(519),
    [anon_sym_PIPE_PIPE] = ACTIONS(519),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(519),
    [anon_sym_BANG_EQ] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(519),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(519),
    [anon_sym_DASH_EQ] = ACTIONS(519),
    [anon_sym_STAR_EQ] = ACTIONS(519),
    [anon_sym_SLASH_EQ] = ACTIONS(519),
    [anon_sym_PERCENT_EQ] = ACTIONS(519),
    [anon_sym_AMP_EQ] = ACTIONS(519),
    [anon_sym_PIPE_EQ] = ACTIONS(519),
    [anon_sym_CARET_EQ] = ACTIONS(519),
    [anon_sym_LT_LT_EQ] = ACTIONS(519),
    [anon_sym_GT_GT_EQ] = ACTIONS(519),
    [anon_sym_move] = ACTIONS(521),
    [anon_sym_DOT] = ACTIONS(521),
    [sym_integer_literal] = ACTIONS(519),
    [aux_sym_string_literal_token1] = ACTIONS(519),
    [sym_char_literal] = ACTIONS(519),
    [anon_sym_true] = ACTIONS(521),
    [anon_sym_false] = ACTIONS(521),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(521),
    [sym_super] = ACTIONS(521),
    [sym_crate] = ACTIONS(521),
    [sym_metavariable] = ACTIONS(519),
    [sym_raw_string_literal] = ACTIONS(519),
    [sym_float_literal] = ACTIONS(519),
    [sym_block_comment] = ACTIONS(3),
  },
  [56] = {
    [ts_builtin_sym_end] = ACTIONS(523),
    [sym_identifier] = ACTIONS(525),
    [anon_sym_SEMI] = ACTIONS(523),
    [anon_sym_macro_rules_BANG] = ACTIONS(523),
    [anon_sym_LPAREN] = ACTIONS(523),
    [anon_sym_LBRACE] = ACTIONS(523),
    [anon_sym_RBRACE] = ACTIONS(523),
    [anon_sym_LBRACK] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(525),
    [anon_sym_STAR] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(523),
    [anon_sym_u8] = ACTIONS(525),
    [anon_sym_i8] = ACTIONS(525),
    [anon_sym_u16] = ACTIONS(525),
    [anon_sym_i16] = ACTIONS(525),
    [anon_sym_u32] = ACTIONS(525),
    [anon_sym_i32] = ACTIONS(525),
    [anon_sym_u64] = ACTIONS(525),
    [anon_sym_i64] = ACTIONS(525),
    [anon_sym_u128] = ACTIONS(525),
    [anon_sym_i128] = ACTIONS(525),
    [anon_sym_isize] = ACTIONS(525),
    [anon_sym_usize] = ACTIONS(525),
    [anon_sym_f32] = ACTIONS(525),
    [anon_sym_f64] = ACTIONS(525),
    [anon_sym_bool] = ACTIONS(525),
    [anon_sym_str] = ACTIONS(525),
    [anon_sym_char] = ACTIONS(525),
    [anon_sym_SQUOTE] = ACTIONS(525),
    [anon_sym_as] = ACTIONS(525),
    [anon_sym_async] = ACTIONS(525),
    [anon_sym_break] = ACTIONS(525),
    [anon_sym_const] = ACTIONS(525),
    [anon_sym_continue] = ACTIONS(525),
    [anon_sym_default] = ACTIONS(525),
    [anon_sym_enum] = ACTIONS(525),
    [anon_sym_fn] = ACTIONS(525),
    [anon_sym_for] = ACTIONS(525),
    [anon_sym_if] = ACTIONS(525),
    [anon_sym_impl] = ACTIONS(525),
    [anon_sym_let] = ACTIONS(525),
    [anon_sym_loop] = ACTIONS(525),
    [anon_sym_match] = ACTIONS(525),
    [anon_sym_mod] = ACTIONS(525),
    [anon_sym_pub] = ACTIONS(525),
    [anon_sym_return] = ACTIONS(525),
    [anon_sym_static] = ACTIONS(525),
    [anon_sym_struct] = ACTIONS(525),
    [anon_sym_trait] = ACTIONS(525),
    [anon_sym_type] = ACTIONS(525),
    [anon_sym_union] = ACTIONS(525),
    [anon_sym_unsafe] = ACTIONS(525),
    [anon_sym_use] = ACTIONS(525),
    [anon_sym_while] = ACTIONS(525),
    [anon_sym_POUND] = ACTIONS(523),
    [anon_sym_BANG] = ACTIONS(525),
    [anon_sym_EQ] = ACTIONS(525),
    [anon_sym_extern] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(525),
    [anon_sym_GT] = ACTIONS(525),
    [anon_sym_COLON_COLON] = ACTIONS(523),
    [anon_sym_AMP] = ACTIONS(525),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(523),
    [anon_sym_DOT_DOT] = ACTIONS(525),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(523),
    [anon_sym_DASH] = ACTIONS(525),
    [anon_sym_AMP_AMP] = ACTIONS(523),
    [anon_sym_PIPE_PIPE] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(525),
    [anon_sym_CARET] = ACTIONS(525),
    [anon_sym_EQ_EQ] = ACTIONS(523),
    [anon_sym_BANG_EQ] = ACTIONS(523),
    [anon_sym_LT_EQ] = ACTIONS(523),
    [anon_sym_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT] = ACTIONS(525),
    [anon_sym_GT_GT] = ACTIONS(525),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_PERCENT] = ACTIONS(525),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_move] = ACTIONS(525),
    [anon_sym_DOT] = ACTIONS(525),
    [sym_integer_literal] = ACTIONS(523),
    [aux_sym_string_literal_token1] = ACTIONS(523),
    [sym_char_literal] = ACTIONS(523),
    [anon_sym_true] = ACTIONS(525),
    [anon_sym_false] = ACTIONS(525),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(525),
    [sym_super] = ACTIONS(525),
    [sym_crate] = ACTIONS(525),
    [sym_metavariable] = ACTIONS(523),
    [sym_raw_string_literal] = ACTIONS(523),
    [sym_float_literal] = ACTIONS(523),
    [sym_block_comment] = ACTIONS(3),
  },
  [57] = {
    [ts_builtin_sym_end] = ACTIONS(527),
    [sym_identifier] = ACTIONS(529),
    [anon_sym_SEMI] = ACTIONS(527),
    [anon_sym_macro_rules_BANG] = ACTIONS(527),
    [anon_sym_LPAREN] = ACTIONS(527),
    [anon_sym_LBRACE] = ACTIONS(527),
    [anon_sym_RBRACE] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_STAR] = ACTIONS(529),
    [anon_sym_QMARK] = ACTIONS(527),
    [anon_sym_u8] = ACTIONS(529),
    [anon_sym_i8] = ACTIONS(529),
    [anon_sym_u16] = ACTIONS(529),
    [anon_sym_i16] = ACTIONS(529),
    [anon_sym_u32] = ACTIONS(529),
    [anon_sym_i32] = ACTIONS(529),
    [anon_sym_u64] = ACTIONS(529),
    [anon_sym_i64] = ACTIONS(529),
    [anon_sym_u128] = ACTIONS(529),
    [anon_sym_i128] = ACTIONS(529),
    [anon_sym_isize] = ACTIONS(529),
    [anon_sym_usize] = ACTIONS(529),
    [anon_sym_f32] = ACTIONS(529),
    [anon_sym_f64] = ACTIONS(529),
    [anon_sym_bool] = ACTIONS(529),
    [anon_sym_str] = ACTIONS(529),
    [anon_sym_char] = ACTIONS(529),
    [anon_sym_SQUOTE] = ACTIONS(529),
    [anon_sym_as] = ACTIONS(529),
    [anon_sym_async] = ACTIONS(529),
    [anon_sym_break] = ACTIONS(529),
    [anon_sym_const] = ACTIONS(529),
    [anon_sym_continue] = ACTIONS(529),
    [anon_sym_default] = ACTIONS(529),
    [anon_sym_enum] = ACTIONS(529),
    [anon_sym_fn] = ACTIONS(529),
    [anon_sym_for] = ACTIONS(529),
    [anon_sym_if] = ACTIONS(529),
    [anon_sym_impl] = ACTIONS(529),
    [anon_sym_let] = ACTIONS(529),
    [anon_sym_loop] = ACTIONS(529),
    [anon_sym_match] = ACTIONS(529),
    [anon_sym_mod] = ACTIONS(529),
    [anon_sym_pub] = ACTIONS(529),
    [anon_sym_return] = ACTIONS(529),
    [anon_sym_static] = ACTIONS(529),
    [anon_sym_struct] = ACTIONS(529),
    [anon_sym_trait] = ACTIONS(529),
    [anon_sym_type] = ACTIONS(529),
    [anon_sym_union] = ACTIONS(529),
    [anon_sym_unsafe] = ACTIONS(529),
    [anon_sym_use] = ACTIONS(529),
    [anon_sym_while] = ACTIONS(529),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_BANG] = ACTIONS(529),
    [anon_sym_EQ] = ACTIONS(529),
    [anon_sym_extern] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(529),
    [anon_sym_GT] = ACTIONS(529),
    [anon_sym_COLON_COLON] = ACTIONS(527),
    [anon_sym_AMP] = ACTIONS(529),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(527),
    [anon_sym_DOT_DOT] = ACTIONS(529),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(527),
    [anon_sym_DASH] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(527),
    [anon_sym_PIPE_PIPE] = ACTIONS(527),
    [anon_sym_PIPE] = ACTIONS(529),
    [anon_sym_CARET] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(527),
    [anon_sym_BANG_EQ] = ACTIONS(527),
    [anon_sym_LT_EQ] = ACTIONS(527),
    [anon_sym_GT_EQ] = ACTIONS(527),
    [anon_sym_LT_LT] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(529),
    [anon_sym_PERCENT] = ACTIONS(529),
    [anon_sym_PLUS_EQ] = ACTIONS(527),
    [anon_sym_DASH_EQ] = ACTIONS(527),
    [anon_sym_STAR_EQ] = ACTIONS(527),
    [anon_sym_SLASH_EQ] = ACTIONS(527),
    [anon_sym_PERCENT_EQ] = ACTIONS(527),
    [anon_sym_AMP_EQ] = ACTIONS(527),
    [anon_sym_PIPE_EQ] = ACTIONS(527),
    [anon_sym_CARET_EQ] = ACTIONS(527),
    [anon_sym_LT_LT_EQ] = ACTIONS(527),
    [anon_sym_GT_GT_EQ] = ACTIONS(527),
    [anon_sym_move] = ACTIONS(529),
    [anon_sym_DOT] = ACTIONS(529),
    [sym_integer_literal] = ACTIONS(527),
    [aux_sym_string_literal_token1] = ACTIONS(527),
    [sym_char_literal] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_false] = ACTIONS(529),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(529),
    [sym_super] = ACTIONS(529),
    [sym_crate] = ACTIONS(529),
    [sym_metavariable] = ACTIONS(527),
    [sym_raw_string_literal] = ACTIONS(527),
    [sym_float_literal] = ACTIONS(527),
    [sym_block_comment] = ACTIONS(3),
  },
  [58] = {
    [ts_builtin_sym_end] = ACTIONS(531),
    [sym_identifier] = ACTIONS(533),
    [anon_sym_SEMI] = ACTIONS(531),
    [anon_sym_macro_rules_BANG] = ACTIONS(531),
    [anon_sym_LPAREN] = ACTIONS(531),
    [anon_sym_LBRACE] = ACTIONS(531),
    [anon_sym_RBRACE] = ACTIONS(531),
    [anon_sym_LBRACK] = ACTIONS(531),
    [anon_sym_PLUS] = ACTIONS(533),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_QMARK] = ACTIONS(531),
    [anon_sym_u8] = ACTIONS(533),
    [anon_sym_i8] = ACTIONS(533),
    [anon_sym_u16] = ACTIONS(533),
    [anon_sym_i16] = ACTIONS(533),
    [anon_sym_u32] = ACTIONS(533),
    [anon_sym_i32] = ACTIONS(533),
    [anon_sym_u64] = ACTIONS(533),
    [anon_sym_i64] = ACTIONS(533),
    [anon_sym_u128] = ACTIONS(533),
    [anon_sym_i128] = ACTIONS(533),
    [anon_sym_isize] = ACTIONS(533),
    [anon_sym_usize] = ACTIONS(533),
    [anon_sym_f32] = ACTIONS(533),
    [anon_sym_f64] = ACTIONS(533),
    [anon_sym_bool] = ACTIONS(533),
    [anon_sym_str] = ACTIONS(533),
    [anon_sym_char] = ACTIONS(533),
    [anon_sym_SQUOTE] = ACTIONS(533),
    [anon_sym_as] = ACTIONS(533),
    [anon_sym_async] = ACTIONS(533),
    [anon_sym_break] = ACTIONS(533),
    [anon_sym_const] = ACTIONS(533),
    [anon_sym_continue] = ACTIONS(533),
    [anon_sym_default] = ACTIONS(533),
    [anon_sym_enum] = ACTIONS(533),
    [anon_sym_fn] = ACTIONS(533),
    [anon_sym_for] = ACTIONS(533),
    [anon_sym_if] = ACTIONS(533),
    [anon_sym_impl] = ACTIONS(533),
    [anon_sym_let] = ACTIONS(533),
    [anon_sym_loop] = ACTIONS(533),
    [anon_sym_match] = ACTIONS(533),
    [anon_sym_mod] = ACTIONS(533),
    [anon_sym_pub] = ACTIONS(533),
    [anon_sym_return] = ACTIONS(533),
    [anon_sym_static] = ACTIONS(533),
    [anon_sym_struct] = ACTIONS(533),
    [anon_sym_trait] = ACTIONS(533),
    [anon_sym_type] = ACTIONS(533),
    [anon_sym_union] = ACTIONS(533),
    [anon_sym_unsafe] = ACTIONS(533),
    [anon_sym_use] = ACTIONS(533),
    [anon_sym_while] = ACTIONS(533),
    [anon_sym_POUND] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_extern] = ACTIONS(533),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_COLON_COLON] = ACTIONS(531),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(531),
    [anon_sym_DOT_DOT] = ACTIONS(533),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(531),
    [anon_sym_DASH] = ACTIONS(533),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_CARET] = ACTIONS(533),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_LT_LT] = ACTIONS(533),
    [anon_sym_GT_GT] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(533),
    [anon_sym_PERCENT] = ACTIONS(533),
    [anon_sym_PLUS_EQ] = ACTIONS(531),
    [anon_sym_DASH_EQ] = ACTIONS(531),
    [anon_sym_STAR_EQ] = ACTIONS(531),
    [anon_sym_SLASH_EQ] = ACTIONS(531),
    [anon_sym_PERCENT_EQ] = ACTIONS(531),
    [anon_sym_AMP_EQ] = ACTIONS(531),
    [anon_sym_PIPE_EQ] = ACTIONS(531),
    [anon_sym_CARET_EQ] = ACTIONS(531),
    [anon_sym_LT_LT_EQ] = ACTIONS(531),
    [anon_sym_GT_GT_EQ] = ACTIONS(531),
    [anon_sym_move] = ACTIONS(533),
    [anon_sym_DOT] = ACTIONS(533),
    [sym_integer_literal] = ACTIONS(531),
    [aux_sym_string_literal_token1] = ACTIONS(531),
    [sym_char_literal] = ACTIONS(531),
    [anon_sym_true] = ACTIONS(533),
    [anon_sym_false] = ACTIONS(533),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(533),
    [sym_super] = ACTIONS(533),
    [sym_crate] = ACTIONS(533),
    [sym_metavariable] = ACTIONS(531),
    [sym_raw_string_literal] = ACTIONS(531),
    [sym_float_literal] = ACTIONS(531),
    [sym_block_comment] = ACTIONS(3),
  },
  [59] = {
    [ts_builtin_sym_end] = ACTIONS(535),
    [sym_identifier] = ACTIONS(537),
    [anon_sym_SEMI] = ACTIONS(535),
    [anon_sym_macro_rules_BANG] = ACTIONS(535),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_LBRACE] = ACTIONS(535),
    [anon_sym_RBRACE] = ACTIONS(535),
    [anon_sym_LBRACK] = ACTIONS(535),
    [anon_sym_PLUS] = ACTIONS(537),
    [anon_sym_STAR] = ACTIONS(537),
    [anon_sym_QMARK] = ACTIONS(535),
    [anon_sym_u8] = ACTIONS(537),
    [anon_sym_i8] = ACTIONS(537),
    [anon_sym_u16] = ACTIONS(537),
    [anon_sym_i16] = ACTIONS(537),
    [anon_sym_u32] = ACTIONS(537),
    [anon_sym_i32] = ACTIONS(537),
    [anon_sym_u64] = ACTIONS(537),
    [anon_sym_i64] = ACTIONS(537),
    [anon_sym_u128] = ACTIONS(537),
    [anon_sym_i128] = ACTIONS(537),
    [anon_sym_isize] = ACTIONS(537),
    [anon_sym_usize] = ACTIONS(537),
    [anon_sym_f32] = ACTIONS(537),
    [anon_sym_f64] = ACTIONS(537),
    [anon_sym_bool] = ACTIONS(537),
    [anon_sym_str] = ACTIONS(537),
    [anon_sym_char] = ACTIONS(537),
    [anon_sym_SQUOTE] = ACTIONS(537),
    [anon_sym_as] = ACTIONS(537),
    [anon_sym_async] = ACTIONS(537),
    [anon_sym_break] = ACTIONS(537),
    [anon_sym_const] = ACTIONS(537),
    [anon_sym_continue] = ACTIONS(537),
    [anon_sym_default] = ACTIONS(537),
    [anon_sym_enum] = ACTIONS(537),
    [anon_sym_fn] = ACTIONS(537),
    [anon_sym_for] = ACTIONS(537),
    [anon_sym_if] = ACTIONS(537),
    [anon_sym_impl] = ACTIONS(537),
    [anon_sym_let] = ACTIONS(537),
    [anon_sym_loop] = ACTIONS(537),
    [anon_sym_match] = ACTIONS(537),
    [anon_sym_mod] = ACTIONS(537),
    [anon_sym_pub] = ACTIONS(537),
    [anon_sym_return] = ACTIONS(537),
    [anon_sym_static] = ACTIONS(537),
    [anon_sym_struct] = ACTIONS(537),
    [anon_sym_trait] = ACTIONS(537),
    [anon_sym_type] = ACTIONS(537),
    [anon_sym_union] = ACTIONS(537),
    [anon_sym_unsafe] = ACTIONS(537),
    [anon_sym_use] = ACTIONS(537),
    [anon_sym_while] = ACTIONS(537),
    [anon_sym_POUND] = ACTIONS(535),
    [anon_sym_BANG] = ACTIONS(537),
    [anon_sym_EQ] = ACTIONS(537),
    [anon_sym_extern] = ACTIONS(537),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_GT] = ACTIONS(537),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym_AMP] = ACTIONS(537),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(535),
    [anon_sym_DOT_DOT] = ACTIONS(537),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(535),
    [anon_sym_DASH] = ACTIONS(537),
    [anon_sym_AMP_AMP] = ACTIONS(535),
    [anon_sym_PIPE_PIPE] = ACTIONS(535),
    [anon_sym_PIPE] = ACTIONS(537),
    [anon_sym_CARET] = ACTIONS(537),
    [anon_sym_EQ_EQ] = ACTIONS(535),
    [anon_sym_BANG_EQ] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(535),
    [anon_sym_GT_EQ] = ACTIONS(535),
    [anon_sym_LT_LT] = ACTIONS(537),
    [anon_sym_GT_GT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(537),
    [anon_sym_PERCENT] = ACTIONS(537),
    [anon_sym_PLUS_EQ] = ACTIONS(535),
    [anon_sym_DASH_EQ] = ACTIONS(535),
    [anon_sym_STAR_EQ] = ACTIONS(535),
    [anon_sym_SLASH_EQ] = ACTIONS(535),
    [anon_sym_PERCENT_EQ] = ACTIONS(535),
    [anon_sym_AMP_EQ] = ACTIONS(535),
    [anon_sym_PIPE_EQ] = ACTIONS(535),
    [anon_sym_CARET_EQ] = ACTIONS(535),
    [anon_sym_LT_LT_EQ] = ACTIONS(535),
    [anon_sym_GT_GT_EQ] = ACTIONS(535),
    [anon_sym_move] = ACTIONS(537),
    [anon_sym_DOT] = ACTIONS(537),
    [sym_integer_literal] = ACTIONS(535),
    [aux_sym_string_literal_token1] = ACTIONS(535),
    [sym_char_literal] = ACTIONS(535),
    [anon_sym_true] = ACTIONS(537),
    [anon_sym_false] = ACTIONS(537),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(537),
    [sym_super] = ACTIONS(537),
    [sym_crate] = ACTIONS(537),
    [sym_metavariable] = ACTIONS(535),
    [sym_raw_string_literal] = ACTIONS(535),
    [sym_float_literal] = ACTIONS(535),
    [sym_block_comment] = ACTIONS(3),
  },
  [60] = {
    [sym_attribute_item] = STATE(536),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1108),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1108),
    [sym_macro_invocation] = STATE(1108),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1108),
    [sym_unary_expression] = STATE(1108),
    [sym_try_expression] = STATE(1108),
    [sym_reference_expression] = STATE(1108),
    [sym_binary_expression] = STATE(1108),
    [sym_assignment_expression] = STATE(1108),
    [sym_compound_assignment_expr] = STATE(1108),
    [sym_type_cast_expression] = STATE(1108),
    [sym_return_expression] = STATE(1108),
    [sym_call_expression] = STATE(1108),
    [sym_array_expression] = STATE(1108),
    [sym_parenthesized_expression] = STATE(1108),
    [sym_tuple_expression] = STATE(1108),
    [sym_unit_expression] = STATE(1108),
    [sym_struct_expression] = STATE(1108),
    [sym_if_expression] = STATE(1108),
    [sym_if_let_expression] = STATE(1108),
    [sym_match_expression] = STATE(1108),
    [sym_while_expression] = STATE(1108),
    [sym_while_let_expression] = STATE(1108),
    [sym_loop_expression] = STATE(1108),
    [sym_for_expression] = STATE(1108),
    [sym_closure_expression] = STATE(1108),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1108),
    [sym_continue_expression] = STATE(1108),
    [sym_index_expression] = STATE(1108),
    [sym_await_expression] = STATE(1108),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1108),
    [sym_async_block] = STATE(1108),
    [sym_block] = STATE(1108),
    [sym__literal] = STATE(1108),
    [sym_string_literal] = STATE(1108),
    [sym_boolean_literal] = STATE(1108),
    [aux_sym_enum_variant_list_repeat1] = STATE(536),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_POUND] = ACTIONS(405),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(539),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(539),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(539),
    [sym_float_literal] = ACTIONS(539),
    [sym_block_comment] = ACTIONS(3),
  },
  [61] = {
    [sym_attribute_item] = STATE(536),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1153),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1153),
    [sym_macro_invocation] = STATE(1153),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1153),
    [sym_unary_expression] = STATE(1153),
    [sym_try_expression] = STATE(1153),
    [sym_reference_expression] = STATE(1153),
    [sym_binary_expression] = STATE(1153),
    [sym_assignment_expression] = STATE(1153),
    [sym_compound_assignment_expr] = STATE(1153),
    [sym_type_cast_expression] = STATE(1153),
    [sym_return_expression] = STATE(1153),
    [sym_call_expression] = STATE(1153),
    [sym_array_expression] = STATE(1153),
    [sym_parenthesized_expression] = STATE(1153),
    [sym_tuple_expression] = STATE(1153),
    [sym_unit_expression] = STATE(1153),
    [sym_struct_expression] = STATE(1153),
    [sym_if_expression] = STATE(1153),
    [sym_if_let_expression] = STATE(1153),
    [sym_match_expression] = STATE(1153),
    [sym_while_expression] = STATE(1153),
    [sym_while_let_expression] = STATE(1153),
    [sym_loop_expression] = STATE(1153),
    [sym_for_expression] = STATE(1153),
    [sym_closure_expression] = STATE(1153),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1153),
    [sym_continue_expression] = STATE(1153),
    [sym_index_expression] = STATE(1153),
    [sym_await_expression] = STATE(1153),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1153),
    [sym_async_block] = STATE(1153),
    [sym_block] = STATE(1153),
    [sym__literal] = STATE(1153),
    [sym_string_literal] = STATE(1153),
    [sym_boolean_literal] = STATE(1153),
    [aux_sym_enum_variant_list_repeat1] = STATE(536),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_POUND] = ACTIONS(405),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(541),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(541),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(541),
    [sym_float_literal] = ACTIONS(541),
    [sym_block_comment] = ACTIONS(3),
  },
  [62] = {
    [sym_identifier] = ACTIONS(491),
    [anon_sym_SEMI] = ACTIONS(483),
    [anon_sym_macro_rules_BANG] = ACTIONS(489),
    [anon_sym_LPAREN] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(489),
    [anon_sym_RBRACE] = ACTIONS(489),
    [anon_sym_LBRACK] = ACTIONS(483),
    [anon_sym_PLUS] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(481),
    [anon_sym_QMARK] = ACTIONS(483),
    [anon_sym_u8] = ACTIONS(491),
    [anon_sym_i8] = ACTIONS(491),
    [anon_sym_u16] = ACTIONS(491),
    [anon_sym_i16] = ACTIONS(491),
    [anon_sym_u32] = ACTIONS(491),
    [anon_sym_i32] = ACTIONS(491),
    [anon_sym_u64] = ACTIONS(491),
    [anon_sym_i64] = ACTIONS(491),
    [anon_sym_u128] = ACTIONS(491),
    [anon_sym_i128] = ACTIONS(491),
    [anon_sym_isize] = ACTIONS(491),
    [anon_sym_usize] = ACTIONS(491),
    [anon_sym_f32] = ACTIONS(491),
    [anon_sym_f64] = ACTIONS(491),
    [anon_sym_bool] = ACTIONS(491),
    [anon_sym_str] = ACTIONS(491),
    [anon_sym_char] = ACTIONS(491),
    [anon_sym_SQUOTE] = ACTIONS(491),
    [anon_sym_as] = ACTIONS(481),
    [anon_sym_async] = ACTIONS(491),
    [anon_sym_break] = ACTIONS(491),
    [anon_sym_const] = ACTIONS(491),
    [anon_sym_continue] = ACTIONS(491),
    [anon_sym_default] = ACTIONS(491),
    [anon_sym_enum] = ACTIONS(491),
    [anon_sym_fn] = ACTIONS(491),
    [anon_sym_for] = ACTIONS(491),
    [anon_sym_if] = ACTIONS(491),
    [anon_sym_impl] = ACTIONS(491),
    [anon_sym_let] = ACTIONS(491),
    [anon_sym_loop] = ACTIONS(491),
    [anon_sym_match] = ACTIONS(491),
    [anon_sym_mod] = ACTIONS(491),
    [anon_sym_pub] = ACTIONS(491),
    [anon_sym_return] = ACTIONS(491),
    [anon_sym_static] = ACTIONS(491),
    [anon_sym_struct] = ACTIONS(491),
    [anon_sym_trait] = ACTIONS(491),
    [anon_sym_type] = ACTIONS(491),
    [anon_sym_union] = ACTIONS(491),
    [anon_sym_unsafe] = ACTIONS(491),
    [anon_sym_use] = ACTIONS(491),
    [anon_sym_while] = ACTIONS(491),
    [anon_sym_POUND] = ACTIONS(489),
    [anon_sym_BANG] = ACTIONS(491),
    [anon_sym_EQ] = ACTIONS(481),
    [anon_sym_extern] = ACTIONS(491),
    [anon_sym_LT] = ACTIONS(481),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_COLON_COLON] = ACTIONS(489),
    [anon_sym_AMP] = ACTIONS(481),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(483),
    [anon_sym_DOT_DOT] = ACTIONS(481),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(483),
    [anon_sym_DASH] = ACTIONS(481),
    [anon_sym_AMP_AMP] = ACTIONS(483),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_CARET] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(483),
    [anon_sym_BANG_EQ] = ACTIONS(483),
    [anon_sym_LT_EQ] = ACTIONS(483),
    [anon_sym_GT_EQ] = ACTIONS(483),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_PERCENT] = ACTIONS(481),
    [anon_sym_PLUS_EQ] = ACTIONS(483),
    [anon_sym_DASH_EQ] = ACTIONS(483),
    [anon_sym_STAR_EQ] = ACTIONS(483),
    [anon_sym_SLASH_EQ] = ACTIONS(483),
    [anon_sym_PERCENT_EQ] = ACTIONS(483),
    [anon_sym_AMP_EQ] = ACTIONS(483),
    [anon_sym_PIPE_EQ] = ACTIONS(483),
    [anon_sym_CARET_EQ] = ACTIONS(483),
    [anon_sym_LT_LT_EQ] = ACTIONS(483),
    [anon_sym_GT_GT_EQ] = ACTIONS(483),
    [anon_sym_move] = ACTIONS(491),
    [anon_sym_DOT] = ACTIONS(481),
    [sym_integer_literal] = ACTIONS(489),
    [aux_sym_string_literal_token1] = ACTIONS(489),
    [sym_char_literal] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(491),
    [sym_super] = ACTIONS(491),
    [sym_crate] = ACTIONS(491),
    [sym_metavariable] = ACTIONS(489),
    [sym_raw_string_literal] = ACTIONS(489),
    [sym_float_literal] = ACTIONS(489),
    [sym_block_comment] = ACTIONS(3),
  },
  [63] = {
    [sym_attribute_item] = STATE(536),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1076),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1076),
    [sym_macro_invocation] = STATE(1076),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1076),
    [sym_unary_expression] = STATE(1076),
    [sym_try_expression] = STATE(1076),
    [sym_reference_expression] = STATE(1076),
    [sym_binary_expression] = STATE(1076),
    [sym_assignment_expression] = STATE(1076),
    [sym_compound_assignment_expr] = STATE(1076),
    [sym_type_cast_expression] = STATE(1076),
    [sym_return_expression] = STATE(1076),
    [sym_call_expression] = STATE(1076),
    [sym_array_expression] = STATE(1076),
    [sym_parenthesized_expression] = STATE(1076),
    [sym_tuple_expression] = STATE(1076),
    [sym_unit_expression] = STATE(1076),
    [sym_struct_expression] = STATE(1076),
    [sym_if_expression] = STATE(1076),
    [sym_if_let_expression] = STATE(1076),
    [sym_match_expression] = STATE(1076),
    [sym_while_expression] = STATE(1076),
    [sym_while_let_expression] = STATE(1076),
    [sym_loop_expression] = STATE(1076),
    [sym_for_expression] = STATE(1076),
    [sym_closure_expression] = STATE(1076),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1076),
    [sym_continue_expression] = STATE(1076),
    [sym_index_expression] = STATE(1076),
    [sym_await_expression] = STATE(1076),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1076),
    [sym_async_block] = STATE(1076),
    [sym_block] = STATE(1076),
    [sym__literal] = STATE(1076),
    [sym_string_literal] = STATE(1076),
    [sym_boolean_literal] = STATE(1076),
    [aux_sym_enum_variant_list_repeat1] = STATE(536),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_POUND] = ACTIONS(405),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(543),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(543),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(543),
    [sym_float_literal] = ACTIONS(543),
    [sym_block_comment] = ACTIONS(3),
  },
  [64] = {
    [sym_attribute_item] = STATE(60),
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1133),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1133),
    [sym_macro_invocation] = STATE(1133),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1133),
    [sym_unary_expression] = STATE(1133),
    [sym_try_expression] = STATE(1133),
    [sym_reference_expression] = STATE(1133),
    [sym_binary_expression] = STATE(1133),
    [sym_assignment_expression] = STATE(1133),
    [sym_compound_assignment_expr] = STATE(1133),
    [sym_type_cast_expression] = STATE(1133),
    [sym_return_expression] = STATE(1133),
    [sym_call_expression] = STATE(1133),
    [sym_array_expression] = STATE(1133),
    [sym_parenthesized_expression] = STATE(1133),
    [sym_tuple_expression] = STATE(1133),
    [sym_unit_expression] = STATE(1133),
    [sym_struct_expression] = STATE(1133),
    [sym_if_expression] = STATE(1133),
    [sym_if_let_expression] = STATE(1133),
    [sym_match_expression] = STATE(1133),
    [sym_while_expression] = STATE(1133),
    [sym_while_let_expression] = STATE(1133),
    [sym_loop_expression] = STATE(1133),
    [sym_for_expression] = STATE(1133),
    [sym_closure_expression] = STATE(1133),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1133),
    [sym_continue_expression] = STATE(1133),
    [sym_index_expression] = STATE(1133),
    [sym_await_expression] = STATE(1133),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1133),
    [sym_async_block] = STATE(1133),
    [sym_block] = STATE(1133),
    [sym__literal] = STATE(1133),
    [sym_string_literal] = STATE(1133),
    [sym_boolean_literal] = STATE(1133),
    [aux_sym_enum_variant_list_repeat1] = STATE(60),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_POUND] = ACTIONS(405),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(469),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(469),
    [sym_float_literal] = ACTIONS(469),
    [sym_block_comment] = ACTIONS(3),
  },
  [65] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1137),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1137),
    [sym_macro_invocation] = STATE(1137),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1137),
    [sym_unary_expression] = STATE(1137),
    [sym_try_expression] = STATE(1137),
    [sym_reference_expression] = STATE(1137),
    [sym_binary_expression] = STATE(1137),
    [sym_assignment_expression] = STATE(1137),
    [sym_compound_assignment_expr] = STATE(1137),
    [sym_type_cast_expression] = STATE(1137),
    [sym_return_expression] = STATE(1137),
    [sym_call_expression] = STATE(1137),
    [sym_array_expression] = STATE(1137),
    [sym_parenthesized_expression] = STATE(1137),
    [sym_tuple_expression] = STATE(1137),
    [sym_unit_expression] = STATE(1137),
    [sym_struct_expression] = STATE(1137),
    [sym_if_expression] = STATE(1137),
    [sym_if_let_expression] = STATE(1137),
    [sym_match_expression] = STATE(1137),
    [sym_while_expression] = STATE(1137),
    [sym_while_let_expression] = STATE(1137),
    [sym_loop_expression] = STATE(1137),
    [sym_for_expression] = STATE(1137),
    [sym_closure_expression] = STATE(1137),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1137),
    [sym_continue_expression] = STATE(1137),
    [sym_index_expression] = STATE(1137),
    [sym_await_expression] = STATE(1137),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1137),
    [sym_async_block] = STATE(1137),
    [sym_block] = STATE(1137),
    [sym__literal] = STATE(1137),
    [sym_string_literal] = STATE(1137),
    [sym_boolean_literal] = STATE(1137),
    [aux_sym_tuple_expression_repeat1] = STATE(68),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(545),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(547),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(547),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(547),
    [sym_float_literal] = ACTIONS(547),
    [sym_block_comment] = ACTIONS(3),
  },
  [66] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1137),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1137),
    [sym_macro_invocation] = STATE(1137),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1137),
    [sym_unary_expression] = STATE(1137),
    [sym_try_expression] = STATE(1137),
    [sym_reference_expression] = STATE(1137),
    [sym_binary_expression] = STATE(1137),
    [sym_assignment_expression] = STATE(1137),
    [sym_compound_assignment_expr] = STATE(1137),
    [sym_type_cast_expression] = STATE(1137),
    [sym_return_expression] = STATE(1137),
    [sym_call_expression] = STATE(1137),
    [sym_array_expression] = STATE(1137),
    [sym_parenthesized_expression] = STATE(1137),
    [sym_tuple_expression] = STATE(1137),
    [sym_unit_expression] = STATE(1137),
    [sym_struct_expression] = STATE(1137),
    [sym_if_expression] = STATE(1137),
    [sym_if_let_expression] = STATE(1137),
    [sym_match_expression] = STATE(1137),
    [sym_while_expression] = STATE(1137),
    [sym_while_let_expression] = STATE(1137),
    [sym_loop_expression] = STATE(1137),
    [sym_for_expression] = STATE(1137),
    [sym_closure_expression] = STATE(1137),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1137),
    [sym_continue_expression] = STATE(1137),
    [sym_index_expression] = STATE(1137),
    [sym_await_expression] = STATE(1137),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1137),
    [sym_async_block] = STATE(1137),
    [sym_block] = STATE(1137),
    [sym__literal] = STATE(1137),
    [sym_string_literal] = STATE(1137),
    [sym_boolean_literal] = STATE(1137),
    [aux_sym_tuple_expression_repeat1] = STATE(67),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(545),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(547),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(547),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(547),
    [sym_float_literal] = ACTIONS(547),
    [sym_block_comment] = ACTIONS(3),
  },
  [67] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1171),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1171),
    [sym_macro_invocation] = STATE(1171),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1171),
    [sym_unary_expression] = STATE(1171),
    [sym_try_expression] = STATE(1171),
    [sym_reference_expression] = STATE(1171),
    [sym_binary_expression] = STATE(1171),
    [sym_assignment_expression] = STATE(1171),
    [sym_compound_assignment_expr] = STATE(1171),
    [sym_type_cast_expression] = STATE(1171),
    [sym_return_expression] = STATE(1171),
    [sym_call_expression] = STATE(1171),
    [sym_array_expression] = STATE(1171),
    [sym_parenthesized_expression] = STATE(1171),
    [sym_tuple_expression] = STATE(1171),
    [sym_unit_expression] = STATE(1171),
    [sym_struct_expression] = STATE(1171),
    [sym_if_expression] = STATE(1171),
    [sym_if_let_expression] = STATE(1171),
    [sym_match_expression] = STATE(1171),
    [sym_while_expression] = STATE(1171),
    [sym_while_let_expression] = STATE(1171),
    [sym_loop_expression] = STATE(1171),
    [sym_for_expression] = STATE(1171),
    [sym_closure_expression] = STATE(1171),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1171),
    [sym_continue_expression] = STATE(1171),
    [sym_index_expression] = STATE(1171),
    [sym_await_expression] = STATE(1171),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1171),
    [sym_async_block] = STATE(1171),
    [sym_block] = STATE(1171),
    [sym__literal] = STATE(1171),
    [sym_string_literal] = STATE(1171),
    [sym_boolean_literal] = STATE(1171),
    [aux_sym_tuple_expression_repeat1] = STATE(67),
    [sym_identifier] = ACTIONS(549),
    [anon_sym_LPAREN] = ACTIONS(552),
    [anon_sym_RPAREN] = ACTIONS(555),
    [anon_sym_LBRACE] = ACTIONS(557),
    [anon_sym_LBRACK] = ACTIONS(560),
    [anon_sym_STAR] = ACTIONS(563),
    [anon_sym_u8] = ACTIONS(566),
    [anon_sym_i8] = ACTIONS(566),
    [anon_sym_u16] = ACTIONS(566),
    [anon_sym_i16] = ACTIONS(566),
    [anon_sym_u32] = ACTIONS(566),
    [anon_sym_i32] = ACTIONS(566),
    [anon_sym_u64] = ACTIONS(566),
    [anon_sym_i64] = ACTIONS(566),
    [anon_sym_u128] = ACTIONS(566),
    [anon_sym_i128] = ACTIONS(566),
    [anon_sym_isize] = ACTIONS(566),
    [anon_sym_usize] = ACTIONS(566),
    [anon_sym_f32] = ACTIONS(566),
    [anon_sym_f64] = ACTIONS(566),
    [anon_sym_bool] = ACTIONS(566),
    [anon_sym_str] = ACTIONS(566),
    [anon_sym_char] = ACTIONS(566),
    [anon_sym_SQUOTE] = ACTIONS(569),
    [anon_sym_async] = ACTIONS(572),
    [anon_sym_break] = ACTIONS(575),
    [anon_sym_continue] = ACTIONS(578),
    [anon_sym_default] = ACTIONS(581),
    [anon_sym_for] = ACTIONS(584),
    [anon_sym_if] = ACTIONS(587),
    [anon_sym_loop] = ACTIONS(590),
    [anon_sym_match] = ACTIONS(593),
    [anon_sym_return] = ACTIONS(596),
    [anon_sym_union] = ACTIONS(581),
    [anon_sym_unsafe] = ACTIONS(599),
    [anon_sym_while] = ACTIONS(602),
    [anon_sym_BANG] = ACTIONS(563),
    [anon_sym_LT] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(608),
    [anon_sym_AMP] = ACTIONS(611),
    [anon_sym_DOT_DOT] = ACTIONS(614),
    [anon_sym_DASH] = ACTIONS(563),
    [anon_sym_PIPE] = ACTIONS(617),
    [anon_sym_move] = ACTIONS(620),
    [sym_integer_literal] = ACTIONS(623),
    [aux_sym_string_literal_token1] = ACTIONS(626),
    [sym_char_literal] = ACTIONS(623),
    [anon_sym_true] = ACTIONS(629),
    [anon_sym_false] = ACTIONS(629),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(632),
    [sym_super] = ACTIONS(635),
    [sym_crate] = ACTIONS(635),
    [sym_metavariable] = ACTIONS(638),
    [sym_raw_string_literal] = ACTIONS(623),
    [sym_float_literal] = ACTIONS(623),
    [sym_block_comment] = ACTIONS(3),
  },
  [68] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1114),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1114),
    [sym_macro_invocation] = STATE(1114),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1114),
    [sym_unary_expression] = STATE(1114),
    [sym_try_expression] = STATE(1114),
    [sym_reference_expression] = STATE(1114),
    [sym_binary_expression] = STATE(1114),
    [sym_assignment_expression] = STATE(1114),
    [sym_compound_assignment_expr] = STATE(1114),
    [sym_type_cast_expression] = STATE(1114),
    [sym_return_expression] = STATE(1114),
    [sym_call_expression] = STATE(1114),
    [sym_array_expression] = STATE(1114),
    [sym_parenthesized_expression] = STATE(1114),
    [sym_tuple_expression] = STATE(1114),
    [sym_unit_expression] = STATE(1114),
    [sym_struct_expression] = STATE(1114),
    [sym_if_expression] = STATE(1114),
    [sym_if_let_expression] = STATE(1114),
    [sym_match_expression] = STATE(1114),
    [sym_while_expression] = STATE(1114),
    [sym_while_let_expression] = STATE(1114),
    [sym_loop_expression] = STATE(1114),
    [sym_for_expression] = STATE(1114),
    [sym_closure_expression] = STATE(1114),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1114),
    [sym_continue_expression] = STATE(1114),
    [sym_index_expression] = STATE(1114),
    [sym_await_expression] = STATE(1114),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1114),
    [sym_async_block] = STATE(1114),
    [sym_block] = STATE(1114),
    [sym__literal] = STATE(1114),
    [sym_string_literal] = STATE(1114),
    [sym_boolean_literal] = STATE(1114),
    [aux_sym_tuple_expression_repeat1] = STATE(67),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(641),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(643),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(643),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(643),
    [sym_float_literal] = ACTIONS(643),
    [sym_block_comment] = ACTIONS(3),
  },
  [69] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1123),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1123),
    [sym_macro_invocation] = STATE(1123),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1123),
    [sym_unary_expression] = STATE(1123),
    [sym_try_expression] = STATE(1123),
    [sym_reference_expression] = STATE(1123),
    [sym_binary_expression] = STATE(1123),
    [sym_assignment_expression] = STATE(1123),
    [sym_compound_assignment_expr] = STATE(1123),
    [sym_type_cast_expression] = STATE(1123),
    [sym_return_expression] = STATE(1123),
    [sym_call_expression] = STATE(1123),
    [sym_array_expression] = STATE(1123),
    [sym_parenthesized_expression] = STATE(1123),
    [sym_tuple_expression] = STATE(1123),
    [sym_unit_expression] = STATE(1123),
    [sym_struct_expression] = STATE(1123),
    [sym_if_expression] = STATE(1123),
    [sym_if_let_expression] = STATE(1123),
    [sym_match_expression] = STATE(1123),
    [sym_while_expression] = STATE(1123),
    [sym_while_let_expression] = STATE(1123),
    [sym_loop_expression] = STATE(1123),
    [sym_for_expression] = STATE(1123),
    [sym_closure_expression] = STATE(1123),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1123),
    [sym_continue_expression] = STATE(1123),
    [sym_index_expression] = STATE(1123),
    [sym_await_expression] = STATE(1123),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1123),
    [sym_async_block] = STATE(1123),
    [sym_block] = STATE(1123),
    [sym__literal] = STATE(1123),
    [sym_string_literal] = STATE(1123),
    [sym_boolean_literal] = STATE(1123),
    [aux_sym_tuple_expression_repeat1] = STATE(66),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(645),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(647),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(647),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(647),
    [sym_float_literal] = ACTIONS(647),
    [sym_block_comment] = ACTIONS(3),
  },
  [70] = {
    [sym_attribute_item] = STATE(185),
    [sym_function_modifiers] = STATE(2207),
    [sym_self_parameter] = STATE(1833),
    [sym_variadic_parameter] = STATE(1833),
    [sym_parameter] = STATE(1833),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1676),
    [sym_bracketed_type] = STATE(2321),
    [sym_lifetime] = STATE(1828),
    [sym_array_type] = STATE(1676),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1676),
    [sym_tuple_type] = STATE(1676),
    [sym_unit_type] = STATE(1676),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2322),
    [sym_bounded_type] = STATE(1676),
    [sym_reference_type] = STATE(1676),
    [sym_pointer_type] = STATE(1676),
    [sym_empty_type] = STATE(1676),
    [sym_abstract_type] = STATE(1676),
    [sym_dynamic_type] = STATE(1676),
    [sym_macro_invocation] = STATE(1676),
    [sym_scoped_identifier] = STATE(1420),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(1573),
    [sym_tuple_pattern] = STATE(1573),
    [sym_slice_pattern] = STATE(1573),
    [sym_tuple_struct_pattern] = STATE(1573),
    [sym_struct_pattern] = STATE(1573),
    [sym_remaining_field_pattern] = STATE(1573),
    [sym_mut_pattern] = STATE(1573),
    [sym_range_pattern] = STATE(1573),
    [sym_ref_pattern] = STATE(1573),
    [sym_captured_pattern] = STATE(1573),
    [sym_reference_pattern] = STATE(1573),
    [sym_or_pattern] = STATE(1573),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(659),
    [anon_sym_i8] = ACTIONS(659),
    [anon_sym_u16] = ACTIONS(659),
    [anon_sym_i16] = ACTIONS(659),
    [anon_sym_u32] = ACTIONS(659),
    [anon_sym_i32] = ACTIONS(659),
    [anon_sym_u64] = ACTIONS(659),
    [anon_sym_i64] = ACTIONS(659),
    [anon_sym_u128] = ACTIONS(659),
    [anon_sym_i128] = ACTIONS(659),
    [anon_sym_isize] = ACTIONS(659),
    [anon_sym_usize] = ACTIONS(659),
    [anon_sym_f32] = ACTIONS(659),
    [anon_sym_f64] = ACTIONS(659),
    [anon_sym_bool] = ACTIONS(659),
    [anon_sym_str] = ACTIONS(659),
    [anon_sym_char] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(665),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_union] = ACTIONS(673),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(675),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(679),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(685),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(689),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(691),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(695),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(707),
    [sym_super] = ACTIONS(709),
    [sym_crate] = ACTIONS(709),
    [sym_metavariable] = ACTIONS(711),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [71] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1101),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1101),
    [sym_macro_invocation] = STATE(1101),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1101),
    [sym_unary_expression] = STATE(1101),
    [sym_try_expression] = STATE(1101),
    [sym_reference_expression] = STATE(1101),
    [sym_binary_expression] = STATE(1101),
    [sym_assignment_expression] = STATE(1101),
    [sym_compound_assignment_expr] = STATE(1101),
    [sym_type_cast_expression] = STATE(1101),
    [sym_return_expression] = STATE(1101),
    [sym_call_expression] = STATE(1101),
    [sym_array_expression] = STATE(1101),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_tuple_expression] = STATE(1101),
    [sym_unit_expression] = STATE(1101),
    [sym_struct_expression] = STATE(1101),
    [sym_if_expression] = STATE(1101),
    [sym_if_let_expression] = STATE(1101),
    [sym_match_expression] = STATE(1101),
    [sym_while_expression] = STATE(1101),
    [sym_while_let_expression] = STATE(1101),
    [sym_loop_expression] = STATE(1101),
    [sym_for_expression] = STATE(1101),
    [sym_closure_expression] = STATE(1101),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1101),
    [sym_continue_expression] = STATE(1101),
    [sym_index_expression] = STATE(1101),
    [sym_await_expression] = STATE(1101),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1101),
    [sym_async_block] = STATE(1101),
    [sym_block] = STATE(1101),
    [sym__literal] = STATE(1101),
    [sym_string_literal] = STATE(1101),
    [sym_boolean_literal] = STATE(1101),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(715),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(721),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(721),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(721),
    [sym_float_literal] = ACTIONS(721),
    [sym_block_comment] = ACTIONS(3),
  },
  [72] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(970),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(970),
    [sym_macro_invocation] = STATE(970),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(970),
    [sym_unary_expression] = STATE(970),
    [sym_try_expression] = STATE(970),
    [sym_reference_expression] = STATE(970),
    [sym_binary_expression] = STATE(970),
    [sym_assignment_expression] = STATE(970),
    [sym_compound_assignment_expr] = STATE(970),
    [sym_type_cast_expression] = STATE(970),
    [sym_return_expression] = STATE(970),
    [sym_call_expression] = STATE(970),
    [sym_array_expression] = STATE(970),
    [sym_parenthesized_expression] = STATE(970),
    [sym_tuple_expression] = STATE(970),
    [sym_unit_expression] = STATE(970),
    [sym_struct_expression] = STATE(970),
    [sym_if_expression] = STATE(970),
    [sym_if_let_expression] = STATE(970),
    [sym_match_expression] = STATE(970),
    [sym_while_expression] = STATE(970),
    [sym_while_let_expression] = STATE(970),
    [sym_loop_expression] = STATE(970),
    [sym_for_expression] = STATE(970),
    [sym_closure_expression] = STATE(970),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(970),
    [sym_continue_expression] = STATE(970),
    [sym_index_expression] = STATE(970),
    [sym_await_expression] = STATE(970),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(970),
    [sym_async_block] = STATE(970),
    [sym_block] = STATE(970),
    [sym__literal] = STATE(970),
    [sym_string_literal] = STATE(970),
    [sym_boolean_literal] = STATE(970),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(725),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(725),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(725),
    [sym_float_literal] = ACTIONS(725),
    [sym_block_comment] = ACTIONS(3),
  },
  [73] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1129),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1129),
    [sym_macro_invocation] = STATE(1129),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1129),
    [sym_unary_expression] = STATE(1129),
    [sym_try_expression] = STATE(1129),
    [sym_reference_expression] = STATE(1129),
    [sym_binary_expression] = STATE(1129),
    [sym_assignment_expression] = STATE(1129),
    [sym_compound_assignment_expr] = STATE(1129),
    [sym_type_cast_expression] = STATE(1129),
    [sym_return_expression] = STATE(1129),
    [sym_call_expression] = STATE(1129),
    [sym_array_expression] = STATE(1129),
    [sym_parenthesized_expression] = STATE(1129),
    [sym_tuple_expression] = STATE(1129),
    [sym_unit_expression] = STATE(1129),
    [sym_struct_expression] = STATE(1129),
    [sym_if_expression] = STATE(1129),
    [sym_if_let_expression] = STATE(1129),
    [sym_match_expression] = STATE(1129),
    [sym_while_expression] = STATE(1129),
    [sym_while_let_expression] = STATE(1129),
    [sym_loop_expression] = STATE(1129),
    [sym_for_expression] = STATE(1129),
    [sym_closure_expression] = STATE(1129),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1129),
    [sym_continue_expression] = STATE(1129),
    [sym_index_expression] = STATE(1129),
    [sym_await_expression] = STATE(1129),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1129),
    [sym_async_block] = STATE(1129),
    [sym_block] = STATE(1129),
    [sym__literal] = STATE(1129),
    [sym_string_literal] = STATE(1129),
    [sym_boolean_literal] = STATE(1129),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(727),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(729),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(729),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(729),
    [sym_float_literal] = ACTIONS(729),
    [sym_block_comment] = ACTIONS(3),
  },
  [74] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1124),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1124),
    [sym_macro_invocation] = STATE(1124),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1124),
    [sym_unary_expression] = STATE(1124),
    [sym_try_expression] = STATE(1124),
    [sym_reference_expression] = STATE(1124),
    [sym_binary_expression] = STATE(1124),
    [sym_assignment_expression] = STATE(1124),
    [sym_compound_assignment_expr] = STATE(1124),
    [sym_type_cast_expression] = STATE(1124),
    [sym_return_expression] = STATE(1124),
    [sym_call_expression] = STATE(1124),
    [sym_array_expression] = STATE(1124),
    [sym_parenthesized_expression] = STATE(1124),
    [sym_tuple_expression] = STATE(1124),
    [sym_unit_expression] = STATE(1124),
    [sym_struct_expression] = STATE(1124),
    [sym_if_expression] = STATE(1124),
    [sym_if_let_expression] = STATE(1124),
    [sym_match_expression] = STATE(1124),
    [sym_while_expression] = STATE(1124),
    [sym_while_let_expression] = STATE(1124),
    [sym_loop_expression] = STATE(1124),
    [sym_for_expression] = STATE(1124),
    [sym_closure_expression] = STATE(1124),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1124),
    [sym_continue_expression] = STATE(1124),
    [sym_index_expression] = STATE(1124),
    [sym_await_expression] = STATE(1124),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1124),
    [sym_async_block] = STATE(1124),
    [sym_block] = STATE(1124),
    [sym__literal] = STATE(1124),
    [sym_string_literal] = STATE(1124),
    [sym_boolean_literal] = STATE(1124),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(731),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(733),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(733),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(733),
    [sym_float_literal] = ACTIONS(733),
    [sym_block_comment] = ACTIONS(3),
  },
  [75] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1129),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1129),
    [sym_macro_invocation] = STATE(1129),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1129),
    [sym_unary_expression] = STATE(1129),
    [sym_try_expression] = STATE(1129),
    [sym_reference_expression] = STATE(1129),
    [sym_binary_expression] = STATE(1129),
    [sym_assignment_expression] = STATE(1129),
    [sym_compound_assignment_expr] = STATE(1129),
    [sym_type_cast_expression] = STATE(1129),
    [sym_return_expression] = STATE(1129),
    [sym_call_expression] = STATE(1129),
    [sym_array_expression] = STATE(1129),
    [sym_parenthesized_expression] = STATE(1129),
    [sym_tuple_expression] = STATE(1129),
    [sym_unit_expression] = STATE(1129),
    [sym_struct_expression] = STATE(1129),
    [sym_if_expression] = STATE(1129),
    [sym_if_let_expression] = STATE(1129),
    [sym_match_expression] = STATE(1129),
    [sym_while_expression] = STATE(1129),
    [sym_while_let_expression] = STATE(1129),
    [sym_loop_expression] = STATE(1129),
    [sym_for_expression] = STATE(1129),
    [sym_closure_expression] = STATE(1129),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1129),
    [sym_continue_expression] = STATE(1129),
    [sym_index_expression] = STATE(1129),
    [sym_await_expression] = STATE(1129),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1129),
    [sym_async_block] = STATE(1129),
    [sym_block] = STATE(1129),
    [sym__literal] = STATE(1129),
    [sym_string_literal] = STATE(1129),
    [sym_boolean_literal] = STATE(1129),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(735),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(729),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(729),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(729),
    [sym_float_literal] = ACTIONS(729),
    [sym_block_comment] = ACTIONS(3),
  },
  [76] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1162),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1162),
    [sym_macro_invocation] = STATE(1162),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1162),
    [sym_unary_expression] = STATE(1162),
    [sym_try_expression] = STATE(1162),
    [sym_reference_expression] = STATE(1162),
    [sym_binary_expression] = STATE(1162),
    [sym_assignment_expression] = STATE(1162),
    [sym_compound_assignment_expr] = STATE(1162),
    [sym_type_cast_expression] = STATE(1162),
    [sym_return_expression] = STATE(1162),
    [sym_call_expression] = STATE(1162),
    [sym_array_expression] = STATE(1162),
    [sym_parenthesized_expression] = STATE(1162),
    [sym_tuple_expression] = STATE(1162),
    [sym_unit_expression] = STATE(1162),
    [sym_struct_expression] = STATE(1162),
    [sym_if_expression] = STATE(1162),
    [sym_if_let_expression] = STATE(1162),
    [sym_match_expression] = STATE(1162),
    [sym_while_expression] = STATE(1162),
    [sym_while_let_expression] = STATE(1162),
    [sym_loop_expression] = STATE(1162),
    [sym_for_expression] = STATE(1162),
    [sym_closure_expression] = STATE(1162),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1162),
    [sym_continue_expression] = STATE(1162),
    [sym_index_expression] = STATE(1162),
    [sym_await_expression] = STATE(1162),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1162),
    [sym_async_block] = STATE(1162),
    [sym_block] = STATE(1162),
    [sym__literal] = STATE(1162),
    [sym_string_literal] = STATE(1162),
    [sym_boolean_literal] = STATE(1162),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_DASH_GT] = ACTIONS(723),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(737),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(737),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(737),
    [sym_float_literal] = ACTIONS(737),
    [sym_block_comment] = ACTIONS(3),
  },
  [77] = {
    [sym_attribute_item] = STATE(185),
    [sym_function_modifiers] = STATE(2207),
    [sym_self_parameter] = STATE(1833),
    [sym_variadic_parameter] = STATE(1833),
    [sym_parameter] = STATE(1833),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1676),
    [sym_bracketed_type] = STATE(2321),
    [sym_lifetime] = STATE(1828),
    [sym_array_type] = STATE(1676),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1676),
    [sym_tuple_type] = STATE(1676),
    [sym_unit_type] = STATE(1676),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2322),
    [sym_bounded_type] = STATE(1676),
    [sym_reference_type] = STATE(1676),
    [sym_pointer_type] = STATE(1676),
    [sym_empty_type] = STATE(1676),
    [sym_abstract_type] = STATE(1676),
    [sym_dynamic_type] = STATE(1676),
    [sym_macro_invocation] = STATE(1676),
    [sym_scoped_identifier] = STATE(1420),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(1573),
    [sym_tuple_pattern] = STATE(1573),
    [sym_slice_pattern] = STATE(1573),
    [sym_tuple_struct_pattern] = STATE(1573),
    [sym_struct_pattern] = STATE(1573),
    [sym_remaining_field_pattern] = STATE(1573),
    [sym_mut_pattern] = STATE(1573),
    [sym_range_pattern] = STATE(1573),
    [sym_ref_pattern] = STATE(1573),
    [sym_captured_pattern] = STATE(1573),
    [sym_reference_pattern] = STATE(1573),
    [sym_or_pattern] = STATE(1573),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_RPAREN] = ACTIONS(739),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(659),
    [anon_sym_i8] = ACTIONS(659),
    [anon_sym_u16] = ACTIONS(659),
    [anon_sym_i16] = ACTIONS(659),
    [anon_sym_u32] = ACTIONS(659),
    [anon_sym_i32] = ACTIONS(659),
    [anon_sym_u64] = ACTIONS(659),
    [anon_sym_i64] = ACTIONS(659),
    [anon_sym_u128] = ACTIONS(659),
    [anon_sym_i128] = ACTIONS(659),
    [anon_sym_isize] = ACTIONS(659),
    [anon_sym_usize] = ACTIONS(659),
    [anon_sym_f32] = ACTIONS(659),
    [anon_sym_f64] = ACTIONS(659),
    [anon_sym_bool] = ACTIONS(659),
    [anon_sym_str] = ACTIONS(659),
    [anon_sym_char] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(665),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_union] = ACTIONS(673),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(675),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(741),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(685),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(689),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(691),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(695),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(707),
    [sym_super] = ACTIONS(709),
    [sym_crate] = ACTIONS(709),
    [sym_metavariable] = ACTIONS(711),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [78] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1183),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1183),
    [sym_macro_invocation] = STATE(1183),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1183),
    [sym_unary_expression] = STATE(1183),
    [sym_try_expression] = STATE(1183),
    [sym_reference_expression] = STATE(1183),
    [sym_binary_expression] = STATE(1183),
    [sym_assignment_expression] = STATE(1183),
    [sym_compound_assignment_expr] = STATE(1183),
    [sym_type_cast_expression] = STATE(1183),
    [sym_return_expression] = STATE(1183),
    [sym_call_expression] = STATE(1183),
    [sym_array_expression] = STATE(1183),
    [sym_parenthesized_expression] = STATE(1183),
    [sym_tuple_expression] = STATE(1183),
    [sym_unit_expression] = STATE(1183),
    [sym_struct_expression] = STATE(1183),
    [sym_if_expression] = STATE(1183),
    [sym_if_let_expression] = STATE(1183),
    [sym_match_expression] = STATE(1183),
    [sym_while_expression] = STATE(1183),
    [sym_while_let_expression] = STATE(1183),
    [sym_loop_expression] = STATE(1183),
    [sym_for_expression] = STATE(1183),
    [sym_closure_expression] = STATE(1183),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1183),
    [sym_continue_expression] = STATE(1183),
    [sym_index_expression] = STATE(1183),
    [sym_await_expression] = STATE(1183),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1183),
    [sym_async_block] = STATE(1183),
    [sym_block] = STATE(1183),
    [sym__literal] = STATE(1183),
    [sym_string_literal] = STATE(1183),
    [sym_boolean_literal] = STATE(1183),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_DASH_GT] = ACTIONS(743),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(745),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(745),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(745),
    [sym_float_literal] = ACTIONS(745),
    [sym_block_comment] = ACTIONS(3),
  },
  [79] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1139),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1139),
    [sym_macro_invocation] = STATE(1139),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1139),
    [sym_unary_expression] = STATE(1139),
    [sym_try_expression] = STATE(1139),
    [sym_reference_expression] = STATE(1139),
    [sym_binary_expression] = STATE(1139),
    [sym_assignment_expression] = STATE(1139),
    [sym_compound_assignment_expr] = STATE(1139),
    [sym_type_cast_expression] = STATE(1139),
    [sym_return_expression] = STATE(1139),
    [sym_call_expression] = STATE(1139),
    [sym_array_expression] = STATE(1139),
    [sym_parenthesized_expression] = STATE(1139),
    [sym_tuple_expression] = STATE(1139),
    [sym_unit_expression] = STATE(1139),
    [sym_struct_expression] = STATE(1139),
    [sym_if_expression] = STATE(1139),
    [sym_if_let_expression] = STATE(1139),
    [sym_match_expression] = STATE(1139),
    [sym_while_expression] = STATE(1139),
    [sym_while_let_expression] = STATE(1139),
    [sym_loop_expression] = STATE(1139),
    [sym_for_expression] = STATE(1139),
    [sym_closure_expression] = STATE(1139),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1139),
    [sym_continue_expression] = STATE(1139),
    [sym_index_expression] = STATE(1139),
    [sym_await_expression] = STATE(1139),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1139),
    [sym_async_block] = STATE(1139),
    [sym_block] = STATE(1139),
    [sym__literal] = STATE(1139),
    [sym_string_literal] = STATE(1139),
    [sym_boolean_literal] = STATE(1139),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(747),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(749),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(749),
    [sym_float_literal] = ACTIONS(749),
    [sym_block_comment] = ACTIONS(3),
  },
  [80] = {
    [sym_attribute_item] = STATE(185),
    [sym_function_modifiers] = STATE(2207),
    [sym_self_parameter] = STATE(1833),
    [sym_variadic_parameter] = STATE(1833),
    [sym_parameter] = STATE(1833),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1676),
    [sym_bracketed_type] = STATE(2321),
    [sym_lifetime] = STATE(1828),
    [sym_array_type] = STATE(1676),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1676),
    [sym_tuple_type] = STATE(1676),
    [sym_unit_type] = STATE(1676),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2322),
    [sym_bounded_type] = STATE(1676),
    [sym_reference_type] = STATE(1676),
    [sym_pointer_type] = STATE(1676),
    [sym_empty_type] = STATE(1676),
    [sym_abstract_type] = STATE(1676),
    [sym_dynamic_type] = STATE(1676),
    [sym_macro_invocation] = STATE(1676),
    [sym_scoped_identifier] = STATE(1420),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(1573),
    [sym_tuple_pattern] = STATE(1573),
    [sym_slice_pattern] = STATE(1573),
    [sym_tuple_struct_pattern] = STATE(1573),
    [sym_struct_pattern] = STATE(1573),
    [sym_remaining_field_pattern] = STATE(1573),
    [sym_mut_pattern] = STATE(1573),
    [sym_range_pattern] = STATE(1573),
    [sym_ref_pattern] = STATE(1573),
    [sym_captured_pattern] = STATE(1573),
    [sym_reference_pattern] = STATE(1573),
    [sym_or_pattern] = STATE(1573),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_RPAREN] = ACTIONS(751),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(659),
    [anon_sym_i8] = ACTIONS(659),
    [anon_sym_u16] = ACTIONS(659),
    [anon_sym_i16] = ACTIONS(659),
    [anon_sym_u32] = ACTIONS(659),
    [anon_sym_i32] = ACTIONS(659),
    [anon_sym_u64] = ACTIONS(659),
    [anon_sym_i64] = ACTIONS(659),
    [anon_sym_u128] = ACTIONS(659),
    [anon_sym_i128] = ACTIONS(659),
    [anon_sym_isize] = ACTIONS(659),
    [anon_sym_usize] = ACTIONS(659),
    [anon_sym_f32] = ACTIONS(659),
    [anon_sym_f64] = ACTIONS(659),
    [anon_sym_bool] = ACTIONS(659),
    [anon_sym_str] = ACTIONS(659),
    [anon_sym_char] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(665),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_union] = ACTIONS(673),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(675),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(753),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(685),
    [anon_sym__] = ACTIONS(687),
    [anon_sym_AMP] = ACTIONS(689),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(691),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(695),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(707),
    [sym_super] = ACTIONS(709),
    [sym_crate] = ACTIONS(709),
    [sym_metavariable] = ACTIONS(711),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [81] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1082),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1082),
    [sym_macro_invocation] = STATE(1082),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1082),
    [sym_unary_expression] = STATE(1082),
    [sym_try_expression] = STATE(1082),
    [sym_reference_expression] = STATE(1082),
    [sym_binary_expression] = STATE(1082),
    [sym_assignment_expression] = STATE(1082),
    [sym_compound_assignment_expr] = STATE(1082),
    [sym_type_cast_expression] = STATE(1082),
    [sym_return_expression] = STATE(1082),
    [sym_call_expression] = STATE(1082),
    [sym_array_expression] = STATE(1082),
    [sym_parenthesized_expression] = STATE(1082),
    [sym_tuple_expression] = STATE(1082),
    [sym_unit_expression] = STATE(1082),
    [sym_struct_expression] = STATE(1082),
    [sym_if_expression] = STATE(1082),
    [sym_if_let_expression] = STATE(1082),
    [sym_match_expression] = STATE(1082),
    [sym_while_expression] = STATE(1082),
    [sym_while_let_expression] = STATE(1082),
    [sym_loop_expression] = STATE(1082),
    [sym_for_expression] = STATE(1082),
    [sym_closure_expression] = STATE(1082),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1082),
    [sym_continue_expression] = STATE(1082),
    [sym_index_expression] = STATE(1082),
    [sym_await_expression] = STATE(1082),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1082),
    [sym_async_block] = STATE(1082),
    [sym_block] = STATE(1082),
    [sym__literal] = STATE(1082),
    [sym_string_literal] = STATE(1082),
    [sym_boolean_literal] = STATE(1082),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(755),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(757),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(757),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(757),
    [sym_float_literal] = ACTIONS(757),
    [sym_block_comment] = ACTIONS(3),
  },
  [82] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(951),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(951),
    [sym_macro_invocation] = STATE(951),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(951),
    [sym_unary_expression] = STATE(951),
    [sym_try_expression] = STATE(951),
    [sym_reference_expression] = STATE(951),
    [sym_binary_expression] = STATE(951),
    [sym_assignment_expression] = STATE(951),
    [sym_compound_assignment_expr] = STATE(951),
    [sym_type_cast_expression] = STATE(951),
    [sym_return_expression] = STATE(951),
    [sym_call_expression] = STATE(951),
    [sym_array_expression] = STATE(951),
    [sym_parenthesized_expression] = STATE(951),
    [sym_tuple_expression] = STATE(951),
    [sym_unit_expression] = STATE(951),
    [sym_struct_expression] = STATE(951),
    [sym_if_expression] = STATE(951),
    [sym_if_let_expression] = STATE(951),
    [sym_match_expression] = STATE(951),
    [sym_while_expression] = STATE(951),
    [sym_while_let_expression] = STATE(951),
    [sym_loop_expression] = STATE(951),
    [sym_for_expression] = STATE(951),
    [sym_closure_expression] = STATE(951),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(951),
    [sym_continue_expression] = STATE(951),
    [sym_index_expression] = STATE(951),
    [sym_await_expression] = STATE(951),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(951),
    [sym_async_block] = STATE(951),
    [sym_block] = STATE(951),
    [sym__literal] = STATE(951),
    [sym_string_literal] = STATE(951),
    [sym_boolean_literal] = STATE(951),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [sym_mutable_specifier] = ACTIONS(759),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(761),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(761),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(761),
    [sym_float_literal] = ACTIONS(761),
    [sym_block_comment] = ACTIONS(3),
  },
  [83] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1129),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1129),
    [sym_macro_invocation] = STATE(1129),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1129),
    [sym_unary_expression] = STATE(1129),
    [sym_try_expression] = STATE(1129),
    [sym_reference_expression] = STATE(1129),
    [sym_binary_expression] = STATE(1129),
    [sym_assignment_expression] = STATE(1129),
    [sym_compound_assignment_expr] = STATE(1129),
    [sym_type_cast_expression] = STATE(1129),
    [sym_return_expression] = STATE(1129),
    [sym_call_expression] = STATE(1129),
    [sym_array_expression] = STATE(1129),
    [sym_parenthesized_expression] = STATE(1129),
    [sym_tuple_expression] = STATE(1129),
    [sym_unit_expression] = STATE(1129),
    [sym_struct_expression] = STATE(1129),
    [sym_if_expression] = STATE(1129),
    [sym_if_let_expression] = STATE(1129),
    [sym_match_expression] = STATE(1129),
    [sym_while_expression] = STATE(1129),
    [sym_while_let_expression] = STATE(1129),
    [sym_loop_expression] = STATE(1129),
    [sym_for_expression] = STATE(1129),
    [sym_closure_expression] = STATE(1129),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1129),
    [sym_continue_expression] = STATE(1129),
    [sym_index_expression] = STATE(1129),
    [sym_await_expression] = STATE(1129),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1129),
    [sym_async_block] = STATE(1129),
    [sym_block] = STATE(1129),
    [sym__literal] = STATE(1129),
    [sym_string_literal] = STATE(1129),
    [sym_boolean_literal] = STATE(1129),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_RBRACK] = ACTIONS(763),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(729),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(729),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(729),
    [sym_float_literal] = ACTIONS(729),
    [sym_block_comment] = ACTIONS(3),
  },
  [84] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(951),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(951),
    [sym_macro_invocation] = STATE(951),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(951),
    [sym_unary_expression] = STATE(951),
    [sym_try_expression] = STATE(951),
    [sym_reference_expression] = STATE(951),
    [sym_binary_expression] = STATE(951),
    [sym_assignment_expression] = STATE(951),
    [sym_compound_assignment_expr] = STATE(951),
    [sym_type_cast_expression] = STATE(951),
    [sym_return_expression] = STATE(951),
    [sym_call_expression] = STATE(951),
    [sym_array_expression] = STATE(951),
    [sym_parenthesized_expression] = STATE(951),
    [sym_tuple_expression] = STATE(951),
    [sym_unit_expression] = STATE(951),
    [sym_struct_expression] = STATE(951),
    [sym_if_expression] = STATE(951),
    [sym_if_let_expression] = STATE(951),
    [sym_match_expression] = STATE(951),
    [sym_while_expression] = STATE(951),
    [sym_while_let_expression] = STATE(951),
    [sym_loop_expression] = STATE(951),
    [sym_for_expression] = STATE(951),
    [sym_closure_expression] = STATE(951),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(951),
    [sym_continue_expression] = STATE(951),
    [sym_index_expression] = STATE(951),
    [sym_await_expression] = STATE(951),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(951),
    [sym_async_block] = STATE(951),
    [sym_block] = STATE(951),
    [sym__literal] = STATE(951),
    [sym_string_literal] = STATE(951),
    [sym_boolean_literal] = STATE(951),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [sym_mutable_specifier] = ACTIONS(765),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(761),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(761),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(761),
    [sym_float_literal] = ACTIONS(761),
    [sym_block_comment] = ACTIONS(3),
  },
  [85] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1134),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1134),
    [sym_macro_invocation] = STATE(1134),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1134),
    [sym_unary_expression] = STATE(1134),
    [sym_try_expression] = STATE(1134),
    [sym_reference_expression] = STATE(1134),
    [sym_binary_expression] = STATE(1134),
    [sym_assignment_expression] = STATE(1134),
    [sym_compound_assignment_expr] = STATE(1134),
    [sym_type_cast_expression] = STATE(1134),
    [sym_return_expression] = STATE(1134),
    [sym_call_expression] = STATE(1134),
    [sym_array_expression] = STATE(1134),
    [sym_parenthesized_expression] = STATE(1134),
    [sym_tuple_expression] = STATE(1134),
    [sym_unit_expression] = STATE(1134),
    [sym_struct_expression] = STATE(1134),
    [sym_if_expression] = STATE(1134),
    [sym_if_let_expression] = STATE(1134),
    [sym_match_expression] = STATE(1134),
    [sym_while_expression] = STATE(1134),
    [sym_while_let_expression] = STATE(1134),
    [sym_loop_expression] = STATE(1134),
    [sym_for_expression] = STATE(1134),
    [sym_closure_expression] = STATE(1134),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1134),
    [sym_continue_expression] = STATE(1134),
    [sym_index_expression] = STATE(1134),
    [sym_await_expression] = STATE(1134),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1134),
    [sym_async_block] = STATE(1134),
    [sym_block] = STATE(1134),
    [sym__literal] = STATE(1134),
    [sym_string_literal] = STATE(1134),
    [sym_boolean_literal] = STATE(1134),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(767),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(769),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(769),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(769),
    [sym_float_literal] = ACTIONS(769),
    [sym_block_comment] = ACTIONS(3),
  },
  [86] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(997),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(997),
    [sym_macro_invocation] = STATE(997),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(997),
    [sym_unary_expression] = STATE(997),
    [sym_try_expression] = STATE(997),
    [sym_reference_expression] = STATE(997),
    [sym_binary_expression] = STATE(997),
    [sym_assignment_expression] = STATE(997),
    [sym_compound_assignment_expr] = STATE(997),
    [sym_type_cast_expression] = STATE(997),
    [sym_return_expression] = STATE(997),
    [sym_call_expression] = STATE(997),
    [sym_array_expression] = STATE(997),
    [sym_parenthesized_expression] = STATE(997),
    [sym_tuple_expression] = STATE(997),
    [sym_unit_expression] = STATE(997),
    [sym_struct_expression] = STATE(997),
    [sym_if_expression] = STATE(997),
    [sym_if_let_expression] = STATE(997),
    [sym_match_expression] = STATE(997),
    [sym_while_expression] = STATE(997),
    [sym_while_let_expression] = STATE(997),
    [sym_loop_expression] = STATE(997),
    [sym_for_expression] = STATE(997),
    [sym_closure_expression] = STATE(997),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(997),
    [sym_continue_expression] = STATE(997),
    [sym_index_expression] = STATE(997),
    [sym_await_expression] = STATE(997),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(997),
    [sym_async_block] = STATE(997),
    [sym_block] = STATE(997),
    [sym__literal] = STATE(997),
    [sym_string_literal] = STATE(997),
    [sym_boolean_literal] = STATE(997),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_DASH_GT] = ACTIONS(743),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(771),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(771),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(771),
    [sym_float_literal] = ACTIONS(771),
    [sym_block_comment] = ACTIONS(3),
  },
  [87] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1084),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1084),
    [sym_macro_invocation] = STATE(1084),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1084),
    [sym_unary_expression] = STATE(1084),
    [sym_try_expression] = STATE(1084),
    [sym_reference_expression] = STATE(1084),
    [sym_binary_expression] = STATE(1084),
    [sym_assignment_expression] = STATE(1084),
    [sym_compound_assignment_expr] = STATE(1084),
    [sym_type_cast_expression] = STATE(1084),
    [sym_return_expression] = STATE(1084),
    [sym_call_expression] = STATE(1084),
    [sym_array_expression] = STATE(1084),
    [sym_parenthesized_expression] = STATE(1084),
    [sym_tuple_expression] = STATE(1084),
    [sym_unit_expression] = STATE(1084),
    [sym_struct_expression] = STATE(1084),
    [sym_if_expression] = STATE(1084),
    [sym_if_let_expression] = STATE(1084),
    [sym_match_expression] = STATE(1084),
    [sym_while_expression] = STATE(1084),
    [sym_while_let_expression] = STATE(1084),
    [sym_loop_expression] = STATE(1084),
    [sym_for_expression] = STATE(1084),
    [sym_closure_expression] = STATE(1084),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1084),
    [sym_continue_expression] = STATE(1084),
    [sym_index_expression] = STATE(1084),
    [sym_await_expression] = STATE(1084),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1084),
    [sym_async_block] = STATE(1084),
    [sym_block] = STATE(1084),
    [sym__literal] = STATE(1084),
    [sym_string_literal] = STATE(1084),
    [sym_boolean_literal] = STATE(1084),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(773),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(775),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(775),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(775),
    [sym_float_literal] = ACTIONS(775),
    [sym_block_comment] = ACTIONS(3),
  },
  [88] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1088),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1088),
    [sym_macro_invocation] = STATE(1088),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1088),
    [sym_unary_expression] = STATE(1088),
    [sym_try_expression] = STATE(1088),
    [sym_reference_expression] = STATE(1088),
    [sym_binary_expression] = STATE(1088),
    [sym_assignment_expression] = STATE(1088),
    [sym_compound_assignment_expr] = STATE(1088),
    [sym_type_cast_expression] = STATE(1088),
    [sym_return_expression] = STATE(1088),
    [sym_call_expression] = STATE(1088),
    [sym_array_expression] = STATE(1088),
    [sym_parenthesized_expression] = STATE(1088),
    [sym_tuple_expression] = STATE(1088),
    [sym_unit_expression] = STATE(1088),
    [sym_struct_expression] = STATE(1088),
    [sym_if_expression] = STATE(1088),
    [sym_if_let_expression] = STATE(1088),
    [sym_match_expression] = STATE(1088),
    [sym_while_expression] = STATE(1088),
    [sym_while_let_expression] = STATE(1088),
    [sym_loop_expression] = STATE(1088),
    [sym_for_expression] = STATE(1088),
    [sym_closure_expression] = STATE(1088),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1088),
    [sym_continue_expression] = STATE(1088),
    [sym_index_expression] = STATE(1088),
    [sym_await_expression] = STATE(1088),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1088),
    [sym_async_block] = STATE(1088),
    [sym_block] = STATE(1088),
    [sym__literal] = STATE(1088),
    [sym_string_literal] = STATE(1088),
    [sym_boolean_literal] = STATE(1088),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(777),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(779),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(779),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(779),
    [sym_float_literal] = ACTIONS(779),
    [sym_block_comment] = ACTIONS(3),
  },
  [89] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1132),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1132),
    [sym_macro_invocation] = STATE(1132),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1132),
    [sym_unary_expression] = STATE(1132),
    [sym_try_expression] = STATE(1132),
    [sym_reference_expression] = STATE(1132),
    [sym_binary_expression] = STATE(1132),
    [sym_assignment_expression] = STATE(1132),
    [sym_compound_assignment_expr] = STATE(1132),
    [sym_type_cast_expression] = STATE(1132),
    [sym_return_expression] = STATE(1132),
    [sym_call_expression] = STATE(1132),
    [sym_array_expression] = STATE(1132),
    [sym_parenthesized_expression] = STATE(1132),
    [sym_tuple_expression] = STATE(1132),
    [sym_unit_expression] = STATE(1132),
    [sym_struct_expression] = STATE(1132),
    [sym_if_expression] = STATE(1132),
    [sym_if_let_expression] = STATE(1132),
    [sym_match_expression] = STATE(1132),
    [sym_while_expression] = STATE(1132),
    [sym_while_let_expression] = STATE(1132),
    [sym_loop_expression] = STATE(1132),
    [sym_for_expression] = STATE(1132),
    [sym_closure_expression] = STATE(1132),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1132),
    [sym_continue_expression] = STATE(1132),
    [sym_index_expression] = STATE(1132),
    [sym_await_expression] = STATE(1132),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1132),
    [sym_async_block] = STATE(1132),
    [sym_block] = STATE(1132),
    [sym__literal] = STATE(1132),
    [sym_string_literal] = STATE(1132),
    [sym_boolean_literal] = STATE(1132),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(781),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(783),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(783),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(783),
    [sym_float_literal] = ACTIONS(783),
    [sym_block_comment] = ACTIONS(3),
  },
  [90] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1090),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1090),
    [sym_macro_invocation] = STATE(1090),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1090),
    [sym_unary_expression] = STATE(1090),
    [sym_try_expression] = STATE(1090),
    [sym_reference_expression] = STATE(1090),
    [sym_binary_expression] = STATE(1090),
    [sym_assignment_expression] = STATE(1090),
    [sym_compound_assignment_expr] = STATE(1090),
    [sym_type_cast_expression] = STATE(1090),
    [sym_return_expression] = STATE(1090),
    [sym_call_expression] = STATE(1090),
    [sym_array_expression] = STATE(1090),
    [sym_parenthesized_expression] = STATE(1090),
    [sym_tuple_expression] = STATE(1090),
    [sym_unit_expression] = STATE(1090),
    [sym_struct_expression] = STATE(1090),
    [sym_if_expression] = STATE(1090),
    [sym_if_let_expression] = STATE(1090),
    [sym_match_expression] = STATE(1090),
    [sym_while_expression] = STATE(1090),
    [sym_while_let_expression] = STATE(1090),
    [sym_loop_expression] = STATE(1090),
    [sym_for_expression] = STATE(1090),
    [sym_closure_expression] = STATE(1090),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1090),
    [sym_continue_expression] = STATE(1090),
    [sym_index_expression] = STATE(1090),
    [sym_await_expression] = STATE(1090),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1090),
    [sym_async_block] = STATE(1090),
    [sym_block] = STATE(1090),
    [sym__literal] = STATE(1090),
    [sym_string_literal] = STATE(1090),
    [sym_boolean_literal] = STATE(1090),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_let] = ACTIONS(785),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(787),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(787),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(787),
    [sym_float_literal] = ACTIONS(787),
    [sym_block_comment] = ACTIONS(3),
  },
  [91] = {
    [sym_attribute_item] = STATE(186),
    [sym_function_modifiers] = STATE(2207),
    [sym_self_parameter] = STATE(1928),
    [sym_variadic_parameter] = STATE(1928),
    [sym_parameter] = STATE(1928),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1660),
    [sym_bracketed_type] = STATE(2318),
    [sym_lifetime] = STATE(1828),
    [sym_array_type] = STATE(1660),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1660),
    [sym_tuple_type] = STATE(1660),
    [sym_unit_type] = STATE(1660),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2319),
    [sym_bounded_type] = STATE(1660),
    [sym_reference_type] = STATE(1660),
    [sym_pointer_type] = STATE(1660),
    [sym_empty_type] = STATE(1660),
    [sym_abstract_type] = STATE(1660),
    [sym_dynamic_type] = STATE(1660),
    [sym_macro_invocation] = STATE(1660),
    [sym_scoped_identifier] = STATE(1472),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(2132),
    [sym_tuple_pattern] = STATE(2132),
    [sym_slice_pattern] = STATE(2132),
    [sym_tuple_struct_pattern] = STATE(2132),
    [sym_struct_pattern] = STATE(2132),
    [sym_remaining_field_pattern] = STATE(2132),
    [sym_mut_pattern] = STATE(2132),
    [sym_range_pattern] = STATE(2132),
    [sym_ref_pattern] = STATE(2132),
    [sym_captured_pattern] = STATE(2132),
    [sym_reference_pattern] = STATE(2132),
    [sym_or_pattern] = STATE(2132),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(793),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(795),
    [anon_sym_i8] = ACTIONS(795),
    [anon_sym_u16] = ACTIONS(795),
    [anon_sym_i16] = ACTIONS(795),
    [anon_sym_u32] = ACTIONS(795),
    [anon_sym_i32] = ACTIONS(795),
    [anon_sym_u64] = ACTIONS(795),
    [anon_sym_i64] = ACTIONS(795),
    [anon_sym_u128] = ACTIONS(795),
    [anon_sym_i128] = ACTIONS(795),
    [anon_sym_isize] = ACTIONS(795),
    [anon_sym_usize] = ACTIONS(795),
    [anon_sym_f32] = ACTIONS(795),
    [anon_sym_f64] = ACTIONS(795),
    [anon_sym_bool] = ACTIONS(795),
    [anon_sym_str] = ACTIONS(795),
    [anon_sym_char] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(665),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_union] = ACTIONS(673),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(675),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(797),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym__] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(691),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(695),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(805),
    [sym_super] = ACTIONS(807),
    [sym_crate] = ACTIONS(807),
    [sym_metavariable] = ACTIONS(809),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [92] = {
    [sym_attribute_item] = STATE(185),
    [sym_function_modifiers] = STATE(2207),
    [sym_self_parameter] = STATE(1833),
    [sym_variadic_parameter] = STATE(1833),
    [sym_parameter] = STATE(1833),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1676),
    [sym_bracketed_type] = STATE(2318),
    [sym_lifetime] = STATE(1828),
    [sym_array_type] = STATE(1676),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1676),
    [sym_tuple_type] = STATE(1676),
    [sym_unit_type] = STATE(1676),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2319),
    [sym_bounded_type] = STATE(1676),
    [sym_reference_type] = STATE(1676),
    [sym_pointer_type] = STATE(1676),
    [sym_empty_type] = STATE(1676),
    [sym_abstract_type] = STATE(1676),
    [sym_dynamic_type] = STATE(1676),
    [sym_macro_invocation] = STATE(1676),
    [sym_scoped_identifier] = STATE(1472),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(2132),
    [sym_tuple_pattern] = STATE(2132),
    [sym_slice_pattern] = STATE(2132),
    [sym_tuple_struct_pattern] = STATE(2132),
    [sym_struct_pattern] = STATE(2132),
    [sym_remaining_field_pattern] = STATE(2132),
    [sym_mut_pattern] = STATE(2132),
    [sym_range_pattern] = STATE(2132),
    [sym_ref_pattern] = STATE(2132),
    [sym_captured_pattern] = STATE(2132),
    [sym_reference_pattern] = STATE(2132),
    [sym_or_pattern] = STATE(2132),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(811),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(795),
    [anon_sym_i8] = ACTIONS(795),
    [anon_sym_u16] = ACTIONS(795),
    [anon_sym_i16] = ACTIONS(795),
    [anon_sym_u32] = ACTIONS(795),
    [anon_sym_i32] = ACTIONS(795),
    [anon_sym_u64] = ACTIONS(795),
    [anon_sym_i64] = ACTIONS(795),
    [anon_sym_u128] = ACTIONS(795),
    [anon_sym_i128] = ACTIONS(795),
    [anon_sym_isize] = ACTIONS(795),
    [anon_sym_usize] = ACTIONS(795),
    [anon_sym_f32] = ACTIONS(795),
    [anon_sym_f64] = ACTIONS(795),
    [anon_sym_bool] = ACTIONS(795),
    [anon_sym_str] = ACTIONS(795),
    [anon_sym_char] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(665),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_union] = ACTIONS(673),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(675),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym__] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(691),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(695),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(805),
    [sym_super] = ACTIONS(807),
    [sym_crate] = ACTIONS(807),
    [sym_metavariable] = ACTIONS(809),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [93] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1201),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1201),
    [sym_macro_invocation] = STATE(1201),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1201),
    [sym_unary_expression] = STATE(1201),
    [sym_try_expression] = STATE(1201),
    [sym_reference_expression] = STATE(1201),
    [sym_binary_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1201),
    [sym_compound_assignment_expr] = STATE(1201),
    [sym_type_cast_expression] = STATE(1201),
    [sym_return_expression] = STATE(1201),
    [sym_call_expression] = STATE(1201),
    [sym_array_expression] = STATE(1201),
    [sym_parenthesized_expression] = STATE(1201),
    [sym_tuple_expression] = STATE(1201),
    [sym_unit_expression] = STATE(1201),
    [sym_struct_expression] = STATE(1201),
    [sym_if_expression] = STATE(1201),
    [sym_if_let_expression] = STATE(1201),
    [sym_match_expression] = STATE(1201),
    [sym_while_expression] = STATE(1201),
    [sym_while_let_expression] = STATE(1201),
    [sym_loop_expression] = STATE(1201),
    [sym_for_expression] = STATE(1201),
    [sym_closure_expression] = STATE(1201),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1201),
    [sym_continue_expression] = STATE(1201),
    [sym_index_expression] = STATE(1201),
    [sym_await_expression] = STATE(1201),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1201),
    [sym_async_block] = STATE(1201),
    [sym_block] = STATE(1201),
    [sym__literal] = STATE(1201),
    [sym_string_literal] = STATE(1201),
    [sym_boolean_literal] = STATE(1201),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(817),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(817),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(817),
    [sym_float_literal] = ACTIONS(817),
    [sym_block_comment] = ACTIONS(3),
  },
  [94] = {
    [sym_attribute_item] = STATE(184),
    [sym_function_modifiers] = STATE(2207),
    [sym_self_parameter] = STATE(2017),
    [sym_variadic_parameter] = STATE(2017),
    [sym_parameter] = STATE(2017),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1752),
    [sym_bracketed_type] = STATE(2318),
    [sym_lifetime] = STATE(1828),
    [sym_array_type] = STATE(1752),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1752),
    [sym_tuple_type] = STATE(1752),
    [sym_unit_type] = STATE(1752),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2319),
    [sym_bounded_type] = STATE(1752),
    [sym_reference_type] = STATE(1752),
    [sym_pointer_type] = STATE(1752),
    [sym_empty_type] = STATE(1752),
    [sym_abstract_type] = STATE(1752),
    [sym_dynamic_type] = STATE(1752),
    [sym_macro_invocation] = STATE(1752),
    [sym_scoped_identifier] = STATE(1472),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(2132),
    [sym_tuple_pattern] = STATE(2132),
    [sym_slice_pattern] = STATE(2132),
    [sym_tuple_struct_pattern] = STATE(2132),
    [sym_struct_pattern] = STATE(2132),
    [sym_remaining_field_pattern] = STATE(2132),
    [sym_mut_pattern] = STATE(2132),
    [sym_range_pattern] = STATE(2132),
    [sym_ref_pattern] = STATE(2132),
    [sym_captured_pattern] = STATE(2132),
    [sym_reference_pattern] = STATE(2132),
    [sym_or_pattern] = STATE(2132),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(819),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(795),
    [anon_sym_i8] = ACTIONS(795),
    [anon_sym_u16] = ACTIONS(795),
    [anon_sym_i16] = ACTIONS(795),
    [anon_sym_u32] = ACTIONS(795),
    [anon_sym_i32] = ACTIONS(795),
    [anon_sym_u64] = ACTIONS(795),
    [anon_sym_i64] = ACTIONS(795),
    [anon_sym_u128] = ACTIONS(795),
    [anon_sym_i128] = ACTIONS(795),
    [anon_sym_isize] = ACTIONS(795),
    [anon_sym_usize] = ACTIONS(795),
    [anon_sym_f32] = ACTIONS(795),
    [anon_sym_f64] = ACTIONS(795),
    [anon_sym_bool] = ACTIONS(795),
    [anon_sym_str] = ACTIONS(795),
    [anon_sym_char] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(665),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_union] = ACTIONS(673),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(675),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym__] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(691),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(695),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(805),
    [sym_super] = ACTIONS(807),
    [sym_crate] = ACTIONS(807),
    [sym_metavariable] = ACTIONS(809),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [95] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1121),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1121),
    [sym_macro_invocation] = STATE(1121),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1121),
    [sym_unary_expression] = STATE(1121),
    [sym_try_expression] = STATE(1121),
    [sym_reference_expression] = STATE(1121),
    [sym_binary_expression] = STATE(1121),
    [sym_assignment_expression] = STATE(1121),
    [sym_compound_assignment_expr] = STATE(1121),
    [sym_type_cast_expression] = STATE(1121),
    [sym_return_expression] = STATE(1121),
    [sym_call_expression] = STATE(1121),
    [sym_array_expression] = STATE(1121),
    [sym_parenthesized_expression] = STATE(1121),
    [sym_tuple_expression] = STATE(1121),
    [sym_unit_expression] = STATE(1121),
    [sym_struct_expression] = STATE(1121),
    [sym_if_expression] = STATE(1121),
    [sym_if_let_expression] = STATE(1121),
    [sym_match_expression] = STATE(1121),
    [sym_while_expression] = STATE(1121),
    [sym_while_let_expression] = STATE(1121),
    [sym_loop_expression] = STATE(1121),
    [sym_for_expression] = STATE(1121),
    [sym_closure_expression] = STATE(1121),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1121),
    [sym_continue_expression] = STATE(1121),
    [sym_index_expression] = STATE(1121),
    [sym_await_expression] = STATE(1121),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1121),
    [sym_async_block] = STATE(1121),
    [sym_block] = STATE(1121),
    [sym__literal] = STATE(1121),
    [sym_string_literal] = STATE(1121),
    [sym_boolean_literal] = STATE(1121),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(823),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(823),
    [sym_float_literal] = ACTIONS(823),
    [sym_block_comment] = ACTIONS(3),
  },
  [96] = {
    [sym_attribute_item] = STATE(184),
    [sym_function_modifiers] = STATE(2207),
    [sym_self_parameter] = STATE(2017),
    [sym_variadic_parameter] = STATE(2017),
    [sym_parameter] = STATE(2017),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1752),
    [sym_bracketed_type] = STATE(2318),
    [sym_lifetime] = STATE(1828),
    [sym_array_type] = STATE(1752),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1752),
    [sym_tuple_type] = STATE(1752),
    [sym_unit_type] = STATE(1752),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2319),
    [sym_bounded_type] = STATE(1752),
    [sym_reference_type] = STATE(1752),
    [sym_pointer_type] = STATE(1752),
    [sym_empty_type] = STATE(1752),
    [sym_abstract_type] = STATE(1752),
    [sym_dynamic_type] = STATE(1752),
    [sym_macro_invocation] = STATE(1752),
    [sym_scoped_identifier] = STATE(1472),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(2132),
    [sym_tuple_pattern] = STATE(2132),
    [sym_slice_pattern] = STATE(2132),
    [sym_tuple_struct_pattern] = STATE(2132),
    [sym_struct_pattern] = STATE(2132),
    [sym_remaining_field_pattern] = STATE(2132),
    [sym_mut_pattern] = STATE(2132),
    [sym_range_pattern] = STATE(2132),
    [sym_ref_pattern] = STATE(2132),
    [sym_captured_pattern] = STATE(2132),
    [sym_reference_pattern] = STATE(2132),
    [sym_or_pattern] = STATE(2132),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(825),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(795),
    [anon_sym_i8] = ACTIONS(795),
    [anon_sym_u16] = ACTIONS(795),
    [anon_sym_i16] = ACTIONS(795),
    [anon_sym_u32] = ACTIONS(795),
    [anon_sym_i32] = ACTIONS(795),
    [anon_sym_u64] = ACTIONS(795),
    [anon_sym_i64] = ACTIONS(795),
    [anon_sym_u128] = ACTIONS(795),
    [anon_sym_i128] = ACTIONS(795),
    [anon_sym_isize] = ACTIONS(795),
    [anon_sym_usize] = ACTIONS(795),
    [anon_sym_f32] = ACTIONS(795),
    [anon_sym_f64] = ACTIONS(795),
    [anon_sym_bool] = ACTIONS(795),
    [anon_sym_str] = ACTIONS(795),
    [anon_sym_char] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(665),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_union] = ACTIONS(673),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(675),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym__] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(691),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(695),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(805),
    [sym_super] = ACTIONS(807),
    [sym_crate] = ACTIONS(807),
    [sym_metavariable] = ACTIONS(809),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [97] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1110),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1110),
    [sym_macro_invocation] = STATE(1110),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1110),
    [sym_unary_expression] = STATE(1110),
    [sym_try_expression] = STATE(1110),
    [sym_reference_expression] = STATE(1110),
    [sym_binary_expression] = STATE(1110),
    [sym_assignment_expression] = STATE(1110),
    [sym_compound_assignment_expr] = STATE(1110),
    [sym_type_cast_expression] = STATE(1110),
    [sym_return_expression] = STATE(1110),
    [sym_call_expression] = STATE(1110),
    [sym_array_expression] = STATE(1110),
    [sym_parenthesized_expression] = STATE(1110),
    [sym_tuple_expression] = STATE(1110),
    [sym_unit_expression] = STATE(1110),
    [sym_struct_expression] = STATE(1110),
    [sym_if_expression] = STATE(1110),
    [sym_if_let_expression] = STATE(1110),
    [sym_match_expression] = STATE(1110),
    [sym_while_expression] = STATE(1110),
    [sym_while_let_expression] = STATE(1110),
    [sym_loop_expression] = STATE(1110),
    [sym_for_expression] = STATE(1110),
    [sym_closure_expression] = STATE(1110),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1110),
    [sym_continue_expression] = STATE(1110),
    [sym_index_expression] = STATE(1110),
    [sym_await_expression] = STATE(1110),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1110),
    [sym_async_block] = STATE(1110),
    [sym_block] = STATE(1110),
    [sym__literal] = STATE(1110),
    [sym_string_literal] = STATE(1110),
    [sym_boolean_literal] = STATE(1110),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(827),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(827),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(827),
    [sym_float_literal] = ACTIONS(827),
    [sym_block_comment] = ACTIONS(3),
  },
  [98] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1159),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1159),
    [sym_macro_invocation] = STATE(1159),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1159),
    [sym_unary_expression] = STATE(1159),
    [sym_try_expression] = STATE(1159),
    [sym_reference_expression] = STATE(1159),
    [sym_binary_expression] = STATE(1159),
    [sym_assignment_expression] = STATE(1159),
    [sym_compound_assignment_expr] = STATE(1159),
    [sym_type_cast_expression] = STATE(1159),
    [sym_return_expression] = STATE(1159),
    [sym_call_expression] = STATE(1159),
    [sym_array_expression] = STATE(1159),
    [sym_parenthesized_expression] = STATE(1159),
    [sym_tuple_expression] = STATE(1159),
    [sym_unit_expression] = STATE(1159),
    [sym_struct_expression] = STATE(1159),
    [sym_if_expression] = STATE(1159),
    [sym_if_let_expression] = STATE(1159),
    [sym_match_expression] = STATE(1159),
    [sym_while_expression] = STATE(1159),
    [sym_while_let_expression] = STATE(1159),
    [sym_loop_expression] = STATE(1159),
    [sym_for_expression] = STATE(1159),
    [sym_closure_expression] = STATE(1159),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1159),
    [sym_continue_expression] = STATE(1159),
    [sym_index_expression] = STATE(1159),
    [sym_await_expression] = STATE(1159),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1159),
    [sym_async_block] = STATE(1159),
    [sym_block] = STATE(1159),
    [sym__literal] = STATE(1159),
    [sym_string_literal] = STATE(1159),
    [sym_boolean_literal] = STATE(1159),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(829),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(829),
    [sym_float_literal] = ACTIONS(829),
    [sym_block_comment] = ACTIONS(3),
  },
  [99] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1177),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1177),
    [sym_macro_invocation] = STATE(1177),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1177),
    [sym_unary_expression] = STATE(1177),
    [sym_try_expression] = STATE(1177),
    [sym_reference_expression] = STATE(1177),
    [sym_binary_expression] = STATE(1177),
    [sym_assignment_expression] = STATE(1177),
    [sym_compound_assignment_expr] = STATE(1177),
    [sym_type_cast_expression] = STATE(1177),
    [sym_return_expression] = STATE(1177),
    [sym_call_expression] = STATE(1177),
    [sym_array_expression] = STATE(1177),
    [sym_parenthesized_expression] = STATE(1177),
    [sym_tuple_expression] = STATE(1177),
    [sym_unit_expression] = STATE(1177),
    [sym_struct_expression] = STATE(1177),
    [sym_if_expression] = STATE(1177),
    [sym_if_let_expression] = STATE(1177),
    [sym_match_expression] = STATE(1177),
    [sym_while_expression] = STATE(1177),
    [sym_while_let_expression] = STATE(1177),
    [sym_loop_expression] = STATE(1177),
    [sym_for_expression] = STATE(1177),
    [sym_closure_expression] = STATE(1177),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1177),
    [sym_continue_expression] = STATE(1177),
    [sym_index_expression] = STATE(1177),
    [sym_await_expression] = STATE(1177),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1177),
    [sym_async_block] = STATE(1177),
    [sym_block] = STATE(1177),
    [sym__literal] = STATE(1177),
    [sym_string_literal] = STATE(1177),
    [sym_boolean_literal] = STATE(1177),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(831),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(831),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(831),
    [sym_float_literal] = ACTIONS(831),
    [sym_block_comment] = ACTIONS(3),
  },
  [100] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1158),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1158),
    [sym_macro_invocation] = STATE(1158),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1158),
    [sym_unary_expression] = STATE(1158),
    [sym_try_expression] = STATE(1158),
    [sym_reference_expression] = STATE(1158),
    [sym_binary_expression] = STATE(1158),
    [sym_assignment_expression] = STATE(1158),
    [sym_compound_assignment_expr] = STATE(1158),
    [sym_type_cast_expression] = STATE(1158),
    [sym_return_expression] = STATE(1158),
    [sym_call_expression] = STATE(1158),
    [sym_array_expression] = STATE(1158),
    [sym_parenthesized_expression] = STATE(1158),
    [sym_tuple_expression] = STATE(1158),
    [sym_unit_expression] = STATE(1158),
    [sym_struct_expression] = STATE(1158),
    [sym_if_expression] = STATE(1158),
    [sym_if_let_expression] = STATE(1158),
    [sym_match_expression] = STATE(1158),
    [sym_while_expression] = STATE(1158),
    [sym_while_let_expression] = STATE(1158),
    [sym_loop_expression] = STATE(1158),
    [sym_for_expression] = STATE(1158),
    [sym_closure_expression] = STATE(1158),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1158),
    [sym_continue_expression] = STATE(1158),
    [sym_index_expression] = STATE(1158),
    [sym_await_expression] = STATE(1158),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1158),
    [sym_async_block] = STATE(1158),
    [sym_block] = STATE(1158),
    [sym__literal] = STATE(1158),
    [sym_string_literal] = STATE(1158),
    [sym_boolean_literal] = STATE(1158),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(833),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(833),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(833),
    [sym_float_literal] = ACTIONS(833),
    [sym_block_comment] = ACTIONS(3),
  },
  [101] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1149),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1149),
    [sym_macro_invocation] = STATE(1149),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1149),
    [sym_unary_expression] = STATE(1149),
    [sym_try_expression] = STATE(1149),
    [sym_reference_expression] = STATE(1149),
    [sym_binary_expression] = STATE(1149),
    [sym_assignment_expression] = STATE(1149),
    [sym_compound_assignment_expr] = STATE(1149),
    [sym_type_cast_expression] = STATE(1149),
    [sym_return_expression] = STATE(1149),
    [sym_call_expression] = STATE(1149),
    [sym_array_expression] = STATE(1149),
    [sym_parenthesized_expression] = STATE(1149),
    [sym_tuple_expression] = STATE(1149),
    [sym_unit_expression] = STATE(1149),
    [sym_struct_expression] = STATE(1149),
    [sym_if_expression] = STATE(1149),
    [sym_if_let_expression] = STATE(1149),
    [sym_match_expression] = STATE(1149),
    [sym_while_expression] = STATE(1149),
    [sym_while_let_expression] = STATE(1149),
    [sym_loop_expression] = STATE(1149),
    [sym_for_expression] = STATE(1149),
    [sym_closure_expression] = STATE(1149),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1149),
    [sym_continue_expression] = STATE(1149),
    [sym_index_expression] = STATE(1149),
    [sym_await_expression] = STATE(1149),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1149),
    [sym_async_block] = STATE(1149),
    [sym_block] = STATE(1149),
    [sym__literal] = STATE(1149),
    [sym_string_literal] = STATE(1149),
    [sym_boolean_literal] = STATE(1149),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(835),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(835),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(835),
    [sym_float_literal] = ACTIONS(835),
    [sym_block_comment] = ACTIONS(3),
  },
  [102] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1087),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1087),
    [sym_macro_invocation] = STATE(1087),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1087),
    [sym_unary_expression] = STATE(1087),
    [sym_try_expression] = STATE(1087),
    [sym_reference_expression] = STATE(1087),
    [sym_binary_expression] = STATE(1087),
    [sym_assignment_expression] = STATE(1087),
    [sym_compound_assignment_expr] = STATE(1087),
    [sym_type_cast_expression] = STATE(1087),
    [sym_return_expression] = STATE(1087),
    [sym_call_expression] = STATE(1087),
    [sym_array_expression] = STATE(1087),
    [sym_parenthesized_expression] = STATE(1087),
    [sym_tuple_expression] = STATE(1087),
    [sym_unit_expression] = STATE(1087),
    [sym_struct_expression] = STATE(1087),
    [sym_if_expression] = STATE(1087),
    [sym_if_let_expression] = STATE(1087),
    [sym_match_expression] = STATE(1087),
    [sym_while_expression] = STATE(1087),
    [sym_while_let_expression] = STATE(1087),
    [sym_loop_expression] = STATE(1087),
    [sym_for_expression] = STATE(1087),
    [sym_closure_expression] = STATE(1087),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1087),
    [sym_continue_expression] = STATE(1087),
    [sym_index_expression] = STATE(1087),
    [sym_await_expression] = STATE(1087),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1087),
    [sym_async_block] = STATE(1087),
    [sym_block] = STATE(1087),
    [sym__literal] = STATE(1087),
    [sym_string_literal] = STATE(1087),
    [sym_boolean_literal] = STATE(1087),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(837),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(837),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(837),
    [sym_float_literal] = ACTIONS(837),
    [sym_block_comment] = ACTIONS(3),
  },
  [103] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1194),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1194),
    [sym_macro_invocation] = STATE(1194),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1194),
    [sym_unary_expression] = STATE(1194),
    [sym_try_expression] = STATE(1194),
    [sym_reference_expression] = STATE(1194),
    [sym_binary_expression] = STATE(1194),
    [sym_assignment_expression] = STATE(1194),
    [sym_compound_assignment_expr] = STATE(1194),
    [sym_type_cast_expression] = STATE(1194),
    [sym_return_expression] = STATE(1194),
    [sym_call_expression] = STATE(1194),
    [sym_array_expression] = STATE(1194),
    [sym_parenthesized_expression] = STATE(1194),
    [sym_tuple_expression] = STATE(1194),
    [sym_unit_expression] = STATE(1194),
    [sym_struct_expression] = STATE(1194),
    [sym_if_expression] = STATE(1194),
    [sym_if_let_expression] = STATE(1194),
    [sym_match_expression] = STATE(1194),
    [sym_while_expression] = STATE(1194),
    [sym_while_let_expression] = STATE(1194),
    [sym_loop_expression] = STATE(1194),
    [sym_for_expression] = STATE(1194),
    [sym_closure_expression] = STATE(1194),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1194),
    [sym_continue_expression] = STATE(1194),
    [sym_index_expression] = STATE(1194),
    [sym_await_expression] = STATE(1194),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1194),
    [sym_async_block] = STATE(1194),
    [sym_block] = STATE(1194),
    [sym__literal] = STATE(1194),
    [sym_string_literal] = STATE(1194),
    [sym_boolean_literal] = STATE(1194),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(839),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(839),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(839),
    [sym_float_literal] = ACTIONS(839),
    [sym_block_comment] = ACTIONS(3),
  },
  [104] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1104),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1104),
    [sym_macro_invocation] = STATE(1104),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1104),
    [sym_unary_expression] = STATE(1104),
    [sym_try_expression] = STATE(1104),
    [sym_reference_expression] = STATE(1104),
    [sym_binary_expression] = STATE(1104),
    [sym_assignment_expression] = STATE(1104),
    [sym_compound_assignment_expr] = STATE(1104),
    [sym_type_cast_expression] = STATE(1104),
    [sym_return_expression] = STATE(1104),
    [sym_call_expression] = STATE(1104),
    [sym_array_expression] = STATE(1104),
    [sym_parenthesized_expression] = STATE(1104),
    [sym_tuple_expression] = STATE(1104),
    [sym_unit_expression] = STATE(1104),
    [sym_struct_expression] = STATE(1104),
    [sym_if_expression] = STATE(1104),
    [sym_if_let_expression] = STATE(1104),
    [sym_match_expression] = STATE(1104),
    [sym_while_expression] = STATE(1104),
    [sym_while_let_expression] = STATE(1104),
    [sym_loop_expression] = STATE(1104),
    [sym_for_expression] = STATE(1104),
    [sym_closure_expression] = STATE(1104),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1104),
    [sym_continue_expression] = STATE(1104),
    [sym_index_expression] = STATE(1104),
    [sym_await_expression] = STATE(1104),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1104),
    [sym_async_block] = STATE(1104),
    [sym_block] = STATE(1104),
    [sym__literal] = STATE(1104),
    [sym_string_literal] = STATE(1104),
    [sym_boolean_literal] = STATE(1104),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(841),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(841),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(841),
    [sym_float_literal] = ACTIONS(841),
    [sym_block_comment] = ACTIONS(3),
  },
  [105] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1204),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1204),
    [sym_macro_invocation] = STATE(1204),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1204),
    [sym_unary_expression] = STATE(1204),
    [sym_try_expression] = STATE(1204),
    [sym_reference_expression] = STATE(1204),
    [sym_binary_expression] = STATE(1204),
    [sym_assignment_expression] = STATE(1204),
    [sym_compound_assignment_expr] = STATE(1204),
    [sym_type_cast_expression] = STATE(1204),
    [sym_return_expression] = STATE(1204),
    [sym_call_expression] = STATE(1204),
    [sym_array_expression] = STATE(1204),
    [sym_parenthesized_expression] = STATE(1204),
    [sym_tuple_expression] = STATE(1204),
    [sym_unit_expression] = STATE(1204),
    [sym_struct_expression] = STATE(1204),
    [sym_if_expression] = STATE(1204),
    [sym_if_let_expression] = STATE(1204),
    [sym_match_expression] = STATE(1204),
    [sym_while_expression] = STATE(1204),
    [sym_while_let_expression] = STATE(1204),
    [sym_loop_expression] = STATE(1204),
    [sym_for_expression] = STATE(1204),
    [sym_closure_expression] = STATE(1204),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1204),
    [sym_continue_expression] = STATE(1204),
    [sym_index_expression] = STATE(1204),
    [sym_await_expression] = STATE(1204),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1204),
    [sym_async_block] = STATE(1204),
    [sym_block] = STATE(1204),
    [sym__literal] = STATE(1204),
    [sym_string_literal] = STATE(1204),
    [sym_boolean_literal] = STATE(1204),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(843),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(843),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(843),
    [sym_float_literal] = ACTIONS(843),
    [sym_block_comment] = ACTIONS(3),
  },
  [106] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1115),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1115),
    [sym_macro_invocation] = STATE(1115),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1115),
    [sym_unary_expression] = STATE(1115),
    [sym_try_expression] = STATE(1115),
    [sym_reference_expression] = STATE(1115),
    [sym_binary_expression] = STATE(1115),
    [sym_assignment_expression] = STATE(1115),
    [sym_compound_assignment_expr] = STATE(1115),
    [sym_type_cast_expression] = STATE(1115),
    [sym_return_expression] = STATE(1115),
    [sym_call_expression] = STATE(1115),
    [sym_array_expression] = STATE(1115),
    [sym_parenthesized_expression] = STATE(1115),
    [sym_tuple_expression] = STATE(1115),
    [sym_unit_expression] = STATE(1115),
    [sym_struct_expression] = STATE(1115),
    [sym_if_expression] = STATE(1115),
    [sym_if_let_expression] = STATE(1115),
    [sym_match_expression] = STATE(1115),
    [sym_while_expression] = STATE(1115),
    [sym_while_let_expression] = STATE(1115),
    [sym_loop_expression] = STATE(1115),
    [sym_for_expression] = STATE(1115),
    [sym_closure_expression] = STATE(1115),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1115),
    [sym_continue_expression] = STATE(1115),
    [sym_index_expression] = STATE(1115),
    [sym_await_expression] = STATE(1115),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1115),
    [sym_async_block] = STATE(1115),
    [sym_block] = STATE(1115),
    [sym__literal] = STATE(1115),
    [sym_string_literal] = STATE(1115),
    [sym_boolean_literal] = STATE(1115),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(845),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(845),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(845),
    [sym_float_literal] = ACTIONS(845),
    [sym_block_comment] = ACTIONS(3),
  },
  [107] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1200),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1200),
    [sym_macro_invocation] = STATE(1200),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1200),
    [sym_unary_expression] = STATE(1200),
    [sym_try_expression] = STATE(1200),
    [sym_reference_expression] = STATE(1200),
    [sym_binary_expression] = STATE(1200),
    [sym_assignment_expression] = STATE(1200),
    [sym_compound_assignment_expr] = STATE(1200),
    [sym_type_cast_expression] = STATE(1200),
    [sym_return_expression] = STATE(1200),
    [sym_call_expression] = STATE(1200),
    [sym_array_expression] = STATE(1200),
    [sym_parenthesized_expression] = STATE(1200),
    [sym_tuple_expression] = STATE(1200),
    [sym_unit_expression] = STATE(1200),
    [sym_struct_expression] = STATE(1200),
    [sym_if_expression] = STATE(1200),
    [sym_if_let_expression] = STATE(1200),
    [sym_match_expression] = STATE(1200),
    [sym_while_expression] = STATE(1200),
    [sym_while_let_expression] = STATE(1200),
    [sym_loop_expression] = STATE(1200),
    [sym_for_expression] = STATE(1200),
    [sym_closure_expression] = STATE(1200),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1200),
    [sym_continue_expression] = STATE(1200),
    [sym_index_expression] = STATE(1200),
    [sym_await_expression] = STATE(1200),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1200),
    [sym_async_block] = STATE(1200),
    [sym_block] = STATE(1200),
    [sym__literal] = STATE(1200),
    [sym_string_literal] = STATE(1200),
    [sym_boolean_literal] = STATE(1200),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(847),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(847),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(847),
    [sym_float_literal] = ACTIONS(847),
    [sym_block_comment] = ACTIONS(3),
  },
  [108] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1199),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1199),
    [sym_macro_invocation] = STATE(1199),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1199),
    [sym_unary_expression] = STATE(1199),
    [sym_try_expression] = STATE(1199),
    [sym_reference_expression] = STATE(1199),
    [sym_binary_expression] = STATE(1199),
    [sym_assignment_expression] = STATE(1199),
    [sym_compound_assignment_expr] = STATE(1199),
    [sym_type_cast_expression] = STATE(1199),
    [sym_return_expression] = STATE(1199),
    [sym_call_expression] = STATE(1199),
    [sym_array_expression] = STATE(1199),
    [sym_parenthesized_expression] = STATE(1199),
    [sym_tuple_expression] = STATE(1199),
    [sym_unit_expression] = STATE(1199),
    [sym_struct_expression] = STATE(1199),
    [sym_if_expression] = STATE(1199),
    [sym_if_let_expression] = STATE(1199),
    [sym_match_expression] = STATE(1199),
    [sym_while_expression] = STATE(1199),
    [sym_while_let_expression] = STATE(1199),
    [sym_loop_expression] = STATE(1199),
    [sym_for_expression] = STATE(1199),
    [sym_closure_expression] = STATE(1199),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1199),
    [sym_continue_expression] = STATE(1199),
    [sym_index_expression] = STATE(1199),
    [sym_await_expression] = STATE(1199),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1199),
    [sym_async_block] = STATE(1199),
    [sym_block] = STATE(1199),
    [sym__literal] = STATE(1199),
    [sym_string_literal] = STATE(1199),
    [sym_boolean_literal] = STATE(1199),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(849),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(849),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(849),
    [sym_float_literal] = ACTIONS(849),
    [sym_block_comment] = ACTIONS(3),
  },
  [109] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1198),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1198),
    [sym_macro_invocation] = STATE(1198),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1198),
    [sym_unary_expression] = STATE(1198),
    [sym_try_expression] = STATE(1198),
    [sym_reference_expression] = STATE(1198),
    [sym_binary_expression] = STATE(1198),
    [sym_assignment_expression] = STATE(1198),
    [sym_compound_assignment_expr] = STATE(1198),
    [sym_type_cast_expression] = STATE(1198),
    [sym_return_expression] = STATE(1198),
    [sym_call_expression] = STATE(1198),
    [sym_array_expression] = STATE(1198),
    [sym_parenthesized_expression] = STATE(1198),
    [sym_tuple_expression] = STATE(1198),
    [sym_unit_expression] = STATE(1198),
    [sym_struct_expression] = STATE(1198),
    [sym_if_expression] = STATE(1198),
    [sym_if_let_expression] = STATE(1198),
    [sym_match_expression] = STATE(1198),
    [sym_while_expression] = STATE(1198),
    [sym_while_let_expression] = STATE(1198),
    [sym_loop_expression] = STATE(1198),
    [sym_for_expression] = STATE(1198),
    [sym_closure_expression] = STATE(1198),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1198),
    [sym_continue_expression] = STATE(1198),
    [sym_index_expression] = STATE(1198),
    [sym_await_expression] = STATE(1198),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1198),
    [sym_async_block] = STATE(1198),
    [sym_block] = STATE(1198),
    [sym__literal] = STATE(1198),
    [sym_string_literal] = STATE(1198),
    [sym_boolean_literal] = STATE(1198),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(851),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(851),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(851),
    [sym_float_literal] = ACTIONS(851),
    [sym_block_comment] = ACTIONS(3),
  },
  [110] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1196),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1196),
    [sym_macro_invocation] = STATE(1196),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1196),
    [sym_unary_expression] = STATE(1196),
    [sym_try_expression] = STATE(1196),
    [sym_reference_expression] = STATE(1196),
    [sym_binary_expression] = STATE(1196),
    [sym_assignment_expression] = STATE(1196),
    [sym_compound_assignment_expr] = STATE(1196),
    [sym_type_cast_expression] = STATE(1196),
    [sym_return_expression] = STATE(1196),
    [sym_call_expression] = STATE(1196),
    [sym_array_expression] = STATE(1196),
    [sym_parenthesized_expression] = STATE(1196),
    [sym_tuple_expression] = STATE(1196),
    [sym_unit_expression] = STATE(1196),
    [sym_struct_expression] = STATE(1196),
    [sym_if_expression] = STATE(1196),
    [sym_if_let_expression] = STATE(1196),
    [sym_match_expression] = STATE(1196),
    [sym_while_expression] = STATE(1196),
    [sym_while_let_expression] = STATE(1196),
    [sym_loop_expression] = STATE(1196),
    [sym_for_expression] = STATE(1196),
    [sym_closure_expression] = STATE(1196),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1196),
    [sym_continue_expression] = STATE(1196),
    [sym_index_expression] = STATE(1196),
    [sym_await_expression] = STATE(1196),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1196),
    [sym_async_block] = STATE(1196),
    [sym_block] = STATE(1196),
    [sym__literal] = STATE(1196),
    [sym_string_literal] = STATE(1196),
    [sym_boolean_literal] = STATE(1196),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(385),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(385),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(385),
    [sym_float_literal] = ACTIONS(385),
    [sym_block_comment] = ACTIONS(3),
  },
  [111] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1193),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1193),
    [sym_macro_invocation] = STATE(1193),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1193),
    [sym_unary_expression] = STATE(1193),
    [sym_try_expression] = STATE(1193),
    [sym_reference_expression] = STATE(1193),
    [sym_binary_expression] = STATE(1193),
    [sym_assignment_expression] = STATE(1193),
    [sym_compound_assignment_expr] = STATE(1193),
    [sym_type_cast_expression] = STATE(1193),
    [sym_return_expression] = STATE(1193),
    [sym_call_expression] = STATE(1193),
    [sym_array_expression] = STATE(1193),
    [sym_parenthesized_expression] = STATE(1193),
    [sym_tuple_expression] = STATE(1193),
    [sym_unit_expression] = STATE(1193),
    [sym_struct_expression] = STATE(1193),
    [sym_if_expression] = STATE(1193),
    [sym_if_let_expression] = STATE(1193),
    [sym_match_expression] = STATE(1193),
    [sym_while_expression] = STATE(1193),
    [sym_while_let_expression] = STATE(1193),
    [sym_loop_expression] = STATE(1193),
    [sym_for_expression] = STATE(1193),
    [sym_closure_expression] = STATE(1193),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1193),
    [sym_continue_expression] = STATE(1193),
    [sym_index_expression] = STATE(1193),
    [sym_await_expression] = STATE(1193),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1193),
    [sym_async_block] = STATE(1193),
    [sym_block] = STATE(1193),
    [sym__literal] = STATE(1193),
    [sym_string_literal] = STATE(1193),
    [sym_boolean_literal] = STATE(1193),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(853),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(853),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(853),
    [sym_float_literal] = ACTIONS(853),
    [sym_block_comment] = ACTIONS(3),
  },
  [112] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1099),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1099),
    [sym_macro_invocation] = STATE(1099),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1099),
    [sym_unary_expression] = STATE(1099),
    [sym_try_expression] = STATE(1099),
    [sym_reference_expression] = STATE(1099),
    [sym_binary_expression] = STATE(1099),
    [sym_assignment_expression] = STATE(1099),
    [sym_compound_assignment_expr] = STATE(1099),
    [sym_type_cast_expression] = STATE(1099),
    [sym_return_expression] = STATE(1099),
    [sym_call_expression] = STATE(1099),
    [sym_array_expression] = STATE(1099),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_tuple_expression] = STATE(1099),
    [sym_unit_expression] = STATE(1099),
    [sym_struct_expression] = STATE(1099),
    [sym_if_expression] = STATE(1099),
    [sym_if_let_expression] = STATE(1099),
    [sym_match_expression] = STATE(1099),
    [sym_while_expression] = STATE(1099),
    [sym_while_let_expression] = STATE(1099),
    [sym_loop_expression] = STATE(1099),
    [sym_for_expression] = STATE(1099),
    [sym_closure_expression] = STATE(1099),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1099),
    [sym_continue_expression] = STATE(1099),
    [sym_index_expression] = STATE(1099),
    [sym_await_expression] = STATE(1099),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1099),
    [sym_async_block] = STATE(1099),
    [sym_block] = STATE(1099),
    [sym__literal] = STATE(1099),
    [sym_string_literal] = STATE(1099),
    [sym_boolean_literal] = STATE(1099),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(855),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(855),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(855),
    [sym_float_literal] = ACTIONS(855),
    [sym_block_comment] = ACTIONS(3),
  },
  [113] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1192),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1192),
    [sym_macro_invocation] = STATE(1192),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1192),
    [sym_unary_expression] = STATE(1192),
    [sym_try_expression] = STATE(1192),
    [sym_reference_expression] = STATE(1192),
    [sym_binary_expression] = STATE(1192),
    [sym_assignment_expression] = STATE(1192),
    [sym_compound_assignment_expr] = STATE(1192),
    [sym_type_cast_expression] = STATE(1192),
    [sym_return_expression] = STATE(1192),
    [sym_call_expression] = STATE(1192),
    [sym_array_expression] = STATE(1192),
    [sym_parenthesized_expression] = STATE(1192),
    [sym_tuple_expression] = STATE(1192),
    [sym_unit_expression] = STATE(1192),
    [sym_struct_expression] = STATE(1192),
    [sym_if_expression] = STATE(1192),
    [sym_if_let_expression] = STATE(1192),
    [sym_match_expression] = STATE(1192),
    [sym_while_expression] = STATE(1192),
    [sym_while_let_expression] = STATE(1192),
    [sym_loop_expression] = STATE(1192),
    [sym_for_expression] = STATE(1192),
    [sym_closure_expression] = STATE(1192),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1192),
    [sym_continue_expression] = STATE(1192),
    [sym_index_expression] = STATE(1192),
    [sym_await_expression] = STATE(1192),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1192),
    [sym_async_block] = STATE(1192),
    [sym_block] = STATE(1192),
    [sym__literal] = STATE(1192),
    [sym_string_literal] = STATE(1192),
    [sym_boolean_literal] = STATE(1192),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(857),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(857),
    [sym_float_literal] = ACTIONS(857),
    [sym_block_comment] = ACTIONS(3),
  },
  [114] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1169),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1169),
    [sym_macro_invocation] = STATE(1169),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1169),
    [sym_unary_expression] = STATE(1169),
    [sym_try_expression] = STATE(1169),
    [sym_reference_expression] = STATE(1169),
    [sym_binary_expression] = STATE(1169),
    [sym_assignment_expression] = STATE(1169),
    [sym_compound_assignment_expr] = STATE(1169),
    [sym_type_cast_expression] = STATE(1169),
    [sym_return_expression] = STATE(1169),
    [sym_call_expression] = STATE(1169),
    [sym_array_expression] = STATE(1169),
    [sym_parenthesized_expression] = STATE(1169),
    [sym_tuple_expression] = STATE(1169),
    [sym_unit_expression] = STATE(1169),
    [sym_struct_expression] = STATE(1169),
    [sym_if_expression] = STATE(1169),
    [sym_if_let_expression] = STATE(1169),
    [sym_match_expression] = STATE(1169),
    [sym_while_expression] = STATE(1169),
    [sym_while_let_expression] = STATE(1169),
    [sym_loop_expression] = STATE(1169),
    [sym_for_expression] = STATE(1169),
    [sym_closure_expression] = STATE(1169),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1169),
    [sym_continue_expression] = STATE(1169),
    [sym_index_expression] = STATE(1169),
    [sym_await_expression] = STATE(1169),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1169),
    [sym_async_block] = STATE(1169),
    [sym_block] = STATE(1169),
    [sym__literal] = STATE(1169),
    [sym_string_literal] = STATE(1169),
    [sym_boolean_literal] = STATE(1169),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(859),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(859),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(859),
    [sym_float_literal] = ACTIONS(859),
    [sym_block_comment] = ACTIONS(3),
  },
  [115] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1143),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1143),
    [sym_macro_invocation] = STATE(1143),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1143),
    [sym_unary_expression] = STATE(1143),
    [sym_try_expression] = STATE(1143),
    [sym_reference_expression] = STATE(1143),
    [sym_binary_expression] = STATE(1143),
    [sym_assignment_expression] = STATE(1143),
    [sym_compound_assignment_expr] = STATE(1143),
    [sym_type_cast_expression] = STATE(1143),
    [sym_return_expression] = STATE(1143),
    [sym_call_expression] = STATE(1143),
    [sym_array_expression] = STATE(1143),
    [sym_parenthesized_expression] = STATE(1143),
    [sym_tuple_expression] = STATE(1143),
    [sym_unit_expression] = STATE(1143),
    [sym_struct_expression] = STATE(1143),
    [sym_if_expression] = STATE(1143),
    [sym_if_let_expression] = STATE(1143),
    [sym_match_expression] = STATE(1143),
    [sym_while_expression] = STATE(1143),
    [sym_while_let_expression] = STATE(1143),
    [sym_loop_expression] = STATE(1143),
    [sym_for_expression] = STATE(1143),
    [sym_closure_expression] = STATE(1143),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1143),
    [sym_continue_expression] = STATE(1143),
    [sym_index_expression] = STATE(1143),
    [sym_await_expression] = STATE(1143),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1143),
    [sym_async_block] = STATE(1143),
    [sym_block] = STATE(1143),
    [sym__literal] = STATE(1143),
    [sym_string_literal] = STATE(1143),
    [sym_boolean_literal] = STATE(1143),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(861),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(861),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(861),
    [sym_float_literal] = ACTIONS(861),
    [sym_block_comment] = ACTIONS(3),
  },
  [116] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(755),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(755),
    [sym_macro_invocation] = STATE(755),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(755),
    [sym_unary_expression] = STATE(755),
    [sym_try_expression] = STATE(755),
    [sym_reference_expression] = STATE(755),
    [sym_binary_expression] = STATE(755),
    [sym_assignment_expression] = STATE(755),
    [sym_compound_assignment_expr] = STATE(755),
    [sym_type_cast_expression] = STATE(755),
    [sym_return_expression] = STATE(755),
    [sym_call_expression] = STATE(755),
    [sym_array_expression] = STATE(755),
    [sym_parenthesized_expression] = STATE(755),
    [sym_tuple_expression] = STATE(755),
    [sym_unit_expression] = STATE(755),
    [sym_struct_expression] = STATE(755),
    [sym_if_expression] = STATE(755),
    [sym_if_let_expression] = STATE(755),
    [sym_match_expression] = STATE(755),
    [sym_while_expression] = STATE(755),
    [sym_while_let_expression] = STATE(755),
    [sym_loop_expression] = STATE(755),
    [sym_for_expression] = STATE(755),
    [sym_closure_expression] = STATE(755),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(755),
    [sym_continue_expression] = STATE(755),
    [sym_index_expression] = STATE(755),
    [sym_await_expression] = STATE(755),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(755),
    [sym_async_block] = STATE(755),
    [sym_block] = STATE(755),
    [sym__literal] = STATE(755),
    [sym_string_literal] = STATE(755),
    [sym_boolean_literal] = STATE(755),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(863),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(863),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(863),
    [sym_float_literal] = ACTIONS(863),
    [sym_block_comment] = ACTIONS(3),
  },
  [117] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1190),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1190),
    [sym_macro_invocation] = STATE(1190),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1190),
    [sym_unary_expression] = STATE(1190),
    [sym_try_expression] = STATE(1190),
    [sym_reference_expression] = STATE(1190),
    [sym_binary_expression] = STATE(1190),
    [sym_assignment_expression] = STATE(1190),
    [sym_compound_assignment_expr] = STATE(1190),
    [sym_type_cast_expression] = STATE(1190),
    [sym_return_expression] = STATE(1190),
    [sym_call_expression] = STATE(1190),
    [sym_array_expression] = STATE(1190),
    [sym_parenthesized_expression] = STATE(1190),
    [sym_tuple_expression] = STATE(1190),
    [sym_unit_expression] = STATE(1190),
    [sym_struct_expression] = STATE(1190),
    [sym_if_expression] = STATE(1190),
    [sym_if_let_expression] = STATE(1190),
    [sym_match_expression] = STATE(1190),
    [sym_while_expression] = STATE(1190),
    [sym_while_let_expression] = STATE(1190),
    [sym_loop_expression] = STATE(1190),
    [sym_for_expression] = STATE(1190),
    [sym_closure_expression] = STATE(1190),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1190),
    [sym_continue_expression] = STATE(1190),
    [sym_index_expression] = STATE(1190),
    [sym_await_expression] = STATE(1190),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1190),
    [sym_async_block] = STATE(1190),
    [sym_block] = STATE(1190),
    [sym__literal] = STATE(1190),
    [sym_string_literal] = STATE(1190),
    [sym_boolean_literal] = STATE(1190),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(865),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(865),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(865),
    [sym_float_literal] = ACTIONS(865),
    [sym_block_comment] = ACTIONS(3),
  },
  [118] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1042),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1042),
    [sym_macro_invocation] = STATE(1042),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1042),
    [sym_unary_expression] = STATE(1042),
    [sym_try_expression] = STATE(1042),
    [sym_reference_expression] = STATE(1042),
    [sym_binary_expression] = STATE(1042),
    [sym_assignment_expression] = STATE(1042),
    [sym_compound_assignment_expr] = STATE(1042),
    [sym_type_cast_expression] = STATE(1042),
    [sym_return_expression] = STATE(1042),
    [sym_call_expression] = STATE(1042),
    [sym_array_expression] = STATE(1042),
    [sym_parenthesized_expression] = STATE(1042),
    [sym_tuple_expression] = STATE(1042),
    [sym_unit_expression] = STATE(1042),
    [sym_struct_expression] = STATE(1042),
    [sym_if_expression] = STATE(1042),
    [sym_if_let_expression] = STATE(1042),
    [sym_match_expression] = STATE(1042),
    [sym_while_expression] = STATE(1042),
    [sym_while_let_expression] = STATE(1042),
    [sym_loop_expression] = STATE(1042),
    [sym_for_expression] = STATE(1042),
    [sym_closure_expression] = STATE(1042),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1042),
    [sym_continue_expression] = STATE(1042),
    [sym_index_expression] = STATE(1042),
    [sym_await_expression] = STATE(1042),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1042),
    [sym_async_block] = STATE(1042),
    [sym_block] = STATE(1042),
    [sym__literal] = STATE(1042),
    [sym_string_literal] = STATE(1042),
    [sym_boolean_literal] = STATE(1042),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(867),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(867),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(867),
    [sym_float_literal] = ACTIONS(867),
    [sym_block_comment] = ACTIONS(3),
  },
  [119] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1155),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1155),
    [sym_macro_invocation] = STATE(1155),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1155),
    [sym_unary_expression] = STATE(1155),
    [sym_try_expression] = STATE(1155),
    [sym_reference_expression] = STATE(1155),
    [sym_binary_expression] = STATE(1155),
    [sym_assignment_expression] = STATE(1155),
    [sym_compound_assignment_expr] = STATE(1155),
    [sym_type_cast_expression] = STATE(1155),
    [sym_return_expression] = STATE(1155),
    [sym_call_expression] = STATE(1155),
    [sym_array_expression] = STATE(1155),
    [sym_parenthesized_expression] = STATE(1155),
    [sym_tuple_expression] = STATE(1155),
    [sym_unit_expression] = STATE(1155),
    [sym_struct_expression] = STATE(1155),
    [sym_if_expression] = STATE(1155),
    [sym_if_let_expression] = STATE(1155),
    [sym_match_expression] = STATE(1155),
    [sym_while_expression] = STATE(1155),
    [sym_while_let_expression] = STATE(1155),
    [sym_loop_expression] = STATE(1155),
    [sym_for_expression] = STATE(1155),
    [sym_closure_expression] = STATE(1155),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1155),
    [sym_continue_expression] = STATE(1155),
    [sym_index_expression] = STATE(1155),
    [sym_await_expression] = STATE(1155),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1155),
    [sym_async_block] = STATE(1155),
    [sym_block] = STATE(1155),
    [sym__literal] = STATE(1155),
    [sym_string_literal] = STATE(1155),
    [sym_boolean_literal] = STATE(1155),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(869),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(869),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(869),
    [sym_float_literal] = ACTIONS(869),
    [sym_block_comment] = ACTIONS(3),
  },
  [120] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1136),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1136),
    [sym_macro_invocation] = STATE(1136),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1136),
    [sym_unary_expression] = STATE(1136),
    [sym_try_expression] = STATE(1136),
    [sym_reference_expression] = STATE(1136),
    [sym_binary_expression] = STATE(1136),
    [sym_assignment_expression] = STATE(1136),
    [sym_compound_assignment_expr] = STATE(1136),
    [sym_type_cast_expression] = STATE(1136),
    [sym_return_expression] = STATE(1136),
    [sym_call_expression] = STATE(1136),
    [sym_array_expression] = STATE(1136),
    [sym_parenthesized_expression] = STATE(1136),
    [sym_tuple_expression] = STATE(1136),
    [sym_unit_expression] = STATE(1136),
    [sym_struct_expression] = STATE(1136),
    [sym_if_expression] = STATE(1136),
    [sym_if_let_expression] = STATE(1136),
    [sym_match_expression] = STATE(1136),
    [sym_while_expression] = STATE(1136),
    [sym_while_let_expression] = STATE(1136),
    [sym_loop_expression] = STATE(1136),
    [sym_for_expression] = STATE(1136),
    [sym_closure_expression] = STATE(1136),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1136),
    [sym_continue_expression] = STATE(1136),
    [sym_index_expression] = STATE(1136),
    [sym_await_expression] = STATE(1136),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1136),
    [sym_async_block] = STATE(1136),
    [sym_block] = STATE(1136),
    [sym__literal] = STATE(1136),
    [sym_string_literal] = STATE(1136),
    [sym_boolean_literal] = STATE(1136),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(871),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(871),
    [sym_float_literal] = ACTIONS(871),
    [sym_block_comment] = ACTIONS(3),
  },
  [121] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(813),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(813),
    [sym_macro_invocation] = STATE(813),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(813),
    [sym_unary_expression] = STATE(813),
    [sym_try_expression] = STATE(813),
    [sym_reference_expression] = STATE(813),
    [sym_binary_expression] = STATE(813),
    [sym_assignment_expression] = STATE(813),
    [sym_compound_assignment_expr] = STATE(813),
    [sym_type_cast_expression] = STATE(813),
    [sym_return_expression] = STATE(813),
    [sym_call_expression] = STATE(813),
    [sym_array_expression] = STATE(813),
    [sym_parenthesized_expression] = STATE(813),
    [sym_tuple_expression] = STATE(813),
    [sym_unit_expression] = STATE(813),
    [sym_struct_expression] = STATE(813),
    [sym_if_expression] = STATE(813),
    [sym_if_let_expression] = STATE(813),
    [sym_match_expression] = STATE(813),
    [sym_while_expression] = STATE(813),
    [sym_while_let_expression] = STATE(813),
    [sym_loop_expression] = STATE(813),
    [sym_for_expression] = STATE(813),
    [sym_closure_expression] = STATE(813),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(813),
    [sym_continue_expression] = STATE(813),
    [sym_index_expression] = STATE(813),
    [sym_await_expression] = STATE(813),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(813),
    [sym_async_block] = STATE(813),
    [sym_block] = STATE(813),
    [sym__literal] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym_boolean_literal] = STATE(813),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(873),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(873),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(873),
    [sym_float_literal] = ACTIONS(873),
    [sym_block_comment] = ACTIONS(3),
  },
  [122] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1041),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1041),
    [sym_macro_invocation] = STATE(1041),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1041),
    [sym_unary_expression] = STATE(1041),
    [sym_try_expression] = STATE(1041),
    [sym_reference_expression] = STATE(1041),
    [sym_binary_expression] = STATE(1041),
    [sym_assignment_expression] = STATE(1041),
    [sym_compound_assignment_expr] = STATE(1041),
    [sym_type_cast_expression] = STATE(1041),
    [sym_return_expression] = STATE(1041),
    [sym_call_expression] = STATE(1041),
    [sym_array_expression] = STATE(1041),
    [sym_parenthesized_expression] = STATE(1041),
    [sym_tuple_expression] = STATE(1041),
    [sym_unit_expression] = STATE(1041),
    [sym_struct_expression] = STATE(1041),
    [sym_if_expression] = STATE(1041),
    [sym_if_let_expression] = STATE(1041),
    [sym_match_expression] = STATE(1041),
    [sym_while_expression] = STATE(1041),
    [sym_while_let_expression] = STATE(1041),
    [sym_loop_expression] = STATE(1041),
    [sym_for_expression] = STATE(1041),
    [sym_closure_expression] = STATE(1041),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1041),
    [sym_continue_expression] = STATE(1041),
    [sym_index_expression] = STATE(1041),
    [sym_await_expression] = STATE(1041),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1041),
    [sym_async_block] = STATE(1041),
    [sym_block] = STATE(1041),
    [sym__literal] = STATE(1041),
    [sym_string_literal] = STATE(1041),
    [sym_boolean_literal] = STATE(1041),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(875),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(875),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(875),
    [sym_float_literal] = ACTIONS(875),
    [sym_block_comment] = ACTIONS(3),
  },
  [123] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1157),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1157),
    [sym_macro_invocation] = STATE(1157),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1157),
    [sym_unary_expression] = STATE(1157),
    [sym_try_expression] = STATE(1157),
    [sym_reference_expression] = STATE(1157),
    [sym_binary_expression] = STATE(1157),
    [sym_assignment_expression] = STATE(1157),
    [sym_compound_assignment_expr] = STATE(1157),
    [sym_type_cast_expression] = STATE(1157),
    [sym_return_expression] = STATE(1157),
    [sym_call_expression] = STATE(1157),
    [sym_array_expression] = STATE(1157),
    [sym_parenthesized_expression] = STATE(1157),
    [sym_tuple_expression] = STATE(1157),
    [sym_unit_expression] = STATE(1157),
    [sym_struct_expression] = STATE(1157),
    [sym_if_expression] = STATE(1157),
    [sym_if_let_expression] = STATE(1157),
    [sym_match_expression] = STATE(1157),
    [sym_while_expression] = STATE(1157),
    [sym_while_let_expression] = STATE(1157),
    [sym_loop_expression] = STATE(1157),
    [sym_for_expression] = STATE(1157),
    [sym_closure_expression] = STATE(1157),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1157),
    [sym_continue_expression] = STATE(1157),
    [sym_index_expression] = STATE(1157),
    [sym_await_expression] = STATE(1157),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1157),
    [sym_async_block] = STATE(1157),
    [sym_block] = STATE(1157),
    [sym__literal] = STATE(1157),
    [sym_string_literal] = STATE(1157),
    [sym_boolean_literal] = STATE(1157),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(877),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(877),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(877),
    [sym_float_literal] = ACTIONS(877),
    [sym_block_comment] = ACTIONS(3),
  },
  [124] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1039),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1039),
    [sym_macro_invocation] = STATE(1039),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1039),
    [sym_unary_expression] = STATE(1039),
    [sym_try_expression] = STATE(1039),
    [sym_reference_expression] = STATE(1039),
    [sym_binary_expression] = STATE(1039),
    [sym_assignment_expression] = STATE(1039),
    [sym_compound_assignment_expr] = STATE(1039),
    [sym_type_cast_expression] = STATE(1039),
    [sym_return_expression] = STATE(1039),
    [sym_call_expression] = STATE(1039),
    [sym_array_expression] = STATE(1039),
    [sym_parenthesized_expression] = STATE(1039),
    [sym_tuple_expression] = STATE(1039),
    [sym_unit_expression] = STATE(1039),
    [sym_struct_expression] = STATE(1039),
    [sym_if_expression] = STATE(1039),
    [sym_if_let_expression] = STATE(1039),
    [sym_match_expression] = STATE(1039),
    [sym_while_expression] = STATE(1039),
    [sym_while_let_expression] = STATE(1039),
    [sym_loop_expression] = STATE(1039),
    [sym_for_expression] = STATE(1039),
    [sym_closure_expression] = STATE(1039),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1039),
    [sym_continue_expression] = STATE(1039),
    [sym_index_expression] = STATE(1039),
    [sym_await_expression] = STATE(1039),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1039),
    [sym_async_block] = STATE(1039),
    [sym_block] = STATE(1039),
    [sym__literal] = STATE(1039),
    [sym_string_literal] = STATE(1039),
    [sym_boolean_literal] = STATE(1039),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(325),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(325),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(325),
    [sym_float_literal] = ACTIONS(325),
    [sym_block_comment] = ACTIONS(3),
  },
  [125] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1120),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1120),
    [sym_macro_invocation] = STATE(1120),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1120),
    [sym_unary_expression] = STATE(1120),
    [sym_try_expression] = STATE(1120),
    [sym_reference_expression] = STATE(1120),
    [sym_binary_expression] = STATE(1120),
    [sym_assignment_expression] = STATE(1120),
    [sym_compound_assignment_expr] = STATE(1120),
    [sym_type_cast_expression] = STATE(1120),
    [sym_return_expression] = STATE(1120),
    [sym_call_expression] = STATE(1120),
    [sym_array_expression] = STATE(1120),
    [sym_parenthesized_expression] = STATE(1120),
    [sym_tuple_expression] = STATE(1120),
    [sym_unit_expression] = STATE(1120),
    [sym_struct_expression] = STATE(1120),
    [sym_if_expression] = STATE(1120),
    [sym_if_let_expression] = STATE(1120),
    [sym_match_expression] = STATE(1120),
    [sym_while_expression] = STATE(1120),
    [sym_while_let_expression] = STATE(1120),
    [sym_loop_expression] = STATE(1120),
    [sym_for_expression] = STATE(1120),
    [sym_closure_expression] = STATE(1120),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1120),
    [sym_continue_expression] = STATE(1120),
    [sym_index_expression] = STATE(1120),
    [sym_await_expression] = STATE(1120),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1120),
    [sym_async_block] = STATE(1120),
    [sym_block] = STATE(1120),
    [sym__literal] = STATE(1120),
    [sym_string_literal] = STATE(1120),
    [sym_boolean_literal] = STATE(1120),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(879),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(879),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(879),
    [sym_float_literal] = ACTIONS(879),
    [sym_block_comment] = ACTIONS(3),
  },
  [126] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1152),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1152),
    [sym_macro_invocation] = STATE(1152),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1152),
    [sym_unary_expression] = STATE(1152),
    [sym_try_expression] = STATE(1152),
    [sym_reference_expression] = STATE(1152),
    [sym_binary_expression] = STATE(1152),
    [sym_assignment_expression] = STATE(1152),
    [sym_compound_assignment_expr] = STATE(1152),
    [sym_type_cast_expression] = STATE(1152),
    [sym_return_expression] = STATE(1152),
    [sym_call_expression] = STATE(1152),
    [sym_array_expression] = STATE(1152),
    [sym_parenthesized_expression] = STATE(1152),
    [sym_tuple_expression] = STATE(1152),
    [sym_unit_expression] = STATE(1152),
    [sym_struct_expression] = STATE(1152),
    [sym_if_expression] = STATE(1152),
    [sym_if_let_expression] = STATE(1152),
    [sym_match_expression] = STATE(1152),
    [sym_while_expression] = STATE(1152),
    [sym_while_let_expression] = STATE(1152),
    [sym_loop_expression] = STATE(1152),
    [sym_for_expression] = STATE(1152),
    [sym_closure_expression] = STATE(1152),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1152),
    [sym_continue_expression] = STATE(1152),
    [sym_index_expression] = STATE(1152),
    [sym_await_expression] = STATE(1152),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1152),
    [sym_async_block] = STATE(1152),
    [sym_block] = STATE(1152),
    [sym__literal] = STATE(1152),
    [sym_string_literal] = STATE(1152),
    [sym_boolean_literal] = STATE(1152),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(881),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(881),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(881),
    [sym_float_literal] = ACTIONS(881),
    [sym_block_comment] = ACTIONS(3),
  },
  [127] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1103),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1103),
    [sym_macro_invocation] = STATE(1103),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1103),
    [sym_unary_expression] = STATE(1103),
    [sym_try_expression] = STATE(1103),
    [sym_reference_expression] = STATE(1103),
    [sym_binary_expression] = STATE(1103),
    [sym_assignment_expression] = STATE(1103),
    [sym_compound_assignment_expr] = STATE(1103),
    [sym_type_cast_expression] = STATE(1103),
    [sym_return_expression] = STATE(1103),
    [sym_call_expression] = STATE(1103),
    [sym_array_expression] = STATE(1103),
    [sym_parenthesized_expression] = STATE(1103),
    [sym_tuple_expression] = STATE(1103),
    [sym_unit_expression] = STATE(1103),
    [sym_struct_expression] = STATE(1103),
    [sym_if_expression] = STATE(1103),
    [sym_if_let_expression] = STATE(1103),
    [sym_match_expression] = STATE(1103),
    [sym_while_expression] = STATE(1103),
    [sym_while_let_expression] = STATE(1103),
    [sym_loop_expression] = STATE(1103),
    [sym_for_expression] = STATE(1103),
    [sym_closure_expression] = STATE(1103),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1103),
    [sym_continue_expression] = STATE(1103),
    [sym_index_expression] = STATE(1103),
    [sym_await_expression] = STATE(1103),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1103),
    [sym_async_block] = STATE(1103),
    [sym_block] = STATE(1103),
    [sym__literal] = STATE(1103),
    [sym_string_literal] = STATE(1103),
    [sym_boolean_literal] = STATE(1103),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(883),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(883),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(883),
    [sym_float_literal] = ACTIONS(883),
    [sym_block_comment] = ACTIONS(3),
  },
  [128] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1096),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1096),
    [sym_macro_invocation] = STATE(1096),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1096),
    [sym_unary_expression] = STATE(1096),
    [sym_try_expression] = STATE(1096),
    [sym_reference_expression] = STATE(1096),
    [sym_binary_expression] = STATE(1096),
    [sym_assignment_expression] = STATE(1096),
    [sym_compound_assignment_expr] = STATE(1096),
    [sym_type_cast_expression] = STATE(1096),
    [sym_return_expression] = STATE(1096),
    [sym_call_expression] = STATE(1096),
    [sym_array_expression] = STATE(1096),
    [sym_parenthesized_expression] = STATE(1096),
    [sym_tuple_expression] = STATE(1096),
    [sym_unit_expression] = STATE(1096),
    [sym_struct_expression] = STATE(1096),
    [sym_if_expression] = STATE(1096),
    [sym_if_let_expression] = STATE(1096),
    [sym_match_expression] = STATE(1096),
    [sym_while_expression] = STATE(1096),
    [sym_while_let_expression] = STATE(1096),
    [sym_loop_expression] = STATE(1096),
    [sym_for_expression] = STATE(1096),
    [sym_closure_expression] = STATE(1096),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1096),
    [sym_continue_expression] = STATE(1096),
    [sym_index_expression] = STATE(1096),
    [sym_await_expression] = STATE(1096),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1096),
    [sym_async_block] = STATE(1096),
    [sym_block] = STATE(1096),
    [sym__literal] = STATE(1096),
    [sym_string_literal] = STATE(1096),
    [sym_boolean_literal] = STATE(1096),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(885),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(885),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(885),
    [sym_float_literal] = ACTIONS(885),
    [sym_block_comment] = ACTIONS(3),
  },
  [129] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(781),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(781),
    [sym_macro_invocation] = STATE(781),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(781),
    [sym_unary_expression] = STATE(781),
    [sym_try_expression] = STATE(781),
    [sym_reference_expression] = STATE(781),
    [sym_binary_expression] = STATE(781),
    [sym_assignment_expression] = STATE(781),
    [sym_compound_assignment_expr] = STATE(781),
    [sym_type_cast_expression] = STATE(781),
    [sym_return_expression] = STATE(781),
    [sym_call_expression] = STATE(781),
    [sym_array_expression] = STATE(781),
    [sym_parenthesized_expression] = STATE(781),
    [sym_tuple_expression] = STATE(781),
    [sym_unit_expression] = STATE(781),
    [sym_struct_expression] = STATE(781),
    [sym_if_expression] = STATE(781),
    [sym_if_let_expression] = STATE(781),
    [sym_match_expression] = STATE(781),
    [sym_while_expression] = STATE(781),
    [sym_while_let_expression] = STATE(781),
    [sym_loop_expression] = STATE(781),
    [sym_for_expression] = STATE(781),
    [sym_closure_expression] = STATE(781),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(781),
    [sym_continue_expression] = STATE(781),
    [sym_index_expression] = STATE(781),
    [sym_await_expression] = STATE(781),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(781),
    [sym_async_block] = STATE(781),
    [sym_block] = STATE(781),
    [sym__literal] = STATE(781),
    [sym_string_literal] = STATE(781),
    [sym_boolean_literal] = STATE(781),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(887),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(887),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(887),
    [sym_float_literal] = ACTIONS(887),
    [sym_block_comment] = ACTIONS(3),
  },
  [130] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1129),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1129),
    [sym_macro_invocation] = STATE(1129),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1129),
    [sym_unary_expression] = STATE(1129),
    [sym_try_expression] = STATE(1129),
    [sym_reference_expression] = STATE(1129),
    [sym_binary_expression] = STATE(1129),
    [sym_assignment_expression] = STATE(1129),
    [sym_compound_assignment_expr] = STATE(1129),
    [sym_type_cast_expression] = STATE(1129),
    [sym_return_expression] = STATE(1129),
    [sym_call_expression] = STATE(1129),
    [sym_array_expression] = STATE(1129),
    [sym_parenthesized_expression] = STATE(1129),
    [sym_tuple_expression] = STATE(1129),
    [sym_unit_expression] = STATE(1129),
    [sym_struct_expression] = STATE(1129),
    [sym_if_expression] = STATE(1129),
    [sym_if_let_expression] = STATE(1129),
    [sym_match_expression] = STATE(1129),
    [sym_while_expression] = STATE(1129),
    [sym_while_let_expression] = STATE(1129),
    [sym_loop_expression] = STATE(1129),
    [sym_for_expression] = STATE(1129),
    [sym_closure_expression] = STATE(1129),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1129),
    [sym_continue_expression] = STATE(1129),
    [sym_index_expression] = STATE(1129),
    [sym_await_expression] = STATE(1129),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1129),
    [sym_async_block] = STATE(1129),
    [sym_block] = STATE(1129),
    [sym__literal] = STATE(1129),
    [sym_string_literal] = STATE(1129),
    [sym_boolean_literal] = STATE(1129),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(729),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(729),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(729),
    [sym_float_literal] = ACTIONS(729),
    [sym_block_comment] = ACTIONS(3),
  },
  [131] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1116),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1116),
    [sym_macro_invocation] = STATE(1116),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1116),
    [sym_unary_expression] = STATE(1116),
    [sym_try_expression] = STATE(1116),
    [sym_reference_expression] = STATE(1116),
    [sym_binary_expression] = STATE(1116),
    [sym_assignment_expression] = STATE(1116),
    [sym_compound_assignment_expr] = STATE(1116),
    [sym_type_cast_expression] = STATE(1116),
    [sym_return_expression] = STATE(1116),
    [sym_call_expression] = STATE(1116),
    [sym_array_expression] = STATE(1116),
    [sym_parenthesized_expression] = STATE(1116),
    [sym_tuple_expression] = STATE(1116),
    [sym_unit_expression] = STATE(1116),
    [sym_struct_expression] = STATE(1116),
    [sym_if_expression] = STATE(1116),
    [sym_if_let_expression] = STATE(1116),
    [sym_match_expression] = STATE(1116),
    [sym_while_expression] = STATE(1116),
    [sym_while_let_expression] = STATE(1116),
    [sym_loop_expression] = STATE(1116),
    [sym_for_expression] = STATE(1116),
    [sym_closure_expression] = STATE(1116),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1116),
    [sym_continue_expression] = STATE(1116),
    [sym_index_expression] = STATE(1116),
    [sym_await_expression] = STATE(1116),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1116),
    [sym_async_block] = STATE(1116),
    [sym_block] = STATE(1116),
    [sym__literal] = STATE(1116),
    [sym_string_literal] = STATE(1116),
    [sym_boolean_literal] = STATE(1116),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(889),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(889),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(889),
    [sym_float_literal] = ACTIONS(889),
    [sym_block_comment] = ACTIONS(3),
  },
  [132] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1191),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1191),
    [sym_macro_invocation] = STATE(1191),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1191),
    [sym_unary_expression] = STATE(1191),
    [sym_try_expression] = STATE(1191),
    [sym_reference_expression] = STATE(1191),
    [sym_binary_expression] = STATE(1191),
    [sym_assignment_expression] = STATE(1191),
    [sym_compound_assignment_expr] = STATE(1191),
    [sym_type_cast_expression] = STATE(1191),
    [sym_return_expression] = STATE(1191),
    [sym_call_expression] = STATE(1191),
    [sym_array_expression] = STATE(1191),
    [sym_parenthesized_expression] = STATE(1191),
    [sym_tuple_expression] = STATE(1191),
    [sym_unit_expression] = STATE(1191),
    [sym_struct_expression] = STATE(1191),
    [sym_if_expression] = STATE(1191),
    [sym_if_let_expression] = STATE(1191),
    [sym_match_expression] = STATE(1191),
    [sym_while_expression] = STATE(1191),
    [sym_while_let_expression] = STATE(1191),
    [sym_loop_expression] = STATE(1191),
    [sym_for_expression] = STATE(1191),
    [sym_closure_expression] = STATE(1191),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1191),
    [sym_continue_expression] = STATE(1191),
    [sym_index_expression] = STATE(1191),
    [sym_await_expression] = STATE(1191),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1191),
    [sym_async_block] = STATE(1191),
    [sym_block] = STATE(1191),
    [sym__literal] = STATE(1191),
    [sym_string_literal] = STATE(1191),
    [sym_boolean_literal] = STATE(1191),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(891),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(891),
    [sym_float_literal] = ACTIONS(891),
    [sym_block_comment] = ACTIONS(3),
  },
  [133] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1127),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1127),
    [sym_macro_invocation] = STATE(1127),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1127),
    [sym_unary_expression] = STATE(1127),
    [sym_try_expression] = STATE(1127),
    [sym_reference_expression] = STATE(1127),
    [sym_binary_expression] = STATE(1127),
    [sym_assignment_expression] = STATE(1127),
    [sym_compound_assignment_expr] = STATE(1127),
    [sym_type_cast_expression] = STATE(1127),
    [sym_return_expression] = STATE(1127),
    [sym_call_expression] = STATE(1127),
    [sym_array_expression] = STATE(1127),
    [sym_parenthesized_expression] = STATE(1127),
    [sym_tuple_expression] = STATE(1127),
    [sym_unit_expression] = STATE(1127),
    [sym_struct_expression] = STATE(1127),
    [sym_if_expression] = STATE(1127),
    [sym_if_let_expression] = STATE(1127),
    [sym_match_expression] = STATE(1127),
    [sym_while_expression] = STATE(1127),
    [sym_while_let_expression] = STATE(1127),
    [sym_loop_expression] = STATE(1127),
    [sym_for_expression] = STATE(1127),
    [sym_closure_expression] = STATE(1127),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1127),
    [sym_continue_expression] = STATE(1127),
    [sym_index_expression] = STATE(1127),
    [sym_await_expression] = STATE(1127),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1127),
    [sym_async_block] = STATE(1127),
    [sym_block] = STATE(1127),
    [sym__literal] = STATE(1127),
    [sym_string_literal] = STATE(1127),
    [sym_boolean_literal] = STATE(1127),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(893),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(893),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(893),
    [sym_float_literal] = ACTIONS(893),
    [sym_block_comment] = ACTIONS(3),
  },
  [134] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1173),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1173),
    [sym_macro_invocation] = STATE(1173),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1173),
    [sym_unary_expression] = STATE(1173),
    [sym_try_expression] = STATE(1173),
    [sym_reference_expression] = STATE(1173),
    [sym_binary_expression] = STATE(1173),
    [sym_assignment_expression] = STATE(1173),
    [sym_compound_assignment_expr] = STATE(1173),
    [sym_type_cast_expression] = STATE(1173),
    [sym_return_expression] = STATE(1173),
    [sym_call_expression] = STATE(1173),
    [sym_array_expression] = STATE(1173),
    [sym_parenthesized_expression] = STATE(1173),
    [sym_tuple_expression] = STATE(1173),
    [sym_unit_expression] = STATE(1173),
    [sym_struct_expression] = STATE(1173),
    [sym_if_expression] = STATE(1173),
    [sym_if_let_expression] = STATE(1173),
    [sym_match_expression] = STATE(1173),
    [sym_while_expression] = STATE(1173),
    [sym_while_let_expression] = STATE(1173),
    [sym_loop_expression] = STATE(1173),
    [sym_for_expression] = STATE(1173),
    [sym_closure_expression] = STATE(1173),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1173),
    [sym_continue_expression] = STATE(1173),
    [sym_index_expression] = STATE(1173),
    [sym_await_expression] = STATE(1173),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1173),
    [sym_async_block] = STATE(1173),
    [sym_block] = STATE(1173),
    [sym__literal] = STATE(1173),
    [sym_string_literal] = STATE(1173),
    [sym_boolean_literal] = STATE(1173),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(895),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(895),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(895),
    [sym_float_literal] = ACTIONS(895),
    [sym_block_comment] = ACTIONS(3),
  },
  [135] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1105),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1105),
    [sym_macro_invocation] = STATE(1105),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1105),
    [sym_unary_expression] = STATE(1105),
    [sym_try_expression] = STATE(1105),
    [sym_reference_expression] = STATE(1105),
    [sym_binary_expression] = STATE(1105),
    [sym_assignment_expression] = STATE(1105),
    [sym_compound_assignment_expr] = STATE(1105),
    [sym_type_cast_expression] = STATE(1105),
    [sym_return_expression] = STATE(1105),
    [sym_call_expression] = STATE(1105),
    [sym_array_expression] = STATE(1105),
    [sym_parenthesized_expression] = STATE(1105),
    [sym_tuple_expression] = STATE(1105),
    [sym_unit_expression] = STATE(1105),
    [sym_struct_expression] = STATE(1105),
    [sym_if_expression] = STATE(1105),
    [sym_if_let_expression] = STATE(1105),
    [sym_match_expression] = STATE(1105),
    [sym_while_expression] = STATE(1105),
    [sym_while_let_expression] = STATE(1105),
    [sym_loop_expression] = STATE(1105),
    [sym_for_expression] = STATE(1105),
    [sym_closure_expression] = STATE(1105),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1105),
    [sym_continue_expression] = STATE(1105),
    [sym_index_expression] = STATE(1105),
    [sym_await_expression] = STATE(1105),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1105),
    [sym_async_block] = STATE(1105),
    [sym_block] = STATE(1105),
    [sym__literal] = STATE(1105),
    [sym_string_literal] = STATE(1105),
    [sym_boolean_literal] = STATE(1105),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(897),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(897),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(897),
    [sym_float_literal] = ACTIONS(897),
    [sym_block_comment] = ACTIONS(3),
  },
  [136] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(781),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(781),
    [sym_macro_invocation] = STATE(781),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(781),
    [sym_unary_expression] = STATE(781),
    [sym_try_expression] = STATE(781),
    [sym_reference_expression] = STATE(781),
    [sym_binary_expression] = STATE(781),
    [sym_assignment_expression] = STATE(781),
    [sym_compound_assignment_expr] = STATE(781),
    [sym_type_cast_expression] = STATE(781),
    [sym_return_expression] = STATE(781),
    [sym_call_expression] = STATE(781),
    [sym_array_expression] = STATE(781),
    [sym_parenthesized_expression] = STATE(781),
    [sym_tuple_expression] = STATE(781),
    [sym_unit_expression] = STATE(781),
    [sym_struct_expression] = STATE(781),
    [sym_if_expression] = STATE(781),
    [sym_if_let_expression] = STATE(781),
    [sym_match_expression] = STATE(781),
    [sym_while_expression] = STATE(781),
    [sym_while_let_expression] = STATE(781),
    [sym_loop_expression] = STATE(781),
    [sym_for_expression] = STATE(781),
    [sym_closure_expression] = STATE(781),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(781),
    [sym_continue_expression] = STATE(781),
    [sym_index_expression] = STATE(781),
    [sym_await_expression] = STATE(781),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(781),
    [sym_async_block] = STATE(781),
    [sym_block] = STATE(781),
    [sym__literal] = STATE(781),
    [sym_string_literal] = STATE(781),
    [sym_boolean_literal] = STATE(781),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(887),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(887),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(887),
    [sym_float_literal] = ACTIONS(887),
    [sym_block_comment] = ACTIONS(3),
  },
  [137] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1038),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1038),
    [sym_macro_invocation] = STATE(1038),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1038),
    [sym_unary_expression] = STATE(1038),
    [sym_try_expression] = STATE(1038),
    [sym_reference_expression] = STATE(1038),
    [sym_binary_expression] = STATE(1038),
    [sym_assignment_expression] = STATE(1038),
    [sym_compound_assignment_expr] = STATE(1038),
    [sym_type_cast_expression] = STATE(1038),
    [sym_return_expression] = STATE(1038),
    [sym_call_expression] = STATE(1038),
    [sym_array_expression] = STATE(1038),
    [sym_parenthesized_expression] = STATE(1038),
    [sym_tuple_expression] = STATE(1038),
    [sym_unit_expression] = STATE(1038),
    [sym_struct_expression] = STATE(1038),
    [sym_if_expression] = STATE(1038),
    [sym_if_let_expression] = STATE(1038),
    [sym_match_expression] = STATE(1038),
    [sym_while_expression] = STATE(1038),
    [sym_while_let_expression] = STATE(1038),
    [sym_loop_expression] = STATE(1038),
    [sym_for_expression] = STATE(1038),
    [sym_closure_expression] = STATE(1038),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1038),
    [sym_continue_expression] = STATE(1038),
    [sym_index_expression] = STATE(1038),
    [sym_await_expression] = STATE(1038),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1038),
    [sym_async_block] = STATE(1038),
    [sym_block] = STATE(1038),
    [sym__literal] = STATE(1038),
    [sym_string_literal] = STATE(1038),
    [sym_boolean_literal] = STATE(1038),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(899),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(899),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(899),
    [sym_float_literal] = ACTIONS(899),
    [sym_block_comment] = ACTIONS(3),
  },
  [138] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1100),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1100),
    [sym_macro_invocation] = STATE(1100),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1100),
    [sym_unary_expression] = STATE(1100),
    [sym_try_expression] = STATE(1100),
    [sym_reference_expression] = STATE(1100),
    [sym_binary_expression] = STATE(1100),
    [sym_assignment_expression] = STATE(1100),
    [sym_compound_assignment_expr] = STATE(1100),
    [sym_type_cast_expression] = STATE(1100),
    [sym_return_expression] = STATE(1100),
    [sym_call_expression] = STATE(1100),
    [sym_array_expression] = STATE(1100),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_tuple_expression] = STATE(1100),
    [sym_unit_expression] = STATE(1100),
    [sym_struct_expression] = STATE(1100),
    [sym_if_expression] = STATE(1100),
    [sym_if_let_expression] = STATE(1100),
    [sym_match_expression] = STATE(1100),
    [sym_while_expression] = STATE(1100),
    [sym_while_let_expression] = STATE(1100),
    [sym_loop_expression] = STATE(1100),
    [sym_for_expression] = STATE(1100),
    [sym_closure_expression] = STATE(1100),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1100),
    [sym_continue_expression] = STATE(1100),
    [sym_index_expression] = STATE(1100),
    [sym_await_expression] = STATE(1100),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1100),
    [sym_async_block] = STATE(1100),
    [sym_block] = STATE(1100),
    [sym__literal] = STATE(1100),
    [sym_string_literal] = STATE(1100),
    [sym_boolean_literal] = STATE(1100),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(901),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(901),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(901),
    [sym_float_literal] = ACTIONS(901),
    [sym_block_comment] = ACTIONS(3),
  },
  [139] = {
    [sym_attribute_item] = STATE(184),
    [sym_function_modifiers] = STATE(2207),
    [sym_self_parameter] = STATE(2017),
    [sym_variadic_parameter] = STATE(2017),
    [sym_parameter] = STATE(2017),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1752),
    [sym_bracketed_type] = STATE(2318),
    [sym_lifetime] = STATE(1828),
    [sym_array_type] = STATE(1752),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1752),
    [sym_tuple_type] = STATE(1752),
    [sym_unit_type] = STATE(1752),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2319),
    [sym_bounded_type] = STATE(1752),
    [sym_reference_type] = STATE(1752),
    [sym_pointer_type] = STATE(1752),
    [sym_empty_type] = STATE(1752),
    [sym_abstract_type] = STATE(1752),
    [sym_dynamic_type] = STATE(1752),
    [sym_macro_invocation] = STATE(1752),
    [sym_scoped_identifier] = STATE(1472),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(2132),
    [sym_tuple_pattern] = STATE(2132),
    [sym_slice_pattern] = STATE(2132),
    [sym_tuple_struct_pattern] = STATE(2132),
    [sym_struct_pattern] = STATE(2132),
    [sym_remaining_field_pattern] = STATE(2132),
    [sym_mut_pattern] = STATE(2132),
    [sym_range_pattern] = STATE(2132),
    [sym_ref_pattern] = STATE(2132),
    [sym_captured_pattern] = STATE(2132),
    [sym_reference_pattern] = STATE(2132),
    [sym_or_pattern] = STATE(2132),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(795),
    [anon_sym_i8] = ACTIONS(795),
    [anon_sym_u16] = ACTIONS(795),
    [anon_sym_i16] = ACTIONS(795),
    [anon_sym_u32] = ACTIONS(795),
    [anon_sym_i32] = ACTIONS(795),
    [anon_sym_u64] = ACTIONS(795),
    [anon_sym_i64] = ACTIONS(795),
    [anon_sym_u128] = ACTIONS(795),
    [anon_sym_i128] = ACTIONS(795),
    [anon_sym_isize] = ACTIONS(795),
    [anon_sym_usize] = ACTIONS(795),
    [anon_sym_f32] = ACTIONS(795),
    [anon_sym_f64] = ACTIONS(795),
    [anon_sym_bool] = ACTIONS(795),
    [anon_sym_str] = ACTIONS(795),
    [anon_sym_char] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(665),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_union] = ACTIONS(673),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(675),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym__] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(691),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(695),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(805),
    [sym_super] = ACTIONS(807),
    [sym_crate] = ACTIONS(807),
    [sym_metavariable] = ACTIONS(809),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [140] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1125),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1125),
    [sym_macro_invocation] = STATE(1125),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1125),
    [sym_unary_expression] = STATE(1125),
    [sym_try_expression] = STATE(1125),
    [sym_reference_expression] = STATE(1125),
    [sym_binary_expression] = STATE(1125),
    [sym_assignment_expression] = STATE(1125),
    [sym_compound_assignment_expr] = STATE(1125),
    [sym_type_cast_expression] = STATE(1125),
    [sym_return_expression] = STATE(1125),
    [sym_call_expression] = STATE(1125),
    [sym_array_expression] = STATE(1125),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_tuple_expression] = STATE(1125),
    [sym_unit_expression] = STATE(1125),
    [sym_struct_expression] = STATE(1125),
    [sym_if_expression] = STATE(1125),
    [sym_if_let_expression] = STATE(1125),
    [sym_match_expression] = STATE(1125),
    [sym_while_expression] = STATE(1125),
    [sym_while_let_expression] = STATE(1125),
    [sym_loop_expression] = STATE(1125),
    [sym_for_expression] = STATE(1125),
    [sym_closure_expression] = STATE(1125),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1125),
    [sym_continue_expression] = STATE(1125),
    [sym_index_expression] = STATE(1125),
    [sym_await_expression] = STATE(1125),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1125),
    [sym_async_block] = STATE(1125),
    [sym_block] = STATE(1125),
    [sym__literal] = STATE(1125),
    [sym_string_literal] = STATE(1125),
    [sym_boolean_literal] = STATE(1125),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(905),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(905),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(905),
    [sym_float_literal] = ACTIONS(905),
    [sym_block_comment] = ACTIONS(3),
  },
  [141] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1036),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1036),
    [sym_macro_invocation] = STATE(1036),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1036),
    [sym_unary_expression] = STATE(1036),
    [sym_try_expression] = STATE(1036),
    [sym_reference_expression] = STATE(1036),
    [sym_binary_expression] = STATE(1036),
    [sym_assignment_expression] = STATE(1036),
    [sym_compound_assignment_expr] = STATE(1036),
    [sym_type_cast_expression] = STATE(1036),
    [sym_return_expression] = STATE(1036),
    [sym_call_expression] = STATE(1036),
    [sym_array_expression] = STATE(1036),
    [sym_parenthesized_expression] = STATE(1036),
    [sym_tuple_expression] = STATE(1036),
    [sym_unit_expression] = STATE(1036),
    [sym_struct_expression] = STATE(1036),
    [sym_if_expression] = STATE(1036),
    [sym_if_let_expression] = STATE(1036),
    [sym_match_expression] = STATE(1036),
    [sym_while_expression] = STATE(1036),
    [sym_while_let_expression] = STATE(1036),
    [sym_loop_expression] = STATE(1036),
    [sym_for_expression] = STATE(1036),
    [sym_closure_expression] = STATE(1036),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1036),
    [sym_continue_expression] = STATE(1036),
    [sym_index_expression] = STATE(1036),
    [sym_await_expression] = STATE(1036),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1036),
    [sym_async_block] = STATE(1036),
    [sym_block] = STATE(1036),
    [sym__literal] = STATE(1036),
    [sym_string_literal] = STATE(1036),
    [sym_boolean_literal] = STATE(1036),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(907),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(907),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(907),
    [sym_float_literal] = ACTIONS(907),
    [sym_block_comment] = ACTIONS(3),
  },
  [142] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1035),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1035),
    [sym_macro_invocation] = STATE(1035),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1035),
    [sym_unary_expression] = STATE(1035),
    [sym_try_expression] = STATE(1035),
    [sym_reference_expression] = STATE(1035),
    [sym_binary_expression] = STATE(1035),
    [sym_assignment_expression] = STATE(1035),
    [sym_compound_assignment_expr] = STATE(1035),
    [sym_type_cast_expression] = STATE(1035),
    [sym_return_expression] = STATE(1035),
    [sym_call_expression] = STATE(1035),
    [sym_array_expression] = STATE(1035),
    [sym_parenthesized_expression] = STATE(1035),
    [sym_tuple_expression] = STATE(1035),
    [sym_unit_expression] = STATE(1035),
    [sym_struct_expression] = STATE(1035),
    [sym_if_expression] = STATE(1035),
    [sym_if_let_expression] = STATE(1035),
    [sym_match_expression] = STATE(1035),
    [sym_while_expression] = STATE(1035),
    [sym_while_let_expression] = STATE(1035),
    [sym_loop_expression] = STATE(1035),
    [sym_for_expression] = STATE(1035),
    [sym_closure_expression] = STATE(1035),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1035),
    [sym_continue_expression] = STATE(1035),
    [sym_index_expression] = STATE(1035),
    [sym_await_expression] = STATE(1035),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1035),
    [sym_async_block] = STATE(1035),
    [sym_block] = STATE(1035),
    [sym__literal] = STATE(1035),
    [sym_string_literal] = STATE(1035),
    [sym_boolean_literal] = STATE(1035),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(909),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(909),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(909),
    [sym_float_literal] = ACTIONS(909),
    [sym_block_comment] = ACTIONS(3),
  },
  [143] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1094),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1094),
    [sym_macro_invocation] = STATE(1094),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1094),
    [sym_unary_expression] = STATE(1094),
    [sym_try_expression] = STATE(1094),
    [sym_reference_expression] = STATE(1094),
    [sym_binary_expression] = STATE(1094),
    [sym_assignment_expression] = STATE(1094),
    [sym_compound_assignment_expr] = STATE(1094),
    [sym_type_cast_expression] = STATE(1094),
    [sym_return_expression] = STATE(1094),
    [sym_call_expression] = STATE(1094),
    [sym_array_expression] = STATE(1094),
    [sym_parenthesized_expression] = STATE(1094),
    [sym_tuple_expression] = STATE(1094),
    [sym_unit_expression] = STATE(1094),
    [sym_struct_expression] = STATE(1094),
    [sym_if_expression] = STATE(1094),
    [sym_if_let_expression] = STATE(1094),
    [sym_match_expression] = STATE(1094),
    [sym_while_expression] = STATE(1094),
    [sym_while_let_expression] = STATE(1094),
    [sym_loop_expression] = STATE(1094),
    [sym_for_expression] = STATE(1094),
    [sym_closure_expression] = STATE(1094),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1094),
    [sym_continue_expression] = STATE(1094),
    [sym_index_expression] = STATE(1094),
    [sym_await_expression] = STATE(1094),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1094),
    [sym_async_block] = STATE(1094),
    [sym_block] = STATE(1094),
    [sym__literal] = STATE(1094),
    [sym_string_literal] = STATE(1094),
    [sym_boolean_literal] = STATE(1094),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(911),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(911),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(911),
    [sym_float_literal] = ACTIONS(911),
    [sym_block_comment] = ACTIONS(3),
  },
  [144] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1188),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1188),
    [sym_macro_invocation] = STATE(1188),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1188),
    [sym_unary_expression] = STATE(1188),
    [sym_try_expression] = STATE(1188),
    [sym_reference_expression] = STATE(1188),
    [sym_binary_expression] = STATE(1188),
    [sym_assignment_expression] = STATE(1188),
    [sym_compound_assignment_expr] = STATE(1188),
    [sym_type_cast_expression] = STATE(1188),
    [sym_return_expression] = STATE(1188),
    [sym_call_expression] = STATE(1188),
    [sym_array_expression] = STATE(1188),
    [sym_parenthesized_expression] = STATE(1188),
    [sym_tuple_expression] = STATE(1188),
    [sym_unit_expression] = STATE(1188),
    [sym_struct_expression] = STATE(1188),
    [sym_if_expression] = STATE(1188),
    [sym_if_let_expression] = STATE(1188),
    [sym_match_expression] = STATE(1188),
    [sym_while_expression] = STATE(1188),
    [sym_while_let_expression] = STATE(1188),
    [sym_loop_expression] = STATE(1188),
    [sym_for_expression] = STATE(1188),
    [sym_closure_expression] = STATE(1188),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1188),
    [sym_continue_expression] = STATE(1188),
    [sym_index_expression] = STATE(1188),
    [sym_await_expression] = STATE(1188),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1188),
    [sym_async_block] = STATE(1188),
    [sym_block] = STATE(1188),
    [sym__literal] = STATE(1188),
    [sym_string_literal] = STATE(1188),
    [sym_boolean_literal] = STATE(1188),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(913),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(913),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(913),
    [sym_float_literal] = ACTIONS(913),
    [sym_block_comment] = ACTIONS(3),
  },
  [145] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1142),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1142),
    [sym_macro_invocation] = STATE(1142),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1142),
    [sym_unary_expression] = STATE(1142),
    [sym_try_expression] = STATE(1142),
    [sym_reference_expression] = STATE(1142),
    [sym_binary_expression] = STATE(1142),
    [sym_assignment_expression] = STATE(1142),
    [sym_compound_assignment_expr] = STATE(1142),
    [sym_type_cast_expression] = STATE(1142),
    [sym_return_expression] = STATE(1142),
    [sym_call_expression] = STATE(1142),
    [sym_array_expression] = STATE(1142),
    [sym_parenthesized_expression] = STATE(1142),
    [sym_tuple_expression] = STATE(1142),
    [sym_unit_expression] = STATE(1142),
    [sym_struct_expression] = STATE(1142),
    [sym_if_expression] = STATE(1142),
    [sym_if_let_expression] = STATE(1142),
    [sym_match_expression] = STATE(1142),
    [sym_while_expression] = STATE(1142),
    [sym_while_let_expression] = STATE(1142),
    [sym_loop_expression] = STATE(1142),
    [sym_for_expression] = STATE(1142),
    [sym_closure_expression] = STATE(1142),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1142),
    [sym_continue_expression] = STATE(1142),
    [sym_index_expression] = STATE(1142),
    [sym_await_expression] = STATE(1142),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1142),
    [sym_async_block] = STATE(1142),
    [sym_block] = STATE(1142),
    [sym__literal] = STATE(1142),
    [sym_string_literal] = STATE(1142),
    [sym_boolean_literal] = STATE(1142),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(915),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(915),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(915),
    [sym_float_literal] = ACTIONS(915),
    [sym_block_comment] = ACTIONS(3),
  },
  [146] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1176),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1176),
    [sym_macro_invocation] = STATE(1176),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1176),
    [sym_unary_expression] = STATE(1176),
    [sym_try_expression] = STATE(1176),
    [sym_reference_expression] = STATE(1176),
    [sym_binary_expression] = STATE(1176),
    [sym_assignment_expression] = STATE(1176),
    [sym_compound_assignment_expr] = STATE(1176),
    [sym_type_cast_expression] = STATE(1176),
    [sym_return_expression] = STATE(1176),
    [sym_call_expression] = STATE(1176),
    [sym_array_expression] = STATE(1176),
    [sym_parenthesized_expression] = STATE(1176),
    [sym_tuple_expression] = STATE(1176),
    [sym_unit_expression] = STATE(1176),
    [sym_struct_expression] = STATE(1176),
    [sym_if_expression] = STATE(1176),
    [sym_if_let_expression] = STATE(1176),
    [sym_match_expression] = STATE(1176),
    [sym_while_expression] = STATE(1176),
    [sym_while_let_expression] = STATE(1176),
    [sym_loop_expression] = STATE(1176),
    [sym_for_expression] = STATE(1176),
    [sym_closure_expression] = STATE(1176),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1176),
    [sym_continue_expression] = STATE(1176),
    [sym_index_expression] = STATE(1176),
    [sym_await_expression] = STATE(1176),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1176),
    [sym_async_block] = STATE(1176),
    [sym_block] = STATE(1176),
    [sym__literal] = STATE(1176),
    [sym_string_literal] = STATE(1176),
    [sym_boolean_literal] = STATE(1176),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(917),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(917),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(917),
    [sym_float_literal] = ACTIONS(917),
    [sym_block_comment] = ACTIONS(3),
  },
  [147] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1117),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1117),
    [sym_macro_invocation] = STATE(1117),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1117),
    [sym_unary_expression] = STATE(1117),
    [sym_try_expression] = STATE(1117),
    [sym_reference_expression] = STATE(1117),
    [sym_binary_expression] = STATE(1117),
    [sym_assignment_expression] = STATE(1117),
    [sym_compound_assignment_expr] = STATE(1117),
    [sym_type_cast_expression] = STATE(1117),
    [sym_return_expression] = STATE(1117),
    [sym_call_expression] = STATE(1117),
    [sym_array_expression] = STATE(1117),
    [sym_parenthesized_expression] = STATE(1117),
    [sym_tuple_expression] = STATE(1117),
    [sym_unit_expression] = STATE(1117),
    [sym_struct_expression] = STATE(1117),
    [sym_if_expression] = STATE(226),
    [sym_if_let_expression] = STATE(226),
    [sym_match_expression] = STATE(226),
    [sym_while_expression] = STATE(226),
    [sym_while_let_expression] = STATE(226),
    [sym_loop_expression] = STATE(226),
    [sym_for_expression] = STATE(226),
    [sym_closure_expression] = STATE(1117),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2363),
    [sym_break_expression] = STATE(1117),
    [sym_continue_expression] = STATE(1117),
    [sym_index_expression] = STATE(1117),
    [sym_await_expression] = STATE(1117),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(226),
    [sym_async_block] = STATE(226),
    [sym_block] = STATE(226),
    [sym__literal] = STATE(1117),
    [sym_string_literal] = STATE(1117),
    [sym_boolean_literal] = STATE(1117),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(921),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(925),
    [anon_sym_loop] = ACTIONS(927),
    [anon_sym_match] = ACTIONS(929),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(931),
    [anon_sym_while] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(935),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(935),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(935),
    [sym_float_literal] = ACTIONS(935),
    [sym_block_comment] = ACTIONS(3),
  },
  [148] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1195),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1195),
    [sym_macro_invocation] = STATE(1195),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1195),
    [sym_unary_expression] = STATE(1195),
    [sym_try_expression] = STATE(1195),
    [sym_reference_expression] = STATE(1195),
    [sym_binary_expression] = STATE(1195),
    [sym_assignment_expression] = STATE(1195),
    [sym_compound_assignment_expr] = STATE(1195),
    [sym_type_cast_expression] = STATE(1195),
    [sym_return_expression] = STATE(1195),
    [sym_call_expression] = STATE(1195),
    [sym_array_expression] = STATE(1195),
    [sym_parenthesized_expression] = STATE(1195),
    [sym_tuple_expression] = STATE(1195),
    [sym_unit_expression] = STATE(1195),
    [sym_struct_expression] = STATE(1195),
    [sym_if_expression] = STATE(1195),
    [sym_if_let_expression] = STATE(1195),
    [sym_match_expression] = STATE(1195),
    [sym_while_expression] = STATE(1195),
    [sym_while_let_expression] = STATE(1195),
    [sym_loop_expression] = STATE(1195),
    [sym_for_expression] = STATE(1195),
    [sym_closure_expression] = STATE(1195),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1195),
    [sym_continue_expression] = STATE(1195),
    [sym_index_expression] = STATE(1195),
    [sym_await_expression] = STATE(1195),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1195),
    [sym_async_block] = STATE(1195),
    [sym_block] = STATE(1195),
    [sym__literal] = STATE(1195),
    [sym_string_literal] = STATE(1195),
    [sym_boolean_literal] = STATE(1195),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(937),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(937),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(937),
    [sym_float_literal] = ACTIONS(937),
    [sym_block_comment] = ACTIONS(3),
  },
  [149] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1092),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1092),
    [sym_macro_invocation] = STATE(1092),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1092),
    [sym_unary_expression] = STATE(1092),
    [sym_try_expression] = STATE(1092),
    [sym_reference_expression] = STATE(1092),
    [sym_binary_expression] = STATE(1092),
    [sym_assignment_expression] = STATE(1092),
    [sym_compound_assignment_expr] = STATE(1092),
    [sym_type_cast_expression] = STATE(1092),
    [sym_return_expression] = STATE(1092),
    [sym_call_expression] = STATE(1092),
    [sym_array_expression] = STATE(1092),
    [sym_parenthesized_expression] = STATE(1092),
    [sym_tuple_expression] = STATE(1092),
    [sym_unit_expression] = STATE(1092),
    [sym_struct_expression] = STATE(1092),
    [sym_if_expression] = STATE(1092),
    [sym_if_let_expression] = STATE(1092),
    [sym_match_expression] = STATE(1092),
    [sym_while_expression] = STATE(1092),
    [sym_while_let_expression] = STATE(1092),
    [sym_loop_expression] = STATE(1092),
    [sym_for_expression] = STATE(1092),
    [sym_closure_expression] = STATE(1092),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1092),
    [sym_continue_expression] = STATE(1092),
    [sym_index_expression] = STATE(1092),
    [sym_await_expression] = STATE(1092),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1092),
    [sym_async_block] = STATE(1092),
    [sym_block] = STATE(1092),
    [sym__literal] = STATE(1092),
    [sym_string_literal] = STATE(1092),
    [sym_boolean_literal] = STATE(1092),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(939),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(939),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(939),
    [sym_float_literal] = ACTIONS(939),
    [sym_block_comment] = ACTIONS(3),
  },
  [150] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1147),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1147),
    [sym_macro_invocation] = STATE(1147),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1147),
    [sym_unary_expression] = STATE(1147),
    [sym_try_expression] = STATE(1147),
    [sym_reference_expression] = STATE(1147),
    [sym_binary_expression] = STATE(1147),
    [sym_assignment_expression] = STATE(1147),
    [sym_compound_assignment_expr] = STATE(1147),
    [sym_type_cast_expression] = STATE(1147),
    [sym_return_expression] = STATE(1147),
    [sym_call_expression] = STATE(1147),
    [sym_array_expression] = STATE(1147),
    [sym_parenthesized_expression] = STATE(1147),
    [sym_tuple_expression] = STATE(1147),
    [sym_unit_expression] = STATE(1147),
    [sym_struct_expression] = STATE(1147),
    [sym_if_expression] = STATE(1147),
    [sym_if_let_expression] = STATE(1147),
    [sym_match_expression] = STATE(1147),
    [sym_while_expression] = STATE(1147),
    [sym_while_let_expression] = STATE(1147),
    [sym_loop_expression] = STATE(1147),
    [sym_for_expression] = STATE(1147),
    [sym_closure_expression] = STATE(1147),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1147),
    [sym_continue_expression] = STATE(1147),
    [sym_index_expression] = STATE(1147),
    [sym_await_expression] = STATE(1147),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1147),
    [sym_async_block] = STATE(1147),
    [sym_block] = STATE(1147),
    [sym__literal] = STATE(1147),
    [sym_string_literal] = STATE(1147),
    [sym_boolean_literal] = STATE(1147),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(941),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(941),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(941),
    [sym_float_literal] = ACTIONS(941),
    [sym_block_comment] = ACTIONS(3),
  },
  [151] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1130),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1130),
    [sym_macro_invocation] = STATE(1130),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1130),
    [sym_unary_expression] = STATE(1130),
    [sym_try_expression] = STATE(1130),
    [sym_reference_expression] = STATE(1130),
    [sym_binary_expression] = STATE(1130),
    [sym_assignment_expression] = STATE(1130),
    [sym_compound_assignment_expr] = STATE(1130),
    [sym_type_cast_expression] = STATE(1130),
    [sym_return_expression] = STATE(1130),
    [sym_call_expression] = STATE(1130),
    [sym_array_expression] = STATE(1130),
    [sym_parenthesized_expression] = STATE(1130),
    [sym_tuple_expression] = STATE(1130),
    [sym_unit_expression] = STATE(1130),
    [sym_struct_expression] = STATE(1130),
    [sym_if_expression] = STATE(1130),
    [sym_if_let_expression] = STATE(1130),
    [sym_match_expression] = STATE(1130),
    [sym_while_expression] = STATE(1130),
    [sym_while_let_expression] = STATE(1130),
    [sym_loop_expression] = STATE(1130),
    [sym_for_expression] = STATE(1130),
    [sym_closure_expression] = STATE(1130),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1130),
    [sym_continue_expression] = STATE(1130),
    [sym_index_expression] = STATE(1130),
    [sym_await_expression] = STATE(1130),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1130),
    [sym_async_block] = STATE(1130),
    [sym_block] = STATE(1130),
    [sym__literal] = STATE(1130),
    [sym_string_literal] = STATE(1130),
    [sym_boolean_literal] = STATE(1130),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(943),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(943),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(943),
    [sym_float_literal] = ACTIONS(943),
    [sym_block_comment] = ACTIONS(3),
  },
  [152] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1106),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1106),
    [sym_macro_invocation] = STATE(1106),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1106),
    [sym_unary_expression] = STATE(1106),
    [sym_try_expression] = STATE(1106),
    [sym_reference_expression] = STATE(1106),
    [sym_binary_expression] = STATE(1106),
    [sym_assignment_expression] = STATE(1106),
    [sym_compound_assignment_expr] = STATE(1106),
    [sym_type_cast_expression] = STATE(1106),
    [sym_return_expression] = STATE(1106),
    [sym_call_expression] = STATE(1106),
    [sym_array_expression] = STATE(1106),
    [sym_parenthesized_expression] = STATE(1106),
    [sym_tuple_expression] = STATE(1106),
    [sym_unit_expression] = STATE(1106),
    [sym_struct_expression] = STATE(1106),
    [sym_if_expression] = STATE(1106),
    [sym_if_let_expression] = STATE(1106),
    [sym_match_expression] = STATE(1106),
    [sym_while_expression] = STATE(1106),
    [sym_while_let_expression] = STATE(1106),
    [sym_loop_expression] = STATE(1106),
    [sym_for_expression] = STATE(1106),
    [sym_closure_expression] = STATE(1106),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1106),
    [sym_continue_expression] = STATE(1106),
    [sym_index_expression] = STATE(1106),
    [sym_await_expression] = STATE(1106),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1106),
    [sym_async_block] = STATE(1106),
    [sym_block] = STATE(1106),
    [sym__literal] = STATE(1106),
    [sym_string_literal] = STATE(1106),
    [sym_boolean_literal] = STATE(1106),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(945),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(945),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(945),
    [sym_float_literal] = ACTIONS(945),
    [sym_block_comment] = ACTIONS(3),
  },
  [153] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1197),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1197),
    [sym_macro_invocation] = STATE(1197),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1197),
    [sym_unary_expression] = STATE(1197),
    [sym_try_expression] = STATE(1197),
    [sym_reference_expression] = STATE(1197),
    [sym_binary_expression] = STATE(1197),
    [sym_assignment_expression] = STATE(1197),
    [sym_compound_assignment_expr] = STATE(1197),
    [sym_type_cast_expression] = STATE(1197),
    [sym_return_expression] = STATE(1197),
    [sym_call_expression] = STATE(1197),
    [sym_array_expression] = STATE(1197),
    [sym_parenthesized_expression] = STATE(1197),
    [sym_tuple_expression] = STATE(1197),
    [sym_unit_expression] = STATE(1197),
    [sym_struct_expression] = STATE(1197),
    [sym_if_expression] = STATE(1197),
    [sym_if_let_expression] = STATE(1197),
    [sym_match_expression] = STATE(1197),
    [sym_while_expression] = STATE(1197),
    [sym_while_let_expression] = STATE(1197),
    [sym_loop_expression] = STATE(1197),
    [sym_for_expression] = STATE(1197),
    [sym_closure_expression] = STATE(1197),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1197),
    [sym_continue_expression] = STATE(1197),
    [sym_index_expression] = STATE(1197),
    [sym_await_expression] = STATE(1197),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1197),
    [sym_async_block] = STATE(1197),
    [sym_block] = STATE(1197),
    [sym__literal] = STATE(1197),
    [sym_string_literal] = STATE(1197),
    [sym_boolean_literal] = STATE(1197),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(947),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(947),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(947),
    [sym_float_literal] = ACTIONS(947),
    [sym_block_comment] = ACTIONS(3),
  },
  [154] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1189),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1189),
    [sym_macro_invocation] = STATE(1189),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1189),
    [sym_unary_expression] = STATE(1189),
    [sym_try_expression] = STATE(1189),
    [sym_reference_expression] = STATE(1189),
    [sym_binary_expression] = STATE(1189),
    [sym_assignment_expression] = STATE(1189),
    [sym_compound_assignment_expr] = STATE(1189),
    [sym_type_cast_expression] = STATE(1189),
    [sym_return_expression] = STATE(1189),
    [sym_call_expression] = STATE(1189),
    [sym_array_expression] = STATE(1189),
    [sym_parenthesized_expression] = STATE(1189),
    [sym_tuple_expression] = STATE(1189),
    [sym_unit_expression] = STATE(1189),
    [sym_struct_expression] = STATE(1189),
    [sym_if_expression] = STATE(226),
    [sym_if_let_expression] = STATE(226),
    [sym_match_expression] = STATE(226),
    [sym_while_expression] = STATE(226),
    [sym_while_let_expression] = STATE(226),
    [sym_loop_expression] = STATE(226),
    [sym_for_expression] = STATE(226),
    [sym_closure_expression] = STATE(1189),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2363),
    [sym_break_expression] = STATE(1189),
    [sym_continue_expression] = STATE(1189),
    [sym_index_expression] = STATE(1189),
    [sym_await_expression] = STATE(1189),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(226),
    [sym_async_block] = STATE(226),
    [sym_block] = STATE(226),
    [sym__literal] = STATE(1189),
    [sym_string_literal] = STATE(1189),
    [sym_boolean_literal] = STATE(1189),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(921),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(925),
    [anon_sym_loop] = ACTIONS(927),
    [anon_sym_match] = ACTIONS(929),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(931),
    [anon_sym_while] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(949),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(949),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(949),
    [sym_float_literal] = ACTIONS(949),
    [sym_block_comment] = ACTIONS(3),
  },
  [155] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1164),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1164),
    [sym_macro_invocation] = STATE(1164),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1164),
    [sym_unary_expression] = STATE(1164),
    [sym_try_expression] = STATE(1164),
    [sym_reference_expression] = STATE(1164),
    [sym_binary_expression] = STATE(1164),
    [sym_assignment_expression] = STATE(1164),
    [sym_compound_assignment_expr] = STATE(1164),
    [sym_type_cast_expression] = STATE(1164),
    [sym_return_expression] = STATE(1164),
    [sym_call_expression] = STATE(1164),
    [sym_array_expression] = STATE(1164),
    [sym_parenthesized_expression] = STATE(1164),
    [sym_tuple_expression] = STATE(1164),
    [sym_unit_expression] = STATE(1164),
    [sym_struct_expression] = STATE(1164),
    [sym_if_expression] = STATE(1164),
    [sym_if_let_expression] = STATE(1164),
    [sym_match_expression] = STATE(1164),
    [sym_while_expression] = STATE(1164),
    [sym_while_let_expression] = STATE(1164),
    [sym_loop_expression] = STATE(1164),
    [sym_for_expression] = STATE(1164),
    [sym_closure_expression] = STATE(1164),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1164),
    [sym_continue_expression] = STATE(1164),
    [sym_index_expression] = STATE(1164),
    [sym_await_expression] = STATE(1164),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1164),
    [sym_async_block] = STATE(1164),
    [sym_block] = STATE(1164),
    [sym__literal] = STATE(1164),
    [sym_string_literal] = STATE(1164),
    [sym_boolean_literal] = STATE(1164),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(951),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(951),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(951),
    [sym_float_literal] = ACTIONS(951),
    [sym_block_comment] = ACTIONS(3),
  },
  [156] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1102),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1102),
    [sym_macro_invocation] = STATE(1102),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1102),
    [sym_unary_expression] = STATE(1102),
    [sym_try_expression] = STATE(1102),
    [sym_reference_expression] = STATE(1102),
    [sym_binary_expression] = STATE(1102),
    [sym_assignment_expression] = STATE(1102),
    [sym_compound_assignment_expr] = STATE(1102),
    [sym_type_cast_expression] = STATE(1102),
    [sym_return_expression] = STATE(1102),
    [sym_call_expression] = STATE(1102),
    [sym_array_expression] = STATE(1102),
    [sym_parenthesized_expression] = STATE(1102),
    [sym_tuple_expression] = STATE(1102),
    [sym_unit_expression] = STATE(1102),
    [sym_struct_expression] = STATE(1102),
    [sym_if_expression] = STATE(1102),
    [sym_if_let_expression] = STATE(1102),
    [sym_match_expression] = STATE(1102),
    [sym_while_expression] = STATE(1102),
    [sym_while_let_expression] = STATE(1102),
    [sym_loop_expression] = STATE(1102),
    [sym_for_expression] = STATE(1102),
    [sym_closure_expression] = STATE(1102),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1102),
    [sym_continue_expression] = STATE(1102),
    [sym_index_expression] = STATE(1102),
    [sym_await_expression] = STATE(1102),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1102),
    [sym_async_block] = STATE(1102),
    [sym_block] = STATE(1102),
    [sym__literal] = STATE(1102),
    [sym_string_literal] = STATE(1102),
    [sym_boolean_literal] = STATE(1102),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(953),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(953),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(953),
    [sym_float_literal] = ACTIONS(953),
    [sym_block_comment] = ACTIONS(3),
  },
  [157] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1174),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1174),
    [sym_macro_invocation] = STATE(1174),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1174),
    [sym_unary_expression] = STATE(1174),
    [sym_try_expression] = STATE(1174),
    [sym_reference_expression] = STATE(1174),
    [sym_binary_expression] = STATE(1174),
    [sym_assignment_expression] = STATE(1174),
    [sym_compound_assignment_expr] = STATE(1174),
    [sym_type_cast_expression] = STATE(1174),
    [sym_return_expression] = STATE(1174),
    [sym_call_expression] = STATE(1174),
    [sym_array_expression] = STATE(1174),
    [sym_parenthesized_expression] = STATE(1174),
    [sym_tuple_expression] = STATE(1174),
    [sym_unit_expression] = STATE(1174),
    [sym_struct_expression] = STATE(1174),
    [sym_if_expression] = STATE(1174),
    [sym_if_let_expression] = STATE(1174),
    [sym_match_expression] = STATE(1174),
    [sym_while_expression] = STATE(1174),
    [sym_while_let_expression] = STATE(1174),
    [sym_loop_expression] = STATE(1174),
    [sym_for_expression] = STATE(1174),
    [sym_closure_expression] = STATE(1174),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1174),
    [sym_continue_expression] = STATE(1174),
    [sym_index_expression] = STATE(1174),
    [sym_await_expression] = STATE(1174),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1174),
    [sym_async_block] = STATE(1174),
    [sym_block] = STATE(1174),
    [sym__literal] = STATE(1174),
    [sym_string_literal] = STATE(1174),
    [sym_boolean_literal] = STATE(1174),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(955),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(955),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(955),
    [sym_float_literal] = ACTIONS(955),
    [sym_block_comment] = ACTIONS(3),
  },
  [158] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1091),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1091),
    [sym_macro_invocation] = STATE(1091),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1091),
    [sym_unary_expression] = STATE(1091),
    [sym_try_expression] = STATE(1091),
    [sym_reference_expression] = STATE(1091),
    [sym_binary_expression] = STATE(1091),
    [sym_assignment_expression] = STATE(1091),
    [sym_compound_assignment_expr] = STATE(1091),
    [sym_type_cast_expression] = STATE(1091),
    [sym_return_expression] = STATE(1091),
    [sym_call_expression] = STATE(1091),
    [sym_array_expression] = STATE(1091),
    [sym_parenthesized_expression] = STATE(1091),
    [sym_tuple_expression] = STATE(1091),
    [sym_unit_expression] = STATE(1091),
    [sym_struct_expression] = STATE(1091),
    [sym_if_expression] = STATE(1091),
    [sym_if_let_expression] = STATE(1091),
    [sym_match_expression] = STATE(1091),
    [sym_while_expression] = STATE(1091),
    [sym_while_let_expression] = STATE(1091),
    [sym_loop_expression] = STATE(1091),
    [sym_for_expression] = STATE(1091),
    [sym_closure_expression] = STATE(1091),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1091),
    [sym_continue_expression] = STATE(1091),
    [sym_index_expression] = STATE(1091),
    [sym_await_expression] = STATE(1091),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1091),
    [sym_async_block] = STATE(1091),
    [sym_block] = STATE(1091),
    [sym__literal] = STATE(1091),
    [sym_string_literal] = STATE(1091),
    [sym_boolean_literal] = STATE(1091),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(957),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(957),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(957),
    [sym_float_literal] = ACTIONS(957),
    [sym_block_comment] = ACTIONS(3),
  },
  [159] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1170),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1170),
    [sym_macro_invocation] = STATE(1170),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1170),
    [sym_unary_expression] = STATE(1170),
    [sym_try_expression] = STATE(1170),
    [sym_reference_expression] = STATE(1170),
    [sym_binary_expression] = STATE(1170),
    [sym_assignment_expression] = STATE(1170),
    [sym_compound_assignment_expr] = STATE(1170),
    [sym_type_cast_expression] = STATE(1170),
    [sym_return_expression] = STATE(1170),
    [sym_call_expression] = STATE(1170),
    [sym_array_expression] = STATE(1170),
    [sym_parenthesized_expression] = STATE(1170),
    [sym_tuple_expression] = STATE(1170),
    [sym_unit_expression] = STATE(1170),
    [sym_struct_expression] = STATE(1170),
    [sym_if_expression] = STATE(1170),
    [sym_if_let_expression] = STATE(1170),
    [sym_match_expression] = STATE(1170),
    [sym_while_expression] = STATE(1170),
    [sym_while_let_expression] = STATE(1170),
    [sym_loop_expression] = STATE(1170),
    [sym_for_expression] = STATE(1170),
    [sym_closure_expression] = STATE(1170),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1170),
    [sym_continue_expression] = STATE(1170),
    [sym_index_expression] = STATE(1170),
    [sym_await_expression] = STATE(1170),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1170),
    [sym_async_block] = STATE(1170),
    [sym_block] = STATE(1170),
    [sym__literal] = STATE(1170),
    [sym_string_literal] = STATE(1170),
    [sym_boolean_literal] = STATE(1170),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(959),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(959),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(959),
    [sym_float_literal] = ACTIONS(959),
    [sym_block_comment] = ACTIONS(3),
  },
  [160] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1168),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1168),
    [sym_macro_invocation] = STATE(1168),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1168),
    [sym_unary_expression] = STATE(1168),
    [sym_try_expression] = STATE(1168),
    [sym_reference_expression] = STATE(1168),
    [sym_binary_expression] = STATE(1168),
    [sym_assignment_expression] = STATE(1168),
    [sym_compound_assignment_expr] = STATE(1168),
    [sym_type_cast_expression] = STATE(1168),
    [sym_return_expression] = STATE(1168),
    [sym_call_expression] = STATE(1168),
    [sym_array_expression] = STATE(1168),
    [sym_parenthesized_expression] = STATE(1168),
    [sym_tuple_expression] = STATE(1168),
    [sym_unit_expression] = STATE(1168),
    [sym_struct_expression] = STATE(1168),
    [sym_if_expression] = STATE(225),
    [sym_if_let_expression] = STATE(225),
    [sym_match_expression] = STATE(225),
    [sym_while_expression] = STATE(225),
    [sym_while_let_expression] = STATE(225),
    [sym_loop_expression] = STATE(225),
    [sym_for_expression] = STATE(225),
    [sym_closure_expression] = STATE(1168),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2363),
    [sym_break_expression] = STATE(1168),
    [sym_continue_expression] = STATE(1168),
    [sym_index_expression] = STATE(1168),
    [sym_await_expression] = STATE(1168),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(225),
    [sym_async_block] = STATE(225),
    [sym_block] = STATE(225),
    [sym__literal] = STATE(1168),
    [sym_string_literal] = STATE(1168),
    [sym_boolean_literal] = STATE(1168),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(921),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(925),
    [anon_sym_loop] = ACTIONS(927),
    [anon_sym_match] = ACTIONS(929),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(931),
    [anon_sym_while] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(961),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(961),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(961),
    [sym_float_literal] = ACTIONS(961),
    [sym_block_comment] = ACTIONS(3),
  },
  [161] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1046),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1046),
    [sym_macro_invocation] = STATE(1046),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1046),
    [sym_unary_expression] = STATE(1046),
    [sym_try_expression] = STATE(1046),
    [sym_reference_expression] = STATE(1046),
    [sym_binary_expression] = STATE(1046),
    [sym_assignment_expression] = STATE(1046),
    [sym_compound_assignment_expr] = STATE(1046),
    [sym_type_cast_expression] = STATE(1046),
    [sym_return_expression] = STATE(1046),
    [sym_call_expression] = STATE(1046),
    [sym_array_expression] = STATE(1046),
    [sym_parenthesized_expression] = STATE(1046),
    [sym_tuple_expression] = STATE(1046),
    [sym_unit_expression] = STATE(1046),
    [sym_struct_expression] = STATE(1046),
    [sym_if_expression] = STATE(1046),
    [sym_if_let_expression] = STATE(1046),
    [sym_match_expression] = STATE(1046),
    [sym_while_expression] = STATE(1046),
    [sym_while_let_expression] = STATE(1046),
    [sym_loop_expression] = STATE(1046),
    [sym_for_expression] = STATE(1046),
    [sym_closure_expression] = STATE(1046),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1046),
    [sym_continue_expression] = STATE(1046),
    [sym_index_expression] = STATE(1046),
    [sym_await_expression] = STATE(1046),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1046),
    [sym_async_block] = STATE(1046),
    [sym_block] = STATE(1046),
    [sym__literal] = STATE(1046),
    [sym_string_literal] = STATE(1046),
    [sym_boolean_literal] = STATE(1046),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(963),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(963),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(963),
    [sym_float_literal] = ACTIONS(963),
    [sym_block_comment] = ACTIONS(3),
  },
  [162] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1202),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1202),
    [sym_macro_invocation] = STATE(1202),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1202),
    [sym_unary_expression] = STATE(1202),
    [sym_try_expression] = STATE(1202),
    [sym_reference_expression] = STATE(1202),
    [sym_binary_expression] = STATE(1202),
    [sym_assignment_expression] = STATE(1202),
    [sym_compound_assignment_expr] = STATE(1202),
    [sym_type_cast_expression] = STATE(1202),
    [sym_return_expression] = STATE(1202),
    [sym_call_expression] = STATE(1202),
    [sym_array_expression] = STATE(1202),
    [sym_parenthesized_expression] = STATE(1202),
    [sym_tuple_expression] = STATE(1202),
    [sym_unit_expression] = STATE(1202),
    [sym_struct_expression] = STATE(1202),
    [sym_if_expression] = STATE(1202),
    [sym_if_let_expression] = STATE(1202),
    [sym_match_expression] = STATE(1202),
    [sym_while_expression] = STATE(1202),
    [sym_while_let_expression] = STATE(1202),
    [sym_loop_expression] = STATE(1202),
    [sym_for_expression] = STATE(1202),
    [sym_closure_expression] = STATE(1202),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1202),
    [sym_continue_expression] = STATE(1202),
    [sym_index_expression] = STATE(1202),
    [sym_await_expression] = STATE(1202),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1202),
    [sym_async_block] = STATE(1202),
    [sym_block] = STATE(1202),
    [sym__literal] = STATE(1202),
    [sym_string_literal] = STATE(1202),
    [sym_boolean_literal] = STATE(1202),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(965),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(965),
    [sym_float_literal] = ACTIONS(965),
    [sym_block_comment] = ACTIONS(3),
  },
  [163] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1045),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1045),
    [sym_macro_invocation] = STATE(1045),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1045),
    [sym_unary_expression] = STATE(1045),
    [sym_try_expression] = STATE(1045),
    [sym_reference_expression] = STATE(1045),
    [sym_binary_expression] = STATE(1045),
    [sym_assignment_expression] = STATE(1045),
    [sym_compound_assignment_expr] = STATE(1045),
    [sym_type_cast_expression] = STATE(1045),
    [sym_return_expression] = STATE(1045),
    [sym_call_expression] = STATE(1045),
    [sym_array_expression] = STATE(1045),
    [sym_parenthesized_expression] = STATE(1045),
    [sym_tuple_expression] = STATE(1045),
    [sym_unit_expression] = STATE(1045),
    [sym_struct_expression] = STATE(1045),
    [sym_if_expression] = STATE(1045),
    [sym_if_let_expression] = STATE(1045),
    [sym_match_expression] = STATE(1045),
    [sym_while_expression] = STATE(1045),
    [sym_while_let_expression] = STATE(1045),
    [sym_loop_expression] = STATE(1045),
    [sym_for_expression] = STATE(1045),
    [sym_closure_expression] = STATE(1045),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1045),
    [sym_continue_expression] = STATE(1045),
    [sym_index_expression] = STATE(1045),
    [sym_await_expression] = STATE(1045),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1045),
    [sym_async_block] = STATE(1045),
    [sym_block] = STATE(1045),
    [sym__literal] = STATE(1045),
    [sym_string_literal] = STATE(1045),
    [sym_boolean_literal] = STATE(1045),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(967),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(967),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(967),
    [sym_float_literal] = ACTIONS(967),
    [sym_block_comment] = ACTIONS(3),
  },
  [164] = {
    [sym_attribute_item] = STATE(184),
    [sym_function_modifiers] = STATE(2207),
    [sym_self_parameter] = STATE(2017),
    [sym_variadic_parameter] = STATE(2017),
    [sym_parameter] = STATE(2017),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1752),
    [sym_bracketed_type] = STATE(2318),
    [sym_lifetime] = STATE(1828),
    [sym_array_type] = STATE(1752),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1752),
    [sym_tuple_type] = STATE(1752),
    [sym_unit_type] = STATE(1752),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2319),
    [sym_bounded_type] = STATE(1752),
    [sym_reference_type] = STATE(1752),
    [sym_pointer_type] = STATE(1752),
    [sym_empty_type] = STATE(1752),
    [sym_abstract_type] = STATE(1752),
    [sym_dynamic_type] = STATE(1752),
    [sym_macro_invocation] = STATE(1752),
    [sym_scoped_identifier] = STATE(1472),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(2132),
    [sym_tuple_pattern] = STATE(2132),
    [sym_slice_pattern] = STATE(2132),
    [sym_tuple_struct_pattern] = STATE(2132),
    [sym_struct_pattern] = STATE(2132),
    [sym_remaining_field_pattern] = STATE(2132),
    [sym_mut_pattern] = STATE(2132),
    [sym_range_pattern] = STATE(2132),
    [sym_ref_pattern] = STATE(2132),
    [sym_captured_pattern] = STATE(2132),
    [sym_reference_pattern] = STATE(2132),
    [sym_or_pattern] = STATE(2132),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(969),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(795),
    [anon_sym_i8] = ACTIONS(795),
    [anon_sym_u16] = ACTIONS(795),
    [anon_sym_i16] = ACTIONS(795),
    [anon_sym_u32] = ACTIONS(795),
    [anon_sym_i32] = ACTIONS(795),
    [anon_sym_u64] = ACTIONS(795),
    [anon_sym_i64] = ACTIONS(795),
    [anon_sym_u128] = ACTIONS(795),
    [anon_sym_i128] = ACTIONS(795),
    [anon_sym_isize] = ACTIONS(795),
    [anon_sym_usize] = ACTIONS(795),
    [anon_sym_f32] = ACTIONS(795),
    [anon_sym_f64] = ACTIONS(795),
    [anon_sym_bool] = ACTIONS(795),
    [anon_sym_str] = ACTIONS(795),
    [anon_sym_char] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(665),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_union] = ACTIONS(673),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(675),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym__] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(691),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(695),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(805),
    [sym_super] = ACTIONS(807),
    [sym_crate] = ACTIONS(807),
    [sym_metavariable] = ACTIONS(809),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [165] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1044),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1044),
    [sym_macro_invocation] = STATE(1044),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1044),
    [sym_unary_expression] = STATE(1044),
    [sym_try_expression] = STATE(1044),
    [sym_reference_expression] = STATE(1044),
    [sym_binary_expression] = STATE(1044),
    [sym_assignment_expression] = STATE(1044),
    [sym_compound_assignment_expr] = STATE(1044),
    [sym_type_cast_expression] = STATE(1044),
    [sym_return_expression] = STATE(1044),
    [sym_call_expression] = STATE(1044),
    [sym_array_expression] = STATE(1044),
    [sym_parenthesized_expression] = STATE(1044),
    [sym_tuple_expression] = STATE(1044),
    [sym_unit_expression] = STATE(1044),
    [sym_struct_expression] = STATE(1044),
    [sym_if_expression] = STATE(1044),
    [sym_if_let_expression] = STATE(1044),
    [sym_match_expression] = STATE(1044),
    [sym_while_expression] = STATE(1044),
    [sym_while_let_expression] = STATE(1044),
    [sym_loop_expression] = STATE(1044),
    [sym_for_expression] = STATE(1044),
    [sym_closure_expression] = STATE(1044),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1044),
    [sym_continue_expression] = STATE(1044),
    [sym_index_expression] = STATE(1044),
    [sym_await_expression] = STATE(1044),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1044),
    [sym_async_block] = STATE(1044),
    [sym_block] = STATE(1044),
    [sym__literal] = STATE(1044),
    [sym_string_literal] = STATE(1044),
    [sym_boolean_literal] = STATE(1044),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(971),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(971),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(971),
    [sym_float_literal] = ACTIONS(971),
    [sym_block_comment] = ACTIONS(3),
  },
  [166] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1043),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1043),
    [sym_macro_invocation] = STATE(1043),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1043),
    [sym_unary_expression] = STATE(1043),
    [sym_try_expression] = STATE(1043),
    [sym_reference_expression] = STATE(1043),
    [sym_binary_expression] = STATE(1043),
    [sym_assignment_expression] = STATE(1043),
    [sym_compound_assignment_expr] = STATE(1043),
    [sym_type_cast_expression] = STATE(1043),
    [sym_return_expression] = STATE(1043),
    [sym_call_expression] = STATE(1043),
    [sym_array_expression] = STATE(1043),
    [sym_parenthesized_expression] = STATE(1043),
    [sym_tuple_expression] = STATE(1043),
    [sym_unit_expression] = STATE(1043),
    [sym_struct_expression] = STATE(1043),
    [sym_if_expression] = STATE(1043),
    [sym_if_let_expression] = STATE(1043),
    [sym_match_expression] = STATE(1043),
    [sym_while_expression] = STATE(1043),
    [sym_while_let_expression] = STATE(1043),
    [sym_loop_expression] = STATE(1043),
    [sym_for_expression] = STATE(1043),
    [sym_closure_expression] = STATE(1043),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1043),
    [sym_continue_expression] = STATE(1043),
    [sym_index_expression] = STATE(1043),
    [sym_await_expression] = STATE(1043),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1043),
    [sym_async_block] = STATE(1043),
    [sym_block] = STATE(1043),
    [sym__literal] = STATE(1043),
    [sym_string_literal] = STATE(1043),
    [sym_boolean_literal] = STATE(1043),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(973),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(973),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(973),
    [sym_float_literal] = ACTIONS(973),
    [sym_block_comment] = ACTIONS(3),
  },
  [167] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1185),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1185),
    [sym_macro_invocation] = STATE(1185),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1185),
    [sym_unary_expression] = STATE(1185),
    [sym_try_expression] = STATE(1185),
    [sym_reference_expression] = STATE(1185),
    [sym_binary_expression] = STATE(1185),
    [sym_assignment_expression] = STATE(1185),
    [sym_compound_assignment_expr] = STATE(1185),
    [sym_type_cast_expression] = STATE(1185),
    [sym_return_expression] = STATE(1185),
    [sym_call_expression] = STATE(1185),
    [sym_array_expression] = STATE(1185),
    [sym_parenthesized_expression] = STATE(1185),
    [sym_tuple_expression] = STATE(1185),
    [sym_unit_expression] = STATE(1185),
    [sym_struct_expression] = STATE(1185),
    [sym_if_expression] = STATE(1185),
    [sym_if_let_expression] = STATE(1185),
    [sym_match_expression] = STATE(1185),
    [sym_while_expression] = STATE(1185),
    [sym_while_let_expression] = STATE(1185),
    [sym_loop_expression] = STATE(1185),
    [sym_for_expression] = STATE(1185),
    [sym_closure_expression] = STATE(1185),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1185),
    [sym_continue_expression] = STATE(1185),
    [sym_index_expression] = STATE(1185),
    [sym_await_expression] = STATE(1185),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1185),
    [sym_async_block] = STATE(1185),
    [sym_block] = STATE(1185),
    [sym__literal] = STATE(1185),
    [sym_string_literal] = STATE(1185),
    [sym_boolean_literal] = STATE(1185),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(975),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(975),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(975),
    [sym_float_literal] = ACTIONS(975),
    [sym_block_comment] = ACTIONS(3),
  },
  [168] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1119),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1119),
    [sym_macro_invocation] = STATE(1119),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1119),
    [sym_unary_expression] = STATE(1119),
    [sym_try_expression] = STATE(1119),
    [sym_reference_expression] = STATE(1119),
    [sym_binary_expression] = STATE(1119),
    [sym_assignment_expression] = STATE(1119),
    [sym_compound_assignment_expr] = STATE(1119),
    [sym_type_cast_expression] = STATE(1119),
    [sym_return_expression] = STATE(1119),
    [sym_call_expression] = STATE(1119),
    [sym_array_expression] = STATE(1119),
    [sym_parenthesized_expression] = STATE(1119),
    [sym_tuple_expression] = STATE(1119),
    [sym_unit_expression] = STATE(1119),
    [sym_struct_expression] = STATE(1119),
    [sym_if_expression] = STATE(225),
    [sym_if_let_expression] = STATE(225),
    [sym_match_expression] = STATE(225),
    [sym_while_expression] = STATE(225),
    [sym_while_let_expression] = STATE(225),
    [sym_loop_expression] = STATE(225),
    [sym_for_expression] = STATE(225),
    [sym_closure_expression] = STATE(1119),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2363),
    [sym_break_expression] = STATE(1119),
    [sym_continue_expression] = STATE(1119),
    [sym_index_expression] = STATE(1119),
    [sym_await_expression] = STATE(1119),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(225),
    [sym_async_block] = STATE(225),
    [sym_block] = STATE(225),
    [sym__literal] = STATE(1119),
    [sym_string_literal] = STATE(1119),
    [sym_boolean_literal] = STATE(1119),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(921),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(923),
    [anon_sym_if] = ACTIONS(925),
    [anon_sym_loop] = ACTIONS(927),
    [anon_sym_match] = ACTIONS(929),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(931),
    [anon_sym_while] = ACTIONS(933),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(977),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(977),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(977),
    [sym_float_literal] = ACTIONS(977),
    [sym_block_comment] = ACTIONS(3),
  },
  [169] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1166),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1166),
    [sym_macro_invocation] = STATE(1166),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1166),
    [sym_unary_expression] = STATE(1166),
    [sym_try_expression] = STATE(1166),
    [sym_reference_expression] = STATE(1166),
    [sym_binary_expression] = STATE(1166),
    [sym_assignment_expression] = STATE(1166),
    [sym_compound_assignment_expr] = STATE(1166),
    [sym_type_cast_expression] = STATE(1166),
    [sym_return_expression] = STATE(1166),
    [sym_call_expression] = STATE(1166),
    [sym_array_expression] = STATE(1166),
    [sym_parenthesized_expression] = STATE(1166),
    [sym_tuple_expression] = STATE(1166),
    [sym_unit_expression] = STATE(1166),
    [sym_struct_expression] = STATE(1166),
    [sym_if_expression] = STATE(1166),
    [sym_if_let_expression] = STATE(1166),
    [sym_match_expression] = STATE(1166),
    [sym_while_expression] = STATE(1166),
    [sym_while_let_expression] = STATE(1166),
    [sym_loop_expression] = STATE(1166),
    [sym_for_expression] = STATE(1166),
    [sym_closure_expression] = STATE(1166),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1166),
    [sym_continue_expression] = STATE(1166),
    [sym_index_expression] = STATE(1166),
    [sym_await_expression] = STATE(1166),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1166),
    [sym_async_block] = STATE(1166),
    [sym_block] = STATE(1166),
    [sym__literal] = STATE(1166),
    [sym_string_literal] = STATE(1166),
    [sym_boolean_literal] = STATE(1166),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(979),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(979),
    [sym_float_literal] = ACTIONS(979),
    [sym_block_comment] = ACTIONS(3),
  },
  [170] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(813),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(813),
    [sym_macro_invocation] = STATE(813),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(813),
    [sym_unary_expression] = STATE(813),
    [sym_try_expression] = STATE(813),
    [sym_reference_expression] = STATE(813),
    [sym_binary_expression] = STATE(813),
    [sym_assignment_expression] = STATE(813),
    [sym_compound_assignment_expr] = STATE(813),
    [sym_type_cast_expression] = STATE(813),
    [sym_return_expression] = STATE(813),
    [sym_call_expression] = STATE(813),
    [sym_array_expression] = STATE(813),
    [sym_parenthesized_expression] = STATE(813),
    [sym_tuple_expression] = STATE(813),
    [sym_unit_expression] = STATE(813),
    [sym_struct_expression] = STATE(813),
    [sym_if_expression] = STATE(813),
    [sym_if_let_expression] = STATE(813),
    [sym_match_expression] = STATE(813),
    [sym_while_expression] = STATE(813),
    [sym_while_let_expression] = STATE(813),
    [sym_loop_expression] = STATE(813),
    [sym_for_expression] = STATE(813),
    [sym_closure_expression] = STATE(813),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(813),
    [sym_continue_expression] = STATE(813),
    [sym_index_expression] = STATE(813),
    [sym_await_expression] = STATE(813),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(813),
    [sym_async_block] = STATE(813),
    [sym_block] = STATE(813),
    [sym__literal] = STATE(813),
    [sym_string_literal] = STATE(813),
    [sym_boolean_literal] = STATE(813),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(873),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(873),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(873),
    [sym_float_literal] = ACTIONS(873),
    [sym_block_comment] = ACTIONS(3),
  },
  [171] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1203),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1203),
    [sym_macro_invocation] = STATE(1203),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1203),
    [sym_unary_expression] = STATE(1203),
    [sym_try_expression] = STATE(1203),
    [sym_reference_expression] = STATE(1203),
    [sym_binary_expression] = STATE(1203),
    [sym_assignment_expression] = STATE(1203),
    [sym_compound_assignment_expr] = STATE(1203),
    [sym_type_cast_expression] = STATE(1203),
    [sym_return_expression] = STATE(1203),
    [sym_call_expression] = STATE(1203),
    [sym_array_expression] = STATE(1203),
    [sym_parenthesized_expression] = STATE(1203),
    [sym_tuple_expression] = STATE(1203),
    [sym_unit_expression] = STATE(1203),
    [sym_struct_expression] = STATE(1203),
    [sym_if_expression] = STATE(1203),
    [sym_if_let_expression] = STATE(1203),
    [sym_match_expression] = STATE(1203),
    [sym_while_expression] = STATE(1203),
    [sym_while_let_expression] = STATE(1203),
    [sym_loop_expression] = STATE(1203),
    [sym_for_expression] = STATE(1203),
    [sym_closure_expression] = STATE(1203),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1203),
    [sym_continue_expression] = STATE(1203),
    [sym_index_expression] = STATE(1203),
    [sym_await_expression] = STATE(1203),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1203),
    [sym_async_block] = STATE(1203),
    [sym_block] = STATE(1203),
    [sym__literal] = STATE(1203),
    [sym_string_literal] = STATE(1203),
    [sym_boolean_literal] = STATE(1203),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(981),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(981),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(981),
    [sym_float_literal] = ACTIONS(981),
    [sym_block_comment] = ACTIONS(3),
  },
  [172] = {
    [sym_attribute_item] = STATE(184),
    [sym_function_modifiers] = STATE(2207),
    [sym_self_parameter] = STATE(2017),
    [sym_variadic_parameter] = STATE(2017),
    [sym_parameter] = STATE(2017),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1752),
    [sym_bracketed_type] = STATE(2318),
    [sym_lifetime] = STATE(1828),
    [sym_array_type] = STATE(1752),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1752),
    [sym_tuple_type] = STATE(1752),
    [sym_unit_type] = STATE(1752),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2319),
    [sym_bounded_type] = STATE(1752),
    [sym_reference_type] = STATE(1752),
    [sym_pointer_type] = STATE(1752),
    [sym_empty_type] = STATE(1752),
    [sym_abstract_type] = STATE(1752),
    [sym_dynamic_type] = STATE(1752),
    [sym_macro_invocation] = STATE(1752),
    [sym_scoped_identifier] = STATE(1472),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(2132),
    [sym_tuple_pattern] = STATE(2132),
    [sym_slice_pattern] = STATE(2132),
    [sym_tuple_struct_pattern] = STATE(2132),
    [sym_struct_pattern] = STATE(2132),
    [sym_remaining_field_pattern] = STATE(2132),
    [sym_mut_pattern] = STATE(2132),
    [sym_range_pattern] = STATE(2132),
    [sym_ref_pattern] = STATE(2132),
    [sym_captured_pattern] = STATE(2132),
    [sym_reference_pattern] = STATE(2132),
    [sym_or_pattern] = STATE(2132),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(983),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(795),
    [anon_sym_i8] = ACTIONS(795),
    [anon_sym_u16] = ACTIONS(795),
    [anon_sym_i16] = ACTIONS(795),
    [anon_sym_u32] = ACTIONS(795),
    [anon_sym_i32] = ACTIONS(795),
    [anon_sym_u64] = ACTIONS(795),
    [anon_sym_i64] = ACTIONS(795),
    [anon_sym_u128] = ACTIONS(795),
    [anon_sym_i128] = ACTIONS(795),
    [anon_sym_isize] = ACTIONS(795),
    [anon_sym_usize] = ACTIONS(795),
    [anon_sym_f32] = ACTIONS(795),
    [anon_sym_f64] = ACTIONS(795),
    [anon_sym_bool] = ACTIONS(795),
    [anon_sym_str] = ACTIONS(795),
    [anon_sym_char] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(665),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_union] = ACTIONS(673),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(675),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym__] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(691),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(695),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(805),
    [sym_super] = ACTIONS(807),
    [sym_crate] = ACTIONS(807),
    [sym_metavariable] = ACTIONS(809),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [173] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1083),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1083),
    [sym_macro_invocation] = STATE(1083),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1083),
    [sym_unary_expression] = STATE(1083),
    [sym_try_expression] = STATE(1083),
    [sym_reference_expression] = STATE(1083),
    [sym_binary_expression] = STATE(1083),
    [sym_assignment_expression] = STATE(1083),
    [sym_compound_assignment_expr] = STATE(1083),
    [sym_type_cast_expression] = STATE(1083),
    [sym_return_expression] = STATE(1083),
    [sym_call_expression] = STATE(1083),
    [sym_array_expression] = STATE(1083),
    [sym_parenthesized_expression] = STATE(1083),
    [sym_tuple_expression] = STATE(1083),
    [sym_unit_expression] = STATE(1083),
    [sym_struct_expression] = STATE(1083),
    [sym_if_expression] = STATE(1083),
    [sym_if_let_expression] = STATE(1083),
    [sym_match_expression] = STATE(1083),
    [sym_while_expression] = STATE(1083),
    [sym_while_let_expression] = STATE(1083),
    [sym_loop_expression] = STATE(1083),
    [sym_for_expression] = STATE(1083),
    [sym_closure_expression] = STATE(1083),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1083),
    [sym_continue_expression] = STATE(1083),
    [sym_index_expression] = STATE(1083),
    [sym_await_expression] = STATE(1083),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1083),
    [sym_async_block] = STATE(1083),
    [sym_block] = STATE(1083),
    [sym__literal] = STATE(1083),
    [sym_string_literal] = STATE(1083),
    [sym_boolean_literal] = STATE(1083),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(985),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(985),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(985),
    [sym_float_literal] = ACTIONS(985),
    [sym_block_comment] = ACTIONS(3),
  },
  [174] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1080),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1080),
    [sym_macro_invocation] = STATE(1080),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1080),
    [sym_unary_expression] = STATE(1080),
    [sym_try_expression] = STATE(1080),
    [sym_reference_expression] = STATE(1080),
    [sym_binary_expression] = STATE(1080),
    [sym_assignment_expression] = STATE(1080),
    [sym_compound_assignment_expr] = STATE(1080),
    [sym_type_cast_expression] = STATE(1080),
    [sym_return_expression] = STATE(1080),
    [sym_call_expression] = STATE(1080),
    [sym_array_expression] = STATE(1080),
    [sym_parenthesized_expression] = STATE(1080),
    [sym_tuple_expression] = STATE(1080),
    [sym_unit_expression] = STATE(1080),
    [sym_struct_expression] = STATE(1080),
    [sym_if_expression] = STATE(1080),
    [sym_if_let_expression] = STATE(1080),
    [sym_match_expression] = STATE(1080),
    [sym_while_expression] = STATE(1080),
    [sym_while_let_expression] = STATE(1080),
    [sym_loop_expression] = STATE(1080),
    [sym_for_expression] = STATE(1080),
    [sym_closure_expression] = STATE(1080),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1080),
    [sym_continue_expression] = STATE(1080),
    [sym_index_expression] = STATE(1080),
    [sym_await_expression] = STATE(1080),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1080),
    [sym_async_block] = STATE(1080),
    [sym_block] = STATE(1080),
    [sym__literal] = STATE(1080),
    [sym_string_literal] = STATE(1080),
    [sym_boolean_literal] = STATE(1080),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(987),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(987),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(987),
    [sym_float_literal] = ACTIONS(987),
    [sym_block_comment] = ACTIONS(3),
  },
  [175] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1138),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1138),
    [sym_macro_invocation] = STATE(1138),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1138),
    [sym_unary_expression] = STATE(1138),
    [sym_try_expression] = STATE(1138),
    [sym_reference_expression] = STATE(1138),
    [sym_binary_expression] = STATE(1138),
    [sym_assignment_expression] = STATE(1138),
    [sym_compound_assignment_expr] = STATE(1138),
    [sym_type_cast_expression] = STATE(1138),
    [sym_return_expression] = STATE(1138),
    [sym_call_expression] = STATE(1138),
    [sym_array_expression] = STATE(1138),
    [sym_parenthesized_expression] = STATE(1138),
    [sym_tuple_expression] = STATE(1138),
    [sym_unit_expression] = STATE(1138),
    [sym_struct_expression] = STATE(1138),
    [sym_if_expression] = STATE(1138),
    [sym_if_let_expression] = STATE(1138),
    [sym_match_expression] = STATE(1138),
    [sym_while_expression] = STATE(1138),
    [sym_while_let_expression] = STATE(1138),
    [sym_loop_expression] = STATE(1138),
    [sym_for_expression] = STATE(1138),
    [sym_closure_expression] = STATE(1138),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1138),
    [sym_continue_expression] = STATE(1138),
    [sym_index_expression] = STATE(1138),
    [sym_await_expression] = STATE(1138),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1138),
    [sym_async_block] = STATE(1138),
    [sym_block] = STATE(1138),
    [sym__literal] = STATE(1138),
    [sym_string_literal] = STATE(1138),
    [sym_boolean_literal] = STATE(1138),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(989),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(989),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(989),
    [sym_float_literal] = ACTIONS(989),
    [sym_block_comment] = ACTIONS(3),
  },
  [176] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1154),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1154),
    [sym_macro_invocation] = STATE(1154),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1154),
    [sym_unary_expression] = STATE(1154),
    [sym_try_expression] = STATE(1154),
    [sym_reference_expression] = STATE(1154),
    [sym_binary_expression] = STATE(1154),
    [sym_assignment_expression] = STATE(1154),
    [sym_compound_assignment_expr] = STATE(1154),
    [sym_type_cast_expression] = STATE(1154),
    [sym_return_expression] = STATE(1154),
    [sym_call_expression] = STATE(1154),
    [sym_array_expression] = STATE(1154),
    [sym_parenthesized_expression] = STATE(1154),
    [sym_tuple_expression] = STATE(1154),
    [sym_unit_expression] = STATE(1154),
    [sym_struct_expression] = STATE(1154),
    [sym_if_expression] = STATE(1154),
    [sym_if_let_expression] = STATE(1154),
    [sym_match_expression] = STATE(1154),
    [sym_while_expression] = STATE(1154),
    [sym_while_let_expression] = STATE(1154),
    [sym_loop_expression] = STATE(1154),
    [sym_for_expression] = STATE(1154),
    [sym_closure_expression] = STATE(1154),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1154),
    [sym_continue_expression] = STATE(1154),
    [sym_index_expression] = STATE(1154),
    [sym_await_expression] = STATE(1154),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1154),
    [sym_async_block] = STATE(1154),
    [sym_block] = STATE(1154),
    [sym__literal] = STATE(1154),
    [sym_string_literal] = STATE(1154),
    [sym_boolean_literal] = STATE(1154),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(991),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(991),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(991),
    [sym_float_literal] = ACTIONS(991),
    [sym_block_comment] = ACTIONS(3),
  },
  [177] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1089),
    [sym_generic_type_with_turbofish] = STATE(1818),
    [sym__expression] = STATE(1089),
    [sym_macro_invocation] = STATE(1089),
    [sym_scoped_identifier] = STATE(1095),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1089),
    [sym_unary_expression] = STATE(1089),
    [sym_try_expression] = STATE(1089),
    [sym_reference_expression] = STATE(1089),
    [sym_binary_expression] = STATE(1089),
    [sym_assignment_expression] = STATE(1089),
    [sym_compound_assignment_expr] = STATE(1089),
    [sym_type_cast_expression] = STATE(1089),
    [sym_return_expression] = STATE(1089),
    [sym_call_expression] = STATE(1089),
    [sym_array_expression] = STATE(1089),
    [sym_parenthesized_expression] = STATE(1089),
    [sym_tuple_expression] = STATE(1089),
    [sym_unit_expression] = STATE(1089),
    [sym_struct_expression] = STATE(1089),
    [sym_if_expression] = STATE(1089),
    [sym_if_let_expression] = STATE(1089),
    [sym_match_expression] = STATE(1089),
    [sym_while_expression] = STATE(1089),
    [sym_while_let_expression] = STATE(1089),
    [sym_loop_expression] = STATE(1089),
    [sym_for_expression] = STATE(1089),
    [sym_closure_expression] = STATE(1089),
    [sym_closure_parameters] = STATE(76),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1089),
    [sym_continue_expression] = STATE(1089),
    [sym_index_expression] = STATE(1089),
    [sym_await_expression] = STATE(1089),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1089),
    [sym_async_block] = STATE(1089),
    [sym_block] = STATE(1089),
    [sym__literal] = STATE(1089),
    [sym_string_literal] = STATE(1089),
    [sym_boolean_literal] = STATE(1089),
    [sym_identifier] = ACTIONS(355),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(713),
    [anon_sym_u8] = ACTIONS(357),
    [anon_sym_i8] = ACTIONS(357),
    [anon_sym_u16] = ACTIONS(357),
    [anon_sym_i16] = ACTIONS(357),
    [anon_sym_u32] = ACTIONS(357),
    [anon_sym_i32] = ACTIONS(357),
    [anon_sym_u64] = ACTIONS(357),
    [anon_sym_i64] = ACTIONS(357),
    [anon_sym_u128] = ACTIONS(357),
    [anon_sym_i128] = ACTIONS(357),
    [anon_sym_isize] = ACTIONS(357),
    [anon_sym_usize] = ACTIONS(357),
    [anon_sym_f32] = ACTIONS(357),
    [anon_sym_f64] = ACTIONS(357),
    [anon_sym_bool] = ACTIONS(357),
    [anon_sym_str] = ACTIONS(357),
    [anon_sym_char] = ACTIONS(357),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(359),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(361),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DASH] = ACTIONS(713),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(367),
    [sym_integer_literal] = ACTIONS(993),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(993),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(371),
    [sym_super] = ACTIONS(373),
    [sym_crate] = ACTIONS(373),
    [sym_metavariable] = ACTIONS(375),
    [sym_raw_string_literal] = ACTIONS(993),
    [sym_float_literal] = ACTIONS(993),
    [sym_block_comment] = ACTIONS(3),
  },
  [178] = {
    [sym_attribute_item] = STATE(184),
    [sym_function_modifiers] = STATE(2207),
    [sym_self_parameter] = STATE(2017),
    [sym_variadic_parameter] = STATE(2017),
    [sym_parameter] = STATE(2017),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1752),
    [sym_bracketed_type] = STATE(2318),
    [sym_lifetime] = STATE(1828),
    [sym_array_type] = STATE(1752),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1752),
    [sym_tuple_type] = STATE(1752),
    [sym_unit_type] = STATE(1752),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2319),
    [sym_bounded_type] = STATE(1752),
    [sym_reference_type] = STATE(1752),
    [sym_pointer_type] = STATE(1752),
    [sym_empty_type] = STATE(1752),
    [sym_abstract_type] = STATE(1752),
    [sym_dynamic_type] = STATE(1752),
    [sym_macro_invocation] = STATE(1752),
    [sym_scoped_identifier] = STATE(1472),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(2132),
    [sym_tuple_pattern] = STATE(2132),
    [sym_slice_pattern] = STATE(2132),
    [sym_tuple_struct_pattern] = STATE(2132),
    [sym_struct_pattern] = STATE(2132),
    [sym_remaining_field_pattern] = STATE(2132),
    [sym_mut_pattern] = STATE(2132),
    [sym_range_pattern] = STATE(2132),
    [sym_ref_pattern] = STATE(2132),
    [sym_captured_pattern] = STATE(2132),
    [sym_reference_pattern] = STATE(2132),
    [sym_or_pattern] = STATE(2132),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(795),
    [anon_sym_i8] = ACTIONS(795),
    [anon_sym_u16] = ACTIONS(795),
    [anon_sym_i16] = ACTIONS(795),
    [anon_sym_u32] = ACTIONS(795),
    [anon_sym_i32] = ACTIONS(795),
    [anon_sym_u64] = ACTIONS(795),
    [anon_sym_i64] = ACTIONS(795),
    [anon_sym_u128] = ACTIONS(795),
    [anon_sym_i128] = ACTIONS(795),
    [anon_sym_isize] = ACTIONS(795),
    [anon_sym_usize] = ACTIONS(795),
    [anon_sym_f32] = ACTIONS(795),
    [anon_sym_f64] = ACTIONS(795),
    [anon_sym_bool] = ACTIONS(795),
    [anon_sym_str] = ACTIONS(795),
    [anon_sym_char] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(665),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_union] = ACTIONS(673),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(675),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym__] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(691),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(695),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(805),
    [sym_super] = ACTIONS(807),
    [sym_crate] = ACTIONS(807),
    [sym_metavariable] = ACTIONS(809),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [179] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1150),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1150),
    [sym_macro_invocation] = STATE(1150),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1150),
    [sym_unary_expression] = STATE(1150),
    [sym_try_expression] = STATE(1150),
    [sym_reference_expression] = STATE(1150),
    [sym_binary_expression] = STATE(1150),
    [sym_assignment_expression] = STATE(1150),
    [sym_compound_assignment_expr] = STATE(1150),
    [sym_type_cast_expression] = STATE(1150),
    [sym_return_expression] = STATE(1150),
    [sym_call_expression] = STATE(1150),
    [sym_array_expression] = STATE(1150),
    [sym_parenthesized_expression] = STATE(1150),
    [sym_tuple_expression] = STATE(1150),
    [sym_unit_expression] = STATE(1150),
    [sym_struct_expression] = STATE(1150),
    [sym_if_expression] = STATE(1150),
    [sym_if_let_expression] = STATE(1150),
    [sym_match_expression] = STATE(1150),
    [sym_while_expression] = STATE(1150),
    [sym_while_let_expression] = STATE(1150),
    [sym_loop_expression] = STATE(1150),
    [sym_for_expression] = STATE(1150),
    [sym_closure_expression] = STATE(1150),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1150),
    [sym_continue_expression] = STATE(1150),
    [sym_index_expression] = STATE(1150),
    [sym_await_expression] = STATE(1150),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1150),
    [sym_async_block] = STATE(1150),
    [sym_block] = STATE(1150),
    [sym__literal] = STATE(1150),
    [sym_string_literal] = STATE(1150),
    [sym_boolean_literal] = STATE(1150),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(997),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(997),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(997),
    [sym_float_literal] = ACTIONS(997),
    [sym_block_comment] = ACTIONS(3),
  },
  [180] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(755),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(755),
    [sym_macro_invocation] = STATE(755),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(755),
    [sym_unary_expression] = STATE(755),
    [sym_try_expression] = STATE(755),
    [sym_reference_expression] = STATE(755),
    [sym_binary_expression] = STATE(755),
    [sym_assignment_expression] = STATE(755),
    [sym_compound_assignment_expr] = STATE(755),
    [sym_type_cast_expression] = STATE(755),
    [sym_return_expression] = STATE(755),
    [sym_call_expression] = STATE(755),
    [sym_array_expression] = STATE(755),
    [sym_parenthesized_expression] = STATE(755),
    [sym_tuple_expression] = STATE(755),
    [sym_unit_expression] = STATE(755),
    [sym_struct_expression] = STATE(755),
    [sym_if_expression] = STATE(755),
    [sym_if_let_expression] = STATE(755),
    [sym_match_expression] = STATE(755),
    [sym_while_expression] = STATE(755),
    [sym_while_let_expression] = STATE(755),
    [sym_loop_expression] = STATE(755),
    [sym_for_expression] = STATE(755),
    [sym_closure_expression] = STATE(755),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(755),
    [sym_continue_expression] = STATE(755),
    [sym_index_expression] = STATE(755),
    [sym_await_expression] = STATE(755),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(755),
    [sym_async_block] = STATE(755),
    [sym_block] = STATE(755),
    [sym__literal] = STATE(755),
    [sym_string_literal] = STATE(755),
    [sym_boolean_literal] = STATE(755),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(863),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(863),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(863),
    [sym_float_literal] = ACTIONS(863),
    [sym_block_comment] = ACTIONS(3),
  },
  [181] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1182),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1182),
    [sym_macro_invocation] = STATE(1182),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1182),
    [sym_unary_expression] = STATE(1182),
    [sym_try_expression] = STATE(1182),
    [sym_reference_expression] = STATE(1182),
    [sym_binary_expression] = STATE(1182),
    [sym_assignment_expression] = STATE(1182),
    [sym_compound_assignment_expr] = STATE(1182),
    [sym_type_cast_expression] = STATE(1182),
    [sym_return_expression] = STATE(1182),
    [sym_call_expression] = STATE(1182),
    [sym_array_expression] = STATE(1182),
    [sym_parenthesized_expression] = STATE(1182),
    [sym_tuple_expression] = STATE(1182),
    [sym_unit_expression] = STATE(1182),
    [sym_struct_expression] = STATE(1182),
    [sym_if_expression] = STATE(1182),
    [sym_if_let_expression] = STATE(1182),
    [sym_match_expression] = STATE(1182),
    [sym_while_expression] = STATE(1182),
    [sym_while_let_expression] = STATE(1182),
    [sym_loop_expression] = STATE(1182),
    [sym_for_expression] = STATE(1182),
    [sym_closure_expression] = STATE(1182),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1182),
    [sym_continue_expression] = STATE(1182),
    [sym_index_expression] = STATE(1182),
    [sym_await_expression] = STATE(1182),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1182),
    [sym_async_block] = STATE(1182),
    [sym_block] = STATE(1182),
    [sym__literal] = STATE(1182),
    [sym_string_literal] = STATE(1182),
    [sym_boolean_literal] = STATE(1182),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(999),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(999),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(999),
    [sym_float_literal] = ACTIONS(999),
    [sym_block_comment] = ACTIONS(3),
  },
  [182] = {
    [sym_bracketed_type] = STATE(2291),
    [sym_generic_function] = STATE(1030),
    [sym_generic_type_with_turbofish] = STATE(1775),
    [sym__expression] = STATE(1030),
    [sym_macro_invocation] = STATE(1030),
    [sym_scoped_identifier] = STATE(939),
    [sym_scoped_type_identifier_in_expression_position] = STATE(2079),
    [sym_range_expression] = STATE(1030),
    [sym_unary_expression] = STATE(1030),
    [sym_try_expression] = STATE(1030),
    [sym_reference_expression] = STATE(1030),
    [sym_binary_expression] = STATE(1030),
    [sym_assignment_expression] = STATE(1030),
    [sym_compound_assignment_expr] = STATE(1030),
    [sym_type_cast_expression] = STATE(1030),
    [sym_return_expression] = STATE(1030),
    [sym_call_expression] = STATE(1030),
    [sym_array_expression] = STATE(1030),
    [sym_parenthesized_expression] = STATE(1030),
    [sym_tuple_expression] = STATE(1030),
    [sym_unit_expression] = STATE(1030),
    [sym_struct_expression] = STATE(1030),
    [sym_if_expression] = STATE(1030),
    [sym_if_let_expression] = STATE(1030),
    [sym_match_expression] = STATE(1030),
    [sym_while_expression] = STATE(1030),
    [sym_while_let_expression] = STATE(1030),
    [sym_loop_expression] = STATE(1030),
    [sym_for_expression] = STATE(1030),
    [sym_closure_expression] = STATE(1030),
    [sym_closure_parameters] = STATE(72),
    [sym_loop_label] = STATE(2330),
    [sym_break_expression] = STATE(1030),
    [sym_continue_expression] = STATE(1030),
    [sym_index_expression] = STATE(1030),
    [sym_await_expression] = STATE(1030),
    [sym_field_expression] = STATE(761),
    [sym_unsafe_block] = STATE(1030),
    [sym_async_block] = STATE(1030),
    [sym_block] = STATE(1030),
    [sym__literal] = STATE(1030),
    [sym_string_literal] = STATE(1030),
    [sym_boolean_literal] = STATE(1030),
    [sym_identifier] = ACTIONS(291),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_LBRACE] = ACTIONS(295),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_STAR] = ACTIONS(19),
    [anon_sym_u8] = ACTIONS(21),
    [anon_sym_i8] = ACTIONS(21),
    [anon_sym_u16] = ACTIONS(21),
    [anon_sym_i16] = ACTIONS(21),
    [anon_sym_u32] = ACTIONS(21),
    [anon_sym_i32] = ACTIONS(21),
    [anon_sym_u64] = ACTIONS(21),
    [anon_sym_i64] = ACTIONS(21),
    [anon_sym_u128] = ACTIONS(21),
    [anon_sym_i128] = ACTIONS(21),
    [anon_sym_isize] = ACTIONS(21),
    [anon_sym_usize] = ACTIONS(21),
    [anon_sym_f32] = ACTIONS(21),
    [anon_sym_f64] = ACTIONS(21),
    [anon_sym_bool] = ACTIONS(21),
    [anon_sym_str] = ACTIONS(21),
    [anon_sym_char] = ACTIONS(21),
    [anon_sym_SQUOTE] = ACTIONS(23),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(31),
    [anon_sym_default] = ACTIONS(303),
    [anon_sym_for] = ACTIONS(305),
    [anon_sym_if] = ACTIONS(307),
    [anon_sym_loop] = ACTIONS(309),
    [anon_sym_match] = ACTIONS(311),
    [anon_sym_return] = ACTIONS(55),
    [anon_sym_union] = ACTIONS(303),
    [anon_sym_unsafe] = ACTIONS(313),
    [anon_sym_while] = ACTIONS(315),
    [anon_sym_BANG] = ACTIONS(19),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(79),
    [anon_sym_AMP] = ACTIONS(81),
    [anon_sym_DOT_DOT] = ACTIONS(83),
    [anon_sym_DASH] = ACTIONS(19),
    [anon_sym_PIPE] = ACTIONS(85),
    [anon_sym_move] = ACTIONS(87),
    [sym_integer_literal] = ACTIONS(1001),
    [aux_sym_string_literal_token1] = ACTIONS(91),
    [sym_char_literal] = ACTIONS(1001),
    [anon_sym_true] = ACTIONS(93),
    [anon_sym_false] = ACTIONS(93),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(95),
    [sym_super] = ACTIONS(97),
    [sym_crate] = ACTIONS(97),
    [sym_metavariable] = ACTIONS(101),
    [sym_raw_string_literal] = ACTIONS(1001),
    [sym_float_literal] = ACTIONS(1001),
    [sym_block_comment] = ACTIONS(3),
  },
  [183] = {
    [sym_attribute_item] = STATE(184),
    [sym_function_modifiers] = STATE(2207),
    [sym_self_parameter] = STATE(2017),
    [sym_variadic_parameter] = STATE(2017),
    [sym_parameter] = STATE(2017),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1752),
    [sym_bracketed_type] = STATE(2318),
    [sym_lifetime] = STATE(1828),
    [sym_array_type] = STATE(1752),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1752),
    [sym_tuple_type] = STATE(1752),
    [sym_unit_type] = STATE(1752),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2319),
    [sym_bounded_type] = STATE(1752),
    [sym_reference_type] = STATE(1752),
    [sym_pointer_type] = STATE(1752),
    [sym_empty_type] = STATE(1752),
    [sym_abstract_type] = STATE(1752),
    [sym_dynamic_type] = STATE(1752),
    [sym_macro_invocation] = STATE(1752),
    [sym_scoped_identifier] = STATE(1472),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(2132),
    [sym_tuple_pattern] = STATE(2132),
    [sym_slice_pattern] = STATE(2132),
    [sym_tuple_struct_pattern] = STATE(2132),
    [sym_struct_pattern] = STATE(2132),
    [sym_remaining_field_pattern] = STATE(2132),
    [sym_mut_pattern] = STATE(2132),
    [sym_range_pattern] = STATE(2132),
    [sym_ref_pattern] = STATE(2132),
    [sym_captured_pattern] = STATE(2132),
    [sym_reference_pattern] = STATE(2132),
    [sym_or_pattern] = STATE(2132),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(795),
    [anon_sym_i8] = ACTIONS(795),
    [anon_sym_u16] = ACTIONS(795),
    [anon_sym_i16] = ACTIONS(795),
    [anon_sym_u32] = ACTIONS(795),
    [anon_sym_i32] = ACTIONS(795),
    [anon_sym_u64] = ACTIONS(795),
    [anon_sym_i64] = ACTIONS(795),
    [anon_sym_u128] = ACTIONS(795),
    [anon_sym_i128] = ACTIONS(795),
    [anon_sym_isize] = ACTIONS(795),
    [anon_sym_usize] = ACTIONS(795),
    [anon_sym_f32] = ACTIONS(795),
    [anon_sym_f64] = ACTIONS(795),
    [anon_sym_bool] = ACTIONS(795),
    [anon_sym_str] = ACTIONS(795),
    [anon_sym_char] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(665),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_union] = ACTIONS(673),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(675),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym__] = ACTIONS(821),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(691),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(695),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(805),
    [sym_super] = ACTIONS(807),
    [sym_crate] = ACTIONS(807),
    [sym_metavariable] = ACTIONS(809),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [184] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_self_parameter] = STATE(2062),
    [sym_variadic_parameter] = STATE(2062),
    [sym_parameter] = STATE(2062),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1902),
    [sym_bracketed_type] = STATE(2318),
    [sym_lifetime] = STATE(1828),
    [sym_array_type] = STATE(1902),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1902),
    [sym_tuple_type] = STATE(1902),
    [sym_unit_type] = STATE(1902),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2319),
    [sym_bounded_type] = STATE(1902),
    [sym_reference_type] = STATE(1902),
    [sym_pointer_type] = STATE(1902),
    [sym_empty_type] = STATE(1902),
    [sym_abstract_type] = STATE(1902),
    [sym_dynamic_type] = STATE(1902),
    [sym_macro_invocation] = STATE(1902),
    [sym_scoped_identifier] = STATE(1472),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(2132),
    [sym_tuple_pattern] = STATE(2132),
    [sym_slice_pattern] = STATE(2132),
    [sym_tuple_struct_pattern] = STATE(2132),
    [sym_struct_pattern] = STATE(2132),
    [sym_remaining_field_pattern] = STATE(2132),
    [sym_mut_pattern] = STATE(2132),
    [sym_range_pattern] = STATE(2132),
    [sym_ref_pattern] = STATE(2132),
    [sym_captured_pattern] = STATE(2132),
    [sym_reference_pattern] = STATE(2132),
    [sym_or_pattern] = STATE(2132),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(795),
    [anon_sym_i8] = ACTIONS(795),
    [anon_sym_u16] = ACTIONS(795),
    [anon_sym_i16] = ACTIONS(795),
    [anon_sym_u32] = ACTIONS(795),
    [anon_sym_i32] = ACTIONS(795),
    [anon_sym_u64] = ACTIONS(795),
    [anon_sym_i64] = ACTIONS(795),
    [anon_sym_u128] = ACTIONS(795),
    [anon_sym_i128] = ACTIONS(795),
    [anon_sym_isize] = ACTIONS(795),
    [anon_sym_usize] = ACTIONS(795),
    [anon_sym_f32] = ACTIONS(795),
    [anon_sym_f64] = ACTIONS(795),
    [anon_sym_bool] = ACTIONS(795),
    [anon_sym_str] = ACTIONS(795),
    [anon_sym_char] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(665),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_union] = ACTIONS(673),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym__] = ACTIONS(1003),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(691),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(695),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(805),
    [sym_super] = ACTIONS(807),
    [sym_crate] = ACTIONS(807),
    [sym_metavariable] = ACTIONS(809),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [185] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_self_parameter] = STATE(1812),
    [sym_variadic_parameter] = STATE(1812),
    [sym_parameter] = STATE(1812),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1694),
    [sym_bracketed_type] = STATE(2318),
    [sym_lifetime] = STATE(1828),
    [sym_array_type] = STATE(1694),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1694),
    [sym_tuple_type] = STATE(1694),
    [sym_unit_type] = STATE(1694),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2319),
    [sym_bounded_type] = STATE(1694),
    [sym_reference_type] = STATE(1694),
    [sym_pointer_type] = STATE(1694),
    [sym_empty_type] = STATE(1694),
    [sym_abstract_type] = STATE(1694),
    [sym_dynamic_type] = STATE(1694),
    [sym_macro_invocation] = STATE(1694),
    [sym_scoped_identifier] = STATE(1472),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(2132),
    [sym_tuple_pattern] = STATE(2132),
    [sym_slice_pattern] = STATE(2132),
    [sym_tuple_struct_pattern] = STATE(2132),
    [sym_struct_pattern] = STATE(2132),
    [sym_remaining_field_pattern] = STATE(2132),
    [sym_mut_pattern] = STATE(2132),
    [sym_range_pattern] = STATE(2132),
    [sym_ref_pattern] = STATE(2132),
    [sym_captured_pattern] = STATE(2132),
    [sym_reference_pattern] = STATE(2132),
    [sym_or_pattern] = STATE(2132),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(795),
    [anon_sym_i8] = ACTIONS(795),
    [anon_sym_u16] = ACTIONS(795),
    [anon_sym_i16] = ACTIONS(795),
    [anon_sym_u32] = ACTIONS(795),
    [anon_sym_i32] = ACTIONS(795),
    [anon_sym_u64] = ACTIONS(795),
    [anon_sym_i64] = ACTIONS(795),
    [anon_sym_u128] = ACTIONS(795),
    [anon_sym_i128] = ACTIONS(795),
    [anon_sym_isize] = ACTIONS(795),
    [anon_sym_usize] = ACTIONS(795),
    [anon_sym_f32] = ACTIONS(795),
    [anon_sym_f64] = ACTIONS(795),
    [anon_sym_bool] = ACTIONS(795),
    [anon_sym_str] = ACTIONS(795),
    [anon_sym_char] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(665),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_union] = ACTIONS(673),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym__] = ACTIONS(1005),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(691),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(695),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(805),
    [sym_super] = ACTIONS(807),
    [sym_crate] = ACTIONS(807),
    [sym_metavariable] = ACTIONS(809),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [186] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_self_parameter] = STATE(1948),
    [sym_variadic_parameter] = STATE(1948),
    [sym_parameter] = STATE(1948),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1637),
    [sym_bracketed_type] = STATE(2318),
    [sym_lifetime] = STATE(1828),
    [sym_array_type] = STATE(1637),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1637),
    [sym_tuple_type] = STATE(1637),
    [sym_unit_type] = STATE(1637),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2319),
    [sym_bounded_type] = STATE(1637),
    [sym_reference_type] = STATE(1637),
    [sym_pointer_type] = STATE(1637),
    [sym_empty_type] = STATE(1637),
    [sym_abstract_type] = STATE(1637),
    [sym_dynamic_type] = STATE(1637),
    [sym_macro_invocation] = STATE(1637),
    [sym_scoped_identifier] = STATE(1472),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(2132),
    [sym_tuple_pattern] = STATE(2132),
    [sym_slice_pattern] = STATE(2132),
    [sym_tuple_struct_pattern] = STATE(2132),
    [sym_struct_pattern] = STATE(2132),
    [sym_remaining_field_pattern] = STATE(2132),
    [sym_mut_pattern] = STATE(2132),
    [sym_range_pattern] = STATE(2132),
    [sym_ref_pattern] = STATE(2132),
    [sym_captured_pattern] = STATE(2132),
    [sym_reference_pattern] = STATE(2132),
    [sym_or_pattern] = STATE(2132),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(795),
    [anon_sym_i8] = ACTIONS(795),
    [anon_sym_u16] = ACTIONS(795),
    [anon_sym_i16] = ACTIONS(795),
    [anon_sym_u32] = ACTIONS(795),
    [anon_sym_i32] = ACTIONS(795),
    [anon_sym_u64] = ACTIONS(795),
    [anon_sym_i64] = ACTIONS(795),
    [anon_sym_u128] = ACTIONS(795),
    [anon_sym_i128] = ACTIONS(795),
    [anon_sym_isize] = ACTIONS(795),
    [anon_sym_usize] = ACTIONS(795),
    [anon_sym_f32] = ACTIONS(795),
    [anon_sym_f64] = ACTIONS(795),
    [anon_sym_bool] = ACTIONS(795),
    [anon_sym_str] = ACTIONS(795),
    [anon_sym_char] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(665),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_union] = ACTIONS(673),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym__] = ACTIONS(1007),
    [anon_sym_AMP] = ACTIONS(803),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(691),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(695),
    [anon_sym_DOT_DOT] = ACTIONS(697),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(805),
    [sym_super] = ACTIONS(807),
    [sym_crate] = ACTIONS(807),
    [sym_metavariable] = ACTIONS(809),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [187] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1716),
    [sym_bracketed_type] = STATE(2321),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(1716),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1716),
    [sym_tuple_type] = STATE(1716),
    [sym_unit_type] = STATE(1716),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2322),
    [sym_bounded_type] = STATE(1716),
    [sym_reference_type] = STATE(1716),
    [sym_pointer_type] = STATE(1716),
    [sym_empty_type] = STATE(1716),
    [sym_abstract_type] = STATE(1716),
    [sym_dynamic_type] = STATE(1716),
    [sym_macro_invocation] = STATE(1716),
    [sym_scoped_identifier] = STATE(1420),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(1706),
    [sym_tuple_pattern] = STATE(1706),
    [sym_slice_pattern] = STATE(1706),
    [sym_tuple_struct_pattern] = STATE(1706),
    [sym_struct_pattern] = STATE(1706),
    [sym_remaining_field_pattern] = STATE(1706),
    [sym_mut_pattern] = STATE(1706),
    [sym_range_pattern] = STATE(1706),
    [sym_ref_pattern] = STATE(1706),
    [sym_captured_pattern] = STATE(1706),
    [sym_reference_pattern] = STATE(1706),
    [sym_or_pattern] = STATE(1706),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_RPAREN] = ACTIONS(1009),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(659),
    [anon_sym_i8] = ACTIONS(659),
    [anon_sym_u16] = ACTIONS(659),
    [anon_sym_i16] = ACTIONS(659),
    [anon_sym_u32] = ACTIONS(659),
    [anon_sym_i32] = ACTIONS(659),
    [anon_sym_u64] = ACTIONS(659),
    [anon_sym_i64] = ACTIONS(659),
    [anon_sym_u128] = ACTIONS(659),
    [anon_sym_i128] = ACTIONS(659),
    [anon_sym_isize] = ACTIONS(659),
    [anon_sym_usize] = ACTIONS(659),
    [anon_sym_f32] = ACTIONS(659),
    [anon_sym_f64] = ACTIONS(659),
    [anon_sym_bool] = ACTIONS(659),
    [anon_sym_str] = ACTIONS(659),
    [anon_sym_char] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(1011),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(685),
    [anon_sym__] = ACTIONS(1013),
    [anon_sym_AMP] = ACTIONS(1015),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(1017),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(709),
    [sym_super] = ACTIONS(709),
    [sym_crate] = ACTIONS(709),
    [sym_metavariable] = ACTIONS(711),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [188] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1716),
    [sym_bracketed_type] = STATE(2321),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(1716),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1716),
    [sym_tuple_type] = STATE(1716),
    [sym_unit_type] = STATE(1716),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2322),
    [sym_bounded_type] = STATE(1716),
    [sym_reference_type] = STATE(1716),
    [sym_pointer_type] = STATE(1716),
    [sym_empty_type] = STATE(1716),
    [sym_abstract_type] = STATE(1716),
    [sym_dynamic_type] = STATE(1716),
    [sym_macro_invocation] = STATE(1716),
    [sym_scoped_identifier] = STATE(1420),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(1706),
    [sym_tuple_pattern] = STATE(1706),
    [sym_slice_pattern] = STATE(1706),
    [sym_tuple_struct_pattern] = STATE(1706),
    [sym_struct_pattern] = STATE(1706),
    [sym_remaining_field_pattern] = STATE(1706),
    [sym_mut_pattern] = STATE(1706),
    [sym_range_pattern] = STATE(1706),
    [sym_ref_pattern] = STATE(1706),
    [sym_captured_pattern] = STATE(1706),
    [sym_reference_pattern] = STATE(1706),
    [sym_or_pattern] = STATE(1706),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_RPAREN] = ACTIONS(1021),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(659),
    [anon_sym_i8] = ACTIONS(659),
    [anon_sym_u16] = ACTIONS(659),
    [anon_sym_i16] = ACTIONS(659),
    [anon_sym_u32] = ACTIONS(659),
    [anon_sym_i32] = ACTIONS(659),
    [anon_sym_u64] = ACTIONS(659),
    [anon_sym_i64] = ACTIONS(659),
    [anon_sym_u128] = ACTIONS(659),
    [anon_sym_i128] = ACTIONS(659),
    [anon_sym_isize] = ACTIONS(659),
    [anon_sym_usize] = ACTIONS(659),
    [anon_sym_f32] = ACTIONS(659),
    [anon_sym_f64] = ACTIONS(659),
    [anon_sym_bool] = ACTIONS(659),
    [anon_sym_str] = ACTIONS(659),
    [anon_sym_char] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(1011),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(685),
    [anon_sym__] = ACTIONS(1013),
    [anon_sym_AMP] = ACTIONS(1015),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(1017),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(709),
    [sym_super] = ACTIONS(709),
    [sym_crate] = ACTIONS(709),
    [sym_metavariable] = ACTIONS(711),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [189] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1750),
    [sym_bracketed_type] = STATE(2324),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(1750),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1750),
    [sym_tuple_type] = STATE(1750),
    [sym_unit_type] = STATE(1750),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2325),
    [sym_bounded_type] = STATE(1750),
    [sym_reference_type] = STATE(1750),
    [sym_pointer_type] = STATE(1750),
    [sym_empty_type] = STATE(1750),
    [sym_abstract_type] = STATE(1750),
    [sym_dynamic_type] = STATE(1750),
    [sym_macro_invocation] = STATE(1750),
    [sym_scoped_identifier] = STATE(1458),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(1707),
    [sym_tuple_pattern] = STATE(1707),
    [sym_slice_pattern] = STATE(1707),
    [sym_tuple_struct_pattern] = STATE(1707),
    [sym_struct_pattern] = STATE(1707),
    [sym_remaining_field_pattern] = STATE(1707),
    [sym_mut_pattern] = STATE(1707),
    [sym_range_pattern] = STATE(1707),
    [sym_ref_pattern] = STATE(1707),
    [sym_captured_pattern] = STATE(1707),
    [sym_reference_pattern] = STATE(1707),
    [sym_or_pattern] = STATE(1707),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(1023),
    [anon_sym_LPAREN] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_RBRACK] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1029),
    [anon_sym_i8] = ACTIONS(1029),
    [anon_sym_u16] = ACTIONS(1029),
    [anon_sym_i16] = ACTIONS(1029),
    [anon_sym_u32] = ACTIONS(1029),
    [anon_sym_i32] = ACTIONS(1029),
    [anon_sym_u64] = ACTIONS(1029),
    [anon_sym_i64] = ACTIONS(1029),
    [anon_sym_u128] = ACTIONS(1029),
    [anon_sym_i128] = ACTIONS(1029),
    [anon_sym_isize] = ACTIONS(1029),
    [anon_sym_usize] = ACTIONS(1029),
    [anon_sym_f32] = ACTIONS(1029),
    [anon_sym_f64] = ACTIONS(1029),
    [anon_sym_bool] = ACTIONS(1029),
    [anon_sym_str] = ACTIONS(1029),
    [anon_sym_char] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(1031),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1033),
    [anon_sym__] = ACTIONS(1035),
    [anon_sym_AMP] = ACTIONS(1037),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(1017),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1039),
    [sym_super] = ACTIONS(1039),
    [sym_crate] = ACTIONS(1039),
    [sym_metavariable] = ACTIONS(1041),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [190] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1716),
    [sym_bracketed_type] = STATE(2321),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(1716),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1716),
    [sym_tuple_type] = STATE(1716),
    [sym_unit_type] = STATE(1716),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2322),
    [sym_bounded_type] = STATE(1716),
    [sym_reference_type] = STATE(1716),
    [sym_pointer_type] = STATE(1716),
    [sym_empty_type] = STATE(1716),
    [sym_abstract_type] = STATE(1716),
    [sym_dynamic_type] = STATE(1716),
    [sym_macro_invocation] = STATE(1716),
    [sym_scoped_identifier] = STATE(1420),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(1706),
    [sym_tuple_pattern] = STATE(1706),
    [sym_slice_pattern] = STATE(1706),
    [sym_tuple_struct_pattern] = STATE(1706),
    [sym_struct_pattern] = STATE(1706),
    [sym_remaining_field_pattern] = STATE(1706),
    [sym_mut_pattern] = STATE(1706),
    [sym_range_pattern] = STATE(1706),
    [sym_ref_pattern] = STATE(1706),
    [sym_captured_pattern] = STATE(1706),
    [sym_reference_pattern] = STATE(1706),
    [sym_or_pattern] = STATE(1706),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_RPAREN] = ACTIONS(1043),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(659),
    [anon_sym_i8] = ACTIONS(659),
    [anon_sym_u16] = ACTIONS(659),
    [anon_sym_i16] = ACTIONS(659),
    [anon_sym_u32] = ACTIONS(659),
    [anon_sym_i32] = ACTIONS(659),
    [anon_sym_u64] = ACTIONS(659),
    [anon_sym_i64] = ACTIONS(659),
    [anon_sym_u128] = ACTIONS(659),
    [anon_sym_i128] = ACTIONS(659),
    [anon_sym_isize] = ACTIONS(659),
    [anon_sym_usize] = ACTIONS(659),
    [anon_sym_f32] = ACTIONS(659),
    [anon_sym_f64] = ACTIONS(659),
    [anon_sym_bool] = ACTIONS(659),
    [anon_sym_str] = ACTIONS(659),
    [anon_sym_char] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(1011),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(685),
    [anon_sym__] = ACTIONS(1013),
    [anon_sym_AMP] = ACTIONS(1015),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(1017),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(709),
    [sym_super] = ACTIONS(709),
    [sym_crate] = ACTIONS(709),
    [sym_metavariable] = ACTIONS(711),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [191] = {
    [sym_identifier] = ACTIONS(1045),
    [anon_sym_SEMI] = ACTIONS(1047),
    [anon_sym_LPAREN] = ACTIONS(1047),
    [anon_sym_RPAREN] = ACTIONS(1047),
    [anon_sym_LBRACE] = ACTIONS(1047),
    [anon_sym_RBRACE] = ACTIONS(1047),
    [anon_sym_EQ_GT] = ACTIONS(1047),
    [anon_sym_LBRACK] = ACTIONS(1047),
    [anon_sym_RBRACK] = ACTIONS(1047),
    [anon_sym_COLON] = ACTIONS(1045),
    [anon_sym_PLUS] = ACTIONS(1045),
    [anon_sym_STAR] = ACTIONS(1045),
    [anon_sym_QMARK] = ACTIONS(1047),
    [anon_sym_u8] = ACTIONS(1045),
    [anon_sym_i8] = ACTIONS(1045),
    [anon_sym_u16] = ACTIONS(1045),
    [anon_sym_i16] = ACTIONS(1045),
    [anon_sym_u32] = ACTIONS(1045),
    [anon_sym_i32] = ACTIONS(1045),
    [anon_sym_u64] = ACTIONS(1045),
    [anon_sym_i64] = ACTIONS(1045),
    [anon_sym_u128] = ACTIONS(1045),
    [anon_sym_i128] = ACTIONS(1045),
    [anon_sym_isize] = ACTIONS(1045),
    [anon_sym_usize] = ACTIONS(1045),
    [anon_sym_f32] = ACTIONS(1045),
    [anon_sym_f64] = ACTIONS(1045),
    [anon_sym_bool] = ACTIONS(1045),
    [anon_sym_str] = ACTIONS(1045),
    [anon_sym_char] = ACTIONS(1045),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_as] = ACTIONS(1045),
    [anon_sym_async] = ACTIONS(1045),
    [anon_sym_break] = ACTIONS(1045),
    [anon_sym_continue] = ACTIONS(1045),
    [anon_sym_default] = ACTIONS(1045),
    [anon_sym_for] = ACTIONS(1045),
    [anon_sym_if] = ACTIONS(1045),
    [anon_sym_loop] = ACTIONS(1045),
    [anon_sym_match] = ACTIONS(1045),
    [anon_sym_return] = ACTIONS(1045),
    [anon_sym_union] = ACTIONS(1045),
    [anon_sym_unsafe] = ACTIONS(1045),
    [anon_sym_while] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1045),
    [anon_sym_EQ] = ACTIONS(1045),
    [anon_sym_COMMA] = ACTIONS(1047),
    [anon_sym_LT] = ACTIONS(1045),
    [anon_sym_GT] = ACTIONS(1045),
    [anon_sym_COLON_COLON] = ACTIONS(1047),
    [anon_sym_AMP] = ACTIONS(1045),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1047),
    [anon_sym_DOT_DOT] = ACTIONS(1045),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(1047),
    [anon_sym_DASH] = ACTIONS(1045),
    [anon_sym_AMP_AMP] = ACTIONS(1047),
    [anon_sym_PIPE_PIPE] = ACTIONS(1047),
    [anon_sym_PIPE] = ACTIONS(1045),
    [anon_sym_CARET] = ACTIONS(1045),
    [anon_sym_EQ_EQ] = ACTIONS(1047),
    [anon_sym_BANG_EQ] = ACTIONS(1047),
    [anon_sym_LT_EQ] = ACTIONS(1047),
    [anon_sym_GT_EQ] = ACTIONS(1047),
    [anon_sym_LT_LT] = ACTIONS(1045),
    [anon_sym_GT_GT] = ACTIONS(1045),
    [anon_sym_SLASH] = ACTIONS(1045),
    [anon_sym_PERCENT] = ACTIONS(1045),
    [anon_sym_PLUS_EQ] = ACTIONS(1047),
    [anon_sym_DASH_EQ] = ACTIONS(1047),
    [anon_sym_STAR_EQ] = ACTIONS(1047),
    [anon_sym_SLASH_EQ] = ACTIONS(1047),
    [anon_sym_PERCENT_EQ] = ACTIONS(1047),
    [anon_sym_AMP_EQ] = ACTIONS(1047),
    [anon_sym_PIPE_EQ] = ACTIONS(1047),
    [anon_sym_CARET_EQ] = ACTIONS(1047),
    [anon_sym_LT_LT_EQ] = ACTIONS(1047),
    [anon_sym_GT_GT_EQ] = ACTIONS(1047),
    [anon_sym_move] = ACTIONS(1045),
    [anon_sym_DOT] = ACTIONS(1045),
    [sym_integer_literal] = ACTIONS(1047),
    [aux_sym_string_literal_token1] = ACTIONS(1047),
    [sym_char_literal] = ACTIONS(1047),
    [anon_sym_true] = ACTIONS(1045),
    [anon_sym_false] = ACTIONS(1045),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1045),
    [sym_super] = ACTIONS(1045),
    [sym_crate] = ACTIONS(1045),
    [sym_metavariable] = ACTIONS(1047),
    [sym_raw_string_literal] = ACTIONS(1047),
    [sym_float_literal] = ACTIONS(1047),
    [sym_block_comment] = ACTIONS(3),
  },
  [192] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1304),
    [sym_bracketed_type] = STATE(2324),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(1304),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1304),
    [sym_tuple_type] = STATE(1304),
    [sym_unit_type] = STATE(1304),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2325),
    [sym_bounded_type] = STATE(1304),
    [sym_reference_type] = STATE(1304),
    [sym_pointer_type] = STATE(1304),
    [sym_empty_type] = STATE(1304),
    [sym_abstract_type] = STATE(1304),
    [sym_dynamic_type] = STATE(1304),
    [sym_macro_invocation] = STATE(1304),
    [sym_scoped_identifier] = STATE(1458),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(1342),
    [sym_tuple_pattern] = STATE(1342),
    [sym_slice_pattern] = STATE(1342),
    [sym_tuple_struct_pattern] = STATE(1342),
    [sym_struct_pattern] = STATE(1342),
    [sym_remaining_field_pattern] = STATE(1342),
    [sym_mut_pattern] = STATE(1342),
    [sym_range_pattern] = STATE(1342),
    [sym_ref_pattern] = STATE(1342),
    [sym_captured_pattern] = STATE(1342),
    [sym_reference_pattern] = STATE(1342),
    [sym_or_pattern] = STATE(1342),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(1023),
    [anon_sym_LPAREN] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1029),
    [anon_sym_i8] = ACTIONS(1029),
    [anon_sym_u16] = ACTIONS(1029),
    [anon_sym_i16] = ACTIONS(1029),
    [anon_sym_u32] = ACTIONS(1029),
    [anon_sym_i32] = ACTIONS(1029),
    [anon_sym_u64] = ACTIONS(1029),
    [anon_sym_i64] = ACTIONS(1029),
    [anon_sym_u128] = ACTIONS(1029),
    [anon_sym_i128] = ACTIONS(1029),
    [anon_sym_isize] = ACTIONS(1029),
    [anon_sym_usize] = ACTIONS(1029),
    [anon_sym_f32] = ACTIONS(1029),
    [anon_sym_f64] = ACTIONS(1029),
    [anon_sym_bool] = ACTIONS(1029),
    [anon_sym_str] = ACTIONS(1029),
    [anon_sym_char] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1033),
    [anon_sym__] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1037),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(1017),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1039),
    [sym_super] = ACTIONS(1039),
    [sym_crate] = ACTIONS(1039),
    [sym_metavariable] = ACTIONS(1041),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [193] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1304),
    [sym_bracketed_type] = STATE(2321),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(1304),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1304),
    [sym_tuple_type] = STATE(1304),
    [sym_unit_type] = STATE(1304),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2322),
    [sym_bounded_type] = STATE(1304),
    [sym_reference_type] = STATE(1304),
    [sym_pointer_type] = STATE(1304),
    [sym_empty_type] = STATE(1304),
    [sym_abstract_type] = STATE(1304),
    [sym_dynamic_type] = STATE(1304),
    [sym_macro_invocation] = STATE(1304),
    [sym_scoped_identifier] = STATE(1420),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(1342),
    [sym_tuple_pattern] = STATE(1342),
    [sym_slice_pattern] = STATE(1342),
    [sym_tuple_struct_pattern] = STATE(1342),
    [sym_struct_pattern] = STATE(1342),
    [sym_remaining_field_pattern] = STATE(1342),
    [sym_mut_pattern] = STATE(1342),
    [sym_range_pattern] = STATE(1342),
    [sym_ref_pattern] = STATE(1342),
    [sym_captured_pattern] = STATE(1342),
    [sym_reference_pattern] = STATE(1342),
    [sym_or_pattern] = STATE(1342),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(659),
    [anon_sym_i8] = ACTIONS(659),
    [anon_sym_u16] = ACTIONS(659),
    [anon_sym_i16] = ACTIONS(659),
    [anon_sym_u32] = ACTIONS(659),
    [anon_sym_i32] = ACTIONS(659),
    [anon_sym_u64] = ACTIONS(659),
    [anon_sym_i64] = ACTIONS(659),
    [anon_sym_u128] = ACTIONS(659),
    [anon_sym_i128] = ACTIONS(659),
    [anon_sym_isize] = ACTIONS(659),
    [anon_sym_usize] = ACTIONS(659),
    [anon_sym_f32] = ACTIONS(659),
    [anon_sym_f64] = ACTIONS(659),
    [anon_sym_bool] = ACTIONS(659),
    [anon_sym_str] = ACTIONS(659),
    [anon_sym_char] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(685),
    [anon_sym__] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1015),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(1017),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1051),
    [sym_super] = ACTIONS(709),
    [sym_crate] = ACTIONS(709),
    [sym_metavariable] = ACTIONS(711),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [194] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1305),
    [sym_bracketed_type] = STATE(2324),
    [sym_lifetime] = STATE(526),
    [sym_array_type] = STATE(1305),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1305),
    [sym_tuple_type] = STATE(1305),
    [sym_unit_type] = STATE(1305),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2325),
    [sym_bounded_type] = STATE(1305),
    [sym_reference_type] = STATE(1305),
    [sym_pointer_type] = STATE(1305),
    [sym_empty_type] = STATE(1305),
    [sym_abstract_type] = STATE(1305),
    [sym_dynamic_type] = STATE(1305),
    [sym_macro_invocation] = STATE(1305),
    [sym_scoped_identifier] = STATE(1458),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(1361),
    [sym_tuple_pattern] = STATE(1361),
    [sym_slice_pattern] = STATE(1361),
    [sym_tuple_struct_pattern] = STATE(1361),
    [sym_struct_pattern] = STATE(1361),
    [sym_remaining_field_pattern] = STATE(1361),
    [sym_mut_pattern] = STATE(1361),
    [sym_range_pattern] = STATE(1361),
    [sym_ref_pattern] = STATE(1361),
    [sym_captured_pattern] = STATE(1361),
    [sym_reference_pattern] = STATE(1361),
    [sym_or_pattern] = STATE(1361),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(1023),
    [anon_sym_LPAREN] = ACTIONS(1025),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1029),
    [anon_sym_i8] = ACTIONS(1029),
    [anon_sym_u16] = ACTIONS(1029),
    [anon_sym_i16] = ACTIONS(1029),
    [anon_sym_u32] = ACTIONS(1029),
    [anon_sym_i32] = ACTIONS(1029),
    [anon_sym_u64] = ACTIONS(1029),
    [anon_sym_i64] = ACTIONS(1029),
    [anon_sym_u128] = ACTIONS(1029),
    [anon_sym_i128] = ACTIONS(1029),
    [anon_sym_isize] = ACTIONS(1029),
    [anon_sym_usize] = ACTIONS(1029),
    [anon_sym_f32] = ACTIONS(1029),
    [anon_sym_f64] = ACTIONS(1029),
    [anon_sym_bool] = ACTIONS(1029),
    [anon_sym_str] = ACTIONS(1029),
    [anon_sym_char] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1033),
    [anon_sym__] = ACTIONS(1055),
    [anon_sym_AMP] = ACTIONS(1037),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(1057),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1039),
    [sym_super] = ACTIONS(1039),
    [sym_crate] = ACTIONS(1039),
    [sym_metavariable] = ACTIONS(1041),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [195] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1305),
    [sym_bracketed_type] = STATE(2321),
    [sym_lifetime] = STATE(526),
    [sym_array_type] = STATE(1305),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1305),
    [sym_tuple_type] = STATE(1305),
    [sym_unit_type] = STATE(1305),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2322),
    [sym_bounded_type] = STATE(1305),
    [sym_reference_type] = STATE(1305),
    [sym_pointer_type] = STATE(1305),
    [sym_empty_type] = STATE(1305),
    [sym_abstract_type] = STATE(1305),
    [sym_dynamic_type] = STATE(1305),
    [sym_macro_invocation] = STATE(1305),
    [sym_scoped_identifier] = STATE(1420),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(1361),
    [sym_tuple_pattern] = STATE(1361),
    [sym_slice_pattern] = STATE(1361),
    [sym_tuple_struct_pattern] = STATE(1361),
    [sym_struct_pattern] = STATE(1361),
    [sym_remaining_field_pattern] = STATE(1361),
    [sym_mut_pattern] = STATE(1361),
    [sym_range_pattern] = STATE(1361),
    [sym_ref_pattern] = STATE(1361),
    [sym_captured_pattern] = STATE(1361),
    [sym_reference_pattern] = STATE(1361),
    [sym_or_pattern] = STATE(1361),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(659),
    [anon_sym_i8] = ACTIONS(659),
    [anon_sym_u16] = ACTIONS(659),
    [anon_sym_i16] = ACTIONS(659),
    [anon_sym_u32] = ACTIONS(659),
    [anon_sym_i32] = ACTIONS(659),
    [anon_sym_u64] = ACTIONS(659),
    [anon_sym_i64] = ACTIONS(659),
    [anon_sym_u128] = ACTIONS(659),
    [anon_sym_i128] = ACTIONS(659),
    [anon_sym_isize] = ACTIONS(659),
    [anon_sym_usize] = ACTIONS(659),
    [anon_sym_f32] = ACTIONS(659),
    [anon_sym_f64] = ACTIONS(659),
    [anon_sym_bool] = ACTIONS(659),
    [anon_sym_str] = ACTIONS(659),
    [anon_sym_char] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(685),
    [anon_sym__] = ACTIONS(1055),
    [anon_sym_AMP] = ACTIONS(1015),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(1059),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(709),
    [sym_super] = ACTIONS(709),
    [sym_crate] = ACTIONS(709),
    [sym_metavariable] = ACTIONS(711),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [196] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1304),
    [sym_bracketed_type] = STATE(2318),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(1304),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1304),
    [sym_tuple_type] = STATE(1304),
    [sym_unit_type] = STATE(1304),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2319),
    [sym_bounded_type] = STATE(1304),
    [sym_reference_type] = STATE(1304),
    [sym_pointer_type] = STATE(1304),
    [sym_empty_type] = STATE(1304),
    [sym_abstract_type] = STATE(1304),
    [sym_dynamic_type] = STATE(1304),
    [sym_macro_invocation] = STATE(1304),
    [sym_scoped_identifier] = STATE(1472),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(1342),
    [sym_tuple_pattern] = STATE(1342),
    [sym_slice_pattern] = STATE(1342),
    [sym_tuple_struct_pattern] = STATE(1342),
    [sym_struct_pattern] = STATE(1342),
    [sym_remaining_field_pattern] = STATE(1342),
    [sym_mut_pattern] = STATE(1342),
    [sym_range_pattern] = STATE(1342),
    [sym_ref_pattern] = STATE(1342),
    [sym_captured_pattern] = STATE(1342),
    [sym_reference_pattern] = STATE(1342),
    [sym_or_pattern] = STATE(1342),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(795),
    [anon_sym_i8] = ACTIONS(795),
    [anon_sym_u16] = ACTIONS(795),
    [anon_sym_i16] = ACTIONS(795),
    [anon_sym_u32] = ACTIONS(795),
    [anon_sym_i32] = ACTIONS(795),
    [anon_sym_u64] = ACTIONS(795),
    [anon_sym_i64] = ACTIONS(795),
    [anon_sym_u128] = ACTIONS(795),
    [anon_sym_i128] = ACTIONS(795),
    [anon_sym_isize] = ACTIONS(795),
    [anon_sym_usize] = ACTIONS(795),
    [anon_sym_f32] = ACTIONS(795),
    [anon_sym_f64] = ACTIONS(795),
    [anon_sym_bool] = ACTIONS(795),
    [anon_sym_str] = ACTIONS(795),
    [anon_sym_char] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym__] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1061),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(1017),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1063),
    [sym_super] = ACTIONS(807),
    [sym_crate] = ACTIONS(807),
    [sym_metavariable] = ACTIONS(809),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [197] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1305),
    [sym_bracketed_type] = STATE(2318),
    [sym_lifetime] = STATE(526),
    [sym_array_type] = STATE(1305),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1305),
    [sym_tuple_type] = STATE(1305),
    [sym_unit_type] = STATE(1305),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2319),
    [sym_bounded_type] = STATE(1305),
    [sym_reference_type] = STATE(1305),
    [sym_pointer_type] = STATE(1305),
    [sym_empty_type] = STATE(1305),
    [sym_abstract_type] = STATE(1305),
    [sym_dynamic_type] = STATE(1305),
    [sym_macro_invocation] = STATE(1305),
    [sym_scoped_identifier] = STATE(1472),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(1361),
    [sym_tuple_pattern] = STATE(1361),
    [sym_slice_pattern] = STATE(1361),
    [sym_tuple_struct_pattern] = STATE(1361),
    [sym_struct_pattern] = STATE(1361),
    [sym_remaining_field_pattern] = STATE(1361),
    [sym_mut_pattern] = STATE(1361),
    [sym_range_pattern] = STATE(1361),
    [sym_ref_pattern] = STATE(1361),
    [sym_captured_pattern] = STATE(1361),
    [sym_reference_pattern] = STATE(1361),
    [sym_or_pattern] = STATE(1361),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(795),
    [anon_sym_i8] = ACTIONS(795),
    [anon_sym_u16] = ACTIONS(795),
    [anon_sym_i16] = ACTIONS(795),
    [anon_sym_u32] = ACTIONS(795),
    [anon_sym_i32] = ACTIONS(795),
    [anon_sym_u64] = ACTIONS(795),
    [anon_sym_i64] = ACTIONS(795),
    [anon_sym_u128] = ACTIONS(795),
    [anon_sym_i128] = ACTIONS(795),
    [anon_sym_isize] = ACTIONS(795),
    [anon_sym_usize] = ACTIONS(795),
    [anon_sym_f32] = ACTIONS(795),
    [anon_sym_f64] = ACTIONS(795),
    [anon_sym_bool] = ACTIONS(795),
    [anon_sym_str] = ACTIONS(795),
    [anon_sym_char] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym__] = ACTIONS(1055),
    [anon_sym_AMP] = ACTIONS(1061),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(1065),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(807),
    [sym_super] = ACTIONS(807),
    [sym_crate] = ACTIONS(807),
    [sym_metavariable] = ACTIONS(809),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [198] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1304),
    [sym_bracketed_type] = STATE(2318),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(1304),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1304),
    [sym_tuple_type] = STATE(1304),
    [sym_unit_type] = STATE(1304),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2319),
    [sym_bounded_type] = STATE(1304),
    [sym_reference_type] = STATE(1304),
    [sym_pointer_type] = STATE(1304),
    [sym_empty_type] = STATE(1304),
    [sym_abstract_type] = STATE(1304),
    [sym_dynamic_type] = STATE(1304),
    [sym_macro_invocation] = STATE(1304),
    [sym_scoped_identifier] = STATE(1472),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(1342),
    [sym_tuple_pattern] = STATE(1342),
    [sym_slice_pattern] = STATE(1342),
    [sym_tuple_struct_pattern] = STATE(1342),
    [sym_struct_pattern] = STATE(1342),
    [sym_remaining_field_pattern] = STATE(1342),
    [sym_mut_pattern] = STATE(1342),
    [sym_range_pattern] = STATE(1342),
    [sym_ref_pattern] = STATE(1342),
    [sym_captured_pattern] = STATE(1342),
    [sym_reference_pattern] = STATE(1342),
    [sym_or_pattern] = STATE(1342),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(795),
    [anon_sym_i8] = ACTIONS(795),
    [anon_sym_u16] = ACTIONS(795),
    [anon_sym_i16] = ACTIONS(795),
    [anon_sym_u32] = ACTIONS(795),
    [anon_sym_i32] = ACTIONS(795),
    [anon_sym_u64] = ACTIONS(795),
    [anon_sym_i64] = ACTIONS(795),
    [anon_sym_u128] = ACTIONS(795),
    [anon_sym_i128] = ACTIONS(795),
    [anon_sym_isize] = ACTIONS(795),
    [anon_sym_usize] = ACTIONS(795),
    [anon_sym_f32] = ACTIONS(795),
    [anon_sym_f64] = ACTIONS(795),
    [anon_sym_bool] = ACTIONS(795),
    [anon_sym_str] = ACTIONS(795),
    [anon_sym_char] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym__] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1061),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(1017),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(807),
    [sym_super] = ACTIONS(807),
    [sym_crate] = ACTIONS(807),
    [sym_metavariable] = ACTIONS(809),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [199] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1305),
    [sym_bracketed_type] = STATE(2318),
    [sym_lifetime] = STATE(530),
    [sym_array_type] = STATE(1305),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1305),
    [sym_tuple_type] = STATE(1305),
    [sym_unit_type] = STATE(1305),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2319),
    [sym_bounded_type] = STATE(1305),
    [sym_reference_type] = STATE(1305),
    [sym_pointer_type] = STATE(1305),
    [sym_empty_type] = STATE(1305),
    [sym_abstract_type] = STATE(1305),
    [sym_dynamic_type] = STATE(1305),
    [sym_macro_invocation] = STATE(1305),
    [sym_scoped_identifier] = STATE(1472),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(1361),
    [sym_tuple_pattern] = STATE(1361),
    [sym_slice_pattern] = STATE(1361),
    [sym_tuple_struct_pattern] = STATE(1361),
    [sym_struct_pattern] = STATE(1361),
    [sym_remaining_field_pattern] = STATE(1361),
    [sym_mut_pattern] = STATE(1361),
    [sym_range_pattern] = STATE(1361),
    [sym_ref_pattern] = STATE(1361),
    [sym_captured_pattern] = STATE(1361),
    [sym_reference_pattern] = STATE(1361),
    [sym_or_pattern] = STATE(1361),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(791),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(795),
    [anon_sym_i8] = ACTIONS(795),
    [anon_sym_u16] = ACTIONS(795),
    [anon_sym_i16] = ACTIONS(795),
    [anon_sym_u32] = ACTIONS(795),
    [anon_sym_i32] = ACTIONS(795),
    [anon_sym_u64] = ACTIONS(795),
    [anon_sym_i64] = ACTIONS(795),
    [anon_sym_u128] = ACTIONS(795),
    [anon_sym_i128] = ACTIONS(795),
    [anon_sym_isize] = ACTIONS(795),
    [anon_sym_usize] = ACTIONS(795),
    [anon_sym_f32] = ACTIONS(795),
    [anon_sym_f64] = ACTIONS(795),
    [anon_sym_bool] = ACTIONS(795),
    [anon_sym_str] = ACTIONS(795),
    [anon_sym_char] = ACTIONS(795),
    [anon_sym_SQUOTE] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(799),
    [anon_sym__] = ACTIONS(1055),
    [anon_sym_AMP] = ACTIONS(1061),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(1067),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1069),
    [sym_super] = ACTIONS(807),
    [sym_crate] = ACTIONS(807),
    [sym_metavariable] = ACTIONS(809),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [200] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1305),
    [sym_bracketed_type] = STATE(2321),
    [sym_lifetime] = STATE(530),
    [sym_array_type] = STATE(1305),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1305),
    [sym_tuple_type] = STATE(1305),
    [sym_unit_type] = STATE(1305),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2322),
    [sym_bounded_type] = STATE(1305),
    [sym_reference_type] = STATE(1305),
    [sym_pointer_type] = STATE(1305),
    [sym_empty_type] = STATE(1305),
    [sym_abstract_type] = STATE(1305),
    [sym_dynamic_type] = STATE(1305),
    [sym_macro_invocation] = STATE(1305),
    [sym_scoped_identifier] = STATE(1420),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(1361),
    [sym_tuple_pattern] = STATE(1361),
    [sym_slice_pattern] = STATE(1361),
    [sym_tuple_struct_pattern] = STATE(1361),
    [sym_struct_pattern] = STATE(1361),
    [sym_remaining_field_pattern] = STATE(1361),
    [sym_mut_pattern] = STATE(1361),
    [sym_range_pattern] = STATE(1361),
    [sym_ref_pattern] = STATE(1361),
    [sym_captured_pattern] = STATE(1361),
    [sym_reference_pattern] = STATE(1361),
    [sym_or_pattern] = STATE(1361),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(659),
    [anon_sym_i8] = ACTIONS(659),
    [anon_sym_u16] = ACTIONS(659),
    [anon_sym_i16] = ACTIONS(659),
    [anon_sym_u32] = ACTIONS(659),
    [anon_sym_i32] = ACTIONS(659),
    [anon_sym_u64] = ACTIONS(659),
    [anon_sym_i64] = ACTIONS(659),
    [anon_sym_u128] = ACTIONS(659),
    [anon_sym_i128] = ACTIONS(659),
    [anon_sym_isize] = ACTIONS(659),
    [anon_sym_usize] = ACTIONS(659),
    [anon_sym_f32] = ACTIONS(659),
    [anon_sym_f64] = ACTIONS(659),
    [anon_sym_bool] = ACTIONS(659),
    [anon_sym_str] = ACTIONS(659),
    [anon_sym_char] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(1053),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(685),
    [anon_sym__] = ACTIONS(1055),
    [anon_sym_AMP] = ACTIONS(1015),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(1071),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1073),
    [sym_super] = ACTIONS(709),
    [sym_crate] = ACTIONS(709),
    [sym_metavariable] = ACTIONS(711),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [201] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1304),
    [sym_bracketed_type] = STATE(2321),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(1304),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1304),
    [sym_tuple_type] = STATE(1304),
    [sym_unit_type] = STATE(1304),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2322),
    [sym_bounded_type] = STATE(1304),
    [sym_reference_type] = STATE(1304),
    [sym_pointer_type] = STATE(1304),
    [sym_empty_type] = STATE(1304),
    [sym_abstract_type] = STATE(1304),
    [sym_dynamic_type] = STATE(1304),
    [sym_macro_invocation] = STATE(1304),
    [sym_scoped_identifier] = STATE(1420),
    [sym_scoped_type_identifier] = STATE(1378),
    [sym__pattern] = STATE(1342),
    [sym_tuple_pattern] = STATE(1342),
    [sym_slice_pattern] = STATE(1342),
    [sym_tuple_struct_pattern] = STATE(1342),
    [sym_struct_pattern] = STATE(1342),
    [sym_remaining_field_pattern] = STATE(1342),
    [sym_mut_pattern] = STATE(1342),
    [sym_range_pattern] = STATE(1342),
    [sym_ref_pattern] = STATE(1342),
    [sym_captured_pattern] = STATE(1342),
    [sym_reference_pattern] = STATE(1342),
    [sym_or_pattern] = STATE(1342),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_LBRACK] = ACTIONS(655),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(659),
    [anon_sym_i8] = ACTIONS(659),
    [anon_sym_u16] = ACTIONS(659),
    [anon_sym_i16] = ACTIONS(659),
    [anon_sym_u32] = ACTIONS(659),
    [anon_sym_i32] = ACTIONS(659),
    [anon_sym_u64] = ACTIONS(659),
    [anon_sym_i64] = ACTIONS(659),
    [anon_sym_u128] = ACTIONS(659),
    [anon_sym_i128] = ACTIONS(659),
    [anon_sym_isize] = ACTIONS(659),
    [anon_sym_usize] = ACTIONS(659),
    [anon_sym_f32] = ACTIONS(659),
    [anon_sym_f64] = ACTIONS(659),
    [anon_sym_bool] = ACTIONS(659),
    [anon_sym_str] = ACTIONS(659),
    [anon_sym_char] = ACTIONS(659),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(685),
    [anon_sym__] = ACTIONS(1049),
    [anon_sym_AMP] = ACTIONS(1015),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(1017),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(709),
    [sym_super] = ACTIONS(709),
    [sym_crate] = ACTIONS(709),
    [sym_metavariable] = ACTIONS(711),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [202] = {
    [sym_bracketed_type] = STATE(2256),
    [sym_generic_type] = STATE(2255),
    [sym_generic_type_with_turbofish] = STATE(2253),
    [sym_scoped_identifier] = STATE(1253),
    [sym_scoped_type_identifier] = STATE(1796),
    [sym__pattern] = STATE(1367),
    [sym_tuple_pattern] = STATE(1367),
    [sym_slice_pattern] = STATE(1367),
    [sym_tuple_struct_pattern] = STATE(1367),
    [sym_struct_pattern] = STATE(1367),
    [sym_remaining_field_pattern] = STATE(1367),
    [sym_mut_pattern] = STATE(1367),
    [sym_range_pattern] = STATE(1367),
    [sym_ref_pattern] = STATE(1367),
    [sym_captured_pattern] = STATE(1367),
    [sym_reference_pattern] = STATE(1367),
    [sym_or_pattern] = STATE(1367),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [sym_identifier] = ACTIONS(1075),
    [anon_sym_LPAREN] = ACTIONS(1077),
    [anon_sym_LBRACE] = ACTIONS(1077),
    [anon_sym_LBRACK] = ACTIONS(1077),
    [anon_sym_STAR] = ACTIONS(1077),
    [anon_sym_u8] = ACTIONS(1075),
    [anon_sym_i8] = ACTIONS(1075),
    [anon_sym_u16] = ACTIONS(1075),
    [anon_sym_i16] = ACTIONS(1075),
    [anon_sym_u32] = ACTIONS(1075),
    [anon_sym_i32] = ACTIONS(1075),
    [anon_sym_u64] = ACTIONS(1075),
    [anon_sym_i64] = ACTIONS(1075),
    [anon_sym_u128] = ACTIONS(1075),
    [anon_sym_i128] = ACTIONS(1075),
    [anon_sym_isize] = ACTIONS(1075),
    [anon_sym_usize] = ACTIONS(1075),
    [anon_sym_f32] = ACTIONS(1075),
    [anon_sym_f64] = ACTIONS(1075),
    [anon_sym_bool] = ACTIONS(1075),
    [anon_sym_str] = ACTIONS(1075),
    [anon_sym_char] = ACTIONS(1075),
    [anon_sym_SQUOTE] = ACTIONS(1075),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_break] = ACTIONS(1075),
    [anon_sym_continue] = ACTIONS(1075),
    [anon_sym_default] = ACTIONS(1075),
    [anon_sym_for] = ACTIONS(1075),
    [anon_sym_if] = ACTIONS(1075),
    [anon_sym_loop] = ACTIONS(1075),
    [anon_sym_match] = ACTIONS(1075),
    [anon_sym_return] = ACTIONS(1075),
    [anon_sym_union] = ACTIONS(1075),
    [anon_sym_unsafe] = ACTIONS(1075),
    [anon_sym_while] = ACTIONS(1075),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_DASH_GT] = ACTIONS(1077),
    [anon_sym_LT] = ACTIONS(1077),
    [anon_sym_COLON_COLON] = ACTIONS(1077),
    [anon_sym__] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1077),
    [sym_mutable_specifier] = ACTIONS(1017),
    [anon_sym_DOT_DOT] = ACTIONS(1077),
    [anon_sym_DASH] = ACTIONS(1075),
    [anon_sym_PIPE] = ACTIONS(1077),
    [anon_sym_move] = ACTIONS(1075),
    [sym_integer_literal] = ACTIONS(1077),
    [aux_sym_string_literal_token1] = ACTIONS(1077),
    [sym_char_literal] = ACTIONS(1077),
    [anon_sym_true] = ACTIONS(1075),
    [anon_sym_false] = ACTIONS(1075),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1075),
    [sym_super] = ACTIONS(1075),
    [sym_crate] = ACTIONS(1075),
    [sym_metavariable] = ACTIONS(1077),
    [sym_raw_string_literal] = ACTIONS(1077),
    [sym_float_literal] = ACTIONS(1077),
    [sym_block_comment] = ACTIONS(3),
  },
  [203] = {
    [sym__else_tail] = STATE(221),
    [sym_identifier] = ACTIONS(397),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_RBRACE] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(395),
    [anon_sym_PLUS] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(397),
    [anon_sym_QMARK] = ACTIONS(395),
    [anon_sym_u8] = ACTIONS(397),
    [anon_sym_i8] = ACTIONS(397),
    [anon_sym_u16] = ACTIONS(397),
    [anon_sym_i16] = ACTIONS(397),
    [anon_sym_u32] = ACTIONS(397),
    [anon_sym_i32] = ACTIONS(397),
    [anon_sym_u64] = ACTIONS(397),
    [anon_sym_i64] = ACTIONS(397),
    [anon_sym_u128] = ACTIONS(397),
    [anon_sym_i128] = ACTIONS(397),
    [anon_sym_isize] = ACTIONS(397),
    [anon_sym_usize] = ACTIONS(397),
    [anon_sym_f32] = ACTIONS(397),
    [anon_sym_f64] = ACTIONS(397),
    [anon_sym_bool] = ACTIONS(397),
    [anon_sym_str] = ACTIONS(397),
    [anon_sym_char] = ACTIONS(397),
    [anon_sym_as] = ACTIONS(397),
    [anon_sym_POUND] = ACTIONS(395),
    [anon_sym_EQ] = ACTIONS(397),
    [anon_sym_COMMA] = ACTIONS(395),
    [anon_sym_ref] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(397),
    [anon_sym_COLON_COLON] = ACTIONS(395),
    [anon_sym__] = ACTIONS(397),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(395),
    [sym_mutable_specifier] = ACTIONS(397),
    [anon_sym_DOT_DOT] = ACTIONS(397),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(395),
    [anon_sym_DASH] = ACTIONS(397),
    [anon_sym_AMP_AMP] = ACTIONS(395),
    [anon_sym_PIPE_PIPE] = ACTIONS(395),
    [anon_sym_PIPE] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(395),
    [anon_sym_BANG_EQ] = ACTIONS(395),
    [anon_sym_LT_EQ] = ACTIONS(395),
    [anon_sym_GT_EQ] = ACTIONS(395),
    [anon_sym_LT_LT] = ACTIONS(397),
    [anon_sym_GT_GT] = ACTIONS(397),
    [anon_sym_SLASH] = ACTIONS(397),
    [anon_sym_PERCENT] = ACTIONS(397),
    [anon_sym_PLUS_EQ] = ACTIONS(395),
    [anon_sym_DASH_EQ] = ACTIONS(395),
    [anon_sym_STAR_EQ] = ACTIONS(395),
    [anon_sym_SLASH_EQ] = ACTIONS(395),
    [anon_sym_PERCENT_EQ] = ACTIONS(395),
    [anon_sym_AMP_EQ] = ACTIONS(395),
    [anon_sym_PIPE_EQ] = ACTIONS(395),
    [anon_sym_CARET_EQ] = ACTIONS(395),
    [anon_sym_LT_LT_EQ] = ACTIONS(395),
    [anon_sym_GT_GT_EQ] = ACTIONS(395),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOT] = ACTIONS(397),
    [sym_integer_literal] = ACTIONS(395),
    [aux_sym_string_literal_token1] = ACTIONS(395),
    [sym_char_literal] = ACTIONS(395),
    [anon_sym_true] = ACTIONS(397),
    [anon_sym_false] = ACTIONS(397),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(397),
    [sym_super] = ACTIONS(397),
    [sym_crate] = ACTIONS(397),
    [sym_metavariable] = ACTIONS(395),
    [sym_raw_string_literal] = ACTIONS(395),
    [sym_float_literal] = ACTIONS(395),
    [sym_block_comment] = ACTIONS(3),
  },
  [204] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1765),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(1767),
    [sym_array_type] = STATE(1765),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1765),
    [sym_tuple_type] = STATE(1765),
    [sym_unit_type] = STATE(1765),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1765),
    [sym_type_binding] = STATE(2054),
    [sym_reference_type] = STATE(1765),
    [sym_pointer_type] = STATE(1765),
    [sym_empty_type] = STATE(1765),
    [sym_abstract_type] = STATE(1765),
    [sym_dynamic_type] = STATE(1765),
    [sym_macro_invocation] = STATE(1765),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [sym_block] = STATE(2054),
    [sym__literal] = STATE(2054),
    [sym_string_literal] = STATE(2054),
    [sym_boolean_literal] = STATE(2054),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_GT] = ACTIONS(1093),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(1099),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(1101),
    [sym_metavariable] = ACTIONS(1103),
    [sym_raw_string_literal] = ACTIONS(1099),
    [sym_float_literal] = ACTIONS(1099),
    [sym_block_comment] = ACTIONS(3),
  },
  [205] = {
    [sym__else_tail] = STATE(231),
    [sym_identifier] = ACTIONS(391),
    [anon_sym_LPAREN] = ACTIONS(389),
    [anon_sym_RBRACE] = ACTIONS(389),
    [anon_sym_LBRACK] = ACTIONS(389),
    [anon_sym_PLUS] = ACTIONS(391),
    [anon_sym_STAR] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(389),
    [anon_sym_u8] = ACTIONS(391),
    [anon_sym_i8] = ACTIONS(391),
    [anon_sym_u16] = ACTIONS(391),
    [anon_sym_i16] = ACTIONS(391),
    [anon_sym_u32] = ACTIONS(391),
    [anon_sym_i32] = ACTIONS(391),
    [anon_sym_u64] = ACTIONS(391),
    [anon_sym_i64] = ACTIONS(391),
    [anon_sym_u128] = ACTIONS(391),
    [anon_sym_i128] = ACTIONS(391),
    [anon_sym_isize] = ACTIONS(391),
    [anon_sym_usize] = ACTIONS(391),
    [anon_sym_f32] = ACTIONS(391),
    [anon_sym_f64] = ACTIONS(391),
    [anon_sym_bool] = ACTIONS(391),
    [anon_sym_str] = ACTIONS(391),
    [anon_sym_char] = ACTIONS(391),
    [anon_sym_as] = ACTIONS(391),
    [anon_sym_POUND] = ACTIONS(389),
    [anon_sym_EQ] = ACTIONS(391),
    [anon_sym_COMMA] = ACTIONS(389),
    [anon_sym_ref] = ACTIONS(391),
    [anon_sym_LT] = ACTIONS(391),
    [anon_sym_GT] = ACTIONS(391),
    [anon_sym_COLON_COLON] = ACTIONS(389),
    [anon_sym__] = ACTIONS(391),
    [anon_sym_AMP] = ACTIONS(391),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(389),
    [sym_mutable_specifier] = ACTIONS(391),
    [anon_sym_DOT_DOT] = ACTIONS(391),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(389),
    [anon_sym_DASH] = ACTIONS(391),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(391),
    [anon_sym_CARET] = ACTIONS(391),
    [anon_sym_EQ_EQ] = ACTIONS(389),
    [anon_sym_BANG_EQ] = ACTIONS(389),
    [anon_sym_LT_EQ] = ACTIONS(389),
    [anon_sym_GT_EQ] = ACTIONS(389),
    [anon_sym_LT_LT] = ACTIONS(391),
    [anon_sym_GT_GT] = ACTIONS(391),
    [anon_sym_SLASH] = ACTIONS(391),
    [anon_sym_PERCENT] = ACTIONS(391),
    [anon_sym_PLUS_EQ] = ACTIONS(389),
    [anon_sym_DASH_EQ] = ACTIONS(389),
    [anon_sym_STAR_EQ] = ACTIONS(389),
    [anon_sym_SLASH_EQ] = ACTIONS(389),
    [anon_sym_PERCENT_EQ] = ACTIONS(389),
    [anon_sym_AMP_EQ] = ACTIONS(389),
    [anon_sym_PIPE_EQ] = ACTIONS(389),
    [anon_sym_CARET_EQ] = ACTIONS(389),
    [anon_sym_LT_LT_EQ] = ACTIONS(389),
    [anon_sym_GT_GT_EQ] = ACTIONS(389),
    [anon_sym_else] = ACTIONS(1081),
    [anon_sym_DOT] = ACTIONS(391),
    [sym_integer_literal] = ACTIONS(389),
    [aux_sym_string_literal_token1] = ACTIONS(389),
    [sym_char_literal] = ACTIONS(389),
    [anon_sym_true] = ACTIONS(391),
    [anon_sym_false] = ACTIONS(391),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(391),
    [sym_super] = ACTIONS(391),
    [sym_crate] = ACTIONS(391),
    [sym_metavariable] = ACTIONS(389),
    [sym_raw_string_literal] = ACTIONS(389),
    [sym_float_literal] = ACTIONS(389),
    [sym_block_comment] = ACTIONS(3),
  },
  [206] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1765),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(1767),
    [sym_array_type] = STATE(1765),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1765),
    [sym_tuple_type] = STATE(1765),
    [sym_unit_type] = STATE(1765),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1765),
    [sym_type_binding] = STATE(2054),
    [sym_reference_type] = STATE(1765),
    [sym_pointer_type] = STATE(1765),
    [sym_empty_type] = STATE(1765),
    [sym_abstract_type] = STATE(1765),
    [sym_dynamic_type] = STATE(1765),
    [sym_macro_invocation] = STATE(1765),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [sym_block] = STATE(2054),
    [sym__literal] = STATE(2054),
    [sym_string_literal] = STATE(2054),
    [sym_boolean_literal] = STATE(2054),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_GT] = ACTIONS(1105),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(1099),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(1101),
    [sym_metavariable] = ACTIONS(1103),
    [sym_raw_string_literal] = ACTIONS(1099),
    [sym_float_literal] = ACTIONS(1099),
    [sym_block_comment] = ACTIONS(3),
  },
  [207] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1765),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(1767),
    [sym_array_type] = STATE(1765),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1765),
    [sym_tuple_type] = STATE(1765),
    [sym_unit_type] = STATE(1765),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1765),
    [sym_type_binding] = STATE(2054),
    [sym_reference_type] = STATE(1765),
    [sym_pointer_type] = STATE(1765),
    [sym_empty_type] = STATE(1765),
    [sym_abstract_type] = STATE(1765),
    [sym_dynamic_type] = STATE(1765),
    [sym_macro_invocation] = STATE(1765),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [sym_block] = STATE(2054),
    [sym__literal] = STATE(2054),
    [sym_string_literal] = STATE(2054),
    [sym_boolean_literal] = STATE(2054),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_GT] = ACTIONS(1107),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(1099),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(1101),
    [sym_metavariable] = ACTIONS(1103),
    [sym_raw_string_literal] = ACTIONS(1099),
    [sym_float_literal] = ACTIONS(1099),
    [sym_block_comment] = ACTIONS(3),
  },
  [208] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1765),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(1767),
    [sym_array_type] = STATE(1765),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1765),
    [sym_tuple_type] = STATE(1765),
    [sym_unit_type] = STATE(1765),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1765),
    [sym_type_binding] = STATE(2054),
    [sym_reference_type] = STATE(1765),
    [sym_pointer_type] = STATE(1765),
    [sym_empty_type] = STATE(1765),
    [sym_abstract_type] = STATE(1765),
    [sym_dynamic_type] = STATE(1765),
    [sym_macro_invocation] = STATE(1765),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [sym_block] = STATE(2054),
    [sym__literal] = STATE(2054),
    [sym_string_literal] = STATE(2054),
    [sym_boolean_literal] = STATE(2054),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_GT] = ACTIONS(1109),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(1099),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(1101),
    [sym_metavariable] = ACTIONS(1103),
    [sym_raw_string_literal] = ACTIONS(1099),
    [sym_float_literal] = ACTIONS(1099),
    [sym_block_comment] = ACTIONS(3),
  },
  [209] = {
    [sym__token_pattern] = STATE(209),
    [sym_token_tree_pattern] = STATE(209),
    [sym_token_binding_pattern] = STATE(209),
    [sym_token_repetition_pattern] = STATE(209),
    [sym__literal] = STATE(209),
    [sym_string_literal] = STATE(209),
    [sym_boolean_literal] = STATE(209),
    [aux_sym_token_tree_pattern_repeat1] = STATE(209),
    [sym_identifier] = ACTIONS(1111),
    [anon_sym_LPAREN] = ACTIONS(1114),
    [anon_sym_RPAREN] = ACTIONS(1117),
    [anon_sym_LBRACE] = ACTIONS(1119),
    [anon_sym_RBRACE] = ACTIONS(1117),
    [anon_sym_LBRACK] = ACTIONS(1122),
    [anon_sym_RBRACK] = ACTIONS(1117),
    [anon_sym_DOLLAR] = ACTIONS(1125),
    [anon_sym_u8] = ACTIONS(1128),
    [anon_sym_i8] = ACTIONS(1128),
    [anon_sym_u16] = ACTIONS(1128),
    [anon_sym_i16] = ACTIONS(1128),
    [anon_sym_u32] = ACTIONS(1128),
    [anon_sym_i32] = ACTIONS(1128),
    [anon_sym_u64] = ACTIONS(1128),
    [anon_sym_i64] = ACTIONS(1128),
    [anon_sym_u128] = ACTIONS(1128),
    [anon_sym_i128] = ACTIONS(1128),
    [anon_sym_isize] = ACTIONS(1128),
    [anon_sym_usize] = ACTIONS(1128),
    [anon_sym_f32] = ACTIONS(1128),
    [anon_sym_f64] = ACTIONS(1128),
    [anon_sym_bool] = ACTIONS(1128),
    [anon_sym_str] = ACTIONS(1128),
    [anon_sym_char] = ACTIONS(1128),
    [aux_sym__non_special_token_token1] = ACTIONS(1111),
    [anon_sym_SQUOTE] = ACTIONS(1111),
    [anon_sym_as] = ACTIONS(1111),
    [anon_sym_async] = ACTIONS(1111),
    [anon_sym_await] = ACTIONS(1111),
    [anon_sym_break] = ACTIONS(1111),
    [anon_sym_const] = ACTIONS(1111),
    [anon_sym_continue] = ACTIONS(1111),
    [anon_sym_default] = ACTIONS(1111),
    [anon_sym_enum] = ACTIONS(1111),
    [anon_sym_fn] = ACTIONS(1111),
    [anon_sym_for] = ACTIONS(1111),
    [anon_sym_if] = ACTIONS(1111),
    [anon_sym_impl] = ACTIONS(1111),
    [anon_sym_let] = ACTIONS(1111),
    [anon_sym_loop] = ACTIONS(1111),
    [anon_sym_match] = ACTIONS(1111),
    [anon_sym_mod] = ACTIONS(1111),
    [anon_sym_pub] = ACTIONS(1111),
    [anon_sym_return] = ACTIONS(1111),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_struct] = ACTIONS(1111),
    [anon_sym_trait] = ACTIONS(1111),
    [anon_sym_type] = ACTIONS(1111),
    [anon_sym_union] = ACTIONS(1111),
    [anon_sym_unsafe] = ACTIONS(1111),
    [anon_sym_use] = ACTIONS(1111),
    [anon_sym_where] = ACTIONS(1111),
    [anon_sym_while] = ACTIONS(1111),
    [sym_mutable_specifier] = ACTIONS(1111),
    [sym_integer_literal] = ACTIONS(1131),
    [aux_sym_string_literal_token1] = ACTIONS(1134),
    [sym_char_literal] = ACTIONS(1131),
    [anon_sym_true] = ACTIONS(1137),
    [anon_sym_false] = ACTIONS(1137),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(1111),
    [sym_super] = ACTIONS(1111),
    [sym_crate] = ACTIONS(1111),
    [sym_metavariable] = ACTIONS(1142),
    [sym_raw_string_literal] = ACTIONS(1131),
    [sym_float_literal] = ACTIONS(1131),
    [sym_block_comment] = ACTIONS(3),
  },
  [210] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1765),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(1767),
    [sym_array_type] = STATE(1765),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1765),
    [sym_tuple_type] = STATE(1765),
    [sym_unit_type] = STATE(1765),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1765),
    [sym_type_binding] = STATE(2054),
    [sym_reference_type] = STATE(1765),
    [sym_pointer_type] = STATE(1765),
    [sym_empty_type] = STATE(1765),
    [sym_abstract_type] = STATE(1765),
    [sym_dynamic_type] = STATE(1765),
    [sym_macro_invocation] = STATE(1765),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [sym_block] = STATE(2054),
    [sym__literal] = STATE(2054),
    [sym_string_literal] = STATE(2054),
    [sym_boolean_literal] = STATE(2054),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(1099),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(1101),
    [sym_metavariable] = ACTIONS(1103),
    [sym_raw_string_literal] = ACTIONS(1099),
    [sym_float_literal] = ACTIONS(1099),
    [sym_block_comment] = ACTIONS(3),
  },
  [211] = {
    [sym_empty_statement] = STATE(211),
    [sym_macro_definition] = STATE(211),
    [sym_attribute_item] = STATE(211),
    [sym_inner_attribute_item] = STATE(211),
    [sym_mod_item] = STATE(211),
    [sym_foreign_mod_item] = STATE(211),
    [sym_struct_item] = STATE(211),
    [sym_union_item] = STATE(211),
    [sym_enum_item] = STATE(211),
    [sym_extern_crate_declaration] = STATE(211),
    [sym_const_item] = STATE(211),
    [sym_static_item] = STATE(211),
    [sym_type_item] = STATE(211),
    [sym_function_item] = STATE(211),
    [sym_function_signature_item] = STATE(211),
    [sym_function_modifiers] = STATE(2373),
    [sym_impl_item] = STATE(211),
    [sym_trait_item] = STATE(211),
    [sym_associated_type] = STATE(211),
    [sym_let_declaration] = STATE(211),
    [sym_use_declaration] = STATE(211),
    [sym_extern_modifier] = STATE(1389),
    [sym_visibility_modifier] = STATE(1245),
    [sym_bracketed_type] = STATE(2210),
    [sym_generic_type_with_turbofish] = STATE(2275),
    [sym_macro_invocation] = STATE(211),
    [sym_scoped_identifier] = STATE(2019),
    [aux_sym_declaration_list_repeat1] = STATE(211),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(1145),
    [anon_sym_SEMI] = ACTIONS(1148),
    [anon_sym_macro_rules_BANG] = ACTIONS(1151),
    [anon_sym_RBRACE] = ACTIONS(1154),
    [anon_sym_u8] = ACTIONS(1156),
    [anon_sym_i8] = ACTIONS(1156),
    [anon_sym_u16] = ACTIONS(1156),
    [anon_sym_i16] = ACTIONS(1156),
    [anon_sym_u32] = ACTIONS(1156),
    [anon_sym_i32] = ACTIONS(1156),
    [anon_sym_u64] = ACTIONS(1156),
    [anon_sym_i64] = ACTIONS(1156),
    [anon_sym_u128] = ACTIONS(1156),
    [anon_sym_i128] = ACTIONS(1156),
    [anon_sym_isize] = ACTIONS(1156),
    [anon_sym_usize] = ACTIONS(1156),
    [anon_sym_f32] = ACTIONS(1156),
    [anon_sym_f64] = ACTIONS(1156),
    [anon_sym_bool] = ACTIONS(1156),
    [anon_sym_str] = ACTIONS(1156),
    [anon_sym_char] = ACTIONS(1156),
    [anon_sym_async] = ACTIONS(1159),
    [anon_sym_const] = ACTIONS(1162),
    [anon_sym_default] = ACTIONS(1159),
    [anon_sym_enum] = ACTIONS(1165),
    [anon_sym_fn] = ACTIONS(1168),
    [anon_sym_impl] = ACTIONS(1171),
    [anon_sym_let] = ACTIONS(1174),
    [anon_sym_mod] = ACTIONS(1177),
    [anon_sym_pub] = ACTIONS(1180),
    [anon_sym_static] = ACTIONS(1183),
    [anon_sym_struct] = ACTIONS(1186),
    [anon_sym_trait] = ACTIONS(1189),
    [anon_sym_type] = ACTIONS(1192),
    [anon_sym_union] = ACTIONS(1195),
    [anon_sym_unsafe] = ACTIONS(1198),
    [anon_sym_use] = ACTIONS(1201),
    [anon_sym_POUND] = ACTIONS(1204),
    [anon_sym_extern] = ACTIONS(1207),
    [anon_sym_LT] = ACTIONS(1210),
    [anon_sym_COLON_COLON] = ACTIONS(1213),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1216),
    [sym_super] = ACTIONS(1216),
    [sym_crate] = ACTIONS(1219),
    [sym_metavariable] = ACTIONS(1222),
    [sym_block_comment] = ACTIONS(3),
  },
  [212] = {
    [sym_identifier] = ACTIONS(401),
    [anon_sym_LPAREN] = ACTIONS(399),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_LBRACK] = ACTIONS(399),
    [anon_sym_PLUS] = ACTIONS(401),
    [anon_sym_STAR] = ACTIONS(401),
    [anon_sym_QMARK] = ACTIONS(399),
    [anon_sym_u8] = ACTIONS(401),
    [anon_sym_i8] = ACTIONS(401),
    [anon_sym_u16] = ACTIONS(401),
    [anon_sym_i16] = ACTIONS(401),
    [anon_sym_u32] = ACTIONS(401),
    [anon_sym_i32] = ACTIONS(401),
    [anon_sym_u64] = ACTIONS(401),
    [anon_sym_i64] = ACTIONS(401),
    [anon_sym_u128] = ACTIONS(401),
    [anon_sym_i128] = ACTIONS(401),
    [anon_sym_isize] = ACTIONS(401),
    [anon_sym_usize] = ACTIONS(401),
    [anon_sym_f32] = ACTIONS(401),
    [anon_sym_f64] = ACTIONS(401),
    [anon_sym_bool] = ACTIONS(401),
    [anon_sym_str] = ACTIONS(401),
    [anon_sym_char] = ACTIONS(401),
    [anon_sym_as] = ACTIONS(401),
    [anon_sym_POUND] = ACTIONS(399),
    [anon_sym_EQ] = ACTIONS(401),
    [anon_sym_COMMA] = ACTIONS(399),
    [anon_sym_ref] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(401),
    [anon_sym_GT] = ACTIONS(401),
    [anon_sym_COLON_COLON] = ACTIONS(399),
    [anon_sym__] = ACTIONS(401),
    [anon_sym_AMP] = ACTIONS(401),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(399),
    [sym_mutable_specifier] = ACTIONS(401),
    [anon_sym_DOT_DOT] = ACTIONS(401),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(401),
    [anon_sym_AMP_AMP] = ACTIONS(399),
    [anon_sym_PIPE_PIPE] = ACTIONS(399),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_CARET] = ACTIONS(401),
    [anon_sym_EQ_EQ] = ACTIONS(399),
    [anon_sym_BANG_EQ] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(399),
    [anon_sym_GT_EQ] = ACTIONS(399),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_GT_GT] = ACTIONS(401),
    [anon_sym_SLASH] = ACTIONS(401),
    [anon_sym_PERCENT] = ACTIONS(401),
    [anon_sym_PLUS_EQ] = ACTIONS(399),
    [anon_sym_DASH_EQ] = ACTIONS(399),
    [anon_sym_STAR_EQ] = ACTIONS(399),
    [anon_sym_SLASH_EQ] = ACTIONS(399),
    [anon_sym_PERCENT_EQ] = ACTIONS(399),
    [anon_sym_AMP_EQ] = ACTIONS(399),
    [anon_sym_PIPE_EQ] = ACTIONS(399),
    [anon_sym_CARET_EQ] = ACTIONS(399),
    [anon_sym_LT_LT_EQ] = ACTIONS(399),
    [anon_sym_GT_GT_EQ] = ACTIONS(399),
    [anon_sym_else] = ACTIONS(401),
    [anon_sym_DOT] = ACTIONS(401),
    [sym_integer_literal] = ACTIONS(399),
    [aux_sym_string_literal_token1] = ACTIONS(399),
    [sym_char_literal] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(401),
    [sym_super] = ACTIONS(401),
    [sym_crate] = ACTIONS(401),
    [sym_metavariable] = ACTIONS(399),
    [sym_raw_string_literal] = ACTIONS(399),
    [sym_float_literal] = ACTIONS(399),
    [sym_block_comment] = ACTIONS(3),
  },
  [213] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1658),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(1657),
    [sym_array_type] = STATE(1658),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1658),
    [sym_tuple_type] = STATE(1658),
    [sym_unit_type] = STATE(1658),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1658),
    [sym_type_binding] = STATE(1935),
    [sym_reference_type] = STATE(1658),
    [sym_pointer_type] = STATE(1658),
    [sym_empty_type] = STATE(1658),
    [sym_abstract_type] = STATE(1658),
    [sym_dynamic_type] = STATE(1658),
    [sym_macro_invocation] = STATE(1658),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [sym_block] = STATE(1935),
    [sym__literal] = STATE(1935),
    [sym_string_literal] = STATE(1935),
    [sym_boolean_literal] = STATE(1935),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(1225),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(1101),
    [sym_metavariable] = ACTIONS(1103),
    [sym_raw_string_literal] = ACTIONS(1225),
    [sym_float_literal] = ACTIONS(1225),
    [sym_block_comment] = ACTIONS(3),
  },
  [214] = {
    [sym_empty_statement] = STATE(211),
    [sym_macro_definition] = STATE(211),
    [sym_attribute_item] = STATE(211),
    [sym_inner_attribute_item] = STATE(211),
    [sym_mod_item] = STATE(211),
    [sym_foreign_mod_item] = STATE(211),
    [sym_struct_item] = STATE(211),
    [sym_union_item] = STATE(211),
    [sym_enum_item] = STATE(211),
    [sym_extern_crate_declaration] = STATE(211),
    [sym_const_item] = STATE(211),
    [sym_static_item] = STATE(211),
    [sym_type_item] = STATE(211),
    [sym_function_item] = STATE(211),
    [sym_function_signature_item] = STATE(211),
    [sym_function_modifiers] = STATE(2373),
    [sym_impl_item] = STATE(211),
    [sym_trait_item] = STATE(211),
    [sym_associated_type] = STATE(211),
    [sym_let_declaration] = STATE(211),
    [sym_use_declaration] = STATE(211),
    [sym_extern_modifier] = STATE(1389),
    [sym_visibility_modifier] = STATE(1245),
    [sym_bracketed_type] = STATE(2210),
    [sym_generic_type_with_turbofish] = STATE(2275),
    [sym_macro_invocation] = STATE(211),
    [sym_scoped_identifier] = STATE(2019),
    [aux_sym_declaration_list_repeat1] = STATE(211),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_macro_rules_BANG] = ACTIONS(1231),
    [anon_sym_RBRACE] = ACTIONS(1233),
    [anon_sym_u8] = ACTIONS(1235),
    [anon_sym_i8] = ACTIONS(1235),
    [anon_sym_u16] = ACTIONS(1235),
    [anon_sym_i16] = ACTIONS(1235),
    [anon_sym_u32] = ACTIONS(1235),
    [anon_sym_i32] = ACTIONS(1235),
    [anon_sym_u64] = ACTIONS(1235),
    [anon_sym_i64] = ACTIONS(1235),
    [anon_sym_u128] = ACTIONS(1235),
    [anon_sym_i128] = ACTIONS(1235),
    [anon_sym_isize] = ACTIONS(1235),
    [anon_sym_usize] = ACTIONS(1235),
    [anon_sym_f32] = ACTIONS(1235),
    [anon_sym_f64] = ACTIONS(1235),
    [anon_sym_bool] = ACTIONS(1235),
    [anon_sym_str] = ACTIONS(1235),
    [anon_sym_char] = ACTIONS(1235),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_enum] = ACTIONS(1239),
    [anon_sym_fn] = ACTIONS(1241),
    [anon_sym_impl] = ACTIONS(1243),
    [anon_sym_let] = ACTIONS(1245),
    [anon_sym_mod] = ACTIONS(1247),
    [anon_sym_pub] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(1249),
    [anon_sym_struct] = ACTIONS(1251),
    [anon_sym_trait] = ACTIONS(1253),
    [anon_sym_type] = ACTIONS(1255),
    [anon_sym_union] = ACTIONS(1257),
    [anon_sym_unsafe] = ACTIONS(1259),
    [anon_sym_use] = ACTIONS(1261),
    [anon_sym_POUND] = ACTIONS(1263),
    [anon_sym_extern] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1267),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1269),
    [sym_super] = ACTIONS(1269),
    [sym_crate] = ACTIONS(1271),
    [sym_metavariable] = ACTIONS(1273),
    [sym_block_comment] = ACTIONS(3),
  },
  [215] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1721),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(1687),
    [sym_array_type] = STATE(1721),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1721),
    [sym_tuple_type] = STATE(1721),
    [sym_unit_type] = STATE(1721),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1721),
    [sym_type_binding] = STATE(1776),
    [sym_reference_type] = STATE(1721),
    [sym_pointer_type] = STATE(1721),
    [sym_empty_type] = STATE(1721),
    [sym_abstract_type] = STATE(1721),
    [sym_dynamic_type] = STATE(1721),
    [sym_macro_invocation] = STATE(1721),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [sym_block] = STATE(1776),
    [sym__literal] = STATE(1776),
    [sym_string_literal] = STATE(1776),
    [sym_boolean_literal] = STATE(1776),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(1083),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_LBRACE] = ACTIONS(1087),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(661),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_integer_literal] = ACTIONS(1275),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(1275),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(1101),
    [sym_metavariable] = ACTIONS(1103),
    [sym_raw_string_literal] = ACTIONS(1275),
    [sym_float_literal] = ACTIONS(1275),
    [sym_block_comment] = ACTIONS(3),
  },
  [216] = {
    [sym_empty_statement] = STATE(211),
    [sym_macro_definition] = STATE(211),
    [sym_attribute_item] = STATE(211),
    [sym_inner_attribute_item] = STATE(211),
    [sym_mod_item] = STATE(211),
    [sym_foreign_mod_item] = STATE(211),
    [sym_struct_item] = STATE(211),
    [sym_union_item] = STATE(211),
    [sym_enum_item] = STATE(211),
    [sym_extern_crate_declaration] = STATE(211),
    [sym_const_item] = STATE(211),
    [sym_static_item] = STATE(211),
    [sym_type_item] = STATE(211),
    [sym_function_item] = STATE(211),
    [sym_function_signature_item] = STATE(211),
    [sym_function_modifiers] = STATE(2373),
    [sym_impl_item] = STATE(211),
    [sym_trait_item] = STATE(211),
    [sym_associated_type] = STATE(211),
    [sym_let_declaration] = STATE(211),
    [sym_use_declaration] = STATE(211),
    [sym_extern_modifier] = STATE(1389),
    [sym_visibility_modifier] = STATE(1245),
    [sym_bracketed_type] = STATE(2210),
    [sym_generic_type_with_turbofish] = STATE(2275),
    [sym_macro_invocation] = STATE(211),
    [sym_scoped_identifier] = STATE(2019),
    [aux_sym_declaration_list_repeat1] = STATE(211),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_macro_rules_BANG] = ACTIONS(1231),
    [anon_sym_RBRACE] = ACTIONS(1277),
    [anon_sym_u8] = ACTIONS(1235),
    [anon_sym_i8] = ACTIONS(1235),
    [anon_sym_u16] = ACTIONS(1235),
    [anon_sym_i16] = ACTIONS(1235),
    [anon_sym_u32] = ACTIONS(1235),
    [anon_sym_i32] = ACTIONS(1235),
    [anon_sym_u64] = ACTIONS(1235),
    [anon_sym_i64] = ACTIONS(1235),
    [anon_sym_u128] = ACTIONS(1235),
    [anon_sym_i128] = ACTIONS(1235),
    [anon_sym_isize] = ACTIONS(1235),
    [anon_sym_usize] = ACTIONS(1235),
    [anon_sym_f32] = ACTIONS(1235),
    [anon_sym_f64] = ACTIONS(1235),
    [anon_sym_bool] = ACTIONS(1235),
    [anon_sym_str] = ACTIONS(1235),
    [anon_sym_char] = ACTIONS(1235),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_enum] = ACTIONS(1239),
    [anon_sym_fn] = ACTIONS(1241),
    [anon_sym_impl] = ACTIONS(1243),
    [anon_sym_let] = ACTIONS(1245),
    [anon_sym_mod] = ACTIONS(1247),
    [anon_sym_pub] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(1249),
    [anon_sym_struct] = ACTIONS(1251),
    [anon_sym_trait] = ACTIONS(1253),
    [anon_sym_type] = ACTIONS(1255),
    [anon_sym_union] = ACTIONS(1257),
    [anon_sym_unsafe] = ACTIONS(1259),
    [anon_sym_use] = ACTIONS(1261),
    [anon_sym_POUND] = ACTIONS(1263),
    [anon_sym_extern] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1267),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1269),
    [sym_super] = ACTIONS(1269),
    [sym_crate] = ACTIONS(1271),
    [sym_metavariable] = ACTIONS(1273),
    [sym_block_comment] = ACTIONS(3),
  },
  [217] = {
    [sym_empty_statement] = STATE(216),
    [sym_macro_definition] = STATE(216),
    [sym_attribute_item] = STATE(216),
    [sym_inner_attribute_item] = STATE(216),
    [sym_mod_item] = STATE(216),
    [sym_foreign_mod_item] = STATE(216),
    [sym_struct_item] = STATE(216),
    [sym_union_item] = STATE(216),
    [sym_enum_item] = STATE(216),
    [sym_extern_crate_declaration] = STATE(216),
    [sym_const_item] = STATE(216),
    [sym_static_item] = STATE(216),
    [sym_type_item] = STATE(216),
    [sym_function_item] = STATE(216),
    [sym_function_signature_item] = STATE(216),
    [sym_function_modifiers] = STATE(2373),
    [sym_impl_item] = STATE(216),
    [sym_trait_item] = STATE(216),
    [sym_associated_type] = STATE(216),
    [sym_let_declaration] = STATE(216),
    [sym_use_declaration] = STATE(216),
    [sym_extern_modifier] = STATE(1389),
    [sym_visibility_modifier] = STATE(1245),
    [sym_bracketed_type] = STATE(2210),
    [sym_generic_type_with_turbofish] = STATE(2275),
    [sym_macro_invocation] = STATE(216),
    [sym_scoped_identifier] = STATE(2019),
    [aux_sym_declaration_list_repeat1] = STATE(216),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_macro_rules_BANG] = ACTIONS(1231),
    [anon_sym_RBRACE] = ACTIONS(1279),
    [anon_sym_u8] = ACTIONS(1235),
    [anon_sym_i8] = ACTIONS(1235),
    [anon_sym_u16] = ACTIONS(1235),
    [anon_sym_i16] = ACTIONS(1235),
    [anon_sym_u32] = ACTIONS(1235),
    [anon_sym_i32] = ACTIONS(1235),
    [anon_sym_u64] = ACTIONS(1235),
    [anon_sym_i64] = ACTIONS(1235),
    [anon_sym_u128] = ACTIONS(1235),
    [anon_sym_i128] = ACTIONS(1235),
    [anon_sym_isize] = ACTIONS(1235),
    [anon_sym_usize] = ACTIONS(1235),
    [anon_sym_f32] = ACTIONS(1235),
    [anon_sym_f64] = ACTIONS(1235),
    [anon_sym_bool] = ACTIONS(1235),
    [anon_sym_str] = ACTIONS(1235),
    [anon_sym_char] = ACTIONS(1235),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_enum] = ACTIONS(1239),
    [anon_sym_fn] = ACTIONS(1241),
    [anon_sym_impl] = ACTIONS(1243),
    [anon_sym_let] = ACTIONS(1245),
    [anon_sym_mod] = ACTIONS(1247),
    [anon_sym_pub] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(1249),
    [anon_sym_struct] = ACTIONS(1251),
    [anon_sym_trait] = ACTIONS(1253),
    [anon_sym_type] = ACTIONS(1255),
    [anon_sym_union] = ACTIONS(1257),
    [anon_sym_unsafe] = ACTIONS(1259),
    [anon_sym_use] = ACTIONS(1261),
    [anon_sym_POUND] = ACTIONS(1263),
    [anon_sym_extern] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1267),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1269),
    [sym_super] = ACTIONS(1269),
    [sym_crate] = ACTIONS(1271),
    [sym_metavariable] = ACTIONS(1273),
    [sym_block_comment] = ACTIONS(3),
  },
  [218] = {
    [sym_identifier] = ACTIONS(429),
    [anon_sym_LPAREN] = ACTIONS(427),
    [anon_sym_RBRACE] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(427),
    [anon_sym_PLUS] = ACTIONS(429),
    [anon_sym_STAR] = ACTIONS(429),
    [anon_sym_QMARK] = ACTIONS(427),
    [anon_sym_u8] = ACTIONS(429),
    [anon_sym_i8] = ACTIONS(429),
    [anon_sym_u16] = ACTIONS(429),
    [anon_sym_i16] = ACTIONS(429),
    [anon_sym_u32] = ACTIONS(429),
    [anon_sym_i32] = ACTIONS(429),
    [anon_sym_u64] = ACTIONS(429),
    [anon_sym_i64] = ACTIONS(429),
    [anon_sym_u128] = ACTIONS(429),
    [anon_sym_i128] = ACTIONS(429),
    [anon_sym_isize] = ACTIONS(429),
    [anon_sym_usize] = ACTIONS(429),
    [anon_sym_f32] = ACTIONS(429),
    [anon_sym_f64] = ACTIONS(429),
    [anon_sym_bool] = ACTIONS(429),
    [anon_sym_str] = ACTIONS(429),
    [anon_sym_char] = ACTIONS(429),
    [anon_sym_as] = ACTIONS(429),
    [anon_sym_POUND] = ACTIONS(427),
    [anon_sym_EQ] = ACTIONS(429),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_ref] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(429),
    [anon_sym_GT] = ACTIONS(429),
    [anon_sym_COLON_COLON] = ACTIONS(427),
    [anon_sym__] = ACTIONS(429),
    [anon_sym_AMP] = ACTIONS(429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(427),
    [sym_mutable_specifier] = ACTIONS(429),
    [anon_sym_DOT_DOT] = ACTIONS(429),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(427),
    [anon_sym_DASH] = ACTIONS(429),
    [anon_sym_AMP_AMP] = ACTIONS(427),
    [anon_sym_PIPE_PIPE] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(429),
    [anon_sym_CARET] = ACTIONS(429),
    [anon_sym_EQ_EQ] = ACTIONS(427),
    [anon_sym_BANG_EQ] = ACTIONS(427),
    [anon_sym_LT_EQ] = ACTIONS(427),
    [anon_sym_GT_EQ] = ACTIONS(427),
    [anon_sym_LT_LT] = ACTIONS(429),
    [anon_sym_GT_GT] = ACTIONS(429),
    [anon_sym_SLASH] = ACTIONS(429),
    [anon_sym_PERCENT] = ACTIONS(429),
    [anon_sym_PLUS_EQ] = ACTIONS(427),
    [anon_sym_DASH_EQ] = ACTIONS(427),
    [anon_sym_STAR_EQ] = ACTIONS(427),
    [anon_sym_SLASH_EQ] = ACTIONS(427),
    [anon_sym_PERCENT_EQ] = ACTIONS(427),
    [anon_sym_AMP_EQ] = ACTIONS(427),
    [anon_sym_PIPE_EQ] = ACTIONS(427),
    [anon_sym_CARET_EQ] = ACTIONS(427),
    [anon_sym_LT_LT_EQ] = ACTIONS(427),
    [anon_sym_GT_GT_EQ] = ACTIONS(427),
    [anon_sym_else] = ACTIONS(429),
    [anon_sym_DOT] = ACTIONS(429),
    [sym_integer_literal] = ACTIONS(427),
    [aux_sym_string_literal_token1] = ACTIONS(427),
    [sym_char_literal] = ACTIONS(427),
    [anon_sym_true] = ACTIONS(429),
    [anon_sym_false] = ACTIONS(429),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(429),
    [sym_super] = ACTIONS(429),
    [sym_crate] = ACTIONS(429),
    [sym_metavariable] = ACTIONS(427),
    [sym_raw_string_literal] = ACTIONS(427),
    [sym_float_literal] = ACTIONS(427),
    [sym_block_comment] = ACTIONS(3),
  },
  [219] = {
    [sym_empty_statement] = STATE(214),
    [sym_macro_definition] = STATE(214),
    [sym_attribute_item] = STATE(214),
    [sym_inner_attribute_item] = STATE(214),
    [sym_mod_item] = STATE(214),
    [sym_foreign_mod_item] = STATE(214),
    [sym_struct_item] = STATE(214),
    [sym_union_item] = STATE(214),
    [sym_enum_item] = STATE(214),
    [sym_extern_crate_declaration] = STATE(214),
    [sym_const_item] = STATE(214),
    [sym_static_item] = STATE(214),
    [sym_type_item] = STATE(214),
    [sym_function_item] = STATE(214),
    [sym_function_signature_item] = STATE(214),
    [sym_function_modifiers] = STATE(2373),
    [sym_impl_item] = STATE(214),
    [sym_trait_item] = STATE(214),
    [sym_associated_type] = STATE(214),
    [sym_let_declaration] = STATE(214),
    [sym_use_declaration] = STATE(214),
    [sym_extern_modifier] = STATE(1389),
    [sym_visibility_modifier] = STATE(1245),
    [sym_bracketed_type] = STATE(2210),
    [sym_generic_type_with_turbofish] = STATE(2275),
    [sym_macro_invocation] = STATE(214),
    [sym_scoped_identifier] = STATE(2019),
    [aux_sym_declaration_list_repeat1] = STATE(214),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(1227),
    [anon_sym_SEMI] = ACTIONS(1229),
    [anon_sym_macro_rules_BANG] = ACTIONS(1231),
    [anon_sym_RBRACE] = ACTIONS(1281),
    [anon_sym_u8] = ACTIONS(1235),
    [anon_sym_i8] = ACTIONS(1235),
    [anon_sym_u16] = ACTIONS(1235),
    [anon_sym_i16] = ACTIONS(1235),
    [anon_sym_u32] = ACTIONS(1235),
    [anon_sym_i32] = ACTIONS(1235),
    [anon_sym_u64] = ACTIONS(1235),
    [anon_sym_i64] = ACTIONS(1235),
    [anon_sym_u128] = ACTIONS(1235),
    [anon_sym_i128] = ACTIONS(1235),
    [anon_sym_isize] = ACTIONS(1235),
    [anon_sym_usize] = ACTIONS(1235),
    [anon_sym_f32] = ACTIONS(1235),
    [anon_sym_f64] = ACTIONS(1235),
    [anon_sym_bool] = ACTIONS(1235),
    [anon_sym_str] = ACTIONS(1235),
    [anon_sym_char] = ACTIONS(1235),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(1237),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_enum] = ACTIONS(1239),
    [anon_sym_fn] = ACTIONS(1241),
    [anon_sym_impl] = ACTIONS(1243),
    [anon_sym_let] = ACTIONS(1245),
    [anon_sym_mod] = ACTIONS(1247),
    [anon_sym_pub] = ACTIONS(53),
    [anon_sym_static] = ACTIONS(1249),
    [anon_sym_struct] = ACTIONS(1251),
    [anon_sym_trait] = ACTIONS(1253),
    [anon_sym_type] = ACTIONS(1255),
    [anon_sym_union] = ACTIONS(1257),
    [anon_sym_unsafe] = ACTIONS(1259),
    [anon_sym_use] = ACTIONS(1261),
    [anon_sym_POUND] = ACTIONS(1263),
    [anon_sym_extern] = ACTIONS(1265),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1267),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1269),
    [sym_super] = ACTIONS(1269),
    [sym_crate] = ACTIONS(1271),
    [sym_metavariable] = ACTIONS(1273),
    [sym_block_comment] = ACTIONS(3),
  },
  [220] = {
    [sym_identifier] = ACTIONS(419),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_u8] = ACTIONS(419),
    [anon_sym_i8] = ACTIONS(419),
    [anon_sym_u16] = ACTIONS(419),
    [anon_sym_i16] = ACTIONS(419),
    [anon_sym_u32] = ACTIONS(419),
    [anon_sym_i32] = ACTIONS(419),
    [anon_sym_u64] = ACTIONS(419),
    [anon_sym_i64] = ACTIONS(419),
    [anon_sym_u128] = ACTIONS(419),
    [anon_sym_i128] = ACTIONS(419),
    [anon_sym_isize] = ACTIONS(419),
    [anon_sym_usize] = ACTIONS(419),
    [anon_sym_f32] = ACTIONS(419),
    [anon_sym_f64] = ACTIONS(419),
    [anon_sym_bool] = ACTIONS(419),
    [anon_sym_str] = ACTIONS(419),
    [anon_sym_char] = ACTIONS(419),
    [anon_sym_as] = ACTIONS(419),
    [anon_sym_POUND] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(419),
    [anon_sym_COMMA] = ACTIONS(417),
    [anon_sym_ref] = ACTIONS(419),
    [anon_sym_LT] = ACTIONS(419),
    [anon_sym_GT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(417),
    [anon_sym__] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(419),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(417),
    [sym_mutable_specifier] = ACTIONS(419),
    [anon_sym_DOT_DOT] = ACTIONS(419),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(417),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_PLUS_EQ] = ACTIONS(417),
    [anon_sym_DASH_EQ] = ACTIONS(417),
    [anon_sym_STAR_EQ] = ACTIONS(417),
    [anon_sym_SLASH_EQ] = ACTIONS(417),
    [anon_sym_PERCENT_EQ] = ACTIONS(417),
    [anon_sym_AMP_EQ] = ACTIONS(417),
    [anon_sym_PIPE_EQ] = ACTIONS(417),
    [anon_sym_CARET_EQ] = ACTIONS(417),
    [anon_sym_LT_LT_EQ] = ACTIONS(417),
    [anon_sym_GT_GT_EQ] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(419),
    [sym_integer_literal] = ACTIONS(417),
    [aux_sym_string_literal_token1] = ACTIONS(417),
    [sym_char_literal] = ACTIONS(417),
    [anon_sym_true] = ACTIONS(419),
    [anon_sym_false] = ACTIONS(419),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(419),
    [sym_super] = ACTIONS(419),
    [sym_crate] = ACTIONS(419),
    [sym_metavariable] = ACTIONS(417),
    [sym_raw_string_literal] = ACTIONS(417),
    [sym_float_literal] = ACTIONS(417),
    [sym_block_comment] = ACTIONS(3),
  },
  [221] = {
    [sym_identifier] = ACTIONS(437),
    [anon_sym_LPAREN] = ACTIONS(435),
    [anon_sym_RBRACE] = ACTIONS(435),
    [anon_sym_LBRACK] = ACTIONS(435),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_STAR] = ACTIONS(437),
    [anon_sym_QMARK] = ACTIONS(435),
    [anon_sym_u8] = ACTIONS(437),
    [anon_sym_i8] = ACTIONS(437),
    [anon_sym_u16] = ACTIONS(437),
    [anon_sym_i16] = ACTIONS(437),
    [anon_sym_u32] = ACTIONS(437),
    [anon_sym_i32] = ACTIONS(437),
    [anon_sym_u64] = ACTIONS(437),
    [anon_sym_i64] = ACTIONS(437),
    [anon_sym_u128] = ACTIONS(437),
    [anon_sym_i128] = ACTIONS(437),
    [anon_sym_isize] = ACTIONS(437),
    [anon_sym_usize] = ACTIONS(437),
    [anon_sym_f32] = ACTIONS(437),
    [anon_sym_f64] = ACTIONS(437),
    [anon_sym_bool] = ACTIONS(437),
    [anon_sym_str] = ACTIONS(437),
    [anon_sym_char] = ACTIONS(437),
    [anon_sym_as] = ACTIONS(437),
    [anon_sym_POUND] = ACTIONS(435),
    [anon_sym_EQ] = ACTIONS(437),
    [anon_sym_COMMA] = ACTIONS(435),
    [anon_sym_ref] = ACTIONS(437),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_GT] = ACTIONS(437),
    [anon_sym_COLON_COLON] = ACTIONS(435),
    [anon_sym__] = ACTIONS(437),
    [anon_sym_AMP] = ACTIONS(437),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(435),
    [sym_mutable_specifier] = ACTIONS(437),
    [anon_sym_DOT_DOT] = ACTIONS(437),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(435),
    [anon_sym_DASH] = ACTIONS(437),
    [anon_sym_AMP_AMP] = ACTIONS(435),
    [anon_sym_PIPE_PIPE] = ACTIONS(435),
    [anon_sym_PIPE] = ACTIONS(437),
    [anon_sym_CARET] = ACTIONS(437),
    [anon_sym_EQ_EQ] = ACTIONS(435),
    [anon_sym_BANG_EQ] = ACTIONS(435),
    [anon_sym_LT_EQ] = ACTIONS(435),
    [anon_sym_GT_EQ] = ACTIONS(435),
    [anon_sym_LT_LT] = ACTIONS(437),
    [anon_sym_GT_GT] = ACTIONS(437),
    [anon_sym_SLASH] = ACTIONS(437),
    [anon_sym_PERCENT] = ACTIONS(437),
    [anon_sym_PLUS_EQ] = ACTIONS(435),
    [anon_sym_DASH_EQ] = ACTIONS(435),
    [anon_sym_STAR_EQ] = ACTIONS(435),
    [anon_sym_SLASH_EQ] = ACTIONS(435),
    [anon_sym_PERCENT_EQ] = ACTIONS(435),
    [anon_sym_AMP_EQ] = ACTIONS(435),
    [anon_sym_PIPE_EQ] = ACTIONS(435),
    [anon_sym_CARET_EQ] = ACTIONS(435),
    [anon_sym_LT_LT_EQ] = ACTIONS(435),
    [anon_sym_GT_GT_EQ] = ACTIONS(435),
    [anon_sym_DOT] = ACTIONS(437),
    [sym_integer_literal] = ACTIONS(435),
    [aux_sym_string_literal_token1] = ACTIONS(435),
    [sym_char_literal] = ACTIONS(435),
    [anon_sym_true] = ACTIONS(437),
    [anon_sym_false] = ACTIONS(437),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(437),
    [sym_super] = ACTIONS(437),
    [sym_crate] = ACTIONS(437),
    [sym_metavariable] = ACTIONS(435),
    [sym_raw_string_literal] = ACTIONS(435),
    [sym_float_literal] = ACTIONS(435),
    [sym_block_comment] = ACTIONS(3),
  },
  [222] = {
    [sym_identifier] = ACTIONS(465),
    [anon_sym_LPAREN] = ACTIONS(463),
    [anon_sym_RBRACE] = ACTIONS(463),
    [anon_sym_LBRACK] = ACTIONS(463),
    [anon_sym_PLUS] = ACTIONS(465),
    [anon_sym_STAR] = ACTIONS(465),
    [anon_sym_QMARK] = ACTIONS(463),
    [anon_sym_u8] = ACTIONS(465),
    [anon_sym_i8] = ACTIONS(465),
    [anon_sym_u16] = ACTIONS(465),
    [anon_sym_i16] = ACTIONS(465),
    [anon_sym_u32] = ACTIONS(465),
    [anon_sym_i32] = ACTIONS(465),
    [anon_sym_u64] = ACTIONS(465),
    [anon_sym_i64] = ACTIONS(465),
    [anon_sym_u128] = ACTIONS(465),
    [anon_sym_i128] = ACTIONS(465),
    [anon_sym_isize] = ACTIONS(465),
    [anon_sym_usize] = ACTIONS(465),
    [anon_sym_f32] = ACTIONS(465),
    [anon_sym_f64] = ACTIONS(465),
    [anon_sym_bool] = ACTIONS(465),
    [anon_sym_str] = ACTIONS(465),
    [anon_sym_char] = ACTIONS(465),
    [anon_sym_as] = ACTIONS(465),
    [anon_sym_POUND] = ACTIONS(463),
    [anon_sym_EQ] = ACTIONS(465),
    [anon_sym_COMMA] = ACTIONS(463),
    [anon_sym_ref] = ACTIONS(465),
    [anon_sym_LT] = ACTIONS(465),
    [anon_sym_GT] = ACTIONS(465),
    [anon_sym_COLON_COLON] = ACTIONS(463),
    [anon_sym__] = ACTIONS(465),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(463),
    [sym_mutable_specifier] = ACTIONS(465),
    [anon_sym_DOT_DOT] = ACTIONS(465),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(463),
    [anon_sym_DASH] = ACTIONS(465),
    [anon_sym_AMP_AMP] = ACTIONS(463),
    [anon_sym_PIPE_PIPE] = ACTIONS(463),
    [anon_sym_PIPE] = ACTIONS(465),
    [anon_sym_CARET] = ACTIONS(465),
    [anon_sym_EQ_EQ] = ACTIONS(463),
    [anon_sym_BANG_EQ] = ACTIONS(463),
    [anon_sym_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_EQ] = ACTIONS(463),
    [anon_sym_LT_LT] = ACTIONS(465),
    [anon_sym_GT_GT] = ACTIONS(465),
    [anon_sym_SLASH] = ACTIONS(465),
    [anon_sym_PERCENT] = ACTIONS(465),
    [anon_sym_PLUS_EQ] = ACTIONS(463),
    [anon_sym_DASH_EQ] = ACTIONS(463),
    [anon_sym_STAR_EQ] = ACTIONS(463),
    [anon_sym_SLASH_EQ] = ACTIONS(463),
    [anon_sym_PERCENT_EQ] = ACTIONS(463),
    [anon_sym_AMP_EQ] = ACTIONS(463),
    [anon_sym_PIPE_EQ] = ACTIONS(463),
    [anon_sym_CARET_EQ] = ACTIONS(463),
    [anon_sym_LT_LT_EQ] = ACTIONS(463),
    [anon_sym_GT_GT_EQ] = ACTIONS(463),
    [anon_sym_DOT] = ACTIONS(465),
    [sym_integer_literal] = ACTIONS(463),
    [aux_sym_string_literal_token1] = ACTIONS(463),
    [sym_char_literal] = ACTIONS(463),
    [anon_sym_true] = ACTIONS(465),
    [anon_sym_false] = ACTIONS(465),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(465),
    [sym_super] = ACTIONS(465),
    [sym_crate] = ACTIONS(465),
    [sym_metavariable] = ACTIONS(463),
    [sym_raw_string_literal] = ACTIONS(463),
    [sym_float_literal] = ACTIONS(463),
    [sym_block_comment] = ACTIONS(3),
  },
  [223] = {
    [sym_identifier] = ACTIONS(495),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_RBRACE] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(493),
    [anon_sym_PLUS] = ACTIONS(495),
    [anon_sym_STAR] = ACTIONS(495),
    [anon_sym_QMARK] = ACTIONS(493),
    [anon_sym_u8] = ACTIONS(495),
    [anon_sym_i8] = ACTIONS(495),
    [anon_sym_u16] = ACTIONS(495),
    [anon_sym_i16] = ACTIONS(495),
    [anon_sym_u32] = ACTIONS(495),
    [anon_sym_i32] = ACTIONS(495),
    [anon_sym_u64] = ACTIONS(495),
    [anon_sym_i64] = ACTIONS(495),
    [anon_sym_u128] = ACTIONS(495),
    [anon_sym_i128] = ACTIONS(495),
    [anon_sym_isize] = ACTIONS(495),
    [anon_sym_usize] = ACTIONS(495),
    [anon_sym_f32] = ACTIONS(495),
    [anon_sym_f64] = ACTIONS(495),
    [anon_sym_bool] = ACTIONS(495),
    [anon_sym_str] = ACTIONS(495),
    [anon_sym_char] = ACTIONS(495),
    [anon_sym_as] = ACTIONS(495),
    [anon_sym_POUND] = ACTIONS(493),
    [anon_sym_EQ] = ACTIONS(495),
    [anon_sym_COMMA] = ACTIONS(493),
    [anon_sym_ref] = ACTIONS(495),
    [anon_sym_LT] = ACTIONS(495),
    [anon_sym_GT] = ACTIONS(495),
    [anon_sym_COLON_COLON] = ACTIONS(493),
    [anon_sym__] = ACTIONS(495),
    [anon_sym_AMP] = ACTIONS(495),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(493),
    [sym_mutable_specifier] = ACTIONS(495),
    [anon_sym_DOT_DOT] = ACTIONS(495),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(493),
    [anon_sym_DASH] = ACTIONS(495),
    [anon_sym_AMP_AMP] = ACTIONS(493),
    [anon_sym_PIPE_PIPE] = ACTIONS(493),
    [anon_sym_PIPE] = ACTIONS(495),
    [anon_sym_CARET] = ACTIONS(495),
    [anon_sym_EQ_EQ] = ACTIONS(493),
    [anon_sym_BANG_EQ] = ACTIONS(493),
    [anon_sym_LT_EQ] = ACTIONS(493),
    [anon_sym_GT_EQ] = ACTIONS(493),
    [anon_sym_LT_LT] = ACTIONS(495),
    [anon_sym_GT_GT] = ACTIONS(495),
    [anon_sym_SLASH] = ACTIONS(495),
    [anon_sym_PERCENT] = ACTIONS(495),
    [anon_sym_PLUS_EQ] = ACTIONS(493),
    [anon_sym_DASH_EQ] = ACTIONS(493),
    [anon_sym_STAR_EQ] = ACTIONS(493),
    [anon_sym_SLASH_EQ] = ACTIONS(493),
    [anon_sym_PERCENT_EQ] = ACTIONS(493),
    [anon_sym_AMP_EQ] = ACTIONS(493),
    [anon_sym_PIPE_EQ] = ACTIONS(493),
    [anon_sym_CARET_EQ] = ACTIONS(493),
    [anon_sym_LT_LT_EQ] = ACTIONS(493),
    [anon_sym_GT_GT_EQ] = ACTIONS(493),
    [anon_sym_DOT] = ACTIONS(495),
    [sym_integer_literal] = ACTIONS(493),
    [aux_sym_string_literal_token1] = ACTIONS(493),
    [sym_char_literal] = ACTIONS(493),
    [anon_sym_true] = ACTIONS(495),
    [anon_sym_false] = ACTIONS(495),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(495),
    [sym_super] = ACTIONS(495),
    [sym_crate] = ACTIONS(495),
    [sym_metavariable] = ACTIONS(493),
    [sym_raw_string_literal] = ACTIONS(493),
    [sym_float_literal] = ACTIONS(493),
    [sym_block_comment] = ACTIONS(3),
  },
  [224] = {
    [sym_identifier] = ACTIONS(499),
    [anon_sym_LPAREN] = ACTIONS(497),
    [anon_sym_RBRACE] = ACTIONS(497),
    [anon_sym_LBRACK] = ACTIONS(497),
    [anon_sym_PLUS] = ACTIONS(499),
    [anon_sym_STAR] = ACTIONS(499),
    [anon_sym_QMARK] = ACTIONS(497),
    [anon_sym_u8] = ACTIONS(499),
    [anon_sym_i8] = ACTIONS(499),
    [anon_sym_u16] = ACTIONS(499),
    [anon_sym_i16] = ACTIONS(499),
    [anon_sym_u32] = ACTIONS(499),
    [anon_sym_i32] = ACTIONS(499),
    [anon_sym_u64] = ACTIONS(499),
    [anon_sym_i64] = ACTIONS(499),
    [anon_sym_u128] = ACTIONS(499),
    [anon_sym_i128] = ACTIONS(499),
    [anon_sym_isize] = ACTIONS(499),
    [anon_sym_usize] = ACTIONS(499),
    [anon_sym_f32] = ACTIONS(499),
    [anon_sym_f64] = ACTIONS(499),
    [anon_sym_bool] = ACTIONS(499),
    [anon_sym_str] = ACTIONS(499),
    [anon_sym_char] = ACTIONS(499),
    [anon_sym_as] = ACTIONS(499),
    [anon_sym_POUND] = ACTIONS(497),
    [anon_sym_EQ] = ACTIONS(499),
    [anon_sym_COMMA] = ACTIONS(497),
    [anon_sym_ref] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(499),
    [anon_sym_GT] = ACTIONS(499),
    [anon_sym_COLON_COLON] = ACTIONS(497),
    [anon_sym__] = ACTIONS(499),
    [anon_sym_AMP] = ACTIONS(499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(497),
    [sym_mutable_specifier] = ACTIONS(499),
    [anon_sym_DOT_DOT] = ACTIONS(499),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(497),
    [anon_sym_DASH] = ACTIONS(499),
    [anon_sym_AMP_AMP] = ACTIONS(497),
    [anon_sym_PIPE_PIPE] = ACTIONS(497),
    [anon_sym_PIPE] = ACTIONS(499),
    [anon_sym_CARET] = ACTIONS(499),
    [anon_sym_EQ_EQ] = ACTIONS(497),
    [anon_sym_BANG_EQ] = ACTIONS(497),
    [anon_sym_LT_EQ] = ACTIONS(497),
    [anon_sym_GT_EQ] = ACTIONS(497),
    [anon_sym_LT_LT] = ACTIONS(499),
    [anon_sym_GT_GT] = ACTIONS(499),
    [anon_sym_SLASH] = ACTIONS(499),
    [anon_sym_PERCENT] = ACTIONS(499),
    [anon_sym_PLUS_EQ] = ACTIONS(497),
    [anon_sym_DASH_EQ] = ACTIONS(497),
    [anon_sym_STAR_EQ] = ACTIONS(497),
    [anon_sym_SLASH_EQ] = ACTIONS(497),
    [anon_sym_PERCENT_EQ] = ACTIONS(497),
    [anon_sym_AMP_EQ] = ACTIONS(497),
    [anon_sym_PIPE_EQ] = ACTIONS(497),
    [anon_sym_CARET_EQ] = ACTIONS(497),
    [anon_sym_LT_LT_EQ] = ACTIONS(497),
    [anon_sym_GT_GT_EQ] = ACTIONS(497),
    [anon_sym_DOT] = ACTIONS(499),
    [sym_integer_literal] = ACTIONS(497),
    [aux_sym_string_literal_token1] = ACTIONS(497),
    [sym_char_literal] = ACTIONS(497),
    [anon_sym_true] = ACTIONS(499),
    [anon_sym_false] = ACTIONS(499),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(499),
    [sym_super] = ACTIONS(499),
    [sym_crate] = ACTIONS(499),
    [sym_metavariable] = ACTIONS(497),
    [sym_raw_string_literal] = ACTIONS(497),
    [sym_float_literal] = ACTIONS(497),
    [sym_block_comment] = ACTIONS(3),
  },
  [225] = {
    [sym_identifier] = ACTIONS(1283),
    [anon_sym_LPAREN] = ACTIONS(1285),
    [anon_sym_RBRACE] = ACTIONS(483),
    [anon_sym_LBRACK] = ACTIONS(1285),
    [anon_sym_PLUS] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(481),
    [anon_sym_QMARK] = ACTIONS(483),
    [anon_sym_u8] = ACTIONS(1283),
    [anon_sym_i8] = ACTIONS(1283),
    [anon_sym_u16] = ACTIONS(1283),
    [anon_sym_i16] = ACTIONS(1283),
    [anon_sym_u32] = ACTIONS(1283),
    [anon_sym_i32] = ACTIONS(1283),
    [anon_sym_u64] = ACTIONS(1283),
    [anon_sym_i64] = ACTIONS(1283),
    [anon_sym_u128] = ACTIONS(1283),
    [anon_sym_i128] = ACTIONS(1283),
    [anon_sym_isize] = ACTIONS(1283),
    [anon_sym_usize] = ACTIONS(1283),
    [anon_sym_f32] = ACTIONS(1283),
    [anon_sym_f64] = ACTIONS(1283),
    [anon_sym_bool] = ACTIONS(1283),
    [anon_sym_str] = ACTIONS(1283),
    [anon_sym_char] = ACTIONS(1283),
    [anon_sym_as] = ACTIONS(481),
    [anon_sym_POUND] = ACTIONS(1285),
    [anon_sym_EQ] = ACTIONS(481),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_ref] = ACTIONS(1283),
    [anon_sym_LT] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_COLON_COLON] = ACTIONS(1285),
    [anon_sym__] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1283),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(483),
    [sym_mutable_specifier] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1283),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(483),
    [anon_sym_DASH] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(483),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_CARET] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(483),
    [anon_sym_BANG_EQ] = ACTIONS(483),
    [anon_sym_LT_EQ] = ACTIONS(483),
    [anon_sym_GT_EQ] = ACTIONS(483),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_PERCENT] = ACTIONS(481),
    [anon_sym_PLUS_EQ] = ACTIONS(483),
    [anon_sym_DASH_EQ] = ACTIONS(483),
    [anon_sym_STAR_EQ] = ACTIONS(483),
    [anon_sym_SLASH_EQ] = ACTIONS(483),
    [anon_sym_PERCENT_EQ] = ACTIONS(483),
    [anon_sym_AMP_EQ] = ACTIONS(483),
    [anon_sym_PIPE_EQ] = ACTIONS(483),
    [anon_sym_CARET_EQ] = ACTIONS(483),
    [anon_sym_LT_LT_EQ] = ACTIONS(483),
    [anon_sym_GT_GT_EQ] = ACTIONS(483),
    [anon_sym_DOT] = ACTIONS(481),
    [sym_integer_literal] = ACTIONS(1285),
    [aux_sym_string_literal_token1] = ACTIONS(1285),
    [sym_char_literal] = ACTIONS(1285),
    [anon_sym_true] = ACTIONS(1283),
    [anon_sym_false] = ACTIONS(1283),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1283),
    [sym_super] = ACTIONS(1283),
    [sym_crate] = ACTIONS(1283),
    [sym_metavariable] = ACTIONS(1285),
    [sym_raw_string_literal] = ACTIONS(1285),
    [sym_float_literal] = ACTIONS(1285),
    [sym_block_comment] = ACTIONS(3),
  },
  [226] = {
    [sym_identifier] = ACTIONS(1287),
    [anon_sym_LPAREN] = ACTIONS(1289),
    [anon_sym_RBRACE] = ACTIONS(483),
    [anon_sym_LBRACK] = ACTIONS(1289),
    [anon_sym_PLUS] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(481),
    [anon_sym_QMARK] = ACTIONS(483),
    [anon_sym_u8] = ACTIONS(1287),
    [anon_sym_i8] = ACTIONS(1287),
    [anon_sym_u16] = ACTIONS(1287),
    [anon_sym_i16] = ACTIONS(1287),
    [anon_sym_u32] = ACTIONS(1287),
    [anon_sym_i32] = ACTIONS(1287),
    [anon_sym_u64] = ACTIONS(1287),
    [anon_sym_i64] = ACTIONS(1287),
    [anon_sym_u128] = ACTIONS(1287),
    [anon_sym_i128] = ACTIONS(1287),
    [anon_sym_isize] = ACTIONS(1287),
    [anon_sym_usize] = ACTIONS(1287),
    [anon_sym_f32] = ACTIONS(1287),
    [anon_sym_f64] = ACTIONS(1287),
    [anon_sym_bool] = ACTIONS(1287),
    [anon_sym_str] = ACTIONS(1287),
    [anon_sym_char] = ACTIONS(1287),
    [anon_sym_as] = ACTIONS(481),
    [anon_sym_POUND] = ACTIONS(1289),
    [anon_sym_EQ] = ACTIONS(481),
    [anon_sym_COMMA] = ACTIONS(483),
    [anon_sym_ref] = ACTIONS(1287),
    [anon_sym_LT] = ACTIONS(1287),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_COLON_COLON] = ACTIONS(1289),
    [anon_sym__] = ACTIONS(1287),
    [anon_sym_AMP] = ACTIONS(1287),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(483),
    [sym_mutable_specifier] = ACTIONS(1287),
    [anon_sym_DOT_DOT] = ACTIONS(1287),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(483),
    [anon_sym_DASH] = ACTIONS(1287),
    [anon_sym_AMP_AMP] = ACTIONS(483),
    [anon_sym_PIPE_PIPE] = ACTIONS(483),
    [anon_sym_PIPE] = ACTIONS(481),
    [anon_sym_CARET] = ACTIONS(481),
    [anon_sym_EQ_EQ] = ACTIONS(483),
    [anon_sym_BANG_EQ] = ACTIONS(483),
    [anon_sym_LT_EQ] = ACTIONS(483),
    [anon_sym_GT_EQ] = ACTIONS(483),
    [anon_sym_LT_LT] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_SLASH] = ACTIONS(481),
    [anon_sym_PERCENT] = ACTIONS(481),
    [anon_sym_PLUS_EQ] = ACTIONS(483),
    [anon_sym_DASH_EQ] = ACTIONS(483),
    [anon_sym_STAR_EQ] = ACTIONS(483),
    [anon_sym_SLASH_EQ] = ACTIONS(483),
    [anon_sym_PERCENT_EQ] = ACTIONS(483),
    [anon_sym_AMP_EQ] = ACTIONS(483),
    [anon_sym_PIPE_EQ] = ACTIONS(483),
    [anon_sym_CARET_EQ] = ACTIONS(483),
    [anon_sym_LT_LT_EQ] = ACTIONS(483),
    [anon_sym_GT_GT_EQ] = ACTIONS(483),
    [anon_sym_DOT] = ACTIONS(481),
    [sym_integer_literal] = ACTIONS(1289),
    [aux_sym_string_literal_token1] = ACTIONS(1289),
    [sym_char_literal] = ACTIONS(1289),
    [anon_sym_true] = ACTIONS(1287),
    [anon_sym_false] = ACTIONS(1287),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1287),
    [sym_super] = ACTIONS(1287),
    [sym_crate] = ACTIONS(1287),
    [sym_metavariable] = ACTIONS(1289),
    [sym_raw_string_literal] = ACTIONS(1289),
    [sym_float_literal] = ACTIONS(1289),
    [sym_block_comment] = ACTIONS(3),
  },
  [227] = {
    [sym_identifier] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(527),
    [anon_sym_RBRACE] = ACTIONS(527),
    [anon_sym_LBRACK] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_STAR] = ACTIONS(529),
    [anon_sym_QMARK] = ACTIONS(527),
    [anon_sym_u8] = ACTIONS(529),
    [anon_sym_i8] = ACTIONS(529),
    [anon_sym_u16] = ACTIONS(529),
    [anon_sym_i16] = ACTIONS(529),
    [anon_sym_u32] = ACTIONS(529),
    [anon_sym_i32] = ACTIONS(529),
    [anon_sym_u64] = ACTIONS(529),
    [anon_sym_i64] = ACTIONS(529),
    [anon_sym_u128] = ACTIONS(529),
    [anon_sym_i128] = ACTIONS(529),
    [anon_sym_isize] = ACTIONS(529),
    [anon_sym_usize] = ACTIONS(529),
    [anon_sym_f32] = ACTIONS(529),
    [anon_sym_f64] = ACTIONS(529),
    [anon_sym_bool] = ACTIONS(529),
    [anon_sym_str] = ACTIONS(529),
    [anon_sym_char] = ACTIONS(529),
    [anon_sym_as] = ACTIONS(529),
    [anon_sym_POUND] = ACTIONS(527),
    [anon_sym_EQ] = ACTIONS(529),
    [anon_sym_COMMA] = ACTIONS(527),
    [anon_sym_ref] = ACTIONS(529),
    [anon_sym_LT] = ACTIONS(529),
    [anon_sym_GT] = ACTIONS(529),
    [anon_sym_COLON_COLON] = ACTIONS(527),
    [anon_sym__] = ACTIONS(529),
    [anon_sym_AMP] = ACTIONS(529),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(527),
    [sym_mutable_specifier] = ACTIONS(529),
    [anon_sym_DOT_DOT] = ACTIONS(529),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(527),
    [anon_sym_DASH] = ACTIONS(529),
    [anon_sym_AMP_AMP] = ACTIONS(527),
    [anon_sym_PIPE_PIPE] = ACTIONS(527),
    [anon_sym_PIPE] = ACTIONS(529),
    [anon_sym_CARET] = ACTIONS(529),
    [anon_sym_EQ_EQ] = ACTIONS(527),
    [anon_sym_BANG_EQ] = ACTIONS(527),
    [anon_sym_LT_EQ] = ACTIONS(527),
    [anon_sym_GT_EQ] = ACTIONS(527),
    [anon_sym_LT_LT] = ACTIONS(529),
    [anon_sym_GT_GT] = ACTIONS(529),
    [anon_sym_SLASH] = ACTIONS(529),
    [anon_sym_PERCENT] = ACTIONS(529),
    [anon_sym_PLUS_EQ] = ACTIONS(527),
    [anon_sym_DASH_EQ] = ACTIONS(527),
    [anon_sym_STAR_EQ] = ACTIONS(527),
    [anon_sym_SLASH_EQ] = ACTIONS(527),
    [anon_sym_PERCENT_EQ] = ACTIONS(527),
    [anon_sym_AMP_EQ] = ACTIONS(527),
    [anon_sym_PIPE_EQ] = ACTIONS(527),
    [anon_sym_CARET_EQ] = ACTIONS(527),
    [anon_sym_LT_LT_EQ] = ACTIONS(527),
    [anon_sym_GT_GT_EQ] = ACTIONS(527),
    [anon_sym_DOT] = ACTIONS(529),
    [sym_integer_literal] = ACTIONS(527),
    [aux_sym_string_literal_token1] = ACTIONS(527),
    [sym_char_literal] = ACTIONS(527),
    [anon_sym_true] = ACTIONS(529),
    [anon_sym_false] = ACTIONS(529),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(529),
    [sym_super] = ACTIONS(529),
    [sym_crate] = ACTIONS(529),
    [sym_metavariable] = ACTIONS(527),
    [sym_raw_string_literal] = ACTIONS(527),
    [sym_float_literal] = ACTIONS(527),
    [sym_block_comment] = ACTIONS(3),
  },
  [228] = {
    [sym_identifier] = ACTIONS(449),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RBRACE] = ACTIONS(447),
    [anon_sym_LBRACK] = ACTIONS(447),
    [anon_sym_PLUS] = ACTIONS(449),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_QMARK] = ACTIONS(447),
    [anon_sym_u8] = ACTIONS(449),
    [anon_sym_i8] = ACTIONS(449),
    [anon_sym_u16] = ACTIONS(449),
    [anon_sym_i16] = ACTIONS(449),
    [anon_sym_u32] = ACTIONS(449),
    [anon_sym_i32] = ACTIONS(449),
    [anon_sym_u64] = ACTIONS(449),
    [anon_sym_i64] = ACTIONS(449),
    [anon_sym_u128] = ACTIONS(449),
    [anon_sym_i128] = ACTIONS(449),
    [anon_sym_isize] = ACTIONS(449),
    [anon_sym_usize] = ACTIONS(449),
    [anon_sym_f32] = ACTIONS(449),
    [anon_sym_f64] = ACTIONS(449),
    [anon_sym_bool] = ACTIONS(449),
    [anon_sym_str] = ACTIONS(449),
    [anon_sym_char] = ACTIONS(449),
    [anon_sym_as] = ACTIONS(449),
    [anon_sym_POUND] = ACTIONS(447),
    [anon_sym_EQ] = ACTIONS(449),
    [anon_sym_COMMA] = ACTIONS(447),
    [anon_sym_ref] = ACTIONS(449),
    [anon_sym_LT] = ACTIONS(449),
    [anon_sym_GT] = ACTIONS(449),
    [anon_sym_COLON_COLON] = ACTIONS(447),
    [anon_sym__] = ACTIONS(449),
    [anon_sym_AMP] = ACTIONS(449),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(447),
    [sym_mutable_specifier] = ACTIONS(449),
    [anon_sym_DOT_DOT] = ACTIONS(449),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(447),
    [anon_sym_DASH] = ACTIONS(449),
    [anon_sym_AMP_AMP] = ACTIONS(447),
    [anon_sym_PIPE_PIPE] = ACTIONS(447),
    [anon_sym_PIPE] = ACTIONS(449),
    [anon_sym_CARET] = ACTIONS(449),
    [anon_sym_EQ_EQ] = ACTIONS(447),
    [anon_sym_BANG_EQ] = ACTIONS(447),
    [anon_sym_LT_EQ] = ACTIONS(447),
    [anon_sym_GT_EQ] = ACTIONS(447),
    [anon_sym_LT_LT] = ACTIONS(449),
    [anon_sym_GT_GT] = ACTIONS(449),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_PERCENT] = ACTIONS(449),
    [anon_sym_PLUS_EQ] = ACTIONS(447),
    [anon_sym_DASH_EQ] = ACTIONS(447),
    [anon_sym_STAR_EQ] = ACTIONS(447),
    [anon_sym_SLASH_EQ] = ACTIONS(447),
    [anon_sym_PERCENT_EQ] = ACTIONS(447),
    [anon_sym_AMP_EQ] = ACTIONS(447),
    [anon_sym_PIPE_EQ] = ACTIONS(447),
    [anon_sym_CARET_EQ] = ACTIONS(447),
    [anon_sym_LT_LT_EQ] = ACTIONS(447),
    [anon_sym_GT_GT_EQ] = ACTIONS(447),
    [anon_sym_DOT] = ACTIONS(449),
    [sym_integer_literal] = ACTIONS(447),
    [aux_sym_string_literal_token1] = ACTIONS(447),
    [sym_char_literal] = ACTIONS(447),
    [anon_sym_true] = ACTIONS(449),
    [anon_sym_false] = ACTIONS(449),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(449),
    [sym_super] = ACTIONS(449),
    [sym_crate] = ACTIONS(449),
    [sym_metavariable] = ACTIONS(447),
    [sym_raw_string_literal] = ACTIONS(447),
    [sym_float_literal] = ACTIONS(447),
    [sym_block_comment] = ACTIONS(3),
  },
  [229] = {
    [sym_identifier] = ACTIONS(537),
    [anon_sym_LPAREN] = ACTIONS(535),
    [anon_sym_RBRACE] = ACTIONS(535),
    [anon_sym_LBRACK] = ACTIONS(535),
    [anon_sym_PLUS] = ACTIONS(537),
    [anon_sym_STAR] = ACTIONS(537),
    [anon_sym_QMARK] = ACTIONS(535),
    [anon_sym_u8] = ACTIONS(537),
    [anon_sym_i8] = ACTIONS(537),
    [anon_sym_u16] = ACTIONS(537),
    [anon_sym_i16] = ACTIONS(537),
    [anon_sym_u32] = ACTIONS(537),
    [anon_sym_i32] = ACTIONS(537),
    [anon_sym_u64] = ACTIONS(537),
    [anon_sym_i64] = ACTIONS(537),
    [anon_sym_u128] = ACTIONS(537),
    [anon_sym_i128] = ACTIONS(537),
    [anon_sym_isize] = ACTIONS(537),
    [anon_sym_usize] = ACTIONS(537),
    [anon_sym_f32] = ACTIONS(537),
    [anon_sym_f64] = ACTIONS(537),
    [anon_sym_bool] = ACTIONS(537),
    [anon_sym_str] = ACTIONS(537),
    [anon_sym_char] = ACTIONS(537),
    [anon_sym_as] = ACTIONS(537),
    [anon_sym_POUND] = ACTIONS(535),
    [anon_sym_EQ] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(535),
    [anon_sym_ref] = ACTIONS(537),
    [anon_sym_LT] = ACTIONS(537),
    [anon_sym_GT] = ACTIONS(537),
    [anon_sym_COLON_COLON] = ACTIONS(535),
    [anon_sym__] = ACTIONS(537),
    [anon_sym_AMP] = ACTIONS(537),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(535),
    [sym_mutable_specifier] = ACTIONS(537),
    [anon_sym_DOT_DOT] = ACTIONS(537),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(535),
    [anon_sym_DASH] = ACTIONS(537),
    [anon_sym_AMP_AMP] = ACTIONS(535),
    [anon_sym_PIPE_PIPE] = ACTIONS(535),
    [anon_sym_PIPE] = ACTIONS(537),
    [anon_sym_CARET] = ACTIONS(537),
    [anon_sym_EQ_EQ] = ACTIONS(535),
    [anon_sym_BANG_EQ] = ACTIONS(535),
    [anon_sym_LT_EQ] = ACTIONS(535),
    [anon_sym_GT_EQ] = ACTIONS(535),
    [anon_sym_LT_LT] = ACTIONS(537),
    [anon_sym_GT_GT] = ACTIONS(537),
    [anon_sym_SLASH] = ACTIONS(537),
    [anon_sym_PERCENT] = ACTIONS(537),
    [anon_sym_PLUS_EQ] = ACTIONS(535),
    [anon_sym_DASH_EQ] = ACTIONS(535),
    [anon_sym_STAR_EQ] = ACTIONS(535),
    [anon_sym_SLASH_EQ] = ACTIONS(535),
    [anon_sym_PERCENT_EQ] = ACTIONS(535),
    [anon_sym_AMP_EQ] = ACTIONS(535),
    [anon_sym_PIPE_EQ] = ACTIONS(535),
    [anon_sym_CARET_EQ] = ACTIONS(535),
    [anon_sym_LT_LT_EQ] = ACTIONS(535),
    [anon_sym_GT_GT_EQ] = ACTIONS(535),
    [anon_sym_DOT] = ACTIONS(537),
    [sym_integer_literal] = ACTIONS(535),
    [aux_sym_string_literal_token1] = ACTIONS(535),
    [sym_char_literal] = ACTIONS(535),
    [anon_sym_true] = ACTIONS(537),
    [anon_sym_false] = ACTIONS(537),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(537),
    [sym_super] = ACTIONS(537),
    [sym_crate] = ACTIONS(537),
    [sym_metavariable] = ACTIONS(535),
    [sym_raw_string_literal] = ACTIONS(535),
    [sym_float_literal] = ACTIONS(535),
    [sym_block_comment] = ACTIONS(3),
  },
  [230] = {
    [sym_identifier] = ACTIONS(521),
    [anon_sym_LPAREN] = ACTIONS(519),
    [anon_sym_RBRACE] = ACTIONS(519),
    [anon_sym_LBRACK] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_STAR] = ACTIONS(521),
    [anon_sym_QMARK] = ACTIONS(519),
    [anon_sym_u8] = ACTIONS(521),
    [anon_sym_i8] = ACTIONS(521),
    [anon_sym_u16] = ACTIONS(521),
    [anon_sym_i16] = ACTIONS(521),
    [anon_sym_u32] = ACTIONS(521),
    [anon_sym_i32] = ACTIONS(521),
    [anon_sym_u64] = ACTIONS(521),
    [anon_sym_i64] = ACTIONS(521),
    [anon_sym_u128] = ACTIONS(521),
    [anon_sym_i128] = ACTIONS(521),
    [anon_sym_isize] = ACTIONS(521),
    [anon_sym_usize] = ACTIONS(521),
    [anon_sym_f32] = ACTIONS(521),
    [anon_sym_f64] = ACTIONS(521),
    [anon_sym_bool] = ACTIONS(521),
    [anon_sym_str] = ACTIONS(521),
    [anon_sym_char] = ACTIONS(521),
    [anon_sym_as] = ACTIONS(521),
    [anon_sym_POUND] = ACTIONS(519),
    [anon_sym_EQ] = ACTIONS(521),
    [anon_sym_COMMA] = ACTIONS(519),
    [anon_sym_ref] = ACTIONS(521),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_COLON_COLON] = ACTIONS(519),
    [anon_sym__] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(519),
    [sym_mutable_specifier] = ACTIONS(521),
    [anon_sym_DOT_DOT] = ACTIONS(521),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(519),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_AMP_AMP] = ACTIONS(519),
    [anon_sym_PIPE_PIPE] = ACTIONS(519),
    [anon_sym_PIPE] = ACTIONS(521),
    [anon_sym_CARET] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(519),
    [anon_sym_BANG_EQ] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(519),
    [anon_sym_LT_LT] = ACTIONS(521),
    [anon_sym_GT_GT] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(521),
    [anon_sym_PERCENT] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(519),
    [anon_sym_DASH_EQ] = ACTIONS(519),
    [anon_sym_STAR_EQ] = ACTIONS(519),
    [anon_sym_SLASH_EQ] = ACTIONS(519),
    [anon_sym_PERCENT_EQ] = ACTIONS(519),
    [anon_sym_AMP_EQ] = ACTIONS(519),
    [anon_sym_PIPE_EQ] = ACTIONS(519),
    [anon_sym_CARET_EQ] = ACTIONS(519),
    [anon_sym_LT_LT_EQ] = ACTIONS(519),
    [anon_sym_GT_GT_EQ] = ACTIONS(519),
    [anon_sym_DOT] = ACTIONS(521),
    [sym_integer_literal] = ACTIONS(519),
    [aux_sym_string_literal_token1] = ACTIONS(519),
    [sym_char_literal] = ACTIONS(519),
    [anon_sym_true] = ACTIONS(521),
    [anon_sym_false] = ACTIONS(521),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(521),
    [sym_super] = ACTIONS(521),
    [sym_crate] = ACTIONS(521),
    [sym_metavariable] = ACTIONS(519),
    [sym_raw_string_literal] = ACTIONS(519),
    [sym_float_literal] = ACTIONS(519),
    [sym_block_comment] = ACTIONS(3),
  },
  [231] = {
    [sym_identifier] = ACTIONS(503),
    [anon_sym_LPAREN] = ACTIONS(501),
    [anon_sym_RBRACE] = ACTIONS(501),
    [anon_sym_LBRACK] = ACTIONS(501),
    [anon_sym_PLUS] = ACTIONS(503),
    [anon_sym_STAR] = ACTIONS(503),
    [anon_sym_QMARK] = ACTIONS(501),
    [anon_sym_u8] = ACTIONS(503),
    [anon_sym_i8] = ACTIONS(503),
    [anon_sym_u16] = ACTIONS(503),
    [anon_sym_i16] = ACTIONS(503),
    [anon_sym_u32] = ACTIONS(503),
    [anon_sym_i32] = ACTIONS(503),
    [anon_sym_u64] = ACTIONS(503),
    [anon_sym_i64] = ACTIONS(503),
    [anon_sym_u128] = ACTIONS(503),
    [anon_sym_i128] = ACTIONS(503),
    [anon_sym_isize] = ACTIONS(503),
    [anon_sym_usize] = ACTIONS(503),
    [anon_sym_f32] = ACTIONS(503),
    [anon_sym_f64] = ACTIONS(503),
    [anon_sym_bool] = ACTIONS(503),
    [anon_sym_str] = ACTIONS(503),
    [anon_sym_char] = ACTIONS(503),
    [anon_sym_as] = ACTIONS(503),
    [anon_sym_POUND] = ACTIONS(501),
    [anon_sym_EQ] = ACTIONS(503),
    [anon_sym_COMMA] = ACTIONS(501),
    [anon_sym_ref] = ACTIONS(503),
    [anon_sym_LT] = ACTIONS(503),
    [anon_sym_GT] = ACTIONS(503),
    [anon_sym_COLON_COLON] = ACTIONS(501),
    [anon_sym__] = ACTIONS(503),
    [anon_sym_AMP] = ACTIONS(503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(501),
    [sym_mutable_specifier] = ACTIONS(503),
    [anon_sym_DOT_DOT] = ACTIONS(503),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(501),
    [anon_sym_DASH] = ACTIONS(503),
    [anon_sym_AMP_AMP] = ACTIONS(501),
    [anon_sym_PIPE_PIPE] = ACTIONS(501),
    [anon_sym_PIPE] = ACTIONS(503),
    [anon_sym_CARET] = ACTIONS(503),
    [anon_sym_EQ_EQ] = ACTIONS(501),
    [anon_sym_BANG_EQ] = ACTIONS(501),
    [anon_sym_LT_EQ] = ACTIONS(501),
    [anon_sym_GT_EQ] = ACTIONS(501),
    [anon_sym_LT_LT] = ACTIONS(503),
    [anon_sym_GT_GT] = ACTIONS(503),
    [anon_sym_SLASH] = ACTIONS(503),
    [anon_sym_PERCENT] = ACTIONS(503),
    [anon_sym_PLUS_EQ] = ACTIONS(501),
    [anon_sym_DASH_EQ] = ACTIONS(501),
    [anon_sym_STAR_EQ] = ACTIONS(501),
    [anon_sym_SLASH_EQ] = ACTIONS(501),
    [anon_sym_PERCENT_EQ] = ACTIONS(501),
    [anon_sym_AMP_EQ] = ACTIONS(501),
    [anon_sym_PIPE_EQ] = ACTIONS(501),
    [anon_sym_CARET_EQ] = ACTIONS(501),
    [anon_sym_LT_LT_EQ] = ACTIONS(501),
    [anon_sym_GT_GT_EQ] = ACTIONS(501),
    [anon_sym_DOT] = ACTIONS(503),
    [sym_integer_literal] = ACTIONS(501),
    [aux_sym_string_literal_token1] = ACTIONS(501),
    [sym_char_literal] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(503),
    [anon_sym_false] = ACTIONS(503),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(503),
    [sym_super] = ACTIONS(503),
    [sym_crate] = ACTIONS(503),
    [sym_metavariable] = ACTIONS(501),
    [sym_raw_string_literal] = ACTIONS(501),
    [sym_float_literal] = ACTIONS(501),
    [sym_block_comment] = ACTIONS(3),
  },
  [232] = {
    [sym_identifier] = ACTIONS(453),
    [anon_sym_LPAREN] = ACTIONS(451),
    [anon_sym_RBRACE] = ACTIONS(451),
    [anon_sym_LBRACK] = ACTIONS(451),
    [anon_sym_PLUS] = ACTIONS(453),
    [anon_sym_STAR] = ACTIONS(453),
    [anon_sym_QMARK] = ACTIONS(451),
    [anon_sym_u8] = ACTIONS(453),
    [anon_sym_i8] = ACTIONS(453),
    [anon_sym_u16] = ACTIONS(453),
    [anon_sym_i16] = ACTIONS(453),
    [anon_sym_u32] = ACTIONS(453),
    [anon_sym_i32] = ACTIONS(453),
    [anon_sym_u64] = ACTIONS(453),
    [anon_sym_i64] = ACTIONS(453),
    [anon_sym_u128] = ACTIONS(453),
    [anon_sym_i128] = ACTIONS(453),
    [anon_sym_isize] = ACTIONS(453),
    [anon_sym_usize] = ACTIONS(453),
    [anon_sym_f32] = ACTIONS(453),
    [anon_sym_f64] = ACTIONS(453),
    [anon_sym_bool] = ACTIONS(453),
    [anon_sym_str] = ACTIONS(453),
    [anon_sym_char] = ACTIONS(453),
    [anon_sym_as] = ACTIONS(453),
    [anon_sym_POUND] = ACTIONS(451),
    [anon_sym_EQ] = ACTIONS(453),
    [anon_sym_COMMA] = ACTIONS(451),
    [anon_sym_ref] = ACTIONS(453),
    [anon_sym_LT] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(453),
    [anon_sym_COLON_COLON] = ACTIONS(451),
    [anon_sym__] = ACTIONS(453),
    [anon_sym_AMP] = ACTIONS(453),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(451),
    [sym_mutable_specifier] = ACTIONS(453),
    [anon_sym_DOT_DOT] = ACTIONS(453),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(451),
    [anon_sym_DASH] = ACTIONS(453),
    [anon_sym_AMP_AMP] = ACTIONS(451),
    [anon_sym_PIPE_PIPE] = ACTIONS(451),
    [anon_sym_PIPE] = ACTIONS(453),
    [anon_sym_CARET] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(451),
    [anon_sym_BANG_EQ] = ACTIONS(451),
    [anon_sym_LT_EQ] = ACTIONS(451),
    [anon_sym_GT_EQ] = ACTIONS(451),
    [anon_sym_LT_LT] = ACTIONS(453),
    [anon_sym_GT_GT] = ACTIONS(453),
    [anon_sym_SLASH] = ACTIONS(453),
    [anon_sym_PERCENT] = ACTIONS(453),
    [anon_sym_PLUS_EQ] = ACTIONS(451),
    [anon_sym_DASH_EQ] = ACTIONS(451),
    [anon_sym_STAR_EQ] = ACTIONS(451),
    [anon_sym_SLASH_EQ] = ACTIONS(451),
    [anon_sym_PERCENT_EQ] = ACTIONS(451),
    [anon_sym_AMP_EQ] = ACTIONS(451),
    [anon_sym_PIPE_EQ] = ACTIONS(451),
    [anon_sym_CARET_EQ] = ACTIONS(451),
    [anon_sym_LT_LT_EQ] = ACTIONS(451),
    [anon_sym_GT_GT_EQ] = ACTIONS(451),
    [anon_sym_DOT] = ACTIONS(453),
    [sym_integer_literal] = ACTIONS(451),
    [aux_sym_string_literal_token1] = ACTIONS(451),
    [sym_char_literal] = ACTIONS(451),
    [anon_sym_true] = ACTIONS(453),
    [anon_sym_false] = ACTIONS(453),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(453),
    [sym_super] = ACTIONS(453),
    [sym_crate] = ACTIONS(453),
    [sym_metavariable] = ACTIONS(451),
    [sym_raw_string_literal] = ACTIONS(451),
    [sym_float_literal] = ACTIONS(451),
    [sym_block_comment] = ACTIONS(3),
  },
  [233] = {
    [sym_identifier] = ACTIONS(487),
    [anon_sym_LPAREN] = ACTIONS(485),
    [anon_sym_RBRACE] = ACTIONS(485),
    [anon_sym_LBRACK] = ACTIONS(485),
    [anon_sym_PLUS] = ACTIONS(487),
    [anon_sym_STAR] = ACTIONS(487),
    [anon_sym_QMARK] = ACTIONS(485),
    [anon_sym_u8] = ACTIONS(487),
    [anon_sym_i8] = ACTIONS(487),
    [anon_sym_u16] = ACTIONS(487),
    [anon_sym_i16] = ACTIONS(487),
    [anon_sym_u32] = ACTIONS(487),
    [anon_sym_i32] = ACTIONS(487),
    [anon_sym_u64] = ACTIONS(487),
    [anon_sym_i64] = ACTIONS(487),
    [anon_sym_u128] = ACTIONS(487),
    [anon_sym_i128] = ACTIONS(487),
    [anon_sym_isize] = ACTIONS(487),
    [anon_sym_usize] = ACTIONS(487),
    [anon_sym_f32] = ACTIONS(487),
    [anon_sym_f64] = ACTIONS(487),
    [anon_sym_bool] = ACTIONS(487),
    [anon_sym_str] = ACTIONS(487),
    [anon_sym_char] = ACTIONS(487),
    [anon_sym_as] = ACTIONS(487),
    [anon_sym_POUND] = ACTIONS(485),
    [anon_sym_EQ] = ACTIONS(487),
    [anon_sym_COMMA] = ACTIONS(485),
    [anon_sym_ref] = ACTIONS(487),
    [anon_sym_LT] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(487),
    [anon_sym_COLON_COLON] = ACTIONS(485),
    [anon_sym__] = ACTIONS(487),
    [anon_sym_AMP] = ACTIONS(487),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(485),
    [sym_mutable_specifier] = ACTIONS(487),
    [anon_sym_DOT_DOT] = ACTIONS(487),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(485),
    [anon_sym_DASH] = ACTIONS(487),
    [anon_sym_AMP_AMP] = ACTIONS(485),
    [anon_sym_PIPE_PIPE] = ACTIONS(485),
    [anon_sym_PIPE] = ACTIONS(487),
    [anon_sym_CARET] = ACTIONS(487),
    [anon_sym_EQ_EQ] = ACTIONS(485),
    [anon_sym_BANG_EQ] = ACTIONS(485),
    [anon_sym_LT_EQ] = ACTIONS(485),
    [anon_sym_GT_EQ] = ACTIONS(485),
    [anon_sym_LT_LT] = ACTIONS(487),
    [anon_sym_GT_GT] = ACTIONS(487),
    [anon_sym_SLASH] = ACTIONS(487),
    [anon_sym_PERCENT] = ACTIONS(487),
    [anon_sym_PLUS_EQ] = ACTIONS(485),
    [anon_sym_DASH_EQ] = ACTIONS(485),
    [anon_sym_STAR_EQ] = ACTIONS(485),
    [anon_sym_SLASH_EQ] = ACTIONS(485),
    [anon_sym_PERCENT_EQ] = ACTIONS(485),
    [anon_sym_AMP_EQ] = ACTIONS(485),
    [anon_sym_PIPE_EQ] = ACTIONS(485),
    [anon_sym_CARET_EQ] = ACTIONS(485),
    [anon_sym_LT_LT_EQ] = ACTIONS(485),
    [anon_sym_GT_GT_EQ] = ACTIONS(485),
    [anon_sym_DOT] = ACTIONS(487),
    [sym_integer_literal] = ACTIONS(485),
    [aux_sym_string_literal_token1] = ACTIONS(485),
    [sym_char_literal] = ACTIONS(485),
    [anon_sym_true] = ACTIONS(487),
    [anon_sym_false] = ACTIONS(487),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(487),
    [sym_super] = ACTIONS(487),
    [sym_crate] = ACTIONS(487),
    [sym_metavariable] = ACTIONS(485),
    [sym_raw_string_literal] = ACTIONS(485),
    [sym_float_literal] = ACTIONS(485),
    [sym_block_comment] = ACTIONS(3),
  },
  [234] = {
    [sym_identifier] = ACTIONS(433),
    [anon_sym_LPAREN] = ACTIONS(431),
    [anon_sym_RBRACE] = ACTIONS(431),
    [anon_sym_LBRACK] = ACTIONS(431),
    [anon_sym_PLUS] = ACTIONS(433),
    [anon_sym_STAR] = ACTIONS(433),
    [anon_sym_QMARK] = ACTIONS(431),
    [anon_sym_u8] = ACTIONS(433),
    [anon_sym_i8] = ACTIONS(433),
    [anon_sym_u16] = ACTIONS(433),
    [anon_sym_i16] = ACTIONS(433),
    [anon_sym_u32] = ACTIONS(433),
    [anon_sym_i32] = ACTIONS(433),
    [anon_sym_u64] = ACTIONS(433),
    [anon_sym_i64] = ACTIONS(433),
    [anon_sym_u128] = ACTIONS(433),
    [anon_sym_i128] = ACTIONS(433),
    [anon_sym_isize] = ACTIONS(433),
    [anon_sym_usize] = ACTIONS(433),
    [anon_sym_f32] = ACTIONS(433),
    [anon_sym_f64] = ACTIONS(433),
    [anon_sym_bool] = ACTIONS(433),
    [anon_sym_str] = ACTIONS(433),
    [anon_sym_char] = ACTIONS(433),
    [anon_sym_as] = ACTIONS(433),
    [anon_sym_POUND] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(433),
    [anon_sym_COMMA] = ACTIONS(431),
    [anon_sym_ref] = ACTIONS(433),
    [anon_sym_LT] = ACTIONS(433),
    [anon_sym_GT] = ACTIONS(433),
    [anon_sym_COLON_COLON] = ACTIONS(431),
    [anon_sym__] = ACTIONS(433),
    [anon_sym_AMP] = ACTIONS(433),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(431),
    [sym_mutable_specifier] = ACTIONS(433),
    [anon_sym_DOT_DOT] = ACTIONS(433),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(431),
    [anon_sym_DASH] = ACTIONS(433),
    [anon_sym_AMP_AMP] = ACTIONS(431),
    [anon_sym_PIPE_PIPE] = ACTIONS(431),
    [anon_sym_PIPE] = ACTIONS(433),
    [anon_sym_CARET] = ACTIONS(433),
    [anon_sym_EQ_EQ] = ACTIONS(431),
    [anon_sym_BANG_EQ] = ACTIONS(431),
    [anon_sym_LT_EQ] = ACTIONS(431),
    [anon_sym_GT_EQ] = ACTIONS(431),
    [anon_sym_LT_LT] = ACTIONS(433),
    [anon_sym_GT_GT] = ACTIONS(433),
    [anon_sym_SLASH] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(433),
    [anon_sym_PLUS_EQ] = ACTIONS(431),
    [anon_sym_DASH_EQ] = ACTIONS(431),
    [anon_sym_STAR_EQ] = ACTIONS(431),
    [anon_sym_SLASH_EQ] = ACTIONS(431),
    [anon_sym_PERCENT_EQ] = ACTIONS(431),
    [anon_sym_AMP_EQ] = ACTIONS(431),
    [anon_sym_PIPE_EQ] = ACTIONS(431),
    [anon_sym_CARET_EQ] = ACTIONS(431),
    [anon_sym_LT_LT_EQ] = ACTIONS(431),
    [anon_sym_GT_GT_EQ] = ACTIONS(431),
    [anon_sym_DOT] = ACTIONS(433),
    [sym_integer_literal] = ACTIONS(431),
    [aux_sym_string_literal_token1] = ACTIONS(431),
    [sym_char_literal] = ACTIONS(431),
    [anon_sym_true] = ACTIONS(433),
    [anon_sym_false] = ACTIONS(433),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(433),
    [sym_super] = ACTIONS(433),
    [sym_crate] = ACTIONS(433),
    [sym_metavariable] = ACTIONS(431),
    [sym_raw_string_literal] = ACTIONS(431),
    [sym_float_literal] = ACTIONS(431),
    [sym_block_comment] = ACTIONS(3),
  },
  [235] = {
    [sym_identifier] = ACTIONS(473),
    [anon_sym_LPAREN] = ACTIONS(471),
    [anon_sym_RBRACE] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(471),
    [anon_sym_PLUS] = ACTIONS(473),
    [anon_sym_STAR] = ACTIONS(473),
    [anon_sym_QMARK] = ACTIONS(471),
    [anon_sym_u8] = ACTIONS(473),
    [anon_sym_i8] = ACTIONS(473),
    [anon_sym_u16] = ACTIONS(473),
    [anon_sym_i16] = ACTIONS(473),
    [anon_sym_u32] = ACTIONS(473),
    [anon_sym_i32] = ACTIONS(473),
    [anon_sym_u64] = ACTIONS(473),
    [anon_sym_i64] = ACTIONS(473),
    [anon_sym_u128] = ACTIONS(473),
    [anon_sym_i128] = ACTIONS(473),
    [anon_sym_isize] = ACTIONS(473),
    [anon_sym_usize] = ACTIONS(473),
    [anon_sym_f32] = ACTIONS(473),
    [anon_sym_f64] = ACTIONS(473),
    [anon_sym_bool] = ACTIONS(473),
    [anon_sym_str] = ACTIONS(473),
    [anon_sym_char] = ACTIONS(473),
    [anon_sym_as] = ACTIONS(473),
    [anon_sym_POUND] = ACTIONS(471),
    [anon_sym_EQ] = ACTIONS(473),
    [anon_sym_COMMA] = ACTIONS(471),
    [anon_sym_ref] = ACTIONS(473),
    [anon_sym_LT] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(471),
    [anon_sym__] = ACTIONS(473),
    [anon_sym_AMP] = ACTIONS(473),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(471),
    [sym_mutable_specifier] = ACTIONS(473),
    [anon_sym_DOT_DOT] = ACTIONS(473),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(471),
    [anon_sym_DASH] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(471),
    [anon_sym_PIPE_PIPE] = ACTIONS(471),
    [anon_sym_PIPE] = ACTIONS(473),
    [anon_sym_CARET] = ACTIONS(473),
    [anon_sym_EQ_EQ] = ACTIONS(471),
    [anon_sym_BANG_EQ] = ACTIONS(471),
    [anon_sym_LT_EQ] = ACTIONS(471),
    [anon_sym_GT_EQ] = ACTIONS(471),
    [anon_sym_LT_LT] = ACTIONS(473),
    [anon_sym_GT_GT] = ACTIONS(473),
    [anon_sym_SLASH] = ACTIONS(473),
    [anon_sym_PERCENT] = ACTIONS(473),
    [anon_sym_PLUS_EQ] = ACTIONS(471),
    [anon_sym_DASH_EQ] = ACTIONS(471),
    [anon_sym_STAR_EQ] = ACTIONS(471),
    [anon_sym_SLASH_EQ] = ACTIONS(471),
    [anon_sym_PERCENT_EQ] = ACTIONS(471),
    [anon_sym_AMP_EQ] = ACTIONS(471),
    [anon_sym_PIPE_EQ] = ACTIONS(471),
    [anon_sym_CARET_EQ] = ACTIONS(471),
    [anon_sym_LT_LT_EQ] = ACTIONS(471),
    [anon_sym_GT_GT_EQ] = ACTIONS(471),
    [anon_sym_DOT] = ACTIONS(473),
    [sym_integer_literal] = ACTIONS(471),
    [aux_sym_string_literal_token1] = ACTIONS(471),
    [sym_char_literal] = ACTIONS(471),
    [anon_sym_true] = ACTIONS(473),
    [anon_sym_false] = ACTIONS(473),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(473),
    [sym_super] = ACTIONS(473),
    [sym_crate] = ACTIONS(473),
    [sym_metavariable] = ACTIONS(471),
    [sym_raw_string_literal] = ACTIONS(471),
    [sym_float_literal] = ACTIONS(471),
    [sym_block_comment] = ACTIONS(3),
  },
  [236] = {
    [sym_identifier] = ACTIONS(513),
    [anon_sym_LPAREN] = ACTIONS(511),
    [anon_sym_RBRACE] = ACTIONS(511),
    [anon_sym_LBRACK] = ACTIONS(511),
    [anon_sym_PLUS] = ACTIONS(513),
    [anon_sym_STAR] = ACTIONS(513),
    [anon_sym_QMARK] = ACTIONS(511),
    [anon_sym_u8] = ACTIONS(513),
    [anon_sym_i8] = ACTIONS(513),
    [anon_sym_u16] = ACTIONS(513),
    [anon_sym_i16] = ACTIONS(513),
    [anon_sym_u32] = ACTIONS(513),
    [anon_sym_i32] = ACTIONS(513),
    [anon_sym_u64] = ACTIONS(513),
    [anon_sym_i64] = ACTIONS(513),
    [anon_sym_u128] = ACTIONS(513),
    [anon_sym_i128] = ACTIONS(513),
    [anon_sym_isize] = ACTIONS(513),
    [anon_sym_usize] = ACTIONS(513),
    [anon_sym_f32] = ACTIONS(513),
    [anon_sym_f64] = ACTIONS(513),
    [anon_sym_bool] = ACTIONS(513),
    [anon_sym_str] = ACTIONS(513),
    [anon_sym_char] = ACTIONS(513),
    [anon_sym_as] = ACTIONS(513),
    [anon_sym_POUND] = ACTIONS(511),
    [anon_sym_EQ] = ACTIONS(513),
    [anon_sym_COMMA] = ACTIONS(511),
    [anon_sym_ref] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(513),
    [anon_sym_GT] = ACTIONS(513),
    [anon_sym_COLON_COLON] = ACTIONS(511),
    [anon_sym__] = ACTIONS(513),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(511),
    [sym_mutable_specifier] = ACTIONS(513),
    [anon_sym_DOT_DOT] = ACTIONS(513),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(511),
    [anon_sym_DASH] = ACTIONS(513),
    [anon_sym_AMP_AMP] = ACTIONS(511),
    [anon_sym_PIPE_PIPE] = ACTIONS(511),
    [anon_sym_PIPE] = ACTIONS(513),
    [anon_sym_CARET] = ACTIONS(513),
    [anon_sym_EQ_EQ] = ACTIONS(511),
    [anon_sym_BANG_EQ] = ACTIONS(511),
    [anon_sym_LT_EQ] = ACTIONS(511),
    [anon_sym_GT_EQ] = ACTIONS(511),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_GT_GT] = ACTIONS(513),
    [anon_sym_SLASH] = ACTIONS(513),
    [anon_sym_PERCENT] = ACTIONS(513),
    [anon_sym_PLUS_EQ] = ACTIONS(511),
    [anon_sym_DASH_EQ] = ACTIONS(511),
    [anon_sym_STAR_EQ] = ACTIONS(511),
    [anon_sym_SLASH_EQ] = ACTIONS(511),
    [anon_sym_PERCENT_EQ] = ACTIONS(511),
    [anon_sym_AMP_EQ] = ACTIONS(511),
    [anon_sym_PIPE_EQ] = ACTIONS(511),
    [anon_sym_CARET_EQ] = ACTIONS(511),
    [anon_sym_LT_LT_EQ] = ACTIONS(511),
    [anon_sym_GT_GT_EQ] = ACTIONS(511),
    [anon_sym_DOT] = ACTIONS(513),
    [sym_integer_literal] = ACTIONS(511),
    [aux_sym_string_literal_token1] = ACTIONS(511),
    [sym_char_literal] = ACTIONS(511),
    [anon_sym_true] = ACTIONS(513),
    [anon_sym_false] = ACTIONS(513),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(513),
    [sym_super] = ACTIONS(513),
    [sym_crate] = ACTIONS(513),
    [sym_metavariable] = ACTIONS(511),
    [sym_raw_string_literal] = ACTIONS(511),
    [sym_float_literal] = ACTIONS(511),
    [sym_block_comment] = ACTIONS(3),
  },
  [237] = {
    [sym_identifier] = ACTIONS(533),
    [anon_sym_LPAREN] = ACTIONS(531),
    [anon_sym_RBRACE] = ACTIONS(531),
    [anon_sym_LBRACK] = ACTIONS(531),
    [anon_sym_PLUS] = ACTIONS(533),
    [anon_sym_STAR] = ACTIONS(533),
    [anon_sym_QMARK] = ACTIONS(531),
    [anon_sym_u8] = ACTIONS(533),
    [anon_sym_i8] = ACTIONS(533),
    [anon_sym_u16] = ACTIONS(533),
    [anon_sym_i16] = ACTIONS(533),
    [anon_sym_u32] = ACTIONS(533),
    [anon_sym_i32] = ACTIONS(533),
    [anon_sym_u64] = ACTIONS(533),
    [anon_sym_i64] = ACTIONS(533),
    [anon_sym_u128] = ACTIONS(533),
    [anon_sym_i128] = ACTIONS(533),
    [anon_sym_isize] = ACTIONS(533),
    [anon_sym_usize] = ACTIONS(533),
    [anon_sym_f32] = ACTIONS(533),
    [anon_sym_f64] = ACTIONS(533),
    [anon_sym_bool] = ACTIONS(533),
    [anon_sym_str] = ACTIONS(533),
    [anon_sym_char] = ACTIONS(533),
    [anon_sym_as] = ACTIONS(533),
    [anon_sym_POUND] = ACTIONS(531),
    [anon_sym_EQ] = ACTIONS(533),
    [anon_sym_COMMA] = ACTIONS(531),
    [anon_sym_ref] = ACTIONS(533),
    [anon_sym_LT] = ACTIONS(533),
    [anon_sym_GT] = ACTIONS(533),
    [anon_sym_COLON_COLON] = ACTIONS(531),
    [anon_sym__] = ACTIONS(533),
    [anon_sym_AMP] = ACTIONS(533),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(531),
    [sym_mutable_specifier] = ACTIONS(533),
    [anon_sym_DOT_DOT] = ACTIONS(533),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(531),
    [anon_sym_DASH] = ACTIONS(533),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_PIPE] = ACTIONS(533),
    [anon_sym_CARET] = ACTIONS(533),
    [anon_sym_EQ_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_LT_LT] = ACTIONS(533),
    [anon_sym_GT_GT] = ACTIONS(533),
    [anon_sym_SLASH] = ACTIONS(533),
    [anon_sym_PERCENT] = ACTIONS(533),
    [anon_sym_PLUS_EQ] = ACTIONS(531),
    [anon_sym_DASH_EQ] = ACTIONS(531),
    [anon_sym_STAR_EQ] = ACTIONS(531),
    [anon_sym_SLASH_EQ] = ACTIONS(531),
    [anon_sym_PERCENT_EQ] = ACTIONS(531),
    [anon_sym_AMP_EQ] = ACTIONS(531),
    [anon_sym_PIPE_EQ] = ACTIONS(531),
    [anon_sym_CARET_EQ] = ACTIONS(531),
    [anon_sym_LT_LT_EQ] = ACTIONS(531),
    [anon_sym_GT_GT_EQ] = ACTIONS(531),
    [anon_sym_DOT] = ACTIONS(533),
    [sym_integer_literal] = ACTIONS(531),
    [aux_sym_string_literal_token1] = ACTIONS(531),
    [sym_char_literal] = ACTIONS(531),
    [anon_sym_true] = ACTIONS(533),
    [anon_sym_false] = ACTIONS(533),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(533),
    [sym_super] = ACTIONS(533),
    [sym_crate] = ACTIONS(533),
    [sym_metavariable] = ACTIONS(531),
    [sym_raw_string_literal] = ACTIONS(531),
    [sym_float_literal] = ACTIONS(531),
    [sym_block_comment] = ACTIONS(3),
  },
  [238] = {
    [sym_identifier] = ACTIONS(509),
    [anon_sym_LPAREN] = ACTIONS(507),
    [anon_sym_RBRACE] = ACTIONS(507),
    [anon_sym_LBRACK] = ACTIONS(507),
    [anon_sym_PLUS] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(509),
    [anon_sym_QMARK] = ACTIONS(507),
    [anon_sym_u8] = ACTIONS(509),
    [anon_sym_i8] = ACTIONS(509),
    [anon_sym_u16] = ACTIONS(509),
    [anon_sym_i16] = ACTIONS(509),
    [anon_sym_u32] = ACTIONS(509),
    [anon_sym_i32] = ACTIONS(509),
    [anon_sym_u64] = ACTIONS(509),
    [anon_sym_i64] = ACTIONS(509),
    [anon_sym_u128] = ACTIONS(509),
    [anon_sym_i128] = ACTIONS(509),
    [anon_sym_isize] = ACTIONS(509),
    [anon_sym_usize] = ACTIONS(509),
    [anon_sym_f32] = ACTIONS(509),
    [anon_sym_f64] = ACTIONS(509),
    [anon_sym_bool] = ACTIONS(509),
    [anon_sym_str] = ACTIONS(509),
    [anon_sym_char] = ACTIONS(509),
    [anon_sym_as] = ACTIONS(509),
    [anon_sym_POUND] = ACTIONS(507),
    [anon_sym_EQ] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(507),
    [anon_sym_ref] = ACTIONS(509),
    [anon_sym_LT] = ACTIONS(509),
    [anon_sym_GT] = ACTIONS(509),
    [anon_sym_COLON_COLON] = ACTIONS(507),
    [anon_sym__] = ACTIONS(509),
    [anon_sym_AMP] = ACTIONS(509),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(507),
    [sym_mutable_specifier] = ACTIONS(509),
    [anon_sym_DOT_DOT] = ACTIONS(509),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(507),
    [anon_sym_DASH] = ACTIONS(509),
    [anon_sym_AMP_AMP] = ACTIONS(507),
    [anon_sym_PIPE_PIPE] = ACTIONS(507),
    [anon_sym_PIPE] = ACTIONS(509),
    [anon_sym_CARET] = ACTIONS(509),
    [anon_sym_EQ_EQ] = ACTIONS(507),
    [anon_sym_BANG_EQ] = ACTIONS(507),
    [anon_sym_LT_EQ] = ACTIONS(507),
    [anon_sym_GT_EQ] = ACTIONS(507),
    [anon_sym_LT_LT] = ACTIONS(509),
    [anon_sym_GT_GT] = ACTIONS(509),
    [anon_sym_SLASH] = ACTIONS(509),
    [anon_sym_PERCENT] = ACTIONS(509),
    [anon_sym_PLUS_EQ] = ACTIONS(507),
    [anon_sym_DASH_EQ] = ACTIONS(507),
    [anon_sym_STAR_EQ] = ACTIONS(507),
    [anon_sym_SLASH_EQ] = ACTIONS(507),
    [anon_sym_PERCENT_EQ] = ACTIONS(507),
    [anon_sym_AMP_EQ] = ACTIONS(507),
    [anon_sym_PIPE_EQ] = ACTIONS(507),
    [anon_sym_CARET_EQ] = ACTIONS(507),
    [anon_sym_LT_LT_EQ] = ACTIONS(507),
    [anon_sym_GT_GT_EQ] = ACTIONS(507),
    [anon_sym_DOT] = ACTIONS(509),
    [sym_integer_literal] = ACTIONS(507),
    [aux_sym_string_literal_token1] = ACTIONS(507),
    [sym_char_literal] = ACTIONS(507),
    [anon_sym_true] = ACTIONS(509),
    [anon_sym_false] = ACTIONS(509),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(509),
    [sym_super] = ACTIONS(509),
    [sym_crate] = ACTIONS(509),
    [sym_metavariable] = ACTIONS(507),
    [sym_raw_string_literal] = ACTIONS(507),
    [sym_float_literal] = ACTIONS(507),
    [sym_block_comment] = ACTIONS(3),
  },
  [239] = {
    [sym_identifier] = ACTIONS(517),
    [anon_sym_LPAREN] = ACTIONS(515),
    [anon_sym_RBRACE] = ACTIONS(515),
    [anon_sym_LBRACK] = ACTIONS(515),
    [anon_sym_PLUS] = ACTIONS(517),
    [anon_sym_STAR] = ACTIONS(517),
    [anon_sym_QMARK] = ACTIONS(515),
    [anon_sym_u8] = ACTIONS(517),
    [anon_sym_i8] = ACTIONS(517),
    [anon_sym_u16] = ACTIONS(517),
    [anon_sym_i16] = ACTIONS(517),
    [anon_sym_u32] = ACTIONS(517),
    [anon_sym_i32] = ACTIONS(517),
    [anon_sym_u64] = ACTIONS(517),
    [anon_sym_i64] = ACTIONS(517),
    [anon_sym_u128] = ACTIONS(517),
    [anon_sym_i128] = ACTIONS(517),
    [anon_sym_isize] = ACTIONS(517),
    [anon_sym_usize] = ACTIONS(517),
    [anon_sym_f32] = ACTIONS(517),
    [anon_sym_f64] = ACTIONS(517),
    [anon_sym_bool] = ACTIONS(517),
    [anon_sym_str] = ACTIONS(517),
    [anon_sym_char] = ACTIONS(517),
    [anon_sym_as] = ACTIONS(517),
    [anon_sym_POUND] = ACTIONS(515),
    [anon_sym_EQ] = ACTIONS(517),
    [anon_sym_COMMA] = ACTIONS(515),
    [anon_sym_ref] = ACTIONS(517),
    [anon_sym_LT] = ACTIONS(517),
    [anon_sym_GT] = ACTIONS(517),
    [anon_sym_COLON_COLON] = ACTIONS(515),
    [anon_sym__] = ACTIONS(517),
    [anon_sym_AMP] = ACTIONS(517),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(515),
    [sym_mutable_specifier] = ACTIONS(517),
    [anon_sym_DOT_DOT] = ACTIONS(517),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(515),
    [anon_sym_DASH] = ACTIONS(517),
    [anon_sym_AMP_AMP] = ACTIONS(515),
    [anon_sym_PIPE_PIPE] = ACTIONS(515),
    [anon_sym_PIPE] = ACTIONS(517),
    [anon_sym_CARET] = ACTIONS(517),
    [anon_sym_EQ_EQ] = ACTIONS(515),
    [anon_sym_BANG_EQ] = ACTIONS(515),
    [anon_sym_LT_EQ] = ACTIONS(515),
    [anon_sym_GT_EQ] = ACTIONS(515),
    [anon_sym_LT_LT] = ACTIONS(517),
    [anon_sym_GT_GT] = ACTIONS(517),
    [anon_sym_SLASH] = ACTIONS(517),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_PLUS_EQ] = ACTIONS(515),
    [anon_sym_DASH_EQ] = ACTIONS(515),
    [anon_sym_STAR_EQ] = ACTIONS(515),
    [anon_sym_SLASH_EQ] = ACTIONS(515),
    [anon_sym_PERCENT_EQ] = ACTIONS(515),
    [anon_sym_AMP_EQ] = ACTIONS(515),
    [anon_sym_PIPE_EQ] = ACTIONS(515),
    [anon_sym_CARET_EQ] = ACTIONS(515),
    [anon_sym_LT_LT_EQ] = ACTIONS(515),
    [anon_sym_GT_GT_EQ] = ACTIONS(515),
    [anon_sym_DOT] = ACTIONS(517),
    [sym_integer_literal] = ACTIONS(515),
    [aux_sym_string_literal_token1] = ACTIONS(515),
    [sym_char_literal] = ACTIONS(515),
    [anon_sym_true] = ACTIONS(517),
    [anon_sym_false] = ACTIONS(517),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(517),
    [sym_super] = ACTIONS(517),
    [sym_crate] = ACTIONS(517),
    [sym_metavariable] = ACTIONS(515),
    [sym_raw_string_literal] = ACTIONS(515),
    [sym_float_literal] = ACTIONS(515),
    [sym_block_comment] = ACTIONS(3),
  },
  [240] = {
    [sym_identifier] = ACTIONS(525),
    [anon_sym_LPAREN] = ACTIONS(523),
    [anon_sym_RBRACE] = ACTIONS(523),
    [anon_sym_LBRACK] = ACTIONS(523),
    [anon_sym_PLUS] = ACTIONS(525),
    [anon_sym_STAR] = ACTIONS(525),
    [anon_sym_QMARK] = ACTIONS(523),
    [anon_sym_u8] = ACTIONS(525),
    [anon_sym_i8] = ACTIONS(525),
    [anon_sym_u16] = ACTIONS(525),
    [anon_sym_i16] = ACTIONS(525),
    [anon_sym_u32] = ACTIONS(525),
    [anon_sym_i32] = ACTIONS(525),
    [anon_sym_u64] = ACTIONS(525),
    [anon_sym_i64] = ACTIONS(525),
    [anon_sym_u128] = ACTIONS(525),
    [anon_sym_i128] = ACTIONS(525),
    [anon_sym_isize] = ACTIONS(525),
    [anon_sym_usize] = ACTIONS(525),
    [anon_sym_f32] = ACTIONS(525),
    [anon_sym_f64] = ACTIONS(525),
    [anon_sym_bool] = ACTIONS(525),
    [anon_sym_str] = ACTIONS(525),
    [anon_sym_char] = ACTIONS(525),
    [anon_sym_as] = ACTIONS(525),
    [anon_sym_POUND] = ACTIONS(523),
    [anon_sym_EQ] = ACTIONS(525),
    [anon_sym_COMMA] = ACTIONS(523),
    [anon_sym_ref] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(525),
    [anon_sym_GT] = ACTIONS(525),
    [anon_sym_COLON_COLON] = ACTIONS(523),
    [anon_sym__] = ACTIONS(525),
    [anon_sym_AMP] = ACTIONS(525),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(523),
    [sym_mutable_specifier] = ACTIONS(525),
    [anon_sym_DOT_DOT] = ACTIONS(525),
    [anon_sym_DOT_DOT_EQ] = ACTIONS(523),
    [anon_sym_DASH] = ACTIONS(525),
    [anon_sym_AMP_AMP] = ACTIONS(523),
    [anon_sym_PIPE_PIPE] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(525),
    [anon_sym_CARET] = ACTIONS(525),
    [anon_sym_EQ_EQ] = ACTIONS(523),
    [anon_sym_BANG_EQ] = ACTIONS(523),
    [anon_sym_LT_EQ] = ACTIONS(523),
    [anon_sym_GT_EQ] = ACTIONS(523),
    [anon_sym_LT_LT] = ACTIONS(525),
    [anon_sym_GT_GT] = ACTIONS(525),
    [anon_sym_SLASH] = ACTIONS(525),
    [anon_sym_PERCENT] = ACTIONS(525),
    [anon_sym_PLUS_EQ] = ACTIONS(523),
    [anon_sym_DASH_EQ] = ACTIONS(523),
    [anon_sym_STAR_EQ] = ACTIONS(523),
    [anon_sym_SLASH_EQ] = ACTIONS(523),
    [anon_sym_PERCENT_EQ] = ACTIONS(523),
    [anon_sym_AMP_EQ] = ACTIONS(523),
    [anon_sym_PIPE_EQ] = ACTIONS(523),
    [anon_sym_CARET_EQ] = ACTIONS(523),
    [anon_sym_LT_LT_EQ] = ACTIONS(523),
    [anon_sym_GT_GT_EQ] = ACTIONS(523),
    [anon_sym_DOT] = ACTIONS(525),
    [sym_integer_literal] = ACTIONS(523),
    [aux_sym_string_literal_token1] = ACTIONS(523),
    [sym_char_literal] = ACTIONS(523),
    [anon_sym_true] = ACTIONS(525),
    [anon_sym_false] = ACTIONS(525),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(525),
    [sym_super] = ACTIONS(525),
    [sym_crate] = ACTIONS(525),
    [sym_metavariable] = ACTIONS(523),
    [sym_raw_string_literal] = ACTIONS(523),
    [sym_float_literal] = ACTIONS(523),
    [sym_block_comment] = ACTIONS(3),
  },
  [241] = {
    [ts_builtin_sym_end] = ACTIONS(1291),
    [sym_identifier] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1291),
    [anon_sym_macro_rules_BANG] = ACTIONS(1291),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_LBRACE] = ACTIONS(1291),
    [anon_sym_RBRACE] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(1291),
    [anon_sym_STAR] = ACTIONS(1291),
    [anon_sym_u8] = ACTIONS(1293),
    [anon_sym_i8] = ACTIONS(1293),
    [anon_sym_u16] = ACTIONS(1293),
    [anon_sym_i16] = ACTIONS(1293),
    [anon_sym_u32] = ACTIONS(1293),
    [anon_sym_i32] = ACTIONS(1293),
    [anon_sym_u64] = ACTIONS(1293),
    [anon_sym_i64] = ACTIONS(1293),
    [anon_sym_u128] = ACTIONS(1293),
    [anon_sym_i128] = ACTIONS(1293),
    [anon_sym_isize] = ACTIONS(1293),
    [anon_sym_usize] = ACTIONS(1293),
    [anon_sym_f32] = ACTIONS(1293),
    [anon_sym_f64] = ACTIONS(1293),
    [anon_sym_bool] = ACTIONS(1293),
    [anon_sym_str] = ACTIONS(1293),
    [anon_sym_char] = ACTIONS(1293),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1293),
    [anon_sym_break] = ACTIONS(1293),
    [anon_sym_const] = ACTIONS(1293),
    [anon_sym_continue] = ACTIONS(1293),
    [anon_sym_default] = ACTIONS(1293),
    [anon_sym_enum] = ACTIONS(1293),
    [anon_sym_fn] = ACTIONS(1293),
    [anon_sym_for] = ACTIONS(1293),
    [anon_sym_if] = ACTIONS(1293),
    [anon_sym_impl] = ACTIONS(1293),
    [anon_sym_let] = ACTIONS(1293),
    [anon_sym_loop] = ACTIONS(1293),
    [anon_sym_match] = ACTIONS(1293),
    [anon_sym_mod] = ACTIONS(1293),
    [anon_sym_pub] = ACTIONS(1293),
    [anon_sym_return] = ACTIONS(1293),
    [anon_sym_static] = ACTIONS(1293),
    [anon_sym_struct] = ACTIONS(1293),
    [anon_sym_trait] = ACTIONS(1293),
    [anon_sym_type] = ACTIONS(1293),
    [anon_sym_union] = ACTIONS(1293),
    [anon_sym_unsafe] = ACTIONS(1293),
    [anon_sym_use] = ACTIONS(1293),
    [anon_sym_while] = ACTIONS(1293),
    [anon_sym_POUND] = ACTIONS(1291),
    [anon_sym_BANG] = ACTIONS(1291),
    [anon_sym_extern] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1291),
    [anon_sym_COLON_COLON] = ACTIONS(1291),
    [anon_sym_AMP] = ACTIONS(1291),
    [anon_sym_DOT_DOT] = ACTIONS(1291),
    [anon_sym_DASH] = ACTIONS(1291),
    [anon_sym_PIPE] = ACTIONS(1291),
    [anon_sym_move] = ACTIONS(1293),
    [sym_integer_literal] = ACTIONS(1291),
    [aux_sym_string_literal_token1] = ACTIONS(1291),
    [sym_char_literal] = ACTIONS(1291),
    [anon_sym_true] = ACTIONS(1293),
    [anon_sym_false] = ACTIONS(1293),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1293),
    [sym_super] = ACTIONS(1293),
    [sym_crate] = ACTIONS(1293),
    [sym_metavariable] = ACTIONS(1291),
    [sym_raw_string_literal] = ACTIONS(1291),
    [sym_float_literal] = ACTIONS(1291),
    [sym_block_comment] = ACTIONS(3),
  },
  [242] = {
    [ts_builtin_sym_end] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1297),
    [anon_sym_SEMI] = ACTIONS(1295),
    [anon_sym_macro_rules_BANG] = ACTIONS(1295),
    [anon_sym_LPAREN] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_RBRACE] = ACTIONS(1295),
    [anon_sym_LBRACK] = ACTIONS(1295),
    [anon_sym_STAR] = ACTIONS(1295),
    [anon_sym_u8] = ACTIONS(1297),
    [anon_sym_i8] = ACTIONS(1297),
    [anon_sym_u16] = ACTIONS(1297),
    [anon_sym_i16] = ACTIONS(1297),
    [anon_sym_u32] = ACTIONS(1297),
    [anon_sym_i32] = ACTIONS(1297),
    [anon_sym_u64] = ACTIONS(1297),
    [anon_sym_i64] = ACTIONS(1297),
    [anon_sym_u128] = ACTIONS(1297),
    [anon_sym_i128] = ACTIONS(1297),
    [anon_sym_isize] = ACTIONS(1297),
    [anon_sym_usize] = ACTIONS(1297),
    [anon_sym_f32] = ACTIONS(1297),
    [anon_sym_f64] = ACTIONS(1297),
    [anon_sym_bool] = ACTIONS(1297),
    [anon_sym_str] = ACTIONS(1297),
    [anon_sym_char] = ACTIONS(1297),
    [anon_sym_SQUOTE] = ACTIONS(1297),
    [anon_sym_async] = ACTIONS(1297),
    [anon_sym_break] = ACTIONS(1297),
    [anon_sym_const] = ACTIONS(1297),
    [anon_sym_continue] = ACTIONS(1297),
    [anon_sym_default] = ACTIONS(1297),
    [anon_sym_enum] = ACTIONS(1297),
    [anon_sym_fn] = ACTIONS(1297),
    [anon_sym_for] = ACTIONS(1297),
    [anon_sym_if] = ACTIONS(1297),
    [anon_sym_impl] = ACTIONS(1297),
    [anon_sym_let] = ACTIONS(1297),
    [anon_sym_loop] = ACTIONS(1297),
    [anon_sym_match] = ACTIONS(1297),
    [anon_sym_mod] = ACTIONS(1297),
    [anon_sym_pub] = ACTIONS(1297),
    [anon_sym_return] = ACTIONS(1297),
    [anon_sym_static] = ACTIONS(1297),
    [anon_sym_struct] = ACTIONS(1297),
    [anon_sym_trait] = ACTIONS(1297),
    [anon_sym_type] = ACTIONS(1297),
    [anon_sym_union] = ACTIONS(1297),
    [anon_sym_unsafe] = ACTIONS(1297),
    [anon_sym_use] = ACTIONS(1297),
    [anon_sym_while] = ACTIONS(1297),
    [anon_sym_POUND] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1295),
    [anon_sym_extern] = ACTIONS(1297),
    [anon_sym_LT] = ACTIONS(1295),
    [anon_sym_COLON_COLON] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_DOT_DOT] = ACTIONS(1295),
    [anon_sym_DASH] = ACTIONS(1295),
    [anon_sym_PIPE] = ACTIONS(1295),
    [anon_sym_move] = ACTIONS(1297),
    [sym_integer_literal] = ACTIONS(1295),
    [aux_sym_string_literal_token1] = ACTIONS(1295),
    [sym_char_literal] = ACTIONS(1295),
    [anon_sym_true] = ACTIONS(1297),
    [anon_sym_false] = ACTIONS(1297),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1297),
    [sym_super] = ACTIONS(1297),
    [sym_crate] = ACTIONS(1297),
    [sym_metavariable] = ACTIONS(1295),
    [sym_raw_string_literal] = ACTIONS(1295),
    [sym_float_literal] = ACTIONS(1295),
    [sym_block_comment] = ACTIONS(3),
  },
  [243] = {
    [ts_builtin_sym_end] = ACTIONS(1299),
    [sym_identifier] = ACTIONS(1301),
    [anon_sym_SEMI] = ACTIONS(1299),
    [anon_sym_macro_rules_BANG] = ACTIONS(1299),
    [anon_sym_LPAREN] = ACTIONS(1299),
    [anon_sym_LBRACE] = ACTIONS(1299),
    [anon_sym_RBRACE] = ACTIONS(1299),
    [anon_sym_LBRACK] = ACTIONS(1299),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_u8] = ACTIONS(1301),
    [anon_sym_i8] = ACTIONS(1301),
    [anon_sym_u16] = ACTIONS(1301),
    [anon_sym_i16] = ACTIONS(1301),
    [anon_sym_u32] = ACTIONS(1301),
    [anon_sym_i32] = ACTIONS(1301),
    [anon_sym_u64] = ACTIONS(1301),
    [anon_sym_i64] = ACTIONS(1301),
    [anon_sym_u128] = ACTIONS(1301),
    [anon_sym_i128] = ACTIONS(1301),
    [anon_sym_isize] = ACTIONS(1301),
    [anon_sym_usize] = ACTIONS(1301),
    [anon_sym_f32] = ACTIONS(1301),
    [anon_sym_f64] = ACTIONS(1301),
    [anon_sym_bool] = ACTIONS(1301),
    [anon_sym_str] = ACTIONS(1301),
    [anon_sym_char] = ACTIONS(1301),
    [anon_sym_SQUOTE] = ACTIONS(1301),
    [anon_sym_async] = ACTIONS(1301),
    [anon_sym_break] = ACTIONS(1301),
    [anon_sym_const] = ACTIONS(1301),
    [anon_sym_continue] = ACTIONS(1301),
    [anon_sym_default] = ACTIONS(1301),
    [anon_sym_enum] = ACTIONS(1301),
    [anon_sym_fn] = ACTIONS(1301),
    [anon_sym_for] = ACTIONS(1301),
    [anon_sym_if] = ACTIONS(1301),
    [anon_sym_impl] = ACTIONS(1301),
    [anon_sym_let] = ACTIONS(1301),
    [anon_sym_loop] = ACTIONS(1301),
    [anon_sym_match] = ACTIONS(1301),
    [anon_sym_mod] = ACTIONS(1301),
    [anon_sym_pub] = ACTIONS(1301),
    [anon_sym_return] = ACTIONS(1301),
    [anon_sym_static] = ACTIONS(1301),
    [anon_sym_struct] = ACTIONS(1301),
    [anon_sym_trait] = ACTIONS(1301),
    [anon_sym_type] = ACTIONS(1301),
    [anon_sym_union] = ACTIONS(1301),
    [anon_sym_unsafe] = ACTIONS(1301),
    [anon_sym_use] = ACTIONS(1301),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_POUND] = ACTIONS(1299),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_extern] = ACTIONS(1301),
    [anon_sym_LT] = ACTIONS(1299),
    [anon_sym_COLON_COLON] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_DOT_DOT] = ACTIONS(1299),
    [anon_sym_DASH] = ACTIONS(1299),
    [anon_sym_PIPE] = ACTIONS(1299),
    [anon_sym_move] = ACTIONS(1301),
    [sym_integer_literal] = ACTIONS(1299),
    [aux_sym_string_literal_token1] = ACTIONS(1299),
    [sym_char_literal] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(1301),
    [anon_sym_false] = ACTIONS(1301),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1301),
    [sym_super] = ACTIONS(1301),
    [sym_crate] = ACTIONS(1301),
    [sym_metavariable] = ACTIONS(1299),
    [sym_raw_string_literal] = ACTIONS(1299),
    [sym_float_literal] = ACTIONS(1299),
    [sym_block_comment] = ACTIONS(3),
  },
  [244] = {
    [ts_builtin_sym_end] = ACTIONS(1303),
    [sym_identifier] = ACTIONS(1305),
    [anon_sym_SEMI] = ACTIONS(1303),
    [anon_sym_macro_rules_BANG] = ACTIONS(1303),
    [anon_sym_LPAREN] = ACTIONS(1303),
    [anon_sym_LBRACE] = ACTIONS(1303),
    [anon_sym_RBRACE] = ACTIONS(1303),
    [anon_sym_LBRACK] = ACTIONS(1303),
    [anon_sym_STAR] = ACTIONS(1303),
    [anon_sym_u8] = ACTIONS(1305),
    [anon_sym_i8] = ACTIONS(1305),
    [anon_sym_u16] = ACTIONS(1305),
    [anon_sym_i16] = ACTIONS(1305),
    [anon_sym_u32] = ACTIONS(1305),
    [anon_sym_i32] = ACTIONS(1305),
    [anon_sym_u64] = ACTIONS(1305),
    [anon_sym_i64] = ACTIONS(1305),
    [anon_sym_u128] = ACTIONS(1305),
    [anon_sym_i128] = ACTIONS(1305),
    [anon_sym_isize] = ACTIONS(1305),
    [anon_sym_usize] = ACTIONS(1305),
    [anon_sym_f32] = ACTIONS(1305),
    [anon_sym_f64] = ACTIONS(1305),
    [anon_sym_bool] = ACTIONS(1305),
    [anon_sym_str] = ACTIONS(1305),
    [anon_sym_char] = ACTIONS(1305),
    [anon_sym_SQUOTE] = ACTIONS(1305),
    [anon_sym_async] = ACTIONS(1305),
    [anon_sym_break] = ACTIONS(1305),
    [anon_sym_const] = ACTIONS(1305),
    [anon_sym_continue] = ACTIONS(1305),
    [anon_sym_default] = ACTIONS(1305),
    [anon_sym_enum] = ACTIONS(1305),
    [anon_sym_fn] = ACTIONS(1305),
    [anon_sym_for] = ACTIONS(1305),
    [anon_sym_if] = ACTIONS(1305),
    [anon_sym_impl] = ACTIONS(1305),
    [anon_sym_let] = ACTIONS(1305),
    [anon_sym_loop] = ACTIONS(1305),
    [anon_sym_match] = ACTIONS(1305),
    [anon_sym_mod] = ACTIONS(1305),
    [anon_sym_pub] = ACTIONS(1305),
    [anon_sym_return] = ACTIONS(1305),
    [anon_sym_static] = ACTIONS(1305),
    [anon_sym_struct] = ACTIONS(1305),
    [anon_sym_trait] = ACTIONS(1305),
    [anon_sym_type] = ACTIONS(1305),
    [anon_sym_union] = ACTIONS(1305),
    [anon_sym_unsafe] = ACTIONS(1305),
    [anon_sym_use] = ACTIONS(1305),
    [anon_sym_while] = ACTIONS(1305),
    [anon_sym_POUND] = ACTIONS(1303),
    [anon_sym_BANG] = ACTIONS(1303),
    [anon_sym_extern] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1303),
    [anon_sym_COLON_COLON] = ACTIONS(1303),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_DOT_DOT] = ACTIONS(1303),
    [anon_sym_DASH] = ACTIONS(1303),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_move] = ACTIONS(1305),
    [sym_integer_literal] = ACTIONS(1303),
    [aux_sym_string_literal_token1] = ACTIONS(1303),
    [sym_char_literal] = ACTIONS(1303),
    [anon_sym_true] = ACTIONS(1305),
    [anon_sym_false] = ACTIONS(1305),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1305),
    [sym_super] = ACTIONS(1305),
    [sym_crate] = ACTIONS(1305),
    [sym_metavariable] = ACTIONS(1303),
    [sym_raw_string_literal] = ACTIONS(1303),
    [sym_float_literal] = ACTIONS(1303),
    [sym_block_comment] = ACTIONS(3),
  },
  [245] = {
    [ts_builtin_sym_end] = ACTIONS(1307),
    [sym_identifier] = ACTIONS(1309),
    [anon_sym_SEMI] = ACTIONS(1307),
    [anon_sym_macro_rules_BANG] = ACTIONS(1307),
    [anon_sym_LPAREN] = ACTIONS(1307),
    [anon_sym_LBRACE] = ACTIONS(1307),
    [anon_sym_RBRACE] = ACTIONS(1307),
    [anon_sym_LBRACK] = ACTIONS(1307),
    [anon_sym_STAR] = ACTIONS(1307),
    [anon_sym_u8] = ACTIONS(1309),
    [anon_sym_i8] = ACTIONS(1309),
    [anon_sym_u16] = ACTIONS(1309),
    [anon_sym_i16] = ACTIONS(1309),
    [anon_sym_u32] = ACTIONS(1309),
    [anon_sym_i32] = ACTIONS(1309),
    [anon_sym_u64] = ACTIONS(1309),
    [anon_sym_i64] = ACTIONS(1309),
    [anon_sym_u128] = ACTIONS(1309),
    [anon_sym_i128] = ACTIONS(1309),
    [anon_sym_isize] = ACTIONS(1309),
    [anon_sym_usize] = ACTIONS(1309),
    [anon_sym_f32] = ACTIONS(1309),
    [anon_sym_f64] = ACTIONS(1309),
    [anon_sym_bool] = ACTIONS(1309),
    [anon_sym_str] = ACTIONS(1309),
    [anon_sym_char] = ACTIONS(1309),
    [anon_sym_SQUOTE] = ACTIONS(1309),
    [anon_sym_async] = ACTIONS(1309),
    [anon_sym_break] = ACTIONS(1309),
    [anon_sym_const] = ACTIONS(1309),
    [anon_sym_continue] = ACTIONS(1309),
    [anon_sym_default] = ACTIONS(1309),
    [anon_sym_enum] = ACTIONS(1309),
    [anon_sym_fn] = ACTIONS(1309),
    [anon_sym_for] = ACTIONS(1309),
    [anon_sym_if] = ACTIONS(1309),
    [anon_sym_impl] = ACTIONS(1309),
    [anon_sym_let] = ACTIONS(1309),
    [anon_sym_loop] = ACTIONS(1309),
    [anon_sym_match] = ACTIONS(1309),
    [anon_sym_mod] = ACTIONS(1309),
    [anon_sym_pub] = ACTIONS(1309),
    [anon_sym_return] = ACTIONS(1309),
    [anon_sym_static] = ACTIONS(1309),
    [anon_sym_struct] = ACTIONS(1309),
    [anon_sym_trait] = ACTIONS(1309),
    [anon_sym_type] = ACTIONS(1309),
    [anon_sym_union] = ACTIONS(1309),
    [anon_sym_unsafe] = ACTIONS(1309),
    [anon_sym_use] = ACTIONS(1309),
    [anon_sym_while] = ACTIONS(1309),
    [anon_sym_POUND] = ACTIONS(1307),
    [anon_sym_BANG] = ACTIONS(1307),
    [anon_sym_extern] = ACTIONS(1309),
    [anon_sym_LT] = ACTIONS(1307),
    [anon_sym_COLON_COLON] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(1307),
    [anon_sym_DOT_DOT] = ACTIONS(1307),
    [anon_sym_DASH] = ACTIONS(1307),
    [anon_sym_PIPE] = ACTIONS(1307),
    [anon_sym_move] = ACTIONS(1309),
    [sym_integer_literal] = ACTIONS(1307),
    [aux_sym_string_literal_token1] = ACTIONS(1307),
    [sym_char_literal] = ACTIONS(1307),
    [anon_sym_true] = ACTIONS(1309),
    [anon_sym_false] = ACTIONS(1309),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1309),
    [sym_super] = ACTIONS(1309),
    [sym_crate] = ACTIONS(1309),
    [sym_metavariable] = ACTIONS(1307),
    [sym_raw_string_literal] = ACTIONS(1307),
    [sym_float_literal] = ACTIONS(1307),
    [sym_block_comment] = ACTIONS(3),
  },
  [246] = {
    [sym__token_pattern] = STATE(209),
    [sym_token_tree_pattern] = STATE(209),
    [sym_token_binding_pattern] = STATE(209),
    [sym_token_repetition_pattern] = STATE(209),
    [sym__literal] = STATE(209),
    [sym_string_literal] = STATE(209),
    [sym_boolean_literal] = STATE(209),
    [aux_sym_token_tree_pattern_repeat1] = STATE(209),
    [sym_identifier] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_RPAREN] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_DOLLAR] = ACTIONS(1321),
    [anon_sym_u8] = ACTIONS(1323),
    [anon_sym_i8] = ACTIONS(1323),
    [anon_sym_u16] = ACTIONS(1323),
    [anon_sym_i16] = ACTIONS(1323),
    [anon_sym_u32] = ACTIONS(1323),
    [anon_sym_i32] = ACTIONS(1323),
    [anon_sym_u64] = ACTIONS(1323),
    [anon_sym_i64] = ACTIONS(1323),
    [anon_sym_u128] = ACTIONS(1323),
    [anon_sym_i128] = ACTIONS(1323),
    [anon_sym_isize] = ACTIONS(1323),
    [anon_sym_usize] = ACTIONS(1323),
    [anon_sym_f32] = ACTIONS(1323),
    [anon_sym_f64] = ACTIONS(1323),
    [anon_sym_bool] = ACTIONS(1323),
    [anon_sym_str] = ACTIONS(1323),
    [anon_sym_char] = ACTIONS(1323),
    [aux_sym__non_special_token_token1] = ACTIONS(1311),
    [anon_sym_SQUOTE] = ACTIONS(1311),
    [anon_sym_as] = ACTIONS(1311),
    [anon_sym_async] = ACTIONS(1311),
    [anon_sym_await] = ACTIONS(1311),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_const] = ACTIONS(1311),
    [anon_sym_continue] = ACTIONS(1311),
    [anon_sym_default] = ACTIONS(1311),
    [anon_sym_enum] = ACTIONS(1311),
    [anon_sym_fn] = ACTIONS(1311),
    [anon_sym_for] = ACTIONS(1311),
    [anon_sym_if] = ACTIONS(1311),
    [anon_sym_impl] = ACTIONS(1311),
    [anon_sym_let] = ACTIONS(1311),
    [anon_sym_loop] = ACTIONS(1311),
    [anon_sym_match] = ACTIONS(1311),
    [anon_sym_mod] = ACTIONS(1311),
    [anon_sym_pub] = ACTIONS(1311),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_struct] = ACTIONS(1311),
    [anon_sym_trait] = ACTIONS(1311),
    [anon_sym_type] = ACTIONS(1311),
    [anon_sym_union] = ACTIONS(1311),
    [anon_sym_unsafe] = ACTIONS(1311),
    [anon_sym_use] = ACTIONS(1311),
    [anon_sym_where] = ACTIONS(1311),
    [anon_sym_while] = ACTIONS(1311),
    [sym_mutable_specifier] = ACTIONS(1311),
    [sym_integer_literal] = ACTIONS(1325),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(1325),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(1311),
    [sym_super] = ACTIONS(1311),
    [sym_crate] = ACTIONS(1311),
    [sym_metavariable] = ACTIONS(1331),
    [sym_raw_string_literal] = ACTIONS(1325),
    [sym_float_literal] = ACTIONS(1325),
    [sym_block_comment] = ACTIONS(3),
  },
  [247] = {
    [ts_builtin_sym_end] = ACTIONS(1333),
    [sym_identifier] = ACTIONS(1335),
    [anon_sym_SEMI] = ACTIONS(1333),
    [anon_sym_macro_rules_BANG] = ACTIONS(1333),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_LBRACE] = ACTIONS(1333),
    [anon_sym_RBRACE] = ACTIONS(1333),
    [anon_sym_LBRACK] = ACTIONS(1333),
    [anon_sym_STAR] = ACTIONS(1333),
    [anon_sym_u8] = ACTIONS(1335),
    [anon_sym_i8] = ACTIONS(1335),
    [anon_sym_u16] = ACTIONS(1335),
    [anon_sym_i16] = ACTIONS(1335),
    [anon_sym_u32] = ACTIONS(1335),
    [anon_sym_i32] = ACTIONS(1335),
    [anon_sym_u64] = ACTIONS(1335),
    [anon_sym_i64] = ACTIONS(1335),
    [anon_sym_u128] = ACTIONS(1335),
    [anon_sym_i128] = ACTIONS(1335),
    [anon_sym_isize] = ACTIONS(1335),
    [anon_sym_usize] = ACTIONS(1335),
    [anon_sym_f32] = ACTIONS(1335),
    [anon_sym_f64] = ACTIONS(1335),
    [anon_sym_bool] = ACTIONS(1335),
    [anon_sym_str] = ACTIONS(1335),
    [anon_sym_char] = ACTIONS(1335),
    [anon_sym_SQUOTE] = ACTIONS(1335),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_break] = ACTIONS(1335),
    [anon_sym_const] = ACTIONS(1335),
    [anon_sym_continue] = ACTIONS(1335),
    [anon_sym_default] = ACTIONS(1335),
    [anon_sym_enum] = ACTIONS(1335),
    [anon_sym_fn] = ACTIONS(1335),
    [anon_sym_for] = ACTIONS(1335),
    [anon_sym_if] = ACTIONS(1335),
    [anon_sym_impl] = ACTIONS(1335),
    [anon_sym_let] = ACTIONS(1335),
    [anon_sym_loop] = ACTIONS(1335),
    [anon_sym_match] = ACTIONS(1335),
    [anon_sym_mod] = ACTIONS(1335),
    [anon_sym_pub] = ACTIONS(1335),
    [anon_sym_return] = ACTIONS(1335),
    [anon_sym_static] = ACTIONS(1335),
    [anon_sym_struct] = ACTIONS(1335),
    [anon_sym_trait] = ACTIONS(1335),
    [anon_sym_type] = ACTIONS(1335),
    [anon_sym_union] = ACTIONS(1335),
    [anon_sym_unsafe] = ACTIONS(1335),
    [anon_sym_use] = ACTIONS(1335),
    [anon_sym_while] = ACTIONS(1335),
    [anon_sym_POUND] = ACTIONS(1333),
    [anon_sym_BANG] = ACTIONS(1333),
    [anon_sym_extern] = ACTIONS(1335),
    [anon_sym_LT] = ACTIONS(1333),
    [anon_sym_COLON_COLON] = ACTIONS(1333),
    [anon_sym_AMP] = ACTIONS(1333),
    [anon_sym_DOT_DOT] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1333),
    [anon_sym_move] = ACTIONS(1335),
    [sym_integer_literal] = ACTIONS(1333),
    [aux_sym_string_literal_token1] = ACTIONS(1333),
    [sym_char_literal] = ACTIONS(1333),
    [anon_sym_true] = ACTIONS(1335),
    [anon_sym_false] = ACTIONS(1335),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1335),
    [sym_super] = ACTIONS(1335),
    [sym_crate] = ACTIONS(1335),
    [sym_metavariable] = ACTIONS(1333),
    [sym_raw_string_literal] = ACTIONS(1333),
    [sym_float_literal] = ACTIONS(1333),
    [sym_block_comment] = ACTIONS(3),
  },
  [248] = {
    [ts_builtin_sym_end] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1339),
    [anon_sym_SEMI] = ACTIONS(1337),
    [anon_sym_macro_rules_BANG] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(1337),
    [anon_sym_LBRACE] = ACTIONS(1337),
    [anon_sym_RBRACE] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(1337),
    [anon_sym_STAR] = ACTIONS(1337),
    [anon_sym_u8] = ACTIONS(1339),
    [anon_sym_i8] = ACTIONS(1339),
    [anon_sym_u16] = ACTIONS(1339),
    [anon_sym_i16] = ACTIONS(1339),
    [anon_sym_u32] = ACTIONS(1339),
    [anon_sym_i32] = ACTIONS(1339),
    [anon_sym_u64] = ACTIONS(1339),
    [anon_sym_i64] = ACTIONS(1339),
    [anon_sym_u128] = ACTIONS(1339),
    [anon_sym_i128] = ACTIONS(1339),
    [anon_sym_isize] = ACTIONS(1339),
    [anon_sym_usize] = ACTIONS(1339),
    [anon_sym_f32] = ACTIONS(1339),
    [anon_sym_f64] = ACTIONS(1339),
    [anon_sym_bool] = ACTIONS(1339),
    [anon_sym_str] = ACTIONS(1339),
    [anon_sym_char] = ACTIONS(1339),
    [anon_sym_SQUOTE] = ACTIONS(1339),
    [anon_sym_async] = ACTIONS(1339),
    [anon_sym_break] = ACTIONS(1339),
    [anon_sym_const] = ACTIONS(1339),
    [anon_sym_continue] = ACTIONS(1339),
    [anon_sym_default] = ACTIONS(1339),
    [anon_sym_enum] = ACTIONS(1339),
    [anon_sym_fn] = ACTIONS(1339),
    [anon_sym_for] = ACTIONS(1339),
    [anon_sym_if] = ACTIONS(1339),
    [anon_sym_impl] = ACTIONS(1339),
    [anon_sym_let] = ACTIONS(1339),
    [anon_sym_loop] = ACTIONS(1339),
    [anon_sym_match] = ACTIONS(1339),
    [anon_sym_mod] = ACTIONS(1339),
    [anon_sym_pub] = ACTIONS(1339),
    [anon_sym_return] = ACTIONS(1339),
    [anon_sym_static] = ACTIONS(1339),
    [anon_sym_struct] = ACTIONS(1339),
    [anon_sym_trait] = ACTIONS(1339),
    [anon_sym_type] = ACTIONS(1339),
    [anon_sym_union] = ACTIONS(1339),
    [anon_sym_unsafe] = ACTIONS(1339),
    [anon_sym_use] = ACTIONS(1339),
    [anon_sym_while] = ACTIONS(1339),
    [anon_sym_POUND] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(1337),
    [anon_sym_extern] = ACTIONS(1339),
    [anon_sym_LT] = ACTIONS(1337),
    [anon_sym_COLON_COLON] = ACTIONS(1337),
    [anon_sym_AMP] = ACTIONS(1337),
    [anon_sym_DOT_DOT] = ACTIONS(1337),
    [anon_sym_DASH] = ACTIONS(1337),
    [anon_sym_PIPE] = ACTIONS(1337),
    [anon_sym_move] = ACTIONS(1339),
    [sym_integer_literal] = ACTIONS(1337),
    [aux_sym_string_literal_token1] = ACTIONS(1337),
    [sym_char_literal] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(1339),
    [anon_sym_false] = ACTIONS(1339),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1339),
    [sym_super] = ACTIONS(1339),
    [sym_crate] = ACTIONS(1339),
    [sym_metavariable] = ACTIONS(1337),
    [sym_raw_string_literal] = ACTIONS(1337),
    [sym_float_literal] = ACTIONS(1337),
    [sym_block_comment] = ACTIONS(3),
  },
  [249] = {
    [ts_builtin_sym_end] = ACTIONS(1341),
    [sym_identifier] = ACTIONS(1343),
    [anon_sym_SEMI] = ACTIONS(1341),
    [anon_sym_macro_rules_BANG] = ACTIONS(1341),
    [anon_sym_LPAREN] = ACTIONS(1341),
    [anon_sym_LBRACE] = ACTIONS(1341),
    [anon_sym_RBRACE] = ACTIONS(1341),
    [anon_sym_LBRACK] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1341),
    [anon_sym_u8] = ACTIONS(1343),
    [anon_sym_i8] = ACTIONS(1343),
    [anon_sym_u16] = ACTIONS(1343),
    [anon_sym_i16] = ACTIONS(1343),
    [anon_sym_u32] = ACTIONS(1343),
    [anon_sym_i32] = ACTIONS(1343),
    [anon_sym_u64] = ACTIONS(1343),
    [anon_sym_i64] = ACTIONS(1343),
    [anon_sym_u128] = ACTIONS(1343),
    [anon_sym_i128] = ACTIONS(1343),
    [anon_sym_isize] = ACTIONS(1343),
    [anon_sym_usize] = ACTIONS(1343),
    [anon_sym_f32] = ACTIONS(1343),
    [anon_sym_f64] = ACTIONS(1343),
    [anon_sym_bool] = ACTIONS(1343),
    [anon_sym_str] = ACTIONS(1343),
    [anon_sym_char] = ACTIONS(1343),
    [anon_sym_SQUOTE] = ACTIONS(1343),
    [anon_sym_async] = ACTIONS(1343),
    [anon_sym_break] = ACTIONS(1343),
    [anon_sym_const] = ACTIONS(1343),
    [anon_sym_continue] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(1343),
    [anon_sym_enum] = ACTIONS(1343),
    [anon_sym_fn] = ACTIONS(1343),
    [anon_sym_for] = ACTIONS(1343),
    [anon_sym_if] = ACTIONS(1343),
    [anon_sym_impl] = ACTIONS(1343),
    [anon_sym_let] = ACTIONS(1343),
    [anon_sym_loop] = ACTIONS(1343),
    [anon_sym_match] = ACTIONS(1343),
    [anon_sym_mod] = ACTIONS(1343),
    [anon_sym_pub] = ACTIONS(1343),
    [anon_sym_return] = ACTIONS(1343),
    [anon_sym_static] = ACTIONS(1343),
    [anon_sym_struct] = ACTIONS(1343),
    [anon_sym_trait] = ACTIONS(1343),
    [anon_sym_type] = ACTIONS(1343),
    [anon_sym_union] = ACTIONS(1343),
    [anon_sym_unsafe] = ACTIONS(1343),
    [anon_sym_use] = ACTIONS(1343),
    [anon_sym_while] = ACTIONS(1343),
    [anon_sym_POUND] = ACTIONS(1341),
    [anon_sym_BANG] = ACTIONS(1341),
    [anon_sym_extern] = ACTIONS(1343),
    [anon_sym_LT] = ACTIONS(1341),
    [anon_sym_COLON_COLON] = ACTIONS(1341),
    [anon_sym_AMP] = ACTIONS(1341),
    [anon_sym_DOT_DOT] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_move] = ACTIONS(1343),
    [sym_integer_literal] = ACTIONS(1341),
    [aux_sym_string_literal_token1] = ACTIONS(1341),
    [sym_char_literal] = ACTIONS(1341),
    [anon_sym_true] = ACTIONS(1343),
    [anon_sym_false] = ACTIONS(1343),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1343),
    [sym_super] = ACTIONS(1343),
    [sym_crate] = ACTIONS(1343),
    [sym_metavariable] = ACTIONS(1341),
    [sym_raw_string_literal] = ACTIONS(1341),
    [sym_float_literal] = ACTIONS(1341),
    [sym_block_comment] = ACTIONS(3),
  },
  [250] = {
    [ts_builtin_sym_end] = ACTIONS(1345),
    [sym_identifier] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(1345),
    [anon_sym_macro_rules_BANG] = ACTIONS(1345),
    [anon_sym_LPAREN] = ACTIONS(1345),
    [anon_sym_LBRACE] = ACTIONS(1345),
    [anon_sym_RBRACE] = ACTIONS(1345),
    [anon_sym_LBRACK] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1345),
    [anon_sym_u8] = ACTIONS(1347),
    [anon_sym_i8] = ACTIONS(1347),
    [anon_sym_u16] = ACTIONS(1347),
    [anon_sym_i16] = ACTIONS(1347),
    [anon_sym_u32] = ACTIONS(1347),
    [anon_sym_i32] = ACTIONS(1347),
    [anon_sym_u64] = ACTIONS(1347),
    [anon_sym_i64] = ACTIONS(1347),
    [anon_sym_u128] = ACTIONS(1347),
    [anon_sym_i128] = ACTIONS(1347),
    [anon_sym_isize] = ACTIONS(1347),
    [anon_sym_usize] = ACTIONS(1347),
    [anon_sym_f32] = ACTIONS(1347),
    [anon_sym_f64] = ACTIONS(1347),
    [anon_sym_bool] = ACTIONS(1347),
    [anon_sym_str] = ACTIONS(1347),
    [anon_sym_char] = ACTIONS(1347),
    [anon_sym_SQUOTE] = ACTIONS(1347),
    [anon_sym_async] = ACTIONS(1347),
    [anon_sym_break] = ACTIONS(1347),
    [anon_sym_const] = ACTIONS(1347),
    [anon_sym_continue] = ACTIONS(1347),
    [anon_sym_default] = ACTIONS(1347),
    [anon_sym_enum] = ACTIONS(1347),
    [anon_sym_fn] = ACTIONS(1347),
    [anon_sym_for] = ACTIONS(1347),
    [anon_sym_if] = ACTIONS(1347),
    [anon_sym_impl] = ACTIONS(1347),
    [anon_sym_let] = ACTIONS(1347),
    [anon_sym_loop] = ACTIONS(1347),
    [anon_sym_match] = ACTIONS(1347),
    [anon_sym_mod] = ACTIONS(1347),
    [anon_sym_pub] = ACTIONS(1347),
    [anon_sym_return] = ACTIONS(1347),
    [anon_sym_static] = ACTIONS(1347),
    [anon_sym_struct] = ACTIONS(1347),
    [anon_sym_trait] = ACTIONS(1347),
    [anon_sym_type] = ACTIONS(1347),
    [anon_sym_union] = ACTIONS(1347),
    [anon_sym_unsafe] = ACTIONS(1347),
    [anon_sym_use] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1347),
    [anon_sym_POUND] = ACTIONS(1345),
    [anon_sym_BANG] = ACTIONS(1345),
    [anon_sym_extern] = ACTIONS(1347),
    [anon_sym_LT] = ACTIONS(1345),
    [anon_sym_COLON_COLON] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1345),
    [anon_sym_DOT_DOT] = ACTIONS(1345),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_PIPE] = ACTIONS(1345),
    [anon_sym_move] = ACTIONS(1347),
    [sym_integer_literal] = ACTIONS(1345),
    [aux_sym_string_literal_token1] = ACTIONS(1345),
    [sym_char_literal] = ACTIONS(1345),
    [anon_sym_true] = ACTIONS(1347),
    [anon_sym_false] = ACTIONS(1347),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1347),
    [sym_super] = ACTIONS(1347),
    [sym_crate] = ACTIONS(1347),
    [sym_metavariable] = ACTIONS(1345),
    [sym_raw_string_literal] = ACTIONS(1345),
    [sym_float_literal] = ACTIONS(1345),
    [sym_block_comment] = ACTIONS(3),
  },
  [251] = {
    [ts_builtin_sym_end] = ACTIONS(1349),
    [sym_identifier] = ACTIONS(1351),
    [anon_sym_SEMI] = ACTIONS(1349),
    [anon_sym_macro_rules_BANG] = ACTIONS(1349),
    [anon_sym_LPAREN] = ACTIONS(1349),
    [anon_sym_LBRACE] = ACTIONS(1349),
    [anon_sym_RBRACE] = ACTIONS(1349),
    [anon_sym_LBRACK] = ACTIONS(1349),
    [anon_sym_STAR] = ACTIONS(1349),
    [anon_sym_u8] = ACTIONS(1351),
    [anon_sym_i8] = ACTIONS(1351),
    [anon_sym_u16] = ACTIONS(1351),
    [anon_sym_i16] = ACTIONS(1351),
    [anon_sym_u32] = ACTIONS(1351),
    [anon_sym_i32] = ACTIONS(1351),
    [anon_sym_u64] = ACTIONS(1351),
    [anon_sym_i64] = ACTIONS(1351),
    [anon_sym_u128] = ACTIONS(1351),
    [anon_sym_i128] = ACTIONS(1351),
    [anon_sym_isize] = ACTIONS(1351),
    [anon_sym_usize] = ACTIONS(1351),
    [anon_sym_f32] = ACTIONS(1351),
    [anon_sym_f64] = ACTIONS(1351),
    [anon_sym_bool] = ACTIONS(1351),
    [anon_sym_str] = ACTIONS(1351),
    [anon_sym_char] = ACTIONS(1351),
    [anon_sym_SQUOTE] = ACTIONS(1351),
    [anon_sym_async] = ACTIONS(1351),
    [anon_sym_break] = ACTIONS(1351),
    [anon_sym_const] = ACTIONS(1351),
    [anon_sym_continue] = ACTIONS(1351),
    [anon_sym_default] = ACTIONS(1351),
    [anon_sym_enum] = ACTIONS(1351),
    [anon_sym_fn] = ACTIONS(1351),
    [anon_sym_for] = ACTIONS(1351),
    [anon_sym_if] = ACTIONS(1351),
    [anon_sym_impl] = ACTIONS(1351),
    [anon_sym_let] = ACTIONS(1351),
    [anon_sym_loop] = ACTIONS(1351),
    [anon_sym_match] = ACTIONS(1351),
    [anon_sym_mod] = ACTIONS(1351),
    [anon_sym_pub] = ACTIONS(1351),
    [anon_sym_return] = ACTIONS(1351),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_struct] = ACTIONS(1351),
    [anon_sym_trait] = ACTIONS(1351),
    [anon_sym_type] = ACTIONS(1351),
    [anon_sym_union] = ACTIONS(1351),
    [anon_sym_unsafe] = ACTIONS(1351),
    [anon_sym_use] = ACTIONS(1351),
    [anon_sym_while] = ACTIONS(1351),
    [anon_sym_POUND] = ACTIONS(1349),
    [anon_sym_BANG] = ACTIONS(1349),
    [anon_sym_extern] = ACTIONS(1351),
    [anon_sym_LT] = ACTIONS(1349),
    [anon_sym_COLON_COLON] = ACTIONS(1349),
    [anon_sym_AMP] = ACTIONS(1349),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym_DASH] = ACTIONS(1349),
    [anon_sym_PIPE] = ACTIONS(1349),
    [anon_sym_move] = ACTIONS(1351),
    [sym_integer_literal] = ACTIONS(1349),
    [aux_sym_string_literal_token1] = ACTIONS(1349),
    [sym_char_literal] = ACTIONS(1349),
    [anon_sym_true] = ACTIONS(1351),
    [anon_sym_false] = ACTIONS(1351),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1351),
    [sym_super] = ACTIONS(1351),
    [sym_crate] = ACTIONS(1351),
    [sym_metavariable] = ACTIONS(1349),
    [sym_raw_string_literal] = ACTIONS(1349),
    [sym_float_literal] = ACTIONS(1349),
    [sym_block_comment] = ACTIONS(3),
  },
  [252] = {
    [ts_builtin_sym_end] = ACTIONS(1353),
    [sym_identifier] = ACTIONS(1355),
    [anon_sym_SEMI] = ACTIONS(1353),
    [anon_sym_macro_rules_BANG] = ACTIONS(1353),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_LBRACE] = ACTIONS(1353),
    [anon_sym_RBRACE] = ACTIONS(1353),
    [anon_sym_LBRACK] = ACTIONS(1353),
    [anon_sym_STAR] = ACTIONS(1353),
    [anon_sym_u8] = ACTIONS(1355),
    [anon_sym_i8] = ACTIONS(1355),
    [anon_sym_u16] = ACTIONS(1355),
    [anon_sym_i16] = ACTIONS(1355),
    [anon_sym_u32] = ACTIONS(1355),
    [anon_sym_i32] = ACTIONS(1355),
    [anon_sym_u64] = ACTIONS(1355),
    [anon_sym_i64] = ACTIONS(1355),
    [anon_sym_u128] = ACTIONS(1355),
    [anon_sym_i128] = ACTIONS(1355),
    [anon_sym_isize] = ACTIONS(1355),
    [anon_sym_usize] = ACTIONS(1355),
    [anon_sym_f32] = ACTIONS(1355),
    [anon_sym_f64] = ACTIONS(1355),
    [anon_sym_bool] = ACTIONS(1355),
    [anon_sym_str] = ACTIONS(1355),
    [anon_sym_char] = ACTIONS(1355),
    [anon_sym_SQUOTE] = ACTIONS(1355),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_break] = ACTIONS(1355),
    [anon_sym_const] = ACTIONS(1355),
    [anon_sym_continue] = ACTIONS(1355),
    [anon_sym_default] = ACTIONS(1355),
    [anon_sym_enum] = ACTIONS(1355),
    [anon_sym_fn] = ACTIONS(1355),
    [anon_sym_for] = ACTIONS(1355),
    [anon_sym_if] = ACTIONS(1355),
    [anon_sym_impl] = ACTIONS(1355),
    [anon_sym_let] = ACTIONS(1355),
    [anon_sym_loop] = ACTIONS(1355),
    [anon_sym_match] = ACTIONS(1355),
    [anon_sym_mod] = ACTIONS(1355),
    [anon_sym_pub] = ACTIONS(1355),
    [anon_sym_return] = ACTIONS(1355),
    [anon_sym_static] = ACTIONS(1355),
    [anon_sym_struct] = ACTIONS(1355),
    [anon_sym_trait] = ACTIONS(1355),
    [anon_sym_type] = ACTIONS(1355),
    [anon_sym_union] = ACTIONS(1355),
    [anon_sym_unsafe] = ACTIONS(1355),
    [anon_sym_use] = ACTIONS(1355),
    [anon_sym_while] = ACTIONS(1355),
    [anon_sym_POUND] = ACTIONS(1353),
    [anon_sym_BANG] = ACTIONS(1353),
    [anon_sym_extern] = ACTIONS(1355),
    [anon_sym_LT] = ACTIONS(1353),
    [anon_sym_COLON_COLON] = ACTIONS(1353),
    [anon_sym_AMP] = ACTIONS(1353),
    [anon_sym_DOT_DOT] = ACTIONS(1353),
    [anon_sym_DASH] = ACTIONS(1353),
    [anon_sym_PIPE] = ACTIONS(1353),
    [anon_sym_move] = ACTIONS(1355),
    [sym_integer_literal] = ACTIONS(1353),
    [aux_sym_string_literal_token1] = ACTIONS(1353),
    [sym_char_literal] = ACTIONS(1353),
    [anon_sym_true] = ACTIONS(1355),
    [anon_sym_false] = ACTIONS(1355),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1355),
    [sym_super] = ACTIONS(1355),
    [sym_crate] = ACTIONS(1355),
    [sym_metavariable] = ACTIONS(1353),
    [sym_raw_string_literal] = ACTIONS(1353),
    [sym_float_literal] = ACTIONS(1353),
    [sym_block_comment] = ACTIONS(3),
  },
  [253] = {
    [ts_builtin_sym_end] = ACTIONS(1357),
    [sym_identifier] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(1357),
    [anon_sym_macro_rules_BANG] = ACTIONS(1357),
    [anon_sym_LPAREN] = ACTIONS(1357),
    [anon_sym_LBRACE] = ACTIONS(1357),
    [anon_sym_RBRACE] = ACTIONS(1357),
    [anon_sym_LBRACK] = ACTIONS(1357),
    [anon_sym_STAR] = ACTIONS(1357),
    [anon_sym_u8] = ACTIONS(1359),
    [anon_sym_i8] = ACTIONS(1359),
    [anon_sym_u16] = ACTIONS(1359),
    [anon_sym_i16] = ACTIONS(1359),
    [anon_sym_u32] = ACTIONS(1359),
    [anon_sym_i32] = ACTIONS(1359),
    [anon_sym_u64] = ACTIONS(1359),
    [anon_sym_i64] = ACTIONS(1359),
    [anon_sym_u128] = ACTIONS(1359),
    [anon_sym_i128] = ACTIONS(1359),
    [anon_sym_isize] = ACTIONS(1359),
    [anon_sym_usize] = ACTIONS(1359),
    [anon_sym_f32] = ACTIONS(1359),
    [anon_sym_f64] = ACTIONS(1359),
    [anon_sym_bool] = ACTIONS(1359),
    [anon_sym_str] = ACTIONS(1359),
    [anon_sym_char] = ACTIONS(1359),
    [anon_sym_SQUOTE] = ACTIONS(1359),
    [anon_sym_async] = ACTIONS(1359),
    [anon_sym_break] = ACTIONS(1359),
    [anon_sym_const] = ACTIONS(1359),
    [anon_sym_continue] = ACTIONS(1359),
    [anon_sym_default] = ACTIONS(1359),
    [anon_sym_enum] = ACTIONS(1359),
    [anon_sym_fn] = ACTIONS(1359),
    [anon_sym_for] = ACTIONS(1359),
    [anon_sym_if] = ACTIONS(1359),
    [anon_sym_impl] = ACTIONS(1359),
    [anon_sym_let] = ACTIONS(1359),
    [anon_sym_loop] = ACTIONS(1359),
    [anon_sym_match] = ACTIONS(1359),
    [anon_sym_mod] = ACTIONS(1359),
    [anon_sym_pub] = ACTIONS(1359),
    [anon_sym_return] = ACTIONS(1359),
    [anon_sym_static] = ACTIONS(1359),
    [anon_sym_struct] = ACTIONS(1359),
    [anon_sym_trait] = ACTIONS(1359),
    [anon_sym_type] = ACTIONS(1359),
    [anon_sym_union] = ACTIONS(1359),
    [anon_sym_unsafe] = ACTIONS(1359),
    [anon_sym_use] = ACTIONS(1359),
    [anon_sym_while] = ACTIONS(1359),
    [anon_sym_POUND] = ACTIONS(1357),
    [anon_sym_BANG] = ACTIONS(1357),
    [anon_sym_extern] = ACTIONS(1359),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_COLON_COLON] = ACTIONS(1357),
    [anon_sym_AMP] = ACTIONS(1357),
    [anon_sym_DOT_DOT] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(1357),
    [anon_sym_PIPE] = ACTIONS(1357),
    [anon_sym_move] = ACTIONS(1359),
    [sym_integer_literal] = ACTIONS(1357),
    [aux_sym_string_literal_token1] = ACTIONS(1357),
    [sym_char_literal] = ACTIONS(1357),
    [anon_sym_true] = ACTIONS(1359),
    [anon_sym_false] = ACTIONS(1359),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1359),
    [sym_super] = ACTIONS(1359),
    [sym_crate] = ACTIONS(1359),
    [sym_metavariable] = ACTIONS(1357),
    [sym_raw_string_literal] = ACTIONS(1357),
    [sym_float_literal] = ACTIONS(1357),
    [sym_block_comment] = ACTIONS(3),
  },
  [254] = {
    [ts_builtin_sym_end] = ACTIONS(1361),
    [sym_identifier] = ACTIONS(1363),
    [anon_sym_SEMI] = ACTIONS(1361),
    [anon_sym_macro_rules_BANG] = ACTIONS(1361),
    [anon_sym_LPAREN] = ACTIONS(1361),
    [anon_sym_LBRACE] = ACTIONS(1361),
    [anon_sym_RBRACE] = ACTIONS(1361),
    [anon_sym_LBRACK] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1361),
    [anon_sym_u8] = ACTIONS(1363),
    [anon_sym_i8] = ACTIONS(1363),
    [anon_sym_u16] = ACTIONS(1363),
    [anon_sym_i16] = ACTIONS(1363),
    [anon_sym_u32] = ACTIONS(1363),
    [anon_sym_i32] = ACTIONS(1363),
    [anon_sym_u64] = ACTIONS(1363),
    [anon_sym_i64] = ACTIONS(1363),
    [anon_sym_u128] = ACTIONS(1363),
    [anon_sym_i128] = ACTIONS(1363),
    [anon_sym_isize] = ACTIONS(1363),
    [anon_sym_usize] = ACTIONS(1363),
    [anon_sym_f32] = ACTIONS(1363),
    [anon_sym_f64] = ACTIONS(1363),
    [anon_sym_bool] = ACTIONS(1363),
    [anon_sym_str] = ACTIONS(1363),
    [anon_sym_char] = ACTIONS(1363),
    [anon_sym_SQUOTE] = ACTIONS(1363),
    [anon_sym_async] = ACTIONS(1363),
    [anon_sym_break] = ACTIONS(1363),
    [anon_sym_const] = ACTIONS(1363),
    [anon_sym_continue] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(1363),
    [anon_sym_enum] = ACTIONS(1363),
    [anon_sym_fn] = ACTIONS(1363),
    [anon_sym_for] = ACTIONS(1363),
    [anon_sym_if] = ACTIONS(1363),
    [anon_sym_impl] = ACTIONS(1363),
    [anon_sym_let] = ACTIONS(1363),
    [anon_sym_loop] = ACTIONS(1363),
    [anon_sym_match] = ACTIONS(1363),
    [anon_sym_mod] = ACTIONS(1363),
    [anon_sym_pub] = ACTIONS(1363),
    [anon_sym_return] = ACTIONS(1363),
    [anon_sym_static] = ACTIONS(1363),
    [anon_sym_struct] = ACTIONS(1363),
    [anon_sym_trait] = ACTIONS(1363),
    [anon_sym_type] = ACTIONS(1363),
    [anon_sym_union] = ACTIONS(1363),
    [anon_sym_unsafe] = ACTIONS(1363),
    [anon_sym_use] = ACTIONS(1363),
    [anon_sym_while] = ACTIONS(1363),
    [anon_sym_POUND] = ACTIONS(1361),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_extern] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1361),
    [anon_sym_COLON_COLON] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1361),
    [anon_sym_DOT_DOT] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_PIPE] = ACTIONS(1361),
    [anon_sym_move] = ACTIONS(1363),
    [sym_integer_literal] = ACTIONS(1361),
    [aux_sym_string_literal_token1] = ACTIONS(1361),
    [sym_char_literal] = ACTIONS(1361),
    [anon_sym_true] = ACTIONS(1363),
    [anon_sym_false] = ACTIONS(1363),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1363),
    [sym_super] = ACTIONS(1363),
    [sym_crate] = ACTIONS(1363),
    [sym_metavariable] = ACTIONS(1361),
    [sym_raw_string_literal] = ACTIONS(1361),
    [sym_float_literal] = ACTIONS(1361),
    [sym_block_comment] = ACTIONS(3),
  },
  [255] = {
    [ts_builtin_sym_end] = ACTIONS(1365),
    [sym_identifier] = ACTIONS(1367),
    [anon_sym_SEMI] = ACTIONS(1365),
    [anon_sym_macro_rules_BANG] = ACTIONS(1365),
    [anon_sym_LPAREN] = ACTIONS(1365),
    [anon_sym_LBRACE] = ACTIONS(1365),
    [anon_sym_RBRACE] = ACTIONS(1365),
    [anon_sym_LBRACK] = ACTIONS(1365),
    [anon_sym_STAR] = ACTIONS(1365),
    [anon_sym_u8] = ACTIONS(1367),
    [anon_sym_i8] = ACTIONS(1367),
    [anon_sym_u16] = ACTIONS(1367),
    [anon_sym_i16] = ACTIONS(1367),
    [anon_sym_u32] = ACTIONS(1367),
    [anon_sym_i32] = ACTIONS(1367),
    [anon_sym_u64] = ACTIONS(1367),
    [anon_sym_i64] = ACTIONS(1367),
    [anon_sym_u128] = ACTIONS(1367),
    [anon_sym_i128] = ACTIONS(1367),
    [anon_sym_isize] = ACTIONS(1367),
    [anon_sym_usize] = ACTIONS(1367),
    [anon_sym_f32] = ACTIONS(1367),
    [anon_sym_f64] = ACTIONS(1367),
    [anon_sym_bool] = ACTIONS(1367),
    [anon_sym_str] = ACTIONS(1367),
    [anon_sym_char] = ACTIONS(1367),
    [anon_sym_SQUOTE] = ACTIONS(1367),
    [anon_sym_async] = ACTIONS(1367),
    [anon_sym_break] = ACTIONS(1367),
    [anon_sym_const] = ACTIONS(1367),
    [anon_sym_continue] = ACTIONS(1367),
    [anon_sym_default] = ACTIONS(1367),
    [anon_sym_enum] = ACTIONS(1367),
    [anon_sym_fn] = ACTIONS(1367),
    [anon_sym_for] = ACTIONS(1367),
    [anon_sym_if] = ACTIONS(1367),
    [anon_sym_impl] = ACTIONS(1367),
    [anon_sym_let] = ACTIONS(1367),
    [anon_sym_loop] = ACTIONS(1367),
    [anon_sym_match] = ACTIONS(1367),
    [anon_sym_mod] = ACTIONS(1367),
    [anon_sym_pub] = ACTIONS(1367),
    [anon_sym_return] = ACTIONS(1367),
    [anon_sym_static] = ACTIONS(1367),
    [anon_sym_struct] = ACTIONS(1367),
    [anon_sym_trait] = ACTIONS(1367),
    [anon_sym_type] = ACTIONS(1367),
    [anon_sym_union] = ACTIONS(1367),
    [anon_sym_unsafe] = ACTIONS(1367),
    [anon_sym_use] = ACTIONS(1367),
    [anon_sym_while] = ACTIONS(1367),
    [anon_sym_POUND] = ACTIONS(1365),
    [anon_sym_BANG] = ACTIONS(1365),
    [anon_sym_extern] = ACTIONS(1367),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_COLON_COLON] = ACTIONS(1365),
    [anon_sym_AMP] = ACTIONS(1365),
    [anon_sym_DOT_DOT] = ACTIONS(1365),
    [anon_sym_DASH] = ACTIONS(1365),
    [anon_sym_PIPE] = ACTIONS(1365),
    [anon_sym_move] = ACTIONS(1367),
    [sym_integer_literal] = ACTIONS(1365),
    [aux_sym_string_literal_token1] = ACTIONS(1365),
    [sym_char_literal] = ACTIONS(1365),
    [anon_sym_true] = ACTIONS(1367),
    [anon_sym_false] = ACTIONS(1367),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1367),
    [sym_super] = ACTIONS(1367),
    [sym_crate] = ACTIONS(1367),
    [sym_metavariable] = ACTIONS(1365),
    [sym_raw_string_literal] = ACTIONS(1365),
    [sym_float_literal] = ACTIONS(1365),
    [sym_block_comment] = ACTIONS(3),
  },
  [256] = {
    [ts_builtin_sym_end] = ACTIONS(1369),
    [sym_identifier] = ACTIONS(1371),
    [anon_sym_SEMI] = ACTIONS(1369),
    [anon_sym_macro_rules_BANG] = ACTIONS(1369),
    [anon_sym_LPAREN] = ACTIONS(1369),
    [anon_sym_LBRACE] = ACTIONS(1369),
    [anon_sym_RBRACE] = ACTIONS(1369),
    [anon_sym_LBRACK] = ACTIONS(1369),
    [anon_sym_STAR] = ACTIONS(1369),
    [anon_sym_u8] = ACTIONS(1371),
    [anon_sym_i8] = ACTIONS(1371),
    [anon_sym_u16] = ACTIONS(1371),
    [anon_sym_i16] = ACTIONS(1371),
    [anon_sym_u32] = ACTIONS(1371),
    [anon_sym_i32] = ACTIONS(1371),
    [anon_sym_u64] = ACTIONS(1371),
    [anon_sym_i64] = ACTIONS(1371),
    [anon_sym_u128] = ACTIONS(1371),
    [anon_sym_i128] = ACTIONS(1371),
    [anon_sym_isize] = ACTIONS(1371),
    [anon_sym_usize] = ACTIONS(1371),
    [anon_sym_f32] = ACTIONS(1371),
    [anon_sym_f64] = ACTIONS(1371),
    [anon_sym_bool] = ACTIONS(1371),
    [anon_sym_str] = ACTIONS(1371),
    [anon_sym_char] = ACTIONS(1371),
    [anon_sym_SQUOTE] = ACTIONS(1371),
    [anon_sym_async] = ACTIONS(1371),
    [anon_sym_break] = ACTIONS(1371),
    [anon_sym_const] = ACTIONS(1371),
    [anon_sym_continue] = ACTIONS(1371),
    [anon_sym_default] = ACTIONS(1371),
    [anon_sym_enum] = ACTIONS(1371),
    [anon_sym_fn] = ACTIONS(1371),
    [anon_sym_for] = ACTIONS(1371),
    [anon_sym_if] = ACTIONS(1371),
    [anon_sym_impl] = ACTIONS(1371),
    [anon_sym_let] = ACTIONS(1371),
    [anon_sym_loop] = ACTIONS(1371),
    [anon_sym_match] = ACTIONS(1371),
    [anon_sym_mod] = ACTIONS(1371),
    [anon_sym_pub] = ACTIONS(1371),
    [anon_sym_return] = ACTIONS(1371),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_struct] = ACTIONS(1371),
    [anon_sym_trait] = ACTIONS(1371),
    [anon_sym_type] = ACTIONS(1371),
    [anon_sym_union] = ACTIONS(1371),
    [anon_sym_unsafe] = ACTIONS(1371),
    [anon_sym_use] = ACTIONS(1371),
    [anon_sym_while] = ACTIONS(1371),
    [anon_sym_POUND] = ACTIONS(1369),
    [anon_sym_BANG] = ACTIONS(1369),
    [anon_sym_extern] = ACTIONS(1371),
    [anon_sym_LT] = ACTIONS(1369),
    [anon_sym_COLON_COLON] = ACTIONS(1369),
    [anon_sym_AMP] = ACTIONS(1369),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym_DASH] = ACTIONS(1369),
    [anon_sym_PIPE] = ACTIONS(1369),
    [anon_sym_move] = ACTIONS(1371),
    [sym_integer_literal] = ACTIONS(1369),
    [aux_sym_string_literal_token1] = ACTIONS(1369),
    [sym_char_literal] = ACTIONS(1369),
    [anon_sym_true] = ACTIONS(1371),
    [anon_sym_false] = ACTIONS(1371),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1371),
    [sym_super] = ACTIONS(1371),
    [sym_crate] = ACTIONS(1371),
    [sym_metavariable] = ACTIONS(1369),
    [sym_raw_string_literal] = ACTIONS(1369),
    [sym_float_literal] = ACTIONS(1369),
    [sym_block_comment] = ACTIONS(3),
  },
  [257] = {
    [ts_builtin_sym_end] = ACTIONS(1373),
    [sym_identifier] = ACTIONS(1375),
    [anon_sym_SEMI] = ACTIONS(1373),
    [anon_sym_macro_rules_BANG] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_LBRACE] = ACTIONS(1373),
    [anon_sym_RBRACE] = ACTIONS(1373),
    [anon_sym_LBRACK] = ACTIONS(1373),
    [anon_sym_STAR] = ACTIONS(1373),
    [anon_sym_u8] = ACTIONS(1375),
    [anon_sym_i8] = ACTIONS(1375),
    [anon_sym_u16] = ACTIONS(1375),
    [anon_sym_i16] = ACTIONS(1375),
    [anon_sym_u32] = ACTIONS(1375),
    [anon_sym_i32] = ACTIONS(1375),
    [anon_sym_u64] = ACTIONS(1375),
    [anon_sym_i64] = ACTIONS(1375),
    [anon_sym_u128] = ACTIONS(1375),
    [anon_sym_i128] = ACTIONS(1375),
    [anon_sym_isize] = ACTIONS(1375),
    [anon_sym_usize] = ACTIONS(1375),
    [anon_sym_f32] = ACTIONS(1375),
    [anon_sym_f64] = ACTIONS(1375),
    [anon_sym_bool] = ACTIONS(1375),
    [anon_sym_str] = ACTIONS(1375),
    [anon_sym_char] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(1375),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_break] = ACTIONS(1375),
    [anon_sym_const] = ACTIONS(1375),
    [anon_sym_continue] = ACTIONS(1375),
    [anon_sym_default] = ACTIONS(1375),
    [anon_sym_enum] = ACTIONS(1375),
    [anon_sym_fn] = ACTIONS(1375),
    [anon_sym_for] = ACTIONS(1375),
    [anon_sym_if] = ACTIONS(1375),
    [anon_sym_impl] = ACTIONS(1375),
    [anon_sym_let] = ACTIONS(1375),
    [anon_sym_loop] = ACTIONS(1375),
    [anon_sym_match] = ACTIONS(1375),
    [anon_sym_mod] = ACTIONS(1375),
    [anon_sym_pub] = ACTIONS(1375),
    [anon_sym_return] = ACTIONS(1375),
    [anon_sym_static] = ACTIONS(1375),
    [anon_sym_struct] = ACTIONS(1375),
    [anon_sym_trait] = ACTIONS(1375),
    [anon_sym_type] = ACTIONS(1375),
    [anon_sym_union] = ACTIONS(1375),
    [anon_sym_unsafe] = ACTIONS(1375),
    [anon_sym_use] = ACTIONS(1375),
    [anon_sym_while] = ACTIONS(1375),
    [anon_sym_POUND] = ACTIONS(1373),
    [anon_sym_BANG] = ACTIONS(1373),
    [anon_sym_extern] = ACTIONS(1375),
    [anon_sym_LT] = ACTIONS(1373),
    [anon_sym_COLON_COLON] = ACTIONS(1373),
    [anon_sym_AMP] = ACTIONS(1373),
    [anon_sym_DOT_DOT] = ACTIONS(1373),
    [anon_sym_DASH] = ACTIONS(1373),
    [anon_sym_PIPE] = ACTIONS(1373),
    [anon_sym_move] = ACTIONS(1375),
    [sym_integer_literal] = ACTIONS(1373),
    [aux_sym_string_literal_token1] = ACTIONS(1373),
    [sym_char_literal] = ACTIONS(1373),
    [anon_sym_true] = ACTIONS(1375),
    [anon_sym_false] = ACTIONS(1375),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1375),
    [sym_super] = ACTIONS(1375),
    [sym_crate] = ACTIONS(1375),
    [sym_metavariable] = ACTIONS(1373),
    [sym_raw_string_literal] = ACTIONS(1373),
    [sym_float_literal] = ACTIONS(1373),
    [sym_block_comment] = ACTIONS(3),
  },
  [258] = {
    [sym__token_pattern] = STATE(292),
    [sym_token_tree_pattern] = STATE(292),
    [sym_token_binding_pattern] = STATE(292),
    [sym_token_repetition_pattern] = STATE(292),
    [sym__literal] = STATE(292),
    [sym_string_literal] = STATE(292),
    [sym_boolean_literal] = STATE(292),
    [aux_sym_token_tree_pattern_repeat1] = STATE(292),
    [sym_identifier] = ACTIONS(1377),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_RBRACK] = ACTIONS(1379),
    [anon_sym_DOLLAR] = ACTIONS(1321),
    [anon_sym_u8] = ACTIONS(1323),
    [anon_sym_i8] = ACTIONS(1323),
    [anon_sym_u16] = ACTIONS(1323),
    [anon_sym_i16] = ACTIONS(1323),
    [anon_sym_u32] = ACTIONS(1323),
    [anon_sym_i32] = ACTIONS(1323),
    [anon_sym_u64] = ACTIONS(1323),
    [anon_sym_i64] = ACTIONS(1323),
    [anon_sym_u128] = ACTIONS(1323),
    [anon_sym_i128] = ACTIONS(1323),
    [anon_sym_isize] = ACTIONS(1323),
    [anon_sym_usize] = ACTIONS(1323),
    [anon_sym_f32] = ACTIONS(1323),
    [anon_sym_f64] = ACTIONS(1323),
    [anon_sym_bool] = ACTIONS(1323),
    [anon_sym_str] = ACTIONS(1323),
    [anon_sym_char] = ACTIONS(1323),
    [aux_sym__non_special_token_token1] = ACTIONS(1377),
    [anon_sym_SQUOTE] = ACTIONS(1377),
    [anon_sym_as] = ACTIONS(1377),
    [anon_sym_async] = ACTIONS(1377),
    [anon_sym_await] = ACTIONS(1377),
    [anon_sym_break] = ACTIONS(1377),
    [anon_sym_const] = ACTIONS(1377),
    [anon_sym_continue] = ACTIONS(1377),
    [anon_sym_default] = ACTIONS(1377),
    [anon_sym_enum] = ACTIONS(1377),
    [anon_sym_fn] = ACTIONS(1377),
    [anon_sym_for] = ACTIONS(1377),
    [anon_sym_if] = ACTIONS(1377),
    [anon_sym_impl] = ACTIONS(1377),
    [anon_sym_let] = ACTIONS(1377),
    [anon_sym_loop] = ACTIONS(1377),
    [anon_sym_match] = ACTIONS(1377),
    [anon_sym_mod] = ACTIONS(1377),
    [anon_sym_pub] = ACTIONS(1377),
    [anon_sym_return] = ACTIONS(1377),
    [anon_sym_static] = ACTIONS(1377),
    [anon_sym_struct] = ACTIONS(1377),
    [anon_sym_trait] = ACTIONS(1377),
    [anon_sym_type] = ACTIONS(1377),
    [anon_sym_union] = ACTIONS(1377),
    [anon_sym_unsafe] = ACTIONS(1377),
    [anon_sym_use] = ACTIONS(1377),
    [anon_sym_where] = ACTIONS(1377),
    [anon_sym_while] = ACTIONS(1377),
    [sym_mutable_specifier] = ACTIONS(1377),
    [sym_integer_literal] = ACTIONS(1381),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(1381),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(1377),
    [sym_super] = ACTIONS(1377),
    [sym_crate] = ACTIONS(1377),
    [sym_metavariable] = ACTIONS(1331),
    [sym_raw_string_literal] = ACTIONS(1381),
    [sym_float_literal] = ACTIONS(1381),
    [sym_block_comment] = ACTIONS(3),
  },
  [259] = {
    [ts_builtin_sym_end] = ACTIONS(1383),
    [sym_identifier] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1383),
    [anon_sym_macro_rules_BANG] = ACTIONS(1383),
    [anon_sym_LPAREN] = ACTIONS(1383),
    [anon_sym_LBRACE] = ACTIONS(1383),
    [anon_sym_RBRACE] = ACTIONS(1383),
    [anon_sym_LBRACK] = ACTIONS(1383),
    [anon_sym_STAR] = ACTIONS(1383),
    [anon_sym_u8] = ACTIONS(1385),
    [anon_sym_i8] = ACTIONS(1385),
    [anon_sym_u16] = ACTIONS(1385),
    [anon_sym_i16] = ACTIONS(1385),
    [anon_sym_u32] = ACTIONS(1385),
    [anon_sym_i32] = ACTIONS(1385),
    [anon_sym_u64] = ACTIONS(1385),
    [anon_sym_i64] = ACTIONS(1385),
    [anon_sym_u128] = ACTIONS(1385),
    [anon_sym_i128] = ACTIONS(1385),
    [anon_sym_isize] = ACTIONS(1385),
    [anon_sym_usize] = ACTIONS(1385),
    [anon_sym_f32] = ACTIONS(1385),
    [anon_sym_f64] = ACTIONS(1385),
    [anon_sym_bool] = ACTIONS(1385),
    [anon_sym_str] = ACTIONS(1385),
    [anon_sym_char] = ACTIONS(1385),
    [anon_sym_SQUOTE] = ACTIONS(1385),
    [anon_sym_async] = ACTIONS(1385),
    [anon_sym_break] = ACTIONS(1385),
    [anon_sym_const] = ACTIONS(1385),
    [anon_sym_continue] = ACTIONS(1385),
    [anon_sym_default] = ACTIONS(1385),
    [anon_sym_enum] = ACTIONS(1385),
    [anon_sym_fn] = ACTIONS(1385),
    [anon_sym_for] = ACTIONS(1385),
    [anon_sym_if] = ACTIONS(1385),
    [anon_sym_impl] = ACTIONS(1385),
    [anon_sym_let] = ACTIONS(1385),
    [anon_sym_loop] = ACTIONS(1385),
    [anon_sym_match] = ACTIONS(1385),
    [anon_sym_mod] = ACTIONS(1385),
    [anon_sym_pub] = ACTIONS(1385),
    [anon_sym_return] = ACTIONS(1385),
    [anon_sym_static] = ACTIONS(1385),
    [anon_sym_struct] = ACTIONS(1385),
    [anon_sym_trait] = ACTIONS(1385),
    [anon_sym_type] = ACTIONS(1385),
    [anon_sym_union] = ACTIONS(1385),
    [anon_sym_unsafe] = ACTIONS(1385),
    [anon_sym_use] = ACTIONS(1385),
    [anon_sym_while] = ACTIONS(1385),
    [anon_sym_POUND] = ACTIONS(1383),
    [anon_sym_BANG] = ACTIONS(1383),
    [anon_sym_extern] = ACTIONS(1385),
    [anon_sym_LT] = ACTIONS(1383),
    [anon_sym_COLON_COLON] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1383),
    [anon_sym_DOT_DOT] = ACTIONS(1383),
    [anon_sym_DASH] = ACTIONS(1383),
    [anon_sym_PIPE] = ACTIONS(1383),
    [anon_sym_move] = ACTIONS(1385),
    [sym_integer_literal] = ACTIONS(1383),
    [aux_sym_string_literal_token1] = ACTIONS(1383),
    [sym_char_literal] = ACTIONS(1383),
    [anon_sym_true] = ACTIONS(1385),
    [anon_sym_false] = ACTIONS(1385),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1385),
    [sym_super] = ACTIONS(1385),
    [sym_crate] = ACTIONS(1385),
    [sym_metavariable] = ACTIONS(1383),
    [sym_raw_string_literal] = ACTIONS(1383),
    [sym_float_literal] = ACTIONS(1383),
    [sym_block_comment] = ACTIONS(3),
  },
  [260] = {
    [ts_builtin_sym_end] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1389),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_macro_rules_BANG] = ACTIONS(1387),
    [anon_sym_LPAREN] = ACTIONS(1387),
    [anon_sym_LBRACE] = ACTIONS(1387),
    [anon_sym_RBRACE] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(1387),
    [anon_sym_STAR] = ACTIONS(1387),
    [anon_sym_u8] = ACTIONS(1389),
    [anon_sym_i8] = ACTIONS(1389),
    [anon_sym_u16] = ACTIONS(1389),
    [anon_sym_i16] = ACTIONS(1389),
    [anon_sym_u32] = ACTIONS(1389),
    [anon_sym_i32] = ACTIONS(1389),
    [anon_sym_u64] = ACTIONS(1389),
    [anon_sym_i64] = ACTIONS(1389),
    [anon_sym_u128] = ACTIONS(1389),
    [anon_sym_i128] = ACTIONS(1389),
    [anon_sym_isize] = ACTIONS(1389),
    [anon_sym_usize] = ACTIONS(1389),
    [anon_sym_f32] = ACTIONS(1389),
    [anon_sym_f64] = ACTIONS(1389),
    [anon_sym_bool] = ACTIONS(1389),
    [anon_sym_str] = ACTIONS(1389),
    [anon_sym_char] = ACTIONS(1389),
    [anon_sym_SQUOTE] = ACTIONS(1389),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_break] = ACTIONS(1389),
    [anon_sym_const] = ACTIONS(1389),
    [anon_sym_continue] = ACTIONS(1389),
    [anon_sym_default] = ACTIONS(1389),
    [anon_sym_enum] = ACTIONS(1389),
    [anon_sym_fn] = ACTIONS(1389),
    [anon_sym_for] = ACTIONS(1389),
    [anon_sym_if] = ACTIONS(1389),
    [anon_sym_impl] = ACTIONS(1389),
    [anon_sym_let] = ACTIONS(1389),
    [anon_sym_loop] = ACTIONS(1389),
    [anon_sym_match] = ACTIONS(1389),
    [anon_sym_mod] = ACTIONS(1389),
    [anon_sym_pub] = ACTIONS(1389),
    [anon_sym_return] = ACTIONS(1389),
    [anon_sym_static] = ACTIONS(1389),
    [anon_sym_struct] = ACTIONS(1389),
    [anon_sym_trait] = ACTIONS(1389),
    [anon_sym_type] = ACTIONS(1389),
    [anon_sym_union] = ACTIONS(1389),
    [anon_sym_unsafe] = ACTIONS(1389),
    [anon_sym_use] = ACTIONS(1389),
    [anon_sym_while] = ACTIONS(1389),
    [anon_sym_POUND] = ACTIONS(1387),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_extern] = ACTIONS(1389),
    [anon_sym_LT] = ACTIONS(1387),
    [anon_sym_COLON_COLON] = ACTIONS(1387),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_DOT_DOT] = ACTIONS(1387),
    [anon_sym_DASH] = ACTIONS(1387),
    [anon_sym_PIPE] = ACTIONS(1387),
    [anon_sym_move] = ACTIONS(1389),
    [sym_integer_literal] = ACTIONS(1387),
    [aux_sym_string_literal_token1] = ACTIONS(1387),
    [sym_char_literal] = ACTIONS(1387),
    [anon_sym_true] = ACTIONS(1389),
    [anon_sym_false] = ACTIONS(1389),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1389),
    [sym_super] = ACTIONS(1389),
    [sym_crate] = ACTIONS(1389),
    [sym_metavariable] = ACTIONS(1387),
    [sym_raw_string_literal] = ACTIONS(1387),
    [sym_float_literal] = ACTIONS(1387),
    [sym_block_comment] = ACTIONS(3),
  },
  [261] = {
    [ts_builtin_sym_end] = ACTIONS(1391),
    [sym_identifier] = ACTIONS(1393),
    [anon_sym_SEMI] = ACTIONS(1391),
    [anon_sym_macro_rules_BANG] = ACTIONS(1391),
    [anon_sym_LPAREN] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(1391),
    [anon_sym_RBRACE] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1391),
    [anon_sym_STAR] = ACTIONS(1391),
    [anon_sym_u8] = ACTIONS(1393),
    [anon_sym_i8] = ACTIONS(1393),
    [anon_sym_u16] = ACTIONS(1393),
    [anon_sym_i16] = ACTIONS(1393),
    [anon_sym_u32] = ACTIONS(1393),
    [anon_sym_i32] = ACTIONS(1393),
    [anon_sym_u64] = ACTIONS(1393),
    [anon_sym_i64] = ACTIONS(1393),
    [anon_sym_u128] = ACTIONS(1393),
    [anon_sym_i128] = ACTIONS(1393),
    [anon_sym_isize] = ACTIONS(1393),
    [anon_sym_usize] = ACTIONS(1393),
    [anon_sym_f32] = ACTIONS(1393),
    [anon_sym_f64] = ACTIONS(1393),
    [anon_sym_bool] = ACTIONS(1393),
    [anon_sym_str] = ACTIONS(1393),
    [anon_sym_char] = ACTIONS(1393),
    [anon_sym_SQUOTE] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1393),
    [anon_sym_break] = ACTIONS(1393),
    [anon_sym_const] = ACTIONS(1393),
    [anon_sym_continue] = ACTIONS(1393),
    [anon_sym_default] = ACTIONS(1393),
    [anon_sym_enum] = ACTIONS(1393),
    [anon_sym_fn] = ACTIONS(1393),
    [anon_sym_for] = ACTIONS(1393),
    [anon_sym_if] = ACTIONS(1393),
    [anon_sym_impl] = ACTIONS(1393),
    [anon_sym_let] = ACTIONS(1393),
    [anon_sym_loop] = ACTIONS(1393),
    [anon_sym_match] = ACTIONS(1393),
    [anon_sym_mod] = ACTIONS(1393),
    [anon_sym_pub] = ACTIONS(1393),
    [anon_sym_return] = ACTIONS(1393),
    [anon_sym_static] = ACTIONS(1393),
    [anon_sym_struct] = ACTIONS(1393),
    [anon_sym_trait] = ACTIONS(1393),
    [anon_sym_type] = ACTIONS(1393),
    [anon_sym_union] = ACTIONS(1393),
    [anon_sym_unsafe] = ACTIONS(1393),
    [anon_sym_use] = ACTIONS(1393),
    [anon_sym_while] = ACTIONS(1393),
    [anon_sym_POUND] = ACTIONS(1391),
    [anon_sym_BANG] = ACTIONS(1391),
    [anon_sym_extern] = ACTIONS(1393),
    [anon_sym_LT] = ACTIONS(1391),
    [anon_sym_COLON_COLON] = ACTIONS(1391),
    [anon_sym_AMP] = ACTIONS(1391),
    [anon_sym_DOT_DOT] = ACTIONS(1391),
    [anon_sym_DASH] = ACTIONS(1391),
    [anon_sym_PIPE] = ACTIONS(1391),
    [anon_sym_move] = ACTIONS(1393),
    [sym_integer_literal] = ACTIONS(1391),
    [aux_sym_string_literal_token1] = ACTIONS(1391),
    [sym_char_literal] = ACTIONS(1391),
    [anon_sym_true] = ACTIONS(1393),
    [anon_sym_false] = ACTIONS(1393),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1393),
    [sym_super] = ACTIONS(1393),
    [sym_crate] = ACTIONS(1393),
    [sym_metavariable] = ACTIONS(1391),
    [sym_raw_string_literal] = ACTIONS(1391),
    [sym_float_literal] = ACTIONS(1391),
    [sym_block_comment] = ACTIONS(3),
  },
  [262] = {
    [ts_builtin_sym_end] = ACTIONS(1395),
    [sym_identifier] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(1395),
    [anon_sym_macro_rules_BANG] = ACTIONS(1395),
    [anon_sym_LPAREN] = ACTIONS(1395),
    [anon_sym_LBRACE] = ACTIONS(1395),
    [anon_sym_RBRACE] = ACTIONS(1395),
    [anon_sym_LBRACK] = ACTIONS(1395),
    [anon_sym_STAR] = ACTIONS(1395),
    [anon_sym_u8] = ACTIONS(1397),
    [anon_sym_i8] = ACTIONS(1397),
    [anon_sym_u16] = ACTIONS(1397),
    [anon_sym_i16] = ACTIONS(1397),
    [anon_sym_u32] = ACTIONS(1397),
    [anon_sym_i32] = ACTIONS(1397),
    [anon_sym_u64] = ACTIONS(1397),
    [anon_sym_i64] = ACTIONS(1397),
    [anon_sym_u128] = ACTIONS(1397),
    [anon_sym_i128] = ACTIONS(1397),
    [anon_sym_isize] = ACTIONS(1397),
    [anon_sym_usize] = ACTIONS(1397),
    [anon_sym_f32] = ACTIONS(1397),
    [anon_sym_f64] = ACTIONS(1397),
    [anon_sym_bool] = ACTIONS(1397),
    [anon_sym_str] = ACTIONS(1397),
    [anon_sym_char] = ACTIONS(1397),
    [anon_sym_SQUOTE] = ACTIONS(1397),
    [anon_sym_async] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1397),
    [anon_sym_const] = ACTIONS(1397),
    [anon_sym_continue] = ACTIONS(1397),
    [anon_sym_default] = ACTIONS(1397),
    [anon_sym_enum] = ACTIONS(1397),
    [anon_sym_fn] = ACTIONS(1397),
    [anon_sym_for] = ACTIONS(1397),
    [anon_sym_if] = ACTIONS(1397),
    [anon_sym_impl] = ACTIONS(1397),
    [anon_sym_let] = ACTIONS(1397),
    [anon_sym_loop] = ACTIONS(1397),
    [anon_sym_match] = ACTIONS(1397),
    [anon_sym_mod] = ACTIONS(1397),
    [anon_sym_pub] = ACTIONS(1397),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_static] = ACTIONS(1397),
    [anon_sym_struct] = ACTIONS(1397),
    [anon_sym_trait] = ACTIONS(1397),
    [anon_sym_type] = ACTIONS(1397),
    [anon_sym_union] = ACTIONS(1397),
    [anon_sym_unsafe] = ACTIONS(1397),
    [anon_sym_use] = ACTIONS(1397),
    [anon_sym_while] = ACTIONS(1397),
    [anon_sym_POUND] = ACTIONS(1395),
    [anon_sym_BANG] = ACTIONS(1395),
    [anon_sym_extern] = ACTIONS(1397),
    [anon_sym_LT] = ACTIONS(1395),
    [anon_sym_COLON_COLON] = ACTIONS(1395),
    [anon_sym_AMP] = ACTIONS(1395),
    [anon_sym_DOT_DOT] = ACTIONS(1395),
    [anon_sym_DASH] = ACTIONS(1395),
    [anon_sym_PIPE] = ACTIONS(1395),
    [anon_sym_move] = ACTIONS(1397),
    [sym_integer_literal] = ACTIONS(1395),
    [aux_sym_string_literal_token1] = ACTIONS(1395),
    [sym_char_literal] = ACTIONS(1395),
    [anon_sym_true] = ACTIONS(1397),
    [anon_sym_false] = ACTIONS(1397),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1397),
    [sym_super] = ACTIONS(1397),
    [sym_crate] = ACTIONS(1397),
    [sym_metavariable] = ACTIONS(1395),
    [sym_raw_string_literal] = ACTIONS(1395),
    [sym_float_literal] = ACTIONS(1395),
    [sym_block_comment] = ACTIONS(3),
  },
  [263] = {
    [ts_builtin_sym_end] = ACTIONS(1399),
    [sym_identifier] = ACTIONS(1401),
    [anon_sym_SEMI] = ACTIONS(1399),
    [anon_sym_macro_rules_BANG] = ACTIONS(1399),
    [anon_sym_LPAREN] = ACTIONS(1399),
    [anon_sym_LBRACE] = ACTIONS(1399),
    [anon_sym_RBRACE] = ACTIONS(1399),
    [anon_sym_LBRACK] = ACTIONS(1399),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_u8] = ACTIONS(1401),
    [anon_sym_i8] = ACTIONS(1401),
    [anon_sym_u16] = ACTIONS(1401),
    [anon_sym_i16] = ACTIONS(1401),
    [anon_sym_u32] = ACTIONS(1401),
    [anon_sym_i32] = ACTIONS(1401),
    [anon_sym_u64] = ACTIONS(1401),
    [anon_sym_i64] = ACTIONS(1401),
    [anon_sym_u128] = ACTIONS(1401),
    [anon_sym_i128] = ACTIONS(1401),
    [anon_sym_isize] = ACTIONS(1401),
    [anon_sym_usize] = ACTIONS(1401),
    [anon_sym_f32] = ACTIONS(1401),
    [anon_sym_f64] = ACTIONS(1401),
    [anon_sym_bool] = ACTIONS(1401),
    [anon_sym_str] = ACTIONS(1401),
    [anon_sym_char] = ACTIONS(1401),
    [anon_sym_SQUOTE] = ACTIONS(1401),
    [anon_sym_async] = ACTIONS(1401),
    [anon_sym_break] = ACTIONS(1401),
    [anon_sym_const] = ACTIONS(1401),
    [anon_sym_continue] = ACTIONS(1401),
    [anon_sym_default] = ACTIONS(1401),
    [anon_sym_enum] = ACTIONS(1401),
    [anon_sym_fn] = ACTIONS(1401),
    [anon_sym_for] = ACTIONS(1401),
    [anon_sym_if] = ACTIONS(1401),
    [anon_sym_impl] = ACTIONS(1401),
    [anon_sym_let] = ACTIONS(1401),
    [anon_sym_loop] = ACTIONS(1401),
    [anon_sym_match] = ACTIONS(1401),
    [anon_sym_mod] = ACTIONS(1401),
    [anon_sym_pub] = ACTIONS(1401),
    [anon_sym_return] = ACTIONS(1401),
    [anon_sym_static] = ACTIONS(1401),
    [anon_sym_struct] = ACTIONS(1401),
    [anon_sym_trait] = ACTIONS(1401),
    [anon_sym_type] = ACTIONS(1401),
    [anon_sym_union] = ACTIONS(1401),
    [anon_sym_unsafe] = ACTIONS(1401),
    [anon_sym_use] = ACTIONS(1401),
    [anon_sym_while] = ACTIONS(1401),
    [anon_sym_POUND] = ACTIONS(1399),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_extern] = ACTIONS(1401),
    [anon_sym_LT] = ACTIONS(1399),
    [anon_sym_COLON_COLON] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_DOT_DOT] = ACTIONS(1399),
    [anon_sym_DASH] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1399),
    [anon_sym_move] = ACTIONS(1401),
    [sym_integer_literal] = ACTIONS(1399),
    [aux_sym_string_literal_token1] = ACTIONS(1399),
    [sym_char_literal] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1401),
    [anon_sym_false] = ACTIONS(1401),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1401),
    [sym_super] = ACTIONS(1401),
    [sym_crate] = ACTIONS(1401),
    [sym_metavariable] = ACTIONS(1399),
    [sym_raw_string_literal] = ACTIONS(1399),
    [sym_float_literal] = ACTIONS(1399),
    [sym_block_comment] = ACTIONS(3),
  },
  [264] = {
    [ts_builtin_sym_end] = ACTIONS(1403),
    [sym_identifier] = ACTIONS(1405),
    [anon_sym_SEMI] = ACTIONS(1403),
    [anon_sym_macro_rules_BANG] = ACTIONS(1403),
    [anon_sym_LPAREN] = ACTIONS(1403),
    [anon_sym_LBRACE] = ACTIONS(1403),
    [anon_sym_RBRACE] = ACTIONS(1403),
    [anon_sym_LBRACK] = ACTIONS(1403),
    [anon_sym_STAR] = ACTIONS(1403),
    [anon_sym_u8] = ACTIONS(1405),
    [anon_sym_i8] = ACTIONS(1405),
    [anon_sym_u16] = ACTIONS(1405),
    [anon_sym_i16] = ACTIONS(1405),
    [anon_sym_u32] = ACTIONS(1405),
    [anon_sym_i32] = ACTIONS(1405),
    [anon_sym_u64] = ACTIONS(1405),
    [anon_sym_i64] = ACTIONS(1405),
    [anon_sym_u128] = ACTIONS(1405),
    [anon_sym_i128] = ACTIONS(1405),
    [anon_sym_isize] = ACTIONS(1405),
    [anon_sym_usize] = ACTIONS(1405),
    [anon_sym_f32] = ACTIONS(1405),
    [anon_sym_f64] = ACTIONS(1405),
    [anon_sym_bool] = ACTIONS(1405),
    [anon_sym_str] = ACTIONS(1405),
    [anon_sym_char] = ACTIONS(1405),
    [anon_sym_SQUOTE] = ACTIONS(1405),
    [anon_sym_async] = ACTIONS(1405),
    [anon_sym_break] = ACTIONS(1405),
    [anon_sym_const] = ACTIONS(1405),
    [anon_sym_continue] = ACTIONS(1405),
    [anon_sym_default] = ACTIONS(1405),
    [anon_sym_enum] = ACTIONS(1405),
    [anon_sym_fn] = ACTIONS(1405),
    [anon_sym_for] = ACTIONS(1405),
    [anon_sym_if] = ACTIONS(1405),
    [anon_sym_impl] = ACTIONS(1405),
    [anon_sym_let] = ACTIONS(1405),
    [anon_sym_loop] = ACTIONS(1405),
    [anon_sym_match] = ACTIONS(1405),
    [anon_sym_mod] = ACTIONS(1405),
    [anon_sym_pub] = ACTIONS(1405),
    [anon_sym_return] = ACTIONS(1405),
    [anon_sym_static] = ACTIONS(1405),
    [anon_sym_struct] = ACTIONS(1405),
    [anon_sym_trait] = ACTIONS(1405),
    [anon_sym_type] = ACTIONS(1405),
    [anon_sym_union] = ACTIONS(1405),
    [anon_sym_unsafe] = ACTIONS(1405),
    [anon_sym_use] = ACTIONS(1405),
    [anon_sym_while] = ACTIONS(1405),
    [anon_sym_POUND] = ACTIONS(1403),
    [anon_sym_BANG] = ACTIONS(1403),
    [anon_sym_extern] = ACTIONS(1405),
    [anon_sym_LT] = ACTIONS(1403),
    [anon_sym_COLON_COLON] = ACTIONS(1403),
    [anon_sym_AMP] = ACTIONS(1403),
    [anon_sym_DOT_DOT] = ACTIONS(1403),
    [anon_sym_DASH] = ACTIONS(1403),
    [anon_sym_PIPE] = ACTIONS(1403),
    [anon_sym_move] = ACTIONS(1405),
    [sym_integer_literal] = ACTIONS(1403),
    [aux_sym_string_literal_token1] = ACTIONS(1403),
    [sym_char_literal] = ACTIONS(1403),
    [anon_sym_true] = ACTIONS(1405),
    [anon_sym_false] = ACTIONS(1405),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1405),
    [sym_super] = ACTIONS(1405),
    [sym_crate] = ACTIONS(1405),
    [sym_metavariable] = ACTIONS(1403),
    [sym_raw_string_literal] = ACTIONS(1403),
    [sym_float_literal] = ACTIONS(1403),
    [sym_block_comment] = ACTIONS(3),
  },
  [265] = {
    [ts_builtin_sym_end] = ACTIONS(1407),
    [sym_identifier] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_macro_rules_BANG] = ACTIONS(1407),
    [anon_sym_LPAREN] = ACTIONS(1407),
    [anon_sym_LBRACE] = ACTIONS(1407),
    [anon_sym_RBRACE] = ACTIONS(1407),
    [anon_sym_LBRACK] = ACTIONS(1407),
    [anon_sym_STAR] = ACTIONS(1407),
    [anon_sym_u8] = ACTIONS(1409),
    [anon_sym_i8] = ACTIONS(1409),
    [anon_sym_u16] = ACTIONS(1409),
    [anon_sym_i16] = ACTIONS(1409),
    [anon_sym_u32] = ACTIONS(1409),
    [anon_sym_i32] = ACTIONS(1409),
    [anon_sym_u64] = ACTIONS(1409),
    [anon_sym_i64] = ACTIONS(1409),
    [anon_sym_u128] = ACTIONS(1409),
    [anon_sym_i128] = ACTIONS(1409),
    [anon_sym_isize] = ACTIONS(1409),
    [anon_sym_usize] = ACTIONS(1409),
    [anon_sym_f32] = ACTIONS(1409),
    [anon_sym_f64] = ACTIONS(1409),
    [anon_sym_bool] = ACTIONS(1409),
    [anon_sym_str] = ACTIONS(1409),
    [anon_sym_char] = ACTIONS(1409),
    [anon_sym_SQUOTE] = ACTIONS(1409),
    [anon_sym_async] = ACTIONS(1409),
    [anon_sym_break] = ACTIONS(1409),
    [anon_sym_const] = ACTIONS(1409),
    [anon_sym_continue] = ACTIONS(1409),
    [anon_sym_default] = ACTIONS(1409),
    [anon_sym_enum] = ACTIONS(1409),
    [anon_sym_fn] = ACTIONS(1409),
    [anon_sym_for] = ACTIONS(1409),
    [anon_sym_if] = ACTIONS(1409),
    [anon_sym_impl] = ACTIONS(1409),
    [anon_sym_let] = ACTIONS(1409),
    [anon_sym_loop] = ACTIONS(1409),
    [anon_sym_match] = ACTIONS(1409),
    [anon_sym_mod] = ACTIONS(1409),
    [anon_sym_pub] = ACTIONS(1409),
    [anon_sym_return] = ACTIONS(1409),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_struct] = ACTIONS(1409),
    [anon_sym_trait] = ACTIONS(1409),
    [anon_sym_type] = ACTIONS(1409),
    [anon_sym_union] = ACTIONS(1409),
    [anon_sym_unsafe] = ACTIONS(1409),
    [anon_sym_use] = ACTIONS(1409),
    [anon_sym_while] = ACTIONS(1409),
    [anon_sym_POUND] = ACTIONS(1407),
    [anon_sym_BANG] = ACTIONS(1407),
    [anon_sym_extern] = ACTIONS(1409),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_COLON_COLON] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1407),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym_DASH] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1407),
    [anon_sym_move] = ACTIONS(1409),
    [sym_integer_literal] = ACTIONS(1407),
    [aux_sym_string_literal_token1] = ACTIONS(1407),
    [sym_char_literal] = ACTIONS(1407),
    [anon_sym_true] = ACTIONS(1409),
    [anon_sym_false] = ACTIONS(1409),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1409),
    [sym_super] = ACTIONS(1409),
    [sym_crate] = ACTIONS(1409),
    [sym_metavariable] = ACTIONS(1407),
    [sym_raw_string_literal] = ACTIONS(1407),
    [sym_float_literal] = ACTIONS(1407),
    [sym_block_comment] = ACTIONS(3),
  },
  [266] = {
    [ts_builtin_sym_end] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1413),
    [anon_sym_SEMI] = ACTIONS(1411),
    [anon_sym_macro_rules_BANG] = ACTIONS(1411),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_LBRACE] = ACTIONS(1411),
    [anon_sym_RBRACE] = ACTIONS(1411),
    [anon_sym_LBRACK] = ACTIONS(1411),
    [anon_sym_STAR] = ACTIONS(1411),
    [anon_sym_u8] = ACTIONS(1413),
    [anon_sym_i8] = ACTIONS(1413),
    [anon_sym_u16] = ACTIONS(1413),
    [anon_sym_i16] = ACTIONS(1413),
    [anon_sym_u32] = ACTIONS(1413),
    [anon_sym_i32] = ACTIONS(1413),
    [anon_sym_u64] = ACTIONS(1413),
    [anon_sym_i64] = ACTIONS(1413),
    [anon_sym_u128] = ACTIONS(1413),
    [anon_sym_i128] = ACTIONS(1413),
    [anon_sym_isize] = ACTIONS(1413),
    [anon_sym_usize] = ACTIONS(1413),
    [anon_sym_f32] = ACTIONS(1413),
    [anon_sym_f64] = ACTIONS(1413),
    [anon_sym_bool] = ACTIONS(1413),
    [anon_sym_str] = ACTIONS(1413),
    [anon_sym_char] = ACTIONS(1413),
    [anon_sym_SQUOTE] = ACTIONS(1413),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_break] = ACTIONS(1413),
    [anon_sym_const] = ACTIONS(1413),
    [anon_sym_continue] = ACTIONS(1413),
    [anon_sym_default] = ACTIONS(1413),
    [anon_sym_enum] = ACTIONS(1413),
    [anon_sym_fn] = ACTIONS(1413),
    [anon_sym_for] = ACTIONS(1413),
    [anon_sym_if] = ACTIONS(1413),
    [anon_sym_impl] = ACTIONS(1413),
    [anon_sym_let] = ACTIONS(1413),
    [anon_sym_loop] = ACTIONS(1413),
    [anon_sym_match] = ACTIONS(1413),
    [anon_sym_mod] = ACTIONS(1413),
    [anon_sym_pub] = ACTIONS(1413),
    [anon_sym_return] = ACTIONS(1413),
    [anon_sym_static] = ACTIONS(1413),
    [anon_sym_struct] = ACTIONS(1413),
    [anon_sym_trait] = ACTIONS(1413),
    [anon_sym_type] = ACTIONS(1413),
    [anon_sym_union] = ACTIONS(1413),
    [anon_sym_unsafe] = ACTIONS(1413),
    [anon_sym_use] = ACTIONS(1413),
    [anon_sym_while] = ACTIONS(1413),
    [anon_sym_POUND] = ACTIONS(1411),
    [anon_sym_BANG] = ACTIONS(1411),
    [anon_sym_extern] = ACTIONS(1413),
    [anon_sym_LT] = ACTIONS(1411),
    [anon_sym_COLON_COLON] = ACTIONS(1411),
    [anon_sym_AMP] = ACTIONS(1411),
    [anon_sym_DOT_DOT] = ACTIONS(1411),
    [anon_sym_DASH] = ACTIONS(1411),
    [anon_sym_PIPE] = ACTIONS(1411),
    [anon_sym_move] = ACTIONS(1413),
    [sym_integer_literal] = ACTIONS(1411),
    [aux_sym_string_literal_token1] = ACTIONS(1411),
    [sym_char_literal] = ACTIONS(1411),
    [anon_sym_true] = ACTIONS(1413),
    [anon_sym_false] = ACTIONS(1413),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1413),
    [sym_super] = ACTIONS(1413),
    [sym_crate] = ACTIONS(1413),
    [sym_metavariable] = ACTIONS(1411),
    [sym_raw_string_literal] = ACTIONS(1411),
    [sym_float_literal] = ACTIONS(1411),
    [sym_block_comment] = ACTIONS(3),
  },
  [267] = {
    [ts_builtin_sym_end] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1417),
    [anon_sym_SEMI] = ACTIONS(1415),
    [anon_sym_macro_rules_BANG] = ACTIONS(1415),
    [anon_sym_LPAREN] = ACTIONS(1415),
    [anon_sym_LBRACE] = ACTIONS(1415),
    [anon_sym_RBRACE] = ACTIONS(1415),
    [anon_sym_LBRACK] = ACTIONS(1415),
    [anon_sym_STAR] = ACTIONS(1415),
    [anon_sym_u8] = ACTIONS(1417),
    [anon_sym_i8] = ACTIONS(1417),
    [anon_sym_u16] = ACTIONS(1417),
    [anon_sym_i16] = ACTIONS(1417),
    [anon_sym_u32] = ACTIONS(1417),
    [anon_sym_i32] = ACTIONS(1417),
    [anon_sym_u64] = ACTIONS(1417),
    [anon_sym_i64] = ACTIONS(1417),
    [anon_sym_u128] = ACTIONS(1417),
    [anon_sym_i128] = ACTIONS(1417),
    [anon_sym_isize] = ACTIONS(1417),
    [anon_sym_usize] = ACTIONS(1417),
    [anon_sym_f32] = ACTIONS(1417),
    [anon_sym_f64] = ACTIONS(1417),
    [anon_sym_bool] = ACTIONS(1417),
    [anon_sym_str] = ACTIONS(1417),
    [anon_sym_char] = ACTIONS(1417),
    [anon_sym_SQUOTE] = ACTIONS(1417),
    [anon_sym_async] = ACTIONS(1417),
    [anon_sym_break] = ACTIONS(1417),
    [anon_sym_const] = ACTIONS(1417),
    [anon_sym_continue] = ACTIONS(1417),
    [anon_sym_default] = ACTIONS(1417),
    [anon_sym_enum] = ACTIONS(1417),
    [anon_sym_fn] = ACTIONS(1417),
    [anon_sym_for] = ACTIONS(1417),
    [anon_sym_if] = ACTIONS(1417),
    [anon_sym_impl] = ACTIONS(1417),
    [anon_sym_let] = ACTIONS(1417),
    [anon_sym_loop] = ACTIONS(1417),
    [anon_sym_match] = ACTIONS(1417),
    [anon_sym_mod] = ACTIONS(1417),
    [anon_sym_pub] = ACTIONS(1417),
    [anon_sym_return] = ACTIONS(1417),
    [anon_sym_static] = ACTIONS(1417),
    [anon_sym_struct] = ACTIONS(1417),
    [anon_sym_trait] = ACTIONS(1417),
    [anon_sym_type] = ACTIONS(1417),
    [anon_sym_union] = ACTIONS(1417),
    [anon_sym_unsafe] = ACTIONS(1417),
    [anon_sym_use] = ACTIONS(1417),
    [anon_sym_while] = ACTIONS(1417),
    [anon_sym_POUND] = ACTIONS(1415),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_extern] = ACTIONS(1417),
    [anon_sym_LT] = ACTIONS(1415),
    [anon_sym_COLON_COLON] = ACTIONS(1415),
    [anon_sym_AMP] = ACTIONS(1415),
    [anon_sym_DOT_DOT] = ACTIONS(1415),
    [anon_sym_DASH] = ACTIONS(1415),
    [anon_sym_PIPE] = ACTIONS(1415),
    [anon_sym_move] = ACTIONS(1417),
    [sym_integer_literal] = ACTIONS(1415),
    [aux_sym_string_literal_token1] = ACTIONS(1415),
    [sym_char_literal] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(1417),
    [anon_sym_false] = ACTIONS(1417),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1417),
    [sym_super] = ACTIONS(1417),
    [sym_crate] = ACTIONS(1417),
    [sym_metavariable] = ACTIONS(1415),
    [sym_raw_string_literal] = ACTIONS(1415),
    [sym_float_literal] = ACTIONS(1415),
    [sym_block_comment] = ACTIONS(3),
  },
  [268] = {
    [ts_builtin_sym_end] = ACTIONS(1419),
    [sym_identifier] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1419),
    [anon_sym_macro_rules_BANG] = ACTIONS(1419),
    [anon_sym_LPAREN] = ACTIONS(1419),
    [anon_sym_LBRACE] = ACTIONS(1419),
    [anon_sym_RBRACE] = ACTIONS(1419),
    [anon_sym_LBRACK] = ACTIONS(1419),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_u8] = ACTIONS(1421),
    [anon_sym_i8] = ACTIONS(1421),
    [anon_sym_u16] = ACTIONS(1421),
    [anon_sym_i16] = ACTIONS(1421),
    [anon_sym_u32] = ACTIONS(1421),
    [anon_sym_i32] = ACTIONS(1421),
    [anon_sym_u64] = ACTIONS(1421),
    [anon_sym_i64] = ACTIONS(1421),
    [anon_sym_u128] = ACTIONS(1421),
    [anon_sym_i128] = ACTIONS(1421),
    [anon_sym_isize] = ACTIONS(1421),
    [anon_sym_usize] = ACTIONS(1421),
    [anon_sym_f32] = ACTIONS(1421),
    [anon_sym_f64] = ACTIONS(1421),
    [anon_sym_bool] = ACTIONS(1421),
    [anon_sym_str] = ACTIONS(1421),
    [anon_sym_char] = ACTIONS(1421),
    [anon_sym_SQUOTE] = ACTIONS(1421),
    [anon_sym_async] = ACTIONS(1421),
    [anon_sym_break] = ACTIONS(1421),
    [anon_sym_const] = ACTIONS(1421),
    [anon_sym_continue] = ACTIONS(1421),
    [anon_sym_default] = ACTIONS(1421),
    [anon_sym_enum] = ACTIONS(1421),
    [anon_sym_fn] = ACTIONS(1421),
    [anon_sym_for] = ACTIONS(1421),
    [anon_sym_if] = ACTIONS(1421),
    [anon_sym_impl] = ACTIONS(1421),
    [anon_sym_let] = ACTIONS(1421),
    [anon_sym_loop] = ACTIONS(1421),
    [anon_sym_match] = ACTIONS(1421),
    [anon_sym_mod] = ACTIONS(1421),
    [anon_sym_pub] = ACTIONS(1421),
    [anon_sym_return] = ACTIONS(1421),
    [anon_sym_static] = ACTIONS(1421),
    [anon_sym_struct] = ACTIONS(1421),
    [anon_sym_trait] = ACTIONS(1421),
    [anon_sym_type] = ACTIONS(1421),
    [anon_sym_union] = ACTIONS(1421),
    [anon_sym_unsafe] = ACTIONS(1421),
    [anon_sym_use] = ACTIONS(1421),
    [anon_sym_while] = ACTIONS(1421),
    [anon_sym_POUND] = ACTIONS(1419),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_extern] = ACTIONS(1421),
    [anon_sym_LT] = ACTIONS(1419),
    [anon_sym_COLON_COLON] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_DOT_DOT] = ACTIONS(1419),
    [anon_sym_DASH] = ACTIONS(1419),
    [anon_sym_PIPE] = ACTIONS(1419),
    [anon_sym_move] = ACTIONS(1421),
    [sym_integer_literal] = ACTIONS(1419),
    [aux_sym_string_literal_token1] = ACTIONS(1419),
    [sym_char_literal] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(1421),
    [anon_sym_false] = ACTIONS(1421),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1421),
    [sym_super] = ACTIONS(1421),
    [sym_crate] = ACTIONS(1421),
    [sym_metavariable] = ACTIONS(1419),
    [sym_raw_string_literal] = ACTIONS(1419),
    [sym_float_literal] = ACTIONS(1419),
    [sym_block_comment] = ACTIONS(3),
  },
  [269] = {
    [ts_builtin_sym_end] = ACTIONS(1423),
    [sym_identifier] = ACTIONS(1425),
    [anon_sym_SEMI] = ACTIONS(1423),
    [anon_sym_macro_rules_BANG] = ACTIONS(1423),
    [anon_sym_LPAREN] = ACTIONS(1423),
    [anon_sym_LBRACE] = ACTIONS(1423),
    [anon_sym_RBRACE] = ACTIONS(1423),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_STAR] = ACTIONS(1423),
    [anon_sym_u8] = ACTIONS(1425),
    [anon_sym_i8] = ACTIONS(1425),
    [anon_sym_u16] = ACTIONS(1425),
    [anon_sym_i16] = ACTIONS(1425),
    [anon_sym_u32] = ACTIONS(1425),
    [anon_sym_i32] = ACTIONS(1425),
    [anon_sym_u64] = ACTIONS(1425),
    [anon_sym_i64] = ACTIONS(1425),
    [anon_sym_u128] = ACTIONS(1425),
    [anon_sym_i128] = ACTIONS(1425),
    [anon_sym_isize] = ACTIONS(1425),
    [anon_sym_usize] = ACTIONS(1425),
    [anon_sym_f32] = ACTIONS(1425),
    [anon_sym_f64] = ACTIONS(1425),
    [anon_sym_bool] = ACTIONS(1425),
    [anon_sym_str] = ACTIONS(1425),
    [anon_sym_char] = ACTIONS(1425),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_async] = ACTIONS(1425),
    [anon_sym_break] = ACTIONS(1425),
    [anon_sym_const] = ACTIONS(1425),
    [anon_sym_continue] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(1425),
    [anon_sym_enum] = ACTIONS(1425),
    [anon_sym_fn] = ACTIONS(1425),
    [anon_sym_for] = ACTIONS(1425),
    [anon_sym_if] = ACTIONS(1425),
    [anon_sym_impl] = ACTIONS(1425),
    [anon_sym_let] = ACTIONS(1425),
    [anon_sym_loop] = ACTIONS(1425),
    [anon_sym_match] = ACTIONS(1425),
    [anon_sym_mod] = ACTIONS(1425),
    [anon_sym_pub] = ACTIONS(1425),
    [anon_sym_return] = ACTIONS(1425),
    [anon_sym_static] = ACTIONS(1425),
    [anon_sym_struct] = ACTIONS(1425),
    [anon_sym_trait] = ACTIONS(1425),
    [anon_sym_type] = ACTIONS(1425),
    [anon_sym_union] = ACTIONS(1425),
    [anon_sym_unsafe] = ACTIONS(1425),
    [anon_sym_use] = ACTIONS(1425),
    [anon_sym_while] = ACTIONS(1425),
    [anon_sym_POUND] = ACTIONS(1423),
    [anon_sym_BANG] = ACTIONS(1423),
    [anon_sym_extern] = ACTIONS(1425),
    [anon_sym_LT] = ACTIONS(1423),
    [anon_sym_COLON_COLON] = ACTIONS(1423),
    [anon_sym_AMP] = ACTIONS(1423),
    [anon_sym_DOT_DOT] = ACTIONS(1423),
    [anon_sym_DASH] = ACTIONS(1423),
    [anon_sym_PIPE] = ACTIONS(1423),
    [anon_sym_move] = ACTIONS(1425),
    [sym_integer_literal] = ACTIONS(1423),
    [aux_sym_string_literal_token1] = ACTIONS(1423),
    [sym_char_literal] = ACTIONS(1423),
    [anon_sym_true] = ACTIONS(1425),
    [anon_sym_false] = ACTIONS(1425),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1425),
    [sym_super] = ACTIONS(1425),
    [sym_crate] = ACTIONS(1425),
    [sym_metavariable] = ACTIONS(1423),
    [sym_raw_string_literal] = ACTIONS(1423),
    [sym_float_literal] = ACTIONS(1423),
    [sym_block_comment] = ACTIONS(3),
  },
  [270] = {
    [ts_builtin_sym_end] = ACTIONS(1427),
    [sym_identifier] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1427),
    [anon_sym_macro_rules_BANG] = ACTIONS(1427),
    [anon_sym_LPAREN] = ACTIONS(1427),
    [anon_sym_LBRACE] = ACTIONS(1427),
    [anon_sym_RBRACE] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_STAR] = ACTIONS(1427),
    [anon_sym_u8] = ACTIONS(1429),
    [anon_sym_i8] = ACTIONS(1429),
    [anon_sym_u16] = ACTIONS(1429),
    [anon_sym_i16] = ACTIONS(1429),
    [anon_sym_u32] = ACTIONS(1429),
    [anon_sym_i32] = ACTIONS(1429),
    [anon_sym_u64] = ACTIONS(1429),
    [anon_sym_i64] = ACTIONS(1429),
    [anon_sym_u128] = ACTIONS(1429),
    [anon_sym_i128] = ACTIONS(1429),
    [anon_sym_isize] = ACTIONS(1429),
    [anon_sym_usize] = ACTIONS(1429),
    [anon_sym_f32] = ACTIONS(1429),
    [anon_sym_f64] = ACTIONS(1429),
    [anon_sym_bool] = ACTIONS(1429),
    [anon_sym_str] = ACTIONS(1429),
    [anon_sym_char] = ACTIONS(1429),
    [anon_sym_SQUOTE] = ACTIONS(1429),
    [anon_sym_async] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1429),
    [anon_sym_const] = ACTIONS(1429),
    [anon_sym_continue] = ACTIONS(1429),
    [anon_sym_default] = ACTIONS(1429),
    [anon_sym_enum] = ACTIONS(1429),
    [anon_sym_fn] = ACTIONS(1429),
    [anon_sym_for] = ACTIONS(1429),
    [anon_sym_if] = ACTIONS(1429),
    [anon_sym_impl] = ACTIONS(1429),
    [anon_sym_let] = ACTIONS(1429),
    [anon_sym_loop] = ACTIONS(1429),
    [anon_sym_match] = ACTIONS(1429),
    [anon_sym_mod] = ACTIONS(1429),
    [anon_sym_pub] = ACTIONS(1429),
    [anon_sym_return] = ACTIONS(1429),
    [anon_sym_static] = ACTIONS(1429),
    [anon_sym_struct] = ACTIONS(1429),
    [anon_sym_trait] = ACTIONS(1429),
    [anon_sym_type] = ACTIONS(1429),
    [anon_sym_union] = ACTIONS(1429),
    [anon_sym_unsafe] = ACTIONS(1429),
    [anon_sym_use] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(1429),
    [anon_sym_POUND] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_extern] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1427),
    [anon_sym_COLON_COLON] = ACTIONS(1427),
    [anon_sym_AMP] = ACTIONS(1427),
    [anon_sym_DOT_DOT] = ACTIONS(1427),
    [anon_sym_DASH] = ACTIONS(1427),
    [anon_sym_PIPE] = ACTIONS(1427),
    [anon_sym_move] = ACTIONS(1429),
    [sym_integer_literal] = ACTIONS(1427),
    [aux_sym_string_literal_token1] = ACTIONS(1427),
    [sym_char_literal] = ACTIONS(1427),
    [anon_sym_true] = ACTIONS(1429),
    [anon_sym_false] = ACTIONS(1429),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1429),
    [sym_super] = ACTIONS(1429),
    [sym_crate] = ACTIONS(1429),
    [sym_metavariable] = ACTIONS(1427),
    [sym_raw_string_literal] = ACTIONS(1427),
    [sym_float_literal] = ACTIONS(1427),
    [sym_block_comment] = ACTIONS(3),
  },
  [271] = {
    [sym__token_pattern] = STATE(288),
    [sym_token_tree_pattern] = STATE(288),
    [sym_token_binding_pattern] = STATE(288),
    [sym_token_repetition_pattern] = STATE(288),
    [sym__literal] = STATE(288),
    [sym_string_literal] = STATE(288),
    [sym_boolean_literal] = STATE(288),
    [aux_sym_token_tree_pattern_repeat1] = STATE(288),
    [sym_identifier] = ACTIONS(1431),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_RPAREN] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_DOLLAR] = ACTIONS(1321),
    [anon_sym_u8] = ACTIONS(1323),
    [anon_sym_i8] = ACTIONS(1323),
    [anon_sym_u16] = ACTIONS(1323),
    [anon_sym_i16] = ACTIONS(1323),
    [anon_sym_u32] = ACTIONS(1323),
    [anon_sym_i32] = ACTIONS(1323),
    [anon_sym_u64] = ACTIONS(1323),
    [anon_sym_i64] = ACTIONS(1323),
    [anon_sym_u128] = ACTIONS(1323),
    [anon_sym_i128] = ACTIONS(1323),
    [anon_sym_isize] = ACTIONS(1323),
    [anon_sym_usize] = ACTIONS(1323),
    [anon_sym_f32] = ACTIONS(1323),
    [anon_sym_f64] = ACTIONS(1323),
    [anon_sym_bool] = ACTIONS(1323),
    [anon_sym_str] = ACTIONS(1323),
    [anon_sym_char] = ACTIONS(1323),
    [aux_sym__non_special_token_token1] = ACTIONS(1431),
    [anon_sym_SQUOTE] = ACTIONS(1431),
    [anon_sym_as] = ACTIONS(1431),
    [anon_sym_async] = ACTIONS(1431),
    [anon_sym_await] = ACTIONS(1431),
    [anon_sym_break] = ACTIONS(1431),
    [anon_sym_const] = ACTIONS(1431),
    [anon_sym_continue] = ACTIONS(1431),
    [anon_sym_default] = ACTIONS(1431),
    [anon_sym_enum] = ACTIONS(1431),
    [anon_sym_fn] = ACTIONS(1431),
    [anon_sym_for] = ACTIONS(1431),
    [anon_sym_if] = ACTIONS(1431),
    [anon_sym_impl] = ACTIONS(1431),
    [anon_sym_let] = ACTIONS(1431),
    [anon_sym_loop] = ACTIONS(1431),
    [anon_sym_match] = ACTIONS(1431),
    [anon_sym_mod] = ACTIONS(1431),
    [anon_sym_pub] = ACTIONS(1431),
    [anon_sym_return] = ACTIONS(1431),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_struct] = ACTIONS(1431),
    [anon_sym_trait] = ACTIONS(1431),
    [anon_sym_type] = ACTIONS(1431),
    [anon_sym_union] = ACTIONS(1431),
    [anon_sym_unsafe] = ACTIONS(1431),
    [anon_sym_use] = ACTIONS(1431),
    [anon_sym_where] = ACTIONS(1431),
    [anon_sym_while] = ACTIONS(1431),
    [sym_mutable_specifier] = ACTIONS(1431),
    [sym_integer_literal] = ACTIONS(1433),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(1431),
    [sym_super] = ACTIONS(1431),
    [sym_crate] = ACTIONS(1431),
    [sym_metavariable] = ACTIONS(1331),
    [sym_raw_string_literal] = ACTIONS(1433),
    [sym_float_literal] = ACTIONS(1433),
    [sym_block_comment] = ACTIONS(3),
  },
  [272] = {
    [sym__token_pattern] = STATE(291),
    [sym_token_tree_pattern] = STATE(291),
    [sym_token_binding_pattern] = STATE(291),
    [sym_token_repetition_pattern] = STATE(291),
    [sym__literal] = STATE(291),
    [sym_string_literal] = STATE(291),
    [sym_boolean_literal] = STATE(291),
    [aux_sym_token_tree_pattern_repeat1] = STATE(291),
    [sym_identifier] = ACTIONS(1435),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(1379),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_DOLLAR] = ACTIONS(1321),
    [anon_sym_u8] = ACTIONS(1323),
    [anon_sym_i8] = ACTIONS(1323),
    [anon_sym_u16] = ACTIONS(1323),
    [anon_sym_i16] = ACTIONS(1323),
    [anon_sym_u32] = ACTIONS(1323),
    [anon_sym_i32] = ACTIONS(1323),
    [anon_sym_u64] = ACTIONS(1323),
    [anon_sym_i64] = ACTIONS(1323),
    [anon_sym_u128] = ACTIONS(1323),
    [anon_sym_i128] = ACTIONS(1323),
    [anon_sym_isize] = ACTIONS(1323),
    [anon_sym_usize] = ACTIONS(1323),
    [anon_sym_f32] = ACTIONS(1323),
    [anon_sym_f64] = ACTIONS(1323),
    [anon_sym_bool] = ACTIONS(1323),
    [anon_sym_str] = ACTIONS(1323),
    [anon_sym_char] = ACTIONS(1323),
    [aux_sym__non_special_token_token1] = ACTIONS(1435),
    [anon_sym_SQUOTE] = ACTIONS(1435),
    [anon_sym_as] = ACTIONS(1435),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_await] = ACTIONS(1435),
    [anon_sym_break] = ACTIONS(1435),
    [anon_sym_const] = ACTIONS(1435),
    [anon_sym_continue] = ACTIONS(1435),
    [anon_sym_default] = ACTIONS(1435),
    [anon_sym_enum] = ACTIONS(1435),
    [anon_sym_fn] = ACTIONS(1435),
    [anon_sym_for] = ACTIONS(1435),
    [anon_sym_if] = ACTIONS(1435),
    [anon_sym_impl] = ACTIONS(1435),
    [anon_sym_let] = ACTIONS(1435),
    [anon_sym_loop] = ACTIONS(1435),
    [anon_sym_match] = ACTIONS(1435),
    [anon_sym_mod] = ACTIONS(1435),
    [anon_sym_pub] = ACTIONS(1435),
    [anon_sym_return] = ACTIONS(1435),
    [anon_sym_static] = ACTIONS(1435),
    [anon_sym_struct] = ACTIONS(1435),
    [anon_sym_trait] = ACTIONS(1435),
    [anon_sym_type] = ACTIONS(1435),
    [anon_sym_union] = ACTIONS(1435),
    [anon_sym_unsafe] = ACTIONS(1435),
    [anon_sym_use] = ACTIONS(1435),
    [anon_sym_where] = ACTIONS(1435),
    [anon_sym_while] = ACTIONS(1435),
    [sym_mutable_specifier] = ACTIONS(1435),
    [sym_integer_literal] = ACTIONS(1437),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(1437),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(1435),
    [sym_super] = ACTIONS(1435),
    [sym_crate] = ACTIONS(1435),
    [sym_metavariable] = ACTIONS(1331),
    [sym_raw_string_literal] = ACTIONS(1437),
    [sym_float_literal] = ACTIONS(1437),
    [sym_block_comment] = ACTIONS(3),
  },
  [273] = {
    [ts_builtin_sym_end] = ACTIONS(1439),
    [sym_identifier] = ACTIONS(1441),
    [anon_sym_SEMI] = ACTIONS(1439),
    [anon_sym_macro_rules_BANG] = ACTIONS(1439),
    [anon_sym_LPAREN] = ACTIONS(1439),
    [anon_sym_LBRACE] = ACTIONS(1439),
    [anon_sym_RBRACE] = ACTIONS(1439),
    [anon_sym_LBRACK] = ACTIONS(1439),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_u8] = ACTIONS(1441),
    [anon_sym_i8] = ACTIONS(1441),
    [anon_sym_u16] = ACTIONS(1441),
    [anon_sym_i16] = ACTIONS(1441),
    [anon_sym_u32] = ACTIONS(1441),
    [anon_sym_i32] = ACTIONS(1441),
    [anon_sym_u64] = ACTIONS(1441),
    [anon_sym_i64] = ACTIONS(1441),
    [anon_sym_u128] = ACTIONS(1441),
    [anon_sym_i128] = ACTIONS(1441),
    [anon_sym_isize] = ACTIONS(1441),
    [anon_sym_usize] = ACTIONS(1441),
    [anon_sym_f32] = ACTIONS(1441),
    [anon_sym_f64] = ACTIONS(1441),
    [anon_sym_bool] = ACTIONS(1441),
    [anon_sym_str] = ACTIONS(1441),
    [anon_sym_char] = ACTIONS(1441),
    [anon_sym_SQUOTE] = ACTIONS(1441),
    [anon_sym_async] = ACTIONS(1441),
    [anon_sym_break] = ACTIONS(1441),
    [anon_sym_const] = ACTIONS(1441),
    [anon_sym_continue] = ACTIONS(1441),
    [anon_sym_default] = ACTIONS(1441),
    [anon_sym_enum] = ACTIONS(1441),
    [anon_sym_fn] = ACTIONS(1441),
    [anon_sym_for] = ACTIONS(1441),
    [anon_sym_if] = ACTIONS(1441),
    [anon_sym_impl] = ACTIONS(1441),
    [anon_sym_let] = ACTIONS(1441),
    [anon_sym_loop] = ACTIONS(1441),
    [anon_sym_match] = ACTIONS(1441),
    [anon_sym_mod] = ACTIONS(1441),
    [anon_sym_pub] = ACTIONS(1441),
    [anon_sym_return] = ACTIONS(1441),
    [anon_sym_static] = ACTIONS(1441),
    [anon_sym_struct] = ACTIONS(1441),
    [anon_sym_trait] = ACTIONS(1441),
    [anon_sym_type] = ACTIONS(1441),
    [anon_sym_union] = ACTIONS(1441),
    [anon_sym_unsafe] = ACTIONS(1441),
    [anon_sym_use] = ACTIONS(1441),
    [anon_sym_while] = ACTIONS(1441),
    [anon_sym_POUND] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_extern] = ACTIONS(1441),
    [anon_sym_LT] = ACTIONS(1439),
    [anon_sym_COLON_COLON] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_DOT_DOT] = ACTIONS(1439),
    [anon_sym_DASH] = ACTIONS(1439),
    [anon_sym_PIPE] = ACTIONS(1439),
    [anon_sym_move] = ACTIONS(1441),
    [sym_integer_literal] = ACTIONS(1439),
    [aux_sym_string_literal_token1] = ACTIONS(1439),
    [sym_char_literal] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1441),
    [anon_sym_false] = ACTIONS(1441),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1441),
    [sym_super] = ACTIONS(1441),
    [sym_crate] = ACTIONS(1441),
    [sym_metavariable] = ACTIONS(1439),
    [sym_raw_string_literal] = ACTIONS(1439),
    [sym_float_literal] = ACTIONS(1439),
    [sym_block_comment] = ACTIONS(3),
  },
  [274] = {
    [ts_builtin_sym_end] = ACTIONS(1443),
    [sym_identifier] = ACTIONS(1445),
    [anon_sym_SEMI] = ACTIONS(1443),
    [anon_sym_macro_rules_BANG] = ACTIONS(1443),
    [anon_sym_LPAREN] = ACTIONS(1443),
    [anon_sym_LBRACE] = ACTIONS(1443),
    [anon_sym_RBRACE] = ACTIONS(1443),
    [anon_sym_LBRACK] = ACTIONS(1443),
    [anon_sym_STAR] = ACTIONS(1443),
    [anon_sym_u8] = ACTIONS(1445),
    [anon_sym_i8] = ACTIONS(1445),
    [anon_sym_u16] = ACTIONS(1445),
    [anon_sym_i16] = ACTIONS(1445),
    [anon_sym_u32] = ACTIONS(1445),
    [anon_sym_i32] = ACTIONS(1445),
    [anon_sym_u64] = ACTIONS(1445),
    [anon_sym_i64] = ACTIONS(1445),
    [anon_sym_u128] = ACTIONS(1445),
    [anon_sym_i128] = ACTIONS(1445),
    [anon_sym_isize] = ACTIONS(1445),
    [anon_sym_usize] = ACTIONS(1445),
    [anon_sym_f32] = ACTIONS(1445),
    [anon_sym_f64] = ACTIONS(1445),
    [anon_sym_bool] = ACTIONS(1445),
    [anon_sym_str] = ACTIONS(1445),
    [anon_sym_char] = ACTIONS(1445),
    [anon_sym_SQUOTE] = ACTIONS(1445),
    [anon_sym_async] = ACTIONS(1445),
    [anon_sym_break] = ACTIONS(1445),
    [anon_sym_const] = ACTIONS(1445),
    [anon_sym_continue] = ACTIONS(1445),
    [anon_sym_default] = ACTIONS(1445),
    [anon_sym_enum] = ACTIONS(1445),
    [anon_sym_fn] = ACTIONS(1445),
    [anon_sym_for] = ACTIONS(1445),
    [anon_sym_if] = ACTIONS(1445),
    [anon_sym_impl] = ACTIONS(1445),
    [anon_sym_let] = ACTIONS(1445),
    [anon_sym_loop] = ACTIONS(1445),
    [anon_sym_match] = ACTIONS(1445),
    [anon_sym_mod] = ACTIONS(1445),
    [anon_sym_pub] = ACTIONS(1445),
    [anon_sym_return] = ACTIONS(1445),
    [anon_sym_static] = ACTIONS(1445),
    [anon_sym_struct] = ACTIONS(1445),
    [anon_sym_trait] = ACTIONS(1445),
    [anon_sym_type] = ACTIONS(1445),
    [anon_sym_union] = ACTIONS(1445),
    [anon_sym_unsafe] = ACTIONS(1445),
    [anon_sym_use] = ACTIONS(1445),
    [anon_sym_while] = ACTIONS(1445),
    [anon_sym_POUND] = ACTIONS(1443),
    [anon_sym_BANG] = ACTIONS(1443),
    [anon_sym_extern] = ACTIONS(1445),
    [anon_sym_LT] = ACTIONS(1443),
    [anon_sym_COLON_COLON] = ACTIONS(1443),
    [anon_sym_AMP] = ACTIONS(1443),
    [anon_sym_DOT_DOT] = ACTIONS(1443),
    [anon_sym_DASH] = ACTIONS(1443),
    [anon_sym_PIPE] = ACTIONS(1443),
    [anon_sym_move] = ACTIONS(1445),
    [sym_integer_literal] = ACTIONS(1443),
    [aux_sym_string_literal_token1] = ACTIONS(1443),
    [sym_char_literal] = ACTIONS(1443),
    [anon_sym_true] = ACTIONS(1445),
    [anon_sym_false] = ACTIONS(1445),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1445),
    [sym_super] = ACTIONS(1445),
    [sym_crate] = ACTIONS(1445),
    [sym_metavariable] = ACTIONS(1443),
    [sym_raw_string_literal] = ACTIONS(1443),
    [sym_float_literal] = ACTIONS(1443),
    [sym_block_comment] = ACTIONS(3),
  },
  [275] = {
    [ts_builtin_sym_end] = ACTIONS(1447),
    [sym_identifier] = ACTIONS(1449),
    [anon_sym_SEMI] = ACTIONS(1447),
    [anon_sym_macro_rules_BANG] = ACTIONS(1447),
    [anon_sym_LPAREN] = ACTIONS(1447),
    [anon_sym_LBRACE] = ACTIONS(1447),
    [anon_sym_RBRACE] = ACTIONS(1447),
    [anon_sym_LBRACK] = ACTIONS(1447),
    [anon_sym_STAR] = ACTIONS(1447),
    [anon_sym_u8] = ACTIONS(1449),
    [anon_sym_i8] = ACTIONS(1449),
    [anon_sym_u16] = ACTIONS(1449),
    [anon_sym_i16] = ACTIONS(1449),
    [anon_sym_u32] = ACTIONS(1449),
    [anon_sym_i32] = ACTIONS(1449),
    [anon_sym_u64] = ACTIONS(1449),
    [anon_sym_i64] = ACTIONS(1449),
    [anon_sym_u128] = ACTIONS(1449),
    [anon_sym_i128] = ACTIONS(1449),
    [anon_sym_isize] = ACTIONS(1449),
    [anon_sym_usize] = ACTIONS(1449),
    [anon_sym_f32] = ACTIONS(1449),
    [anon_sym_f64] = ACTIONS(1449),
    [anon_sym_bool] = ACTIONS(1449),
    [anon_sym_str] = ACTIONS(1449),
    [anon_sym_char] = ACTIONS(1449),
    [anon_sym_SQUOTE] = ACTIONS(1449),
    [anon_sym_async] = ACTIONS(1449),
    [anon_sym_break] = ACTIONS(1449),
    [anon_sym_const] = ACTIONS(1449),
    [anon_sym_continue] = ACTIONS(1449),
    [anon_sym_default] = ACTIONS(1449),
    [anon_sym_enum] = ACTIONS(1449),
    [anon_sym_fn] = ACTIONS(1449),
    [anon_sym_for] = ACTIONS(1449),
    [anon_sym_if] = ACTIONS(1449),
    [anon_sym_impl] = ACTIONS(1449),
    [anon_sym_let] = ACTIONS(1449),
    [anon_sym_loop] = ACTIONS(1449),
    [anon_sym_match] = ACTIONS(1449),
    [anon_sym_mod] = ACTIONS(1449),
    [anon_sym_pub] = ACTIONS(1449),
    [anon_sym_return] = ACTIONS(1449),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_struct] = ACTIONS(1449),
    [anon_sym_trait] = ACTIONS(1449),
    [anon_sym_type] = ACTIONS(1449),
    [anon_sym_union] = ACTIONS(1449),
    [anon_sym_unsafe] = ACTIONS(1449),
    [anon_sym_use] = ACTIONS(1449),
    [anon_sym_while] = ACTIONS(1449),
    [anon_sym_POUND] = ACTIONS(1447),
    [anon_sym_BANG] = ACTIONS(1447),
    [anon_sym_extern] = ACTIONS(1449),
    [anon_sym_LT] = ACTIONS(1447),
    [anon_sym_COLON_COLON] = ACTIONS(1447),
    [anon_sym_AMP] = ACTIONS(1447),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym_DASH] = ACTIONS(1447),
    [anon_sym_PIPE] = ACTIONS(1447),
    [anon_sym_move] = ACTIONS(1449),
    [sym_integer_literal] = ACTIONS(1447),
    [aux_sym_string_literal_token1] = ACTIONS(1447),
    [sym_char_literal] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(1449),
    [anon_sym_false] = ACTIONS(1449),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1449),
    [sym_super] = ACTIONS(1449),
    [sym_crate] = ACTIONS(1449),
    [sym_metavariable] = ACTIONS(1447),
    [sym_raw_string_literal] = ACTIONS(1447),
    [sym_float_literal] = ACTIONS(1447),
    [sym_block_comment] = ACTIONS(3),
  },
  [276] = {
    [ts_builtin_sym_end] = ACTIONS(1451),
    [sym_identifier] = ACTIONS(1453),
    [anon_sym_SEMI] = ACTIONS(1451),
    [anon_sym_macro_rules_BANG] = ACTIONS(1451),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_LBRACE] = ACTIONS(1451),
    [anon_sym_RBRACE] = ACTIONS(1451),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_STAR] = ACTIONS(1451),
    [anon_sym_u8] = ACTIONS(1453),
    [anon_sym_i8] = ACTIONS(1453),
    [anon_sym_u16] = ACTIONS(1453),
    [anon_sym_i16] = ACTIONS(1453),
    [anon_sym_u32] = ACTIONS(1453),
    [anon_sym_i32] = ACTIONS(1453),
    [anon_sym_u64] = ACTIONS(1453),
    [anon_sym_i64] = ACTIONS(1453),
    [anon_sym_u128] = ACTIONS(1453),
    [anon_sym_i128] = ACTIONS(1453),
    [anon_sym_isize] = ACTIONS(1453),
    [anon_sym_usize] = ACTIONS(1453),
    [anon_sym_f32] = ACTIONS(1453),
    [anon_sym_f64] = ACTIONS(1453),
    [anon_sym_bool] = ACTIONS(1453),
    [anon_sym_str] = ACTIONS(1453),
    [anon_sym_char] = ACTIONS(1453),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_break] = ACTIONS(1453),
    [anon_sym_const] = ACTIONS(1453),
    [anon_sym_continue] = ACTIONS(1453),
    [anon_sym_default] = ACTIONS(1453),
    [anon_sym_enum] = ACTIONS(1453),
    [anon_sym_fn] = ACTIONS(1453),
    [anon_sym_for] = ACTIONS(1453),
    [anon_sym_if] = ACTIONS(1453),
    [anon_sym_impl] = ACTIONS(1453),
    [anon_sym_let] = ACTIONS(1453),
    [anon_sym_loop] = ACTIONS(1453),
    [anon_sym_match] = ACTIONS(1453),
    [anon_sym_mod] = ACTIONS(1453),
    [anon_sym_pub] = ACTIONS(1453),
    [anon_sym_return] = ACTIONS(1453),
    [anon_sym_static] = ACTIONS(1453),
    [anon_sym_struct] = ACTIONS(1453),
    [anon_sym_trait] = ACTIONS(1453),
    [anon_sym_type] = ACTIONS(1453),
    [anon_sym_union] = ACTIONS(1453),
    [anon_sym_unsafe] = ACTIONS(1453),
    [anon_sym_use] = ACTIONS(1453),
    [anon_sym_while] = ACTIONS(1453),
    [anon_sym_POUND] = ACTIONS(1451),
    [anon_sym_BANG] = ACTIONS(1451),
    [anon_sym_extern] = ACTIONS(1453),
    [anon_sym_LT] = ACTIONS(1451),
    [anon_sym_COLON_COLON] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(1451),
    [anon_sym_DOT_DOT] = ACTIONS(1451),
    [anon_sym_DASH] = ACTIONS(1451),
    [anon_sym_PIPE] = ACTIONS(1451),
    [anon_sym_move] = ACTIONS(1453),
    [sym_integer_literal] = ACTIONS(1451),
    [aux_sym_string_literal_token1] = ACTIONS(1451),
    [sym_char_literal] = ACTIONS(1451),
    [anon_sym_true] = ACTIONS(1453),
    [anon_sym_false] = ACTIONS(1453),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1453),
    [sym_super] = ACTIONS(1453),
    [sym_crate] = ACTIONS(1453),
    [sym_metavariable] = ACTIONS(1451),
    [sym_raw_string_literal] = ACTIONS(1451),
    [sym_float_literal] = ACTIONS(1451),
    [sym_block_comment] = ACTIONS(3),
  },
  [277] = {
    [ts_builtin_sym_end] = ACTIONS(1455),
    [sym_identifier] = ACTIONS(1457),
    [anon_sym_SEMI] = ACTIONS(1455),
    [anon_sym_macro_rules_BANG] = ACTIONS(1455),
    [anon_sym_LPAREN] = ACTIONS(1455),
    [anon_sym_LBRACE] = ACTIONS(1455),
    [anon_sym_RBRACE] = ACTIONS(1455),
    [anon_sym_LBRACK] = ACTIONS(1455),
    [anon_sym_STAR] = ACTIONS(1455),
    [anon_sym_u8] = ACTIONS(1457),
    [anon_sym_i8] = ACTIONS(1457),
    [anon_sym_u16] = ACTIONS(1457),
    [anon_sym_i16] = ACTIONS(1457),
    [anon_sym_u32] = ACTIONS(1457),
    [anon_sym_i32] = ACTIONS(1457),
    [anon_sym_u64] = ACTIONS(1457),
    [anon_sym_i64] = ACTIONS(1457),
    [anon_sym_u128] = ACTIONS(1457),
    [anon_sym_i128] = ACTIONS(1457),
    [anon_sym_isize] = ACTIONS(1457),
    [anon_sym_usize] = ACTIONS(1457),
    [anon_sym_f32] = ACTIONS(1457),
    [anon_sym_f64] = ACTIONS(1457),
    [anon_sym_bool] = ACTIONS(1457),
    [anon_sym_str] = ACTIONS(1457),
    [anon_sym_char] = ACTIONS(1457),
    [anon_sym_SQUOTE] = ACTIONS(1457),
    [anon_sym_async] = ACTIONS(1457),
    [anon_sym_break] = ACTIONS(1457),
    [anon_sym_const] = ACTIONS(1457),
    [anon_sym_continue] = ACTIONS(1457),
    [anon_sym_default] = ACTIONS(1457),
    [anon_sym_enum] = ACTIONS(1457),
    [anon_sym_fn] = ACTIONS(1457),
    [anon_sym_for] = ACTIONS(1457),
    [anon_sym_if] = ACTIONS(1457),
    [anon_sym_impl] = ACTIONS(1457),
    [anon_sym_let] = ACTIONS(1457),
    [anon_sym_loop] = ACTIONS(1457),
    [anon_sym_match] = ACTIONS(1457),
    [anon_sym_mod] = ACTIONS(1457),
    [anon_sym_pub] = ACTIONS(1457),
    [anon_sym_return] = ACTIONS(1457),
    [anon_sym_static] = ACTIONS(1457),
    [anon_sym_struct] = ACTIONS(1457),
    [anon_sym_trait] = ACTIONS(1457),
    [anon_sym_type] = ACTIONS(1457),
    [anon_sym_union] = ACTIONS(1457),
    [anon_sym_unsafe] = ACTIONS(1457),
    [anon_sym_use] = ACTIONS(1457),
    [anon_sym_while] = ACTIONS(1457),
    [anon_sym_POUND] = ACTIONS(1455),
    [anon_sym_BANG] = ACTIONS(1455),
    [anon_sym_extern] = ACTIONS(1457),
    [anon_sym_LT] = ACTIONS(1455),
    [anon_sym_COLON_COLON] = ACTIONS(1455),
    [anon_sym_AMP] = ACTIONS(1455),
    [anon_sym_DOT_DOT] = ACTIONS(1455),
    [anon_sym_DASH] = ACTIONS(1455),
    [anon_sym_PIPE] = ACTIONS(1455),
    [anon_sym_move] = ACTIONS(1457),
    [sym_integer_literal] = ACTIONS(1455),
    [aux_sym_string_literal_token1] = ACTIONS(1455),
    [sym_char_literal] = ACTIONS(1455),
    [anon_sym_true] = ACTIONS(1457),
    [anon_sym_false] = ACTIONS(1457),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1457),
    [sym_super] = ACTIONS(1457),
    [sym_crate] = ACTIONS(1457),
    [sym_metavariable] = ACTIONS(1455),
    [sym_raw_string_literal] = ACTIONS(1455),
    [sym_float_literal] = ACTIONS(1455),
    [sym_block_comment] = ACTIONS(3),
  },
  [278] = {
    [ts_builtin_sym_end] = ACTIONS(1459),
    [sym_identifier] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_macro_rules_BANG] = ACTIONS(1459),
    [anon_sym_LPAREN] = ACTIONS(1459),
    [anon_sym_LBRACE] = ACTIONS(1459),
    [anon_sym_RBRACE] = ACTIONS(1459),
    [anon_sym_LBRACK] = ACTIONS(1459),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_u8] = ACTIONS(1461),
    [anon_sym_i8] = ACTIONS(1461),
    [anon_sym_u16] = ACTIONS(1461),
    [anon_sym_i16] = ACTIONS(1461),
    [anon_sym_u32] = ACTIONS(1461),
    [anon_sym_i32] = ACTIONS(1461),
    [anon_sym_u64] = ACTIONS(1461),
    [anon_sym_i64] = ACTIONS(1461),
    [anon_sym_u128] = ACTIONS(1461),
    [anon_sym_i128] = ACTIONS(1461),
    [anon_sym_isize] = ACTIONS(1461),
    [anon_sym_usize] = ACTIONS(1461),
    [anon_sym_f32] = ACTIONS(1461),
    [anon_sym_f64] = ACTIONS(1461),
    [anon_sym_bool] = ACTIONS(1461),
    [anon_sym_str] = ACTIONS(1461),
    [anon_sym_char] = ACTIONS(1461),
    [anon_sym_SQUOTE] = ACTIONS(1461),
    [anon_sym_async] = ACTIONS(1461),
    [anon_sym_break] = ACTIONS(1461),
    [anon_sym_const] = ACTIONS(1461),
    [anon_sym_continue] = ACTIONS(1461),
    [anon_sym_default] = ACTIONS(1461),
    [anon_sym_enum] = ACTIONS(1461),
    [anon_sym_fn] = ACTIONS(1461),
    [anon_sym_for] = ACTIONS(1461),
    [anon_sym_if] = ACTIONS(1461),
    [anon_sym_impl] = ACTIONS(1461),
    [anon_sym_let] = ACTIONS(1461),
    [anon_sym_loop] = ACTIONS(1461),
    [anon_sym_match] = ACTIONS(1461),
    [anon_sym_mod] = ACTIONS(1461),
    [anon_sym_pub] = ACTIONS(1461),
    [anon_sym_return] = ACTIONS(1461),
    [anon_sym_static] = ACTIONS(1461),
    [anon_sym_struct] = ACTIONS(1461),
    [anon_sym_trait] = ACTIONS(1461),
    [anon_sym_type] = ACTIONS(1461),
    [anon_sym_union] = ACTIONS(1461),
    [anon_sym_unsafe] = ACTIONS(1461),
    [anon_sym_use] = ACTIONS(1461),
    [anon_sym_while] = ACTIONS(1461),
    [anon_sym_POUND] = ACTIONS(1459),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_extern] = ACTIONS(1461),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_COLON_COLON] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_DOT_DOT] = ACTIONS(1459),
    [anon_sym_DASH] = ACTIONS(1459),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_move] = ACTIONS(1461),
    [sym_integer_literal] = ACTIONS(1459),
    [aux_sym_string_literal_token1] = ACTIONS(1459),
    [sym_char_literal] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(1461),
    [anon_sym_false] = ACTIONS(1461),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1461),
    [sym_super] = ACTIONS(1461),
    [sym_crate] = ACTIONS(1461),
    [sym_metavariable] = ACTIONS(1459),
    [sym_raw_string_literal] = ACTIONS(1459),
    [sym_float_literal] = ACTIONS(1459),
    [sym_block_comment] = ACTIONS(3),
  },
  [279] = {
    [ts_builtin_sym_end] = ACTIONS(1463),
    [sym_identifier] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [anon_sym_macro_rules_BANG] = ACTIONS(1463),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_LBRACE] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(1463),
    [anon_sym_LBRACK] = ACTIONS(1463),
    [anon_sym_STAR] = ACTIONS(1463),
    [anon_sym_u8] = ACTIONS(1465),
    [anon_sym_i8] = ACTIONS(1465),
    [anon_sym_u16] = ACTIONS(1465),
    [anon_sym_i16] = ACTIONS(1465),
    [anon_sym_u32] = ACTIONS(1465),
    [anon_sym_i32] = ACTIONS(1465),
    [anon_sym_u64] = ACTIONS(1465),
    [anon_sym_i64] = ACTIONS(1465),
    [anon_sym_u128] = ACTIONS(1465),
    [anon_sym_i128] = ACTIONS(1465),
    [anon_sym_isize] = ACTIONS(1465),
    [anon_sym_usize] = ACTIONS(1465),
    [anon_sym_f32] = ACTIONS(1465),
    [anon_sym_f64] = ACTIONS(1465),
    [anon_sym_bool] = ACTIONS(1465),
    [anon_sym_str] = ACTIONS(1465),
    [anon_sym_char] = ACTIONS(1465),
    [anon_sym_SQUOTE] = ACTIONS(1465),
    [anon_sym_async] = ACTIONS(1465),
    [anon_sym_break] = ACTIONS(1465),
    [anon_sym_const] = ACTIONS(1465),
    [anon_sym_continue] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(1465),
    [anon_sym_enum] = ACTIONS(1465),
    [anon_sym_fn] = ACTIONS(1465),
    [anon_sym_for] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(1465),
    [anon_sym_impl] = ACTIONS(1465),
    [anon_sym_let] = ACTIONS(1465),
    [anon_sym_loop] = ACTIONS(1465),
    [anon_sym_match] = ACTIONS(1465),
    [anon_sym_mod] = ACTIONS(1465),
    [anon_sym_pub] = ACTIONS(1465),
    [anon_sym_return] = ACTIONS(1465),
    [anon_sym_static] = ACTIONS(1465),
    [anon_sym_struct] = ACTIONS(1465),
    [anon_sym_trait] = ACTIONS(1465),
    [anon_sym_type] = ACTIONS(1465),
    [anon_sym_union] = ACTIONS(1465),
    [anon_sym_unsafe] = ACTIONS(1465),
    [anon_sym_use] = ACTIONS(1465),
    [anon_sym_while] = ACTIONS(1465),
    [anon_sym_POUND] = ACTIONS(1463),
    [anon_sym_BANG] = ACTIONS(1463),
    [anon_sym_extern] = ACTIONS(1465),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_COLON_COLON] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_DOT_DOT] = ACTIONS(1463),
    [anon_sym_DASH] = ACTIONS(1463),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_move] = ACTIONS(1465),
    [sym_integer_literal] = ACTIONS(1463),
    [aux_sym_string_literal_token1] = ACTIONS(1463),
    [sym_char_literal] = ACTIONS(1463),
    [anon_sym_true] = ACTIONS(1465),
    [anon_sym_false] = ACTIONS(1465),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1465),
    [sym_super] = ACTIONS(1465),
    [sym_crate] = ACTIONS(1465),
    [sym_metavariable] = ACTIONS(1463),
    [sym_raw_string_literal] = ACTIONS(1463),
    [sym_float_literal] = ACTIONS(1463),
    [sym_block_comment] = ACTIONS(3),
  },
  [280] = {
    [ts_builtin_sym_end] = ACTIONS(1467),
    [sym_identifier] = ACTIONS(1469),
    [anon_sym_SEMI] = ACTIONS(1467),
    [anon_sym_macro_rules_BANG] = ACTIONS(1467),
    [anon_sym_LPAREN] = ACTIONS(1467),
    [anon_sym_LBRACE] = ACTIONS(1467),
    [anon_sym_RBRACE] = ACTIONS(1467),
    [anon_sym_LBRACK] = ACTIONS(1467),
    [anon_sym_STAR] = ACTIONS(1467),
    [anon_sym_u8] = ACTIONS(1469),
    [anon_sym_i8] = ACTIONS(1469),
    [anon_sym_u16] = ACTIONS(1469),
    [anon_sym_i16] = ACTIONS(1469),
    [anon_sym_u32] = ACTIONS(1469),
    [anon_sym_i32] = ACTIONS(1469),
    [anon_sym_u64] = ACTIONS(1469),
    [anon_sym_i64] = ACTIONS(1469),
    [anon_sym_u128] = ACTIONS(1469),
    [anon_sym_i128] = ACTIONS(1469),
    [anon_sym_isize] = ACTIONS(1469),
    [anon_sym_usize] = ACTIONS(1469),
    [anon_sym_f32] = ACTIONS(1469),
    [anon_sym_f64] = ACTIONS(1469),
    [anon_sym_bool] = ACTIONS(1469),
    [anon_sym_str] = ACTIONS(1469),
    [anon_sym_char] = ACTIONS(1469),
    [anon_sym_SQUOTE] = ACTIONS(1469),
    [anon_sym_async] = ACTIONS(1469),
    [anon_sym_break] = ACTIONS(1469),
    [anon_sym_const] = ACTIONS(1469),
    [anon_sym_continue] = ACTIONS(1469),
    [anon_sym_default] = ACTIONS(1469),
    [anon_sym_enum] = ACTIONS(1469),
    [anon_sym_fn] = ACTIONS(1469),
    [anon_sym_for] = ACTIONS(1469),
    [anon_sym_if] = ACTIONS(1469),
    [anon_sym_impl] = ACTIONS(1469),
    [anon_sym_let] = ACTIONS(1469),
    [anon_sym_loop] = ACTIONS(1469),
    [anon_sym_match] = ACTIONS(1469),
    [anon_sym_mod] = ACTIONS(1469),
    [anon_sym_pub] = ACTIONS(1469),
    [anon_sym_return] = ACTIONS(1469),
    [anon_sym_static] = ACTIONS(1469),
    [anon_sym_struct] = ACTIONS(1469),
    [anon_sym_trait] = ACTIONS(1469),
    [anon_sym_type] = ACTIONS(1469),
    [anon_sym_union] = ACTIONS(1469),
    [anon_sym_unsafe] = ACTIONS(1469),
    [anon_sym_use] = ACTIONS(1469),
    [anon_sym_while] = ACTIONS(1469),
    [anon_sym_POUND] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(1467),
    [anon_sym_extern] = ACTIONS(1469),
    [anon_sym_LT] = ACTIONS(1467),
    [anon_sym_COLON_COLON] = ACTIONS(1467),
    [anon_sym_AMP] = ACTIONS(1467),
    [anon_sym_DOT_DOT] = ACTIONS(1467),
    [anon_sym_DASH] = ACTIONS(1467),
    [anon_sym_PIPE] = ACTIONS(1467),
    [anon_sym_move] = ACTIONS(1469),
    [sym_integer_literal] = ACTIONS(1467),
    [aux_sym_string_literal_token1] = ACTIONS(1467),
    [sym_char_literal] = ACTIONS(1467),
    [anon_sym_true] = ACTIONS(1469),
    [anon_sym_false] = ACTIONS(1469),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1469),
    [sym_super] = ACTIONS(1469),
    [sym_crate] = ACTIONS(1469),
    [sym_metavariable] = ACTIONS(1467),
    [sym_raw_string_literal] = ACTIONS(1467),
    [sym_float_literal] = ACTIONS(1467),
    [sym_block_comment] = ACTIONS(3),
  },
  [281] = {
    [ts_builtin_sym_end] = ACTIONS(1471),
    [sym_identifier] = ACTIONS(1473),
    [anon_sym_SEMI] = ACTIONS(1471),
    [anon_sym_macro_rules_BANG] = ACTIONS(1471),
    [anon_sym_LPAREN] = ACTIONS(1471),
    [anon_sym_LBRACE] = ACTIONS(1471),
    [anon_sym_RBRACE] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(1471),
    [anon_sym_STAR] = ACTIONS(1471),
    [anon_sym_u8] = ACTIONS(1473),
    [anon_sym_i8] = ACTIONS(1473),
    [anon_sym_u16] = ACTIONS(1473),
    [anon_sym_i16] = ACTIONS(1473),
    [anon_sym_u32] = ACTIONS(1473),
    [anon_sym_i32] = ACTIONS(1473),
    [anon_sym_u64] = ACTIONS(1473),
    [anon_sym_i64] = ACTIONS(1473),
    [anon_sym_u128] = ACTIONS(1473),
    [anon_sym_i128] = ACTIONS(1473),
    [anon_sym_isize] = ACTIONS(1473),
    [anon_sym_usize] = ACTIONS(1473),
    [anon_sym_f32] = ACTIONS(1473),
    [anon_sym_f64] = ACTIONS(1473),
    [anon_sym_bool] = ACTIONS(1473),
    [anon_sym_str] = ACTIONS(1473),
    [anon_sym_char] = ACTIONS(1473),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1473),
    [anon_sym_break] = ACTIONS(1473),
    [anon_sym_const] = ACTIONS(1473),
    [anon_sym_continue] = ACTIONS(1473),
    [anon_sym_default] = ACTIONS(1473),
    [anon_sym_enum] = ACTIONS(1473),
    [anon_sym_fn] = ACTIONS(1473),
    [anon_sym_for] = ACTIONS(1473),
    [anon_sym_if] = ACTIONS(1473),
    [anon_sym_impl] = ACTIONS(1473),
    [anon_sym_let] = ACTIONS(1473),
    [anon_sym_loop] = ACTIONS(1473),
    [anon_sym_match] = ACTIONS(1473),
    [anon_sym_mod] = ACTIONS(1473),
    [anon_sym_pub] = ACTIONS(1473),
    [anon_sym_return] = ACTIONS(1473),
    [anon_sym_static] = ACTIONS(1473),
    [anon_sym_struct] = ACTIONS(1473),
    [anon_sym_trait] = ACTIONS(1473),
    [anon_sym_type] = ACTIONS(1473),
    [anon_sym_union] = ACTIONS(1473),
    [anon_sym_unsafe] = ACTIONS(1473),
    [anon_sym_use] = ACTIONS(1473),
    [anon_sym_while] = ACTIONS(1473),
    [anon_sym_POUND] = ACTIONS(1471),
    [anon_sym_BANG] = ACTIONS(1471),
    [anon_sym_extern] = ACTIONS(1473),
    [anon_sym_LT] = ACTIONS(1471),
    [anon_sym_COLON_COLON] = ACTIONS(1471),
    [anon_sym_AMP] = ACTIONS(1471),
    [anon_sym_DOT_DOT] = ACTIONS(1471),
    [anon_sym_DASH] = ACTIONS(1471),
    [anon_sym_PIPE] = ACTIONS(1471),
    [anon_sym_move] = ACTIONS(1473),
    [sym_integer_literal] = ACTIONS(1471),
    [aux_sym_string_literal_token1] = ACTIONS(1471),
    [sym_char_literal] = ACTIONS(1471),
    [anon_sym_true] = ACTIONS(1473),
    [anon_sym_false] = ACTIONS(1473),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1473),
    [sym_super] = ACTIONS(1473),
    [sym_crate] = ACTIONS(1473),
    [sym_metavariable] = ACTIONS(1471),
    [sym_raw_string_literal] = ACTIONS(1471),
    [sym_float_literal] = ACTIONS(1471),
    [sym_block_comment] = ACTIONS(3),
  },
  [282] = {
    [ts_builtin_sym_end] = ACTIONS(1475),
    [sym_identifier] = ACTIONS(1477),
    [anon_sym_SEMI] = ACTIONS(1475),
    [anon_sym_macro_rules_BANG] = ACTIONS(1475),
    [anon_sym_LPAREN] = ACTIONS(1475),
    [anon_sym_LBRACE] = ACTIONS(1475),
    [anon_sym_RBRACE] = ACTIONS(1475),
    [anon_sym_LBRACK] = ACTIONS(1475),
    [anon_sym_STAR] = ACTIONS(1475),
    [anon_sym_u8] = ACTIONS(1477),
    [anon_sym_i8] = ACTIONS(1477),
    [anon_sym_u16] = ACTIONS(1477),
    [anon_sym_i16] = ACTIONS(1477),
    [anon_sym_u32] = ACTIONS(1477),
    [anon_sym_i32] = ACTIONS(1477),
    [anon_sym_u64] = ACTIONS(1477),
    [anon_sym_i64] = ACTIONS(1477),
    [anon_sym_u128] = ACTIONS(1477),
    [anon_sym_i128] = ACTIONS(1477),
    [anon_sym_isize] = ACTIONS(1477),
    [anon_sym_usize] = ACTIONS(1477),
    [anon_sym_f32] = ACTIONS(1477),
    [anon_sym_f64] = ACTIONS(1477),
    [anon_sym_bool] = ACTIONS(1477),
    [anon_sym_str] = ACTIONS(1477),
    [anon_sym_char] = ACTIONS(1477),
    [anon_sym_SQUOTE] = ACTIONS(1477),
    [anon_sym_async] = ACTIONS(1477),
    [anon_sym_break] = ACTIONS(1477),
    [anon_sym_const] = ACTIONS(1477),
    [anon_sym_continue] = ACTIONS(1477),
    [anon_sym_default] = ACTIONS(1477),
    [anon_sym_enum] = ACTIONS(1477),
    [anon_sym_fn] = ACTIONS(1477),
    [anon_sym_for] = ACTIONS(1477),
    [anon_sym_if] = ACTIONS(1477),
    [anon_sym_impl] = ACTIONS(1477),
    [anon_sym_let] = ACTIONS(1477),
    [anon_sym_loop] = ACTIONS(1477),
    [anon_sym_match] = ACTIONS(1477),
    [anon_sym_mod] = ACTIONS(1477),
    [anon_sym_pub] = ACTIONS(1477),
    [anon_sym_return] = ACTIONS(1477),
    [anon_sym_static] = ACTIONS(1477),
    [anon_sym_struct] = ACTIONS(1477),
    [anon_sym_trait] = ACTIONS(1477),
    [anon_sym_type] = ACTIONS(1477),
    [anon_sym_union] = ACTIONS(1477),
    [anon_sym_unsafe] = ACTIONS(1477),
    [anon_sym_use] = ACTIONS(1477),
    [anon_sym_while] = ACTIONS(1477),
    [anon_sym_POUND] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(1475),
    [anon_sym_extern] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1475),
    [anon_sym_COLON_COLON] = ACTIONS(1475),
    [anon_sym_AMP] = ACTIONS(1475),
    [anon_sym_DOT_DOT] = ACTIONS(1475),
    [anon_sym_DASH] = ACTIONS(1475),
    [anon_sym_PIPE] = ACTIONS(1475),
    [anon_sym_move] = ACTIONS(1477),
    [sym_integer_literal] = ACTIONS(1475),
    [aux_sym_string_literal_token1] = ACTIONS(1475),
    [sym_char_literal] = ACTIONS(1475),
    [anon_sym_true] = ACTIONS(1477),
    [anon_sym_false] = ACTIONS(1477),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1477),
    [sym_super] = ACTIONS(1477),
    [sym_crate] = ACTIONS(1477),
    [sym_metavariable] = ACTIONS(1475),
    [sym_raw_string_literal] = ACTIONS(1475),
    [sym_float_literal] = ACTIONS(1475),
    [sym_block_comment] = ACTIONS(3),
  },
  [283] = {
    [ts_builtin_sym_end] = ACTIONS(417),
    [sym_identifier] = ACTIONS(419),
    [anon_sym_SEMI] = ACTIONS(417),
    [anon_sym_macro_rules_BANG] = ACTIONS(417),
    [anon_sym_LPAREN] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(417),
    [anon_sym_RBRACE] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(417),
    [anon_sym_u8] = ACTIONS(419),
    [anon_sym_i8] = ACTIONS(419),
    [anon_sym_u16] = ACTIONS(419),
    [anon_sym_i16] = ACTIONS(419),
    [anon_sym_u32] = ACTIONS(419),
    [anon_sym_i32] = ACTIONS(419),
    [anon_sym_u64] = ACTIONS(419),
    [anon_sym_i64] = ACTIONS(419),
    [anon_sym_u128] = ACTIONS(419),
    [anon_sym_i128] = ACTIONS(419),
    [anon_sym_isize] = ACTIONS(419),
    [anon_sym_usize] = ACTIONS(419),
    [anon_sym_f32] = ACTIONS(419),
    [anon_sym_f64] = ACTIONS(419),
    [anon_sym_bool] = ACTIONS(419),
    [anon_sym_str] = ACTIONS(419),
    [anon_sym_char] = ACTIONS(419),
    [anon_sym_SQUOTE] = ACTIONS(419),
    [anon_sym_async] = ACTIONS(419),
    [anon_sym_break] = ACTIONS(419),
    [anon_sym_const] = ACTIONS(419),
    [anon_sym_continue] = ACTIONS(419),
    [anon_sym_default] = ACTIONS(419),
    [anon_sym_enum] = ACTIONS(419),
    [anon_sym_fn] = ACTIONS(419),
    [anon_sym_for] = ACTIONS(419),
    [anon_sym_if] = ACTIONS(419),
    [anon_sym_impl] = ACTIONS(419),
    [anon_sym_let] = ACTIONS(419),
    [anon_sym_loop] = ACTIONS(419),
    [anon_sym_match] = ACTIONS(419),
    [anon_sym_mod] = ACTIONS(419),
    [anon_sym_pub] = ACTIONS(419),
    [anon_sym_return] = ACTIONS(419),
    [anon_sym_static] = ACTIONS(419),
    [anon_sym_struct] = ACTIONS(419),
    [anon_sym_trait] = ACTIONS(419),
    [anon_sym_type] = ACTIONS(419),
    [anon_sym_union] = ACTIONS(419),
    [anon_sym_unsafe] = ACTIONS(419),
    [anon_sym_use] = ACTIONS(419),
    [anon_sym_while] = ACTIONS(419),
    [anon_sym_POUND] = ACTIONS(417),
    [anon_sym_BANG] = ACTIONS(417),
    [anon_sym_extern] = ACTIONS(419),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DASH] = ACTIONS(417),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_move] = ACTIONS(419),
    [sym_integer_literal] = ACTIONS(417),
    [aux_sym_string_literal_token1] = ACTIONS(417),
    [sym_char_literal] = ACTIONS(417),
    [anon_sym_true] = ACTIONS(419),
    [anon_sym_false] = ACTIONS(419),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(419),
    [sym_super] = ACTIONS(419),
    [sym_crate] = ACTIONS(419),
    [sym_metavariable] = ACTIONS(417),
    [sym_raw_string_literal] = ACTIONS(417),
    [sym_float_literal] = ACTIONS(417),
    [sym_block_comment] = ACTIONS(3),
  },
  [284] = {
    [ts_builtin_sym_end] = ACTIONS(1479),
    [sym_identifier] = ACTIONS(1481),
    [anon_sym_SEMI] = ACTIONS(1479),
    [anon_sym_macro_rules_BANG] = ACTIONS(1479),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_LBRACE] = ACTIONS(1479),
    [anon_sym_RBRACE] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1479),
    [anon_sym_STAR] = ACTIONS(1479),
    [anon_sym_u8] = ACTIONS(1481),
    [anon_sym_i8] = ACTIONS(1481),
    [anon_sym_u16] = ACTIONS(1481),
    [anon_sym_i16] = ACTIONS(1481),
    [anon_sym_u32] = ACTIONS(1481),
    [anon_sym_i32] = ACTIONS(1481),
    [anon_sym_u64] = ACTIONS(1481),
    [anon_sym_i64] = ACTIONS(1481),
    [anon_sym_u128] = ACTIONS(1481),
    [anon_sym_i128] = ACTIONS(1481),
    [anon_sym_isize] = ACTIONS(1481),
    [anon_sym_usize] = ACTIONS(1481),
    [anon_sym_f32] = ACTIONS(1481),
    [anon_sym_f64] = ACTIONS(1481),
    [anon_sym_bool] = ACTIONS(1481),
    [anon_sym_str] = ACTIONS(1481),
    [anon_sym_char] = ACTIONS(1481),
    [anon_sym_SQUOTE] = ACTIONS(1481),
    [anon_sym_async] = ACTIONS(1481),
    [anon_sym_break] = ACTIONS(1481),
    [anon_sym_const] = ACTIONS(1481),
    [anon_sym_continue] = ACTIONS(1481),
    [anon_sym_default] = ACTIONS(1481),
    [anon_sym_enum] = ACTIONS(1481),
    [anon_sym_fn] = ACTIONS(1481),
    [anon_sym_for] = ACTIONS(1481),
    [anon_sym_if] = ACTIONS(1481),
    [anon_sym_impl] = ACTIONS(1481),
    [anon_sym_let] = ACTIONS(1481),
    [anon_sym_loop] = ACTIONS(1481),
    [anon_sym_match] = ACTIONS(1481),
    [anon_sym_mod] = ACTIONS(1481),
    [anon_sym_pub] = ACTIONS(1481),
    [anon_sym_return] = ACTIONS(1481),
    [anon_sym_static] = ACTIONS(1481),
    [anon_sym_struct] = ACTIONS(1481),
    [anon_sym_trait] = ACTIONS(1481),
    [anon_sym_type] = ACTIONS(1481),
    [anon_sym_union] = ACTIONS(1481),
    [anon_sym_unsafe] = ACTIONS(1481),
    [anon_sym_use] = ACTIONS(1481),
    [anon_sym_while] = ACTIONS(1481),
    [anon_sym_POUND] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [anon_sym_extern] = ACTIONS(1481),
    [anon_sym_LT] = ACTIONS(1479),
    [anon_sym_COLON_COLON] = ACTIONS(1479),
    [anon_sym_AMP] = ACTIONS(1479),
    [anon_sym_DOT_DOT] = ACTIONS(1479),
    [anon_sym_DASH] = ACTIONS(1479),
    [anon_sym_PIPE] = ACTIONS(1479),
    [anon_sym_move] = ACTIONS(1481),
    [sym_integer_literal] = ACTIONS(1479),
    [aux_sym_string_literal_token1] = ACTIONS(1479),
    [sym_char_literal] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(1481),
    [anon_sym_false] = ACTIONS(1481),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1481),
    [sym_super] = ACTIONS(1481),
    [sym_crate] = ACTIONS(1481),
    [sym_metavariable] = ACTIONS(1479),
    [sym_raw_string_literal] = ACTIONS(1479),
    [sym_float_literal] = ACTIONS(1479),
    [sym_block_comment] = ACTIONS(3),
  },
  [285] = {
    [ts_builtin_sym_end] = ACTIONS(1483),
    [sym_identifier] = ACTIONS(1485),
    [anon_sym_SEMI] = ACTIONS(1483),
    [anon_sym_macro_rules_BANG] = ACTIONS(1483),
    [anon_sym_LPAREN] = ACTIONS(1483),
    [anon_sym_LBRACE] = ACTIONS(1483),
    [anon_sym_RBRACE] = ACTIONS(1483),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1483),
    [anon_sym_u8] = ACTIONS(1485),
    [anon_sym_i8] = ACTIONS(1485),
    [anon_sym_u16] = ACTIONS(1485),
    [anon_sym_i16] = ACTIONS(1485),
    [anon_sym_u32] = ACTIONS(1485),
    [anon_sym_i32] = ACTIONS(1485),
    [anon_sym_u64] = ACTIONS(1485),
    [anon_sym_i64] = ACTIONS(1485),
    [anon_sym_u128] = ACTIONS(1485),
    [anon_sym_i128] = ACTIONS(1485),
    [anon_sym_isize] = ACTIONS(1485),
    [anon_sym_usize] = ACTIONS(1485),
    [anon_sym_f32] = ACTIONS(1485),
    [anon_sym_f64] = ACTIONS(1485),
    [anon_sym_bool] = ACTIONS(1485),
    [anon_sym_str] = ACTIONS(1485),
    [anon_sym_char] = ACTIONS(1485),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_async] = ACTIONS(1485),
    [anon_sym_break] = ACTIONS(1485),
    [anon_sym_const] = ACTIONS(1485),
    [anon_sym_continue] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(1485),
    [anon_sym_enum] = ACTIONS(1485),
    [anon_sym_fn] = ACTIONS(1485),
    [anon_sym_for] = ACTIONS(1485),
    [anon_sym_if] = ACTIONS(1485),
    [anon_sym_impl] = ACTIONS(1485),
    [anon_sym_let] = ACTIONS(1485),
    [anon_sym_loop] = ACTIONS(1485),
    [anon_sym_match] = ACTIONS(1485),
    [anon_sym_mod] = ACTIONS(1485),
    [anon_sym_pub] = ACTIONS(1485),
    [anon_sym_return] = ACTIONS(1485),
    [anon_sym_static] = ACTIONS(1485),
    [anon_sym_struct] = ACTIONS(1485),
    [anon_sym_trait] = ACTIONS(1485),
    [anon_sym_type] = ACTIONS(1485),
    [anon_sym_union] = ACTIONS(1485),
    [anon_sym_unsafe] = ACTIONS(1485),
    [anon_sym_use] = ACTIONS(1485),
    [anon_sym_while] = ACTIONS(1485),
    [anon_sym_POUND] = ACTIONS(1483),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_extern] = ACTIONS(1485),
    [anon_sym_LT] = ACTIONS(1483),
    [anon_sym_COLON_COLON] = ACTIONS(1483),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_DOT_DOT] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(1483),
    [anon_sym_move] = ACTIONS(1485),
    [sym_integer_literal] = ACTIONS(1483),
    [aux_sym_string_literal_token1] = ACTIONS(1483),
    [sym_char_literal] = ACTIONS(1483),
    [anon_sym_true] = ACTIONS(1485),
    [anon_sym_false] = ACTIONS(1485),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1485),
    [sym_super] = ACTIONS(1485),
    [sym_crate] = ACTIONS(1485),
    [sym_metavariable] = ACTIONS(1483),
    [sym_raw_string_literal] = ACTIONS(1483),
    [sym_float_literal] = ACTIONS(1483),
    [sym_block_comment] = ACTIONS(3),
  },
  [286] = {
    [ts_builtin_sym_end] = ACTIONS(1487),
    [sym_identifier] = ACTIONS(1489),
    [anon_sym_SEMI] = ACTIONS(1487),
    [anon_sym_macro_rules_BANG] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(1487),
    [anon_sym_LBRACE] = ACTIONS(1487),
    [anon_sym_RBRACE] = ACTIONS(1487),
    [anon_sym_LBRACK] = ACTIONS(1487),
    [anon_sym_STAR] = ACTIONS(1487),
    [anon_sym_u8] = ACTIONS(1489),
    [anon_sym_i8] = ACTIONS(1489),
    [anon_sym_u16] = ACTIONS(1489),
    [anon_sym_i16] = ACTIONS(1489),
    [anon_sym_u32] = ACTIONS(1489),
    [anon_sym_i32] = ACTIONS(1489),
    [anon_sym_u64] = ACTIONS(1489),
    [anon_sym_i64] = ACTIONS(1489),
    [anon_sym_u128] = ACTIONS(1489),
    [anon_sym_i128] = ACTIONS(1489),
    [anon_sym_isize] = ACTIONS(1489),
    [anon_sym_usize] = ACTIONS(1489),
    [anon_sym_f32] = ACTIONS(1489),
    [anon_sym_f64] = ACTIONS(1489),
    [anon_sym_bool] = ACTIONS(1489),
    [anon_sym_str] = ACTIONS(1489),
    [anon_sym_char] = ACTIONS(1489),
    [anon_sym_SQUOTE] = ACTIONS(1489),
    [anon_sym_async] = ACTIONS(1489),
    [anon_sym_break] = ACTIONS(1489),
    [anon_sym_const] = ACTIONS(1489),
    [anon_sym_continue] = ACTIONS(1489),
    [anon_sym_default] = ACTIONS(1489),
    [anon_sym_enum] = ACTIONS(1489),
    [anon_sym_fn] = ACTIONS(1489),
    [anon_sym_for] = ACTIONS(1489),
    [anon_sym_if] = ACTIONS(1489),
    [anon_sym_impl] = ACTIONS(1489),
    [anon_sym_let] = ACTIONS(1489),
    [anon_sym_loop] = ACTIONS(1489),
    [anon_sym_match] = ACTIONS(1489),
    [anon_sym_mod] = ACTIONS(1489),
    [anon_sym_pub] = ACTIONS(1489),
    [anon_sym_return] = ACTIONS(1489),
    [anon_sym_static] = ACTIONS(1489),
    [anon_sym_struct] = ACTIONS(1489),
    [anon_sym_trait] = ACTIONS(1489),
    [anon_sym_type] = ACTIONS(1489),
    [anon_sym_union] = ACTIONS(1489),
    [anon_sym_unsafe] = ACTIONS(1489),
    [anon_sym_use] = ACTIONS(1489),
    [anon_sym_while] = ACTIONS(1489),
    [anon_sym_POUND] = ACTIONS(1487),
    [anon_sym_BANG] = ACTIONS(1487),
    [anon_sym_extern] = ACTIONS(1489),
    [anon_sym_LT] = ACTIONS(1487),
    [anon_sym_COLON_COLON] = ACTIONS(1487),
    [anon_sym_AMP] = ACTIONS(1487),
    [anon_sym_DOT_DOT] = ACTIONS(1487),
    [anon_sym_DASH] = ACTIONS(1487),
    [anon_sym_PIPE] = ACTIONS(1487),
    [anon_sym_move] = ACTIONS(1489),
    [sym_integer_literal] = ACTIONS(1487),
    [aux_sym_string_literal_token1] = ACTIONS(1487),
    [sym_char_literal] = ACTIONS(1487),
    [anon_sym_true] = ACTIONS(1489),
    [anon_sym_false] = ACTIONS(1489),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1489),
    [sym_super] = ACTIONS(1489),
    [sym_crate] = ACTIONS(1489),
    [sym_metavariable] = ACTIONS(1487),
    [sym_raw_string_literal] = ACTIONS(1487),
    [sym_float_literal] = ACTIONS(1487),
    [sym_block_comment] = ACTIONS(3),
  },
  [287] = {
    [ts_builtin_sym_end] = ACTIONS(1491),
    [sym_identifier] = ACTIONS(1493),
    [anon_sym_SEMI] = ACTIONS(1491),
    [anon_sym_macro_rules_BANG] = ACTIONS(1491),
    [anon_sym_LPAREN] = ACTIONS(1491),
    [anon_sym_LBRACE] = ACTIONS(1491),
    [anon_sym_RBRACE] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(1491),
    [anon_sym_STAR] = ACTIONS(1491),
    [anon_sym_u8] = ACTIONS(1493),
    [anon_sym_i8] = ACTIONS(1493),
    [anon_sym_u16] = ACTIONS(1493),
    [anon_sym_i16] = ACTIONS(1493),
    [anon_sym_u32] = ACTIONS(1493),
    [anon_sym_i32] = ACTIONS(1493),
    [anon_sym_u64] = ACTIONS(1493),
    [anon_sym_i64] = ACTIONS(1493),
    [anon_sym_u128] = ACTIONS(1493),
    [anon_sym_i128] = ACTIONS(1493),
    [anon_sym_isize] = ACTIONS(1493),
    [anon_sym_usize] = ACTIONS(1493),
    [anon_sym_f32] = ACTIONS(1493),
    [anon_sym_f64] = ACTIONS(1493),
    [anon_sym_bool] = ACTIONS(1493),
    [anon_sym_str] = ACTIONS(1493),
    [anon_sym_char] = ACTIONS(1493),
    [anon_sym_SQUOTE] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1493),
    [anon_sym_break] = ACTIONS(1493),
    [anon_sym_const] = ACTIONS(1493),
    [anon_sym_continue] = ACTIONS(1493),
    [anon_sym_default] = ACTIONS(1493),
    [anon_sym_enum] = ACTIONS(1493),
    [anon_sym_fn] = ACTIONS(1493),
    [anon_sym_for] = ACTIONS(1493),
    [anon_sym_if] = ACTIONS(1493),
    [anon_sym_impl] = ACTIONS(1493),
    [anon_sym_let] = ACTIONS(1493),
    [anon_sym_loop] = ACTIONS(1493),
    [anon_sym_match] = ACTIONS(1493),
    [anon_sym_mod] = ACTIONS(1493),
    [anon_sym_pub] = ACTIONS(1493),
    [anon_sym_return] = ACTIONS(1493),
    [anon_sym_static] = ACTIONS(1493),
    [anon_sym_struct] = ACTIONS(1493),
    [anon_sym_trait] = ACTIONS(1493),
    [anon_sym_type] = ACTIONS(1493),
    [anon_sym_union] = ACTIONS(1493),
    [anon_sym_unsafe] = ACTIONS(1493),
    [anon_sym_use] = ACTIONS(1493),
    [anon_sym_while] = ACTIONS(1493),
    [anon_sym_POUND] = ACTIONS(1491),
    [anon_sym_BANG] = ACTIONS(1491),
    [anon_sym_extern] = ACTIONS(1493),
    [anon_sym_LT] = ACTIONS(1491),
    [anon_sym_COLON_COLON] = ACTIONS(1491),
    [anon_sym_AMP] = ACTIONS(1491),
    [anon_sym_DOT_DOT] = ACTIONS(1491),
    [anon_sym_DASH] = ACTIONS(1491),
    [anon_sym_PIPE] = ACTIONS(1491),
    [anon_sym_move] = ACTIONS(1493),
    [sym_integer_literal] = ACTIONS(1491),
    [aux_sym_string_literal_token1] = ACTIONS(1491),
    [sym_char_literal] = ACTIONS(1491),
    [anon_sym_true] = ACTIONS(1493),
    [anon_sym_false] = ACTIONS(1493),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1493),
    [sym_super] = ACTIONS(1493),
    [sym_crate] = ACTIONS(1493),
    [sym_metavariable] = ACTIONS(1491),
    [sym_raw_string_literal] = ACTIONS(1491),
    [sym_float_literal] = ACTIONS(1491),
    [sym_block_comment] = ACTIONS(3),
  },
  [288] = {
    [sym__token_pattern] = STATE(209),
    [sym_token_tree_pattern] = STATE(209),
    [sym_token_binding_pattern] = STATE(209),
    [sym_token_repetition_pattern] = STATE(209),
    [sym__literal] = STATE(209),
    [sym_string_literal] = STATE(209),
    [sym_boolean_literal] = STATE(209),
    [aux_sym_token_tree_pattern_repeat1] = STATE(209),
    [sym_identifier] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_RPAREN] = ACTIONS(1495),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_DOLLAR] = ACTIONS(1321),
    [anon_sym_u8] = ACTIONS(1323),
    [anon_sym_i8] = ACTIONS(1323),
    [anon_sym_u16] = ACTIONS(1323),
    [anon_sym_i16] = ACTIONS(1323),
    [anon_sym_u32] = ACTIONS(1323),
    [anon_sym_i32] = ACTIONS(1323),
    [anon_sym_u64] = ACTIONS(1323),
    [anon_sym_i64] = ACTIONS(1323),
    [anon_sym_u128] = ACTIONS(1323),
    [anon_sym_i128] = ACTIONS(1323),
    [anon_sym_isize] = ACTIONS(1323),
    [anon_sym_usize] = ACTIONS(1323),
    [anon_sym_f32] = ACTIONS(1323),
    [anon_sym_f64] = ACTIONS(1323),
    [anon_sym_bool] = ACTIONS(1323),
    [anon_sym_str] = ACTIONS(1323),
    [anon_sym_char] = ACTIONS(1323),
    [aux_sym__non_special_token_token1] = ACTIONS(1311),
    [anon_sym_SQUOTE] = ACTIONS(1311),
    [anon_sym_as] = ACTIONS(1311),
    [anon_sym_async] = ACTIONS(1311),
    [anon_sym_await] = ACTIONS(1311),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_const] = ACTIONS(1311),
    [anon_sym_continue] = ACTIONS(1311),
    [anon_sym_default] = ACTIONS(1311),
    [anon_sym_enum] = ACTIONS(1311),
    [anon_sym_fn] = ACTIONS(1311),
    [anon_sym_for] = ACTIONS(1311),
    [anon_sym_if] = ACTIONS(1311),
    [anon_sym_impl] = ACTIONS(1311),
    [anon_sym_let] = ACTIONS(1311),
    [anon_sym_loop] = ACTIONS(1311),
    [anon_sym_match] = ACTIONS(1311),
    [anon_sym_mod] = ACTIONS(1311),
    [anon_sym_pub] = ACTIONS(1311),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_struct] = ACTIONS(1311),
    [anon_sym_trait] = ACTIONS(1311),
    [anon_sym_type] = ACTIONS(1311),
    [anon_sym_union] = ACTIONS(1311),
    [anon_sym_unsafe] = ACTIONS(1311),
    [anon_sym_use] = ACTIONS(1311),
    [anon_sym_where] = ACTIONS(1311),
    [anon_sym_while] = ACTIONS(1311),
    [sym_mutable_specifier] = ACTIONS(1311),
    [sym_integer_literal] = ACTIONS(1325),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(1325),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(1311),
    [sym_super] = ACTIONS(1311),
    [sym_crate] = ACTIONS(1311),
    [sym_metavariable] = ACTIONS(1331),
    [sym_raw_string_literal] = ACTIONS(1325),
    [sym_float_literal] = ACTIONS(1325),
    [sym_block_comment] = ACTIONS(3),
  },
  [289] = {
    [ts_builtin_sym_end] = ACTIONS(1497),
    [sym_identifier] = ACTIONS(1499),
    [anon_sym_SEMI] = ACTIONS(1497),
    [anon_sym_macro_rules_BANG] = ACTIONS(1497),
    [anon_sym_LPAREN] = ACTIONS(1497),
    [anon_sym_LBRACE] = ACTIONS(1497),
    [anon_sym_RBRACE] = ACTIONS(1497),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_STAR] = ACTIONS(1497),
    [anon_sym_u8] = ACTIONS(1499),
    [anon_sym_i8] = ACTIONS(1499),
    [anon_sym_u16] = ACTIONS(1499),
    [anon_sym_i16] = ACTIONS(1499),
    [anon_sym_u32] = ACTIONS(1499),
    [anon_sym_i32] = ACTIONS(1499),
    [anon_sym_u64] = ACTIONS(1499),
    [anon_sym_i64] = ACTIONS(1499),
    [anon_sym_u128] = ACTIONS(1499),
    [anon_sym_i128] = ACTIONS(1499),
    [anon_sym_isize] = ACTIONS(1499),
    [anon_sym_usize] = ACTIONS(1499),
    [anon_sym_f32] = ACTIONS(1499),
    [anon_sym_f64] = ACTIONS(1499),
    [anon_sym_bool] = ACTIONS(1499),
    [anon_sym_str] = ACTIONS(1499),
    [anon_sym_char] = ACTIONS(1499),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_async] = ACTIONS(1499),
    [anon_sym_break] = ACTIONS(1499),
    [anon_sym_const] = ACTIONS(1499),
    [anon_sym_continue] = ACTIONS(1499),
    [anon_sym_default] = ACTIONS(1499),
    [anon_sym_enum] = ACTIONS(1499),
    [anon_sym_fn] = ACTIONS(1499),
    [anon_sym_for] = ACTIONS(1499),
    [anon_sym_if] = ACTIONS(1499),
    [anon_sym_impl] = ACTIONS(1499),
    [anon_sym_let] = ACTIONS(1499),
    [anon_sym_loop] = ACTIONS(1499),
    [anon_sym_match] = ACTIONS(1499),
    [anon_sym_mod] = ACTIONS(1499),
    [anon_sym_pub] = ACTIONS(1499),
    [anon_sym_return] = ACTIONS(1499),
    [anon_sym_static] = ACTIONS(1499),
    [anon_sym_struct] = ACTIONS(1499),
    [anon_sym_trait] = ACTIONS(1499),
    [anon_sym_type] = ACTIONS(1499),
    [anon_sym_union] = ACTIONS(1499),
    [anon_sym_unsafe] = ACTIONS(1499),
    [anon_sym_use] = ACTIONS(1499),
    [anon_sym_while] = ACTIONS(1499),
    [anon_sym_POUND] = ACTIONS(1497),
    [anon_sym_BANG] = ACTIONS(1497),
    [anon_sym_extern] = ACTIONS(1499),
    [anon_sym_LT] = ACTIONS(1497),
    [anon_sym_COLON_COLON] = ACTIONS(1497),
    [anon_sym_AMP] = ACTIONS(1497),
    [anon_sym_DOT_DOT] = ACTIONS(1497),
    [anon_sym_DASH] = ACTIONS(1497),
    [anon_sym_PIPE] = ACTIONS(1497),
    [anon_sym_move] = ACTIONS(1499),
    [sym_integer_literal] = ACTIONS(1497),
    [aux_sym_string_literal_token1] = ACTIONS(1497),
    [sym_char_literal] = ACTIONS(1497),
    [anon_sym_true] = ACTIONS(1499),
    [anon_sym_false] = ACTIONS(1499),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1499),
    [sym_super] = ACTIONS(1499),
    [sym_crate] = ACTIONS(1499),
    [sym_metavariable] = ACTIONS(1497),
    [sym_raw_string_literal] = ACTIONS(1497),
    [sym_float_literal] = ACTIONS(1497),
    [sym_block_comment] = ACTIONS(3),
  },
  [290] = {
    [ts_builtin_sym_end] = ACTIONS(1501),
    [sym_identifier] = ACTIONS(1503),
    [anon_sym_SEMI] = ACTIONS(1501),
    [anon_sym_macro_rules_BANG] = ACTIONS(1501),
    [anon_sym_LPAREN] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(1501),
    [anon_sym_RBRACE] = ACTIONS(1501),
    [anon_sym_LBRACK] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_u8] = ACTIONS(1503),
    [anon_sym_i8] = ACTIONS(1503),
    [anon_sym_u16] = ACTIONS(1503),
    [anon_sym_i16] = ACTIONS(1503),
    [anon_sym_u32] = ACTIONS(1503),
    [anon_sym_i32] = ACTIONS(1503),
    [anon_sym_u64] = ACTIONS(1503),
    [anon_sym_i64] = ACTIONS(1503),
    [anon_sym_u128] = ACTIONS(1503),
    [anon_sym_i128] = ACTIONS(1503),
    [anon_sym_isize] = ACTIONS(1503),
    [anon_sym_usize] = ACTIONS(1503),
    [anon_sym_f32] = ACTIONS(1503),
    [anon_sym_f64] = ACTIONS(1503),
    [anon_sym_bool] = ACTIONS(1503),
    [anon_sym_str] = ACTIONS(1503),
    [anon_sym_char] = ACTIONS(1503),
    [anon_sym_SQUOTE] = ACTIONS(1503),
    [anon_sym_async] = ACTIONS(1503),
    [anon_sym_break] = ACTIONS(1503),
    [anon_sym_const] = ACTIONS(1503),
    [anon_sym_continue] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(1503),
    [anon_sym_enum] = ACTIONS(1503),
    [anon_sym_fn] = ACTIONS(1503),
    [anon_sym_for] = ACTIONS(1503),
    [anon_sym_if] = ACTIONS(1503),
    [anon_sym_impl] = ACTIONS(1503),
    [anon_sym_let] = ACTIONS(1503),
    [anon_sym_loop] = ACTIONS(1503),
    [anon_sym_match] = ACTIONS(1503),
    [anon_sym_mod] = ACTIONS(1503),
    [anon_sym_pub] = ACTIONS(1503),
    [anon_sym_return] = ACTIONS(1503),
    [anon_sym_static] = ACTIONS(1503),
    [anon_sym_struct] = ACTIONS(1503),
    [anon_sym_trait] = ACTIONS(1503),
    [anon_sym_type] = ACTIONS(1503),
    [anon_sym_union] = ACTIONS(1503),
    [anon_sym_unsafe] = ACTIONS(1503),
    [anon_sym_use] = ACTIONS(1503),
    [anon_sym_while] = ACTIONS(1503),
    [anon_sym_POUND] = ACTIONS(1501),
    [anon_sym_BANG] = ACTIONS(1501),
    [anon_sym_extern] = ACTIONS(1503),
    [anon_sym_LT] = ACTIONS(1501),
    [anon_sym_COLON_COLON] = ACTIONS(1501),
    [anon_sym_AMP] = ACTIONS(1501),
    [anon_sym_DOT_DOT] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_PIPE] = ACTIONS(1501),
    [anon_sym_move] = ACTIONS(1503),
    [sym_integer_literal] = ACTIONS(1501),
    [aux_sym_string_literal_token1] = ACTIONS(1501),
    [sym_char_literal] = ACTIONS(1501),
    [anon_sym_true] = ACTIONS(1503),
    [anon_sym_false] = ACTIONS(1503),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1503),
    [sym_super] = ACTIONS(1503),
    [sym_crate] = ACTIONS(1503),
    [sym_metavariable] = ACTIONS(1501),
    [sym_raw_string_literal] = ACTIONS(1501),
    [sym_float_literal] = ACTIONS(1501),
    [sym_block_comment] = ACTIONS(3),
  },
  [291] = {
    [sym__token_pattern] = STATE(209),
    [sym_token_tree_pattern] = STATE(209),
    [sym_token_binding_pattern] = STATE(209),
    [sym_token_repetition_pattern] = STATE(209),
    [sym__literal] = STATE(209),
    [sym_string_literal] = STATE(209),
    [sym_boolean_literal] = STATE(209),
    [aux_sym_token_tree_pattern_repeat1] = STATE(209),
    [sym_identifier] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_DOLLAR] = ACTIONS(1321),
    [anon_sym_u8] = ACTIONS(1323),
    [anon_sym_i8] = ACTIONS(1323),
    [anon_sym_u16] = ACTIONS(1323),
    [anon_sym_i16] = ACTIONS(1323),
    [anon_sym_u32] = ACTIONS(1323),
    [anon_sym_i32] = ACTIONS(1323),
    [anon_sym_u64] = ACTIONS(1323),
    [anon_sym_i64] = ACTIONS(1323),
    [anon_sym_u128] = ACTIONS(1323),
    [anon_sym_i128] = ACTIONS(1323),
    [anon_sym_isize] = ACTIONS(1323),
    [anon_sym_usize] = ACTIONS(1323),
    [anon_sym_f32] = ACTIONS(1323),
    [anon_sym_f64] = ACTIONS(1323),
    [anon_sym_bool] = ACTIONS(1323),
    [anon_sym_str] = ACTIONS(1323),
    [anon_sym_char] = ACTIONS(1323),
    [aux_sym__non_special_token_token1] = ACTIONS(1311),
    [anon_sym_SQUOTE] = ACTIONS(1311),
    [anon_sym_as] = ACTIONS(1311),
    [anon_sym_async] = ACTIONS(1311),
    [anon_sym_await] = ACTIONS(1311),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_const] = ACTIONS(1311),
    [anon_sym_continue] = ACTIONS(1311),
    [anon_sym_default] = ACTIONS(1311),
    [anon_sym_enum] = ACTIONS(1311),
    [anon_sym_fn] = ACTIONS(1311),
    [anon_sym_for] = ACTIONS(1311),
    [anon_sym_if] = ACTIONS(1311),
    [anon_sym_impl] = ACTIONS(1311),
    [anon_sym_let] = ACTIONS(1311),
    [anon_sym_loop] = ACTIONS(1311),
    [anon_sym_match] = ACTIONS(1311),
    [anon_sym_mod] = ACTIONS(1311),
    [anon_sym_pub] = ACTIONS(1311),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_struct] = ACTIONS(1311),
    [anon_sym_trait] = ACTIONS(1311),
    [anon_sym_type] = ACTIONS(1311),
    [anon_sym_union] = ACTIONS(1311),
    [anon_sym_unsafe] = ACTIONS(1311),
    [anon_sym_use] = ACTIONS(1311),
    [anon_sym_where] = ACTIONS(1311),
    [anon_sym_while] = ACTIONS(1311),
    [sym_mutable_specifier] = ACTIONS(1311),
    [sym_integer_literal] = ACTIONS(1325),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(1325),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(1311),
    [sym_super] = ACTIONS(1311),
    [sym_crate] = ACTIONS(1311),
    [sym_metavariable] = ACTIONS(1331),
    [sym_raw_string_literal] = ACTIONS(1325),
    [sym_float_literal] = ACTIONS(1325),
    [sym_block_comment] = ACTIONS(3),
  },
  [292] = {
    [sym__token_pattern] = STATE(209),
    [sym_token_tree_pattern] = STATE(209),
    [sym_token_binding_pattern] = STATE(209),
    [sym_token_repetition_pattern] = STATE(209),
    [sym__literal] = STATE(209),
    [sym_string_literal] = STATE(209),
    [sym_boolean_literal] = STATE(209),
    [aux_sym_token_tree_pattern_repeat1] = STATE(209),
    [sym_identifier] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_RBRACK] = ACTIONS(1495),
    [anon_sym_DOLLAR] = ACTIONS(1321),
    [anon_sym_u8] = ACTIONS(1323),
    [anon_sym_i8] = ACTIONS(1323),
    [anon_sym_u16] = ACTIONS(1323),
    [anon_sym_i16] = ACTIONS(1323),
    [anon_sym_u32] = ACTIONS(1323),
    [anon_sym_i32] = ACTIONS(1323),
    [anon_sym_u64] = ACTIONS(1323),
    [anon_sym_i64] = ACTIONS(1323),
    [anon_sym_u128] = ACTIONS(1323),
    [anon_sym_i128] = ACTIONS(1323),
    [anon_sym_isize] = ACTIONS(1323),
    [anon_sym_usize] = ACTIONS(1323),
    [anon_sym_f32] = ACTIONS(1323),
    [anon_sym_f64] = ACTIONS(1323),
    [anon_sym_bool] = ACTIONS(1323),
    [anon_sym_str] = ACTIONS(1323),
    [anon_sym_char] = ACTIONS(1323),
    [aux_sym__non_special_token_token1] = ACTIONS(1311),
    [anon_sym_SQUOTE] = ACTIONS(1311),
    [anon_sym_as] = ACTIONS(1311),
    [anon_sym_async] = ACTIONS(1311),
    [anon_sym_await] = ACTIONS(1311),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_const] = ACTIONS(1311),
    [anon_sym_continue] = ACTIONS(1311),
    [anon_sym_default] = ACTIONS(1311),
    [anon_sym_enum] = ACTIONS(1311),
    [anon_sym_fn] = ACTIONS(1311),
    [anon_sym_for] = ACTIONS(1311),
    [anon_sym_if] = ACTIONS(1311),
    [anon_sym_impl] = ACTIONS(1311),
    [anon_sym_let] = ACTIONS(1311),
    [anon_sym_loop] = ACTIONS(1311),
    [anon_sym_match] = ACTIONS(1311),
    [anon_sym_mod] = ACTIONS(1311),
    [anon_sym_pub] = ACTIONS(1311),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_struct] = ACTIONS(1311),
    [anon_sym_trait] = ACTIONS(1311),
    [anon_sym_type] = ACTIONS(1311),
    [anon_sym_union] = ACTIONS(1311),
    [anon_sym_unsafe] = ACTIONS(1311),
    [anon_sym_use] = ACTIONS(1311),
    [anon_sym_where] = ACTIONS(1311),
    [anon_sym_while] = ACTIONS(1311),
    [sym_mutable_specifier] = ACTIONS(1311),
    [sym_integer_literal] = ACTIONS(1325),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(1325),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(1311),
    [sym_super] = ACTIONS(1311),
    [sym_crate] = ACTIONS(1311),
    [sym_metavariable] = ACTIONS(1331),
    [sym_raw_string_literal] = ACTIONS(1325),
    [sym_float_literal] = ACTIONS(1325),
    [sym_block_comment] = ACTIONS(3),
  },
  [293] = {
    [ts_builtin_sym_end] = ACTIONS(399),
    [sym_identifier] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(399),
    [anon_sym_macro_rules_BANG] = ACTIONS(399),
    [anon_sym_LPAREN] = ACTIONS(399),
    [anon_sym_LBRACE] = ACTIONS(399),
    [anon_sym_RBRACE] = ACTIONS(399),
    [anon_sym_LBRACK] = ACTIONS(399),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_u8] = ACTIONS(401),
    [anon_sym_i8] = ACTIONS(401),
    [anon_sym_u16] = ACTIONS(401),
    [anon_sym_i16] = ACTIONS(401),
    [anon_sym_u32] = ACTIONS(401),
    [anon_sym_i32] = ACTIONS(401),
    [anon_sym_u64] = ACTIONS(401),
    [anon_sym_i64] = ACTIONS(401),
    [anon_sym_u128] = ACTIONS(401),
    [anon_sym_i128] = ACTIONS(401),
    [anon_sym_isize] = ACTIONS(401),
    [anon_sym_usize] = ACTIONS(401),
    [anon_sym_f32] = ACTIONS(401),
    [anon_sym_f64] = ACTIONS(401),
    [anon_sym_bool] = ACTIONS(401),
    [anon_sym_str] = ACTIONS(401),
    [anon_sym_char] = ACTIONS(401),
    [anon_sym_SQUOTE] = ACTIONS(401),
    [anon_sym_async] = ACTIONS(401),
    [anon_sym_break] = ACTIONS(401),
    [anon_sym_const] = ACTIONS(401),
    [anon_sym_continue] = ACTIONS(401),
    [anon_sym_default] = ACTIONS(401),
    [anon_sym_enum] = ACTIONS(401),
    [anon_sym_fn] = ACTIONS(401),
    [anon_sym_for] = ACTIONS(401),
    [anon_sym_if] = ACTIONS(401),
    [anon_sym_impl] = ACTIONS(401),
    [anon_sym_let] = ACTIONS(401),
    [anon_sym_loop] = ACTIONS(401),
    [anon_sym_match] = ACTIONS(401),
    [anon_sym_mod] = ACTIONS(401),
    [anon_sym_pub] = ACTIONS(401),
    [anon_sym_return] = ACTIONS(401),
    [anon_sym_static] = ACTIONS(401),
    [anon_sym_struct] = ACTIONS(401),
    [anon_sym_trait] = ACTIONS(401),
    [anon_sym_type] = ACTIONS(401),
    [anon_sym_union] = ACTIONS(401),
    [anon_sym_unsafe] = ACTIONS(401),
    [anon_sym_use] = ACTIONS(401),
    [anon_sym_while] = ACTIONS(401),
    [anon_sym_POUND] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_extern] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_COLON_COLON] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_DOT_DOT] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(399),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_move] = ACTIONS(401),
    [sym_integer_literal] = ACTIONS(399),
    [aux_sym_string_literal_token1] = ACTIONS(399),
    [sym_char_literal] = ACTIONS(399),
    [anon_sym_true] = ACTIONS(401),
    [anon_sym_false] = ACTIONS(401),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(401),
    [sym_super] = ACTIONS(401),
    [sym_crate] = ACTIONS(401),
    [sym_metavariable] = ACTIONS(399),
    [sym_raw_string_literal] = ACTIONS(399),
    [sym_float_literal] = ACTIONS(399),
    [sym_block_comment] = ACTIONS(3),
  },
  [294] = {
    [ts_builtin_sym_end] = ACTIONS(1505),
    [sym_identifier] = ACTIONS(1507),
    [anon_sym_SEMI] = ACTIONS(1505),
    [anon_sym_macro_rules_BANG] = ACTIONS(1505),
    [anon_sym_LPAREN] = ACTIONS(1505),
    [anon_sym_LBRACE] = ACTIONS(1505),
    [anon_sym_RBRACE] = ACTIONS(1505),
    [anon_sym_LBRACK] = ACTIONS(1505),
    [anon_sym_STAR] = ACTIONS(1505),
    [anon_sym_u8] = ACTIONS(1507),
    [anon_sym_i8] = ACTIONS(1507),
    [anon_sym_u16] = ACTIONS(1507),
    [anon_sym_i16] = ACTIONS(1507),
    [anon_sym_u32] = ACTIONS(1507),
    [anon_sym_i32] = ACTIONS(1507),
    [anon_sym_u64] = ACTIONS(1507),
    [anon_sym_i64] = ACTIONS(1507),
    [anon_sym_u128] = ACTIONS(1507),
    [anon_sym_i128] = ACTIONS(1507),
    [anon_sym_isize] = ACTIONS(1507),
    [anon_sym_usize] = ACTIONS(1507),
    [anon_sym_f32] = ACTIONS(1507),
    [anon_sym_f64] = ACTIONS(1507),
    [anon_sym_bool] = ACTIONS(1507),
    [anon_sym_str] = ACTIONS(1507),
    [anon_sym_char] = ACTIONS(1507),
    [anon_sym_SQUOTE] = ACTIONS(1507),
    [anon_sym_async] = ACTIONS(1507),
    [anon_sym_break] = ACTIONS(1507),
    [anon_sym_const] = ACTIONS(1507),
    [anon_sym_continue] = ACTIONS(1507),
    [anon_sym_default] = ACTIONS(1507),
    [anon_sym_enum] = ACTIONS(1507),
    [anon_sym_fn] = ACTIONS(1507),
    [anon_sym_for] = ACTIONS(1507),
    [anon_sym_if] = ACTIONS(1507),
    [anon_sym_impl] = ACTIONS(1507),
    [anon_sym_let] = ACTIONS(1507),
    [anon_sym_loop] = ACTIONS(1507),
    [anon_sym_match] = ACTIONS(1507),
    [anon_sym_mod] = ACTIONS(1507),
    [anon_sym_pub] = ACTIONS(1507),
    [anon_sym_return] = ACTIONS(1507),
    [anon_sym_static] = ACTIONS(1507),
    [anon_sym_struct] = ACTIONS(1507),
    [anon_sym_trait] = ACTIONS(1507),
    [anon_sym_type] = ACTIONS(1507),
    [anon_sym_union] = ACTIONS(1507),
    [anon_sym_unsafe] = ACTIONS(1507),
    [anon_sym_use] = ACTIONS(1507),
    [anon_sym_while] = ACTIONS(1507),
    [anon_sym_POUND] = ACTIONS(1505),
    [anon_sym_BANG] = ACTIONS(1505),
    [anon_sym_extern] = ACTIONS(1507),
    [anon_sym_LT] = ACTIONS(1505),
    [anon_sym_COLON_COLON] = ACTIONS(1505),
    [anon_sym_AMP] = ACTIONS(1505),
    [anon_sym_DOT_DOT] = ACTIONS(1505),
    [anon_sym_DASH] = ACTIONS(1505),
    [anon_sym_PIPE] = ACTIONS(1505),
    [anon_sym_move] = ACTIONS(1507),
    [sym_integer_literal] = ACTIONS(1505),
    [aux_sym_string_literal_token1] = ACTIONS(1505),
    [sym_char_literal] = ACTIONS(1505),
    [anon_sym_true] = ACTIONS(1507),
    [anon_sym_false] = ACTIONS(1507),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1507),
    [sym_super] = ACTIONS(1507),
    [sym_crate] = ACTIONS(1507),
    [sym_metavariable] = ACTIONS(1505),
    [sym_raw_string_literal] = ACTIONS(1505),
    [sym_float_literal] = ACTIONS(1505),
    [sym_block_comment] = ACTIONS(3),
  },
  [295] = {
    [ts_builtin_sym_end] = ACTIONS(1509),
    [sym_identifier] = ACTIONS(1511),
    [anon_sym_SEMI] = ACTIONS(1509),
    [anon_sym_macro_rules_BANG] = ACTIONS(1509),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [anon_sym_LBRACE] = ACTIONS(1509),
    [anon_sym_RBRACE] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(1509),
    [anon_sym_STAR] = ACTIONS(1509),
    [anon_sym_u8] = ACTIONS(1511),
    [anon_sym_i8] = ACTIONS(1511),
    [anon_sym_u16] = ACTIONS(1511),
    [anon_sym_i16] = ACTIONS(1511),
    [anon_sym_u32] = ACTIONS(1511),
    [anon_sym_i32] = ACTIONS(1511),
    [anon_sym_u64] = ACTIONS(1511),
    [anon_sym_i64] = ACTIONS(1511),
    [anon_sym_u128] = ACTIONS(1511),
    [anon_sym_i128] = ACTIONS(1511),
    [anon_sym_isize] = ACTIONS(1511),
    [anon_sym_usize] = ACTIONS(1511),
    [anon_sym_f32] = ACTIONS(1511),
    [anon_sym_f64] = ACTIONS(1511),
    [anon_sym_bool] = ACTIONS(1511),
    [anon_sym_str] = ACTIONS(1511),
    [anon_sym_char] = ACTIONS(1511),
    [anon_sym_SQUOTE] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1511),
    [anon_sym_const] = ACTIONS(1511),
    [anon_sym_continue] = ACTIONS(1511),
    [anon_sym_default] = ACTIONS(1511),
    [anon_sym_enum] = ACTIONS(1511),
    [anon_sym_fn] = ACTIONS(1511),
    [anon_sym_for] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(1511),
    [anon_sym_impl] = ACTIONS(1511),
    [anon_sym_let] = ACTIONS(1511),
    [anon_sym_loop] = ACTIONS(1511),
    [anon_sym_match] = ACTIONS(1511),
    [anon_sym_mod] = ACTIONS(1511),
    [anon_sym_pub] = ACTIONS(1511),
    [anon_sym_return] = ACTIONS(1511),
    [anon_sym_static] = ACTIONS(1511),
    [anon_sym_struct] = ACTIONS(1511),
    [anon_sym_trait] = ACTIONS(1511),
    [anon_sym_type] = ACTIONS(1511),
    [anon_sym_union] = ACTIONS(1511),
    [anon_sym_unsafe] = ACTIONS(1511),
    [anon_sym_use] = ACTIONS(1511),
    [anon_sym_while] = ACTIONS(1511),
    [anon_sym_POUND] = ACTIONS(1509),
    [anon_sym_BANG] = ACTIONS(1509),
    [anon_sym_extern] = ACTIONS(1511),
    [anon_sym_LT] = ACTIONS(1509),
    [anon_sym_COLON_COLON] = ACTIONS(1509),
    [anon_sym_AMP] = ACTIONS(1509),
    [anon_sym_DOT_DOT] = ACTIONS(1509),
    [anon_sym_DASH] = ACTIONS(1509),
    [anon_sym_PIPE] = ACTIONS(1509),
    [anon_sym_move] = ACTIONS(1511),
    [sym_integer_literal] = ACTIONS(1509),
    [aux_sym_string_literal_token1] = ACTIONS(1509),
    [sym_char_literal] = ACTIONS(1509),
    [anon_sym_true] = ACTIONS(1511),
    [anon_sym_false] = ACTIONS(1511),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1511),
    [sym_super] = ACTIONS(1511),
    [sym_crate] = ACTIONS(1511),
    [sym_metavariable] = ACTIONS(1509),
    [sym_raw_string_literal] = ACTIONS(1509),
    [sym_float_literal] = ACTIONS(1509),
    [sym_block_comment] = ACTIONS(3),
  },
  [296] = {
    [ts_builtin_sym_end] = ACTIONS(1513),
    [sym_identifier] = ACTIONS(1515),
    [anon_sym_SEMI] = ACTIONS(1513),
    [anon_sym_macro_rules_BANG] = ACTIONS(1513),
    [anon_sym_LPAREN] = ACTIONS(1513),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_RBRACE] = ACTIONS(1513),
    [anon_sym_LBRACK] = ACTIONS(1513),
    [anon_sym_STAR] = ACTIONS(1513),
    [anon_sym_u8] = ACTIONS(1515),
    [anon_sym_i8] = ACTIONS(1515),
    [anon_sym_u16] = ACTIONS(1515),
    [anon_sym_i16] = ACTIONS(1515),
    [anon_sym_u32] = ACTIONS(1515),
    [anon_sym_i32] = ACTIONS(1515),
    [anon_sym_u64] = ACTIONS(1515),
    [anon_sym_i64] = ACTIONS(1515),
    [anon_sym_u128] = ACTIONS(1515),
    [anon_sym_i128] = ACTIONS(1515),
    [anon_sym_isize] = ACTIONS(1515),
    [anon_sym_usize] = ACTIONS(1515),
    [anon_sym_f32] = ACTIONS(1515),
    [anon_sym_f64] = ACTIONS(1515),
    [anon_sym_bool] = ACTIONS(1515),
    [anon_sym_str] = ACTIONS(1515),
    [anon_sym_char] = ACTIONS(1515),
    [anon_sym_SQUOTE] = ACTIONS(1515),
    [anon_sym_async] = ACTIONS(1515),
    [anon_sym_break] = ACTIONS(1515),
    [anon_sym_const] = ACTIONS(1515),
    [anon_sym_continue] = ACTIONS(1515),
    [anon_sym_default] = ACTIONS(1515),
    [anon_sym_enum] = ACTIONS(1515),
    [anon_sym_fn] = ACTIONS(1515),
    [anon_sym_for] = ACTIONS(1515),
    [anon_sym_if] = ACTIONS(1515),
    [anon_sym_impl] = ACTIONS(1515),
    [anon_sym_let] = ACTIONS(1515),
    [anon_sym_loop] = ACTIONS(1515),
    [anon_sym_match] = ACTIONS(1515),
    [anon_sym_mod] = ACTIONS(1515),
    [anon_sym_pub] = ACTIONS(1515),
    [anon_sym_return] = ACTIONS(1515),
    [anon_sym_static] = ACTIONS(1515),
    [anon_sym_struct] = ACTIONS(1515),
    [anon_sym_trait] = ACTIONS(1515),
    [anon_sym_type] = ACTIONS(1515),
    [anon_sym_union] = ACTIONS(1515),
    [anon_sym_unsafe] = ACTIONS(1515),
    [anon_sym_use] = ACTIONS(1515),
    [anon_sym_while] = ACTIONS(1515),
    [anon_sym_POUND] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(1513),
    [anon_sym_extern] = ACTIONS(1515),
    [anon_sym_LT] = ACTIONS(1513),
    [anon_sym_COLON_COLON] = ACTIONS(1513),
    [anon_sym_AMP] = ACTIONS(1513),
    [anon_sym_DOT_DOT] = ACTIONS(1513),
    [anon_sym_DASH] = ACTIONS(1513),
    [anon_sym_PIPE] = ACTIONS(1513),
    [anon_sym_move] = ACTIONS(1515),
    [sym_integer_literal] = ACTIONS(1513),
    [aux_sym_string_literal_token1] = ACTIONS(1513),
    [sym_char_literal] = ACTIONS(1513),
    [anon_sym_true] = ACTIONS(1515),
    [anon_sym_false] = ACTIONS(1515),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1515),
    [sym_super] = ACTIONS(1515),
    [sym_crate] = ACTIONS(1515),
    [sym_metavariable] = ACTIONS(1513),
    [sym_raw_string_literal] = ACTIONS(1513),
    [sym_float_literal] = ACTIONS(1513),
    [sym_block_comment] = ACTIONS(3),
  },
  [297] = {
    [ts_builtin_sym_end] = ACTIONS(1517),
    [sym_identifier] = ACTIONS(1519),
    [anon_sym_SEMI] = ACTIONS(1517),
    [anon_sym_macro_rules_BANG] = ACTIONS(1517),
    [anon_sym_LPAREN] = ACTIONS(1517),
    [anon_sym_LBRACE] = ACTIONS(1517),
    [anon_sym_RBRACE] = ACTIONS(1517),
    [anon_sym_LBRACK] = ACTIONS(1517),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_u8] = ACTIONS(1519),
    [anon_sym_i8] = ACTIONS(1519),
    [anon_sym_u16] = ACTIONS(1519),
    [anon_sym_i16] = ACTIONS(1519),
    [anon_sym_u32] = ACTIONS(1519),
    [anon_sym_i32] = ACTIONS(1519),
    [anon_sym_u64] = ACTIONS(1519),
    [anon_sym_i64] = ACTIONS(1519),
    [anon_sym_u128] = ACTIONS(1519),
    [anon_sym_i128] = ACTIONS(1519),
    [anon_sym_isize] = ACTIONS(1519),
    [anon_sym_usize] = ACTIONS(1519),
    [anon_sym_f32] = ACTIONS(1519),
    [anon_sym_f64] = ACTIONS(1519),
    [anon_sym_bool] = ACTIONS(1519),
    [anon_sym_str] = ACTIONS(1519),
    [anon_sym_char] = ACTIONS(1519),
    [anon_sym_SQUOTE] = ACTIONS(1519),
    [anon_sym_async] = ACTIONS(1519),
    [anon_sym_break] = ACTIONS(1519),
    [anon_sym_const] = ACTIONS(1519),
    [anon_sym_continue] = ACTIONS(1519),
    [anon_sym_default] = ACTIONS(1519),
    [anon_sym_enum] = ACTIONS(1519),
    [anon_sym_fn] = ACTIONS(1519),
    [anon_sym_for] = ACTIONS(1519),
    [anon_sym_if] = ACTIONS(1519),
    [anon_sym_impl] = ACTIONS(1519),
    [anon_sym_let] = ACTIONS(1519),
    [anon_sym_loop] = ACTIONS(1519),
    [anon_sym_match] = ACTIONS(1519),
    [anon_sym_mod] = ACTIONS(1519),
    [anon_sym_pub] = ACTIONS(1519),
    [anon_sym_return] = ACTIONS(1519),
    [anon_sym_static] = ACTIONS(1519),
    [anon_sym_struct] = ACTIONS(1519),
    [anon_sym_trait] = ACTIONS(1519),
    [anon_sym_type] = ACTIONS(1519),
    [anon_sym_union] = ACTIONS(1519),
    [anon_sym_unsafe] = ACTIONS(1519),
    [anon_sym_use] = ACTIONS(1519),
    [anon_sym_while] = ACTIONS(1519),
    [anon_sym_POUND] = ACTIONS(1517),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_extern] = ACTIONS(1519),
    [anon_sym_LT] = ACTIONS(1517),
    [anon_sym_COLON_COLON] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_DOT_DOT] = ACTIONS(1517),
    [anon_sym_DASH] = ACTIONS(1517),
    [anon_sym_PIPE] = ACTIONS(1517),
    [anon_sym_move] = ACTIONS(1519),
    [sym_integer_literal] = ACTIONS(1517),
    [aux_sym_string_literal_token1] = ACTIONS(1517),
    [sym_char_literal] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(1519),
    [anon_sym_false] = ACTIONS(1519),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1519),
    [sym_super] = ACTIONS(1519),
    [sym_crate] = ACTIONS(1519),
    [sym_metavariable] = ACTIONS(1517),
    [sym_raw_string_literal] = ACTIONS(1517),
    [sym_float_literal] = ACTIONS(1517),
    [sym_block_comment] = ACTIONS(3),
  },
  [298] = {
    [ts_builtin_sym_end] = ACTIONS(1521),
    [sym_identifier] = ACTIONS(1523),
    [anon_sym_SEMI] = ACTIONS(1521),
    [anon_sym_macro_rules_BANG] = ACTIONS(1521),
    [anon_sym_LPAREN] = ACTIONS(1521),
    [anon_sym_LBRACE] = ACTIONS(1521),
    [anon_sym_RBRACE] = ACTIONS(1521),
    [anon_sym_LBRACK] = ACTIONS(1521),
    [anon_sym_STAR] = ACTIONS(1521),
    [anon_sym_u8] = ACTIONS(1523),
    [anon_sym_i8] = ACTIONS(1523),
    [anon_sym_u16] = ACTIONS(1523),
    [anon_sym_i16] = ACTIONS(1523),
    [anon_sym_u32] = ACTIONS(1523),
    [anon_sym_i32] = ACTIONS(1523),
    [anon_sym_u64] = ACTIONS(1523),
    [anon_sym_i64] = ACTIONS(1523),
    [anon_sym_u128] = ACTIONS(1523),
    [anon_sym_i128] = ACTIONS(1523),
    [anon_sym_isize] = ACTIONS(1523),
    [anon_sym_usize] = ACTIONS(1523),
    [anon_sym_f32] = ACTIONS(1523),
    [anon_sym_f64] = ACTIONS(1523),
    [anon_sym_bool] = ACTIONS(1523),
    [anon_sym_str] = ACTIONS(1523),
    [anon_sym_char] = ACTIONS(1523),
    [anon_sym_SQUOTE] = ACTIONS(1523),
    [anon_sym_async] = ACTIONS(1523),
    [anon_sym_break] = ACTIONS(1523),
    [anon_sym_const] = ACTIONS(1523),
    [anon_sym_continue] = ACTIONS(1523),
    [anon_sym_default] = ACTIONS(1523),
    [anon_sym_enum] = ACTIONS(1523),
    [anon_sym_fn] = ACTIONS(1523),
    [anon_sym_for] = ACTIONS(1523),
    [anon_sym_if] = ACTIONS(1523),
    [anon_sym_impl] = ACTIONS(1523),
    [anon_sym_let] = ACTIONS(1523),
    [anon_sym_loop] = ACTIONS(1523),
    [anon_sym_match] = ACTIONS(1523),
    [anon_sym_mod] = ACTIONS(1523),
    [anon_sym_pub] = ACTIONS(1523),
    [anon_sym_return] = ACTIONS(1523),
    [anon_sym_static] = ACTIONS(1523),
    [anon_sym_struct] = ACTIONS(1523),
    [anon_sym_trait] = ACTIONS(1523),
    [anon_sym_type] = ACTIONS(1523),
    [anon_sym_union] = ACTIONS(1523),
    [anon_sym_unsafe] = ACTIONS(1523),
    [anon_sym_use] = ACTIONS(1523),
    [anon_sym_while] = ACTIONS(1523),
    [anon_sym_POUND] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1521),
    [anon_sym_extern] = ACTIONS(1523),
    [anon_sym_LT] = ACTIONS(1521),
    [anon_sym_COLON_COLON] = ACTIONS(1521),
    [anon_sym_AMP] = ACTIONS(1521),
    [anon_sym_DOT_DOT] = ACTIONS(1521),
    [anon_sym_DASH] = ACTIONS(1521),
    [anon_sym_PIPE] = ACTIONS(1521),
    [anon_sym_move] = ACTIONS(1523),
    [sym_integer_literal] = ACTIONS(1521),
    [aux_sym_string_literal_token1] = ACTIONS(1521),
    [sym_char_literal] = ACTIONS(1521),
    [anon_sym_true] = ACTIONS(1523),
    [anon_sym_false] = ACTIONS(1523),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1523),
    [sym_super] = ACTIONS(1523),
    [sym_crate] = ACTIONS(1523),
    [sym_metavariable] = ACTIONS(1521),
    [sym_raw_string_literal] = ACTIONS(1521),
    [sym_float_literal] = ACTIONS(1521),
    [sym_block_comment] = ACTIONS(3),
  },
  [299] = {
    [ts_builtin_sym_end] = ACTIONS(427),
    [sym_identifier] = ACTIONS(429),
    [anon_sym_SEMI] = ACTIONS(427),
    [anon_sym_macro_rules_BANG] = ACTIONS(427),
    [anon_sym_LPAREN] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(427),
    [anon_sym_RBRACE] = ACTIONS(427),
    [anon_sym_LBRACK] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(427),
    [anon_sym_u8] = ACTIONS(429),
    [anon_sym_i8] = ACTIONS(429),
    [anon_sym_u16] = ACTIONS(429),
    [anon_sym_i16] = ACTIONS(429),
    [anon_sym_u32] = ACTIONS(429),
    [anon_sym_i32] = ACTIONS(429),
    [anon_sym_u64] = ACTIONS(429),
    [anon_sym_i64] = ACTIONS(429),
    [anon_sym_u128] = ACTIONS(429),
    [anon_sym_i128] = ACTIONS(429),
    [anon_sym_isize] = ACTIONS(429),
    [anon_sym_usize] = ACTIONS(429),
    [anon_sym_f32] = ACTIONS(429),
    [anon_sym_f64] = ACTIONS(429),
    [anon_sym_bool] = ACTIONS(429),
    [anon_sym_str] = ACTIONS(429),
    [anon_sym_char] = ACTIONS(429),
    [anon_sym_SQUOTE] = ACTIONS(429),
    [anon_sym_async] = ACTIONS(429),
    [anon_sym_break] = ACTIONS(429),
    [anon_sym_const] = ACTIONS(429),
    [anon_sym_continue] = ACTIONS(429),
    [anon_sym_default] = ACTIONS(429),
    [anon_sym_enum] = ACTIONS(429),
    [anon_sym_fn] = ACTIONS(429),
    [anon_sym_for] = ACTIONS(429),
    [anon_sym_if] = ACTIONS(429),
    [anon_sym_impl] = ACTIONS(429),
    [anon_sym_let] = ACTIONS(429),
    [anon_sym_loop] = ACTIONS(429),
    [anon_sym_match] = ACTIONS(429),
    [anon_sym_mod] = ACTIONS(429),
    [anon_sym_pub] = ACTIONS(429),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_static] = ACTIONS(429),
    [anon_sym_struct] = ACTIONS(429),
    [anon_sym_trait] = ACTIONS(429),
    [anon_sym_type] = ACTIONS(429),
    [anon_sym_union] = ACTIONS(429),
    [anon_sym_unsafe] = ACTIONS(429),
    [anon_sym_use] = ACTIONS(429),
    [anon_sym_while] = ACTIONS(429),
    [anon_sym_POUND] = ACTIONS(427),
    [anon_sym_BANG] = ACTIONS(427),
    [anon_sym_extern] = ACTIONS(429),
    [anon_sym_LT] = ACTIONS(427),
    [anon_sym_COLON_COLON] = ACTIONS(427),
    [anon_sym_AMP] = ACTIONS(427),
    [anon_sym_DOT_DOT] = ACTIONS(427),
    [anon_sym_DASH] = ACTIONS(427),
    [anon_sym_PIPE] = ACTIONS(427),
    [anon_sym_move] = ACTIONS(429),
    [sym_integer_literal] = ACTIONS(427),
    [aux_sym_string_literal_token1] = ACTIONS(427),
    [sym_char_literal] = ACTIONS(427),
    [anon_sym_true] = ACTIONS(429),
    [anon_sym_false] = ACTIONS(429),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(429),
    [sym_super] = ACTIONS(429),
    [sym_crate] = ACTIONS(429),
    [sym_metavariable] = ACTIONS(427),
    [sym_raw_string_literal] = ACTIONS(427),
    [sym_float_literal] = ACTIONS(427),
    [sym_block_comment] = ACTIONS(3),
  },
  [300] = {
    [ts_builtin_sym_end] = ACTIONS(1525),
    [sym_identifier] = ACTIONS(1527),
    [anon_sym_SEMI] = ACTIONS(1525),
    [anon_sym_macro_rules_BANG] = ACTIONS(1525),
    [anon_sym_LPAREN] = ACTIONS(1525),
    [anon_sym_LBRACE] = ACTIONS(1525),
    [anon_sym_RBRACE] = ACTIONS(1525),
    [anon_sym_LBRACK] = ACTIONS(1525),
    [anon_sym_STAR] = ACTIONS(1525),
    [anon_sym_u8] = ACTIONS(1527),
    [anon_sym_i8] = ACTIONS(1527),
    [anon_sym_u16] = ACTIONS(1527),
    [anon_sym_i16] = ACTIONS(1527),
    [anon_sym_u32] = ACTIONS(1527),
    [anon_sym_i32] = ACTIONS(1527),
    [anon_sym_u64] = ACTIONS(1527),
    [anon_sym_i64] = ACTIONS(1527),
    [anon_sym_u128] = ACTIONS(1527),
    [anon_sym_i128] = ACTIONS(1527),
    [anon_sym_isize] = ACTIONS(1527),
    [anon_sym_usize] = ACTIONS(1527),
    [anon_sym_f32] = ACTIONS(1527),
    [anon_sym_f64] = ACTIONS(1527),
    [anon_sym_bool] = ACTIONS(1527),
    [anon_sym_str] = ACTIONS(1527),
    [anon_sym_char] = ACTIONS(1527),
    [anon_sym_SQUOTE] = ACTIONS(1527),
    [anon_sym_async] = ACTIONS(1527),
    [anon_sym_break] = ACTIONS(1527),
    [anon_sym_const] = ACTIONS(1527),
    [anon_sym_continue] = ACTIONS(1527),
    [anon_sym_default] = ACTIONS(1527),
    [anon_sym_enum] = ACTIONS(1527),
    [anon_sym_fn] = ACTIONS(1527),
    [anon_sym_for] = ACTIONS(1527),
    [anon_sym_if] = ACTIONS(1527),
    [anon_sym_impl] = ACTIONS(1527),
    [anon_sym_let] = ACTIONS(1527),
    [anon_sym_loop] = ACTIONS(1527),
    [anon_sym_match] = ACTIONS(1527),
    [anon_sym_mod] = ACTIONS(1527),
    [anon_sym_pub] = ACTIONS(1527),
    [anon_sym_return] = ACTIONS(1527),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_struct] = ACTIONS(1527),
    [anon_sym_trait] = ACTIONS(1527),
    [anon_sym_type] = ACTIONS(1527),
    [anon_sym_union] = ACTIONS(1527),
    [anon_sym_unsafe] = ACTIONS(1527),
    [anon_sym_use] = ACTIONS(1527),
    [anon_sym_while] = ACTIONS(1527),
    [anon_sym_POUND] = ACTIONS(1525),
    [anon_sym_BANG] = ACTIONS(1525),
    [anon_sym_extern] = ACTIONS(1527),
    [anon_sym_LT] = ACTIONS(1525),
    [anon_sym_COLON_COLON] = ACTIONS(1525),
    [anon_sym_AMP] = ACTIONS(1525),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym_DASH] = ACTIONS(1525),
    [anon_sym_PIPE] = ACTIONS(1525),
    [anon_sym_move] = ACTIONS(1527),
    [sym_integer_literal] = ACTIONS(1525),
    [aux_sym_string_literal_token1] = ACTIONS(1525),
    [sym_char_literal] = ACTIONS(1525),
    [anon_sym_true] = ACTIONS(1527),
    [anon_sym_false] = ACTIONS(1527),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1527),
    [sym_super] = ACTIONS(1527),
    [sym_crate] = ACTIONS(1527),
    [sym_metavariable] = ACTIONS(1525),
    [sym_raw_string_literal] = ACTIONS(1525),
    [sym_float_literal] = ACTIONS(1525),
    [sym_block_comment] = ACTIONS(3),
  },
  [301] = {
    [ts_builtin_sym_end] = ACTIONS(1529),
    [sym_identifier] = ACTIONS(1531),
    [anon_sym_SEMI] = ACTIONS(1529),
    [anon_sym_macro_rules_BANG] = ACTIONS(1529),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_LBRACE] = ACTIONS(1529),
    [anon_sym_RBRACE] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1529),
    [anon_sym_STAR] = ACTIONS(1529),
    [anon_sym_u8] = ACTIONS(1531),
    [anon_sym_i8] = ACTIONS(1531),
    [anon_sym_u16] = ACTIONS(1531),
    [anon_sym_i16] = ACTIONS(1531),
    [anon_sym_u32] = ACTIONS(1531),
    [anon_sym_i32] = ACTIONS(1531),
    [anon_sym_u64] = ACTIONS(1531),
    [anon_sym_i64] = ACTIONS(1531),
    [anon_sym_u128] = ACTIONS(1531),
    [anon_sym_i128] = ACTIONS(1531),
    [anon_sym_isize] = ACTIONS(1531),
    [anon_sym_usize] = ACTIONS(1531),
    [anon_sym_f32] = ACTIONS(1531),
    [anon_sym_f64] = ACTIONS(1531),
    [anon_sym_bool] = ACTIONS(1531),
    [anon_sym_str] = ACTIONS(1531),
    [anon_sym_char] = ACTIONS(1531),
    [anon_sym_SQUOTE] = ACTIONS(1531),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_break] = ACTIONS(1531),
    [anon_sym_const] = ACTIONS(1531),
    [anon_sym_continue] = ACTIONS(1531),
    [anon_sym_default] = ACTIONS(1531),
    [anon_sym_enum] = ACTIONS(1531),
    [anon_sym_fn] = ACTIONS(1531),
    [anon_sym_for] = ACTIONS(1531),
    [anon_sym_if] = ACTIONS(1531),
    [anon_sym_impl] = ACTIONS(1531),
    [anon_sym_let] = ACTIONS(1531),
    [anon_sym_loop] = ACTIONS(1531),
    [anon_sym_match] = ACTIONS(1531),
    [anon_sym_mod] = ACTIONS(1531),
    [anon_sym_pub] = ACTIONS(1531),
    [anon_sym_return] = ACTIONS(1531),
    [anon_sym_static] = ACTIONS(1531),
    [anon_sym_struct] = ACTIONS(1531),
    [anon_sym_trait] = ACTIONS(1531),
    [anon_sym_type] = ACTIONS(1531),
    [anon_sym_union] = ACTIONS(1531),
    [anon_sym_unsafe] = ACTIONS(1531),
    [anon_sym_use] = ACTIONS(1531),
    [anon_sym_while] = ACTIONS(1531),
    [anon_sym_POUND] = ACTIONS(1529),
    [anon_sym_BANG] = ACTIONS(1529),
    [anon_sym_extern] = ACTIONS(1531),
    [anon_sym_LT] = ACTIONS(1529),
    [anon_sym_COLON_COLON] = ACTIONS(1529),
    [anon_sym_AMP] = ACTIONS(1529),
    [anon_sym_DOT_DOT] = ACTIONS(1529),
    [anon_sym_DASH] = ACTIONS(1529),
    [anon_sym_PIPE] = ACTIONS(1529),
    [anon_sym_move] = ACTIONS(1531),
    [sym_integer_literal] = ACTIONS(1529),
    [aux_sym_string_literal_token1] = ACTIONS(1529),
    [sym_char_literal] = ACTIONS(1529),
    [anon_sym_true] = ACTIONS(1531),
    [anon_sym_false] = ACTIONS(1531),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1531),
    [sym_super] = ACTIONS(1531),
    [sym_crate] = ACTIONS(1531),
    [sym_metavariable] = ACTIONS(1529),
    [sym_raw_string_literal] = ACTIONS(1529),
    [sym_float_literal] = ACTIONS(1529),
    [sym_block_comment] = ACTIONS(3),
  },
  [302] = {
    [ts_builtin_sym_end] = ACTIONS(1533),
    [sym_identifier] = ACTIONS(1535),
    [anon_sym_SEMI] = ACTIONS(1533),
    [anon_sym_macro_rules_BANG] = ACTIONS(1533),
    [anon_sym_LPAREN] = ACTIONS(1533),
    [anon_sym_LBRACE] = ACTIONS(1533),
    [anon_sym_RBRACE] = ACTIONS(1533),
    [anon_sym_LBRACK] = ACTIONS(1533),
    [anon_sym_STAR] = ACTIONS(1533),
    [anon_sym_u8] = ACTIONS(1535),
    [anon_sym_i8] = ACTIONS(1535),
    [anon_sym_u16] = ACTIONS(1535),
    [anon_sym_i16] = ACTIONS(1535),
    [anon_sym_u32] = ACTIONS(1535),
    [anon_sym_i32] = ACTIONS(1535),
    [anon_sym_u64] = ACTIONS(1535),
    [anon_sym_i64] = ACTIONS(1535),
    [anon_sym_u128] = ACTIONS(1535),
    [anon_sym_i128] = ACTIONS(1535),
    [anon_sym_isize] = ACTIONS(1535),
    [anon_sym_usize] = ACTIONS(1535),
    [anon_sym_f32] = ACTIONS(1535),
    [anon_sym_f64] = ACTIONS(1535),
    [anon_sym_bool] = ACTIONS(1535),
    [anon_sym_str] = ACTIONS(1535),
    [anon_sym_char] = ACTIONS(1535),
    [anon_sym_SQUOTE] = ACTIONS(1535),
    [anon_sym_async] = ACTIONS(1535),
    [anon_sym_break] = ACTIONS(1535),
    [anon_sym_const] = ACTIONS(1535),
    [anon_sym_continue] = ACTIONS(1535),
    [anon_sym_default] = ACTIONS(1535),
    [anon_sym_enum] = ACTIONS(1535),
    [anon_sym_fn] = ACTIONS(1535),
    [anon_sym_for] = ACTIONS(1535),
    [anon_sym_if] = ACTIONS(1535),
    [anon_sym_impl] = ACTIONS(1535),
    [anon_sym_let] = ACTIONS(1535),
    [anon_sym_loop] = ACTIONS(1535),
    [anon_sym_match] = ACTIONS(1535),
    [anon_sym_mod] = ACTIONS(1535),
    [anon_sym_pub] = ACTIONS(1535),
    [anon_sym_return] = ACTIONS(1535),
    [anon_sym_static] = ACTIONS(1535),
    [anon_sym_struct] = ACTIONS(1535),
    [anon_sym_trait] = ACTIONS(1535),
    [anon_sym_type] = ACTIONS(1535),
    [anon_sym_union] = ACTIONS(1535),
    [anon_sym_unsafe] = ACTIONS(1535),
    [anon_sym_use] = ACTIONS(1535),
    [anon_sym_while] = ACTIONS(1535),
    [anon_sym_POUND] = ACTIONS(1533),
    [anon_sym_BANG] = ACTIONS(1533),
    [anon_sym_extern] = ACTIONS(1535),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_COLON_COLON] = ACTIONS(1533),
    [anon_sym_AMP] = ACTIONS(1533),
    [anon_sym_DOT_DOT] = ACTIONS(1533),
    [anon_sym_DASH] = ACTIONS(1533),
    [anon_sym_PIPE] = ACTIONS(1533),
    [anon_sym_move] = ACTIONS(1535),
    [sym_integer_literal] = ACTIONS(1533),
    [aux_sym_string_literal_token1] = ACTIONS(1533),
    [sym_char_literal] = ACTIONS(1533),
    [anon_sym_true] = ACTIONS(1535),
    [anon_sym_false] = ACTIONS(1535),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1535),
    [sym_super] = ACTIONS(1535),
    [sym_crate] = ACTIONS(1535),
    [sym_metavariable] = ACTIONS(1533),
    [sym_raw_string_literal] = ACTIONS(1533),
    [sym_float_literal] = ACTIONS(1533),
    [sym_block_comment] = ACTIONS(3),
  },
  [303] = {
    [ts_builtin_sym_end] = ACTIONS(1537),
    [sym_identifier] = ACTIONS(1539),
    [anon_sym_SEMI] = ACTIONS(1537),
    [anon_sym_macro_rules_BANG] = ACTIONS(1537),
    [anon_sym_LPAREN] = ACTIONS(1537),
    [anon_sym_LBRACE] = ACTIONS(1537),
    [anon_sym_RBRACE] = ACTIONS(1537),
    [anon_sym_LBRACK] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1537),
    [anon_sym_u8] = ACTIONS(1539),
    [anon_sym_i8] = ACTIONS(1539),
    [anon_sym_u16] = ACTIONS(1539),
    [anon_sym_i16] = ACTIONS(1539),
    [anon_sym_u32] = ACTIONS(1539),
    [anon_sym_i32] = ACTIONS(1539),
    [anon_sym_u64] = ACTIONS(1539),
    [anon_sym_i64] = ACTIONS(1539),
    [anon_sym_u128] = ACTIONS(1539),
    [anon_sym_i128] = ACTIONS(1539),
    [anon_sym_isize] = ACTIONS(1539),
    [anon_sym_usize] = ACTIONS(1539),
    [anon_sym_f32] = ACTIONS(1539),
    [anon_sym_f64] = ACTIONS(1539),
    [anon_sym_bool] = ACTIONS(1539),
    [anon_sym_str] = ACTIONS(1539),
    [anon_sym_char] = ACTIONS(1539),
    [anon_sym_SQUOTE] = ACTIONS(1539),
    [anon_sym_async] = ACTIONS(1539),
    [anon_sym_break] = ACTIONS(1539),
    [anon_sym_const] = ACTIONS(1539),
    [anon_sym_continue] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(1539),
    [anon_sym_enum] = ACTIONS(1539),
    [anon_sym_fn] = ACTIONS(1539),
    [anon_sym_for] = ACTIONS(1539),
    [anon_sym_if] = ACTIONS(1539),
    [anon_sym_impl] = ACTIONS(1539),
    [anon_sym_let] = ACTIONS(1539),
    [anon_sym_loop] = ACTIONS(1539),
    [anon_sym_match] = ACTIONS(1539),
    [anon_sym_mod] = ACTIONS(1539),
    [anon_sym_pub] = ACTIONS(1539),
    [anon_sym_return] = ACTIONS(1539),
    [anon_sym_static] = ACTIONS(1539),
    [anon_sym_struct] = ACTIONS(1539),
    [anon_sym_trait] = ACTIONS(1539),
    [anon_sym_type] = ACTIONS(1539),
    [anon_sym_union] = ACTIONS(1539),
    [anon_sym_unsafe] = ACTIONS(1539),
    [anon_sym_use] = ACTIONS(1539),
    [anon_sym_while] = ACTIONS(1539),
    [anon_sym_POUND] = ACTIONS(1537),
    [anon_sym_BANG] = ACTIONS(1537),
    [anon_sym_extern] = ACTIONS(1539),
    [anon_sym_LT] = ACTIONS(1537),
    [anon_sym_COLON_COLON] = ACTIONS(1537),
    [anon_sym_AMP] = ACTIONS(1537),
    [anon_sym_DOT_DOT] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(1537),
    [anon_sym_move] = ACTIONS(1539),
    [sym_integer_literal] = ACTIONS(1537),
    [aux_sym_string_literal_token1] = ACTIONS(1537),
    [sym_char_literal] = ACTIONS(1537),
    [anon_sym_true] = ACTIONS(1539),
    [anon_sym_false] = ACTIONS(1539),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1539),
    [sym_super] = ACTIONS(1539),
    [sym_crate] = ACTIONS(1539),
    [sym_metavariable] = ACTIONS(1537),
    [sym_raw_string_literal] = ACTIONS(1537),
    [sym_float_literal] = ACTIONS(1537),
    [sym_block_comment] = ACTIONS(3),
  },
  [304] = {
    [ts_builtin_sym_end] = ACTIONS(1541),
    [sym_identifier] = ACTIONS(1543),
    [anon_sym_SEMI] = ACTIONS(1541),
    [anon_sym_macro_rules_BANG] = ACTIONS(1541),
    [anon_sym_LPAREN] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(1541),
    [anon_sym_RBRACE] = ACTIONS(1541),
    [anon_sym_LBRACK] = ACTIONS(1541),
    [anon_sym_STAR] = ACTIONS(1541),
    [anon_sym_u8] = ACTIONS(1543),
    [anon_sym_i8] = ACTIONS(1543),
    [anon_sym_u16] = ACTIONS(1543),
    [anon_sym_i16] = ACTIONS(1543),
    [anon_sym_u32] = ACTIONS(1543),
    [anon_sym_i32] = ACTIONS(1543),
    [anon_sym_u64] = ACTIONS(1543),
    [anon_sym_i64] = ACTIONS(1543),
    [anon_sym_u128] = ACTIONS(1543),
    [anon_sym_i128] = ACTIONS(1543),
    [anon_sym_isize] = ACTIONS(1543),
    [anon_sym_usize] = ACTIONS(1543),
    [anon_sym_f32] = ACTIONS(1543),
    [anon_sym_f64] = ACTIONS(1543),
    [anon_sym_bool] = ACTIONS(1543),
    [anon_sym_str] = ACTIONS(1543),
    [anon_sym_char] = ACTIONS(1543),
    [anon_sym_SQUOTE] = ACTIONS(1543),
    [anon_sym_async] = ACTIONS(1543),
    [anon_sym_break] = ACTIONS(1543),
    [anon_sym_const] = ACTIONS(1543),
    [anon_sym_continue] = ACTIONS(1543),
    [anon_sym_default] = ACTIONS(1543),
    [anon_sym_enum] = ACTIONS(1543),
    [anon_sym_fn] = ACTIONS(1543),
    [anon_sym_for] = ACTIONS(1543),
    [anon_sym_if] = ACTIONS(1543),
    [anon_sym_impl] = ACTIONS(1543),
    [anon_sym_let] = ACTIONS(1543),
    [anon_sym_loop] = ACTIONS(1543),
    [anon_sym_match] = ACTIONS(1543),
    [anon_sym_mod] = ACTIONS(1543),
    [anon_sym_pub] = ACTIONS(1543),
    [anon_sym_return] = ACTIONS(1543),
    [anon_sym_static] = ACTIONS(1543),
    [anon_sym_struct] = ACTIONS(1543),
    [anon_sym_trait] = ACTIONS(1543),
    [anon_sym_type] = ACTIONS(1543),
    [anon_sym_union] = ACTIONS(1543),
    [anon_sym_unsafe] = ACTIONS(1543),
    [anon_sym_use] = ACTIONS(1543),
    [anon_sym_while] = ACTIONS(1543),
    [anon_sym_POUND] = ACTIONS(1541),
    [anon_sym_BANG] = ACTIONS(1541),
    [anon_sym_extern] = ACTIONS(1543),
    [anon_sym_LT] = ACTIONS(1541),
    [anon_sym_COLON_COLON] = ACTIONS(1541),
    [anon_sym_AMP] = ACTIONS(1541),
    [anon_sym_DOT_DOT] = ACTIONS(1541),
    [anon_sym_DASH] = ACTIONS(1541),
    [anon_sym_PIPE] = ACTIONS(1541),
    [anon_sym_move] = ACTIONS(1543),
    [sym_integer_literal] = ACTIONS(1541),
    [aux_sym_string_literal_token1] = ACTIONS(1541),
    [sym_char_literal] = ACTIONS(1541),
    [anon_sym_true] = ACTIONS(1543),
    [anon_sym_false] = ACTIONS(1543),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1543),
    [sym_super] = ACTIONS(1543),
    [sym_crate] = ACTIONS(1543),
    [sym_metavariable] = ACTIONS(1541),
    [sym_raw_string_literal] = ACTIONS(1541),
    [sym_float_literal] = ACTIONS(1541),
    [sym_block_comment] = ACTIONS(3),
  },
  [305] = {
    [ts_builtin_sym_end] = ACTIONS(1545),
    [sym_identifier] = ACTIONS(1547),
    [anon_sym_SEMI] = ACTIONS(1545),
    [anon_sym_macro_rules_BANG] = ACTIONS(1545),
    [anon_sym_LPAREN] = ACTIONS(1545),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_RBRACE] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(1545),
    [anon_sym_STAR] = ACTIONS(1545),
    [anon_sym_u8] = ACTIONS(1547),
    [anon_sym_i8] = ACTIONS(1547),
    [anon_sym_u16] = ACTIONS(1547),
    [anon_sym_i16] = ACTIONS(1547),
    [anon_sym_u32] = ACTIONS(1547),
    [anon_sym_i32] = ACTIONS(1547),
    [anon_sym_u64] = ACTIONS(1547),
    [anon_sym_i64] = ACTIONS(1547),
    [anon_sym_u128] = ACTIONS(1547),
    [anon_sym_i128] = ACTIONS(1547),
    [anon_sym_isize] = ACTIONS(1547),
    [anon_sym_usize] = ACTIONS(1547),
    [anon_sym_f32] = ACTIONS(1547),
    [anon_sym_f64] = ACTIONS(1547),
    [anon_sym_bool] = ACTIONS(1547),
    [anon_sym_str] = ACTIONS(1547),
    [anon_sym_char] = ACTIONS(1547),
    [anon_sym_SQUOTE] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1547),
    [anon_sym_break] = ACTIONS(1547),
    [anon_sym_const] = ACTIONS(1547),
    [anon_sym_continue] = ACTIONS(1547),
    [anon_sym_default] = ACTIONS(1547),
    [anon_sym_enum] = ACTIONS(1547),
    [anon_sym_fn] = ACTIONS(1547),
    [anon_sym_for] = ACTIONS(1547),
    [anon_sym_if] = ACTIONS(1547),
    [anon_sym_impl] = ACTIONS(1547),
    [anon_sym_let] = ACTIONS(1547),
    [anon_sym_loop] = ACTIONS(1547),
    [anon_sym_match] = ACTIONS(1547),
    [anon_sym_mod] = ACTIONS(1547),
    [anon_sym_pub] = ACTIONS(1547),
    [anon_sym_return] = ACTIONS(1547),
    [anon_sym_static] = ACTIONS(1547),
    [anon_sym_struct] = ACTIONS(1547),
    [anon_sym_trait] = ACTIONS(1547),
    [anon_sym_type] = ACTIONS(1547),
    [anon_sym_union] = ACTIONS(1547),
    [anon_sym_unsafe] = ACTIONS(1547),
    [anon_sym_use] = ACTIONS(1547),
    [anon_sym_while] = ACTIONS(1547),
    [anon_sym_POUND] = ACTIONS(1545),
    [anon_sym_BANG] = ACTIONS(1545),
    [anon_sym_extern] = ACTIONS(1547),
    [anon_sym_LT] = ACTIONS(1545),
    [anon_sym_COLON_COLON] = ACTIONS(1545),
    [anon_sym_AMP] = ACTIONS(1545),
    [anon_sym_DOT_DOT] = ACTIONS(1545),
    [anon_sym_DASH] = ACTIONS(1545),
    [anon_sym_PIPE] = ACTIONS(1545),
    [anon_sym_move] = ACTIONS(1547),
    [sym_integer_literal] = ACTIONS(1545),
    [aux_sym_string_literal_token1] = ACTIONS(1545),
    [sym_char_literal] = ACTIONS(1545),
    [anon_sym_true] = ACTIONS(1547),
    [anon_sym_false] = ACTIONS(1547),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1547),
    [sym_super] = ACTIONS(1547),
    [sym_crate] = ACTIONS(1547),
    [sym_metavariable] = ACTIONS(1545),
    [sym_raw_string_literal] = ACTIONS(1545),
    [sym_float_literal] = ACTIONS(1545),
    [sym_block_comment] = ACTIONS(3),
  },
  [306] = {
    [ts_builtin_sym_end] = ACTIONS(1549),
    [sym_identifier] = ACTIONS(1551),
    [anon_sym_SEMI] = ACTIONS(1549),
    [anon_sym_macro_rules_BANG] = ACTIONS(1549),
    [anon_sym_LPAREN] = ACTIONS(1549),
    [anon_sym_LBRACE] = ACTIONS(1549),
    [anon_sym_RBRACE] = ACTIONS(1549),
    [anon_sym_LBRACK] = ACTIONS(1549),
    [anon_sym_STAR] = ACTIONS(1549),
    [anon_sym_u8] = ACTIONS(1551),
    [anon_sym_i8] = ACTIONS(1551),
    [anon_sym_u16] = ACTIONS(1551),
    [anon_sym_i16] = ACTIONS(1551),
    [anon_sym_u32] = ACTIONS(1551),
    [anon_sym_i32] = ACTIONS(1551),
    [anon_sym_u64] = ACTIONS(1551),
    [anon_sym_i64] = ACTIONS(1551),
    [anon_sym_u128] = ACTIONS(1551),
    [anon_sym_i128] = ACTIONS(1551),
    [anon_sym_isize] = ACTIONS(1551),
    [anon_sym_usize] = ACTIONS(1551),
    [anon_sym_f32] = ACTIONS(1551),
    [anon_sym_f64] = ACTIONS(1551),
    [anon_sym_bool] = ACTIONS(1551),
    [anon_sym_str] = ACTIONS(1551),
    [anon_sym_char] = ACTIONS(1551),
    [anon_sym_SQUOTE] = ACTIONS(1551),
    [anon_sym_async] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1551),
    [anon_sym_const] = ACTIONS(1551),
    [anon_sym_continue] = ACTIONS(1551),
    [anon_sym_default] = ACTIONS(1551),
    [anon_sym_enum] = ACTIONS(1551),
    [anon_sym_fn] = ACTIONS(1551),
    [anon_sym_for] = ACTIONS(1551),
    [anon_sym_if] = ACTIONS(1551),
    [anon_sym_impl] = ACTIONS(1551),
    [anon_sym_let] = ACTIONS(1551),
    [anon_sym_loop] = ACTIONS(1551),
    [anon_sym_match] = ACTIONS(1551),
    [anon_sym_mod] = ACTIONS(1551),
    [anon_sym_pub] = ACTIONS(1551),
    [anon_sym_return] = ACTIONS(1551),
    [anon_sym_static] = ACTIONS(1551),
    [anon_sym_struct] = ACTIONS(1551),
    [anon_sym_trait] = ACTIONS(1551),
    [anon_sym_type] = ACTIONS(1551),
    [anon_sym_union] = ACTIONS(1551),
    [anon_sym_unsafe] = ACTIONS(1551),
    [anon_sym_use] = ACTIONS(1551),
    [anon_sym_while] = ACTIONS(1551),
    [anon_sym_POUND] = ACTIONS(1549),
    [anon_sym_BANG] = ACTIONS(1549),
    [anon_sym_extern] = ACTIONS(1551),
    [anon_sym_LT] = ACTIONS(1549),
    [anon_sym_COLON_COLON] = ACTIONS(1549),
    [anon_sym_AMP] = ACTIONS(1549),
    [anon_sym_DOT_DOT] = ACTIONS(1549),
    [anon_sym_DASH] = ACTIONS(1549),
    [anon_sym_PIPE] = ACTIONS(1549),
    [anon_sym_move] = ACTIONS(1551),
    [sym_integer_literal] = ACTIONS(1549),
    [aux_sym_string_literal_token1] = ACTIONS(1549),
    [sym_char_literal] = ACTIONS(1549),
    [anon_sym_true] = ACTIONS(1551),
    [anon_sym_false] = ACTIONS(1551),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1551),
    [sym_super] = ACTIONS(1551),
    [sym_crate] = ACTIONS(1551),
    [sym_metavariable] = ACTIONS(1549),
    [sym_raw_string_literal] = ACTIONS(1549),
    [sym_float_literal] = ACTIONS(1549),
    [sym_block_comment] = ACTIONS(3),
  },
  [307] = {
    [ts_builtin_sym_end] = ACTIONS(1553),
    [sym_identifier] = ACTIONS(1555),
    [anon_sym_SEMI] = ACTIONS(1553),
    [anon_sym_macro_rules_BANG] = ACTIONS(1553),
    [anon_sym_LPAREN] = ACTIONS(1553),
    [anon_sym_LBRACE] = ACTIONS(1553),
    [anon_sym_RBRACE] = ACTIONS(1553),
    [anon_sym_LBRACK] = ACTIONS(1553),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_u8] = ACTIONS(1555),
    [anon_sym_i8] = ACTIONS(1555),
    [anon_sym_u16] = ACTIONS(1555),
    [anon_sym_i16] = ACTIONS(1555),
    [anon_sym_u32] = ACTIONS(1555),
    [anon_sym_i32] = ACTIONS(1555),
    [anon_sym_u64] = ACTIONS(1555),
    [anon_sym_i64] = ACTIONS(1555),
    [anon_sym_u128] = ACTIONS(1555),
    [anon_sym_i128] = ACTIONS(1555),
    [anon_sym_isize] = ACTIONS(1555),
    [anon_sym_usize] = ACTIONS(1555),
    [anon_sym_f32] = ACTIONS(1555),
    [anon_sym_f64] = ACTIONS(1555),
    [anon_sym_bool] = ACTIONS(1555),
    [anon_sym_str] = ACTIONS(1555),
    [anon_sym_char] = ACTIONS(1555),
    [anon_sym_SQUOTE] = ACTIONS(1555),
    [anon_sym_async] = ACTIONS(1555),
    [anon_sym_break] = ACTIONS(1555),
    [anon_sym_const] = ACTIONS(1555),
    [anon_sym_continue] = ACTIONS(1555),
    [anon_sym_default] = ACTIONS(1555),
    [anon_sym_enum] = ACTIONS(1555),
    [anon_sym_fn] = ACTIONS(1555),
    [anon_sym_for] = ACTIONS(1555),
    [anon_sym_if] = ACTIONS(1555),
    [anon_sym_impl] = ACTIONS(1555),
    [anon_sym_let] = ACTIONS(1555),
    [anon_sym_loop] = ACTIONS(1555),
    [anon_sym_match] = ACTIONS(1555),
    [anon_sym_mod] = ACTIONS(1555),
    [anon_sym_pub] = ACTIONS(1555),
    [anon_sym_return] = ACTIONS(1555),
    [anon_sym_static] = ACTIONS(1555),
    [anon_sym_struct] = ACTIONS(1555),
    [anon_sym_trait] = ACTIONS(1555),
    [anon_sym_type] = ACTIONS(1555),
    [anon_sym_union] = ACTIONS(1555),
    [anon_sym_unsafe] = ACTIONS(1555),
    [anon_sym_use] = ACTIONS(1555),
    [anon_sym_while] = ACTIONS(1555),
    [anon_sym_POUND] = ACTIONS(1553),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_extern] = ACTIONS(1555),
    [anon_sym_LT] = ACTIONS(1553),
    [anon_sym_COLON_COLON] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_DOT_DOT] = ACTIONS(1553),
    [anon_sym_DASH] = ACTIONS(1553),
    [anon_sym_PIPE] = ACTIONS(1553),
    [anon_sym_move] = ACTIONS(1555),
    [sym_integer_literal] = ACTIONS(1553),
    [aux_sym_string_literal_token1] = ACTIONS(1553),
    [sym_char_literal] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(1555),
    [anon_sym_false] = ACTIONS(1555),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1555),
    [sym_super] = ACTIONS(1555),
    [sym_crate] = ACTIONS(1555),
    [sym_metavariable] = ACTIONS(1553),
    [sym_raw_string_literal] = ACTIONS(1553),
    [sym_float_literal] = ACTIONS(1553),
    [sym_block_comment] = ACTIONS(3),
  },
  [308] = {
    [ts_builtin_sym_end] = ACTIONS(1557),
    [sym_identifier] = ACTIONS(1559),
    [anon_sym_SEMI] = ACTIONS(1557),
    [anon_sym_macro_rules_BANG] = ACTIONS(1557),
    [anon_sym_LPAREN] = ACTIONS(1557),
    [anon_sym_LBRACE] = ACTIONS(1557),
    [anon_sym_RBRACE] = ACTIONS(1557),
    [anon_sym_LBRACK] = ACTIONS(1557),
    [anon_sym_STAR] = ACTIONS(1557),
    [anon_sym_u8] = ACTIONS(1559),
    [anon_sym_i8] = ACTIONS(1559),
    [anon_sym_u16] = ACTIONS(1559),
    [anon_sym_i16] = ACTIONS(1559),
    [anon_sym_u32] = ACTIONS(1559),
    [anon_sym_i32] = ACTIONS(1559),
    [anon_sym_u64] = ACTIONS(1559),
    [anon_sym_i64] = ACTIONS(1559),
    [anon_sym_u128] = ACTIONS(1559),
    [anon_sym_i128] = ACTIONS(1559),
    [anon_sym_isize] = ACTIONS(1559),
    [anon_sym_usize] = ACTIONS(1559),
    [anon_sym_f32] = ACTIONS(1559),
    [anon_sym_f64] = ACTIONS(1559),
    [anon_sym_bool] = ACTIONS(1559),
    [anon_sym_str] = ACTIONS(1559),
    [anon_sym_char] = ACTIONS(1559),
    [anon_sym_SQUOTE] = ACTIONS(1559),
    [anon_sym_async] = ACTIONS(1559),
    [anon_sym_break] = ACTIONS(1559),
    [anon_sym_const] = ACTIONS(1559),
    [anon_sym_continue] = ACTIONS(1559),
    [anon_sym_default] = ACTIONS(1559),
    [anon_sym_enum] = ACTIONS(1559),
    [anon_sym_fn] = ACTIONS(1559),
    [anon_sym_for] = ACTIONS(1559),
    [anon_sym_if] = ACTIONS(1559),
    [anon_sym_impl] = ACTIONS(1559),
    [anon_sym_let] = ACTIONS(1559),
    [anon_sym_loop] = ACTIONS(1559),
    [anon_sym_match] = ACTIONS(1559),
    [anon_sym_mod] = ACTIONS(1559),
    [anon_sym_pub] = ACTIONS(1559),
    [anon_sym_return] = ACTIONS(1559),
    [anon_sym_static] = ACTIONS(1559),
    [anon_sym_struct] = ACTIONS(1559),
    [anon_sym_trait] = ACTIONS(1559),
    [anon_sym_type] = ACTIONS(1559),
    [anon_sym_union] = ACTIONS(1559),
    [anon_sym_unsafe] = ACTIONS(1559),
    [anon_sym_use] = ACTIONS(1559),
    [anon_sym_while] = ACTIONS(1559),
    [anon_sym_POUND] = ACTIONS(1557),
    [anon_sym_BANG] = ACTIONS(1557),
    [anon_sym_extern] = ACTIONS(1559),
    [anon_sym_LT] = ACTIONS(1557),
    [anon_sym_COLON_COLON] = ACTIONS(1557),
    [anon_sym_AMP] = ACTIONS(1557),
    [anon_sym_DOT_DOT] = ACTIONS(1557),
    [anon_sym_DASH] = ACTIONS(1557),
    [anon_sym_PIPE] = ACTIONS(1557),
    [anon_sym_move] = ACTIONS(1559),
    [sym_integer_literal] = ACTIONS(1557),
    [aux_sym_string_literal_token1] = ACTIONS(1557),
    [sym_char_literal] = ACTIONS(1557),
    [anon_sym_true] = ACTIONS(1559),
    [anon_sym_false] = ACTIONS(1559),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1559),
    [sym_super] = ACTIONS(1559),
    [sym_crate] = ACTIONS(1559),
    [sym_metavariable] = ACTIONS(1557),
    [sym_raw_string_literal] = ACTIONS(1557),
    [sym_float_literal] = ACTIONS(1557),
    [sym_block_comment] = ACTIONS(3),
  },
  [309] = {
    [ts_builtin_sym_end] = ACTIONS(1561),
    [sym_identifier] = ACTIONS(1563),
    [anon_sym_SEMI] = ACTIONS(1561),
    [anon_sym_macro_rules_BANG] = ACTIONS(1561),
    [anon_sym_LPAREN] = ACTIONS(1561),
    [anon_sym_LBRACE] = ACTIONS(1561),
    [anon_sym_RBRACE] = ACTIONS(1561),
    [anon_sym_LBRACK] = ACTIONS(1561),
    [anon_sym_STAR] = ACTIONS(1561),
    [anon_sym_u8] = ACTIONS(1563),
    [anon_sym_i8] = ACTIONS(1563),
    [anon_sym_u16] = ACTIONS(1563),
    [anon_sym_i16] = ACTIONS(1563),
    [anon_sym_u32] = ACTIONS(1563),
    [anon_sym_i32] = ACTIONS(1563),
    [anon_sym_u64] = ACTIONS(1563),
    [anon_sym_i64] = ACTIONS(1563),
    [anon_sym_u128] = ACTIONS(1563),
    [anon_sym_i128] = ACTIONS(1563),
    [anon_sym_isize] = ACTIONS(1563),
    [anon_sym_usize] = ACTIONS(1563),
    [anon_sym_f32] = ACTIONS(1563),
    [anon_sym_f64] = ACTIONS(1563),
    [anon_sym_bool] = ACTIONS(1563),
    [anon_sym_str] = ACTIONS(1563),
    [anon_sym_char] = ACTIONS(1563),
    [anon_sym_SQUOTE] = ACTIONS(1563),
    [anon_sym_async] = ACTIONS(1563),
    [anon_sym_break] = ACTIONS(1563),
    [anon_sym_const] = ACTIONS(1563),
    [anon_sym_continue] = ACTIONS(1563),
    [anon_sym_default] = ACTIONS(1563),
    [anon_sym_enum] = ACTIONS(1563),
    [anon_sym_fn] = ACTIONS(1563),
    [anon_sym_for] = ACTIONS(1563),
    [anon_sym_if] = ACTIONS(1563),
    [anon_sym_impl] = ACTIONS(1563),
    [anon_sym_let] = ACTIONS(1563),
    [anon_sym_loop] = ACTIONS(1563),
    [anon_sym_match] = ACTIONS(1563),
    [anon_sym_mod] = ACTIONS(1563),
    [anon_sym_pub] = ACTIONS(1563),
    [anon_sym_return] = ACTIONS(1563),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_struct] = ACTIONS(1563),
    [anon_sym_trait] = ACTIONS(1563),
    [anon_sym_type] = ACTIONS(1563),
    [anon_sym_union] = ACTIONS(1563),
    [anon_sym_unsafe] = ACTIONS(1563),
    [anon_sym_use] = ACTIONS(1563),
    [anon_sym_while] = ACTIONS(1563),
    [anon_sym_POUND] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1561),
    [anon_sym_extern] = ACTIONS(1563),
    [anon_sym_LT] = ACTIONS(1561),
    [anon_sym_COLON_COLON] = ACTIONS(1561),
    [anon_sym_AMP] = ACTIONS(1561),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym_DASH] = ACTIONS(1561),
    [anon_sym_PIPE] = ACTIONS(1561),
    [anon_sym_move] = ACTIONS(1563),
    [sym_integer_literal] = ACTIONS(1561),
    [aux_sym_string_literal_token1] = ACTIONS(1561),
    [sym_char_literal] = ACTIONS(1561),
    [anon_sym_true] = ACTIONS(1563),
    [anon_sym_false] = ACTIONS(1563),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1563),
    [sym_super] = ACTIONS(1563),
    [sym_crate] = ACTIONS(1563),
    [sym_metavariable] = ACTIONS(1561),
    [sym_raw_string_literal] = ACTIONS(1561),
    [sym_float_literal] = ACTIONS(1561),
    [sym_block_comment] = ACTIONS(3),
  },
  [310] = {
    [ts_builtin_sym_end] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1567),
    [anon_sym_SEMI] = ACTIONS(1565),
    [anon_sym_macro_rules_BANG] = ACTIONS(1565),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_LBRACE] = ACTIONS(1565),
    [anon_sym_RBRACE] = ACTIONS(1565),
    [anon_sym_LBRACK] = ACTIONS(1565),
    [anon_sym_STAR] = ACTIONS(1565),
    [anon_sym_u8] = ACTIONS(1567),
    [anon_sym_i8] = ACTIONS(1567),
    [anon_sym_u16] = ACTIONS(1567),
    [anon_sym_i16] = ACTIONS(1567),
    [anon_sym_u32] = ACTIONS(1567),
    [anon_sym_i32] = ACTIONS(1567),
    [anon_sym_u64] = ACTIONS(1567),
    [anon_sym_i64] = ACTIONS(1567),
    [anon_sym_u128] = ACTIONS(1567),
    [anon_sym_i128] = ACTIONS(1567),
    [anon_sym_isize] = ACTIONS(1567),
    [anon_sym_usize] = ACTIONS(1567),
    [anon_sym_f32] = ACTIONS(1567),
    [anon_sym_f64] = ACTIONS(1567),
    [anon_sym_bool] = ACTIONS(1567),
    [anon_sym_str] = ACTIONS(1567),
    [anon_sym_char] = ACTIONS(1567),
    [anon_sym_SQUOTE] = ACTIONS(1567),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_break] = ACTIONS(1567),
    [anon_sym_const] = ACTIONS(1567),
    [anon_sym_continue] = ACTIONS(1567),
    [anon_sym_default] = ACTIONS(1567),
    [anon_sym_enum] = ACTIONS(1567),
    [anon_sym_fn] = ACTIONS(1567),
    [anon_sym_for] = ACTIONS(1567),
    [anon_sym_if] = ACTIONS(1567),
    [anon_sym_impl] = ACTIONS(1567),
    [anon_sym_let] = ACTIONS(1567),
    [anon_sym_loop] = ACTIONS(1567),
    [anon_sym_match] = ACTIONS(1567),
    [anon_sym_mod] = ACTIONS(1567),
    [anon_sym_pub] = ACTIONS(1567),
    [anon_sym_return] = ACTIONS(1567),
    [anon_sym_static] = ACTIONS(1567),
    [anon_sym_struct] = ACTIONS(1567),
    [anon_sym_trait] = ACTIONS(1567),
    [anon_sym_type] = ACTIONS(1567),
    [anon_sym_union] = ACTIONS(1567),
    [anon_sym_unsafe] = ACTIONS(1567),
    [anon_sym_use] = ACTIONS(1567),
    [anon_sym_while] = ACTIONS(1567),
    [anon_sym_POUND] = ACTIONS(1565),
    [anon_sym_BANG] = ACTIONS(1565),
    [anon_sym_extern] = ACTIONS(1567),
    [anon_sym_LT] = ACTIONS(1565),
    [anon_sym_COLON_COLON] = ACTIONS(1565),
    [anon_sym_AMP] = ACTIONS(1565),
    [anon_sym_DOT_DOT] = ACTIONS(1565),
    [anon_sym_DASH] = ACTIONS(1565),
    [anon_sym_PIPE] = ACTIONS(1565),
    [anon_sym_move] = ACTIONS(1567),
    [sym_integer_literal] = ACTIONS(1565),
    [aux_sym_string_literal_token1] = ACTIONS(1565),
    [sym_char_literal] = ACTIONS(1565),
    [anon_sym_true] = ACTIONS(1567),
    [anon_sym_false] = ACTIONS(1567),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1567),
    [sym_super] = ACTIONS(1567),
    [sym_crate] = ACTIONS(1567),
    [sym_metavariable] = ACTIONS(1565),
    [sym_raw_string_literal] = ACTIONS(1565),
    [sym_float_literal] = ACTIONS(1565),
    [sym_block_comment] = ACTIONS(3),
  },
  [311] = {
    [ts_builtin_sym_end] = ACTIONS(1569),
    [sym_identifier] = ACTIONS(1571),
    [anon_sym_SEMI] = ACTIONS(1569),
    [anon_sym_macro_rules_BANG] = ACTIONS(1569),
    [anon_sym_LPAREN] = ACTIONS(1569),
    [anon_sym_LBRACE] = ACTIONS(1569),
    [anon_sym_RBRACE] = ACTIONS(1569),
    [anon_sym_LBRACK] = ACTIONS(1569),
    [anon_sym_STAR] = ACTIONS(1569),
    [anon_sym_u8] = ACTIONS(1571),
    [anon_sym_i8] = ACTIONS(1571),
    [anon_sym_u16] = ACTIONS(1571),
    [anon_sym_i16] = ACTIONS(1571),
    [anon_sym_u32] = ACTIONS(1571),
    [anon_sym_i32] = ACTIONS(1571),
    [anon_sym_u64] = ACTIONS(1571),
    [anon_sym_i64] = ACTIONS(1571),
    [anon_sym_u128] = ACTIONS(1571),
    [anon_sym_i128] = ACTIONS(1571),
    [anon_sym_isize] = ACTIONS(1571),
    [anon_sym_usize] = ACTIONS(1571),
    [anon_sym_f32] = ACTIONS(1571),
    [anon_sym_f64] = ACTIONS(1571),
    [anon_sym_bool] = ACTIONS(1571),
    [anon_sym_str] = ACTIONS(1571),
    [anon_sym_char] = ACTIONS(1571),
    [anon_sym_SQUOTE] = ACTIONS(1571),
    [anon_sym_async] = ACTIONS(1571),
    [anon_sym_break] = ACTIONS(1571),
    [anon_sym_const] = ACTIONS(1571),
    [anon_sym_continue] = ACTIONS(1571),
    [anon_sym_default] = ACTIONS(1571),
    [anon_sym_enum] = ACTIONS(1571),
    [anon_sym_fn] = ACTIONS(1571),
    [anon_sym_for] = ACTIONS(1571),
    [anon_sym_if] = ACTIONS(1571),
    [anon_sym_impl] = ACTIONS(1571),
    [anon_sym_let] = ACTIONS(1571),
    [anon_sym_loop] = ACTIONS(1571),
    [anon_sym_match] = ACTIONS(1571),
    [anon_sym_mod] = ACTIONS(1571),
    [anon_sym_pub] = ACTIONS(1571),
    [anon_sym_return] = ACTIONS(1571),
    [anon_sym_static] = ACTIONS(1571),
    [anon_sym_struct] = ACTIONS(1571),
    [anon_sym_trait] = ACTIONS(1571),
    [anon_sym_type] = ACTIONS(1571),
    [anon_sym_union] = ACTIONS(1571),
    [anon_sym_unsafe] = ACTIONS(1571),
    [anon_sym_use] = ACTIONS(1571),
    [anon_sym_while] = ACTIONS(1571),
    [anon_sym_POUND] = ACTIONS(1569),
    [anon_sym_BANG] = ACTIONS(1569),
    [anon_sym_extern] = ACTIONS(1571),
    [anon_sym_LT] = ACTIONS(1569),
    [anon_sym_COLON_COLON] = ACTIONS(1569),
    [anon_sym_AMP] = ACTIONS(1569),
    [anon_sym_DOT_DOT] = ACTIONS(1569),
    [anon_sym_DASH] = ACTIONS(1569),
    [anon_sym_PIPE] = ACTIONS(1569),
    [anon_sym_move] = ACTIONS(1571),
    [sym_integer_literal] = ACTIONS(1569),
    [aux_sym_string_literal_token1] = ACTIONS(1569),
    [sym_char_literal] = ACTIONS(1569),
    [anon_sym_true] = ACTIONS(1571),
    [anon_sym_false] = ACTIONS(1571),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1571),
    [sym_super] = ACTIONS(1571),
    [sym_crate] = ACTIONS(1571),
    [sym_metavariable] = ACTIONS(1569),
    [sym_raw_string_literal] = ACTIONS(1569),
    [sym_float_literal] = ACTIONS(1569),
    [sym_block_comment] = ACTIONS(3),
  },
  [312] = {
    [ts_builtin_sym_end] = ACTIONS(1573),
    [sym_identifier] = ACTIONS(1575),
    [anon_sym_SEMI] = ACTIONS(1573),
    [anon_sym_macro_rules_BANG] = ACTIONS(1573),
    [anon_sym_LPAREN] = ACTIONS(1573),
    [anon_sym_LBRACE] = ACTIONS(1573),
    [anon_sym_RBRACE] = ACTIONS(1573),
    [anon_sym_LBRACK] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1573),
    [anon_sym_u8] = ACTIONS(1575),
    [anon_sym_i8] = ACTIONS(1575),
    [anon_sym_u16] = ACTIONS(1575),
    [anon_sym_i16] = ACTIONS(1575),
    [anon_sym_u32] = ACTIONS(1575),
    [anon_sym_i32] = ACTIONS(1575),
    [anon_sym_u64] = ACTIONS(1575),
    [anon_sym_i64] = ACTIONS(1575),
    [anon_sym_u128] = ACTIONS(1575),
    [anon_sym_i128] = ACTIONS(1575),
    [anon_sym_isize] = ACTIONS(1575),
    [anon_sym_usize] = ACTIONS(1575),
    [anon_sym_f32] = ACTIONS(1575),
    [anon_sym_f64] = ACTIONS(1575),
    [anon_sym_bool] = ACTIONS(1575),
    [anon_sym_str] = ACTIONS(1575),
    [anon_sym_char] = ACTIONS(1575),
    [anon_sym_SQUOTE] = ACTIONS(1575),
    [anon_sym_async] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1575),
    [anon_sym_const] = ACTIONS(1575),
    [anon_sym_continue] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(1575),
    [anon_sym_enum] = ACTIONS(1575),
    [anon_sym_fn] = ACTIONS(1575),
    [anon_sym_for] = ACTIONS(1575),
    [anon_sym_if] = ACTIONS(1575),
    [anon_sym_impl] = ACTIONS(1575),
    [anon_sym_let] = ACTIONS(1575),
    [anon_sym_loop] = ACTIONS(1575),
    [anon_sym_match] = ACTIONS(1575),
    [anon_sym_mod] = ACTIONS(1575),
    [anon_sym_pub] = ACTIONS(1575),
    [anon_sym_return] = ACTIONS(1575),
    [anon_sym_static] = ACTIONS(1575),
    [anon_sym_struct] = ACTIONS(1575),
    [anon_sym_trait] = ACTIONS(1575),
    [anon_sym_type] = ACTIONS(1575),
    [anon_sym_union] = ACTIONS(1575),
    [anon_sym_unsafe] = ACTIONS(1575),
    [anon_sym_use] = ACTIONS(1575),
    [anon_sym_while] = ACTIONS(1575),
    [anon_sym_POUND] = ACTIONS(1573),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_extern] = ACTIONS(1575),
    [anon_sym_LT] = ACTIONS(1573),
    [anon_sym_COLON_COLON] = ACTIONS(1573),
    [anon_sym_AMP] = ACTIONS(1573),
    [anon_sym_DOT_DOT] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_PIPE] = ACTIONS(1573),
    [anon_sym_move] = ACTIONS(1575),
    [sym_integer_literal] = ACTIONS(1573),
    [aux_sym_string_literal_token1] = ACTIONS(1573),
    [sym_char_literal] = ACTIONS(1573),
    [anon_sym_true] = ACTIONS(1575),
    [anon_sym_false] = ACTIONS(1575),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1575),
    [sym_super] = ACTIONS(1575),
    [sym_crate] = ACTIONS(1575),
    [sym_metavariable] = ACTIONS(1573),
    [sym_raw_string_literal] = ACTIONS(1573),
    [sym_float_literal] = ACTIONS(1573),
    [sym_block_comment] = ACTIONS(3),
  },
  [313] = {
    [ts_builtin_sym_end] = ACTIONS(1577),
    [sym_identifier] = ACTIONS(1579),
    [anon_sym_SEMI] = ACTIONS(1577),
    [anon_sym_macro_rules_BANG] = ACTIONS(1577),
    [anon_sym_LPAREN] = ACTIONS(1577),
    [anon_sym_LBRACE] = ACTIONS(1577),
    [anon_sym_RBRACE] = ACTIONS(1577),
    [anon_sym_LBRACK] = ACTIONS(1577),
    [anon_sym_STAR] = ACTIONS(1577),
    [anon_sym_u8] = ACTIONS(1579),
    [anon_sym_i8] = ACTIONS(1579),
    [anon_sym_u16] = ACTIONS(1579),
    [anon_sym_i16] = ACTIONS(1579),
    [anon_sym_u32] = ACTIONS(1579),
    [anon_sym_i32] = ACTIONS(1579),
    [anon_sym_u64] = ACTIONS(1579),
    [anon_sym_i64] = ACTIONS(1579),
    [anon_sym_u128] = ACTIONS(1579),
    [anon_sym_i128] = ACTIONS(1579),
    [anon_sym_isize] = ACTIONS(1579),
    [anon_sym_usize] = ACTIONS(1579),
    [anon_sym_f32] = ACTIONS(1579),
    [anon_sym_f64] = ACTIONS(1579),
    [anon_sym_bool] = ACTIONS(1579),
    [anon_sym_str] = ACTIONS(1579),
    [anon_sym_char] = ACTIONS(1579),
    [anon_sym_SQUOTE] = ACTIONS(1579),
    [anon_sym_async] = ACTIONS(1579),
    [anon_sym_break] = ACTIONS(1579),
    [anon_sym_const] = ACTIONS(1579),
    [anon_sym_continue] = ACTIONS(1579),
    [anon_sym_default] = ACTIONS(1579),
    [anon_sym_enum] = ACTIONS(1579),
    [anon_sym_fn] = ACTIONS(1579),
    [anon_sym_for] = ACTIONS(1579),
    [anon_sym_if] = ACTIONS(1579),
    [anon_sym_impl] = ACTIONS(1579),
    [anon_sym_let] = ACTIONS(1579),
    [anon_sym_loop] = ACTIONS(1579),
    [anon_sym_match] = ACTIONS(1579),
    [anon_sym_mod] = ACTIONS(1579),
    [anon_sym_pub] = ACTIONS(1579),
    [anon_sym_return] = ACTIONS(1579),
    [anon_sym_static] = ACTIONS(1579),
    [anon_sym_struct] = ACTIONS(1579),
    [anon_sym_trait] = ACTIONS(1579),
    [anon_sym_type] = ACTIONS(1579),
    [anon_sym_union] = ACTIONS(1579),
    [anon_sym_unsafe] = ACTIONS(1579),
    [anon_sym_use] = ACTIONS(1579),
    [anon_sym_while] = ACTIONS(1579),
    [anon_sym_POUND] = ACTIONS(1577),
    [anon_sym_BANG] = ACTIONS(1577),
    [anon_sym_extern] = ACTIONS(1579),
    [anon_sym_LT] = ACTIONS(1577),
    [anon_sym_COLON_COLON] = ACTIONS(1577),
    [anon_sym_AMP] = ACTIONS(1577),
    [anon_sym_DOT_DOT] = ACTIONS(1577),
    [anon_sym_DASH] = ACTIONS(1577),
    [anon_sym_PIPE] = ACTIONS(1577),
    [anon_sym_move] = ACTIONS(1579),
    [sym_integer_literal] = ACTIONS(1577),
    [aux_sym_string_literal_token1] = ACTIONS(1577),
    [sym_char_literal] = ACTIONS(1577),
    [anon_sym_true] = ACTIONS(1579),
    [anon_sym_false] = ACTIONS(1579),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1579),
    [sym_super] = ACTIONS(1579),
    [sym_crate] = ACTIONS(1579),
    [sym_metavariable] = ACTIONS(1577),
    [sym_raw_string_literal] = ACTIONS(1577),
    [sym_float_literal] = ACTIONS(1577),
    [sym_block_comment] = ACTIONS(3),
  },
  [314] = {
    [ts_builtin_sym_end] = ACTIONS(1581),
    [sym_identifier] = ACTIONS(1583),
    [anon_sym_SEMI] = ACTIONS(1581),
    [anon_sym_macro_rules_BANG] = ACTIONS(1581),
    [anon_sym_LPAREN] = ACTIONS(1581),
    [anon_sym_LBRACE] = ACTIONS(1581),
    [anon_sym_RBRACE] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(1581),
    [anon_sym_STAR] = ACTIONS(1581),
    [anon_sym_u8] = ACTIONS(1583),
    [anon_sym_i8] = ACTIONS(1583),
    [anon_sym_u16] = ACTIONS(1583),
    [anon_sym_i16] = ACTIONS(1583),
    [anon_sym_u32] = ACTIONS(1583),
    [anon_sym_i32] = ACTIONS(1583),
    [anon_sym_u64] = ACTIONS(1583),
    [anon_sym_i64] = ACTIONS(1583),
    [anon_sym_u128] = ACTIONS(1583),
    [anon_sym_i128] = ACTIONS(1583),
    [anon_sym_isize] = ACTIONS(1583),
    [anon_sym_usize] = ACTIONS(1583),
    [anon_sym_f32] = ACTIONS(1583),
    [anon_sym_f64] = ACTIONS(1583),
    [anon_sym_bool] = ACTIONS(1583),
    [anon_sym_str] = ACTIONS(1583),
    [anon_sym_char] = ACTIONS(1583),
    [anon_sym_SQUOTE] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1583),
    [anon_sym_break] = ACTIONS(1583),
    [anon_sym_const] = ACTIONS(1583),
    [anon_sym_continue] = ACTIONS(1583),
    [anon_sym_default] = ACTIONS(1583),
    [anon_sym_enum] = ACTIONS(1583),
    [anon_sym_fn] = ACTIONS(1583),
    [anon_sym_for] = ACTIONS(1583),
    [anon_sym_if] = ACTIONS(1583),
    [anon_sym_impl] = ACTIONS(1583),
    [anon_sym_let] = ACTIONS(1583),
    [anon_sym_loop] = ACTIONS(1583),
    [anon_sym_match] = ACTIONS(1583),
    [anon_sym_mod] = ACTIONS(1583),
    [anon_sym_pub] = ACTIONS(1583),
    [anon_sym_return] = ACTIONS(1583),
    [anon_sym_static] = ACTIONS(1583),
    [anon_sym_struct] = ACTIONS(1583),
    [anon_sym_trait] = ACTIONS(1583),
    [anon_sym_type] = ACTIONS(1583),
    [anon_sym_union] = ACTIONS(1583),
    [anon_sym_unsafe] = ACTIONS(1583),
    [anon_sym_use] = ACTIONS(1583),
    [anon_sym_while] = ACTIONS(1583),
    [anon_sym_POUND] = ACTIONS(1581),
    [anon_sym_BANG] = ACTIONS(1581),
    [anon_sym_extern] = ACTIONS(1583),
    [anon_sym_LT] = ACTIONS(1581),
    [anon_sym_COLON_COLON] = ACTIONS(1581),
    [anon_sym_AMP] = ACTIONS(1581),
    [anon_sym_DOT_DOT] = ACTIONS(1581),
    [anon_sym_DASH] = ACTIONS(1581),
    [anon_sym_PIPE] = ACTIONS(1581),
    [anon_sym_move] = ACTIONS(1583),
    [sym_integer_literal] = ACTIONS(1581),
    [aux_sym_string_literal_token1] = ACTIONS(1581),
    [sym_char_literal] = ACTIONS(1581),
    [anon_sym_true] = ACTIONS(1583),
    [anon_sym_false] = ACTIONS(1583),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1583),
    [sym_super] = ACTIONS(1583),
    [sym_crate] = ACTIONS(1583),
    [sym_metavariable] = ACTIONS(1581),
    [sym_raw_string_literal] = ACTIONS(1581),
    [sym_float_literal] = ACTIONS(1581),
    [sym_block_comment] = ACTIONS(3),
  },
  [315] = {
    [ts_builtin_sym_end] = ACTIONS(1585),
    [sym_identifier] = ACTIONS(1587),
    [anon_sym_SEMI] = ACTIONS(1585),
    [anon_sym_macro_rules_BANG] = ACTIONS(1585),
    [anon_sym_LPAREN] = ACTIONS(1585),
    [anon_sym_LBRACE] = ACTIONS(1585),
    [anon_sym_RBRACE] = ACTIONS(1585),
    [anon_sym_LBRACK] = ACTIONS(1585),
    [anon_sym_STAR] = ACTIONS(1585),
    [anon_sym_u8] = ACTIONS(1587),
    [anon_sym_i8] = ACTIONS(1587),
    [anon_sym_u16] = ACTIONS(1587),
    [anon_sym_i16] = ACTIONS(1587),
    [anon_sym_u32] = ACTIONS(1587),
    [anon_sym_i32] = ACTIONS(1587),
    [anon_sym_u64] = ACTIONS(1587),
    [anon_sym_i64] = ACTIONS(1587),
    [anon_sym_u128] = ACTIONS(1587),
    [anon_sym_i128] = ACTIONS(1587),
    [anon_sym_isize] = ACTIONS(1587),
    [anon_sym_usize] = ACTIONS(1587),
    [anon_sym_f32] = ACTIONS(1587),
    [anon_sym_f64] = ACTIONS(1587),
    [anon_sym_bool] = ACTIONS(1587),
    [anon_sym_str] = ACTIONS(1587),
    [anon_sym_char] = ACTIONS(1587),
    [anon_sym_SQUOTE] = ACTIONS(1587),
    [anon_sym_async] = ACTIONS(1587),
    [anon_sym_break] = ACTIONS(1587),
    [anon_sym_const] = ACTIONS(1587),
    [anon_sym_continue] = ACTIONS(1587),
    [anon_sym_default] = ACTIONS(1587),
    [anon_sym_enum] = ACTIONS(1587),
    [anon_sym_fn] = ACTIONS(1587),
    [anon_sym_for] = ACTIONS(1587),
    [anon_sym_if] = ACTIONS(1587),
    [anon_sym_impl] = ACTIONS(1587),
    [anon_sym_let] = ACTIONS(1587),
    [anon_sym_loop] = ACTIONS(1587),
    [anon_sym_match] = ACTIONS(1587),
    [anon_sym_mod] = ACTIONS(1587),
    [anon_sym_pub] = ACTIONS(1587),
    [anon_sym_return] = ACTIONS(1587),
    [anon_sym_static] = ACTIONS(1587),
    [anon_sym_struct] = ACTIONS(1587),
    [anon_sym_trait] = ACTIONS(1587),
    [anon_sym_type] = ACTIONS(1587),
    [anon_sym_union] = ACTIONS(1587),
    [anon_sym_unsafe] = ACTIONS(1587),
    [anon_sym_use] = ACTIONS(1587),
    [anon_sym_while] = ACTIONS(1587),
    [anon_sym_POUND] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1585),
    [anon_sym_extern] = ACTIONS(1587),
    [anon_sym_LT] = ACTIONS(1585),
    [anon_sym_COLON_COLON] = ACTIONS(1585),
    [anon_sym_AMP] = ACTIONS(1585),
    [anon_sym_DOT_DOT] = ACTIONS(1585),
    [anon_sym_DASH] = ACTIONS(1585),
    [anon_sym_PIPE] = ACTIONS(1585),
    [anon_sym_move] = ACTIONS(1587),
    [sym_integer_literal] = ACTIONS(1585),
    [aux_sym_string_literal_token1] = ACTIONS(1585),
    [sym_char_literal] = ACTIONS(1585),
    [anon_sym_true] = ACTIONS(1587),
    [anon_sym_false] = ACTIONS(1587),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1587),
    [sym_super] = ACTIONS(1587),
    [sym_crate] = ACTIONS(1587),
    [sym_metavariable] = ACTIONS(1585),
    [sym_raw_string_literal] = ACTIONS(1585),
    [sym_float_literal] = ACTIONS(1585),
    [sym_block_comment] = ACTIONS(3),
  },
  [316] = {
    [ts_builtin_sym_end] = ACTIONS(1589),
    [sym_identifier] = ACTIONS(1591),
    [anon_sym_SEMI] = ACTIONS(1589),
    [anon_sym_macro_rules_BANG] = ACTIONS(1589),
    [anon_sym_LPAREN] = ACTIONS(1589),
    [anon_sym_LBRACE] = ACTIONS(1589),
    [anon_sym_RBRACE] = ACTIONS(1589),
    [anon_sym_LBRACK] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_u8] = ACTIONS(1591),
    [anon_sym_i8] = ACTIONS(1591),
    [anon_sym_u16] = ACTIONS(1591),
    [anon_sym_i16] = ACTIONS(1591),
    [anon_sym_u32] = ACTIONS(1591),
    [anon_sym_i32] = ACTIONS(1591),
    [anon_sym_u64] = ACTIONS(1591),
    [anon_sym_i64] = ACTIONS(1591),
    [anon_sym_u128] = ACTIONS(1591),
    [anon_sym_i128] = ACTIONS(1591),
    [anon_sym_isize] = ACTIONS(1591),
    [anon_sym_usize] = ACTIONS(1591),
    [anon_sym_f32] = ACTIONS(1591),
    [anon_sym_f64] = ACTIONS(1591),
    [anon_sym_bool] = ACTIONS(1591),
    [anon_sym_str] = ACTIONS(1591),
    [anon_sym_char] = ACTIONS(1591),
    [anon_sym_SQUOTE] = ACTIONS(1591),
    [anon_sym_async] = ACTIONS(1591),
    [anon_sym_break] = ACTIONS(1591),
    [anon_sym_const] = ACTIONS(1591),
    [anon_sym_continue] = ACTIONS(1591),
    [anon_sym_default] = ACTIONS(1591),
    [anon_sym_enum] = ACTIONS(1591),
    [anon_sym_fn] = ACTIONS(1591),
    [anon_sym_for] = ACTIONS(1591),
    [anon_sym_if] = ACTIONS(1591),
    [anon_sym_impl] = ACTIONS(1591),
    [anon_sym_let] = ACTIONS(1591),
    [anon_sym_loop] = ACTIONS(1591),
    [anon_sym_match] = ACTIONS(1591),
    [anon_sym_mod] = ACTIONS(1591),
    [anon_sym_pub] = ACTIONS(1591),
    [anon_sym_return] = ACTIONS(1591),
    [anon_sym_static] = ACTIONS(1591),
    [anon_sym_struct] = ACTIONS(1591),
    [anon_sym_trait] = ACTIONS(1591),
    [anon_sym_type] = ACTIONS(1591),
    [anon_sym_union] = ACTIONS(1591),
    [anon_sym_unsafe] = ACTIONS(1591),
    [anon_sym_use] = ACTIONS(1591),
    [anon_sym_while] = ACTIONS(1591),
    [anon_sym_POUND] = ACTIONS(1589),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_extern] = ACTIONS(1591),
    [anon_sym_LT] = ACTIONS(1589),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_DOT_DOT] = ACTIONS(1589),
    [anon_sym_DASH] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(1589),
    [anon_sym_move] = ACTIONS(1591),
    [sym_integer_literal] = ACTIONS(1589),
    [aux_sym_string_literal_token1] = ACTIONS(1589),
    [sym_char_literal] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(1591),
    [anon_sym_false] = ACTIONS(1591),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1591),
    [sym_super] = ACTIONS(1591),
    [sym_crate] = ACTIONS(1591),
    [sym_metavariable] = ACTIONS(1589),
    [sym_raw_string_literal] = ACTIONS(1589),
    [sym_float_literal] = ACTIONS(1589),
    [sym_block_comment] = ACTIONS(3),
  },
  [317] = {
    [ts_builtin_sym_end] = ACTIONS(1593),
    [sym_identifier] = ACTIONS(1595),
    [anon_sym_SEMI] = ACTIONS(1593),
    [anon_sym_macro_rules_BANG] = ACTIONS(1593),
    [anon_sym_LPAREN] = ACTIONS(1593),
    [anon_sym_LBRACE] = ACTIONS(1593),
    [anon_sym_RBRACE] = ACTIONS(1593),
    [anon_sym_LBRACK] = ACTIONS(1593),
    [anon_sym_STAR] = ACTIONS(1593),
    [anon_sym_u8] = ACTIONS(1595),
    [anon_sym_i8] = ACTIONS(1595),
    [anon_sym_u16] = ACTIONS(1595),
    [anon_sym_i16] = ACTIONS(1595),
    [anon_sym_u32] = ACTIONS(1595),
    [anon_sym_i32] = ACTIONS(1595),
    [anon_sym_u64] = ACTIONS(1595),
    [anon_sym_i64] = ACTIONS(1595),
    [anon_sym_u128] = ACTIONS(1595),
    [anon_sym_i128] = ACTIONS(1595),
    [anon_sym_isize] = ACTIONS(1595),
    [anon_sym_usize] = ACTIONS(1595),
    [anon_sym_f32] = ACTIONS(1595),
    [anon_sym_f64] = ACTIONS(1595),
    [anon_sym_bool] = ACTIONS(1595),
    [anon_sym_str] = ACTIONS(1595),
    [anon_sym_char] = ACTIONS(1595),
    [anon_sym_SQUOTE] = ACTIONS(1595),
    [anon_sym_async] = ACTIONS(1595),
    [anon_sym_break] = ACTIONS(1595),
    [anon_sym_const] = ACTIONS(1595),
    [anon_sym_continue] = ACTIONS(1595),
    [anon_sym_default] = ACTIONS(1595),
    [anon_sym_enum] = ACTIONS(1595),
    [anon_sym_fn] = ACTIONS(1595),
    [anon_sym_for] = ACTIONS(1595),
    [anon_sym_if] = ACTIONS(1595),
    [anon_sym_impl] = ACTIONS(1595),
    [anon_sym_let] = ACTIONS(1595),
    [anon_sym_loop] = ACTIONS(1595),
    [anon_sym_match] = ACTIONS(1595),
    [anon_sym_mod] = ACTIONS(1595),
    [anon_sym_pub] = ACTIONS(1595),
    [anon_sym_return] = ACTIONS(1595),
    [anon_sym_static] = ACTIONS(1595),
    [anon_sym_struct] = ACTIONS(1595),
    [anon_sym_trait] = ACTIONS(1595),
    [anon_sym_type] = ACTIONS(1595),
    [anon_sym_union] = ACTIONS(1595),
    [anon_sym_unsafe] = ACTIONS(1595),
    [anon_sym_use] = ACTIONS(1595),
    [anon_sym_while] = ACTIONS(1595),
    [anon_sym_POUND] = ACTIONS(1593),
    [anon_sym_BANG] = ACTIONS(1593),
    [anon_sym_extern] = ACTIONS(1595),
    [anon_sym_LT] = ACTIONS(1593),
    [anon_sym_COLON_COLON] = ACTIONS(1593),
    [anon_sym_AMP] = ACTIONS(1593),
    [anon_sym_DOT_DOT] = ACTIONS(1593),
    [anon_sym_DASH] = ACTIONS(1593),
    [anon_sym_PIPE] = ACTIONS(1593),
    [anon_sym_move] = ACTIONS(1595),
    [sym_integer_literal] = ACTIONS(1593),
    [aux_sym_string_literal_token1] = ACTIONS(1593),
    [sym_char_literal] = ACTIONS(1593),
    [anon_sym_true] = ACTIONS(1595),
    [anon_sym_false] = ACTIONS(1595),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1595),
    [sym_super] = ACTIONS(1595),
    [sym_crate] = ACTIONS(1595),
    [sym_metavariable] = ACTIONS(1593),
    [sym_raw_string_literal] = ACTIONS(1593),
    [sym_float_literal] = ACTIONS(1593),
    [sym_block_comment] = ACTIONS(3),
  },
  [318] = {
    [ts_builtin_sym_end] = ACTIONS(1597),
    [sym_identifier] = ACTIONS(1599),
    [anon_sym_SEMI] = ACTIONS(1597),
    [anon_sym_macro_rules_BANG] = ACTIONS(1597),
    [anon_sym_LPAREN] = ACTIONS(1597),
    [anon_sym_LBRACE] = ACTIONS(1597),
    [anon_sym_RBRACE] = ACTIONS(1597),
    [anon_sym_LBRACK] = ACTIONS(1597),
    [anon_sym_STAR] = ACTIONS(1597),
    [anon_sym_u8] = ACTIONS(1599),
    [anon_sym_i8] = ACTIONS(1599),
    [anon_sym_u16] = ACTIONS(1599),
    [anon_sym_i16] = ACTIONS(1599),
    [anon_sym_u32] = ACTIONS(1599),
    [anon_sym_i32] = ACTIONS(1599),
    [anon_sym_u64] = ACTIONS(1599),
    [anon_sym_i64] = ACTIONS(1599),
    [anon_sym_u128] = ACTIONS(1599),
    [anon_sym_i128] = ACTIONS(1599),
    [anon_sym_isize] = ACTIONS(1599),
    [anon_sym_usize] = ACTIONS(1599),
    [anon_sym_f32] = ACTIONS(1599),
    [anon_sym_f64] = ACTIONS(1599),
    [anon_sym_bool] = ACTIONS(1599),
    [anon_sym_str] = ACTIONS(1599),
    [anon_sym_char] = ACTIONS(1599),
    [anon_sym_SQUOTE] = ACTIONS(1599),
    [anon_sym_async] = ACTIONS(1599),
    [anon_sym_break] = ACTIONS(1599),
    [anon_sym_const] = ACTIONS(1599),
    [anon_sym_continue] = ACTIONS(1599),
    [anon_sym_default] = ACTIONS(1599),
    [anon_sym_enum] = ACTIONS(1599),
    [anon_sym_fn] = ACTIONS(1599),
    [anon_sym_for] = ACTIONS(1599),
    [anon_sym_if] = ACTIONS(1599),
    [anon_sym_impl] = ACTIONS(1599),
    [anon_sym_let] = ACTIONS(1599),
    [anon_sym_loop] = ACTIONS(1599),
    [anon_sym_match] = ACTIONS(1599),
    [anon_sym_mod] = ACTIONS(1599),
    [anon_sym_pub] = ACTIONS(1599),
    [anon_sym_return] = ACTIONS(1599),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_struct] = ACTIONS(1599),
    [anon_sym_trait] = ACTIONS(1599),
    [anon_sym_type] = ACTIONS(1599),
    [anon_sym_union] = ACTIONS(1599),
    [anon_sym_unsafe] = ACTIONS(1599),
    [anon_sym_use] = ACTIONS(1599),
    [anon_sym_while] = ACTIONS(1599),
    [anon_sym_POUND] = ACTIONS(1597),
    [anon_sym_BANG] = ACTIONS(1597),
    [anon_sym_extern] = ACTIONS(1599),
    [anon_sym_LT] = ACTIONS(1597),
    [anon_sym_COLON_COLON] = ACTIONS(1597),
    [anon_sym_AMP] = ACTIONS(1597),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym_DASH] = ACTIONS(1597),
    [anon_sym_PIPE] = ACTIONS(1597),
    [anon_sym_move] = ACTIONS(1599),
    [sym_integer_literal] = ACTIONS(1597),
    [aux_sym_string_literal_token1] = ACTIONS(1597),
    [sym_char_literal] = ACTIONS(1597),
    [anon_sym_true] = ACTIONS(1599),
    [anon_sym_false] = ACTIONS(1599),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1599),
    [sym_super] = ACTIONS(1599),
    [sym_crate] = ACTIONS(1599),
    [sym_metavariable] = ACTIONS(1597),
    [sym_raw_string_literal] = ACTIONS(1597),
    [sym_float_literal] = ACTIONS(1597),
    [sym_block_comment] = ACTIONS(3),
  },
  [319] = {
    [ts_builtin_sym_end] = ACTIONS(1601),
    [sym_identifier] = ACTIONS(1603),
    [anon_sym_SEMI] = ACTIONS(1601),
    [anon_sym_macro_rules_BANG] = ACTIONS(1601),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_LBRACE] = ACTIONS(1601),
    [anon_sym_RBRACE] = ACTIONS(1601),
    [anon_sym_LBRACK] = ACTIONS(1601),
    [anon_sym_STAR] = ACTIONS(1601),
    [anon_sym_u8] = ACTIONS(1603),
    [anon_sym_i8] = ACTIONS(1603),
    [anon_sym_u16] = ACTIONS(1603),
    [anon_sym_i16] = ACTIONS(1603),
    [anon_sym_u32] = ACTIONS(1603),
    [anon_sym_i32] = ACTIONS(1603),
    [anon_sym_u64] = ACTIONS(1603),
    [anon_sym_i64] = ACTIONS(1603),
    [anon_sym_u128] = ACTIONS(1603),
    [anon_sym_i128] = ACTIONS(1603),
    [anon_sym_isize] = ACTIONS(1603),
    [anon_sym_usize] = ACTIONS(1603),
    [anon_sym_f32] = ACTIONS(1603),
    [anon_sym_f64] = ACTIONS(1603),
    [anon_sym_bool] = ACTIONS(1603),
    [anon_sym_str] = ACTIONS(1603),
    [anon_sym_char] = ACTIONS(1603),
    [anon_sym_SQUOTE] = ACTIONS(1603),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_break] = ACTIONS(1603),
    [anon_sym_const] = ACTIONS(1603),
    [anon_sym_continue] = ACTIONS(1603),
    [anon_sym_default] = ACTIONS(1603),
    [anon_sym_enum] = ACTIONS(1603),
    [anon_sym_fn] = ACTIONS(1603),
    [anon_sym_for] = ACTIONS(1603),
    [anon_sym_if] = ACTIONS(1603),
    [anon_sym_impl] = ACTIONS(1603),
    [anon_sym_let] = ACTIONS(1603),
    [anon_sym_loop] = ACTIONS(1603),
    [anon_sym_match] = ACTIONS(1603),
    [anon_sym_mod] = ACTIONS(1603),
    [anon_sym_pub] = ACTIONS(1603),
    [anon_sym_return] = ACTIONS(1603),
    [anon_sym_static] = ACTIONS(1603),
    [anon_sym_struct] = ACTIONS(1603),
    [anon_sym_trait] = ACTIONS(1603),
    [anon_sym_type] = ACTIONS(1603),
    [anon_sym_union] = ACTIONS(1603),
    [anon_sym_unsafe] = ACTIONS(1603),
    [anon_sym_use] = ACTIONS(1603),
    [anon_sym_while] = ACTIONS(1603),
    [anon_sym_POUND] = ACTIONS(1601),
    [anon_sym_BANG] = ACTIONS(1601),
    [anon_sym_extern] = ACTIONS(1603),
    [anon_sym_LT] = ACTIONS(1601),
    [anon_sym_COLON_COLON] = ACTIONS(1601),
    [anon_sym_AMP] = ACTIONS(1601),
    [anon_sym_DOT_DOT] = ACTIONS(1601),
    [anon_sym_DASH] = ACTIONS(1601),
    [anon_sym_PIPE] = ACTIONS(1601),
    [anon_sym_move] = ACTIONS(1603),
    [sym_integer_literal] = ACTIONS(1601),
    [aux_sym_string_literal_token1] = ACTIONS(1601),
    [sym_char_literal] = ACTIONS(1601),
    [anon_sym_true] = ACTIONS(1603),
    [anon_sym_false] = ACTIONS(1603),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1603),
    [sym_super] = ACTIONS(1603),
    [sym_crate] = ACTIONS(1603),
    [sym_metavariable] = ACTIONS(1601),
    [sym_raw_string_literal] = ACTIONS(1601),
    [sym_float_literal] = ACTIONS(1601),
    [sym_block_comment] = ACTIONS(3),
  },
  [320] = {
    [ts_builtin_sym_end] = ACTIONS(1605),
    [sym_identifier] = ACTIONS(1607),
    [anon_sym_SEMI] = ACTIONS(1605),
    [anon_sym_macro_rules_BANG] = ACTIONS(1605),
    [anon_sym_LPAREN] = ACTIONS(1605),
    [anon_sym_LBRACE] = ACTIONS(1605),
    [anon_sym_RBRACE] = ACTIONS(1605),
    [anon_sym_LBRACK] = ACTIONS(1605),
    [anon_sym_STAR] = ACTIONS(1605),
    [anon_sym_u8] = ACTIONS(1607),
    [anon_sym_i8] = ACTIONS(1607),
    [anon_sym_u16] = ACTIONS(1607),
    [anon_sym_i16] = ACTIONS(1607),
    [anon_sym_u32] = ACTIONS(1607),
    [anon_sym_i32] = ACTIONS(1607),
    [anon_sym_u64] = ACTIONS(1607),
    [anon_sym_i64] = ACTIONS(1607),
    [anon_sym_u128] = ACTIONS(1607),
    [anon_sym_i128] = ACTIONS(1607),
    [anon_sym_isize] = ACTIONS(1607),
    [anon_sym_usize] = ACTIONS(1607),
    [anon_sym_f32] = ACTIONS(1607),
    [anon_sym_f64] = ACTIONS(1607),
    [anon_sym_bool] = ACTIONS(1607),
    [anon_sym_str] = ACTIONS(1607),
    [anon_sym_char] = ACTIONS(1607),
    [anon_sym_SQUOTE] = ACTIONS(1607),
    [anon_sym_async] = ACTIONS(1607),
    [anon_sym_break] = ACTIONS(1607),
    [anon_sym_const] = ACTIONS(1607),
    [anon_sym_continue] = ACTIONS(1607),
    [anon_sym_default] = ACTIONS(1607),
    [anon_sym_enum] = ACTIONS(1607),
    [anon_sym_fn] = ACTIONS(1607),
    [anon_sym_for] = ACTIONS(1607),
    [anon_sym_if] = ACTIONS(1607),
    [anon_sym_impl] = ACTIONS(1607),
    [anon_sym_let] = ACTIONS(1607),
    [anon_sym_loop] = ACTIONS(1607),
    [anon_sym_match] = ACTIONS(1607),
    [anon_sym_mod] = ACTIONS(1607),
    [anon_sym_pub] = ACTIONS(1607),
    [anon_sym_return] = ACTIONS(1607),
    [anon_sym_static] = ACTIONS(1607),
    [anon_sym_struct] = ACTIONS(1607),
    [anon_sym_trait] = ACTIONS(1607),
    [anon_sym_type] = ACTIONS(1607),
    [anon_sym_union] = ACTIONS(1607),
    [anon_sym_unsafe] = ACTIONS(1607),
    [anon_sym_use] = ACTIONS(1607),
    [anon_sym_while] = ACTIONS(1607),
    [anon_sym_POUND] = ACTIONS(1605),
    [anon_sym_BANG] = ACTIONS(1605),
    [anon_sym_extern] = ACTIONS(1607),
    [anon_sym_LT] = ACTIONS(1605),
    [anon_sym_COLON_COLON] = ACTIONS(1605),
    [anon_sym_AMP] = ACTIONS(1605),
    [anon_sym_DOT_DOT] = ACTIONS(1605),
    [anon_sym_DASH] = ACTIONS(1605),
    [anon_sym_PIPE] = ACTIONS(1605),
    [anon_sym_move] = ACTIONS(1607),
    [sym_integer_literal] = ACTIONS(1605),
    [aux_sym_string_literal_token1] = ACTIONS(1605),
    [sym_char_literal] = ACTIONS(1605),
    [anon_sym_true] = ACTIONS(1607),
    [anon_sym_false] = ACTIONS(1607),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1607),
    [sym_super] = ACTIONS(1607),
    [sym_crate] = ACTIONS(1607),
    [sym_metavariable] = ACTIONS(1605),
    [sym_raw_string_literal] = ACTIONS(1605),
    [sym_float_literal] = ACTIONS(1605),
    [sym_block_comment] = ACTIONS(3),
  },
  [321] = {
    [ts_builtin_sym_end] = ACTIONS(1609),
    [sym_identifier] = ACTIONS(1611),
    [anon_sym_SEMI] = ACTIONS(1609),
    [anon_sym_macro_rules_BANG] = ACTIONS(1609),
    [anon_sym_LPAREN] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(1609),
    [anon_sym_RBRACE] = ACTIONS(1609),
    [anon_sym_LBRACK] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1609),
    [anon_sym_u8] = ACTIONS(1611),
    [anon_sym_i8] = ACTIONS(1611),
    [anon_sym_u16] = ACTIONS(1611),
    [anon_sym_i16] = ACTIONS(1611),
    [anon_sym_u32] = ACTIONS(1611),
    [anon_sym_i32] = ACTIONS(1611),
    [anon_sym_u64] = ACTIONS(1611),
    [anon_sym_i64] = ACTIONS(1611),
    [anon_sym_u128] = ACTIONS(1611),
    [anon_sym_i128] = ACTIONS(1611),
    [anon_sym_isize] = ACTIONS(1611),
    [anon_sym_usize] = ACTIONS(1611),
    [anon_sym_f32] = ACTIONS(1611),
    [anon_sym_f64] = ACTIONS(1611),
    [anon_sym_bool] = ACTIONS(1611),
    [anon_sym_str] = ACTIONS(1611),
    [anon_sym_char] = ACTIONS(1611),
    [anon_sym_SQUOTE] = ACTIONS(1611),
    [anon_sym_async] = ACTIONS(1611),
    [anon_sym_break] = ACTIONS(1611),
    [anon_sym_const] = ACTIONS(1611),
    [anon_sym_continue] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(1611),
    [anon_sym_enum] = ACTIONS(1611),
    [anon_sym_fn] = ACTIONS(1611),
    [anon_sym_for] = ACTIONS(1611),
    [anon_sym_if] = ACTIONS(1611),
    [anon_sym_impl] = ACTIONS(1611),
    [anon_sym_let] = ACTIONS(1611),
    [anon_sym_loop] = ACTIONS(1611),
    [anon_sym_match] = ACTIONS(1611),
    [anon_sym_mod] = ACTIONS(1611),
    [anon_sym_pub] = ACTIONS(1611),
    [anon_sym_return] = ACTIONS(1611),
    [anon_sym_static] = ACTIONS(1611),
    [anon_sym_struct] = ACTIONS(1611),
    [anon_sym_trait] = ACTIONS(1611),
    [anon_sym_type] = ACTIONS(1611),
    [anon_sym_union] = ACTIONS(1611),
    [anon_sym_unsafe] = ACTIONS(1611),
    [anon_sym_use] = ACTIONS(1611),
    [anon_sym_while] = ACTIONS(1611),
    [anon_sym_POUND] = ACTIONS(1609),
    [anon_sym_BANG] = ACTIONS(1609),
    [anon_sym_extern] = ACTIONS(1611),
    [anon_sym_LT] = ACTIONS(1609),
    [anon_sym_COLON_COLON] = ACTIONS(1609),
    [anon_sym_AMP] = ACTIONS(1609),
    [anon_sym_DOT_DOT] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_PIPE] = ACTIONS(1609),
    [anon_sym_move] = ACTIONS(1611),
    [sym_integer_literal] = ACTIONS(1609),
    [aux_sym_string_literal_token1] = ACTIONS(1609),
    [sym_char_literal] = ACTIONS(1609),
    [anon_sym_true] = ACTIONS(1611),
    [anon_sym_false] = ACTIONS(1611),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1611),
    [sym_super] = ACTIONS(1611),
    [sym_crate] = ACTIONS(1611),
    [sym_metavariable] = ACTIONS(1609),
    [sym_raw_string_literal] = ACTIONS(1609),
    [sym_float_literal] = ACTIONS(1609),
    [sym_block_comment] = ACTIONS(3),
  },
  [322] = {
    [ts_builtin_sym_end] = ACTIONS(1613),
    [sym_identifier] = ACTIONS(1615),
    [anon_sym_SEMI] = ACTIONS(1613),
    [anon_sym_macro_rules_BANG] = ACTIONS(1613),
    [anon_sym_LPAREN] = ACTIONS(1613),
    [anon_sym_LBRACE] = ACTIONS(1613),
    [anon_sym_RBRACE] = ACTIONS(1613),
    [anon_sym_LBRACK] = ACTIONS(1613),
    [anon_sym_STAR] = ACTIONS(1613),
    [anon_sym_u8] = ACTIONS(1615),
    [anon_sym_i8] = ACTIONS(1615),
    [anon_sym_u16] = ACTIONS(1615),
    [anon_sym_i16] = ACTIONS(1615),
    [anon_sym_u32] = ACTIONS(1615),
    [anon_sym_i32] = ACTIONS(1615),
    [anon_sym_u64] = ACTIONS(1615),
    [anon_sym_i64] = ACTIONS(1615),
    [anon_sym_u128] = ACTIONS(1615),
    [anon_sym_i128] = ACTIONS(1615),
    [anon_sym_isize] = ACTIONS(1615),
    [anon_sym_usize] = ACTIONS(1615),
    [anon_sym_f32] = ACTIONS(1615),
    [anon_sym_f64] = ACTIONS(1615),
    [anon_sym_bool] = ACTIONS(1615),
    [anon_sym_str] = ACTIONS(1615),
    [anon_sym_char] = ACTIONS(1615),
    [anon_sym_SQUOTE] = ACTIONS(1615),
    [anon_sym_async] = ACTIONS(1615),
    [anon_sym_break] = ACTIONS(1615),
    [anon_sym_const] = ACTIONS(1615),
    [anon_sym_continue] = ACTIONS(1615),
    [anon_sym_default] = ACTIONS(1615),
    [anon_sym_enum] = ACTIONS(1615),
    [anon_sym_fn] = ACTIONS(1615),
    [anon_sym_for] = ACTIONS(1615),
    [anon_sym_if] = ACTIONS(1615),
    [anon_sym_impl] = ACTIONS(1615),
    [anon_sym_let] = ACTIONS(1615),
    [anon_sym_loop] = ACTIONS(1615),
    [anon_sym_match] = ACTIONS(1615),
    [anon_sym_mod] = ACTIONS(1615),
    [anon_sym_pub] = ACTIONS(1615),
    [anon_sym_return] = ACTIONS(1615),
    [anon_sym_static] = ACTIONS(1615),
    [anon_sym_struct] = ACTIONS(1615),
    [anon_sym_trait] = ACTIONS(1615),
    [anon_sym_type] = ACTIONS(1615),
    [anon_sym_union] = ACTIONS(1615),
    [anon_sym_unsafe] = ACTIONS(1615),
    [anon_sym_use] = ACTIONS(1615),
    [anon_sym_while] = ACTIONS(1615),
    [anon_sym_POUND] = ACTIONS(1613),
    [anon_sym_BANG] = ACTIONS(1613),
    [anon_sym_extern] = ACTIONS(1615),
    [anon_sym_LT] = ACTIONS(1613),
    [anon_sym_COLON_COLON] = ACTIONS(1613),
    [anon_sym_AMP] = ACTIONS(1613),
    [anon_sym_DOT_DOT] = ACTIONS(1613),
    [anon_sym_DASH] = ACTIONS(1613),
    [anon_sym_PIPE] = ACTIONS(1613),
    [anon_sym_move] = ACTIONS(1615),
    [sym_integer_literal] = ACTIONS(1613),
    [aux_sym_string_literal_token1] = ACTIONS(1613),
    [sym_char_literal] = ACTIONS(1613),
    [anon_sym_true] = ACTIONS(1615),
    [anon_sym_false] = ACTIONS(1615),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1615),
    [sym_super] = ACTIONS(1615),
    [sym_crate] = ACTIONS(1615),
    [sym_metavariable] = ACTIONS(1613),
    [sym_raw_string_literal] = ACTIONS(1613),
    [sym_float_literal] = ACTIONS(1613),
    [sym_block_comment] = ACTIONS(3),
  },
  [323] = {
    [ts_builtin_sym_end] = ACTIONS(1617),
    [sym_identifier] = ACTIONS(1619),
    [anon_sym_SEMI] = ACTIONS(1617),
    [anon_sym_macro_rules_BANG] = ACTIONS(1617),
    [anon_sym_LPAREN] = ACTIONS(1617),
    [anon_sym_LBRACE] = ACTIONS(1617),
    [anon_sym_RBRACE] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(1617),
    [anon_sym_STAR] = ACTIONS(1617),
    [anon_sym_u8] = ACTIONS(1619),
    [anon_sym_i8] = ACTIONS(1619),
    [anon_sym_u16] = ACTIONS(1619),
    [anon_sym_i16] = ACTIONS(1619),
    [anon_sym_u32] = ACTIONS(1619),
    [anon_sym_i32] = ACTIONS(1619),
    [anon_sym_u64] = ACTIONS(1619),
    [anon_sym_i64] = ACTIONS(1619),
    [anon_sym_u128] = ACTIONS(1619),
    [anon_sym_i128] = ACTIONS(1619),
    [anon_sym_isize] = ACTIONS(1619),
    [anon_sym_usize] = ACTIONS(1619),
    [anon_sym_f32] = ACTIONS(1619),
    [anon_sym_f64] = ACTIONS(1619),
    [anon_sym_bool] = ACTIONS(1619),
    [anon_sym_str] = ACTIONS(1619),
    [anon_sym_char] = ACTIONS(1619),
    [anon_sym_SQUOTE] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1619),
    [anon_sym_const] = ACTIONS(1619),
    [anon_sym_continue] = ACTIONS(1619),
    [anon_sym_default] = ACTIONS(1619),
    [anon_sym_enum] = ACTIONS(1619),
    [anon_sym_fn] = ACTIONS(1619),
    [anon_sym_for] = ACTIONS(1619),
    [anon_sym_if] = ACTIONS(1619),
    [anon_sym_impl] = ACTIONS(1619),
    [anon_sym_let] = ACTIONS(1619),
    [anon_sym_loop] = ACTIONS(1619),
    [anon_sym_match] = ACTIONS(1619),
    [anon_sym_mod] = ACTIONS(1619),
    [anon_sym_pub] = ACTIONS(1619),
    [anon_sym_return] = ACTIONS(1619),
    [anon_sym_static] = ACTIONS(1619),
    [anon_sym_struct] = ACTIONS(1619),
    [anon_sym_trait] = ACTIONS(1619),
    [anon_sym_type] = ACTIONS(1619),
    [anon_sym_union] = ACTIONS(1619),
    [anon_sym_unsafe] = ACTIONS(1619),
    [anon_sym_use] = ACTIONS(1619),
    [anon_sym_while] = ACTIONS(1619),
    [anon_sym_POUND] = ACTIONS(1617),
    [anon_sym_BANG] = ACTIONS(1617),
    [anon_sym_extern] = ACTIONS(1619),
    [anon_sym_LT] = ACTIONS(1617),
    [anon_sym_COLON_COLON] = ACTIONS(1617),
    [anon_sym_AMP] = ACTIONS(1617),
    [anon_sym_DOT_DOT] = ACTIONS(1617),
    [anon_sym_DASH] = ACTIONS(1617),
    [anon_sym_PIPE] = ACTIONS(1617),
    [anon_sym_move] = ACTIONS(1619),
    [sym_integer_literal] = ACTIONS(1617),
    [aux_sym_string_literal_token1] = ACTIONS(1617),
    [sym_char_literal] = ACTIONS(1617),
    [anon_sym_true] = ACTIONS(1619),
    [anon_sym_false] = ACTIONS(1619),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1619),
    [sym_super] = ACTIONS(1619),
    [sym_crate] = ACTIONS(1619),
    [sym_metavariable] = ACTIONS(1617),
    [sym_raw_string_literal] = ACTIONS(1617),
    [sym_float_literal] = ACTIONS(1617),
    [sym_block_comment] = ACTIONS(3),
  },
  [324] = {
    [ts_builtin_sym_end] = ACTIONS(1621),
    [sym_identifier] = ACTIONS(1623),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_macro_rules_BANG] = ACTIONS(1621),
    [anon_sym_LPAREN] = ACTIONS(1621),
    [anon_sym_LBRACE] = ACTIONS(1621),
    [anon_sym_RBRACE] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(1621),
    [anon_sym_STAR] = ACTIONS(1621),
    [anon_sym_u8] = ACTIONS(1623),
    [anon_sym_i8] = ACTIONS(1623),
    [anon_sym_u16] = ACTIONS(1623),
    [anon_sym_i16] = ACTIONS(1623),
    [anon_sym_u32] = ACTIONS(1623),
    [anon_sym_i32] = ACTIONS(1623),
    [anon_sym_u64] = ACTIONS(1623),
    [anon_sym_i64] = ACTIONS(1623),
    [anon_sym_u128] = ACTIONS(1623),
    [anon_sym_i128] = ACTIONS(1623),
    [anon_sym_isize] = ACTIONS(1623),
    [anon_sym_usize] = ACTIONS(1623),
    [anon_sym_f32] = ACTIONS(1623),
    [anon_sym_f64] = ACTIONS(1623),
    [anon_sym_bool] = ACTIONS(1623),
    [anon_sym_str] = ACTIONS(1623),
    [anon_sym_char] = ACTIONS(1623),
    [anon_sym_SQUOTE] = ACTIONS(1623),
    [anon_sym_async] = ACTIONS(1623),
    [anon_sym_break] = ACTIONS(1623),
    [anon_sym_const] = ACTIONS(1623),
    [anon_sym_continue] = ACTIONS(1623),
    [anon_sym_default] = ACTIONS(1623),
    [anon_sym_enum] = ACTIONS(1623),
    [anon_sym_fn] = ACTIONS(1623),
    [anon_sym_for] = ACTIONS(1623),
    [anon_sym_if] = ACTIONS(1623),
    [anon_sym_impl] = ACTIONS(1623),
    [anon_sym_let] = ACTIONS(1623),
    [anon_sym_loop] = ACTIONS(1623),
    [anon_sym_match] = ACTIONS(1623),
    [anon_sym_mod] = ACTIONS(1623),
    [anon_sym_pub] = ACTIONS(1623),
    [anon_sym_return] = ACTIONS(1623),
    [anon_sym_static] = ACTIONS(1623),
    [anon_sym_struct] = ACTIONS(1623),
    [anon_sym_trait] = ACTIONS(1623),
    [anon_sym_type] = ACTIONS(1623),
    [anon_sym_union] = ACTIONS(1623),
    [anon_sym_unsafe] = ACTIONS(1623),
    [anon_sym_use] = ACTIONS(1623),
    [anon_sym_while] = ACTIONS(1623),
    [anon_sym_POUND] = ACTIONS(1621),
    [anon_sym_BANG] = ACTIONS(1621),
    [anon_sym_extern] = ACTIONS(1623),
    [anon_sym_LT] = ACTIONS(1621),
    [anon_sym_COLON_COLON] = ACTIONS(1621),
    [anon_sym_AMP] = ACTIONS(1621),
    [anon_sym_DOT_DOT] = ACTIONS(1621),
    [anon_sym_DASH] = ACTIONS(1621),
    [anon_sym_PIPE] = ACTIONS(1621),
    [anon_sym_move] = ACTIONS(1623),
    [sym_integer_literal] = ACTIONS(1621),
    [aux_sym_string_literal_token1] = ACTIONS(1621),
    [sym_char_literal] = ACTIONS(1621),
    [anon_sym_true] = ACTIONS(1623),
    [anon_sym_false] = ACTIONS(1623),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1623),
    [sym_super] = ACTIONS(1623),
    [sym_crate] = ACTIONS(1623),
    [sym_metavariable] = ACTIONS(1621),
    [sym_raw_string_literal] = ACTIONS(1621),
    [sym_float_literal] = ACTIONS(1621),
    [sym_block_comment] = ACTIONS(3),
  },
  [325] = {
    [ts_builtin_sym_end] = ACTIONS(1625),
    [sym_identifier] = ACTIONS(1627),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_macro_rules_BANG] = ACTIONS(1625),
    [anon_sym_LPAREN] = ACTIONS(1625),
    [anon_sym_LBRACE] = ACTIONS(1625),
    [anon_sym_RBRACE] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1625),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_u8] = ACTIONS(1627),
    [anon_sym_i8] = ACTIONS(1627),
    [anon_sym_u16] = ACTIONS(1627),
    [anon_sym_i16] = ACTIONS(1627),
    [anon_sym_u32] = ACTIONS(1627),
    [anon_sym_i32] = ACTIONS(1627),
    [anon_sym_u64] = ACTIONS(1627),
    [anon_sym_i64] = ACTIONS(1627),
    [anon_sym_u128] = ACTIONS(1627),
    [anon_sym_i128] = ACTIONS(1627),
    [anon_sym_isize] = ACTIONS(1627),
    [anon_sym_usize] = ACTIONS(1627),
    [anon_sym_f32] = ACTIONS(1627),
    [anon_sym_f64] = ACTIONS(1627),
    [anon_sym_bool] = ACTIONS(1627),
    [anon_sym_str] = ACTIONS(1627),
    [anon_sym_char] = ACTIONS(1627),
    [anon_sym_SQUOTE] = ACTIONS(1627),
    [anon_sym_async] = ACTIONS(1627),
    [anon_sym_break] = ACTIONS(1627),
    [anon_sym_const] = ACTIONS(1627),
    [anon_sym_continue] = ACTIONS(1627),
    [anon_sym_default] = ACTIONS(1627),
    [anon_sym_enum] = ACTIONS(1627),
    [anon_sym_fn] = ACTIONS(1627),
    [anon_sym_for] = ACTIONS(1627),
    [anon_sym_if] = ACTIONS(1627),
    [anon_sym_impl] = ACTIONS(1627),
    [anon_sym_let] = ACTIONS(1627),
    [anon_sym_loop] = ACTIONS(1627),
    [anon_sym_match] = ACTIONS(1627),
    [anon_sym_mod] = ACTIONS(1627),
    [anon_sym_pub] = ACTIONS(1627),
    [anon_sym_return] = ACTIONS(1627),
    [anon_sym_static] = ACTIONS(1627),
    [anon_sym_struct] = ACTIONS(1627),
    [anon_sym_trait] = ACTIONS(1627),
    [anon_sym_type] = ACTIONS(1627),
    [anon_sym_union] = ACTIONS(1627),
    [anon_sym_unsafe] = ACTIONS(1627),
    [anon_sym_use] = ACTIONS(1627),
    [anon_sym_while] = ACTIONS(1627),
    [anon_sym_POUND] = ACTIONS(1625),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_extern] = ACTIONS(1627),
    [anon_sym_LT] = ACTIONS(1625),
    [anon_sym_COLON_COLON] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_DOT_DOT] = ACTIONS(1625),
    [anon_sym_DASH] = ACTIONS(1625),
    [anon_sym_PIPE] = ACTIONS(1625),
    [anon_sym_move] = ACTIONS(1627),
    [sym_integer_literal] = ACTIONS(1625),
    [aux_sym_string_literal_token1] = ACTIONS(1625),
    [sym_char_literal] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(1627),
    [anon_sym_false] = ACTIONS(1627),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1627),
    [sym_super] = ACTIONS(1627),
    [sym_crate] = ACTIONS(1627),
    [sym_metavariable] = ACTIONS(1625),
    [sym_raw_string_literal] = ACTIONS(1625),
    [sym_float_literal] = ACTIONS(1625),
    [sym_block_comment] = ACTIONS(3),
  },
  [326] = {
    [ts_builtin_sym_end] = ACTIONS(1629),
    [sym_identifier] = ACTIONS(1631),
    [anon_sym_SEMI] = ACTIONS(1629),
    [anon_sym_macro_rules_BANG] = ACTIONS(1629),
    [anon_sym_LPAREN] = ACTIONS(1629),
    [anon_sym_LBRACE] = ACTIONS(1629),
    [anon_sym_RBRACE] = ACTIONS(1629),
    [anon_sym_LBRACK] = ACTIONS(1629),
    [anon_sym_STAR] = ACTIONS(1629),
    [anon_sym_u8] = ACTIONS(1631),
    [anon_sym_i8] = ACTIONS(1631),
    [anon_sym_u16] = ACTIONS(1631),
    [anon_sym_i16] = ACTIONS(1631),
    [anon_sym_u32] = ACTIONS(1631),
    [anon_sym_i32] = ACTIONS(1631),
    [anon_sym_u64] = ACTIONS(1631),
    [anon_sym_i64] = ACTIONS(1631),
    [anon_sym_u128] = ACTIONS(1631),
    [anon_sym_i128] = ACTIONS(1631),
    [anon_sym_isize] = ACTIONS(1631),
    [anon_sym_usize] = ACTIONS(1631),
    [anon_sym_f32] = ACTIONS(1631),
    [anon_sym_f64] = ACTIONS(1631),
    [anon_sym_bool] = ACTIONS(1631),
    [anon_sym_str] = ACTIONS(1631),
    [anon_sym_char] = ACTIONS(1631),
    [anon_sym_SQUOTE] = ACTIONS(1631),
    [anon_sym_async] = ACTIONS(1631),
    [anon_sym_break] = ACTIONS(1631),
    [anon_sym_const] = ACTIONS(1631),
    [anon_sym_continue] = ACTIONS(1631),
    [anon_sym_default] = ACTIONS(1631),
    [anon_sym_enum] = ACTIONS(1631),
    [anon_sym_fn] = ACTIONS(1631),
    [anon_sym_for] = ACTIONS(1631),
    [anon_sym_if] = ACTIONS(1631),
    [anon_sym_impl] = ACTIONS(1631),
    [anon_sym_let] = ACTIONS(1631),
    [anon_sym_loop] = ACTIONS(1631),
    [anon_sym_match] = ACTIONS(1631),
    [anon_sym_mod] = ACTIONS(1631),
    [anon_sym_pub] = ACTIONS(1631),
    [anon_sym_return] = ACTIONS(1631),
    [anon_sym_static] = ACTIONS(1631),
    [anon_sym_struct] = ACTIONS(1631),
    [anon_sym_trait] = ACTIONS(1631),
    [anon_sym_type] = ACTIONS(1631),
    [anon_sym_union] = ACTIONS(1631),
    [anon_sym_unsafe] = ACTIONS(1631),
    [anon_sym_use] = ACTIONS(1631),
    [anon_sym_while] = ACTIONS(1631),
    [anon_sym_POUND] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1629),
    [anon_sym_extern] = ACTIONS(1631),
    [anon_sym_LT] = ACTIONS(1629),
    [anon_sym_COLON_COLON] = ACTIONS(1629),
    [anon_sym_AMP] = ACTIONS(1629),
    [anon_sym_DOT_DOT] = ACTIONS(1629),
    [anon_sym_DASH] = ACTIONS(1629),
    [anon_sym_PIPE] = ACTIONS(1629),
    [anon_sym_move] = ACTIONS(1631),
    [sym_integer_literal] = ACTIONS(1629),
    [aux_sym_string_literal_token1] = ACTIONS(1629),
    [sym_char_literal] = ACTIONS(1629),
    [anon_sym_true] = ACTIONS(1631),
    [anon_sym_false] = ACTIONS(1631),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1631),
    [sym_super] = ACTIONS(1631),
    [sym_crate] = ACTIONS(1631),
    [sym_metavariable] = ACTIONS(1629),
    [sym_raw_string_literal] = ACTIONS(1629),
    [sym_float_literal] = ACTIONS(1629),
    [sym_block_comment] = ACTIONS(3),
  },
  [327] = {
    [ts_builtin_sym_end] = ACTIONS(1633),
    [sym_identifier] = ACTIONS(1635),
    [anon_sym_SEMI] = ACTIONS(1633),
    [anon_sym_macro_rules_BANG] = ACTIONS(1633),
    [anon_sym_LPAREN] = ACTIONS(1633),
    [anon_sym_LBRACE] = ACTIONS(1633),
    [anon_sym_RBRACE] = ACTIONS(1633),
    [anon_sym_LBRACK] = ACTIONS(1633),
    [anon_sym_STAR] = ACTIONS(1633),
    [anon_sym_u8] = ACTIONS(1635),
    [anon_sym_i8] = ACTIONS(1635),
    [anon_sym_u16] = ACTIONS(1635),
    [anon_sym_i16] = ACTIONS(1635),
    [anon_sym_u32] = ACTIONS(1635),
    [anon_sym_i32] = ACTIONS(1635),
    [anon_sym_u64] = ACTIONS(1635),
    [anon_sym_i64] = ACTIONS(1635),
    [anon_sym_u128] = ACTIONS(1635),
    [anon_sym_i128] = ACTIONS(1635),
    [anon_sym_isize] = ACTIONS(1635),
    [anon_sym_usize] = ACTIONS(1635),
    [anon_sym_f32] = ACTIONS(1635),
    [anon_sym_f64] = ACTIONS(1635),
    [anon_sym_bool] = ACTIONS(1635),
    [anon_sym_str] = ACTIONS(1635),
    [anon_sym_char] = ACTIONS(1635),
    [anon_sym_SQUOTE] = ACTIONS(1635),
    [anon_sym_async] = ACTIONS(1635),
    [anon_sym_break] = ACTIONS(1635),
    [anon_sym_const] = ACTIONS(1635),
    [anon_sym_continue] = ACTIONS(1635),
    [anon_sym_default] = ACTIONS(1635),
    [anon_sym_enum] = ACTIONS(1635),
    [anon_sym_fn] = ACTIONS(1635),
    [anon_sym_for] = ACTIONS(1635),
    [anon_sym_if] = ACTIONS(1635),
    [anon_sym_impl] = ACTIONS(1635),
    [anon_sym_let] = ACTIONS(1635),
    [anon_sym_loop] = ACTIONS(1635),
    [anon_sym_match] = ACTIONS(1635),
    [anon_sym_mod] = ACTIONS(1635),
    [anon_sym_pub] = ACTIONS(1635),
    [anon_sym_return] = ACTIONS(1635),
    [anon_sym_static] = ACTIONS(1635),
    [anon_sym_struct] = ACTIONS(1635),
    [anon_sym_trait] = ACTIONS(1635),
    [anon_sym_type] = ACTIONS(1635),
    [anon_sym_union] = ACTIONS(1635),
    [anon_sym_unsafe] = ACTIONS(1635),
    [anon_sym_use] = ACTIONS(1635),
    [anon_sym_while] = ACTIONS(1635),
    [anon_sym_POUND] = ACTIONS(1633),
    [anon_sym_BANG] = ACTIONS(1633),
    [anon_sym_extern] = ACTIONS(1635),
    [anon_sym_LT] = ACTIONS(1633),
    [anon_sym_COLON_COLON] = ACTIONS(1633),
    [anon_sym_AMP] = ACTIONS(1633),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym_DASH] = ACTIONS(1633),
    [anon_sym_PIPE] = ACTIONS(1633),
    [anon_sym_move] = ACTIONS(1635),
    [sym_integer_literal] = ACTIONS(1633),
    [aux_sym_string_literal_token1] = ACTIONS(1633),
    [sym_char_literal] = ACTIONS(1633),
    [anon_sym_true] = ACTIONS(1635),
    [anon_sym_false] = ACTIONS(1635),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1635),
    [sym_super] = ACTIONS(1635),
    [sym_crate] = ACTIONS(1635),
    [sym_metavariable] = ACTIONS(1633),
    [sym_raw_string_literal] = ACTIONS(1633),
    [sym_float_literal] = ACTIONS(1633),
    [sym_block_comment] = ACTIONS(3),
  },
  [328] = {
    [ts_builtin_sym_end] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1639),
    [anon_sym_SEMI] = ACTIONS(1637),
    [anon_sym_macro_rules_BANG] = ACTIONS(1637),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_LBRACE] = ACTIONS(1637),
    [anon_sym_RBRACE] = ACTIONS(1637),
    [anon_sym_LBRACK] = ACTIONS(1637),
    [anon_sym_STAR] = ACTIONS(1637),
    [anon_sym_u8] = ACTIONS(1639),
    [anon_sym_i8] = ACTIONS(1639),
    [anon_sym_u16] = ACTIONS(1639),
    [anon_sym_i16] = ACTIONS(1639),
    [anon_sym_u32] = ACTIONS(1639),
    [anon_sym_i32] = ACTIONS(1639),
    [anon_sym_u64] = ACTIONS(1639),
    [anon_sym_i64] = ACTIONS(1639),
    [anon_sym_u128] = ACTIONS(1639),
    [anon_sym_i128] = ACTIONS(1639),
    [anon_sym_isize] = ACTIONS(1639),
    [anon_sym_usize] = ACTIONS(1639),
    [anon_sym_f32] = ACTIONS(1639),
    [anon_sym_f64] = ACTIONS(1639),
    [anon_sym_bool] = ACTIONS(1639),
    [anon_sym_str] = ACTIONS(1639),
    [anon_sym_char] = ACTIONS(1639),
    [anon_sym_SQUOTE] = ACTIONS(1639),
    [anon_sym_async] = ACTIONS(1639),
    [anon_sym_break] = ACTIONS(1639),
    [anon_sym_const] = ACTIONS(1639),
    [anon_sym_continue] = ACTIONS(1639),
    [anon_sym_default] = ACTIONS(1639),
    [anon_sym_enum] = ACTIONS(1639),
    [anon_sym_fn] = ACTIONS(1639),
    [anon_sym_for] = ACTIONS(1639),
    [anon_sym_if] = ACTIONS(1639),
    [anon_sym_impl] = ACTIONS(1639),
    [anon_sym_let] = ACTIONS(1639),
    [anon_sym_loop] = ACTIONS(1639),
    [anon_sym_match] = ACTIONS(1639),
    [anon_sym_mod] = ACTIONS(1639),
    [anon_sym_pub] = ACTIONS(1639),
    [anon_sym_return] = ACTIONS(1639),
    [anon_sym_static] = ACTIONS(1639),
    [anon_sym_struct] = ACTIONS(1639),
    [anon_sym_trait] = ACTIONS(1639),
    [anon_sym_type] = ACTIONS(1639),
    [anon_sym_union] = ACTIONS(1639),
    [anon_sym_unsafe] = ACTIONS(1639),
    [anon_sym_use] = ACTIONS(1639),
    [anon_sym_while] = ACTIONS(1639),
    [anon_sym_POUND] = ACTIONS(1637),
    [anon_sym_BANG] = ACTIONS(1637),
    [anon_sym_extern] = ACTIONS(1639),
    [anon_sym_LT] = ACTIONS(1637),
    [anon_sym_COLON_COLON] = ACTIONS(1637),
    [anon_sym_AMP] = ACTIONS(1637),
    [anon_sym_DOT_DOT] = ACTIONS(1637),
    [anon_sym_DASH] = ACTIONS(1637),
    [anon_sym_PIPE] = ACTIONS(1637),
    [anon_sym_move] = ACTIONS(1639),
    [sym_integer_literal] = ACTIONS(1637),
    [aux_sym_string_literal_token1] = ACTIONS(1637),
    [sym_char_literal] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(1639),
    [anon_sym_false] = ACTIONS(1639),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1639),
    [sym_super] = ACTIONS(1639),
    [sym_crate] = ACTIONS(1639),
    [sym_metavariable] = ACTIONS(1637),
    [sym_raw_string_literal] = ACTIONS(1637),
    [sym_float_literal] = ACTIONS(1637),
    [sym_block_comment] = ACTIONS(3),
  },
  [329] = {
    [ts_builtin_sym_end] = ACTIONS(1641),
    [sym_identifier] = ACTIONS(1643),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_macro_rules_BANG] = ACTIONS(1641),
    [anon_sym_LPAREN] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_RBRACE] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_STAR] = ACTIONS(1641),
    [anon_sym_u8] = ACTIONS(1643),
    [anon_sym_i8] = ACTIONS(1643),
    [anon_sym_u16] = ACTIONS(1643),
    [anon_sym_i16] = ACTIONS(1643),
    [anon_sym_u32] = ACTIONS(1643),
    [anon_sym_i32] = ACTIONS(1643),
    [anon_sym_u64] = ACTIONS(1643),
    [anon_sym_i64] = ACTIONS(1643),
    [anon_sym_u128] = ACTIONS(1643),
    [anon_sym_i128] = ACTIONS(1643),
    [anon_sym_isize] = ACTIONS(1643),
    [anon_sym_usize] = ACTIONS(1643),
    [anon_sym_f32] = ACTIONS(1643),
    [anon_sym_f64] = ACTIONS(1643),
    [anon_sym_bool] = ACTIONS(1643),
    [anon_sym_str] = ACTIONS(1643),
    [anon_sym_char] = ACTIONS(1643),
    [anon_sym_SQUOTE] = ACTIONS(1643),
    [anon_sym_async] = ACTIONS(1643),
    [anon_sym_break] = ACTIONS(1643),
    [anon_sym_const] = ACTIONS(1643),
    [anon_sym_continue] = ACTIONS(1643),
    [anon_sym_default] = ACTIONS(1643),
    [anon_sym_enum] = ACTIONS(1643),
    [anon_sym_fn] = ACTIONS(1643),
    [anon_sym_for] = ACTIONS(1643),
    [anon_sym_if] = ACTIONS(1643),
    [anon_sym_impl] = ACTIONS(1643),
    [anon_sym_let] = ACTIONS(1643),
    [anon_sym_loop] = ACTIONS(1643),
    [anon_sym_match] = ACTIONS(1643),
    [anon_sym_mod] = ACTIONS(1643),
    [anon_sym_pub] = ACTIONS(1643),
    [anon_sym_return] = ACTIONS(1643),
    [anon_sym_static] = ACTIONS(1643),
    [anon_sym_struct] = ACTIONS(1643),
    [anon_sym_trait] = ACTIONS(1643),
    [anon_sym_type] = ACTIONS(1643),
    [anon_sym_union] = ACTIONS(1643),
    [anon_sym_unsafe] = ACTIONS(1643),
    [anon_sym_use] = ACTIONS(1643),
    [anon_sym_while] = ACTIONS(1643),
    [anon_sym_POUND] = ACTIONS(1641),
    [anon_sym_BANG] = ACTIONS(1641),
    [anon_sym_extern] = ACTIONS(1643),
    [anon_sym_LT] = ACTIONS(1641),
    [anon_sym_COLON_COLON] = ACTIONS(1641),
    [anon_sym_AMP] = ACTIONS(1641),
    [anon_sym_DOT_DOT] = ACTIONS(1641),
    [anon_sym_DASH] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(1641),
    [anon_sym_move] = ACTIONS(1643),
    [sym_integer_literal] = ACTIONS(1641),
    [aux_sym_string_literal_token1] = ACTIONS(1641),
    [sym_char_literal] = ACTIONS(1641),
    [anon_sym_true] = ACTIONS(1643),
    [anon_sym_false] = ACTIONS(1643),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1643),
    [sym_super] = ACTIONS(1643),
    [sym_crate] = ACTIONS(1643),
    [sym_metavariable] = ACTIONS(1641),
    [sym_raw_string_literal] = ACTIONS(1641),
    [sym_float_literal] = ACTIONS(1641),
    [sym_block_comment] = ACTIONS(3),
  },
  [330] = {
    [ts_builtin_sym_end] = ACTIONS(1645),
    [sym_identifier] = ACTIONS(1647),
    [anon_sym_SEMI] = ACTIONS(1645),
    [anon_sym_macro_rules_BANG] = ACTIONS(1645),
    [anon_sym_LPAREN] = ACTIONS(1645),
    [anon_sym_LBRACE] = ACTIONS(1645),
    [anon_sym_RBRACE] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(1645),
    [anon_sym_STAR] = ACTIONS(1645),
    [anon_sym_u8] = ACTIONS(1647),
    [anon_sym_i8] = ACTIONS(1647),
    [anon_sym_u16] = ACTIONS(1647),
    [anon_sym_i16] = ACTIONS(1647),
    [anon_sym_u32] = ACTIONS(1647),
    [anon_sym_i32] = ACTIONS(1647),
    [anon_sym_u64] = ACTIONS(1647),
    [anon_sym_i64] = ACTIONS(1647),
    [anon_sym_u128] = ACTIONS(1647),
    [anon_sym_i128] = ACTIONS(1647),
    [anon_sym_isize] = ACTIONS(1647),
    [anon_sym_usize] = ACTIONS(1647),
    [anon_sym_f32] = ACTIONS(1647),
    [anon_sym_f64] = ACTIONS(1647),
    [anon_sym_bool] = ACTIONS(1647),
    [anon_sym_str] = ACTIONS(1647),
    [anon_sym_char] = ACTIONS(1647),
    [anon_sym_SQUOTE] = ACTIONS(1647),
    [anon_sym_async] = ACTIONS(1647),
    [anon_sym_break] = ACTIONS(1647),
    [anon_sym_const] = ACTIONS(1647),
    [anon_sym_continue] = ACTIONS(1647),
    [anon_sym_default] = ACTIONS(1647),
    [anon_sym_enum] = ACTIONS(1647),
    [anon_sym_fn] = ACTIONS(1647),
    [anon_sym_for] = ACTIONS(1647),
    [anon_sym_if] = ACTIONS(1647),
    [anon_sym_impl] = ACTIONS(1647),
    [anon_sym_let] = ACTIONS(1647),
    [anon_sym_loop] = ACTIONS(1647),
    [anon_sym_match] = ACTIONS(1647),
    [anon_sym_mod] = ACTIONS(1647),
    [anon_sym_pub] = ACTIONS(1647),
    [anon_sym_return] = ACTIONS(1647),
    [anon_sym_static] = ACTIONS(1647),
    [anon_sym_struct] = ACTIONS(1647),
    [anon_sym_trait] = ACTIONS(1647),
    [anon_sym_type] = ACTIONS(1647),
    [anon_sym_union] = ACTIONS(1647),
    [anon_sym_unsafe] = ACTIONS(1647),
    [anon_sym_use] = ACTIONS(1647),
    [anon_sym_while] = ACTIONS(1647),
    [anon_sym_POUND] = ACTIONS(1645),
    [anon_sym_BANG] = ACTIONS(1645),
    [anon_sym_extern] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(1645),
    [anon_sym_COLON_COLON] = ACTIONS(1645),
    [anon_sym_AMP] = ACTIONS(1645),
    [anon_sym_DOT_DOT] = ACTIONS(1645),
    [anon_sym_DASH] = ACTIONS(1645),
    [anon_sym_PIPE] = ACTIONS(1645),
    [anon_sym_move] = ACTIONS(1647),
    [sym_integer_literal] = ACTIONS(1645),
    [aux_sym_string_literal_token1] = ACTIONS(1645),
    [sym_char_literal] = ACTIONS(1645),
    [anon_sym_true] = ACTIONS(1647),
    [anon_sym_false] = ACTIONS(1647),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1647),
    [sym_super] = ACTIONS(1647),
    [sym_crate] = ACTIONS(1647),
    [sym_metavariable] = ACTIONS(1645),
    [sym_raw_string_literal] = ACTIONS(1645),
    [sym_float_literal] = ACTIONS(1645),
    [sym_block_comment] = ACTIONS(3),
  },
  [331] = {
    [ts_builtin_sym_end] = ACTIONS(1649),
    [sym_identifier] = ACTIONS(1651),
    [anon_sym_SEMI] = ACTIONS(1649),
    [anon_sym_macro_rules_BANG] = ACTIONS(1649),
    [anon_sym_LPAREN] = ACTIONS(1649),
    [anon_sym_LBRACE] = ACTIONS(1649),
    [anon_sym_RBRACE] = ACTIONS(1649),
    [anon_sym_LBRACK] = ACTIONS(1649),
    [anon_sym_STAR] = ACTIONS(1649),
    [anon_sym_u8] = ACTIONS(1651),
    [anon_sym_i8] = ACTIONS(1651),
    [anon_sym_u16] = ACTIONS(1651),
    [anon_sym_i16] = ACTIONS(1651),
    [anon_sym_u32] = ACTIONS(1651),
    [anon_sym_i32] = ACTIONS(1651),
    [anon_sym_u64] = ACTIONS(1651),
    [anon_sym_i64] = ACTIONS(1651),
    [anon_sym_u128] = ACTIONS(1651),
    [anon_sym_i128] = ACTIONS(1651),
    [anon_sym_isize] = ACTIONS(1651),
    [anon_sym_usize] = ACTIONS(1651),
    [anon_sym_f32] = ACTIONS(1651),
    [anon_sym_f64] = ACTIONS(1651),
    [anon_sym_bool] = ACTIONS(1651),
    [anon_sym_str] = ACTIONS(1651),
    [anon_sym_char] = ACTIONS(1651),
    [anon_sym_SQUOTE] = ACTIONS(1651),
    [anon_sym_async] = ACTIONS(1651),
    [anon_sym_break] = ACTIONS(1651),
    [anon_sym_const] = ACTIONS(1651),
    [anon_sym_continue] = ACTIONS(1651),
    [anon_sym_default] = ACTIONS(1651),
    [anon_sym_enum] = ACTIONS(1651),
    [anon_sym_fn] = ACTIONS(1651),
    [anon_sym_for] = ACTIONS(1651),
    [anon_sym_if] = ACTIONS(1651),
    [anon_sym_impl] = ACTIONS(1651),
    [anon_sym_let] = ACTIONS(1651),
    [anon_sym_loop] = ACTIONS(1651),
    [anon_sym_match] = ACTIONS(1651),
    [anon_sym_mod] = ACTIONS(1651),
    [anon_sym_pub] = ACTIONS(1651),
    [anon_sym_return] = ACTIONS(1651),
    [anon_sym_static] = ACTIONS(1651),
    [anon_sym_struct] = ACTIONS(1651),
    [anon_sym_trait] = ACTIONS(1651),
    [anon_sym_type] = ACTIONS(1651),
    [anon_sym_union] = ACTIONS(1651),
    [anon_sym_unsafe] = ACTIONS(1651),
    [anon_sym_use] = ACTIONS(1651),
    [anon_sym_while] = ACTIONS(1651),
    [anon_sym_POUND] = ACTIONS(1649),
    [anon_sym_BANG] = ACTIONS(1649),
    [anon_sym_extern] = ACTIONS(1651),
    [anon_sym_LT] = ACTIONS(1649),
    [anon_sym_COLON_COLON] = ACTIONS(1649),
    [anon_sym_AMP] = ACTIONS(1649),
    [anon_sym_DOT_DOT] = ACTIONS(1649),
    [anon_sym_DASH] = ACTIONS(1649),
    [anon_sym_PIPE] = ACTIONS(1649),
    [anon_sym_move] = ACTIONS(1651),
    [sym_integer_literal] = ACTIONS(1649),
    [aux_sym_string_literal_token1] = ACTIONS(1649),
    [sym_char_literal] = ACTIONS(1649),
    [anon_sym_true] = ACTIONS(1651),
    [anon_sym_false] = ACTIONS(1651),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1651),
    [sym_super] = ACTIONS(1651),
    [sym_crate] = ACTIONS(1651),
    [sym_metavariable] = ACTIONS(1649),
    [sym_raw_string_literal] = ACTIONS(1649),
    [sym_float_literal] = ACTIONS(1649),
    [sym_block_comment] = ACTIONS(3),
  },
  [332] = {
    [ts_builtin_sym_end] = ACTIONS(1653),
    [sym_identifier] = ACTIONS(1655),
    [anon_sym_SEMI] = ACTIONS(1653),
    [anon_sym_macro_rules_BANG] = ACTIONS(1653),
    [anon_sym_LPAREN] = ACTIONS(1653),
    [anon_sym_LBRACE] = ACTIONS(1653),
    [anon_sym_RBRACE] = ACTIONS(1653),
    [anon_sym_LBRACK] = ACTIONS(1653),
    [anon_sym_STAR] = ACTIONS(1653),
    [anon_sym_u8] = ACTIONS(1655),
    [anon_sym_i8] = ACTIONS(1655),
    [anon_sym_u16] = ACTIONS(1655),
    [anon_sym_i16] = ACTIONS(1655),
    [anon_sym_u32] = ACTIONS(1655),
    [anon_sym_i32] = ACTIONS(1655),
    [anon_sym_u64] = ACTIONS(1655),
    [anon_sym_i64] = ACTIONS(1655),
    [anon_sym_u128] = ACTIONS(1655),
    [anon_sym_i128] = ACTIONS(1655),
    [anon_sym_isize] = ACTIONS(1655),
    [anon_sym_usize] = ACTIONS(1655),
    [anon_sym_f32] = ACTIONS(1655),
    [anon_sym_f64] = ACTIONS(1655),
    [anon_sym_bool] = ACTIONS(1655),
    [anon_sym_str] = ACTIONS(1655),
    [anon_sym_char] = ACTIONS(1655),
    [anon_sym_SQUOTE] = ACTIONS(1655),
    [anon_sym_async] = ACTIONS(1655),
    [anon_sym_break] = ACTIONS(1655),
    [anon_sym_const] = ACTIONS(1655),
    [anon_sym_continue] = ACTIONS(1655),
    [anon_sym_default] = ACTIONS(1655),
    [anon_sym_enum] = ACTIONS(1655),
    [anon_sym_fn] = ACTIONS(1655),
    [anon_sym_for] = ACTIONS(1655),
    [anon_sym_if] = ACTIONS(1655),
    [anon_sym_impl] = ACTIONS(1655),
    [anon_sym_let] = ACTIONS(1655),
    [anon_sym_loop] = ACTIONS(1655),
    [anon_sym_match] = ACTIONS(1655),
    [anon_sym_mod] = ACTIONS(1655),
    [anon_sym_pub] = ACTIONS(1655),
    [anon_sym_return] = ACTIONS(1655),
    [anon_sym_static] = ACTIONS(1655),
    [anon_sym_struct] = ACTIONS(1655),
    [anon_sym_trait] = ACTIONS(1655),
    [anon_sym_type] = ACTIONS(1655),
    [anon_sym_union] = ACTIONS(1655),
    [anon_sym_unsafe] = ACTIONS(1655),
    [anon_sym_use] = ACTIONS(1655),
    [anon_sym_while] = ACTIONS(1655),
    [anon_sym_POUND] = ACTIONS(1653),
    [anon_sym_BANG] = ACTIONS(1653),
    [anon_sym_extern] = ACTIONS(1655),
    [anon_sym_LT] = ACTIONS(1653),
    [anon_sym_COLON_COLON] = ACTIONS(1653),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_DOT_DOT] = ACTIONS(1653),
    [anon_sym_DASH] = ACTIONS(1653),
    [anon_sym_PIPE] = ACTIONS(1653),
    [anon_sym_move] = ACTIONS(1655),
    [sym_integer_literal] = ACTIONS(1653),
    [aux_sym_string_literal_token1] = ACTIONS(1653),
    [sym_char_literal] = ACTIONS(1653),
    [anon_sym_true] = ACTIONS(1655),
    [anon_sym_false] = ACTIONS(1655),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1655),
    [sym_super] = ACTIONS(1655),
    [sym_crate] = ACTIONS(1655),
    [sym_metavariable] = ACTIONS(1653),
    [sym_raw_string_literal] = ACTIONS(1653),
    [sym_float_literal] = ACTIONS(1653),
    [sym_block_comment] = ACTIONS(3),
  },
  [333] = {
    [ts_builtin_sym_end] = ACTIONS(1657),
    [sym_identifier] = ACTIONS(1659),
    [anon_sym_SEMI] = ACTIONS(1657),
    [anon_sym_macro_rules_BANG] = ACTIONS(1657),
    [anon_sym_LPAREN] = ACTIONS(1657),
    [anon_sym_LBRACE] = ACTIONS(1657),
    [anon_sym_RBRACE] = ACTIONS(1657),
    [anon_sym_LBRACK] = ACTIONS(1657),
    [anon_sym_STAR] = ACTIONS(1657),
    [anon_sym_u8] = ACTIONS(1659),
    [anon_sym_i8] = ACTIONS(1659),
    [anon_sym_u16] = ACTIONS(1659),
    [anon_sym_i16] = ACTIONS(1659),
    [anon_sym_u32] = ACTIONS(1659),
    [anon_sym_i32] = ACTIONS(1659),
    [anon_sym_u64] = ACTIONS(1659),
    [anon_sym_i64] = ACTIONS(1659),
    [anon_sym_u128] = ACTIONS(1659),
    [anon_sym_i128] = ACTIONS(1659),
    [anon_sym_isize] = ACTIONS(1659),
    [anon_sym_usize] = ACTIONS(1659),
    [anon_sym_f32] = ACTIONS(1659),
    [anon_sym_f64] = ACTIONS(1659),
    [anon_sym_bool] = ACTIONS(1659),
    [anon_sym_str] = ACTIONS(1659),
    [anon_sym_char] = ACTIONS(1659),
    [anon_sym_SQUOTE] = ACTIONS(1659),
    [anon_sym_async] = ACTIONS(1659),
    [anon_sym_break] = ACTIONS(1659),
    [anon_sym_const] = ACTIONS(1659),
    [anon_sym_continue] = ACTIONS(1659),
    [anon_sym_default] = ACTIONS(1659),
    [anon_sym_enum] = ACTIONS(1659),
    [anon_sym_fn] = ACTIONS(1659),
    [anon_sym_for] = ACTIONS(1659),
    [anon_sym_if] = ACTIONS(1659),
    [anon_sym_impl] = ACTIONS(1659),
    [anon_sym_let] = ACTIONS(1659),
    [anon_sym_loop] = ACTIONS(1659),
    [anon_sym_match] = ACTIONS(1659),
    [anon_sym_mod] = ACTIONS(1659),
    [anon_sym_pub] = ACTIONS(1659),
    [anon_sym_return] = ACTIONS(1659),
    [anon_sym_static] = ACTIONS(1659),
    [anon_sym_struct] = ACTIONS(1659),
    [anon_sym_trait] = ACTIONS(1659),
    [anon_sym_type] = ACTIONS(1659),
    [anon_sym_union] = ACTIONS(1659),
    [anon_sym_unsafe] = ACTIONS(1659),
    [anon_sym_use] = ACTIONS(1659),
    [anon_sym_while] = ACTIONS(1659),
    [anon_sym_POUND] = ACTIONS(1657),
    [anon_sym_BANG] = ACTIONS(1657),
    [anon_sym_extern] = ACTIONS(1659),
    [anon_sym_LT] = ACTIONS(1657),
    [anon_sym_COLON_COLON] = ACTIONS(1657),
    [anon_sym_AMP] = ACTIONS(1657),
    [anon_sym_DOT_DOT] = ACTIONS(1657),
    [anon_sym_DASH] = ACTIONS(1657),
    [anon_sym_PIPE] = ACTIONS(1657),
    [anon_sym_move] = ACTIONS(1659),
    [sym_integer_literal] = ACTIONS(1657),
    [aux_sym_string_literal_token1] = ACTIONS(1657),
    [sym_char_literal] = ACTIONS(1657),
    [anon_sym_true] = ACTIONS(1659),
    [anon_sym_false] = ACTIONS(1659),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1659),
    [sym_super] = ACTIONS(1659),
    [sym_crate] = ACTIONS(1659),
    [sym_metavariable] = ACTIONS(1657),
    [sym_raw_string_literal] = ACTIONS(1657),
    [sym_float_literal] = ACTIONS(1657),
    [sym_block_comment] = ACTIONS(3),
  },
  [334] = {
    [ts_builtin_sym_end] = ACTIONS(1661),
    [sym_identifier] = ACTIONS(1663),
    [anon_sym_SEMI] = ACTIONS(1661),
    [anon_sym_macro_rules_BANG] = ACTIONS(1661),
    [anon_sym_LPAREN] = ACTIONS(1661),
    [anon_sym_LBRACE] = ACTIONS(1661),
    [anon_sym_RBRACE] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1661),
    [anon_sym_STAR] = ACTIONS(1661),
    [anon_sym_u8] = ACTIONS(1663),
    [anon_sym_i8] = ACTIONS(1663),
    [anon_sym_u16] = ACTIONS(1663),
    [anon_sym_i16] = ACTIONS(1663),
    [anon_sym_u32] = ACTIONS(1663),
    [anon_sym_i32] = ACTIONS(1663),
    [anon_sym_u64] = ACTIONS(1663),
    [anon_sym_i64] = ACTIONS(1663),
    [anon_sym_u128] = ACTIONS(1663),
    [anon_sym_i128] = ACTIONS(1663),
    [anon_sym_isize] = ACTIONS(1663),
    [anon_sym_usize] = ACTIONS(1663),
    [anon_sym_f32] = ACTIONS(1663),
    [anon_sym_f64] = ACTIONS(1663),
    [anon_sym_bool] = ACTIONS(1663),
    [anon_sym_str] = ACTIONS(1663),
    [anon_sym_char] = ACTIONS(1663),
    [anon_sym_SQUOTE] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(1663),
    [anon_sym_break] = ACTIONS(1663),
    [anon_sym_const] = ACTIONS(1663),
    [anon_sym_continue] = ACTIONS(1663),
    [anon_sym_default] = ACTIONS(1663),
    [anon_sym_enum] = ACTIONS(1663),
    [anon_sym_fn] = ACTIONS(1663),
    [anon_sym_for] = ACTIONS(1663),
    [anon_sym_if] = ACTIONS(1663),
    [anon_sym_impl] = ACTIONS(1663),
    [anon_sym_let] = ACTIONS(1663),
    [anon_sym_loop] = ACTIONS(1663),
    [anon_sym_match] = ACTIONS(1663),
    [anon_sym_mod] = ACTIONS(1663),
    [anon_sym_pub] = ACTIONS(1663),
    [anon_sym_return] = ACTIONS(1663),
    [anon_sym_static] = ACTIONS(1663),
    [anon_sym_struct] = ACTIONS(1663),
    [anon_sym_trait] = ACTIONS(1663),
    [anon_sym_type] = ACTIONS(1663),
    [anon_sym_union] = ACTIONS(1663),
    [anon_sym_unsafe] = ACTIONS(1663),
    [anon_sym_use] = ACTIONS(1663),
    [anon_sym_while] = ACTIONS(1663),
    [anon_sym_POUND] = ACTIONS(1661),
    [anon_sym_BANG] = ACTIONS(1661),
    [anon_sym_extern] = ACTIONS(1663),
    [anon_sym_LT] = ACTIONS(1661),
    [anon_sym_COLON_COLON] = ACTIONS(1661),
    [anon_sym_AMP] = ACTIONS(1661),
    [anon_sym_DOT_DOT] = ACTIONS(1661),
    [anon_sym_DASH] = ACTIONS(1661),
    [anon_sym_PIPE] = ACTIONS(1661),
    [anon_sym_move] = ACTIONS(1663),
    [sym_integer_literal] = ACTIONS(1661),
    [aux_sym_string_literal_token1] = ACTIONS(1661),
    [sym_char_literal] = ACTIONS(1661),
    [anon_sym_true] = ACTIONS(1663),
    [anon_sym_false] = ACTIONS(1663),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1663),
    [sym_super] = ACTIONS(1663),
    [sym_crate] = ACTIONS(1663),
    [sym_metavariable] = ACTIONS(1661),
    [sym_raw_string_literal] = ACTIONS(1661),
    [sym_float_literal] = ACTIONS(1661),
    [sym_block_comment] = ACTIONS(3),
  },
  [335] = {
    [ts_builtin_sym_end] = ACTIONS(1665),
    [sym_identifier] = ACTIONS(1667),
    [anon_sym_SEMI] = ACTIONS(1665),
    [anon_sym_macro_rules_BANG] = ACTIONS(1665),
    [anon_sym_LPAREN] = ACTIONS(1665),
    [anon_sym_LBRACE] = ACTIONS(1665),
    [anon_sym_RBRACE] = ACTIONS(1665),
    [anon_sym_LBRACK] = ACTIONS(1665),
    [anon_sym_STAR] = ACTIONS(1665),
    [anon_sym_u8] = ACTIONS(1667),
    [anon_sym_i8] = ACTIONS(1667),
    [anon_sym_u16] = ACTIONS(1667),
    [anon_sym_i16] = ACTIONS(1667),
    [anon_sym_u32] = ACTIONS(1667),
    [anon_sym_i32] = ACTIONS(1667),
    [anon_sym_u64] = ACTIONS(1667),
    [anon_sym_i64] = ACTIONS(1667),
    [anon_sym_u128] = ACTIONS(1667),
    [anon_sym_i128] = ACTIONS(1667),
    [anon_sym_isize] = ACTIONS(1667),
    [anon_sym_usize] = ACTIONS(1667),
    [anon_sym_f32] = ACTIONS(1667),
    [anon_sym_f64] = ACTIONS(1667),
    [anon_sym_bool] = ACTIONS(1667),
    [anon_sym_str] = ACTIONS(1667),
    [anon_sym_char] = ACTIONS(1667),
    [anon_sym_SQUOTE] = ACTIONS(1667),
    [anon_sym_async] = ACTIONS(1667),
    [anon_sym_break] = ACTIONS(1667),
    [anon_sym_const] = ACTIONS(1667),
    [anon_sym_continue] = ACTIONS(1667),
    [anon_sym_default] = ACTIONS(1667),
    [anon_sym_enum] = ACTIONS(1667),
    [anon_sym_fn] = ACTIONS(1667),
    [anon_sym_for] = ACTIONS(1667),
    [anon_sym_if] = ACTIONS(1667),
    [anon_sym_impl] = ACTIONS(1667),
    [anon_sym_let] = ACTIONS(1667),
    [anon_sym_loop] = ACTIONS(1667),
    [anon_sym_match] = ACTIONS(1667),
    [anon_sym_mod] = ACTIONS(1667),
    [anon_sym_pub] = ACTIONS(1667),
    [anon_sym_return] = ACTIONS(1667),
    [anon_sym_static] = ACTIONS(1667),
    [anon_sym_struct] = ACTIONS(1667),
    [anon_sym_trait] = ACTIONS(1667),
    [anon_sym_type] = ACTIONS(1667),
    [anon_sym_union] = ACTIONS(1667),
    [anon_sym_unsafe] = ACTIONS(1667),
    [anon_sym_use] = ACTIONS(1667),
    [anon_sym_while] = ACTIONS(1667),
    [anon_sym_POUND] = ACTIONS(1665),
    [anon_sym_BANG] = ACTIONS(1665),
    [anon_sym_extern] = ACTIONS(1667),
    [anon_sym_LT] = ACTIONS(1665),
    [anon_sym_COLON_COLON] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_DOT_DOT] = ACTIONS(1665),
    [anon_sym_DASH] = ACTIONS(1665),
    [anon_sym_PIPE] = ACTIONS(1665),
    [anon_sym_move] = ACTIONS(1667),
    [sym_integer_literal] = ACTIONS(1665),
    [aux_sym_string_literal_token1] = ACTIONS(1665),
    [sym_char_literal] = ACTIONS(1665),
    [anon_sym_true] = ACTIONS(1667),
    [anon_sym_false] = ACTIONS(1667),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1667),
    [sym_super] = ACTIONS(1667),
    [sym_crate] = ACTIONS(1667),
    [sym_metavariable] = ACTIONS(1665),
    [sym_raw_string_literal] = ACTIONS(1665),
    [sym_float_literal] = ACTIONS(1665),
    [sym_block_comment] = ACTIONS(3),
  },
  [336] = {
    [ts_builtin_sym_end] = ACTIONS(1669),
    [sym_identifier] = ACTIONS(1671),
    [anon_sym_SEMI] = ACTIONS(1669),
    [anon_sym_macro_rules_BANG] = ACTIONS(1669),
    [anon_sym_LPAREN] = ACTIONS(1669),
    [anon_sym_LBRACE] = ACTIONS(1669),
    [anon_sym_RBRACE] = ACTIONS(1669),
    [anon_sym_LBRACK] = ACTIONS(1669),
    [anon_sym_STAR] = ACTIONS(1669),
    [anon_sym_u8] = ACTIONS(1671),
    [anon_sym_i8] = ACTIONS(1671),
    [anon_sym_u16] = ACTIONS(1671),
    [anon_sym_i16] = ACTIONS(1671),
    [anon_sym_u32] = ACTIONS(1671),
    [anon_sym_i32] = ACTIONS(1671),
    [anon_sym_u64] = ACTIONS(1671),
    [anon_sym_i64] = ACTIONS(1671),
    [anon_sym_u128] = ACTIONS(1671),
    [anon_sym_i128] = ACTIONS(1671),
    [anon_sym_isize] = ACTIONS(1671),
    [anon_sym_usize] = ACTIONS(1671),
    [anon_sym_f32] = ACTIONS(1671),
    [anon_sym_f64] = ACTIONS(1671),
    [anon_sym_bool] = ACTIONS(1671),
    [anon_sym_str] = ACTIONS(1671),
    [anon_sym_char] = ACTIONS(1671),
    [anon_sym_SQUOTE] = ACTIONS(1671),
    [anon_sym_async] = ACTIONS(1671),
    [anon_sym_break] = ACTIONS(1671),
    [anon_sym_const] = ACTIONS(1671),
    [anon_sym_continue] = ACTIONS(1671),
    [anon_sym_default] = ACTIONS(1671),
    [anon_sym_enum] = ACTIONS(1671),
    [anon_sym_fn] = ACTIONS(1671),
    [anon_sym_for] = ACTIONS(1671),
    [anon_sym_if] = ACTIONS(1671),
    [anon_sym_impl] = ACTIONS(1671),
    [anon_sym_let] = ACTIONS(1671),
    [anon_sym_loop] = ACTIONS(1671),
    [anon_sym_match] = ACTIONS(1671),
    [anon_sym_mod] = ACTIONS(1671),
    [anon_sym_pub] = ACTIONS(1671),
    [anon_sym_return] = ACTIONS(1671),
    [anon_sym_static] = ACTIONS(1671),
    [anon_sym_struct] = ACTIONS(1671),
    [anon_sym_trait] = ACTIONS(1671),
    [anon_sym_type] = ACTIONS(1671),
    [anon_sym_union] = ACTIONS(1671),
    [anon_sym_unsafe] = ACTIONS(1671),
    [anon_sym_use] = ACTIONS(1671),
    [anon_sym_while] = ACTIONS(1671),
    [anon_sym_POUND] = ACTIONS(1669),
    [anon_sym_BANG] = ACTIONS(1669),
    [anon_sym_extern] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1669),
    [anon_sym_COLON_COLON] = ACTIONS(1669),
    [anon_sym_AMP] = ACTIONS(1669),
    [anon_sym_DOT_DOT] = ACTIONS(1669),
    [anon_sym_DASH] = ACTIONS(1669),
    [anon_sym_PIPE] = ACTIONS(1669),
    [anon_sym_move] = ACTIONS(1671),
    [sym_integer_literal] = ACTIONS(1669),
    [aux_sym_string_literal_token1] = ACTIONS(1669),
    [sym_char_literal] = ACTIONS(1669),
    [anon_sym_true] = ACTIONS(1671),
    [anon_sym_false] = ACTIONS(1671),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1671),
    [sym_super] = ACTIONS(1671),
    [sym_crate] = ACTIONS(1671),
    [sym_metavariable] = ACTIONS(1669),
    [sym_raw_string_literal] = ACTIONS(1669),
    [sym_float_literal] = ACTIONS(1669),
    [sym_block_comment] = ACTIONS(3),
  },
  [337] = {
    [sym__token_pattern] = STATE(246),
    [sym_token_tree_pattern] = STATE(246),
    [sym_token_binding_pattern] = STATE(246),
    [sym_token_repetition_pattern] = STATE(246),
    [sym__literal] = STATE(246),
    [sym_string_literal] = STATE(246),
    [sym_boolean_literal] = STATE(246),
    [aux_sym_token_tree_pattern_repeat1] = STATE(246),
    [sym_identifier] = ACTIONS(1673),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_RPAREN] = ACTIONS(1675),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_DOLLAR] = ACTIONS(1321),
    [anon_sym_u8] = ACTIONS(1323),
    [anon_sym_i8] = ACTIONS(1323),
    [anon_sym_u16] = ACTIONS(1323),
    [anon_sym_i16] = ACTIONS(1323),
    [anon_sym_u32] = ACTIONS(1323),
    [anon_sym_i32] = ACTIONS(1323),
    [anon_sym_u64] = ACTIONS(1323),
    [anon_sym_i64] = ACTIONS(1323),
    [anon_sym_u128] = ACTIONS(1323),
    [anon_sym_i128] = ACTIONS(1323),
    [anon_sym_isize] = ACTIONS(1323),
    [anon_sym_usize] = ACTIONS(1323),
    [anon_sym_f32] = ACTIONS(1323),
    [anon_sym_f64] = ACTIONS(1323),
    [anon_sym_bool] = ACTIONS(1323),
    [anon_sym_str] = ACTIONS(1323),
    [anon_sym_char] = ACTIONS(1323),
    [aux_sym__non_special_token_token1] = ACTIONS(1673),
    [anon_sym_SQUOTE] = ACTIONS(1673),
    [anon_sym_as] = ACTIONS(1673),
    [anon_sym_async] = ACTIONS(1673),
    [anon_sym_await] = ACTIONS(1673),
    [anon_sym_break] = ACTIONS(1673),
    [anon_sym_const] = ACTIONS(1673),
    [anon_sym_continue] = ACTIONS(1673),
    [anon_sym_default] = ACTIONS(1673),
    [anon_sym_enum] = ACTIONS(1673),
    [anon_sym_fn] = ACTIONS(1673),
    [anon_sym_for] = ACTIONS(1673),
    [anon_sym_if] = ACTIONS(1673),
    [anon_sym_impl] = ACTIONS(1673),
    [anon_sym_let] = ACTIONS(1673),
    [anon_sym_loop] = ACTIONS(1673),
    [anon_sym_match] = ACTIONS(1673),
    [anon_sym_mod] = ACTIONS(1673),
    [anon_sym_pub] = ACTIONS(1673),
    [anon_sym_return] = ACTIONS(1673),
    [anon_sym_static] = ACTIONS(1673),
    [anon_sym_struct] = ACTIONS(1673),
    [anon_sym_trait] = ACTIONS(1673),
    [anon_sym_type] = ACTIONS(1673),
    [anon_sym_union] = ACTIONS(1673),
    [anon_sym_unsafe] = ACTIONS(1673),
    [anon_sym_use] = ACTIONS(1673),
    [anon_sym_where] = ACTIONS(1673),
    [anon_sym_while] = ACTIONS(1673),
    [sym_mutable_specifier] = ACTIONS(1673),
    [sym_integer_literal] = ACTIONS(1677),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(1677),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(1673),
    [sym_super] = ACTIONS(1673),
    [sym_crate] = ACTIONS(1673),
    [sym_metavariable] = ACTIONS(1331),
    [sym_raw_string_literal] = ACTIONS(1677),
    [sym_float_literal] = ACTIONS(1677),
    [sym_block_comment] = ACTIONS(3),
  },
  [338] = {
    [ts_builtin_sym_end] = ACTIONS(1679),
    [sym_identifier] = ACTIONS(1681),
    [anon_sym_SEMI] = ACTIONS(1679),
    [anon_sym_macro_rules_BANG] = ACTIONS(1679),
    [anon_sym_LPAREN] = ACTIONS(1679),
    [anon_sym_LBRACE] = ACTIONS(1679),
    [anon_sym_RBRACE] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(1679),
    [anon_sym_STAR] = ACTIONS(1679),
    [anon_sym_u8] = ACTIONS(1681),
    [anon_sym_i8] = ACTIONS(1681),
    [anon_sym_u16] = ACTIONS(1681),
    [anon_sym_i16] = ACTIONS(1681),
    [anon_sym_u32] = ACTIONS(1681),
    [anon_sym_i32] = ACTIONS(1681),
    [anon_sym_u64] = ACTIONS(1681),
    [anon_sym_i64] = ACTIONS(1681),
    [anon_sym_u128] = ACTIONS(1681),
    [anon_sym_i128] = ACTIONS(1681),
    [anon_sym_isize] = ACTIONS(1681),
    [anon_sym_usize] = ACTIONS(1681),
    [anon_sym_f32] = ACTIONS(1681),
    [anon_sym_f64] = ACTIONS(1681),
    [anon_sym_bool] = ACTIONS(1681),
    [anon_sym_str] = ACTIONS(1681),
    [anon_sym_char] = ACTIONS(1681),
    [anon_sym_SQUOTE] = ACTIONS(1681),
    [anon_sym_async] = ACTIONS(1681),
    [anon_sym_break] = ACTIONS(1681),
    [anon_sym_const] = ACTIONS(1681),
    [anon_sym_continue] = ACTIONS(1681),
    [anon_sym_default] = ACTIONS(1681),
    [anon_sym_enum] = ACTIONS(1681),
    [anon_sym_fn] = ACTIONS(1681),
    [anon_sym_for] = ACTIONS(1681),
    [anon_sym_if] = ACTIONS(1681),
    [anon_sym_impl] = ACTIONS(1681),
    [anon_sym_let] = ACTIONS(1681),
    [anon_sym_loop] = ACTIONS(1681),
    [anon_sym_match] = ACTIONS(1681),
    [anon_sym_mod] = ACTIONS(1681),
    [anon_sym_pub] = ACTIONS(1681),
    [anon_sym_return] = ACTIONS(1681),
    [anon_sym_static] = ACTIONS(1681),
    [anon_sym_struct] = ACTIONS(1681),
    [anon_sym_trait] = ACTIONS(1681),
    [anon_sym_type] = ACTIONS(1681),
    [anon_sym_union] = ACTIONS(1681),
    [anon_sym_unsafe] = ACTIONS(1681),
    [anon_sym_use] = ACTIONS(1681),
    [anon_sym_while] = ACTIONS(1681),
    [anon_sym_POUND] = ACTIONS(1679),
    [anon_sym_BANG] = ACTIONS(1679),
    [anon_sym_extern] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1679),
    [anon_sym_COLON_COLON] = ACTIONS(1679),
    [anon_sym_AMP] = ACTIONS(1679),
    [anon_sym_DOT_DOT] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1679),
    [anon_sym_PIPE] = ACTIONS(1679),
    [anon_sym_move] = ACTIONS(1681),
    [sym_integer_literal] = ACTIONS(1679),
    [aux_sym_string_literal_token1] = ACTIONS(1679),
    [sym_char_literal] = ACTIONS(1679),
    [anon_sym_true] = ACTIONS(1681),
    [anon_sym_false] = ACTIONS(1681),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1681),
    [sym_super] = ACTIONS(1681),
    [sym_crate] = ACTIONS(1681),
    [sym_metavariable] = ACTIONS(1679),
    [sym_raw_string_literal] = ACTIONS(1679),
    [sym_float_literal] = ACTIONS(1679),
    [sym_block_comment] = ACTIONS(3),
  },
  [339] = {
    [ts_builtin_sym_end] = ACTIONS(1683),
    [sym_identifier] = ACTIONS(1685),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_macro_rules_BANG] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(1683),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1683),
    [anon_sym_STAR] = ACTIONS(1683),
    [anon_sym_u8] = ACTIONS(1685),
    [anon_sym_i8] = ACTIONS(1685),
    [anon_sym_u16] = ACTIONS(1685),
    [anon_sym_i16] = ACTIONS(1685),
    [anon_sym_u32] = ACTIONS(1685),
    [anon_sym_i32] = ACTIONS(1685),
    [anon_sym_u64] = ACTIONS(1685),
    [anon_sym_i64] = ACTIONS(1685),
    [anon_sym_u128] = ACTIONS(1685),
    [anon_sym_i128] = ACTIONS(1685),
    [anon_sym_isize] = ACTIONS(1685),
    [anon_sym_usize] = ACTIONS(1685),
    [anon_sym_f32] = ACTIONS(1685),
    [anon_sym_f64] = ACTIONS(1685),
    [anon_sym_bool] = ACTIONS(1685),
    [anon_sym_str] = ACTIONS(1685),
    [anon_sym_char] = ACTIONS(1685),
    [anon_sym_SQUOTE] = ACTIONS(1685),
    [anon_sym_async] = ACTIONS(1685),
    [anon_sym_break] = ACTIONS(1685),
    [anon_sym_const] = ACTIONS(1685),
    [anon_sym_continue] = ACTIONS(1685),
    [anon_sym_default] = ACTIONS(1685),
    [anon_sym_enum] = ACTIONS(1685),
    [anon_sym_fn] = ACTIONS(1685),
    [anon_sym_for] = ACTIONS(1685),
    [anon_sym_if] = ACTIONS(1685),
    [anon_sym_impl] = ACTIONS(1685),
    [anon_sym_let] = ACTIONS(1685),
    [anon_sym_loop] = ACTIONS(1685),
    [anon_sym_match] = ACTIONS(1685),
    [anon_sym_mod] = ACTIONS(1685),
    [anon_sym_pub] = ACTIONS(1685),
    [anon_sym_return] = ACTIONS(1685),
    [anon_sym_static] = ACTIONS(1685),
    [anon_sym_struct] = ACTIONS(1685),
    [anon_sym_trait] = ACTIONS(1685),
    [anon_sym_type] = ACTIONS(1685),
    [anon_sym_union] = ACTIONS(1685),
    [anon_sym_unsafe] = ACTIONS(1685),
    [anon_sym_use] = ACTIONS(1685),
    [anon_sym_while] = ACTIONS(1685),
    [anon_sym_POUND] = ACTIONS(1683),
    [anon_sym_BANG] = ACTIONS(1683),
    [anon_sym_extern] = ACTIONS(1685),
    [anon_sym_LT] = ACTIONS(1683),
    [anon_sym_COLON_COLON] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1683),
    [anon_sym_DOT_DOT] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1683),
    [anon_sym_move] = ACTIONS(1685),
    [sym_integer_literal] = ACTIONS(1683),
    [aux_sym_string_literal_token1] = ACTIONS(1683),
    [sym_char_literal] = ACTIONS(1683),
    [anon_sym_true] = ACTIONS(1685),
    [anon_sym_false] = ACTIONS(1685),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1685),
    [sym_super] = ACTIONS(1685),
    [sym_crate] = ACTIONS(1685),
    [sym_metavariable] = ACTIONS(1683),
    [sym_raw_string_literal] = ACTIONS(1683),
    [sym_float_literal] = ACTIONS(1683),
    [sym_block_comment] = ACTIONS(3),
  },
  [340] = {
    [ts_builtin_sym_end] = ACTIONS(1687),
    [sym_identifier] = ACTIONS(1689),
    [anon_sym_SEMI] = ACTIONS(1687),
    [anon_sym_macro_rules_BANG] = ACTIONS(1687),
    [anon_sym_LPAREN] = ACTIONS(1687),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_RBRACE] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1687),
    [anon_sym_STAR] = ACTIONS(1687),
    [anon_sym_u8] = ACTIONS(1689),
    [anon_sym_i8] = ACTIONS(1689),
    [anon_sym_u16] = ACTIONS(1689),
    [anon_sym_i16] = ACTIONS(1689),
    [anon_sym_u32] = ACTIONS(1689),
    [anon_sym_i32] = ACTIONS(1689),
    [anon_sym_u64] = ACTIONS(1689),
    [anon_sym_i64] = ACTIONS(1689),
    [anon_sym_u128] = ACTIONS(1689),
    [anon_sym_i128] = ACTIONS(1689),
    [anon_sym_isize] = ACTIONS(1689),
    [anon_sym_usize] = ACTIONS(1689),
    [anon_sym_f32] = ACTIONS(1689),
    [anon_sym_f64] = ACTIONS(1689),
    [anon_sym_bool] = ACTIONS(1689),
    [anon_sym_str] = ACTIONS(1689),
    [anon_sym_char] = ACTIONS(1689),
    [anon_sym_SQUOTE] = ACTIONS(1689),
    [anon_sym_async] = ACTIONS(1689),
    [anon_sym_break] = ACTIONS(1689),
    [anon_sym_const] = ACTIONS(1689),
    [anon_sym_continue] = ACTIONS(1689),
    [anon_sym_default] = ACTIONS(1689),
    [anon_sym_enum] = ACTIONS(1689),
    [anon_sym_fn] = ACTIONS(1689),
    [anon_sym_for] = ACTIONS(1689),
    [anon_sym_if] = ACTIONS(1689),
    [anon_sym_impl] = ACTIONS(1689),
    [anon_sym_let] = ACTIONS(1689),
    [anon_sym_loop] = ACTIONS(1689),
    [anon_sym_match] = ACTIONS(1689),
    [anon_sym_mod] = ACTIONS(1689),
    [anon_sym_pub] = ACTIONS(1689),
    [anon_sym_return] = ACTIONS(1689),
    [anon_sym_static] = ACTIONS(1689),
    [anon_sym_struct] = ACTIONS(1689),
    [anon_sym_trait] = ACTIONS(1689),
    [anon_sym_type] = ACTIONS(1689),
    [anon_sym_union] = ACTIONS(1689),
    [anon_sym_unsafe] = ACTIONS(1689),
    [anon_sym_use] = ACTIONS(1689),
    [anon_sym_while] = ACTIONS(1689),
    [anon_sym_POUND] = ACTIONS(1687),
    [anon_sym_BANG] = ACTIONS(1687),
    [anon_sym_extern] = ACTIONS(1689),
    [anon_sym_LT] = ACTIONS(1687),
    [anon_sym_COLON_COLON] = ACTIONS(1687),
    [anon_sym_AMP] = ACTIONS(1687),
    [anon_sym_DOT_DOT] = ACTIONS(1687),
    [anon_sym_DASH] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(1687),
    [anon_sym_move] = ACTIONS(1689),
    [sym_integer_literal] = ACTIONS(1687),
    [aux_sym_string_literal_token1] = ACTIONS(1687),
    [sym_char_literal] = ACTIONS(1687),
    [anon_sym_true] = ACTIONS(1689),
    [anon_sym_false] = ACTIONS(1689),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1689),
    [sym_super] = ACTIONS(1689),
    [sym_crate] = ACTIONS(1689),
    [sym_metavariable] = ACTIONS(1687),
    [sym_raw_string_literal] = ACTIONS(1687),
    [sym_float_literal] = ACTIONS(1687),
    [sym_block_comment] = ACTIONS(3),
  },
  [341] = {
    [ts_builtin_sym_end] = ACTIONS(1691),
    [sym_identifier] = ACTIONS(1693),
    [anon_sym_SEMI] = ACTIONS(1691),
    [anon_sym_macro_rules_BANG] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1691),
    [anon_sym_LBRACE] = ACTIONS(1691),
    [anon_sym_RBRACE] = ACTIONS(1691),
    [anon_sym_LBRACK] = ACTIONS(1691),
    [anon_sym_STAR] = ACTIONS(1691),
    [anon_sym_u8] = ACTIONS(1693),
    [anon_sym_i8] = ACTIONS(1693),
    [anon_sym_u16] = ACTIONS(1693),
    [anon_sym_i16] = ACTIONS(1693),
    [anon_sym_u32] = ACTIONS(1693),
    [anon_sym_i32] = ACTIONS(1693),
    [anon_sym_u64] = ACTIONS(1693),
    [anon_sym_i64] = ACTIONS(1693),
    [anon_sym_u128] = ACTIONS(1693),
    [anon_sym_i128] = ACTIONS(1693),
    [anon_sym_isize] = ACTIONS(1693),
    [anon_sym_usize] = ACTIONS(1693),
    [anon_sym_f32] = ACTIONS(1693),
    [anon_sym_f64] = ACTIONS(1693),
    [anon_sym_bool] = ACTIONS(1693),
    [anon_sym_str] = ACTIONS(1693),
    [anon_sym_char] = ACTIONS(1693),
    [anon_sym_SQUOTE] = ACTIONS(1693),
    [anon_sym_async] = ACTIONS(1693),
    [anon_sym_break] = ACTIONS(1693),
    [anon_sym_const] = ACTIONS(1693),
    [anon_sym_continue] = ACTIONS(1693),
    [anon_sym_default] = ACTIONS(1693),
    [anon_sym_enum] = ACTIONS(1693),
    [anon_sym_fn] = ACTIONS(1693),
    [anon_sym_for] = ACTIONS(1693),
    [anon_sym_if] = ACTIONS(1693),
    [anon_sym_impl] = ACTIONS(1693),
    [anon_sym_let] = ACTIONS(1693),
    [anon_sym_loop] = ACTIONS(1693),
    [anon_sym_match] = ACTIONS(1693),
    [anon_sym_mod] = ACTIONS(1693),
    [anon_sym_pub] = ACTIONS(1693),
    [anon_sym_return] = ACTIONS(1693),
    [anon_sym_static] = ACTIONS(1693),
    [anon_sym_struct] = ACTIONS(1693),
    [anon_sym_trait] = ACTIONS(1693),
    [anon_sym_type] = ACTIONS(1693),
    [anon_sym_union] = ACTIONS(1693),
    [anon_sym_unsafe] = ACTIONS(1693),
    [anon_sym_use] = ACTIONS(1693),
    [anon_sym_while] = ACTIONS(1693),
    [anon_sym_POUND] = ACTIONS(1691),
    [anon_sym_BANG] = ACTIONS(1691),
    [anon_sym_extern] = ACTIONS(1693),
    [anon_sym_LT] = ACTIONS(1691),
    [anon_sym_COLON_COLON] = ACTIONS(1691),
    [anon_sym_AMP] = ACTIONS(1691),
    [anon_sym_DOT_DOT] = ACTIONS(1691),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_PIPE] = ACTIONS(1691),
    [anon_sym_move] = ACTIONS(1693),
    [sym_integer_literal] = ACTIONS(1691),
    [aux_sym_string_literal_token1] = ACTIONS(1691),
    [sym_char_literal] = ACTIONS(1691),
    [anon_sym_true] = ACTIONS(1693),
    [anon_sym_false] = ACTIONS(1693),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1693),
    [sym_super] = ACTIONS(1693),
    [sym_crate] = ACTIONS(1693),
    [sym_metavariable] = ACTIONS(1691),
    [sym_raw_string_literal] = ACTIONS(1691),
    [sym_float_literal] = ACTIONS(1691),
    [sym_block_comment] = ACTIONS(3),
  },
  [342] = {
    [ts_builtin_sym_end] = ACTIONS(1695),
    [sym_identifier] = ACTIONS(1697),
    [anon_sym_SEMI] = ACTIONS(1695),
    [anon_sym_macro_rules_BANG] = ACTIONS(1695),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_LBRACE] = ACTIONS(1695),
    [anon_sym_RBRACE] = ACTIONS(1695),
    [anon_sym_LBRACK] = ACTIONS(1695),
    [anon_sym_STAR] = ACTIONS(1695),
    [anon_sym_u8] = ACTIONS(1697),
    [anon_sym_i8] = ACTIONS(1697),
    [anon_sym_u16] = ACTIONS(1697),
    [anon_sym_i16] = ACTIONS(1697),
    [anon_sym_u32] = ACTIONS(1697),
    [anon_sym_i32] = ACTIONS(1697),
    [anon_sym_u64] = ACTIONS(1697),
    [anon_sym_i64] = ACTIONS(1697),
    [anon_sym_u128] = ACTIONS(1697),
    [anon_sym_i128] = ACTIONS(1697),
    [anon_sym_isize] = ACTIONS(1697),
    [anon_sym_usize] = ACTIONS(1697),
    [anon_sym_f32] = ACTIONS(1697),
    [anon_sym_f64] = ACTIONS(1697),
    [anon_sym_bool] = ACTIONS(1697),
    [anon_sym_str] = ACTIONS(1697),
    [anon_sym_char] = ACTIONS(1697),
    [anon_sym_SQUOTE] = ACTIONS(1697),
    [anon_sym_async] = ACTIONS(1697),
    [anon_sym_break] = ACTIONS(1697),
    [anon_sym_const] = ACTIONS(1697),
    [anon_sym_continue] = ACTIONS(1697),
    [anon_sym_default] = ACTIONS(1697),
    [anon_sym_enum] = ACTIONS(1697),
    [anon_sym_fn] = ACTIONS(1697),
    [anon_sym_for] = ACTIONS(1697),
    [anon_sym_if] = ACTIONS(1697),
    [anon_sym_impl] = ACTIONS(1697),
    [anon_sym_let] = ACTIONS(1697),
    [anon_sym_loop] = ACTIONS(1697),
    [anon_sym_match] = ACTIONS(1697),
    [anon_sym_mod] = ACTIONS(1697),
    [anon_sym_pub] = ACTIONS(1697),
    [anon_sym_return] = ACTIONS(1697),
    [anon_sym_static] = ACTIONS(1697),
    [anon_sym_struct] = ACTIONS(1697),
    [anon_sym_trait] = ACTIONS(1697),
    [anon_sym_type] = ACTIONS(1697),
    [anon_sym_union] = ACTIONS(1697),
    [anon_sym_unsafe] = ACTIONS(1697),
    [anon_sym_use] = ACTIONS(1697),
    [anon_sym_while] = ACTIONS(1697),
    [anon_sym_POUND] = ACTIONS(1695),
    [anon_sym_BANG] = ACTIONS(1695),
    [anon_sym_extern] = ACTIONS(1697),
    [anon_sym_LT] = ACTIONS(1695),
    [anon_sym_COLON_COLON] = ACTIONS(1695),
    [anon_sym_AMP] = ACTIONS(1695),
    [anon_sym_DOT_DOT] = ACTIONS(1695),
    [anon_sym_DASH] = ACTIONS(1695),
    [anon_sym_PIPE] = ACTIONS(1695),
    [anon_sym_move] = ACTIONS(1697),
    [sym_integer_literal] = ACTIONS(1695),
    [aux_sym_string_literal_token1] = ACTIONS(1695),
    [sym_char_literal] = ACTIONS(1695),
    [anon_sym_true] = ACTIONS(1697),
    [anon_sym_false] = ACTIONS(1697),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1697),
    [sym_super] = ACTIONS(1697),
    [sym_crate] = ACTIONS(1697),
    [sym_metavariable] = ACTIONS(1695),
    [sym_raw_string_literal] = ACTIONS(1695),
    [sym_float_literal] = ACTIONS(1695),
    [sym_block_comment] = ACTIONS(3),
  },
  [343] = {
    [ts_builtin_sym_end] = ACTIONS(1699),
    [sym_identifier] = ACTIONS(1701),
    [anon_sym_SEMI] = ACTIONS(1699),
    [anon_sym_macro_rules_BANG] = ACTIONS(1699),
    [anon_sym_LPAREN] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1699),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1699),
    [anon_sym_STAR] = ACTIONS(1699),
    [anon_sym_u8] = ACTIONS(1701),
    [anon_sym_i8] = ACTIONS(1701),
    [anon_sym_u16] = ACTIONS(1701),
    [anon_sym_i16] = ACTIONS(1701),
    [anon_sym_u32] = ACTIONS(1701),
    [anon_sym_i32] = ACTIONS(1701),
    [anon_sym_u64] = ACTIONS(1701),
    [anon_sym_i64] = ACTIONS(1701),
    [anon_sym_u128] = ACTIONS(1701),
    [anon_sym_i128] = ACTIONS(1701),
    [anon_sym_isize] = ACTIONS(1701),
    [anon_sym_usize] = ACTIONS(1701),
    [anon_sym_f32] = ACTIONS(1701),
    [anon_sym_f64] = ACTIONS(1701),
    [anon_sym_bool] = ACTIONS(1701),
    [anon_sym_str] = ACTIONS(1701),
    [anon_sym_char] = ACTIONS(1701),
    [anon_sym_SQUOTE] = ACTIONS(1701),
    [anon_sym_async] = ACTIONS(1701),
    [anon_sym_break] = ACTIONS(1701),
    [anon_sym_const] = ACTIONS(1701),
    [anon_sym_continue] = ACTIONS(1701),
    [anon_sym_default] = ACTIONS(1701),
    [anon_sym_enum] = ACTIONS(1701),
    [anon_sym_fn] = ACTIONS(1701),
    [anon_sym_for] = ACTIONS(1701),
    [anon_sym_if] = ACTIONS(1701),
    [anon_sym_impl] = ACTIONS(1701),
    [anon_sym_let] = ACTIONS(1701),
    [anon_sym_loop] = ACTIONS(1701),
    [anon_sym_match] = ACTIONS(1701),
    [anon_sym_mod] = ACTIONS(1701),
    [anon_sym_pub] = ACTIONS(1701),
    [anon_sym_return] = ACTIONS(1701),
    [anon_sym_static] = ACTIONS(1701),
    [anon_sym_struct] = ACTIONS(1701),
    [anon_sym_trait] = ACTIONS(1701),
    [anon_sym_type] = ACTIONS(1701),
    [anon_sym_union] = ACTIONS(1701),
    [anon_sym_unsafe] = ACTIONS(1701),
    [anon_sym_use] = ACTIONS(1701),
    [anon_sym_while] = ACTIONS(1701),
    [anon_sym_POUND] = ACTIONS(1699),
    [anon_sym_BANG] = ACTIONS(1699),
    [anon_sym_extern] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1699),
    [anon_sym_COLON_COLON] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1699),
    [anon_sym_DOT_DOT] = ACTIONS(1699),
    [anon_sym_DASH] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1699),
    [anon_sym_move] = ACTIONS(1701),
    [sym_integer_literal] = ACTIONS(1699),
    [aux_sym_string_literal_token1] = ACTIONS(1699),
    [sym_char_literal] = ACTIONS(1699),
    [anon_sym_true] = ACTIONS(1701),
    [anon_sym_false] = ACTIONS(1701),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1701),
    [sym_super] = ACTIONS(1701),
    [sym_crate] = ACTIONS(1701),
    [sym_metavariable] = ACTIONS(1699),
    [sym_raw_string_literal] = ACTIONS(1699),
    [sym_float_literal] = ACTIONS(1699),
    [sym_block_comment] = ACTIONS(3),
  },
  [344] = {
    [ts_builtin_sym_end] = ACTIONS(1703),
    [sym_identifier] = ACTIONS(1705),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_macro_rules_BANG] = ACTIONS(1703),
    [anon_sym_LPAREN] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1703),
    [anon_sym_u8] = ACTIONS(1705),
    [anon_sym_i8] = ACTIONS(1705),
    [anon_sym_u16] = ACTIONS(1705),
    [anon_sym_i16] = ACTIONS(1705),
    [anon_sym_u32] = ACTIONS(1705),
    [anon_sym_i32] = ACTIONS(1705),
    [anon_sym_u64] = ACTIONS(1705),
    [anon_sym_i64] = ACTIONS(1705),
    [anon_sym_u128] = ACTIONS(1705),
    [anon_sym_i128] = ACTIONS(1705),
    [anon_sym_isize] = ACTIONS(1705),
    [anon_sym_usize] = ACTIONS(1705),
    [anon_sym_f32] = ACTIONS(1705),
    [anon_sym_f64] = ACTIONS(1705),
    [anon_sym_bool] = ACTIONS(1705),
    [anon_sym_str] = ACTIONS(1705),
    [anon_sym_char] = ACTIONS(1705),
    [anon_sym_SQUOTE] = ACTIONS(1705),
    [anon_sym_async] = ACTIONS(1705),
    [anon_sym_break] = ACTIONS(1705),
    [anon_sym_const] = ACTIONS(1705),
    [anon_sym_continue] = ACTIONS(1705),
    [anon_sym_default] = ACTIONS(1705),
    [anon_sym_enum] = ACTIONS(1705),
    [anon_sym_fn] = ACTIONS(1705),
    [anon_sym_for] = ACTIONS(1705),
    [anon_sym_if] = ACTIONS(1705),
    [anon_sym_impl] = ACTIONS(1705),
    [anon_sym_let] = ACTIONS(1705),
    [anon_sym_loop] = ACTIONS(1705),
    [anon_sym_match] = ACTIONS(1705),
    [anon_sym_mod] = ACTIONS(1705),
    [anon_sym_pub] = ACTIONS(1705),
    [anon_sym_return] = ACTIONS(1705),
    [anon_sym_static] = ACTIONS(1705),
    [anon_sym_struct] = ACTIONS(1705),
    [anon_sym_trait] = ACTIONS(1705),
    [anon_sym_type] = ACTIONS(1705),
    [anon_sym_union] = ACTIONS(1705),
    [anon_sym_unsafe] = ACTIONS(1705),
    [anon_sym_use] = ACTIONS(1705),
    [anon_sym_while] = ACTIONS(1705),
    [anon_sym_POUND] = ACTIONS(1703),
    [anon_sym_BANG] = ACTIONS(1703),
    [anon_sym_extern] = ACTIONS(1705),
    [anon_sym_LT] = ACTIONS(1703),
    [anon_sym_COLON_COLON] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1703),
    [anon_sym_DASH] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1703),
    [anon_sym_move] = ACTIONS(1705),
    [sym_integer_literal] = ACTIONS(1703),
    [aux_sym_string_literal_token1] = ACTIONS(1703),
    [sym_char_literal] = ACTIONS(1703),
    [anon_sym_true] = ACTIONS(1705),
    [anon_sym_false] = ACTIONS(1705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1705),
    [sym_super] = ACTIONS(1705),
    [sym_crate] = ACTIONS(1705),
    [sym_metavariable] = ACTIONS(1703),
    [sym_raw_string_literal] = ACTIONS(1703),
    [sym_float_literal] = ACTIONS(1703),
    [sym_block_comment] = ACTIONS(3),
  },
  [345] = {
    [ts_builtin_sym_end] = ACTIONS(1707),
    [sym_identifier] = ACTIONS(1709),
    [anon_sym_SEMI] = ACTIONS(1707),
    [anon_sym_macro_rules_BANG] = ACTIONS(1707),
    [anon_sym_LPAREN] = ACTIONS(1707),
    [anon_sym_LBRACE] = ACTIONS(1707),
    [anon_sym_RBRACE] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1707),
    [anon_sym_STAR] = ACTIONS(1707),
    [anon_sym_u8] = ACTIONS(1709),
    [anon_sym_i8] = ACTIONS(1709),
    [anon_sym_u16] = ACTIONS(1709),
    [anon_sym_i16] = ACTIONS(1709),
    [anon_sym_u32] = ACTIONS(1709),
    [anon_sym_i32] = ACTIONS(1709),
    [anon_sym_u64] = ACTIONS(1709),
    [anon_sym_i64] = ACTIONS(1709),
    [anon_sym_u128] = ACTIONS(1709),
    [anon_sym_i128] = ACTIONS(1709),
    [anon_sym_isize] = ACTIONS(1709),
    [anon_sym_usize] = ACTIONS(1709),
    [anon_sym_f32] = ACTIONS(1709),
    [anon_sym_f64] = ACTIONS(1709),
    [anon_sym_bool] = ACTIONS(1709),
    [anon_sym_str] = ACTIONS(1709),
    [anon_sym_char] = ACTIONS(1709),
    [anon_sym_SQUOTE] = ACTIONS(1709),
    [anon_sym_async] = ACTIONS(1709),
    [anon_sym_break] = ACTIONS(1709),
    [anon_sym_const] = ACTIONS(1709),
    [anon_sym_continue] = ACTIONS(1709),
    [anon_sym_default] = ACTIONS(1709),
    [anon_sym_enum] = ACTIONS(1709),
    [anon_sym_fn] = ACTIONS(1709),
    [anon_sym_for] = ACTIONS(1709),
    [anon_sym_if] = ACTIONS(1709),
    [anon_sym_impl] = ACTIONS(1709),
    [anon_sym_let] = ACTIONS(1709),
    [anon_sym_loop] = ACTIONS(1709),
    [anon_sym_match] = ACTIONS(1709),
    [anon_sym_mod] = ACTIONS(1709),
    [anon_sym_pub] = ACTIONS(1709),
    [anon_sym_return] = ACTIONS(1709),
    [anon_sym_static] = ACTIONS(1709),
    [anon_sym_struct] = ACTIONS(1709),
    [anon_sym_trait] = ACTIONS(1709),
    [anon_sym_type] = ACTIONS(1709),
    [anon_sym_union] = ACTIONS(1709),
    [anon_sym_unsafe] = ACTIONS(1709),
    [anon_sym_use] = ACTIONS(1709),
    [anon_sym_while] = ACTIONS(1709),
    [anon_sym_POUND] = ACTIONS(1707),
    [anon_sym_BANG] = ACTIONS(1707),
    [anon_sym_extern] = ACTIONS(1709),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_COLON_COLON] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DASH] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_move] = ACTIONS(1709),
    [sym_integer_literal] = ACTIONS(1707),
    [aux_sym_string_literal_token1] = ACTIONS(1707),
    [sym_char_literal] = ACTIONS(1707),
    [anon_sym_true] = ACTIONS(1709),
    [anon_sym_false] = ACTIONS(1709),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1709),
    [sym_super] = ACTIONS(1709),
    [sym_crate] = ACTIONS(1709),
    [sym_metavariable] = ACTIONS(1707),
    [sym_raw_string_literal] = ACTIONS(1707),
    [sym_float_literal] = ACTIONS(1707),
    [sym_block_comment] = ACTIONS(3),
  },
  [346] = {
    [ts_builtin_sym_end] = ACTIONS(1711),
    [sym_identifier] = ACTIONS(1713),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_macro_rules_BANG] = ACTIONS(1711),
    [anon_sym_LPAREN] = ACTIONS(1711),
    [anon_sym_LBRACE] = ACTIONS(1711),
    [anon_sym_RBRACE] = ACTIONS(1711),
    [anon_sym_LBRACK] = ACTIONS(1711),
    [anon_sym_STAR] = ACTIONS(1711),
    [anon_sym_u8] = ACTIONS(1713),
    [anon_sym_i8] = ACTIONS(1713),
    [anon_sym_u16] = ACTIONS(1713),
    [anon_sym_i16] = ACTIONS(1713),
    [anon_sym_u32] = ACTIONS(1713),
    [anon_sym_i32] = ACTIONS(1713),
    [anon_sym_u64] = ACTIONS(1713),
    [anon_sym_i64] = ACTIONS(1713),
    [anon_sym_u128] = ACTIONS(1713),
    [anon_sym_i128] = ACTIONS(1713),
    [anon_sym_isize] = ACTIONS(1713),
    [anon_sym_usize] = ACTIONS(1713),
    [anon_sym_f32] = ACTIONS(1713),
    [anon_sym_f64] = ACTIONS(1713),
    [anon_sym_bool] = ACTIONS(1713),
    [anon_sym_str] = ACTIONS(1713),
    [anon_sym_char] = ACTIONS(1713),
    [anon_sym_SQUOTE] = ACTIONS(1713),
    [anon_sym_async] = ACTIONS(1713),
    [anon_sym_break] = ACTIONS(1713),
    [anon_sym_const] = ACTIONS(1713),
    [anon_sym_continue] = ACTIONS(1713),
    [anon_sym_default] = ACTIONS(1713),
    [anon_sym_enum] = ACTIONS(1713),
    [anon_sym_fn] = ACTIONS(1713),
    [anon_sym_for] = ACTIONS(1713),
    [anon_sym_if] = ACTIONS(1713),
    [anon_sym_impl] = ACTIONS(1713),
    [anon_sym_let] = ACTIONS(1713),
    [anon_sym_loop] = ACTIONS(1713),
    [anon_sym_match] = ACTIONS(1713),
    [anon_sym_mod] = ACTIONS(1713),
    [anon_sym_pub] = ACTIONS(1713),
    [anon_sym_return] = ACTIONS(1713),
    [anon_sym_static] = ACTIONS(1713),
    [anon_sym_struct] = ACTIONS(1713),
    [anon_sym_trait] = ACTIONS(1713),
    [anon_sym_type] = ACTIONS(1713),
    [anon_sym_union] = ACTIONS(1713),
    [anon_sym_unsafe] = ACTIONS(1713),
    [anon_sym_use] = ACTIONS(1713),
    [anon_sym_while] = ACTIONS(1713),
    [anon_sym_POUND] = ACTIONS(1711),
    [anon_sym_BANG] = ACTIONS(1711),
    [anon_sym_extern] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(1711),
    [anon_sym_COLON_COLON] = ACTIONS(1711),
    [anon_sym_AMP] = ACTIONS(1711),
    [anon_sym_DOT_DOT] = ACTIONS(1711),
    [anon_sym_DASH] = ACTIONS(1711),
    [anon_sym_PIPE] = ACTIONS(1711),
    [anon_sym_move] = ACTIONS(1713),
    [sym_integer_literal] = ACTIONS(1711),
    [aux_sym_string_literal_token1] = ACTIONS(1711),
    [sym_char_literal] = ACTIONS(1711),
    [anon_sym_true] = ACTIONS(1713),
    [anon_sym_false] = ACTIONS(1713),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1713),
    [sym_super] = ACTIONS(1713),
    [sym_crate] = ACTIONS(1713),
    [sym_metavariable] = ACTIONS(1711),
    [sym_raw_string_literal] = ACTIONS(1711),
    [sym_float_literal] = ACTIONS(1711),
    [sym_block_comment] = ACTIONS(3),
  },
  [347] = {
    [ts_builtin_sym_end] = ACTIONS(1715),
    [sym_identifier] = ACTIONS(1717),
    [anon_sym_SEMI] = ACTIONS(1715),
    [anon_sym_macro_rules_BANG] = ACTIONS(1715),
    [anon_sym_LPAREN] = ACTIONS(1715),
    [anon_sym_LBRACE] = ACTIONS(1715),
    [anon_sym_RBRACE] = ACTIONS(1715),
    [anon_sym_LBRACK] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1715),
    [anon_sym_u8] = ACTIONS(1717),
    [anon_sym_i8] = ACTIONS(1717),
    [anon_sym_u16] = ACTIONS(1717),
    [anon_sym_i16] = ACTIONS(1717),
    [anon_sym_u32] = ACTIONS(1717),
    [anon_sym_i32] = ACTIONS(1717),
    [anon_sym_u64] = ACTIONS(1717),
    [anon_sym_i64] = ACTIONS(1717),
    [anon_sym_u128] = ACTIONS(1717),
    [anon_sym_i128] = ACTIONS(1717),
    [anon_sym_isize] = ACTIONS(1717),
    [anon_sym_usize] = ACTIONS(1717),
    [anon_sym_f32] = ACTIONS(1717),
    [anon_sym_f64] = ACTIONS(1717),
    [anon_sym_bool] = ACTIONS(1717),
    [anon_sym_str] = ACTIONS(1717),
    [anon_sym_char] = ACTIONS(1717),
    [anon_sym_SQUOTE] = ACTIONS(1717),
    [anon_sym_async] = ACTIONS(1717),
    [anon_sym_break] = ACTIONS(1717),
    [anon_sym_const] = ACTIONS(1717),
    [anon_sym_continue] = ACTIONS(1717),
    [anon_sym_default] = ACTIONS(1717),
    [anon_sym_enum] = ACTIONS(1717),
    [anon_sym_fn] = ACTIONS(1717),
    [anon_sym_for] = ACTIONS(1717),
    [anon_sym_if] = ACTIONS(1717),
    [anon_sym_impl] = ACTIONS(1717),
    [anon_sym_let] = ACTIONS(1717),
    [anon_sym_loop] = ACTIONS(1717),
    [anon_sym_match] = ACTIONS(1717),
    [anon_sym_mod] = ACTIONS(1717),
    [anon_sym_pub] = ACTIONS(1717),
    [anon_sym_return] = ACTIONS(1717),
    [anon_sym_static] = ACTIONS(1717),
    [anon_sym_struct] = ACTIONS(1717),
    [anon_sym_trait] = ACTIONS(1717),
    [anon_sym_type] = ACTIONS(1717),
    [anon_sym_union] = ACTIONS(1717),
    [anon_sym_unsafe] = ACTIONS(1717),
    [anon_sym_use] = ACTIONS(1717),
    [anon_sym_while] = ACTIONS(1717),
    [anon_sym_POUND] = ACTIONS(1715),
    [anon_sym_BANG] = ACTIONS(1715),
    [anon_sym_extern] = ACTIONS(1717),
    [anon_sym_LT] = ACTIONS(1715),
    [anon_sym_COLON_COLON] = ACTIONS(1715),
    [anon_sym_AMP] = ACTIONS(1715),
    [anon_sym_DOT_DOT] = ACTIONS(1715),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_PIPE] = ACTIONS(1715),
    [anon_sym_move] = ACTIONS(1717),
    [sym_integer_literal] = ACTIONS(1715),
    [aux_sym_string_literal_token1] = ACTIONS(1715),
    [sym_char_literal] = ACTIONS(1715),
    [anon_sym_true] = ACTIONS(1717),
    [anon_sym_false] = ACTIONS(1717),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1717),
    [sym_super] = ACTIONS(1717),
    [sym_crate] = ACTIONS(1717),
    [sym_metavariable] = ACTIONS(1715),
    [sym_raw_string_literal] = ACTIONS(1715),
    [sym_float_literal] = ACTIONS(1715),
    [sym_block_comment] = ACTIONS(3),
  },
  [348] = {
    [ts_builtin_sym_end] = ACTIONS(1719),
    [sym_identifier] = ACTIONS(1721),
    [anon_sym_SEMI] = ACTIONS(1719),
    [anon_sym_macro_rules_BANG] = ACTIONS(1719),
    [anon_sym_LPAREN] = ACTIONS(1719),
    [anon_sym_LBRACE] = ACTIONS(1719),
    [anon_sym_RBRACE] = ACTIONS(1719),
    [anon_sym_LBRACK] = ACTIONS(1719),
    [anon_sym_STAR] = ACTIONS(1719),
    [anon_sym_u8] = ACTIONS(1721),
    [anon_sym_i8] = ACTIONS(1721),
    [anon_sym_u16] = ACTIONS(1721),
    [anon_sym_i16] = ACTIONS(1721),
    [anon_sym_u32] = ACTIONS(1721),
    [anon_sym_i32] = ACTIONS(1721),
    [anon_sym_u64] = ACTIONS(1721),
    [anon_sym_i64] = ACTIONS(1721),
    [anon_sym_u128] = ACTIONS(1721),
    [anon_sym_i128] = ACTIONS(1721),
    [anon_sym_isize] = ACTIONS(1721),
    [anon_sym_usize] = ACTIONS(1721),
    [anon_sym_f32] = ACTIONS(1721),
    [anon_sym_f64] = ACTIONS(1721),
    [anon_sym_bool] = ACTIONS(1721),
    [anon_sym_str] = ACTIONS(1721),
    [anon_sym_char] = ACTIONS(1721),
    [anon_sym_SQUOTE] = ACTIONS(1721),
    [anon_sym_async] = ACTIONS(1721),
    [anon_sym_break] = ACTIONS(1721),
    [anon_sym_const] = ACTIONS(1721),
    [anon_sym_continue] = ACTIONS(1721),
    [anon_sym_default] = ACTIONS(1721),
    [anon_sym_enum] = ACTIONS(1721),
    [anon_sym_fn] = ACTIONS(1721),
    [anon_sym_for] = ACTIONS(1721),
    [anon_sym_if] = ACTIONS(1721),
    [anon_sym_impl] = ACTIONS(1721),
    [anon_sym_let] = ACTIONS(1721),
    [anon_sym_loop] = ACTIONS(1721),
    [anon_sym_match] = ACTIONS(1721),
    [anon_sym_mod] = ACTIONS(1721),
    [anon_sym_pub] = ACTIONS(1721),
    [anon_sym_return] = ACTIONS(1721),
    [anon_sym_static] = ACTIONS(1721),
    [anon_sym_struct] = ACTIONS(1721),
    [anon_sym_trait] = ACTIONS(1721),
    [anon_sym_type] = ACTIONS(1721),
    [anon_sym_union] = ACTIONS(1721),
    [anon_sym_unsafe] = ACTIONS(1721),
    [anon_sym_use] = ACTIONS(1721),
    [anon_sym_while] = ACTIONS(1721),
    [anon_sym_POUND] = ACTIONS(1719),
    [anon_sym_BANG] = ACTIONS(1719),
    [anon_sym_extern] = ACTIONS(1721),
    [anon_sym_LT] = ACTIONS(1719),
    [anon_sym_COLON_COLON] = ACTIONS(1719),
    [anon_sym_AMP] = ACTIONS(1719),
    [anon_sym_DOT_DOT] = ACTIONS(1719),
    [anon_sym_DASH] = ACTIONS(1719),
    [anon_sym_PIPE] = ACTIONS(1719),
    [anon_sym_move] = ACTIONS(1721),
    [sym_integer_literal] = ACTIONS(1719),
    [aux_sym_string_literal_token1] = ACTIONS(1719),
    [sym_char_literal] = ACTIONS(1719),
    [anon_sym_true] = ACTIONS(1721),
    [anon_sym_false] = ACTIONS(1721),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1721),
    [sym_super] = ACTIONS(1721),
    [sym_crate] = ACTIONS(1721),
    [sym_metavariable] = ACTIONS(1719),
    [sym_raw_string_literal] = ACTIONS(1719),
    [sym_float_literal] = ACTIONS(1719),
    [sym_block_comment] = ACTIONS(3),
  },
  [349] = {
    [ts_builtin_sym_end] = ACTIONS(1723),
    [sym_identifier] = ACTIONS(1725),
    [anon_sym_SEMI] = ACTIONS(1723),
    [anon_sym_macro_rules_BANG] = ACTIONS(1723),
    [anon_sym_LPAREN] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_RBRACE] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(1723),
    [anon_sym_STAR] = ACTIONS(1723),
    [anon_sym_u8] = ACTIONS(1725),
    [anon_sym_i8] = ACTIONS(1725),
    [anon_sym_u16] = ACTIONS(1725),
    [anon_sym_i16] = ACTIONS(1725),
    [anon_sym_u32] = ACTIONS(1725),
    [anon_sym_i32] = ACTIONS(1725),
    [anon_sym_u64] = ACTIONS(1725),
    [anon_sym_i64] = ACTIONS(1725),
    [anon_sym_u128] = ACTIONS(1725),
    [anon_sym_i128] = ACTIONS(1725),
    [anon_sym_isize] = ACTIONS(1725),
    [anon_sym_usize] = ACTIONS(1725),
    [anon_sym_f32] = ACTIONS(1725),
    [anon_sym_f64] = ACTIONS(1725),
    [anon_sym_bool] = ACTIONS(1725),
    [anon_sym_str] = ACTIONS(1725),
    [anon_sym_char] = ACTIONS(1725),
    [anon_sym_SQUOTE] = ACTIONS(1725),
    [anon_sym_async] = ACTIONS(1725),
    [anon_sym_break] = ACTIONS(1725),
    [anon_sym_const] = ACTIONS(1725),
    [anon_sym_continue] = ACTIONS(1725),
    [anon_sym_default] = ACTIONS(1725),
    [anon_sym_enum] = ACTIONS(1725),
    [anon_sym_fn] = ACTIONS(1725),
    [anon_sym_for] = ACTIONS(1725),
    [anon_sym_if] = ACTIONS(1725),
    [anon_sym_impl] = ACTIONS(1725),
    [anon_sym_let] = ACTIONS(1725),
    [anon_sym_loop] = ACTIONS(1725),
    [anon_sym_match] = ACTIONS(1725),
    [anon_sym_mod] = ACTIONS(1725),
    [anon_sym_pub] = ACTIONS(1725),
    [anon_sym_return] = ACTIONS(1725),
    [anon_sym_static] = ACTIONS(1725),
    [anon_sym_struct] = ACTIONS(1725),
    [anon_sym_trait] = ACTIONS(1725),
    [anon_sym_type] = ACTIONS(1725),
    [anon_sym_union] = ACTIONS(1725),
    [anon_sym_unsafe] = ACTIONS(1725),
    [anon_sym_use] = ACTIONS(1725),
    [anon_sym_while] = ACTIONS(1725),
    [anon_sym_POUND] = ACTIONS(1723),
    [anon_sym_BANG] = ACTIONS(1723),
    [anon_sym_extern] = ACTIONS(1725),
    [anon_sym_LT] = ACTIONS(1723),
    [anon_sym_COLON_COLON] = ACTIONS(1723),
    [anon_sym_AMP] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1723),
    [anon_sym_DASH] = ACTIONS(1723),
    [anon_sym_PIPE] = ACTIONS(1723),
    [anon_sym_move] = ACTIONS(1725),
    [sym_integer_literal] = ACTIONS(1723),
    [aux_sym_string_literal_token1] = ACTIONS(1723),
    [sym_char_literal] = ACTIONS(1723),
    [anon_sym_true] = ACTIONS(1725),
    [anon_sym_false] = ACTIONS(1725),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1725),
    [sym_super] = ACTIONS(1725),
    [sym_crate] = ACTIONS(1725),
    [sym_metavariable] = ACTIONS(1723),
    [sym_raw_string_literal] = ACTIONS(1723),
    [sym_float_literal] = ACTIONS(1723),
    [sym_block_comment] = ACTIONS(3),
  },
  [350] = {
    [ts_builtin_sym_end] = ACTIONS(1727),
    [sym_identifier] = ACTIONS(1729),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym_macro_rules_BANG] = ACTIONS(1727),
    [anon_sym_LPAREN] = ACTIONS(1727),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_RBRACE] = ACTIONS(1727),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_STAR] = ACTIONS(1727),
    [anon_sym_u8] = ACTIONS(1729),
    [anon_sym_i8] = ACTIONS(1729),
    [anon_sym_u16] = ACTIONS(1729),
    [anon_sym_i16] = ACTIONS(1729),
    [anon_sym_u32] = ACTIONS(1729),
    [anon_sym_i32] = ACTIONS(1729),
    [anon_sym_u64] = ACTIONS(1729),
    [anon_sym_i64] = ACTIONS(1729),
    [anon_sym_u128] = ACTIONS(1729),
    [anon_sym_i128] = ACTIONS(1729),
    [anon_sym_isize] = ACTIONS(1729),
    [anon_sym_usize] = ACTIONS(1729),
    [anon_sym_f32] = ACTIONS(1729),
    [anon_sym_f64] = ACTIONS(1729),
    [anon_sym_bool] = ACTIONS(1729),
    [anon_sym_str] = ACTIONS(1729),
    [anon_sym_char] = ACTIONS(1729),
    [anon_sym_SQUOTE] = ACTIONS(1729),
    [anon_sym_async] = ACTIONS(1729),
    [anon_sym_break] = ACTIONS(1729),
    [anon_sym_const] = ACTIONS(1729),
    [anon_sym_continue] = ACTIONS(1729),
    [anon_sym_default] = ACTIONS(1729),
    [anon_sym_enum] = ACTIONS(1729),
    [anon_sym_fn] = ACTIONS(1729),
    [anon_sym_for] = ACTIONS(1729),
    [anon_sym_if] = ACTIONS(1729),
    [anon_sym_impl] = ACTIONS(1729),
    [anon_sym_let] = ACTIONS(1729),
    [anon_sym_loop] = ACTIONS(1729),
    [anon_sym_match] = ACTIONS(1729),
    [anon_sym_mod] = ACTIONS(1729),
    [anon_sym_pub] = ACTIONS(1729),
    [anon_sym_return] = ACTIONS(1729),
    [anon_sym_static] = ACTIONS(1729),
    [anon_sym_struct] = ACTIONS(1729),
    [anon_sym_trait] = ACTIONS(1729),
    [anon_sym_type] = ACTIONS(1729),
    [anon_sym_union] = ACTIONS(1729),
    [anon_sym_unsafe] = ACTIONS(1729),
    [anon_sym_use] = ACTIONS(1729),
    [anon_sym_while] = ACTIONS(1729),
    [anon_sym_POUND] = ACTIONS(1727),
    [anon_sym_BANG] = ACTIONS(1727),
    [anon_sym_extern] = ACTIONS(1729),
    [anon_sym_LT] = ACTIONS(1727),
    [anon_sym_COLON_COLON] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1727),
    [anon_sym_DOT_DOT] = ACTIONS(1727),
    [anon_sym_DASH] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1727),
    [anon_sym_move] = ACTIONS(1729),
    [sym_integer_literal] = ACTIONS(1727),
    [aux_sym_string_literal_token1] = ACTIONS(1727),
    [sym_char_literal] = ACTIONS(1727),
    [anon_sym_true] = ACTIONS(1729),
    [anon_sym_false] = ACTIONS(1729),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1729),
    [sym_super] = ACTIONS(1729),
    [sym_crate] = ACTIONS(1729),
    [sym_metavariable] = ACTIONS(1727),
    [sym_raw_string_literal] = ACTIONS(1727),
    [sym_float_literal] = ACTIONS(1727),
    [sym_block_comment] = ACTIONS(3),
  },
  [351] = {
    [ts_builtin_sym_end] = ACTIONS(1731),
    [sym_identifier] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1731),
    [anon_sym_macro_rules_BANG] = ACTIONS(1731),
    [anon_sym_LPAREN] = ACTIONS(1731),
    [anon_sym_LBRACE] = ACTIONS(1731),
    [anon_sym_RBRACE] = ACTIONS(1731),
    [anon_sym_LBRACK] = ACTIONS(1731),
    [anon_sym_STAR] = ACTIONS(1731),
    [anon_sym_u8] = ACTIONS(1733),
    [anon_sym_i8] = ACTIONS(1733),
    [anon_sym_u16] = ACTIONS(1733),
    [anon_sym_i16] = ACTIONS(1733),
    [anon_sym_u32] = ACTIONS(1733),
    [anon_sym_i32] = ACTIONS(1733),
    [anon_sym_u64] = ACTIONS(1733),
    [anon_sym_i64] = ACTIONS(1733),
    [anon_sym_u128] = ACTIONS(1733),
    [anon_sym_i128] = ACTIONS(1733),
    [anon_sym_isize] = ACTIONS(1733),
    [anon_sym_usize] = ACTIONS(1733),
    [anon_sym_f32] = ACTIONS(1733),
    [anon_sym_f64] = ACTIONS(1733),
    [anon_sym_bool] = ACTIONS(1733),
    [anon_sym_str] = ACTIONS(1733),
    [anon_sym_char] = ACTIONS(1733),
    [anon_sym_SQUOTE] = ACTIONS(1733),
    [anon_sym_async] = ACTIONS(1733),
    [anon_sym_break] = ACTIONS(1733),
    [anon_sym_const] = ACTIONS(1733),
    [anon_sym_continue] = ACTIONS(1733),
    [anon_sym_default] = ACTIONS(1733),
    [anon_sym_enum] = ACTIONS(1733),
    [anon_sym_fn] = ACTIONS(1733),
    [anon_sym_for] = ACTIONS(1733),
    [anon_sym_if] = ACTIONS(1733),
    [anon_sym_impl] = ACTIONS(1733),
    [anon_sym_let] = ACTIONS(1733),
    [anon_sym_loop] = ACTIONS(1733),
    [anon_sym_match] = ACTIONS(1733),
    [anon_sym_mod] = ACTIONS(1733),
    [anon_sym_pub] = ACTIONS(1733),
    [anon_sym_return] = ACTIONS(1733),
    [anon_sym_static] = ACTIONS(1733),
    [anon_sym_struct] = ACTIONS(1733),
    [anon_sym_trait] = ACTIONS(1733),
    [anon_sym_type] = ACTIONS(1733),
    [anon_sym_union] = ACTIONS(1733),
    [anon_sym_unsafe] = ACTIONS(1733),
    [anon_sym_use] = ACTIONS(1733),
    [anon_sym_while] = ACTIONS(1733),
    [anon_sym_POUND] = ACTIONS(1731),
    [anon_sym_BANG] = ACTIONS(1731),
    [anon_sym_extern] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1731),
    [anon_sym_COLON_COLON] = ACTIONS(1731),
    [anon_sym_AMP] = ACTIONS(1731),
    [anon_sym_DOT_DOT] = ACTIONS(1731),
    [anon_sym_DASH] = ACTIONS(1731),
    [anon_sym_PIPE] = ACTIONS(1731),
    [anon_sym_move] = ACTIONS(1733),
    [sym_integer_literal] = ACTIONS(1731),
    [aux_sym_string_literal_token1] = ACTIONS(1731),
    [sym_char_literal] = ACTIONS(1731),
    [anon_sym_true] = ACTIONS(1733),
    [anon_sym_false] = ACTIONS(1733),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1733),
    [sym_super] = ACTIONS(1733),
    [sym_crate] = ACTIONS(1733),
    [sym_metavariable] = ACTIONS(1731),
    [sym_raw_string_literal] = ACTIONS(1731),
    [sym_float_literal] = ACTIONS(1731),
    [sym_block_comment] = ACTIONS(3),
  },
  [352] = {
    [ts_builtin_sym_end] = ACTIONS(1735),
    [sym_identifier] = ACTIONS(1737),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_macro_rules_BANG] = ACTIONS(1735),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(1735),
    [anon_sym_RBRACE] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1735),
    [anon_sym_STAR] = ACTIONS(1735),
    [anon_sym_u8] = ACTIONS(1737),
    [anon_sym_i8] = ACTIONS(1737),
    [anon_sym_u16] = ACTIONS(1737),
    [anon_sym_i16] = ACTIONS(1737),
    [anon_sym_u32] = ACTIONS(1737),
    [anon_sym_i32] = ACTIONS(1737),
    [anon_sym_u64] = ACTIONS(1737),
    [anon_sym_i64] = ACTIONS(1737),
    [anon_sym_u128] = ACTIONS(1737),
    [anon_sym_i128] = ACTIONS(1737),
    [anon_sym_isize] = ACTIONS(1737),
    [anon_sym_usize] = ACTIONS(1737),
    [anon_sym_f32] = ACTIONS(1737),
    [anon_sym_f64] = ACTIONS(1737),
    [anon_sym_bool] = ACTIONS(1737),
    [anon_sym_str] = ACTIONS(1737),
    [anon_sym_char] = ACTIONS(1737),
    [anon_sym_SQUOTE] = ACTIONS(1737),
    [anon_sym_async] = ACTIONS(1737),
    [anon_sym_break] = ACTIONS(1737),
    [anon_sym_const] = ACTIONS(1737),
    [anon_sym_continue] = ACTIONS(1737),
    [anon_sym_default] = ACTIONS(1737),
    [anon_sym_enum] = ACTIONS(1737),
    [anon_sym_fn] = ACTIONS(1737),
    [anon_sym_for] = ACTIONS(1737),
    [anon_sym_if] = ACTIONS(1737),
    [anon_sym_impl] = ACTIONS(1737),
    [anon_sym_let] = ACTIONS(1737),
    [anon_sym_loop] = ACTIONS(1737),
    [anon_sym_match] = ACTIONS(1737),
    [anon_sym_mod] = ACTIONS(1737),
    [anon_sym_pub] = ACTIONS(1737),
    [anon_sym_return] = ACTIONS(1737),
    [anon_sym_static] = ACTIONS(1737),
    [anon_sym_struct] = ACTIONS(1737),
    [anon_sym_trait] = ACTIONS(1737),
    [anon_sym_type] = ACTIONS(1737),
    [anon_sym_union] = ACTIONS(1737),
    [anon_sym_unsafe] = ACTIONS(1737),
    [anon_sym_use] = ACTIONS(1737),
    [anon_sym_while] = ACTIONS(1737),
    [anon_sym_POUND] = ACTIONS(1735),
    [anon_sym_BANG] = ACTIONS(1735),
    [anon_sym_extern] = ACTIONS(1737),
    [anon_sym_LT] = ACTIONS(1735),
    [anon_sym_COLON_COLON] = ACTIONS(1735),
    [anon_sym_AMP] = ACTIONS(1735),
    [anon_sym_DOT_DOT] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1735),
    [anon_sym_PIPE] = ACTIONS(1735),
    [anon_sym_move] = ACTIONS(1737),
    [sym_integer_literal] = ACTIONS(1735),
    [aux_sym_string_literal_token1] = ACTIONS(1735),
    [sym_char_literal] = ACTIONS(1735),
    [anon_sym_true] = ACTIONS(1737),
    [anon_sym_false] = ACTIONS(1737),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1737),
    [sym_super] = ACTIONS(1737),
    [sym_crate] = ACTIONS(1737),
    [sym_metavariable] = ACTIONS(1735),
    [sym_raw_string_literal] = ACTIONS(1735),
    [sym_float_literal] = ACTIONS(1735),
    [sym_block_comment] = ACTIONS(3),
  },
  [353] = {
    [ts_builtin_sym_end] = ACTIONS(1739),
    [sym_identifier] = ACTIONS(1741),
    [anon_sym_SEMI] = ACTIONS(1739),
    [anon_sym_macro_rules_BANG] = ACTIONS(1739),
    [anon_sym_LPAREN] = ACTIONS(1739),
    [anon_sym_LBRACE] = ACTIONS(1739),
    [anon_sym_RBRACE] = ACTIONS(1739),
    [anon_sym_LBRACK] = ACTIONS(1739),
    [anon_sym_STAR] = ACTIONS(1739),
    [anon_sym_u8] = ACTIONS(1741),
    [anon_sym_i8] = ACTIONS(1741),
    [anon_sym_u16] = ACTIONS(1741),
    [anon_sym_i16] = ACTIONS(1741),
    [anon_sym_u32] = ACTIONS(1741),
    [anon_sym_i32] = ACTIONS(1741),
    [anon_sym_u64] = ACTIONS(1741),
    [anon_sym_i64] = ACTIONS(1741),
    [anon_sym_u128] = ACTIONS(1741),
    [anon_sym_i128] = ACTIONS(1741),
    [anon_sym_isize] = ACTIONS(1741),
    [anon_sym_usize] = ACTIONS(1741),
    [anon_sym_f32] = ACTIONS(1741),
    [anon_sym_f64] = ACTIONS(1741),
    [anon_sym_bool] = ACTIONS(1741),
    [anon_sym_str] = ACTIONS(1741),
    [anon_sym_char] = ACTIONS(1741),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [anon_sym_async] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1741),
    [anon_sym_const] = ACTIONS(1741),
    [anon_sym_continue] = ACTIONS(1741),
    [anon_sym_default] = ACTIONS(1741),
    [anon_sym_enum] = ACTIONS(1741),
    [anon_sym_fn] = ACTIONS(1741),
    [anon_sym_for] = ACTIONS(1741),
    [anon_sym_if] = ACTIONS(1741),
    [anon_sym_impl] = ACTIONS(1741),
    [anon_sym_let] = ACTIONS(1741),
    [anon_sym_loop] = ACTIONS(1741),
    [anon_sym_match] = ACTIONS(1741),
    [anon_sym_mod] = ACTIONS(1741),
    [anon_sym_pub] = ACTIONS(1741),
    [anon_sym_return] = ACTIONS(1741),
    [anon_sym_static] = ACTIONS(1741),
    [anon_sym_struct] = ACTIONS(1741),
    [anon_sym_trait] = ACTIONS(1741),
    [anon_sym_type] = ACTIONS(1741),
    [anon_sym_union] = ACTIONS(1741),
    [anon_sym_unsafe] = ACTIONS(1741),
    [anon_sym_use] = ACTIONS(1741),
    [anon_sym_while] = ACTIONS(1741),
    [anon_sym_POUND] = ACTIONS(1739),
    [anon_sym_BANG] = ACTIONS(1739),
    [anon_sym_extern] = ACTIONS(1741),
    [anon_sym_LT] = ACTIONS(1739),
    [anon_sym_COLON_COLON] = ACTIONS(1739),
    [anon_sym_AMP] = ACTIONS(1739),
    [anon_sym_DOT_DOT] = ACTIONS(1739),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_PIPE] = ACTIONS(1739),
    [anon_sym_move] = ACTIONS(1741),
    [sym_integer_literal] = ACTIONS(1739),
    [aux_sym_string_literal_token1] = ACTIONS(1739),
    [sym_char_literal] = ACTIONS(1739),
    [anon_sym_true] = ACTIONS(1741),
    [anon_sym_false] = ACTIONS(1741),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1741),
    [sym_super] = ACTIONS(1741),
    [sym_crate] = ACTIONS(1741),
    [sym_metavariable] = ACTIONS(1739),
    [sym_raw_string_literal] = ACTIONS(1739),
    [sym_float_literal] = ACTIONS(1739),
    [sym_block_comment] = ACTIONS(3),
  },
  [354] = {
    [ts_builtin_sym_end] = ACTIONS(1743),
    [sym_identifier] = ACTIONS(1745),
    [anon_sym_SEMI] = ACTIONS(1743),
    [anon_sym_macro_rules_BANG] = ACTIONS(1743),
    [anon_sym_LPAREN] = ACTIONS(1743),
    [anon_sym_LBRACE] = ACTIONS(1743),
    [anon_sym_RBRACE] = ACTIONS(1743),
    [anon_sym_LBRACK] = ACTIONS(1743),
    [anon_sym_STAR] = ACTIONS(1743),
    [anon_sym_u8] = ACTIONS(1745),
    [anon_sym_i8] = ACTIONS(1745),
    [anon_sym_u16] = ACTIONS(1745),
    [anon_sym_i16] = ACTIONS(1745),
    [anon_sym_u32] = ACTIONS(1745),
    [anon_sym_i32] = ACTIONS(1745),
    [anon_sym_u64] = ACTIONS(1745),
    [anon_sym_i64] = ACTIONS(1745),
    [anon_sym_u128] = ACTIONS(1745),
    [anon_sym_i128] = ACTIONS(1745),
    [anon_sym_isize] = ACTIONS(1745),
    [anon_sym_usize] = ACTIONS(1745),
    [anon_sym_f32] = ACTIONS(1745),
    [anon_sym_f64] = ACTIONS(1745),
    [anon_sym_bool] = ACTIONS(1745),
    [anon_sym_str] = ACTIONS(1745),
    [anon_sym_char] = ACTIONS(1745),
    [anon_sym_SQUOTE] = ACTIONS(1745),
    [anon_sym_async] = ACTIONS(1745),
    [anon_sym_break] = ACTIONS(1745),
    [anon_sym_const] = ACTIONS(1745),
    [anon_sym_continue] = ACTIONS(1745),
    [anon_sym_default] = ACTIONS(1745),
    [anon_sym_enum] = ACTIONS(1745),
    [anon_sym_fn] = ACTIONS(1745),
    [anon_sym_for] = ACTIONS(1745),
    [anon_sym_if] = ACTIONS(1745),
    [anon_sym_impl] = ACTIONS(1745),
    [anon_sym_let] = ACTIONS(1745),
    [anon_sym_loop] = ACTIONS(1745),
    [anon_sym_match] = ACTIONS(1745),
    [anon_sym_mod] = ACTIONS(1745),
    [anon_sym_pub] = ACTIONS(1745),
    [anon_sym_return] = ACTIONS(1745),
    [anon_sym_static] = ACTIONS(1745),
    [anon_sym_struct] = ACTIONS(1745),
    [anon_sym_trait] = ACTIONS(1745),
    [anon_sym_type] = ACTIONS(1745),
    [anon_sym_union] = ACTIONS(1745),
    [anon_sym_unsafe] = ACTIONS(1745),
    [anon_sym_use] = ACTIONS(1745),
    [anon_sym_while] = ACTIONS(1745),
    [anon_sym_POUND] = ACTIONS(1743),
    [anon_sym_BANG] = ACTIONS(1743),
    [anon_sym_extern] = ACTIONS(1745),
    [anon_sym_LT] = ACTIONS(1743),
    [anon_sym_COLON_COLON] = ACTIONS(1743),
    [anon_sym_AMP] = ACTIONS(1743),
    [anon_sym_DOT_DOT] = ACTIONS(1743),
    [anon_sym_DASH] = ACTIONS(1743),
    [anon_sym_PIPE] = ACTIONS(1743),
    [anon_sym_move] = ACTIONS(1745),
    [sym_integer_literal] = ACTIONS(1743),
    [aux_sym_string_literal_token1] = ACTIONS(1743),
    [sym_char_literal] = ACTIONS(1743),
    [anon_sym_true] = ACTIONS(1745),
    [anon_sym_false] = ACTIONS(1745),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1745),
    [sym_super] = ACTIONS(1745),
    [sym_crate] = ACTIONS(1745),
    [sym_metavariable] = ACTIONS(1743),
    [sym_raw_string_literal] = ACTIONS(1743),
    [sym_float_literal] = ACTIONS(1743),
    [sym_block_comment] = ACTIONS(3),
  },
  [355] = {
    [ts_builtin_sym_end] = ACTIONS(1747),
    [sym_identifier] = ACTIONS(1749),
    [anon_sym_SEMI] = ACTIONS(1747),
    [anon_sym_macro_rules_BANG] = ACTIONS(1747),
    [anon_sym_LPAREN] = ACTIONS(1747),
    [anon_sym_LBRACE] = ACTIONS(1747),
    [anon_sym_RBRACE] = ACTIONS(1747),
    [anon_sym_LBRACK] = ACTIONS(1747),
    [anon_sym_STAR] = ACTIONS(1747),
    [anon_sym_u8] = ACTIONS(1749),
    [anon_sym_i8] = ACTIONS(1749),
    [anon_sym_u16] = ACTIONS(1749),
    [anon_sym_i16] = ACTIONS(1749),
    [anon_sym_u32] = ACTIONS(1749),
    [anon_sym_i32] = ACTIONS(1749),
    [anon_sym_u64] = ACTIONS(1749),
    [anon_sym_i64] = ACTIONS(1749),
    [anon_sym_u128] = ACTIONS(1749),
    [anon_sym_i128] = ACTIONS(1749),
    [anon_sym_isize] = ACTIONS(1749),
    [anon_sym_usize] = ACTIONS(1749),
    [anon_sym_f32] = ACTIONS(1749),
    [anon_sym_f64] = ACTIONS(1749),
    [anon_sym_bool] = ACTIONS(1749),
    [anon_sym_str] = ACTIONS(1749),
    [anon_sym_char] = ACTIONS(1749),
    [anon_sym_SQUOTE] = ACTIONS(1749),
    [anon_sym_async] = ACTIONS(1749),
    [anon_sym_break] = ACTIONS(1749),
    [anon_sym_const] = ACTIONS(1749),
    [anon_sym_continue] = ACTIONS(1749),
    [anon_sym_default] = ACTIONS(1749),
    [anon_sym_enum] = ACTIONS(1749),
    [anon_sym_fn] = ACTIONS(1749),
    [anon_sym_for] = ACTIONS(1749),
    [anon_sym_if] = ACTIONS(1749),
    [anon_sym_impl] = ACTIONS(1749),
    [anon_sym_let] = ACTIONS(1749),
    [anon_sym_loop] = ACTIONS(1749),
    [anon_sym_match] = ACTIONS(1749),
    [anon_sym_mod] = ACTIONS(1749),
    [anon_sym_pub] = ACTIONS(1749),
    [anon_sym_return] = ACTIONS(1749),
    [anon_sym_static] = ACTIONS(1749),
    [anon_sym_struct] = ACTIONS(1749),
    [anon_sym_trait] = ACTIONS(1749),
    [anon_sym_type] = ACTIONS(1749),
    [anon_sym_union] = ACTIONS(1749),
    [anon_sym_unsafe] = ACTIONS(1749),
    [anon_sym_use] = ACTIONS(1749),
    [anon_sym_while] = ACTIONS(1749),
    [anon_sym_POUND] = ACTIONS(1747),
    [anon_sym_BANG] = ACTIONS(1747),
    [anon_sym_extern] = ACTIONS(1749),
    [anon_sym_LT] = ACTIONS(1747),
    [anon_sym_COLON_COLON] = ACTIONS(1747),
    [anon_sym_AMP] = ACTIONS(1747),
    [anon_sym_DOT_DOT] = ACTIONS(1747),
    [anon_sym_DASH] = ACTIONS(1747),
    [anon_sym_PIPE] = ACTIONS(1747),
    [anon_sym_move] = ACTIONS(1749),
    [sym_integer_literal] = ACTIONS(1747),
    [aux_sym_string_literal_token1] = ACTIONS(1747),
    [sym_char_literal] = ACTIONS(1747),
    [anon_sym_true] = ACTIONS(1749),
    [anon_sym_false] = ACTIONS(1749),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1749),
    [sym_super] = ACTIONS(1749),
    [sym_crate] = ACTIONS(1749),
    [sym_metavariable] = ACTIONS(1747),
    [sym_raw_string_literal] = ACTIONS(1747),
    [sym_float_literal] = ACTIONS(1747),
    [sym_block_comment] = ACTIONS(3),
  },
  [356] = {
    [ts_builtin_sym_end] = ACTIONS(1751),
    [sym_identifier] = ACTIONS(1753),
    [anon_sym_SEMI] = ACTIONS(1751),
    [anon_sym_macro_rules_BANG] = ACTIONS(1751),
    [anon_sym_LPAREN] = ACTIONS(1751),
    [anon_sym_LBRACE] = ACTIONS(1751),
    [anon_sym_RBRACE] = ACTIONS(1751),
    [anon_sym_LBRACK] = ACTIONS(1751),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_u8] = ACTIONS(1753),
    [anon_sym_i8] = ACTIONS(1753),
    [anon_sym_u16] = ACTIONS(1753),
    [anon_sym_i16] = ACTIONS(1753),
    [anon_sym_u32] = ACTIONS(1753),
    [anon_sym_i32] = ACTIONS(1753),
    [anon_sym_u64] = ACTIONS(1753),
    [anon_sym_i64] = ACTIONS(1753),
    [anon_sym_u128] = ACTIONS(1753),
    [anon_sym_i128] = ACTIONS(1753),
    [anon_sym_isize] = ACTIONS(1753),
    [anon_sym_usize] = ACTIONS(1753),
    [anon_sym_f32] = ACTIONS(1753),
    [anon_sym_f64] = ACTIONS(1753),
    [anon_sym_bool] = ACTIONS(1753),
    [anon_sym_str] = ACTIONS(1753),
    [anon_sym_char] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(1753),
    [anon_sym_async] = ACTIONS(1753),
    [anon_sym_break] = ACTIONS(1753),
    [anon_sym_const] = ACTIONS(1753),
    [anon_sym_continue] = ACTIONS(1753),
    [anon_sym_default] = ACTIONS(1753),
    [anon_sym_enum] = ACTIONS(1753),
    [anon_sym_fn] = ACTIONS(1753),
    [anon_sym_for] = ACTIONS(1753),
    [anon_sym_if] = ACTIONS(1753),
    [anon_sym_impl] = ACTIONS(1753),
    [anon_sym_let] = ACTIONS(1753),
    [anon_sym_loop] = ACTIONS(1753),
    [anon_sym_match] = ACTIONS(1753),
    [anon_sym_mod] = ACTIONS(1753),
    [anon_sym_pub] = ACTIONS(1753),
    [anon_sym_return] = ACTIONS(1753),
    [anon_sym_static] = ACTIONS(1753),
    [anon_sym_struct] = ACTIONS(1753),
    [anon_sym_trait] = ACTIONS(1753),
    [anon_sym_type] = ACTIONS(1753),
    [anon_sym_union] = ACTIONS(1753),
    [anon_sym_unsafe] = ACTIONS(1753),
    [anon_sym_use] = ACTIONS(1753),
    [anon_sym_while] = ACTIONS(1753),
    [anon_sym_POUND] = ACTIONS(1751),
    [anon_sym_BANG] = ACTIONS(1751),
    [anon_sym_extern] = ACTIONS(1753),
    [anon_sym_LT] = ACTIONS(1751),
    [anon_sym_COLON_COLON] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_DOT_DOT] = ACTIONS(1751),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_move] = ACTIONS(1753),
    [sym_integer_literal] = ACTIONS(1751),
    [aux_sym_string_literal_token1] = ACTIONS(1751),
    [sym_char_literal] = ACTIONS(1751),
    [anon_sym_true] = ACTIONS(1753),
    [anon_sym_false] = ACTIONS(1753),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1753),
    [sym_super] = ACTIONS(1753),
    [sym_crate] = ACTIONS(1753),
    [sym_metavariable] = ACTIONS(1751),
    [sym_raw_string_literal] = ACTIONS(1751),
    [sym_float_literal] = ACTIONS(1751),
    [sym_block_comment] = ACTIONS(3),
  },
  [357] = {
    [ts_builtin_sym_end] = ACTIONS(1755),
    [sym_identifier] = ACTIONS(1757),
    [anon_sym_SEMI] = ACTIONS(1755),
    [anon_sym_macro_rules_BANG] = ACTIONS(1755),
    [anon_sym_LPAREN] = ACTIONS(1755),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_RBRACE] = ACTIONS(1755),
    [anon_sym_LBRACK] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1755),
    [anon_sym_u8] = ACTIONS(1757),
    [anon_sym_i8] = ACTIONS(1757),
    [anon_sym_u16] = ACTIONS(1757),
    [anon_sym_i16] = ACTIONS(1757),
    [anon_sym_u32] = ACTIONS(1757),
    [anon_sym_i32] = ACTIONS(1757),
    [anon_sym_u64] = ACTIONS(1757),
    [anon_sym_i64] = ACTIONS(1757),
    [anon_sym_u128] = ACTIONS(1757),
    [anon_sym_i128] = ACTIONS(1757),
    [anon_sym_isize] = ACTIONS(1757),
    [anon_sym_usize] = ACTIONS(1757),
    [anon_sym_f32] = ACTIONS(1757),
    [anon_sym_f64] = ACTIONS(1757),
    [anon_sym_bool] = ACTIONS(1757),
    [anon_sym_str] = ACTIONS(1757),
    [anon_sym_char] = ACTIONS(1757),
    [anon_sym_SQUOTE] = ACTIONS(1757),
    [anon_sym_async] = ACTIONS(1757),
    [anon_sym_break] = ACTIONS(1757),
    [anon_sym_const] = ACTIONS(1757),
    [anon_sym_continue] = ACTIONS(1757),
    [anon_sym_default] = ACTIONS(1757),
    [anon_sym_enum] = ACTIONS(1757),
    [anon_sym_fn] = ACTIONS(1757),
    [anon_sym_for] = ACTIONS(1757),
    [anon_sym_if] = ACTIONS(1757),
    [anon_sym_impl] = ACTIONS(1757),
    [anon_sym_let] = ACTIONS(1757),
    [anon_sym_loop] = ACTIONS(1757),
    [anon_sym_match] = ACTIONS(1757),
    [anon_sym_mod] = ACTIONS(1757),
    [anon_sym_pub] = ACTIONS(1757),
    [anon_sym_return] = ACTIONS(1757),
    [anon_sym_static] = ACTIONS(1757),
    [anon_sym_struct] = ACTIONS(1757),
    [anon_sym_trait] = ACTIONS(1757),
    [anon_sym_type] = ACTIONS(1757),
    [anon_sym_union] = ACTIONS(1757),
    [anon_sym_unsafe] = ACTIONS(1757),
    [anon_sym_use] = ACTIONS(1757),
    [anon_sym_while] = ACTIONS(1757),
    [anon_sym_POUND] = ACTIONS(1755),
    [anon_sym_BANG] = ACTIONS(1755),
    [anon_sym_extern] = ACTIONS(1757),
    [anon_sym_LT] = ACTIONS(1755),
    [anon_sym_COLON_COLON] = ACTIONS(1755),
    [anon_sym_AMP] = ACTIONS(1755),
    [anon_sym_DOT_DOT] = ACTIONS(1755),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_PIPE] = ACTIONS(1755),
    [anon_sym_move] = ACTIONS(1757),
    [sym_integer_literal] = ACTIONS(1755),
    [aux_sym_string_literal_token1] = ACTIONS(1755),
    [sym_char_literal] = ACTIONS(1755),
    [anon_sym_true] = ACTIONS(1757),
    [anon_sym_false] = ACTIONS(1757),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1757),
    [sym_super] = ACTIONS(1757),
    [sym_crate] = ACTIONS(1757),
    [sym_metavariable] = ACTIONS(1755),
    [sym_raw_string_literal] = ACTIONS(1755),
    [sym_float_literal] = ACTIONS(1755),
    [sym_block_comment] = ACTIONS(3),
  },
  [358] = {
    [ts_builtin_sym_end] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1761),
    [anon_sym_SEMI] = ACTIONS(1759),
    [anon_sym_macro_rules_BANG] = ACTIONS(1759),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1759),
    [anon_sym_RBRACE] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1759),
    [anon_sym_STAR] = ACTIONS(1759),
    [anon_sym_u8] = ACTIONS(1761),
    [anon_sym_i8] = ACTIONS(1761),
    [anon_sym_u16] = ACTIONS(1761),
    [anon_sym_i16] = ACTIONS(1761),
    [anon_sym_u32] = ACTIONS(1761),
    [anon_sym_i32] = ACTIONS(1761),
    [anon_sym_u64] = ACTIONS(1761),
    [anon_sym_i64] = ACTIONS(1761),
    [anon_sym_u128] = ACTIONS(1761),
    [anon_sym_i128] = ACTIONS(1761),
    [anon_sym_isize] = ACTIONS(1761),
    [anon_sym_usize] = ACTIONS(1761),
    [anon_sym_f32] = ACTIONS(1761),
    [anon_sym_f64] = ACTIONS(1761),
    [anon_sym_bool] = ACTIONS(1761),
    [anon_sym_str] = ACTIONS(1761),
    [anon_sym_char] = ACTIONS(1761),
    [anon_sym_SQUOTE] = ACTIONS(1761),
    [anon_sym_async] = ACTIONS(1761),
    [anon_sym_break] = ACTIONS(1761),
    [anon_sym_const] = ACTIONS(1761),
    [anon_sym_continue] = ACTIONS(1761),
    [anon_sym_default] = ACTIONS(1761),
    [anon_sym_enum] = ACTIONS(1761),
    [anon_sym_fn] = ACTIONS(1761),
    [anon_sym_for] = ACTIONS(1761),
    [anon_sym_if] = ACTIONS(1761),
    [anon_sym_impl] = ACTIONS(1761),
    [anon_sym_let] = ACTIONS(1761),
    [anon_sym_loop] = ACTIONS(1761),
    [anon_sym_match] = ACTIONS(1761),
    [anon_sym_mod] = ACTIONS(1761),
    [anon_sym_pub] = ACTIONS(1761),
    [anon_sym_return] = ACTIONS(1761),
    [anon_sym_static] = ACTIONS(1761),
    [anon_sym_struct] = ACTIONS(1761),
    [anon_sym_trait] = ACTIONS(1761),
    [anon_sym_type] = ACTIONS(1761),
    [anon_sym_union] = ACTIONS(1761),
    [anon_sym_unsafe] = ACTIONS(1761),
    [anon_sym_use] = ACTIONS(1761),
    [anon_sym_while] = ACTIONS(1761),
    [anon_sym_POUND] = ACTIONS(1759),
    [anon_sym_BANG] = ACTIONS(1759),
    [anon_sym_extern] = ACTIONS(1761),
    [anon_sym_LT] = ACTIONS(1759),
    [anon_sym_COLON_COLON] = ACTIONS(1759),
    [anon_sym_AMP] = ACTIONS(1759),
    [anon_sym_DOT_DOT] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1759),
    [anon_sym_PIPE] = ACTIONS(1759),
    [anon_sym_move] = ACTIONS(1761),
    [sym_integer_literal] = ACTIONS(1759),
    [aux_sym_string_literal_token1] = ACTIONS(1759),
    [sym_char_literal] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(1761),
    [anon_sym_false] = ACTIONS(1761),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1761),
    [sym_super] = ACTIONS(1761),
    [sym_crate] = ACTIONS(1761),
    [sym_metavariable] = ACTIONS(1759),
    [sym_raw_string_literal] = ACTIONS(1759),
    [sym_float_literal] = ACTIONS(1759),
    [sym_block_comment] = ACTIONS(3),
  },
  [359] = {
    [ts_builtin_sym_end] = ACTIONS(1763),
    [sym_identifier] = ACTIONS(1765),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_macro_rules_BANG] = ACTIONS(1763),
    [anon_sym_LPAREN] = ACTIONS(1763),
    [anon_sym_LBRACE] = ACTIONS(1763),
    [anon_sym_RBRACE] = ACTIONS(1763),
    [anon_sym_LBRACK] = ACTIONS(1763),
    [anon_sym_STAR] = ACTIONS(1763),
    [anon_sym_u8] = ACTIONS(1765),
    [anon_sym_i8] = ACTIONS(1765),
    [anon_sym_u16] = ACTIONS(1765),
    [anon_sym_i16] = ACTIONS(1765),
    [anon_sym_u32] = ACTIONS(1765),
    [anon_sym_i32] = ACTIONS(1765),
    [anon_sym_u64] = ACTIONS(1765),
    [anon_sym_i64] = ACTIONS(1765),
    [anon_sym_u128] = ACTIONS(1765),
    [anon_sym_i128] = ACTIONS(1765),
    [anon_sym_isize] = ACTIONS(1765),
    [anon_sym_usize] = ACTIONS(1765),
    [anon_sym_f32] = ACTIONS(1765),
    [anon_sym_f64] = ACTIONS(1765),
    [anon_sym_bool] = ACTIONS(1765),
    [anon_sym_str] = ACTIONS(1765),
    [anon_sym_char] = ACTIONS(1765),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_async] = ACTIONS(1765),
    [anon_sym_break] = ACTIONS(1765),
    [anon_sym_const] = ACTIONS(1765),
    [anon_sym_continue] = ACTIONS(1765),
    [anon_sym_default] = ACTIONS(1765),
    [anon_sym_enum] = ACTIONS(1765),
    [anon_sym_fn] = ACTIONS(1765),
    [anon_sym_for] = ACTIONS(1765),
    [anon_sym_if] = ACTIONS(1765),
    [anon_sym_impl] = ACTIONS(1765),
    [anon_sym_let] = ACTIONS(1765),
    [anon_sym_loop] = ACTIONS(1765),
    [anon_sym_match] = ACTIONS(1765),
    [anon_sym_mod] = ACTIONS(1765),
    [anon_sym_pub] = ACTIONS(1765),
    [anon_sym_return] = ACTIONS(1765),
    [anon_sym_static] = ACTIONS(1765),
    [anon_sym_struct] = ACTIONS(1765),
    [anon_sym_trait] = ACTIONS(1765),
    [anon_sym_type] = ACTIONS(1765),
    [anon_sym_union] = ACTIONS(1765),
    [anon_sym_unsafe] = ACTIONS(1765),
    [anon_sym_use] = ACTIONS(1765),
    [anon_sym_while] = ACTIONS(1765),
    [anon_sym_POUND] = ACTIONS(1763),
    [anon_sym_BANG] = ACTIONS(1763),
    [anon_sym_extern] = ACTIONS(1765),
    [anon_sym_LT] = ACTIONS(1763),
    [anon_sym_COLON_COLON] = ACTIONS(1763),
    [anon_sym_AMP] = ACTIONS(1763),
    [anon_sym_DOT_DOT] = ACTIONS(1763),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_PIPE] = ACTIONS(1763),
    [anon_sym_move] = ACTIONS(1765),
    [sym_integer_literal] = ACTIONS(1763),
    [aux_sym_string_literal_token1] = ACTIONS(1763),
    [sym_char_literal] = ACTIONS(1763),
    [anon_sym_true] = ACTIONS(1765),
    [anon_sym_false] = ACTIONS(1765),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1765),
    [sym_super] = ACTIONS(1765),
    [sym_crate] = ACTIONS(1765),
    [sym_metavariable] = ACTIONS(1763),
    [sym_raw_string_literal] = ACTIONS(1763),
    [sym_float_literal] = ACTIONS(1763),
    [sym_block_comment] = ACTIONS(3),
  },
  [360] = {
    [ts_builtin_sym_end] = ACTIONS(1767),
    [sym_identifier] = ACTIONS(1769),
    [anon_sym_SEMI] = ACTIONS(1767),
    [anon_sym_macro_rules_BANG] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(1767),
    [anon_sym_LBRACE] = ACTIONS(1767),
    [anon_sym_RBRACE] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(1767),
    [anon_sym_STAR] = ACTIONS(1767),
    [anon_sym_u8] = ACTIONS(1769),
    [anon_sym_i8] = ACTIONS(1769),
    [anon_sym_u16] = ACTIONS(1769),
    [anon_sym_i16] = ACTIONS(1769),
    [anon_sym_u32] = ACTIONS(1769),
    [anon_sym_i32] = ACTIONS(1769),
    [anon_sym_u64] = ACTIONS(1769),
    [anon_sym_i64] = ACTIONS(1769),
    [anon_sym_u128] = ACTIONS(1769),
    [anon_sym_i128] = ACTIONS(1769),
    [anon_sym_isize] = ACTIONS(1769),
    [anon_sym_usize] = ACTIONS(1769),
    [anon_sym_f32] = ACTIONS(1769),
    [anon_sym_f64] = ACTIONS(1769),
    [anon_sym_bool] = ACTIONS(1769),
    [anon_sym_str] = ACTIONS(1769),
    [anon_sym_char] = ACTIONS(1769),
    [anon_sym_SQUOTE] = ACTIONS(1769),
    [anon_sym_async] = ACTIONS(1769),
    [anon_sym_break] = ACTIONS(1769),
    [anon_sym_const] = ACTIONS(1769),
    [anon_sym_continue] = ACTIONS(1769),
    [anon_sym_default] = ACTIONS(1769),
    [anon_sym_enum] = ACTIONS(1769),
    [anon_sym_fn] = ACTIONS(1769),
    [anon_sym_for] = ACTIONS(1769),
    [anon_sym_if] = ACTIONS(1769),
    [anon_sym_impl] = ACTIONS(1769),
    [anon_sym_let] = ACTIONS(1769),
    [anon_sym_loop] = ACTIONS(1769),
    [anon_sym_match] = ACTIONS(1769),
    [anon_sym_mod] = ACTIONS(1769),
    [anon_sym_pub] = ACTIONS(1769),
    [anon_sym_return] = ACTIONS(1769),
    [anon_sym_static] = ACTIONS(1769),
    [anon_sym_struct] = ACTIONS(1769),
    [anon_sym_trait] = ACTIONS(1769),
    [anon_sym_type] = ACTIONS(1769),
    [anon_sym_union] = ACTIONS(1769),
    [anon_sym_unsafe] = ACTIONS(1769),
    [anon_sym_use] = ACTIONS(1769),
    [anon_sym_while] = ACTIONS(1769),
    [anon_sym_POUND] = ACTIONS(1767),
    [anon_sym_BANG] = ACTIONS(1767),
    [anon_sym_extern] = ACTIONS(1769),
    [anon_sym_LT] = ACTIONS(1767),
    [anon_sym_COLON_COLON] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_DOT_DOT] = ACTIONS(1767),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_PIPE] = ACTIONS(1767),
    [anon_sym_move] = ACTIONS(1769),
    [sym_integer_literal] = ACTIONS(1767),
    [aux_sym_string_literal_token1] = ACTIONS(1767),
    [sym_char_literal] = ACTIONS(1767),
    [anon_sym_true] = ACTIONS(1769),
    [anon_sym_false] = ACTIONS(1769),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1769),
    [sym_super] = ACTIONS(1769),
    [sym_crate] = ACTIONS(1769),
    [sym_metavariable] = ACTIONS(1767),
    [sym_raw_string_literal] = ACTIONS(1767),
    [sym_float_literal] = ACTIONS(1767),
    [sym_block_comment] = ACTIONS(3),
  },
  [361] = {
    [ts_builtin_sym_end] = ACTIONS(1771),
    [sym_identifier] = ACTIONS(1773),
    [anon_sym_SEMI] = ACTIONS(1771),
    [anon_sym_macro_rules_BANG] = ACTIONS(1771),
    [anon_sym_LPAREN] = ACTIONS(1771),
    [anon_sym_LBRACE] = ACTIONS(1771),
    [anon_sym_RBRACE] = ACTIONS(1771),
    [anon_sym_LBRACK] = ACTIONS(1771),
    [anon_sym_STAR] = ACTIONS(1771),
    [anon_sym_u8] = ACTIONS(1773),
    [anon_sym_i8] = ACTIONS(1773),
    [anon_sym_u16] = ACTIONS(1773),
    [anon_sym_i16] = ACTIONS(1773),
    [anon_sym_u32] = ACTIONS(1773),
    [anon_sym_i32] = ACTIONS(1773),
    [anon_sym_u64] = ACTIONS(1773),
    [anon_sym_i64] = ACTIONS(1773),
    [anon_sym_u128] = ACTIONS(1773),
    [anon_sym_i128] = ACTIONS(1773),
    [anon_sym_isize] = ACTIONS(1773),
    [anon_sym_usize] = ACTIONS(1773),
    [anon_sym_f32] = ACTIONS(1773),
    [anon_sym_f64] = ACTIONS(1773),
    [anon_sym_bool] = ACTIONS(1773),
    [anon_sym_str] = ACTIONS(1773),
    [anon_sym_char] = ACTIONS(1773),
    [anon_sym_SQUOTE] = ACTIONS(1773),
    [anon_sym_async] = ACTIONS(1773),
    [anon_sym_break] = ACTIONS(1773),
    [anon_sym_const] = ACTIONS(1773),
    [anon_sym_continue] = ACTIONS(1773),
    [anon_sym_default] = ACTIONS(1773),
    [anon_sym_enum] = ACTIONS(1773),
    [anon_sym_fn] = ACTIONS(1773),
    [anon_sym_for] = ACTIONS(1773),
    [anon_sym_if] = ACTIONS(1773),
    [anon_sym_impl] = ACTIONS(1773),
    [anon_sym_let] = ACTIONS(1773),
    [anon_sym_loop] = ACTIONS(1773),
    [anon_sym_match] = ACTIONS(1773),
    [anon_sym_mod] = ACTIONS(1773),
    [anon_sym_pub] = ACTIONS(1773),
    [anon_sym_return] = ACTIONS(1773),
    [anon_sym_static] = ACTIONS(1773),
    [anon_sym_struct] = ACTIONS(1773),
    [anon_sym_trait] = ACTIONS(1773),
    [anon_sym_type] = ACTIONS(1773),
    [anon_sym_union] = ACTIONS(1773),
    [anon_sym_unsafe] = ACTIONS(1773),
    [anon_sym_use] = ACTIONS(1773),
    [anon_sym_while] = ACTIONS(1773),
    [anon_sym_POUND] = ACTIONS(1771),
    [anon_sym_BANG] = ACTIONS(1771),
    [anon_sym_extern] = ACTIONS(1773),
    [anon_sym_LT] = ACTIONS(1771),
    [anon_sym_COLON_COLON] = ACTIONS(1771),
    [anon_sym_AMP] = ACTIONS(1771),
    [anon_sym_DOT_DOT] = ACTIONS(1771),
    [anon_sym_DASH] = ACTIONS(1771),
    [anon_sym_PIPE] = ACTIONS(1771),
    [anon_sym_move] = ACTIONS(1773),
    [sym_integer_literal] = ACTIONS(1771),
    [aux_sym_string_literal_token1] = ACTIONS(1771),
    [sym_char_literal] = ACTIONS(1771),
    [anon_sym_true] = ACTIONS(1773),
    [anon_sym_false] = ACTIONS(1773),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1773),
    [sym_super] = ACTIONS(1773),
    [sym_crate] = ACTIONS(1773),
    [sym_metavariable] = ACTIONS(1771),
    [sym_raw_string_literal] = ACTIONS(1771),
    [sym_float_literal] = ACTIONS(1771),
    [sym_block_comment] = ACTIONS(3),
  },
  [362] = {
    [ts_builtin_sym_end] = ACTIONS(1775),
    [sym_identifier] = ACTIONS(1777),
    [anon_sym_SEMI] = ACTIONS(1775),
    [anon_sym_macro_rules_BANG] = ACTIONS(1775),
    [anon_sym_LPAREN] = ACTIONS(1775),
    [anon_sym_LBRACE] = ACTIONS(1775),
    [anon_sym_RBRACE] = ACTIONS(1775),
    [anon_sym_LBRACK] = ACTIONS(1775),
    [anon_sym_STAR] = ACTIONS(1775),
    [anon_sym_u8] = ACTIONS(1777),
    [anon_sym_i8] = ACTIONS(1777),
    [anon_sym_u16] = ACTIONS(1777),
    [anon_sym_i16] = ACTIONS(1777),
    [anon_sym_u32] = ACTIONS(1777),
    [anon_sym_i32] = ACTIONS(1777),
    [anon_sym_u64] = ACTIONS(1777),
    [anon_sym_i64] = ACTIONS(1777),
    [anon_sym_u128] = ACTIONS(1777),
    [anon_sym_i128] = ACTIONS(1777),
    [anon_sym_isize] = ACTIONS(1777),
    [anon_sym_usize] = ACTIONS(1777),
    [anon_sym_f32] = ACTIONS(1777),
    [anon_sym_f64] = ACTIONS(1777),
    [anon_sym_bool] = ACTIONS(1777),
    [anon_sym_str] = ACTIONS(1777),
    [anon_sym_char] = ACTIONS(1777),
    [anon_sym_SQUOTE] = ACTIONS(1777),
    [anon_sym_async] = ACTIONS(1777),
    [anon_sym_break] = ACTIONS(1777),
    [anon_sym_const] = ACTIONS(1777),
    [anon_sym_continue] = ACTIONS(1777),
    [anon_sym_default] = ACTIONS(1777),
    [anon_sym_enum] = ACTIONS(1777),
    [anon_sym_fn] = ACTIONS(1777),
    [anon_sym_for] = ACTIONS(1777),
    [anon_sym_if] = ACTIONS(1777),
    [anon_sym_impl] = ACTIONS(1777),
    [anon_sym_let] = ACTIONS(1777),
    [anon_sym_loop] = ACTIONS(1777),
    [anon_sym_match] = ACTIONS(1777),
    [anon_sym_mod] = ACTIONS(1777),
    [anon_sym_pub] = ACTIONS(1777),
    [anon_sym_return] = ACTIONS(1777),
    [anon_sym_static] = ACTIONS(1777),
    [anon_sym_struct] = ACTIONS(1777),
    [anon_sym_trait] = ACTIONS(1777),
    [anon_sym_type] = ACTIONS(1777),
    [anon_sym_union] = ACTIONS(1777),
    [anon_sym_unsafe] = ACTIONS(1777),
    [anon_sym_use] = ACTIONS(1777),
    [anon_sym_while] = ACTIONS(1777),
    [anon_sym_POUND] = ACTIONS(1775),
    [anon_sym_BANG] = ACTIONS(1775),
    [anon_sym_extern] = ACTIONS(1777),
    [anon_sym_LT] = ACTIONS(1775),
    [anon_sym_COLON_COLON] = ACTIONS(1775),
    [anon_sym_AMP] = ACTIONS(1775),
    [anon_sym_DOT_DOT] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_PIPE] = ACTIONS(1775),
    [anon_sym_move] = ACTIONS(1777),
    [sym_integer_literal] = ACTIONS(1775),
    [aux_sym_string_literal_token1] = ACTIONS(1775),
    [sym_char_literal] = ACTIONS(1775),
    [anon_sym_true] = ACTIONS(1777),
    [anon_sym_false] = ACTIONS(1777),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1777),
    [sym_super] = ACTIONS(1777),
    [sym_crate] = ACTIONS(1777),
    [sym_metavariable] = ACTIONS(1775),
    [sym_raw_string_literal] = ACTIONS(1775),
    [sym_float_literal] = ACTIONS(1775),
    [sym_block_comment] = ACTIONS(3),
  },
  [363] = {
    [ts_builtin_sym_end] = ACTIONS(1779),
    [sym_identifier] = ACTIONS(1781),
    [anon_sym_SEMI] = ACTIONS(1779),
    [anon_sym_macro_rules_BANG] = ACTIONS(1779),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1779),
    [anon_sym_RBRACE] = ACTIONS(1779),
    [anon_sym_LBRACK] = ACTIONS(1779),
    [anon_sym_STAR] = ACTIONS(1779),
    [anon_sym_u8] = ACTIONS(1781),
    [anon_sym_i8] = ACTIONS(1781),
    [anon_sym_u16] = ACTIONS(1781),
    [anon_sym_i16] = ACTIONS(1781),
    [anon_sym_u32] = ACTIONS(1781),
    [anon_sym_i32] = ACTIONS(1781),
    [anon_sym_u64] = ACTIONS(1781),
    [anon_sym_i64] = ACTIONS(1781),
    [anon_sym_u128] = ACTIONS(1781),
    [anon_sym_i128] = ACTIONS(1781),
    [anon_sym_isize] = ACTIONS(1781),
    [anon_sym_usize] = ACTIONS(1781),
    [anon_sym_f32] = ACTIONS(1781),
    [anon_sym_f64] = ACTIONS(1781),
    [anon_sym_bool] = ACTIONS(1781),
    [anon_sym_str] = ACTIONS(1781),
    [anon_sym_char] = ACTIONS(1781),
    [anon_sym_SQUOTE] = ACTIONS(1781),
    [anon_sym_async] = ACTIONS(1781),
    [anon_sym_break] = ACTIONS(1781),
    [anon_sym_const] = ACTIONS(1781),
    [anon_sym_continue] = ACTIONS(1781),
    [anon_sym_default] = ACTIONS(1781),
    [anon_sym_enum] = ACTIONS(1781),
    [anon_sym_fn] = ACTIONS(1781),
    [anon_sym_for] = ACTIONS(1781),
    [anon_sym_if] = ACTIONS(1781),
    [anon_sym_impl] = ACTIONS(1781),
    [anon_sym_let] = ACTIONS(1781),
    [anon_sym_loop] = ACTIONS(1781),
    [anon_sym_match] = ACTIONS(1781),
    [anon_sym_mod] = ACTIONS(1781),
    [anon_sym_pub] = ACTIONS(1781),
    [anon_sym_return] = ACTIONS(1781),
    [anon_sym_static] = ACTIONS(1781),
    [anon_sym_struct] = ACTIONS(1781),
    [anon_sym_trait] = ACTIONS(1781),
    [anon_sym_type] = ACTIONS(1781),
    [anon_sym_union] = ACTIONS(1781),
    [anon_sym_unsafe] = ACTIONS(1781),
    [anon_sym_use] = ACTIONS(1781),
    [anon_sym_while] = ACTIONS(1781),
    [anon_sym_POUND] = ACTIONS(1779),
    [anon_sym_BANG] = ACTIONS(1779),
    [anon_sym_extern] = ACTIONS(1781),
    [anon_sym_LT] = ACTIONS(1779),
    [anon_sym_COLON_COLON] = ACTIONS(1779),
    [anon_sym_AMP] = ACTIONS(1779),
    [anon_sym_DOT_DOT] = ACTIONS(1779),
    [anon_sym_DASH] = ACTIONS(1779),
    [anon_sym_PIPE] = ACTIONS(1779),
    [anon_sym_move] = ACTIONS(1781),
    [sym_integer_literal] = ACTIONS(1779),
    [aux_sym_string_literal_token1] = ACTIONS(1779),
    [sym_char_literal] = ACTIONS(1779),
    [anon_sym_true] = ACTIONS(1781),
    [anon_sym_false] = ACTIONS(1781),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1781),
    [sym_super] = ACTIONS(1781),
    [sym_crate] = ACTIONS(1781),
    [sym_metavariable] = ACTIONS(1779),
    [sym_raw_string_literal] = ACTIONS(1779),
    [sym_float_literal] = ACTIONS(1779),
    [sym_block_comment] = ACTIONS(3),
  },
  [364] = {
    [ts_builtin_sym_end] = ACTIONS(1783),
    [sym_identifier] = ACTIONS(1785),
    [anon_sym_SEMI] = ACTIONS(1783),
    [anon_sym_macro_rules_BANG] = ACTIONS(1783),
    [anon_sym_LPAREN] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1783),
    [anon_sym_RBRACE] = ACTIONS(1783),
    [anon_sym_LBRACK] = ACTIONS(1783),
    [anon_sym_STAR] = ACTIONS(1783),
    [anon_sym_u8] = ACTIONS(1785),
    [anon_sym_i8] = ACTIONS(1785),
    [anon_sym_u16] = ACTIONS(1785),
    [anon_sym_i16] = ACTIONS(1785),
    [anon_sym_u32] = ACTIONS(1785),
    [anon_sym_i32] = ACTIONS(1785),
    [anon_sym_u64] = ACTIONS(1785),
    [anon_sym_i64] = ACTIONS(1785),
    [anon_sym_u128] = ACTIONS(1785),
    [anon_sym_i128] = ACTIONS(1785),
    [anon_sym_isize] = ACTIONS(1785),
    [anon_sym_usize] = ACTIONS(1785),
    [anon_sym_f32] = ACTIONS(1785),
    [anon_sym_f64] = ACTIONS(1785),
    [anon_sym_bool] = ACTIONS(1785),
    [anon_sym_str] = ACTIONS(1785),
    [anon_sym_char] = ACTIONS(1785),
    [anon_sym_SQUOTE] = ACTIONS(1785),
    [anon_sym_async] = ACTIONS(1785),
    [anon_sym_break] = ACTIONS(1785),
    [anon_sym_const] = ACTIONS(1785),
    [anon_sym_continue] = ACTIONS(1785),
    [anon_sym_default] = ACTIONS(1785),
    [anon_sym_enum] = ACTIONS(1785),
    [anon_sym_fn] = ACTIONS(1785),
    [anon_sym_for] = ACTIONS(1785),
    [anon_sym_if] = ACTIONS(1785),
    [anon_sym_impl] = ACTIONS(1785),
    [anon_sym_let] = ACTIONS(1785),
    [anon_sym_loop] = ACTIONS(1785),
    [anon_sym_match] = ACTIONS(1785),
    [anon_sym_mod] = ACTIONS(1785),
    [anon_sym_pub] = ACTIONS(1785),
    [anon_sym_return] = ACTIONS(1785),
    [anon_sym_static] = ACTIONS(1785),
    [anon_sym_struct] = ACTIONS(1785),
    [anon_sym_trait] = ACTIONS(1785),
    [anon_sym_type] = ACTIONS(1785),
    [anon_sym_union] = ACTIONS(1785),
    [anon_sym_unsafe] = ACTIONS(1785),
    [anon_sym_use] = ACTIONS(1785),
    [anon_sym_while] = ACTIONS(1785),
    [anon_sym_POUND] = ACTIONS(1783),
    [anon_sym_BANG] = ACTIONS(1783),
    [anon_sym_extern] = ACTIONS(1785),
    [anon_sym_LT] = ACTIONS(1783),
    [anon_sym_COLON_COLON] = ACTIONS(1783),
    [anon_sym_AMP] = ACTIONS(1783),
    [anon_sym_DOT_DOT] = ACTIONS(1783),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_PIPE] = ACTIONS(1783),
    [anon_sym_move] = ACTIONS(1785),
    [sym_integer_literal] = ACTIONS(1783),
    [aux_sym_string_literal_token1] = ACTIONS(1783),
    [sym_char_literal] = ACTIONS(1783),
    [anon_sym_true] = ACTIONS(1785),
    [anon_sym_false] = ACTIONS(1785),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1785),
    [sym_super] = ACTIONS(1785),
    [sym_crate] = ACTIONS(1785),
    [sym_metavariable] = ACTIONS(1783),
    [sym_raw_string_literal] = ACTIONS(1783),
    [sym_float_literal] = ACTIONS(1783),
    [sym_block_comment] = ACTIONS(3),
  },
  [365] = {
    [ts_builtin_sym_end] = ACTIONS(1787),
    [sym_identifier] = ACTIONS(1789),
    [anon_sym_SEMI] = ACTIONS(1787),
    [anon_sym_macro_rules_BANG] = ACTIONS(1787),
    [anon_sym_LPAREN] = ACTIONS(1787),
    [anon_sym_LBRACE] = ACTIONS(1787),
    [anon_sym_RBRACE] = ACTIONS(1787),
    [anon_sym_LBRACK] = ACTIONS(1787),
    [anon_sym_STAR] = ACTIONS(1787),
    [anon_sym_u8] = ACTIONS(1789),
    [anon_sym_i8] = ACTIONS(1789),
    [anon_sym_u16] = ACTIONS(1789),
    [anon_sym_i16] = ACTIONS(1789),
    [anon_sym_u32] = ACTIONS(1789),
    [anon_sym_i32] = ACTIONS(1789),
    [anon_sym_u64] = ACTIONS(1789),
    [anon_sym_i64] = ACTIONS(1789),
    [anon_sym_u128] = ACTIONS(1789),
    [anon_sym_i128] = ACTIONS(1789),
    [anon_sym_isize] = ACTIONS(1789),
    [anon_sym_usize] = ACTIONS(1789),
    [anon_sym_f32] = ACTIONS(1789),
    [anon_sym_f64] = ACTIONS(1789),
    [anon_sym_bool] = ACTIONS(1789),
    [anon_sym_str] = ACTIONS(1789),
    [anon_sym_char] = ACTIONS(1789),
    [anon_sym_SQUOTE] = ACTIONS(1789),
    [anon_sym_async] = ACTIONS(1789),
    [anon_sym_break] = ACTIONS(1789),
    [anon_sym_const] = ACTIONS(1789),
    [anon_sym_continue] = ACTIONS(1789),
    [anon_sym_default] = ACTIONS(1789),
    [anon_sym_enum] = ACTIONS(1789),
    [anon_sym_fn] = ACTIONS(1789),
    [anon_sym_for] = ACTIONS(1789),
    [anon_sym_if] = ACTIONS(1789),
    [anon_sym_impl] = ACTIONS(1789),
    [anon_sym_let] = ACTIONS(1789),
    [anon_sym_loop] = ACTIONS(1789),
    [anon_sym_match] = ACTIONS(1789),
    [anon_sym_mod] = ACTIONS(1789),
    [anon_sym_pub] = ACTIONS(1789),
    [anon_sym_return] = ACTIONS(1789),
    [anon_sym_static] = ACTIONS(1789),
    [anon_sym_struct] = ACTIONS(1789),
    [anon_sym_trait] = ACTIONS(1789),
    [anon_sym_type] = ACTIONS(1789),
    [anon_sym_union] = ACTIONS(1789),
    [anon_sym_unsafe] = ACTIONS(1789),
    [anon_sym_use] = ACTIONS(1789),
    [anon_sym_while] = ACTIONS(1789),
    [anon_sym_POUND] = ACTIONS(1787),
    [anon_sym_BANG] = ACTIONS(1787),
    [anon_sym_extern] = ACTIONS(1789),
    [anon_sym_LT] = ACTIONS(1787),
    [anon_sym_COLON_COLON] = ACTIONS(1787),
    [anon_sym_AMP] = ACTIONS(1787),
    [anon_sym_DOT_DOT] = ACTIONS(1787),
    [anon_sym_DASH] = ACTIONS(1787),
    [anon_sym_PIPE] = ACTIONS(1787),
    [anon_sym_move] = ACTIONS(1789),
    [sym_integer_literal] = ACTIONS(1787),
    [aux_sym_string_literal_token1] = ACTIONS(1787),
    [sym_char_literal] = ACTIONS(1787),
    [anon_sym_true] = ACTIONS(1789),
    [anon_sym_false] = ACTIONS(1789),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1789),
    [sym_super] = ACTIONS(1789),
    [sym_crate] = ACTIONS(1789),
    [sym_metavariable] = ACTIONS(1787),
    [sym_raw_string_literal] = ACTIONS(1787),
    [sym_float_literal] = ACTIONS(1787),
    [sym_block_comment] = ACTIONS(3),
  },
  [366] = {
    [ts_builtin_sym_end] = ACTIONS(1791),
    [sym_identifier] = ACTIONS(1793),
    [anon_sym_SEMI] = ACTIONS(1791),
    [anon_sym_macro_rules_BANG] = ACTIONS(1791),
    [anon_sym_LPAREN] = ACTIONS(1791),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_RBRACE] = ACTIONS(1791),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [anon_sym_STAR] = ACTIONS(1791),
    [anon_sym_u8] = ACTIONS(1793),
    [anon_sym_i8] = ACTIONS(1793),
    [anon_sym_u16] = ACTIONS(1793),
    [anon_sym_i16] = ACTIONS(1793),
    [anon_sym_u32] = ACTIONS(1793),
    [anon_sym_i32] = ACTIONS(1793),
    [anon_sym_u64] = ACTIONS(1793),
    [anon_sym_i64] = ACTIONS(1793),
    [anon_sym_u128] = ACTIONS(1793),
    [anon_sym_i128] = ACTIONS(1793),
    [anon_sym_isize] = ACTIONS(1793),
    [anon_sym_usize] = ACTIONS(1793),
    [anon_sym_f32] = ACTIONS(1793),
    [anon_sym_f64] = ACTIONS(1793),
    [anon_sym_bool] = ACTIONS(1793),
    [anon_sym_str] = ACTIONS(1793),
    [anon_sym_char] = ACTIONS(1793),
    [anon_sym_SQUOTE] = ACTIONS(1793),
    [anon_sym_async] = ACTIONS(1793),
    [anon_sym_break] = ACTIONS(1793),
    [anon_sym_const] = ACTIONS(1793),
    [anon_sym_continue] = ACTIONS(1793),
    [anon_sym_default] = ACTIONS(1793),
    [anon_sym_enum] = ACTIONS(1793),
    [anon_sym_fn] = ACTIONS(1793),
    [anon_sym_for] = ACTIONS(1793),
    [anon_sym_if] = ACTIONS(1793),
    [anon_sym_impl] = ACTIONS(1793),
    [anon_sym_let] = ACTIONS(1793),
    [anon_sym_loop] = ACTIONS(1793),
    [anon_sym_match] = ACTIONS(1793),
    [anon_sym_mod] = ACTIONS(1793),
    [anon_sym_pub] = ACTIONS(1793),
    [anon_sym_return] = ACTIONS(1793),
    [anon_sym_static] = ACTIONS(1793),
    [anon_sym_struct] = ACTIONS(1793),
    [anon_sym_trait] = ACTIONS(1793),
    [anon_sym_type] = ACTIONS(1793),
    [anon_sym_union] = ACTIONS(1793),
    [anon_sym_unsafe] = ACTIONS(1793),
    [anon_sym_use] = ACTIONS(1793),
    [anon_sym_while] = ACTIONS(1793),
    [anon_sym_POUND] = ACTIONS(1791),
    [anon_sym_BANG] = ACTIONS(1791),
    [anon_sym_extern] = ACTIONS(1793),
    [anon_sym_LT] = ACTIONS(1791),
    [anon_sym_COLON_COLON] = ACTIONS(1791),
    [anon_sym_AMP] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1791),
    [anon_sym_PIPE] = ACTIONS(1791),
    [anon_sym_move] = ACTIONS(1793),
    [sym_integer_literal] = ACTIONS(1791),
    [aux_sym_string_literal_token1] = ACTIONS(1791),
    [sym_char_literal] = ACTIONS(1791),
    [anon_sym_true] = ACTIONS(1793),
    [anon_sym_false] = ACTIONS(1793),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1793),
    [sym_super] = ACTIONS(1793),
    [sym_crate] = ACTIONS(1793),
    [sym_metavariable] = ACTIONS(1791),
    [sym_raw_string_literal] = ACTIONS(1791),
    [sym_float_literal] = ACTIONS(1791),
    [sym_block_comment] = ACTIONS(3),
  },
  [367] = {
    [ts_builtin_sym_end] = ACTIONS(1795),
    [sym_identifier] = ACTIONS(1797),
    [anon_sym_SEMI] = ACTIONS(1795),
    [anon_sym_macro_rules_BANG] = ACTIONS(1795),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_LBRACE] = ACTIONS(1795),
    [anon_sym_RBRACE] = ACTIONS(1795),
    [anon_sym_LBRACK] = ACTIONS(1795),
    [anon_sym_STAR] = ACTIONS(1795),
    [anon_sym_u8] = ACTIONS(1797),
    [anon_sym_i8] = ACTIONS(1797),
    [anon_sym_u16] = ACTIONS(1797),
    [anon_sym_i16] = ACTIONS(1797),
    [anon_sym_u32] = ACTIONS(1797),
    [anon_sym_i32] = ACTIONS(1797),
    [anon_sym_u64] = ACTIONS(1797),
    [anon_sym_i64] = ACTIONS(1797),
    [anon_sym_u128] = ACTIONS(1797),
    [anon_sym_i128] = ACTIONS(1797),
    [anon_sym_isize] = ACTIONS(1797),
    [anon_sym_usize] = ACTIONS(1797),
    [anon_sym_f32] = ACTIONS(1797),
    [anon_sym_f64] = ACTIONS(1797),
    [anon_sym_bool] = ACTIONS(1797),
    [anon_sym_str] = ACTIONS(1797),
    [anon_sym_char] = ACTIONS(1797),
    [anon_sym_SQUOTE] = ACTIONS(1797),
    [anon_sym_async] = ACTIONS(1797),
    [anon_sym_break] = ACTIONS(1797),
    [anon_sym_const] = ACTIONS(1797),
    [anon_sym_continue] = ACTIONS(1797),
    [anon_sym_default] = ACTIONS(1797),
    [anon_sym_enum] = ACTIONS(1797),
    [anon_sym_fn] = ACTIONS(1797),
    [anon_sym_for] = ACTIONS(1797),
    [anon_sym_if] = ACTIONS(1797),
    [anon_sym_impl] = ACTIONS(1797),
    [anon_sym_let] = ACTIONS(1797),
    [anon_sym_loop] = ACTIONS(1797),
    [anon_sym_match] = ACTIONS(1797),
    [anon_sym_mod] = ACTIONS(1797),
    [anon_sym_pub] = ACTIONS(1797),
    [anon_sym_return] = ACTIONS(1797),
    [anon_sym_static] = ACTIONS(1797),
    [anon_sym_struct] = ACTIONS(1797),
    [anon_sym_trait] = ACTIONS(1797),
    [anon_sym_type] = ACTIONS(1797),
    [anon_sym_union] = ACTIONS(1797),
    [anon_sym_unsafe] = ACTIONS(1797),
    [anon_sym_use] = ACTIONS(1797),
    [anon_sym_while] = ACTIONS(1797),
    [anon_sym_POUND] = ACTIONS(1795),
    [anon_sym_BANG] = ACTIONS(1795),
    [anon_sym_extern] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(1795),
    [anon_sym_COLON_COLON] = ACTIONS(1795),
    [anon_sym_AMP] = ACTIONS(1795),
    [anon_sym_DOT_DOT] = ACTIONS(1795),
    [anon_sym_DASH] = ACTIONS(1795),
    [anon_sym_PIPE] = ACTIONS(1795),
    [anon_sym_move] = ACTIONS(1797),
    [sym_integer_literal] = ACTIONS(1795),
    [aux_sym_string_literal_token1] = ACTIONS(1795),
    [sym_char_literal] = ACTIONS(1795),
    [anon_sym_true] = ACTIONS(1797),
    [anon_sym_false] = ACTIONS(1797),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1797),
    [sym_super] = ACTIONS(1797),
    [sym_crate] = ACTIONS(1797),
    [sym_metavariable] = ACTIONS(1795),
    [sym_raw_string_literal] = ACTIONS(1795),
    [sym_float_literal] = ACTIONS(1795),
    [sym_block_comment] = ACTIONS(3),
  },
  [368] = {
    [ts_builtin_sym_end] = ACTIONS(1799),
    [sym_identifier] = ACTIONS(1801),
    [anon_sym_SEMI] = ACTIONS(1799),
    [anon_sym_macro_rules_BANG] = ACTIONS(1799),
    [anon_sym_LPAREN] = ACTIONS(1799),
    [anon_sym_LBRACE] = ACTIONS(1799),
    [anon_sym_RBRACE] = ACTIONS(1799),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_STAR] = ACTIONS(1799),
    [anon_sym_u8] = ACTIONS(1801),
    [anon_sym_i8] = ACTIONS(1801),
    [anon_sym_u16] = ACTIONS(1801),
    [anon_sym_i16] = ACTIONS(1801),
    [anon_sym_u32] = ACTIONS(1801),
    [anon_sym_i32] = ACTIONS(1801),
    [anon_sym_u64] = ACTIONS(1801),
    [anon_sym_i64] = ACTIONS(1801),
    [anon_sym_u128] = ACTIONS(1801),
    [anon_sym_i128] = ACTIONS(1801),
    [anon_sym_isize] = ACTIONS(1801),
    [anon_sym_usize] = ACTIONS(1801),
    [anon_sym_f32] = ACTIONS(1801),
    [anon_sym_f64] = ACTIONS(1801),
    [anon_sym_bool] = ACTIONS(1801),
    [anon_sym_str] = ACTIONS(1801),
    [anon_sym_char] = ACTIONS(1801),
    [anon_sym_SQUOTE] = ACTIONS(1801),
    [anon_sym_async] = ACTIONS(1801),
    [anon_sym_break] = ACTIONS(1801),
    [anon_sym_const] = ACTIONS(1801),
    [anon_sym_continue] = ACTIONS(1801),
    [anon_sym_default] = ACTIONS(1801),
    [anon_sym_enum] = ACTIONS(1801),
    [anon_sym_fn] = ACTIONS(1801),
    [anon_sym_for] = ACTIONS(1801),
    [anon_sym_if] = ACTIONS(1801),
    [anon_sym_impl] = ACTIONS(1801),
    [anon_sym_let] = ACTIONS(1801),
    [anon_sym_loop] = ACTIONS(1801),
    [anon_sym_match] = ACTIONS(1801),
    [anon_sym_mod] = ACTIONS(1801),
    [anon_sym_pub] = ACTIONS(1801),
    [anon_sym_return] = ACTIONS(1801),
    [anon_sym_static] = ACTIONS(1801),
    [anon_sym_struct] = ACTIONS(1801),
    [anon_sym_trait] = ACTIONS(1801),
    [anon_sym_type] = ACTIONS(1801),
    [anon_sym_union] = ACTIONS(1801),
    [anon_sym_unsafe] = ACTIONS(1801),
    [anon_sym_use] = ACTIONS(1801),
    [anon_sym_while] = ACTIONS(1801),
    [anon_sym_POUND] = ACTIONS(1799),
    [anon_sym_BANG] = ACTIONS(1799),
    [anon_sym_extern] = ACTIONS(1801),
    [anon_sym_LT] = ACTIONS(1799),
    [anon_sym_COLON_COLON] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1799),
    [anon_sym_DOT_DOT] = ACTIONS(1799),
    [anon_sym_DASH] = ACTIONS(1799),
    [anon_sym_PIPE] = ACTIONS(1799),
    [anon_sym_move] = ACTIONS(1801),
    [sym_integer_literal] = ACTIONS(1799),
    [aux_sym_string_literal_token1] = ACTIONS(1799),
    [sym_char_literal] = ACTIONS(1799),
    [anon_sym_true] = ACTIONS(1801),
    [anon_sym_false] = ACTIONS(1801),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1801),
    [sym_super] = ACTIONS(1801),
    [sym_crate] = ACTIONS(1801),
    [sym_metavariable] = ACTIONS(1799),
    [sym_raw_string_literal] = ACTIONS(1799),
    [sym_float_literal] = ACTIONS(1799),
    [sym_block_comment] = ACTIONS(3),
  },
  [369] = {
    [ts_builtin_sym_end] = ACTIONS(1803),
    [sym_identifier] = ACTIONS(1805),
    [anon_sym_SEMI] = ACTIONS(1803),
    [anon_sym_macro_rules_BANG] = ACTIONS(1803),
    [anon_sym_LPAREN] = ACTIONS(1803),
    [anon_sym_LBRACE] = ACTIONS(1803),
    [anon_sym_RBRACE] = ACTIONS(1803),
    [anon_sym_LBRACK] = ACTIONS(1803),
    [anon_sym_STAR] = ACTIONS(1803),
    [anon_sym_u8] = ACTIONS(1805),
    [anon_sym_i8] = ACTIONS(1805),
    [anon_sym_u16] = ACTIONS(1805),
    [anon_sym_i16] = ACTIONS(1805),
    [anon_sym_u32] = ACTIONS(1805),
    [anon_sym_i32] = ACTIONS(1805),
    [anon_sym_u64] = ACTIONS(1805),
    [anon_sym_i64] = ACTIONS(1805),
    [anon_sym_u128] = ACTIONS(1805),
    [anon_sym_i128] = ACTIONS(1805),
    [anon_sym_isize] = ACTIONS(1805),
    [anon_sym_usize] = ACTIONS(1805),
    [anon_sym_f32] = ACTIONS(1805),
    [anon_sym_f64] = ACTIONS(1805),
    [anon_sym_bool] = ACTIONS(1805),
    [anon_sym_str] = ACTIONS(1805),
    [anon_sym_char] = ACTIONS(1805),
    [anon_sym_SQUOTE] = ACTIONS(1805),
    [anon_sym_async] = ACTIONS(1805),
    [anon_sym_break] = ACTIONS(1805),
    [anon_sym_const] = ACTIONS(1805),
    [anon_sym_continue] = ACTIONS(1805),
    [anon_sym_default] = ACTIONS(1805),
    [anon_sym_enum] = ACTIONS(1805),
    [anon_sym_fn] = ACTIONS(1805),
    [anon_sym_for] = ACTIONS(1805),
    [anon_sym_if] = ACTIONS(1805),
    [anon_sym_impl] = ACTIONS(1805),
    [anon_sym_let] = ACTIONS(1805),
    [anon_sym_loop] = ACTIONS(1805),
    [anon_sym_match] = ACTIONS(1805),
    [anon_sym_mod] = ACTIONS(1805),
    [anon_sym_pub] = ACTIONS(1805),
    [anon_sym_return] = ACTIONS(1805),
    [anon_sym_static] = ACTIONS(1805),
    [anon_sym_struct] = ACTIONS(1805),
    [anon_sym_trait] = ACTIONS(1805),
    [anon_sym_type] = ACTIONS(1805),
    [anon_sym_union] = ACTIONS(1805),
    [anon_sym_unsafe] = ACTIONS(1805),
    [anon_sym_use] = ACTIONS(1805),
    [anon_sym_while] = ACTIONS(1805),
    [anon_sym_POUND] = ACTIONS(1803),
    [anon_sym_BANG] = ACTIONS(1803),
    [anon_sym_extern] = ACTIONS(1805),
    [anon_sym_LT] = ACTIONS(1803),
    [anon_sym_COLON_COLON] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_DOT_DOT] = ACTIONS(1803),
    [anon_sym_DASH] = ACTIONS(1803),
    [anon_sym_PIPE] = ACTIONS(1803),
    [anon_sym_move] = ACTIONS(1805),
    [sym_integer_literal] = ACTIONS(1803),
    [aux_sym_string_literal_token1] = ACTIONS(1803),
    [sym_char_literal] = ACTIONS(1803),
    [anon_sym_true] = ACTIONS(1805),
    [anon_sym_false] = ACTIONS(1805),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1805),
    [sym_super] = ACTIONS(1805),
    [sym_crate] = ACTIONS(1805),
    [sym_metavariable] = ACTIONS(1803),
    [sym_raw_string_literal] = ACTIONS(1803),
    [sym_float_literal] = ACTIONS(1803),
    [sym_block_comment] = ACTIONS(3),
  },
  [370] = {
    [ts_builtin_sym_end] = ACTIONS(1807),
    [sym_identifier] = ACTIONS(1809),
    [anon_sym_SEMI] = ACTIONS(1807),
    [anon_sym_macro_rules_BANG] = ACTIONS(1807),
    [anon_sym_LPAREN] = ACTIONS(1807),
    [anon_sym_LBRACE] = ACTIONS(1807),
    [anon_sym_RBRACE] = ACTIONS(1807),
    [anon_sym_LBRACK] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1807),
    [anon_sym_u8] = ACTIONS(1809),
    [anon_sym_i8] = ACTIONS(1809),
    [anon_sym_u16] = ACTIONS(1809),
    [anon_sym_i16] = ACTIONS(1809),
    [anon_sym_u32] = ACTIONS(1809),
    [anon_sym_i32] = ACTIONS(1809),
    [anon_sym_u64] = ACTIONS(1809),
    [anon_sym_i64] = ACTIONS(1809),
    [anon_sym_u128] = ACTIONS(1809),
    [anon_sym_i128] = ACTIONS(1809),
    [anon_sym_isize] = ACTIONS(1809),
    [anon_sym_usize] = ACTIONS(1809),
    [anon_sym_f32] = ACTIONS(1809),
    [anon_sym_f64] = ACTIONS(1809),
    [anon_sym_bool] = ACTIONS(1809),
    [anon_sym_str] = ACTIONS(1809),
    [anon_sym_char] = ACTIONS(1809),
    [anon_sym_SQUOTE] = ACTIONS(1809),
    [anon_sym_async] = ACTIONS(1809),
    [anon_sym_break] = ACTIONS(1809),
    [anon_sym_const] = ACTIONS(1809),
    [anon_sym_continue] = ACTIONS(1809),
    [anon_sym_default] = ACTIONS(1809),
    [anon_sym_enum] = ACTIONS(1809),
    [anon_sym_fn] = ACTIONS(1809),
    [anon_sym_for] = ACTIONS(1809),
    [anon_sym_if] = ACTIONS(1809),
    [anon_sym_impl] = ACTIONS(1809),
    [anon_sym_let] = ACTIONS(1809),
    [anon_sym_loop] = ACTIONS(1809),
    [anon_sym_match] = ACTIONS(1809),
    [anon_sym_mod] = ACTIONS(1809),
    [anon_sym_pub] = ACTIONS(1809),
    [anon_sym_return] = ACTIONS(1809),
    [anon_sym_static] = ACTIONS(1809),
    [anon_sym_struct] = ACTIONS(1809),
    [anon_sym_trait] = ACTIONS(1809),
    [anon_sym_type] = ACTIONS(1809),
    [anon_sym_union] = ACTIONS(1809),
    [anon_sym_unsafe] = ACTIONS(1809),
    [anon_sym_use] = ACTIONS(1809),
    [anon_sym_while] = ACTIONS(1809),
    [anon_sym_POUND] = ACTIONS(1807),
    [anon_sym_BANG] = ACTIONS(1807),
    [anon_sym_extern] = ACTIONS(1809),
    [anon_sym_LT] = ACTIONS(1807),
    [anon_sym_COLON_COLON] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_DOT_DOT] = ACTIONS(1807),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_PIPE] = ACTIONS(1807),
    [anon_sym_move] = ACTIONS(1809),
    [sym_integer_literal] = ACTIONS(1807),
    [aux_sym_string_literal_token1] = ACTIONS(1807),
    [sym_char_literal] = ACTIONS(1807),
    [anon_sym_true] = ACTIONS(1809),
    [anon_sym_false] = ACTIONS(1809),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1809),
    [sym_super] = ACTIONS(1809),
    [sym_crate] = ACTIONS(1809),
    [sym_metavariable] = ACTIONS(1807),
    [sym_raw_string_literal] = ACTIONS(1807),
    [sym_float_literal] = ACTIONS(1807),
    [sym_block_comment] = ACTIONS(3),
  },
  [371] = {
    [ts_builtin_sym_end] = ACTIONS(1811),
    [sym_identifier] = ACTIONS(1813),
    [anon_sym_SEMI] = ACTIONS(1811),
    [anon_sym_macro_rules_BANG] = ACTIONS(1811),
    [anon_sym_LPAREN] = ACTIONS(1811),
    [anon_sym_LBRACE] = ACTIONS(1811),
    [anon_sym_RBRACE] = ACTIONS(1811),
    [anon_sym_LBRACK] = ACTIONS(1811),
    [anon_sym_STAR] = ACTIONS(1811),
    [anon_sym_u8] = ACTIONS(1813),
    [anon_sym_i8] = ACTIONS(1813),
    [anon_sym_u16] = ACTIONS(1813),
    [anon_sym_i16] = ACTIONS(1813),
    [anon_sym_u32] = ACTIONS(1813),
    [anon_sym_i32] = ACTIONS(1813),
    [anon_sym_u64] = ACTIONS(1813),
    [anon_sym_i64] = ACTIONS(1813),
    [anon_sym_u128] = ACTIONS(1813),
    [anon_sym_i128] = ACTIONS(1813),
    [anon_sym_isize] = ACTIONS(1813),
    [anon_sym_usize] = ACTIONS(1813),
    [anon_sym_f32] = ACTIONS(1813),
    [anon_sym_f64] = ACTIONS(1813),
    [anon_sym_bool] = ACTIONS(1813),
    [anon_sym_str] = ACTIONS(1813),
    [anon_sym_char] = ACTIONS(1813),
    [anon_sym_SQUOTE] = ACTIONS(1813),
    [anon_sym_async] = ACTIONS(1813),
    [anon_sym_break] = ACTIONS(1813),
    [anon_sym_const] = ACTIONS(1813),
    [anon_sym_continue] = ACTIONS(1813),
    [anon_sym_default] = ACTIONS(1813),
    [anon_sym_enum] = ACTIONS(1813),
    [anon_sym_fn] = ACTIONS(1813),
    [anon_sym_for] = ACTIONS(1813),
    [anon_sym_if] = ACTIONS(1813),
    [anon_sym_impl] = ACTIONS(1813),
    [anon_sym_let] = ACTIONS(1813),
    [anon_sym_loop] = ACTIONS(1813),
    [anon_sym_match] = ACTIONS(1813),
    [anon_sym_mod] = ACTIONS(1813),
    [anon_sym_pub] = ACTIONS(1813),
    [anon_sym_return] = ACTIONS(1813),
    [anon_sym_static] = ACTIONS(1813),
    [anon_sym_struct] = ACTIONS(1813),
    [anon_sym_trait] = ACTIONS(1813),
    [anon_sym_type] = ACTIONS(1813),
    [anon_sym_union] = ACTIONS(1813),
    [anon_sym_unsafe] = ACTIONS(1813),
    [anon_sym_use] = ACTIONS(1813),
    [anon_sym_while] = ACTIONS(1813),
    [anon_sym_POUND] = ACTIONS(1811),
    [anon_sym_BANG] = ACTIONS(1811),
    [anon_sym_extern] = ACTIONS(1813),
    [anon_sym_LT] = ACTIONS(1811),
    [anon_sym_COLON_COLON] = ACTIONS(1811),
    [anon_sym_AMP] = ACTIONS(1811),
    [anon_sym_DOT_DOT] = ACTIONS(1811),
    [anon_sym_DASH] = ACTIONS(1811),
    [anon_sym_PIPE] = ACTIONS(1811),
    [anon_sym_move] = ACTIONS(1813),
    [sym_integer_literal] = ACTIONS(1811),
    [aux_sym_string_literal_token1] = ACTIONS(1811),
    [sym_char_literal] = ACTIONS(1811),
    [anon_sym_true] = ACTIONS(1813),
    [anon_sym_false] = ACTIONS(1813),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1813),
    [sym_super] = ACTIONS(1813),
    [sym_crate] = ACTIONS(1813),
    [sym_metavariable] = ACTIONS(1811),
    [sym_raw_string_literal] = ACTIONS(1811),
    [sym_float_literal] = ACTIONS(1811),
    [sym_block_comment] = ACTIONS(3),
  },
  [372] = {
    [ts_builtin_sym_end] = ACTIONS(1815),
    [sym_identifier] = ACTIONS(1817),
    [anon_sym_SEMI] = ACTIONS(1815),
    [anon_sym_macro_rules_BANG] = ACTIONS(1815),
    [anon_sym_LPAREN] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(1815),
    [anon_sym_RBRACE] = ACTIONS(1815),
    [anon_sym_LBRACK] = ACTIONS(1815),
    [anon_sym_STAR] = ACTIONS(1815),
    [anon_sym_u8] = ACTIONS(1817),
    [anon_sym_i8] = ACTIONS(1817),
    [anon_sym_u16] = ACTIONS(1817),
    [anon_sym_i16] = ACTIONS(1817),
    [anon_sym_u32] = ACTIONS(1817),
    [anon_sym_i32] = ACTIONS(1817),
    [anon_sym_u64] = ACTIONS(1817),
    [anon_sym_i64] = ACTIONS(1817),
    [anon_sym_u128] = ACTIONS(1817),
    [anon_sym_i128] = ACTIONS(1817),
    [anon_sym_isize] = ACTIONS(1817),
    [anon_sym_usize] = ACTIONS(1817),
    [anon_sym_f32] = ACTIONS(1817),
    [anon_sym_f64] = ACTIONS(1817),
    [anon_sym_bool] = ACTIONS(1817),
    [anon_sym_str] = ACTIONS(1817),
    [anon_sym_char] = ACTIONS(1817),
    [anon_sym_SQUOTE] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(1817),
    [anon_sym_break] = ACTIONS(1817),
    [anon_sym_const] = ACTIONS(1817),
    [anon_sym_continue] = ACTIONS(1817),
    [anon_sym_default] = ACTIONS(1817),
    [anon_sym_enum] = ACTIONS(1817),
    [anon_sym_fn] = ACTIONS(1817),
    [anon_sym_for] = ACTIONS(1817),
    [anon_sym_if] = ACTIONS(1817),
    [anon_sym_impl] = ACTIONS(1817),
    [anon_sym_let] = ACTIONS(1817),
    [anon_sym_loop] = ACTIONS(1817),
    [anon_sym_match] = ACTIONS(1817),
    [anon_sym_mod] = ACTIONS(1817),
    [anon_sym_pub] = ACTIONS(1817),
    [anon_sym_return] = ACTIONS(1817),
    [anon_sym_static] = ACTIONS(1817),
    [anon_sym_struct] = ACTIONS(1817),
    [anon_sym_trait] = ACTIONS(1817),
    [anon_sym_type] = ACTIONS(1817),
    [anon_sym_union] = ACTIONS(1817),
    [anon_sym_unsafe] = ACTIONS(1817),
    [anon_sym_use] = ACTIONS(1817),
    [anon_sym_while] = ACTIONS(1817),
    [anon_sym_POUND] = ACTIONS(1815),
    [anon_sym_BANG] = ACTIONS(1815),
    [anon_sym_extern] = ACTIONS(1817),
    [anon_sym_LT] = ACTIONS(1815),
    [anon_sym_COLON_COLON] = ACTIONS(1815),
    [anon_sym_AMP] = ACTIONS(1815),
    [anon_sym_DOT_DOT] = ACTIONS(1815),
    [anon_sym_DASH] = ACTIONS(1815),
    [anon_sym_PIPE] = ACTIONS(1815),
    [anon_sym_move] = ACTIONS(1817),
    [sym_integer_literal] = ACTIONS(1815),
    [aux_sym_string_literal_token1] = ACTIONS(1815),
    [sym_char_literal] = ACTIONS(1815),
    [anon_sym_true] = ACTIONS(1817),
    [anon_sym_false] = ACTIONS(1817),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1817),
    [sym_super] = ACTIONS(1817),
    [sym_crate] = ACTIONS(1817),
    [sym_metavariable] = ACTIONS(1815),
    [sym_raw_string_literal] = ACTIONS(1815),
    [sym_float_literal] = ACTIONS(1815),
    [sym_block_comment] = ACTIONS(3),
  },
  [373] = {
    [ts_builtin_sym_end] = ACTIONS(1819),
    [sym_identifier] = ACTIONS(1821),
    [anon_sym_SEMI] = ACTIONS(1819),
    [anon_sym_macro_rules_BANG] = ACTIONS(1819),
    [anon_sym_LPAREN] = ACTIONS(1819),
    [anon_sym_LBRACE] = ACTIONS(1819),
    [anon_sym_RBRACE] = ACTIONS(1819),
    [anon_sym_LBRACK] = ACTIONS(1819),
    [anon_sym_STAR] = ACTIONS(1819),
    [anon_sym_u8] = ACTIONS(1821),
    [anon_sym_i8] = ACTIONS(1821),
    [anon_sym_u16] = ACTIONS(1821),
    [anon_sym_i16] = ACTIONS(1821),
    [anon_sym_u32] = ACTIONS(1821),
    [anon_sym_i32] = ACTIONS(1821),
    [anon_sym_u64] = ACTIONS(1821),
    [anon_sym_i64] = ACTIONS(1821),
    [anon_sym_u128] = ACTIONS(1821),
    [anon_sym_i128] = ACTIONS(1821),
    [anon_sym_isize] = ACTIONS(1821),
    [anon_sym_usize] = ACTIONS(1821),
    [anon_sym_f32] = ACTIONS(1821),
    [anon_sym_f64] = ACTIONS(1821),
    [anon_sym_bool] = ACTIONS(1821),
    [anon_sym_str] = ACTIONS(1821),
    [anon_sym_char] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(1821),
    [anon_sym_async] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1821),
    [anon_sym_const] = ACTIONS(1821),
    [anon_sym_continue] = ACTIONS(1821),
    [anon_sym_default] = ACTIONS(1821),
    [anon_sym_enum] = ACTIONS(1821),
    [anon_sym_fn] = ACTIONS(1821),
    [anon_sym_for] = ACTIONS(1821),
    [anon_sym_if] = ACTIONS(1821),
    [anon_sym_impl] = ACTIONS(1821),
    [anon_sym_let] = ACTIONS(1821),
    [anon_sym_loop] = ACTIONS(1821),
    [anon_sym_match] = ACTIONS(1821),
    [anon_sym_mod] = ACTIONS(1821),
    [anon_sym_pub] = ACTIONS(1821),
    [anon_sym_return] = ACTIONS(1821),
    [anon_sym_static] = ACTIONS(1821),
    [anon_sym_struct] = ACTIONS(1821),
    [anon_sym_trait] = ACTIONS(1821),
    [anon_sym_type] = ACTIONS(1821),
    [anon_sym_union] = ACTIONS(1821),
    [anon_sym_unsafe] = ACTIONS(1821),
    [anon_sym_use] = ACTIONS(1821),
    [anon_sym_while] = ACTIONS(1821),
    [anon_sym_POUND] = ACTIONS(1819),
    [anon_sym_BANG] = ACTIONS(1819),
    [anon_sym_extern] = ACTIONS(1821),
    [anon_sym_LT] = ACTIONS(1819),
    [anon_sym_COLON_COLON] = ACTIONS(1819),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_DOT_DOT] = ACTIONS(1819),
    [anon_sym_DASH] = ACTIONS(1819),
    [anon_sym_PIPE] = ACTIONS(1819),
    [anon_sym_move] = ACTIONS(1821),
    [sym_integer_literal] = ACTIONS(1819),
    [aux_sym_string_literal_token1] = ACTIONS(1819),
    [sym_char_literal] = ACTIONS(1819),
    [anon_sym_true] = ACTIONS(1821),
    [anon_sym_false] = ACTIONS(1821),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1821),
    [sym_super] = ACTIONS(1821),
    [sym_crate] = ACTIONS(1821),
    [sym_metavariable] = ACTIONS(1819),
    [sym_raw_string_literal] = ACTIONS(1819),
    [sym_float_literal] = ACTIONS(1819),
    [sym_block_comment] = ACTIONS(3),
  },
  [374] = {
    [ts_builtin_sym_end] = ACTIONS(1823),
    [sym_identifier] = ACTIONS(1825),
    [anon_sym_SEMI] = ACTIONS(1823),
    [anon_sym_macro_rules_BANG] = ACTIONS(1823),
    [anon_sym_LPAREN] = ACTIONS(1823),
    [anon_sym_LBRACE] = ACTIONS(1823),
    [anon_sym_RBRACE] = ACTIONS(1823),
    [anon_sym_LBRACK] = ACTIONS(1823),
    [anon_sym_STAR] = ACTIONS(1823),
    [anon_sym_u8] = ACTIONS(1825),
    [anon_sym_i8] = ACTIONS(1825),
    [anon_sym_u16] = ACTIONS(1825),
    [anon_sym_i16] = ACTIONS(1825),
    [anon_sym_u32] = ACTIONS(1825),
    [anon_sym_i32] = ACTIONS(1825),
    [anon_sym_u64] = ACTIONS(1825),
    [anon_sym_i64] = ACTIONS(1825),
    [anon_sym_u128] = ACTIONS(1825),
    [anon_sym_i128] = ACTIONS(1825),
    [anon_sym_isize] = ACTIONS(1825),
    [anon_sym_usize] = ACTIONS(1825),
    [anon_sym_f32] = ACTIONS(1825),
    [anon_sym_f64] = ACTIONS(1825),
    [anon_sym_bool] = ACTIONS(1825),
    [anon_sym_str] = ACTIONS(1825),
    [anon_sym_char] = ACTIONS(1825),
    [anon_sym_SQUOTE] = ACTIONS(1825),
    [anon_sym_async] = ACTIONS(1825),
    [anon_sym_break] = ACTIONS(1825),
    [anon_sym_const] = ACTIONS(1825),
    [anon_sym_continue] = ACTIONS(1825),
    [anon_sym_default] = ACTIONS(1825),
    [anon_sym_enum] = ACTIONS(1825),
    [anon_sym_fn] = ACTIONS(1825),
    [anon_sym_for] = ACTIONS(1825),
    [anon_sym_if] = ACTIONS(1825),
    [anon_sym_impl] = ACTIONS(1825),
    [anon_sym_let] = ACTIONS(1825),
    [anon_sym_loop] = ACTIONS(1825),
    [anon_sym_match] = ACTIONS(1825),
    [anon_sym_mod] = ACTIONS(1825),
    [anon_sym_pub] = ACTIONS(1825),
    [anon_sym_return] = ACTIONS(1825),
    [anon_sym_static] = ACTIONS(1825),
    [anon_sym_struct] = ACTIONS(1825),
    [anon_sym_trait] = ACTIONS(1825),
    [anon_sym_type] = ACTIONS(1825),
    [anon_sym_union] = ACTIONS(1825),
    [anon_sym_unsafe] = ACTIONS(1825),
    [anon_sym_use] = ACTIONS(1825),
    [anon_sym_while] = ACTIONS(1825),
    [anon_sym_POUND] = ACTIONS(1823),
    [anon_sym_BANG] = ACTIONS(1823),
    [anon_sym_extern] = ACTIONS(1825),
    [anon_sym_LT] = ACTIONS(1823),
    [anon_sym_COLON_COLON] = ACTIONS(1823),
    [anon_sym_AMP] = ACTIONS(1823),
    [anon_sym_DOT_DOT] = ACTIONS(1823),
    [anon_sym_DASH] = ACTIONS(1823),
    [anon_sym_PIPE] = ACTIONS(1823),
    [anon_sym_move] = ACTIONS(1825),
    [sym_integer_literal] = ACTIONS(1823),
    [aux_sym_string_literal_token1] = ACTIONS(1823),
    [sym_char_literal] = ACTIONS(1823),
    [anon_sym_true] = ACTIONS(1825),
    [anon_sym_false] = ACTIONS(1825),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1825),
    [sym_super] = ACTIONS(1825),
    [sym_crate] = ACTIONS(1825),
    [sym_metavariable] = ACTIONS(1823),
    [sym_raw_string_literal] = ACTIONS(1823),
    [sym_float_literal] = ACTIONS(1823),
    [sym_block_comment] = ACTIONS(3),
  },
  [375] = {
    [ts_builtin_sym_end] = ACTIONS(1827),
    [sym_identifier] = ACTIONS(1829),
    [anon_sym_SEMI] = ACTIONS(1827),
    [anon_sym_macro_rules_BANG] = ACTIONS(1827),
    [anon_sym_LPAREN] = ACTIONS(1827),
    [anon_sym_LBRACE] = ACTIONS(1827),
    [anon_sym_RBRACE] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(1827),
    [anon_sym_STAR] = ACTIONS(1827),
    [anon_sym_u8] = ACTIONS(1829),
    [anon_sym_i8] = ACTIONS(1829),
    [anon_sym_u16] = ACTIONS(1829),
    [anon_sym_i16] = ACTIONS(1829),
    [anon_sym_u32] = ACTIONS(1829),
    [anon_sym_i32] = ACTIONS(1829),
    [anon_sym_u64] = ACTIONS(1829),
    [anon_sym_i64] = ACTIONS(1829),
    [anon_sym_u128] = ACTIONS(1829),
    [anon_sym_i128] = ACTIONS(1829),
    [anon_sym_isize] = ACTIONS(1829),
    [anon_sym_usize] = ACTIONS(1829),
    [anon_sym_f32] = ACTIONS(1829),
    [anon_sym_f64] = ACTIONS(1829),
    [anon_sym_bool] = ACTIONS(1829),
    [anon_sym_str] = ACTIONS(1829),
    [anon_sym_char] = ACTIONS(1829),
    [anon_sym_SQUOTE] = ACTIONS(1829),
    [anon_sym_async] = ACTIONS(1829),
    [anon_sym_break] = ACTIONS(1829),
    [anon_sym_const] = ACTIONS(1829),
    [anon_sym_continue] = ACTIONS(1829),
    [anon_sym_default] = ACTIONS(1829),
    [anon_sym_enum] = ACTIONS(1829),
    [anon_sym_fn] = ACTIONS(1829),
    [anon_sym_for] = ACTIONS(1829),
    [anon_sym_if] = ACTIONS(1829),
    [anon_sym_impl] = ACTIONS(1829),
    [anon_sym_let] = ACTIONS(1829),
    [anon_sym_loop] = ACTIONS(1829),
    [anon_sym_match] = ACTIONS(1829),
    [anon_sym_mod] = ACTIONS(1829),
    [anon_sym_pub] = ACTIONS(1829),
    [anon_sym_return] = ACTIONS(1829),
    [anon_sym_static] = ACTIONS(1829),
    [anon_sym_struct] = ACTIONS(1829),
    [anon_sym_trait] = ACTIONS(1829),
    [anon_sym_type] = ACTIONS(1829),
    [anon_sym_union] = ACTIONS(1829),
    [anon_sym_unsafe] = ACTIONS(1829),
    [anon_sym_use] = ACTIONS(1829),
    [anon_sym_while] = ACTIONS(1829),
    [anon_sym_POUND] = ACTIONS(1827),
    [anon_sym_BANG] = ACTIONS(1827),
    [anon_sym_extern] = ACTIONS(1829),
    [anon_sym_LT] = ACTIONS(1827),
    [anon_sym_COLON_COLON] = ACTIONS(1827),
    [anon_sym_AMP] = ACTIONS(1827),
    [anon_sym_DOT_DOT] = ACTIONS(1827),
    [anon_sym_DASH] = ACTIONS(1827),
    [anon_sym_PIPE] = ACTIONS(1827),
    [anon_sym_move] = ACTIONS(1829),
    [sym_integer_literal] = ACTIONS(1827),
    [aux_sym_string_literal_token1] = ACTIONS(1827),
    [sym_char_literal] = ACTIONS(1827),
    [anon_sym_true] = ACTIONS(1829),
    [anon_sym_false] = ACTIONS(1829),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1829),
    [sym_super] = ACTIONS(1829),
    [sym_crate] = ACTIONS(1829),
    [sym_metavariable] = ACTIONS(1827),
    [sym_raw_string_literal] = ACTIONS(1827),
    [sym_float_literal] = ACTIONS(1827),
    [sym_block_comment] = ACTIONS(3),
  },
  [376] = {
    [ts_builtin_sym_end] = ACTIONS(1831),
    [sym_identifier] = ACTIONS(1833),
    [anon_sym_SEMI] = ACTIONS(1831),
    [anon_sym_macro_rules_BANG] = ACTIONS(1831),
    [anon_sym_LPAREN] = ACTIONS(1831),
    [anon_sym_LBRACE] = ACTIONS(1831),
    [anon_sym_RBRACE] = ACTIONS(1831),
    [anon_sym_LBRACK] = ACTIONS(1831),
    [anon_sym_STAR] = ACTIONS(1831),
    [anon_sym_u8] = ACTIONS(1833),
    [anon_sym_i8] = ACTIONS(1833),
    [anon_sym_u16] = ACTIONS(1833),
    [anon_sym_i16] = ACTIONS(1833),
    [anon_sym_u32] = ACTIONS(1833),
    [anon_sym_i32] = ACTIONS(1833),
    [anon_sym_u64] = ACTIONS(1833),
    [anon_sym_i64] = ACTIONS(1833),
    [anon_sym_u128] = ACTIONS(1833),
    [anon_sym_i128] = ACTIONS(1833),
    [anon_sym_isize] = ACTIONS(1833),
    [anon_sym_usize] = ACTIONS(1833),
    [anon_sym_f32] = ACTIONS(1833),
    [anon_sym_f64] = ACTIONS(1833),
    [anon_sym_bool] = ACTIONS(1833),
    [anon_sym_str] = ACTIONS(1833),
    [anon_sym_char] = ACTIONS(1833),
    [anon_sym_SQUOTE] = ACTIONS(1833),
    [anon_sym_async] = ACTIONS(1833),
    [anon_sym_break] = ACTIONS(1833),
    [anon_sym_const] = ACTIONS(1833),
    [anon_sym_continue] = ACTIONS(1833),
    [anon_sym_default] = ACTIONS(1833),
    [anon_sym_enum] = ACTIONS(1833),
    [anon_sym_fn] = ACTIONS(1833),
    [anon_sym_for] = ACTIONS(1833),
    [anon_sym_if] = ACTIONS(1833),
    [anon_sym_impl] = ACTIONS(1833),
    [anon_sym_let] = ACTIONS(1833),
    [anon_sym_loop] = ACTIONS(1833),
    [anon_sym_match] = ACTIONS(1833),
    [anon_sym_mod] = ACTIONS(1833),
    [anon_sym_pub] = ACTIONS(1833),
    [anon_sym_return] = ACTIONS(1833),
    [anon_sym_static] = ACTIONS(1833),
    [anon_sym_struct] = ACTIONS(1833),
    [anon_sym_trait] = ACTIONS(1833),
    [anon_sym_type] = ACTIONS(1833),
    [anon_sym_union] = ACTIONS(1833),
    [anon_sym_unsafe] = ACTIONS(1833),
    [anon_sym_use] = ACTIONS(1833),
    [anon_sym_while] = ACTIONS(1833),
    [anon_sym_POUND] = ACTIONS(1831),
    [anon_sym_BANG] = ACTIONS(1831),
    [anon_sym_extern] = ACTIONS(1833),
    [anon_sym_LT] = ACTIONS(1831),
    [anon_sym_COLON_COLON] = ACTIONS(1831),
    [anon_sym_AMP] = ACTIONS(1831),
    [anon_sym_DOT_DOT] = ACTIONS(1831),
    [anon_sym_DASH] = ACTIONS(1831),
    [anon_sym_PIPE] = ACTIONS(1831),
    [anon_sym_move] = ACTIONS(1833),
    [sym_integer_literal] = ACTIONS(1831),
    [aux_sym_string_literal_token1] = ACTIONS(1831),
    [sym_char_literal] = ACTIONS(1831),
    [anon_sym_true] = ACTIONS(1833),
    [anon_sym_false] = ACTIONS(1833),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1833),
    [sym_super] = ACTIONS(1833),
    [sym_crate] = ACTIONS(1833),
    [sym_metavariable] = ACTIONS(1831),
    [sym_raw_string_literal] = ACTIONS(1831),
    [sym_float_literal] = ACTIONS(1831),
    [sym_block_comment] = ACTIONS(3),
  },
  [377] = {
    [ts_builtin_sym_end] = ACTIONS(1835),
    [sym_identifier] = ACTIONS(1837),
    [anon_sym_SEMI] = ACTIONS(1835),
    [anon_sym_macro_rules_BANG] = ACTIONS(1835),
    [anon_sym_LPAREN] = ACTIONS(1835),
    [anon_sym_LBRACE] = ACTIONS(1835),
    [anon_sym_RBRACE] = ACTIONS(1835),
    [anon_sym_LBRACK] = ACTIONS(1835),
    [anon_sym_STAR] = ACTIONS(1835),
    [anon_sym_u8] = ACTIONS(1837),
    [anon_sym_i8] = ACTIONS(1837),
    [anon_sym_u16] = ACTIONS(1837),
    [anon_sym_i16] = ACTIONS(1837),
    [anon_sym_u32] = ACTIONS(1837),
    [anon_sym_i32] = ACTIONS(1837),
    [anon_sym_u64] = ACTIONS(1837),
    [anon_sym_i64] = ACTIONS(1837),
    [anon_sym_u128] = ACTIONS(1837),
    [anon_sym_i128] = ACTIONS(1837),
    [anon_sym_isize] = ACTIONS(1837),
    [anon_sym_usize] = ACTIONS(1837),
    [anon_sym_f32] = ACTIONS(1837),
    [anon_sym_f64] = ACTIONS(1837),
    [anon_sym_bool] = ACTIONS(1837),
    [anon_sym_str] = ACTIONS(1837),
    [anon_sym_char] = ACTIONS(1837),
    [anon_sym_SQUOTE] = ACTIONS(1837),
    [anon_sym_async] = ACTIONS(1837),
    [anon_sym_break] = ACTIONS(1837),
    [anon_sym_const] = ACTIONS(1837),
    [anon_sym_continue] = ACTIONS(1837),
    [anon_sym_default] = ACTIONS(1837),
    [anon_sym_enum] = ACTIONS(1837),
    [anon_sym_fn] = ACTIONS(1837),
    [anon_sym_for] = ACTIONS(1837),
    [anon_sym_if] = ACTIONS(1837),
    [anon_sym_impl] = ACTIONS(1837),
    [anon_sym_let] = ACTIONS(1837),
    [anon_sym_loop] = ACTIONS(1837),
    [anon_sym_match] = ACTIONS(1837),
    [anon_sym_mod] = ACTIONS(1837),
    [anon_sym_pub] = ACTIONS(1837),
    [anon_sym_return] = ACTIONS(1837),
    [anon_sym_static] = ACTIONS(1837),
    [anon_sym_struct] = ACTIONS(1837),
    [anon_sym_trait] = ACTIONS(1837),
    [anon_sym_type] = ACTIONS(1837),
    [anon_sym_union] = ACTIONS(1837),
    [anon_sym_unsafe] = ACTIONS(1837),
    [anon_sym_use] = ACTIONS(1837),
    [anon_sym_while] = ACTIONS(1837),
    [anon_sym_POUND] = ACTIONS(1835),
    [anon_sym_BANG] = ACTIONS(1835),
    [anon_sym_extern] = ACTIONS(1837),
    [anon_sym_LT] = ACTIONS(1835),
    [anon_sym_COLON_COLON] = ACTIONS(1835),
    [anon_sym_AMP] = ACTIONS(1835),
    [anon_sym_DOT_DOT] = ACTIONS(1835),
    [anon_sym_DASH] = ACTIONS(1835),
    [anon_sym_PIPE] = ACTIONS(1835),
    [anon_sym_move] = ACTIONS(1837),
    [sym_integer_literal] = ACTIONS(1835),
    [aux_sym_string_literal_token1] = ACTIONS(1835),
    [sym_char_literal] = ACTIONS(1835),
    [anon_sym_true] = ACTIONS(1837),
    [anon_sym_false] = ACTIONS(1837),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1837),
    [sym_super] = ACTIONS(1837),
    [sym_crate] = ACTIONS(1837),
    [sym_metavariable] = ACTIONS(1835),
    [sym_raw_string_literal] = ACTIONS(1835),
    [sym_float_literal] = ACTIONS(1835),
    [sym_block_comment] = ACTIONS(3),
  },
  [378] = {
    [ts_builtin_sym_end] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1841),
    [anon_sym_SEMI] = ACTIONS(1839),
    [anon_sym_macro_rules_BANG] = ACTIONS(1839),
    [anon_sym_LPAREN] = ACTIONS(1839),
    [anon_sym_LBRACE] = ACTIONS(1839),
    [anon_sym_RBRACE] = ACTIONS(1839),
    [anon_sym_LBRACK] = ACTIONS(1839),
    [anon_sym_STAR] = ACTIONS(1839),
    [anon_sym_u8] = ACTIONS(1841),
    [anon_sym_i8] = ACTIONS(1841),
    [anon_sym_u16] = ACTIONS(1841),
    [anon_sym_i16] = ACTIONS(1841),
    [anon_sym_u32] = ACTIONS(1841),
    [anon_sym_i32] = ACTIONS(1841),
    [anon_sym_u64] = ACTIONS(1841),
    [anon_sym_i64] = ACTIONS(1841),
    [anon_sym_u128] = ACTIONS(1841),
    [anon_sym_i128] = ACTIONS(1841),
    [anon_sym_isize] = ACTIONS(1841),
    [anon_sym_usize] = ACTIONS(1841),
    [anon_sym_f32] = ACTIONS(1841),
    [anon_sym_f64] = ACTIONS(1841),
    [anon_sym_bool] = ACTIONS(1841),
    [anon_sym_str] = ACTIONS(1841),
    [anon_sym_char] = ACTIONS(1841),
    [anon_sym_SQUOTE] = ACTIONS(1841),
    [anon_sym_async] = ACTIONS(1841),
    [anon_sym_break] = ACTIONS(1841),
    [anon_sym_const] = ACTIONS(1841),
    [anon_sym_continue] = ACTIONS(1841),
    [anon_sym_default] = ACTIONS(1841),
    [anon_sym_enum] = ACTIONS(1841),
    [anon_sym_fn] = ACTIONS(1841),
    [anon_sym_for] = ACTIONS(1841),
    [anon_sym_if] = ACTIONS(1841),
    [anon_sym_impl] = ACTIONS(1841),
    [anon_sym_let] = ACTIONS(1841),
    [anon_sym_loop] = ACTIONS(1841),
    [anon_sym_match] = ACTIONS(1841),
    [anon_sym_mod] = ACTIONS(1841),
    [anon_sym_pub] = ACTIONS(1841),
    [anon_sym_return] = ACTIONS(1841),
    [anon_sym_static] = ACTIONS(1841),
    [anon_sym_struct] = ACTIONS(1841),
    [anon_sym_trait] = ACTIONS(1841),
    [anon_sym_type] = ACTIONS(1841),
    [anon_sym_union] = ACTIONS(1841),
    [anon_sym_unsafe] = ACTIONS(1841),
    [anon_sym_use] = ACTIONS(1841),
    [anon_sym_while] = ACTIONS(1841),
    [anon_sym_POUND] = ACTIONS(1839),
    [anon_sym_BANG] = ACTIONS(1839),
    [anon_sym_extern] = ACTIONS(1841),
    [anon_sym_LT] = ACTIONS(1839),
    [anon_sym_COLON_COLON] = ACTIONS(1839),
    [anon_sym_AMP] = ACTIONS(1839),
    [anon_sym_DOT_DOT] = ACTIONS(1839),
    [anon_sym_DASH] = ACTIONS(1839),
    [anon_sym_PIPE] = ACTIONS(1839),
    [anon_sym_move] = ACTIONS(1841),
    [sym_integer_literal] = ACTIONS(1839),
    [aux_sym_string_literal_token1] = ACTIONS(1839),
    [sym_char_literal] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(1841),
    [anon_sym_false] = ACTIONS(1841),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1841),
    [sym_super] = ACTIONS(1841),
    [sym_crate] = ACTIONS(1841),
    [sym_metavariable] = ACTIONS(1839),
    [sym_raw_string_literal] = ACTIONS(1839),
    [sym_float_literal] = ACTIONS(1839),
    [sym_block_comment] = ACTIONS(3),
  },
  [379] = {
    [ts_builtin_sym_end] = ACTIONS(1843),
    [sym_identifier] = ACTIONS(1845),
    [anon_sym_SEMI] = ACTIONS(1843),
    [anon_sym_macro_rules_BANG] = ACTIONS(1843),
    [anon_sym_LPAREN] = ACTIONS(1843),
    [anon_sym_LBRACE] = ACTIONS(1843),
    [anon_sym_RBRACE] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(1843),
    [anon_sym_STAR] = ACTIONS(1843),
    [anon_sym_u8] = ACTIONS(1845),
    [anon_sym_i8] = ACTIONS(1845),
    [anon_sym_u16] = ACTIONS(1845),
    [anon_sym_i16] = ACTIONS(1845),
    [anon_sym_u32] = ACTIONS(1845),
    [anon_sym_i32] = ACTIONS(1845),
    [anon_sym_u64] = ACTIONS(1845),
    [anon_sym_i64] = ACTIONS(1845),
    [anon_sym_u128] = ACTIONS(1845),
    [anon_sym_i128] = ACTIONS(1845),
    [anon_sym_isize] = ACTIONS(1845),
    [anon_sym_usize] = ACTIONS(1845),
    [anon_sym_f32] = ACTIONS(1845),
    [anon_sym_f64] = ACTIONS(1845),
    [anon_sym_bool] = ACTIONS(1845),
    [anon_sym_str] = ACTIONS(1845),
    [anon_sym_char] = ACTIONS(1845),
    [anon_sym_SQUOTE] = ACTIONS(1845),
    [anon_sym_async] = ACTIONS(1845),
    [anon_sym_break] = ACTIONS(1845),
    [anon_sym_const] = ACTIONS(1845),
    [anon_sym_continue] = ACTIONS(1845),
    [anon_sym_default] = ACTIONS(1845),
    [anon_sym_enum] = ACTIONS(1845),
    [anon_sym_fn] = ACTIONS(1845),
    [anon_sym_for] = ACTIONS(1845),
    [anon_sym_if] = ACTIONS(1845),
    [anon_sym_impl] = ACTIONS(1845),
    [anon_sym_let] = ACTIONS(1845),
    [anon_sym_loop] = ACTIONS(1845),
    [anon_sym_match] = ACTIONS(1845),
    [anon_sym_mod] = ACTIONS(1845),
    [anon_sym_pub] = ACTIONS(1845),
    [anon_sym_return] = ACTIONS(1845),
    [anon_sym_static] = ACTIONS(1845),
    [anon_sym_struct] = ACTIONS(1845),
    [anon_sym_trait] = ACTIONS(1845),
    [anon_sym_type] = ACTIONS(1845),
    [anon_sym_union] = ACTIONS(1845),
    [anon_sym_unsafe] = ACTIONS(1845),
    [anon_sym_use] = ACTIONS(1845),
    [anon_sym_while] = ACTIONS(1845),
    [anon_sym_POUND] = ACTIONS(1843),
    [anon_sym_BANG] = ACTIONS(1843),
    [anon_sym_extern] = ACTIONS(1845),
    [anon_sym_LT] = ACTIONS(1843),
    [anon_sym_COLON_COLON] = ACTIONS(1843),
    [anon_sym_AMP] = ACTIONS(1843),
    [anon_sym_DOT_DOT] = ACTIONS(1843),
    [anon_sym_DASH] = ACTIONS(1843),
    [anon_sym_PIPE] = ACTIONS(1843),
    [anon_sym_move] = ACTIONS(1845),
    [sym_integer_literal] = ACTIONS(1843),
    [aux_sym_string_literal_token1] = ACTIONS(1843),
    [sym_char_literal] = ACTIONS(1843),
    [anon_sym_true] = ACTIONS(1845),
    [anon_sym_false] = ACTIONS(1845),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1845),
    [sym_super] = ACTIONS(1845),
    [sym_crate] = ACTIONS(1845),
    [sym_metavariable] = ACTIONS(1843),
    [sym_raw_string_literal] = ACTIONS(1843),
    [sym_float_literal] = ACTIONS(1843),
    [sym_block_comment] = ACTIONS(3),
  },
  [380] = {
    [ts_builtin_sym_end] = ACTIONS(1847),
    [sym_identifier] = ACTIONS(1849),
    [anon_sym_SEMI] = ACTIONS(1847),
    [anon_sym_macro_rules_BANG] = ACTIONS(1847),
    [anon_sym_LPAREN] = ACTIONS(1847),
    [anon_sym_LBRACE] = ACTIONS(1847),
    [anon_sym_RBRACE] = ACTIONS(1847),
    [anon_sym_LBRACK] = ACTIONS(1847),
    [anon_sym_STAR] = ACTIONS(1847),
    [anon_sym_u8] = ACTIONS(1849),
    [anon_sym_i8] = ACTIONS(1849),
    [anon_sym_u16] = ACTIONS(1849),
    [anon_sym_i16] = ACTIONS(1849),
    [anon_sym_u32] = ACTIONS(1849),
    [anon_sym_i32] = ACTIONS(1849),
    [anon_sym_u64] = ACTIONS(1849),
    [anon_sym_i64] = ACTIONS(1849),
    [anon_sym_u128] = ACTIONS(1849),
    [anon_sym_i128] = ACTIONS(1849),
    [anon_sym_isize] = ACTIONS(1849),
    [anon_sym_usize] = ACTIONS(1849),
    [anon_sym_f32] = ACTIONS(1849),
    [anon_sym_f64] = ACTIONS(1849),
    [anon_sym_bool] = ACTIONS(1849),
    [anon_sym_str] = ACTIONS(1849),
    [anon_sym_char] = ACTIONS(1849),
    [anon_sym_SQUOTE] = ACTIONS(1849),
    [anon_sym_async] = ACTIONS(1849),
    [anon_sym_break] = ACTIONS(1849),
    [anon_sym_const] = ACTIONS(1849),
    [anon_sym_continue] = ACTIONS(1849),
    [anon_sym_default] = ACTIONS(1849),
    [anon_sym_enum] = ACTIONS(1849),
    [anon_sym_fn] = ACTIONS(1849),
    [anon_sym_for] = ACTIONS(1849),
    [anon_sym_if] = ACTIONS(1849),
    [anon_sym_impl] = ACTIONS(1849),
    [anon_sym_let] = ACTIONS(1849),
    [anon_sym_loop] = ACTIONS(1849),
    [anon_sym_match] = ACTIONS(1849),
    [anon_sym_mod] = ACTIONS(1849),
    [anon_sym_pub] = ACTIONS(1849),
    [anon_sym_return] = ACTIONS(1849),
    [anon_sym_static] = ACTIONS(1849),
    [anon_sym_struct] = ACTIONS(1849),
    [anon_sym_trait] = ACTIONS(1849),
    [anon_sym_type] = ACTIONS(1849),
    [anon_sym_union] = ACTIONS(1849),
    [anon_sym_unsafe] = ACTIONS(1849),
    [anon_sym_use] = ACTIONS(1849),
    [anon_sym_while] = ACTIONS(1849),
    [anon_sym_POUND] = ACTIONS(1847),
    [anon_sym_BANG] = ACTIONS(1847),
    [anon_sym_extern] = ACTIONS(1849),
    [anon_sym_LT] = ACTIONS(1847),
    [anon_sym_COLON_COLON] = ACTIONS(1847),
    [anon_sym_AMP] = ACTIONS(1847),
    [anon_sym_DOT_DOT] = ACTIONS(1847),
    [anon_sym_DASH] = ACTIONS(1847),
    [anon_sym_PIPE] = ACTIONS(1847),
    [anon_sym_move] = ACTIONS(1849),
    [sym_integer_literal] = ACTIONS(1847),
    [aux_sym_string_literal_token1] = ACTIONS(1847),
    [sym_char_literal] = ACTIONS(1847),
    [anon_sym_true] = ACTIONS(1849),
    [anon_sym_false] = ACTIONS(1849),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1849),
    [sym_super] = ACTIONS(1849),
    [sym_crate] = ACTIONS(1849),
    [sym_metavariable] = ACTIONS(1847),
    [sym_raw_string_literal] = ACTIONS(1847),
    [sym_float_literal] = ACTIONS(1847),
    [sym_block_comment] = ACTIONS(3),
  },
  [381] = {
    [ts_builtin_sym_end] = ACTIONS(1851),
    [sym_identifier] = ACTIONS(1853),
    [anon_sym_SEMI] = ACTIONS(1851),
    [anon_sym_macro_rules_BANG] = ACTIONS(1851),
    [anon_sym_LPAREN] = ACTIONS(1851),
    [anon_sym_LBRACE] = ACTIONS(1851),
    [anon_sym_RBRACE] = ACTIONS(1851),
    [anon_sym_LBRACK] = ACTIONS(1851),
    [anon_sym_STAR] = ACTIONS(1851),
    [anon_sym_u8] = ACTIONS(1853),
    [anon_sym_i8] = ACTIONS(1853),
    [anon_sym_u16] = ACTIONS(1853),
    [anon_sym_i16] = ACTIONS(1853),
    [anon_sym_u32] = ACTIONS(1853),
    [anon_sym_i32] = ACTIONS(1853),
    [anon_sym_u64] = ACTIONS(1853),
    [anon_sym_i64] = ACTIONS(1853),
    [anon_sym_u128] = ACTIONS(1853),
    [anon_sym_i128] = ACTIONS(1853),
    [anon_sym_isize] = ACTIONS(1853),
    [anon_sym_usize] = ACTIONS(1853),
    [anon_sym_f32] = ACTIONS(1853),
    [anon_sym_f64] = ACTIONS(1853),
    [anon_sym_bool] = ACTIONS(1853),
    [anon_sym_str] = ACTIONS(1853),
    [anon_sym_char] = ACTIONS(1853),
    [anon_sym_SQUOTE] = ACTIONS(1853),
    [anon_sym_async] = ACTIONS(1853),
    [anon_sym_break] = ACTIONS(1853),
    [anon_sym_const] = ACTIONS(1853),
    [anon_sym_continue] = ACTIONS(1853),
    [anon_sym_default] = ACTIONS(1853),
    [anon_sym_enum] = ACTIONS(1853),
    [anon_sym_fn] = ACTIONS(1853),
    [anon_sym_for] = ACTIONS(1853),
    [anon_sym_if] = ACTIONS(1853),
    [anon_sym_impl] = ACTIONS(1853),
    [anon_sym_let] = ACTIONS(1853),
    [anon_sym_loop] = ACTIONS(1853),
    [anon_sym_match] = ACTIONS(1853),
    [anon_sym_mod] = ACTIONS(1853),
    [anon_sym_pub] = ACTIONS(1853),
    [anon_sym_return] = ACTIONS(1853),
    [anon_sym_static] = ACTIONS(1853),
    [anon_sym_struct] = ACTIONS(1853),
    [anon_sym_trait] = ACTIONS(1853),
    [anon_sym_type] = ACTIONS(1853),
    [anon_sym_union] = ACTIONS(1853),
    [anon_sym_unsafe] = ACTIONS(1853),
    [anon_sym_use] = ACTIONS(1853),
    [anon_sym_while] = ACTIONS(1853),
    [anon_sym_POUND] = ACTIONS(1851),
    [anon_sym_BANG] = ACTIONS(1851),
    [anon_sym_extern] = ACTIONS(1853),
    [anon_sym_LT] = ACTIONS(1851),
    [anon_sym_COLON_COLON] = ACTIONS(1851),
    [anon_sym_AMP] = ACTIONS(1851),
    [anon_sym_DOT_DOT] = ACTIONS(1851),
    [anon_sym_DASH] = ACTIONS(1851),
    [anon_sym_PIPE] = ACTIONS(1851),
    [anon_sym_move] = ACTIONS(1853),
    [sym_integer_literal] = ACTIONS(1851),
    [aux_sym_string_literal_token1] = ACTIONS(1851),
    [sym_char_literal] = ACTIONS(1851),
    [anon_sym_true] = ACTIONS(1853),
    [anon_sym_false] = ACTIONS(1853),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1853),
    [sym_super] = ACTIONS(1853),
    [sym_crate] = ACTIONS(1853),
    [sym_metavariable] = ACTIONS(1851),
    [sym_raw_string_literal] = ACTIONS(1851),
    [sym_float_literal] = ACTIONS(1851),
    [sym_block_comment] = ACTIONS(3),
  },
  [382] = {
    [ts_builtin_sym_end] = ACTIONS(1855),
    [sym_identifier] = ACTIONS(1857),
    [anon_sym_SEMI] = ACTIONS(1855),
    [anon_sym_macro_rules_BANG] = ACTIONS(1855),
    [anon_sym_LPAREN] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1855),
    [anon_sym_RBRACE] = ACTIONS(1855),
    [anon_sym_LBRACK] = ACTIONS(1855),
    [anon_sym_STAR] = ACTIONS(1855),
    [anon_sym_u8] = ACTIONS(1857),
    [anon_sym_i8] = ACTIONS(1857),
    [anon_sym_u16] = ACTIONS(1857),
    [anon_sym_i16] = ACTIONS(1857),
    [anon_sym_u32] = ACTIONS(1857),
    [anon_sym_i32] = ACTIONS(1857),
    [anon_sym_u64] = ACTIONS(1857),
    [anon_sym_i64] = ACTIONS(1857),
    [anon_sym_u128] = ACTIONS(1857),
    [anon_sym_i128] = ACTIONS(1857),
    [anon_sym_isize] = ACTIONS(1857),
    [anon_sym_usize] = ACTIONS(1857),
    [anon_sym_f32] = ACTIONS(1857),
    [anon_sym_f64] = ACTIONS(1857),
    [anon_sym_bool] = ACTIONS(1857),
    [anon_sym_str] = ACTIONS(1857),
    [anon_sym_char] = ACTIONS(1857),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_async] = ACTIONS(1857),
    [anon_sym_break] = ACTIONS(1857),
    [anon_sym_const] = ACTIONS(1857),
    [anon_sym_continue] = ACTIONS(1857),
    [anon_sym_default] = ACTIONS(1857),
    [anon_sym_enum] = ACTIONS(1857),
    [anon_sym_fn] = ACTIONS(1857),
    [anon_sym_for] = ACTIONS(1857),
    [anon_sym_if] = ACTIONS(1857),
    [anon_sym_impl] = ACTIONS(1857),
    [anon_sym_let] = ACTIONS(1857),
    [anon_sym_loop] = ACTIONS(1857),
    [anon_sym_match] = ACTIONS(1857),
    [anon_sym_mod] = ACTIONS(1857),
    [anon_sym_pub] = ACTIONS(1857),
    [anon_sym_return] = ACTIONS(1857),
    [anon_sym_static] = ACTIONS(1857),
    [anon_sym_struct] = ACTIONS(1857),
    [anon_sym_trait] = ACTIONS(1857),
    [anon_sym_type] = ACTIONS(1857),
    [anon_sym_union] = ACTIONS(1857),
    [anon_sym_unsafe] = ACTIONS(1857),
    [anon_sym_use] = ACTIONS(1857),
    [anon_sym_while] = ACTIONS(1857),
    [anon_sym_POUND] = ACTIONS(1855),
    [anon_sym_BANG] = ACTIONS(1855),
    [anon_sym_extern] = ACTIONS(1857),
    [anon_sym_LT] = ACTIONS(1855),
    [anon_sym_COLON_COLON] = ACTIONS(1855),
    [anon_sym_AMP] = ACTIONS(1855),
    [anon_sym_DOT_DOT] = ACTIONS(1855),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_PIPE] = ACTIONS(1855),
    [anon_sym_move] = ACTIONS(1857),
    [sym_integer_literal] = ACTIONS(1855),
    [aux_sym_string_literal_token1] = ACTIONS(1855),
    [sym_char_literal] = ACTIONS(1855),
    [anon_sym_true] = ACTIONS(1857),
    [anon_sym_false] = ACTIONS(1857),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1857),
    [sym_super] = ACTIONS(1857),
    [sym_crate] = ACTIONS(1857),
    [sym_metavariable] = ACTIONS(1855),
    [sym_raw_string_literal] = ACTIONS(1855),
    [sym_float_literal] = ACTIONS(1855),
    [sym_block_comment] = ACTIONS(3),
  },
  [383] = {
    [ts_builtin_sym_end] = ACTIONS(1859),
    [sym_identifier] = ACTIONS(1861),
    [anon_sym_SEMI] = ACTIONS(1859),
    [anon_sym_macro_rules_BANG] = ACTIONS(1859),
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_LBRACE] = ACTIONS(1859),
    [anon_sym_RBRACE] = ACTIONS(1859),
    [anon_sym_LBRACK] = ACTIONS(1859),
    [anon_sym_STAR] = ACTIONS(1859),
    [anon_sym_u8] = ACTIONS(1861),
    [anon_sym_i8] = ACTIONS(1861),
    [anon_sym_u16] = ACTIONS(1861),
    [anon_sym_i16] = ACTIONS(1861),
    [anon_sym_u32] = ACTIONS(1861),
    [anon_sym_i32] = ACTIONS(1861),
    [anon_sym_u64] = ACTIONS(1861),
    [anon_sym_i64] = ACTIONS(1861),
    [anon_sym_u128] = ACTIONS(1861),
    [anon_sym_i128] = ACTIONS(1861),
    [anon_sym_isize] = ACTIONS(1861),
    [anon_sym_usize] = ACTIONS(1861),
    [anon_sym_f32] = ACTIONS(1861),
    [anon_sym_f64] = ACTIONS(1861),
    [anon_sym_bool] = ACTIONS(1861),
    [anon_sym_str] = ACTIONS(1861),
    [anon_sym_char] = ACTIONS(1861),
    [anon_sym_SQUOTE] = ACTIONS(1861),
    [anon_sym_async] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1861),
    [anon_sym_const] = ACTIONS(1861),
    [anon_sym_continue] = ACTIONS(1861),
    [anon_sym_default] = ACTIONS(1861),
    [anon_sym_enum] = ACTIONS(1861),
    [anon_sym_fn] = ACTIONS(1861),
    [anon_sym_for] = ACTIONS(1861),
    [anon_sym_if] = ACTIONS(1861),
    [anon_sym_impl] = ACTIONS(1861),
    [anon_sym_let] = ACTIONS(1861),
    [anon_sym_loop] = ACTIONS(1861),
    [anon_sym_match] = ACTIONS(1861),
    [anon_sym_mod] = ACTIONS(1861),
    [anon_sym_pub] = ACTIONS(1861),
    [anon_sym_return] = ACTIONS(1861),
    [anon_sym_static] = ACTIONS(1861),
    [anon_sym_struct] = ACTIONS(1861),
    [anon_sym_trait] = ACTIONS(1861),
    [anon_sym_type] = ACTIONS(1861),
    [anon_sym_union] = ACTIONS(1861),
    [anon_sym_unsafe] = ACTIONS(1861),
    [anon_sym_use] = ACTIONS(1861),
    [anon_sym_while] = ACTIONS(1861),
    [anon_sym_POUND] = ACTIONS(1859),
    [anon_sym_BANG] = ACTIONS(1859),
    [anon_sym_extern] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1859),
    [anon_sym_COLON_COLON] = ACTIONS(1859),
    [anon_sym_AMP] = ACTIONS(1859),
    [anon_sym_DOT_DOT] = ACTIONS(1859),
    [anon_sym_DASH] = ACTIONS(1859),
    [anon_sym_PIPE] = ACTIONS(1859),
    [anon_sym_move] = ACTIONS(1861),
    [sym_integer_literal] = ACTIONS(1859),
    [aux_sym_string_literal_token1] = ACTIONS(1859),
    [sym_char_literal] = ACTIONS(1859),
    [anon_sym_true] = ACTIONS(1861),
    [anon_sym_false] = ACTIONS(1861),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1861),
    [sym_super] = ACTIONS(1861),
    [sym_crate] = ACTIONS(1861),
    [sym_metavariable] = ACTIONS(1859),
    [sym_raw_string_literal] = ACTIONS(1859),
    [sym_float_literal] = ACTIONS(1859),
    [sym_block_comment] = ACTIONS(3),
  },
  [384] = {
    [ts_builtin_sym_end] = ACTIONS(1863),
    [sym_identifier] = ACTIONS(1865),
    [anon_sym_SEMI] = ACTIONS(1863),
    [anon_sym_macro_rules_BANG] = ACTIONS(1863),
    [anon_sym_LPAREN] = ACTIONS(1863),
    [anon_sym_LBRACE] = ACTIONS(1863),
    [anon_sym_RBRACE] = ACTIONS(1863),
    [anon_sym_LBRACK] = ACTIONS(1863),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_u8] = ACTIONS(1865),
    [anon_sym_i8] = ACTIONS(1865),
    [anon_sym_u16] = ACTIONS(1865),
    [anon_sym_i16] = ACTIONS(1865),
    [anon_sym_u32] = ACTIONS(1865),
    [anon_sym_i32] = ACTIONS(1865),
    [anon_sym_u64] = ACTIONS(1865),
    [anon_sym_i64] = ACTIONS(1865),
    [anon_sym_u128] = ACTIONS(1865),
    [anon_sym_i128] = ACTIONS(1865),
    [anon_sym_isize] = ACTIONS(1865),
    [anon_sym_usize] = ACTIONS(1865),
    [anon_sym_f32] = ACTIONS(1865),
    [anon_sym_f64] = ACTIONS(1865),
    [anon_sym_bool] = ACTIONS(1865),
    [anon_sym_str] = ACTIONS(1865),
    [anon_sym_char] = ACTIONS(1865),
    [anon_sym_SQUOTE] = ACTIONS(1865),
    [anon_sym_async] = ACTIONS(1865),
    [anon_sym_break] = ACTIONS(1865),
    [anon_sym_const] = ACTIONS(1865),
    [anon_sym_continue] = ACTIONS(1865),
    [anon_sym_default] = ACTIONS(1865),
    [anon_sym_enum] = ACTIONS(1865),
    [anon_sym_fn] = ACTIONS(1865),
    [anon_sym_for] = ACTIONS(1865),
    [anon_sym_if] = ACTIONS(1865),
    [anon_sym_impl] = ACTIONS(1865),
    [anon_sym_let] = ACTIONS(1865),
    [anon_sym_loop] = ACTIONS(1865),
    [anon_sym_match] = ACTIONS(1865),
    [anon_sym_mod] = ACTIONS(1865),
    [anon_sym_pub] = ACTIONS(1865),
    [anon_sym_return] = ACTIONS(1865),
    [anon_sym_static] = ACTIONS(1865),
    [anon_sym_struct] = ACTIONS(1865),
    [anon_sym_trait] = ACTIONS(1865),
    [anon_sym_type] = ACTIONS(1865),
    [anon_sym_union] = ACTIONS(1865),
    [anon_sym_unsafe] = ACTIONS(1865),
    [anon_sym_use] = ACTIONS(1865),
    [anon_sym_while] = ACTIONS(1865),
    [anon_sym_POUND] = ACTIONS(1863),
    [anon_sym_BANG] = ACTIONS(1863),
    [anon_sym_extern] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_COLON_COLON] = ACTIONS(1863),
    [anon_sym_AMP] = ACTIONS(1863),
    [anon_sym_DOT_DOT] = ACTIONS(1863),
    [anon_sym_DASH] = ACTIONS(1863),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_move] = ACTIONS(1865),
    [sym_integer_literal] = ACTIONS(1863),
    [aux_sym_string_literal_token1] = ACTIONS(1863),
    [sym_char_literal] = ACTIONS(1863),
    [anon_sym_true] = ACTIONS(1865),
    [anon_sym_false] = ACTIONS(1865),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1865),
    [sym_super] = ACTIONS(1865),
    [sym_crate] = ACTIONS(1865),
    [sym_metavariable] = ACTIONS(1863),
    [sym_raw_string_literal] = ACTIONS(1863),
    [sym_float_literal] = ACTIONS(1863),
    [sym_block_comment] = ACTIONS(3),
  },
  [385] = {
    [ts_builtin_sym_end] = ACTIONS(1867),
    [sym_identifier] = ACTIONS(1869),
    [anon_sym_SEMI] = ACTIONS(1867),
    [anon_sym_macro_rules_BANG] = ACTIONS(1867),
    [anon_sym_LPAREN] = ACTIONS(1867),
    [anon_sym_LBRACE] = ACTIONS(1867),
    [anon_sym_RBRACE] = ACTIONS(1867),
    [anon_sym_LBRACK] = ACTIONS(1867),
    [anon_sym_STAR] = ACTIONS(1867),
    [anon_sym_u8] = ACTIONS(1869),
    [anon_sym_i8] = ACTIONS(1869),
    [anon_sym_u16] = ACTIONS(1869),
    [anon_sym_i16] = ACTIONS(1869),
    [anon_sym_u32] = ACTIONS(1869),
    [anon_sym_i32] = ACTIONS(1869),
    [anon_sym_u64] = ACTIONS(1869),
    [anon_sym_i64] = ACTIONS(1869),
    [anon_sym_u128] = ACTIONS(1869),
    [anon_sym_i128] = ACTIONS(1869),
    [anon_sym_isize] = ACTIONS(1869),
    [anon_sym_usize] = ACTIONS(1869),
    [anon_sym_f32] = ACTIONS(1869),
    [anon_sym_f64] = ACTIONS(1869),
    [anon_sym_bool] = ACTIONS(1869),
    [anon_sym_str] = ACTIONS(1869),
    [anon_sym_char] = ACTIONS(1869),
    [anon_sym_SQUOTE] = ACTIONS(1869),
    [anon_sym_async] = ACTIONS(1869),
    [anon_sym_break] = ACTIONS(1869),
    [anon_sym_const] = ACTIONS(1869),
    [anon_sym_continue] = ACTIONS(1869),
    [anon_sym_default] = ACTIONS(1869),
    [anon_sym_enum] = ACTIONS(1869),
    [anon_sym_fn] = ACTIONS(1869),
    [anon_sym_for] = ACTIONS(1869),
    [anon_sym_if] = ACTIONS(1869),
    [anon_sym_impl] = ACTIONS(1869),
    [anon_sym_let] = ACTIONS(1869),
    [anon_sym_loop] = ACTIONS(1869),
    [anon_sym_match] = ACTIONS(1869),
    [anon_sym_mod] = ACTIONS(1869),
    [anon_sym_pub] = ACTIONS(1869),
    [anon_sym_return] = ACTIONS(1869),
    [anon_sym_static] = ACTIONS(1869),
    [anon_sym_struct] = ACTIONS(1869),
    [anon_sym_trait] = ACTIONS(1869),
    [anon_sym_type] = ACTIONS(1869),
    [anon_sym_union] = ACTIONS(1869),
    [anon_sym_unsafe] = ACTIONS(1869),
    [anon_sym_use] = ACTIONS(1869),
    [anon_sym_while] = ACTIONS(1869),
    [anon_sym_POUND] = ACTIONS(1867),
    [anon_sym_BANG] = ACTIONS(1867),
    [anon_sym_extern] = ACTIONS(1869),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_COLON_COLON] = ACTIONS(1867),
    [anon_sym_AMP] = ACTIONS(1867),
    [anon_sym_DOT_DOT] = ACTIONS(1867),
    [anon_sym_DASH] = ACTIONS(1867),
    [anon_sym_PIPE] = ACTIONS(1867),
    [anon_sym_move] = ACTIONS(1869),
    [sym_integer_literal] = ACTIONS(1867),
    [aux_sym_string_literal_token1] = ACTIONS(1867),
    [sym_char_literal] = ACTIONS(1867),
    [anon_sym_true] = ACTIONS(1869),
    [anon_sym_false] = ACTIONS(1869),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1869),
    [sym_super] = ACTIONS(1869),
    [sym_crate] = ACTIONS(1869),
    [sym_metavariable] = ACTIONS(1867),
    [sym_raw_string_literal] = ACTIONS(1867),
    [sym_float_literal] = ACTIONS(1867),
    [sym_block_comment] = ACTIONS(3),
  },
  [386] = {
    [sym__token_pattern] = STATE(421),
    [sym_token_tree_pattern] = STATE(421),
    [sym_token_binding_pattern] = STATE(421),
    [sym_token_repetition_pattern] = STATE(421),
    [sym__literal] = STATE(421),
    [sym_string_literal] = STATE(421),
    [sym_boolean_literal] = STATE(421),
    [aux_sym_token_tree_pattern_repeat1] = STATE(421),
    [sym_identifier] = ACTIONS(1871),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_RBRACK] = ACTIONS(1873),
    [anon_sym_DOLLAR] = ACTIONS(1321),
    [anon_sym_u8] = ACTIONS(1323),
    [anon_sym_i8] = ACTIONS(1323),
    [anon_sym_u16] = ACTIONS(1323),
    [anon_sym_i16] = ACTIONS(1323),
    [anon_sym_u32] = ACTIONS(1323),
    [anon_sym_i32] = ACTIONS(1323),
    [anon_sym_u64] = ACTIONS(1323),
    [anon_sym_i64] = ACTIONS(1323),
    [anon_sym_u128] = ACTIONS(1323),
    [anon_sym_i128] = ACTIONS(1323),
    [anon_sym_isize] = ACTIONS(1323),
    [anon_sym_usize] = ACTIONS(1323),
    [anon_sym_f32] = ACTIONS(1323),
    [anon_sym_f64] = ACTIONS(1323),
    [anon_sym_bool] = ACTIONS(1323),
    [anon_sym_str] = ACTIONS(1323),
    [anon_sym_char] = ACTIONS(1323),
    [aux_sym__non_special_token_token1] = ACTIONS(1871),
    [anon_sym_SQUOTE] = ACTIONS(1871),
    [anon_sym_as] = ACTIONS(1871),
    [anon_sym_async] = ACTIONS(1871),
    [anon_sym_await] = ACTIONS(1871),
    [anon_sym_break] = ACTIONS(1871),
    [anon_sym_const] = ACTIONS(1871),
    [anon_sym_continue] = ACTIONS(1871),
    [anon_sym_default] = ACTIONS(1871),
    [anon_sym_enum] = ACTIONS(1871),
    [anon_sym_fn] = ACTIONS(1871),
    [anon_sym_for] = ACTIONS(1871),
    [anon_sym_if] = ACTIONS(1871),
    [anon_sym_impl] = ACTIONS(1871),
    [anon_sym_let] = ACTIONS(1871),
    [anon_sym_loop] = ACTIONS(1871),
    [anon_sym_match] = ACTIONS(1871),
    [anon_sym_mod] = ACTIONS(1871),
    [anon_sym_pub] = ACTIONS(1871),
    [anon_sym_return] = ACTIONS(1871),
    [anon_sym_static] = ACTIONS(1871),
    [anon_sym_struct] = ACTIONS(1871),
    [anon_sym_trait] = ACTIONS(1871),
    [anon_sym_type] = ACTIONS(1871),
    [anon_sym_union] = ACTIONS(1871),
    [anon_sym_unsafe] = ACTIONS(1871),
    [anon_sym_use] = ACTIONS(1871),
    [anon_sym_where] = ACTIONS(1871),
    [anon_sym_while] = ACTIONS(1871),
    [sym_mutable_specifier] = ACTIONS(1871),
    [sym_integer_literal] = ACTIONS(1875),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(1875),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(1871),
    [sym_super] = ACTIONS(1871),
    [sym_crate] = ACTIONS(1871),
    [sym_metavariable] = ACTIONS(1331),
    [sym_raw_string_literal] = ACTIONS(1875),
    [sym_float_literal] = ACTIONS(1875),
    [sym_block_comment] = ACTIONS(3),
  },
  [387] = {
    [ts_builtin_sym_end] = ACTIONS(1877),
    [sym_identifier] = ACTIONS(1879),
    [anon_sym_SEMI] = ACTIONS(1877),
    [anon_sym_macro_rules_BANG] = ACTIONS(1877),
    [anon_sym_LPAREN] = ACTIONS(1877),
    [anon_sym_LBRACE] = ACTIONS(1877),
    [anon_sym_RBRACE] = ACTIONS(1877),
    [anon_sym_LBRACK] = ACTIONS(1877),
    [anon_sym_STAR] = ACTIONS(1877),
    [anon_sym_u8] = ACTIONS(1879),
    [anon_sym_i8] = ACTIONS(1879),
    [anon_sym_u16] = ACTIONS(1879),
    [anon_sym_i16] = ACTIONS(1879),
    [anon_sym_u32] = ACTIONS(1879),
    [anon_sym_i32] = ACTIONS(1879),
    [anon_sym_u64] = ACTIONS(1879),
    [anon_sym_i64] = ACTIONS(1879),
    [anon_sym_u128] = ACTIONS(1879),
    [anon_sym_i128] = ACTIONS(1879),
    [anon_sym_isize] = ACTIONS(1879),
    [anon_sym_usize] = ACTIONS(1879),
    [anon_sym_f32] = ACTIONS(1879),
    [anon_sym_f64] = ACTIONS(1879),
    [anon_sym_bool] = ACTIONS(1879),
    [anon_sym_str] = ACTIONS(1879),
    [anon_sym_char] = ACTIONS(1879),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_async] = ACTIONS(1879),
    [anon_sym_break] = ACTIONS(1879),
    [anon_sym_const] = ACTIONS(1879),
    [anon_sym_continue] = ACTIONS(1879),
    [anon_sym_default] = ACTIONS(1879),
    [anon_sym_enum] = ACTIONS(1879),
    [anon_sym_fn] = ACTIONS(1879),
    [anon_sym_for] = ACTIONS(1879),
    [anon_sym_if] = ACTIONS(1879),
    [anon_sym_impl] = ACTIONS(1879),
    [anon_sym_let] = ACTIONS(1879),
    [anon_sym_loop] = ACTIONS(1879),
    [anon_sym_match] = ACTIONS(1879),
    [anon_sym_mod] = ACTIONS(1879),
    [anon_sym_pub] = ACTIONS(1879),
    [anon_sym_return] = ACTIONS(1879),
    [anon_sym_static] = ACTIONS(1879),
    [anon_sym_struct] = ACTIONS(1879),
    [anon_sym_trait] = ACTIONS(1879),
    [anon_sym_type] = ACTIONS(1879),
    [anon_sym_union] = ACTIONS(1879),
    [anon_sym_unsafe] = ACTIONS(1879),
    [anon_sym_use] = ACTIONS(1879),
    [anon_sym_while] = ACTIONS(1879),
    [anon_sym_POUND] = ACTIONS(1877),
    [anon_sym_BANG] = ACTIONS(1877),
    [anon_sym_extern] = ACTIONS(1879),
    [anon_sym_LT] = ACTIONS(1877),
    [anon_sym_COLON_COLON] = ACTIONS(1877),
    [anon_sym_AMP] = ACTIONS(1877),
    [anon_sym_DOT_DOT] = ACTIONS(1877),
    [anon_sym_DASH] = ACTIONS(1877),
    [anon_sym_PIPE] = ACTIONS(1877),
    [anon_sym_move] = ACTIONS(1879),
    [sym_integer_literal] = ACTIONS(1877),
    [aux_sym_string_literal_token1] = ACTIONS(1877),
    [sym_char_literal] = ACTIONS(1877),
    [anon_sym_true] = ACTIONS(1879),
    [anon_sym_false] = ACTIONS(1879),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1879),
    [sym_super] = ACTIONS(1879),
    [sym_crate] = ACTIONS(1879),
    [sym_metavariable] = ACTIONS(1877),
    [sym_raw_string_literal] = ACTIONS(1877),
    [sym_float_literal] = ACTIONS(1877),
    [sym_block_comment] = ACTIONS(3),
  },
  [388] = {
    [sym__token_pattern] = STATE(423),
    [sym_token_tree_pattern] = STATE(423),
    [sym_token_binding_pattern] = STATE(423),
    [sym_token_repetition_pattern] = STATE(423),
    [sym__literal] = STATE(423),
    [sym_string_literal] = STATE(423),
    [sym_boolean_literal] = STATE(423),
    [aux_sym_token_tree_pattern_repeat1] = STATE(423),
    [sym_identifier] = ACTIONS(1881),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(1873),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_DOLLAR] = ACTIONS(1321),
    [anon_sym_u8] = ACTIONS(1323),
    [anon_sym_i8] = ACTIONS(1323),
    [anon_sym_u16] = ACTIONS(1323),
    [anon_sym_i16] = ACTIONS(1323),
    [anon_sym_u32] = ACTIONS(1323),
    [anon_sym_i32] = ACTIONS(1323),
    [anon_sym_u64] = ACTIONS(1323),
    [anon_sym_i64] = ACTIONS(1323),
    [anon_sym_u128] = ACTIONS(1323),
    [anon_sym_i128] = ACTIONS(1323),
    [anon_sym_isize] = ACTIONS(1323),
    [anon_sym_usize] = ACTIONS(1323),
    [anon_sym_f32] = ACTIONS(1323),
    [anon_sym_f64] = ACTIONS(1323),
    [anon_sym_bool] = ACTIONS(1323),
    [anon_sym_str] = ACTIONS(1323),
    [anon_sym_char] = ACTIONS(1323),
    [aux_sym__non_special_token_token1] = ACTIONS(1881),
    [anon_sym_SQUOTE] = ACTIONS(1881),
    [anon_sym_as] = ACTIONS(1881),
    [anon_sym_async] = ACTIONS(1881),
    [anon_sym_await] = ACTIONS(1881),
    [anon_sym_break] = ACTIONS(1881),
    [anon_sym_const] = ACTIONS(1881),
    [anon_sym_continue] = ACTIONS(1881),
    [anon_sym_default] = ACTIONS(1881),
    [anon_sym_enum] = ACTIONS(1881),
    [anon_sym_fn] = ACTIONS(1881),
    [anon_sym_for] = ACTIONS(1881),
    [anon_sym_if] = ACTIONS(1881),
    [anon_sym_impl] = ACTIONS(1881),
    [anon_sym_let] = ACTIONS(1881),
    [anon_sym_loop] = ACTIONS(1881),
    [anon_sym_match] = ACTIONS(1881),
    [anon_sym_mod] = ACTIONS(1881),
    [anon_sym_pub] = ACTIONS(1881),
    [anon_sym_return] = ACTIONS(1881),
    [anon_sym_static] = ACTIONS(1881),
    [anon_sym_struct] = ACTIONS(1881),
    [anon_sym_trait] = ACTIONS(1881),
    [anon_sym_type] = ACTIONS(1881),
    [anon_sym_union] = ACTIONS(1881),
    [anon_sym_unsafe] = ACTIONS(1881),
    [anon_sym_use] = ACTIONS(1881),
    [anon_sym_where] = ACTIONS(1881),
    [anon_sym_while] = ACTIONS(1881),
    [sym_mutable_specifier] = ACTIONS(1881),
    [sym_integer_literal] = ACTIONS(1883),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(1883),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(1881),
    [sym_super] = ACTIONS(1881),
    [sym_crate] = ACTIONS(1881),
    [sym_metavariable] = ACTIONS(1331),
    [sym_raw_string_literal] = ACTIONS(1883),
    [sym_float_literal] = ACTIONS(1883),
    [sym_block_comment] = ACTIONS(3),
  },
  [389] = {
    [ts_builtin_sym_end] = ACTIONS(1885),
    [sym_identifier] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(1885),
    [anon_sym_macro_rules_BANG] = ACTIONS(1885),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_LBRACE] = ACTIONS(1885),
    [anon_sym_RBRACE] = ACTIONS(1885),
    [anon_sym_LBRACK] = ACTIONS(1885),
    [anon_sym_STAR] = ACTIONS(1885),
    [anon_sym_u8] = ACTIONS(1887),
    [anon_sym_i8] = ACTIONS(1887),
    [anon_sym_u16] = ACTIONS(1887),
    [anon_sym_i16] = ACTIONS(1887),
    [anon_sym_u32] = ACTIONS(1887),
    [anon_sym_i32] = ACTIONS(1887),
    [anon_sym_u64] = ACTIONS(1887),
    [anon_sym_i64] = ACTIONS(1887),
    [anon_sym_u128] = ACTIONS(1887),
    [anon_sym_i128] = ACTIONS(1887),
    [anon_sym_isize] = ACTIONS(1887),
    [anon_sym_usize] = ACTIONS(1887),
    [anon_sym_f32] = ACTIONS(1887),
    [anon_sym_f64] = ACTIONS(1887),
    [anon_sym_bool] = ACTIONS(1887),
    [anon_sym_str] = ACTIONS(1887),
    [anon_sym_char] = ACTIONS(1887),
    [anon_sym_SQUOTE] = ACTIONS(1887),
    [anon_sym_async] = ACTIONS(1887),
    [anon_sym_break] = ACTIONS(1887),
    [anon_sym_const] = ACTIONS(1887),
    [anon_sym_continue] = ACTIONS(1887),
    [anon_sym_default] = ACTIONS(1887),
    [anon_sym_enum] = ACTIONS(1887),
    [anon_sym_fn] = ACTIONS(1887),
    [anon_sym_for] = ACTIONS(1887),
    [anon_sym_if] = ACTIONS(1887),
    [anon_sym_impl] = ACTIONS(1887),
    [anon_sym_let] = ACTIONS(1887),
    [anon_sym_loop] = ACTIONS(1887),
    [anon_sym_match] = ACTIONS(1887),
    [anon_sym_mod] = ACTIONS(1887),
    [anon_sym_pub] = ACTIONS(1887),
    [anon_sym_return] = ACTIONS(1887),
    [anon_sym_static] = ACTIONS(1887),
    [anon_sym_struct] = ACTIONS(1887),
    [anon_sym_trait] = ACTIONS(1887),
    [anon_sym_type] = ACTIONS(1887),
    [anon_sym_union] = ACTIONS(1887),
    [anon_sym_unsafe] = ACTIONS(1887),
    [anon_sym_use] = ACTIONS(1887),
    [anon_sym_while] = ACTIONS(1887),
    [anon_sym_POUND] = ACTIONS(1885),
    [anon_sym_BANG] = ACTIONS(1885),
    [anon_sym_extern] = ACTIONS(1887),
    [anon_sym_LT] = ACTIONS(1885),
    [anon_sym_COLON_COLON] = ACTIONS(1885),
    [anon_sym_AMP] = ACTIONS(1885),
    [anon_sym_DOT_DOT] = ACTIONS(1885),
    [anon_sym_DASH] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1885),
    [anon_sym_move] = ACTIONS(1887),
    [sym_integer_literal] = ACTIONS(1885),
    [aux_sym_string_literal_token1] = ACTIONS(1885),
    [sym_char_literal] = ACTIONS(1885),
    [anon_sym_true] = ACTIONS(1887),
    [anon_sym_false] = ACTIONS(1887),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1887),
    [sym_super] = ACTIONS(1887),
    [sym_crate] = ACTIONS(1887),
    [sym_metavariable] = ACTIONS(1885),
    [sym_raw_string_literal] = ACTIONS(1885),
    [sym_float_literal] = ACTIONS(1885),
    [sym_block_comment] = ACTIONS(3),
  },
  [390] = {
    [ts_builtin_sym_end] = ACTIONS(1889),
    [sym_identifier] = ACTIONS(1891),
    [anon_sym_SEMI] = ACTIONS(1889),
    [anon_sym_macro_rules_BANG] = ACTIONS(1889),
    [anon_sym_LPAREN] = ACTIONS(1889),
    [anon_sym_LBRACE] = ACTIONS(1889),
    [anon_sym_RBRACE] = ACTIONS(1889),
    [anon_sym_LBRACK] = ACTIONS(1889),
    [anon_sym_STAR] = ACTIONS(1889),
    [anon_sym_u8] = ACTIONS(1891),
    [anon_sym_i8] = ACTIONS(1891),
    [anon_sym_u16] = ACTIONS(1891),
    [anon_sym_i16] = ACTIONS(1891),
    [anon_sym_u32] = ACTIONS(1891),
    [anon_sym_i32] = ACTIONS(1891),
    [anon_sym_u64] = ACTIONS(1891),
    [anon_sym_i64] = ACTIONS(1891),
    [anon_sym_u128] = ACTIONS(1891),
    [anon_sym_i128] = ACTIONS(1891),
    [anon_sym_isize] = ACTIONS(1891),
    [anon_sym_usize] = ACTIONS(1891),
    [anon_sym_f32] = ACTIONS(1891),
    [anon_sym_f64] = ACTIONS(1891),
    [anon_sym_bool] = ACTIONS(1891),
    [anon_sym_str] = ACTIONS(1891),
    [anon_sym_char] = ACTIONS(1891),
    [anon_sym_SQUOTE] = ACTIONS(1891),
    [anon_sym_async] = ACTIONS(1891),
    [anon_sym_break] = ACTIONS(1891),
    [anon_sym_const] = ACTIONS(1891),
    [anon_sym_continue] = ACTIONS(1891),
    [anon_sym_default] = ACTIONS(1891),
    [anon_sym_enum] = ACTIONS(1891),
    [anon_sym_fn] = ACTIONS(1891),
    [anon_sym_for] = ACTIONS(1891),
    [anon_sym_if] = ACTIONS(1891),
    [anon_sym_impl] = ACTIONS(1891),
    [anon_sym_let] = ACTIONS(1891),
    [anon_sym_loop] = ACTIONS(1891),
    [anon_sym_match] = ACTIONS(1891),
    [anon_sym_mod] = ACTIONS(1891),
    [anon_sym_pub] = ACTIONS(1891),
    [anon_sym_return] = ACTIONS(1891),
    [anon_sym_static] = ACTIONS(1891),
    [anon_sym_struct] = ACTIONS(1891),
    [anon_sym_trait] = ACTIONS(1891),
    [anon_sym_type] = ACTIONS(1891),
    [anon_sym_union] = ACTIONS(1891),
    [anon_sym_unsafe] = ACTIONS(1891),
    [anon_sym_use] = ACTIONS(1891),
    [anon_sym_while] = ACTIONS(1891),
    [anon_sym_POUND] = ACTIONS(1889),
    [anon_sym_BANG] = ACTIONS(1889),
    [anon_sym_extern] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1889),
    [anon_sym_COLON_COLON] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1889),
    [anon_sym_DOT_DOT] = ACTIONS(1889),
    [anon_sym_DASH] = ACTIONS(1889),
    [anon_sym_PIPE] = ACTIONS(1889),
    [anon_sym_move] = ACTIONS(1891),
    [sym_integer_literal] = ACTIONS(1889),
    [aux_sym_string_literal_token1] = ACTIONS(1889),
    [sym_char_literal] = ACTIONS(1889),
    [anon_sym_true] = ACTIONS(1891),
    [anon_sym_false] = ACTIONS(1891),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1891),
    [sym_super] = ACTIONS(1891),
    [sym_crate] = ACTIONS(1891),
    [sym_metavariable] = ACTIONS(1889),
    [sym_raw_string_literal] = ACTIONS(1889),
    [sym_float_literal] = ACTIONS(1889),
    [sym_block_comment] = ACTIONS(3),
  },
  [391] = {
    [ts_builtin_sym_end] = ACTIONS(1893),
    [sym_identifier] = ACTIONS(1895),
    [anon_sym_SEMI] = ACTIONS(1893),
    [anon_sym_macro_rules_BANG] = ACTIONS(1893),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_LBRACE] = ACTIONS(1893),
    [anon_sym_RBRACE] = ACTIONS(1893),
    [anon_sym_LBRACK] = ACTIONS(1893),
    [anon_sym_STAR] = ACTIONS(1893),
    [anon_sym_u8] = ACTIONS(1895),
    [anon_sym_i8] = ACTIONS(1895),
    [anon_sym_u16] = ACTIONS(1895),
    [anon_sym_i16] = ACTIONS(1895),
    [anon_sym_u32] = ACTIONS(1895),
    [anon_sym_i32] = ACTIONS(1895),
    [anon_sym_u64] = ACTIONS(1895),
    [anon_sym_i64] = ACTIONS(1895),
    [anon_sym_u128] = ACTIONS(1895),
    [anon_sym_i128] = ACTIONS(1895),
    [anon_sym_isize] = ACTIONS(1895),
    [anon_sym_usize] = ACTIONS(1895),
    [anon_sym_f32] = ACTIONS(1895),
    [anon_sym_f64] = ACTIONS(1895),
    [anon_sym_bool] = ACTIONS(1895),
    [anon_sym_str] = ACTIONS(1895),
    [anon_sym_char] = ACTIONS(1895),
    [anon_sym_SQUOTE] = ACTIONS(1895),
    [anon_sym_async] = ACTIONS(1895),
    [anon_sym_break] = ACTIONS(1895),
    [anon_sym_const] = ACTIONS(1895),
    [anon_sym_continue] = ACTIONS(1895),
    [anon_sym_default] = ACTIONS(1895),
    [anon_sym_enum] = ACTIONS(1895),
    [anon_sym_fn] = ACTIONS(1895),
    [anon_sym_for] = ACTIONS(1895),
    [anon_sym_if] = ACTIONS(1895),
    [anon_sym_impl] = ACTIONS(1895),
    [anon_sym_let] = ACTIONS(1895),
    [anon_sym_loop] = ACTIONS(1895),
    [anon_sym_match] = ACTIONS(1895),
    [anon_sym_mod] = ACTIONS(1895),
    [anon_sym_pub] = ACTIONS(1895),
    [anon_sym_return] = ACTIONS(1895),
    [anon_sym_static] = ACTIONS(1895),
    [anon_sym_struct] = ACTIONS(1895),
    [anon_sym_trait] = ACTIONS(1895),
    [anon_sym_type] = ACTIONS(1895),
    [anon_sym_union] = ACTIONS(1895),
    [anon_sym_unsafe] = ACTIONS(1895),
    [anon_sym_use] = ACTIONS(1895),
    [anon_sym_while] = ACTIONS(1895),
    [anon_sym_POUND] = ACTIONS(1893),
    [anon_sym_BANG] = ACTIONS(1893),
    [anon_sym_extern] = ACTIONS(1895),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_COLON_COLON] = ACTIONS(1893),
    [anon_sym_AMP] = ACTIONS(1893),
    [anon_sym_DOT_DOT] = ACTIONS(1893),
    [anon_sym_DASH] = ACTIONS(1893),
    [anon_sym_PIPE] = ACTIONS(1893),
    [anon_sym_move] = ACTIONS(1895),
    [sym_integer_literal] = ACTIONS(1893),
    [aux_sym_string_literal_token1] = ACTIONS(1893),
    [sym_char_literal] = ACTIONS(1893),
    [anon_sym_true] = ACTIONS(1895),
    [anon_sym_false] = ACTIONS(1895),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1895),
    [sym_super] = ACTIONS(1895),
    [sym_crate] = ACTIONS(1895),
    [sym_metavariable] = ACTIONS(1893),
    [sym_raw_string_literal] = ACTIONS(1893),
    [sym_float_literal] = ACTIONS(1893),
    [sym_block_comment] = ACTIONS(3),
  },
  [392] = {
    [sym__token_pattern] = STATE(425),
    [sym_token_tree_pattern] = STATE(425),
    [sym_token_binding_pattern] = STATE(425),
    [sym_token_repetition_pattern] = STATE(425),
    [sym__literal] = STATE(425),
    [sym_string_literal] = STATE(425),
    [sym_boolean_literal] = STATE(425),
    [aux_sym_token_tree_pattern_repeat1] = STATE(425),
    [sym_identifier] = ACTIONS(1897),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_RPAREN] = ACTIONS(1873),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_DOLLAR] = ACTIONS(1321),
    [anon_sym_u8] = ACTIONS(1323),
    [anon_sym_i8] = ACTIONS(1323),
    [anon_sym_u16] = ACTIONS(1323),
    [anon_sym_i16] = ACTIONS(1323),
    [anon_sym_u32] = ACTIONS(1323),
    [anon_sym_i32] = ACTIONS(1323),
    [anon_sym_u64] = ACTIONS(1323),
    [anon_sym_i64] = ACTIONS(1323),
    [anon_sym_u128] = ACTIONS(1323),
    [anon_sym_i128] = ACTIONS(1323),
    [anon_sym_isize] = ACTIONS(1323),
    [anon_sym_usize] = ACTIONS(1323),
    [anon_sym_f32] = ACTIONS(1323),
    [anon_sym_f64] = ACTIONS(1323),
    [anon_sym_bool] = ACTIONS(1323),
    [anon_sym_str] = ACTIONS(1323),
    [anon_sym_char] = ACTIONS(1323),
    [aux_sym__non_special_token_token1] = ACTIONS(1897),
    [anon_sym_SQUOTE] = ACTIONS(1897),
    [anon_sym_as] = ACTIONS(1897),
    [anon_sym_async] = ACTIONS(1897),
    [anon_sym_await] = ACTIONS(1897),
    [anon_sym_break] = ACTIONS(1897),
    [anon_sym_const] = ACTIONS(1897),
    [anon_sym_continue] = ACTIONS(1897),
    [anon_sym_default] = ACTIONS(1897),
    [anon_sym_enum] = ACTIONS(1897),
    [anon_sym_fn] = ACTIONS(1897),
    [anon_sym_for] = ACTIONS(1897),
    [anon_sym_if] = ACTIONS(1897),
    [anon_sym_impl] = ACTIONS(1897),
    [anon_sym_let] = ACTIONS(1897),
    [anon_sym_loop] = ACTIONS(1897),
    [anon_sym_match] = ACTIONS(1897),
    [anon_sym_mod] = ACTIONS(1897),
    [anon_sym_pub] = ACTIONS(1897),
    [anon_sym_return] = ACTIONS(1897),
    [anon_sym_static] = ACTIONS(1897),
    [anon_sym_struct] = ACTIONS(1897),
    [anon_sym_trait] = ACTIONS(1897),
    [anon_sym_type] = ACTIONS(1897),
    [anon_sym_union] = ACTIONS(1897),
    [anon_sym_unsafe] = ACTIONS(1897),
    [anon_sym_use] = ACTIONS(1897),
    [anon_sym_where] = ACTIONS(1897),
    [anon_sym_while] = ACTIONS(1897),
    [sym_mutable_specifier] = ACTIONS(1897),
    [sym_integer_literal] = ACTIONS(1899),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(1899),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(1897),
    [sym_super] = ACTIONS(1897),
    [sym_crate] = ACTIONS(1897),
    [sym_metavariable] = ACTIONS(1331),
    [sym_raw_string_literal] = ACTIONS(1899),
    [sym_float_literal] = ACTIONS(1899),
    [sym_block_comment] = ACTIONS(3),
  },
  [393] = {
    [ts_builtin_sym_end] = ACTIONS(1901),
    [sym_identifier] = ACTIONS(1903),
    [anon_sym_SEMI] = ACTIONS(1901),
    [anon_sym_macro_rules_BANG] = ACTIONS(1901),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_LBRACE] = ACTIONS(1901),
    [anon_sym_RBRACE] = ACTIONS(1901),
    [anon_sym_LBRACK] = ACTIONS(1901),
    [anon_sym_STAR] = ACTIONS(1901),
    [anon_sym_u8] = ACTIONS(1903),
    [anon_sym_i8] = ACTIONS(1903),
    [anon_sym_u16] = ACTIONS(1903),
    [anon_sym_i16] = ACTIONS(1903),
    [anon_sym_u32] = ACTIONS(1903),
    [anon_sym_i32] = ACTIONS(1903),
    [anon_sym_u64] = ACTIONS(1903),
    [anon_sym_i64] = ACTIONS(1903),
    [anon_sym_u128] = ACTIONS(1903),
    [anon_sym_i128] = ACTIONS(1903),
    [anon_sym_isize] = ACTIONS(1903),
    [anon_sym_usize] = ACTIONS(1903),
    [anon_sym_f32] = ACTIONS(1903),
    [anon_sym_f64] = ACTIONS(1903),
    [anon_sym_bool] = ACTIONS(1903),
    [anon_sym_str] = ACTIONS(1903),
    [anon_sym_char] = ACTIONS(1903),
    [anon_sym_SQUOTE] = ACTIONS(1903),
    [anon_sym_async] = ACTIONS(1903),
    [anon_sym_break] = ACTIONS(1903),
    [anon_sym_const] = ACTIONS(1903),
    [anon_sym_continue] = ACTIONS(1903),
    [anon_sym_default] = ACTIONS(1903),
    [anon_sym_enum] = ACTIONS(1903),
    [anon_sym_fn] = ACTIONS(1903),
    [anon_sym_for] = ACTIONS(1903),
    [anon_sym_if] = ACTIONS(1903),
    [anon_sym_impl] = ACTIONS(1903),
    [anon_sym_let] = ACTIONS(1903),
    [anon_sym_loop] = ACTIONS(1903),
    [anon_sym_match] = ACTIONS(1903),
    [anon_sym_mod] = ACTIONS(1903),
    [anon_sym_pub] = ACTIONS(1903),
    [anon_sym_return] = ACTIONS(1903),
    [anon_sym_static] = ACTIONS(1903),
    [anon_sym_struct] = ACTIONS(1903),
    [anon_sym_trait] = ACTIONS(1903),
    [anon_sym_type] = ACTIONS(1903),
    [anon_sym_union] = ACTIONS(1903),
    [anon_sym_unsafe] = ACTIONS(1903),
    [anon_sym_use] = ACTIONS(1903),
    [anon_sym_while] = ACTIONS(1903),
    [anon_sym_POUND] = ACTIONS(1901),
    [anon_sym_BANG] = ACTIONS(1901),
    [anon_sym_extern] = ACTIONS(1903),
    [anon_sym_LT] = ACTIONS(1901),
    [anon_sym_COLON_COLON] = ACTIONS(1901),
    [anon_sym_AMP] = ACTIONS(1901),
    [anon_sym_DOT_DOT] = ACTIONS(1901),
    [anon_sym_DASH] = ACTIONS(1901),
    [anon_sym_PIPE] = ACTIONS(1901),
    [anon_sym_move] = ACTIONS(1903),
    [sym_integer_literal] = ACTIONS(1901),
    [aux_sym_string_literal_token1] = ACTIONS(1901),
    [sym_char_literal] = ACTIONS(1901),
    [anon_sym_true] = ACTIONS(1903),
    [anon_sym_false] = ACTIONS(1903),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1903),
    [sym_super] = ACTIONS(1903),
    [sym_crate] = ACTIONS(1903),
    [sym_metavariable] = ACTIONS(1901),
    [sym_raw_string_literal] = ACTIONS(1901),
    [sym_float_literal] = ACTIONS(1901),
    [sym_block_comment] = ACTIONS(3),
  },
  [394] = {
    [ts_builtin_sym_end] = ACTIONS(1905),
    [sym_identifier] = ACTIONS(1907),
    [anon_sym_SEMI] = ACTIONS(1905),
    [anon_sym_macro_rules_BANG] = ACTIONS(1905),
    [anon_sym_LPAREN] = ACTIONS(1905),
    [anon_sym_LBRACE] = ACTIONS(1905),
    [anon_sym_RBRACE] = ACTIONS(1905),
    [anon_sym_LBRACK] = ACTIONS(1905),
    [anon_sym_STAR] = ACTIONS(1905),
    [anon_sym_u8] = ACTIONS(1907),
    [anon_sym_i8] = ACTIONS(1907),
    [anon_sym_u16] = ACTIONS(1907),
    [anon_sym_i16] = ACTIONS(1907),
    [anon_sym_u32] = ACTIONS(1907),
    [anon_sym_i32] = ACTIONS(1907),
    [anon_sym_u64] = ACTIONS(1907),
    [anon_sym_i64] = ACTIONS(1907),
    [anon_sym_u128] = ACTIONS(1907),
    [anon_sym_i128] = ACTIONS(1907),
    [anon_sym_isize] = ACTIONS(1907),
    [anon_sym_usize] = ACTIONS(1907),
    [anon_sym_f32] = ACTIONS(1907),
    [anon_sym_f64] = ACTIONS(1907),
    [anon_sym_bool] = ACTIONS(1907),
    [anon_sym_str] = ACTIONS(1907),
    [anon_sym_char] = ACTIONS(1907),
    [anon_sym_SQUOTE] = ACTIONS(1907),
    [anon_sym_async] = ACTIONS(1907),
    [anon_sym_break] = ACTIONS(1907),
    [anon_sym_const] = ACTIONS(1907),
    [anon_sym_continue] = ACTIONS(1907),
    [anon_sym_default] = ACTIONS(1907),
    [anon_sym_enum] = ACTIONS(1907),
    [anon_sym_fn] = ACTIONS(1907),
    [anon_sym_for] = ACTIONS(1907),
    [anon_sym_if] = ACTIONS(1907),
    [anon_sym_impl] = ACTIONS(1907),
    [anon_sym_let] = ACTIONS(1907),
    [anon_sym_loop] = ACTIONS(1907),
    [anon_sym_match] = ACTIONS(1907),
    [anon_sym_mod] = ACTIONS(1907),
    [anon_sym_pub] = ACTIONS(1907),
    [anon_sym_return] = ACTIONS(1907),
    [anon_sym_static] = ACTIONS(1907),
    [anon_sym_struct] = ACTIONS(1907),
    [anon_sym_trait] = ACTIONS(1907),
    [anon_sym_type] = ACTIONS(1907),
    [anon_sym_union] = ACTIONS(1907),
    [anon_sym_unsafe] = ACTIONS(1907),
    [anon_sym_use] = ACTIONS(1907),
    [anon_sym_while] = ACTIONS(1907),
    [anon_sym_POUND] = ACTIONS(1905),
    [anon_sym_BANG] = ACTIONS(1905),
    [anon_sym_extern] = ACTIONS(1907),
    [anon_sym_LT] = ACTIONS(1905),
    [anon_sym_COLON_COLON] = ACTIONS(1905),
    [anon_sym_AMP] = ACTIONS(1905),
    [anon_sym_DOT_DOT] = ACTIONS(1905),
    [anon_sym_DASH] = ACTIONS(1905),
    [anon_sym_PIPE] = ACTIONS(1905),
    [anon_sym_move] = ACTIONS(1907),
    [sym_integer_literal] = ACTIONS(1905),
    [aux_sym_string_literal_token1] = ACTIONS(1905),
    [sym_char_literal] = ACTIONS(1905),
    [anon_sym_true] = ACTIONS(1907),
    [anon_sym_false] = ACTIONS(1907),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1907),
    [sym_super] = ACTIONS(1907),
    [sym_crate] = ACTIONS(1907),
    [sym_metavariable] = ACTIONS(1905),
    [sym_raw_string_literal] = ACTIONS(1905),
    [sym_float_literal] = ACTIONS(1905),
    [sym_block_comment] = ACTIONS(3),
  },
  [395] = {
    [ts_builtin_sym_end] = ACTIONS(1909),
    [sym_identifier] = ACTIONS(1911),
    [anon_sym_SEMI] = ACTIONS(1909),
    [anon_sym_macro_rules_BANG] = ACTIONS(1909),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_LBRACE] = ACTIONS(1909),
    [anon_sym_RBRACE] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(1909),
    [anon_sym_STAR] = ACTIONS(1909),
    [anon_sym_u8] = ACTIONS(1911),
    [anon_sym_i8] = ACTIONS(1911),
    [anon_sym_u16] = ACTIONS(1911),
    [anon_sym_i16] = ACTIONS(1911),
    [anon_sym_u32] = ACTIONS(1911),
    [anon_sym_i32] = ACTIONS(1911),
    [anon_sym_u64] = ACTIONS(1911),
    [anon_sym_i64] = ACTIONS(1911),
    [anon_sym_u128] = ACTIONS(1911),
    [anon_sym_i128] = ACTIONS(1911),
    [anon_sym_isize] = ACTIONS(1911),
    [anon_sym_usize] = ACTIONS(1911),
    [anon_sym_f32] = ACTIONS(1911),
    [anon_sym_f64] = ACTIONS(1911),
    [anon_sym_bool] = ACTIONS(1911),
    [anon_sym_str] = ACTIONS(1911),
    [anon_sym_char] = ACTIONS(1911),
    [anon_sym_SQUOTE] = ACTIONS(1911),
    [anon_sym_async] = ACTIONS(1911),
    [anon_sym_break] = ACTIONS(1911),
    [anon_sym_const] = ACTIONS(1911),
    [anon_sym_continue] = ACTIONS(1911),
    [anon_sym_default] = ACTIONS(1911),
    [anon_sym_enum] = ACTIONS(1911),
    [anon_sym_fn] = ACTIONS(1911),
    [anon_sym_for] = ACTIONS(1911),
    [anon_sym_if] = ACTIONS(1911),
    [anon_sym_impl] = ACTIONS(1911),
    [anon_sym_let] = ACTIONS(1911),
    [anon_sym_loop] = ACTIONS(1911),
    [anon_sym_match] = ACTIONS(1911),
    [anon_sym_mod] = ACTIONS(1911),
    [anon_sym_pub] = ACTIONS(1911),
    [anon_sym_return] = ACTIONS(1911),
    [anon_sym_static] = ACTIONS(1911),
    [anon_sym_struct] = ACTIONS(1911),
    [anon_sym_trait] = ACTIONS(1911),
    [anon_sym_type] = ACTIONS(1911),
    [anon_sym_union] = ACTIONS(1911),
    [anon_sym_unsafe] = ACTIONS(1911),
    [anon_sym_use] = ACTIONS(1911),
    [anon_sym_while] = ACTIONS(1911),
    [anon_sym_POUND] = ACTIONS(1909),
    [anon_sym_BANG] = ACTIONS(1909),
    [anon_sym_extern] = ACTIONS(1911),
    [anon_sym_LT] = ACTIONS(1909),
    [anon_sym_COLON_COLON] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(1909),
    [anon_sym_DOT_DOT] = ACTIONS(1909),
    [anon_sym_DASH] = ACTIONS(1909),
    [anon_sym_PIPE] = ACTIONS(1909),
    [anon_sym_move] = ACTIONS(1911),
    [sym_integer_literal] = ACTIONS(1909),
    [aux_sym_string_literal_token1] = ACTIONS(1909),
    [sym_char_literal] = ACTIONS(1909),
    [anon_sym_true] = ACTIONS(1911),
    [anon_sym_false] = ACTIONS(1911),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1911),
    [sym_super] = ACTIONS(1911),
    [sym_crate] = ACTIONS(1911),
    [sym_metavariable] = ACTIONS(1909),
    [sym_raw_string_literal] = ACTIONS(1909),
    [sym_float_literal] = ACTIONS(1909),
    [sym_block_comment] = ACTIONS(3),
  },
  [396] = {
    [ts_builtin_sym_end] = ACTIONS(1913),
    [sym_identifier] = ACTIONS(1915),
    [anon_sym_SEMI] = ACTIONS(1913),
    [anon_sym_macro_rules_BANG] = ACTIONS(1913),
    [anon_sym_LPAREN] = ACTIONS(1913),
    [anon_sym_LBRACE] = ACTIONS(1913),
    [anon_sym_RBRACE] = ACTIONS(1913),
    [anon_sym_LBRACK] = ACTIONS(1913),
    [anon_sym_STAR] = ACTIONS(1913),
    [anon_sym_u8] = ACTIONS(1915),
    [anon_sym_i8] = ACTIONS(1915),
    [anon_sym_u16] = ACTIONS(1915),
    [anon_sym_i16] = ACTIONS(1915),
    [anon_sym_u32] = ACTIONS(1915),
    [anon_sym_i32] = ACTIONS(1915),
    [anon_sym_u64] = ACTIONS(1915),
    [anon_sym_i64] = ACTIONS(1915),
    [anon_sym_u128] = ACTIONS(1915),
    [anon_sym_i128] = ACTIONS(1915),
    [anon_sym_isize] = ACTIONS(1915),
    [anon_sym_usize] = ACTIONS(1915),
    [anon_sym_f32] = ACTIONS(1915),
    [anon_sym_f64] = ACTIONS(1915),
    [anon_sym_bool] = ACTIONS(1915),
    [anon_sym_str] = ACTIONS(1915),
    [anon_sym_char] = ACTIONS(1915),
    [anon_sym_SQUOTE] = ACTIONS(1915),
    [anon_sym_async] = ACTIONS(1915),
    [anon_sym_break] = ACTIONS(1915),
    [anon_sym_const] = ACTIONS(1915),
    [anon_sym_continue] = ACTIONS(1915),
    [anon_sym_default] = ACTIONS(1915),
    [anon_sym_enum] = ACTIONS(1915),
    [anon_sym_fn] = ACTIONS(1915),
    [anon_sym_for] = ACTIONS(1915),
    [anon_sym_if] = ACTIONS(1915),
    [anon_sym_impl] = ACTIONS(1915),
    [anon_sym_let] = ACTIONS(1915),
    [anon_sym_loop] = ACTIONS(1915),
    [anon_sym_match] = ACTIONS(1915),
    [anon_sym_mod] = ACTIONS(1915),
    [anon_sym_pub] = ACTIONS(1915),
    [anon_sym_return] = ACTIONS(1915),
    [anon_sym_static] = ACTIONS(1915),
    [anon_sym_struct] = ACTIONS(1915),
    [anon_sym_trait] = ACTIONS(1915),
    [anon_sym_type] = ACTIONS(1915),
    [anon_sym_union] = ACTIONS(1915),
    [anon_sym_unsafe] = ACTIONS(1915),
    [anon_sym_use] = ACTIONS(1915),
    [anon_sym_while] = ACTIONS(1915),
    [anon_sym_POUND] = ACTIONS(1913),
    [anon_sym_BANG] = ACTIONS(1913),
    [anon_sym_extern] = ACTIONS(1915),
    [anon_sym_LT] = ACTIONS(1913),
    [anon_sym_COLON_COLON] = ACTIONS(1913),
    [anon_sym_AMP] = ACTIONS(1913),
    [anon_sym_DOT_DOT] = ACTIONS(1913),
    [anon_sym_DASH] = ACTIONS(1913),
    [anon_sym_PIPE] = ACTIONS(1913),
    [anon_sym_move] = ACTIONS(1915),
    [sym_integer_literal] = ACTIONS(1913),
    [aux_sym_string_literal_token1] = ACTIONS(1913),
    [sym_char_literal] = ACTIONS(1913),
    [anon_sym_true] = ACTIONS(1915),
    [anon_sym_false] = ACTIONS(1915),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1915),
    [sym_super] = ACTIONS(1915),
    [sym_crate] = ACTIONS(1915),
    [sym_metavariable] = ACTIONS(1913),
    [sym_raw_string_literal] = ACTIONS(1913),
    [sym_float_literal] = ACTIONS(1913),
    [sym_block_comment] = ACTIONS(3),
  },
  [397] = {
    [ts_builtin_sym_end] = ACTIONS(1917),
    [sym_identifier] = ACTIONS(1919),
    [anon_sym_SEMI] = ACTIONS(1917),
    [anon_sym_macro_rules_BANG] = ACTIONS(1917),
    [anon_sym_LPAREN] = ACTIONS(1917),
    [anon_sym_LBRACE] = ACTIONS(1917),
    [anon_sym_RBRACE] = ACTIONS(1917),
    [anon_sym_LBRACK] = ACTIONS(1917),
    [anon_sym_STAR] = ACTIONS(1917),
    [anon_sym_u8] = ACTIONS(1919),
    [anon_sym_i8] = ACTIONS(1919),
    [anon_sym_u16] = ACTIONS(1919),
    [anon_sym_i16] = ACTIONS(1919),
    [anon_sym_u32] = ACTIONS(1919),
    [anon_sym_i32] = ACTIONS(1919),
    [anon_sym_u64] = ACTIONS(1919),
    [anon_sym_i64] = ACTIONS(1919),
    [anon_sym_u128] = ACTIONS(1919),
    [anon_sym_i128] = ACTIONS(1919),
    [anon_sym_isize] = ACTIONS(1919),
    [anon_sym_usize] = ACTIONS(1919),
    [anon_sym_f32] = ACTIONS(1919),
    [anon_sym_f64] = ACTIONS(1919),
    [anon_sym_bool] = ACTIONS(1919),
    [anon_sym_str] = ACTIONS(1919),
    [anon_sym_char] = ACTIONS(1919),
    [anon_sym_SQUOTE] = ACTIONS(1919),
    [anon_sym_async] = ACTIONS(1919),
    [anon_sym_break] = ACTIONS(1919),
    [anon_sym_const] = ACTIONS(1919),
    [anon_sym_continue] = ACTIONS(1919),
    [anon_sym_default] = ACTIONS(1919),
    [anon_sym_enum] = ACTIONS(1919),
    [anon_sym_fn] = ACTIONS(1919),
    [anon_sym_for] = ACTIONS(1919),
    [anon_sym_if] = ACTIONS(1919),
    [anon_sym_impl] = ACTIONS(1919),
    [anon_sym_let] = ACTIONS(1919),
    [anon_sym_loop] = ACTIONS(1919),
    [anon_sym_match] = ACTIONS(1919),
    [anon_sym_mod] = ACTIONS(1919),
    [anon_sym_pub] = ACTIONS(1919),
    [anon_sym_return] = ACTIONS(1919),
    [anon_sym_static] = ACTIONS(1919),
    [anon_sym_struct] = ACTIONS(1919),
    [anon_sym_trait] = ACTIONS(1919),
    [anon_sym_type] = ACTIONS(1919),
    [anon_sym_union] = ACTIONS(1919),
    [anon_sym_unsafe] = ACTIONS(1919),
    [anon_sym_use] = ACTIONS(1919),
    [anon_sym_while] = ACTIONS(1919),
    [anon_sym_POUND] = ACTIONS(1917),
    [anon_sym_BANG] = ACTIONS(1917),
    [anon_sym_extern] = ACTIONS(1919),
    [anon_sym_LT] = ACTIONS(1917),
    [anon_sym_COLON_COLON] = ACTIONS(1917),
    [anon_sym_AMP] = ACTIONS(1917),
    [anon_sym_DOT_DOT] = ACTIONS(1917),
    [anon_sym_DASH] = ACTIONS(1917),
    [anon_sym_PIPE] = ACTIONS(1917),
    [anon_sym_move] = ACTIONS(1919),
    [sym_integer_literal] = ACTIONS(1917),
    [aux_sym_string_literal_token1] = ACTIONS(1917),
    [sym_char_literal] = ACTIONS(1917),
    [anon_sym_true] = ACTIONS(1919),
    [anon_sym_false] = ACTIONS(1919),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1919),
    [sym_super] = ACTIONS(1919),
    [sym_crate] = ACTIONS(1919),
    [sym_metavariable] = ACTIONS(1917),
    [sym_raw_string_literal] = ACTIONS(1917),
    [sym_float_literal] = ACTIONS(1917),
    [sym_block_comment] = ACTIONS(3),
  },
  [398] = {
    [ts_builtin_sym_end] = ACTIONS(1921),
    [sym_identifier] = ACTIONS(1923),
    [anon_sym_SEMI] = ACTIONS(1921),
    [anon_sym_macro_rules_BANG] = ACTIONS(1921),
    [anon_sym_LPAREN] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1921),
    [anon_sym_RBRACE] = ACTIONS(1921),
    [anon_sym_LBRACK] = ACTIONS(1921),
    [anon_sym_STAR] = ACTIONS(1921),
    [anon_sym_u8] = ACTIONS(1923),
    [anon_sym_i8] = ACTIONS(1923),
    [anon_sym_u16] = ACTIONS(1923),
    [anon_sym_i16] = ACTIONS(1923),
    [anon_sym_u32] = ACTIONS(1923),
    [anon_sym_i32] = ACTIONS(1923),
    [anon_sym_u64] = ACTIONS(1923),
    [anon_sym_i64] = ACTIONS(1923),
    [anon_sym_u128] = ACTIONS(1923),
    [anon_sym_i128] = ACTIONS(1923),
    [anon_sym_isize] = ACTIONS(1923),
    [anon_sym_usize] = ACTIONS(1923),
    [anon_sym_f32] = ACTIONS(1923),
    [anon_sym_f64] = ACTIONS(1923),
    [anon_sym_bool] = ACTIONS(1923),
    [anon_sym_str] = ACTIONS(1923),
    [anon_sym_char] = ACTIONS(1923),
    [anon_sym_SQUOTE] = ACTIONS(1923),
    [anon_sym_async] = ACTIONS(1923),
    [anon_sym_break] = ACTIONS(1923),
    [anon_sym_const] = ACTIONS(1923),
    [anon_sym_continue] = ACTIONS(1923),
    [anon_sym_default] = ACTIONS(1923),
    [anon_sym_enum] = ACTIONS(1923),
    [anon_sym_fn] = ACTIONS(1923),
    [anon_sym_for] = ACTIONS(1923),
    [anon_sym_if] = ACTIONS(1923),
    [anon_sym_impl] = ACTIONS(1923),
    [anon_sym_let] = ACTIONS(1923),
    [anon_sym_loop] = ACTIONS(1923),
    [anon_sym_match] = ACTIONS(1923),
    [anon_sym_mod] = ACTIONS(1923),
    [anon_sym_pub] = ACTIONS(1923),
    [anon_sym_return] = ACTIONS(1923),
    [anon_sym_static] = ACTIONS(1923),
    [anon_sym_struct] = ACTIONS(1923),
    [anon_sym_trait] = ACTIONS(1923),
    [anon_sym_type] = ACTIONS(1923),
    [anon_sym_union] = ACTIONS(1923),
    [anon_sym_unsafe] = ACTIONS(1923),
    [anon_sym_use] = ACTIONS(1923),
    [anon_sym_while] = ACTIONS(1923),
    [anon_sym_POUND] = ACTIONS(1921),
    [anon_sym_BANG] = ACTIONS(1921),
    [anon_sym_extern] = ACTIONS(1923),
    [anon_sym_LT] = ACTIONS(1921),
    [anon_sym_COLON_COLON] = ACTIONS(1921),
    [anon_sym_AMP] = ACTIONS(1921),
    [anon_sym_DOT_DOT] = ACTIONS(1921),
    [anon_sym_DASH] = ACTIONS(1921),
    [anon_sym_PIPE] = ACTIONS(1921),
    [anon_sym_move] = ACTIONS(1923),
    [sym_integer_literal] = ACTIONS(1921),
    [aux_sym_string_literal_token1] = ACTIONS(1921),
    [sym_char_literal] = ACTIONS(1921),
    [anon_sym_true] = ACTIONS(1923),
    [anon_sym_false] = ACTIONS(1923),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1923),
    [sym_super] = ACTIONS(1923),
    [sym_crate] = ACTIONS(1923),
    [sym_metavariable] = ACTIONS(1921),
    [sym_raw_string_literal] = ACTIONS(1921),
    [sym_float_literal] = ACTIONS(1921),
    [sym_block_comment] = ACTIONS(3),
  },
  [399] = {
    [ts_builtin_sym_end] = ACTIONS(1925),
    [sym_identifier] = ACTIONS(1927),
    [anon_sym_SEMI] = ACTIONS(1925),
    [anon_sym_macro_rules_BANG] = ACTIONS(1925),
    [anon_sym_LPAREN] = ACTIONS(1925),
    [anon_sym_LBRACE] = ACTIONS(1925),
    [anon_sym_RBRACE] = ACTIONS(1925),
    [anon_sym_LBRACK] = ACTIONS(1925),
    [anon_sym_STAR] = ACTIONS(1925),
    [anon_sym_u8] = ACTIONS(1927),
    [anon_sym_i8] = ACTIONS(1927),
    [anon_sym_u16] = ACTIONS(1927),
    [anon_sym_i16] = ACTIONS(1927),
    [anon_sym_u32] = ACTIONS(1927),
    [anon_sym_i32] = ACTIONS(1927),
    [anon_sym_u64] = ACTIONS(1927),
    [anon_sym_i64] = ACTIONS(1927),
    [anon_sym_u128] = ACTIONS(1927),
    [anon_sym_i128] = ACTIONS(1927),
    [anon_sym_isize] = ACTIONS(1927),
    [anon_sym_usize] = ACTIONS(1927),
    [anon_sym_f32] = ACTIONS(1927),
    [anon_sym_f64] = ACTIONS(1927),
    [anon_sym_bool] = ACTIONS(1927),
    [anon_sym_str] = ACTIONS(1927),
    [anon_sym_char] = ACTIONS(1927),
    [anon_sym_SQUOTE] = ACTIONS(1927),
    [anon_sym_async] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1927),
    [anon_sym_const] = ACTIONS(1927),
    [anon_sym_continue] = ACTIONS(1927),
    [anon_sym_default] = ACTIONS(1927),
    [anon_sym_enum] = ACTIONS(1927),
    [anon_sym_fn] = ACTIONS(1927),
    [anon_sym_for] = ACTIONS(1927),
    [anon_sym_if] = ACTIONS(1927),
    [anon_sym_impl] = ACTIONS(1927),
    [anon_sym_let] = ACTIONS(1927),
    [anon_sym_loop] = ACTIONS(1927),
    [anon_sym_match] = ACTIONS(1927),
    [anon_sym_mod] = ACTIONS(1927),
    [anon_sym_pub] = ACTIONS(1927),
    [anon_sym_return] = ACTIONS(1927),
    [anon_sym_static] = ACTIONS(1927),
    [anon_sym_struct] = ACTIONS(1927),
    [anon_sym_trait] = ACTIONS(1927),
    [anon_sym_type] = ACTIONS(1927),
    [anon_sym_union] = ACTIONS(1927),
    [anon_sym_unsafe] = ACTIONS(1927),
    [anon_sym_use] = ACTIONS(1927),
    [anon_sym_while] = ACTIONS(1927),
    [anon_sym_POUND] = ACTIONS(1925),
    [anon_sym_BANG] = ACTIONS(1925),
    [anon_sym_extern] = ACTIONS(1927),
    [anon_sym_LT] = ACTIONS(1925),
    [anon_sym_COLON_COLON] = ACTIONS(1925),
    [anon_sym_AMP] = ACTIONS(1925),
    [anon_sym_DOT_DOT] = ACTIONS(1925),
    [anon_sym_DASH] = ACTIONS(1925),
    [anon_sym_PIPE] = ACTIONS(1925),
    [anon_sym_move] = ACTIONS(1927),
    [sym_integer_literal] = ACTIONS(1925),
    [aux_sym_string_literal_token1] = ACTIONS(1925),
    [sym_char_literal] = ACTIONS(1925),
    [anon_sym_true] = ACTIONS(1927),
    [anon_sym_false] = ACTIONS(1927),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1927),
    [sym_super] = ACTIONS(1927),
    [sym_crate] = ACTIONS(1927),
    [sym_metavariable] = ACTIONS(1925),
    [sym_raw_string_literal] = ACTIONS(1925),
    [sym_float_literal] = ACTIONS(1925),
    [sym_block_comment] = ACTIONS(3),
  },
  [400] = {
    [ts_builtin_sym_end] = ACTIONS(1929),
    [sym_identifier] = ACTIONS(1931),
    [anon_sym_SEMI] = ACTIONS(1929),
    [anon_sym_macro_rules_BANG] = ACTIONS(1929),
    [anon_sym_LPAREN] = ACTIONS(1929),
    [anon_sym_LBRACE] = ACTIONS(1929),
    [anon_sym_RBRACE] = ACTIONS(1929),
    [anon_sym_LBRACK] = ACTIONS(1929),
    [anon_sym_STAR] = ACTIONS(1929),
    [anon_sym_u8] = ACTIONS(1931),
    [anon_sym_i8] = ACTIONS(1931),
    [anon_sym_u16] = ACTIONS(1931),
    [anon_sym_i16] = ACTIONS(1931),
    [anon_sym_u32] = ACTIONS(1931),
    [anon_sym_i32] = ACTIONS(1931),
    [anon_sym_u64] = ACTIONS(1931),
    [anon_sym_i64] = ACTIONS(1931),
    [anon_sym_u128] = ACTIONS(1931),
    [anon_sym_i128] = ACTIONS(1931),
    [anon_sym_isize] = ACTIONS(1931),
    [anon_sym_usize] = ACTIONS(1931),
    [anon_sym_f32] = ACTIONS(1931),
    [anon_sym_f64] = ACTIONS(1931),
    [anon_sym_bool] = ACTIONS(1931),
    [anon_sym_str] = ACTIONS(1931),
    [anon_sym_char] = ACTIONS(1931),
    [anon_sym_SQUOTE] = ACTIONS(1931),
    [anon_sym_async] = ACTIONS(1931),
    [anon_sym_break] = ACTIONS(1931),
    [anon_sym_const] = ACTIONS(1931),
    [anon_sym_continue] = ACTIONS(1931),
    [anon_sym_default] = ACTIONS(1931),
    [anon_sym_enum] = ACTIONS(1931),
    [anon_sym_fn] = ACTIONS(1931),
    [anon_sym_for] = ACTIONS(1931),
    [anon_sym_if] = ACTIONS(1931),
    [anon_sym_impl] = ACTIONS(1931),
    [anon_sym_let] = ACTIONS(1931),
    [anon_sym_loop] = ACTIONS(1931),
    [anon_sym_match] = ACTIONS(1931),
    [anon_sym_mod] = ACTIONS(1931),
    [anon_sym_pub] = ACTIONS(1931),
    [anon_sym_return] = ACTIONS(1931),
    [anon_sym_static] = ACTIONS(1931),
    [anon_sym_struct] = ACTIONS(1931),
    [anon_sym_trait] = ACTIONS(1931),
    [anon_sym_type] = ACTIONS(1931),
    [anon_sym_union] = ACTIONS(1931),
    [anon_sym_unsafe] = ACTIONS(1931),
    [anon_sym_use] = ACTIONS(1931),
    [anon_sym_while] = ACTIONS(1931),
    [anon_sym_POUND] = ACTIONS(1929),
    [anon_sym_BANG] = ACTIONS(1929),
    [anon_sym_extern] = ACTIONS(1931),
    [anon_sym_LT] = ACTIONS(1929),
    [anon_sym_COLON_COLON] = ACTIONS(1929),
    [anon_sym_AMP] = ACTIONS(1929),
    [anon_sym_DOT_DOT] = ACTIONS(1929),
    [anon_sym_DASH] = ACTIONS(1929),
    [anon_sym_PIPE] = ACTIONS(1929),
    [anon_sym_move] = ACTIONS(1931),
    [sym_integer_literal] = ACTIONS(1929),
    [aux_sym_string_literal_token1] = ACTIONS(1929),
    [sym_char_literal] = ACTIONS(1929),
    [anon_sym_true] = ACTIONS(1931),
    [anon_sym_false] = ACTIONS(1931),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1931),
    [sym_super] = ACTIONS(1931),
    [sym_crate] = ACTIONS(1931),
    [sym_metavariable] = ACTIONS(1929),
    [sym_raw_string_literal] = ACTIONS(1929),
    [sym_float_literal] = ACTIONS(1929),
    [sym_block_comment] = ACTIONS(3),
  },
  [401] = {
    [ts_builtin_sym_end] = ACTIONS(1933),
    [sym_identifier] = ACTIONS(1935),
    [anon_sym_SEMI] = ACTIONS(1933),
    [anon_sym_macro_rules_BANG] = ACTIONS(1933),
    [anon_sym_LPAREN] = ACTIONS(1933),
    [anon_sym_LBRACE] = ACTIONS(1933),
    [anon_sym_RBRACE] = ACTIONS(1933),
    [anon_sym_LBRACK] = ACTIONS(1933),
    [anon_sym_STAR] = ACTIONS(1933),
    [anon_sym_u8] = ACTIONS(1935),
    [anon_sym_i8] = ACTIONS(1935),
    [anon_sym_u16] = ACTIONS(1935),
    [anon_sym_i16] = ACTIONS(1935),
    [anon_sym_u32] = ACTIONS(1935),
    [anon_sym_i32] = ACTIONS(1935),
    [anon_sym_u64] = ACTIONS(1935),
    [anon_sym_i64] = ACTIONS(1935),
    [anon_sym_u128] = ACTIONS(1935),
    [anon_sym_i128] = ACTIONS(1935),
    [anon_sym_isize] = ACTIONS(1935),
    [anon_sym_usize] = ACTIONS(1935),
    [anon_sym_f32] = ACTIONS(1935),
    [anon_sym_f64] = ACTIONS(1935),
    [anon_sym_bool] = ACTIONS(1935),
    [anon_sym_str] = ACTIONS(1935),
    [anon_sym_char] = ACTIONS(1935),
    [anon_sym_SQUOTE] = ACTIONS(1935),
    [anon_sym_async] = ACTIONS(1935),
    [anon_sym_break] = ACTIONS(1935),
    [anon_sym_const] = ACTIONS(1935),
    [anon_sym_continue] = ACTIONS(1935),
    [anon_sym_default] = ACTIONS(1935),
    [anon_sym_enum] = ACTIONS(1935),
    [anon_sym_fn] = ACTIONS(1935),
    [anon_sym_for] = ACTIONS(1935),
    [anon_sym_if] = ACTIONS(1935),
    [anon_sym_impl] = ACTIONS(1935),
    [anon_sym_let] = ACTIONS(1935),
    [anon_sym_loop] = ACTIONS(1935),
    [anon_sym_match] = ACTIONS(1935),
    [anon_sym_mod] = ACTIONS(1935),
    [anon_sym_pub] = ACTIONS(1935),
    [anon_sym_return] = ACTIONS(1935),
    [anon_sym_static] = ACTIONS(1935),
    [anon_sym_struct] = ACTIONS(1935),
    [anon_sym_trait] = ACTIONS(1935),
    [anon_sym_type] = ACTIONS(1935),
    [anon_sym_union] = ACTIONS(1935),
    [anon_sym_unsafe] = ACTIONS(1935),
    [anon_sym_use] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1935),
    [anon_sym_POUND] = ACTIONS(1933),
    [anon_sym_BANG] = ACTIONS(1933),
    [anon_sym_extern] = ACTIONS(1935),
    [anon_sym_LT] = ACTIONS(1933),
    [anon_sym_COLON_COLON] = ACTIONS(1933),
    [anon_sym_AMP] = ACTIONS(1933),
    [anon_sym_DOT_DOT] = ACTIONS(1933),
    [anon_sym_DASH] = ACTIONS(1933),
    [anon_sym_PIPE] = ACTIONS(1933),
    [anon_sym_move] = ACTIONS(1935),
    [sym_integer_literal] = ACTIONS(1933),
    [aux_sym_string_literal_token1] = ACTIONS(1933),
    [sym_char_literal] = ACTIONS(1933),
    [anon_sym_true] = ACTIONS(1935),
    [anon_sym_false] = ACTIONS(1935),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1935),
    [sym_super] = ACTIONS(1935),
    [sym_crate] = ACTIONS(1935),
    [sym_metavariable] = ACTIONS(1933),
    [sym_raw_string_literal] = ACTIONS(1933),
    [sym_float_literal] = ACTIONS(1933),
    [sym_block_comment] = ACTIONS(3),
  },
  [402] = {
    [ts_builtin_sym_end] = ACTIONS(1937),
    [sym_identifier] = ACTIONS(1939),
    [anon_sym_SEMI] = ACTIONS(1937),
    [anon_sym_macro_rules_BANG] = ACTIONS(1937),
    [anon_sym_LPAREN] = ACTIONS(1937),
    [anon_sym_LBRACE] = ACTIONS(1937),
    [anon_sym_RBRACE] = ACTIONS(1937),
    [anon_sym_LBRACK] = ACTIONS(1937),
    [anon_sym_STAR] = ACTIONS(1937),
    [anon_sym_u8] = ACTIONS(1939),
    [anon_sym_i8] = ACTIONS(1939),
    [anon_sym_u16] = ACTIONS(1939),
    [anon_sym_i16] = ACTIONS(1939),
    [anon_sym_u32] = ACTIONS(1939),
    [anon_sym_i32] = ACTIONS(1939),
    [anon_sym_u64] = ACTIONS(1939),
    [anon_sym_i64] = ACTIONS(1939),
    [anon_sym_u128] = ACTIONS(1939),
    [anon_sym_i128] = ACTIONS(1939),
    [anon_sym_isize] = ACTIONS(1939),
    [anon_sym_usize] = ACTIONS(1939),
    [anon_sym_f32] = ACTIONS(1939),
    [anon_sym_f64] = ACTIONS(1939),
    [anon_sym_bool] = ACTIONS(1939),
    [anon_sym_str] = ACTIONS(1939),
    [anon_sym_char] = ACTIONS(1939),
    [anon_sym_SQUOTE] = ACTIONS(1939),
    [anon_sym_async] = ACTIONS(1939),
    [anon_sym_break] = ACTIONS(1939),
    [anon_sym_const] = ACTIONS(1939),
    [anon_sym_continue] = ACTIONS(1939),
    [anon_sym_default] = ACTIONS(1939),
    [anon_sym_enum] = ACTIONS(1939),
    [anon_sym_fn] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(1939),
    [anon_sym_if] = ACTIONS(1939),
    [anon_sym_impl] = ACTIONS(1939),
    [anon_sym_let] = ACTIONS(1939),
    [anon_sym_loop] = ACTIONS(1939),
    [anon_sym_match] = ACTIONS(1939),
    [anon_sym_mod] = ACTIONS(1939),
    [anon_sym_pub] = ACTIONS(1939),
    [anon_sym_return] = ACTIONS(1939),
    [anon_sym_static] = ACTIONS(1939),
    [anon_sym_struct] = ACTIONS(1939),
    [anon_sym_trait] = ACTIONS(1939),
    [anon_sym_type] = ACTIONS(1939),
    [anon_sym_union] = ACTIONS(1939),
    [anon_sym_unsafe] = ACTIONS(1939),
    [anon_sym_use] = ACTIONS(1939),
    [anon_sym_while] = ACTIONS(1939),
    [anon_sym_POUND] = ACTIONS(1937),
    [anon_sym_BANG] = ACTIONS(1937),
    [anon_sym_extern] = ACTIONS(1939),
    [anon_sym_LT] = ACTIONS(1937),
    [anon_sym_COLON_COLON] = ACTIONS(1937),
    [anon_sym_AMP] = ACTIONS(1937),
    [anon_sym_DOT_DOT] = ACTIONS(1937),
    [anon_sym_DASH] = ACTIONS(1937),
    [anon_sym_PIPE] = ACTIONS(1937),
    [anon_sym_move] = ACTIONS(1939),
    [sym_integer_literal] = ACTIONS(1937),
    [aux_sym_string_literal_token1] = ACTIONS(1937),
    [sym_char_literal] = ACTIONS(1937),
    [anon_sym_true] = ACTIONS(1939),
    [anon_sym_false] = ACTIONS(1939),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1939),
    [sym_super] = ACTIONS(1939),
    [sym_crate] = ACTIONS(1939),
    [sym_metavariable] = ACTIONS(1937),
    [sym_raw_string_literal] = ACTIONS(1937),
    [sym_float_literal] = ACTIONS(1937),
    [sym_block_comment] = ACTIONS(3),
  },
  [403] = {
    [ts_builtin_sym_end] = ACTIONS(1941),
    [sym_identifier] = ACTIONS(1943),
    [anon_sym_SEMI] = ACTIONS(1941),
    [anon_sym_macro_rules_BANG] = ACTIONS(1941),
    [anon_sym_LPAREN] = ACTIONS(1941),
    [anon_sym_LBRACE] = ACTIONS(1941),
    [anon_sym_RBRACE] = ACTIONS(1941),
    [anon_sym_LBRACK] = ACTIONS(1941),
    [anon_sym_STAR] = ACTIONS(1941),
    [anon_sym_u8] = ACTIONS(1943),
    [anon_sym_i8] = ACTIONS(1943),
    [anon_sym_u16] = ACTIONS(1943),
    [anon_sym_i16] = ACTIONS(1943),
    [anon_sym_u32] = ACTIONS(1943),
    [anon_sym_i32] = ACTIONS(1943),
    [anon_sym_u64] = ACTIONS(1943),
    [anon_sym_i64] = ACTIONS(1943),
    [anon_sym_u128] = ACTIONS(1943),
    [anon_sym_i128] = ACTIONS(1943),
    [anon_sym_isize] = ACTIONS(1943),
    [anon_sym_usize] = ACTIONS(1943),
    [anon_sym_f32] = ACTIONS(1943),
    [anon_sym_f64] = ACTIONS(1943),
    [anon_sym_bool] = ACTIONS(1943),
    [anon_sym_str] = ACTIONS(1943),
    [anon_sym_char] = ACTIONS(1943),
    [anon_sym_SQUOTE] = ACTIONS(1943),
    [anon_sym_async] = ACTIONS(1943),
    [anon_sym_break] = ACTIONS(1943),
    [anon_sym_const] = ACTIONS(1943),
    [anon_sym_continue] = ACTIONS(1943),
    [anon_sym_default] = ACTIONS(1943),
    [anon_sym_enum] = ACTIONS(1943),
    [anon_sym_fn] = ACTIONS(1943),
    [anon_sym_for] = ACTIONS(1943),
    [anon_sym_if] = ACTIONS(1943),
    [anon_sym_impl] = ACTIONS(1943),
    [anon_sym_let] = ACTIONS(1943),
    [anon_sym_loop] = ACTIONS(1943),
    [anon_sym_match] = ACTIONS(1943),
    [anon_sym_mod] = ACTIONS(1943),
    [anon_sym_pub] = ACTIONS(1943),
    [anon_sym_return] = ACTIONS(1943),
    [anon_sym_static] = ACTIONS(1943),
    [anon_sym_struct] = ACTIONS(1943),
    [anon_sym_trait] = ACTIONS(1943),
    [anon_sym_type] = ACTIONS(1943),
    [anon_sym_union] = ACTIONS(1943),
    [anon_sym_unsafe] = ACTIONS(1943),
    [anon_sym_use] = ACTIONS(1943),
    [anon_sym_while] = ACTIONS(1943),
    [anon_sym_POUND] = ACTIONS(1941),
    [anon_sym_BANG] = ACTIONS(1941),
    [anon_sym_extern] = ACTIONS(1943),
    [anon_sym_LT] = ACTIONS(1941),
    [anon_sym_COLON_COLON] = ACTIONS(1941),
    [anon_sym_AMP] = ACTIONS(1941),
    [anon_sym_DOT_DOT] = ACTIONS(1941),
    [anon_sym_DASH] = ACTIONS(1941),
    [anon_sym_PIPE] = ACTIONS(1941),
    [anon_sym_move] = ACTIONS(1943),
    [sym_integer_literal] = ACTIONS(1941),
    [aux_sym_string_literal_token1] = ACTIONS(1941),
    [sym_char_literal] = ACTIONS(1941),
    [anon_sym_true] = ACTIONS(1943),
    [anon_sym_false] = ACTIONS(1943),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1943),
    [sym_super] = ACTIONS(1943),
    [sym_crate] = ACTIONS(1943),
    [sym_metavariable] = ACTIONS(1941),
    [sym_raw_string_literal] = ACTIONS(1941),
    [sym_float_literal] = ACTIONS(1941),
    [sym_block_comment] = ACTIONS(3),
  },
  [404] = {
    [ts_builtin_sym_end] = ACTIONS(1945),
    [sym_identifier] = ACTIONS(1947),
    [anon_sym_SEMI] = ACTIONS(1945),
    [anon_sym_macro_rules_BANG] = ACTIONS(1945),
    [anon_sym_LPAREN] = ACTIONS(1945),
    [anon_sym_LBRACE] = ACTIONS(1945),
    [anon_sym_RBRACE] = ACTIONS(1945),
    [anon_sym_LBRACK] = ACTIONS(1945),
    [anon_sym_STAR] = ACTIONS(1945),
    [anon_sym_u8] = ACTIONS(1947),
    [anon_sym_i8] = ACTIONS(1947),
    [anon_sym_u16] = ACTIONS(1947),
    [anon_sym_i16] = ACTIONS(1947),
    [anon_sym_u32] = ACTIONS(1947),
    [anon_sym_i32] = ACTIONS(1947),
    [anon_sym_u64] = ACTIONS(1947),
    [anon_sym_i64] = ACTIONS(1947),
    [anon_sym_u128] = ACTIONS(1947),
    [anon_sym_i128] = ACTIONS(1947),
    [anon_sym_isize] = ACTIONS(1947),
    [anon_sym_usize] = ACTIONS(1947),
    [anon_sym_f32] = ACTIONS(1947),
    [anon_sym_f64] = ACTIONS(1947),
    [anon_sym_bool] = ACTIONS(1947),
    [anon_sym_str] = ACTIONS(1947),
    [anon_sym_char] = ACTIONS(1947),
    [anon_sym_SQUOTE] = ACTIONS(1947),
    [anon_sym_async] = ACTIONS(1947),
    [anon_sym_break] = ACTIONS(1947),
    [anon_sym_const] = ACTIONS(1947),
    [anon_sym_continue] = ACTIONS(1947),
    [anon_sym_default] = ACTIONS(1947),
    [anon_sym_enum] = ACTIONS(1947),
    [anon_sym_fn] = ACTIONS(1947),
    [anon_sym_for] = ACTIONS(1947),
    [anon_sym_if] = ACTIONS(1947),
    [anon_sym_impl] = ACTIONS(1947),
    [anon_sym_let] = ACTIONS(1947),
    [anon_sym_loop] = ACTIONS(1947),
    [anon_sym_match] = ACTIONS(1947),
    [anon_sym_mod] = ACTIONS(1947),
    [anon_sym_pub] = ACTIONS(1947),
    [anon_sym_return] = ACTIONS(1947),
    [anon_sym_static] = ACTIONS(1947),
    [anon_sym_struct] = ACTIONS(1947),
    [anon_sym_trait] = ACTIONS(1947),
    [anon_sym_type] = ACTIONS(1947),
    [anon_sym_union] = ACTIONS(1947),
    [anon_sym_unsafe] = ACTIONS(1947),
    [anon_sym_use] = ACTIONS(1947),
    [anon_sym_while] = ACTIONS(1947),
    [anon_sym_POUND] = ACTIONS(1945),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_extern] = ACTIONS(1947),
    [anon_sym_LT] = ACTIONS(1945),
    [anon_sym_COLON_COLON] = ACTIONS(1945),
    [anon_sym_AMP] = ACTIONS(1945),
    [anon_sym_DOT_DOT] = ACTIONS(1945),
    [anon_sym_DASH] = ACTIONS(1945),
    [anon_sym_PIPE] = ACTIONS(1945),
    [anon_sym_move] = ACTIONS(1947),
    [sym_integer_literal] = ACTIONS(1945),
    [aux_sym_string_literal_token1] = ACTIONS(1945),
    [sym_char_literal] = ACTIONS(1945),
    [anon_sym_true] = ACTIONS(1947),
    [anon_sym_false] = ACTIONS(1947),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1947),
    [sym_super] = ACTIONS(1947),
    [sym_crate] = ACTIONS(1947),
    [sym_metavariable] = ACTIONS(1945),
    [sym_raw_string_literal] = ACTIONS(1945),
    [sym_float_literal] = ACTIONS(1945),
    [sym_block_comment] = ACTIONS(3),
  },
  [405] = {
    [ts_builtin_sym_end] = ACTIONS(1949),
    [sym_identifier] = ACTIONS(1951),
    [anon_sym_SEMI] = ACTIONS(1949),
    [anon_sym_macro_rules_BANG] = ACTIONS(1949),
    [anon_sym_LPAREN] = ACTIONS(1949),
    [anon_sym_LBRACE] = ACTIONS(1949),
    [anon_sym_RBRACE] = ACTIONS(1949),
    [anon_sym_LBRACK] = ACTIONS(1949),
    [anon_sym_STAR] = ACTIONS(1949),
    [anon_sym_u8] = ACTIONS(1951),
    [anon_sym_i8] = ACTIONS(1951),
    [anon_sym_u16] = ACTIONS(1951),
    [anon_sym_i16] = ACTIONS(1951),
    [anon_sym_u32] = ACTIONS(1951),
    [anon_sym_i32] = ACTIONS(1951),
    [anon_sym_u64] = ACTIONS(1951),
    [anon_sym_i64] = ACTIONS(1951),
    [anon_sym_u128] = ACTIONS(1951),
    [anon_sym_i128] = ACTIONS(1951),
    [anon_sym_isize] = ACTIONS(1951),
    [anon_sym_usize] = ACTIONS(1951),
    [anon_sym_f32] = ACTIONS(1951),
    [anon_sym_f64] = ACTIONS(1951),
    [anon_sym_bool] = ACTIONS(1951),
    [anon_sym_str] = ACTIONS(1951),
    [anon_sym_char] = ACTIONS(1951),
    [anon_sym_SQUOTE] = ACTIONS(1951),
    [anon_sym_async] = ACTIONS(1951),
    [anon_sym_break] = ACTIONS(1951),
    [anon_sym_const] = ACTIONS(1951),
    [anon_sym_continue] = ACTIONS(1951),
    [anon_sym_default] = ACTIONS(1951),
    [anon_sym_enum] = ACTIONS(1951),
    [anon_sym_fn] = ACTIONS(1951),
    [anon_sym_for] = ACTIONS(1951),
    [anon_sym_if] = ACTIONS(1951),
    [anon_sym_impl] = ACTIONS(1951),
    [anon_sym_let] = ACTIONS(1951),
    [anon_sym_loop] = ACTIONS(1951),
    [anon_sym_match] = ACTIONS(1951),
    [anon_sym_mod] = ACTIONS(1951),
    [anon_sym_pub] = ACTIONS(1951),
    [anon_sym_return] = ACTIONS(1951),
    [anon_sym_static] = ACTIONS(1951),
    [anon_sym_struct] = ACTIONS(1951),
    [anon_sym_trait] = ACTIONS(1951),
    [anon_sym_type] = ACTIONS(1951),
    [anon_sym_union] = ACTIONS(1951),
    [anon_sym_unsafe] = ACTIONS(1951),
    [anon_sym_use] = ACTIONS(1951),
    [anon_sym_while] = ACTIONS(1951),
    [anon_sym_POUND] = ACTIONS(1949),
    [anon_sym_BANG] = ACTIONS(1949),
    [anon_sym_extern] = ACTIONS(1951),
    [anon_sym_LT] = ACTIONS(1949),
    [anon_sym_COLON_COLON] = ACTIONS(1949),
    [anon_sym_AMP] = ACTIONS(1949),
    [anon_sym_DOT_DOT] = ACTIONS(1949),
    [anon_sym_DASH] = ACTIONS(1949),
    [anon_sym_PIPE] = ACTIONS(1949),
    [anon_sym_move] = ACTIONS(1951),
    [sym_integer_literal] = ACTIONS(1949),
    [aux_sym_string_literal_token1] = ACTIONS(1949),
    [sym_char_literal] = ACTIONS(1949),
    [anon_sym_true] = ACTIONS(1951),
    [anon_sym_false] = ACTIONS(1951),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1951),
    [sym_super] = ACTIONS(1951),
    [sym_crate] = ACTIONS(1951),
    [sym_metavariable] = ACTIONS(1949),
    [sym_raw_string_literal] = ACTIONS(1949),
    [sym_float_literal] = ACTIONS(1949),
    [sym_block_comment] = ACTIONS(3),
  },
  [406] = {
    [ts_builtin_sym_end] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1955),
    [anon_sym_SEMI] = ACTIONS(1953),
    [anon_sym_macro_rules_BANG] = ACTIONS(1953),
    [anon_sym_LPAREN] = ACTIONS(1953),
    [anon_sym_LBRACE] = ACTIONS(1953),
    [anon_sym_RBRACE] = ACTIONS(1953),
    [anon_sym_LBRACK] = ACTIONS(1953),
    [anon_sym_STAR] = ACTIONS(1953),
    [anon_sym_u8] = ACTIONS(1955),
    [anon_sym_i8] = ACTIONS(1955),
    [anon_sym_u16] = ACTIONS(1955),
    [anon_sym_i16] = ACTIONS(1955),
    [anon_sym_u32] = ACTIONS(1955),
    [anon_sym_i32] = ACTIONS(1955),
    [anon_sym_u64] = ACTIONS(1955),
    [anon_sym_i64] = ACTIONS(1955),
    [anon_sym_u128] = ACTIONS(1955),
    [anon_sym_i128] = ACTIONS(1955),
    [anon_sym_isize] = ACTIONS(1955),
    [anon_sym_usize] = ACTIONS(1955),
    [anon_sym_f32] = ACTIONS(1955),
    [anon_sym_f64] = ACTIONS(1955),
    [anon_sym_bool] = ACTIONS(1955),
    [anon_sym_str] = ACTIONS(1955),
    [anon_sym_char] = ACTIONS(1955),
    [anon_sym_SQUOTE] = ACTIONS(1955),
    [anon_sym_async] = ACTIONS(1955),
    [anon_sym_break] = ACTIONS(1955),
    [anon_sym_const] = ACTIONS(1955),
    [anon_sym_continue] = ACTIONS(1955),
    [anon_sym_default] = ACTIONS(1955),
    [anon_sym_enum] = ACTIONS(1955),
    [anon_sym_fn] = ACTIONS(1955),
    [anon_sym_for] = ACTIONS(1955),
    [anon_sym_if] = ACTIONS(1955),
    [anon_sym_impl] = ACTIONS(1955),
    [anon_sym_let] = ACTIONS(1955),
    [anon_sym_loop] = ACTIONS(1955),
    [anon_sym_match] = ACTIONS(1955),
    [anon_sym_mod] = ACTIONS(1955),
    [anon_sym_pub] = ACTIONS(1955),
    [anon_sym_return] = ACTIONS(1955),
    [anon_sym_static] = ACTIONS(1955),
    [anon_sym_struct] = ACTIONS(1955),
    [anon_sym_trait] = ACTIONS(1955),
    [anon_sym_type] = ACTIONS(1955),
    [anon_sym_union] = ACTIONS(1955),
    [anon_sym_unsafe] = ACTIONS(1955),
    [anon_sym_use] = ACTIONS(1955),
    [anon_sym_while] = ACTIONS(1955),
    [anon_sym_POUND] = ACTIONS(1953),
    [anon_sym_BANG] = ACTIONS(1953),
    [anon_sym_extern] = ACTIONS(1955),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_COLON_COLON] = ACTIONS(1953),
    [anon_sym_AMP] = ACTIONS(1953),
    [anon_sym_DOT_DOT] = ACTIONS(1953),
    [anon_sym_DASH] = ACTIONS(1953),
    [anon_sym_PIPE] = ACTIONS(1953),
    [anon_sym_move] = ACTIONS(1955),
    [sym_integer_literal] = ACTIONS(1953),
    [aux_sym_string_literal_token1] = ACTIONS(1953),
    [sym_char_literal] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(1955),
    [anon_sym_false] = ACTIONS(1955),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1955),
    [sym_super] = ACTIONS(1955),
    [sym_crate] = ACTIONS(1955),
    [sym_metavariable] = ACTIONS(1953),
    [sym_raw_string_literal] = ACTIONS(1953),
    [sym_float_literal] = ACTIONS(1953),
    [sym_block_comment] = ACTIONS(3),
  },
  [407] = {
    [ts_builtin_sym_end] = ACTIONS(1957),
    [sym_identifier] = ACTIONS(1959),
    [anon_sym_SEMI] = ACTIONS(1957),
    [anon_sym_macro_rules_BANG] = ACTIONS(1957),
    [anon_sym_LPAREN] = ACTIONS(1957),
    [anon_sym_LBRACE] = ACTIONS(1957),
    [anon_sym_RBRACE] = ACTIONS(1957),
    [anon_sym_LBRACK] = ACTIONS(1957),
    [anon_sym_STAR] = ACTIONS(1957),
    [anon_sym_u8] = ACTIONS(1959),
    [anon_sym_i8] = ACTIONS(1959),
    [anon_sym_u16] = ACTIONS(1959),
    [anon_sym_i16] = ACTIONS(1959),
    [anon_sym_u32] = ACTIONS(1959),
    [anon_sym_i32] = ACTIONS(1959),
    [anon_sym_u64] = ACTIONS(1959),
    [anon_sym_i64] = ACTIONS(1959),
    [anon_sym_u128] = ACTIONS(1959),
    [anon_sym_i128] = ACTIONS(1959),
    [anon_sym_isize] = ACTIONS(1959),
    [anon_sym_usize] = ACTIONS(1959),
    [anon_sym_f32] = ACTIONS(1959),
    [anon_sym_f64] = ACTIONS(1959),
    [anon_sym_bool] = ACTIONS(1959),
    [anon_sym_str] = ACTIONS(1959),
    [anon_sym_char] = ACTIONS(1959),
    [anon_sym_SQUOTE] = ACTIONS(1959),
    [anon_sym_async] = ACTIONS(1959),
    [anon_sym_break] = ACTIONS(1959),
    [anon_sym_const] = ACTIONS(1959),
    [anon_sym_continue] = ACTIONS(1959),
    [anon_sym_default] = ACTIONS(1959),
    [anon_sym_enum] = ACTIONS(1959),
    [anon_sym_fn] = ACTIONS(1959),
    [anon_sym_for] = ACTIONS(1959),
    [anon_sym_if] = ACTIONS(1959),
    [anon_sym_impl] = ACTIONS(1959),
    [anon_sym_let] = ACTIONS(1959),
    [anon_sym_loop] = ACTIONS(1959),
    [anon_sym_match] = ACTIONS(1959),
    [anon_sym_mod] = ACTIONS(1959),
    [anon_sym_pub] = ACTIONS(1959),
    [anon_sym_return] = ACTIONS(1959),
    [anon_sym_static] = ACTIONS(1959),
    [anon_sym_struct] = ACTIONS(1959),
    [anon_sym_trait] = ACTIONS(1959),
    [anon_sym_type] = ACTIONS(1959),
    [anon_sym_union] = ACTIONS(1959),
    [anon_sym_unsafe] = ACTIONS(1959),
    [anon_sym_use] = ACTIONS(1959),
    [anon_sym_while] = ACTIONS(1959),
    [anon_sym_POUND] = ACTIONS(1957),
    [anon_sym_BANG] = ACTIONS(1957),
    [anon_sym_extern] = ACTIONS(1959),
    [anon_sym_LT] = ACTIONS(1957),
    [anon_sym_COLON_COLON] = ACTIONS(1957),
    [anon_sym_AMP] = ACTIONS(1957),
    [anon_sym_DOT_DOT] = ACTIONS(1957),
    [anon_sym_DASH] = ACTIONS(1957),
    [anon_sym_PIPE] = ACTIONS(1957),
    [anon_sym_move] = ACTIONS(1959),
    [sym_integer_literal] = ACTIONS(1957),
    [aux_sym_string_literal_token1] = ACTIONS(1957),
    [sym_char_literal] = ACTIONS(1957),
    [anon_sym_true] = ACTIONS(1959),
    [anon_sym_false] = ACTIONS(1959),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1959),
    [sym_super] = ACTIONS(1959),
    [sym_crate] = ACTIONS(1959),
    [sym_metavariable] = ACTIONS(1957),
    [sym_raw_string_literal] = ACTIONS(1957),
    [sym_float_literal] = ACTIONS(1957),
    [sym_block_comment] = ACTIONS(3),
  },
  [408] = {
    [ts_builtin_sym_end] = ACTIONS(1961),
    [sym_identifier] = ACTIONS(1963),
    [anon_sym_SEMI] = ACTIONS(1961),
    [anon_sym_macro_rules_BANG] = ACTIONS(1961),
    [anon_sym_LPAREN] = ACTIONS(1961),
    [anon_sym_LBRACE] = ACTIONS(1961),
    [anon_sym_RBRACE] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(1961),
    [anon_sym_STAR] = ACTIONS(1961),
    [anon_sym_u8] = ACTIONS(1963),
    [anon_sym_i8] = ACTIONS(1963),
    [anon_sym_u16] = ACTIONS(1963),
    [anon_sym_i16] = ACTIONS(1963),
    [anon_sym_u32] = ACTIONS(1963),
    [anon_sym_i32] = ACTIONS(1963),
    [anon_sym_u64] = ACTIONS(1963),
    [anon_sym_i64] = ACTIONS(1963),
    [anon_sym_u128] = ACTIONS(1963),
    [anon_sym_i128] = ACTIONS(1963),
    [anon_sym_isize] = ACTIONS(1963),
    [anon_sym_usize] = ACTIONS(1963),
    [anon_sym_f32] = ACTIONS(1963),
    [anon_sym_f64] = ACTIONS(1963),
    [anon_sym_bool] = ACTIONS(1963),
    [anon_sym_str] = ACTIONS(1963),
    [anon_sym_char] = ACTIONS(1963),
    [anon_sym_SQUOTE] = ACTIONS(1963),
    [anon_sym_async] = ACTIONS(1963),
    [anon_sym_break] = ACTIONS(1963),
    [anon_sym_const] = ACTIONS(1963),
    [anon_sym_continue] = ACTIONS(1963),
    [anon_sym_default] = ACTIONS(1963),
    [anon_sym_enum] = ACTIONS(1963),
    [anon_sym_fn] = ACTIONS(1963),
    [anon_sym_for] = ACTIONS(1963),
    [anon_sym_if] = ACTIONS(1963),
    [anon_sym_impl] = ACTIONS(1963),
    [anon_sym_let] = ACTIONS(1963),
    [anon_sym_loop] = ACTIONS(1963),
    [anon_sym_match] = ACTIONS(1963),
    [anon_sym_mod] = ACTIONS(1963),
    [anon_sym_pub] = ACTIONS(1963),
    [anon_sym_return] = ACTIONS(1963),
    [anon_sym_static] = ACTIONS(1963),
    [anon_sym_struct] = ACTIONS(1963),
    [anon_sym_trait] = ACTIONS(1963),
    [anon_sym_type] = ACTIONS(1963),
    [anon_sym_union] = ACTIONS(1963),
    [anon_sym_unsafe] = ACTIONS(1963),
    [anon_sym_use] = ACTIONS(1963),
    [anon_sym_while] = ACTIONS(1963),
    [anon_sym_POUND] = ACTIONS(1961),
    [anon_sym_BANG] = ACTIONS(1961),
    [anon_sym_extern] = ACTIONS(1963),
    [anon_sym_LT] = ACTIONS(1961),
    [anon_sym_COLON_COLON] = ACTIONS(1961),
    [anon_sym_AMP] = ACTIONS(1961),
    [anon_sym_DOT_DOT] = ACTIONS(1961),
    [anon_sym_DASH] = ACTIONS(1961),
    [anon_sym_PIPE] = ACTIONS(1961),
    [anon_sym_move] = ACTIONS(1963),
    [sym_integer_literal] = ACTIONS(1961),
    [aux_sym_string_literal_token1] = ACTIONS(1961),
    [sym_char_literal] = ACTIONS(1961),
    [anon_sym_true] = ACTIONS(1963),
    [anon_sym_false] = ACTIONS(1963),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1963),
    [sym_super] = ACTIONS(1963),
    [sym_crate] = ACTIONS(1963),
    [sym_metavariable] = ACTIONS(1961),
    [sym_raw_string_literal] = ACTIONS(1961),
    [sym_float_literal] = ACTIONS(1961),
    [sym_block_comment] = ACTIONS(3),
  },
  [409] = {
    [ts_builtin_sym_end] = ACTIONS(1965),
    [sym_identifier] = ACTIONS(1967),
    [anon_sym_SEMI] = ACTIONS(1965),
    [anon_sym_macro_rules_BANG] = ACTIONS(1965),
    [anon_sym_LPAREN] = ACTIONS(1965),
    [anon_sym_LBRACE] = ACTIONS(1965),
    [anon_sym_RBRACE] = ACTIONS(1965),
    [anon_sym_LBRACK] = ACTIONS(1965),
    [anon_sym_STAR] = ACTIONS(1965),
    [anon_sym_u8] = ACTIONS(1967),
    [anon_sym_i8] = ACTIONS(1967),
    [anon_sym_u16] = ACTIONS(1967),
    [anon_sym_i16] = ACTIONS(1967),
    [anon_sym_u32] = ACTIONS(1967),
    [anon_sym_i32] = ACTIONS(1967),
    [anon_sym_u64] = ACTIONS(1967),
    [anon_sym_i64] = ACTIONS(1967),
    [anon_sym_u128] = ACTIONS(1967),
    [anon_sym_i128] = ACTIONS(1967),
    [anon_sym_isize] = ACTIONS(1967),
    [anon_sym_usize] = ACTIONS(1967),
    [anon_sym_f32] = ACTIONS(1967),
    [anon_sym_f64] = ACTIONS(1967),
    [anon_sym_bool] = ACTIONS(1967),
    [anon_sym_str] = ACTIONS(1967),
    [anon_sym_char] = ACTIONS(1967),
    [anon_sym_SQUOTE] = ACTIONS(1967),
    [anon_sym_async] = ACTIONS(1967),
    [anon_sym_break] = ACTIONS(1967),
    [anon_sym_const] = ACTIONS(1967),
    [anon_sym_continue] = ACTIONS(1967),
    [anon_sym_default] = ACTIONS(1967),
    [anon_sym_enum] = ACTIONS(1967),
    [anon_sym_fn] = ACTIONS(1967),
    [anon_sym_for] = ACTIONS(1967),
    [anon_sym_if] = ACTIONS(1967),
    [anon_sym_impl] = ACTIONS(1967),
    [anon_sym_let] = ACTIONS(1967),
    [anon_sym_loop] = ACTIONS(1967),
    [anon_sym_match] = ACTIONS(1967),
    [anon_sym_mod] = ACTIONS(1967),
    [anon_sym_pub] = ACTIONS(1967),
    [anon_sym_return] = ACTIONS(1967),
    [anon_sym_static] = ACTIONS(1967),
    [anon_sym_struct] = ACTIONS(1967),
    [anon_sym_trait] = ACTIONS(1967),
    [anon_sym_type] = ACTIONS(1967),
    [anon_sym_union] = ACTIONS(1967),
    [anon_sym_unsafe] = ACTIONS(1967),
    [anon_sym_use] = ACTIONS(1967),
    [anon_sym_while] = ACTIONS(1967),
    [anon_sym_POUND] = ACTIONS(1965),
    [anon_sym_BANG] = ACTIONS(1965),
    [anon_sym_extern] = ACTIONS(1967),
    [anon_sym_LT] = ACTIONS(1965),
    [anon_sym_COLON_COLON] = ACTIONS(1965),
    [anon_sym_AMP] = ACTIONS(1965),
    [anon_sym_DOT_DOT] = ACTIONS(1965),
    [anon_sym_DASH] = ACTIONS(1965),
    [anon_sym_PIPE] = ACTIONS(1965),
    [anon_sym_move] = ACTIONS(1967),
    [sym_integer_literal] = ACTIONS(1965),
    [aux_sym_string_literal_token1] = ACTIONS(1965),
    [sym_char_literal] = ACTIONS(1965),
    [anon_sym_true] = ACTIONS(1967),
    [anon_sym_false] = ACTIONS(1967),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1967),
    [sym_super] = ACTIONS(1967),
    [sym_crate] = ACTIONS(1967),
    [sym_metavariable] = ACTIONS(1965),
    [sym_raw_string_literal] = ACTIONS(1965),
    [sym_float_literal] = ACTIONS(1965),
    [sym_block_comment] = ACTIONS(3),
  },
  [410] = {
    [ts_builtin_sym_end] = ACTIONS(1969),
    [sym_identifier] = ACTIONS(1971),
    [anon_sym_SEMI] = ACTIONS(1969),
    [anon_sym_macro_rules_BANG] = ACTIONS(1969),
    [anon_sym_LPAREN] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(1969),
    [anon_sym_RBRACE] = ACTIONS(1969),
    [anon_sym_LBRACK] = ACTIONS(1969),
    [anon_sym_STAR] = ACTIONS(1969),
    [anon_sym_u8] = ACTIONS(1971),
    [anon_sym_i8] = ACTIONS(1971),
    [anon_sym_u16] = ACTIONS(1971),
    [anon_sym_i16] = ACTIONS(1971),
    [anon_sym_u32] = ACTIONS(1971),
    [anon_sym_i32] = ACTIONS(1971),
    [anon_sym_u64] = ACTIONS(1971),
    [anon_sym_i64] = ACTIONS(1971),
    [anon_sym_u128] = ACTIONS(1971),
    [anon_sym_i128] = ACTIONS(1971),
    [anon_sym_isize] = ACTIONS(1971),
    [anon_sym_usize] = ACTIONS(1971),
    [anon_sym_f32] = ACTIONS(1971),
    [anon_sym_f64] = ACTIONS(1971),
    [anon_sym_bool] = ACTIONS(1971),
    [anon_sym_str] = ACTIONS(1971),
    [anon_sym_char] = ACTIONS(1971),
    [anon_sym_SQUOTE] = ACTIONS(1971),
    [anon_sym_async] = ACTIONS(1971),
    [anon_sym_break] = ACTIONS(1971),
    [anon_sym_const] = ACTIONS(1971),
    [anon_sym_continue] = ACTIONS(1971),
    [anon_sym_default] = ACTIONS(1971),
    [anon_sym_enum] = ACTIONS(1971),
    [anon_sym_fn] = ACTIONS(1971),
    [anon_sym_for] = ACTIONS(1971),
    [anon_sym_if] = ACTIONS(1971),
    [anon_sym_impl] = ACTIONS(1971),
    [anon_sym_let] = ACTIONS(1971),
    [anon_sym_loop] = ACTIONS(1971),
    [anon_sym_match] = ACTIONS(1971),
    [anon_sym_mod] = ACTIONS(1971),
    [anon_sym_pub] = ACTIONS(1971),
    [anon_sym_return] = ACTIONS(1971),
    [anon_sym_static] = ACTIONS(1971),
    [anon_sym_struct] = ACTIONS(1971),
    [anon_sym_trait] = ACTIONS(1971),
    [anon_sym_type] = ACTIONS(1971),
    [anon_sym_union] = ACTIONS(1971),
    [anon_sym_unsafe] = ACTIONS(1971),
    [anon_sym_use] = ACTIONS(1971),
    [anon_sym_while] = ACTIONS(1971),
    [anon_sym_POUND] = ACTIONS(1969),
    [anon_sym_BANG] = ACTIONS(1969),
    [anon_sym_extern] = ACTIONS(1971),
    [anon_sym_LT] = ACTIONS(1969),
    [anon_sym_COLON_COLON] = ACTIONS(1969),
    [anon_sym_AMP] = ACTIONS(1969),
    [anon_sym_DOT_DOT] = ACTIONS(1969),
    [anon_sym_DASH] = ACTIONS(1969),
    [anon_sym_PIPE] = ACTIONS(1969),
    [anon_sym_move] = ACTIONS(1971),
    [sym_integer_literal] = ACTIONS(1969),
    [aux_sym_string_literal_token1] = ACTIONS(1969),
    [sym_char_literal] = ACTIONS(1969),
    [anon_sym_true] = ACTIONS(1971),
    [anon_sym_false] = ACTIONS(1971),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1971),
    [sym_super] = ACTIONS(1971),
    [sym_crate] = ACTIONS(1971),
    [sym_metavariable] = ACTIONS(1969),
    [sym_raw_string_literal] = ACTIONS(1969),
    [sym_float_literal] = ACTIONS(1969),
    [sym_block_comment] = ACTIONS(3),
  },
  [411] = {
    [ts_builtin_sym_end] = ACTIONS(1973),
    [sym_identifier] = ACTIONS(1975),
    [anon_sym_SEMI] = ACTIONS(1973),
    [anon_sym_macro_rules_BANG] = ACTIONS(1973),
    [anon_sym_LPAREN] = ACTIONS(1973),
    [anon_sym_LBRACE] = ACTIONS(1973),
    [anon_sym_RBRACE] = ACTIONS(1973),
    [anon_sym_LBRACK] = ACTIONS(1973),
    [anon_sym_STAR] = ACTIONS(1973),
    [anon_sym_u8] = ACTIONS(1975),
    [anon_sym_i8] = ACTIONS(1975),
    [anon_sym_u16] = ACTIONS(1975),
    [anon_sym_i16] = ACTIONS(1975),
    [anon_sym_u32] = ACTIONS(1975),
    [anon_sym_i32] = ACTIONS(1975),
    [anon_sym_u64] = ACTIONS(1975),
    [anon_sym_i64] = ACTIONS(1975),
    [anon_sym_u128] = ACTIONS(1975),
    [anon_sym_i128] = ACTIONS(1975),
    [anon_sym_isize] = ACTIONS(1975),
    [anon_sym_usize] = ACTIONS(1975),
    [anon_sym_f32] = ACTIONS(1975),
    [anon_sym_f64] = ACTIONS(1975),
    [anon_sym_bool] = ACTIONS(1975),
    [anon_sym_str] = ACTIONS(1975),
    [anon_sym_char] = ACTIONS(1975),
    [anon_sym_SQUOTE] = ACTIONS(1975),
    [anon_sym_async] = ACTIONS(1975),
    [anon_sym_break] = ACTIONS(1975),
    [anon_sym_const] = ACTIONS(1975),
    [anon_sym_continue] = ACTIONS(1975),
    [anon_sym_default] = ACTIONS(1975),
    [anon_sym_enum] = ACTIONS(1975),
    [anon_sym_fn] = ACTIONS(1975),
    [anon_sym_for] = ACTIONS(1975),
    [anon_sym_if] = ACTIONS(1975),
    [anon_sym_impl] = ACTIONS(1975),
    [anon_sym_let] = ACTIONS(1975),
    [anon_sym_loop] = ACTIONS(1975),
    [anon_sym_match] = ACTIONS(1975),
    [anon_sym_mod] = ACTIONS(1975),
    [anon_sym_pub] = ACTIONS(1975),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_static] = ACTIONS(1975),
    [anon_sym_struct] = ACTIONS(1975),
    [anon_sym_trait] = ACTIONS(1975),
    [anon_sym_type] = ACTIONS(1975),
    [anon_sym_union] = ACTIONS(1975),
    [anon_sym_unsafe] = ACTIONS(1975),
    [anon_sym_use] = ACTIONS(1975),
    [anon_sym_while] = ACTIONS(1975),
    [anon_sym_POUND] = ACTIONS(1973),
    [anon_sym_BANG] = ACTIONS(1973),
    [anon_sym_extern] = ACTIONS(1975),
    [anon_sym_LT] = ACTIONS(1973),
    [anon_sym_COLON_COLON] = ACTIONS(1973),
    [anon_sym_AMP] = ACTIONS(1973),
    [anon_sym_DOT_DOT] = ACTIONS(1973),
    [anon_sym_DASH] = ACTIONS(1973),
    [anon_sym_PIPE] = ACTIONS(1973),
    [anon_sym_move] = ACTIONS(1975),
    [sym_integer_literal] = ACTIONS(1973),
    [aux_sym_string_literal_token1] = ACTIONS(1973),
    [sym_char_literal] = ACTIONS(1973),
    [anon_sym_true] = ACTIONS(1975),
    [anon_sym_false] = ACTIONS(1975),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1975),
    [sym_super] = ACTIONS(1975),
    [sym_crate] = ACTIONS(1975),
    [sym_metavariable] = ACTIONS(1973),
    [sym_raw_string_literal] = ACTIONS(1973),
    [sym_float_literal] = ACTIONS(1973),
    [sym_block_comment] = ACTIONS(3),
  },
  [412] = {
    [ts_builtin_sym_end] = ACTIONS(1977),
    [sym_identifier] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym_macro_rules_BANG] = ACTIONS(1977),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_u8] = ACTIONS(1979),
    [anon_sym_i8] = ACTIONS(1979),
    [anon_sym_u16] = ACTIONS(1979),
    [anon_sym_i16] = ACTIONS(1979),
    [anon_sym_u32] = ACTIONS(1979),
    [anon_sym_i32] = ACTIONS(1979),
    [anon_sym_u64] = ACTIONS(1979),
    [anon_sym_i64] = ACTIONS(1979),
    [anon_sym_u128] = ACTIONS(1979),
    [anon_sym_i128] = ACTIONS(1979),
    [anon_sym_isize] = ACTIONS(1979),
    [anon_sym_usize] = ACTIONS(1979),
    [anon_sym_f32] = ACTIONS(1979),
    [anon_sym_f64] = ACTIONS(1979),
    [anon_sym_bool] = ACTIONS(1979),
    [anon_sym_str] = ACTIONS(1979),
    [anon_sym_char] = ACTIONS(1979),
    [anon_sym_SQUOTE] = ACTIONS(1979),
    [anon_sym_async] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_continue] = ACTIONS(1979),
    [anon_sym_default] = ACTIONS(1979),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_fn] = ACTIONS(1979),
    [anon_sym_for] = ACTIONS(1979),
    [anon_sym_if] = ACTIONS(1979),
    [anon_sym_impl] = ACTIONS(1979),
    [anon_sym_let] = ACTIONS(1979),
    [anon_sym_loop] = ACTIONS(1979),
    [anon_sym_match] = ACTIONS(1979),
    [anon_sym_mod] = ACTIONS(1979),
    [anon_sym_pub] = ACTIONS(1979),
    [anon_sym_return] = ACTIONS(1979),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_struct] = ACTIONS(1979),
    [anon_sym_trait] = ACTIONS(1979),
    [anon_sym_type] = ACTIONS(1979),
    [anon_sym_union] = ACTIONS(1979),
    [anon_sym_unsafe] = ACTIONS(1979),
    [anon_sym_use] = ACTIONS(1979),
    [anon_sym_while] = ACTIONS(1979),
    [anon_sym_POUND] = ACTIONS(1977),
    [anon_sym_BANG] = ACTIONS(1977),
    [anon_sym_extern] = ACTIONS(1979),
    [anon_sym_LT] = ACTIONS(1977),
    [anon_sym_COLON_COLON] = ACTIONS(1977),
    [anon_sym_AMP] = ACTIONS(1977),
    [anon_sym_DOT_DOT] = ACTIONS(1977),
    [anon_sym_DASH] = ACTIONS(1977),
    [anon_sym_PIPE] = ACTIONS(1977),
    [anon_sym_move] = ACTIONS(1979),
    [sym_integer_literal] = ACTIONS(1977),
    [aux_sym_string_literal_token1] = ACTIONS(1977),
    [sym_char_literal] = ACTIONS(1977),
    [anon_sym_true] = ACTIONS(1979),
    [anon_sym_false] = ACTIONS(1979),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1979),
    [sym_super] = ACTIONS(1979),
    [sym_crate] = ACTIONS(1979),
    [sym_metavariable] = ACTIONS(1977),
    [sym_raw_string_literal] = ACTIONS(1977),
    [sym_float_literal] = ACTIONS(1977),
    [sym_block_comment] = ACTIONS(3),
  },
  [413] = {
    [ts_builtin_sym_end] = ACTIONS(1981),
    [sym_identifier] = ACTIONS(1983),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym_macro_rules_BANG] = ACTIONS(1981),
    [anon_sym_LPAREN] = ACTIONS(1981),
    [anon_sym_LBRACE] = ACTIONS(1981),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [anon_sym_LBRACK] = ACTIONS(1981),
    [anon_sym_STAR] = ACTIONS(1981),
    [anon_sym_u8] = ACTIONS(1983),
    [anon_sym_i8] = ACTIONS(1983),
    [anon_sym_u16] = ACTIONS(1983),
    [anon_sym_i16] = ACTIONS(1983),
    [anon_sym_u32] = ACTIONS(1983),
    [anon_sym_i32] = ACTIONS(1983),
    [anon_sym_u64] = ACTIONS(1983),
    [anon_sym_i64] = ACTIONS(1983),
    [anon_sym_u128] = ACTIONS(1983),
    [anon_sym_i128] = ACTIONS(1983),
    [anon_sym_isize] = ACTIONS(1983),
    [anon_sym_usize] = ACTIONS(1983),
    [anon_sym_f32] = ACTIONS(1983),
    [anon_sym_f64] = ACTIONS(1983),
    [anon_sym_bool] = ACTIONS(1983),
    [anon_sym_str] = ACTIONS(1983),
    [anon_sym_char] = ACTIONS(1983),
    [anon_sym_SQUOTE] = ACTIONS(1983),
    [anon_sym_async] = ACTIONS(1983),
    [anon_sym_break] = ACTIONS(1983),
    [anon_sym_const] = ACTIONS(1983),
    [anon_sym_continue] = ACTIONS(1983),
    [anon_sym_default] = ACTIONS(1983),
    [anon_sym_enum] = ACTIONS(1983),
    [anon_sym_fn] = ACTIONS(1983),
    [anon_sym_for] = ACTIONS(1983),
    [anon_sym_if] = ACTIONS(1983),
    [anon_sym_impl] = ACTIONS(1983),
    [anon_sym_let] = ACTIONS(1983),
    [anon_sym_loop] = ACTIONS(1983),
    [anon_sym_match] = ACTIONS(1983),
    [anon_sym_mod] = ACTIONS(1983),
    [anon_sym_pub] = ACTIONS(1983),
    [anon_sym_return] = ACTIONS(1983),
    [anon_sym_static] = ACTIONS(1983),
    [anon_sym_struct] = ACTIONS(1983),
    [anon_sym_trait] = ACTIONS(1983),
    [anon_sym_type] = ACTIONS(1983),
    [anon_sym_union] = ACTIONS(1983),
    [anon_sym_unsafe] = ACTIONS(1983),
    [anon_sym_use] = ACTIONS(1983),
    [anon_sym_while] = ACTIONS(1983),
    [anon_sym_POUND] = ACTIONS(1981),
    [anon_sym_BANG] = ACTIONS(1981),
    [anon_sym_extern] = ACTIONS(1983),
    [anon_sym_LT] = ACTIONS(1981),
    [anon_sym_COLON_COLON] = ACTIONS(1981),
    [anon_sym_AMP] = ACTIONS(1981),
    [anon_sym_DOT_DOT] = ACTIONS(1981),
    [anon_sym_DASH] = ACTIONS(1981),
    [anon_sym_PIPE] = ACTIONS(1981),
    [anon_sym_move] = ACTIONS(1983),
    [sym_integer_literal] = ACTIONS(1981),
    [aux_sym_string_literal_token1] = ACTIONS(1981),
    [sym_char_literal] = ACTIONS(1981),
    [anon_sym_true] = ACTIONS(1983),
    [anon_sym_false] = ACTIONS(1983),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1983),
    [sym_super] = ACTIONS(1983),
    [sym_crate] = ACTIONS(1983),
    [sym_metavariable] = ACTIONS(1981),
    [sym_raw_string_literal] = ACTIONS(1981),
    [sym_float_literal] = ACTIONS(1981),
    [sym_block_comment] = ACTIONS(3),
  },
  [414] = {
    [ts_builtin_sym_end] = ACTIONS(1985),
    [sym_identifier] = ACTIONS(1987),
    [anon_sym_SEMI] = ACTIONS(1985),
    [anon_sym_macro_rules_BANG] = ACTIONS(1985),
    [anon_sym_LPAREN] = ACTIONS(1985),
    [anon_sym_LBRACE] = ACTIONS(1985),
    [anon_sym_RBRACE] = ACTIONS(1985),
    [anon_sym_LBRACK] = ACTIONS(1985),
    [anon_sym_STAR] = ACTIONS(1985),
    [anon_sym_u8] = ACTIONS(1987),
    [anon_sym_i8] = ACTIONS(1987),
    [anon_sym_u16] = ACTIONS(1987),
    [anon_sym_i16] = ACTIONS(1987),
    [anon_sym_u32] = ACTIONS(1987),
    [anon_sym_i32] = ACTIONS(1987),
    [anon_sym_u64] = ACTIONS(1987),
    [anon_sym_i64] = ACTIONS(1987),
    [anon_sym_u128] = ACTIONS(1987),
    [anon_sym_i128] = ACTIONS(1987),
    [anon_sym_isize] = ACTIONS(1987),
    [anon_sym_usize] = ACTIONS(1987),
    [anon_sym_f32] = ACTIONS(1987),
    [anon_sym_f64] = ACTIONS(1987),
    [anon_sym_bool] = ACTIONS(1987),
    [anon_sym_str] = ACTIONS(1987),
    [anon_sym_char] = ACTIONS(1987),
    [anon_sym_SQUOTE] = ACTIONS(1987),
    [anon_sym_async] = ACTIONS(1987),
    [anon_sym_break] = ACTIONS(1987),
    [anon_sym_const] = ACTIONS(1987),
    [anon_sym_continue] = ACTIONS(1987),
    [anon_sym_default] = ACTIONS(1987),
    [anon_sym_enum] = ACTIONS(1987),
    [anon_sym_fn] = ACTIONS(1987),
    [anon_sym_for] = ACTIONS(1987),
    [anon_sym_if] = ACTIONS(1987),
    [anon_sym_impl] = ACTIONS(1987),
    [anon_sym_let] = ACTIONS(1987),
    [anon_sym_loop] = ACTIONS(1987),
    [anon_sym_match] = ACTIONS(1987),
    [anon_sym_mod] = ACTIONS(1987),
    [anon_sym_pub] = ACTIONS(1987),
    [anon_sym_return] = ACTIONS(1987),
    [anon_sym_static] = ACTIONS(1987),
    [anon_sym_struct] = ACTIONS(1987),
    [anon_sym_trait] = ACTIONS(1987),
    [anon_sym_type] = ACTIONS(1987),
    [anon_sym_union] = ACTIONS(1987),
    [anon_sym_unsafe] = ACTIONS(1987),
    [anon_sym_use] = ACTIONS(1987),
    [anon_sym_while] = ACTIONS(1987),
    [anon_sym_POUND] = ACTIONS(1985),
    [anon_sym_BANG] = ACTIONS(1985),
    [anon_sym_extern] = ACTIONS(1987),
    [anon_sym_LT] = ACTIONS(1985),
    [anon_sym_COLON_COLON] = ACTIONS(1985),
    [anon_sym_AMP] = ACTIONS(1985),
    [anon_sym_DOT_DOT] = ACTIONS(1985),
    [anon_sym_DASH] = ACTIONS(1985),
    [anon_sym_PIPE] = ACTIONS(1985),
    [anon_sym_move] = ACTIONS(1987),
    [sym_integer_literal] = ACTIONS(1985),
    [aux_sym_string_literal_token1] = ACTIONS(1985),
    [sym_char_literal] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(1987),
    [anon_sym_false] = ACTIONS(1987),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1987),
    [sym_super] = ACTIONS(1987),
    [sym_crate] = ACTIONS(1987),
    [sym_metavariable] = ACTIONS(1985),
    [sym_raw_string_literal] = ACTIONS(1985),
    [sym_float_literal] = ACTIONS(1985),
    [sym_block_comment] = ACTIONS(3),
  },
  [415] = {
    [ts_builtin_sym_end] = ACTIONS(1989),
    [sym_identifier] = ACTIONS(1991),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym_macro_rules_BANG] = ACTIONS(1989),
    [anon_sym_LPAREN] = ACTIONS(1989),
    [anon_sym_LBRACE] = ACTIONS(1989),
    [anon_sym_RBRACE] = ACTIONS(1989),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_STAR] = ACTIONS(1989),
    [anon_sym_u8] = ACTIONS(1991),
    [anon_sym_i8] = ACTIONS(1991),
    [anon_sym_u16] = ACTIONS(1991),
    [anon_sym_i16] = ACTIONS(1991),
    [anon_sym_u32] = ACTIONS(1991),
    [anon_sym_i32] = ACTIONS(1991),
    [anon_sym_u64] = ACTIONS(1991),
    [anon_sym_i64] = ACTIONS(1991),
    [anon_sym_u128] = ACTIONS(1991),
    [anon_sym_i128] = ACTIONS(1991),
    [anon_sym_isize] = ACTIONS(1991),
    [anon_sym_usize] = ACTIONS(1991),
    [anon_sym_f32] = ACTIONS(1991),
    [anon_sym_f64] = ACTIONS(1991),
    [anon_sym_bool] = ACTIONS(1991),
    [anon_sym_str] = ACTIONS(1991),
    [anon_sym_char] = ACTIONS(1991),
    [anon_sym_SQUOTE] = ACTIONS(1991),
    [anon_sym_async] = ACTIONS(1991),
    [anon_sym_break] = ACTIONS(1991),
    [anon_sym_const] = ACTIONS(1991),
    [anon_sym_continue] = ACTIONS(1991),
    [anon_sym_default] = ACTIONS(1991),
    [anon_sym_enum] = ACTIONS(1991),
    [anon_sym_fn] = ACTIONS(1991),
    [anon_sym_for] = ACTIONS(1991),
    [anon_sym_if] = ACTIONS(1991),
    [anon_sym_impl] = ACTIONS(1991),
    [anon_sym_let] = ACTIONS(1991),
    [anon_sym_loop] = ACTIONS(1991),
    [anon_sym_match] = ACTIONS(1991),
    [anon_sym_mod] = ACTIONS(1991),
    [anon_sym_pub] = ACTIONS(1991),
    [anon_sym_return] = ACTIONS(1991),
    [anon_sym_static] = ACTIONS(1991),
    [anon_sym_struct] = ACTIONS(1991),
    [anon_sym_trait] = ACTIONS(1991),
    [anon_sym_type] = ACTIONS(1991),
    [anon_sym_union] = ACTIONS(1991),
    [anon_sym_unsafe] = ACTIONS(1991),
    [anon_sym_use] = ACTIONS(1991),
    [anon_sym_while] = ACTIONS(1991),
    [anon_sym_POUND] = ACTIONS(1989),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_extern] = ACTIONS(1991),
    [anon_sym_LT] = ACTIONS(1989),
    [anon_sym_COLON_COLON] = ACTIONS(1989),
    [anon_sym_AMP] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1989),
    [anon_sym_DASH] = ACTIONS(1989),
    [anon_sym_PIPE] = ACTIONS(1989),
    [anon_sym_move] = ACTIONS(1991),
    [sym_integer_literal] = ACTIONS(1989),
    [aux_sym_string_literal_token1] = ACTIONS(1989),
    [sym_char_literal] = ACTIONS(1989),
    [anon_sym_true] = ACTIONS(1991),
    [anon_sym_false] = ACTIONS(1991),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1991),
    [sym_super] = ACTIONS(1991),
    [sym_crate] = ACTIONS(1991),
    [sym_metavariable] = ACTIONS(1989),
    [sym_raw_string_literal] = ACTIONS(1989),
    [sym_float_literal] = ACTIONS(1989),
    [sym_block_comment] = ACTIONS(3),
  },
  [416] = {
    [ts_builtin_sym_end] = ACTIONS(1993),
    [sym_identifier] = ACTIONS(1995),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym_macro_rules_BANG] = ACTIONS(1993),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACE] = ACTIONS(1993),
    [anon_sym_RBRACE] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1993),
    [anon_sym_STAR] = ACTIONS(1993),
    [anon_sym_u8] = ACTIONS(1995),
    [anon_sym_i8] = ACTIONS(1995),
    [anon_sym_u16] = ACTIONS(1995),
    [anon_sym_i16] = ACTIONS(1995),
    [anon_sym_u32] = ACTIONS(1995),
    [anon_sym_i32] = ACTIONS(1995),
    [anon_sym_u64] = ACTIONS(1995),
    [anon_sym_i64] = ACTIONS(1995),
    [anon_sym_u128] = ACTIONS(1995),
    [anon_sym_i128] = ACTIONS(1995),
    [anon_sym_isize] = ACTIONS(1995),
    [anon_sym_usize] = ACTIONS(1995),
    [anon_sym_f32] = ACTIONS(1995),
    [anon_sym_f64] = ACTIONS(1995),
    [anon_sym_bool] = ACTIONS(1995),
    [anon_sym_str] = ACTIONS(1995),
    [anon_sym_char] = ACTIONS(1995),
    [anon_sym_SQUOTE] = ACTIONS(1995),
    [anon_sym_async] = ACTIONS(1995),
    [anon_sym_break] = ACTIONS(1995),
    [anon_sym_const] = ACTIONS(1995),
    [anon_sym_continue] = ACTIONS(1995),
    [anon_sym_default] = ACTIONS(1995),
    [anon_sym_enum] = ACTIONS(1995),
    [anon_sym_fn] = ACTIONS(1995),
    [anon_sym_for] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(1995),
    [anon_sym_impl] = ACTIONS(1995),
    [anon_sym_let] = ACTIONS(1995),
    [anon_sym_loop] = ACTIONS(1995),
    [anon_sym_match] = ACTIONS(1995),
    [anon_sym_mod] = ACTIONS(1995),
    [anon_sym_pub] = ACTIONS(1995),
    [anon_sym_return] = ACTIONS(1995),
    [anon_sym_static] = ACTIONS(1995),
    [anon_sym_struct] = ACTIONS(1995),
    [anon_sym_trait] = ACTIONS(1995),
    [anon_sym_type] = ACTIONS(1995),
    [anon_sym_union] = ACTIONS(1995),
    [anon_sym_unsafe] = ACTIONS(1995),
    [anon_sym_use] = ACTIONS(1995),
    [anon_sym_while] = ACTIONS(1995),
    [anon_sym_POUND] = ACTIONS(1993),
    [anon_sym_BANG] = ACTIONS(1993),
    [anon_sym_extern] = ACTIONS(1995),
    [anon_sym_LT] = ACTIONS(1993),
    [anon_sym_COLON_COLON] = ACTIONS(1993),
    [anon_sym_AMP] = ACTIONS(1993),
    [anon_sym_DOT_DOT] = ACTIONS(1993),
    [anon_sym_DASH] = ACTIONS(1993),
    [anon_sym_PIPE] = ACTIONS(1993),
    [anon_sym_move] = ACTIONS(1995),
    [sym_integer_literal] = ACTIONS(1993),
    [aux_sym_string_literal_token1] = ACTIONS(1993),
    [sym_char_literal] = ACTIONS(1993),
    [anon_sym_true] = ACTIONS(1995),
    [anon_sym_false] = ACTIONS(1995),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1995),
    [sym_super] = ACTIONS(1995),
    [sym_crate] = ACTIONS(1995),
    [sym_metavariable] = ACTIONS(1993),
    [sym_raw_string_literal] = ACTIONS(1993),
    [sym_float_literal] = ACTIONS(1993),
    [sym_block_comment] = ACTIONS(3),
  },
  [417] = {
    [ts_builtin_sym_end] = ACTIONS(1997),
    [sym_identifier] = ACTIONS(1999),
    [anon_sym_SEMI] = ACTIONS(1997),
    [anon_sym_macro_rules_BANG] = ACTIONS(1997),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_LBRACE] = ACTIONS(1997),
    [anon_sym_RBRACE] = ACTIONS(1997),
    [anon_sym_LBRACK] = ACTIONS(1997),
    [anon_sym_STAR] = ACTIONS(1997),
    [anon_sym_u8] = ACTIONS(1999),
    [anon_sym_i8] = ACTIONS(1999),
    [anon_sym_u16] = ACTIONS(1999),
    [anon_sym_i16] = ACTIONS(1999),
    [anon_sym_u32] = ACTIONS(1999),
    [anon_sym_i32] = ACTIONS(1999),
    [anon_sym_u64] = ACTIONS(1999),
    [anon_sym_i64] = ACTIONS(1999),
    [anon_sym_u128] = ACTIONS(1999),
    [anon_sym_i128] = ACTIONS(1999),
    [anon_sym_isize] = ACTIONS(1999),
    [anon_sym_usize] = ACTIONS(1999),
    [anon_sym_f32] = ACTIONS(1999),
    [anon_sym_f64] = ACTIONS(1999),
    [anon_sym_bool] = ACTIONS(1999),
    [anon_sym_str] = ACTIONS(1999),
    [anon_sym_char] = ACTIONS(1999),
    [anon_sym_SQUOTE] = ACTIONS(1999),
    [anon_sym_async] = ACTIONS(1999),
    [anon_sym_break] = ACTIONS(1999),
    [anon_sym_const] = ACTIONS(1999),
    [anon_sym_continue] = ACTIONS(1999),
    [anon_sym_default] = ACTIONS(1999),
    [anon_sym_enum] = ACTIONS(1999),
    [anon_sym_fn] = ACTIONS(1999),
    [anon_sym_for] = ACTIONS(1999),
    [anon_sym_if] = ACTIONS(1999),
    [anon_sym_impl] = ACTIONS(1999),
    [anon_sym_let] = ACTIONS(1999),
    [anon_sym_loop] = ACTIONS(1999),
    [anon_sym_match] = ACTIONS(1999),
    [anon_sym_mod] = ACTIONS(1999),
    [anon_sym_pub] = ACTIONS(1999),
    [anon_sym_return] = ACTIONS(1999),
    [anon_sym_static] = ACTIONS(1999),
    [anon_sym_struct] = ACTIONS(1999),
    [anon_sym_trait] = ACTIONS(1999),
    [anon_sym_type] = ACTIONS(1999),
    [anon_sym_union] = ACTIONS(1999),
    [anon_sym_unsafe] = ACTIONS(1999),
    [anon_sym_use] = ACTIONS(1999),
    [anon_sym_while] = ACTIONS(1999),
    [anon_sym_POUND] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1997),
    [anon_sym_extern] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(1997),
    [anon_sym_COLON_COLON] = ACTIONS(1997),
    [anon_sym_AMP] = ACTIONS(1997),
    [anon_sym_DOT_DOT] = ACTIONS(1997),
    [anon_sym_DASH] = ACTIONS(1997),
    [anon_sym_PIPE] = ACTIONS(1997),
    [anon_sym_move] = ACTIONS(1999),
    [sym_integer_literal] = ACTIONS(1997),
    [aux_sym_string_literal_token1] = ACTIONS(1997),
    [sym_char_literal] = ACTIONS(1997),
    [anon_sym_true] = ACTIONS(1999),
    [anon_sym_false] = ACTIONS(1999),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1999),
    [sym_super] = ACTIONS(1999),
    [sym_crate] = ACTIONS(1999),
    [sym_metavariable] = ACTIONS(1997),
    [sym_raw_string_literal] = ACTIONS(1997),
    [sym_float_literal] = ACTIONS(1997),
    [sym_block_comment] = ACTIONS(3),
  },
  [418] = {
    [ts_builtin_sym_end] = ACTIONS(2001),
    [sym_identifier] = ACTIONS(2003),
    [anon_sym_SEMI] = ACTIONS(2001),
    [anon_sym_macro_rules_BANG] = ACTIONS(2001),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [anon_sym_LBRACE] = ACTIONS(2001),
    [anon_sym_RBRACE] = ACTIONS(2001),
    [anon_sym_LBRACK] = ACTIONS(2001),
    [anon_sym_STAR] = ACTIONS(2001),
    [anon_sym_u8] = ACTIONS(2003),
    [anon_sym_i8] = ACTIONS(2003),
    [anon_sym_u16] = ACTIONS(2003),
    [anon_sym_i16] = ACTIONS(2003),
    [anon_sym_u32] = ACTIONS(2003),
    [anon_sym_i32] = ACTIONS(2003),
    [anon_sym_u64] = ACTIONS(2003),
    [anon_sym_i64] = ACTIONS(2003),
    [anon_sym_u128] = ACTIONS(2003),
    [anon_sym_i128] = ACTIONS(2003),
    [anon_sym_isize] = ACTIONS(2003),
    [anon_sym_usize] = ACTIONS(2003),
    [anon_sym_f32] = ACTIONS(2003),
    [anon_sym_f64] = ACTIONS(2003),
    [anon_sym_bool] = ACTIONS(2003),
    [anon_sym_str] = ACTIONS(2003),
    [anon_sym_char] = ACTIONS(2003),
    [anon_sym_SQUOTE] = ACTIONS(2003),
    [anon_sym_async] = ACTIONS(2003),
    [anon_sym_break] = ACTIONS(2003),
    [anon_sym_const] = ACTIONS(2003),
    [anon_sym_continue] = ACTIONS(2003),
    [anon_sym_default] = ACTIONS(2003),
    [anon_sym_enum] = ACTIONS(2003),
    [anon_sym_fn] = ACTIONS(2003),
    [anon_sym_for] = ACTIONS(2003),
    [anon_sym_if] = ACTIONS(2003),
    [anon_sym_impl] = ACTIONS(2003),
    [anon_sym_let] = ACTIONS(2003),
    [anon_sym_loop] = ACTIONS(2003),
    [anon_sym_match] = ACTIONS(2003),
    [anon_sym_mod] = ACTIONS(2003),
    [anon_sym_pub] = ACTIONS(2003),
    [anon_sym_return] = ACTIONS(2003),
    [anon_sym_static] = ACTIONS(2003),
    [anon_sym_struct] = ACTIONS(2003),
    [anon_sym_trait] = ACTIONS(2003),
    [anon_sym_type] = ACTIONS(2003),
    [anon_sym_union] = ACTIONS(2003),
    [anon_sym_unsafe] = ACTIONS(2003),
    [anon_sym_use] = ACTIONS(2003),
    [anon_sym_while] = ACTIONS(2003),
    [anon_sym_POUND] = ACTIONS(2001),
    [anon_sym_BANG] = ACTIONS(2001),
    [anon_sym_extern] = ACTIONS(2003),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_COLON_COLON] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
    [anon_sym_DOT_DOT] = ACTIONS(2001),
    [anon_sym_DASH] = ACTIONS(2001),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_move] = ACTIONS(2003),
    [sym_integer_literal] = ACTIONS(2001),
    [aux_sym_string_literal_token1] = ACTIONS(2001),
    [sym_char_literal] = ACTIONS(2001),
    [anon_sym_true] = ACTIONS(2003),
    [anon_sym_false] = ACTIONS(2003),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2003),
    [sym_super] = ACTIONS(2003),
    [sym_crate] = ACTIONS(2003),
    [sym_metavariable] = ACTIONS(2001),
    [sym_raw_string_literal] = ACTIONS(2001),
    [sym_float_literal] = ACTIONS(2001),
    [sym_block_comment] = ACTIONS(3),
  },
  [419] = {
    [ts_builtin_sym_end] = ACTIONS(2005),
    [sym_identifier] = ACTIONS(2007),
    [anon_sym_SEMI] = ACTIONS(2005),
    [anon_sym_macro_rules_BANG] = ACTIONS(2005),
    [anon_sym_LPAREN] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(2005),
    [anon_sym_RBRACE] = ACTIONS(2005),
    [anon_sym_LBRACK] = ACTIONS(2005),
    [anon_sym_STAR] = ACTIONS(2005),
    [anon_sym_u8] = ACTIONS(2007),
    [anon_sym_i8] = ACTIONS(2007),
    [anon_sym_u16] = ACTIONS(2007),
    [anon_sym_i16] = ACTIONS(2007),
    [anon_sym_u32] = ACTIONS(2007),
    [anon_sym_i32] = ACTIONS(2007),
    [anon_sym_u64] = ACTIONS(2007),
    [anon_sym_i64] = ACTIONS(2007),
    [anon_sym_u128] = ACTIONS(2007),
    [anon_sym_i128] = ACTIONS(2007),
    [anon_sym_isize] = ACTIONS(2007),
    [anon_sym_usize] = ACTIONS(2007),
    [anon_sym_f32] = ACTIONS(2007),
    [anon_sym_f64] = ACTIONS(2007),
    [anon_sym_bool] = ACTIONS(2007),
    [anon_sym_str] = ACTIONS(2007),
    [anon_sym_char] = ACTIONS(2007),
    [anon_sym_SQUOTE] = ACTIONS(2007),
    [anon_sym_async] = ACTIONS(2007),
    [anon_sym_break] = ACTIONS(2007),
    [anon_sym_const] = ACTIONS(2007),
    [anon_sym_continue] = ACTIONS(2007),
    [anon_sym_default] = ACTIONS(2007),
    [anon_sym_enum] = ACTIONS(2007),
    [anon_sym_fn] = ACTIONS(2007),
    [anon_sym_for] = ACTIONS(2007),
    [anon_sym_if] = ACTIONS(2007),
    [anon_sym_impl] = ACTIONS(2007),
    [anon_sym_let] = ACTIONS(2007),
    [anon_sym_loop] = ACTIONS(2007),
    [anon_sym_match] = ACTIONS(2007),
    [anon_sym_mod] = ACTIONS(2007),
    [anon_sym_pub] = ACTIONS(2007),
    [anon_sym_return] = ACTIONS(2007),
    [anon_sym_static] = ACTIONS(2007),
    [anon_sym_struct] = ACTIONS(2007),
    [anon_sym_trait] = ACTIONS(2007),
    [anon_sym_type] = ACTIONS(2007),
    [anon_sym_union] = ACTIONS(2007),
    [anon_sym_unsafe] = ACTIONS(2007),
    [anon_sym_use] = ACTIONS(2007),
    [anon_sym_while] = ACTIONS(2007),
    [anon_sym_POUND] = ACTIONS(2005),
    [anon_sym_BANG] = ACTIONS(2005),
    [anon_sym_extern] = ACTIONS(2007),
    [anon_sym_LT] = ACTIONS(2005),
    [anon_sym_COLON_COLON] = ACTIONS(2005),
    [anon_sym_AMP] = ACTIONS(2005),
    [anon_sym_DOT_DOT] = ACTIONS(2005),
    [anon_sym_DASH] = ACTIONS(2005),
    [anon_sym_PIPE] = ACTIONS(2005),
    [anon_sym_move] = ACTIONS(2007),
    [sym_integer_literal] = ACTIONS(2005),
    [aux_sym_string_literal_token1] = ACTIONS(2005),
    [sym_char_literal] = ACTIONS(2005),
    [anon_sym_true] = ACTIONS(2007),
    [anon_sym_false] = ACTIONS(2007),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2007),
    [sym_super] = ACTIONS(2007),
    [sym_crate] = ACTIONS(2007),
    [sym_metavariable] = ACTIONS(2005),
    [sym_raw_string_literal] = ACTIONS(2005),
    [sym_float_literal] = ACTIONS(2005),
    [sym_block_comment] = ACTIONS(3),
  },
  [420] = {
    [ts_builtin_sym_end] = ACTIONS(2009),
    [sym_identifier] = ACTIONS(2011),
    [anon_sym_SEMI] = ACTIONS(2009),
    [anon_sym_macro_rules_BANG] = ACTIONS(2009),
    [anon_sym_LPAREN] = ACTIONS(2009),
    [anon_sym_LBRACE] = ACTIONS(2009),
    [anon_sym_RBRACE] = ACTIONS(2009),
    [anon_sym_LBRACK] = ACTIONS(2009),
    [anon_sym_STAR] = ACTIONS(2009),
    [anon_sym_u8] = ACTIONS(2011),
    [anon_sym_i8] = ACTIONS(2011),
    [anon_sym_u16] = ACTIONS(2011),
    [anon_sym_i16] = ACTIONS(2011),
    [anon_sym_u32] = ACTIONS(2011),
    [anon_sym_i32] = ACTIONS(2011),
    [anon_sym_u64] = ACTIONS(2011),
    [anon_sym_i64] = ACTIONS(2011),
    [anon_sym_u128] = ACTIONS(2011),
    [anon_sym_i128] = ACTIONS(2011),
    [anon_sym_isize] = ACTIONS(2011),
    [anon_sym_usize] = ACTIONS(2011),
    [anon_sym_f32] = ACTIONS(2011),
    [anon_sym_f64] = ACTIONS(2011),
    [anon_sym_bool] = ACTIONS(2011),
    [anon_sym_str] = ACTIONS(2011),
    [anon_sym_char] = ACTIONS(2011),
    [anon_sym_SQUOTE] = ACTIONS(2011),
    [anon_sym_async] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2011),
    [anon_sym_const] = ACTIONS(2011),
    [anon_sym_continue] = ACTIONS(2011),
    [anon_sym_default] = ACTIONS(2011),
    [anon_sym_enum] = ACTIONS(2011),
    [anon_sym_fn] = ACTIONS(2011),
    [anon_sym_for] = ACTIONS(2011),
    [anon_sym_if] = ACTIONS(2011),
    [anon_sym_impl] = ACTIONS(2011),
    [anon_sym_let] = ACTIONS(2011),
    [anon_sym_loop] = ACTIONS(2011),
    [anon_sym_match] = ACTIONS(2011),
    [anon_sym_mod] = ACTIONS(2011),
    [anon_sym_pub] = ACTIONS(2011),
    [anon_sym_return] = ACTIONS(2011),
    [anon_sym_static] = ACTIONS(2011),
    [anon_sym_struct] = ACTIONS(2011),
    [anon_sym_trait] = ACTIONS(2011),
    [anon_sym_type] = ACTIONS(2011),
    [anon_sym_union] = ACTIONS(2011),
    [anon_sym_unsafe] = ACTIONS(2011),
    [anon_sym_use] = ACTIONS(2011),
    [anon_sym_while] = ACTIONS(2011),
    [anon_sym_POUND] = ACTIONS(2009),
    [anon_sym_BANG] = ACTIONS(2009),
    [anon_sym_extern] = ACTIONS(2011),
    [anon_sym_LT] = ACTIONS(2009),
    [anon_sym_COLON_COLON] = ACTIONS(2009),
    [anon_sym_AMP] = ACTIONS(2009),
    [anon_sym_DOT_DOT] = ACTIONS(2009),
    [anon_sym_DASH] = ACTIONS(2009),
    [anon_sym_PIPE] = ACTIONS(2009),
    [anon_sym_move] = ACTIONS(2011),
    [sym_integer_literal] = ACTIONS(2009),
    [aux_sym_string_literal_token1] = ACTIONS(2009),
    [sym_char_literal] = ACTIONS(2009),
    [anon_sym_true] = ACTIONS(2011),
    [anon_sym_false] = ACTIONS(2011),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2011),
    [sym_super] = ACTIONS(2011),
    [sym_crate] = ACTIONS(2011),
    [sym_metavariable] = ACTIONS(2009),
    [sym_raw_string_literal] = ACTIONS(2009),
    [sym_float_literal] = ACTIONS(2009),
    [sym_block_comment] = ACTIONS(3),
  },
  [421] = {
    [sym__token_pattern] = STATE(209),
    [sym_token_tree_pattern] = STATE(209),
    [sym_token_binding_pattern] = STATE(209),
    [sym_token_repetition_pattern] = STATE(209),
    [sym__literal] = STATE(209),
    [sym_string_literal] = STATE(209),
    [sym_boolean_literal] = STATE(209),
    [aux_sym_token_tree_pattern_repeat1] = STATE(209),
    [sym_identifier] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_RBRACK] = ACTIONS(2013),
    [anon_sym_DOLLAR] = ACTIONS(1321),
    [anon_sym_u8] = ACTIONS(1323),
    [anon_sym_i8] = ACTIONS(1323),
    [anon_sym_u16] = ACTIONS(1323),
    [anon_sym_i16] = ACTIONS(1323),
    [anon_sym_u32] = ACTIONS(1323),
    [anon_sym_i32] = ACTIONS(1323),
    [anon_sym_u64] = ACTIONS(1323),
    [anon_sym_i64] = ACTIONS(1323),
    [anon_sym_u128] = ACTIONS(1323),
    [anon_sym_i128] = ACTIONS(1323),
    [anon_sym_isize] = ACTIONS(1323),
    [anon_sym_usize] = ACTIONS(1323),
    [anon_sym_f32] = ACTIONS(1323),
    [anon_sym_f64] = ACTIONS(1323),
    [anon_sym_bool] = ACTIONS(1323),
    [anon_sym_str] = ACTIONS(1323),
    [anon_sym_char] = ACTIONS(1323),
    [aux_sym__non_special_token_token1] = ACTIONS(1311),
    [anon_sym_SQUOTE] = ACTIONS(1311),
    [anon_sym_as] = ACTIONS(1311),
    [anon_sym_async] = ACTIONS(1311),
    [anon_sym_await] = ACTIONS(1311),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_const] = ACTIONS(1311),
    [anon_sym_continue] = ACTIONS(1311),
    [anon_sym_default] = ACTIONS(1311),
    [anon_sym_enum] = ACTIONS(1311),
    [anon_sym_fn] = ACTIONS(1311),
    [anon_sym_for] = ACTIONS(1311),
    [anon_sym_if] = ACTIONS(1311),
    [anon_sym_impl] = ACTIONS(1311),
    [anon_sym_let] = ACTIONS(1311),
    [anon_sym_loop] = ACTIONS(1311),
    [anon_sym_match] = ACTIONS(1311),
    [anon_sym_mod] = ACTIONS(1311),
    [anon_sym_pub] = ACTIONS(1311),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_struct] = ACTIONS(1311),
    [anon_sym_trait] = ACTIONS(1311),
    [anon_sym_type] = ACTIONS(1311),
    [anon_sym_union] = ACTIONS(1311),
    [anon_sym_unsafe] = ACTIONS(1311),
    [anon_sym_use] = ACTIONS(1311),
    [anon_sym_where] = ACTIONS(1311),
    [anon_sym_while] = ACTIONS(1311),
    [sym_mutable_specifier] = ACTIONS(1311),
    [sym_integer_literal] = ACTIONS(1325),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(1325),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(1311),
    [sym_super] = ACTIONS(1311),
    [sym_crate] = ACTIONS(1311),
    [sym_metavariable] = ACTIONS(1331),
    [sym_raw_string_literal] = ACTIONS(1325),
    [sym_float_literal] = ACTIONS(1325),
    [sym_block_comment] = ACTIONS(3),
  },
  [422] = {
    [ts_builtin_sym_end] = ACTIONS(2015),
    [sym_identifier] = ACTIONS(2017),
    [anon_sym_SEMI] = ACTIONS(2015),
    [anon_sym_macro_rules_BANG] = ACTIONS(2015),
    [anon_sym_LPAREN] = ACTIONS(2015),
    [anon_sym_LBRACE] = ACTIONS(2015),
    [anon_sym_RBRACE] = ACTIONS(2015),
    [anon_sym_LBRACK] = ACTIONS(2015),
    [anon_sym_STAR] = ACTIONS(2015),
    [anon_sym_u8] = ACTIONS(2017),
    [anon_sym_i8] = ACTIONS(2017),
    [anon_sym_u16] = ACTIONS(2017),
    [anon_sym_i16] = ACTIONS(2017),
    [anon_sym_u32] = ACTIONS(2017),
    [anon_sym_i32] = ACTIONS(2017),
    [anon_sym_u64] = ACTIONS(2017),
    [anon_sym_i64] = ACTIONS(2017),
    [anon_sym_u128] = ACTIONS(2017),
    [anon_sym_i128] = ACTIONS(2017),
    [anon_sym_isize] = ACTIONS(2017),
    [anon_sym_usize] = ACTIONS(2017),
    [anon_sym_f32] = ACTIONS(2017),
    [anon_sym_f64] = ACTIONS(2017),
    [anon_sym_bool] = ACTIONS(2017),
    [anon_sym_str] = ACTIONS(2017),
    [anon_sym_char] = ACTIONS(2017),
    [anon_sym_SQUOTE] = ACTIONS(2017),
    [anon_sym_async] = ACTIONS(2017),
    [anon_sym_break] = ACTIONS(2017),
    [anon_sym_const] = ACTIONS(2017),
    [anon_sym_continue] = ACTIONS(2017),
    [anon_sym_default] = ACTIONS(2017),
    [anon_sym_enum] = ACTIONS(2017),
    [anon_sym_fn] = ACTIONS(2017),
    [anon_sym_for] = ACTIONS(2017),
    [anon_sym_if] = ACTIONS(2017),
    [anon_sym_impl] = ACTIONS(2017),
    [anon_sym_let] = ACTIONS(2017),
    [anon_sym_loop] = ACTIONS(2017),
    [anon_sym_match] = ACTIONS(2017),
    [anon_sym_mod] = ACTIONS(2017),
    [anon_sym_pub] = ACTIONS(2017),
    [anon_sym_return] = ACTIONS(2017),
    [anon_sym_static] = ACTIONS(2017),
    [anon_sym_struct] = ACTIONS(2017),
    [anon_sym_trait] = ACTIONS(2017),
    [anon_sym_type] = ACTIONS(2017),
    [anon_sym_union] = ACTIONS(2017),
    [anon_sym_unsafe] = ACTIONS(2017),
    [anon_sym_use] = ACTIONS(2017),
    [anon_sym_while] = ACTIONS(2017),
    [anon_sym_POUND] = ACTIONS(2015),
    [anon_sym_BANG] = ACTIONS(2015),
    [anon_sym_extern] = ACTIONS(2017),
    [anon_sym_LT] = ACTIONS(2015),
    [anon_sym_COLON_COLON] = ACTIONS(2015),
    [anon_sym_AMP] = ACTIONS(2015),
    [anon_sym_DOT_DOT] = ACTIONS(2015),
    [anon_sym_DASH] = ACTIONS(2015),
    [anon_sym_PIPE] = ACTIONS(2015),
    [anon_sym_move] = ACTIONS(2017),
    [sym_integer_literal] = ACTIONS(2015),
    [aux_sym_string_literal_token1] = ACTIONS(2015),
    [sym_char_literal] = ACTIONS(2015),
    [anon_sym_true] = ACTIONS(2017),
    [anon_sym_false] = ACTIONS(2017),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2017),
    [sym_super] = ACTIONS(2017),
    [sym_crate] = ACTIONS(2017),
    [sym_metavariable] = ACTIONS(2015),
    [sym_raw_string_literal] = ACTIONS(2015),
    [sym_float_literal] = ACTIONS(2015),
    [sym_block_comment] = ACTIONS(3),
  },
  [423] = {
    [sym__token_pattern] = STATE(209),
    [sym_token_tree_pattern] = STATE(209),
    [sym_token_binding_pattern] = STATE(209),
    [sym_token_repetition_pattern] = STATE(209),
    [sym__literal] = STATE(209),
    [sym_string_literal] = STATE(209),
    [sym_boolean_literal] = STATE(209),
    [aux_sym_token_tree_pattern_repeat1] = STATE(209),
    [sym_identifier] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(2013),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_DOLLAR] = ACTIONS(1321),
    [anon_sym_u8] = ACTIONS(1323),
    [anon_sym_i8] = ACTIONS(1323),
    [anon_sym_u16] = ACTIONS(1323),
    [anon_sym_i16] = ACTIONS(1323),
    [anon_sym_u32] = ACTIONS(1323),
    [anon_sym_i32] = ACTIONS(1323),
    [anon_sym_u64] = ACTIONS(1323),
    [anon_sym_i64] = ACTIONS(1323),
    [anon_sym_u128] = ACTIONS(1323),
    [anon_sym_i128] = ACTIONS(1323),
    [anon_sym_isize] = ACTIONS(1323),
    [anon_sym_usize] = ACTIONS(1323),
    [anon_sym_f32] = ACTIONS(1323),
    [anon_sym_f64] = ACTIONS(1323),
    [anon_sym_bool] = ACTIONS(1323),
    [anon_sym_str] = ACTIONS(1323),
    [anon_sym_char] = ACTIONS(1323),
    [aux_sym__non_special_token_token1] = ACTIONS(1311),
    [anon_sym_SQUOTE] = ACTIONS(1311),
    [anon_sym_as] = ACTIONS(1311),
    [anon_sym_async] = ACTIONS(1311),
    [anon_sym_await] = ACTIONS(1311),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_const] = ACTIONS(1311),
    [anon_sym_continue] = ACTIONS(1311),
    [anon_sym_default] = ACTIONS(1311),
    [anon_sym_enum] = ACTIONS(1311),
    [anon_sym_fn] = ACTIONS(1311),
    [anon_sym_for] = ACTIONS(1311),
    [anon_sym_if] = ACTIONS(1311),
    [anon_sym_impl] = ACTIONS(1311),
    [anon_sym_let] = ACTIONS(1311),
    [anon_sym_loop] = ACTIONS(1311),
    [anon_sym_match] = ACTIONS(1311),
    [anon_sym_mod] = ACTIONS(1311),
    [anon_sym_pub] = ACTIONS(1311),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_struct] = ACTIONS(1311),
    [anon_sym_trait] = ACTIONS(1311),
    [anon_sym_type] = ACTIONS(1311),
    [anon_sym_union] = ACTIONS(1311),
    [anon_sym_unsafe] = ACTIONS(1311),
    [anon_sym_use] = ACTIONS(1311),
    [anon_sym_where] = ACTIONS(1311),
    [anon_sym_while] = ACTIONS(1311),
    [sym_mutable_specifier] = ACTIONS(1311),
    [sym_integer_literal] = ACTIONS(1325),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(1325),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(1311),
    [sym_super] = ACTIONS(1311),
    [sym_crate] = ACTIONS(1311),
    [sym_metavariable] = ACTIONS(1331),
    [sym_raw_string_literal] = ACTIONS(1325),
    [sym_float_literal] = ACTIONS(1325),
    [sym_block_comment] = ACTIONS(3),
  },
  [424] = {
    [ts_builtin_sym_end] = ACTIONS(2019),
    [sym_identifier] = ACTIONS(2021),
    [anon_sym_SEMI] = ACTIONS(2019),
    [anon_sym_macro_rules_BANG] = ACTIONS(2019),
    [anon_sym_LPAREN] = ACTIONS(2019),
    [anon_sym_LBRACE] = ACTIONS(2019),
    [anon_sym_RBRACE] = ACTIONS(2019),
    [anon_sym_LBRACK] = ACTIONS(2019),
    [anon_sym_STAR] = ACTIONS(2019),
    [anon_sym_u8] = ACTIONS(2021),
    [anon_sym_i8] = ACTIONS(2021),
    [anon_sym_u16] = ACTIONS(2021),
    [anon_sym_i16] = ACTIONS(2021),
    [anon_sym_u32] = ACTIONS(2021),
    [anon_sym_i32] = ACTIONS(2021),
    [anon_sym_u64] = ACTIONS(2021),
    [anon_sym_i64] = ACTIONS(2021),
    [anon_sym_u128] = ACTIONS(2021),
    [anon_sym_i128] = ACTIONS(2021),
    [anon_sym_isize] = ACTIONS(2021),
    [anon_sym_usize] = ACTIONS(2021),
    [anon_sym_f32] = ACTIONS(2021),
    [anon_sym_f64] = ACTIONS(2021),
    [anon_sym_bool] = ACTIONS(2021),
    [anon_sym_str] = ACTIONS(2021),
    [anon_sym_char] = ACTIONS(2021),
    [anon_sym_SQUOTE] = ACTIONS(2021),
    [anon_sym_async] = ACTIONS(2021),
    [anon_sym_break] = ACTIONS(2021),
    [anon_sym_const] = ACTIONS(2021),
    [anon_sym_continue] = ACTIONS(2021),
    [anon_sym_default] = ACTIONS(2021),
    [anon_sym_enum] = ACTIONS(2021),
    [anon_sym_fn] = ACTIONS(2021),
    [anon_sym_for] = ACTIONS(2021),
    [anon_sym_if] = ACTIONS(2021),
    [anon_sym_impl] = ACTIONS(2021),
    [anon_sym_let] = ACTIONS(2021),
    [anon_sym_loop] = ACTIONS(2021),
    [anon_sym_match] = ACTIONS(2021),
    [anon_sym_mod] = ACTIONS(2021),
    [anon_sym_pub] = ACTIONS(2021),
    [anon_sym_return] = ACTIONS(2021),
    [anon_sym_static] = ACTIONS(2021),
    [anon_sym_struct] = ACTIONS(2021),
    [anon_sym_trait] = ACTIONS(2021),
    [anon_sym_type] = ACTIONS(2021),
    [anon_sym_union] = ACTIONS(2021),
    [anon_sym_unsafe] = ACTIONS(2021),
    [anon_sym_use] = ACTIONS(2021),
    [anon_sym_while] = ACTIONS(2021),
    [anon_sym_POUND] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2019),
    [anon_sym_extern] = ACTIONS(2021),
    [anon_sym_LT] = ACTIONS(2019),
    [anon_sym_COLON_COLON] = ACTIONS(2019),
    [anon_sym_AMP] = ACTIONS(2019),
    [anon_sym_DOT_DOT] = ACTIONS(2019),
    [anon_sym_DASH] = ACTIONS(2019),
    [anon_sym_PIPE] = ACTIONS(2019),
    [anon_sym_move] = ACTIONS(2021),
    [sym_integer_literal] = ACTIONS(2019),
    [aux_sym_string_literal_token1] = ACTIONS(2019),
    [sym_char_literal] = ACTIONS(2019),
    [anon_sym_true] = ACTIONS(2021),
    [anon_sym_false] = ACTIONS(2021),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2021),
    [sym_super] = ACTIONS(2021),
    [sym_crate] = ACTIONS(2021),
    [sym_metavariable] = ACTIONS(2019),
    [sym_raw_string_literal] = ACTIONS(2019),
    [sym_float_literal] = ACTIONS(2019),
    [sym_block_comment] = ACTIONS(3),
  },
  [425] = {
    [sym__token_pattern] = STATE(209),
    [sym_token_tree_pattern] = STATE(209),
    [sym_token_binding_pattern] = STATE(209),
    [sym_token_repetition_pattern] = STATE(209),
    [sym__literal] = STATE(209),
    [sym_string_literal] = STATE(209),
    [sym_boolean_literal] = STATE(209),
    [aux_sym_token_tree_pattern_repeat1] = STATE(209),
    [sym_identifier] = ACTIONS(1311),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_RPAREN] = ACTIONS(2013),
    [anon_sym_LBRACE] = ACTIONS(1317),
    [anon_sym_LBRACK] = ACTIONS(1319),
    [anon_sym_DOLLAR] = ACTIONS(1321),
    [anon_sym_u8] = ACTIONS(1323),
    [anon_sym_i8] = ACTIONS(1323),
    [anon_sym_u16] = ACTIONS(1323),
    [anon_sym_i16] = ACTIONS(1323),
    [anon_sym_u32] = ACTIONS(1323),
    [anon_sym_i32] = ACTIONS(1323),
    [anon_sym_u64] = ACTIONS(1323),
    [anon_sym_i64] = ACTIONS(1323),
    [anon_sym_u128] = ACTIONS(1323),
    [anon_sym_i128] = ACTIONS(1323),
    [anon_sym_isize] = ACTIONS(1323),
    [anon_sym_usize] = ACTIONS(1323),
    [anon_sym_f32] = ACTIONS(1323),
    [anon_sym_f64] = ACTIONS(1323),
    [anon_sym_bool] = ACTIONS(1323),
    [anon_sym_str] = ACTIONS(1323),
    [anon_sym_char] = ACTIONS(1323),
    [aux_sym__non_special_token_token1] = ACTIONS(1311),
    [anon_sym_SQUOTE] = ACTIONS(1311),
    [anon_sym_as] = ACTIONS(1311),
    [anon_sym_async] = ACTIONS(1311),
    [anon_sym_await] = ACTIONS(1311),
    [anon_sym_break] = ACTIONS(1311),
    [anon_sym_const] = ACTIONS(1311),
    [anon_sym_continue] = ACTIONS(1311),
    [anon_sym_default] = ACTIONS(1311),
    [anon_sym_enum] = ACTIONS(1311),
    [anon_sym_fn] = ACTIONS(1311),
    [anon_sym_for] = ACTIONS(1311),
    [anon_sym_if] = ACTIONS(1311),
    [anon_sym_impl] = ACTIONS(1311),
    [anon_sym_let] = ACTIONS(1311),
    [anon_sym_loop] = ACTIONS(1311),
    [anon_sym_match] = ACTIONS(1311),
    [anon_sym_mod] = ACTIONS(1311),
    [anon_sym_pub] = ACTIONS(1311),
    [anon_sym_return] = ACTIONS(1311),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_struct] = ACTIONS(1311),
    [anon_sym_trait] = ACTIONS(1311),
    [anon_sym_type] = ACTIONS(1311),
    [anon_sym_union] = ACTIONS(1311),
    [anon_sym_unsafe] = ACTIONS(1311),
    [anon_sym_use] = ACTIONS(1311),
    [anon_sym_where] = ACTIONS(1311),
    [anon_sym_while] = ACTIONS(1311),
    [sym_mutable_specifier] = ACTIONS(1311),
    [sym_integer_literal] = ACTIONS(1325),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(1325),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(1311),
    [sym_super] = ACTIONS(1311),
    [sym_crate] = ACTIONS(1311),
    [sym_metavariable] = ACTIONS(1331),
    [sym_raw_string_literal] = ACTIONS(1325),
    [sym_float_literal] = ACTIONS(1325),
    [sym_block_comment] = ACTIONS(3),
  },
  [426] = {
    [sym_token_tree] = STATE(426),
    [sym_token_repetition] = STATE(426),
    [sym__literal] = STATE(426),
    [sym_string_literal] = STATE(426),
    [sym_boolean_literal] = STATE(426),
    [aux_sym_token_tree_repeat1] = STATE(426),
    [sym_identifier] = ACTIONS(2023),
    [anon_sym_LPAREN] = ACTIONS(2026),
    [anon_sym_RPAREN] = ACTIONS(2029),
    [anon_sym_LBRACE] = ACTIONS(2031),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_LBRACK] = ACTIONS(2034),
    [anon_sym_RBRACK] = ACTIONS(2029),
    [anon_sym_DOLLAR] = ACTIONS(2037),
    [anon_sym_u8] = ACTIONS(2040),
    [anon_sym_i8] = ACTIONS(2040),
    [anon_sym_u16] = ACTIONS(2040),
    [anon_sym_i16] = ACTIONS(2040),
    [anon_sym_u32] = ACTIONS(2040),
    [anon_sym_i32] = ACTIONS(2040),
    [anon_sym_u64] = ACTIONS(2040),
    [anon_sym_i64] = ACTIONS(2040),
    [anon_sym_u128] = ACTIONS(2040),
    [anon_sym_i128] = ACTIONS(2040),
    [anon_sym_isize] = ACTIONS(2040),
    [anon_sym_usize] = ACTIONS(2040),
    [anon_sym_f32] = ACTIONS(2040),
    [anon_sym_f64] = ACTIONS(2040),
    [anon_sym_bool] = ACTIONS(2040),
    [anon_sym_str] = ACTIONS(2040),
    [anon_sym_char] = ACTIONS(2040),
    [aux_sym__non_special_token_token1] = ACTIONS(2023),
    [anon_sym_SQUOTE] = ACTIONS(2023),
    [anon_sym_as] = ACTIONS(2023),
    [anon_sym_async] = ACTIONS(2023),
    [anon_sym_await] = ACTIONS(2023),
    [anon_sym_break] = ACTIONS(2023),
    [anon_sym_const] = ACTIONS(2023),
    [anon_sym_continue] = ACTIONS(2023),
    [anon_sym_default] = ACTIONS(2023),
    [anon_sym_enum] = ACTIONS(2023),
    [anon_sym_fn] = ACTIONS(2023),
    [anon_sym_for] = ACTIONS(2023),
    [anon_sym_if] = ACTIONS(2023),
    [anon_sym_impl] = ACTIONS(2023),
    [anon_sym_let] = ACTIONS(2023),
    [anon_sym_loop] = ACTIONS(2023),
    [anon_sym_match] = ACTIONS(2023),
    [anon_sym_mod] = ACTIONS(2023),
    [anon_sym_pub] = ACTIONS(2023),
    [anon_sym_return] = ACTIONS(2023),
    [anon_sym_static] = ACTIONS(2023),
    [anon_sym_struct] = ACTIONS(2023),
    [anon_sym_trait] = ACTIONS(2023),
    [anon_sym_type] = ACTIONS(2023),
    [anon_sym_union] = ACTIONS(2023),
    [anon_sym_unsafe] = ACTIONS(2023),
    [anon_sym_use] = ACTIONS(2023),
    [anon_sym_where] = ACTIONS(2023),
    [anon_sym_while] = ACTIONS(2023),
    [sym_mutable_specifier] = ACTIONS(2023),
    [sym_integer_literal] = ACTIONS(2043),
    [aux_sym_string_literal_token1] = ACTIONS(2046),
    [sym_char_literal] = ACTIONS(2043),
    [anon_sym_true] = ACTIONS(2049),
    [anon_sym_false] = ACTIONS(2049),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2023),
    [sym_super] = ACTIONS(2023),
    [sym_crate] = ACTIONS(2023),
    [sym_metavariable] = ACTIONS(2043),
    [sym_raw_string_literal] = ACTIONS(2043),
    [sym_float_literal] = ACTIONS(2043),
    [sym_block_comment] = ACTIONS(3),
  },
  [427] = {
    [ts_builtin_sym_end] = ACTIONS(2052),
    [sym_identifier] = ACTIONS(2054),
    [anon_sym_SEMI] = ACTIONS(2052),
    [anon_sym_macro_rules_BANG] = ACTIONS(2052),
    [anon_sym_LPAREN] = ACTIONS(2052),
    [anon_sym_LBRACE] = ACTIONS(2052),
    [anon_sym_RBRACE] = ACTIONS(2052),
    [anon_sym_LBRACK] = ACTIONS(2052),
    [anon_sym_STAR] = ACTIONS(2052),
    [anon_sym_u8] = ACTIONS(2054),
    [anon_sym_i8] = ACTIONS(2054),
    [anon_sym_u16] = ACTIONS(2054),
    [anon_sym_i16] = ACTIONS(2054),
    [anon_sym_u32] = ACTIONS(2054),
    [anon_sym_i32] = ACTIONS(2054),
    [anon_sym_u64] = ACTIONS(2054),
    [anon_sym_i64] = ACTIONS(2054),
    [anon_sym_u128] = ACTIONS(2054),
    [anon_sym_i128] = ACTIONS(2054),
    [anon_sym_isize] = ACTIONS(2054),
    [anon_sym_usize] = ACTIONS(2054),
    [anon_sym_f32] = ACTIONS(2054),
    [anon_sym_f64] = ACTIONS(2054),
    [anon_sym_bool] = ACTIONS(2054),
    [anon_sym_str] = ACTIONS(2054),
    [anon_sym_char] = ACTIONS(2054),
    [anon_sym_SQUOTE] = ACTIONS(2054),
    [anon_sym_async] = ACTIONS(2054),
    [anon_sym_break] = ACTIONS(2054),
    [anon_sym_const] = ACTIONS(2054),
    [anon_sym_continue] = ACTIONS(2054),
    [anon_sym_default] = ACTIONS(2054),
    [anon_sym_enum] = ACTIONS(2054),
    [anon_sym_fn] = ACTIONS(2054),
    [anon_sym_for] = ACTIONS(2054),
    [anon_sym_if] = ACTIONS(2054),
    [anon_sym_impl] = ACTIONS(2054),
    [anon_sym_let] = ACTIONS(2054),
    [anon_sym_loop] = ACTIONS(2054),
    [anon_sym_match] = ACTIONS(2054),
    [anon_sym_mod] = ACTIONS(2054),
    [anon_sym_pub] = ACTIONS(2054),
    [anon_sym_return] = ACTIONS(2054),
    [anon_sym_static] = ACTIONS(2054),
    [anon_sym_struct] = ACTIONS(2054),
    [anon_sym_trait] = ACTIONS(2054),
    [anon_sym_type] = ACTIONS(2054),
    [anon_sym_union] = ACTIONS(2054),
    [anon_sym_unsafe] = ACTIONS(2054),
    [anon_sym_use] = ACTIONS(2054),
    [anon_sym_while] = ACTIONS(2054),
    [anon_sym_POUND] = ACTIONS(2052),
    [anon_sym_BANG] = ACTIONS(2052),
    [anon_sym_extern] = ACTIONS(2054),
    [anon_sym_LT] = ACTIONS(2052),
    [anon_sym_COLON_COLON] = ACTIONS(2052),
    [anon_sym_AMP] = ACTIONS(2052),
    [anon_sym_DOT_DOT] = ACTIONS(2052),
    [anon_sym_DASH] = ACTIONS(2052),
    [anon_sym_PIPE] = ACTIONS(2052),
    [anon_sym_move] = ACTIONS(2054),
    [sym_integer_literal] = ACTIONS(2052),
    [aux_sym_string_literal_token1] = ACTIONS(2052),
    [sym_char_literal] = ACTIONS(2052),
    [anon_sym_true] = ACTIONS(2054),
    [anon_sym_false] = ACTIONS(2054),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2054),
    [sym_super] = ACTIONS(2054),
    [sym_crate] = ACTIONS(2054),
    [sym_metavariable] = ACTIONS(2052),
    [sym_raw_string_literal] = ACTIONS(2052),
    [sym_float_literal] = ACTIONS(2052),
    [sym_block_comment] = ACTIONS(3),
  },
  [428] = {
    [ts_builtin_sym_end] = ACTIONS(2056),
    [sym_identifier] = ACTIONS(2058),
    [anon_sym_SEMI] = ACTIONS(2056),
    [anon_sym_macro_rules_BANG] = ACTIONS(2056),
    [anon_sym_LPAREN] = ACTIONS(2056),
    [anon_sym_LBRACE] = ACTIONS(2056),
    [anon_sym_RBRACE] = ACTIONS(2056),
    [anon_sym_LBRACK] = ACTIONS(2056),
    [anon_sym_STAR] = ACTIONS(2056),
    [anon_sym_u8] = ACTIONS(2058),
    [anon_sym_i8] = ACTIONS(2058),
    [anon_sym_u16] = ACTIONS(2058),
    [anon_sym_i16] = ACTIONS(2058),
    [anon_sym_u32] = ACTIONS(2058),
    [anon_sym_i32] = ACTIONS(2058),
    [anon_sym_u64] = ACTIONS(2058),
    [anon_sym_i64] = ACTIONS(2058),
    [anon_sym_u128] = ACTIONS(2058),
    [anon_sym_i128] = ACTIONS(2058),
    [anon_sym_isize] = ACTIONS(2058),
    [anon_sym_usize] = ACTIONS(2058),
    [anon_sym_f32] = ACTIONS(2058),
    [anon_sym_f64] = ACTIONS(2058),
    [anon_sym_bool] = ACTIONS(2058),
    [anon_sym_str] = ACTIONS(2058),
    [anon_sym_char] = ACTIONS(2058),
    [anon_sym_SQUOTE] = ACTIONS(2058),
    [anon_sym_async] = ACTIONS(2058),
    [anon_sym_break] = ACTIONS(2058),
    [anon_sym_const] = ACTIONS(2058),
    [anon_sym_continue] = ACTIONS(2058),
    [anon_sym_default] = ACTIONS(2058),
    [anon_sym_enum] = ACTIONS(2058),
    [anon_sym_fn] = ACTIONS(2058),
    [anon_sym_for] = ACTIONS(2058),
    [anon_sym_if] = ACTIONS(2058),
    [anon_sym_impl] = ACTIONS(2058),
    [anon_sym_let] = ACTIONS(2058),
    [anon_sym_loop] = ACTIONS(2058),
    [anon_sym_match] = ACTIONS(2058),
    [anon_sym_mod] = ACTIONS(2058),
    [anon_sym_pub] = ACTIONS(2058),
    [anon_sym_return] = ACTIONS(2058),
    [anon_sym_static] = ACTIONS(2058),
    [anon_sym_struct] = ACTIONS(2058),
    [anon_sym_trait] = ACTIONS(2058),
    [anon_sym_type] = ACTIONS(2058),
    [anon_sym_union] = ACTIONS(2058),
    [anon_sym_unsafe] = ACTIONS(2058),
    [anon_sym_use] = ACTIONS(2058),
    [anon_sym_while] = ACTIONS(2058),
    [anon_sym_POUND] = ACTIONS(2056),
    [anon_sym_BANG] = ACTIONS(2056),
    [anon_sym_extern] = ACTIONS(2058),
    [anon_sym_LT] = ACTIONS(2056),
    [anon_sym_COLON_COLON] = ACTIONS(2056),
    [anon_sym_AMP] = ACTIONS(2056),
    [anon_sym_DOT_DOT] = ACTIONS(2056),
    [anon_sym_DASH] = ACTIONS(2056),
    [anon_sym_PIPE] = ACTIONS(2056),
    [anon_sym_move] = ACTIONS(2058),
    [sym_integer_literal] = ACTIONS(2056),
    [aux_sym_string_literal_token1] = ACTIONS(2056),
    [sym_char_literal] = ACTIONS(2056),
    [anon_sym_true] = ACTIONS(2058),
    [anon_sym_false] = ACTIONS(2058),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2058),
    [sym_super] = ACTIONS(2058),
    [sym_crate] = ACTIONS(2058),
    [sym_metavariable] = ACTIONS(2056),
    [sym_raw_string_literal] = ACTIONS(2056),
    [sym_float_literal] = ACTIONS(2056),
    [sym_block_comment] = ACTIONS(3),
  },
  [429] = {
    [ts_builtin_sym_end] = ACTIONS(2060),
    [sym_identifier] = ACTIONS(2062),
    [anon_sym_SEMI] = ACTIONS(2060),
    [anon_sym_macro_rules_BANG] = ACTIONS(2060),
    [anon_sym_LPAREN] = ACTIONS(2060),
    [anon_sym_LBRACE] = ACTIONS(2060),
    [anon_sym_RBRACE] = ACTIONS(2060),
    [anon_sym_LBRACK] = ACTIONS(2060),
    [anon_sym_STAR] = ACTIONS(2060),
    [anon_sym_u8] = ACTIONS(2062),
    [anon_sym_i8] = ACTIONS(2062),
    [anon_sym_u16] = ACTIONS(2062),
    [anon_sym_i16] = ACTIONS(2062),
    [anon_sym_u32] = ACTIONS(2062),
    [anon_sym_i32] = ACTIONS(2062),
    [anon_sym_u64] = ACTIONS(2062),
    [anon_sym_i64] = ACTIONS(2062),
    [anon_sym_u128] = ACTIONS(2062),
    [anon_sym_i128] = ACTIONS(2062),
    [anon_sym_isize] = ACTIONS(2062),
    [anon_sym_usize] = ACTIONS(2062),
    [anon_sym_f32] = ACTIONS(2062),
    [anon_sym_f64] = ACTIONS(2062),
    [anon_sym_bool] = ACTIONS(2062),
    [anon_sym_str] = ACTIONS(2062),
    [anon_sym_char] = ACTIONS(2062),
    [anon_sym_SQUOTE] = ACTIONS(2062),
    [anon_sym_async] = ACTIONS(2062),
    [anon_sym_break] = ACTIONS(2062),
    [anon_sym_const] = ACTIONS(2062),
    [anon_sym_continue] = ACTIONS(2062),
    [anon_sym_default] = ACTIONS(2062),
    [anon_sym_enum] = ACTIONS(2062),
    [anon_sym_fn] = ACTIONS(2062),
    [anon_sym_for] = ACTIONS(2062),
    [anon_sym_if] = ACTIONS(2062),
    [anon_sym_impl] = ACTIONS(2062),
    [anon_sym_let] = ACTIONS(2062),
    [anon_sym_loop] = ACTIONS(2062),
    [anon_sym_match] = ACTIONS(2062),
    [anon_sym_mod] = ACTIONS(2062),
    [anon_sym_pub] = ACTIONS(2062),
    [anon_sym_return] = ACTIONS(2062),
    [anon_sym_static] = ACTIONS(2062),
    [anon_sym_struct] = ACTIONS(2062),
    [anon_sym_trait] = ACTIONS(2062),
    [anon_sym_type] = ACTIONS(2062),
    [anon_sym_union] = ACTIONS(2062),
    [anon_sym_unsafe] = ACTIONS(2062),
    [anon_sym_use] = ACTIONS(2062),
    [anon_sym_while] = ACTIONS(2062),
    [anon_sym_POUND] = ACTIONS(2060),
    [anon_sym_BANG] = ACTIONS(2060),
    [anon_sym_extern] = ACTIONS(2062),
    [anon_sym_LT] = ACTIONS(2060),
    [anon_sym_COLON_COLON] = ACTIONS(2060),
    [anon_sym_AMP] = ACTIONS(2060),
    [anon_sym_DOT_DOT] = ACTIONS(2060),
    [anon_sym_DASH] = ACTIONS(2060),
    [anon_sym_PIPE] = ACTIONS(2060),
    [anon_sym_move] = ACTIONS(2062),
    [sym_integer_literal] = ACTIONS(2060),
    [aux_sym_string_literal_token1] = ACTIONS(2060),
    [sym_char_literal] = ACTIONS(2060),
    [anon_sym_true] = ACTIONS(2062),
    [anon_sym_false] = ACTIONS(2062),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2062),
    [sym_super] = ACTIONS(2062),
    [sym_crate] = ACTIONS(2062),
    [sym_metavariable] = ACTIONS(2060),
    [sym_raw_string_literal] = ACTIONS(2060),
    [sym_float_literal] = ACTIONS(2060),
    [sym_block_comment] = ACTIONS(3),
  },
  [430] = {
    [ts_builtin_sym_end] = ACTIONS(2064),
    [sym_identifier] = ACTIONS(2066),
    [anon_sym_SEMI] = ACTIONS(2064),
    [anon_sym_macro_rules_BANG] = ACTIONS(2064),
    [anon_sym_LPAREN] = ACTIONS(2064),
    [anon_sym_LBRACE] = ACTIONS(2064),
    [anon_sym_RBRACE] = ACTIONS(2064),
    [anon_sym_LBRACK] = ACTIONS(2064),
    [anon_sym_STAR] = ACTIONS(2064),
    [anon_sym_u8] = ACTIONS(2066),
    [anon_sym_i8] = ACTIONS(2066),
    [anon_sym_u16] = ACTIONS(2066),
    [anon_sym_i16] = ACTIONS(2066),
    [anon_sym_u32] = ACTIONS(2066),
    [anon_sym_i32] = ACTIONS(2066),
    [anon_sym_u64] = ACTIONS(2066),
    [anon_sym_i64] = ACTIONS(2066),
    [anon_sym_u128] = ACTIONS(2066),
    [anon_sym_i128] = ACTIONS(2066),
    [anon_sym_isize] = ACTIONS(2066),
    [anon_sym_usize] = ACTIONS(2066),
    [anon_sym_f32] = ACTIONS(2066),
    [anon_sym_f64] = ACTIONS(2066),
    [anon_sym_bool] = ACTIONS(2066),
    [anon_sym_str] = ACTIONS(2066),
    [anon_sym_char] = ACTIONS(2066),
    [anon_sym_SQUOTE] = ACTIONS(2066),
    [anon_sym_async] = ACTIONS(2066),
    [anon_sym_break] = ACTIONS(2066),
    [anon_sym_const] = ACTIONS(2066),
    [anon_sym_continue] = ACTIONS(2066),
    [anon_sym_default] = ACTIONS(2066),
    [anon_sym_enum] = ACTIONS(2066),
    [anon_sym_fn] = ACTIONS(2066),
    [anon_sym_for] = ACTIONS(2066),
    [anon_sym_if] = ACTIONS(2066),
    [anon_sym_impl] = ACTIONS(2066),
    [anon_sym_let] = ACTIONS(2066),
    [anon_sym_loop] = ACTIONS(2066),
    [anon_sym_match] = ACTIONS(2066),
    [anon_sym_mod] = ACTIONS(2066),
    [anon_sym_pub] = ACTIONS(2066),
    [anon_sym_return] = ACTIONS(2066),
    [anon_sym_static] = ACTIONS(2066),
    [anon_sym_struct] = ACTIONS(2066),
    [anon_sym_trait] = ACTIONS(2066),
    [anon_sym_type] = ACTIONS(2066),
    [anon_sym_union] = ACTIONS(2066),
    [anon_sym_unsafe] = ACTIONS(2066),
    [anon_sym_use] = ACTIONS(2066),
    [anon_sym_while] = ACTIONS(2066),
    [anon_sym_POUND] = ACTIONS(2064),
    [anon_sym_BANG] = ACTIONS(2064),
    [anon_sym_extern] = ACTIONS(2066),
    [anon_sym_LT] = ACTIONS(2064),
    [anon_sym_COLON_COLON] = ACTIONS(2064),
    [anon_sym_AMP] = ACTIONS(2064),
    [anon_sym_DOT_DOT] = ACTIONS(2064),
    [anon_sym_DASH] = ACTIONS(2064),
    [anon_sym_PIPE] = ACTIONS(2064),
    [anon_sym_move] = ACTIONS(2066),
    [sym_integer_literal] = ACTIONS(2064),
    [aux_sym_string_literal_token1] = ACTIONS(2064),
    [sym_char_literal] = ACTIONS(2064),
    [anon_sym_true] = ACTIONS(2066),
    [anon_sym_false] = ACTIONS(2066),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2066),
    [sym_super] = ACTIONS(2066),
    [sym_crate] = ACTIONS(2066),
    [sym_metavariable] = ACTIONS(2064),
    [sym_raw_string_literal] = ACTIONS(2064),
    [sym_float_literal] = ACTIONS(2064),
    [sym_block_comment] = ACTIONS(3),
  },
  [431] = {
    [ts_builtin_sym_end] = ACTIONS(2068),
    [sym_identifier] = ACTIONS(2070),
    [anon_sym_SEMI] = ACTIONS(2068),
    [anon_sym_macro_rules_BANG] = ACTIONS(2068),
    [anon_sym_LPAREN] = ACTIONS(2068),
    [anon_sym_LBRACE] = ACTIONS(2068),
    [anon_sym_RBRACE] = ACTIONS(2068),
    [anon_sym_LBRACK] = ACTIONS(2068),
    [anon_sym_STAR] = ACTIONS(2068),
    [anon_sym_u8] = ACTIONS(2070),
    [anon_sym_i8] = ACTIONS(2070),
    [anon_sym_u16] = ACTIONS(2070),
    [anon_sym_i16] = ACTIONS(2070),
    [anon_sym_u32] = ACTIONS(2070),
    [anon_sym_i32] = ACTIONS(2070),
    [anon_sym_u64] = ACTIONS(2070),
    [anon_sym_i64] = ACTIONS(2070),
    [anon_sym_u128] = ACTIONS(2070),
    [anon_sym_i128] = ACTIONS(2070),
    [anon_sym_isize] = ACTIONS(2070),
    [anon_sym_usize] = ACTIONS(2070),
    [anon_sym_f32] = ACTIONS(2070),
    [anon_sym_f64] = ACTIONS(2070),
    [anon_sym_bool] = ACTIONS(2070),
    [anon_sym_str] = ACTIONS(2070),
    [anon_sym_char] = ACTIONS(2070),
    [anon_sym_SQUOTE] = ACTIONS(2070),
    [anon_sym_async] = ACTIONS(2070),
    [anon_sym_break] = ACTIONS(2070),
    [anon_sym_const] = ACTIONS(2070),
    [anon_sym_continue] = ACTIONS(2070),
    [anon_sym_default] = ACTIONS(2070),
    [anon_sym_enum] = ACTIONS(2070),
    [anon_sym_fn] = ACTIONS(2070),
    [anon_sym_for] = ACTIONS(2070),
    [anon_sym_if] = ACTIONS(2070),
    [anon_sym_impl] = ACTIONS(2070),
    [anon_sym_let] = ACTIONS(2070),
    [anon_sym_loop] = ACTIONS(2070),
    [anon_sym_match] = ACTIONS(2070),
    [anon_sym_mod] = ACTIONS(2070),
    [anon_sym_pub] = ACTIONS(2070),
    [anon_sym_return] = ACTIONS(2070),
    [anon_sym_static] = ACTIONS(2070),
    [anon_sym_struct] = ACTIONS(2070),
    [anon_sym_trait] = ACTIONS(2070),
    [anon_sym_type] = ACTIONS(2070),
    [anon_sym_union] = ACTIONS(2070),
    [anon_sym_unsafe] = ACTIONS(2070),
    [anon_sym_use] = ACTIONS(2070),
    [anon_sym_while] = ACTIONS(2070),
    [anon_sym_POUND] = ACTIONS(2068),
    [anon_sym_BANG] = ACTIONS(2068),
    [anon_sym_extern] = ACTIONS(2070),
    [anon_sym_LT] = ACTIONS(2068),
    [anon_sym_COLON_COLON] = ACTIONS(2068),
    [anon_sym_AMP] = ACTIONS(2068),
    [anon_sym_DOT_DOT] = ACTIONS(2068),
    [anon_sym_DASH] = ACTIONS(2068),
    [anon_sym_PIPE] = ACTIONS(2068),
    [anon_sym_move] = ACTIONS(2070),
    [sym_integer_literal] = ACTIONS(2068),
    [aux_sym_string_literal_token1] = ACTIONS(2068),
    [sym_char_literal] = ACTIONS(2068),
    [anon_sym_true] = ACTIONS(2070),
    [anon_sym_false] = ACTIONS(2070),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2070),
    [sym_super] = ACTIONS(2070),
    [sym_crate] = ACTIONS(2070),
    [sym_metavariable] = ACTIONS(2068),
    [sym_raw_string_literal] = ACTIONS(2068),
    [sym_float_literal] = ACTIONS(2068),
    [sym_block_comment] = ACTIONS(3),
  },
  [432] = {
    [ts_builtin_sym_end] = ACTIONS(2072),
    [sym_identifier] = ACTIONS(2074),
    [anon_sym_SEMI] = ACTIONS(2072),
    [anon_sym_macro_rules_BANG] = ACTIONS(2072),
    [anon_sym_LPAREN] = ACTIONS(2072),
    [anon_sym_LBRACE] = ACTIONS(2072),
    [anon_sym_RBRACE] = ACTIONS(2072),
    [anon_sym_LBRACK] = ACTIONS(2072),
    [anon_sym_STAR] = ACTIONS(2072),
    [anon_sym_u8] = ACTIONS(2074),
    [anon_sym_i8] = ACTIONS(2074),
    [anon_sym_u16] = ACTIONS(2074),
    [anon_sym_i16] = ACTIONS(2074),
    [anon_sym_u32] = ACTIONS(2074),
    [anon_sym_i32] = ACTIONS(2074),
    [anon_sym_u64] = ACTIONS(2074),
    [anon_sym_i64] = ACTIONS(2074),
    [anon_sym_u128] = ACTIONS(2074),
    [anon_sym_i128] = ACTIONS(2074),
    [anon_sym_isize] = ACTIONS(2074),
    [anon_sym_usize] = ACTIONS(2074),
    [anon_sym_f32] = ACTIONS(2074),
    [anon_sym_f64] = ACTIONS(2074),
    [anon_sym_bool] = ACTIONS(2074),
    [anon_sym_str] = ACTIONS(2074),
    [anon_sym_char] = ACTIONS(2074),
    [anon_sym_SQUOTE] = ACTIONS(2074),
    [anon_sym_async] = ACTIONS(2074),
    [anon_sym_break] = ACTIONS(2074),
    [anon_sym_const] = ACTIONS(2074),
    [anon_sym_continue] = ACTIONS(2074),
    [anon_sym_default] = ACTIONS(2074),
    [anon_sym_enum] = ACTIONS(2074),
    [anon_sym_fn] = ACTIONS(2074),
    [anon_sym_for] = ACTIONS(2074),
    [anon_sym_if] = ACTIONS(2074),
    [anon_sym_impl] = ACTIONS(2074),
    [anon_sym_let] = ACTIONS(2074),
    [anon_sym_loop] = ACTIONS(2074),
    [anon_sym_match] = ACTIONS(2074),
    [anon_sym_mod] = ACTIONS(2074),
    [anon_sym_pub] = ACTIONS(2074),
    [anon_sym_return] = ACTIONS(2074),
    [anon_sym_static] = ACTIONS(2074),
    [anon_sym_struct] = ACTIONS(2074),
    [anon_sym_trait] = ACTIONS(2074),
    [anon_sym_type] = ACTIONS(2074),
    [anon_sym_union] = ACTIONS(2074),
    [anon_sym_unsafe] = ACTIONS(2074),
    [anon_sym_use] = ACTIONS(2074),
    [anon_sym_while] = ACTIONS(2074),
    [anon_sym_POUND] = ACTIONS(2072),
    [anon_sym_BANG] = ACTIONS(2072),
    [anon_sym_extern] = ACTIONS(2074),
    [anon_sym_LT] = ACTIONS(2072),
    [anon_sym_COLON_COLON] = ACTIONS(2072),
    [anon_sym_AMP] = ACTIONS(2072),
    [anon_sym_DOT_DOT] = ACTIONS(2072),
    [anon_sym_DASH] = ACTIONS(2072),
    [anon_sym_PIPE] = ACTIONS(2072),
    [anon_sym_move] = ACTIONS(2074),
    [sym_integer_literal] = ACTIONS(2072),
    [aux_sym_string_literal_token1] = ACTIONS(2072),
    [sym_char_literal] = ACTIONS(2072),
    [anon_sym_true] = ACTIONS(2074),
    [anon_sym_false] = ACTIONS(2074),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2074),
    [sym_super] = ACTIONS(2074),
    [sym_crate] = ACTIONS(2074),
    [sym_metavariable] = ACTIONS(2072),
    [sym_raw_string_literal] = ACTIONS(2072),
    [sym_float_literal] = ACTIONS(2072),
    [sym_block_comment] = ACTIONS(3),
  },
  [433] = {
    [ts_builtin_sym_end] = ACTIONS(2076),
    [sym_identifier] = ACTIONS(2078),
    [anon_sym_SEMI] = ACTIONS(2076),
    [anon_sym_macro_rules_BANG] = ACTIONS(2076),
    [anon_sym_LPAREN] = ACTIONS(2076),
    [anon_sym_LBRACE] = ACTIONS(2076),
    [anon_sym_RBRACE] = ACTIONS(2076),
    [anon_sym_LBRACK] = ACTIONS(2076),
    [anon_sym_STAR] = ACTIONS(2076),
    [anon_sym_u8] = ACTIONS(2078),
    [anon_sym_i8] = ACTIONS(2078),
    [anon_sym_u16] = ACTIONS(2078),
    [anon_sym_i16] = ACTIONS(2078),
    [anon_sym_u32] = ACTIONS(2078),
    [anon_sym_i32] = ACTIONS(2078),
    [anon_sym_u64] = ACTIONS(2078),
    [anon_sym_i64] = ACTIONS(2078),
    [anon_sym_u128] = ACTIONS(2078),
    [anon_sym_i128] = ACTIONS(2078),
    [anon_sym_isize] = ACTIONS(2078),
    [anon_sym_usize] = ACTIONS(2078),
    [anon_sym_f32] = ACTIONS(2078),
    [anon_sym_f64] = ACTIONS(2078),
    [anon_sym_bool] = ACTIONS(2078),
    [anon_sym_str] = ACTIONS(2078),
    [anon_sym_char] = ACTIONS(2078),
    [anon_sym_SQUOTE] = ACTIONS(2078),
    [anon_sym_async] = ACTIONS(2078),
    [anon_sym_break] = ACTIONS(2078),
    [anon_sym_const] = ACTIONS(2078),
    [anon_sym_continue] = ACTIONS(2078),
    [anon_sym_default] = ACTIONS(2078),
    [anon_sym_enum] = ACTIONS(2078),
    [anon_sym_fn] = ACTIONS(2078),
    [anon_sym_for] = ACTIONS(2078),
    [anon_sym_if] = ACTIONS(2078),
    [anon_sym_impl] = ACTIONS(2078),
    [anon_sym_let] = ACTIONS(2078),
    [anon_sym_loop] = ACTIONS(2078),
    [anon_sym_match] = ACTIONS(2078),
    [anon_sym_mod] = ACTIONS(2078),
    [anon_sym_pub] = ACTIONS(2078),
    [anon_sym_return] = ACTIONS(2078),
    [anon_sym_static] = ACTIONS(2078),
    [anon_sym_struct] = ACTIONS(2078),
    [anon_sym_trait] = ACTIONS(2078),
    [anon_sym_type] = ACTIONS(2078),
    [anon_sym_union] = ACTIONS(2078),
    [anon_sym_unsafe] = ACTIONS(2078),
    [anon_sym_use] = ACTIONS(2078),
    [anon_sym_while] = ACTIONS(2078),
    [anon_sym_POUND] = ACTIONS(2076),
    [anon_sym_BANG] = ACTIONS(2076),
    [anon_sym_extern] = ACTIONS(2078),
    [anon_sym_LT] = ACTIONS(2076),
    [anon_sym_COLON_COLON] = ACTIONS(2076),
    [anon_sym_AMP] = ACTIONS(2076),
    [anon_sym_DOT_DOT] = ACTIONS(2076),
    [anon_sym_DASH] = ACTIONS(2076),
    [anon_sym_PIPE] = ACTIONS(2076),
    [anon_sym_move] = ACTIONS(2078),
    [sym_integer_literal] = ACTIONS(2076),
    [aux_sym_string_literal_token1] = ACTIONS(2076),
    [sym_char_literal] = ACTIONS(2076),
    [anon_sym_true] = ACTIONS(2078),
    [anon_sym_false] = ACTIONS(2078),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2078),
    [sym_super] = ACTIONS(2078),
    [sym_crate] = ACTIONS(2078),
    [sym_metavariable] = ACTIONS(2076),
    [sym_raw_string_literal] = ACTIONS(2076),
    [sym_float_literal] = ACTIONS(2076),
    [sym_block_comment] = ACTIONS(3),
  },
  [434] = {
    [ts_builtin_sym_end] = ACTIONS(2080),
    [sym_identifier] = ACTIONS(2082),
    [anon_sym_SEMI] = ACTIONS(2080),
    [anon_sym_macro_rules_BANG] = ACTIONS(2080),
    [anon_sym_LPAREN] = ACTIONS(2080),
    [anon_sym_LBRACE] = ACTIONS(2080),
    [anon_sym_RBRACE] = ACTIONS(2080),
    [anon_sym_LBRACK] = ACTIONS(2080),
    [anon_sym_STAR] = ACTIONS(2080),
    [anon_sym_u8] = ACTIONS(2082),
    [anon_sym_i8] = ACTIONS(2082),
    [anon_sym_u16] = ACTIONS(2082),
    [anon_sym_i16] = ACTIONS(2082),
    [anon_sym_u32] = ACTIONS(2082),
    [anon_sym_i32] = ACTIONS(2082),
    [anon_sym_u64] = ACTIONS(2082),
    [anon_sym_i64] = ACTIONS(2082),
    [anon_sym_u128] = ACTIONS(2082),
    [anon_sym_i128] = ACTIONS(2082),
    [anon_sym_isize] = ACTIONS(2082),
    [anon_sym_usize] = ACTIONS(2082),
    [anon_sym_f32] = ACTIONS(2082),
    [anon_sym_f64] = ACTIONS(2082),
    [anon_sym_bool] = ACTIONS(2082),
    [anon_sym_str] = ACTIONS(2082),
    [anon_sym_char] = ACTIONS(2082),
    [anon_sym_SQUOTE] = ACTIONS(2082),
    [anon_sym_async] = ACTIONS(2082),
    [anon_sym_break] = ACTIONS(2082),
    [anon_sym_const] = ACTIONS(2082),
    [anon_sym_continue] = ACTIONS(2082),
    [anon_sym_default] = ACTIONS(2082),
    [anon_sym_enum] = ACTIONS(2082),
    [anon_sym_fn] = ACTIONS(2082),
    [anon_sym_for] = ACTIONS(2082),
    [anon_sym_if] = ACTIONS(2082),
    [anon_sym_impl] = ACTIONS(2082),
    [anon_sym_let] = ACTIONS(2082),
    [anon_sym_loop] = ACTIONS(2082),
    [anon_sym_match] = ACTIONS(2082),
    [anon_sym_mod] = ACTIONS(2082),
    [anon_sym_pub] = ACTIONS(2082),
    [anon_sym_return] = ACTIONS(2082),
    [anon_sym_static] = ACTIONS(2082),
    [anon_sym_struct] = ACTIONS(2082),
    [anon_sym_trait] = ACTIONS(2082),
    [anon_sym_type] = ACTIONS(2082),
    [anon_sym_union] = ACTIONS(2082),
    [anon_sym_unsafe] = ACTIONS(2082),
    [anon_sym_use] = ACTIONS(2082),
    [anon_sym_while] = ACTIONS(2082),
    [anon_sym_POUND] = ACTIONS(2080),
    [anon_sym_BANG] = ACTIONS(2080),
    [anon_sym_extern] = ACTIONS(2082),
    [anon_sym_LT] = ACTIONS(2080),
    [anon_sym_COLON_COLON] = ACTIONS(2080),
    [anon_sym_AMP] = ACTIONS(2080),
    [anon_sym_DOT_DOT] = ACTIONS(2080),
    [anon_sym_DASH] = ACTIONS(2080),
    [anon_sym_PIPE] = ACTIONS(2080),
    [anon_sym_move] = ACTIONS(2082),
    [sym_integer_literal] = ACTIONS(2080),
    [aux_sym_string_literal_token1] = ACTIONS(2080),
    [sym_char_literal] = ACTIONS(2080),
    [anon_sym_true] = ACTIONS(2082),
    [anon_sym_false] = ACTIONS(2082),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2082),
    [sym_super] = ACTIONS(2082),
    [sym_crate] = ACTIONS(2082),
    [sym_metavariable] = ACTIONS(2080),
    [sym_raw_string_literal] = ACTIONS(2080),
    [sym_float_literal] = ACTIONS(2080),
    [sym_block_comment] = ACTIONS(3),
  },
  [435] = {
    [ts_builtin_sym_end] = ACTIONS(2084),
    [sym_identifier] = ACTIONS(2086),
    [anon_sym_SEMI] = ACTIONS(2084),
    [anon_sym_macro_rules_BANG] = ACTIONS(2084),
    [anon_sym_LPAREN] = ACTIONS(2084),
    [anon_sym_LBRACE] = ACTIONS(2084),
    [anon_sym_RBRACE] = ACTIONS(2084),
    [anon_sym_LBRACK] = ACTIONS(2084),
    [anon_sym_STAR] = ACTIONS(2084),
    [anon_sym_u8] = ACTIONS(2086),
    [anon_sym_i8] = ACTIONS(2086),
    [anon_sym_u16] = ACTIONS(2086),
    [anon_sym_i16] = ACTIONS(2086),
    [anon_sym_u32] = ACTIONS(2086),
    [anon_sym_i32] = ACTIONS(2086),
    [anon_sym_u64] = ACTIONS(2086),
    [anon_sym_i64] = ACTIONS(2086),
    [anon_sym_u128] = ACTIONS(2086),
    [anon_sym_i128] = ACTIONS(2086),
    [anon_sym_isize] = ACTIONS(2086),
    [anon_sym_usize] = ACTIONS(2086),
    [anon_sym_f32] = ACTIONS(2086),
    [anon_sym_f64] = ACTIONS(2086),
    [anon_sym_bool] = ACTIONS(2086),
    [anon_sym_str] = ACTIONS(2086),
    [anon_sym_char] = ACTIONS(2086),
    [anon_sym_SQUOTE] = ACTIONS(2086),
    [anon_sym_async] = ACTIONS(2086),
    [anon_sym_break] = ACTIONS(2086),
    [anon_sym_const] = ACTIONS(2086),
    [anon_sym_continue] = ACTIONS(2086),
    [anon_sym_default] = ACTIONS(2086),
    [anon_sym_enum] = ACTIONS(2086),
    [anon_sym_fn] = ACTIONS(2086),
    [anon_sym_for] = ACTIONS(2086),
    [anon_sym_if] = ACTIONS(2086),
    [anon_sym_impl] = ACTIONS(2086),
    [anon_sym_let] = ACTIONS(2086),
    [anon_sym_loop] = ACTIONS(2086),
    [anon_sym_match] = ACTIONS(2086),
    [anon_sym_mod] = ACTIONS(2086),
    [anon_sym_pub] = ACTIONS(2086),
    [anon_sym_return] = ACTIONS(2086),
    [anon_sym_static] = ACTIONS(2086),
    [anon_sym_struct] = ACTIONS(2086),
    [anon_sym_trait] = ACTIONS(2086),
    [anon_sym_type] = ACTIONS(2086),
    [anon_sym_union] = ACTIONS(2086),
    [anon_sym_unsafe] = ACTIONS(2086),
    [anon_sym_use] = ACTIONS(2086),
    [anon_sym_while] = ACTIONS(2086),
    [anon_sym_POUND] = ACTIONS(2084),
    [anon_sym_BANG] = ACTIONS(2084),
    [anon_sym_extern] = ACTIONS(2086),
    [anon_sym_LT] = ACTIONS(2084),
    [anon_sym_COLON_COLON] = ACTIONS(2084),
    [anon_sym_AMP] = ACTIONS(2084),
    [anon_sym_DOT_DOT] = ACTIONS(2084),
    [anon_sym_DASH] = ACTIONS(2084),
    [anon_sym_PIPE] = ACTIONS(2084),
    [anon_sym_move] = ACTIONS(2086),
    [sym_integer_literal] = ACTIONS(2084),
    [aux_sym_string_literal_token1] = ACTIONS(2084),
    [sym_char_literal] = ACTIONS(2084),
    [anon_sym_true] = ACTIONS(2086),
    [anon_sym_false] = ACTIONS(2086),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2086),
    [sym_super] = ACTIONS(2086),
    [sym_crate] = ACTIONS(2086),
    [sym_metavariable] = ACTIONS(2084),
    [sym_raw_string_literal] = ACTIONS(2084),
    [sym_float_literal] = ACTIONS(2084),
    [sym_block_comment] = ACTIONS(3),
  },
  [436] = {
    [ts_builtin_sym_end] = ACTIONS(2088),
    [sym_identifier] = ACTIONS(2090),
    [anon_sym_SEMI] = ACTIONS(2088),
    [anon_sym_macro_rules_BANG] = ACTIONS(2088),
    [anon_sym_LPAREN] = ACTIONS(2088),
    [anon_sym_LBRACE] = ACTIONS(2088),
    [anon_sym_RBRACE] = ACTIONS(2088),
    [anon_sym_LBRACK] = ACTIONS(2088),
    [anon_sym_STAR] = ACTIONS(2088),
    [anon_sym_u8] = ACTIONS(2090),
    [anon_sym_i8] = ACTIONS(2090),
    [anon_sym_u16] = ACTIONS(2090),
    [anon_sym_i16] = ACTIONS(2090),
    [anon_sym_u32] = ACTIONS(2090),
    [anon_sym_i32] = ACTIONS(2090),
    [anon_sym_u64] = ACTIONS(2090),
    [anon_sym_i64] = ACTIONS(2090),
    [anon_sym_u128] = ACTIONS(2090),
    [anon_sym_i128] = ACTIONS(2090),
    [anon_sym_isize] = ACTIONS(2090),
    [anon_sym_usize] = ACTIONS(2090),
    [anon_sym_f32] = ACTIONS(2090),
    [anon_sym_f64] = ACTIONS(2090),
    [anon_sym_bool] = ACTIONS(2090),
    [anon_sym_str] = ACTIONS(2090),
    [anon_sym_char] = ACTIONS(2090),
    [anon_sym_SQUOTE] = ACTIONS(2090),
    [anon_sym_async] = ACTIONS(2090),
    [anon_sym_break] = ACTIONS(2090),
    [anon_sym_const] = ACTIONS(2090),
    [anon_sym_continue] = ACTIONS(2090),
    [anon_sym_default] = ACTIONS(2090),
    [anon_sym_enum] = ACTIONS(2090),
    [anon_sym_fn] = ACTIONS(2090),
    [anon_sym_for] = ACTIONS(2090),
    [anon_sym_if] = ACTIONS(2090),
    [anon_sym_impl] = ACTIONS(2090),
    [anon_sym_let] = ACTIONS(2090),
    [anon_sym_loop] = ACTIONS(2090),
    [anon_sym_match] = ACTIONS(2090),
    [anon_sym_mod] = ACTIONS(2090),
    [anon_sym_pub] = ACTIONS(2090),
    [anon_sym_return] = ACTIONS(2090),
    [anon_sym_static] = ACTIONS(2090),
    [anon_sym_struct] = ACTIONS(2090),
    [anon_sym_trait] = ACTIONS(2090),
    [anon_sym_type] = ACTIONS(2090),
    [anon_sym_union] = ACTIONS(2090),
    [anon_sym_unsafe] = ACTIONS(2090),
    [anon_sym_use] = ACTIONS(2090),
    [anon_sym_while] = ACTIONS(2090),
    [anon_sym_POUND] = ACTIONS(2088),
    [anon_sym_BANG] = ACTIONS(2088),
    [anon_sym_extern] = ACTIONS(2090),
    [anon_sym_LT] = ACTIONS(2088),
    [anon_sym_COLON_COLON] = ACTIONS(2088),
    [anon_sym_AMP] = ACTIONS(2088),
    [anon_sym_DOT_DOT] = ACTIONS(2088),
    [anon_sym_DASH] = ACTIONS(2088),
    [anon_sym_PIPE] = ACTIONS(2088),
    [anon_sym_move] = ACTIONS(2090),
    [sym_integer_literal] = ACTIONS(2088),
    [aux_sym_string_literal_token1] = ACTIONS(2088),
    [sym_char_literal] = ACTIONS(2088),
    [anon_sym_true] = ACTIONS(2090),
    [anon_sym_false] = ACTIONS(2090),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2090),
    [sym_super] = ACTIONS(2090),
    [sym_crate] = ACTIONS(2090),
    [sym_metavariable] = ACTIONS(2088),
    [sym_raw_string_literal] = ACTIONS(2088),
    [sym_float_literal] = ACTIONS(2088),
    [sym_block_comment] = ACTIONS(3),
  },
  [437] = {
    [ts_builtin_sym_end] = ACTIONS(2092),
    [sym_identifier] = ACTIONS(2094),
    [anon_sym_SEMI] = ACTIONS(2092),
    [anon_sym_macro_rules_BANG] = ACTIONS(2092),
    [anon_sym_LPAREN] = ACTIONS(2092),
    [anon_sym_LBRACE] = ACTIONS(2092),
    [anon_sym_RBRACE] = ACTIONS(2092),
    [anon_sym_LBRACK] = ACTIONS(2092),
    [anon_sym_STAR] = ACTIONS(2092),
    [anon_sym_u8] = ACTIONS(2094),
    [anon_sym_i8] = ACTIONS(2094),
    [anon_sym_u16] = ACTIONS(2094),
    [anon_sym_i16] = ACTIONS(2094),
    [anon_sym_u32] = ACTIONS(2094),
    [anon_sym_i32] = ACTIONS(2094),
    [anon_sym_u64] = ACTIONS(2094),
    [anon_sym_i64] = ACTIONS(2094),
    [anon_sym_u128] = ACTIONS(2094),
    [anon_sym_i128] = ACTIONS(2094),
    [anon_sym_isize] = ACTIONS(2094),
    [anon_sym_usize] = ACTIONS(2094),
    [anon_sym_f32] = ACTIONS(2094),
    [anon_sym_f64] = ACTIONS(2094),
    [anon_sym_bool] = ACTIONS(2094),
    [anon_sym_str] = ACTIONS(2094),
    [anon_sym_char] = ACTIONS(2094),
    [anon_sym_SQUOTE] = ACTIONS(2094),
    [anon_sym_async] = ACTIONS(2094),
    [anon_sym_break] = ACTIONS(2094),
    [anon_sym_const] = ACTIONS(2094),
    [anon_sym_continue] = ACTIONS(2094),
    [anon_sym_default] = ACTIONS(2094),
    [anon_sym_enum] = ACTIONS(2094),
    [anon_sym_fn] = ACTIONS(2094),
    [anon_sym_for] = ACTIONS(2094),
    [anon_sym_if] = ACTIONS(2094),
    [anon_sym_impl] = ACTIONS(2094),
    [anon_sym_let] = ACTIONS(2094),
    [anon_sym_loop] = ACTIONS(2094),
    [anon_sym_match] = ACTIONS(2094),
    [anon_sym_mod] = ACTIONS(2094),
    [anon_sym_pub] = ACTIONS(2094),
    [anon_sym_return] = ACTIONS(2094),
    [anon_sym_static] = ACTIONS(2094),
    [anon_sym_struct] = ACTIONS(2094),
    [anon_sym_trait] = ACTIONS(2094),
    [anon_sym_type] = ACTIONS(2094),
    [anon_sym_union] = ACTIONS(2094),
    [anon_sym_unsafe] = ACTIONS(2094),
    [anon_sym_use] = ACTIONS(2094),
    [anon_sym_while] = ACTIONS(2094),
    [anon_sym_POUND] = ACTIONS(2092),
    [anon_sym_BANG] = ACTIONS(2092),
    [anon_sym_extern] = ACTIONS(2094),
    [anon_sym_LT] = ACTIONS(2092),
    [anon_sym_COLON_COLON] = ACTIONS(2092),
    [anon_sym_AMP] = ACTIONS(2092),
    [anon_sym_DOT_DOT] = ACTIONS(2092),
    [anon_sym_DASH] = ACTIONS(2092),
    [anon_sym_PIPE] = ACTIONS(2092),
    [anon_sym_move] = ACTIONS(2094),
    [sym_integer_literal] = ACTIONS(2092),
    [aux_sym_string_literal_token1] = ACTIONS(2092),
    [sym_char_literal] = ACTIONS(2092),
    [anon_sym_true] = ACTIONS(2094),
    [anon_sym_false] = ACTIONS(2094),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2094),
    [sym_super] = ACTIONS(2094),
    [sym_crate] = ACTIONS(2094),
    [sym_metavariable] = ACTIONS(2092),
    [sym_raw_string_literal] = ACTIONS(2092),
    [sym_float_literal] = ACTIONS(2092),
    [sym_block_comment] = ACTIONS(3),
  },
  [438] = {
    [ts_builtin_sym_end] = ACTIONS(2096),
    [sym_identifier] = ACTIONS(2098),
    [anon_sym_SEMI] = ACTIONS(2096),
    [anon_sym_macro_rules_BANG] = ACTIONS(2096),
    [anon_sym_LPAREN] = ACTIONS(2096),
    [anon_sym_LBRACE] = ACTIONS(2096),
    [anon_sym_RBRACE] = ACTIONS(2096),
    [anon_sym_LBRACK] = ACTIONS(2096),
    [anon_sym_STAR] = ACTIONS(2096),
    [anon_sym_u8] = ACTIONS(2098),
    [anon_sym_i8] = ACTIONS(2098),
    [anon_sym_u16] = ACTIONS(2098),
    [anon_sym_i16] = ACTIONS(2098),
    [anon_sym_u32] = ACTIONS(2098),
    [anon_sym_i32] = ACTIONS(2098),
    [anon_sym_u64] = ACTIONS(2098),
    [anon_sym_i64] = ACTIONS(2098),
    [anon_sym_u128] = ACTIONS(2098),
    [anon_sym_i128] = ACTIONS(2098),
    [anon_sym_isize] = ACTIONS(2098),
    [anon_sym_usize] = ACTIONS(2098),
    [anon_sym_f32] = ACTIONS(2098),
    [anon_sym_f64] = ACTIONS(2098),
    [anon_sym_bool] = ACTIONS(2098),
    [anon_sym_str] = ACTIONS(2098),
    [anon_sym_char] = ACTIONS(2098),
    [anon_sym_SQUOTE] = ACTIONS(2098),
    [anon_sym_async] = ACTIONS(2098),
    [anon_sym_break] = ACTIONS(2098),
    [anon_sym_const] = ACTIONS(2098),
    [anon_sym_continue] = ACTIONS(2098),
    [anon_sym_default] = ACTIONS(2098),
    [anon_sym_enum] = ACTIONS(2098),
    [anon_sym_fn] = ACTIONS(2098),
    [anon_sym_for] = ACTIONS(2098),
    [anon_sym_if] = ACTIONS(2098),
    [anon_sym_impl] = ACTIONS(2098),
    [anon_sym_let] = ACTIONS(2098),
    [anon_sym_loop] = ACTIONS(2098),
    [anon_sym_match] = ACTIONS(2098),
    [anon_sym_mod] = ACTIONS(2098),
    [anon_sym_pub] = ACTIONS(2098),
    [anon_sym_return] = ACTIONS(2098),
    [anon_sym_static] = ACTIONS(2098),
    [anon_sym_struct] = ACTIONS(2098),
    [anon_sym_trait] = ACTIONS(2098),
    [anon_sym_type] = ACTIONS(2098),
    [anon_sym_union] = ACTIONS(2098),
    [anon_sym_unsafe] = ACTIONS(2098),
    [anon_sym_use] = ACTIONS(2098),
    [anon_sym_while] = ACTIONS(2098),
    [anon_sym_POUND] = ACTIONS(2096),
    [anon_sym_BANG] = ACTIONS(2096),
    [anon_sym_extern] = ACTIONS(2098),
    [anon_sym_LT] = ACTIONS(2096),
    [anon_sym_COLON_COLON] = ACTIONS(2096),
    [anon_sym_AMP] = ACTIONS(2096),
    [anon_sym_DOT_DOT] = ACTIONS(2096),
    [anon_sym_DASH] = ACTIONS(2096),
    [anon_sym_PIPE] = ACTIONS(2096),
    [anon_sym_move] = ACTIONS(2098),
    [sym_integer_literal] = ACTIONS(2096),
    [aux_sym_string_literal_token1] = ACTIONS(2096),
    [sym_char_literal] = ACTIONS(2096),
    [anon_sym_true] = ACTIONS(2098),
    [anon_sym_false] = ACTIONS(2098),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2098),
    [sym_super] = ACTIONS(2098),
    [sym_crate] = ACTIONS(2098),
    [sym_metavariable] = ACTIONS(2096),
    [sym_raw_string_literal] = ACTIONS(2096),
    [sym_float_literal] = ACTIONS(2096),
    [sym_block_comment] = ACTIONS(3),
  },
  [439] = {
    [ts_builtin_sym_end] = ACTIONS(2100),
    [sym_identifier] = ACTIONS(2102),
    [anon_sym_SEMI] = ACTIONS(2100),
    [anon_sym_macro_rules_BANG] = ACTIONS(2100),
    [anon_sym_LPAREN] = ACTIONS(2100),
    [anon_sym_LBRACE] = ACTIONS(2100),
    [anon_sym_RBRACE] = ACTIONS(2100),
    [anon_sym_LBRACK] = ACTIONS(2100),
    [anon_sym_STAR] = ACTIONS(2100),
    [anon_sym_u8] = ACTIONS(2102),
    [anon_sym_i8] = ACTIONS(2102),
    [anon_sym_u16] = ACTIONS(2102),
    [anon_sym_i16] = ACTIONS(2102),
    [anon_sym_u32] = ACTIONS(2102),
    [anon_sym_i32] = ACTIONS(2102),
    [anon_sym_u64] = ACTIONS(2102),
    [anon_sym_i64] = ACTIONS(2102),
    [anon_sym_u128] = ACTIONS(2102),
    [anon_sym_i128] = ACTIONS(2102),
    [anon_sym_isize] = ACTIONS(2102),
    [anon_sym_usize] = ACTIONS(2102),
    [anon_sym_f32] = ACTIONS(2102),
    [anon_sym_f64] = ACTIONS(2102),
    [anon_sym_bool] = ACTIONS(2102),
    [anon_sym_str] = ACTIONS(2102),
    [anon_sym_char] = ACTIONS(2102),
    [anon_sym_SQUOTE] = ACTIONS(2102),
    [anon_sym_async] = ACTIONS(2102),
    [anon_sym_break] = ACTIONS(2102),
    [anon_sym_const] = ACTIONS(2102),
    [anon_sym_continue] = ACTIONS(2102),
    [anon_sym_default] = ACTIONS(2102),
    [anon_sym_enum] = ACTIONS(2102),
    [anon_sym_fn] = ACTIONS(2102),
    [anon_sym_for] = ACTIONS(2102),
    [anon_sym_if] = ACTIONS(2102),
    [anon_sym_impl] = ACTIONS(2102),
    [anon_sym_let] = ACTIONS(2102),
    [anon_sym_loop] = ACTIONS(2102),
    [anon_sym_match] = ACTIONS(2102),
    [anon_sym_mod] = ACTIONS(2102),
    [anon_sym_pub] = ACTIONS(2102),
    [anon_sym_return] = ACTIONS(2102),
    [anon_sym_static] = ACTIONS(2102),
    [anon_sym_struct] = ACTIONS(2102),
    [anon_sym_trait] = ACTIONS(2102),
    [anon_sym_type] = ACTIONS(2102),
    [anon_sym_union] = ACTIONS(2102),
    [anon_sym_unsafe] = ACTIONS(2102),
    [anon_sym_use] = ACTIONS(2102),
    [anon_sym_while] = ACTIONS(2102),
    [anon_sym_POUND] = ACTIONS(2100),
    [anon_sym_BANG] = ACTIONS(2100),
    [anon_sym_extern] = ACTIONS(2102),
    [anon_sym_LT] = ACTIONS(2100),
    [anon_sym_COLON_COLON] = ACTIONS(2100),
    [anon_sym_AMP] = ACTIONS(2100),
    [anon_sym_DOT_DOT] = ACTIONS(2100),
    [anon_sym_DASH] = ACTIONS(2100),
    [anon_sym_PIPE] = ACTIONS(2100),
    [anon_sym_move] = ACTIONS(2102),
    [sym_integer_literal] = ACTIONS(2100),
    [aux_sym_string_literal_token1] = ACTIONS(2100),
    [sym_char_literal] = ACTIONS(2100),
    [anon_sym_true] = ACTIONS(2102),
    [anon_sym_false] = ACTIONS(2102),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2102),
    [sym_super] = ACTIONS(2102),
    [sym_crate] = ACTIONS(2102),
    [sym_metavariable] = ACTIONS(2100),
    [sym_raw_string_literal] = ACTIONS(2100),
    [sym_float_literal] = ACTIONS(2100),
    [sym_block_comment] = ACTIONS(3),
  },
  [440] = {
    [ts_builtin_sym_end] = ACTIONS(2104),
    [sym_identifier] = ACTIONS(2106),
    [anon_sym_SEMI] = ACTIONS(2104),
    [anon_sym_macro_rules_BANG] = ACTIONS(2104),
    [anon_sym_LPAREN] = ACTIONS(2104),
    [anon_sym_LBRACE] = ACTIONS(2104),
    [anon_sym_RBRACE] = ACTIONS(2104),
    [anon_sym_LBRACK] = ACTIONS(2104),
    [anon_sym_STAR] = ACTIONS(2104),
    [anon_sym_u8] = ACTIONS(2106),
    [anon_sym_i8] = ACTIONS(2106),
    [anon_sym_u16] = ACTIONS(2106),
    [anon_sym_i16] = ACTIONS(2106),
    [anon_sym_u32] = ACTIONS(2106),
    [anon_sym_i32] = ACTIONS(2106),
    [anon_sym_u64] = ACTIONS(2106),
    [anon_sym_i64] = ACTIONS(2106),
    [anon_sym_u128] = ACTIONS(2106),
    [anon_sym_i128] = ACTIONS(2106),
    [anon_sym_isize] = ACTIONS(2106),
    [anon_sym_usize] = ACTIONS(2106),
    [anon_sym_f32] = ACTIONS(2106),
    [anon_sym_f64] = ACTIONS(2106),
    [anon_sym_bool] = ACTIONS(2106),
    [anon_sym_str] = ACTIONS(2106),
    [anon_sym_char] = ACTIONS(2106),
    [anon_sym_SQUOTE] = ACTIONS(2106),
    [anon_sym_async] = ACTIONS(2106),
    [anon_sym_break] = ACTIONS(2106),
    [anon_sym_const] = ACTIONS(2106),
    [anon_sym_continue] = ACTIONS(2106),
    [anon_sym_default] = ACTIONS(2106),
    [anon_sym_enum] = ACTIONS(2106),
    [anon_sym_fn] = ACTIONS(2106),
    [anon_sym_for] = ACTIONS(2106),
    [anon_sym_if] = ACTIONS(2106),
    [anon_sym_impl] = ACTIONS(2106),
    [anon_sym_let] = ACTIONS(2106),
    [anon_sym_loop] = ACTIONS(2106),
    [anon_sym_match] = ACTIONS(2106),
    [anon_sym_mod] = ACTIONS(2106),
    [anon_sym_pub] = ACTIONS(2106),
    [anon_sym_return] = ACTIONS(2106),
    [anon_sym_static] = ACTIONS(2106),
    [anon_sym_struct] = ACTIONS(2106),
    [anon_sym_trait] = ACTIONS(2106),
    [anon_sym_type] = ACTIONS(2106),
    [anon_sym_union] = ACTIONS(2106),
    [anon_sym_unsafe] = ACTIONS(2106),
    [anon_sym_use] = ACTIONS(2106),
    [anon_sym_while] = ACTIONS(2106),
    [anon_sym_POUND] = ACTIONS(2104),
    [anon_sym_BANG] = ACTIONS(2104),
    [anon_sym_extern] = ACTIONS(2106),
    [anon_sym_LT] = ACTIONS(2104),
    [anon_sym_COLON_COLON] = ACTIONS(2104),
    [anon_sym_AMP] = ACTIONS(2104),
    [anon_sym_DOT_DOT] = ACTIONS(2104),
    [anon_sym_DASH] = ACTIONS(2104),
    [anon_sym_PIPE] = ACTIONS(2104),
    [anon_sym_move] = ACTIONS(2106),
    [sym_integer_literal] = ACTIONS(2104),
    [aux_sym_string_literal_token1] = ACTIONS(2104),
    [sym_char_literal] = ACTIONS(2104),
    [anon_sym_true] = ACTIONS(2106),
    [anon_sym_false] = ACTIONS(2106),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2106),
    [sym_super] = ACTIONS(2106),
    [sym_crate] = ACTIONS(2106),
    [sym_metavariable] = ACTIONS(2104),
    [sym_raw_string_literal] = ACTIONS(2104),
    [sym_float_literal] = ACTIONS(2104),
    [sym_block_comment] = ACTIONS(3),
  },
  [441] = {
    [ts_builtin_sym_end] = ACTIONS(2108),
    [sym_identifier] = ACTIONS(2110),
    [anon_sym_SEMI] = ACTIONS(2108),
    [anon_sym_macro_rules_BANG] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2108),
    [anon_sym_RBRACE] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2108),
    [anon_sym_STAR] = ACTIONS(2108),
    [anon_sym_u8] = ACTIONS(2110),
    [anon_sym_i8] = ACTIONS(2110),
    [anon_sym_u16] = ACTIONS(2110),
    [anon_sym_i16] = ACTIONS(2110),
    [anon_sym_u32] = ACTIONS(2110),
    [anon_sym_i32] = ACTIONS(2110),
    [anon_sym_u64] = ACTIONS(2110),
    [anon_sym_i64] = ACTIONS(2110),
    [anon_sym_u128] = ACTIONS(2110),
    [anon_sym_i128] = ACTIONS(2110),
    [anon_sym_isize] = ACTIONS(2110),
    [anon_sym_usize] = ACTIONS(2110),
    [anon_sym_f32] = ACTIONS(2110),
    [anon_sym_f64] = ACTIONS(2110),
    [anon_sym_bool] = ACTIONS(2110),
    [anon_sym_str] = ACTIONS(2110),
    [anon_sym_char] = ACTIONS(2110),
    [anon_sym_SQUOTE] = ACTIONS(2110),
    [anon_sym_async] = ACTIONS(2110),
    [anon_sym_break] = ACTIONS(2110),
    [anon_sym_const] = ACTIONS(2110),
    [anon_sym_continue] = ACTIONS(2110),
    [anon_sym_default] = ACTIONS(2110),
    [anon_sym_enum] = ACTIONS(2110),
    [anon_sym_fn] = ACTIONS(2110),
    [anon_sym_for] = ACTIONS(2110),
    [anon_sym_if] = ACTIONS(2110),
    [anon_sym_impl] = ACTIONS(2110),
    [anon_sym_let] = ACTIONS(2110),
    [anon_sym_loop] = ACTIONS(2110),
    [anon_sym_match] = ACTIONS(2110),
    [anon_sym_mod] = ACTIONS(2110),
    [anon_sym_pub] = ACTIONS(2110),
    [anon_sym_return] = ACTIONS(2110),
    [anon_sym_static] = ACTIONS(2110),
    [anon_sym_struct] = ACTIONS(2110),
    [anon_sym_trait] = ACTIONS(2110),
    [anon_sym_type] = ACTIONS(2110),
    [anon_sym_union] = ACTIONS(2110),
    [anon_sym_unsafe] = ACTIONS(2110),
    [anon_sym_use] = ACTIONS(2110),
    [anon_sym_while] = ACTIONS(2110),
    [anon_sym_POUND] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2108),
    [anon_sym_extern] = ACTIONS(2110),
    [anon_sym_LT] = ACTIONS(2108),
    [anon_sym_COLON_COLON] = ACTIONS(2108),
    [anon_sym_AMP] = ACTIONS(2108),
    [anon_sym_DOT_DOT] = ACTIONS(2108),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_PIPE] = ACTIONS(2108),
    [anon_sym_move] = ACTIONS(2110),
    [sym_integer_literal] = ACTIONS(2108),
    [aux_sym_string_literal_token1] = ACTIONS(2108),
    [sym_char_literal] = ACTIONS(2108),
    [anon_sym_true] = ACTIONS(2110),
    [anon_sym_false] = ACTIONS(2110),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2110),
    [sym_super] = ACTIONS(2110),
    [sym_crate] = ACTIONS(2110),
    [sym_metavariable] = ACTIONS(2108),
    [sym_raw_string_literal] = ACTIONS(2108),
    [sym_float_literal] = ACTIONS(2108),
    [sym_block_comment] = ACTIONS(3),
  },
  [442] = {
    [ts_builtin_sym_end] = ACTIONS(2112),
    [sym_identifier] = ACTIONS(2114),
    [anon_sym_SEMI] = ACTIONS(2112),
    [anon_sym_macro_rules_BANG] = ACTIONS(2112),
    [anon_sym_LPAREN] = ACTIONS(2112),
    [anon_sym_LBRACE] = ACTIONS(2112),
    [anon_sym_RBRACE] = ACTIONS(2112),
    [anon_sym_LBRACK] = ACTIONS(2112),
    [anon_sym_STAR] = ACTIONS(2112),
    [anon_sym_u8] = ACTIONS(2114),
    [anon_sym_i8] = ACTIONS(2114),
    [anon_sym_u16] = ACTIONS(2114),
    [anon_sym_i16] = ACTIONS(2114),
    [anon_sym_u32] = ACTIONS(2114),
    [anon_sym_i32] = ACTIONS(2114),
    [anon_sym_u64] = ACTIONS(2114),
    [anon_sym_i64] = ACTIONS(2114),
    [anon_sym_u128] = ACTIONS(2114),
    [anon_sym_i128] = ACTIONS(2114),
    [anon_sym_isize] = ACTIONS(2114),
    [anon_sym_usize] = ACTIONS(2114),
    [anon_sym_f32] = ACTIONS(2114),
    [anon_sym_f64] = ACTIONS(2114),
    [anon_sym_bool] = ACTIONS(2114),
    [anon_sym_str] = ACTIONS(2114),
    [anon_sym_char] = ACTIONS(2114),
    [anon_sym_SQUOTE] = ACTIONS(2114),
    [anon_sym_async] = ACTIONS(2114),
    [anon_sym_break] = ACTIONS(2114),
    [anon_sym_const] = ACTIONS(2114),
    [anon_sym_continue] = ACTIONS(2114),
    [anon_sym_default] = ACTIONS(2114),
    [anon_sym_enum] = ACTIONS(2114),
    [anon_sym_fn] = ACTIONS(2114),
    [anon_sym_for] = ACTIONS(2114),
    [anon_sym_if] = ACTIONS(2114),
    [anon_sym_impl] = ACTIONS(2114),
    [anon_sym_let] = ACTIONS(2114),
    [anon_sym_loop] = ACTIONS(2114),
    [anon_sym_match] = ACTIONS(2114),
    [anon_sym_mod] = ACTIONS(2114),
    [anon_sym_pub] = ACTIONS(2114),
    [anon_sym_return] = ACTIONS(2114),
    [anon_sym_static] = ACTIONS(2114),
    [anon_sym_struct] = ACTIONS(2114),
    [anon_sym_trait] = ACTIONS(2114),
    [anon_sym_type] = ACTIONS(2114),
    [anon_sym_union] = ACTIONS(2114),
    [anon_sym_unsafe] = ACTIONS(2114),
    [anon_sym_use] = ACTIONS(2114),
    [anon_sym_while] = ACTIONS(2114),
    [anon_sym_POUND] = ACTIONS(2112),
    [anon_sym_BANG] = ACTIONS(2112),
    [anon_sym_extern] = ACTIONS(2114),
    [anon_sym_LT] = ACTIONS(2112),
    [anon_sym_COLON_COLON] = ACTIONS(2112),
    [anon_sym_AMP] = ACTIONS(2112),
    [anon_sym_DOT_DOT] = ACTIONS(2112),
    [anon_sym_DASH] = ACTIONS(2112),
    [anon_sym_PIPE] = ACTIONS(2112),
    [anon_sym_move] = ACTIONS(2114),
    [sym_integer_literal] = ACTIONS(2112),
    [aux_sym_string_literal_token1] = ACTIONS(2112),
    [sym_char_literal] = ACTIONS(2112),
    [anon_sym_true] = ACTIONS(2114),
    [anon_sym_false] = ACTIONS(2114),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2114),
    [sym_super] = ACTIONS(2114),
    [sym_crate] = ACTIONS(2114),
    [sym_metavariable] = ACTIONS(2112),
    [sym_raw_string_literal] = ACTIONS(2112),
    [sym_float_literal] = ACTIONS(2112),
    [sym_block_comment] = ACTIONS(3),
  },
  [443] = {
    [ts_builtin_sym_end] = ACTIONS(2116),
    [sym_identifier] = ACTIONS(2118),
    [anon_sym_SEMI] = ACTIONS(2116),
    [anon_sym_macro_rules_BANG] = ACTIONS(2116),
    [anon_sym_LPAREN] = ACTIONS(2116),
    [anon_sym_LBRACE] = ACTIONS(2116),
    [anon_sym_RBRACE] = ACTIONS(2116),
    [anon_sym_LBRACK] = ACTIONS(2116),
    [anon_sym_STAR] = ACTIONS(2116),
    [anon_sym_u8] = ACTIONS(2118),
    [anon_sym_i8] = ACTIONS(2118),
    [anon_sym_u16] = ACTIONS(2118),
    [anon_sym_i16] = ACTIONS(2118),
    [anon_sym_u32] = ACTIONS(2118),
    [anon_sym_i32] = ACTIONS(2118),
    [anon_sym_u64] = ACTIONS(2118),
    [anon_sym_i64] = ACTIONS(2118),
    [anon_sym_u128] = ACTIONS(2118),
    [anon_sym_i128] = ACTIONS(2118),
    [anon_sym_isize] = ACTIONS(2118),
    [anon_sym_usize] = ACTIONS(2118),
    [anon_sym_f32] = ACTIONS(2118),
    [anon_sym_f64] = ACTIONS(2118),
    [anon_sym_bool] = ACTIONS(2118),
    [anon_sym_str] = ACTIONS(2118),
    [anon_sym_char] = ACTIONS(2118),
    [anon_sym_SQUOTE] = ACTIONS(2118),
    [anon_sym_async] = ACTIONS(2118),
    [anon_sym_break] = ACTIONS(2118),
    [anon_sym_const] = ACTIONS(2118),
    [anon_sym_continue] = ACTIONS(2118),
    [anon_sym_default] = ACTIONS(2118),
    [anon_sym_enum] = ACTIONS(2118),
    [anon_sym_fn] = ACTIONS(2118),
    [anon_sym_for] = ACTIONS(2118),
    [anon_sym_if] = ACTIONS(2118),
    [anon_sym_impl] = ACTIONS(2118),
    [anon_sym_let] = ACTIONS(2118),
    [anon_sym_loop] = ACTIONS(2118),
    [anon_sym_match] = ACTIONS(2118),
    [anon_sym_mod] = ACTIONS(2118),
    [anon_sym_pub] = ACTIONS(2118),
    [anon_sym_return] = ACTIONS(2118),
    [anon_sym_static] = ACTIONS(2118),
    [anon_sym_struct] = ACTIONS(2118),
    [anon_sym_trait] = ACTIONS(2118),
    [anon_sym_type] = ACTIONS(2118),
    [anon_sym_union] = ACTIONS(2118),
    [anon_sym_unsafe] = ACTIONS(2118),
    [anon_sym_use] = ACTIONS(2118),
    [anon_sym_while] = ACTIONS(2118),
    [anon_sym_POUND] = ACTIONS(2116),
    [anon_sym_BANG] = ACTIONS(2116),
    [anon_sym_extern] = ACTIONS(2118),
    [anon_sym_LT] = ACTIONS(2116),
    [anon_sym_COLON_COLON] = ACTIONS(2116),
    [anon_sym_AMP] = ACTIONS(2116),
    [anon_sym_DOT_DOT] = ACTIONS(2116),
    [anon_sym_DASH] = ACTIONS(2116),
    [anon_sym_PIPE] = ACTIONS(2116),
    [anon_sym_move] = ACTIONS(2118),
    [sym_integer_literal] = ACTIONS(2116),
    [aux_sym_string_literal_token1] = ACTIONS(2116),
    [sym_char_literal] = ACTIONS(2116),
    [anon_sym_true] = ACTIONS(2118),
    [anon_sym_false] = ACTIONS(2118),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2118),
    [sym_super] = ACTIONS(2118),
    [sym_crate] = ACTIONS(2118),
    [sym_metavariable] = ACTIONS(2116),
    [sym_raw_string_literal] = ACTIONS(2116),
    [sym_float_literal] = ACTIONS(2116),
    [sym_block_comment] = ACTIONS(3),
  },
  [444] = {
    [ts_builtin_sym_end] = ACTIONS(2120),
    [sym_identifier] = ACTIONS(2122),
    [anon_sym_SEMI] = ACTIONS(2120),
    [anon_sym_macro_rules_BANG] = ACTIONS(2120),
    [anon_sym_LPAREN] = ACTIONS(2120),
    [anon_sym_LBRACE] = ACTIONS(2120),
    [anon_sym_RBRACE] = ACTIONS(2120),
    [anon_sym_LBRACK] = ACTIONS(2120),
    [anon_sym_STAR] = ACTIONS(2120),
    [anon_sym_u8] = ACTIONS(2122),
    [anon_sym_i8] = ACTIONS(2122),
    [anon_sym_u16] = ACTIONS(2122),
    [anon_sym_i16] = ACTIONS(2122),
    [anon_sym_u32] = ACTIONS(2122),
    [anon_sym_i32] = ACTIONS(2122),
    [anon_sym_u64] = ACTIONS(2122),
    [anon_sym_i64] = ACTIONS(2122),
    [anon_sym_u128] = ACTIONS(2122),
    [anon_sym_i128] = ACTIONS(2122),
    [anon_sym_isize] = ACTIONS(2122),
    [anon_sym_usize] = ACTIONS(2122),
    [anon_sym_f32] = ACTIONS(2122),
    [anon_sym_f64] = ACTIONS(2122),
    [anon_sym_bool] = ACTIONS(2122),
    [anon_sym_str] = ACTIONS(2122),
    [anon_sym_char] = ACTIONS(2122),
    [anon_sym_SQUOTE] = ACTIONS(2122),
    [anon_sym_async] = ACTIONS(2122),
    [anon_sym_break] = ACTIONS(2122),
    [anon_sym_const] = ACTIONS(2122),
    [anon_sym_continue] = ACTIONS(2122),
    [anon_sym_default] = ACTIONS(2122),
    [anon_sym_enum] = ACTIONS(2122),
    [anon_sym_fn] = ACTIONS(2122),
    [anon_sym_for] = ACTIONS(2122),
    [anon_sym_if] = ACTIONS(2122),
    [anon_sym_impl] = ACTIONS(2122),
    [anon_sym_let] = ACTIONS(2122),
    [anon_sym_loop] = ACTIONS(2122),
    [anon_sym_match] = ACTIONS(2122),
    [anon_sym_mod] = ACTIONS(2122),
    [anon_sym_pub] = ACTIONS(2122),
    [anon_sym_return] = ACTIONS(2122),
    [anon_sym_static] = ACTIONS(2122),
    [anon_sym_struct] = ACTIONS(2122),
    [anon_sym_trait] = ACTIONS(2122),
    [anon_sym_type] = ACTIONS(2122),
    [anon_sym_union] = ACTIONS(2122),
    [anon_sym_unsafe] = ACTIONS(2122),
    [anon_sym_use] = ACTIONS(2122),
    [anon_sym_while] = ACTIONS(2122),
    [anon_sym_POUND] = ACTIONS(2120),
    [anon_sym_BANG] = ACTIONS(2120),
    [anon_sym_extern] = ACTIONS(2122),
    [anon_sym_LT] = ACTIONS(2120),
    [anon_sym_COLON_COLON] = ACTIONS(2120),
    [anon_sym_AMP] = ACTIONS(2120),
    [anon_sym_DOT_DOT] = ACTIONS(2120),
    [anon_sym_DASH] = ACTIONS(2120),
    [anon_sym_PIPE] = ACTIONS(2120),
    [anon_sym_move] = ACTIONS(2122),
    [sym_integer_literal] = ACTIONS(2120),
    [aux_sym_string_literal_token1] = ACTIONS(2120),
    [sym_char_literal] = ACTIONS(2120),
    [anon_sym_true] = ACTIONS(2122),
    [anon_sym_false] = ACTIONS(2122),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2122),
    [sym_super] = ACTIONS(2122),
    [sym_crate] = ACTIONS(2122),
    [sym_metavariable] = ACTIONS(2120),
    [sym_raw_string_literal] = ACTIONS(2120),
    [sym_float_literal] = ACTIONS(2120),
    [sym_block_comment] = ACTIONS(3),
  },
  [445] = {
    [ts_builtin_sym_end] = ACTIONS(2124),
    [sym_identifier] = ACTIONS(2126),
    [anon_sym_SEMI] = ACTIONS(2124),
    [anon_sym_macro_rules_BANG] = ACTIONS(2124),
    [anon_sym_LPAREN] = ACTIONS(2124),
    [anon_sym_LBRACE] = ACTIONS(2124),
    [anon_sym_RBRACE] = ACTIONS(2124),
    [anon_sym_LBRACK] = ACTIONS(2124),
    [anon_sym_STAR] = ACTIONS(2124),
    [anon_sym_u8] = ACTIONS(2126),
    [anon_sym_i8] = ACTIONS(2126),
    [anon_sym_u16] = ACTIONS(2126),
    [anon_sym_i16] = ACTIONS(2126),
    [anon_sym_u32] = ACTIONS(2126),
    [anon_sym_i32] = ACTIONS(2126),
    [anon_sym_u64] = ACTIONS(2126),
    [anon_sym_i64] = ACTIONS(2126),
    [anon_sym_u128] = ACTIONS(2126),
    [anon_sym_i128] = ACTIONS(2126),
    [anon_sym_isize] = ACTIONS(2126),
    [anon_sym_usize] = ACTIONS(2126),
    [anon_sym_f32] = ACTIONS(2126),
    [anon_sym_f64] = ACTIONS(2126),
    [anon_sym_bool] = ACTIONS(2126),
    [anon_sym_str] = ACTIONS(2126),
    [anon_sym_char] = ACTIONS(2126),
    [anon_sym_SQUOTE] = ACTIONS(2126),
    [anon_sym_async] = ACTIONS(2126),
    [anon_sym_break] = ACTIONS(2126),
    [anon_sym_const] = ACTIONS(2126),
    [anon_sym_continue] = ACTIONS(2126),
    [anon_sym_default] = ACTIONS(2126),
    [anon_sym_enum] = ACTIONS(2126),
    [anon_sym_fn] = ACTIONS(2126),
    [anon_sym_for] = ACTIONS(2126),
    [anon_sym_if] = ACTIONS(2126),
    [anon_sym_impl] = ACTIONS(2126),
    [anon_sym_let] = ACTIONS(2126),
    [anon_sym_loop] = ACTIONS(2126),
    [anon_sym_match] = ACTIONS(2126),
    [anon_sym_mod] = ACTIONS(2126),
    [anon_sym_pub] = ACTIONS(2126),
    [anon_sym_return] = ACTIONS(2126),
    [anon_sym_static] = ACTIONS(2126),
    [anon_sym_struct] = ACTIONS(2126),
    [anon_sym_trait] = ACTIONS(2126),
    [anon_sym_type] = ACTIONS(2126),
    [anon_sym_union] = ACTIONS(2126),
    [anon_sym_unsafe] = ACTIONS(2126),
    [anon_sym_use] = ACTIONS(2126),
    [anon_sym_while] = ACTIONS(2126),
    [anon_sym_POUND] = ACTIONS(2124),
    [anon_sym_BANG] = ACTIONS(2124),
    [anon_sym_extern] = ACTIONS(2126),
    [anon_sym_LT] = ACTIONS(2124),
    [anon_sym_COLON_COLON] = ACTIONS(2124),
    [anon_sym_AMP] = ACTIONS(2124),
    [anon_sym_DOT_DOT] = ACTIONS(2124),
    [anon_sym_DASH] = ACTIONS(2124),
    [anon_sym_PIPE] = ACTIONS(2124),
    [anon_sym_move] = ACTIONS(2126),
    [sym_integer_literal] = ACTIONS(2124),
    [aux_sym_string_literal_token1] = ACTIONS(2124),
    [sym_char_literal] = ACTIONS(2124),
    [anon_sym_true] = ACTIONS(2126),
    [anon_sym_false] = ACTIONS(2126),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2126),
    [sym_super] = ACTIONS(2126),
    [sym_crate] = ACTIONS(2126),
    [sym_metavariable] = ACTIONS(2124),
    [sym_raw_string_literal] = ACTIONS(2124),
    [sym_float_literal] = ACTIONS(2124),
    [sym_block_comment] = ACTIONS(3),
  },
  [446] = {
    [ts_builtin_sym_end] = ACTIONS(2128),
    [sym_identifier] = ACTIONS(2130),
    [anon_sym_SEMI] = ACTIONS(2128),
    [anon_sym_macro_rules_BANG] = ACTIONS(2128),
    [anon_sym_LPAREN] = ACTIONS(2128),
    [anon_sym_LBRACE] = ACTIONS(2128),
    [anon_sym_RBRACE] = ACTIONS(2128),
    [anon_sym_LBRACK] = ACTIONS(2128),
    [anon_sym_STAR] = ACTIONS(2128),
    [anon_sym_u8] = ACTIONS(2130),
    [anon_sym_i8] = ACTIONS(2130),
    [anon_sym_u16] = ACTIONS(2130),
    [anon_sym_i16] = ACTIONS(2130),
    [anon_sym_u32] = ACTIONS(2130),
    [anon_sym_i32] = ACTIONS(2130),
    [anon_sym_u64] = ACTIONS(2130),
    [anon_sym_i64] = ACTIONS(2130),
    [anon_sym_u128] = ACTIONS(2130),
    [anon_sym_i128] = ACTIONS(2130),
    [anon_sym_isize] = ACTIONS(2130),
    [anon_sym_usize] = ACTIONS(2130),
    [anon_sym_f32] = ACTIONS(2130),
    [anon_sym_f64] = ACTIONS(2130),
    [anon_sym_bool] = ACTIONS(2130),
    [anon_sym_str] = ACTIONS(2130),
    [anon_sym_char] = ACTIONS(2130),
    [anon_sym_SQUOTE] = ACTIONS(2130),
    [anon_sym_async] = ACTIONS(2130),
    [anon_sym_break] = ACTIONS(2130),
    [anon_sym_const] = ACTIONS(2130),
    [anon_sym_continue] = ACTIONS(2130),
    [anon_sym_default] = ACTIONS(2130),
    [anon_sym_enum] = ACTIONS(2130),
    [anon_sym_fn] = ACTIONS(2130),
    [anon_sym_for] = ACTIONS(2130),
    [anon_sym_if] = ACTIONS(2130),
    [anon_sym_impl] = ACTIONS(2130),
    [anon_sym_let] = ACTIONS(2130),
    [anon_sym_loop] = ACTIONS(2130),
    [anon_sym_match] = ACTIONS(2130),
    [anon_sym_mod] = ACTIONS(2130),
    [anon_sym_pub] = ACTIONS(2130),
    [anon_sym_return] = ACTIONS(2130),
    [anon_sym_static] = ACTIONS(2130),
    [anon_sym_struct] = ACTIONS(2130),
    [anon_sym_trait] = ACTIONS(2130),
    [anon_sym_type] = ACTIONS(2130),
    [anon_sym_union] = ACTIONS(2130),
    [anon_sym_unsafe] = ACTIONS(2130),
    [anon_sym_use] = ACTIONS(2130),
    [anon_sym_while] = ACTIONS(2130),
    [anon_sym_POUND] = ACTIONS(2128),
    [anon_sym_BANG] = ACTIONS(2128),
    [anon_sym_extern] = ACTIONS(2130),
    [anon_sym_LT] = ACTIONS(2128),
    [anon_sym_COLON_COLON] = ACTIONS(2128),
    [anon_sym_AMP] = ACTIONS(2128),
    [anon_sym_DOT_DOT] = ACTIONS(2128),
    [anon_sym_DASH] = ACTIONS(2128),
    [anon_sym_PIPE] = ACTIONS(2128),
    [anon_sym_move] = ACTIONS(2130),
    [sym_integer_literal] = ACTIONS(2128),
    [aux_sym_string_literal_token1] = ACTIONS(2128),
    [sym_char_literal] = ACTIONS(2128),
    [anon_sym_true] = ACTIONS(2130),
    [anon_sym_false] = ACTIONS(2130),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2130),
    [sym_super] = ACTIONS(2130),
    [sym_crate] = ACTIONS(2130),
    [sym_metavariable] = ACTIONS(2128),
    [sym_raw_string_literal] = ACTIONS(2128),
    [sym_float_literal] = ACTIONS(2128),
    [sym_block_comment] = ACTIONS(3),
  },
  [447] = {
    [ts_builtin_sym_end] = ACTIONS(2132),
    [sym_identifier] = ACTIONS(2134),
    [anon_sym_SEMI] = ACTIONS(2132),
    [anon_sym_macro_rules_BANG] = ACTIONS(2132),
    [anon_sym_LPAREN] = ACTIONS(2132),
    [anon_sym_LBRACE] = ACTIONS(2132),
    [anon_sym_RBRACE] = ACTIONS(2132),
    [anon_sym_LBRACK] = ACTIONS(2132),
    [anon_sym_STAR] = ACTIONS(2132),
    [anon_sym_u8] = ACTIONS(2134),
    [anon_sym_i8] = ACTIONS(2134),
    [anon_sym_u16] = ACTIONS(2134),
    [anon_sym_i16] = ACTIONS(2134),
    [anon_sym_u32] = ACTIONS(2134),
    [anon_sym_i32] = ACTIONS(2134),
    [anon_sym_u64] = ACTIONS(2134),
    [anon_sym_i64] = ACTIONS(2134),
    [anon_sym_u128] = ACTIONS(2134),
    [anon_sym_i128] = ACTIONS(2134),
    [anon_sym_isize] = ACTIONS(2134),
    [anon_sym_usize] = ACTIONS(2134),
    [anon_sym_f32] = ACTIONS(2134),
    [anon_sym_f64] = ACTIONS(2134),
    [anon_sym_bool] = ACTIONS(2134),
    [anon_sym_str] = ACTIONS(2134),
    [anon_sym_char] = ACTIONS(2134),
    [anon_sym_SQUOTE] = ACTIONS(2134),
    [anon_sym_async] = ACTIONS(2134),
    [anon_sym_break] = ACTIONS(2134),
    [anon_sym_const] = ACTIONS(2134),
    [anon_sym_continue] = ACTIONS(2134),
    [anon_sym_default] = ACTIONS(2134),
    [anon_sym_enum] = ACTIONS(2134),
    [anon_sym_fn] = ACTIONS(2134),
    [anon_sym_for] = ACTIONS(2134),
    [anon_sym_if] = ACTIONS(2134),
    [anon_sym_impl] = ACTIONS(2134),
    [anon_sym_let] = ACTIONS(2134),
    [anon_sym_loop] = ACTIONS(2134),
    [anon_sym_match] = ACTIONS(2134),
    [anon_sym_mod] = ACTIONS(2134),
    [anon_sym_pub] = ACTIONS(2134),
    [anon_sym_return] = ACTIONS(2134),
    [anon_sym_static] = ACTIONS(2134),
    [anon_sym_struct] = ACTIONS(2134),
    [anon_sym_trait] = ACTIONS(2134),
    [anon_sym_type] = ACTIONS(2134),
    [anon_sym_union] = ACTIONS(2134),
    [anon_sym_unsafe] = ACTIONS(2134),
    [anon_sym_use] = ACTIONS(2134),
    [anon_sym_while] = ACTIONS(2134),
    [anon_sym_POUND] = ACTIONS(2132),
    [anon_sym_BANG] = ACTIONS(2132),
    [anon_sym_extern] = ACTIONS(2134),
    [anon_sym_LT] = ACTIONS(2132),
    [anon_sym_COLON_COLON] = ACTIONS(2132),
    [anon_sym_AMP] = ACTIONS(2132),
    [anon_sym_DOT_DOT] = ACTIONS(2132),
    [anon_sym_DASH] = ACTIONS(2132),
    [anon_sym_PIPE] = ACTIONS(2132),
    [anon_sym_move] = ACTIONS(2134),
    [sym_integer_literal] = ACTIONS(2132),
    [aux_sym_string_literal_token1] = ACTIONS(2132),
    [sym_char_literal] = ACTIONS(2132),
    [anon_sym_true] = ACTIONS(2134),
    [anon_sym_false] = ACTIONS(2134),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2134),
    [sym_super] = ACTIONS(2134),
    [sym_crate] = ACTIONS(2134),
    [sym_metavariable] = ACTIONS(2132),
    [sym_raw_string_literal] = ACTIONS(2132),
    [sym_float_literal] = ACTIONS(2132),
    [sym_block_comment] = ACTIONS(3),
  },
  [448] = {
    [ts_builtin_sym_end] = ACTIONS(2136),
    [sym_identifier] = ACTIONS(2138),
    [anon_sym_SEMI] = ACTIONS(2136),
    [anon_sym_macro_rules_BANG] = ACTIONS(2136),
    [anon_sym_LPAREN] = ACTIONS(2136),
    [anon_sym_LBRACE] = ACTIONS(2136),
    [anon_sym_RBRACE] = ACTIONS(2136),
    [anon_sym_LBRACK] = ACTIONS(2136),
    [anon_sym_STAR] = ACTIONS(2136),
    [anon_sym_u8] = ACTIONS(2138),
    [anon_sym_i8] = ACTIONS(2138),
    [anon_sym_u16] = ACTIONS(2138),
    [anon_sym_i16] = ACTIONS(2138),
    [anon_sym_u32] = ACTIONS(2138),
    [anon_sym_i32] = ACTIONS(2138),
    [anon_sym_u64] = ACTIONS(2138),
    [anon_sym_i64] = ACTIONS(2138),
    [anon_sym_u128] = ACTIONS(2138),
    [anon_sym_i128] = ACTIONS(2138),
    [anon_sym_isize] = ACTIONS(2138),
    [anon_sym_usize] = ACTIONS(2138),
    [anon_sym_f32] = ACTIONS(2138),
    [anon_sym_f64] = ACTIONS(2138),
    [anon_sym_bool] = ACTIONS(2138),
    [anon_sym_str] = ACTIONS(2138),
    [anon_sym_char] = ACTIONS(2138),
    [anon_sym_SQUOTE] = ACTIONS(2138),
    [anon_sym_async] = ACTIONS(2138),
    [anon_sym_break] = ACTIONS(2138),
    [anon_sym_const] = ACTIONS(2138),
    [anon_sym_continue] = ACTIONS(2138),
    [anon_sym_default] = ACTIONS(2138),
    [anon_sym_enum] = ACTIONS(2138),
    [anon_sym_fn] = ACTIONS(2138),
    [anon_sym_for] = ACTIONS(2138),
    [anon_sym_if] = ACTIONS(2138),
    [anon_sym_impl] = ACTIONS(2138),
    [anon_sym_let] = ACTIONS(2138),
    [anon_sym_loop] = ACTIONS(2138),
    [anon_sym_match] = ACTIONS(2138),
    [anon_sym_mod] = ACTIONS(2138),
    [anon_sym_pub] = ACTIONS(2138),
    [anon_sym_return] = ACTIONS(2138),
    [anon_sym_static] = ACTIONS(2138),
    [anon_sym_struct] = ACTIONS(2138),
    [anon_sym_trait] = ACTIONS(2138),
    [anon_sym_type] = ACTIONS(2138),
    [anon_sym_union] = ACTIONS(2138),
    [anon_sym_unsafe] = ACTIONS(2138),
    [anon_sym_use] = ACTIONS(2138),
    [anon_sym_while] = ACTIONS(2138),
    [anon_sym_POUND] = ACTIONS(2136),
    [anon_sym_BANG] = ACTIONS(2136),
    [anon_sym_extern] = ACTIONS(2138),
    [anon_sym_LT] = ACTIONS(2136),
    [anon_sym_COLON_COLON] = ACTIONS(2136),
    [anon_sym_AMP] = ACTIONS(2136),
    [anon_sym_DOT_DOT] = ACTIONS(2136),
    [anon_sym_DASH] = ACTIONS(2136),
    [anon_sym_PIPE] = ACTIONS(2136),
    [anon_sym_move] = ACTIONS(2138),
    [sym_integer_literal] = ACTIONS(2136),
    [aux_sym_string_literal_token1] = ACTIONS(2136),
    [sym_char_literal] = ACTIONS(2136),
    [anon_sym_true] = ACTIONS(2138),
    [anon_sym_false] = ACTIONS(2138),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2138),
    [sym_super] = ACTIONS(2138),
    [sym_crate] = ACTIONS(2138),
    [sym_metavariable] = ACTIONS(2136),
    [sym_raw_string_literal] = ACTIONS(2136),
    [sym_float_literal] = ACTIONS(2136),
    [sym_block_comment] = ACTIONS(3),
  },
  [449] = {
    [ts_builtin_sym_end] = ACTIONS(2140),
    [sym_identifier] = ACTIONS(2142),
    [anon_sym_SEMI] = ACTIONS(2140),
    [anon_sym_macro_rules_BANG] = ACTIONS(2140),
    [anon_sym_LPAREN] = ACTIONS(2140),
    [anon_sym_LBRACE] = ACTIONS(2140),
    [anon_sym_RBRACE] = ACTIONS(2140),
    [anon_sym_LBRACK] = ACTIONS(2140),
    [anon_sym_STAR] = ACTIONS(2140),
    [anon_sym_u8] = ACTIONS(2142),
    [anon_sym_i8] = ACTIONS(2142),
    [anon_sym_u16] = ACTIONS(2142),
    [anon_sym_i16] = ACTIONS(2142),
    [anon_sym_u32] = ACTIONS(2142),
    [anon_sym_i32] = ACTIONS(2142),
    [anon_sym_u64] = ACTIONS(2142),
    [anon_sym_i64] = ACTIONS(2142),
    [anon_sym_u128] = ACTIONS(2142),
    [anon_sym_i128] = ACTIONS(2142),
    [anon_sym_isize] = ACTIONS(2142),
    [anon_sym_usize] = ACTIONS(2142),
    [anon_sym_f32] = ACTIONS(2142),
    [anon_sym_f64] = ACTIONS(2142),
    [anon_sym_bool] = ACTIONS(2142),
    [anon_sym_str] = ACTIONS(2142),
    [anon_sym_char] = ACTIONS(2142),
    [anon_sym_SQUOTE] = ACTIONS(2142),
    [anon_sym_async] = ACTIONS(2142),
    [anon_sym_break] = ACTIONS(2142),
    [anon_sym_const] = ACTIONS(2142),
    [anon_sym_continue] = ACTIONS(2142),
    [anon_sym_default] = ACTIONS(2142),
    [anon_sym_enum] = ACTIONS(2142),
    [anon_sym_fn] = ACTIONS(2142),
    [anon_sym_for] = ACTIONS(2142),
    [anon_sym_if] = ACTIONS(2142),
    [anon_sym_impl] = ACTIONS(2142),
    [anon_sym_let] = ACTIONS(2142),
    [anon_sym_loop] = ACTIONS(2142),
    [anon_sym_match] = ACTIONS(2142),
    [anon_sym_mod] = ACTIONS(2142),
    [anon_sym_pub] = ACTIONS(2142),
    [anon_sym_return] = ACTIONS(2142),
    [anon_sym_static] = ACTIONS(2142),
    [anon_sym_struct] = ACTIONS(2142),
    [anon_sym_trait] = ACTIONS(2142),
    [anon_sym_type] = ACTIONS(2142),
    [anon_sym_union] = ACTIONS(2142),
    [anon_sym_unsafe] = ACTIONS(2142),
    [anon_sym_use] = ACTIONS(2142),
    [anon_sym_while] = ACTIONS(2142),
    [anon_sym_POUND] = ACTIONS(2140),
    [anon_sym_BANG] = ACTIONS(2140),
    [anon_sym_extern] = ACTIONS(2142),
    [anon_sym_LT] = ACTIONS(2140),
    [anon_sym_COLON_COLON] = ACTIONS(2140),
    [anon_sym_AMP] = ACTIONS(2140),
    [anon_sym_DOT_DOT] = ACTIONS(2140),
    [anon_sym_DASH] = ACTIONS(2140),
    [anon_sym_PIPE] = ACTIONS(2140),
    [anon_sym_move] = ACTIONS(2142),
    [sym_integer_literal] = ACTIONS(2140),
    [aux_sym_string_literal_token1] = ACTIONS(2140),
    [sym_char_literal] = ACTIONS(2140),
    [anon_sym_true] = ACTIONS(2142),
    [anon_sym_false] = ACTIONS(2142),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2142),
    [sym_super] = ACTIONS(2142),
    [sym_crate] = ACTIONS(2142),
    [sym_metavariable] = ACTIONS(2140),
    [sym_raw_string_literal] = ACTIONS(2140),
    [sym_float_literal] = ACTIONS(2140),
    [sym_block_comment] = ACTIONS(3),
  },
  [450] = {
    [ts_builtin_sym_end] = ACTIONS(2144),
    [sym_identifier] = ACTIONS(2146),
    [anon_sym_SEMI] = ACTIONS(2144),
    [anon_sym_macro_rules_BANG] = ACTIONS(2144),
    [anon_sym_LPAREN] = ACTIONS(2144),
    [anon_sym_LBRACE] = ACTIONS(2144),
    [anon_sym_RBRACE] = ACTIONS(2144),
    [anon_sym_LBRACK] = ACTIONS(2144),
    [anon_sym_STAR] = ACTIONS(2144),
    [anon_sym_u8] = ACTIONS(2146),
    [anon_sym_i8] = ACTIONS(2146),
    [anon_sym_u16] = ACTIONS(2146),
    [anon_sym_i16] = ACTIONS(2146),
    [anon_sym_u32] = ACTIONS(2146),
    [anon_sym_i32] = ACTIONS(2146),
    [anon_sym_u64] = ACTIONS(2146),
    [anon_sym_i64] = ACTIONS(2146),
    [anon_sym_u128] = ACTIONS(2146),
    [anon_sym_i128] = ACTIONS(2146),
    [anon_sym_isize] = ACTIONS(2146),
    [anon_sym_usize] = ACTIONS(2146),
    [anon_sym_f32] = ACTIONS(2146),
    [anon_sym_f64] = ACTIONS(2146),
    [anon_sym_bool] = ACTIONS(2146),
    [anon_sym_str] = ACTIONS(2146),
    [anon_sym_char] = ACTIONS(2146),
    [anon_sym_SQUOTE] = ACTIONS(2146),
    [anon_sym_async] = ACTIONS(2146),
    [anon_sym_break] = ACTIONS(2146),
    [anon_sym_const] = ACTIONS(2146),
    [anon_sym_continue] = ACTIONS(2146),
    [anon_sym_default] = ACTIONS(2146),
    [anon_sym_enum] = ACTIONS(2146),
    [anon_sym_fn] = ACTIONS(2146),
    [anon_sym_for] = ACTIONS(2146),
    [anon_sym_if] = ACTIONS(2146),
    [anon_sym_impl] = ACTIONS(2146),
    [anon_sym_let] = ACTIONS(2146),
    [anon_sym_loop] = ACTIONS(2146),
    [anon_sym_match] = ACTIONS(2146),
    [anon_sym_mod] = ACTIONS(2146),
    [anon_sym_pub] = ACTIONS(2146),
    [anon_sym_return] = ACTIONS(2146),
    [anon_sym_static] = ACTIONS(2146),
    [anon_sym_struct] = ACTIONS(2146),
    [anon_sym_trait] = ACTIONS(2146),
    [anon_sym_type] = ACTIONS(2146),
    [anon_sym_union] = ACTIONS(2146),
    [anon_sym_unsafe] = ACTIONS(2146),
    [anon_sym_use] = ACTIONS(2146),
    [anon_sym_while] = ACTIONS(2146),
    [anon_sym_POUND] = ACTIONS(2144),
    [anon_sym_BANG] = ACTIONS(2144),
    [anon_sym_extern] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(2144),
    [anon_sym_COLON_COLON] = ACTIONS(2144),
    [anon_sym_AMP] = ACTIONS(2144),
    [anon_sym_DOT_DOT] = ACTIONS(2144),
    [anon_sym_DASH] = ACTIONS(2144),
    [anon_sym_PIPE] = ACTIONS(2144),
    [anon_sym_move] = ACTIONS(2146),
    [sym_integer_literal] = ACTIONS(2144),
    [aux_sym_string_literal_token1] = ACTIONS(2144),
    [sym_char_literal] = ACTIONS(2144),
    [anon_sym_true] = ACTIONS(2146),
    [anon_sym_false] = ACTIONS(2146),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2146),
    [sym_super] = ACTIONS(2146),
    [sym_crate] = ACTIONS(2146),
    [sym_metavariable] = ACTIONS(2144),
    [sym_raw_string_literal] = ACTIONS(2144),
    [sym_float_literal] = ACTIONS(2144),
    [sym_block_comment] = ACTIONS(3),
  },
  [451] = {
    [sym_token_tree] = STATE(475),
    [sym_token_repetition] = STATE(475),
    [sym__literal] = STATE(475),
    [sym_string_literal] = STATE(475),
    [sym_boolean_literal] = STATE(475),
    [aux_sym_token_tree_repeat1] = STATE(475),
    [sym_identifier] = ACTIONS(2148),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_RBRACK] = ACTIONS(2156),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2148),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_as] = ACTIONS(2148),
    [anon_sym_async] = ACTIONS(2148),
    [anon_sym_await] = ACTIONS(2148),
    [anon_sym_break] = ACTIONS(2148),
    [anon_sym_const] = ACTIONS(2148),
    [anon_sym_continue] = ACTIONS(2148),
    [anon_sym_default] = ACTIONS(2148),
    [anon_sym_enum] = ACTIONS(2148),
    [anon_sym_fn] = ACTIONS(2148),
    [anon_sym_for] = ACTIONS(2148),
    [anon_sym_if] = ACTIONS(2148),
    [anon_sym_impl] = ACTIONS(2148),
    [anon_sym_let] = ACTIONS(2148),
    [anon_sym_loop] = ACTIONS(2148),
    [anon_sym_match] = ACTIONS(2148),
    [anon_sym_mod] = ACTIONS(2148),
    [anon_sym_pub] = ACTIONS(2148),
    [anon_sym_return] = ACTIONS(2148),
    [anon_sym_static] = ACTIONS(2148),
    [anon_sym_struct] = ACTIONS(2148),
    [anon_sym_trait] = ACTIONS(2148),
    [anon_sym_type] = ACTIONS(2148),
    [anon_sym_union] = ACTIONS(2148),
    [anon_sym_unsafe] = ACTIONS(2148),
    [anon_sym_use] = ACTIONS(2148),
    [anon_sym_where] = ACTIONS(2148),
    [anon_sym_while] = ACTIONS(2148),
    [sym_mutable_specifier] = ACTIONS(2148),
    [sym_integer_literal] = ACTIONS(2162),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2162),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2148),
    [sym_super] = ACTIONS(2148),
    [sym_crate] = ACTIONS(2148),
    [sym_metavariable] = ACTIONS(2162),
    [sym_raw_string_literal] = ACTIONS(2162),
    [sym_float_literal] = ACTIONS(2162),
    [sym_block_comment] = ACTIONS(3),
  },
  [452] = {
    [sym_token_tree] = STATE(426),
    [sym_token_repetition] = STATE(426),
    [sym__literal] = STATE(426),
    [sym_string_literal] = STATE(426),
    [sym_boolean_literal] = STATE(426),
    [aux_sym_token_tree_repeat1] = STATE(426),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_RBRACE] = ACTIONS(2166),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2164),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_as] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_await] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_fn] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_impl] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_loop] = ACTIONS(2164),
    [anon_sym_match] = ACTIONS(2164),
    [anon_sym_mod] = ACTIONS(2164),
    [anon_sym_pub] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_trait] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(2164),
    [anon_sym_use] = ACTIONS(2164),
    [anon_sym_where] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [sym_mutable_specifier] = ACTIONS(2164),
    [sym_integer_literal] = ACTIONS(2168),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2168),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_crate] = ACTIONS(2164),
    [sym_metavariable] = ACTIONS(2168),
    [sym_raw_string_literal] = ACTIONS(2168),
    [sym_float_literal] = ACTIONS(2168),
    [sym_block_comment] = ACTIONS(3),
  },
  [453] = {
    [sym_token_tree] = STATE(458),
    [sym_token_repetition] = STATE(458),
    [sym__literal] = STATE(458),
    [sym_string_literal] = STATE(458),
    [sym_boolean_literal] = STATE(458),
    [aux_sym_token_tree_repeat1] = STATE(458),
    [sym_identifier] = ACTIONS(2170),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_RBRACK] = ACTIONS(2172),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2170),
    [anon_sym_SQUOTE] = ACTIONS(2170),
    [anon_sym_as] = ACTIONS(2170),
    [anon_sym_async] = ACTIONS(2170),
    [anon_sym_await] = ACTIONS(2170),
    [anon_sym_break] = ACTIONS(2170),
    [anon_sym_const] = ACTIONS(2170),
    [anon_sym_continue] = ACTIONS(2170),
    [anon_sym_default] = ACTIONS(2170),
    [anon_sym_enum] = ACTIONS(2170),
    [anon_sym_fn] = ACTIONS(2170),
    [anon_sym_for] = ACTIONS(2170),
    [anon_sym_if] = ACTIONS(2170),
    [anon_sym_impl] = ACTIONS(2170),
    [anon_sym_let] = ACTIONS(2170),
    [anon_sym_loop] = ACTIONS(2170),
    [anon_sym_match] = ACTIONS(2170),
    [anon_sym_mod] = ACTIONS(2170),
    [anon_sym_pub] = ACTIONS(2170),
    [anon_sym_return] = ACTIONS(2170),
    [anon_sym_static] = ACTIONS(2170),
    [anon_sym_struct] = ACTIONS(2170),
    [anon_sym_trait] = ACTIONS(2170),
    [anon_sym_type] = ACTIONS(2170),
    [anon_sym_union] = ACTIONS(2170),
    [anon_sym_unsafe] = ACTIONS(2170),
    [anon_sym_use] = ACTIONS(2170),
    [anon_sym_where] = ACTIONS(2170),
    [anon_sym_while] = ACTIONS(2170),
    [sym_mutable_specifier] = ACTIONS(2170),
    [sym_integer_literal] = ACTIONS(2174),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2174),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2170),
    [sym_super] = ACTIONS(2170),
    [sym_crate] = ACTIONS(2170),
    [sym_metavariable] = ACTIONS(2174),
    [sym_raw_string_literal] = ACTIONS(2174),
    [sym_float_literal] = ACTIONS(2174),
    [sym_block_comment] = ACTIONS(3),
  },
  [454] = {
    [sym_token_tree] = STATE(426),
    [sym_token_repetition] = STATE(426),
    [sym__literal] = STATE(426),
    [sym_string_literal] = STATE(426),
    [sym_boolean_literal] = STATE(426),
    [aux_sym_token_tree_repeat1] = STATE(426),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_RPAREN] = ACTIONS(2176),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2164),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_as] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_await] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_fn] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_impl] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_loop] = ACTIONS(2164),
    [anon_sym_match] = ACTIONS(2164),
    [anon_sym_mod] = ACTIONS(2164),
    [anon_sym_pub] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_trait] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(2164),
    [anon_sym_use] = ACTIONS(2164),
    [anon_sym_where] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [sym_mutable_specifier] = ACTIONS(2164),
    [sym_integer_literal] = ACTIONS(2168),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2168),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_crate] = ACTIONS(2164),
    [sym_metavariable] = ACTIONS(2168),
    [sym_raw_string_literal] = ACTIONS(2168),
    [sym_float_literal] = ACTIONS(2168),
    [sym_block_comment] = ACTIONS(3),
  },
  [455] = {
    [sym_token_tree] = STATE(426),
    [sym_token_repetition] = STATE(426),
    [sym__literal] = STATE(426),
    [sym_string_literal] = STATE(426),
    [sym_boolean_literal] = STATE(426),
    [aux_sym_token_tree_repeat1] = STATE(426),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_RBRACE] = ACTIONS(2178),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2164),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_as] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_await] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_fn] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_impl] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_loop] = ACTIONS(2164),
    [anon_sym_match] = ACTIONS(2164),
    [anon_sym_mod] = ACTIONS(2164),
    [anon_sym_pub] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_trait] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(2164),
    [anon_sym_use] = ACTIONS(2164),
    [anon_sym_where] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [sym_mutable_specifier] = ACTIONS(2164),
    [sym_integer_literal] = ACTIONS(2168),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2168),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_crate] = ACTIONS(2164),
    [sym_metavariable] = ACTIONS(2168),
    [sym_raw_string_literal] = ACTIONS(2168),
    [sym_float_literal] = ACTIONS(2168),
    [sym_block_comment] = ACTIONS(3),
  },
  [456] = {
    [sym_token_tree] = STATE(426),
    [sym_token_repetition] = STATE(426),
    [sym__literal] = STATE(426),
    [sym_string_literal] = STATE(426),
    [sym_boolean_literal] = STATE(426),
    [aux_sym_token_tree_repeat1] = STATE(426),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_RBRACE] = ACTIONS(2176),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2164),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_as] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_await] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_fn] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_impl] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_loop] = ACTIONS(2164),
    [anon_sym_match] = ACTIONS(2164),
    [anon_sym_mod] = ACTIONS(2164),
    [anon_sym_pub] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_trait] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(2164),
    [anon_sym_use] = ACTIONS(2164),
    [anon_sym_where] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [sym_mutable_specifier] = ACTIONS(2164),
    [sym_integer_literal] = ACTIONS(2168),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2168),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_crate] = ACTIONS(2164),
    [sym_metavariable] = ACTIONS(2168),
    [sym_raw_string_literal] = ACTIONS(2168),
    [sym_float_literal] = ACTIONS(2168),
    [sym_block_comment] = ACTIONS(3),
  },
  [457] = {
    [sym_token_tree] = STATE(466),
    [sym_token_repetition] = STATE(466),
    [sym__literal] = STATE(466),
    [sym_string_literal] = STATE(466),
    [sym_boolean_literal] = STATE(466),
    [aux_sym_token_tree_repeat1] = STATE(466),
    [sym_identifier] = ACTIONS(2180),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_RPAREN] = ACTIONS(2182),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2180),
    [anon_sym_SQUOTE] = ACTIONS(2180),
    [anon_sym_as] = ACTIONS(2180),
    [anon_sym_async] = ACTIONS(2180),
    [anon_sym_await] = ACTIONS(2180),
    [anon_sym_break] = ACTIONS(2180),
    [anon_sym_const] = ACTIONS(2180),
    [anon_sym_continue] = ACTIONS(2180),
    [anon_sym_default] = ACTIONS(2180),
    [anon_sym_enum] = ACTIONS(2180),
    [anon_sym_fn] = ACTIONS(2180),
    [anon_sym_for] = ACTIONS(2180),
    [anon_sym_if] = ACTIONS(2180),
    [anon_sym_impl] = ACTIONS(2180),
    [anon_sym_let] = ACTIONS(2180),
    [anon_sym_loop] = ACTIONS(2180),
    [anon_sym_match] = ACTIONS(2180),
    [anon_sym_mod] = ACTIONS(2180),
    [anon_sym_pub] = ACTIONS(2180),
    [anon_sym_return] = ACTIONS(2180),
    [anon_sym_static] = ACTIONS(2180),
    [anon_sym_struct] = ACTIONS(2180),
    [anon_sym_trait] = ACTIONS(2180),
    [anon_sym_type] = ACTIONS(2180),
    [anon_sym_union] = ACTIONS(2180),
    [anon_sym_unsafe] = ACTIONS(2180),
    [anon_sym_use] = ACTIONS(2180),
    [anon_sym_where] = ACTIONS(2180),
    [anon_sym_while] = ACTIONS(2180),
    [sym_mutable_specifier] = ACTIONS(2180),
    [sym_integer_literal] = ACTIONS(2184),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2184),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2180),
    [sym_super] = ACTIONS(2180),
    [sym_crate] = ACTIONS(2180),
    [sym_metavariable] = ACTIONS(2184),
    [sym_raw_string_literal] = ACTIONS(2184),
    [sym_float_literal] = ACTIONS(2184),
    [sym_block_comment] = ACTIONS(3),
  },
  [458] = {
    [sym_token_tree] = STATE(426),
    [sym_token_repetition] = STATE(426),
    [sym__literal] = STATE(426),
    [sym_string_literal] = STATE(426),
    [sym_boolean_literal] = STATE(426),
    [aux_sym_token_tree_repeat1] = STATE(426),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_RBRACK] = ACTIONS(2186),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2164),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_as] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_await] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_fn] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_impl] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_loop] = ACTIONS(2164),
    [anon_sym_match] = ACTIONS(2164),
    [anon_sym_mod] = ACTIONS(2164),
    [anon_sym_pub] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_trait] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(2164),
    [anon_sym_use] = ACTIONS(2164),
    [anon_sym_where] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [sym_mutable_specifier] = ACTIONS(2164),
    [sym_integer_literal] = ACTIONS(2168),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2168),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_crate] = ACTIONS(2164),
    [sym_metavariable] = ACTIONS(2168),
    [sym_raw_string_literal] = ACTIONS(2168),
    [sym_float_literal] = ACTIONS(2168),
    [sym_block_comment] = ACTIONS(3),
  },
  [459] = {
    [sym_token_tree] = STATE(426),
    [sym_token_repetition] = STATE(426),
    [sym__literal] = STATE(426),
    [sym_string_literal] = STATE(426),
    [sym_boolean_literal] = STATE(426),
    [aux_sym_token_tree_repeat1] = STATE(426),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_RBRACE] = ACTIONS(2186),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2164),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_as] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_await] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_fn] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_impl] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_loop] = ACTIONS(2164),
    [anon_sym_match] = ACTIONS(2164),
    [anon_sym_mod] = ACTIONS(2164),
    [anon_sym_pub] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_trait] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(2164),
    [anon_sym_use] = ACTIONS(2164),
    [anon_sym_where] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [sym_mutable_specifier] = ACTIONS(2164),
    [sym_integer_literal] = ACTIONS(2168),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2168),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_crate] = ACTIONS(2164),
    [sym_metavariable] = ACTIONS(2168),
    [sym_raw_string_literal] = ACTIONS(2168),
    [sym_float_literal] = ACTIONS(2168),
    [sym_block_comment] = ACTIONS(3),
  },
  [460] = {
    [sym_token_tree] = STATE(426),
    [sym_token_repetition] = STATE(426),
    [sym__literal] = STATE(426),
    [sym_string_literal] = STATE(426),
    [sym_boolean_literal] = STATE(426),
    [aux_sym_token_tree_repeat1] = STATE(426),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2164),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_as] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_await] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_fn] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_impl] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_loop] = ACTIONS(2164),
    [anon_sym_match] = ACTIONS(2164),
    [anon_sym_mod] = ACTIONS(2164),
    [anon_sym_pub] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_trait] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(2164),
    [anon_sym_use] = ACTIONS(2164),
    [anon_sym_where] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [sym_mutable_specifier] = ACTIONS(2164),
    [sym_integer_literal] = ACTIONS(2168),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2168),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_crate] = ACTIONS(2164),
    [sym_metavariable] = ACTIONS(2168),
    [sym_raw_string_literal] = ACTIONS(2168),
    [sym_float_literal] = ACTIONS(2168),
    [sym_block_comment] = ACTIONS(3),
  },
  [461] = {
    [sym_token_tree] = STATE(452),
    [sym_token_repetition] = STATE(452),
    [sym__literal] = STATE(452),
    [sym_string_literal] = STATE(452),
    [sym_boolean_literal] = STATE(452),
    [aux_sym_token_tree_repeat1] = STATE(452),
    [sym_identifier] = ACTIONS(2188),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2188),
    [anon_sym_SQUOTE] = ACTIONS(2188),
    [anon_sym_as] = ACTIONS(2188),
    [anon_sym_async] = ACTIONS(2188),
    [anon_sym_await] = ACTIONS(2188),
    [anon_sym_break] = ACTIONS(2188),
    [anon_sym_const] = ACTIONS(2188),
    [anon_sym_continue] = ACTIONS(2188),
    [anon_sym_default] = ACTIONS(2188),
    [anon_sym_enum] = ACTIONS(2188),
    [anon_sym_fn] = ACTIONS(2188),
    [anon_sym_for] = ACTIONS(2188),
    [anon_sym_if] = ACTIONS(2188),
    [anon_sym_impl] = ACTIONS(2188),
    [anon_sym_let] = ACTIONS(2188),
    [anon_sym_loop] = ACTIONS(2188),
    [anon_sym_match] = ACTIONS(2188),
    [anon_sym_mod] = ACTIONS(2188),
    [anon_sym_pub] = ACTIONS(2188),
    [anon_sym_return] = ACTIONS(2188),
    [anon_sym_static] = ACTIONS(2188),
    [anon_sym_struct] = ACTIONS(2188),
    [anon_sym_trait] = ACTIONS(2188),
    [anon_sym_type] = ACTIONS(2188),
    [anon_sym_union] = ACTIONS(2188),
    [anon_sym_unsafe] = ACTIONS(2188),
    [anon_sym_use] = ACTIONS(2188),
    [anon_sym_where] = ACTIONS(2188),
    [anon_sym_while] = ACTIONS(2188),
    [sym_mutable_specifier] = ACTIONS(2188),
    [sym_integer_literal] = ACTIONS(2190),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2190),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2188),
    [sym_super] = ACTIONS(2188),
    [sym_crate] = ACTIONS(2188),
    [sym_metavariable] = ACTIONS(2190),
    [sym_raw_string_literal] = ACTIONS(2190),
    [sym_float_literal] = ACTIONS(2190),
    [sym_block_comment] = ACTIONS(3),
  },
  [462] = {
    [sym_token_tree] = STATE(471),
    [sym_token_repetition] = STATE(471),
    [sym__literal] = STATE(471),
    [sym_string_literal] = STATE(471),
    [sym_boolean_literal] = STATE(471),
    [aux_sym_token_tree_repeat1] = STATE(471),
    [sym_identifier] = ACTIONS(2192),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_RBRACK] = ACTIONS(2182),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2192),
    [anon_sym_SQUOTE] = ACTIONS(2192),
    [anon_sym_as] = ACTIONS(2192),
    [anon_sym_async] = ACTIONS(2192),
    [anon_sym_await] = ACTIONS(2192),
    [anon_sym_break] = ACTIONS(2192),
    [anon_sym_const] = ACTIONS(2192),
    [anon_sym_continue] = ACTIONS(2192),
    [anon_sym_default] = ACTIONS(2192),
    [anon_sym_enum] = ACTIONS(2192),
    [anon_sym_fn] = ACTIONS(2192),
    [anon_sym_for] = ACTIONS(2192),
    [anon_sym_if] = ACTIONS(2192),
    [anon_sym_impl] = ACTIONS(2192),
    [anon_sym_let] = ACTIONS(2192),
    [anon_sym_loop] = ACTIONS(2192),
    [anon_sym_match] = ACTIONS(2192),
    [anon_sym_mod] = ACTIONS(2192),
    [anon_sym_pub] = ACTIONS(2192),
    [anon_sym_return] = ACTIONS(2192),
    [anon_sym_static] = ACTIONS(2192),
    [anon_sym_struct] = ACTIONS(2192),
    [anon_sym_trait] = ACTIONS(2192),
    [anon_sym_type] = ACTIONS(2192),
    [anon_sym_union] = ACTIONS(2192),
    [anon_sym_unsafe] = ACTIONS(2192),
    [anon_sym_use] = ACTIONS(2192),
    [anon_sym_where] = ACTIONS(2192),
    [anon_sym_while] = ACTIONS(2192),
    [sym_mutable_specifier] = ACTIONS(2192),
    [sym_integer_literal] = ACTIONS(2194),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2194),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2192),
    [sym_super] = ACTIONS(2192),
    [sym_crate] = ACTIONS(2192),
    [sym_metavariable] = ACTIONS(2194),
    [sym_raw_string_literal] = ACTIONS(2194),
    [sym_float_literal] = ACTIONS(2194),
    [sym_block_comment] = ACTIONS(3),
  },
  [463] = {
    [sym_token_tree] = STATE(426),
    [sym_token_repetition] = STATE(426),
    [sym__literal] = STATE(426),
    [sym_string_literal] = STATE(426),
    [sym_boolean_literal] = STATE(426),
    [aux_sym_token_tree_repeat1] = STATE(426),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_RBRACK] = ACTIONS(2176),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2164),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_as] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_await] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_fn] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_impl] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_loop] = ACTIONS(2164),
    [anon_sym_match] = ACTIONS(2164),
    [anon_sym_mod] = ACTIONS(2164),
    [anon_sym_pub] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_trait] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(2164),
    [anon_sym_use] = ACTIONS(2164),
    [anon_sym_where] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [sym_mutable_specifier] = ACTIONS(2164),
    [sym_integer_literal] = ACTIONS(2168),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2168),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_crate] = ACTIONS(2164),
    [sym_metavariable] = ACTIONS(2168),
    [sym_raw_string_literal] = ACTIONS(2168),
    [sym_float_literal] = ACTIONS(2168),
    [sym_block_comment] = ACTIONS(3),
  },
  [464] = {
    [sym_token_tree] = STATE(460),
    [sym_token_repetition] = STATE(460),
    [sym__literal] = STATE(460),
    [sym_string_literal] = STATE(460),
    [sym_boolean_literal] = STATE(460),
    [aux_sym_token_tree_repeat1] = STATE(460),
    [sym_identifier] = ACTIONS(2196),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_RPAREN] = ACTIONS(2172),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2196),
    [anon_sym_SQUOTE] = ACTIONS(2196),
    [anon_sym_as] = ACTIONS(2196),
    [anon_sym_async] = ACTIONS(2196),
    [anon_sym_await] = ACTIONS(2196),
    [anon_sym_break] = ACTIONS(2196),
    [anon_sym_const] = ACTIONS(2196),
    [anon_sym_continue] = ACTIONS(2196),
    [anon_sym_default] = ACTIONS(2196),
    [anon_sym_enum] = ACTIONS(2196),
    [anon_sym_fn] = ACTIONS(2196),
    [anon_sym_for] = ACTIONS(2196),
    [anon_sym_if] = ACTIONS(2196),
    [anon_sym_impl] = ACTIONS(2196),
    [anon_sym_let] = ACTIONS(2196),
    [anon_sym_loop] = ACTIONS(2196),
    [anon_sym_match] = ACTIONS(2196),
    [anon_sym_mod] = ACTIONS(2196),
    [anon_sym_pub] = ACTIONS(2196),
    [anon_sym_return] = ACTIONS(2196),
    [anon_sym_static] = ACTIONS(2196),
    [anon_sym_struct] = ACTIONS(2196),
    [anon_sym_trait] = ACTIONS(2196),
    [anon_sym_type] = ACTIONS(2196),
    [anon_sym_union] = ACTIONS(2196),
    [anon_sym_unsafe] = ACTIONS(2196),
    [anon_sym_use] = ACTIONS(2196),
    [anon_sym_where] = ACTIONS(2196),
    [anon_sym_while] = ACTIONS(2196),
    [sym_mutable_specifier] = ACTIONS(2196),
    [sym_integer_literal] = ACTIONS(2198),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2198),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2196),
    [sym_super] = ACTIONS(2196),
    [sym_crate] = ACTIONS(2196),
    [sym_metavariable] = ACTIONS(2198),
    [sym_raw_string_literal] = ACTIONS(2198),
    [sym_float_literal] = ACTIONS(2198),
    [sym_block_comment] = ACTIONS(3),
  },
  [465] = {
    [sym_token_tree] = STATE(463),
    [sym_token_repetition] = STATE(463),
    [sym__literal] = STATE(463),
    [sym_string_literal] = STATE(463),
    [sym_boolean_literal] = STATE(463),
    [aux_sym_token_tree_repeat1] = STATE(463),
    [sym_identifier] = ACTIONS(2200),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_RBRACK] = ACTIONS(2202),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2200),
    [anon_sym_SQUOTE] = ACTIONS(2200),
    [anon_sym_as] = ACTIONS(2200),
    [anon_sym_async] = ACTIONS(2200),
    [anon_sym_await] = ACTIONS(2200),
    [anon_sym_break] = ACTIONS(2200),
    [anon_sym_const] = ACTIONS(2200),
    [anon_sym_continue] = ACTIONS(2200),
    [anon_sym_default] = ACTIONS(2200),
    [anon_sym_enum] = ACTIONS(2200),
    [anon_sym_fn] = ACTIONS(2200),
    [anon_sym_for] = ACTIONS(2200),
    [anon_sym_if] = ACTIONS(2200),
    [anon_sym_impl] = ACTIONS(2200),
    [anon_sym_let] = ACTIONS(2200),
    [anon_sym_loop] = ACTIONS(2200),
    [anon_sym_match] = ACTIONS(2200),
    [anon_sym_mod] = ACTIONS(2200),
    [anon_sym_pub] = ACTIONS(2200),
    [anon_sym_return] = ACTIONS(2200),
    [anon_sym_static] = ACTIONS(2200),
    [anon_sym_struct] = ACTIONS(2200),
    [anon_sym_trait] = ACTIONS(2200),
    [anon_sym_type] = ACTIONS(2200),
    [anon_sym_union] = ACTIONS(2200),
    [anon_sym_unsafe] = ACTIONS(2200),
    [anon_sym_use] = ACTIONS(2200),
    [anon_sym_where] = ACTIONS(2200),
    [anon_sym_while] = ACTIONS(2200),
    [sym_mutable_specifier] = ACTIONS(2200),
    [sym_integer_literal] = ACTIONS(2204),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2204),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2200),
    [sym_super] = ACTIONS(2200),
    [sym_crate] = ACTIONS(2200),
    [sym_metavariable] = ACTIONS(2204),
    [sym_raw_string_literal] = ACTIONS(2204),
    [sym_float_literal] = ACTIONS(2204),
    [sym_block_comment] = ACTIONS(3),
  },
  [466] = {
    [sym_token_tree] = STATE(426),
    [sym_token_repetition] = STATE(426),
    [sym__literal] = STATE(426),
    [sym_string_literal] = STATE(426),
    [sym_boolean_literal] = STATE(426),
    [aux_sym_token_tree_repeat1] = STATE(426),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_RPAREN] = ACTIONS(2166),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2164),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_as] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_await] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_fn] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_impl] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_loop] = ACTIONS(2164),
    [anon_sym_match] = ACTIONS(2164),
    [anon_sym_mod] = ACTIONS(2164),
    [anon_sym_pub] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_trait] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(2164),
    [anon_sym_use] = ACTIONS(2164),
    [anon_sym_where] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [sym_mutable_specifier] = ACTIONS(2164),
    [sym_integer_literal] = ACTIONS(2168),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2168),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_crate] = ACTIONS(2164),
    [sym_metavariable] = ACTIONS(2168),
    [sym_raw_string_literal] = ACTIONS(2168),
    [sym_float_literal] = ACTIONS(2168),
    [sym_block_comment] = ACTIONS(3),
  },
  [467] = {
    [sym_token_tree] = STATE(426),
    [sym_token_repetition] = STATE(426),
    [sym__literal] = STATE(426),
    [sym_string_literal] = STATE(426),
    [sym_boolean_literal] = STATE(426),
    [aux_sym_token_tree_repeat1] = STATE(426),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_RPAREN] = ACTIONS(2206),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2164),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_as] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_await] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_fn] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_impl] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_loop] = ACTIONS(2164),
    [anon_sym_match] = ACTIONS(2164),
    [anon_sym_mod] = ACTIONS(2164),
    [anon_sym_pub] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_trait] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(2164),
    [anon_sym_use] = ACTIONS(2164),
    [anon_sym_where] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [sym_mutable_specifier] = ACTIONS(2164),
    [sym_integer_literal] = ACTIONS(2168),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2168),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_crate] = ACTIONS(2164),
    [sym_metavariable] = ACTIONS(2168),
    [sym_raw_string_literal] = ACTIONS(2168),
    [sym_float_literal] = ACTIONS(2168),
    [sym_block_comment] = ACTIONS(3),
  },
  [468] = {
    [sym_token_tree] = STATE(467),
    [sym_token_repetition] = STATE(467),
    [sym__literal] = STATE(467),
    [sym_string_literal] = STATE(467),
    [sym_boolean_literal] = STATE(467),
    [aux_sym_token_tree_repeat1] = STATE(467),
    [sym_identifier] = ACTIONS(2208),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_RPAREN] = ACTIONS(2210),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2208),
    [anon_sym_SQUOTE] = ACTIONS(2208),
    [anon_sym_as] = ACTIONS(2208),
    [anon_sym_async] = ACTIONS(2208),
    [anon_sym_await] = ACTIONS(2208),
    [anon_sym_break] = ACTIONS(2208),
    [anon_sym_const] = ACTIONS(2208),
    [anon_sym_continue] = ACTIONS(2208),
    [anon_sym_default] = ACTIONS(2208),
    [anon_sym_enum] = ACTIONS(2208),
    [anon_sym_fn] = ACTIONS(2208),
    [anon_sym_for] = ACTIONS(2208),
    [anon_sym_if] = ACTIONS(2208),
    [anon_sym_impl] = ACTIONS(2208),
    [anon_sym_let] = ACTIONS(2208),
    [anon_sym_loop] = ACTIONS(2208),
    [anon_sym_match] = ACTIONS(2208),
    [anon_sym_mod] = ACTIONS(2208),
    [anon_sym_pub] = ACTIONS(2208),
    [anon_sym_return] = ACTIONS(2208),
    [anon_sym_static] = ACTIONS(2208),
    [anon_sym_struct] = ACTIONS(2208),
    [anon_sym_trait] = ACTIONS(2208),
    [anon_sym_type] = ACTIONS(2208),
    [anon_sym_union] = ACTIONS(2208),
    [anon_sym_unsafe] = ACTIONS(2208),
    [anon_sym_use] = ACTIONS(2208),
    [anon_sym_where] = ACTIONS(2208),
    [anon_sym_while] = ACTIONS(2208),
    [sym_mutable_specifier] = ACTIONS(2208),
    [sym_integer_literal] = ACTIONS(2212),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2212),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2208),
    [sym_super] = ACTIONS(2208),
    [sym_crate] = ACTIONS(2208),
    [sym_metavariable] = ACTIONS(2212),
    [sym_raw_string_literal] = ACTIONS(2212),
    [sym_float_literal] = ACTIONS(2212),
    [sym_block_comment] = ACTIONS(3),
  },
  [469] = {
    [sym_token_tree] = STATE(426),
    [sym_token_repetition] = STATE(426),
    [sym__literal] = STATE(426),
    [sym_string_literal] = STATE(426),
    [sym_boolean_literal] = STATE(426),
    [aux_sym_token_tree_repeat1] = STATE(426),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_RBRACK] = ACTIONS(2178),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2164),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_as] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_await] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_fn] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_impl] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_loop] = ACTIONS(2164),
    [anon_sym_match] = ACTIONS(2164),
    [anon_sym_mod] = ACTIONS(2164),
    [anon_sym_pub] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_trait] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(2164),
    [anon_sym_use] = ACTIONS(2164),
    [anon_sym_where] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [sym_mutable_specifier] = ACTIONS(2164),
    [sym_integer_literal] = ACTIONS(2168),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2168),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_crate] = ACTIONS(2164),
    [sym_metavariable] = ACTIONS(2168),
    [sym_raw_string_literal] = ACTIONS(2168),
    [sym_float_literal] = ACTIONS(2168),
    [sym_block_comment] = ACTIONS(3),
  },
  [470] = {
    [sym_token_tree] = STATE(426),
    [sym_token_repetition] = STATE(426),
    [sym__literal] = STATE(426),
    [sym_string_literal] = STATE(426),
    [sym_boolean_literal] = STATE(426),
    [aux_sym_token_tree_repeat1] = STATE(426),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_RPAREN] = ACTIONS(2178),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2164),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_as] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_await] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_fn] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_impl] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_loop] = ACTIONS(2164),
    [anon_sym_match] = ACTIONS(2164),
    [anon_sym_mod] = ACTIONS(2164),
    [anon_sym_pub] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_trait] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(2164),
    [anon_sym_use] = ACTIONS(2164),
    [anon_sym_where] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [sym_mutable_specifier] = ACTIONS(2164),
    [sym_integer_literal] = ACTIONS(2168),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2168),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_crate] = ACTIONS(2164),
    [sym_metavariable] = ACTIONS(2168),
    [sym_raw_string_literal] = ACTIONS(2168),
    [sym_float_literal] = ACTIONS(2168),
    [sym_block_comment] = ACTIONS(3),
  },
  [471] = {
    [sym_token_tree] = STATE(426),
    [sym_token_repetition] = STATE(426),
    [sym__literal] = STATE(426),
    [sym_string_literal] = STATE(426),
    [sym_boolean_literal] = STATE(426),
    [aux_sym_token_tree_repeat1] = STATE(426),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_RBRACK] = ACTIONS(2166),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2164),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_as] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_await] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_fn] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_impl] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_loop] = ACTIONS(2164),
    [anon_sym_match] = ACTIONS(2164),
    [anon_sym_mod] = ACTIONS(2164),
    [anon_sym_pub] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_trait] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(2164),
    [anon_sym_use] = ACTIONS(2164),
    [anon_sym_where] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [sym_mutable_specifier] = ACTIONS(2164),
    [sym_integer_literal] = ACTIONS(2168),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2168),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_crate] = ACTIONS(2164),
    [sym_metavariable] = ACTIONS(2168),
    [sym_raw_string_literal] = ACTIONS(2168),
    [sym_float_literal] = ACTIONS(2168),
    [sym_block_comment] = ACTIONS(3),
  },
  [472] = {
    [sym_token_tree] = STATE(469),
    [sym_token_repetition] = STATE(469),
    [sym__literal] = STATE(469),
    [sym_string_literal] = STATE(469),
    [sym_boolean_literal] = STATE(469),
    [aux_sym_token_tree_repeat1] = STATE(469),
    [sym_identifier] = ACTIONS(2214),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_RBRACK] = ACTIONS(2216),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2214),
    [anon_sym_SQUOTE] = ACTIONS(2214),
    [anon_sym_as] = ACTIONS(2214),
    [anon_sym_async] = ACTIONS(2214),
    [anon_sym_await] = ACTIONS(2214),
    [anon_sym_break] = ACTIONS(2214),
    [anon_sym_const] = ACTIONS(2214),
    [anon_sym_continue] = ACTIONS(2214),
    [anon_sym_default] = ACTIONS(2214),
    [anon_sym_enum] = ACTIONS(2214),
    [anon_sym_fn] = ACTIONS(2214),
    [anon_sym_for] = ACTIONS(2214),
    [anon_sym_if] = ACTIONS(2214),
    [anon_sym_impl] = ACTIONS(2214),
    [anon_sym_let] = ACTIONS(2214),
    [anon_sym_loop] = ACTIONS(2214),
    [anon_sym_match] = ACTIONS(2214),
    [anon_sym_mod] = ACTIONS(2214),
    [anon_sym_pub] = ACTIONS(2214),
    [anon_sym_return] = ACTIONS(2214),
    [anon_sym_static] = ACTIONS(2214),
    [anon_sym_struct] = ACTIONS(2214),
    [anon_sym_trait] = ACTIONS(2214),
    [anon_sym_type] = ACTIONS(2214),
    [anon_sym_union] = ACTIONS(2214),
    [anon_sym_unsafe] = ACTIONS(2214),
    [anon_sym_use] = ACTIONS(2214),
    [anon_sym_where] = ACTIONS(2214),
    [anon_sym_while] = ACTIONS(2214),
    [sym_mutable_specifier] = ACTIONS(2214),
    [sym_integer_literal] = ACTIONS(2218),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2218),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2214),
    [sym_super] = ACTIONS(2214),
    [sym_crate] = ACTIONS(2214),
    [sym_metavariable] = ACTIONS(2218),
    [sym_raw_string_literal] = ACTIONS(2218),
    [sym_float_literal] = ACTIONS(2218),
    [sym_block_comment] = ACTIONS(3),
  },
  [473] = {
    [sym_token_tree] = STATE(456),
    [sym_token_repetition] = STATE(456),
    [sym__literal] = STATE(456),
    [sym_string_literal] = STATE(456),
    [sym_boolean_literal] = STATE(456),
    [aux_sym_token_tree_repeat1] = STATE(456),
    [sym_identifier] = ACTIONS(2220),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_RBRACE] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2220),
    [anon_sym_SQUOTE] = ACTIONS(2220),
    [anon_sym_as] = ACTIONS(2220),
    [anon_sym_async] = ACTIONS(2220),
    [anon_sym_await] = ACTIONS(2220),
    [anon_sym_break] = ACTIONS(2220),
    [anon_sym_const] = ACTIONS(2220),
    [anon_sym_continue] = ACTIONS(2220),
    [anon_sym_default] = ACTIONS(2220),
    [anon_sym_enum] = ACTIONS(2220),
    [anon_sym_fn] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2220),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_impl] = ACTIONS(2220),
    [anon_sym_let] = ACTIONS(2220),
    [anon_sym_loop] = ACTIONS(2220),
    [anon_sym_match] = ACTIONS(2220),
    [anon_sym_mod] = ACTIONS(2220),
    [anon_sym_pub] = ACTIONS(2220),
    [anon_sym_return] = ACTIONS(2220),
    [anon_sym_static] = ACTIONS(2220),
    [anon_sym_struct] = ACTIONS(2220),
    [anon_sym_trait] = ACTIONS(2220),
    [anon_sym_type] = ACTIONS(2220),
    [anon_sym_union] = ACTIONS(2220),
    [anon_sym_unsafe] = ACTIONS(2220),
    [anon_sym_use] = ACTIONS(2220),
    [anon_sym_where] = ACTIONS(2220),
    [anon_sym_while] = ACTIONS(2220),
    [sym_mutable_specifier] = ACTIONS(2220),
    [sym_integer_literal] = ACTIONS(2222),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2222),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2220),
    [sym_super] = ACTIONS(2220),
    [sym_crate] = ACTIONS(2220),
    [sym_metavariable] = ACTIONS(2222),
    [sym_raw_string_literal] = ACTIONS(2222),
    [sym_float_literal] = ACTIONS(2222),
    [sym_block_comment] = ACTIONS(3),
  },
  [474] = {
    [sym_token_tree] = STATE(454),
    [sym_token_repetition] = STATE(454),
    [sym__literal] = STATE(454),
    [sym_string_literal] = STATE(454),
    [sym_boolean_literal] = STATE(454),
    [aux_sym_token_tree_repeat1] = STATE(454),
    [sym_identifier] = ACTIONS(2224),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_RPAREN] = ACTIONS(2202),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2224),
    [anon_sym_SQUOTE] = ACTIONS(2224),
    [anon_sym_as] = ACTIONS(2224),
    [anon_sym_async] = ACTIONS(2224),
    [anon_sym_await] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
    [anon_sym_fn] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_impl] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_loop] = ACTIONS(2224),
    [anon_sym_match] = ACTIONS(2224),
    [anon_sym_mod] = ACTIONS(2224),
    [anon_sym_pub] = ACTIONS(2224),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_struct] = ACTIONS(2224),
    [anon_sym_trait] = ACTIONS(2224),
    [anon_sym_type] = ACTIONS(2224),
    [anon_sym_union] = ACTIONS(2224),
    [anon_sym_unsafe] = ACTIONS(2224),
    [anon_sym_use] = ACTIONS(2224),
    [anon_sym_where] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [sym_mutable_specifier] = ACTIONS(2224),
    [sym_integer_literal] = ACTIONS(2226),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2226),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2224),
    [sym_super] = ACTIONS(2224),
    [sym_crate] = ACTIONS(2224),
    [sym_metavariable] = ACTIONS(2226),
    [sym_raw_string_literal] = ACTIONS(2226),
    [sym_float_literal] = ACTIONS(2226),
    [sym_block_comment] = ACTIONS(3),
  },
  [475] = {
    [sym_token_tree] = STATE(426),
    [sym_token_repetition] = STATE(426),
    [sym__literal] = STATE(426),
    [sym_string_literal] = STATE(426),
    [sym_boolean_literal] = STATE(426),
    [aux_sym_token_tree_repeat1] = STATE(426),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_RBRACK] = ACTIONS(2228),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2164),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_as] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_await] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_fn] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_impl] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_loop] = ACTIONS(2164),
    [anon_sym_match] = ACTIONS(2164),
    [anon_sym_mod] = ACTIONS(2164),
    [anon_sym_pub] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_trait] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(2164),
    [anon_sym_use] = ACTIONS(2164),
    [anon_sym_where] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [sym_mutable_specifier] = ACTIONS(2164),
    [sym_integer_literal] = ACTIONS(2168),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2168),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_crate] = ACTIONS(2164),
    [sym_metavariable] = ACTIONS(2168),
    [sym_raw_string_literal] = ACTIONS(2168),
    [sym_float_literal] = ACTIONS(2168),
    [sym_block_comment] = ACTIONS(3),
  },
  [476] = {
    [sym_token_tree] = STATE(426),
    [sym_token_repetition] = STATE(426),
    [sym__literal] = STATE(426),
    [sym_string_literal] = STATE(426),
    [sym_boolean_literal] = STATE(426),
    [aux_sym_token_tree_repeat1] = STATE(426),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_RBRACE] = ACTIONS(2228),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2164),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_as] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_await] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_fn] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_impl] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_loop] = ACTIONS(2164),
    [anon_sym_match] = ACTIONS(2164),
    [anon_sym_mod] = ACTIONS(2164),
    [anon_sym_pub] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_trait] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(2164),
    [anon_sym_use] = ACTIONS(2164),
    [anon_sym_where] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [sym_mutable_specifier] = ACTIONS(2164),
    [sym_integer_literal] = ACTIONS(2168),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2168),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_crate] = ACTIONS(2164),
    [sym_metavariable] = ACTIONS(2168),
    [sym_raw_string_literal] = ACTIONS(2168),
    [sym_float_literal] = ACTIONS(2168),
    [sym_block_comment] = ACTIONS(3),
  },
  [477] = {
    [sym_token_tree] = STATE(455),
    [sym_token_repetition] = STATE(455),
    [sym__literal] = STATE(455),
    [sym_string_literal] = STATE(455),
    [sym_boolean_literal] = STATE(455),
    [aux_sym_token_tree_repeat1] = STATE(455),
    [sym_identifier] = ACTIONS(2230),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_RBRACE] = ACTIONS(2216),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2230),
    [anon_sym_SQUOTE] = ACTIONS(2230),
    [anon_sym_as] = ACTIONS(2230),
    [anon_sym_async] = ACTIONS(2230),
    [anon_sym_await] = ACTIONS(2230),
    [anon_sym_break] = ACTIONS(2230),
    [anon_sym_const] = ACTIONS(2230),
    [anon_sym_continue] = ACTIONS(2230),
    [anon_sym_default] = ACTIONS(2230),
    [anon_sym_enum] = ACTIONS(2230),
    [anon_sym_fn] = ACTIONS(2230),
    [anon_sym_for] = ACTIONS(2230),
    [anon_sym_if] = ACTIONS(2230),
    [anon_sym_impl] = ACTIONS(2230),
    [anon_sym_let] = ACTIONS(2230),
    [anon_sym_loop] = ACTIONS(2230),
    [anon_sym_match] = ACTIONS(2230),
    [anon_sym_mod] = ACTIONS(2230),
    [anon_sym_pub] = ACTIONS(2230),
    [anon_sym_return] = ACTIONS(2230),
    [anon_sym_static] = ACTIONS(2230),
    [anon_sym_struct] = ACTIONS(2230),
    [anon_sym_trait] = ACTIONS(2230),
    [anon_sym_type] = ACTIONS(2230),
    [anon_sym_union] = ACTIONS(2230),
    [anon_sym_unsafe] = ACTIONS(2230),
    [anon_sym_use] = ACTIONS(2230),
    [anon_sym_where] = ACTIONS(2230),
    [anon_sym_while] = ACTIONS(2230),
    [sym_mutable_specifier] = ACTIONS(2230),
    [sym_integer_literal] = ACTIONS(2232),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2232),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2230),
    [sym_super] = ACTIONS(2230),
    [sym_crate] = ACTIONS(2230),
    [sym_metavariable] = ACTIONS(2232),
    [sym_raw_string_literal] = ACTIONS(2232),
    [sym_float_literal] = ACTIONS(2232),
    [sym_block_comment] = ACTIONS(3),
  },
  [478] = {
    [sym_token_tree] = STATE(426),
    [sym_token_repetition] = STATE(426),
    [sym__literal] = STATE(426),
    [sym_string_literal] = STATE(426),
    [sym_boolean_literal] = STATE(426),
    [aux_sym_token_tree_repeat1] = STATE(426),
    [sym_identifier] = ACTIONS(2164),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_RPAREN] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2164),
    [anon_sym_SQUOTE] = ACTIONS(2164),
    [anon_sym_as] = ACTIONS(2164),
    [anon_sym_async] = ACTIONS(2164),
    [anon_sym_await] = ACTIONS(2164),
    [anon_sym_break] = ACTIONS(2164),
    [anon_sym_const] = ACTIONS(2164),
    [anon_sym_continue] = ACTIONS(2164),
    [anon_sym_default] = ACTIONS(2164),
    [anon_sym_enum] = ACTIONS(2164),
    [anon_sym_fn] = ACTIONS(2164),
    [anon_sym_for] = ACTIONS(2164),
    [anon_sym_if] = ACTIONS(2164),
    [anon_sym_impl] = ACTIONS(2164),
    [anon_sym_let] = ACTIONS(2164),
    [anon_sym_loop] = ACTIONS(2164),
    [anon_sym_match] = ACTIONS(2164),
    [anon_sym_mod] = ACTIONS(2164),
    [anon_sym_pub] = ACTIONS(2164),
    [anon_sym_return] = ACTIONS(2164),
    [anon_sym_static] = ACTIONS(2164),
    [anon_sym_struct] = ACTIONS(2164),
    [anon_sym_trait] = ACTIONS(2164),
    [anon_sym_type] = ACTIONS(2164),
    [anon_sym_union] = ACTIONS(2164),
    [anon_sym_unsafe] = ACTIONS(2164),
    [anon_sym_use] = ACTIONS(2164),
    [anon_sym_where] = ACTIONS(2164),
    [anon_sym_while] = ACTIONS(2164),
    [sym_mutable_specifier] = ACTIONS(2164),
    [sym_integer_literal] = ACTIONS(2168),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2168),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2164),
    [sym_super] = ACTIONS(2164),
    [sym_crate] = ACTIONS(2164),
    [sym_metavariable] = ACTIONS(2168),
    [sym_raw_string_literal] = ACTIONS(2168),
    [sym_float_literal] = ACTIONS(2168),
    [sym_block_comment] = ACTIONS(3),
  },
  [479] = {
    [sym_token_tree] = STATE(476),
    [sym_token_repetition] = STATE(476),
    [sym__literal] = STATE(476),
    [sym_string_literal] = STATE(476),
    [sym_boolean_literal] = STATE(476),
    [aux_sym_token_tree_repeat1] = STATE(476),
    [sym_identifier] = ACTIONS(2234),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_RBRACE] = ACTIONS(2156),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2234),
    [anon_sym_SQUOTE] = ACTIONS(2234),
    [anon_sym_as] = ACTIONS(2234),
    [anon_sym_async] = ACTIONS(2234),
    [anon_sym_await] = ACTIONS(2234),
    [anon_sym_break] = ACTIONS(2234),
    [anon_sym_const] = ACTIONS(2234),
    [anon_sym_continue] = ACTIONS(2234),
    [anon_sym_default] = ACTIONS(2234),
    [anon_sym_enum] = ACTIONS(2234),
    [anon_sym_fn] = ACTIONS(2234),
    [anon_sym_for] = ACTIONS(2234),
    [anon_sym_if] = ACTIONS(2234),
    [anon_sym_impl] = ACTIONS(2234),
    [anon_sym_let] = ACTIONS(2234),
    [anon_sym_loop] = ACTIONS(2234),
    [anon_sym_match] = ACTIONS(2234),
    [anon_sym_mod] = ACTIONS(2234),
    [anon_sym_pub] = ACTIONS(2234),
    [anon_sym_return] = ACTIONS(2234),
    [anon_sym_static] = ACTIONS(2234),
    [anon_sym_struct] = ACTIONS(2234),
    [anon_sym_trait] = ACTIONS(2234),
    [anon_sym_type] = ACTIONS(2234),
    [anon_sym_union] = ACTIONS(2234),
    [anon_sym_unsafe] = ACTIONS(2234),
    [anon_sym_use] = ACTIONS(2234),
    [anon_sym_where] = ACTIONS(2234),
    [anon_sym_while] = ACTIONS(2234),
    [sym_mutable_specifier] = ACTIONS(2234),
    [sym_integer_literal] = ACTIONS(2236),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2236),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2234),
    [sym_super] = ACTIONS(2234),
    [sym_crate] = ACTIONS(2234),
    [sym_metavariable] = ACTIONS(2236),
    [sym_raw_string_literal] = ACTIONS(2236),
    [sym_float_literal] = ACTIONS(2236),
    [sym_block_comment] = ACTIONS(3),
  },
  [480] = {
    [sym_token_tree] = STATE(459),
    [sym_token_repetition] = STATE(459),
    [sym__literal] = STATE(459),
    [sym_string_literal] = STATE(459),
    [sym_boolean_literal] = STATE(459),
    [aux_sym_token_tree_repeat1] = STATE(459),
    [sym_identifier] = ACTIONS(2238),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_RBRACE] = ACTIONS(2172),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2238),
    [anon_sym_SQUOTE] = ACTIONS(2238),
    [anon_sym_as] = ACTIONS(2238),
    [anon_sym_async] = ACTIONS(2238),
    [anon_sym_await] = ACTIONS(2238),
    [anon_sym_break] = ACTIONS(2238),
    [anon_sym_const] = ACTIONS(2238),
    [anon_sym_continue] = ACTIONS(2238),
    [anon_sym_default] = ACTIONS(2238),
    [anon_sym_enum] = ACTIONS(2238),
    [anon_sym_fn] = ACTIONS(2238),
    [anon_sym_for] = ACTIONS(2238),
    [anon_sym_if] = ACTIONS(2238),
    [anon_sym_impl] = ACTIONS(2238),
    [anon_sym_let] = ACTIONS(2238),
    [anon_sym_loop] = ACTIONS(2238),
    [anon_sym_match] = ACTIONS(2238),
    [anon_sym_mod] = ACTIONS(2238),
    [anon_sym_pub] = ACTIONS(2238),
    [anon_sym_return] = ACTIONS(2238),
    [anon_sym_static] = ACTIONS(2238),
    [anon_sym_struct] = ACTIONS(2238),
    [anon_sym_trait] = ACTIONS(2238),
    [anon_sym_type] = ACTIONS(2238),
    [anon_sym_union] = ACTIONS(2238),
    [anon_sym_unsafe] = ACTIONS(2238),
    [anon_sym_use] = ACTIONS(2238),
    [anon_sym_where] = ACTIONS(2238),
    [anon_sym_while] = ACTIONS(2238),
    [sym_mutable_specifier] = ACTIONS(2238),
    [sym_integer_literal] = ACTIONS(2240),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2240),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2238),
    [sym_super] = ACTIONS(2238),
    [sym_crate] = ACTIONS(2238),
    [sym_metavariable] = ACTIONS(2240),
    [sym_raw_string_literal] = ACTIONS(2240),
    [sym_float_literal] = ACTIONS(2240),
    [sym_block_comment] = ACTIONS(3),
  },
  [481] = {
    [sym_token_tree] = STATE(478),
    [sym_token_repetition] = STATE(478),
    [sym__literal] = STATE(478),
    [sym_string_literal] = STATE(478),
    [sym_boolean_literal] = STATE(478),
    [aux_sym_token_tree_repeat1] = STATE(478),
    [sym_identifier] = ACTIONS(2242),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_RPAREN] = ACTIONS(2156),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2242),
    [anon_sym_SQUOTE] = ACTIONS(2242),
    [anon_sym_as] = ACTIONS(2242),
    [anon_sym_async] = ACTIONS(2242),
    [anon_sym_await] = ACTIONS(2242),
    [anon_sym_break] = ACTIONS(2242),
    [anon_sym_const] = ACTIONS(2242),
    [anon_sym_continue] = ACTIONS(2242),
    [anon_sym_default] = ACTIONS(2242),
    [anon_sym_enum] = ACTIONS(2242),
    [anon_sym_fn] = ACTIONS(2242),
    [anon_sym_for] = ACTIONS(2242),
    [anon_sym_if] = ACTIONS(2242),
    [anon_sym_impl] = ACTIONS(2242),
    [anon_sym_let] = ACTIONS(2242),
    [anon_sym_loop] = ACTIONS(2242),
    [anon_sym_match] = ACTIONS(2242),
    [anon_sym_mod] = ACTIONS(2242),
    [anon_sym_pub] = ACTIONS(2242),
    [anon_sym_return] = ACTIONS(2242),
    [anon_sym_static] = ACTIONS(2242),
    [anon_sym_struct] = ACTIONS(2242),
    [anon_sym_trait] = ACTIONS(2242),
    [anon_sym_type] = ACTIONS(2242),
    [anon_sym_union] = ACTIONS(2242),
    [anon_sym_unsafe] = ACTIONS(2242),
    [anon_sym_use] = ACTIONS(2242),
    [anon_sym_where] = ACTIONS(2242),
    [anon_sym_while] = ACTIONS(2242),
    [sym_mutable_specifier] = ACTIONS(2242),
    [sym_integer_literal] = ACTIONS(2244),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2244),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2242),
    [sym_super] = ACTIONS(2242),
    [sym_crate] = ACTIONS(2242),
    [sym_metavariable] = ACTIONS(2244),
    [sym_raw_string_literal] = ACTIONS(2244),
    [sym_float_literal] = ACTIONS(2244),
    [sym_block_comment] = ACTIONS(3),
  },
  [482] = {
    [sym_token_tree] = STATE(470),
    [sym_token_repetition] = STATE(470),
    [sym__literal] = STATE(470),
    [sym_string_literal] = STATE(470),
    [sym_boolean_literal] = STATE(470),
    [aux_sym_token_tree_repeat1] = STATE(470),
    [sym_identifier] = ACTIONS(2246),
    [anon_sym_LPAREN] = ACTIONS(2150),
    [anon_sym_RPAREN] = ACTIONS(2216),
    [anon_sym_LBRACE] = ACTIONS(2152),
    [anon_sym_LBRACK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_u8] = ACTIONS(2160),
    [anon_sym_i8] = ACTIONS(2160),
    [anon_sym_u16] = ACTIONS(2160),
    [anon_sym_i16] = ACTIONS(2160),
    [anon_sym_u32] = ACTIONS(2160),
    [anon_sym_i32] = ACTIONS(2160),
    [anon_sym_u64] = ACTIONS(2160),
    [anon_sym_i64] = ACTIONS(2160),
    [anon_sym_u128] = ACTIONS(2160),
    [anon_sym_i128] = ACTIONS(2160),
    [anon_sym_isize] = ACTIONS(2160),
    [anon_sym_usize] = ACTIONS(2160),
    [anon_sym_f32] = ACTIONS(2160),
    [anon_sym_f64] = ACTIONS(2160),
    [anon_sym_bool] = ACTIONS(2160),
    [anon_sym_str] = ACTIONS(2160),
    [anon_sym_char] = ACTIONS(2160),
    [aux_sym__non_special_token_token1] = ACTIONS(2246),
    [anon_sym_SQUOTE] = ACTIONS(2246),
    [anon_sym_as] = ACTIONS(2246),
    [anon_sym_async] = ACTIONS(2246),
    [anon_sym_await] = ACTIONS(2246),
    [anon_sym_break] = ACTIONS(2246),
    [anon_sym_const] = ACTIONS(2246),
    [anon_sym_continue] = ACTIONS(2246),
    [anon_sym_default] = ACTIONS(2246),
    [anon_sym_enum] = ACTIONS(2246),
    [anon_sym_fn] = ACTIONS(2246),
    [anon_sym_for] = ACTIONS(2246),
    [anon_sym_if] = ACTIONS(2246),
    [anon_sym_impl] = ACTIONS(2246),
    [anon_sym_let] = ACTIONS(2246),
    [anon_sym_loop] = ACTIONS(2246),
    [anon_sym_match] = ACTIONS(2246),
    [anon_sym_mod] = ACTIONS(2246),
    [anon_sym_pub] = ACTIONS(2246),
    [anon_sym_return] = ACTIONS(2246),
    [anon_sym_static] = ACTIONS(2246),
    [anon_sym_struct] = ACTIONS(2246),
    [anon_sym_trait] = ACTIONS(2246),
    [anon_sym_type] = ACTIONS(2246),
    [anon_sym_union] = ACTIONS(2246),
    [anon_sym_unsafe] = ACTIONS(2246),
    [anon_sym_use] = ACTIONS(2246),
    [anon_sym_where] = ACTIONS(2246),
    [anon_sym_while] = ACTIONS(2246),
    [sym_mutable_specifier] = ACTIONS(2246),
    [sym_integer_literal] = ACTIONS(2248),
    [aux_sym_string_literal_token1] = ACTIONS(1327),
    [sym_char_literal] = ACTIONS(2248),
    [anon_sym_true] = ACTIONS(1329),
    [anon_sym_false] = ACTIONS(1329),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2246),
    [sym_super] = ACTIONS(2246),
    [sym_crate] = ACTIONS(2246),
    [sym_metavariable] = ACTIONS(2248),
    [sym_raw_string_literal] = ACTIONS(2248),
    [sym_float_literal] = ACTIONS(2248),
    [sym_block_comment] = ACTIONS(3),
  },
  [483] = {
    [sym_attribute_item] = STATE(518),
    [sym_bracketed_type] = STATE(2256),
    [sym_generic_type] = STATE(2255),
    [sym_generic_type_with_turbofish] = STATE(2253),
    [sym_macro_invocation] = STATE(2166),
    [sym_scoped_identifier] = STATE(1446),
    [sym_scoped_type_identifier] = STATE(1796),
    [sym_match_arm] = STATE(487),
    [sym_last_match_arm] = STATE(2163),
    [sym_match_pattern] = STATE(2227),
    [sym__pattern] = STATE(1880),
    [sym_tuple_pattern] = STATE(1880),
    [sym_slice_pattern] = STATE(1880),
    [sym_tuple_struct_pattern] = STATE(1880),
    [sym_struct_pattern] = STATE(1880),
    [sym_remaining_field_pattern] = STATE(1880),
    [sym_mut_pattern] = STATE(1880),
    [sym_range_pattern] = STATE(1880),
    [sym_ref_pattern] = STATE(1880),
    [sym_captured_pattern] = STATE(1880),
    [sym_reference_pattern] = STATE(1880),
    [sym_or_pattern] = STATE(1880),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_enum_variant_list_repeat1] = STATE(518),
    [aux_sym_match_block_repeat1] = STATE(487),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_u8] = ACTIONS(2258),
    [anon_sym_i8] = ACTIONS(2258),
    [anon_sym_u16] = ACTIONS(2258),
    [anon_sym_i16] = ACTIONS(2258),
    [anon_sym_u32] = ACTIONS(2258),
    [anon_sym_i32] = ACTIONS(2258),
    [anon_sym_u64] = ACTIONS(2258),
    [anon_sym_i64] = ACTIONS(2258),
    [anon_sym_u128] = ACTIONS(2258),
    [anon_sym_i128] = ACTIONS(2258),
    [anon_sym_isize] = ACTIONS(2258),
    [anon_sym_usize] = ACTIONS(2258),
    [anon_sym_f32] = ACTIONS(2258),
    [anon_sym_f64] = ACTIONS(2258),
    [anon_sym_bool] = ACTIONS(2258),
    [anon_sym_str] = ACTIONS(2258),
    [anon_sym_char] = ACTIONS(2258),
    [anon_sym_POUND] = ACTIONS(405),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(2260),
    [anon_sym__] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2264),
    [sym_mutable_specifier] = ACTIONS(1017),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2266),
    [sym_super] = ACTIONS(2266),
    [sym_crate] = ACTIONS(2266),
    [sym_metavariable] = ACTIONS(2268),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [484] = {
    [sym_attribute_item] = STATE(518),
    [sym_bracketed_type] = STATE(2256),
    [sym_generic_type] = STATE(2255),
    [sym_generic_type_with_turbofish] = STATE(2253),
    [sym_macro_invocation] = STATE(2166),
    [sym_scoped_identifier] = STATE(1446),
    [sym_scoped_type_identifier] = STATE(1796),
    [sym_match_arm] = STATE(486),
    [sym_last_match_arm] = STATE(2165),
    [sym_match_pattern] = STATE(2227),
    [sym__pattern] = STATE(1880),
    [sym_tuple_pattern] = STATE(1880),
    [sym_slice_pattern] = STATE(1880),
    [sym_tuple_struct_pattern] = STATE(1880),
    [sym_struct_pattern] = STATE(1880),
    [sym_remaining_field_pattern] = STATE(1880),
    [sym_mut_pattern] = STATE(1880),
    [sym_range_pattern] = STATE(1880),
    [sym_ref_pattern] = STATE(1880),
    [sym_captured_pattern] = STATE(1880),
    [sym_reference_pattern] = STATE(1880),
    [sym_or_pattern] = STATE(1880),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_enum_variant_list_repeat1] = STATE(518),
    [aux_sym_match_block_repeat1] = STATE(486),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_u8] = ACTIONS(2258),
    [anon_sym_i8] = ACTIONS(2258),
    [anon_sym_u16] = ACTIONS(2258),
    [anon_sym_i16] = ACTIONS(2258),
    [anon_sym_u32] = ACTIONS(2258),
    [anon_sym_i32] = ACTIONS(2258),
    [anon_sym_u64] = ACTIONS(2258),
    [anon_sym_i64] = ACTIONS(2258),
    [anon_sym_u128] = ACTIONS(2258),
    [anon_sym_i128] = ACTIONS(2258),
    [anon_sym_isize] = ACTIONS(2258),
    [anon_sym_usize] = ACTIONS(2258),
    [anon_sym_f32] = ACTIONS(2258),
    [anon_sym_f64] = ACTIONS(2258),
    [anon_sym_bool] = ACTIONS(2258),
    [anon_sym_str] = ACTIONS(2258),
    [anon_sym_char] = ACTIONS(2258),
    [anon_sym_POUND] = ACTIONS(405),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(2260),
    [anon_sym__] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2264),
    [sym_mutable_specifier] = ACTIONS(1017),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2266),
    [sym_super] = ACTIONS(2266),
    [sym_crate] = ACTIONS(2266),
    [sym_metavariable] = ACTIONS(2268),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [485] = {
    [sym_attribute_item] = STATE(518),
    [sym_bracketed_type] = STATE(2256),
    [sym_generic_type] = STATE(2255),
    [sym_generic_type_with_turbofish] = STATE(2253),
    [sym_macro_invocation] = STATE(2166),
    [sym_scoped_identifier] = STATE(1446),
    [sym_scoped_type_identifier] = STATE(1796),
    [sym_match_arm] = STATE(489),
    [sym_last_match_arm] = STATE(2367),
    [sym_match_pattern] = STATE(2227),
    [sym__pattern] = STATE(1880),
    [sym_tuple_pattern] = STATE(1880),
    [sym_slice_pattern] = STATE(1880),
    [sym_tuple_struct_pattern] = STATE(1880),
    [sym_struct_pattern] = STATE(1880),
    [sym_remaining_field_pattern] = STATE(1880),
    [sym_mut_pattern] = STATE(1880),
    [sym_range_pattern] = STATE(1880),
    [sym_ref_pattern] = STATE(1880),
    [sym_captured_pattern] = STATE(1880),
    [sym_reference_pattern] = STATE(1880),
    [sym_or_pattern] = STATE(1880),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_enum_variant_list_repeat1] = STATE(518),
    [aux_sym_match_block_repeat1] = STATE(489),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_RBRACE] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_u8] = ACTIONS(2258),
    [anon_sym_i8] = ACTIONS(2258),
    [anon_sym_u16] = ACTIONS(2258),
    [anon_sym_i16] = ACTIONS(2258),
    [anon_sym_u32] = ACTIONS(2258),
    [anon_sym_i32] = ACTIONS(2258),
    [anon_sym_u64] = ACTIONS(2258),
    [anon_sym_i64] = ACTIONS(2258),
    [anon_sym_u128] = ACTIONS(2258),
    [anon_sym_i128] = ACTIONS(2258),
    [anon_sym_isize] = ACTIONS(2258),
    [anon_sym_usize] = ACTIONS(2258),
    [anon_sym_f32] = ACTIONS(2258),
    [anon_sym_f64] = ACTIONS(2258),
    [anon_sym_bool] = ACTIONS(2258),
    [anon_sym_str] = ACTIONS(2258),
    [anon_sym_char] = ACTIONS(2258),
    [anon_sym_POUND] = ACTIONS(405),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(2260),
    [anon_sym__] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2264),
    [sym_mutable_specifier] = ACTIONS(1017),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2266),
    [sym_super] = ACTIONS(2266),
    [sym_crate] = ACTIONS(2266),
    [sym_metavariable] = ACTIONS(2268),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [486] = {
    [sym_attribute_item] = STATE(518),
    [sym_bracketed_type] = STATE(2256),
    [sym_generic_type] = STATE(2255),
    [sym_generic_type_with_turbofish] = STATE(2253),
    [sym_macro_invocation] = STATE(2166),
    [sym_scoped_identifier] = STATE(1446),
    [sym_scoped_type_identifier] = STATE(1796),
    [sym_match_arm] = STATE(490),
    [sym_last_match_arm] = STATE(2349),
    [sym_match_pattern] = STATE(2227),
    [sym__pattern] = STATE(1880),
    [sym_tuple_pattern] = STATE(1880),
    [sym_slice_pattern] = STATE(1880),
    [sym_tuple_struct_pattern] = STATE(1880),
    [sym_struct_pattern] = STATE(1880),
    [sym_remaining_field_pattern] = STATE(1880),
    [sym_mut_pattern] = STATE(1880),
    [sym_range_pattern] = STATE(1880),
    [sym_ref_pattern] = STATE(1880),
    [sym_captured_pattern] = STATE(1880),
    [sym_reference_pattern] = STATE(1880),
    [sym_or_pattern] = STATE(1880),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_enum_variant_list_repeat1] = STATE(518),
    [aux_sym_match_block_repeat1] = STATE(490),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_u8] = ACTIONS(2258),
    [anon_sym_i8] = ACTIONS(2258),
    [anon_sym_u16] = ACTIONS(2258),
    [anon_sym_i16] = ACTIONS(2258),
    [anon_sym_u32] = ACTIONS(2258),
    [anon_sym_i32] = ACTIONS(2258),
    [anon_sym_u64] = ACTIONS(2258),
    [anon_sym_i64] = ACTIONS(2258),
    [anon_sym_u128] = ACTIONS(2258),
    [anon_sym_i128] = ACTIONS(2258),
    [anon_sym_isize] = ACTIONS(2258),
    [anon_sym_usize] = ACTIONS(2258),
    [anon_sym_f32] = ACTIONS(2258),
    [anon_sym_f64] = ACTIONS(2258),
    [anon_sym_bool] = ACTIONS(2258),
    [anon_sym_str] = ACTIONS(2258),
    [anon_sym_char] = ACTIONS(2258),
    [anon_sym_POUND] = ACTIONS(405),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(2260),
    [anon_sym__] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2264),
    [sym_mutable_specifier] = ACTIONS(1017),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2266),
    [sym_super] = ACTIONS(2266),
    [sym_crate] = ACTIONS(2266),
    [sym_metavariable] = ACTIONS(2268),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [487] = {
    [sym_attribute_item] = STATE(518),
    [sym_bracketed_type] = STATE(2256),
    [sym_generic_type] = STATE(2255),
    [sym_generic_type_with_turbofish] = STATE(2253),
    [sym_macro_invocation] = STATE(2166),
    [sym_scoped_identifier] = STATE(1446),
    [sym_scoped_type_identifier] = STATE(1796),
    [sym_match_arm] = STATE(490),
    [sym_last_match_arm] = STATE(2169),
    [sym_match_pattern] = STATE(2227),
    [sym__pattern] = STATE(1880),
    [sym_tuple_pattern] = STATE(1880),
    [sym_slice_pattern] = STATE(1880),
    [sym_tuple_struct_pattern] = STATE(1880),
    [sym_struct_pattern] = STATE(1880),
    [sym_remaining_field_pattern] = STATE(1880),
    [sym_mut_pattern] = STATE(1880),
    [sym_range_pattern] = STATE(1880),
    [sym_ref_pattern] = STATE(1880),
    [sym_captured_pattern] = STATE(1880),
    [sym_reference_pattern] = STATE(1880),
    [sym_or_pattern] = STATE(1880),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_enum_variant_list_repeat1] = STATE(518),
    [aux_sym_match_block_repeat1] = STATE(490),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_u8] = ACTIONS(2258),
    [anon_sym_i8] = ACTIONS(2258),
    [anon_sym_u16] = ACTIONS(2258),
    [anon_sym_i16] = ACTIONS(2258),
    [anon_sym_u32] = ACTIONS(2258),
    [anon_sym_i32] = ACTIONS(2258),
    [anon_sym_u64] = ACTIONS(2258),
    [anon_sym_i64] = ACTIONS(2258),
    [anon_sym_u128] = ACTIONS(2258),
    [anon_sym_i128] = ACTIONS(2258),
    [anon_sym_isize] = ACTIONS(2258),
    [anon_sym_usize] = ACTIONS(2258),
    [anon_sym_f32] = ACTIONS(2258),
    [anon_sym_f64] = ACTIONS(2258),
    [anon_sym_bool] = ACTIONS(2258),
    [anon_sym_str] = ACTIONS(2258),
    [anon_sym_char] = ACTIONS(2258),
    [anon_sym_POUND] = ACTIONS(405),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(2260),
    [anon_sym__] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2264),
    [sym_mutable_specifier] = ACTIONS(1017),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2266),
    [sym_super] = ACTIONS(2266),
    [sym_crate] = ACTIONS(2266),
    [sym_metavariable] = ACTIONS(2268),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [488] = {
    [sym_attribute_item] = STATE(498),
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym_visibility_modifier] = STATE(648),
    [sym__type] = STATE(1711),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(1711),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1711),
    [sym_tuple_type] = STATE(1711),
    [sym_unit_type] = STATE(1711),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1711),
    [sym_reference_type] = STATE(1711),
    [sym_pointer_type] = STATE(1711),
    [sym_empty_type] = STATE(1711),
    [sym_abstract_type] = STATE(1711),
    [sym_dynamic_type] = STATE(1711),
    [sym_macro_invocation] = STATE(1711),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [aux_sym_enum_variant_list_repeat1] = STATE(498),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(2276),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_pub] = ACTIONS(2280),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_COMMA] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(2286),
    [sym_metavariable] = ACTIONS(1103),
    [sym_block_comment] = ACTIONS(3),
  },
  [489] = {
    [sym_attribute_item] = STATE(518),
    [sym_bracketed_type] = STATE(2256),
    [sym_generic_type] = STATE(2255),
    [sym_generic_type_with_turbofish] = STATE(2253),
    [sym_macro_invocation] = STATE(2166),
    [sym_scoped_identifier] = STATE(1446),
    [sym_scoped_type_identifier] = STATE(1796),
    [sym_match_arm] = STATE(490),
    [sym_last_match_arm] = STATE(2350),
    [sym_match_pattern] = STATE(2227),
    [sym__pattern] = STATE(1880),
    [sym_tuple_pattern] = STATE(1880),
    [sym_slice_pattern] = STATE(1880),
    [sym_tuple_struct_pattern] = STATE(1880),
    [sym_struct_pattern] = STATE(1880),
    [sym_remaining_field_pattern] = STATE(1880),
    [sym_mut_pattern] = STATE(1880),
    [sym_range_pattern] = STATE(1880),
    [sym_ref_pattern] = STATE(1880),
    [sym_captured_pattern] = STATE(1880),
    [sym_reference_pattern] = STATE(1880),
    [sym_or_pattern] = STATE(1880),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_enum_variant_list_repeat1] = STATE(518),
    [aux_sym_match_block_repeat1] = STATE(490),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_u8] = ACTIONS(2258),
    [anon_sym_i8] = ACTIONS(2258),
    [anon_sym_u16] = ACTIONS(2258),
    [anon_sym_i16] = ACTIONS(2258),
    [anon_sym_u32] = ACTIONS(2258),
    [anon_sym_i32] = ACTIONS(2258),
    [anon_sym_u64] = ACTIONS(2258),
    [anon_sym_i64] = ACTIONS(2258),
    [anon_sym_u128] = ACTIONS(2258),
    [anon_sym_i128] = ACTIONS(2258),
    [anon_sym_isize] = ACTIONS(2258),
    [anon_sym_usize] = ACTIONS(2258),
    [anon_sym_f32] = ACTIONS(2258),
    [anon_sym_f64] = ACTIONS(2258),
    [anon_sym_bool] = ACTIONS(2258),
    [anon_sym_str] = ACTIONS(2258),
    [anon_sym_char] = ACTIONS(2258),
    [anon_sym_POUND] = ACTIONS(405),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(2260),
    [anon_sym__] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2264),
    [sym_mutable_specifier] = ACTIONS(1017),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2266),
    [sym_super] = ACTIONS(2266),
    [sym_crate] = ACTIONS(2266),
    [sym_metavariable] = ACTIONS(2268),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [490] = {
    [sym_attribute_item] = STATE(520),
    [sym_bracketed_type] = STATE(2256),
    [sym_generic_type] = STATE(2255),
    [sym_generic_type_with_turbofish] = STATE(2253),
    [sym_macro_invocation] = STATE(2166),
    [sym_scoped_identifier] = STATE(1446),
    [sym_scoped_type_identifier] = STATE(1796),
    [sym_match_arm] = STATE(490),
    [sym_match_pattern] = STATE(2166),
    [sym__pattern] = STATE(1880),
    [sym_tuple_pattern] = STATE(1880),
    [sym_slice_pattern] = STATE(1880),
    [sym_tuple_struct_pattern] = STATE(1880),
    [sym_struct_pattern] = STATE(1880),
    [sym_remaining_field_pattern] = STATE(1880),
    [sym_mut_pattern] = STATE(1880),
    [sym_range_pattern] = STATE(1880),
    [sym_ref_pattern] = STATE(1880),
    [sym_captured_pattern] = STATE(1880),
    [sym_reference_pattern] = STATE(1880),
    [sym_or_pattern] = STATE(1880),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_enum_variant_list_repeat1] = STATE(520),
    [aux_sym_match_block_repeat1] = STATE(490),
    [sym_identifier] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2291),
    [anon_sym_LBRACK] = ACTIONS(2294),
    [anon_sym_u8] = ACTIONS(2297),
    [anon_sym_i8] = ACTIONS(2297),
    [anon_sym_u16] = ACTIONS(2297),
    [anon_sym_i16] = ACTIONS(2297),
    [anon_sym_u32] = ACTIONS(2297),
    [anon_sym_i32] = ACTIONS(2297),
    [anon_sym_u64] = ACTIONS(2297),
    [anon_sym_i64] = ACTIONS(2297),
    [anon_sym_u128] = ACTIONS(2297),
    [anon_sym_i128] = ACTIONS(2297),
    [anon_sym_isize] = ACTIONS(2297),
    [anon_sym_usize] = ACTIONS(2297),
    [anon_sym_f32] = ACTIONS(2297),
    [anon_sym_f64] = ACTIONS(2297),
    [anon_sym_bool] = ACTIONS(2297),
    [anon_sym_str] = ACTIONS(2297),
    [anon_sym_char] = ACTIONS(2297),
    [anon_sym_POUND] = ACTIONS(2300),
    [anon_sym_ref] = ACTIONS(2303),
    [anon_sym_LT] = ACTIONS(2306),
    [anon_sym_COLON_COLON] = ACTIONS(2309),
    [anon_sym__] = ACTIONS(2312),
    [anon_sym_AMP] = ACTIONS(2315),
    [sym_mutable_specifier] = ACTIONS(2318),
    [anon_sym_DOT_DOT] = ACTIONS(2321),
    [anon_sym_DASH] = ACTIONS(2324),
    [sym_integer_literal] = ACTIONS(2327),
    [aux_sym_string_literal_token1] = ACTIONS(2330),
    [sym_char_literal] = ACTIONS(2327),
    [anon_sym_true] = ACTIONS(2333),
    [anon_sym_false] = ACTIONS(2333),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2336),
    [sym_super] = ACTIONS(2336),
    [sym_crate] = ACTIONS(2336),
    [sym_metavariable] = ACTIONS(2339),
    [sym_raw_string_literal] = ACTIONS(2327),
    [sym_float_literal] = ACTIONS(2327),
    [sym_block_comment] = ACTIONS(3),
  },
  [491] = {
    [sym_attribute_item] = STATE(512),
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym_visibility_modifier] = STATE(581),
    [sym__type] = STATE(1791),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(1791),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1791),
    [sym_tuple_type] = STATE(1791),
    [sym_unit_type] = STATE(1791),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1791),
    [sym_reference_type] = STATE(1791),
    [sym_pointer_type] = STATE(1791),
    [sym_empty_type] = STATE(1791),
    [sym_abstract_type] = STATE(1791),
    [sym_dynamic_type] = STATE(1791),
    [sym_macro_invocation] = STATE(1791),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [aux_sym_enum_variant_list_repeat1] = STATE(512),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(2342),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_pub] = ACTIONS(2280),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(2286),
    [sym_metavariable] = ACTIONS(1103),
    [sym_block_comment] = ACTIONS(3),
  },
  [492] = {
    [sym_attribute_item] = STATE(512),
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym_visibility_modifier] = STATE(581),
    [sym__type] = STATE(1791),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(1791),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1791),
    [sym_tuple_type] = STATE(1791),
    [sym_unit_type] = STATE(1791),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1791),
    [sym_reference_type] = STATE(1791),
    [sym_pointer_type] = STATE(1791),
    [sym_empty_type] = STATE(1791),
    [sym_abstract_type] = STATE(1791),
    [sym_dynamic_type] = STATE(1791),
    [sym_macro_invocation] = STATE(1791),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [aux_sym_enum_variant_list_repeat1] = STATE(512),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_pub] = ACTIONS(2280),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(2286),
    [sym_metavariable] = ACTIONS(1103),
    [sym_block_comment] = ACTIONS(3),
  },
  [493] = {
    [sym_identifier] = ACTIONS(2346),
    [anon_sym_LPAREN] = ACTIONS(2348),
    [anon_sym_RPAREN] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(2348),
    [anon_sym_RBRACE] = ACTIONS(2348),
    [anon_sym_LBRACK] = ACTIONS(2348),
    [anon_sym_RBRACK] = ACTIONS(2348),
    [anon_sym_COLON] = ACTIONS(2350),
    [anon_sym_DOLLAR] = ACTIONS(2346),
    [anon_sym_u8] = ACTIONS(2346),
    [anon_sym_i8] = ACTIONS(2346),
    [anon_sym_u16] = ACTIONS(2346),
    [anon_sym_i16] = ACTIONS(2346),
    [anon_sym_u32] = ACTIONS(2346),
    [anon_sym_i32] = ACTIONS(2346),
    [anon_sym_u64] = ACTIONS(2346),
    [anon_sym_i64] = ACTIONS(2346),
    [anon_sym_u128] = ACTIONS(2346),
    [anon_sym_i128] = ACTIONS(2346),
    [anon_sym_isize] = ACTIONS(2346),
    [anon_sym_usize] = ACTIONS(2346),
    [anon_sym_f32] = ACTIONS(2346),
    [anon_sym_f64] = ACTIONS(2346),
    [anon_sym_bool] = ACTIONS(2346),
    [anon_sym_str] = ACTIONS(2346),
    [anon_sym_char] = ACTIONS(2346),
    [aux_sym__non_special_token_token1] = ACTIONS(2346),
    [anon_sym_SQUOTE] = ACTIONS(2346),
    [anon_sym_as] = ACTIONS(2346),
    [anon_sym_async] = ACTIONS(2346),
    [anon_sym_await] = ACTIONS(2346),
    [anon_sym_break] = ACTIONS(2346),
    [anon_sym_const] = ACTIONS(2346),
    [anon_sym_continue] = ACTIONS(2346),
    [anon_sym_default] = ACTIONS(2346),
    [anon_sym_enum] = ACTIONS(2346),
    [anon_sym_fn] = ACTIONS(2346),
    [anon_sym_for] = ACTIONS(2346),
    [anon_sym_if] = ACTIONS(2346),
    [anon_sym_impl] = ACTIONS(2346),
    [anon_sym_let] = ACTIONS(2346),
    [anon_sym_loop] = ACTIONS(2346),
    [anon_sym_match] = ACTIONS(2346),
    [anon_sym_mod] = ACTIONS(2346),
    [anon_sym_pub] = ACTIONS(2346),
    [anon_sym_return] = ACTIONS(2346),
    [anon_sym_static] = ACTIONS(2346),
    [anon_sym_struct] = ACTIONS(2346),
    [anon_sym_trait] = ACTIONS(2346),
    [anon_sym_type] = ACTIONS(2346),
    [anon_sym_union] = ACTIONS(2346),
    [anon_sym_unsafe] = ACTIONS(2346),
    [anon_sym_use] = ACTIONS(2346),
    [anon_sym_where] = ACTIONS(2346),
    [anon_sym_while] = ACTIONS(2346),
    [sym_mutable_specifier] = ACTIONS(2346),
    [sym_integer_literal] = ACTIONS(2348),
    [aux_sym_string_literal_token1] = ACTIONS(2348),
    [sym_char_literal] = ACTIONS(2348),
    [anon_sym_true] = ACTIONS(2346),
    [anon_sym_false] = ACTIONS(2346),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2346),
    [sym_super] = ACTIONS(2346),
    [sym_crate] = ACTIONS(2346),
    [sym_metavariable] = ACTIONS(2348),
    [sym_raw_string_literal] = ACTIONS(2348),
    [sym_float_literal] = ACTIONS(2348),
    [sym_block_comment] = ACTIONS(3),
  },
  [494] = {
    [sym_attribute_item] = STATE(512),
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym_visibility_modifier] = STATE(581),
    [sym__type] = STATE(1791),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(1791),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1791),
    [sym_tuple_type] = STATE(1791),
    [sym_unit_type] = STATE(1791),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1791),
    [sym_reference_type] = STATE(1791),
    [sym_pointer_type] = STATE(1791),
    [sym_empty_type] = STATE(1791),
    [sym_abstract_type] = STATE(1791),
    [sym_dynamic_type] = STATE(1791),
    [sym_macro_invocation] = STATE(1791),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [aux_sym_enum_variant_list_repeat1] = STATE(512),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(2352),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_pub] = ACTIONS(2280),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(2286),
    [sym_metavariable] = ACTIONS(1103),
    [sym_block_comment] = ACTIONS(3),
  },
  [495] = {
    [sym_attribute_item] = STATE(512),
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym_visibility_modifier] = STATE(581),
    [sym__type] = STATE(1791),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(1791),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1791),
    [sym_tuple_type] = STATE(1791),
    [sym_unit_type] = STATE(1791),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1791),
    [sym_reference_type] = STATE(1791),
    [sym_pointer_type] = STATE(1791),
    [sym_empty_type] = STATE(1791),
    [sym_abstract_type] = STATE(1791),
    [sym_dynamic_type] = STATE(1791),
    [sym_macro_invocation] = STATE(1791),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [aux_sym_enum_variant_list_repeat1] = STATE(512),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(2354),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_pub] = ACTIONS(2280),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(2286),
    [sym_metavariable] = ACTIONS(1103),
    [sym_block_comment] = ACTIONS(3),
  },
  [496] = {
    [sym_attribute_item] = STATE(512),
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym_visibility_modifier] = STATE(581),
    [sym__type] = STATE(1791),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(1791),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1791),
    [sym_tuple_type] = STATE(1791),
    [sym_unit_type] = STATE(1791),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1791),
    [sym_reference_type] = STATE(1791),
    [sym_pointer_type] = STATE(1791),
    [sym_empty_type] = STATE(1791),
    [sym_abstract_type] = STATE(1791),
    [sym_dynamic_type] = STATE(1791),
    [sym_macro_invocation] = STATE(1791),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [aux_sym_enum_variant_list_repeat1] = STATE(512),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_pub] = ACTIONS(2280),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(2286),
    [sym_metavariable] = ACTIONS(1103),
    [sym_block_comment] = ACTIONS(3),
  },
  [497] = {
    [sym_attribute_item] = STATE(512),
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym_visibility_modifier] = STATE(581),
    [sym__type] = STATE(1791),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(1791),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1791),
    [sym_tuple_type] = STATE(1791),
    [sym_unit_type] = STATE(1791),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1791),
    [sym_reference_type] = STATE(1791),
    [sym_pointer_type] = STATE(1791),
    [sym_empty_type] = STATE(1791),
    [sym_abstract_type] = STATE(1791),
    [sym_dynamic_type] = STATE(1791),
    [sym_macro_invocation] = STATE(1791),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [aux_sym_enum_variant_list_repeat1] = STATE(512),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_RPAREN] = ACTIONS(2358),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_pub] = ACTIONS(2280),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(2286),
    [sym_metavariable] = ACTIONS(1103),
    [sym_block_comment] = ACTIONS(3),
  },
  [498] = {
    [sym_attribute_item] = STATE(1055),
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym_visibility_modifier] = STATE(653),
    [sym__type] = STATE(1638),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(1638),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1638),
    [sym_tuple_type] = STATE(1638),
    [sym_unit_type] = STATE(1638),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1638),
    [sym_reference_type] = STATE(1638),
    [sym_pointer_type] = STATE(1638),
    [sym_empty_type] = STATE(1638),
    [sym_abstract_type] = STATE(1638),
    [sym_dynamic_type] = STATE(1638),
    [sym_macro_invocation] = STATE(1638),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [aux_sym_enum_variant_list_repeat1] = STATE(1055),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_pub] = ACTIONS(2280),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(2286),
    [sym_metavariable] = ACTIONS(1103),
    [sym_block_comment] = ACTIONS(3),
  },
  [499] = {
    [sym_identifier] = ACTIONS(2360),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [anon_sym_RPAREN] = ACTIONS(2362),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_RBRACK] = ACTIONS(2362),
    [anon_sym_DOLLAR] = ACTIONS(2360),
    [anon_sym_u8] = ACTIONS(2360),
    [anon_sym_i8] = ACTIONS(2360),
    [anon_sym_u16] = ACTIONS(2360),
    [anon_sym_i16] = ACTIONS(2360),
    [anon_sym_u32] = ACTIONS(2360),
    [anon_sym_i32] = ACTIONS(2360),
    [anon_sym_u64] = ACTIONS(2360),
    [anon_sym_i64] = ACTIONS(2360),
    [anon_sym_u128] = ACTIONS(2360),
    [anon_sym_i128] = ACTIONS(2360),
    [anon_sym_isize] = ACTIONS(2360),
    [anon_sym_usize] = ACTIONS(2360),
    [anon_sym_f32] = ACTIONS(2360),
    [anon_sym_f64] = ACTIONS(2360),
    [anon_sym_bool] = ACTIONS(2360),
    [anon_sym_str] = ACTIONS(2360),
    [anon_sym_char] = ACTIONS(2360),
    [aux_sym__non_special_token_token1] = ACTIONS(2360),
    [anon_sym_SQUOTE] = ACTIONS(2360),
    [anon_sym_as] = ACTIONS(2360),
    [anon_sym_async] = ACTIONS(2360),
    [anon_sym_await] = ACTIONS(2360),
    [anon_sym_break] = ACTIONS(2360),
    [anon_sym_const] = ACTIONS(2360),
    [anon_sym_continue] = ACTIONS(2360),
    [anon_sym_default] = ACTIONS(2360),
    [anon_sym_enum] = ACTIONS(2360),
    [anon_sym_fn] = ACTIONS(2360),
    [anon_sym_for] = ACTIONS(2360),
    [anon_sym_if] = ACTIONS(2360),
    [anon_sym_impl] = ACTIONS(2360),
    [anon_sym_let] = ACTIONS(2360),
    [anon_sym_loop] = ACTIONS(2360),
    [anon_sym_match] = ACTIONS(2360),
    [anon_sym_mod] = ACTIONS(2360),
    [anon_sym_pub] = ACTIONS(2360),
    [anon_sym_return] = ACTIONS(2360),
    [anon_sym_static] = ACTIONS(2360),
    [anon_sym_struct] = ACTIONS(2360),
    [anon_sym_trait] = ACTIONS(2360),
    [anon_sym_type] = ACTIONS(2360),
    [anon_sym_union] = ACTIONS(2360),
    [anon_sym_unsafe] = ACTIONS(2360),
    [anon_sym_use] = ACTIONS(2360),
    [anon_sym_where] = ACTIONS(2360),
    [anon_sym_while] = ACTIONS(2360),
    [sym_mutable_specifier] = ACTIONS(2360),
    [sym_integer_literal] = ACTIONS(2362),
    [aux_sym_string_literal_token1] = ACTIONS(2362),
    [sym_char_literal] = ACTIONS(2362),
    [anon_sym_true] = ACTIONS(2360),
    [anon_sym_false] = ACTIONS(2360),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2360),
    [sym_super] = ACTIONS(2360),
    [sym_crate] = ACTIONS(2360),
    [sym_metavariable] = ACTIONS(2362),
    [sym_raw_string_literal] = ACTIONS(2362),
    [sym_float_literal] = ACTIONS(2362),
    [sym_block_comment] = ACTIONS(3),
  },
  [500] = {
    [sym_attribute_item] = STATE(512),
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym_visibility_modifier] = STATE(581),
    [sym__type] = STATE(1791),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(1791),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1791),
    [sym_tuple_type] = STATE(1791),
    [sym_unit_type] = STATE(1791),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1791),
    [sym_reference_type] = STATE(1791),
    [sym_pointer_type] = STATE(1791),
    [sym_empty_type] = STATE(1791),
    [sym_abstract_type] = STATE(1791),
    [sym_dynamic_type] = STATE(1791),
    [sym_macro_invocation] = STATE(1791),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [aux_sym_enum_variant_list_repeat1] = STATE(512),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_pub] = ACTIONS(2280),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(2286),
    [sym_metavariable] = ACTIONS(1103),
    [sym_block_comment] = ACTIONS(3),
  },
  [501] = {
    [sym_identifier] = ACTIONS(2364),
    [anon_sym_LPAREN] = ACTIONS(2366),
    [anon_sym_RPAREN] = ACTIONS(2366),
    [anon_sym_LBRACE] = ACTIONS(2366),
    [anon_sym_RBRACE] = ACTIONS(2366),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_RBRACK] = ACTIONS(2366),
    [anon_sym_DOLLAR] = ACTIONS(2364),
    [anon_sym_u8] = ACTIONS(2364),
    [anon_sym_i8] = ACTIONS(2364),
    [anon_sym_u16] = ACTIONS(2364),
    [anon_sym_i16] = ACTIONS(2364),
    [anon_sym_u32] = ACTIONS(2364),
    [anon_sym_i32] = ACTIONS(2364),
    [anon_sym_u64] = ACTIONS(2364),
    [anon_sym_i64] = ACTIONS(2364),
    [anon_sym_u128] = ACTIONS(2364),
    [anon_sym_i128] = ACTIONS(2364),
    [anon_sym_isize] = ACTIONS(2364),
    [anon_sym_usize] = ACTIONS(2364),
    [anon_sym_f32] = ACTIONS(2364),
    [anon_sym_f64] = ACTIONS(2364),
    [anon_sym_bool] = ACTIONS(2364),
    [anon_sym_str] = ACTIONS(2364),
    [anon_sym_char] = ACTIONS(2364),
    [aux_sym__non_special_token_token1] = ACTIONS(2364),
    [anon_sym_SQUOTE] = ACTIONS(2364),
    [anon_sym_as] = ACTIONS(2364),
    [anon_sym_async] = ACTIONS(2364),
    [anon_sym_await] = ACTIONS(2364),
    [anon_sym_break] = ACTIONS(2364),
    [anon_sym_const] = ACTIONS(2364),
    [anon_sym_continue] = ACTIONS(2364),
    [anon_sym_default] = ACTIONS(2364),
    [anon_sym_enum] = ACTIONS(2364),
    [anon_sym_fn] = ACTIONS(2364),
    [anon_sym_for] = ACTIONS(2364),
    [anon_sym_if] = ACTIONS(2364),
    [anon_sym_impl] = ACTIONS(2364),
    [anon_sym_let] = ACTIONS(2364),
    [anon_sym_loop] = ACTIONS(2364),
    [anon_sym_match] = ACTIONS(2364),
    [anon_sym_mod] = ACTIONS(2364),
    [anon_sym_pub] = ACTIONS(2364),
    [anon_sym_return] = ACTIONS(2364),
    [anon_sym_static] = ACTIONS(2364),
    [anon_sym_struct] = ACTIONS(2364),
    [anon_sym_trait] = ACTIONS(2364),
    [anon_sym_type] = ACTIONS(2364),
    [anon_sym_union] = ACTIONS(2364),
    [anon_sym_unsafe] = ACTIONS(2364),
    [anon_sym_use] = ACTIONS(2364),
    [anon_sym_where] = ACTIONS(2364),
    [anon_sym_while] = ACTIONS(2364),
    [sym_mutable_specifier] = ACTIONS(2364),
    [sym_integer_literal] = ACTIONS(2366),
    [aux_sym_string_literal_token1] = ACTIONS(2366),
    [sym_char_literal] = ACTIONS(2366),
    [anon_sym_true] = ACTIONS(2364),
    [anon_sym_false] = ACTIONS(2364),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2364),
    [sym_super] = ACTIONS(2364),
    [sym_crate] = ACTIONS(2364),
    [sym_metavariable] = ACTIONS(2366),
    [sym_raw_string_literal] = ACTIONS(2366),
    [sym_float_literal] = ACTIONS(2366),
    [sym_block_comment] = ACTIONS(3),
  },
  [502] = {
    [sym_identifier] = ACTIONS(461),
    [anon_sym_LPAREN] = ACTIONS(459),
    [anon_sym_RPAREN] = ACTIONS(459),
    [anon_sym_LBRACE] = ACTIONS(459),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_LBRACK] = ACTIONS(459),
    [anon_sym_RBRACK] = ACTIONS(459),
    [anon_sym_DOLLAR] = ACTIONS(461),
    [anon_sym_u8] = ACTIONS(461),
    [anon_sym_i8] = ACTIONS(461),
    [anon_sym_u16] = ACTIONS(461),
    [anon_sym_i16] = ACTIONS(461),
    [anon_sym_u32] = ACTIONS(461),
    [anon_sym_i32] = ACTIONS(461),
    [anon_sym_u64] = ACTIONS(461),
    [anon_sym_i64] = ACTIONS(461),
    [anon_sym_u128] = ACTIONS(461),
    [anon_sym_i128] = ACTIONS(461),
    [anon_sym_isize] = ACTIONS(461),
    [anon_sym_usize] = ACTIONS(461),
    [anon_sym_f32] = ACTIONS(461),
    [anon_sym_f64] = ACTIONS(461),
    [anon_sym_bool] = ACTIONS(461),
    [anon_sym_str] = ACTIONS(461),
    [anon_sym_char] = ACTIONS(461),
    [aux_sym__non_special_token_token1] = ACTIONS(461),
    [anon_sym_SQUOTE] = ACTIONS(461),
    [anon_sym_as] = ACTIONS(461),
    [anon_sym_async] = ACTIONS(461),
    [anon_sym_await] = ACTIONS(461),
    [anon_sym_break] = ACTIONS(461),
    [anon_sym_const] = ACTIONS(461),
    [anon_sym_continue] = ACTIONS(461),
    [anon_sym_default] = ACTIONS(461),
    [anon_sym_enum] = ACTIONS(461),
    [anon_sym_fn] = ACTIONS(461),
    [anon_sym_for] = ACTIONS(461),
    [anon_sym_if] = ACTIONS(461),
    [anon_sym_impl] = ACTIONS(461),
    [anon_sym_let] = ACTIONS(461),
    [anon_sym_loop] = ACTIONS(461),
    [anon_sym_match] = ACTIONS(461),
    [anon_sym_mod] = ACTIONS(461),
    [anon_sym_pub] = ACTIONS(461),
    [anon_sym_return] = ACTIONS(461),
    [anon_sym_static] = ACTIONS(461),
    [anon_sym_struct] = ACTIONS(461),
    [anon_sym_trait] = ACTIONS(461),
    [anon_sym_type] = ACTIONS(461),
    [anon_sym_union] = ACTIONS(461),
    [anon_sym_unsafe] = ACTIONS(461),
    [anon_sym_use] = ACTIONS(461),
    [anon_sym_where] = ACTIONS(461),
    [anon_sym_while] = ACTIONS(461),
    [sym_mutable_specifier] = ACTIONS(461),
    [sym_integer_literal] = ACTIONS(459),
    [aux_sym_string_literal_token1] = ACTIONS(459),
    [sym_char_literal] = ACTIONS(459),
    [anon_sym_true] = ACTIONS(461),
    [anon_sym_false] = ACTIONS(461),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(461),
    [sym_super] = ACTIONS(461),
    [sym_crate] = ACTIONS(461),
    [sym_metavariable] = ACTIONS(459),
    [sym_raw_string_literal] = ACTIONS(459),
    [sym_float_literal] = ACTIONS(459),
    [sym_block_comment] = ACTIONS(3),
  },
  [503] = {
    [sym_identifier] = ACTIONS(2368),
    [anon_sym_LPAREN] = ACTIONS(2370),
    [anon_sym_RPAREN] = ACTIONS(2370),
    [anon_sym_LBRACE] = ACTIONS(2370),
    [anon_sym_RBRACE] = ACTIONS(2370),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_RBRACK] = ACTIONS(2370),
    [anon_sym_DOLLAR] = ACTIONS(2368),
    [anon_sym_u8] = ACTIONS(2368),
    [anon_sym_i8] = ACTIONS(2368),
    [anon_sym_u16] = ACTIONS(2368),
    [anon_sym_i16] = ACTIONS(2368),
    [anon_sym_u32] = ACTIONS(2368),
    [anon_sym_i32] = ACTIONS(2368),
    [anon_sym_u64] = ACTIONS(2368),
    [anon_sym_i64] = ACTIONS(2368),
    [anon_sym_u128] = ACTIONS(2368),
    [anon_sym_i128] = ACTIONS(2368),
    [anon_sym_isize] = ACTIONS(2368),
    [anon_sym_usize] = ACTIONS(2368),
    [anon_sym_f32] = ACTIONS(2368),
    [anon_sym_f64] = ACTIONS(2368),
    [anon_sym_bool] = ACTIONS(2368),
    [anon_sym_str] = ACTIONS(2368),
    [anon_sym_char] = ACTIONS(2368),
    [aux_sym__non_special_token_token1] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2368),
    [anon_sym_as] = ACTIONS(2368),
    [anon_sym_async] = ACTIONS(2368),
    [anon_sym_await] = ACTIONS(2368),
    [anon_sym_break] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2368),
    [anon_sym_continue] = ACTIONS(2368),
    [anon_sym_default] = ACTIONS(2368),
    [anon_sym_enum] = ACTIONS(2368),
    [anon_sym_fn] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_impl] = ACTIONS(2368),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_loop] = ACTIONS(2368),
    [anon_sym_match] = ACTIONS(2368),
    [anon_sym_mod] = ACTIONS(2368),
    [anon_sym_pub] = ACTIONS(2368),
    [anon_sym_return] = ACTIONS(2368),
    [anon_sym_static] = ACTIONS(2368),
    [anon_sym_struct] = ACTIONS(2368),
    [anon_sym_trait] = ACTIONS(2368),
    [anon_sym_type] = ACTIONS(2368),
    [anon_sym_union] = ACTIONS(2368),
    [anon_sym_unsafe] = ACTIONS(2368),
    [anon_sym_use] = ACTIONS(2368),
    [anon_sym_where] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [sym_mutable_specifier] = ACTIONS(2368),
    [sym_integer_literal] = ACTIONS(2370),
    [aux_sym_string_literal_token1] = ACTIONS(2370),
    [sym_char_literal] = ACTIONS(2370),
    [anon_sym_true] = ACTIONS(2368),
    [anon_sym_false] = ACTIONS(2368),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2368),
    [sym_super] = ACTIONS(2368),
    [sym_crate] = ACTIONS(2368),
    [sym_metavariable] = ACTIONS(2370),
    [sym_raw_string_literal] = ACTIONS(2370),
    [sym_float_literal] = ACTIONS(2370),
    [sym_block_comment] = ACTIONS(3),
  },
  [504] = {
    [sym_identifier] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(2374),
    [anon_sym_RPAREN] = ACTIONS(2374),
    [anon_sym_LBRACE] = ACTIONS(2374),
    [anon_sym_RBRACE] = ACTIONS(2374),
    [anon_sym_LBRACK] = ACTIONS(2374),
    [anon_sym_RBRACK] = ACTIONS(2374),
    [anon_sym_DOLLAR] = ACTIONS(2372),
    [anon_sym_u8] = ACTIONS(2372),
    [anon_sym_i8] = ACTIONS(2372),
    [anon_sym_u16] = ACTIONS(2372),
    [anon_sym_i16] = ACTIONS(2372),
    [anon_sym_u32] = ACTIONS(2372),
    [anon_sym_i32] = ACTIONS(2372),
    [anon_sym_u64] = ACTIONS(2372),
    [anon_sym_i64] = ACTIONS(2372),
    [anon_sym_u128] = ACTIONS(2372),
    [anon_sym_i128] = ACTIONS(2372),
    [anon_sym_isize] = ACTIONS(2372),
    [anon_sym_usize] = ACTIONS(2372),
    [anon_sym_f32] = ACTIONS(2372),
    [anon_sym_f64] = ACTIONS(2372),
    [anon_sym_bool] = ACTIONS(2372),
    [anon_sym_str] = ACTIONS(2372),
    [anon_sym_char] = ACTIONS(2372),
    [aux_sym__non_special_token_token1] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2372),
    [anon_sym_as] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2372),
    [anon_sym_await] = ACTIONS(2372),
    [anon_sym_break] = ACTIONS(2372),
    [anon_sym_const] = ACTIONS(2372),
    [anon_sym_continue] = ACTIONS(2372),
    [anon_sym_default] = ACTIONS(2372),
    [anon_sym_enum] = ACTIONS(2372),
    [anon_sym_fn] = ACTIONS(2372),
    [anon_sym_for] = ACTIONS(2372),
    [anon_sym_if] = ACTIONS(2372),
    [anon_sym_impl] = ACTIONS(2372),
    [anon_sym_let] = ACTIONS(2372),
    [anon_sym_loop] = ACTIONS(2372),
    [anon_sym_match] = ACTIONS(2372),
    [anon_sym_mod] = ACTIONS(2372),
    [anon_sym_pub] = ACTIONS(2372),
    [anon_sym_return] = ACTIONS(2372),
    [anon_sym_static] = ACTIONS(2372),
    [anon_sym_struct] = ACTIONS(2372),
    [anon_sym_trait] = ACTIONS(2372),
    [anon_sym_type] = ACTIONS(2372),
    [anon_sym_union] = ACTIONS(2372),
    [anon_sym_unsafe] = ACTIONS(2372),
    [anon_sym_use] = ACTIONS(2372),
    [anon_sym_where] = ACTIONS(2372),
    [anon_sym_while] = ACTIONS(2372),
    [sym_mutable_specifier] = ACTIONS(2372),
    [sym_integer_literal] = ACTIONS(2374),
    [aux_sym_string_literal_token1] = ACTIONS(2374),
    [sym_char_literal] = ACTIONS(2374),
    [anon_sym_true] = ACTIONS(2372),
    [anon_sym_false] = ACTIONS(2372),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2372),
    [sym_super] = ACTIONS(2372),
    [sym_crate] = ACTIONS(2372),
    [sym_metavariable] = ACTIONS(2374),
    [sym_raw_string_literal] = ACTIONS(2374),
    [sym_float_literal] = ACTIONS(2374),
    [sym_block_comment] = ACTIONS(3),
  },
  [505] = {
    [sym_identifier] = ACTIONS(2376),
    [anon_sym_LPAREN] = ACTIONS(2378),
    [anon_sym_RPAREN] = ACTIONS(2378),
    [anon_sym_LBRACE] = ACTIONS(2378),
    [anon_sym_RBRACE] = ACTIONS(2378),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_RBRACK] = ACTIONS(2378),
    [anon_sym_DOLLAR] = ACTIONS(2376),
    [anon_sym_u8] = ACTIONS(2376),
    [anon_sym_i8] = ACTIONS(2376),
    [anon_sym_u16] = ACTIONS(2376),
    [anon_sym_i16] = ACTIONS(2376),
    [anon_sym_u32] = ACTIONS(2376),
    [anon_sym_i32] = ACTIONS(2376),
    [anon_sym_u64] = ACTIONS(2376),
    [anon_sym_i64] = ACTIONS(2376),
    [anon_sym_u128] = ACTIONS(2376),
    [anon_sym_i128] = ACTIONS(2376),
    [anon_sym_isize] = ACTIONS(2376),
    [anon_sym_usize] = ACTIONS(2376),
    [anon_sym_f32] = ACTIONS(2376),
    [anon_sym_f64] = ACTIONS(2376),
    [anon_sym_bool] = ACTIONS(2376),
    [anon_sym_str] = ACTIONS(2376),
    [anon_sym_char] = ACTIONS(2376),
    [aux_sym__non_special_token_token1] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2376),
    [anon_sym_as] = ACTIONS(2376),
    [anon_sym_async] = ACTIONS(2376),
    [anon_sym_await] = ACTIONS(2376),
    [anon_sym_break] = ACTIONS(2376),
    [anon_sym_const] = ACTIONS(2376),
    [anon_sym_continue] = ACTIONS(2376),
    [anon_sym_default] = ACTIONS(2376),
    [anon_sym_enum] = ACTIONS(2376),
    [anon_sym_fn] = ACTIONS(2376),
    [anon_sym_for] = ACTIONS(2376),
    [anon_sym_if] = ACTIONS(2376),
    [anon_sym_impl] = ACTIONS(2376),
    [anon_sym_let] = ACTIONS(2376),
    [anon_sym_loop] = ACTIONS(2376),
    [anon_sym_match] = ACTIONS(2376),
    [anon_sym_mod] = ACTIONS(2376),
    [anon_sym_pub] = ACTIONS(2376),
    [anon_sym_return] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2376),
    [anon_sym_struct] = ACTIONS(2376),
    [anon_sym_trait] = ACTIONS(2376),
    [anon_sym_type] = ACTIONS(2376),
    [anon_sym_union] = ACTIONS(2376),
    [anon_sym_unsafe] = ACTIONS(2376),
    [anon_sym_use] = ACTIONS(2376),
    [anon_sym_where] = ACTIONS(2376),
    [anon_sym_while] = ACTIONS(2376),
    [sym_mutable_specifier] = ACTIONS(2376),
    [sym_integer_literal] = ACTIONS(2378),
    [aux_sym_string_literal_token1] = ACTIONS(2378),
    [sym_char_literal] = ACTIONS(2378),
    [anon_sym_true] = ACTIONS(2376),
    [anon_sym_false] = ACTIONS(2376),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2376),
    [sym_super] = ACTIONS(2376),
    [sym_crate] = ACTIONS(2376),
    [sym_metavariable] = ACTIONS(2378),
    [sym_raw_string_literal] = ACTIONS(2378),
    [sym_float_literal] = ACTIONS(2378),
    [sym_block_comment] = ACTIONS(3),
  },
  [506] = {
    [sym_identifier] = ACTIONS(2380),
    [anon_sym_LPAREN] = ACTIONS(2382),
    [anon_sym_RPAREN] = ACTIONS(2382),
    [anon_sym_LBRACE] = ACTIONS(2382),
    [anon_sym_RBRACE] = ACTIONS(2382),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_RBRACK] = ACTIONS(2382),
    [anon_sym_DOLLAR] = ACTIONS(2380),
    [anon_sym_u8] = ACTIONS(2380),
    [anon_sym_i8] = ACTIONS(2380),
    [anon_sym_u16] = ACTIONS(2380),
    [anon_sym_i16] = ACTIONS(2380),
    [anon_sym_u32] = ACTIONS(2380),
    [anon_sym_i32] = ACTIONS(2380),
    [anon_sym_u64] = ACTIONS(2380),
    [anon_sym_i64] = ACTIONS(2380),
    [anon_sym_u128] = ACTIONS(2380),
    [anon_sym_i128] = ACTIONS(2380),
    [anon_sym_isize] = ACTIONS(2380),
    [anon_sym_usize] = ACTIONS(2380),
    [anon_sym_f32] = ACTIONS(2380),
    [anon_sym_f64] = ACTIONS(2380),
    [anon_sym_bool] = ACTIONS(2380),
    [anon_sym_str] = ACTIONS(2380),
    [anon_sym_char] = ACTIONS(2380),
    [aux_sym__non_special_token_token1] = ACTIONS(2380),
    [anon_sym_SQUOTE] = ACTIONS(2380),
    [anon_sym_as] = ACTIONS(2380),
    [anon_sym_async] = ACTIONS(2380),
    [anon_sym_await] = ACTIONS(2380),
    [anon_sym_break] = ACTIONS(2380),
    [anon_sym_const] = ACTIONS(2380),
    [anon_sym_continue] = ACTIONS(2380),
    [anon_sym_default] = ACTIONS(2380),
    [anon_sym_enum] = ACTIONS(2380),
    [anon_sym_fn] = ACTIONS(2380),
    [anon_sym_for] = ACTIONS(2380),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_impl] = ACTIONS(2380),
    [anon_sym_let] = ACTIONS(2380),
    [anon_sym_loop] = ACTIONS(2380),
    [anon_sym_match] = ACTIONS(2380),
    [anon_sym_mod] = ACTIONS(2380),
    [anon_sym_pub] = ACTIONS(2380),
    [anon_sym_return] = ACTIONS(2380),
    [anon_sym_static] = ACTIONS(2380),
    [anon_sym_struct] = ACTIONS(2380),
    [anon_sym_trait] = ACTIONS(2380),
    [anon_sym_type] = ACTIONS(2380),
    [anon_sym_union] = ACTIONS(2380),
    [anon_sym_unsafe] = ACTIONS(2380),
    [anon_sym_use] = ACTIONS(2380),
    [anon_sym_where] = ACTIONS(2380),
    [anon_sym_while] = ACTIONS(2380),
    [sym_mutable_specifier] = ACTIONS(2380),
    [sym_integer_literal] = ACTIONS(2382),
    [aux_sym_string_literal_token1] = ACTIONS(2382),
    [sym_char_literal] = ACTIONS(2382),
    [anon_sym_true] = ACTIONS(2380),
    [anon_sym_false] = ACTIONS(2380),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2380),
    [sym_super] = ACTIONS(2380),
    [sym_crate] = ACTIONS(2380),
    [sym_metavariable] = ACTIONS(2382),
    [sym_raw_string_literal] = ACTIONS(2382),
    [sym_float_literal] = ACTIONS(2382),
    [sym_block_comment] = ACTIONS(3),
  },
  [507] = {
    [sym_identifier] = ACTIONS(2384),
    [anon_sym_LPAREN] = ACTIONS(2386),
    [anon_sym_RPAREN] = ACTIONS(2386),
    [anon_sym_LBRACE] = ACTIONS(2386),
    [anon_sym_RBRACE] = ACTIONS(2386),
    [anon_sym_LBRACK] = ACTIONS(2386),
    [anon_sym_RBRACK] = ACTIONS(2386),
    [anon_sym_DOLLAR] = ACTIONS(2384),
    [anon_sym_u8] = ACTIONS(2384),
    [anon_sym_i8] = ACTIONS(2384),
    [anon_sym_u16] = ACTIONS(2384),
    [anon_sym_i16] = ACTIONS(2384),
    [anon_sym_u32] = ACTIONS(2384),
    [anon_sym_i32] = ACTIONS(2384),
    [anon_sym_u64] = ACTIONS(2384),
    [anon_sym_i64] = ACTIONS(2384),
    [anon_sym_u128] = ACTIONS(2384),
    [anon_sym_i128] = ACTIONS(2384),
    [anon_sym_isize] = ACTIONS(2384),
    [anon_sym_usize] = ACTIONS(2384),
    [anon_sym_f32] = ACTIONS(2384),
    [anon_sym_f64] = ACTIONS(2384),
    [anon_sym_bool] = ACTIONS(2384),
    [anon_sym_str] = ACTIONS(2384),
    [anon_sym_char] = ACTIONS(2384),
    [aux_sym__non_special_token_token1] = ACTIONS(2384),
    [anon_sym_SQUOTE] = ACTIONS(2384),
    [anon_sym_as] = ACTIONS(2384),
    [anon_sym_async] = ACTIONS(2384),
    [anon_sym_await] = ACTIONS(2384),
    [anon_sym_break] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_continue] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
    [anon_sym_fn] = ACTIONS(2384),
    [anon_sym_for] = ACTIONS(2384),
    [anon_sym_if] = ACTIONS(2384),
    [anon_sym_impl] = ACTIONS(2384),
    [anon_sym_let] = ACTIONS(2384),
    [anon_sym_loop] = ACTIONS(2384),
    [anon_sym_match] = ACTIONS(2384),
    [anon_sym_mod] = ACTIONS(2384),
    [anon_sym_pub] = ACTIONS(2384),
    [anon_sym_return] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_struct] = ACTIONS(2384),
    [anon_sym_trait] = ACTIONS(2384),
    [anon_sym_type] = ACTIONS(2384),
    [anon_sym_union] = ACTIONS(2384),
    [anon_sym_unsafe] = ACTIONS(2384),
    [anon_sym_use] = ACTIONS(2384),
    [anon_sym_where] = ACTIONS(2384),
    [anon_sym_while] = ACTIONS(2384),
    [sym_mutable_specifier] = ACTIONS(2384),
    [sym_integer_literal] = ACTIONS(2386),
    [aux_sym_string_literal_token1] = ACTIONS(2386),
    [sym_char_literal] = ACTIONS(2386),
    [anon_sym_true] = ACTIONS(2384),
    [anon_sym_false] = ACTIONS(2384),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2384),
    [sym_super] = ACTIONS(2384),
    [sym_crate] = ACTIONS(2384),
    [sym_metavariable] = ACTIONS(2386),
    [sym_raw_string_literal] = ACTIONS(2386),
    [sym_float_literal] = ACTIONS(2386),
    [sym_block_comment] = ACTIONS(3),
  },
  [508] = {
    [sym_identifier] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(443),
    [anon_sym_RPAREN] = ACTIONS(443),
    [anon_sym_LBRACE] = ACTIONS(443),
    [anon_sym_RBRACE] = ACTIONS(443),
    [anon_sym_LBRACK] = ACTIONS(443),
    [anon_sym_RBRACK] = ACTIONS(443),
    [anon_sym_DOLLAR] = ACTIONS(445),
    [anon_sym_u8] = ACTIONS(445),
    [anon_sym_i8] = ACTIONS(445),
    [anon_sym_u16] = ACTIONS(445),
    [anon_sym_i16] = ACTIONS(445),
    [anon_sym_u32] = ACTIONS(445),
    [anon_sym_i32] = ACTIONS(445),
    [anon_sym_u64] = ACTIONS(445),
    [anon_sym_i64] = ACTIONS(445),
    [anon_sym_u128] = ACTIONS(445),
    [anon_sym_i128] = ACTIONS(445),
    [anon_sym_isize] = ACTIONS(445),
    [anon_sym_usize] = ACTIONS(445),
    [anon_sym_f32] = ACTIONS(445),
    [anon_sym_f64] = ACTIONS(445),
    [anon_sym_bool] = ACTIONS(445),
    [anon_sym_str] = ACTIONS(445),
    [anon_sym_char] = ACTIONS(445),
    [aux_sym__non_special_token_token1] = ACTIONS(445),
    [anon_sym_SQUOTE] = ACTIONS(445),
    [anon_sym_as] = ACTIONS(445),
    [anon_sym_async] = ACTIONS(445),
    [anon_sym_await] = ACTIONS(445),
    [anon_sym_break] = ACTIONS(445),
    [anon_sym_const] = ACTIONS(445),
    [anon_sym_continue] = ACTIONS(445),
    [anon_sym_default] = ACTIONS(445),
    [anon_sym_enum] = ACTIONS(445),
    [anon_sym_fn] = ACTIONS(445),
    [anon_sym_for] = ACTIONS(445),
    [anon_sym_if] = ACTIONS(445),
    [anon_sym_impl] = ACTIONS(445),
    [anon_sym_let] = ACTIONS(445),
    [anon_sym_loop] = ACTIONS(445),
    [anon_sym_match] = ACTIONS(445),
    [anon_sym_mod] = ACTIONS(445),
    [anon_sym_pub] = ACTIONS(445),
    [anon_sym_return] = ACTIONS(445),
    [anon_sym_static] = ACTIONS(445),
    [anon_sym_struct] = ACTIONS(445),
    [anon_sym_trait] = ACTIONS(445),
    [anon_sym_type] = ACTIONS(445),
    [anon_sym_union] = ACTIONS(445),
    [anon_sym_unsafe] = ACTIONS(445),
    [anon_sym_use] = ACTIONS(445),
    [anon_sym_where] = ACTIONS(445),
    [anon_sym_while] = ACTIONS(445),
    [sym_mutable_specifier] = ACTIONS(445),
    [sym_integer_literal] = ACTIONS(443),
    [aux_sym_string_literal_token1] = ACTIONS(443),
    [sym_char_literal] = ACTIONS(443),
    [anon_sym_true] = ACTIONS(445),
    [anon_sym_false] = ACTIONS(445),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(445),
    [sym_super] = ACTIONS(445),
    [sym_crate] = ACTIONS(445),
    [sym_metavariable] = ACTIONS(443),
    [sym_raw_string_literal] = ACTIONS(443),
    [sym_float_literal] = ACTIONS(443),
    [sym_block_comment] = ACTIONS(3),
  },
  [509] = {
    [sym_identifier] = ACTIONS(2388),
    [anon_sym_LPAREN] = ACTIONS(2390),
    [anon_sym_RPAREN] = ACTIONS(2390),
    [anon_sym_LBRACE] = ACTIONS(2390),
    [anon_sym_RBRACE] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2390),
    [anon_sym_RBRACK] = ACTIONS(2390),
    [anon_sym_DOLLAR] = ACTIONS(2388),
    [anon_sym_u8] = ACTIONS(2388),
    [anon_sym_i8] = ACTIONS(2388),
    [anon_sym_u16] = ACTIONS(2388),
    [anon_sym_i16] = ACTIONS(2388),
    [anon_sym_u32] = ACTIONS(2388),
    [anon_sym_i32] = ACTIONS(2388),
    [anon_sym_u64] = ACTIONS(2388),
    [anon_sym_i64] = ACTIONS(2388),
    [anon_sym_u128] = ACTIONS(2388),
    [anon_sym_i128] = ACTIONS(2388),
    [anon_sym_isize] = ACTIONS(2388),
    [anon_sym_usize] = ACTIONS(2388),
    [anon_sym_f32] = ACTIONS(2388),
    [anon_sym_f64] = ACTIONS(2388),
    [anon_sym_bool] = ACTIONS(2388),
    [anon_sym_str] = ACTIONS(2388),
    [anon_sym_char] = ACTIONS(2388),
    [aux_sym__non_special_token_token1] = ACTIONS(2388),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_as] = ACTIONS(2388),
    [anon_sym_async] = ACTIONS(2388),
    [anon_sym_await] = ACTIONS(2388),
    [anon_sym_break] = ACTIONS(2388),
    [anon_sym_const] = ACTIONS(2388),
    [anon_sym_continue] = ACTIONS(2388),
    [anon_sym_default] = ACTIONS(2388),
    [anon_sym_enum] = ACTIONS(2388),
    [anon_sym_fn] = ACTIONS(2388),
    [anon_sym_for] = ACTIONS(2388),
    [anon_sym_if] = ACTIONS(2388),
    [anon_sym_impl] = ACTIONS(2388),
    [anon_sym_let] = ACTIONS(2388),
    [anon_sym_loop] = ACTIONS(2388),
    [anon_sym_match] = ACTIONS(2388),
    [anon_sym_mod] = ACTIONS(2388),
    [anon_sym_pub] = ACTIONS(2388),
    [anon_sym_return] = ACTIONS(2388),
    [anon_sym_static] = ACTIONS(2388),
    [anon_sym_struct] = ACTIONS(2388),
    [anon_sym_trait] = ACTIONS(2388),
    [anon_sym_type] = ACTIONS(2388),
    [anon_sym_union] = ACTIONS(2388),
    [anon_sym_unsafe] = ACTIONS(2388),
    [anon_sym_use] = ACTIONS(2388),
    [anon_sym_where] = ACTIONS(2388),
    [anon_sym_while] = ACTIONS(2388),
    [sym_mutable_specifier] = ACTIONS(2388),
    [sym_integer_literal] = ACTIONS(2390),
    [aux_sym_string_literal_token1] = ACTIONS(2390),
    [sym_char_literal] = ACTIONS(2390),
    [anon_sym_true] = ACTIONS(2388),
    [anon_sym_false] = ACTIONS(2388),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2388),
    [sym_super] = ACTIONS(2388),
    [sym_crate] = ACTIONS(2388),
    [sym_metavariable] = ACTIONS(2390),
    [sym_raw_string_literal] = ACTIONS(2390),
    [sym_float_literal] = ACTIONS(2390),
    [sym_block_comment] = ACTIONS(3),
  },
  [510] = {
    [sym_identifier] = ACTIONS(2392),
    [anon_sym_LPAREN] = ACTIONS(2394),
    [anon_sym_RPAREN] = ACTIONS(2394),
    [anon_sym_LBRACE] = ACTIONS(2394),
    [anon_sym_RBRACE] = ACTIONS(2394),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_RBRACK] = ACTIONS(2394),
    [anon_sym_DOLLAR] = ACTIONS(2392),
    [anon_sym_u8] = ACTIONS(2392),
    [anon_sym_i8] = ACTIONS(2392),
    [anon_sym_u16] = ACTIONS(2392),
    [anon_sym_i16] = ACTIONS(2392),
    [anon_sym_u32] = ACTIONS(2392),
    [anon_sym_i32] = ACTIONS(2392),
    [anon_sym_u64] = ACTIONS(2392),
    [anon_sym_i64] = ACTIONS(2392),
    [anon_sym_u128] = ACTIONS(2392),
    [anon_sym_i128] = ACTIONS(2392),
    [anon_sym_isize] = ACTIONS(2392),
    [anon_sym_usize] = ACTIONS(2392),
    [anon_sym_f32] = ACTIONS(2392),
    [anon_sym_f64] = ACTIONS(2392),
    [anon_sym_bool] = ACTIONS(2392),
    [anon_sym_str] = ACTIONS(2392),
    [anon_sym_char] = ACTIONS(2392),
    [aux_sym__non_special_token_token1] = ACTIONS(2392),
    [anon_sym_SQUOTE] = ACTIONS(2392),
    [anon_sym_as] = ACTIONS(2392),
    [anon_sym_async] = ACTIONS(2392),
    [anon_sym_await] = ACTIONS(2392),
    [anon_sym_break] = ACTIONS(2392),
    [anon_sym_const] = ACTIONS(2392),
    [anon_sym_continue] = ACTIONS(2392),
    [anon_sym_default] = ACTIONS(2392),
    [anon_sym_enum] = ACTIONS(2392),
    [anon_sym_fn] = ACTIONS(2392),
    [anon_sym_for] = ACTIONS(2392),
    [anon_sym_if] = ACTIONS(2392),
    [anon_sym_impl] = ACTIONS(2392),
    [anon_sym_let] = ACTIONS(2392),
    [anon_sym_loop] = ACTIONS(2392),
    [anon_sym_match] = ACTIONS(2392),
    [anon_sym_mod] = ACTIONS(2392),
    [anon_sym_pub] = ACTIONS(2392),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_static] = ACTIONS(2392),
    [anon_sym_struct] = ACTIONS(2392),
    [anon_sym_trait] = ACTIONS(2392),
    [anon_sym_type] = ACTIONS(2392),
    [anon_sym_union] = ACTIONS(2392),
    [anon_sym_unsafe] = ACTIONS(2392),
    [anon_sym_use] = ACTIONS(2392),
    [anon_sym_where] = ACTIONS(2392),
    [anon_sym_while] = ACTIONS(2392),
    [sym_mutable_specifier] = ACTIONS(2392),
    [sym_integer_literal] = ACTIONS(2394),
    [aux_sym_string_literal_token1] = ACTIONS(2394),
    [sym_char_literal] = ACTIONS(2394),
    [anon_sym_true] = ACTIONS(2392),
    [anon_sym_false] = ACTIONS(2392),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2392),
    [sym_super] = ACTIONS(2392),
    [sym_crate] = ACTIONS(2392),
    [sym_metavariable] = ACTIONS(2394),
    [sym_raw_string_literal] = ACTIONS(2394),
    [sym_float_literal] = ACTIONS(2394),
    [sym_block_comment] = ACTIONS(3),
  },
  [511] = {
    [sym_identifier] = ACTIONS(2396),
    [anon_sym_LPAREN] = ACTIONS(2398),
    [anon_sym_RPAREN] = ACTIONS(2398),
    [anon_sym_LBRACE] = ACTIONS(2398),
    [anon_sym_RBRACE] = ACTIONS(2398),
    [anon_sym_LBRACK] = ACTIONS(2398),
    [anon_sym_RBRACK] = ACTIONS(2398),
    [anon_sym_DOLLAR] = ACTIONS(2396),
    [anon_sym_u8] = ACTIONS(2396),
    [anon_sym_i8] = ACTIONS(2396),
    [anon_sym_u16] = ACTIONS(2396),
    [anon_sym_i16] = ACTIONS(2396),
    [anon_sym_u32] = ACTIONS(2396),
    [anon_sym_i32] = ACTIONS(2396),
    [anon_sym_u64] = ACTIONS(2396),
    [anon_sym_i64] = ACTIONS(2396),
    [anon_sym_u128] = ACTIONS(2396),
    [anon_sym_i128] = ACTIONS(2396),
    [anon_sym_isize] = ACTIONS(2396),
    [anon_sym_usize] = ACTIONS(2396),
    [anon_sym_f32] = ACTIONS(2396),
    [anon_sym_f64] = ACTIONS(2396),
    [anon_sym_bool] = ACTIONS(2396),
    [anon_sym_str] = ACTIONS(2396),
    [anon_sym_char] = ACTIONS(2396),
    [aux_sym__non_special_token_token1] = ACTIONS(2396),
    [anon_sym_SQUOTE] = ACTIONS(2396),
    [anon_sym_as] = ACTIONS(2396),
    [anon_sym_async] = ACTIONS(2396),
    [anon_sym_await] = ACTIONS(2396),
    [anon_sym_break] = ACTIONS(2396),
    [anon_sym_const] = ACTIONS(2396),
    [anon_sym_continue] = ACTIONS(2396),
    [anon_sym_default] = ACTIONS(2396),
    [anon_sym_enum] = ACTIONS(2396),
    [anon_sym_fn] = ACTIONS(2396),
    [anon_sym_for] = ACTIONS(2396),
    [anon_sym_if] = ACTIONS(2396),
    [anon_sym_impl] = ACTIONS(2396),
    [anon_sym_let] = ACTIONS(2396),
    [anon_sym_loop] = ACTIONS(2396),
    [anon_sym_match] = ACTIONS(2396),
    [anon_sym_mod] = ACTIONS(2396),
    [anon_sym_pub] = ACTIONS(2396),
    [anon_sym_return] = ACTIONS(2396),
    [anon_sym_static] = ACTIONS(2396),
    [anon_sym_struct] = ACTIONS(2396),
    [anon_sym_trait] = ACTIONS(2396),
    [anon_sym_type] = ACTIONS(2396),
    [anon_sym_union] = ACTIONS(2396),
    [anon_sym_unsafe] = ACTIONS(2396),
    [anon_sym_use] = ACTIONS(2396),
    [anon_sym_where] = ACTIONS(2396),
    [anon_sym_while] = ACTIONS(2396),
    [sym_mutable_specifier] = ACTIONS(2396),
    [sym_integer_literal] = ACTIONS(2398),
    [aux_sym_string_literal_token1] = ACTIONS(2398),
    [sym_char_literal] = ACTIONS(2398),
    [anon_sym_true] = ACTIONS(2396),
    [anon_sym_false] = ACTIONS(2396),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2396),
    [sym_super] = ACTIONS(2396),
    [sym_crate] = ACTIONS(2396),
    [sym_metavariable] = ACTIONS(2398),
    [sym_raw_string_literal] = ACTIONS(2398),
    [sym_float_literal] = ACTIONS(2398),
    [sym_block_comment] = ACTIONS(3),
  },
  [512] = {
    [sym_attribute_item] = STATE(1055),
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym_visibility_modifier] = STATE(655),
    [sym__type] = STATE(1961),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(1961),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1961),
    [sym_tuple_type] = STATE(1961),
    [sym_unit_type] = STATE(1961),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1961),
    [sym_reference_type] = STATE(1961),
    [sym_pointer_type] = STATE(1961),
    [sym_empty_type] = STATE(1961),
    [sym_abstract_type] = STATE(1961),
    [sym_dynamic_type] = STATE(1961),
    [sym_macro_invocation] = STATE(1961),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [aux_sym_enum_variant_list_repeat1] = STATE(1055),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_pub] = ACTIONS(2280),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_POUND] = ACTIONS(2282),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(2286),
    [sym_metavariable] = ACTIONS(1103),
    [sym_block_comment] = ACTIONS(3),
  },
  [513] = {
    [sym_identifier] = ACTIONS(2400),
    [anon_sym_LPAREN] = ACTIONS(2402),
    [anon_sym_RPAREN] = ACTIONS(2402),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_RBRACE] = ACTIONS(2402),
    [anon_sym_LBRACK] = ACTIONS(2402),
    [anon_sym_RBRACK] = ACTIONS(2402),
    [anon_sym_DOLLAR] = ACTIONS(2400),
    [anon_sym_u8] = ACTIONS(2400),
    [anon_sym_i8] = ACTIONS(2400),
    [anon_sym_u16] = ACTIONS(2400),
    [anon_sym_i16] = ACTIONS(2400),
    [anon_sym_u32] = ACTIONS(2400),
    [anon_sym_i32] = ACTIONS(2400),
    [anon_sym_u64] = ACTIONS(2400),
    [anon_sym_i64] = ACTIONS(2400),
    [anon_sym_u128] = ACTIONS(2400),
    [anon_sym_i128] = ACTIONS(2400),
    [anon_sym_isize] = ACTIONS(2400),
    [anon_sym_usize] = ACTIONS(2400),
    [anon_sym_f32] = ACTIONS(2400),
    [anon_sym_f64] = ACTIONS(2400),
    [anon_sym_bool] = ACTIONS(2400),
    [anon_sym_str] = ACTIONS(2400),
    [anon_sym_char] = ACTIONS(2400),
    [aux_sym__non_special_token_token1] = ACTIONS(2400),
    [anon_sym_SQUOTE] = ACTIONS(2400),
    [anon_sym_as] = ACTIONS(2400),
    [anon_sym_async] = ACTIONS(2400),
    [anon_sym_await] = ACTIONS(2400),
    [anon_sym_break] = ACTIONS(2400),
    [anon_sym_const] = ACTIONS(2400),
    [anon_sym_continue] = ACTIONS(2400),
    [anon_sym_default] = ACTIONS(2400),
    [anon_sym_enum] = ACTIONS(2400),
    [anon_sym_fn] = ACTIONS(2400),
    [anon_sym_for] = ACTIONS(2400),
    [anon_sym_if] = ACTIONS(2400),
    [anon_sym_impl] = ACTIONS(2400),
    [anon_sym_let] = ACTIONS(2400),
    [anon_sym_loop] = ACTIONS(2400),
    [anon_sym_match] = ACTIONS(2400),
    [anon_sym_mod] = ACTIONS(2400),
    [anon_sym_pub] = ACTIONS(2400),
    [anon_sym_return] = ACTIONS(2400),
    [anon_sym_static] = ACTIONS(2400),
    [anon_sym_struct] = ACTIONS(2400),
    [anon_sym_trait] = ACTIONS(2400),
    [anon_sym_type] = ACTIONS(2400),
    [anon_sym_union] = ACTIONS(2400),
    [anon_sym_unsafe] = ACTIONS(2400),
    [anon_sym_use] = ACTIONS(2400),
    [anon_sym_where] = ACTIONS(2400),
    [anon_sym_while] = ACTIONS(2400),
    [sym_mutable_specifier] = ACTIONS(2400),
    [sym_integer_literal] = ACTIONS(2402),
    [aux_sym_string_literal_token1] = ACTIONS(2402),
    [sym_char_literal] = ACTIONS(2402),
    [anon_sym_true] = ACTIONS(2400),
    [anon_sym_false] = ACTIONS(2400),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2400),
    [sym_super] = ACTIONS(2400),
    [sym_crate] = ACTIONS(2400),
    [sym_metavariable] = ACTIONS(2402),
    [sym_raw_string_literal] = ACTIONS(2402),
    [sym_float_literal] = ACTIONS(2402),
    [sym_block_comment] = ACTIONS(3),
  },
  [514] = {
    [sym_identifier] = ACTIONS(2404),
    [anon_sym_LPAREN] = ACTIONS(2406),
    [anon_sym_RPAREN] = ACTIONS(2406),
    [anon_sym_LBRACE] = ACTIONS(2406),
    [anon_sym_RBRACE] = ACTIONS(2406),
    [anon_sym_LBRACK] = ACTIONS(2406),
    [anon_sym_RBRACK] = ACTIONS(2406),
    [anon_sym_DOLLAR] = ACTIONS(2404),
    [anon_sym_u8] = ACTIONS(2404),
    [anon_sym_i8] = ACTIONS(2404),
    [anon_sym_u16] = ACTIONS(2404),
    [anon_sym_i16] = ACTIONS(2404),
    [anon_sym_u32] = ACTIONS(2404),
    [anon_sym_i32] = ACTIONS(2404),
    [anon_sym_u64] = ACTIONS(2404),
    [anon_sym_i64] = ACTIONS(2404),
    [anon_sym_u128] = ACTIONS(2404),
    [anon_sym_i128] = ACTIONS(2404),
    [anon_sym_isize] = ACTIONS(2404),
    [anon_sym_usize] = ACTIONS(2404),
    [anon_sym_f32] = ACTIONS(2404),
    [anon_sym_f64] = ACTIONS(2404),
    [anon_sym_bool] = ACTIONS(2404),
    [anon_sym_str] = ACTIONS(2404),
    [anon_sym_char] = ACTIONS(2404),
    [aux_sym__non_special_token_token1] = ACTIONS(2404),
    [anon_sym_SQUOTE] = ACTIONS(2404),
    [anon_sym_as] = ACTIONS(2404),
    [anon_sym_async] = ACTIONS(2404),
    [anon_sym_await] = ACTIONS(2404),
    [anon_sym_break] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [anon_sym_continue] = ACTIONS(2404),
    [anon_sym_default] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [anon_sym_fn] = ACTIONS(2404),
    [anon_sym_for] = ACTIONS(2404),
    [anon_sym_if] = ACTIONS(2404),
    [anon_sym_impl] = ACTIONS(2404),
    [anon_sym_let] = ACTIONS(2404),
    [anon_sym_loop] = ACTIONS(2404),
    [anon_sym_match] = ACTIONS(2404),
    [anon_sym_mod] = ACTIONS(2404),
    [anon_sym_pub] = ACTIONS(2404),
    [anon_sym_return] = ACTIONS(2404),
    [anon_sym_static] = ACTIONS(2404),
    [anon_sym_struct] = ACTIONS(2404),
    [anon_sym_trait] = ACTIONS(2404),
    [anon_sym_type] = ACTIONS(2404),
    [anon_sym_union] = ACTIONS(2404),
    [anon_sym_unsafe] = ACTIONS(2404),
    [anon_sym_use] = ACTIONS(2404),
    [anon_sym_where] = ACTIONS(2404),
    [anon_sym_while] = ACTIONS(2404),
    [sym_mutable_specifier] = ACTIONS(2404),
    [sym_integer_literal] = ACTIONS(2406),
    [aux_sym_string_literal_token1] = ACTIONS(2406),
    [sym_char_literal] = ACTIONS(2406),
    [anon_sym_true] = ACTIONS(2404),
    [anon_sym_false] = ACTIONS(2404),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2404),
    [sym_super] = ACTIONS(2404),
    [sym_crate] = ACTIONS(2404),
    [sym_metavariable] = ACTIONS(2406),
    [sym_raw_string_literal] = ACTIONS(2406),
    [sym_float_literal] = ACTIONS(2406),
    [sym_block_comment] = ACTIONS(3),
  },
  [515] = {
    [sym_identifier] = ACTIONS(2408),
    [anon_sym_LPAREN] = ACTIONS(2410),
    [anon_sym_RPAREN] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2410),
    [anon_sym_RBRACE] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [anon_sym_RBRACK] = ACTIONS(2410),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [anon_sym_u8] = ACTIONS(2408),
    [anon_sym_i8] = ACTIONS(2408),
    [anon_sym_u16] = ACTIONS(2408),
    [anon_sym_i16] = ACTIONS(2408),
    [anon_sym_u32] = ACTIONS(2408),
    [anon_sym_i32] = ACTIONS(2408),
    [anon_sym_u64] = ACTIONS(2408),
    [anon_sym_i64] = ACTIONS(2408),
    [anon_sym_u128] = ACTIONS(2408),
    [anon_sym_i128] = ACTIONS(2408),
    [anon_sym_isize] = ACTIONS(2408),
    [anon_sym_usize] = ACTIONS(2408),
    [anon_sym_f32] = ACTIONS(2408),
    [anon_sym_f64] = ACTIONS(2408),
    [anon_sym_bool] = ACTIONS(2408),
    [anon_sym_str] = ACTIONS(2408),
    [anon_sym_char] = ACTIONS(2408),
    [aux_sym__non_special_token_token1] = ACTIONS(2408),
    [anon_sym_SQUOTE] = ACTIONS(2408),
    [anon_sym_as] = ACTIONS(2408),
    [anon_sym_async] = ACTIONS(2408),
    [anon_sym_await] = ACTIONS(2408),
    [anon_sym_break] = ACTIONS(2408),
    [anon_sym_const] = ACTIONS(2408),
    [anon_sym_continue] = ACTIONS(2408),
    [anon_sym_default] = ACTIONS(2408),
    [anon_sym_enum] = ACTIONS(2408),
    [anon_sym_fn] = ACTIONS(2408),
    [anon_sym_for] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2408),
    [anon_sym_impl] = ACTIONS(2408),
    [anon_sym_let] = ACTIONS(2408),
    [anon_sym_loop] = ACTIONS(2408),
    [anon_sym_match] = ACTIONS(2408),
    [anon_sym_mod] = ACTIONS(2408),
    [anon_sym_pub] = ACTIONS(2408),
    [anon_sym_return] = ACTIONS(2408),
    [anon_sym_static] = ACTIONS(2408),
    [anon_sym_struct] = ACTIONS(2408),
    [anon_sym_trait] = ACTIONS(2408),
    [anon_sym_type] = ACTIONS(2408),
    [anon_sym_union] = ACTIONS(2408),
    [anon_sym_unsafe] = ACTIONS(2408),
    [anon_sym_use] = ACTIONS(2408),
    [anon_sym_where] = ACTIONS(2408),
    [anon_sym_while] = ACTIONS(2408),
    [sym_mutable_specifier] = ACTIONS(2408),
    [sym_integer_literal] = ACTIONS(2410),
    [aux_sym_string_literal_token1] = ACTIONS(2410),
    [sym_char_literal] = ACTIONS(2410),
    [anon_sym_true] = ACTIONS(2408),
    [anon_sym_false] = ACTIONS(2408),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2408),
    [sym_super] = ACTIONS(2408),
    [sym_crate] = ACTIONS(2408),
    [sym_metavariable] = ACTIONS(2410),
    [sym_raw_string_literal] = ACTIONS(2410),
    [sym_float_literal] = ACTIONS(2410),
    [sym_block_comment] = ACTIONS(3),
  },
  [516] = {
    [sym_identifier] = ACTIONS(2412),
    [anon_sym_LPAREN] = ACTIONS(2414),
    [anon_sym_RPAREN] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2414),
    [anon_sym_RBRACE] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2414),
    [anon_sym_RBRACK] = ACTIONS(2414),
    [anon_sym_DOLLAR] = ACTIONS(2412),
    [anon_sym_u8] = ACTIONS(2412),
    [anon_sym_i8] = ACTIONS(2412),
    [anon_sym_u16] = ACTIONS(2412),
    [anon_sym_i16] = ACTIONS(2412),
    [anon_sym_u32] = ACTIONS(2412),
    [anon_sym_i32] = ACTIONS(2412),
    [anon_sym_u64] = ACTIONS(2412),
    [anon_sym_i64] = ACTIONS(2412),
    [anon_sym_u128] = ACTIONS(2412),
    [anon_sym_i128] = ACTIONS(2412),
    [anon_sym_isize] = ACTIONS(2412),
    [anon_sym_usize] = ACTIONS(2412),
    [anon_sym_f32] = ACTIONS(2412),
    [anon_sym_f64] = ACTIONS(2412),
    [anon_sym_bool] = ACTIONS(2412),
    [anon_sym_str] = ACTIONS(2412),
    [anon_sym_char] = ACTIONS(2412),
    [aux_sym__non_special_token_token1] = ACTIONS(2412),
    [anon_sym_SQUOTE] = ACTIONS(2412),
    [anon_sym_as] = ACTIONS(2412),
    [anon_sym_async] = ACTIONS(2412),
    [anon_sym_await] = ACTIONS(2412),
    [anon_sym_break] = ACTIONS(2412),
    [anon_sym_const] = ACTIONS(2412),
    [anon_sym_continue] = ACTIONS(2412),
    [anon_sym_default] = ACTIONS(2412),
    [anon_sym_enum] = ACTIONS(2412),
    [anon_sym_fn] = ACTIONS(2412),
    [anon_sym_for] = ACTIONS(2412),
    [anon_sym_if] = ACTIONS(2412),
    [anon_sym_impl] = ACTIONS(2412),
    [anon_sym_let] = ACTIONS(2412),
    [anon_sym_loop] = ACTIONS(2412),
    [anon_sym_match] = ACTIONS(2412),
    [anon_sym_mod] = ACTIONS(2412),
    [anon_sym_pub] = ACTIONS(2412),
    [anon_sym_return] = ACTIONS(2412),
    [anon_sym_static] = ACTIONS(2412),
    [anon_sym_struct] = ACTIONS(2412),
    [anon_sym_trait] = ACTIONS(2412),
    [anon_sym_type] = ACTIONS(2412),
    [anon_sym_union] = ACTIONS(2412),
    [anon_sym_unsafe] = ACTIONS(2412),
    [anon_sym_use] = ACTIONS(2412),
    [anon_sym_where] = ACTIONS(2412),
    [anon_sym_while] = ACTIONS(2412),
    [sym_mutable_specifier] = ACTIONS(2412),
    [sym_integer_literal] = ACTIONS(2414),
    [aux_sym_string_literal_token1] = ACTIONS(2414),
    [sym_char_literal] = ACTIONS(2414),
    [anon_sym_true] = ACTIONS(2412),
    [anon_sym_false] = ACTIONS(2412),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2412),
    [sym_super] = ACTIONS(2412),
    [sym_crate] = ACTIONS(2412),
    [sym_metavariable] = ACTIONS(2414),
    [sym_raw_string_literal] = ACTIONS(2414),
    [sym_float_literal] = ACTIONS(2414),
    [sym_block_comment] = ACTIONS(3),
  },
  [517] = {
    [sym_identifier] = ACTIONS(2416),
    [anon_sym_LPAREN] = ACTIONS(2418),
    [anon_sym_RPAREN] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_RBRACE] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2418),
    [anon_sym_RBRACK] = ACTIONS(2418),
    [anon_sym_DOLLAR] = ACTIONS(2416),
    [anon_sym_u8] = ACTIONS(2416),
    [anon_sym_i8] = ACTIONS(2416),
    [anon_sym_u16] = ACTIONS(2416),
    [anon_sym_i16] = ACTIONS(2416),
    [anon_sym_u32] = ACTIONS(2416),
    [anon_sym_i32] = ACTIONS(2416),
    [anon_sym_u64] = ACTIONS(2416),
    [anon_sym_i64] = ACTIONS(2416),
    [anon_sym_u128] = ACTIONS(2416),
    [anon_sym_i128] = ACTIONS(2416),
    [anon_sym_isize] = ACTIONS(2416),
    [anon_sym_usize] = ACTIONS(2416),
    [anon_sym_f32] = ACTIONS(2416),
    [anon_sym_f64] = ACTIONS(2416),
    [anon_sym_bool] = ACTIONS(2416),
    [anon_sym_str] = ACTIONS(2416),
    [anon_sym_char] = ACTIONS(2416),
    [aux_sym__non_special_token_token1] = ACTIONS(2416),
    [anon_sym_SQUOTE] = ACTIONS(2416),
    [anon_sym_as] = ACTIONS(2416),
    [anon_sym_async] = ACTIONS(2416),
    [anon_sym_await] = ACTIONS(2416),
    [anon_sym_break] = ACTIONS(2416),
    [anon_sym_const] = ACTIONS(2416),
    [anon_sym_continue] = ACTIONS(2416),
    [anon_sym_default] = ACTIONS(2416),
    [anon_sym_enum] = ACTIONS(2416),
    [anon_sym_fn] = ACTIONS(2416),
    [anon_sym_for] = ACTIONS(2416),
    [anon_sym_if] = ACTIONS(2416),
    [anon_sym_impl] = ACTIONS(2416),
    [anon_sym_let] = ACTIONS(2416),
    [anon_sym_loop] = ACTIONS(2416),
    [anon_sym_match] = ACTIONS(2416),
    [anon_sym_mod] = ACTIONS(2416),
    [anon_sym_pub] = ACTIONS(2416),
    [anon_sym_return] = ACTIONS(2416),
    [anon_sym_static] = ACTIONS(2416),
    [anon_sym_struct] = ACTIONS(2416),
    [anon_sym_trait] = ACTIONS(2416),
    [anon_sym_type] = ACTIONS(2416),
    [anon_sym_union] = ACTIONS(2416),
    [anon_sym_unsafe] = ACTIONS(2416),
    [anon_sym_use] = ACTIONS(2416),
    [anon_sym_where] = ACTIONS(2416),
    [anon_sym_while] = ACTIONS(2416),
    [sym_mutable_specifier] = ACTIONS(2416),
    [sym_integer_literal] = ACTIONS(2418),
    [aux_sym_string_literal_token1] = ACTIONS(2418),
    [sym_char_literal] = ACTIONS(2418),
    [anon_sym_true] = ACTIONS(2416),
    [anon_sym_false] = ACTIONS(2416),
    [sym_line_comment] = ACTIONS(1140),
    [sym_self] = ACTIONS(2416),
    [sym_super] = ACTIONS(2416),
    [sym_crate] = ACTIONS(2416),
    [sym_metavariable] = ACTIONS(2418),
    [sym_raw_string_literal] = ACTIONS(2418),
    [sym_float_literal] = ACTIONS(2418),
    [sym_block_comment] = ACTIONS(3),
  },
  [518] = {
    [sym_attribute_item] = STATE(536),
    [sym_bracketed_type] = STATE(2256),
    [sym_generic_type] = STATE(2255),
    [sym_generic_type_with_turbofish] = STATE(2253),
    [sym_macro_invocation] = STATE(2329),
    [sym_scoped_identifier] = STATE(1446),
    [sym_scoped_type_identifier] = STATE(1796),
    [sym_match_pattern] = STATE(2351),
    [sym__pattern] = STATE(1880),
    [sym_tuple_pattern] = STATE(1880),
    [sym_slice_pattern] = STATE(1880),
    [sym_tuple_struct_pattern] = STATE(1880),
    [sym_struct_pattern] = STATE(1880),
    [sym_remaining_field_pattern] = STATE(1880),
    [sym_mut_pattern] = STATE(1880),
    [sym_range_pattern] = STATE(1880),
    [sym_ref_pattern] = STATE(1880),
    [sym_captured_pattern] = STATE(1880),
    [sym_reference_pattern] = STATE(1880),
    [sym_or_pattern] = STATE(1880),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_enum_variant_list_repeat1] = STATE(536),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_u8] = ACTIONS(2258),
    [anon_sym_i8] = ACTIONS(2258),
    [anon_sym_u16] = ACTIONS(2258),
    [anon_sym_i16] = ACTIONS(2258),
    [anon_sym_u32] = ACTIONS(2258),
    [anon_sym_i32] = ACTIONS(2258),
    [anon_sym_u64] = ACTIONS(2258),
    [anon_sym_i64] = ACTIONS(2258),
    [anon_sym_u128] = ACTIONS(2258),
    [anon_sym_i128] = ACTIONS(2258),
    [anon_sym_isize] = ACTIONS(2258),
    [anon_sym_usize] = ACTIONS(2258),
    [anon_sym_f32] = ACTIONS(2258),
    [anon_sym_f64] = ACTIONS(2258),
    [anon_sym_bool] = ACTIONS(2258),
    [anon_sym_str] = ACTIONS(2258),
    [anon_sym_char] = ACTIONS(2258),
    [anon_sym_POUND] = ACTIONS(405),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(2260),
    [anon_sym__] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2264),
    [sym_mutable_specifier] = ACTIONS(1017),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2266),
    [sym_super] = ACTIONS(2266),
    [sym_crate] = ACTIONS(2266),
    [sym_metavariable] = ACTIONS(2268),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [519] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_const_parameter] = STATE(1737),
    [sym_constrained_type_parameter] = STATE(1722),
    [sym_optional_type_parameter] = STATE(1737),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1903),
    [sym_bracketed_type] = STATE(2213),
    [sym_qualified_type] = STATE(2309),
    [sym_lifetime] = STATE(1550),
    [sym_array_type] = STATE(1903),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1903),
    [sym_tuple_type] = STATE(1903),
    [sym_unit_type] = STATE(1903),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1903),
    [sym_reference_type] = STATE(1903),
    [sym_pointer_type] = STATE(1903),
    [sym_empty_type] = STATE(1903),
    [sym_abstract_type] = STATE(1903),
    [sym_dynamic_type] = STATE(1903),
    [sym_macro_invocation] = STATE(1903),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(2420),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(1101),
    [sym_metavariable] = ACTIONS(2424),
    [sym_block_comment] = ACTIONS(3),
  },
  [520] = {
    [sym_attribute_item] = STATE(536),
    [sym_bracketed_type] = STATE(2256),
    [sym_generic_type] = STATE(2255),
    [sym_generic_type_with_turbofish] = STATE(2253),
    [sym_macro_invocation] = STATE(2329),
    [sym_scoped_identifier] = STATE(1446),
    [sym_scoped_type_identifier] = STATE(1796),
    [sym_match_pattern] = STATE(2329),
    [sym__pattern] = STATE(1880),
    [sym_tuple_pattern] = STATE(1880),
    [sym_slice_pattern] = STATE(1880),
    [sym_tuple_struct_pattern] = STATE(1880),
    [sym_struct_pattern] = STATE(1880),
    [sym_remaining_field_pattern] = STATE(1880),
    [sym_mut_pattern] = STATE(1880),
    [sym_range_pattern] = STATE(1880),
    [sym_ref_pattern] = STATE(1880),
    [sym_captured_pattern] = STATE(1880),
    [sym_reference_pattern] = STATE(1880),
    [sym_or_pattern] = STATE(1880),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [aux_sym_enum_variant_list_repeat1] = STATE(536),
    [sym_identifier] = ACTIONS(2250),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_u8] = ACTIONS(2258),
    [anon_sym_i8] = ACTIONS(2258),
    [anon_sym_u16] = ACTIONS(2258),
    [anon_sym_i16] = ACTIONS(2258),
    [anon_sym_u32] = ACTIONS(2258),
    [anon_sym_i32] = ACTIONS(2258),
    [anon_sym_u64] = ACTIONS(2258),
    [anon_sym_i64] = ACTIONS(2258),
    [anon_sym_u128] = ACTIONS(2258),
    [anon_sym_i128] = ACTIONS(2258),
    [anon_sym_isize] = ACTIONS(2258),
    [anon_sym_usize] = ACTIONS(2258),
    [anon_sym_f32] = ACTIONS(2258),
    [anon_sym_f64] = ACTIONS(2258),
    [anon_sym_bool] = ACTIONS(2258),
    [anon_sym_str] = ACTIONS(2258),
    [anon_sym_char] = ACTIONS(2258),
    [anon_sym_POUND] = ACTIONS(405),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(2260),
    [anon_sym__] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2264),
    [sym_mutable_specifier] = ACTIONS(1017),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2266),
    [sym_super] = ACTIONS(2266),
    [sym_crate] = ACTIONS(2266),
    [sym_metavariable] = ACTIONS(2268),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [521] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_higher_ranked_trait_bound] = STATE(1494),
    [sym_removed_trait_bound] = STATE(1494),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1480),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(1479),
    [sym_array_type] = STATE(1480),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1480),
    [sym_tuple_type] = STATE(1480),
    [sym_unit_type] = STATE(1480),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1480),
    [sym_reference_type] = STATE(1480),
    [sym_pointer_type] = STATE(1480),
    [sym_empty_type] = STATE(1480),
    [sym_abstract_type] = STATE(1480),
    [sym_dynamic_type] = STATE(1480),
    [sym_macro_invocation] = STATE(1480),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(2426),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(2428),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(1101),
    [sym_metavariable] = ACTIONS(1103),
    [sym_block_comment] = ACTIONS(3),
  },
  [522] = {
    [sym_parameter] = STATE(1952),
    [sym_bracketed_type] = STATE(2256),
    [sym_generic_type] = STATE(2255),
    [sym_generic_type_with_turbofish] = STATE(2253),
    [sym_scoped_identifier] = STATE(1253),
    [sym_scoped_type_identifier] = STATE(1796),
    [sym__pattern] = STATE(1641),
    [sym_tuple_pattern] = STATE(1641),
    [sym_slice_pattern] = STATE(1641),
    [sym_tuple_struct_pattern] = STATE(1641),
    [sym_struct_pattern] = STATE(1641),
    [sym_remaining_field_pattern] = STATE(1641),
    [sym_mut_pattern] = STATE(1641),
    [sym_range_pattern] = STATE(1641),
    [sym_ref_pattern] = STATE(1641),
    [sym_captured_pattern] = STATE(1641),
    [sym_reference_pattern] = STATE(1641),
    [sym_or_pattern] = STATE(1641),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [sym_identifier] = ACTIONS(2430),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_u8] = ACTIONS(2258),
    [anon_sym_i8] = ACTIONS(2258),
    [anon_sym_u16] = ACTIONS(2258),
    [anon_sym_i16] = ACTIONS(2258),
    [anon_sym_u32] = ACTIONS(2258),
    [anon_sym_i32] = ACTIONS(2258),
    [anon_sym_u64] = ACTIONS(2258),
    [anon_sym_i64] = ACTIONS(2258),
    [anon_sym_u128] = ACTIONS(2258),
    [anon_sym_i128] = ACTIONS(2258),
    [anon_sym_isize] = ACTIONS(2258),
    [anon_sym_usize] = ACTIONS(2258),
    [anon_sym_f32] = ACTIONS(2258),
    [anon_sym_f64] = ACTIONS(2258),
    [anon_sym_bool] = ACTIONS(2258),
    [anon_sym_str] = ACTIONS(2258),
    [anon_sym_char] = ACTIONS(2258),
    [anon_sym_default] = ACTIONS(673),
    [anon_sym_union] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(2260),
    [anon_sym__] = ACTIONS(2432),
    [anon_sym_AMP] = ACTIONS(2264),
    [sym_mutable_specifier] = ACTIONS(2434),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [anon_sym_PIPE] = ACTIONS(2436),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2438),
    [sym_super] = ACTIONS(2266),
    [sym_crate] = ACTIONS(2266),
    [sym_metavariable] = ACTIONS(2268),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [523] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_higher_ranked_trait_bound] = STATE(1494),
    [sym_removed_trait_bound] = STATE(1494),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1470),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(1479),
    [sym_array_type] = STATE(1470),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1470),
    [sym_tuple_type] = STATE(1470),
    [sym_unit_type] = STATE(1470),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1470),
    [sym_reference_type] = STATE(1470),
    [sym_pointer_type] = STATE(1470),
    [sym_empty_type] = STATE(1470),
    [sym_abstract_type] = STATE(1470),
    [sym_dynamic_type] = STATE(1470),
    [sym_macro_invocation] = STATE(1470),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(2426),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(2428),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(1101),
    [sym_metavariable] = ACTIONS(1103),
    [sym_block_comment] = ACTIONS(3),
  },
  [524] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_higher_ranked_trait_bound] = STATE(1462),
    [sym_removed_trait_bound] = STATE(1462),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1464),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(1465),
    [sym_array_type] = STATE(1464),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1464),
    [sym_tuple_type] = STATE(1464),
    [sym_unit_type] = STATE(1464),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1464),
    [sym_reference_type] = STATE(1464),
    [sym_pointer_type] = STATE(1464),
    [sym_empty_type] = STATE(1464),
    [sym_abstract_type] = STATE(1464),
    [sym_dynamic_type] = STATE(1464),
    [sym_macro_invocation] = STATE(1464),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(2426),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(2428),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(1101),
    [sym_metavariable] = ACTIONS(1103),
    [sym_block_comment] = ACTIONS(3),
  },
  [525] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_higher_ranked_trait_bound] = STATE(1494),
    [sym_removed_trait_bound] = STATE(1494),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1470),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(1471),
    [sym_array_type] = STATE(1470),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1470),
    [sym_tuple_type] = STATE(1470),
    [sym_unit_type] = STATE(1470),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1470),
    [sym_reference_type] = STATE(1470),
    [sym_pointer_type] = STATE(1470),
    [sym_empty_type] = STATE(1470),
    [sym_abstract_type] = STATE(1470),
    [sym_dynamic_type] = STATE(1470),
    [sym_macro_invocation] = STATE(1470),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_QMARK] = ACTIONS(2426),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(2428),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(1101),
    [sym_metavariable] = ACTIONS(1103),
    [sym_block_comment] = ACTIONS(3),
  },
  [526] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1304),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(1304),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1304),
    [sym_tuple_type] = STATE(1304),
    [sym_unit_type] = STATE(1304),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1304),
    [sym_reference_type] = STATE(1304),
    [sym_pointer_type] = STATE(1304),
    [sym_empty_type] = STATE(1304),
    [sym_abstract_type] = STATE(1304),
    [sym_dynamic_type] = STATE(1304),
    [sym_macro_invocation] = STATE(1304),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(2440),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(2442),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(1101),
    [sym_metavariable] = ACTIONS(1103),
    [sym_block_comment] = ACTIONS(3),
  },
  [527] = {
    [sym_parameter] = STATE(2010),
    [sym_bracketed_type] = STATE(2256),
    [sym_generic_type] = STATE(2255),
    [sym_generic_type_with_turbofish] = STATE(2253),
    [sym_scoped_identifier] = STATE(1253),
    [sym_scoped_type_identifier] = STATE(1796),
    [sym__pattern] = STATE(1745),
    [sym_tuple_pattern] = STATE(1745),
    [sym_slice_pattern] = STATE(1745),
    [sym_tuple_struct_pattern] = STATE(1745),
    [sym_struct_pattern] = STATE(1745),
    [sym_remaining_field_pattern] = STATE(1745),
    [sym_mut_pattern] = STATE(1745),
    [sym_range_pattern] = STATE(1745),
    [sym_ref_pattern] = STATE(1745),
    [sym_captured_pattern] = STATE(1745),
    [sym_reference_pattern] = STATE(1745),
    [sym_or_pattern] = STATE(1745),
    [sym__literal_pattern] = STATE(1311),
    [sym_negative_literal] = STATE(1311),
    [sym_string_literal] = STATE(1311),
    [sym_boolean_literal] = STATE(1311),
    [sym_identifier] = ACTIONS(2430),
    [anon_sym_LPAREN] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2256),
    [anon_sym_u8] = ACTIONS(2258),
    [anon_sym_i8] = ACTIONS(2258),
    [anon_sym_u16] = ACTIONS(2258),
    [anon_sym_i16] = ACTIONS(2258),
    [anon_sym_u32] = ACTIONS(2258),
    [anon_sym_i32] = ACTIONS(2258),
    [anon_sym_u64] = ACTIONS(2258),
    [anon_sym_i64] = ACTIONS(2258),
    [anon_sym_u128] = ACTIONS(2258),
    [anon_sym_i128] = ACTIONS(2258),
    [anon_sym_isize] = ACTIONS(2258),
    [anon_sym_usize] = ACTIONS(2258),
    [anon_sym_f32] = ACTIONS(2258),
    [anon_sym_f64] = ACTIONS(2258),
    [anon_sym_bool] = ACTIONS(2258),
    [anon_sym_str] = ACTIONS(2258),
    [anon_sym_char] = ACTIONS(2258),
    [anon_sym_default] = ACTIONS(673),
    [anon_sym_union] = ACTIONS(673),
    [anon_sym_ref] = ACTIONS(683),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(2260),
    [anon_sym__] = ACTIONS(2444),
    [anon_sym_AMP] = ACTIONS(2264),
    [sym_mutable_specifier] = ACTIONS(2434),
    [anon_sym_DOT_DOT] = ACTIONS(1019),
    [anon_sym_DASH] = ACTIONS(699),
    [sym_integer_literal] = ACTIONS(701),
    [aux_sym_string_literal_token1] = ACTIONS(703),
    [sym_char_literal] = ACTIONS(701),
    [anon_sym_true] = ACTIONS(705),
    [anon_sym_false] = ACTIONS(705),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2438),
    [sym_super] = ACTIONS(2266),
    [sym_crate] = ACTIONS(2266),
    [sym_metavariable] = ACTIONS(2268),
    [sym_raw_string_literal] = ACTIONS(701),
    [sym_float_literal] = ACTIONS(701),
    [sym_block_comment] = ACTIONS(3),
  },
  [528] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(2053),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(2053),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(2053),
    [sym_tuple_type] = STATE(2053),
    [sym_unit_type] = STATE(2053),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(2053),
    [sym_reference_type] = STATE(2053),
    [sym_pointer_type] = STATE(2053),
    [sym_empty_type] = STATE(2053),
    [sym_abstract_type] = STATE(2053),
    [sym_dynamic_type] = STATE(2053),
    [sym_macro_invocation] = STATE(2053),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(2440),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(2446),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(1101),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(1101),
    [sym_metavariable] = ACTIONS(1103),
    [sym_block_comment] = ACTIONS(3),
  },
  [529] = {
    [sym_function_modifiers] = STATE(2216),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(959),
    [sym_bracketed_type] = STATE(2304),
    [sym_lifetime] = STATE(2183),
    [sym_array_type] = STATE(959),
    [sym_for_lifetimes] = STATE(1206),
    [sym_function_type] = STATE(959),
    [sym_tuple_type] = STATE(959),
    [sym_unit_type] = STATE(959),
    [sym_generic_type] = STATE(759),
    [sym_generic_type_with_turbofish] = STATE(2305),
    [sym_bounded_type] = STATE(959),
    [sym_reference_type] = STATE(959),
    [sym_pointer_type] = STATE(959),
    [sym_empty_type] = STATE(959),
    [sym_abstract_type] = STATE(959),
    [sym_dynamic_type] = STATE(959),
    [sym_macro_invocation] = STATE(959),
    [sym_scoped_identifier] = STATE(2152),
    [sym_scoped_type_identifier] = STATE(717),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(2448),
    [anon_sym_LPAREN] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(2452),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_STAR] = ACTIONS(2456),
    [anon_sym_u8] = ACTIONS(2458),
    [anon_sym_i8] = ACTIONS(2458),
    [anon_sym_u16] = ACTIONS(2458),
    [anon_sym_i16] = ACTIONS(2458),
    [anon_sym_u32] = ACTIONS(2458),
    [anon_sym_i32] = ACTIONS(2458),
    [anon_sym_u64] = ACTIONS(2458),
    [anon_sym_i64] = ACTIONS(2458),
    [anon_sym_u128] = ACTIONS(2458),
    [anon_sym_i128] = ACTIONS(2458),
    [anon_sym_isize] = ACTIONS(2458),
    [anon_sym_usize] = ACTIONS(2458),
    [anon_sym_f32] = ACTIONS(2458),
    [anon_sym_f64] = ACTIONS(2458),
    [anon_sym_bool] = ACTIONS(2458),
    [anon_sym_str] = ACTIONS(2458),
    [anon_sym_char] = ACTIONS(2458),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(2460),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(2462),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(2466),
    [anon_sym_AMP] = ACTIONS(2468),
    [anon_sym_dyn] = ACTIONS(2470),
    [sym_mutable_specifier] = ACTIONS(2472),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2474),
    [sym_super] = ACTIONS(2474),
    [sym_crate] = ACTIONS(2474),
    [sym_metavariable] = ACTIONS(2476),
    [sym_block_comment] = ACTIONS(3),
  },
  [530] = {
    [sym_function_modifiers] = STATE(2207),
    [sym_extern_modifier] = STATE(1440),
    [sym__type] = STATE(1304),
    [sym_bracketed_type] = STATE(2213),
    [sym_lifetime] = STATE(2200),
    [sym_array_type] = STATE(1304),
    [sym_for_lifetimes] = STATE(1205),
    [sym_function_type] = STATE(1304),
    [sym_tuple_type] = STATE(1304),
    [sym_unit_type] = STATE(1304),
    [sym_generic_type] = STATE(1276),
    [sym_generic_type_with_turbofish] = STATE(2214),
    [sym_bounded_type] = STATE(1304),
    [sym_reference_type] = STATE(1304),
    [sym_pointer_type] = STATE(1304),
    [sym_empty_type] = STATE(1304),
    [sym_abstract_type] = STATE(1304),
    [sym_dynamic_type] = STATE(1304),
    [sym_macro_invocation] = STATE(1304),
    [sym_scoped_identifier] = STATE(2136),
    [sym_scoped_type_identifier] = STATE(1242),
    [aux_sym_function_modifiers_repeat1] = STATE(1440),
    [sym_identifier] = ACTIONS(2274),
    [anon_sym_LPAREN] = ACTIONS(1085),
    [anon_sym_LBRACK] = ACTIONS(1089),
    [anon_sym_PLUS] = ACTIONS(2440),
    [anon_sym_STAR] = ACTIONS(657),
    [anon_sym_u8] = ACTIONS(1091),
    [anon_sym_i8] = ACTIONS(1091),
    [anon_sym_u16] = ACTIONS(1091),
    [anon_sym_i16] = ACTIONS(1091),
    [anon_sym_u32] = ACTIONS(1091),
    [anon_sym_i32] = ACTIONS(1091),
    [anon_sym_u64] = ACTIONS(1091),
    [anon_sym_i64] = ACTIONS(1091),
    [anon_sym_u128] = ACTIONS(1091),
    [anon_sym_i128] = ACTIONS(1091),
    [anon_sym_isize] = ACTIONS(1091),
    [anon_sym_usize] = ACTIONS(1091),
    [anon_sym_f32] = ACTIONS(1091),
    [anon_sym_f64] = ACTIONS(1091),
    [anon_sym_bool] = ACTIONS(1091),
    [anon_sym_str] = ACTIONS(1091),
    [anon_sym_char] = ACTIONS(1091),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [anon_sym_async] = ACTIONS(663),
    [anon_sym_const] = ACTIONS(663),
    [anon_sym_default] = ACTIONS(663),
    [anon_sym_fn] = ACTIONS(667),
    [anon_sym_for] = ACTIONS(669),
    [anon_sym_impl] = ACTIONS(671),
    [anon_sym_unsafe] = ACTIONS(663),
    [anon_sym_BANG] = ACTIONS(677),
    [anon_sym_extern] = ACTIONS(681),
    [anon_sym_LT] = ACTIONS(77),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1097),
    [anon_sym_dyn] = ACTIONS(693),
    [sym_mutable_specifier] = ACTIONS(2478),
    [sym_line_comment] = ACTIONS(3),
    [sym_self] = ACTIONS(2480),
    [sym_super] = ACTIONS(1101),
    [sym_crate] = ACTIONS(1101),
    [sym_metavariable] = ACTIONS(1103),
    [sym_block_comment] = ACTIONS(3),
  },
};

static uint16_t ts_small_parse_table[] = {
  [0] = 27,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2484), 1,
      anon_sym__,
    ACTIONS(2486), 1,
      sym_self,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 2,
      sym_super,
      sym_crate,
    ACTIONS(2482), 2,
      anon_sym_default,
      anon_sym_union,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1672), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [119] = 30,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2488), 1,
      sym_identifier,
    ACTIONS(2490), 1,
      anon_sym_LT,
    STATE(596), 1,
      sym_type_parameters,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1425), 1,
      sym_scoped_type_identifier,
    STATE(1570), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1601), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [244] = 30,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(2448), 1,
      sym_identifier,
    ACTIONS(2450), 1,
      anon_sym_LPAREN,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2456), 1,
      anon_sym_STAR,
    ACTIONS(2460), 1,
      anon_sym_fn,
    ACTIONS(2462), 1,
      anon_sym_impl,
    ACTIONS(2464), 1,
      anon_sym_BANG,
    ACTIONS(2466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2468), 1,
      anon_sym_AMP,
    ACTIONS(2470), 1,
      anon_sym_dyn,
    ACTIONS(2476), 1,
      sym_metavariable,
    ACTIONS(2492), 1,
      anon_sym_SQUOTE,
    ACTIONS(2494), 1,
      sym_mutable_specifier,
    STATE(529), 1,
      sym_lifetime,
    STATE(717), 1,
      sym_scoped_type_identifier,
    STATE(759), 1,
      sym_generic_type,
    STATE(1206), 1,
      sym_for_lifetimes,
    STATE(2152), 1,
      sym_scoped_identifier,
    STATE(2216), 1,
      sym_function_modifiers,
    STATE(2304), 1,
      sym_bracketed_type,
    STATE(2305), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(2474), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(990), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(2458), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [369] = 30,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2496), 1,
      anon_sym_RPAREN,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1863), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [494] = 27,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2498), 1,
      anon_sym_RPAREN,
    ACTIONS(2500), 1,
      anon_sym_COMMA,
    ACTIONS(2502), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1702), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [613] = 5,
    ACTIONS(2508), 1,
      anon_sym_POUND,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(536), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    ACTIONS(2506), 19,
      sym_raw_string_literal,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(2504), 40,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_default,
      anon_sym_for,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_match,
      anon_sym_return,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_while,
      anon_sym_ref,
      anon_sym__,
      sym_mutable_specifier,
      anon_sym_move,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [688] = 30,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2511), 1,
      anon_sym_RPAREN,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1678), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [813] = 30,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2492), 1,
      anon_sym_SQUOTE,
    ACTIONS(2513), 1,
      sym_mutable_specifier,
    STATE(528), 1,
      sym_lifetime,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(2033), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [938] = 30,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2515), 1,
      anon_sym_RPAREN,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1863), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [1063] = 30,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2517), 1,
      anon_sym_RPAREN,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1863), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [1188] = 30,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2490), 1,
      anon_sym_LT,
    ACTIONS(2519), 1,
      sym_identifier,
    STATE(611), 1,
      sym_type_parameters,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1433), 1,
      sym_scoped_type_identifier,
    STATE(1574), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1596), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [1313] = 30,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2490), 1,
      anon_sym_LT,
    ACTIONS(2521), 1,
      sym_identifier,
    STATE(621), 1,
      sym_type_parameters,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1455), 1,
      sym_scoped_type_identifier,
    STATE(1582), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1581), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [1438] = 30,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2492), 1,
      anon_sym_SQUOTE,
    ACTIONS(2523), 1,
      sym_mutable_specifier,
    STATE(526), 1,
      sym_lifetime,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1305), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [1563] = 27,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2484), 1,
      anon_sym__,
    ACTIONS(2525), 1,
      sym_self,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 2,
      sym_super,
      sym_crate,
    ACTIONS(2482), 2,
      anon_sym_default,
      anon_sym_union,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1672), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [1682] = 30,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2490), 1,
      anon_sym_LT,
    ACTIONS(2527), 1,
      sym_identifier,
    STATE(618), 1,
      sym_type_parameters,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1452), 1,
      sym_scoped_type_identifier,
    STATE(1594), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1593), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [1807] = 30,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2529), 1,
      anon_sym_RPAREN,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1716), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [1932] = 27,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1011), 1,
      anon_sym_COMMA,
    ACTIONS(1013), 1,
      anon_sym__,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2531), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1706), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [2051] = 30,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    STATE(2309), 1,
      sym_qualified_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1903), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [2176] = 27,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1027), 1,
      anon_sym_RBRACK,
    ACTIONS(1031), 1,
      anon_sym_COMMA,
    ACTIONS(1035), 1,
      anon_sym__,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1707), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [2295] = 30,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2533), 1,
      anon_sym_RPAREN,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1863), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [2420] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1307), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [2542] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2448), 1,
      sym_identifier,
    ACTIONS(2450), 1,
      anon_sym_LPAREN,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2456), 1,
      anon_sym_STAR,
    ACTIONS(2460), 1,
      anon_sym_fn,
    ACTIONS(2462), 1,
      anon_sym_impl,
    ACTIONS(2464), 1,
      anon_sym_BANG,
    ACTIONS(2466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2468), 1,
      anon_sym_AMP,
    ACTIONS(2470), 1,
      anon_sym_dyn,
    ACTIONS(2476), 1,
      sym_metavariable,
    STATE(717), 1,
      sym_scoped_type_identifier,
    STATE(759), 1,
      sym_generic_type,
    STATE(1206), 1,
      sym_for_lifetimes,
    STATE(2152), 1,
      sym_scoped_identifier,
    STATE(2183), 1,
      sym_lifetime,
    STATE(2216), 1,
      sym_function_modifiers,
    STATE(2304), 1,
      sym_bracketed_type,
    STATE(2305), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(2474), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1052), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(2458), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [2664] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1826), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [2786] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2448), 1,
      sym_identifier,
    ACTIONS(2450), 1,
      anon_sym_LPAREN,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2456), 1,
      anon_sym_STAR,
    ACTIONS(2460), 1,
      anon_sym_fn,
    ACTIONS(2462), 1,
      anon_sym_impl,
    ACTIONS(2464), 1,
      anon_sym_BANG,
    ACTIONS(2466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2468), 1,
      anon_sym_AMP,
    ACTIONS(2470), 1,
      anon_sym_dyn,
    ACTIONS(2476), 1,
      sym_metavariable,
    STATE(717), 1,
      sym_scoped_type_identifier,
    STATE(759), 1,
      sym_generic_type,
    STATE(1206), 1,
      sym_for_lifetimes,
    STATE(2152), 1,
      sym_scoped_identifier,
    STATE(2183), 1,
      sym_lifetime,
    STATE(2216), 1,
      sym_function_modifiers,
    STATE(2304), 1,
      sym_bracketed_type,
    STATE(2305), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(2474), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(992), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(2458), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [2908] = 26,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2535), 1,
      anon_sym_RPAREN,
    ACTIONS(2537), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1691), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [3024] = 26,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2537), 1,
      anon_sym__,
    ACTIONS(2539), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1691), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [3140] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1662), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [3262] = 26,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2537), 1,
      anon_sym__,
    ACTIONS(2541), 1,
      anon_sym_RBRACK,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1691), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [3378] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1667), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [3500] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1303), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [3622] = 30,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2543), 1,
      sym_self,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1101), 2,
      sym_super,
      sym_crate,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1293), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [3746] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(2135), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [3868] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1590), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [3990] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1749), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4112] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2448), 1,
      sym_identifier,
    ACTIONS(2450), 1,
      anon_sym_LPAREN,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2456), 1,
      anon_sym_STAR,
    ACTIONS(2460), 1,
      anon_sym_fn,
    ACTIONS(2462), 1,
      anon_sym_impl,
    ACTIONS(2464), 1,
      anon_sym_BANG,
    ACTIONS(2466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2468), 1,
      anon_sym_AMP,
    ACTIONS(2470), 1,
      anon_sym_dyn,
    ACTIONS(2476), 1,
      sym_metavariable,
    STATE(717), 1,
      sym_scoped_type_identifier,
    STATE(759), 1,
      sym_generic_type,
    STATE(1206), 1,
      sym_for_lifetimes,
    STATE(2152), 1,
      sym_scoped_identifier,
    STATE(2183), 1,
      sym_lifetime,
    STATE(2216), 1,
      sym_function_modifiers,
    STATE(2304), 1,
      sym_bracketed_type,
    STATE(2305), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(2474), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1050), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(2458), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4234] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1717), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4356] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2448), 1,
      sym_identifier,
    ACTIONS(2450), 1,
      anon_sym_LPAREN,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2456), 1,
      anon_sym_STAR,
    ACTIONS(2460), 1,
      anon_sym_fn,
    ACTIONS(2462), 1,
      anon_sym_impl,
    ACTIONS(2464), 1,
      anon_sym_BANG,
    ACTIONS(2466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2468), 1,
      anon_sym_AMP,
    ACTIONS(2470), 1,
      anon_sym_dyn,
    ACTIONS(2476), 1,
      sym_metavariable,
    STATE(717), 1,
      sym_scoped_type_identifier,
    STATE(759), 1,
      sym_generic_type,
    STATE(1206), 1,
      sym_for_lifetimes,
    STATE(2152), 1,
      sym_scoped_identifier,
    STATE(2183), 1,
      sym_lifetime,
    STATE(2216), 1,
      sym_function_modifiers,
    STATE(2304), 1,
      sym_bracketed_type,
    STATE(2305), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(2474), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1051), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(2458), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4478] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1978), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4600] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2448), 1,
      sym_identifier,
    ACTIONS(2450), 1,
      anon_sym_LPAREN,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2456), 1,
      anon_sym_STAR,
    ACTIONS(2460), 1,
      anon_sym_fn,
    ACTIONS(2462), 1,
      anon_sym_impl,
    ACTIONS(2464), 1,
      anon_sym_BANG,
    ACTIONS(2466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2468), 1,
      anon_sym_AMP,
    ACTIONS(2470), 1,
      anon_sym_dyn,
    ACTIONS(2476), 1,
      sym_metavariable,
    STATE(717), 1,
      sym_scoped_type_identifier,
    STATE(759), 1,
      sym_generic_type,
    STATE(1206), 1,
      sym_for_lifetimes,
    STATE(2152), 1,
      sym_scoped_identifier,
    STATE(2183), 1,
      sym_lifetime,
    STATE(2216), 1,
      sym_function_modifiers,
    STATE(2304), 1,
      sym_bracketed_type,
    STATE(2305), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(2474), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1025), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(2458), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4722] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1519), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4844] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1525), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [4966] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1882), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5088] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1526), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5210] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(2073), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5332] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1560), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5454] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1624), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5576] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1625), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5698] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1901), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5820] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1557), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [5942] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(2041), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [6064] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1961), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [6186] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1918), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [6308] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1631), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [6430] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1942), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [6552] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1632), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [6674] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(2025), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [6796] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1933), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [6918] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(2124), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [7040] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2448), 1,
      sym_identifier,
    ACTIONS(2450), 1,
      anon_sym_LPAREN,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2456), 1,
      anon_sym_STAR,
    ACTIONS(2460), 1,
      anon_sym_fn,
    ACTIONS(2462), 1,
      anon_sym_impl,
    ACTIONS(2464), 1,
      anon_sym_BANG,
    ACTIONS(2466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2468), 1,
      anon_sym_AMP,
    ACTIONS(2470), 1,
      anon_sym_dyn,
    ACTIONS(2476), 1,
      sym_metavariable,
    STATE(717), 1,
      sym_scoped_type_identifier,
    STATE(759), 1,
      sym_generic_type,
    STATE(1206), 1,
      sym_for_lifetimes,
    STATE(2152), 1,
      sym_scoped_identifier,
    STATE(2183), 1,
      sym_lifetime,
    STATE(2216), 1,
      sym_function_modifiers,
    STATE(2304), 1,
      sym_bracketed_type,
    STATE(2305), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(2474), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(960), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(2458), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [7162] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1934), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [7284] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1644), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [7406] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1987), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [7528] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1633), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [7650] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1630), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [7772] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1551), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [7894] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2545), 1,
      sym_identifier,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1461), 1,
      sym_scoped_type_identifier,
    STATE(1568), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1617), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [8016] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1967), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [8138] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1956), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [8260] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1513), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [8382] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1949), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [8504] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(2053), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [8626] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2448), 1,
      sym_identifier,
    ACTIONS(2450), 1,
      anon_sym_LPAREN,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2456), 1,
      anon_sym_STAR,
    ACTIONS(2460), 1,
      anon_sym_fn,
    ACTIONS(2462), 1,
      anon_sym_impl,
    ACTIONS(2464), 1,
      anon_sym_BANG,
    ACTIONS(2466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2468), 1,
      anon_sym_AMP,
    ACTIONS(2470), 1,
      anon_sym_dyn,
    ACTIONS(2476), 1,
      sym_metavariable,
    STATE(717), 1,
      sym_scoped_type_identifier,
    STATE(759), 1,
      sym_generic_type,
    STATE(1206), 1,
      sym_for_lifetimes,
    STATE(2152), 1,
      sym_scoped_identifier,
    STATE(2183), 1,
      sym_lifetime,
    STATE(2216), 1,
      sym_function_modifiers,
    STATE(2304), 1,
      sym_bracketed_type,
    STATE(2305), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(2474), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(959), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(2458), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [8748] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1895), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [8870] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1527), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [8992] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1750), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [9114] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1615), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [9236] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1614), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [9358] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1919), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [9480] = 26,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2537), 1,
      anon_sym__,
    ACTIONS(2547), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1691), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [9596] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1950), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [9718] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2549), 1,
      sym_identifier,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1429), 1,
      sym_scoped_type_identifier,
    STATE(1571), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1599), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [9840] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1293), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [9962] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1533), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [10084] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1313), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [10206] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1875), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [10328] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1565), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [10450] = 26,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2537), 1,
      anon_sym__,
    ACTIONS(2551), 1,
      anon_sym_RBRACK,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1691), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [10566] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2553), 1,
      sym_identifier,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1444), 1,
      sym_scoped_type_identifier,
    STATE(1567), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1566), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [10688] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1629), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [10810] = 26,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2537), 1,
      anon_sym__,
    ACTIONS(2555), 1,
      anon_sym_RPAREN,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1691), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [10926] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2557), 1,
      sym_identifier,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1456), 1,
      sym_scoped_type_identifier,
    STATE(1586), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1587), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [11048] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1764), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [11170] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2448), 1,
      sym_identifier,
    ACTIONS(2450), 1,
      anon_sym_LPAREN,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2456), 1,
      anon_sym_STAR,
    ACTIONS(2460), 1,
      anon_sym_fn,
    ACTIONS(2462), 1,
      anon_sym_impl,
    ACTIONS(2464), 1,
      anon_sym_BANG,
    ACTIONS(2466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2468), 1,
      anon_sym_AMP,
    ACTIONS(2470), 1,
      anon_sym_dyn,
    ACTIONS(2476), 1,
      sym_metavariable,
    STATE(717), 1,
      sym_scoped_type_identifier,
    STATE(759), 1,
      sym_generic_type,
    STATE(1206), 1,
      sym_for_lifetimes,
    STATE(2152), 1,
      sym_scoped_identifier,
    STATE(2183), 1,
      sym_lifetime,
    STATE(2216), 1,
      sym_function_modifiers,
    STATE(2304), 1,
      sym_bracketed_type,
    STATE(2305), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(2474), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1037), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(2458), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [11292] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1892), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [11414] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1309), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [11536] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(2133), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [11658] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1938), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [11780] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1620), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [11902] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2448), 1,
      sym_identifier,
    ACTIONS(2450), 1,
      anon_sym_LPAREN,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2456), 1,
      anon_sym_STAR,
    ACTIONS(2460), 1,
      anon_sym_fn,
    ACTIONS(2462), 1,
      anon_sym_impl,
    ACTIONS(2464), 1,
      anon_sym_BANG,
    ACTIONS(2466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2468), 1,
      anon_sym_AMP,
    ACTIONS(2470), 1,
      anon_sym_dyn,
    ACTIONS(2476), 1,
      sym_metavariable,
    STATE(717), 1,
      sym_scoped_type_identifier,
    STATE(759), 1,
      sym_generic_type,
    STATE(1206), 1,
      sym_for_lifetimes,
    STATE(2152), 1,
      sym_scoped_identifier,
    STATE(2183), 1,
      sym_lifetime,
    STATE(2216), 1,
      sym_function_modifiers,
    STATE(2304), 1,
      sym_bracketed_type,
    STATE(2305), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(2474), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1001), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(2458), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [12024] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1476), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [12146] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1518), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [12268] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(2072), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [12390] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2448), 1,
      sym_identifier,
    ACTIONS(2450), 1,
      anon_sym_LPAREN,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2456), 1,
      anon_sym_STAR,
    ACTIONS(2460), 1,
      anon_sym_fn,
    ACTIONS(2462), 1,
      anon_sym_impl,
    ACTIONS(2464), 1,
      anon_sym_BANG,
    ACTIONS(2466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2468), 1,
      anon_sym_AMP,
    ACTIONS(2470), 1,
      anon_sym_dyn,
    ACTIONS(2476), 1,
      sym_metavariable,
    STATE(717), 1,
      sym_scoped_type_identifier,
    STATE(759), 1,
      sym_generic_type,
    STATE(1206), 1,
      sym_for_lifetimes,
    STATE(2152), 1,
      sym_scoped_identifier,
    STATE(2183), 1,
      sym_lifetime,
    STATE(2216), 1,
      sym_function_modifiers,
    STATE(2304), 1,
      sym_bracketed_type,
    STATE(2305), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(2474), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1033), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(2458), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [12512] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2448), 1,
      sym_identifier,
    ACTIONS(2450), 1,
      anon_sym_LPAREN,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2456), 1,
      anon_sym_STAR,
    ACTIONS(2460), 1,
      anon_sym_fn,
    ACTIONS(2462), 1,
      anon_sym_impl,
    ACTIONS(2464), 1,
      anon_sym_BANG,
    ACTIONS(2466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2468), 1,
      anon_sym_AMP,
    ACTIONS(2470), 1,
      anon_sym_dyn,
    ACTIONS(2476), 1,
      sym_metavariable,
    STATE(717), 1,
      sym_scoped_type_identifier,
    STATE(759), 1,
      sym_generic_type,
    STATE(1206), 1,
      sym_for_lifetimes,
    STATE(2152), 1,
      sym_scoped_identifier,
    STATE(2183), 1,
      sym_lifetime,
    STATE(2216), 1,
      sym_function_modifiers,
    STATE(2304), 1,
      sym_bracketed_type,
    STATE(2305), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(2474), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1027), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(2458), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [12634] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1591), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [12756] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1863), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [12878] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1289), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [13000] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1528), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [13122] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1531), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [13244] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(2052), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [13366] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(2448), 1,
      sym_identifier,
    ACTIONS(2450), 1,
      anon_sym_LPAREN,
    ACTIONS(2452), 1,
      anon_sym_LBRACK,
    ACTIONS(2456), 1,
      anon_sym_STAR,
    ACTIONS(2460), 1,
      anon_sym_fn,
    ACTIONS(2462), 1,
      anon_sym_impl,
    ACTIONS(2464), 1,
      anon_sym_BANG,
    ACTIONS(2466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2468), 1,
      anon_sym_AMP,
    ACTIONS(2470), 1,
      anon_sym_dyn,
    ACTIONS(2476), 1,
      sym_metavariable,
    STATE(717), 1,
      sym_scoped_type_identifier,
    STATE(759), 1,
      sym_generic_type,
    STATE(1206), 1,
      sym_for_lifetimes,
    STATE(2152), 1,
      sym_scoped_identifier,
    STATE(2183), 1,
      sym_lifetime,
    STATE(2216), 1,
      sym_function_modifiers,
    STATE(2304), 1,
      sym_bracketed_type,
    STATE(2305), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(2474), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1034), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(2458), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [13488] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1955), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [13610] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1923), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [13732] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1957), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [13854] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1854), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [13976] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1774), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [14098] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1621), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [14220] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1638), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [14342] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1603), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [14464] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(2086), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [14586] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1914), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [14708] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1797), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [14830] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1698), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [14952] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(1308), 1,
      sym_lifetime,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1307), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [15074] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1841), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [15196] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1306), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [15318] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1597), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [15440] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1299), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [15562] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1716), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [15684] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1300), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [15806] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1304), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [15928] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1296), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [16050] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1784), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [16172] = 29,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(657), 1,
      anon_sym_STAR,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(671), 1,
      anon_sym_impl,
    ACTIONS(677), 1,
      anon_sym_BANG,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(693), 1,
      anon_sym_dyn,
    ACTIONS(1085), 1,
      anon_sym_LPAREN,
    ACTIONS(1089), 1,
      anon_sym_LBRACK,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1097), 1,
      anon_sym_AMP,
    ACTIONS(1103), 1,
      sym_metavariable,
    ACTIONS(2274), 1,
      sym_identifier,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1242), 1,
      sym_scoped_type_identifier,
    STATE(1276), 1,
      sym_generic_type,
    STATE(2136), 1,
      sym_scoped_identifier,
    STATE(2200), 1,
      sym_lifetime,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    STATE(1501), 12,
      sym__type,
      sym_array_type,
      sym_function_type,
      sym_tuple_type,
      sym_unit_type,
      sym_bounded_type,
      sym_reference_type,
      sym_pointer_type,
      sym_empty_type,
      sym_abstract_type,
      sym_dynamic_type,
      sym_macro_invocation,
    ACTIONS(1091), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [16294] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1079), 1,
      anon_sym__,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1367), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [16407] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2559), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(2081), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [16520] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2561), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1990), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [16633] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2563), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1845), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [16746] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2565), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1924), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [16859] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2567), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1368), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [16972] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2569), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(2117), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [17085] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2571), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1998), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [17198] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1049), 1,
      anon_sym__,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1342), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [17311] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2573), 1,
      anon_sym__,
    ACTIONS(2575), 1,
      sym_mutable_specifier,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1685), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [17424] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2577), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(2102), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [17537] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2537), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1691), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [17650] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2579), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1718), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [17763] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2581), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(2007), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [17876] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2583), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(2016), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [17989] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2585), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(2031), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [18102] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2587), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(2038), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [18215] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2589), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1339), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [18328] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2591), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(2000), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [18441] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2593), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(2005), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [18554] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2595), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1996), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [18667] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(1055), 1,
      anon_sym__,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2597), 1,
      sym_mutable_specifier,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1361), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [18780] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2599), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1369), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [18893] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2601), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(2023), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [19006] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2603), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(2157), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [19119] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2605), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1989), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [19232] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2607), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1762), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [19345] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1743), 20,
      sym_raw_string_literal,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_STAR,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(1745), 40,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_default,
      anon_sym_for,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_match,
      anon_sym_return,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_while,
      anon_sym_ref,
      anon_sym__,
      sym_mutable_specifier,
      anon_sym_move,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19414] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2609), 1,
      anon_sym__,
    ACTIONS(2611), 1,
      sym_mutable_specifier,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1684), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [19527] = 25,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(683), 1,
      anon_sym_ref,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1017), 1,
      sym_mutable_specifier,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2252), 1,
      anon_sym_LPAREN,
    ACTIONS(2256), 1,
      anon_sym_LBRACK,
    ACTIONS(2260), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2264), 1,
      anon_sym_AMP,
    ACTIONS(2268), 1,
      sym_metavariable,
    ACTIONS(2430), 1,
      sym_identifier,
    ACTIONS(2613), 1,
      anon_sym__,
    STATE(1253), 1,
      sym_scoped_identifier,
    STATE(1796), 1,
      sym_scoped_type_identifier,
    STATE(2253), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2256), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2266), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(701), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1311), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    STATE(1671), 12,
      sym__pattern,
      sym_tuple_pattern,
      sym_slice_pattern,
      sym_tuple_struct_pattern,
      sym_struct_pattern,
      sym_remaining_field_pattern,
      sym_mut_pattern,
      sym_range_pattern,
      sym_ref_pattern,
      sym_captured_pattern,
      sym_reference_pattern,
      sym_or_pattern,
    ACTIONS(2258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [19640] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2617), 17,
      sym_raw_string_literal,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH_GT,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(2615), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_default,
      anon_sym_for,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_match,
      anon_sym_return,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_while,
      anon_sym_DASH,
      anon_sym_move,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19704] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2621), 17,
      sym_raw_string_literal,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH_GT,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(2619), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_default,
      anon_sym_for,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_match,
      anon_sym_return,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_while,
      anon_sym_DASH,
      anon_sym_move,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19768] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(555), 18,
      sym_raw_string_literal,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(2623), 37,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_default,
      anon_sym_for,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_match,
      anon_sym_return,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_while,
      anon_sym_move,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19832] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1077), 17,
      sym_raw_string_literal,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_DASH_GT,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(1075), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_break,
      anon_sym_continue,
      anon_sym_default,
      anon_sym_for,
      anon_sym_if,
      anon_sym_loop,
      anon_sym_match,
      anon_sym_return,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_while,
      anon_sym_DASH,
      anon_sym_move,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19896] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1743), 15,
      sym_raw_string_literal,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DASH,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(1745), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_SQUOTE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_ref,
      anon_sym__,
      anon_sym_dyn,
      sym_mutable_specifier,
      anon_sym_DOT_DOT,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [19958] = 9,
    ACTIONS(2627), 1,
      anon_sym_LPAREN,
    ACTIONS(2631), 1,
      anon_sym_BANG,
    ACTIONS(2633), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2635), 1,
      anon_sym_LT2,
    STATE(807), 1,
      sym_type_arguments,
    STATE(851), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2629), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT_EQ,
      anon_sym_DOT,
    ACTIONS(2625), 26,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [20028] = 8,
    ACTIONS(2627), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2635), 1,
      anon_sym_LT2,
    STATE(807), 1,
      sym_type_arguments,
    STATE(851), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2639), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT_EQ,
      anon_sym_DOT,
    ACTIONS(2637), 26,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [20095] = 8,
    ACTIONS(2627), 1,
      anon_sym_LPAREN,
    ACTIONS(2633), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2635), 1,
      anon_sym_LT2,
    STATE(807), 1,
      sym_type_arguments,
    STATE(851), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2643), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT_EQ,
      anon_sym_DOT,
    ACTIONS(2641), 26,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [20162] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(417), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(419), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20218] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1815), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1817), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20274] = 5,
    ACTIONS(2649), 1,
      anon_sym_BANG,
    ACTIONS(2651), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2647), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT_EQ,
      anon_sym_DOT,
    ACTIONS(2645), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [20334] = 7,
    ACTIONS(2631), 1,
      anon_sym_BANG,
    ACTIONS(2653), 1,
      anon_sym_LBRACE,
    ACTIONS(2655), 1,
      anon_sym_COLON_COLON,
    STATE(957), 1,
      sym_field_initializer_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(481), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(483), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [20398] = 5,
    ACTIONS(2661), 1,
      anon_sym_BANG,
    ACTIONS(2663), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2659), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT_EQ,
      anon_sym_DOT,
    ACTIONS(2657), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [20458] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1501), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1503), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20514] = 5,
    ACTIONS(2669), 1,
      anon_sym_BANG,
    ACTIONS(2671), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2667), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT_EQ,
      anon_sym_DOT,
    ACTIONS(2665), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [20574] = 7,
    ACTIONS(2627), 1,
      anon_sym_LPAREN,
    ACTIONS(2635), 1,
      anon_sym_LT2,
    STATE(808), 1,
      sym_type_arguments,
    STATE(864), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2675), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT_EQ,
      anon_sym_DOT,
    ACTIONS(2673), 26,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [20638] = 5,
    ACTIONS(2681), 1,
      anon_sym_BANG,
    ACTIONS(2683), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2679), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT_EQ,
      anon_sym_DOT,
    ACTIONS(2677), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [20698] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(427), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(429), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20754] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1617), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1619), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20810] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1383), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1385), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20866] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1803), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1805), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20922] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(399), 9,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(401), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [20978] = 7,
    ACTIONS(2627), 1,
      anon_sym_LPAREN,
    ACTIONS(2635), 1,
      anon_sym_LT2,
    STATE(808), 1,
      sym_type_arguments,
    STATE(864), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2687), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT_EQ,
      anon_sym_DOT,
    ACTIONS(2685), 26,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [21042] = 7,
    ACTIONS(2627), 1,
      anon_sym_LPAREN,
    ACTIONS(2635), 1,
      anon_sym_LT2,
    STATE(808), 1,
      sym_type_arguments,
    STATE(864), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2691), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT_EQ,
      anon_sym_DOT,
    ACTIONS(2689), 26,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [21106] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2661), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2663), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [21161] = 4,
    ACTIONS(2693), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2661), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2663), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [21218] = 5,
    ACTIONS(2695), 1,
      anon_sym_else,
    STATE(994), 1,
      sym__else_tail,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(391), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(389), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [21277] = 4,
    ACTIONS(2697), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2681), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2683), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [21334] = 4,
    ACTIONS(2699), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2649), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2651), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [21391] = 5,
    ACTIONS(2695), 1,
      anon_sym_else,
    STATE(968), 1,
      sym__else_tail,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(397), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(395), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [21450] = 5,
    ACTIONS(2705), 1,
      anon_sym_SQUOTE,
    STATE(1004), 1,
      sym_loop_label,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2703), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2701), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [21509] = 4,
    ACTIONS(2707), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2669), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2671), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [21566] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2064), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2066), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21620] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1333), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1335), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21674] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1443), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1445), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21728] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1369), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1371), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21782] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1391), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1393), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21836] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1407), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1409), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21890] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1403), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1405), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21944] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1395), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1397), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [21998] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1419), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1421), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22052] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1387), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1389), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22106] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1423), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1425), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22160] = 4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2711), 2,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
    ACTIONS(2713), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2709), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [22216] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2717), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2715), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [22270] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2721), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2719), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [22324] = 4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2727), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
    ACTIONS(2725), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2723), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [22380] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1867), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1869), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22434] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1337), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1339), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22488] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2124), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2126), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22542] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1345), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1347), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22596] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1349), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1351), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22650] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1467), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1469), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22704] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1455), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1457), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22758] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1459), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1461), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22812] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1549), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1551), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22866] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1557), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1559), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22920] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1581), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1583), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [22974] = 4,
    ACTIONS(2733), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2731), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2729), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [23030] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1593), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1595), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23084] = 7,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2741), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2735), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [23146] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1605), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1607), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23200] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1491), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1493), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23254] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2747), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2745), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [23308] = 4,
    ACTIONS(2749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2687), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2685), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [23364] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1819), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1821), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23418] = 4,
    ACTIONS(2751), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(481), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(483), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [23474] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1735), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1737), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23528] = 4,
    ACTIONS(2753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2687), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2685), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [23584] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1823), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1825), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23638] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1831), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1833), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23692] = 4,
    ACTIONS(2759), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2757), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2755), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [23748] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1839), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1841), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23802] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1513), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1515), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23856] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2763), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2761), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [23910] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1521), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1523), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [23964] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(429), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(427), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_else,
  [24018] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1863), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1865), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24072] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1909), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1911), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24126] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1929), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1931), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24180] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1711), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1713), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24234] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2144), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2146), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24288] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2128), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2130), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24342] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2116), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2118), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24396] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2108), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2110), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24450] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2072), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2074), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24504] = 7,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2767), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2765), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [24566] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2052), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2054), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24620] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2015), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2017), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24674] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2009), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2011), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24728] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1969), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1971), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24782] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2005), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2007), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24836] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1985), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1987), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24890] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1913), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1915), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [24944] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1045), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(1047), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [24998] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1977), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1979), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25052] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1973), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1975), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25106] = 4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2769), 2,
      anon_sym_LBRACE,
      anon_sym_COLON_COLON,
    ACTIONS(2713), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2709), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [25162] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1957), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1959), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25216] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1965), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1967), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25270] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2019), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2021), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25324] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1961), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1963), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25378] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1905), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1907), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25432] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1497), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1499), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25486] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1573), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1575), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25540] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1981), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1983), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25594] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1541), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1543), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25648] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2076), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2078), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25702] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2080), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2082), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25756] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2773), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2771), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [25810] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1537), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1539), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25864] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1365), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1367), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [25918] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2777), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2775), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [25972] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2781), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2779), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [26026] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1533), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1535), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26080] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1529), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1531), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26134] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1517), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1519), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26188] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2084), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2086), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26242] = 7,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2785), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2783), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [26304] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1451), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1453), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26358] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2088), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2090), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26412] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1353), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1355), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26466] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1357), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1359), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26520] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1373), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1375), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26574] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2789), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2787), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [26628] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1447), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1449), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26682] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1471), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1473), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26736] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1475), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1477), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26790] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1411), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1413), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26844] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2793), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2791), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [26898] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2096), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2098), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [26952] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1561), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1563), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27006] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1565), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1567), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27060] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2100), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2102), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27114] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1569), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1571), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27168] = 4,
    ACTIONS(2799), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2797), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2795), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [27224] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1585), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1587), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27278] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1597), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1599), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27332] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2056), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2058), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27386] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1621), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1623), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27440] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1625), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1627), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27494] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1633), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1635), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27548] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1637), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1639), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27602] = 4,
    ACTIONS(2749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2689), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [27658] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1641), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1643), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27712] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1649), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1651), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27766] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2112), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2114), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27820] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1653), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1655), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27874] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2120), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2122), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27928] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1657), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1659), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [27982] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2060), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2062), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28036] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1661), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1663), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28090] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1669), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1671), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28144] = 4,
    ACTIONS(2749), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2675), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2673), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [28200] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1695), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1697), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28254] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1699), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1701), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28308] = 4,
    ACTIONS(2805), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2803), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2801), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [28364] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1703), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1705), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28418] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1629), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1631), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28472] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1759), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1761), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28526] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1707), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1709), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28580] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1295), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1297), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28634] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1723), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1725), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28688] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1739), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1741), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28742] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1731), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1733), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28796] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1751), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1753), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28850] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1755), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1757), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28904] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1719), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1721), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [28958] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2092), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2094), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29012] = 4,
    ACTIONS(2811), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2809), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2807), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [29068] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1775), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1777), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29122] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2815), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2813), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [29176] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1783), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1785), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29230] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1787), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1789), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29284] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1665), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1667), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29338] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1683), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1685), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29392] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1791), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1793), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29446] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1795), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1797), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29500] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1687), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1689), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29554] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1691), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1693), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29608] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1807), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1809), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29662] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1811), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1813), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29716] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2819), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2817), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [29770] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1827), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1829), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29824] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1307), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1309), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29878] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1835), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1837), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29932] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1843), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1845), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [29986] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1847), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1849), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [30040] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1851), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1853), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [30094] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1715), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1717), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [30148] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1859), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1861), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [30202] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1727), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1729), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [30256] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1877), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1879), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [30310] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1747), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1749), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [30364] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1885), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1887), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [30418] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(401), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(399), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_else,
  [30472] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1893), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1895), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [30526] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1763), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1765), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [30580] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1901), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1903), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [30634] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1291), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1293), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [30688] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1679), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1681), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [30742] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1767), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1769), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [30796] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1925), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1927), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [30850] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1933), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1935), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [30904] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1937), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1939), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [30958] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1941), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1943), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [31012] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1945), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1947), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [31066] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1949), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1951), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [31120] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1953), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1955), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [31174] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1989), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1991), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [31228] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1997), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1999), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [31282] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2001), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2003), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [31336] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1361), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1363), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [31390] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1779), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1781), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [31444] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1855), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1857), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [31498] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1645), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1647), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [31552] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1613), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1615), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [31606] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1993), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1995), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [31660] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1509), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1511), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [31714] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1601), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1603), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [31768] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1415), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1417), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [31822] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2068), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2070), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [31876] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1545), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1547), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [31930] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1771), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1773), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [31984] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(419), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(417), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_else,
  [32038] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1609), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1611), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32092] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(455), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(457), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32146] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1463), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1465), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32200] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1439), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1441), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32254] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1743), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1745), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32308] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1589), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1591), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32362] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1487), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1489), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32416] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1577), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1579), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32470] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1799), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1801), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32524] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2823), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2821), 30,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [32578] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(443), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(445), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32632] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1553), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1555), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32686] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(459), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(461), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32740] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1889), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1891), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32794] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1525), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1527), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32848] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1299), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1301), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32902] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1303), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1305), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [32956] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2104), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2106), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33010] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2659), 17,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_EQ,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_LT_LT_EQ,
      anon_sym_DOT,
    ACTIONS(2657), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_LT2,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_GT_GT_EQ,
  [33064] = 5,
    ACTIONS(2631), 1,
      anon_sym_BANG,
    ACTIONS(2825), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(481), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(483), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33122] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1505), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1507), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33176] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1341), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1343), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33230] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1483), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1485), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33284] = 4,
    ACTIONS(2831), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2829), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2827), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33340] = 4,
    ACTIONS(2837), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2835), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2833), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33396] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2132), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2134), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33450] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2136), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2138), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33504] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1479), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1481), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33558] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1917), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1919), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33612] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1921), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1923), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33666] = 4,
    ACTIONS(2843), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2841), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2839), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33722] = 7,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2847), 14,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2845), 27,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33784] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2140), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(2142), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33838] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1427), 7,
      anon_sym_SEMI,
      anon_sym_macro_rules_BANG,
      anon_sym_RBRACE,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(1429), 38,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_impl,
      anon_sym_let,
      anon_sym_mod,
      anon_sym_pub,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [33892] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2851), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2849), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33945] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2725), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2723), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [33998] = 17,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(323), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(321), 20,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34079] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2875), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2873), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34132] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2879), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2877), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34185] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2883), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2881), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34238] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2887), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2885), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34291] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(449), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(447), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34344] = 19,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2891), 1,
      anon_sym_EQ,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2889), 18,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34429] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2899), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2897), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34482] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2903), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2901), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34535] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2907), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2905), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34588] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2911), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2909), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34641] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(465), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(463), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34694] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(437), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(435), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34747] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2915), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2913), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34800] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2917), 6,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34891] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2929), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2927), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34944] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2933), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2931), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [34997] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2937), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2935), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35050] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2941), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2939), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35103] = 19,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2945), 1,
      anon_sym_EQ,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2943), 18,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35188] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2949), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2947), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35241] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2953), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2951), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35294] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(433), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(431), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35347] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(457), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(455), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35400] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(509), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(507), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35453] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(499), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(497), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35506] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(517), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(515), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35559] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2957), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2955), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35612] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(529), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(527), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35665] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2961), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2959), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35718] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2965), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2963), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35771] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(445), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(443), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35824] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2675), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2673), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35877] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2969), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2967), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35930] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2973), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2971), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [35983] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2691), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2689), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36036] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2977), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2975), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36089] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(461), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(459), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36142] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(503), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(501), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36195] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2981), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2979), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36248] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2985), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2983), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36301] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2987), 6,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36392] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2408), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2410), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36445] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(495), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(493), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36498] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2991), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2989), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36551] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2879), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2877), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36604] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2995), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2993), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36657] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2376), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2378), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36710] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2999), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2997), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36763] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3003), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3001), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36816] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3007), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3005), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36869] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3011), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3009), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36922] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(453), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(451), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [36975] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3015), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3013), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37028] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3019), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3017), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37081] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3023), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3021), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37134] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3027), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3025), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37187] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(473), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(471), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37240] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3031), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3029), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37293] = 19,
    ACTIONS(299), 1,
      anon_sym_EQ,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(293), 18,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37378] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3035), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3033), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37431] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3039), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3037), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37484] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3043), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3041), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37537] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(525), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(523), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37590] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(533), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(531), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37643] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(487), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(485), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37696] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(537), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(535), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37749] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(521), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(519), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37802] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3047), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3045), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37855] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3051), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3049), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37908] = 4,
    ACTIONS(3053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(481), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(483), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [37963] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3057), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3055), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38016] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3061), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3059), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38069] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2372), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2374), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38122] = 8,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2741), 11,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2735), 26,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38185] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3065), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3063), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38238] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3069), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3067), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38291] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3073), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3071), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38344] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3077), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3075), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38397] = 19,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3081), 1,
      anon_sym_EQ,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3079), 18,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38482] = 13,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2741), 4,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 26,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38555] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3085), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3083), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38608] = 10,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2741), 7,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(2735), 26,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38675] = 17,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3089), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3087), 20,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38756] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(513), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(511), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38809] = 15,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2741), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2735), 22,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38886] = 16,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2741), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2735), 21,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [38965] = 12,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2741), 5,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
    ACTIONS(2735), 26,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39036] = 11,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2741), 6,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(2735), 26,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39105] = 9,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2741), 9,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2735), 26,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39170] = 19,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3093), 1,
      anon_sym_EQ,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3091), 18,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39255] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3097), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3095), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39308] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3101), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3099), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39361] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2713), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2709), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39414] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3105), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3103), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39467] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3109), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3107), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39520] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3113), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(3111), 29,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39573] = 4,
    ACTIONS(3115), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2725), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2723), 28,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39628] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3119), 12,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      sym_metavariable,
    ACTIONS(3117), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [39680] = 5,
    ACTIONS(3121), 1,
      anon_sym_POUND,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1055), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    ACTIONS(2506), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      sym_metavariable,
    ACTIONS(2504), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_pub,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [39736] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3126), 12,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      sym_metavariable,
    ACTIONS(3124), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [39788] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3130), 12,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      sym_metavariable,
    ACTIONS(3128), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [39840] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3134), 12,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      sym_metavariable,
    ACTIONS(3132), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [39892] = 7,
    ACTIONS(2653), 1,
      anon_sym_LBRACE,
    ACTIONS(2655), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3136), 1,
      anon_sym_BANG,
    STATE(957), 1,
      sym_field_initializer_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(481), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(483), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [39952] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3140), 12,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      sym_metavariable,
    ACTIONS(3138), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [40004] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3144), 12,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      sym_metavariable,
    ACTIONS(3142), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_unsafe,
      anon_sym_where,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [40056] = 20,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(3146), 1,
      sym_identifier,
    ACTIONS(3150), 1,
      anon_sym_LPAREN,
    ACTIONS(3152), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_for,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3160), 1,
      sym_metavariable,
    STATE(1655), 1,
      sym_scoped_type_identifier,
    STATE(1741), 1,
      sym_where_predicate,
    STATE(1865), 1,
      sym_generic_type,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    STATE(2357), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3148), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2110), 5,
      sym_higher_ranked_trait_bound,
      sym_lifetime,
      sym_tuple_type,
      sym_reference_type,
      sym_pointer_type,
    ACTIONS(3154), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [40141] = 20,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(3146), 1,
      sym_identifier,
    ACTIONS(3150), 1,
      anon_sym_LPAREN,
    ACTIONS(3152), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_for,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3160), 1,
      sym_metavariable,
    STATE(1655), 1,
      sym_scoped_type_identifier,
    STATE(1741), 1,
      sym_where_predicate,
    STATE(1865), 1,
      sym_generic_type,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    STATE(2357), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3162), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2110), 5,
      sym_higher_ranked_trait_bound,
      sym_lifetime,
      sym_tuple_type,
      sym_reference_type,
      sym_pointer_type,
    ACTIONS(3154), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [40226] = 25,
    ACTIONS(411), 1,
      anon_sym_RBRACK,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3164), 1,
      anon_sym_SEMI,
    ACTIONS(3166), 1,
      anon_sym_COMMA,
    STATE(969), 1,
      sym_arguments,
    STATE(1808), 1,
      aux_sym_array_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40321] = 25,
    ACTIONS(735), 1,
      anon_sym_RBRACK,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3168), 1,
      anon_sym_SEMI,
    ACTIONS(3170), 1,
      anon_sym_COMMA,
    STATE(969), 1,
      sym_arguments,
    STATE(1916), 1,
      aux_sym_array_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40416] = 6,
    ACTIONS(2631), 1,
      anon_sym_BANG,
    ACTIONS(3172), 1,
      anon_sym_COLON_COLON,
    STATE(957), 1,
      sym_field_initializer_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(481), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(483), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40472] = 20,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3160), 1,
      sym_metavariable,
    ACTIONS(3174), 1,
      sym_identifier,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1244), 1,
      sym_scoped_type_identifier,
    STATE(1272), 1,
      sym_generic_type,
    STATE(1314), 1,
      sym_function_type,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    STATE(2357), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    ACTIONS(3176), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [40556] = 4,
    ACTIONS(3182), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3180), 14,
      sym_raw_string_literal,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3178), 26,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_ref,
      anon_sym__,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [40608] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2979), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      sym_metavariable,
    ACTIONS(2981), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_mutable_specifier,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [40658] = 20,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(2460), 1,
      anon_sym_fn,
    ACTIONS(2466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3184), 1,
      sym_identifier,
    ACTIONS(3188), 1,
      sym_metavariable,
    STATE(718), 1,
      sym_scoped_type_identifier,
    STATE(838), 1,
      sym_generic_type,
    STATE(991), 1,
      sym_function_type,
    STATE(1206), 1,
      sym_for_lifetimes,
    STATE(2216), 1,
      sym_function_modifiers,
    STATE(2233), 1,
      sym_scoped_identifier,
    STATE(2304), 1,
      sym_bracketed_type,
    STATE(2305), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(2474), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    ACTIONS(3186), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [40742] = 20,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(2460), 1,
      anon_sym_fn,
    ACTIONS(2466), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3188), 1,
      sym_metavariable,
    ACTIONS(3190), 1,
      sym_identifier,
    STATE(710), 1,
      sym_scoped_type_identifier,
    STATE(848), 1,
      sym_generic_type,
    STATE(988), 1,
      sym_function_type,
    STATE(1206), 1,
      sym_for_lifetimes,
    STATE(2216), 1,
      sym_function_modifiers,
    STATE(2233), 1,
      sym_scoped_identifier,
    STATE(2304), 1,
      sym_bracketed_type,
    STATE(2305), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(2474), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    ACTIONS(3186), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [40826] = 4,
    ACTIONS(3196), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3194), 14,
      sym_raw_string_literal,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3192), 26,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_ref,
      anon_sym__,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [40878] = 5,
    ACTIONS(2825), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3136), 1,
      anon_sym_BANG,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(481), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(483), 24,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [40932] = 24,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3198), 1,
      anon_sym_RPAREN,
    ACTIONS(3200), 1,
      anon_sym_COMMA,
    STATE(969), 1,
      sym_arguments,
    STATE(1778), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41024] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1743), 10,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_POUND,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      sym_metavariable,
    ACTIONS(1745), 31,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_pub,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [41074] = 24,
    ACTIONS(475), 1,
      anon_sym_RPAREN,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3202), 1,
      anon_sym_COMMA,
    STATE(969), 1,
      sym_arguments,
    STATE(1785), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41166] = 20,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(667), 1,
      anon_sym_fn,
    ACTIONS(669), 1,
      anon_sym_for,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3160), 1,
      sym_metavariable,
    ACTIONS(3204), 1,
      sym_identifier,
    STATE(1205), 1,
      sym_for_lifetimes,
    STATE(1243), 1,
      sym_scoped_type_identifier,
    STATE(1281), 1,
      sym_generic_type,
    STATE(1297), 1,
      sym_function_type,
    STATE(2207), 1,
      sym_function_modifiers,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    STATE(2357), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    ACTIONS(3176), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [41250] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2661), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2663), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41299] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3194), 14,
      sym_raw_string_literal,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3192), 26,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_ref,
      anon_sym__,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [41348] = 23,
    ACTIONS(15), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(25), 1,
      sym_block,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41437] = 23,
    ACTIONS(267), 1,
      anon_sym_RBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3234), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41526] = 23,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(203), 1,
      sym_block,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41615] = 23,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    ACTIONS(3236), 1,
      anon_sym_LBRACE,
    STATE(239), 1,
      sym_match_block,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41704] = 23,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(238), 1,
      sym_block,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41793] = 4,
    ACTIONS(3238), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2725), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_as,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2723), 23,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41844] = 23,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3234), 1,
      anon_sym_SEMI,
    ACTIONS(3240), 1,
      anon_sym_RBRACE,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [41933] = 23,
    ACTIONS(15), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(38), 1,
      sym_block,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42022] = 23,
    ACTIONS(15), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(52), 1,
      sym_block,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42111] = 23,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(229), 1,
      sym_block,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42200] = 23,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(234), 1,
      sym_block,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42289] = 23,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(205), 1,
      sym_block,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42378] = 23,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(232), 1,
      sym_block,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42467] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2681), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2683), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42516] = 23,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(227), 1,
      sym_block,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42605] = 5,
    ACTIONS(2631), 1,
      anon_sym_BANG,
    ACTIONS(3242), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(481), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(483), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42658] = 23,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(224), 1,
      sym_block,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42747] = 23,
    ACTIONS(263), 1,
      anon_sym_RBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3234), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42836] = 23,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3234), 1,
      anon_sym_SEMI,
    ACTIONS(3244), 1,
      anon_sym_RBRACE,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [42925] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3246), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43012] = 23,
    ACTIONS(15), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(49), 1,
      sym_block,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43101] = 23,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    STATE(980), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43190] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3248), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43277] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3250), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43364] = 23,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    STATE(1008), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43453] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3252), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43540] = 23,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    STATE(981), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43629] = 16,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(91), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3254), 1,
      sym_identifier,
    ACTIONS(3256), 1,
      anon_sym_RPAREN,
    ACTIONS(3260), 1,
      anon_sym_COMMA,
    ACTIONS(3266), 1,
      sym_metavariable,
    STATE(1473), 1,
      sym_scoped_identifier,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    STATE(2291), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(93), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3264), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3262), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1852), 4,
      sym_meta_item,
      sym__literal,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(3258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [43704] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3268), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43791] = 23,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3234), 1,
      anon_sym_SEMI,
    ACTIONS(3270), 1,
      anon_sym_RBRACE,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43880] = 23,
    ACTIONS(15), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(57), 1,
      sym_block,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [43969] = 23,
    ACTIONS(287), 1,
      anon_sym_RBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3234), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44058] = 23,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3272), 1,
      anon_sym_RPAREN,
    ACTIONS(3274), 1,
      anon_sym_COMMA,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44147] = 23,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3234), 1,
      anon_sym_SEMI,
    ACTIONS(3276), 1,
      anon_sym_RBRACE,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44236] = 23,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3278), 1,
      anon_sym_RPAREN,
    ACTIONS(3280), 1,
      anon_sym_COMMA,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44325] = 23,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    ACTIONS(3282), 1,
      anon_sym_LBRACE,
    STATE(54), 1,
      sym_match_block,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44414] = 23,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    ACTIONS(3284), 1,
      anon_sym_LBRACE,
    STATE(969), 1,
      sym_arguments,
    STATE(982), 1,
      sym_match_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44503] = 23,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3286), 1,
      anon_sym_RBRACE,
    ACTIONS(3288), 1,
      anon_sym_COMMA,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44592] = 23,
    ACTIONS(283), 1,
      anon_sym_RBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3234), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44681] = 23,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3290), 1,
      anon_sym_RBRACE,
    ACTIONS(3292), 1,
      anon_sym_COMMA,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44770] = 23,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    STATE(1022), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44859] = 23,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    STATE(984), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44948] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2649), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2651), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [44997] = 23,
    ACTIONS(545), 1,
      anon_sym_RPAREN,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3280), 1,
      anon_sym_COMMA,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45086] = 23,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(724), 1,
      sym_block,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45175] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3294), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45262] = 23,
    ACTIONS(107), 1,
      anon_sym_RBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3234), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45351] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3296), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45438] = 23,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3234), 1,
      anon_sym_SEMI,
    ACTIONS(3298), 1,
      anon_sym_RBRACE,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45527] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3300), 2,
      anon_sym_RBRACK,
      anon_sym_COMMA,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45614] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3302), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45701] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2669), 16,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_BANG,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2671), 24,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45750] = 23,
    ACTIONS(15), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(33), 1,
      sym_block,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45839] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3304), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [45926] = 23,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    STATE(978), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46015] = 19,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(3146), 1,
      sym_identifier,
    ACTIONS(3150), 1,
      anon_sym_LPAREN,
    ACTIONS(3152), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_for,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3160), 1,
      sym_metavariable,
    STATE(1655), 1,
      sym_scoped_type_identifier,
    STATE(1741), 1,
      sym_where_predicate,
    STATE(1865), 1,
      sym_generic_type,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    STATE(2357), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2110), 5,
      sym_higher_ranked_trait_bound,
      sym_lifetime,
      sym_tuple_type,
      sym_reference_type,
      sym_pointer_type,
    ACTIONS(3154), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [46096] = 23,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(721), 1,
      sym_block,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46185] = 23,
    ACTIONS(641), 1,
      anon_sym_RPAREN,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3280), 1,
      anon_sym_COMMA,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46274] = 23,
    ACTIONS(15), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(59), 1,
      sym_block,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46363] = 23,
    ACTIONS(15), 1,
      anon_sym_LBRACE,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(26), 1,
      sym_block,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46452] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3180), 14,
      sym_raw_string_literal,
      sym_float_literal,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_POUND,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      sym_integer_literal,
      aux_sym_string_literal_token1,
      sym_char_literal,
      sym_metavariable,
    ACTIONS(3178), 26,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_ref,
      anon_sym__,
      sym_mutable_specifier,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [46501] = 19,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(3146), 1,
      sym_identifier,
    ACTIONS(3150), 1,
      anon_sym_LPAREN,
    ACTIONS(3152), 1,
      anon_sym_STAR,
    ACTIONS(3156), 1,
      anon_sym_for,
    ACTIONS(3158), 1,
      anon_sym_AMP,
    ACTIONS(3160), 1,
      sym_metavariable,
    STATE(1651), 1,
      sym_where_predicate,
    STATE(1655), 1,
      sym_scoped_type_identifier,
    STATE(1865), 1,
      sym_generic_type,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    STATE(2357), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2110), 5,
      sym_higher_ranked_trait_bound,
      sym_lifetime,
      sym_tuple_type,
      sym_reference_type,
      sym_pointer_type,
    ACTIONS(3154), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [46582] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3306), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46668] = 19,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(3081), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3079), 13,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [46748] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3310), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      sym_metavariable,
    ACTIONS(3308), 30,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [46796] = 15,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3312), 1,
      sym_identifier,
    ACTIONS(3320), 1,
      sym_metavariable,
    STATE(1336), 1,
      sym_scoped_identifier,
    STATE(2210), 1,
      sym_bracketed_type,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3318), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3316), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1358), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(3314), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [46868] = 4,
    ACTIONS(3324), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3326), 8,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      sym_metavariable,
    ACTIONS(3322), 30,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [46918] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3328), 1,
      anon_sym_RBRACK,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47004] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3332), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      sym_metavariable,
    ACTIONS(3330), 30,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [47052] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3334), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47138] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3336), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47224] = 15,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(699), 1,
      anon_sym_DASH,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3338), 1,
      sym_identifier,
    ACTIONS(3346), 1,
      sym_metavariable,
    STATE(1316), 1,
      sym_scoped_identifier,
    STATE(2210), 1,
      sym_bracketed_type,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(705), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3344), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3342), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(1347), 4,
      sym__literal_pattern,
      sym_negative_literal,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(3340), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [47296] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3348), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47382] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3350), 1,
      anon_sym_COMMA,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47468] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3352), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47554] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3354), 1,
      anon_sym_RBRACK,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47640] = 19,
    ACTIONS(299), 1,
      anon_sym_EQ,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(293), 13,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47720] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3356), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47806] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3358), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47892] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3360), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [47978] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3364), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      sym_metavariable,
    ACTIONS(3362), 30,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [48026] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3130), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      sym_metavariable,
    ACTIONS(3128), 30,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [48074] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2917), 1,
      anon_sym_LBRACE,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48160] = 4,
    ACTIONS(3366), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(481), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(483), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48210] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3368), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48296] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3134), 9,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      anon_sym_AMP,
      sym_metavariable,
    ACTIONS(3132), 30,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [48344] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3370), 1,
      anon_sym_EQ_GT,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48430] = 4,
    ACTIONS(3372), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2725), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2723), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48480] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3374), 1,
      anon_sym_COMMA,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48566] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3376), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48652] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3378), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48738] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3280), 1,
      anon_sym_COMMA,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48824] = 15,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(91), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3254), 1,
      sym_identifier,
    ACTIONS(3266), 1,
      sym_metavariable,
    ACTIONS(3380), 1,
      anon_sym_RPAREN,
    STATE(1473), 1,
      sym_scoped_identifier,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    STATE(2291), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(93), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3264), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3382), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(2036), 4,
      sym_meta_item,
      sym__literal,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(3258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [48896] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3384), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [48982] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3386), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49068] = 19,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2945), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2943), 13,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49148] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3388), 1,
      anon_sym_RBRACK,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49234] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3390), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49320] = 19,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2891), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2889), 13,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49400] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3234), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49486] = 15,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(91), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3254), 1,
      sym_identifier,
    ACTIONS(3266), 1,
      sym_metavariable,
    ACTIONS(3392), 1,
      anon_sym_RPAREN,
    STATE(1473), 1,
      sym_scoped_identifier,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    STATE(2291), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(93), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3264), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3382), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(2036), 4,
      sym_meta_item,
      sym__literal,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(3258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [49558] = 4,
    ACTIONS(3394), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3326), 8,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_LT,
      anon_sym_AMP,
      sym_metavariable,
    ACTIONS(3322), 30,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_for,
      anon_sym_impl,
      anon_sym_unsafe,
      anon_sym_extern,
      anon_sym_dyn,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [49608] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3396), 1,
      anon_sym_RBRACK,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49694] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2987), 1,
      anon_sym_LBRACE,
    ACTIONS(3210), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3232), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49780] = 17,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(323), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(321), 15,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49856] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3398), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49942] = 4,
    ACTIONS(2711), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2713), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2709), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [49992] = 4,
    ACTIONS(2769), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2713), 15,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_DOT,
    ACTIONS(2709), 23,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50042] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3400), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50128] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3402), 1,
      anon_sym_COMMA,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50214] = 8,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2741), 11,
      anon_sym_PLUS,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_DASH,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2735), 21,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50272] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3404), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50358] = 13,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2741), 4,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT_DOT,
    ACTIONS(2735), 21,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50426] = 10,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2741), 7,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(2735), 21,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50488] = 19,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(3093), 1,
      anon_sym_EQ,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3218), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3216), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3091), 13,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50568] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3406), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50654] = 17,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3222), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3089), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(3087), 15,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50730] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3408), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50816] = 15,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2741), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2735), 17,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50888] = 16,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3220), 1,
      anon_sym_AMP_AMP,
    ACTIONS(3224), 1,
      anon_sym_PIPE,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2741), 2,
      anon_sym_EQ,
      anon_sym_DOT_DOT,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3212), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3228), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2735), 16,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE_PIPE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [50962] = 12,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    ACTIONS(3226), 1,
      anon_sym_CARET,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2741), 5,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
    ACTIONS(2735), 21,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51028] = 11,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(3214), 1,
      anon_sym_AMP,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3230), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2741), 6,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_CARET,
    ACTIONS(2735), 21,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51092] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3410), 1,
      anon_sym_RBRACK,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51178] = 22,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    ACTIONS(2859), 1,
      anon_sym_AMP,
    ACTIONS(2861), 1,
      anon_sym_AMP_AMP,
    ACTIONS(2863), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(2865), 1,
      anon_sym_PIPE,
    ACTIONS(2867), 1,
      anon_sym_CARET,
    ACTIONS(2895), 1,
      anon_sym_DOT_DOT,
    ACTIONS(2919), 1,
      anon_sym_QMARK,
    ACTIONS(2921), 1,
      anon_sym_as,
    ACTIONS(2923), 1,
      anon_sym_EQ,
    ACTIONS(3412), 1,
      anon_sym_SEMI,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2853), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(2857), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(2871), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2893), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2855), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2869), 4,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
    ACTIONS(2925), 10,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51264] = 9,
    ACTIONS(2737), 1,
      anon_sym_LPAREN,
    ACTIONS(2739), 1,
      anon_sym_LBRACK,
    ACTIONS(2743), 1,
      anon_sym_DOT,
    STATE(969), 1,
      sym_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3206), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(3208), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(2741), 9,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      anon_sym_DOT_DOT,
      anon_sym_PIPE,
      anon_sym_CARET,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(2735), 21,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_as,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_LT_EQ,
      anon_sym_GT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_CARET_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
  [51324] = 17,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3160), 1,
      sym_metavariable,
    ACTIONS(3414), 1,
      sym_identifier,
    ACTIONS(3416), 1,
      anon_sym_fn,
    STATE(1719), 1,
      sym_scoped_type_identifier,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2357), 1,
      sym_scoped_identifier,
    STATE(2390), 1,
      sym_function_modifiers,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    ACTIONS(3176), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [51399] = 17,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(681), 1,
      anon_sym_extern,
    ACTIONS(1095), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3160), 1,
      sym_metavariable,
    ACTIONS(3418), 1,
      sym_identifier,
    ACTIONS(3420), 1,
      anon_sym_fn,
    STATE(1674), 1,
      sym_scoped_type_identifier,
    STATE(2213), 1,
      sym_bracketed_type,
    STATE(2214), 1,
      sym_generic_type_with_turbofish,
    STATE(2235), 1,
      sym_function_modifiers,
    STATE(2255), 1,
      sym_generic_type,
    STATE(2357), 1,
      sym_scoped_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1440), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(1101), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(663), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
    ACTIONS(3176), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [51474] = 14,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(91), 1,
      aux_sym_string_literal_token1,
    ACTIONS(1267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3254), 1,
      sym_identifier,
    ACTIONS(3266), 1,
      sym_metavariable,
    STATE(1473), 1,
      sym_scoped_identifier,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    STATE(2291), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(93), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(3264), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3382), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
    STATE(2036), 4,
      sym_meta_item,
      sym__literal,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(3258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [51543] = 15,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(3422), 1,
      sym_identifier,
    ACTIONS(3424), 1,
      anon_sym_LBRACE,
    ACTIONS(3426), 1,
      anon_sym_RBRACE,
    ACTIONS(3428), 1,
      anon_sym_STAR,
    ACTIONS(3432), 1,
      anon_sym_COMMA,
    ACTIONS(3434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3438), 1,
      sym_metavariable,
    STATE(1610), 1,
      sym_scoped_identifier,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    STATE(2291), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3436), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(1743), 5,
      sym__use_clause,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(3430), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [51612] = 14,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(3422), 1,
      sym_identifier,
    ACTIONS(3424), 1,
      anon_sym_LBRACE,
    ACTIONS(3428), 1,
      anon_sym_STAR,
    ACTIONS(3434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3438), 1,
      sym_metavariable,
    ACTIONS(3440), 1,
      anon_sym_RBRACE,
    STATE(1610), 1,
      sym_scoped_identifier,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    STATE(2291), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3436), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2116), 5,
      sym__use_clause,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(3430), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [51678] = 14,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(3422), 1,
      sym_identifier,
    ACTIONS(3424), 1,
      anon_sym_LBRACE,
    ACTIONS(3428), 1,
      anon_sym_STAR,
    ACTIONS(3434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3438), 1,
      sym_metavariable,
    ACTIONS(3442), 1,
      anon_sym_RBRACE,
    STATE(1610), 1,
      sym_scoped_identifier,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    STATE(2291), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3436), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2116), 5,
      sym__use_clause,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(3430), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [51744] = 13,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(3422), 1,
      sym_identifier,
    ACTIONS(3424), 1,
      anon_sym_LBRACE,
    ACTIONS(3428), 1,
      anon_sym_STAR,
    ACTIONS(3434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3438), 1,
      sym_metavariable,
    STATE(1610), 1,
      sym_scoped_identifier,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    STATE(2291), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3436), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2307), 5,
      sym__use_clause,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(3430), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [51807] = 13,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(3422), 1,
      sym_identifier,
    ACTIONS(3424), 1,
      anon_sym_LBRACE,
    ACTIONS(3428), 1,
      anon_sym_STAR,
    ACTIONS(3434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3438), 1,
      sym_metavariable,
    STATE(1610), 1,
      sym_scoped_identifier,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    STATE(2291), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3436), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2174), 5,
      sym__use_clause,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(3430), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [51870] = 13,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(3422), 1,
      sym_identifier,
    ACTIONS(3424), 1,
      anon_sym_LBRACE,
    ACTIONS(3428), 1,
      anon_sym_STAR,
    ACTIONS(3434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3438), 1,
      sym_metavariable,
    STATE(1610), 1,
      sym_scoped_identifier,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    STATE(2291), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3436), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2116), 5,
      sym__use_clause,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(3430), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [51933] = 13,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(3422), 1,
      sym_identifier,
    ACTIONS(3424), 1,
      anon_sym_LBRACE,
    ACTIONS(3428), 1,
      anon_sym_STAR,
    ACTIONS(3434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3438), 1,
      sym_metavariable,
    STATE(1610), 1,
      sym_scoped_identifier,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    STATE(2291), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3436), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2164), 5,
      sym__use_clause,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(3430), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [51996] = 13,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(3422), 1,
      sym_identifier,
    ACTIONS(3424), 1,
      anon_sym_LBRACE,
    ACTIONS(3428), 1,
      anon_sym_STAR,
    ACTIONS(3434), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3438), 1,
      sym_metavariable,
    STATE(1610), 1,
      sym_scoped_identifier,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    STATE(2291), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3436), 3,
      sym_self,
      sym_super,
      sym_crate,
    STATE(2171), 5,
      sym__use_clause,
      sym_scoped_use_list,
      sym_use_list,
      sym_use_as_clause,
      sym_use_wildcard,
    ACTIONS(3430), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [52059] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3446), 3,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(3444), 27,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [52098] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3450), 3,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(3448), 27,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [52137] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3454), 3,
      anon_sym_LT,
      anon_sym_COLON_COLON,
      sym_metavariable,
    ACTIONS(3452), 27,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
      sym_identifier,
      sym_self,
      sym_super,
      sym_crate,
  [52176] = 11,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(1267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3254), 1,
      sym_identifier,
    ACTIONS(3266), 1,
      sym_metavariable,
    STATE(1473), 1,
      sym_scoped_identifier,
    STATE(2192), 1,
      sym_meta_item,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    STATE(2291), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3264), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [52229] = 11,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(1267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3254), 1,
      sym_identifier,
    ACTIONS(3266), 1,
      sym_metavariable,
    STATE(1473), 1,
      sym_scoped_identifier,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    STATE(2291), 1,
      sym_bracketed_type,
    STATE(2389), 1,
      sym_meta_item,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3264), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [52282] = 11,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(1267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3254), 1,
      sym_identifier,
    ACTIONS(3266), 1,
      sym_metavariable,
    STATE(1473), 1,
      sym_scoped_identifier,
    STATE(2180), 1,
      sym_meta_item,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    STATE(2291), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3264), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [52335] = 11,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(1267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3254), 1,
      sym_identifier,
    ACTIONS(3266), 1,
      sym_metavariable,
    STATE(1473), 1,
      sym_scoped_identifier,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    STATE(2291), 1,
      sym_bracketed_type,
    STATE(2300), 1,
      sym_meta_item,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3264), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [52388] = 11,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(1267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3254), 1,
      sym_identifier,
    ACTIONS(3266), 1,
      sym_metavariable,
    STATE(1473), 1,
      sym_scoped_identifier,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    STATE(2291), 1,
      sym_bracketed_type,
    STATE(2378), 1,
      sym_meta_item,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3264), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [52441] = 11,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(1267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3254), 1,
      sym_identifier,
    ACTIONS(3266), 1,
      sym_metavariable,
    STATE(1473), 1,
      sym_scoped_identifier,
    STATE(2229), 1,
      sym_meta_item,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    STATE(2291), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3264), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [52494] = 11,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(1267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3254), 1,
      sym_identifier,
    ACTIONS(3266), 1,
      sym_metavariable,
    STATE(1473), 1,
      sym_scoped_identifier,
    STATE(2248), 1,
      sym_meta_item,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    STATE(2291), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3264), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3258), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [52547] = 10,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(1267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3456), 1,
      sym_identifier,
    ACTIONS(3462), 1,
      sym_metavariable,
    STATE(2013), 1,
      sym_scoped_identifier,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    STATE(2291), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3460), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3458), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [52597] = 10,
    ACTIONS(77), 1,
      anon_sym_LT,
    ACTIONS(1267), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3464), 1,
      sym_identifier,
    ACTIONS(3470), 1,
      sym_metavariable,
    STATE(1992), 1,
      sym_scoped_identifier,
    STATE(2275), 1,
      sym_generic_type_with_turbofish,
    STATE(2291), 1,
      sym_bracketed_type,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3468), 3,
      sym_self,
      sym_super,
      sym_crate,
    ACTIONS(3466), 17,
      anon_sym_u8,
      anon_sym_i8,
      anon_sym_u16,
      anon_sym_i16,
      anon_sym_u32,
      anon_sym_i32,
      anon_sym_u64,
      anon_sym_i64,
      anon_sym_u128,
      anon_sym_i128,
      anon_sym_isize,
      anon_sym_usize,
      anon_sym_f32,
      anon_sym_f64,
      anon_sym_bool,
      anon_sym_str,
      anon_sym_char,
  [52647] = 3,
    ACTIONS(2408), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2410), 20,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_unsafe,
      anon_sym_COMMA,
      anon_sym_extern,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE,
  [52677] = 3,
    ACTIONS(2376), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2378), 20,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_if,
      anon_sym_unsafe,
      anon_sym_COMMA,
      anon_sym_extern,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE,
  [52707] = 10,
    ACTIONS(3474), 1,
      anon_sym_LPAREN,
    ACTIONS(3476), 1,
      anon_sym_LBRACE,
    ACTIONS(3480), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3486), 1,
      anon_sym_AT,
    STATE(1265), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3478), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3472), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [52749] = 9,
    ACTIONS(2629), 1,
      anon_sym_COLON,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3490), 1,
      anon_sym_BANG,
    ACTIONS(3492), 1,
      anon_sym_COLON_COLON,
    STATE(1265), 1,
      sym_type_arguments,
    STATE(1268), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2625), 12,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [52789] = 8,
    ACTIONS(2643), 1,
      anon_sym_COLON,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3492), 1,
      anon_sym_COLON_COLON,
    STATE(1265), 1,
      sym_type_arguments,
    STATE(1268), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2641), 12,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [52826] = 4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2645), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    ACTIONS(2649), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(2651), 14,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_BANG,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE,
  [52855] = 4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2665), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    ACTIONS(2669), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(2671), 14,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_BANG,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE,
  [52884] = 4,
    ACTIONS(2667), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2671), 2,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
    ACTIONS(2665), 15,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LT2,
      anon_sym_PIPE,
  [52913] = 4,
    ACTIONS(2679), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2683), 2,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
    ACTIONS(2677), 15,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LT2,
      anon_sym_PIPE,
  [52942] = 8,
    ACTIONS(2639), 1,
      anon_sym_COLON,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3492), 1,
      anon_sym_COLON_COLON,
    STATE(1265), 1,
      sym_type_arguments,
    STATE(1268), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2637), 12,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [52979] = 4,
    ACTIONS(2659), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2663), 2,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
    ACTIONS(2657), 15,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LT2,
      anon_sym_PIPE,
  [53008] = 4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2657), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    ACTIONS(2661), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(2663), 14,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_BANG,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE,
  [53037] = 4,
    ACTIONS(2647), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2651), 2,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
    ACTIONS(2645), 15,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LT2,
      anon_sym_PIPE,
  [53066] = 4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2677), 2,
      anon_sym_LBRACE,
      anon_sym_LT2,
    ACTIONS(2681), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(2683), 14,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_BANG,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE,
  [53095] = 6,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    STATE(1255), 1,
      sym_type_arguments,
    STATE(1283), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2685), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [53127] = 6,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    STATE(1255), 1,
      sym_type_arguments,
    STATE(1283), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2689), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [53159] = 6,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    STATE(1255), 1,
      sym_type_arguments,
    STATE(1283), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2673), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [53191] = 17,
    ACTIONS(3496), 1,
      anon_sym_const,
    ACTIONS(3498), 1,
      anon_sym_enum,
    ACTIONS(3500), 1,
      anon_sym_fn,
    ACTIONS(3502), 1,
      anon_sym_mod,
    ACTIONS(3504), 1,
      anon_sym_static,
    ACTIONS(3506), 1,
      anon_sym_struct,
    ACTIONS(3508), 1,
      anon_sym_trait,
    ACTIONS(3510), 1,
      anon_sym_type,
    ACTIONS(3512), 1,
      anon_sym_union,
    ACTIONS(3514), 1,
      anon_sym_unsafe,
    ACTIONS(3516), 1,
      anon_sym_use,
    ACTIONS(3518), 1,
      anon_sym_extern,
    STATE(1399), 1,
      sym_extern_modifier,
    STATE(1440), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2381), 1,
      sym_function_modifiers,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3494), 2,
      anon_sym_async,
      anon_sym_default,
  [53245] = 17,
    ACTIONS(3520), 1,
      anon_sym_const,
    ACTIONS(3522), 1,
      anon_sym_enum,
    ACTIONS(3524), 1,
      anon_sym_fn,
    ACTIONS(3526), 1,
      anon_sym_mod,
    ACTIONS(3528), 1,
      anon_sym_static,
    ACTIONS(3530), 1,
      anon_sym_struct,
    ACTIONS(3532), 1,
      anon_sym_trait,
    ACTIONS(3534), 1,
      anon_sym_type,
    ACTIONS(3536), 1,
      anon_sym_union,
    ACTIONS(3538), 1,
      anon_sym_unsafe,
    ACTIONS(3540), 1,
      anon_sym_use,
    ACTIONS(3542), 1,
      anon_sym_extern,
    STATE(1400), 1,
      sym_extern_modifier,
    STATE(1440), 1,
      aux_sym_function_modifiers_repeat1,
    STATE(2303), 1,
      sym_function_modifiers,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3494), 2,
      anon_sym_async,
      anon_sym_default,
  [53299] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2657), 16,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LT2,
      anon_sym_PIPE,
  [53322] = 3,
    ACTIONS(3544), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3322), 15,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
  [53347] = 3,
    ACTIONS(2819), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2817), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [53371] = 3,
    ACTIONS(3546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3326), 14,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
  [53395] = 13,
    ACTIONS(3472), 1,
      anon_sym_PIPE,
    ACTIONS(3476), 1,
      anon_sym_LBRACE,
    ACTIONS(3478), 1,
      anon_sym_COLON,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3486), 1,
      anon_sym_AT,
    ACTIONS(3490), 1,
      anon_sym_BANG,
    ACTIONS(3548), 1,
      anon_sym_LPAREN,
    ACTIONS(3550), 1,
      anon_sym_COLON_COLON,
    STATE(1265), 1,
      sym_type_arguments,
    STATE(1268), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2625), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [53439] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2649), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(2651), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_BANG,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_in,
      anon_sym_PIPE,
  [53463] = 6,
    ACTIONS(3474), 1,
      anon_sym_LPAREN,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3478), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3472), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [53493] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2979), 15,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      sym_mutable_specifier,
      anon_sym_PIPE,
      sym_self,
  [53515] = 3,
    ACTIONS(2781), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2779), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [53539] = 13,
    ACTIONS(3476), 1,
      anon_sym_LBRACE,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3486), 1,
      anon_sym_AT,
    ACTIONS(3490), 1,
      anon_sym_BANG,
    ACTIONS(3554), 1,
      anon_sym_LPAREN,
    ACTIONS(3556), 1,
      anon_sym_RBRACK,
    ACTIONS(3559), 1,
      anon_sym_COLON_COLON,
    STATE(1265), 1,
      sym_type_arguments,
    STATE(1268), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2625), 2,
      anon_sym_SEMI,
      anon_sym_PLUS,
    ACTIONS(3472), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [53583] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3362), 15,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
  [53605] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2669), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(2671), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_BANG,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_in,
      anon_sym_PIPE,
  [53629] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2681), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(2683), 13,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_as,
      anon_sym_if,
      anon_sym_BANG,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_in,
      anon_sym_PIPE,
  [53653] = 3,
    ACTIONS(2747), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2745), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [53677] = 3,
    ACTIONS(3053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3326), 14,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
  [53701] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3330), 15,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
  [53723] = 14,
    ACTIONS(2625), 1,
      anon_sym_PLUS,
    ACTIONS(3472), 1,
      anon_sym_PIPE,
    ACTIONS(3476), 1,
      anon_sym_LBRACE,
    ACTIONS(3478), 1,
      anon_sym_COLON,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3486), 1,
      anon_sym_AT,
    ACTIONS(3490), 1,
      anon_sym_BANG,
    ACTIONS(3561), 1,
      anon_sym_LPAREN,
    ACTIONS(3563), 1,
      anon_sym_COLON_COLON,
    STATE(1265), 1,
      sym_type_arguments,
    STATE(1268), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3556), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [53769] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3308), 15,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_enum,
      anon_sym_fn,
      anon_sym_mod,
      anon_sym_static,
      anon_sym_struct,
      anon_sym_trait,
      anon_sym_type,
      anon_sym_union,
      anon_sym_unsafe,
      anon_sym_use,
      anon_sym_extern,
      sym_identifier,
  [53791] = 3,
    ACTIONS(2777), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2775), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [53815] = 3,
    ACTIONS(2793), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2791), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_for,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_COLON_COLON,
      anon_sym_PIPE,
  [53839] = 5,
    ACTIONS(3569), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3567), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(3571), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3565), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [53866] = 3,
    ACTIONS(3573), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2801), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [53889] = 4,
    ACTIONS(2757), 1,
      anon_sym_COLON,
    ACTIONS(3575), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2755), 12,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [53914] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2813), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_PIPE,
  [53935] = 4,
    ACTIONS(3579), 1,
      anon_sym_pat,
    STATE(501), 1,
      sym_fragment_specifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3577), 12,
      anon_sym_block,
      anon_sym_expr,
      anon_sym_ident,
      anon_sym_item,
      anon_sym_lifetime,
      anon_sym_literal,
      anon_sym_meta,
      anon_sym_path,
      anon_sym_stmt,
      anon_sym_tt,
      anon_sym_ty,
      anon_sym_vis,
  [53960] = 4,
    ACTIONS(2675), 1,
      anon_sym_COLON,
    ACTIONS(3581), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2673), 12,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [53985] = 4,
    ACTIONS(2687), 1,
      anon_sym_COLON,
    ACTIONS(3394), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2685), 12,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54010] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2761), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_PIPE,
  [54031] = 3,
    ACTIONS(3583), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2729), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54054] = 4,
    ACTIONS(2687), 1,
      anon_sym_COLON,
    ACTIONS(3581), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2685), 12,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54079] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2821), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_PIPE,
  [54100] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2771), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_PIPE,
  [54121] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2787), 14,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
      anon_sym_GT,
      anon_sym_PIPE,
  [54142] = 14,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3490), 1,
      anon_sym_BANG,
    ACTIONS(3492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3585), 1,
      anon_sym_COLON,
    ACTIONS(3587), 1,
      anon_sym_EQ,
    ACTIONS(3589), 1,
      anon_sym_COMMA,
    ACTIONS(3591), 1,
      anon_sym_GT,
    STATE(1265), 1,
      sym_type_arguments,
    STATE(1268), 1,
      sym_parameters,
    STATE(1811), 1,
      sym_trait_bounds,
    STATE(1814), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2625), 2,
      anon_sym_PLUS,
      anon_sym_as,
  [54187] = 4,
    ACTIONS(2691), 1,
      anon_sym_COLON,
    ACTIONS(3581), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2689), 12,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54212] = 3,
    ACTIONS(3593), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2839), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54235] = 3,
    ACTIONS(3595), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2807), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54258] = 3,
    ACTIONS(3597), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2795), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54281] = 3,
    ACTIONS(3599), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2833), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54304] = 3,
    ACTIONS(3601), 1,
      anon_sym_DASH_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2827), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54327] = 3,
    ACTIONS(2372), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2374), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE,
  [54350] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2955), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54370] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3049), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54390] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(455), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54410] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2901), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54430] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2661), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(2663), 11,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_BANG,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_in,
      anon_sym_PIPE,
  [54452] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3055), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54472] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2993), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54492] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3041), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54512] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2885), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54532] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2689), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54552] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2967), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54572] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3107), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54592] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3103), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54612] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(443), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54632] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(459), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54652] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2975), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54672] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2881), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54692] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2971), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54712] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3111), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54732] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2877), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54752] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2877), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54772] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3083), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54792] = 3,
    ACTIONS(3605), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3603), 12,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_DOT_DOT_DOT,
      anon_sym_in,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE,
  [54814] = 4,
    ACTIONS(3478), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3472), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [54838] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2983), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54858] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3071), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54878] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2673), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54898] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3045), 13,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_PLUS,
      anon_sym_as,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_PIPE,
  [54918] = 4,
    ACTIONS(3611), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3609), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(3607), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [54941] = 10,
    ACTIONS(3474), 1,
      anon_sym_LPAREN,
    ACTIONS(3476), 1,
      anon_sym_LBRACE,
    ACTIONS(3480), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3486), 1,
      anon_sym_AT,
    ACTIONS(3613), 1,
      anon_sym_BANG,
    STATE(1265), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3472), 3,
      anon_sym_EQ_GT,
      anon_sym_if,
      anon_sym_PIPE,
  [54976] = 5,
    ACTIONS(2681), 1,
      anon_sym_COLON,
    ACTIONS(3615), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2677), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_LT2,
    ACTIONS(2683), 5,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE,
  [55001] = 5,
    ACTIONS(2669), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2665), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(3618), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2671), 5,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE,
  [55026] = 5,
    ACTIONS(2649), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2645), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(3621), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2651), 5,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE,
  [55051] = 5,
    ACTIONS(2661), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2657), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(3624), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2663), 5,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE,
  [55076] = 5,
    ACTIONS(2681), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2677), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(3615), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    ACTIONS(2683), 5,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE,
  [55101] = 4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3618), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    ACTIONS(2665), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(2671), 6,
      anon_sym_BANG,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE,
  [55124] = 4,
    ACTIONS(3546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3609), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(3607), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55147] = 4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3621), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    ACTIONS(2645), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(2651), 6,
      anon_sym_BANG,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE,
  [55170] = 4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3624), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    ACTIONS(2657), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(2663), 6,
      anon_sym_BANG,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE,
  [55193] = 5,
    ACTIONS(2661), 1,
      anon_sym_COLON,
    ACTIONS(3624), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2657), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_LT2,
    ACTIONS(2663), 5,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE,
  [55218] = 5,
    ACTIONS(2649), 1,
      anon_sym_COLON,
    ACTIONS(3621), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2645), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_LT2,
    ACTIONS(2651), 5,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE,
  [55243] = 4,
    ACTIONS(3627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3609), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(3607), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55266] = 4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3615), 2,
      anon_sym_LPAREN,
      anon_sym_RBRACK,
    ACTIONS(2677), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_LT2,
    ACTIONS(2683), 6,
      anon_sym_BANG,
      anon_sym_COMMA,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE,
  [55289] = 5,
    ACTIONS(2669), 1,
      anon_sym_COLON,
    ACTIONS(3618), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2665), 5,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_LT2,
    ACTIONS(2671), 5,
      anon_sym_BANG,
      anon_sym_COLON_COLON,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
      anon_sym_PIPE,
  [55314] = 4,
    ACTIONS(3633), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3631), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(3629), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55337] = 4,
    ACTIONS(3627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3637), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(3635), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55360] = 4,
    ACTIONS(3633), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3641), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(3639), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55383] = 4,
    ACTIONS(3546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3637), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(3635), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55406] = 4,
    ACTIONS(3611), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3637), 2,
      anon_sym_COLON,
      anon_sym_EQ,
    ACTIONS(3635), 9,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55429] = 3,
    ACTIONS(3645), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3643), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55449] = 3,
    ACTIONS(3649), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3647), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55469] = 3,
    ACTIONS(3653), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3651), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55489] = 3,
    ACTIONS(3657), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3655), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55509] = 3,
    ACTIONS(3661), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3659), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55529] = 3,
    ACTIONS(3665), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3663), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55549] = 3,
    ACTIONS(3669), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3667), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55569] = 3,
    ACTIONS(3673), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3671), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55589] = 3,
    ACTIONS(3677), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3675), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55609] = 5,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(3681), 1,
      sym_crate,
    STATE(1426), 1,
      sym_string_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3679), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [55633] = 3,
    ACTIONS(3609), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3607), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55653] = 3,
    ACTIONS(3685), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3683), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55673] = 3,
    ACTIONS(3689), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3687), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55693] = 3,
    ACTIONS(3693), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3691), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55713] = 3,
    ACTIONS(3697), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3695), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55733] = 3,
    ACTIONS(3701), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3699), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55753] = 5,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(3703), 1,
      sym_crate,
    STATE(1426), 1,
      sym_string_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3679), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [55777] = 3,
    ACTIONS(3707), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3705), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55797] = 3,
    ACTIONS(3711), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3709), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55817] = 3,
    ACTIONS(3715), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3713), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55837] = 5,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(3717), 1,
      sym_crate,
    STATE(1426), 1,
      sym_string_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3679), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [55861] = 3,
    ACTIONS(3637), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3635), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55881] = 3,
    ACTIONS(3721), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3719), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55901] = 5,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    ACTIONS(3723), 1,
      sym_crate,
    STATE(1426), 1,
      sym_string_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3679), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [55925] = 3,
    ACTIONS(3727), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3725), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55945] = 3,
    ACTIONS(3731), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3729), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55965] = 3,
    ACTIONS(3735), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3733), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [55985] = 3,
    ACTIONS(3739), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3737), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [56005] = 3,
    ACTIONS(3743), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3741), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [56025] = 3,
    ACTIONS(3747), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3745), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [56045] = 3,
    ACTIONS(3751), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3749), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [56065] = 3,
    ACTIONS(3755), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3753), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [56085] = 3,
    ACTIONS(3759), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3757), 10,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_if,
      anon_sym_COMMA,
      anon_sym_in,
      anon_sym_PIPE,
  [56105] = 10,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3761), 1,
      sym_identifier,
    ACTIONS(3763), 1,
      anon_sym_RBRACE,
    ACTIONS(3765), 1,
      anon_sym_COMMA,
    ACTIONS(3767), 1,
      sym_crate,
    STATE(1930), 1,
      sym_field_declaration,
    STATE(2345), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1445), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [56138] = 9,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3490), 1,
      anon_sym_BANG,
    ACTIONS(3492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3769), 1,
      anon_sym_for,
    STATE(1265), 1,
      sym_type_arguments,
    STATE(1268), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2625), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [56169] = 8,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3771), 1,
      sym_identifier,
    ACTIONS(3773), 1,
      anon_sym_RBRACE,
    ACTIONS(3775), 1,
      anon_sym_COMMA,
    ACTIONS(3777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1666), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    STATE(1904), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [56198] = 10,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3767), 1,
      sym_crate,
    ACTIONS(3779), 1,
      sym_identifier,
    ACTIONS(3781), 1,
      anon_sym_RBRACE,
    ACTIONS(3783), 1,
      anon_sym_COMMA,
    STATE(1921), 1,
      sym_enum_variant,
    STATE(2279), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1428), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [56231] = 10,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3767), 1,
      sym_crate,
    ACTIONS(3779), 1,
      sym_identifier,
    ACTIONS(3785), 1,
      anon_sym_RBRACE,
    ACTIONS(3787), 1,
      anon_sym_COMMA,
    STATE(1855), 1,
      sym_enum_variant,
    STATE(2279), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1451), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [56264] = 9,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3490), 1,
      anon_sym_BANG,
    ACTIONS(3492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3789), 1,
      anon_sym_for,
    STATE(1265), 1,
      sym_type_arguments,
    STATE(1268), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2625), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [56295] = 10,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3761), 1,
      sym_identifier,
    ACTIONS(3767), 1,
      sym_crate,
    ACTIONS(3791), 1,
      anon_sym_RBRACE,
    ACTIONS(3793), 1,
      anon_sym_COMMA,
    STATE(1958), 1,
      sym_field_declaration,
    STATE(2345), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1421), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [56328] = 9,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3490), 1,
      anon_sym_BANG,
    ACTIONS(3492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3795), 1,
      anon_sym_for,
    STATE(1265), 1,
      sym_type_arguments,
    STATE(1268), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2625), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [56359] = 7,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3797), 1,
      anon_sym_LBRACE,
    STATE(1255), 1,
      sym_type_arguments,
    STATE(1283), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2685), 5,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [56386] = 9,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3490), 1,
      anon_sym_BANG,
    ACTIONS(3492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3799), 1,
      anon_sym_for,
    STATE(1265), 1,
      sym_type_arguments,
    STATE(1268), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2625), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [56417] = 9,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3490), 1,
      anon_sym_BANG,
    ACTIONS(3492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3801), 1,
      anon_sym_for,
    STATE(1265), 1,
      sym_type_arguments,
    STATE(1268), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2625), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [56448] = 9,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3490), 1,
      anon_sym_BANG,
    ACTIONS(3492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3803), 1,
      anon_sym_for,
    STATE(1265), 1,
      sym_type_arguments,
    STATE(1268), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2625), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [56479] = 9,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3490), 1,
      anon_sym_BANG,
    ACTIONS(3492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3805), 1,
      anon_sym_for,
    STATE(1265), 1,
      sym_type_arguments,
    STATE(1268), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2625), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [56510] = 5,
    ACTIONS(91), 1,
      aux_sym_string_literal_token1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1851), 3,
      sym__literal,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(3807), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
  [56533] = 5,
    ACTIONS(91), 1,
      aux_sym_string_literal_token1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3809), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(1849), 3,
      sym__literal,
      sym_string_literal,
      sym_boolean_literal,
    ACTIONS(3811), 4,
      sym_raw_string_literal,
      sym_float_literal,
      sym_integer_literal,
      sym_char_literal,
  [56556] = 9,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3490), 1,
      anon_sym_BANG,
    ACTIONS(3492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3813), 1,
      anon_sym_EQ,
    STATE(1265), 1,
      sym_type_arguments,
    STATE(1268), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2625), 3,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_GT,
  [56587] = 9,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3490), 1,
      anon_sym_BANG,
    ACTIONS(3492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3815), 1,
      anon_sym_for,
    STATE(1265), 1,
      sym_type_arguments,
    STATE(1268), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2625), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [56618] = 6,
    ACTIONS(15), 1,
      anon_sym_LBRACE,
    ACTIONS(3532), 1,
      anon_sym_trait,
    ACTIONS(3817), 1,
      anon_sym_impl,
    STATE(58), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2727), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [56643] = 9,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(3819), 1,
      sym_identifier,
    ACTIONS(3821), 1,
      anon_sym_const,
    ACTIONS(3823), 1,
      anon_sym_GT,
    ACTIONS(3825), 1,
      sym_metavariable,
    STATE(1659), 1,
      sym_lifetime,
    STATE(1907), 1,
      sym_constrained_type_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2056), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [56673] = 5,
    ACTIONS(3827), 1,
      anon_sym_SEMI,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(748), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2727), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [56695] = 10,
    ACTIONS(3831), 1,
      anon_sym_SEMI,
    ACTIONS(3833), 1,
      anon_sym_LPAREN,
    ACTIONS(3835), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3839), 1,
      anon_sym_LT,
    STATE(350), 1,
      sym_field_declaration_list,
    STATE(1487), 1,
      sym_type_parameters,
    STATE(1780), 1,
      sym_ordered_field_declaration_list,
    STATE(2101), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [56727] = 9,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3761), 1,
      sym_identifier,
    ACTIONS(3767), 1,
      sym_crate,
    ACTIONS(3841), 1,
      anon_sym_RBRACE,
    STATE(2120), 1,
      sym_field_declaration,
    STATE(2345), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1439), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [56757] = 5,
    ACTIONS(3843), 1,
      anon_sym_SEMI,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(277), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2727), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [56779] = 9,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3767), 1,
      sym_crate,
    ACTIONS(3779), 1,
      sym_identifier,
    ACTIONS(3847), 1,
      anon_sym_RBRACE,
    STATE(2100), 1,
      sym_enum_variant,
    STATE(2279), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1432), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [56809] = 9,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3767), 1,
      sym_crate,
    ACTIONS(3779), 1,
      sym_identifier,
    ACTIONS(3849), 1,
      anon_sym_RBRACE,
    STATE(2100), 1,
      sym_enum_variant,
    STATE(2279), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1432), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [56839] = 10,
    ACTIONS(3833), 1,
      anon_sym_LPAREN,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3851), 1,
      anon_sym_SEMI,
    ACTIONS(3853), 1,
      anon_sym_LBRACE,
    STATE(886), 1,
      sym_field_declaration_list,
    STATE(1468), 1,
      sym_type_parameters,
    STATE(1890), 1,
      sym_ordered_field_declaration_list,
    STATE(2071), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [56871] = 10,
    ACTIONS(3833), 1,
      anon_sym_LPAREN,
    ACTIONS(3835), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3855), 1,
      anon_sym_SEMI,
    STATE(435), 1,
      sym_field_declaration_list,
    STATE(1503), 1,
      sym_type_parameters,
    STATE(1766), 1,
      sym_ordered_field_declaration_list,
    STATE(2055), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [56903] = 7,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3771), 1,
      sym_identifier,
    ACTIONS(3777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3857), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1666), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    STATE(2158), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [56929] = 9,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3761), 1,
      sym_identifier,
    ACTIONS(3767), 1,
      sym_crate,
    ACTIONS(3859), 1,
      anon_sym_RBRACE,
    STATE(2120), 1,
      sym_field_declaration,
    STATE(2345), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1439), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [56959] = 5,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3861), 1,
      anon_sym_SEMI,
    STATE(916), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2727), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [56981] = 5,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    ACTIONS(3863), 1,
      anon_sym_SEMI,
    STATE(431), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2727), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [57003] = 9,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(3819), 1,
      sym_identifier,
    ACTIONS(3821), 1,
      anon_sym_const,
    ACTIONS(3825), 1,
      sym_metavariable,
    ACTIONS(3865), 1,
      anon_sym_GT,
    STATE(1659), 1,
      sym_lifetime,
    STATE(1907), 1,
      sym_constrained_type_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2056), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [57033] = 10,
    ACTIONS(3833), 1,
      anon_sym_LPAREN,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3853), 1,
      anon_sym_LBRACE,
    ACTIONS(3867), 1,
      anon_sym_SEMI,
    STATE(812), 1,
      sym_field_declaration_list,
    STATE(1492), 1,
      sym_type_parameters,
    STATE(1962), 1,
      sym_ordered_field_declaration_list,
    STATE(1980), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [57065] = 9,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(3819), 1,
      sym_identifier,
    ACTIONS(3821), 1,
      anon_sym_const,
    ACTIONS(3825), 1,
      sym_metavariable,
    ACTIONS(3869), 1,
      anon_sym_GT,
    STATE(1659), 1,
      sym_lifetime,
    STATE(1907), 1,
      sym_constrained_type_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2056), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [57095] = 9,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(3819), 1,
      sym_identifier,
    ACTIONS(3821), 1,
      anon_sym_const,
    ACTIONS(3825), 1,
      sym_metavariable,
    ACTIONS(3871), 1,
      anon_sym_GT,
    STATE(1659), 1,
      sym_lifetime,
    STATE(1907), 1,
      sym_constrained_type_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2056), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [57125] = 9,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(3819), 1,
      sym_identifier,
    ACTIONS(3821), 1,
      anon_sym_const,
    ACTIONS(3825), 1,
      sym_metavariable,
    ACTIONS(3873), 1,
      anon_sym_GT,
    STATE(1659), 1,
      sym_lifetime,
    STATE(1907), 1,
      sym_constrained_type_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2056), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [57155] = 9,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(3819), 1,
      sym_identifier,
    ACTIONS(3821), 1,
      anon_sym_const,
    ACTIONS(3825), 1,
      sym_metavariable,
    ACTIONS(3875), 1,
      anon_sym_GT,
    STATE(1689), 1,
      sym_lifetime,
    STATE(1907), 1,
      sym_constrained_type_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2056), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [57185] = 9,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3761), 1,
      sym_identifier,
    ACTIONS(3767), 1,
      sym_crate,
    ACTIONS(3877), 1,
      anon_sym_RBRACE,
    STATE(2120), 1,
      sym_field_declaration,
    STATE(2345), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1439), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [57215] = 9,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(3819), 1,
      sym_identifier,
    ACTIONS(3821), 1,
      anon_sym_const,
    ACTIONS(3825), 1,
      sym_metavariable,
    ACTIONS(3879), 1,
      anon_sym_GT,
    STATE(1659), 1,
      sym_lifetime,
    STATE(1907), 1,
      sym_constrained_type_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2056), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [57245] = 9,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3767), 1,
      sym_crate,
    ACTIONS(3779), 1,
      sym_identifier,
    ACTIONS(3881), 1,
      anon_sym_RBRACE,
    STATE(2100), 1,
      sym_enum_variant,
    STATE(2279), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1432), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [57275] = 9,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(3819), 1,
      sym_identifier,
    ACTIONS(3821), 1,
      anon_sym_const,
    ACTIONS(3825), 1,
      sym_metavariable,
    ACTIONS(3883), 1,
      anon_sym_GT,
    STATE(1659), 1,
      sym_lifetime,
    STATE(1907), 1,
      sym_constrained_type_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2056), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [57305] = 9,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(3819), 1,
      sym_identifier,
    ACTIONS(3821), 1,
      anon_sym_const,
    ACTIONS(3825), 1,
      sym_metavariable,
    ACTIONS(3885), 1,
      anon_sym_GT,
    STATE(1659), 1,
      sym_lifetime,
    STATE(1907), 1,
      sym_constrained_type_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2056), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [57335] = 9,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3761), 1,
      sym_identifier,
    ACTIONS(3767), 1,
      sym_crate,
    ACTIONS(3887), 1,
      anon_sym_RBRACE,
    STATE(2120), 1,
      sym_field_declaration,
    STATE(2345), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1439), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [57365] = 9,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3767), 1,
      sym_crate,
    ACTIONS(3779), 1,
      sym_identifier,
    ACTIONS(3889), 1,
      anon_sym_RBRACE,
    STATE(2100), 1,
      sym_enum_variant,
    STATE(2279), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1432), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [57395] = 9,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3767), 1,
      sym_crate,
    ACTIONS(3779), 1,
      sym_identifier,
    ACTIONS(3891), 1,
      anon_sym_RBRACE,
    STATE(2100), 1,
      sym_enum_variant,
    STATE(2279), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1432), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [57425] = 5,
    ACTIONS(15), 1,
      anon_sym_LBRACE,
    ACTIONS(3893), 1,
      anon_sym_move,
    STATE(43), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2727), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [57447] = 9,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3767), 1,
      sym_crate,
    ACTIONS(3779), 1,
      sym_identifier,
    ACTIONS(3895), 1,
      anon_sym_RBRACE,
    STATE(2100), 1,
      sym_enum_variant,
    STATE(2279), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1432), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [57477] = 7,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3771), 1,
      sym_identifier,
    ACTIONS(3777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3897), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1666), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    STATE(2158), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [57503] = 9,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3761), 1,
      sym_identifier,
    ACTIONS(3767), 1,
      sym_crate,
    ACTIONS(3899), 1,
      anon_sym_RBRACE,
    STATE(2120), 1,
      sym_field_declaration,
    STATE(2345), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1439), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [57533] = 9,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3761), 1,
      sym_identifier,
    ACTIONS(3767), 1,
      sym_crate,
    ACTIONS(3901), 1,
      anon_sym_RBRACE,
    STATE(2120), 1,
      sym_field_declaration,
    STATE(2345), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1439), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [57563] = 7,
    ACTIONS(3474), 1,
      anon_sym_LPAREN,
    ACTIONS(3478), 1,
      anon_sym_COLON,
    ACTIONS(3490), 1,
      anon_sym_BANG,
    ACTIONS(3903), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3472), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [57589] = 8,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3761), 1,
      sym_identifier,
    ACTIONS(3767), 1,
      sym_crate,
    STATE(1929), 1,
      sym_field_declaration,
    STATE(2345), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1055), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [57616] = 4,
    ACTIONS(3907), 1,
      anon_sym_PLUS,
    STATE(1422), 1,
      aux_sym_trait_bounds_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3905), 6,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [57635] = 8,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3910), 1,
      sym_identifier,
    ACTIONS(3912), 1,
      anon_sym_RBRACE,
    ACTIONS(3914), 1,
      anon_sym_COMMA,
    ACTIONS(3916), 1,
      anon_sym_ref,
    ACTIONS(3918), 1,
      sym_mutable_specifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1742), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [57662] = 8,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(3821), 1,
      anon_sym_const,
    ACTIONS(3920), 1,
      sym_identifier,
    ACTIONS(3922), 1,
      sym_metavariable,
    STATE(1542), 1,
      sym_lifetime,
    STATE(1722), 1,
      sym_constrained_type_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1737), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [57689] = 7,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3924), 1,
      anon_sym_for,
    STATE(1255), 1,
      sym_type_arguments,
    STATE(1283), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2685), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [57714] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3926), 8,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [57729] = 6,
    ACTIONS(3928), 1,
      anon_sym_RBRACK,
    ACTIONS(3931), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2755), 2,
      anon_sym_SEMI,
      anon_sym_PLUS,
    ACTIONS(3565), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
    ACTIONS(3571), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [57752] = 8,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3767), 1,
      sym_crate,
    ACTIONS(3779), 1,
      sym_identifier,
    STATE(1953), 1,
      sym_enum_variant,
    STATE(2279), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1055), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [57779] = 7,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3933), 1,
      anon_sym_for,
    STATE(1255), 1,
      sym_type_arguments,
    STATE(1283), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2685), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [57804] = 8,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3910), 1,
      sym_identifier,
    ACTIONS(3916), 1,
      anon_sym_ref,
    ACTIONS(3918), 1,
      sym_mutable_specifier,
    ACTIONS(3935), 1,
      anon_sym_RBRACE,
    ACTIONS(3937), 1,
      anon_sym_COMMA,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1781), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [57831] = 8,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3767), 1,
      sym_crate,
    ACTIONS(3779), 1,
      sym_identifier,
    STATE(2100), 1,
      sym_enum_variant,
    STATE(2279), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1432), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [57858] = 8,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3767), 1,
      sym_crate,
    ACTIONS(3779), 1,
      sym_identifier,
    STATE(2078), 1,
      sym_enum_variant,
    STATE(2279), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1055), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [57885] = 7,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3939), 1,
      anon_sym_for,
    STATE(1255), 1,
      sym_type_arguments,
    STATE(1283), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2685), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [57910] = 9,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    ACTIONS(3943), 1,
      anon_sym_LT,
    STATE(933), 1,
      sym_declaration_list,
    STATE(1554), 1,
      sym_type_parameters,
    STATE(1636), 1,
      sym_trait_bounds,
    STATE(2043), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [57939] = 9,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    ACTIONS(3943), 1,
      anon_sym_LT,
    STATE(888), 1,
      sym_declaration_list,
    STATE(1530), 1,
      sym_type_parameters,
    STATE(1669), 1,
      sym_trait_bounds,
    STATE(2070), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [57968] = 7,
    ACTIONS(2755), 1,
      anon_sym_PLUS,
    ACTIONS(3565), 1,
      anon_sym_PIPE,
    ACTIONS(3567), 1,
      anon_sym_COLON,
    ACTIONS(3945), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3571), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3928), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [57993] = 9,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    ACTIONS(3943), 1,
      anon_sym_LT,
    STATE(390), 1,
      sym_declaration_list,
    STATE(1546), 1,
      sym_type_parameters,
    STATE(1697), 1,
      sym_trait_bounds,
    STATE(2146), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [58022] = 8,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(3821), 1,
      anon_sym_const,
    ACTIONS(3947), 1,
      sym_identifier,
    ACTIONS(3949), 1,
      sym_metavariable,
    STATE(1606), 1,
      sym_lifetime,
    STATE(1677), 1,
      sym_constrained_type_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1877), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [58049] = 8,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3761), 1,
      sym_identifier,
    ACTIONS(3767), 1,
      sym_crate,
    STATE(1971), 1,
      sym_field_declaration,
    STATE(2345), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1055), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [58076] = 5,
    ACTIONS(3953), 1,
      anon_sym_fn,
    ACTIONS(3955), 1,
      anon_sym_extern,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1453), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(3951), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
  [58097] = 9,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    ACTIONS(3943), 1,
      anon_sym_LT,
    STATE(355), 1,
      sym_declaration_list,
    STATE(1539), 1,
      sym_type_parameters,
    STATE(1708), 1,
      sym_trait_bounds,
    STATE(2107), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [58126] = 8,
    ACTIONS(3957), 1,
      anon_sym_LPAREN,
    ACTIONS(3962), 1,
      anon_sym_LBRACE,
    ACTIONS(3965), 1,
      anon_sym_LBRACK,
    STATE(1442), 1,
      aux_sym_macro_definition_repeat1,
    STATE(2282), 1,
      sym_macro_rule,
    STATE(2366), 1,
      sym_token_tree_pattern,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3960), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [58153] = 8,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3761), 1,
      sym_identifier,
    ACTIONS(3767), 1,
      sym_crate,
    STATE(2120), 1,
      sym_field_declaration,
    STATE(2345), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1439), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [58180] = 7,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3968), 1,
      anon_sym_for,
    STATE(1255), 1,
      sym_type_arguments,
    STATE(1283), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2685), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [58205] = 8,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3761), 1,
      sym_identifier,
    ACTIONS(3767), 1,
      sym_crate,
    STATE(1885), 1,
      sym_field_declaration,
    STATE(2345), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1055), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [58232] = 6,
    ACTIONS(3474), 1,
      anon_sym_LPAREN,
    ACTIONS(3552), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3613), 1,
      anon_sym_BANG,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3472), 3,
      anon_sym_EQ_GT,
      anon_sym_if,
      anon_sym_PIPE,
  [58255] = 4,
    ACTIONS(3508), 1,
      anon_sym_trait,
    ACTIONS(3970), 1,
      anon_sym_impl,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2727), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [58274] = 8,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(3819), 1,
      sym_identifier,
    ACTIONS(3821), 1,
      anon_sym_const,
    ACTIONS(3825), 1,
      sym_metavariable,
    STATE(1659), 1,
      sym_lifetime,
    STATE(1907), 1,
      sym_constrained_type_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2056), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [58301] = 6,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3771), 1,
      sym_identifier,
    ACTIONS(3777), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1666), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
    STATE(2158), 3,
      sym_shorthand_field_initializer,
      sym_field_initializer,
      sym_base_field_initializer,
  [58324] = 8,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(3821), 1,
      anon_sym_const,
    ACTIONS(3920), 1,
      sym_identifier,
    ACTIONS(3922), 1,
      sym_metavariable,
    STATE(1611), 1,
      sym_lifetime,
    STATE(1722), 1,
      sym_constrained_type_parameter,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1737), 2,
      sym_const_parameter,
      sym_optional_type_parameter,
  [58351] = 8,
    ACTIONS(53), 1,
      anon_sym_pub,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(3767), 1,
      sym_crate,
    ACTIONS(3779), 1,
      sym_identifier,
    STATE(1799), 1,
      sym_enum_variant,
    STATE(2279), 1,
      sym_visibility_modifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1055), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [58378] = 7,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3972), 1,
      anon_sym_for,
    STATE(1255), 1,
      sym_type_arguments,
    STATE(1283), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2685), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [58403] = 5,
    ACTIONS(3977), 1,
      anon_sym_fn,
    ACTIONS(3979), 1,
      anon_sym_extern,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1453), 2,
      sym_extern_modifier,
      aux_sym_function_modifiers_repeat1,
    ACTIONS(3974), 4,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_unsafe,
  [58424] = 4,
    ACTIONS(3984), 1,
      anon_sym_PLUS,
    STATE(1422), 1,
      aux_sym_trait_bounds_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3982), 6,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [58443] = 7,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3986), 1,
      anon_sym_for,
    STATE(1255), 1,
      sym_type_arguments,
    STATE(1283), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2685), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [58468] = 7,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3988), 1,
      anon_sym_for,
    STATE(1255), 1,
      sym_type_arguments,
    STATE(1283), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2685), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [58493] = 9,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    ACTIONS(3943), 1,
      anon_sym_LT,
    STATE(351), 1,
      sym_declaration_list,
    STATE(1540), 1,
      sym_type_parameters,
    STATE(1710), 1,
      sym_trait_bounds,
    STATE(2109), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [58522] = 6,
    ACTIONS(3474), 1,
      anon_sym_LPAREN,
    ACTIONS(3490), 1,
      anon_sym_BANG,
    ACTIONS(3990), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(3472), 3,
      anon_sym_RBRACK,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [58545] = 6,
    ACTIONS(3565), 1,
      anon_sym_PIPE,
    ACTIONS(3567), 1,
      anon_sym_COLON,
    ACTIONS(3992), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3571), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2755), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [58568] = 4,
    ACTIONS(703), 1,
      aux_sym_string_literal_token1,
    STATE(1426), 1,
      sym_string_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3679), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [58587] = 7,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3994), 1,
      anon_sym_for,
    STATE(1255), 1,
      sym_type_arguments,
    STATE(1283), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2685), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [58612] = 4,
    ACTIONS(3984), 1,
      anon_sym_PLUS,
    STATE(1454), 1,
      aux_sym_trait_bounds_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3996), 6,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [58631] = 9,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    ACTIONS(3943), 1,
      anon_sym_LT,
    STATE(859), 1,
      sym_declaration_list,
    STATE(1545), 1,
      sym_type_parameters,
    STATE(1650), 1,
      sym_trait_bounds,
    STATE(1969), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [58660] = 4,
    ACTIONS(3998), 1,
      anon_sym_PLUS,
    STATE(1454), 1,
      aux_sym_trait_bounds_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3996), 6,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [58679] = 4,
    ACTIONS(4000), 1,
      anon_sym_PLUS,
    STATE(1454), 1,
      aux_sym_trait_bounds_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3996), 6,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [58698] = 3,
    ACTIONS(4002), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4004), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [58714] = 6,
    ACTIONS(3633), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4006), 1,
      anon_sym_LPAREN,
    ACTIONS(4010), 1,
      anon_sym_EQ,
    STATE(1732), 1,
      sym_meta_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4008), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [58736] = 8,
    ACTIONS(3833), 1,
      anon_sym_LPAREN,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3853), 1,
      anon_sym_LBRACE,
    ACTIONS(4012), 1,
      anon_sym_SEMI,
    STATE(927), 1,
      sym_field_declaration_list,
    STATE(1960), 1,
      sym_ordered_field_declaration_list,
    STATE(1986), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [58762] = 6,
    ACTIONS(3833), 1,
      anon_sym_LPAREN,
    ACTIONS(3853), 1,
      anon_sym_LBRACE,
    ACTIONS(4016), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4014), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1793), 2,
      sym_field_declaration_list,
      sym_ordered_field_declaration_list,
  [58784] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3905), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [58798] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3905), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [58812] = 7,
    ACTIONS(3472), 1,
      anon_sym_PIPE,
    ACTIONS(3474), 1,
      anon_sym_LPAREN,
    ACTIONS(3478), 1,
      anon_sym_COLON,
    ACTIONS(3490), 1,
      anon_sym_BANG,
    ACTIONS(4018), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [58836] = 6,
    ACTIONS(4006), 1,
      anon_sym_LPAREN,
    ACTIONS(4022), 1,
      anon_sym_EQ,
    ACTIONS(4024), 1,
      anon_sym_COLON_COLON,
    STATE(1734), 1,
      sym_meta_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4020), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [58858] = 7,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3910), 1,
      sym_identifier,
    ACTIONS(3916), 1,
      anon_sym_ref,
    ACTIONS(3918), 1,
      sym_mutable_specifier,
    ACTIONS(4026), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2049), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [58882] = 8,
    ACTIONS(4028), 1,
      anon_sym_LPAREN,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4032), 1,
      anon_sym_RBRACE,
    ACTIONS(4034), 1,
      anon_sym_LBRACK,
    STATE(1493), 1,
      aux_sym_macro_definition_repeat1,
    STATE(2039), 1,
      sym_macro_rule,
    STATE(2366), 1,
      sym_token_tree_pattern,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [58908] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4036), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [58922] = 3,
    ACTIONS(4038), 1,
      anon_sym_trait,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2727), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [58938] = 3,
    ACTIONS(4040), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2727), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [58954] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3905), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [58968] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3905), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [58982] = 7,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3910), 1,
      sym_identifier,
    ACTIONS(3916), 1,
      anon_sym_ref,
    ACTIONS(3918), 1,
      sym_mutable_specifier,
    ACTIONS(4042), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2049), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [59006] = 8,
    ACTIONS(4028), 1,
      anon_sym_LPAREN,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4034), 1,
      anon_sym_LBRACK,
    ACTIONS(4044), 1,
      anon_sym_RPAREN,
    STATE(1498), 1,
      aux_sym_macro_definition_repeat1,
    STATE(1999), 1,
      sym_macro_rule,
    STATE(2366), 1,
      sym_token_tree_pattern,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59032] = 7,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3910), 1,
      sym_identifier,
    ACTIONS(3916), 1,
      anon_sym_ref,
    ACTIONS(3918), 1,
      sym_mutable_specifier,
    ACTIONS(4046), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2049), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [59056] = 8,
    ACTIONS(4028), 1,
      anon_sym_LPAREN,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4034), 1,
      anon_sym_LBRACK,
    ACTIONS(4048), 1,
      anon_sym_RPAREN,
    STATE(1442), 1,
      aux_sym_macro_definition_repeat1,
    STATE(2084), 1,
      sym_macro_rule,
    STATE(2366), 1,
      sym_token_tree_pattern,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59082] = 6,
    ACTIONS(4006), 1,
      anon_sym_LPAREN,
    ACTIONS(4022), 1,
      anon_sym_EQ,
    ACTIONS(4050), 1,
      anon_sym_COLON_COLON,
    STATE(1734), 1,
      sym_meta_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4020), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [59104] = 8,
    ACTIONS(4028), 1,
      anon_sym_LPAREN,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4034), 1,
      anon_sym_LBRACK,
    ACTIONS(4052), 1,
      anon_sym_RBRACE,
    STATE(1500), 1,
      aux_sym_macro_definition_repeat1,
    STATE(2002), 1,
      sym_macro_rule,
    STATE(2366), 1,
      sym_token_tree_pattern,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59130] = 8,
    ACTIONS(3833), 1,
      anon_sym_LPAREN,
    ACTIONS(3835), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4054), 1,
      anon_sym_SEMI,
    STATE(313), 1,
      sym_field_declaration_list,
    STATE(1878), 1,
      sym_ordered_field_declaration_list,
    STATE(2098), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59156] = 3,
    ACTIONS(4056), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4004), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [59172] = 6,
    ACTIONS(3833), 1,
      anon_sym_LPAREN,
    ACTIONS(3853), 1,
      anon_sym_LBRACE,
    ACTIONS(4060), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4058), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
    STATE(1728), 2,
      sym_field_declaration_list,
      sym_ordered_field_declaration_list,
  [59194] = 8,
    ACTIONS(4028), 1,
      anon_sym_LPAREN,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4034), 1,
      anon_sym_LBRACK,
    ACTIONS(4062), 1,
      anon_sym_RPAREN,
    STATE(1484), 1,
      aux_sym_macro_definition_repeat1,
    STATE(2113), 1,
      sym_macro_rule,
    STATE(2366), 1,
      sym_token_tree_pattern,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59220] = 3,
    ACTIONS(4064), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4004), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [59236] = 8,
    ACTIONS(3833), 1,
      anon_sym_LPAREN,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3853), 1,
      anon_sym_LBRACE,
    ACTIONS(4066), 1,
      anon_sym_SEMI,
    STATE(952), 1,
      sym_field_declaration_list,
    STATE(1917), 1,
      sym_ordered_field_declaration_list,
    STATE(2040), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59262] = 8,
    ACTIONS(4028), 1,
      anon_sym_LPAREN,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4034), 1,
      anon_sym_LBRACK,
    ACTIONS(4068), 1,
      anon_sym_RBRACE,
    STATE(1442), 1,
      aux_sym_macro_definition_repeat1,
    STATE(1991), 1,
      sym_macro_rule,
    STATE(2366), 1,
      sym_token_tree_pattern,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59288] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3905), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [59302] = 3,
    ACTIONS(4070), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4004), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [59318] = 3,
    ACTIONS(4072), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4004), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [59334] = 7,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3910), 1,
      sym_identifier,
    ACTIONS(3916), 1,
      anon_sym_ref,
    ACTIONS(3918), 1,
      sym_mutable_specifier,
    ACTIONS(4074), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2049), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [59358] = 8,
    ACTIONS(4028), 1,
      anon_sym_LPAREN,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4034), 1,
      anon_sym_LBRACK,
    ACTIONS(4076), 1,
      anon_sym_RPAREN,
    STATE(1442), 1,
      aux_sym_macro_definition_repeat1,
    STATE(2111), 1,
      sym_macro_rule,
    STATE(2366), 1,
      sym_token_tree_pattern,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59384] = 3,
    ACTIONS(4078), 1,
      anon_sym_trait,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2727), 6,
      anon_sym_async,
      anon_sym_const,
      anon_sym_default,
      anon_sym_fn,
      anon_sym_unsafe,
      anon_sym_extern,
  [59400] = 8,
    ACTIONS(4028), 1,
      anon_sym_LPAREN,
    ACTIONS(4030), 1,
      anon_sym_LBRACE,
    ACTIONS(4034), 1,
      anon_sym_LBRACK,
    ACTIONS(4080), 1,
      anon_sym_RBRACE,
    STATE(1442), 1,
      aux_sym_macro_definition_repeat1,
    STATE(2115), 1,
      sym_macro_rule,
    STATE(2366), 1,
      sym_token_tree_pattern,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59426] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4082), 7,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [59440] = 6,
    ACTIONS(4006), 1,
      anon_sym_LPAREN,
    ACTIONS(4022), 1,
      anon_sym_EQ,
    ACTIONS(4084), 1,
      anon_sym_COLON_COLON,
    STATE(1734), 1,
      sym_meta_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4020), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [59462] = 8,
    ACTIONS(3833), 1,
      anon_sym_LPAREN,
    ACTIONS(3835), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4086), 1,
      anon_sym_SEMI,
    STATE(449), 1,
      sym_field_declaration_list,
    STATE(1817), 1,
      sym_ordered_field_declaration_list,
    STATE(2138), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59488] = 7,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(4088), 1,
      anon_sym_LBRACE,
    STATE(442), 1,
      sym_enum_variant_list,
    STATE(1715), 1,
      sym_type_parameters,
    STATE(2048), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59511] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3745), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(2821), 4,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
  [59526] = 7,
    ACTIONS(3835), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3839), 1,
      anon_sym_LT,
    STATE(363), 1,
      sym_field_declaration_list,
    STATE(1703), 1,
      sym_type_parameters,
    STATE(2125), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59549] = 7,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    ACTIONS(4090), 1,
      anon_sym_SEMI,
    ACTIONS(4092), 1,
      anon_sym_EQ,
    STATE(2290), 1,
      sym_trait_bounds,
    STATE(2347), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59572] = 7,
    ACTIONS(3835), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3839), 1,
      anon_sym_LT,
    STATE(434), 1,
      sym_field_declaration_list,
    STATE(1713), 1,
      sym_type_parameters,
    STATE(2063), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59595] = 7,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3853), 1,
      anon_sym_LBRACE,
    STATE(908), 1,
      sym_field_declaration_list,
    STATE(1668), 1,
      sym_type_parameters,
    STATE(2064), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59618] = 7,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4094), 1,
      anon_sym_SEMI,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4098), 1,
      anon_sym_DASH_GT,
    STATE(276), 1,
      sym_block,
    STATE(1879), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59641] = 4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2821), 2,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
    ACTIONS(3745), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(4100), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [59658] = 7,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    ACTIONS(4103), 1,
      anon_sym_SEMI,
    ACTIONS(4105), 1,
      anon_sym_EQ,
    STATE(2239), 1,
      sym_type_parameters,
    STATE(2250), 1,
      sym_trait_bounds,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59681] = 7,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4107), 1,
      anon_sym_SEMI,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(281), 1,
      sym_block,
    STATE(1915), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59704] = 7,
    ACTIONS(3587), 1,
      anon_sym_EQ,
    ACTIONS(3589), 1,
      anon_sym_COMMA,
    ACTIONS(3591), 1,
      anon_sym_GT,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    STATE(1811), 1,
      sym_trait_bounds,
    STATE(1814), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59727] = 7,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4111), 1,
      anon_sym_SEMI,
    ACTIONS(4113), 1,
      anon_sym_DASH_GT,
    STATE(420), 1,
      sym_block,
    STATE(1840), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59750] = 7,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(4088), 1,
      anon_sym_LBRACE,
    STATE(255), 1,
      sym_enum_variant_list,
    STATE(1704), 1,
      sym_type_parameters,
    STATE(2123), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59773] = 4,
    ACTIONS(4115), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2685), 3,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_PLUS,
  [59790] = 7,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4117), 1,
      anon_sym_SEMI,
    STATE(241), 1,
      sym_block,
    STATE(1806), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59813] = 7,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4119), 1,
      anon_sym_SEMI,
    STATE(901), 1,
      sym_block,
    STATE(1871), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59836] = 7,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    STATE(806), 1,
      sym_enum_variant_list,
    STATE(1679), 1,
      sym_type_parameters,
    STATE(2118), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59859] = 5,
    ACTIONS(4125), 1,
      anon_sym_COLON,
    ACTIONS(4127), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4123), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [59878] = 7,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4129), 1,
      anon_sym_SEMI,
    ACTIONS(4131), 1,
      anon_sym_DASH_GT,
    STATE(353), 1,
      sym_block,
    STATE(1862), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59901] = 4,
    ACTIONS(4127), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2685), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [59918] = 7,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4133), 1,
      anon_sym_SEMI,
    ACTIONS(4135), 1,
      anon_sym_DASH_GT,
    STATE(936), 1,
      sym_block,
    STATE(1932), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59941] = 7,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4137), 1,
      anon_sym_SEMI,
    STATE(894), 1,
      sym_block,
    STATE(1872), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59964] = 7,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4139), 1,
      anon_sym_SEMI,
    STATE(880), 1,
      sym_block,
    STATE(1874), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [59987] = 7,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4141), 1,
      anon_sym_SEMI,
    STATE(334), 1,
      sym_block,
    STATE(1900), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60010] = 7,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4143), 1,
      anon_sym_SEMI,
    STATE(245), 1,
      sym_block,
    STATE(1759), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60033] = 4,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2761), 2,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
    ACTIONS(3659), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(4145), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [60050] = 7,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    STATE(911), 1,
      sym_declaration_list,
    STATE(1653), 1,
      sym_trait_bounds,
    STATE(1976), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60073] = 7,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4148), 1,
      anon_sym_SEMI,
    STATE(404), 1,
      sym_block,
    STATE(1795), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60096] = 7,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4150), 1,
      anon_sym_SEMI,
    ACTIONS(4152), 1,
      anon_sym_DASH_GT,
    STATE(376), 1,
      sym_block,
    STATE(1823), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60119] = 7,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4154), 1,
      anon_sym_SEMI,
    STATE(377), 1,
      sym_block,
    STATE(1824), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60142] = 5,
    ACTIONS(4158), 1,
      anon_sym_COLON,
    ACTIONS(4160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4156), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [60161] = 7,
    ACTIONS(3424), 1,
      anon_sym_LBRACE,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(4162), 1,
      sym_identifier,
    ACTIONS(4164), 1,
      anon_sym_STAR,
    STATE(1888), 1,
      sym_use_list,
    STATE(2277), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60184] = 7,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    STATE(841), 1,
      sym_enum_variant_list,
    STATE(1648), 1,
      sym_type_parameters,
    STATE(1977), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60207] = 7,
    ACTIONS(3424), 1,
      anon_sym_LBRACE,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(4162), 1,
      sym_identifier,
    ACTIONS(4164), 1,
      anon_sym_STAR,
    STATE(1888), 1,
      sym_use_list,
    STATE(2240), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60230] = 7,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(3853), 1,
      anon_sym_LBRACE,
    STATE(803), 1,
      sym_field_declaration_list,
    STATE(1647), 1,
      sym_type_parameters,
    STATE(1982), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60253] = 7,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    STATE(322), 1,
      sym_declaration_list,
    STATE(1686), 1,
      sym_trait_bounds,
    STATE(2153), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60276] = 7,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    STATE(298), 1,
      sym_declaration_list,
    STATE(1654), 1,
      sym_trait_bounds,
    STATE(2099), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60299] = 7,
    ACTIONS(3587), 1,
      anon_sym_EQ,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    ACTIONS(4166), 1,
      anon_sym_COMMA,
    ACTIONS(4168), 1,
      anon_sym_GT,
    STATE(1811), 1,
      sym_trait_bounds,
    STATE(1941), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60322] = 7,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    ACTIONS(4170), 1,
      anon_sym_COMMA,
    ACTIONS(4172), 1,
      anon_sym_GT,
    STATE(1819), 1,
      aux_sym_type_parameters_repeat1,
    STATE(1820), 1,
      sym_trait_bounds,
    STATE(1889), 1,
      aux_sym_for_lifetimes_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60345] = 7,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4174), 1,
      anon_sym_SEMI,
    ACTIONS(4176), 1,
      anon_sym_DASH_GT,
    STATE(765), 1,
      sym_block,
    STATE(1947), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60368] = 7,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4178), 1,
      anon_sym_SEMI,
    ACTIONS(4180), 1,
      anon_sym_DASH_GT,
    STATE(244), 1,
      sym_block,
    STATE(1816), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60391] = 7,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    STATE(770), 1,
      sym_declaration_list,
    STATE(1634), 1,
      sym_trait_bounds,
    STATE(2030), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60414] = 7,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    STATE(301), 1,
      sym_declaration_list,
    STATE(1649), 1,
      sym_trait_bounds,
    STATE(2106), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60437] = 7,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4182), 1,
      anon_sym_SEMI,
    ACTIONS(4184), 1,
      anon_sym_DASH_GT,
    STATE(845), 1,
      sym_block,
    STATE(1920), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60460] = 4,
    ACTIONS(4145), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3659), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
    ACTIONS(2761), 3,
      anon_sym_SEMI,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
  [60477] = 4,
    ACTIONS(4100), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3745), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
    ACTIONS(2821), 3,
      anon_sym_SEMI,
      anon_sym_PLUS,
      anon_sym_DASH_GT,
  [60494] = 7,
    ACTIONS(2440), 1,
      anon_sym_PLUS,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    ACTIONS(4186), 1,
      anon_sym_COMMA,
    ACTIONS(4188), 1,
      anon_sym_GT,
    STATE(1819), 1,
      aux_sym_type_parameters_repeat1,
    STATE(1820), 1,
      sym_trait_bounds,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60517] = 7,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4190), 1,
      anon_sym_SEMI,
    STATE(879), 1,
      sym_block,
    STATE(1905), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60540] = 6,
    ACTIONS(1019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(3910), 1,
      sym_identifier,
    ACTIONS(3916), 1,
      anon_sym_ref,
    ACTIONS(3918), 1,
      sym_mutable_specifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(2049), 2,
      sym_field_pattern,
      sym_remaining_field_pattern,
  [60561] = 7,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4192), 1,
      anon_sym_SEMI,
    ACTIONS(4194), 1,
      anon_sym_DASH_GT,
    STATE(784), 1,
      sym_block,
    STATE(1893), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60584] = 7,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    STATE(810), 1,
      sym_declaration_list,
    STATE(1643), 1,
      sym_trait_bounds,
    STATE(2075), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60607] = 7,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4196), 1,
      anon_sym_SEMI,
    ACTIONS(4198), 1,
      anon_sym_DASH_GT,
    STATE(814), 1,
      sym_block,
    STATE(1886), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60630] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3659), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(2761), 4,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
      anon_sym_DASH_GT,
  [60645] = 7,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4200), 1,
      anon_sym_SEMI,
    STATE(821), 1,
      sym_block,
    STATE(1884), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60668] = 6,
    ACTIONS(3394), 1,
      anon_sym_COLON_COLON,
    ACTIONS(4186), 1,
      anon_sym_COMMA,
    ACTIONS(4188), 1,
      anon_sym_GT,
    STATE(1819), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2685), 2,
      anon_sym_PLUS,
      anon_sym_as,
  [60689] = 4,
    ACTIONS(4202), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(2685), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [60706] = 7,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4204), 1,
      anon_sym_SEMI,
    STATE(846), 1,
      sym_block,
    STATE(1883), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60729] = 7,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4206), 1,
      anon_sym_SEMI,
    ACTIONS(4208), 1,
      anon_sym_DASH_GT,
    STATE(858), 1,
      sym_block,
    STATE(1881), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60752] = 5,
    ACTIONS(4125), 1,
      anon_sym_COLON,
    ACTIONS(4202), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4123), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [60771] = 7,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4210), 1,
      anon_sym_SEMI,
    ACTIONS(4212), 1,
      anon_sym_DASH_GT,
    STATE(429), 1,
      sym_block,
    STATE(1838), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60794] = 6,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3492), 1,
      anon_sym_COLON_COLON,
    STATE(1265), 1,
      sym_type_arguments,
    STATE(1285), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60814] = 6,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(256), 1,
      sym_declaration_list,
    STATE(2067), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60834] = 6,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(270), 1,
      sym_declaration_list,
    STATE(1966), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60854] = 4,
    ACTIONS(3581), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3968), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2685), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [60870] = 4,
    ACTIONS(3581), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3994), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2685), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [60886] = 4,
    ACTIONS(4214), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2983), 2,
      anon_sym_SEMI,
      anon_sym_PLUS,
    ACTIONS(3733), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [60902] = 4,
    ACTIONS(3581), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3924), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2685), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [60918] = 4,
    ACTIONS(3581), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3933), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2685), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [60934] = 4,
    ACTIONS(4127), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4217), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [60950] = 6,
    ACTIONS(4219), 1,
      anon_sym_RPAREN,
    ACTIONS(4221), 1,
      anon_sym_COLON,
    ACTIONS(4223), 1,
      anon_sym_COMMA,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    STATE(1836), 1,
      aux_sym_tuple_pattern_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [60970] = 4,
    ACTIONS(3581), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3939), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2685), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [60986] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3960), 5,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_LBRACK,
  [60998] = 4,
    ACTIONS(2983), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3733), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(4214), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [61014] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4227), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
  [61026] = 4,
    ACTIONS(4202), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4217), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [61042] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4229), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
  [61054] = 4,
    ACTIONS(4202), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4156), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [61070] = 6,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(348), 1,
      sym_declaration_list,
    STATE(2126), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61090] = 4,
    ACTIONS(3581), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3986), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2685), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [61106] = 4,
    ACTIONS(15), 1,
      anon_sym_LBRACE,
    ACTIONS(4231), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(55), 3,
      sym_if_expression,
      sym_if_let_expression,
      sym_block,
  [61122] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4233), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
  [61134] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4235), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
  [61146] = 4,
    ACTIONS(3581), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3988), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2685), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [61162] = 6,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(274), 1,
      sym_declaration_list,
    STATE(2091), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61182] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3733), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(2983), 3,
      anon_sym_RPAREN,
      anon_sym_PLUS,
      anon_sym_COMMA,
  [61196] = 4,
    ACTIONS(4127), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
    ACTIONS(4156), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [61212] = 6,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(325), 1,
      sym_declaration_list,
    STATE(2008), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61232] = 6,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(327), 1,
      sym_declaration_list,
    STATE(2021), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61252] = 5,
    ACTIONS(903), 1,
      anon_sym_RPAREN,
    ACTIONS(4237), 1,
      anon_sym_COMMA,
    STATE(1757), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3472), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
  [61270] = 6,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(326), 1,
      sym_declaration_list,
    STATE(1988), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61290] = 4,
    ACTIONS(3581), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3972), 1,
      anon_sym_for,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(2685), 3,
      anon_sym_LBRACE,
      anon_sym_PLUS,
      anon_sym_where,
  [61306] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4239), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
  [61318] = 6,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(853), 1,
      sym_declaration_list,
    STATE(2090), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61338] = 6,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(320), 1,
      sym_declaration_list,
    STATE(1981), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61358] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4241), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
  [61370] = 6,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(953), 1,
      sym_declaration_list,
    STATE(2006), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61390] = 6,
    ACTIONS(2627), 1,
      anon_sym_LPAREN,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3492), 1,
      anon_sym_COLON_COLON,
    STATE(944), 1,
      sym_parameters,
    STATE(1265), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61410] = 6,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(862), 1,
      sym_declaration_list,
    STATE(1968), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61430] = 5,
    ACTIONS(3587), 1,
      anon_sym_EQ,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    STATE(1811), 1,
      sym_trait_bounds,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4243), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [61448] = 6,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(314), 1,
      sym_declaration_list,
    STATE(2095), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61468] = 4,
    ACTIONS(4247), 1,
      anon_sym_as,
    ACTIONS(4249), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4245), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [61484] = 5,
    ACTIONS(4251), 1,
      anon_sym_RPAREN,
    ACTIONS(4253), 1,
      anon_sym_COMMA,
    STATE(1809), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3472), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
  [61502] = 6,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    ACTIONS(4255), 1,
      anon_sym_COMMA,
    ACTIONS(4257), 1,
      anon_sym_GT,
    STATE(1820), 1,
      sym_trait_bounds,
    STATE(1943), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61522] = 4,
    ACTIONS(4261), 1,
      anon_sym_as,
    ACTIONS(4263), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4259), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [61538] = 4,
    ACTIONS(4261), 1,
      anon_sym_as,
    ACTIONS(4265), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4259), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [61554] = 4,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    ACTIONS(4267), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(230), 3,
      sym_if_expression,
      sym_if_let_expression,
      sym_block,
  [61570] = 4,
    ACTIONS(4261), 1,
      anon_sym_as,
    ACTIONS(4269), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4259), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [61586] = 6,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    ACTIONS(4186), 1,
      anon_sym_COMMA,
    ACTIONS(4188), 1,
      anon_sym_GT,
    STATE(1819), 1,
      aux_sym_type_parameters_repeat1,
    STATE(1820), 1,
      sym_trait_bounds,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61606] = 5,
    ACTIONS(4271), 1,
      anon_sym_RPAREN,
    ACTIONS(4273), 1,
      anon_sym_COMMA,
    STATE(1951), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3472), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
  [61624] = 4,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(4275), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1023), 3,
      sym_if_expression,
      sym_if_let_expression,
      sym_block,
  [61640] = 6,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(756), 1,
      sym_declaration_list,
    STATE(2012), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61660] = 6,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(752), 1,
      sym_declaration_list,
    STATE(2015), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61680] = 5,
    ACTIONS(4277), 1,
      anon_sym_RPAREN,
    ACTIONS(4280), 1,
      anon_sym_COMMA,
    STATE(1809), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3472), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
  [61698] = 6,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(729), 1,
      sym_declaration_list,
    STATE(2027), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61718] = 6,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3492), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3585), 1,
      anon_sym_COLON,
    STATE(1265), 1,
      sym_type_arguments,
    STATE(1801), 1,
      sym_trait_bounds,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61738] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4283), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
  [61750] = 6,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(446), 1,
      sym_declaration_list,
    STATE(2129), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61770] = 6,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(346), 1,
      sym_declaration_list,
    STATE(2154), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61790] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4285), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
  [61802] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4287), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
  [61814] = 6,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(836), 1,
      sym_declaration_list,
    STATE(2088), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61834] = 6,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(835), 1,
      sym_declaration_list,
    STATE(2087), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61854] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4289), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
  [61866] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4291), 5,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_where,
      anon_sym_EQ,
      anon_sym_COMMA,
  [61878] = 5,
    ACTIONS(983), 1,
      anon_sym_RPAREN,
    ACTIONS(4293), 1,
      anon_sym_COMMA,
    STATE(1911), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3472), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
  [61896] = 6,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(261), 1,
      sym_declaration_list,
    STATE(2076), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61916] = 6,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(730), 1,
      sym_declaration_list,
    STATE(2058), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61936] = 6,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(777), 1,
      sym_declaration_list,
    STATE(2068), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61956] = 6,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(775), 1,
      sym_declaration_list,
    STATE(2065), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61976] = 6,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(731), 1,
      sym_declaration_list,
    STATE(2059), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [61996] = 5,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    STATE(780), 1,
      sym_declaration_list,
    STATE(2069), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62013] = 4,
    ACTIONS(4295), 1,
      anon_sym_COMMA,
    STATE(1720), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3162), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [62028] = 5,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    STATE(809), 1,
      sym_declaration_list,
    STATE(2074), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62045] = 5,
    ACTIONS(983), 1,
      anon_sym_RPAREN,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4293), 1,
      anon_sym_COMMA,
    STATE(1911), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62062] = 5,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4297), 1,
      anon_sym_RPAREN,
    ACTIONS(4299), 1,
      anon_sym_COMMA,
    STATE(1789), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62079] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3472), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(4301), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [62092] = 4,
    ACTIONS(4125), 1,
      anon_sym_COLON,
    ACTIONS(4160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [62107] = 5,
    ACTIONS(4221), 1,
      anon_sym_COLON,
    ACTIONS(4303), 1,
      anon_sym_COMMA,
    ACTIONS(4305), 1,
      anon_sym_PIPE,
    STATE(1894), 1,
      aux_sym_closure_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62124] = 4,
    ACTIONS(4307), 1,
      anon_sym_DQUOTE,
    STATE(1670), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4309), 2,
      sym__string_content,
      sym_escape_sequence,
  [62139] = 5,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    STATE(855), 1,
      sym_declaration_list,
    STATE(2093), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62156] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4311), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [62169] = 5,
    ACTIONS(4313), 1,
      anon_sym_LPAREN,
    ACTIONS(4315), 1,
      anon_sym_LBRACE,
    ACTIONS(4317), 1,
      anon_sym_LBRACK,
    STATE(39), 1,
      sym_token_tree,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62186] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(1140), 1,
      sym_line_comment,
    ACTIONS(4319), 1,
      aux_sym_token_repetition_pattern_token1,
    ACTIONS(4321), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [62201] = 5,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3853), 1,
      anon_sym_LBRACE,
    STATE(948), 1,
      sym_field_declaration_list,
    STATE(2042), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62218] = 5,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    STATE(937), 1,
      sym_enum_variant_list,
    STATE(2037), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62235] = 5,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(345), 1,
      sym_declaration_list,
    STATE(2026), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62252] = 5,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    STATE(768), 1,
      sym_declaration_list,
    STATE(2029), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62269] = 4,
    ACTIONS(4325), 1,
      anon_sym_COMMA,
    STATE(1635), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4323), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [62284] = 4,
    ACTIONS(4327), 1,
      anon_sym_DQUOTE,
    STATE(1656), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4329), 2,
      sym__string_content,
      sym_escape_sequence,
  [62299] = 5,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    STATE(734), 1,
      sym_declaration_list,
    STATE(2024), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62316] = 5,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(432), 1,
      sym_declaration_list,
    STATE(2131), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62333] = 5,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    STATE(1255), 1,
      sym_type_arguments,
    STATE(1804), 1,
      sym_trait_bounds,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62350] = 4,
    ACTIONS(4331), 1,
      anon_sym_DQUOTE,
    STATE(1670), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4309), 2,
      sym__string_content,
      sym_escape_sequence,
  [62365] = 5,
    ACTIONS(2440), 1,
      anon_sym_PLUS,
    ACTIONS(4333), 1,
      anon_sym_COMMA,
    ACTIONS(4335), 1,
      anon_sym_GT,
    STATE(1946), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62382] = 5,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4333), 1,
      anon_sym_COMMA,
    ACTIONS(4335), 1,
      anon_sym_GT,
    STATE(1946), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62399] = 4,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    STATE(1820), 1,
      sym_trait_bounds,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4337), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [62414] = 5,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4271), 1,
      anon_sym_RPAREN,
    ACTIONS(4273), 1,
      anon_sym_COMMA,
    STATE(1951), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62431] = 5,
    ACTIONS(4339), 1,
      anon_sym_LPAREN,
    ACTIONS(4341), 1,
      anon_sym_LBRACE,
    ACTIONS(4343), 1,
      anon_sym_LBRACK,
    STATE(1290), 1,
      sym_token_tree,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62448] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4345), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [62461] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(1140), 1,
      sym_line_comment,
    ACTIONS(4347), 1,
      aux_sym_token_repetition_pattern_token1,
    ACTIONS(4349), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [62476] = 5,
    ACTIONS(4351), 1,
      anon_sym_LPAREN,
    ACTIONS(4353), 1,
      anon_sym_LBRACE,
    ACTIONS(4355), 1,
      anon_sym_LBRACK,
    STATE(921), 1,
      sym_token_tree,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62493] = 5,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3839), 1,
      anon_sym_LT,
    STATE(1563), 1,
      sym_parameters,
    STATE(2047), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62510] = 4,
    ACTIONS(2282), 1,
      anon_sym_POUND,
    ACTIONS(4357), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    STATE(1055), 2,
      sym_attribute_item,
      aux_sym_enum_variant_list_repeat1,
  [62525] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4359), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [62538] = 5,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3853), 1,
      anon_sym_LBRACE,
    STATE(870), 1,
      sym_field_declaration_list,
    STATE(2151), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62555] = 5,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    STATE(914), 1,
      sym_declaration_list,
    STATE(1979), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62572] = 4,
    ACTIONS(4361), 1,
      anon_sym_DQUOTE,
    STATE(1670), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4363), 2,
      sym__string_content,
      sym_escape_sequence,
  [62587] = 5,
    ACTIONS(3757), 1,
      anon_sym_PIPE,
    ACTIONS(4366), 1,
      anon_sym_SEMI,
    ACTIONS(4368), 1,
      anon_sym_COLON,
    ACTIONS(4370), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62604] = 3,
    ACTIONS(4372), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3757), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [62617] = 4,
    ACTIONS(4158), 1,
      anon_sym_COLON,
    ACTIONS(4160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [62632] = 5,
    ACTIONS(2627), 1,
      anon_sym_LPAREN,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    STATE(943), 1,
      sym_parameters,
    STATE(1255), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62649] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(1140), 1,
      sym_line_comment,
    ACTIONS(4374), 1,
      aux_sym_token_repetition_pattern_token1,
    ACTIONS(4376), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [62664] = 5,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4251), 1,
      anon_sym_RPAREN,
    ACTIONS(4253), 1,
      anon_sym_COMMA,
    STATE(1809), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62681] = 5,
    ACTIONS(4255), 1,
      anon_sym_COMMA,
    ACTIONS(4257), 1,
      anon_sym_GT,
    ACTIONS(4378), 1,
      anon_sym_EQ,
    STATE(1943), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62698] = 5,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4380), 1,
      anon_sym_RPAREN,
    ACTIONS(4382), 1,
      anon_sym_COMMA,
    STATE(1939), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62715] = 5,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    STATE(923), 1,
      sym_enum_variant_list,
    STATE(2032), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62732] = 5,
    ACTIONS(4384), 1,
      anon_sym_LPAREN,
    ACTIONS(4386), 1,
      anon_sym_LBRACE,
    ACTIONS(4388), 1,
      anon_sym_LBRACK,
    STATE(979), 1,
      sym_token_tree,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62749] = 4,
    ACTIONS(4390), 1,
      anon_sym_DQUOTE,
    STATE(1670), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4309), 2,
      sym__string_content,
      sym_escape_sequence,
  [62764] = 4,
    ACTIONS(3), 1,
      sym_block_comment,
    ACTIONS(1140), 1,
      sym_line_comment,
    ACTIONS(4392), 1,
      aux_sym_token_repetition_pattern_token1,
    ACTIONS(4394), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [62779] = 3,
    ACTIONS(4396), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4398), 3,
      sym_self,
      sym_super,
      sym_crate,
  [62792] = 5,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(4400), 1,
      anon_sym_SEMI,
    ACTIONS(4402), 1,
      anon_sym_COLON,
    ACTIONS(4404), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62809] = 5,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(4406), 1,
      anon_sym_SEMI,
    ACTIONS(4408), 1,
      anon_sym_COLON,
    ACTIONS(4410), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62826] = 5,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(262), 1,
      sym_declaration_list,
    STATE(2085), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62843] = 5,
    ACTIONS(2440), 1,
      anon_sym_PLUS,
    ACTIONS(4412), 1,
      anon_sym_COMMA,
    ACTIONS(4414), 1,
      anon_sym_GT,
    STATE(1856), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62860] = 5,
    ACTIONS(3424), 1,
      anon_sym_LBRACE,
    ACTIONS(4162), 1,
      sym_identifier,
    ACTIONS(4164), 1,
      anon_sym_STAR,
    STATE(1888), 1,
      sym_use_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62877] = 4,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    STATE(1820), 1,
      sym_trait_bounds,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4416), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [62892] = 4,
    ACTIONS(4421), 1,
      anon_sym_COMMA,
    STATE(1690), 1,
      aux_sym_tuple_pattern_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4419), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
  [62907] = 3,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4419), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [62920] = 4,
    ACTIONS(4424), 1,
      anon_sym_DQUOTE,
    STATE(1681), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4426), 2,
      sym__string_content,
      sym_escape_sequence,
  [62935] = 5,
    ACTIONS(3424), 1,
      anon_sym_LBRACE,
    ACTIONS(4428), 1,
      sym_identifier,
    ACTIONS(4430), 1,
      anon_sym_STAR,
    STATE(1805), 1,
      sym_use_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62952] = 5,
    ACTIONS(903), 1,
      anon_sym_RPAREN,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4237), 1,
      anon_sym_COMMA,
    STATE(1757), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62969] = 5,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3839), 1,
      anon_sym_LT,
    STATE(1524), 1,
      sym_parameters,
    STATE(2122), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [62986] = 3,
    ACTIONS(4432), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4434), 3,
      sym_self,
      sym_super,
      sym_crate,
  [62999] = 5,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(302), 1,
      sym_declaration_list,
    STATE(2112), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63016] = 5,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4436), 1,
      anon_sym_RPAREN,
    ACTIONS(4438), 1,
      anon_sym_COMMA,
    STATE(1964), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63033] = 5,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3839), 1,
      anon_sym_LT,
    STATE(1547), 1,
      sym_parameters,
    STATE(2092), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63050] = 5,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3839), 1,
      anon_sym_LT,
    STATE(1544), 1,
      sym_parameters,
    STATE(2020), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63067] = 5,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3839), 1,
      anon_sym_LT,
    STATE(1555), 1,
      sym_parameters,
    STATE(2077), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63084] = 5,
    ACTIONS(4219), 1,
      anon_sym_RPAREN,
    ACTIONS(4223), 1,
      anon_sym_COMMA,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    STATE(1836), 1,
      aux_sym_tuple_pattern_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63101] = 5,
    ACTIONS(3835), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    STATE(339), 1,
      sym_field_declaration_list,
    STATE(2149), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63118] = 5,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4088), 1,
      anon_sym_LBRACE,
    STATE(273), 1,
      sym_enum_variant_list,
    STATE(2004), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63135] = 5,
    ACTIONS(4384), 1,
      anon_sym_LPAREN,
    ACTIONS(4386), 1,
      anon_sym_LBRACE,
    ACTIONS(4388), 1,
      anon_sym_LBRACK,
    STATE(1782), 1,
      sym_token_tree,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63152] = 5,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(4440), 1,
      anon_sym_RPAREN,
    ACTIONS(4442), 1,
      anon_sym_COMMA,
    STATE(1813), 1,
      aux_sym_tuple_pattern_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63169] = 5,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(4444), 1,
      anon_sym_RBRACK,
    ACTIONS(4446), 1,
      anon_sym_COMMA,
    STATE(1724), 1,
      aux_sym_tuple_pattern_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63186] = 5,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(319), 1,
      sym_declaration_list,
    STATE(2141), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63203] = 4,
    ACTIONS(4448), 1,
      anon_sym_DQUOTE,
    STATE(1642), 1,
      aux_sym_string_literal_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4450), 2,
      sym__string_content,
      sym_escape_sequence,
  [63218] = 5,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(296), 1,
      sym_declaration_list,
    STATE(2097), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63235] = 5,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4452), 1,
      anon_sym_RPAREN,
    ACTIONS(4454), 1,
      anon_sym_COMMA,
    STATE(1906), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63252] = 5,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    ACTIONS(3839), 1,
      anon_sym_LT,
    STATE(1510), 1,
      sym_parameters,
    STATE(2114), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63269] = 5,
    ACTIONS(3835), 1,
      anon_sym_LBRACE,
    ACTIONS(3837), 1,
      anon_sym_where,
    STATE(397), 1,
      sym_field_declaration_list,
    STATE(2155), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63286] = 3,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3472), 2,
      anon_sym_COLON,
      anon_sym_PIPE,
    ACTIONS(4456), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [63299] = 5,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4088), 1,
      anon_sym_LBRACE,
    STATE(440), 1,
      sym_enum_variant_list,
    STATE(2134), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63316] = 5,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4458), 1,
      anon_sym_RPAREN,
    ACTIONS(4460), 1,
      anon_sym_COMMA,
    STATE(1783), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63333] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4462), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [63346] = 5,
    ACTIONS(3757), 1,
      anon_sym_PIPE,
    ACTIONS(4464), 1,
      anon_sym_SEMI,
    ACTIONS(4466), 1,
      anon_sym_COLON,
    ACTIONS(4468), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63363] = 5,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    STATE(1255), 1,
      sym_type_arguments,
    STATE(1286), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63380] = 4,
    ACTIONS(4472), 1,
      anon_sym_COMMA,
    STATE(1720), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4470), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [63395] = 5,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4412), 1,
      anon_sym_COMMA,
    ACTIONS(4414), 1,
      anon_sym_GT,
    STATE(1856), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63412] = 5,
    ACTIONS(4186), 1,
      anon_sym_COMMA,
    ACTIONS(4188), 1,
      anon_sym_GT,
    ACTIONS(4378), 1,
      anon_sym_EQ,
    STATE(1819), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63429] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4475), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [63439] = 4,
    ACTIONS(2541), 1,
      anon_sym_RBRACK,
    ACTIONS(4477), 1,
      anon_sym_COMMA,
    STATE(1690), 1,
      aux_sym_tuple_pattern_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63453] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4479), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [63463] = 4,
    ACTIONS(4481), 1,
      anon_sym_RBRACE,
    ACTIONS(4483), 1,
      anon_sym_COMMA,
    STATE(1726), 1,
      aux_sym_enum_variant_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63477] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4486), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [63487] = 3,
    ACTIONS(4490), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4488), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [63499] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4492), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [63509] = 4,
    ACTIONS(3897), 1,
      anon_sym_RBRACE,
    ACTIONS(4494), 1,
      anon_sym_COMMA,
    STATE(1839), 1,
      aux_sym_field_initializer_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63523] = 4,
    ACTIONS(4496), 1,
      sym_identifier,
    ACTIONS(4498), 1,
      anon_sym_ref,
    ACTIONS(4500), 1,
      sym_mutable_specifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63537] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4502), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [63547] = 4,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(4162), 1,
      sym_identifier,
    STATE(2240), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63561] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4504), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [63571] = 4,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(4162), 1,
      sym_identifier,
    STATE(2277), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63585] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4506), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [63595] = 4,
    ACTIONS(4186), 1,
      anon_sym_COMMA,
    ACTIONS(4188), 1,
      anon_sym_GT,
    STATE(1819), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63609] = 4,
    ACTIONS(3889), 1,
      anon_sym_RBRACE,
    ACTIONS(4508), 1,
      anon_sym_COMMA,
    STATE(1726), 1,
      aux_sym_enum_variant_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63623] = 4,
    ACTIONS(4510), 1,
      sym_identifier,
    ACTIONS(4512), 1,
      anon_sym_ref,
    ACTIONS(4514), 1,
      sym_mutable_specifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63637] = 4,
    ACTIONS(4516), 1,
      sym_identifier,
    ACTIONS(4518), 1,
      anon_sym_ref,
    ACTIONS(4520), 1,
      sym_mutable_specifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63651] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4470), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [63661] = 4,
    ACTIONS(4522), 1,
      anon_sym_RBRACE,
    ACTIONS(4524), 1,
      anon_sym_COMMA,
    STATE(1847), 1,
      aux_sym_struct_pattern_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63675] = 4,
    ACTIONS(4526), 1,
      anon_sym_RBRACE,
    ACTIONS(4528), 1,
      anon_sym_COMMA,
    STATE(1751), 1,
      aux_sym_use_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63689] = 3,
    ACTIONS(4532), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4530), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [63701] = 3,
    ACTIONS(4221), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4534), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [63713] = 4,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(4536), 1,
      anon_sym_EQ,
    STATE(2359), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63727] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3126), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_where,
  [63737] = 4,
    ACTIONS(4534), 1,
      anon_sym_PIPE,
    ACTIONS(4538), 1,
      anon_sym_COMMA,
    STATE(1748), 1,
      aux_sym_closure_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63751] = 4,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(971), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63765] = 4,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4541), 1,
      anon_sym_SEMI,
    ACTIONS(4543), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63779] = 4,
    ACTIONS(3442), 1,
      anon_sym_RBRACE,
    ACTIONS(4545), 1,
      anon_sym_COMMA,
    STATE(1857), 1,
      aux_sym_use_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63793] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4456), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [63805] = 4,
    ACTIONS(4456), 1,
      anon_sym_RPAREN,
    ACTIONS(4547), 1,
      anon_sym_COMMA,
    STATE(1753), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63819] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3130), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_where,
  [63829] = 3,
    ACTIONS(3394), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4217), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [63841] = 3,
    ACTIONS(4552), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4550), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [63853] = 4,
    ACTIONS(825), 1,
      anon_sym_RPAREN,
    ACTIONS(4554), 1,
      anon_sym_COMMA,
    STATE(1753), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63867] = 4,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(4556), 1,
      sym_identifier,
    STATE(2277), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63881] = 4,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4558), 1,
      anon_sym_SEMI,
    STATE(289), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63895] = 3,
    ACTIONS(4562), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4560), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [63907] = 3,
    ACTIONS(4115), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [63919] = 3,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4564), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [63931] = 4,
    ACTIONS(4566), 1,
      anon_sym_RBRACE,
    ACTIONS(4568), 1,
      anon_sym_COMMA,
    STATE(1763), 1,
      aux_sym_struct_pattern_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63945] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4571), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [63957] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4573), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [63969] = 4,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4575), 1,
      anon_sym_SEMI,
    STATE(2208), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [63983] = 3,
    ACTIONS(2440), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4573), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [63995] = 4,
    ACTIONS(4577), 1,
      anon_sym_for,
    ACTIONS(4579), 1,
      anon_sym_loop,
    ACTIONS(4581), 1,
      anon_sym_while,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64009] = 4,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(4556), 1,
      sym_identifier,
    STATE(2240), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64023] = 3,
    ACTIONS(4202), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [64035] = 4,
    ACTIONS(4573), 1,
      anon_sym_GT,
    ACTIONS(4583), 1,
      anon_sym_COMMA,
    STATE(1771), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64049] = 4,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(4586), 1,
      anon_sym_GT,
    STATE(2061), 1,
      sym_lifetime,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64063] = 4,
    ACTIONS(4588), 1,
      anon_sym_COMMA,
    ACTIONS(4591), 1,
      anon_sym_GT,
    STATE(1773), 1,
      aux_sym_for_lifetimes_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64077] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4593), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [64089] = 4,
    ACTIONS(2653), 1,
      anon_sym_LBRACE,
    ACTIONS(4595), 1,
      anon_sym_COLON_COLON,
    STATE(965), 1,
      sym_field_initializer_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64103] = 4,
    ACTIONS(4412), 1,
      anon_sym_COMMA,
    ACTIONS(4414), 1,
      anon_sym_GT,
    STATE(1856), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64117] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4597), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [64127] = 4,
    ACTIONS(475), 1,
      anon_sym_RPAREN,
    ACTIONS(3202), 1,
      anon_sym_COMMA,
    STATE(1788), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64141] = 4,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(4599), 1,
      anon_sym_move,
    STATE(1013), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64155] = 4,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4601), 1,
      anon_sym_SEMI,
    STATE(2274), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64169] = 4,
    ACTIONS(4603), 1,
      anon_sym_RBRACE,
    ACTIONS(4605), 1,
      anon_sym_COMMA,
    STATE(1861), 1,
      aux_sym_struct_pattern_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64183] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4607), 3,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [64193] = 4,
    ACTIONS(2533), 1,
      anon_sym_RPAREN,
    ACTIONS(4609), 1,
      anon_sym_COMMA,
    STATE(1867), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64207] = 4,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4611), 1,
      anon_sym_SEMI,
    ACTIONS(4613), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64221] = 4,
    ACTIONS(505), 1,
      anon_sym_RPAREN,
    ACTIONS(4615), 1,
      anon_sym_COMMA,
    STATE(1788), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64235] = 3,
    ACTIONS(4160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [64247] = 4,
    ACTIONS(4617), 1,
      anon_sym_COMMA,
    ACTIONS(4619), 1,
      anon_sym_GT,
    STATE(1889), 1,
      aux_sym_for_lifetimes_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64261] = 4,
    ACTIONS(3304), 1,
      anon_sym_RPAREN,
    ACTIONS(4621), 1,
      anon_sym_COMMA,
    STATE(1788), 1,
      aux_sym_arguments_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64275] = 4,
    ACTIONS(2352), 1,
      anon_sym_RPAREN,
    ACTIONS(4624), 1,
      anon_sym_COMMA,
    STATE(1792), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64289] = 4,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(4626), 1,
      sym_identifier,
    STATE(2277), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64303] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4628), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [64315] = 4,
    ACTIONS(4630), 1,
      anon_sym_RPAREN,
    ACTIONS(4632), 1,
      anon_sym_COMMA,
    STATE(1792), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64329] = 3,
    ACTIONS(4637), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4635), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [64341] = 4,
    ACTIONS(3847), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_COMMA,
    STATE(1726), 1,
      aux_sym_enum_variant_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64355] = 4,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4641), 1,
      anon_sym_SEMI,
    STATE(418), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64369] = 4,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(3797), 1,
      anon_sym_LBRACE,
    STATE(1255), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64383] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4643), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [64395] = 4,
    ACTIONS(4645), 1,
      anon_sym_RBRACE,
    ACTIONS(4647), 1,
      anon_sym_COMMA,
    STATE(1798), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64409] = 4,
    ACTIONS(3847), 1,
      anon_sym_RBRACE,
    ACTIONS(4639), 1,
      anon_sym_COMMA,
    STATE(1738), 1,
      aux_sym_enum_variant_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64423] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4650), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [64433] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4652), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [64443] = 4,
    ACTIONS(3841), 1,
      anon_sym_RBRACE,
    ACTIONS(4654), 1,
      anon_sym_COMMA,
    STATE(1798), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64457] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4656), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [64467] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4658), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_COMMA,
  [64477] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4660), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [64487] = 4,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4662), 1,
      anon_sym_SEMI,
    STATE(406), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64501] = 4,
    ACTIONS(4664), 1,
      anon_sym_for,
    ACTIONS(4666), 1,
      anon_sym_loop,
    ACTIONS(4668), 1,
      anon_sym_while,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64515] = 4,
    ACTIONS(735), 1,
      anon_sym_RBRACK,
    ACTIONS(3170), 1,
      anon_sym_COMMA,
    STATE(1926), 1,
      aux_sym_array_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64529] = 4,
    ACTIONS(903), 1,
      anon_sym_RPAREN,
    ACTIONS(4237), 1,
      anon_sym_COMMA,
    STATE(1753), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64543] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4670), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [64553] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4672), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [64563] = 4,
    ACTIONS(903), 1,
      anon_sym_RPAREN,
    ACTIONS(4237), 1,
      anon_sym_COMMA,
    STATE(1757), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64577] = 4,
    ACTIONS(2539), 1,
      anon_sym_RPAREN,
    ACTIONS(4674), 1,
      anon_sym_COMMA,
    STATE(1690), 1,
      aux_sym_tuple_pattern_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64591] = 4,
    ACTIONS(3869), 1,
      anon_sym_GT,
    ACTIONS(4676), 1,
      anon_sym_COMMA,
    STATE(1936), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64605] = 3,
    ACTIONS(4127), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3482), 2,
      anon_sym_DOT_DOT_DOT,
      anon_sym_DOT_DOT_EQ,
  [64617] = 4,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4678), 1,
      anon_sym_SEMI,
    STATE(373), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64631] = 4,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4680), 1,
      anon_sym_SEMI,
    STATE(2162), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64645] = 4,
    ACTIONS(2653), 1,
      anon_sym_LBRACE,
    ACTIONS(4682), 1,
      anon_sym_COLON_COLON,
    STATE(965), 1,
      sym_field_initializer_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64659] = 4,
    ACTIONS(3865), 1,
      anon_sym_GT,
    ACTIONS(4684), 1,
      anon_sym_COMMA,
    STATE(1936), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64673] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4686), 3,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_GT,
  [64683] = 4,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    ACTIONS(4688), 1,
      anon_sym_move,
    STATE(235), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64697] = 4,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(4690), 1,
      sym_identifier,
    STATE(2277), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64711] = 4,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4692), 1,
      anon_sym_SEMI,
    STATE(249), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64725] = 4,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4694), 1,
      anon_sym_SEMI,
    STATE(402), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64739] = 4,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(4690), 1,
      sym_identifier,
    STATE(2240), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64753] = 4,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4696), 1,
      anon_sym_SEMI,
    ACTIONS(4698), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64767] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4700), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [64777] = 4,
    ACTIONS(2440), 1,
      anon_sym_PLUS,
    ACTIONS(4702), 1,
      sym_mutable_specifier,
    ACTIONS(4704), 1,
      sym_self,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64791] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4706), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [64801] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4708), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [64811] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4710), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [64821] = 4,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    ACTIONS(4712), 1,
      anon_sym_SEMI,
    STATE(341), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64835] = 4,
    ACTIONS(4251), 1,
      anon_sym_RPAREN,
    ACTIONS(4253), 1,
      anon_sym_COMMA,
    STATE(1809), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64849] = 4,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(4714), 1,
      sym_identifier,
    STATE(2277), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64863] = 4,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(4714), 1,
      sym_identifier,
    STATE(2240), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64877] = 4,
    ACTIONS(2555), 1,
      anon_sym_RPAREN,
    ACTIONS(4716), 1,
      anon_sym_COMMA,
    STATE(1690), 1,
      aux_sym_tuple_pattern_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64891] = 4,
    ACTIONS(3380), 1,
      anon_sym_RPAREN,
    ACTIONS(4718), 1,
      anon_sym_COMMA,
    STATE(1910), 1,
      aux_sym_meta_arguments_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64905] = 4,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4720), 1,
      anon_sym_SEMI,
    STATE(414), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64919] = 4,
    ACTIONS(4722), 1,
      anon_sym_RBRACE,
    ACTIONS(4724), 1,
      anon_sym_COMMA,
    STATE(1839), 1,
      aux_sym_field_initializer_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64933] = 4,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4727), 1,
      anon_sym_SEMI,
    STATE(332), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64947] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4729), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [64959] = 4,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(4731), 1,
      anon_sym_SEMI,
    STATE(874), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64973] = 4,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(4733), 1,
      sym_identifier,
    STATE(2277), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [64987] = 4,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(4733), 1,
      sym_identifier,
    STATE(2240), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65001] = 3,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4735), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [65013] = 3,
    ACTIONS(4739), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4737), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [65025] = 4,
    ACTIONS(4074), 1,
      anon_sym_RBRACE,
    ACTIONS(4741), 1,
      anon_sym_COMMA,
    STATE(1763), 1,
      aux_sym_struct_pattern_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65039] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4743), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [65049] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4745), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [65059] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4747), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [65069] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4749), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [65079] = 4,
    ACTIONS(4751), 1,
      anon_sym_RPAREN,
    ACTIONS(4753), 1,
      anon_sym_COMMA,
    STATE(1837), 1,
      aux_sym_meta_arguments_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65093] = 4,
    ACTIONS(2635), 1,
      anon_sym_LT2,
    ACTIONS(4755), 1,
      sym_identifier,
    STATE(1187), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65107] = 4,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4757), 1,
      anon_sym_SEMI,
    ACTIONS(4759), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65121] = 4,
    ACTIONS(4761), 1,
      anon_sym_RBRACE,
    ACTIONS(4763), 1,
      anon_sym_COMMA,
    STATE(1794), 1,
      aux_sym_enum_variant_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65135] = 4,
    ACTIONS(1107), 1,
      anon_sym_GT,
    ACTIONS(4765), 1,
      anon_sym_COMMA,
    STATE(1771), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65149] = 4,
    ACTIONS(4767), 1,
      anon_sym_RBRACE,
    ACTIONS(4769), 1,
      anon_sym_COMMA,
    STATE(1857), 1,
      aux_sym_use_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65163] = 4,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(4772), 1,
      sym_identifier,
    STATE(2277), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65177] = 4,
    ACTIONS(2635), 1,
      anon_sym_LT2,
    ACTIONS(4755), 1,
      sym_identifier,
    STATE(1186), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65191] = 4,
    ACTIONS(4774), 1,
      anon_sym_for,
    ACTIONS(4776), 1,
      anon_sym_loop,
    ACTIONS(4778), 1,
      anon_sym_while,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65205] = 4,
    ACTIONS(4046), 1,
      anon_sym_RBRACE,
    ACTIONS(4780), 1,
      anon_sym_COMMA,
    STATE(1763), 1,
      aux_sym_struct_pattern_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65219] = 4,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4782), 1,
      anon_sym_SEMI,
    STATE(391), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65233] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4784), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [65245] = 4,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(4772), 1,
      sym_identifier,
    STATE(2240), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65259] = 4,
    ACTIONS(3581), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3585), 1,
      anon_sym_COLON,
    STATE(1804), 1,
      sym_trait_bounds,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65273] = 4,
    ACTIONS(2635), 1,
      anon_sym_LT2,
    ACTIONS(4786), 1,
      sym_identifier,
    STATE(738), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65287] = 4,
    ACTIONS(4784), 1,
      anon_sym_RPAREN,
    ACTIONS(4788), 1,
      anon_sym_COMMA,
    STATE(1867), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65301] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4791), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [65311] = 4,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(4793), 1,
      sym_identifier,
    STATE(2240), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65325] = 4,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(4626), 1,
      sym_identifier,
    STATE(2240), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65339] = 4,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(4795), 1,
      anon_sym_SEMI,
    STATE(906), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65353] = 4,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(4797), 1,
      anon_sym_SEMI,
    STATE(903), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65367] = 4,
    ACTIONS(3484), 1,
      anon_sym_LT2,
    ACTIONS(4793), 1,
      sym_identifier,
    STATE(2277), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65381] = 4,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(4799), 1,
      anon_sym_SEMI,
    STATE(899), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65395] = 4,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4801), 1,
      anon_sym_SEMI,
    ACTIONS(4803), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65409] = 4,
    ACTIONS(4805), 1,
      sym_identifier,
    ACTIONS(4807), 1,
      anon_sym_await,
    ACTIONS(4809), 1,
      sym_integer_literal,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65423] = 4,
    ACTIONS(4255), 1,
      anon_sym_COMMA,
    ACTIONS(4257), 1,
      anon_sym_GT,
    STATE(1943), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65437] = 4,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4811), 1,
      anon_sym_SEMI,
    STATE(2280), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65451] = 4,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4813), 1,
      anon_sym_SEMI,
    STATE(357), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65465] = 4,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(4815), 1,
      anon_sym_EQ_GT,
    ACTIONS(4817), 1,
      anon_sym_if,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65479] = 4,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(4819), 1,
      anon_sym_SEMI,
    STATE(891), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65493] = 4,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4821), 1,
      anon_sym_SEMI,
    ACTIONS(4823), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65507] = 4,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(4825), 1,
      anon_sym_SEMI,
    STATE(882), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65521] = 4,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(4827), 1,
      anon_sym_SEMI,
    STATE(868), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65535] = 4,
    ACTIONS(3899), 1,
      anon_sym_RBRACE,
    ACTIONS(4829), 1,
      anon_sym_COMMA,
    STATE(1802), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65549] = 4,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(4831), 1,
      anon_sym_SEMI,
    STATE(861), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65563] = 4,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    ACTIONS(4833), 1,
      anon_sym_GT,
    STATE(2061), 1,
      sym_lifetime,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65577] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4835), 3,
      anon_sym_SEMI,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [65587] = 4,
    ACTIONS(4833), 1,
      anon_sym_GT,
    ACTIONS(4837), 1,
      anon_sym_COMMA,
    STATE(1773), 1,
      aux_sym_for_lifetimes_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65601] = 4,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4839), 1,
      anon_sym_SEMI,
    STATE(2375), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65615] = 4,
    ACTIONS(3899), 1,
      anon_sym_RBRACE,
    ACTIONS(4829), 1,
      anon_sym_COMMA,
    STATE(1798), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65629] = 4,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4841), 1,
      anon_sym_SEMI,
    ACTIONS(4843), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65643] = 4,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(4845), 1,
      anon_sym_SEMI,
    STATE(842), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65657] = 4,
    ACTIONS(4303), 1,
      anon_sym_COMMA,
    ACTIONS(4847), 1,
      anon_sym_PIPE,
    STATE(1748), 1,
      aux_sym_closure_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65671] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4849), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [65683] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3134), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_where,
  [65693] = 4,
    ACTIONS(3901), 1,
      anon_sym_RBRACE,
    ACTIONS(4851), 1,
      anon_sym_COMMA,
    STATE(1798), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65707] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3119), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_where,
  [65717] = 3,
    ACTIONS(4855), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4853), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [65729] = 4,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4857), 1,
      anon_sym_SEMI,
    STATE(380), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65743] = 4,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4859), 1,
      anon_sym_SEMI,
    ACTIONS(4861), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65757] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4301), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [65769] = 4,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4863), 1,
      anon_sym_as,
    ACTIONS(4865), 1,
      anon_sym_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65783] = 4,
    ACTIONS(4867), 1,
      anon_sym_RBRACE,
    ACTIONS(4869), 1,
      anon_sym_COMMA,
    STATE(1730), 1,
      aux_sym_field_initializer_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65797] = 4,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(4871), 1,
      anon_sym_SEMI,
    STATE(798), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65811] = 4,
    ACTIONS(2344), 1,
      anon_sym_RPAREN,
    ACTIONS(4873), 1,
      anon_sym_COMMA,
    STATE(1792), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65825] = 3,
    ACTIONS(4378), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4337), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [65837] = 4,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    ACTIONS(4875), 1,
      anon_sym_SEMI,
    STATE(825), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65851] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4877), 3,
      anon_sym_PLUS,
      anon_sym_STAR,
      anon_sym_QMARK,
  [65861] = 4,
    ACTIONS(4879), 1,
      anon_sym_RPAREN,
    ACTIONS(4881), 1,
      anon_sym_COMMA,
    STATE(1910), 1,
      aux_sym_meta_arguments_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65875] = 4,
    ACTIONS(819), 1,
      anon_sym_RPAREN,
    ACTIONS(4884), 1,
      anon_sym_COMMA,
    STATE(1753), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65889] = 3,
    ACTIONS(3394), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4886), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [65901] = 4,
    ACTIONS(3891), 1,
      anon_sym_RBRACE,
    ACTIONS(4888), 1,
      anon_sym_COMMA,
    STATE(1726), 1,
      aux_sym_enum_variant_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65915] = 4,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4890), 1,
      anon_sym_SEMI,
    ACTIONS(4892), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65929] = 4,
    ACTIONS(4096), 1,
      anon_sym_LBRACE,
    ACTIONS(4894), 1,
      anon_sym_SEMI,
    STATE(365), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65943] = 4,
    ACTIONS(727), 1,
      anon_sym_RBRACK,
    ACTIONS(4896), 1,
      anon_sym_COMMA,
    STATE(1926), 1,
      aux_sym_array_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65957] = 4,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4898), 1,
      anon_sym_SEMI,
    STATE(2289), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65971] = 4,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4900), 1,
      anon_sym_SEMI,
    ACTIONS(4902), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65985] = 4,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4904), 1,
      anon_sym_SEMI,
    ACTIONS(4906), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [65999] = 4,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(4908), 1,
      anon_sym_SEMI,
    STATE(787), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66013] = 4,
    ACTIONS(4910), 1,
      anon_sym_RBRACE,
    ACTIONS(4912), 1,
      anon_sym_COMMA,
    STATE(1954), 1,
      aux_sym_enum_variant_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66027] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4914), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [66037] = 4,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4916), 1,
      anon_sym_SEMI,
    ACTIONS(4918), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66051] = 3,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4920), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [66063] = 4,
    ACTIONS(4922), 1,
      sym_identifier,
    ACTIONS(4924), 1,
      anon_sym_ref,
    ACTIONS(4926), 1,
      sym_mutable_specifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66077] = 4,
    ACTIONS(3300), 1,
      anon_sym_RBRACK,
    ACTIONS(4928), 1,
      anon_sym_COMMA,
    STATE(1926), 1,
      aux_sym_array_expression_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66091] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3140), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_where,
  [66101] = 4,
    ACTIONS(4271), 1,
      anon_sym_RPAREN,
    ACTIONS(4273), 1,
      anon_sym_COMMA,
    STATE(1951), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66115] = 4,
    ACTIONS(3887), 1,
      anon_sym_RBRACE,
    ACTIONS(4931), 1,
      anon_sym_COMMA,
    STATE(1897), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66129] = 4,
    ACTIONS(4933), 1,
      anon_sym_RBRACE,
    ACTIONS(4935), 1,
      anon_sym_COMMA,
    STATE(1891), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66143] = 4,
    ACTIONS(3887), 1,
      anon_sym_RBRACE,
    ACTIONS(4931), 1,
      anon_sym_COMMA,
    STATE(1798), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66157] = 4,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(4937), 1,
      anon_sym_SEMI,
    STATE(760), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66171] = 4,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4939), 1,
      anon_sym_SEMI,
    ACTIONS(4941), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66185] = 4,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4943), 1,
      anon_sym_SEMI,
    ACTIONS(4945), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66199] = 4,
    ACTIONS(4333), 1,
      anon_sym_COMMA,
    ACTIONS(4335), 1,
      anon_sym_GT,
    STATE(1946), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66213] = 4,
    ACTIONS(4337), 1,
      anon_sym_GT,
    ACTIONS(4947), 1,
      anon_sym_COMMA,
    STATE(1936), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66227] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(3144), 3,
      anon_sym_LBRACE,
      anon_sym_COLON,
      anon_sym_where,
  [66237] = 4,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4950), 1,
      anon_sym_SEMI,
    ACTIONS(4952), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66251] = 4,
    ACTIONS(2515), 1,
      anon_sym_RPAREN,
    ACTIONS(4954), 1,
      anon_sym_COMMA,
    STATE(1867), 1,
      aux_sym_tuple_type_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66265] = 4,
    ACTIONS(3424), 1,
      anon_sym_LBRACE,
    ACTIONS(4956), 1,
      sym_identifier,
    STATE(1831), 1,
      sym_use_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66279] = 4,
    ACTIONS(3823), 1,
      anon_sym_GT,
    ACTIONS(4958), 1,
      anon_sym_COMMA,
    STATE(1936), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66293] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4960), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [66305] = 4,
    ACTIONS(3879), 1,
      anon_sym_GT,
    ACTIONS(4962), 1,
      anon_sym_COMMA,
    STATE(1936), 1,
      aux_sym_type_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66319] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4964), 3,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_COMMA,
  [66329] = 4,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    ACTIONS(4966), 1,
      anon_sym_SEMI,
    STATE(438), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66343] = 4,
    ACTIONS(1093), 1,
      anon_sym_GT,
    ACTIONS(4968), 1,
      anon_sym_COMMA,
    STATE(1771), 1,
      aux_sym_type_arguments_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66357] = 4,
    ACTIONS(1087), 1,
      anon_sym_LBRACE,
    ACTIONS(4970), 1,
      anon_sym_SEMI,
    STATE(941), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66371] = 4,
    ACTIONS(983), 1,
      anon_sym_RPAREN,
    ACTIONS(4293), 1,
      anon_sym_COMMA,
    STATE(1911), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66385] = 4,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4972), 1,
      anon_sym_SEMI,
    ACTIONS(4974), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66399] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4976), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [66411] = 4,
    ACTIONS(983), 1,
      anon_sym_RPAREN,
    ACTIONS(4293), 1,
      anon_sym_COMMA,
    STATE(1753), 1,
      aux_sym_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66425] = 4,
    ACTIONS(4303), 1,
      anon_sym_COMMA,
    ACTIONS(4978), 1,
      anon_sym_PIPE,
    STATE(1894), 1,
      aux_sym_closure_parameters_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66439] = 4,
    ACTIONS(3881), 1,
      anon_sym_RBRACE,
    ACTIONS(4980), 1,
      anon_sym_COMMA,
    STATE(1913), 1,
      aux_sym_enum_variant_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66453] = 4,
    ACTIONS(3881), 1,
      anon_sym_RBRACE,
    ACTIONS(4980), 1,
      anon_sym_COMMA,
    STATE(1726), 1,
      aux_sym_enum_variant_list_repeat2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66467] = 4,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    STATE(1009), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66481] = 4,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4982), 1,
      anon_sym_SEMI,
    ACTIONS(4984), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66495] = 4,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(4986), 1,
      anon_sym_SEMI,
    ACTIONS(4988), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66509] = 4,
    ACTIONS(4990), 1,
      anon_sym_RBRACE,
    ACTIONS(4992), 1,
      anon_sym_COMMA,
    STATE(1931), 1,
      aux_sym_field_declaration_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66523] = 4,
    ACTIONS(2635), 1,
      anon_sym_LT2,
    ACTIONS(4786), 1,
      sym_identifier,
    STATE(792), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66537] = 4,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4994), 1,
      anon_sym_SEMI,
    STATE(2348), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66551] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4996), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [66563] = 4,
    ACTIONS(3837), 1,
      anon_sym_where,
    ACTIONS(4998), 1,
      anon_sym_SEMI,
    STATE(2336), 1,
      sym_where_clause,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66577] = 4,
    ACTIONS(3575), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3585), 1,
      anon_sym_COLON,
    STATE(1800), 1,
      sym_trait_bounds,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66591] = 4,
    ACTIONS(2358), 1,
      anon_sym_RPAREN,
    ACTIONS(5000), 1,
      anon_sym_COMMA,
    STATE(1792), 1,
      aux_sym_ordered_field_declaration_list_repeat1,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66605] = 4,
    ACTIONS(3839), 1,
      anon_sym_LT,
    ACTIONS(5002), 1,
      anon_sym_EQ,
    STATE(2302), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66619] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(317), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66630] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(5004), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66641] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(926), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66652] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(913), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66663] = 3,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    STATE(1282), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66674] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5006), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [66683] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5008), 2,
      sym_identifier,
      sym_metavariable,
  [66692] = 3,
    ACTIONS(15), 1,
      anon_sym_LBRACE,
    STATE(56), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66703] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5010), 2,
      sym_identifier,
      sym_metavariable,
  [66712] = 3,
    ACTIONS(5012), 1,
      sym_identifier,
    ACTIONS(5014), 1,
      sym_mutable_specifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66723] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(736), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66734] = 3,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    STATE(863), 1,
      sym_enum_variant_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66745] = 3,
    ACTIONS(4036), 1,
      anon_sym_COLON,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66756] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(742), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66767] = 3,
    ACTIONS(3853), 1,
      anon_sym_LBRACE,
    STATE(945), 1,
      sym_field_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66778] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(266), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66789] = 3,
    ACTIONS(3853), 1,
      anon_sym_LBRACE,
    STATE(949), 1,
      sym_field_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66800] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5016), 2,
      sym_identifier,
      sym_metavariable,
  [66809] = 3,
    ACTIONS(4496), 1,
      sym_identifier,
    ACTIONS(4500), 1,
      sym_mutable_specifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66820] = 3,
    ACTIONS(5018), 1,
      anon_sym_SEMI,
    ACTIONS(5020), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66831] = 3,
    ACTIONS(3853), 1,
      anon_sym_LBRACE,
    STATE(743), 1,
      sym_field_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66842] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(5022), 1,
      anon_sym_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66853] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(284), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66864] = 3,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(5024), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66875] = 3,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(5026), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66886] = 3,
    ACTIONS(5028), 1,
      anon_sym_SEMI,
    ACTIONS(5030), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66897] = 3,
    ACTIONS(4024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5032), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66908] = 3,
    ACTIONS(4084), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5032), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66919] = 3,
    ACTIONS(4050), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5032), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66930] = 3,
    ACTIONS(15), 1,
      anon_sym_LBRACE,
    STATE(48), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66941] = 3,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(5034), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66952] = 3,
    ACTIONS(3633), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5036), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66963] = 3,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(5038), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66974] = 3,
    ACTIONS(4076), 1,
      anon_sym_RPAREN,
    ACTIONS(5028), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66985] = 3,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(5040), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [66996] = 3,
    ACTIONS(5042), 1,
      sym_identifier,
    ACTIONS(5044), 1,
      sym_mutable_specifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67007] = 3,
    ACTIONS(4080), 1,
      anon_sym_RBRACE,
    ACTIONS(5028), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67018] = 3,
    ACTIONS(2627), 1,
      anon_sym_LPAREN,
    STATE(753), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67029] = 3,
    ACTIONS(4088), 1,
      anon_sym_LBRACE,
    STATE(396), 1,
      sym_enum_variant_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67040] = 3,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(5046), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67051] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(754), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67062] = 3,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(5048), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67073] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(370), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67084] = 3,
    ACTIONS(4050), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5050), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67095] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4534), 2,
      anon_sym_COMMA,
      anon_sym_PIPE,
  [67104] = 3,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(2061), 1,
      sym_lifetime,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67115] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(823), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67126] = 3,
    ACTIONS(4024), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5050), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67137] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5052), 2,
      sym_identifier,
      sym_metavariable,
  [67146] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(735), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67157] = 3,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(5054), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67168] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4456), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [67177] = 3,
    ACTIONS(2278), 1,
      anon_sym_SQUOTE,
    STATE(1787), 1,
      sym_lifetime,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67188] = 3,
    ACTIONS(3611), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5056), 1,
      anon_sym_BANG,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67199] = 3,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    STATE(1532), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67210] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(371), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67221] = 3,
    ACTIONS(3627), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5056), 1,
      anon_sym_BANG,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67232] = 3,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(5058), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67243] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(773), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67254] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(5060), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67265] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(387), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67276] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(776), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67287] = 3,
    ACTIONS(4084), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5050), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67298] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(778), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67309] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(779), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67320] = 3,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(5062), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67331] = 3,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    STATE(788), 1,
      sym_enum_variant_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67342] = 3,
    ACTIONS(2971), 1,
      anon_sym_COLON,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67353] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5064), 2,
      sym_identifier,
      sym_metavariable,
  [67362] = 3,
    ACTIONS(5066), 1,
      sym_identifier,
    ACTIONS(5068), 1,
      sym_mutable_specifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67373] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4879), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [67382] = 3,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    STATE(791), 1,
      sym_enum_variant_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67393] = 3,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(5070), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67404] = 3,
    ACTIONS(4068), 1,
      anon_sym_RBRACE,
    ACTIONS(5028), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67415] = 3,
    ACTIONS(3853), 1,
      anon_sym_LBRACE,
    STATE(896), 1,
      sym_field_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67426] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(5072), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67437] = 3,
    ACTIONS(3853), 1,
      anon_sym_LBRACE,
    STATE(801), 1,
      sym_field_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67448] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(805), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67459] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4217), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [67468] = 3,
    ACTIONS(5074), 1,
      anon_sym_LBRACK,
    ACTIONS(5076), 1,
      anon_sym_BANG,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67479] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5078), 2,
      sym_identifier,
      sym_metavariable,
  [67488] = 3,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    STATE(1515), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67499] = 3,
    ACTIONS(4088), 1,
      anon_sym_LBRACE,
    STATE(437), 1,
      sym_enum_variant_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67510] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4566), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [67519] = 3,
    ACTIONS(5080), 1,
      anon_sym_LBRACK,
    ACTIONS(5082), 1,
      anon_sym_BANG,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67530] = 3,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    STATE(999), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67541] = 3,
    ACTIONS(2885), 1,
      anon_sym_COLON,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67552] = 3,
    ACTIONS(2881), 1,
      anon_sym_COLON,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67563] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4573), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [67572] = 3,
    ACTIONS(3835), 1,
      anon_sym_LBRACE,
    STATE(447), 1,
      sym_field_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67583] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4337), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [67592] = 3,
    ACTIONS(85), 1,
      anon_sym_PIPE,
    STATE(86), 1,
      sym_closure_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67603] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(826), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67614] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(827), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67625] = 3,
    ACTIONS(5084), 1,
      anon_sym_SEMI,
    ACTIONS(5086), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67636] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4591), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [67645] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4301), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [67654] = 3,
    ACTIONS(3835), 1,
      anon_sym_LBRACE,
    STATE(398), 1,
      sym_field_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67665] = 3,
    ACTIONS(3853), 1,
      anon_sym_LBRACE,
    STATE(895), 1,
      sym_field_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67676] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(834), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67687] = 3,
    ACTIONS(5088), 1,
      anon_sym_SEMI,
    ACTIONS(5090), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67698] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(309), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67709] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(837), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67720] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(839), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67731] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(925), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67742] = 3,
    ACTIONS(3853), 1,
      anon_sym_LBRACE,
    STATE(934), 1,
      sym_field_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67753] = 3,
    ACTIONS(3055), 1,
      anon_sym_COLON,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67764] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(5092), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67775] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(850), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67786] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(852), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67797] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(310), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67808] = 3,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    STATE(1561), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67819] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5094), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [67828] = 3,
    ACTIONS(2653), 1,
      anon_sym_LBRACE,
    STATE(965), 1,
      sym_field_initializer_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67839] = 3,
    ACTIONS(5096), 1,
      anon_sym_LPAREN,
    ACTIONS(5098), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67850] = 3,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(5100), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67861] = 3,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    STATE(1020), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67872] = 3,
    ACTIONS(5102), 1,
      anon_sym_SEMI,
    ACTIONS(5104), 1,
      anon_sym_as,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67883] = 3,
    ACTIONS(5028), 1,
      anon_sym_SEMI,
    ACTIONS(5106), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67894] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(395), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67905] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(5108), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67916] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(875), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67927] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(876), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67938] = 3,
    ACTIONS(3633), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5110), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67949] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(947), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67960] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(450), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67971] = 3,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    STATE(1553), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67982] = 3,
    ACTIONS(3829), 1,
      anon_sym_LBRACE,
    STATE(887), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [67993] = 3,
    ACTIONS(2627), 1,
      anon_sym_LPAREN,
    STATE(950), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68004] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(268), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68015] = 3,
    ACTIONS(15), 1,
      anon_sym_LBRACE,
    STATE(37), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68026] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(443), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68037] = 3,
    ACTIONS(3835), 1,
      anon_sym_LBRACE,
    STATE(248), 1,
      sym_field_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68048] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(441), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68059] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4481), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [68068] = 3,
    ACTIONS(3835), 1,
      anon_sym_LBRACE,
    STATE(300), 1,
      sym_field_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68079] = 3,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(5112), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68090] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5114), 2,
      sym_float_literal,
      sym_integer_literal,
  [68099] = 3,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    STATE(240), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68110] = 3,
    ACTIONS(3839), 1,
      anon_sym_LT,
    STATE(568), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68121] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(344), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68132] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(316), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68143] = 3,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    STATE(228), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68154] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(295), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68165] = 3,
    ACTIONS(3941), 1,
      anon_sym_COLON,
    STATE(1804), 1,
      sym_trait_bounds,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68176] = 3,
    ACTIONS(5028), 1,
      anon_sym_SEMI,
    ACTIONS(5116), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68187] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(343), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68198] = 3,
    ACTIONS(4048), 1,
      anon_sym_RPAREN,
    ACTIONS(5028), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68209] = 3,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    STATE(1522), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68220] = 3,
    ACTIONS(5028), 1,
      anon_sym_SEMI,
    ACTIONS(5118), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68231] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4767), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [68240] = 3,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(5120), 1,
      anon_sym_in,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68251] = 3,
    ACTIONS(4121), 1,
      anon_sym_LBRACE,
    STATE(922), 1,
      sym_enum_variant_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68262] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5122), 2,
      anon_sym_const,
      sym_mutable_specifier,
  [68271] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4645), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [68280] = 3,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    STATE(1284), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68291] = 3,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    STATE(1543), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68302] = 3,
    ACTIONS(4088), 1,
      anon_sym_LBRACE,
    STATE(279), 1,
      sym_enum_variant_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68313] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(5124), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68324] = 3,
    ACTIONS(3835), 1,
      anon_sym_LBRACE,
    STATE(338), 1,
      sym_field_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68335] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(286), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68346] = 3,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    STATE(223), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68357] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4156), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [68366] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(328), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68377] = 3,
    ACTIONS(2635), 1,
      anon_sym_LT2,
    STATE(1049), 1,
      sym_type_arguments,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68388] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(329), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68399] = 3,
    ACTIONS(4221), 1,
      anon_sym_COLON,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68410] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(5126), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68421] = 3,
    ACTIONS(4088), 1,
      anon_sym_LBRACE,
    STATE(411), 1,
      sym_enum_variant_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68432] = 3,
    ACTIONS(4109), 1,
      anon_sym_PLUS,
    ACTIONS(5128), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68443] = 3,
    ACTIONS(3490), 1,
      anon_sym_BANG,
    ACTIONS(5130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68454] = 3,
    ACTIONS(85), 1,
      anon_sym_PIPE,
    STATE(78), 1,
      sym_closure_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68465] = 3,
    ACTIONS(3835), 1,
      anon_sym_LBRACE,
    STATE(360), 1,
      sym_field_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68476] = 3,
    ACTIONS(5132), 1,
      anon_sym_LT,
    STATE(630), 1,
      sym_type_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68487] = 3,
    ACTIONS(2627), 1,
      anon_sym_LPAREN,
    STATE(830), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68498] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(385), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68509] = 3,
    ACTIONS(5134), 1,
      anon_sym_LPAREN,
    ACTIONS(5136), 1,
      anon_sym_LBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68520] = 3,
    ACTIONS(4922), 1,
      sym_identifier,
    ACTIONS(4926), 1,
      sym_mutable_specifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68531] = 3,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    STATE(1019), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68542] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5138), 2,
      anon_sym_const,
      sym_mutable_specifier,
  [68551] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(303), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68562] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5140), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [68571] = 3,
    ACTIONS(3488), 1,
      anon_sym_LPAREN,
    STATE(1275), 1,
      sym_parameters,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68582] = 3,
    ACTIONS(3835), 1,
      anon_sym_LBRACE,
    STATE(265), 1,
      sym_field_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68593] = 3,
    ACTIONS(295), 1,
      anon_sym_LBRACE,
    STATE(961), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68604] = 3,
    ACTIONS(3853), 1,
      anon_sym_LBRACE,
    STATE(732), 1,
      sym_field_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68615] = 3,
    ACTIONS(3613), 1,
      anon_sym_BANG,
    ACTIONS(5142), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68626] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(260), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68637] = 3,
    ACTIONS(3845), 1,
      anon_sym_LBRACE,
    STATE(324), 1,
      sym_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68648] = 3,
    ACTIONS(3835), 1,
      anon_sym_LBRACE,
    STATE(304), 1,
      sym_field_declaration_list,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68659] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(5144), 2,
      anon_sym_const,
      sym_mutable_specifier,
  [68668] = 3,
    ACTIONS(4225), 1,
      anon_sym_PIPE,
    ACTIONS(5146), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68679] = 2,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
    ACTIONS(4722), 2,
      anon_sym_RBRACE,
      anon_sym_COMMA,
  [68688] = 3,
    ACTIONS(919), 1,
      anon_sym_LBRACE,
    STATE(237), 1,
      sym_block,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68699] = 2,
    ACTIONS(5148), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68707] = 2,
    ACTIONS(5150), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68715] = 2,
    ACTIONS(5152), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68723] = 2,
    ACTIONS(5154), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68731] = 2,
    ACTIONS(5156), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68739] = 2,
    ACTIONS(5158), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68747] = 2,
    ACTIONS(5160), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68755] = 2,
    ACTIONS(4755), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68763] = 2,
    ACTIONS(4751), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68771] = 2,
    ACTIONS(5162), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68779] = 2,
    ACTIONS(5164), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68787] = 2,
    ACTIONS(5166), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68795] = 2,
    ACTIONS(4251), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68803] = 2,
    ACTIONS(5168), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68811] = 2,
    ACTIONS(5170), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68819] = 2,
    ACTIONS(5172), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68827] = 2,
    ACTIONS(5174), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68835] = 2,
    ACTIONS(5176), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68843] = 2,
    ACTIONS(4733), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68851] = 2,
    ACTIONS(5178), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68859] = 2,
    ACTIONS(5180), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68867] = 2,
    ACTIONS(2382), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68875] = 2,
    ACTIONS(5182), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68883] = 2,
    ACTIONS(2454), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68891] = 2,
    ACTIONS(5184), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68899] = 2,
    ACTIONS(5186), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68907] = 2,
    ACTIONS(5188), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68915] = 2,
    ACTIONS(5190), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68923] = 2,
    ACTIONS(5192), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68931] = 2,
    ACTIONS(5194), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68939] = 2,
    ACTIONS(4714), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68947] = 2,
    ACTIONS(5196), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68955] = 2,
    ACTIONS(5198), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68963] = 2,
    ACTIONS(5200), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68971] = 2,
    ACTIONS(5202), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68979] = 2,
    ACTIONS(5204), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68987] = 2,
    ACTIONS(5206), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [68995] = 2,
    ACTIONS(4690), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69003] = 2,
    ACTIONS(5208), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69011] = 2,
    ACTIONS(5210), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69019] = 2,
    ACTIONS(2440), 1,
      anon_sym_PLUS,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69027] = 2,
    ACTIONS(5212), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69035] = 2,
    ACTIONS(5214), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69043] = 2,
    ACTIONS(5216), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69051] = 2,
    ACTIONS(5218), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69059] = 2,
    ACTIONS(5220), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69067] = 2,
    ACTIONS(5222), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69075] = 2,
    ACTIONS(5224), 1,
      anon_sym_fn,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69083] = 2,
    ACTIONS(5226), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69091] = 2,
    ACTIONS(3366), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69099] = 2,
    ACTIONS(3546), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69107] = 2,
    ACTIONS(5228), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69115] = 2,
    ACTIONS(5230), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69123] = 2,
    ACTIONS(3394), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69131] = 2,
    ACTIONS(5232), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69139] = 2,
    ACTIONS(5234), 1,
      sym_self,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69147] = 2,
    ACTIONS(5236), 1,
      anon_sym_fn,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69155] = 2,
    ACTIONS(4956), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69163] = 2,
    ACTIONS(4526), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69171] = 2,
    ACTIONS(5238), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69179] = 2,
    ACTIONS(5240), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69187] = 2,
    ACTIONS(5242), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69195] = 2,
    ACTIONS(5244), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69203] = 2,
    ACTIONS(5246), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69211] = 2,
    ACTIONS(5248), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69219] = 2,
    ACTIONS(735), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69227] = 2,
    ACTIONS(5250), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69235] = 2,
    ACTIONS(5252), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69243] = 2,
    ACTIONS(4626), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69251] = 2,
    ACTIONS(5254), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69259] = 2,
    ACTIONS(5256), 1,
      anon_sym_LT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69267] = 2,
    ACTIONS(5258), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69275] = 2,
    ACTIONS(2759), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69283] = 2,
    ACTIONS(5142), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69291] = 2,
    ACTIONS(5260), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69299] = 2,
    ACTIONS(5262), 1,
      anon_sym_fn,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69307] = 2,
    ACTIONS(5264), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69315] = 2,
    ACTIONS(5266), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69323] = 2,
    ACTIONS(5268), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69331] = 2,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69339] = 2,
    ACTIONS(2769), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69347] = 2,
    ACTIONS(4772), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69355] = 2,
    ACTIONS(4162), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69363] = 2,
    ACTIONS(5272), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69371] = 2,
    ACTIONS(5274), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69379] = 2,
    ACTIONS(5276), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69387] = 2,
    ACTIONS(5278), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69395] = 2,
    ACTIONS(5280), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69403] = 2,
    ACTIONS(5282), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69411] = 2,
    ACTIONS(5284), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69419] = 2,
    ACTIONS(5286), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69427] = 2,
    ACTIONS(4440), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69435] = 2,
    ACTIONS(5288), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69443] = 2,
    ACTIONS(5290), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69451] = 2,
    ACTIONS(5118), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69459] = 2,
    ACTIONS(3581), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69467] = 2,
    ACTIONS(4160), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69475] = 2,
    ACTIONS(4444), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69483] = 2,
    ACTIONS(5292), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69491] = 2,
    ACTIONS(5294), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69499] = 2,
    ACTIONS(4793), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69507] = 2,
    ACTIONS(5296), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69515] = 2,
    ACTIONS(5298), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69523] = 2,
    ACTIONS(5300), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69531] = 2,
    ACTIONS(5302), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69539] = 2,
    ACTIONS(5304), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69547] = 2,
    ACTIONS(5306), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69555] = 2,
    ACTIONS(5308), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69563] = 2,
    ACTIONS(5310), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69571] = 2,
    ACTIONS(5312), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69579] = 2,
    ACTIONS(5314), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69587] = 2,
    ACTIONS(5316), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69595] = 2,
    ACTIONS(411), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69603] = 2,
    ACTIONS(2390), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69611] = 2,
    ACTIONS(5318), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69619] = 2,
    ACTIONS(5320), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69627] = 2,
    ACTIONS(4603), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69635] = 2,
    ACTIONS(2711), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69643] = 2,
    ACTIONS(5322), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69651] = 2,
    ACTIONS(5324), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69659] = 2,
    ACTIONS(5326), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69667] = 2,
    ACTIONS(5328), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69675] = 2,
    ACTIONS(5028), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69683] = 2,
    ACTIONS(5330), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69691] = 2,
    ACTIONS(5332), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69699] = 2,
    ACTIONS(5334), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69707] = 2,
    ACTIONS(5336), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69715] = 2,
    ACTIONS(5338), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69723] = 2,
    ACTIONS(5340), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69731] = 2,
    ACTIONS(5342), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69739] = 2,
    ACTIONS(5344), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69747] = 2,
    ACTIONS(4084), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69755] = 2,
    ACTIONS(5346), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69763] = 2,
    ACTIONS(5348), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69771] = 2,
    ACTIONS(3524), 1,
      anon_sym_fn,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69779] = 2,
    ACTIONS(5350), 1,
      ts_builtin_sym_end,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69787] = 2,
    ACTIONS(3326), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69795] = 2,
    ACTIONS(3053), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69803] = 2,
    ACTIONS(4867), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69811] = 2,
    ACTIONS(4219), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69819] = 2,
    ACTIONS(5352), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69827] = 2,
    ACTIONS(5354), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69835] = 2,
    ACTIONS(5356), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69843] = 2,
    ACTIONS(5358), 1,
      anon_sym_fn,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69851] = 2,
    ACTIONS(2753), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69859] = 2,
    ACTIONS(5360), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69867] = 2,
    ACTIONS(3633), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69875] = 2,
    ACTIONS(5362), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69883] = 2,
    ACTIONS(5364), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69891] = 2,
    ACTIONS(4865), 1,
      anon_sym_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69899] = 2,
    ACTIONS(5366), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69907] = 2,
    ACTIONS(4556), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69915] = 2,
    ACTIONS(5368), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69923] = 2,
    ACTIONS(5370), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69931] = 2,
    ACTIONS(5372), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69939] = 2,
    ACTIONS(5374), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69947] = 2,
    ACTIONS(5376), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69955] = 2,
    ACTIONS(4761), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69963] = 2,
    ACTIONS(4127), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69971] = 2,
    ACTIONS(5378), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69979] = 2,
    ACTIONS(5380), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69987] = 2,
    ACTIONS(4202), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [69995] = 2,
    ACTIONS(5382), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70003] = 2,
    ACTIONS(4068), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70011] = 2,
    ACTIONS(4115), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70019] = 2,
    ACTIONS(5384), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70027] = 2,
    ACTIONS(5386), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70035] = 2,
    ACTIONS(5388), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70043] = 2,
    ACTIONS(5390), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70051] = 2,
    ACTIONS(5392), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70059] = 2,
    ACTIONS(5394), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70067] = 2,
    ACTIONS(5396), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70075] = 2,
    ACTIONS(5398), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70083] = 2,
    ACTIONS(5400), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70091] = 2,
    ACTIONS(5402), 1,
      anon_sym_LPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70099] = 2,
    ACTIONS(4522), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70107] = 2,
    ACTIONS(5404), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70115] = 2,
    ACTIONS(5406), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70123] = 2,
    ACTIONS(5408), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70131] = 2,
    ACTIONS(4910), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70139] = 2,
    ACTIONS(5410), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70147] = 2,
    ACTIONS(5412), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70155] = 2,
    ACTIONS(5414), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70163] = 2,
    ACTIONS(5416), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70171] = 2,
    ACTIONS(4271), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70179] = 2,
    ACTIONS(5418), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70187] = 2,
    ACTIONS(5420), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70195] = 2,
    ACTIONS(5422), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70203] = 2,
    ACTIONS(5424), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70211] = 2,
    ACTIONS(5426), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70219] = 2,
    ACTIONS(5428), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70227] = 2,
    ACTIONS(5430), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70235] = 2,
    ACTIONS(5432), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70243] = 2,
    ACTIONS(3575), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70251] = 2,
    ACTIONS(5434), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70259] = 2,
    ACTIONS(5436), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70267] = 2,
    ACTIONS(5438), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70275] = 2,
    ACTIONS(5130), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70283] = 2,
    ACTIONS(5440), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70291] = 2,
    ACTIONS(5442), 1,
      anon_sym_EQ,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70299] = 2,
    ACTIONS(5444), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70307] = 2,
    ACTIONS(5446), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70315] = 2,
    ACTIONS(5448), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70323] = 2,
    ACTIONS(5450), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70331] = 2,
    ACTIONS(5452), 1,
      anon_sym_LBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70339] = 2,
    ACTIONS(4040), 1,
      anon_sym_COLON,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70347] = 2,
    ACTIONS(5454), 1,
      anon_sym_EQ_GT,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70355] = 2,
    ACTIONS(5456), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70363] = 2,
    ACTIONS(4080), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70371] = 2,
    ACTIONS(5030), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70379] = 2,
    ACTIONS(5458), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70387] = 2,
    ACTIONS(5460), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70395] = 2,
    ACTIONS(4990), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70403] = 2,
    ACTIONS(3500), 1,
      anon_sym_fn,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70411] = 2,
    ACTIONS(5462), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70419] = 2,
    ACTIONS(5464), 1,
      anon_sym_SEMI,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70427] = 2,
    ACTIONS(5466), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70435] = 2,
    ACTIONS(3198), 1,
      anon_sym_RPAREN,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70443] = 2,
    ACTIONS(5468), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70451] = 2,
    ACTIONS(4428), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70459] = 2,
    ACTIONS(5470), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70467] = 2,
    ACTIONS(5472), 1,
      anon_sym_fn,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70475] = 2,
    ACTIONS(5474), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70483] = 2,
    ACTIONS(5476), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70491] = 2,
    ACTIONS(5478), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70499] = 2,
    ACTIONS(5480), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70507] = 2,
    ACTIONS(4786), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70515] = 2,
    ACTIONS(4933), 1,
      anon_sym_RBRACE,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70523] = 2,
    ACTIONS(5482), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70531] = 2,
    ACTIONS(5484), 1,
      anon_sym_RBRACK,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70539] = 2,
    ACTIONS(5486), 1,
      anon_sym_fn,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
  [70547] = 2,
    ACTIONS(5488), 1,
      sym_identifier,
    ACTIONS(3), 2,
      sym_block_comment,
      sym_line_comment,
};

static uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(531)] = 0,
  [SMALL_STATE(532)] = 119,
  [SMALL_STATE(533)] = 244,
  [SMALL_STATE(534)] = 369,
  [SMALL_STATE(535)] = 494,
  [SMALL_STATE(536)] = 613,
  [SMALL_STATE(537)] = 688,
  [SMALL_STATE(538)] = 813,
  [SMALL_STATE(539)] = 938,
  [SMALL_STATE(540)] = 1063,
  [SMALL_STATE(541)] = 1188,
  [SMALL_STATE(542)] = 1313,
  [SMALL_STATE(543)] = 1438,
  [SMALL_STATE(544)] = 1563,
  [SMALL_STATE(545)] = 1682,
  [SMALL_STATE(546)] = 1807,
  [SMALL_STATE(547)] = 1932,
  [SMALL_STATE(548)] = 2051,
  [SMALL_STATE(549)] = 2176,
  [SMALL_STATE(550)] = 2295,
  [SMALL_STATE(551)] = 2420,
  [SMALL_STATE(552)] = 2542,
  [SMALL_STATE(553)] = 2664,
  [SMALL_STATE(554)] = 2786,
  [SMALL_STATE(555)] = 2908,
  [SMALL_STATE(556)] = 3024,
  [SMALL_STATE(557)] = 3140,
  [SMALL_STATE(558)] = 3262,
  [SMALL_STATE(559)] = 3378,
  [SMALL_STATE(560)] = 3500,
  [SMALL_STATE(561)] = 3622,
  [SMALL_STATE(562)] = 3746,
  [SMALL_STATE(563)] = 3868,
  [SMALL_STATE(564)] = 3990,
  [SMALL_STATE(565)] = 4112,
  [SMALL_STATE(566)] = 4234,
  [SMALL_STATE(567)] = 4356,
  [SMALL_STATE(568)] = 4478,
  [SMALL_STATE(569)] = 4600,
  [SMALL_STATE(570)] = 4722,
  [SMALL_STATE(571)] = 4844,
  [SMALL_STATE(572)] = 4966,
  [SMALL_STATE(573)] = 5088,
  [SMALL_STATE(574)] = 5210,
  [SMALL_STATE(575)] = 5332,
  [SMALL_STATE(576)] = 5454,
  [SMALL_STATE(577)] = 5576,
  [SMALL_STATE(578)] = 5698,
  [SMALL_STATE(579)] = 5820,
  [SMALL_STATE(580)] = 5942,
  [SMALL_STATE(581)] = 6064,
  [SMALL_STATE(582)] = 6186,
  [SMALL_STATE(583)] = 6308,
  [SMALL_STATE(584)] = 6430,
  [SMALL_STATE(585)] = 6552,
  [SMALL_STATE(586)] = 6674,
  [SMALL_STATE(587)] = 6796,
  [SMALL_STATE(588)] = 6918,
  [SMALL_STATE(589)] = 7040,
  [SMALL_STATE(590)] = 7162,
  [SMALL_STATE(591)] = 7284,
  [SMALL_STATE(592)] = 7406,
  [SMALL_STATE(593)] = 7528,
  [SMALL_STATE(594)] = 7650,
  [SMALL_STATE(595)] = 7772,
  [SMALL_STATE(596)] = 7894,
  [SMALL_STATE(597)] = 8016,
  [SMALL_STATE(598)] = 8138,
  [SMALL_STATE(599)] = 8260,
  [SMALL_STATE(600)] = 8382,
  [SMALL_STATE(601)] = 8504,
  [SMALL_STATE(602)] = 8626,
  [SMALL_STATE(603)] = 8748,
  [SMALL_STATE(604)] = 8870,
  [SMALL_STATE(605)] = 8992,
  [SMALL_STATE(606)] = 9114,
  [SMALL_STATE(607)] = 9236,
  [SMALL_STATE(608)] = 9358,
  [SMALL_STATE(609)] = 9480,
  [SMALL_STATE(610)] = 9596,
  [SMALL_STATE(611)] = 9718,
  [SMALL_STATE(612)] = 9840,
  [SMALL_STATE(613)] = 9962,
  [SMALL_STATE(614)] = 10084,
  [SMALL_STATE(615)] = 10206,
  [SMALL_STATE(616)] = 10328,
  [SMALL_STATE(617)] = 10450,
  [SMALL_STATE(618)] = 10566,
  [SMALL_STATE(619)] = 10688,
  [SMALL_STATE(620)] = 10810,
  [SMALL_STATE(621)] = 10926,
  [SMALL_STATE(622)] = 11048,
  [SMALL_STATE(623)] = 11170,
  [SMALL_STATE(624)] = 11292,
  [SMALL_STATE(625)] = 11414,
  [SMALL_STATE(626)] = 11536,
  [SMALL_STATE(627)] = 11658,
  [SMALL_STATE(628)] = 11780,
  [SMALL_STATE(629)] = 11902,
  [SMALL_STATE(630)] = 12024,
  [SMALL_STATE(631)] = 12146,
  [SMALL_STATE(632)] = 12268,
  [SMALL_STATE(633)] = 12390,
  [SMALL_STATE(634)] = 12512,
  [SMALL_STATE(635)] = 12634,
  [SMALL_STATE(636)] = 12756,
  [SMALL_STATE(637)] = 12878,
  [SMALL_STATE(638)] = 13000,
  [SMALL_STATE(639)] = 13122,
  [SMALL_STATE(640)] = 13244,
  [SMALL_STATE(641)] = 13366,
  [SMALL_STATE(642)] = 13488,
  [SMALL_STATE(643)] = 13610,
  [SMALL_STATE(644)] = 13732,
  [SMALL_STATE(645)] = 13854,
  [SMALL_STATE(646)] = 13976,
  [SMALL_STATE(647)] = 14098,
  [SMALL_STATE(648)] = 14220,
  [SMALL_STATE(649)] = 14342,
  [SMALL_STATE(650)] = 14464,
  [SMALL_STATE(651)] = 14586,
  [SMALL_STATE(652)] = 14708,
  [SMALL_STATE(653)] = 14830,
  [SMALL_STATE(654)] = 14952,
  [SMALL_STATE(655)] = 15074,
  [SMALL_STATE(656)] = 15196,
  [SMALL_STATE(657)] = 15318,
  [SMALL_STATE(658)] = 15440,
  [SMALL_STATE(659)] = 15562,
  [SMALL_STATE(660)] = 15684,
  [SMALL_STATE(661)] = 15806,
  [SMALL_STATE(662)] = 15928,
  [SMALL_STATE(663)] = 16050,
  [SMALL_STATE(664)] = 16172,
  [SMALL_STATE(665)] = 16294,
  [SMALL_STATE(666)] = 16407,
  [SMALL_STATE(667)] = 16520,
  [SMALL_STATE(668)] = 16633,
  [SMALL_STATE(669)] = 16746,
  [SMALL_STATE(670)] = 16859,
  [SMALL_STATE(671)] = 16972,
  [SMALL_STATE(672)] = 17085,
  [SMALL_STATE(673)] = 17198,
  [SMALL_STATE(674)] = 17311,
  [SMALL_STATE(675)] = 17424,
  [SMALL_STATE(676)] = 17537,
  [SMALL_STATE(677)] = 17650,
  [SMALL_STATE(678)] = 17763,
  [SMALL_STATE(679)] = 17876,
  [SMALL_STATE(680)] = 17989,
  [SMALL_STATE(681)] = 18102,
  [SMALL_STATE(682)] = 18215,
  [SMALL_STATE(683)] = 18328,
  [SMALL_STATE(684)] = 18441,
  [SMALL_STATE(685)] = 18554,
  [SMALL_STATE(686)] = 18667,
  [SMALL_STATE(687)] = 18780,
  [SMALL_STATE(688)] = 18893,
  [SMALL_STATE(689)] = 19006,
  [SMALL_STATE(690)] = 19119,
  [SMALL_STATE(691)] = 19232,
  [SMALL_STATE(692)] = 19345,
  [SMALL_STATE(693)] = 19414,
  [SMALL_STATE(694)] = 19527,
  [SMALL_STATE(695)] = 19640,
  [SMALL_STATE(696)] = 19704,
  [SMALL_STATE(697)] = 19768,
  [SMALL_STATE(698)] = 19832,
  [SMALL_STATE(699)] = 19896,
  [SMALL_STATE(700)] = 19958,
  [SMALL_STATE(701)] = 20028,
  [SMALL_STATE(702)] = 20095,
  [SMALL_STATE(703)] = 20162,
  [SMALL_STATE(704)] = 20218,
  [SMALL_STATE(705)] = 20274,
  [SMALL_STATE(706)] = 20334,
  [SMALL_STATE(707)] = 20398,
  [SMALL_STATE(708)] = 20458,
  [SMALL_STATE(709)] = 20514,
  [SMALL_STATE(710)] = 20574,
  [SMALL_STATE(711)] = 20638,
  [SMALL_STATE(712)] = 20698,
  [SMALL_STATE(713)] = 20754,
  [SMALL_STATE(714)] = 20810,
  [SMALL_STATE(715)] = 20866,
  [SMALL_STATE(716)] = 20922,
  [SMALL_STATE(717)] = 20978,
  [SMALL_STATE(718)] = 21042,
  [SMALL_STATE(719)] = 21106,
  [SMALL_STATE(720)] = 21161,
  [SMALL_STATE(721)] = 21218,
  [SMALL_STATE(722)] = 21277,
  [SMALL_STATE(723)] = 21334,
  [SMALL_STATE(724)] = 21391,
  [SMALL_STATE(725)] = 21450,
  [SMALL_STATE(726)] = 21509,
  [SMALL_STATE(727)] = 21566,
  [SMALL_STATE(728)] = 21620,
  [SMALL_STATE(729)] = 21674,
  [SMALL_STATE(730)] = 21728,
  [SMALL_STATE(731)] = 21782,
  [SMALL_STATE(732)] = 21836,
  [SMALL_STATE(733)] = 21890,
  [SMALL_STATE(734)] = 21944,
  [SMALL_STATE(735)] = 21998,
  [SMALL_STATE(736)] = 22052,
  [SMALL_STATE(737)] = 22106,
  [SMALL_STATE(738)] = 22160,
  [SMALL_STATE(739)] = 22216,
  [SMALL_STATE(740)] = 22270,
  [SMALL_STATE(741)] = 22324,
  [SMALL_STATE(742)] = 22380,
  [SMALL_STATE(743)] = 22434,
  [SMALL_STATE(744)] = 22488,
  [SMALL_STATE(745)] = 22542,
  [SMALL_STATE(746)] = 22596,
  [SMALL_STATE(747)] = 22650,
  [SMALL_STATE(748)] = 22704,
  [SMALL_STATE(749)] = 22758,
  [SMALL_STATE(750)] = 22812,
  [SMALL_STATE(751)] = 22866,
  [SMALL_STATE(752)] = 22920,
  [SMALL_STATE(753)] = 22974,
  [SMALL_STATE(754)] = 23030,
  [SMALL_STATE(755)] = 23084,
  [SMALL_STATE(756)] = 23146,
  [SMALL_STATE(757)] = 23200,
  [SMALL_STATE(758)] = 23254,
  [SMALL_STATE(759)] = 23308,
  [SMALL_STATE(760)] = 23364,
  [SMALL_STATE(761)] = 23418,
  [SMALL_STATE(762)] = 23474,
  [SMALL_STATE(763)] = 23528,
  [SMALL_STATE(764)] = 23584,
  [SMALL_STATE(765)] = 23638,
  [SMALL_STATE(766)] = 23692,
  [SMALL_STATE(767)] = 23748,
  [SMALL_STATE(768)] = 23802,
  [SMALL_STATE(769)] = 23856,
  [SMALL_STATE(770)] = 23910,
  [SMALL_STATE(771)] = 23964,
  [SMALL_STATE(772)] = 24018,
  [SMALL_STATE(773)] = 24072,
  [SMALL_STATE(774)] = 24126,
  [SMALL_STATE(775)] = 24180,
  [SMALL_STATE(776)] = 24234,
  [SMALL_STATE(777)] = 24288,
  [SMALL_STATE(778)] = 24342,
  [SMALL_STATE(779)] = 24396,
  [SMALL_STATE(780)] = 24450,
  [SMALL_STATE(781)] = 24504,
  [SMALL_STATE(782)] = 24566,
  [SMALL_STATE(783)] = 24620,
  [SMALL_STATE(784)] = 24674,
  [SMALL_STATE(785)] = 24728,
  [SMALL_STATE(786)] = 24782,
  [SMALL_STATE(787)] = 24836,
  [SMALL_STATE(788)] = 24890,
  [SMALL_STATE(789)] = 24944,
  [SMALL_STATE(790)] = 24998,
  [SMALL_STATE(791)] = 25052,
  [SMALL_STATE(792)] = 25106,
  [SMALL_STATE(793)] = 25162,
  [SMALL_STATE(794)] = 25216,
  [SMALL_STATE(795)] = 25270,
  [SMALL_STATE(796)] = 25324,
  [SMALL_STATE(797)] = 25378,
  [SMALL_STATE(798)] = 25432,
  [SMALL_STATE(799)] = 25486,
  [SMALL_STATE(800)] = 25540,
  [SMALL_STATE(801)] = 25594,
  [SMALL_STATE(802)] = 25648,
  [SMALL_STATE(803)] = 25702,
  [SMALL_STATE(804)] = 25756,
  [SMALL_STATE(805)] = 25810,
  [SMALL_STATE(806)] = 25864,
  [SMALL_STATE(807)] = 25918,
  [SMALL_STATE(808)] = 25972,
  [SMALL_STATE(809)] = 26026,
  [SMALL_STATE(810)] = 26080,
  [SMALL_STATE(811)] = 26134,
  [SMALL_STATE(812)] = 26188,
  [SMALL_STATE(813)] = 26242,
  [SMALL_STATE(814)] = 26304,
  [SMALL_STATE(815)] = 26358,
  [SMALL_STATE(816)] = 26412,
  [SMALL_STATE(817)] = 26466,
  [SMALL_STATE(818)] = 26520,
  [SMALL_STATE(819)] = 26574,
  [SMALL_STATE(820)] = 26628,
  [SMALL_STATE(821)] = 26682,
  [SMALL_STATE(822)] = 26736,
  [SMALL_STATE(823)] = 26790,
  [SMALL_STATE(824)] = 26844,
  [SMALL_STATE(825)] = 26898,
  [SMALL_STATE(826)] = 26952,
  [SMALL_STATE(827)] = 27006,
  [SMALL_STATE(828)] = 27060,
  [SMALL_STATE(829)] = 27114,
  [SMALL_STATE(830)] = 27168,
  [SMALL_STATE(831)] = 27224,
  [SMALL_STATE(832)] = 27278,
  [SMALL_STATE(833)] = 27332,
  [SMALL_STATE(834)] = 27386,
  [SMALL_STATE(835)] = 27440,
  [SMALL_STATE(836)] = 27494,
  [SMALL_STATE(837)] = 27548,
  [SMALL_STATE(838)] = 27602,
  [SMALL_STATE(839)] = 27658,
  [SMALL_STATE(840)] = 27712,
  [SMALL_STATE(841)] = 27766,
  [SMALL_STATE(842)] = 27820,
  [SMALL_STATE(843)] = 27874,
  [SMALL_STATE(844)] = 27928,
  [SMALL_STATE(845)] = 27982,
  [SMALL_STATE(846)] = 28036,
  [SMALL_STATE(847)] = 28090,
  [SMALL_STATE(848)] = 28144,
  [SMALL_STATE(849)] = 28200,
  [SMALL_STATE(850)] = 28254,
  [SMALL_STATE(851)] = 28308,
  [SMALL_STATE(852)] = 28364,
  [SMALL_STATE(853)] = 28418,
  [SMALL_STATE(854)] = 28472,
  [SMALL_STATE(855)] = 28526,
  [SMALL_STATE(856)] = 28580,
  [SMALL_STATE(857)] = 28634,
  [SMALL_STATE(858)] = 28688,
  [SMALL_STATE(859)] = 28742,
  [SMALL_STATE(860)] = 28796,
  [SMALL_STATE(861)] = 28850,
  [SMALL_STATE(862)] = 28904,
  [SMALL_STATE(863)] = 28958,
  [SMALL_STATE(864)] = 29012,
  [SMALL_STATE(865)] = 29068,
  [SMALL_STATE(866)] = 29122,
  [SMALL_STATE(867)] = 29176,
  [SMALL_STATE(868)] = 29230,
  [SMALL_STATE(869)] = 29284,
  [SMALL_STATE(870)] = 29338,
  [SMALL_STATE(871)] = 29392,
  [SMALL_STATE(872)] = 29446,
  [SMALL_STATE(873)] = 29500,
  [SMALL_STATE(874)] = 29554,
  [SMALL_STATE(875)] = 29608,
  [SMALL_STATE(876)] = 29662,
  [SMALL_STATE(877)] = 29716,
  [SMALL_STATE(878)] = 29770,
  [SMALL_STATE(879)] = 29824,
  [SMALL_STATE(880)] = 29878,
  [SMALL_STATE(881)] = 29932,
  [SMALL_STATE(882)] = 29986,
  [SMALL_STATE(883)] = 30040,
  [SMALL_STATE(884)] = 30094,
  [SMALL_STATE(885)] = 30148,
  [SMALL_STATE(886)] = 30202,
  [SMALL_STATE(887)] = 30256,
  [SMALL_STATE(888)] = 30310,
  [SMALL_STATE(889)] = 30364,
  [SMALL_STATE(890)] = 30418,
  [SMALL_STATE(891)] = 30472,
  [SMALL_STATE(892)] = 30526,
  [SMALL_STATE(893)] = 30580,
  [SMALL_STATE(894)] = 30634,
  [SMALL_STATE(895)] = 30688,
  [SMALL_STATE(896)] = 30742,
  [SMALL_STATE(897)] = 30796,
  [SMALL_STATE(898)] = 30850,
  [SMALL_STATE(899)] = 30904,
  [SMALL_STATE(900)] = 30958,
  [SMALL_STATE(901)] = 31012,
  [SMALL_STATE(902)] = 31066,
  [SMALL_STATE(903)] = 31120,
  [SMALL_STATE(904)] = 31174,
  [SMALL_STATE(905)] = 31228,
  [SMALL_STATE(906)] = 31282,
  [SMALL_STATE(907)] = 31336,
  [SMALL_STATE(908)] = 31390,
  [SMALL_STATE(909)] = 31444,
  [SMALL_STATE(910)] = 31498,
  [SMALL_STATE(911)] = 31552,
  [SMALL_STATE(912)] = 31606,
  [SMALL_STATE(913)] = 31660,
  [SMALL_STATE(914)] = 31714,
  [SMALL_STATE(915)] = 31768,
  [SMALL_STATE(916)] = 31822,
  [SMALL_STATE(917)] = 31876,
  [SMALL_STATE(918)] = 31930,
  [SMALL_STATE(919)] = 31984,
  [SMALL_STATE(920)] = 32038,
  [SMALL_STATE(921)] = 32092,
  [SMALL_STATE(922)] = 32146,
  [SMALL_STATE(923)] = 32200,
  [SMALL_STATE(924)] = 32254,
  [SMALL_STATE(925)] = 32308,
  [SMALL_STATE(926)] = 32362,
  [SMALL_STATE(927)] = 32416,
  [SMALL_STATE(928)] = 32470,
  [SMALL_STATE(929)] = 32524,
  [SMALL_STATE(930)] = 32578,
  [SMALL_STATE(931)] = 32632,
  [SMALL_STATE(932)] = 32686,
  [SMALL_STATE(933)] = 32740,
  [SMALL_STATE(934)] = 32794,
  [SMALL_STATE(935)] = 32848,
  [SMALL_STATE(936)] = 32902,
  [SMALL_STATE(937)] = 32956,
  [SMALL_STATE(938)] = 33010,
  [SMALL_STATE(939)] = 33064,
  [SMALL_STATE(940)] = 33122,
  [SMALL_STATE(941)] = 33176,
  [SMALL_STATE(942)] = 33230,
  [SMALL_STATE(943)] = 33284,
  [SMALL_STATE(944)] = 33340,
  [SMALL_STATE(945)] = 33396,
  [SMALL_STATE(946)] = 33450,
  [SMALL_STATE(947)] = 33504,
  [SMALL_STATE(948)] = 33558,
  [SMALL_STATE(949)] = 33612,
  [SMALL_STATE(950)] = 33666,
  [SMALL_STATE(951)] = 33722,
  [SMALL_STATE(952)] = 33784,
  [SMALL_STATE(953)] = 33838,
  [SMALL_STATE(954)] = 33892,
  [SMALL_STATE(955)] = 33945,
  [SMALL_STATE(956)] = 33998,
  [SMALL_STATE(957)] = 34079,
  [SMALL_STATE(958)] = 34132,
  [SMALL_STATE(959)] = 34185,
  [SMALL_STATE(960)] = 34238,
  [SMALL_STATE(961)] = 34291,
  [SMALL_STATE(962)] = 34344,
  [SMALL_STATE(963)] = 34429,
  [SMALL_STATE(964)] = 34482,
  [SMALL_STATE(965)] = 34535,
  [SMALL_STATE(966)] = 34588,
  [SMALL_STATE(967)] = 34641,
  [SMALL_STATE(968)] = 34694,
  [SMALL_STATE(969)] = 34747,
  [SMALL_STATE(970)] = 34800,
  [SMALL_STATE(971)] = 34891,
  [SMALL_STATE(972)] = 34944,
  [SMALL_STATE(973)] = 34997,
  [SMALL_STATE(974)] = 35050,
  [SMALL_STATE(975)] = 35103,
  [SMALL_STATE(976)] = 35188,
  [SMALL_STATE(977)] = 35241,
  [SMALL_STATE(978)] = 35294,
  [SMALL_STATE(979)] = 35347,
  [SMALL_STATE(980)] = 35400,
  [SMALL_STATE(981)] = 35453,
  [SMALL_STATE(982)] = 35506,
  [SMALL_STATE(983)] = 35559,
  [SMALL_STATE(984)] = 35612,
  [SMALL_STATE(985)] = 35665,
  [SMALL_STATE(986)] = 35718,
  [SMALL_STATE(987)] = 35771,
  [SMALL_STATE(988)] = 35824,
  [SMALL_STATE(989)] = 35877,
  [SMALL_STATE(990)] = 35930,
  [SMALL_STATE(991)] = 35983,
  [SMALL_STATE(992)] = 36036,
  [SMALL_STATE(993)] = 36089,
  [SMALL_STATE(994)] = 36142,
  [SMALL_STATE(995)] = 36195,
  [SMALL_STATE(996)] = 36248,
  [SMALL_STATE(997)] = 36301,
  [SMALL_STATE(998)] = 36392,
  [SMALL_STATE(999)] = 36445,
  [SMALL_STATE(1000)] = 36498,
  [SMALL_STATE(1001)] = 36551,
  [SMALL_STATE(1002)] = 36604,
  [SMALL_STATE(1003)] = 36657,
  [SMALL_STATE(1004)] = 36710,
  [SMALL_STATE(1005)] = 36763,
  [SMALL_STATE(1006)] = 36816,
  [SMALL_STATE(1007)] = 36869,
  [SMALL_STATE(1008)] = 36922,
  [SMALL_STATE(1009)] = 36975,
  [SMALL_STATE(1010)] = 37028,
  [SMALL_STATE(1011)] = 37081,
  [SMALL_STATE(1012)] = 37134,
  [SMALL_STATE(1013)] = 37187,
  [SMALL_STATE(1014)] = 37240,
  [SMALL_STATE(1015)] = 37293,
  [SMALL_STATE(1016)] = 37378,
  [SMALL_STATE(1017)] = 37431,
  [SMALL_STATE(1018)] = 37484,
  [SMALL_STATE(1019)] = 37537,
  [SMALL_STATE(1020)] = 37590,
  [SMALL_STATE(1021)] = 37643,
  [SMALL_STATE(1022)] = 37696,
  [SMALL_STATE(1023)] = 37749,
  [SMALL_STATE(1024)] = 37802,
  [SMALL_STATE(1025)] = 37855,
  [SMALL_STATE(1026)] = 37908,
  [SMALL_STATE(1027)] = 37963,
  [SMALL_STATE(1028)] = 38016,
  [SMALL_STATE(1029)] = 38069,
  [SMALL_STATE(1030)] = 38122,
  [SMALL_STATE(1031)] = 38185,
  [SMALL_STATE(1032)] = 38238,
  [SMALL_STATE(1033)] = 38291,
  [SMALL_STATE(1034)] = 38344,
  [SMALL_STATE(1035)] = 38397,
  [SMALL_STATE(1036)] = 38482,
  [SMALL_STATE(1037)] = 38555,
  [SMALL_STATE(1038)] = 38608,
  [SMALL_STATE(1039)] = 38675,
  [SMALL_STATE(1040)] = 38756,
  [SMALL_STATE(1041)] = 38809,
  [SMALL_STATE(1042)] = 38886,
  [SMALL_STATE(1043)] = 38965,
  [SMALL_STATE(1044)] = 39036,
  [SMALL_STATE(1045)] = 39105,
  [SMALL_STATE(1046)] = 39170,
  [SMALL_STATE(1047)] = 39255,
  [SMALL_STATE(1048)] = 39308,
  [SMALL_STATE(1049)] = 39361,
  [SMALL_STATE(1050)] = 39414,
  [SMALL_STATE(1051)] = 39467,
  [SMALL_STATE(1052)] = 39520,
  [SMALL_STATE(1053)] = 39573,
  [SMALL_STATE(1054)] = 39628,
  [SMALL_STATE(1055)] = 39680,
  [SMALL_STATE(1056)] = 39736,
  [SMALL_STATE(1057)] = 39788,
  [SMALL_STATE(1058)] = 39840,
  [SMALL_STATE(1059)] = 39892,
  [SMALL_STATE(1060)] = 39952,
  [SMALL_STATE(1061)] = 40004,
  [SMALL_STATE(1062)] = 40056,
  [SMALL_STATE(1063)] = 40141,
  [SMALL_STATE(1064)] = 40226,
  [SMALL_STATE(1065)] = 40321,
  [SMALL_STATE(1066)] = 40416,
  [SMALL_STATE(1067)] = 40472,
  [SMALL_STATE(1068)] = 40556,
  [SMALL_STATE(1069)] = 40608,
  [SMALL_STATE(1070)] = 40658,
  [SMALL_STATE(1071)] = 40742,
  [SMALL_STATE(1072)] = 40826,
  [SMALL_STATE(1073)] = 40878,
  [SMALL_STATE(1074)] = 40932,
  [SMALL_STATE(1075)] = 41024,
  [SMALL_STATE(1076)] = 41074,
  [SMALL_STATE(1077)] = 41166,
  [SMALL_STATE(1078)] = 41250,
  [SMALL_STATE(1079)] = 41299,
  [SMALL_STATE(1080)] = 41348,
  [SMALL_STATE(1081)] = 41437,
  [SMALL_STATE(1082)] = 41526,
  [SMALL_STATE(1083)] = 41615,
  [SMALL_STATE(1084)] = 41704,
  [SMALL_STATE(1085)] = 41793,
  [SMALL_STATE(1086)] = 41844,
  [SMALL_STATE(1087)] = 41933,
  [SMALL_STATE(1088)] = 42022,
  [SMALL_STATE(1089)] = 42111,
  [SMALL_STATE(1090)] = 42200,
  [SMALL_STATE(1091)] = 42289,
  [SMALL_STATE(1092)] = 42378,
  [SMALL_STATE(1093)] = 42467,
  [SMALL_STATE(1094)] = 42516,
  [SMALL_STATE(1095)] = 42605,
  [SMALL_STATE(1096)] = 42658,
  [SMALL_STATE(1097)] = 42747,
  [SMALL_STATE(1098)] = 42836,
  [SMALL_STATE(1099)] = 42925,
  [SMALL_STATE(1100)] = 43012,
  [SMALL_STATE(1101)] = 43101,
  [SMALL_STATE(1102)] = 43190,
  [SMALL_STATE(1103)] = 43277,
  [SMALL_STATE(1104)] = 43364,
  [SMALL_STATE(1105)] = 43453,
  [SMALL_STATE(1106)] = 43540,
  [SMALL_STATE(1107)] = 43629,
  [SMALL_STATE(1108)] = 43704,
  [SMALL_STATE(1109)] = 43791,
  [SMALL_STATE(1110)] = 43880,
  [SMALL_STATE(1111)] = 43969,
  [SMALL_STATE(1112)] = 44058,
  [SMALL_STATE(1113)] = 44147,
  [SMALL_STATE(1114)] = 44236,
  [SMALL_STATE(1115)] = 44325,
  [SMALL_STATE(1116)] = 44414,
  [SMALL_STATE(1117)] = 44503,
  [SMALL_STATE(1118)] = 44592,
  [SMALL_STATE(1119)] = 44681,
  [SMALL_STATE(1120)] = 44770,
  [SMALL_STATE(1121)] = 44859,
  [SMALL_STATE(1122)] = 44948,
  [SMALL_STATE(1123)] = 44997,
  [SMALL_STATE(1124)] = 45086,
  [SMALL_STATE(1125)] = 45175,
  [SMALL_STATE(1126)] = 45262,
  [SMALL_STATE(1127)] = 45351,
  [SMALL_STATE(1128)] = 45438,
  [SMALL_STATE(1129)] = 45527,
  [SMALL_STATE(1130)] = 45614,
  [SMALL_STATE(1131)] = 45701,
  [SMALL_STATE(1132)] = 45750,
  [SMALL_STATE(1133)] = 45839,
  [SMALL_STATE(1134)] = 45926,
  [SMALL_STATE(1135)] = 46015,
  [SMALL_STATE(1136)] = 46096,
  [SMALL_STATE(1137)] = 46185,
  [SMALL_STATE(1138)] = 46274,
  [SMALL_STATE(1139)] = 46363,
  [SMALL_STATE(1140)] = 46452,
  [SMALL_STATE(1141)] = 46501,
  [SMALL_STATE(1142)] = 46582,
  [SMALL_STATE(1143)] = 46668,
  [SMALL_STATE(1144)] = 46748,
  [SMALL_STATE(1145)] = 46796,
  [SMALL_STATE(1146)] = 46868,
  [SMALL_STATE(1147)] = 46918,
  [SMALL_STATE(1148)] = 47004,
  [SMALL_STATE(1149)] = 47052,
  [SMALL_STATE(1150)] = 47138,
  [SMALL_STATE(1151)] = 47224,
  [SMALL_STATE(1152)] = 47296,
  [SMALL_STATE(1153)] = 47382,
  [SMALL_STATE(1154)] = 47468,
  [SMALL_STATE(1155)] = 47554,
  [SMALL_STATE(1156)] = 47640,
  [SMALL_STATE(1157)] = 47720,
  [SMALL_STATE(1158)] = 47806,
  [SMALL_STATE(1159)] = 47892,
  [SMALL_STATE(1160)] = 47978,
  [SMALL_STATE(1161)] = 48026,
  [SMALL_STATE(1162)] = 48074,
  [SMALL_STATE(1163)] = 48160,
  [SMALL_STATE(1164)] = 48210,
  [SMALL_STATE(1165)] = 48296,
  [SMALL_STATE(1166)] = 48344,
  [SMALL_STATE(1167)] = 48430,
  [SMALL_STATE(1168)] = 48480,
  [SMALL_STATE(1169)] = 48566,
  [SMALL_STATE(1170)] = 48652,
  [SMALL_STATE(1171)] = 48738,
  [SMALL_STATE(1172)] = 48824,
  [SMALL_STATE(1173)] = 48896,
  [SMALL_STATE(1174)] = 48982,
  [SMALL_STATE(1175)] = 49068,
  [SMALL_STATE(1176)] = 49148,
  [SMALL_STATE(1177)] = 49234,
  [SMALL_STATE(1178)] = 49320,
  [SMALL_STATE(1179)] = 49400,
  [SMALL_STATE(1180)] = 49486,
  [SMALL_STATE(1181)] = 49558,
  [SMALL_STATE(1182)] = 49608,
  [SMALL_STATE(1183)] = 49694,
  [SMALL_STATE(1184)] = 49780,
  [SMALL_STATE(1185)] = 49856,
  [SMALL_STATE(1186)] = 49942,
  [SMALL_STATE(1187)] = 49992,
  [SMALL_STATE(1188)] = 50042,
  [SMALL_STATE(1189)] = 50128,
  [SMALL_STATE(1190)] = 50214,
  [SMALL_STATE(1191)] = 50272,
  [SMALL_STATE(1192)] = 50358,
  [SMALL_STATE(1193)] = 50426,
  [SMALL_STATE(1194)] = 50488,
  [SMALL_STATE(1195)] = 50568,
  [SMALL_STATE(1196)] = 50654,
  [SMALL_STATE(1197)] = 50730,
  [SMALL_STATE(1198)] = 50816,
  [SMALL_STATE(1199)] = 50888,
  [SMALL_STATE(1200)] = 50962,
  [SMALL_STATE(1201)] = 51028,
  [SMALL_STATE(1202)] = 51092,
  [SMALL_STATE(1203)] = 51178,
  [SMALL_STATE(1204)] = 51264,
  [SMALL_STATE(1205)] = 51324,
  [SMALL_STATE(1206)] = 51399,
  [SMALL_STATE(1207)] = 51474,
  [SMALL_STATE(1208)] = 51543,
  [SMALL_STATE(1209)] = 51612,
  [SMALL_STATE(1210)] = 51678,
  [SMALL_STATE(1211)] = 51744,
  [SMALL_STATE(1212)] = 51807,
  [SMALL_STATE(1213)] = 51870,
  [SMALL_STATE(1214)] = 51933,
  [SMALL_STATE(1215)] = 51996,
  [SMALL_STATE(1216)] = 52059,
  [SMALL_STATE(1217)] = 52098,
  [SMALL_STATE(1218)] = 52137,
  [SMALL_STATE(1219)] = 52176,
  [SMALL_STATE(1220)] = 52229,
  [SMALL_STATE(1221)] = 52282,
  [SMALL_STATE(1222)] = 52335,
  [SMALL_STATE(1223)] = 52388,
  [SMALL_STATE(1224)] = 52441,
  [SMALL_STATE(1225)] = 52494,
  [SMALL_STATE(1226)] = 52547,
  [SMALL_STATE(1227)] = 52597,
  [SMALL_STATE(1228)] = 52647,
  [SMALL_STATE(1229)] = 52677,
  [SMALL_STATE(1230)] = 52707,
  [SMALL_STATE(1231)] = 52749,
  [SMALL_STATE(1232)] = 52789,
  [SMALL_STATE(1233)] = 52826,
  [SMALL_STATE(1234)] = 52855,
  [SMALL_STATE(1235)] = 52884,
  [SMALL_STATE(1236)] = 52913,
  [SMALL_STATE(1237)] = 52942,
  [SMALL_STATE(1238)] = 52979,
  [SMALL_STATE(1239)] = 53008,
  [SMALL_STATE(1240)] = 53037,
  [SMALL_STATE(1241)] = 53066,
  [SMALL_STATE(1242)] = 53095,
  [SMALL_STATE(1243)] = 53127,
  [SMALL_STATE(1244)] = 53159,
  [SMALL_STATE(1245)] = 53191,
  [SMALL_STATE(1246)] = 53245,
  [SMALL_STATE(1247)] = 53299,
  [SMALL_STATE(1248)] = 53322,
  [SMALL_STATE(1249)] = 53347,
  [SMALL_STATE(1250)] = 53371,
  [SMALL_STATE(1251)] = 53395,
  [SMALL_STATE(1252)] = 53439,
  [SMALL_STATE(1253)] = 53463,
  [SMALL_STATE(1254)] = 53493,
  [SMALL_STATE(1255)] = 53515,
  [SMALL_STATE(1256)] = 53539,
  [SMALL_STATE(1257)] = 53583,
  [SMALL_STATE(1258)] = 53605,
  [SMALL_STATE(1259)] = 53629,
  [SMALL_STATE(1260)] = 53653,
  [SMALL_STATE(1261)] = 53677,
  [SMALL_STATE(1262)] = 53701,
  [SMALL_STATE(1263)] = 53723,
  [SMALL_STATE(1264)] = 53769,
  [SMALL_STATE(1265)] = 53791,
  [SMALL_STATE(1266)] = 53815,
  [SMALL_STATE(1267)] = 53839,
  [SMALL_STATE(1268)] = 53866,
  [SMALL_STATE(1269)] = 53889,
  [SMALL_STATE(1270)] = 53914,
  [SMALL_STATE(1271)] = 53935,
  [SMALL_STATE(1272)] = 53960,
  [SMALL_STATE(1273)] = 53985,
  [SMALL_STATE(1274)] = 54010,
  [SMALL_STATE(1275)] = 54031,
  [SMALL_STATE(1276)] = 54054,
  [SMALL_STATE(1277)] = 54079,
  [SMALL_STATE(1278)] = 54100,
  [SMALL_STATE(1279)] = 54121,
  [SMALL_STATE(1280)] = 54142,
  [SMALL_STATE(1281)] = 54187,
  [SMALL_STATE(1282)] = 54212,
  [SMALL_STATE(1283)] = 54235,
  [SMALL_STATE(1284)] = 54258,
  [SMALL_STATE(1285)] = 54281,
  [SMALL_STATE(1286)] = 54304,
  [SMALL_STATE(1287)] = 54327,
  [SMALL_STATE(1288)] = 54350,
  [SMALL_STATE(1289)] = 54370,
  [SMALL_STATE(1290)] = 54390,
  [SMALL_STATE(1291)] = 54410,
  [SMALL_STATE(1292)] = 54430,
  [SMALL_STATE(1293)] = 54452,
  [SMALL_STATE(1294)] = 54472,
  [SMALL_STATE(1295)] = 54492,
  [SMALL_STATE(1296)] = 54512,
  [SMALL_STATE(1297)] = 54532,
  [SMALL_STATE(1298)] = 54552,
  [SMALL_STATE(1299)] = 54572,
  [SMALL_STATE(1300)] = 54592,
  [SMALL_STATE(1301)] = 54612,
  [SMALL_STATE(1302)] = 54632,
  [SMALL_STATE(1303)] = 54652,
  [SMALL_STATE(1304)] = 54672,
  [SMALL_STATE(1305)] = 54692,
  [SMALL_STATE(1306)] = 54712,
  [SMALL_STATE(1307)] = 54732,
  [SMALL_STATE(1308)] = 54752,
  [SMALL_STATE(1309)] = 54772,
  [SMALL_STATE(1310)] = 54792,
  [SMALL_STATE(1311)] = 54814,
  [SMALL_STATE(1312)] = 54838,
  [SMALL_STATE(1313)] = 54858,
  [SMALL_STATE(1314)] = 54878,
  [SMALL_STATE(1315)] = 54898,
  [SMALL_STATE(1316)] = 54918,
  [SMALL_STATE(1317)] = 54941,
  [SMALL_STATE(1318)] = 54976,
  [SMALL_STATE(1319)] = 55001,
  [SMALL_STATE(1320)] = 55026,
  [SMALL_STATE(1321)] = 55051,
  [SMALL_STATE(1322)] = 55076,
  [SMALL_STATE(1323)] = 55101,
  [SMALL_STATE(1324)] = 55124,
  [SMALL_STATE(1325)] = 55147,
  [SMALL_STATE(1326)] = 55170,
  [SMALL_STATE(1327)] = 55193,
  [SMALL_STATE(1328)] = 55218,
  [SMALL_STATE(1329)] = 55243,
  [SMALL_STATE(1330)] = 55266,
  [SMALL_STATE(1331)] = 55289,
  [SMALL_STATE(1332)] = 55314,
  [SMALL_STATE(1333)] = 55337,
  [SMALL_STATE(1334)] = 55360,
  [SMALL_STATE(1335)] = 55383,
  [SMALL_STATE(1336)] = 55406,
  [SMALL_STATE(1337)] = 55429,
  [SMALL_STATE(1338)] = 55449,
  [SMALL_STATE(1339)] = 55469,
  [SMALL_STATE(1340)] = 55489,
  [SMALL_STATE(1341)] = 55509,
  [SMALL_STATE(1342)] = 55529,
  [SMALL_STATE(1343)] = 55549,
  [SMALL_STATE(1344)] = 55569,
  [SMALL_STATE(1345)] = 55589,
  [SMALL_STATE(1346)] = 55609,
  [SMALL_STATE(1347)] = 55633,
  [SMALL_STATE(1348)] = 55653,
  [SMALL_STATE(1349)] = 55673,
  [SMALL_STATE(1350)] = 55693,
  [SMALL_STATE(1351)] = 55713,
  [SMALL_STATE(1352)] = 55733,
  [SMALL_STATE(1353)] = 55753,
  [SMALL_STATE(1354)] = 55777,
  [SMALL_STATE(1355)] = 55797,
  [SMALL_STATE(1356)] = 55817,
  [SMALL_STATE(1357)] = 55837,
  [SMALL_STATE(1358)] = 55861,
  [SMALL_STATE(1359)] = 55881,
  [SMALL_STATE(1360)] = 55901,
  [SMALL_STATE(1361)] = 55925,
  [SMALL_STATE(1362)] = 55945,
  [SMALL_STATE(1363)] = 55965,
  [SMALL_STATE(1364)] = 55985,
  [SMALL_STATE(1365)] = 56005,
  [SMALL_STATE(1366)] = 56025,
  [SMALL_STATE(1367)] = 56045,
  [SMALL_STATE(1368)] = 56065,
  [SMALL_STATE(1369)] = 56085,
  [SMALL_STATE(1370)] = 56105,
  [SMALL_STATE(1371)] = 56138,
  [SMALL_STATE(1372)] = 56169,
  [SMALL_STATE(1373)] = 56198,
  [SMALL_STATE(1374)] = 56231,
  [SMALL_STATE(1375)] = 56264,
  [SMALL_STATE(1376)] = 56295,
  [SMALL_STATE(1377)] = 56328,
  [SMALL_STATE(1378)] = 56359,
  [SMALL_STATE(1379)] = 56386,
  [SMALL_STATE(1380)] = 56417,
  [SMALL_STATE(1381)] = 56448,
  [SMALL_STATE(1382)] = 56479,
  [SMALL_STATE(1383)] = 56510,
  [SMALL_STATE(1384)] = 56533,
  [SMALL_STATE(1385)] = 56556,
  [SMALL_STATE(1386)] = 56587,
  [SMALL_STATE(1387)] = 56618,
  [SMALL_STATE(1388)] = 56643,
  [SMALL_STATE(1389)] = 56673,
  [SMALL_STATE(1390)] = 56695,
  [SMALL_STATE(1391)] = 56727,
  [SMALL_STATE(1392)] = 56757,
  [SMALL_STATE(1393)] = 56779,
  [SMALL_STATE(1394)] = 56809,
  [SMALL_STATE(1395)] = 56839,
  [SMALL_STATE(1396)] = 56871,
  [SMALL_STATE(1397)] = 56903,
  [SMALL_STATE(1398)] = 56929,
  [SMALL_STATE(1399)] = 56959,
  [SMALL_STATE(1400)] = 56981,
  [SMALL_STATE(1401)] = 57003,
  [SMALL_STATE(1402)] = 57033,
  [SMALL_STATE(1403)] = 57065,
  [SMALL_STATE(1404)] = 57095,
  [SMALL_STATE(1405)] = 57125,
  [SMALL_STATE(1406)] = 57155,
  [SMALL_STATE(1407)] = 57185,
  [SMALL_STATE(1408)] = 57215,
  [SMALL_STATE(1409)] = 57245,
  [SMALL_STATE(1410)] = 57275,
  [SMALL_STATE(1411)] = 57305,
  [SMALL_STATE(1412)] = 57335,
  [SMALL_STATE(1413)] = 57365,
  [SMALL_STATE(1414)] = 57395,
  [SMALL_STATE(1415)] = 57425,
  [SMALL_STATE(1416)] = 57447,
  [SMALL_STATE(1417)] = 57477,
  [SMALL_STATE(1418)] = 57503,
  [SMALL_STATE(1419)] = 57533,
  [SMALL_STATE(1420)] = 57563,
  [SMALL_STATE(1421)] = 57589,
  [SMALL_STATE(1422)] = 57616,
  [SMALL_STATE(1423)] = 57635,
  [SMALL_STATE(1424)] = 57662,
  [SMALL_STATE(1425)] = 57689,
  [SMALL_STATE(1426)] = 57714,
  [SMALL_STATE(1427)] = 57729,
  [SMALL_STATE(1428)] = 57752,
  [SMALL_STATE(1429)] = 57779,
  [SMALL_STATE(1430)] = 57804,
  [SMALL_STATE(1431)] = 57831,
  [SMALL_STATE(1432)] = 57858,
  [SMALL_STATE(1433)] = 57885,
  [SMALL_STATE(1434)] = 57910,
  [SMALL_STATE(1435)] = 57939,
  [SMALL_STATE(1436)] = 57968,
  [SMALL_STATE(1437)] = 57993,
  [SMALL_STATE(1438)] = 58022,
  [SMALL_STATE(1439)] = 58049,
  [SMALL_STATE(1440)] = 58076,
  [SMALL_STATE(1441)] = 58097,
  [SMALL_STATE(1442)] = 58126,
  [SMALL_STATE(1443)] = 58153,
  [SMALL_STATE(1444)] = 58180,
  [SMALL_STATE(1445)] = 58205,
  [SMALL_STATE(1446)] = 58232,
  [SMALL_STATE(1447)] = 58255,
  [SMALL_STATE(1448)] = 58274,
  [SMALL_STATE(1449)] = 58301,
  [SMALL_STATE(1450)] = 58324,
  [SMALL_STATE(1451)] = 58351,
  [SMALL_STATE(1452)] = 58378,
  [SMALL_STATE(1453)] = 58403,
  [SMALL_STATE(1454)] = 58424,
  [SMALL_STATE(1455)] = 58443,
  [SMALL_STATE(1456)] = 58468,
  [SMALL_STATE(1457)] = 58493,
  [SMALL_STATE(1458)] = 58522,
  [SMALL_STATE(1459)] = 58545,
  [SMALL_STATE(1460)] = 58568,
  [SMALL_STATE(1461)] = 58587,
  [SMALL_STATE(1462)] = 58612,
  [SMALL_STATE(1463)] = 58631,
  [SMALL_STATE(1464)] = 58660,
  [SMALL_STATE(1465)] = 58679,
  [SMALL_STATE(1466)] = 58698,
  [SMALL_STATE(1467)] = 58714,
  [SMALL_STATE(1468)] = 58736,
  [SMALL_STATE(1469)] = 58762,
  [SMALL_STATE(1470)] = 58784,
  [SMALL_STATE(1471)] = 58798,
  [SMALL_STATE(1472)] = 58812,
  [SMALL_STATE(1473)] = 58836,
  [SMALL_STATE(1474)] = 58858,
  [SMALL_STATE(1475)] = 58882,
  [SMALL_STATE(1476)] = 58908,
  [SMALL_STATE(1477)] = 58922,
  [SMALL_STATE(1478)] = 58938,
  [SMALL_STATE(1479)] = 58954,
  [SMALL_STATE(1480)] = 58968,
  [SMALL_STATE(1481)] = 58982,
  [SMALL_STATE(1482)] = 59006,
  [SMALL_STATE(1483)] = 59032,
  [SMALL_STATE(1484)] = 59056,
  [SMALL_STATE(1485)] = 59082,
  [SMALL_STATE(1486)] = 59104,
  [SMALL_STATE(1487)] = 59130,
  [SMALL_STATE(1488)] = 59156,
  [SMALL_STATE(1489)] = 59172,
  [SMALL_STATE(1490)] = 59194,
  [SMALL_STATE(1491)] = 59220,
  [SMALL_STATE(1492)] = 59236,
  [SMALL_STATE(1493)] = 59262,
  [SMALL_STATE(1494)] = 59288,
  [SMALL_STATE(1495)] = 59302,
  [SMALL_STATE(1496)] = 59318,
  [SMALL_STATE(1497)] = 59334,
  [SMALL_STATE(1498)] = 59358,
  [SMALL_STATE(1499)] = 59384,
  [SMALL_STATE(1500)] = 59400,
  [SMALL_STATE(1501)] = 59426,
  [SMALL_STATE(1502)] = 59440,
  [SMALL_STATE(1503)] = 59462,
  [SMALL_STATE(1504)] = 59488,
  [SMALL_STATE(1505)] = 59511,
  [SMALL_STATE(1506)] = 59526,
  [SMALL_STATE(1507)] = 59549,
  [SMALL_STATE(1508)] = 59572,
  [SMALL_STATE(1509)] = 59595,
  [SMALL_STATE(1510)] = 59618,
  [SMALL_STATE(1511)] = 59641,
  [SMALL_STATE(1512)] = 59658,
  [SMALL_STATE(1513)] = 59681,
  [SMALL_STATE(1514)] = 59704,
  [SMALL_STATE(1515)] = 59727,
  [SMALL_STATE(1516)] = 59750,
  [SMALL_STATE(1517)] = 59773,
  [SMALL_STATE(1518)] = 59790,
  [SMALL_STATE(1519)] = 59813,
  [SMALL_STATE(1520)] = 59836,
  [SMALL_STATE(1521)] = 59859,
  [SMALL_STATE(1522)] = 59878,
  [SMALL_STATE(1523)] = 59901,
  [SMALL_STATE(1524)] = 59918,
  [SMALL_STATE(1525)] = 59941,
  [SMALL_STATE(1526)] = 59964,
  [SMALL_STATE(1527)] = 59987,
  [SMALL_STATE(1528)] = 60010,
  [SMALL_STATE(1529)] = 60033,
  [SMALL_STATE(1530)] = 60050,
  [SMALL_STATE(1531)] = 60073,
  [SMALL_STATE(1532)] = 60096,
  [SMALL_STATE(1533)] = 60119,
  [SMALL_STATE(1534)] = 60142,
  [SMALL_STATE(1535)] = 60161,
  [SMALL_STATE(1536)] = 60184,
  [SMALL_STATE(1537)] = 60207,
  [SMALL_STATE(1538)] = 60230,
  [SMALL_STATE(1539)] = 60253,
  [SMALL_STATE(1540)] = 60276,
  [SMALL_STATE(1541)] = 60299,
  [SMALL_STATE(1542)] = 60322,
  [SMALL_STATE(1543)] = 60345,
  [SMALL_STATE(1544)] = 60368,
  [SMALL_STATE(1545)] = 60391,
  [SMALL_STATE(1546)] = 60414,
  [SMALL_STATE(1547)] = 60437,
  [SMALL_STATE(1548)] = 60460,
  [SMALL_STATE(1549)] = 60477,
  [SMALL_STATE(1550)] = 60494,
  [SMALL_STATE(1551)] = 60517,
  [SMALL_STATE(1552)] = 60540,
  [SMALL_STATE(1553)] = 60561,
  [SMALL_STATE(1554)] = 60584,
  [SMALL_STATE(1555)] = 60607,
  [SMALL_STATE(1556)] = 60630,
  [SMALL_STATE(1557)] = 60645,
  [SMALL_STATE(1558)] = 60668,
  [SMALL_STATE(1559)] = 60689,
  [SMALL_STATE(1560)] = 60706,
  [SMALL_STATE(1561)] = 60729,
  [SMALL_STATE(1562)] = 60752,
  [SMALL_STATE(1563)] = 60771,
  [SMALL_STATE(1564)] = 60794,
  [SMALL_STATE(1565)] = 60814,
  [SMALL_STATE(1566)] = 60834,
  [SMALL_STATE(1567)] = 60854,
  [SMALL_STATE(1568)] = 60870,
  [SMALL_STATE(1569)] = 60886,
  [SMALL_STATE(1570)] = 60902,
  [SMALL_STATE(1571)] = 60918,
  [SMALL_STATE(1572)] = 60934,
  [SMALL_STATE(1573)] = 60950,
  [SMALL_STATE(1574)] = 60970,
  [SMALL_STATE(1575)] = 60986,
  [SMALL_STATE(1576)] = 60998,
  [SMALL_STATE(1577)] = 61014,
  [SMALL_STATE(1578)] = 61026,
  [SMALL_STATE(1579)] = 61042,
  [SMALL_STATE(1580)] = 61054,
  [SMALL_STATE(1581)] = 61070,
  [SMALL_STATE(1582)] = 61090,
  [SMALL_STATE(1583)] = 61106,
  [SMALL_STATE(1584)] = 61122,
  [SMALL_STATE(1585)] = 61134,
  [SMALL_STATE(1586)] = 61146,
  [SMALL_STATE(1587)] = 61162,
  [SMALL_STATE(1588)] = 61182,
  [SMALL_STATE(1589)] = 61196,
  [SMALL_STATE(1590)] = 61212,
  [SMALL_STATE(1591)] = 61232,
  [SMALL_STATE(1592)] = 61252,
  [SMALL_STATE(1593)] = 61270,
  [SMALL_STATE(1594)] = 61290,
  [SMALL_STATE(1595)] = 61306,
  [SMALL_STATE(1596)] = 61318,
  [SMALL_STATE(1597)] = 61338,
  [SMALL_STATE(1598)] = 61358,
  [SMALL_STATE(1599)] = 61370,
  [SMALL_STATE(1600)] = 61390,
  [SMALL_STATE(1601)] = 61410,
  [SMALL_STATE(1602)] = 61430,
  [SMALL_STATE(1603)] = 61448,
  [SMALL_STATE(1604)] = 61468,
  [SMALL_STATE(1605)] = 61484,
  [SMALL_STATE(1606)] = 61502,
  [SMALL_STATE(1607)] = 61522,
  [SMALL_STATE(1608)] = 61538,
  [SMALL_STATE(1609)] = 61554,
  [SMALL_STATE(1610)] = 61570,
  [SMALL_STATE(1611)] = 61586,
  [SMALL_STATE(1612)] = 61606,
  [SMALL_STATE(1613)] = 61624,
  [SMALL_STATE(1614)] = 61640,
  [SMALL_STATE(1615)] = 61660,
  [SMALL_STATE(1616)] = 61680,
  [SMALL_STATE(1617)] = 61698,
  [SMALL_STATE(1618)] = 61718,
  [SMALL_STATE(1619)] = 61738,
  [SMALL_STATE(1620)] = 61750,
  [SMALL_STATE(1621)] = 61770,
  [SMALL_STATE(1622)] = 61790,
  [SMALL_STATE(1623)] = 61802,
  [SMALL_STATE(1624)] = 61814,
  [SMALL_STATE(1625)] = 61834,
  [SMALL_STATE(1626)] = 61854,
  [SMALL_STATE(1627)] = 61866,
  [SMALL_STATE(1628)] = 61878,
  [SMALL_STATE(1629)] = 61896,
  [SMALL_STATE(1630)] = 61916,
  [SMALL_STATE(1631)] = 61936,
  [SMALL_STATE(1632)] = 61956,
  [SMALL_STATE(1633)] = 61976,
  [SMALL_STATE(1634)] = 61996,
  [SMALL_STATE(1635)] = 62013,
  [SMALL_STATE(1636)] = 62028,
  [SMALL_STATE(1637)] = 62045,
  [SMALL_STATE(1638)] = 62062,
  [SMALL_STATE(1639)] = 62079,
  [SMALL_STATE(1640)] = 62092,
  [SMALL_STATE(1641)] = 62107,
  [SMALL_STATE(1642)] = 62124,
  [SMALL_STATE(1643)] = 62139,
  [SMALL_STATE(1644)] = 62156,
  [SMALL_STATE(1645)] = 62169,
  [SMALL_STATE(1646)] = 62186,
  [SMALL_STATE(1647)] = 62201,
  [SMALL_STATE(1648)] = 62218,
  [SMALL_STATE(1649)] = 62235,
  [SMALL_STATE(1650)] = 62252,
  [SMALL_STATE(1651)] = 62269,
  [SMALL_STATE(1652)] = 62284,
  [SMALL_STATE(1653)] = 62299,
  [SMALL_STATE(1654)] = 62316,
  [SMALL_STATE(1655)] = 62333,
  [SMALL_STATE(1656)] = 62350,
  [SMALL_STATE(1657)] = 62365,
  [SMALL_STATE(1658)] = 62382,
  [SMALL_STATE(1659)] = 62399,
  [SMALL_STATE(1660)] = 62414,
  [SMALL_STATE(1661)] = 62431,
  [SMALL_STATE(1662)] = 62448,
  [SMALL_STATE(1663)] = 62461,
  [SMALL_STATE(1664)] = 62476,
  [SMALL_STATE(1665)] = 62493,
  [SMALL_STATE(1666)] = 62510,
  [SMALL_STATE(1667)] = 62525,
  [SMALL_STATE(1668)] = 62538,
  [SMALL_STATE(1669)] = 62555,
  [SMALL_STATE(1670)] = 62572,
  [SMALL_STATE(1671)] = 62587,
  [SMALL_STATE(1672)] = 62604,
  [SMALL_STATE(1673)] = 62617,
  [SMALL_STATE(1674)] = 62632,
  [SMALL_STATE(1675)] = 62649,
  [SMALL_STATE(1676)] = 62664,
  [SMALL_STATE(1677)] = 62681,
  [SMALL_STATE(1678)] = 62698,
  [SMALL_STATE(1679)] = 62715,
  [SMALL_STATE(1680)] = 62732,
  [SMALL_STATE(1681)] = 62749,
  [SMALL_STATE(1682)] = 62764,
  [SMALL_STATE(1683)] = 62779,
  [SMALL_STATE(1684)] = 62792,
  [SMALL_STATE(1685)] = 62809,
  [SMALL_STATE(1686)] = 62826,
  [SMALL_STATE(1687)] = 62843,
  [SMALL_STATE(1688)] = 62860,
  [SMALL_STATE(1689)] = 62877,
  [SMALL_STATE(1690)] = 62892,
  [SMALL_STATE(1691)] = 62907,
  [SMALL_STATE(1692)] = 62920,
  [SMALL_STATE(1693)] = 62935,
  [SMALL_STATE(1694)] = 62952,
  [SMALL_STATE(1695)] = 62969,
  [SMALL_STATE(1696)] = 62986,
  [SMALL_STATE(1697)] = 62999,
  [SMALL_STATE(1698)] = 63016,
  [SMALL_STATE(1699)] = 63033,
  [SMALL_STATE(1700)] = 63050,
  [SMALL_STATE(1701)] = 63067,
  [SMALL_STATE(1702)] = 63084,
  [SMALL_STATE(1703)] = 63101,
  [SMALL_STATE(1704)] = 63118,
  [SMALL_STATE(1705)] = 63135,
  [SMALL_STATE(1706)] = 63152,
  [SMALL_STATE(1707)] = 63169,
  [SMALL_STATE(1708)] = 63186,
  [SMALL_STATE(1709)] = 63203,
  [SMALL_STATE(1710)] = 63218,
  [SMALL_STATE(1711)] = 63235,
  [SMALL_STATE(1712)] = 63252,
  [SMALL_STATE(1713)] = 63269,
  [SMALL_STATE(1714)] = 63286,
  [SMALL_STATE(1715)] = 63299,
  [SMALL_STATE(1716)] = 63316,
  [SMALL_STATE(1717)] = 63333,
  [SMALL_STATE(1718)] = 63346,
  [SMALL_STATE(1719)] = 63363,
  [SMALL_STATE(1720)] = 63380,
  [SMALL_STATE(1721)] = 63395,
  [SMALL_STATE(1722)] = 63412,
  [SMALL_STATE(1723)] = 63429,
  [SMALL_STATE(1724)] = 63439,
  [SMALL_STATE(1725)] = 63453,
  [SMALL_STATE(1726)] = 63463,
  [SMALL_STATE(1727)] = 63477,
  [SMALL_STATE(1728)] = 63487,
  [SMALL_STATE(1729)] = 63499,
  [SMALL_STATE(1730)] = 63509,
  [SMALL_STATE(1731)] = 63523,
  [SMALL_STATE(1732)] = 63537,
  [SMALL_STATE(1733)] = 63547,
  [SMALL_STATE(1734)] = 63561,
  [SMALL_STATE(1735)] = 63571,
  [SMALL_STATE(1736)] = 63585,
  [SMALL_STATE(1737)] = 63595,
  [SMALL_STATE(1738)] = 63609,
  [SMALL_STATE(1739)] = 63623,
  [SMALL_STATE(1740)] = 63637,
  [SMALL_STATE(1741)] = 63651,
  [SMALL_STATE(1742)] = 63661,
  [SMALL_STATE(1743)] = 63675,
  [SMALL_STATE(1744)] = 63689,
  [SMALL_STATE(1745)] = 63701,
  [SMALL_STATE(1746)] = 63713,
  [SMALL_STATE(1747)] = 63727,
  [SMALL_STATE(1748)] = 63737,
  [SMALL_STATE(1749)] = 63751,
  [SMALL_STATE(1750)] = 63765,
  [SMALL_STATE(1751)] = 63779,
  [SMALL_STATE(1752)] = 63793,
  [SMALL_STATE(1753)] = 63805,
  [SMALL_STATE(1754)] = 63819,
  [SMALL_STATE(1755)] = 63829,
  [SMALL_STATE(1756)] = 63841,
  [SMALL_STATE(1757)] = 63853,
  [SMALL_STATE(1758)] = 63867,
  [SMALL_STATE(1759)] = 63881,
  [SMALL_STATE(1760)] = 63895,
  [SMALL_STATE(1761)] = 63907,
  [SMALL_STATE(1762)] = 63919,
  [SMALL_STATE(1763)] = 63931,
  [SMALL_STATE(1764)] = 63945,
  [SMALL_STATE(1765)] = 63957,
  [SMALL_STATE(1766)] = 63969,
  [SMALL_STATE(1767)] = 63983,
  [SMALL_STATE(1768)] = 63995,
  [SMALL_STATE(1769)] = 64009,
  [SMALL_STATE(1770)] = 64023,
  [SMALL_STATE(1771)] = 64035,
  [SMALL_STATE(1772)] = 64049,
  [SMALL_STATE(1773)] = 64063,
  [SMALL_STATE(1774)] = 64077,
  [SMALL_STATE(1775)] = 64089,
  [SMALL_STATE(1776)] = 64103,
  [SMALL_STATE(1777)] = 64117,
  [SMALL_STATE(1778)] = 64127,
  [SMALL_STATE(1779)] = 64141,
  [SMALL_STATE(1780)] = 64155,
  [SMALL_STATE(1781)] = 64169,
  [SMALL_STATE(1782)] = 64183,
  [SMALL_STATE(1783)] = 64193,
  [SMALL_STATE(1784)] = 64207,
  [SMALL_STATE(1785)] = 64221,
  [SMALL_STATE(1786)] = 64235,
  [SMALL_STATE(1787)] = 64247,
  [SMALL_STATE(1788)] = 64261,
  [SMALL_STATE(1789)] = 64275,
  [SMALL_STATE(1790)] = 64289,
  [SMALL_STATE(1791)] = 64303,
  [SMALL_STATE(1792)] = 64315,
  [SMALL_STATE(1793)] = 64329,
  [SMALL_STATE(1794)] = 64341,
  [SMALL_STATE(1795)] = 64355,
  [SMALL_STATE(1796)] = 64369,
  [SMALL_STATE(1797)] = 64383,
  [SMALL_STATE(1798)] = 64395,
  [SMALL_STATE(1799)] = 64409,
  [SMALL_STATE(1800)] = 64423,
  [SMALL_STATE(1801)] = 64433,
  [SMALL_STATE(1802)] = 64443,
  [SMALL_STATE(1803)] = 64457,
  [SMALL_STATE(1804)] = 64467,
  [SMALL_STATE(1805)] = 64477,
  [SMALL_STATE(1806)] = 64487,
  [SMALL_STATE(1807)] = 64501,
  [SMALL_STATE(1808)] = 64515,
  [SMALL_STATE(1809)] = 64529,
  [SMALL_STATE(1810)] = 64543,
  [SMALL_STATE(1811)] = 64553,
  [SMALL_STATE(1812)] = 64563,
  [SMALL_STATE(1813)] = 64577,
  [SMALL_STATE(1814)] = 64591,
  [SMALL_STATE(1815)] = 64605,
  [SMALL_STATE(1816)] = 64617,
  [SMALL_STATE(1817)] = 64631,
  [SMALL_STATE(1818)] = 64645,
  [SMALL_STATE(1819)] = 64659,
  [SMALL_STATE(1820)] = 64673,
  [SMALL_STATE(1821)] = 64683,
  [SMALL_STATE(1822)] = 64697,
  [SMALL_STATE(1823)] = 64711,
  [SMALL_STATE(1824)] = 64725,
  [SMALL_STATE(1825)] = 64739,
  [SMALL_STATE(1826)] = 64753,
  [SMALL_STATE(1827)] = 64767,
  [SMALL_STATE(1828)] = 64777,
  [SMALL_STATE(1829)] = 64791,
  [SMALL_STATE(1830)] = 64801,
  [SMALL_STATE(1831)] = 64811,
  [SMALL_STATE(1832)] = 64821,
  [SMALL_STATE(1833)] = 64835,
  [SMALL_STATE(1834)] = 64849,
  [SMALL_STATE(1835)] = 64863,
  [SMALL_STATE(1836)] = 64877,
  [SMALL_STATE(1837)] = 64891,
  [SMALL_STATE(1838)] = 64905,
  [SMALL_STATE(1839)] = 64919,
  [SMALL_STATE(1840)] = 64933,
  [SMALL_STATE(1841)] = 64947,
  [SMALL_STATE(1842)] = 64959,
  [SMALL_STATE(1843)] = 64973,
  [SMALL_STATE(1844)] = 64987,
  [SMALL_STATE(1845)] = 65001,
  [SMALL_STATE(1846)] = 65013,
  [SMALL_STATE(1847)] = 65025,
  [SMALL_STATE(1848)] = 65039,
  [SMALL_STATE(1849)] = 65049,
  [SMALL_STATE(1850)] = 65059,
  [SMALL_STATE(1851)] = 65069,
  [SMALL_STATE(1852)] = 65079,
  [SMALL_STATE(1853)] = 65093,
  [SMALL_STATE(1854)] = 65107,
  [SMALL_STATE(1855)] = 65121,
  [SMALL_STATE(1856)] = 65135,
  [SMALL_STATE(1857)] = 65149,
  [SMALL_STATE(1858)] = 65163,
  [SMALL_STATE(1859)] = 65177,
  [SMALL_STATE(1860)] = 65191,
  [SMALL_STATE(1861)] = 65205,
  [SMALL_STATE(1862)] = 65219,
  [SMALL_STATE(1863)] = 65233,
  [SMALL_STATE(1864)] = 65245,
  [SMALL_STATE(1865)] = 65259,
  [SMALL_STATE(1866)] = 65273,
  [SMALL_STATE(1867)] = 65287,
  [SMALL_STATE(1868)] = 65301,
  [SMALL_STATE(1869)] = 65311,
  [SMALL_STATE(1870)] = 65325,
  [SMALL_STATE(1871)] = 65339,
  [SMALL_STATE(1872)] = 65353,
  [SMALL_STATE(1873)] = 65367,
  [SMALL_STATE(1874)] = 65381,
  [SMALL_STATE(1875)] = 65395,
  [SMALL_STATE(1876)] = 65409,
  [SMALL_STATE(1877)] = 65423,
  [SMALL_STATE(1878)] = 65437,
  [SMALL_STATE(1879)] = 65451,
  [SMALL_STATE(1880)] = 65465,
  [SMALL_STATE(1881)] = 65479,
  [SMALL_STATE(1882)] = 65493,
  [SMALL_STATE(1883)] = 65507,
  [SMALL_STATE(1884)] = 65521,
  [SMALL_STATE(1885)] = 65535,
  [SMALL_STATE(1886)] = 65549,
  [SMALL_STATE(1887)] = 65563,
  [SMALL_STATE(1888)] = 65577,
  [SMALL_STATE(1889)] = 65587,
  [SMALL_STATE(1890)] = 65601,
  [SMALL_STATE(1891)] = 65615,
  [SMALL_STATE(1892)] = 65629,
  [SMALL_STATE(1893)] = 65643,
  [SMALL_STATE(1894)] = 65657,
  [SMALL_STATE(1895)] = 65671,
  [SMALL_STATE(1896)] = 65683,
  [SMALL_STATE(1897)] = 65693,
  [SMALL_STATE(1898)] = 65707,
  [SMALL_STATE(1899)] = 65717,
  [SMALL_STATE(1900)] = 65729,
  [SMALL_STATE(1901)] = 65743,
  [SMALL_STATE(1902)] = 65757,
  [SMALL_STATE(1903)] = 65769,
  [SMALL_STATE(1904)] = 65783,
  [SMALL_STATE(1905)] = 65797,
  [SMALL_STATE(1906)] = 65811,
  [SMALL_STATE(1907)] = 65825,
  [SMALL_STATE(1908)] = 65837,
  [SMALL_STATE(1909)] = 65851,
  [SMALL_STATE(1910)] = 65861,
  [SMALL_STATE(1911)] = 65875,
  [SMALL_STATE(1912)] = 65889,
  [SMALL_STATE(1913)] = 65901,
  [SMALL_STATE(1914)] = 65915,
  [SMALL_STATE(1915)] = 65929,
  [SMALL_STATE(1916)] = 65943,
  [SMALL_STATE(1917)] = 65957,
  [SMALL_STATE(1918)] = 65971,
  [SMALL_STATE(1919)] = 65985,
  [SMALL_STATE(1920)] = 65999,
  [SMALL_STATE(1921)] = 66013,
  [SMALL_STATE(1922)] = 66027,
  [SMALL_STATE(1923)] = 66037,
  [SMALL_STATE(1924)] = 66051,
  [SMALL_STATE(1925)] = 66063,
  [SMALL_STATE(1926)] = 66077,
  [SMALL_STATE(1927)] = 66091,
  [SMALL_STATE(1928)] = 66101,
  [SMALL_STATE(1929)] = 66115,
  [SMALL_STATE(1930)] = 66129,
  [SMALL_STATE(1931)] = 66143,
  [SMALL_STATE(1932)] = 66157,
  [SMALL_STATE(1933)] = 66171,
  [SMALL_STATE(1934)] = 66185,
  [SMALL_STATE(1935)] = 66199,
  [SMALL_STATE(1936)] = 66213,
  [SMALL_STATE(1937)] = 66227,
  [SMALL_STATE(1938)] = 66237,
  [SMALL_STATE(1939)] = 66251,
  [SMALL_STATE(1940)] = 66265,
  [SMALL_STATE(1941)] = 66279,
  [SMALL_STATE(1942)] = 66293,
  [SMALL_STATE(1943)] = 66305,
  [SMALL_STATE(1944)] = 66319,
  [SMALL_STATE(1945)] = 66329,
  [SMALL_STATE(1946)] = 66343,
  [SMALL_STATE(1947)] = 66357,
  [SMALL_STATE(1948)] = 66371,
  [SMALL_STATE(1949)] = 66385,
  [SMALL_STATE(1950)] = 66399,
  [SMALL_STATE(1951)] = 66411,
  [SMALL_STATE(1952)] = 66425,
  [SMALL_STATE(1953)] = 66439,
  [SMALL_STATE(1954)] = 66453,
  [SMALL_STATE(1955)] = 66467,
  [SMALL_STATE(1956)] = 66481,
  [SMALL_STATE(1957)] = 66495,
  [SMALL_STATE(1958)] = 66509,
  [SMALL_STATE(1959)] = 66523,
  [SMALL_STATE(1960)] = 66537,
  [SMALL_STATE(1961)] = 66551,
  [SMALL_STATE(1962)] = 66563,
  [SMALL_STATE(1963)] = 66577,
  [SMALL_STATE(1964)] = 66591,
  [SMALL_STATE(1965)] = 66605,
  [SMALL_STATE(1966)] = 66619,
  [SMALL_STATE(1967)] = 66630,
  [SMALL_STATE(1968)] = 66641,
  [SMALL_STATE(1969)] = 66652,
  [SMALL_STATE(1970)] = 66663,
  [SMALL_STATE(1971)] = 66674,
  [SMALL_STATE(1972)] = 66683,
  [SMALL_STATE(1973)] = 66692,
  [SMALL_STATE(1974)] = 66703,
  [SMALL_STATE(1975)] = 66712,
  [SMALL_STATE(1976)] = 66723,
  [SMALL_STATE(1977)] = 66734,
  [SMALL_STATE(1978)] = 66745,
  [SMALL_STATE(1979)] = 66756,
  [SMALL_STATE(1980)] = 66767,
  [SMALL_STATE(1981)] = 66778,
  [SMALL_STATE(1982)] = 66789,
  [SMALL_STATE(1983)] = 66800,
  [SMALL_STATE(1984)] = 66809,
  [SMALL_STATE(1985)] = 66820,
  [SMALL_STATE(1986)] = 66831,
  [SMALL_STATE(1987)] = 66842,
  [SMALL_STATE(1988)] = 66853,
  [SMALL_STATE(1989)] = 66864,
  [SMALL_STATE(1990)] = 66875,
  [SMALL_STATE(1991)] = 66886,
  [SMALL_STATE(1992)] = 66897,
  [SMALL_STATE(1993)] = 66908,
  [SMALL_STATE(1994)] = 66919,
  [SMALL_STATE(1995)] = 66930,
  [SMALL_STATE(1996)] = 66941,
  [SMALL_STATE(1997)] = 66952,
  [SMALL_STATE(1998)] = 66963,
  [SMALL_STATE(1999)] = 66974,
  [SMALL_STATE(2000)] = 66985,
  [SMALL_STATE(2001)] = 66996,
  [SMALL_STATE(2002)] = 67007,
  [SMALL_STATE(2003)] = 67018,
  [SMALL_STATE(2004)] = 67029,
  [SMALL_STATE(2005)] = 67040,
  [SMALL_STATE(2006)] = 67051,
  [SMALL_STATE(2007)] = 67062,
  [SMALL_STATE(2008)] = 67073,
  [SMALL_STATE(2009)] = 67084,
  [SMALL_STATE(2010)] = 67095,
  [SMALL_STATE(2011)] = 67104,
  [SMALL_STATE(2012)] = 67115,
  [SMALL_STATE(2013)] = 67126,
  [SMALL_STATE(2014)] = 67137,
  [SMALL_STATE(2015)] = 67146,
  [SMALL_STATE(2016)] = 67157,
  [SMALL_STATE(2017)] = 67168,
  [SMALL_STATE(2018)] = 67177,
  [SMALL_STATE(2019)] = 67188,
  [SMALL_STATE(2020)] = 67199,
  [SMALL_STATE(2021)] = 67210,
  [SMALL_STATE(2022)] = 67221,
  [SMALL_STATE(2023)] = 67232,
  [SMALL_STATE(2024)] = 67243,
  [SMALL_STATE(2025)] = 67254,
  [SMALL_STATE(2026)] = 67265,
  [SMALL_STATE(2027)] = 67276,
  [SMALL_STATE(2028)] = 67287,
  [SMALL_STATE(2029)] = 67298,
  [SMALL_STATE(2030)] = 67309,
  [SMALL_STATE(2031)] = 67320,
  [SMALL_STATE(2032)] = 67331,
  [SMALL_STATE(2033)] = 67342,
  [SMALL_STATE(2034)] = 67353,
  [SMALL_STATE(2035)] = 67362,
  [SMALL_STATE(2036)] = 67373,
  [SMALL_STATE(2037)] = 67382,
  [SMALL_STATE(2038)] = 67393,
  [SMALL_STATE(2039)] = 67404,
  [SMALL_STATE(2040)] = 67415,
  [SMALL_STATE(2041)] = 67426,
  [SMALL_STATE(2042)] = 67437,
  [SMALL_STATE(2043)] = 67448,
  [SMALL_STATE(2044)] = 67459,
  [SMALL_STATE(2045)] = 67468,
  [SMALL_STATE(2046)] = 67479,
  [SMALL_STATE(2047)] = 67488,
  [SMALL_STATE(2048)] = 67499,
  [SMALL_STATE(2049)] = 67510,
  [SMALL_STATE(2050)] = 67519,
  [SMALL_STATE(2051)] = 67530,
  [SMALL_STATE(2052)] = 67541,
  [SMALL_STATE(2053)] = 67552,
  [SMALL_STATE(2054)] = 67563,
  [SMALL_STATE(2055)] = 67572,
  [SMALL_STATE(2056)] = 67583,
  [SMALL_STATE(2057)] = 67592,
  [SMALL_STATE(2058)] = 67603,
  [SMALL_STATE(2059)] = 67614,
  [SMALL_STATE(2060)] = 67625,
  [SMALL_STATE(2061)] = 67636,
  [SMALL_STATE(2062)] = 67645,
  [SMALL_STATE(2063)] = 67654,
  [SMALL_STATE(2064)] = 67665,
  [SMALL_STATE(2065)] = 67676,
  [SMALL_STATE(2066)] = 67687,
  [SMALL_STATE(2067)] = 67698,
  [SMALL_STATE(2068)] = 67709,
  [SMALL_STATE(2069)] = 67720,
  [SMALL_STATE(2070)] = 67731,
  [SMALL_STATE(2071)] = 67742,
  [SMALL_STATE(2072)] = 67753,
  [SMALL_STATE(2073)] = 67764,
  [SMALL_STATE(2074)] = 67775,
  [SMALL_STATE(2075)] = 67786,
  [SMALL_STATE(2076)] = 67797,
  [SMALL_STATE(2077)] = 67808,
  [SMALL_STATE(2078)] = 67819,
  [SMALL_STATE(2079)] = 67828,
  [SMALL_STATE(2080)] = 67839,
  [SMALL_STATE(2081)] = 67850,
  [SMALL_STATE(2082)] = 67861,
  [SMALL_STATE(2083)] = 67872,
  [SMALL_STATE(2084)] = 67883,
  [SMALL_STATE(2085)] = 67894,
  [SMALL_STATE(2086)] = 67905,
  [SMALL_STATE(2087)] = 67916,
  [SMALL_STATE(2088)] = 67927,
  [SMALL_STATE(2089)] = 67938,
  [SMALL_STATE(2090)] = 67949,
  [SMALL_STATE(2091)] = 67960,
  [SMALL_STATE(2092)] = 67971,
  [SMALL_STATE(2093)] = 67982,
  [SMALL_STATE(2094)] = 67993,
  [SMALL_STATE(2095)] = 68004,
  [SMALL_STATE(2096)] = 68015,
  [SMALL_STATE(2097)] = 68026,
  [SMALL_STATE(2098)] = 68037,
  [SMALL_STATE(2099)] = 68048,
  [SMALL_STATE(2100)] = 68059,
  [SMALL_STATE(2101)] = 68068,
  [SMALL_STATE(2102)] = 68079,
  [SMALL_STATE(2103)] = 68090,
  [SMALL_STATE(2104)] = 68099,
  [SMALL_STATE(2105)] = 68110,
  [SMALL_STATE(2106)] = 68121,
  [SMALL_STATE(2107)] = 68132,
  [SMALL_STATE(2108)] = 68143,
  [SMALL_STATE(2109)] = 68154,
  [SMALL_STATE(2110)] = 68165,
  [SMALL_STATE(2111)] = 68176,
  [SMALL_STATE(2112)] = 68187,
  [SMALL_STATE(2113)] = 68198,
  [SMALL_STATE(2114)] = 68209,
  [SMALL_STATE(2115)] = 68220,
  [SMALL_STATE(2116)] = 68231,
  [SMALL_STATE(2117)] = 68240,
  [SMALL_STATE(2118)] = 68251,
  [SMALL_STATE(2119)] = 68262,
  [SMALL_STATE(2120)] = 68271,
  [SMALL_STATE(2121)] = 68280,
  [SMALL_STATE(2122)] = 68291,
  [SMALL_STATE(2123)] = 68302,
  [SMALL_STATE(2124)] = 68313,
  [SMALL_STATE(2125)] = 68324,
  [SMALL_STATE(2126)] = 68335,
  [SMALL_STATE(2127)] = 68346,
  [SMALL_STATE(2128)] = 68357,
  [SMALL_STATE(2129)] = 68366,
  [SMALL_STATE(2130)] = 68377,
  [SMALL_STATE(2131)] = 68388,
  [SMALL_STATE(2132)] = 68399,
  [SMALL_STATE(2133)] = 68410,
  [SMALL_STATE(2134)] = 68421,
  [SMALL_STATE(2135)] = 68432,
  [SMALL_STATE(2136)] = 68443,
  [SMALL_STATE(2137)] = 68454,
  [SMALL_STATE(2138)] = 68465,
  [SMALL_STATE(2139)] = 68476,
  [SMALL_STATE(2140)] = 68487,
  [SMALL_STATE(2141)] = 68498,
  [SMALL_STATE(2142)] = 68509,
  [SMALL_STATE(2143)] = 68520,
  [SMALL_STATE(2144)] = 68531,
  [SMALL_STATE(2145)] = 68542,
  [SMALL_STATE(2146)] = 68551,
  [SMALL_STATE(2147)] = 68562,
  [SMALL_STATE(2148)] = 68571,
  [SMALL_STATE(2149)] = 68582,
  [SMALL_STATE(2150)] = 68593,
  [SMALL_STATE(2151)] = 68604,
  [SMALL_STATE(2152)] = 68615,
  [SMALL_STATE(2153)] = 68626,
  [SMALL_STATE(2154)] = 68637,
  [SMALL_STATE(2155)] = 68648,
  [SMALL_STATE(2156)] = 68659,
  [SMALL_STATE(2157)] = 68668,
  [SMALL_STATE(2158)] = 68679,
  [SMALL_STATE(2159)] = 68688,
  [SMALL_STATE(2160)] = 68699,
  [SMALL_STATE(2161)] = 68707,
  [SMALL_STATE(2162)] = 68715,
  [SMALL_STATE(2163)] = 68723,
  [SMALL_STATE(2164)] = 68731,
  [SMALL_STATE(2165)] = 68739,
  [SMALL_STATE(2166)] = 68747,
  [SMALL_STATE(2167)] = 68755,
  [SMALL_STATE(2168)] = 68763,
  [SMALL_STATE(2169)] = 68771,
  [SMALL_STATE(2170)] = 68779,
  [SMALL_STATE(2171)] = 68787,
  [SMALL_STATE(2172)] = 68795,
  [SMALL_STATE(2173)] = 68803,
  [SMALL_STATE(2174)] = 68811,
  [SMALL_STATE(2175)] = 68819,
  [SMALL_STATE(2176)] = 68827,
  [SMALL_STATE(2177)] = 68835,
  [SMALL_STATE(2178)] = 68843,
  [SMALL_STATE(2179)] = 68851,
  [SMALL_STATE(2180)] = 68859,
  [SMALL_STATE(2181)] = 68867,
  [SMALL_STATE(2182)] = 68875,
  [SMALL_STATE(2183)] = 68883,
  [SMALL_STATE(2184)] = 68891,
  [SMALL_STATE(2185)] = 68899,
  [SMALL_STATE(2186)] = 68907,
  [SMALL_STATE(2187)] = 68915,
  [SMALL_STATE(2188)] = 68923,
  [SMALL_STATE(2189)] = 68931,
  [SMALL_STATE(2190)] = 68939,
  [SMALL_STATE(2191)] = 68947,
  [SMALL_STATE(2192)] = 68955,
  [SMALL_STATE(2193)] = 68963,
  [SMALL_STATE(2194)] = 68971,
  [SMALL_STATE(2195)] = 68979,
  [SMALL_STATE(2196)] = 68987,
  [SMALL_STATE(2197)] = 68995,
  [SMALL_STATE(2198)] = 69003,
  [SMALL_STATE(2199)] = 69011,
  [SMALL_STATE(2200)] = 69019,
  [SMALL_STATE(2201)] = 69027,
  [SMALL_STATE(2202)] = 69035,
  [SMALL_STATE(2203)] = 69043,
  [SMALL_STATE(2204)] = 69051,
  [SMALL_STATE(2205)] = 69059,
  [SMALL_STATE(2206)] = 69067,
  [SMALL_STATE(2207)] = 69075,
  [SMALL_STATE(2208)] = 69083,
  [SMALL_STATE(2209)] = 69091,
  [SMALL_STATE(2210)] = 69099,
  [SMALL_STATE(2211)] = 69107,
  [SMALL_STATE(2212)] = 69115,
  [SMALL_STATE(2213)] = 69123,
  [SMALL_STATE(2214)] = 69131,
  [SMALL_STATE(2215)] = 69139,
  [SMALL_STATE(2216)] = 69147,
  [SMALL_STATE(2217)] = 69155,
  [SMALL_STATE(2218)] = 69163,
  [SMALL_STATE(2219)] = 69171,
  [SMALL_STATE(2220)] = 69179,
  [SMALL_STATE(2221)] = 69187,
  [SMALL_STATE(2222)] = 69195,
  [SMALL_STATE(2223)] = 69203,
  [SMALL_STATE(2224)] = 69211,
  [SMALL_STATE(2225)] = 69219,
  [SMALL_STATE(2226)] = 69227,
  [SMALL_STATE(2227)] = 69235,
  [SMALL_STATE(2228)] = 69243,
  [SMALL_STATE(2229)] = 69251,
  [SMALL_STATE(2230)] = 69259,
  [SMALL_STATE(2231)] = 69267,
  [SMALL_STATE(2232)] = 69275,
  [SMALL_STATE(2233)] = 69283,
  [SMALL_STATE(2234)] = 69291,
  [SMALL_STATE(2235)] = 69299,
  [SMALL_STATE(2236)] = 69307,
  [SMALL_STATE(2237)] = 69315,
  [SMALL_STATE(2238)] = 69323,
  [SMALL_STATE(2239)] = 69331,
  [SMALL_STATE(2240)] = 69339,
  [SMALL_STATE(2241)] = 69347,
  [SMALL_STATE(2242)] = 69355,
  [SMALL_STATE(2243)] = 69363,
  [SMALL_STATE(2244)] = 69371,
  [SMALL_STATE(2245)] = 69379,
  [SMALL_STATE(2246)] = 69387,
  [SMALL_STATE(2247)] = 69395,
  [SMALL_STATE(2248)] = 69403,
  [SMALL_STATE(2249)] = 69411,
  [SMALL_STATE(2250)] = 69419,
  [SMALL_STATE(2251)] = 69427,
  [SMALL_STATE(2252)] = 69435,
  [SMALL_STATE(2253)] = 69443,
  [SMALL_STATE(2254)] = 69451,
  [SMALL_STATE(2255)] = 69459,
  [SMALL_STATE(2256)] = 69467,
  [SMALL_STATE(2257)] = 69475,
  [SMALL_STATE(2258)] = 69483,
  [SMALL_STATE(2259)] = 69491,
  [SMALL_STATE(2260)] = 69499,
  [SMALL_STATE(2261)] = 69507,
  [SMALL_STATE(2262)] = 69515,
  [SMALL_STATE(2263)] = 69523,
  [SMALL_STATE(2264)] = 69531,
  [SMALL_STATE(2265)] = 69539,
  [SMALL_STATE(2266)] = 69547,
  [SMALL_STATE(2267)] = 69555,
  [SMALL_STATE(2268)] = 69563,
  [SMALL_STATE(2269)] = 69571,
  [SMALL_STATE(2270)] = 69579,
  [SMALL_STATE(2271)] = 69587,
  [SMALL_STATE(2272)] = 69595,
  [SMALL_STATE(2273)] = 69603,
  [SMALL_STATE(2274)] = 69611,
  [SMALL_STATE(2275)] = 69619,
  [SMALL_STATE(2276)] = 69627,
  [SMALL_STATE(2277)] = 69635,
  [SMALL_STATE(2278)] = 69643,
  [SMALL_STATE(2279)] = 69651,
  [SMALL_STATE(2280)] = 69659,
  [SMALL_STATE(2281)] = 69667,
  [SMALL_STATE(2282)] = 69675,
  [SMALL_STATE(2283)] = 69683,
  [SMALL_STATE(2284)] = 69691,
  [SMALL_STATE(2285)] = 69699,
  [SMALL_STATE(2286)] = 69707,
  [SMALL_STATE(2287)] = 69715,
  [SMALL_STATE(2288)] = 69723,
  [SMALL_STATE(2289)] = 69731,
  [SMALL_STATE(2290)] = 69739,
  [SMALL_STATE(2291)] = 69747,
  [SMALL_STATE(2292)] = 69755,
  [SMALL_STATE(2293)] = 69763,
  [SMALL_STATE(2294)] = 69771,
  [SMALL_STATE(2295)] = 69779,
  [SMALL_STATE(2296)] = 69787,
  [SMALL_STATE(2297)] = 69795,
  [SMALL_STATE(2298)] = 69803,
  [SMALL_STATE(2299)] = 69811,
  [SMALL_STATE(2300)] = 69819,
  [SMALL_STATE(2301)] = 69827,
  [SMALL_STATE(2302)] = 69835,
  [SMALL_STATE(2303)] = 69843,
  [SMALL_STATE(2304)] = 69851,
  [SMALL_STATE(2305)] = 69859,
  [SMALL_STATE(2306)] = 69867,
  [SMALL_STATE(2307)] = 69875,
  [SMALL_STATE(2308)] = 69883,
  [SMALL_STATE(2309)] = 69891,
  [SMALL_STATE(2310)] = 69899,
  [SMALL_STATE(2311)] = 69907,
  [SMALL_STATE(2312)] = 69915,
  [SMALL_STATE(2313)] = 69923,
  [SMALL_STATE(2314)] = 69931,
  [SMALL_STATE(2315)] = 69939,
  [SMALL_STATE(2316)] = 69947,
  [SMALL_STATE(2317)] = 69955,
  [SMALL_STATE(2318)] = 69963,
  [SMALL_STATE(2319)] = 69971,
  [SMALL_STATE(2320)] = 69979,
  [SMALL_STATE(2321)] = 69987,
  [SMALL_STATE(2322)] = 69995,
  [SMALL_STATE(2323)] = 70003,
  [SMALL_STATE(2324)] = 70011,
  [SMALL_STATE(2325)] = 70019,
  [SMALL_STATE(2326)] = 70027,
  [SMALL_STATE(2327)] = 70035,
  [SMALL_STATE(2328)] = 70043,
  [SMALL_STATE(2329)] = 70051,
  [SMALL_STATE(2330)] = 70059,
  [SMALL_STATE(2331)] = 70067,
  [SMALL_STATE(2332)] = 70075,
  [SMALL_STATE(2333)] = 70083,
  [SMALL_STATE(2334)] = 70091,
  [SMALL_STATE(2335)] = 70099,
  [SMALL_STATE(2336)] = 70107,
  [SMALL_STATE(2337)] = 70115,
  [SMALL_STATE(2338)] = 70123,
  [SMALL_STATE(2339)] = 70131,
  [SMALL_STATE(2340)] = 70139,
  [SMALL_STATE(2341)] = 70147,
  [SMALL_STATE(2342)] = 70155,
  [SMALL_STATE(2343)] = 70163,
  [SMALL_STATE(2344)] = 70171,
  [SMALL_STATE(2345)] = 70179,
  [SMALL_STATE(2346)] = 70187,
  [SMALL_STATE(2347)] = 70195,
  [SMALL_STATE(2348)] = 70203,
  [SMALL_STATE(2349)] = 70211,
  [SMALL_STATE(2350)] = 70219,
  [SMALL_STATE(2351)] = 70227,
  [SMALL_STATE(2352)] = 70235,
  [SMALL_STATE(2353)] = 70243,
  [SMALL_STATE(2354)] = 70251,
  [SMALL_STATE(2355)] = 70259,
  [SMALL_STATE(2356)] = 70267,
  [SMALL_STATE(2357)] = 70275,
  [SMALL_STATE(2358)] = 70283,
  [SMALL_STATE(2359)] = 70291,
  [SMALL_STATE(2360)] = 70299,
  [SMALL_STATE(2361)] = 70307,
  [SMALL_STATE(2362)] = 70315,
  [SMALL_STATE(2363)] = 70323,
  [SMALL_STATE(2364)] = 70331,
  [SMALL_STATE(2365)] = 70339,
  [SMALL_STATE(2366)] = 70347,
  [SMALL_STATE(2367)] = 70355,
  [SMALL_STATE(2368)] = 70363,
  [SMALL_STATE(2369)] = 70371,
  [SMALL_STATE(2370)] = 70379,
  [SMALL_STATE(2371)] = 70387,
  [SMALL_STATE(2372)] = 70395,
  [SMALL_STATE(2373)] = 70403,
  [SMALL_STATE(2374)] = 70411,
  [SMALL_STATE(2375)] = 70419,
  [SMALL_STATE(2376)] = 70427,
  [SMALL_STATE(2377)] = 70435,
  [SMALL_STATE(2378)] = 70443,
  [SMALL_STATE(2379)] = 70451,
  [SMALL_STATE(2380)] = 70459,
  [SMALL_STATE(2381)] = 70467,
  [SMALL_STATE(2382)] = 70475,
  [SMALL_STATE(2383)] = 70483,
  [SMALL_STATE(2384)] = 70491,
  [SMALL_STATE(2385)] = 70499,
  [SMALL_STATE(2386)] = 70507,
  [SMALL_STATE(2387)] = 70515,
  [SMALL_STATE(2388)] = 70523,
  [SMALL_STATE(2389)] = 70531,
  [SMALL_STATE(2390)] = 70539,
  [SMALL_STATE(2391)] = 70547,
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0),
  [7] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1059),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [23] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2391),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1415),
  [27] = {.entry = {.count = 1, .reusable = false}}, SHIFT(18),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(741),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2388),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1972),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(671),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(674),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1973),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(106),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2384),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1739),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2371),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2316),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2315),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(88),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1346),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2057),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1179),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1709),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1026),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2297),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(712),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1),
  [117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2),
  [119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1059),
  [122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(410),
  [125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2265),
  [128] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(35),
  [131] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(4),
  [134] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(28),
  [137] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(136),
  [140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1053),
  [143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2391),
  [146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1415),
  [149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(18),
  [152] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1495),
  [155] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(725),
  [158] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(741),
  [161] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2388),
  [164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1972),
  [167] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(671),
  [170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(79),
  [173] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(545),
  [176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(674),
  [179] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1973),
  [182] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(106),
  [185] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2384),
  [188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1248),
  [191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(19),
  [194] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1739),
  [197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2371),
  [200] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2316),
  [203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2315),
  [206] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1085),
  [209] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1387),
  [212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1214),
  [215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(88),
  [218] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2050),
  [221] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1346),
  [224] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(548),
  [227] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2301),
  [230] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(84),
  [233] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(17),
  [236] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(522),
  [239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2057),
  [242] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1179),
  [245] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1709),
  [248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1029),
  [251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1026),
  [254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(2297),
  [257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1261),
  [260] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2), SHIFT_REPEAT(1026),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(706),
  [293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_expression, 2),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1807),
  [299] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_expression, 2),
  [301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1779),
  [303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(681),
  [307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2144),
  [311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(131),
  [313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2082),
  [315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 2),
  [323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 2),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 1),
  [329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 1),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_expression, 1),
  [335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_expression, 1),
  [337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2212),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_expression, 1),
  [343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_expression, 1),
  [345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(548),
  [347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(17),
  [351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1066),
  [357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1167),
  [359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(129),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2137),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1163),
  [373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2209),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [379] = {.entry = {.count = 1, .reusable = false}}, SHIFT(82),
  [381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(24),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1196),
  [387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [389] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_let_expression, 6, .production_id = 139),
  [391] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_let_expression, 6, .production_id = 139),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1583),
  [395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 3, .production_id = 17),
  [397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 3, .production_id = 17),
  [399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3),
  [401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3),
  [403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2278),
  [407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [417] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 4),
  [419] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 4),
  [421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2377),
  [425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2),
  [429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2),
  [431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 5, .production_id = 129),
  [433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 5, .production_id = 129),
  [435] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 4, .production_id = 57),
  [437] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 4, .production_id = 57),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_tree, 2),
  [445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_tree, 2),
  [447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_async_block, 3),
  [449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_async_block, 3),
  [451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_let_expression, 6, .production_id = 163),
  [453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_let_expression, 6, .production_id = 163),
  [455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_invocation, 3, .production_id = 33),
  [457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_invocation, 3, .production_id = 33),
  [459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_tree, 3),
  [461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_tree, 3),
  [463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 2),
  [465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 2),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_async_block, 2),
  [473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_async_block, 2),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [477] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_statement, 1),
  [479] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_statement, 1),
  [481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 4),
  [487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 4),
  [489] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1),
  [491] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1),
  [493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_expression, 4, .production_id = 88),
  [495] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop_expression, 4, .production_id = 88),
  [497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_let_expression, 8, .production_id = 224),
  [499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_let_expression, 8, .production_id = 224),
  [501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_let_expression, 7, .production_id = 183),
  [503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_let_expression, 7, .production_id = 183),
  [505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [507] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_expression, 3, .production_id = 30),
  [509] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_expression, 3, .production_id = 30),
  [511] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 3),
  [513] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 3),
  [515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 3, .production_id = 26),
  [517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 3, .production_id = 26),
  [519] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__else_tail, 2, .production_id = 98),
  [521] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__else_tail, 2, .production_id = 98),
  [523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_expression, 2, .production_id = 4),
  [525] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop_expression, 2, .production_id = 4),
  [527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 7, .production_id = 207),
  [529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 7, .production_id = 207),
  [531] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unsafe_block, 2),
  [533] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unsafe_block, 2),
  [535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_expression, 5, .production_id = 97),
  [537] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_expression, 5, .production_id = 97),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1153),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(706),
  [552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(35),
  [555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2),
  [557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(11),
  [560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(28),
  [563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(136),
  [566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(1053),
  [569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(2391),
  [572] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(1779),
  [575] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(18),
  [578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(725),
  [581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(955),
  [584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(681),
  [587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(74),
  [590] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(2144),
  [593] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(131),
  [596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(19),
  [599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(2082),
  [602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(71),
  [605] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(548),
  [608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(2301),
  [611] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(84),
  [614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(17),
  [617] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(522),
  [620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(2057),
  [623] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(1171),
  [626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(1709),
  [629] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(1029),
  [632] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(1026),
  [635] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(2297),
  [638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_expression_repeat1, 2), SHIFT_REPEAT(1026),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [649] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2234),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2121),
  [669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2230),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1077),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2365),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2308),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(682),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1616),
  [689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1067),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1287),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1562),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1770),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(679),
  [717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(680),
  [733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1162),
  [739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(688),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1549),
  [753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(672),
  [757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(684),
  [769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(685),
  [775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(689),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(675),
  [783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(690),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1612),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1521),
  [807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1815),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2172),
  [815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1605),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(819),
  [821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1714),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1177),
  [833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1149),
  [837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1194),
  [841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1190),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1152),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1191),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1821),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(683),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2104),
  [929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2159),
  [933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1195),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1147),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1197),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1170),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1185),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1166),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1203),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1154),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1639),
  [1005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1592),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1628),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1576),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1706),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(687),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1345),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1569),
  [1023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1356),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1427),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2160),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1707),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1761),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1517),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1588),
  [1045] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_loop_label, 2),
  [1047] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_loop_label, 2),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1578),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2193),
  [1055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1361),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(192),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [1063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1572),
  [1065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(198),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [1069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1589),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [1073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1580),
  [1075] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_parameters, 3),
  [1077] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_parameters, 3),
  [1079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1367),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1609),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2054),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2213),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1266),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [1111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(209),
  [1114] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(271),
  [1117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2),
  [1119] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(272),
  [1122] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(258),
  [1125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(2271),
  [1128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(499),
  [1131] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(209),
  [1134] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(1652),
  [1137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(504),
  [1140] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [1142] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_pattern_repeat1, 2), SHIFT_REPEAT(493),
  [1145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2022),
  [1148] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(785),
  [1151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2326),
  [1154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2),
  [1156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2306),
  [1159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1440),
  [1162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1466),
  [1165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2199),
  [1168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2046),
  [1171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(541),
  [1174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(693),
  [1177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2201),
  [1180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1248),
  [1183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1740),
  [1186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2202),
  [1189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2203),
  [1192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2204),
  [1195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2341),
  [1198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1447),
  [1201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1212),
  [1204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2045),
  [1207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1353),
  [1210] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(548),
  [1213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2217),
  [1216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2210),
  [1219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(1250),
  [1222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2210),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [1227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2022),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [1235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2306),
  [1237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [1239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2199),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2046),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [1245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(693),
  [1247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2201),
  [1249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1740),
  [1251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2202),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2203),
  [1255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2204),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2341),
  [1259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1447),
  [1261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1212),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [1265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1353),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2210),
  [1271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [1281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [1283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 3, .production_id = 150),
  [1285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 3, .production_id = 150),
  [1287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 4, .production_id = 110),
  [1289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 4, .production_id = 110),
  [1291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 8, .production_id = 223),
  [1293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 8, .production_id = 223),
  [1295] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_crate_declaration, 7, .production_id = 203),
  [1297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_crate_declaration, 7, .production_id = 203),
  [1299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 4, .production_id = 50),
  [1301] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 4, .production_id = 50),
  [1303] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 4, .production_id = 51),
  [1305] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 4, .production_id = 51),
  [1307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 6, .production_id = 135),
  [1309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 6, .production_id = 135),
  [1311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2271),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(499),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [1329] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [1333] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 6, .production_id = 134),
  [1335] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 6, .production_id = 134),
  [1337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, .production_id = 92),
  [1339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, .production_id = 92),
  [1341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 6, .production_id = 133),
  [1343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 6, .production_id = 133),
  [1345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, .production_id = 49),
  [1347] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, .production_id = 49),
  [1349] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, .production_id = 14),
  [1351] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, .production_id = 14),
  [1353] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 7, .production_id = 5),
  [1355] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 7, .production_id = 5),
  [1357] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_item, 7, .production_id = 176),
  [1359] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_item, 7, .production_id = 176),
  [1361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 6, .production_id = 93),
  [1363] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 6, .production_id = 93),
  [1365] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 3, .production_id = 14),
  [1367] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 3, .production_id = 14),
  [1369] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, .production_id = 143),
  [1371] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, .production_id = 143),
  [1373] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 5),
  [1375] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 5),
  [1377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(292),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [1383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 3),
  [1385] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 3),
  [1387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, .production_id = 92),
  [1389] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, .production_id = 92),
  [1391] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, .production_id = 144),
  [1393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, .production_id = 144),
  [1395] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, .production_id = 113),
  [1397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, .production_id = 113),
  [1399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression_statement, 2),
  [1401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression_statement, 2),
  [1403] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 5, .production_id = 114),
  [1405] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 5, .production_id = 114),
  [1407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 5, .production_id = 92),
  [1409] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 5, .production_id = 92),
  [1411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, .production_id = 141),
  [1413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, .production_id = 141),
  [1415] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 4),
  [1417] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 4),
  [1419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, .production_id = 147),
  [1421] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, .production_id = 147),
  [1423] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 6, .production_id = 148),
  [1425] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 6, .production_id = 148),
  [1427] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 4, .production_id = 64),
  [1429] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 4, .production_id = 64),
  [1431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(288),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [1435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(291),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [1439] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 4, .production_id = 49),
  [1441] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 4, .production_id = 49),
  [1443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, .production_id = 115),
  [1445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, .production_id = 115),
  [1447] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, .production_id = 179),
  [1449] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, .production_id = 179),
  [1451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 6, .production_id = 174),
  [1453] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 6, .production_id = 174),
  [1455] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_mod_item, 2, .production_id = 4),
  [1457] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreign_mod_item, 2, .production_id = 4),
  [1459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_mod_item, 2),
  [1461] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreign_mod_item, 2),
  [1463] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 4, .production_id = 48),
  [1465] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 4, .production_id = 48),
  [1467] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 5, .production_id = 90),
  [1469] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 5, .production_id = 90),
  [1471] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, .production_id = 180),
  [1473] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, .production_id = 180),
  [1475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, .production_id = 134),
  [1477] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, .production_id = 134),
  [1479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 4, .production_id = 65),
  [1481] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 4, .production_id = 65),
  [1483] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 4, .production_id = 68),
  [1485] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 4, .production_id = 68),
  [1487] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, .production_id = 116),
  [1489] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, .production_id = 116),
  [1491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 6, .production_id = 149),
  [1493] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 6, .production_id = 149),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(506),
  [1497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, .production_id = 181),
  [1499] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, .production_id = 181),
  [1501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 2),
  [1503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 2),
  [1505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, .production_id = 14),
  [1507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, .production_id = 14),
  [1509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, .production_id = 117),
  [1511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, .production_id = 117),
  [1513] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, .production_id = 118),
  [1515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, .production_id = 118),
  [1517] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 6, .production_id = 173),
  [1519] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 6, .production_id = 173),
  [1521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, .production_id = 119),
  [1523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, .production_id = 119),
  [1525] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, .production_id = 48),
  [1527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, .production_id = 48),
  [1529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, .production_id = 172),
  [1531] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, .production_id = 172),
  [1533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, .production_id = 171),
  [1535] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, .production_id = 171),
  [1537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, .production_id = 170),
  [1539] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, .production_id = 170),
  [1541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 6, .production_id = 161),
  [1543] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 6, .production_id = 161),
  [1545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 6, .production_id = 5),
  [1547] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 6, .production_id = 5),
  [1549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 5, .production_id = 110),
  [1551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 5, .production_id = 110),
  [1553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, .production_id = 69),
  [1555] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, .production_id = 69),
  [1557] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 5, .production_id = 109),
  [1559] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 5, .production_id = 109),
  [1561] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 184),
  [1563] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 184),
  [1565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 185),
  [1567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 185),
  [1569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 7, .production_id = 187),
  [1571] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 7, .production_id = 187),
  [1573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 6, .production_id = 169),
  [1575] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 6, .production_id = 169),
  [1577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, .production_id = 49),
  [1579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, .production_id = 49),
  [1581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, .production_id = 107),
  [1583] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, .production_id = 107),
  [1585] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 7, .production_id = 188),
  [1587] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 7, .production_id = 188),
  [1589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 4, .production_id = 48),
  [1591] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 4, .production_id = 48),
  [1593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, .production_id = 105),
  [1595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, .production_id = 105),
  [1597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 7, .production_id = 176),
  [1599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 7, .production_id = 176),
  [1601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 4, .production_id = 70),
  [1603] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 4, .production_id = 70),
  [1605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 5, .production_id = 103),
  [1607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 5, .production_id = 103),
  [1609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 2),
  [1611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 2),
  [1613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 4, .production_id = 49),
  [1615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 4, .production_id = 49),
  [1617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 5),
  [1619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 5),
  [1621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 191),
  [1623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 191),
  [1625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 192),
  [1627] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 192),
  [1629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 3, .production_id = 23),
  [1631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 3, .production_id = 23),
  [1633] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 193),
  [1635] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 193),
  [1637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 7, .production_id = 194),
  [1639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 7, .production_id = 194),
  [1641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 7, .production_id = 195),
  [1643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 7, .production_id = 195),
  [1645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 4, .production_id = 71),
  [1647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 4, .production_id = 71),
  [1649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, .production_id = 166),
  [1651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, .production_id = 166),
  [1653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, .production_id = 196),
  [1655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, .production_id = 196),
  [1657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, .production_id = 197),
  [1659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, .production_id = 197),
  [1661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, .production_id = 198),
  [1663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, .production_id = 198),
  [1665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 3, .production_id = 25),
  [1667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 3, .production_id = 25),
  [1669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 7, .production_id = 119),
  [1671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 7, .production_id = 119),
  [1673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [1675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [1677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [1679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 4, .production_id = 48),
  [1681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 4, .production_id = 48),
  [1683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 4, .production_id = 49),
  [1685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 4, .production_id = 49),
  [1687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod_item, 3, .production_id = 5),
  [1689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod_item, 3, .production_id = 5),
  [1691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod_item, 3, .production_id = 27),
  [1693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod_item, 3, .production_id = 27),
  [1695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 7, .production_id = 199),
  [1697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 7, .production_id = 199),
  [1699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 7, .production_id = 200),
  [1701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 7, .production_id = 200),
  [1703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 7, .production_id = 201),
  [1705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 7, .production_id = 201),
  [1707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 7, .production_id = 202),
  [1709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 7, .production_id = 202),
  [1711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, .production_id = 157),
  [1713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, .production_id = 157),
  [1715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 3, .production_id = 6),
  [1717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 3, .production_id = 6),
  [1719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 4, .production_id = 72),
  [1721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 4, .production_id = 72),
  [1723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, .production_id = 204),
  [1725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, .production_id = 204),
  [1727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 3, .production_id = 14),
  [1729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 3, .production_id = 14),
  [1731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 4, .production_id = 73),
  [1733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 4, .production_id = 73),
  [1735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 6, .production_id = 152),
  [1737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 6, .production_id = 152),
  [1739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, .production_id = 205),
  [1741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, .production_id = 205),
  [1743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_item, 4),
  [1745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_item, 4),
  [1747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 3, .production_id = 14),
  [1749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 3, .production_id = 14),
  [1751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 7, .production_id = 173),
  [1753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 7, .production_id = 173),
  [1755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 7, .production_id = 206),
  [1757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 7, .production_id = 206),
  [1759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_crate_declaration, 4, .production_id = 80),
  [1761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_crate_declaration, 4, .production_id = 80),
  [1763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_associated_type, 3, .production_id = 6),
  [1765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_associated_type, 3, .production_id = 6),
  [1767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 6, .production_id = 161),
  [1769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 6, .production_id = 161),
  [1771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 4, .production_id = 5),
  [1773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 4, .production_id = 5),
  [1775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 6),
  [1777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 6),
  [1779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 3, .production_id = 14),
  [1781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 3, .production_id = 14),
  [1783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 8, .production_id = 179),
  [1785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 8, .production_id = 179),
  [1787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 8, .production_id = 209),
  [1789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 8, .production_id = 209),
  [1791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_declaration, 8, .production_id = 211),
  [1793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_let_declaration, 8, .production_id = 211),
  [1795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 8, .production_id = 212),
  [1797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 8, .production_id = 212),
  [1799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_crate_declaration, 5, .production_id = 128),
  [1801] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_crate_declaration, 5, .production_id = 128),
  [1803] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 6),
  [1805] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 6),
  [1807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, .production_id = 214),
  [1809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, .production_id = 214),
  [1811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 8, .production_id = 215),
  [1813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 8, .production_id = 215),
  [1815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration_list, 4),
  [1817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration_list, 4),
  [1819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 5, .production_id = 95),
  [1821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 5, .production_id = 95),
  [1823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 5, .production_id = 50),
  [1825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 5, .production_id = 50),
  [1827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 8, .production_id = 216),
  [1829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 8, .production_id = 216),
  [1831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 5, .production_id = 94),
  [1833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 5, .production_id = 94),
  [1835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 8, .production_id = 217),
  [1837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 8, .production_id = 217),
  [1839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 5, .production_id = 93),
  [1841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 5, .production_id = 93),
  [1843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 8, .production_id = 197),
  [1845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 8, .production_id = 197),
  [1847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 8, .production_id = 218),
  [1849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 8, .production_id = 218),
  [1851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_item, 8, .production_id = 212),
  [1853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_item, 8, .production_id = 212),
  [1855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_declaration, 3, .production_id = 29),
  [1857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_declaration, 3, .production_id = 29),
  [1859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 8, .production_id = 219),
  [1861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 8, .production_id = 219),
  [1863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 6, .production_id = 49),
  [1865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 6, .production_id = 49),
  [1867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, .production_id = 112),
  [1869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, .production_id = 112),
  [1871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [1873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2273),
  [1875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 8, .production_id = 220),
  [1879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 8, .production_id = 220),
  [1881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(423),
  [1883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [1885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 8, .production_id = 204),
  [1887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 8, .production_id = 204),
  [1889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 5, .production_id = 127),
  [1891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 5, .production_id = 127),
  [1893] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 8, .production_id = 221),
  [1895] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 8, .production_id = 221),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [1899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [1901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 8, .production_id = 222),
  [1903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 8, .production_id = 222),
  [1905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 6, .production_id = 119),
  [1907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 6, .production_id = 119),
  [1909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, .production_id = 155),
  [1911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, .production_id = 155),
  [1913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 5, .production_id = 92),
  [1915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 5, .production_id = 92),
  [1917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 5, .production_id = 119),
  [1919] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 5, .production_id = 119),
  [1921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 5, .production_id = 117),
  [1923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 5, .production_id = 117),
  [1925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 9, .production_id = 225),
  [1927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 9, .production_id = 225),
  [1929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_item, 6, .production_id = 156),
  [1931] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_item, 6, .production_id = 156),
  [1933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 9, .production_id = 216),
  [1935] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 9, .production_id = 216),
  [1937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 9, .production_id = 227),
  [1939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 9, .production_id = 227),
  [1941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 9, .production_id = 228),
  [1943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 9, .production_id = 228),
  [1945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 9, .production_id = 229),
  [1947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 9, .production_id = 229),
  [1949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 9, .production_id = 222),
  [1951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 9, .production_id = 222),
  [1953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 9, .production_id = 230),
  [1955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 9, .production_id = 230),
  [1957] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant_list, 3),
  [1959] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_variant_list, 3),
  [1961] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 6, .production_id = 73),
  [1963] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 6, .production_id = 73),
  [1965] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_item, 5, .production_id = 90),
  [1967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_item, 5, .production_id = 90),
  [1969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [1971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [1973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 6, .production_id = 161),
  [1975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 6, .production_id = 161),
  [1977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_item, 6, .production_id = 152),
  [1979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_const_item, 6, .production_id = 152),
  [1981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inner_attribute_item, 5),
  [1983] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_inner_attribute_item, 5),
  [1985] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 6, .production_id = 168),
  [1987] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 6, .production_id = 168),
  [1989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_static_item, 10, .production_id = 231),
  [1991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_static_item, 10, .production_id = 231),
  [1993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2),
  [1995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2),
  [1997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 10, .production_id = 228),
  [1999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 10, .production_id = 228),
  [2001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 10, .production_id = 232),
  [2003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 10, .production_id = 232),
  [2005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 6, .production_id = 124),
  [2007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 6, .production_id = 124),
  [2009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 6, .production_id = 167),
  [2011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 6, .production_id = 167),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [2015] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 6, .production_id = 166),
  [2017] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 6, .production_id = 166),
  [2019] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_definition, 5, .production_id = 5),
  [2021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_definition, 5, .production_id = 5),
  [2023] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(426),
  [2026] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(481),
  [2029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2),
  [2031] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(479),
  [2034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(451),
  [2037] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(2334),
  [2040] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(510),
  [2043] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(426),
  [2046] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(1652),
  [2049] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_token_tree_repeat1, 2), SHIFT_REPEAT(504),
  [2052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_crate_declaration, 6, .production_id = 164),
  [2054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_crate_declaration, 6, .production_id = 164),
  [2056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_signature_item, 5, .production_id = 124),
  [2058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_signature_item, 5, .production_id = 124),
  [2060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_item, 5, .production_id = 125),
  [2062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_item, 5, .production_id = 125),
  [2064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_mod_item, 3),
  [2066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreign_mod_item, 3),
  [2068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_foreign_mod_item, 3, .production_id = 38),
  [2070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_foreign_mod_item, 3, .production_id = 38),
  [2072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, .production_id = 162),
  [2074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, .production_id = 162),
  [2076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_declaration, 4, .production_id = 86),
  [2078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_declaration, 4, .production_id = 86),
  [2080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_union_item, 4, .production_id = 73),
  [2082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_union_item, 4, .production_id = 73),
  [2084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, .production_id = 73),
  [2086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, .production_id = 73),
  [2088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 4, .production_id = 85),
  [2090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 4, .production_id = 85),
  [2092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 5, .production_id = 117),
  [2094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 5, .production_id = 117),
  [2096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod_item, 4, .production_id = 84),
  [2098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod_item, 4, .production_id = 84),
  [2100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod_item, 4, .production_id = 80),
  [2102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mod_item, 4, .production_id = 80),
  [2104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 5, .production_id = 119),
  [2106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 5, .production_id = 119),
  [2108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, .production_id = 161),
  [2110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, .production_id = 161),
  [2112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_item, 4, .production_id = 73),
  [2114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_item, 4, .production_id = 73),
  [2116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_item, 6, .production_id = 160),
  [2118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_trait_item, 6, .production_id = 160),
  [2120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3),
  [2122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3),
  [2124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, .production_id = 73),
  [2126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, .production_id = 73),
  [2128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, .production_id = 159),
  [2130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, .production_id = 159),
  [2132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, .production_id = 117),
  [2134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, .production_id = 117),
  [2136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, .production_id = 126),
  [2138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, .production_id = 126),
  [2140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_item, 5, .production_id = 119),
  [2142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_item, 5, .production_id = 119),
  [2144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl_item, 6, .production_id = 158),
  [2146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_impl_item, 6, .production_id = 158),
  [2148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(475),
  [2150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [2152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [2154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [2156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [2158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2334),
  [2160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [2162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [2164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(426),
  [2166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [2168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [2170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(458),
  [2172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [2174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [2176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [2178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [2180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [2182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [2184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [2186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [2188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(452),
  [2190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [2192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [2194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [2196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [2198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [2200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [2202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [2204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(463),
  [2206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [2208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [2210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [2212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [2214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [2216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [2218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [2220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [2222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [2224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [2226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [2228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [2230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [2232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [2234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(476),
  [2236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [2238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(459),
  [2240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [2242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [2244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [2246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [2248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(470),
  [2250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [2252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [2254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [2256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [2258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1267),
  [2260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2261),
  [2262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1880),
  [2264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [2266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1786),
  [2268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1786),
  [2270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [2272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [2274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1231),
  [2276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1626),
  [2278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [2280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [2282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [2284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2370),
  [2286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [2288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(1317),
  [2291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(547),
  [2294] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(549),
  [2297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(1267),
  [2300] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(2278),
  [2303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(682),
  [2306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(548),
  [2309] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(2261),
  [2312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(1880),
  [2315] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(686),
  [2318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(687),
  [2321] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(1345),
  [2324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(2103),
  [2327] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(1311),
  [2330] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(1692),
  [2333] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(1287),
  [2336] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(1786),
  [2339] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2), SHIFT_REPEAT(1786),
  [2342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [2344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1585),
  [2346] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__token_pattern, 1),
  [2348] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__token_pattern, 1),
  [2350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [2352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [2354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1577),
  [2356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1598),
  [2358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1595),
  [2360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__token_pattern, 1, .production_id = 2),
  [2362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__token_pattern, 1, .production_id = 2),
  [2364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_binding_pattern, 3, .production_id = 175),
  [2366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_binding_pattern, 3, .production_id = 175),
  [2368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition_pattern, 4),
  [2370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition_pattern, 4),
  [2372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_literal, 1),
  [2374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_literal, 1),
  [2376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2),
  [2378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2),
  [2380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_tree_pattern, 3),
  [2382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_tree_pattern, 3),
  [2384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fragment_specifier, 1),
  [2386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fragment_specifier, 1),
  [2388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_tree_pattern, 2),
  [2390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_tree_pattern, 2),
  [2392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_token_tree_repeat1, 1, .production_id = 2),
  [2394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_token_tree_repeat1, 1, .production_id = 2),
  [2396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition_pattern, 6),
  [2398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition_pattern, 6),
  [2400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition_pattern, 5),
  [2402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition_pattern, 5),
  [2404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition, 6),
  [2406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition, 6),
  [2408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3),
  [2410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3),
  [2412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition, 5),
  [2414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition, 5),
  [2416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_token_repetition, 4),
  [2418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_token_repetition, 4),
  [2420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [2422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1496),
  [2424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1558),
  [2426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [2428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2139),
  [2430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [2432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1641),
  [2434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(544),
  [2436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [2438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1640),
  [2440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [2442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(612),
  [2444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1745),
  [2446] = {.entry = {.count = 1, .reusable = false}}, SHIFT(632),
  [2448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(700),
  [2450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [2452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [2454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [2456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [2458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [2460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2140),
  [2462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [2464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [2466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [2468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [2470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [2472] = {.entry = {.count = 1, .reusable = false}}, SHIFT(634),
  [2474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2304),
  [2476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [2478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(561),
  [2480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1755),
  [2482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2286),
  [2484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1672),
  [2486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1534),
  [2488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [2490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [2492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [2494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(602),
  [2496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [2498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [2500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [2502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1702),
  [2504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2),
  [2506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2),
  [2508] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT_REPEAT(2278),
  [2511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [2513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(601),
  [2515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1024),
  [2517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [2519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [2521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1371),
  [2523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(661),
  [2525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1673),
  [2527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [2529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [2531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1363),
  [2533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1315),
  [2535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [2537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1691),
  [2539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1350),
  [2541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1344),
  [2543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1912),
  [2545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [2547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [2549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1381),
  [2551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1349),
  [2553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [2555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [2557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1380),
  [2559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2081),
  [2561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1990),
  [2563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1845),
  [2565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1924),
  [2567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [2569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2117),
  [2571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1998),
  [2573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1685),
  [2575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(677),
  [2577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2102),
  [2579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1718),
  [2581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2007),
  [2583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2016),
  [2585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2031),
  [2587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2038),
  [2589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [2591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2000),
  [2593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2005),
  [2595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1996),
  [2597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(673),
  [2599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [2601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2023),
  [2603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2157),
  [2605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1989),
  [2607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1762),
  [2609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1684),
  [2611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(694),
  [2613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1671),
  [2615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_parameters, 2),
  [2617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_parameters, 2),
  [2619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_parameters, 4),
  [2621] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_parameters, 4),
  [2623] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_tuple_expression_repeat1, 2),
  [2625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1, .production_id = 3),
  [2627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [2629] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1, .production_id = 3),
  [2631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1680),
  [2633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [2635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [2637] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dynamic_type, 2, .production_id = 19),
  [2639] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic_type, 2, .production_id = 19),
  [2641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_type, 2, .production_id = 19),
  [2643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_type, 2, .production_id = 19),
  [2645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 13),
  [2647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 13),
  [2649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, .production_id = 12),
  [2651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, .production_id = 12),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [2657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 35),
  [2659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 35),
  [2661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, .production_id = 34),
  [2663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, .production_id = 34),
  [2665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 2, .production_id = 6),
  [2667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 2, .production_id = 6),
  [2669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 2, .production_id = 5),
  [2671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 2, .production_id = 5),
  [2673] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_dynamic_type, 2, .production_id = 20),
  [2675] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_dynamic_type, 2, .production_id = 20),
  [2677] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 40),
  [2679] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_type_identifier, 3, .production_id = 40),
  [2681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, .production_id = 39),
  [2683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, .production_id = 39),
  [2685] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [2687] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [2689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_abstract_type, 2, .production_id = 20),
  [2691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_abstract_type, 2, .production_id = 20),
  [2693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier_in_expression_position, 3, .production_id = 35),
  [2695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [2697] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier_in_expression_position, 3, .production_id = 40),
  [2699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier_in_expression_position, 3, .production_id = 13),
  [2701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_expression, 1),
  [2703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_expression, 1),
  [2705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [2707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_type_identifier_in_expression_position, 2, .production_id = 6),
  [2709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_function, 3, .production_id = 36),
  [2711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type_with_turbofish, 3, .production_id = 46),
  [2713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_function, 3, .production_id = 36),
  [2715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, .production_id = 45),
  [2717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, .production_id = 45),
  [2719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_expression, 3, .production_id = 44),
  [2721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_expression, 3, .production_id = 44),
  [2723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, .production_id = 1),
  [2725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, .production_id = 1),
  [2727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_modifiers_repeat1, 1),
  [2729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, .production_id = 106),
  [2731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, .production_id = 106),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [2735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 41),
  [2737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [2739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [2741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 41),
  [2743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1876),
  [2745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 3),
  [2747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 3),
  [2749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [2751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [2755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1, .production_id = 2),
  [2757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1, .production_id = 2),
  [2759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [2761] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 3),
  [2763] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 3),
  [2765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2),
  [2767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2),
  [2769] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type_with_turbofish, 3, .production_id = 37),
  [2771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 4),
  [2773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 4),
  [2775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 15),
  [2777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 15),
  [2779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_type, 2, .production_id = 16),
  [2781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_type, 2, .production_id = 16),
  [2783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_expression, 3, .production_id = 31),
  [2785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_expression, 3, .production_id = 31),
  [2787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 5),
  [2789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 5),
  [2791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 5),
  [2793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 5),
  [2795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 2, .production_id = 18),
  [2797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 18),
  [2799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [2801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 2, .production_id = 22),
  [2803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 22),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [2807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 2, .production_id = 24),
  [2809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 2, .production_id = 24),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [2813] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 6),
  [2815] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 6),
  [2817] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_arguments, 4),
  [2819] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_arguments, 4),
  [2821] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameters, 2),
  [2823] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parameters, 2),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [2827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, .production_id = 67),
  [2829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, .production_id = 67),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [2833] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, .production_id = 66),
  [2835] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, .production_id = 66),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [2839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 3, .production_id = 63),
  [2841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 3, .production_id = 63),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [2845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_expression, 2, .production_id = 7),
  [2847] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_expression, 2, .production_id = 7),
  [2849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 5),
  [2851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 5),
  [2853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(182),
  [2855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [2857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(141),
  [2859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(137),
  [2861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [2863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [2865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(166),
  [2867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(165),
  [2869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [2871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [2873] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_expression, 2, .production_id = 8),
  [2875] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_expression, 2, .production_id = 8),
  [2877] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bounded_type, 3),
  [2879] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bounded_type, 3),
  [2881] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_type, 3, .production_id = 59),
  [2883] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_type, 3, .production_id = 59),
  [2885] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 3, .production_id = 59),
  [2887] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 3, .production_id = 59),
  [2889] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_expression, 2),
  [2891] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_expression, 2),
  [2893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [2895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [2897] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 5),
  [2899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 5),
  [2901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3),
  [2903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 3),
  [2905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_expression, 2, .production_id = 9),
  [2907] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_expression, 2, .production_id = 9),
  [2909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_expression, 2),
  [2911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_expression, 2),
  [2913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_call_expression, 2, .production_id = 10),
  [2915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_call_expression, 2, .production_id = 10),
  [2917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 2, .production_id = 11),
  [2919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [2921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [2923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(142),
  [2925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [2927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 5, .production_id = 122),
  [2929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_expression, 5, .production_id = 122),
  [2931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [2933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [2935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 4),
  [2937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer_list, 4),
  [2939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 3),
  [2941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 3),
  [2943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_expression, 3),
  [2945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_expression, 3),
  [2947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 5),
  [2949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer_list, 5),
  [2951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 7),
  [2953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 7),
  [2955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5),
  [2957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5),
  [2959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 4),
  [2961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 4),
  [2963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 6),
  [2965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 6),
  [2967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 5, .production_id = 140),
  [2969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 5, .production_id = 140),
  [2971] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_type, 2, .production_id = 21),
  [2973] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_type, 2, .production_id = 21),
  [2975] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 6, .production_id = 186),
  [2977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 6, .production_id = 186),
  [2979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lifetime, 2),
  [2981] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lifetime, 2),
  [2983] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unit_type, 2),
  [2985] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unit_type, 2),
  [2987] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 3, .production_id = 32),
  [2989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 2),
  [2991] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer_list, 2),
  [2993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 3, .production_id = 58),
  [2995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 3, .production_id = 58),
  [2997] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_expression, 2),
  [2999] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_expression, 2),
  [3001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 5, .production_id = 89),
  [3003] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 5, .production_id = 89),
  [3005] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 4),
  [3007] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 4),
  [3009] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 5),
  [3011] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 5),
  [3013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_closure_expression, 4, .production_id = 87),
  [3015] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_closure_expression, 4, .production_id = 87),
  [3017] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index_expression, 4),
  [3019] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index_expression, 4),
  [3021] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 4),
  [3023] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 4),
  [3025] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 2),
  [3027] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 2),
  [3029] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 3),
  [3031] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 3),
  [3033] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arguments, 2),
  [3035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arguments, 2),
  [3037] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unit_expression, 2),
  [3039] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unit_expression, 2),
  [3041] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_type, 1),
  [3043] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_type, 1),
  [3045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4),
  [3047] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 4),
  [3049] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, .production_id = 99),
  [3051] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, .production_id = 99),
  [3053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2386),
  [3055] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_type, 4, .production_id = 102),
  [3057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_type, 4, .production_id = 102),
  [3059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 6),
  [3061] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 6),
  [3063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 6, .production_id = 130),
  [3065] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 6, .production_id = 130),
  [3067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_expression, 6),
  [3069] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_expression, 6),
  [3071] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, .production_id = 104),
  [3073] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, .production_id = 104),
  [3075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_cast_expression, 3, .production_id = 42),
  [3077] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_cast_expression, 3, .production_id = 42),
  [3079] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 43),
  [3081] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 43),
  [3083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 4, .production_id = 108),
  [3085] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 4, .production_id = 108),
  [3087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 3),
  [3089] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 3),
  [3091] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compound_assignment_expr, 3, .production_id = 41),
  [3093] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_compound_assignment_expr, 3, .production_id = 41),
  [3095] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 3),
  [3097] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 3),
  [3099] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer_list, 3),
  [3101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_initializer_list, 3),
  [3103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 5, .production_id = 146),
  [3105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 5, .production_id = 146),
  [3107] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 5, .production_id = 145),
  [3109] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 5, .production_id = 145),
  [3111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_type, 5, .production_id = 142),
  [3113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_type, 5, .production_id = 142),
  [3115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [3117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3, .production_id = 60),
  [3119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3, .production_id = 60),
  [3121] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat1, 2), SHIFT_REPEAT(2331),
  [3124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4, .production_id = 60),
  [3126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4, .production_id = 60),
  [3128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 4),
  [3130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 4),
  [3132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 3),
  [3134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 3),
  [3136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1645),
  [3138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5, .production_id = 60),
  [3140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5, .production_id = 60),
  [3142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_parameters, 5),
  [3144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameters, 5),
  [3146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1618),
  [3148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 4),
  [3150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [3152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [3154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [3156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2105),
  [3158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [3160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [3162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 3),
  [3164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [3168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [3170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [3172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [3174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [3176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2353),
  [3178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 4, .production_id = 150),
  [3180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 4, .production_id = 150),
  [3182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 4, .production_id = 150),
  [3184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(702),
  [3186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2232),
  [3188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [3190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(701),
  [3192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 5, .production_id = 110),
  [3194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 5, .production_id = 110),
  [3196] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 5, .production_id = 110),
  [3198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [3200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [3202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [3204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [3206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [3208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(116),
  [3210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [3212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(113),
  [3214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(111),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [3218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(23),
  [3220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [3222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [3224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [3226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(93),
  [3228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [3230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [3232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [3234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [3236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [3238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1506),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [3242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1859),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [3246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 3, .production_id = 123),
  [3248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 5, .production_id = 208),
  [3250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_initializer, 4, .production_id = 165),
  [3252] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 3, .production_id = 131),
  [3254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1485),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [3258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1467),
  [3260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [3262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [3264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1502),
  [3266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [3268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 3),
  [3270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [3272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [3274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [3276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [3278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [3280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [3282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [3284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [3286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 4, .production_id = 110),
  [3288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [3290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 3, .production_id = 150),
  [3292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [3294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 4, .production_id = 177),
  [3296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_field_initializer, 2),
  [3298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [3300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_expression_repeat1, 2),
  [3302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 4, .production_id = 178),
  [3304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2),
  [3306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [3308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility_modifier, 5, .production_id = 111),
  [3310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility_modifier, 5, .production_id = 111),
  [3312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1333),
  [3314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [3316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1358),
  [3318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1335),
  [3320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [3322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility_modifier, 1),
  [3324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1696),
  [3326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility_modifier, 1),
  [3328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [3330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility_modifier, 5),
  [3332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility_modifier, 5),
  [3334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [3336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [3338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1329),
  [3340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1334),
  [3342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [3344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1324),
  [3346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [3348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [3350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [3352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [3354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [3356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [3358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [3360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [3362] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_visibility_modifier, 4),
  [3364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_visibility_modifier, 4),
  [3366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [3368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [3370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_pattern, 3, .production_id = 151),
  [3372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [3374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [3376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(757),
  [3378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [3380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1922),
  [3382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [3384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [3386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [3388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [3390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [3392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [3394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [3396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [3398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [3404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [3406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(883),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [3410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [3414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1564),
  [3416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1970),
  [3418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1600),
  [3420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2094),
  [3422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1607),
  [3424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [3426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [3428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [3430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1604),
  [3432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [3434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [3436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1608),
  [3438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [3440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1723),
  [3442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1868),
  [3444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_lifetimes, 5),
  [3446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_lifetimes, 5),
  [3448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_lifetimes, 6),
  [3450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_lifetimes, 6),
  [3452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_lifetimes, 4),
  [3454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_lifetimes, 4),
  [3456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2009),
  [3458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [3460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2028),
  [3462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [3464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1994),
  [3466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1997),
  [3468] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1993),
  [3470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1993),
  [3472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1),
  [3474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [3476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [3478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern, 1),
  [3480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1769),
  [3482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [3484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [3486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [3488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [3490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [3492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [3494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [3496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [3498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [3500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [3502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [3504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [3506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [3508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [3510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2380),
  [3512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [3514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [3516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1211),
  [3518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1357),
  [3520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1491),
  [3522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [3524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [3526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [3528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1925),
  [3530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [3532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2182),
  [3534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [3536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [3538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [3540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [3542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [3544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [3546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [3548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [3550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [3552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [3554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [3556] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type, 1, .production_id = 3), REDUCE(sym__pattern, 1),
  [3559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [3561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [3563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [3565] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1, .production_id = 1),
  [3567] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern, 1, .production_id = 1),
  [3569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [3571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [3573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [3575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2249),
  [3577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [3579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [3581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [3583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [3585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [3587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [3589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1403),
  [3591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [3593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [3595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [3597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [3599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [3601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [3603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_negative_literal, 2),
  [3605] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_negative_literal, 2),
  [3607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 3),
  [3609] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_pattern, 3),
  [3611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [3613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1680),
  [3615] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, .production_id = 39), REDUCE(sym_scoped_type_identifier, 3, .production_id = 40),
  [3618] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_scoped_identifier, 2, .production_id = 5), REDUCE(sym_scoped_type_identifier, 2, .production_id = 6),
  [3621] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, .production_id = 12), REDUCE(sym_scoped_type_identifier, 3, .production_id = 13),
  [3624] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, .production_id = 34), REDUCE(sym_scoped_type_identifier, 3, .production_id = 35),
  [3627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [3629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 3, .production_id = 52),
  [3631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_pattern, 3, .production_id = 52),
  [3633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [3635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 3, .production_id = 1),
  [3637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_pattern, 3, .production_id = 1),
  [3639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_pattern, 3, .production_id = 56),
  [3641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_pattern, 3, .production_id = 56),
  [3643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 4, .production_id = 54),
  [3645] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_pattern, 4, .production_id = 54),
  [3647] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 3, .production_id = 53),
  [3649] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_pattern, 3, .production_id = 53),
  [3651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_pattern, 2),
  [3653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_pattern, 2),
  [3655] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 5, .production_id = 54),
  [3657] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_pattern, 5, .production_id = 54),
  [3659] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 4, .production_id = 53),
  [3661] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_struct_pattern, 4, .production_id = 53),
  [3663] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_pattern, 3),
  [3665] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_pattern, 3),
  [3667] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 6, .production_id = 54),
  [3669] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_pattern, 6, .production_id = 54),
  [3671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_pattern, 4),
  [3673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_pattern, 4),
  [3675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_remaining_field_pattern, 1),
  [3677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_remaining_field_pattern, 1),
  [3679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_modifier, 1),
  [3681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2259),
  [3683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 5, .production_id = 53),
  [3685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_pattern, 5, .production_id = 53),
  [3687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_pattern, 5),
  [3689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_pattern, 5),
  [3691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 4),
  [3693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_pattern, 4),
  [3695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 5),
  [3697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_pattern, 5),
  [3699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_pattern, 3),
  [3701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_pattern, 3),
  [3703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [3705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 6, .production_id = 53),
  [3707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_struct_pattern, 6, .production_id = 53),
  [3709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 6, .production_id = 53),
  [3711] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_pattern, 6, .production_id = 53),
  [3713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_slice_pattern, 2),
  [3715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_slice_pattern, 2),
  [3717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2246),
  [3719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3),
  [3721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_pattern, 3),
  [3723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [3725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reference_pattern, 2),
  [3727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_reference_pattern, 2),
  [3729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 5, .production_id = 53),
  [3731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_struct_pattern, 5, .production_id = 53),
  [3733] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 2),
  [3735] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_pattern, 2),
  [3737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 4, .production_id = 53),
  [3739] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_pattern, 4, .production_id = 53),
  [3741] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_pattern, 3, .production_id = 54),
  [3743] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_pattern, 3, .production_id = 54),
  [3745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_struct_pattern, 3, .production_id = 53),
  [3747] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_struct_pattern, 3, .production_id = 53),
  [3749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_or_pattern, 3),
  [3751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_or_pattern, 3),
  [3753] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_captured_pattern, 3),
  [3755] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_captured_pattern, 3),
  [3757] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mut_pattern, 2),
  [3759] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_mut_pattern, 2),
  [3761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2356),
  [3763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(290),
  [3765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [3767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2296),
  [3769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [3771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [3773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [3775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2298),
  [3777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [3779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [3781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [3783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2339),
  [3785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(321),
  [3787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [3789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [3791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [3793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [3795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [3797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1430),
  [3799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [3801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [3803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [3805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [3807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1851),
  [3809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [3811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [3813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [3815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [3817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [3819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1602),
  [3821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2247),
  [3823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1747),
  [3825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [3827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [3829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [3831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [3833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [3835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [3837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [3839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [3841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [3843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [3845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [3847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [3849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [3851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [3853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1376),
  [3855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [3857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [3859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [3861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [3863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [3865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [3867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [3869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [3871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [3873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [3875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [3877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [3879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1754),
  [3881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [3883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [3885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [3887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [3889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [3891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [3893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2096),
  [3895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [3897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [3899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [3901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [3903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [3905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_trait_bounds_repeat1, 2),
  [3907] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_trait_bounds_repeat1, 2), SHIFT_REPEAT(521),
  [3910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1744),
  [3912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1365),
  [3914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [3916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2035),
  [3918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2343),
  [3920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [3922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [3924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [3926] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_modifier, 2),
  [3928] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type, 1, .production_id = 2), REDUCE(sym__pattern, 1, .production_id = 1),
  [3931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [3933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [3935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [3937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [3939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [3941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [3943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [3945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [3947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1541),
  [3949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1877),
  [3951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [3953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_modifiers, 1),
  [3955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [3957] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_definition_repeat1, 2), SHIFT_REPEAT(392),
  [3960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_macro_definition_repeat1, 2),
  [3962] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_definition_repeat1, 2), SHIFT_REPEAT(388),
  [3965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_definition_repeat1, 2), SHIFT_REPEAT(386),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [3970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [3972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [3974] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_modifiers_repeat1, 2), SHIFT_REPEAT(1453),
  [3977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_modifiers_repeat1, 2),
  [3979] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_modifiers_repeat1, 2), SHIFT_REPEAT(1460),
  [3982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_bounds, 3),
  [3984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [3986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [3988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [3990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1822),
  [3992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [3994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [3996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait_bounds, 2),
  [3998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [4000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [4002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [4004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_function_modifiers_repeat1, 1),
  [4006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [4008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_item, 1, .production_id = 1),
  [4010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1383),
  [4012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(931),
  [4014] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 1, .production_id = 47),
  [4016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [4018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [4020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_item, 1),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1384),
  [4024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [4026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1355),
  [4028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [4030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [4032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [4034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [4036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_higher_ranked_trait_bound, 3, .production_id = 132),
  [4038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [4042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [4044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2368),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1348),
  [4048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [4050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [4054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [4056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2352),
  [4058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 2, .production_id = 5),
  [4060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [4062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [4064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2354),
  [4066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [4068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [4070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2266),
  [4072] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2244),
  [4074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1340),
  [4076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [4078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [4080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [4082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_removed_trait_bound, 2),
  [4084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [4086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(448),
  [4088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1374),
  [4090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [4094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [4096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [4098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [4100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameters, 2), REDUCE(sym_tuple_struct_pattern, 3, .production_id = 53),
  [4103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [4105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [4107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [4109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [4111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [4113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [4115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2197),
  [4117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [4119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [4121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [4123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_parameter, 1),
  [4125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(566),
  [4127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [4129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [4131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [4133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(935),
  [4135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [4137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(893),
  [4139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(878),
  [4141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [4143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [4145] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameters, 3), REDUCE(sym_tuple_struct_pattern, 4, .production_id = 53),
  [4148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [4150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [4152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [4154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [4156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_parameter, 2),
  [4158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(557),
  [4160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2311),
  [4162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [4164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [4166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [4168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [4170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [4172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1165),
  [4174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(767),
  [4176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [4178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [4180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [4182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [4184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [4186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [4188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [4190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [4192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [4194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [4196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [4198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [4200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [4202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2190),
  [4204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [4206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [4208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [4210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [4212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [4214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_unit_type, 2), REDUCE(sym_tuple_pattern, 2),
  [4217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_parameter, 3),
  [4219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [4221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [4223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [4225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [4227] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 7, .production_id = 226),
  [4229] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 3),
  [4231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [4233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 4, .production_id = 59),
  [4235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 4, .production_id = 21),
  [4237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [4239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 6, .production_id = 102),
  [4241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 6, .production_id = 213),
  [4243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2, .production_id = 60),
  [4245] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__use_clause, 1, .production_id = 1),
  [4247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [4249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1693),
  [4251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [4253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [4255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1408),
  [4257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [4259] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__use_clause, 1),
  [4261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2189),
  [4263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [4265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [4267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [4269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [4271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [4273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [4275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [4277] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__pattern, 1), SHIFT(1274),
  [4280] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__pattern, 1), SHIFT(139),
  [4283] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 5, .production_id = 102),
  [4285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 5, .production_id = 189),
  [4287] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 5, .production_id = 59),
  [4289] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 2),
  [4291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ordered_field_declaration_list, 3, .production_id = 21),
  [4293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [4295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [4297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1584),
  [4299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [4301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 3),
  [4303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [4305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [4307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [4309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [4311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, .production_id = 82),
  [4313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(464),
  [4315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [4317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [4319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1850),
  [4321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [4323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 2),
  [4325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [4327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [4329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [4331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(515),
  [4333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [4335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [4337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [4339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [4341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [4343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [4345] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, .production_id = 109),
  [4347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1827),
  [4349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [4351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [4353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [4355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [4357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1756),
  [4359] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, .production_id = 121),
  [4361] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2),
  [4363] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(1670),
  [4366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [4368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [4370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [4372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [4374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1909),
  [4376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [4378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [4380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [4382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [4384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [4386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(461),
  [4388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [4390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [4392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1803),
  [4394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [4396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1226),
  [4398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [4400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [4402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [4404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [4406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [4408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [4410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [4412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [4414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [4416] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), REDUCE(aux_sym_for_lifetimes_repeat1, 2),
  [4419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2),
  [4421] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2), SHIFT_REPEAT(676),
  [4424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [4426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [4428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [4430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [4432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [4434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2288),
  [4436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [4438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [4440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [4442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [4444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1352),
  [4446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [4448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [4450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [4452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [4454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [4456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2),
  [4458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [4460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [4462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, .production_id = 83),
  [4464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [4466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [4468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [4470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2),
  [4472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2), SHIFT_REPEAT(1135),
  [4475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 5),
  [4477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [4479] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_as_clause, 3, .production_id = 74),
  [4481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat2, 2),
  [4483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat2, 2), SHIFT_REPEAT(1431),
  [4486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_as_clause, 3, .production_id = 76),
  [4488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 3, .production_id = 27),
  [4490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [4492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_wildcard, 3),
  [4494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [4496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2346),
  [4498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1975),
  [4500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2382),
  [4502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_item, 2, .production_id = 78),
  [4504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_item, 2, .production_id = 79),
  [4506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_wildcard, 3, .production_id = 1),
  [4508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [4510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2184),
  [4512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2143),
  [4514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2186),
  [4516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2337),
  [4518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1984),
  [4520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2376),
  [4522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [4524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1497),
  [4526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1777),
  [4528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [4530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 1, .production_id = 55),
  [4532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [4534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_closure_parameters_repeat1, 2),
  [4536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [4538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_closure_parameters_repeat1, 2), SHIFT_REPEAT(527),
  [4541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [4543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1294),
  [4545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [4547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameters_repeat1, 2), SHIFT_REPEAT(183),
  [4550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shorthand_field_initializer, 2),
  [4552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [4554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [4556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [4558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [4560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 3, .production_id = 136),
  [4562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [4564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 3, .production_id = 137),
  [4566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_struct_pattern_repeat1, 2),
  [4568] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_struct_pattern_repeat1, 2), SHIFT_REPEAT(1552),
  [4571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_binding, 3, .production_id = 138),
  [4573] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2),
  [4575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [4577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [4579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [4581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [4583] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_arguments_repeat1, 2), SHIFT_REPEAT(210),
  [4586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [4588] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_lifetimes_repeat1, 2), SHIFT_REPEAT(2011),
  [4591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_lifetimes_repeat1, 2),
  [4593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_const_parameter, 4, .production_id = 90),
  [4595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [4597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 3),
  [4599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [4601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [4603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [4605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1483),
  [4607] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_rule, 3, .production_id = 43),
  [4609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [4611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [4613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [4615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [4617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1887),
  [4619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [4621] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_arguments_repeat1, 2), SHIFT_REPEAT(64),
  [4624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [4626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [4628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 2, .production_id = 21),
  [4630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 2, .production_id = 153),
  [4632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 2, .production_id = 153), SHIFT_REPEAT(500),
  [4635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_variant, 2, .production_id = 9),
  [4637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [4639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1413),
  [4641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [4643] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3, .production_id = 154),
  [4645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2),
  [4647] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 2), SHIFT_REPEAT(1443),
  [4650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_predicate, 2, .production_id = 91),
  [4652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_predicate, 2, .production_id = 61),
  [4654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [4656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(511),
  [4658] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_predicate, 2, .production_id = 62),
  [4660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_use_list, 3, .production_id = 75),
  [4662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [4664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [4666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [4668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [4670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 2),
  [4672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constrained_type_parameter, 2, .production_id = 61),
  [4674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [4676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1404),
  [4678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [4680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [4682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [4684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [4686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constrained_type_parameter, 2, .production_id = 62),
  [4688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [4690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [4692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [4694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [4696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [4698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [4700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [4702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2215),
  [4704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [4706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_arguments, 3),
  [4708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_arguments, 5),
  [4710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_use_list, 2, .production_id = 28),
  [4712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [4714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [4716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [4718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [4720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [4722] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2),
  [4724] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_field_initializer_list_repeat1, 2), SHIFT_REPEAT(1449),
  [4727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [4729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 4, .production_id = 102),
  [4731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [4733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [4735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 5, .production_id = 210),
  [4737] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 2, .production_id = 96),
  [4739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [4741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [4743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_wildcard, 1),
  [4745] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_item, 3, .production_id = 31),
  [4747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [4749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_item, 3, .production_id = 120),
  [4751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1829),
  [4753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1172),
  [4755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [4757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [4759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [4761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [4763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1393),
  [4765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [4767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2),
  [4769] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_use_list_repeat1, 2), SHIFT_REPEAT(1213),
  [4772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [4774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [4776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1995),
  [4778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [4780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1474),
  [4782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [4784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2),
  [4786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [4788] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2), SHIFT_REPEAT(636),
  [4791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_list, 4),
  [4793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [4795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(905),
  [4797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [4799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [4801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [4803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [4805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [4807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1047),
  [4809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [4811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [4813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [4815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_pattern, 1),
  [4817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [4819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [4821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [4823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [4825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(881),
  [4827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [4829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1391),
  [4831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [4833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [4835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_use_list, 3, .production_id = 77),
  [4837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1772),
  [4839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [4841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [4843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [4845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [4847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [4849] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter, 3, .production_id = 100),
  [4851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1398),
  [4853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_shorthand_field_initializer, 1),
  [4855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [4857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [4859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [4861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [4863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [4865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [4867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [4869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [4871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [4873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [4875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(828),
  [4877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [4879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_meta_arguments_repeat1, 2),
  [4881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_meta_arguments_repeat1, 2), SHIFT_REPEAT(1207),
  [4884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [4886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_self_parameter, 4),
  [4888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1394),
  [4890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [4892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [4894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [4896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [4898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [4900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [4902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [4904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [4906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [4908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [4910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(793),
  [4912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [4914] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_arguments, 4),
  [4916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [4918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [4920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_pattern, 4, .production_id = 182),
  [4922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2292),
  [4924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2001),
  [4926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2293),
  [4928] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_expression_repeat1, 2), SHIFT_REPEAT(130),
  [4931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [4933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [4935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [4937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [4939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [4941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [4943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [4945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [4947] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(1448),
  [4950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [4952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [4954] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [4956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [4958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [4960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4, .production_id = 190),
  [4962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1411),
  [4964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_meta_arguments, 2),
  [4966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [4968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [4970] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [4972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [4974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [4976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_optional_type_parameter, 3, .production_id = 101),
  [4978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [4980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1414),
  [4982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [4984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [4986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [4988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [4990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [4992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [4994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(745),
  [4996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_ordered_field_declaration_list_repeat1, 3, .production_id = 59),
  [4998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [5000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [5002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [5004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [5006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_field_declaration_list_repeat1, 3),
  [5008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [5010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [5012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2355),
  [5014] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2385),
  [5016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1712),
  [5018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(928),
  [5020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [5022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_type, 3, .production_id = 81),
  [5024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [5026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [5028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1575),
  [5030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(917),
  [5032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [5034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [5036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1144),
  [5038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [5040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [5042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2358),
  [5044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2310),
  [5046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [5048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [5050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [5052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1701),
  [5054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [5056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [5058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [5060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [5062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [5064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [5066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1846),
  [5068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2177),
  [5070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [5072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [5074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [5076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2338),
  [5078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [5080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1225),
  [5082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [5084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [5086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [5088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [5090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [5092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [5094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_variant_list_repeat2, 3),
  [5096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [5098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [5100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [5102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [5104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [5106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [5108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [5110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [5112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [5114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [5116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2161),
  [5118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [5120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [5122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [5124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [5126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [5128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [5130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [5132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [5134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [5136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1475),
  [5138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [5140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variadic_parameter, 1),
  [5142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [5144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [5146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [5148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [5150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [5152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [5154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [5156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [5158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [5160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [5162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [5164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1548),
  [5166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [5168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [5170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [5172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [5174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [5176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [5178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [5180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [5182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1457),
  [5184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [5186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [5188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [5190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [5192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [5194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1727),
  [5196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [5198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [5200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [5202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [5204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [5206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [5208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [5210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [5212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [5214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1395),
  [5216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1435),
  [5218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1507),
  [5220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [5222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1725),
  [5224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1970),
  [5226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [5228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [5230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [5232] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2262),
  [5234] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [5236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [5238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1463),
  [5240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [5242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [5244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [5246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [5248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [5250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [5252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [5254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [5256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [5258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [5260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1254),
  [5262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2003),
  [5264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [5266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [5268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [5270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [5272] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [5274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [5276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [5278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [5280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [5282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [5284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [5286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [5288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [5290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [5292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(709),
  [5294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2083),
  [5296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [5298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1236),
  [5300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1233),
  [5302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [5304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [5306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [5308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [5310] = {.entry = {.count = 1, .reusable = true}}, SHIFT(723),
  [5312] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2342),
  [5314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [5316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [5318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [5320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [5322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1222),
  [5324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [5326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [5328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_type, 3),
  [5330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1860),
  [5332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [5334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [5336] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [5338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [5340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1160),
  [5342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [5344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(910),
  [5346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [5348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2358),
  [5350] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [5352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [5354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [5356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [5358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1983),
  [5360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [5362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [5364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [5366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2205),
  [5368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [5370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [5372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [5374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [5376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1441),
  [5378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [5380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [5382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [5384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [5386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [5388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [5390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1965),
  [5392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [5394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [5396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [5398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [5400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [5402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(468),
  [5404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [5406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [5408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1220),
  [5410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [5412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [5414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [5416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1846),
  [5418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [5420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [5422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [5424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [5426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [5428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [5430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [5432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [5436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [5438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [5440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [5442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [5444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [5446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [5448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [5450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [5452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1219),
  [5454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [5456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [5458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [5460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [5462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [5464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(746),
  [5466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2346),
  [5468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [5470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [5472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [5474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [5476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [5478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [5480] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [5482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1516),
  [5484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(800),
  [5486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [5488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_rust_external_scanner_create(void);
void tree_sitter_rust_external_scanner_destroy(void *);
bool tree_sitter_rust_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_rust_external_scanner_serialize(void *, char *);
void tree_sitter_rust_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_rust(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .small_parse_table = (const uint16_t *)ts_small_parse_table,
    .small_parse_table_map = (const uint32_t *)ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .public_symbol_map = ts_symbol_map,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .field_names = ts_field_names,
    .field_map_slices = (const TSFieldMapSlice *)ts_field_map_slices,
    .field_map_entries = (const TSFieldMapEntry *)ts_field_map_entries,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_rust_external_scanner_create,
      tree_sitter_rust_external_scanner_destroy,
      tree_sitter_rust_external_scanner_scan,
      tree_sitter_rust_external_scanner_serialize,
      tree_sitter_rust_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
